<?php
// (c) Copyright 2002-2012 by authors of the Tiki Wiki CMS Groupware Project
// 
// All Rights Reserved. See copyright.txt for details and a complete list of authors.
// Licensed under the GNU LESSER GENERAL PUBLIC LICENSE. See license.txt for details.

// Note for translators about translation of text ending with punctuation
// 
// The current list of concerned punctuation can be found in 'lib/init/tra.php'
// On 2009-03-02, it is: (':', '!', ';', '.', ',', '?')
// For clarity, we explain here only for colons: ':' but it is the same for the rest
// 
// Short version: it is not a problem that string "Login:" has no translation. Only "Login" needs to be translated.
// 
// Technical justification:
// If a string ending with colon needs translating (like "{tr}Login:{/tr}")
// then Tiki tries to translate 'Login' and ':' separately.
// This allows to have only one translation for "{tr}Login{/tr}" and "{tr}Login:{/tr}"
// and it still allows to translate ":" as " :" for languages that
// need it (like French)
// Note: the difference is invisible but " :" has an UTF-8 non-breaking-space, not a regular space, but the UTF-8 equivalent of the HTML &nbsp;.
// This allows correctly displaying emails and JavaScript messages, not only web pages as would happen with &nbsp;.

$lang = array(
// "You must specify a directory" => "You must specify a directory",
"Creation Date" => "Data de creació",
"Name" => "Nom",
"Last modification date" => "Data de la darrera modificació",
"Hits" => "Cops",
"Owner" => "Propietari",
"Description" => "Descripció",
"ID" => "ID",
"moved %d images, %d errors occurred." => "mogudes: %d imatges; han ocorregut %d errors.",
"a timeout occurred. Hit the reload button to move the rest" => "ha ocorregut una desconnexió. Prem el botó Actualitza per moure la resta",
"Detected, Version:" => "Detectat/da, Versió:",
// "Test Image" => "Test Image",
"Not detected." => "No detectat/da.",
"Unknown" => "Desconegut/da",
// "Tiki Email Test" => "Tiki Email Test",
// "Tiki Test email from" => "Tiki Test email from",
// "Unable to send mail" => "Unable to send mail",
// "Test mail sent to" => "Test mail sent to",
// "%d user-group assignments" => "%d user-group assignments",
"None" => "Cap",
"All Fields except gdaltindex must be filled" => "Tots els camps excepte gdaltindex han de ser omplerts",
// "Path to mapfiles is invalid" => "Path to mapfiles is invalid",
"No valid gdaltindex executable" => "No hi ha cap gdaltindex vàlid executable",
"No valid ogr2ogr executable" => "No hi ha cap executable ogr2ogr vàlid",
// "New configuration created (id %0)" => "New configuration created (id %0)",
// "Configuration updated" => "Configuration updated",
// "You must set a home file gallery" => "You must set a home file gallery",
"Tag already exists" => "El marcador ja existeix",
"Tag not found" => "No s'ha trobat el marcador",
// "Welsh" => "Welsh",
// "Slovene" => "Slovene",
"Arabic" => "Àrab",
// "Bulgarian" => "Bulgarian",
"Catalan" => "Català",
"Simplified Chinese" => "Xinès Simplificat",
"Czech" => "Txec",
"Danish" => "Danès",
"German" => "Alemany",
"English" => "Anglès",
"English British" => "Anglès Britànic",
"Spanish" => "Castellà",
"Greek" => "Grec",
"Farsi" => "Farsi",
"Finnish" => "Finès",
"Fijian" => "Fijià",
"French" => "Francès",
// "Frisian Netherlands" => "Frisian Netherlands",
"Galician" => "Gallec",
"Hebrew" => "Hebreu",
"Croatian" => "Croat",
// "Indonesian" => "Indonesian",
// "Icelandic" => "Icelandic",
"Italian" => "Italià",
// "Inuktitut" => "Inuktitut",
"Japanese" => "Japonès",
"Korean" => "Coreà",
"Hungarian" => "Hongarès",
// "Lithuanian" => "Lithuanian",
// "Low German" => "Low German",
"Dutch" => "Dels Països Baixos",
"Norwegian" => "Noruec",
"Polish" => "Polonès",
// "Portuguese" => "Portuguese",
"Brazilian Portuguese" => "Portuguès-Brasiler",
// "Romanian" => "Romanian",
// "Romansh" => "Romansh",
"Russian" => "Rus",
"Pijin Solomon" => "Pidgin de les illes Salomó",
// "Sinhala" => "Sinhala",
"Slovak" => "Eslovac",
// "Albanian" => "Albanian",
"Serbian Latin" => "Serbi Llatí",
"Swedish" => "Suec",
"Tuvaluan" => "Tuvaluà",
// "Turkish" => "Turkish",
"Traditional Chinese" => "Xinés traditional",
"Ukrainian" => "Ukranià",
// "Vietnamese" => "Vietnamese",
"Afghanistan" => "Afganistan",
"Aland Islands" => "Illes_Aland",
// "Aland_Islands" => "Aland_Islands",
"Albania" => "Albània",
"Algeria" => "Algèria",
"American Samoa" => "Samoa_Americana",
// "American_Samoa" => "American_Samoa",
"Andorra" => "Andorra",
"Angola" => "Angola",
"Anguilla" => "Anguilla",
"Antigua" => "Antigua",
"Argentina" => "Argentina",
"Armenia" => "Armènia",
"Aruba" => "Aruba",
"Australia" => "Austràlia",
"Austria" => "Àustria",
"Azerbaijan" => "Azerbaitjan",
"Bahamas" => "Bahames",
"Bahrain" => "Bahrain",
"Bangladesh" => "Bangla_Desh",
"Barbados" => "Barbados",
"Belarus" => "Bielorússia",
"Belgium" => "Bèlgica",
"Belize" => "Belize",
"Benin" => "Benín",
"Bermuda" => "Bermuda",
"Bhutan" => "Bhutan",
"Bolivia" => "Bolívia",
"Bosnia and Herzegovina" => "Bosnia_i_Herzegovina",
// "Bosnia_and_Herzegovina" => "Bosnia_and_Herzegovina",
"Botswana" => "Botswana",
"Bouvet Island" => "Illa_Bouvet",
// "Bouvet_Island" => "Bouvet_Island",
"Brazil" => "Brasil",
"British Indian Ocean Territory" => "Territori_Britànic_de_l'Oceà_Índic",
"British Virgin Islands" => "Illes_Verge_Britàniques",
// "British_Indian_Ocean_Territory" => "British_Indian_Ocean_Territory",
// "British_Virgin_Islands" => "British_Virgin_Islands",
"Brunei" => "Brunei",
"Bulgaria" => "Bulgària",
"Burkina Faso" => "Burkina_Faso",
// "Burkina_Faso" => "Burkina_Faso",
"Burundi" => "Burundi",
"Cambodia" => "Cambodja",
"Cameroon" => "Camerun",
"Canada" => "Canadà",
"Cape Verde" => "Cap_Verd",
// "Cape_Verde" => "Cape_Verde",
"Catalan Countries" => "Països_Catalans",
"Catalan_Countries" => "Països Catalans",
"Cayman Islands" => "Illes_Caiman",
// "Cayman_Islands" => "Cayman_Islands",
"Central African Republic" => "República_Centreafricana",
// "Central_African_Republic" => "Central_African_Republic",
"Chad" => "Txad",
"Chile" => "Xile",
"China" => "Xina",
"Christmas Island" => "Illa_Christmas",
// "Christmas_Island" => "Christmas_Island",
"Cocos Islands" => "Illes_Cocos",
// "Cocos_Islands" => "Cocos_Islands",
"Colombia" => "Colòmbia",
"Comoros" => "Comores",
"Congo Democratic" => "Congo,_Repúlica_Democràtica",
"Congo" => "Congo",
// "Congo_Democratic" => "Congo_Democratic",
"Cook Islands" => "Illes_Cook",
// "Cook_Islands" => "Cook_Islands",
"Costa Rica" => "Costa_Rica",
// "Costa_Rica" => "Costa_Rica",
"Croatia" => "Croàcia",
"Cuba" => "Cuba",
"Cyprus" => "Xipre",
"Czech Republic" => "República_Txeca",
// "Czech_Republic" => "Czech_Republic",
"Denmark" => "Dinamarca",
"Djibouti" => "Djibouti",
"Dominica" => "Dominica",
"Dominican Republic" => "República_Dominicana",
// "Dominican_Republic" => "Dominican_Republic",
"Ecuador" => "Equador",
"Egypt" => "Egipte",
"El Salvador" => "El_Salvador",
// "El_Salvador" => "El_Salvador",
"Equatorial Guinea" => "Guinea_Equatorial",
// "Equatorial_Guinea" => "Equatorial_Guinea",
"Eritrea" => "Eritrea",
"Estonia" => "Estònia",
"Ethiopia" => "Etiòpia",
"Europe" => "Europa",
"Falkland Islands" => "Illes_Malvines_(Falkland)",
// "Falkland_Islands" => "Falkland_Islands",
"Faroe Islands" => "Illes_Fèroe",
// "Faroe_Islands" => "Faroe_Islands",
"Federated States of Micronesia" => "Micronèsia,_Estats_Federats_de",
// "Federated_States_of_Micronesia" => "Federated_States_of_Micronesia",
"Fiji" => "Fiji",
"Finland" => "Finlàndia",
"France" => "França",
"French Guiana" => "Guaiana_Francesa",
"French Polynesia" => "Polinèsia_Francesa",
"French Southern Territories" => "Territoris_Francesos_del_Sud",
// "French_Guiana" => "French_Guiana",
// "French_Polynesia" => "French_Polynesia",
// "French_Southern_Territories" => "French_Southern_Territories",
"Gabon" => "Gabon",
"Gambia" => "Gàmbia",
"Georgia" => "Geòrgia",
"Germany" => "Alemanya",
"Ghana" => "Ghana",
"Gibraltar" => "Gibraltar",
"Greece" => "Grècia",
"Greenland" => "Groenlàndia",
"Grenada" => "Grenada",
"Guadeloupe" => "Guadalupe",
"Guam" => "Guam",
"Guatemala" => "Guatemala",
"Guernsey" => "Guernsey",
"Guinea Bissau" => "Guinea_Bissau",
"Guinea" => "Guinea",
// "Guinea_Bissau" => "Guinea_Bissau",
"Guyana" => "Guyana",
"Haiti" => "Haití",
"Heard Island and McDonald Islands" => "Illa_Heard_i_Illes_McDonald",
// "Heard_Island_and_McDonald_Islands" => "Heard_Island_and_McDonald_Islands",
"Honduras" => "Hondures",
"Hong Kong" => "Hong_Kong",
// "Hong_Kong" => "Hong_Kong",
"Hungary" => "Hongria",
"Iceland" => "Islàndia",
"India" => "Índia",
"Indonesia" => "Indonèsia",
"Iran" => "Iran",
"Iraq" => "Iraq",
"Ireland" => "Irlanda",
"Isle of Man" => "Illa de Man",
"Israel" => "Israel",
"Italy" => "Itàlia",
"Ivory Coast" => "Costa d'Ivori",
// "Ivory_Coast" => "Ivory_Coast",
"Jamaica" => "Jamaica",
"Japan" => "Japó",
"Jersey" => "Jersei",
"Jordan" => "Jordània",
"Kazakstan" => "Kazakhstan",
"Kenya" => "Kenya",
"Kiribati" => "Kiribati",
"Kuwait" => "Kuwait",
"Kyrgyzstan" => "Kirguizistan",
"Laos" => "Laos",
"Latvia" => "Letònia",
"Lebanon" => "Líban",
"Lesotho" => "Lesotho",
"Liberia" => "Libèria",
"Libya" => "Líbia",
"Liechtenstein" => "Liechtenstein",
"Lithuania" => "Lituània",
"Luxemburg" => "Luxemburg",
"Macao" => "Macau",
"Macedonia" => "Macedònia",
"Madagascar" => "Madagascar",
"Malawi" => "Malawi",
"Malaysia" => "Malaysia",
"Maldives" => "Maldives",
"Mali" => "Mali",
"Malta" => "Malta",
"Marshall Islands" => "Illes_Marshall",
// "Marshall_Islands" => "Marshall_Islands",
"Martinique" => "Martinica",
"Mauritania" => "Mauritània",
"Mauritius" => "Maurici",
"Mayotte" => "Mayotte",
"Mexico" => "Mèxic",
"Moldova" => "Moldàvia",
"Monaco" => "Mònaco",
"Mongolia" => "Mongòlia",
"Montenegro" => "Montenegro",
"Montserrat" => "Montserrat",
"Morocco" => "Marroc",
"Mozambique" => "Moçambic",
"Myanmar" => "Myanmar",
"Namibia" => "Namíbia",
"Nauru" => "Nauru",
"Nepal" => "Nepal",
"Netherlands Antilles" => "Antilles_Holandeses",
"Netherlands" => "Països_Baixos",
// "Netherlands_Antilles" => "Netherlands_Antilles",
"New Caledonia" => "Nova_Caledònia",
"New Zealand" => "Nova_Zelanda",
// "New_Caledonia" => "New_Caledonia",
// "New_Zealand" => "New_Zealand",
"Nicaragua" => "Nicaragua",
"Niger" => "Níger",
"Nigeria" => "Nigèria",
"Niue" => "Niue",
"Norfolk Island" => "Illa_Norfolk",
// "Norfolk_Island" => "Norfolk_Island",
"North Korea" => "Corea_del_Nord",
// "North_Korea" => "North_Korea",
"Northern Mariana Islands" => "Illes_Marianes_del_Nord",
// "Northern_Mariana_Islands" => "Northern_Mariana_Islands",
"Norway" => "Noruega",
"Oman" => "Oman",
"Other" => "Altre/a",
"Pakistan" => "Pakistan",
"Palau" => "Palau",
"Palestine" => "Palestina",
"Panama" => "Panamà",
"Papua New Guinea" => "Papua_Nova_Guinea",
// "Papua_New_Guinea" => "Papua_New_Guinea",
"Paraguay" => "Paraguai",
"Peru" => "Perú",
"Philippines" => "Filipines",
"Pitcairn" => "Pitcairn",
"Poland" => "Polònia",
"Portugal" => "Portugal",
"Puerto Rico" => "Puerto_Rico",
// "Puerto_Rico" => "Puerto_Rico",
"Quatar" => "Qatar",
"Republic of Macedonia" => "Macedònia",
// "Republic_of_Macedonia" => "Republic_of_Macedonia",
"Reunion" => "Reunion",
"Romania" => "Romania",
"Russia" => "Rússia",
"Russian Federation" => "Rússia",
// "Russian_Federation" => "Russian_Federation",
"Rwanda" => "Rwanda",
"Saint Helena" => "Saint_Helena",
"Saint Kitts and Nevis" => "Saint_Christopher_i_Nevis",
"Saint Lucia" => "Saint_Lucia",
"Saint Pierre and Miquelon" => "Saint_Pierre_i_Miquelon",
// "Saint_Helena" => "Saint_Helena",
// "Saint_Kitts_and_Nevis" => "Saint_Kitts_and_Nevis",
// "Saint_Lucia" => "Saint_Lucia",
// "Saint_Pierre_and_Miquelon" => "Saint_Pierre_and_Miquelon",
"Samoa" => "Samoa",
"San Marino" => "San_Marino",
// "San_Marino" => "San_Marino",
"Sao Tome and Principe" => "Sao_Tome_i_Príncipe",
// "Sao_Tome_and_Principe" => "Sao_Tome_and_Principe",
"Saudi Arabia" => "Aràbia_Saudita",
// "Saudi_Arabia" => "Saudi_Arabia",
"Senegal" => "Senegal",
"Serbia" => "Sèrbia",
"Seychelles" => "Seychelles",
"Sierra Leone" => "Sierra_Leone",
// "Sierra_Leone" => "Sierra_Leone",
"Singapore" => "Singapur",
"Slovakia" => "Eslovàquia",
"Slovenia" => "Eslovènia",
"Solomon Islands" => "Illes_Solomó",
// "Solomon_Islands" => "Solomon_Islands",
"Somalia" => "Somàlia",
"South Africa" => "Sud-àfrica",
"South Georgia and South Sandwich Islands" => "Illes_Geòrgia_del_Sud_i_Sandwich_del_Sud",
"South Korea" => "Corea_del_Sud",
// "South_Africa" => "South_Africa",
// "South_Georgia_and_South_Sandwich_Islands" => "South_Georgia_and_South_Sandwich_Islands",
// "South_Korea" => "South_Korea",
"Spain" => "Espanya",
"Sri Lanka" => "Sri_Lanka",
// "Sri_Lanka" => "Sri_Lanka",
"St Vincent Grenadines" => "St._Vincent_i_les_Grenadines",
// "St_Vincent_Grenadines" => "St_Vincent_Grenadines",
"Sudan" => "Sudan",
"Surinam" => "Surinam",
"Svalbard and Jan Mayen" => "Svalbard_i_Jan_Mayen",
// "Svalbard_and_Jan_Mayen" => "Svalbard_and_Jan_Mayen",
"Swaziland" => "Swazilàndia",
"Sweden" => "Suècia",
"Switzerland" => "Suïssa",
"Syria" => "Síria",
"Taiwan" => "Taiwan",
"Tajikistan" => "Tadjikistan",
"Tanzania" => "Tanzània",
"Thailand" => "Tailàndia",
"Timor-Leste" => "Timor-Leste",
"Togo" => "Togo",
"Tokelau" => "Tokelau",
"Tonga" => "Tonga",
"Trinidad Tobago" => "Trinitat_i_Tobago",
// "Trinidad_Tobago" => "Trinidad_Tobago",
"Tunisia" => "Tunísia",
"Turkey" => "Turquia",
"Turkmenistan" => "Turkmenistan",
"Turks and Caicos Islands" => "Illes_Turks_i_Caicos",
// "Turks_and_Caicos_Islands" => "Turks_and_Caicos_Islands",
"Tuvalu" => "Tuvalu",
"US Virgin Islands" => "Illes_Verge_Americanes",
// "US_Virgin_Islands" => "US_Virgin_Islands",
"Uganda" => "Uganda",
"Ukraine" => "Ucraïna",
"United Arab Emirates" => "Unió_dels_Emirats_Àrabs",
"United Kingdom" => "Regne_Unit",
"United Nations Organization" => "Organització de les Nacions Unides",
"United States Minor Outlying Islands" => "Illes_Perifèriques_Menors_dels_EUA",
"United States" => "Estats_Units_(EUA)",
// "United_Arab_Emirates" => "United_Arab_Emirates",
// "United_Kingdom" => "United_Kingdom",
// "United_Kingdom_-_England_and_Wales" => "United_Kingdom_-_England_and_Wales",
// "United_Kingdom_-_Northern_Ireland" => "United_Kingdom_-_Northern_Ireland",
// "United_Kingdom_-_Scotland" => "United_Kingdom_-_Scotland",
"United_Nations_Organization" => "Organització_de_les_Nacions_Unides",
// "United_States" => "United_States",
// "United_States_Minor_Outlying_Islands" => "United_States_Minor_Outlying_Islands",
"Uruguay" => "Uruguai",
"Uzbekistan" => "Uzbekistan",
"Vanuatu" => "Vanuatu",
"Vatican" => "Vaticà",
"Venezuela" => "Veneçuela",
"Viet Nam" => "Vietnam",
// "Viet_Nam" => "Viet_Nam",
"Wales" => "Wales",
"Wallis and Futuna" => "Wallis_i_Futuna",
// "Wallis_and_Futuna" => "Wallis_and_Futuna",
"Western Sahara" => "Sàhara_Occidental",
// "Western_Sahara" => "Western_Sahara",
"World" => "Món",
"Yemen" => "Iemen",
"Yugoslavia" => "Iugoslàvia",
"Zambia" => "Zàmbia",
"Zimbabwe" => "Zimbabwe",
// "the former Yugoslav Republic of Macedonia" => "the former Yugoslav Republic of Macedonia",
// "the_former_Yugoslav_Republic_of_Macedonia" => "the_former_Yugoslav_Republic_of_Macedonia",
"Re:" => "Re:",
"This forum is flat and doesn't allow replies to other replies" => "Aquest fòrum és pla i no permet respostes a altres respostes",
"Copyright management" => "Gestió de Copyright",
"No page indicated" => "No s'ha indicat cap pàgina",
"You must supply all the information, including title and year." => "Has de facilitar tota la informació, incloent títol i any.",
"Tiki was unable to retrieve login data from the database " => "Tiki no ha pogut obtenir les dades de connexió de la base de dades ",
"The following error message was returned" => "S'ha retornat el següent missatge d'error",
"Things to check" => "Coses a comprovar",
"Are your database login credentials correct" => "Són correctes les teves credencials de connexió",
"Did you complete the <a href='tiki-install.php' >Tiki Installer" => "Vas completar <a href='tiki-install.php' >l'instal·lador",
"Please see <a href=\"http://doc.tiki.org/\">the documentation</a> for more information" => "Si us plau, consulta <a href=\"http://doc.tiki.org/\">la documentació</a> per a més informació",
"You do not have permission to use this feature" => "Permís denegat per accedir a aquesta secció",
"This feature is for admins only" => "Aquesta funcionalitat és només per administradors/es",
"Type" => "Tipus",
"Size" => "Mida",
"Created" => "Creada",
"Uploaded" => "Carregat",
"Last Modified" => "Darrera modificació",
"Uploaded by" => "Pujar per",
"Creator" => "Creador",
"Last Modified by" => "Modificat per darrera vegada per",
"Comment" => "Comentari",
"Files" => "Arxius",
"Last download" => "Darrera descàrrega",
"Locked by" => "Bloquejat per",
"Backlinks" => "Retroenllaços",
// "Delete After" => "Delete After",
// "Share with" => "Share with",
"Source" => "Codi font",
"Explorer" => "Explorer",
"Path" => "Ruta",
"Slideshow" => "Passi de diapositives",
"Default View" => "Visualització per omissió",
// "Gallery Icon" => "Gallery Icon",
"Register" => "Registre",
"Tiki Installer" => "Instal·lador de Tiki",
"MySQL Improved (mysqli)" => "MySQL Millorat (mysqli)",
"MySQL classic (mysql)" => "MySQL clàssic (mysql)",
"Email address not valid, test mail not sent" => "Adreça de correu-e invàlida, no s'ha pogut enviar el correu-e de prova",
"Email address empty and \"copy\" checkbox not set, test mail not sent" => "Adreça de correu-e buida i la casella de verificació de \"copia\" no ha estat seleccionada, no s'ha enviat el correu-e de prova",
// "Test mail from Tiki installer %0" => "Test mail from Tiki installer %0",
"Tiki version" => "Versió de Tiki",
"PHP version" => "Versió de PHP",
"Server" => "Servidor",
"Sent" => "Enviat",
// "Some invalid characters were detected in database name. Please use alphanumeric characters or _ or -" => "Some invalid characters were detected in database name. Please use alphanumeric characters or _ or -",
// "Database `%0` was created" => "Database `%0` was created",
// "Database `%0` creation failed. You need to create the database" => "Database `%0` creation failed. You need to create the database",
"No database name specified" => "No s'ha especificat cap nom de base de dades",
"Congratulations!\n\nYour server can send emails.\n\n" => "Felicitats!\n\nEl teu servidor pot enviar correus-e.\n\n",
// "No automated tax" => "No automated tax",
// "Account name must not be empty" => "Account name must not be empty",
// "Budget is not a valid amount: " => "Budget is not a valid amount: ",
// "Locked must be either 0 or 1" => "Locked must be either 0 or 1",
// "Error creating account" => "Error creating account",
// "AccountId %0 is already in use and must not be changed. Please disable it if it is no longer needed" => "AccountId %0 is already in use and must not be changed. Please disable it if it is no longer needed",
// "Error updating account" => "Error updating account",
// "Account is already in use and must not be deleted. Please disable it, if it is no longer needed" => "Account is already in use and must not be deleted. Please disable it, if it is no longer needed",
// "Rollback failed, inconsistent database: Cleanup needed for journalId %0 in book %1" => "Rollback failed, inconsistent database: Cleanup needed for journalId %0 in book %1",
// "successfully rolled back #" => "successfully rolled back #",
// "Booking error creating journal entry" => "Booking error creating journal entry",
// "Booking error creating debit entry" => "Booking error creating debit entry",
// "Booking error creating credit entry" => "Booking error creating credit entry",
// "Number of debit entries differ: " => "Number of debit entries differ: ",
// "Number of credit entries differ: " => "Number of credit entries differ: ",
// "Splitting is only allowed on one side" => "Splitting is only allowed on one side",
// "Invalid debit amount " => "Invalid debit amount ",
// "Invalid debit account number " => "Invalid debit account number ",
// "Invalid credit amount " => "Invalid credit amount ",
// "Invalid credit account number " => "Invalid credit account number ",
// "Difference between debit and credit amounts " => "Difference between debit and credit amounts ",
// "Rollback failed, inconsistent database: Cleanup needed for stackId %0 in book %1" => "Rollback failed, inconsistent database: Cleanup needed for stackId %0 in book %1",
// "Booking error creating stack entry" => "Booking error creating stack entry",
// "Booking error creating stack debit entry" => "Booking error creating stack debit entry",
// "Booking error creating stack credit entry" => "Booking error creating stack credit entry",
// "Error deleting entry from stack" => "Error deleting entry from stack",
// "Booking error confirming stack entry" => "Booking error confirming stack entry",
// "Booking error cconfirming stack entry" => "Booking error cconfirming stack entry",
// "Error while updating statement" => "Error while updating statement",
// "is is not a number" => "is is not a number",
// "must be > 0" => "must be > 0",
// "Invalid transaction - please contact administrator" => "Invalid transaction - please contact administrator",
// "Error checking" => "Error checking",
// "does not exist" => "does not exist",
// "already exists" => "already exists",
// "This book has been closed. You can't create new accounts" => "This book has been closed. You can't create new accounts",
// "This book has been closed. You can't modify the account" => "This book has been closed. You can't modify the account",
// "This book has been closed. You can't delete the account" => "This book has been closed. You can't delete the account",
// "The date for the transaction is before this books start date" => "The date for the transaction is before this books start date",
// "The date for the transaction is after this books end date" => "The date for the transaction is after this books end date",
// "This book has been closed. You can't book into it any more" => "This book has been closed. You can't book into it any more",
// "Invalid booking date" => "Invalid booking date",
// "This book has been closed. You can't cancel transactions in it any more" => "This book has been closed. You can't cancel transactions in it any more",
"New article post" => "Nova publicació d'article",
"Edited article post" => "Publicació d'article editada",
"Deleted article post" => "Publicació d'article esborrada",
"The file is not a CSV file or has not a correct syntax" => "El fitxer no és del tipus CSV file o no té una sintaxi correcta",
"Error line: %d" => "Línia amb error: %d",
// "Spam is not welcome here" => "Spam is not welcome here",
"anonymous" => "anònim",
"Blog cannot be found" => "No es pot trobar el bloc",
"locked" => "bloquejat",
"locked by" => "bloquejat per",
"refresh" => "refresc",
// "go back to this crumb" => "go back to this crumb",
"Administration:" => "Administració:",
"All day" => "Tot el dia",
"First day of week: Sunday (its ID is 0) - translators you need to localize this string!" => "1",
"Sunday" => "Diumenge",
"Su" => "Du",
"Monday" => "dilluns",
"Tuesday" => "Dimarts",
"Wednesday" => "Dimecres",
"Thursday" => "Dijous",
"Friday" => "divendres",
"Saturday" => "Dissabte",
"Mo" => "Dl",
"Tu" => "Dt",
"We" => "Dc",
"Th" => "Dj",
"Fr" => "Dv",
"Sa" => "Ds",
"in" => "a",
"continued" => "continuat",
"New Image Uploaded by" => "Nova imatge pujada per",
"New Subscriptions" => "Subscripcions noves",
"New Item in Tracker" => "Nova entrada al formulari-bd",
"tracker" => "formulari-bd",
"by" => "per",
"Wiki" => "Wiki",
"Image Gallery" => "Galeria d'imatges",
"Articles" => "Articles",
"Blogs" => "Blocs",
"Forums" => "Fòrums",
"Directory" => "Directori",
"File Gallery" => "Galeria d'arxius",
"FAQs" => "PUFs",
"Quizzes" => "Qüestionaris",
"Trackers" => "Formularis-bd",
"Survey" => "Enquesta",
"Newsletter" => "Butlletins",
"Empty captcha value" => "Valor buit anti-robots",
"You have mistyped the anti-bot verification code. Please try again" => "Has comès alguna errada en el codi de verificació anti-robots. Prova-ho de nou, si us plau",
"Failed to validate captcha" => "Error en intentar validar el codi antirobots",
"Captcha ID field is missing" => "Manca el camp ID antirobots (captcha)",
"Get a visual challenge" => "Demana un desafiament visual",
"Get an audio challenge" => "Demana un desafiament auditiu",
"Get a new challenge" => "Demana un nou desafiament",
"Type the two words" => "Escriu les dues paraules",
"Type what you hear" => "Escriu el que et dirà la web",
"Help" => "Ajuda",
"Play sound again" => "Reprodueix el so de nou",
"Download sound as MP3" => "Descarrega el so com a MP3",
"Incorrect. Try again" => "No és correcte, Prova de nou",
// "A category named %0 already exists in %1" => "A category named %0 already exists in %1",
"article" => "article",
"blog" => "bloc",
"directory" => "directori",
"faq" => "pmf",
"file gallery" => "galeria d'arxius",
"forum" => "fòrum",
"image gallery" => "galeria d'imatges",
"newsletter" => "butlletí",
"poll" => "consultes",
"quiz" => "qüestionari",
"survey" => "enquesta",
"wiki page" => "pàgina wiki",
"image" => "imatge",
"calendar" => "calendari",
"Permission denied" => "Permís denegat",
"Invalid filename (using filters for filenames)" => "Nom d'arxiu Invàlid (usant filtres per a noms d'arxius)",
"Cannot upload this file - maximum upload size exceeded" => "No es pot pujar aquest arxiu , supera el límit màxim de mida",
"Cannot write to this file" => "No es pot escriure a aquest arxiu",
"(not registered)" => "(no registrat)",
"Anonymous" => "Anònim/a",
"Your comment was rejected" => "El teu comentari ha estat rebutjat",
"Cannot perform spam check: %0" => "No es pot realitzar la comprovació de spam: %0",
"Please wait %0 seconds between posts" => "Si us plau, espera %0 segons entre publicacions",
"Wrong password. Cannot post comment" => "Contrasenya errònia. No pots publicar el comentari",
"A contribution is mandatory" => "És necessari especificar algun tipus de contribució",
"You have to enter a title and text" => "Has d'introduir un títol i text",
"Invalid Email" => "Correu-e invàlid",
"Your message has been queued for approval and will be posted after a moderator approves it." => "El teu missatge ha estat posat a la qua de moderació per ser aprovat; es publicarà el missatge quan un moderador l'aprovi.",
"This forum is locked" => "Aquest fòrum està bloquejat",
"This thread is locked" => "Aquest fil de discussió està bloquejat",
// "This can happen if the page you are linking to has changed since you obtained the forwardlink or if the page is not viewable by the public" => "This can happen if the page you are linking to has changed since you obtained the forwardlink or if the page is not viewable by the public",
// "If you are logged in, try loggin out and then recreate the forwardlink" => "If you are logged in, try loggin out and then recreate the forwardlink",
// "Phrase not found" => "Phrase not found",
"Date" => "Data",
// "Click below to read Citing blocks" => "Click below to read Citing blocks",
// "Apply Profile \"Simple Wiki Attributes\" To Add ForwardLink Questions" => "Apply Profile \"Simple Wiki Attributes\" To Add ForwardLink Questions",
// "Saving.." => "Saving..",
// "Editing: " => "Editing: ",
"OK" => "D'acord",
"Cancel" => "Cancel·lar",
"New" => "Nou/va",
"Save" => "Guardar",
// "Create ForwardLink" => "Create ForwardLink",
// "Highlight text to be linked" => "Highlight text to be linked",
// "Accept TextLink & ForwardLink" => "Accept TextLink & ForwardLink",
// "Ok" => "Ok",
// "You selected" => "You selected",
// "Suggested selection" => "Suggested selection",
// "Copy To Clipboard" => "Copy To Clipboard",
// "TextLink & ForwardLink data copied to your clipboard" => "TextLink & ForwardLink data copied to your clipboard",
"Loading..." => "Carregant...",
// "Edit ForwardLink Questions" => "Edit ForwardLink Questions",
"Edit" => "Editar",
"Delete" => "Esborra",
// "Are you sure" => "Are you sure",
// "Suggestion" => "Suggestion",
// "Please fill in the questions below" => "Please fill in the questions below",
// "Copy This" => "Copy This",
// "New File" => "New File",
// "%0 near \"%1\"" => "%0 near \"%1\"",
// "Expecting \"(\"" => "Expecting \"(\"",
// "Unexpected \"%0\"" => "Unexpected \"%0\"",
// "Expecting \")\"" => "Expecting \")\"",
// "No formula provided" => "No formula provided",
// "Variable not found \"%0\"" => "Variable not found \"%0\"",
// "Unknown operation \"%0\"" => "Unknown operation \"%0\"",
"All" => "Tots",
// "Count" => "Count",
// "Count By Date" => "Count By Date",
// "Count By Date Filter Id" => "Count By Date Filter Id",
// "Count Users Filter Id" => "Count Users Filter Id",
// "Count Users IP Filter Id" => "Count Users IP Filter Id",
// "Ascending By Date" => "Ascending By Date",
// "Descending By Date" => "Descending By Date",
// "Logs" => "Logs",
"Action" => "Acció",
"Start" => "Començament",
"End" => "Fi",
"Fields" => "Camps",
// "Grouping" => "Grouping",
"Sort" => "Ordena",
// "Limit" => "Limit",
"Tracker" => "Formulari-bd",
// " Join Tracker " => " Join Tracker ",
// " on " => " on ",
// " equals " => " equals ",
// "Item Id" => "Item Id",
"Search" => "Cercar",
// " for " => " for ",
"Status" => "estat",
"Articles deleted" => "Articles esborrats",
"removed the article" => "ha eliminat l'article",
"Edited articles" => "Articles editats",
"edited the article" => "ha editat l'article",
"New articles submited" => "S'han enviat noves col·laboracions d'articles",
"created the article" => "ha creat l'article",
"New blog posts" => "Noves publicacions de blocs",
"replied to the blog" => "ha respost al bloc",
"New calendar events" => "Nous esdeveniments a l'agenda",
"%0 added or updated event %1" => "%0 ha afegit o actualitzat %1",
"Changes in categories" => "Canvis a categories",
"added the %0 %1 to the category %2" => "ha afegit el/la %0 %1 a %2",
"created the subcategory" => "ha creat la subcategoria",
"removed the subcategory" => "ha eliminat la subcategoria",
"from" => "des de",
"edited the category" => "ha editat la categoria",
"removed the %0 %1 from the category %2" => "ha eliminat el/la %0 %1 de %2",
"File galleries changed" => "Han canviat algunes galeries d'arxius",
"%0 edited the file gallery %1" => "%0 ha editat la galeria d'arxius %1",
"%0 uploaded the file %1" => "%0 ha pujat l'arxiu %1",
"onto" => "sobre",
"%0 removed the file %1 from %2" => "%0 ha eliminat l'arxiu %1 de %2",
"New replies in forum topics" => "Noves respostes a temes de fòrums",
"%0 <a href=%1>replied</a> to the topic %2" => "%0 <a href=%1>ha respost</a> al tema %2",
"New posts in forums" => "Noves publicacions en fòrums",
"%0 created the topic %1 at forum %2" => "%0 ha creat el tema %1 a %2",
// "Image galleries changed" => "Image galleries changed",
"changed the picture gallery" => "ha canviat la galeria de fotos",
"uploaded the picture" => "ha pujat la foto",
"removed the picture" => "ha eliminat la foto",
"Comments in tracker items" => "Comentaris a ítems dels formularis-bd",
"%0 added a new comment to %1 on tracker %2" => "%0 n'ha afegit un a %1 en %2",
"%0 added a new comment to item id %1 on tracker %2" => "%0 n'ha afegit un a l'item %1 en %2",
"Tracker items modified" => "S'han modificat ítems de formularis-bd",
"%0 added or updated tracker item %1 on tracker %2" => "%0 ha afegit o actualitzat %1 de %2",
"%0 added or updated tracker item id %1 on tracker %2" => "%0 ha afegit o actualitzat l'ítem %1 de %2",
"New attachments in wiki pages" => "Nous adjunts a pàgines wiki",
"%0 uploaded the file %1 onto %2" => "%0 ha adjuntat l'arxiu %1 a %2",
"Wiki pages updated" => "Pàgines wiki actualitzades",
"%0 edited the wikipage %1 (<a href=%2>this history</a>, <a href=%3>all history</a>)" => "%0 ha editat %1 (<a href=%2>aquests canvis</a>, <a href=%3>tot l'històric</a>)",
"and %0 more changes of the same type" => "i %0 canvis més del mateix tipus",
"Nothing has happened" => "No ha succeït res",
"Report from %0 (1 change)" => "Informe des de: %0 (1 canvi)",
"Report from %0 (%1 changes)" => "Informe des de: %0 (%1 canvis)",
"Report from %0 (no changes)" => "Informe des de: %0 (sense canvis)",
"%0 (latest)" => "%0 (el darrer)",
"No value for '%0'" => "Cap valor per a '%0'",
// "Unknown formatting rule '%0' for '%1'" => "Unknown formatting rule '%0' for '%1'",
// "Indexing failed while processing \"%0\" (type %1) with the error \"%2\"" => "Indexing failed while processing \"%0\" (type %1) with the error \"%2\"",
// "filterRange: \"from\" value not parsed" => "filterRange: \"from\" value not parsed",
// "filterRange: \"to\" value not parsed" => "filterRange: \"to\" value not parsed",
// "Permission Denied" => "Permission Denied",
// "Invalid data" => "Invalid data",
// "Action not found (%0 in %1)" => "Action not found (%0 in %1)",
// "Controller not found (%0)" => "Controller not found (%0)",
"Comments not allowed on this page" => "No es permeten comentaris en aquesta pàgina",
// "Parent is locked" => "Parent is locked",
// "Pseudonym must be specified" => "Pseudonym must be specified",
"Email must be specified" => "S'ha d'indicar el correu-e",
"Title is empty" => "Cal posar un títol (és buit ara)",
"Content is empty" => "Cal posar algun contingut (és buit ara)",
// "Permissions denied" => "Permissions denied",
// "Comment not found" => "Comment not found",
// "Comment already approved" => "Comment already approved",
// "Invalid argument" => "Invalid argument",
// "Thread not specified" => "Thread not specified",
"Feature disabled" => "Característica deshabilitada",
// "Reserved to administrators during development" => "Reserved to administrators during development",
// "Tiki not connected. Please click \"Send Info\" to join in" => "Tiki not connected. Please click \"Send Info\" to join in",
// "Something went wrong. Tiki Connect is still experimental. Please try again" => "Something went wrong. Tiki Connect is still experimental. Please try again",
// "registration" => "registration",
// "confirmation" => "confirmation",
// "Connect Feature disabled" => "Connect Feature disabled",
// "Connect Server Mode disabled" => "Connect Server Mode disabled",
// "Please confirm you want to participate in Tiki Connect" => "Please confirm you want to participate in Tiki Connect",
// "Welcome to Tiki Connect, please click \"Send Info\" when you want to make a connection" => "Welcome to Tiki Connect, please click \"Send Info\" when you want to make a connection",
// "Something went wrong on the server. Tiki Connect is still experimental" => "Something went wrong on the server. Tiki Connect is still experimental",
// "Captcha code problem" => "Captcha code problem",
// "Connect data received, thanks" => "Connect data received, thanks",
// "Your Tiki is not registered here yet, please try again" => "Your Tiki is not registered here yet, please try again",
// "Feature disabled: %0" => "Feature disabled: %0",
// "\"%0\" already exists" => "\"%0\" already exists",
// "Field Required" => "Field Required",
// "Not found" => "Not found",
// "Must be authenticated" => "Must be authenticated",
// "Invalid input" => "Invalid input",
// "File could not be uploaded. Restrictions apply" => "File could not be uploaded. Restrictions apply",
// "Upload from source disabled" => "Upload from source disabled",
// "Data could not be obtained" => "Data could not be obtained",
// "Manual refresh disabled" => "Manual refresh disabled",
// "Requested gallery does not exist" => "Requested gallery does not exist",
// "Feature Disabled" => "Feature Disabled",
// "Translation not supported for the specified object type" => "Translation not supported for the specified object type",
// "No source provided" => "No source provided",
// "No source or target provided" => "No source or target provided",
// "Not allowed to attach the selected translations" => "Not allowed to attach the selected translations",
// "Could not attach the translations" => "Could not attach the translations",
// "Not allowed to detach the selected translations" => "Not allowed to detach the selected translations",
// "Object has no language and cannot be translated" => "Object has no language and cannot be translated",
// "No box available for %0" => "No box available for %0",
// "Remote service unaccessible (%0)" => "Remote service unaccessible (%0)",
// "Reserved to tracker administrators" => "Reserved to tracker administrators",
// "Type does not exist" => "Type does not exist",
// "Not allowed to view the tracker" => "Not allowed to view the tracker",
// "Warning: Required field types not enabled: %0" => "Warning: Required field types not enabled: %0",
// "Tracker contains no listed field, no meaningful information will be provided in the default list" => "Tracker contains no listed field, no meaningful information will be provided in the default list",
// "Tracker contains no field in the title, no link will be generated" => "Tracker contains no field in the title, no link will be generated",
// "Captcha" => "Captcha",
// "Distinct" => "Distinct",
// "Page Name" => "Page Name",
"Password" => "Contrasenya",
// "Regular Expression (Pattern)" => "Regular Expression (Pattern)",
// "User Name" => "User Name",
// "Invalid data provided" => "Invalid data provided",
// "Item could not be created" => "Item could not be created",
// "Not allowed to export" => "Not allowed to export",
// "No valid field selected for export" => "No valid field selected for export",
// "File upload failed" => "File upload failed",
// "Uploaded file could not be read" => "Uploaded file could not be read",
"Last Modification" => "Última modificació",
// "Item ID" => "Item ID",
"Filename" => "Nom d'arxiu",
"Creation date" => "Data de creació",
// "Views" => "Views",
// "File size" => "File size",
"Version" => "Versió",
// "File type" => "File type",
// "Long description" => "Long description",
"User" => "Usuari",
// "Error in search query" => "Error in search query",
// "Remote Source" => "Remote Source",
// "Automatically generated field for synchronized trackers. Contains the itemId of the remote item" => "Automatically generated field for synchronized trackers. Contains the itemId of the remote item",
// "Tracker does not exist" => "Tracker does not exist",
// "Tracker is not synchronized with a remote source" => "Tracker is not synchronized with a remote source",
// "Operation reserved for tracker administrators" => "Operation reserved for tracker administrators",
// "Following mandatory fields are missing: %0" => "Following mandatory fields are missing: %0",
// "Invalid value in %0: %1" => "Invalid value in %0: %1",
// "Invalid value in %0" => "Invalid value in %0",
// "Field does not exist in tracker" => "Field does not exist in tracker",
// "secure connection required" => "secure connection required",
// "Create a form which will be posted somewhere, not necessarily trackers or even Tiki" => "Create a form which will be posted somewhere, not necessarily trackers or even Tiki",
// "The title of the button" => "The title of the button",
"Post" => "Publicar",
// "The protocol to use at the form: either get or post" => "The protocol to use at the form: either get or post",
// "Script" => "Script",
// "The arbitrary url of the destination of the form" => "The arbitrary url of the destination of the form",
"Parameters" => "Paràmetres",
// "Here page:fieldname can be repeated several times, it specifies the variable names to pass in the form, as well as value taken from the current item from field named fieldname. highlight=test can also be repeated and is useful for fixed values as params to pass to the form" => "Here page:fieldname can be repeated several times, it specifies the variable names to pass in the form, as well as value taken from the current item from field named fieldname. highlight=test can also be repeated and is useful for fixed values as params to pass to the form",
// "Auto-Increment" => "Auto-Increment",
// "Allows an incrementing value field, or itemId field" => "Allows an incrementing value field, or itemId field",
// "The starting value for the field" => "The starting value for the field",
// "Prepend" => "Prepend",
// "Text that will be displayed before the field" => "Text that will be displayed before the field",
// "Append" => "Append",
// "Text that will be displayed after the field" => "Text that will be displayed after the field",
// "If set to \"itemId\", will set this field to match the value of the actual database itemId field value" => "If set to \"itemId\", will set this field to match the value of the actual database itemId field value",
"Category" => "Categoria",
// "Allows for one or multiple categories under the specified main category to be affected to the tracker item" => "Allows for one or multiple categories under the specified main category to be affected to the tracker item",
// "Parent Category" => "Parent Category",
// "Child categories will be provided as options for the field" => "Child categories will be provided as options for the field",
// "Input Type" => "Input Type",
// "User interface control to be used" => "User interface control to be used",
// "Drop Down" => "Drop Down",
// "Radio buttons" => "Radio buttons",
// "List box" => "List box",
// "Multiple-selection check-boxes" => "Multiple-selection check-boxes",
"Select All" => "Selecciona-ho tot",
// "Includes a control to select all available options for multi-selection controls" => "Includes a control to select all available options for multi-selection controls",
// "No controls" => "No controls",
// "Include controls" => "Include controls",
// "All descendants" => "All descendants",
// "Display all descendants instead of only first-level ones" => "Display all descendants instead of only first-level ones",
// "First level only" => "First level only",
// "Displays the field description in a help tooltip" => "Displays the field description in a help tooltip",
// "No help" => "No help",
// "Tooltip" => "Tooltip",
// "Checkbox" => "Checkbox",
// "Provides a checkbox field for yes/no, on/off input" => "Provides a checkbox field for yes/no, on/off input",
"Yes" => "Si",
"No" => "No",
// "Computed Field" => "Computed Field",
// "Provides a computed value based on numeric field values. Consider using webservices or JavaScript to perform the task instead of using this type" => "Provides a computed value based on numeric field values. Consider using webservices or JavaScript to perform the task instead of using this type",
// "This feature is still in place for backwards compatibility. While there are no flaws associated to it, it could be used as a vector for attacks causing a lot of damage. Webservice field or custom JavaScript is recommended instead of this field" => "This feature is still in place for backwards compatibility. While there are no flaws associated to it, it could be used as a vector for attacks causing a lot of damage. Webservice field or custom JavaScript is recommended instead of this field",
"Formula" => "Fórmula",
// "The formula to be computed supporting various operators (+ - * / and parenthesis), references to other field made using the field id preceeded by #" => "The formula to be computed supporting various operators (+ - * / and parenthesis), references to other field made using the field id preceeded by #",
// "Country Selector" => "Country Selector",
// "Allows a selection from a specified list of countries" => "Allows a selection from a specified list of countries",
"Display" => "Mostra",
// "Specify the rendering type for the field" => "Specify the rendering type for the field",
// "Name and flag" => "Name and flag",
// "Name only" => "Name only",
// "Flag only" => "Flag only",
"Sort Order" => "Ordenació",
// "Determines whether the ordering should be based on the translated name or the English name" => "Determines whether the ordering should be based on the translated name or the English name",
// "Translated name" => "Translated name",
// "English name" => "English name",
// "Currency Field" => "Currency Field",
// "Provides a one-line field for numeric input only. Prepend or append values may be alphanumeric" => "Provides a one-line field for numeric input only. Prepend or append values may be alphanumeric",
// "Same Row" => "Same Row",
// "Displays the next field on the same line" => "Displays the next field on the same line",
// "Display Size" => "Display Size",
// "Visible size of the field in characters. Does not affect the numeric length" => "Visible size of the field in characters. Does not affect the numeric length",
// "Text to be displayed prior to the currency amount" => "Text to be displayed prior to the currency amount",
// "Text to be displayed after the numeric value" => "Text to be displayed after the numeric value",
// "Locale" => "Locale",
// "Set locale for currency formatting, for example en_US or en_US.UTF-8 or en_US.ISO-8559-1. Default is en_US" => "Set locale for currency formatting, for example en_US or en_US.UTF-8 or en_US.ISO-8559-1. Default is en_US",
"Currency" => "Moneda",
// "A custom alphanumeric currency code. Not needed if locale is set and a standard code is desired. Default is USD" => "A custom alphanumeric currency code. Not needed if locale is set and a standard code is desired. Default is USD",
// "Symbol" => "Symbol",
// "Set whether the currency code (for example USD) or symbol (for example \$) will display. Defaults to symbol" => "Set whether the currency code (for example USD) or symbol (for example \$) will display. Defaults to symbol",
// "Currency code" => "Currency code",
// "Currency symbol" => "Currency symbol",
// "First or all" => "First or all",
// "Set whether the currency code or symbol will be displayed against all amounts or only the first amount" => "Set whether the currency code or symbol will be displayed against all amounts or only the first amount",
// "First item only" => "First item only",
"Date and Time" => "Data i Hora",
// "Provides drop-down options to accurately select a date and/or time" => "Provides drop-down options to accurately select a date and/or time",
// "Components to be included" => "Components to be included",
// "Date only" => "Date only",
// "Start Year" => "Start Year",
// "Year to allow selecting from" => "Year to allow selecting from",
// "End Year" => "End Year",
// "Year to allow selecting to" => "Year to allow selecting to",
// "Default selection" => "Default selection",
// "Indicates if blank dates should be allowed" => "Indicates if blank dates should be allowed",
// "Current Date" => "Current Date",
// "Blank" => "Blank",
// "Allows users to select only from a specified set of options" => "Allows users to select only from a specified set of options",
"Option" => "Opció",
// "An option, if containing an equal sign, the prior part will be used as the value while the later as the label" => "An option, if containing an equal sign, the prior part will be used as the value while the later as the label",
// "Drop Down with Other field" => "Drop Down with Other field",
// "Allows users to select from a specified set of options or to enter an alternate option" => "Allows users to select from a specified set of options or to enter an alternate option",
// "An option, if containing an equal sign, the prior part will be used as the value while the later as the label. It is recommended to add an \"other\" option" => "An option, if containing an equal sign, the prior part will be used as the value while the later as the label. It is recommended to add an \"other\" option",
// "Radio Buttons" => "Radio Buttons",
// "Multiselect" => "Multiselect",
// "Allows a user to select multiple values from a specified set of options" => "Allows a user to select multiple values from a specified set of options",
// "Dynamic Items List" => "Dynamic Items List",
// "Dynamically updates a selection list based on linked data from another tracker" => "Dynamically updates a selection list based on linked data from another tracker",
// "Tracker ID" => "Tracker ID",
// "Tracker to link with" => "Tracker to link with",
// "Field ID (Other tracker)" => "Field ID (Other tracker)",
// "Field ID to link with in the other tracker" => "Field ID to link with in the other tracker",
// "Field ID (This tracker)" => "Field ID (This tracker)",
// "Field ID to link with in the current tracker" => "Field ID to link with in the current tracker",
// "Listed Field" => "Listed Field",
// "Field ID to be displayed in the drop list" => "Field ID to be displayed in the drop list",
// "Status Filter" => "Status Filter",
// "Restrict listed items to specific statuses" => "Restrict listed items to specific statuses",
"all" => "tots",
"open" => "obert",
"pending" => "pendent",
"closed" => "tancat",
// "open, pending" => "open, pending",
// "pending, closed" => "pending, closed",
// "Tracker Field Factory Error: Pref \"%0\" required for field type \"%1\"" => "Tracker Field Factory Error: Pref \"%0\" required for field type \"%1\"",
"Attachment" => "Adjunt",
// "Allows a file to be attached to the tracker item" => "Allows a file to be attached to the tracker item",
"List View" => "Vista de Llista",
// "Defines how attachments will be displayed within the field" => "Defines how attachments will be displayed within the field",
"name" => "nom",
"type" => "tipus",
// "name, size" => "name, size",
// "name, type, size" => "name, type, size",
// "uploader" => "uploader",
// "mediaplayer" => "mediaplayer",
"Download" => "Descarregar",
// "Attached and upload files stored in the file galleries to the tracker item" => "Attached and upload files stored in the file galleries to the tracker item",
"Gallery ID" => "ID de la Galleria",
// "File gallery to upload new files into" => "File gallery to upload new files into",
// "MIME Type Filter" => "MIME Type Filter",
// "Mask for accepted MIME types in the field" => "Mask for accepted MIME types in the field",
// "File Count" => "File Count",
// "Maximum number of files to be attached on the field" => "Maximum number of files to be attached on the field",
// "Display Images" => "Display Images",
// "Show files as images or object links" => "Show files as images or object links",
"Links" => "Enllaços",
"Images" => "Imatges",
// "Image parameters" => "Image parameters",
// "URL encoded params used as in the {img} plugin. e.g" => "URL encoded params used as in the {img} plugin. e.g",
// "Image parameters for lists" => "Image parameters for lists",
// "Include Child Galleries" => "Include Child Galleries",
// "Use files from child galleries as well" => "Use files from child galleries as well",
// "Replace Existing File" => "Replace Existing File",
// "Replace existing file if any, instead of uploading new one" => "Replace existing file if any, instead of uploading new one",
// "Problem with uploaded file: \"%0\"" => "Problem with uploaded file: \"%0\"",
// "No gallery for uploaded file, galleryId=%0" => "No gallery for uploaded file, galleryId=%0",
// "No permissions to upload file to gallery \"%0\"" => "No permissions to upload file to gallery \"%0\"",
"Freetags" => "Etiquetes lliures",
// "Allows freetags to be shown or added for tracker items" => "Allows freetags to be shown or added for tracker items",
// "Visible size of the input field" => "Visible size of the input field",
// "Hide or show the input help" => "Hide or show the input help",
"Show" => "Mostra",
"Hide" => "Oculta",
// "Suggest" => "Suggest",
// "Hide or show the freetag suggestions" => "Hide or show the freetag suggestions",
// "Geographic Feature" => "Geographic Feature",
// "Stores a geographic feature on a map" => "Stores a geographic feature on a map",
// "Feature cannot be set or modified through this interface" => "Feature cannot be set or modified through this interface",
// "Feature cannot be viewed" => "Feature cannot be viewed",
// "Group Selector" => "Group Selector",
// "Allows a selection from a specified list of user groups" => "Allows a selection from a specified list of user groups",
// "Auto-Assign" => "Auto-Assign",
// "Determines if any group should be automatically assigned to the field" => "Determines if any group should be automatically assigned to the field",
// "Modifier" => "Modifier",
// "Group Filter" => "Group Filter",
// "Limit listed groups to those including the specified group" => "Limit listed groups to those including the specified group",
// "Assign to the group" => "Assign to the group",
// "For no autoaassigned field, the user (user selector if exsits or user) will be assigned to the group and it will be his default group. The group must have the user choice setting on" => "For no autoaassigned field, the user (user selector if exsits or user) will be assigned to the group and it will be his default group. The group must have the user choice setting on",
"Assign" => "Assigna",
// "Header" => "Header",
// "Displays a header between fields to delimit a section and allow folding the fields" => "Displays a header between fields to delimit a section and allow folding the fields",
// "Header Level" => "Header Level",
// "Level of the header to use for complex tracker structures needing multiple heading levels" => "Level of the header to use for complex tracker structures needing multiple heading levels",
// "Default State" => "Default State",
// "Controls the section toggles" => "Controls the section toggles",
"Open" => "Obert",
"Closed" => "Tancat",
"Icon" => "Icona",
// "Allows to select an image as an icon attached to the tracker item from file galleries" => "Allows to select an image as an icon attached to the tracker item from file galleries",
// "Default image" => "Default image",
// "Path to the default icon used" => "Path to the default icon used",
"Image" => "Imatge",
// "Allow users to upload images on the tracker item" => "Allow users to upload images on the tracker item",
// "List image width" => "List image width",
// "Display size in pixels" => "Display size in pixels",
// "List image height" => "List image height",
// "Detail image width" => "Detail image width",
// "Detail image height" => "Detail image height",
// "Maximum image size" => "Maximum image size",
// "Maximum image width or height in pixels" => "Maximum image width or height in pixels",
"Shadowbox" => "Shadowbox (permet efectes gràfics moderns en imatges)",
// "Shadowbox usage on this field" => "Shadowbox usage on this field",
// "Do not use" => "Do not use",
// "One box per item" => "One box per item",
// "Use the same box for all images" => "Use the same box for all images",
// "Missing Icon" => "Missing Icon",
// "Icon to use when no images have been uploaded" => "Icon to use when no images have been uploaded",
"Invalid imagename (using filters for filenames)" => "Invàlid nom d'imatge (usant filtres per a noms d'arxius)",
// "In Group" => "In Group",
// "Indicates if the user associated to the item is member of a specified group" => "Indicates if the user associated to the item is member of a specified group",
// "Group Name" => "Group Name",
// "Name of the group to verify" => "Name of the group to verify",
// "How to display the result" => "How to display the result",
// "Yes/No" => "Yes/No",
// "Join date" => "Join date",
// "IP Selector" => "IP Selector",
// "IP address input field" => "IP address input field",
// "Auto-assign" => "Auto-assign",
// "Automatically assign the value on creation or edit" => "Automatically assign the value on creation or edit",
// "Item Link" => "Item Link",
// "Link to an other item, similar to a foreign key" => "Link to an other item, similar to a foreign key",
// "Tracker to link to" => "Tracker to link to",
// "Field ID" => "Field ID",
// "Default field to display" => "Default field to display",
// "How the link to the item should be rendered" => "How the link to the item should be rendered",
"Value" => "Valor",
"Link" => "Enllaç",
// "Multiple Fields" => "Multiple Fields",
// "Display the values from multiple fields instead of a single one, separated by |" => "Display the values from multiple fields instead of a single one, separated by |",
// "Limit the available items to a selected set" => "Limit the available items to a selected set",
// "Link Page" => "Link Page",
// "Link to a wiki page instead of directly to the item" => "Link to a wiki page instead of directly to the item",
// "Add Items" => "Add Items",
// "Display text to allow new items to be added - e.g. \"Add item...\" (requires jQuery-UI)" => "Display text to allow new items to be added - e.g. \"Add item...\" (requires jQuery-UI)",
// "Add Item Template Page" => "Add Item Template Page",
// "Wiki page to use as a Pretty Tracker template" => "Wiki page to use as a Pretty Tracker template",
// "Preselect item based on value in this field" => "Preselect item based on value in this field",
// "Preselect item based on value in specified field ID of item being edited" => "Preselect item based on value in specified field ID of item being edited",
// "Preselect based on value in this remote field" => "Preselect based on value in this remote field",
// "Match preselect item with this field ID in tracker that is being linked to" => "Match preselect item with this field ID in tracker that is being linked to",
// "Preselection matching method" => "Preselection matching method",
// "Method to use to match fields for preselection purposes" => "Method to use to match fields for preselection purposes",
// "Exact Match" => "Exact Match",
// "Field here is part of field there" => "Field here is part of field there",
// "Match domain, used for URL fields" => "Match domain, used for URL fields",
// "One item per value" => "One item per value",
// "Display only one random item per value" => "Display only one random item per value",
// "Only one random item for each value" => "Only one random item for each value",
// "Displays all the items for a same value with a notation value (itemId)" => "Displays all the items for a same value with a notation value (itemId)",
// "Select multiple values" => "Select multiple values",
// "Allow the user to select multiple values" => "Allow the user to select multiple values",
// "Index remote fields" => "Index remote fields",
// "Index one or multiple fields from the master tracker along with the child, separated by |" => "Index one or multiple fields from the master tracker along with the child, separated by |",
// "Items List" => "Items List",
// "Displays a list of field values from another tracker that has a relation with this tracker" => "Displays a list of field values from another tracker that has a relation with this tracker",
// "Tracker to list items from" => "Tracker to list items from",
// "Link Field ID" => "Link Field ID",
// "Field ID from the other tracker containing an item link pointing to the item in this tracker or some other value to be matched" => "Field ID from the other tracker containing an item link pointing to the item in this tracker or some other value to be matched",
// "Value Field ID" => "Value Field ID",
// "Field ID from this tracker matching the value in the link field ID from the other tracker if the field above is not an item link" => "Field ID from this tracker matching the value in the link field ID from the other tracker if the field above is not an item link",
// "Fields to display" => "Fields to display",
// "Display alternate fields from the other tracker instead of the item title" => "Display alternate fields from the other tracker instead of the item title",
// "How the link to the items should be rendered" => "How the link to the items should be rendered",
// "Read Only" => "Read Only",
// "Date and Time (Date Picker)" => "Date and Time (Date Picker)",
// "Provides jQuery-UI date picker select a date and optionally time" => "Provides jQuery-UI date picker select a date and optionally time",
// "Default value" => "Default value",
// "Default date and time for new items" => "Default date and time for new items",
// "None (undefined)" => "None (undefined)",
// "Item creation date and time" => "Item creation date and time",
"Language" => "Llenguatge",
// "Assign a language to the tracker item to enable multilingual trackers" => "Assign a language to the tracker item to enable multilingual trackers",
// "Indicates if the language should be assigned as the item's language" => "Indicates if the language should be assigned as the item's language",
"LDAP" => "LDAP",
// "Display a field value from a specific user in LDAP" => "Display a field value from a specific user in LDAP",
"Filter" => "Filtra",
// "LDAP filter, can contain the %field_name% placeholder to be replaced with the current field's name" => "LDAP filter, can contain the %field_name% placeholder to be replaced with the current field's name",
"Field" => "Camp",
// "Field name returned by LDAP" => "Field name returned by LDAP",
"DSN" => "DSN",
// "Data source name registered in Tiki" => "Data source name registered in Tiki",
"Location" => "Localització",
// "Allows to select a geolocation for the item and displays it on a map" => "Allows to select a geolocation for the item and displays it on a map",
// "Use as item location" => "Use as item location",
// "When enabled, records the field's value as the item's geolocation to be displayed on locator maps" => "When enabled, records the field's value as the item's geolocation to be displayed on locator maps",
// "Numeric Field" => "Numeric Field",
// "Text to be displayed prior to the numeric value" => "Text to be displayed prior to the numeric value",
// "Decimal Places" => "Decimal Places",
// "Amount of decimals to preserve before rounding" => "Amount of decimals to preserve before rounding",
// "Decimal separator when displaying data" => "Decimal separator when displaying data",
// "Single character. Use c for comma, d for dot or s for space. The valid decimal separator when inserting numbers may depend on site language and web browser. See documentation for more details" => "Single character. Use c for comma, d for dot or s for space. The valid decimal separator when inserting numbers may depend on site language and web browser. See documentation for more details",
// "Thousand separator when displaying data" => "Thousand separator when displaying data",
// "Single character,  Use c for comma, d for dot or s for space.  When inserting data no thousands separator is needed" => "Single character,  Use c for comma, d for dot or s for space.  When inserting data no thousands separator is needed",
// "Page Selector" => "Page Selector",
// "Allows a selection from the list of pages" => "Allows a selection from the list of pages",
// "Will auto-assign the creator of the item" => "Will auto-assign the creator of the item",
// "Visible size of the input in characters" => "Visible size of the input in characters",
"Create Page" => "Crear pàgina",
// "Create missing pages using the page name in this file as the template" => "Create missing pages using the page name in this file as the template",
// "Display the value as a link to the page" => "Display the value as a link to the page",
"Rating" => "Puntuació",
// "A rating of the tracker item" => "A rating of the tracker item",
// "The possible options (comma separated integers) for the rating" => "The possible options (comma separated integers) for the rating",
"Mode" => "Mode",
// "Display rating options as" => "Display rating options as",
// "Stars" => "Stars",
// "Single Option: e.g. Like" => "Single Option: e.g. Like",
"Labels" => "Etiquetes",
// "The text labels (comma separated) for the possible options" => "The text labels (comma separated) for the possible options",
// "Stars (deprecated)" => "Stars (deprecated)",
// "Displays a star rating" => "Displays a star rating",
// "A possible option for the rating" => "A possible option for the rating",
// "Stars (system)" => "Stars (system)",
"Average:" => "Mitjana:",
"Number of votes" => "Nombre de vots",
"Your rating" => "La teva puntuació",
// "Relations" => "Relations",
// "Allows to create arbitrary relations between the trackers and other objects in the system" => "Allows to create arbitrary relations between the trackers and other objects in the system",
// "Relation" => "Relation",
// "Relation qualifier. Must be a three-part qualifier containing letters and separated by dots" => "Relation qualifier. Must be a three-part qualifier containing letters and separated by dots",
// "URL-encoded list of filters to be applied on object selection" => "URL-encoded list of filters to be applied on object selection",
// "Read-only" => "Read-only",
// "Only display the incoming relations instead of manipulating them" => "Only display the incoming relations instead of manipulating them",
// "Include Invert" => "Include Invert",
// "Include invert relations in the list" => "Include invert relations in the list",
"Email" => "Correu-e",
// "Allows to input an email address with options of making it active" => "Allows to input an email address with options of making it active",
// "Link Type" => "Link Type",
// "How the email address will be rendered" => "How the email address will be rendered",
"Plain text" => "Correu-e en text senzill",
// "Encoded mailto link" => "Encoded mailto link",
// "Simple mailto link" => "Simple mailto link",
// "Watch Open" => "Watch Open",
// "Notify this address every time the status changes to open" => "Notify this address every time the status changes to open",
// "Watch Pending" => "Watch Pending",
// "Notify this address every time the status changes to pending" => "Notify this address every time the status changes to pending",
// "Watch Closed" => "Watch Closed",
// "Notify this address every time the status changes to closed" => "Notify this address every time the status changes to closed",
// "Static Text" => "Static Text",
// "Displays the field description as static text that can be used to display notes or additional instructions" => "Displays the field description as static text that can be used to display notes or additional instructions",
// "Wiki Parse" => "Wiki Parse",
// "Indicates if the description should be parsed as wiki syntax for formatting" => "Indicates if the description should be parsed as wiki syntax for formatting",
// "Handle line breaks as new lines only" => "Handle line breaks as new lines only",
// "Maximum Length (List)" => "Maximum Length (List)",
// "Maximum amount of characters to be displayed in list mode" => "Maximum amount of characters to be displayed in list mode",
// "Text Field" => "Text Field",
// "Single-line text input" => "Single-line text input",
// "Display the next field on the same row" => "Display the next field on the same row",
// "Visible size of the field in characters" => "Visible size of the field in characters",
// "Text to prepend when displaying the value" => "Text to prepend when displaying the value",
// "Maximum Length" => "Maximum Length",
// "Maximum amount of characters to store" => "Maximum amount of characters to store",
// "Autocomplete" => "Autocomplete",
// "Enable autocompletion while typing in the field" => "Enable autocompletion while typing in the field",
// "Index exact value" => "Index exact value",
// "In addition to indexing the content of the field, also index it as an identifier in tracker_field_{perm name}_exact. This option is not available for multilingual fields. Mostly for identifiers like product codes or ISBN numbers" => "In addition to indexing the content of the field, also index it as an identifier in tracker_field_{perm name}_exact. This option is not available for multilingual fields. Mostly for identifiers like product codes or ISBN numbers",
"Text Area" => "Àrea de Text",
// "Multi-line text input" => "Multi-line text input",
"Toolbars" => "Barres d'eines",
// "Enable the toolbars as syntax helpers" => "Enable the toolbars as syntax helpers",
"Disable" => "Deshabilita",
"Enable" => "Habilita",
"Width" => "Amplada",
// "Size of the text area in characters" => "Size of the text area in characters",
"Height" => "Alçada",
// "Size of the text area in lines" => "Size of the text area in lines",
// "Character Limit" => "Character Limit",
// "Maximum amount of characters to be stored" => "Maximum amount of characters to be stored",
// "Display Limit (List)" => "Display Limit (List)",
// "Maximum amount of characters to be displayed in list mode before the value gets truncated" => "Maximum amount of characters to be displayed in list mode before the value gets truncated",
"Word Count" => "Recompte de paraules",
// "Limit the length of the text in words" => "Limit the length of the text in words",
// "Distinct Values" => "Distinct Values",
// "All values in the field must be different" => "All values in the field must be different",
// "Use WYSIWYG" => "Use WYSIWYG",
// "Use a rich text editor instead of a plain text box" => "Use a rich text editor instead of a plain text box",
"Word Limit Exceeded" => "S'ha excedit el límit de paraules",
"Character Limit Exceeded" => "S'ha excedit el límit de caracters",
"URL" => "URL (Localitzador de Recurs Universal)",
// "Creates a link to a specified URL" => "Creates a link to a specified URL",
// "How the URL should be rendered" => "How the URL should be rendered",
// "URL as link" => "URL as link",
// "Site title as link" => "Site title as link",
// "URL as link plus site title" => "URL as link plus site title",
// "User Groups" => "User Groups",
// "Displays the list of groups for the user associated with the tracker items" => "Displays the list of groups for the user associated with the tracker items",
// "User Preference" => "User Preference",
// "Allows user preference changes from a tracker" => "Allows user preference changes from a tracker",
// "Preference Name" => "Preference Name",
// "Name of the preference to manipulate. password and email are not preferences, but are also valid values that will modify the user's profile" => "Name of the preference to manipulate. password and email are not preferences, but are also valid values that will modify the user's profile",
// "User Selector" => "User Selector",
// "Allows the selection of a user from a list" => "Allows the selection of a user from a list",
// "Assign the value based on the creator or modifier" => "Assign the value based on the creator or modifier",
// "Email Notification" => "Email Notification",
// "Send an email notification to the user every time the item is modified" => "Send an email notification to the user every time the item is modified",
// "Only when other users modify the item" => "Only when other users modify the item",
// "Group IDs" => "Group IDs",
// "Limit the list of users to members of specific groups" => "Limit the list of users to members of specific groups",
// "User Subscription" => "User Subscription",
// "Allows registered users to subscribe themselves to a tracker item. The item should ideally only be editable by the creator or administrators. Prepend the maximum amount of subscribers to the field value foloowed by # if such a limit is desired. E.g. 50# means that 50 subscriptions will be allowed for this item" => "Allows registered users to subscribe themselves to a tracker item. The item should ideally only be editable by the creator or administrators. Prepend the maximum amount of subscribers to the field value foloowed by # if such a limit is desired. E.g. 50# means that 50 subscriptions will be allowed for this item",
// "Webservice" => "Webservice",
// "Displays the result of a registered webservice call" => "Displays the result of a registered webservice call",
// "Service Name" => "Service Name",
// "Webservice name as registered in Tiki" => "Webservice name as registered in Tiki",
// "Template Name" => "Template Name",
// "Template name to use for rendering as registered with the webservice" => "Template name to use for rendering as registered with the webservice",
// "URL-encoded list of parameters to send to the webservice. %field_name% can be used in the string to be replaced with the values in the tracker item" => "URL-encoded list of parameters to send to the webservice. %field_name% can be used in the string to be replaced with the values in the tracker item",
"Create page:" => "Crea pàgina:",
"Internal error" => "Error intern",
"User error" => "Error de l'usuari",
"Plugin argument(s) missing" => "Manca argument(s) del connector (plugin)",
"Plugin <strong>%0</strong> cannot be executed" => "No es pot executar el Connector (Plugin) <strong>%0</strong> cannot be executed",
"Set" => "Configurar",
"Plugin disabled" => "Connector (plugin) desactivat",
"Line:" => "Línia:",
"Lines:" => "Línies:",
"WikiDiff::apply: line count mismatch: %s != %s" => "WikiDiff::applica: manca de coincidència del contador de línies: %s != %s",
"WikiDiff::_check: failed" => "WikiDiff::_check: error",
"WikiDiff::_check: edit sequence is non-optimal" => "WikiDiff::_check: la seqüència d'edició no és óptima",
"WikiDiff Okay: LCS = %s" => "WikiDiff Ok: LCS = %s",
// "`%0` does not match acceptable naming patterns" => "`%0` does not match acceptable naming patterns",
"Cannot open this file:" => "No puc obrir aquest arxiu:",
// "User File Galleries" => "User File Galleries",
// "Wiki Attachment File Galleries" => "Wiki Attachment File Galleries",
"File Galleries" => "Galeries d'arxius",
"My Files" => "Els meus arxius",
// "Files of " => "Files of ",
"The upload has not been done" => "La pujada no s'ha pogut efectuar",
"Reason: The global quota has been reached" => "Raó: S'ha arribat al maxim de quota permès",
"Reason: The quota has been reached in \"%s\"" => "Raó: S'ha arribat al maxim de quota permès en \"%s\"",
"File gallery quota exceeded" => "S'ha excedit la quota de la galeria d'arxius",
// "Number of files transferred to the database" => "Number of files transferred to the database",
// "Number of files transferred to the file system" => "Number of files transferred to the file system",
// "Old File deleted" => "Old File deleted",
"Incorrect param" => "Paràmetre Incorrecte",
"You do not have permission to remove files from this gallery" => "Permís denegat, no podeu eliminar arxius dóaquesta galeria",
// "WARNING: The file is used in" => "WARNING: The file is used in",
// "Remove file draft: " => "Remove file draft: ",
// "Remove file: " => "Remove file: ",
// "You are trying to edit multiple files in different galleries, which is not supported yet" => "You are trying to edit multiple files in different galleries, which is not supported yet",
// "The specified file does not exist" => "The specified file does not exist",
"Upload was not successful" => "La pujada no s'ha realitzat amb èxit",
"An exception occurred" => "Ha ocorregut una excepció",
"Batch file processed" => "S'ha processat l'arxiu per lots",
"No permission to upload zipped file packages" => "No hi ha permisos per baixar-se paquets de fitxers enzipats",
"Errors detected" => "Errors detectats",
// "Check that these paths exist and are writable by the web server" => "Check that these paths exist and are writable by the web server",
"File added: " => "S'ha afegit l'arxiu: ",
// "Cannot read the file" => "Cannot read the file",
// "Incorrect file extension" => "Incorrect file extension",
// "Warning: Empty file" => "Warning: Empty file",
"Please re-upload your file" => "Per favor, torna a pujar el teu arxiu",
"Upload was not successful. Duplicate file content" => "La pujada ha fallat. Duplica el contingut de l'arxiu",
"File update was successful" => "L'actualització de l'arxiu ha tingut èxit",
"Cannot resize the file" => "No s'ha pogut redimensionar l'arxiu",
"Cannot write the file" => "No s'ha pogut escriure l'arxiu",
"Image was reduced: %s x %s -> %s x %s" => "La imatge ha estat reduïda: %s x %s -> %s x %s",
"Could not upload the file" => "No es pot pujar l'arxiu",
"Could not find the file requested" => "No s'ha pogut trobar l'arxiu demanat",
"The file is locked by %s" => "L'arxiu és bloquejat per %s",
"You do not have permission to edit this file" => "Permís denegat, no podeu editar aquest fitxer",
"Cannot read uploaded file" => "No es pot llegir l'arxiu pujat",
"Cannot read file on disk" => "No es pot llegir l'arxiu al disc",
"unknown" => "desconegut",
// "Automatic revision from source" => "Automatic revision from source",
"Page" => "Pàgina",
"Cannot upload this file" => "No es pot pujar aquest arxiu",
"This is an approximation based on your server memory limit" => "Això és una aproximació basada en el limit de memòria del teu servidor",
"This is the value of your server's PHP '%s' setting" => "Aquest és el valor de la configuració PHP '%s' del teu servidor",
"You are alerted by the server " => "Estàs alertat pel servidor ",
"You can check the modifications at : " => "Pots comprovar les modificacions a : ",
"You are alerted of a change on " => "Està alertat de canvis sobre ",
"No image yet, sorry." => "Ho sento, encara no hi ha cap imatge.",
"unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>" => "directori de destinació desconegut. Configura'l a <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>",
"unlink failed" => "no s'ha pogut treure l'enllaç",
"The uploaded file exceeds the upload_max_filesize directive in php.ini" => "L'arxiu pujar excedeix la mida màxima fixada a la directiva upload_max_filesize al php.ini",
"The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form" => "L'arxiu pujar excedeix la mida màxima fixada a la directiva MAX_FILE_SIZE que s'ha especificat al formulari HTML",
"The uploaded file was only partially uploaded. Please try again" => "L'arxiu pujar només s'ha pujat parcialment. Si us plau, prova-ho de nou",
"No file was uploaded" => "No s'ha pujat cap arxiu",
"Missing a temporary folder" => "Manca un directori temporal",
"Failed to write file to disk" => "No s'ha pogut desar l'arxiu al disc",
"File upload stopped by extension" => "S'ha aturat la pujada de l'arxiu a causa de l'extensió de l'arxiu (.xxx)",
// "Set new blog as Tiki homepage" => "Set new blog as Tiki homepage",
// "Importation completed" => "Importation completed",
"<a href=\"tiki-importer.php\">Click here</a> to finish the import process" => "<a href=\"tiki-importer.php\">Clica aquí</a> per finalitzar el procés d'importació",
// "Found %0 posts, %1 pages, %2 tags and %3 categories. Inserting them into Tiki" => "Found %0 posts, %1 pages, %2 tags and %3 categories. Inserting them into Tiki",
// "Item \"%0\" NOT imported (there was already a item with the same name)" => "Item \"%0\" NOT imported (there was already a item with the same name)",
// "Page \"%0\" sucessfully imported" => "Page \"%0\" sucessfully imported",
// "Post \"%0\" sucessfully imported" => "Post \"%0\" sucessfully imported",
// "Import images and other attachments" => "Import images and other attachments",
// "Update internal links (experimental)" => "Update internal links (experimental)",
// "Suggest .htaccess rules to redirect from old WP URLs to new Tiki URLs (experimental)" => "Suggest .htaccess rules to redirect from old WP URLs to new Tiki URLs (experimental)",
"Class DOMDocument not available, check your PHP installation. For more information see http://php.net/manual/en/book.dom.php" => "No es troba disponible la classe DOMDocument, comprova la teva instal·lació de PHP. Per a més informació, consulta http://php.net/manual/en/book.dom.php",
"Invalid file mime type" => "El tipus mime de l'arxiu és invàlid",
// "Error while loading XML file. Probably your XML file is malformed. Some versions of Wordpress generate a malformed XML file. See the Tiki Importer documentation for more information" => "Error while loading XML file. Probably your XML file is malformed. Some versions of Wordpress generate a malformed XML file. See the Tiki Importer documentation for more information",
// "Invalid Wordpress XML file" => "Invalid Wordpress XML file",
// "No attachments found to import" => "No attachments found to import",
// "Importing attachments" => "Importing attachments",
// "Attachment %0 successfully imported" => "Attachment %0 successfully imported",
// "Unable to download attachment %0. Error message was: %1 %2" => "Unable to download attachment %0. Error message was: %1 %2",
// "%0 attachments imported and %1 errors" => "%0 attachments imported and %1 errors",
// "Page \"%0\" successfully extracted" => "Page \"%0\" successfully extracted",
// "Post \"%0\" successfully extracted" => "Post \"%0\" successfully extracted",
// "Extracting data from XML file" => "Extracting data from XML file",
"Number of page revisions to import (0 for all revisions):" => "Nombre de revisions de pàgines a importar (0 per a totes les revisions):",
// "What to do with page names that already exists in Tiki" => "What to do with page names that already exists in Tiki",
"Do not import" => "No importar",
"Override" => "Sobreescriure",
"Append software name as prefix to the page name" => "Afegeix el nom del programari com a sufix del nom de la pàgina",
// "Page %0 sucessfully imported" => "Page %0 sucessfully imported",
// "Page %0 NOT imported (there was already a page with the same name)" => "Page %0 NOT imported (there was already a page with the same name)",
// "%0 pages parsed. Starting to insert those pages into Tiki" => "%0 pages parsed. Starting to insert those pages into Tiki",
"Import images and attachments (see documentation for more information)" => "Importa  les imatges i els adjunts (consulta la documentació per a més informació)",
// "Add a maketoc at the top of each page" => "Add a maketoc at the top of each page",
"XML file does not validate against the Mediawiki XML schema" => "L'arxiu XML no valida contra l'esquema XML de Mediawiki ",
// "ABORTING: destination directory for attachments (%0) does no exist. Fix the problem or try to import without the attachments" => "ABORTING: destination directory for attachments (%0) does no exist. Fix the problem or try to import without the attachments",
// "ABORTING: destination directory for attachments (%0) is not writable. Fix the problem or try to import without attachments" => "ABORTING: destination directory for attachments (%0) is not writable. Fix the problem or try to import without attachments",
// "NOT importing file %0 as there is already a file with the same name in the destination directory (%1)" => "NOT importing file %0 as there is already a file with the same name in the destination directory (%1)",
// "File %0 successfully imported" => "File %0 successfully imported",
// "Unable to download file %0. File not found" => "Unable to download file %0. File not found",
// "Error while parsing revision %0 of the page \"%1\". Or there is a problem on the page syntax or on the Text_Wiki parser (the parser used by the importer)" => "Error while parsing revision %0 of the page \"%1\". Or there is a problem on the page syntax or on the Text_Wiki parser (the parser used by the importer)",
// "Page \"%0\" successfully parsed with %1 revisions (from a total of %2 revisions)" => "Page \"%0\" successfully parsed with %1 revisions (from a total of %2 revisions)",
// "Page \"%0\" is NOT going to be imported. It was not possible to parse any of the page revisions" => "Page \"%0\" is NOT going to be imported. It was not possible to parse any of the page revisions",
// "Mediawiki XML file version %0 is not supported" => "Mediawiki XML file version %0 is not supported",
// "ABORTING: you need to enable the PHP setting 'allow_url_fopen' to be able to import attachments. Fix the problem or try to import without the attachments" => "ABORTING: you need to enable the PHP setting 'allow_url_fopen' to be able to import attachments. Fix the problem or try to import without the attachments",
// "Parsing pages" => "Parsing pages",
// "No attachments found to import! Make sure you have created your XML file with the dumpDump.php script and with the option --uploads. This is the only way to import attachment" => "No attachments found to import! Make sure you have created your XML file with the dumpDump.php script and with the option --uploads. This is the only way to import attachment",
// "string" => "string",
// "ERROR: unable to write to lang/%s/language.php" => "ERROR: unable to write to lang/%s/language.php",
// "The file lang/%0/language.php is not well formated. Run get_strings.php?lang=%0 and then try to export the translations again" => "The file lang/%0/language.php is not well formated. Run get_strings.php?lang=%0 and then try to export the translations again",
"Contributions" => "Contribucions",
"Query point:" => "Punt de la consulta:",
"layer:" => "capa:",
"Record:" => "Registre:",
"This feature is disabled" => "Aquesta característica està deshabilitada",
"Could not create \$tdo.mif in data directory" => "No s'ha pogut crear \$tdo.mif en el directori de dades",
"Could not create \$tdo.mid in data directory" => "No s'ha pogut crear \$tdo.mid en el directori de dades",
"User Map Generated in:" => "Mapa d'usuaris generat a:",
"Image Map Generated in:" => "Mapa d'imatges generat a:",
// "(copy)" => "(copy)",
"You can only use optionId = 0 to create a new option or optionId equal an id that already belongs to the menu to update it." => "Només pots utilitzar optionId = 0 per crear una nova opció, o optionId igual a una id que ja pertanyi al menú per actualitzar-la.",
"menu" => "menú",
"NONE" => "CAP",
// "Stored IPTC Digest" => "Stored IPTC Digest",
// "Calculated IPTC Digest" => "Calculated IPTC Digest",
// "The file is empty" => "The file is empty",
// "The file is not readable" => "The file is not readable",
// "File type not handled by Tiki - only basic metadata available" => "File type not handled by Tiki - only basic metadata available",
// "Photographer Data (IPTC)" => "Photographer Data (IPTC)",
// "No IPTC data" => "No IPTC data",
// "File Data (EXIF)" => "File Data (EXIF)",
// "No EXIF data" => "No EXIF data",
// "Not processed" => "Not processed",
// "Unixtime" => "Unixtime",
// "XMP Data" => "XMP Data",
// "No XMP data" => "No XMP data",
// "File type not handled by Tiki" => "File type not handled by Tiki",
// "Invalid \"from\" date received" => "Invalid \"from\" date received",
// "Invalid \"to\" date received" => "Invalid \"to\" date received",
// "Sorry, \"from\" date must precede \"to\" date" => "Sorry, \"from\" date must precede \"to\" date",
// "Sorry, no data available for the future" => "Sorry, no data available for the future",
"for month of" => "per al més de",
"for" => "per a",
"for week of" => "per a la setmana de",
"Integer (i)" => "Sencer / Interger (i)",
"Percentage (%)" => "Percentatge (%)",
"Float (f)" => "Flotant / Float (f)",
"List (L)" => "Llista (L)",
"Daily (+)" => "Diari (+)",
"Monthly and weekly (@)" => "Menusal i setmanal (@)",
"Weekly (-)" => "Setmanal (-)",
"File %s not found" => "No s'ha trobat l'arxiu %s ",
"File %s is not a valid archive" => "L'arxiu %s no és un arxiu vàlid",
"Impossible to open %s : %s" => "Impossible obrir %s : %s",
"The content retrieved at %s is not a list of mods" => "El contingut recuperat a %s no és una llista de mods",
"Can't chdir to '%s'" => "No es pot chdir a '%s'",
"%s impossible to remove" => "No es pot eliminar %s",
"Description not available" => "No hi ha descripció disponible",
"Module Title" => "Títol del mòdul",
"Title to display at the top of the box" => "Títol que es vol mostrar a sobre de la caixa",
// "No Box" => "No Box",
"Show only the content" => "Mostra només el contingut",
"Decorations" => "Decoracions",
"Show module decorations" => "Mostra les decoracions dels mòduls",
// "No Title" => "No Title",
"Show module title" => "Mostra el títol del mòdul",
// "Module displayed depending on category. Multiple category ids or names can be separated by semi-colons" => "Module displayed depending on category. Multiple category ids or names can be separated by semi-colons",
// "No Category" => "No Category",
// "Module hidden depending on category. Multiple category ids or names can be separated by semi-colons. This takes precedence over the category parameter above" => "Module hidden depending on category. Multiple category ids or names can be separated by semi-colons. This takes precedence over the category parameter above",
"Perspective" => "Perspectiva",
// "Only display the module if in one of the listed perspective IDs. Semi-colon separated" => "Only display the module if in one of the listed perspective IDs. Semi-colon separated",
// "Module only applicable for the specified languages. Languages are defined as two character language codes. Multiple values can be separated by semi-colons" => "Module only applicable for the specified languages. Languages are defined as two character language codes. Multiple values can be separated by semi-colons",
"Section" => "Secció",
// "Module only applicable for the specified sections. Multiple values can be separated by semi-colons" => "Module only applicable for the specified sections. Multiple values can be separated by semi-colons",
// "Page Filter" => "Page Filter",
// "Module only applicable on the specified page names. Multiple values can be separated by semi-colons" => "Module only applicable on the specified page names. Multiple values can be separated by semi-colons",
"No Page" => "Cap pàgina",
// "Module not applicable on the specified page names. Multiple values can be separated by semi-colons" => "Module not applicable on the specified page names. Multiple values can be separated by semi-colons",
"Theme" => "Tema",
// "Module enabled or disabled depending on the theme file name (e.g. \"thenews.css\"). Specified themes can be either included or excluded. Theme names prefixed by \"!\" are in the exclusion list. Multiple values can be separated by semi-colons" => "Module enabled or disabled depending on the theme file name (e.g. \"thenews.css\"). Specified themes can be either included or excluded. Theme names prefixed by \"!\" are in the exclusion list. Multiple values can be separated by semi-colons",
// "Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module" => "Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module",
// "Contributor" => "Contributor",
// "Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module" => "Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module",
"Flip" => "Permet amagar-lo",
"Users can shade module" => "Els usuaris poden amagar el mòdul",
"Style" => "Estil",
// "CSS styling for positioning the module" => "CSS styling for positioning the module",
"Class" => "Classe",
// "Custom CSS class" => "Custom CSS class",
// "Containing Class" => "Containing Class",
// "Custom CSS class around" => "Custom CSS class around",
// "No Numbers" => "No Numbers",
"If set to \"y\", the module will not number list items" => "Si es posa en \"y\", el mòdul no numerarà la llista d'ítems",
"Rows" => "Files",
"Number of rows, or items, to display" => "Nombre de files o ítems a mostrar",
"Default: 10" => "Per omissió: 10",
// "Failed to execute \"%0\" module" => "Failed to execute \"%0\" module",
// "Missing dependencies" => "Missing dependencies",
// "Contact the system administrator" => "Contact the system administrator",
"Newsletter subscription information at" => "La informació de subscripció a butlletins es troba a",
"Error" => "Error",
// "Limiting the email send rate. Resuming in %0 seconds" => "Limiting the email send rate. Resuming in %0 seconds",
"invalid email" => "correu-e invàlid",
"Sending to" => "Enviant-ho a",
"A user registers" => "Un usuari es registra",
"A user submits an article" => "Un usuari envia una col·laboració",
"A user edits an article" => "Un usuari edita un article",
"A user deletes an article" => "Un usuari esborra un article",
// "An article is submitted, edited, deleted or commented on" => "An article is submitted, edited, deleted or commented on",
// "A new blog post is published" => "A new blog post is published",
// "A wiki page is created, deleted or edited, except for minor changes" => "A wiki page is created, deleted or edited, except for minor changes",
// "A wiki page is created, deleted or edited, even for minor changes" => "A wiki page is created, deleted or edited, even for minor changes",
// "A comment in a wiki page is posted or edited" => "A comment in a wiki page is posted or edited",
// "A comment in an article is posted or edited" => "A comment in an article is posted or edited",
// "Token is called" => "Token is called",
// "User joins a group" => "User joins a group",
"section edit" => "secció edició",
"Edit Section" => "Edita la secció",
"index" => "índex",
"Table of contents" => "Taula de continguts (índex)",
"Show/Hide" => "Mostra/Amaga",
// "smiling" => "smiling",
"sad" => "trist",
// "grinning" => "grinning",
"confused" => "confós",
"cool" => "guai",
// "crying" => "crying",
// "frightened" => "frightened",
// "evil stuff" => "evil stuff",
// "exclamation mark " => "exclamation mark ",
// "frowning" => "frowning",
// "light bulb" => "light bulb",
// "idea " => "idea ",
// "LOL" => "LOL",
// "laughing out loud " => "laughing out loud ",
"mad" => "boig",
// "Mr. Green laughing" => "Mr. Green laughing",
// "Payment sent but verification not currently available. (Work in progress)" => "Payment sent but verification not currently available. (Work in progress)",
// "Gift card is not valid for products in cart" => "Gift card is not valid for products in cart",
// "Bundled Product" => "Bundled Product",
"Product" => "Producte",
"Quantity" => "Quantitat",
"Unit Price" => "PReu unitari",
// "There is not enough inventory left for your request" => "There is not enough inventory left for your request",
// "Registration Check-Out" => "Registration Check-Out",
// "Gift Certificate: " => "Gift Certificate: ",
// "Gift Certificate Amount Used: " => "Gift Certificate Amount Used: ",
"No registries specified in admin/payment/cclite" => "No s'han especificat xarxes (registries) a admin > pagaments > cclite",
"Cclite payment initiated on %0" => "Pagament via cclite iniciat el %0",
"Connection to cclite server %0 failed for %1<br />\"%2\"" => "La connexió al servidor de cclite %0 ha fallat per %1<br />\"%2\"",
// "Tiki credits payment done on %0 for %1 (using %2)" => "Tiki credits payment done on %0 for %1 (using %2)",
// "No category jail set in any perspective" => "No category jail set in any perspective",
// "Areas root category id" => "Areas root category id",
// "is invalid" => "is invalid",
// "Ajax auto-save" => "Ajax auto-save",
// "Saves your edits as you go along enabling you to recover your work after an \"interruption\". Also enables \"Live\" preview and is required for wysiwyg plugin processing" => "Saves your edits as you go along enabling you to recover your work after an \"interruption\". Also enables \"Live\" preview and is required for wysiwyg plugin processing",
"Users accept internal messages by default" => "Els usuaris poden acceptar missatges interns per defecte",
// "Users can opt-out of internal messages" => "Users can opt-out of internal messages",
// "Id of category whose children are bound to a perspective by areas" => "Id of category whose children are bound to a perspective by areas",
"Newest first" => "Primer els més nous",
"ascending" => "ascendent",
"descending" => "descendent",
// "Article ordering" => "Article ordering",
// "Default sort mode for the articles on the article listing" => "Default sort mode for the articles on the article listing",
// "Title of articles home page" => "Title of articles home page",
"Topic" => "Tema",
"Title" => "Títol",
"Title length" => "Longitud del Títol",
"Publication date" => "Data de publicació",
"Expiration date" => "Data de caducitat",
"Visible" => "Visible",
"Author" => "Autor",
// "Author Rating" => "Author Rating",
"Reads" => "Lectures",
"Id" => "Id",
// "Trailer position" => "Trailer position",
"Top" => "Dalt",
// "Between heading and body" => "Between heading and body",
// "Header text position" => "Header text position",
// "Requires a smaller image for list view" => "Requires a smaller image for list view",
// "Next image" => "Next image",
// "Below image" => "Below image",
"Oldest first" => "Els més antic primer",
"Points" => "Punts",
// "Default number per page" => "Default number per page",
// "Default Ordering" => "Default Ordering",
// "Paginate articles" => "Paginate articles",
// "Divide articles into multiple pages with pagebreak markers" => "Divide articles into multiple pages with pagebreak markers",
// "User ratings on articles" => "User ratings on articles",
// "Allows users to rate the articles" => "Allows users to rate the articles",
// "Article rating options" => "Article rating options",
// "List of options available for the rating of articles" => "List of options available for the rating of articles",
// "Default maximum width for custom article images" => "Default maximum width for custom article images",
// "Number of pixels, 0 for no maximum" => "Number of pixels, 0 for no maximum",
// "Default maximum height for custom article images" => "Default maximum height for custom article images",
// "Default maximum width for custom article images in list mode (on View Articles)" => "Default maximum width for custom article images in list mode (on View Articles)",
// "Number of pixels, 0 to fallback to the view mode maximum" => "Number of pixels, 0 to fallback to the view mode maximum",
// "Default maximum height for custom article images in list mode (on View Articles)" => "Default maximum height for custom article images in list mode (on View Articles)",
// "Custom attributes for article types" => "Custom attributes for article types",
// "Allow additional custom fields for article types" => "Allow additional custom fields for article types",
// "Your ShareThis publisher identifier (optional)" => "Your ShareThis publisher identifier (optional)",
// "Related articles" => "Related articles",
// "Display a list of related articles at the bottom of the article page" => "Display a list of related articles at the bottom of the article page",
"Authentication method" => "Mètode d'Autentificació",
// "Tiki supports several authentication methods. The default value is to use the internal user database" => "Tiki supports several authentication methods. The default value is to use the internal user database",
"Tiki" => "Tiki",
// "Tiki and OpenID" => "Tiki and OpenID",
"Tiki and PAM" => "Tiki i PAM",
// "Tiki and LDAP" => "Tiki and LDAP",
"CAS (Central Authentication Service)" => "CAS (Servei Central d'Autenticació)",
"Shibboleth" => "Shibboleth",
"Web Server" => "Servidor Web",
// "phpBB" => "phpBB",
// "Token Access" => "Token Access",
// "Allow to access the content with superior rights with the presentation of a token. The primary use of this authentication method is to grant temporary access to content to an external service" => "Allow to access the content with superior rights with the presentation of a token. The primary use of this authentication method is to grant temporary access to content to an external service",
// "Token Access Max Timeout" => "Token Access Max Timeout",
// "The maximum duration for which the generated tokens will be valid" => "The maximum duration for which the generated tokens will be valid",
// "(seconds)" => "(seconds)",
// "Token Access Max Hits" => "Token Access Max Hits",
// "The maximum amount of times a token can be used before it expires" => "The maximum amount of times a token can be used before it expires",
// "Share access rights with friends when using Tell a friend" => "Share access rights with friends when using Tell a friend",
// "Allow users to share their access rights on the current page with a friend when sending the link by email. Lifespan of the links is defined by the site" => "Allow users to share their access rights on the current page with a friend when sending the link by email. Lifespan of the links is defined by the site",
// "Share access rights with friends when using Share" => "Share access rights with friends when using Share",
// "Allow users to share their access rights on the current page with a friend when sending the link by email/Twitter/Facebook. Lifespan of the links is defined by the site" => "Allow users to share their access rights on the current page with a friend when sending the link by email/Twitter/Facebook. Lifespan of the links is defined by the site",
// "Create user if not in Tiki" => "Create user if not in Tiki",
// "Use Tiki authentication for Admin login" => "Use Tiki authentication for Admin login",
// "phpBB Version" => "phpBB Version",
"3" => "3",
// "phpBB Database Hostname" => "phpBB Database Hostname",
// "phpBB Database Username" => "phpBB Database Username",
// "phpBB Database Password" => "phpBB Database Password",
// "phpBB Database Name" => "phpBB Database Name",
// "phpBB Table Prefix" => "phpBB Table Prefix",
// "Use Tiki authentication for users created in Tiki" => "Use Tiki authentication for users created in Tiki",
// "Host" => "Host",
"Port" => "Port",
// "Write LDAP debug Information in Tiki Logs" => "Write LDAP debug Information in Tiki Logs",
// "Use SSL (ldaps)" => "Use SSL (ldaps)",
// "Use TLS" => "Use TLS",
// "LDAP Bind Type" => "LDAP Bind Type",
// "Default: Anonymous Bind" => "Default: Anonymous Bind",
// "Full: userattr=username,UserDN,BaseDN" => "Full: userattr=username,UserDN,BaseDN",
// "OpenLDAP: cn=username,BaseDN" => "OpenLDAP: cn=username,BaseDN",
// "Active Directory (username@domain)" => "Active Directory (username@domain)",
// "Plain Username" => "Plain Username",
// "Search scope" => "Search scope",
// "Subtree" => "Subtree",
// "One level" => "One level",
// "Base object" => "Base object",
// "LDAP version" => "LDAP version",
// "Base DN" => "Base DN",
// "User DN" => "User DN",
// "User attribute" => "User attribute",
// "User OC" => "User OC",
// "Realname attribute" => "Realname attribute",
// "Country attribute" => "Country attribute",
// "E-mail attribute" => "E-mail attribute",
// "Group DN" => "Group DN",
// "Group name attribute" => "Group name attribute",
// "Group description attribute" => "Group description attribute",
// "Group OC" => "Group OC",
// "Member attribute" => "Member attribute",
// "Member is DN" => "Member is DN",
// "Group attribute" => "Group attribute",
// "Group attribute in group entry" => "Group attribute in group entry",
// "(Leave this empty if the group name is already given in the user attribute)" => "(Leave this empty if the group name is already given in the user attribute)",
// "Admin user" => "Admin user",
// "Admin password" => "Admin password",
// "Use an external LDAP server for groups" => "Use an external LDAP server for groups",
// "Corresponding user attribute in 1st directory" => "Corresponding user attribute in 1st directory",
// "Disable Tiki users who don't have a phpBB login. (They could have been deleted)" => "Disable Tiki users who don't have a phpBB login. (They could have been deleted)",
// "Available languages" => "Available languages",
// "By default, all languages supported by tikiwiki are available on multilingual sites. This option allows to limit the languages to a subset" => "By default, all languages supported by tikiwiki are available on multilingual sites. This option allows to limit the languages to a subset",
// "Available styles" => "Available styles",
// "BigBlueButton Web Conferencing" => "BigBlueButton Web Conferencing",
// "Integration with the BigBlueButton collaboration server for web conference and screen sharing" => "Integration with the BigBlueButton collaboration server for web conference and screen sharing",
// "BigBlueButton server location" => "BigBlueButton server location",
// "Full URL to the BigBlueButton installation" => "Full URL to the BigBlueButton installation",
// "http://host.example.com/" => "http://host.example.com/",
// "BigBlueButton server salt" => "BigBlueButton server salt",
// "A salt key used to generate checksums for the BigBlueButton server to know the requests are authentic" => "A salt key used to generate checksums for the BigBlueButton server to know the requests are authentic",
// "BigBlueButton recording maximum duration" => "BigBlueButton recording maximum duration",
// "A maximum duration for the meetings must be provided to BigBlueButton to prevent the recordings to be excessively long if a user leaves the window open too long" => "A maximum duration for the meetings must be provided to BigBlueButton to prevent the recordings to be excessively long if a user leaves the window open too long",
"minutes" => "minuts",
// "Default ordering" => "Default ordering",
"Creation Date (desc)" => "Data de creació (desc)",
"Last modification date (desc)" => "Data de l'última modificació (desc)",
"Blog title (asc)" => "Títol del bloc (asc)",
"Number of posts (desc)" => "Nombre de publicacions (desc)",
"Visits (desc)" => "Visites (desc)",
"Activity (desc)" => "Activitat (desc)",
"Last modified" => "Darrers canvis",
"Disabled" => "Deshabilitades",
"Link to user information" => "Enllaç a la informació d'usuari",
"User avatar" => "Avatar de l'usuari/a",
"Posts" => "Publicacions",
"Visits" => "Visites",
"Activity" => "Activitat",
// "Module (box) shadow start" => "Module (box) shadow start",
// "Module (box) shadow end" => "Module (box) shadow end",
// "Days to display in the Calendar" => "Days to display in the Calendar",
"Default view mode" => "Mode de vista per defecte",
"Day" => "Dia",
"Week" => "Setmana",
"Month" => "Mes",
"Quarter" => "Quadrimestre",
"Semester" => "Semestre",
"Year" => "Any",
// "View list begins" => "View list begins",
// "Focus Date" => "Focus Date",
// "Period beginning" => "Period beginning",
"First day of the week" => "Primer dia de la setmana",
"Depends user language" => "Depèn de l'idioma de l'usuari",
"Split hours in periods of" => "Divideix hores en períodes de",
"1 minute" => "1 minut",
"5 minutes" => "5 minuts",
"10 minutes" => "10 minuts",
"15 minutes" => "15 minuts",
"30 minutes" => "30 minuts",
// "First year in the dropdown" => "First year in the dropdown",
// "Enter a year or use +/- N to specify a year relative to the current year" => "Enter a year or use +/- N to specify a year relative to the current year",
// "Last year in the dropdown" => "Last year in the dropdown",
// "Sticky popup" => "Sticky popup",
// "Item view tab" => "Item view tab",
// "Show Add to Google Calendar icon" => "Show Add to Google Calendar icon",
// "Show Export Calendars button" => "Show Export Calendars button",
// "Use FullCalendar to display Calendars" => "Use FullCalendar to display Calendars",
// "Treat calendar item descriptions as HTML" => "Treat calendar item descriptions as HTML",
// "Use this if you use the WYSIWYG editor for calendars. This is to handle legacy data from Tiki pre 7.0" => "Use this if you use the WYSIWYG editor for calendars. This is to handle legacy data from Tiki pre 7.0",
// "Word length of the captcha image" => "Word length of the captcha image",
// "Default" => "Default",
// "Width of the captcha image in pixels" => "Width of the captcha image in pixels",
// "Level of noise of the captcha image" => "Level of noise of the captcha image",
// "Choose a smaller number for less noise and easier reading" => "Choose a smaller number for less noise and easier reading",
// "Try automatically to connect SSO" => "Try automatically to connect SSO",
// "Force CAS log-out when the user logs out from Tiki" => "Force CAS log-out when the user logs out from Tiki",
// "Show Alternate Login Method in Header" => "Show Alternate Login Method in Header",
"CAS server version" => "versió del servidor CAS",
"none" => "cap",
"Version 1.0" => "Versió 1.0",
"Version 2.0" => "Versió 2.0",
// "Hostname" => "Hostname",
// "Hostname of the CAS server" => "Hostname of the CAS server",
// "Port of the CAS server" => "Port of the CAS server",
// "Path for the CAS server" => "Path for the CAS server",
// "CAS Extra Parameter" => "CAS Extra Parameter",
// "Extra Parameter to pass to the CAS Server" => "Extra Parameter to pass to the CAS Server",
// "CAS Authentication Verification Timeout" => "CAS Authentication Verification Timeout",
// "Verify authentication with the CAS server every N seconds. Null value means never reverify" => "Verify authentication with the CAS server every N seconds. Null value means never reverify",
"Never" => "Mai",
// "2 minutes" => "2 minutes",
"1 hour" => "1 hora",
// "Categories used in templates (TPL)" => "Categories used in templates (TPL)",
// "Permits to show alternate content depending on category of current object" => "Permits to show alternate content depending on category of current object",
// "Category Jail" => "Category Jail",
// "Limits the visibility of objects to those in these category IDs. Used mainly for creating workspaces from perspectives" => "Limits the visibility of objects to those in these category IDs. Used mainly for creating workspaces from perspectives",
// "Category Defaults" => "Category Defaults",
// "Force certain categories to be present. If none of the categories in a given set are provided, assign a category by default" => "Force certain categories to be present. If none of the categories in a given set are provided, assign a category by default",
// "Use *7 to specify all the categories in the subtree of 7 + category 7" => "Use *7 to specify all the categories in the subtree of 7 + category 7",
// "Can do only this for objectname matching the regex (Example: /^RND_/ = name beginning by RND_)(Optional)" => "Can do only this for objectname matching the regex (Example: /^RND_/ = name beginning by RND_)(Optional)",
// "Can do for wiki only (optional)" => "Can do for wiki only (optional)",
// "Rename will only reassign the categories for wiki pages" => "Rename will only reassign the categories for wiki pages",
// "One per line. ex:1,4,6,*7/4:/^RND_/:wiki page" => "One per line. ex:1,4,6,*7/4:/^RND_/:wiki page",
// "Synchronize multilingual categories" => "Synchronize multilingual categories",
// "Make sure that the categories on the translations are synchronized when modified on any version" => "Make sure that the categories on the translations are synchronized when modified on any version",
// "Only those specified" => "Only those specified",
// "All but those specified" => "All but those specified",
// "Synchronized categories" => "Synchronized categories",
// "List of categories affected by the multilingual synchronization. Depending on the parent feature, this list will be used as a white list (only categories allows) or as a black list (all except thoses specified)" => "List of categories affected by the multilingual synchronization. Depending on the parent feature, this list will be used as a white list (only categories allows) or as a black list (all except thoses specified)",
// "Sort categories by legacy ASCII sequence" => "Sort categories by legacy ASCII sequence",
// "If turned on, will sort categories taking into account all characters as upper case, in ASCII sequence, will only consider limited set of accented characters. Might be needed to be able to override the normal sort by prepending punctuation characters to category names, such as \"-\" to sort at the beginning and \"[\" to sort at the end" => "If turned on, will sort categories taking into account all characters as upper case, in ASCII sequence, will only consider limited set of accented characters. Might be needed to be able to override the normal sort by prepending punctuation characters to category names, such as \"-\" to sort at the beginning and \"[\" to sort at the end",
// "Automatically geocode items when categorized in" => "Automatically geocode items when categorized in",
// "Automatically geocode items based on category name when categorized in the sub-categories of this category ID" => "Automatically geocode items based on category name when categorized in the sub-categories of this category ID",
// "Replace existing geocode if any" => "Replace existing geocode if any",
// "When automatically geocoding items based on category name, replace existing geocode if any" => "When automatically geocoding items based on category name, replace existing geocode if any",
// "Use approximate geocode location" => "Use approximate geocode location",
// "When automatically geocoding items based on category name, use randomly approximated location instead of precise location" => "When automatically geocoding items based on category name, use randomly approximated location instead of precise location",
// "\"More Like This\" algorithm for categories" => "\"More Like This\" algorithm for categories",
// "Basic" => "Basic",
// "Weighted" => "Weighted",
// "Minimum number of categories in common" => "Minimum number of categories in common",
"1" => "1",
"2" => "2",
"4" => "4",
"5" => "5",
// "6" => "6",
// "7" => "7",
// "8" => "8",
// "9" => "9",
// "10" => "10",
// "Or look for the maximum less categories in common if no objects with the above number of common categories" => "Or look for the maximum less categories in common if no objects with the above number of common categories",
// "Maximum of objects more like this, otherwise use the default max records" => "Maximum of objects more like this, otherwise use the default max records",
// "Exclude these category IDs" => "Exclude these category IDs",
// "Category path won't appear for these category IDs" => "Category path won't appear for these category IDs",
// "Center shadow start" => "Center shadow start",
// "Center shadow end" => "Center shadow end",
// "Users can change site language" => "Users can change site language",
// "Allow users to change the language of the menus and labels" => "Allow users to change the language of the menus and labels",
"Users can change theme" => " Els usuaris registrats poden canviar el tema",
// "Users can change their password" => "Users can change their password",
// "Disable title for comments" => "Disable title for comments",
// "Hide the title field on comments and their replies" => "Hide the title field on comments and their replies",
// "Email field" => "Email field",
// "Email field for comments (only for anonymous users)" => "Email field for comments (only for anonymous users)",
// "Website field" => "Website field",
// "Website field for comments (only for anonymous users)" => "Website field for comments (only for anonymous users)",
// "Use vote system for comments" => "Use vote system for comments",
// "Allows users with permission tiki_p_vote_comments to vote comments" => "Allows users with permission tiki_p_vote_comments to vote comments",
// "Archive comments" => "Archive comments",
// "If a comment is archived, only admins can see it" => "If a comment is archived, only admins can see it",
// "Use Akismet to filter comments" => "Use Akismet to filter comments",
// "Prevent comment spam by using the Akismet service to determine if the comment is spam. If comment moderation is enabled, the Akismet will indicate if the comment is to be moderated or not. If there is no comment moderation, the comment will be rejected if considered as spam" => "Prevent comment spam by using the Akismet service to determine if the comment is spam. If comment moderation is enabled, the Akismet will indicate if the comment is to be moderated or not. If there is no comment moderation, the comment will be rejected if considered as spam",
// "Akismet API Key" => "Akismet API Key",
// "Key required for the Akismet comment spam prevention to work" => "Key required for the Akismet comment spam prevention to work",
// "Obtain this key by registering your site on [%0]" => "Obtain this key by registering your site on [%0]",
// "Filter spam for registered users" => "Filter spam for registered users",
// "Enable spam filtering for registered users as well. Useful if your site allows for anyone to register without much validation" => "Enable spam filtering for registered users as well. Useful if your site allows for anyone to register without much validation",
// "Allow comments to be corrected by their author" => "Allow comments to be corrected by their author",
// "Allow comments to be modified by their author shortly after posting it, allowing to correct broken links or typos for a period of 30 minutes" => "Allow comments to be modified by their author shortly after posting it, allowing to correct broken links or typos for a period of 30 minutes",
// "Tiki Connect" => "Tiki Connect",
// "Connect your Tiki with the community by sending anonymised statistical data to tiki.org" => "Connect your Tiki with the community by sending anonymised statistical data to tiki.org",
// "Experimental. This feature is still under development" => "Experimental. This feature is still under development",
// "Send Site Information" => "Send Site Information",
// "Additionally send keywords, location etc to tiki.org so you can connect with Tikis near you" => "Additionally send keywords, location etc to tiki.org so you can connect with Tikis near you",
// "Site Title" => "Site Title",
// "Name of site on Tiki Connect" => "Name of site on Tiki Connect",
// "Email Contact" => "Email Contact",
// "Email to register" => "Email to register",
// "URL to register" => "URL to register",
// "Key Words" => "Key Words",
// "Key words or tags describing your site" => "Key words or tags describing your site",
// "Site Location" => "Site Location",
// "Site location as longitude,latitude,zoom" => "Site location as longitude,latitude,zoom",
// "Send Anonymous Information" => "Send Anonymous Information",
// "Send anonymous usage information" => "Send anonymous usage information",
// "Connection frequency" => "Connection frequency",
// "How often to send information (in hours)" => "How often to send information (in hours)",
// "weekly" => "weekly",
// "Experimental. Currently unused, click \"Send Info\" to connect" => "Experimental. Currently unused, click \"Send Info\" to connect",
// "Tiki Connect Server URL" => "Tiki Connect Server URL",
// "Where to send the information" => "Where to send the information",
// "Last connection" => "Last connection",
// "Connect Server Mode" => "Connect Server Mode",
// "For use by mother.tiki.org" => "For use by mother.tiki.org",
// "Connect GUID" => "Connect GUID",
// "For use by mother.tiki.org. Do not modify" => "For use by mother.tiki.org. Do not modify",
// "Allow anonymous visitors to use the \"Contact Us\" feature" => "Allow anonymous visitors to use the \"Contact Us\" feature",
"Contact user" => "Usuari de contacte",
// "Cookie name" => "Cookie name",
// "Domain" => "Domain",
"Count admin pageviews" => "Compta visualitzacions de pàgines per l'admin",
// "Include pageviews by the Admin when reporting stats" => "Include pageviews by the Admin when reporting stats",
// "Enable daily reports for new users" => "Enable daily reports for new users",
// "Default charset for sending mail" => "Default charset for sending mail",
"utf-8" => "utf-8",
"iso-8859-1" => "iso-8859-1",
"default mapfile" => "arxiudemapa per defecte",
// "Default diff style" => "Default diff style",
"Only with last version" => "Només amb la darrera versió",
"HTML diff" => "Diferències en HTML",
"Side-by-side diff" => "Diferències costat-a-costat",
"Side-by-side diff by characters" => "Diferències costat a costat per caràcters",
"Inline diff" => "Diferències en línia",
"Inline diff by characters" => "Diff en línia per caràcters",
"Full side-by-side diff" => "Diferències en tot costat-a-costat",
"Full side-by-side diff by characters" => "Diff costat-a-costat sencer per caràcters",
"Full inline diff" => "Diff en línia sencer",
"Full inline diff by characters" => "Diff en línia sencer per caràcters",
"Unified diff" => "Diferències unificades",
"Side-by-side view" => "Vista costat-a-costat",
"rows" => "línies",
// "Default number of rows for comment box" => "Default number of rows for comment box",
"Forum" => "Fòrum",
// "Forum reply" => "Forum reply",
// "Default Editor" => "Default Editor",
"Simple" => "Simple",
"Advanced" => "Avançat",
// "Disable browser's autocomplete feature for username and password fields" => "Disable browser's autocomplete feature for username and password fields",
"Use direct pagination links" => "Empra enllaços directes de paginació",
// "Max. number of links around the current item" => "Max. number of links around the current item",
// "Max. number of links after the first or before the last item" => "Max. number of links after the first or before the last item",
"Show Country Flag" => "Mostra la bandera del país",
// "Show the country flag" => "Show the country flag",
// "Enable cool sites" => "Enable cool sites",
"Validate URLs" => "Validació de URLs",
// "Number of columns per page when listing directory categories" => "Number of columns per page when listing directory categories",
"Links per page" => "Enllaços per pàgina",
// "Method to Open Directory Links" => "Method to Open Directory Links",
"Method to open directory links" => "Mètode per obrir el directori d'enllaços",
"replace current window" => "susbtitueix la finestra actual",
"new window" => "nova finestra",
"inline frame" => "marc en línia",
"Fields display order" => "Ordenació per mostrar els camps",
// "Re-validate user by email after" => "Re-validate user by email after",
"days" => "dies",
"Use \"-1\" for never" => "Empra \"-1\" per a mai",
// "Email footer" => "Email footer",
// "Text appended to outgoing emails" => "Text appended to outgoing emails",
"PHP errors visible to admin only" => "Errors PHP visibles només a admins",
// "For development purposes, it's better to display errors for all users. However, in production settings, they should only be displayed to administrators" => "For development purposes, it's better to display errors for all users. However, in production settings, they should only be displayed to administrators",
"PHP Error reporting level" => "Nivell d'informes d'errors PHP",
"Level from which errors should be reported" => "Nivell al qual s'hauria d'informar dels errors",
"No error reporting" => "Sense informes d'errors",
"Report all PHP errors except strict" => "Informa de tots els errors PHP menys els de regles estrictes",
"Report all PHP errors" => "Informar de tots els errors de PHP",
"Report all PHP errors except notices" => "Informa de tots els errors PHP menys els d'avisos",
"According to PHP configuration" => "Segons la configuració del PHP",
"Default number of comments per page" => "Nombre per defecte de comentaris per pàgina",
"Comments default ordering" => "Ordre per defecte dels comentaris",
"Question and Answer prefix on Answers" => "Prefix de pregunta i resposta a les respostes",
"Q and A" => "P i R",
"Question ID" => "Identificador de pregunta",
"Blog" => "Bloc",
"Force and limit categorization to within subtree of" => "Força i limita la categorització a dins del subarbre de",
// "If you get an error message indicating a mandatory category is required when editing a blog post, this is the option to blame. Set it to None" => "If you get an error message indicating a mandatory category is required when editing a blog post, this is the option to blame. Set it to None",
// "Areas" => "Areas",
// "Binding categories and perspectives to each other" => "Binding categories and perspectives to each other",
// "Collaboratively authored documents with history of changes" => "Collaboratively authored documents with history of changes",
// "Online diaries or journals" => "Online diaries or journals",
// "Collections of graphic images for viewing or downloading (photo album)" => "Collections of graphic images for viewing or downloading (photo album)",
// "You can use file galleries instead" => "You can use file galleries instead",
// "Machine Translation (by Google Translate)" => "Machine Translation (by Google Translate)",
// "Uses Google Translate to translate the content of wiki pages to other languages" => "Uses Google Translate to translate the content of wiki pages to other languages",
"Experimental" => "Experimentals",
// "Database & form generator" => "Database & form generator",
"Reports" => "Informes",
"Reports Generator" => "Generador d'informes",
// "Online discussions on a variety of topics. Threaded or flat" => "Online discussions on a variety of topics. Threaded or flat",
// "Computer files, videos or software for downloading. With check-in & check-out (lock)" => "Computer files, videos or software for downloading. With check-in & check-out (lock)",
// "Save files as drafts" => "Save files as drafts",
// "File Galleries configuration templates" => "File Galleries configuration templates",
"template" => "plantilla",
// "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"" => "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"",
"Polls" => "Consultes",
// "Brief list of votable options; appears in module (left or right column)" => "Brief list of votable options; appears in module (left or right column)",
"Newsletters" => "Butlletins",
// "Content mailed to registered users" => "Content mailed to registered users",
"Calendar" => "Calendari",
// "Events calendar with public, private and group channels" => "Events calendar with public, private and group channels",
"Banners" => "Pancartes",
// "Insert, track, and manage advertising banners" => "Insert, track, and manage advertising banners",
// "Global category system. Items of different types (wiki pages, articles, tracker items, etc) can be added to one or many categories. Categories can have permissions" => "Global category system. Items of different types (wiki pages, articles, tracker items, etc) can be added to one or many categories. Categories can have permissions",
"Score" => "Puntuació",
// "Score is a game to motivate participants to increase their contribution by comparing to other users" => "Score is a game to motivate participants to increase their contribution by comparing to other users",
// "Unified Search" => "Unified Search",
// "Enables searching for content on the website, using Tiki-managed index" => "Enables searching for content on the website, using Tiki-managed index",
// "Allows to set tags on pages and various objects within the website and generate tag cloud navigation patterns" => "Allows to set tags on pages and various objects within the website and generate tag cloud navigation patterns",
"Action Log" => "Registre d'accions",
// "Allows to keep track of what users are doing and produce reports on a per-user or per-category basis" => "Allows to keep track of what users are doing and produce reports on a per-user or per-category basis",
"Contribution" => "Contribucions (tipus)",
// "Allows users to specify the type of contribution they are making while editing objects. The contributions are then displayed as color-coded in history and other reports" => "Allows users to specify the type of contribution they are making while editing objects. The contributions are then displayed as color-coded in history and other reports",
"Multilingual" => "Multilingualitat",
// "Enables internationalization features and multilingual support for then entire site" => "Enables internationalization features and multilingual support for then entire site",
"FAQ" => "PUF",
// "Frequently asked questions and answers" => "Frequently asked questions and answers",
// "You can use wiki pages instead" => "You can use wiki pages instead",
"Surveys" => "Enquestes",
// "Questionnaire with multiple choice or open ended question" => "Questionnaire with multiple choice or open ended question",
// "User-submitted Web links" => "User-submitted Web links",
// "Timed questionnaire with recorded scores" => "Timed questionnaire with recorded scores",
// "Featured Links" => "Featured Links",
// "Simple menu system which can optionally add an external web page in an iframe" => "Simple menu system which can optionally add an external web page in an iframe",
"Copyright" => "Copyright",
// "The Copyright Management System (or ©MS) is a way of licensing your content" => "The Copyright Management System (or ©MS) is a way of licensing your content",
"Shoutbox" => "Quadre d'avisos",
// "Quick comment (graffiti) box. Like a group chat, but not in real time" => "Quick comment (graffiti) box. Like a group chat, but not in real time",
// "MapServer" => "MapServer",
// "Navigable, interactive maps with user-selectable layers" => "Navigable, interactive maps with user-selectable layers",
// "Requires MapServer" => "Requires MapServer",
"Google Maps" => "Mapes de Google",
// "Interactive use of Google Maps" => "Interactive use of Google Maps",
"Live support system" => "Sistema de suport en directe",
// "One-on-one chatting with customer" => "One-on-one chatting with customer",
"Tell a Friend" => "Digues-li a les teves amistats",
// "Add a link \"Email this page\" in all the pages" => "Add a link \"Email this page\" in all the pages",
// "Share" => "Share",
// "Add a \"Share\" link in all pages to send it via e-mail, Twitter, Facebook, message or forums" => "Add a \"Share\" link in all pages to send it via e-mail, Twitter, Facebook, message or forums",
// "be careful when allowing to anonymous to activate the antibot feature" => "be careful when allowing to anonymous to activate the antibot feature",
// "HTML pages" => "HTML pages",
// "Static and dynamic HTML content" => "Static and dynamic HTML content",
// "HTML can be used in wiki pages. This is a separate feature" => "HTML can be used in wiki pages. This is a separate feature",
"Contact Us" => "Contacta'ns",
// "Basic form from visitor to admin" => "Basic form from visitor to admin",
// "Minichat" => "Minichat",
// "Real-time group text chatting" => "Real-time group text chatting",
// "Comments Moderation" => "Comments Moderation",
// "An admin must validate a comment before it is visible" => "An admin must validate a comment before it is visible",
// "Comments Locking" => "Comments Locking",
// "Comments can be closed (no new comments)" => "Comments can be closed (no new comments)",
// "Allow logged in users to pretend to be anonymous when posting a commment" => "Allow logged in users to pretend to be anonymous when posting a commment",
// "This can be used to encourage honest feedback with the opportunity to voice an opinion anonymously. Like in a forum where you ask feedback on what is done wrong or should be improved internally" => "This can be used to encourage honest feedback with the opportunity to voice an opinion anonymously. Like in a forum where you ask feedback on what is done wrong or should be improved internally",
// "Display page description" => "Display page description",
// "Display the page description below the heading when viewing the page" => "Display the page description below the heading when viewing the page",
// "Display page name as page title" => "Display page name as page title",
// "Display the page name at the top of each page as page title. If not enabled, the page content should be structured to contain a header" => "Display the page name at the top of each page as page title. If not enabled, the page content should be structured to contain a header",
// "Display page ID" => "Display page ID",
// "Display the internal page ID when viewing the page" => "Display the internal page ID when viewing the page",
// "Individual wiki cache" => "Individual wiki cache",
// "Allow users to change the duration of the cache on a per-page basis" => "Allow users to change the duration of the cache on a per-page basis",
// "JS Calendar" => "JS Calendar",
// "JavaScript popup date selector. Will use jQuery UI DatePicker if enabled" => "JavaScript popup date selector. Will use jQuery UI DatePicker if enabled",
// "Output should be HTML Purified" => "Output should be HTML Purified",
// "This enables HTML Purifier on outputs to filter potential remaining security problems like XSS" => "This enables HTML Purifier on outputs to filter potential remaining security problems like XSS",
// "Full Screen" => "Full Screen",
"Allow users to activate fullscreen mode" => "Permet als usuaris activar el mode de pantalla completa",
// "CSS Menus" => "CSS Menus",
// "CSS Menus (suckerfish)" => "CSS Menus (suckerfish)",
// "Shadowbox / ColorBox" => "Shadowbox / ColorBox",
// "\"Displaying content with Eye Candy\". <br />Uses jQuery plugin \"ColorBox\". e.g. <code>{img fileId=\"42\" thumb=\"y\" alt=\"\" rel=\"box[g]\"}</code>" => "\"Displaying content with Eye Candy\". <br />Uses jQuery plugin \"ColorBox\". e.g. <code>{img fileId=\"42\" thumb=\"y\" alt=\"\" rel=\"box[g]\"}</code>",
// "Quick Permission Assignment" => "Quick Permission Assignment",
// "Quickperms allow to define classes of privileges and grant them to roles on objects" => "Quickperms allow to define classes of privileges and grant them to roles on objects",
"HTML Purifier" => "Purificador d'HTML",
// "If you are trying to use HTML in your pages and it gets stripped out, you should make sure your HTML is valid or de-activate this feature" => "If you are trying to use HTML in your pages and it gets stripped out, you should make sure your HTML is valid or de-activate this feature",
"Ajax" => "Ajax",
"Morcego 3D browser" => "Navegador 3D Morcego",
// "Visualize relationships between wiki pages, in a 3D applet" => "Visualize relationships between wiki pages, in a 3D applet",
"Webmail" => "CorreuWeb",
"Intertiki" => "Intertiki",
// "Allows several Tiki sites (slaves) to get authentication from a master Tiki site" => "Allows several Tiki sites (slaves) to get authentication from a master Tiki site",
"Mail-in" => "Correu-in",
// "Populate wiki pages and articles by email" => "Populate wiki pages and articles by email",
// "Mindmap" => "Mindmap",
// "Print Indexed" => "Print Indexed",
"Spreadsheet" => "Full de càlcul",
// "Datasheets with calculations and charts" => "Datasheets with calculations and charts",
// "Slideshow (jQuery.s5)" => "Slideshow (jQuery.s5)",
// "Web based slideshow" => "Web based slideshow",
// "Slideshow (jQuery.s5) PDF Export" => "Slideshow (jQuery.s5) PDF Export",
// "Web based slideshow to pdf export" => "Web based slideshow to pdf export",
"Invoice" => "Factura",
// "Invoice system" => "Invoice system",
"Wysiwyg editor" => "Editor Wysiwyg",
// "WYSIWYG is an acronym for What You See Is What You Get. Uses CKEditor" => "WYSIWYG is an acronym for What You See Is What You Get. Uses CKEditor",
// "Kaltura Video Management" => "Kaltura Video Management",
// "Integration to the Kaltura video management platform" => "Integration to the Kaltura video management platform",
"Friendship Network" => "Xarxa d'amistats",
// "Users can identify other users as their friends" => "Users can identify other users as their friends",
// "Neglected feature" => "Neglected feature",
"Banning system" => "Sistema de prohibició",
// "Deny access to specific users based on username, IP, and date/time range" => "Deny access to specific users based on username, IP, and date/time range",
"Stats" => "Estadístiques",
// "Record basic statistics about major Tiki features (number of wiki pages, size of file galleries, etc.)" => "Record basic statistics about major Tiki features (number of wiki pages, size of file galleries, etc.)",
"Action Calendar" => "Calendari d'Accions",
"Referer Stats" => "Estadístiques de referenciadors",
// "Record domain name of sites that send visitors to this Tiki" => "Record domain name of sites that send visitors to this Tiki",
"Redirect On Error" => "Redirigeix en trobar Errors",
// "On error, goto the HomePage as configured in Admin->General" => "On error, goto the HomePage as configured in Admin->General",
"Communications (send/receive objects)" => "Comunicacions (enviar/rebre objectes)",
// "Send/receive wiki pages and articles between Tiki-powered sites" => "Send/receive wiki pages and articles between Tiki-powered sites",
"Custom Home" => "Personalitzar Inici",
"Mini Calendar" => "Mini Calendari",
"User Preferences Screen" => "Pantalla de preferències d'usuari/a",
"User Notepad" => "Bloc de notes de l'usuari",
// "My Bookmarks" => "My Bookmarks",
"User Contacts" => "Contactes d'usuari",
"User Watches" => "Avisos d'usuari/a",
// "Receive email notification of changes" => "Receive email notification of changes",
// "Group Watches" => "Group Watches",
"Daily Reports for User Watches" => "Resums Diaris per als seguiments de l'usuari/a",
"User Watches Translations" => "L'usuari vigila les traduccions",
// "User Watches Languages" => "User Watches Languages",
// "Watch language-specific changes within a category" => "Watch language-specific changes within a category",
"User Menu" => "Menú d'Usuari ",
"User Tasks" => "Tasques d'usuari",
"User Messages" => "Missatges d'usuari",
"User Files" => "Arxius d'Usuari",
// "Menu User Levels" => "Menu User Levels",
// "Allows to control the menu options that can be seen by a user" => "Allows to control the menu options that can be seen by a user",
// "Group Alert" => "Group Alert",
"Integrator" => "Integrador",
"XMLRPC API" => "XMLRPC API",
"Debugger Console" => "Consol·la Depuradora",
// "TikiTests" => "TikiTests",
// "Permits recording and playback of functional tests" => "Permits recording and playback of functional tests",
// "Check for updates automatically" => "Check for updates automatically",
// "Tiki will check for updates when you access the main Administration page" => "Tiki will check for updates when you access the main Administration page",
// "Require confirmation if possible CSRF detected" => "Require confirmation if possible CSRF detected",
"Protect against CSRF with a ticket" => "Protegir contra CSRF amb un tiquet",
"Detect browser language" => "Detecta l'idioma del navegador",
// "Lookup the user's preferred language through browser preferences" => "Lookup the user's preferred language through browser preferences",
"Show pages in user's preferred language" => "Mostra la pàgines en l'idioma preferit de l'usuari",
// "When accessing a page which has an equivalent in the user's preferred language, favor the translated page" => "When accessing a page which has an equivalent in the user's preferred language, favor the translated page",
// "Changing the page language also changes the site language" => "Changing the page language also changes the site language",
// "Translation assistant" => "Translation assistant",
// "Track translation operations between pages" => "Track translation operations between pages",
// "Urgent translation notifications" => "Urgent translation notifications",
// "Allow to flag changes as urgent, leading translations to be marked with a notice visible to all users" => "Allow to flag changes as urgent, leading translations to be marked with a notice visible to all users",
// "Incomplete translation notice" => "Incomplete translation notice",
// "When a page is translated to a new language, a notice will be automatically inserted into the page to indicate that the translation is not yet complete" => "When a page is translated to a new language, a notice will be automatically inserted into the page to indicate that the translation is not yet complete",
"Multilingual structures" => "Estructures Multilíngües",
// "Structures to lookup equivalent pages in other languages. May cause performance problems on larger structures" => "Structures to lookup equivalent pages in other languages. May cause performance problems on larger structures",
// "Display all languages in a single page" => "Display all languages in a single page",
// "List all languages as a language option in the page language drop list to see all languages at once" => "List all languages as a language option in the page language drop list to see all languages at once",
// "GZip output" => "GZip output",
// "Compress your pages on-the-fly, if the requesting browser supports this" => "Compress your pages on-the-fly, if the requesting browser supports this",
"Help System" => "Ajuda del Sistema",
// "Yahoo! Babel Fish Translation URLs" => "Yahoo! Babel Fish Translation URLs",
// "Show clickable URLs to translate the page to another language using Babel Fish website" => "Show clickable URLs to translate the page to another language using Babel Fish website",
// "You need to assign somewhere on the page via a module" => "You need to assign somewhere on the page via a module",
// "Yahoo! Babel Fish Translation icons" => "Yahoo! Babel Fish Translation icons",
// "Show clickable icons to translate the page to another language using Babel Fish website" => "Show clickable icons to translate the page to another language using Babel Fish website",
"Smileys" => "Emoticons",
// "Also known as emoticons" => "Also known as emoticons",
// "Draw (SVG-edit)" => "Draw (SVG-edit)",
// "Draw gives you the ability to edit SVG images all around Tiki" => "Draw gives you the ability to edit SVG images all around Tiki",
// "Draw (SVG-edit) Hide Buttons" => "Draw (SVG-edit) Hide Buttons",
// "Hide buttons found in Tiki Draw, HTML id, comma-delimited.  Example: \"tool_select,tool_fhpath,tools_line_show,tools_rect_show,tools_ellipse_show,tool_path,tools_shapelib_show,tool_text,tool_image,tool_zoom,tool_eyedropper\"" => "Hide buttons found in Tiki Draw, HTML id, comma-delimited.  Example: \"tool_select,tool_fhpath,tools_line_show,tools_rect_show,tools_ellipse_show,tool_path,tools_shapelib_show,tool_text,tool_image,tool_zoom,tool_eyedropper\"",
// "Docs (WebODF)" => "Docs (WebODF)",
// "Docs gives you the ability to view/edit Open Document Format" => "Docs gives you the ability to view/edit Open Document Format",
"Dynamic Content System" => "sistema contingut Dinàmic",
// "Bloc of content which can be reused and programmed (timed)" => "Bloc of content which can be reused and programmed (timed)",
// "Use File Galleries to store pictures" => "Use File Galleries to store pictures",
// "If disabled, pictures will be stored in ../img/wiki_up/.. instead" => "If disabled, pictures will be stored in ../img/wiki_up/.. instead",
// "External link icon" => "External link icon",
// "External links will be identifed with an icon. Use the ../img/icons/external_link.gif image to customize the icon" => "External links will be identifed with an icon. Use the ../img/icons/external_link.gif image to customize the icon",
// "Add \"rel=nofollow\" on external links" => "Add \"rel=nofollow\" on external links",
// "Semantic links" => "Semantic links",
// "Going beyond Backlinks, allows to define some semantic relationships between wiki pages" => "Going beyond Backlinks, allows to define some semantic relationships between wiki pages",
// "Web Services" => "Web Services",
// "Can consume webservices in JSON or YAML" => "Can consume webservices in JSON or YAML",
"Display menus as folders" => "Mostra menús com a carpetes",
// "Breadcrumbs" => "Breadcrumbs",
// "Attempts to show you where you are" => "Attempts to show you where you are",
// "Anonymous editors must enter anti-bot code (CAPTCHA)" => "Anonymous editors must enter anti-bot code (CAPTCHA)",
"Protect email against spam" => "Protegeix el correu-e contra el correu brossa",
// "Protect email against spam currently does not operate in pages edited in WYSIWYG mode (Tiki 6.1)" => "Protect email against spam currently does not operate in pages edited in WYSIWYG mode (Tiki 6.1)",
"Activate" => "Activa",
// "Anonymous voting" => "Anonymous voting",
// "Allow re-voting" => "Allow re-voting",
// "Comments for polls" => "Comments for polls",
// "Comments for FAQs" => "Comments for FAQs",
// "Search engine friendly URL" => "Search engine friendly URL",
// "If you are using Apache, you can copy _htaccess to .htaccess to get Short URLs. On IIS, copy web_config to web.config" => "If you are using Apache, you can copy _htaccess to .htaccess to get Short URLs. On IIS, copy web_config to web.config",
// "Search engine friendly url Postfilter" => "Search engine friendly url Postfilter",
// "Display article title in the sefurl" => "Display article title in the sefurl",
// "Display blog title in the SEFURL" => "Display blog title in the SEFURL",
// "Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page" => "Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page",
// "This redirection uses the wiki prefix alias feature" => "This redirection uses the wiki prefix alias feature",
// "Canonical URL tag" => "Canonical URL tag",
// "Indicates to search engines which URL to use which prevents duplicate listings" => "Indicates to search engines which URL to use which prevents duplicate listings",
// "Show module controls" => "Show module controls",
// "Perspectives" => "Perspectives",
// "Permits to override preferences" => "Permits to override preferences",
"Search and replace" => "Cerca i reemplaça",
// "Permits find and replace of content in the edit box" => "Permits find and replace of content in the edit box",
"Submissions" => "Col·laboracions",
// "Submissions are sent in but need to be approved before they go live" => "Submissions are sent in but need to be approved before they go live",
"Rankings" => "Posicions",
// "Comments for articles" => "Comments for articles",
// "Article content templates" => "Article content templates",
// "template article news" => "template article news",
// "Predefined content for a news article" => "Predefined content for a news article",
"Print" => "Multi-Impressió",
// "Specify notification emails when creating articles" => "Specify notification emails when creating articles",
// "ShareThis buttons" => "ShareThis buttons",
// "Insert a ShareThis button from www.sharethis.com" => "Insert a ShareThis button from www.sharethis.com",
"Category Path" => "Ruta a la categoria",
// "Show category tree, above wiki pages" => "Show category tree, above wiki pages",
// "Show category objects" => "Show category objects",
// "Show objects sharing the same category, below wiki pages" => "Show objects sharing the same category, below wiki pages",
"Ignore category viewing restrictions" => "Ignora les restriccions de visualització de categories",
// "Will improve performance, but may show forbidden results" => "Will improve performance, but may show forbidden results",
"List pages" => "Llistar pàgines",
"Latest Changes" => "Darrers canvis",
"Orphan pages" => "Pàgines òrfenes",
// "MySQL Full-Text Search" => "MySQL Full-Text Search",
// "This search uses the MySQL Full-Text Search feature. The indexation is continuously updated" => "This search uses the MySQL Full-Text Search feature. The indexation is continuously updated",
"Referer Search Highlighting" => "Ressaltat dels referenciadors de les cerques",
"Search stats" => "Estadístiques de les cerques",
"Ignore individual object permissions" => "Ignora els permisos individuals dels objectes",
// "Object filter" => "Object filter",
"Search box" => "Cerca",
// "Pertinence" => "Pertinence",
"Object type" => "Tipus d'objecte",
// "Last modified date" => "Last modified date",
// "Custom blog headings" => "Custom blog headings",
// "Using custom blog headings will use significantly more server resources. Unless you need per-blog templates, you should use a customize the template file" => "Using custom blog headings will use significantly more server resources. Unless you need per-blog templates, you should use a customize the template file",
// "Publish dates can be modified" => "Publish dates can be modified",
// "Comments on blog posts" => "Comments on blog posts",
// "Insert a ShareThis button from [http://www.sharethis.com]" => "Insert a ShareThis button from [http://www.sharethis.com]",
// "File Gallery Comments" => "File Gallery Comments",
// "Use file galleries for user files" => "Use file galleries for user files",
// "experimental" => "experimental",
// "Use file galleries for wiki attachments" => "Use file galleries for wiki attachments",
// "Batch uploading" => "Batch uploading",
// "Direct import of local files into a File Gallery. Can handle large files. User can upload file via FTP to target folder" => "Direct import of local files into a File Gallery. Can handle large files. User can upload file via FTP to target folder",
// "Use batch uploading to integrate large files into File Galleries" => "Use batch uploading to integrate large files into File Galleries",
"Accept wiki syntax" => "Aceptar sintaxi-wiki",
// "Topic archiving" => "Topic archiving",
// "Quick jumps" => "Quick jumps",
// "Replies are empty" => "Replies are empty",
// "If disabled, replies will quote the original post" => "If disabled, replies will quote the original post",
// "First post of a thread can have an empty body" => "First post of a thread can have an empty body",
// "Will be a thread title" => "Will be a thread title",
// "Forum name search" => "Forum name search",
// "When listing forums" => "When listing forums",
// "Forum content search" => "Forum content search",
// "Topic content search" => "Topic content search",
// "Tiki-indexed search" => "Tiki-indexed search",
// "Use database (full-text) search" => "Use database (full-text) search",
// "Store password as plain text" => "Store password as plain text",
// "Encryption method" => "Encryption method",
"tikihash (old)" => "tikihash (vell)",
"Edit CSS" => "Edita CSS",
"Theme Control" => "Control de Temes",
// "Assign different themes to different sections, categories, and objects" => "Assign different themes to different sections, categories, and objects",
// "design themes" => "design themes",
"Tiki Template Viewing" => "Visualització de plantilles del Tiki",
"Edit Templates" => "edita plantilles",
// "Custom HTML <head> Content" => "Custom HTML <head> Content",
"Example" => "Exemple",
// "Use to include custom &lt;meta&gt; or &lt;link&gt; tags" => "Use to include custom &lt;meta&gt; or &lt;link&gt; tags",
// "Add BASE tag in the page HEAD" => "Add BASE tag in the page HEAD",
// "The &lt;base&gt; tag specifies a default address for all links on a page" => "The &lt;base&gt; tag specifies a default address for all links on a page",
// "Site Logo and Title" => "Site Logo and Title",
// "Expected to be migrated to modules entirely and made obsolete" => "Expected to be migrated to modules entirely and made obsolete",
"Left column" => "Columna esquerra",
// "Controls visibility of the left column of modules" => "Controls visibility of the left column of modules",
// "side bar" => "side bar",
// "Only if module" => "Only if module",
"Always" => "Sempre",
// "User Decides" => "User Decides",
// "Right Column" => "Right Column",
// "Controls visibility of the right column of modules" => "Controls visibility of the right column of modules",
// "Prefix breadcrumbs with \"Location : \"" => "Prefix breadcrumbs with \"Location : \"",
"Site location bar" => "Barra de localització del lloc",
// "Use breadcrumbs module" => "Use breadcrumbs module",
// "Top of center column (legacy mode)" => "Top of center column (legacy mode)",
"Larger font for" => "Font més gran per a",
// "Entire location" => "Entire location",
"Page name" => "Nom de la pàgina",
"Use page description" => "Empra descripció de la pàgina",
// "Top of page" => "Top of page",
// "Top of center column" => "Top of center column",
// "Custom End of <body> Code" => "Custom End of <body> Code",
"Webmaster Report" => "Informa al Mestre de la Web",
"Webmaster Email" => "Correu-e del Mestre de la Web",
// "Leave blank to use the default sender email" => "Leave blank to use the default sender email",
"Email this page" => "Envia aquesta pàgina per Correu-e",
// "Add a link at the bottom if set, otherwise add a link at the top" => "Add a link at the bottom if set, otherwise add a link at the top",
// "Shadow layer" => "Shadow layer",
// "Additional layers for shadows, rounded corners or other decorative styling" => "Additional layers for shadows, rounded corners or other decorative styling",
// "Tooltips" => "Tooltips",
// "Make tooltips such as this appear in a custom style. Use CSS to change their appearance" => "Make tooltips such as this appear in a custom style. Use CSS to change their appearance",
// "Provides various drop-down menus on many text input boxes for page names, user names, groups, tags etc" => "Provides various drop-down menus on many text input boxes for page names, user names, groups, tags etc",
// "Superfish" => "Superfish",
// "Adds animation effects to CSS \"Suckerfish\" menus" => "Adds animation effects to CSS \"Suckerfish\" menus",
// "Reflection" => "Reflection",
// "Allows images to have a reflection effect below them. See the admin icons above for an example" => "Allows images to have a reflection effect below them. See the admin icons above for an example",
// "JQuery UI" => "JQuery UI",
// "Include jQuery UI library. Enables many user interface features" => "Include jQuery UI library. Enables many user interface features",
// "jQuery UI Theme" => "jQuery UI Theme",
// "jQuery UI Theme. Used in spreadsheet, for example" => "jQuery UI Theme. Used in spreadsheet, for example",
// "Validation" => "Validation",
// "Provides various validation possibilities like in Trackers" => "Provides various validation possibilities like in Trackers",
// "jQuery Infinite Carousel" => "jQuery Infinite Carousel",
// "Image \"carousel\" plugin (coming soon)" => "Image \"carousel\" plugin (coming soon)",
// "jQuery Sortable Tables" => "jQuery Sortable Tables",
// "Sort in fancytable plugin" => "Sort in fancytable plugin",
// "This feature can cause problems with JS minify on some systems" => "This feature can cause problems with JS minify on some systems",
// "jQuery Media" => "jQuery Media",
// "Media player" => "Media player",
"Use Tabs" => "Empra tabuladors",
// "Makes pages shorter by splitting the content in different tabs" => "Makes pages shorter by splitting the content in different tabs",
// "Correct PNG images alpha transparency in IE6 (experimental)" => "Correct PNG images alpha transparency in IE6 (experimental)",
// "Wiki content templates" => "Wiki content templates",
// "Predefined content for a wiki page" => "Predefined content for a wiki page",
"Warn on edit conflict" => "Conflicte d'avís en editar",
// "Tiki will warn users who attempt to edit a page that another user is currenly editing" => "Tiki will warn users who attempt to edit a page that another user is currenly editing",
"Undo" => "Desfès",
"Footnotes" => "Notes al peu",
// "Create private notes for a page that are visible only by the author" => "Create private notes for a page that are visible only by the author",
"Allow HTML" => "Permetre HTML",
// "Log bytes changes (+/-) in action logs" => "Log bytes changes (+/-) in action logs",
// "May impact performance" => "May impact performance",
"Sandbox" => "LlocdeProves",
// "A special wiki page for testing. Users can edit, but not save the Sandbox" => "A special wiki page for testing. Users can edit, but not save the Sandbox",
// "Comments below wiki pages" => "Comments below wiki pages",
// "Allow users (with permission) to post threaded comments to a page" => "Allow users (with permission) to post threaded comments to a page",
"Pictures" => "Fotos",
// "Allow users to upload images (pictures) to a page" => "Allow users to upload images (pictures) to a page",
"Export" => "Exporta",
// "WikiWords" => "WikiWords",
// "Automatically convert words with UpPeR and LoWeR-case letters into wiki links" => "Automatically convert words with UpPeR and LoWeR-case letters into wiki links",
"Link plural WikiWords to their singular forms" => "Enllaç plural a les WikiParaules als seus formularis-bd particulars",
"Accept dashes and underscores in WikiWords" => "Accepta guions normals (-) i guions baixos (_) en ParaulesWiki",
"History" => "Historial",
// "Display IP address" => "Display IP address",
// "Record all versions, rather than only when page content or description changes or when an edit comment is given" => "Record all versions, rather than only when page content or description changes or when an edit comment is given",
// "View page contributions by author" => "View page contributions by author",
// "Visualize the contributions of different authors made to a wiki page" => "Visualize the contributions of different authors made to a wiki page",
"Discuss pages on forums" => "Pàgines de Debat als fòrums",
// "Include a link on each page to a forum topic" => "Include a link on each page to a forum topic",
// "View source" => "View source",
// "Similar (like pages)" => "Similar (like pages)",
"Structures" => "Estructures",
// "Structures Drill Down Menu" => "Structures Drill Down Menu",
// "Ajax style drill down menu for structures" => "Ajax style drill down menu for structures",
"Open page as structure" => "Obre la pàgina com una estructura",
"Make structure from page" => "Fes estructura a partir de la pàgina",
"Categorize structure pages together" => "Categoritza les pàgines de l'estructura totes juntes",
// "Disable inheritance of direct object permissions when adding pages from a structure" => "Disable inheritance of direct object permissions when adding pages from a structure",
"Create webhelp from structure" => "Crea ajuda web a partir de l'estructura",
"Import HTML" => "Importar HTML",
// "Use date parameter" => "Use date parameter",
"Report it in wiki links" => "Informa'n en enllaços wiki",
// "Import pages" => "Import pages",
// "A personal page for the user to manage" => "A personal page for the user to manage",
"UserPage prefix" => "Prefix per a la PlanaUsuari",
// "All user pages share a common prefix. The concatenation of the prefix and the username will generate the page name. The prefix cannot be empty" => "All user pages share a common prefix. The concatenation of the prefix and the username will generate the page name. The prefix cannot be empty",
// "Users can lock pages" => "Users can lock pages",
"MultiPrint" => "MultiImpressió",
// "Pages not in structure" => "Pages not in structure",
"Attachments" => "Afegits",
// "Allow users to upload (attach) files to a page" => "Allow users to upload (attach) files to a page",
"Dumps" => "Buidats",
// "If you get an error message indicating a mandatory category is required when editing a wiki page, this is the option to blame. Set it to None" => "If you get an error message indicating a mandatory category is required when editing a wiki page, this is the option to blame. Set it to None",
// "If you get an error message indicating a mandatory category is required when editing an image (in an image gallery), this is the option to blame. Set it to None" => "If you get an error message indicating a mandatory category is required when editing an image (in an image gallery), this is the option to blame. Set it to None",
// "Display show/hide icon displayed before headings" => "Display show/hide icon displayed before headings",
// "Metrics Dashboard" => "Metrics Dashboard",
// "Generate automated statistics from configured database queries" => "Generate automated statistics from configured database queries",
// "Wiki argument variables" => "Wiki argument variables",
// "Allow to write request variables inside wiki content using {{paramname}} or {{paramname|default}} - special case {{page}} {{user}}" => "Allow to write request variables inside wiki content using {{paramname}} or {{paramname|default}} - special case {{page}} {{user}}",
"Use challenge/response authentication" => "Empra autenticació de repte/resposta",
// "Confirm that the Admin account has a valid email address or you will not be permitted to login" => "Confirm that the Admin account has a valid email address or you will not be permitted to login",
// "Users can choose to stay in SSL mode after an HTTPS login" => "Users can choose to stay in SSL mode after an HTTPS login",
// "Users can switch between secured or standard mode at login" => "Users can switch between secured or standard mode at login",
// "Wiki paragraph formatting" => "Wiki paragraph formatting",
"Because the Wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines." => "Com la funcionalitat de formatació de paràgrafs Wiki està activada, tots els grups de línies que no estiguin en blanc són agrupades en paràgrafs.  Les línies poden ser de qualseovl longitud, i seran formatades juntes amb la següent línia.  Els paràgrafs es separen amb línies en blanc.",
"Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line." => "Com la funcionalitat de formatació de paràgrafs Wiki està desactivada, cada línia es mostrarà tal i com l'escriguis. Això vol dir que si vols que els paràgrafs es formatin correctament, un paràgraf ha d'estar tot ell en una sola línia.",
// "...but still create line breaks within paragraphs" => "...but still create line breaks within paragraphs",
"Automonospaced text" => "Text Automonoespaiat",
"Tables syntax" => "Sintaxi de taules",
"|| for rows" => "|| per files",
"<return> for rows" => "\n for rows",
"AutoLinks" => "Autoenllaços",
// "Tiki will automatically convert http:// and email addresses into links" => "Tiki will automatically convert http:// and email addresses into links",
"Hotwords" => "Paraules calentes",
// "Open Hotwords in new window" => "Open Hotwords in new window",
// "Characters that limit a hotword" => "Characters that limit a hotword",
// "Use Quote plugin rather than \">\" for quoting" => "Use Quote plugin rather than \">\" for quoting",
// "Use three colons instead of two to center text. Avoids conflict with C++ resolution scope operator" => "Use three colons instead of two to center text. Avoids conflict with C++ resolution scope operator",
// "String to use to delimit simplebox" => "String to use to delimit simplebox",
// "Users can choose to show their gender" => "Users can choose to show their gender",
// "Real name" => "Real name",
"Gender" => "Gènere",
// "Picture (avatar)" => "Picture (avatar)",
"Number of friends" => "Nombre d'amics/gues",
"Country" => "País",
"E-mail" => "Correu electrònic",
"Last login" => "Última connexió",
"Distance" => "Distància",
// "Manual selection of time/date" => "Manual selection of time/date",
// "WebDAV access to Tiki" => "WebDAV access to Tiki",
// "Allow to access File Galleries with WebDAV" => "Allow to access File Galleries with WebDAV",
// "use tiki-webdav.php as the URI of the WebDAV repository" => "use tiki-webdav.php as the URI of the WebDAV repository",
// "Fixed width" => "Fixed width",
// "Constrains the width of the site" => "Constrains the width of the site",
// "Social networks" => "Social networks",
// "Integration with different social networks like Twitter or Facebook" => "Integration with different social networks like Twitter or Facebook",
// "Group Transition" => "Group Transition",
// "Enables transitions for users between different groups. Transitions will create a user approval workflow" => "Enables transitions for users between different groups. Transitions will create a user approval workflow",
// "Category Transition" => "Category Transition",
// "Enables transitions on objects between different categories. Transitions will create a document workflow" => "Enables transitions on objects between different categories. Transitions will create a document workflow",
// "Ustream Watershed live video streaming" => "Ustream Watershed live video streaming",
// "Integration to Ustream Watershed live video streaming" => "Integration to Ustream Watershed live video streaming",
// "Tiki User Credits" => "Tiki User Credits",
// "Invite users" => "Invite users",
// "Allow users to invite new users by mail to register on this tiki" => "Allow users to invite new users by mail to register on this tiki",
// "Alternate Registration Page" => "Alternate Registration Page",
// "Makes any access to tiki-register.php redirect to an alternate page for registration" => "Makes any access to tiki-register.php redirect to an alternate page for registration",
// "Load Balancer" => "Load Balancer",
// "Enable this only if the server is behind a load balancer (or reverse proxy), this allow tiki to log the IP of the user, instead of the IP of the proxy server" => "Enable this only if the server is behind a load balancer (or reverse proxy), this allow tiki to log the IP of the user, instead of the IP of the proxy server",
// "Accounting" => "Accounting",
// "Double-entry accounting system" => "Double-entry accounting system",
// "Syntax Highlighter (CodeMirror)" => "Syntax Highlighter (CodeMirror)",
// "Enables syntax highlighting with the use of CodeMirror" => "Enables syntax highlighting with the use of CodeMirror",
// "Syntax Highlighter (CodeMirror) Theme" => "Syntax Highlighter (CodeMirror) Theme",
// "Code Mirror Themes (clear cache when you change)" => "Code Mirror Themes (clear cache when you change)",
// "Jison Wiki Parser" => "Jison Wiki Parser",
// "Is a new strategy for parsing wiki pages more like a programming language" => "Is a new strategy for parsing wiki pages more like a programming language",
// "Dummy preference" => "Dummy preference",
// "This is useful for developers to learn how to create a new preference" => "This is useful for developers to learn how to create a new preference",
// "This is the detail" => "This is the detail",
// "This is the warning" => "This is the warning",
// "This is the hint" => "This is the hint",
// "This is the shorthint" => "This is the shorthint",
// "Time Sheet" => "Time Sheet",
// "A project time manager" => "A project time manager",
// "Html Feed" => "Html Feed",
// "A way to push and pull html bits around from one site to another" => "A way to push and pull html bits around from one site to another",
// "ForwardLink-Protocol" => "ForwardLink-Protocol",
// "A Dynamic Compendia" => "A Dynamic Compendia",
// "Unified Search requires more server processing ressources, and that you properly set the server permissions. Also, it's recommended to set a cron job to periodically rebuild the search index" => "Unified Search requires more server processing ressources, and that you properly set the server permissions. Also, it's recommended to set a cron job to periodically rebuild the search index",
// "HTML Purifier is a standards-compliant HTML filter library written in PHP and integrated in Tiki. HTML Purifier will not only remove all malicious code (better known as XSS) with a thoroughly audited, secure yet permissive whitelist, it will also make sure your documents are standards compliant, something only achievable with a comprehensive knowledge of W3C's specifications" => "HTML Purifier is a standards-compliant HTML filter library written in PHP and integrated in Tiki. HTML Purifier will not only remove all malicious code (better known as XSS) with a thoroughly audited, secure yet permissive whitelist, it will also make sure your documents are standards compliant, something only achievable with a comprehensive knowledge of W3C's specifications",
"Display 'MyTiki' in the application menu" => "Mostra 'ElMeuTiki' al menú de l'aplicació",
// "Show user's contribution on the user information page" => "Show user's contribution on the user information page",
// "nofollow is used to instruct some search engines that links should not influence search engines. It can reduce search engine spam and prevent 'spamdexing'" => "nofollow is used to instruct some search engines that links should not influence search engines. It can reduce search engine spam and prevent 'spamdexing'",
// "InnoDB doesn't support Full-Text Search until 5.6, so if this is your case, use Unified Search" => "InnoDB doesn't support Full-Text Search until 5.6, so if this is your case, use Unified Search",
// "Require file author's name for anonymous uploads" => "Require file author's name for anonymous uploads",
// "Redirect to similar wiki page" => "Redirect to similar wiki page",
// "If a requested page doesn't exist, redirect to a similarly named page" => "If a requested page doesn't exist, redirect to a similarly named page",
// "Redirect to page alias, if any" => "Redirect to page alias, if any",
// "If a requested page doesn't exist, redirect to an alias page, if specified using an alias semantic link" => "If a requested page doesn't exist, redirect to an alias page, if specified using an alias semantic link",
// "User's page" => "User's page",
// "Show user's information on mouseover" => "Show user's information on mouseover",
// "Requires user's information to be public" => "Requires user's information to be public",
// "Default feed format" => "Default feed format",
// "ATOM 1.0" => "ATOM 1.0",
// "RSS 2.0" => "RSS 2.0",
// "Feed author name" => "Feed author name",
// "This field is mandatory unless both feed author email and homepage are empty" => "This field is mandatory unless both feed author email and homepage are empty",
// "Feeed author email" => "Feeed author email",
// "Feed author homepage" => "Feed author homepage",
// "Feed editor email" => "Feed editor email",
// "Email address for person responsible for editorial content" => "Email address for person responsible for editorial content",
// "Feed webmaster email" => "Feed webmaster email",
// "Email address for person responsible for technical issues relating to channel" => "Email address for person responsible for technical issues relating to channel",
// "Feed Image path" => "Feed Image path",
// "Specifies a GIF, JPEG or PNG image that can be displayed with the feed" => "Specifies a GIF, JPEG or PNG image that can be displayed with the feed",
// "Feed Language" => "Feed Language",
// "RSS basic Authentication" => "RSS basic Authentication",
// "Propose basic http authentication if the user has no permission to see the feed" => "Propose basic http authentication if the user has no permission to see the feed",
// "Feed Caching time" => "Feed Caching time",
"seconds" => "segons",
// "Use 0 for no caching" => "Use 0 for no caching",
// "Feed caching is done for anonymous users only" => "Feed caching is done for anonymous users only",
// "RSS for articles" => "RSS for articles",
// "RSS feeds for articles" => "RSS feeds for articles",
// "RSS for blogs" => "RSS for blogs",
// "RSS feeds for blogs" => "RSS feeds for blogs",
// "RSS for individual blogs" => "RSS for individual blogs",
// "RSS feed for individual blogs" => "RSS feed for individual blogs",
// "RSS for image galleries" => "RSS for image galleries",
// "RSS feed for image galleries" => "RSS feed for image galleries",
// "RSS for individual image galleries" => "RSS for individual image galleries",
// "RSS feed for individual image galleries" => "RSS feed for individual image galleries",
// "RSS for file galleries" => "RSS for file galleries",
// "RSS feed for file galleries" => "RSS feed for file galleries",
// "RSS for individual file galleries" => "RSS for individual file galleries",
// "RSS feed for individual file galleries" => "RSS feed for individual file galleries",
// "RSS for wiki pages" => "RSS for wiki pages",
// "RSS feed for wiki" => "RSS feed for wiki",
// "RSS for forums" => "RSS for forums",
// "RSS feed for forums" => "RSS feed for forums",
// "RSS for individual forums" => "RSS for individual forums",
// "RSS feed for individual forums" => "RSS feed for individual forums",
// "RSS per tracker" => "RSS per tracker",
// "RSS feed per tracker" => "RSS feed per tracker",
// "RSS for calendar events" => "RSS for calendar events",
// "RSS feed for calendar events" => "RSS feed for calendar events",
// "RSS for directories" => "RSS for directories",
// "RSS feed for directories" => "RSS feed for directories",
// "RSS for shoutbox" => "RSS for shoutbox",
// "RSS feed for shoutbox" => "RSS feed for shoutbox",
"Maximum number of items to display" => "Màximu nombre d'ítems per mostrar",
// "Show Author" => "Show Author",
"Homepage URL" => "URL de pàgina principal",
"Tiki RSS feed for articles" => "Alimentació RSS del Tiki per a articles",
"Tiki RSS feed for weblogs" => "Alimentació RSS del Tiki per a bitàcoles web",
// "Title to be prepended to the blog title for all blogs. If this field is empty only the blog title will be used" => "Title to be prepended to the blog title for all blogs. If this field is empty only the blog title will be used",
"Tiki RSS feed for image galleries" => "Alimentació RSS del Tiki per a galeries d'imatges",
"Tiki RSS feed for the image gallery: " => "Alimentació RSS del Tiki per a la galeria d'imatges: ",
"Tiki RSS feed for file galleries" => "Alimentació RSS del Tiki per a galeries de fitxers",
"Tiki RSS feed for the file gallery: " => "Alimentació RSS del Tiki per a la galeria de fitxers: ",
"Tiki RSS feed for the wiki pages" => "Alimentació RSS del Tiki per a pàgines wiki",
"Tiki RSS feed for forums" => "Alimentació RSS del Tiki per a fòrums",
"Tiki RSS feed for forum: " => "Alimentació RSS del Tiki per al fòrum: ",
"Tiki RSS feed for individual trackers: " => "Alimentació RSS del Tiki per a formularis-bd individuals: ",
"Tiki RSS feed for calendars" => "Alimentacions RSS de Tiki per als calendariss",
"Tiki RSS feed for directory sites" => "Alimentació RSS del Tiki per a llocs del directori",
// "Tiki RSS feed for shoutbox messages" => "Tiki RSS feed for shoutbox messages",
// "Article RSS Description" => "Article RSS Description",
// "Description to be published as part of the RSS feed for articles" => "Description to be published as part of the RSS feed for articles",
"Last articles." => "Els últims articles.",
// "Blogs RSS Description" => "Blogs RSS Description",
// "Description to be published as part of the RSS feed for blogs" => "Description to be published as part of the RSS feed for blogs",
"Last posts to weblogs." => "Darrers enviaments a les bitàcoles.",
// "Blog RSS Description" => "Blog RSS Description",
// "Description to be prepended to the blog description and published as part of the RSS feed for individual blogs. If this field is empty only the blog description will be used" => "Description to be prepended to the blog description and published as part of the RSS feed for individual blogs. If this field is empty only the blog description will be used",
// "Image galleries RSS Description" => "Image galleries RSS Description",
// "Description to be published as part of the RSS feed for image galleries" => "Description to be published as part of the RSS feed for image galleries",
"Last images uploaded to the image galleries." => "darreres imatges pujades a les galeries d'imatges.",
// "Individual image galleries RSS Description" => "Individual image galleries RSS Description",
// "Description to be published as part of the RSS feed for individual image galleries" => "Description to be published as part of the RSS feed for individual image galleries",
// "Last images uploaded to this image gallery. " => "Last images uploaded to this image gallery. ",
// "File galleries RSS Description" => "File galleries RSS Description",
// "Description to be published as part of the RSS feed for file galleries" => "Description to be published as part of the RSS feed for file galleries",
"Last files uploaded to the file galleries." => "Darrers arxius pujats a les galeries d'arxius.",
// "Individual file galleries RSS Description" => "Individual file galleries RSS Description",
// "Description to be published as part of the RSS feed for individual file galleries" => "Description to be published as part of the RSS feed for individual file galleries",
// "Last files uploaded to this file gallery. " => "Last files uploaded to this file gallery. ",
// "Wiki pages RSS Description" => "Wiki pages RSS Description",
// "Description to be published as part of the RSS feed for wiki pages" => "Description to be published as part of the RSS feed for wiki pages",
"Last modifications to the Wiki." => "Darreres modificacions al Wiki.",
// "Forums RSS Description" => "Forums RSS Description",
// "Description to be published as part of the RSS feed for forums" => "Description to be published as part of the RSS feed for forums",
"Last topics in forums." => "Darrers Temes als fòrums.",
// "Individual forums RSS Description" => "Individual forums RSS Description",
// "Description to be published as part of the RSS feed for individual forums" => "Description to be published as part of the RSS feed for individual forums",
"Last posts to this forum. " => "Darreres publicacions a aquest fòrum. ",
// "Individual trackers RSS Description" => "Individual trackers RSS Description",
// "Description to be published as part of the RSS feed for individual trackers" => "Description to be published as part of the RSS feed for individual trackers",
// "Last items published on this tracker" => "Last items published on this tracker",
// "Calendar events RSS Description" => "Calendar events RSS Description",
// "Description to be published as part of the RSS feed for calendar events" => "Description to be published as part of the RSS feed for calendar events",
"Upcoming Events" => "Propers Esdeveniments",
// "Directories RSS Description" => "Directories RSS Description",
// "Description to be published as part of the RSS feed for directories" => "Description to be published as part of the RSS feed for directories",
"Last sites." => "Darreres webs.",
// "Shoutbox RSS Description" => "Shoutbox RSS Description",
// "Description to be published as part of the RSS feed for shoutbox messages" => "Description to be published as part of the RSS feed for shoutbox messages",
// "Last shoutbox messages" => "Last shoutbox messages",
// "Podcast directory" => "Podcast directory",
"The server must be able to read/write the directory." => "El servidor ha de poder llegir/escriure el directori.",
// "Required for podcasts" => "Required for podcasts",
// "If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload files in that dir, either by scp, ftp, or other protocols" => "If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload files in that dir, either by scp, ftp, or other protocols",
// "The server must be able to read the directory" => "The server must be able to read the directory",
"The directory can be outside the web space." => "El directori pot ser fora de l'espai web.",
// "Prevent download if score becomes negative" => "Prevent download if score becomes negative",
// "Allow download limit per file" => "Allow download limit per file",
"Allow same file to be uploaded more than once" => "Permet que es pugui pujar el mateix arxiu més d'un cop",
"Yes, even in the same gallery" => "Sí, fins i tot a la mateixa galeria",
"Only in different galleries" => "Només en galeries diferents",
// "Display zip option in gallery" => "Display zip option in gallery",
// "Display in the gallery the zip option (in upload and gallery file)" => "Display in the gallery the zip option (in upload and gallery file)",
// "Upload progressbar" => "Upload progressbar",
// "Ajax / Flash (Browser-based)" => "Ajax / Flash (Browser-based)",
// "Must match" => "Must match",
// "Cannot match" => "Cannot match",
// "Quota for all the files and archives" => "Quota for all the files and archives",
"Mb" => "MegaOctets (Mb)",
// "(0 for unlimited)" => "(0 for unlimited)",
// "Quota can be defined for each file gallery" => "Quota can be defined for each file gallery",
// "Default quota for each new gallery" => "Default quota for each new gallery",
// "Show quota bar in the list page" => "Show quota bar in the list page",
// "Yes, display bar and detail text" => "Yes, display bar and detail text",
// "Yes, display only bar" => "Yes, display only bar",
// "Yes, display only text" => "Yes, display only text",
"Storage" => "Emmagatzematge",
// "Store in database" => "Store in database",
// "Store in directory" => "Store in directory",
// "Path to store files in the file gallery" => "Path to store files in the file gallery",
// "Include the search box on the current gallery files just after the find div" => "Include the search box on the current gallery files just after the find div",
// "Include a search box on file galleries" => "Include a search box on file galleries",
// "Display hits with a ratio between hits / maxhits" => "Display hits with a ratio between hits / maxhits",
// "Display properties in the context menu" => "Display properties in the context menu",
// "Display replace menu in context menu" => "Display replace menu in context menu",
// "Automatic deletion of old files" => "Automatic deletion of old files",
// "The user will have an option when uploading a file to specify the time after which the file is deleted" => "The user will have an option when uploading a file to specify the time after which the file is deleted",
// "Allow action on multiple files or galleries" => "Allow action on multiple files or galleries",
// "The check button on file gallery can be remove" => "The check button on file gallery can be remove",
// "Deletion emails notification" => "Deletion emails notification",
// "These emails will receive a copy of each deleted file. Emails are separated with comma" => "These emails will receive a copy of each deleted file. Emails are separated with comma",
// "Keep the same fileId for the latest version of a file" => "Keep the same fileId for the latest version of a file",
// "If checked, the fileId of the latest version of a file stays the same. Link to a file will always give you the latest version. If not checked, the fileId is attached to the file for ever, link to file will give you the precise version of a file" => "If checked, the fileId of the latest version of a file stays the same. Link to a file will always give you the latest version. If not checked, the fileId is attached to the file for ever, link to file will give you the precise version of a file",
// "Show thumbnail actions" => "Show thumbnail actions",
// "Show the checkbox and wrench icon for file actions menu when not displaying details" => "Show the checkbox and wrench icon for file actions menu when not displaying details",
// "Max thumbnail size" => "Max thumbnail size",
// "Maximum width or height for image thumbnails" => "Maximum width or height for image thumbnails",
// "In pixels" => "In pixels",
// "Automatic indexing of file content" => "Automatic indexing of file content",
// "Uses command line tools to extract the information from the files based on their MIME types" => "Uses command line tools to extract the information from the files based on their MIME types",
// "Upload files from remote source" => "Upload files from remote source",
// "Allow to create files in file galleries using a URL that will be polled for new revisions" => "Allow to create files in file galleries using a URL that will be polled for new revisions",
// "Remote source refresh frequency limit" => "Remote source refresh frequency limit",
// "Minimum amount of seconds to be ellapsed between source checks to prevent flooding servers" => "Minimum amount of seconds to be ellapsed between source checks to prevent flooding servers",
// "Display controls to attempt refresh" => "Display controls to attempt refresh",
// "Let users trigger a refresh attempt from the remote host" => "Let users trigger a refresh attempt from the remote host",
// "Allow searching for existing files in the tracker files field" => "Allow searching for existing files in the tracker files field",
// "Search files using the search index" => "Search files using the search index",
// "Fix mime types based on file suffix" => "Fix mime types based on file suffix",
// "Fixes mime type of image files based on file suffixes when they are incorrectly detected as application/octet-stream" => "Fixes mime type of image files based on file suffixes when they are incorrectly detected as application/octet-stream",
// "Max Name Length" => "Max Name Length",
// "Length to truncate file names to in browse view" => "Length to truncate file names to in browse view",
// "Set a directory on your server. Ex.: /var/www/  It's recommended that this directory not be web accessible. PHP must be able to read/write to the directory" => "Set a directory on your server. Ex.: /var/www/  It's recommended that this directory not be web accessible. PHP must be able to read/write to the directory",
// "Revision Approval" => "Revision Approval",
// "Uses flagged revisions to hide unapproved wiki page revisions from users with lower privileges" => "Uses flagged revisions to hide unapproved wiki page revisions from users with lower privileges",
// "Revision Approval Categories" => "Revision Approval Categories",
// "List of category IDs on which revision approval is required" => "List of category IDs on which revision approval is required",
// "Footer shadow start" => "Footer shadow start",
// "Footer shadow end" => "Footer shadow end",
"Uploaded filenames must match regex" => "Els arxius penjats han de coincidir amb aquesta regex ",
// "Manage thread defaults per-forum" => "Manage thread defaults per-forum",
// "Display thread configuration bar" => "Display thread configuration bar",
// "Allows users to override the defaults" => "Allows users to override the defaults",
// "Display thread configuration bar only when number of posts exceed" => "Display thread configuration bar only when number of posts exceed",
// "Keep settings for all forums during the user session" => "Keep settings for all forums during the user session",
// "Default style" => "Default style",
"Plain" => "Senzill",
"Threaded" => "Per fils de discussió",
"Headers Only" => "Només capçaleres",
// "Default sort mode" => "Default sort mode",
"Title (desc)" => "Títol (desc)",
"Title (asc)" => "Títol (asc)",
"Topics" => "Temes",
"Posts per day" => "Publicacions per dia",
"Last post" => "Darrer enviament",
// "Description length" => "Description length",
// "Hide titles for forum threads" => "Hide titles for forum threads",
// "Most titles are left untouched because they are a direct reply to the parent thread. This feature hides the title altogether from the forms and display" => "Most titles are left untouched because they are a direct reply to the parent thread. This feature hides the title altogether from the forms and display",
// "Force title in reply" => "Force title in reply",
// "Shows a blank title box and requires it to be filled before submission of forum post" => "Shows a blank title box and requires it to be filled before submission of forum post",
// "Do not prefix messages titles by 'Re: '" => "Do not prefix messages titles by 'Re: '",
"Creation Date (asc)" => "Data de creació (asc)",
"Topics (desc)" => "Temes (desc)",
"Threads (desc)" => "Missatges (desc)",
"Last post (desc)" => "Últim post (desc)",
"Name (desc)" => "Nom (desc)",
"Name (asc)" => "Nom (asc)",
// "Multilingual tags" => "Multilingual tags",
// "Permits translation management of tags" => "Permits translation management of tags",
// "Show tag cloud" => "Show tag cloud",
// "Maximum number of tags in cloud" => "Maximum number of tags in cloud",
// "Show freetags in middle column" => "Show freetags in middle column",
// "Preload freetag random tag" => "Preload freetag random tag",
// "Number of Tags to show in Tag Suggestions" => "Number of Tags to show in Tag Suggestions",
// "Valid characters pattern" => "Valid characters pattern",
// "Lowercase tags only" => "Lowercase tags only",
// "Enable freetags 3D browser" => "Enable freetags 3D browser",
// "3D autoload" => "3D autoload",
"Browser width" => "Amplada del navegador",
"Browser height" => "Alçada del navegador",
"Navigation depth" => "Profunditat de navegació",
"Node size" => "Mida del node",
"Text size" => "Mida del text",
"Spring (connection) size" => "Mida (de la connexió) de la molla",
"Existing page node color" => "Color de node d'una pàgina existent",
"Missing page node color" => "Falta color del node de pàgina",
"Camera distance adjusted relative to nearest node" => "La distància a la càmera s'ajusta en funció del node més proper",
"Camera distance" => "Distància a la càmera",
"Field of view" => "Camp de vista",
"Feed animation interval (milisecs)" => "Interval d'animació del canal (milisegons)",
"Friction constant" => "Constant de fricció",
"Elastic constant" => "Constant elàstica",
// "Electrostatic constant" => "Electrostatic constant",
"Node mass" => "Massa del node",
"Node charge" => "Càrrega del node",
// "Include \"Generate Password\" option on registration form" => "Include \"Generate Password\" option on registration form",
// "Geolocate wiki pages" => "Geolocate wiki pages",
// "Provide controls to geolocate wiki pages from the edit functionality" => "Provide controls to geolocate wiki pages from the edit functionality",
// "Geolocate articles" => "Geolocate articles",
// "Provide controls to geolocate articles from the edit functionality" => "Provide controls to geolocate articles from the edit functionality",
// "Geolocate blog posts" => "Geolocate blog posts",
// "Provide controls to geolocate blog posts from the edit functionality" => "Provide controls to geolocate blog posts from the edit functionality",
// "Available tile layers on maps" => "Available tile layers on maps",
// "Allows to replace the default OpenStreetMap tiles for tiles from other mapping services, such as Google or Bing" => "Allows to replace the default OpenStreetMap tiles for tiles from other mapping services, such as Google or Bing",
// "Valid options are: %0" => "Valid options are: %0",
// "Google Street View" => "Google Street View",
// "Open up Google Street View in a window to see the visible coordinates" => "Open up Google Street View in a window to see the visible coordinates",
// "Google Street View Overlay" => "Google Street View Overlay",
// "This is not guaranteed to work" => "This is not guaranteed to work",
// "Always load OpenLayers" => "Always load OpenLayers",
// "Load the OpenLayers library even if no map is explicitly included in the page" => "Load the OpenLayers library even if no map is explicitly included in the page",
// "Style of the site, sometimes called a skin or CSS. See http://themes.tiki.org for more Tiki themes" => "Style of the site, sometimes called a skin or CSS. See http://themes.tiki.org for more Tiki themes",
"Browser title" => "Títol (finestra del navegador)",
// "Label visible in the browser's title bar on all pages. Also appears in search engines" => "Label visible in the browser's title bar on all pages. Also appears in search engines",
// "Validate new user registrations by email" => "Validate new user registrations by email",
// "Upon registration, the new user will receive an email containing a link to confirm validity" => "Upon registration, the new user will receive an email containing a link to confirm validity",
"Home page" => "Pàgina Principal",
// "Landing page used for the wiki when no page is specified. The page will be created if it does not exist" => "Landing page used for the wiki when no page is specified. The page will be created if it does not exist",
"Use group homepages" => "Empra pàgines d'inici de grup",
// "Users can be sent to different pages upon login, depending on their default group" => "Users can be sent to different pages upon login, depending on their default group",
"Go to group homepage only if login from default homepage" => "Ves a la pàgina de grup només si la connexió es fa des de la pàgina inicial per defecte",
// "Default language" => "Default language",
// "Site language used when no other language is specified by the user" => "Site language used when no other language is specified by the user",
// "Cache external pages" => "Cache external pages",
// "Cache external images" => "Cache external images",
"Temporary directory" => "Directori temporal",
// "Tiki requires full read and write access to this directory" => "Tiki requires full read and write access to this directory",
"Help URL" => "URL d'Ajuda",
// "The default help system may not be complete. You can help with the Tiki documentation" => "The default help system may not be complete. You can help with the Tiki documentation",
"Open external links in new window" => "Obrir enllaços externs en una finestra nova",
// "License page" => "License page",
// "Submit notice" => "Submit notice",
"Full path to gdaltindex" => "Ruta sencera al gdaltindex",
"Full path to ogr2ogr" => "Camí complet a ogr2ogr",
"Map Zone" => "Zona del Mapa",
"Display modules to all groups always" => "Mostra sempre els mòduls a tots els grups",
"Hide anonymous-only modules from registered users" => "Amaga els mòduls per a anònims dels usuaris registrats",
// "Hide anonymous-only modules from Admins" => "Hide anonymous-only modules from Admins",
// "Maximum number of articles on articles home page" => "Maximum number of articles on articles home page",
// "Site Ads and Banners Content" => "Site Ads and Banners Content",
"Test" => "Test",
// "URL to go to when clicking on a username" => "URL to go to when clicking on a username",
// "Use %user% for login name and %userId% for userId)" => "Use %user% for login name and %userId% for userId)",
// "Forgot password" => "Forgot password",
// "Users can request to reset password. They will receive a link by email" => "Users can request to reset password. They will receive a link by email",
// "Each group can have its theme" => "Each group can have its theme",
// "Site title" => "Site title",
"Subtitle" => "Subtítol",
"Maximum number of records in listings" => "Quantitat màxima de registres en llistats",
// "Maximum number of versions" => "Maximum number of versions",
// "0 for unlimited versions" => "0 for unlimited versions",
"Users can register" => "Els usuaris es poden registrar",
// "Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server" => "Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server",
// "Require validation by Admin" => "Require validation by Admin",
// "The administrator will receive an email for each new user registration, and must validate the user before the user can login" => "The administrator will receive an email for each new user registration, and must validate the user before the user can login",
// "Require passcode to register" => "Require passcode to register",
// "Users must enter a code to register.  You must inform users of this code. Use to restrict registration to invited users only" => "Users must enter a code to register.  You must inform users of this code. Use to restrict registration to invited users only",
// "Passcode" => "Passcode",
// "Alphanumeric code required to complete the registration" => "Alphanumeric code required to complete the registration",
// "Show passcode on registration form" => "Show passcode on registration form",
// "Use tracker to collect more user information" => "Use tracker to collect more user information",
// "Display a tracker (form) for the user to complete, as part of the registration process. Use this tracker to store additional information about each user" => "Display a tracker (form) for the user to complete, as part of the registration process. Use this tracker to store additional information about each user",
// "Use the \"Admin Groups\" page to select which tracker and fields to display" => "Use the \"Admin Groups\" page to select which tracker and fields to display",
// "Use tracker to collect more group information" => "Use tracker to collect more group information",
// "Create a new group for each user" => "Create a new group for each user",
// "Synchronize Tiki groups with a directory" => "Synchronize Tiki groups with a directory",
// "Define the directory within the \"LDAP\" tab" => "Define the directory within the \"LDAP\" tab",
// "Synchronize Tiki users with a directory" => "Synchronize Tiki users with a directory",
"Remember me" => "Recorda'm",
"Duration" => "Durada",
"hour" => "hora",
"hours" => "hores",
"day" => "dia",
"week" => "setmana",
"month" => "mes",
"year" => "any",
// "Use custom homepage" => "Use custom homepage",
// "Use a Tiki feature homepage or another homepage" => "Use a Tiki feature homepage or another homepage",
// "Use Tiki feature as homepage" => "Use Tiki feature as homepage",
// "Select the Tiki feature to use as the site homepage. Only enabled features are listed" => "Select the Tiki feature to use as the site homepage. Only enabled features are listed",
// "Disable JavaScript" => "Disable JavaScript",
// "Disable JavaScript for testing purpose even if the browser allows it" => "Disable JavaScript for testing purpose even if the browser allows it",
// "Partner ID" => "Partner ID",
// "Kaltura Partner ID" => "Kaltura Partner ID",
// "User secret" => "User secret",
// "Kaltura partner setting user secret" => "Kaltura partner setting user secret",
// "Admin secret" => "Admin secret",
// "Kaltura partner setting admin secret" => "Kaltura partner setting admin secret",
// "KDP UI Configuration ID" => "KDP UI Configuration ID",
// "Kaltura Dynamic Player (KDP) user interface configuration ID" => "Kaltura Dynamic Player (KDP) user interface configuration ID",
// "KDP Widget ID" => "KDP Widget ID",
// "Kaltura Dynamic Player (KDP) Widget ID. This configuration is specific to your account" => "Kaltura Dynamic Player (KDP) Widget ID. This configuration is specific to your account",
// "KCW UI Configuration ID" => "KCW UI Configuration ID",
// "Kaltura Configuration Wizard (KCW) user interface configuration ID" => "Kaltura Configuration Wizard (KCW) user interface configuration ID",
// "Kaltura Simple Editor UI Configuration ID" => "Kaltura Simple Editor UI Configuration ID",
// "Kaltura Advanced Editor UI Configuration ID" => "Kaltura Advanced Editor UI Configuration ID",
// "Kaltura \"User\"" => "Kaltura \"User\"",
// "Owner of content shared by all Tiki users on this site. If empty then each Tiki user can only see their own media entries" => "Owner of content shared by all Tiki users on this site. If empty then each Tiki user can only see their own media entries",
// "Kaltura Service URL" => "Kaltura Service URL",
// "e.g. http://www.kaltura.com/" => "e.g. http://www.kaltura.com/",
// "Set blogs homepage first" => "Set blogs homepage first",
// "Set Image gal homepage first" => "Set Image gal homepage first",
// "Set Forum homepage first" => "Set Forum homepage first",
"Custom home" => "Inici personalitzat",
// "Since passwords are encrypted, it's not possible to tell the user what the password is. It's only possible to change it" => "Since passwords are encrypted, it's not possible to tell the user what the password is. It's only possible to change it",
// "Validate user's email server" => "Validate user's email server",
// "Displays the required passcode on the registration form. This is helpful for legitimate users who want to register while making it difficult for automated robots because the passcode is unique for each site and because it is displayed in JavaScript" => "Displays the required passcode on the registration form. This is helpful for legitimate users who want to register while making it difficult for automated robots because the passcode is unique for each site and because it is displayed in JavaScript",
// "The group will be named identical to the user's username" => "The group will be named identical to the user's username",
"User's choice" => "Elecció de l'usuari",
// "If you don't know better, use '_yourPartnerID'" => "If you don't know better, use '_yourPartnerID'",
// "You could use your server name for this. e.g. %0" => "You could use your server name for this. e.g. %0",
// "Google Maps API Key" => "Google Maps API Key",
"Default x for map center" => "Coordenada x per defecte per al centre del mapa",
// "Default y for map center" => "Default y for map center",
"Default zoom level" => "Nivell de zoom per defecte",
"whole earth" => "tota la Terra",
"country size" => "mida de país",
"city size" => "mida de ciutat",
// "village size" => "village size",
"max zoom" => "zoom màxim",
// "Show map mode buttons in articles list" => "Show map mode buttons in articles list",
// "Show map mode buttons in page list" => "Show map mode buttons in page list",
// "Header shadow start" => "Header shadow start",
// "Header shadow end" => "Header shadow end",
// "Custom CSS" => "Custom CSS",
// "Includes a custom block of CSS inline in all pages" => "Includes a custom block of CSS inline in all pages",
// "Custom JavaScript" => "Custom JavaScript",
// "Includes a custom block of inline JavaScript in all pages" => "Includes a custom block of inline JavaScript in all pages",
// "Do not include the <script> and </script> tags" => "Do not include the <script> and </script> tags",
// "Highlight group" => "Highlight group",
"Home Blog (main blog)" => "Bloc Inicial (principal)",
"Home Forum (main forum)" => "Fòrum Inicial (principal)",
// "Home File Gallery (main file gallery)" => "Home File Gallery (main file gallery)",
"Home Gallery (main gallery)" => "Galeria principal",
// "No image gallery available (create one first)" => "No image gallery available (create one first)",
// "No file gallery available (create one first)" => "No file gallery available (create one first)",
// "No forum available (create one first)" => "No forum available (create one first)",
// "No blog available (create one first)" => "No blog available (create one first)",
"HTTP port" => "Port HTTP",
// "If left empty, port 80 will be used" => "If left empty, port 80 will be used",
// "HTTP Lookup Skip Framesets" => "HTTP Lookup Skip Framesets",
// "When performing and HTTP request to an external source, verify if the result is a frameset and use heuristic to provide the real content" => "When performing and HTTP request to an external source, verify if the result is a frameset and use heuristic to provide the real content",
// "Registration referrer check" => "Registration referrer check",
// "Use the HTTP referrer to check registration POST is sent from same host. (May not work on some setups.)" => "Use the HTTP referrer to check registration POST is sent from same host. (May not work on some setups.)",
// "Use HTTPS when building user-specific links" => "Use HTTPS when building user-specific links",
// "When building notification emails, RSS feeds or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server" => "When building notification emails, RSS feeds or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server",
"HTTPS port" => "Port HTTPS",
// "If left empty, port 443 will be used" => "If left empty, port 443 will be used",
// "Use HTTPS login" => "Use HTTPS login",
// "Increase security by allowing to transmit authentication credentials over SSL. Certificates must be configured on the server" => "Increase security by allowing to transmit authentication credentials over SSL. Certificates must be configured on the server",
"Allow secure (https) login" => "Permet connexió segura (https)",
"Encourage secure (https) login" => "Anima a emprar connexió segura (https)",
"Consider we are always in HTTPS, but do not check" => "Considera que som sempre en HTTPS, però no comprovis",
"Require secure (https) login" => "Requereix connexió segura (https)",
// "Do not require HTTPS until you have setup and tested the connection, otherwise, you will make your whole site unaccessible" => "Do not require HTTPS until you have setup and tested the connection, otherwise, you will make your whole site unaccessible",
// "CSS selectors to be fixed" => "CSS selectors to be fixed",
// "Separate multiple elements with a comma (,)" => "Separate multiple elements with a comma (,)",
// "HTMLDomElements to be fixed" => "HTMLDomElements to be fixed",
// "IP can be checked" => "IP can be checked",
// "Check anonymous votes by user's IP" => "Check anonymous votes by user's IP",
// "Use CDN for JavaScript" => "Use CDN for JavaScript",
// "Obtain jQuery and jQuery UI libraries through a content delivery network" => "Obtain jQuery and jQuery UI libraries through a content delivery network",
// "Google (supports SSL via HTTPS)" => "Google (supports SSL via HTTPS)",
// "jQuery" => "jQuery",
// "Slide" => "Slide",
"Fade" => "Esvaeix",
// "Blind (UI)" => "Blind (UI)",
// "Clip (UI)" => "Clip (UI)",
// "Drop (UI)" => "Drop (UI)",
// "Explode (UI)" => "Explode (UI)",
// "Fold (UI)" => "Fold (UI)",
// "Puff (UI)" => "Puff (UI)",
// "Slide (UI)" => "Slide (UI)",
// "Effect for modules" => "Effect for modules",
// "Effect for tabs" => "Effect for tabs",
// "Speed" => "Speed",
// "Fast" => "Fast",
"Normal" => "Normal",
// "Slow" => "Slow",
"Direction" => "Direcció",
"Vertical" => "Vertical",
"Horizontal" => "Horitzontal",
"Left" => "Cap a l'esquerra",
"Right" => "Cap a la dreta",
"Up" => "Cap a dalt",
"Down" => "Cap avall",
// "jQuery-ui Select Menu" => "jQuery-ui Select Menu",
// "Styled replacement for dropdown select menus" => "Styled replacement for dropdown select menus",
// "Use Select Menu on all select elements" => "Use Select Menu on all select elements",
// "Applies jQuery-ui Select Menu to every select menu" => "Applies jQuery-ui Select Menu to every select menu",
// "Experimental. This feature is under development" => "Experimental. This feature is under development",
// "Never delete versions younger than" => "Never delete versions younger than",
"Use database for translation" => "Empra base de dades per a la traducció",
// "Use the database to store the translated strings and allow using interactive translation" => "Use the database to store the translated strings and allow using interactive translation",
// "[%0|Edit or export/import Languages]" => "[%0|Edit or export/import Languages]",
// "Language inclusion threshold" => "Language inclusion threshold",
// "When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages" => "When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages",
"Layout per section" => "Format per secció",
// "Layout Width" => "Layout Width",
// "Constrains the site display width (default: 990px)" => "Constrains the site display width (default: 990px)",
// "ex.: 800px" => "ex.: 800px",
// "Users can choose not to have tabs" => "Users can choose not to have tabs",
// "Add group CSS info" => "Add group CSS info",
// "Add classes to the page BODY tag to indicate group membership" => "Add classes to the page BODY tag to indicate group membership",
// "Either grp_Anonymous or grp_Registered and possibly grp_Admins as well" => "Either grp_Anonymous or grp_Registered and possibly grp_Admins as well",
// "If user does not exist in Tiki" => "If user does not exist in Tiki",
// "Create the user" => "Create the user",
// "Deny access" => "Deny access",
// "Create user if not in LDAP" => "Create user if not in LDAP",
// "Maximum average server load threshold in the last minute" => "Maximum average server load threshold in the last minute",
// "Log mail in Tiki logs" => "Log mail in Tiki logs",
"Smarty Template usage indicator" => "Indicador d'ús de Plantilles Smarty",
"Add HTML comment at start and end of each Smarty template (TPL)" => "Afegeix comentaris HTML a l'inici i final de cada plantilla Smarty (TPL)",
// "Use only for development, not in production because these warnings are added to emails as well, and visible to the users" => "Use only for development, not in production because these warnings are added to emails as well, and visible to the users",
// "You need to clear your Tiki template cache for this change to take effect" => "You need to clear your Tiki template cache for this change to take effect",
// "Log SQL" => "Log SQL",
// "Log SQL queries" => "Log SQL queries",
// "Log queries using more than (seconds)" => "Log queries using more than (seconds)",
// "This may impact performance" => "This may impact performance",
// "Use email as username" => "Use email as username",
// "Instead of creating new usernames, use the user's email address for authentication" => "Instead of creating new usernames, use the user's email address for authentication",
// "Obscure email when using email as username if possible (coverage will not be complete)" => "Obscure email when using email as username if possible (coverage will not be complete)",
// "This will attempt as much as possible to hide the email, showing the realname or the truncated email instead" => "This will attempt as much as possible to hide the email, showing the realname or the truncated email instead",
// "HTTP Basic Authentication" => "HTTP Basic Authentication",
// "Check credentials from HTTP Basic Authentication, useful to allow webservices to use credentials" => "Check credentials from HTTP Basic Authentication, useful to allow webservices to use credentials",
// "SSL Only (Recommended)" => "SSL Only (Recommended)",
"Long date format" => "Format llarg de data",
"Long time format" => "Format llarg d'hora",
"%A %d of %B, %Y" => "%A %d de %B, %Y",
"%H:%M:%S %Z" => "%H:%M:%S %Z",
// "%A %d of %B, %Y %H:%M:%S %Z" => "%A %d of %B, %Y %H:%M:%S %Z",
// "Force lowercase" => "Force lowercase",
// "Mail end of line" => "Mail end of line",
"CRLF (standard)" => "CRLF (estàndard)",
"LF (some Unix MTA)" => "LF (alguns MTA Unix)",
// "Main shadow start" => "Main shadow start",
// "Main shadow end" => "Main shadow end",
"full path to mapfiles" => "ruta sencera als mapfiles",
"Wiki Page for Help" => "Plana Wiki d'Ajuda",
"Wiki Page for Comments" => "Plana Wiki per Comentaris",
// "Maximum length" => "Maximum length",
// "Memcache" => "Memcache",
// "Enable connection to memcached servers to store temporary information" => "Enable connection to memcached servers to store temporary information",
// "Requires the PHP memcache extension" => "Requires the PHP memcache extension",
// "Memcache compression" => "Memcache compression",
// "Enable compression for memcache storage" => "Enable compression for memcache storage",
// "Memcache servers" => "Memcache servers",
// "Server list which may be accessed. For each server, the address, port and weight must be specified" => "Server list which may be accessed. For each server, the address, port and weight must be specified",
// "One per line. address:port (weight)" => "One per line. address:port (weight)",
// "Memcache key prefix" => "Memcache key prefix",
// "When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoiding conflicts" => "When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoiding conflicts",
// "Memcache expiration" => "Memcache expiration",
// "Duration for which the data will be kept" => "Duration for which the data will be kept",
// "Cache wiki data in memcache" => "Cache wiki data in memcache",
// "Cache wiki output in memcache" => "Cache wiki output in memcache",
// "Cache forum output in memcache" => "Cache forum output in memcache",
// "Menu icons" => "Menu icons",
// "Allows to define icons for menu entries" => "Allows to define icons for menu entries",
// "Default path for the icons" => "Default path for the icons",
// "Allow HTML in menu option names and URLs" => "Allow HTML in menu option names and URLs",
// "If enabled, menu option names and URL-s are treated as HTML content and they are not escaped (no replacement of HTML special characters). This allows the use of HTML to insert images for example. Code must be valid. This allows menu item editors to put arbitrary HTML; only enable if you know what you are doing" => "If enabled, menu option names and URL-s are treated as HTML content and they are not escaped (no replacement of HTML special characters). This allows the use of HTML to insert images for example. Code must be valid. This allows menu item editors to put arbitrary HTML; only enable if you know what you are doing",
// "REALLY allow HTML (INSECURE)" => "REALLY allow HTML (INSECURE)",
// "This needs to be checked for the parent preference to be actually enabled. This allows menu item editors to put arbitrary HTML, which could allow session hijacking; only enable if you know what you are doing" => "This needs to be checked for the parent preference to be actually enabled. This allows menu item editors to put arbitrary HTML, which could allow session hijacking; only enable if you know what you are doing",
"Maximum mailbox size (messages, 0=unlimited)" => "Mida màxima de la bústia de correu-e (missatges, 0=sense límit)",
"Maximum mail archive size (messages, 0=unlimited)" => "Mida màxima dels arxius de correu-e (missatges, 0=sense límit)",
"Maximum sent box size (messages, 0=unlimited)" => "Mida màxima de la bústia de sortida (missatges, 0=sense límit)",
// "Keywords" => "Keywords",
// "A list of key words (separated by commas) that describe your site" => "A list of key words (separated by commas) that describe your site",
// "Include freetags" => "Include freetags",
// "If the freetags feature is enabled, use the freetags in the meta keywords for each page with freetags set. This allows individual pages on the site to carry different meta tags" => "If the freetags feature is enabled, use the freetags in the meta keywords for each page with freetags set. This allows individual pages on the site to carry different meta tags",
// "Use thread title instead" => "Use thread title instead",
// "Use the forum thread title in the meta title tag" => "Use the forum thread title in the meta title tag",
// "Use image title instead" => "Use image title instead",
// "Use the image title in the meta title tag" => "Use the image title in the meta title tag",
// "A short description of your site. Some search engines display this information with your site's listing" => "A short description of your site. Some search engines display this information with your site's listing",
// "Page Description" => "Page Description",
// "Use individual page description as a met tag for the page" => "Use individual page description as a met tag for the page",
// "The author of your site. Typically this will be the Admin or Webmaster" => "The author of your site. Typically this will be the Admin or Webmaster",
"geo.position" => "geo.posició",
// "The latitude and longitude of the physical location of the site. For example \"38.898748, -77.037684\"" => "The latitude and longitude of the physical location of the site. For example \"38.898748, -77.037684\"",
"geo.region" => "geo.regió",
// "The ISO-3166 Country and Region Codes for your location. For example, \"US-NY\"" => "The ISO-3166 Country and Region Codes for your location. For example, \"US-NY\"",
"geo.placename" => "geo.nomdellloc",
// "A free-text description of your location" => "A free-text description of your location",
// "Meta robots" => "Meta robots",
// "Specify how web-bots should index your site. Valid values include: INDEX or NOINDEX, and FOLLOW or NOFOLLOW" => "Specify how web-bots should index your site. Valid values include: INDEX or NOINDEX, and FOLLOW or NOFOLLOW",
// "Revisit after" => "Revisit after",
// "Specify how often (in days) web-bots should visit your site" => "Specify how often (in days) web-bots should visit your site",
// "Show past metrics results" => "Show past metrics results",
// "In the metrics dashboard, identify if the previously collected metrics should be displayed" => "In the metrics dashboard, identify if the previously collected metrics should be displayed",
// "Past metrics count" => "Past metrics count",
// "Amount of past results to display" => "Amount of past results to display",
// "No metric trend value" => "No metric trend value",
// "Value to display when no trend is available for the metric" => "Value to display when no trend is available for the metric",
// "Metric trend prefix" => "Metric trend prefix",
// "Portion of text to display before the metric trend value" => "Portion of text to display before the metric trend value",
// "Metric trend suffix" => "Metric trend suffix",
// "Portion of text to display after the metric trend value" => "Portion of text to display after the metric trend value",
// "Metric name length" => "Metric name length",
// "Metric tab name length" => "Metric tab name length",
// "Cache metrics output" => "Cache metrics output",
// "Most metrics are expensive to generate. Because they tend to evolve slowly, some delay between update and generation can be tolerated. Disabling cache is not recommended" => "Most metrics are expensive to generate. Because they tend to evolve slowly, some delay between update and generation can be tolerated. Disabling cache is not recommended",
// "Middle shadow start" => "Middle shadow start",
// "Middle shadow end" => "Middle shadow end",
// "Minimum length" => "Minimum length",
// "Mobile Access" => "Mobile Access",
// "New mobile feature for Tiki 7" => "New mobile feature for Tiki 7",
// "Mobile Perspectives" => "Mobile Perspectives",
// "Header Theme" => "Header Theme",
// "jQuery Mobile Theme" => "jQuery Mobile Theme",
// "Content Theme" => "Content Theme",
// "Footer Theme" => "Footer Theme",
// "Modules Theme" => "Modules Theme",
// "Menus Theme" => "Menus Theme",
// "Use Latest Library" => "Use Latest Library",
// "Use latest version of the jquery.mobile" => "Use latest version of the jquery.mobile",
// "Uses latest build from jquery.com CDN" => "Uses latest build from jquery.com CDN",
// "Top module zone" => "Top module zone",
// "Visibility of area to keep modules such as logo, login etc (header)" => "Visibility of area to keep modules such as logo, login etc (header)",
// "Topbar module zone" => "Topbar module zone",
// "Visibility of area for modules such as main horizontal menu, search form, page-wide content, etc" => "Visibility of area for modules such as main horizontal menu, search form, page-wide content, etc",
// "topbar" => "topbar",
// "Page top module zone" => "Page top module zone",
// "Visibility of area to keep modules such as share etc" => "Visibility of area to keep modules such as share etc",
// "Bottom module zone" => "Bottom module zone",
// "Visibility of area to keep modules such as \"powered by\" and \"rss list\" (footer)" => "Visibility of area to keep modules such as \"powered by\" and \"rss list\" (footer)",
// "Page bottom module zone" => "Page bottom module zone",
// "Visibility of area to keep modules at the foot of each page" => "Visibility of area to keep modules at the foot of each page",
// "\"More Like This\" algorithm" => "\"More Like This\" algorithm",
// "Minimum number of tags in common" => "Minimum number of tags in common",
// "Multi-domain" => "Multi-domain",
// "Allows to map domain names to perspectives and simulate multiple domains hosted on the same instance" => "Allows to map domain names to perspectives and simulate multiple domains hosted on the same instance",
// "Multi-domain Configuration" => "Multi-domain Configuration",
// "Comma-separated values mapping the domain name to the perspective ID" => "Comma-separated values mapping the domain name to the perspective ID",
// "One domain per line. Comma separated with perspective ID. Ex.: tiki.org,1" => "One domain per line. Comma separated with perspective ID. Ex.: tiki.org,1",
// "Switch domain when switching perspective" => "Switch domain when switching perspective",
// "Remember that different domains have different login sessions and even in the case of subdomains you need to have an understanding of session cookies to make it work" => "Remember that different domains have different login sessions and even in the case of subdomains you need to have an understanding of session cookies to make it work",
// "Throttle newsletter send rate" => "Throttle newsletter send rate",
// "Pause for a given amount of seconds before each batch to avoid overloading the mail server" => "Pause for a given amount of seconds before each batch to avoid overloading the mail server",
// "Newsletter pause length" => "Newsletter pause length",
// "Amount of seconds on wait before each batch" => "Amount of seconds on wait before each batch",
// "Newsletter batch size" => "Newsletter batch size",
// "Amount of emails to send in each batch" => "Amount of emails to send in each batch",
// "Allow sending newsletters through external clients" => "Allow sending newsletters through external clients",
// "Generate mailto links using the recipients as the BCC list" => "Generate mailto links using the recipients as the BCC list",
// "This will expose the list if email addresses to all users allowed to send newsletters" => "This will expose the list if email addresses to all users allowed to send newsletters",
"Use relative (next / previous) pagination links" => "Empra enllaços relatius de paginació (següent / previ)",
// "Wiki buttons" => "Wiki buttons",
// "Page description, icons, backlinks, .." => "Page description, icons, backlinks, ..",
// "Top " => "Top ",
"Bottom" => "Fons",
// "Neither" => "Neither",
// "A page can occur multiple times in a structure" => "A page can occur multiple times in a structure",
"Display fast move links (by 10 percent of the total number of pages) " => "Mostra enllaços per moure's ràpid (per 10 per cent del nombre total de pàgines) ",
// "Hide pagination when there is only one page" => "Hide pagination when there is only one page",
"Use Icons" => "Empra Icones",
"Display 'First' and 'Last' links" => "Mostra Enllaços 'Primer/a' i 'Darrer/a'",
"PAM service" => "Servei PAM",
"Currently unused" => "No utilitzat actualment",
// "Require characters and numerals" => "Require characters and numerals",
// "For improved security, require users to include a mix of characters and numerals in passwords" => "For improved security, require users to include a mix of characters and numerals in passwords",
// "Password expires after" => "Password expires after",
// "Require alphabetical characters in lower and upper case" => "Require alphabetical characters in lower and upper case",
// "Password must contain at least one alphabetical character in lower case like a and one in upper case like A" => "Password must contain at least one alphabetical character in lower case like a and one in upper case like A",
// "Require special characters" => "Require special characters",
// "Password must contain at least one special character in lower case like \" / \$ % ? & * ( ) _ + .." => "Password must contain at least one special character in lower case like \" / \$ % ? & * ( ) _ + ..",
// "Require no consecutive repetition of the same character" => "Require no consecutive repetition of the same character",
// "Password must contain no consecutive repetition of the same character as 111 or aab" => "Password must contain no consecutive repetition of the same character as 111 or aab",
"Password must be different from the user login" => "La contrasenya ha de ser diferent del nom d'usuari",
// "Payment" => "Payment",
// "Feature to manage and track payment requests" => "Feature to manage and track payment requests",
"Payment System" => "Sistema de Pagament",
"Currently a choice between PayPal, and Cclite (in development), or Tiki User Credits" => "Actualment s'ha d'escollir entre PayPal, i Cclite (en desenvolupament), o Crèdits d'Usuari de Tiki",
"PayPal: see PayPal.com - Cclite: Community currency" => "PayPal: consulta PayPal.com - Cclite: Monedes Comunitàries",
"PayPal" => "PayPal",
"Cclite" => "Cclite",
// "Paypal Business ID" => "Paypal Business ID",
// "Enable payments through paypal" => "Enable payments through paypal",
"Email address" => "Adreça de correu-e",
// "Paypal Environment" => "Paypal Environment",
// "Used to switch between the paypal sandbox, used for testing and development and the live environment" => "Used to switch between the paypal sandbox, used for testing and development and the live environment",
// "Production" => "Production",
// "Paypal Instant Payment Notification (IPN)" => "Paypal Instant Payment Notification (IPN)",
// "Enable IPN for automatic payment completion. When enabled, Paypal will ping back the site when a payment is confirmed. The payment will then be entered automatically. This may not be possible if the server is not on a public server" => "Enable IPN for automatic payment completion. When enabled, Paypal will ping back the site when a payment is confirmed. The payment will then be entered automatically. This may not be possible if the server is not on a public server",
"Currency used when entering payments" => "Moneda emprada en introduir els pagaments",
"Default acceptable payment delay" => "Retard acceptable per omissió per a fer els pagaments",
"Amount of days before the payment requests becomes overdue. This can be changed per payment request" => "Nombre de dies abans que la petició de pagament passi de termini. Això es pot canviar a cada petició de pagament",
"Cclite Registries" => "Registres (Xarxes d'intercanvi) de Cclite",
// "Registries in Cclite" => "Registries in Cclite",
"Registry names in Cclite" => "Noms de registres (xarxes d'intercanvi) a Cclite",
"Cclite Registry Currencies" => "Monedes de cada registre (xarxa d'intercanvi) de Cclite",
// "Currencies in Cclite" => "Currencies in Cclite",
"Each registry in Cclite can have it's own currency. Must be one per registry. (case sensitive)" => "Cada registre (xarxa d'intercanvi) a Cclite pot tenir la seva pròpia moneda. Ha de ser una per registre (xarxa d'intercanvi). (sensible a majúscules/minúscules)",
"Cclite Server URL" => "URL del servidor de Cclite",
"Full URL of the repository" => "URL sencera del dipòsit (repositori)",
"e.g. https://cclite.yourdomain.org/cclite/" => "e.g. https://cclite.elteudomini.org/cclite/",
"Cclite Merchant Key" => "Clau de Comerç de Cclite",
"Corresponds with Merchant Key setting in Cclite" => "Correspon al paràmetre de Clau de Comerç (Merchant Key) a Cclite",
"Cclite Merchant User" => "Usuari de Comerç de Cclite",
"User name in Cclite representing \"the management\". Defaults to \"manager\"" => "Nom d'usuari a Cclite representant a \"la gestió\". Per omissió és el \"manager\" (gestor)",
"Cclite Enable Payments" => "Cclite Habilita Pagaments",
"Test or Live operation" => "Operació de proves o en viu",
"Live" => "En viu",
"Hashing Algorithm" => "Algoritme de xifratge (Hashing Algorithm)",
"Encryption type" => "Tipus de xifratge",
"SHA1" => "SHA1",
"SHA256" => "SHA256",
"SHA512" => "SHA512",
"Cclite Payment Notification" => "Notificació de Pagament de Cclite",
// "TODO" => "TODO",
// "Wiki page containing the instruction to send manual payment like check" => "Wiki page containing the instruction to send manual payment like check",
"Wiki page" => "Plana Wiki",
// "Prefix to the invoice" => "Prefix to the invoice",
// "Prefix must be set and unique if the same paypal account is used for different tiki sites as paypal checks that the invoice is not paid twice" => "Prefix must be set and unique if the same paypal account is used for different tiki sites as paypal checks that the invoice is not paid twice",
// "Types of credit to use" => "Types of credit to use",
// "This is a list of the types of Tiki user credits to accept to pay with" => "This is a list of the types of Tiki user credits to accept to pay with",
// "Exchange rate for types of credit to use" => "Exchange rate for types of credit to use",
// "This is a corresponding list of amount of credits equivalent to 1 of the payment currency" => "This is a corresponding list of amount of credits equivalent to 1 of the payment currency",
// "User can only see his own outstanding payments" => "User can only see his own outstanding payments",
// "Unless with administer payment permissions, a user can only see his own outstanding payments" => "Unless with administer payment permissions, a user can only see his own outstanding payments",
// "User can only see his own past or cancelled payments" => "User can only see his own past or cancelled payments",
// "Unless with administer payment permissions, a user can only see his own past or cancelled payments" => "Unless with administer payment permissions, a user can only see his own past or cancelled payments",
// "Manage product inventory" => "Manage product inventory",
// "Activate product inventory feature, needs Products tracker to be set up properly, the itemId must be the product code" => "Activate product inventory feature, needs Products tracker to be set up properly, the itemId must be the product code",
// "Products Tracker ID" => "Products Tracker ID",
// "Tracker ID of tracker that is the Products tracker, needed for advanced cart features, the itemId will be the product code" => "Tracker ID of tracker that is the Products tracker, needed for advanced cart features, the itemId will be the product code",
// "Products Tracker Name" => "Products Tracker Name",
// "Name of tracker that is the Products tracker, needed for advanced cart features, the itemId will be the product code" => "Name of tracker that is the Products tracker, needed for advanced cart features, the itemId will be the product code",
// "Inventory Type Field ID" => "Inventory Type Field ID",
// "Field ID in Products tracker to store the inventory type, the value of the field must be \"none\" or \"internal\"" => "Field ID in Products tracker to store the inventory type, the value of the field must be \"none\" or \"internal\"",
// "Inventory Total Field ID" => "Inventory Total Field ID",
// "Field ID in Products tracker to store the total inventory of product" => "Field ID in Products tracker to store the total inventory of product",
// "Inventory Total Less Hold Field ID" => "Inventory Total Less Hold Field ID",
// "Field ID in Products tracker to store the total inventory of product less the amount on hold because they are currently in carts" => "Field ID in Products tracker to store the total inventory of product less the amount on hold because they are currently in carts",
// "Inventory Hold Timeout (minutes)" => "Inventory Hold Timeout (minutes)",
// "Minutes to hold inventory before making it available again when there is no user cart action" => "Minutes to hold inventory before making it available again when there is no user cart action",
// "Bundled products feature for cart" => "Bundled products feature for cart",
// "Activate bundled products feature, needs Products tracker to be set up properly, the itemId must be the product code" => "Activate bundled products feature, needs Products tracker to be set up properly, the itemId must be the product code",
// "Product Name Field Name" => "Product Name Field Name",
// "Field Name in Products tracker of the product name that will be used as the label of the product, e.g. in a bundle" => "Field Name in Products tracker of the product name that will be used as the label of the product, e.g. in a bundle",
// "Items in Bundle Field Name" => "Items in Bundle Field Name",
// "Field Name in Products tracker of a comma separated list of product IDs of products in the bundle (i.e. if the field contains anything, then this product is a bundle), you can also specify the number of the sub-products, e.g. 23:(\"colon\")2,24 means item 23 (x2) + item 24 (x1)" => "Field Name in Products tracker of a comma separated list of product IDs of products in the bundle (i.e. if the field contains anything, then this product is a bundle), you can also specify the number of the sub-products, e.g. 23:(\"colon\")2,24 means item 23 (x2) + item 24 (x1)",
// "Product Price Field Name" => "Product Price Field Name",
// "Field Name in Products tracker of the product price" => "Field Name in Products tracker of the product price",
// "Associated Event ID Field Name" => "Associated Event ID Field Name",
// "Field Name in Products tracker of the Associated Event ID, needed for the Associated Events cart feature, requires an Events tracker to be setup where the item ID there is the event ID to associate to" => "Field Name in Products tracker of the Associated Event ID, needed for the Associated Events cart feature, requires an Events tracker to be setup where the item ID there is the event ID to associate to",
// "Product Class ID Field Name" => "Product Class ID Field Name",
// "Field Name in Products tracker of the Product Class ID, needed for the Gift Certificates cart feature" => "Field Name in Products tracker of the Product Class ID, needed for the Gift Certificates cart feature",
// "Gift Certificate Template Field Name" => "Gift Certificate Template Field Name",
// "Field Name in Products tracker of the Gift Cert Template, needed for the Gift Certificates cart feature" => "Field Name in Products tracker of the Gift Cert Template, needed for the Gift Certificates cart feature",
// "Record cart orders in trackers (registered users)" => "Record cart orders in trackers (registered users)",
// "This feature requires 2 trackers, and Orders tracker and an Orders Item tracker to be configured. It also needs profiles to be configured to do the recording" => "This feature requires 2 trackers, and Orders tracker and an Orders Item tracker to be configured. It also needs profiles to be configured to do the recording",
// "Orders Profile" => "Orders Profile",
// "Wiki page where the profile for creating orders is (page name must be without spaces)" => "Wiki page where the profile for creating orders is (page name must be without spaces)",
// "Order Item Profile" => "Order Item Profile",
// "Wiki page where the profile for creating orders items is (page name must be without spaces)" => "Wiki page where the profile for creating orders items is (page name must be without spaces)",
// "Allow anonymous shopping and record their orders in trackers" => "Allow anonymous shopping and record their orders in trackers",
// "Allows shopping as anonymous user" => "Allows shopping as anonymous user",
// "Anonymous Orders Profile" => "Anonymous Orders Profile",
// "Wiki page where the profile for creating orders for Anonymous users is (page name must be without spaces)" => "Wiki page where the profile for creating orders for Anonymous users is (page name must be without spaces)",
// "Anonymous Order Item Profile" => "Anonymous Order Item Profile",
// "Wiki page where the profile for creating orders items for Anonymous users is (page name must be without spaces)" => "Wiki page where the profile for creating orders items for Anonymous users is (page name must be without spaces)",
// "Anonymous Shopper Info Profile" => "Anonymous Shopper Info Profile",
// "Anonymous Users Order Review Page" => "Anonymous Users Order Review Page",
// "Wiki page where Anonymous users can review their orders)" => "Wiki page where Anonymous users can review their orders)",
// "Temporary Shopper Group to Access Review Page via Token" => "Temporary Shopper Group to Access Review Page via Token",
// "Group name of group with perms to access review page via token" => "Group name of group with perms to access review page via token",
// "Allow association of product orders to events (or projects etc...)" => "Allow association of product orders to events (or projects etc...)",
// "Allow association of products to events (or projects etc...)" => "Allow association of products to events (or projects etc...)",
// "Events Tracker ID" => "Events Tracker ID",
// "Tracker ID of tracker that is the Events tracker" => "Tracker ID of tracker that is the Events tracker",
// "Events Tracker Name" => "Events Tracker Name",
// "Name of tracker that is the Events tracker" => "Name of tracker that is the Events tracker",
// "Event Start Field Name" => "Event Start Field Name",
// "Field Name in Events tracker of start date/time" => "Field Name in Events tracker of start date/time",
// "Event End Field Name" => "Event End Field Name",
// "Field Name in Events tracker of end date/time" => "Field Name in Events tracker of end date/time",
// "Allow exchange of products" => "Allow exchange of products",
// "Order Items Tracker ID" => "Order Items Tracker ID",
// "Tracker ID of tracker that is the Order Items tracker" => "Tracker ID of tracker that is the Order Items tracker",
// "Gift certificates" => "Gift certificates",
// "Gift Certificates" => "Gift Certificates",
// "Gift Certificate Tracker ID" => "Gift Certificate Tracker ID",
// "Tracker ID of tracker that is the Gift Certificate tracker" => "Tracker ID of tracker that is the Gift Certificate tracker",
// "Gift Certificate Tracker Name" => "Gift Certificate Tracker Name",
// "Name of tracker that is the Gift Certificate tracker" => "Name of tracker that is the Gift Certificate tracker",
// "Orders Tracker Name" => "Orders Tracker Name",
// "Name of tracker that is the Orders tracker" => "Name of tracker that is the Orders tracker",
// "Order Items Tracker Name" => "Order Items Tracker Name",
// "Name of tracker that is the Order Items tracker" => "Name of tracker that is the Order Items tracker",
// "Product Classes Tracker Name" => "Product Classes Tracker Name",
// "Name of tracker that is the Product Classes tracker" => "Name of tracker that is the Product Classes tracker",
// "Send to URL" => "Send to URL",
// "On permission denied, display login module (for Anonymous)" => "On permission denied, display login module (for Anonymous)",
// "PHP libxml extension" => "PHP libxml extension",
// "This extension requires the libxml PHP extension.\n\t\t\t\t\t\t\tThis means that passing in --enable-libxml is also required, although this is\n\t\t\t\t\t\t\timplicitly accomplished because libxml is enabled by default" => "This extension requires the libxml PHP extension.\n\t\t\t\t\t\t\tThis means that passing in --enable-libxml is also required, although this is\n\t\t\t\t\t\t\timplicitly accomplished because libxml is enabled by default",
// "PHP DateTime" => "PHP DateTime",
// "DateTime class (and related functions) are enabled\n\t\t\t\t\t\t\tby default since PHP 5.2.0, it is possible to add experimental support into PHP\n\t\t\t\t\t\t\t5.1.x by using the following flag before configure/compile:\n\t\t\t\t\t\t\tCFLAGS=-DEXPERIMENTAL_DATE_SUPPORT=1" => "DateTime class (and related functions) are enabled\n\t\t\t\t\t\t\tby default since PHP 5.2.0, it is possible to add experimental support into PHP\n\t\t\t\t\t\t\t5.1.x by using the following flag before configure/compile:\n\t\t\t\t\t\t\tCFLAGS=-DEXPERIMENTAL_DATE_SUPPORT=1",
"Show categories" => "Mostra categories",
"Show objects" => "Mostra objectes",
// "Multiple polls per object" => "Multiple polls per object",
// "When used with the rating features, allow multiple polls to be attached to a single object" => "When used with the rating features, allow multiple polls to be attached to a single object",
// "PDF from URL" => "PDF from URL",
// "Using extenal tools, generate PDF document from web URLs" => "Using extenal tools, generate PDF document from web URLs",
// "WebKit (wkhtmltopdf)" => "WebKit (wkhtmltopdf)",
// "Webservice URL" => "Webservice URL",
// "URL to a service taking a URL as the query string and returns a PDF document" => "URL to a service taking a URL as the query string and returns a PDF document",
// "WebKit path" => "WebKit path",
// "Full path to the wkhtmltopdf executable to generate the PDF document with" => "Full path to the wkhtmltopdf executable to generate the PDF document with",
// "Repository URLs" => "Repository URLs",
// "List of URLs for the profile repositories that will be used" => "List of URLs for the profile repositories that will be used",
// "Enter multiple repository URLs, one per line" => "Enter multiple repository URLs, one per line",
// "Data Channels" => "Data Channels",
// "Data channels are templates that can be applied from a post request. They can be used to automate work on more complex installations" => "Data channels are templates that can be applied from a post request. They can be used to automate work on more complex installations",
// "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain __channel name, domain, profile, allowed groups, (optional) \$profilerequest:input\$ matches to groups__" => "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain __channel name, domain, profile, allowed groups, (optional) \$profilerequest:input\$ matches to groups__",
// "There are security considerations related to using data channels. Make sure the profile page is controlled by administrators only" => "There are security considerations related to using data channels. Make sure the profile page is controlled by administrators only",
// "Developer mode" => "Developer mode",
// "For profiles under an approval workflow, always use the latest version, even if not approved" => "For profiles under an approval workflow, always use the latest version, even if not approved",
// "Make sure you review the profiles you install" => "Make sure you review the profiles you install",
// "Proxy host name" => "Proxy host name",
// "Proxy host - without http:// or similar, just the host name" => "Proxy host - without http:// or similar, just the host name",
"Proxy port" => "Port del Proxy",
// "Proxy username" => "Proxy username",
// "Proxy password" => "Proxy password",
"Quantify change size" => "Quantifica la mida del canvi",
// "In addition to tracking the changes, track the change size and display the approximate up-to-date-ness of the page" => "In addition to tracking the changes, track the change size and display the approximate up-to-date-ness of the page",
// "Advanced Rating" => "Advanced Rating",
// "Rating system allowing for options and calculation method to be configured" => "Rating system allowing for options and calculation method to be configured",
// "Rating recalculation mode" => "Rating recalculation mode",
// "Determines when and how rating aggregates are recalculated. Depending on the site load, some options may be preferred to others. On large volume sites, it should be done as a cron job. On vote recalculation may be inaccurate if rating calculation depends time" => "Determines when and how rating aggregates are recalculated. Depending on the site load, some options may be preferred to others. On large volume sites, it should be done as a cron job. On vote recalculation may be inaccurate if rating calculation depends time",
// "Recalculate on vote" => "Recalculate on vote",
// "Randomly recalculate oldest ratings (on load)" => "Randomly recalculate oldest ratings (on load)",
// "Randomly recalculate oldest ratings (on vote)" => "Randomly recalculate oldest ratings (on vote)",
// "Cron job (must be set manually)" => "Cron job (must be set manually)",
// "Recalculation odds (1 in X)" => "Recalculation odds (1 in X)",
// "Dice roll performed on every request. When successful, will recalculate a certain number of votes" => "Dice roll performed on every request. When successful, will recalculate a certain number of votes",
// "Recalculation count" => "Recalculation count",
// "How many ratings should be recalculated when odds strike" => "How many ratings should be recalculated when odds strike",
// "Use ReCaptcha" => "Use ReCaptcha",
// "Use ReCaptcha, a specialized captcha service, instead of default CAPTCHA" => "Use ReCaptcha, a specialized captcha service, instead of default CAPTCHA",
// "You will need to register at [http://www.google.com/recaptcha]" => "You will need to register at [http://www.google.com/recaptcha]",
// "Public Key" => "Public Key",
// "ReCaptcha public key" => "ReCaptcha public key",
// "Private Key" => "Private Key",
// "ReCaptcha private key" => "ReCaptcha private key",
"Record untranslated strings" => "Registre no traduït",
// "Keep track of the unsuccessful attemps to translate strings" => "Keep track of the unsuccessful attemps to translate strings",
"Restrict supported languages" => "Restringeix els idiomes suportats",
// "Limit the languages made available on the site" => "Limit the languages made available on the site",
// "SCORM Support" => "SCORM Support",
// "Handle SCORM package files on upload. SCORM is a standard used in Learning Management Systems" => "Handle SCORM package files on upload. SCORM is a standard used in Learning Management Systems",
// "SCORM Tracker" => "SCORM Tracker",
// "Tracker ID to use to store the SCORM metadata" => "Tracker ID to use to store the SCORM metadata",
// "Parse the results" => "Parse the results",
// "Default where" => "Default where",
// "When object filter is not on, limit to search one type of object" => "When object filter is not on, limit to search one type of object",
"Entire site" => "Lloc complet",
"Wiki Pages" => "Pàgines del wiki",
"Blog Posts" => "Publicacions de bitàcoles",
"Tracker Items" => "Punts del formulari",
"Spreadsheets" => "Fulls de càlcul",
// "Restrict search language by default" => "Restrict search language by default",
// "If enabled, only search content in the interface language, otherwise show language menu" => "If enabled, only search content in the interface language, otherwise show language menu",
// "Autocomplete on page names" => "Autocomplete on page names",
// "Category filter" => "Category filter",
// "Tag filter" => "Tag filter",
// "Parse wiki syntax in comments in all sections apart from Forums" => "Parse wiki syntax in comments in all sections apart from Forums",
// "Use \"Accept wiki syntax\" for forums in admin forums page" => "Use \"Accept wiki syntax\" for forums in admin forums page",
"Sender email" => "correu-e de l'enviador",
// "Email address that will be used as the sender for outgoing emails" => "Email address that will be used as the sender for outgoing emails",
// "Time zone" => "Time zone",
// "Indicates the default time zone to use for the server" => "Indicates the default time zone to use for the server",
// "Session storage location" => "Session storage location",
// "Select where the session information should be stored. Memcache sessions require memcache to be configured" => "Select where the session information should be stored. Memcache sessions require memcache to be configured",
// "Default (from php.ini)" => "Default (from php.ini)",
"Database" => "Base de Dades",
// "Session lifetime" => "Session lifetime",
// "Value provided in minutes. It will be the minimum time you are logged in. If you want it to be the exact time, you need to adjust in .htaccess session.gc_probability and session.gc_divisor to 1. Be careful that changing the probability will affect the server performance" => "Value provided in minutes. It will be the minimum time you are logged in. If you want it to be the exact time, you need to adjust in .htaccess session.gc_probability and session.gc_divisor to 1. Be careful that changing the probability will affect the server performance",
// "Silent session" => "Silent session",
// "Do not automatically start sessions" => "Do not automatically start sessions",
// "Users will only have a session if they log in. So anonymous users will lose the capacity to have things like Switch Language (a session is needed for this)" => "Users will only have a session if they log in. So anonymous users will lose the capacity to have things like Switch Language (a session is needed for this)",
// "Session cookie name" => "Session cookie name",
// "Session cookie name used instead of the PHP default configuration" => "Session cookie name used instead of the PHP default configuration",
// "Protect all sessions with HTTPS" => "Protect all sessions with HTTPS",
// "Always redirect to HTTPS to prevent session hijack through network sniffing" => "Always redirect to HTTPS to prevent session hijack through network sniffing",
// "Only activate if you have already configured SSL, otherwise, your will lock yourself out of Tiki" => "Only activate if you have already configured SSL, otherwise, your will lock yourself out of Tiki",
// "Display links in the share page" => "Display links in the share page",
// "Token notification" => "Token notification",
// "Users can subscribe to the notifications of consultation of the token" => "Users can subscribe to the notifications of consultation of the token",
// "Add contact" => "Add contact",
// "If not exist, recipients are add in the list of contacts" => "If not exist, recipients are add in the list of contacts",
// "Display name and email" => "Display name and email",
// "If user is connect, name and email display in the page" => "If user is connect, name and email display in the page",
// "How many times accessed" => "How many times accessed",
// "User can choose how many times the share page can be consulted" => "User can choose how many times the share page can be consulted",
// "Max how many times accessed" => "Max how many times accessed",
// "Maximum number of times that the shared page can be consulted" => "Maximum number of times that the shared page can be consulted",
// "Default group" => "Default group",
// "Create with default group" => "Create with default group",
// "Valid affiliations" => "Valid affiliations",
// "Separate multiple affiliations with commas" => "Separate multiple affiliations with commas",
// "Shipping Service" => "Shipping Service",
// "Expose a JSON shipping rate estimation service. Accounts from providers may be required (FedEx, UPS, ...)" => "Expose a JSON shipping rate estimation service. Accounts from providers may be required (FedEx, UPS, ...)",
// "FedEx API" => "FedEx API",
// "Enable shipping rate calculation through FedEx APIs" => "Enable shipping rate calculation through FedEx APIs",
// "FedEx Key" => "FedEx Key",
// "Developer Key" => "Developer Key",
// "FedEx Password" => "FedEx Password",
// "FedEx Meter Number" => "FedEx Meter Number",
// "FedEx Account Number" => "FedEx Account Number",
// "UPS API" => "UPS API",
// "Enable shipping rate calculation using the UPS carrier" => "Enable shipping rate calculation using the UPS carrier",
// "UPS Username" => "UPS Username",
// "UPS credentials" => "UPS credentials",
// "UPS Password" => "UPS Password",
// "UPS Access Key" => "UPS Access Key",
// "Custom Shipping Provider" => "Custom Shipping Provider",
"Short date format" => "Format curt de data",
"Short time format" => "Format curt d'hora",
// "%Y-%m-%d" => "%Y-%m-%d",
// "%H:%M" => "%H:%M",
// "%Y-%m-%d %H:%M" => "%Y-%m-%d %H:%M",
// "Display available translations" => "Display available translations",
// "" => "",
// "Close site (except for those with permission)" => "Close site (except for those with permission)",
// "Message to display" => "Message to display",
// "Locations (breadcrumbs)" => "Locations (breadcrumbs)",
// "Choices" => "Choices",
// "Site title location" => "Site title location",
// "Location of the site title in the browser title bar relative to the current page's descriptor" => "Location of the site title in the browser title bar relative to the current page's descriptor",
"After" => "Després de",
"Before" => "Abans de",
// "Browser title display mode" => "Browser title display mode",
// "When breadcrumbs are used, method in which the browser title should be displayed" => "When breadcrumbs are used, method in which the browser title should be displayed",
// "Most specific first" => "Most specific first",
// "Least specific first (site)" => "Least specific first (site)",
// "Current only" => "Current only",
// "Favicon icon file name" => "Favicon icon file name",
// "Favicon MIME type" => "Favicon MIME type",
// "Typical file extensions:<table><tr><td>image/jpeg</td><td><strong>.jpg</strong></td></tr><tr><td>imp/png</td><td><strong>.png</strong></td></tr><tr><td>img/gif</td><td><strong>.gif</strong></td></tr><tr><td>image/vnd.microsoft.icon</td><td><strong>.ico</strong></td></tr></table>" => "Typical file extensions:<table><tr><td>image/jpeg</td><td><strong>.jpg</strong></td></tr><tr><td>imp/png</td><td><strong>.png</strong></td></tr><tr><td>img/gif</td><td><strong>.gif</strong></td></tr><tr><td>image/vnd.microsoft.icon</td><td><strong>.ico</strong></td></tr></table>",
// "image/jpeg" => "image/jpeg",
"image/png" => "imatge/png",
// "image/gif" => "image/gif",
// "image/vnd.microsoft.icon" => "image/vnd.microsoft.icon",
// "Site Terminal" => "Site Terminal",
// "Allows to direct users to a specific perspective depending on the origin IP address. Can be used inside intranets to use different configurations for users depending on their departements or discriminate people in web contexts. Unspecified IPs will fall back to default behavior, including multi-domain handling. Manually selected perspectives take precedence over this" => "Allows to direct users to a specific perspective depending on the origin IP address. Can be used inside intranets to use different configurations for users depending on their departements or discriminate people in web contexts. Unspecified IPs will fall back to default behavior, including multi-domain handling. Manually selected perspectives take precedence over this",
// "Site Terminal Configuration" => "Site Terminal Configuration",
// "Provides the mapping from subnets to perspective" => "Provides the mapping from subnets to perspective",
// "One per line. Network prefix in CIDR notation (address/mask size), separated by comma with the perspective ID" => "One per line. Network prefix in CIDR notation (address/mask size), separated by comma with the perspective ID",
"Publish" => "Publica",
// "Logo source (image path)" => "Logo source (image path)",
// "Logo background color" => "Logo background color",
"Examples" => "Exemples",
// "Logo title (on mouse over)" => "Logo title (on mouse over)",
"Alt. description (e.g. for text browsers)" => "Descripció alt. (p.e. per navegadors basats en text)",
// "Include smarty notices in PHP error report" => "Include smarty notices in PHP error report",
// "In most cases, smarty notices can be safely ignored. However, they may be useful in the development process when strange issues occur" => "In most cases, smarty notices can be safely ignored. However, they may be useful in the development process when strange issues occur",
// "Smarty Security" => "Smarty Security",
// "Do not allow php code in smarty templates" => "Do not allow php code in smarty templates",
// "You should leave this on unless you know what you are doing" => "You should leave this on unless you know what you are doing",
// "Smarty Compilation" => "Smarty Compilation",
// "Indicates when the template cache should be refreshed" => "Indicates when the template cache should be refreshed",
"Modified" => "Modificat",
// "Never check (performance)" => "Never check (performance)",
// "Always (development, slow)" => "Always (development, slow)",
// "Consumer key" => "Consumer key",
// "Consumer key generated by registering your site as an application at Twitter" => "Consumer key generated by registering your site as an application at Twitter",
// "Consumer secret" => "Consumer secret",
// "Consumer secret generated by registering your site as an application at Twitter" => "Consumer secret generated by registering your site as an application at Twitter",
// "Application secret" => "Application secret",
// "Application secret generated by registering your site as an application at Facebook" => "Application secret generated by registering your site as an application at Facebook",
// "Application ID" => "Application ID",
// "Application id generated by registering your site as an application at Facebook" => "Application id generated by registering your site as an application at Facebook",
// "Login using Facebook" => "Login using Facebook",
// "Allow users to login using Facebook" => "Allow users to login using Facebook",
// "Auto-create Tiki user" => "Auto-create Tiki user",
// "Automatically create a Tiki user by the username of fb_xxxxxxxx for users logging in using Facebook if they do not yet have a Tiki account. If not, they will be asked to link or register a Tiki account" => "Automatically create a Tiki user by the username of fb_xxxxxxxx for users logging in using Facebook if they do not yet have a Tiki account. If not, they will be asked to link or register a Tiki account",
// "Require Facebook users to enter local account info" => "Require Facebook users to enter local account info",
// "Require Facebook users to enter local account info, specifically email and local login name" => "Require Facebook users to enter local account info, specifically email and local login name",
// "Tiki can access Facebook at any time" => "Tiki can access Facebook at any time",
// "Even when user is not logged onto Facebook, Tiki can access it" => "Even when user is not logged onto Facebook, Tiki can access it",
// "Tiki can post to Wall" => "Tiki can post to Wall",
// "Tiki may post status messages, notes, photos, and videos to Facebook Wall" => "Tiki may post status messages, notes, photos, and videos to Facebook Wall",
// "Tiki can manage events" => "Tiki can manage events",
// "Tiki may create and RSVP to Facebook events" => "Tiki may create and RSVP to Facebook events",
// "Tiki can manage pages" => "Tiki can manage pages",
// "Tiki may manage user pages" => "Tiki may manage user pages",
// "Tiki can SMS" => "Tiki can SMS",
// "Tiki may SMS via Facebook" => "Tiki may SMS via Facebook",
// "bit.ly Login" => "bit.ly Login",
// "Site wide login (username) for bit.ly" => "Site wide login (username) for bit.ly",
// "bit.ly Key" => "bit.ly Key",
// "Site wide API key for bit.ly" => "Site wide API key for bit.ly",
// "Use site-wide account" => "Use site-wide account",
// "When setting this option to yes, only the site wide account will be used for all users" => "When setting this option to yes, only the site wide account will be used for all users",
// "Theme options" => "Theme options",
// "Style options" => "Style options",
// "New.." => "New..",
// "Theme Generator" => "Theme Generator",
// "Permits to adjust colors and fonts via the browser" => "Permits to adjust colors and fonts via the browser",
// "Custom Theme" => "Custom Theme",
// "Description needed" => "Description needed",
"Check frequency" => "Freqüència de comprovació",
"Each day" => "Cada dia",
"Each week" => "Cada setmana",
"Each month" => "Cada mes",
// "Minify JavaScript" => "Minify JavaScript",
// "Compress JavaScript files used in the page into a single file to be distributed statically. Changes to JavaScript files will require cache to be cleared. Uses http://code.google.com/p/minify/" => "Compress JavaScript files used in the page into a single file to be distributed statically. Changes to JavaScript files will require cache to be cleared. Uses http://code.google.com/p/minify/",
// "Minify CSS" => "Minify CSS",
// "Compress CSS files by removing additional spaces and grouping multiple files into one. Changes to CSS files will require cache to be cleared. Uses http://code.google.com/p/minify/" => "Compress CSS files by removing additional spaces and grouping multiple files into one. Changes to CSS files will require cache to be cleared. Uses http://code.google.com/p/minify/",
// "Minify CSS into a single file" => "Minify CSS into a single file",
// "In addition to reducing the size of the CSS, reduce the number of included files" => "In addition to reducing the size of the CSS, reduce the number of included files",
// "This setting may not work out of the box for all styles. import needs to use @import url(\"...\") and not @import \"...\"" => "This setting may not work out of the box for all styles. import needs to use @import url(\"...\") and not @import \"...\"",
// "Skip date for same day" => "Skip date for same day",
// "When displaying short date and time, skip date for today. Only time will be displayed" => "When displaying short date and time, skip date for today. Only time will be displayed",
// "Cache-Control header" => "Cache-Control header",
// "Custom HTTP header to use when a session is active" => "Custom HTTP header to use when a session is active",
// "Example: no-cache, pre-check=0, post-check=0" => "Example: no-cache, pre-check=0, post-check=0",
// "Cache-Control header (no session)" => "Cache-Control header (no session)",
// "Custom HTTP header to use when no session is active" => "Custom HTTP header to use when no session is active",
// "Content Delivery Network" => "Content Delivery Network",
// "Use an alternate domain name to serve static files from tiki to avoid sending cookies, improve local caching and generally improve user experience performance" => "Use an alternate domain name to serve static files from tiki to avoid sending cookies, improve local caching and generally improve user experience performance",
// "Prefix to include before the static files, for example: http://cdn.example.com" => "Prefix to include before the static files, for example: http://cdn.example.com",
// "Content Delivery Network (in SSL)" => "Content Delivery Network (in SSL)",
// "Use an alternate domain name to serve static files from tiki to avoid sending cookies, improve local caching and generally improve user experience performance. Leave empty to disable CDN in SSL mode" => "Use an alternate domain name to serve static files from tiki to avoid sending cookies, improve local caching and generally improve user experience performance. Leave empty to disable CDN in SSL mode",
// "Prefix to include before the static files, for example: https://cdn.example.com" => "Prefix to include before the static files, for example: https://cdn.example.com",
// "Domain prefix handling" => "Domain prefix handling",
// "Strip or automatically add the \"www.\" prefix on domain names to standardize URLs" => "Strip or automatically add the \"www.\" prefix on domain names to standardize URLs",
// "Leave as-is" => "Leave as-is",
// "Remove the www" => "Remove the www",
// "Add the www" => "Add the www",
// "Domain redirects" => "Domain redirects",
// "When the site is accessed through specific domain names, redirect to an alternate domain preserving the URL. Useful for domain name transitions, like tikiwiki.org to tiki.org" => "When the site is accessed through specific domain names, redirect to an alternate domain preserving the URL. Useful for domain name transitions, like tikiwiki.org to tiki.org",
// "One entry per line. Comma separated list: old, new" => "One entry per line. Comma separated list: old, new",
// "Validate uploaded file content" => "Validate uploaded file content",
// "Do not trust user input and open the files to verify their content" => "Do not trust user input and open the files to verify their content",
// "Allow the tiki_p_trust_input permission" => "Allow the tiki_p_trust_input permission",
// "Bypasses user input filtering" => "Bypasses user input filtering",
// "Note, all permissions are granted to the Admins group including this one, so if you enable this you may expose your site to XSS (Cross Site Scripting) attacks for admin users" => "Note, all permissions are granted to the Admins group including this one, so if you enable this you may expose your site to XSS (Cross Site Scripting) attacks for admin users",
// "Synchronize Remote Tracker" => "Synchronize Remote Tracker",
// "Allows to clone a tracker on a remote host and synchronize the data locally on demand" => "Allows to clone a tracker on a remote host and synchronize the data locally on demand",
// "Refresh item link items when master is modified" => "Refresh item link items when master is modified",
// "To be used when item link is used in trackers so that the index remains in good shape when data on the master that is indexed with the detail is modified and used to search on" => "To be used when item link is used in trackers so that the index remains in good shape when data on the master that is indexed with the detail is modified and used to search on",
// "Unified Search Engine" => "Unified Search Engine",
// "Search engine used to index the content of your Tiki. Some engines are more suitable for larger sites, but require additional software on the server" => "Search engine used to index the content of your Tiki. Some engines are more suitable for larger sites, but require additional software on the server",
// "Lucene (PHP Implementation)" => "Lucene (PHP Implementation)",
// "Lucene Index Location" => "Lucene Index Location",
// "Path to the location of the Lucene search index. The index must be on a local filesystem with enough space to contain the volume of the database" => "Path to the location of the Lucene search index. The index must be on a local filesystem with enough space to contain the volume of the database",
// "Highlight results snippets" => "Highlight results snippets",
// "Highlight the result snippet based on the search query. Enabling this option will impact performance, but improve user experience" => "Highlight the result snippet based on the search query. Enabling this option will impact performance, but improve user experience",
// "Lucene Maximum Results" => "Lucene Maximum Results",
// "Maximum amount of results to expose. Results further than these will need a more refined query to be reached" => "Maximum amount of results to expose. Results further than these will need a more refined query to be reached",
// "Lucene Maximum Result Set Limit" => "Lucene Maximum Result Set Limit",
// "Maximum size of result set to consider. Default 1000, 0 = unlimited" => "Maximum size of result set to consider. Default 1000, 0 = unlimited",
// "This is used when calculating result scores and sort order which can lead to out of memory errors on large data sets. The default of 1000 is safe with the PHP memory_limit set to 128M" => "This is used when calculating result scores and sort order which can lead to out of memory errors on large data sets. The default of 1000 is safe with the PHP memory_limit set to 128M",
// "Lucene Terms Per Query Limit" => "Lucene Terms Per Query Limit",
// "Maximum number of terms to be generated. Try increasing this value if you get errors saying \"Terms per query limit is reached\" espescially with wildcard, range and fuzzy searches" => "Maximum number of terms to be generated. Try increasing this value if you get errors saying \"Terms per query limit is reached\" espescially with wildcard, range and fuzzy searches",
// "Lucene Max Buffered Documents" => "Lucene Max Buffered Documents",
// "Number of documents required before the buffered in-memory documents are written into a new segment" => "Number of documents required before the buffered in-memory documents are written into a new segment",
// "Lucene Max Merge Documents" => "Lucene Max Merge Documents",
// "Largest number of documents ever merged by addDocument(). Small values (e.g., less than 10,000) are best for interactive indexing, as this limits the length of pauses while indexing to a few seconds. Larger values are best for batched indexing and speedier searches" => "Largest number of documents ever merged by addDocument(). Small values (e.g., less than 10,000) are best for interactive indexing, as this limits the length of pauses while indexing to a few seconds. Larger values are best for batched indexing and speedier searches",
// "Small values (e.g., less than 10,000) are best for interactive indexing. Use 0 for the Lucene default, which is practically infinite" => "Small values (e.g., less than 10,000) are best for interactive indexing. Use 0 for the Lucene default, which is practically infinite",
// "Lucene Default Boolean Operator" => "Lucene Default Boolean Operator",
// "Use OR (default) or AND as the default search operator" => "Use OR (default) or AND as the default search operator",
// "OR" => "OR",
// "AND" => "AND",
// "Lucene Merge Factor" => "Lucene Merge Factor",
// "How often segment indices are merged by addDocument(). With smaller values, less RAM is used while indexing, and searches on unoptimized indices are faster, but indexing speed is slower. With larger values, more RAM is used during indexing, and while searches on unoptimized indices are slower, indexing is faster. Thus larger values (> 10) are best for batch index creation, and smaller values (< 10) for indices that are interactively maintained" => "How often segment indices are merged by addDocument(). With smaller values, less RAM is used while indexing, and searches on unoptimized indices are faster, but indexing speed is slower. With larger values, more RAM is used during indexing, and while searches on unoptimized indices are slower, indexing is faster. Thus larger values (> 10) are best for batch index creation, and smaller values (< 10) for indices that are interactively maintained",
// "Large values (> 10) are best for batch index creation, and smaller values (< 10) for indices that are interactively maintained" => "Large values (> 10) are best for batch index creation, and smaller values (< 10) for indices that are interactively maintained",
// "Incremental Index Update" => "Incremental Index Update",
// "Update the index incrementally as the site content is modified. This may lead to lower performance and accuracy than processing the index on a periodic basis" => "Update the index incrementally as the site content is modified. This may lead to lower performance and accuracy than processing the index on a periodic basis",
// "Field Weights" => "Field Weights",
// "Allows to set the field weights that apply when ranking the pages for search listing. The weight only applies when the field is in the query. To nullify the value of a field, use an insignificant amount, not 0, which may lead to unexpected behaviors, such as stripping results" => "Allows to set the field weights that apply when ranking the pages for search listing. The weight only applies when the field is in the query. To nullify the value of a field, use an insignificant amount, not 0, which may lead to unexpected behaviors, such as stripping results",
// "One field per line, field_name__:__5.3" => "One field per line, field_name__:__5.3",
// "Default content fields" => "Default content fields",
// "All of the content is aggregated in the contents field. For custom weighting to apply, the fields must be included in the query. This option allows to include other fields in the default content search" => "All of the content is aggregated in the contents field. For custom weighting to apply, the fields must be included in the query. This option allows to include other fields in the default content search",
// "Tokenize version numbers" => "Tokenize version numbers",
// "Tokenize version number strings so that major versions are found when sub-versions are mentionned. For example, searching for 2.7 would return documents containing 2.7.4, but not 1.2.7" => "Tokenize version number strings so that major versions are found when sub-versions are mentionned. For example, searching for 2.7 would return documents containing 2.7.4, but not 1.2.7",
// "Cache per user and query" => "Cache per user and query",
// "Time in minutes a user has a same query cached " => "Time in minutes a user has a same query cached ",
// "In minutes" => "In minutes",
// "Index forum replies together with root post" => "Index forum replies together with root post",
// "If enabled, forum replies will be indexed together with the root post as a single document instead of being separately indexed" => "If enabled, forum replies will be indexed together with the root post as a single document instead of being separately indexed",
// "Search formatters to cache" => "Search formatters to cache",
// "Search formatters to cache the output of" => "Search formatters to cache the output of",
// "Format to use for tracker field keys" => "Format to use for tracker field keys",
// "Choose between field ids and permanent names for the tracker indexing" => "Choose between field ids and permanent names for the tracker indexing",
// "Permanent Name" => "Permanent Name",
// "Field ID (Backward compatibility mode with Tiki 7 and 8)" => "Field ID (Backward compatibility mode with Tiki 7 and 8)",
// "Excluded categories" => "Excluded categories",
// "List of category ids to exclude from the search index" => "List of category ids to exclude from the search index",
// "unsuccessful login attempts" => "unsuccessful login attempts",
// "After a certain number of consecutive unsuccessfull login attempts, the user will receive a mail with instruction to validate his account. However the user can still log-in with his old password" => "After a certain number of consecutive unsuccessfull login attempts, the user will receive a mail with instruction to validate his account. However the user can still log-in with his old password",
// "Suspend account after" => "Suspend account after",
// "After a certain number of consecutive unsuccessfull login attempts, the account is suspended . An admin must revalidate the account before the user can use it again" => "After a certain number of consecutive unsuccessfull login attempts, the account is suspended . An admin must revalidate the account before the user can use it again",
// "URL a user is redirected to after account validation" => "URL a user is redirected to after account validation",
"Account validated successfully." => "Compte validat satisfactòriament.",
// "URL an anonymous is redirected when page not found" => "URL an anonymous is redirected when page not found",
// "Close site when server load is above the threshold  (except for those with permission)" => "Close site when server load is above the threshold  (except for those with permission)",
"Use proxy" => "Empra proxy",
// "Use context menus for actions (icons)" => "Use context menus for actions (icons)",
// "Use context menus for actions (text)" => "Use context menus for actions (text)",
// "Show user's real name instead of login (when possible)" => "Show user's real name instead of login (when possible)",
// "Display UserTracker information on the user information page" => "Display UserTracker information on the user information page",
// "Input the user tracker ID then field IDs to be shown, all separated by commas. Example: 1,1,2,3,4 (user tracker ID 1 followed by field IDs 1-4)" => "Input the user tracker ID then field IDs to be shown, all separated by commas. Example: 1,1,2,3,4 (user tracker ID 1 followed by field IDs 1-4)",
"Users can configure modules" => "Els usuaris poden configurar mòduls",
// "Users can shade modules" => "Users can shade modules",
// "Allows users to hide/show modules" => "Allows users to hide/show modules",
// "Module decides" => "Module decides",
// "Store full-size copy of avatar in file gallery" => "Store full-size copy of avatar in file gallery",
// "File gallery to store full-size copy of avatar in" => "File gallery to store full-size copy of avatar in",
// "Enter the gallery id here. Please create a dedicated gallery that is admin-only for security, or make sure gallery permissions are set so that only admins can edit" => "Enter the gallery id here. Please create a dedicated gallery that is admin-only for security, or make sure gallery permissions are set so that only admins can edit",
// "File ID of default avatar image" => "File ID of default avatar image",
// "File ID of image to use in file gallery as the avatar if user has no avatar image in file galleries" => "File ID of image to use in file gallery as the avatar if user has no avatar image in file galleries",
// "Display who viewed my stuff on the user information page" => "Display who viewed my stuff on the user information page",
// "You will need to activate tracking of views for various items in the action log for this to work" => "You will need to activate tracking of views for various items in the action log for this to work",
// "Number of days to consider who viewed my stuff" => "Number of days to consider who viewed my stuff",
// "Number of days before current time to consider when showing who viewed my stuff" => "Number of days before current time to consider when showing who viewed my stuff",
// "Show to others who viewed my stuff on the user information page" => "Show to others who viewed my stuff on the user information page",
// "Show to others who viewed my stuff on the user information page. Admins can always see this information" => "Show to others who viewed my stuff on the user information page. Admins can always see this information",
// "Maximum number of users to show in drop down lists" => "Maximum number of users to show in drop down lists",
// "Prevents out of memory and performance issues when user list is very large by using a jQuery autocomplete text input box" => "Prevents out of memory and performance issues when user list is very large by using a jQuery autocomplete text input box",
// "Use pretty trackers for registration form" => "Use pretty trackers for registration form",
// "Registration pretty tracker template" => "Registration pretty tracker template",
// "Use wiki page name or template file with .tpl extension" => "Use wiki page name or template file with .tpl extension",
// "Output the registration results" => "Output the registration results",
// "Use a wiki page as template to output the registration results to" => "Use a wiki page as template to output the registration results to",
// "Output registration pretty tracker template" => "Output registration pretty tracker template",
// "Wiki page only" => "Wiki page only",
// "Page name fieldId" => "Page name fieldId",
// "User trackers field id whose value is used as output page name" => "User trackers field id whose value is used as output page name",
// "User tracker IDs to sync prefs from" => "User tracker IDs to sync prefs from",
// "Enter the IDs separated by commas of trackers to sync user prefs from" => "Enter the IDs separated by commas of trackers to sync user prefs from",
// "Tracker field IDs to sync Real Name pref from" => "Tracker field IDs to sync Real Name pref from",
// "Enter the IDs separated by commas in priority of being chosen, each item can concatenate multiple fields using +, e.g. 2+3,4" => "Enter the IDs separated by commas in priority of being chosen, each item can concatenate multiple fields using +, e.g. 2+3,4",
// "Synchronize long/lat/zoom to location field" => "Synchronize long/lat/zoom to location field",
// "Synchronize user geolocation prefs to main location field" => "Synchronize user geolocation prefs to main location field",
// "Synchronize categories of user tracker item to user groups" => "Synchronize categories of user tracker item to user groups",
// "Will add the user tracker item to the category of the same name as the user groups and vice versa" => "Will add the user tracker item to the category of the same name as the user groups and vice versa",
// "Put user in group only if categorized within" => "Put user in group only if categorized within",
// "Change user system language when changing user tracker item language" => "Change user system language when changing user tracker item language",
// "Show user's real name instead of login in autocomplete selector in trackers feature" => "Show user's real name instead of login in autocomplete selector in trackers feature",
// "Use user's real name instead of login in autocomplete selector in trackers feature" => "Use user's real name instead of login in autocomplete selector in trackers feature",
// "Show user's real name instead of login in autocomplete selector in messaging feature" => "Show user's real name instead of login in autocomplete selector in messaging feature",
// "Use user's real name instead of login in autocomplete selector in messaging feature" => "Use user's real name instead of login in autocomplete selector in messaging feature",
// "User Favorites" => "User Favorites",
// "Allows for users to flag content as their favorite" => "Allows for users to flag content as their favorite",
// "Users must choose a group at registration" => "Users must choose a group at registration",
// "Users cannot register without choosing one of the groups defined above" => "Users cannot register without choosing one of the groups defined above",
"Score ascending" => "Ascendent per puntuació",
"Score descending" => "Descendent per puntuació",
"Name ascending" => "Ascendent per Nom de l'Usuari",
"Name descending" => "Descendent per Nom de l'Usuari",
"Login ascending" => "Ascendent per Nom de Connexió d'usuari",
"Login descending" => "Descendent per Nom de Connexió d'usuari",
// "Quota (MB)" => "Quota (MB)",
"Private" => "Privat",
// "Users can see each other's files" => "Users can see each other's files",
// "Username pattern" => "Username pattern",
// "Serve avatar images statically" => "Serve avatar images statically",
// "When enabled, feature checks and permission checks will be skipped" => "When enabled, feature checks and permission checks will be skipped",
"Displayed time zone" => "Zona horària mostrada",
// "Always the site default time zone" => "Always the site default time zone",
// "Use time zone set from user preferences, or the automatically detected time zone for anonymous (if browser allows). Site default is used as fallback" => "Use time zone set from user preferences, or the automatically detected time zone for anonymous (if browser allows). Site default is used as fallback",
"Number of visited pages to remember" => "Quantitat de pàgines visitades a recordar",
"User information" => "Informació d'usuari/a",
"Public" => "Públic",
"Use double-click to edit pages" => "Empra doble-clic per editar pàgines",
// "Use 12-hour clock for time selectors" => "Use 12-hour clock for time selectors",
// "Use the 12-hour clock (with AM and PM) for time selectors used in some edit windows to set the time for publishing new or edited blog posts, articles, etc" => "Use the 12-hour clock (with AM and PM) for time selectors used in some edit windows to set the time for publishing new or edited blog posts, articles, etc",
// "Use new diff any version interface" => "Use new diff any version interface",
"Tasks per page" => "Tasques per pàgina",
// "20" => "20",
// "30" => "30",
// "40" => "40",
// "50" => "50",
"Messages per page" => "Missatge per pàgina",
"Allow messages from other users" => "Permetre missatges d'altres usuaris",
// "Notify sender when reading mail" => "Notify sender when reading mail",
"Send me an email for messages with priority equal or greater than" => "Envia'm un email per els missatges amb prioritat més gran o igual que",
// "Auto-archive read messages after" => "Auto-archive read messages after",
// "60" => "60",
"My pages" => "Les meves pàgines",
"My blogs" => "Les meves bitàcoles",
"My galleries" => "Les meves galeries",
"My messages" => "Els meus missatges",
"My tasks" => "Les meves tasques",
"My forum topics" => "Els meus tòpics de fòrums",
"My forum replies" => "Les meves respostes de fòrums",
"My items" => "Els meus ítems",
// "Character set for mail" => "Character set for mail",
"Show user's info on mouseover" => "Mostra la informació de l'usuari en passar el punter del ratolí per sobre",
// "Validator emails (separated by comma) if different than the sender email" => "Validator emails (separated by comma) if different than the sender email",
// "Display by default" => "Display by default",
// "Path (if stored in directory)" => "Path (if stored in directory)",
"Edit idle timeout" => "edita temps de desconnexió",
// "15" => "15",
// "Log errors to Tiki log" => "Log errors to Tiki log",
// "Errors will be logged to the Tiki log" => "Errors will be logged to the Tiki log",
// "Tracker ID of Channel tracker" => "Tracker ID of Channel tracker",
// "There must be a tracker to store info of each channel you create" => "There must be a tracker to store info of each channel you create",
// "Field ID of BrandId" => "Field ID of BrandId",
// "The Channel tracker must have a text field for the Watershed BrandId" => "The Channel tracker must have a text field for the Watershed BrandId",
// "Field ID of ChannelCode" => "Field ID of ChannelCode",
// "The Channel tracker must have a text field for the Watershed ChannelCode" => "The Channel tracker must have a text field for the Watershed ChannelCode",
// "Tracker ID of Archive tracker" => "Tracker ID of Archive tracker",
// "There must be a tracker to store Archive info" => "There must be a tracker to store Archive info",
// "Field ID of videoId" => "Field ID of videoId",
// "The Archive tracker must have a text field for the videoId of each archive" => "The Archive tracker must have a text field for the videoId of each archive",
// "Field ID of BrandId for Archive" => "Field ID of BrandId for Archive",
// "The Archive tracker must have a text field for the BrandId of each archive" => "The Archive tracker must have a text field for the BrandId of each archive",
// "Field ID of ChannelCode for Archive" => "Field ID of ChannelCode for Archive",
// "The Archive tracker must have a text field for the ChannelCode of each archive" => "The Archive tracker must have a text field for the ChannelCode of each archive",
// "Field ID of rtmpURL for Archive (url field type)" => "Field ID of rtmpURL for Archive (url field type)",
// "The Archive tracker must have a url field for storing the RTMP URL to access the archive" => "The Archive tracker must have a url field for storing the RTMP URL to access the archive",
// "Field ID of flvURL for Archive (url field type)" => "Field ID of flvURL for Archive (url field type)",
// "The Archive tracker must have a url field for storing the FLV URL to access the archive" => "The Archive tracker must have a url field for storing the FLV URL to access the archive",
// "Field ID of Date string for Archive" => "Field ID of Date string for Archive",
// "The Archive tracker can have a text field for storing the time the recording completed" => "The Archive tracker can have a text field for storing the time the recording completed",
// "Field ID of Duration for Archive" => "Field ID of Duration for Archive",
// "The Archive tracker can have a text field for storing the duration of the recording" => "The Archive tracker can have a text field for storing the duration of the recording",
// "Field ID of Filesize for Archive" => "Field ID of Filesize for Archive",
// "The Archive tracker can have a text field for storing the filesize of the recording" => "The Archive tracker can have a text field for storing the filesize of the recording",
// "Field ID of Title for Archive" => "Field ID of Title for Archive",
// "The Archive tracker could have a text field for storing the title of the recording" => "The Archive tracker could have a text field for storing the title of the recording",
// "Field ID of Description for Archive (textarea field type)" => "Field ID of Description for Archive (textarea field type)",
// "The Archive tracker could have a textarea field for storing the description of the recording" => "The Archive tracker could have a textarea field for storing the description of the recording",
// "Field ID of Tags for Archive (freetags field type)" => "Field ID of Tags for Archive (freetags field type)",
// "The Archive tracker could have a freetags field for storing the tags of the recording" => "The Archive tracker could have a freetags field for storing the tags of the recording",
// "Flash Media Encoder shared secret" => "Flash Media Encoder shared secret",
// "Shared key for authenticating Flash Media Encoder" => "Shared key for authenticating Flash Media Encoder",
"Allow viewing HTML mails?" => "Permetre veure correus en HTML?",
"Maximum size for each attachment" => "Mida màxima per cada afegit",
// "500Kb" => "500Kb",
// "1Mb" => "1Mb",
// "1.5Mb" => "1.5Mb",
// "2Mb" => "2Mb",
// "2.5Mb" => "2.5Mb",
// "3Mb" => "3Mb",
"Unlimited" => "Il·limitat",
// "Include a flag by each e-mail to quickly flag/un-flag them" => "Include a flag by each e-mail to quickly flag/un-flag them",
"LastModif" => "Última modificació",
"Last editor" => "Darrer editor",
// "Wiki link format" => "Wiki link format",
// "What level of special characters are accepted as wiki links for page names. Ex.: ((Page &eacute;&agrave;&icirc;))" => "What level of special characters are accepted as wiki links for page names. Ex.: ((Page &eacute;&agrave;&icirc;))",
// "Strict will only be basic characters like a-z and 0-9. If you have accented or special characters in page names, you should not use strict" => "Strict will only be basic characters like a-z and 0-9. If you have accented or special characters in page names, you should not use strict",
"Complete" => "Complet",
// "Relaxed" => "Relaxed",
// "Strict" => "Strict",
// "Display page version" => "Display page version",
// "Display the page version information when viewing the page" => "Display the page version information when viewing the page",
// "Display page name above page" => "Display page name above page",
// "Display page name above page instead of inside page" => "Display page name above page instead of inside page",
// "Page name display stripper" => "Page name display stripper",
// "Character to use as a delimiter in the page name. The portion of the name after this character will not be displayed" => "Character to use as a delimiter in the page name. The portion of the name after this character will not be displayed",
// "Wiki author list style" => "Wiki author list style",
// "Changes the list format used to display the authors of the page" => "Changes the list format used to display the authors of the page",
// "Creator & Author" => "Creator & Author",
"Business style" => "Estil de Negocis",
"Collaborative style" => "Estil col·laboratiu",
"Page last modified on" => "Darrera modificació de la pàgina el",
// "none (disabled)" => "none (disabled)",
// "Specify wiki author list style per page" => "Specify wiki author list style per page",
// "Allows to modify the style in which the author list is displayed on a per-page basis" => "Allows to modify the style in which the author list is displayed on a per-page basis",
// "Wiki action bar location" => "Wiki action bar location",
// "Buttons: Save, Preview, Cancel, .." => "Buttons: Save, Preview, Cancel, ..",
"Both" => "Ambdues coses",
// "Wiki navigation bar location" => "Wiki navigation bar location",
// "When using the ...page... page break wiki syntax" => "When using the ...page... page break wiki syntax",
// "Wiki top line location" => "Wiki top line location",
"Cache wiki pages (global)" => "Posar les pàgines wiki en memòria cau (global)",
// "Enable page cache globally for wiki pages" => "Enable page cache globally for wiki pages",
"no cache" => "Sense memòria cau",
"minute" => "minut",
// "Allow comments per wiki page" => "Allow comments per wiki page",
// "Enable control for comments on wiki pages individually" => "Enable control for comments on wiki pages individually",
// "Enable (default On)" => "Enable (default On)",
// "Enable (default Off)" => "Enable (default Off)",
// "Enable edit plugin icons" => "Enable edit plugin icons",
// "Permits editing of a plugin, via a popup form, without needing to edit the whole page" => "Permits editing of a plugin, via a popup form, without needing to edit the whole page",
// "Requires JavaScript" => "Requires JavaScript",
// "Prevent special characters in page names" => "Prevent special characters in page names",
// "Some characters may prevent the pages from being easily accessible from the URL or through wiki links. This option prevents from creating pages with such characters" => "Some characters may prevent the pages from being easily accessible from the URL or through wiki links. This option prevents from creating pages with such characters",
// "Page ranking reload probability" => "Page ranking reload probability",
// "Calculation of page rankings is an expensive task that cannot be performed at every page load. It will be calculated at random page loads based on a dice roll. This option indicates the amount of faces on the dice. Larger numbers lead to less load, but less accurate ranking" => "Calculation of page rankings is an expensive task that cannot be performed at every page load. It will be calculated at random page loads based on a dice roll. This option indicates the amount of faces on the dice. Larger numbers lead to less load, but less accurate ranking",
// "Encourage contribution to wiki pages by anonymous" => "Encourage contribution to wiki pages by anonymous",
// "When a page is not editable and the user is anonymous, display the edit links anyway. The visitor will be prompted with a login screen and be encouraged to register" => "When a page is not editable and the user is anonymous, display the edit links anyway. The visitor will be prompted with a login screen and be encouraged to register",
// "Warn before page lock timeout" => "Warn before page lock timeout",
// "Provide a JavaScript alert before the user's lock on a page times out" => "Provide a JavaScript alert before the user's lock on a page times out",
"Dynamic variables" => "variables Dinàmiques",
// "Global snippets of text that can be included in wiki pages and edited in place" => "Global snippets of text that can be included in wiki pages and edited in place",
// "Single (%varname%)" => "Single (%varname%)",
// "Double (%%varname%%)" => "Double (%%varname%%)",
// "Multilingual dynamic variables" => "Multilingual dynamic variables",
// "Make dynamic variable content language specific" => "Make dynamic variable content language specific",
// "Edit section" => "Edit section",
// "Edit section level" => "Edit section level",
// "Toggle display of section and plugin edit icons" => "Toggle display of section and plugin edit icons",
// "Allow minor edits" => "Allow minor edits",
// "Add a slideshow button on wiki pages" => "Add a slideshow button on wiki pages",
"Page creators are admin of their pages" => "Els creadors de pàgines en son els adminsitradors",
"Create watch for author on page creation" => "L'autor vigila la pàgina en crear-la",
"Enable watches on comments" => "Permet vigilar comentaris",
"Enable watch events when I am the editor" => "Permet vigilar canvis quan sóc l'editor",
// "Watch minor edits" => "Watch minor edits",
// "Page ID" => "Page ID",
// "Name length" => "Name length",
"Last modified by" => "Darrera modicicació per",
// "Edit comments" => "Edit comments",
// "Edit Comment length" => "Edit Comment length",
"Versions" => "Versions",
"Categories" => "Categories",
"Categories path" => "Ruta de les categories",
"Default sort order" => "Ordre d'ordenació per defecte",
// "Sort Direction" => "Sort Direction",
"Descending" => "Descendent",
"Ascending" => "Ascendent",
"Enable wiki 3D browser" => "Activa el navegador Wiki 3D",
"Load page on navigation" => "Carrega la pàgina en navegar per ella",
// "Forum for discussion" => "Forum for discussion",
// "Allow to manage keywords on a per-page basis" => "Allow to manage keywords on a per-page basis",
// "Similar pages only listed in same language" => "Similar pages only listed in same language",
// "When listing similar pages, such as in missing page 404, only display pages in the same language as the request" => "When listing similar pages, such as in missing page 404, only display pages in the same language as the request",
// "Mandatory edit summary on wiki pages" => "Mandatory edit summary on wiki pages",
// "Reject save attempts not providing an edit summary to describe the changes made" => "Reject save attempts not providing an edit summary to describe the changes made",
// "Choose position of freetags selection" => "Choose position of freetags selection",
// "If you wish to place freetags selection more prominently than in the properties tab" => "If you wish to place freetags selection more prominently than in the properties tab",
// "Properties tab" => "Properties tab",
// "Edit tab" => "Edit tab",
// "Freetags tab" => "Freetags tab",
// "Structure navigation bar location" => "Structure navigation bar location",
// "Displays Next/Back buttons, breadcrumbs, and form to add a new page" => "Displays Next/Back buttons, breadcrumbs, and form to add a new page",
// "Maximum length (characters) to display/truncate for backlink page names. Use \"0\" for no truncation" => "Maximum length (characters) to display/truncate for backlink page names. Use \"0\" for no truncation",
// "Simple wiki ratings" => "Simple wiki ratings",
// "Enable users to rate articles based on a simple numeric scale" => "Enable users to rate articles based on a simple numeric scale",
// "Wiki rating options" => "Wiki rating options",
// "List of options available for the rating of wiki pages" => "List of options available for the rating of wiki pages",
// "Semantic link types to use as page alias markers" => "Semantic link types to use as page alias markers",
// "Comma separated list of semantic links to use to identify a page as an alias to another" => "Comma separated list of semantic links to use to identify a page as an alias to another",
// "Redirect pages using these prefix alias semantic links" => "Redirect pages using these prefix alias semantic links",
// "Comma separated list of prefixes of which pages will be redirected to page with semantic link" => "Comma separated list of prefixes of which pages will be redirected to page with semantic link",
// "Plugin %0" => "Plugin %0",
// "Global cache time for the plugin snarf in seconds" => "Global cache time for the plugin snarf in seconds",
// "Default cache time for the plugin snarf" => "Default cache time for the plugin snarf",
// "0 for no cache" => "0 for no cache",
// "Inline plugin %0" => "Inline plugin %0",
// "Plugin pending approval notification" => "Plugin pending approval notification",
// "Alert by e-mail users with permission to approve plugin when a plugin is pending approval" => "Alert by e-mail users with permission to approve plugin when a plugin is pending approval",
"Wysiwyg Editor is optional" => "L'editor Wysiwyg és opcional",
// "Wysiwyg Editor is displayed by default" => "Wysiwyg Editor is displayed by default",
"Reopen with the same editor" => "Reobre amb el mateix editor",
"Content is parsed like wiki page" => "El contingut és interpretat com una pàgina Wiki",
// "This allows a mixture of wiki and HTML. All wiki syntax is parsed" => "This allows a mixture of wiki and HTML. All wiki syntax is parsed",
// "Content is partially wiki parsed" => "Content is partially wiki parsed",
// "This also allows a mixture of wiki and HTML. Only some wiki syntax is parsed, such as plugins (not inline character styles etc)" => "This also allows a mixture of wiki and HTML. Only some wiki syntax is parsed, such as plugins (not inline character styles etc)",
// "Neglected. This feature can have unpredicable results and may be removed in future versions" => "Neglected. This feature can have unpredicable results and may be removed in future versions",
// "Wysiwyg editor skin" => "Wysiwyg editor skin",
// "Kama (Default)" => "Kama (Default)",
// "Office 2003" => "Office 2003",
// "V2 (FCKEditor appearance)" => "V2 (FCKEditor appearance)",
// "Use Wiki syntax in WYSIWYG" => "Use Wiki syntax in WYSIWYG",
// "Experimental, new : Allow to keep the wiki syntax with the WYSIWYG editor. WARNING: plugin edit is not working in that case in WYSIWYG mode, use the Source mode instead " => "Experimental, new : Allow to keep the wiki syntax with the WYSIWYG editor. WARNING: plugin edit is not working in that case in WYSIWYG mode, use the Source mode instead ",
// "Font names" => "Font names",
// "List of font names separated by" => "List of font names separated by",
// "SMTP Server" => "SMTP Server",
"Username" => "Nom d'usuari",
"Security" => "Seguretat",
// "SSL" => "SSL",
// "TLS" => "TLS",
// "Mail Sender" => "Mail Sender",
// "Sendmail" => "Sendmail",
// "SMTP" => "SMTP",
// "Authentication" => "Authentication",
// "Mail server authentication" => "Mail server authentication",
// "LOGIN" => "LOGIN",
// "PLAIN" => "PLAIN",
// "CRAM-MD5" => "CRAM-MD5",
// "Zotero Bibliography" => "Zotero Bibliography",
// "Connect Tiki to the Zotero online bibliography management system" => "Connect Tiki to the Zotero online bibliography management system",
// "Zotero Client Key" => "Zotero Client Key",
// "Required identification key. Registration required" => "Required identification key. Registration required",
// "Zotero Client Secret" => "Zotero Client Secret",
// "Zotero Group ID" => "Zotero Group ID",
// "Numeric ID of the group, can be found in the URL" => "Numeric ID of the group, can be found in the URL",
// "Zotero Reference Style" => "Zotero Reference Style",
// "Use an alternate Zotero reference style when formatting the references. The reference formats must be installed on the Zotero server" => "Use an alternate Zotero reference style when formatting the references. The reference formats must be installed on the Zotero server",
// "Unmatched system requirement. Missing php extension among %0" => "Unmatched system requirement. Missing php extension among %0",
// "Unmatched system requirement. The database you are using does not support this feature" => "Unmatched system requirement. The database you are using does not support this feature",
// "Missing default for preference \"%0\"" => "Missing default for preference \"%0\"",
// "Configuration forced by host" => "Configuration forced by host",
// "Disabled by host" => "Disabled by host",
"Actions" => "Accions",
"Admin" => "Administrar",
"Permissions" => "Permisos",
"View" => "Visualitza",
"Module" => "Mòdul",
"Plugin" => "Connector (Plugin)",
// "Like" => "Like",
// "Fix me" => "Fix me",
"Unavailable" => "No disponibles",
// "Don't like" => "Don't like",
// "Don't fix me" => "Don't fix me",
// "What's this for" => "What's this for",
// "Nothing was changed, please check profile for errors" => "Nothing was changed, please check profile for errors",
// "An error occurred: " => "An error occurred: ",
// "Applying profile" => "Applying profile",
// "Preference set" => "Preference set",
"Added (or modified)" => "Afegit/s (o modificat/s)",
// "Group changed (or modified)" => "Group changed (or modified)",
// "Modified permission %s for %s" => "Modified permission %s for %s",
// "Modified permission %s on %s/%s for %s" => "Modified permission %s on %s/%s for %s",
// "User %0 was added to %1" => "User %0 was added to %1",
"Created by profile installer" => "Creat per l'instal·lador de perfils",
"Page updated by profile installer" => "Pàgina actualitzada per l'instal·lador de perfils",
// "File gallery does not exist" => "File gallery does not exist",
// "File gallery already exists" => "File gallery already exists",
// "Calendar does not exist" => "Calendar does not exist",
// "Calendar already exists" => "Calendar already exists",
"Page cannot be found" => "No s'ha pogut trobar la pàgina",
// "Syntax error: " => "Syntax error: ",
// "Circular reference" => "Circular reference",
// "No name" => "No name",
// "Bad object" => "Bad object",
// "Permissions' object must have a field 'type' and 'id'" => "Permissions' object must have a field 'type' and 'id'",
// "Needs a 'type' and 'data' field" => "Needs a 'type' and 'data' field",
"Wiki top pages" => "Pàgines Wiki més actives",
"Most relevant pages" => "Pàgines més rellevants",
"Relevance" => "Rellevancia",
"Wiki last pages" => "Darreres pàgines Wiki",
"Forums last posts" => "Fòrums: darrers enviaments",
"Topic date" => "Data de tòpic",
"Forums most read topics" => "Temes més llegits dels Fòrums",
"Forums best topics" => "Fòrums: millors temes",
"Forums most visited forums" => "Fòrums més visitats",
"Forums with most posts" => "Fòrums amb més escrits",
"Wiki top galleries" => "Galeries d'imatges Wiki més actives",
"Wiki top file galleries" => "Galeries de fitxers Wiki més actives",
"Wiki top images" => "Imatges Wiki més visitades",
"Wiki top files" => "Fitxers Wiki més vists",
"Downloads" => "Descàrregues",
"Wiki last images" => "Darreres imatges Wiki",
"Upload date" => "Data de pujada",
"Wiki last files" => "Darrers fitxers Wiki",
// "Top Articles" => "Top Articles",
"Most visited blogs" => "Blocs més visitats",
// "Most-active Blogs" => "Most-active Blogs",
"Blogs last posts" => "Darrers enviaments al Bloc",
"Post date" => "Data de publicació",
"Wiki top authors" => "Autors Wiki més actius",
"Pages" => "Pàgines",
"Top article authors" => "Els autors d'articles més actius",
// "Expecting three arguments for article-info" => "Expecting three arguments for article-info",
// "Unsupported property. Supported properties are: " => "Unsupported property. Supported properties are: ",
// "Articles feature not enabled" => "Articles feature not enabled",
// "Unexpected values: %0" => "Unexpected values: %0",
// "Object must be provided and contain two arguments: type and object" => "Object must be provided and contain two arguments: type and object",
// "Invalid property" => "Invalid property",
// "Invalid range" => "Invalid range",
// "Invalid revote period" => "Invalid revote period",
// "Expecting \"keep\" to be \"latest\" or \"oldest\"" => "Expecting \"keep\" to be \"latest\" or \"oldest\"",
// "Unknown variables referenced: %0" => "Unknown variables referenced: %0",
// "Username is required" => "Username is required",
"Password is required" => "Contrasenya requerida",
"User already exists" => "Aquest usuari ja existeix",
"Registered" => "Enregistrats/des",
"Invalid username" => "El nom de l'usuari no és vàlid",
"Username is too long" => "El nom de l'usuari és massa llarg",
"Username cannot contain uppercase letters" => "El nom d'usuari no pot contenir majúscules",
"Wrong passcode. You need to know the passcode to register at this site" => "Codi de registre no vàlid. Necessites saber el codi de registre per donar-te d'alta en aquest lloc web",
"You must choose a group" => "Has d'escollir un grup",
// "Email not valid. Should be in the format \"mailbox@example.com\"" => "Email not valid. Should be in the format \"mailbox@example.com\"",
"The passwords don't match" => "Les contrasenyes no coincideixen",
// "Username must be at least %0 characters long" => "Username must be at least %0 characters long",
// "Username cannot contain more than %0 characters" => "Username cannot contain more than %0 characters",
// "This invitation does not exist or is deprecated or wrong email" => "This invitation does not exist or is deprecated or wrong email",
// "The fields title and description are mandatory to generate a feed" => "The fields title and description are mandatory to generate a feed",
// "To fix this error go to Admin -> Feeds" => "To fix this error go to Admin -> Feeds",
// "Please contact the site administrator and ask him to fix this error" => "Please contact the site administrator and ask him to fix this error",
// "If you set feed author email or URL, you must set feed author name" => "If you set feed author email or URL, you must set feed author name",
// "Feed logo" => "Feed logo",
"Unspecified" => "No especificat",
"Log In" => "Connecta't",
"See other users' profiles" => "Mira el perfil dels altres usuaris",
"Have your profile seen" => "Tingues el teu perfil visible",
"Make friends" => "Fes amistats",
"Receive message" => "Rep missatge",
"Send message" => "Envia missatge",
"Read an article" => "Llegeix un article",
"Publish an article" => "Publica un article",
"Have your article read" => "Tingues el teu article llegit",
"Create New File Gallery" => "Crea una Nova Galería d'Arxius",
"Upload new file to gallery" => "Puja un arxiu nou a la galeria",
"Download other user's file" => "Descarrega l'arxiu d'altres usuaris",
"Have your file downloaded" => "Tingues el teu arxiu descarregat",
"Create a new image gallery" => "Crea una nova galeria d'imatges",
"Upload new image to gallery" => "Puja una nova imatge a la galeria",
"See other users' galleries" => "Mira la galaeria d'altres usuaris",
"See other users' images" => "Mira la imatge d'altres usuaris",
"Have your gallery seen by other users" => "Tingues la teva galeria vista per altres usuaris",
"Have your image seen" => "Tingues la teva imatge vista",
"Create new blog" => "Crea un bloc nou",
"Post in a blog" => "Publica en un bloc",
"Read other users' blogs" => "Llegeix el bloc d'altres usuaris",
"Have your blog read" => "Tingues el teu bloc llegit",
"Create a new wiki page" => "Crea una nova pàgina wiki",
"Edit an existing page" => "Edita una pàgina existent",
"Attach file" => "Adjuntar arxiu",
// "try rebuilding or optimizing the index on the search admin page" => "try rebuilding or optimizing the index on the search admin page",
// "Search index could not be updated: %0" => "Search index could not be updated: %0",
"Wiki Comment" => "Comentari Wiki",
"Calendar item" => "Ítem del Calendari",
"Gallery" => "Galeria",
"Article" => "Article",
"Blog post" => "Publicació de Bloc",
"Tracker item" => "Item del formulari",
// "Search index could not be updated. The site is misconfigured. Contact an administrator" => "Search index could not be updated. The site is misconfigured. Contact an administrator",
// "blog post" => "blog post",
"file" => "arxiu",
// "forum post" => "forum post",
"trackeritem" => "ítem del formulari-bd",
"sheet" => "full de càlcul",
"comment" => "comentari",
// " has accessed your temporary shared content" => " has accessed your temporary shared content",
// "has accessed the following shared content" => "has accessed the following shared content",
// "Your access to this page has expired" => "Your access to this page has expired",
// "Handling actions of plugin \"%s\" failed" => "Handling actions of plugin \"%s\" failed",
// "You must choose an option" => "You must choose an option",
"For you to vote, cookies must be allowed" => "Les galetes haurien de tenir dret al vot",
"This poll is closed." => "Consulta tancada.",
"Thank you for installing Tiki" => "Gràcies per instal·lar Tiki",
"The entire Tiki Community would like to thank you and help you get introduced to Tiki" => "La Comunitat de Tiki en conjunt voldria donar-te les gràcies i ajudar-te amb la teva introducció a Tiki",
"How To Get Started" => "Com __posar-te en marxa__ ",
"Tiki has more than 1000 features and settings" => "Tiki té més de 1000 funcionalitats i ajustaments",
"This allows you to create both very simple and complex websites" => "Això li permet crear llocs web des de molt simples fins a molt complexos",
"We understand that so many features might seem overwhelming at first. This is why we offer you two different ways to __Get Started__ with Tiki" => "Entenem que un programari amb tantes característiques pot semblar aclaparador al principi. Aquesta és la raó per la que t'oferim dues maneres diferents per a __Posar-te en marxa__ amb Tiki",
"Manual Setup using Admin Panel" => "Configuració Manual emprant el Panell d'Administració",
"Get Started using Admin Panel" => "Posa't en marxa emprant el Panell d'Administració",
"Who Should Use This" => "Qui hauria d'emprar això",
"You are familiar with software Admin Panels" => "Estàs familiaritzat amb panells d'administració de programes",
"You enjoy exploring and playing with many options" => "T'agrada explorar i jugar amb moltes opcions",
"You already know Tiki" => "Ja coneixes Tiki",
"Easy Setup using Profiles" => "Ajust fàcil emprant Perfils (de Configuració)",
"Get Started using Profiles" => "Posa't en marxa emprant Perfils (de Configuració)",
"You want to get started quickly" => "Vols començar ràpidament",
"Featured Profiles" => "Perfils destacats",
"__Collaborative Community__ ([%0|apply profile now])" => "__Comunitat Col·laborativa__ ([%0|instal·la el perfil ara])",
"Setup to help subject experts and enthusiasts work together to build a Knowledge Base" => "Configuració per ajudar a entusiastes i experts en les vostres matèries a treballar conjuntament per construir una Base de Coneixement",
"Wiki Editing" => "Edició Wiki",
"Personal Member Spaces" => "Espais personals per als membres",
"__Personal Blog and Profile__ ([%0|apply profile now])" => "__Bloc i perfil personal__ ([%0|instal·la el perfil ara])",
"Setup with many cool features to help you integrate the Social Web and establish a strong presence in the Blogosphere" => "Configuració amb moltes funcionalitats guais per ajudar-te a ser part de la Web Social i establir-te una presència notable a la Blogosfera",
"Blog (Full set of blog related features)" => "Bloc (Conjunt complert de característiques relacionades amb bitàcoles - blogs)",
"RSS Integration" => "Integració RSS",
"Video Log" => "Registre de vídeos",
"__Company Intranet__ ([%0|apply profile now])" => "__Intranet d'Empresa__ ([%0|instal·la el perfil ara])",
"Setup for a Corporate Intranet of a typical medium-sized business" => "Configuració per a una intranet d'Empresa d'un negoci típic de mida mitjana (PIME)",
"Company News Articles" => "Articles de Notícies de l'Empresa",
"Executive Blog" => "Bloc Executiu",
"File Repository & Management" => "Gestió d'arxius i repositoris",
"Collaborative Wiki" => "Wiki col·laboratiu",
"__Small Organization Web Presence__ ([%0|apply profile now])" => "__Presència Web d'una Organització Petita__ ([%0|instal·la el perfil ara])",
"Setup for a Web Presence of a typical small business or non-profit" => "Configuració per a la presència web d'una entitat sense ànim de lucre, ONG o petita empresa típica",
"Company News & Updates" => "Notícies de l'entitat i actualitzacions",
"File Gallery (great for Media Kit)" => "Galeria d'arxius (ideal per a un kit per als mitjans de comunicació)",
"Contact Form" => "Formulari de Contacte",
"Congratulations" => "Felicitats",
"This is the default homepage for your Tiki. If you are seeing this page, your installation was successful" => "Aquesta és la pàgina Inicial per omissió per al teu Tiki. Si veus aquesta pàgina, la teva instal·lació s'ha realitzat correctament",
"You can change this page after logging in. Please review the [http://doc.tiki.org/wiki+syntax|wiki syntax] for editing details" => "Pots canviar aquesta pàgina després de connectar-te. Si us plau, revisa la [http://doc.tiki.org/wiki+syntax|sintaxi wiki] per als detalls d'edició",
"{img src=img/icons/star.png alt=\\\"Star\\\"} Get started" => "{img src=img/icons/star.png alt=\\\"Star\\\"} Posa't en marxa",
"To begin configuring your site" => "Per a començar la configuració del teu lloc",
"1) Log in with your newly created password" => "1) Inicia la sessió com a usuari __admin__ amb la teva nova contrasenya",
"2) Manually Enable specific Tiki features" => "2) Habilita funcionalitats específiques de Tiki",
"3) Run Tiki Profiles to quickly get up and running" => "3) Aplica perfils de configuració de Tiki per posar-te en marxa de forma àgil",
"{img src=img/icons/help.png alt=\\\"Help\\\"} Need help" => "{img src=img/icons/help.png alt=\\\"Help\\\"} Necessites ajuda",
"For more information" => "Per a més informació",
"[http://info.tiki.org/Learn+More|Learn more about Tiki]" => "[http://info.tiki.org/Learn+More|Més informació sobre Tiki]",
"[http://info.tiki.org/Help+Others|Get help], including the [http://doc.tiki.org|official documentation] and [http://tiki.org/forums|support forums]" => "[http://info.tiki.org/Help+Others|Obtenir ajuda], inclosos la [http://doc.tiki.org|documentació oficial] i els [http://www.tiki.org/forums|fòrums de suport]",
"[http://info.tiki.org/Join+the+community|Join the Tiki community]" => "[http://info.tiki.org/Join+the+community|Uneix-te a la comunitat de Tiki]",
"You don't feel like learning the Admin Panel right away" => "No tens ganes d'aprendre el Panell d'Administració immediatament",
"You want to quickly test out some of Tiki's Features" => "Vols provar de forma ràpida algunes funcionalitats de Tiki",
"Highlight Company's Products and Services" => "Destacar els Productes i Serveis de la Companyia",
"new" => "nou",
"Saved" => "Desat",
"Save failed" => "No s'ha pogut desar",
// "Standard Shipping" => "Standard Shipping",
// "3 to 5 working days" => "3 to 5 working days",
// "Express Shipping" => "Express Shipping",
// "Next day delivery" => "Next day delivery",
// "Custom Shipping Example" => "Custom Shipping Example",
// "UPS_CODE_%0" => "UPS_CODE_%0",
// "Problem reading custom shipping provider \"%0\"" => "Problem reading custom shipping provider \"%0\"",
"Click for Help" => "Clica per a llegir l'Ajuda",
// "You are not in group of friends to have the content of this block displayed for you" => "You are not in group of friends to have the content of this block displayed for you",
"<!-- jq smarty plugin inactive: feature_jquery off -->" => "<!-- connector smarty jq inactiu: feature_jquery desactivada -->",
"No records to display" => "No hi ha cap registre per mostrar",
"Fast Next" => "Següent ràpid",
"Fast Prev" => "Previsualització ràpida",
"Prev" => "Previ",
"Next" => "Següent",
// "More results may be available. Refine criteria to access the estimated %0 results" => "More results may be available. Refine criteria to access the estimated %0 results",
// "First %0" => "First %0",
// "Last %0" => "Last %0",
// "Next %0" => "Next %0",
// "Prev %0" => "Prev %0",
// "tip" => "tip",
// "warning" => "warning",
// "confirm" => "confirm",
// "note" => "note",
// "errors" => "errors",
// "information" => "information",
// "Tab View" => "Tab View",
"No Tabs" => "Sense pestanyes",
"Tip" => "Pista",
// "This edit session will expire in" => "This edit session will expire in",
// "<strong>Preview</strong> (if available) or <strong>Save</strong> your work to restart the edit session timer" => "<strong>Preview</strong> (if available) or <strong>Save</strong> your work to restart the edit session timer",
// "There is an autosaved draft of your recent edits, to use it instead of what is current displayed" => "There is an autosaved draft of your recent edits, to use it instead of what is current displayed",
// "If you want the original version instead of the autosaved draft of your edits" => "If you want the original version instead of the autosaved draft of your edits",
"click here" => "cliqueu aquí",
"AutoSave" => "AutoDesa",
// "<strong>Thank you for trying the new ckeditor implementation for Tiki 6</strong><br /><br />" => "<strong>Thank you for trying the new ckeditor implementation for Tiki 6</strong><br /><br />",
// "Some of the settings at this site should be set differently for this to work best. Please ask the administrator to try this" => "Some of the settings at this site should be set differently for this to work best. Please ask the administrator to try this",
// "Ckeditor Development Notice" => "Ckeditor Development Notice",
"Your edit session has expired" => "Ha caducat la teva sessió d'edició",
"Your edit session will expire in" => "La teva sessió d'edició caducarà en",
"You must PREVIEW or SAVE your work now, to avoid losing your edits" => "Has de PREVISUALITZAR o DESAR ara el teu treball, per tal d'evitar perdre els teus canvis",
"You are about to leave this page. Changes since your last save will be lost. Are you sure you want to exit this page" => "Ets a punt de marxar d`aquesta pàgina. Es perdran els canvis des de la teva darrera visita. Segur que vols marxar d`aquesta pàgina",
// "Some of your preferences should be set differently for this to work at it's best. Please click this to apply the recommended profile" => "Some of your preferences should be set differently for this to work at it's best. Please click this to apply the recommended profile",
"Help page:" => "Pàgina d'ajuda:",
// "View or edit tpl" => "View or edit tpl",
"Edit Template" => "Edita plantilla",
"View tpl:" => "Visualitza tpl:",
// "View Template" => "View Template",
// "Admin page" => "Admin page",
"Admin Feature" => "Administra Funcionalitat",
// "Plugin name not specified" => "Plugin name not specified",
// "Wrong attachments gallery" => "Wrong attachments gallery",
// "You are attempting to display a gallery that is not a valid attachment gallery" => "You are attempting to display a gallery that is not a valid attachment gallery",
"Error(s)" => "Hi ha alguna(es) errada(es)",
"Clear errors" => "Neteja els missatges d'error",
// "Favorite" => "Favorite",
"Hour" => "Hora",
"Minute" => "Minut",
"Error:" => "Error:",
// "a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z" => "a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z",
"Click here to go to Edit Languages" => "Clica aquí per anar a Editar Idiomes",
"The text is" => "El text és",
"character(s) too long - please edit it." => "caràcter(s) massa llarg - si us plau edita-ho.",
"Date Selector" => "Selector de Data",
// "Month beginning" => "Month beginning",
// "Week beginning" => "Week beginning",
// "Data (change %)" => "Data (change %)",
"No records found." => "No s'han trobat registres.",
// "No object information provided" => "No object information provided",
// "No title specified" => "No title specified",
// "Relation not found" => "Relation not found",
// "freetags disabled" => "freetags disabled",
"Currency in payment (%0) does not match the currency for that registry (%1)" => "La moneda del pagament (%0) no es correspon amb la moneda del registre - xarxa d'intercanvi (%1)",
// "This invoice does not exist or is in limited access" => "This invoice does not exist or is in limited access",
// " (found in " => " (found in ",
// "(not found in an admin panel)" => "(not found in an admin panel)",
// "Preference %0 is not defined" => "Preference %0 is not defined",
// "Drag this out of the perspective and resave it" => "Drag this out of the perspective and resave it",
// "No object information provided for rating" => "No object information provided for rating",
// "An error occurred" => "An error occurred",
"Invert Sort" => "Inverteix l'ordre",
// "No rows found" => "No rows found",
// "Toggle sections" => "Toggle sections",
// "Show only selected" => "Show only selected",
// "You might want to also set the tiki_p_modify_object_categories permission under the tiki section" => "You might want to also set the tiki_p_modify_object_categories permission under the tiki section",
"You are already logged in" => "No estàs connectat",
// "Request not from this host" => "Request not from this host",
// "One of these groups is required" => "One of these groups is required",
"This field is required" => "Es obligatori omplir aquest camp del formulari",
"Please enter a valid %s.  No spaces, more than %d characters and contain %s" => "Si us plau, introdueix al camp %s un valor vàlid. Sense espais, més de %d caràcters i que contingui %s",
"username" => "usuari",
"password" => "la contrasenya",
"You have to enable cookies to be able to login to this site" => "Has d'habilitar les galetes 'cookies' per que puguis entrar en aquest lloc",
"second" => "segon",
"years" => "anys",
"months" => "mesos",
"weeks" => "setmanes",
"done" => "fet",
"Text cut here" => "Tall del text aquí",
"Task" => "Tasca",
"Priority" => "Prioritat",
"Start date:" => "Data d'inici:",
"End date:" => "Data de fi:",
// "in %s days, the %s" => "in %s days, the %s",
// "in %s day, the %s" => "in %s day, the %s",
"Friend" => "Amic",
"km" => "km",
"Last seen on" => "Vista per darrera vegada el",
"(idle for %s seconds)" => "(inactiu durant %s segons)",
"User information - Click for more info" => "Informació de l'usuari - Punxa per més informació",
// "More info about %0 (idle for %1)" => "More info about %0 (idle for %1)",
// " seconds" => " seconds",
// "Permission denied: the specified wiki page cannot be used as Smarty template resource" => "Permission denied: the specified wiki page cannot be used as Smarty template resource",
// "No WSDL found" => "No WSDL found",
"pvs" => "pvs",
// "Days with the most pageviews" => "Days with the most pageviews",
// "Day with the most pageviews" => "Day with the most pageviews",
// "Days with the least pageviews" => "Days with the least pageviews",
// "Day with the least pageviews" => "Day with the least pageviews",
// "No pageviews yet" => "No pageviews yet",
// "n/a" => "n/a",
"Use this tree to copy the structure" => "Empra aquest arbre per copiar l'estructura",
"created from structure" => "creat des d'estructura",
"You have to make %d choice(s) for the question" => "Has de fer %d elecció(ons) per a la pregunta",
"You have to make at least %d choice(s) for the question" => "Has de fer al menys %d elecció(ons) per a la pregunta",
"You have to make less than %d choice(s) for the question" => "Has de fer menys de %d eleccions per a la pregunta",
"You have to choose at least %d choice(s) for the question" => "Has d'escollir al menys %d elecció(ons) per a la pregunta",
// "Foreground Colors" => "Foreground Colors",
// "Background Colors" => "Background Colors",
"Colors" => "Colors",
// "Border Colors" => "Border Colors",
// "Border Widths" => "Border Widths",
// "Border Styles" => "Border Styles",
// "Border Radii" => "Border Radii",
// "Borders" => "Borders",
// "Font Sizes" => "Font Sizes",
// "Line Heights" => "Line Heights",
"Font" => "Font",
// "Font Families" => "Font Families",
// "Typography" => "Typography",
// "Select.." => "Select..",
// "Required features: <b>%0</b>. If you do not have the privileges to activate these features, ask the site administrator" => "Required features: <b>%0</b>. If you do not have the privileges to activate these features, ask the site administrator",
"Sea Surfing (CSRF) detected. Operation blocked." => "Sea Surfing (CSRF) detectat. Operació bloquejada.",
"unknown error" => "error desconegut",
"You are not logged in" => "No està connectat",
"This script cannot be called directly" => "No es pot cridar a aquesta rutina directament",
"Page '%0' cannot be found" => "No es pot trobar la pàgina '%0'",
"You do not have permission to view this section" => "Permís denegat per accedir a aquesta secció",
"For the security of your password direct access to the feed is only available via https" => "Per la seguretat de la teva contrasenya, l'accés directe a l'alimentació només és troba disponible via https",
"Help link" => "Enllaç d'ajuda",
"You are banned from" => "Estàs exclós des de",
"wiki" => "wiki",
"img-g" => "g-img",
"file-g" => "g-arx",
"faqs" => "pufs",
"quizzes" => "qüestionaris",
"arts" => "arts",
"blogs" => "bitàcoles",
"forums" => "fòrums",
"The file was uploaded with success" => "S'ha pujat l'arxiu amb èxit",
"The file you are trying upload was only partially uploaded." => "L'arxiu que proves de penjar només s'ha carregat parcialment.",
"No file was uploaded. Was a file selected " => "No s'ha pujat cap arxiu. S'havia seleeccionat un arxiu ",
"A temporary folder is missing" => "Manca un directori temporal",
"Unknown error" => "Error no conegut",
"Flash player not available" => "El reproductor Flash player no està disponible",
"%d points" => "%d punts",
"Removed" => "Eliminat/da",
"at" => "a",
// "Plugin %0 pending approval" => "Plugin %0 pending approval",
"Unknown language" => "Llenguatge desconegut",
"Click here to confirm your action" => "Fes clic aquí per confirmar la teva acció",
"Bold" => "Negreta",
// "img/icons/text_bold.png" => "img/icons/text_bold.png",
"Italic" => "Cursives",
// "img/icons/text_italic.png" => "img/icons/text_italic.png",
"Underline" => "Subratllat",
// "img/icons/text_underline.png" => "img/icons/text_underline.png",
"Strikethrough" => "Tatxat",
// "img/icons/text_strikethrough.png" => "img/icons/text_strikethrough.png",
"Non-parsed (Wiki syntax does not apply)" => "Sense interpretar (No s'aplicarà la sintaxi wiki)",
// "img/icons/noparse.png" => "img/icons/noparse.png",
"Align Center" => "Alinea al centre",
// "img/icons/text_align_center.png" => "img/icons/text_align_center.png",
"Horizontal Bar" => "Barra horizontal",
// "img/icons/page.png" => "img/icons/page.png",
"Page Break" => "Salt de pàgina",
// "img/icons/page_break.png" => "img/icons/page_break.png",
"Box" => "Caixa",
// "img/icons/box.png" => "img/icons/box.png",
// "img/icons/email.png" => "img/icons/email.png",
"Heading" => "Capçalera",
"Title bar" => "Barra de títol",
// "img/icons/book.png" => "img/icons/book.png",
"Unordered List" => "Llista Desordenada",
// "img/icons/text_list_bullets.png" => "img/icons/text_list_bullets.png",
"Ordered List" => "Llista Ordenada",
// "img/icons/text_list_numbers.png" => "img/icons/text_list_numbers.png",
"Special Characters" => "Caràcters especials",
// "lib/ckeditor_tiki/ckeditor-icons/specialchar.gif" => "lib/ckeditor_tiki/ckeditor-icons/specialchar.gif",
// "img/smiles/icon_smile.gif" => "img/smiles/icon_smile.gif",
"Foreground color" => "Color del davant",
// "img/icons/palette.png" => "img/icons/palette.png",
"Background Color" => "Color de Fons",
// "img/icons/palette_bg.png" => "img/icons/palette_bg.png",
"Wiki Link" => "Enllaç Wiki",
// "img/icons/page_link.png" => "img/icons/page_link.png",
"External Link" => "Enllaç Extern",
// "img/icons/world_link.png" => "img/icons/world_link.png",
// "img/icons/table.png" => "img/icons/table.png",
"Table Builder" => "Constructor de taules",
// "img/icons/find.png" => "img/icons/find.png",
"Find Text" => "Cerca Text",
// "img/icons/text_replace.png" => "img/icons/text_replace.png",
"Text Replace" => "Cerca i reemplaça text",
"Full Screen Edit" => "Edició a pantalla completa",
"Wiki Help" => "Ajuda del Wiki",
// "Wiki Wysiwyg Help" => "Wiki Wysiwyg Help",
"Wysiwyg Help" => "Ajuda Wysiwyg (editor visual)",
"Choose or upload images" => "Escull o puja imatges",
// "img/icons/pictures.png" => "img/icons/pictures.png",
"Choose or upload files" => "Escull o puja arxius",
// "img/icons/file-manager-add.png" => "img/icons/file-manager-add.png",
"Switch Editor (wiki or WYSIWYG)" => "Canvia d'Editor (wiki o WYSIWYG)",
// "img/icons/pencil_go.png" => "img/icons/pencil_go.png",
"Save Sheet" => "Desa el Full",
// "img/icons/disk.png" => "img/icons/disk.png",
// "Add Row After Selection Or To End If No Selection" => "Add Row After Selection Or To End If No Selection",
// "img/icons/sheet_row_add.png" => "img/icons/sheet_row_add.png",
// "Add Multiple Rows After Selection Or To End If No Selection" => "Add Multiple Rows After Selection Or To End If No Selection",
// "img/icons/sheet_row_add_multi.png" => "img/icons/sheet_row_add_multi.png",
// "Add Row Before Selection Or To End If No Selection" => "Add Row Before Selection Or To End If No Selection",
// "Delete Selected Row" => "Delete Selected Row",
// "img/icons/sheet_row_delete.png" => "img/icons/sheet_row_delete.png",
// "Add Column After Selection Or To End If No Selection" => "Add Column After Selection Or To End If No Selection",
// "img/icons/sheet_col_add.png" => "img/icons/sheet_col_add.png",
// "Delete Selected Column" => "Delete Selected Column",
// "img/icons/sheet_col_delete.png" => "img/icons/sheet_col_delete.png",
// "Add Multiple Columns After Selection Or To End If No Selection" => "Add Multiple Columns After Selection Or To End If No Selection",
// "img/icons/sheet_col_add_multi.png" => "img/icons/sheet_col_add_multi.png",
// "Add Column Before Selection Or To End If No Selection" => "Add Column Before Selection Or To End If No Selection",
"Get Cell Range" => "Aconsegueix el rang de les cel·les",
// "img/icons/sheet_get_range.png" => "img/icons/sheet_get_range.png",
"Find" => "Cerca",
"Refresh Calculations" => "Refresca els càlculs",
// "img/icons/arrow_refresh.png" => "img/icons/arrow_refresh.png",
"Finish Editing" => "Acaba l'edició",
// "img/icons/close.png" => "img/icons/close.png",
// "Admin Toolbars" => "Admin Toolbars",
// "Reset Colors" => "Reset Colors",
"Reset" => "Reespecifica",
// "*** ERROR: Tracker ID not set ***" => "*** ERROR: Tracker ID not set ***",
// "*** ERROR: Field ID not set ***" => "*** ERROR: Field ID not set ***",
// "*** ERROR: Tracker %0 not found ***" => "*** ERROR: Tracker %0 not found ***",
// "*** ERROR: Field %0 not found ***" => "*** ERROR: Field %0 not found ***",
// "Problem inserting tracker item: trackerId=%0, created=%1, lastModif=%2, status=%3" => "Problem inserting tracker item: trackerId=%0, created=%1, lastModif=%2, status=%3",
// "Problem converting tracker item link field: trackerId=%0, fieldId=%1, itemId=%2" => "Problem converting tracker item link field: trackerId=%0, fieldId=%1, itemId=%2",
"Field is not numeric" => "El camp no és numèric",
// "Function" => "Function",
// "Tracker field setup error - display field not found: " => "Tracker field setup error - display field not found: ",
"Item Modification" => "Modificació de l'ítem",
"Item creation" => "Creació de l'ítem",
"Item" => "Ïtem",
"Subject" => "Tema",
// "Tracker was modified at %0 by %1" => "Tracker was modified at %0 by %1",
"View the tracker item at:" => "Visualitza l'ítem del formulari a:",
// "Tracker field not enabled: fieldId=%0 type=%1" => "Tracker field not enabled: fieldId=%0 type=%1",
"Message" => "Missatge",
"No extra information for that attached file. " => "No hi ha informació extra per aquest fitxer adjunt. ",
"(AT)" => "(ARROBA)",
"(DOT)" => "(PUNT)",
// "Can create/close a book" => "Can create/close a book",
// "Can create/edit/lock accounts" => "Can create/edit/lock accounts",
// "Create a new transaction" => "Create a new transaction",
// "Permission to view the journal" => "Permission to view the journal",
// "Can book into the stack where statements can be changed" => "Can book into the stack where statements can be changed",
// "Can import statements from external accounts" => "Can import statements from external accounts",
// "Can manage templates for recurring transactions" => "Can manage templates for recurring transactions",
// "Can admin the articles" => "Can admin the articles",
"Can approve submissions" => "Pot aprovar trameses",
"Can admin article topics" => "Pot administrar temes d'articles",
"Can admin article types" => "Pot administrar tipus d'articles",
// "Can read article headings" => "Can read article headings",
// "Submitted articles automatically approved" => "Submitted articles automatically approved",
"Can edit articles" => "Pot editar articles",
"Can edit submissions" => "Pot editar trameses",
"Can read articles" => "Pot llegir articles",
"Can remove articles" => "Pot esborrar articles",
"Can remove submissions" => "Pot esborrar trameses",
"Can submit articles" => "Pot trametre articles",
// "Can rate articles" => "Can rate articles",
"Can read a topic (Applies only to individual topic perms)" => "Pot llegir un tema (només per als casos amb permisos individuals per a temes)",
// "Can view recordings from past meetings" => "Can view recordings from past meetings",
// "Can join a meeting" => "Can join a meeting",
// "Can moderate a meeting" => "Can moderate a meeting",
// "Can create a meeting" => "Can create a meeting",
"Can admin blogs" => "Pot administrar blogs",
"Can assign perms to blog" => "Pot assignar permisos a blocs",
"Can post to a blog" => "Pot publicar en un bloc",
"Can create a blog" => "Pot crear un blog",
"Can read blogs" => "Pot llegir blocs",
// "Can view in module and feed the blog posts" => "Can view in module and feed the blog posts",
// "Can view in module and feed the blog" => "Can view in module and feed the blog",
// "Can create/admin calendars" => "Can create/admin calendars",
"Can add events in the calendar" => "Pot afegir esdeveniments al calendari",
"Can change events in the calendar" => "Pot canviar esdeveniments del calendari",
// "Can browse the calendar" => "Can browse the calendar",
"Can view events details" => "Pot visualitzar informació dels esdeveniments",
// "Can add own user to the participants" => "Can add own user to the participants",
// "Can add guest to the participants" => "Can add guest to the participants",
// "Can view Tiki tools calendar" => "Can view Tiki tools calendar",
"Can admin categories" => "Pot administrar categories",
// "Can see the category in a listing" => "Can see the category in a listing",
// "Can add objects to the category (needs tiki_p_modify_object_categories)" => "Can add objects to the category (needs tiki_p_modify_object_categories)",
// "Can remove objects from the category (needs tiki_p_modify_object_categories)" => "Can remove objects from the category (needs tiki_p_modify_object_categories)",
// "Can assign perms to category)" => "Can assign perms to category)",
// "Administrator can create channels, remove channels, etc" => "Administrator can create channels, remove channels, etc",
"Can use the chat system" => "Pot utilitzar el sistema de xat",
"Can admin received articles" => "Pot administrar articles rebuts",
"Can admin received pages" => "Pot administrar pàgines rebudes",
"Can send articles to other sites" => "Pot enviar articles a altres llocs web",
"Can send articles to this site" => "Pot enviar articles a aquest lloc web",
"Can send pages to this site" => "Pot enviar pàgines a aquest lloc web",
"Can send pages to other sites" => "Pot enviar pàgines a altres llocs web",
"Can post new comments" => "Pot publicar nous comentaris",
"Can read comments" => "Pot llegir comentaris",
"Can admin comments" => "Pot administrar comentaris",
"Can edit all comments" => "Pot editar tots els comentaris",
"Can delete comments" => "Pot esborrar comentaris",
"Can vote comments" => "Pot votar comentaris",
"Can admin content templates" => "Pot administrar plantilles de contingut",
"Can edit content templates" => "Pot editar plantilles de contingut",
"Can use content templates" => "Pot utilitzar plantilles de contingut",
"Can admin contributions" => "Pot administrar contribucions",
"Can admin the directory" => "Pot administrar el directori",
"Can admin directory categories" => "Pot administrar categories de directoris",
"Can admin directory sites" => "Pot administrar enllaços",
// "Submitted links are valid" => "Submitted links are valid",
"Can submit sites to the directory" => "Pot trametre llocs web al directori",
"Can validate submitted links" => "Pot validar els enllaços tramesos",
"Can use the directory" => "Pot utilitzar el directori",
// "Can execute arbitrary queries on a given DSN" => "Can execute arbitrary queries on a given DSN",
"Can admin faqs" => "Pot administrar pmf",
"Can suggest faq questions" => "Pot suggerir preguntes pmf",
"Can view faqs" => "Pot visualitzar pmf",
"Can download files" => "Pot descarregar arxius",
"Can upload files" => "Pot penjar arxius",
"Can list file galleries" => "Pot llistar galeries d'arxius",
"Can view file galleries" => "Pot visualitzar galeries d'arxius",
"Can admin file galleries" => "Pot administrar galeries d'arxius",
"Can assign perms to file gallery" => "Pot assignar permisos a galeries d'arxius",
// "Can use Directory Batch Load" => "Can use Directory Batch Load",
"Can upload zip files with files" => "Pot penjar arxius zip amb arxius",
"Can create file galleries" => "Pot crear galeries d'arxius",
"Can edit a gallery file" => "Pot editar un arxiu de la galeria",
// "Can remove files" => "Can remove files",
"Can view file galleries explorer" => "Pot visualitzar l'explorador de galeries d'arxius",
"Can view file galleries path" => "Pot visualitzar el camí de les galeries d'arxius",
"Can admin forums" => "Pot administrar fòrums",
"Can attach to forum posts" => "Pot adjuntar a publicacions del fòrum",
"Auto approve forum posts" => "Auto aprova les publicacions dels fòrums",
"Can edit own forum posts" => "Pot editar les seves publicacions del fòrum",
"Can post in forums" => "Pot publicar als fòrums",
"Can start threads in forums" => "Pot iniciar fils de discussió als fòrums",
"Can read forums" => "Pot llegir fòrums",
// "Can report posts to moderator" => "Can report posts to moderator",
"Can vote comments in forums" => "Pot votar comentaris de fòrums",
// "Can browse freetags" => "Can browse freetags",
// "Can admin freetags" => "Can admin freetags",
"Can tag objects" => "Pot etiquetar objectes",
"Can unassign tags from an object" => "Pot desassignar etiquetes d'un objecte",
"Can subscribe to groups" => "Pot subscriure a grups",
// "Can invite user to my groups" => "Can invite user to my groups",
// "Can view the group" => "Can view the group",
// "Can view the group members" => "Can view the group members",
// "Can add group members" => "Can add group members",
// "Can remove group members" => "Can remove group members",
// "Can join or leave the group" => "Can join or leave the group",
"Can edit HTML pages" => "Pot editar pàgines HTML",
"Can view HTML pages" => "Pot visualitzar pàgines HTML",
"Can admin Image Galleries" => "Pot administrar galeries d'imatges",
// "Can assign perms to image gallery" => "Can assign perms to image gallery",
"Can upload zip files with images" => "Pot penjar arxius zip amb imatges",
"Can create image galleries" => "Pot crear galeries d'imatges",
"Can list image galleries" => "Pot llistar galeries d'imatges",
"Can upload images" => "Pot penjar imatges",
"Can view image galleries" => "Pot visualitzar galeries d'imatges",
// "Can admin Kaltura video feature" => "Can admin Kaltura video feature",
// "Can upload video or record from webcam" => "Can upload video or record from webcam",
// "Can edit media information" => "Can edit media information",
// "Can create kaltura remix video" => "Can create kaltura remix video",
// "Can delete media" => "Can delete media",
// "Can download media" => "Can download media",
// "Can list media" => "Can list media",
// "Can view media" => "Can view media",
// "Can create new mapfile" => "Can create new mapfile",
// "Can delete mapfiles" => "Can delete mapfiles",
// "Can edit mapfiles" => "Can edit mapfiles",
// "Can view mapfiles" => "Can view mapfiles",
// "Can view contents of mapfiles" => "Can view contents of mapfiles",
"Can broadcast messages to all user" => "Pot difondre missatges a tots els usuaris",
"Can broadcast messages to groups" => "Pot difondre missatges a grups",
"Can use the messaging system" => "Pot utilitzar el sistema de missatgeria",
"Can admin newsletters" => "Pot administrar butlletins",
"Can subscribe many e-mails at once (requires tiki_p_subscribe email)" => "Pot subscriure molts correus-e alhora (requereix tiki_p_subscribe email)",
"Can send newsletters" => "Pot enviar butlletins",
"Can subscribe any email to newsletters" => "Pot subscriure els correus-e als butlletins",
"Can subscribe to newsletters" => "Pot subscriure a butlletins",
// "Can view the archive of a newsletters" => "Can view the archive of a newsletters",
// "Can list newsletters" => "Can list newsletters",
// "Can administer payments" => "Can administer payments",
// "Can view payment requests and details" => "Can view payment requests and details",
// "Can enter manual payments" => "Can enter manual payments",
// "Can request a payment" => "Can request a payment",
// "Can view the perspective" => "Can view the perspective",
// "Can edit the perspective" => "Can edit the perspective",
// "Can create a perspective" => "Can create a perspective",
// "Can admin perspectives" => "Can admin perspectives",
"Can admin polls" => "Pot administrar consultes",
"Can view poll results" => "Pot veure resultats de les consultes",
"Can vote polls" => "Pot votar a les consultes",
// "Can view poll voters" => "Can view poll voters",
"Can admin quizzes" => "Pot administrar concursos",
"Can take quizzes" => "Pot participar a concursos",
"Can view quiz stats" => "Pot visualitzar estadístiques dels concursos",
"Can view user quiz results" => "Pot visualitzar resultats dels usuaris en els concursos",
"Can admin sheet" => "Pot administrar fulls",
"Can create and edit sheets" => "Pot crear i editar fulls",
"Can view sheet" => "Pot visualitzar un full",
"Can view sheet history" => "Pot visualitzar l'historial de fulls",
// "Can admin shoutbox (Edit/remove messages)" => "Can admin shoutbox (Edit/remove messages)",
// "Can post messages in shoutbox" => "Can post messages in shoutbox",
// "Can view shoutbox" => "Can view shoutbox",
// "user can use social network integration" => "user can use social network integration",
// "user can register this site with social networks" => "user can register this site with social networks",
// "Admin live support system" => "Admin live support system",
// "Can use live support system" => "Can use live support system",
"Can admin surveys" => "Pot administrar enquestes",
"Can take surveys" => "Pot fer enquestes",
"Can view survey stats" => "Pot visualitzar estadístiques d'enquestes",
// "Can admin the TikiTests" => "Can admin the TikiTests",
// "Can edit TikiTests" => "Can edit TikiTests",
// "Can replay the TikiTests" => "Can replay the TikiTests",
"Can admin trackers" => "Pot administrar formularis-bd",
"Can attach files to tracker items" => "Pot adjuntar fitxers a elements de formulari",
// "Can view tracker items attachments and download" => "Can view tracker items attachments and download",
"Can insert comments for tracker items" => "Pot inserir comentaris per a registres de formulari",
// "Can view tracker items comments" => "Can view tracker items comments",
"Can create new items for trackers" => "Pot crear nous registres per a formularis-bd",
"Can list trackers" => "Pot llistar formularis-bd",
"Can change tracker items" => "Pot canviar registres de formulari",
// "Can change pending tracker items" => "Can change pending tracker items",
// "Can change closed tracker items" => "Can change closed tracker items",
// "Can remove tracker items" => "Can remove tracker items",
// "Can remove pending tracker items" => "Can remove pending tracker items",
// "Can remove closed tracker items" => "Can remove closed tracker items",
"Can view rating result for tracker items" => "Pot visualitzar el resultat de la valoració de registres de formulari",
"Can vote a rating for tracker items" => "Pot votar per a una valoració de registres de formularis-bd",
// "Can re-vote a rating for tracker items" => "Can re-vote a rating for tracker items",
"Can view trackers" => "Pot visualitzar formularis-bd",
// "Can view closed trackers items" => "Can view closed trackers items",
// "Can view pending trackers items" => "Can view pending trackers items",
"Can watch tracker" => "Pot vigilar formulari",
// "Can export tracker items" => "Can export tracker items",
// "Can save a .CSV backup of entire trackers" => "Can save a .CSV backup of entire trackers",
// "Can trigger the transition between two states" => "Can trigger the transition between two states",
"Can admin users" => "Pot administrar usuaris",
// "Can cache user bookmarks" => "Can cache user bookmarks",
"Can configure modules" => "Pot configurar mòduls",
"Can create user bookmarks" => "Pot crear adreces d'interès d'usuari",
"Can use the mini event calendar" => "Pot utilitzar el minicalendari d'esdeveniments",
"Can use the notepad" => "Pot utilitzar el bloc de notes",
"Can admin public tasks" => "Pot administrar tasques públiques",
"Can use tasks" => "Pot utilitzar tasques",
"Can receive tasks from other users" => "Pot rebre tasques d'altres usuaris",
"Can send tasks to other users" => "Pot enviar tasques a altres usuaris",
"Can upload personal files" => "Pot penjar arxius personals",
"Can create items in personal menu" => "Pot crear elements al menú personal",
"Can list registered users" => "Pot llistar usuaris registrats",
// "Can invite users by email, and include them in groups" => "Can invite users by email, and include them in groups",
"Can use webmail" => "Pot utilitzar el correu web",
// "Can use group webmail" => "Can use group webmail",
// "Can admin group webmail accounts" => "Can admin group webmail accounts",
// "Can use personal webmail accounts" => "Can use personal webmail accounts",
// "Can admin personal webmail accounts" => "Can admin personal webmail accounts",
"Can view page/pages" => "Pot visualitzar pàgina/es",
"Can edit pages" => "Pot editar pàgines",
"Can view wiki history" => "Pot visualitzar historials wiki",
"Can admin the wiki" => "Pot administrar el wiki",
"Can assign perms to wiki pages" => "Pot assignar permisos a pàgines wiki",
"Can edit copyright notices" => "Pot editar avisos de copyright",
"Can edit dynamic variables" => "Pot editar variables dinàmiques",
"Can create and edit structures" => "Pot crear i editar estructures",
// "Can export wiki pages using the export feature" => "Can export wiki pages using the export feature",
"Can lock pages" => "Pot bloquejar pàgines",
"Can save as minor edit" => "Pot guardar com a edició menor",
"Can remove" => "Pot esborrar",
"Can rename pages" => "Pot canviar noms de pàgines",
// "Can rollback pages" => "Can rollback pages",
"Can upload pictures to wiki pages" => "Pot penjar imatges en pàgines wiki",
// "Can use the page as a tracker template" => "Can use the page as a tracker template",
// "Can view in module and feed the wiki pages reference" => "Can view in module and feed the wiki pages reference",
"Can watch structure" => "Pot vigilar estructura",
// "Can admin attachments on wiki pages" => "Can admin attachments on wiki pages",
"Can add and change ratings on wiki pages" => "Pot afegir i canviar valoracions a les pàgines wiki",
"Can attach files to wiki pages" => "Pot adjuntar fitxers a pàgines wiki",
"Can view wiki attachments and download" => "Pot visualitzar fitxers wiki adjunts i descarregar-los",
"Can view wiki comments" => "Pot visualitzar comentaris wiki",
"Can view rating of wiki pages" => "Pot visualitzar la valoració de pàgines wiki",
"Can view source of wiki pages" => "Pot visualitzar l'origen de les pàgines wiki",
// "Can participate to rating of wiki pages" => "Can participate to rating of wiki pages",
// "Can view similar wiki pages" => "Can view similar wiki pages",
// "View page backlinks" => "View page backlinks",
// "Can view unapproved revisions of pages" => "Can view unapproved revisions of pages",
// "Can approve revisions of pages" => "Can approve revisions of pages",
// "Can view contributions to a page" => "Can view contributions to a page",
// "Administrator can manage users, groups and permissions and all features" => "Administrator can manage users, groups and permissions and all features",
"Can access site when closed" => "Pot accedir al lloc web quan està tancat",
// "Administrator can admin banners" => "Administrator can admin banners",
// "Can ban users or ips" => "Can ban users or ips",
"Can admin the dynamic content system" => "Pot administrar el sistema de contingut dinàmic",
// "Can admin integrator repositories and rules" => "Can admin integrator repositories and rules",
"Can admin mail-in accounts" => "Pot administrar comptes de correu-dins",
"Can edit object permissions" => "Pot editar permisos d'objectes",
// "Can admin external feeds" => "Can admin external feeds",
"Can clean cache" => "Pot esborrar la memòria cau",
// "Can create new css suffixed with -user" => "Can create new css suffixed with -user",
"Can remove association between two pages in a translation set" => "Pot eliminar l'associació entre dues pàgines en un conjunt de traducció",
"Can admin cookies" => "Pot administrar galetes",
"Can edit translations and create new languages" => "Pot editar traduccions i crear nous llenguatges",
"Can edit menu" => "Pot editar menús",
"Can edit menu option" => "Pot editar opcions de menú",
"Can edit site templates" => "Pot editar plantilles de lloc web",
"Can search" => "Pot buscar",
"Can report a link to the webmaster" => "Pot informar d'un enllaç a l'administrador",
"Can send a link to a friend" => "Pot enviar un enllaç a un amic",
// "Can share a page (email, Twitter, Facebook, message, forums)" => "Can share a page (email, Twitter, Facebook, message, forums)",
"Can use HTML in pages" => "Pot utilitzar HTML a les pàgines",
// "Can view action log" => "Can view action log",
// "Can view action log for users of his own groups" => "Can view action log for users of his own groups",
"Can view integrated repositories" => "Pot visualitzar repositoris integrats",
// "Can view referrer stats" => "Can view referrer stats",
"Can view site stats" => "Pot visualitzar estadístiques",
"Can view site templates" => "Pot visualitzar plantilles de llocs web",
// "Can admin toolbars" => "Can admin toolbars",
// "Trust all user inputs including plugins (no security checks)" => "Trust all user inputs including plugins (no security checks)",
// "Can view unapproved plugin details" => "Can view unapproved plugin details",
// "Can execute unapproved plugin registered" => "Can execute unapproved plugin registered",
// "Can approve plugin execution" => "Can approve plugin execution",
// "Can admin mail notifications" => "Can admin mail notifications",
// "Can delete his/her own account" => "Can delete his/her own account",
// "Can use the importer" => "Can use the importer",
// "Can change the categories of the object" => "Can change the categories of the object",
// "User can administer modules" => "User can administer modules",
// "Can switch between wiki and WYSIWYG modes while editing" => "Can switch between wiki and WYSIWYG modes while editing",
// "User \"%0\" is banned from the group \"%1\"" => "User \"%0\" is banned from the group \"%1\"",
// "Do you want to unban them and continue" => "Do you want to unban them and continue",
// "Password should be at least %0 characters long" => "Password should be at least %0 characters long",
"Password must contain both letters and numbers" => "La contrasenya ha de contenir tant lletres com números",
"The administrator has not yet validated your account. Please wait." => "L'administrator no ha validat el teu compte encara. Si us plau, espera.",
"You must validate your account first. An email has been sent to you" => "Primer has de validar el teu compte. Se t'ha enviat un correu-e",
"The registration mail can't be sent. Contact the administrator" => "No es pot enviar el mail de registre. Contacteu amb l'administrador",
"The registration mail can't be sent because there is no server email address set, and this feature is disabled" => "No es pot enviar el correu-e de registre de noves altes per que no hi ha especificada cap adreça de correu-e, i la funcionalitat està desactivada",
"The user email confirmation can't be sent. Contact the administrator" => "No es pot enviar el correu-e de confirmació de l'usuari. Contacta l'administrador",
// "Edit field: (Parameter needs to be 'trackerId=XX&fileId=YY' or be empty to use the current field)" => "Edit field: (Parameter needs to be 'trackerId=XX&fileId=YY' or be empty to use the current field)",
// "Edit field: (Incorrect validation parameter)" => "Edit field: (Incorrect validation parameter)",
"Page already exists" => "la pàgina ja existeix",
// "Page does not exist" => "Page does not exist",
"Invalid character combination for username" => "Combinació de caracters invàlida com a nom d'usuari",
"here" => "aquí",
// "Could not establish Kaltura session. Try again" => "Could not establish Kaltura session. Try again",
// "You need to set your Kaltura account details: " => "You need to set your Kaltura account details: ",
// "Cannot connect with web service" => "Cannot connect with web service",
// "No permission to broadcast to channel" => "No permission to broadcast to channel",
// "Broadcaster successfully authenticated" => "Broadcaster successfully authenticated",
// "No permission to broadcast to any channel" => "No permission to broadcast to any channel",
// "Successfully logged in mobile broadcaster" => "Successfully logged in mobile broadcaster",
// "No viewable channels available for mobile" => "No viewable channels available for mobile",
// "Failed to log in mobile broadcaster" => "Failed to log in mobile broadcaster",
// "Successfully logged in FME" => "Successfully logged in FME",
// "Failed to log in FME" => "Failed to log in FME",
// "No permission to view channel" => "No permission to view channel",
// "Viewer successfully authenticated" => "Viewer successfully authenticated",
// "No permission to view any channel" => "No permission to view any channel",
// "Successfully stored archive in tracker" => "Successfully stored archive in tracker",
// "Failed to stored archive in tracker" => "Failed to stored archive in tracker",
"Personal Phone" => "Telèfon personal",
"Personal Mobile" => "Mòbil personal",
"Personal Fax" => "Fax personal",
"Work Phone" => "Telèfon de la feina",
"Work Mobile" => "Mòbil de la feina",
"Work Fax" => "Fax de la feina",
"Company" => "Empresa",
"Organization" => "Organització",
"Department" => "Departament",
"Division" => "Divisió",
"Job Title" => "Càrrec",
"Street Address" => "Adreça",
"City" => "Població",
"State" => "Estat",
"Zip Code" => "Codi postal",
// "Mailbox uninitialised??" => "Mailbox uninitialised??",
"No subject" => "No hi ha cap assumpte",
// "No mail body found" => "No mail body found",
"Cannot create aliased page" => "No es pot crear una pàgina que ja està emulada a través d'un alias",
"You attempted to create the following page" => "Has intentat crear la següent pàgina",
"That page is an alias for the following pages" => "Aquesta pàgina és un alias per a les següents pàgines",
"If you want to create the page, you must first edit each the pages above, and remove the alias link it may contain. This link should look something like this" => "Si realment vols crear la pàgina, primer has d'editar cadascuna de les pàgines de més amunt, i eliminar l'enllaç de tipus alias que contenen. Aquest enllaç hauria de semblar quelcom com",
// "Can't parse HTML data - no grammar file" => "Can't parse HTML data - no grammar file",
"Removed version \$version" => "Versió \$version eliminada",
// "rollback version " => "rollback version ",
"Changed actual version to \$version" => "La versió actual s'ha canviat a \$version",
"No version indicated" => "No s'ha indicat cap versió",
"Plugin " => "Connector (plugin) ",
"failed" => "sense èxit",
// "Required parameters are in</em> <b>bold</b>" => "Required parameters are in</em> <b>bold</b>",
// "Parameter Info" => "Parameter Info",
// "There are no approved versions of this page" => "There are no approved versions of this page",
// "Semantic token already exists" => "Semantic token already exists",
// "Invalid semantic token name" => "Invalid semantic token name",
// "Semantic token not found" => "Semantic token not found",
"Page locked" => "Pàgina bloquejada",
"Page unlocked" => "Pàgina desbloquejada",
"Removed last version" => "Úlitma versió eliminada",
// "Add Freetag" => "Add Freetag",
// "Add a single freetag to specified object" => "Add a single freetag to specified object",
"Object" => "Objecte",
// "Object type and id, as in type:id, if unset, will use current object" => "Object type and id, as in type:id, if unset, will use current object",
// "Add Relation" => "Add Relation",
// "Displays a simple button that toggles i.e. adds or removes a pre-specified relation" => "Displays a simple button that toggles i.e. adds or removes a pre-specified relation",
// "Qualifier" => "Qualifier",
// "Relation qualifier. Usually a three part string separated by 2 periods" => "Relation qualifier. Usually a three part string separated by 2 periods",
// "Source Object" => "Source Object",
// "Object identifier as type:itemId to start the relation from, will use the current object if left blank" => "Object identifier as type:itemId to start the relation from, will use the current object if left blank",
// "Target Object" => "Target Object",
// "Object identifier as type:itemId to end the relation to, will use the current object if left blank" => "Object identifier as type:itemId to end the relation to, will use the current object if left blank",
// "Button Text for Add" => "Button Text for Add",
// "Text to show on the button to add relation" => "Text to show on the button to add relation",
// "Button Text for Already Added State" => "Button Text for Already Added State",
// "Text to show on the button when relation is already added" => "Text to show on the button when relation is already added",
// "Relation Added" => "Relation Added",
// "Mouseover Button Text for Remove" => "Mouseover Button Text for Remove",
// "Text to show on the button to remove relation" => "Text to show on the button to remove relation",
// "Remove Relation" => "Remove Relation",
// "Button Id" => "Button Id",
// "A unique ID to distinguish the button from others on the page if there is more than one" => "A unique ID to distinguish the button from others on the page if there is more than one",
// "Source and target object cannot be the same" => "Source and target object cannot be the same",
// "Add to cart" => "Add to cart",
// "PluginAddToCart" => "PluginAddToCart",
// "Adds a product to the virtual cart. The cart can be manipulated using the cart module" => "Adds a product to the virtual cart. The cart can be manipulated using the cart module",
// "Product code" => "Product code",
// "Unique identifier for the product. Two products with the same code will be the same and the information used will be the one of the first in" => "Unique identifier for the product. Two products with the same code will be the same and the information used will be the one of the first in",
// "Label for the product in the cart" => "Label for the product in the cart",
// "Product Type" => "Product Type",
// "The product type that is being sold, which will affect fulfillment, e.g. standard product, gift certificate, event ticket" => "The product type that is being sold, which will affect fulfillment, e.g. standard product, gift certificate, event ticket",
// "Product Class" => "Product Class",
// "The class the product belongs to, can be used to limit how gift cards are used" => "The class the product belongs to, can be used to limit how gift cards are used",
// "Product Bundle" => "Product Bundle",
// "The bundle the product belongs to, can be used to limit how gift cards are used, will automatically add other products in same class to cart" => "The bundle the product belongs to, can be used to limit how gift cards are used, will automatically add other products in same class to cart",
// "Bundle Class" => "Bundle Class",
// "The class the bundle belongs to, can be used to limit how gift cards are used" => "The class the bundle belongs to, can be used to limit how gift cards are used",
// "Price" => "Price",
// "The price to charge for the item" => "The price to charge for the item",
// "URL of the product's information. The URL may be relative or absolute (begin with http://)" => "URL of the product's information. The URL may be relative or absolute (begin with http://)",
// "Button label" => "Button label",
// "Text for the submit button. default: \"Add to cart\"" => "Text for the submit button. default: \"Add to cart\"",
// "Associated event code" => "Associated event code",
// "Unique identifier for the event that is associated to the product" => "Unique identifier for the event that is associated to the product",
// "Automatically checkout" => "Automatically checkout",
// "Automatically checkout for purchase and send user to pay (this is disabled when there is already something in the cart)" => "Automatically checkout for purchase and send user to pay (this is disabled when there is already something in the cart)",
// "Buy on behalf of" => "Buy on behalf of",
// "Allows the selection of user to make purchase on behalf of" => "Allows the selection of user to make purchase on behalf of",
// "Shop as anonymous always" => "Shop as anonymous always",
// "Add to cart as anonymous shopper even if logged in" => "Add to cart as anonymous shopper even if logged in",
// "Forward to this URL after free purchase" => "Forward to this URL after free purchase",
// "Gift certificate" => "Gift certificate",
// "Allows user to add gift certificate from the product view" => "Allows user to add gift certificate from the product view",
// "Order Item ID to exchange product" => "Order Item ID to exchange product",
// "Used in conjunction with exchange feature" => "Used in conjunction with exchange feature",
// "Product ID to exchange to" => "Product ID to exchange to",
// "Amount of new product to exchange for" => "Amount of new product to exchange for",
// "Should normally be set to the amount of products in the order being exchanged" => "Should normally be set to the amount of products in the order being exchanged",
// "Ajax add to cart feature" => "Ajax add to cart feature",
// "Attempts to turn ajax for cart on" => "Attempts to turn ajax for cart on",
// "A session must be active to use the cart" => "A session must be active to use the cart",
// "Please enter your shopper information first" => "Please enter your shopper information first",
// "The order was recorded and is now awaiting payment. Reference number is %0" => "The order was recorded and is now awaiting payment. Reference number is %0",
// "Your free order of %0 (%1) has been processed. An email has been sent to you for your records" => "Your free order of %0 (%1) has been processed. An email has been sent to you for your records",
// "Your free order of %0 (%1) has been processed" => "Your free order of %0 (%1) has been processed",
// "%0 (%1) was added to your cart" => "%0 (%1) was added to your cart",
// "Invalid gift certificate: " => "Invalid gift certificate: ",
// "Add to Google Calendar" => "Add to Google Calendar",
// "Add a calendar item to a Google calendar" => "Add a calendar item to a Google calendar",
// "Calendar item ID" => "Calendar item ID",
// "The item ID of the calendar to add to Google calendar" => "The item ID of the calendar to add to Google calendar",
// "A calendar item ID number" => "A calendar item ID number",
// "Icon Style" => "Icon Style",
// "Choose the icon style" => "Choose the icon style",
// "Either 1, 2 or 3" => "Either 1, 2 or 3",
// "One" => "One",
// "Two" => "Two",
// "Three" => "Three",
// "Adjust Inventory" => "Adjust Inventory",
// "PluginAdjustInventory" => "PluginAdjustInventory",
// "Modifies inventory of a product" => "Modifies inventory of a product",
// "Product ID" => "Product ID",
// "Product ID of item in the cart tracker" => "Product ID of item in the cart tracker",
// "Show add" => "Show add",
// "y|n" => "y|n",
// "Show subtract" => "Show subtract",
// "Inventory was adjusted by %0" => "Inventory was adjusted by %0",
// "User Agent Info" => "User Agent Info",
// "Show user's browser and server information" => "Show user's browser and server information",
"Info" => "Info",
// "Display's the visitor's IP address (IP or default), browser information (BROWSER), or server software (SVRSW)" => "Display's the visitor's IP address (IP or default), browser information (BROWSER), or server software (SVRSW)",
// "IP address" => "IP address",
// "Server software" => "Server software",
// "Browser" => "Browser",
"Anchor Link" => "Enllaç àncora",
// "Create a link to an anchor" => "Create a link to an anchor",
"Anchor link label" => "Etiqueta de l'àncora",
"Anchor Name" => "Nom de l'Àncora",
"The anchor name as defined in the ANAME plugin" => "El nom de l'àncora tal i com es defineix en el connector ANAME",
// "The name of the wiki page containing the anchor. If empty, the anchor name will be searched for on the wiki page where the plugin is used" => "The name of the wiki page containing the anchor. If empty, the anchor name will be searched for on the wiki page where the plugin is used",
// "Create an anchor that can be linked to" => "Create an anchor that can be linked to",
"The name of the anchor" => "El nom de l'àncora",
"Image Annotation" => "Annotació d'Imatges",
// "Annotate an image" => "Annotate an image",
"Autogenerated content. Leave blank initially" => "Contingut autogenerat. Deixa inicialment en blanc",
// "Absolute URL to the image or relative path from tiki root" => "Absolute URL to the image or relative path from tiki root",
// "Image width in pixels" => "Image width in pixels",
// "Image height in pixels" => "Image height in pixels",
"Alignment" => "Alineació",
// "Image alignment. Possible values: left, right, center. Default is left" => "Image alignment. Possible values: left, right, center. Default is left",
"Center" => "Centra",
"Save changes to annotations" => "Desa els canvis a les anotacions",
"Image annotations changed" => "Les anotacions de la imatge han canviat",
// "Application Frame" => "Application Frame",
// "Creates a frame to assemble custom applications in. Components in the frame will be various wiki pages and modules" => "Creates a frame to assemble custom applications in. Components in the frame will be various wiki pages and modules",
// "Application layout" => "Application layout",
// "Minimal height" => "Minimal height",
// "Prevent the frame from becoming any shorter than the specified size" => "Prevent the frame from becoming any shorter than the specified size",
// "Hide left column" => "Hide left column",
// "Hide the left column when the application frame is in use to provide more space to the application" => "Hide the left column when the application frame is in use to provide more space to the application",
// "Hide right column" => "Hide right column",
// "Hide the right column when the application frame is in use to provide more space to the application" => "Hide the right column when the application frame is in use to provide more space to the application",
// "Full page" => "Full page",
// "Occupy the complete content area of the page" => "Occupy the complete content area of the page",
// "Absolute Position" => "Absolute Position",
// "Position the app frame to use absolute position and really use all available space" => "Position the app frame to use absolute position and really use all available space",
// "When using absolute mode, leave some space for the header at the top" => "When using absolute mode, leave some space for the header at the top",
// "Template file not found: %0" => "Template file not found: %0",
// "Pan/Zoom" => "Pan/Zoom",
"Select" => "Seleccionar",
// "Select/Modify" => "Select/Modify",
// "Draw Polygon" => "Draw Polygon",
// "Draw Path" => "Draw Path",
// "Reset Zoom" => "Reset Zoom",
// "Archive Builder" => "Archive Builder",
// "Build a zip archive that can be downloaded" => "Build a zip archive that can be downloaded",
// "Description of the archive content. Multiple handlers are available for content types. One per line. Ex: page-as-pdf:some-folder/foo.pdf:HomePage , tracker-attachments:target-folder/:3435" => "Description of the archive content. Multiple handlers are available for content types. One per line. Ex: page-as-pdf:some-folder/foo.pdf:HomePage , tracker-attachments:target-folder/:3435",
// "Archive Name" => "Archive Name",
// "Upon download, the name of the file that will be provided" => "Upon download, the name of the file that will be provided",
// "Missing extension zip" => "Missing extension zip",
// "Incorrect parameter" => "Incorrect parameter",
// "Download archive" => "Download archive",
// "Display a field of an article" => "Display a field of an article",
"The article field to display. Default field is Heading" => "El camp de l'article a mostrar. El camp per omissió és la Capçalera",
"Article ID" => "ID de l'article",
"The article to display. If no value is provided, most recent article will be used" => "Article a mostrar. Si no es dóna cap valor, s'emprarà l'article més recent",
"Article List" => "Llista d'Articles",
// "Display multiple articles" => "Display multiple articles",
// "Use Pagination" => "Use Pagination",
// "Activate pagination when articles listing are long. Default is n" => "Activate pagination when articles listing are long. Default is n",
// "Maximum Displayed" => "Maximum Displayed",
// "The number of articles to display in the list (no max set by default)" => "The number of articles to display in the list (no max set by default)",
// "If Pagination is set to y (Yes), this will determine the amount of articles per page" => "If Pagination is set to y (Yes), this will determine the amount of articles per page",
// "Topic Name Filter" => "Topic Name Filter",
// "Filter the list of articles by topic. Example: " => "Filter the list of articles by topic. Example: ",
// "Topic ID Filter" => "Topic ID Filter",
// "Filter the list of articles by topic ID. Example: " => "Filter the list of articles by topic ID. Example: ",
// "Type Filter" => "Type Filter",
// "Filter the list of articles by types. Example: " => "Filter the list of articles by types. Example: ",
"Category ID" => "ID de categoria",
// "The ID of the category that articles need to be in to be listed" => "The ID of the category that articles need to be in to be listed",
// "List only articles in this language" => "List only articles in this language",
"Sort order" => "Ordenació",
// "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")" => "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")",
// "Use random to have random items" => "Use random to have random items",
// "Specific order" => "Specific order",
// "List of ArticleId that must appear in this order if present" => "List of ArticleId that must appear in this order if present",
// "Only these articles" => "Only these articles",
// "List of ArticleId to display separated by |" => "List of ArticleId to display separated by |",
// "Not these articles" => "Not these articles",
// "List of ArticleId that can not be displayed separated by |" => "List of ArticleId that can not be displayed separated by |",
"Quiet" => "Silenciós",
// "Whether to not report when there are no articles (no reporting by default)" => "Whether to not report when there are no articles (no reporting by default)",
// "Title Only" => "Title Only",
// "Whether to only show the title of the articles (not set to title only by default)" => "Whether to only show the title of the articles (not set to title only by default)",
// "Body Only" => "Body Only",
// "Whether to only show the body of the articles or just the heading and title. (not set to body only by default)" => "Whether to only show the body of the articles or just the heading and title. (not set to body only by default)",
// "Starting Article" => "Starting Article",
// "The article number that the list should start with (starts with first article by default)" => "The article number that the list should start with (starts with first article by default)",
// "This will not work if Pagination is used" => "This will not work if Pagination is used",
"Start Date" => "Data d'inici",
// "Earliest date to select articles from" => "Earliest date to select articles from",
// " (YYYY-MM-DD)" => " (YYYY-MM-DD)",
"End date" => "Data de finalització",
// "Latest date to select articles from" => "Latest date to select articles from",
// "Period quantity" => "Period quantity",
// "Numeric value to display only last articles published within a user defined time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how many of those units are to be considered to define the time frame. If this parameter is set, \"Start Date\" and \"End date\" are ignored" => "Numeric value to display only last articles published within a user defined time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how many of those units are to be considered to define the time frame. If this parameter is set, \"Start Date\" and \"End date\" are ignored",
// "Period unit" => "Period unit",
// "Time unit used with \"Period quantity\"" => "Time unit used with \"Period quantity\"",
// "Override Dates" => "Override Dates",
// "Whether to obey article type's \"show before publish\" and \"show after expiry\" settings (not obeyed by default)" => "Whether to obey article type's \"show before publish\" and \"show after expiry\" settings (not obeyed by default)",
// "Container class" => "Container class",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")",
// "Large First Image" => "Large First Image",
// "If set to y (Yes), the first image will be displayed with the dimension used to view of the article" => "If set to y (Yes), the first image will be displayed with the dimension used to view of the article",
// "Additional URL Param to the link to read article" => "Additional URL Param to the link to read article",
// "Show actions (buttons and links)" => "Show actions (buttons and links)",
// "Whether to show the buttons and links to do actions on each article (for the actions you have permission to do" => "Whether to show the buttons and links to do actions on each article (for the actions you have permission to do",
// "No translation" => "No translation",
// "User or pipe separated list of two letter language codes for additional languages to display. List pages with no language or with a missing translation in one of the language" => "User or pipe separated list of two letter language codes for additional languages to display. List pages with no language or with a missing translation in one of the language",
"Displays an attachment or a list of them" => "Mostra un adjunt o una llista d'adjunts",
// "File name of the attached file to link to. Either name, file, id or num can be used to identify a single attachment" => "File name of the attached file to link to. Either name, file, id or num can be used to identify a single attachment",
"File" => "Fitxer",
"Same as name" => "Igual que el nom",
// "Name of the wiki page the file is attached to. If left empty when the plugin is used on a wiki page, this defaults to that wiki page" => "Name of the wiki page the file is attached to. If left empty when the plugin is used on a wiki page, this defaults to that wiki page",
// "Show Description" => "Show Description",
// "Shows the description as the link text instead of the file name (not used by default)" => "Shows the description as the link text instead of the file name (not used by default)",
"Bullets" => "Vinyetes",
// "Makes the list of attachments a bulleted list (not set by default)" => "Makes the list of attachments a bulleted list (not set by default)",
// "Indicates that this file is an image, and should be displayed inline using the img tag (not set by default)" => "Indicates that this file is an image, and should be displayed inline using the img tag (not set by default)",
// "Custom Label" => "Custom Label",
// "Makes the text between the {ATTACH} tags the link text instead of the file name or description. Only the first attachment will be listed" => "Makes the text between the {ATTACH} tags the link text instead of the file name or description. Only the first attachment will be listed",
// "Lists links to all attachments for the entire tiki site together with pages they are attached to when set to 1 (Yes)" => "Lists links to all attachments for the entire tiki site together with pages they are attached to when set to 1 (Yes)",
// "Order Number" => "Order Number",
// "Identifies the attachment to link to by the order of the attachment in the list of attachments to a page instead of by file name or ID. Either name, file, id or num can be used to identify a single attachment" => "Identifies the attachment to link to by the order of the attachment in the list of attachments to a page instead of by file name or ID. Either name, file, id or num can be used to identify a single attachment",
// "Identifies the attachment to link to by id number instead of by file name or order number. Either name, file, id or num can be used to identify a single attachment" => "Identifies the attachment to link to by id number instead of by file name or order number. Either name, file, id or num can be used to identify a single attachment",
// "The alt text that pops up on mouseover will include the number of downloads of the attachment at the end when set to 1 (Yes)" => "The alt text that pops up on mouseover will include the number of downloads of the attachment at the end when set to 1 (Yes)",
// "File Type Icon" => "File Type Icon",
// "A file type icon is displayed in front of the attachment link when this is set to 1" => "A file type icon is displayed in front of the attachment link when this is set to 1",
// "Page \"%0\" does not exist" => "Page \"%0\" does not exist",
"No such attachment on this page" => "Aquest fitxer adjunt no és en aquesta pàgina",
// "Attributes" => "Attributes",
// "Assign generic attributes to the current object" => "Assign generic attributes to the current object",
// "View author contributions to a wiki page" => "View author contributions to a wiki page",
"text" => "text",
// "User name of the user who wrote the text" => "User name of the user who wrote the text",
// "Deleted by User" => "Deleted by User",
// "User name of the user who deleted the text" => "User name of the user who deleted the text",
// "Make Visible" => "Make Visible",
// "Show popup with author/deleted by" => "Show popup with author/deleted by",
// "Generate a popup with names of author(s) (default: no)" => "Generate a popup with names of author(s) (default: no)",
// "deleted by" => "deleted by",
// "Should this author's contribution be visible (default: no)" => "Should this author's contribution be visible (default: no)",
"Avatar" => "Avatar",
// "Display a user's avatar" => "Display a user's avatar",
// "The wiki page the avatar will link to. If empty and the user's information is public, \n\t\t\t\t\t\t\t\tthen the avatar will link automatically the that user's user information page" => "The wiki page the avatar will link to. If empty and the user's information is public, \n\t\t\t\t\t\t\t\tthen the avatar will link automatically the that user's user information page",
"Float" => "Flota",
// "Align the avatar on the page" => "Align the avatar on the page",
"Back" => "Enrera",
// "Displays a link that goes back one page in the browser history" => "Displays a link that goes back one page in the browser history",
// "Lists all pages that link to a particular page" => "Lists all pages that link to a particular page",
"The page links will point to. Default value is the current page" => "A on apuntaran els enllaços de la pàgina. El valor per omissió és a la mateixa pàgina",
// "Displayed Information" => "Displayed Information",
"Pipe separated list of fields to display. ex: hits|user" => "Lista de camps separada per barres verticalsa mostrar. exexmple: hits|user",
"Excluded pages" => "Pàgines excloses",
"Pipe separated list of pages to be excluded from the listing. ex: HomePage|Sandbox" => "Llista de pàgines separada per barres verticals a excloure del llistat. exemple: HomePage|Sandbox",
"Include Self" => "Inclou-re's a si mateix",
// "With or without self-link (default is without)" => "With or without self-link (default is without)",
// "With or without header (default is with header)" => "With or without header (default is with header)",
// "With header" => "With header",
// "Without header" => "Without header",
// "No pages link to" => "No pages link to",
"One page links to" => "Una pàgina apunta a",
"pages link to" => "pàgines que apunten a",
"Banner" => "Pancarta (Banner)",
// "Add a banner" => "Add a banner",
"Zone" => "Zona",
// "Name of the zone created in Admin > Banners" => "Name of the zone created in Admin > Banners",
"Target" => "Destí",
// "Determines the browser behavior once the banner is clicked" => "Determines the browser behavior once the banner is clicked",
"missing parameter" => "manca paràmetre",
// "BigBlueButton" => "BigBlueButton",
"Starts a video/audio/chat/presentation session using BigBlueButton" => "Comença una sessió de video/audio/xat/presentació emprant el programari BigBlueButton",
"Meeting" => "Trobada",
"MeetingID for BigBlueButton. This is a 5 digit number, starting with a 7. Ex.: 77777 or 71111" => "IDdeTrobada per a BigBlueButton. Aquest és un número de 5 dígits, començant per 7. Per ex.: 77777 o 71111",
"Anonymous prefix" => "Prefix per a anònims",
"Unregistered users will get this token prepended to their name" => "Els usuaris no registrats rebran aquest text com a prefix del nom d'usuari que escullin en entrar a la Trobada",
"Welcome Message" => "Missatge de Benvinguda",
"A message to be provided when someone enters the room" => "Missatge que es mostrarà quan algú entri a la sala de la trobada",
"Dial Number" => "Número per a trucades",
"The phone-in support number to join from traditional phones" => "El número per a rebre trucades entrants que vinguin de telèfons tradicionals",
"Voice Bridge" => "Pont de veu",
"Code to enter for phone attendees to join the room. Typically, the same 5 digits of the MeetingID" => "Codi que hauran d'introduir els assistents per telèfon per a unirse a la trobada. Típicament, els mateixos 5 dígits de l'IDdeTrobada",
"Log-out URL" => "URL post-desconnexió",
"URL to which the user will be redirected when logging out from BigBlueButton" => "URL a la que re-dirigir als usuaris un cop es desconnectin de la trobada en BigBlueButton",
"Record meetings" => "Registra les Trobades",
"Requires BBB >= 0.8" => "Requereix BBB >= 0.8",
"Off" => "Inactiu",
"On" => "Actiu",
"BigBlueButton misconfigured or unaccessible" => "El BigBlueButton es troba malament configurat o innaccessible per alguna raó",
// "Bliptv" => "Bliptv",
// "Display a Blip.tv video" => "Display a Blip.tv video",
// "Blip.tv embed URL. Example: http://blip.tv/play/AYGd_GAC" => "Blip.tv embed URL. Example: http://blip.tv/play/AYGd_GAC",
// "Width in pixels (default is 425" => "Width in pixels (default is 425",
// "Height in pixels (default is 350)" => "Height in pixels (default is 350)",
"Blog List" => "Llista de bitàcoles",
// "Display posts from a site blog" => "Display posts from a site blog",
"Blog ID" => "ID del bloc",
// "The ID number of the blog on the site you wish to list posts from" => "The ID number of the blog on the site you wish to list posts from",
// "Maximum Items" => "Maximum Items",
// "Maximum number of entries to list (no maximum set by default)" => "Maximum number of entries to list (no maximum set by default)",
// "Only display posts created by this user (all posts listed by default)" => "Only display posts created by this user (all posts listed by default)",
// "Simple List" => "Simple List",
// "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)" => "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)",
// "Earliest date to select posts from" => "Earliest date to select posts from",
"End Date" => "Data final",
// "Latest date to select posts from" => "Latest date to select posts from",
// "Container Class" => "Container Class",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")",
// "Contains Html" => "Contains Html",
// "Body of the blog posts should be parsed as containing HTML (default=n)" => "Body of the blog posts should be parsed as containing HTML (default=n)",
// "Creates a formatted box with a title bar" => "Creates a formatted box with a title bar",
"Box title" => "Títol de la caixa",
"Displayed above the content" => "Mostrat sobre el contingut",
"Background color" => "Color del rerafons",
"As defined by CSS, name or Hex code" => "Tal i com es defineix pel CSS, nom o codi Hex",
"Box width" => "Amplada de la caixa",
"In pixels or percentage. Default value is 100%" => "En pixels o percentatge. El valor per omissió és 100%",
"Text Alignment" => "Alineació del text",
// "Aligns the text within the box (left aligned by default)" => "Aligns the text within the box (left aligned by default)",
"Float Position" => "Posició flotant",
// "Set the alignment for the entire box. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)" => "Set the alignment for the entire box. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)",
"Clear" => "Neteja",
// "Items are not allowed to wrap around the box if this parameter is set to.1 (Yes)" => "Items are not allowed to wrap around the box if this parameter is set to.1 (Yes)",
"CSS Class" => "Classe CSS",
"Apply custom CSS class to the box" => "Aplica classe CSS particular a la caixa",
// "Button" => "Button",
// "Add a link formatted as a button" => "Add a link formatted as a button",
"Url" => "Url",
// "URL to be produced by the button. You can use wiki argument variables like {{itemId}} in it" => "URL to be produced by the button. You can use wiki argument variables like {{itemId}} in it",
// "CSS class for the button" => "CSS class for the button",
"Label" => "Etiqueta",
// "Label for the button" => "Label for the button",
// "lib/smarty_tiki/function.button.php is missing or unreadable" => "lib/smarty_tiki/function.button.php is missing or unreadable",
// "Display a calendar and its events" => "Display a calendar and its events",
// "Calendar IDs" => "Calendar IDs",
// "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by commas (\",\")" => "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by commas (\",\")",
// "Example values" => "Example values",
// "Not set by default" => "Not set by default",
// "View Type" => "View Type",
// "Determines how to show events" => "Determines how to show events",
// "Possible values" => "Possible values",
// "\"table\" shows events in a calendar" => "\"table\" shows events in a calendar",
"List" => "Llista",
"Table" => "Taula",
// "View Time Span" => "View Time Span",
// "If in calendar (or \"table\") view type, determines the time span displayed by the calendar" => "If in calendar (or \"table\") view type, determines the time span displayed by the calendar",
// "Default is month" => "Default is month",
// "Navigation Bar" => "Navigation Bar",
// "Decide or not to show the navigation bar (not shown by default)" => "Decide or not to show the navigation bar (not shown by default)",
// "Carousel" => "Carousel",
// "Display images in a self-advancing carousel" => "Display images in a self-advancing carousel",
// "File Gallery ID" => "File Gallery ID",
// "ID number of the file gallery that contains the images to be displayed" => "ID number of the file gallery that contains the images to be displayed",
"Sort Mode" => "Mode d'ordenació",
"Sort by database table field name, ascending or descending. Examples: fileId_asc or name_desc" => "Ordena pel nom del camp en anglès de la base de dades, ascendent o descendent. Exemples: fileId_asc o name_desc",
// "Transition time" => "Transition time",
// "The time (in milliseconds) it will take to transition between two images" => "The time (in milliseconds) it will take to transition between two images",
// "number" => "number",
// "Display time" => "Display time",
// "The time (in milliseconds) to display each image" => "The time (in milliseconds) to display each image",
// "Caption height" => "Caption height",
// "The height of the caption. This is a fraction of the height of the images" => "The height of the caption. This is a fraction of the height of the images",
// "real between 0 and 1" => "real between 0 and 1",
// "Display progress ring" => "Display progress ring",
// "Display thumbnails" => "Display thumbnails",
// "Display thumbnails, number, count etc" => "Display thumbnails, number, count etc",
// "Buttons" => "Buttons",
// "Numbers" => "Numbers",
// "Thumbnail box width" => "Thumbnail box width",
// "Width of thumbnail box in CSS units (default \"20px\")" => "Width of thumbnail box in CSS units (default \"20px\")",
// "Thumbnail box height" => "Thumbnail box height",
// "Height of thumbnail box in CSS units (default \"20px\")" => "Height of thumbnail box in CSS units (default \"20px\")",
// "Start automatically" => "Start automatically",
// "Move the carousel automatically when the page loads (default Yes)" => "Move the carousel automatically when the page loads (default Yes)",
// "Legacy v2 param" => "Legacy v2 param",
// "Display place numbers in the thumbnail boxes" => "Display place numbers in the thumbnail boxes",
// "Use corresponding image as background for a thumbnail box" => "Use corresponding image as background for a thumbnail box",
// "Thumbnail box font size" => "Thumbnail box font size",
// "Font size of thumbnail box in CSS units (default \".7em\")" => "Font size of thumbnail box in CSS units (default \".7em\")",
// "Size of picture" => "Size of picture",
// "In case your picture is too large, you can specify a scale between 0 and 1 to reduce it" => "In case your picture is too large, you can specify a scale between 0 and 1 to reduce it",
// "Cart Missing User Info" => "Cart Missing User Info",
// "PluginCartMissingUserInfo" => "PluginCartMissingUserInfo",
// "Check if user still has missing info to enter" => "Check if user still has missing info to enter",
// "Type of Information" => "Type of Information",
// "Post Purchase" => "Post Purchase",
// "Required before purchase" => "Required before purchase",
// "Product Class ID" => "Product Class ID",
// "Missing parameters" => "Missing parameters",
// "List categories and objects assigned to them" => "List categories and objects assigned to them",
"Category IDs" => "IDs de les Categories",
"List of category IDs separated by + signs. ex: 1+2+3. Default will use category of the current page" => "Llista d'IDs de categories separades per signes +. exemple: 1+2+3. Per omissió s'empra la categoria de la pàgina actual",
"Types" => "Tipus",
// "List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal<br />+forum+igal+newsletter<br />+event+poll+quiz+survey<br />+tracker+wiki+img" => "List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal<br />+forum+igal+newsletter<br />+event+poll+quiz+survey<br />+tracker+wiki+img",
// "Sort ascending or descending based on various attributes (sorted ascending by name by default)" => "Sort ascending or descending based on various attributes (sorted ascending by name by default)",
// "Created Ascending" => "Created Ascending",
// "Created Descending" => "Created Descending",
// "Hits Ascending" => "Hits Ascending",
// "Hits Descending" => "Hits Descending",
// "Item ID Ascending" => "Item ID Ascending",
// "Item ID Descending" => "Item ID Descending",
// "Name Ascending" => "Name Ascending",
// "Name Descending" => "Name Descending",
// "Type Ascending" => "Type Ascending",
// "Type Descending" => "Type Descending",
// "Random" => "Random",
"Split" => "Separa",
// "Whether multiple categories will be listed on different lines (default is to split them)" => "Whether multiple categories will be listed on different lines (default is to split them)",
"And" => "I",
// "If set to y (Yes), only objects in all of the categories will be shown (default is to show objects in any of the categories)" => "If set to y (Yes), only objects in all of the categories will be shown (default is to show objects in any of the categories)",
// "With Sub-categories" => "With Sub-categories",
// "Also list objects in sub-categories of the categories given (default is to list sub-category objects)" => "Also list objects in sub-categories of the categories given (default is to list sub-category objects)",
// "Show descriptions (not shown by default)" => "Show descriptions (not shown by default)",
// "Show Name" => "Show Name",
// "Show object names (shown by default)" => "Show object names (shown by default)",
// "Show type" => "Show type",
// "Show type (shown by default)" => "Show type (shown by default)",
// "One Per Line" => "One Per Line",
// "Show one object per line (multiple per line shown by default)" => "Show one object per line (multiple per line shown by default)",
// "Show Child Links" => "Show Child Links",
// "Show children category links (shown by default)" => "Show children category links (shown by default)",
// "Show Top Link" => "Show Top Link",
// "Show top category link (shown by default)" => "Show top category link (shown by default)",
// "Max Records" => "Max Records",
// "Maximum number of objects to list (default is 50)" => "Maximum number of objects to list (default is 50)",
// "Show Title" => "Show Title",
// "Show title text above category object lists (shown by default)" => "Show title text above category object lists (shown by default)",
// "List only objects in this language" => "List only objects in this language",
// "Only apply if type=wiki" => "Only apply if type=wiki",
"Categories are disabled" => "Les Categories han estat deshabilitades",
// "PluginCategoryTransition" => "PluginCategoryTransition",
// "Displays controls to trigger category transitions for any object" => "Displays controls to trigger category transitions for any object",
// "Object Type" => "Object Type",
// "Object ID" => "Object ID",
// "Redirect URL" => "Redirect URL",
// "URL the user is sent to after transition is done" => "URL the user is sent to after transition is done",
"Category Orphans" => "Orfans de categoria",
// "List objects that are not categorized" => "List objects that are not categorized",
// "Currently, only works with wiki pages (set to wiki (Wiki Pages) by default)" => "Currently, only works with wiki pages (set to wiki (Wiki Pages) by default)",
// "Max" => "Max",
// "Maximum number of items. Use -1 for unlimited. Default is the site admin setting for maximum records" => "Maximum number of items. Use -1 for unlimited. Default is the site admin setting for maximum records",
// "Result Offset" => "Result Offset",
// "Result number at which the listing should start (default is no offset)" => "Result number at which the listing should start (default is no offset)",
// "Show the full category path for a wiki page" => "Show the full category path for a wiki page",
"Separator" => "Separador",
"String used to separate the categories in the path. Default character is >" => "Cadena emprada per separar les categories en la ruta. El caràcter per omissió és >",
// "Display Top Category" => "Display Top Category",
// "Show the top category as part of the path name (not shown by default)" => "Show the top category as part of the path name (not shown by default)",
// "General purpose cclite utility plugin" => "General purpose cclite utility plugin",
// "Mode of operation - summary or recent. Default: summary" => "Mode of operation - summary or recent. Default: summary",
// "Account summary" => "Account summary",
// "Recent transactions" => "Recent transactions",
// "Registry" => "Registry",
// "Registry to query. Default: site preference (or first in list when more than one)" => "Registry to query. Default: site preference (or first in list when more than one)",
// "You need to be logged in to view this information" => "You need to be logged in to view this information",
// "Center text" => "Center text",
"Chart" => "Gràfic",
// "Display a chart from TikiSheet" => "Display a chart from TikiSheet",
"Chart caption" => "Títol del gràfic",
"Sheet ID" => "ID del Full",
"Data sheet ID" => "ID del Full de dades",
"Chart Type" => "Tipus de gràfic",
"Chart Width" => "Amplada de gràfic",
"Width in pixels" => "Amplada en pixels",
"Chart Height" => "Alçada del gràfic",
"Height in pixels" => "Alçada en pixels",
"Value series" => "Sèries de valors",
"Required for pie charts" => "Requerit per gràfics de formatgets",
"Independant series" => "Sèrie independent",
"Required for types other than pie chart" => "Requerit per a tipus diferents dels gràfics de formatgets",
"Dependant series" => "Sèrie dependent",
"List of colors to use" => "Llistat de colors a emprar",
"Styles" => "Estils",
"List of styles to use" => "Llista d'estils a emprar",
"Labels for the series or values in the legend" => "Etiquetes per les sèries o valors a la llegenda",
"Chart as PDF" => "Sondeig (chart) com a PDF",
"Chart as PostScript" => "Sondeig (chart) com a PostScript",
"Code" => "Codi",
// "Display code syntax with line numbers and color highlights" => "Display code syntax with line numbers and color highlights",
// "Code to be displayed" => "Code to be displayed",
"Caption" => "Capçalera",
"Code snippet label" => "Etiqueta del tros de codi",
"Word Wrap" => "Doblega línies llargues",
// "Enable word wrapping on the code to avoid breaking the layout" => "Enable word wrapping on the code to avoid breaking the layout",
// "Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus.." => "Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus..",
// "Line Numbers" => "Line Numbers",
// "Show line numbers for each line of code. May not be used with colors unless GeSHI is installed" => "Show line numbers for each line of code. May not be used with colors unless GeSHI is installed",
// "Right to Left" => "Right to Left",
// "Switch the text display from left to right to right to left  (left to right by default)" => "Switch the text display from left to right to right to left  (left to right by default)",
// "Code Tag" => "Code Tag",
// "Encloses the code in an HTML code tag, for example: &lt;code&gt;user input&lt;code&gt" => "Encloses the code in an HTML code tag, for example: &lt;code&gt;user input&lt;code&gt",
// "Colorbox" => "Colorbox",
// "Display a gallery of images in a popup slideshow" => "Display a gallery of images in a popup slideshow",
// "Image Gallery ID" => "Image Gallery ID",
// "ID number of the image gallery that contains the images to be displayed" => "ID number of the image gallery that contains the images to be displayed",
// "File ID Filter" => "File ID Filter",
// "Filter on fileIds in a file gallery to only show those images. Separate each fileId with ':'" => "Filter on fileIds in a file gallery to only show those images. Separate each fileId with ':'",
"Thumb" => "Contactes",
"Display as a thumbnail (y) or full size (n)" => "Mostra com a contacte/en petit (y) o a mida completa (n)",
// "Show File Title" => "Show File Title",
"Show file title" => "Mostra el títol de l'arxiu",
// "Show File Name" => "Show File Name",
"Show file name" => "Mostra el nom de l'arxiu",
// "Show All Thumbs" => "Show All Thumbs",
// "Show thumbnails of all the images in the gallery" => "Show thumbnails of all the images in the gallery",
// "Parse Descriptions" => "Parse Descriptions",
"Parse the file descriptions as wiki syntax" => "Interpreta la sintaxi wiki de les descripcions dels arxius",
// "Display a comment area for any specified object" => "Display a comment area for any specified object",
// "The current wiki page you have added the plugin to" => "The current wiki page you have added the plugin to",
"Dynamic Content" => "Contingut dinàmic",
// "Display content from dynamic content repository" => "Display content from dynamic content repository",
"Content ID" => "ID del contingut",
// "Dynamic content ID. The value can be obtained in the listing" => "Dynamic content ID. The value can be obtained in the listing",
// "Content Label" => "Content Label",
// "Label of the dynamic content to display" => "Label of the dynamic content to display",
// "Contributions Dashboard" => "Contributions Dashboard",
// "List users contributions to your work" => "List users contributions to your work",
// "Notice" => "Notice",
// "Default Beginning Date" => "Default Beginning Date",
// "Default Ending Date" => "Default Ending Date",
// "Dashboard Types" => "Dashboard Types",
// "The type of charts that will be rendered seperated by comma" => "The type of charts that will be rendered seperated by comma",
// "Date Range" => "Date Range",
"Update" => "Actualitza",
"Convene" => "Convocatòria",
"Convene an event with schedule and members" => "Convoca un event amb dates i membres",
"Convene data generated from user input" => "Dades de la convocatòria generades a partir de les eleccions dels usuaris",
"Title of Event" => "Títol de l'event",
// "Calendar ID" => "Calendar ID",
// "ID number for the site calendar where to store the date for the events with maximum votes" => "ID number for the site calendar where to store the date for the events with maximum votes",
// "Minimum Number of votes to show Add-to-Calendar icon" => "Minimum Number of votes to show Add-to-Calendar icon",
// "Minimum Number of votes needed to show Add-to-Calendar icon, so that new users do not see a potentially confusing icon before the convene has enough information on it" => "Minimum Number of votes needed to show Add-to-Calendar icon, so that new users do not see a potentially confusing icon before the convene has enough information on it",
"Date and time format" => "Format de data i hora",
"Display date and time in short or long format, according to the site wide setting" => "Mostra la data i l'hora en format curt o llarg, amb els detalls que hi hagi especificats per a aquest tipus de format a nivell de lloc web sencer",
"Short" => "Curt",
"Long" => "Llarg",
// "Not ok" => "Not ok",
// "Unconfirmed" => "Unconfirmed",
"Add User" => "Afegeix Usuari",
"Add Date" => "Afegeix data",
"Delete Date" => "Esborra data",
"Edit User/Save changes" => "Edita Usuari/Desa canvis",
"Delete User" => "Esborra Usuari",
"Selected Date" => "Data seleccionada",
"Add as Calendar Event" => "Afegeix com a entrada del Calendari",
"Add User & Date" => "Afegeix Ususari i Data",
"Login to edit Convene" => "Connectat per a editar la Convocatòria",
"Add" => "Afegeix",
"Cookie" => "Galeta",
// "Display a rotating set of taglines or quotes (also known as fortune cookies)" => "Display a rotating set of taglines or quotes (also known as fortune cookies)",
"Insert copyright notices" => "Insertar avisos de drets d'autor",
"Pattern to display the copyright in. May contain ~title~, ~year~ and ~authors~" => "Forma de mostrar el copyright a dins. Pot contenir ~title~ (títol), ~year~ (any) i ~authors~ (autors)",
"Countdown" => "Compte enrera",
// "Display a countdown to a specified date" => "Display a countdown to a specified date",
"Text to append to the countdown" => "Text a afegir al compte enrera",
// "Target date and time. Multiple formats accepted" => "Target date and time. Multiple formats accepted",
// "Items to Show" => "Items to Show",
// "Select: y=years, o=months, d=days, h=hours, m=minutes, s=seconds. \n\t\t\t\t\t\t\t\tEnter multiple values as: yodhms. Must be in the order of descending length, and a time unit should not be skipped. \n\t\t\t\t\t\t\t\tIf blank, the time is shown down to the hour if not zero" => "Select: y=years, o=months, d=days, h=hours, m=minutes, s=seconds. \n\t\t\t\t\t\t\t\tEnter multiple values as: yodhms. Must be in the order of descending length, and a time unit should not be skipped. \n\t\t\t\t\t\t\t\tIf blank, the time is shown down to the hour if not zero",
// "Years" => "Years",
// "Years, Months" => "Years, Months",
// "Years, Months, Days" => "Years, Months, Days",
// "Years, Months, Days, Hours" => "Years, Months, Days, Hours",
// "Years, Months, Days, Hours, Minutes" => "Years, Months, Days, Hours, Minutes",
// "Years, Months, Days, Hours, Minutes & Seconds" => "Years, Months, Days, Hours, Minutes & Seconds",
// "Months" => "Months",
// "Months, Days" => "Months, Days",
// "Months, Days, Hours" => "Months, Days, Hours",
// "Months, Days, Hours, Minutes" => "Months, Days, Hours, Minutes",
// "Months, Days, Hours, Minutes & Seconds" => "Months, Days, Hours, Minutes & Seconds",
"Days" => "Dies",
// "Days & Hours" => "Days & Hours",
// "Days, Hours & Minutes" => "Days, Hours & Minutes",
// "Days, Hours, Minutes & Seconds" => "Days, Hours, Minutes & Seconds",
"Hours" => "Hores",
// "Hours & Minutes" => "Hours & Minutes",
// "Hours, Minutes & Seconds" => "Hours, Minutes & Seconds",
"Minutes" => "Minuts",
// "Minutes & Seconds" => "Minutes & Seconds",
// "Seconds" => "Seconds",
// "Calendar Days" => "Calendar Days",
// "Will use calendar day difference when set to Yes (y) and time units are not shown. \n\t\t\t\t\t\t\t\tResult is that tomorrow, for example, is always shown as a one day away even if less than 24 hours from now. No (n) is the default" => "Will use calendar day difference when set to Yes (y) and time units are not shown. \n\t\t\t\t\t\t\t\tResult is that tomorrow, for example, is always shown as a one day away even if less than 24 hours from now. No (n) is the default",
// "Handle Past Events" => "Handle Past Events",
// "If Yes (y), will display amount of time since the event (default). \n\t\t\t\t\t\t\t\tIf No (n) and if there is body text, will display \"is over\" or custom text set in text parameter after body text" => "If Yes (y), will display amount of time since the event (default). \n\t\t\t\t\t\t\t\tIf No (n) and if there is body text, will display \"is over\" or custom text set in text parameter after body text",
"Text" => "Texte",
// "Text that will show with the countdown and body text. \n\t\t\t\t\t\t\t\tSet to \"default\" or leave empty to show \"xxx days until/since [body text]\", except that if\n\t\t\t\t\t\t\t\t the since parameter is set to No (n), \"[body text] is over\" will show after the end date has passed.\n\t\t\t\t\t\t\t\tAlso, if no time is shown because of the time units being displayed (for example, only years are shown and it's\n\t\t\t\t\t\t\t\tless than a year before/after the end date) then \"[body text] will happen in less than a year/happened in the last year\" will show.\n\t\t\t\t\t\t\t\tOr set pipe-separated custom text as follows: before date|before date by less than shortest time unit shown|after date\n\t\t\t\t\t\t\t\t|after date by less than shortest time unit shown|after date and since set to No (n).\n\t\t\t\t\t\t\t\tSet to silent for no text" => "Text that will show with the countdown and body text. \n\t\t\t\t\t\t\t\tSet to \"default\" or leave empty to show \"xxx days until/since [body text]\", except that if\n\t\t\t\t\t\t\t\t the since parameter is set to No (n), \"[body text] is over\" will show after the end date has passed.\n\t\t\t\t\t\t\t\tAlso, if no time is shown because of the time units being displayed (for example, only years are shown and it's\n\t\t\t\t\t\t\t\tless than a year before/after the end date) then \"[body text] will happen in less than a year/happened in the last year\" will show.\n\t\t\t\t\t\t\t\tOr set pipe-separated custom text as follows: before date|before date by less than shortest time unit shown|after date\n\t\t\t\t\t\t\t\t|after date by less than shortest time unit shown|after date and since set to No (n).\n\t\t\t\t\t\t\t\tSet to silent for no text",
// "default, silent, custom: before event|after event|after event when time not shown" => "default, silent, custom: before event|after event|after event when time not shown",
// "Thousands Separator" => "Thousands Separator",
// "Set the thousands separator for results of 1,000 or more. \n\t\t\t\t\t\t\t\tChoices are comma (c), decimal (d), space (s), or leave blank for no separator" => "Set the thousands separator for results of 1,000 or more. \n\t\t\t\t\t\t\t\tChoices are comma (c), decimal (d), space (s), or leave blank for no separator",
// "Comma" => "Comma",
"Period" => "Període",
// "Space" => "Space",
// "COUNTDOWN: Missing \"enddate\" parameter for plugin" => "COUNTDOWN: Missing \"enddate\" parameter for plugin",
"and" => "i",
// "will happen in less than a year" => "will happen in less than a year",
// "will happen in less than a month" => "will happen in less than a month",
// "will happen in less than a day" => "will happen in less than a day",
// "will happen in less than an hour" => "will happen in less than an hour",
// "will happen in less than a minute" => "will happen in less than a minute",
// "is happening this second" => "is happening this second",
// "happened in the last year" => "happened in the last year",
// "happened in the last month" => "happened in the last month",
// "happened in the last day" => "happened in the last day",
// "happened in the last hour" => "happened in the last hour",
// "happened in the last minute" => "happened in the last minute",
// "until" => "until",
"since" => "des de",
// "is over" => "is over",
// "Custom Search" => "Custom Search",
// "Custom Search Interface that displays results using the LIST plugin" => "Custom Search Interface that displays results using the LIST plugin",
// "LIST plugin configuration information" => "LIST plugin configuration information",
// "Template wiki page" => "Template wiki page",
// "Wiki page where search user interface template is found" => "Wiki page where search user interface template is found",
// "Alphanumeric Unique Identifier for search" => "Alphanumeric Unique Identifier for search",
// "A unique identifier to distinguish custom searches for storing of previous search criteria entered by users" => "A unique identifier to distinguish custom searches for storing of previous search criteria entered by users",
// "Autotrigger AJAX search on criteria change" => "Autotrigger AJAX search on criteria change",
// "Delay in milliseconds before automatically triggering search after change (0 disables)" => "Delay in milliseconds before automatically triggering search after change (0 disables)",
// "Div to fade when AJAX search in progress" => "Div to fade when AJAX search in progress",
// "The specific ID of the specific div to fade out when AJAX search is in progress, if not set will attempt to fade the whole area or if failing simply show the spinner" => "The specific ID of the specific div to fade out when AJAX search is in progress, if not set will attempt to fade the whole area or if failing simply show the spinner",
// "Return users to same search parameters on coming back to the search page after leaving" => "Return users to same search parameters on coming back to the search page after leaving",
// "In the same session, return users to same search parameters on coming back to the search page after leaving" => "In the same session, return users to same search parameters on coming back to the search page after leaving",
// "Custom JavaScript wiki page" => "Custom JavaScript wiki page",
// "The wiki page on which custom JavaScript that is to be executed on return of AJAX results" => "The wiki page on which custom JavaScript that is to be executed on return of AJAX results",
// "Destination Div" => "Destination Div",
// "Id of a pre-existing div to contain the search results" => "Id of a pre-existing div to contain the search results",
// "Search On Load" => "Search On Load",
// "Execute the search when the page loads (default: Yes)" => "Execute the search when the page loads (default: Yes)",
// "Template is not specified" => "Template is not specified",
// "Template page not found" => "Template page not found",
// "Searching.." => "Searching..",
// "_group is needed to be set if _style is checkbox or radio" => "_group is needed to be set if _style is checkbox or radio",
// "Data Channel" => "Data Channel",
// "Display a form to access data channels" => "Display a form to access data channels",
// "List of fields to display. One field per line. Comma delimited: fieldname,label" => "List of fields to display. One field per line. Comma delimited: fieldname,label",
// "To use values from other forms on the same page as parameters for the data-channel use \"fieldname, external=fieldid\"" => "To use values from other forms on the same page as parameters for the data-channel use \"fieldname, external=fieldid\"",
// "Where \"fieldid\" is the id (important) of the external input to use, and \"fieldname\" is the name of the parameter in the data-channel" => "Where \"fieldid\" is the id (important) of the external input to use, and \"fieldname\" is the name of the parameter in the data-channel",
// "To use fixed hidden preset values use \"fieldname, hidden=value.\"" => "To use fixed hidden preset values use \"fieldname, hidden=value.\"",
// "Channel Name" => "Channel Name",
// "Name of the channel as registered by the administrator" => "Name of the channel as registered by the administrator",
// "Return URL" => "Return URL",
// "URL to go to after data channel has run. Defaults to current page" => "URL to go to after data channel has run. Defaults to current page",
// "Do not use returnURI but instead return true quietly" => "Do not use returnURI but instead return true quietly",
// "If set to y, will return quietly after data channel has run which would be needed if plugin is used in non-wiki page context" => "If set to y, will return quietly after data channel has run which would be needed if plugin is used in non-wiki page context",
// "Button Label" => "Button Label",
// "Label for the submit button. Default: \"Go\"" => "Label for the submit button. Default: \"Go\"",
// "CSS class for this form" => "CSS class for this form",
// "Empty Caches" => "Empty Caches",
// "Which caches to empty. Default \"Clear all Tiki caches\"" => "Which caches to empty. Default \"Clear all Tiki caches\"",
// "Clear all Tiki caches" => "Clear all Tiki caches",
"All user prefs sessions" => "Totes les sessions de preferències d'usuaris",
// "Price to execute the datachannel (%0)" => "Price to execute the datachannel (%0)",
// "Payment Label" => "Payment Label",
"Debug" => "Debug (Neteja d'errors)",
// "Be careful, if debug is on, the page will not be refreshed and previous modules can be obsolete (not on by default)" => "Be careful, if debug is on, the page will not be refreshed and previous modules can be obsolete (not on by default)",
// "Multiple Values" => "Multiple Values",
// "Accept arrays of multiple values in the POST. e.g. itemId[]=42&itemId=43 etc. (multiple values not accepted by default)" => "Accept arrays of multiple values in the POST. e.g. itemId[]=42&itemId=43 etc. (multiple values not accepted by default)",
// "Datachannel" => "Datachannel",
"DB Report" => "Informes de BD",
// "Query a database and display results (only works with ADOdb, does not work with PDO)" => "Query a database and display results (only works with ADOdb, does not work with PDO)",
"report definition" => "definició d'informe",
"Full DSN" => "DSN sencer",
"A full DSN (Data Source Name) connection string. eg: mysql://user:pass@server/database" => "Una text sencer de connexió a DSN (Data Source Name). exemple: mysql://usuari:contrasenya@servidor/basededades",
// "Wiki DSN Name" => "Wiki DSN Name",
"The name of a DSN connection defined by the Wiki administrator" => "El nom d'una connexió a DSN definida per l'administrador del Wiki",
"Wiki Syntax" => "Sintaxi Wiki",
// "Parse wiki syntax within the report (not parsed by default)" => "Parse wiki syntax within the report (not parsed by default)",
// "Display the parsed report definition (not displayed by default)" => "Display the parsed report definition (not displayed by default)",
"Missing db or dsn parameter" => "Manca base de dades o paràmetre dsn",
"No DSN connection string found" => "No s'ha trobat text de connexió al DSN",
"Run a database report" => "Executa un informe sobre una base de dades",
// "Dialog" => "Dialog",
// "Create a jQuery-UI dialog" => "Create a jQuery-UI dialog",
// "Button labels separated by commas" => "Button labels separated by commas",
// "Button actions" => "Button actions",
// "JS to perform on 1st button click" => "JS to perform on 1st button click",
// "Dialog width" => "Dialog width",
// "HTML ID" => "HTML ID",
// "Automatically generated if left empty in the form \"wpdialog_XX\" (must be unique per page)" => "Automatically generated if left empty in the form \"wpdialog_XX\" (must be unique per page)",
// "Show animation" => "Show animation",
// "Hide animation" => "Hide animation",
// "Auto open" => "Auto open",
// "y/n" => "y/n",
// "Modal" => "Modal",
// "Wiki page to use as dialog body" => "Wiki page to use as dialog body",
// "Open Action" => "Open Action",
// "JS to execute when dialog opens" => "JS to execute when dialog opens",
"Div" => "Div",
// "Define and format sections of a page or text" => "Define and format sections of a page or text",
// "Indicate the type of HTML tag to use (default is div)" => "Indicate the type of HTML tag to use (default is div)",
// "Span" => "Span",
"Pre" => "Pre",
// "Teletype" => "Teletype",
// "Paragraph" => "Paragraph",
// "Block quote" => "Block quote",
// "In pixels or percentage. Default is original size" => "In pixels or percentage. Default is original size",
// "Aligns the text within the element" => "Aligns the text within the element",
// "Justify" => "Justify",
// "Set the alignment for the entire element. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)" => "Set the alignment for the entire element. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)",
// "Items are not allowed to wrap around the side(s) this parameter is set to" => "Items are not allowed to wrap around the side(s) this parameter is set to",
// "Apply custom CSS class to the div" => "Apply custom CSS class to the div",
// "Sets the div's id attribute, as defined by HTML" => "Sets the div's id attribute, as defined by HTML",
// "Title attribute" => "Title attribute",
// "Title for the div, usually displayed as a tooltip" => "Title for the div, usually displayed as a tooltip",
"Definition List" => "Llista de definició",
// "Create a definition list" => "Create a definition list",
"One entry per line. Each line is in \"Term: Definition\" format" => "Una entrada per línia. Cada línia és en el format \"Terme: Definició\"",
"Draw" => "Dibuixa",
// "Display or create an image from TikiDraw that is stored into the File Gallery" => "Display or create an image from TikiDraw that is stored into the File Gallery",
// "Drawing ID" => "Drawing ID",
// "Internal ID of the file id" => "Internal ID of the file id",
// "Width in pixels or percentage. Default value is page width. e.g. \"200px\" or \"100%\"" => "Width in pixels or percentage. Default value is page width. e.g. \"200px\" or \"100%\"",
// "Height in pixels or percentage. Default value is complete drawing height" => "Height in pixels or percentage. Default value is complete drawing height",
// "Force Display Archive" => "Force Display Archive",
// "The latest revision of file is automatically shown, by setting archive to y, it bypasses this check and shows the archive rather than the latest revision" => "The latest revision of file is automatically shown, by setting archive to y, it bypasses this check and shows the archive rather than the latest revision",
// "Draw New SVG Image" => "Draw New SVG Image",
// "Edit SVG Image" => "Edit SVG Image",
// " in " => " in ",
"File not found" => "No s'ha trobat el fitxer",
"Equation" => "Equació",
// "Render an equation written in LaTeX syntax as an image" => "Render an equation written in LaTeX syntax as an image",
"equation" => "equació",
// "Size expressed as a percentage of the normal size. 100 produces the default size. 200 produces an image twice as large" => "Size expressed as a percentage of the normal size. 100 produces the default size. 200 produces an image twice as large",
"Events" => "Events",
// "Display upcoming events from calendars" => "Display upcoming events from calendars",
// "ID numbers for the site calendars whose events are to be displayed, separated by vertical bars (|)" => "ID numbers for the site calendars whose events are to be displayed, separated by vertical bars (|)",
// "Maximum Days" => "Maximum Days",
// "Events occurring within this number of days in the future from today will be included in the list (unless limited by other parameter settings). Default is 365 days" => "Events occurring within this number of days in the future from today will be included in the list (unless limited by other parameter settings). Default is 365 days",
// "Maximum Events" => "Maximum Events",
// "Maximum number of events to display. Default is 10. Set to 0 to display all (unless limited by other parameter settings)" => "Maximum number of events to display. Default is 10. Set to 0 to display all (unless limited by other parameter settings)",
// "Show Time" => "Show Time",
// "Show the time along with the date (shown by default)" => "Show the time along with the date (shown by default)",
// "Show the description of the event (shown by default)" => "Show the description of the event (shown by default)",
// "Exercise" => "Exercise",
// "PluginExercise" => "PluginExercise",
// "Creates exercises within a wiki page for students to test their new skills. The plugin allows to define inline questions and optional answers to be selected from. A score is given for multiple exercises within a page" => "Creates exercises within a wiki page for students to test their new skills. The plugin allows to define inline questions and optional answers to be selected from. A score is given for multiple exercises within a page",
"Answer" => "Resposta",
// "Used inline to specify the right answer to the question and propose an input field" => "Used inline to specify the right answer to the question and propose an input field",
// "Incorrect" => "Incorrect",
// "Alternative answers to provide" => "Alternative answers to provide",
// "Check your score" => "Check your score",
// "You scored %0 out of %1" => "You scored %0 out of %1",
// "Good" => "Good",
// "Oops" => "Oops",
// "Extend Cart Inventory Hold" => "Extend Cart Inventory Hold",
// "PluginExtendCartHold" => "PluginExtendCartHold",
// "Extends the time that items are held in the shop before timing out" => "Extends the time that items are held in the shop before timing out",
// "Create a link that shows/hides initially hidden content" => "Create a link that shows/hides initially hidden content",
// "Wiki syntax containing the content that can be hidden or shown" => "Wiki syntax containing the content that can be hidden or shown",
// "Label for link that shows and hides the content when clicked" => "Label for link that shows and hides the content when clicked",
"Unspecified label" => "Etiqueta no especificada",
// "Arrow icon showing that content can be hidden or shown" => "Arrow icon showing that content can be hidden or shown",
// "Show Speed" => "Show Speed",
// "Speed of animation in milliseconds when showing content (200 is fast and 600 is slow. 1000 equals 1 second)" => "Speed of animation in milliseconds when showing content (200 is fast and 600 is slow. 1000 equals 1 second)",
// "Integer greater than 0 and less than or equal to 1000, or 'fast' or 'slow'" => "Integer greater than 0 and less than or equal to 1000, or 'fast' or 'slow'",
// "Hide Speed" => "Hide Speed",
// "Speed of animation in milliseconds when hiding content (200 is fast and 600 is slow. 1000 equals 1 second)" => "Speed of animation in milliseconds when hiding content (200 is fast and 600 is slow. 1000 equals 1 second)",
"Fancy List" => "Llista maca",
// "Create a fancy-looking list" => "Create a fancy-looking list",
"One item per line starting with anything followed by \")\"" => "Un ítem per línia començant per quelcom seguit de  \")\"",
// "Use Div" => "Use Div",
// "Use the HTML tag div instead of the HTML tag for lists (ol)" => "Use the HTML tag div instead of the HTML tag for lists (ol)",
"CSS class for the fancylist" => "Classe CSS de la llista maca",
"Fancy Table" => "Taula maca",
// "Create a formatted table" => "Create a formatted table",
// "Rows separated by >> in the header; for the table body, one row per line. Cells separated by | in both cases" => "Rows separated by >> in the header; for the table body, one row per line. Cells separated by | in both cases",
// "Heading Row" => "Heading Row",
// "Header rows of the table. Use >> to separate multiple rows" => "Header rows of the table. Use >> to separate multiple rows",
"Heading CSS Class" => "Classe CSS Capçalera",
"CSS class to apply to the heading row" => "Classe CSS a aplicar a la fila de la capçalera",
// "Header Horizontal Align" => "Header Horizontal Align",
// "Horizontal alignments for header cells separated by |. Choices: left, right, center, justify" => "Horizontal alignments for header cells separated by |. Choices: left, right, center, justify",
// "Header Vertical Align" => "Header Vertical Align",
// "Vertical alignments for header cells separated by |. Choices: top, middle, bottom, baseline" => "Vertical alignments for header cells separated by |. Choices: top, middle, bottom, baseline",
// "Column Sort" => "Column Sort",
// "Indicate whether columns are sortable or not (not sortable by default)" => "Indicate whether columns are sortable or not (not sortable by default)",
// "Pre-sorted Columns" => "Pre-sorted Columns",
// "Bracketed numbers for column number and sort direction (0 = ascending, 1 = descending), for example: [0,0],[1,0]" => "Bracketed numbers for column number and sort direction (0 = ascending, 1 = descending), for example: [0,0],[1,0]",
// "Column Widths" => "Column Widths",
// "Column widths followed by px for pixels or % for percentages. Each column separated by |" => "Column widths followed by px for pixels or % for percentages. Each column separated by |",
// "Cell Horizontal Align" => "Cell Horizontal Align",
// "Table body column horizontal alignments separated by |. Choices: left, right, center, justify" => "Table body column horizontal alignments separated by |. Choices: left, right, center, justify",
// "Cell Vertical Align" => "Cell Vertical Align",
// "Table body column vertical alignments separated by |. Choices: top, middle, bottom, baseline" => "Table body column vertical alignments separated by |. Choices: top, middle, bottom, baseline",
"The feature must be activated" => "La funcionalitat ha de ser activada",
// "Shows if item is user favorite or not and provide the way to set it" => "Shows if item is user favorite or not and provide the way to set it",
// "Link to a file that's attached or in a file gallery or archive. See PluginFiles for more functionality" => "Link to a file that's attached or in a file gallery or archive. See PluginFiles for more functionality",
// "Label for the link to the file (ignored if the file is a wiki attachment)" => "Label for the link to the file (ignored if the file is a wiki attachment)",
// "Indicate whether the file is in a file gallery or is a wiki page attachment" => "Indicate whether the file is in a file gallery or is a wiki page attachment",
// "Identify an attachment by entering its file name, which will show as a link to the file.\n\t\t\t\t\t\t\t\t If the page parameter is empty, it must be a file name of an attachment to the page where the plugin is used" => "Identify an attachment by entering its file name, which will show as a link to the file.\n\t\t\t\t\t\t\t\t If the page parameter is empty, it must be a file name of an attachment to the page where the plugin is used",
// "Custom Description" => "Custom Description",
// "Custom text that will be used for the link instead of the file name or file description" => "Custom text that will be used for the link instead of the file name or file description",
// "Name of the wiki page the file is attached to. Defaults to the wiki page where the plugin is used if empty" => "Name of the wiki page the file is attached to. Defaults to the wiki page where the plugin is used if empty",
// "Attachment Description" => "Attachment Description",
// "Show the attachment description as the link label instead of the attachment file name" => "Show the attachment description as the link label instead of the attachment file name",
// "Indicates that this attachment is an image, and should be displayed inline using the img tag" => "Indicates that this attachment is an image, and should be displayed inline using the img tag",
"File ID" => "ID de l'arxiu",
// "File ID of a file in a file gallery or an archive" => "File ID of a file in a file gallery or an archive",
// "Example value" => "Example value",
// "For an archive file, the archive created just before this date will be linked to. Special values : PAGE_LAST_MOD and PAGE_VIEW_DATE" => "For an archive file, the archive created just before this date will be linked to. Special values : PAGE_LAST_MOD and PAGE_VIEW_DATE",
// "Show Icon" => "Show Icon",
// "Show an icon version of the file or file type with the link to the file" => "Show an icon version of the file or file type with the link to the file",
// "File Gallery File/Archive" => "File Gallery File/Archive",
// "Wiki Page Attachment" => "Wiki Page Attachment",
// "The date has not been set" => "The date has not been set",
// "Incorrect date format" => "Incorrect date format",
// "No such file" => "No such file",
// "Wiki attachments are disabled" => "Wiki attachments are disabled",
// "List files by ID, gallery or category, or show a slideshow of image files" => "List files by ID, gallery or category, or show a slideshow of image files",
// "Title for the file listing, or the link text when slideshow = y" => "Title for the file listing, or the link text when slideshow = y",
// "File Galleries ID" => "File Galleries ID",
// "To list only files contained in these file galleries (multiple IDs separated by colon)" => "To list only files contained in these file galleries (multiple IDs separated by colon)",
// "Or enter a username for user files (hint: enter {{user}} for current logged in user)" => "Or enter a username for user files (hint: enter {{user}} for current logged in user)",
// "To restrict files listed to those belonging to one or more categories. Enter a single category or ID or list of them separated by colon" => "To restrict files listed to those belonging to one or more categories. Enter a single category or ID or list of them separated by colon",
// "To list only specified files, enter their file IDs separated by colon" => "To list only specified files, enter their file IDs separated by colon",
// "Order ascending or descending based on any field in the file gallery table. Default is name_asc" => "Order ascending or descending based on any field in the file gallery table. Default is name_asc",
// "Show Action" => "Show Action",
// "Show a column with icons for the various actions the user can take with each file (not shown by default)" => "Show a column with icons for the various actions the user can take with each file (not shown by default)",
// "Show Find" => "Show Find",
// "Show a search box above the list (not shown by default)" => "Show a search box above the list (not shown by default)",
// "Show the title of the file gallery (shown by default). Also shown on slide show pop up window if a single galleryId is used" => "Show the title of the file gallery (shown by default). Also shown on slide show pop up window if a single galleryId is used",
// "Show ID" => "Show ID",
// "Show the ID number of each file (shown by default)" => "Show the ID number of each file (shown by default)",
// "Show an icon for each file depicting the file type" => "Show an icon for each file depicting the file type",
// "Show the name given to the file upon upload into the file gallery (shown by default). Set to Yes (y) to show as a caption in a slide show" => "Show the name given to the file upon upload into the file gallery (shown by default). Set to Yes (y) to show as a caption in a slide show",
// "Show Filename" => "Show Filename",
// "Show each file's filename (shown by default except in slide show). Set to Yes (y) to show as a caption in a slide show" => "Show each file's filename (shown by default except in slide show). Set to Yes (y) to show as a caption in a slide show",
// "Show Size" => "Show Size",
// "Show the size of each file in kilobytes (shown by default except in slide show)" => "Show the size of each file in kilobytes (shown by default except in slide show)",
// "Show the description of the file given upon upload into the file gallery (shown by default except in slide show). Set to Yes (y) to show as a caption in a slide show" => "Show the description of the file given upon upload into the file gallery (shown by default except in slide show). Set to Yes (y) to show as a caption in a slide show",
// "Show Creation Date" => "Show Creation Date",
// "Show the date each file was created (not shown by default)" => "Show the date each file was created (not shown by default)",
// "Show Last Modification Date" => "Show Last Modification Date",
// "Show the date each file was last modified (shown by default)" => "Show the date each file was last modified (shown by default)",
// "Show Hits" => "Show Hits",
// "Show the number of hits each file has received (not shown by default)" => "Show the number of hits each file has received (not shown by default)",
// "Show Locked By" => "Show Locked By",
// "For locked files, show the user name of the user who locked it (not shown by default)" => "For locked files, show the user name of the user who locked it (not shown by default)",
// "Show the user name of the user who is the author of the file (not shown by default)" => "Show the user name of the user who is the author of the file (not shown by default)",
// "Show Creator" => "Show Creator",
// "Show the user name of the user who is the creator of the file (not shown by default)" => "Show the user name of the user who is the creator of the file (not shown by default)",
// "Show Parent Gallery Name" => "Show Parent Gallery Name",
// "Show the name of the parent gallery" => "Show the name of the parent gallery",
// "Show File Count" => "Show File Count",
// "For galleries included in the list (where the file gallery includes other galleries), show the number of files in each of those galleries (not shown by default)" => "For galleries included in the list (where the file gallery includes other galleries), show the number of files in each of those galleries (not shown by default)",
// "Show Slideshow" => "Show Slideshow",
// "Show a link that produces a pop-up slide show when clicked (not set by default)" => "Show a link that produces a pop-up slide show when clicked (not set by default)",
// "Slideshow Width" => "Slideshow Width",
// "Set width of slideshow popup" => "Set width of slideshow popup",
// "Slideshow Height" => "Slideshow Height",
// "Set height of slideshow popup" => "Set height of slideshow popup",
// "Show Comment" => "Show Comment",
// "Show comments for each file (not shown by default)" => "Show comments for each file (not shown by default)",
// "Show Last Editor" => "Show Last Editor",
// "Show the user name of the user who last modified the file (shown by default)" => "Show the user name of the user who last modified the file (shown by default)",
// "Show Image Thumb" => "Show Image Thumb",
// "Show Image thumb" => "Show Image thumb",
// "Show only files created by this user" => "Show only files created by this user",
// "Show Upload" => "Show Upload",
// "Show a simple upload form to the gallery (not shown by default)" => "Show a simple upload form to the gallery (not shown by default)",
// "Number of rows (default: -1 = all)" => "Number of rows (default: -1 = all)",
// "Recursive" => "Recursive",
// "With sub-galleries" => "With sub-galleries",
// "Flash Video" => "Flash Video",
// "Embed a video or audio file" => "Embed a video or audio file",
// "Flash Type" => "Flash Type",
// "Whether you want to insert a Flash from a URL, a fileId from a podcast file gallery or a link to a specific service like Youtube or Vimeo" => "Whether you want to insert a Flash from a URL, a fileId from a podcast file gallery or a link to a specific service like Youtube or Vimeo",
// "Select an option" => "Select an option",
// "Blip.tv" => "Blip.tv",
// "File Gallery Podcast" => "File Gallery Podcast",
"Movie URL" => "URL del vídeo",
// "Vimeo" => "Vimeo",
// "Youtube" => "Youtube",
// "Complete URL to the movie to include. e.g. files/test.swf" => "Complete URL to the movie to include. e.g. files/test.swf",
// "File Gallery Podcast ID" => "File Gallery Podcast ID",
// "Id of a file from a podcast gallery - will work only with podcast gallery" => "Id of a file from a podcast gallery - will work only with podcast gallery",
// "YouTube URL" => "YouTube URL",
// "Entire URL to the YouTube video" => "Entire URL to the YouTube video",
// "Vimeo URL" => "Vimeo URL",
// "Entire URL to the Vimeo video" => "Entire URL to the Vimeo video",
// "Blip.tv URL" => "Blip.tv URL",
// "Blip.tv embed URL" => "Blip.tv embed URL",
// "Width of movie in pixels (default is 425)" => "Width of movie in pixels (default is 425)",
// "Height of movie in pixels (default is 350)" => "Height of movie in pixels (default is 350)",
"Quality" => "Qualitat",
"Flash video quality. Default value: high" => "Qualitat del vídeo Flash. Valor per defecte: high",
"High" => "Alt",
// "Medium" => "Medium",
"Low" => "Baix",
// "Alternative image URL" => "Alternative image URL",
// "Image to display if Flash is not available" => "Image to display if Flash is not available",
// "Invalid URL" => "Invalid URL",
"Missing parameter movie to the plugin flash" => "Manca el paràmetre movie per al plugin flash",
// "FONT" => "FONT",
// "Experimental: Font family and font size" => "Experimental: Font family and font size",
"Content" => "Contingut",
// "Font Family" => "Font Family",
// "Select the font family to display the content" => "Select the font family to display the content",
// "Font Size" => "Font Size",
// "Define the size of the font in pixels (enter '12' to get a font of 12px)" => "Define the size of the font in pixels (enter '12' to get a font of 12px)",
"Footnote" => "Nota al peu",
// "Create automatically numbered footnotes (together with PluginFootnoteArea)" => "Create automatically numbered footnotes (together with PluginFootnoteArea)",
"The footnote" => "La nota al peu",
// "Sameas" => "Sameas",
// "Tag to existing footnote" => "Tag to existing footnote",
// "Footnote Area" => "Footnote Area",
// "Create automatically numbered footnotes (together with PluginFootnote)" => "Create automatically numbered footnotes (together with PluginFootnote)",
// "Freetagged" => "Freetagged",
// "List similarly tagged objects" => "List similarly tagged objects",
// "Tags to find similar to" => "Tags to find similar to",
// "Leave blank to use the object's own tags" => "Leave blank to use the object's own tags",
// "Type of objects to extract. Set to All to find all types" => "Type of objects to extract. Set to All to find all types",
// "Same" => "Same",
"Faqs" => "Pufs (faqs)",
// "Offset" => "Offset",
// "Start record" => "Start record",
// "Default -1 (all)" => "Default -1 (all)",
// "Choose from:  objectId, type, itemId, description, created, name, href, hits, comments_locked (Default: created_desc)" => "Choose from:  objectId, type, itemId, description, created, name, href, hits, comments_locked (Default: created_desc)",
// "Comments Locked Ascending" => "Comments Locked Ascending",
// "Comments Locked Descending" => "Comments Locked Descending",
// "Description Ascending" => "Description Ascending",
// "Description Descending" => "Description Descending",
// "Href Ascending" => "Href Ascending",
// "Href Descending" => "Href Descending",
// "Object ID Ascending" => "Object ID Ascending",
// "Object ID Descending" => "Object ID Descending",
// "Show objects with names or descriptions similar to the text entered here" => "Show objects with names or descriptions similar to the text entered here",
// "Broaden" => "Broaden",
// "n|y" => "n|y",
// "Choose the header level for formatting. Default is 3 (for header level h3). Set to -1 for no header tags" => "Choose the header level for formatting. Default is 3 (for header level h3). Set to -1 for no header tags",
// "Show Titles Only" => "Show Titles Only",
// "Choose whether to show titles only (not shown by default)" => "Choose whether to show titles only (not shown by default)",
// "Maximum Image Size" => "Maximum Image Size",
// "Height or width in pixels. Default = 0 (no maximum)" => "Height or width in pixels. Default = 0 (no maximum)",
// "FTP" => "FTP",
// "Create a button for downloading a file from an FTP server" => "Create a button for downloading a file from an FTP server",
"file name" => "nom de l'arxiu",
// "Server Name" => "Server Name",
// "Name of the server where the FTP account is housed. Example: " => "Name of the server where the FTP account is housed. Example: ",
// "User name needed to access the FTP account" => "User name needed to access the FTP account",
// "Password needed to access the FTP account" => "Password needed to access the FTP account",
// "Download Button Label" => "Download Button Label",
// "Label for the FTP download button" => "Label for the FTP download button",
"missing parameters" => "paràmetres que manquen",
"Connection failed" => "La connexió ha fallat",
// "Galleriffic" => "Galleriffic",
// "Displays images in galleriffic" => "Displays images in galleriffic",
// "Thumbs div width" => "Thumbs div width",
// "Width in pixels or percentage. (e.g. \"200px\" or \"100%\")" => "Width in pixels or percentage. (e.g. \"200px\" or \"100%\")",
// "Image slideshow width" => "Image slideshow width",
// "Width in pixels or percentage of the largest image. (e.g. \"200px\" or \"100%\")" => "Width in pixels or percentage of the largest image. (e.g. \"200px\" or \"100%\")",
// "Image slideshow height" => "Image slideshow height",
// "Height in pixels or percentage of the largest images. (e.g. \"200px\" or \"100%\")" => "Height in pixels or percentage of the largest images. (e.g. \"200px\" or \"100%\")",
// "Start Slideshow" => "Start Slideshow",
// "Automatically start the slideshow" => "Automatically start the slideshow",
"Delay" => "Decalatge",
// "Delay in milliseconds between each transition" => "Delay in milliseconds between each transition",
// "Number of Thumbnails" => "Number of Thumbnails",
// "The number of thumbnails to show per page" => "The number of thumbnails to show per page",
// "Show top pager" => "Show top pager",
// "Display thumbnail pager at top" => "Display thumbnail pager at top",
// "Show bottom pager" => "Show bottom pager",
// "Display thumbnail pager at bottom" => "Display thumbnail pager at bottom",
// "Play Slideshow" => "Play Slideshow",
// "Pause SlideShow" => "Pause SlideShow",
// "Previous Photo" => "Previous Photo",
// "Next Photo" => "Next Photo",
"Gauge" => "Barra de nivell",
// "Display a horizontal bar gauge" => "Display a horizontal bar gauge",
"description" => "descripció",
// "Current value to be represented by the gauge" => "Current value to be represented by the gauge",
"Maximum Value" => "Valor Màxim",
"Maximum possible value. Default: 100" => "Valor màxim possible. Per omissió: 100",
"Label displayed on the left side of the gauge" => "l'Etiqueta mostrada a l'esquerra de la barra de nivell",
"Color" => "Color",
// "Main color of the gauge. Use HTML color codes or names" => "Main color of the gauge. Use HTML color codes or names",
// "Background color of the gauge. Use HTML color codes or names" => "Background color of the gauge. Use HTML color codes or names",
"Bar width in pixels" => "Amplada de la barra en píxels",
"Label Width" => "Amplada de l'etiqueta",
"Width in pixels allocated to the label" => "Amplada en píxels destinada a l'etiqueta",
"Display Percentage" => "Percentatge de Pantalla",
// "Set to true (Yes) to display a percentage of the maximum" => "Set to true (Yes) to display a percentage of the maximum",
"Display Value" => "Valor de Pantalla",
// "Set to false (No) to hide the numeric value (shown by default)" => "Set to false (No) to hide the numeric value (shown by default)",
"Bar height in pixels" => "Alçada de la barra en píxels",
// "Get Security Token" => "Get Security Token",
// "PluginGetAccessToken" => "PluginGetAccessToken",
// "Get security token for specified parameters" => "Get security token for specified parameters",
// "Entry point path or part of it" => "Entry point path or part of it",
// "The path of part of the path for which the token is for" => "The path of part of the path for which the token is for",
// "Query string parameter keys" => "Query string parameter keys",
// "Query string parameter keys for which the token is for, separated by " => "Query string parameter keys for which the token is for, separated by ",
// "Query string parameter Values" => "Query string parameter Values",
// "Query string parameter values for which the token is for, separated by " => "Query string parameter values for which the token is for, separated by ",
"Google Analytics" => "Analítica de Google",
"Add the tracking code for Google Analytics" => "Afegir el codi de rastreig per a l'Analítica de Google",
// "Account Number" => "Account Number",
// "The account number for the site. Your account number from google looks like UA-XXXXXXX-YY. All you need to enter is XXXXXXX-YY" => "The account number for the site. Your account number from google looks like UA-XXXXXXX-YY. All you need to enter is XXXXXXX-YY",
"Missing parameter" => "Manca algun paràmetre",
// "Google Doc" => "Google Doc",
// "Display a Google document" => "Display a Google document",
"Leave this empty" => "Deixar això buit",
"Type of Google document" => "Tipus de document de Google",
// "Document" => "Document",
// "Presentation" => "Presentation",
"key" => "clau",
"Google doc key - for example: pXsHENf1bGGY92X1iEeJJI" => "Clau del document de Google - per exemple pXsHENf1bGGY92X1iEeJJI",
// "Name of iframe. Default is \"Frame\" + the key" => "Name of iframe. Default is \"Frame\" + the key",
// "Size of frame. Use instead of width and height. The sizes will fit the Google presentations sizes exactly" => "Size of frame. Use instead of width and height. The sizes will fit the Google presentations sizes exactly",
// "Small" => "Small",
// "Large" => "Large",
// "Width in pixels or %" => "Width in pixels or %",
// "Height in pixels or %" => "Height in pixels or %",
// "Middle" => "Middle",
// "Frame Border" => "Frame Border",
// "Choose whether to show a border around the iframe" => "Choose whether to show a border around the iframe",
"Margin Height" => "Alçada de Marge",
// "Margin height in pixels" => "Margin height in pixels",
"Margin Width" => "Amplada de Marge",
// "Margin width in pixels" => "Margin width in pixels",
"Scrolling" => "Desplaçament",
// "Choose whether to add a scroll bar" => "Choose whether to add a scroll bar",
// "Auto" => "Auto",
// "Edit Link" => "Edit Link",
// "Choose whether to show an edit link and set its location" => "Choose whether to show an edit link and set its location",
"Required parameter \"type\" missing" => "Manca el paràmetre \"tipus\" requerit",
"Required parameter \"key\" missing" => "Manca el paràmetre \"clau\" requerit",
// "Google Map" => "Google Map",
// "Display a Google map" => "Display a Google map",
// "Type of items to show on google map" => "Type of items to show on google map",
// "Locator" => "Locator",
// "Object List" => "Object List",
// "Tracker Field" => "Tracker Field",
// "Display Mode" => "Display Mode",
// "Map display mode" => "Map display mode",
// "Satellite" => "Satellite",
// "Hybrid" => "Hybrid",
// "API Key" => "API Key",
// "Google maps key. Not needed if set in user preferences" => "Google maps key. Not needed if set in user preferences",
// "Valid key for the website, which can be obtained at http://code.google.com/apis/maps/signup.html" => "Valid key for the website, which can be obtained at http://code.google.com/apis/maps/signup.html",
// "Map ID" => "Map ID",
// "Id suffix of Google map div to avoid conflicts with other maps on same page" => "Id suffix of Google map div to avoid conflicts with other maps on same page",
// "Single \"word\" which must begin with a letter and may be followed by any number of digits, hyphens, underscores, colons and periods" => "Single \"word\" which must begin with a letter and may be followed by any number of digits, hyphens, underscores, colons and periods",
// "A plain number will be interpreted as pixels. Add a % symbol after the number to indicate percentage" => "A plain number will be interpreted as pixels. Add a % symbol after the number to indicate percentage",
// "Show Border" => "Show Border",
// "Choose whether to show a frame border around the map (no border shown by default)" => "Choose whether to show a frame border around the map (no border shown by default)",
// "Default Center Longitude" => "Default Center Longitude",
// "Default longitude value used to center the map, e.g. -79.39. Default is the default set in the Gmap feature" => "Default longitude value used to center the map, e.g. -79.39. Default is the default set in the Gmap feature",
// "An integer between -180 and 180" => "An integer between -180 and 180",
// "Default Center Latitude" => "Default Center Latitude",
// "Default latitude value used to center the map, e.g. 43.7. Default is the default set in the Gmap feature" => "Default latitude value used to center the map, e.g. 43.7. Default is the default set in the Gmap feature",
// "Default Zoom" => "Default Zoom",
// "Use an integer between 1 and 21 to set a default zoom level for the map. Default is the default set in the Gmap feature" => "Use an integer between 1 and 21 to set a default zoom level for the map. Default is the default set in the Gmap feature",
// "Save View" => "Save View",
// "Allow user to set current map view as default view for himself only" => "Allow user to set current map view as default view for himself only",
// "Marker" => "Marker",
// "Add a marker when only the default or no coordinates are set. No marker by default" => "Add a marker when only the default or no coordinates are set. No marker by default",
// "Text Bubble" => "Text Bubble",
// "Text for bubble for marker. Tiki wiki-syntax can be used" => "Text for bubble for marker. Tiki wiki-syntax can be used",
// "Plain text or Tiki wiki-syntax" => "Plain text or Tiki wiki-syntax",
// "Show/Hide Marker Text" => "Show/Hide Marker Text",
// "Set whether the marker text bubble is shown or hidden initially. Default is to hide" => "Set whether the marker text bubble is shown or hidden initially. Default is to hide",
// "Item Type" => "Item Type",
// "Type of item being geotagged (user, wiki page, blog, etc). Will attempt to use current object if not specified. Tracker items must be categorized" => "Type of item being geotagged (user, wiki page, blog, etc). Will attempt to use current object if not specified. Tracker items must be categorized",
// "Item ID or Name" => "Item ID or Name",
// "ID of item being geotagged (name of page, blog ID, etc). Will attempt to use current object if not specified" => "ID of item being geotagged (name of page, blog ID, etc). Will attempt to use current object if not specified",
// "Any ID number or name for an existing object of the type specified in the Item Type field" => "Any ID number or name for an existing object of the type specified in the Item Type field",
// "Hide If No Markers" => "Hide If No Markers",
// "Hide map if there are no markers to be shown. Default is to show the map" => "Hide map if there are no markers to be shown. Default is to show the map",
// "Visibility Toggle" => "Visibility Toggle",
// "Add ability to toggle visibility. No toggle by default" => "Add ability to toggle visibility. No toggle by default",
// "Toggle Link Align" => "Toggle Link Align",
// "Alignment for the show/hide toggle link" => "Alignment for the show/hide toggle link",
// "Start Hidden" => "Start Hidden",
// "Choose whether to keep the map hidden initially. Default is to show the map initially" => "Choose whether to keep the map hidden initially. Default is to show the map initially",
// "Auto Zoom" => "Auto Zoom",
// "Use an integer between 1 and 21 to auto zoom to this level on address find" => "Use an integer between 1 and 21 to auto zoom to this level on address find",
// "Show Controls" => "Show Controls",
// "Show map controls (shown by default)" => "Show map controls (shown by default)",
// "Zoom Only" => "Zoom Only",
// "Zoom and Type" => "Zoom and Type",
// "Zoom and Scale" => "Zoom and Scale",
// "Type Only" => "Type Only",
// "Type and Scale" => "Type and Scale",
// "Scale Only" => "Scale Only",
// "Tracker Field ID" => "Tracker Field ID",
// "Field ID of tracker field if type is Item, Tracker Field or Locator, Item Type is trackeritem and Item ID is the tracker item ID. Tracker item must be categorized" => "Field ID of tracker field if type is Item, Tracker Field or Locator, Item Type is trackeritem and Item ID is the tracker item ID. Tracker item must be categorized",
// "Numeric ID of a location type tracker field" => "Numeric ID of a location type tracker field",
// "Tracker HTML ID" => "Tracker HTML ID",
// "HTML ID of tracker field input box where value is copied to by Javascript. Auto set if used as part of entry forms" => "HTML ID of tracker field input box where value is copied to by Javascript. Auto set if used as part of entry forms",
// "In Form" => "In Form",
// "Set to 1 (Yes) if this is embedded inside a form. Needed to prevent nested forms which is not allowed in HTML" => "Set to 1 (Yes) if this is embedded inside a form. Needed to prevent nested forms which is not allowed in HTML",
// "Show location map" => "Show location map",
// "Hide location map" => "Hide location map",
// "Google Maps API key not set" => "Google Maps API key not set",
// "No such user" => "No such user",
"The user has chosen to make his information private" => "L'usuari ha escollit convertir la seva informació en privada",
// "No such object" => "No such object",
"Group" => "Grup",
// "Display content based on the user's groups or friends" => "Display content based on the user's groups or friends",
// "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the conditions" => "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the conditions",
// "Allowed User Friends" => "Allowed User Friends",
// "Pipe separated list of users whose friends are allowed to view the block. ex: admin|johndoe|foo" => "Pipe separated list of users whose friends are allowed to view the block. ex: admin|johndoe|foo",
"Allowed Groups" => "Grups Permesos",
"Pipe separated list of groups allowed to view the block. ex: Admins|Developers" => "Lista separada per barres verticals dels grups permesos per veure el bloc. ex: Admins|Desenvolupadors",
"Denied Groups" => "Grups Denegats",
"Pipe separated list of groups denied from viewing the block. ex: Anonymous|Managers" => "Llista separada per barres verticals dels grups denegats per veure el bloc. ex: Gestors|Anònims",
// "Group Expiry" => "Group Expiry",
// "Show the expiry date of a group membership of the current user" => "Show the expiry date of a group membership of the current user",
// "not in group" => "not in group",
// "never expires" => "never expires",
// "Group List" => "Group List",
// "List all groups or just groups that include a certain group" => "List all groups or just groups that include a certain group",
// "If empty, all groups will be listed. Entering a group name will cause only groups that include this group to be listed" => "If empty, all groups will be listed. Entering a group name will cause only groups that include this group to be listed",
// "Group Home Page" => "Group Home Page",
// "Link the group name to the group home page, if there is one (not linked by default)" => "Link the group name to the group home page, if there is one (not linked by default)",
// "Recursively List Groups" => "Recursively List Groups",
// "Recurse on the included groups (default is not to recurse)" => "Recurse on the included groups (default is not to recurse)",
// "GroupMail Core" => "GroupMail Core",
// "Displays GroupMail functions on a wiki page. Usually set up using a plugin alias created by the GroupMail profile" => "Displays GroupMail functions on a wiki page. Usually set up using a plugin alias created by the GroupMail profile",
// "From Email" => "From Email",
// "Email address to report" => "Email address to report",
// "Tracker Id" => "Tracker Id",
// "Id of GroupMail Logs tracker (set up in alias by profile)" => "Id of GroupMail Logs tracker (set up in alias by profile)",
// "From Field Id" => "From Field Id",
// "Id of GroupMail Logs tracker field (usually set up in alias by profile)" => "Id of GroupMail Logs tracker field (usually set up in alias by profile)",
// "Operator Field Id" => "Operator Field Id",
// "Subject Field Id" => "Subject Field Id",
// "Message Field Id" => "Message Field Id",
// "Content Field Id" => "Content Field Id",
// "Account Field Id" => "Account Field Id",
// "Datetime Field Id" => "Datetime Field Id",
// "Group Stats" => "Group Stats",
// "Show the distribution of users among groups" => "Show the distribution of users among groups",
"Groups" => "Grups",
// "Groups separated by :. If empty, all groups will be listed" => "Groups separated by :. If empty, all groups will be listed",
// "Percentage of" => "Percentage of",
// "Show percentage out of all users in site, or just specified groups if any" => "Show percentage out of all users in site, or just specified groups if any",
// "Users in specified groups, if any" => "Users in specified groups, if any",
// "Site users" => "Site users",
// "Show Percentage" => "Show Percentage",
// "Show the percentage of total users that are members of each group (percentages are shown by default)" => "Show the percentage of total users that are members of each group (percentages are shown by default)",
// "Show Bar" => "Show Bar",
// "Represent the percentage of total users that are members of each group in a bar graph (default is not to show the bar graph)" => "Represent the percentage of total users that are members of each group in a bar graph (default is not to show the bar graph)",
// "Has Bought" => "Has Bought",
// "Check if user has bought certain item or if it is in cart" => "Check if user has bought certain item or if it is in cart",
// "PluginHasBought" => "PluginHasBought",
// "Session key names to be collected" => "Session key names to be collected",
// "Key name of passcode to be checked" => "Key name of passcode to be checked",
// "Labels for the key names to be collected" => "Labels for the key names to be collected",
// "Label of the key name of passcode to be checked" => "Label of the key name of passcode to be checked",
// "Tracker from which to get passcode to check against" => "Tracker from which to get passcode to check against",
// "Field ID from which to get passcode to check against" => "Field ID from which to get passcode to check against",
// "Item ID from which to get passcode to check against" => "Item ID from which to get passcode to check against",
// "Please fill in all fields" => "Please fill in all fields",
"HTML" => "HTML",
// "Add HTML to a page" => "Add HTML to a page",
"HTML code" => "codi HTML",
// "Parse wiki syntax within the HTML code" => "Parse wiki syntax within the HTML code",
// "Textlink" => "Textlink",
// "Adds an item to HTML feed" => "Adds an item to HTML feed",
// "HTML Feed Link" => "HTML Feed Link",
// "Display remote content" => "Display remote content",
// "Initial Value" => "Initial Value",
// "Feed location" => "Feed location",
// "Name of content" => "Name of content",
// "Style of content" => "Style of content",
// "Highlight" => "Highlight",
// "Asterisk" => "Asterisk",
// "HTML Feed Link Type" => "HTML Feed Link Type",
"Replace" => "Reemplaçar",
// "Backlink" => "Backlink",
// "Popup" => "Popup",
// "Hover" => "Hover",
// "Is the HTML feed moderated" => "Is the HTML feed moderated",
// "Date of last accepted HTML item, not used if not moderated" => "Date of last accepted HTML item, not used if not moderated",
"Iframe" => "Iframe",
// "Include another web page within a frame" => "Include another web page within a frame",
// "Frame title" => "Frame title",
"Pixels or %" => "Píxels o %",
// "Align the iframe on the page" => "Align the iframe on the page",
// "Display custom formatted images" => "Display custom formatted images",
// "Image source" => "Image source",
// "Full URL to the image to display. \"src\", id\", \"fileId\", \"attId\" or \"randomGalleryId\" required" => "Full URL to the image to display. \"src\", id\", \"fileId\", \"attId\" or \"randomGalleryId\" required",
"Image ID" => "Imatge ID",
// "Numeric ID of an image in an Image Gallery (or list separated by commas or |)" => "Numeric ID of an image in an Image Gallery (or list separated by commas or |)",
// "Numeric ID of an image in a File Gallery (or list separated by commas or |)" => "Numeric ID of an image in a File Gallery (or list separated by commas or |)",
// "Numeric ID of a file gallery. Displays a random image from that gallery" => "Numeric ID of a file gallery. Displays a random image from that gallery",
// "Numeric ID of a file gallery. Displays all images from that gallery" => "Numeric ID of a file gallery. Displays all images from that gallery",
// "File Name Ascending" => "File Name Ascending",
// "File Name Descending" => "File Name Descending",
// "Comment Ascending" => "Comment Ascending",
// "Comment Descending" => "Comment Descending",
// "Max Hits Ascending" => "Max Hits Ascending",
// "Max Hits Descending" => "Max Hits Descending",
// "File Size Ascending" => "File Size Ascending",
// "File Size Descending" => "File Size Descending",
// "File Type Ascending" => "File Type Ascending",
// "File Type Descending" => "File Type Descending",
// "User Ascending" => "User Ascending",
// "User Descending" => "User Descending",
// "Author Ascending" => "Author Ascending",
// "Author Descending" => "Author Descending",
// "Locked By Ascending" => "Locked By Ascending",
// "Locked By Descending" => "Locked By Descending",
// "Last Modified User Ascending" => "Last Modified User Ascending",
// "Last Modified User Descending" => "Last Modified User Descending",
// "Last Modified Date Ascending" => "Last Modified Date Ascending",
// "Last Modified Date Descending" => "Last Modified Date Descending",
// "Last Download Ascending" => "Last Download Ascending",
// "Last Download Descending" => "Last Download Descending",
// "Delete After Ascending" => "Delete After Ascending",
// "Delete After Descending" => "Delete After Descending",
// "Votes Ascending" => "Votes Ascending",
// "Votes Descending" => "Votes Descending",
// "Points Ascending" => "Points Ascending",
// "Points Descending" => "Points Descending",
// "Archive ID Ascending" => "Archive ID Ascending",
// "Archive ID Descending" => "Archive ID Descending",
// "Attachment ID" => "Attachment ID",
// "Numeric ID of an image attached to a wiki page (or list separated by commas or |)" => "Numeric ID of an image attached to a wiki page (or list separated by commas or |)",
"Thumbnail" => "Miniatura",
// "Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery or attachments" => "Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery or attachments",
// "Full size image appears when thumbnail is clicked" => "Full size image appears when thumbnail is clicked",
// "Mouseover" => "Mouseover",
// "Full size image will pop up while cursor is over the thumbnail (and disappear when not)" => "Full size image will pop up while cursor is over the thumbnail (and disappear when not)",
// "Mouseover (Sticky)" => "Mouseover (Sticky)",
// "Full size image will pop up once cursor passes over thumbnail and will remain up unless cursor passes over full size popup" => "Full size image will pop up once cursor passes over thumbnail and will remain up unless cursor passes over full size popup",
// "Full size image will open in a separate winow or tab (depending on browser settings) when thumbnail is clicked" => "Full size image will open in a separate winow or tab (depending on browser settings) when thumbnail is clicked",
"Browse" => "Visitar",
// "Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery" => "Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery",
// "Browse Popup" => "Browse Popup",
// "Same as \"browse\" except that the page opens in a new window or tab" => "Same as \"browse\" except that the page opens in a new window or tab",
// "Download dialog box will appear for file gallery and attachment images when thumbnail is clicked" => "Download dialog box will appear for file gallery and attachment images when thumbnail is clicked",
// "Enlarge button" => "Enlarge button",
// "Button for enlarging image" => "Button for enlarging image",
// "Enter a URL to the address the image should link to. Not needed if thumb parameter is set; overrides thumb setting" => "Enter a URL to the address the image should link to. Not needed if thumb parameter is set; overrides thumb setting",
// "Link relation" => "Link relation",
// "Enter \"box\" for colorbox effect (like shadowbox and lightbox) or appropriate syntax for link relation" => "Enter \"box\" for colorbox effect (like shadowbox and lightbox) or appropriate syntax for link relation",
// "Image map" => "Image map",
// "Name of the image map to use for the image" => "Name of the image map to use for the image",
"Image height" => "Alçada de la imatge",
// "Height in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent" => "Height in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent",
"Image width" => "Amplada d'Imatge",
// "Width in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent" => "Width in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent",
// "Maximum height or width in pixels (largest dimension is scaled). Overrides height and width settings" => "Maximum height or width in pixels (largest dimension is scaled). Overrides height and width settings",
// "Align image" => "Align image",
// "Aligns the image itself. If the image is inside a box (because of other settings), use the align parameter to align the box" => "Aligns the image itself. If the image is inside a box (because of other settings), use the align parameter to align the box",
// "Image style" => "Image style",
// "Enter \"border\" to place a dark gray border around the image. Otherwise enter CSS styling syntax for other style effects" => "Enter \"border\" to place a dark gray border around the image. Otherwise enter CSS styling syntax for other style effects",
// "Align image block" => "Align image block",
// "Aligns the box containing the image" => "Aligns the box containing the image",
// "Image block style" => "Image block style",
// "Enter \"border\" to place a dark gray border frame around the image. Otherwise enter CSS styling syntax for other style effects" => "Enter \"border\" to place a dark gray border frame around the image. Otherwise enter CSS styling syntax for other style effects",
// "Description style" => "Description style",
// "Enter \"right\" or \"left\" to align text accordingly. Otherwise enter CSS styling syntax for other style effects" => "Enter \"right\" or \"left\" to align text accordingly. Otherwise enter CSS styling syntax for other style effects",
// "Wrapping control" => "Wrapping control",
// "Control how other items wrap around the image" => "Control how other items wrap around the image",
// "CSS class to apply to the image" => "CSS class to apply to the image",
// "Image caption. \"desc\" or \"name\" or \"namedesc\" for tiki images, \"idesc\" or \"ititle\" for iptc data, otherwise enter your own description" => "Image caption. \"desc\" or \"name\" or \"namedesc\" for tiki images, \"idesc\" or \"ititle\" for iptc data, otherwise enter your own description",
// "Link title" => "Link title",
// "Title text. \"desc\" or \"name\" or \"namedesc\", otherwise enter your own title" => "Title text. \"desc\" or \"name\" or \"namedesc\", otherwise enter your own title",
// "Metadata" => "Metadata",
// "Display the image metadata (IPTC and EXIF information)" => "Display the image metadata (IPTC and EXIF information)",
// "Alternate text" => "Alternate text",
// "Alternate text that displays when image does not load. Set to \"Image\" by default" => "Alternate text that displays when image does not load. Set to \"Image\" by default",
// "Default config settings" => "Default config settings",
// "Default configuration settings (usually set by admin in the source code or through Plugin Alias)" => "Default configuration settings (usually set by admin in the source code or through Plugin Alias)",
// "Mandatory admin setting" => "Mandatory admin setting",
// "Mandatory configuration settings (usually set by admin in the source code or through Plugin Alias)" => "Mandatory configuration settings (usually set by admin in the source code or through Plugin Alias)",
// "PluginImg: User lacks permission to view image" => "PluginImg: User lacks permission to view image",
// "File is not an image" => "File is not an image",
// "Server does not support image manipulation" => "Server does not support image manipulation",
// "Enlarge" => "Enlarge",
// "''No image specified. One of the following parameters must be set: fileId, randomGalleryId, fgalId, attId, id.''" => "''No image specified. One of the following parameters must be set: fileId, randomGalleryId, fgalId, attId, id.''",
// "''Use one and only one of the following parameters: fileId, randomGalleryId, fgalId, attId, id, or src.''" => "''Use one and only one of the following parameters: fileId, randomGalleryId, fgalId, attId, id, or src.''",
// "Edit: Image" => "Edit: Image",
// "(experimental)" => "(experimental)",
"Include" => "Inclou",
// "Include content from a wiki page" => "Include content from a wiki page",
// "Wiki page name to include" => "Wiki page name to include",
// "When only a portion of the page should be included, specify the marker from which inclusion should start" => "When only a portion of the page should be included, specify the marker from which inclusion should start",
"Stop" => "Atura",
// "When only a portion of the page should be included, specify the marker at which inclusion should end" => "When only a portion of the page should be included, specify the marker at which inclusion should end",
// "Nopage Text" => "Nopage Text",
// "Text to show when no page is found" => "Text to show when no page is found",
// "Page Denied Text" => "Page Denied Text",
// "Text to show when the page exists but is denied to the user" => "Text to show when the page exists but is denied to the user",
// "Include Plugin" => "Include Plugin",
// "Edit the included page" => "Edit the included page",
// "Invite" => "Invite",
// "Invite a user to join your groups" => "Invite a user to join your groups",
// "Confirmation message after posting form" => "Confirmation message after posting form",
// "Including Group" => "Including Group",
// "Will list only the groups that include this group" => "Will list only the groups that include this group",
"Default Group" => "grup per defecte",
// "Dropdown list will show this group by default" => "Dropdown list will show this group by default",
// "Dropdown list will show the group related to this item ID (in group selector or creator field) by default" => "Dropdown list will show the group related to this item ID (in group selector or creator field) by default",
"Following mandatory fields are missing" => "Manquen els camps obligatoris següents",
// "Jabber" => "Jabber",
// "Chat using Jabber" => "Chat using Jabber",
// "Applet height in pixels" => "Applet height in pixels",
// "Applet width in pixels" => "Applet width in pixels",
// "XML Host Name" => "XML Host Name",
// "Web site where XML is hosted. Default is jabber.org" => "Web site where XML is hosted. Default is jabber.org",
// "Default Color" => "Default Color",
// "Set default color. Default is 255,255,255" => "Set default color. Default is 255,255,255",
// "Add JavaScript code" => "Add JavaScript code",
// "JavaScript code" => "JavaScript code",
// "Not On Ready" => "Not On Ready",
// "Do not execute on document ready (execute inline)" => "Do not execute on document ready (execute inline)",
// "No JavaScript" => "No JavaScript",
// "Optional markup for when JavaScript is off" => "Optional markup for when JavaScript is off",
// "<!-- jq plugin inactive: JavaScript off -->" => "<!-- jq plugin inactive: JavaScript off -->",
// "JavaScript" => "JavaScript",
// "JavaScript filename" => "JavaScript filename",
// "Late Load" => "Late Load",
// "Late load, use headerlib" => "Late load, use headerlib",
// "Kaltura Video" => "Kaltura Video",
// "Display a video created through the Kaltura feature" => "Display a video created through the Kaltura feature",
// "Kaltura Entry ID" => "Kaltura Entry ID",
// "Kaltura entry ID of the video to be displayed" => "Kaltura entry ID of the video to be displayed",
// "Vary text based on the page language" => "Vary text based on the page language",
// "List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs",
// "Not Language" => "Not Language",
// "List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs",
// "Show the last modification date for a page" => "Show the last modification date for a page",
// "Page name to display information of. Default value is current page" => "Page name to display information of. Default value is current page",
// "Create lists of Tiki objects based on custom search criteria and formatting" => "Create lists of Tiki objects based on custom search criteria and formatting",
// "List configuration information" => "List configuration information",
// "Missing template \"%0\"" => "Missing template \"%0\"",
// "No results for query" => "No results for query",
// "Missing objectype or qualifier for relation filter" => "Missing objectype or qualifier for relation filter",
// "Missing from or to for range filter" => "Missing from or to for range filter",
"List Pages" => "Llista pàgines",
// "List pages based on various criteria" => "List pages based on various criteria",
// "Result number at which the listing should start" => "Result number at which the listing should start",
// "Limit number of items displayed in the list. Default is to display all" => "Limit number of items displayed in the list. Default is to display all",
// "Initial" => "Initial",
// "txt" => "txt",
// "Show Name Only" => "Show Name Only",
// "Show only the page names" => "Show only the page names",
// "If set to a category identifier, restrict the pages displayed to those in the specified category" => "If set to a category identifier, restrict the pages displayed to those in the specified category",
// "If set to a list of category identifiers separated by colons (:), restrict the pages to those in any of the specified categories" => "If set to a list of category identifiers separated by colons (:), restrict the pages to those in any of the specified categories",
// "If set to a list of category identifiers separated by plus signs (+), only display a page if it is in all of the specified categories" => "If set to a list of category identifiers separated by plus signs (+), only display a page if it is in all of the specified categories",
// "If set to a list of category identifiers separated by minus signs (-), only display a page if it is in the first specified category and not in any of the following categories" => "If set to a list of category identifiers separated by minus signs (-), only display a page if it is in the first specified category and not in any of the following categories",
// "Structure Head" => "Structure Head",
// "Filter by structure head" => "Filter by structure head",
// "Show Page Alias" => "Show Page Alias",
// "Show page alias in the list" => "Show page alias in the list",
// "Only pages with names similar the text entered for this parameter will be listed" => "Only pages with names similar the text entered for this parameter will be listed",
// "Two letter language code to filter pages listed" => "Two letter language code to filter pages listed",
// "Orphan Language" => "Orphan Language",
// "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed" => "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed",
// "Load Translations" => "Load Translations",
// "User or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter" => "User or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter",
// "Page name and text entered for the filter parameter must match exactly to be listed" => "Page name and text entered for the filter parameter must match exactly to be listed",
// "Only Orphan Pages" => "Only Orphan Pages",
// "Only list orphan pages" => "Only list orphan pages",
// "For List Pages" => "For List Pages",
// "Sort ascending or descending on any field in the tiki_pages table. Syntax is field name followed by _asc or _desc. Example: " => "Sort ascending or descending on any field in the tiki_pages table. Syntax is field name followed by _asc or _desc. Example: ",
"or" => "o",
// "Length" => "Length",
// "Number of characters to display" => "Number of characters to display",
// "Show checkboxes" => "Show checkboxes",
// "List Directory" => "List Directory",
"Lists files in a directory" => "Llista arxius en un directori",
// "Full path to the server-local directory. Default is the document root" => "Full path to the server-local directory. Default is the document root",
// "URL Prefix" => "URL Prefix",
// "Make the file name a link to the file by adding the URL path preceding the file name. Example: http://yoursite.com/tiki/" => "Make the file name a link to the file by adding the URL path preceding the file name. Example: http://yoursite.com/tiki/",
// "Set the sort order of the file list" => "Set the sort order of the file list",
"File Name" => "Nom d'arxiu",
// "File Size" => "File Size",
// "Last Access" => "Last Access",
// "Last Metadata Change" => "Last Metadata Change",
// "Only list files with filenames that contain this filter. Example: \".jpg\"" => "Only list files with filenames that contain this filter. Example: \".jpg\"",
// "Maximum amount of files to display. Default is no limit" => "Maximum amount of files to display. Default is no limit",
"could not be opened because it doesn't exist or permission was denied" => "no es pot obrir perquè no hi és o s'ha denegat el permís",
"Mail" => "Correu",
// "Directly mail other users or groups" => "Directly mail other users or groups",
// "Limit the list of groups to the groups including each group" => "Limit the list of groups to the groups including each group",
// "Show Group Dropdown" => "Show Group Dropdown",
// "Show a dropdown list of groups (not shown by default)" => "Show a dropdown list of groups (not shown by default)",
// "Recurse on groups" => "Recurse on groups",
// "show each group and each group included in this group" => "show each group and each group included in this group",
// "Recurse on groups to have the users" => "Recurse on groups to have the users",
// "Collect the users of a selected group and the users of each included groups. If 0 do not recurse, if 1, recurse one time, 2 two times..." => "Collect the users of a selected group and the users of each included groups. If 0 do not recurse, if 1, recurse one time, 2 two times...",
// "Show User Dropdown" => "Show User Dropdown",
// "Show a dropdown list of users (not shown by default)" => "Show a dropdown list of users (not shown by default)",
// "User Autocomplete" => "User Autocomplete",
// "Show an autocomplete box on user name" => "Show an autocomplete box on user name",
// "Real Name Dropdown" => "Real Name Dropdown",
// "Show a dropdown list of user real names (not shown by default)" => "Show a dropdown list of user real names (not shown by default)",
"Map" => "Mapa",
// "Display a map" => "Display a map",
// "Instructions to load content" => "Instructions to load content",
// "Scope" => "Scope",
// "Display the geolocated items represented in the page (all, center, or custom as a CSS selector). Default: center" => "Display the geolocated items represented in the page (all, center, or custom as a CSS selector). Default: center",
// "Controls" => "Controls",
// "Allows to specify which map controls will be displayed on the map and around it (controls, layers, search_location, levels, current_location, scale, streetview, navigation, coordinates, overview)" => "Allows to specify which map controls will be displayed on the map and around it (controls, layers, search_location, levels, current_location, scale, streetview, navigation, coordinates, overview)",
// "Width of the map in pixels" => "Width of the map in pixels",
// "Height of the map in pixels" => "Height of the map in pixels",
"Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19" => "Format: x,y,zoom on x és la longitud, y és la latitud, i el Zoom pot anar de 0(vista de tota la Terra) fins a 19",
// "MapServer File" => "MapServer File",
// "MapServer file identifier. Only fill this in if you are using MapServer" => "MapServer file identifier. Only fill this in if you are using MapServer",
// "Extents" => "Extents",
// "Size of the map" => "Size of the map",
// "Color Picker" => "Color Picker",
// "Mayan Calendars" => "Mayan Calendars",
// "Convert a Gregorian date to a Mayan calendar date" => "Convert a Gregorian date to a Mayan calendar date",
"Template" => "Plantilla",
// "You must use the variable substitution" => "You must use the variable substitution",
// "LongCount: " => "LongCount: ",
// "Tzolkin: " => "Tzolkin: ",
// "Haab: " => "Haab: ",
// "Misc: " => "Misc: ",
// "Example: template " => "Example: template ",
// "for 22.05.2009 will return 12.19.16.6.11, 8 CHUEN, 9 SIP" => "for 22.05.2009 will return 12.19.16.6.11, 8 CHUEN, 9 SIP",
// "Default template: " => "Default template: ",
// "Gregorian date" => "Gregorian date",
// "Gregorian date for convert. Format: DD.MM.YYYY. Default: Today date" => "Gregorian date for convert. Format: DD.MM.YYYY. Default: Today date",
// " is not a valid date format. should be dd.mm.yyyy" => " is not a valid date format. should be dd.mm.yyyy",
// "Media Player" => "Media Player",
// "Add a media player to a page" => "Add a media player to a page",
// "Allow Fullscreen" => "Allow Fullscreen",
// "Allow fullscreen mode" => "Allow fullscreen mode",
// " true|false" => " true|false",
// "MP3 URL" => "MP3 URL",
// "Complete URL to the mp3 to include" => "Complete URL to the mp3 to include",
// "FLV URL" => "FLV URL",
// "Complete URL to the flv to include" => "Complete URL to the flv to include",
// "Complete URL to the media to include" => "Complete URL to the media to include",
// "One of" => "One of",
// "Flash Window Mode" => "Flash Window Mode",
// "Sets the Window Mode property of the Flash movie. Transparent lets what's behind the movie show through and allows the movie to be covered Opaque hides what's behind the movie and Window plays the movie in its own window. Default value: " => "Sets the Window Mode property of the Flash movie. Transparent lets what's behind the movie show through and allows the movie to be covered Opaque hides what's behind the movie and Window plays the movie in its own window. Default value: ",
"Transparent" => "Transparent",
// "Opaque" => "Opaque",
// "Window" => "Window",
// "Member List" => "Member List",
// "List and allow editing of group members" => "List and allow editing of group members",
// "List of groups to handle through the interface (use \"*\" for all). Colon separated" => "List of groups to handle through the interface (use \"*\" for all). Colon separated",
// "Show Descriptions" => "Show Descriptions",
// "Display group descriptions below list name" => "Display group descriptions below list name",
// "Display mode" => "Display mode",
// "How to show the member lists" => "How to show the member lists",
// "Tabs" => "Tabs",
// "Maximum" => "Maximum",
// "Maximum number of users to list in each group (default 100)" => "Maximum number of users to list in each group (default 100)",
// "Members Only" => "Members Only",
// "Only shows groups containing a certain user. Enter \"%user%\" to show groups for the current logged in user" => "Only shows groups containing a certain user. Enter \"%user%\" to show groups for the current logged in user",
// "Sort mode" => "Sort mode",
// "Sort mode for member listing" => "Sort mode for member listing",
// "Read only" => "Read only",
// "Read only mode. All ability to modify membership is hidden" => "Read only mode. All ability to modify membership is hidden",
// "Set as Default Group" => "Set as Default Group",
// "Adds possibility to set group as default group. This automatically adds the user to the group. \"Forced\" option will not propose simple addition in group" => "Adds possibility to set group as default group. This automatically adds the user to the group. \"Forced\" option will not propose simple addition in group",
// "Not suggested" => "Not suggested",
// "Suggested" => "Suggested",
// "Forced" => "Forced",
// "Only groups including the group that you specify will be listed" => "Only groups including the group that you specify will be listed",
// "Member Payment" => "Member Payment",
// "Receive payments from a member to extend membership to a group" => "Receive payments from a member to extend membership to a group",
// "Name of the group for which the subscription should be added or extended" => "Name of the group for which the subscription should be added or extended",
// "Price per period (%0)" => "Price per period (%0)",
// "Current User Member" => "Current User Member",
// "Membership only for the current user" => "Membership only for the current user",
// "Input Title" => "Input Title",
// "Title of the input form" => "Title of the input form",
// "Use %0 for the group name" => "Use %0 for the group name",
// "Supports wiki syntax" => "Supports wiki syntax",
// "Tiki Payments Invoice Title" => "Tiki Payments Invoice Title",
// "Use %0 for the group name, %4 for the number of days or %5 for the number of years" => "Use %0 for the group name, %4 for the number of days or %5 for the number of years",
// "Prevent double request" => "Prevent double request",
// "Prevent user from extended if there is already a pending request" => "Prevent user from extended if there is already a pending request",
// "Give specified numbers of free periods" => "Give specified numbers of free periods",
// "Give specified numbers of free periods, the first one could be prorated, in addition to those bought" => "Give specified numbers of free periods, the first one could be prorated, in addition to those bought",
// "Periods Label" => "Periods Label",
// "Give the period a label" => "Give the period a label",
// "The user " => "The user ",
// " already has a pending extension request payment invoice " => " already has a pending extension request payment invoice ",
// "Membership to %0 for %1 (x%2)" => "Membership to %0 for %1 (x%2)",
// "Membership to %0 for %1 users (x%2)" => "Membership to %0 for %1 users (x%2)",
// "The group " => "The group ",
// " does not have a membership term" => " does not have a membership term",
// " Go to " => " Go to ",
// "Admin > Groups" => "Admin > Groups",
// " to specify a term for this group by automatically unassigning users after a certain number of days" => " to specify a term for this group by automatically unassigning users after a certain number of days",
// " does not exist" => " does not exist",
// "Mini Quiz" => "Mini Quiz",
// "Create a quiz using a tracker" => "Create a quiz using a tracker",
// "Instructions::Feedback" => "Instructions::Feedback",
// "Numeric value representing the miniquiz tracker ID" => "Numeric value representing the miniquiz tracker ID",
"Insert Module" => "Insereix un mòdul",
// "Display a module" => "Display a module",
"Module Name" => "Nom del mòdul",
// "Module name as known in Tiki" => "Module name as known in Tiki",
// "Select Yes (y) to hide the title (default is to show the title)" => "Select Yes (y) to hide the title (default is to show the title)",
// "Title to display at the top of the box, assuming No Title is not set to Yes (y)" => "Title to display at the top of the box, assuming No Title is not set to Yes (y)",
// "Align the module to the left or right on the page allowing other elements to align against it" => "Align the module to the left or right on the page allowing other elements to align against it",
// "Number of rows (default: 10)" => "Number of rows (default: 10)",
"Parse" => "Interpreta",
// "Parse wiki syntax" => "Parse wiki syntax",
// "Show only the content with no box surrounding it" => "Show only the content with no box surrounding it",
// "Decoration" => "Decoration",
// "Show box decorations (default is to show them)" => "Show box decorations (default is to show them)",
// "Add ability to show/hide the content of the module (default is the site admin setting for modules)" => "Add ability to show/hide the content of the module (default is the site admin setting for modules)",
// "Title Background" => "Title Background",
// "Override the background color for the title (if the title is shown). The value can be a color name (ex: bgcolor=blue) or a hexadecimal value (ex: bgcolor=#FFEBCD)" => "Override the background color for the title (if the title is shown). The value can be a color name (ex: bgcolor=blue) or a hexadecimal value (ex: bgcolor=#FFEBCD)",
// "Module Style" => "Module Style",
// "Inline CSS for the containing DIV element, e.g. \"max-width:80%\"" => "Inline CSS for the containing DIV element, e.g. \"max-width:80%\"",
// "CSS styling for the module data itself" => "CSS styling for the module data itself",
"Please choose a module" => "Si us plau, trieu un mòdul",
"to be used as argument" => "per ser emprat com a argument",
"Sorry, no such module" => "Perdó, aquest mòdul no existeix",
// "Monospace" => "Monospace",
// "Display text in a monospace font" => "Display text in a monospace font",
// "Font name as known in browsers" => "Font name as known in browsers",
// "Display hidden content by mousing over a text" => "Display hidden content by mousing over a text",
// "Hidden content, unless the label parameter is undefined, in which case this is the label" => "Hidden content, unless the label parameter is undefined, in which case this is the label",
// "Text displayed on the page. The body is the hidden content" => "Text displayed on the page. The body is the hidden content",
// "Destination link when mouseover text is clicked. Use http:// for external links" => "Destination link when mouseover text is clicked. Use http:// for external links",
// "DEPRECATED" => "DEPRECATED",
// "Hidden content. The body contains the label" => "Hidden content. The body contains the label",
// "Mouseover box width. Default: 400px" => "Mouseover box width. Default: 400px",
// "Mouseover box height. Default: 200px" => "Mouseover box height. Default: 200px",
// "Offset X" => "Offset X",
// "Shifts the overlay to the right by the specified number of pixels relative to the cursor. Default: 5" => "Shifts the overlay to the right by the specified number of pixels relative to the cursor. Default: 5",
// "Offset Y" => "Offset Y",
// "Shifts the overlay lower by the specified number of pixels relative to the cursor. Default: 0" => "Shifts the overlay lower by the specified number of pixels relative to the cursor. Default: 0",
// "Parse Body" => "Parse Body",
// "Parse the body of the plugin as wiki content (parsed by default)" => "Parse the body of the plugin as wiki content (parsed by default)",
// "Parse Label" => "Parse Label",
// "Parse the label as wiki content (parsed by default)" => "Parse the label as wiki content (parsed by default)",
// "CSS class to apply" => "CSS class to apply",
// "Background color to apply to the popup" => "Background color to apply to the popup",
// "Text Color" => "Text Color",
// "Color to apply to the text in the popup" => "Color to apply to the text in the popup",
"Sticky" => "Enganxós",
// "When enabled, popup stays visible until it is clicked" => "When enabled, popup stays visible until it is clicked",
// "Padding" => "Padding",
// "Padding size in pixels" => "Padding size in pixels",
// "Effect" => "Effect",
// "Set the type of show/hide animation that will be used" => "Set the type of show/hide animation that will be used",
// "Effect Speed" => "Effect Speed",
// "Set the speed of the animation" => "Set the speed of the animation",
// "Close Delay" => "Close Delay",
// "Number of seconds before popup closes" => "Number of seconds before popup closes",
"Tag" => "Marcador",
// "HTML tag to use for the label. Default \"a\"" => "HTML tag to use for the label. Default \"a\"",
// "No label specified" => "No label specified",
// "MediaWiki Table" => "MediaWiki Table",
// "Display a table using MediaWiki syntax (experimental - may change in future versions)" => "Display a table using MediaWiki syntax (experimental - may change in future versions)",
// "Fancy" => "Fancy",
// "Set to true to apply additional formatting to the table (header style, odd/even rows, etc.)" => "Set to true to apply additional formatting to the table (header style, odd/even rows, etc.)",
// "True" => "True",
// "False" => "False",
// "Wiki Classes" => "Wiki Classes",
// "Determines whether wiki style classes will be used for the table and cells (used by default)" => "Determines whether wiki style classes will be used for the table and cells (used by default)",
// "MySpace" => "MySpace",
// "Display a MySpace Flash mp3 playlist" => "Display a MySpace Flash mp3 playlist",
// "MySpace Page" => "MySpace Page",
// "MySpace page name" => "MySpace page name",
// "Now" => "Now",
// "Display the current date or time" => "Display the current date or time",
"Format" => "Format",
// "Time format" => "Time format",
// "Object Hits" => "Object Hits",
// "Display the number of hits for certain objects" => "Display the number of hits for certain objects",
// "For a wiki page, the page name, for other object types: ID number + ? + object title" => "For a wiki page, the page name, for other object types: ID number + ? + object title",
// "Object type, such as wiki, file gallery, file, article, etc. Default is \"wiki\"" => "Object type, such as wiki, file gallery, file, article, etc. Default is \"wiki\"",
// "Show the number of hits over the past number of days indicated. Default is to show all hits" => "Show the number of hits over the past number of days indicated. Default is to show all hits",
// "Page Tabs" => "Page Tabs",
// "PluginPageTabs" => "PluginPageTabs",
// "Display page content in a set of tabs" => "Display page content in a set of tabs",
// "Wiki page names" => "Wiki page names",
// "The wiki pages you would like to use in this plugin, optional, separate with pipe \"|\".  Or a table with the class of \"pagetabs\" on the main page. On child pages use as a way to redirect to the parent" => "The wiki pages you would like to use in this plugin, optional, separate with pipe \"|\".  Or a table with the class of \"pagetabs\" on the main page. On child pages use as a way to redirect to the parent",
// "Param" => "Param",
// "Display content based on URL parameters" => "Display content based on URL parameters",
// "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed if conditions are not met" => "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed if conditions are not met",
// "Names of parameter required to display text" => "Names of parameter required to display text",
// "Source where the parameter is checked. Possible values : request .." => "Source where the parameter is checked. Possible values : request ..",
// "Show details of a payment request or invoice" => "Show details of a payment request or invoice",
// "Payment Request Number" => "Payment Request Number",
// "Unique identifier of the payment request" => "Unique identifier of the payment request",
// "Display content based on permission settings" => "Display content based on permission settings",
// "Possible Permissions" => "Possible Permissions",
// "Pipe separated list of permissions, one of which is needed to view the default text" => "Pipe separated list of permissions, one of which is needed to view the default text",
// "Forbidden Permissions" => "Forbidden Permissions",
// "Pipe separated list of permissions, any of which will cause the default text not to show" => "Pipe separated list of permissions, any of which will cause the default text not to show",
// "Display content based on the reader's current perspective" => "Display content based on the reader's current perspective",
"Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the condition" => "Text Wiki a mostrar si es compleixen les condicions. El cos pot contenir {ELSE}. El text de després del marcador serà mostrat als usuaris que no compleixin la condició",
// "Allowed Perspectives" => "Allowed Perspectives",
// "Pipe-separated list of identifiers of perspectives in which the block is shown" => "Pipe-separated list of identifiers of perspectives in which the block is shown",
// "Denied Perspectives" => "Denied Perspectives",
// "Pipe-separated list of identifiers of perspectives in which the block is not shown" => "Pipe-separated list of identifiers of perspectives in which the block is not shown",
// "The module or plugin parameter must be set, but not both" => "The module or plugin parameter must be set, but not both",
// "Plugin Manager error: %0%1 not found" => "Plugin Manager error: %0%1 not found",
// "Plugin Manager error: %0%1%2%3%4 not found" => "Plugin Manager error: %0%1%2%3%4 not found",
// "Plugin Manager error:  %0%1 not found" => "Plugin Manager error:  %0%1 not found",
"Options" => "Opcions",
// "Introduced in Tiki version %0" => "Introduced in Tiki version %0",
// "Accepted Values" => "Accepted Values",
// "(body of plugin)" => "(body of plugin)",
// "(blank)" => "(blank)",
// "any string except for HTML and PHP tags" => "any string except for HTML and PHP tags",
// "Since" => "Since",
// "no parameters" => "no parameters",
// "Preferences required" => "Preferences required",
// "Required parameters are in%0 %1bold%2" => "Required parameters are in%0 %1bold%2",
// "Plugin Manager" => "Plugin Manager",
// "List wiki plugin or module information for the site" => "List wiki plugin or module information for the site",
"Information" => "Informació",
// "Determines what information is shown. Values separated with | . Ignored when singletitle is set to top or none" => "Determines what information is shown. Values separated with | . Ignored when singletitle is set to top or none",
// "One or more of: description | parameters | paraminfo" => "One or more of: description | parameters | paraminfo",
// "Description & Parameters" => "Description & Parameters",
// "Description & Parameter Info" => "Description & Parameter Info",
// "Parameters & Parameter Info" => "Parameters & Parameter Info",
// "Name of a plugin (e.g., backlinks), or list separated by |, or range separated by \"-\". Single plugin can be used with limit parameter" => "Name of a plugin (e.g., backlinks), or list separated by |, or range separated by \"-\". Single plugin can be used with limit parameter",
// "Name of a module (e.g., calendar_new), or list separated by |, or range separated by \"-\". Single module can be used with limit parameter" => "Name of a module (e.g., calendar_new), or list separated by |, or range separated by \"-\". Single module can be used with limit parameter",
// "Single Title" => "Single Title",
// "Set placement of plugin name and description when displaying information for only one plugin" => "Set placement of plugin name and description when displaying information for only one plugin",
// "Title Heading" => "Title Heading",
// "Sets the heading size for the title, e.g., h2" => "Sets the heading size for the title, e.g., h2",
// "Start with this plugin record number (must be an integer 1 or greater)" => "Start with this plugin record number (must be an integer 1 or greater)",
// "Number of plugins to show. Can be used either with start or plugin as the starting point. Must be an integer 1 or greater" => "Number of plugins to show. Can be used either with start or plugin as the starting point. Must be an integer 1 or greater",
"Poll" => "Consulta",
// "Display a poll" => "Display a poll",
// "Numeric value representing the poll ID" => "Numeric value representing the poll ID",
// "Show poll title (shown by default)" => "Show poll title (shown by default)",
// "Show result" => "Show result",
// "Show total votes" => "Show total votes",
// "Pretty Tracker View Tracking" => "Pretty Tracker View Tracking",
// "PluginPrettyTrackerViews" => "PluginPrettyTrackerViews",
// "Stores tiki.tracker.pretty.views attribute for trackeritem" => "Stores tiki.tracker.pretty.views attribute for trackeritem",
// "Record" => "Record",
// "set to y to record view each time this is loaded" => "set to y to record view each time this is loaded",
// "set to n to hide showing of attribute" => "set to n to hide showing of attribute",
// "Set to ID of tracker item" => "Set to ID of tracker item",
// "Profile Application" => "Profile Application",
// "Add a button for applying a profile" => "Add a button for applying a profile",
// "Profile repository domain. Default value is profiles.tiki.org" => "Profile repository domain. Default value is profiles.tiki.org",
// "Profile Name" => "Profile Name",
// "Name of the profile to be applied" => "Name of the profile to be applied",
// "Profile plugin only available to administrators" => "Profile plugin only available to administrators",
// "Profile %0/%1 not found" => "Profile %0/%1 not found",
"Proposal" => "Proposta",
// "Allow users to vote on a proposal and view the results" => "Allow users to vote on a proposal and view the results",
"The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username" => "La llista de vots emesos. Un vot per línia. Ó bé 0, +1 ó -1 seguits per un nom d'usuari",
"Short description of the proposal to vote on. Will be displayed above the result table" => "Breu descripció de la proposta sobre la que es vol votar. Es mostrarà a sobre de la taula de resultats",
"Accept proposal" => "Accepta la proposta",
"Still undecided" => "Indecís encara",
"Reject proposal" => "Rebutja la proposta",
// "Quote" => "Quote",
// "Format text as a quote" => "Format text as a quote",
// "Quoted text" => "Quoted text",
// "Reply To" => "Reply To",
// "Name of the quoted person" => "Name of the quoted person",
"wrote:" => "va escriure:",
"Quote:" => "Cita:",
// "Random Include" => "Random Include",
// "Include a random page's content" => "Include a random page's content",
// "Random Dynamic Content" => "Random Dynamic Content",
// "Display pre-programmed changing content" => "Display pre-programmed changing content",
// "Numeric value representing the content ID" => "Numeric value representing the content ID",
// "User List with Real Names" => "User List with Real Names",
// "Show user real names for members of a group" => "Show user real names for members of a group",
// " (experimental, should be merged with UserList)" => " (experimental, should be merged with UserList)",
// "Group name - only users belonging to a group or groups with group names containing this text will be included in the list. If empty all site users will be included" => "Group name - only users belonging to a group or groups with group names containing this text will be included in the list. If empty all site users will be included",
// "String to use between elements of the list if table layout is not used" => "String to use between elements of the list if table layout is not used",
// "Result limit" => "Result limit",
// "Set to sort in ascending or descending order (unsorted by default" => "Set to sort in ascending or descending order (unsorted by default",
// "Layout" => "Layout",
// "Set to table to show results in a table (not shown in a table by default)" => "Set to table to show results in a table (not shown in a table by default)",
// "Make the listed names links to various types of user information" => "Make the listed names links to various types of user information",
"User Information" => "Informació de l'usuari",
// "User Page" => "User Page",
"User Preferences" => "Preferències de l'usuari",
// "Exclude" => "Exclude",
// "Exclude certain test or admin names from the list" => "Exclude certain test or admin names from the list",
"admin" => "administrar",
// "admin-test" => "admin-test",
// "test" => "test",
// "test-admin" => "test-admin",
"Preferences" => "Preferències",
// "Redirect" => "Redirect",
// "Redirect to another page" => "Redirect to another page",
// "Wiki page name to redirect to" => "Wiki page name to redirect to",
// "Complete URL, internal or external" => "Complete URL, internal or external",
// "The ID of a perspective to switch to (requires feature_perspective)" => "The ID of a perspective to switch to (requires feature_perspective)",
// "perspective " => "perspective ",
// "nowhere" => "nowhere",
// "REDIRECT plugin: The redirection to '%s' is disabled just after saving the page" => "REDIRECT plugin: The redirection to '%s' is disabled just after saving the page",
// "REDIRECT plugin: The redirection to '%s' is disabled in preview mode. " => "REDIRECT plugin: The redirection to '%s' is disabled in preview mode. ",
// "REDIRECT plugin: redirect loop detected" => "REDIRECT plugin: redirect loop detected",
// "Regular Expression" => "Regular Expression",
// "Perform a regular expression search and replace" => "Perform a regular expression search and replace",
// "Each line of content is evaluated separately" => "Each line of content is evaluated separately",
// "Name of page containing search and replace expressions separated by two colons. Example of syntax on that page: /search pattern/::replacement text" => "Name of page containing search and replace expressions separated by two colons. Example of syntax on that page: /search pattern/::replacement text",
// "Register Member Payment" => "Register Member Payment",
// "Allows user to register and make member payment at the same time" => "Allows user to register and make member payment at the same time",
// "NA" => "NA",
// "Fixed Periods" => "Fixed Periods",
// "Give specific periods that can be chosen with a dropdown list.  Example - \"name:value;name:value;value;value;\"" => "Give specific periods that can be chosen with a dropdown list.  Example - \"name:value;name:value;value;value;\"",
// "Insufficient Privileges" => "Insufficient Privileges",
"Submit" => "Envia",
// "You will be redirected in 5 seconds" => "You will be redirected in 5 seconds",
// "Displays the relations between the current object or a specified one and the rest of Tiki" => "Displays the relations between the current object or a specified one and the rest of Tiki",
// "Qualifiers" => "Qualifiers",
// "Comma-separated list of relation qualifiers" => "Comma-separated list of relation qualifiers",
// "Object identifier as type:itemId" => "Object identifier as type:itemId",
// "Single List" => "Single List",
// "Render all qualifiers into a single list without displaying the qualifier name" => "Render all qualifiers into a single list without displaying the qualifier name",
// "Remarks Box" => "Remarks Box",
"Displays a comment, tip, note or warning box" => "Mostra un comentari, consell, nota o quadre d'avís",
"remarks text" => "text de comentaris",
// "Select type of remarksbox, which determines what icon and style will be displayed" => "Select type of remarksbox, which determines what icon and style will be displayed",
// "Confirm" => "Confirm",
"Errors" => "Error",
"Note" => "Nota",
"Warning" => "Avís",
// "Label displayed above the remark" => "Label displayed above the remark",
// "Use the highlight class for formatting (not used by default)" => "Use the highlight class for formatting (not used by default)",
// "Custom Icon" => "Custom Icon",
// "Enter a Tiki icon file name (with or without extension) or path to display a custom icon" => "Enter a Tiki icon file name (with or without extension) or path to display a custom icon",
"Close" => "Tanca",
// "Show a close button (not shown by default)" => "Show a close button (not shown by default)",
// "Width (e.g. 100% or 250px - default \"\")" => "Width (e.g. 100% or 250px - default \"\")",
"Report" => "Informe",
// "Build a report, and store it in a wiki page" => "Build a report, and store it in a wiki page",
// "The wiki syntax report settings" => "The wiki syntax report settings",
"Report View" => "Vista d'Informe",
"Report Plugin View" => "Vista de Connector (Plugin) d'Informe",
"Sheet" => "Full",
"Report Name" => "Nom de l'Informe",
"Report Plugin Name, sometimes used headings and reference" => "Nom del Plugin d'Informe, de vegades s'han emprat capçaleres i referència",
"Edit Report" => "Edita l'Informe",
// "RSS Feed" => "RSS Feed",
// "Display items from an RSS feed" => "Display items from an RSS feed",
// "IDs" => "IDs",
// "List of feed IDs separated by colons. ex: feedId:feedId2" => "List of feed IDs separated by colons. ex: feedId:feedId2",
// "Result Count" => "Result Count",
// "Number of results displayed" => "Number of results displayed",
// "Show date of each item (not shown by default)" => "Show date of each item (not shown by default)",
// "Show feed descriptions (not shown by default)" => "Show feed descriptions (not shown by default)",
// "Show authors (not shown by default)" => "Show authors (not shown by default)",
// "Url to a favicon to put before each entry" => "Url to a favicon to put before each entry",
// "Show the title of the feed (shown by default)" => "Show the title of the feed (shown by default)",
// "Scroll" => "Scroll",
// "Show animated text that scrolls up or down" => "Show animated text that scrolls up or down",
// "Width in pixels. Example: 600px" => "Width in pixels. Example: 600px",
// "Number of pixels followed by \"px\". Example: 600px" => "Number of pixels followed by \"px\". Example: 600px",
// "Height in pixels. Example: 450px" => "Height in pixels. Example: 450px",
// "Number of pixels followed by \"px\". Example: 450px" => "Number of pixels followed by \"px\". Example: 450px",
// "Scroll speed in number of seconds (default is 8 seconds)" => "Scroll speed in number of seconds (default is 8 seconds)",
// "SourceForge" => "SourceForge",
// "Creates a link to SourceForge tracker items" => "Creates a link to SourceForge tracker items",
// "Group ID" => "Group ID",
// "SourceForge project ID (shows as group_id in the URL of a tracker item" => "SourceForge project ID (shows as group_id in the URL of a tracker item",
// "SourceForge tracker ID (shows as atid in the URL of a tracker item" => "SourceForge tracker ID (shows as atid in the URL of a tracker item",
// "SourceForge item ID (shows as aid in the URL of a tracker item" => "SourceForge item ID (shows as aid in the URL of a tracker item",
// "First part of link tooltip identifying the type of tracker item (bug, feature request, patch or support request)" => "First part of link tooltip identifying the type of tracker item (bug, feature request, patch or support request)",
// "ShareThis" => "ShareThis",
// "Add a ShareThis button" => "Add a ShareThis button",
// "Send Services" => "Send Services",
// "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services" => "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services",
// "Aim" => "Aim",
// "Aim \$ Email" => "Aim \$ Email",
// "Aim \$ Sms" => "Aim \$ Sms",
// "Email \$ Sms" => "Email \$ Sms",
// "Button Style" => "Button Style",
// "Set button style: horizontal, vertical or rotate" => "Set button style: horizontal, vertical or rotate",
// "Rotate" => "Rotate",
// "Rotate Image" => "Rotate Image",
// "A value of y (Yes) will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping" => "A value of y (Yes) will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping",
// "Multiple Icons" => "Multiple Icons",
// "Enter list: email | facebook | twitter | sharethis, depending on which icons you'd like" => "Enter list: email | facebook | twitter | sharethis, depending on which icons you'd like",
// "First Services Shown" => "First Services Shown",
// "Input a list of post services (like Facebook, Myspace, Digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget" => "Input a list of post services (like Facebook, Myspace, Digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget",
// "Button Text" => "Button Text",
// "Custom link text for the button" => "Custom link text for the button",
// "Header Title" => "Header Title",
// "Optional header title text for the widget" => "Optional header title text for the widget",
// "Header Background" => "Header Background",
// "HTML color code (not color name) for the background color for the header if an optional header title is used" => "HTML color code (not color name) for the background color for the header if an optional header title is used",
// "Header Text Color" => "Header Text Color",
// "HTML color code (not color name) for the header text if an optional header title is used" => "HTML color code (not color name) for the header text if an optional header title is used",
// "Link text color for services" => "Link text color for services",
// "HTML color code (not color name) for the link text for all send and post services shown in the widget" => "HTML color code (not color name) for the link text for all send and post services shown in the widget",
"Pop-up" => "Finestra emergent",
// "A value of true will cause the widget to show in a pop-up window" => "A value of true will cause the widget to show in a pop-up window",
// "Embedded Elements" => "Embedded Elements",
// "A value of true will allow embedded elements (like flash) to be seen while iframe is loading" => "A value of true will allow embedded elements (like flash) to be seen while iframe is loading",
// "Display data from a TikiSheet" => "Display data from a TikiSheet",
"Sheet Heading" => "Capçalera del full",
// "Internal ID of the TikiSheet.  Either id or url MUST be used" => "Internal ID of the TikiSheet.  Either id or url MUST be used",
// "Sheet Url Location" => "Sheet Url Location",
// "Internal URL of the Table to use as a spreadsheet.  Either id or url MUST be used" => "Internal URL of the Table to use as a spreadsheet.  Either id or url MUST be used",
// "Simple table view y/n (Default: n = jquery.sheet view if feature enabled)" => "Simple table view y/n (Default: n = jquery.sheet view if feature enabled)",
// "Height in pixels or percentage. Default value is complete spreadsheet height" => "Height in pixels or percentage. Default value is complete spreadsheet height",
// "Editable" => "Editable",
// "Show edit button. Default 'y' depending on user's permissions" => "Show edit button. Default 'y' depending on user's permissions",
// "Show subsheets" => "Show subsheets",
// "y/n. Show multi-sheets. Default 'y'" => "y/n. Show multi-sheets. Default 'y'",
// "Range" => "Range",
// "Show a range of cells (or single cell). Default shows all. e.g. \"D1:F3\" or \"e14:e14\"" => "Show a range of cells (or single cell). Default shows all. e.g. \"D1:F3\" or \"e14:e14\"",
// "Apply custom CSS class to the containing div" => "Apply custom CSS class to the containing div",
// "New sheet in page: " => "New sheet in page: ",
"Create New Sheet" => "Crea un nou full",
// "Error loading spreadsheet" => "Error loading spreadsheet",
"Edit Sheet" => "Edita Full",
// "Collect Anonymous Shopper Info" => "Collect Anonymous Shopper Info",
// "PluginShopperinfo" => "PluginShopperinfo",
// "Collect Anonymous Shopper Info for Shopping Cart" => "Collect Anonymous Shopper Info for Shopping Cart",
// "Values to be collected" => "Values to be collected",
// "Names of values to be collected separated by : as defined in shopper profile" => "Names of values to be collected separated by : as defined in shopper profile",
// "Labels for the values to be collected" => "Labels for the values to be collected",
// "Labels of the values to be collected separated by " => "Labels of the values to be collected separated by ",
// "Show even if logged in" => "Show even if logged in",
// "Normally this is used for anonymous users but sometimes may be used when logged in also" => "Normally this is used for anonymous users but sometimes may be used when logged in also",
// "Show Pages" => "Show Pages",
// "Find pages by searching within page names" => "Find pages by searching within page names",
// "Search criteria" => "Search criteria",
// "Maximum amount of results displayed" => "Maximum amount of results displayed",
// "Display page name and/or description. Both displayed by default" => "Display page name and/or description. Both displayed by default",
// "Name & Description" => "Name & Description",
// "Skype" => "Skype",
"Clickable Skype link" => "Enllaç clicable de Skype",
// "Name or number to call or chat with" => "Name or number to call or chat with",
// "Set whether to call or chat. Default is chat" => "Set whether to call or chat. Default is chat",
// "Call" => "Call",
"Chat" => "Xat",
"Show status" => "Mostra l'estat",
// "Show a status icon or not i.e. if online/offline/etc. Default is no" => "Show a status icon or not i.e. if online/offline/etc. Default is no",
"yes" => "si",
"no" => "no",
// "do not forget to check the tools / options/ privacy / allow my status to be show on the web" => "do not forget to check the tools / options/ privacy / allow my status to be show on the web",
// "click to" => "click to",
// "Slider" => "Slider",
// "Arrange content in a sliding area" => "Arrange content in a sliding area",
// "Content separated by /////" => "Content separated by /////",
// "Slider Titles" => "Slider Titles",
// "Pipe separated list of slider titles. Ex: slider 1|slider 2|slider 3" => "Pipe separated list of slider titles. Ex: slider 1|slider 2|slider 3",
// "Height in pixels or percentage. Default value is complete slider height" => "Height in pixels or percentage. Default value is complete slider height",
// "The theme to use in slider" => "The theme to use in slider",
// "Expand" => "Expand",
// "if y, the entire slider will expand to fit the parent element" => "if y, the entire slider will expand to fit the parent element",
// "Resize Contents" => "Resize Contents",
// "if y, solitary images/objects in the panel will expand to fit the viewport" => "if y, solitary images/objects in the panel will expand to fit the viewport",
// "Show Multiple" => "Show Multiple",
// "Set this value to a number and it will show that many slides at once" => "Set this value to a number and it will show that many slides at once",
// "Build Arrows" => "Build Arrows",
// "if y, builds the forwards and backwards buttons" => "if y, builds the forwards and backwards buttons",
// "Build Navigation" => "Build Navigation",
// "if y, builds a list of anchor links to link to each panel" => "if y, builds a list of anchor links to link to each panel",
// "Build Start Stop" => "Build Start Stop",
// "if y, builds the start/stop button and adds slideshow functionality" => "if y, builds the start/stop button and adds slideshow functionality",
// "Toggle Arrows" => "Toggle Arrows",
// "if y, side navigation arrows will slide out on hovering & hide @ other times" => "if y, side navigation arrows will slide out on hovering & hide @ other times",
// "Toggle Controls" => "Toggle Controls",
// "if y, slide in controls (navigation + play/stop button) on hover and slide change, hide @ other times" => "if y, slide in controls (navigation + play/stop button) on hover and slide change, hide @ other times",
// "Enable Arrows" => "Enable Arrows",
// "if n, arrows will be visible, but not clickable" => "if n, arrows will be visible, but not clickable",
// "Enable Navigation" => "Enable Navigation",
// "if n, navigation links will still be visible, but not clickable" => "if n, navigation links will still be visible, but not clickable",
// "Enable Start Stop" => "Enable Start Stop",
// "if n, the play/stop button will still be visible, but not clickable. Previously \"enablePlay\"" => "if n, the play/stop button will still be visible, but not clickable. Previously \"enablePlay\"",
// "Enable Keyboard" => "Enable Keyboard",
// "if n, keyboard arrow keys will not work for this slider" => "if n, keyboard arrow keys will not work for this slider",
// "Auto Play" => "Auto Play",
// "if y, the slideshow will start running; replaces \"startStopped\" option" => "if y, the slideshow will start running; replaces \"startStopped\" option",
// "Auto Play Locked" => "Auto Play Locked",
// "if y, user changing slides will not stop the slideshow" => "if y, user changing slides will not stop the slideshow",
// "Auto Play Delayed" => "Auto Play Delayed",
// "if y, starting a slideshow will delay advancing slides; if n, the slider will immediately advance to the next slide when slideshow starts" => "if y, starting a slideshow will delay advancing slides; if n, the slider will immediately advance to the next slide when slideshow starts",
// "Pause On Hover" => "Pause On Hover",
// "if y & the slideshow is active, the slideshow will pause on hover" => "if y & the slideshow is active, the slideshow will pause on hover",
// "Stop At End" => "Stop At End",
// "if y & the slideshow is active, the slideshow will stop on the last page. This also stops the rewind effect when infiniteSlides is false" => "if y & the slideshow is active, the slideshow will stop on the last page. This also stops the rewind effect when infiniteSlides is false",
// "Play Right To Left" => "Play Right To Left",
// "if y, the slideshow will move right-to-left" => "if y, the slideshow will move right-to-left",
// "Resume On Video End" => "Resume On Video End",
// "if y & the slideshow is active & a supported video is playing, it will pause the autoplay until the video is complete" => "if y & the slideshow is active & a supported video is playing, it will pause the autoplay until the video is complete",
// "Configure a slideshow. Extends the existing wiki page slideshow with notes & styles" => "Configure a slideshow. Extends the existing wiki page slideshow with notes & styles",
// "Slideshow notes - Separate with \"/////\"" => "Slideshow notes - Separate with \"/////\"",
// "The theme you want to use for the slideshow, default will be what you choose from the admin panel under Look and Feel for jQuery UI" => "The theme you want to use for the slideshow, default will be what you choose from the admin panel under Look and Feel for jQuery UI",
// "Tiki jQuery UI Theme" => "Tiki jQuery UI Theme",
// "Background Url Location" => "Background Url Location",
// "URL of the background image to use in your slideshow, overrides backgroundcolor" => "URL of the background image to use in your slideshow, overrides backgroundcolor",
// "Valid url" => "Valid url",
// "Background color to use in your slideshow, default " => "Background color to use in your slideshow, default ",
// "Any valid CSS class" => "Any valid CSS class",
// "Header font color" => "Header font color",
// "Apply a color to the headers of your slideshow" => "Apply a color to the headers of your slideshow",
// "Any HTML color" => "Any HTML color",
// "Header background color" => "Header background color",
// "Slide font color" => "Slide font color",
// "Apply a color to the slides of your slideshow" => "Apply a color to the slides of your slideshow",
// "Line Item highlight color" => "Line Item highlight color",
// "Apply a color to the line item when mouse over" => "Apply a color to the line item when mouse over",
// "Slide Seconds" => "Slide Seconds",
// "How many seconds a slide will be open while playing, overridden when slideduration is set" => "How many seconds a slide will be open while playing, overridden when slideduration is set",
// "Second count" => "Second count",
// "Slide Milliseconds" => "Slide Milliseconds",
// "How many milliseconds a slide will be open while playing" => "How many milliseconds a slide will be open while playing",
// "Text Side" => "Text Side",
// "The side on which you would like to display text if there are images that are resized or present" => "The side on which you would like to display text if there are images that are resized or present",
// "Smarty function" => "Smarty function",
// "Insert a Smarty function" => "Insert a Smarty function",
// "The name of the Smarty function that the button will activate. Available functions are: lib/smarty/libs/plugins/function.[name].php" => "The name of the Smarty function that the button will activate. Available functions are: lib/smarty/libs/plugins/function.[name].php",
// "Snarf" => "Snarf",
// "Display the contents of another web page" => "Display the contents of another web page",
// "Full URL to the page to include" => "Full URL to the page to include",
// "Regular Expression Pattern" => "Regular Expression Pattern",
// "PCRE-compliant regular expression pattern to find the parts you want changed" => "PCRE-compliant regular expression pattern to find the parts you want changed",
// "Regular Expression Replacement" => "Regular Expression Replacement",
// "PCRE-compliant regular expression replacement syntax showing what the content should be changed to" => "PCRE-compliant regular expression replacement syntax showing what the content should be changed to",
// "Enable/disable word wrapping of snippets of code (enabled by default)" => "Enable/disable word wrapping of snippets of code (enabled by default)",
// "Syntax highlighting to use for code snippets. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, .." => "Syntax highlighting to use for code snippets. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, ..",
// "Set to 1 (Yes) to add line numbers to code snippets (not shown by default)" => "Set to 1 (Yes) to add line numbers to code snippets (not shown by default)",
// "Parse wiki syntax within the code snippet (not parsed by default)" => "Parse wiki syntax within the code snippet (not parsed by default)",
// "Switch the text display from left to right to right to left" => "Switch the text display from left to right to right to left",
// "HTML Content" => "HTML Content",
// "Set to 1 (Yes) to display the content as is instead of escaping HTML special chars (not set by default)" => "Set to 1 (Yes) to display the content as is instead of escaping HTML special chars (not set by default)",
// "Cache Url" => "Cache Url",
// "Cache time in minutes. Default is to use site preference, Set to 0 for no cache" => "Cache time in minutes. Default is to use site preference, Set to 0 for no cache",
// "Text to click on to fetch the url via ajax" => "Text to click on to fetch the url via ajax",
// "Sort lines of text" => "Sort lines of text",
// "Data to sort, one entry per line" => "Data to sort, one entry per line",
"Order" => "Ordre",
// "Set the sort order of lines of content (default is ascending)" => "Set the sort order of lines of content (default is ascending)",
// "Reverse" => "Reverse",
// "Shuffle" => "Shuffle",
// "Easily arrange content on a page into rows and columns" => "Easily arrange content on a page into rows and columns",
// "Join Columns" => "Join Columns",
// "Generate the colspan attribute if columns are missing" => "Generate the colspan attribute if columns are missing",
// "Fixed Size" => "Fixed Size",
// "Generate the width attribute for the columns" => "Generate the width attribute for the columns",
// "Column Sizes" => "Column Sizes",
// "Specify all column widths in number of pixels or percent, separating each width by a pipe (|)" => "Specify all column widths in number of pixels or percent, separating each width by a pipe (|)",
"First" => "Primer",
// "Cells specified are ordered first left to right across rows (default) or top to bottom down columns" => "Cells specified are ordered first left to right across rows (default) or top to bottom down columns",
"Column" => "Columna",
// "Line" => "Line",
// "Display edit icon for each section" => "Display edit icon for each section",
// "Custom Class" => "Custom Class",
// "Add a class to customize the design" => "Add a class to customize the design",
// "SQL" => "SQL",
// "Query a MySQL database and display the results" => "Query a MySQL database and display the results",
// "The SQL query goes in the body. Example: SELECT column1, column2 FROM table" => "The SQL query goes in the body. Example: SELECT column1, column2 FROM table",
// "DSN Name" => "DSN Name",
// "DSN name of the database being queried. The DSN name needs to first be defined at tiki-admin_dsn.php" => "DSN name of the database being queried. The DSN name needs to first be defined at tiki-admin_dsn.php",
"Missing db param" => "Falta paràmetre de la bd",
// "Could not obtain valid DSN connection" => "Could not obtain valid DSN connection",
// "Stat" => "Stat",
// "Show various statistics for an object" => "Show various statistics for an object",
// "Object type to show stats for. Choices are article, trackeritem or wiki, or a combination of these separated by colons" => "Object type to show stats for. Choices are article, trackeritem or wiki, or a combination of these separated by colons",
// "Article & Tracker Item" => "Article & Tracker Item",
// "Article & Tracker Item & Wiki" => "Article & Tracker Item & Wiki",
// "Article & Wiki" => "Article & Wiki",
// "Article & Wiki & Tracker Item" => "Article & Wiki & Tracker Item",
// "Tracker Item" => "Tracker Item",
// "Tracker Item & Article" => "Tracker Item & Article",
// "Tracker Item & Article & Wiki" => "Tracker Item & Article & Wiki",
// "Tracker Item & Wiki" => "Tracker Item & Wiki",
// "Tracker Item & Wiki & Article" => "Tracker Item & Wiki & Article",
// "Wiki & Article" => "Wiki & Article",
// "Wiki & Article & Tracker Item" => "Wiki & Article & Tracker Item",
// "Wiki & Tracker Item" => "Wiki & Tracker Item",
// "Wiki & Tracker Item & Article" => "Wiki & Tracker Item & Article",
// "Parent ID" => "Parent ID",
// "Enter a tracker ID to restrict stats to that tracker (for use with trackeritems only)" => "Enter a tracker ID to restrict stats to that tracker (for use with trackeritems only)",
// "Last 24 Hours" => "Last 24 Hours",
// "Added and/or viewed in the last 24 hours (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed in the last 24 hours (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
"Added" => "Afegit",
// "Added and Viewed" => "Added and Viewed",
"Viewed" => "Visualitzat",
// "Viewed & Added" => "Viewed & Added",
"Today" => "Avui",
// "Added and/or viewed since the beginning of the day (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the day (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Last 7 Days" => "Last 7 Days",
// "Added and/or viewed in the last 7 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed in the last 7 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "This Week" => "This Week",
// "Added and/or viewed since the beginning of the week (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the week (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Last Month" => "Last Month",
// "Added and/or viewed last month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed last month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "This Month" => "This Month",
// "Added and/or viewed since the beginning of the month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Last Year" => "Last Year",
// "Added and/or viewed in the last 365 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed in the last 365 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "This Year" => "This Year",
// "Added and/or viewed since the beginning of the year (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the year (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Incorrect parameter: " => "Incorrect parameter: ",
// "Subscript" => "Subscript",
// "Apply subscript font to text" => "Apply subscript font to text",
// "Subscribe Group" => "Subscribe Group",
// "Allow users to subscribe to a group" => "Allow users to subscribe to a group",
// "text displayed before the button" => "text displayed before the button",
// "Group name to subscribe to or unsubscribe from" => "Group name to subscribe to or unsubscribe from",
"Subscribe Text" => "Text per a la subscripció",
"Subscribe text, containing %s as the placeholder for the group name" => "Text per a la subscripció, contenint %s com a indicador d'on es col·locarà el nom del grup",
"Subscribe" => "Subscriu",
"Unsubscribe Text" => "Text per a desubscriure's",
"Unsubscribe text, containing %s as the placeholder for the group name" => "Text per a desubscriure's,contenint %s com a indicador d'on es col·locarà el nom del grup",
"Unsubscribe" => "De-subscriu-me",
"Subscribe Action" => "Acció de Subscriure's",
"Subscribe button label, containing %s as the placeholder for the group name" => "Etiqueta del botó de subscripció, contenint %s com a indicador d'on es col·locarà el nom del grup",
"Unsubscribe Action" => "Acció de de-subscriure's",
"Unsubscribe button label, containing %s as the placeholder for the group name" => "Etiqueta del botó de de-subscripció, contenint %s com a indicador d'on es col·locarà el nom del grup",
// "Postsubscribe URL" => "Postsubscribe URL",
// "URL to send the user to after subscribing, if required" => "URL to send the user to after subscribing, if required",
// "Postunsubscribe URL" => "Postunsubscribe URL",
// "URL to send the user to after unsubscribing, if required" => "URL to send the user to after unsubscribing, if required",
// "Make this the default group text, containing %s as the placeholder for the group name." => "Make this the default group text, containing %s as the placeholder for the group name.",
// "Not Default Group" => "Not Default Group",
// "Stop this being default group text, containing %s as the placeholder for the group name." => "Stop this being default group text, containing %s as the placeholder for the group name.",
// "Default Group Action" => "Default Group Action",
// "Default group button label. Will subscribe to the group first if not already a member" => "Default group button label. Will subscribe to the group first if not already a member",
// "Not Default Group Action" => "Not Default Group Action",
// "Stop this being default group button label. Does not unsubscribe from the group" => "Stop this being default group button label. Does not unsubscribe from the group",
// "Group To Set When Not Default" => "Group To Set When Not Default",
// "Group name to set as default when user stops this group being it" => "Group name to set as default when user stops this group being it",
// "Go To Default Group Home" => "Go To Default Group Home",
// "Redirect to new home page after default group change. (Default y)" => "Redirect to new home page after default group change. (Default y)",
"Subscribe Groups" => "Subscribe Groups",
// "Allow users to subscribe to a list of groups" => "Allow users to subscribe to a list of groups",
// "Text shown in the dropdown box. Default: \"Subscribe to a group\"" => "Text shown in the dropdown box. Default: \"Subscribe to a group\"",
// "Show Subscribe Box" => "Show Subscribe Box",
// "Show the subscribe box (shown by default). Will not show if there are no other groups the user may register for" => "Show the subscribe box (shown by default). Will not show if there are no other groups the user may register for",
// "Subscribe Box Style" => "Subscribe Box Style",
// "Style to show the subscribe box, either dropdown or table" => "Style to show the subscribe box, either dropdown or table",
// "Show Default" => "Show Default",
// "Shows which group is the user's default group (if any) and allows the user to change his default group" => "Shows which group is the user's default group (if any) and allows the user to change his default group",
// "Group Description" => "Group Description",
// "Show the description of the group (not shown by default)" => "Show the description of the group (not shown by default)",
// "Colon separated list of groups. By default the list of groups available to the user" => "Colon separated list of groups. By default the list of groups available to the user",
// "Only list groups that include the group being specified here" => "Only list groups that include the group being specified here",
// "Default URL" => "Default URL",
// "Page user will be directed to after clicking on icon to change default group" => "Page user will be directed to after clicking on icon to change default group",
// "Leader Group Name" => "Leader Group Name",
// "Name of group for leaders of the group, where \"groupName\" will be substituted by the group name" => "Name of group for leaders of the group, where \"groupName\" will be substituted by the group name",
// "Pending Users Group Name" => "Pending Users Group Name",
// "Name of group for users that are waiting for approval to enter the group, where \"groupName\" will be substituted by the group name" => "Name of group for users that are waiting for approval to enter the group, where \"groupName\" will be substituted by the group name",
// "Group Management Page Name" => "Group Management Page Name",
// "Name of wiki page for group management by leaders, where \"groupName\" will be substituted by the group name" => "Name of wiki page for group management by leaders, where \"groupName\" will be substituted by the group name",
// "Hide link for groups including" => "Hide link for groups including",
// "Hide link to group home page for groups that include the group being specified here" => "Hide link to group home page for groups that include the group being specified here",
// "Always allow leaving group" => "Always allow leaving group",
// "Always allow leaving group even if userChoice for group is set to n" => "Always allow leaving group even if userChoice for group is set to n",
// "You do not have permission to subscribe to groups" => "You do not have permission to subscribe to groups",
// "Subscribe newsletter" => "Subscribe newsletter",
// "Allow users to subscribe to a newsletter" => "Allow users to subscribe to a newsletter",
// "Invitation message" => "Invitation message",
// "Newsletter ID" => "Newsletter ID",
// "Identification number (nlId) of the Newsletter that you want to allow the users to subscribe to" => "Identification number (nlId) of the Newsletter that you want to allow the users to subscribe to",
// "Confirmation Message" => "Confirmation Message",
// "Confirmation message after posting form. The plugin body is then the button label" => "Confirmation message after posting form. The plugin body is then the button label",
// "Button label. The plugin body is then the confirmation message" => "Button label. The plugin body is then the confirmation message",
// "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)" => "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)",
// "Already subscribed" => "Already subscribed",
// "Superscript" => "Superscript",
// "Apply superscript font to text" => "Apply superscript font to text",
// "Display a survey" => "Display a survey",
// "Wiki Page to redirect the user after his vote" => "Wiki Page to redirect the user after his vote",
// "Arrange content in tabs" => "Arrange content in tabs",
// "Tabs content separated by /////" => "Tabs content separated by /////",
// "Tabset Name" => "Tabset Name",
// "Unique tabset name (if you want it to remember its last state). Ex: user_profile_tabs" => "Unique tabset name (if you want it to remember its last state). Ex: user_profile_tabs",
// "Tab Titles" => "Tab Titles",
// "Pipe separated list of tab titles. Ex: tab 1|tab 2|tab 3" => "Pipe separated list of tab titles. Ex: tab 1|tab 2|tab 3",
// "Toggle Tabs" => "Toggle Tabs",
// "Allows to toggle from tabs to no tabs view" => "Allows to toggle from tabs to no tabs view",
// "Inside Pretty Tracker" => "Inside Pretty Tracker",
// "Parse pretty tracker variables within tabs" => "Parse pretty tracker variables within tabs",
// "No tab title specified. At least one has to be set to make the tabs appear" => "No tab title specified. At least one has to be set to make the tabs appear",
// "Apply an HTML tag to content" => "Apply an HTML tag to content",
"Tag Name" => "Nom de marca",
// "Any valid HTML tag, span by default" => "Any valid HTML tag, span by default",
// "CSS Style" => "CSS Style",
// "Equivalent to the style attribute of an HTML tag" => "Equivalent to the style attribute of an HTML tag",
// "TextLink" => "TextLink",
// "Links your article to a site using forwardlink protocol" => "Links your article to a site using forwardlink protocol",
// "Text to link to forwardlink" => "Text to link to forwardlink",
// "ClipboardData" => "ClipboardData",
// "ForwardLinks To: " => "ForwardLinks To: ",
// "Timeline" => "Timeline",
// "Display a timeline" => "Display a timeline",
// "Display the eventlist items represented in the page. (all, center, or custom as a CSS selector)" => "Display the eventlist items represented in the page. (all, center, or custom as a CSS selector)",
// "Width of the timeline as CSS units (default: \"100%\")" => "Width of the timeline as CSS units (default: \"100%\")",
// "Height of the timeline as CSS units (default: \"400px\")" => "Height of the timeline as CSS units (default: \"400px\")",
// "Lower Bound" => "Lower Bound",
// "Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format",
// "Upper Bound" => "Upper Bound",
// "Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format",
// "Primary Scale Unit" => "Primary Scale Unit",
// "Unit of time to use for the primary scale (default to Month)" => "Unit of time to use for the primary scale (default to Month)",
// "Decade" => "Decade",
// "Century" => "Century",
// "Secondary Scale Unit" => "Secondary Scale Unit",
// "Unit of time to use for the secondary scale (default to empty)" => "Unit of time to use for the secondary scale (default to empty)",
"TimeSheet" => "Full de Temps",
// "A portable timesheet usable in a webpage" => "A portable timesheet usable in a webpage",
// "Title Search" => "Title Search",
// "Search pages by title" => "Search pages by title",
// "Search Criteria" => "Search Criteria",
// "Portion of a page name" => "Portion of a page name",
// "Also show page hits or user" => "Also show page hits or user",
// "Pipe-separated list of page names to exclude from results" => "Pipe-separated list of page names to exclude from results",
"No Header" => "Sense capçalera",
// "Set to 1 (Yes) to have no header for the search results" => "Set to 1 (Yes) to have no header for the search results",
"No pages found for title search" => "No s'ha trobat cap pàgina per la cerca de títols",
"One page found for title search" => "Una pàgina ha estat trobada a la cerca per al títol",
"pages found for title search" => "pàgines trobades pel títol de la cerca",
// "Table of Contents (Structure)" => "Table of Contents (Structure)",
// "Display a table of contents of pages or sub-pages" => "Display a table of contents of pages or sub-pages",
// "Maximum Depth" => "Maximum Depth",
// "Maximum number of levels to display. On very large structures, this should be limited. Zero means no limit (and is the default)" => "Maximum number of levels to display. On very large structures, this should be limited. Zero means no limit (and is the default)",
"Structure ID" => "ID de l'Estructura",
// "By default, structure for the current page will be displayed. Alternate structure may be provided" => "By default, structure for the current page will be displayed. Alternate structure may be provided",
// "Order items in ascending or descending order (default is ascending)" => "Order items in ascending or descending order (default is ascending)",
// "Show the page description instead of the page name" => "Show the page description instead of the page name",
// "Show Numbering" => "Show Numbering",
// "Display the section numbers or not" => "Display the section numbers or not",
// "Style to apply" => "Style to apply",
// "By default, the table of contents for the current page will be displayed. Alternate page may be provided" => "By default, the table of contents for the current page will be displayed. Alternate page may be provided",
// "Top Friends" => "Top Friends",
"List top-scoring users" => "Llista dels usuaris amb més punts",
// "Maximum result count" => "Maximum result count",
// "Set whether public or not" => "Set whether public or not",
"Translate" => "Tradueix",
// "Translate text to the user language" => "Translate text to the user language",
// "Create a form in a wiki page to populate a tracker" => "Create a form in a wiki page to populate a tracker",
// "Numeric value representing the tracker ID" => "Numeric value representing the tracker ID",
// "Colon-separated list of field IDs to be displayed. Example: 2:4:5  If empty, all fields will be shown" => "Colon-separated list of field IDs to be displayed. Example: 2:4:5  If empty, all fields will be shown",
// "Label on the submit button. Default is \"Save\"" => "Label on the submit button. Default is \"Save\"",
// "Display the title of the tracker (not shown by default)" => "Display the title of the tracker (not shown by default)",
// "Show the tracker's description (not shown by default)" => "Show the tracker's description (not shown by default)",
// "Mark Mandatory" => "Mark Mandatory",
// "Indicate mandatory fields with an asterisk (shown by default)" => "Indicate mandatory fields with an asterisk (shown by default)",
// "Show Status" => "Show Status",
// "Show the status of the items (not shown by default)" => "Show the status of the items (not shown by default)",
// "Embedded" => "Embedded",
// "To send an email once the tracker item has been created. Format: from" => "To send an email once the tracker item has been created. Format: from",
"to" => "a",
// "Email format" => "Email format",
// "Text or HTML setting" => "Text or HTML setting",
// "URL the user is sent to after the form is submitted" => "URL the user is sent to after the form is submitted",
// "URL Target" => "URL Target",
// "Set the target parameter for the url (determines whether target will open in a new page, etc.)" => "Set the target parameter for the url (determines whether target will open in a new page, etc.)",
"Parent" => "Pare",
// "Self" => "Self",
// "Values" => "Values",
// "Colon-separated list of default values for the fields. First value corresponds to first field, second value to second field, etc" => "Colon-separated list of default values for the fields. First value corresponds to first field, second value to second field, etc",
"Overwrite" => "Reescriure",
// "Overwrite current field values of the item with the input values" => "Overwrite current field values of the item with the input values",
// "Display columns in the order listed in the fields parameter instead of by field ID (field ID order is used by default" => "Display columns in the order listed in the fields parameter instead of by field ID (field ID order is used by default",
"Preview" => "Vista prèvia",
// "Label for the preview button. Default" => "Label for the preview button. Default",
// "Label for the reset button, to return all fields to their default values" => "Label for the reset button, to return all fields to their default values",
"reset" => "reiniciar",
// "Status of the item used in combination with" => "Status of the item used in combination with",
// "ItemId" => "ItemId",
// "ItemId allowing for editing an item" => "ItemId allowing for editing an item",
// "Ignore ItemId" => "Ignore ItemId",
// "Do not filter on the parameter itemId if in the url" => "Do not filter on the parameter itemId if in the url",
// "Template File" => "Template File",
// "Name of the template used to display the tracker items" => "Name of the template used to display the tracker items",
// "Name of the wiki page containing the template to display the tracker items" => "Name of the wiki page containing the template to display the tracker items",
// "New Status" => "New Status",
// "Default status applied to newly created items" => "Default status applied to newly created items",
// "Pending" => "Pending",
// "Specify the width in pixels or percentage of the first column (the labels) in the tracker form" => "Specify the width in pixels or percentage of the first column (the labels) in the tracker form",
// "Autosave fields" => "Autosave fields",
// "Colon-separated list of field IDs to be automatically filled with values" => "Colon-separated list of field IDs to be automatically filled with values",
// "Autosavevalue" => "Autosavevalue",
// "Colon-separated values corresponding to autosavefields" => "Colon-separated values corresponding to autosavefields",
// "Increase-only autosave fields" => "Increase-only autosave fields",
// "Colon-separated list of field IDs being autosaved whose value can only go up, not down" => "Colon-separated list of field IDs being autosaved whose value can only go up, not down",
// "Registration Fields" => "Registration Fields",
// "Add registration fields such as Username and Password" => "Add registration fields such as Username and Password",
// "Output To Wiki" => "Output To Wiki",
// "Output result to a new wiki page with the name taken from the input for the specified fieldId" => "Output result to a new wiki page with the name taken from the input for the specified fieldId",
// "Discard After Output" => "Discard After Output",
// "Used when results are output to a wiki page to discard the tracker item itself once the wiki page is created" => "Used when results are output to a wiki page to discard the tracker item itself once the wiki page is created",
// "Template Page" => "Template Page",
// "Name of the wiki page containing the template to format the output to wiki page" => "Name of the wiki page containing the template to format the output to wiki page",
// "Multiple Fill Fields" => "Multiple Fill Fields",
// "Colon-separated list of field IDs to be filled with multiple values, to create multiple items in one save. Example: 2:4:5  If empty, only one item will be created. Only for item creation" => "Colon-separated list of field IDs to be filled with multiple values, to create multiple items in one save. Example: 2:4:5  If empty, only one item will be created. Only for item creation",
// "Separator for Multiple Fill Fields" => "Separator for Multiple Fill Fields",
// "Choose separator between fields in each line of the Multiple Fill text area. Default is pipe (|)" => "Choose separator between fields in each line of the Multiple Fill text area. Default is pipe (|)",
// "Multiple Fill Fields defaults" => "Multiple Fill Fields defaults",
// "Colon-separated list of default values for Multiple Fill Fields" => "Colon-separated list of default values for Multiple Fill Fields",
// "Embed the tracker in a form tag" => "Embed the tracker in a form tag",
// "If set to Yes, the tracker is contained in a <form> tag and has action buttons" => "If set to Yes, the tracker is contained in a <form> tag and has action buttons",
// "The page to output the results to already exists. Try another name" => "The page to output the results to already exists. Try another name",
"Tracker was modified at " => "El formulari va ser modificat el ",
"Incorrect fieldId:" => "Identificador de camp incorrecte:",
"Following fields are incorrect" => "Els camps següents són incorrectes",
// "Each line is a list of %d field values separated with: %s" => "Each line is a list of %d field values separated with: %s",
// "Missing wiki template page \"%0\"" => "Missing wiki template page \"%0\"",
"You do not have permission to insert an item" => "No tens permís per insertar ítems",
// "Incorrect item" => "Incorrect item",
"You do not have permission to modify an item" => "No tens permisos per modificar un element",
// "The page to output the results to contains the following prohibited characters: %0. Try another name" => "The page to output the results to contains the following prohibited characters: %0. Try another name",
"Invalid email" => "Correu-e Invàlid",
"Passwords do not match" => "No coincideixen les dues contrasenyes",
"Insert one item per line" => "Insereix un ítem per línia",
"Fields marked with a * are mandatory." => "Els camps marcats amb un asterisc (*) són obligatoris.",
// "Tracker Comments" => "Tracker Comments",
// "Display the number of tracker comments" => "Display the number of tracker comments",
"Item Count" => "Recompte d'ítems",
// "Determines whether the number of items will be shown (not shown by default)" => "Determines whether the number of items will be shown (not shown by default)",
// "Enter a user name to select the items of the current user" => "Enter a user name to select the items of the current user",
// "a user name" => "a user name",
// "Comments found" => "Comments found",
"Filters" => "Filtres",
// "The list of fields that can be used as filters along with their formats. The field number and format are separated by a / and multile fields are separated by \":\". Format choices are: d - dropdown; r - radio buttons; m - multiple choice dropdown; c - checkbox; t - text with wild characters; T - exact text match; i - initials; sqlsearch - advanced search; >, <, >=, <= - greater than, less than, greater than or equal, less than or equal. Example" => "The list of fields that can be used as filters along with their formats. The field number and format are separated by a / and multile fields are separated by \":\". Format choices are: d - dropdown; r - radio buttons; m - multiple choice dropdown; c - checkbox; t - text with wild characters; T - exact text match; i - initials; sqlsearch - advanced search; >, <, >=, <= - greater than, less than, greater than or equal, less than or equal. Example",
// "Label on the submit button. Default: \"Filter\". Use a space character to omit the button (for use in datachannels etc)" => "Label on the submit button. Default: \"Filter\". Use a space character to omit the button (for use in datachannels etc)",
// "Display List" => "Display List",
// "Show the full list (before filtering) initially (filtered list shown by default)" => "Show the full list (before filtering) initially (filtered list shown by default)",
// "Displays all the filters on the same line (not shown on same line by default)" => "Displays all the filters on the same line (not shown on same line by default)",
// "Yes with field label in dropdown" => "Yes with field label in dropdown",
// "No Toggle" => "No Toggle",
// "The toggle button to show/hide filters will not be shown if set to y (Yes). Default is to show the toggle" => "The toggle button to show/hide filters will not be shown if set to y (Yes). Default is to show the toggle",
// "Export CSV" => "Export CSV",
// "Label for an export button. Leave blank to show the usual \"Filter\" button instead" => "Label for an export button. Leave blank to show the usual \"Filter\" button instead",
// "Google Map Buttons" => "Google Map Buttons",
// "Display Mapview and Listview buttons" => "Display Mapview and Listview buttons",
// "Tracker Filter" => "Tracker Filter",
// "Create a form to filter tracker fields" => "Create a form to filter tracker fields",
// "notice" => "notice",
"tracker field type not processed yet" => "algun tipus emprat de camp de formulari no ha estat processat encara",
// "Tracker If" => "Tracker If",
// "Display content based on results of a tracker field test" => "Display content based on results of a tracker field test",
// "Ignore" => "Ignore",
// "Ignore test in edit mode" => "Ignore test in edit mode",
// "Copy Tracker Item" => "Copy Tracker Item",
// "PluginTrackerItemCopy" => "PluginTrackerItemCopy",
// "Will not work with category or certain special fields, copies only data from specified fields" => "Will not work with category or certain special fields, copies only data from specified fields",
// "Tracker from which to copy item, joined tracker ids separated by " => "Tracker from which to copy item, joined tracker ids separated by ",
// "Fields links that are related to this tracker that you would like to join on, separated by " => "Fields links that are related to this tracker that you would like to join on, separated by ",
// "Field IDs to copy" => "Field IDs to copy",
// "Field IDs to copy old value of, separated by :, joined fields separated by |" => "Field IDs to copy old value of, separated by :, joined fields separated by |",
// "Field IDs to update values with" => "Field IDs to update values with",
// "Field IDs to update with new values specified, separated by :, joined fields separated by |" => "Field IDs to update with new values specified, separated by :, joined fields separated by |",
// "New Values" => "New Values",
// "New Values to replace for the field IDs specified, separated by :, joined fields separated by |, -randomstring- will generate random string; and f_xx to use value of field xx of itemId" => "New Values to replace for the field IDs specified, separated by :, joined fields separated by |, -randomstring- will generate random string; and f_xx to use value of field xx of itemId",
// "ID of item to make copy of, otherwise input is asked for" => "ID of item to make copy of, otherwise input is asked for",
// "Make this number of copies on load" => "Make this number of copies on load",
// "Set the number of copies to make on load of plugin automatically" => "Set the number of copies to make on load of plugin automatically",
// "Returns array non-interactively" => "Returns array non-interactively",
// "If y, returns array of new information instead of displaying results to screen, used in non-interactive mode" => "If y, returns array of new information instead of displaying results to screen, used in non-interactive mode",
// "Missing mandatory parameters" => "Missing mandatory parameters",
// "Number of update fields do not match new values" => "Number of update fields do not match new values",
// "Tracker Item Field" => "Tracker Item Field",
// "Display or test the value of a tracker item field" => "Display or test the value of a tracker item field",
// "Wiki text containing an {ELSE} marker" => "Wiki text containing an {ELSE} marker",
// "Numeric value representing the item ID. Default is the user tracker item for the current user" => "Numeric value representing the item ID. Default is the user tracker item for the current user",
// "Numeric value representing the field ID displayed or tested" => "Numeric value representing the field ID displayed or tested",
// "Colon separated list of field IDs. Default is all fields" => "Colon separated list of field IDs. Default is all fields",
// "Status of the tracker item" => "Status of the tracker item",
// "Open & Pending" => "Open & Pending",
// "Open & Closed" => "Open & Closed",
// "Pending & Closed" => "Pending & Closed",
// "Open, Pending & Closed" => "Open, Pending & Closed",
// "Set to 1 (Yes) to test whether a field is empty (if value parameter is empty) or has a value the same as the value parameter" => "Set to 1 (Yes) to test whether a field is empty (if value parameter is empty) or has a value the same as the value parameter",
// "Value to compare against" => "Value to compare against",
// "You are not allowed to view this item" => "You are not allowed to view this item",
// "You are not allowed to view this field" => "You are not allowed to view this field",
// "Tracker List" => "Tracker List",
// "List, filter and sort the items in a tracker" => "List, filter and sort the items in a tracker",
// "Colon-separated list of field IDs for the fields to be displayed. Example: 2:4:5" => "Colon-separated list of field IDs for the fields to be displayed. Example: 2:4:5",
// "Colon-separated list of fields which will display in a tooltip on mouse over. Example: 6:7" => "Colon-separated list of fields which will display in a tooltip on mouse over. Example: 6:7",
// "Sticky Popup" => "Sticky Popup",
// "Choose whether the tooltip will stay displayed on mouse out (does not stay open by default)" => "Choose whether the tooltip will stay displayed on mouse out (does not stay open by default)",
// "Show Links" => "Show Links",
// "Show links to each tracker item (not shown by default)" => "Show links to each tracker item (not shown by default)",
// "Show Item Count" => "Show Item Count",
// "Show the number of items found (not shown by default)" => "Show the number of items found (not shown by default)",
// "Show Initials" => "Show Initials",
// "Show an alphabetical index by first letter to assist in navigation (not shown by default)" => "Show an alphabetical index by first letter to assist in navigation (not shown by default)",
// "Creation date display is based on tracker settings unless overriden here" => "Creation date display is based on tracker settings unless overriden here",
// "Last Modification Date" => "Last Modification Date",
// "Last modification date display is based on tracker settings unless overriden here" => "Last modification date display is based on tracker settings unless overriden here",
// "Show Field Name" => "Show Field Name",
// "Use the field names as column titles (used by default)" => "Use the field names as column titles (used by default)",
// "Show Item Rank" => "Show Item Rank",
// "Show item ranks (not shown by default)" => "Show item ranks (not shown by default)",
// "Only show items matching certain status filters (only items with open status shown by default)" => "Only show items matching certain status filters (only items with open status shown by default)",
// "Sort rows in ascending or descending order based on field ID, date created or date last modified using these values: " => "Sort rows in ascending or descending order based on field ID, date created or date last modified using these values: ",
// "(replacing fieldId with the field ID number)" => "(replacing fieldId with the field ID number)",
// "Sort Choice" => "Sort Choice",
// "Add a dropdown of sorting choices. Example with two sorting choices: created_desc|Newest first: lastModif_desc|Last modified first" => "Add a dropdown of sorting choices. Example with two sorting choices: created_desc|Newest first: lastModif_desc|Last modified first",
// "Maximum number of items to display or -1 for all values. Defaults to max records preference, if set" => "Maximum number of items to display or -1 for all values. Defaults to max records preference, if set",
// "Offset of first item. Default is no offset" => "Offset of first item. Default is no offset",
// "Fix offset always (no pagination)" => "Fix offset always (no pagination)",
// "Fix offset to that specified, disallow pagination" => "Fix offset to that specified, disallow pagination",
// "Show Pagination" => "Show Pagination",
// "Determines whether pagination will be shown (shown by default)" => "Determines whether pagination will be shown (shown by default)",
// "Filter Field" => "Filter Field",
// "Colon separated list of fields to allow filtering on" => "Colon separated list of fields to allow filtering on",
// "Filter Value" => "Filter Value",
// "Filter value of the filterfield. For better performance, use exactvalue instead" => "Filter value of the filterfield. For better performance, use exactvalue instead",
// "Exact Value" => "Exact Value",
// "Exact value of the filter" => "Exact value of the filter",
// "Adds a checkbox on each line to be able to do an action" => "Adds a checkbox on each line to be able to do an action",
// "e.g. fieldId/postName/Title/Submit/ActionUrl/tpl/radio|dropdown" => "e.g. fieldId/postName/Title/Submit/ActionUrl/tpl/radio|dropdown",
// "goIfOne" => "goIfOne",
// "Go directly to tiki-view_tracker_item.php if only one item is found" => "Go directly to tiki-view_tracker_item.php if only one item is found",
"More" => "Més",
// "Show a 'more' button that links to tiki-view_tracker.php (not shown by default)" => "Show a 'more' button that links to tiki-view_tracker.php (not shown by default)",
// "More URL" => "More URL",
// "More link pointing to specified URL instead of default tracker item link" => "More link pointing to specified URL instead of default tracker item link",
// "Display only the items of the current user, the current page name or the current IP address" => "Display only the items of the current user, the current page name or the current IP address",
// "Use content of the tpl file as template to display the item" => "Use content of the tpl file as template to display the item",
// "Wiki Page" => "Wiki Page",
// "Use content of the wiki page as template to display the item. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins" => "Use content of the wiki page as template to display the item. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins",
// "Template file in a Wiki page" => "Template file in a Wiki page",
// "Use content of the wiki page as template to display the item but with as little parsing on the content as with a tpl on disk. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins" => "Use content of the wiki page as template to display the item but with as little parsing on the content as with a tpl on disk. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins",
"View User" => "Visualitza els de l'usuari/a",
"Will display the items of the specified user" => "Mostrarà els ítems de l'usuari/a especificat/da",
// "Item ID separated with " => "Item ID separated with ",
// "To restrict the list to these item IDs" => "To restrict the list to these item IDs",
// "Ignore the itemId url parameter when filtering list (not ignored by default)" => "Ignore the itemId url parameter when filtering list (not ignored by default)",
// "The link that will be on each main field" => "The link that will be on each main field",
// "Left Deliminator" => "Left Deliminator",
// "Smarty left delimiter for Latex generation" => "Smarty left delimiter for Latex generation",
// "Right Deliminator" => "Right Deliminator",
// "Smarty right delimiter for Latex generation" => "Smarty right delimiter for Latex generation",
// "List Mode" => "List Mode",
// "Set output format. Yes (y) displays tracker list view with truncated values (default); \n\t\t\t\t\t\t\t\tNo (n) displays in tracker item view; Comma Separated Values (csv) outputs without any HTML formatting" => "Set output format. Yes (y) displays tracker list view with truncated values (default); \n\t\t\t\t\t\t\t\tNo (n) displays in tracker item view; Comma Separated Values (csv) outputs without any HTML formatting",
// "Comma Separated Values" => "Comma Separated Values",
// "Export Button" => "Export Button",
// "Show an export button (not shown by default)" => "Show an export button (not shown by default)",
// "Compute" => "Compute",
// "Sum or average all the values of a field and displays it at the bottom of the table" => "Sum or average all the values of a field and displays it at the bottom of the table",
// "fieldId" => "fieldId",
// "Silent" => "Silent",
// "Show nothing if no items found (the table header and a 'No records found' message is shown by default)" => "Show nothing if no items found (the table header and a 'No records found' message is shown by default)",
// "Show Delete" => "Show Delete",
// "Show a delete option (not shown by default)" => "Show a delete option (not shown by default)",
// "Show Open Item" => "Show Open Item",
// "Show an open item  option (not shown by default)" => "Show an open item  option (not shown by default)",
// "Show Close Item" => "Show Close Item",
// "Show a close item option (not shown by default)" => "Show a close item option (not shown by default)",
// "Show Pending Item" => "Show Pending Item",
// "Show a pending item option (not shown by default)" => "Show a pending item option (not shown by default)",
// "Show Watch Button" => "Show Watch Button",
// "Show a watch button (not shown by default)" => "Show a watch button (not shown by default)",
// "Show Feed Button" => "Show Feed Button",
// "Show an RSS feed button (not shown by default)" => "Show an RSS feed button (not shown by default)",
// "Show Google Map" => "Show Google Map",
// "Show Google Map of results (not shown by default)" => "Show Google Map of results (not shown by default)",
// "Google Map Icon" => "Google Map Icon",
// "Url of default icon to use for markers on the map" => "Url of default icon to use for markers on the map",
// "Calendar Field IDs" => "Calendar Field IDs",
// "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds separated with : for start:end" => "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds separated with : for start:end",
// "Calendar View Mode" => "Calendar View Mode",
// "Calendar view type time span (default is month)" => "Calendar view type time span (default is month)",
// "Bimester" => "Bimester",
// "Trimester" => "Trimester",
// "Calendar Popup" => "Calendar Popup",
// "Calendar items will pop-up, overrides Sticky Popup if turned off. Set to y (Yes) by default" => "Calendar items will pop-up, overrides Sticky Popup if turned off. Set to y (Yes) by default",
// "Calendar item pop-ups will stay open if set to y (Yes). Set to n (No) by default" => "Calendar item pop-ups will stay open if set to y (Yes). Set to n (No) by default",
// "Beginning of Month" => "Beginning of Month",
// "Set whether calendar will begin at the beginning of the month (does by default)" => "Set whether calendar will begin at the beginning of the month (does by default)",
// "Show calendar navigation bar (shown by default)" => "Show calendar navigation bar (shown by default)",
// "Partial" => "Partial",
// "Calendar Title" => "Calendar Title",
// "Enter a title to display a calendar title (not set by default)" => "Enter a title to display a calendar title (not set by default)",
// "Calendar Delta" => "Calendar Delta",
// "Set the calendar delta that will be shown (not set by default)" => "Set the calendar delta that will be shown (not set by default)",
// "Plus Month" => "Plus Month",
// "Minus Month" => "Minus Month",
// "Plus Bimester" => "Plus Bimester",
// "Minus Bimester" => "Minus Bimester",
// "Display Spreadsheet" => "Display Spreadsheet",
// "Display tracker as a spreadsheet (not used by default)" => "Display tracker as a spreadsheet (not used by default)",
// "Force Compile" => "Force Compile",
// "Force Smarty to recompile the templates for each tracker item when using a wiki page as a template. Default=n (best performance)" => "Force Smarty to recompile the templates for each tracker item when using a wiki page as a template. Default=n (best performance)",
// "Numeric value to display only last tracker items created within a user defined time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how many of those units are to be considered to define the time frame. Use in conjunction with \"max=-1\" to list all items (by default \"max\" is set to 10)" => "Numeric value to display only last tracker items created within a user defined time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how many of those units are to be considered to define the time frame. Use in conjunction with \"max=-1\" to list all items (by default \"max\" is set to 10)",
// "Period type" => "Period type",
// "Time period after creation or after modification" => "Time period after creation or after modification",
// "Creation" => "Creation",
// "Modification" => "Modification",
"incorrect filterfield" => "camp de filtrat (filterfield) incorrecte",
"Error in tracker ID" => "Error a l'ID del formulari",
"No field indicated" => "No s'ha indicat cap camp",
// "Check Tracker Passcodes" => "Check Tracker Passcodes",
// "PluginTrackerpasscode" => "PluginTrackerpasscode",
// "Tracker Prefill" => "Tracker Prefill",
// "Create a button to prefill tracker fields" => "Create a button to prefill tracker fields",
// "Tracker Page Name" => "Tracker Page Name",
// "URL Parameters" => "URL Parameters",
// "Parameters to pass in the url, e.g. &my_parameter1=123&my_parameter2=q" => "Parameters to pass in the url, e.g. &my_parameter1=123&my_parameter2=q",
// "Field 1" => "Field 1",
// "Field ID for the first field" => "Field ID for the first field",
// "Value 1" => "Value 1",
// "Content that should be used to prefill the field" => "Content that should be used to prefill the field",
// "Field 2" => "Field 2",
// "Field ID for the second field" => "Field ID for the second field",
// "Value 2" => "Value 2",
// "Field 3" => "Field 3",
// "Field ID for the third field" => "Field ID for the third field",
// "Value 3" => "Value 3",
// "Field 4" => "Field 4",
// "Field ID for the fourth field" => "Field ID for the fourth field",
// "Value 4" => "Value 4",
// "Field 5" => "Field 5",
// "Field ID for the fifth field" => "Field ID for the fifth field",
// "Value 5" => "Value 5",
// "Field 6" => "Field 6",
// "Field ID for the sixth field" => "Field ID for the sixth field",
// "Value 6" => "Value 6",
// "Field 7" => "Field 7",
// "Field ID for the seventh field" => "Field ID for the seventh field",
// "Value 7" => "Value 7",
// "Field 8" => "Field 8",
// "Field ID for the eighth field" => "Field ID for the eighth field",
// "Value 8" => "Value 8",
// "Tracker Stats" => "Tracker Stats",
// "Display statistics about a tracker" => "Display statistics about a tracker",
// "Colon-separated list of field IDs to be displayed. Example: 2:4:5" => "Colon-separated list of field IDs to be displayed. Example: 2:4:5",
// "Show Count" => "Show Count",
// "Choose whether to show the count of votes each option received (shown by default)" => "Choose whether to show the count of votes each option received (shown by default)",
// "Choose whether to show the percentage of the vote each option received (not shown by default)" => "Choose whether to show the percentage of the vote each option received (not shown by default)",
// "Choose whether to show a bar representing the number of votes each option received (not shown by default)" => "Choose whether to show a bar representing the number of votes each option received (not shown by default)",
// "Only show items matching certain status filters" => "Only show items matching certain status filters",
// "Show Link" => "Show Link",
// "Show link to tiki-view_tracker" => "Show link to tiki-view_tracker",
// "Show last modification date of a tracker. Set to y to use site setting or use PHP\\s format (www.php.net/strftime)" => "Show last modification date of a tracker. Set to y to use site setting or use PHP\\s format (www.php.net/strftime)",
// "y to use the site setting for short date format. Otherwise, use PHP format (www.php.net/strftime), Example: \"%A %d of %B, %Y\"" => "y to use the site setting for short date format. Otherwise, use PHP format (www.php.net/strftime), Example: \"%A %d of %B, %Y\"",
// "invalid status" => "invalid status",
"incorrect fieldId" => "Identificador de camp incorrecte",
// "Tracker Timeline" => "Tracker Timeline",
// "Show a timeline view of a tracker" => "Show a timeline view of a tracker",
// "Title Field" => "Title Field",
// "Tracker Field ID containing the item title" => "Tracker Field ID containing the item title",
// "Summary Field" => "Summary Field",
// "Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused" => "Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused",
// "Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field" => "Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field",
// "Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field" => "Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field",
// "Element Group" => "Element Group",
// "Tracker Field ID containing the element's group. Elements of a same group are displayed on the same row" => "Tracker Field ID containing the element's group. Elements of a same group are displayed on the same row",
// "Unit of time to use for the primary scale (default to hour - * SIMILE only)" => "Unit of time to use for the primary scale (default to hour - * SIMILE only)",
// "Decade *" => "Decade *",
// "Century *" => "Century *",
// "Unit of time to use for the secondary scale (default to empty - * SIMILE only)" => "Unit of time to use for the secondary scale (default to empty - * SIMILE only)",
// "Timeline height" => "Timeline height",
// "Height of the timeline band as a CSS unit (default: 250px -  - * SIMILE only)" => "Height of the timeline band as a CSS unit (default: 250px -  - * SIMILE only)",
// "Lower band height" => "Lower band height",
// "Height of the lower timeline band as a percentage (default: 30 -  - * SIMILE only)" => "Height of the lower timeline band as a percentage (default: 30 -  - * SIMILE only)",
// "Link Group Name" => "Link Group Name",
// "Convert the group name to a link" => "Convert the group name to a link",
// "Page Link Field" => "Page Link Field",
// "Tracker Field ID containing the page name for item details" => "Tracker Field ID containing the page name for item details",
// "SIMILE Timeline" => "SIMILE Timeline",
// "Use the SIMILE Timeline Widget" => "Use the SIMILE Timeline Widget",
// "Image Field" => "Image Field",
// "Tracker Field ID containing in image" => "Tracker Field ID containing in image",
// "Missing parameter: %0" => "Missing parameter: %0",
// "Start date after end date" => "Start date after end date",
// "Tracker Toggle" => "Tracker Toggle",
// "Toggle element display on a field value" => "Toggle element display on a field value",
// "Numeric value representing the field ID tested" => "Numeric value representing the field ID tested",
// "Element visibility" => "Element visibility",
// "If y, is visible when the field has the value" => "If y, is visible when the field has the value",
// "Html ID of the element that is toggled" => "Html ID of the element that is toggled",
// "Use the field of specific item. The URL param itemId is used if this parameter is not set" => "Use the field of specific item. The URL param itemId is used if this parameter is not set",
// "Trade" => "Trade",
// "Send or receive payments from one member to another. (for cclite only so far, experimental)" => "Send or receive payments from one member to another. (for cclite only so far, experimental)",
// "Currency depends on the selected registry" => "Currency depends on the selected registry",
// "Registry to trade in. Default: site preference (or first in list when more than one)" => "Registry to trade in. Default: site preference (or first in list when more than one)",
// "Currency to trade in. Default: Cclite currency preference for registry set above" => "Currency to trade in. Default: Cclite currency preference for registry set above",
// "Other User" => "Other User",
// "Name of the user to recieve or send the payment" => "Name of the user to recieve or send the payment",
// "Leave empty to display an input box" => "Leave empty to display an input box",
// "Offered or wanted item" => "Offered or wanted item",
// "Offered" => "Offered",
// "Wanted" => "Wanted",
"Continue" => "Continúa",
// "Use %0 for the amount, %1 for currency, %2 for your user name, %3 for the other user" => "Use %0 for the amount, %1 for currency, %2 for your user name, %3 for the other user",
// "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user %2 from %3\" for wanted" => "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user %2 from %3\" for wanted",
"Please log in" => "Si us plau, Connecta't",
// " needs to validate their account" => " needs to validate their account",
// "Transclude" => "Transclude",
// "PluginTransclude" => "PluginTransclude",
// "Include the content of another page with certain changes" => "Include the content of another page with certain changes",
// "Name of the wiki page to use as a template for the values" => "Name of the wiki page to use as a template for the values",
// "Attempt to include a page that cannot be viewed" => "Attempt to include a page that cannot be viewed",
"Page not found" => "No s'ha trobat la pàgina",
// "Page named \"%0\" does not exist at this time" => "Page named \"%0\" does not exist at this time",
// "Translated" => "Translated",
// "Create multi-lingual links" => "Create multi-lingual links",
// "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)" => "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)",
// "Two letter language code of the language, ex: fr" => "Two letter language code of the language, ex: fr",
"Flag" => "Bandera",
// "Country name, ex: France" => "Country name, ex: France",
// "Twitter" => "Twitter",
// "Display the activity for a twitter account" => "Display the activity for a twitter account",
// "Account Name" => "Account Name",
// "Name of the twitter account" => "Name of the twitter account",
// "Shell Background Color" => "Shell Background Color",
// "Background color for the overall widget, i.e., header, footer and outside border. Default is red (color code #15a2b)" => "Background color for the overall widget, i.e., header, footer and outside border. Default is red (color code #15a2b)",
// "Valid HTML color codes (with beginning #) or names" => "Valid HTML color codes (with beginning #) or names",
// "Shell Text Color" => "Shell Text Color",
// "Text color for the widget header and footer. Default is white (color code #ffffff)" => "Text color for the widget header and footer. Default is white (color code #ffffff)",
// "Tweet Background Color" => "Tweet Background Color",
// "Background color for individual tweets. Default is white" => "Background color for individual tweets. Default is white",
// "Tweet Text Color" => "Tweet Text Color",
// "Text color for individual tweets. Default is black" => "Text color for individual tweets. Default is black",
// "Height of widget in pixels. Default is 300" => "Height of widget in pixels. Default is 300",
// "Width of widget in pixels or 'auto' to fit to width of page. Default is auto" => "Width of widget in pixels or 'auto' to fit to width of page. Default is auto",
// "Number of pixels or the word 'auto'" => "Number of pixels or the word 'auto'",
// "User Count" => "User Count",
// "Display number of users for a site or group" => "Display number of users for a site or group",
"Group name" => "Nom del Grup",
// "User Link" => "User Link",
// "Display a link to a user's information page" => "Display a link to a user's information page",
// "User account name (which can be an email address)" => "User account name (which can be an email address)",
"User List" => "Llistat d'usuaris",
// "Display a list of registered users" => "Display a list of registered users",
// "Login Filter" => "Login Filter",
// "Separator to use between users in the list. Default: comma" => "Separator to use between users in the list. Default: comma",
// "User info" => "User info",
// "User page" => "User page",
// "User pref" => "User pref",
"Real Name" => "Nom real",
// "Display the user's real name (when available) instead of login name" => "Display the user's real name (when available) instead of login name",
// "Filter on a group" => "Filter on a group",
"users" => "usuaris",
// "Display contents based on user preference settings" => "Display contents based on user preference settings",
// "Create tabs for showing alternate versions of content" => "Create tabs for showing alternate versions of content",
// "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default" => "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default",
// "Navigation" => "Navigation",
// "Displays a navigation box that allows users to select a specific version to display" => "Displays a navigation box that allows users to select a specific version to display",
// "Display the current version name as the title. No title shows when nav=>y; otherwise shows by default" => "Display the current version name as the title. No title shows when nav=>y; otherwise shows by default",
// "Default Label" => "Default Label",
// "Specifies version label to show when displaying the page for the first time. Default label is 'Default'" => "Specifies version label to show when displaying the page for the first time. Default label is 'Default'",
// "Display a Vimeo video" => "Display a Vimeo video",
// "Entire URL to the Vimeo video. Example: http://vimeo.com/3319966" => "Entire URL to the Vimeo video. Example: http://vimeo.com/3319966",
// "Quality of the video" => "Quality of the video",
// "Full screen" => "Full screen",
// "Expand to full screen" => "Expand to full screen",
"Vote" => "Votar",
// "Create a tracker for voting" => "Create a tracker for voting",
// "Show Stats" => "Show Stats",
// "Choose whether to show the voting results (shown by default)" => "Choose whether to show the voting results (shown by default)",
// "Show Stats After" => "Show Stats After",
// "Choose whether to show the voting results only after the date given in the tracker configuration (not set by default)" => "Choose whether to show the voting results only after the date given in the tracker configuration (not set by default)",
// "Choose whether to display the user name of the creator of the voting tracker (not shown by default)" => "Choose whether to display the user name of the creator of the voting tracker (not shown by default)",
// "Align the plugin on the page, allowing other elements to wrap around it (not set by default)" => "Align the plugin on the page, allowing other elements to wrap around it (not set by default)",
// "Votings" => "Votings",
// "Saves voting information in Smarty variables for display" => "Saves voting information in Smarty variables for display",
// "Object Key" => "Object Key",
// "Object key that is used to record votes" => "Object key that is used to record votes",
// "Return value" => "Return value",
// "Value to display as output of plugin" => "Value to display as output of plugin",
// "Wanted Pages" => "Wanted Pages",
// "Show location of links to pages not yet created" => "Show location of links to pages not yet created",
// "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom). Possible values: a valid regex-expression (PCRE)" => "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom). Possible values: a valid regex-expression (PCRE)",
// "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)" => "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)",
// "a valid regex-expression (PCRE)" => "a valid regex-expression (PCRE)",
// "Split By" => "Split By",
// "The character by which ignored patterns are separated" => "The character by which ignored patterns are separated",
// "Skip Extension" => "Skip Extension",
// "Whether to include external wikis in the list (not included by default)" => "Whether to include external wikis in the list (not included by default)",
// "Collect" => "Collect",
// "Collect either originating (from) or wanted pages (to) in a cell and display them in the second column" => "Collect either originating (from) or wanted pages (to) in a cell and display them in the second column",
"From" => "Des de",
"To" => "A",
// "Switch on debug output with details about the items (debug not on by default)" => "Switch on debug output with details about the items (debug not on by default)",
// "Memory Saver" => "Memory Saver",
// "Multiple collected items are separated in distinct table rows (default), or by comma or line break in one cell" => "Multiple collected items are separated in distinct table rows (default), or by comma or line break in one cell",
"Line break" => "Salt de línia",
// "Separate Row" => "Separate Row",
// "Level" => "Level",
// "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex" => "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex",
// "Custom" => "Custom",
// "Full" => "Full",
// "non-valid custom regex" => "non-valid custom regex",
", " => ", ",
"ignored" => "ignorat",
"External Wiki" => "Wiki Extern",
"dash-WikiWord" => "guio-ParaulaWiki",
"WikiWord" => "ParaulaWiki",
"not in level" => "no al nivell",
"valid" => "vàlid",
"End of debug output." => "Final de la sortida de depuració.",
"Wanted Page" => "Pàgina buscada",
"Referenced By Page" => "Referenciat per la pàgina",
// "Watershed" => "Watershed",
// "Viewer for UStream Watershed Embed" => "Viewer for UStream Watershed Embed",
// "Specify archive, broadcaster, chat or viewer" => "Specify archive, broadcaster, chat or viewer",
"Archive" => "Arxiu",
// "Broadcaster" => "Broadcaster",
// "Viewer" => "Viewer",
// "Channel code" => "Channel code",
// "Specify the channel code to search in the tracker for a channel to use" => "Specify the channel code to search in the tracker for a channel to use",
// "Brand ID" => "Brand ID",
// "Specify the brand id to search in the tracker for a channel to use" => "Specify the brand id to search in the tracker for a channel to use",
// "Brand prefix" => "Brand prefix",
// "Copy the prefix from the chat embed, e.g. Name-of-Brand-" => "Copy the prefix from the chat embed, e.g. Name-of-Brand-",
// "Video ID" => "Video ID",
// "Video ID of archive which can be found in the tracker" => "Video ID of archive which can be found in the tracker",
// "Locale specified in viewer embed, default is en_US" => "Locale specified in viewer embed, default is en_US",
// "More than one channel found for specified criteria. Please be more specific" => "More than one channel found for specified criteria. Please be more specific",
// "No videoId specified for archive" => "No videoId specified for archive",
// "Web Service" => "Web Service",
// "Display remote information exposed in JSON or YAML" => "Display remote information exposed in JSON or YAML",
// "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter" => "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter",
// "Complete service URL" => "Complete service URL",
// "Registered service name" => "Registered service name",
// "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided" => "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided",
// "Body as Parameter" => "Body as Parameter",
// "Name of the argument to send the body as for services with complex input. Named service required for this to be useful" => "Name of the argument to send the body as for services with complex input. Named service required for this to be useful",
// "Parameters formatted like a query : param1=value1&amp;param2=value2" => "Parameters formatted like a query : param1=value1&amp;param2=value2",
// "Unknown Template" => "Unknown Template",
// "Unknown Service" => "Unknown Service",
// "Permits to have a WYSIWYG section for part of a page" => "Permits to have a WYSIWYG section for part of a page",
// "Minimum width for DIV. Default:500px" => "Minimum width for DIV. Default:500px",
// "Minimum height for DIV. Default:300px" => "Minimum height for DIV. Default:300px",
// "You have unsaved changes in this WYSIWYG section.\nDo you want to save your changes" => "You have unsaved changes in this WYSIWYG section.\nDo you want to save your changes",
// "YouTube" => "YouTube",
// "Display a YouTube video" => "Display a YouTube video",
// "Movie" => "Movie",
// "Entire URL to the YouTube video or last part (after www.youtube.com/v/ and before the first question mark)" => "Entire URL to the YouTube video or last part (after www.youtube.com/v/ and before the first question mark)",
// "Quality of the video. Default is high" => "Quality of the video. Default is high",
// "Enlarge video to full screen size" => "Enlarge video to full screen size",
"Related" => "Relacionat",
// "Show related videos (shown by default)" => "Show related videos (shown by default)",
// "Background" => "Background",
// "Toolbar background color. Use an HTML color code. Example: ffffff" => "Toolbar background color. Use an HTML color code. Example: ffffff",
// "HTML color code, e.g. ffffff" => "HTML color code, e.g. ffffff",
// "Toolbar border colors. Use an HTML color code. Example: ffffff" => "Toolbar border colors. Use an HTML color code. Example: ffffff",
// "Plugin YouTube error: the movie parameter is empty" => "Plugin YouTube error: the movie parameter is empty",
// "Missing parameter movie to the Youtube plugin" => "Missing parameter movie to the Youtube plugin",
// "Zotero Citation" => "Zotero Citation",
// "Retrieves and includes a Zotero reference in the page" => "Retrieves and includes a Zotero reference in the page",
// "Reference Key" => "Reference Key",
// "Unique reference for the group associated to the site. Can be retrieved from the Zotero Bibliography module" => "Unique reference for the group associated to the site. Can be retrieved from the Zotero Bibliography module",
// "Reference Tag" => "Reference Tag",
// "Uses the first result using the specified tag. Useful when the tag mechanism is coerced into creating unique human memorizable keys" => "Uses the first result using the specified tag. Useful when the tag mechanism is coerced into creating unique human memorizable keys",
// "Append a note to the reference for additional information, like page numbers or other sub-references" => "Append a note to the reference for additional information, like page numbers or other sub-references",
// "Zotero Reference List" => "Zotero Reference List",
// "Produces the complete reference list from the Zotero server" => "Produces the complete reference list from the Zotero server",
// "Provide the list of references with a given tag" => "Provide the list of references with a given tag",
// "No results obtained. The Zotero citation server may be down" => "No results obtained. The Zotero citation server may be down",
"ERROR: Either the subject or body must be non-empty" => "ERROR: El títol o el cos no han d'estar buits",
// "User %s does not have the permission" => "User %s does not have the permission",
"The message has been sent to" => "S'ha enviat el missatge a",
"The message will be sent to" => "S'enviarà el missatge a",
"ERROR: No valid users to send the message" => "ERROR: No hi ha usuaris válids per enviar el missatge",
"User %s does not want to receive messages" => "La persona usuària %s no vol rebre missatges",
"Invalid user" => "Invàlid usuari",
"Sent box is full. Archive or delete some sent messages first if you want to send more messages." => "La bústia Enviats és plena. Arxiveu o esborreu alguns missatges enviats si voleu enviar més missatges.",
// "An error occurred, please check your mail settings and try again" => "An error occurred, please check your mail settings and try again",
"You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'" => "Heu de poder rebre missatges per tal d'enviar-ne. Aneu a preferències de l'usuari i activa 'Permetre missatges d'altres usuaris'",
"User %s can not receive messages, mailbox is full" => "L'usuari %s no pot rebre missatges, la bústia de correu és plena",
"User %s can not receive messages" => "L'usuari %s no pot rebre missatges",
"Invalid user: %s" => "Usuari no vàlid: %s",
"Message has been sent to: " => "S'ha enviat el missatge a: ",
"Archive is full. Delete some messages from archive first." => "L'arxiu és ple. Esborreu primer alguns missatges de l'arxiu.",
"No more messages" => "No hi ha mes missatges",
// "ERROR: " => "ERROR: ",
// "ERROR: Invalid tab_id received. Numeric format expected, got %0" => "ERROR: Invalid tab_id received. Numeric format expected, got %0",
// "Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page" => "Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page",
// "Item types filter" => "Item types filter",
// "If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes" => "If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes",
// "Possible item type values" => "Possible item type values",
"Similar Content" => "Contingut similar",
// "Find similar content based on FreeTags" => "Find similar content based on FreeTags",
// "Similar Content Filter" => "Similar Content Filter",
// "Display only similar content of type specified" => "Display only similar content of type specified",
// "Default: \"All Content Type\"" => "Default: \"All Content Type\"",
// "Options: \"article, wiki page, blog post\"" => "Options: \"article, wiki page, blog post\"",
// "Broaden FreeTag Search" => "Broaden FreeTag Search",
// "Find similar content that contains one of the Tags or All of the Tags" => "Find similar content that contains one of the Tags or All of the Tags",
// "Default: \"n - needs to contain all of the Tags\"" => "Default: \"n - needs to contain all of the Tags\"",
// "Options: \"n - Needs to contain All Tags / y - Needs to contain one of the Tags\"" => "Options: \"n - Needs to contain All Tags / y - Needs to contain one of the Tags\"",
// "Google AdSense" => "Google AdSense",
// "Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code" => "Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code",
// "ad_channel" => "ad_channel",
// "Advertisement channel, as optionally provided by Google" => "Advertisement channel, as optionally provided by Google",
// "client" => "client",
// "As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"" => "As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"",
// "display" => "display",
// "Global banner format as provided by Google. For example: \"display=468*60_as\"" => "Global banner format as provided by Google. For example: \"display=468*60_as\"",
// "color_bg" => "color_bg",
// "Background color, as optionally provided by Google" => "Background color, as optionally provided by Google",
// "color_border" => "color_border",
// "Border color, as optionally provided by Google" => "Border color, as optionally provided by Google",
// "color_link" => "color_link",
// "Link color, as optionally provided by Google" => "Link color, as optionally provided by Google",
// "color_text" => "color_text",
// "Text color, as optionally provided by Google" => "Text color, as optionally provided by Google",
// "color_url" => "color_url",
// "URL color, as optionally provided by Google" => "URL color, as optionally provided by Google",
// "Article Archives" => "Article Archives",
// "Shows links to the published articles for each month" => "Shows links to the published articles for each month",
// "If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles" => "If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles",
// "Default: \"n\"" => "Default: \"n\"",
// "If set to a category identifier, only consider the articles in the specified category" => "If set to a category identifier, only consider the articles in the specified category",
// "Example value: 13" => "Example value: 13",
// "Topic filter (by names)" => "Topic filter (by names)",
// "If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered",
// "Topic filter (by identifiers)" => "Topic filter (by identifiers)",
// "If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered",
// "Example values: 13, !13, 1+3, !1+5+7" => "Example values: 13, !13, 1+3, !1+5+7",
// "Types filter" => "Types filter",
// "If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered" => "If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered",
// "Example values: Event, !Event, Event+Review, !Event+Classified+Article" => "Example values: Event, !Event, Event+Review, !Event+Classified+Article",
// "Language filter" => "Language filter",
// "If set to a language code, only consider the articles in the specified language" => "If set to a language code, only consider the articles in the specified language",
"Article Topics" => "Temes de l'article",
// "Lists all article topics with links to their articles" => "Lists all article topics with links to their articles",
// "Lists the specified number of published articles in the specified order" => "Lists the specified number of published articles in the specified order",
// "Show publication time" => "Show publication time",
// "If set to \"y\", article publication times are shown" => "If set to \"y\", article publication times are shown",
// "Show creation time" => "Show creation time",
// "If set to \"y\", article creation times are shown" => "If set to \"y\", article creation times are shown",
// "Show rating selector" => "Show rating selector",
// "If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating" => "If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating",
// "If set, displays an image for each article if one applies, with the given width (in pixels). The article's own image is used, with a fallback to the article's topic image" => "If set, displays an image for each article if one applies, with the given width (in pixels). The article's own image is used, with a fallback to the article's topic image",
// "If set to a category identifier, only lists the articles in the specified category" => "If set to a category identifier, only lists the articles in the specified category",
// "If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed",
// "If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed",
// "If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed" => "If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed",
// "If set to a language code, only lists the articles in the specified language" => "If set to a language code, only lists the articles in the specified language",
// "Specifies how the articles should be sorted" => "Specifies how the articles should be sorted",
// "Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date" => "Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date",
// "If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead" => "If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead",
// "If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles" => "If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles",
// "Absolute URL" => "Absolute URL",
// "If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example" => "If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example",
// "If set to 0, will take the topicId of the article if in an article" => "If set to 0, will take the topicId of the article if in an article",
// "Tiki Assistant" => "Tiki Assistant",
// "Display an assistant to guide new Tiki admins" => "Display an assistant to guide new Tiki admins",
// "Babel Fish Links" => "Babel Fish Links",
// "Offers a link to the Yahoo! Babel Fish translation service" => "Offers a link to the Yahoo! Babel Fish translation service",
// "Babel Fish Icon Link" => "Babel Fish Icon Link",
// "Display an icon linked to the Yahoo! Babel Fish translation service" => "Display an icon linked to the Yahoo! Babel Fish translation service",
// "Newest Blog Post Comments" => "Newest Blog Post Comments",
// "Displays the specified number of the blog post comments most recently added" => "Displays the specified number of the blog post comments most recently added",
// "No date" => "No date",
// "If set to \"y\", the date of comments is not displayed in the module box" => "If set to \"y\", the date of comments is not displayed in the module box",
// "Verbose tooltips" => "Verbose tooltips",
// "If set to \"y\", blog post title is only visible as a tooltip and not displayed" => "If set to \"y\", blog post title is only visible as a tooltip and not displayed",
// "Options: \"y,n\"" => "Options: \"y,n\"",
// "Last-Visited Pages" => "Last-Visited Pages",
// "Displays the last Wiki pages visited by the user" => "Displays the last Wiki pages visited by the user",
// "Maximum number of characters in page names allowed before truncating" => "Maximum number of characters in page names allowed before truncating",
// "A hierarchy of where you are. Ex.: Home > Section1 > Subsection C" => "A hierarchy of where you are. Ex.: Home > Section1 > Subsection C",
// "Label preceding the crumbs" => "Label preceding the crumbs",
// "Menu Id" => "Menu Id",
// "Menu to take the crumb trail from" => "Menu to take the crumb trail from",
// "Menu Start Level" => "Menu Start Level",
// "Lowest level of the menu to display" => "Lowest level of the menu to display",
// "Menu Stop Level" => "Menu Stop Level",
// "Highest level of the menu to display" => "Highest level of the menu to display",
// "Show Site Crumb" => "Show Site Crumb",
// "Display the first crumb, usually the site, when using menu crumbs" => "Display the first crumb, usually the site, when using menu crumbs",
// "Show Page Crumb" => "Show Page Crumb",
// "Display the last crumb, usually the page, when using menu crumbs" => "Display the last crumb, usually the page, when using menu crumbs",
// "Show Crumb Links" => "Show Crumb Links",
// "Display links on the crumbs" => "Display links on the crumbs",
// "Includes a calendar or a list of calendar events" => "Includes a calendar or a list of calendar events",
// "Calendars filter" => "Calendars filter",
// "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\"). Example values: \"13\", \"4,7\", \"31:49\". Not set by default" => "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\"). Example values: \"13\", \"4,7\", \"31:49\". Not set by default",
// "Displayed month (relative)" => "Displayed month (relative)",
// "Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span. Example values: 2, 0, -2, -12" => "Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span. Example values: 2, 0, -2, -12",
// "View type" => "View type",
// "Determines how to show events. Possible values: %0, %1" => "Determines how to show events. Possible values: %0, %1",
// "Calendar view type time span" => "Calendar view type time span",
// "If in calendar (or \"table\") view type, determines the time span displayed by the calendar. Possible values: %0, %1, %2, %3 ,%4, %5. A user changing this time span in the calendar can change the time span the module displays for him" => "If in calendar (or \"table\") view type, determines the time span displayed by the calendar. Possible values: %0, %1, %2, %3 ,%4, %5. A user changing this time span in the calendar can change the time span the module displays for him",
// "Show action" => "Show action",
// "Viewmode when clicking on a day" => "Viewmode when clicking on a day",
// "Put a link on all the days , not only those with event" => "Put a link on all the days , not only those with event",
// "View navigation bar" => "View navigation bar",
// "Cart" => "Cart",
// "Displays the content of the cart, allows to modify quantities and proceed to payment" => "Displays the content of the cart, allows to modify quantities and proceed to payment",
// "The quantities in your cart were updated" => "The quantities in your cart were updated",
// "Gift card added" => "Gift card added",
// "Gift card not found" => "Gift card not found",
// "Gift card removed" => "Gift card removed",
// "Displays links to categories as a tree" => "Displays links to categories as a tree",
// "Object type filter" => "Object type filter",
// "Object type filter to apply when accessing a linked category. Example values" => "Object type filter to apply when accessing a linked category. Example values",
// "Deep" => "Deep",
// "Show subcategories objects when accessing a linked category. Possible values: on (default), off" => "Show subcategories objects when accessing a linked category. Possible values: on (default), off",
// "Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don't limit display)" => "Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don't limit display)",
// "Show these categories and their children" => "Show these categories and their children",
// "Show only these categories and the immediate child categories of these in the order the parameter specifies. Example values: 3,5,6" => "Show only these categories and the immediate child categories of these in the order the parameter specifies. Example values: 3,5,6",
// "Category links to a page named as the category" => "Category links to a page named as the category",
// "If y, category links to a page named as the category" => "If y, category links to a page named as the category",
// "Category Transitions" => "Category Transitions",
// "Displays controls to trigger category transitions and change the page's state according to predefined rules" => "Displays controls to trigger category transitions and change the page's state according to predefined rules",
// "Example Transition" => "Example Transition",
// "Change Category" => "Change Category",
// "Enables to categorize an object" => "Enables to categorize an object",
// "This module currently only supports Wiki pages. Some combinations of Multiple categories, Detailed, Unassign and Assign may challenge intuition or be simply broken" => "This module currently only supports Wiki pages. Some combinations of Multiple categories, Detailed, Unassign and Assign may challenge intuition or be simply broken",
// "Category identifier" => "Category identifier",
// "Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier" => "Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier",
// "Note that the root category is not displayed" => "Note that the root category is not displayed",
// "Defaults to 0 (root)" => "Defaults to 0 (root)",
// "No top" => "No top",
// "In non-detailed view, disallow uncategorizing. Example value: 1" => "In non-detailed view, disallow uncategorizing. Example value: 1",
// "Display path" => "Display path",
// "Unless set to \"n\", display relative category paths in the category tree rather than category names" => "Unless set to \"n\", display relative category paths in the category tree rather than category names",
// "Paths are relative to the root category, which is not displayed" => "Paths are relative to the root category, which is not displayed",
// "Multiple categories" => "Multiple categories",
// "If set to \"n\", only allows categorizing in one category (from those displayed)" => "If set to \"n\", only allows categorizing in one category (from those displayed)",
"Categorize" => "Categoritzar",
// "String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize" => "String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize",
// "Shy" => "Shy",
// "If set to \"y\", the module is not shown on pages which are not already categorized" => "If set to \"y\", the module is not shown on pages which are not already categorized",
// "Detailed" => "Detailed",
// "If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list" => "If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list",
"Unassign" => "Desassigna",
// "If set to \"n\", the detailed list of categories will not offer to unassign a category" => "If set to \"n\", the detailed list of categories will not offer to unassign a category",
// "If set to \"y\", allow to assign new categories" => "If set to \"y\", allow to assign new categories",
// "Example values: y, n" => "Example values: y, n",
// "Default value: y" => "Default value: y",
// "Group filter" => "Group filter",
// "Very particular filter option. If set to \"y\", only categories with a name matching one of the user's groups are shown, and descendants of these matching categories" => "Very particular filter option. If set to \"y\", only categories with a name matching one of the user's groups are shown, and descendants of these matching categories",
// "Default value: n" => "Default value: n",
// "Image URL not in category" => "Image URL not in category",
// "Very particular parameter. If both this and \"Image URL in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category" => "Very particular parameter. If both this and \"Image URL in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category",
// "Image URL in category" => "Image URL in category",
// "Very particular parameter. If both this and \"Image URL not in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category" => "Very particular parameter. If both this and \"Image URL not in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category",
// "Categorize %s" => "Categorize %s",
"Categorize %s in %s" => "Classifica %s en %s",
// "Received Objects" => "Received Objects",
// "Displays the number of pages received (via Communications)" => "Displays the number of pages received (via Communications)",
"Contributors" => "Contribuïdors",
// "Lists the contributors to the wiki page being viewed and some information on them" => "Lists the contributors to the wiki page being viewed and some information on them",
// "Shows the credits a user has" => "Shows the credits a user has",
// "Newest Directory Sites" => "Newest Directory Sites",
// "Displays the specified number of the directory sites most recently added" => "Displays the specified number of the directory sites most recently added",
// "Directory category identifier" => "Directory category identifier",
// "If set to a directory category identifier, only displays the sites in the specified directory category" => "If set to a directory category identifier, only displays the sites in the specified directory category",
// "If set to \"y\", displays a button labelled \"More\" that links to the directory" => "If set to \"y\", displays a button labelled \"More\" that links to the directory",
"Show description" => "Mostrar descripció",
// "If set to \"y\", the description of the directory site appears" => "If set to \"y\", the description of the directory site appears",
// "Maximum length of description" => "Maximum length of description",
// "If desc = \"y\", use maxdesc to set the maximum length of the directory site (in characters). Leave blank to set no maximum (show the entire description)" => "If desc = \"y\", use maxdesc to set the maximum length of the directory site (in characters). Leave blank to set no maximum (show the entire description)",
// "Default: blank" => "Default: blank",
// "Directory Statistics" => "Directory Statistics",
// "Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links" => "Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links",
// "Top Directory Sites" => "Top Directory Sites",
// "Displays the specified number of the directory sites from most visited to least visited" => "Displays the specified number of the directory sites from most visited to least visited",
// "Displays the site's first featured links" => "Displays the site's first featured links",
// "Displays links to file galleries" => "Displays links to file galleries",
// "Top-Rated Topics" => "Top-Rated Topics",
// "Displays the specified number of the forum topics with the best ratings" => "Displays the specified number of the forum topics with the best ratings",
"Newest Forum Posts" => "Publicacions més recents als fòrums",
"Displays the latest forum posts" => "Mostra les darreres publicacions als fòrums",
"Topics only" => "Només tòpics",
// "If set to \"y\", only displays topics" => "If set to \"y\", only displays topics",
// "List of forum identifiers" => "List of forum identifiers",
// "If set to a list of forum identifiers, restricts the posts to those in the identified forums. Identifiers are separated by colons (\":\")" => "If set to a list of forum identifiers, restricts the posts to those in the identified forums. Identifiers are separated by colons (\":\")",
// "Show date" => "Show date",
// "If set to \"y\", show post date directly instead of as tooltip" => "If set to \"y\", show post date directly instead of as tooltip",
// "Show time" => "Show time",
// "Show times after dates" => "Show times after dates",
"Show author" => "Mostrar autor",
// "If set to \"y\", show post author directly instead of as tooltip" => "If set to \"y\", show post author directly instead of as tooltip",
"Most Commented Forums" => "Fòrums amb més comentaris",
// "Display the specified number of the forums with the most comments" => "Display the specified number of the forums with the most comments",
// "Top Visited Forum Topics" => "Top Visited Forum Topics",
// "Display the specified number of the forum topics with the most reads" => "Display the specified number of the forum topics with the most reads",
// "Top Visited Forums" => "Top Visited Forums",
// "Display the specified number of the forums with the most visits" => "Display the specified number of the forums with the most visits",
"Tags Editor" => "Editor de Marques",
// "Shows current freetags and enables to add and remove some if permissions allow" => "Shows current freetags and enables to add and remove some if permissions allow",
// "Wiki Page Tags" => "Wiki Page Tags",
// "Displays current freetags on wiki pages and enables to add tags if permissions allow" => "Displays current freetags on wiki pages and enables to add tags if permissions allow",
"Similar-Tag Items" => "Ítems amb Marques Similars",
// "Shows content with multiple freetags in common" => "Shows content with multiple freetags in common",
// "Type of objects to extract" => "Type of objects to extract",
"Similar pages" => "Pàgines similars",
"Most Popular Tags" => "Marques Més Populars",
// "Shows the most popular freetags. More popularity is indicated by a larger font" => "Shows the most popular freetags. More popularity is indicated by a larger font",
// "Display type" => "Display type",
// "If set to \"cloud\", links are displayed as a cloud" => "If set to \"cloud\", links are displayed as a cloud",
// "Default: \"list\"" => "Default: \"list\"",
// "Maximum elements" => "Maximum elements",
// "If set to a number, limits the number of tags displayed" => "If set to a number, limits the number of tags displayed",
"My Preferred Tags" => "Les Meves Marques Preferides",
// "Displays to registered users the freetags they prefer, based on the number of objects they added the tag to. More preference is indicated by a larger font" => "Displays to registered users the freetags they prefer, based on the number of objects they added the tag to. More preference is indicated by a larger font",
"My preferred tags" => "Les meves marques preferides",
"Google Search" => "Cerca a Google",
// "Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site" => "Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site",
// "Groups Emulation" => "Groups Emulation",
// "Enables temporarily changing one's group memberships to see how users in fewer groups experience the site" => "Enables temporarily changing one's group memberships to see how users in fewer groups experience the site",
"Emulate Groups" => "Emula Grups",
// "Last Actions" => "Last Actions",
// "Displays the specified number of last actions" => "Displays the specified number of last actions",
// "Show user" => "Show user",
// "If set to \"y\", user names are displayed in the module box" => "If set to \"y\", user names are displayed in the module box",
// "If set to \"y\", action dates are displayed in the module box" => "If set to \"y\", action dates are displayed in the module box",
// "Maximum number of characters in action descriptions before truncating" => "Maximum number of characters in action descriptions before truncating",
// "Newest Blog Posts" => "Newest Blog Posts",
// "Lists the specified number of blogs posts from newest to oldest" => "Lists the specified number of blogs posts from newest to oldest",
// "If set to \"y\", the date of posts is not displayed in the module box" => "If set to \"y\", the date of posts is not displayed in the module box",
// "Blog identifier" => "Blog identifier",
// "If set to a blog identifier, restricts the blog posts to those in the identified blog" => "If set to a blog identifier, restricts the blog posts to those in the identified blog",
// "Newest Category Items" => "Newest Category Items",
// "Lists the specified number of objects of the given type in the given category, starting from the most recently created" => "Lists the specified number of objects of the given type in the given category, starting from the most recently created",
// "Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed" => "Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed",
// "Maximum number of characters in object names allowed before truncating" => "Maximum number of characters in object names allowed before truncating",
// "Type of the objects to list. Example values" => "Type of the objects to list. Example values",
"no object here yet" => "encara no hi ha cap objecte aquí",
// "Newest Blogs" => "Newest Blogs",
// "Displays the specified number of blogs from newest to oldest" => "Displays the specified number of blogs from newest to oldest",
// "Newest FAQs" => "Newest FAQs",
// "Displays the specified number of FAQs from newest to oldest" => "Displays the specified number of FAQs from newest to oldest",
// "Newest Quizzes" => "Newest Quizzes",
// "Displays the specified number of quizzes from newest to oldest" => "Displays the specified number of quizzes from newest to oldest",
// "Last-Modified File Galleries" => "Last-Modified File Galleries",
// "Display the specified number of file galleries, starting from the most recently modified" => "Display the specified number of file galleries, starting from the most recently modified",
// "Newest Files" => "Newest Files",
// "List the specified number of files, starting from the most recently added" => "List the specified number of files, starting from the most recently added",
// "Gallery identifiers" => "Gallery identifiers",
// "If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers" => "If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers",
// "Example value: 13, 2:13, 1:2:3:5:6" => "Example value: 13, 2:13, 1:2:3:5:6",
// "Last-Modified Image Galleries" => "Last-Modified Image Galleries",
// "Displays the specified number of image galleries, starting from the most recently modified" => "Displays the specified number of image galleries, starting from the most recently modified",
// "Newest Images" => "Newest Images",
// "List the specified number of images, starting from the most recently added" => "List the specified number of images, starting from the most recently added",
// "Gallery identifier" => "Gallery identifier",
// "If set to an image gallery identifier, restricts the images to those in the identified gallery" => "If set to an image gallery identifier, restricts the images to those in the identified gallery",
// "Link content" => "Link content",
// "Display the links as image names or thumbnails" => "Display the links as image names or thumbnails",
// "Possible values: \"names\" or \"thumbnails\". Default value: \"names\"" => "Possible values: \"names\" or \"thumbnails\". Default value: \"names\"",
// "Last-Modified Events" => "Last-Modified Events",
// "Display the specified number of calendar events, starting from the most recently modified" => "Display the specified number of calendar events, starting from the most recently modified",
// "Calendar Identifier" => "Calendar Identifier",
// "If set to a calendar identifier, restricts the events to those in the identified calendar" => "If set to a calendar identifier, restricts the events to those in the identified calendar",
// "Maximum number of characters in event names allowed before truncating" => "Maximum number of characters in event names allowed before truncating",
// "Hide Date" => "Hide Date",
// "If set to \"y\", it will hide date" => "If set to \"y\", it will hide date",
// "List the specified number of pages, starting from the most recently modified" => "List the specified number of pages, starting from the most recently modified",
// "Link Target" => "Link Target",
// "Target URL of the \"...more\" link at the bottom of the module" => "Target URL of the \"...more\" link at the bottom of the module",
// "Last-Modified Blogs" => "Last-Modified Blogs",
// "Displays the specified number of blogs, starting from the most recently modified" => "Displays the specified number of blogs, starting from the most recently modified",
// "Newest Podcasts" => "Newest Podcasts",
// "Displays Podcasts" => "Displays Podcasts",
// "File galleries IDs" => "File galleries IDs",
// "List of IDs of file galleries of type \"Podcast (Audio)\". Identifiers are separated by a colon (\":\"). If none, all file galleries will be scanned" => "List of IDs of file galleries of type \"Podcast (Audio)\". Identifiers are separated by a colon (\":\"). If none, all file galleries will be scanned",
"width" => "amplada",
// "Width of mediaplayer in pixels" => "Width of mediaplayer in pixels",
"height" => "alçada",
// "Height of mediaplayer in pixels" => "Height of mediaplayer in pixels",
// "Path to mp3 player. For instance media/player_mp3_maxi.swf if you downloaded player_mp3_maxi.swf from http://flash-mp3-player.net/players/maxi/download/ to directory media/ (directory needs to be created or you can chose another place)" => "Path to mp3 player. For instance media/player_mp3_maxi.swf if you downloaded player_mp3_maxi.swf from http://flash-mp3-player.net/players/maxi/download/ to directory media/ (directory needs to be created or you can chose another place)",
// "Bottom Link URL" => "Bottom Link URL",
// "URL for a link at bottom of module" => "URL for a link at bottom of module",
// "Bottom Link URL Text" => "Bottom Link URL Text",
// "Text for link if Bottom Link URL is set" => "Text for link if Bottom Link URL is set",
// "More Podcasts" => "More Podcasts",
// "Verbose" => "Verbose",
// "Display description of podcast below player if \"y\", and on title mouseover if \"n\"" => "Display description of podcast below player if \"y\", and on title mouseover if \"n\"",
// "Newest Article Submissions" => "Newest Article Submissions",
// "Lists the specified number of article submissions from newest to oldest" => "Lists the specified number of article submissions from newest to oldest",
"Newest Tracker Comments" => "Comentaris més recents a Formularis-bd",
// "Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted" => "Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted",
// "Tracker identifier" => "Tracker identifier",
// "If set to a tracker identifier, only displays the comments on the given tracker" => "If set to a tracker identifier, only displays the comments on the given tracker",
// "Item identifier" => "Item identifier",
// "If set to an item identifier, only displays the comments on the given item" => "If set to an item identifier, only displays the comments on the given item",
// "Newest Tracker Items" => "Newest Tracker Items",
// "Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required" => "Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required",
// "Identifier of the tracker from which items are listed" => "Identifier of the tracker from which items are listed",
// "Field identifier" => "Field identifier",
// "Identifier of the field from which values are listed. If Field name is set, this parameter is ignored" => "Identifier of the field from which values are listed. If Field name is set, this parameter is ignored",
// "Field name" => "Field name",
// "Name of the field from which values are listed" => "Name of the field from which values are listed",
// "Example value: age" => "Example value: age",
// "Specifies how the items should be sorted" => "Specifies how the items should be sorted",
// "Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date" => "Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date",
// "Status filter" => "Status filter",
// "If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values" => "If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values",
// "Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set" => "Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set",
// "You do not have permission to view this tracker" => "You do not have permission to view this tracker",
"Last Items" => "Últims Punts",
"Last Modified Items" => "Últims Punts modificats",
// "Newest Validated FAQ Questions" => "Newest Validated FAQ Questions",
// "Displays the specified number of validated questions FAQs from newest to oldest" => "Displays the specified number of validated questions FAQs from newest to oldest",
// "Faq identifier" => "Faq identifier",
// "If set to a faq identifier, restricts the chosen questions to those in the identified faq" => "If set to a faq identifier, restricts the chosen questions to those in the identified faq",
"Last Visitors" => "Últims visitants",
// "Displays information about the specified number of users in decreasing order of last login time" => "Displays information about the specified number of users in decreasing order of last login time",
// "Show avatars" => "Show avatars",
// "If set to \"y\", show user avatars" => "If set to \"y\", show user avatars",
// "Maximum number of characters in user names allowed before truncating" => "Maximum number of characters in user names allowed before truncating",
// "Don't show date" => "Don't show date",
// "YouTube Playlist" => "YouTube Playlist",
// "Display a YouTube playlist" => "Display a YouTube playlist",
// "Playlist ID" => "Playlist ID",
// "ID of the YouTube playlist to display (not the complete URL). Example: id=4DE69387D46DA2F6" => "ID of the YouTube playlist to display (not the complete URL). Example: id=4DE69387D46DA2F6",
// "Width of each video in pixels" => "Width of each video in pixels",
// "Height of each video in pixels" => "Height of each video in pixels",
// "Allow FullScreen" => "Allow FullScreen",
// "Bottom Link" => "Bottom Link",
// "Url for a link at bottom of module. Example: link_url=http://www.youtube.com/CouncilofEurope#grid/user/E57D0D93BA3A56C8" => "Url for a link at bottom of module. Example: link_url=http://www.youtube.com/CouncilofEurope#grid/user/E57D0D93BA3A56C8",
// "Bottom Link Text" => "Bottom Link Text",
// "Text for link if link_url is set, otherwise 'More Videos'" => "Text for link if link_url is set, otherwise 'More Videos'",
// "Video Descriptions" => "Video Descriptions",
// "Display description of video on title mouseover if 'y'. Default is 'y'" => "Display description of video on title mouseover if 'y'. Default is 'y'",
// "Order by" => "Order by",
// "Criteria to order by the videos in the list. Default is 'position'" => "Criteria to order by the videos in the list. Default is 'position'",
// "position" => "position",
// "commentCount" => "commentCount",
"duration" => "durada",
// "published" => "published",
// "reversedPosition" => "reversedPosition",
// "title" => "title",
// "viewCount" => "viewCount",
// "No Playlist found" => "No Playlist found",
// "No Playlist ID was provided" => "No Playlist ID was provided",
"Live Support" => "Suport en directe",
// "Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console" => "Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console",
// "Server Load" => "Server Load",
// "Report of server resources used" => "Report of server resources used",
// "Presents a map with the geolocated content within the page" => "Presents a map with the geolocated content within the page",
// "Log-in box" => "Log-in box",
// "Input size" => "Input size",
// "Number of characters for username and password input fields" => "Number of characters for username and password input fields",
// "Display mode: module, header or popup. Leave empty for module mode" => "Display mode: module, header or popup. Leave empty for module mode",
// "Show Register" => "Show Register",
// "Show the register link" => "Show the register link",
// "Show I Forgot" => "Show I Forgot",
// "Show the \"I forgot my password\" link" => "Show the \"I forgot my password\" link",
// "Show Remember me" => "Show Remember me",
// "Show the \"Remember me\" checkbox" => "Show the \"Remember me\" checkbox",
// "Logo" => "Logo",
// "Site logo, title and subtitle" => "Site logo, title and subtitle",
// "Map Feature Editor" => "Map Feature Editor",
// "Allows to draw shapes over the map" => "Allows to draw shapes over the map",
// "Tracker to store the feature in" => "Tracker to store the feature in",
// "Hidden Input" => "Hidden Input",
// "Hidden values to be sent over to the dialog. fieldName(value)" => "Hidden values to be sent over to the dialog. fieldName(value)",
// "Standard controls" => "Standard controls",
// "Dispay the standard draw controls" => "Dispay the standard draw controls",
// "Layer Selector" => "Layer Selector",
// "Replace the map's built-in layer controls" => "Replace the map's built-in layer controls",
// "Mode Selector" => "Mode Selector",
// "Toggle input modes for the map" => "Toggle input modes for the map",
// "Map location search" => "Map location search",
// "Simple search controls for the map" => "Simple search controls for the map",
"Menu" => "Menú",
// "Displays a menu or a structure as a menu" => "Displays a menu or a structure as a menu",
// "Identifier of a menu (from tiki-admin_menus.php)" => "Identifier of a menu (from tiki-admin_menus.php)",
"Structure" => "Estructura",
// "Identifier of a structure of wiki pages (name or number from tiki-admin_structures.php)" => "Identifier of a structure of wiki pages (name or number from tiki-admin_structures.php)",
// "Direction for menu: horiz or vert (default vert)" => "Direction for menu: horiz or vert (default vert)",
// "CSS/Superfish" => "CSS/Superfish",
// "Use CSS Superfish menu. y|n (default y)" => "Use CSS Superfish menu. y|n (default y)",
// "DOM #id" => "DOM #id",
// "Id of the menu in the DOM" => "Id of the menu in the DOM",
// "CSS class" => "CSS class",
// "Class of the menu container" => "Class of the menu container",
// "Limit low visibles levels" => "Limit low visibles levels",
// "All the submenus beginning at this level will be displayed if the url matches one of the option of this level or above or below" => "All the submenus beginning at this level will be displayed if the url matches one of the option of this level or above or below",
// "Limit top visible levels" => "Limit top visible levels",
// "Do not display options higher than this level" => "Do not display options higher than this level",
// "Link on Section" => "Link on Section",
// "Create links on menu sections" => "Create links on menu sections",
// "(y/n default y)" => "(y/n default y)",
// "Translate labels" => "Translate labels",
// "Menu Cookie" => "Menu Cookie",
// "Open the menu to show current option if possible" => "Open the menu to show current option if possible",
// "One of these parameters has to be set" => "One of these parameters has to be set",
// "Menu Page" => "Menu Page",
// "Displays a Wiki page" => "Displays a Wiki page",
// "Page to display in the menu. Example value: HomePage" => "Page to display in the menu. Example value: HomePage",
// "Wiki Structure Menu" => "Wiki Structure Menu",
// "Displays a structure" => "Displays a structure",
// "N.B. Deprecated, use the Menu module instead" => "N.B. Deprecated, use the Menu module instead",
// "Structure to display in the menu" => "Structure to display in the menu",
// "Unread Inter-User Messages" => "Unread Inter-User Messages",
// "Displays to users their number of new inter-user messages and a link to their message box" => "Displays to users their number of new inter-user messages and a link to their message box",
// "Show If Empty" => "Show If Empty",
// "Show the module when there are no messages waiting. y|n " => "Show the module when there are no messages waiting. y|n ",
// "Default=y" => "Default=y",
"Messages" => "Missatges",
// "Small live chat box" => "Small live chat box",
// "Channels" => "Channels",
// "List of chat channels. Channel names are separated by a comma (\",\")" => "List of chat channels. Channel names are separated by a comma (\",\")",
// "By default, a single channel named \"default\" exists" => "By default, a single channel named \"default\" exists",
"Mobile" => "Mòbil",
// "Currently only shows switch to and from mobile mode" => "Currently only shows switch to and from mobile mode",
// "To Label" => "To Label",
// "Switch to normal site label" => "Switch to normal site label",
// "From Label" => "From Label",
// "Switch to mobile site label" => "Switch to mobile site label",
"Switch Perspective" => "Canvi de Perspectiva",
// "Also switch perspective back to this one when leaving mobile mode" => "Also switch perspective back to this one when leaving mobile mode",
// "Stay" => "Stay",
// "Stay on same page" => "Stay on same page",
"Switch to mobile site" => "Canvia a vesió de mòbil",
"Switch to normal site" => "Canvia a vesió normal",
"Months Links" => "Months links (Arxiu per mesos)",
// "Link to articles or blog posts for the current month and those preceding it" => "Link to articles or blog posts for the current month and those preceding it",
// "Type of objects to link to" => "Type of objects to link to",
// "\"blogs\" for blog posts, \"cms\" for published articles" => "\"blogs\" for blog posts, \"cms\" for published articles",
// "Object Identifier" => "Object Identifier",
// "Identifier of an object with children to link to" => "Identifier of an object with children to link to",
// "This is required for the blog Object type" => "This is required for the blog Object type",
// "For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3" => "For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3",
"List by month" => "Arxiu mensual",
"Most Commented" => "Més comentats/des",
"Display the most commented objects of a certain type" => "Mostra els objectes més comentats d'un cert tipus",
"Type of objects to consider" => "Tipus d'objectes a considerar",
// "Possible values: wiki (Wiki pages), blog (blog posts), article (articles)" => "Possible values: wiki (Wiki pages), blog (blog posts), article (articles)",
// "Language Filter" => "Language Filter",
// "If set to a RFC1766 language tag, restricts the objects considered to those in the specified language" => "If set to a RFC1766 language tag, restricts the objects considered to those in the specified language",
"Pending Article Submissions" => "Enviaments d'Articles Pendents",
// "Displays the number of article submissions waiting examination and a link to the list" => "Displays the number of article submissions waiting examination and a link to the list",
"Old Articles" => "Articles antics",
// "Displays the specified number of old articles (which do not show on articles home page anymore)" => "Displays the specified number of old articles (which do not show on articles home page anymore)",
// "Payments Outstanding" => "Payments Outstanding",
// "Displays the payments outstanding for the current user" => "Displays the payments outstanding for the current user",
// "Enables to change current perspective" => "Enables to change current perspective",
"Powered By" => "Potenciat Per",
"Powered by Tiki, and others" => "Potenciat per Tiki, i altres",
// "Shows \"Powered by Tiki Wiki CMS Groupware\" message" => "Shows \"Powered by Tiki Wiki CMS Groupware\" message",
// "Tiki version info" => "Tiki version info",
// "Credits" => "Credits",
// "Shows theme credits (contents of credits.tpl)" => "Shows theme credits (contents of credits.tpl)",
// "Icons" => "Icons",
// "Shows various \"powered by\" icons" => "Shows various \"powered by\" icons",
"Quick Edit" => "Edició Ràpida",
// "Enables to quickly create or edit Wiki pages" => "Enables to quickly create or edit Wiki pages",
// "Deprecated - use the Search module instead" => "Deprecated - use the Search module instead",
// "Template identifier" => "Template identifier",
// "If set to a template identifier, the specified template is used for creating new Wiki pages" => "If set to a template identifier, the specified template is used for creating new Wiki pages",
// "If set, send the form to the given location (relative to Tiki's root) for processing" => "If set, send the form to the given location (relative to Tiki's root) for processing",
// "SUBMIT label" => "SUBMIT label",
// "The label on the button to submit the form" => "The label on the button to submit the form",
"Create/Edit" => "Crea/edita",
// "INPUT SIZE" => "INPUT SIZE",
// "Size attribute (horizontal, in characters) of the text input field for page names" => "Size attribute (horizontal, in characters) of the text input field for page names",
// "Optional heading to display at the top of the module's content" => "Optional heading to display at the top of the module's content",
// "Category to preselect" => "Category to preselect",
// "If set, pages created through the module have this category prechecked to be categorized in" => "If set, pages created through the module have this category prechecked to be categorized in",
// "Tip to be shown" => "Tip to be shown",
// "Custom text to be shown as a tip at the top of the edit page" => "Custom text to be shown as a tip at the top of the edit page",
// "Title of tip to be shown" => "Title of tip to be shown",
// "Custom title to be shown for the tip at the top of the edit page" => "Custom title to be shown for the tip at the top of the edit page",
// "Custom header template" => "Custom header template",
// "Wiki page to be used as a template to show content on top of edit page" => "Wiki page to be used as a template to show content on top of edit page",
"Quick Edit a Wiki Page" => "Crea/Edita pàgina Wiki",
"Quick Search" => "Cerca Ràpida",
// "Performs a search query and persists the results in the module for quick navigation access" => "Performs a search query and persists the results in the module for quick navigation access",
// "Filter object type" => "Filter object type",
// "Limit search results to a specific object type. Enter an object type to use a static filter or write \"selector\" to provide an input" => "Limit search results to a specific object type. Enter an object type to use a static filter or write \"selector\" to provide an input",
// "Filter category" => "Filter category",
// "Limit search results to a specific category. Enter the comma separated list of category IDs to include in the selector. Single category will display no controls" => "Limit search results to a specific category. Enter the comma separated list of category IDs to include in the selector. Single category will display no controls",
"Quick Admin" => "Admin. ràpida",
// "Some helpful tools for admins" => "Some helpful tools for admins",
// "Display mode: module or header. Leave empty for module mode" => "Display mode: module or header. Leave empty for module mode",
"Random Image" => "Imatge aleatòria",
// "Displays a random image" => "Displays a random image",
// "If set to an image gallery identifier, restricts the chosen images to those in the identified gallery" => "If set to an image gallery identifier, restricts the chosen images to those in the identified gallery",
// "Show link" => "Show link",
// "If set to \"n\", the image thumbnail does not link to the image" => "If set to \"n\", the image thumbnail does not link to the image",
// "Default: \"y\"" => "Default: \"y\"",
// "Show name" => "Show name",
// "If set to \"y\", the name of the image is displayed" => "If set to \"y\", the name of the image is displayed",
// "If set to \"y\", the description of the image is displayed" => "If set to \"y\", the description of the image is displayed",
"Random Pages" => "Pàgines a l'atzar",
// "Displays the specified number of random wiki pages" => "Displays the specified number of random wiki pages",
// "New User Registration" => "New User Registration",
// "Permit anonymous visitors to create an account on the site" => "Permit anonymous visitors to create an account on the site",
// "News Feeds" => "News Feeds",
// "List of feeds available on this site" => "List of feeds available on this site",
// "Multi-purpose search module (go or edit page by name and/or search site)" => "Multi-purpose search module (go or edit page by name and/or search site)",
// "Legacy Mode" => "Legacy Mode",
// "Setting to emulate previous behaviour" => "Setting to emulate previous behaviour",
// "If set to \"y\" the search performed is a \"Tiki search\"" => "If set to \"y\" the search performed is a \"Tiki search\"",
// " (full text search)" => " (full text search)",
// "Show Object Type Filter" => "Show Object Type Filter",
// "If set to \"y\" shows a dropdown of sections to search" => "If set to \"y\" shows a dropdown of sections to search",
// " (no object filter)" => " (no object filter)",
// "Use autocomplete" => "Use autocomplete",
// "If set to \"y\" input uses autocomplete for pagenames if applicable" => "If set to \"y\" input uses autocomplete for pagenames if applicable",
// " (use autocomplete)" => " (use autocomplete)",
"Advanced search" => "Cerca advançada",
// "Use advanced (boolean) search (full text search only)" => "Use advanced (boolean) search (full text search only)",
// " (use advanced search)" => " (use advanced search)",
// "Advanced search checkbox" => "Advanced search checkbox",
// "Show advanced search checkbox (full text search only)" => "Show advanced search checkbox (full text search only)",
// " (advanced search checkbox off)" => " (advanced search checkbox off)",
// "Advanced search help" => "Advanced search help",
// "Show advanced search help icon (full text search only)" => "Show advanced search help icon (full text search only)",
// " (advanced search help off)" => " (advanced search help off)",
// "Show Search Button" => "Show Search Button",
// "Show search button" => "Show search button",
// " (do show search button)" => " (do show search button)",
// "Show Go Button" => "Show Go Button",
// "Show go to page button" => "Show go to page button",
// " (do show go button)" => " (do show go button)",
// "Show Edit Button" => "Show Edit Button",
// "Show edit button" => "Show edit button",
// " (do show edit button)" => " (do show edit button)",
// "Default Button" => "Default Button",
// "Action to perform on entering <return>" => "Action to perform on entering <return>",
// " (search|go|edit)" => " (search|go|edit)",
// "Search Form Action" => "Search Form Action",
// " tiki-searchresults.php or tiki-searchindex.php (for Tiki search)" => " tiki-searchresults.php or tiki-searchindex.php (for Tiki search)",
// "Edit Submit Label" => "Edit Submit Label",
// "Go Form Action" => "Go Form Action",
"Go" => "Fes-ho",
// "Edit Form Action" => "Edit Form Action",
// "Input field width" => "Input field width",
// "Width of the text input field (in characters)" => "Width of the text input field (in characters)",
// " 0 (leave automatic width)" => " 0 (leave automatic width)",
// "Select size" => "Select size",
// "Size of the Search Filter dropdown list" => "Size of the Search Filter dropdown list",
// "Edit Template identifier" => "Edit Template identifier",
// "If set to a category identifier, pages created through the module are automatically categorized in the specified category" => "If set to a category identifier, pages created through the module are automatically categorized in the specified category",
// "Compact mode" => "Compact mode",
// "Makes the three buttons only appear on mouse-over" => "Makes the three buttons only appear on mouse-over",
// "Search is disabled" => "Search is disabled",
// "Titles" => "Titles",
// "Search for Wiki Page" => "Search for Wiki Page",
// "Search Box" => "Search Box",
// "Small search form for wiki, articles, blogs, etc" => "Small search form for wiki, articles, blogs, etc",
// "If set to \"y\", the search performed is a \"Tiki search\". Default: \"n\" (full text search)" => "If set to \"y\", the search performed is a \"Tiki search\". Default: \"n\" (full text search)",
// "Search For a Wiki Page" => "Search For a Wiki Page",
// "Search for a wiki page by name" => "Search for a wiki page by name",
// "Exact match checkbox checked by default if set to \"y\"" => "Exact match checkbox checked by default if set to \"y\"",
// "Semantic Links" => "Semantic Links",
// "List the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from" => "List the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from",
// "Links for sharing, reporting etc" => "Links for sharing, reporting etc",
"Report to Webmaster" => "Informa als administradors web",
"Share this page" => "Comparteix aquesta pàgina",
// "Use icons for report, share and email links" => "Use icons for report, share and email links",
// "Facebook" => "Facebook",
// "Show Facebook \"Like\" button on the current page" => "Show Facebook \"Like\" button on the current page",
// "Facebook: URL" => "Facebook: URL",
// "URL to \"Like\" (leave blank for current URL)" => "URL to \"Like\" (leave blank for current URL)",
// "Facebook: Send" => "Facebook: Send",
// "Show Facebook \"Send\" button" => "Show Facebook \"Send\" button",
// "Facebook: Layout" => "Facebook: Layout",
// "Size, layout and amount of social context" => "Size, layout and amount of social context",
// "Facebook: Width" => "Facebook: Width",
// "Facebook: Height" => "Facebook: Height",
// "Container height in CSS units (e.g. \"120px\" or \"2em\")" => "Container height in CSS units (e.g. \"120px\" or \"2em\")",
// "Facebook: Show Faces" => "Facebook: Show Faces",
// "Show pictures of others who like this" => "Show pictures of others who like this",
// "Facebook: Verb" => "Facebook: Verb",
// "Verb to display in button" => "Verb to display in button",
// "Facebook: Colors" => "Facebook: Colors",
// "Color scheme" => "Color scheme",
// "Facebook: Font" => "Facebook: Font",
// "Font to display" => "Font to display",
// "Facebook: Locale" => "Facebook: Locale",
// "Locale in the format ll_CC (default \"en_US\")" => "Locale in the format ll_CC (default \"en_US\")",
// "Facebook: Referrals" => "Facebook: Referrals",
// "Label for tracking referrals (optional)" => "Label for tracking referrals (optional)",
// "Facebook: App Id" => "Facebook: App Id",
// "ID of your Facebook app (optional)" => "ID of your Facebook app (optional)",
// "Show Twitter Follow Button on the current page" => "Show Twitter Follow Button on the current page",
// "Twitter: User Name" => "Twitter: User Name",
// "Twitter user name to quote as \"via\"" => "Twitter user name to quote as \"via\"",
// "Twitter: Label" => "Twitter: Label",
// "Text to display. Default \"Tweet\"" => "Text to display. Default \"Tweet\"",
// "Twitter: URL" => "Twitter: URL",
// "URL to \"Tweet\" (leave blank for current URL)" => "URL to \"Tweet\" (leave blank for current URL)",
// "Twitter: Show Count" => "Twitter: Show Count",
// "Position of Tweet count" => "Position of Tweet count",
// "Twitter: Language" => "Twitter: Language",
// "Two letter language code" => "Two letter language code",
// "Twitter: Width" => "Twitter: Width",
// "Width in pixels or percentage (e.g. 300px)" => "Width in pixels or percentage (e.g. 300px)",
// "Twitter: Height" => "Twitter: Height",
// "Twitter: Text" => "Twitter: Text",
// "Tweet text (leave empty to use page title" => "Tweet text (leave empty to use page title",
// "LinkedIn" => "LinkedIn",
// "Linked in share button" => "Linked in share button",
// "LinkedIn: URL" => "LinkedIn: URL",
// "URL to share (leave blank for current URL)" => "URL to share (leave blank for current URL)",
// "LinkedIn: Count Mode" => "LinkedIn: Count Mode",
// "Position of count" => "Position of count",
// "Google +1" => "Google +1",
// "Google +1 button" => "Google +1 button",
// "Google: Size" => "Google: Size",
// "Google button size" => "Google button size",
// "Google: Annotation" => "Google: Annotation",
// "Google annotation" => "Google annotation",
// "Google: Language" => "Google: Language",
// "Google language" => "Google language",
// "Google: URL" => "Google: URL",
// "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows to send messages" => "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows to send messages",
// "If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content" => "If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content",
// "Label on the button to post a message" => "Label on the button to post a message",
// "Wait label" => "Wait label",
// "Label on the button to post a message when the message is being posted if AJAX is enabled" => "Label on the button to post a message when the message is being posted if AJAX is enabled",
"Please wait.." => "Si us plau espera..",
// "Maximum messages shown" => "Maximum messages shown",
// "Number of messages to display" => "Number of messages to display",
// "Tweet" => "Tweet",
// "If set to \"1\" and the user has authorized us to tweet messages with Twitter, the user can decide, if he wants to shout via Twitter" => "If set to \"1\" and the user has authorized us to tweet messages with Twitter, the user can decide, if he wants to shout via Twitter",
// "If set to \"1\" and the user has authorized us with Facebook, the user can decide, if he wants to add the shout to his Facebook wall" => "If set to \"1\" and the user has authorized us with Facebook, the user can decide, if he wants to add the shout to his Facebook wall",
"Since Last Visit (Simple)" => "Des de la Darrera Visita (Simple)",
// "Displays to logged in users the number of new or updated objects since their last login date and time" => "Displays to logged in users the number of new or updated objects since their last login date and time",
"Since your last visit" => "Des de la teva última visita",
"Since Last Visit" => "Des de la Darrera Visita",
// "Displays to logged in users new or updated objects since a point in time, by default their last login date and time" => "Displays to logged in users new or updated objects since a point in time, by default their last login date and time",
// "Show users" => "Show users",
// "If set to \"n\", do not show new users" => "If set to \"n\", do not show new users",
// "Show trackers" => "Show trackers",
// "If set to \"n\", do not show tracker changes" => "If set to \"n\", do not show tracker changes",
// "Calendar focus" => "Calendar focus",
// "Unless set to \"ignore\", the module changes the reference point in time from the user's last login date and time to a day where users browse to using the calendar" => "Unless set to \"ignore\", the module changes the reference point in time from the user's last login date and time to a day where users browse to using the calendar",
// "Show date as a calendar link" => "Show date as a calendar link",
// "If set to \"n\", do not add a link to tiki calendar on the date in the header (even if feature calendar is set)" => "If set to \"n\", do not add a link to tiki calendar on the date in the header (even if feature calendar is set)",
// "Fold sections by default" => "Fold sections by default",
// "If set to \"y\", fold automatically sections and show only the title (user has to click on each section in order to see the details of modifications)" => "If set to \"y\", fold automatically sections and show only the title (user has to click on each section in order to see the details of modifications)",
// "Use jQuery presentation" => "Use jQuery presentation",
// "If set to \"y\", use jQuery to show the result" => "If set to \"y\", use jQuery to show the result",
// "Minimum timespan" => "Minimum timespan",
// "Instead of the last login time, go back this minimum time, specified in days, in case the last login time is more recent" => "Instead of the last login time, go back this minimum time, specified in days, in case the last login time is more recent",
"Changes since" => "Canvis des de",
"Since your last visit.." => "Desde la teva darrera visita..",
"In the last %0 days.." => "En els darrers %0 dies..",
"new comments" => "comentaris nous",
" (archived)" => " (archivats/des)",
"new posts" => "noves publicacions",
"wiki pages changed" => "pàgines del wiki modificades",
"new articles" => "articles nous",
"new FAQs" => "Noves FAQs",
"new blogs" => "bitàcoles noves",
"new blog posts" => "noves entrades al bloc",
"new image galleries" => "noves galeries d'imatge",
"new images" => "imatges noves",
"new file galleries" => "noves galeries de fitxers",
"new files" => "arxius nous",
"new polls" => "consultes noves",
"new users" => "usuaris/es nous/ves",
"new tracker items" => "nous ítems del formulari",
"updated tracker items" => "ítems de formularis-db actualitzats",
// "SVN Up Info" => "SVN Up Info",
// "SVN Version and last update information" => "SVN Version and last update information",
"Switch Language" => "Canvia l'Idioma",
// "Displays a language picker to change the language of the site" => "Displays a language picker to change the language of the site",
// "Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist" => "Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist",
"Switch Theme" => "Canvia el Tema (d'estil)",
// "Enables to quickly change the theme" => "Enables to quickly change the theme",
// "Terminology" => "Terminology",
// "Support for multilingual terminology" => "Support for multilingual terminology",
"Root category" => "Categoria Arrel",
// "All terms will automatically be put in that category. " => "All terms will automatically be put in that category. ",
// "Note that the category must already exist. " => "Note that the category must already exist. ",
// "Defaults to 'Term'" => "Defaults to 'Term'",
// "Tiki Tests" => "Tiki Tests",
// "Tiki test suite helper" => "Tiki test suite helper",
"Most Active blogs" => "Blocs més actius",
// "Displays the specified number of blogs with links to them, from the most active one to the least" => "Displays the specified number of blogs with links to them, from the most active one to the least",
// "Blog activity measurement can be more or less accurate" => "Blog activity measurement can be more or less accurate",
// "Lists the specified number of articles with links to them, from the most visited one to the least" => "Lists the specified number of articles with links to them, from the most visited one to the least",
"Top File Galleries" => "Galeria d'arxius principals",
// "Displays the specified number of file galleries with links to them, starting with the one with most hits" => "Displays the specified number of file galleries with links to them, starting with the one with most hits",
// "Top Files" => "Top Files",
// "Displays the specified number of files with links to them, starting with the one with most hits" => "Displays the specified number of files with links to them, starting with the one with most hits",
"Top Forum Posters" => "Els publicadors de Fòrums més actius",
// "Displays the specified number of users who posted to forums, starting with the one having most posts" => "Displays the specified number of users who posted to forums, starting with the one having most posts",
// "Top Image Galleries" => "Top Image Galleries",
// "Displays the specified number of image galleries with links to them, starting with the one with most hits" => "Displays the specified number of image galleries with links to them, starting with the one with most hits",
"Top Images" => "Imatges per dalt",
// "Displays the specified number of images with links to them, from the most visited one to the least" => "Displays the specified number of images with links to them, from the most visited one to the least",
"Top Objects" => "Objects més actius",
// "Displays the specified number of objects, starting with the one having the most hits" => "Displays the specified number of objects, starting with the one having the most hits",
"Top Pages" => "Pàgines per dalt",
// "Displays the specified number of wiki pages with links to them, starting with the one having the most hits" => "Displays the specified number of wiki pages with links to them, starting with the one having the most hits",
"Top Quizzes" => "Qüestionaris principals",
// "Displays the specified number of quizzes with links to them, starting with the one having the most hits" => "Displays the specified number of quizzes with links to them, starting with the one having the most hits",
"Top Visited Blogs" => "Blocs més visitats",
// "Display the specified number of blogs with links to them, from the most visited one to the least" => "Display the specified number of blogs with links to them, from the most visited one to the least",
// "Show Last Post" => "Show Last Post",
// "Top Visited FAQs" => "Top Visited FAQs",
// "Display the specified number of FAQs with links to them, from the most visited one to the least" => "Display the specified number of FAQs with links to them, from the most visited one to the least",
// "Tracker Input" => "Tracker Input",
// "Allows to open a dialog to create new tracker items" => "Allows to open a dialog to create new tracker items",
// "Tracker ID to render" => "Tracker ID to render",
// "Text Input" => "Text Input",
// "Multiple text fields to display as part of the main form along with the label. Field names map to the permanent names in the tracker field definitions. ex: groupName(Group Name) relatedTask(Task)" => "Multiple text fields to display as part of the main form along with the label. Field names map to the permanent names in the tracker field definitions. ex: groupName(Group Name) relatedTask(Task)",
// "Location Field" => "Location Field",
// "Obtain the coordinates from a nearby map and send them to the location field. In addition to the field name, :marker or :viewport can be used as the suffix. Default is :marker" => "Obtain the coordinates from a nearby map and send them to the location field. In addition to the field name, :marker or :viewport can be used as the suffix. Default is :marker",
// "Capture StreetView" => "Capture StreetView",
// "Include a button on the StreetView interface to create tracker items from the location. Requires upload image from URL and location parameter" => "Include a button on the StreetView interface to create tracker items from the location. Requires upload image from URL and location parameter",
// "Alter the submit button label" => "Alter the submit button label",
// "Operation to perform on success" => "Operation to perform on success",
// "Operation to perform in the following format: operationName(argument). Current operations are redirect with the URL template as the argument. @valueName@ will be replaced by the appropriate value where valueName is itemId, status or a permanent name" => "Operation to perform in the following format: operationName(argument). Current operations are redirect with the URL template as the argument. @valueName@ will be replaced by the appropriate value where valueName is itemId, status or a permanent name",
"Create" => "Crear",
// "Tracker Help" => "Tracker Help",
// "Display the fields of a tracker (name and identifier)" => "Display the fields of a tracker (name and identifier)",
// "Text field height" => "Text field height",
"Number of lines" => "Nombre de línies",
// "Text field width" => "Text field width",
// "Number of characters" => "Number of characters",
// "Translate Updates" => "Translate Updates",
// "Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed" => "Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed",
// "Reference language" => "Reference language",
// "If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed" => "If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed",
// "Show language" => "Show language",
// "If \"y\" the page language will be shown instead of the page name" => "If \"y\" the page language will be shown instead of the page name",
// "Default = \"y\"" => "Default = \"y\"",
// "Lists the specified number of calendar events, ordered by their start date" => "Lists the specified number of calendar events, ordered by their start date",
// "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")" => "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")",
// "Maximum days in the future" => "Maximum days in the future",
// "Maximum distance to event start dates in days (looking forward)" => "Maximum distance to event start dates in days (looking forward)",
// "Maximum days in the past" => "Maximum days in the past",
// "Maximum distance to event end dates in days (looking backward)" => "Maximum distance to event end dates in days (looking backward)",
// "cellpadding" => "cellpadding",
// "If set to an integer, apply this cellpadding to the HTML table generated" => "If set to an integer, apply this cellpadding to the HTML table generated",
// "cellspacing" => "cellspacing",
// "If set to an integer, apply this cellspacing to the HTML table generated" => "If set to an integer, apply this cellspacing to the HTML table generated",
// "If set to \"y\", event descriptions are displayed" => "If set to \"y\", event descriptions are displayed",
"Show end date and time" => "Mostra la data i hora finals",
// "If set to \"y\", event end dates and times are displayed, when appropriate" => "If set to \"y\", event end dates and times are displayed, when appropriate",
// "Use custom calendar background colors" => "Use custom calendar background colors",
// "If set to \"y\", events are displayed with their calendar's custom background color (if one is set)" => "If set to \"y\", events are displayed with their calendar's custom background color (if one is set)",
// "Show information in tooltips" => "Show information in tooltips",
// "If set to \"n\", event tooltips will not display event information" => "If set to \"n\", event tooltips will not display event information",
// "Date format" => "Date format",
// "Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>" => "Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>",
// "site preference for short date format followed by site preference for short time format" => "site preference for short date format followed by site preference for short time format",
// "If set to an integer, event names are allowed that number of characters as a maximum before being truncated" => "If set to an integer, event names are allowed that number of characters as a maximum before being truncated",
// "My Blogs" => "My Blogs",
// "Displays to registered users their blogs" => "Displays to registered users their blogs",
// "Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed" => "Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed",
// "My Image Galleries" => "My Image Galleries",
// "Displays to registered users their image galleries" => "Displays to registered users their image galleries",
"User Pages" => "Pàgines de l'usuari",
// "Displays to registered users the specified number of wiki pages which they were the last to edit" => "Displays to registered users the specified number of wiki pages which they were the last to edit",
"My Pages" => "Les meves pàgines",
"My Tasks" => "Les meves tasques",
// "Lightweight interface to user tasks, enabling to view them concisely and do some manipulations" => "Lightweight interface to user tasks, enabling to view them concisely and do some manipulations",
"The task title must have at least 3 characters" => "El títol de la tasca ha de tenir com a mínim 3 caràcters",
// "Public Tasks" => "Public Tasks",
// "Lists the public user tasks of a chosen group, with links to tasks" => "Lists the public user tasks of a chosen group, with links to tasks",
// "User-Group Tracker" => "User-Group Tracker",
// "User and Group tracker links" => "User and Group tracker links",
// "My Score" => "My Score",
// "Display the logged user's rank and score" => "Display the logged user's rank and score",
"Most Active Users" => "Usuaris més actius",
// "Display the specified number of users and their score, starting from the one with the highest score" => "Display the specified number of users and their score, starting from the one with the highest score",
// "Webmail Inbox" => "Webmail Inbox",
// "Displays Webmail Inbox" => "Displays Webmail Inbox",
// "Account Id" => "Account Id",
// "Webmail account identifier (if not set uses user's current account)" => "Webmail account identifier (if not set uses user's current account)",
// "GroupMail: Group (e.g. \"Help Team\")" => "GroupMail: Group (e.g. \"Help Team\")",
// "GroupMail: Tracker Id (to store GroupMail activity)" => "GroupMail: Tracker Id (to store GroupMail activity)",
// "GroupMail: From Field (Id of field in tracker to store email From header)" => "GroupMail: From Field (Id of field in tracker to store email From header)",
// "GroupMail: Subject Field (Id of field in tracker to store email Subject header)" => "GroupMail: Subject Field (Id of field in tracker to store email Subject header)",
// "GroupMail: Message Field (Id of field in tracker to store email message identifier)" => "GroupMail: Message Field (Id of field in tracker to store email message identifier)",
// "GroupMail: Content Field (Id of field in tracker to store email message body content)" => "GroupMail: Content Field (Id of field in tracker to store email message body content)",
// "GroupMail: Account Field (Id of field in tracker to store Webmail account name)" => "GroupMail: Account Field (Id of field in tracker to store Webmail account name)",
// "DateTime Field Id" => "DateTime Field Id",
// "GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)" => "GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)",
// "GroupMail: Operator Field (Id of field in tracker to store operator name (username))" => "GroupMail: Operator Field (Id of field in tracker to store operator name (username))",
// "Maximum number of characters in subjects allowed before truncating" => "Maximum number of characters in subjects allowed before truncating",
// "Webmail error" => "Webmail error",
// "No accounts set up (or no current account set)" => "No accounts set up (or no current account set)",
// "Related Items" => "Related Items",
// "Lists objects which share a category with the viewed object" => "Lists objects which share a category with the viewed object",
// "Online Users" => "Online Users",
// "Display information about users currently logged in" => "Display information about users currently logged in",
// "List Type" => "List Type",
// "Display the number of users logged in, the list of users logged in, or both" => "Display the number of users logged in, the list of users logged in, or both",
// "Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"" => "Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"",
// "Cluster Mode" => "Cluster Mode",
// "If set to \"1\", separate users based on which host/server they logged on" => "If set to \"1\", separate users based on which host/server they logged on",
// "Newest Comments" => "Newest Comments",
// "Lists the specified number of comments starting from the most recently posted" => "Lists the specified number of comments starting from the most recently posted",
// "More in tooltips" => "More in tooltips",
// "If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item's tooltip" => "If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item's tooltip",
// "Type of the objects from which comments will be listed. Possible values" => "Type of the objects from which comments will be listed. Possible values",
// "Comments about objects in this language only" => "Comments about objects in this language only",
"Last article comments" => "Darrers comentaris d'articles",
"Last wiki comments" => "Darrers comentaris de pàgines wiki",
// "Displays YouTube videos and/or a link to a YouTube user's page" => "Displays YouTube videos and/or a link to a YouTube user's page",
// "Video identifiers" => "Video identifiers",
// "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")" => "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")",
// "YouTube user identifier" => "YouTube user identifier",
// "If set to a YouTube user identifier, display a link to the videos of this user" => "If set to a YouTube user identifier, display a link to the videos of this user",
// "Videos on YouTube" => "Videos on YouTube",
// "Bibliography Search" => "Bibliography Search",
// "Search the group's Zotero library for entries with the specified tags" => "Search the group's Zotero library for entries with the specified tags",
"Invalid server key" => "Clau del servidor invàlida",
"Invalid username or password" => "Usuari o contrasenya  no vàlids",
"Cookie not found" => "No s'ha trobat la galeta",
// "Select <a href=\"tiki-list_banners.php\" title=\"Banners\">Admin &gt; Banners</a> from the menu to create and edit banner zones" => "Select <a href=\"tiki-list_banners.php\" title=\"Banners\">Admin &gt; Banners</a> from the menu to create and edit banner zones",
"Cancel Edit" => "Cancel·la edició",
"Change preferences" => "Canviar preferències",
// "Activate the feature" => "Activate the feature",
"Plugins" => "Connectors (Plugins)",
"Site Ads and Banners" => "Anuncis i pancartes del lloc",
// "<strong>Activate</strong> will display content for Admin only. Select <strong>Publish</strong> to display for all users" => "<strong>Activate</strong> will display content for Admin only. Select <strong>Publish</strong> to display for all users",
"Settings" => "Configuració",
// "Areas Overview" => "Areas Overview",
// "Nothing was updated" => "Nothing was updated",
// "Edit perspective" => "Edit perspective",
// "No category found in area" => "No category found in area",
// "Hint" => "Hint",
// "This tab shows you an overview of categories affected by the areas feature. The category with the smallest id should be the category set as areas root in the settings tab. If not so, update this overview with the button below" => "This tab shows you an overview of categories affected by the areas feature. The category with the smallest id should be the category set as areas root in the settings tab. If not so, update this overview with the button below",
// "Update areas" => "Update areas",
// "How to setup" => "How to setup",
// "You have to enable the perspective and the categories feature. Then set a structure of categories with a common parent. Set that parent as areas root in the settings tab. Then go to " => "You have to enable the perspective and the categories feature. Then set a structure of categories with a common parent. Set that parent as areas root in the settings tab. Then go to ",
// "perspectives" => "perspectives",
// "There you can create a set of perspectives to bind the children of areas root to. Change for every perspective you want the category jail to another child. It is designed that every child category is bind to one perspective only. If you do otherwise, the first found perspective is used" => "There you can create a set of perspectives to bind the children of areas root to. Change for every perspective you want the category jail to another child. It is designed that every child category is bind to one perspective only. If you do otherwise, the first found perspective is used",
"Look under \"Articles\" on the application menu for links to" => "Cerca dins de \"Articles\", en el menú principal de l'aplicació, per enllaços a",
// "Admin topics" => "Admin topics",
// "Admin types" => "Admin types",
"General Settings" => "Configuracions Generals",
"Features" => "Funcionalitats",
// "Article properties" => "Article properties",
// "Default maximum dimensions of custom images" => "Default maximum dimensions of custom images",
// "General (view mode)" => "General (view mode)",
// "List mode" => "List mode",
// "Sharing on social networks" => "Sharing on social networks",
"Import CSV file" => "Importeu un fitxer CSV",
"Batch upload (CSV file):" => "Càrrega de lots (arxiu CSV):",
// "File format: title,authorName,heading,body,lang,user" => "File format: title,authorName,heading,body,lang,user",
"Import" => "Importa",
// "Articles Listing" => "Articles Listing",
"List Articles" => "Llista d'Articles",
// "Select which items to display when listing articles" => "Select which items to display when listing articles",
// "Article View" => "Article View",
"To add/remove blogs, go to \"Create/Edit Blog\" under \"Blogs\" on the application menu, or" => "Per afegir/eliminar bitàcoles, ves a \"Crea/Edita bloc\" dins de \"Blocs\" en el menú principal de l'aplicació, o",
"Click Here" => "Cliqueu aquí",
"Comments" => "Comentaris",
// "Blogs Listings" => "Blogs Listings",
// "Select which items to display when listing blogs" => "Select which items to display when listing blogs",
"To add/remove calendars, look for \"Calendar\" under \"Admin\" on the application menu, or" => "Per afegir/eliminar calendaris, cerca \"Calendari\" dins de \"Admin\" en el menú principal de l'aplicació, o",
"Change settings" => "Canvia els paràmetres",
"General settings" => "Paràmetres generals",
"Default calendars to display" => "Calendaris a mostrar per omissió",
"All calendars" => "Tots els calendaris",
"A subset of available calendars" => "Un subconjunt dels calendaris disponibles",
"Create calendar" => "Crea un calendari",
// "Year selection is valid when the JS Calendar <strong>is not</strong> enabled" => "Year selection is valid when the JS Calendar <strong>is not</strong> enabled",
"Browse categories" => "Navega per les categories",
"Administer categories" => "Administra categories",
// "Organize Objects" => "Organize Objects",
"Feedback" => "Retroalimentació",
// "Category objects" => "Category objects",
// "Re-apply the last saved category defaults to the wiki pages" => "Re-apply the last saved category defaults to the wiki pages",
"List comments" => "Llista els comentaris",
"General Preferences" => "Preferències Generals",
// "Site-wide features" => "Site-wide features",
// "Display options" => "Display options",
"Permission" => "Permís",
// "Inline comments" => "Inline comments",
// "The feature below must be activated for this feature to work" => "The feature below must be activated for this feature to work",
// "Using comments in various features" => "Using comments in various features",
"Admin Groups" => "Administració de grups",
"Admin Users" => "Administrar usuaris",
// "Manage permissions" => "Manage permissions",
// "User features" => "User features",
"Community" => "Comunitat",
// "Default user preferences" => "Default user preferences",
"Users Default Preferences" => "Preferències per defecte per als nous usuaris",
"User messages" => "Missatges d'Usaeuari",
"My Tiki" => "El meu Tiki",
// "Select which items to display when listing users" => "Select which items to display when listing users",
"Join the community" => "Uneix-te a la comunitat",
"Tiki Wiki CMS Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU" => "Tiki Wiki CMS Groupware és Programari Lliure i de Codi Obert (FOSS, de les seves sigles en anglès). És un projecte que el porta una comunitat que existeix i millora gràcies a la participació de gent com ara TU mateix",
"Join the Community" => "Uneix-te a la Comunitat",
"Tiki news" => "Novetats de Tiki",
// "Embedded RSS feed from info.tiki.org TODO, meanwhile" => "Embedded RSS feed from info.tiki.org TODO, meanwhile",
// "Tiki Newsletter" => "Tiki Newsletter",
// "Promote your site" => "Promote your site",
// "Add your site to the Tiki diretory" => "Add your site to the Tiki diretory",
// "Submit your site" => "Submit your site",
// "Spread the word" => "Spread the word",
// "Add the \"Powered by\" module to your site. " => "Add the \"Powered by\" module to your site. ",
// "Manage Modules" => "Manage Modules",
"Help improve Tiki" => "Ajuda a millorar Tiki",
"Submit a feature request or bug report" => "Envia una petició de funcionalitat o informe d'error",
"Click here to go to our development site" => "Fes click aquí per tal d'anar al lloc de desenvolupament",
"Make a financial contribution to the Tiki Association" => "Fes una contribució financera a l'Associació de Tiki",
"Contribute to Tiki" => "Contribueix a Tiki",
"New Feature" => "Nova Funcionalitat",
// "Please note: Experimental - work in progress" => "Please note: Experimental - work in progress",
// "Tiki Connect is a way to let the Tiki project know how it is being used, and which parts people like or would like fixing (or explaining)" => "Tiki Connect is a way to let the Tiki project know how it is being used, and which parts people like or would like fixing (or explaining)",
// "When you click the \"Send Info\" below you will be connected with mother.tiki.org, which is where the data will be collected" => "When you click the \"Send Info\" below you will be connected with mother.tiki.org, which is where the data will be collected",
// "You can also send feedback about Tiki by checking the \"Feedback\" checkbox above. Icons will appear next to all the preferences where you can \"like\", request a \"fix\" or ask \"what's this for?\"" => "You can also send feedback about Tiki by checking the \"Feedback\" checkbox above. Icons will appear next to all the preferences where you can \"like\", request a \"fix\" or ask \"what's this for?\"",
// "Your votes are sent when you connect with mother.tiki.org (currently only be clicking the \"Send Info\" button)" => "Your votes are sent when you connect with mother.tiki.org (currently only be clicking the \"Send Info\" button)",
// "For more info" => "For more info",
// "Send Info" => "Send Info",
// "Send the data" => "Send the data",
// "Preview info" => "Preview info",
// "See what is going to be sent" => "See what is going to be sent",
// "Fill form" => "Fill form",
// "Fill this form in based on other preferences" => "Fill this form in based on other preferences",
// "Site Title is required" => "Site Title is required",
// "Advanced settings" => "Advanced settings",
// "Exposed to assist testing and development" => "Exposed to assist testing and development",
// "Connections received" => "Connections received",
// "Recent connections" => "Recent connections",
// "Rebuild Index" => "Rebuild Index",
// "Rebuild received connections index" => "Rebuild received connections index",
// "<strong>Server stats:</strong> %0 reports received from %1 Tikis" => "<strong>Server stats:</strong> %0 reports received from %1 Tikis",
// "Copyright allows to determine a copyright for all the objects of tiki" => "Copyright allows to determine a copyright for all the objects of tiki",
// "Enable copyright management for" => "Enable copyright management for",
"To configure your directory, find \"Admin Directory\" under \"Directory\" on the application menu, or" => "Per configurar el teu directori, troba \"Admin directori\" dins de \"Directori\" en el menú principal de l'aplicació, o",
"To add/remove FAQs, look for \"Admin FAQs\" under \"FAQs\" on the application menu, or" => "Per afegir/eliminar PUFs, cerca \"Admin FAQs\" dins de \"PUFs\" en el menú principal de l'aplicació, o",
"Please see the <a class='rbox-link' target='tikihelp' href='http://doc.tiki.org/Features'>evaluation of each feature</a> on Tiki's developer site." => "Si us plau, consulta l'<a class='rbox-link' target='tikihelp' href='http://doc.tiki.org/Features'>avaluació de cada funcionalitat</a> al lloc web de documentació de Tiki.",
"Apply" => "Aplica",
// "Global features" => "Global features",
// "Main feature" => "Main feature",
// "Additional" => "Additional",
// "Interaction with online services or other software" => "Interaction with online services or other software",
// "Configuration completed" => "Configuration completed",
// "Authenticate with Zotero" => "Authenticate with Zotero",
"Watches" => "Avisos",
// "Interface" => "Interface",
// "jQuery plugins and add-ons" => "jQuery plugins and add-ons",
// "Mobile Themes" => "Mobile Themes",
// "Programmer" => "Programmer",
"Logging and Reporting" => "Registres i informes",
"Visible to admin only" => "Visible només a l'admin",
"Include Smarty notices" => "Inclous avisos d'Smarty",
"Custom Code" => "Codi Adaptat",
// "Event Hooks" => "Event Hooks",
// "Please note that this is a relatively new feature that still needs to be deployed all around. Expect more events to be added over time" => "Please note that this is a relatively new feature that still needs to be deployed all around. Expect more events to be added over time",
// "If you need to add behaviors to Tiki, there are several event hooks you can attach to. Here are the events and the inheritance" => "If you need to add behaviors to Tiki, there are several event hooks you can attach to. Here are the events and the inheritance",
// "Draw Event Diagram" => "Draw Event Diagram",
// "To create or remove file galleries, select" => "To create or remove file galleries, select",
// "from the application menu" => "from the application menu",
"If you decide to store files in a directory you must ensure that the user cannot access directly to the directory." => "Si decideixes guaradr arxius en un directori, t'has assegurar que l'usuari no pot accedir directament el directori.",
"You have two options to accomplish this:<br /><ul><li>Use a directory outside your document root, make sure your php script can read and write to that directory</li><li>Use a directory inside the document root and use .htaccess to prevent the user from listing the directory contents</li></ul>" => "Tens dues opcions per aconseguir això:<br /><ul><li>Empra un directori fora de la teva carpeta arrel de documents web; assegura't que els teus arxius mphp poden llegir i esciure a aquest directori</li><li>Empra un directori dins la carpeta arrel de documents web i empra .htaccess per prevenir que l'usuari pugui llistar el contingut d'aquest directori</li></ul>",
"To configure the directory path use UNIX like paths for example files/ or c:/foo/files or /www/files/" => "Per configurar la ruta al directori empra rutes estil UNIX; per exemple arxius/ o c:/foo/arxius o /www/arxius/",
// "Move files from database to directory" => "Move files from database to directory",
// "Move files from directory to database" => "Move files from directory to database",
// "Manage comment settings" => "Manage comment settings",
// "You are highly recommended to use a file directory as the File Gallery storage, when using this feature" => "You are highly recommended to use a file directory as the File Gallery storage, when using this feature",
// "A cron job must be set up in order to delete the files" => "A cron job must be set up in order to delete the files",
// "Update mime of all non archived octet-stream files" => "Update mime of all non archived octet-stream files",
// "Quota" => "Quota",
// "Used" => "Used",
// "Upload Regex" => "Upload Regex",
// "Gallery Listings" => "Gallery Listings",
// "Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries" => "Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries",
// "Select which items to display when listing galleries: " => "Select which items to display when listing galleries: ",
// "Admin Gallery Listings" => "Admin Gallery Listings",
// "Select which items to display when admin galleries: " => "Select which items to display when admin galleries: ",
// "Search Indexing" => "Search Indexing",
// "Handlers" => "Handlers",
// "Add custom handlers to make your files &quot;searchable&quot; content" => "Add custom handlers to make your files &quot;searchable&quot; content",
// "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command" => "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command",
// "To delete a handler, leave the <strong>System Command</strong> field blank" => "To delete a handler, leave the <strong>System Command</strong> field blank",
// "Tiki is pre-configured to handle many common types. If any of those are listed here, it is because the command line tool is unavailable" => "Tiki is pre-configured to handle many common types. If any of those are listed here, it is because the command line tool is unavailable",
// "Missing Handlers" => "Missing Handlers",
"MIME Type" => "Tipus MIME",
// "System Command" => "System Command",
"Reindex all files for search" => "Reindexa tots els arxius per a la cerca",
// "SCORM" => "SCORM",
"To add/remove forums, look for \"Admin forums\" under \"Forums\" on the application menu, or" => "Per afegir/eliminar fòrums, cerca \"Admin fòrums\" dins de \"Fòrums\" en el menú de principal l'aplicació, o",
"Threads" => "Fils",
"Searches" => "Cerques",
"Forums Listing" => "Llistat de fòrums",
"Select which items to display when listing forums" => "Selecciona quins ítems mostrar quan es llistin els fòrums",
// "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>" => "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>",
// "Random tag cloud colors" => "Random tag cloud colors",
// "Separate colors with a comma (,)" => "Separate colors with a comma (,)",
// "Alphanumeric ASCII characters only" => "Alphanumeric ASCII characters only",
// "No accents or special characters" => "No accents or special characters",
// "Accept all characters" => "Accept all characters",
"Tag Management" => "Gestió d'Etiquetes",
// "Cleanup unused tags" => "Cleanup unused tags",
// "3D Tag Browser Configuration" => "3D Tag Browser Configuration",
"General" => "General",
// "Graph appearance" => "Graph appearance",
// "Camera settings" => "Camera settings",
// "Physics engine" => "Physics engine",
"To add/remove image galleries, go to \"Image Galleries\" on the application menu, or" => "Per afegir/eliminar galeries d'imatges, ves a \"Galeries d'Imatges\" en el menú de principal l'aplicació, o",
"You can upload images of a size of " => "Pots pujar imatges fins la mida de ",
"Alter the php.ini variables file_uploads, upload_max_filesize, post_max_size and database variables (max_allowed_packet for mysql) to change this value" => "Altera les variables de l'arxiu php.ini file_uploads, upload_max_filesize, post_max_size i database variables (max_allowed_packet for mysql) per canviar aquest valor",
"Home Gallery" => "Galeria inicial",
"Galleries features" => "Preferència de galeries",
"Comments:" => "Comentaris:",
"Uses Slideshow" => "Empra Pasi de diapos",
"Use database to store images" => "Empra la base de dades per desar les imatges",
"Use a directory to store images" => " Empra el directori per desar les imatges",
"Directory path" => "Ruta cap al directori",
// "Note: if you change this directory, you have to move the contents to the new directory. You can also use the 'Mover' below" => "Note: if you change this directory, you have to move the contents to the new directory. You can also use the 'Mover' below",
"Library to use for processing images" => "Llibreria per a fer servir per a processament d'imatges",
"Uploaded image names must match regex" => "Els noms de les imatges penjades han de coincidir amb el regex",
"Uploaded image names cannot match regex" => "Els noms de les imatges penjades no han de coincidir amb el regex",
"Directory Batch Loading" => "Directori per Pujades en Bloc",
"If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload images in that dir, either by scp, ftp, or other protocols" => "Si habilites el Directori per Pujades en Bloc, necessites configurar un directori llegible per la web (fora del teu espai web és millor). Llavors posa a punt una manera per pujar les teves imatges en aquest directori, sigui via scp, sftp, ssh, ftp, o altres protocols",
"Enable directory batch loading" => "Habilita la carrega en bloc al directori",
"Batch loading directory" => "Directori per càrregues en bloc",
// "Display image information in a mouseover box" => "Display image information in a mouseover box",
// "yes, and don't display that information under the image" => "yes, and don't display that information under the image",
// "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)" => "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)",
"Max Rows per page" => "Files màx. per pàgina",
"Images per row" => "Imatges per fila",
"Thumbnails size X" => "Mida x per a miniatures",
// "Pixels Default" => "Pixels Default",
"Thumbnails size Y" => "Mida Y per a miniatures",
// "Default scale size" => "Default scale size",
"pixels" => "píxels",
"Set features" => "Fixar Funcionalitats",
"Exterminator" => "Exterminador",
"Remove images in the system gallery not being used in Wiki pages, articles or blog posts" => "Treure imatges de la galeria del sistema, no emprades en pàgines wiki, galeries o publicacions de les bitàcoles",
"Remove" => "Elimina",
"Mover" => "Translocador",
"Move images from database storage to filesystem storage" => "Moure les imatges des de l'emmagatzematge en base de dades a l'emmagatzematge en el sistema d'arxius",
"Move images from filesystem storage to database storage" => "Moure les imatges des de l'emmagatzematge en el sistema d'arxius a l'emmagatzematge en base de dades",
"All galleries" => "Totes les galeries",
"System Gallery" => "Galeria del sistema",
"Move" => "Moure",
"Move images from old filesystem store to new directory" => "Moure les imatges des de l'emmagatzematge en sistema d'arxius vell al nou directori",
"Moved" => "Moguts/des",
"Gallery listing configuration" => "Configuració de llistat de galeries",
"Change configuration" => "Canvia la configuració",
"Image galleries comments settings" => "Configuració dels comentaris de les galeries d'imatges",
// "Server Fitness" => "Server Fitness",
// "Release Check" => "Release Check",
"Last update from SVN" => "Darrera actualització a partir de SVN",
"Reset or upgrade your database" => "Torna a especificar o actualitza la teva base de dades",
// "Check for updates now" => "Check for updates now",
"Site Identity" => "Identitat del Lloc",
// "Go to <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look & Feel</strong></a> section for additional site related customization preferences" => "Go to <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look & Feel</strong></a> section for additional site related customization preferences",
// "These values will be stored in plain text in the database" => "These values will be stored in plain text in the database",
// "Email to send a test mail" => "Email to send a test mail",
// "Sessions" => "Sessions",
// "Advanced configuration warning" => "Advanced configuration warning",
// "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects" => "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects",
// "Changing this feature will immediately log you out when you save this preference" => "Changing this feature will immediately log you out when you save this preference",
"Enable now" => "Habilita-ho ara mateix",
"Contact" => "Contacte",
"Miscellaneous" => "Miscel·lània",
"Menus" => "Menús",
"Create and edit menus " => "Crea i edita menús ",
"Home Page" => "Pàgina Inicial",
"Redirects" => "Redireccionaments",
"Site Access" => "Accés al lloc",
"Sample" => "Mostra",
"Date and Time Format Help" => "ajuda Data i Format de Temps",
"Change admin password" => "Canviar contrasenya de l'administrador",
"Change the <strong>Admin</strong> password" => "Canvia la contrasenya de l'usuari administrador (<strong>Admin</strong>)",
"User administration" => "Administració d'usuaris",
// "To use Google Maps, you must generate a Google Maps API Key for your web site. See <a href=\"http://code.google.com/intl/fr/apis/maps/signup.html\">http://code.google.com/intl/fr/apis/maps/signup.html</a> for details" => "To use Google Maps, you must generate a Google Maps API Key for your web site. See <a href=\"http://code.google.com/intl/fr/apis/maps/signup.html\">http://code.google.com/intl/fr/apis/maps/signup.html</a> for details",
"Defaults" => "Per omissió",
"Map mode in listings" => "Mode de mapa en llistats",
"Internationalization" => "Internacionalització (I18n)",
"Babelfish links" => "Enllaços de Babelfish",
"Customized String Translation" => "Traducció de cadenes de text a mida",
"Syntax error" => "Error de Sintaxi",
"Cannot open/write this file" => "No puc obrir/desar aquest arxiu",
"Custom translation will not be saved. Ask your administration to change the permission" => "No es poden desar les traduccions a mida. Demana a la persona administradora del lloc que canviï el permís",
"ok" => "d'acord",
"The file has been saved" => "S'ha desat l'arxiu",
"Translation" => "Traducció",
"Intertiki client" => "Client InterTiki",
"Tiki Unique key" => "Clau Tiki Única",
"InterTiki Slave mode" => "Mode esclau de l'InterTiki",
"Warning: overrides manually registered local users" => "Avís: sobreescriu manualment els usuaris locals registrats",
"as master" => "com a mestre",
"Import user preferences" => "Importa les preferències d'usuari",
"Import user groups" => "Importa els grups d'usuari",
"Limit group import (comma-separated list of imported groups, leave empty to avoid limitation)" => "Limita la importació de grups (llista separada per comes de grups importats, deixa en blanc per evitar la limitació)",
// "Intertiki shared cookie for sliding auth under same domain" => "Intertiki shared cookie for sliding auth under same domain",
"InterTiki Server" => "Servidor InterTiki",
"host" => "servidor",
"port" => "port",
"Add new server" => "Afegeix nou servidor",
"Intertiki server" => "Servidor Intertiki",
"Intertiki Server enabled" => "Servidor Intertiki disponible",
"Access Log file" => "Arxiu de registre d'accessos",
"Errors Log file" => "Fitxer de registre d'errors",
"Known hosts" => "Servidors coneguts",
"Key" => "Clau",
"IP" => "IP",
"New:" => "Nou:",
"Enable/disable Tiki features in " => "Habilita/deshabilita funcionalitats de Tiki en ",
", but configure them elsewhere" => ", però configura-les en un altres lloc",
"Registration" => "Registre",
"Log in" => "Connecta't",
// "Generate a passcode" => "Generate a passcode",
"Requires PHP GD library" => "Requereix la llibreria PHP GD",
// "Users can select a group to join at registration" => "Users can select a group to join at registration",
// "By default, new users automatically join the Registered group" => "By default, new users automatically join the Registered group",
// "Store passwords in plain text is activated. You should never set this unless you know what you are doing" => "Store passwords in plain text is activated. You should never set this unless you know what you are doing",
// "Assign users to group function of email pattern" => "Assign users to group function of email pattern",
// "You must change the Authentication Method to LDAP for these changes to take effect" => "You must change the Authentication Method to LDAP for these changes to take effect",
// "LDAP Bind settings" => "LDAP Bind settings",
// "LDAP User" => "LDAP User",
// "LDAP Admin" => "LDAP Admin",
// "LDAP external groups" => "LDAP external groups",
// "LDAP Group" => "LDAP Group",
// "LDAP Group Member - if group membership can be found in group attributes" => "LDAP Group Member - if group membership can be found in group attributes",
// "LDAP User Group - if group membership can be found in user attributes" => "LDAP User Group - if group membership can be found in user attributes",
"PAM" => "PAM",
// "You must change the Authentication Method to PAM for these changes to take effect" => "You must change the Authentication Method to PAM for these changes to take effect",
// "Shibboleth Authentication " => "Shibboleth Authentication ",
// "You must change the Authentication Method to Shibboleth for these changes to take effect" => "You must change the Authentication Method to Shibboleth for these changes to take effect",
// "CAS" => "CAS",
// "You must change the Authentication Method to CAS for these changes to take effect" => "You must change the Authentication Method to CAS for these changes to take effect",
// "CAS Server" => "CAS Server",
// "CAS Server Name" => "CAS Server Name",
// "CAS Server Port" => "CAS Server Port",
// "CAS Server Path" => "CAS Server Path",
// "phpBB User Database Authentication " => "phpBB User Database Authentication ",
// "You must change the Authentication Method to phpBB for these changes to take effect" => "You must change the Authentication Method to phpBB for these changes to take effect",
// "You must turn Users can register off for phpBB Authentication to function properly" => "You must turn Users can register off for phpBB Authentication to function properly",
// "MySql only (for now)" => "MySql only (for now)",
// "Web Server Authentication " => "Web Server Authentication ",
// "You must change the Authentication Method to Web Server for these changes to take effect" => "You must change the Authentication Method to Web Server for these changes to take effect",
// "Theme Screenshot" => "Theme Screenshot",
// "The \"users can change theme\" feature will override the theme displayed" => "The \"users can change theme\" feature will override the theme displayed",
// "Theme not saved yet - click \"Apply\"" => "Theme not saved yet - click \"Apply\"",
"Restrict available themes" => "Restringeix els temes d'estètica disponibles",
"General Layout" => "Disposició General",
// "&quot;Modules&quot; are the items of content at the top &amp; bottom and in the right &amp; left columns of the site" => "&quot;Modules&quot; are the items of content at the top &amp; bottom and in the right &amp; left columns of the site",
// "Admin &gt; Modules" => "Admin &gt; Modules",
// "from the menu to create and edit modules" => "from the menu to create and edit modules",
// "Module zone visibility" => "Module zone visibility",
"Site Report Bar" => "Barra d'Informes del Lloc",
// "Pagination" => "Pagination",
// "UI Effects" => "UI Effects",
// "Standard UI effects" => "Standard UI effects",
// "Tab UI effects" => "Tab UI effects",
// "Customization" => "Customization",
// "Open editor" => "Open editor",
// "Preview Theme" => "Preview Theme",
// "Custom Codes" => "Custom Codes",
// "Experimental: CSS assistant (work in progress - click the x to remove)" => "Experimental: CSS assistant (work in progress - click the x to remove)",
"Editing" => "Editant",
"View Templates" => "Visualitza les plantilles",
"Admin layout per section" => "Administra formats per seccions",
// "Favicon" => "Favicon",
// "Context Menus" => "Context Menus",
// "Currently used in File Galleries only" => "Currently used in File Galleries only",
// "Separators" => "Separators",
// "MapServer settings" => "MapServer settings",
"Generate User Map" => "Genera Mapa d'usuaris",
// "See also" => "See also",
// "Search Engine Friendly URLs" => "Search Engine Friendly URLs",
// "Meta tags" => "Meta tags",
// "Geo URL" => "Geo URL",
"Robots" => "Robots",
// "Configure metrics" => "Configure metrics",
// "Show past results" => "Show past results",
// "Past results count" => "Past results count",
// "{\$crumbs[\$crumb]->description}" => "{\$crumbs[\$crumb]->description}",
// "If you lose your login module, use tiki-login_scr.php to be able to login" => "If you lose your login module, use tiki-login_scr.php to be able to login",
// "Payments" => "Payments",
// "Choose payment system" => "Choose payment system",
// "You can use only one payment method: PayPal or Cclite or Tiki User Credits" => "You can use only one payment method: PayPal or Cclite or Tiki User Credits",
// "PayPal is working at the moment. See PayPal.com" => "PayPal is working at the moment. See PayPal.com",
// "Cclite: Community currency accounting for local exchange trading systems (LETS). See " => "Cclite: Community currency accounting for local exchange trading systems (LETS). See ",
// "sourceforge.net" => "sourceforge.net",
// "Tiki User Credits: Requires this other feature to be configured" => "Tiki User Credits: Requires this other feature to be configured",
// "Cclite is for creating and managing alternative or complementary trading currencies and groups" => "Cclite is for creating and managing alternative or complementary trading currencies and groups",
// "Work in progress since Tiki 6" => "Work in progress since Tiki 6",
// "Advanced Shopping Cart" => "Advanced Shopping Cart",
// "Advanced Cart Tracker Names Setup" => "Advanced Cart Tracker Names Setup",
// "Products Tracker Setup" => "Products Tracker Setup",
// "Depending on which feature you are using, you may need some or all of the following fields to be setup" => "Depending on which feature you are using, you may need some or all of the following fields to be setup",
// "Shipping" => "Shipping",
// "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Performance page</a> on Tiki's developer site" => "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Performance page</a> on Tiki's developer site",
"Performance" => "Rendiment",
// "Output compression is active" => "Output compression is active",
// "Compression is handled by" => "Compression is handled by",
// "Bytecode Cache" => "Bytecode Cache",
// "Using <strong>%0</strong>.These stats affect all PHP applications running on the server" => "Using <strong>%0</strong>.These stats affect all PHP applications running on the server",
// "Configuration setting <em>xcache.admin.enable_auth</em> prevents from accessing statistics. This will also prevent the cache from being cleared when clearing template cache" => "Configuration setting <em>xcache.admin.enable_auth</em> prevents from accessing statistics. This will also prevent the cache from being cleared when clearing template cache",
// "Available" => "Available",
"Memory" => "Memòria",
// "Miss" => "Miss",
"Hit" => "Cop",
// "Cache Hits" => "Cache Hits",
// "Memory Used" => "Memory Used",
// "Misses" => "Misses",
// "Few hits recorded. Statistics may not be representative" => "Few hits recorded. Statistics may not be representative",
// "Low hit ratio. %0 may be misconfigured and not used" => "Low hit ratio. %0 may be misconfigured and not used",
// "Little memory available. Thrashing likely to occur" => "Little memory available. Thrashing likely to occur",
// "The values to increase are apc.shm_size (for APC) or xcache.size (for XCache)" => "The values to increase are apc.shm_size (for APC) or xcache.size (for XCache)",
// "Small amount of memory allocated to %0. Verify the configuration" => "Small amount of memory allocated to %0. Verify the configuration",
// "Configuration <em>%0</em> is enabled. Disabling modification checks can improve performance, but will require manual clear on file updates" => "Configuration <em>%0</em> is enabled. Disabling modification checks can improve performance, but will require manual clear on file updates",
// "<em>%0</em> should not be disabled due to authentication on XCache" => "<em>%0</em> should not be disabled due to authentication on XCache",
// "Bytecode cache is not used. Using a bytecode cache (APC, XCache, WinCache) is highly recommended for production environments" => "Bytecode cache is not used. Using a bytecode cache (APC, XCache, WinCache) is highly recommended for production environments",
// "Major slow down" => "Major slow down",
// "These are reported to slow down Tiki. If you have a high-volume site, you may want to deactivate them" => "These are reported to slow down Tiki. If you have a high-volume site, you may want to deactivate them",
// "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\">Search admin panel</a>" => "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\">Search admin panel</a>",
"To add/remove polls, look for \"Polls\" under \"Admin\" on the application menu, or" => "Per afegir/eliminar consultes, cerca \"Consultes\" dins d'\"Admin\" en el menú principal de l'aplicació, o",
// "Loading profile" => "Loading profile",
// "Are you sure you want to apply the profile" => "Are you sure you want to apply the profile",
// "Are you sure you want to re-apply the profile" => "Are you sure you want to re-apply the profile",
// "Sending" => "Sending",
"Waiting" => "Esperant",
// "Tiki Configuration Profiles" => "Tiki Configuration Profiles",
"The following list of changes has been applied" => "S'ha aplicat la següent llista de canvis",
// "Apply Profiles" => "Apply Profiles",
// "Configure Tiki in 3 easy steps using Profiles" => "Configure Tiki in 3 easy steps using Profiles",
// "A Friendly Warning" => "A Friendly Warning",
// "Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles" => "Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles",
"Profiles" => "Perfils",
// "Step 1: Use the Quick or Manual Filter option to see a list of Configuration Profiles you can apply" => "Step 1: Use the Quick or Manual Filter option to see a list of Configuration Profiles you can apply",
// "Option 1: Quick Filter" => "Option 1: Quick Filter",
// "Option 2: Manual Filter" => "Option 2: Manual Filter",
// "Featured Profiles is a list of applications that are maintained by the Tiki community and are a great way to get started" => "Featured Profiles is a list of applications that are maintained by the Tiki community and are a great way to get started",
// "Full Profiles" => "Full Profiles",
// "Full Profiles are full featured out of the box solutions" => "Full Profiles are full featured out of the box solutions",
// "Mini Profiles" => "Mini Profiles",
// "Mini Profiles will configure specific features and are a great way to add more functionality to an existing configuration" => "Mini Profiles will configure specific features and are a great way to add more functionality to an existing configuration",
// "Learning Profiles" => "Learning Profiles",
// "Learning Profiles will allow you to quickly evaluate specific features in Tiki" => "Learning Profiles will allow you to quickly evaluate specific features in Tiki",
// "Filter the list of profiles" => "Filter the list of profiles",
// "Profile name" => "Profile name",
// "Profile types" => "Profile types",
// "Repository" => "Repository",
// "Step 2: Click on a Configuration Profile Name below to review it and to be able to apply it on your Web site" => "Step 2: Click on a Configuration Profile Name below to review it and to be able to apply it on your Web site",
// "Profile type" => "Profile type",
// "applied" => "applied",
// "Profile repository" => "Profile repository",
"Last update" => "Última actualització",
"Refresh" => "Refrescar",
// "JavaScript must be turned <strong>ON</strong> in order to apply Profiles. Please enable your JavaScript and try again" => "JavaScript must be turned <strong>ON</strong> in order to apply Profiles. Please enable your JavaScript and try again",
// "Export YAML" => "Export YAML",
"Object type:" => "Tipus d'objecte:",
"Modules" => "Mòduls",
// "Export modified preferences as YAML" => "Export modified preferences as YAML",
// "Toggle Visible" => "Toggle Visible",
// "Show added preferences" => "Show added preferences",
// "no default" => "no default",
// "Repositories" => "Repositories",
// "Profile tester" => "Profile tester",
// "Paste or type wiki markup and YAML (with or without the {literal}{CODE}{/literal} tags) into the text area below" => "Paste or type wiki markup and YAML (with or without the {literal}{CODE}{/literal} tags) into the text area below",
// "This will run the profile and make potentially unrecoverable changes in your database" => "This will run the profile and make potentially unrecoverable changes in your database",
// "Test Profile Name" => "Test Profile Name",
// "Global configuration" => "Global configuration",
// "Cache duration" => "Cache duration",
"Create New" => "Crear nou",
// "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use the <strong>Admin</strong> &gt; <strong>External Feeds</strong> menu option, or" => "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use the <strong>Admin</strong> &gt; <strong>External Feeds</strong> menu option, or",
// "External feeds" => "External feeds",
"Feeds" => "Alimentacions",
// "Feed for articles" => "Feed for articles",
// "Feed for blogs" => "Feed for blogs",
// "Feed for individual blogs" => "Feed for individual blogs",
// "Feed for image galleries" => "Feed for image galleries",
// "Feed for individual image galleries" => "Feed for individual image galleries",
// "Feed for file galleries" => "Feed for file galleries",
// "Feed for individual file galleries" => "Feed for individual file galleries",
// "Feed for wiki pages (with diff)" => "Feed for wiki pages (with diff)",
// "Feed for wiki pages (no diff)" => "Feed for wiki pages (no diff)",
// "Feed for forums" => "Feed for forums",
// "Feed for individual forums" => "Feed for individual forums",
// "Feed for trackers" => "Feed for trackers",
// "Feed for calendars" => "Feed for calendars",
"Feed for directories" => "Contingut per als directoris",
// "Feed for shoutbox" => "Feed for shoutbox",
"You can see users rank by score in the module users_rank, for that go to" => "Pots veure un ranking d'usuaris per puntuació en el mòdul de ranking d'usuaris (users_rank); si t'interessa, ves a",
"Admin modules" => "Admin moòuls",
"Expiration" => "Caducitat",
// "{\$events[e].category}" => "{\$events[e].category}",
// "{\$events[e].description}" => "{\$events[e].description}",
"can be seen on page" => "pot ser vist a la pàgina",
"in Admin menu" => "al menú d'Administració",
// "Also see the Search Indexing tab here" => "Also see the Search Indexing tab here",
// "File Gallery admin panel" => "File Gallery admin panel",
// "Basic Search" => "Basic Search",
// "Advanced Search" => "Advanced Search",
// "Search Engine Settings" => "Search Engine Settings",
// "Index maintenance" => "Index maintenance",
// "Optimize" => "Optimize",
// "From the command line" => "From the command line",
// "Log rebuild" => "Log rebuild",
// "Log file is saved as temp/Search_Indexer.log" => "Log file is saved as temp/Search_Indexer.log",
// "Indexation" => "Indexation",
// "Queue size" => "Queue size",
"Process" => "Procés",
// "Uses JavaScript to reload this page until queue is processed" => "Uses JavaScript to reload this page until queue is processed",
// "Forum searches" => "Forum searches",
// "Search Results" => "Search Results",
// "Select the items to display on the search results page" => "Select the items to display on the search results page",
// "Select the information to display for each result" => "Select the information to display for each result",
// "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Security'>Security page</a> on Tiki's developer site" => "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Security'>Security page</a> on Tiki's developer site",
// "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings" => "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings",
// "General Security" => "General Security",
"Please also see:" => "Si us plau, mira també:",
// "HTTPS (SSL) and other login preferences" => "HTTPS (SSL) and other login preferences",
// "CSRF Security" => "CSRF Security",
// "Use these options to protect against cross-site request forgeries (CSRF)" => "Use these options to protect against cross-site request forgeries (CSRF)",
// "Spam protection" => "Spam protection",
"Search results" => "Resultats de la cerca",
// "Tokens" => "Tokens",
// "To manage tokens go to <a href=\"tiki-admin_tokens.php\">Admin Tokens</a> page" => "To manage tokens go to <a href=\"tiki-admin_tokens.php\">Admin Tokens</a> page",
// "Clipperz online password management" => "Clipperz online password management",
// "Tiki doesn't offer a built-in password management feature" => "Tiki doesn't offer a built-in password management feature",
// "Learn more about Clipperz" => "Learn more about Clipperz",
// "Meta-tags" => "Meta-tags",
// "SEFURL requires the <strong>URL Rewrite module</strong> for IIS. You do not seem to have this module installed" => "SEFURL requires the <strong>URL Rewrite module</strong> for IIS. You do not seem to have this module installed",
// "Please see <a href=\"http://doc.tiki.org/Windows+Server+Install\">Windows Server Install</a> on tiki.org for more information" => "Please see <a href=\"http://doc.tiki.org/Windows+Server+Install\">Windows Server Install</a> on tiki.org for more information",
// "SEFURL will not work unless Tiki specific directives are deployed to the %0 file" => "SEFURL will not work unless Tiki specific directives are deployed to the %0 file",
// "To enable this file, simply copy the %0 file (located in the main directory of your Tiki installation) to %1" => "To enable this file, simply copy the %0 file (located in the main directory of your Tiki installation) to %1",
// "If you need to keep an existing (non Tiki) %0 file, just add Tiki directives to it" => "If you need to keep an existing (non Tiki) %0 file, just add Tiki directives to it",
// "When you upgrade Tiki (e.g. from version 7 to version 8), make sure to make use of the new URL rewriting configuration file" => "When you upgrade Tiki (e.g. from version 7 to version 8), make sure to make use of the new URL rewriting configuration file",
// "%0 file is missing" => "%0 file is missing",
// "Unable to verify that your URL rewriting configuration is up to date" => "Unable to verify that your URL rewriting configuration is up to date",
// "SEFURL may not work completely or correctly if Tiki URL rewriting configuration is not current" => "SEFURL may not work completely or correctly if Tiki URL rewriting configuration is not current",
// "%0 is not in the expected format" => "%0 is not in the expected format",
// "%0 may simply be outdated" => "%0 may simply be outdated",
// "To update this file, if it was not customized, copy the %0 file (located in the main directory of your Tiki installation) to %1, overwriting the latter" => "To update this file, if it was not customized, copy the %0 file (located in the main directory of your Tiki installation) to %1, overwriting the latter",
// "%0 file is out of date" => "%0 file is out of date",
// "The RewriteBase directive seems not to be set up correctly. This is required for sefurl to function correctly" => "The RewriteBase directive seems not to be set up correctly. This is required for sefurl to function correctly",
// "The current value in %0 is %1 but the base url for this site is %2" => "The current value in %0 is %1 but the base url for this site is %2",
// "List of Url Parameters that should go in the path" => "List of Url Parameters that should go in the path",
// "Known Types" => "Known Types",
// "Token" => "Token",
// "Invert" => "Invert",
// "Show Usage" => "Show Usage",
// "Delete &amp; Unreference" => "Delete &amp; Unreference",
// "Invert Relation" => "Invert Relation",
// "New Types" => "New Types",
// "Fix" => "Fix",
// "No occurences found" => "No occurences found",
// "If you don't want to limit it, an input box will be displayed; otherwise, it will be checkbox" => "If you don't want to limit it, an input box will be displayed; otherwise, it will be checkbox",
// "Twitter Settings" => "Twitter Settings",
// "To use Twitter integration, you must register this site as an application at" => "To use Twitter integration, you must register this site as an application at",
// "and allow write access for the application" => "and allow write access for the application",
// "Enter &lt;your site URL&gt;tiki-socialnetworks.php as callback URL" => "Enter &lt;your site URL&gt;tiki-socialnetworks.php as callback URL",
// "Facebook Settings" => "Facebook Settings",
// "To use Facebook integration, you must register this site as an application at" => "To use Facebook integration, you must register this site as an application at",
// "and allow extended access for the application" => "and allow extended access for the application",
// "Enter &lt;your site URL&gt;tiki-socialnetworks.php?request_facebook as Site URL and &lt;your site&gt; as Site Domain" => "Enter &lt;your site URL&gt;tiki-socialnetworks.php?request_facebook as Site URL and &lt;your site&gt; as Site Domain",
// "The following preferences affect what permissions the user is asked to allow Tiki to do by Facebook when authorizing it" => "The following preferences affect what permissions the user is asked to allow Tiki to do by Facebook when authorizing it",
// "bit.ly Settings" => "bit.ly Settings",
// "There is no need to set up a site-wide bit.ly account; every user can have his or her own, but this allows for site-wide statistics" => "There is no need to set up a site-wide bit.ly account; every user can have his or her own, but this allows for site-wide statistics",
"Go to" => "Ves a",
// "to sign up for an account" => "to sign up for an account",
// "to retrieve the API key" => "to retrieve the API key",
"Text area (that apply throughout many features)" => "Àrea de text (que té aplicació a través de moltes funcions)",
"Wiki syntax" => "Sintaxi Wiki",
// "Default size" => "Default size",
// "External links and images" => "External links and images",
// "External links will be identified with" => "External links will be identified with",
// "About plugins" => "About plugins",
// "Tiki plugins add functionality to wiki pages, articles, blogs, and so on. You can enable and disable them below" => "Tiki plugins add functionality to wiki pages, articles, blogs, and so on. You can enable and disable them below",
// "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>" => "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>",
// "The edit-plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below" => "The edit-plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below",
// "Check disabled plugins used in wiki pages" => "Check disabled plugins used in wiki pages",
// "Disabled used plugins" => "Disabled used plugins",
// "Plugin preferences" => "Plugin preferences",
// "Edit plugin icons" => "Edit plugin icons",
// "Disable edit plugin icon (make plugin inline)" => "Disable edit plugin icon (make plugin inline)",
"Plugin Aliases" => "Aliases de connectors (Plugins)",
// "About plugin aliases" => "About plugin aliases",
// "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}" => "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}",
// "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}" => "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}",
// "Available Alias" => "Available Alias",
// "Enable Plugins" => "Enable Plugins",
// "Delete Plugins" => "Delete Plugins",
// "Click on the plugin name to edit it" => "Click on the plugin name to edit it",
// "Click on the + icon to add a new one" => "Click on the + icon to add a new one",
// "General Information" => "General Information",
// "Plugin Name" => "Plugin Name",
// "Base Plugin" => "Base Plugin",
"Name:" => "Nom:",
"Description:" => " Descripció",
// "Body Label" => "Body Label",
// "Dependencies" => "Dependencies",
// "Inline (No Plugin Edit UI)" => "Inline (No Plugin Edit UI)",
// "Simple Plugin Arguments" => "Simple Plugin Arguments",
// "Argument" => "Argument",
// "New Argument" => "New Argument",
// "Plugin Parameter Documentation" => "Plugin Parameter Documentation",
"Required" => "Requerit",
// "Safe" => "Safe",
// "Plugin Body" => "Plugin Body",
// "Ignore User Input" => "Ignore User Input",
// "Default Content" => "Default Content",
// "Encoding" => "Encoding",
// "Argument Source (if different)" => "Argument Source (if different)",
// "Default Value" => "Default Value",
// "Composed Plugin Arguments" => "Composed Plugin Arguments",
// "Pattern" => "Pattern",
// "To configure your trackers, select \"Trackers\" in the application menu, or" => "To configure your trackers, select \"Trackers\" in the application menu, or",
// "Tracker settings" => "Tracker settings",
// "Tracker attachment preferences" => "Tracker attachment preferences",
"Use database to store files" => "Empra la base de dades per desar arxius",
"Use a directory to store files" => "Empra un directori per desar arxius",
// "Field Types" => "Field Types",
// "Tracker attachments" => "Tracker attachments",
"dls" => "baixades",
// "Switch storage" => "Switch storage",
"Change all to db" => "Canvia-ho tot a base de dades",
"Change all to file" => "Canvia-ho tot a arxius",
"Use database to store userfiles" => "Utilitza una base de dades per emmagatzemar les dades dels usuaris",
"Use a directory to store userfiles" => "Utilitza un directori per emmagatzemar les dades dels usuaris",
// "Kaltura" => "Kaltura",
// "Kaltura Registration" => "Kaltura Registration",
// "To get a Kaltura Partner ID" => "To get a Kaltura Partner ID",
// "Setup your own instance of Kaltura Community Edition (CE)" => "Setup your own instance of Kaltura Community Edition (CE)",
// "get an account via Kaltura.com" => "get an account via Kaltura.com",
// "List Media Entries" => "List Media Entries",
// "List Remix Entries" => "List Remix Entries",
// "Add New Media" => "Add New Media",
// "Kaltura / Tiki config" => "Kaltura / Tiki config",
// "Kaltura Partner Settings" => "Kaltura Partner Settings",
// "Kaltura Dynamic Player" => "Kaltura Dynamic Player",
// "Kaltura Contribution Wizard" => "Kaltura Contribution Wizard",
// "Kaltura Remix Editors" => "Kaltura Remix Editors",
// "Ustream Watershed" => "Ustream Watershed",
// "Ustream Watershed Registration" => "Ustream Watershed Registration",
// "If you don't have a Watershed account, " => "If you don't have a Watershed account, ",
// "you can find out more about it here" => "you can find out more about it here",
// "Configuration within Watershed" => "Configuration within Watershed",
// "Set the webservice to point to tiki-watershed_service.php on your site, and turn on Authentication Lock" => "Set the webservice to point to tiki-watershed_service.php on your site, and turn on Authentication Lock",
// "Watershed Wiki plugins" => "Watershed Wiki plugins",
// "Use Wiki plugins WatershedBroadcaster, WatershedViewer and WatershedChat to embed your broadcaster, viewer or chat" => "Use Wiki plugins WatershedBroadcaster, WatershedViewer and WatershedChat to embed your broadcaster, viewer or chat",
// "Basic tracker settings" => "Basic tracker settings",
// "Information for each channel is stored in a tracker. Tracker item view/modify permissions will determine which channels users will be able to view or broadcast to respectively. You can find the Brand Id and Channel Code from the embed codes provided by Watershed, looking for the cid variable which will be \"brandId%2Fchannelcode\"" => "Information for each channel is stored in a tracker. Tracker item view/modify permissions will determine which channels users will be able to view or broadcast to respectively. You can find the Brand Id and Channel Code from the embed codes provided by Watershed, looking for the cid variable which will be \"brandId%2Fchannelcode\"",
// "Archive settings" => "Archive settings",
// "Information on archived clips are stored in a tracker. Tracker item view permissions will determine which archives users will be able to view. Note that recordings set to private in the broadcaster are not added to Tiki. Also, there is a delay for information to be received which could be quite long (30 min)" => "Information on archived clips are stored in a tracker. Tracker item view permissions will determine which archives users will be able to view. Note that recordings set to private in the broadcaster are not added to Tiki. Also, there is a delay for information to be received which could be quite long (30 min)",
// "Archive settings (optional)" => "Archive settings (optional)",
// "Flash Media Encoder" => "Flash Media Encoder",
// "This is only needed if you are using Flash Media Encoder for higher-quality broadcasting which support only shared secret authentication" => "This is only needed if you are using Flash Media Encoder for higher-quality broadcasting which support only shared secret authentication",
// "Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used" => "Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used",
"URL:" => "URL:",
// "Parameters (%name%)" => "Parameters (%name%)",
"Operation" => "Operació",
// "Lookup" => "Lookup",
// "{\$url} requires no parameter" => "{\$url} requires no parameter",
// "Test Input" => "Test Input",
// "Response Information" => "Response Information",
// "OIntegrate Version" => "OIntegrate Version",
// "Not supported" => "Not supported",
// "Schema Version" => "Schema Version",
// "Schema Documentation" => "Schema Documentation",
"Cache" => "Memòria cau",
// "Not specified, default used" => "Not specified, default used",
// "Content Type" => "Content Type",
// "Not specified" => "Not specified",
// "Returned Data" => "Returned Data",
// "Proposed Templates" => "Proposed Templates",
// "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters" => "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters",
// "Register Service" => "Register Service",
// "Registered Templates" => "Registered Templates",
// "Engine" => "Engine",
// "Output" => "Output",
// "Register Template" => "Register Template",
// "The following pages were modified" => "The following pages were modified",
// "Nothing was changed (no images in wiki_up were found in Wiki pages)" => "Nothing was changed (no images in wiki_up were found in Wiki pages)",
// "Use the 'Quick Edit' module to easily create or edit wiki pages" => "Use the 'Quick Edit' module to easily create or edit wiki pages",
// "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules" => "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules",
// "Page display" => "Page display",
// "Page version" => "Page version",
"List authors" => "Llista autors",
// "Allow override per page" => "Allow override per page",
// "Minor edits do not flag new content for translation and do not send watch notifications (unless \"Watch minor edits\" is enabled)" => "Minor edits do not flag new content for translation and do not send watch notifications (unless \"Watch minor edits\" is enabled)",
// "Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled" => "Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled",
// "If you change storage, it is better to move all the files for easy backup.." => "If you change storage, it is better to move all the files for easy backup..",
// "Tag for current wiki" => "Tag for current wiki",
// "Restore wiki to tag" => "Restore wiki to tag",
// "Restore" => "Restore",
"Remove a tag" => "Elimina una etiqueta",
"Generate dump" => "Generar volcat",
"Download last dump" => "Baixar darrer volcat",
"Remove unused pictures" => "Elimina fotos no emprades",
// "Move images from wiki_up to the home file gallery" => "Move images from wiki_up to the home file gallery",
// "If you use these buttons please make sure to have a backup of the database and the directory wiki_up" => "If you use these buttons please make sure to have a backup of the database and the directory wiki_up",
"Export Wiki Pages" => "Exporta Pàgines del Wiki",
// "Wiki watch" => "Wiki watch",
// "Flagged Revision" => "Flagged Revision",
// "Page Listings" => "Page Listings",
// "Configuration" => "Configuration",
// "Select which items to display when listing pages" => "Select which items to display when listing pages",
"Wiki 3D Browser Configuration" => "Configuració del Navegador Wiki 3D",
"Tools" => "Eines",
// "Mass search and replace" => "Mass search and replace",
"Wiki attachments" => "Adjuncions del Wiki",
"Change" => "Canvia",
// "WYSIWYG means What You See Is What You Get, and is handled in Tiki by <a href=\"http://ckeditor.com/\">CKEditor</a>" => "WYSIWYG means What You See Is What You Get, and is handled in Tiki by <a href=\"http://ckeditor.com/\">CKEditor</a>",
// "Page links" => "Page links",
// "Note that if the SEFURL feature is on, page links created using wysiwyg might not be automatically updated when pages are renamed. This is planned to be addressed through the future \"Use Wiki syntax in WYSIWYG\" feature" => "Note that if the SEFURL feature is on, page links created using wysiwyg might not be automatically updated when pages are renamed. This is planned to be addressed through the future \"Use Wiki syntax in WYSIWYG\" feature",
"Wysiwyg Editor Features" => "Funcionalitat d'Edició Wysiwyg",
// "Related features" => "Related features",
// "{\$sect|capitalize}" => "{\$sect|capitalize}",
"Position" => "Posició",
// "Topbar" => "Topbar",
// "Page Top" => "Page Top",
// "Page Bottom" => "Page Bottom",
"Cache Time" => "Temps en memòria cau",
"secs" => "segs",
"Use Ctrl+Click to select multiple options" => "Empra Ctrl+Click per a seleccionar multiples opcions",
// "The" => "The",
// "Display Modules to All Groups" => "Display Modules to All Groups",
// "setting will override your selection of specific groups" => "setting will override your selection of specific groups",
"Visibility" => "Visibilitat",
"Displayed now for all eligible users even with personal assigned modules" => "Mostrat ara per a tots els usuaris/es escollits inclós amb mòduls personalment assignats.",
"Displayed for the eligible users with no personal assigned modules" => "Mostrat per als usuaris/es escollits sense mòduls personalment no assignats",
"Displayed now, can't be unassigned" => "Mostrat ara, no es pot estar sense assignar",
"Not displayed until a user chooses it" => "No mostrat fins que l'usuari l'esculli",
// "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either" => "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either",
// "to make sure users will notice any newly assigned modules" => "to make sure users will notice any newly assigned modules",
"required" => "requerit",
// "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y" => "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y",
// "Enter the parameters in URL format, e.g. 'nobox=y&class=rbox-data'" => "Enter the parameters in URL format, e.g. 'nobox=y&class=rbox-data'",
// "Edit custom module" => "Edit custom module",
// "Non Advanced Search or Natural Search" => "Non Advanced Search or Natural Search",
// "The documents are returned sorted on relevance depending on order, proximity, frequency of terms. " => "The documents are returned sorted on relevance depending on order, proximity, frequency of terms. ",
// "Advanced Search or Boolean Search" => "Advanced Search or Boolean Search",
// "Default search behavior" => "Default search behavior",
// "By default, all search terms are <em>optional</em>" => "By default, all search terms are <em>optional</em>",
// "It behaves like an OR logic" => "It behaves like an OR logic",
// "Objects that contain the more terms are rated higher in the results and will appear first in their type" => "Objects that contain the more terms are rated higher in the results and will appear first in their type",
// "For example, <strong>wiki forum</strong> will find" => "For example, <strong>wiki forum</strong> will find",
// "objects that include both terms" => "objects that include both terms",
// "objects that include the term <strong>wiki</strong>" => "objects that include the term <strong>wiki</strong>",
// "objects that include the term <strong>forum</strong>" => "objects that include the term <strong>forum</strong>",
// "Requiring terms" => "Requiring terms",
// "Add a plus sign ( + ) before a term to indicate that the term <em>must</em> appear in results" => "Add a plus sign ( + ) before a term to indicate that the term <em>must</em> appear in results",
// "Example: <strong>+wiki forum</strong> will find objects containing at least <strong>wiki</strong>. Objects with both terms and many occurences of the terms will appear first" => "Example: <strong>+wiki forum</strong> will find objects containing at least <strong>wiki</strong>. Objects with both terms and many occurences of the terms will appear first",
// "Excluding terms" => "Excluding terms",
// "Add a minus sign ( - ) before a term to indicate that the term <em>must not</em> appear in the results" => "Add a minus sign ( - ) before a term to indicate that the term <em>must not</em> appear in the results",
// "To reduce a term's value without completely excluding it, <a href=\"#reducing\" title=\"{tr}Reducing a term's value" => "To reduce a term's value without completely excluding it, <a href=\"#reducing\" title=\"{tr}Reducing a term's value",
// "Example: <strong>-wiki forum</strong> will find objects that do not contain <strong>wiki</strong> but contain <strong>forum</strong>" => "Example: <strong>-wiki forum</strong> will find objects that do not contain <strong>wiki</strong> but contain <strong>forum</strong>",
// "Grouping terms" => "Grouping terms",
// "Use parenthesis ( ) to group terms into subexpressions" => "Use parenthesis ( ) to group terms into subexpressions",
// "Example: <strong>+wiki +(forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order" => "Example: <strong>+wiki +(forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order",
// "Finding phrases" => "Finding phrases",
// "Use double quotes ( \" \" ) around a phrase to find terms in the exact order, exactly as typed" => "Use double quotes ( \" \" ) around a phrase to find terms in the exact order, exactly as typed",
// "Example: <strong>\"Alex Bell\"</strong> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong>. " => "Example: <strong>\"Alex Bell\"</strong> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong>. ",
// "Using wildcards" => "Using wildcards",
// "Add an asterisk ( * ) after a term to find objects that include the root word" => "Add an asterisk ( * ) after a term to find objects that include the root word",
// "For example, <strong>run*</strong> will find" => "For example, <strong>run*</strong> will find",
// "objects that include the term <strong>run</strong>" => "objects that include the term <strong>run</strong>",
// "objects that include the term <strong>runner</strong>" => "objects that include the term <strong>runner</strong>",
// "objects that include the term <strong>running</strong>" => "objects that include the term <strong>running</strong>",
// "Reducing a term's value" => "Reducing a term's value",
// "Add a tilde ( ~ ) before a term to reduce its value indicate to the ranking of the results" => "Add a tilde ( ~ ) before a term to reduce its value indicate to the ranking of the results",
// "Objects that contain the term will appear lower than other objects (unlike the <a href=\"#excluding\" title=\"{tr}Excluding terms" => "Objects that contain the term will appear lower than other objects (unlike the <a href=\"#excluding\" title=\"{tr}Excluding terms",
// "Example: <strong>+wiki ~forum</strong> will rate an object with only <strong>wiki</strong> higher that an object with <strong>wiki</strong> and  <strong>forum</strong>" => "Example: <strong>+wiki ~forum</strong> will rate an object with only <strong>wiki</strong> higher that an object with <strong>wiki</strong> and  <strong>forum</strong>",
// "Changing relevance value" => "Changing relevance value",
// "Add a less than ( &lt; ) or greater than ( &gt; ) sign before a term to change the term's contribution to the overall relevance value assigned to a object" => "Add a less than ( &lt; ) or greater than ( &gt; ) sign before a term to change the term's contribution to the overall relevance value assigned to a object",
// "Example: <strong>+wiki +(&gt;forum &lt; blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or <strong>wiki</strong> and <strong>blog</strong> in any order. <strong>wiki forum</strong> will be rated higher" => "Example: <strong>+wiki +(&gt;forum &lt; blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or <strong>wiki</strong> and <strong>blog</strong> in any order. <strong>wiki forum</strong> will be rated higher",
"Anti-Bot verification code image" => "Imatge del codi de verificació anti-robots",
"Enter the code you see above" => "Introdueix el codi que veus més amunt",
"Try another code" => "Prova amb un altre codi",
"Author:" => "Autor:",
// "Expires At" => "Expires At",
"star" => "estrella",
"half star" => "mitja estrella",
// "{\$topicName}" => "{\$topicName}",
"List all articles of this same topic" => "Llista tots els articles del mateix tema",
// "{\$topicName|escape}" => "{\$topicName|escape}",
// "{\$topics[\$topicId].name|escape}" => "{\$topics[\$topicId].name|escape}",
// "You do not have permission to read complete articles" => "You do not have permission to read complete articles",
"First page" => "Primera pàgina",
"Previous page" => "Pàgina anterior",
"page" => "pàgina",
"Next page" => "Pàgina següent",
"Last page" => "Última pàgina",
"Related content" => "Contingut relacionat",
"bytes" => "octets",
"Share page" => "Comparteix la pàgina",
"Share This" => "Comparteix això",
// "ShareThis via AIM, social bookmarking and networking sites, etc" => "ShareThis via AIM, social bookmarking and networking sites, etc",
"Send a link" => "Envia un enllaç",
"List of attached files" => "Llista de fitxers adjunts",
"desc" => "descripció",
"uploaded" => "pujat/s",
"Upload file" => "Pujar un arxiu",
"Comment:" => "Comentari:",
"Attach" => "Adjunció",
"Attach a file to this item" => "Afegeix un fitxer a aquest ítem",
// "{\$attfields[ix]}" => "{\$attfields[ix]}",
"more info" => "més informació",
"No attachments for this item" => "No hi ha afegits per a aquest ítem",
"debug" => "depurador",
"Fatal error" => "Error fatal",
"Save to notepad" => "Guardar al bloc de notes",
"Published " => "Publicat ",
"on" => "en",
"Previous post" => "Publicació prèvia",
"Next post" => "Publicació següent",
"Read more" => "Llegeix més",
"More..." => "Més...",
"pages" => "pàgines",
"Permalink" => "Enllaç de Permanència",
"Leave a comment" => "Deixa un comentari",
"%0 comment" => "%0 comentari",
"%0 comments" => "%0 comentaris",
"Parent Gallery" => "Galeria mare",
"Properties" => "Propietats",
"Click Here to Insert in Wiki Syntax" => "Clica aquí per a inserir amb sintaxi Wiki",
"No records found" => "No es trobaren registres",
"Category:" => "Categoria:",
"Select Categories" => "Selecciona Categories",
"Admin Categories" => "Administrar categories",
"Select/deselect all categories" => "Selecciona/deselecciona totes les categories",
"No categories defined" => "No hi ha categories definides",
"Browse Category" => "Navega per les categories",
// "Are you sure you want to archive this comment" => "Are you sure you want to archive this comment",
// "Are you sure you want to unarchive this comment" => "Are you sure you want to unarchive this comment",
// "Return" => "Return",
"Title:" => "Títol:",
// "Do you really want to lock comments" => "Do you really want to lock comments",
"Lock" => "Bloquejar",
// "Do you really want to unlock comments" => "Do you really want to unlock comments",
"Unlock" => "Desbloquejar",
// "Are you sure you want to remove this comment" => "Are you sure you want to remove this comment",
"Unarchive" => "Desarxiva",
// "Are you sure you want to approve this comment" => "Are you sure you want to approve this comment",
"Approve" => "Aprovar",
// "Are you sure you want to reject this comment" => "Are you sure you want to reject this comment",
"Reject" => "Rebutja",
"Comment posted by %0 on %1" => "Comentari publicat per %0 el %1",
"Reply" => "Respon",
"No comments" => "Sense comentaris",
"There are no comments at this time" => "No hi ha comentaris ara mateix",
"Post new comment" => "Publica un comentari nou",
"Add Comment" => "Afegeix un comentari",
// "Are you sure you want to lock comments on this object" => "Are you sure you want to lock comments on this object",
"Your comment was posted" => "S'ha publicat el teu comentari",
"Identity" => "Identitat",
// "You are currently registered on this site. This section is <strong>optional</strong>. By filling it, you will not link this post to your account and preserve your anonymity" => "You are currently registered on this site. This section is <strong>optional</strong>. By filling it, you will not link this post to your account and preserve your anonymity",
"Pseudonym" => "Pseudònim",
"Email:" => "Correu-e:",
"Website" => "Lloc web",
// "Are you sure you want to unlock comments on this object" => "Are you sure you want to unlock comments on this object",
"Posted by" => "Publicat per",
"posts:" => "publicacions:",
"stars" => "estels",
"User Level" => "Nivell d'usuari/a",
"private message" => "missatge privat",
"Send eMail to User" => "Enviar email a usuari",
"user online" => "usuari/a en línia",
"user offline" => "usuari/a fora de línia",
"top of page" => "dalt de la pàgina",
"Report this post" => "Informa d'aquesta publicacó",
"Monitor this Topic" => "Segueix aquest tema",
"Stop Monitoring this Topic" => "Deixa de seguir aquest tòpic",
"Group Monitor" => "Subscriu a grups sencers d'usuaris",
"Watched by categories" => "Vigilat per categories",
"Moderator actions" => "Accions del moderador",
"reported:" => "reportat:",
"queued:" => "a la cua:",
"Move to topic:" => "Moure al tema:",
"Delete Selected" => "Esborrar seleccionats",
"Sort:" => "Ordena:",
"Threshold" => "Llindar mínim",
"Replies" => "Respostes",
"below your current threshold" => "sota el teu llindar actual",
"New Reply" => "Resposta nova",
"Editing reply" => "Editant la resposta",
"Reply to the selected post" => "Respon a la publicació seleccionada",
"Post new message" => "Publica un nou missatge",
"If you would like to be notified when someone replies to this topic<br />please tell us your e-mail address" => "Si vols ser notificat/da quan alguna persona respongui a aquest tema<br />indican'ns la teva adreça de correu-e, si us plau",
"Send me an e-mail when someone replies" => "Envia'm un correu-e quan algú respongui",
"Maximum size" => "Mida màxima",
"Reply to parent post" => "Respon a la publicació original",
"Post new reply" => "Publica una resposta nova",
"Post as Anonymous" => "Publica-ho anònimament",
"Please note that the preview does not keep the attached file which you will have to choose before posting" => "Si us plau, tingues present que en previsualitzar no es manté l'arxiu adjunt i l'hauràs de seleccionar abans de publicar definitivament",
"Posting replies" => "Publicant respostes",
"Please enter a title" => "Si us plau, introdueix un títol",
"1 comment" => "1 comentari",
"Go back" => "Tornar Enrera",
"Return to home page" => "Torna a la pàgina d'inici",
"Type of contribution:" => "Tipus de contribució:",
"Copyrights" => "Copyrights",
"Year:" => "Any:",
"Authors:" => "Autors:",
"System error" => "Error del sistema",
// "Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue" => "Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue",
// "If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation" => "If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation",
// "The query was" => "The query was",
// "The built query was likely" => "The built query was likely",
// "Stacktrace" => "Stacktrace",
// "Tiki is unable to connect to the database" => "Tiki is unable to connect to the database",
// "An error occurred while performing the request" => "An error occurred while performing the request",
"Current URL" => "Actual URL",
"Command" => "Comanda",
"exec" => "executa",
"Type <code>help</code> to get list of available commands" => "Escriu <code>help</code> (ajuda) per obtenir una llista de les comandes disponibles",
"Syntax" => "Sintaxi",
"Page generation debugging log" => "Pagina generadora del registre de depuració",
"Features state" => "Estat de les característiques",
"Total" => "Total",
"features matched" => "característiques coincidents",
"Watchlist" => "Llista de coses vigilades",
"Duplicate File Gallery" => "Duplica la galeria d'arxius",
"File gallery" => "Galeria d'Arxius",
"Duplicate categories" => "Duplica les categories",
// "Duplicate permissions" => "Duplicate permissions",
"Duplicate" => "Duplica",
"There are individual permissions set for this file gallery" => "Existeixen permisos fixats individualment per a aquesta galeria de fitxers",
"View inserted gallery" => "Visualitza la galeria inserida",
// "{\$gal_info.name}" => "{\$gal_info.name}",
"System" => "Sistema",
// "Other (%0)" => "Other (%0)",
"Any file" => "Qualsevol Arxiu",
// "Podcast (audio)" => "Podcast (audio)",
// "Podcast (video)" => "Podcast (video)",
// "Gallery is visible to non-admin users" => "Gallery is visible to non-admin users",
// "Gallery is public" => "Gallery is public",
// "Any user with permission (not only the gallery owner) can upload files" => "Any user with permission (not only the gallery owner) can upload files",
// "Perms of the backlinks are checked to view a file" => "Perms of the backlinks are checked to view a file",
// "Files can be locked at download" => "Files can be locked at download",
"Maximum number of archives for each file" => "Nombre màxim d'arxius per a cada fitxer",
"Use" => "Ús",
"unlimited" => "sense límit",
"Parent gallery" => "Galeria mare",
"Owner of the gallery" => "Propietari de la galeria",
// "Min" => "Min",
// "Group of users alerted when file gallery is modified" => "Group of users alerted when file gallery is modified",
// "Allows to select each user for small groups" => "Allows to select each user for small groups",
// "Maximum width for images in gallery" => "Maximum width for images in gallery",
// "If an image is wider than this, it will be resized" => "If an image is wider than this, it will be resized",
// "Attention: In this case, the original image will be lost" => "Attention: In this case, the original image will be lost",
// "Maximum height for images in gallery" => "Maximum height for images in gallery",
// "If an image is higher than this, it will be resized" => "If an image is higher than this, it will be resized",
// "Wiki markup to enter when image selected from \"file gallery manager\"" => "Wiki markup to enter when image selected from \"file gallery manager\"",
// "The default is " => "The default is ",
// "Field names will be replaced when enclosed in % chars. e.g. %fileId%, %name%, %filename%, %description%" => "Field names will be replaced when enclosed in % chars. e.g. %fileId%, %name%, %filename%, %description%",
"Display Properties" => "Visualitza les propietats",
"Max description display size" => "Tamany màxim de la mostra de descripció",
// "Max rows per page" => "Max rows per page",
// "Select which items to display when listing galleries" => "Select which items to display when listing galleries",
// "File error" => "File error",
"Perhaps you are looking for:" => "Potser estaves cercant:",
"There are no wiki pages similar to '{\$page|escape}'" => "No hi ha pàgines wiki similars a '{\$page|escape}'",
// "Token Error" => "Token Error",
"Go to Log in Page" => "Ves a la Pàgina per Connectar-te",
// "Change them here" => "Change them here",
"Create this page" => "Crear aquest pàgina",
"(page will be orphaned)" => "(la pàgina es quedarà òrfena)",
"Close Window" => "Tanca Finestra",
// "Attached files" => "Attached files",
"Private Gallery" => "Galeria privada",
"Active Perms" => "Activar permisos",
"Perms" => "Perms",
"Open as WebFolder" => "Obre com a CarpetaWeb (webdav)",
// "Edit: " => "Edit: ",
// "Download current version" => "Download current version",
"Archives" => "Arxius",
"Upload New Version" => "Puja una nova versió",
// "Replace your draft" => "Replace your draft",
// "Upload your draft" => "Upload your draft",
// "Validate your draft" => "Validate your draft",
// "Delete your draft" => "Delete your draft",
"Download and lock" => "Descarrega i bloqueja",
// "Open your draft in WebDAV" => "Open your draft in WebDAV",
"Open in WebDAV" => "Obre a través de WebDAV",
"Share a link to this file" => "Comparteix un enllaç a aquest arxiu",
"Email a link to this file" => "Envia per correu-e un enllaç a aquest arxiu",
// "Enter the ID of any file in any gallery to be used as the icon for this gallery in browse view" => "Enter the ID of any file in any gallery to be used as the icon for this gallery in browse view",
// "The checkbox is disabled because this preference is disabled globally" => "The checkbox is disabled because this preference is disabled globally",
// "Please, enable the preference globally first" => "Please, enable the preference globally first",
// "You can ask your site Admin to enable the preference" => "You can ask your site Admin to enable the preference",
"Name-filename" => "Nom-nom del fitxer",
"Filename only" => "Només el nom del fitxer",
"Show as a column" => "Mostra-ho com una columna",
"Show in popup box" => "Mostra en requadre emergent",
"Show an icon in a column" => "Mostra una icona en una columna",
"Upload from URL" => "Puja des de URL",
"File added" => "S'ha afegit l'arxiu",
// "{\$file_backlinks_title}" => "{\$file_backlinks_title}",
"Start the Slideshow" => "Inicia el passi de diapositives",
"Pause the Slideshow" => "Pausael passi de diapositives",
"There are no images to display" => "No hi ha cap imatge per a ser mostrada",
"Search Help" => "Ajuda de la cerca",
"Any" => "Qualsevol",
"Deep search" => "Cerca profunda",
"Tags" => "Marques",
"Select Tags" => "Selecciona Marques (tags)",
// "Include objects without a specified language" => "Include objects without a specified language",
"Add to filter" => "Afegeix al filtre",
// "{\$whatlabel}" => "{\$whatlabel}",
"Find in" => "Troba a",
"Exact match" => "Ocurrència exacta",
"and all the sub-objects" => "i tots els subobjectes",
"any type" => "qualsevol tipus",
"any topic" => "qualsevol tòpic",
"any language" => "qualsevol idioma",
"not in" => "però no en",
"any category" => "qualsevol categoria",
"Multiple select" => "Selecció múltiple",
"in:" => "en:",
// "{\$value}" => "{\$value}",
// "{\$duration.label}" => "{\$duration.label}",
"Orphans" => "Òrfens/es",
// "{\$find_other}" => "{\$find_other}",
"Number of displayed rows" => "Nombre de columnes mostrades",
"Clear Filter" => "Clear Filter",
"Map View" => "Visualització en mapa",
"Show php error messages" => "Mostra missatges d'error php",
"Folksonomy Tags" => "Marcadors de folcsonomia",
"Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes" => "Posa marques separades per espais. Per a marques amb més d'una paraula, no empris espais i posa les paraules juntes o bé envolta-les per dobles cometes",
// "Folksonomy Language" => "Folksonomy Language",
// "Untag" => "Untag",
"Translate tags" => "Tradueix etiquetes",
"Images Galleries" => "Galeries d'Imatges",
"Edit this page" => "Edita aquesta pàgina",
"RSS Wiki" => "RSS del Wiki",
"RSS Blogs" => "RSS dels Blocs",
"RSS Articles" => "RSS dels Articles",
"RSS Image Galleries" => "RSS de les Galeries d'Imatges",
"RSS File Galleries" => "RSS de les Galeries d'Arxius",
"RSS Forums" => "RSS dels Fòrums",
"RSS Maps" => "RSS dels Mapes",
"RSS Directories" => "RSS dels Directoris",
"RSS Calendars" => "RSS dels Calendaris",
// "RSS Tracker" => "RSS Tracker",
"Interactive Translation" => "Traducció interactiva",
"Once checked, click on any string to translate it" => "Un cop seleccionada, clica sobre qualsevol cadena de text per traduir-la",
// "Couldn't find any translatable string" => "Couldn't find any translatable string",
"Save translations" => "Desa les traduccions",
"Changes will be applied on next page load only" => "S'aplicaran els canvis un cop carreguis la pàgina de nou",
"Show Tree" => "Mostra l'Arbre",
"Hide Tree" => "Amaga l'Arbre",
"Perform action with checked:" => "Amb els seleccionats, realitza l'acció:",
"Move Selected Files" => "Mou els arxius seleccionats",
"Are you sure you want to delete the selected files?" => "Segur que vols esborrar els següents arxius?",
// "Are you sure you want to reset the default gallery list table settings" => "Are you sure you want to reset the default gallery list table settings",
// "Reset to default gallery list table settings" => "Reset to default gallery list table settings",
"Download the zip" => "Descarrega el zip",
// "Assign permissions to file galleries" => "Assign permissions to file galleries",
"Move to" => "Mou a",
"Other Sorts" => "Altres ordenacions",
// "No Additional Sort" => "No Additional Sort",
"No information" => "No hi ha informació",
"Hi {\$mail_user|username} has sent you this link" => "Hola, {\$mail_user|username} t'ha enviat aquest enllaç",
"Blog post:" => "Publicació de bloc:",
"at:" => "a:",
// "Gift Certificate Information" => "Gift Certificate Information",
// "Percentage Discount" => "Percentage Discount",
// "Value of Gift Certificate" => "Value of Gift Certificate",
// "Redeem Code" => "Redeem Code",
// "Your Gift Certificate Purchase" => "Your Gift Certificate Purchase",
// "Your cart order has been received. Please note that orders are not finalized until payment has been made" => "Your cart order has been received. Please note that orders are not finalized until payment has been made",
// "You can review your order at" => "You can review your order at",
// "Your cart order" => "Your cart order",
"Somebody or you tried to subscribe this email address at our site:" => "Algú o vostè ha intentat subscriure la seva adreça email al nostre lloc:",
"To the newsletter:" => "Als butlletins de notícies:",
"In order to confirm your subscription you must access the following URL:" => "Per poder confirmar la teva subscripció hauries d'accedir a l'adreça (URL) següent:",
"To validate your account and login to the site, please click on the following link:" => "Per validar el teu compte i connectar-te al lloc, clica a l'enllaç següent, si us plau:",
"The administrator approved your account." => "L'administrador ha aprovat el teu compte.",
"Confirm your email at %s" => "Confirma el teu correu-e a %s",
"Remove file" => "Elimina l'arxiu",
// "GalleryId" => "GalleryId",
// "Identifier" => "Identifier",
"User:" => "Usuari/a:",
"A new message was posted to forum" => "Un nou missatge ha estat escrit al fòrum",
"New topic:" => "Tòpic nou:",
"An anonymous user" => "Un usuaria anònim",
"has posted a reply to a thread you're watching. \nYou can view the thread and reply at the following URL" => "ha publicat una reposta a un fil de debat al que estàs subscrit. \nPots veure el fil i la resposta a la següent adreça d'internet (URL)",
"You are invited by" => "Estàs convidat per",
"You join this group" => "T'apuntes a aquest grup",
"Join me on %s" => "Apunta'm a %s",
"You sent a request with the subject:" => "Has enviat una petició amb el tema:",
"Use the subject to indicate the operation to apply:" => "Utilitza l'assumpte per indicar quina operació s'ha d'aplicar:",
"GET:WikiName to get a wiki page" => "GET:NomWiki per obtenir una pàgina wiki",
"PUT:WikiName to update/create a wiki page (use the body for the page data)" => "PUT:NomWiki per actualitzar/crear una pàgina wiki (empra el cos per a les dades de la pàgina)",
"APPEND:WikiName to append data to a Wiki page (use the body for the data to add)" => "APPEND:NomWiki per afegir dades a una  pàgina Wiki (utilitza el cos per a les dades que vols afegir)",
"PREPEND:WikiName to append the data at the top" => "PREPEND:NomWiki per afegir les dades a sobre de tot",
"Tiki mail-in instructions" => "Intruccions de correu-dins del Tiki",
"Tiki mail-in auto-reply." => "Resposta automàtica del correu-dins de tiki.",
"Page not found:" => "Pàgina no trobada:",
"A new message was posted to you at {\$mail_machine}" => "Un nou missatge ha estat escrit per a tu per {\$mail_machine}",
"New message arrived from %s" => "T'ha arribat un missatge nou de %s",
"Hi" => "Hola",
"Your account registration request for {\$mail_site} was validated by the site admin and your account is active now." => "El teu registre de nou compte de Tiki per al lloc {\$mail_site} ha estat validat per la persona administradora del lloc i ara el teu compte ja és actiu.",
"To login with your username and password, please follow this link:" => "Per connectar-te amb el teu nom d'usuari i contrasenya, segueix aquest enllaç, si us plau:",
"Enjoy the site!" => "Disfruta del lloc!",
"User Account Activated" => "Compte d'usuari Tiki activat",
"{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first" => "{\$mail_user} <{\$mail_email}> ha demanat una nova contrassenya a {\$mail_site}, però primer has de validar el seu compte",
"has requested an account on" => "ha demanat un compte a",
"Group:" => "Grup:",
"User Tracker" => "Formulari-bd d'usuaris",
"To validate that account, please follow the link:" => "Per validar aquest compte, segueix aquest enllaç, si us plau:",
"Assign to a group" => "Assigna a un grup",
"View user's data" => "Visualitza les dades de l'usuari",
"Best regards" => "Records",
"User Registration Request" => "Petició de Registre d'Usuari",
"Go to your friendship network to accept or refuse this request" => "Ves a la teva xarxa d'amistat per acceptar o rebutjar aquesta petició",
"You're invited to join my network of friends!" => "Estàs convidat/da a unir-te a la meva xarxa d'amistats!",
"The user" => "L'usuari/a",
"registered at your site" => "registrat al seu lloc",
"New user registration" => "Registre d'usuari nou",
"Published" => "Publicada",
"By:" => "Per",
"Bye bye!" => "Adéu!",
"This email address has been removed to the list of subscriptors of:" => "Aquesta adreça de correu-e ha estat esborrada de la llista de subscriptors de:",
"Newsletter:" => "Butlletí:",
"Bye bye from %s at %s" => "Fins aviat, de %s en %s",
"You can unsubscribe from this newsletter following this link" => "Pots desubscriure't d'aquest butlletí seguint aquest enllaç",
"Welcome to our newsletter!" => "Benvingut/da al nostre butlletí!",
"This email address has been added to the list of subscriptors of:" => "Aquesta adreça de correu-e ha estat afegida a la llista de subscriptors de:",
"You can always cancel your subscription using:" => "Sempre pots cancel.lar la teva subscripció emprant:",
"Welcome to %s at %s" => "Benvingut/da %s  %s",
"Reply notification" => "Notificació de resposta",
"Email notification" => "Notificació de correu-e del Tiki",
"Someone" => "Alguna persona",
"requested a reminder of the password for your account" => "ha demanat un recordatori de la contrasenya del teu compte",
"requested password reset for your account" => "ha demanat que es posi una nova contrasenya per al teu compte",
"Since this is your registered email address we inform that the password for this account is" => "Com aquesta és la teva adreça registrada de correu-e, t'informem que la nova contrasenya per a aquest compte és",
"Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else" => "Si us plau, clica en el següent enllaç per confirmar que vols canviar la teva contrasenya i anar a la pantalla on hauràs d'introduir una contrasenya nova. Si us plau, escull una contrasenya que només sàpigues tu, i no la comparteixis amb altres persones",
"Important: Username & password are CaSe SenSitiVe" => "Important: el nom com a persona usuària i la contrasenya són sensibles a les Majúscules i minúscules",
"Important: The old password remains active if you don't click the link above." => "Important: La teva antiga contrasenya roman activa si no punxes sobre l'enllaç de més amunt.",
"Your account information for %s" => "La informació del teu compte Tiki per %s",
// "}Plugin %0 is pending approval on %1" => "}Plugin %0 is pending approval on %1",
// "tiki-plugins.php\"}See all the pending plugins in the <a href='%0'>plugin approval page</a>" => "tiki-plugins.php\"}See all the pending plugins in the <a href='%0'>plugin approval page</a>",
// "Plugin arguments" => "Plugin arguments",
// "Plugin body" => "Plugin body",
"Report for %0" => "Informe per a %0",
"Last Report sent on %0" => "Darrer Informe enviat el %0",
"Changes in detail" => "Canvis en detall",
"You are receiving notification emails grouped in a periodic digest. To receive them individually when posted instead, change your preferences at %0" => "Estàs rebent correus-e de notificació agrupats en un resum periòdic. Per a rebre'ls en canvi individualment tot just es publiquin, canvia les teves preferències a %0",
"Look at this link:" => "Mira aquest enllaç:",
"A friend sends you a link from: " => "Un amic t'envia un enllaç des de: ",
"A new article was submitted by {\$mail_user|username} to {\$mail_site} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "S'ha enviat una nova col·laboració d'article per {\$mail_user|username} a {\$mail_site} el {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"You can edit the submission following this link:" => "Pots editar l'enviament seguint aquest enllaç:",
"Heading:" => "Encapçalament:",
"Body:" => "Cos:",
"New article submitted at %s" => "Nou article enviat a %s",
"ItemID {\$mail_itemId} {\$mail_item_desc} was deleted in the tracker {\$mail_trackerName}" => "L'ItemID {\$mail_itemId} {\$mail_item_desc} ha estat esborrat a la base de dades de  {\$mail_trackerName}",
"New status for ItemID {\$mail_itemId} {\$mail_item_desc} for the tracker {\$mail_trackerName}" => "Hi ha un nou estatus per a l'ItemID {\$mail_itemId} {\$mail_item_desc} a la base de dades {\$mail_trackerName}",
"Download the file at:" => "Descarrega l'arxiu a:",
"item" => "ítem",
"was modified at" => "ha estat modificat a",
"Please visit this link before login again:" => "Si us plau, visita aquest enllaç abans de connectar-te de nou:",
"Last attempt" => "Darrer intent",
"Confirm your account at %s" => "Confirma el teu compte a %s",
"Site" => "Lloc",
// "Account suspended" => "Account suspended",
"An administrator of the site below has added you as a new user" => "Un administrador del lloc que diu més avall t'ha afegit com a nou/va usuari/a",
"If you want to confirm your membership in this site, click on the following link to login for the first time" => "Si vols confirmar que vols ser membres d'aquest lloc web, clica al següent enllaç per a connectar-te per primer cop",
"Your authentication credentials are" => "LEs teves credencials d'autenticació són",
"Welcome to the site!" => "Benvingut/da al lloc web",
"Your personal access to" => "El teu accés personal a",
// "joined the group" => "joined the group",
// "User joined group" => "User joined group",
"You or someone registered this email address at" => "tu o alguna persona ha registrat aquesta adreça de correu-e a",
"If you want to be a registered user in this site you will have to use the following link to login for the first time:" => "Si vols ser un usuari registrat en aquesta web hauràs de seguir aquest enllaç la primera vegada:",
"Your registration confirmation" => "El teu registre d'informació de Tiki",
"You will receive an email with the information needed to log into this site the first time" => "Rebràs un correu-e amb la informació necessària per a connectar-te per primer cop a aquest lloc web",
"Your account request has been stored and will be activated by the admin as soon as possible." => "La teva petició de compte ha estat arxivada i serà activada per la persona administradora tan aviat com li sigui possible.",
"You'll receive email notification once your account is activated." => "Rebràs notificació per correu-e un cop ja s'hagi activat el teu compte.",
"Please do not attempt to login until you receive the email notification." => "Si us plau, no intentis connectar-te fins que rebis la notificació per correu-e.",
"{\$mail_action} article post" => "{\$mail_action} article publicat",
"{\$mail_title} by {\$mail_user|username} at" => "{\$mail_title} per {\$mail_user|username} el",
"View the article at:" => "Visualitza l'article a:",
"If you don't want to receive these notifications follow this link:" => "Si no vols rebre aquestes notificacions segueix aquest enllaç:",
"Publish Date" => "Data de publicació",
"Expiration Date" => "Data de caducitat",
// "The old article follows" => "The old article follows",
// "{\$mail_action}" => "{\$mail_action}",
"article post at" => "article publicat a",
"New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "Nova publicació al bloc: {\$mail_title}, \"{\$mail_post_title}\", per {\$mail_user|username} el {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"View the blog at:" => "Visualitza el bloc a:",
"New blog post at %s" => "Nova publicació al bloc %s",
"View item calendar at:" => "Mostra l'entrada del calendari a:",
"Modified calendar item" => "Entrada del calendari modificada",
"New calendar item" => "Nova entrada al calendari",
"changed" => "modificat",
"A new category was created in" => "S'ha creat una nova categoria a",
"Created by:" => "Creat per:",
"created" => "creat",
"A category was removed in" => "S'ha eliminat una categoria a",
"Removed by" => "Eliminat per",
"removed" => "eliminat/da",
"A category was updated" => "S'ha actualitzat una categoria",
"Updated by" => "Actualitzat per",
"Old:" => "Antic:",
"updated" => "Actualitzat",
"The Wiki page {\$mail_objectname} was commented on by" => "La pàgina Wiki {\$mail_objectname} ha estat comentada per",
"an anonymous user" => "un usuari anònim",
"The article {\$mail_objectname} was commented on by" => "L'article {\$mail_objectname} ha estat comentat per ",
"The tracker item {\$mail_item_title} of tracker {\$mail_objectname} was commented on by" => "L'ítem {\$mail_item_title} del formulari-bd {\$mail_objectname} ha estat comentat per",
"You can view the comment by following this link" => "Pots veure el comentari en seguir aquest enllaç",
"File Gallery %s changed" => "La galeria d'arxius %s ha canviat",
"A file was removed from the file gallery" => "Es va eliminar un arxiu de la galeria d'arxius",
"A new file was posted to file gallery" => "S'ha pujat un nou arxiu a la galeria d'arxius",
"File Description" => "Descripció de l'arxiu",
"New forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "Nou tòpic de fòrum a <{\$mail_forum|truncate:20:\"...\"}> per {\$mail_author|username}",
"New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "Nova publicació al fòrum <{\$mail_forum|truncate:20:\"...\"}> per {\$mail_author|username}",
"Image Gallery {\$galleryName} changed" => "Ha canviat la galeria d'imatges {\$galleryName}",
"A new file was posted to image gallery" => "Un nou arxiu s'ha publicat a la galeria d'imatges",
// "The map {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The map {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"You can view the updated map following this link:" => "Pots veure el mapa actualitzat seguint aquest enllaç:",
"You can edit the map following this link:" => "Pots editar el mapa seguint aquest enllaç:",
"An object was added to category" => "S'ha afegit un nou objecte a la categoria",
"Added by" => "Afegit per",
"An object was removed from category" => "S'ha eliminat un nou objecte a la categoria",
"A page has been added to your watched sub-structure:" => "S'ha afegit una pàgina a la subestructura que estàs vigilant:",
"A page has been removed from your watched sub-structure:" => "S'ha afegit una pàgina a la subestructura que estàs vigilant:",
"A page has been promoted out your watched sub-structure:" => "S'ha mogut una pàgina fora de la subestructura que estàs vigilant:",
"A page has been demoted to your watched structure:" => "S'ha mogut una pàgina a la subestructura que estàs vigilant:",
"Structure modified" => "Estructura modificada",
// "has consulted your" => "has consulted your",
// "Go to the File Gallery" => "Go to the File Gallery",
// "Download the file" => "Download the file",
"A new file have been attached to page" => "S'ha adjuntat un nou arxiu a la pàgina",
"File name" => "Nom de l'arxiu",
"New attachment on %s, page" => "Adjunt nou a la pàgina %s,",
// "The page {\$mail_page} was created by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The page {\$mail_page} was created by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "The page {\$mail_page} was deleted by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The page {\$mail_page} was deleted by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"A file was attached to {\$mail_page}" => "S'ha afegit un nou arxiu a {\$mail_page}",
"The page {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "La pàgina {\$mail_page} ha estat canviada per {\$mail_user|username} el {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"The page {\$mail_page} was deleted but used to be here" => "La pàgina {\$mail_page} ha estat esborrada però solia ser aquí",
"You can view the page by following this link:" => "Pots veure la pàgina si segueixes aquest enllaç:",
"You can view a diff back to the previous version by following this link:" => "Pots veure els canvis respecte la versió anterior si segueixes aquest enllaç:",
"The changes in this version follow below, followed after by the current full page text." => "Els canvis en aquesta versió són a sota, seguides després per la versió sencera actual del text de la pàgina.",
"-Lines: {\$oldd} changed to +Lines: {\$newd}" => "-Línies: {\$oldd} canviades per +Línies: {\$newd}",
"The old page content follows below" => "L'anterior contingut de la pàgina es mostra a continuació a sota",
"The new page content follows below." => "El nou contingut de la pàgina segueix a sota.",
"Wiki page %s created by {\$mail_user|username}" => "La pàgina %s ha estat creada per {\$mail_user|username}",
"Wiki page %s deleted by {\$mail_user|username}" => "La pàgina %s ha estat esborrada per {\$mail_user|username}",
"A file was attached to %s" => "S'ha adjuntat un arxiu a %s",
"Wiki page %s changed by {\$mail_user|username}" => "Pàgina wiki %s canviada per {\$mail_user|username}",
"Wiki page renamed" => "La pàgina Wiki ha estat reanomenada",
"Old name" => "Nom vell",
"New name" => "Nou nom",
"Thank you for your registration." => "Gràcies per registrar-te.",
"You may log in now." => "Ara pots connectar-te.",
"click on the map to zoom or pan, do not drag" => "fes clic a sobre del mapa per ampliar o allunyar, no arrosseguisr",
"Query Results" => "Resultats de la consulta",
"Querying" => "Consultant",
"Scroll Up" => "Desplaça cap a munt",
"Scroll Down" => "Desplaça cap a baix",
"Scale" => "Escala",
// "Zoom out" => "Zoom out",
"Query" => "Consulta",
"Pan" => "Pan",
// "Zoom in" => "Zoom in",
"Redraw" => "Redibuixar",
"select zoom/pan/query and image size" => "seleccionar zoom/pan/consulta i tamany d'imatge",
"View the Map Only" => "Veure només el mapa",
"Reset Map" => "Reinicia el mapa",
"Click on the map or click redraw" => "Fes clic a sobre del mapa o fes clic a redibuixar",
"Overview" => "Vista Esquema",
"Legend" => "Llegenda",
"Layer Manager" => "Control de Capa",
"Layer" => "Capa",
// "{\$my_layers[j]->group}" => "{\$my_layers[j]->group}",
// "{\$layer_wiki[i]}" => "{\$layer_wiki[i]}",
// "{\$layer_wiki[j]}" => "{\$layer_wiki[j]}",
"Download Layer" => "Capa de Descàrrega",
"This layer has been set by the maps administrator to not be downloadable" => "Aquesta capa ha estat configurada per l'administrador del mapa perquè no sigui descarregable",
"you have requested to download the layer:" => "has demanat descarregar la capa:",
// "from the mapfile" => "from the mapfile",
"Here are the files to download, do not forget to rename them:" => "Aquí hi ha els fitxers a descarregar-se, no t'oblidis de renombrar-los:",
"Mapfiles" => "Fitxers de mapa",
"Mapfile" => "Fitxer de mapa",
"Available mapfiles" => "Permés mapa d'arxius",
"hits last 7 days" => "visites dels últims set dies",
"monitor this map" => "Segueix aquest mapa",
"Stop Monitoring this Map" => "Deixa de seguir aquest  mapa",
"Create a new mapfile" => "Crear un nou mapa de l'arxiu",
"Mapfile listing" => "Llista de Mapfiles",
"Reload" => "Recarrega",
"You can view this map in your browser using" => "Pots veure aquest mapa en el teu navegador emprant",
"Zoom out x2" => "Disminuir zoom x2",
"Zoom in x2" => "Augmentar zoom x2",
"Mapfile History" => "Historial de fitxers de mapa",
"of" => "de",
"Version:" => "Versió:",
"Compare" => "Comparar",
"Comparing version {\$old.version} with version {\$new.version}" => "Comparant la versió {\$old.version} amb la versió {\$new.version}",
"Current" => "Actual",
"Versions are identical" => "Les versions són idèntiques",
"Legend:" => "Llegenda:",
"v=view" => "v=visualització",
"c=compare" => "c=compara",
"d=diff" => "d=dif",
"Ip" => "Ip",
"Diff" => "Dif",
"Older Version" => "Versió més vella",
// "{\$dir}" => "{\$dir}",
"Directories" => "Directoris",
"back to" => "torna a",
"Upload From Disk:" => "Puja des de Disc:",
"Upload Files" => "Puja fitxers",
"Bytes maximum" => "Octets màxim",
"Create Directory:" => "Crear Directori:",
"index file (.shp):" => "arxiu índex (.shp):",
"files to index (regexp):" => "arxius a indexar (regexp):",
"Message Archive" => "Arxiu de missatges",
"messages" => "missatges",
"Archive is full!" => "L'arxiu és ple!",
"Read" => "Llegeix",
"Unread" => "No llegit",
"Flagged" => "Senyalat",
"Unflagged" => "Desmarcat",
"Containing" => "Contingut",
"Sender" => "remitent",
"No messages to display" => "No hi ha cap missatge per mostrar",
"Broadcast message" => "Difondre un missatge",
"Confirmation" => "Confirmació",
"Please Confirm" => "Si us plau, confirma-ho",
"All users" => "Tots els usuaris",
"Lowest" => "El més baix",
"Very High" => "Molt Alt",
"Send" => "Envia",
"Compose message" => "Escriu un missatge",
"If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences." => "Si vols que la gent et pugui respondre, habilita l'opció <a href='tiki-user_preferences.php'>Permet missatges d'altres usuaris</a> a les teves preferències.",
"ERROR" => "ERROR",
"Invalid" => "Invàlid",
// "To: Multiple addresses can be separated with semicolons (\";\") or commas (\",\")" => "To: Multiple addresses can be separated with semicolons (\";\") or commas (\",\")",
"CC" => "CC",
// "CC: Multiple addresses can be separated with semicolons (\";\") or commas (\",\")" => "CC: Multiple addresses can be separated with semicolons (\";\") or commas (\",\")",
"BCC" => "BCC",
// "BCC: Multiple addresses can be separated with semicolons (\";\") or commas (\",\")" => "BCC: Multiple addresses can be separated with semicolons (\";\") or commas (\",\")",
"Reply-to my email" => "Respon-me al meu correu-e",
"The user will be able to reply to you directly via email" => "La persona usuària podrà respondre't directament via correu-e",
"Send me a copy" => "Envia'm una còpia",
"You will be sent a copy of this email" => "Se t'enviarà una còpia d'aquest correu-e",
"No messages to download" => "No hi ha missatges per descarregar",
"Mailbox is full! Delete or archive some messages if you want to receive more messages." => "La bústia de correu és plena! Esborra o arxiva alguns missatges si vols rebre'n més.",
"is reply to" => "és resposta a",
"Find replied message" => "busca missatges contestats",
"Mark as read" => "Marca com llegit",
"Mark as unread" => "Marca com no llegit",
"Mark as flagged" => "Marca com a senyalat",
"Mark as unflagged" => "Marca com no senyalat",
"Mark" => "marca",
"Mailbox" => "Bústia",
"Compose" => "Redacta",
"Broadcast" => "Difon",
"Auto-archive age for read messages:" => "Edat d'autoarxivament per als missatges llegits:",
"Read message" => "Llegeix missatge",
"Return to mailbox" => "Retorna a la bústia de correu",
"replyall" => "respondre tot",
"Unflag" => "Desmarca",
"Flag this message" => "Marca aquest missatge",
"From:" => "de part de:",
"Cc" => "Cc",
"Return to archive" => "Torna a l'arxiu",
"Return to outbox" => "Torna a la bústia de sortida",
"Sent Messages" => "Missatges enviats",
"Replied" => "Respost",
"Not replied" => "No repost",
"move to archive" => "mou a l'arxiu",
"receiver" => "receptor",
"Move module up" => "Pujar mòdul",
"Move module down" => "Baixar mòdul",
"Move module to opposite side" => "Moure mòdul al costat oposat",
"opp side" => "banda contrària",
"Unassign this module" => "Desassigna aquest mòdul",
"Are you sure you want to unassign this module?" => "Segur que vols desassignar aquest mòdul?",
"Toggle module contents" => "Intercanvia el contingut del mòdul",
"toggle" => "intercanvia",
// "Toggle Vertically" => "Toggle Vertically",
"Display type unknown, you have to enter the banner type" => "Tipus de pantalla desconegut, has d'introduir el tipus de pancarta",
"You forgot your Google ad_client number !" => "Heu oblidat el vostre número de Google ad_client!",
"To configure your Tiki" => "Per configurar el teu Tiki",
"Admin Home" => "Admin Inici",
"from the menu" => "des del menú",
// "Read the <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Tiki Documentation\" target=\"_blank\">configuration documentation</a>" => "Read the <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Tiki Documentation\" target=\"_blank\">configuration documentation</a>",
"Watch the <a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies" => "Mira els <a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">videos de demostració",
"To remove this module" => "Per eliminar aquest mòdul",
"Admin Modules" => "Administració de Mòduls",
"and remove the assistant module" => "i eliminar el mòdul de l'assistent",
"You can also add other modules" => "Pots afegir també altres mòduls",
"To customize the menu" => "Per adaptar el menú",
"Admin Menus" => "Administració de Menús",
"and edit menu ID 42" => "i edita el menú ID 42",
"Or, create your own menu and add it to a module" => "O, crea el teu propi menú i afegeix-ho com a mòdul",
"Login" => "Connecta't",
"To begin configuring Tiki, please" => "Per començar a configurar Tiki, si us plau",
"login" => "connecta't",
"as admin" => "com l'Administrador",
"The Tiki Community" => "La Comunitat de Tiki",
// "To learn more, visit: <a href=\"http://tiki.org\" title=\"The Tiki Community\" target=\"_blank\">http://tiki.org</a>" => "To learn more, visit: <a href=\"http://tiki.org\" title=\"The Tiki Community\" target=\"_blank\">http://tiki.org</a>",
// "Tiki Documentation" => "Tiki Documentation",
// "For help, visit <a href=\"http://doc.tiki.org\" title=\"Tiki Documentation\" target=\"_blank\">http://doc.tiki.org</a>" => "For help, visit <a href=\"http://doc.tiki.org\" title=\"Tiki Documentation\" target=\"_blank\">http://doc.tiki.org</a>",
"Published on" => "Publicat el",
"private" => "privat",
"on blogpost" => "a blogpost",
// "Untitled" => "Untitled",
// "{\$module_params.label|escape:\"html\"}" => "{\$module_params.label|escape:\"html\"}",
// "{\$crumbs[0]->description}" => "{\$crumbs[0]->description}",
"Add event" => "Afegeix esdeveniment",
// "Unit cost" => "Unit cost",
// "Qty" => "Qty",
// "Gift Certificate" => "Gift Certificate",
// "Remove Gift Certificate" => "Remove Gift Certificate",
// "Add Gift Certificate" => "Add Gift Certificate",
// "Check-out" => "Check-out",
// "Your cart is empty" => "Your cart is empty",
// "Missing %0 of the following categories" => "Missing %0 of the following categories",
// "%0 extra of the following categories" => "%0 extra of the following categories",
// "Unknown comparison" => "Unknown comparison",
// "Impossible condition, %0 of" => "Impossible condition, %0 of",
// "Assign into category" => "Assign into category",
// "{\$modcatlist[\$k].name|escape}" => "{\$modcatlist[\$k].name|escape}",
// "Unassign category" => "Unassign category",
// "{\$module_params.categorize}" => "{\$module_params.categorize}",
"Pages:" => "Pàgines:",
// "{\$contributor.country|stringfix}" => "{\$contributor.country|stringfix}",
"Homepage" => "Plana inicial",
// "1 more contributor" => "1 more contributor",
// "{\$hiddenContributors} more contributors" => "{\$hiddenContributors} more contributors",
"empty" => "buit",
"low" => "baixa",
"Sites" => "Llocs",
"Sites to validate" => "Llocs per validar",
"Categories:" => "Categories:",
"Visited links" => "Enllaços visitats",
// "By" => "By",
// "hits" => "hits",
"Add tags" => "Afegeix etiquetes",
"List everything tagged" => "Llista tot el que estigui etiquetat",
"All Groups" => "Ttos els Grups",
"Your Groups" => "Els teus Grups",
// "Emulated Groups" => "Emulated Groups",
"Switch to Groups" => "Canvia a Grups",
"Simulate" => "Simula-ho",
// "Add Post" => "Add Post",
"insert original" => "inserta l'original",
"insert thumbnail" => "insert el contacte",
"more" => "més",
// "Last %0 Podcasts" => "Last %0 Podcasts",
// "This is likely not a podcast file" => "This is likely not a podcast file",
// "The path to a podcast player is required" => "The path to a podcast player is required",
// "{\$link_text}" => "{\$link_text}",
// "No avatar" => "No avatar",
"You" => "Tu",
// "{\$data.info.title|escape:\"html\"}" => "{\$data.info.title|escape:\"html\"}",
"Open operator console" => "Obre la consola d'operador",
"Execution time" => "Temps d'execució",
"Memory usage" => "Memòria d'ús",
"database queries used in " => "crides a la base de dades a ",
"Server load" => "Càrrega del servidor",
"Logged in as" => "Connectat com a",
"Log out" => "Desconnecta't",
"Switch User" => "Canvia't per l'Usuari",
// "Enter user name and click 'Switch'.<br />Useful for testing permissions" => "Enter user name and click 'Switch'.<br />Useful for testing permissions",
"Switch" => "Canvi",
"Switch user" => "Canvia usuari",
// "Log in through CAS" => "Log in through CAS",
// "Log in as admin" => "Log in as admin",
// "Log in through Shibboleth" => "Log in through Shibboleth",
"eMail" => "Correu-e",
"CapsLock is on" => "Tens activada la tecla de bloqueig de majúscules",
"Click here if you've forgotten your password" => "Fes clic aquí si has oblidat la teva contrasenya",
"I forgot my password" => "He oblidat la meva contrasenya",
"Click here to register" => "Fes clic aquí per registrar-te",
"Click here to login using the default security protocol" => "Fes clic aquí per entrar usant el protocol de seguretat per defecte",
"Standard" => "Estàndar",
"Click here to login using a secure protocol" => "Fes clic aquí per entrar usant un protocol segur",
"Secure" => "Segur",
"Stay in SSL mode" => "Roman en mode segur (ssl)",
"local account" => "compte local",
"OpenID Log in" => "Connexió via OpenID",
"What is OpenID" => "Qué és OpenID",
// "No acceptable field to store the feature was found in the specified tracker" => "No acceptable field to store the feature was found in the specified tracker",
"You have" => "Teniu",
"new messages" => "nous missatges",
"new message" => "nou missatge",
"You have 0 new messages" => "No teniu cap missatge nou",
// "No article found" => "No article found",
// "No blog post found" => "No blog post found",
"We have" => "Tenim",
"submissions waiting to be examined" => "col·laboracions esperant ser examinades",
// "Stay on this page" => "Stay on this page",
// "Edit perspectives" => "Edit perspectives",
"Powered by" => "Basat en",
// "Tiki Wiki CMS Groupware" => "Tiki Wiki CMS Groupware",
"Made with" => "Fet amb",
// "Search Terms" => "Search Terms",
// "Any type" => "Any type",
// "Admin home" => "Admin home",
// "Modify the look &amp; feel (logo, theme, etc.)" => "Modify the look &amp; feel (logo, theme, etc.)",
"Users" => "Usuaris",
"Toggle interactive translation off" => "Desactiva la traducció interactiva",
"Toggle interactive translation on" => "Activa la traducció interactiva",
// "Theme Generator Editor" => "Theme Generator Editor",
// "Rebuild Search index" => "Rebuild Search index",
"Plugin Approval" => "Aprovació d'Ús de Connectors",
"SysLogs" => "Registres del systema",
// "Open Smarty debug window" => "Open Smarty debug window",
// "Wiki feed" => "Wiki feed",
// "Feed" => "Feed",
// "Blogs feed" => "Blogs feed",
// "Articles feed" => "Articles feed",
// "Image Galleries feed" => "Image Galleries feed",
"Image Galleries" => "Galeries d'imatges",
// "File Galleries feed" => "File Galleries feed",
// "Forums feed" => "Forums feed",
// "Maps feed" => "Maps feed",
"Maps" => "Mapes",
"Calendars" => "Calendaris",
// "{\$tracker.name}" => "{\$tracker.name}",
"Entire Site" => "Lloc complet",
"Image Gals" => "Imatges Gals",
"Search for text throughout the site" => "Cerca el text per tot el lloc",
"Go directly to a page, or search in page titles if exact match is not found" => "Ves directament a una página, o cerca als títols de pàgines si no hi ha cap pàgina amb aquest nom exacte",
"Edit existing page or create a new one" => "Edita una pàgina pre-existent o crea'n una de nova",
// "Page Relations" => "Page Relations",
"Are you sure you want to delete this shout" => "Segur que vols eliminar aquesta nota",
// "Tweet with Twitter" => "Tweet with Twitter",
// "Post on my Facebook wall" => "Post on my Facebook wall",
// "Shout date" => "Shout date",
// "Delete this shout" => "Delete this shout",
// "Edit this shout" => "Edit this shout",
"Read More" => "Llegeix més",
"Since your last visit on" => "Des de la teva última visita el...",
"New Images" => "Imatges noves",
"Wiki Pages Changed" => "Pàgines del wiki modificades",
"New Files" => "Arxius nous",
"New Comments" => "Comentaris nous",
"New Tracker Items" => "Nous ítems del formulari",
"New Calendar Events" => "Nous Esdeveniments al Calendari",
"New Users" => "Usuaris/es nous/ves",
"click to edit" => "fes clic per editar",
"Nothing has changed" => "Res no ha canviat",
// "Updated" => "Updated",
"Multiple" => "Múltiple/s",
"including" => "incloent",
"Site default" => "El que hi ha per defecte a aquest lloc",
// "Find term" => "Find term",
// "{\$user_languages[ix].name}" => "{\$user_languages[ix].name}",
// "If not found, you will be given a chance to create it" => "If not found, you will be given a chance to create it",
// "TikiTests Menu" => "TikiTests Menu",
// "List Tests" => "List Tests",
// "Create Test" => "Create Test",
"Top galleries" => "Galeries per dalt",
// "Posted to" => "Posted to",
// "(Read More)" => "(Read More)",
// "Missing values" => "Missing values",
// "Add Marker" => "Add Marker",
// "Tracker name" => "Tracker name",
// "Insert fields in wiki textarea" => "Insert fields in wiki textarea",
"There are no translations of this page." => "No hi ha traduccions d'aquesta pàgina.",
"Up-to-date-ness" => "Nivell d'actualització",
// "Incoming" => "Incoming",
// "To <strong>continue translating</strong>, select the language to translate from" => "To <strong>continue translating</strong>, select the language to translate from",
"update from it" => "actualitza-ho des d'ella",
"None match your" => "Cap encaixa amb els teus",
"Set your preferred languages." => "Especifica el teu idioma preferit.",
"preferred languages" => "idiomes preferits",
"view" => "veure",
// "Outgoing" => "Outgoing",
"update it" => "actualitza des d'ella",
"click to view" => "punxa per veure",
"Add Event" => "Afegeix Esdeveniment",
"Bookmarks" => "Adreces d'interès",
// "Create Bookmark" => "Create Bookmark",
// "New Folder" => "New Folder",
"Done" => "fet",
"Del" => "Esb",
"select" => "selecciona",
// "{\$user_groups[ix].groupName|escape}" => "{\$user_groups[ix].groupName|escape}",
// "Group information" => "Group information",
"You need to activate user and/or group trackers" => "Necessites activar el formulari d'usuari i/o de grup",
// "%0 out of %1 users" => "%0 out of %1 users",
// "Webmail inbox" => "Webmail inbox",
// "Refresh (non-ajax)" => "Refresh (non-ajax)",
// "TAKE" => "TAKE",
// "View contact" => "View contact",
"online users" => "usuaris en línia",
"online user" => "usuari en línia",
"on host" => "al servidor",
// "User does not accept messages" => "User does not accept messages",
"Send a message to" => "Envia un missatge a",
"Send a message" => "Envieu un missatge",
// "More Videos" => "More Videos",
"No results" => "Sense resultats",
// "No results were found. Are you sure you searched for a tag" => "No results were found. Are you sure you searched for a tag",
// "We are not autorized to access the group at this time. If you have access to the Zotero group, you can grant this site read access" => "We are not autorized to access the group at this time. If you have access to the Zotero group, you can grant this site read access",
"No individual permissions, category permissions apply" => "No hi ha permisos individuals; s'apliquen els permisos de categoria",
// "There are individual permissions set for this object" => "There are individual permissions set for this object",
"No individual permissions. Global permissions apply." => "No hi ha permisos individuals, s'aplicaràn els permisos globals",
// "Session" => "Session",
// "Old Session" => "Old Session",
// "Old Version" => "Old Version",
// "New Session" => "New Session",
// "New Version" => "New Version",
"Minimum %0 characters long" => "Com a mínim %0 caràcters de longitud",
"[-]" => "[-]",
"vote" => "vota",
"Requires" => "Requireix",
// "You need to set" => "You need to set",
// "Separator is " => "Separator is ",
// "Reset to default" => "Reset to default",
// "Restore current value" => "Restore current value",
"Rate" => "Qualificació",
"A valid email is mandatory to register" => "Cal una adreça de correu-e vàlida per enregistrar-te",
// "{\$customfields[ir].label}" => "{\$customfields[ir].label}",
// "{\$gr.groupDesc|escape}" => "{\$gr.groupDesc|escape}",
"Use your email as login" => "Empra el teu correu-e com a nom per connectar-te",
"Lowercase only" => "Només minúscules",
"Repeat password" => "Repetiu la contrasenya",
"Generate a password" => "Generar una contrasenya",
"Passcode to register" => "Codi de pas per registrar-se",
"Not your password" => "No la teva contrasenya",
"To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}" => "Per requerir un codi de pas, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\tcontacta a les persones administradores del sistema{if \$prefs.feature_contact eq 'y'}</a>{/if}",
// "The passcode (to block robots from registration) is" => "The passcode (to block robots from registration) is",
// "{\$remarksbox_type}" => "{\$remarksbox_type}",
// "{\$result.object_type|escape}" => "{\$result.object_type|escape}",
"Last modification" => "Darrera modificació",
"No pages matched the search criteria" => "Cap pàgina ha encaixat en el criteri de cerca",
// "Download Log File" => "Download Log File",
"Send Newsletter" => "Envia el Butlletí",
"To edit the copyright notices" => "Per editar els avisos de Copyright",
"The content on this page is licensed under the terms of the" => "El contingut d'aquesta pàgina està sota llicència amb els termes de",
// "Page alias.." => "Page alias..",
"Monitor the Sub-Structure" => "Vigila la Sub-Estructura",
"Stop Monitoring the Sub-Structure" => "Deixa de vigilar la Sub-Estructura",
// "locked by %0" => "locked by %0",
"Locked" => "Bloquejat",
"Edit page" => "Edita la pàgina",
"Add new child page" => "Afegeix una nova pàgina filla",
"Jump to Content" => "Salta al Contingut",
"Fullscreen" => "Pantalla Sencera",
"Cancel Fullscreen" => "Cancel·la Pantalla Sencera",
"Show/Hide Left Column" => "Mostra/Amaga Menús de l'esquerra",
"Show/Hide Right Column" => "Mostra/Amaga Menús de la dreta",
// "Module errors" => "Module errors",
// "The following modules could not be loaded" => "The following modules could not be loaded",
// "absE" => "absE",
"Design by" => "Dissenyat per",
"comments" => "comentaris",
// "More search options" => "More search options",
// "View latest version before editing" => "View latest version before editing",
"Rename" => "Reanomenar",
// "Contributions by author" => "Contributions by author",
"Similar" => "Similar",
"Make Structure" => "Fes Estructura",
"Discuss" => "Debat",
"Attach File" => "Adjuntar arxiu",
"1 File Attached" => "1 arxiu adjunt",
"{\$atts|@count} files attached" => "{\$atts|@count} arxius adjunts",
// "Bookmark" => "Bookmark",
"Edit This Tracker" => "Edita aquest Formulari-bd",
"Edit Fields" => "Edita els camps",
"Create Item" => "Crea un ítem",
"View Items" => "Visualitza els ítems",
"Preview your changes." => "Previsualitza els teus canvis.",
"Edit wiki page" => "Edita la pàgina wiki",
"Save the page as a partial translation." => "Desa la pàgina com a traducció parcial.",
"Partial Translation" => "Traducció Parcial",
"Save the page as a completed translation." => "Desa la pàgina com a traducció completa.",
"Complete Translation" => "Traducció Completa",
"Save the page, but do not count it as new content to be translated" => "Desa la pàgina, però no ho comptis com a nou contingut per a ser traduït",
"Save the page, but do not send notifications and do not count it as new content to be translated." => "Desa la pàgina, però no enviïs notificacions <br/>i no ho comptis com a nou contingut<br/> per ser traduït",
"Save Minor Edit" => "Edició Menor",
"Save the page." => "Desa la pàgina.",
"Cancel the edit, you will lose your changes." => "Cancel·la l'edició, perdràs els teus canvis.",
// "Designed originally by" => "Designed originally by",
"* PREVIEW *" => "* PREVISUALITZACIÓ *",
// "Modifying" => "Modifying",
// "Toggle checkboxes" => "Toggle checkboxes",
// "Toggle changed" => "Toggle changed",
// "Live preview" => "Live preview",
// "Reset selected" => "Reset selected",
// "Found in" => "Found in",
// "Changed from %0 to %1" => "Changed from %0 to %1",
// "Unchanged" => "Unchanged",
// "No definitions found" => "No definitions found",
// "No types found" => "No types found",
// "This book" => "This book",
"Start date" => "Data d'inici",
"before" => "abans",
// "after" => "after",
// "don't display" => "don't display",
// "Decimals" => "Decimals",
// "Decimal Point" => "Decimal Point",
// "Auto Tax" => "Auto Tax",
"Tasks" => "Tasques",
// "Book new entries" => "Book new entries",
// "Confirm stack entries" => "Confirm stack entries",
// "Book into Stack" => "Book into Stack",
"Accounts" => "Comptes",
// "Bank acounts" => "Bank acounts",
// "Journal" => "Journal",
// "Fetch all" => "Fetch all",
"Account" => "Compte",
// "Successfully deleted account %0 %1" => "Successfully deleted account %0 %1",
// "Return to main accounting page" => "Return to main accounting page",
// "Create new account" => "Create new account",
// "Edit Account" => "Edit Account",
"Account number" => "Número de compte",
"Account name" => "Nom del compte",
"Notes" => "Notes",
// "Budget" => "Budget",
// "Create account" => "Create account",
// "Modify account" => "Modify account",
// "Delete this account" => "Delete this account",
// "Back to book page" => "Back to book page",
// "Debit" => "Debit",
// "Credit" => "Credit",
// "Tax" => "Tax",
// "edit account" => "edit account",
// "unlock account" => "unlock account",
// "Are you sure you want to unlock this account" => "Are you sure you want to unlock this account",
// "lock account" => "lock account",
// "Are you sure you want to lock this account" => "Are you sure you want to lock this account",
// "delete account" => "delete account",
// "Are you sure, you want to delete this account" => "Are you sure, you want to delete this account",
// "Create a new account" => "Create a new account",
// "printable version" => "printable version",
// "export table" => "export table",
// "View account" => "View account",
// "Edit this account" => "Edit this account",
// "My books" => "My books",
// "Tax automation" => "Tax automation",
"hide" => "oculta",
// "behind" => "behind",
// "Are you sure, you want to close this book" => "Are you sure, you want to close this book",
// "close book" => "close book",
// "Create a book" => "Create a book",
// "Book properties" => "Book properties",
// "Name of the book" => "Name of the book",
// "First date in journal" => "First date in journal",
// "Last date in journal" => "Last date in journal",
// "Currency settings" => "Currency settings",
// "Currency (up to 3 letters) " => "Currency (up to 3 letters) ",
// "Position of the currency " => "Position of the currency ",
// "Show no currency" => "Show no currency",
// "Show currency in front of numbers" => "Show currency in front of numbers",
// "Show currency behind numbers" => "Show currency behind numbers",
// "Decimal point" => "Decimal point",
// "Decimal" => "Decimal",
// "Thousands separator" => "Thousands separator",
// "Quote strings with" => "Quote strings with",
// "End of Line" => "End of Line",
// "Carriage return" => "Carriage return",
// "Line feed" => "Line feed",
// "Carriage Return/Line feed" => "Carriage Return/Line feed",
// "Automatic Tax Calculation" => "Automatic Tax Calculation",
// "Allow automatic tax calculation" => "Allow automatic tax calculation",
// "Create a new book" => "Create a new book",
// "The following transaction has been cancelled" => "The following transaction has been cancelled",
"id" => "id",
// "booking date" => "booking date",
// "Amount" => "Amount",
// "Book a transaction" => "Book a transaction",
// "Add entry" => "Add entry",
// "Book" => "Book",
// "Export {\$what}" => "Export {\$what}",
// "Export CSV settings" => "Export CSV settings",
// "Separator between fields" => "Separator between fields",
// "Quote character for text" => "Quote character for text",
"Export as CSV" => "Exporta com a CSV",
// "cancel this transaction" => "cancel this transaction",
// "Are you sure you want to cancel this transaction" => "Are you sure you want to cancel this transaction",
"Balance" => "Balanç",
// "Deleted" => "Deleted",
// "Debit Account" => "Debit Account",
// "Debit Amount" => "Debit Amount",
// "Debit Text" => "Debit Text",
// "Credit Account" => "Credit Account",
// "Credit Amount" => "Credit Amount",
// "Credit Text" => "Credit Text",
// "Book a transaction into the stack" => "Book a transaction into the stack",
// "delete this transaction from the stack" => "delete this transaction from the stack",
// "Are you sure you want to delete this transaction from stack" => "Are you sure you want to delete this transaction from stack",
// "confirm this transaction" => "confirm this transaction",
// "Are you sure you want to confirm this transaction" => "Are you sure you want to confirm this transaction",
"Do not group by item" => "No agrupis per ítem",
"Group by item" => "Agrupa per ítem",
"Calendar View" => "Vista de Calendari",
"Tiki Action Calendar" => "Calendari d'accions del Tiki",
"Tools Calendars" => "Eines de Calendaris",
"Check / Uncheck All" => "Marcar / desmarcar tot",
// "Your sender email is not set. You can set it <a href=\"%0\">here</a>" => "Your sender email is not set. You can set it <a href=\"%0\">here</a>",
// "Preference Filters" => "Preference Filters",
"Set as my default" => "Fixa com les meves per omissió",
"Configuration search" => "Cerca als panells de configuració",
// "Note: The search index needs rebuilding, this will take a few minutes" => "Note: The search index needs rebuilding, this will take a few minutes",
// "Potential Cross-Site Request Forgery" => "Potential Cross-Site Request Forgery",
"Search error" => "Error de cerca",
"Preferences Search Results" => "Resultats de la Cerca de Preferències",
"No preferences were found for your search query" => "No s'han trobat preferències per a la teva cerca",
"Database Version Problem" => "Hi ha un problema amb la versió de la base de dades",
// "Your database requires an update to match the current Tiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provokes errors" => "Your database requires an update to match the current Tiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provokes errors",
// "A new version of Tiki, <b>{\$prefs.tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tiki.org/Download\">tiki.org/Download</a>" => "A new version of Tiki, <b>{\$prefs.tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tiki.org/Download\">tiki.org/Download</a>",
"Enabled" => "Permès",
"Changed" => "Canviat",
"Preference" => "Preferència",
// "{\$tikifeedback[n].mes|stringfix}" => "{\$tikifeedback[n].mes|stringfix}",
"Preference name" => "Nom de la preferència",
"Crosslinks to other features and settings" => "Enllaços creuats a altres funcionalitats i especificacions",
"Administration features" => "Administració de Funcionalitats",
"TikiCache/System" => "TikiCache/Sistema",
"phpinfo" => "phpinfo",
"Mods" => "Mods",
"Transversal features" => "Funcionalitats transversals",
"which apply to more than one section" => "que s'apliquen a més d'una secció",
"Mail Notifications" => "Notificacions per correu",
"Navigation features" => "Funcionaliats de navegació",
"Text area features" => "Funcionalitats de l'àrea de text",
"features you can use in all text areas, like wiki pages, blogs, articles, forums, etc" => "funcionalitats que pots emprar en totes les arees de text, com pàgines wiki, bitàcoles, articles, fòrums, etc",
"Cookies" => "Galetes",
// "External Pages Cache" => "External Pages Cache",
// "External Wikis" => "External Wikis",
// "Please select some actions to be reported" => "Please select some actions to be reported",
"Start:" => "Inici:",
"End:" => "Final:",
// "Users and Groups" => "Users and Groups",
"Misc" => "Misc",
"Units" => "Unitats",
// "kb" => "kb",
"Contibution Time" => "Unitats de freqüència per als informes de contribucions",
// "Graph Contributions" => "Graph Contributions",
// "Group Bar Plot" => "Group Bar Plot",
// "Accumulated Bar Plot" => "Accumulated Bar Plot",
// "{\$color}" => "{\$color}",
// "Legend background color" => "Legend background color",
// "Save graphs to image gallery" => "Save graphs to image gallery",
// "See Statistics" => "See Statistics",
"Records:" => "Registres:",
"contribution" => "tipus de contribució",
// "contributor" => "contributor",
// "{\$actionlog.action|escape}" => "{\$actionlog.action|escape}",
// "{\$actionlog.objectType}" => "{\$actionlog.objectType}",
// "{\$actionlog.ip}" => "{\$actionlog.ip}",
// "Ban" => "Ban",
// "Edit Action" => "Edit Action",
// "Save Action" => "Save Action",
"Statistics" => "Estadístiques",
// "Volumes are equally distributed on each contributors/author" => "Volumes are equally distributed on each contributors/author",
// "connection time" => "connection time",
// "connection seconds" => "connection seconds",
// "mns" => "mns",
// "Volume per category" => "Volume per category",
// "Volume per category and per user" => "Volume per category and per user",
// "Number of actions per user" => "Number of actions per user",
// "Total number of users" => "Total number of users",
// "Number of actions per object" => "Number of actions per object",
// "Total number of objects" => "Total number of objects",
// "Number of actions per category" => "Number of actions per category",
// "Number of actions per category and per user" => "Number of actions per category and per user",
// "Volume per the users' group and per contribution" => "Volume per the users' group and per contribution",
// "Volume per group and per contribution" => "Volume per group and per contribution",
// "Volume per user and per contribution" => "Volume per user and per contribution",
// "Volume per users' contribution and time" => "Volume per users' contribution and time",
// "Volume per contribution and time" => "Volume per contribution and time",
"Weeks" => "Setmanes",
"Setting" => "Configuració",
// "How" => "How",
// "You need to check out the recorded box for each action type we may be interested to have some report later. To see a report of some action types, select the reported checkboxes of these action types, goto the Report tab and select additional filters. The report will only contains the actions that occurred since the action type has been set to recorded" => "You need to check out the recorded box for each action type we may be interested to have some report later. To see a report of some action types, select the reported checkboxes of these action types, goto the Report tab and select additional filters. The report will only contains the actions that occurred since the action type has been set to recorded",
"Wiki page actions except viewed will always be recorded but can be not reported." => "Les accions en pàgines wiki (excepte les de visualització) sempre es registren però es pot selecionar que no es mostrin als informes.",
"Recorded" => "Registrat",
"Reported" => "Mostrat a l'informe",
// "{\$actionlog.action}" => "{\$actionlog.action}",
// "Import as CSV" => "Import as CSV",
// "Banning rules have been updated" => "Banning rules have been updated",
// "Add or edit rules" => "Add or edit rules",
"Rule title" => "Titol de la regla",
"Username regex matching" => "Apaarellament de regex de nom d'usuari",
// "Multiple IP regex matching" => "Multiple IP regex matching",
"IP regex matching" => "IP comprovació",
"Banned from sections" => "Expulsat de les seccions",
// "{\$sec}" => "{\$sec}",
"Rule activated by dates" => "Regla activada per dates",
"Rule active from" => "Regla activa desde",
"Rule active until" => "Regla activa fins",
"Custom message to the user" => "Personalitzar missatge a l'usuari/a",
// "Import rules as CSV" => "Import rules as CSV",
"CSV File" => "Arxiu CSV",
"Column names on the first line" => "Els nom de les columnes van a la primera línia",
// "Sections format" => "Sections format",
// "section names are splitted by pipes (vertical bars). To see an example and use it as template, add one rule by hand, and export it as csv" => "section names are splitted by pipes (vertical bars). To see an example and use it as template, add one rule by hand, and export it as csv",
"See" => "Consulta",
// "Import as new rules" => "Import as new rules",
"import" => "importa",
"Find:" => "Troba:",
"Rules" => "Regles",
"x" => "x",
"User/IP" => "Usuari/a-IP",
"Sections" => "Seccions",
"Admin Calendars" => "Administrar Calendaris",
// "Create Calendar" => "Create Calendar",
"View Calendars" => "Mostra els Calendaris",
"List of Calendars" => "Llista de calendaris",
// "Calendar name" => "Calendar name",
"Loc" => "Loc",
"Participants" => "Participants",
"Cat" => "Cat",
"Lang" => "Idm",
"Prio" => "Prio",
"Subscription" => "Subscripció",
// "Perso" => "Perso",
"View Calendar" => "Visualitza el Calendari",
"Edit Calendar" => "Edita el Calendari",
"Custom Locations" => "Personalitzar Llocs",
"Custom Participants" => "Participants customitzats",
// "Custom Classifications" => "Custom Classifications",
"Custom Languages" => "Personalitzar Idiomes",
"Custom URL" => "URL personalitzada",
"Custom Subscription List" => "Llista de subscripcions customitzada",
"Custom Priorities" => "Personalitzar Prioritats",
"Personal Calendar" => "Calendari personal",
"Start of day" => "Inici del dia",
"End of day" => "Final del dia",
// "Days to display" => "Days to display",
"Standard Colors" => "Colors estàndard",
"Green" => "Verd",
"Blue" => "Blau",
"Purple" => "Violeta",
"Red" => "Vermell",
"Orange" => "Taronja",
"Yellow" => "Groc",
"Custom foreground color" => "Color de davant personalitzat",
"Ex" => "Ex.",
"Custom background color" => "Color del fons personalitzat",
"Default event status" => "Estatus de l'esdeveniment per omissió",
"Show in calendar view" => "Mostra a la vista de calendari",
"Group of users alerted when calendar event is modified" => "Grup d'usuaris a avisar quan un esdeveniment del calendari sigui modificat",
// "Default event to all day" => "Default event to all day",
// "Event name on each day in calendar view" => "Event name on each day in calendar view",
"Delete events older than" => "Esborra esdeveniments més vells que",
"Browse the category system" => "Navega pel sistema de categories",
"Current category" => "Categoria actual",
"Current Category ID:" => "Category Actual amb ID:",
// "Create/Edit category" => "Create/Edit category",
"Edit this category:" => "edita aquesta categoria:",
"Add new category" => "Afegeix una nova categoria",
// "Apply parent category permissions" => "Apply parent category permissions",
"Batch upload" => "Puja al rerafons",
"Batch upload (CSV file)" => "Pujada en bloc (arxiu CSV)",
"Objects in category" => "Objectes en la categoria",
// "Remove from this Category" => "Remove from this Category",
// "{\$objects[ix].type}" => "{\$objects[ix].type}",
// "Moving objects between categories" => "Moving objects between categories",
// "Unassign all objects from this category" => "Unassign all objects from this category",
// "Move all the objects from this category to this one" => "Move all the objects from this category to this one",
// "Assign all objects of this category to this one" => "Assign all objects of this category to this one",
"Add objects to category" => "Afegir objectes a la categoria",
"image gal" => "Galeria d'images",
// "File gal" => "File gal",
"Admin templates" => "Admin plantilles",
// "Use the Administration page of each enabled feature to allow the use of content templates" => "Use the Administration page of each enabled feature to allow the use of content templates",
"Edit this template:" => "Edita aquesta plantilla:",
"Create new template" => "Crea una nova plantilla",
// "Name field is mandatory" => "Name field is mandatory",
// "Use in" => "Use in",
"CMS" => "SGC (CMS)",
"HTML Pages" => "Pàgines HTML",
// "No features are configured to use templates" => "No features are configured to use templates",
// "Template Type" => "Template Type",
"Text area" => "Àrea de Text",
// "Is HTML" => "Is HTML",
"Templates" => "Plantilles",
// "Visible in no sections" => "Visible in no sections",
// "Remove section" => "Remove section",
"Admin Contributions" => "Administrar Tipus de Contribucions",
"Edit the contribution:" => "Edita el tipus de contribució:",
"Contributions are mandatory in wiki pages" => "És obligatori especificar tipus de contribucions en les pàgines wiki",
"Contributions are mandatory in forums" => "És obligatori especificar tipus de contribucions en els fòrums",
"Contributions are mandatory in comments" => "És obligatori especificar tipus de contribucions en els comentaris",
// "Contributions are mandatory in blogs" => "Contributions are mandatory in blogs",
"Contributions are displayed in the comment/post" => "Es mostren els tipus de contributions en els comentaris/publicacions",
"Create a new contribution" => "Crea un nou tipus de contribució",
"List of contributions" => "Llista de tipus de contribucions",
"Admin cookies" => "Administrar cookies",
"To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}." => "Per utilitzar una galeta en una àrea de text (pàgina wiki, etc.), un mòdul <a class=\"rbox-link\" href=\"tiki-admin_modules.php\"> </a> o una plantilla, utilitza {literal}{cookie}{/literal}.",
"Create/edit cookies" => "Crear/editar galetes",
"Upload Cookies from textfile" => "Puja Galetes des d'un arxiu de text ",
"Upload from disk:" => "Puja des del disc",
"Upload" => "Puja",
"Remove all cookies" => "Esborrar totes les cookies",
"cookie" => "galeta",
// "Manage Credits" => "Manage Credits",
// "(YYYY-MM-DD HH:MM:SS)" => "(YYYY-MM-DD HH:MM:SS)",
// "(level credits always 0)" => "(level credits always 0)",
// "Delete Checked" => "Delete Checked",
// "User Credits Expiry Summary (Plans)" => "User Credits Expiry Summary (Plans)",
// "User Plan" => "User Plan",
// "Start of Latest Plan" => "Start of Latest Plan",
// "Start of Next Plan" => "Start of Next Plan",
// "Expiry" => "Expiry",
// "Use User Credits" => "Use User Credits",
// "Restore User Level Credits" => "Restore User Level Credits",
// "Historical Usage Report" => "Historical Usage Report",
"all types" => "tots els tipus",
"filter" => "filtra",
// "Usage Date" => "Usage Date",
// "Amount Used" => "Amount Used",
// "Manage Credit Types" => "Manage Credit Types",
// "Display Text" => "Display Text",
// "Unit Text" => "Unit Text",
// "Is Static Level Credit" => "Is Static Level Credit",
// "Display Bar Length Scaling Divisor" => "Display Bar Length Scaling Divisor",
// "Purge Expired and Used Credits (All Users)" => "Purge Expired and Used Credits (All Users)",
// "Purge" => "Purge",
// "Admin Content Sources" => "Admin Content Sources",
"Use Admin DSN to define the database to be used by the SQL plugin." => "Empra Admin DSN per definir la base de dades a ser emprada pel connector 'SQL plugin'.",
// "Create/edit DSN" => "Create/edit DSN",
// "Local (Tiki database)" => "Local (Tiki database)",
// "See db/local.php" => "See db/local.php",
// "Content Authentication" => "Content Authentication",
// "Identification" => "Identification",
// "HTTP Basic" => "HTTP Basic",
// "HTTP Session / Login" => "HTTP Session / Login",
// "HTTP Session / Visit" => "HTTP Session / Visit",
// "Admin External Wikis" => "Admin External Wikis",
"Create/Edit External Wiki" => "Crea/Edita un Wiki External",
"URL (use \$page to be replaced by the page name in the URL example: http://www.example.com/tiki-index.php?page=\$page)" => "URL (empra \$page per ser reemplaçat pel nom de la pàgina a l'exemple d'URL: http://www.example.com/tiki-index.php?page=\$page)",
"ExtWiki" => "Wikiext",
"Admin Forums" => "Administrar fòrums",
"Create New Forum" => "Crear un Nou Fòrum",
"Duplicate Forum" => "Duplica el Fòrum",
// "View this forum" => "View this forum",
"Import forums" => "Importa fòrums",
"List forums" => "Llista de fòrums",
"Coms" => "Coms",
"Age" => "Edat",
"PPD" => "Ppd",
// ".." => "..",
// "Create/Edit Forums" => "Create/Edit Forums",
"Edit this Forum:" => "edita aquest fòrum:",
"Prevent flooding" => "Prevenir edicions simultànies",
"Minimum time between posts" => "Temps mínim entre publicacions",
"Create new" => "Crea nou",
"Moderator user" => "Usuari moderador",
"Moderator group" => "Grup moderador",
"Password protected" => "Contrasenya protegida",
"Forum password" => "Contrasenya del Fòrum",
// "Only allow replies to the first message (flat forum)" => "Only allow replies to the first message (flat forum)",
"Send this forums posts to this email" => "Enviar post d'aquest fòrum a aquest correu-e",
"Prune unreplied messages after" => "Eliminar missatges sense resposta després de ",
"Prune old messages after" => "Eliminar missatges antics després de",
"Topic list configuration" => "Configuració de la llista de tòpics",
// "Last post title" => "Last post title",
// "Last post avatar" => "Last post avatar",
// "Author avatar" => "Author avatar",
"Posts can be rated" => "Les publicacions poden ser puntuades",
"Display last post titles" => "Mostra darrers títols enviats",
"Forward messages to this forum to this e-mail address, in a format that can be used for sending back to the inbound forum e-mail address" => "Missatges reenviats a aquest fòrum per a aquesta adreça d'e-mail , en un format que pot ser emprat per a retornar a la primera adreça d'e-mail",
"Send mails even when the post is generated by inbound mail" => "Envia correus-e encara que un correu d'entrada hagi generat la publicació",
"Append a reply link to outbound mails" => "Afegeix un enllaç de resposta als correus enviats",
"Originating e-mail address for mails from this forum" => "Originant adreça d'e-mail  per a correus des de aquest fòrum",
"Add messages from this email to the forum" => "Afegeix missatges d'aquest correu-e al fòrum",
"POP3 server" => "servidor POP3",
"Use topic smileys" => "Empra emoticons",
"Show topic summary" => "Mostra el resum del tòpic",
"User information display" => "Mostra de la informació de l'usuari/a",
// "Online" => "Online",
"Approval type" => "Tipus d'Aprovació",
"Store attachments in:" => "Guardar adjunts a:",
"Max attachment size (bytes)" => "Tamany Màxim d'adjunts (en octets)",
// "Shows number of attachments of the all thread in forum list" => "Shows number of attachments of the all thread in forum list",
// "Set topics preferences" => "Set topics preferences",
// "Show topics preferences" => "Show topics preferences",
// "hide topics preferences" => "hide topics preferences",
"Default ordering for topics" => "Ordre per defecte per a temes",
"Topics per page" => "Temes per pàgina",
// "Set thread preferences" => "Set thread preferences",
// "Show threads preferences" => "Show threads preferences",
// "hide threads preferences" => "hide threads preferences",
"Default ordering for threads" => "Ordre per defecte per a missatges",
// "Default style for threads" => "Default style for threads",
"Duplicate perms" => "Duplica els permisos",
"Admin Hotwords" => "Admin paraules calentes",
"Add Hotword" => "Afegeix una paraula clau",
"Word" => "Paraula",
// "Admin HTML Page Dynamic Zones" => "Admin HTML Page Dynamic Zones",
"Admin HTML pages" => "Administra pàginas HTML",
"View page" => "Visualitza la pàgina",
"Edit zone" => "Edita zona",
"Dynamic zones" => "Zones dinàmiques",
"zone" => "zona",
"content" => "contingut",
"Mass update" => "Actualització massiva",
"Create new HTML page" => "Crea una nova pàgina HTML",
// "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones" => "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones",
"Edit this HTML page:" => "Edita aquesta pàgina HTML:",
"Apply template" => "Aplica plantilla",
// "{\$templates[ix].name}" => "{\$templates[ix].name}",
"Dynamic" => "Dinàmic",
"Static" => "Estàtic",
// "Refresh rate (if dynamic)" => "Refresh rate (if dynamic)",
"Last Modif" => "Darrera modificació",
// "Admin dynamic zones" => "Admin dynamic zones",
"An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> feature." => "Una manera fàcil d'integrar contingut d'un altre lloc web al Tiki és a través d'enllaços emmarcats utilitzant la funcionalitat Tiki <a class=\"rbox-link\" href=\"tiki-admin_links.php\">enllaços destacats</a>.",
"Edit Repository:" => "Edita Dipòsit:",
"Create New Repository" => "Crea Nou Dipòsit",
"List Repositories" => "Llista dipòsits",
"New Repository" => "Nou dipòsit",
"View Repository" => "Visualitza dipòsit",
"Human-readable repository name" => "Nom de dipòsit en format llegible",
"Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')" => "Ruta al dipòsit (sistemes de fitxers locals: adreça web relativa/absoluta, remots: prefixada amb 'http://')",
"File name of start page" => "Nom de l'arxiu de la pàgina de començament",
"Start page" => "Pàgina d'inici",
"CSS file to load when browse this repository" => "Fitxer CSS per carregar quan es navegui per aquest dipòsit",
"CSS File" => "Arxiu CSS",
"Is repository visible to users" => "Dipòsit visible per a les persones usuàries?",
"Can files from repository be cached" => "Es poden posar en memòria cau els fitxers del dipòsit?",
"Cacheable" => "Captable en memòria cau",
"Are files from repository can be cached" => "Es poden posar en memòria cau els fitxers del dipòsit?",
"Clear all cached pages of this repository" => "Neteja totes les pàgines en memòria cau d'aquest dipòsit?",
"Clear cache" => "Neteja memòria cau",
"Seconds count 'till cached page will be expired" => "Segons que resten fins que la pàgina quedi expirada",
"Cache expiration" => "Expiració de la memòria cau",
"Human-readable text description of repository" => "Text de descriptió en format llegible del dipòsit",
"Available Repositories" => "Dipòsits disponibles",
"Edit rules" => "edita normes",
"Edit Rules for Repository:" => "Editar Regles pel Dipòsit:",
"Configure Repositories" => "Configura dipòsits",
"Configure this Repository" => "Configurar aquest dipòsit",
"View this Repository" => "Veure aquest dipòsit",
"New Rule" => "Nova regla",
"Copy Rules" => "Copiar regles",
"view/hide copy rules dialog" => "veure/amagar diàleg de copies de regles",
"Source repository" => "Eines del dipòsit",
"Copy" => "Copiar",
"According this order rules will be applied ('0' or empty = auto)" => "Segons aquest ordre de regles, s'aplicarà ('0' o buit = auto)",
"Rule order" => "Ordre de regles",
"Text to search for" => "Text a cercar per",
"Text to replace" => "Texte a reemplaçar",
"Is this regular expression or simple search/replacer" => "És aquesta una expressió regular  o una simple paraula de recerca",
"Regex" => "Expresió Regular",
"Is case sensitive (for simple replacer)" => "És sensible a les majúscules (per a poder sobreescriure)",
"Case sensitive" => "Sensible a Majúscules",
"subset of chars: imsxeADSXUu, which is regex modifiers" => "subconjunt de caràcters:  imsxeADSXUu, els quals son modificadors d'expresions regulars",
"Regex modifiers" => "Modificadors d'expresions regulars",
"Human-readable text description of rule" => "Norma escrita de forma llegible",
"Check to enable this rule" => "marcar per a habilitar aquesta norma",
"Preview options" => "Previsualitzar opcions",
"Apply all rules or just this to generate preview" => "Aplica totes les normes o només per a generar aquesta vista prèvia",
"Apply all rules" => "Aplica totes les normes",
"View source code after rules applied" => "Visualitza el codi font després que s'apliquin les regles",
"Code preview" => "vista prèvia del Codi",
"Generate HTML preview" => "Generar vista prèvia",
"HTML preview" => "Vista prèvia en HTML",
"Test file from repository to generate preview for (empty = configured start page)" => "Fitxer test del dipòsit per generar previsualització per (buit = pàgina d'inici configurada)",
"Preview Results" => "Previsualitzar resultats",
"Rules List" => "Llista de Regles",
"Case" => "Cas",
"Configure/Options" => "Configura/Opcions",
// "Admin Invoices" => "Admin Invoices",
// "Admin keywords" => "Admin keywords",
// "Keywords have been updated" => "Keywords have been updated",
// "Updating keywords has failed. Page probably doesn't exist" => "Updating keywords has failed. Page probably doesn't exist",
// "Edit page keywords" => "Edit page keywords",
// "Current Page Keywords" => "Current Page Keywords",
// "Search by page" => "Search by page",
"results found" => "resultats trobats",
"No pages found" => "No s'han trobat pàgines",
"Admin layout" => "Administrar colocació dels elements",
"Theme control" => "Control de temes",
"layout options" => "opcions de format",
// "{\$sections[ix].name}" => "{\$sections[ix].name}",
"Right column" => "Columna dreta",
"Top bar" => "Barra d'encapçalament",
"Bottom bar" => "Barra al peu",
// "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>" => "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>",
"Generate positions by hits" => "Genera posicions per cops",
"List of featured links" => "Llista d'enllaços destacats",
"Add Featured Link" => "Afegeix un enllaç",
"Edit this Featured Link:" => "Edita aquest Enllaç Especial:",
"Create new Featured Link" => "Crea un nou Enllaç Especial",
"disables the link" => "deshabilita l'enllaç",
"Link type" => "Tipus d'enllaç",
"replace current page" => "reemplaçar la pàgina actual",
"framed" => "en un marc",
"open new window" => "obrir una finestra nova",
"Mail-in accounts" => "Comptes de Correu-in",
// "{\$accounts[ix].type}" => "{\$accounts[ix].type}",
"Add new Mail-in account" => "Afegeix un nou compte de Correu-dins",
"Edit Mail-in account" => "Edita el compte de correu-dins",
"POP server" => "Servidor POP",
"SMTP server" => "Servidor SMTP",
"SMTP requires authentication" => "SMTP requereix autenticació",
"article-put" => "article-put",
"wiki-get" => "wiki-get",
"wiki-put" => "wiki-put",
"wiki-append" => "wiki-append",
"Article Topic" => "Tema de l'article",
"Admin Topics" => "Admin temes",
"Article Type" => "Tipus de l'article",
// "{\$types[t].type}" => "{\$types[t].type}",
"Admin Types" => "Administrar tipus",
"Active" => "Actiu/va",
"Allow anonymous access" => "Permetre accès anònim",
"Allow attachments" => "Permetre adjunts",
"Discard to the end from" => "Descarta fins al final des de",
"Check Mail-in accounts" => "comprovar comptes de Mail",
"Check automatically" => "comprovar automàticament",
"Frequency" => "Freqüència",
"mn" => "mn",
"Admin Menu" => "Admin menú",
"List menus" => "Llista menús",
"Edit this menu" => "Edita menú",
// "Manage menu" => "Manage menu",
"Menu options" => "Opcions del menú",
// "switch with previous option" => "switch with previous option",
// "switch with next option" => "switch with next option",
// "Create menu option" => "Create menu option",
// "Edit menu option" => "Edit menu option",
"Show Quick Urls" => "Mostra Urls Ràpides",
"Some useful URLs" => "Algunes URLS útils",
"Hide Quick Urls" => "Amaga Urls Ràpides",
"Home" => "Inici",
"Choose" => "Escull",
"Home Blog" => "Bloc Inicial",
"Home Image Gal" => "Galeria d'imatges Inicial",
"Home Image Gallery" => "Galeria d'imatges Inicial",
"Home File Gal" => "Galeria d'arxius Inicial",
"Home File Gallery" => "Galeria d'arxius Inicial",
"User preferences" => "Preferències de l'usuari",
"User prefs" => "Prefs de l'usuari",
"Wiki Home" => "Inici del Wiki",
"List galleries" => "Llista les galeries",
"List image galleries" => "Llista galeries d'imatges",
"Upload image" => "Pujar imatge",
"Gallery Rankings" => "Posicions de galeries",
"Browse a gallery" => "Fulleja una galeria",
"Articles home" => "Inici d'articles",
"All articles" => "Tots els articles",
"List articles" => "Llistar articles",
"List Blogs" => "Llista bitàcoles",
"Create Blog" => "Crea Bloc",
"View a forum" => "Visualitza fòrum",
"View a thread" => "Visualitza missatge",
"View a FAQ" => "Veure una PUF",
"Take a quiz" => "Resol un test",
"Quiz stats" => "Estadístiques dels Tests",
"Stats for a Quiz" => "Estadístiques per un Test",
// "For wiki page, use ((PageName))" => "For wiki page, use ((PageName))",
"option" => "opció",
"section level 0" => "secció de nivell 0",
"section level 1" => "secció de nivell 1",
"section level 2" => "secció de nivell 2",
"section level 3" => "secció de nivell 3",
"sorted section level 0" => "secció ordenada de nivell 0",
"separator" => "separador",
// "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each" => "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each",
// "If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed" => "If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed",
// "Separate multiple feature/preferences with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple feature/preferences with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
// "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
"Preview menu" => "Previsualitza menú",
// "Appearance" => "Appearance",
// "Import/export menu" => "Import/export menu",
"Export CSV data" => "Exporta dades CSV",
"Import CSV data" => "Importa dades CSV",
// "To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'" => "To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'",
// "RESET" => "RESET",
// "Clone this menu and its options" => "Clone this menu and its options",
// "Create/Edit Menu" => "Create/Edit Menu",
"Edit this Menu:" => "Edita aquest menú:",
"Create new Menu" => "Crea un nou menú",
"dynamic collapsed" => "col·lapsat dinàmic",
"dynamic extended" => "dinàmic extès",
"fixed" => "fixat",
// "Labels of all options will be wiki parsed" => "Labels of all options will be wiki parsed",
// "Folder Icon" => "Folder Icon",
// "Path and filename of closed folder icon" => "Path and filename of closed folder icon",
// "To use custom folder icons in menus, enter the path to the icon for the <strong>closed</strong> folder" => "To use custom folder icons in menus, enter the path to the icon for the <strong>closed</strong> folder",
// "In the same directory, include an icon for the opened folder" => "In the same directory, include an icon for the opened folder",
// "The \"opened folder\" icon name must be identical to the \"closed folder\" icon name, prefixed with the letter <strong>o</strong>" => "The \"opened folder\" icon name must be identical to the \"closed folder\" icon name, prefixed with the letter <strong>o</strong>",
// "For example, the default icon is: img/icons/folder.png" => "For example, the default icon is: img/icons/folder.png",
// "The name of the \"open folder\" icon is: img/icons/ofolder.png" => "The name of the \"open folder\" icon is: img/icons/ofolder.png",
// "Configure icons for menu entries" => "Configure icons for menu entries",
// "You can use menus by assigning the menu <a href=\"tiki-admin_modules.php\">module</a> (to the top, left, right, etc.), or you can customize a template, using {literal}{menu id=x}{/literal}, where x is the ID of the menu" => "You can use menus by assigning the menu <a href=\"tiki-admin_modules.php\">module</a> (to the top, left, right, etc.), or you can customize a template, using {literal}{menu id=x}{/literal}, where x is the ID of the menu",
// "To use a menu in a tiki format" => "To use a menu in a tiki format",
// "To use menu in a css/suckerfish format" => "To use menu in a css/suckerfish format",
// "To customize the menu's CSS id (#)" => "To customize the menu's CSS id (#)",
// "Admin Metrics" => "Admin Metrics",
// "Metrics" => "Metrics",
// "Assign Metrics" => "Assign Metrics",
// "Assigned Metrics" => "Assigned Metrics",
// "Edit/Create Metrics" => "Edit/Create Metrics",
// "Edit/Create Tab" => "Edit/Create Tab",
// "Data Type" => "Data Type",
"Weight" => "Pes",
// "Metric Name" => "Metric Name",
// "Tab Name" => "Tab Name",
// "Assign metric" => "Assign metric",
// "Edit this assigned metric" => "Edit this assigned metric",
// "Tab for metric" => "Tab for metric",
// "Create new metric" => "Create new metric",
// "Edit this metric" => "Edit this metric",
// "Hints" => "Hints",
// "For list-based metrics, include the \"LIMIT #\" in your query" => "For list-based metrics, include the \"LIMIT #\" in your query",
// "Name (must be unique)" => "Name (must be unique)",
// "Create Metric" => "Create Metric",
// "Edit Metric" => "Edit Metric",
// "Create new tab" => "Create new tab",
// "Edit this tab" => "Edit this tab",
// "Weight (must be integer)" => "Weight (must be integer)",
// "Create Tab" => "Create Tab",
// "Edit Tab" => "Edit Tab",
"Clear Cache" => "Esborra memòria cau",
// "Show hidden modules" => "Show hidden modules",
// "Hide hidden modules" => "Hide hidden modules",
// "Exit Modules" => "Exit Modules",
// "Modules Parameters" => "Modules Parameters",
// "The following required parameters are missing" => "The following required parameters are missing",
// "Drag the modules around to re-order then click save when ready" => "Drag the modules around to re-order then click save when ready",
// "Double click them to edit" => "Double click them to edit",
// "Modules with \"position: absolute\" in their style can be dragged in to position" => "Modules with \"position: absolute\" in their style can be dragged in to position",
// "New modules can be dragged from the \"All Modules\" tab" => "New modules can be dragged from the \"All Modules\" tab",
// "Links and buttons in modules, apart from the Application Menu, have been deliberately disabled on this page to make drag and drop more reliable. Click here to return <a href=\"./\">HOME</a>" => "Links and buttons in modules, apart from the Application Menu, have been deliberately disabled on this page to make drag and drop more reliable. Click here to return <a href=\"./\">HOME</a>",
// "More info here" => "More info here",
"Assigned modules" => "Mòduls Assignats",
// "Assign/Edit modules" => "Assign/Edit modules",
"Assigned Modules" => "Mòduls assignats",
// "Add module" => "Add module",
// "Move Up" => "Move Up",
// "Move Down" => "Move Down",
// "Edit module" => "Edit module",
"Assign new module" => "Assigna un nou mòdul",
"Edit this assigned module:" => "Edita el mòdul asignat:",
// "Module Options" => "Module Options",
// "Custom Modules" => "Custom Modules",
// "Create new custom module" => "Create new custom module",
// "Edit this custom module" => "Edit this custom module",
"Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\">assigning it</a>. Using HTML, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site." => "Crea el teu nou mòdul personalitzat a continuació. Assegura't de previsualitzar-lo primer i que tot és correcte abans d'<a href=\"#assign\">assignar-lo</a>. Pots emprar html si vols a més. No obstant això, si utilizes la sintaxi wiki o un codi Smarty de manera incorrecta, pot ser que tu mateix t'expulsis del lloc web.",
"Must be wiki parsed" => "Interpreta el format Wiki",
"Objects that can be included" => "Objectes que es poden incloure",
"Available polls" => "Consultes disponibles",
"Random active poll" => "Consulta activa aleatòria",
"Random current poll" => "Consulta actual aleatòria",
"Use Poll" => "Empra la consulta",
"Random image from" => "Imatge a l'atzar de",
"Use Gallery" => "Empra galeria",
"Dynamic content blocks" => "Blocs de contingut dinàmic",
"Use Dynamic Content" => "Usa contingut dinàmic",
"Use RSS Module" => "Empra mòdul RSS",
// "Default Tiki menus" => "Default Tiki menus",
"Use Menu" => "Empra menú",
// "CSS menus" => "CSS menus",
// "Use CSS menu" => "Use CSS menu",
"Banner zones" => "Zones de banners",
"Use Banner Zone" => "Usa zones de banners",
"Structures:" => "Estructures:",
"Use Wiki Structure" => "Empra Estructura Wiki",
// "To use a <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\">CSS (Superfish) menu</a>, use one of these syntaxes" => "To use a <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\">CSS (Superfish) menu</a>, use one of these syntaxes",
// "To use a default Tiki menu" => "To use a default Tiki menu",
"Data" => "Dades",
// "All Modules" => "All Modules",
// "Show all modules" => "Show all modules",
"Admin newsletter subscriptions" => "Administrar subscripcions al butlletí",
"List Newsletters" => "Llista fulls de notícies",
"Edit Newsletter" => "Edita el Butlletí",
"Admin Newsletters" => "Administra fulls de notícies",
"Send Newsletters" => "Envia Butlletins",
"Subscriptions" => "Subscripcions",
// "Groups included through inheritence" => "Groups included through inheritence",
"Wiki Page Name" => "Nom de pàgina wiki",
"Validate Addresses" => "Valida les adreces",
"Add To List" => "Afegeix-ne a la llista",
"Valid" => "Vàlid",
"Subscribed" => "subscrit",
// "Unsubscribed" => "Unsubscribed",
"Add subscribers" => "Afegeix subscriptors",
"You can add several email addresses by separating them with commas." => "Podeu afegir varies adreces de correu electrònic separant-les amb comes.",
"Add email:" => "Afegeix email:",
"Add user:" => "Afegeix usuari:",
"Users from group" => "Usuaris del grup",
"Group subscription also subscribes included groups" => "La subscripció al grup també subscriu als grups inclosos",
"Don't send confirmation mail" => "No enviis un correu electrònic de confirmació",
"The user email will be refreshed at each newsletter sending" => "El correu-e de l'usuari s'actualitzarà cada vegada que s'envii un butlletí",
"Import emails from file" => "Importa correus-e des d'un arxiu",
"txt file, one e-mail per line" => "arxiu txt, amb un correu-e a cada línia",
"Don't send confirmation mails" => "No enviïs correus-e de confirmació",
"Import emails from wiki page" => "Importa correus-e des d'una pàgina wiki",
"Wiki page, one e-mail per line" => "Pàgina wiki, un correu-e a cada línia",
"Subscribe group" => "Subscriu el grup",
// "Including group inheritence" => "Including group inheritence",
// "Including group, group users and emails will be refreshed at each newsletter sending" => "Including group, group users and emails will be refreshed at each newsletter sending",
"Use subscribers of another newsletter" => "Empra subscriptors d'un altre butlletí",
"Use emails from wiki page" => "Empra correus-e des de pàgina wiki",
"Emails on a wiki page which will be added at each newsletter sending, one e-mail per line" => "Correus-e a una pàgina wiki que seran afegits cada vegada que s'enviï un nou butlletí, amb un correu-e a cada línia",
"Don't subscribe emails" => "No subscriguis correus-e",
"Export Subscriber Emails" => "Exporta els correus-e dels subscriptors",
"Admin newsletters" => "Administrar butlletins",
"Create Newsletter" => "Crea un Butlletí",
"Editions" => "Edicions",
"Drafts" => "Esborranys",
"Last Sent" => "últims enviats",
"Assign Permissions" => "Assignar permisos",
"Create/Edit Newsletters" => "Crea/edita butlletins",
"There are individual permissions set for this newsletter" => "Hi ha permisos individuals fixats per a aquest butlletí",
"Users can subscribe/unsubscribe to this list" => "Els usuaris es poden subscriure/desubscriure a la llista d'aquest butlletí",
"Users can subscribe any email address" => "Els usuaris poden subscriure qualsevol adreça de correu-e",
"Add unsubscribe instructions to each newsletter" => "Afegir instruccions de desubscripció a cada butlletí",
"Validate email addresses" => "Valida adreces de correu-e",
"Allow customized text message to be sent with the HTML version" => "Permet que s'hi pugui posar un missatge de text senzill personalitzat amb l'enviament de la versió en html",
"Allow clipping of articles into newsletter" => "Permet el retallat d'articles a dins d'un butlletí",
"Automatically clip articles into newsletter" => "Retalla automàticament els articles a dins del butlletí",
"Clip articles published in the past number of days" => "Retalla els articles publicats en el darrer número de dies",
"Article types to clip" => "Tipus d'articles a retallar",
"Mail notifications" => "Notificacions per correu-e",
"You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications" => "Has d'especificar el <a href=\"tiki-admin.php?page=general\">Correu-e de l'enviador</a> abans de crear notificacions de correu-e",
"Add notification" => "Afegeix notificació",
"Alert" => "Alerta",
"Event" => "Esdeveniment",
// "Destination" => "Destination",
// "Myself" => "Myself",
// "Note that a user is not notified for his own action" => "Note that a user is not notified for his own action",
// "User / Group" => "User / Group",
// "Trackers Outbound Emails" => "Trackers Outbound Emails",
// "Forums Outbound Emails" => "Forums Outbound Emails",
"Admin Polls" => "Administrar consultes",
"List polls" => "Llista consultes",
"Edit this poll" => "Edita consulta",
"Preview poll" => "Previsualitza consultes",
"Add poll option" => "Afegix opció per a la consulta",
"Edit poll option" => "Edita l'opció de la consulta",
"Poll options" => "Opcions de la consulta",
"Votes" => "Vots",
"Set last poll as current" => "Posar l'última consulta com actual",
"Close all polls but last" => "Tanca totes les consultes menys la darrera",
"Activate all polls" => "Activar totes les consultes",
"Create poll" => "Crea una consulta",
"Edit poll" => "Edita la consulta",
"active" => "actiu/va",
"current" => "actual",
"object" => "objecte",
// "Toggle Quick Options" => "Toggle Quick Options",
// "Add Option" => "Add Option",
// "Leave box empty to delete an option" => "Leave box empty to delete an option",
// "Votes older than these days are not considered" => "Votes older than these days are not considered",
// "0 for no limit" => "0 for no limit",
"Objects" => "Objectes",
"Results" => "Resultats",
"Add poll to pages" => "Afegeix consulta a pàgines",
// "{\$channels[ix].title}" => "{\$channels[ix].title}",
// "This menu shows only Polls with 'status': \"template\"" => "This menu shows only Polls with 'status': \"template\"",
"Wiki pages" => "Pàgines Wiki",
// "{\$listPages[ix].pageName|escape}" => "{\$listPages[ix].pageName|escape}",
"Lock the pages" => "Bloqueja les pàgines",
// "Admin External Feeds" => "Admin External Feeds",
// "Tips" => "Tips",
// "This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or" => "This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or",
// "To use feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed" => "To use feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed",
"Content for the feed" => "Contingut per a l'alimentació",
// "External Feeds" => "External Feeds",
// "Show Date" => "Show Date",
"Refresh rate" => "Temps de refresc",
// "View feed" => "View feed",
// "Article Generator" => "Article Generator",
// "Edit Feed" => "Edit Feed",
// "Create Feed" => "Create Feed",
// "Create new external feed" => "Create new external feed",
"show feed title" => "mostrar titol del feed",
"show publish date" => "mostrar data de publicació",
// "The article generator will create a new article for every item read in the RSS feed" => "The article generator will create a new article for every item read in the RSS feed",
// "Use Article Submission System" => "Use Article Submission System",
// "Publish in the future" => "Publish in the future",
// "-1 to use original publishing date from the feed" => "-1 to use original publishing date from the feed",
// "Configure" => "Configure",
"Security Admin" => "Admin Seguretat ",
"To <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">report any security issues</a>." => "Per <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">informar de qualsevol incidència relacionada amb la seguretat</a>.",
// "For additional security checks, please visit <a href=\"tiki-check.php\">Tiki Server Compatibility Check</a>" => "For additional security checks, please visit <a href=\"tiki-check.php\">Tiki Server Compatibility Check</a>",
// "Tiki settings" => "Tiki settings",
"Tiki variable" => "Variable de Tiki",
"Risk Factor" => "Factor de Risc",
"Explanation" => "Explicació",
// "About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors" => "About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors",
// "You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)" => "You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)",
// "Security checks" => "Security checks",
"Check all tiki files" => "Comprova tots els arxius de tiki",
"Note, that this can take a very long time. You should check your max_execution_time setting in php.ini." => "Tingues present que això pot prendre's una estona molt llarga. Seria convenient comprovar el paràmetre del temps màxim d'execució (max_execution_time) a l'arxiu php.ini.",
"File checks" => "Comprovacions d'arxius",
// "Check file permissions" => "Check file permissions",
// "This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments" => "This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments",
// "See end of table for detailed explanations" => "See end of table for detailed explanations",
// "owner" => "owner",
// "special" => "special",
"user" => "usuari",
"group" => "grup",
// "other" => "other",
// "uid" => "uid",
// "gid" => "gid",
// "suid" => "suid",
// "sgid" => "sgid",
"sticky" => "enganxós",
// "r" => "r",
// "w" => "w",
// "Set User ID (suid) files" => "Set User ID (suid) files",
// "World writable files or directories" => "World writable files or directories",
// "Files or directories the Webserver can write to" => "Files or directories the Webserver can write to",
// "Strange Inodes (not file, not link, not directory)" => "Strange Inodes (not file, not link, not directory)",
// "Executable files" => "Executable files",
// "What to do with these check results" => "What to do with these check results",
// "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"" => "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"",
// "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content" => "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content",
// "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information" => "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information",
// "Inodes that are not files or directories are not part of tiki. Review these Inodes" => "Inodes that are not files or directories are not part of tiki. Review these Inodes",
// "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod" => "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod",
"Admin Shoutbox Words" => "Administra quadre d'avisos",
"Add Banned Word" => "Afegeix una paraula prohibida",
"Are you sure you want to delete this word?" => "Segur que voleu eliminar aquesta paraula?",
// "XML Zip Import" => "XML Zip Import",
"The structure" => "L'Estructura",
"has just been created." => "ha estat creada ara mateix.",
"You will remove structure" => "Esborraràs lestructura",
"Destroy the structure leaving the wiki pages" => "Destrueix l'estructura deixant les pàgines wiki",
"Destroy the structure and remove the pages" => "Destrueix l'estructura i esborra les pàgines",
"Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict:" => "Pren nota que les pàgines següents formen part també d'una altra estructura. Assegura't que els permisos d'accés (si n'hi ha) no entren en conflicte:",
"The following pages have automatically been categorized with the same categories as the structure:" => "Les pàgines següents han estat categoritzades automàticament amb les mateixes categories que l'estructura:",
"The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent:" => "Les pàgines següents estan assignades a categories però l'estrucura no en té assignada cap. És possible que vulguis descategoritzar-les per ser consistent:",
"The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent:" => "Les següents pàgines es troben en categories a les quals l'estructura no es troba assignada. És possible qeu vulguis recategoritzar-les a fi i efecte de ser consistent:",
"Edit structure" => "Edita l'estructura",
"View structure" => "Visualitza l'estructura",
"Export Pages" => "Exportar pàgines",
"PDF" => "PDF",
"Dump Tree" => "Baixa't l'arbre",
"Create WebHelp" => "Crear AjudaWeb",
"View WebHelp" => "Visualitza ajutweb",
"XML Zip" => "Zip XML",
"Delete with the pages" => "Esborra-ho amb les pàgines",
"Create New Structure" => "Crear nova estructura",
"Alias" => "Àlies",
"Tree" => "Arbre",
"Use single spaces to indent structure levels" => "Empra espais simples per indentar nivells d'estructura",
"Edit survey questions" => "Edita preguntes de l'enquesta",
// "Add a New Question" => "Add a New Question",
"List surveys" => "Llista enquestes",
"Survey Stats" => "Estadístiques d'enquestes",
// "This survey stats" => "This survey stats",
"Edit this Survey" => "Edita aquesta enquesta",
"Admin Surveys" => "Administra enquestes",
// "Edit Survey Question" => "Edit Survey Question",
// "Add a New Question to this survey" => "Add a New Question to this survey",
"Question" => "Pregunta",
"One choice" => "Una opció",
"Multiple choices" => "Múltiples opcions",
// "Multiple choices of thumbnails from a file gallery" => "Multiple choices of thumbnails from a file gallery",
"Short text" => "Text curt",
// "Wiki textarea" => "Wiki textarea",
"Rate (1..5)" => "Valor (1..5)",
"Rate (1..10)" => "Valor (1..10)",
"Answer is mandatory" => "La resposta és obligatòria",
// "Number of required answers (for multiple choices)" => "Number of required answers (for multiple choices)",
"For a multiple answer question put the answers into the following field, separated by a comma. Example: one,two,many,lots" => "Per qüestions amb múltiples respostes escriu les respostes en el camp següent separades per comes. Exemple: un, dos, alguns, molts",
"For a rate, you can give the maximum value." => "Per a una valoració, pots donar el valor màxim.",
// "For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4" => "For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4",
// "For the 'wiki textarea' type, options are: rows,columns. Example: 10,60" => "For the 'wiki textarea' type, options are: rows,columns. Example: 10,60",
"Options (if apply)" => "Opcions (si és el cas)",
"Questions" => "Preguntes",
"Admin surveys" => "Administrar enquestes",
"List Surveys" => "Llista Enquestes",
"Create Survey" => "Crea una Enquesta",
"Create/Edit Surveys" => "Crea/Edita Enquestes",
"Edit this Survey:" => "Edita aquesta Enquesta:",
"Create New Survey" => "Crea Nova Enquesta",
"There are individual permissions set for this survey" => "Hi ha permisos individuals fixats per a aquesta enquesta",
"Tiki Cache/System Admin" => "Tiki Cau/Admin Sistema",
"If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed)." => "Si el teu Tiki està actuant de forma rara, la primera cosa a provar és netejar la memòria cau de sota. També és molt important netejar la teva memòria cau després d'una actualització (per FTP/SSH si és necessari).",
// "Also see \"Rebuild Index\" in the <a href=\"tiki-admin.php?page=search\">Search Admin Panel</a>" => "Also see \"Rebuild Index\" in the <a href=\"tiki-admin.php?page=search\">Search Admin Panel</a>",
// "Clear cached content" => "Clear cached content",
// "Directory to clear" => "Directory to clear",
"Empty" => "Buit",
// "Directories to save" => "Directories to save",
// "Full Path to the Zip File" => "Full Path to the Zip File",
// "Generate a zip of those directories" => "Generate a zip of those directories",
// "A zip has been written to %0" => "A zip has been written to %0",
// "Directory is not writeable" => "Directory is not writeable",
"Clean" => "Neteja",
// "Groups still used in the database but no more defined" => "Groups still used in the database but no more defined",
// "Click to remove" => "Click to remove",
// "Admin Tokens" => "Admin Tokens",
// "List tokens" => "List tokens",
// "Entry" => "Entry",
// "Timeout" => "Timeout",
// "Max hits" => "Max hits",
// "Add new token" => "Add new token",
// "Token successfully created" => "Token successfully created",
// "Full URL" => "Full URL",
// "Timeout in seconds (-1 for unlimited)" => "Timeout in seconds (-1 for unlimited)",
// "Maximum number of hits (-1 for unlimited)" => "Maximum number of hits (-1 for unlimited)",
// "Groups (separated by comma)" => "Groups (separated by comma)",
// "View mode" => "View mode",
// "Wiki and WYSIWYG" => "Wiki and WYSIWYG",
// "Wiki only" => "Wiki only",
// "WYSIWYG only" => "WYSIWYG only",
// "Visual Wiki" => "Visual Wiki",
// "Load" => "Load",
// "Reset to Global" => "Reset to Global",
// "Reset to defaults" => "Reset to defaults",
// "Auto Reloading" => "Auto Reloading",
// "Row" => "Row",
// "Formatting Tools" => "Formatting Tools",
// "Plugin Tools" => "Plugin Tools",
// "Edit tool" => "Edit tool",
// "Wysiwyg Token" => "Wysiwyg Token",
// "Plugin name" => "Plugin name",
// "Custom Tools" => "Custom Tools",
// "Add a new custom tool" => "Add a new custom tool",
// "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br />\nDrag icons back from the toolbar rows onto the full list to remove them.<br />\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br />\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save" => "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br />\nDrag icons back from the toolbar rows onto the full list to remove them.<br />\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br />\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save",
// "If you are experiencing problems with this page after upgrading from Tiki 4 please use this link to delete all your customised tools" => "If you are experiencing problems with this page after upgrading from Tiki 4 please use this link to delete all your customised tools",
// "Delete all custom tools" => "Delete all custom tools",
// "Warning: There is no undo" => "Warning: There is no undo",
// "Admin Article Topics" => "Admin Article Topics",
// "Add topic" => "Add topic",
"topic image" => "imatge del tema",
"Active Permissions" => "Permisos actius",
"Inactive - Click to Activate" => "Inactiu/va - Clica per Activar",
"Deactivate" => "Desactiva",
"Active - Click to Deactivate" => "Actiu/va - Clica per Deactivar",
"Remove with articles" => "Esborrar amb els articles",
"Admin Tracker" => "Administra formulari",
"Tracker fields" => "Camps de formulari",
"Mandatory" => "Obligatori",
"Save All" => "Desa-ho Tot",
"Remove Selected" => "Elimina els seleccionats",
"Export Selected" => "Exporta els seleccionats",
"Add Field" => "Afegeix un camp",
"Import Tracker Fields" => "Importa Camps del Formulari-bd",
"Raw Fields" => "Camps en brut",
"Preserve Field IDs" => "Manté els IDs dels camps",
"Transitions" => "Transicions",
"Subset Selection" => "Escoge subslección",
// "Category Selection" => "Category Selection",
// "Group Selection" => "Group Selection",
// "Type in a group name and click \"enter\"" => "Type in a group name and click \"enter\"",
// "Once you have selected at least two, click" => "Once you have selected at least two, click",
// "and then, click the \"New/Edit\" tab which will appear above" => "and then, click the \"New/Edit\" tab which will appear above",
// "Draw Transition Diagram" => "Draw Transition Diagram",
// "Guards" => "Guards",
// "preserved" => "preserved",
// "Assign permissions for transition" => "Assign permissions for transition",
// "No transitions" => "No transitions",
"New / Edit" => "Nuevo / Edita",
"Edit <em>%0</em>" => "Edita <em>%0</em>",
// "New transition" => "New transition",
// "Upon trigger, preserve the initial state" => "Upon trigger, preserve the initial state",
"Members" => "Membres",
// "No guards on this transition" => "No guards on this transition",
// "New Guard" => "New Guard",
"Exactly" => "Exactly",
"At Least" => "Com a mínim",
"At Most" => "Com a molt",
"States" => "Estats",
"Admin groups" => "Administra grups",
"Admin users" => "Administra usuaris",
"Add new group" => "Afegeix un nou grup",
"Invitation List" => "Llista de convidats",
"List of existing groups" => "Llista de grups existents",
// "Inherits Permissions from" => "Inherits Permissions from",
"User Choice" => "elecció de l'usuari",
// "{\$users[user].groupDesc|escape|nl2br}" => "{\$users[user].groupDesc|escape|nl2br}",
"Group Homepage" => "Pàgina del Grup",
// "{\$users[user].groupHome}" => "{\$users[user].groupHome}",
// "{\$users[user].userChoice}" => "{\$users[user].userChoice}",
"Edit group" => "Edita el grup",
"Add a New Group" => "Afegeix un grup nou",
"Group is NOT being monitored. Click icon to START monitoring" => "El Grup NO està essent monitorejat. Fes clic a la icona per a COMENÇAR A monitorejar-lo",
"Group IS being monitored. Click icon to STOP monitoring" => "El Grup SI que està essent monitorejat. Fes clic a la icona per a DEIXAR DE monitorejar-lo",
// "Inherit permissions directly from following groups" => "Inherit permissions directly from following groups",
// "Also inheriting permissions from the following groups (indirect inheritance through the groups selected above)" => "Also inheriting permissions from the following groups (indirect inheritance through the groups selected above)",
"Group Homepage or Url" => "Pàgina o URL d'Inici de Grup",
"Use wiki page name or full URL" => "Empra pàgina Wiki o URL sencera",
// "For other Tiki features, use links relative to the Tiki root (such as <em>/tiki-forums.php</em>)" => "For other Tiki features, use links relative to the Tiki root (such as <em>/tiki-forums.php</em>)",
"Default category assigned to uncategorized objects edited by a user with this default group" => "Categoria per defecte assignada a objectes no categoritzats editats per un usuari amb aquest grup per defecte",
"Group Theme" => "Tema (d'estètica) per al Grup",
"Use site default" => "Fes servir el que hi ha per defecte al lloc",
"Group Information Tracker" => "Formulari-bd per a la informació del Grup",
"choose a group tracker ..." => "escull un formulari de grup ...",
"choose a field ..." => "escull un camp ...",
"Users Information Tracker" => "Formulari-bd per a la informació dels Usuaris",
"choose a users tracker ..." => "escull un formulari d'usuaris ...",
"Users Information Tracker Fields Asked at Registration Time<br />(fieldIds separated with :)" => "Camps del Formulari-bd d'Informació d'Usuaris que es demanaran en el moment de Registre<br />(IdsDeCamps separats amb :)",
"User can assign to the group himself" => "L'usuari es pot afegir ell mateix al grup",
// "Users are automatically unassigned from the group after" => "Users are automatically unassigned from the group after",
// "0 or empty for never" => "0 or empty for never",
// "Or, users are automatically unassigned from the group at an anniversary date" => "Or, users are automatically unassigned from the group at an anniversary date",
// "MMDD for annual or DD for monthly" => "MMDD for annual or DD for monthly",
// "Payment for membership extension is prorated at a minimum interval of a" => "Payment for membership extension is prorated at a minimum interval of a",
// "Users are automatically assigned at registration in the group if their emails match the pattern" => "Users are automatically assigned at registration in the group if their emails match the pattern",
// "Example: " => "Example: ",
// "Assign group <em>management</em> permissions" => "Assign group <em>management</em> permissions",
"Group tracker item : {\$groupitemid}" => "Item del formulari de Grup : {\$groupitemid}",
"Edit Item" => "Edita ítem",
"Group tracker item not found" => "No s'ha trobat l'ítem del formulari de Grup",
"Choose a field .." => "Escull un camp ..",
"Members List" => "Llista de membres",
"Expire" => "Caduca",
"Remove from Group" => "Elimina del grup",
"users in group" => "usuaris en el grup",
// "Banned members List" => "Banned members List",
// "Unban user" => "Unban user",
// "Add or Ban members to" => "Add or Ban members to",
// "Add to group" => "Add to group",
// "Ban user from group" => "Ban user from group",
"Import/Export" => "Importa/Exporta",
"Download CSV export" => "Descarrega't exportació en format CSV",
"Charset encoding:" => "Codificació de caràcters:",
"UTF-8" => "UTF-8",
"ISO-8859-1" => "ISO-8859-1",
"Assign users to group:" => "Assigna usuaris al grup:",
// "Each user in the file must already exist" => "Each user in the file must already exist",
// "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>" => "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>",
"Add a New User" => "Afegeix un nou usuari",
// "Since this Tiki site is in slave mode and imports groups, the master groups will be automatically reimported at each login" => "Since this Tiki site is in slave mode and imports groups, the master groups will be automatically reimported at each login",
// "Since this Tiki site is in slave mode and imports preferences, the master user preferences will be automatically reimported at each login" => "Since this Tiki site is in slave mode and imports preferences, the master user preferences will be automatically reimported at each login",
// "{\$tikifeedback[n].mes|escape}" => "{\$tikifeedback[n].mes|escape}",
"Batch Upload Results" => "Pujada en bloc: Resultats",
"Updated users" => "Usuaris Actualitzats",
"Rejected users" => "usuaris rebutjats",
"Reason" => "Raó",
"More Criteria" => "Més Criteris",
"Group (direct)" => "Grup (directe)",
// "OpenID" => "OpenID",
"Edit Account Settings" => "Edita els paràmetres del compte",
// "N" => "N",
// "Registered %0 ago" => "Registered %0 ago",
// "Need to validate email" => "Need to validate email",
"Edit Included Group" => "Edita el grup inclòs",
// "Edit Group" => "Edit Group",
"default" => "per defecte",
// "Remove %0 from %1" => "Remove %0 from %1",
// "Assign to group" => "Assign to group",
// "Assign %0 to groups" => "Assign %0 to groups",
// "Edit Account Settings: %0" => "Edit Account Settings: %0",
// "Change user preferences: %0" => "Change user preferences: %0",
// "User Information: %0" => "User Information: %0",
// "Validate user: %0" => "Validate user: %0",
// "Confirm user email: %0" => "Confirm user email: %0",
// "Invalidate email" => "Invalidate email",
// "Remove link with OpenID account" => "Remove link with OpenID account",
"Remove Users and their Userpages" => "Elimina els usuaris i les seves pàgines d'usuari",
"Manage Group Assignments" => "Gestiona les assignacions a grups",
"Set Default Groups" => "Especifica els grups per defecte",
// "Send a wiki page by Email" => "Send a wiki page by Email",
"Assign selected to" => "Assigna els seleccionats a",
"Remove selected from" => "Elimina els escollits de",
"the following groups:" => "els següents grups:",
"Set the default group of the selected users to" => "Especifica que el grup per defecte dels usuaris seleccionats sigui",
"bcc" => "bcc",
"Edit user" => "Editeu l'usuari",
"Assign user to Groups" => "Assigna l'usuari a Grups",
"Use the email as username" => "Empra correu-e com a nom d'usuari",
// "Warning: changing the username could require the user to change his password (for user registered with an old Tiki&lt;=1.8)" => "Warning: changing the username could require the user to change his password (for user registered with an old Tiki&lt;=1.8)",
// "Warning: it will mess with slave intertiki sites that use this one as master" => "Warning: it will mess with slave intertiki sites that use this one as master",
"No password is required" => "No cal contrasenya",
// "Tiki is configured to delegate the password managment to LDAP" => "Tiki is configured to delegate the password managment to LDAP",
"Repeat Password" => "Repeteix la contrasenya",
"User must change password at next login" => "L'usuari ha de canviar la contrasenya a la següent connexió",
// "Send an email to the user in order to allow him to validate his account" => "Send an email to the user in order to allow him to validate his account",
"You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a>" => "Cal establir <a href=\"tiki-admin.php?page=general\">correu electrònic emissor</a>",
// "Pass confirmed" => "Pass confirmed",
// "Email confirmed" => "Email confirmed",
// "%0 days ago" => "%0 days ago",
// "Current Login" => "Current Login",
"Last Login" => "Darrera Connexió",
"User tracker item : {\$usersitemid}" => "Ítem del formulari de l'usuari : {\$usersitemid}",
// "You do not have permission to edit this user" => "You do not have permission to edit this user",
// "CSV file layout" => "CSV file layout",
// "login,password,email,groups,default_group,realName<br />user1,pass1,email1,group1,group1<br />user2,pass2,email2,\\\"group1,group2\\\",group1" => "login,password,email,groups,default_group,realName<br />user1,pass1,email1,group1,group1<br />user2,pass2,email2,\\\"group1,group2\\\",group1",
// "Only login, password, email are mandatory.Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma" => "Only login, password, email are mandatory.Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma",
// "Don't overwrite" => "Don't overwrite",
// "Overwrite groups" => "Overwrite groups",
// "Create groups" => "Create groups",
// "User must change password at first login" => "User must change password at first login",
// "You can export users of a group in <a href=\"tiki-admingroups.php\">admin->groups->a_group</a>" => "You can export users of a group in <a href=\"tiki-admingroups.php\">admin->groups->a_group</a>",
// "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences" => "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences",
"Admin Article Types" => "Administrar Tipus d'Article",
// "Article Types" => "Article Types",
// "{\$types[user].type|escape}" => "{\$types[user].type|escape}",
// "View articles with this type" => "View articles with this type",
// "Author rating" => "Author rating",
"Show before publish date" => "Mostrar avans de la data de publicació",
"Show after expire date" => "Mostrar despres de la data expirada",
"Heading only" => "Encapçalament només",
// "Comment can rate article" => "Comment can rate article",
"Show image" => "Mostrar imatge",
"Show avatar" => "Mostrar avatar",
"Show publish date" => "Mostrar data de publicació",
"Show expire date" => "Mostrar data d'expiració",
"Show reads" => "Mostrar lectures",
"Show size" => "Mostrar tamany",
"Show topline" => "Mostra línea superior",
"Show subtitle" => "Mostra subtítol",
"Show source" => "Mostra font",
// "Show image caption" => "Show image caption",
"Creator can edit" => "El creador pot editar-ho",
"Custom attribute" => "Atribut a mida",
// "Add Type" => "Add Type",
// "Add article type" => "Add article type",
"Assign User %0 to Groups" => "Assigna l'Usuari %0 als grups",
// "{\$users[user].groupDesc|escape}" => "{\$users[user].groupDesc|escape}",
"Assign User to Group" => "Assigna l'Usuari al Grup",
"backlinks to" => "retroenllaços cap a",
"No backlinks to this page" => "No hi ha retroenllaços a aquesta pàgina",
"Directory batch upload" => "Càrrega de lots de directoris",
"Browse Gallery" => "Fulleja galeria",
"Upload From Disk" => "Pujar des del disc local",
"available images" => "imatges disponibles",
"Filesize" => "Mida de l'arxiu",
"Filetype" => "Tipus d'arxiu",
// "Remove File Extension from Image Name" => "Remove File Extension from Image Name",
"eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field" => "ex. per \"digicam0001.jpg\" s'utilitzarà digicam0001 pel camp nom",
// "Convert the last sub directory to a sub gallery" => "Convert the last sub directory to a sub gallery",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created",
// "Use the last sub directory name as description" => "Use the last sub directory name as description",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created",
"Select a Gallery" => "Selecciona una Galeria",
"Browse File Gallery" => "Navega per la Galeria d'Arxius",
// "Please do not use this feature to upload data into the database" => "Please do not use this feature to upload data into the database",
// "Available Files" => "Available Files",
// "Remove extension from filename" => "Remove extension from filename",
// "Select a File Gallery" => "Select a File Gallery",
// "Process files" => "Process files",
"Edit Post" => "Edita la publicació",
"New Post" => "Nova Publicació",
"View post" => "Visualitza la publicació",
"View Blog" => "Visualitza el bloc",
"Note: Remember that this is only a preview, and has not yet been saved!" => "Avís: Recorda que això és només una previsualització, i que no ha estat gravat encara!",
"Excerpt" => "Extracte",
"Trash" => "Brossa",
"Mark entry as private:" => "Marca la publicació com a privada:",
// "Admin Category" => "Admin Category",
// "Admin the Category System" => "Admin the Category System",
"Browse in" => "Navega per",
"Image galleries" => "Galeries d'imatges",
"Trackers Items" => "Ítems dels Formularis-bd",
"Sheets" => "Fulls",
"in the current category - and its subcategories: " => "a la categoria actual - i les seves subcategories: ",
"Hide subcategories objects" => "Amaga els objectes de les subcategories",
"Show subcategories objects" => "Mostra els objectes de les subcategories",
"Upper level" => "Nivell de Pujada",
// "{\$objects[ix].type|replace:\"wiki page\":\"wiki\"|replace:\"trackeritem\":\"tracker item\"}" => "{\$objects[ix].type|replace:\"wiki page\":\"wiki\"|replace:\"trackeritem\":\"tracker item\"}",
"Browse related tags" => "Navega per les etiquetes relacionades",
"Network of Tags related to" => "Xarxa d'etiquetes relacionades a ",
"With all selected tags" => "Amb totes les etiquetes seleccionades",
"With one selected tag" => "Amb una etiqueta seleccionada",
"With last selected tag" => "Amb l'última etiqueta seleccionada",
"More Popular Tags" => "Etiquetes més populars",
"Alphabetically" => "Alfabèticament",
"By Size" => "Per mida",
"Cloud" => "Núvol",
// "{\$feature_label}" => "{\$feature_label}",
"No result found" => "No s'han trobat resultats",
"result found" => "resultat trobat",
// "{\$objects[ix].type|replace:\"wiki page\":\"Wiki\"|replace:\"article\":\"Article\"|regex_replace:\"/tracker [0-9]*/\":\"tracker item\"}" => "{\$objects[ix].type|replace:\"wiki page\":\"Wiki\"|replace:\"article\":\"Article\"|regex_replace:\"/tracker [0-9]*/\":\"tracker item\"}",
"Browsing Gallery" => "Fullejant Galeria",
"List Galleries" => "Llista les Galeries",
"Edit Gallery" => "Edita la Galeria",
"Rebuild Thumbnails" => "Reconstrueix miniatures",
"Upload Image" => "Pujarimatge",
"Directory Batch" => "Directori per pujada en bloc",
"List Gallery" => "Llista la galeria",
"All Images" => "Totes les imatges",
"RSS" => "RSS",
"Monitor this Gallery" => "Vigila aquesta Galeria",
"Stop Monitoring this Gallery" => "Deixa de vigilar aquesta Galeria",
// "{\$advice}" => "{\$advice}",
"Sort Images by" => "Ordena la imatge per",
"subgallery" => "subgaleria",
"Subgallery" => "Subgaleria",
"Original Size" => "Tamany original",
"rotate right" => "voltar a la dreta",
"rotate" => "voltar",
"Details" => "Detalls",
"popup" => "emergent",
"You can view this gallery's configured image (first, random, etc.) in your browser using" => "Pots veure la imatge que representa a aquesta galeria (la primera, a l'atzar, etc.) al teu navegador emprant",
"You can include the gallery's image in an HTML page using" => "Pots incloure la imatge d'aquesta galeria en una pàgina HTML emprant",
"You can include the image in a tiki page using" => "Pots incloure la imatge d'aquesta galeria en una pàgina de Tiki emprant",
"Browsing Image" => "Fullejant imatge",
"Return to Gallery" => "Torna a la galeria",
"Edit Image" => "Editar la imatge",
"First Image" => "Primera imatge",
"Prev Image" => "Imatge prèvia",
"Smaller" => "Més petit",
"Bigger" => "Més gran",
"Popup window" => "Finestra emergent",
"Next Image" => "Propera imatge",
"Slideshow Forward" => "Endavant el Passi de diapositives",
"Last Image" => "La última imatge",
"Cyclic" => "Cíclic",
"Click to zoom" => "Fes clic per ampliar",
"Image Name" => "Nom de la imatge",
"Image size" => "Mida de la imatge",
"Image Scale" => "Escala de la imatge",
"Latitude (WGS84/decimal degrees)" => "Latitud (WGS84/graus decimals)",
"Longitude (WGS84/decimal degrees)" => "Longitud (WGS84/graus decimals)",
"Move image" => "Moure la imatge",
"Include the image in a tiki page using the following syntax" => "Inclou la imatge d'aquesta galeria en una pàgina de Tiki emprant la següent sintaxi",
"To include the image in an HTML page" => "Per a incloure la imatge en una pàgina HTML",
"To link to this page from another tiki page" => "Per a enllaçar a aquesta pàgina des d'una altra pàgina de Tiki",
"Stop Monitoring this Page" => "Deixa de vigilar-ho",
"Monitor this Page" => "Vigila-ho",
"Export Calendars" => "Exporta els Calendaris",
"Click to export calendars" => "Clica per tal d'exportar els calendaris",
"Visible Calendars" => "Calendaris Visibles",
"Click to select visible calendars" => "Clica per seleccionar calendaris visibles",
"Group Calendars" => "Calendaris de Grup",
"Export calendars" => "Exporta els calendaris",
"advanced parameters" => "parametres avançats",
"Export as iCal" => "Exporta com a iCal",
"January" => "Gener",
"February" => "Febrer",
"March" => "Març",
"April" => "Abril",
"May" => "Maig",
"June" => "Juny",
"July" => "Juliol",
"August" => "Agost",
"September" => "Setembre",
"October" => "Octubre",
"November" => "Novembre",
"December" => "Desembre",
// "Jan" => "Jan",
// "Feb" => "Feb",
// "Mar" => "Mar",
// "Apr" => "Apr",
// "Jun" => "Jun",
// "Jul" => "Jul",
// "Aug" => "Aug",
// "Sep" => "Sep",
// "Oct" => "Oct",
// "Nov" => "Nov",
// "Dec" => "Dec",
"Sun" => "Dg",
"Mon" => "Dl",
"Tue" => "Dm",
"Wed" => "Dc",
"Thu" => "Dj",
"Fri" => "Dv",
"Sat" => "Ds",
"today" => "avui",
"all-day" => "tot-el-dia",
"Export event" => "Exporta esdeveniment",
"Edit event" => "Edita esdeveniment",
"Delete event" => "Esborra esdeveniment",
"View event" => "Visualitza esdeveniment",
"Organized by" => "Organitzat per",
"Classification" => "Classificació",
"Tentative" => "Tentativa",
"Confirmed" => "Confirmat",
"Cancelled" => "Cancel·lat",
"View this Week" => "Visualitza aquesta Setmana",
"Change Focus" => "Change Focus",
"+" => "+",
"View this Day" => "Visualitza aquesta Dia",
"o" => "o",
"Calendar event : " => "Esdeveniment del Calendari : ",
"New event" => "Nou esdeveniment",
"Edit/Delete event" => "Edita/Esborra l'esdeveniment",
"Edit Calendar Item" => "edita l'item del calendari",
"New Calendar Item" => "Nova Cita al Calendari",
"Recurrence" => "Recurrència",
"This event depends on a recurrence rule" => "Aquest esdeveniment depèn d'una regla de recurrència",
"This event is not recurrent" => "Aquest esdeveniment no és recurrent",
"On a weekly basis" => "En base setmanal",
"Each" => "Cada",
"of the week" => "de la setmana",
"On a monthly basis" => "En base mensual",
"of the month" => "del mes",
"On a yearly basis" => "En base anual",
"Starting on" => "Començant el",
"ending by" => "acabant pel",
"ending after" => "acabant després de",
"events" => "esdeveniments",
"Start period" => "Període d'inici",
"End after" => "S'acaba després de",
"occurrences" => "occurrències",
"occurrence" => "occurrència",
"End before" => "Acaba abans de",
"Event occurs once on" => "L'esdeveniment ocorre un cop el",
"Event is repeated" => "Aquest esdeveniment es troba repetit",
"times" => "vegades",
// "{\$daysnames[\$recurrence.weekday]}s" => "{\$daysnames[\$recurrence.weekday]}s",
"of every month" => "de cada mes",
"on each" => "a cada",
// "{\$monthnames[\$recurrence.dateOfYear_month]}" => "{\$monthnames[\$recurrence.dateOfYear_month]}",
"starting" => "començant",
"ending" => "acabant",
"Show duration" => "Mostra la durada",
"Events cannot end before they start" => "Els esdeveniments no poden acabar abans de començar",
"No description" => "Sese descripció",
"or new" => "o nou/va",
"Choose users to alert" => "Escull a quins usuaris avisar",
"Withdraw me from the list of participants" => "Treu-me de la llista de participants",
"Add me to the list of participants" => "Afegeix-me a la llista de participants",
"Participant names separated by comma" => "Els noms dels participants van separats per comes",
"Roles" => "Rols",
"chair" => "presideix",
"default role" => "rol per defecte",
"required participant" => "participant requerit",
"optional participant" => "participant opcional",
"non participant" => "no participant",
"Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in:" => "Posa la llista de participants separats per comes. Els rols han de ser posats en un prefix separats per dos punts com a:",
"role:login_or_email,login_or_email" => "rol:nom_d_usuari_o_correu-e,nom_d_usuari_o_correu-e",
"If no role is provided, default role will be \"Chair participant\"" => "Si no es posa cap rol, el rol per omissió serà \"Membre participant\"",
"Update this event only" => "Actualitza només aquest esdeveniment",
"Update every unchanged events of this recurrence rule" => "Actualitza tots els esdeveniments no modificats d'aquesta regla de recurrència",
"Update every events of this recurrence rule" => "Actualitza tots els esdeveniments d'aquesta regla de recurrència",
"Delete Recurrent events" => "Esborra els events recurrents",
"Calendar import" => "Importa calendari",
"Calendar has been updated" => "El calendari ha estat actualitzat",
"%0 column name can be used instead of %1" => "Es pot emprar el nom de columna %0 enlloc de %1",
"D" => "D",
"W" => "S",
"M" => "M",
"%d/%m" => "%d/%m",
"%m/%d" => "%m/%d",
"Advanced parameters for iCal export" => "Paràmetres avançats per a l'exportació iCal",
"Calendars to be exported" => "Calendaris que s'han d'exportar",
"Export calendars iCal" => "Exporta els calendaris en format iCal",
"Export calendars CSV" => "Exporta els calendaris en format CSV",
"Your account has been validated" => "S'ha validat el teu compte",
"You have to choose a password to use this account" => "Has d'escollir una contrasenya per a emprar aquest compte",
"Change password enforced" => "Força a canviar contrasenya",
"Change your password" => "Canvia la contrasenya",
"Old password" => "Contrasenya antiga",
"New password" => "Nova contrasenya",
// "Server Check" => "Server Check",
// "MySQL or MariaDB Database Properties" => "MySQL or MariaDB Database Properties",
// "Property" => "Property",
// "Tiki Fitness" => "Tiki Fitness",
// "Be careful" => "Be careful",
// "Server Information" => "Server Information",
// "Server Properties" => "Server Properties",
// "Fitness" => "Fitness",
// "Apache properties" => "Apache properties",
// "IIS properties" => "IIS properties",
// "PHP scripting language properties" => "PHP scripting language properties",
// "PHP Security properties" => "PHP Security properties",
// "MySQL Variable Information" => "MySQL Variable Information",
// "PHP Info" => "PHP Info",
"Please choose the language for this page" => "Si us plau, escull l'idioma d'aquesta pàgina",
"Page: \"%0\"" => "Pàgina: \"%0\"",
"Choose language" => "Escull l'idioma",
"Success" => "Èxit",
"Send a message to us" => "Envia'ns un missatge",
"Your email" => "El teu correu-e",
"Contact us by email" => "Contacta'ns via correu-e",
"Click here to send us an email" => "Fes clic aquí per a enviar-nos un correu electrònic",
"Send another message" => "Envia un altre missatge",
"Contacts" => "Contactes",
"Group View" => "Vista agrupada",
"Create/edit contacts" => "Crea/edita contactes",
"First Name" => "Primer nom",
"Publish this contact to groups" => "Publica aquest contact a grups",
"Last Name" => "Darrer Nom",
"Nickname" => "Sobrenom",
// "Copy page" => "Copy page",
"Invalid page name" => "Nom de àgina invàlid",
"The page name specified contains unallowed characters. It will not be possible to save the page until those are removed: <strong>%0</strong>" => "El nom de pàgina especificat conté caracters que no són permesos. No et serà possible desar la pàgina fins que no eliminis aquests caracters: <strong>%0</strong>",
"The page name specified contains characters that may render the page hard to access. You may want to consider removing those: <strong>%0</strong>" => "El nom de pàgina especificat conté caracters que poden fer-la d'accés difícil. Potser vols reconsiderar eliminar-ne aquests: <strong>%0</strong>",
// "Use this name anyway" => "Use this name anyway",
"Quick Create Multilanguage Pages" => "Creació ràpida de Pàgines Multilíngües",
// "Following pages were created, as translations of each other" => "Following pages were created, as translations of each other",
// "Following pages were not created" => "Following pages were not created",
"page already exists" => "la pàgina ja existeix",
// "Enter the names of a new page page in various languages" => "Enter the names of a new page page in various languages",
// "Preferred languages" => "Preferred languages",
// "Other languages" => "Other languages",
// "Create pages" => "Create pages",
// "View generated WebHelp" => "View generated WebHelp",
"No structure" => "Cap estructura",
"Top page" => "La pàgina més activa",
"Add a new site" => "Afegeix una nova web",
"You cannot add sites until Directory Categories are setup." => "No pots afegir enllaços fins que es configurin les categories d'enllaços.",
"Please contact the Site Administrator" => "Si us plau, contacteu amb l'administrador del portal",
// "<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>" => "<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>",
"Site added" => "Lloc afegit",
// "The following site was added, but may require validation by the admin before appearing on the lists" => "The following site was added, but may require validation by the admin before appearing on the lists",
// "{\$msg}" => "{\$msg}",
// "Edit a site" => "Edit a site",
"Add a Site" => "Afegiu un lloc",
// "Directory Categories" => "Directory Categories",
// "{\$countries[ux]}" => "{\$countries[ux]}",
"Directory Administration" => "Administració del Directori",
"There are" => "Hi ha/n",
"invalid sites" => "web Invàlida",
"valid sites" => "llocs vàlids",
"Users have visited" => "Els usuaris han visitat",
"sites from the directory" => "llocs desde el directori",
"Users have searched" => "Els usuaris han cercat",
"times from the directory" => "vegades del directori",
"Validate" => "Valida",
"Admin directory categories" => "Administrar directori de categories",
// "Parent directory category" => "Parent directory category",
"Add a directory category" => "Afegeix una categoria directori",
"Edit this directory category" => "edita aquest directori de categoria",
// "Add a Directory Category" => "Add a Directory Category",
"Children type" => "tipus infantil",
// "Most visited directory sub-categories" => "Most visited directory sub-categories",
// "Directory Category description" => "Directory Category description",
// "Random directory sub-categories" => "Random directory sub-categories",
"Maximum number of children to show" => "Nombre màxim de nens a mostrar",
// "Allow sites in this directory category" => "Allow sites in this directory category",
// "Show number of sites in this directory category" => "Show number of sites in this directory category",
"Editor group" => "Editor de grup",
// "Directory Subcategories" => "Directory Subcategories",
"cType" => "cTipus",
"allow" => "permetre",
"count" => "compte",
"editor" => "editor",
"relate" => "relacionar",
// "Admin related directory categories" => "Admin related directory categories",
// "Add a related directory category" => "Add a related directory category",
// "Directory Category" => "Directory Category",
"Mutual" => "Mutu",
// "Related directory categories" => "Related directory categories",
"Admin sites" => "Administració de llocs web",
"Is valid" => "És vàlid",
"Perform action with selected" => "Realitza l'acció amb els seleccionats",
"New Sites" => "Nous llocs",
"Cool Sites" => "Llocs fantàstics",
"any" => "qualsevol",
"in entire directory" => "a tot el directori",
// "in current directory category" => "in current directory category",
"Sort by" => "Ordenat per",
// "Hits (desc)" => "Hits (desc)",
// "Hits (asc)" => "Hits (asc)",
// "Last updated (desc)" => "Last updated (desc)",
// "Last updated (asc)" => "Last updated (asc)",
"sort" => "ordenar",
"Added:" => "Afegit:",
"Last updated" => "Actualitzat per darrera vegada el",
// "No records" => "No records",
// "Total directory categories" => "Total directory categories",
"Total links" => "Enllaços totals",
"Links to validate" => "Enllaços per validar",
"Searches performed" => "Cerca enllestida",
"Total links visited" => "Nombre d'enllaços visitats",
"Directory ranking" => "llista de Directoris",
"Validate sites" => "Valida llocs",
"country" => "país",
// "Discounts" => "Discounts",
// "Max time the discount can be used in the first phase of payment" => "Max time the discount can be used in the first phase of payment",
// "-1 for illimited" => "-1 for illimited",
// "Translation of this page is incomplete" => "Translation of this page is incomplete",
// "To add <strong>new content</strong> to the page" => "To add <strong>new content</strong> to the page",
// "use the editor" => "use the editor",
"Edit article" => "Editar article",
"View Articles" => "Visualitza articles",
"One of the email addresses you typed is invalid" => "Una de les adreces de correu electrònic que heu escrit és invàlida",
"Topline" => "Línia superior",
// "To translate, do not change the language and the content.\n\t\t\t\t\t\tInstead, <a href=\"%0\">create a new translation</a> in the new language" => "To translate, do not change the language and the content.\n\t\t\t\t\t\tInstead, <a href=\"%0\">create a new translation</a> in the new language",
// "Edit Translations" => "Edit Translations",
// "Attach existing article ID as translation" => "Attach existing article ID as translation",
"Author Name" => "Nom de l'autor",
// "{\$typei|escape}" => "{\$typei|escape}",
"Own Image" => "Imatge pròpia",
// "If not the topic image" => "If not the topic image",
"Article image" => "Imatge de l'article",
"Use own image" => "Empra imatge pròpia",
"Float text around image" => "text flotant al voltant de la imatge",
// "Maximum dimensions of custom image in view mode (Read Article)" => "Maximum dimensions of custom image in view mode (Read Article)",
// "If different than the uploaded image" => "If different than the uploaded image",
// "Maximum dimensions of custom image in list mode (View Articles)" => "Maximum dimensions of custom image in list mode (View Articles)",
// "If different than in view mode" => "If different than in view mode",
"Image caption" => "Requadre de la imatge",
// "If not the topic name" => "If not the topic name",
// "Allow full HTML" => "Allow full HTML",
// "Keep any HTML tag" => "Keep any HTML tag",
// "If not enabled, Tiki will retain some HTML tags (a, p, pre, img, hr, b, i)" => "If not enabled, Tiki will retain some HTML tags (a, p, pre, img, hr, b, i)",
// "Emails to be notified (separated with commas)" => "Emails to be notified (separated with commas)",
"Edit or create banners" => "Edita o crea blocs de publicitat",
"List banners" => "Llista butlletins",
"URL to link the banner" => "URL on enllaça el banner",
"Client" => "Client",
"Max impressions" => "Impressions màximes",
// "-1 for unlimited" => "-1 for unlimited",
// "Max impressions for a user" => "Max impressions for a user",
// "Max clicks" => "Max clicks",
// "URIs where the banner appears only" => "URIs where the banner appears only",
// "Type each URI enclosed with the # character. Exemple:#/this_page#/tiki-index.php?page=this_page#" => "Type each URI enclosed with the # character. Exemple:#/this_page#/tiki-index.php?page=this_page#",
// "URIs where the banner will not appear " => "URIs where the banner will not appear ",
// "Or, create a new zone" => "Or, create a new zone",
"Show the banner only between these dates" => "Mostrar el banner només en aquestes dates",
"From date" => "Des de la data",
"To date" => "Fins la data",
"Use dates" => "Utilitza dates",
"Show the banner only in this hours" => "Mostrar el banner només a aquestes hores",
"Show the banner only on" => "Mostrar el banner sempre on",
"Select ONE method for the banner" => "Seleccioneu UN mètode per al banner",
"Use HTML" => "Utilitza HTML",
"Use image" => "Utilitza imatge",
"Image:" => "Imatge:",
"Current Image" => "Imatge actual",
"Use image generated by URL (the image will be requested at the URL for each impression)" => "Emprar la imatge generada per la URL (la imatge serà manada a la URL per cada impressió)",
"Use Flash" => "Empra Flash",
"Movie Size" => "Mida del vídeo",
"Pixels" => "Píxels",
"FlashPlugin min version" => "Versió min del connector FlashPlugin",
// "ex" => "ex",
"Use text" => "Utilitzar text",
"Save the Banner" => "Desar el banner",
"Remove Zones (you lose entered info for the banner)" => "Esborrar Zones (es perdrà l'informació entrada per el banner)",
"Edit Blog" => "Edita el bloc",
"A category is mandatory" => "Una categoria és obligatòria",
"There are individual permissions set for this blog" => "Existeixen permisos fixats individualment per a aquest bloc",
"Allow other users to post in this blog" => "Permet a altres usuaris de publicar en aquest bloc",
// "If others post to blog, author should always be owner" => "If others post to blog, author should always be owner",
"Allow search" => "Permetre cerca",
"Allow comments" => "Permetre comentaris",
// "Display Options" => "Display Options",
// "Number of posts to show per page" => "Number of posts to show per page",
// "Display blog title in posts list page" => "Display blog title in posts list page",
// "Display blog title in post page" => "Display blog title in post page",
// "Display blog description" => "Display blog description",
// "Display breadcrumbs" => "Display breadcrumbs",
// "Display author in blog posts" => "Display author in blog posts",
// "Display published date in blog posts" => "Display published date in blog posts",
"Show user avatar" => "Mostra l'avatar de l'usuari",
// "Show post related content" => "Show post related content",
// "The checkbox is disabled because feature_freetags is disabled globally" => "The checkbox is disabled because feature_freetags is disabled globally",
// "Maximum number of related posts to display" => "Maximum number of related posts to display",
// "Use post excerpt" => "Use post excerpt",
"Blog heading" => "Encapçalament",
// "Heading preview" => "Heading preview",
// "Blog post heading" => "Blog post heading",
// "Organizer" => "Organizer",
// "Move objects between categories" => "Move objects between categories",
// "Click on the category name you want to list. The list of objects in that category will become visible" => "Click on the category name you want to list. The list of objects in that category will become visible",
// "Select the objects you want to affect. Controls will appear in the category browser" => "Select the objects you want to affect. Controls will appear in the category browser",
// "Use the plus and minus signs to add or remove the categories on selected objects" => "Use the plus and minus signs to add or remove the categories on selected objects",
// "More results available. Please refine the search criterias" => "More results available. Please refine the search criterias",
"Select all" => "Selecciona-ho tot",
"Unselect all" => "Deselecciona-ho tot",
"Edit Style Sheet" => "edita Full d'Estil",
"Style Sheet" => "Fulla d'Estil",
"The file will be saved in" => "Es gravarà l'arxiu a",
"choose a stylesheet" => "escull un full d'estil",
"Try" => "Prova",
// "Tiki Docs" => "Tiki Docs",
// "Save file" => "Save file",
// "Cancel editing file" => "Cancel editing file",
// "Editing file" => "Editing file",
"Save and Back" => "Desa-ho i retorna",
"Toggle Fullscreen" => "Commuta la Pantalla Completa",
"For more information, please see" => "Per a més informació, si us plau consulta",
"Wiki Page Editor" => "l'Editor de pàgines Wiki",
"More help on editing wiki pages" => "Més ajuda sobre l'edició de pàgines wiki",
"The syntax system used for creating pages in Tiki" => "El sistema de sintaxi per crear pàgines en Tiki",
"Bold text" => "Text en negreta",
"Italic text" => "Text en cursiva",
"single quotes" => "Apòstrofs",
"Underlined text" => "Text subratllat",
"Colored text" => "Text en colors",
"Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background." => "Es mostrarà amb el codi HTML o nom en anglès del color indicat. El color del nom en anglès pot contenir dos colors separats per una coma. En aquest cas, el primer color seria el color de la lletra i el segon el color del fons",
"Deleted text" => "Text esborrat",
"2 dashes" => "2 guions",
"Headings" => "Capçaleres (o Títols)",
"show/hide heading section. + (shown) or - (hidden) by default" => "mostra/amaga la secció de la capçalera. + (mostrat) o - (amaga) per defecte",
"Autonumbered Headings" => "Estils de títol autonumerats",
"{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} imprimeixen una taula de continguts (índex) per a la página actual basant-se en les págines filles de la seva estructura (toc) o en els amb encapçalaments amb estils de títol amb ! (maketoc)",
"Common optional parameters for maketoc are: title|maxdepth|levels|nums, and for toc are: order|showdesc|shownum|structId|maxdepth|pagename" => "Els paràmetres típics per a maketoc són: title|maxdepth|levels|nums, i per a toc són: order|showdesc|shownum|structId|maxdepth|pagename",
"Horizontal rule" => "Regla horitzontal",
"Text box" => "Requadre de text",
"Box content" => "Contingut de la caixa",
"Centered text" => "Text centrat",
"Inserts an editable variable" => "Inserta una variable editable",
"External links" => "Enllaços externs",
"use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)." => "empra claudators per a un enllaç extern: [URL], [URL|descripció_de_l_enllaç],[URL|descripció_de_l_enllaç|relació] o [URL|descripció_de_l_enllaç|relació|nocache] (aquest darrer evita que el Wiki local desi una còpia de la pàgina enllaçada a la memòria cau; es pot emprar la relació per insertar l'atribut rel per a l'enllaç - útil , p.e., per als efectes visuals amb la funcionalitat shadowbox).",
"For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))" => "Per a un Wiki extern, empri NomWikiExtern:NomPlana o ((Nom Wiki Extern: Nom Plana))",
"Square Brackets" => "Corxets",
"Use [[foo] to show [foo]." => "Empra [[foo] per mostrar [foo].",
"Wiki References" => "Referències del Wiki",
"JoinCapitalizedWords or use" => "AjuntarParaulesEnMajúscula o usar",
"page|description" => "pàg|desc",
"for wiki references" => "per referències del wiki",
"page|#anchor" => "pàgina|#àncora",
"page|#anchor|desc" => "pàgina|#àncora|descripció",
"for wiki heading/anchor references" => "per a referències a estils de títol wiki/àncora",
"SomeName" => "AlgunNom",
"prevents referencing" => "impedeix referenciar",
"Lists" => "Llistes",
"for bullet lists" => "per a llistes de punts",
"for numbered lists" => "per a llistes numerades",
"definition" => "definició",
"for definiton lists" => "per a llistes de definicions",
"Indentation" => "Sagnat",
"Creates an indentation for each plus (useful in list to continue at the same level)" => "Crea un sagnat de text per a cada més (útil en llistes per continuar amb la numeració més avall)",
"Tables" => "Taules",
"row" => "fila",
"col" => "col",
"Monospace font" => "Font monoespaiada",
"Code sample" => "Mostra de codi",
"(very useful especially in tables)" => "(molt útil especialment en les taules)",
"Multi-page pages" => "Pàgines múltiples",
"to separate pages" => "per separar pàgines",
"Non parsed sections" => "Seccions no analitzades",
"data" => "dades",
"Prevents wiki parsing of the enclosed data." => "Evita interpretar el codi wiki de les dades incloses.",
"Preformated sections" => "Seccions preformatades",
"~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text." => "~pp~ data ~/pp~ Mostra text/codi preformatat; no es fa cap interpretació de sintaxi Wiki dins d'aquestes seccions (com amb np), i l'espaiat és fixe (no es fa cap plegament de línies llarges).  ~pre~ data ~/pre~ també mostra text preformatat amb espaiat fix, però es si que s'interpreta la sintaxi wiki en el text..",
"~tc~ Tiki Comment ~/tc~ makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  ~hc~ HTML Comment ~/hc~ makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar." => "~tc~ Comentari Tiki ~/tc~ fa un comentari a Tiki.  Serà eliminat completament del text mostrat, però es desarà en l'arxiu per a referències futures i és visible pels editors de les pàgines.  ~hc~ Comentari HTML ~/hc~ fa un comentari HTML.  Serà  insertat com a comentari en l'HTML produït; aquests no es mostraran en navegadors web, però poden ser vistos en mostrar el codi font de la pàgina del navegador o formes similar.",
"Block Preformatting" => "Preformatat de Block",
"Indent text with any number of spaces to turn it into a monospaced block that still follows other Wiki formatting instructions. It will be indended with the same number of spaces that you used.  Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that." => "Sagna (inserta espais al principi per alinear el paràgraf més a la dreta) el text amb qualsevol nombre d'espais per convertir-lo en un bloc monoespaiat que encara segŭeix altres instruccions de format Wiki. Serà sagnat amb el mateix nombre d'espais que has emprat. Nota que d'aquesta forma no es preseva ni l'espaiat exacte ni els salts de línia; empra ~pp~...~/pp~ per això.",
// "Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew" => "Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew",
"Special characters" => "Caràcters especials",
"hard space" => "espai rigid (no permet que es trenqui la línia)",
"numeric between ~ for HTML numeric characters entity" => "numeric entre ~ per a entitats html de caràcters numèrics",
"Plugin Help" => "Ajuda de Plugins",
"Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt;" => "Fixa't que els arguments dels connectors (plugins) es poden envoltar de cometes dobles (&quot;); això permet que continguin , o = o &gt;",
"More help here" => "Més ajuda, aquí",
"Wiki plugins extend the function of wiki syntax with more specialized commands" => "Els connectors (plugins) del Wiki estenen la funació de la sintaxi wiki amb instruccions més especialitzades",
"Activate/deactivate plugins" => "Activa/desactiva Connectors (plugins)",
"No description available" => "No hi ha disponible cap descripció",
// "Spreadsheet Creation" => "Spreadsheet Creation",
// "Spreadsheet Interface" => "Spreadsheet Interface",
// "Tiki uses jQuery.sheet for displaying spreadsheets, below you will see a list of usable functions and how to enhance how you use it" => "Tiki uses jQuery.sheet for displaying spreadsheets, below you will see a list of usable functions and how to enhance how you use it",
"Wysiwyg Editor" => "Editor Visual (Wysiwyg)",
"More help on wysiwyg editing" => "Més ajuda sobre l'edició visual amb wysiwyg",
// "WYSIWYG in wiki mode is an experimental feature in Tiki 7+ and uses\n\t<a href=\"http://ckeditor.com\">CKEditor</a>" => "WYSIWYG in wiki mode is an experimental feature in Tiki 7+ and uses\n\t<a href=\"http://ckeditor.com\">CKEditor</a>",
// "To switch modes between WYSIWYG and Wiki edit modes click the {icon _id=\"pencil_go\"} button on the toolbar" => "To switch modes between WYSIWYG and Wiki edit modes click the {icon _id=\"pencil_go\"} button on the toolbar",
// "<strong>N.B. </strong>Using this button changes the editor between WYSIWYG and the usual wiki editor, but leaves the page source in wiki syntax" => "<strong>N.B. </strong>Using this button changes the editor between WYSIWYG and the usual wiki editor, but leaves the page source in wiki syntax",
// "Wiki plugins can be used and edited in WYSIWYG mode, double click the plugin to bring up the plugin edit popup form.<br />\n\tHere is an example of the {ldelim}BOX{rdelim} plugin" => "Wiki plugins can be used and edited in WYSIWYG mode, double click the plugin to bring up the plugin edit popup form.<br />\n\tHere is an example of the {ldelim}BOX{rdelim} plugin",
// "This is the text in the box which is justified; the box has a cream background, takes 80% of the screen width and is centred" => "This is the text in the box which is justified; the box has a cream background, takes 80% of the screen width and is centred",
// "<strong>Caution:</strong> This is a new feature and still work in progress.<br />\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br />\n\tCurrently (in Tiki 9.0) drag and drop of plugins in WYSIWYG does not work" => "<strong>Caution:</strong> This is a new feature and still work in progress.<br />\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br />\n\tCurrently (in Tiki 9.0) drag and drop of plugins in WYSIWYG does not work",
// "<strong>Admins:</strong><br />\n\t\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way.\n\t\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">wysiwyg admin page</a>.\n\t\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a>\n\t\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>" => "<strong>Admins:</strong><br />\n\t\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way.\n\t\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">wysiwyg admin page</a>.\n\t\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a>\n\t\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>",
// "The WYSIWYG editor in Tiki 6+ is\n\t<a href=\"http://ckeditor.com\">CKEditor</a>,\n\tthe new version of FCKEditor (used in Tiki since version 2.0)" => "The WYSIWYG editor in Tiki 6+ is\n\t<a href=\"http://ckeditor.com\">CKEditor</a>,\n\tthe new version of FCKEditor (used in Tiki since version 2.0)",
// "<strong>N.B. </strong>Using this button converts the page source from wiki to HTML, or vice versa.\n\tThe conversion process is not entirely transparent, meaning that you may notice differences between the look of a page in different modes.\n\tThis will improve in future updates but as the two systems have significant differences in what they can do it is unlikely to ever be totally transparent" => "<strong>N.B. </strong>Using this button converts the page source from wiki to HTML, or vice versa.\n\tThe conversion process is not entirely transparent, meaning that you may notice differences between the look of a page in different modes.\n\tThis will improve in future updates but as the two systems have significant differences in what they can do it is unlikely to ever be totally transparent",
// "<strong>Caution:</strong> This is a new feature and still work in progress.<br />\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br />\n\tCurrently (still in Tiki 9.0) drag and drop of plugins in WYSIWYG does not work" => "<strong>Caution:</strong> This is a new feature and still work in progress.<br />\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br />\n\tCurrently (still in Tiki 9.0) drag and drop of plugins in WYSIWYG does not work",
"Browse Images" => "Explorar Imatges",
"Edit successful!" => "Edició feta amb èxit!",
"The following image was successfully edited" => "La imatge següent ha estat editada amb èxit",
"Image Description" => "Descripció de la imatge",
"Upload from disk to change the image:" => "Puja des del disc per canviar la imatge:",
"Save and Go Next" => "Desa i ves al següent",
// "Edit Invoice" => "Edit Invoice",
// "Invoice Number" => "Invoice Number",
// "Date Issued" => "Date Issued",
// "Work Description" => "Work Description",
// "Taxable" => "Taxable",
// "New Item" => "New Item",
// "Invoice Note" => "Invoice Note",
// "Save Invoice" => "Save Invoice",
// "Edit or export languages" => "Edit or export languages",
"Edit languages" => "Edita els idiomes",
"Select the language to edit" => "Selecionar l'idioma que es vol editar",
"Add a translation" => "Afegeix una traducció",
"Edit translations" => "edita traduccions",
// "Show only database stored translations" => "Show only database stored translations",
// "Untranslated strings" => "Untranslated strings",
// "Show only database stored untranslated strings" => "Show only database stored untranslated strings",
"Original" => "Original",
// "Original translation" => "Original translation",
// "Last changed by %0 on %1" => "Last changed by %0 on %1",
// "Translate all" => "Translate all",
"Delete all" => "Net.",
// "Are you sure you want to delete all untranslated strings from database" => "Are you sure you want to delete all untranslated strings from database",
// "Are you sure you want to delete all translations from database" => "Are you sure you want to delete all translations from database",
// "Export languages" => "Export languages",
// "No translations in the database available to export. First translate strings using interactive translation or \"Edit languages\" tab" => "No translations in the database available to export. First translate strings using interactive translation or \"Edit languages\" tab",
"Select the language to Export" => "Selecionar l'idioma que es vol Exportar",
// "If you click \"Download database translations\", you will download a file with all the translations in the database" => "If you click \"Download database translations\", you will download a file with all the translations in the database",
// "If you click \"Write to language.php\", the translations in the database will be merged with the other translations in language.php. Note that after writing translations to language.php they are removed from the database" => "If you click \"Write to language.php\", the translations in the database will be merged with the other translations in language.php. Note that after writing translations to language.php they are removed from the database",
// "To be able to write your translations back to language.php make sure that the web server has write permission in the lang/ directory" => "To be able to write your translations back to language.php make sure that the web server has write permission in the lang/ directory",
// "Download database translations" => "Download database translations",
// "Write to language.php" => "Write to language.php",
// "Return to default perspective" => "Return to default perspective",
// "Switch to" => "Switch to",
// "Configurations" => "Configurations",
// "Search for configurations below and drag them in to the configuration section above" => "Search for configurations below and drag them in to the configuration section above",
"Program dynamic content for block" => "Programar el contingut dinàmic per al bloc",
"Create New Block" => "Crear un nou bloc",
"Return to block listing" => "Torna a la llista de blocs",
"Block description: " => "Descripció del bloc",
"You are editing block:" => "Estàs editant el bloc:",
"Publishing date" => "Data de publicació",
"Publishing Date" => "Data de Publicació",
"Edit question options" => "edita opcions de pregunta",
"List Quizzes" => "Fes llista dels qüestionaris",
"Quiz Stats" => "Estadístiques de Tests",
"This Quiz Stats" => "Estadistiques d'aquest test",
"Edit this Quiz" => "Edita aquest test",
"Admin Quizzes" => "Administrar qüestionaris",
"Create/edit options for question" => "Crear/edita opcions per a una pregunta",
"points" => "punts",
"Quiz" => "Test",
"canRepeat" => "potRepetir",
"timeLimit" => "tempsLimit",
"Create/edit quizzes" => "Crea/edita qüestionaris",
"There are individual permissions set for this quiz" => "Hi ha permisos individuals per a aquest Test",
"Quiz can be repeated" => "El test pot repetir-se",
"Store quiz results" => "Desar resultats d'aquest test",
"Quiz is time limited" => "El test té un temps limitat",
"Maximum time" => "Temps màxim",
"Passing Percentage" => "Percentatge d'aprovació'",
"%" => "%",
"Edit quiz questions" => "edita preguntes del test",
"Create/edit questions for quiz" => "Crear/edita preguntes per a test",
"Question Type" => "Tipus de pregunta",
"Import questions from text" => "Importa preguntes des de text",
"Instructions: Type, or paste, your multiple choice questions below.  One line for the question, then start answer choices on subsequent lines.  Separate additional questions with a blank line.  Indicate correct answers by starting them with a \"*\" (without the quotes) character." => "Instruccions: Escriviu o enganxeu les preguntes amb respostes múltiples per escollir a sota. Una línia per la pregunta, després comenceu les opcions de resposta a les línies següents. Separeu les preguntes adicionals amb una línia en blanc. Indiqueu la resposta correcta començant la línia amb el caràcter \"*\" (sense les cometes).",
"Input" => "Entrada",
"maxScore" => "maxResultat",
// "Edit quiz results" => "Edit quiz results",
"From Points" => "Des de punts",
"To Points" => "Fins a punts",
// "Report Builder" => "Report Builder",
// "Report Type" => "Report Type",
// "Select Report Type" => "Select Report Type",
// "Wiki Data" => "Wiki Data",
// "Export As CSV" => "Export As CSV",
"Modify Structure" => "Modifica l'estructura",
"You will remove" => "Eliminaràs",
"and its subpages from the structure, now you have two options:" => "i amb les seves subpàgines de l'estructura, ara tens dues opcions:",
"and its subpages from the structure" => "i les seves subpàgines de l'estructura",
"\n\t\t\tRemove only from structure" => "\n\t\t\tElimina només de l'estructura",
"\n\t\t\t\tRemove from structure and remove page too" => "\n\t\t\t\tElimina de l'estructura i elimina també les pàgines",
"The page already exists. The page that has been added to the structure is the existing one." => "La pàgina ja existeix. La pàgina que s'ha afegit a l'estructura és l'existent.",
"The following pages added have automatically been categorized with the same categories as the structure:" => "Les pàgines següents afegides han estat automàticament categoritzades amb les mateixes categories que l'estructura:",
"Structure Layout" => "Disseny de l'estructura",
"Add pages" => "Afegeix pàgines",
"Use pre-existing page by dragging into the structure above" => "Empra la pàgina pre-existent a través de deixar-ho caure a l'estructura de sobre",
// "{\$catix.categpath}" => "{\$catix.categpath}",
"Categorize all pages in structure together" => "Categoritza totes les pàgines de l'estructura juntes",
"Remove existing categories from ALL pages before recategorizing" => "Elimina les categories existents de TOTES les pàgines abans de recategoritzar",
"Move to another structure" => "Mou a una altra estructura",
"at the beginning" => "al principi",
"at the end" => "al final",
"Submit article" => "Enviar col·laboracions",
"List Submissions" => "Llista d'enviaments",
"Use ...page... to separate pages in a multi-page post" => "Empra ...page... per separar pàgines en una publicació multi-pàgina",
"<b>*</b>=optional" => "<b>*</b>=opcional",
"<b>Topline</b>=small line above Title" => "<b>Línia superior</b>=línia petita sobre el Títol",
"<b>Subtitle</b>=small line below Title" => "<b>Subtítol</b>=linia petita sota el Títol",
"<b>Source</b>=URL to article source" => "<b>Font</b>=URL a la font de l'article",
"Own image size x" => "Dimensió x d'imatge pròpia",
"Own image size y" => "Dimensió y d'imatge pròpia",
"Submit Article" => "Envia un Article",
"Auto-Approve Article" => "Autoaprova l'Article",
"View template" => "Visualitza plantilla",
"Edit template" => "Edita Plantilles",
"Edit templates" => "Editar plantilles",
"Template listing" => "Llistat de plantilles",
"Available templates" => "Plantilles Permesses",
"Important" => "Important",
// "If you edit this (or any TPL) file via the built-in editor below, any JavaScript may be sanitized or completely stripped out \n\t\t\t\t\tby Tiki security filtering, which would cause certain functions to stop working (e.g. menus no longer collapse or expand)" => "If you edit this (or any TPL) file via the built-in editor below, any JavaScript may be sanitized or completely stripped out \n\t\t\t\t\tby Tiki security filtering, which would cause certain functions to stop working (e.g. menus no longer collapse or expand)",
// "You should only modify default header.tpl and other important files via a text code editor, through console, \n\t\t\t\t\tor SSH, or FTP edit commands--and only if you know what you are doing! ;-)" => "You should only modify default header.tpl and other important files via a text code editor, through console, \n\t\t\t\t\tor SSH, or FTP edit commands--and only if you know what you are doing! ;-)",
// "Extensive customizations can be made safely through the <a href=\"tiki-admin.php?page=look\" class=\"titletips\" \n\t\t\t\t\ttitle=\"Look & Feel\">Look & Feel</a> admin panel custom code or general layout areas" => "Extensive customizations can be made safely through the <a href=\"tiki-admin.php?page=look\" class=\"titletips\" \n\t\t\t\t\ttitle=\"Look & Feel\">Look & Feel</a> admin panel custom code or general layout areas",
// "To be safe and to make upgrades easier, it is recommended that you create a custom theme before modifying tpl files.\n\t\t\t\t\tSee <a href=\"http://doc.tiki.org/Customizing+Themes\" class=\"titletips\" title=\"Customizing Themes help page\">\n\t\t\t\t\tdoc.tiki.org/Customizing+Themes</a> for how to do that" => "To be safe and to make upgrades easier, it is recommended that you create a custom theme before modifying tpl files.\n\t\t\t\t\tSee <a href=\"http://doc.tiki.org/Customizing+Themes\" class=\"titletips\" title=\"Customizing Themes help page\">\n\t\t\t\t\tdoc.tiki.org/Customizing+Themes</a> for how to do that",
"Save Only in the Theme:" => "Desa només en el Tema:",
"Delete the copy in the theme:" => "Esborra la còpia en el tema:",
"Edit topic" => "Edita el tema",
"Notification Email" => "Correu-e de notificació",
"Admin notifications" => "Administra les notificacions",
"Translate:" => "Tradueix:",
"View Page" => "Visualitza pàgina",
"View Article" => "Visualitza Article",
"You must specify the object language" => "Has d'especificar l'idioma de l'objecte",
"The object doesn't exist" => "L'objecte no existeix",
"The object doesn't have a language" => "L'objecte no té un idioma",
"The object has already a translation for this language" => "L'objecte ja té una traducció per a aquest idioma",
"The object is already in the set of translations" => "L'objecte ja hi és en el conjunt de la traducció",
"Translate updates made on this page or one of its translations" => "Tradueix les actualitzacions fetes sobre aquesta pàgina o una de les seves traduccions",
"Translate this page to a new language" => "Tradueix aquesta pàgina a un nou idioma",
"Attach or detach existing translations of this page" => "Adjunta o desadjunta traduccions existents d'aquesta pàgina",
"Change language for this page" => "Canvia l'idioma per a aquesta pàgina",
"Select language to translate to" => "Selecciona l'idioma al qual traduir-la",
"Enter the page title" => "Introdueix el títol de la pàgina",
"Below, assign categories to this new translation (Note: they should probably be the same as the categories of the page being translate)" => "Assigna categories a sota per a aquesta nova traducció (Nota: probablement haurien de ser les mateixes que les de la pàgina que s'està traduint)",
"Create translation" => "Crea la traducció",
"\"You forgot to specify the language of the translation. Please choose a language in the picklist.\"" => "\"T'has oblidat d'especificar l'idioma de la traducció. si us plau, escull un idioma de la llista.\"",
"\"The page already exists. It was selected in the list below.\"" => "\"La pàgina ja existeix. Va ser seleccionada a la llista de sota.\"",
"Change Language" => "Change Language",
"No language is assigned to this page." => "No hi ha cap idioma assignat a aquesta pàgina.",
"Please select a language before performing translation." => "Si us plau, selecciona un idioma abans de fer la traducció.",
"Set Current Page's Language" => "Especifica l'idioma de la pàgina actual",
// "Manage translations" => "Manage translations",
// "{\$customTip|escape}" => "{\$customTip|escape}",
"Edit Section:" => "Edita la secció",
"Update '{\$page}'" => "Actualitza '{\$page}'",
"Draft written on" => "Esborrany desat el",
"Warning: new versions of this page have been made after this draft" => "Avís: s'han fet noves versions d'aquesta pàgina després d'aquest esborrany",
"The SandBox is a page where you can practice your editing skills, use the preview feature to preview the appearance of the page, no versions are stored for this page." => "El LlocdeProves (SandBox) és una pàgina on pots practicar les teves habilitats d'edició, emprar la opció de previsualització per previsualitzar l'aspecte de la pàgina, i no es guarda cap versió per a aquesta pàgina.",
"An edit summary is mandatory" => "És obligatori posar un resum d'edició",
"Translate from" => "Tradueix des de",
"Changes that need to be translated are highlighted below" => "Els canvis que cal traduir es mostren destacats a sota",
"No comment" => "Cap comentari",
"All Versions" => "totes les versions",
"Select the style used to display differences to be translated" => "Selecciona l'estil emprat per mostrar diferències que cal traduir",
"html" => "html",
"text full" => "text sencer",
"Change the style used to display differences to be translated" => "Canvia l'estil emprat per mostrar les diferències que s'han de traduir",
"Change diff styles" => "Canvia l'estil de diff",
"Translate to" => "Tradueix a",
"Reproduce the changes highlighted on the left using the editor below" => "Reprodueix els canvis destacats a l'esquerra emprant l'editor de sota",
"Describe the change you made:" => "Descriu el canvi que has fet:",
"Edit comment: Enter some text to describe the changes you are currently making" => "Edita el comentari: Introdueix una mica de text per descriure els canvis que estàs fent actualment",
"Monitor this page" => "Segueix aquesta pàgina",
"Upload picture" => "Puja foto",
"Add another image" => "Afegeix una altra imatge",
"Categorization has been preset for this edit" => "La categorització ha estat ja pre-seleccionada per a aquesta edició",
"Categories will be inherited from the structure top page" => "S'heredaran les categories de la pàgina inicial de l'estructura",
// "{\$templates[ix].name|escape}" => "{\$templates[ix].name|escape}",
"Admin Content Templates" => "Administrar contingut de les plantilles",
"Lock this page" => "Bloqueja aquesta pàgina",
"Allow comments on this page" => "Permet comentaris a aquesta pàgina",
"Try to convert HTML to wiki" => "Prova de convertir HTML a wiki",
"Import page" => "Pàgina d'importació",
"export all versions" => "exporta totes les versions",
// "Only cache a page if it should look the same to all groups authorized to see it" => "Only cache a page if it should look the same to all groups authorized to see it",
"Manage structures" => "Gestioneu estructures",
"License" => "Llicència",
// "{\$prefs.wikiLicensePage}" => "{\$prefs.wikiLicensePage}",
// "{\$prefs.wikiSubmitNotice}" => "{\$prefs.wikiSubmitNotice}",
// "Authors' style" => "Authors' style",
// "Description (used for metatags)" => "Description (used for metatags)",
"My Footnotes" => "Les meves notes al peu de pàgina",
"Use rating" => "Empra valoració",
// "{\$template.title|escape}" => "{\$template.title|escape}",
"There is no available poll template." => "No hi ha cap plantilla de consulta disponible.",
"You should ask an admin to create them." => "Haurieu de preguntar a l'administrador per crear-ho.",
// "\"}To translate, do not change the language and the content.\n\t\t\t\t\t\t\t\t\tInstead, <a href=\"%0\">create a new translation</a> in the new language" => "\"}To translate, do not change the language and the content.\n\t\t\t\t\t\t\t\t\tInstead, <a href=\"%0\">create a new translation</a> in the new language",
"Translation request" => "Petició de traducció",
"Send urgent translation request." => "Envia una petició de traducció urgent.",
// "Admin wiki preferences" => "Admin wiki preferences",
// "{\$title}" => "{\$title}",
"List Sheets" => "Llista fulls",
"Graph" => "Grafica",
// "Export to file" => "Export to file",
"Autodetect" => "Autodetecta",
"Admin FAQ" => "Administració de PMF",
"List FAQs" => "Fer llista de PUFs",
"View FAQ" => "Veure PUF",
"Edit this FAQ" => "Edita aquesta PUF",
"New Question" => "Pregunta nova",
// "Edit FAQ question" => "Edit FAQ question",
// "Add FAQ question" => "Add FAQ question",
"Use a question from another FAQ" => "Empra pregunta d'una altra PUF",
"FAQ questions" => "Preguntes d'Ús Freqüent (PUFs)",
"Suggested questions" => "Preguntes suggerides",
"No suggested questions" => "No hi ha cap suggeriment",
"File Archive" => "Arxiva el fitxer",
"Upload File" => "Puja l'arxiu",
"File Galleries tpl" => "Galeries d'arxius tpl",
"Be careful to set the right permissions on the files you link to" => "Tingues cura de posar els permisos adients als arxius als que enllaces",
"You can access the file gallery using the following URL" => "Pots accedir a la galeria d'arxius emprant la URL",
"Size (width x height)" => "Mida (amplada x alçada)",
"Newer content available" => "Hi ha contingut més nou disponible",
// "You are currently viewing the latest version of the page" => "You are currently viewing the latest version of the page",
// "You can also view the {self_link}latest approved version{/self_link}" => "You can also view the {self_link}latest approved version{/self_link}",
// "You can approve this revision and make it available to a wider audience. Make sure you review all the changes before approving" => "You can approve this revision and make it available to a wider audience. Make sure you review all the changes before approving",
// "Show changes since last approved revision" => "Show changes since last approved revision",
// "This page has no prior approved revision. <strong>All of the content must be reviewed.</strong>" => "This page has no prior approved revision. <strong>All of the content must be reviewed.</strong>",
// "Approve current revision" => "Approve current revision",
// "Content waiting for approval" => "Content waiting for approval",
// "You are currently viewing the approved version of the page" => "You are currently viewing the approved version of the page",
// "You can also view the {self_link latest=1}latest version{/self_link}" => "You can also view the {self_link latest=1}latest version{/self_link}",
// "View the {self_link latest=1}latest version{/self_link}" => "View the {self_link latest=1}latest version{/self_link}",
"Forum Importer" => "Importador de Fòrums",
"Admin forums" => "Admin fòrums",
"Import from a Local SQL File" => "Importa a partir d'arxiu SQL Local",
"Forum Type" => "Tipus de Fòrum",
"DB Prefix" => "Prefix de DB",
"Local SQL Filename on Server (path will be stripped)" => "Arxiu SQL local al servidor (la ruta serà estripada)",
"Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up" => "Ha d'estar a tikiroot/{\$tmpdir} o a tikiroot/img/wiki_up",
// "Get Forum List" => "Get Forum List",
"Verification" => "Verificació",
// "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>" => "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>",
"File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred." => "No s'ha especificat l'arxiu, o no va ser possible trobar-lo en cap dels dos llocs.  Si us plau, posar l'arxiu en algun dels dos directoris i torna Enrere. Si l'arxiu hi és en ambdos llocs, el lloc \$tikiroot/{\$filecheck} serà escollit preferentment.",
// "Proceed" => "Proceed",
"Go Back" => "Torna enrere",
"Select a Forum You Wish to Move (ONE at a time!)" => "Selecciona un Fòrum que vulguis moure (UN cada cop!)",
"Which Forum Do You Wish to Import this Into?" => "A quin fòrum vols importar això?",
// "Message queue for forum" => "Message queue for forum",
"Back to forum" => "Torna al fòrum",
"Edit queued message" => "edita missatge en cua",
"make this a thread of" => "fes aixó un missatge permanent de",
"None, this is a thread message" => "Cap, aquest és un missatge fil",
"summary" => "resum",
"Announce" => "Anunci",
"Hot" => "Calent",
"no feeling" => "sense sentiment",
"frown" => "front",
"exclaim" => "Exclamació",
"idea" => "idea",
"neutral" => "neutral",
"question" => "pregunta",
"happy" => "feliç",
"wink" => "parpadejar",
"Save and Approve" => "Desa i aprova",
"convert to topic" => "converteix a tema",
"List of messages" => "Llista de missatges",
"Topic:" => "Tema:",
"New Topic" => "Nou tema",
"no summary" => "sense resum",
"No messages queued yet" => "Encara no hi ha missatges a la cua",
"Search by name" => "Cerca per nom de fòrum",
"Search in content" => "Cerca al contingut dels fòrums",
"Last Post" => "Darrer missatge",
"Configure Forum" => "Configura el fòrum",
"Reported messages for forum" => "Missatges dels quals s'ha informat per fòrum",
"Reported by" => "Reportat per",
"Perfom action with checked" => "Realitza l'acció amb els items seleccionats",
// "Un-report" => "Un-report",
"Tag translation" => "Etiqueta traducció",
"Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag." => "Fixa't que les etiquetes que han estat creades a pàgines sense idioma assignat romandran \n\tuniversals (és a dir, amb la mateixa etiqueta a tots els idiomes) fins que s'especifiqui un idioma per a l'etiqueta.",
"Until then, they cannot be translated." => "Fins llavors, no poden ser traduïdes.",
"Show checkboxes to clear language information on tags" => "Mostra caselles de verificació per netejar la informació d'idioma a les etiquetes",
"Previous" => "Anterior",
"There are no tags on this page in your preferred languages" => "No hi ha etiquetes en aquesta pàgina per als teus idiomes preferits",
"Set language" => "Especifica idioma",
"Universal" => "Universal",
"Show the following languages" => "Mostra els següents idiomes",
"Pending requests" => "Peticions pendents",
"Request Time" => "Data de petició",
"Accept" => "Accepta",
"Refuse" => "Rebutja",
"Waiting requests" => "Esperant peticions",
"Cancel friendship request" => "Cancel·la la sol·licitud d'amistat",
"Your friends" => "Les teves amistats",
"break friendship" => "trenca amistat",
"Galleries" => "Galeries",
"Create New Gallery" => "Crear una nova galeria",
"Create a gallery" => "Crear una galeria",
"Edit this gallery:" => "edita aquesta galeria:",
"There are individual permissions set for this gallery" => "Existeixen permisos fixats individualment per a aquesta galeria",
"Gallery is visible to non-admin users?" => "Galeria visible per usuaris no autoritzats",
"Geographic" => "Geogràfic",
"Fields to show during browsing the gallery" => "Camps que es mostren quan es navega per la galeria",
"XY-Size" => "mida-XY",
"Gallery Image" => "Imatge de la galeria",
"Available scales" => "Permesses escales",
"Global default" => "Per defecte Global",
"Bounding box" => "Requadre delimitador",
"default scale" => "escala per defecte",
"No scales available" => "No hi ha cap escala disponible",
"Original image is default scale" => "La imatge original és a l'escala per defecte",
"Add scaled images with bounding box of square size" => "Afegeix imatges escalades amb requadre delimitador quadrat",
"Other users can upload images to this gallery" => "Permetre a altres usuaris afegir imatges en aquesta galeria",
"You can access the gallery using the following URL" => "Pots accedir a la galeria emprant la URL",
"Available Galleries" => "Galeries disponibles",
"Choose a filter" => "Escull un filtre",
"Imgs" => "Imtgs",
"Make Map" => "Fes el Mapa",
"Google Map Locator" => "Localitzador als Mapes de Google",
"Back to preferences" => "Torna a preferències",
"enter address" => "introdueix adreça",
"Find address" => "Cerca l'adreça",
"Save clicked point" => "Guarda el punt on he clicat",
"Reset view to default" => "Torna a especificar la visualització al que hi ha per omissió",
"Save current view as default" => "Guarda la visualització actual com a la visualització per defecte",
"Center map to saved point" => "Centra el mapa al punt desat",
"Reset view to site default" => "Torna a especificar la visualització al que hi ha per omissió en aquest lloc",
"Users Map" => "Mapa d'Usuaris",
"Select Graphic Type" => "Selecciona Tipus de Gràfic",
"Pie Chart" => "Gràfic de Pastís",
"Multiline" => "Multilínia",
"Multibar" => "Multibarra",
"Bar Stack" => "Barres apilades",
"Landscape" => "Apaisat",
"Portrait" => "Vertical",
"Independant Scale" => "Escala independent",
"Horizontal Scale" => "Escala horitzontal",
"Vertical Scale" => "Escala vertical",
"Series" => "Sèries",
// "Edit Spreadsheet" => "Edit Spreadsheet",
// "List Spreadsheets" => "List Spreadsheets",
"Wiki plug-in" => "Connector Wiki (plug-in)",
// "Spreadsheet History" => "Spreadsheet History",
"Clone" => "Clona-ho",
"Rollback" => "Restableix",
"Toggle Full Screen" => "Commuta la Pantalla Completa",
"Date Selection" => "Selecció de dates",
"Edit Date" => "Edita la Data",
// "View Spreadsheet" => "View Spreadsheet",
// "Clone Spreadsheet" => "Clone Spreadsheet",
// "Roll Back Spreadsheet" => "Roll Back Spreadsheet",
// "Roll-Back" => "Roll-Back",
// "Ical import / Export" => "Ical import / Export",
"Select The calendar to export" => "Escull el calendari que vols exportar",
"Calendar Import" => "Importació de Calendaris",
// "ICal File" => "ICal File",
"Import From File" => "Importa des d'un arxiu",
"Grab Wiki Tables" => "Agafa les Taules Wiki",
"Import pages from a Structured Text Dump" => "Importa pàgines d'una descarrega de text estructurada",
"Name of the dump file (it has to be in dump/)" => "Nom de l'arxiu de descàrrega (ha d'estar a dump/)",
"Overwrite existing pages if the name is the same" => "Sobreescriu pàgines existents si el nom és el mateix",
"Previously remove existing page versions" => "Treu primer les versions existents de la pàgina",
"excerpt" => "extracte",
"Result" => "Resultat",
"body" => "cos",
"Or" => "O",
// "Name of the zip file on the server" => "Name of the zip file on the server",
// "Tiki Importer" => "Tiki Importer",
// "If you are NOT running a new Tiki installation, make a backup of your database before using this importer" => "If you are NOT running a new Tiki installation, make a backup of your database before using this importer",
// "If your pages contain XML code, the HTML purifier will delete it. Deactivate this feature" => "If your pages contain XML code, the HTML purifier will delete it. Deactivate this feature",
// "Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibility to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode" => "Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibility to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode",
// "Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)" => "Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)",
// "Select the software to import from" => "Select the software to import from",
// "WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button" => "WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button",
// "Congratulations! You have successful imported your data to Tiki" => "Congratulations! You have successful imported your data to Tiki",
// "%0 pages imported from a total of %1" => "%0 pages imported from a total of %1",
// "%0 pages imported" => "%0 pages imported",
// "(you can see the list of wiki pages in your site <a href=\"tiki-listpages.php\">here</a>)" => "(you can see the list of wiki pages in your site <a href=\"tiki-listpages.php\">here</a>)",
// "%0 posts imported" => "%0 posts imported",
// "%0 tags imported" => "%0 tags imported",
// "%0 categories imported" => "%0 categories imported",
"Errors:" => "Errors:",
// "Importer log" => "Importer log",
// "Suggested .htaccess rules" => "Suggested .htaccess rules",
// "Locked by %0" => "Locked by %0",
"Tiki installer" => "Instal·lador de Tiki",
"Welcome" => "Benvinguts",
"Welcome to the Tiki installation and upgrade script" => "Benvinguts/des a l'Instal·lador i actualitzador de Tiki",
"Use this script to install a new Tiki database or upgrade your existing database to release" => "Empra aquesta utilitat per instal·lar una nova base de dades o actualitzar la teva base de dades existent a la versió",
"For the latest information about this release, please read the" => "Per a la darrera informació sobre aquest alliberament, si us plau, llegeix les",
"Release Notes" => "Notes d'alliberament",
"For complete documentation, please visit" => "Per a la documentació completa, si us plau visita",
"For more information about Tiki, please visit" => "Per més informació sobre Tiki, si us plau visita",
"Select your language" => "Selecciona el teu idioma",
"Read the License" => "Llegeix la Llicència",
"Tiki is software distributed under the LGPL license" => "Tiki és programari distribuït sota la llicència LGPL",
"Review the System Requirements" => "Revisa els requeriments del Sistema",
"Review" => "Revisió",
"Before installing Tiki, <a href=\"http://doc.tiki.org/Requirements\" target=\"_blank\">review the documentation</a> and confirm that your system meets the minimum requirements" => "Abans d'instal·lar Tiki, <a href=\"http://doc.tiki.org/tiki-index.php?page=Requirements&bl=y\" target=\"_blank\">revisa la documentació</a> i confirma que el teu sistema té els requeriments mínims necessaris",
"This installer will perform some basic checks automatically" => "Aquest instal·lador realitzarà algunes comprovacions bàsiques automàticament",
// "Please see: " => "Please see: ",
// "a detailed report about your server" => "a detailed report about your server",
"Tiki has not detected your PHP memory_limit" => "Tiki no ha detectat el teu  memory_limit de PHP",
"This probably means you have no set limit (all is well)" => "Això probablement vol dir que no tens límit específicat (tot està bé)",
"Tiki has detected your PHP memory limit at" => "Tiki ha detectat que tens el limit de memòria de PHP a",
// "Tiki requires <strong>at least</strong> 128MB of PHP memory for script execution" => "Tiki requires <strong>at least</strong> 128MB of PHP memory for script execution",
"Allocating too little memory will cause Tiki to display blank pages" => "Permetre massa poca memòria provocarà que Tiki mostri pàgines en blanc en algunes funcionalitats",
// "To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 128M) and restart your webserver" => "To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 128M) and restart your webserver",
"Tiki has detected your PHP memory_limit at" => "Tiki ha detectat el paràmetre de PHP memory_limit del teu servidor web en",
"Tiki uses the PHP <strong>mail</strong> function to send email notifications and messages" => "Tiki empra la funció PHP <strong>mail</strong> per enviar notificacions per correu-e i missatges",
"To test your system configuration, Tiki will attempt to send a test message to you" => "Per tal de provar la configuració del teu sistema, Tiki provarà d'enviar-te un missatge de correu-e de prova",
"Test email" => "Test email",
"Email address to send test to" => "Adreça de correu-e a on enviar el correu-e de prova",
"Copy test mail to " => "Copia el correu-e de prova a ",
"Send Test Message" => "Envia missatge de prova",
"Tiki was able to send a test message to" => "Tiki ha pogut enviar el missatge de prova a ",
"Tiki was not able to send a test message" => "Tiki no ha pogut enviar cap missatge de prova",
"Review your mail log for details" => "Revisa el registre del correu-e del servidor per més detalls",
"Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)" => "Revisa els paràmetres del correu en l'arxiu <strong>php.ini</strong> del teu sistema (per exemple: confirma que la ruta <strong>sendmail_path</strong> és correcta)",
"If your host requires SMTP authentication, additional configuration may be necessary" => "Si el teu hoste requereix autenticació SMTP, pot ser necessària una mica més de configuració addicional",
"Image Processing" => "Processat d'imatges",
"Tiki detected" => "Tiki ha detectat",
"Tiki can create images" => "Tiki pot crear imatges",
"Tiki was not able to create a sample image. Please check your GD library configuration" => "Tiki no ha pogut crear una imatge de prova. Si us plau, comprova la configuració de la llibreria GD",
"Tiki was not able to detect the GD library" => "Tiki no ha pogut detectar la llibreria GD",
"Tiki uses the GD library to process images for the Image Gallery and CAPTCHA support" => "Tiki empra la llibreria GD per processar imatges a les galeries d'imatges i per al suport al CAPTCHA (imatges de verificació anti-robots)",
"Set the Database Connection" => "Especifica la connexió a la base de dades",
"Tiki requires an active database connection" => "Tiki requireix una connexió activa a base de dades",
"You must create the database and user <em>before</em> completing this page" => "Has de crear la base de dades i el seu usuari <em>abans</em> de completar aquesta pàgina",
"Tiki cannot find a database connection" => "Tiki no pot trobar cap connexió amb la base de dades",
"This is normal for a new installation" => "Això és normal per a una instal·lació nova",
"Tiki found an existing database connection in your local.php file" => "Tiki ha trobat que ja existeix una connexió a base dades en el teu arxiu local.php",
"Database name: &quot;%0&quot" => "Nom de la Base de dades: &quot;%0&quot",
"Use Existing Connection" => "Empra la connexió existent",
"Modify database connection" => "Modifca la connexió a la base de dades",
"Use this page to create a new database connection, or use the <a href=\"http://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>" => "Empra aquesta pàgina per crear una nova connexió a base de dades, o empra el <a href=\"http://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">procés d'instal·lació manual</a>",
"Database information" => "Informació de la Base de dades",
"Enter your database connection information" => "Introdueix la informació de la teva connexió a base de dades",
"Database type" => "Tipus de Base de dades",
"Select the type of database to use with Tiki." => "Selecciona el tipus de base de dades per emprar amb Tiki.",
"Only databases supported by your PHP installation are listed here. If your database is not in the list, try to install the appropriate PHP extension." => "Aquí només es mostren les bases de dades suportades per la teva instal·lació PHP. Si la teva base de dades no està a la llista, prova d'instal·lar l'extensió de PHP apropiada.",
"Host name" => "Nom de l'hoste",
"Enter the host name or IP for your database" => "Introdueix el nom de l'hoste o IP per a la teva base de dades",
"Use <strong>localhost</strong> if the database is running on the same machine as Tiki" => "Empra <strong>localhost</strong> si la base de dades s'està executant a la mateixa màquina que el Tiki",
// "For non-default port number use <strong>example.com;port=3307</strong>" => "For non-default port number use <strong>example.com;port=3307</strong>",
"Database name" => "Nom de la Base de dades",
"Enter the name of the database that Tiki will use (if already created) or create (if permitted)" => "Introdueix el nom de la base de dades que Tiki emprarà (si ja existeix) o crearà (si té permisos)",
// "You can create the database using mysqladmin, phpMyAdmin, cPanel, or ask your hosting provider. If the database doesn't exist and the supplied username has permissions, the database will be created" => "You can create the database using mysqladmin, phpMyAdmin, cPanel, or ask your hosting provider. If the database doesn't exist and the supplied username has permissions, the database will be created",
// "If you are using a database which is already being used for something else (not recommended), check db/tiki.sql to make sure the table names used by Tiki are not already used" => "If you are using a database which is already being used for something else (not recommended), check db/tiki.sql to make sure the table names used by Tiki are not already used",
"Database user" => "Usuari de la Base de dades",
"Enter a database user with administrator permission for the Database" => "Introdueix un usuari de base de dades amb permisos d'administració per a la Base de dades",
"User name:" => "Nom d'usuari:",
"Character set" => "Conjunt de caràcters",
"Highly recommended for new installations. However, if you are upgrading or migrating a previous tiki database, you are recommended to uncheck this box" => "Altament recomanat per a instal·lacions noves. De totes formes, si estàs actualitzant o migrant una base de dades prèvia de Tiki, es recomana que treguis la selecció d'aquesta casella de sota",
"Always force connection to use UTF-8" => "Força sempre a que s'utilitzi el conjunt de caràcters UTF-8 per a la connexió a la base de dades",
"More information" => "Més informació",
"Install &amp; Upgrade" => "Instal·lacions &amp; Actualitzacions",
"Install" => "Instal·lació",
"Failed to set max_execution_time for PHP. You may experience problems when creating/upgrading the database using this installer on a slow system. This can manifest itself by a blank page" => "No s'ha pogut esecificar el paràmetre max_execution_time per a PHP. És possible que hi et trobis amb problemes quan creis o actualitzis la base de dades emprant aquest instal·lador en un sistema lent. Això es manifestar a través d'una pàgina en blanc",
"This install will populate (or upgrade) the database" => "Aquesta instal·lació omplirà (o actualitzarà) la base de dades",
"If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"http://doc.tiki.org/Upgrade\" target=\"_blank\">Upgrade instructions</a>" => "Si vols actualitzar des d'una versió prèvia de Tiki, assegura't d'haver llegit i entès les <a href=\"http://doc.tiki.org/Upgrade\" target=\"_blank\">instruccions d'Actualització</a>",
"A new install will populate the database" => "S'omplirà la base de dades amb una instal·lació nova",
"Encoding Issue" => "Qüestió de la codificació",
"<p>Your database encoding is <strong>not</strong> in UTF-8.</p><p>Current encoding is <em>%0</em>. The languages that will be available for content on the site will be limited. If you plan on using languages not covered by the character set, you should re-create or alter the database so the default encoding is <em>utf8</em>.</p>" => "<p>La codificació (conjunt de caràcters) de la teva base de dades  <strong>no</strong> es troba en UTF-8.</p><p>La codificació actual és <em>%0</em>. Els idiomes que estaran disponibles per al contingut d'aquest lloc seran limitats. Si tens intenció d'emprar idiomes que no estan coberts pel conjunt de caràcters, hauries de re-crear o modificar la base de dades de forma que la codificació per omissió sigui <em>utf8</em>.</p>",
"Character Set Conversion" => "Conversió del Conjunt de Caracters",
"Use at your own risk. If the data in the database currently contains improperly converted data, this may make matters worse. Suitable for new installations. Requires ALTER privilege on the database" => "Empra sota el teu propi risc. Si les dades a la base de dades contenen actualment dades convertides inadequadament, aquest procés pot fer que les coses empitjorin. Aquest procés és adequat per a instal·lacions noves. Requereix el privilegi ALTER sobre la base de dades",
"Convert database and tables to UTF-8" => "Converteix la base de dades i taules a UTF-8",
"This will destroy your current database &quot;%0&quot;" => "Això destruirà la teva base de dades actual &quot;%0&quot;",
"Reinstall the database" => "Reinstal·la la base de dades",
"Select database engine" => "Selecciona el motor de la base de dades",
// "MyISAM" => "MyISAM",
// "InnoDB" => "InnoDB",
"Reinstall" => "Reinstal·la-ho",
"Upgrade" => "Actualització",
"Warning: Category Permissions Will Not Be Upgraded" => "Avís: Els permisos de categories no seran actualitzats automàticament",
"Category permissions have been revamped since version 3. If you have been using category permissions, note that they may not work properly after upgrading to version 4 onwards, and it will be necessary to reconfigure them" => "Els permisos de categories han estat modificats substancialment des de la versió 3. Si has estat emprant permisos de categories, tingues en compte que és possible que no funcionin adequadament després d'actualitzar a Tiki 4 o versions posteriors, i serà necessari que els reconfiguris manualment",
"Automatically upgrade your existing database to v" => "Actualitza automàticament la teva base de dades existent a la v",
"This site has an admin account configured" => "Aquest lloc té un compte d'administrador configurat",
"Please log in with your admin password to continue" => "Si us plau, connecta't amb la teva contrasenya de persona administradora (admin) per tal de continuar",
"Pass" => "Contrasenya",
"Review the Upgrade" => "Revisa l'Actualització",
"Review the Installation" => "Revisa la Instal·lació",
"Upgrade complete" => "Actualització completa",
"Installation complete" => "Instal·lació completa",
"Your database has been configured and Tiki is ready to run" => "La teva base de dades ha estat configurada i Tiki està llest per funcionar",
"If this is your first install, your admin password is <strong>admin</strong>." => "Si és la teva primera instal·lació, la teva contrasenya d'administrador <strong>admin</strong>.",
"You can now log in into Tiki as user <strong>admin</strong> and start configuring the application" => "Ara pots connectar-te al teu Tiki com a usuari <strong>admin</strong> i començar a configurar l'aplicació",
"Upgrade operations executed successfully" => "Operacions d'actualització executades amb èxit",
"Installation operations executed successfully" => "Operacions d'instal·lació executades amb èxit",
"SQL queries" => "Consultes SQL",
"Database was left unchanged" => "S'ha deixat la base de dades sense canvis",
"Failed" => "No  han tingut èxit",
"Operations failed" => "Operacions que no han tingut èxit",
"Display details" => "Mostra detalls",
"During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages." => "Durant una actualització, és normal tenir missatges d'error SQL de l'estil <strong>La taula ja existeix</strong>.",
// "Check all errors" => "Check all errors",
".htaccess File" => "Arxiu .htaccess",
"We recommend enabling the <strong>.htaccess</strong> file for your Tiki" => "Recomanem habilitar l'arxiu <strong>.htaccess</strong> per al teu Tiki",
"This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security" => "Això et permetrà emprar les  SEFURLs (adreces d'internet amigables als cercadors) i ajudar a millorar la seguretat del teu lloc",
"Configure General Settings" => "Configuracions Generals",
"Complete these fields to configure common, general settings for your site" => "Completa aquests camps per configurar paràmetres comuns i generals del teu lloc",
"The information you enter here can be changed later" => "La informació que introdueixis aquí la podràs canviar més endavant",
"Refer to the <a href=\"http://doc.tiki.org/Admin+Panels\" target=\"_blank\">documentation</a> for complete information on these, and other, settings" => "Consulta la <a href=\"http://doc.tiki.org/Admin+Panels\" target=\"_blank\">documentació</a> per informació completa sobre aquests i altres paràmetres de configuració",
"This will appear in the browser title bar" => "Això apareixerà en la barra de títol del navegador",
"Email sent by your site will use this address" => "Els correus-e enviats pel teu lloc empraran aquesta adreça de sortida",
"Secure Log in" => "Connexió Segura",
// "It is recommended to choose the \"Require secure (https) login\" option for better security. A security certificate and dedicated IP address are required to implement a secure login" => "It is recommended to choose the \"Require secure (https) login\" option for better security. A security certificate and dedicated IP address are required to implement a secure login",
"HTTPS login" => "Connexió segura HTTPS",
"PHP error reporting level" => "Nivell d'informes d'error de PHP",
"Report all errors except notices" => "Informar de tots els errors excepte les notificacions",
"Visible to Admin only" => "Visibles només a persones administradores",
"Administrator" => "Administrador/a",
"Admin email" => "Correu-e de l'admin",
"This is the email address for your administrator account" => "Aquesta és l'adreça de correu-e del teu compte d'administrador/a",
"Upgrade fix" => "Reparació per a actualitzacions (opcional)",
"Experiencing problems with the upgrade? Your administrator account lost its privileges? This may occur if you upgraded from a very old version of Tiki.</p>\n\t\t\t<p>We can fix it! Doing so will" => "T'has trobat amb problemes amb la teva actualització? El teu compte d'admin ha perdut els seus privilegis? Això pot ocórrer si has actualitzat des d'una versió molt antiga de Tiki.</p>\n\t\t\t<p>Podem arregar-lo! Fer-ho realitzarà les següents acccions",
"Create the <em>Admins</em> group, if missing" => "Es crearà el grup <em>Admins</em>, si no hi és present",
"Grant <em>tiki_p_admin</em> to the group, if missing" => "Es donarà el permís <em>tiki_p_admin</em> al grup, si hi manca",
"Add the administrator account to the group, if missing" => "S'afegirà el compte d'administrador (admin) al grup, si no hi és",
"To do so enter the name of the main admin account in the field below" => "Per a fer-ho introdueix el nom del compte d'usuari principal d'administració en el camp de sota",
"Administrator account (optional): <input type=\"text\" name=\"admin_account\"/> <em>The default account is <strong>admin</strong></em>" => "Compte de l'Administrador (opcional): <input type=\"text\" name=\"admin_account\"/> <em>El compte per omissió és <strong>admin</strong></em>",
// "Check this box if you have a lot of disabled accounts after an upgrade to tiki4" => "Check this box if you have a lot of disabled accounts after an upgrade to tiki4",
// "List of accounts that will be enabled" => "List of accounts that will be enabled",
"Enter Your Tiki" => "Entra al teu Tiki",
"The installation is complete" => "S'ha acabat el procés d'instal·lació",
"Tiki is an open source project, <em>you</em> can <a href='http://info.tiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tiki.org/Develop+Tiki' target='_blank'>develop Tiki</a>" => "Tiki és un projecte de codi lliure/fonts obertes: <em>tu</em> també pots <a href='http://info.tiki.org/Join+the+Community' target='_blank'>ajuntar-te amb la comunitat</a> i ajudar <a href='http://info.tiki.org/Develop+Tiki' target='_blank'>a desenvolupar Tiki</a>",
"Installation" => "Instal·lació",
"If this is a first time installation, go to <strong>tiki-admin.php</strong> after login to start configuring your new Tiki installation" => "Si aquesta és una instal·lació inicial, ves a <strong>tiki-admin.php</strong> després de connectar-te per tal de començar a configurar la teva nova instal·lació Tiki",
"If this is an upgrade, clean the Tiki caches manually (the <strong>templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu." => "Si això és una actualització, neteja la memòria cau (cache) de Tiki manualment (el directori <strong>templates_c</strong>) o a través d'emprar l'opció del menú d'administració <strong>Admin &gt; Sistema</strong>.",
"Enter Tiki and Lock Installer" => "Entra a Tiki i bloqueja l'Instal·lador",
"Recommended" => "Recomanat",
"Enter Tiki Without Locking Installer" => "Entra a Tiki SENSE bloquejar l'Instal·lador",
// "Not recommended due to security risk" => "Not recommended due to security risk",
"Stay up-to-date" => "Estigues actualitzat",
"Subscribe to the <a href=\"http://tiki.org/Newsletter\" title=\"Subscribe\" target=\"_blank\">Tiki newsletter</a> or <a href=\"http://info.tiki.org/tiki-articles_rss.php\" title=\"RSS\" target=\"_blank\">RSS feed</a> to learn about new releases, security updates, and community news" => "Subscriu-te al <a href=\"http://tiki.org/Newsletter\" title=\"Subscribe\" target=\"_blank\">Butlletí de Tiki</a> o a l'<a href=\"http://info.tiki.org/tiki-articles_rss.php\" title=\"RSS\" target=\"_blank\">alimentació RSS</a> per a assabentar-te de noves versions que s'alliberin, actualitzacions de seguretat, i notícies de la Comunitat",
"You can now access the site normally. Report back any issues that you might find (if any) to the Tiki forums or bug tracker" => "Ja pots accedir ara al lloc amb normalitat. Informa de qualsevol incidència o problemes que detectis (si és el cas) als fòrums comunitaris o al formulari de registre d'errors",
"Are you sure you want to attempt to fix the encoding of your entire database" => "Segur que vols intentar solucionar la codificació de la teva base de dades sencera",
"Upgrading and running into encoding issues" => "Actualitant i trobant-te amb incidències de codificació",
"We can try to fix it, but <strong>make sure you have backups, and can restore them</strong>" => "Podem intentar solucionar-ho, però <strong>assegura't que tens còpies de seguretat, i que pots restaurar-les</strong>",
"Previous table encoding" => "Codificació anterior de les taules",
"Please select" => "Si us plau, selecciona una",
"Dangerous: Fix double encoding" => "Perillós: Arregla la codificació doble",
"Oops. You need to make sure client charset is forced to UTF-8. Reset the database connection to continue" => "Uups. Has d'assegurar-te que el conjunt de caràcters del client està forçat a UTF-8. Re-especifica la connexió a la base de dades per poder continuar",
"MultiTiki Setup" => "Instal·lació MultiTiki",
"Default Installation" => "Instal·lació per omissió",
"DB OK" => "BD OK",
"No DB" => "Cap BD",
"Adding a new host" => "Afegint un nou hoste",
"To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter" => "Per afegir un nou allotjament virtual executa l'arxiu setup.sh amb el nom del domini del nou allotjament com a últim paràmetre",
"MultiTiki" => "MultiTiki",
"Are you upgrading an existing Tiki site" => "Estàs actualitzant un lloc Tiki existent",
"Go directly to the <strong>Install/Upgrade</strong> step" => "Ves directament al pas d'<strong>Instal·lació / Actualització</strong> ",
"Install/Upgrade" => "Instal·lació / Actualització",
"Restart the installer" => "Reinicia l'instal·lador",
"Database Connection" => "Connexió a la Base de dades",
"Reset the Database Connection" => "Re-especifica la connexió a la Base de dades",
"Configure the General Settings" => "Configura els paràmetres generals",
"Tiki Icon" => "Icona de Tiki",
"Tiki Project Web Site" => "Lloc Web del Projecte Tiki",
"Documentation" => "Documentació",
"Support Forums" => "Fòrums de Suport",
"Powered by Tiki Wiki CMS Groupware" => "Potenciat per Tiki Wiki CMS Groupware",
"Clear cached version and refresh cache" => "Neteja versió captada i actualitza memòria cau",
"configure rules" => "configura normes",
"Edit Repository" => "Edita dipòsit",
// "Invitation" => "Invitation",
// "Invitations list" => "Invitations list",
// "The mail has been sent to: " => "The mail has been sent to: ",
// "You are about to send an invitation to theses people, please confirm" => "You are about to send an invitation to theses people, please confirm",
// "Fill this box with the list of e-mails you want to invite " => "Fill this box with the list of e-mails you want to invite ",
// "Format of the list above " => "Format of the list above ",
// "CSV Style: One line per invitation, with the format: lastname,firstname,email" => "CSV Style: One line per invitation, with the format: lastname,firstname,email",
// "Everything that appear as an email in the text will be detected and used (in that case, {literal}{firstname} and {lastname}{/literal} will be ignored in the email content)" => "Everything that appear as an email in the text will be detected and used (in that case, {literal}{firstname} and {lastname}{/literal} will be ignored in the email content)",
// "Type here the e-mail subject you'll want to be sent to them " => "Type here the e-mail subject you'll want to be sent to them ",
// "Type here the e-mail content you'll want to be sent to them (and let the {literal}{link}{/literal} word, it will be replaced with the good link for registering) " => "Type here the e-mail content you'll want to be sent to them (and let the {literal}{link}{/literal} word, it will be replaced with the good link for registering) ",
// "Type here the content that the user will see when he'll click on the link from the mail " => "Type here the content that the user will see when he'll click on the link from the mail ",
// "Choose one or more group you want theses suscribtion to be in. Don't choose any if you don't want anything special " => "Choose one or more group you want theses suscribtion to be in. Don't choose any if you don't want anything special ",
// "Invoices" => "Invoices",
"New Invoice" => "Nova factura",
// "Clients" => "Clients",
// "New Client" => "New Client",
// "Invoice Reports" => "Invoice Reports",
// "Upload to Kaltura" => "Upload to Kaltura",
// "Upload Successful" => "Upload Successful",
// "You have successfully added {\$count} new entry/entries" => "You have successfully added {\$count} new entry/entries",
// "Add more media" => "Add more media",
// "Change Details" => "Change Details",
// "Remix" => "Remix",
// "Media Entries" => "Media Entries",
// "Advanced Editor" => "Advanced Editor",
// "Simple Editor" => "Simple Editor",
// "Video Title" => "Video Title",
"Editor" => "Editor",
// "Embed code" => "Embed code",
// "Plays" => "Plays",
// "No action specified" => "No action specified",
"Last Changes" => "Últimes modificacions",
"Last 2 days" => "Darrers 2 dies",
"Last 3 days" => "Darrers 3 dies",
"Last 5 days" => "Darrers 5 dies",
"Last week" => "Darrera setmana",
"Last 2 weeks" => "Darreres 2 setmanes",
"Last month" => "Darrer mes",
"Search by Date" => "Cerca per data",
"Found" => "Trobat",
"LastChanges" => "DarrersCanvis",
// "{\$lastchanges[changes].action|escape}" => "{\$lastchanges[changes].action|escape}",
"v" => "v",
"Pages like" => "Pàgines similars",
"New Article" => "Nou Article",
"View Submissions" => "Veure col·laboracions",
"Expiry Date" => "Data de Caducitat",
// "{\$listpages[changes].type|escape}" => "{\$listpages[changes].type|escape}",
// "{\$listpages[changes].disp_article}" => "{\$listpages[changes].disp_article}",
// "{\$listpages[changes].lang}" => "{\$listpages[changes].lang}",
// "{\$listpages[changes].hasImage}" => "{\$listpages[changes].hasImage}",
// "{\$listpages[changes].useImage}" => "{\$listpages[changes].useImage}",
"Permissons" => "Permissos",
"Select Duplicates" => "Selecciona els Duplicats",
"To use a banner in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone." => "Per utilitzar un banner en un <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">mòdul</a> o una plantilla, utilitzeu {literal}{banner zone=ABC}{/literal}, on ABC és el nom de la zona.",
"Create banner" => "Crea una banner",
"Method" => "Mètode",
"Use Dates?" => "Utilitzar dates?",
"Max Impressions" => "Impressions màx",
"Impressions" => "Impressions",
"Max Clicks" => "Clics Max.",
"Clicks" => "Clics",
"Create New Blog" => "Crear un nou bloc",
"List all comments" => "Mostra tots els comentaris",
"The cache is used by" => "La memòria cau és emprada per",
// "{\$headerName}" => "{\$headerName}",
"Approval" => "Aprova-ho",
// "More info" => "More info",
// "(no title)" => "(no title)",
// "{\$val|ucwords}" => "{\$val|ucwords}",
"Approved" => "Aprovat/da",
"Rejected" => "Rebutjat/da",
"Delete & Ban" => "Esborra i Censura",
"To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block." => "Per utilitzar blocs de continguts en una àrea de text (Pàgina wiki, etc), un <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">mòdul</a> o una plantilla, utilitzeu {literal}{content id=x}{/literal}, on x és l'ID del bloc de continguts.",
"You can also use {literal}{content label=x}{/literal}, where x is the label of the content block" => "També pots emprar {literal}{content label=x}{/literal}, on x és l'etiqueta del bloc de contingut",
"Available content blocks" => "Blocs disponibles",
"Current Value" => "Valor actual",
"Current ver" => "Versió actual",
"Next ver" => "Propera versió",
"Future vers" => "Vers. futura",
"Program" => "Programar",
// "Create/Edit content block" => "Create/Edit content block",
"Edit content block" => "Edita bloc de contingut",
"Create content block" => "Crea bloc de contingut",
"Available FAQs" => "PMF disponibles",
"Edit/Create" => "Edita/Crea",
"Edit this FAQ:" => "Editeu aquesta PMF:",
"Create new FAQ" => "Creeu una nova PMF",
"Create New FAQ:" => "Creeu una nova PMF:",
"Users can suggest questions" => "Els usuaris poden suggerir preguntes",
"Create a File Gallery" => "Crear una galeria d'arxius",
"RSS feed" => "Alimentació RSS",
// "Admin View" => "Admin View",
"Create a drawing" => "Crea un dibuix",
"SlideShow" => "Passi de diapositives",
"Keep gallery window open" => "Manté la finestra de la galeria oberta",
"Your comment" => "El teu comentari",
"optional" => "opcional",
"Modifications" => "Modificacions",
// "Property <b>{\$fgp_name}</b> Changed" => "Property <b>{\$fgp_name}</b> Changed",
"Gallery of this fileId" => "Galeria d'aquest número id d'arxiu",
"space use on" => "espai emprat a",
"Gallery Images" => "Galeries d'imatges",
"Inviter" => "Qui et convida",
// "Only successful invitations" => "Only successful invitations",
// "Only pending invitations" => "Only pending invitations",
// "Number of invitations" => "Number of invitations",
// "Invoice Clients" => "Invoice Clients",
// "Tax Status" => "Tax Status",
// "New Contact" => "New Contact",
// "Client Name" => "Client Name",
// "Kaltura Remix Entries" => "Kaltura Remix Entries",
// "Kaltura Media Entries" => "Kaltura Media Entries",
// "Loads" => "Loads",
// "List Remixes" => "List Remixes",
// "Browse Media Entries" => "Browse Media Entries",
// "Browse Remixes" => "Browse Remixes",
// "Create Remix" => "Create Remix",
// "Please select some media entries to use" => "Please select some media entries to use",
// "Remix Video" => "Remix Video",
"Additional Info" => "Informació adicional",
"Created by" => "Creat por",
// "Media Id" => "Media Id",
// "Wiki plugin code" => "Wiki plugin code",
"Media Type" => "Tipus de media",
"More Information" => "Més Informació",
"No entries" => "Sense entrades",
"No media entries found" => "No s'han trobat entrades de mèdia",
"Click here" => "Clic aquí",
"to upload" => "per pujar",
"Modified By" => "Modificat per",
// "No mix entries found" => "No mix entries found",
// "to create a new mix" => "to create a new mix",
// "Mix Entries" => "Mix Entries",
// "Playlist Type" => "Playlist Type",
// "No playlists found. " => "No playlists found. ",
// "Click here " => "Click here ",
// "to create a playlist" => "to create a playlist",
// "Object Permissions List" => "Object Permissions List",
// "Manage Permissions" => "Manage Permissions",
// "\$type" => "\$type",
// "global permissions" => "global permissions",
// "object permissions" => "object permissions",
// "category permissions" => "category permissions",
// "Global Permissions" => "Global Permissions",
// "Delete the selected permissions" => "Delete the selected permissions",
// "Duplicate the selected permissions on this group" => "Duplicate the selected permissions on this group",
// "Object Permissions" => "Object Permissions",
// "If an object is not listed in this section nor in the Category Permissions section, then only the global permissions apply to it" => "If an object is not listed in this section nor in the Category Permissions section, then only the global permissions apply to it",
// "Category Permissions" => "Category Permissions",
// "If an object is not listed in this section nor in the Object Permissions section, then only the global permissions apply to it" => "If an object is not listed in this section nor in the Object Permissions section, then only the global permissions apply to it",
// "{\$special.reason|escape}" => "{\$special.reason|escape}",
"Blog: %0" => "Bloc: %0",
"New Blog Post" => "Nova Publicació de Bloc",
"Post Title" => "Títol de Publicació",
"Blog Title" => "Títol del Bloc",
"New Submission" => "Nou enviament",
"Survey stats" => "Estadístiques de l'enquesta",
"Take Survey" => "Omple l'enquesta",
"trackers" => "formularis-bd",
"Items" => "Ítems",
"Export %0" => "Exporta %0",
"Import in %0" => "Importa a %0",
"Stop Monitor" => "Deixa de vigilar per correu-e",
"Monitor" => "Vigila-ho per correu-e",
"Create tracker" => "Crea un formulari-bd",
// "Do you really remove this tracker" => "Do you really remove this tracker",
// "Do you really want to clear all the items from this tracker? (N.B. there is no undo and notifications will not be sent)" => "Do you really want to clear all the items from this tracker? (N.B. there is no undo and notifications will not be sent)",
"Duplicate/Import Tracker" => "Duplica/Importa el formulari-bd",
"Duplicate Tracker" => "Duplica el Formulari-bd",
"Duplicate Remote Tracker" => "Duplica el Formulari-bd remot",
"Search for trackers to clone" => "Cerca formularis-bd a clonar",
"Import From Export" => "Importa d'una Exportació prèvia",
"Raw data" => "Dades crues",
"Preserve tracker ID" => "Preserva l'ID del formulari-bd",
"users registered" => "usuaris enregistrats",
"like" => "com",
"Distance (km)" => "Distància (km)",
// "{\$listuserscountry[changes]}" => "{\$listuserscountry[changes]}",
"List Wiki Pages" => "Llista les Pàgines Wiki",
"Page aliases found" => "S'han trobat noms alias de la pàgina",
"Create a Wiki Page" => "Crea una pàgina Wiki",
"Insert name of the page you wish to create" => "Inserta el nom de la pàgina que vols crear",
"Last mod" => "Darrera mod",
"Page creator" => "Creador de la pàgina",
"Last author" => "Darrer autor",
"Last version" => "Darrera versió",
"Last ver." => "Darr. ver.",
"Status of the page" => "Estatus de la pàgian",
"Vers." => "Vers.",
"Links to other items in page" => "enllaça a altres ítems a la pàgina",
"Links to this page in other pages" => "Enllaços a aquesta pàgina en altres pàgines",
"Backl." => "Retroenll.",
"Page size" => "Mida de pàgina",
"Lang." => "Idiom.",
// "Ratings" => "Ratings",
"unlocked" => "desbloquejat/da",
// "No page" => "No page",
// "No pages found with" => "No pages found with",
// "Xml Zip" => "Xml Zip",
// "Add page name as a header ! at the beginning of the page content" => "Add page name as a header ! at the beginning of the page content",
"Open client window" => "Obre la finestra de client",
"Generate HTML" => "Genera HTML",
"Transcripts" => "Transcripcions",
"Online operators" => "Operadors connectats",
"Operator" => "Operador",
"Accepted requests" => "Sol·licituds acceptades",
// "{\$online_operators[ix].status}" => "{\$online_operators[ix].status}",
"transcripts" => "transcripcions",
"offline" => "fora de línia",
"Offline operators" => "Operadors desconnectats",
// "{\$offline_operators[ix].status}" => "{\$offline_operators[ix].status}",
"Add an operator to the system" => "Afegiu un operador al sistema",
"Operators must be tiki users" => "Els operadors han de ser usuaris del tiki",
"Set as Operator" => "Definit com a operador",
"Chat started" => "Xat iniciat",
"Operator:" => "Operador:",
"Live support:User window" => "Suport Directe:finestra de l'usuari/a",
"Request live support" => "Demanar soport en directe",
"Request support" => "Demanar suport",
"Open a support ticket instead" => "Obrir una butlleta de suport",
"Your request is being processed" => "La teva petició està essent processada",
"cancel request and exit" => "Cancel·lar petició i sortir",
"cancel request and leave a message" => "Cancel·lar petició i deixar un missatge",
"Live support:Console" => "Suport Directe:Consol·la",
"Status:" => "Estat:",
// "{\$status}" => "{\$status}",
"be online" => "estar connectat",
"be offline" => "estar desconnectat",
// "You are not an operator" => "You are not an operator",
"Support requests" => "Peticións d'ajuda",
"Requested" => "Sol·licitat",
"Join" => "Uneix-te",
// "No support requests" => "No support requests",
"Support chat transcripts" => "Suport de transcripcions de chat",
"Back to admin" => "Torna a admin",
"operator" => "operador",
"started" => "començat",
"reason" => "raó",
"msgs" => "mstgs",
"Transcript" => "Transcripció",
"For security purposes we must periodically validate your email address to allow continued access to this site." => "Per qüestions de seguretat hem de validar periòdicament la teva adreça de correu-e per permetre l'acés continuat en aquest lloc.",
"A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site." => "Se t'ha enviat un correu-e de validació. Si us plau, obre'l i segueix les instruccions per obtenir de nou accés al lloc.",
"Thank you" => "Gràcies",
"Mail-in feature" => "Prestació Correu-in",
// "You do not have any mailin accounts set up" => "You do not have any mailin accounts set up",
// "Click here to go to mailin admin" => "Click here to go to mailin admin",
"Change to" => "Canvia a",
"Week containing" => "Setmana que contingui",
"Month containing" => "Mes que contingui",
// "{\$metrics_range_prefix}" => "{\$metrics_range_prefix}",
// "{\$metrics_range_suffix}" => "{\$metrics_range_suffix}",
"Missing dependency. Obtain <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/" => "Manca una dependència. Pots obtenir l'arxiu' <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> i pujar-lo a dins de la carpeta files/ al servidor",
"Prefs" => "Prefs",
"Daily" => "Diari",
"Weekly" => "Setmanal",
"Remove old events" => "Elimina els esdeveniments antics",
"h" => "h",
"mins" => "minuts",
"Edit Event" => "Edita Esdeveniment",
"Mini Calendar: Preferences" => "Mini Calendari: Preferències",
"Calendar Interval in daily view" => "Vista diària dels intervals del calendari",
"Start hour for days" => "Hora d'inici per als dies",
"End hour for days" => "Hora d'acabament per als dies",
"Reminders" => "Recordatoris",
"no reminders" => "sense recordatoris",
"min" => "min",
"Or enter path or URL" => "O entreu-hi el camí o la URL",
"Add Topic" => "Afegiu-hi un tema",
// "Tiki Mods" => "Tiki Mods",
"Mods Configuration" => "Configuració de Mods",
"Update remote index" => "Actualitza índex remot",
"Rebuild local list" => "Reconstrueix la lista local",
"Republish all" => "Republica'ls tots",
"Publish all" => "Publica'ls tots",
"Unpublish all" => "Despublica'ls tots",
"Tiki \"mods\" are additional features not included in the public release. Learn more at <a target=\"tikihelp\" href=\"http://mods.tiki.org\">mods.tiki.org</a>" => "Els \"mods\" de Tiki són funcionalitats adicionals no incloses en l'alliberament public de Tiki. Aprèn més a <a target=\"tikihelp\" href=\"http://mods.tiki.org\">mods.tiki.org</a>",
// "Tiki \"mods\" are undergoing refurbishment" => "Tiki \"mods\" are undergoing refurbishment",
"You will probably find mods shown as being compatible with older versions of Tiki will work with later versions with little or no modification" => "Probablement trobaràs que alguns mods mostrats com a compatibles amb versions antigues de Tiki fruncionaran amb versions posteriors de Tiki amb poques o cap modificació",
// "Your help is needed! Please visit <a href=\"http://dev.tiki.org/Mods\">dev.tiki.org</a> to find out more" => "Your help is needed! Please visit <a href=\"http://dev.tiki.org/Mods\">dev.tiki.org</a> to find out more",
"Attention" => "Atenció",
"Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"sh setup.sh\" for example)" => "Apache té permís per escriure en el teu arbre d'arxius, el que permet la instal·lació, esborrat o actualització de paquets. Quan hagis acabat amb aquestes operacions, pensa en tornar a deixar els permissos en un estat segur (emprant \"sh setup.sh\" per exemple)",
"To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"sh setup.sh open\" to set it up). After installation you need to remove that permission (using \"sh setup.sh\")" => "Per instal·lar, eliminar o actualitzar paquets necessites donar-li a l'usuari apache el dret a escriure arxius en el teu arbre de directoris (pots fer-ho emprant \"sh setup.sh open\" per configurar-ho així temporalment). Després de la instal·lació necessites eliminar aquests permisos (emprant \"sh setup.sh\")",
"for version" => "per a la versió",
"All versions" => "Totes les versions",
"or later" => "o posterior",
"No mods found" => "No s'han trobat mods",
"Display only this type" => "Mostra només aquest tipus",
"Unpublish" => "Despublica",
"Republish" => "Republica",
"licence" => "llicència",
"Last Modification:" => "última modificació:",
// "Tiki Mods Configuration" => "Tiki Mods Configuration",
"Mods Install/uninstall" => "Instal·lació/Desinstal·lació de Mods",
"Enable Mods providing" => "Habilita el proveïemnt de Mods",
"Mods local directory" => "Directori local de Mods",
"Mods remote server" => "Directori remot de Mods",
"Package Config" => "Configuració de Paquets",
"y" => "s",
// "Edit: %0" => "Edit: %0",
"User Galleries" => "Galeries de l'usuari/a",
"My Articles" => "Els meus Articles",
"User Articles" => "Articles de l'usuari",
"My User Items" => "Els meus ítems d'usuari",
"User Items" => "Ítems d'usuari",
"Unread Messages" => "Missatges no llegits",
"User forum topics" => "Tòpics de l'usuari als fòrums",
"Forum topics" => "Tòpics del Fòrum",
"Date of post" => "Data de publicació",
"User forum replies" => "Respostes de l'usuari al fòrum",
"Forum replies" => "Respostes al Fòrum",
"User Blogs" => "Blocs de l'usuari",
"To display the objects you created or contributed to:" => "Per mostrar els objectes en els que participes:",
"MyTiki" => "ElmeuTiki",
"MyInfo" => "Les meves informacions",
"Contacts Preferences" => "Preferències dels contactes",
"Notepad" => "Bloc de notes",
"MyFiles" => "Elsmeusarxius",
"My Watches" => "Els meus avisos",
"Sent editions" => "Edicions enviades",
"HTML version" => "Versió en HTML",
"Text version" => "Versió en Text senzill",
"The newsletter was sent to {\$sent} email addresses" => "El butlletí ha estat enviat a {\$sent} adreces de correu-e",
"Delete errors" => "Esborra errors",
"Not sent" => "No s'ha enviat",
"Thanks for your subscription. You will receive an email soon to confirm your subscription. No newsletters will be sent to you until the subscription is confirmed." => "Gràcies per la vostra subscripció. Aviat rebreu un missatge  com a confirmació de la vostra subscripció. No rebreu cap butlletí fins que confirmeu la subscripció.",
"Your email address was removed from the list of subscriptors." => "La teva adreça de correu-e ha estat eliminada de la llista de subscriptors.",
"Removal of your email address failed" => "No s'ha pogut treure la teva adreça de correu-e",
"Subscription confirmed!" => "Subscripció confirmada!",
"Subscription failed" => "La subscripció ha fallat",
"Subscribe to Newsletter" => "Subscriure a butlletí",
"Subscribe to this Newsletter" => "Subscriu",
"Available Newsletters" => "Butlletins disponibles",
"Write a note" => "Escriu una nota",
"quota" => "quota",
"No notes yet" => "Encara no hi ha notes",
"Merge selected notes into" => "fusiona les notes seleccionades en",
"Reading note:" => "Nota de lectura:",
"List notes" => "Llista de notes",
"Write note" => "Escriu nota",
"Wiki Create" => "Crea wiki",
"Wiki Overwrite" => "Sobrescriu wiki",
"Object Watches" => "Subscripcions a l'objecte",
// "Changes to groups watching" => "Changes to groups watching",
"These changes to group watches" => "Aquests canvis a subscripcions de grups",
"were made to these descendants" => "han estat fets a aquests descendents",
// "Groups watching" => "Groups watching",
"This Category" => "Aquesta Categoria",
"All Descendants" => "Tots els descendents",
// "Assign global permissions" => "Assign global permissions",
"Assign permissions to " => "Assignar permisos a ",
"Edit Permissions" => "Edita els permisos",
// "Currently editing Global permissions" => "Currently editing Global permissions",
// "This object's direct permissions override any global permissions or category permissions affecting this object" => "This object's direct permissions override any global permissions or category permissions affecting this object",
// "This category's direct permissions override any global permissions affecting objects in it" => "This category's direct permissions override any global permissions affecting objects in it",
// "To edit global permissions" => "To edit global permissions",
// "No permissions yet applied to this object but category permissions affect this object and are displayed below" => "No permissions yet applied to this object but category permissions affect this object and are displayed below",
// "To edit category permissions" => "To edit category permissions",
// "No direct permissions yet applied to this object. Global permissions apply" => "No direct permissions yet applied to this object. Global permissions apply",
// "Currently inherited permissions displayed" => "Currently inherited permissions displayed",
// "Assign permissions to this category" => "Assign permissions to this category",
"Assign permissions to this object" => "Assigna permisos a aquest objecte",
// "Delete category permissions" => "Delete category permissions",
// "Delete object permissions" => "Delete object permissions",
// "Reset Perms" => "Reset Perms",
// "This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions" => "This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions",
// "This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions" => "This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions",
// "Permissions Clipboard" => "Permissions Clipboard",
// "Copy the permissions set here" => "Copy the permissions set here",
"Paste" => "Enganxa",
// "Paste copied permissions from " => "Paste copied permissions from ",
// "Assign or remove permissions on <em>all</em> child categories" => "Assign or remove permissions on <em>all</em> child categories",
// "Are you sure you want to affect all child categories?\\nThere is no undo" => "Are you sure you want to affect all child categories?\\nThere is no undo",
// "Assign or remove permissions on all pages of the sub-structure" => "Assign or remove permissions on all pages of the sub-structure",
// "Are you sure you want to affect all pages in this sub-structure?\\nThere is no undo" => "Are you sure you want to affect all pages in this sub-structure?\\nThere is no undo",
// "You must select at least one feature" => "You must select at least one feature",
// "View Differences" => "View Differences",
// "Permissions added" => "Permissions added",
// "Permissions removed" => "Permissions removed",
// "Select groups" => "Select groups",
// "Some of your groups have been automatically hidden.<br /> Select the groups below to assign permissions for" => "Some of your groups have been automatically hidden.<br /> Select the groups below to assign permissions for",
// "These groups are not the groups that have permissions on the object. It is only the groups you can see in the columns of the first tab" => "These groups are not the groups that have permissions on the object. It is only the groups you can see in the columns of the first tab",
// "Select only groups that have a perm with the object" => "Select only groups that have a perm with the object",
// "Select features" => "Select features",
// "Some of your features have been automatically hidden.<br /> Select the features below to assign permissions for" => "Some of your features have been automatically hidden.<br /> Select the features below to assign permissions for",
// "Show permissions for disabled features" => "Show permissions for disabled features",
// "Feature name" => "Feature name",
// "Quick Permissions" => "Quick Permissions",
// "Assign Quick-Permissions to this object" => "Assign Quick-Permissions to this object",
// "A couple of userdefined permissions are currently assigned (See tab Assign Permissions)" => "A couple of userdefined permissions are currently assigned (See tab Assign Permissions)",
// "<em>Quick permissions</em> should be considered as an experimental feature" => "<em>Quick permissions</em> should be considered as an experimental feature",
// "Although permissions will be set as expected using this form, it doesn't necessarily show the current permissions reliably" => "Although permissions will be set as expected using this form, it doesn't necessarily show the current permissions reliably",
// "There is also no undo - <strong>Use with care!</strong>" => "There is also no undo - <strong>Use with care!</strong>",
"Your OpenID identity is valid" => "La teva identitat OpenID és vàlida",
"Your identity gives you access to multiple user accounts." => "La teva identitat et dona accés a múltiples comptes d'usuari.",
"Select account" => "Selecciona compte",
"Orphan Pages" => "Pàgines òrfenes",
"Browser not supported" => "Explorador no suportat",
// "Contributions to" => "Contributions to",
// "current version" => "current version",
"version" => "versió",
// "Words" => "Words",
// "Whitespaces" => "Whitespaces",
// "Characters" => "Characters",
// "Printable characters" => "Printable characters",
// "Page changes" => "Page changes",
// "Original wiki text" => "Original wiki text",
// "Parsed Text (HTML)" => "Parsed Text (HTML)",
// "Output text only (No HTML tags)" => "Output text only (No HTML tags)",
// "Show statistics" => "Show statistics",
// "Visualize page changes" => "Visualize page changes",
// "Show popups" => "Show popups",
// "Escape HTML / Wiki syntax in page changes" => "Escape HTML / Wiki syntax in page changes",
// "Show contributions" => "Show contributions",
// "Show Edit Sessions" => "Show Edit Sessions",
// "Show All Versions" => "Show All Versions",
"Preview of version" => "Previsualitzacióde la versió",
"(current)" => "(actual)",
"Rollback to this version" => "Restableix aquesta versió",
// "Content Approval" => "Content Approval",
// "This revision is currently marked as approved" => "This revision is currently marked as approved",
// "Remove Approval" => "Remove Approval",
// "This revision has not been approved" => "This revision has not been approved",
// "Approve Revision" => "Approve Revision",
"Source of version" => "Codi font de la versió",
"s=source" => "s=codi font",
"b=rollback" => "b=restableix",
// "by %0" => "by %0",
// "from %0" => "from %0",
// "approved" => "approved",
"Updated from" => "Actualitza des de",
"Used to update" => "Emprat per actualitzar",
// "Wiki Wysiwyg" => "Wiki Wysiwyg",
"Update Translation" => "Actualitza traducció",
"Hide translation history" => "Amaga l'historial de la traducció",
"Show translation history" => "Mostra l'historial de la traducció",
// "Enable pagination" => "Enable pagination",
// "per page" => "per page",
// "Payment Date" => "Payment Date",
// "Payment Type" => "Payment Type",
// "Payer" => "Payer",
// "View payment info" => "View payment info",
// "Assign permissions for payments" => "Assign permissions for payments",
// "Cancel this payment request" => "Cancel this payment request",
// "Request Date" => "Request Date",
// "View payment request" => "View payment request",
// "Paypal" => "Paypal",
// "Transaction ID" => "Transaction ID",
// "Payment made by <em>%0, %1</em> (%2)" => "Payment made by <em>%0, %1</em> (%2)",
// "{\$wp_member_title}" => "{\$wp_member_title}",
// "{\$payment_info.state|escape}" => "{\$payment_info.state|escape}",
// "Paid amount" => "Paid amount",
// "Initial amount" => "Initial amount",
// "Amount remaining" => "Amount remaining",
// "Payment request was sent on %0 and is due by %1" => "Payment request was sent on %0 and is due by %1",
// "Pay with Credit Card through Paypal" => "Pay with Credit Card through Paypal",
// "Pay with Paypal" => "Pay with Paypal",
// "Refresh page" => "Refresh page",
// "Payment info" => "Payment info",
// "Trade with Cclite" => "Trade with Cclite",
// "Payment problem" => "Payment problem",
// "Pay with Tiki User Credits" => "Pay with Tiki User Credits",
// "Credit type" => "Credit type",
// "Credits left" => "Credits left",
// "Amount to pay" => "Amount to pay",
// "Pay using" => "Pay using",
// "Manual payment entry" => "Manual payment entry",
// "Enter payment" => "Enter payment",
// "using" => "using",
// "Payment information" => "Payment information",
// "Outstanding" => "Outstanding",
// "Overdue" => "Overdue",
// "Past" => "Past",
// "Request" => "Request",
// "Detail" => "Detail",
// "Payable within" => "Payable within",
"Avatar:" => "Avatar:",
"Pick your avatar" => "Escull el teu avatar",
"Your current avatar" => "El teu avatar actual",
// "Full size" => "Full size",
"no avatar" => "cap avatar",
"Pick avatar from the library" => "Trieu avatar de la biblioteca",
"Pick user Avatar" => "Escull l'Avatar de l'usuari",
"Hide all" => "Amaga-ho tot",
"icons" => "icones",
"Show all" => "Mostra-ho tot",
"Avatar Image" => "Imatge Avatar",
"random" => "aleatori",
"Upload your own avatar" => "Puja el teu propi avatar",
"File (only .gif, .jpg and .png images approximately 45px × 45px)" => "Arxiu (només imatges .gif, .jpg i .png d'aproximadament 45px × 45px)",
// "File (only .gif, .jpg and .png images)" => "File (only .gif, .jpg and .png images)",
"Plugin execution was denied" => "S'ha denegat l'execució del connector",
"Plugin execution pending approval" => "Execució del connector esperant aprovació",
"After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected" => "Després de la validació dels arguments per un editor, es va denegar l'execució del connector. Aquesta ús del connector serà eventualment eliminat o corregit",
"This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible" => "Aquest ús del connector ha estat afegit o midificat recentment. Fins que un edior del lloc en validi els paràmetres, la seva execució no és possible",
"You are allowed to" => "T'està permés de",
"View arguments" => "Veure els arguments",
"Execute the plugin in preview mode (may be dangerous)" => "Executar el connector en mode de previsualització (pot ser perillós)",
"Approve the plugin for public execution" => "Aprovar l'ús del connector per a execució pública",
"View Details" => "Mostra detalls",
"This plugin does not contain any arguments" => "Aquest connector no conté arguments",
"Body" => "Cos",
"This plugin's body is empty" => "El cos del connector és buit",
"Insert" => "Insertar",
// "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups" => "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups",
// "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins" => "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins",
// "This page lists the plugins that require validation, the first time they are encountered" => "This page lists the plugins that require validation, the first time they are encountered",
// "Each plugin contains a unique <em>signature</em> that is preserved" => "Each plugin contains a unique <em>signature</em> that is preserved",
// "When you upgrade from an old version, you may need to reparse all the pages" => "When you upgrade from an old version, you may need to reparse all the pages",
// "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list" => "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list",
// "The plugin will automatically be added if it is encountered" => "The plugin will automatically be added if it is encountered",
// "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin" => "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin",
// "For security, you should review each plugin to ensure it is safe to approve" => "For security, you should review each plugin to ensure it is safe to approve",
// "Added By" => "Added By",
// "Signature" => "Signature",
// "Wiki page: <a href=\"%0#%2\" title=\"{tr}View this page" => "Wiki page: <a href=\"%0#%2\" title=\"{tr}View this page",
// "<a href=\"%0#%2\" title=\"{tr}View this page" => "<a href=\"%0#%2\" title=\"{tr}View this page",
// "Approve all pending plugins" => "Approve all pending plugins",
// "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins" => "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins",
// "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe" => "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe",
// "No plugins pending approval" => "No plugins pending approval",
// "{\$channels[ix].title|escape}" => "{\$channels[ix].title|escape}",
"View Results" => "Visualitza resultats",
"Vote poll" => "Participa en la consulta",
// "This poll is closed" => "This poll is closed",
"Other Polls" => "Altres Consultes",
"Poll Results" => "Resultats de la Consulta",
"Top Voted Polls" => "Consultes amb més participació",
"Edit Poll" => "Edita el Sondeig",
"Find the poll" => "Troba el sondeig",
// "{\$what}" => "{\$what}",
"Number of top voted polls to show" => "Nombre a mostrar de consultes amb més participació",
"Vote range displayed" => "Rang de consulta mostrat",
// "All votes with no span consideration" => "All votes with no span consideration",
// "All votes with span consideration" => "All votes with span consideration",
// "All votes" => "All votes",
"List Votes" => "Llista Vots",
"votes" => "vots",
// "Popup preview" => "Popup preview",
// "Close preview" => "Close preview",
"Topic image" => "Imatge del tòpic",
"The original document is available at" => "El document original està disponible en",
"Print multiple pages" => "Imprimir múltiples pàgines",
"Selected Structures" => "Estructures seleccionades",
"Add Structure" => "Afegeix estructura",
"No structures" => "Cap estructura",
// "Available Pages" => "Available Pages",
"No pages" => "Cap pàgina",
// "All pages selected" => "All pages selected",
"Add Page" => "Afegeix pàgina",
"Remove Page" => "Eliminar pàgina",
"Selected Pages" => "Pàgines Seleccionades",
"No pages selected" => "Cap pàgina seleccionada",
"Add Pages from Structures" => "Afegeix pàgines des d'Estructures",
"Edit quiz" => "Edita el qüestionari",
"Current Version" => "Versió actual",
"General Options" => "Opcions generals",
"Publication Date" => "Data de publicació",
"at " => "a ",
"Use " => "Empra ",
"randomly selected questions." => "preguntes seleccionades a l'atzar.",
"Test-time Options" => "Opcions de test amb temps limitat",
"Shuffle questions" => "Qüestions barrejades",
"Shuffle answers" => "Respostes barrejades",
"Limit questions displayed per page to " => "Limita les preguntes mostrades per pàgina a ",
"  question(s)." => "  pregunta/es.",
"Impose a time limit of " => "Imposa un temps limit de ",
"Allow students to store partial results and return to quiz." => "Permet als estudiants guardar els resultats parcials i tornar al qüestionari.",
"Allow students to retake this quiz " => "Permet als estudiants repetir aquest qüestionari ",
"Grading and Feedback" => "Avaluació i retroalimentació",
"Grading method " => "Mètode d'avaluació ",
"Show students their score " => "Mostra als estudiants la seva puntuació ",
"Show students the correct answers " => "Mostra als estudiants les respostes correctes",
"Publish statistics " => "Publica les estadístiques ",
"Extra Options" => "Opcions extres",
"Solicit additional questions from students" => "Solicita preguntes addicionals dels estudiants",
"Link quiz to forum named: " => "Enllaça la pregunta al fòrum anomenat: ",
"Prologue:" => "Pròleg:",
"Epilogue:" => "Epíleg:",
"Quiz result stats" => "Estadístiques dels resultats dels Tests",
"Time" => "Temps",
"User answers" => "Respostes de l'usuari/a",
"Stats for quizzes" => "Estadistiques de qüestionaris",
"taken" => "pres/os",
"Av score" => "Resultat mitjà",
"Av time" => "Temps mitjà",
"Stats for quiz" => "Estadistiques per test",
"Clear Stats" => "Esborrar estadístiques",
"time taken" => "temps emprat",
"P/F" => "P/F",
"Passed" => "Aprovat",
"Stats for this quiz Questions " => "Estadístiques per a les preguntes d'aquest test",
"Average" => "Mitjana",
"Top 10" => "10 per dalt",
"Top 20" => "20 per dalt",
"Top 50" => "50 per dalt",
"Top 100" => "100 per dalt",
// "Rank" => "Rank",
// "Not Published" => "Not Published",
// "This Article is currently not published and only visible by Editors" => "This Article is currently not published and only visible by Editors",
"Received articles" => "Articles rebuts",
"Edit received article" => "Edita article rebut",
"Use Image" => "Empra imatge",
"Image x size" => "Mida x de la imatge",
"Image y size" => "Mida y de la imatge",
"Image name" => "Nom de la imatge",
"Accept Article" => "Accepta Article",
"Received Pages" => "Pàgines Rebudes",
// "{\$error.error}" => "{\$error.error}",
"Edit Received Page" => "Edita la Pàgina Rebuda",
"The highlight pages already exist." => "Les pàgines ressaltades ja existeixen.",
"Please, change the name if you want the page to be uploaded." => "Si us plau, canvia el nom si vols que es pugi la pàgina.",
"Received Structures" => "Estructures rebudes",
// "Prefix the checked" => "Prefix the checked",
// "Postfix the checked" => "Postfix the checked",
"Referer stats" => "Estadístiques de referenciadors",
"Last" => "Darrer",
"Register as a new user" => "Registrar-se com a usuari nou",
"Tiki site registered" => "Llocs Tiki registrats",
"The following site was added and validation by admin may be needed before appearing on the lists" => "El lloc web següent s'hi ha afegit i potser necessitarà ser validat per l'administrador abans d'aparèixer a les llistes",
"You don't have permission to use this feature." => "No tens permís per emprar aquesta característica. Prova (re)connectar-te primer, enregistrant-te abans si no ho has fet encara",
"Please register." => "Si us plau, registreu-vos.",
// "Register this site at Tiki.org" => "Register this site at Tiki.org",
"Read this first!" => "Llegeix això abans de començar!",
// "On this page you can make your tiki site known to Tiki.org. It will get shown there in a list of known tiki sites" => "On this page you can make your tiki site known to Tiki.org. It will get shown there in a list of known tiki sites",
"Registering is voluntary." => "Registrar-se és voluntari.",
"Registering does not give you any benefits except one more link to your site." => "Registrar-se no et dona cap més avantatge que un enllaç més cap al teu lloc.",
"You don't get any emails, we don't sell the data about your site." => "No aconseguiràs adreces d'e-correus, no venem les dades dels llocs.",
"Registering is just for us to get an overview of Tiki's usage." => "El registre només és per fer-nos una idea de l'ús que es fa de Tiki.",
"If your site is private or inside your intranet, you should not register!" => "Si el teu lloc és privat o està en una (intranet/xarxa interna), no et registris!",
"tiki.org" => "tiki.org",
"Information about your site" => "Informació del teu lloc",
"Enter your username or email" => "Introdueix el teu nom d'usuari o correu-e",
"Enter your email" => "Introdueix el teu correu-e",
"Send me my Password" => "Envia'm la meva contrasenya",
"Request Password Reset" => "Demana un canvi de contrasenya",
"Remove page" => "Eliminar pàgina",
"Last Version" => "última versió",
"Back to page" => "Retorna a la pàgina",
"You are about to remove the page" => "Esteu a punt d'eliminar la pàgina",
"permanently" => "permanentment",
"Remove all versions of this page" => "Elimina totes les versions d'aquesta pàgina",
"Rename page" => "Renombrar la pàgina",
"Rollback page" => "Restableix versió",
"to version" => "a la versió",
// "This feature currently searches and replaces within wiki pages only" => "This feature currently searches and replaces within wiki pages only",
// "Max number of pages at a time" => "Max number of pages at a time",
// "Number of surrounding chars to preview" => "Number of surrounding chars to preview",
// "Replace selected" => "Replace selected",
"Searched" => "Cercat",
"Search in" => "Buscar a",
"Date Search" => "Cerca per dates",
"All dates" => "Totes les dades",
// "{\$languages[ix].name}" => "{\$languages[ix].name}",
"Calendar Items" => "Ítems del Calendari",
"{\$where|escape}" => "{\$where|escape}",
// "{\$where_label|escape}" => "{\$where_label|escape}",
// "{\$results[search].type|escape}" => "{\$results[search].type|escape}",
"Simple search" => "Cerca simple",
// "You can also send newsletters using an external client" => "You can also send newsletters using an external client",
"This newsletter will be sent to {\$subscribers} email addresses." => "Aquest butlletí serà enviat a {\$subscribers} adreces de correu-e.",
// "Reply to" => "Reply to",
"Recipients" => "Destinataris",
"Validated" => "Validats/des",
"Is user" => "És usuari/a",
"Sending Newsletter" => "Enviament del Butlletí",
"Prepare a newsletter to be sent" => "Prepara un butlletí per ser enviat",
"Apply content template" => "Aplica la plantilla de contingut",
"Data HTML" => "Dades HTML",
"Data Txt" => "Dades Txt",
"Article Clip (read only)" => "Retall d'article (només de lectura)",
"Clip Now" => "Inclou retalls ara",
"Clip Articles" => "Inclou retalls d'articles",
"To include the article clipping into your newsletter, cut and paste it into the contents" => "Per a incloure retalls d'articles al teu butlletí, talla i enganxa-ho en els continguts del butlletí",
"If autoclipping is enabled, you can also enter \"~~~articleclip~~~\" which will be replaced with the latest\tclip when sending" => "Si s'ha activat l'autoretallat, també pots introduir \"~~~articleclip~~~\" que serà reemplaçat amb el darrer \tretall quan s'enviï",
// "Be careful not to paste articles that must not be seen by the recipients" => "Be careful not to paste articles that must not be seen by the recipients",
"Attached Files" => "Arxius adjunts",
"remove" => "eliminar",
"octets" => "octets",
"To add a file, click here" => "Per a afegir un arxiu, clica aquí",
"Reply To Email" => "Respon al Correu-e",
"if not" => "si no",
// "Sender email not set" => "Sender email not set",
"Save as Draft" => "Desa-ho com a esborrany",
"Save your changes" => "Desa els canvis",
"Save any changes and send to all subscribers" => "Desa qualsevol canvi i envia a totes les persones subscriptores",
// "Drafts (%0)" => "Drafts (%0)",
// "Sent Editions (%0)" => "Sent Editions (%0)",
"Send objects" => "Envia objectes",
"Transmission results" => "Resultats de la transmissió",
"Send Wiki Pages" => "Envia pàgines del Wiki",
"Send a structure" => "Envia una estructura",
"Send Articles" => "Envia articles",
"Add Article" => "Afegeix article",
"Send objects to this site" => "Envia objectes a aquest lloc",
"Ex: http://tiki.org or localhost" => "Ex: http://tiki.org o localhost",
// "Use /commxmlrpc.php if your Tiki site is installed at the root, otherwise adapt /tiki to your need" => "Use /commxmlrpc.php if your Tiki site is installed at the root, otherwise adapt /tiki to your need",
"Report this page" => "Informa d'aquesta pàgina",
"Page shared" => "Pàgina compartida",
"The link was sent via e-Mail to the following addresses" => "S'ha enviat l'enllaç via correu-e a les adreces següens",
"The link was sent via Twitter" => "S'ha enviat l'enllaç via Twitter",
"The link was posted on your Facebook wall" => "S'ha publicat l'enllaç al teu mur de Facebook",
"The link was sent as message to" => "S'ha enviat l'enllaç com a missatge a",
"The link was published in a" => "S'ha publicat l'enllaç en un/a",
"Short link" => "Enllaç curt",
"Have a look at this page" => "Fes una ullada a aquesta pàgina",
"Your message" => "El teu missatge",
"I found an interesting page that I thought you would like" => "He trobat una pàgina interessant que he pensat que et podria agradar",
"e-Mail" => "correu-e",
"Send via e-Mail" => "Envia per correu-e",
"Recipient(s)" => "Destinatari(s)",
// "Separate multiple email addresses with a comma and a space" => "Separate multiple email addresses with a comma and a space",
"Separate multiple email addresses with a comma" => "Separa múltiples adreces de correu-e amb comes",
"Your name" => "El teu nom",
"Tweet via Twitter" => "Tweet via Twitter",
"Authorize with Twitter first" => "Autoritza primer amb Twitter",
"Have a look at " => "Fes una ullada a ",
"Put on my Facebook wall" => "Posa en el meu mur de Facebook",
"Authorize with Facebook first" => "Autoritza primer amb Facebook",
"Link text" => "Text de l'enllaç",
"This will be the title for the URL" => "Aquesta serà el títol per a la URL",
"Like this post" => "m'agrada aquesta publicació",
// "Subscribe notification" => "Subscribe notification",
// "How much time recipients can access to this page" => "How much time recipients can access to this page",
"time" => "temps",
"You do not have the permission to send messages or you did not allow other users to send you messages" => "No tens permís per enviar missatges o no permets a altres usuaris que t'enviïn missatges",
// "Separate multiple recipients with a semicolon" => "Separate multiple recipients with a semicolon",
"Post on forum" => "Publica a un fòrum",
"There is no forum where you can post a message" => "No hi ha cap fòrum on puguis publicar un missatge",
// "password-protected" => "password-protected",
"Share access rights" => "Comparteix els permisos d'accés",
// "Return to previous page" => "Return to previous page",
"Create a sheet" => "Crea un full",
// "Configure this sheet" => "Configure this sheet",
"There are individual permissions set for this sheet" => "Hi ha permisos individuals fixats per a aquest full",
"Class Name" => "Nom de Classe",
"Header Rows" => "Files de Capçalera",
"Footer Rows" => "Files de Peu de pàgina",
"Wiki Parse Values" => "Interpreta els valors i sintaxi Wiki",
"Parent Spreadsheet" => "Full de càlcul Pare",
"Makes this sheet a \"child\" sheet of a multi-sheet set" => "Converteix aquest full en un \"fill\" d'un multi-full de càlcul(llibre de càlcul)",
"You can access the sheet using the following URL" => "Pots accedir a aquest full emprant la següent URL",
// "Banned Words" => "Banned Words",
"Change shoutbox general settings" => "canvia les opcions generals del diàleg",
"auto-link urls" => "auto-enllaç urls",
"Post or edit a message" => "Editar o enviar missatge",
"Location : " => "Lloc : ",
"Content may be out of date" => "Aquest contingut pot estar desfasat",
"An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages:" => "S'ha enviat una petició urgent de traducció. Fins que la pàgina no estigui actualitzada, pots veure una versió corregida a les pàgines següents:",
// "page: %0/%1" => "page: %0/%1",
// "This text was automatically translated by Google Translate from the following page: " => "This text was automatically translated by Google Translate from the following page: ",
"Last edited by" => "Editat per darrera vegada per",
"based on work by" => "basat en treball fet per",
"Contributors to this page" => "Contribuïdors a aquesta pàgina",
// "First Slide" => "First Slide",
// "Previous Slide" => "Previous Slide",
// "Previous Point" => "Previous Point",
// "Next Point" => "Next Point",
// "Next Slide" => "Next Slide",
// "Last Slide" => "Last Slide",
// "Jump To Slide" => "Jump To Slide",
// "Play" => "Play",
// "Pause" => "Pause",
// "Toggle Loop" => "Toggle Loop",
// "Export to PDF" => "Export to PDF",
// "Exit" => "Exit",
// "Change Theme" => "Change Theme",
// "To use Twitter integration, the site admin must register this site as an application at <a href=\"http://twitter.com/oauth_clients/\" target=\"_blank\">http://twitter.com/oauth_clients/</a> and allow write access for the application" => "To use Twitter integration, the site admin must register this site as an application at <a href=\"http://twitter.com/oauth_clients/\" target=\"_blank\">http://twitter.com/oauth_clients/</a> and allow write access for the application",
// "Twitter authorisation" => "Twitter authorisation",
// "to manage your authorisations at Twitter" => "to manage your authorisations at Twitter",
// "this site with twitter.com to use Twitter integration of this site" => "this site with twitter.com to use Twitter integration of this site",
// "To use Facebook integration, the site admin must register this site as an application at <a href=\"http://developers.facebook.com/setup/\" target=\"_blank\">http://developers.facebook.com/setup/</a> first" => "To use Facebook integration, the site admin must register this site as an application at <a href=\"http://developers.facebook.com/setup/\" target=\"_blank\">http://developers.facebook.com/setup/</a> first",
// "Facebook authorisation" => "Facebook authorisation",
// "to manage your authorisations at Facebook" => "to manage your authorisations at Facebook",
// "this site with facebook.com to use Facebook integration of this site" => "this site with facebook.com to use Facebook integration of this site",
// "The site admin has set up a global account which will be used for this site" => "The site admin has set up a global account which will be used for this site",
"Save changes" => "Desa els canvis",
// "You will be redirected to the home page shortly" => "You will be redirected to the home page shortly",
// "to go to the home page immediately" => "to go to the home page immediately",
// "Please provide local account information" => "Please provide local account information",
// "Do you already have a local account for this site? Login to link to it using the following form instead" => "Do you already have a local account for this site? Login to link to it using the following form instead",
// "Link to Existing Account" => "Link to Existing Account",
// "You will not see the latest queries" => "You will not see the latest queries",
"Params" => "Params",
"Most viewed objects" => "Objectes més visualitzats",
"Most viewed objects in the last 7 days" => "Objectes més visualitzats en els darrers 7 dies",
"Site Stats" => "Estadístiques del lloc",
// "Date of first pageview" => "Date of first pageview",
// "Days since first pageview" => "Days since first pageview",
"Total pageviews" => "Visualitzacions de pàgines en total",
"Average pageviews per day" => "Mitjana de visualització de pàgines per dia",
"Wiki Stats" => "Estadístiques del Wiki",
"Size of Wiki Pages" => "Mida de les pàgines del Wiki",
"Average page length" => "Mida mitjana de les pàgines",
"Average versions per page" => "Mitjana de versions per pàgina",
"Visits to wiki pages" => "Visites a pàgines del wiki",
"Average links per page" => "Quantitat mitjana d'enllaços per pàgina",
"Image galleries Stats" => "Estadístiques de galeries d'imatges",
"Average images per gallery" => "Mitjana d'imatges per galeria",
"Total size of images" => "Mida total de les imatges",
"Average image size" => "Mida mitjana d'imatge",
"Visits to image galleries" => "Visites a galeries d'imatges",
"File galleries Stats" => "Estadístiques de galeries d'arxius",
"Average files per gallery" => "Mitjana d'arxius per galeria",
"Total size of files" => "Mida total dels arxius",
"Average file size" => "Mida mitjana d'arxiu",
"Visits to file galleries" => "Visites a les galeries d'arxius",
// "Articles Stats" => "Articles Stats",
"Total reads" => "Quantitat de notes llegides",
"Average reads per article" => "Mitjana de lectures per article",
"Total articles size" => "Mida total dels articles",
"Average article size" => "Mida mitajana d'un article",
"Forum Stats" => "Estadístiques de fòrums",
"Total topics" => "Quantitat de temes",
"Average topics per forums" => "Quantitat mitjana de temes per fòrum",
"Total replies" => "Respostes totals",
// "Average number of replies per topic" => "Average number of replies per topic",
"Visits to forums" => "Visites als fòrums",
"Blog Stats" => "Estadístiques dels Blocs web",
"Weblogs" => "Blocs Web",
"Total posts" => "Publicacions totals",
"Average posts per weblog" => "Mitjana enviaments per bloc web",
"Total size of blog posts" => "Mida total de les publicacions al bloc",
"Average posts size" => "Mida mitjana d'una publicació",
"Visits to weblogs" => "Visites a les bitàcoles web",
"Poll Stats" => "Estadístiques de consultes",
"Total votes" => "Vots totals",
"Average votes per poll" => "Mitjana de vots per consulta",
// "FAQ Stats" => "FAQ Stats",
"Total questions" => "Preguntes en total",
"Average questions per FAQ" => "Mitjana de preguntes per PUF",
"User Stats" => "Estadístiques d'usuaris",
"Average bookmarks per user" => "Mitjana d'enllaços d'interès per usuari",
"Average questions per quiz" => "Mitjana de preguntes per Test",
"Quizzes taken" => "Qüestionaris presos",
"Average quiz score" => "Puntuació mitjana de tests",
"Average time per quiz" => "Temps mitjà per test",
// "Most viewed objects in period" => "Most viewed objects in period",
// "{\$best_objects_stats_between[i]->type}" => "{\$best_objects_stats_between[i]->type}",
// "{\$best_objects_stats_lastweek[i]->type}" => "{\$best_objects_stats_lastweek[i]->type}",
"Usage chart" => "Gràfica d'ús",
"Usage chart image" => "Emprar imatge de gràfic",
"Daily Usage" => "Ús diari",
"Stats for surveys" => "Estadístiques per enquestes",
"Last taken" => "Darrer pres",
"Stats for survey" => "Estadístiques per enquesta",
// "Tiki Logs" => "Tiki Logs",
// "Export through Action Log" => "Export through Action Log",
"Clean logs older than" => "Esborra els registres més antics de",
"Time Left" => "Temps Restant",
"Send Answers" => "Envia respostes",
"Thank you for your submission" => "Gràcies pel teu enviament",
"Send a link to a friend" => "Envia un enllaç a un amic/ga",
"Your email was sent" => "El teu correu-e ha estat enviat",
"The link was sent to the following addresses:" => "S'ha enviat l'enllaç a les següents adreces:",
// "Friend's email" => "Friend's email",
// "TikiTests Edit" => "TikiTests Edit",
// "Summary mode" => "Summary mode",
// "Show Page Differences" => "Show Page Differences",
// "Show Tidy Errors and Warnings" => "Show Tidy Errors and Warnings",
// "Show POST Data" => "Show POST Data",
// "Use Current Session/Log out" => "Use Current Session/Log out",
// "Recorded Links" => "Recorded Links",
// "Element to compare (Xpath expression)" => "Element to compare (Xpath expression)",
// "Test Xpath Expression" => "Test Xpath Expression",
// "Post Variables" => "Post Variables",
// "Tidy Results" => "Tidy Results",
// "Delete this link" => "Delete this link",
// "TikiTests List" => "TikiTests List",
"Config" => "Configuració",
// "Replay" => "Replay",
// "Tidy extension not present" => "Tidy extension not present",
// "PECL HTTP extension present" => "PECL HTTP extension present",
// "cURL extension present" => "cURL extension present",
// "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible" => "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible",
// "List TikiTests" => "List TikiTests",
// "Create a TikiTest" => "Create a TikiTest",
// "Replay the TikiTest" => "Replay the TikiTest",
// "Edit the TikiTest" => "Edit the TikiTest",
// "TikiTests Record Configuration" => "TikiTests Record Configuration",
// "Start Recording Test" => "Start Recording Test",
// "TikiTests Replay Configuration" => "TikiTests Replay Configuration",
"Failure" => "Fallada",
// "Reference" => "Reference",
// "The pages are different" => "The pages are different",
// "The pages are identical" => "The pages are identical",
// "Recording to pause press the pause button" => "Recording to pause press the pause button",
// "Pause the recording" => "Pause the recording",
// "Paused to resume press the play button" => "Paused to resume press the play button",
// "Resume the recording" => "Resume the recording",
// "Stop the recording" => "Stop the recording",
// "Theme Control Center: Categories" => "Theme Control Center: Categories",
"Theme is selected as follows" => "Theme se selecciona de la manera següent",
"If a theme is assigned to the individual object that theme is used." => "Si assigneu un theme a un objecte individual, aquest theme sera l'utilitzat.",
"If not then if a theme is assigned to the object's category that theme is used" => "Si no és així, si assigneu un theme a una categoria d'objecte, aquest tema serà l'utilitzat",
"If not then a theme for the section is used" => "Si no és així, s'utilitzarà un theme per a la secció",
"If none of the above was selected the user theme is used" => "Si no trieu cap de les opcions anteriors, s'utilitzarà el theme de l'usuari",
"Finally if the user didn't select a theme the default theme is used" => "Finalment, si l'usuari no ha seleccionat cap theme, s'utilitzarà el theme per defecte",
"Control by Objects" => "Control per objectes",
"Control by Sections" => "Control per Seccions",
"Assign themes to categories" => "Assigna themes a categories",
"Assigned categories" => "Categories assignades",
"Theme Control Center: Objects" => "Centre de control de temes: Objectes",
"Control by Categories" => "Control per Categories",
"Assign themes to objects" => "Assignar aspectes als objectes",
"Assigned objects" => "Objectes Assignats",
// "Theme Control Center: Sections" => "Theme Control Center: Sections",
"Assign themes to sections" => "Assignar aspectes a les seccions",
"Assigned sections" => "Seccions Assignades",
"Apply the following profile for enhancements: " => "Aplica el següent perfil de configuració per a millores: ",
"Time Tracker" => "Formulari-bd de Temps",
"Local Cache (Not Committed)" => "En memòria cau local (No Enviades)",
"Saved (Committed)" => "Desades (Enviades)",
"New task" => "Nova",
"Toggle completed" => "Intercanvia les completades",
"Toggle archived" => "Intercanvia les arxivades",
"Task name" => "Nom de la tasca",
"Estimate (in min.)" => "Estimació (en min.)",
"Estimate" => "Estimació",
"Task is completed" => "Tasca completada",
"Task is archived" => "Tasca arxivada",
"Created at" => "Creat/da el",
"Are you sure you want to delete all tasks" => "Segur que vols esborrar totes les tasques",
"Commit Time Sheet Items" => "Envia els ítems del full de temps",
"View All" => "Mostra-les totes",
"View My Items" => "Visualitza els meus ítems",
"Summary" => "Resum",
"Time Spent" => "Temps invertit",
"Done By" => "Fet per",
"Add Tracker" => "Afegeix formulari-bd",
"Add Tracker To Tracker Report" => "Afegeix formulari-bd a l'Informe de Formularis-bd",
// "View Tracker Report" => "View Tracker Report",
// "Pick tracker to join" => "Pick tracker to join",
// "Pick fields to join on" => "Pick fields to join on",
// "Join inner" => "Join inner",
// "Join outer" => "Join outer",
// "Tracker - Open" => "Tracker - Open",
// "Tracker - Pending" => "Tracker - Pending",
// "Tracker - Closed" => "Tracker - Closed",
// "Tracker Item History" => "Tracker Item History",
// "View Tracker Item" => "View Tracker Item",
// "Not logging" => "Not logging",
// "Tracker changes are not being logged: Go to <a href=\"tiki-admin_actionlog.php?action_log_type=trackeritem&cookietab=2\" >Action log admin</a> to enable" => "Tracker changes are not being logged: Go to <a href=\"tiki-admin_actionlog.php?action_log_type=trackeritem&cookietab=2\" >Action log admin</a> to enable",
"Old" => "Vell/a",
"Edit File:" => "Edita l'Arxiu:",
"Advanced mode" => "Mode avançat",
"Simple mode" => "Mode senzill",
"Retry" => "Intenta de nou",
"The following file was successfully uploaded" => "El següent arxiu s'ha pujat correctament",
"The following files have been successfully uploaded" => "El següents arxius s'han pujat correctament",
"You can download this file using" => "Podeu baixar l'arxiu emprant",
"You can link to the file from a Wiki page using" => "Pots incloure l'arxiu en una pàgina Wiki emprant",
"You can display an image in a Wiki page using" => "Pots incloure l'arxiu en una pàgina HTML emprant",
// "Or using as a thumbnail with ShadowBox" => "Or using as a thumbnail with ShadowBox",
// "You can link to the file from an HTML page using" => "You can link to the file from an HTML page using",
"You locked the file" => "Has bloquejat l'arxiu",
"The file is locked by {\$fileInfo.lockedby}" => "L'arxiu està bloquejat per {\$fileInfo.lockedby}",
"File title" => "Títol de l'arxiu",
"required field for podcasts" => "els podcasts requereixen aquest camp",
"File description" => "Descripció de l'arxiu",
// "We're sorry" => "We're sorry",
// "Upload interface could not load.  You must have JavaScript enabled to enjoy Upload interface" => "Upload interface could not load.  You must have JavaScript enabled to enjoy Upload interface",
// "Upload interface is loading" => "Upload interface is loading",
"Please wait a moment.." => "Si us plau, espera un moment..",
// "Upload interface is taking a long time to load or the load has failed" => "Upload interface is taking a long time to load or the load has failed",
// "Please make sure that the Flash Plugin is enabled and that a working version of the Adobe Flash Player is installed" => "Please make sure that the Flash Plugin is enabled and that a working version of the Adobe Flash Player is installed",
// "We are sorry: Upload interface could not load.  You may need to install or upgrade Flash Player" => "We are sorry: Upload interface could not load.  You may need to install or upgrade Flash Player",
// "Visit the Adobe Website to get the Flash Player" => "Visit the Adobe Website to get the Flash Player",
"Unzip zip files" => "Descomprimeix els arxius zip",
"File can be deleted after" => "Es pot esborrar l'arxiu després",
"Root" => "Arrel",
"Creator of file, if different from the 'Uploaded by' user" => "Creador de l'arxiu, si és diferent de l'usuari que ha pujat l'arxiu",
// "Maximum number of downloads" => "Maximum number of downloads",
// "-1 for no limit" => "-1 for no limit",
"Upload File(s)" => "Puja Arxiu(s)",
"Cancel Upload" => "Cancel·la la Pujada",
"Add Another File" => "Afegeix un altre arxiu",
"Maximum file size is around" => "La mida màxima de l'arxiu és al voltant de",
"Uploading file.." => "Pujant l'arxiu..",
"No File to Upload.." => "No hi ha cap arxiu per pujar..",
" Syntax tips" => " Pistes de sintaxi",
"Link to file from a Wiki page" => "Enllaç a l'arxiu des d'una pàgina Wiki",
"In addition, for image files" => "Addicionalment, per a arxius d'imatge",
"To display full size in a Wiki page" => "Per a mostrar-ho a mida completa en pàgines Wiki",
"Display thumbnail that enlarges" => "Mostra un contacte que s'engrandeix en fer clic a sobre",
"Upload successful!" => "Pujada amb èxit!",
"The following image was successfully uploaded" => "La següent imatge s'ha pujat correctament",
"Image ID thumb" => "Diapositiva de la Imatge ID",
"You can view this image in your browser using" => "Podeu visualitzar aquesta imatge en el vostre cercador emprant",
"You can include the image in an Wiki page using" => "Pots incloure la imatge a una pàgina wiki emprant",
"or use filename" => "o utilitza el nom del fitxer",
"Now enter the image URL" => "Introduïu ara la URL de la imatge",
"or upload a local image from your disk" => "o puja una imatge local des del teu disc",
"Batch Upload" => "Puja al rerafons",
"Thumbnail (optional, overrides automatic thumbnail generation)" => "Miniatures (opcional, impedeix que es generin contactes pel sistema)",
// "No gallery available" => "No gallery available",
"You have to create a gallery first!" => "Has de crear una galeria primer!",
"User assigned modules" => "Mòduls assignats per l'usuari",
"Restore defaults" => "Recupera predeterminats",
// "The column is disabled" => "The column is disabled",
"#" => "#",
"act" => "acte",
"Move to Right Column" => "Moure ala columna dreta",
"Move to Left Column" => "Moure a la columna esquerra",
"Assign module" => "Assigna mòdul",
"top" => "més actius/ves",
"Current folder" => "Carpeta actual",
"Folders" => "Carpetes",
"Folder in" => "En la carpeta",
"Remove Folder" => "Elimina carpeta",
"Refresh Cache" => "Refresca memòria cau",
"Admin folders and bookmarks" => "Administració de carpetes i adreces d'interès",
// "a folder" => "a folder",
// "a bookmark" => "a bookmark",
// "User Contacts Preferences" => "User Contacts Preferences",
"Manage Fields" => "Gestiona els camps",
// "{\$ext.fieldname|escape}" => "{\$ext.fieldname|escape}",
// "{if \$escape_menu_labels}{\$chdata.name|escape}{else}{\$chdata.name}{/if}" => "{if \$escape_menu_labels}{\$chdata.name|escape}{else}{\$chdata.name}{/if}",
"Send me a message" => "Envia'm un missatge",
"Basic Data" => "Dades bàsiques",
"Assign Group" => "Assignar Grup",
"Change user preferences" => "Canvia les preferències de l'usuari",
"User Icon" => "Icona d'usuari",
// "{\$gender}" => "{\$gender}",
// "(non public)" => "(non public)",
// "{\$country|stringfix}" => "{\$country|stringfix}",
// "User's homepage" => "User's homepage",
"Personal Wiki Page" => "Pàgina Wiki Personal",
"This user is your friend " => "Aquest usuari/a és una de les teves amistats ",
"The user requested friendship with you" => "Aquest usuari/a ha demanat la teva amistat",
"Accept friendship from this user" => "Accepta l'amistat d'aquest usuari",
"Refuse friendship from this user" => "Refusa l'amistat d'aquest usuari",
"Currently waiting for user approval" => "Actualment esperant aprovació de l'usuari",
"Cancel friendship request towards this user" => "Cancel·la la petició d'amistat cap a aquest usuari",
"Request friendship from this user" => "Demana l'amistat d'aquest usuari",
"Additional Information" => "Informació adicional",
// "Change user information" => "Change user information",
"User Contribution" => "Contribucions d'usuari",
"has contributed to the following content" => "ha contribuït al següent contingut",
"has not contributed to any content yet" => "No ha contribuït amb cap contingut encara",
"Forum comments" => "Comentaris del Fòrum",
"Who Looks At Stuff?" => "Qui mira les coses?",
"Who Looks At Your Stuff?" => "Qui mira les meves coses?",
"Who Looks At His Stuff" => "Qui mira les teves coses",
"Send Me A Message" => "Envia'm un missatge",
"Send me a message !" => "Envia'm un missatge !",
"The following message will be sent to user" => "El següent missatge serà enviat a l'usuari",
"Message Body" => "Cos del missatge",
"Toggle" => "Commuta",
"Toggle options" => "Opcions de commutació",
"Personal Information" => "Informació Personal",
"Male" => "Home",
"Female" => "Dona",
"Hidden" => "Ocult",
// "{\$flags[ix]|stringfix}" => "{\$flags[ix]|stringfix}",
"Your personal Wiki Page" => "La teva pàgina personal al Wiki",
"User's personal tracker information" => "Informació personal de l'usuari a la base de dades (tracker)",
"View extra information" => "Visualitza informació extra",
"Your personal tracker information" => "Informació del teu formulari-bd personal",
"Is email public? (uses scrambling to prevent spam)" => "És públic aquest correu-e ? (per a provenir spam)",
"Unavailable - please set your e-mail below" => "No disponible - si us plau, posa el teu correu-e a sota",
"Does your mail reader need a special charset" => "Necessita el teu programa lector de correu-e un conjunt de caracters especial",
"Preferred language" => "Idioma/es preferit/s",
"Can you read more languages?" => "Pots llegir més idiomes?",
"Other languages you can read (select on the left to add to the list on the right)" => "Altres idiomes que pots llegir (selecciona a l'esquerra per afegir a la llista de la dreta - l'ordre importa)",
"Select language..." => "Selecciona l'idioma...",
"Detect user time zone if browser allows, otherwise site default" => "Detecta la zona horària de l'usuari si el navegador ho permet, d'altra forma, per defecte del lloc",
"Use 12-hour clock in time selectors" => "Empra rellotge de 12-hores en selectors de temps",
"Display info tooltip on mouseover for every user who allows his/her information to be public" => "Mostra requadre d'informació en passar el ratolí per sobre per a cada usuari que permet que la seva informació sigui pública",
"Notify sender when reading his mail" => "Avisa l'autor quan llegiu el seu missatge",
"Auto-archive read messages after x days" => "Auto-arxiva missatges llegits després de x dies",
"never" => "mai",
"My user items" => "Els meus ítems d'usuari",
"My level" => "El meu nivell",
"Account Information" => "Informació del compte",
"Leave \"New password\" and \"Confirm new password\" fields blank to keep current password" => "Deixa els camps \"Contrasenya nova\" i \"Confirma contrasenya nova\" en blanc per mantenir la contrasenya actual",
"Confirm new password" => "Confirma contrasenya nova",
"Current password (required)" => "Contrasenya actual (requerida)",
"Account Deletion" => "Esborrat del compte",
"Are you really sure you want to delete the account %0" => "Estàs segur realment de voler esborrar el compte %0",
"Check this box if you really want to delete the account" => "Marca aquesta casella si vols esborrar realment el compte",
"Delete the account" => "Esborra el compte",
"Delete my account" => "Esborra el meu compte",
"Task list" => "Llista de tasques",
"Admin mode off" => "Mode Administrador inactiu",
"Admin mode on" => "Mode Administrador activat",
"Task help" => "Ajuda de tasques",
"Empty Trash" => "Buida paperea",
// "Task received" => "Task received",
// "You received this task" => "You received this task",
// "Task sent" => "Task sent",
// "You sent this task to another user" => "You sent this task to another user",
// "Task shared by a group" => "Task shared by a group",
// "Task is shared by a group" => "Task is shared by a group",
// "Accepted by task user and creator" => "Accepted by task user and creator",
// "Task has been accepted by user and creator" => "Task has been accepted by user and creator",
// "Rejected by a user" => "Rejected by a user",
// "Task has been rejected by a user" => "Task has been rejected by a user",
// "Waiting for me" => "Waiting for me",
// "Task has not yet been accepted or rejected by you" => "Task has not yet been accepted or rejected by you",
// "Waiting for other user" => "Waiting for other user",
// "Task has not yet been accepted or rejected by another user" => "Task has not yet been accepted or rejected by another user",
"Admin Mode" => "Mode administrador",
"Edit Task" => "Edita la tasca",
"NOT accept" => "NO acceptis",
"Remove from Trash" => "Elimina de la paperera",
// "Move to trash" => "Move to trash",
// "Move to Trash" => "Move to Trash",
"Task saved" => "Tasca guardada",
"View Task" => "Mostra la tasca",
"Open a new task" => "Obre una nova tasca",
"taskId" => "IdTasca",
"Task user" => "Usuari de la tasca",
"Only the creator can delete this task" => "Només el creador pot esborrar aquesta tasca",
"Use start date and time" => "Empra data i hora d'inici",
"Use end date and time" => "Empra data i hora de finalització",
"Open / In Process" => "Oberta / en procés",
"Waiting / Not Started" => "En espera / no iniciada",
"Percentage completed" => "Percentatge completat",
"Shared for Group" => "Compartida per al group",
"Accepted by User" => "Acceptada per l'usuari/a",
"No / Rejected" => "No / rebutjada",
"Accepted by Creator" => "Acceptada pel creador",
"This message will be send to users if you are makeing changes of assigned tasks" => "Aquest missatge serà enviat als usuaris si fas canvis a tasques assignades",
"Send message with changes" => "Envia missatge amb canvis",
"Modified by" => "Modificada per",
"Marked as deleted" => "Marcat com a eliminat",
"Inform task user by email" => "Informa a l'usuari de la tasca per correu-e",
"You can only view this task" => "Pots veure només aquesta tasca",
"Completed" => "Completada",
// "In the trash" => "In the trash",
"Not Accepted by One User" => "No acceptada per un/a usuari/a",
"Not Accepted User" => "Usuari no acceptat",
"No tasks entered" => "No hi ha cap tasca",
"Select One" => "Selecciona un/a",
"Undo Trash" => "Desfés paperera",
"Show:" => "Mostra:",
"Received" => "Rebut/da",
"Submitted" => "Enviat/da",
"Shared" => "Compartit/da",
"All Shared Tasks" => "Totes les tasques compartides",
"completed (100%)" => "completat/da (100%)",
"Public for group" => "Pública per al grup",
// "User Watches and preferences" => "User Watches and preferences",
// "You need to set your email to receive email notifications" => "You need to set your email to receive email notifications",
"Report Preferences" => "Preferències dels informes",
// "You are not allowed to remove this notification " => "You are not allowed to remove this notification ",
"Use reports to summarise notifications about objects you are watching." => "Empra resums periòdics de notificacions de canvis als objectes que estàs seguint",
"Use reports" => "Empra resums periòdics",
"Interval in which you want to get the reports" => "Interval per al qual vols rebre els resums periòdics",
"Monthly" => "Mensual",
"Short report" => "Informe breu",
"Detailed report" => "Informe detallat",
"HTML-Email" => "Correu-e en HTML",
"Send me an email also if nothing happened" => "Envia'm un correu-e també si no passa res",
"My watches" => "Els meus seguiments",
"Use \"watches\" to monitor wiki pages or other objects." => "Fes servir els \"seguiments\" per vigilar pàgines wiki o altres objectes.",
"Watch new items by clicking the {icon _id=eye} button on specific pages." => "Vigila nous ítems en clicar al botó de l'ull {icon _id=eye} de pàgines específiques.",
"Add Watch" => "Afegeix avís",
"Select event type" => "Selecciona tipus d'esdeveniment",
"All watched events" => "Tots els esdeveniments vigilats",
"A user submits a blog post" => "Un usuari envia una publicació de blog",
"A user posts a forum thread" => "Una persona usuària publica un fil de discussió del fòrum",
"A user posts a forum topic" => "Una persona usuària publica un topic del fòrum",
// "A user edited or commented on a wiki page" => "A user edited or commented on a wiki page",
"A user edited a wiki page" => "Un usuari edita una pàgina wiki",
// "{\$w.type}" => "{\$w.type}",
// "Used space" => "Used space",
// "up to" => "up to",
// "no limit for admin" => "no limit for admin",
"May need to refresh twice to see changes" => "Es necessita actualitzar dos cops per tal de veure els canvis",
"Add top level bookmarks to menu" => "Afegeix els millors favorits al menú",
"Add or edit an item" => "Afegeix o edita un ítem",
"New Window" => "Nova finestra",
"replace window" => "reemplaçar la finestra",
"Pos" => "Pos",
"User_versions_for" => "Versions de l'usuari per a",
// "{\$topic|escape}" => "{\$topic|escape}",
// "{\$type|escape}" => "{\$type|escape}",
"Monitor Articles" => "Segueix els Articles per correu-e",
"Stop Monitoring Articles" => "Deixa de seguir els Articles per correu-e",
"Published At" => "Publicat el",
// "{\$listpages[ix].topicName}" => "{\$listpages[ix].topicName}",
"No articles yet" => "Sense articles encara",
"Add an article" => "Afegeix un article",
"Banner stats" => "Pancarta: estadístiques",
"Create new banner" => "Crea un nou banner",
"Banner Information" => "Informació de la Pancarta",
"Click ratio" => "Taxa de clicks",
"Weekdays" => "Dies de la setmana",
"mon" => "dl",
"tue" => "dm",
"wed" => "dc",
"thu" => "dj",
"fri" => "dv",
"sat" => "ds",
"sun" => "dg",
"Banner raw data" => "Dades en brut del bànner",
"Monitor this Blog" => "Subscriu-te a aquest bloc",
"Stop Monitoring this Blog" => "Desubscriu-te a aquest bloc",
"Cached" => "Carregat en memòria cau",
"This is a cached version of the page." => "Aquesta és una versió en memòria cau de la pàgina",
"Click here to view the Google cache of the page instead." => "Cliqueu aquí per veure la memòria cau Google de la pàgina.",
// "{\$faq_info.title}" => "{\$faq_info.title}",
// "There are no questions in this FAQ" => "There are no questions in this FAQ",
"Answers" => "Respostes",
"Add Suggestion" => "Afegeix un suggeriment",
"Forum List" => "Llista de fòrums",
"Edit Forum" => "Editar fòrum",
// "Manage Message Queue" => "Manage Message Queue",
// "Manage Reported Messages" => "Manage Reported Messages",
"Monitor Topics of this Forum" => "Vigila per correu-e els Tòpics d'aquest Fòrum",
"Stop Monitoring Topics of this Forum" => "Deixa de vigilar per correu-e els Tòpics d'aquest Fòrum",
"Monitor Topics and Threads of this Forum" => "Vigila per correu-e els Tòpics i respostes d'aquest fòrum",
"Stop Monitoring Topics and Threads of this Forum" => "Deixa de vigilar per correu-e els Tòpics i respostes d'aquest fòrum",
"Group Monitor Topics of this Forum" => "Fes que alguns grups vigilin els Tòpics d'aquest Fòrum",
"Group Monitor Topics and Threads of this Forum" => "Fes que alguns grups vigilin per correu-e  els Tòpics i respostes d'aquest fòrum",
"Post New" => "Publica'n una de nova",
"Watch for replies" => "Vigila per correu-e les respostes",
"Send me an e-mail when someone replies to my topic" => "Envia'm un missatge de correu-e quan algú respongui al meu tòpic",
"Don't send me any e-mails" => "No m'enviïs missatges de correu-e",
"Enter your name" => "Introdueix el teu nom",
"Editing posts" => "Editant publicacions",
"for links" => "per a enllaços",
"HTML tags are not allowed inside posts" => "No són permeses les etiquetes HTML dins les publicacions",
"Moderator Actions" => "Accions del moderador",
"Move Selected Topics" => "Moure temes seleccionats",
"Unlock Selected Topics" => "Desbloqueja tòpics seleccionats",
"Lock Selected Topics" => "Bloqueja temes escollits",
"Delete Selected Topics" => "Esborrar temes seleccionats",
"Merge" => "Escapçar",
"Merge Selected Topics" => "Escapçar els temes escollits",
"Reported Messages:" => "Missatges reportats:",
"Queued Messages:" => "Missatges a la cua:",
"Merge into topic" => "Encabir dins el tema",
"Emot" => "Emot",
"pts" => "pts",
// "Atts" => "Atts",
// "Forum Lock" => "Forum Lock",
"posts in this forum" => "publicacions en aquest fòrum",
// "Filter Posts" => "Filter Posts",
"Jump to forum" => "Saltar al fòrum",
// "Posts Filtering" => "Posts Filtering",
// "Last post date" => "Last post date",
"All posts" => "Tots els escrits",
"Last hour" => "La última hora",
"Last 24 hours" => "Les últimes 24 hores",
"Last 48 hours" => "Les últimes 48 hores",
"Show archived posts" => "Mostra publicacions arxivades",
// "Containing posts by" => "Containing posts by",
// "Me" => "Me",
"normal" => "normal",
"announce" => "anunci",
"hot" => "calent",
// "Posts with no replies" => "Posts with no replies",
"Archived" => "Arxivada/des",
// "Topic List" => "Topic List",
"The post has been reported and will be reviewed by a moderator." => "S'ha informat de la publicació i serà revisada per un moderador.",
"prev topic" => "tòpic ant",
"next topic" => "tema següent",
// "You are viewing a reply to" => "You are viewing a reply to",
"Print this page only" => "Imprimeix només aquesta pàgina",
"Print all pages" => "Imprimeix totes les pàgines",
"Show posts" => "Mostrar publicacions",
// "View Invoice" => "View Invoice",
// "Invoice %0" => "Invoice %0",
// "Date Issued %0" => "Date Issued %0",
// "Amount: %0" => "Amount: %0",
// "Total: %0" => "Total: %0",
// "Payment Terms: %0" => "Payment Terms: %0",
// "Back to Page" => "Back to Page",
// "Already being edited by" => "Already being edited by",
"Tiki Sheet" => "Full Tiki",
// "Save current spreadsheet" => "Save current spreadsheet",
// "Cancel editing current spreadsheet" => "Cancel editing current spreadsheet",
// "No parse" => "No parse",
// "What would you like to add" => "What would you like to add",
// "New spreadsheet" => "New spreadsheet",
// "Existing spreadsheet" => "Existing spreadsheet",
// "Tracker as a spreadsheet" => "Tracker as a spreadsheet",
// "Spreadsheet from file gallery" => "Spreadsheet from file gallery",
// "Cell" => "Cell",
// "Set Reference" => "Set Reference",
// "Un-Merge" => "Un-Merge",
// "Adds an additional row to bottom of the spreadsheet" => "Adds an additional row to bottom of the spreadsheet",
"Add Row" => "Afegeix Fil·la",
// "Adds an additional rows to bottom of the spreadsheet" => "Adds an additional rows to bottom of the spreadsheet",
"Add Multi-Rows" => "Afegeix Múltiples Fil·les",
// "Delets the current row thats highlighted" => "Delets the current row thats highlighted",
"Delete Row" => "Esborra Fil·la",
// "Inserts an additional row after currently selected row" => "Inserts an additional row after currently selected row",
// "Insert Row Before" => "Insert Row Before",
// "Insert Row After" => "Insert Row After",
// "Unhides all the hidden rows" => "Unhides all the hidden rows",
"Show All" => "Mostrar Tot",
// "Hides or shows the currently selected row" => "Hides or shows the currently selected row",
// "Toggle Hide Row" => "Toggle Hide Row",
// "Adds an additional column to the right of the spreadsheet" => "Adds an additional column to the right of the spreadsheet",
"Add Column" => "Afegeix Columna",
// "Adds an additional columns to the right of the spreadsheet" => "Adds an additional columns to the right of the spreadsheet",
"Add Multi-Columns" => "Afegeix Múltiples Columnes",
// "Deletes the current column thats highlighted" => "Deletes the current column thats highlighted",
"Delete Column" => "Esborra Columna",
// "Inserts an additional column after currently selected column" => "Inserts an additional column after currently selected column",
// "Insert Column Before" => "Insert Column Before",
// "Insert Column After" => "Insert Column After",
// "Fill down current cell value" => "Fill down current cell value",
// "Fill Down" => "Fill Down",
// "Fill up current cell value" => "Fill up current cell value",
// "Fill Up" => "Fill Up",
// "Unhides all the hidden columns" => "Unhides all the hidden columns",
// "Hides or shows the currently selected column" => "Hides or shows the currently selected column",
// "Toggle Hide Column" => "Toggle Hide Column",
// "Add new spreadsheet" => "Add new spreadsheet",
// "Add Spreadsheet" => "Add Spreadsheet",
// "Delete the current spreadsheet" => "Delete the current spreadsheet",
// "Delete Spreadsheet" => "Delete Spreadsheet",
// "Recompiles the current sheet" => "Recompiles the current sheet",
// "Change the title of the sheet" => "Change the title of the sheet",
// "Wrap Cell Range" => "Wrap Cell Range",
// "Wrap with SUM" => "Wrap with SUM",
// "Wrap with CEILING" => "Wrap with CEILING",
// "Wrap with COUNT" => "Wrap with COUNT",
// "Wrap with MAX" => "Wrap with MAX",
// "Wrap with MIN" => "Wrap with MIN",
// "Redo" => "Redo",
// "Toggle State" => "Toggle State",
// "Function Reference" => "Function Reference",
// "Usage Example: =SUM(SUM(A1:B1) + SUM(D7))" => "Usage Example: =SUM(SUM(A1:B1) + SUM(D7))",
// "=(TRUE(N(A1)) || FALSE(N(B1)))" => "=(TRUE(N(A1)) || FALSE(N(B1)))",
// "Returns the absolute value of a number" => "Returns the absolute value of a number",
// "Returns a rounded number" => "Returns a rounded number",
// "Returns a number rounded up based on a multiple of significance" => "Returns a number rounded up based on a multiple of significance",
// "Counts the number of cells that contain a value" => "Counts the number of cells that contain a value",
// "Counts full days from a specific date - format(YYYY,MM,DD)" => "Counts full days from a specific date - format(YYYY,MM,DD)",
// "Converts a number to text, using a currency format - options(number, decimals, symbol)" => "Converts a number to text, using a currency format - options(number, decimals, symbol)",
// "Returns a logical value of FALSE" => "Returns a logical value of FALSE",
// "Returns a text representation of a number rounded to a specified number of decimal places - options(number, decimals, useCommas)" => "Returns a text representation of a number rounded to a specified number of decimal places - options(number, decimals, useCommas)",
// "Returns a number rounded down based on a multiple of significance" => "Returns a number rounded down based on a multiple of significance",
// "Returns the integer portion of a number" => "Returns the integer portion of a number",
// "Returns the largest value from the numbers provided" => "Returns the largest value from the numbers provided",
// "Returns the smallest value from the numbers provided" => "Returns the smallest value from the numbers provided",
// "Converts a value to a number" => "Converts a value to a number",
// "Gets full date of today" => "Gets full date of today",
// "Returns the mathematical constant called pi, which is 3.14159265358979" => "Returns the mathematical constant called pi, which is 3.14159265358979",
// "Returns the result of a number raised to a given power" => "Returns the result of a number raised to a given power",
// "Returns a random number that is greater than or equal to 0 and less than 1" => "Returns a random number that is greater than or equal to 0 and less than 1",
// "Returns a number rounded to a specified number of digits" => "Returns a number rounded to a specified number of digits",
// "Returns all of the values in each of the specified cells and added together" => "Returns all of the values in each of the specified cells and added together",
// "Returns a logical value of TRUE" => "Returns a logical value of TRUE",
// "Converts a text value that represents a number to a number" => "Converts a text value that represents a number to a number",
// "Italics" => "Italics",
// "Uppercase" => "Uppercase",
// "Capitalize" => "Capitalize",
// "Lowercase" => "Lowercase",
// "Font Size +" => "Font Size +",
// "Font Size -" => "Font Size -",
"Items found" => "Ítems trobats",
"lastModif" => "UltimaModif",
"atts" => "adjunts",
"List Attachments" => "Llista els Deures",
// "View/Edit" => "View/Edit",
"Insert New Item" => "Inserta un nou ítem",
"View inserted item" => "Mostra el registre insertat",
"Insert new item" => "Inserta un nou ítem",
// "Synchronization" => "Synchronization",
// "This tracker is a remote copy of <a href=\"%0\">%0</a>" => "This tracker is a remote copy of <a href=\"%0\">%0</a>",
// "It was last updated on %0" => "It was last updated on %0",
// "Reload field definitions" => "Reload field definitions",
// "Items added locally" => "Items added locally",
// "Push new items" => "Push new items",
// "Safe modifications (no remote conflict)" => "Safe modifications (no remote conflict)",
// "Dangerous modifications (remote conflict)" => "Dangerous modifications (remote conflict)",
// "On push, local items will be removed until data reload" => "On push, local items will be removed until data reload",
// "Push local changes" => "Push local changes",
// "Local changes will be lost" => "Local changes will be lost",
// "When reloading the data from the source, all local changes will be lost" => "When reloading the data from the source, all local changes will be lost",
// "New items that must be preserved should be pushed using the above controls" => "New items that must be preserved should be pushed using the above controls",
// "Modifications that must be preserved should be replicated" => "Modifications that must be preserved should be replicated",
// "Without conflicts: Using the above controls" => "Without conflicts: Using the above controls",
// "With conflicts: Manually on the source" => "With conflicts: Manually on the source",
// "Using the above controls will cause information loss" => "Using the above controls will cause information loss",
// "Reload data from source" => "Reload data from source",
"Local" => "Local",
// "Remote" => "Remote",
"View Item" => "Visualitza ítem",
// "Translations" => "Translations",
"Move to another tracker" => "Mou a un altre formulari-bd",
"Back to Items list" => "Retorna a la llista d'Ítems",
"Back to Items List" => "Retorna a la Llista d'Ítems",
"Special Operations" => "Operacions especials",
"close" => "tanca",
// "Open Tiki WebDAV (Wiki pages) as WebFolder" => "Open Tiki WebDAV (Wiki pages) as WebFolder",
// "Open Tiki WebDAV as WebFolder" => "Open Tiki WebDAV as WebFolder",
// "Personal e-mail accounts" => "Personal e-mail accounts",
// "This is the active account" => "This is the active account",
// "IMAP" => "IMAP",
// "Mbox" => "Mbox",
// "Maildir" => "Maildir",
// "POP3" => "POP3",
// "Group e-mail accounts" => "Group e-mail accounts",
// "Incoming servers (used in this order)" => "Incoming servers (used in this order)",
// "IMAP server" => "IMAP server",
// "Mbox filepath" => "Mbox filepath",
// "Maildir mail directory" => "Maildir mail directory",
// "Use SSL" => "Use SSL",
// "Outgoing server" => "Outgoing server",
// "From email" => "From email",
// "Uses current in preferences if empty" => "Uses current in preferences if empty",
// "No email set" => "No email set",
// "Account details" => "Account details",
// "Group (shared mail inbox) or private" => "Group (shared mail inbox) or private",
// "This will be a group mail account" => "This will be a group mail account",
// "This will be a personal mail account" => "This will be a personal mail account",
// "Auto-refresh page time" => "Auto-refresh page time",
// "seconds (0 = no auto refresh)" => "seconds (0 = no auto refresh)",
// "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission" => "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission",
// "Show Unread" => "Show Unread",
// "Show Flagged" => "Show Flagged",
// "Auto refresh set for every \$autoRefresh seconds" => "Auto refresh set for every \$autoRefresh seconds",
// "Refresh now" => "Refresh now",
// "Group messages" => "Group messages",
// "unFlagged" => "unFlagged",
"Clip" => "clip",
"Back To Mailbox" => "torna a bustia de correu",
"Full Headers" => "capçaleres senceres",
"Normal Headers" => "capçaleres normals",
"Reply To All" => "respon a tots",
"Forward" => "reenvia",
// "Part" => "Part",
"Select from address book" => "selecciona del llibre d'adreces",
"Use HTML mail" => "Empra correu HTML",
"The following addresses are not in your address book" => "La següent adreça no es troba en el teu llibre d'adreces",
"Add Contacts" => "Afegeix contactes",
"Attachment 1" => "Afegit 1",
"Attachment 2" => "Afegit 2",
"Attachment 3" => "Afegit 3",
"Address book" => "Llibre d'adreces",
"TOC" => "Índex",
"Parent page" => "Pàgina filial",
"Child" => "Filla",
"page id" => "id de pàgina",
"View edit icons" => "Visualitza les icones d'edició",
"3d browser" => "navegador 3d",
"Page is NOT being monitored. Click icon to START monitoring" => "NO s'està vigilant la pàgina. Clica a la icona per COMENÇAR A vigilar-la",
"Page IS being monitored. Click icon to STOP monitoring" => "SI que s'està vigilant la pàgina. Clica a la icona per DEIXAR DE vigilar-la",
"Group Monitor on Structure" => "Subscriu a grups sencers d'usuaris a l'Estructura",
// "Hide structure bar" => "Hide structure bar",
// "Hide structure" => "Hide structure",
// "More types available" => "More types available",
// "More field types may be enabled from the <a href=\"%0\">administration panel</a>" => "More field types may be enabled from the <a href=\"%0\">administration panel</a>",
// "Contact your administrator to see if they can be enabled. The complete field type list is available in the <a rel=\"external\" class=\"external\" href=\"%0\">documentation</a>" => "Contact your administrator to see if they can be enabled. The complete field type list is available in the <a rel=\"external\" class=\"external\" href=\"%0\">documentation</a>",
"Description contains wiki syntax" => "La descripció contè sintaxi wiki",
// "Restrict visibility to administrators" => "Restrict visibility to administrators",
// "Useful if you are working on a live tracker" => "Useful if you are working on a live tracker",
"Add Field &amp; Edit Advanced Options" => "Afegeix un camp &amp; Edita les Opcions Avançades",
"New tracker created" => "S'ha creat un nou formulari-bd",
"Return to Trackers" => "Retorna als Formularis-bd",
"Options for %0" => "Opcions per a %0",
"Separate multiple with commas" => "Separa mutiples valors amb comes",
"Error Message" => "Missatge d'error",
"Visible by all" => "Visible per tothom",
"Visible by administrators only" => "Visible només pels administradors",
"Editable by administrators only" => "Editable només pels administradors",
"Editable by administrators and creator only" => "Editable només pels administradors i pel creador",
"Creator requires a user field with auto-assign to creator (1)" => "La opció del Creador requereix un camp d'usuari autoassignat al creador (1)",
"Visible by" => "Visible per",
"Editable by" => "Editable per",
// "Changing the permanent name may have consequences in integrated systems" => "Changing the permanent name may have consequences in integrated systems",
"Quick Export" => "Exportació Ràpida",
"Produce a CSV with basic formatting" => "Produeix un arxiu CSV amb formateig bàsic",
"Export Tracker Items" => "Exporta Ítems del Formulari-bd",
"Charset encoding" => "Codificació de Caràcters",
// "ISO-8859-1 Latin" => "ISO-8859-1 Latin",
"Delimitor (left)" => "Delimitador (esquerra)",
"Delimitor (right)" => "Delimitador (dreta)",
"Carriage return inside field value" => "Retorn de carro dins del valor d'un camp",
// "Export dates as UNIX Timestamps to facilitate importing" => "Export dates as UNIX Timestamps to facilitate importing",
"Export ItemLink type fields as the itemId of the linked item (to facilitate importing)" => "Exporta es camps de tipus EnllaçaItem (ItemLink) com a itemId de l'ítem enllaçat (per facilitar l'importat posterior)",
// "Export country type fields as the system name of the country (to facilitate importing)" => "Export country type fields as the system name of the country (to facilitate importing)",
"Parse as wiki text" => "Interpreta com a text wiki",
"Generic information" => "Informació genèrica",
"Number of records" => "Nombre de registres",
"First record" => "Primer registre",
"Tracker Export" => "Exporta el Formulari-bd",
"Profile Export" => "Exporta com a Perfil de Configuració",
"Produce YAML for a profile" => "Produeix el codi YAML per a un perfil de configuració",
// "Linked tracker and field IDs (such as those referenced in ItemLink, ItemsList field options, for instance) are not currently converted to profile object references, so will need manual replacement" => "Linked tracker and field IDs (such as those referenced in ItemLink, ItemsList field options, for instance) are not currently converted to profile object references, so will need manual replacement",
// "For example: \$profileobject:field_ref\$" => "For example: \$profileobject:field_ref\$",
// "Export Profile" => "Export Profile",
// "YAML Export" => "YAML Export",
// "Profile for trackerId %0" => "Profile for trackerId %0",
// "Import fields for this tracker" => "Import fields for this tracker",
// "Imported file '%0'" => "Imported file '%0'",
// "Import completed with '%0'" => "Import completed with '%0'",
// "The order of the fields does not matter, but you need to add a header with the field names" => "The order of the fields does not matter, but you need to add a header with the field names",
// "Add \" -- \" to the end of the fields in the header that you would like to import" => "Add \" -- \" to the end of the fields in the header that you would like to import",
// "Auto-incremented itemid fields shall be included with no matter what values" => "Auto-incremented itemid fields shall be included with no matter what values",
// "UNIX Timestamp" => "UNIX Timestamp",
// "Character encoding" => "Character encoding",
// "Create as new items" => "Create as new items",
// "Update lastModif date if updating items (status and created are updated only if the fields are specified in the csv)" => "Update lastModif date if updating items (status and created are updated only if the fields are specified in the csv)",
// "Convert values of ItemLink type fields from the value in the CSV file to the itemId of the linked item. Requires the linked item to be correctly set up in advance" => "Convert values of ItemLink type fields from the value in the CSV file to the itemId of the linked item. Requires the linked item to be correctly set up in advance",
// "Do you really want to remove the %0 tracker" => "Do you really want to remove the %0 tracker",
// "Back to tracker list" => "Back to tracker list",
// "Are you sure you want to remove the fields? Data will be lost" => "Are you sure you want to remove the fields? Data will be lost",
// "Remove Fields" => "Remove Fields",
// "Return to field administration" => "Return to field administration",
"Are you sure you want to delete this item" => "Segur que vols eliminar aquest ítem",
"Delete item" => "Elimina l'ítem",
"Description is wiki-parsed" => "La descripció es interpretada com a sintaxi wiki",
// "Allow ratings (deprecated, use rating field)" => "Allow ratings (deprecated, use rating field)",
// "Rating options" => "Rating options",
// "Show ratings in listing" => "Show ratings in listing",
// "Show comments in listing" => "Show comments in listing",
// "Display last comment author and date" => "Display last comment author and date",
// "Display attachments in listing" => "Display attachments in listing",
// "Attachment attributes (sortable)" => "Attachment attributes (sortable)",
// "Show status to tracker administrator only" => "Show status to tracker administrator only",
// "Show creation date when listing items" => "Show creation date when listing items",
// "Creation date format" => "Creation date format",
// "Show item creator" => "Show item creator",
// "Show creation date when viewing items" => "Show creation date when viewing items",
// "Show last modification date when listing items" => "Show last modification date when listing items",
// "Show item last modifier" => "Show item last modifier",
// "Modification date format" => "Modification date format",
// "Show last modification date when viewing items" => "Show last modification date when viewing items",
// "Default sort direction" => "Default sort direction",
// "Hide empty fields from item view" => "Hide empty fields from item view",
// "List detail pop-up" => "List detail pop-up",
// "Comma-separated list of field IDs" => "Comma-separated list of field IDs",
// "Template to display an item" => "Template to display an item",
"wiki:pageName for a wiki page or tpl:tplName for a template" => "wiki:nomdePagina per a una pàgina wiki o tpl:tplName per a una plantilla",
// "Template to edit an item" => "Template to edit an item",
// "New item status" => "New item status",
// "Modified item status" => "Modified item status",
"No change" => "Cap canvi",
"Default status displayed in list mode" => "Mostrar l'estat per defecte en el mode de llista",
"Notifications" => "Notificacions",
// "Copy activity to email" => "Copy activity to email",
"Use simplified e-mail format" => "Empra el format de correu-e simplificat",
"The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender" => "El formulari-bd emprarà el camp de text anomenat Subject si hi ha algun com a subject i emprarà el correu-e de l'usuari com a enviador, o per a usuaris anònims, el camp de correu-e si existeix",
// "Publish RSS feed for this tracker" => "Publish RSS feed for this tracker",
// "Requires \"RSS per tracker\" to be set in Admin/RSS" => "Requires \"RSS per tracker\" to be set in Admin/RSS",
// "(Currently set)" => "(Currently set)",
// "(Currently not set)" => "(Currently not set)",
// "Group alerted on item modification" => "Group alerted on item modification",
// "Allow user selection for small groups" => "Allow user selection for small groups",
// "Item creator can modify his items" => "Item creator can modify his items",
// "The tracker needs a user field with the auto-assign activated" => "The tracker needs a user field with the auto-assign activated",
// "Item creator can remove his items" => "Item creator can remove his items",
// "User can take ownership of item created by anonymous" => "User can take ownership of item created by anonymous",
"Only one item per user or IP" => "Només un ítem per usuari o IP",
// "The tracker needs a user or IP address field with the auto-assign activated" => "The tracker needs a user or IP address field with the auto-assign activated",
// "Members of the creator group can modify items" => "Members of the creator group can modify items",
// "The tracker needs a group field with the auto-assign activated" => "The tracker needs a group field with the auto-assign activated",
// "Members of the creator group can remove items" => "Members of the creator group can remove items",
// "Creation date constraint" => "Creation date constraint",
// "Auto-create corresponding categories" => "Auto-create corresponding categories",
// "Create a group for each item" => "Create a group for each item",
// "Groups will include" => "Groups will include",
// "Creator is assigned to the group" => "Creator is assigned to the group",
// "Will become the creator's default group" => "Will become the creator's default group",
// "Will become the new item's group creator" => "Will become the new item's group creator",
// "Copy the default group in the field ID before updating the group" => "Copy the default group in the field ID before updating the group",
// "{\$sc.label|escape}" => "{\$sc.label|escape}",
// "Admin Fields" => "Admin Fields",
// "It is very likely that authentication will be required to access this data on the remote site. Configure the authentication source from Admin DSN" => "It is very likely that authentication will be required to access this data on the remote site. Configure the authentication source from Admin DSN",
"Notification" => "Notificació",
"Do you really want to remove the scheduled event" => "Segur que vols esborrar aquest esdeveniment programat",
"No events registered" => "No hi ha cap esdeveniment registrat",
"Reference date" => "Data de referència",
"After creation" => "Després de la creació",
"After last modification" => "Després de la darrera modificació",
"Delay prior to status change" => "Decataltge abans del canvi d'estatus",
"Mail subject text" => "Text de l'assumpte del correu-e",
"Mail body ressource" => "Recurs del cos del missatge",
"wiki:pageName for a wiki page or tplName.tpl for a template" => "wiki:paginaWiki per a una pàgina wiki o tplName.tpl per a una plantilla",
"(automatically generated after item creation)" => "(creat automàticament després de la creació de l'ítem)",
"Hold \"Ctrl\" in order to select multiple values" => "Mantingues presionada la tecla \"Ctrl\" per a seleccionar múltiples valors",
"Other:" => "Altre/a:",
"Upload files" => "Puja arxius",
// "Attached files limitation" => "Attached files limitation",
// "The amount of files that can be attached is limited to <strong>%0</strong>. Additional files uploaded will still be uploaded to the server and searchable, but they will not be attached to this item. Make sure you remove the files no longer required before you save your changes" => "The amount of files that can be attached is limited to <strong>%0</strong>. Additional files uploaded will still be uploaded to the server and searchable, but they will not be attached to this item. Make sure you remove the files no longer required before you save your changes",
"Drop files from your desktop here or browse for them" => "Deixa caure arxius des del teu escriptori o navega per a seleccionar-los",
"Existing files" => "Arxius existents",
"Search query" => "Text a cercar",
"Select Icon" => "Selecciona Icona",
"Remove Image" => "Elimina imatge",
"Are you sure you want to delete this image" => "Segur que vols esborrar aquesta imatge",
"Character Count" => "Nombre de caràcters",
// "Administrator intervention required" => "Administrator intervention required",
// "Freetags is not enabled" => "Freetags is not enabled",
"You did not vote yet" => "No has votat encara",
"My rating" => "La meva puntuació",
// "{\$field.labels[i]}" => "{\$field.labels[i]}",
"Click to vote for this value" => "Clica per tal de votar aquest valor",
// "Click to delete your vote" => "Click to delete your vote",
// "Language: %0" => "Language: %0",
"You have ever subscribed" => "Ja t'havies subscrit abans",
"You have not yet subscribed" => "Encara no t'has subscrit",
"with" => "amb",
"friends" => "amics",
"Current language" => "Idioma actual",
"Show all translations of this page on a single page" => "Mostra totes les traduccions d'aquesta pàgina en una sola pàgina",
"All languages" => "Tots els idiomes",
// "Google translate" => "Google translate",
// "Machine translations" => "Machine translations",
"Translate page" => "Tradueix la pàgina",
"Manage page translations" => "Gestiona les traduccions de la pàgina",
// "Translate article" => "Translate article",
// "Manage article translations" => "Manage article translations",
"Maintenance" => "Manteniment",
"Are you sure you want to detach these translations" => "Segur que vols separar aquestes traduccions",
"Current translation set" => "Conjunt de traduccions actual",
"Are you sure you want to detach the translation" => "Segur que vols separar la traducció",
"No translations available at this time" => "No hi ha cap traducció disponible actualment",
"Add a new object to the set" => "Afegeix un nou objecte al conjunt",
"All possible translations exist" => "Ja existeixen totes les possibles traduccions",
// "Objects that contain the more terms are rated higher in the results and will appear first" => "Objects that contain the more terms are rated higher in the results and will appear first",
// "objects that include both tokenized terms" => "objects that include both tokenized terms",
// "Boolean operators" => "Boolean operators",
// "You can use AND or OR or NOT also to do a boolean search" => "You can use AND or OR or NOT also to do a boolean search",
// "Example: <strong>wiki and forum</strong> will find objects with both terms" => "Example: <strong>wiki and forum</strong> will find objects with both terms",
// "Example: <strong>wiki or forum</strong> will find objects with one of the term" => "Example: <strong>wiki or forum</strong> will find objects with one of the term",
// "Example: <strong>wiki and (forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order" => "Example: <strong>wiki and (forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order",
// "Use double quotes ( \" \" ) around a phrase to find terms in the exact order, next to each other" => "Use double quotes ( \" \" ) around a phrase to find terms in the exact order, next to each other",
// "Example: <strong>\"Alex Bell\"</strong> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong> but <strong>Alex Bells</strong>. " => "Example: <strong>\"Alex Bell\"</strong> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong> but <strong>Alex Bells</strong>. ",
"However, no account is associated to the OpenID identifier." => "Ara bé, no hi ha cap compte associat a l'identificador OpenID.",
"If you use an email filter, be sure to add %0 to your accepted list" => "Si empres un filtre de correu-e, assegura't d'afegir %0 a la llista de les adreces que acceptes",
// "Associate OpenID with an existing Tiki account" => "Associate OpenID with an existing Tiki account",
"Use this thread to discuss the page:" => "Utilitza aquest fòrum per parlar de la pàgina:",
// "Missing or incorrect trackerId parameter for the plugin" => "Missing or incorrect trackerId parameter for the plugin",
"List Trackers" => "Llista Formularis-bd",
"Add Tag" => "Afegeix Marca",
"Subtract" => "Elimina-ho",
"Meeting ID" => "ID de la Trobada",
"Current attendees" => "Assitents actuals",
"No attendees at this time" => "Sense assistents aquesta vegada",
"Last time we checked, the room you requested did not exist" => "El darrer cop que ho vam intentar, no s'havia creat encara la sala que s'ha demanat",
"Current recordings" => "Gravacions actuals",
"On %0 from %1 to %2" => "El %0 des de la/les %1 a la/les %2",
// "{\$button_label}" => "{\$button_label}",
"list" => "llista",
// "{\$ftptitle}" => "{\$ftptitle}",
// "Lon." => "Lon.",
// "Lat." => "Lat.",
"Zoom" => "Zoom",
"saving.." => "desant..",
"Save current map view as user default" => "Desa la visualització actual del mapa com a la per omissió del usuari",
"Save as user location" => "Desa com a localització de l'usuari",
"Save as object location" => "Desa-ho com a localitació de l'objecte",
"Number of Users" => "Nombre d'usuaris",
// "Percentage of Total" => "Percentage of Total",
// "Email address the person you want to invite" => "Email address the person you want to invite",
// "Set in these groups" => "Set in these groups",
"Message sent to" => "Missatge enviat a",
// "Email sent to" => "Email sent to",
// "Emails number" => "Emails number",
// "Send Mail" => "Send Mail",
// "Send to users" => "Send to users",
// "Send to" => "Send to",
// "Email separated by comma" => "Email separated by comma",
// "Send to groups" => "Send to groups",
// "Preview Mail" => "Preview Mail",
// "Check to remove" => "Check to remove",
// "Add in group" => "Add in group",
// "Set as default group for users" => "Set as default group for users",
"Join myself" => "Apunta'm a mi mateix/a",
"Leave myself" => "Desapunta'm a mi mateix/a",
// "%0 year" => "%0 year",
// "%0 years" => "%0 years",
// "%0 days" => "%0 days",
// "Membership term commences on %0-%1 each year" => "Membership term commences on %0-%1 each year",
// "Membership commences on %0 day of each month" => "Membership commences on %0 day of each month",
// "Cost for one period" => "Cost for one period",
// "Free for the rest of the current period, a prorated value of" => "Free for the rest of the current period, a prorated value of",
// "Prorated cost for first period" => "Prorated cost for first period",
// "Special offer! Free additional periods" => "Special offer! Free additional periods",
// "Membership to %0 for %1 year at %2 %3" => "Membership to %0 for %1 year at %2 %3",
// "Membership to %0 for %1 years at %2 %3" => "Membership to %0 for %1 years at %2 %3",
// "Membership to %0 for %1 days at %2 %3" => "Membership to %0 for %1 days at %2 %3",
// "separated by |" => "separated by |",
// "{\$periodslabel}" => "{\$periodslabel}",
// "Re-Apply" => "Re-Apply",
// "Undecided" => "Undecided",
// "No relations found" => "No relations found",
// "{\$snarfParams.ajax|escape:html}" => "{\$snarfParams.ajax|escape:html}",
// "Last Day" => "Last Day",
// "Last Week" => "Last Week",
// "{\$action}" => "{\$action}",
// "Groups you are in" => "Groups you are in",
// "(This is an included group)" => "(This is an included group)",
// "(You are a leader)" => "(You are a leader)",
// "Your default group" => "Your default group",
// "Leave Group" => "Leave Group",
// "Manage Group" => "Manage Group",
// "Change default group" => "Change default group",
"Subscribe to a group" => "Subscriu-te a un grup",
"Groups you can join" => "Grups als que pots unir-te",
// "This group requires approval to join" => "This group requires approval to join",
// "Subscribe to groups" => "Subscribe to groups",
"Subscribe to the newsletter" => "Subscriu-te al butlletí",
// "Mini TimeSheet" => "Mini TimeSheet",
// "Full View" => "Full View",
"Before:" => "Abans:",
"After:" => "Després:",
// "{\$export_action}" => "{\$export_action}",
// "Tracker - " => "Tracker - ",
// "{\$checkbox.title}" => "{\$checkbox.title}",
// "Export Tracker" => "Export Tracker",
// "Close item" => "Close item",
// "Open item" => "Open item",
// "Pend item" => "Pend item",
// "{\$params.label}" => "{\$params.label}",
"Please login first" => "Si us plau, connecta't primer",
"Toggle display" => "Intercanvia com es mostra",
"Close:" => "Tanca:",
// "Page last modified on %0 by %1" => "Page last modified on %0 by %1",
"Created by %0" => "Creat per %0",
"Last Modification: %0 by %1" => "Modificat per darrera vegada: %0 per %1",
// "Creator &amp; Last Editor" => "Creator &amp; Last Editor",
"as Creator &amp; Last Editor" => "com Creador &amp; Darrer Editor",
"no (disabled)" => "no (desactivat)",
// "Missing book id" => "Missing book id",
// "You do not have the right view this page" => "You do not have the right view this page",
// "Missing account id" => "Missing account id",
// "You do not have the rights to view this account" => "You do not have the rights to view this account",
// "You do not have the rights to manage accounts" => "You do not have the rights to manage accounts",
// "You do not have permissions to create a book" => "You do not have permissions to create a book",
// "You do not have permissions to close this book" => "You do not have permissions to close this book",
// "Missing journal id" => "Missing journal id",
// "You do not have the right to cancel transactions" => "You do not have the right to cancel transactions",
// "Error retrieving data from journal" => "Error retrieving data from journal",
// "You do not have the right to book" => "You do not have the right to book",
// "Don't know what to export" => "Don't know what to export",
// "You do not have the right export/view this data" => "You do not have the right export/view this data",
// "You do not have the right to book into the stack" => "You do not have the right to book into the stack",
"Tiki Calendar" => "Calendari del Tiki",
"%0 enabled" => "%0 ha estat habilitat",
"%0 disabled" => "%0 ha estat deshabilitat",
"%0 set" => "%0 ha estat posat/da",
"%0 unset" => "%0 ha estat tret/a",
"Administration" => "Administració",
// "Help on Configuration Sections" => "Help on Configuration Sections",
// "%0 reset" => "%0 reset",
// "Bad request - potential cross-site request forgery (CSRF) detected. Operation blocked" => "Bad request - potential cross-site request forgery (CSRF) detected. Operation blocked",
// "Global site configuration, date formats, admin password etc" => "Global site configuration, date formats, admin password etc",
// "Switches for major features" => "Switches for major features",
// "User registration, remember me cookie settings and authentication methods" => "User registration, remember me cookie settings and authentication methods",
// "User specific features and settings" => "User specific features and settings",
// "Repository configuration, browse and apply profiles" => "Repository configuration, browse and apply profiles",
"Look & Feel" => "Aparença",
// "Theme selection, layout settings and UI effect controls" => "Theme selection, layout settings and UI effect controls",
"Editing and Plugins" => "Edició i connectors (Plugins)",
"Text editing settings applicable to many areas. Plugin activation and plugin alias management" => "Aspectes relacionats amb l'edició de text aplicables a molts àrees. Activació de connectors (plugins) i gestió dels alias de connectors",
// "Module appearance settings" => "Module appearance settings",
"Meta Tags" => "Meta Etiquetes",
// "Information to include in the header of each page" => "Information to include in the header of each page",
"i18n" => "i18n (Internacionalització i idiomes)",
"Internationalization and localization - mulitlingual features" => "Funcionalitat multilíngües d'internationalització (i18n) i localizació (l10n)",
// "Settings and features for maps" => "Settings and features for maps",
// "Server performance settings" => "Server performance settings",
"Site security settings" => "Aspectes de configuració del lloc",
// "Comments settings" => "Comments settings",
// "Outgoing RSS feed setup" => "Outgoing RSS feed setup",
"Connect" => "Connecta",
// "Tiki Connect - join in" => "Tiki Connect - join in",
// "Search configuration" => "Search configuration",
"Wiki page settings and features" => "Configuració i funcionalitats de pàgines Wiki",
// "Defaults and configuration for file galleries" => "Defaults and configuration for file galleries",
// "Settings for blogs" => "Settings for blogs",
// "Defaults and configuration for image galleries (will be phased out in favour of file galleries)" => "Defaults and configuration for image galleries (will be phased out in favour of file galleries)",
// "Settings and features for articles" => "Settings and features for articles",
// "Settings and features for forums" => "Settings and features for forums",
// "Settings and features for trackers" => "Settings and features for trackers",
// "Settings and features for polls" => "Settings and features for polls",
// "Settings and features for calendars" => "Settings and features for calendars",
// "Settings and features for categories" => "Settings and features for categories",
// "Configure areas feature" => "Configure areas feature",
// "Values of actions for users rank score" => "Values of actions for users rank score",
// "Settings and features for freetags" => "Settings and features for freetags",
// "Settings and features for FAQs" => "Settings and features for FAQs",
// "Settings and features for directory of links" => "Settings and features for directory of links",
// "Defaults and API key for Google Maps" => "Defaults and API key for Google Maps",
// "Site-wide copyright information" => "Site-wide copyright information",
// "Message settings" => "Message settings",
"User files" => "Fitxers de l'usuari",
// "User files settings" => "User files settings",
// "Webmail settings" => "Webmail settings",
"Wysiwyg" => "Wysiwyg (Editor Visual)",
// "Options for WYSIWYG editor" => "Options for WYSIWYG editor",
// "Banners are a common way to display advertisements and notices on a Web page" => "Banners are a common way to display advertisements and notices on a Web page",
"InterTiki" => "InterTiki",
// "Set up links between Tiki servers" => "Set up links between Tiki servers",
// "Manage semantic wiki links" => "Manage semantic wiki links",
// "Webservices" => "Webservices",
// "Register and manage web services" => "Register and manage web services",
"Search engine friendly url" => "URLs amigables als cercadors",
"Video streaming integration" => "Integració d'streaming de Vídeo",
// "Video integration configuration" => "Video integration configuration",
// "Configure social networks integration" => "Configure social networks integration",
// "Configure share feature" => "Configure share feature",
// "Current version is up to date : <b>%0</b>" => "Current version is up to date : <b>%0</b>",
// "A new %0 major release branch is available" => "A new %0 major release branch is available",
// "Help on %0 Config" => "Help on %0 Config",
// "Must specify actionId" => "Must specify actionId",
// "Users Contributions: Addition" => "Users Contributions: Addition",
// "%s Contributions: Addition" => "%s Contributions: Addition",
// "Users Contributions: Suppression" => "Users Contributions: Suppression",
// "%s Contributions: Suppression" => "%s Contributions: Suppression",
// "Total Contributions Addition per Day" => "Total Contributions Addition per Day",
// "Total Contributions Addition per Week" => "Total Contributions Addition per Week",
// "Total Contributions Suppression per Day" => "Total Contributions Suppression per Day",
// "Total Contributions Suppression per Week" => "Total Contributions Suppression per Week",
// "Total Contributions: Addition" => "Total Contributions: Addition",
// "Total Contributions: Suppression" => "Total Contributions: Suppression",
// "Groups Contributions: Addition" => "Groups Contributions: Addition",
// "Groups Contributions: Suppression" => "Groups Contributions: Suppression",
// "white" => "white",
// "gray" => "gray",
// "silver" => "silver",
// "ivory" => "ivory",
// "whitesmoke" => "whitesmoke",
// "beige" => "beige",
// "darkgrey" => "darkgrey",
// "Multiple IP Banning" => "Multiple IP Banning",
// "Access from your localization was forbidden due to excessive spamming" => "Access from your localization was forbidden due to excessive spamming",
// "Delete comments then set banning rules" => "Delete comments then set banning rules",
// "Are you sure you want to unassign the objects of this category: " => "Are you sure you want to unassign the objects of this category: ",
// "Click here to delete the category" => "Click here to delete the category",
"The file does not have the required header:" => "L'arxiu no té l'encapçalamet requerit:",
"Edit permissions for this category" => "Edita els permisos per a aquesta categoria",
"Category can`t be parent of itself" => "La categoria no pot ser mare de si mateixa",
// "Content Templates" => "Content Templates",
"Upload failed" => "Ha fallat la pujada",
// "Admin credits" => "Admin credits",
"All posted" => "Tots els enviaments",
"Queue anonymous posts" => "Encua les publicacions anònimes",
"Queue all posts" => "Encua totes les publicacions",
"No attachments" => "Cap adjunt",
"Everybody can attach" => "Tots poden adjuntar",
"Only users with attach permission" => "Només usuaris/es amb permís per a adjuntar ",
"Moderators and admin can attach" => "Els Moderadors i administradors poden adjuntar",
// "No display" => "No display",
"Date (desc)" => "Data (desc)",
"Date (asc)" => "Data (asc)",
"Score (desc)" => "Punts (desc)",
"Replies (desc)" => "Respostes (desc)",
"Reads (desc)" => "Lectures (desc)",
"You have to provide a hotword and a URL" => "Has de proveïr una paraula calenta i una URL",
"Requested action is not supported on repository" => "L'acció demanada no és suportada al dipòsit",
"Repository name can't be an empty" => "El nom de dipòsit no pot quedar buit",
"No repository" => "Cap dipòsit",
"Search is mandatory field" => "Buscar es camp obligatori",
"File not found " => "No s'ha trobat el fitxer ",
"Requested action in not supported on repository" => "L'acció demanada no és suportada al dipòsit",
// "You need to apply the \"Invoice\" profile" => "You need to apply the \"Invoice\" profile",
"Non-existent link" => "Aquest enllaç no existeix",
"Mail-in account %s incorrect" => "Compte %s de Correu-dins incorrecta",
"Mail-in account %s saved" => "Compte %s de Correu-dins desada",
"Frequency should be a positive integer!" => "la Freqüència hauria de ser un integrador positiu",
"Mail-in accounts set to be checked every %s minutes" => "S'ha especificat que es comprovin cada %s minuts els comptes de Correu-dins",
"Automatic Mail-in accounts checking disabled" => "Està desactivada la comprovació de comptes correu-dins automàtica",
"No menu indicated" => "No s'indica cap menú",
// "Are you sure you want to delete menu id" => "Are you sure you want to delete menu id",
// "Are you sure you want to reset the Application Menu to the current system default" => "Are you sure you want to reset the Application Menu to the current system default",
// "metric_remove must be a numeric value" => "metric_remove must be a numeric value",
// "tab_remove must be a numeric value" => "tab_remove must be a numeric value",
// "assign_remove must be a numeric value" => "assign_remove must be a numeric value",
// "metric_edit must be a numeric value" => "metric_edit must be a numeric value",
// "tab_edit must be a numeric value" => "tab_edit must be a numeric value",
// "Memcache is disabled for metrics" => "Memcache is disabled for metrics",
// "tab_clearcache must be a numeric value" => "tab_clearcache must be a numeric value",
// "assign_metric must be a numeric value" => "assign_metric must be a numeric value",
// "assign_metric_edit must be a numeric value" => "assign_metric_edit must be a numeric value",
// "Assign: Invalid metric value" => "Assign: Invalid metric value",
// "Assign: Invalid tab value" => "Assign: Invalid tab value",
// "Cannot create or update metric: You need to specify a name for the metric" => "Cannot create or update metric: You need to specify a name for the metric",
// "Cannot create or update metric: Metric name must be under %0 characters in length" => "Cannot create or update metric: Metric name must be under %0 characters in length",
// "Cannot create or update metric: You need to specify a range for the metric" => "Cannot create or update metric: You need to specify a range for the metric",
// "Cannot create or update metric: You need to specify a data type for the metric" => "Cannot create or update metric: You need to specify a data type for the metric",
// "Cannot create or update metric: You need to specify a query for the metric" => "Cannot create or update metric: You need to specify a query for the metric",
// "Cannot create or update tab: You need to specify a name for the tab" => "Cannot create or update tab: You need to specify a name for the tab",
// "Cannot create or update tab: Tab name must be under %0 characters in length" => "Cannot create or update tab: Tab name must be under %0 characters in length",
// "Cannot create or update tab: You need to specify an integer range for the tab order" => "Cannot create or update tab: You need to specify an integer range for the tab order",
// "Cannot create or update tab: Tab content cannot be empty" => "Cannot create or update tab: Tab content cannot be empty",
"Cannot create or update module: You need to specify a name for the module" => "No es pot crear o actualitzar el mòdul: cal especificar el nom del mòdul",
"Cannot create or update module: You cannot leave the data field empty" => "No es pot crear o actualitzar el mòdul: no es pot deixar buit el camp data",
// "A module with that \"name\" already exists, please choose another" => "A module with that \"name\" already exists, please choose another",
// "There is a problem with your custom module \"%0\": ' . '<br><br><em>' . \$e->getMessage() . '</em><br><br>' .\n\t\t\t\t\t'<span class=\"button\"><a href=\"tiki-admin_modules.php?um_edit=' . \$_REQUEST['assign_name'] . '&cookietab=2#editcreate\">' .\n\t\t\t\t\ttr('Click here to edit the module" => "There is a problem with your custom module \"%0\": ' . '<br><br><em>' . \$e->getMessage() . '</em><br><br>' .\n\t\t\t\t\t'<span class=\"button\"><a href=\"tiki-admin_modules.php?um_edit=' . \$_REQUEST['assign_name'] . '&cookietab=2#editcreate\">' .\n\t\t\t\t\ttr('Click here to edit the module",
// "Are you sure you want to delete this Custom Module" => "Are you sure you want to delete this Custom Module",
"No newsletter indicated" => "No s'ha indicat cap butlletí",
// "Newsletter does not exist" => "Newsletter does not exist",
// "Error importing from wiki page: " => "Error importing from wiki page: ",
// "Error opening uploaded file" => "Error opening uploaded file",
"You need to provide a username or an email" => "Ha d'indicar un nom d'usuari o un correu-e",
// "The user has no email set. No notifications will be sent" => "The user has no email set. No notifications will be sent",
"No poll indicated" => "No s'indica cap consulta",
"unsafe" => "insegur",
"The Path to store files in the filegallery should be outside the tiki root directory" => "El camí per emmagatzemar arxius a la galeria d'arxius ha d'estar fora del directori arrel de tiki",
"The Path to store files in the imagegallery should be outside the tiki root directory" => "El camí per emmagatzemar arxius a la galeria d'imatges ha d'estar fora del directori arrel de tiki",
"The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code." => "La funcionalitat \"Edita Plantilles\" està activada. No permetis emprar aquesta funcionalitat a ningú amb qui no confiïs. Pot ser emprada fàcilment per injectar codi php.",
// "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any HTML" => "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any HTML",
// "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement" => "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement",
// "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory" => "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory",
// "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts" => "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts",
// "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)" => "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)",
// "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users" => "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users",
// "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users" => "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users",
// "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands" => "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands",
"Path disclosure" => "Desglossament del camí",
"Path disclosure through error message" => "Desglossament del camí mitjançant un missatge d'error",
"SQL injection" => "Injecció SQL",
"SQL injection by authenticated user" => "Injecció SQL per un usuari autenticat",
"SQL injection by authenticated user with special privileges" => "Injecció SQL per un usuari autenticat amb privilegis especials",
"SQL injection without authentication" => "Injecció SQL sense autenticació",
"PHP command injection" => "Injecció de comanda PHP",
"PHP command injection by authenticated user" => "Injecció de comanda PHP per usuari autenticat",
"PHP command injection by authenticated user with special privileges" => "Injecció de comanda PHP per usuari autenticat amb privilegis especials",
"PHP command injection without authentication" => "Injecció de comanda PHP sense autenticació",
"File upload" => "Arxiu pujat",
"File is not readable. Unable to check." => "L'arxiu no es pot llegir. No es pot comprovar.",
// "This is not a Tiki file. Check if this file was uploaded and if it is dangerous" => "This is not a Tiki file. Check if this file was uploaded and if it is dangerous",
"This is a modified File. Cannot check version. Check if it is dangerous." => "Aquest és un arxiu modificat. No es pot comprovar la versió. Comprova si és perillós.",
// "This file is from another Tiki version: " => "This file is from another Tiki version: ",
// "Shoutbox Words" => "Shoutbox Words",
"You have to provide a word" => "Cal que poseu una paraula",
"You do not have permission to view this page." => "No tens autorització per veure aquesta pàgina",
"You do not have permission to edit this page." => "No teniu autorització per a editar aquesta pàgina",
"You must specify a page name, it will be created if it doesn't exist." => "Has d'especificar un nom de pàgina, serà creada si no existeix.",
"page not added (Exists)" => "pàgina no afegida (ja existeix)",
"No survey indicated" => "No s'ha indicat cap enquesta",
// "Tiki Cache/Sys Admin" => "Tiki Cache/Sys Admin",
// "Global" => "Global",
// "WYSIWYG Plugin" => "WYSIWYG Plugin",
// "Are you sure you want to delete all your custom tools" => "Are you sure you want to delete all your custom tools",
"Are you sure you want to delete this custom tool" => "Segur que vols eliminar aquesta eina personalitzada",
// "Are you sure you want to remove this topic" => "Are you sure you want to remove this topic",
// "Are you sure you want to remove this topic AND all the articles related" => "Are you sure you want to remove this topic AND all the articles related",
"No tracker indicated" => "No s'ha indicat cap formulari-bd",
"You don't have permission to use this feature" => "No tens permís per emprar aquesta funcionalitat",
// "Are you sure you want to create a new group" => "Are you sure you want to create a new group",
// "Are you sure you want to add this user" => "Are you sure you want to add this user",
// "Are you sure you want to ban the user \"%0\" from the group \"%1\"" => "Are you sure you want to ban the user \"%0\" from the group \"%1\"",
// "Are you sure you want to unban the user \"%0\" from the group \"%1\"" => "Are you sure you want to unban the user \"%0\" from the group \"%1\"",
"Group already exists" => "Aquest grup ja existeix",
// "Remove group: " => "Remove group: ",
// "Are you sure you want to delete these groups" => "Are you sure you want to delete these groups",
// "Group name can not be empty" => "Group name can not be empty",
"User doesn't exist" => "Aquest usuari no existeix",
"No records were found. Check the file please!" => "No s'ha trobat cap registre. Revisa el fitxer si us plau!",
"User login or email is required" => "És necessari un nom o correu-e de l'usuari",
// "User does not exist on master" => "User does not exist on master",
"User login is required" => "Es requereix l'entrada de l'usuari/a",
"Email is required" => "Es requereix correu-e",
"User is duplicated" => "Usuari/a duplicat/da",
"Created account %s <%s>" => "S'ha creat el compte %s <%s>",
"Assigned %s in group %s" => "Assignat %s al grup %s",
// "Are you sure you want to add this new user" => "Are you sure you want to add this new user",
// "Email validation requested but email address not set" => "Email validation requested but email address not set",
"The passwords do not match" => "Les contrasenyes no coincideixen",
// "Password not set" => "Password not set",
"User %s already exists" => "L'usuari %s ja existeix",
"User login contains invalid characters" => "El nom d'usuari per connectar-te conté caràcters invàlids",
// "New user created with username %s" => "New user created with username %s",
"Impossible to create new %s with %s %s." => "No ha estat possible de crear cap nou/va %s amb %s %s.",
"Are you sure you want to delete this user" => "Segur que vols eliminar aquest usuari",
"%s %s successfully deleted." => "S'ha eliminat %s %s amb èxit.",
// "Deleted account %s" => "Deleted account %s",
// "Are you sure you want to remove the admin user from the Admins group? You may not be able to administer your Tiki any more if you do this" => "Are you sure you want to remove the admin user from the Admins group? You may not be able to administer your Tiki any more if you do this",
// "Are you sure you want to remove this user from this group" => "Are you sure you want to remove this user from this group",
"%s %s removed from %s %s." => "S'ha eliminat %s %s de %s %s.",
// "Are you sure you want to reset email due for this user" => "Are you sure you want to reset email due for this user",
// "Are you sure you want to remove the link with OpenID for this user" => "Are you sure you want to remove the link with OpenID for this user",
// "Are you sure you want to delete these users" => "Are you sure you want to delete these users",
// "Are you sure you want to add this user to these groups" => "Are you sure you want to add this user to these groups",
// "%s %s assigned to %s %s" => "%s %s assigned to %s %s",
// "Are you sure you want to remove this user from these groups" => "Are you sure you want to remove this user from these groups",
// "Are you sure you want to set the default groups for these users" => "Are you sure you want to set the default groups for these users",
// "group %s set as the default group of user %s" => "group %s set as the default group of user %s",
// "Are you sure you want to send a wiki page as an email to these users" => "Are you sure you want to send a wiki page as an email to these users",
// "The description is mandatory as it is used as mail subject" => "The description is mandatory as it is used as mail subject",
"Invalid or unknown email" => "Correu-e invàlid o desconegut",
"Login contains invalid characters" => "El nom per la connexió conté caràcters invàlids",
"%s changed from %s to %s" => "Ha canviat %s de %s a %s",
"%s modified successfully." => "S'ha modificat %s amb èxit.",
"%s modification failed." => "la modificació de %s ha fallat.",
"email" => "correu-e",
"Impossible to change %s from %s to %s" => "Impossible canviar %s de %s a %s",
// "Please go back and try again" => "Please go back and try again",
// "Could not create user" => "Could not create user",
// "Are you sure you want to modify this user's data" => "Are you sure you want to modify this user's data",
"Classified" => "Classificat",
// "Failed to add attribute" => "Failed to add attribute",
"rss feed disabled" => "alimentació rss desactivada",
"You have to indicate a group" => "Cal indicar un grup",
"This group is invalid" => "Aquest grup és invàlid",
"The page cannot be found" => "No s'ha pogut trobar la pàgina",
"Image Galleries Admin Panel" => "Panell d'administració de les galeries d'imatges",
"Could not read image %s." => "No es pot llegir la imatge %s.",
"Image %s upload failed." => "La pujada de la imatge %s ha fallat.",
"Image %s uploaded successfully." => "La imatge %s ha pujat correctament.",
"Image %s removed from Batch directory." => "La imatge %s ha estat eliminada del directori de lots.",
"Impossible to remove image %s from Batch directory." => "És impossible eliminar la imatge %s del directori de lots.",
"Incorrect directory chosen for batch upload of images." => "S'ha escollit un directori incorrecte per a la càrrega de lots d'imatges.",
"Please setup that dir on " => "Si us plau, configureu aquest directori a ",
"Please contact the website administrator." => "Si us plau, contacta l'administrador de lloc web.",
"Invalid directory name" => "Nom de directori Invàlid",
"Directory batch" => "Directori per pujada en bloc",
// "File Galleries Admin Panel" => "File Galleries Admin Panel",
// "Upload was not successful for %0 (%1)" => "Upload was not successful for %0 (%1)",
"Upload was successful" => "Pujada amb èxit",
// "File %s removed from Batch directory" => "File %s removed from Batch directory",
// "Impossible to remove file %s from Batch directory" => "Impossible to remove file %s from Batch directory",
// "Incorrect directory chosen for batch upload of files" => "Incorrect directory chosen for batch upload of files",
"It isn't possible to post in any blog. You may need to create a blog first." => "No podeu publicar sense crear primer un bloc",
"You do not have permission to edit this post" => "Permís denegat per editar aquesta publicació",
"Top visited blogs" => "Les bitàcoles més visitades",
"Last posts" => "Darrers enviaments",
"Top active blogs" => "Les bitàcoles més actives",
"No blogId specified" => "No s'ha especificat cap bloc",
// "Stop watching all categories" => "Stop watching all categories",
// "Watch all categories" => "Watch all categories",
// "Group watches for all categories" => "Group watches for all categories",
// "Stop watching this category and its descendants" => "Stop watching this category and its descendants",
// "Watch this category and its descendants" => "Watch this category and its descendants",
// "Group watches for this category" => "Group watches for this category",
"Stop watching this category" => "Deixa de seguir aquesta categoria",
"Watch this category" => "Segueix aquesta categoria",
"Nothing tagged yet" => "No hi ha res etiquetat encara",
"You must clear your browser cache." => "Has d'esborrar la memòria cau (cache) del teu navegador.",
"You do not have permission to access this gallery" => "No estàs autoritzat/da a accedir a aquesta galeria",
"No gallery indicated" => "No s'ha indicat cap galeria",
"You do not have permission to remove images from this gallery" => "No tens autorització per suprimir imatges d'aquesta galeria",
"You do not have permission to rebuild thumbnails in this gallery" => "Permís denegat, no podeu refer miniatures en aquesta galeria",
"You do not have permission to rotate images in this gallery" => "Permís denegat, no podeu rotar les imatges d'aquesta galeria",
"No image indicated" => "No s'ha indicat cap imatge",
"picture not found" => "no s'ha trobat la imatge",
"You do not have permission to move images from this gallery" => "No estàs autoritzat/da a moure imatges d'aquesta galeria",
"You do not have permission to view the calendar" => "Permís denegat, no podeu veure el calendari",
// "You need to <a href=\"tiki-admin_calendars.php?cookietab=2\">create a calendar</a>" => "You need to <a href=\"tiki-admin_calendars.php?cookietab=2\">create a calendar</a>",
"There's no such date as" => "Aquesta data no existeix",
"event without name" => "Event sense nom",
"You do not have permission to view this page" => "Permís denegat: no pots veure aquesta pàgina",
// "Invalid date format" => "Invalid date format",
// "Your PHP installation does not have calendar enabled" => "Your PHP installation does not have calendar enabled",
"%H:%M %Z" => "%H:%M %Z",
"Invalid username or activation code. Maybe this code has already been used." => "Nom d'usuari o codi d'activació invàlids. Potser ja s'ha fet servir aquest codi d'activació.",
"Your email could not be validated; make sure you email is correct" => "No s'ha pogut validar el teu correu-e; assegura't que el teu correu-e és correcte",
"You can not use the same password again" => "No pots emprar la mateixa contrasenya de nou",
"Invalid old password" => "Contrasenya antiga invàlida",
// "Invalid request. Expecting channels array" => "Invalid request. Expecting channels array",
// "Missing channel name" => "Missing channel name",
// "Authentication required" => "Authentication required",
// "One of the requested channels cannot be requested. It does not exist or permission is denied" => "One of the requested channels cannot be requested. It does not exist or permission is denied",
// "One of the install profiles could not be obtained" => "One of the install profiles could not be obtained",
// "info" => "info",
// "You will get no errors reported, because error_reporting and display_errors are both turned off. This might be the right thing for a production site, but in case of problems enable these in php.ini to get more information" => "You will get no errors reported, because error_reporting and display_errors are both turned off. This might be the right thing for a production site, but in case of problems enable these in php.ini to get more information",
// "You will get no errors reported although display_errors is On, because the error_reporting level is set to 0. This might be the right thing for a production site, but in case of problems raise the value in php.ini to get more information" => "You will get no errors reported although display_errors is On, because the error_reporting level is set to 0. This might be the right thing for a production site, but in case of problems raise the value in php.ini to get more information",
// "You will get no errors reported, because display_errors is turned off. This might be the right thing for a production site, but in case of problems enable it in php.ini to get more information. Your error_reporting level is decent at '.\$e.'" => "You will get no errors reported, because display_errors is turned off. This might be the right thing for a production site, but in case of problems enable it in php.ini to get more information. Your error_reporting level is decent at '.\$e.'",
// "You will not get all errors reported as your error_reporting level is at '.\$e.'. '.'This is not necessarily a bad thing (and it might be just right for production sites) as you will still get critical errors reported, but sometimes it can be handy to get more information. Check your error_reporting level in php.ini in case of having issues" => "You will not get all errors reported as your error_reporting level is at '.\$e.'. '.'This is not necessarily a bad thing (and it might be just right for production sites) as you will still get critical errors reported, but sometimes it can be handy to get more information. Check your error_reporting level in php.ini in case of having issues",
// "You will get no errors reported although your error_reporting level is all the way up at '.\$e" => "You will get no errors reported although your error_reporting level is all the way up at '.\$e",
// "You will get all errors reported as your error_reporting level is all the way up at '.\$e.' and display_errors is on. Way to go in case of problems as the error reports usually contain some valuable hints" => "You will get all errors reported as your error_reporting level is all the way up at '.\$e.' and display_errors is on. Way to go in case of problems as the error reports usually contain some valuable hints",
// "good" => "good",
// "ini_set is used in some places to accomodate for special needs of some Tiki features" => "ini_set is used in some places to accomodate for special needs of some Tiki features",
// "ugly" => "ugly",
// "ini_set is used in some places to accomodate for special needs of some Tiki features. Check disable_functions in your php.ini" => "ini_set is used in some places to accomodate for special needs of some Tiki features. Check disable_functions in your php.ini",
// "The PDO extension is the suggested database driver/abstraction layer" => "The PDO extension is the suggested database driver/abstraction layer",
// "You do not have the recommended PDO database driver/abstraction layer. You do have the MySQLi driver though, so we will to fall back to the AdoDB abstraction layer that is bundled with Tiki" => "You do not have the recommended PDO database driver/abstraction layer. You do have the MySQLi driver though, so we will to fall back to the AdoDB abstraction layer that is bundled with Tiki",
// "You do not have the recommended PDO database driver/abstraction layer. You do have the MySQL driver though, so we will to fall back to the AdoDB abstraction layer that is bundled with Tiki" => "You do not have the recommended PDO database driver/abstraction layer. You do have the MySQL driver though, so we will to fall back to the AdoDB abstraction layer that is bundled with Tiki",
// "bad" => "bad",
// "You do not have any of the supported database drivers (PDO/mysqli/mysql) loaded. Tiki will not work" => "You do not have any of the supported database drivers (PDO/mysqli/mysql) loaded. Tiki will not work",
// "N/A" => "N/A",
// "You have less than 200 megs of free disk space. Tiki will not fit on this disk drive" => "You have less than 200 megs of free disk space. Tiki will not fit on this disk drive",
// "You have less than 250 megs of free disk space. This is quite tight. Tiki needs disk space for compiling templates and for uploading files" => "You have less than 250 megs of free disk space. This is quite tight. Tiki needs disk space for compiling templates and for uploading files",
// "When the disk runs full you will not be able to log into your Tiki any more" => "When the disk runs full you will not be able to log into your Tiki any more",
// "We can not reliably check for quotas, so be warned that if your server makes use of them you might have less disk space available" => "We can not reliably check for quotas, so be warned that if your server makes use of them you might have less disk space available",
// "You have more than 251 megs of free disk space. Tiki will run nicely, but you may run into issues when your site grows (e.g. file uploads)" => "You have more than 251 megs of free disk space. Tiki will run nicely, but you may run into issues when your site grows (e.g. file uploads)",
// "The PHP function disk_free_space is not available on your server, so we can't check for this" => "The PHP function disk_free_space is not available on your server, so we can't check for this",
// "You are running PHP as CGI. Feel free to use a threaded Apache MPM to increase performance" => "You are running PHP as CGI. Feel free to use a threaded Apache MPM to increase performance",
// "You are running PHP using FPM (Fastcgi Process Manager). Feel free to use a threaded Apache MPM to increase performance" => "You are running PHP using FPM (Fastcgi Process Manager). Feel free to use a threaded Apache MPM to increase performance",
// "You are not running PHP as CGI. Be aware that PHP is not thread-safe and you should not use a threaded Apache MPM (like worker)" => "You are not running PHP as CGI. Be aware that PHP is not thread-safe and you should not use a threaded Apache MPM (like worker)",
// "You are using APC as your ByteCode Cache which increases performance, if correctly configured. See Admin->Performance in your Tiki for more details" => "You are using APC as your ByteCode Cache which increases performance, if correctly configured. See Admin->Performance in your Tiki for more details",
// "You are using xCache as your ByteCode Cache which increases performance, if correctly configured. See Admin->Performance in your Tiki for more details" => "You are using xCache as your ByteCode Cache which increases performance, if correctly configured. See Admin->Performance in your Tiki for more details",
// "You are using WinCache as your ByteCode Cache which increases performance, if correctly configured. See Admin->Performance in your Tiki for more details" => "You are using WinCache as your ByteCode Cache which increases performance, if correctly configured. See Admin->Performance in your Tiki for more details",
// "You are using WinCache as your ByteCode Cache, but you do not seem to use the required CGI/FastCGI server API" => "You are using WinCache as your ByteCode Cache, but you do not seem to use the required CGI/FastCGI server API",
// "You are using neither APC, WinCache nor xCache as your ByteCode Cache which would increase performance, if correctly configured. See Admin->Performance in your Tiki for more details" => "You are using neither APC, WinCache nor xCache as your ByteCode Cache which would increase performance, if correctly configured. See Admin->Performance in your Tiki for more details",
// "You are using neither APC nor xCache as your ByteCode Cache which would increase performance, if correctly configured. See Admin->Performance in your Tiki for more details" => "You are using neither APC nor xCache as your ByteCode Cache which would increase performance, if correctly configured. See Admin->Performance in your Tiki for more details",
// "Your memory_limit is at" => "Your memory_limit is at",
// "This is known to behave well even for bigger sites" => "This is known to behave well even for bigger sites",
// "This will normally work, but you might run into problems when your site grows" => "This will normally work, but you might run into problems when your site grows",
// "This is known to cause issues! You should raise your memory_limit to at least 128M, which is the default of PHP" => "This is known to cause issues! You should raise your memory_limit to at least 128M, which is the default of PHP",
// "Your session.save_handler must be set to 'files'" => "Your session.save_handler must be set to 'files'",
// "Well set! the default setting of 'files' is needed for Tiki" => "Well set! the default setting of 'files' is needed for Tiki",
// "You have zlib output compression turned on. This saves bandwidth. Turning it off would in turn reduce CPU usage. Choose your poison" => "You have zlib output compression turned on. This saves bandwidth. Turning it off would in turn reduce CPU usage. Choose your poison",
// "You have zlib output compression turned off. This reduces CPU usage. Turning it on would in turn save bandwidth. Choose your poison" => "You have zlib output compression turned off. This reduces CPU usage. Turning it on would in turn save bandwidth. Choose your poison",
// "register_globals should be off by default. See the PHP manual for details" => "register_globals should be off by default. See the PHP manual for details",
// "Well set! And you are future proof also as register_globals is deprecated" => "Well set! And you are future proof also as register_globals is deprecated",
// "safe_mode is deprecated and should be off by default. See the <a href=\"http://www.php.net/manual/de/features.safe-mode.php\">PHP manual</a> for details" => "safe_mode is deprecated and should be off by default. See the <a href=\"http://www.php.net/manual/de/features.safe-mode.php\">PHP manual</a> for details",
// "Well set! And you are future proof also as safe_mode is deprecated" => "Well set! And you are future proof also as safe_mode is deprecated",
// "Some features like assigning perms to a group with a name containing a quote will not work with this being on. magic_quotes_gpc is also deprecated and should be off by default. See the PHP manual for details. You may experience weird behaviour of your Tiki" => "Some features like assigning perms to a group with a name containing a quote will not work with this being on. magic_quotes_gpc is also deprecated and should be off by default. See the PHP manual for details. You may experience weird behaviour of your Tiki",
// "Well set! Some features like assigning perms to a group with a name containing a quote will not work with this being on. And you are future proof also as magic_quotes_gpc is deprecated" => "Well set! Some features like assigning perms to a group with a name containing a quote will not work with this being on. And you are future proof also as magic_quotes_gpc is deprecated",
// "Well set! Tiki is fully UTF-8 and so should your installation be" => "Well set! Tiki is fully UTF-8 and so should your installation be",
// "default_charset should be UTF-8 as Tiki is fully UTF-8. Please check your php.ini" => "default_charset should be UTF-8 as Tiki is fully UTF-8. Please check your php.ini",
// "You have no timezone set! While there are a lot of fallbacks in PHP to determine the timezone, the only reliable solution is to set it explicitly in php.ini! Please check the value of date.timezone in php.ini" => "You have no timezone set! While there are a lot of fallbacks in PHP to determine the timezone, the only reliable solution is to set it explicitly in php.ini! Please check the value of date.timezone in php.ini",
// "Well done! Having a timezone set protects you from many weird errors" => "Well done! Having a timezone set protects you from many weird errors",
// "You can upload files to your Tiki" => "You can upload files to your Tiki",
// "You will not be able to upload any files to your Tiki" => "You will not be able to upload any files to your Tiki",
// "Your max_execution_time is at" => "Your max_execution_time is at",
// "This is a good value for production sites. If you experience timeouts (such as when performing admin functions) you may need to increase this nevertheless" => "This is a good value for production sites. If you experience timeouts (such as when performing admin functions) you may need to increase this nevertheless",
// "Your max_execution_time is unlimited" => "Your max_execution_time is unlimited",
// "This is not necessarily bad, but it's a good idea to limit this time on productions servers in order to eliminate unexpectedly long running scripts" => "This is not necessarily bad, but it's a good idea to limit this time on productions servers in order to eliminate unexpectedly long running scripts",
// "It is likely that some scripts, e.g. admin functions will not finish in this time! You should raise your max_execution_time to at least 30s" => "It is likely that some scripts, e.g. admin functions will not finish in this time! You should raise your max_execution_time to at least 30s",
// "Your max_input_time is at" => "Your max_input_time is at",
// "Your max_input_time is unlimited" => "Your max_input_time is unlimited",
// "It is likely that some scripts, e.g. admin functions will not finish in this time! You should raise your max_input_time to at least 30 seconds" => "It is likely that some scripts, e.g. admin functions will not finish in this time! You should raise your max_input_time to at least 30 seconds",
// "Your upload_max_filesize is at" => "Your upload_max_filesize is at",
// "You can upload quite big files, but keep in mind to set your script timeouts accordingly" => "You can upload quite big files, but keep in mind to set your script timeouts accordingly",
// "Nothing wrong with that, but some users might want to upload something bigger" => "Nothing wrong with that, but some users might want to upload something bigger",
// "Your post_max_size is at" => "Your post_max_size is at",
// "The GD extension is needed for manipulation of images, e.g. also for CAPTCHAs" => "The GD extension is needed for manipulation of images, e.g. also for CAPTCHAs",
// "The GD extension is loaded, and Tiki can create images, but the FreeType extension is needed for CAPTCHA text generation" => "The GD extension is loaded, and Tiki can create images, but the FreeType extension is needed for CAPTCHA text generation",
// "The GD extension is loaded, but Tiki is unable to create images. Please check your GD library configuration" => "The GD extension is loaded, but Tiki is unable to create images. Please check your GD library configuration",
// "ImageMagick is used as a fallback in case that GD is not available" => "ImageMagick is used as a fallback in case that GD is not available",
// "ImageMagick is available, but unable to create images. Please check your ImageMagick configuration" => "ImageMagick is available, but unable to create images. Please check your ImageMagick configuration",
// "The mbstring extension is needed for an UTF-8 compatible lower case filter in the admin search for example" => "The mbstring extension is needed for an UTF-8 compatible lower case filter in the admin search for example",
// "The mbstring extension is loaded, but mbstring.func_overload = '.' '.\$func_overload.'.'.' '.'Tiki only works with mbsring.func_overload = 0. Please check your php.ini" => "The mbstring extension is loaded, but mbstring.func_overload = '.' '.\$func_overload.'.'.' '.'Tiki only works with mbsring.func_overload = 0. Please check your php.ini",
// "The mbstring extension is loaded, but missing important functions as for example mb_split(). You need to reinstall it with --enable-mbregex or ask your hoster do do it" => "The mbstring extension is loaded, but missing important functions as for example mb_split(). You need to reinstall it with --enable-mbregex or ask your hoster do do it",
// "The mbstring extension is needed for an UTF-8 compatible lower case filter" => "The mbstring extension is needed for an UTF-8 compatible lower case filter",
// "calendar extension is needed by Tiki" => "calendar extension is needed by Tiki",
// "You will not be able to use the calendar feature of Tiki" => "You will not be able to use the calendar feature of Tiki",
// "ctype extension is needed by Tiki" => "ctype extension is needed by Tiki",
// "This extension is needed for WebDAV" => "This extension is needed for WebDAV",
// "This extension is needed to connect your Tiki to an LDAP server. More info at: http://doc.tiki.org/LDAP " => "This extension is needed to connect your Tiki to an LDAP server. More info at: http://doc.tiki.org/LDAP ",
// "You will not be able to connect your Tiki to an LDAP server as the needed PHP extension is missing. More info at: http://doc.tiki.org/LDAP" => "You will not be able to connect your Tiki to an LDAP server as the needed PHP extension is missing. More info at: http://doc.tiki.org/LDAP",
// "This extension can be used to speed up your Tiki by saving sessions as well as wiki and forum data on a memcached server" => "This extension can be used to speed up your Tiki by saving sessions as well as wiki and forum data on a memcached server",
// "This extension is used to interpret SVN information for TortoiseSVN 1.7 or higher" => "This extension is used to interpret SVN information for TortoiseSVN 1.7 or higher",
// "The eval() function is required by the Smarty templating engine" => "The eval() function is required by the Smarty templating engine",
// "You will get \"Please contact support about\" messages instead of modules. eval() is most probably disabled via Suhosin" => "You will get \"Please contact support about\" messages instead of modules. eval() is most probably disabled via Suhosin",
// "The ZipArchive class is needed for features such as XML Wiki Import/Export and PluginArchiveBuilder" => "The ZipArchive class is needed for features such as XML Wiki Import/Export and PluginArchiveBuilder",
// "The DateTime class is needed for the WebDAV feature" => "The DateTime class is needed for the WebDAV feature",
// "Tiki requires MySQL >= 5.x" => "Tiki requires MySQL >= 5.x",
// "Your max_allowed_packet setting is at" => "Your max_allowed_packet setting is at",
// "This limits the size of binary files that can be added to Tiki, when storing files in the database. Please see: <a href=\"http://doc.tiki.org/File+Storage\">file storage</a>" => "This limits the size of binary files that can be added to Tiki, when storing files in the database. Please see: <a href=\"http://doc.tiki.org/File+Storage\">file storage</a>",
// "Tiki is fully UTF-8 and so should every part of your stack be" => "Tiki is fully UTF-8 and so should every part of your stack be",
// "On a fresh install you should have everything set to UTF-8 to not run into any suprises. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>" => "On a fresh install you should have everything set to UTF-8 to not run into any suprises. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>",
// "Tiki is fully UTF-8 and so should every part of your stack be. utf8_unicode_ci is the default collation for Tiki" => "Tiki is fully UTF-8 and so should every part of your stack be. utf8_unicode_ci is the default collation for Tiki",
// "On a fresh install you should have everything set to UTF-8 to not run into any suprises. utf8_unicode_ci is the default collation for Tiki. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>" => "On a fresh install you should have everything set to UTF-8 to not run into any suprises. utf8_unicode_ci is the default collation for Tiki. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>",
// "Your MySQL doesn't log slow queries. If you have performance issues, you might want to enable this, but keep in mind that the logging itself slows MySQL down" => "Your MySQL doesn't log slow queries. If you have performance issues, you might want to enable this, but keep in mind that the logging itself slows MySQL down",
// "Your MySQL logs slow queries. If you don't have performance issues, you should disable this on a production site as it slows MySQL down" => "Your MySQL logs slow queries. If you don't have performance issues, you should disable this on a production site as it slows MySQL down",
// "Tiki needs this module for Search Engine Friendly URLs via .htaccess. We can't check though, if your web server respects configurations made in .htaccess. For further information go to Admin->SefURL in your Tiki" => "Tiki needs this module for Search Engine Friendly URLs via .htaccess. We can't check though, if your web server respects configurations made in .htaccess. For further information go to Admin->SefURL in your Tiki",
// "Tiki needs this module for Search Engine Friendly URLs. For further information go to Admin->SefURL in your Tiki" => "Tiki needs this module for Search Engine Friendly URLs. For further information go to Admin->SefURL in your Tiki",
// "Your RewriteBase is set correctly in .htaccess. Search Engine Friendly URLs should work. Beware though that we can't check if Apache really loads .htaccess" => "Your RewriteBase is set correctly in .htaccess. Search Engine Friendly URLs should work. Beware though that we can't check if Apache really loads .htaccess",
// "Your RewriteBase is not set correctly in .htaccess. Search Engine Friendly URLs are not going to work like that. It should be set to \"" => "Your RewriteBase is not set correctly in .htaccess. Search Engine Friendly URLs are not going to work like that. It should be set to \"",
// "You haven't activated .htaccess. So this check is useless. If you want to use Search Engine Friendly URLs, you will have to activate .htaccess by copying _htaccess into its place (or a symlink if supported by your Operating System). Then come back to have a look at this check again" => "You haven't activated .htaccess. So this check is useless. If you want to use Search Engine Friendly URLs, you will have to activate .htaccess by copying _htaccess into its place (or a symlink if supported by your Operating System). Then come back to have a look at this check again",
// "With this module you can set the HTTP Expires header and therefore increase performance. We can't check though, if mod_expires is configured correctly" => "With this module you can set the HTTP Expires header and therefore increase performance. We can't check though, if mod_expires is configured correctly",
// "With this module you can set the HTTP Expires header and therefore increase performance. Once you install it, you still need to configure it correctly" => "With this module you can set the HTTP Expires header and therefore increase performance. Once you install it, you still need to configure it correctly",
// "With this module you can compress the data your webserver sends out and therefore decrease used bandwidth and increase performance. We can't check though, if mod_deflate is configured correctly" => "With this module you can compress the data your webserver sends out and therefore decrease used bandwidth and increase performance. We can't check though, if mod_deflate is configured correctly",
// "With this module you can compress the data your webserver sends out and therefore decrease used bandwidth and increase performance. Once you install it, you still need to configure it correctly" => "With this module you can compress the data your webserver sends out and therefore decrease used bandwidth and increase performance. Once you install it, you still need to configure it correctly",
// "This module can increase security of your Tiki and therefore your server, but be warned that it is very tricky to configure it correctly. A misconfiguration can lead to failed page saves or other hard to trace bugs" => "This module can increase security of your Tiki and therefore your server, but be warned that it is very tricky to configure it correctly. A misconfiguration can lead to failed page saves or other hard to trace bugs",
// "The URL Rewrite Module is required to use SEFURL on IIS" => "The URL Rewrite Module is required to use SEFURL on IIS",
// "upload_tmp_dir is probably within your Tiki directory. There is a risk that someone can upload any file to this directory and access them via web browser" => "upload_tmp_dir is probably within your Tiki directory. There is a risk that someone can upload any file to this directory and access them via web browser",
// "Can't reliably determine, if your upload_tmp_dir is accessible via a web browser. To make sure you should check your webserver config" => "Can't reliably determine, if your upload_tmp_dir is accessible via a web browser. To make sure you should check your webserver config",
"register_globals should be off by default. See the php manual for details." => "el paràmetre register_globals hauria d'estar com a desactivat (off) per defecte. Mira el manual de php per més detalls.",
"safe" => "segur",
// "WebKit is enabled" => "WebKit is enabled",
// "Blogs is enabled" => "Blogs is enabled",
// "Exec can potentially be used to execute arbitrary code on your server" => "Exec can potentially be used to execute arbitrary code on your server",
// "Tiki does not need it, you may want to disable it" => "Tiki does not need it, you may want to disable it",
// "Exec can be potentially be used to execute arbitrary code on your server" => "Exec can be potentially be used to execute arbitrary code on your server",
// "Tiki does not need it, you are wise to have it disabled" => "Tiki does not need it, you are wise to have it disabled",
// "Passthru is similar to exec" => "Passthru is similar to exec",
// "Shell_exec is similar to exec" => "Shell_exec is similar to exec",
// "Tiki needs it to run PDF from URL: WebKit (wkhtmltopdf). '.\$pdf_webkit.'If you need this and trust the other PHP software on your server, you should enable it" => "Tiki needs it to run PDF from URL: WebKit (wkhtmltopdf). '.\$pdf_webkit.'If you need this and trust the other PHP software on your server, you should enable it",
// "System is similar to exec" => "System is similar to exec",
// "Proc_open is similar to exec" => "Proc_open is similar to exec",
// "Curl_exec can potentially be abused to write malicious code" => "Curl_exec can potentially be abused to write malicious code",
// "Tiki needs it to run features like Kaltura, CAS login, CClite and the myspace and sf wiki-plugins. If you need these and trust the other PHP software on your server, you should enable it" => "Tiki needs it to run features like Kaltura, CAS login, CClite and the myspace and sf wiki-plugins. If you need these and trust the other PHP software on your server, you should enable it",
// "Curl_multi_exec can potentially be abused to write malicious code" => "Curl_multi_exec can potentially be abused to write malicious code",
// "It is probably an urban myth that this is dangerous. Tiki team will reconsider this check, but be warned" => "It is probably an urban myth that this is dangerous. Tiki team will reconsider this check, but be warned",
"risky" => "arriscat",
"session.use_trans_sid should be off by default. See the php manual for details." => "el paràmetre session.use_trans_sid hauria d'estar com a desactivat (off) per defecte. Mira el manual de php per més detalls.",
// "setting the xbithack option is unsafe. Depending on the file handling of your webserver and your tiki settings, it may be possible that an attacker can upload scripts to file gallery and execute them" => "setting the xbithack option is unsafe. Depending on the file handling of your webserver and your tiki settings, it may be possible that an attacker can upload scripts to file gallery and execute them",
// "allow_url_fopen may potentially be used to upload remote data or scripts. '.\$feature_blogs.'If you dont use the blog feature, you can switch it off" => "allow_url_fopen may potentially be used to upload remote data or scripts. '.\$feature_blogs.'If you dont use the blog feature, you can switch it off",
// "Test mail from Tiki Server Compatibility Test" => "Test mail from Tiki Server Compatibility Test",
// "We were able to send an e-mail. This only means that a mail server accepted the mail for delivery. We don't know, if that server really delivers the mail. Please check the inbox of '.\$_POST['email_test_to'].' to see, if the delivery really works" => "We were able to send an e-mail. This only means that a mail server accepted the mail for delivery. We don't know, if that server really delivers the mail. Please check the inbox of '.\$_POST['email_test_to'].' to see, if the delivery really works",
// "We were not able to send an e-mail. It may be that there is no mail server installed on this machine or that it is badly configured. If you absolutely can't get the local mail server to work, you can setup a regular mail account and set SMTP settings in tiki-admin.php" => "We were not able to send an e-mail. It may be that there is no mail server installed on this machine or that it is badly configured. If you absolutely can't get the local mail server to work, you can setup a regular mail account and set SMTP settings in tiki-admin.php",
// "The fileinfo extension is needed for the 'Validate uploaded file content' preference" => "The fileinfo extension is needed for the 'Validate uploaded file content' preference",
"Top authors" => "Els autors més actius",
"Problem. Try to log in again to receive new confirmation instructions." => "Problema. Prova de connectar-te de nou per rebre noves intruccions de confirmació.",
// "You must include a subject or a message" => "You must include a subject or a message",
// "You must make sure to have a valid e-mail address in the From field" => "You must make sure to have a valid e-mail address in the From field",
// "%0 sent you a message" => "%0 sent you a message",
"last version" => "última versió",
"Cannot rename page because the new name begins with reserved prefix" => "No es pot reanomenar la pàgina perquè el nom nou comença amb un prefix reservat",
// "Cannot copy page because maybe new page name already exists" => "Cannot copy page because maybe new page name already exists",
// "TikiHelp WebHelp generation engine. Generating WebHelp using" => "TikiHelp WebHelp generation engine. Generating WebHelp using",
// "Eliminating previous files" => "Eliminating previous files",
// "Index: <strong>%0</strong>" => "Index: <strong>%0</strong>",
// "Directory: <strong>%0</strong>" => "Directory: <strong>%0</strong>",
"You need to change chmod 'whelp' manually to 777" => "Necessites canviar via chmod 'whelp' manualment a 777",
// "Creating directory structure in <strong>%0</strong>" => "Creating directory structure in <strong>%0</strong>",
// "Submit a new link" => "Submit a new link",
"Must enter a name to add a site. " => "Has d'afegir un nom per afegir un nou lloc. ",
"Must enter a url to add a site. " => "Has d'afegir una url per afegir un nou lloc. ",
"URL already added to the directory. Duplicate site? " => "L'URL ja ha estat afegida al directori. Lloc duplicat? ",
"URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. " => "No es pot accedir a l'URL (URL errònia or el lloc està fora de línea i no pot ser afegit al directori). ",
"Must select a category. " => "Has de seleccionar una categoria. ",
"Must enter a name to add a site" => "Has d'escriure un nom per a la web a afegir",
"Must enter a url to add a site" => "Has d'escriure una dreça URL per a afegir una web",
"URL already added to the directory. Duplicate site?" => "L'URL ja ha estat afegida al directori. Lloc duplicat?",
"URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory" => "No es pot accedir a l'URL (URL errònia or el lloc està fora de línea i no pot ser afegit al directori)",
"Admin Directory" => "Administrar directori",
"Must select a category" => "Has d'escollir una categoria",
"Browse Directory" => "Explorar directori",
// "How to use Directory" => "How to use Directory",
"No site indicated" => "No s'ha indicat cap lloc",
// "This feature is disabled: %0" => "This feature is disabled: %0",
"No parent specified" => "No s'ha especificat cap pare",
// "Last sites of directory %0" => "Last sites of directory %0",
// "Discount code already exists" => "Discount code already exists",
// "File has been deleted" => "File has been deleted",
// "You cannot download this file right now. Your score is low or file limit was reached" => "You cannot download this file right now. Your score is low or file limit was reached",
"Error : The file %s doesn't exist." => "Error: El fitxer %s no existeix.",
"Article not found" => "Article no trobat",
"You do not have permission to edit this article" => "No té permís per editar l'article",
"Invalid email:" => "Correu Invàlid:",
"The language can't be changed as its set of translations has already this language" => "No es pot canviar a aquest idioma per que el conjunt de traduccions ja té aquest idioma",
"Banner not found" => "No s'ha trobat banner",
"You do not have permission to edit this banner" => "No teniu permís per editar aquest banner",
"You do not have permission to edit this blog" => "Permís denegat per editar aquest bloc",
// "Incorrect name" => "Incorrect name",
"You do not have permission to write the style sheet" => "No teniu permís per escriure al full d'estil",
// "Wrong file type, expected %0" => "Wrong file type, expected %0",
// "You do not have permission to view/edit this file" => "You do not have permission to view/edit this file",
// "New Svg Image" => "New Svg Image",
"Invalid request to edit an image" => "La petició per editar la imatge no és vàlida",
"You have permission to edit images but not in this gallery" => "No estàs autoritzat per editar imatges en aquesta galeria",
"Failed to edit the image" => "s'ha produït un error en editar la imatge",
// "Wrote %d new strings and updated %d to lang/%s/language.php" => "Wrote %d new strings and updated %d to lang/%s/language.php",
// "Edit Perspectives" => "Edit Perspectives",
"No content id indicated" => "Cap id de contingut especificat",
"No question indicated" => "No s'ha indicat cap pregunta",
"No quiz indicated" => "No has indicat cap test",
"No structure indicated" => "No s'ha indicat cap estructura",
"Invalid structure_id or page_ref_id" => "Estructura Invàlida o referència invàlida",
"You do not have permission to edit submissions" => "Permís denegat per editar col·laboracions",
"You have to create a topic first" => "Has de crear un tòpic primer",
// "Template directory %0 unknown" => "Template directory %0 unknown",
"You do not have permission to do that" => "No teniu permís per fer això",
"You do not have permission to write the template:" => "No teniu permís per escriure la plantilla:",
"You do not have permission to read the template" => "No teniu permís per llegir la plantilla",
"No topic id specified" => "No s'ha especificat cap id de tema",
"Invalid topic id specified" => "Tema Invàlid",
"No object indicated" => "No s'ha indicat cap objecte",
// "Only wiki pages are supported" => "Only wiki pages are supported",
"Not enable for this type of object" => "No està habilitat per aquest tipus d'objecte",
"Override lock and carry on with edit" => "Ignora el bloqueig i continua per editar",
"Page is currently being edited" => "La pàgina està essent editada en aquest moment",
"page imported" => "pàgina importada",
"created from import" => "creada des de l'importació",
// "Describe the change you made" => "Describe the change you made",
// "This page is being edited by %0. Please check with the user before editing the page,\totherwise the changes will be stored as two separate versions in the history and you will have to manually merge them later" => "This page is being edited by %0. Please check with the user before editing the page,\totherwise the changes will be stored as two separate versions in the history and you will have to manually merge them later",
"Can't import remote HTML page" => "No es pot importar la pàgina HTML remota",
"The SandBox is disabled" => "El LlocdeProves està deshabilitat",
"Cannot edit page because it is locked" => "No es pot editar la pàgina perquè està bloquejada",
"Page already exists. Go back and choose a different name." => "La pàgina ja existeix. Ves enrere i escull un nom diferent.",
// "Page name is" => "Page name is",
"The translation set already contains a page in this language." => "El conjunt de traducció ja conté una pàgina en aquest idioma.",
// "Can not open the file" => "Can not open the file",
// "Problem zip initialisation" => "Problem zip initialisation",
// "Problem zip" => "Problem zip",
// "Another user is currently exporting that tracker, please try again later" => "Another user is currently exporting that tracker, please try again later",
"No questions group indicated" => "No s'ha indicat cap grup de preguntes",
// "Remove archive: " => "Remove archive: ",
// "Remove file gallery: " => "Remove file gallery: ",
"Top visited file galleries" => "Les galeries de fitxers més visitades",
"Most downloaded files" => "Arxius més descarregats",
"Last files" => "Els últims fitxers",
"No galleryId specified" => "No s'ha especificat el galleryId",
"Form error - no import method selected for some reason." => "Error de formulari-bd html - no s'ha seleccionat cap mètode d'importació per alguna raó.",
"Form error - no server-side filename entered for selected import method." => "Error de formulari-bd html - no s'ha introduït cap nom d'arxiu al costat del servidor per al mètode d'importaicó seleccionat.",
"No forum indicated" => "No s'ha indicat cap fòrum",
"Last forum topics" => "Últims temes en fòrums",
// "Last replied forum topics" => "Last replied forum topics",
// "Most-Read Forum Topics" => "Most-Read Forum Topics",
"Top topics" => "Temes principals",
"Forum posts" => "Escrits del Fòrum",
// "Most-Visited Forums" => "Most-Visited Forums",
"No forumId specified" => "No s'ha especificat el fòrumId",
"List Forums" => "Llista Fòrums",
// "Not supported yet" => "Not supported yet",
"Accepted friendship request from %s" => "Petició d'inclusió a la xarxa d'amistat de %s acceptada",
"Refused friendship request from %s" => "Petició d'inclusió a la xarxa d'amistat de %s rebutjada",
// "Canceled friendship request with %s" => "Canceled friendship request with %s",
"Broke friendship with %s" => "Elimina de la teva xarxa d'amistat a %s",
"I have broken our friendship!" => "He trencat la teva inclusió a la meva xarxa d'amistat en aquesta web!",
"Friendship request sent to %s" => "Petició d'inclusió a la seva xarxa d'amistat enviada a %s",
"You're already friend of %s" => "Ja ets amic/ga de %s",
"I have accepted your friendship request!" => "He acceptat la teva petició d'inclusió a la meva xarxa d'amistat!",
"I have refused your friendship request" => "He rebutjat la teva petició d'amistat",
"I have canceled my friendship request" => "He cancel·lat la teva petició d'amistat",
"first uploaded image" => "primera imatge pujada",
"last uploaded image" => "última imatge pujada",
"first image" => "primera imatge",
"last image" => "La última imatge",
"random image" => "imatge aleatòria",
"You do not have permission to create galleries and so you cannot edit them" => "Permís denegat, no podeu crear galeries ni editar-les",
"You do not have permission to edit this gallery" => "Permís denegat, no podeu editar aquesta galeria",
"You do not have permission to remove this gallery" => "Permís denagat, no podeu eliminar aquesta galeria",
"You do not have permission to make the map of this gallery" => "Permís denegat, no pots fer el mapa d'aquesta galeria",
"Top images" => "Les imatges més emprades",
"Last images" => "Les últimes imatges",
"Back to item" => "Torna a l'ítem",
"No valid renderer found. GD or PDFLib required." => "No s'ha trobat un renderitzador vàlid. Es requereix un GD o PDFLib.",
"No sheet specified." => "No s'ha especificat cap full.",
"You must select a renderer." => "Has de seleccionar un renderitzador.",
"Invalid Series for current graphic." => "Sèrie no vàlida per al gràfic actual.",
"overwriting old page" => "Reescriure la pàgina antiga",
"updated from structured text import" => "actualitzat amb la importació de text estructurada",
"page created" => "pàgina creada",
"created from structured text import" => "creat a partir de la importació de text estructurat",
// "Operations executed successfully" => "Operations executed successfully",
// "Invalid software name" => "Invalid software name",
"No name indicated for wiki page" => "No s'ha indicat cap nom per la pàgina wiki",
// "This version does not exist" => "This version does not exist",
"There is more than one item in the tracker with this title" => "Hi ha més d'un ítem al tracker (base de dades) amb aquest títol",
"There are no items in the tracker with this title" => "No hi ha cap ítem al tracker amb aquest títol",
"Page saved (version %d)" => "Pàgina desada (versió %d)",
// "You have requested that this page be machine translated" => "You have requested that this page be machine translated",
// "However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it" => "However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it",
"No repository given" => "Cap dipòsit indicat",
"This invitation does not exist or is deprecated" => "Aquesta invitació no existeix o està caducada",
"Congratulations! You are now part of this invitation group(s)" => "Felicitats! Ara ja ets part d'aquest grup(s) convidat(s)",
// "Upload Media" => "Upload Media",
// "Communication error" => "Communication error",
// "Invalid response provided by the Kaltura server. Please retry" => "Invalid response provided by the Kaltura server. Please retry",
// "Are you sure you want to permanently remove the article with identifier %0" => "Are you sure you want to permanently remove the article with identifier %0",
// "Are you sure you want to permanently remove these %0 articles" => "Are you sure you want to permanently remove these %0 articles",
"You do not have permission to remove articles" => "No té permís per eliminar l'article",
"You do not have permission to remove banners" => "No té autorització per eliminar banners",
// "List Blog Posts" => "List Blog Posts",
"You do not have permission to remove this blog" => "Permís denegat per traslladar aquest bloc",
// "You do not have permission to view the comments for this blog" => "You do not have permission to view the comments for this blog",
// "Delete comments" => "Delete comments",
// "Approved Status" => "Approved Status",
// "Queued" => "Queued",
"This blog has no posts" => "Aquest bloc no té publicacions",
// "Dynamic content" => "Dynamic content",
// "Admin FAQs" => "Admin FAQs",
"Non-existent gallery" => "Aquesta galeria no existeix",
// "You do not have permission to view this gallery" => "You do not have permission to view this gallery",
// "The file is already locked by %s" => "The file is already locked by %s",
// "Permission denied you cannot validate files from this gallery" => "Permission denied you cannot validate files from this gallery",
// "Validate draft: " => "Validate draft: ",
// "Quota too big" => "Quota too big",
// "Quota too small" => "Quota too small",
"You have permission to upload files but not to this file gallery" => "Premís denegat, no podeu pujar fitxers a aquesta galeria",
// "Not modified since" => "Not modified since",
// "Not downloaded since" => "Not downloaded since",
"You do not have permission to upload files so you cannot edit them" => "Permís denegat, no podeu pujar fitxers i per tant no podeu editar-los",
"This gallery does not exist" => "Aquesta galeria no existeix",
// "List Entries" => "List Entries",
// "Error importing" => "Error importing",
// "Error converting" => "Error converting",
// "Importing" => "Importing",
// "Processing" => "Processing",
// "Ready" => "Ready",
// "Pending moderation" => "Pending moderation",
// "Blocked" => "Blocked",
// "Invalid action" => "Invalid action",
// "Remove permission %0 from %1" => "Remove permission %0 from %1",
// "Assign permission %0 to %1" => "Assign permission %0 to %1",
// "Delete posts" => "Delete posts",
// "View submissions" => "View submissions",
// "Are you sure you want to permanently remove the submitted article with identifier %0" => "Are you sure you want to permanently remove the submitted article with identifier %0",
// "Are you sure you want to permanently remove these %0 submitted articles" => "Are you sure you want to permanently remove these %0 submitted articles",
// "Are you sure you want to approve these %0 submitted articles" => "Are you sure you want to approve these %0 submitted articles",
// "Are you sure you want to remove the %0 selected pages" => "Are you sure you want to remove the %0 selected pages",
// "Are you sure you want to print the %0 selected pages" => "Are you sure you want to print the %0 selected pages",
// "Are you sure you want to unlock the %0 selected pages" => "Are you sure you want to unlock the %0 selected pages",
// "Are you sure you want to lock the %0 selected pages" => "Are you sure you want to lock the %0 selected pages",
// "Are you sure you want to download a zip of the %0 selected pages" => "Are you sure you want to download a zip of the %0 selected pages",
// "Are you sure you want to modify the %0 pages" => "Are you sure you want to modify the %0 pages",
// "No history will be created" => "No history will be created",
// "You are neither an administrator nor an operator of live support" => "You are neither an administrator nor an operator of live support",
"Username field cannot be empty. Please go back and try again" => "El camp d'usuari no pot quedar en blanc. Si us plau, torna enrere i prova de nou",
"Unable to contact remote server." => "No es pot contactar amb el servidor remot.",
"XMLRPC Error: " => "Error XMLRPC: ",
"Unable to create login" => "Incapaç de crear el compte (login)",
"More than %d unsuccessful login attempts have been made." => "S'han produït més de %d intents de connexió sense èxit.",
"Your account has been suspended" => "S'ha suspès (al menys temporalment) el teu compte",
"A site administrator will reactivate it" => "Caldrà que una persona administradora del lloc la reactivi de nou",
"An email has been sent to you with the instructions to follow." => "Se t'ha enviat un correu-e amb instruccions a seguir.",
"Account disabled" => "Compte desactivat",
"You did not validate your account" => "Encara no has validat el teu compte",
"Resend" => "Torna a enviar-ho",
"You should have received an email. Check your mailbox and your spam box. Otherwise click on the button to resend the email" => "Hauries d'haver rebut un correu-e. Comprova la teva bústia de correu-e i correu no desitjat. Si no, clica sobre el botó de sota per a tornar a enviar el correu-e",
"You must use the right case for your user name" => "Has d'emprar exactament les majúscules i minúscules del teu nom d'usuari",
"You are not yet validated" => "Encara no estàs validat",
"The mail can't be sent. Contact the administrator" => "El missatge no es pot enviar. Contacta l'administrador",
"Your default nickname is already in use. A new one has to be selected." => "El teu nom d'usuari per defecte ja està en ús. Has d'escollir-ne un altre.",
"Verification cancelled" => "S'ha cancel·lat la verificació",
"The selected account is not associated with your identity." => "El compte seleccionat no està associat amb la teva identitat.",
"unknown action" => "acció no coneguda",
"Authentication method is not OpenID" => "El mètode d'autenticació no és OpenID",
// "Authentication error; probably not a valid OpenID" => "Authentication error; probably not a valid OpenID",
// "Could not redirect to server: " => "Could not redirect to server: ",
// "OpenID authentication failed: " => "OpenID authentication failed: ",
// "You have already validated your account. Please log in" => "You have already validated your account. Please log in",
"Tiki mail-in auto-reply" => "Autoresposta de correu-dins del Tiki",
"Sorry, you can't use this feature." => "Disculpa, no pots fer servir aquesta funcionalitat.",
// "You must first setup MapServer" => "You must first setup MapServer",
// "invalid mapfile name" => "invalid mapfile name",
// "An error as occurred with the mapfile" => "An error as occurred with the mapfile",
"edit" => "editar",
// "Please create a directory named %0 to hold your map files" => "Please create a directory named %0 to hold your map files",
"Maps feature is not correctly setup : Maps path is missing." => "L'opció de mapes no està correctament configurada: la ruta dels Mapes falta.",
"mapfile name incorrect" => "Nom de mapfile incorrecte",
"This mapfile already exists" => "Aquest fitxer de mapa ja existeix",
"You do not have permission to write to the mapfile" => "No tens permisos per escriure en el fitxer de mapes",
"You do not have permission to delete the mapfile" => "No tens permisos per esborrar el fitxer de mapes",
"I could not make a copy" => "No es pot fer una copia",
"You do not have permission to read the mapfile" => "No tens permisos per llegir el fitxer de mapes",
// "map edit" => "map edit",
"You dont have permission to do that" => "No tens permís per fer això",
"Tiki RSS feed for maps" => "Alimentació RSS del Tiki per als mapes",
"List of maps available." => "Llista de mapes existents.",
"Layer Management" => "Controlant capes",
"The Directory is not empty" => "El directori no està buit",
"Invalid file name" => "Nom d'arxiu Invàlid",
"Invalid files to index" => "Invàlids arxius a indexar",
"I do not know where is gdaltindex. Set correctly the Map feature" => "No sé on està el gdaltindex. Configura correctament el Mapa",
"I could not create the index file" => "No puc crear el fitxer d'index",
// " to " => " to ",
// "No page provided" => "No page provided",
"You need to run setup.sh :<br />./setup.sh \$APACHEUSER all<br />Common Apache users are www-data, apache or nobody" => "Has d'executar setup.sh :<br />./setup.sh \$APACHEUSER all<br />Usuaris freqüents de l'Apache són www-data, apache o nobody",
"Your PHP installation does not have zlib enabled." => "La teva instal·lació PHP no té zlib activat.",
"You must log in to use this feature" => "Heu d'estar connecta't per emprar aquesta característica",
"MyTiki Home" => "Inici ElmeuTiki",
"You do not have permission to view other users data" => "No tens permís per veure les dades de les altres persones usuàries",
"You must be logged in to subscribe to newsletters" => "Has d'estar connectat per subscriure't a un butlletí",
"No note indicated" => "No s'ha indicat cap nota",
"merged note:" => "nota escapçada:",
"File is too big" => "El fitxer es massa gran",
"No item indicated" => "No s'ha indicat cap ítem",
"Are you sure you want to delete this note" => "Segur que vols eliminar aquesta nota",
"created from notepad" => "creada des del bloc de notes",
// "Note not found" => "Note not found",
"Not enough information to display this page" => "No hi ha suficient informació per mostrar aquesta pàgina",
// "You do not have permission to assign permissions for this object" => "You do not have permission to assign permissions for this object",
// "Are you sure you want to remove the direct permissions from this object" => "Are you sure you want to remove the direct permissions from this object",
// "Are you sure you want paste the copied permissions onto this object" => "Are you sure you want paste the copied permissions onto this object",
// "Manual payment entered" => "Manual payment entered",
// "You do not have permission to enter payment" => "You do not have permission to enter payment",
// "New payment requested" => "New payment requested",
// "Cancel payment %0" => "Cancel payment %0",
// "Payment canceled" => "Payment canceled",
"No article indicated" => "No s'indica un article",
"Article is not published yet" => "L'article no ha estat publicat",
"No post indicated" => "No s'ha indicat cap publicació",
"Blog not found" => "No es troba el bloc",
// "Missing object list type argument" => "Missing object list type argument",
// "Index" => "Index",
// "Index (%0)" => "Index (%0)",
"No pages indicated" => "No s'han indicat les pàgines",
"Multiple Print" => "Impressió Múltiple",
"Pageviews" => "Visualitzacions de pàgines",
"No result indicated" => "No hi ha cap resultat indicat",
"Invalid or unknown username" => "El nom de l'usuari es invàlid o desconegut",
"Unable to send mail. User has not configured email" => "No es pot enviar el mail. L'usuari no té el correu electrònic configurat",
"Please provide a username or email" => "Si us plau, indica el teu nom d'usuari o correu-e",
"Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password." => "Si us plau, contacta a l'Administrador si no reps el correu-e, o si hi ha algun problema en canviar-te la contrasenya.",
"A password reminder email has been sent " => "Un correu-e recordatori de contrasenya ha estat enviat ",
"An email with a link to reset your password has been sent " => "S'ha enviat el correu-e amb l'enllaç per canviar la teva contrasenya ",
"to the email" => "al correu-e",
"to the registered email address for" => "a l'adreça de correu-e registrada per a",
"Non-existent version" => "Aquesta versió no existeix",
// "Tiki RSS Feed Error Message: %0" => "Tiki RSS Feed Error Message: %0",
// "This match was not case sensitive" => "This match was not case sensitive",
"No items selected" => "Cap item seleccionat",
"Page cannot be found: " => "No es pot trobar la pàgina: ",
// "Page has changed since preview: " => "Page has changed since preview: ",
// "Page not updated due to error in replacing: " => "Page not updated due to error in replacing: ",
// "Page updated: " => "Page updated: ",
// "Search Stats" => "Search Stats",
// "%0: Results for \"%1\"" => "%0: Results for \"%1\"",
// "Searchindex" => "Searchindex",
// "A problem occurred during file uploading" => "A problem occurred during file uploading",
// "File which was causing trouble was at rank" => "File which was causing trouble was at rank",
// "The error was" => "The error was",
// "Error: You can't send the same newsletter by refreshing this frame content" => "Error: You can't send the same newsletter by refreshing this frame content",
// "Newsletter successfully sent to %s users" => "Newsletter successfully sent to %s users",
// "There was %s errors" => "There was %s errors",
"No newsletters available." => "No hi ha cap butlletí disponible.",
// "Cannot login to server maybe the server is down" => "Cannot login to server maybe the server is down",
"successfully sent" => "enviat amb èxit",
"not sent" => "no enviat",
"Error: " => "Error: ",
"Send Pages" => "Enviar pàgines",
// "Notice: this variable may not be empty" => "Notice: this variable may not be empty",
"Notice: invalid variable value:" => "Avís: valor de variable no vàlid:",
"Report to the webmaster" => "Informa al mestre Web",
// "Token called" => "Token called",
// "Error sending tweet" => "Error sending tweet",
// "Your link was sent" => "Your link was sent",
// "Your email is mandatory" => "Your email is mandatory",
// "Error sending mail to" => "Error sending mail to",
// "Permission to post in forum denied" => "Permission to post in forum denied",
// "No text given for tweet" => "No text given for tweet",
// "Spreadsheet - " => "Spreadsheet - ",
// "Are you sure you want to delete this spreadsheet" => "Are you sure you want to delete this spreadsheet",
// "You do not have permission to edit messages %0" => "You do not have permission to edit messages %0",
// "Permission denied. You cannot view this page" => "Permission denied. You cannot view this page",
// "Updating Theme.." => "Updating Theme..",
// "Update slideshow theme" => "Update slideshow theme",
"Page must be defined inside a structure to use this feature" => "La Pàgina ha d'estar definida dins una estructura per a fer servir aquesta prestació",
"Username and email are mandatory" => "Es obligatori indicar el nom d'usuari i correu-e",
"Email is invalid" => "El correu-e no és vàlid",
// "Clean the sql logs" => "Clean the sql logs",
// "Are you sure you want to clear all statistics and data for this survey" => "Are you sure you want to clear all statistics and data for this survey",
"You cannot take this quiz twice" => "No pots accedir a aquest test dues vegades",
"Quiz time limit exceeded quiz cannot be computed" => "S'ha excedit el temps límit del qüestionari i no pot ser completat",
"You cannot take this survey twice" => "No pots fer aquesta enquesta dues vegades",
"Please create a category first" => "Si us plau, primer creeu una categoria",
"Committing.." => "Enviant...",
"Could not save" => "No s'ha pogut desar",
"Tracker item:" => "Registre del formulari-bd:",
"No trackerId specified" => "No s'ha especificat cap trackerId",
"Incorrect file gallery" => "Galeria d'arxius errònia",
// "You must lock the file before editing it" => "You must lock the file before editing it",
"Error processing zipped image package" => "Error al processar la imatge comprimida amb zip",
"No permission to upload zipped image packages" => "No hi ha permisos per pujar paquets d'imatges enzipades",
"The uploaded file ist not recognized as a image" => "El fitxer pujat no és reconegut com a imatge",
"You do not have permission to upload images" => "No tens autorització per pujar imatges",
"You have permission to upload images but not to this gallery" => "Tens autorització per penjar imatges, malgrat no en aquesta categoria",
"Cannot get image from URL" => "No s'ha pogut aconseguir la imatge des de la URL",
"That is not an image (or you have php < 4.0.5)" => "Això no es una imatge (o be te php < 4.0.5)",
"Usage" => "Ús",
"TOP" => "MÉS ACTIUS/VES",
"No url indicated" => "No s'ha indicat cap url",
"Unknown user" => "Usuari desconegut",
"Password has been changed" => "S'ha canviat la contrasenya",
// "Invalid password. Your current password is required to change administrative information" => "Invalid password. Your current password is required to change administrative information",
"Email is set to %s" => "El correu-e ha estat canviar a %s",
"The passwords did not match" => "Les contrasenyes no coincideixen",
"If you really want to delete your account, you must check the checkbox" => "Si realment vols esborrar el teu compte, has de seleccionar aquesta casella",
"unicode" => "unicode",
"was moved into trash" => "va ser mogut/da a la paperera",
"trashed by" => "llençat a la paperera per",
"open / in process" => "oberta / en procés",
"Rights by creator" => "Drets per creador",
"END" => "FI",
"Percentage" => "Percentatge",
"Task accepted by creator" => "Tasca acceptada pel creador",
"Task accepted by task user" => "Tasca acceptada per l'usuari de la tasca",
"Task NOT accepted by creator" => "Tasca NO acceptada pel creador",
"Task NOT accepted by task user" => "Tasca NO acceptada per l'usuari de la tasca",
"Sorry this task does not exist or you have no rights to view this task" => "Disculpeu, aquesta tasca no existeix o no teniu permís per veure-la",
"Task entries:" => "Entrades de tasques:",
"Changes:" => "Canvis:",
"Info message" => "Missatge d'info",
"NEW Task" => "Tasca NOVA",
"Sorry you are not allowed to send tasks to other users, or the user is not allowed to receive tasks!" => "Disculpeu, no tens autorització per enviar tasques a altres usuaris o l'usuari no té autorització per rebre'n!",
"Changes on Task" => "Canvis a la tasca",
"You received a new task" => "Heu rebut una tasca nova",
"The priority is" => "La prioritat és",
"very low" => "molt baixa",
"high" => "alta",
"very high" => "molt alta",
"You've to start your work at least on" => "Heu de començar la vostra feina com a mínim el",
"You've to finish your work on" => "Heu de finalizar la vostra feina el",
"Login and click the link below" => "Connecta't i punxa en l'enllaç de sota",
"Please read the task and work on it!" => "Si us plau, llegiu la tasca i treballeu-hi!",
"Sorry, there was an error while trying to write data into the database" => "Disculpeu, hi ha hagut un error mentre s'intentava escriure informació a la base de dades",
// "A new page is created in a language" => "A new page is created in a language",
// "Category change in a language" => "Category change in a language",
// "Remove the notification email" => "Remove the notification email",
"Language watch" => "Vigila l'idioma",
// "Category watch: %0, Language: %1" => "Category watch: %0, Language: %1",
"Cannot upload this file not enough quota" => "No es pot pujar aquest arxiu , no hi ha espai suficient",
"No user indicated" => "No s'ha indicat usuari",
"Non-existent user" => "Aquest usuari no existeix",
"Articles Home" => "Inici dels articles",
"No banner indicated" => "No s'ha indicat cap banner",
"No blog indicated" => "No s'indica cap bloc",
// "Post not found" => "Post not found",
// "You do not have permission to view this blog post while it is marked as private" => "You do not have permission to view this blog post while it is marked as private",
"No cache information available" => "No hi ha informació disponible a la memòria cau",
// "You must suggest a question; please try again" => "You must suggest a question; please try again",
"No faq indicated" => "no s'ha indicat cap PUF",
"You are not permitted to remove someone else's post!" => "No tens permís per eliminar la publicació d'algú altre!",
"Incorrect thread" => "Fil de discussió incorrecte",
"No thread indicated" => "No s'ha indicat cap tema",
// "Files are read only at this time" => "Files are read only at this time",
// "Are you sure you want to clone this spreadsheet" => "Are you sure you want to clone this spreadsheet",
// "Clone Error" => "Clone Error",
// "Are you sure you want to rollback this spreadsheet" => "Are you sure you want to rollback this spreadsheet",
// "Rollback Error" => "Rollback Error",
// "Tracker Added To Spreadsheet" => "Tracker Added To Spreadsheet",
// "Tracker Removed From Spreadsheet" => "Tracker Removed From Spreadsheet",
// "Spreadsheet added" => "Spreadsheet added",
// "Spreadsheet removed" => "Spreadsheet removed",
// "File removed" => "File removed",
// "Spreadsheet truncated" => "Spreadsheet truncated",
"Create tracker item" => "Crea l'ítem del formulari-bd",
// "Are you sure you want to remove this attachment" => "Are you sure you want to remove this attachment",
"Edit/Delete" => "Edita/Esborra",
"You don't have a personal tracker item yet. Click here to make one" => "No tens encara cap ítem del formulari-bd. Clica aquí per a fer-ne un",
"That tracker don't use extras." => "Aquell formulari-bd no empra extres.",
"Tiki WebDAV access" => "Accés a Tiki a través de WebDAV",
// "You do not have permission to admin the requested webmail account" => "You do not have permission to admin the requested webmail account",
// "You do not have permission to use the requested webmail account" => "You do not have permission to use the requested webmail account",
// "You no longer have permission to use your active webmail account" => "You no longer have permission to use your active webmail account",
// "There was a problem connecting to that account" => "There was a problem connecting to that account",
// "There was a problem deleting that mail" => "There was a problem deleting that mail",
// "Mail ID" => "Mail ID",
// "There was a problem while trying to delete these mails" => "There was a problem while trying to delete these mails",
// "There was a problem while trying to delete that mail" => "There was a problem while trying to delete that mail",
"Are you sure you want to delete this account" => "Segur que vols eliminar aquest compte",
// "Taking" => "Taking",
// "Putting back" => "Putting back",
// "Checking" => "Checking",
"Aborted" => "Abortat/da",
"Top pages" => "Les pàgines més actives",
"Last pages" => "Les últimes pàgines",
"Plugin modified by editor" => "El Connector (plugin) ha estat modificat per un editor",
// "Tidy Extension not present" => "Tidy Extension not present",
// "The TikiTests Replay File is Empty" => "The TikiTests Replay File is Empty",
// "The TikiTests Replay File has an error" => "The TikiTests Replay File has an error",
// "You are about to delete a TikiTest file, do you want to continue " => "You are about to delete a TikiTest file, do you want to continue ",
// "Error deleting the file" => "Error deleting the file",
// "TikiTest List" => "TikiTest List",
// "TikiTest Record" => "TikiTest Record",
// "You need one of the extension pecl HTTP or Curl to replay the TikiTest" => "You need one of the extension pecl HTTP or Curl to replay the TikiTest",
// "The TikiTest Replay File is Empty" => "The TikiTest Replay File is Empty",
// "TikiTest Replay" => "TikiTest Replay",
// "The page is empty" => "The page is empty",
"You do not have permissions to view the maps" => "No tens permís per veure els mapes",
);
