<?php
// (c) Copyright 2002-2012 by authors of the Tiki Wiki CMS Groupware Project
// 
// All Rights Reserved. See copyright.txt for details and a complete list of authors.
// Licensed under the GNU LESSER GENERAL PUBLIC LICENSE. See license.txt for details.

// Note for translators about translation of text ending with punctuation
// 
// The current list of concerned punctuation can be found in 'lib/init/tra.php'
// On 2009-03-02, it is: (':', '!', ';', '.', ',', '?')
// For clarity, we explain here only for colons: ':' but it is the same for the rest
// 
// Short version: it is not a problem that string "Login:" has no translation. Only "Login" needs to be translated.
// 
// Technical justification:
// If a string ending with colon needs translating (like "{tr}Login:{/tr}")
// then Tiki tries to translate 'Login' and ':' separately.
// This allows to have only one translation for "{tr}Login{/tr}" and "{tr}Login:{/tr}"
// and it still allows to translate ":" as " :" for languages that
// need it (like French)
// Note: the difference is invisible but " :" has an UTF-8 non-breaking-space, not a regular space, but the UTF-8 equivalent of the HTML &nbsp;.
// This allows correctly displaying emails and JavaScript messages, not only web pages as would happen with &nbsp;.

$lang = array(
// "You must specify a directory" => "You must specify a directory",
"Creation Date" => "Fecha de Creación",
"Name" => "Nombre",
"Last modification date" => "Fecha de última modificación",
"Hits" => "Hits",
"Owner" => "Dueño",
"Description" => "Descripción",
"ID" => "ID",
// "moved %d images, %d errors occurred" => "moved %d images, %d errors occurred",
// "a timeout occurred. Hit the reload button to move the rest" => "a timeout occurred. Hit the reload button to move the rest",
"Detected, Version:" => "Detectado, Versión:",
// "Test Image" => "Test Image",
"Not detected." => "No detectada.",
"Unknown" => "Desconocido",
// "Tiki Email Test" => "Tiki Email Test",
// "Tiki Test email from" => "Tiki Test email from",
// "Unable to send mail" => "Unable to send mail",
// "Test mail sent to" => "Test mail sent to",
// "%d user-group assignments" => "%d user-group assignments",
"None" => "Ninguno",
"All Fields except gdaltindex must be filled" => "Todos los campos excepto gdaltindex deben ser completados",
// "Path to mapfiles is invalid" => "Path to mapfiles is invalid",
"No valid gdaltindex executable" => "Ejecutable gdaltindex no válido",
"No valid ogr2ogr executable" => "Ejecutable ogr2ogr no válido",
// "New configuration created (id %0)" => "New configuration created (id %0)",
// "Configuration updated" => "Configuration updated",
// "You must set a home file gallery" => "You must set a home file gallery",
"Tag already exists" => "La etiqueta ya existe",
"Tag not found" => "Etiqueta no encontrada",
// "Welsh" => "Welsh",
// "Slovene" => "Slovene",
"Arabic" => "Arabic",
// "Bulgarian" => "Bulgarian",
"Catalan" => "Catalan",
"Simplified Chinese" => "Chino Simplificado",
"Czech" => "Checoslovaco",
"Danish" => "Danés",
"German" => "Alemán",
"English" => "Inglés",
"English British" => "Inglés Británico",
"Spanish" => "Castellano",
"Greek" => "Griego",
"Farsi" => "Persa",
"Finnish" => "Finlandés",
"Fijian" => "Fiyiano",
"French" => "Francés",
// "Frisian Netherlands" => "Frisian Netherlands",
"Galician" => "Gallego",
"Hebrew" => "Hebreo",
"Croatian" => "Croata",
// "Indonesian" => "Indonesian",
// "Icelandic" => "Icelandic",
"Italian" => "Italiano",
// "Inuktitut" => "Inuktitut",
"Japanese" => "Japonés",
"Korean" => "Koreano",
"Hungarian" => "Hungaro",
// "Lithuanian" => "Lithuanian",
// "Low German" => "Low German",
"Dutch" => "Holandés",
"Norwegian" => "Noruego",
"Polish" => "Polaco",
// "Portuguese" => "Portuguese",
"Brazilian Portuguese" => "Portugués Brasileño",
// "Romanian" => "Romanian",
// "Romansh" => "Romansh",
"Russian" => "Ruso",
"Pijin Solomon" => "Pijin Solomon",
// "Sinhala" => "Sinhala",
"Slovak" => "Eslovaco",
// "Albanian" => "Albanian",
"Serbian Latin" => "Serbio Latin",
"Swedish" => "Sueco",
"Tuvaluan" => "Tuvaluan",
// "Turkish" => "Turkish",
"Traditional Chinese" => "Chino Tradicional",
"Ukrainian" => "Ucraniano",
// "Vietnamese" => "Vietnamese",
// "Afghanistan" => "Afghanistan",
// "Aland Islands" => "Aland Islands",
// "Aland_Islands" => "Aland_Islands",
// "Albania" => "Albania",
"Algeria" => "Algeria",
"American Samoa" => "Samoa_Americana",
"American_Samoa" => "Samoa_Americana",
// "Andorra" => "Andorra",
"Angola" => "Angola",
// "Anguilla" => "Anguilla",
"Antigua" => "Antigua",
"Argentina" => "Argentina",
"Armenia" => "Armenia",
// "Aruba" => "Aruba",
"Australia" => "Australia",
"Austria" => "Austria",
// "Azerbaijan" => "Azerbaijan",
"Bahamas" => "Bahamas",
"Bahrain" => "Bahrein",
"Bangladesh" => "Bangladesh",
"Barbados" => "Barbados",
"Belarus" => "Belarus",
"Belgium" => "Bélgica",
// "Belize" => "Belize",
// "Benin" => "Benin",
"Bermuda" => "Bermuda",
// "Bhutan" => "Bhutan",
"Bolivia" => "Bolivia",
// "Bosnia and Herzegovina" => "Bosnia and Herzegovina",
// "Bosnia_and_Herzegovina" => "Bosnia_and_Herzegovina",
// "Botswana" => "Botswana",
// "Bouvet Island" => "Bouvet Island",
// "Bouvet_Island" => "Bouvet_Island",
"Brazil" => "Brasil",
// "British Indian Ocean Territory" => "British Indian Ocean Territory",
// "British Virgin Islands" => "British Virgin Islands",
// "British_Indian_Ocean_Territory" => "British_Indian_Ocean_Territory",
// "British_Virgin_Islands" => "British_Virgin_Islands",
"Brunei" => "Brunei",
"Bulgaria" => "Bulgaria",
// "Burkina Faso" => "Burkina Faso",
// "Burkina_Faso" => "Burkina_Faso",
// "Burundi" => "Burundi",
// "Cambodia" => "Cambodia",
// "Cameroon" => "Cameroon",
"Canada" => "Canadá",
// "Cape Verde" => "Cape Verde",
// "Cape_Verde" => "Cape_Verde",
"Catalan Countries" => "Países Catalanes",
"Catalan_Countries" => "Países Catalanes",
"Cayman Islands" => "Islas_Cayman",
"Cayman_Islands" => "Islas_Cayman",
// "Central African Republic" => "Central African Republic",
// "Central_African_Republic" => "Central_African_Republic",
// "Chad" => "Chad",
"Chile" => "Chile",
"China" => "China",
// "Christmas Island" => "Christmas Island",
// "Christmas_Island" => "Christmas_Island",
// "Cocos Islands" => "Cocos Islands",
// "Cocos_Islands" => "Cocos_Islands",
"Colombia" => "Colombia",
// "Comoros" => "Comoros",
// "Congo Democratic" => "Congo Democratic",
// "Congo" => "Congo",
// "Congo_Democratic" => "Congo_Democratic",
"Cook Islands" => "Islas_Cook",
"Cook_Islands" => "Islas_Cook",
"Costa Rica" => "Costa_Rica",
"Costa_Rica" => "Costa_Rica",
"Croatia" => "Croacia",
"Cuba" => "Cuba",
"Cyprus" => "Chipre",
"Czech Republic" => "República_Checa",
"Czech_Republic" => "República_Checa",
"Denmark" => "Dinamarca",
// "Djibouti" => "Djibouti",
// "Dominica" => "Dominica",
"Dominican Republic" => "República_Dominicana",
"Dominican_Republic" => "República_Dominicana",
"Ecuador" => "Ecuador",
"Egypt" => "Egipto",
"El Salvador" => "El_Salvador",
"El_Salvador" => "El_Salvador",
// "Equatorial Guinea" => "Equatorial Guinea",
// "Equatorial_Guinea" => "Equatorial_Guinea",
// "Eritrea" => "Eritrea",
"Estonia" => "Estonia",
// "Ethiopia" => "Ethiopia",
// "Europe" => "Europe",
// "Falkland Islands" => "Falkland Islands",
// "Falkland_Islands" => "Falkland_Islands",
// "Faroe Islands" => "Faroe Islands",
// "Faroe_Islands" => "Faroe_Islands",
"Federated States of Micronesia" => "Estados_Federados_de_Micronesia",
"Federated_States_of_Micronesia" => "Estados_Federados_de_Micronesia",
"Fiji" => "Fiji",
"Finland" => "Finlandia",
"France" => "Francia",
// "French Guiana" => "French Guiana",
"French Polynesia" => "Polinesa_Francesa",
// "French Southern Territories" => "French Southern Territories",
// "French_Guiana" => "French_Guiana",
"French_Polynesia" => "Polinesia_Francesa",
// "French_Southern_Territories" => "French_Southern_Territories",
// "Gabon" => "Gabon",
// "Gambia" => "Gambia",
// "Georgia" => "Georgia",
"Germany" => "Alemania",
// "Ghana" => "Ghana",
// "Gibraltar" => "Gibraltar",
"Greece" => "Grecia",
// "Greenland" => "Greenland",
"Grenada" => "Granada",
// "Guadeloupe" => "Guadeloupe",
"Guam" => "Guam",
"Guatemala" => "Guatemala",
// "Guernsey" => "Guernsey",
// "Guinea Bissau" => "Guinea Bissau",
// "Guinea" => "Guinea",
// "Guinea_Bissau" => "Guinea_Bissau",
// "Guyana" => "Guyana",
"Haiti" => "Haití",
// "Heard Island and McDonald Islands" => "Heard Island and McDonald Islands",
// "Heard_Island_and_McDonald_Islands" => "Heard_Island_and_McDonald_Islands",
"Honduras" => "Honduras",
// "Hong Kong" => "Hong Kong",
// "Hong_Kong" => "Hong_Kong",
"Hungary" => "Hungría",
"Iceland" => "Islandia",
"India" => "India",
"Indonesia" => "Indonesia",
"Iran" => "Iran",
"Iraq" => "Iraq",
"Ireland" => "Irlanda",
// "Isle of Man" => "Isle of Man",
"Israel" => "Israel",
"Italy" => "Italia",
"Ivory Coast" => "Ivory_Coast",
"Ivory_Coast" => "Ivory_Coast",
"Jamaica" => "Jamaica",
"Japan" => "Japón",
// "Jersey" => "Jersey",
"Jordan" => "Jordania",
"Kazakstan" => "Kazakstan",
"Kenya" => "Kenia",
"Kiribati" => "Kiribati",
"Kuwait" => "Kuwait",
// "Kyrgyzstan" => "Kyrgyzstan",
// "Laos" => "Laos",
"Latvia" => "Latvia",
"Lebanon" => "Líbano",
// "Lesotho" => "Lesotho",
// "Liberia" => "Liberia",
// "Libya" => "Libya",
// "Liechtenstein" => "Liechtenstein",
"Lithuania" => "Lituania",
"Luxemburg" => "Luxemburg",
// "Macao" => "Macao",
// "Macedonia" => "Macedonia",
// "Madagascar" => "Madagascar",
"Malawi" => "Malawi",
"Malaysia" => "Malasia",
// "Maldives" => "Maldives",
// "Mali" => "Mali",
"Malta" => "Malta",
"Marshall Islands" => "Islas_Marshall",
"Marshall_Islands" => "Islas_Marshall",
// "Martinique" => "Martinique",
// "Mauritania" => "Mauritania",
"Mauritius" => "Mauricio",
// "Mayotte" => "Mayotte",
"Mexico" => "México",
// "Moldova" => "Moldova",
// "Monaco" => "Monaco",
// "Mongolia" => "Mongolia",
// "Montenegro" => "Montenegro",
// "Montserrat" => "Montserrat",
"Morocco" => "Marruecos",
"Mozambique" => "Mozambique",
// "Myanmar" => "Myanmar",
// "Namibia" => "Namibia",
"Nauru" => "Nauru",
"Nepal" => "Nepal",
// "Netherlands Antilles" => "Netherlands Antilles",
"Netherlands" => "Holanda",
// "Netherlands_Antilles" => "Netherlands_Antilles",
"New Caledonia" => "Nueva_Caledonia",
"New Zealand" => "Nueva_Zelanda",
"New_Caledonia" => "Nueva_Caledonia",
"New_Zealand" => "Nueva_Zelanda",
"Nicaragua" => "Nicaragua",
// "Niger" => "Niger",
"Nigeria" => "Nigeria",
"Niue" => "Niue",
// "Norfolk Island" => "Norfolk Island",
// "Norfolk_Island" => "Norfolk_Island",
// "North Korea" => "North Korea",
// "North_Korea" => "North_Korea",
// "Northern Mariana Islands" => "Northern Mariana Islands",
// "Northern_Mariana_Islands" => "Northern_Mariana_Islands",
"Norway" => "Noruega",
// "Oman" => "Oman",
"Other" => "Otro",
"Pakistan" => "Pakistan",
// "Palau" => "Palau",
// "Palestine" => "Palestine",
"Panama" => "Panamá",
"Papua New Guinea" => "Papua_Nueva_Guinea",
"Papua_New_Guinea" => "Papúa_Nueva_Guinea",
"Paraguay" => "Paraguay",
"Peru" => "Perú",
// "Philippines" => "Philippines",
// "Pitcairn" => "Pitcairn",
"Poland" => "Polonia",
"Portugal" => "Portugal",
"Puerto Rico" => "Puerto_Rico",
"Puerto_Rico" => "Puerto_Rico",
"Quatar" => "Quatar",
// "Republic of Macedonia" => "Republic of Macedonia",
// "Republic_of_Macedonia" => "Republic_of_Macedonia",
// "Reunion" => "Reunion",
"Romania" => "Rumanía",
"Russia" => "Rusia",
"Russian Federation" => "Rusia",
// "Russian_Federation" => "Russian_Federation",
// "Rwanda" => "Rwanda",
// "Saint Helena" => "Saint Helena",
// "Saint Kitts and Nevis" => "Saint Kitts and Nevis",
// "Saint Lucia" => "Saint Lucia",
// "Saint Pierre and Miquelon" => "Saint Pierre and Miquelon",
// "Saint_Helena" => "Saint_Helena",
// "Saint_Kitts_and_Nevis" => "Saint_Kitts_and_Nevis",
// "Saint_Lucia" => "Saint_Lucia",
// "Saint_Pierre_and_Miquelon" => "Saint_Pierre_and_Miquelon",
"Samoa" => "Samoa",
// "San Marino" => "San Marino",
// "San_Marino" => "San_Marino",
// "Sao Tome and Principe" => "Sao Tome and Principe",
// "Sao_Tome_and_Principe" => "Sao_Tome_and_Principe",
"Saudi Arabia" => "Arabia_Saudita",
"Saudi_Arabia" => "Arabia_Saudita",
// "Senegal" => "Senegal",
// "Serbia" => "Serbia",
// "Seychelles" => "Seychelles",
// "Sierra Leone" => "Sierra Leone",
// "Sierra_Leone" => "Sierra_Leone",
"Singapore" => "Singapur",
"Slovakia" => "Eslovaquia",
"Slovenia" => "Eslovenia",
"Solomon Islands" => "Islas_Salomón",
"Solomon_Islands" => "Islas_Salomón",
"Somalia" => "Somalia",
"South Africa" => "Sudafrica",
// "South Georgia and South Sandwich Islands" => "South Georgia and South Sandwich Islands",
"South Korea" => "Corea_del_Sur",
"South_Africa" => "Sudáfrica",
// "South_Georgia_and_South_Sandwich_Islands" => "South_Georgia_and_South_Sandwich_Islands",
"South_Korea" => "Corea_del_Sur",
"Spain" => "España",
"Sri Lanka" => "Sri_Lanka",
"Sri_Lanka" => "Sri_Lanka",
"St Vincent Grenadines" => "St_Vincent_Grenadines",
"St_Vincent_Grenadines" => "St_Vincent_Grenadines",
// "Sudan" => "Sudan",
"Surinam" => "Surinam",
// "Svalbard and Jan Mayen" => "Svalbard and Jan Mayen",
// "Svalbard_and_Jan_Mayen" => "Svalbard_and_Jan_Mayen",
// "Swaziland" => "Swaziland",
"Sweden" => "Suecia",
"Switzerland" => "Suiza",
// "Syria" => "Syria",
"Taiwan" => "Taiwan",
// "Tajikistan" => "Tajikistan",
// "Tanzania" => "Tanzania",
"Thailand" => "Tailandia",
// "Timor-Leste" => "Timor-Leste",
// "Togo" => "Togo",
// "Tokelau" => "Tokelau",
"Tonga" => "Tonga",
"Trinidad Tobago" => "Trinidad_Tobago",
"Trinidad_Tobago" => "Trinidad_Tobago",
// "Tunisia" => "Tunisia",
"Turkey" => "Turquía",
// "Turkmenistan" => "Turkmenistan",
// "Turks and Caicos Islands" => "Turks and Caicos Islands",
// "Turks_and_Caicos_Islands" => "Turks_and_Caicos_Islands",
"Tuvalu" => "Tuvalu",
// "US Virgin Islands" => "US Virgin Islands",
// "US_Virgin_Islands" => "US_Virgin_Islands",
// "Uganda" => "Uganda",
"Ukraine" => "Ucrania",
"United Arab Emirates" => "Emiratos_Arabes_Unidos",
"United Kingdom" => "Reino_Unido",
// "United Nations Organization" => "United Nations Organization",
// "United States Minor Outlying Islands" => "United States Minor Outlying Islands",
"United States" => "Estados_Unidos",
"United_Arab_Emirates" => "Emiratos_Arabes_Unidos",
"United_Kingdom" => "Reino_Unido",
// "United_Kingdom_-_England_and_Wales" => "United_Kingdom_-_England_and_Wales",
// "United_Kingdom_-_Northern_Ireland" => "United_Kingdom_-_Northern_Ireland",
// "United_Kingdom_-_Scotland" => "United_Kingdom_-_Scotland",
// "United_Nations_Organization" => "United_Nations_Organization",
"United_States" => "Estados_Unidos",
// "United_States_Minor_Outlying_Islands" => "United_States_Minor_Outlying_Islands",
"Uruguay" => "Uruguay",
// "Uzbekistan" => "Uzbekistan",
"Vanuatu" => "Vanuatu",
// "Vatican" => "Vatican",
"Venezuela" => "Venezuela",
// "Viet Nam" => "Viet Nam",
// "Viet_Nam" => "Viet_Nam",
"Wales" => "Gales",
// "Wallis and Futuna" => "Wallis and Futuna",
// "Wallis_and_Futuna" => "Wallis_and_Futuna",
// "Western Sahara" => "Western Sahara",
// "Western_Sahara" => "Western_Sahara",
// "World" => "World",
// "Yemen" => "Yemen",
"Yugoslavia" => "Yugoslavia",
"Zambia" => "Zambia",
"Zimbabwe" => "Zimbabwe",
// "the former Yugoslav Republic of Macedonia" => "the former Yugoslav Republic of Macedonia",
// "the_former_Yugoslav_Republic_of_Macedonia" => "the_former_Yugoslav_Republic_of_Macedonia",
"Re:" => "Re:",
"This forum is flat and doesn't allow replies to other replies" => "Este foro es plano y no permite respuestas a otras respuestas",
"Copyright management" => "Gestión del Copyright",
"No page indicated" => "No se indica una página",
"You must supply all the information, including title and year." => "Debe dar toda la información, incluyendo título y año.",
"Tiki was unable to retrieve login data from the database " => "Tiki no pudo recuperar desde la base de datos la información de login",
"The following error message was returned" => "El siguiente mensaje de error fue devuelto",
"Things to check" => "Cosas a revisar",
"Are your database login credentials correct" => "Son sus credenciales para conectarse a la base de datos correctas",
"Did you complete the <a href='tiki-install.php' >Tiki Installer" => "Finalizó el <a href='tiki-install.php' >Instalador de Tiki",
"Please see <a href=\"http://doc.tiki.org/\">the documentation</a> for more information" => "Por favor lea <a href=\"http://doc.tiki.org/\">la documentación </a> para más información",
"You do not have permission to use this feature" => "No tiene permiso para acceder a esta característica",
"This feature is for admins only" => "Esta función es sólo para admins",
"Type" => "Tipo",
"Size" => "Tamaño",
"Created" => "Creada",
"Uploaded" => "Subido",
"Last Modified" => "Modificado",
// "Uploaded by" => "Uploaded by",
"Creator" => "Creador",
// "Last Modified by" => "Last Modified by",
"Comment" => "Comentario",
"Files" => "Archivos",
// "Last download" => "Last download",
"Locked by" => "Bloqueado por",
"Backlinks" => "Backlinks",
// "Delete After" => "Delete After",
// "Share with" => "Share with",
"Source" => "Fuente",
"Explorer" => "Explorador",
"Path" => "Camino",
"Slideshow" => "Slideshow",
"Default View" => "Vista por defecto",
// "Gallery Icon" => "Gallery Icon",
"Register" => "Registrarse",
// "Tiki Installer" => "Tiki Installer",
// "MySQL Improved (mysqli)" => "MySQL Improved (mysqli)",
"MySQL classic (mysql)" => "MySQL Clásico (mysql)",
"Email address not valid, test mail not sent" => "Dirección email no válida, el email de prueba no fue enviado",
"Email address empty and \"copy\" checkbox not set, test mail not sent" => "Dirección de email vacía y casilla \"copia\" no marcada, el email de prueba no fue enviado",
// "Test mail from Tiki installer %0" => "Test mail from Tiki installer %0",
"Tiki version" => "Versión de Tiki",
"PHP version" => "Versión de PHP",
"Server" => "Servidor",
"Sent" => "Enviado",
// "Some invalid characters were detected in database name. Please use alphanumeric characters or _ or -" => "Some invalid characters were detected in database name. Please use alphanumeric characters or _ or -",
// "Database `%0` was created" => "Database `%0` was created",
// "Database `%0` creation failed. You need to create the database" => "Database `%0` creation failed. You need to create the database",
// "No database name specified" => "No database name specified",
"Congratulations!\n\nYour server can send emails.\n\n" => "Genial!\n\nSu servidor puede enviar emails.\n\n",
// "No automated tax" => "No automated tax",
// "Account name must not be empty" => "Account name must not be empty",
// "Budget is not a valid amount: " => "Budget is not a valid amount: ",
// "Locked must be either 0 or 1" => "Locked must be either 0 or 1",
// "Error creating account" => "Error creating account",
// "AccountId %0 is already in use and must not be changed. Please disable it if it is no longer needed" => "AccountId %0 is already in use and must not be changed. Please disable it if it is no longer needed",
// "Error updating account" => "Error updating account",
// "Account is already in use and must not be deleted. Please disable it, if it is no longer needed" => "Account is already in use and must not be deleted. Please disable it, if it is no longer needed",
// "Rollback failed, inconsistent database: Cleanup needed for journalId %0 in book %1" => "Rollback failed, inconsistent database: Cleanup needed for journalId %0 in book %1",
// "successfully rolled back #" => "successfully rolled back #",
// "Booking error creating journal entry" => "Booking error creating journal entry",
// "Booking error creating debit entry" => "Booking error creating debit entry",
// "Booking error creating credit entry" => "Booking error creating credit entry",
// "Number of debit entries differ: " => "Number of debit entries differ: ",
// "Number of credit entries differ: " => "Number of credit entries differ: ",
// "Splitting is only allowed on one side" => "Splitting is only allowed on one side",
// "Invalid debit amount " => "Invalid debit amount ",
// "Invalid debit account number " => "Invalid debit account number ",
// "Invalid credit amount " => "Invalid credit amount ",
// "Invalid credit account number " => "Invalid credit account number ",
// "Difference between debit and credit amounts " => "Difference between debit and credit amounts ",
// "Rollback failed, inconsistent database: Cleanup needed for stackId %0 in book %1" => "Rollback failed, inconsistent database: Cleanup needed for stackId %0 in book %1",
// "Booking error creating stack entry" => "Booking error creating stack entry",
// "Booking error creating stack debit entry" => "Booking error creating stack debit entry",
// "Booking error creating stack credit entry" => "Booking error creating stack credit entry",
// "Error deleting entry from stack" => "Error deleting entry from stack",
// "Booking error confirming stack entry" => "Booking error confirming stack entry",
// "Booking error cconfirming stack entry" => "Booking error cconfirming stack entry",
// "Error while updating statement" => "Error while updating statement",
// "is is not a number" => "is is not a number",
// "must be > 0" => "must be > 0",
// "Invalid transaction - please contact administrator" => "Invalid transaction - please contact administrator",
// "Error checking" => "Error checking",
// "does not exist" => "does not exist",
// "already exists" => "already exists",
// "This book has been closed. You can't create new accounts" => "This book has been closed. You can't create new accounts",
// "This book has been closed. You can't modify the account" => "This book has been closed. You can't modify the account",
// "This book has been closed. You can't delete the account" => "This book has been closed. You can't delete the account",
// "The date for the transaction is before this books start date" => "The date for the transaction is before this books start date",
// "The date for the transaction is after this books end date" => "The date for the transaction is after this books end date",
// "This book has been closed. You can't book into it any more" => "This book has been closed. You can't book into it any more",
// "Invalid booking date" => "Invalid booking date",
// "This book has been closed. You can't cancel transactions in it any more" => "This book has been closed. You can't cancel transactions in it any more",
// "New article post" => "New article post",
// "Edited article post" => "Edited article post",
// "Deleted article post" => "Deleted article post",
"The file is not a CSV file or has not a correct syntax" => "El archivo no es un archivo CSV o no tiene la sintaxis correcta",
"Error line: %d" => "Error en la línea: %d",
// "Spam is not welcome here" => "Spam is not welcome here",
// "anonymous" => "anonymous",
// "Blog cannot be found" => "Blog cannot be found",
"locked" => "bloqueado",
"locked by" => "bloqueado por",
"refresh" => "refresco",
// "go back to this crumb" => "go back to this crumb",
"Administration:" => "Administración:",
"All day" => "Todo el Día",
"First day of week: Sunday (its ID is 0) - translators you need to localize this string!" => "Primer día de la semana: Domingo (su ID es 0) - ¡traductores necesitan localizar esta cadena!",
"Sunday" => "Domingo",
"Su" => "Do",
"Monday" => "Lunes",
"Tuesday" => "Martes",
"Wednesday" => "Miércoles",
"Thursday" => "Jueves",
"Friday" => "Viernes",
"Saturday" => "Sábado",
"Mo" => "Lu",
"Tu" => "Ma",
"We" => "Mi",
"Th" => "Ju",
"Fr" => "Vi",
"Sa" => "Sa",
"in" => "en",
"continued" => "continuado",
"New Image Uploaded by" => "Nueva imágen subida por",
"New Subscriptions" => "Nueva suscripción",
"New Item in Tracker" => "Nuevo item de formulario-bd",
"tracker" => "formulario-bd",
"by" => "por",
"Wiki" => "Wiki",
"Image Gallery" => "Galería de imágenes",
"Articles" => "Artículos",
"Blogs" => "Blogs",
"Forums" => "Foros",
"Directory" => "Directorio",
"File Gallery" => "Galería de archivos",
"FAQs" => "FAQs",
"Quizzes" => "Cuestionarios",
"Trackers" => "Formularios-bd",
"Survey" => "Encuesta",
"Newsletter" => "Boletín",
"Empty captcha value" => "Valor vacío de verificación anti-robots",
"You have mistyped the anti-bot verification code. Please try again" => "Parece que te has equivocado en el código de verificación anti-robots. Por favor, pruébalo de nuevo",
"Failed to validate captcha" => "Error en la verficación del código anti-robots",
// "Captcha ID field is missing" => "Captcha ID field is missing",
// "Get a visual challenge" => "Get a visual challenge",
// "Get an audio challenge" => "Get an audio challenge",
// "Get a new challenge" => "Get a new challenge",
// "Type the two words" => "Type the two words",
// "Type what you hear" => "Type what you hear",
"Help" => "Ayuda",
// "Play sound again" => "Play sound again",
// "Download sound as MP3" => "Download sound as MP3",
"Incorrect. Try again" => "Incorrecto. Prueba de nuevo",
// "A category named %0 already exists in %1" => "A category named %0 already exists in %1",
"article" => "artículo",
"blog" => "blog",
"directory" => "directorio",
"faq" => "faq",
"file gallery" => "galería de archivos",
"forum" => "foro",
"image gallery" => "galería de imágenes",
"newsletter" => "boletín",
"poll" => "poll",
"quiz" => "cuestionario",
"survey" => "encuesta",
"wiki page" => "página wiki",
"image" => "imagen",
"calendar" => "calendario",
"Permission denied" => "Permiso denegado",
"Invalid filename (using filters for filenames)" => "Nombre de archivo no válido (usando filtros para nombres de archivo)",
"Cannot upload this file - maximum upload size exceeded" => "No puede subir este archivo tamaño máximo de subida excedido",
"Cannot write to this file" => "No puedo escribir en este archivo",
"(not registered)" => "(no registrado)",
"Anonymous" => "Anónimo",
// "Your comment was rejected" => "Your comment was rejected",
// "Cannot perform spam check: %0" => "Cannot perform spam check: %0",
// "Please wait %0 seconds between posts" => "Please wait %0 seconds between posts",
"Wrong password. Cannot post comment" => "Contraseña incorrecta. No puede escribir comentario",
"A contribution is mandatory" => "Una contribución es obligatoria",
"You have to enter a title and text" => "Debe entrar un título y texto",
"Invalid Email" => "Email Inválido",
"Your message has been queued for approval and will be posted after a moderator approves it" => "Su mensaje está pendiente de aprobación, el mensaje será publicado cuando un moderador lo apruebe",
"This forum is locked" => "Este foro está cerrado",
"This thread is locked" => "Este hilo está cerrado",
// "This can happen if the page you are linking to has changed since you obtained the forwardlink or if the page is not viewable by the public" => "This can happen if the page you are linking to has changed since you obtained the forwardlink or if the page is not viewable by the public",
// "If you are logged in, try loggin out and then recreate the forwardlink" => "If you are logged in, try loggin out and then recreate the forwardlink",
// "Phrase not found" => "Phrase not found",
"Date" => "Fecha",
// "Click below to read Citing blocks" => "Click below to read Citing blocks",
// "Apply Profile \"Simple Wiki Attributes\" To Add ForwardLink Questions" => "Apply Profile \"Simple Wiki Attributes\" To Add ForwardLink Questions",
// "Saving.." => "Saving..",
// "Editing: " => "Editing: ",
"OK" => "Ok",
"Cancel" => "Cancelar",
// "New" => "New",
"Save" => "Guardar",
// "Create ForwardLink" => "Create ForwardLink",
// "Highlight text to be linked" => "Highlight text to be linked",
// "Accept TextLink & ForwardLink" => "Accept TextLink & ForwardLink",
// "Ok" => "Ok",
// "You selected" => "You selected",
// "Suggested selection" => "Suggested selection",
// "Copy To Clipboard" => "Copy To Clipboard",
// "TextLink & ForwardLink data copied to your clipboard" => "TextLink & ForwardLink data copied to your clipboard",
"Loading.." => "Cargando..",
// "Edit ForwardLink Questions" => "Edit ForwardLink Questions",
"Edit" => "Edita",
"Delete" => "Borrar",
// "Are you sure" => "Are you sure",
// "Suggestion" => "Suggestion",
// "Please fill in the questions below" => "Please fill in the questions below",
// "Copy This" => "Copy This",
// "New File" => "New File",
// "%0 near \"%1\"" => "%0 near \"%1\"",
// "Expecting \"(\"" => "Expecting \"(\"",
// "Unexpected \"%0\"" => "Unexpected \"%0\"",
// "Expecting \")\"" => "Expecting \")\"",
// "No formula provided" => "No formula provided",
// "Variable not found \"%0\"" => "Variable not found \"%0\"",
// "Unknown operation \"%0\"" => "Unknown operation \"%0\"",
"All" => "Todos",
// "Count" => "Count",
// "Count By Date" => "Count By Date",
// "Count By Date Filter Id" => "Count By Date Filter Id",
// "Count Users Filter Id" => "Count Users Filter Id",
// "Count Users IP Filter Id" => "Count Users IP Filter Id",
// "Ascending By Date" => "Ascending By Date",
// "Descending By Date" => "Descending By Date",
// "Logs" => "Logs",
"Action" => "Acción",
"Start" => "Comienzo",
"End" => "Fin",
"Fields" => "Campos",
"Grouping" => "Agrupamiento",
"Sort" => "Ordena",
"Limit" => "Limita",
"Tracker" => "Formulario-bd",
" Join Tracker " => " Fusiona el Formulario-bd ",
" on " => " sobre ",
" equals " => " es igual a ",
"Item Id" => "Id del Ítem",
"Search" => "Buscar",
" for " => " por ",
"Status" => "Estado",
"Articles deleted" => "Artículos borrados",
"removed the article" => "ha borrado el artículo",
"Edited articles" => "Artículos editados",
"edited the article" => "ha editado el artículo",
"New articles submited" => "Nuevos artículos enviados",
"created the article" => "ha creado el artículo",
"New blog posts" => "Nuevas publicaciones en blogs",
"replied to the blog" => "ha respondido al blog",
"New calendar events" => "Nuevos eventos en la agenda",
"%0 added or updated event %1" => "%0 ha añadido o actualizado %1",
"Changes in categories" => "Cambios en categorías",
"added the %0 %1 to the category %2" => "ha añadido %0 %1 a %2",
"created the subcategory" => "ha creado la subcategoría",
"removed the subcategory" => "ha eliminado la subcategoría",
"from" => "desde",
"edited the category" => "ha editado la categoría",
"removed the %0 %1 from the category %2" => "ha eliminado %0 %1 de %2",
"File galleries changed" => "Galerías de archivos cambiadas",
"%0 edited the file gallery %1" => "%0 ha editado la galería de archivos %1",
"%0 uploaded the file %1" => "%0 ha actualizado el archivo %1",
"onto" => "sobre",
"%0 removed the file %1 from %2" => "%0 ha eliminado el archivo %1 de %2",
"New replies in forum topics" => "Nuevas respuestas a temas en foros",
"%0 <a href=%1>replied</a> to the topic %2" => "%0 <a href=%1>ha respondido</a> al tema %2",
"New posts in forums" => "Nuevas publicaciones en foros",
"%0 created the topic %1 at forum %2" => "%0 ha creado el tema %1 en el foro %2",
// "Image galleries changed" => "Image galleries changed",
// "changed the picture gallery" => "changed the picture gallery",
// "uploaded the picture" => "uploaded the picture",
// "removed the picture" => "removed the picture",
"Comments in tracker items" => "Comentarios en ítems de formulario-bd",
"%0 added a new comment to %1 on tracker %2" => "%0 ha añadido uno a %1 en %2",
"%0 added a new comment to item id %1 on tracker %2" => "%0 ha añadido uno al ítem %1 en %2",
"Tracker items modified" => "Ítems de formulario-bd modificados",
"%0 added or updated tracker item %1 on tracker %2" => "%0 ha añadido o actualizado %1 en %2",
"%0 added or updated tracker item id %1 on tracker %2" => "%0 ha añadido o actualizado el ítem id %1 en %2",
"New attachments in wiki pages" => "Nuevos adjuntos en páginas wiki",
"%0 uploaded the file %1 onto %2" => "%0 ha subido el archivo %1 a %2",
"Wiki pages updated" => "Páginas Wiki actualizadas",
"%0 edited the wikipage %1 (<a href=%2>this history</a>, <a href=%3>all history</a>)" => "%0 ha editado %1 (<a href=%2>estos cambios</a>, <a href=%3>todos los cambios</a>)",
"and %0 more changes of the same type" => "y %0 cambios más del mismo tipo",
"Nothing has happened" => "No ha ocurrido nada",
"Report from %0 (1 change)" => "Informe de %0 (1 cambio)",
"Report from %0 (%1 changes)" => "Informe de  %0 (%1 cambios)",
"Report from %0 (no changes)" => "Informe de  %0 (sin cambios)",
"%0 (latest)" => "%0 (el más reciente)",
// "No value for '%0'" => "No value for '%0'",
// "Unknown formatting rule '%0' for '%1'" => "Unknown formatting rule '%0' for '%1'",
// "Indexing failed while processing \"%0\" (type %1) with the error \"%2\"" => "Indexing failed while processing \"%0\" (type %1) with the error \"%2\"",
// "filterRange: \"from\" value not parsed" => "filterRange: \"from\" value not parsed",
// "filterRange: \"to\" value not parsed" => "filterRange: \"to\" value not parsed",
// "Permission Denied" => "Permission Denied",
// "Invalid data" => "Invalid data",
// "Action not found (%0 in %1)" => "Action not found (%0 in %1)",
// "Controller not found (%0)" => "Controller not found (%0)",
"Comments not allowed on this page" => "No se permiten comentarios en esta página",
// "Parent is locked" => "Parent is locked",
"Pseudonym must be specified" => "Se ha de especificar el pseudónino",
"Email must be specified" => "Se ha de especificar el correo-e",
"Title is empty" => "El título está vacío",
"Content is empty" => "El contenido está vacio",
"Permissions denied" => "Se han denegado los permisos necesarios para realizar esta acción",
"Comment not found" => "No se encuentra este comentario",
"Comment already approved" => "Comentario ya aprobado",
"Invalid argument" => "Argumento inválido",
"Thread not specified" => "Hilo no especificado",
"Feature disabled" => "Opción deshabilitada",
// "Reserved to administrators during development" => "Reserved to administrators during development",
// "Tiki not connected. Please click \"Send Info\" to join in" => "Tiki not connected. Please click \"Send Info\" to join in",
// "Something went wrong. Tiki Connect is still experimental. Please try again" => "Something went wrong. Tiki Connect is still experimental. Please try again",
// "registration" => "registration",
// "confirmation" => "confirmation",
// "Connect Feature disabled" => "Connect Feature disabled",
// "Connect Server Mode disabled" => "Connect Server Mode disabled",
// "Please confirm you want to participate in Tiki Connect" => "Please confirm you want to participate in Tiki Connect",
// "Welcome to Tiki Connect, please click \"Send Info\" when you want to make a connection" => "Welcome to Tiki Connect, please click \"Send Info\" when you want to make a connection",
// "Something went wrong on the server. Tiki Connect is still experimental" => "Something went wrong on the server. Tiki Connect is still experimental",
// "Captcha code problem" => "Captcha code problem",
// "Connect data received, thanks" => "Connect data received, thanks",
// "Your Tiki is not registered here yet, please try again" => "Your Tiki is not registered here yet, please try again",
// "Feature disabled: %0" => "Feature disabled: %0",
// "\"%0\" already exists" => "\"%0\" already exists",
// "Field Required" => "Field Required",
// "Not found" => "Not found",
// "Must be authenticated" => "Must be authenticated",
// "Invalid input" => "Invalid input",
// "File could not be uploaded. Restrictions apply" => "File could not be uploaded. Restrictions apply",
// "Upload from source disabled" => "Upload from source disabled",
// "Data could not be obtained" => "Data could not be obtained",
// "Manual refresh disabled" => "Manual refresh disabled",
// "Requested gallery does not exist" => "Requested gallery does not exist",
// "Feature Disabled" => "Feature Disabled",
// "Translation not supported for the specified object type" => "Translation not supported for the specified object type",
// "No source provided" => "No source provided",
// "No source or target provided" => "No source or target provided",
// "Not allowed to attach the selected translations" => "Not allowed to attach the selected translations",
// "Could not attach the translations" => "Could not attach the translations",
// "Not allowed to detach the selected translations" => "Not allowed to detach the selected translations",
// "Object has no language and cannot be translated" => "Object has no language and cannot be translated",
// "No box available for %0" => "No box available for %0",
// "Remote service unaccessible (%0)" => "Remote service unaccessible (%0)",
"Reserved to tracker administrators" => "Reservado a administradores de formularios-bd",
// "Type does not exist" => "Type does not exist",
"Not allowed to view the tracker" => "No tienes permisos para ver este formulario-bd",
// "Warning: Required field types not enabled: %0" => "Warning: Required field types not enabled: %0",
// "Tracker contains no listed field, no meaningful information will be provided in the default list" => "Tracker contains no listed field, no meaningful information will be provided in the default list",
// "Tracker contains no field in the title, no link will be generated" => "Tracker contains no field in the title, no link will be generated",
// "Captcha" => "Captcha",
// "Distinct" => "Distinct",
// "Page Name" => "Page Name",
"Password" => "Clave",
// "Regular Expression (Pattern)" => "Regular Expression (Pattern)",
// "User Name" => "User Name",
// "Invalid data provided" => "Invalid data provided",
// "Item could not be created" => "Item could not be created",
// "Not allowed to export" => "Not allowed to export",
// "No valid field selected for export" => "No valid field selected for export",
// "File upload failed" => "File upload failed",
// "Uploaded file could not be read" => "Uploaded file could not be read",
"Last Modification" => "última modificación",
// "Item ID" => "Item ID",
"Filename" => "Nombre de archivo",
"Creation date" => "Fecha de creación",
// "Views" => "Views",
// "File size" => "File size",
"Version" => "Versión",
// "File type" => "File type",
// "Long description" => "Long description",
"User" => "Usuario",
// "Error in search query" => "Error in search query",
"Remote Source" => "Fuente Remota",
"Automatically generated field for synchronized trackers. Contains the itemId of the remote item" => "Campo generado automáticamente en formularios-bd sincronizados. Contiene el itemId del ítem remoto",
"Tracker does not exist" => "No existe el Formulario-bd",
"Tracker is not synchronized with a remote source" => "El Formulario-bd no está sincronizado con la fuente remota",
"Operation reserved for tracker administrators" => "Operación reservada a administradores del formulario-bd",
"Following mandatory fields are missing: %0" => "Faltan los siguientes campos obligatorios: %0",
// "Invalid value in %0: %1" => "Invalid value in %0: %1",
// "Invalid value in %0" => "Invalid value in %0",
"Field does not exist in tracker" => "No existe el campo en el formulario-bd",
// "secure connection required" => "secure connection required",
// "Create a form which will be posted somewhere, not necessarily trackers or even Tiki" => "Create a form which will be posted somewhere, not necessarily trackers or even Tiki",
// "The title of the button" => "The title of the button",
"Post" => "Publicar",
// "The protocol to use at the form: either get or post" => "The protocol to use at the form: either get or post",
// "Script" => "Script",
// "The arbitrary url of the destination of the form" => "The arbitrary url of the destination of the form",
"Parameters" => "Parámetros",
// "Here page:fieldname can be repeated several times, it specifies the variable names to pass in the form, as well as value taken from the current item from field named fieldname. highlight=test can also be repeated and is useful for fixed values as params to pass to the form" => "Here page:fieldname can be repeated several times, it specifies the variable names to pass in the form, as well as value taken from the current item from field named fieldname. highlight=test can also be repeated and is useful for fixed values as params to pass to the form",
// "Auto-Increment" => "Auto-Increment",
// "Allows an incrementing value field, or itemId field" => "Allows an incrementing value field, or itemId field",
// "The starting value for the field" => "The starting value for the field",
// "Prepend" => "Prepend",
// "Text that will be displayed before the field" => "Text that will be displayed before the field",
// "Append" => "Append",
// "Text that will be displayed after the field" => "Text that will be displayed after the field",
// "If set to \"itemId\", will set this field to match the value of the actual database itemId field value" => "If set to \"itemId\", will set this field to match the value of the actual database itemId field value",
"Category" => "Categoría",
// "Allows for one or multiple categories under the specified main category to be affected to the tracker item" => "Allows for one or multiple categories under the specified main category to be affected to the tracker item",
// "Parent Category" => "Parent Category",
// "Child categories will be provided as options for the field" => "Child categories will be provided as options for the field",
// "Input Type" => "Input Type",
// "User interface control to be used" => "User interface control to be used",
// "Drop Down" => "Drop Down",
// "Radio buttons" => "Radio buttons",
// "List box" => "List box",
// "Multiple-selection check-boxes" => "Multiple-selection check-boxes",
"Select All" => "Elegir todo",
// "Includes a control to select all available options for multi-selection controls" => "Includes a control to select all available options for multi-selection controls",
// "No controls" => "No controls",
// "Include controls" => "Include controls",
// "All descendants" => "All descendants",
// "Display all descendants instead of only first-level ones" => "Display all descendants instead of only first-level ones",
// "First level only" => "First level only",
// "Displays the field description in a help tooltip" => "Displays the field description in a help tooltip",
// "No help" => "No help",
// "Tooltip" => "Tooltip",
// "Checkbox" => "Checkbox",
// "Provides a checkbox field for yes/no, on/off input" => "Provides a checkbox field for yes/no, on/off input",
"Yes" => "Sí",
"No" => "No",
// "Computed Field" => "Computed Field",
// "Provides a computed value based on numeric field values. Consider using webservices or JavaScript to perform the task instead of using this type" => "Provides a computed value based on numeric field values. Consider using webservices or JavaScript to perform the task instead of using this type",
// "This feature is still in place for backwards compatibility. While there are no flaws associated to it, it could be used as a vector for attacks causing a lot of damage. Webservice field or custom JavaScript is recommended instead of this field" => "This feature is still in place for backwards compatibility. While there are no flaws associated to it, it could be used as a vector for attacks causing a lot of damage. Webservice field or custom JavaScript is recommended instead of this field",
// "Formula" => "Formula",
// "The formula to be computed supporting various operators (+ - * / and parenthesis), references to other field made using the field id preceeded by #" => "The formula to be computed supporting various operators (+ - * / and parenthesis), references to other field made using the field id preceeded by #",
// "Country Selector" => "Country Selector",
// "Allows a selection from a specified list of countries" => "Allows a selection from a specified list of countries",
"Display" => "Mostrar",
// "Specify the rendering type for the field" => "Specify the rendering type for the field",
// "Name and flag" => "Name and flag",
// "Name only" => "Name only",
// "Flag only" => "Flag only",
"Sort Order" => "Orden de ordenación",
// "Determines whether the ordering should be based on the translated name or the English name" => "Determines whether the ordering should be based on the translated name or the English name",
// "Translated name" => "Translated name",
// "English name" => "English name",
// "Currency Field" => "Currency Field",
// "Provides a one-line field for numeric input only. Prepend or append values may be alphanumeric" => "Provides a one-line field for numeric input only. Prepend or append values may be alphanumeric",
// "Same Row" => "Same Row",
// "Displays the next field on the same line" => "Displays the next field on the same line",
// "Display Size" => "Display Size",
// "Visible size of the field in characters. Does not affect the numeric length" => "Visible size of the field in characters. Does not affect the numeric length",
// "Text to be displayed prior to the currency amount" => "Text to be displayed prior to the currency amount",
// "Text to be displayed after the numeric value" => "Text to be displayed after the numeric value",
// "Locale" => "Locale",
// "Set locale for currency formatting, for example en_US or en_US.UTF-8 or en_US.ISO-8559-1. Default is en_US" => "Set locale for currency formatting, for example en_US or en_US.UTF-8 or en_US.ISO-8559-1. Default is en_US",
// "Currency" => "Currency",
// "A custom alphanumeric currency code. Not needed if locale is set and a standard code is desired. Default is USD" => "A custom alphanumeric currency code. Not needed if locale is set and a standard code is desired. Default is USD",
// "Symbol" => "Symbol",
// "Set whether the currency code (for example USD) or symbol (for example \$) will display. Defaults to symbol" => "Set whether the currency code (for example USD) or symbol (for example \$) will display. Defaults to symbol",
// "Currency code" => "Currency code",
// "Currency symbol" => "Currency symbol",
// "First or all" => "First or all",
// "Set whether the currency code or symbol will be displayed against all amounts or only the first amount" => "Set whether the currency code or symbol will be displayed against all amounts or only the first amount",
// "First item only" => "First item only",
// "Date and Time" => "Date and Time",
// "Provides drop-down options to accurately select a date and/or time" => "Provides drop-down options to accurately select a date and/or time",
// "Components to be included" => "Components to be included",
// "Date only" => "Date only",
// "Start Year" => "Start Year",
// "Year to allow selecting from" => "Year to allow selecting from",
// "End Year" => "End Year",
// "Year to allow selecting to" => "Year to allow selecting to",
// "Default selection" => "Default selection",
// "Indicates if blank dates should be allowed" => "Indicates if blank dates should be allowed",
// "Current Date" => "Current Date",
// "Blank" => "Blank",
// "Allows users to select only from a specified set of options" => "Allows users to select only from a specified set of options",
"Option" => "Opción",
// "An option, if containing an equal sign, the prior part will be used as the value while the later as the label" => "An option, if containing an equal sign, the prior part will be used as the value while the later as the label",
// "Drop Down with Other field" => "Drop Down with Other field",
// "Allows users to select from a specified set of options or to enter an alternate option" => "Allows users to select from a specified set of options or to enter an alternate option",
// "An option, if containing an equal sign, the prior part will be used as the value while the later as the label. It is recommended to add an \"other\" option" => "An option, if containing an equal sign, the prior part will be used as the value while the later as the label. It is recommended to add an \"other\" option",
// "Radio Buttons" => "Radio Buttons",
// "Multiselect" => "Multiselect",
// "Allows a user to select multiple values from a specified set of options" => "Allows a user to select multiple values from a specified set of options",
"Dynamic Items List" => "Lista Dinámica de Ítems",
"Dynamically updates a selection list based on linked data from another tracker" => "Actualiza dinamicamente una lista de selección basada en datos enlzados desde otro formulario-bd",
"Tracker ID" => "ID del Formulario-bd",
"Tracker to link with" => "Formulario-bd con el que enlazar",
"Field ID (Other tracker)" => "ID del Campo (del otro formulario-bd)",
"Field ID to link with in the other tracker" => "ID del campo con el que enlazar en el otro formulario-bd",
"Field ID (This tracker)" => "ID del campo (en este formulario-bd)",
"Field ID to link with in the current tracker" => "ID del campo a enlazar en este formulario-bd",
"Listed Field" => "Campo a ser mostrado en el listado",
"Field ID to be displayed in the drop list" => "ID del campo a ser mostrado en la lista del desplegable",
"Status Filter" => "Filtro de Estatus",
"Restrict listed items to specific statuses" => "Restringe los ítems listados a estatus específicos",
"all" => "todos",
"open" => "abierto",
"pending" => "pendiente",
"closed" => "cerrado",
"open, pending" => "abierto, pendiente",
"pending, closed" => "pendiente, cerrado",
"Tracker Field Factory Error: Pref \"%0\" required for field type \"%1\"" => "Error de la factoría de Campos de Formularios-bd: Se requiere la Pref \"%0\" para el campo de tipo \"%1\"",
"Attachment" => "Adjunto",
"Allows a file to be attached to the tracker item" => "PErmite que se adjunte un archivo a un item de un formulario-bd",
"List View" => "Ver lista",
// "Defines how attachments will be displayed within the field" => "Defines how attachments will be displayed within the field",
"name" => "nombre",
"type" => "tipo",
// "name, size" => "name, size",
// "name, type, size" => "name, type, size",
// "uploader" => "uploader",
// "mediaplayer" => "mediaplayer",
"Download" => "Bajar",
"Attached and upload files stored in the file galleries to the tracker item" => "Sube archivos a galerías de archivos y adjúntalos al ítem del formularios-bd",
"Gallery ID" => "ID de la Galería",
"File gallery to upload new files into" => "Galería de archivos donde subir los archivos",
"MIME Type Filter" => "Filtro de Tipo MIME",
"Mask for accepted MIME types in the field" => "Mácara para los tipos MIME aceptados en el campo",
"File Count" => "Recuento de archivos",
"Maximum number of files to be attached on the field" => "Número máximo de archivos que adjuntar en el campo",
"Display Images" => "Muestra Imágenes",
"Show files as images or object links" => "Muestra los archivos como archivos o como enlaces a objetos",
"Links" => "Enlaces",
"Images" => "Imágenes",
"Image parameters" => "Parámetros para las Imágenes",
// "URL encoded params used as in the {img} plugin. e.g" => "URL encoded params used as in the {img} plugin. e.g",
// "Image parameters for lists" => "Image parameters for lists",
// "Include Child Galleries" => "Include Child Galleries",
// "Use files from child galleries as well" => "Use files from child galleries as well",
"Replace Existing File" => "Substituye el Archivo Existente",
"Replace existing file if any, instead of uploading new one" => "Substituye el archivo existente por el nuevo, si es el caso, en lugar de añadir el nuevo archivo a la lista de archivos adjuntados",
"Problem with uploaded file: \"%0\"" => "Ha habido algún problema con el archivo subido: \"%0\"",
// "No gallery for uploaded file, galleryId=%0" => "No gallery for uploaded file, galleryId=%0",
// "No permissions to upload file to gallery \"%0\"" => "No permissions to upload file to gallery \"%0\"",
"Freetags" => "Marcas",
"Allows freetags to be shown or added for tracker items" => "Permite mostrar o añadir marcas a items de formularios-bd",
// "Visible size of the input field" => "Visible size of the input field",
// "Hide or show the input help" => "Hide or show the input help",
"Show" => "Mostrar",
"Hide" => "Ocultar",
"Suggest" => "Sugerir",
// "Hide or show the freetag suggestions" => "Hide or show the freetag suggestions",
// "Geographic Feature" => "Geographic Feature",
// "Stores a geographic feature on a map" => "Stores a geographic feature on a map",
// "Feature cannot be set or modified through this interface" => "Feature cannot be set or modified through this interface",
// "Feature cannot be viewed" => "Feature cannot be viewed",
// "Group Selector" => "Group Selector",
// "Allows a selection from a specified list of user groups" => "Allows a selection from a specified list of user groups",
// "Auto-Assign" => "Auto-Assign",
// "Determines if any group should be automatically assigned to the field" => "Determines if any group should be automatically assigned to the field",
// "Modifier" => "Modifier",
// "Group Filter" => "Group Filter",
// "Limit listed groups to those including the specified group" => "Limit listed groups to those including the specified group",
// "Assign to the group" => "Assign to the group",
// "For no autoaassigned field, the user (user selector if exsits or user) will be assigned to the group and it will be his default group. The group must have the user choice setting on" => "For no autoaassigned field, the user (user selector if exsits or user) will be assigned to the group and it will be his default group. The group must have the user choice setting on",
"Assign" => "Asignar",
// "Header" => "Header",
// "Displays a header between fields to delimit a section and allow folding the fields" => "Displays a header between fields to delimit a section and allow folding the fields",
// "Header Level" => "Header Level",
// "Level of the header to use for complex tracker structures needing multiple heading levels" => "Level of the header to use for complex tracker structures needing multiple heading levels",
// "Default State" => "Default State",
// "Controls the section toggles" => "Controls the section toggles",
"Open" => "Abierta",
// "Closed" => "Closed",
"Icon" => "Icono",
// "Allows to select an image as an icon attached to the tracker item from file galleries" => "Allows to select an image as an icon attached to the tracker item from file galleries",
// "Default image" => "Default image",
// "Path to the default icon used" => "Path to the default icon used",
"Image" => "Imagen",
"Allow users to upload images on the tracker item" => "Permite a los usuarios subir imágenes al ítem del formulario-bd",
// "List image width" => "List image width",
// "Display size in pixels" => "Display size in pixels",
// "List image height" => "List image height",
// "Detail image width" => "Detail image width",
// "Detail image height" => "Detail image height",
// "Maximum image size" => "Maximum image size",
// "Maximum image width or height in pixels" => "Maximum image width or height in pixels",
// "Shadowbox" => "Shadowbox",
// "Shadowbox usage on this field" => "Shadowbox usage on this field",
// "Do not use" => "Do not use",
// "One box per item" => "One box per item",
// "Use the same box for all images" => "Use the same box for all images",
// "Missing Icon" => "Missing Icon",
// "Icon to use when no images have been uploaded" => "Icon to use when no images have been uploaded",
"Invalid imagename (using filters for filenames)" => "Nombre de imagen no válido (usando filtros para nombres de archivos)",
// "In Group" => "In Group",
// "Indicates if the user associated to the item is member of a specified group" => "Indicates if the user associated to the item is member of a specified group",
// "Group Name" => "Group Name",
// "Name of the group to verify" => "Name of the group to verify",
// "How to display the result" => "How to display the result",
// "Yes/No" => "Yes/No",
// "Join date" => "Join date",
// "IP Selector" => "IP Selector",
// "IP address input field" => "IP address input field",
// "Auto-assign" => "Auto-assign",
// "Automatically assign the value on creation or edit" => "Automatically assign the value on creation or edit",
// "Item Link" => "Item Link",
// "Link to an other item, similar to a foreign key" => "Link to an other item, similar to a foreign key",
"Tracker to link to" => "Formulario-bd al que enlazar",
// "Field ID" => "Field ID",
// "Default field to display" => "Default field to display",
// "How the link to the item should be rendered" => "How the link to the item should be rendered",
"Value" => "Valor",
"Link" => "Enlace",
// "Multiple Fields" => "Multiple Fields",
// "Display the values from multiple fields instead of a single one, separated by |" => "Display the values from multiple fields instead of a single one, separated by |",
// "Limit the available items to a selected set" => "Limit the available items to a selected set",
// "Link Page" => "Link Page",
// "Link to a wiki page instead of directly to the item" => "Link to a wiki page instead of directly to the item",
// "Add Items" => "Add Items",
// "Display text to allow new items to be added - e.g. \"Add item...\" (requires jQuery-UI)" => "Display text to allow new items to be added - e.g. \"Add item...\" (requires jQuery-UI)",
// "Add Item Template Page" => "Add Item Template Page",
"Wiki page to use as a Pretty Tracker template" => "Página Wiki a usar como plantilla de Formulario-bd bonito",
// "Preselect item based on value in this field" => "Preselect item based on value in this field",
// "Preselect item based on value in specified field ID of item being edited" => "Preselect item based on value in specified field ID of item being edited",
// "Preselect based on value in this remote field" => "Preselect based on value in this remote field",
// "Match preselect item with this field ID in tracker that is being linked to" => "Match preselect item with this field ID in tracker that is being linked to",
// "Preselection matching method" => "Preselection matching method",
// "Method to use to match fields for preselection purposes" => "Method to use to match fields for preselection purposes",
// "Exact Match" => "Exact Match",
// "Field here is part of field there" => "Field here is part of field there",
// "Match domain, used for URL fields" => "Match domain, used for URL fields",
// "One item per value" => "One item per value",
// "Display only one random item per value" => "Display only one random item per value",
// "Only one random item for each value" => "Only one random item for each value",
// "Displays all the items for a same value with a notation value (itemId)" => "Displays all the items for a same value with a notation value (itemId)",
// "Select multiple values" => "Select multiple values",
// "Allow the user to select multiple values" => "Allow the user to select multiple values",
// "Index remote fields" => "Index remote fields",
// "Index one or multiple fields from the master tracker along with the child, separated by |" => "Index one or multiple fields from the master tracker along with the child, separated by |",
// "Items List" => "Items List",
// "Displays a list of field values from another tracker that has a relation with this tracker" => "Displays a list of field values from another tracker that has a relation with this tracker",
"Tracker to list items from" => "Formulario-bd del cual listar ítems",
// "Link Field ID" => "Link Field ID",
// "Field ID from the other tracker containing an item link pointing to the item in this tracker or some other value to be matched" => "Field ID from the other tracker containing an item link pointing to the item in this tracker or some other value to be matched",
// "Value Field ID" => "Value Field ID",
// "Field ID from this tracker matching the value in the link field ID from the other tracker if the field above is not an item link" => "Field ID from this tracker matching the value in the link field ID from the other tracker if the field above is not an item link",
// "Fields to display" => "Fields to display",
// "Display alternate fields from the other tracker instead of the item title" => "Display alternate fields from the other tracker instead of the item title",
// "How the link to the items should be rendered" => "How the link to the items should be rendered",
// "Read Only" => "Read Only",
// "Date and Time (Date Picker)" => "Date and Time (Date Picker)",
// "Provides jQuery-UI date picker select a date and optionally time" => "Provides jQuery-UI date picker select a date and optionally time",
// "Default value" => "Default value",
// "Default date and time for new items" => "Default date and time for new items",
// "None (undefined)" => "None (undefined)",
// "Item creation date and time" => "Item creation date and time",
"Language" => "Lenguaje",
"Assign a language to the tracker item to enable multilingual trackers" => "Asigna un idioma al ítem del formulario-bd para habilitar formularios-bd multilingües",
// "Indicates if the language should be assigned as the item's language" => "Indicates if the language should be assigned as the item's language",
"LDAP" => "LDAP",
// "Display a field value from a specific user in LDAP" => "Display a field value from a specific user in LDAP",
"Filter" => "Filtrar",
// "LDAP filter, can contain the %field_name% placeholder to be replaced with the current field's name" => "LDAP filter, can contain the %field_name% placeholder to be replaced with the current field's name",
"Field" => "Campo",
// "Field name returned by LDAP" => "Field name returned by LDAP",
"DSN" => "DSN",
// "Data source name registered in Tiki" => "Data source name registered in Tiki",
"Location" => "Ubicación",
// "Allows to select a geolocation for the item and displays it on a map" => "Allows to select a geolocation for the item and displays it on a map",
// "Use as item location" => "Use as item location",
// "When enabled, records the field's value as the item's geolocation to be displayed on locator maps" => "When enabled, records the field's value as the item's geolocation to be displayed on locator maps",
// "Numeric Field" => "Numeric Field",
// "Text to be displayed prior to the numeric value" => "Text to be displayed prior to the numeric value",
// "Decimal Places" => "Decimal Places",
// "Amount of decimals to preserve before rounding" => "Amount of decimals to preserve before rounding",
// "Decimal separator when displaying data" => "Decimal separator when displaying data",
// "Single character. Use c for comma, d for dot or s for space. The valid decimal separator when inserting numbers may depend on site language and web browser. See documentation for more details" => "Single character. Use c for comma, d for dot or s for space. The valid decimal separator when inserting numbers may depend on site language and web browser. See documentation for more details",
// "Thousand separator when displaying data" => "Thousand separator when displaying data",
// "Single character,  Use c for comma, d for dot or s for space.  When inserting data no thousands separator is needed" => "Single character,  Use c for comma, d for dot or s for space.  When inserting data no thousands separator is needed",
// "Page Selector" => "Page Selector",
// "Allows a selection from the list of pages" => "Allows a selection from the list of pages",
// "Will auto-assign the creator of the item" => "Will auto-assign the creator of the item",
// "Visible size of the input in characters" => "Visible size of the input in characters",
"Create Page" => "Crear página",
// "Create missing pages using the page name in this file as the template" => "Create missing pages using the page name in this file as the template",
// "Display the value as a link to the page" => "Display the value as a link to the page",
"Rating" => "Calificación",
// "A rating of the tracker item" => "A rating of the tracker item",
// "The possible options (comma separated integers) for the rating" => "The possible options (comma separated integers) for the rating",
"Mode" => "Modo",
// "Display rating options as" => "Display rating options as",
// "Stars" => "Stars",
// "Single Option: e.g. Like" => "Single Option: e.g. Like",
"Labels" => "Etiquetas",
// "The text labels (comma separated) for the possible options" => "The text labels (comma separated) for the possible options",
// "Stars (deprecated)" => "Stars (deprecated)",
// "Displays a star rating" => "Displays a star rating",
// "A possible option for the rating" => "A possible option for the rating",
// "Stars (system)" => "Stars (system)",
"Average" => "Promedio",
"Number of votes" => "Número de votos",
"Your rating" => "Tu valoración",
// "Relations" => "Relations",
// "Allows to create arbitrary relations between the trackers and other objects in the system" => "Allows to create arbitrary relations between the trackers and other objects in the system",
// "Relation" => "Relation",
// "Relation qualifier. Must be a three-part qualifier containing letters and separated by dots" => "Relation qualifier. Must be a three-part qualifier containing letters and separated by dots",
// "URL-encoded list of filters to be applied on object selection" => "URL-encoded list of filters to be applied on object selection",
// "Read-only" => "Read-only",
// "Only display the incoming relations instead of manipulating them" => "Only display the incoming relations instead of manipulating them",
// "Include Invert" => "Include Invert",
// "Include invert relations in the list" => "Include invert relations in the list",
"Email" => "Correo",
// "Allows to input an email address with options of making it active" => "Allows to input an email address with options of making it active",
// "Link Type" => "Link Type",
// "How the email address will be rendered" => "How the email address will be rendered",
"Plain text" => "Texto plano",
// "Encoded mailto link" => "Encoded mailto link",
// "Simple mailto link" => "Simple mailto link",
// "Watch Open" => "Watch Open",
// "Notify this address every time the status changes to open" => "Notify this address every time the status changes to open",
// "Watch Pending" => "Watch Pending",
// "Notify this address every time the status changes to pending" => "Notify this address every time the status changes to pending",
// "Watch Closed" => "Watch Closed",
// "Notify this address every time the status changes to closed" => "Notify this address every time the status changes to closed",
// "Static Text" => "Static Text",
// "Displays the field description as static text that can be used to display notes or additional instructions" => "Displays the field description as static text that can be used to display notes or additional instructions",
// "Wiki Parse" => "Wiki Parse",
// "Indicates if the description should be parsed as wiki syntax for formatting" => "Indicates if the description should be parsed as wiki syntax for formatting",
// "Handle line breaks as new lines only" => "Handle line breaks as new lines only",
// "Maximum Length (List)" => "Maximum Length (List)",
// "Maximum amount of characters to be displayed in list mode" => "Maximum amount of characters to be displayed in list mode",
// "Text Field" => "Text Field",
// "Single-line text input" => "Single-line text input",
// "Display the next field on the same row" => "Display the next field on the same row",
// "Visible size of the field in characters" => "Visible size of the field in characters",
// "Text to prepend when displaying the value" => "Text to prepend when displaying the value",
// "Maximum Length" => "Maximum Length",
// "Maximum amount of characters to store" => "Maximum amount of characters to store",
// "Autocomplete" => "Autocomplete",
// "Enable autocompletion while typing in the field" => "Enable autocompletion while typing in the field",
// "Index exact value" => "Index exact value",
// "In addition to indexing the content of the field, also index it as an identifier in tracker_field_{perm name}_exact. This option is not available for multilingual fields. Mostly for identifiers like product codes or ISBN numbers" => "In addition to indexing the content of the field, also index it as an identifier in tracker_field_{perm name}_exact. This option is not available for multilingual fields. Mostly for identifiers like product codes or ISBN numbers",
// "Text Area" => "Text Area",
// "Multi-line text input" => "Multi-line text input",
"Toolbars" => "Barras de herramientas",
"Enable the toolbars as syntax helpers" => "Habilita alguna barra de herramientas como ayudantes de edición",
"Disable" => "Deshabilita",
"Enable" => "Habilita",
"Width" => "Anchura",
"Size of the text area in characters" => "Tamaño del área texto en caracteres",
"Height" => "Altura",
// "Size of the text area in lines" => "Size of the text area in lines",
// "Character Limit" => "Character Limit",
// "Maximum amount of characters to be stored" => "Maximum amount of characters to be stored",
// "Display Limit (List)" => "Display Limit (List)",
// "Maximum amount of characters to be displayed in list mode before the value gets truncated" => "Maximum amount of characters to be displayed in list mode before the value gets truncated",
// "Word Count" => "Word Count",
// "Limit the length of the text in words" => "Limit the length of the text in words",
// "Distinct Values" => "Distinct Values",
// "All values in the field must be different" => "All values in the field must be different",
// "Use WYSIWYG" => "Use WYSIWYG",
// "Use a rich text editor instead of a plain text box" => "Use a rich text editor instead of a plain text box",
// "Word Limit Exceeded" => "Word Limit Exceeded",
// "Character Limit Exceeded" => "Character Limit Exceeded",
"URL" => "URL",
// "Creates a link to a specified URL" => "Creates a link to a specified URL",
// "How the URL should be rendered" => "How the URL should be rendered",
// "URL as link" => "URL as link",
// "Site title as link" => "Site title as link",
// "URL as link plus site title" => "URL as link plus site title",
// "User Groups" => "User Groups",
// "Displays the list of groups for the user associated with the tracker items" => "Displays the list of groups for the user associated with the tracker items",
// "User Preference" => "User Preference",
// "Allows user preference changes from a tracker" => "Allows user preference changes from a tracker",
// "Preference Name" => "Preference Name",
// "Name of the preference to manipulate. password and email are not preferences, but are also valid values that will modify the user's profile" => "Name of the preference to manipulate. password and email are not preferences, but are also valid values that will modify the user's profile",
// "User Selector" => "User Selector",
// "Allows the selection of a user from a list" => "Allows the selection of a user from a list",
// "Assign the value based on the creator or modifier" => "Assign the value based on the creator or modifier",
// "Email Notification" => "Email Notification",
// "Send an email notification to the user every time the item is modified" => "Send an email notification to the user every time the item is modified",
// "Only when other users modify the item" => "Only when other users modify the item",
// "Group IDs" => "Group IDs",
// "Limit the list of users to members of specific groups" => "Limit the list of users to members of specific groups",
// "User Subscription" => "User Subscription",
// "Allows registered users to subscribe themselves to a tracker item. The item should ideally only be editable by the creator or administrators. Prepend the maximum amount of subscribers to the field value foloowed by # if such a limit is desired. E.g. 50# means that 50 subscriptions will be allowed for this item" => "Allows registered users to subscribe themselves to a tracker item. The item should ideally only be editable by the creator or administrators. Prepend the maximum amount of subscribers to the field value foloowed by # if such a limit is desired. E.g. 50# means that 50 subscriptions will be allowed for this item",
// "Webservice" => "Webservice",
// "Displays the result of a registered webservice call" => "Displays the result of a registered webservice call",
// "Service Name" => "Service Name",
// "Webservice name as registered in Tiki" => "Webservice name as registered in Tiki",
// "Template Name" => "Template Name",
// "Template name to use for rendering as registered with the webservice" => "Template name to use for rendering as registered with the webservice",
// "URL-encoded list of parameters to send to the webservice. %field_name% can be used in the string to be replaced with the values in the tracker item" => "URL-encoded list of parameters to send to the webservice. %field_name% can be used in the string to be replaced with the values in the tracker item",
"Create page:" => "Crear página:",
// "Internal error" => "Internal error",
// "User error" => "User error",
// "Plugin argument(s) missing" => "Plugin argument(s) missing",
// "Plugin <strong>%0</strong> cannot be executed" => "Plugin <strong>%0</strong> cannot be executed",
// "Set" => "Set",
// "Plugin disabled" => "Plugin disabled",
"Line:" => "Línea:",
"Lines:" => "Líneas:",
"WikiDiff::apply: line count mismatch: %s != %s" => "WikiDiff::aplicar: cuenta de líneas no coincide: %s != %s",
"WikiDiff::_check: failed" => "WikiDiff::_chequeo: fallo",
"WikiDiff::_check: edit sequence is non-optimal" => "WikiDiff::_chequeo: secuencia de edición es no óptima",
"WikiDiff Okay: LCS = %s" => "WikiDiff Okay: LCS = %s",
// "`%0` does not match acceptable naming patterns" => "`%0` does not match acceptable naming patterns",
"Cannot open this file" => "No es posible abrir este fichero",
// "User File Galleries" => "User File Galleries",
// "Wiki Attachment File Galleries" => "Wiki Attachment File Galleries",
"File Galleries" => "Galerías de archivos",
"My Files" => "Mis archivos",
// "Files of " => "Files of ",
// "The upload has not been done" => "The upload has not been done",
// "Reason: The global quota has been reached" => "Reason: The global quota has been reached",
// "Reason: The quota has been reached in \"%s\"" => "Reason: The quota has been reached in \"%s\"",
// "File gallery quota exceeded" => "File gallery quota exceeded",
// "Number of files transferred to the database" => "Number of files transferred to the database",
// "Number of files transferred to the file system" => "Number of files transferred to the file system",
// "Old File deleted" => "Old File deleted",
// "Incorrect param" => "Incorrect param",
"You do not have permission to remove files from this gallery" => "Permiso rechazado no puede eliminar archivos de esta galería",
// "WARNING: The file is used in" => "WARNING: The file is used in",
// "Remove file draft: " => "Remove file draft: ",
// "Remove file: " => "Remove file: ",
// "You are trying to edit multiple files in different galleries, which is not supported yet" => "You are trying to edit multiple files in different galleries, which is not supported yet",
// "The specified file does not exist" => "The specified file does not exist",
"Upload was not successful" => "La subida no fue exitosa",
// "An exception occurred" => "An exception occurred",
// "Batch file processed" => "Batch file processed",
"No permission to upload zipped file packages" => "No tiene permiso para subir paquetes de archivos zipeados",
"Errors detected" => "Errores detectados",
// "Check that these paths exist and are writable by the web server" => "Check that these paths exist and are writable by the web server",
// "File added: " => "File added: ",
// "Cannot read the file" => "Cannot read the file",
// "Incorrect file extension" => "Incorrect file extension",
// "Warning: Empty file" => "Warning: Empty file",
// "Please re-upload your file" => "Please re-upload your file",
// "Upload was not successful. Duplicate file content" => "Upload was not successful. Duplicate file content",
"File update was successful" => "Actualización de archivo exitosa",
// "Cannot resize the file" => "Cannot resize the file",
// "Cannot write the file" => "Cannot write the file",
// "Image was reduced: %s x %s -> %s x %s" => "Image was reduced: %s x %s -> %s x %s",
"Could not upload the file" => "No puedo subir el archivo",
"Could not find the file requested" => "No puedo encontrar el archivo pedido",
// "The file is locked by %s" => "The file is locked by %s",
"You do not have permission to edit this file" => "Permiso denegado no puede editar este archivo",
// "Cannot read uploaded file" => "Cannot read uploaded file",
// "Cannot read file on disk" => "Cannot read file on disk",
"unknown" => "desconocido",
// "Automatic revision from source" => "Automatic revision from source",
"Page" => "Página",
// "Cannot upload this file" => "Cannot upload this file",
"This is an approximation based on your server memory limit" => "Esta es una aproximación basada el límite de memoria de su servidor",
"This is the value of your server's PHP '%s' setting" => "Este es el valor de la configuración PHP '%s' de su servidor",
"You are alerted by the server " => "Usted es alertado por el servidor ",
"You can check the modifications at : " => "Puede comprobar las modificaciones en : ",
"You are alerted of a change on " => "Usted es alertado de un cambio en ",
"No image yet, sorry." => "Sin imagen aún, lo siento.",
"unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>" => "directorio de destino desconocido. Por favor, configurelo en <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>",
"unlink failed" => "fallo al deshacer el enlace",
// "The uploaded file exceeds the upload_max_filesize directive in php.ini" => "The uploaded file exceeds the upload_max_filesize directive in php.ini",
// "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form" => "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form",
// "The uploaded file was only partially uploaded. Please try again" => "The uploaded file was only partially uploaded. Please try again",
// "No file was uploaded" => "No file was uploaded",
// "Missing a temporary folder" => "Missing a temporary folder",
// "Failed to write file to disk" => "Failed to write file to disk",
// "File upload stopped by extension" => "File upload stopped by extension",
// "Set new blog as Tiki homepage" => "Set new blog as Tiki homepage",
// "Importation completed" => "Importation completed",
// "<a href=\"tiki-importer.php\">Click here</a> to finish the import process" => "<a href=\"tiki-importer.php\">Click here</a> to finish the import process",
// "Found %0 posts, %1 pages, %2 tags and %3 categories. Inserting them into Tiki" => "Found %0 posts, %1 pages, %2 tags and %3 categories. Inserting them into Tiki",
// "Item \"%0\" NOT imported (there was already a item with the same name)" => "Item \"%0\" NOT imported (there was already a item with the same name)",
// "Page \"%0\" sucessfully imported" => "Page \"%0\" sucessfully imported",
// "Post \"%0\" sucessfully imported" => "Post \"%0\" sucessfully imported",
// "Import images and other attachments" => "Import images and other attachments",
// "Update internal links (experimental)" => "Update internal links (experimental)",
// "Suggest .htaccess rules to redirect from old WP URLs to new Tiki URLs (experimental)" => "Suggest .htaccess rules to redirect from old WP URLs to new Tiki URLs (experimental)",
// "Class DOMDocument not available, check your PHP installation. For more information see http://php.net/manual/en/book.dom.php" => "Class DOMDocument not available, check your PHP installation. For more information see http://php.net/manual/en/book.dom.php",
// "Invalid file mime type" => "Invalid file mime type",
// "Error while loading XML file. Probably your XML file is malformed. Some versions of Wordpress generate a malformed XML file. See the Tiki Importer documentation for more information" => "Error while loading XML file. Probably your XML file is malformed. Some versions of Wordpress generate a malformed XML file. See the Tiki Importer documentation for more information",
// "Invalid Wordpress XML file" => "Invalid Wordpress XML file",
// "No attachments found to import" => "No attachments found to import",
// "Importing attachments" => "Importing attachments",
// "Attachment %0 successfully imported" => "Attachment %0 successfully imported",
// "Unable to download attachment %0. Error message was: %1 %2" => "Unable to download attachment %0. Error message was: %1 %2",
// "%0 attachments imported and %1 errors" => "%0 attachments imported and %1 errors",
// "Page \"%0\" successfully extracted" => "Page \"%0\" successfully extracted",
// "Post \"%0\" successfully extracted" => "Post \"%0\" successfully extracted",
// "Extracting data from XML file" => "Extracting data from XML file",
// "Number of page revisions to import (0 for all revisions)" => "Number of page revisions to import (0 for all revisions)",
// "What to do with page names that already exists in Tiki" => "What to do with page names that already exists in Tiki",
// "Do not import" => "Do not import",
// "Override" => "Override",
// "Append software name as prefix to the page name" => "Append software name as prefix to the page name",
// "Page %0 sucessfully imported" => "Page %0 sucessfully imported",
// "Page %0 NOT imported (there was already a page with the same name)" => "Page %0 NOT imported (there was already a page with the same name)",
// "%0 pages parsed. Starting to insert those pages into Tiki" => "%0 pages parsed. Starting to insert those pages into Tiki",
// "Import images and attachments (see documentation for more information)" => "Import images and attachments (see documentation for more information)",
// "Add a maketoc at the top of each page" => "Add a maketoc at the top of each page",
// "XML file does not validate against the Mediawiki XML schema" => "XML file does not validate against the Mediawiki XML schema",
// "ABORTING: destination directory for attachments (%0) does no exist. Fix the problem or try to import without the attachments" => "ABORTING: destination directory for attachments (%0) does no exist. Fix the problem or try to import without the attachments",
// "ABORTING: destination directory for attachments (%0) is not writable. Fix the problem or try to import without attachments" => "ABORTING: destination directory for attachments (%0) is not writable. Fix the problem or try to import without attachments",
// "NOT importing file %0 as there is already a file with the same name in the destination directory (%1)" => "NOT importing file %0 as there is already a file with the same name in the destination directory (%1)",
// "File %0 successfully imported" => "File %0 successfully imported",
// "Unable to download file %0. File not found" => "Unable to download file %0. File not found",
// "Error while parsing revision %0 of the page \"%1\". Or there is a problem on the page syntax or on the Text_Wiki parser (the parser used by the importer)" => "Error while parsing revision %0 of the page \"%1\". Or there is a problem on the page syntax or on the Text_Wiki parser (the parser used by the importer)",
// "Page \"%0\" successfully parsed with %1 revisions (from a total of %2 revisions)" => "Page \"%0\" successfully parsed with %1 revisions (from a total of %2 revisions)",
// "Page \"%0\" is NOT going to be imported. It was not possible to parse any of the page revisions" => "Page \"%0\" is NOT going to be imported. It was not possible to parse any of the page revisions",
// "Mediawiki XML file version %0 is not supported" => "Mediawiki XML file version %0 is not supported",
// "ABORTING: you need to enable the PHP setting 'allow_url_fopen' to be able to import attachments. Fix the problem or try to import without the attachments" => "ABORTING: you need to enable the PHP setting 'allow_url_fopen' to be able to import attachments. Fix the problem or try to import without the attachments",
// "Parsing pages" => "Parsing pages",
// "No attachments found to import! Make sure you have created your XML file with the dumpDump.php script and with the option --uploads. This is the only way to import attachment" => "No attachments found to import! Make sure you have created your XML file with the dumpDump.php script and with the option --uploads. This is the only way to import attachment",
// "string" => "string",
// "ERROR: unable to write to lang/%s/language.php" => "ERROR: unable to write to lang/%s/language.php",
// "The file lang/%0/language.php is not well formated. Run get_strings.php?lang=%0 and then try to export the translations again" => "The file lang/%0/language.php is not well formated. Run get_strings.php?lang=%0 and then try to export the translations again",
"Contributions" => "Contribuciones",
"Query point" => "Consulta el punto",
"layer" => "capa",
"Record" => "Grabar",
"This feature is disabled" => "Esta característica está deshabilitada",
"Could not create \$tdo.mif in data directory" => "No puedo crear \$tdo.mif en directorio de datos",
"Could not create \$tdo.mid in data directory" => "No puedo crear \$tdo.mid en directorio de datos",
"User Map Generated in:" => "Mapa de Usuario Generado en:",
"Image Map Generated in:" => "Imagen de Mapa Generado en:",
// "(copy)" => "(copy)",
"You can only use optionId = 0 to create a new option or optionId equal an id that already belongs to the menu to update it" => "Solo puede utilizar optionId = 0 para crear una nueva opción u optionId igual a un id que ya pertenezca al menú en el que va a actualizarlo",
"menu" => "menú",
"NONE" => "NINGUNO",
// "Stored IPTC Digest" => "Stored IPTC Digest",
// "Calculated IPTC Digest" => "Calculated IPTC Digest",
// "The file is empty" => "The file is empty",
// "The file is not readable" => "The file is not readable",
// "File type not handled by Tiki - only basic metadata available" => "File type not handled by Tiki - only basic metadata available",
// "Photographer Data (IPTC)" => "Photographer Data (IPTC)",
// "No IPTC data" => "No IPTC data",
// "File Data (EXIF)" => "File Data (EXIF)",
// "No EXIF data" => "No EXIF data",
// "Not processed" => "Not processed",
// "Unixtime" => "Unixtime",
// "XMP Data" => "XMP Data",
// "No XMP data" => "No XMP data",
// "File type not handled by Tiki" => "File type not handled by Tiki",
// "Invalid \"from\" date received" => "Invalid \"from\" date received",
// "Invalid \"to\" date received" => "Invalid \"to\" date received",
// "Sorry, \"from\" date must precede \"to\" date" => "Sorry, \"from\" date must precede \"to\" date",
// "Sorry, no data available for the future" => "Sorry, no data available for the future",
// "for month of" => "for month of",
"for" => "para",
// "for week of" => "for week of",
// "Integer (i)" => "Integer (i)",
// "Percentage (%)" => "Percentage (%)",
// "Float (f)" => "Float (f)",
// "List (L)" => "List (L)",
// "Daily (+)" => "Daily (+)",
// "Monthly and weekly (@)" => "Monthly and weekly (@)",
// "Weekly (-)" => "Weekly (-)",
"File %s not found" => "Fichero %s no encontrado",
"File %s is not a valid archive" => "Fichero %s no es un archivo válido",
"Impossible to open %s : %s" => "Imposible abrir  %s : %s",
"The content retrieved at %s is not a list of mods" => "El contenido devuelto en %s no es una lista de mods",
"Can't chdir to '%s'" => "No es posible hacer chdir a '%s'",
"%s impossible to remove" => "imposible borrar %s",
// "Description not available" => "Description not available",
// "Module Title" => "Module Title",
// "Title to display at the top of the box" => "Title to display at the top of the box",
// "No Box" => "No Box",
// "Show only the content" => "Show only the content",
// "Decorations" => "Decorations",
// "Show module decorations" => "Show module decorations",
// "No Title" => "No Title",
// "Show module title" => "Show module title",
// "Module displayed depending on category. Multiple category ids or names can be separated by semi-colons" => "Module displayed depending on category. Multiple category ids or names can be separated by semi-colons",
// "No Category" => "No Category",
// "Module hidden depending on category. Multiple category ids or names can be separated by semi-colons. This takes precedence over the category parameter above" => "Module hidden depending on category. Multiple category ids or names can be separated by semi-colons. This takes precedence over the category parameter above",
// "Perspective" => "Perspective",
// "Only display the module if in one of the listed perspective IDs. Semi-colon separated" => "Only display the module if in one of the listed perspective IDs. Semi-colon separated",
// "Module only applicable for the specified languages. Languages are defined as two character language codes. Multiple values can be separated by semi-colons" => "Module only applicable for the specified languages. Languages are defined as two character language codes. Multiple values can be separated by semi-colons",
"Section" => "Sección",
// "Module only applicable for the specified sections. Multiple values can be separated by semi-colons" => "Module only applicable for the specified sections. Multiple values can be separated by semi-colons",
// "Page Filter" => "Page Filter",
// "Module only applicable on the specified page names. Multiple values can be separated by semi-colons" => "Module only applicable on the specified page names. Multiple values can be separated by semi-colons",
// "No Page" => "No Page",
// "Module not applicable on the specified page names. Multiple values can be separated by semi-colons" => "Module not applicable on the specified page names. Multiple values can be separated by semi-colons",
"Theme" => "Tema",
// "Module enabled or disabled depending on the theme file name (e.g. \"thenews.css\"). Specified themes can be either included or excluded. Theme names prefixed by \"!\" are in the exclusion list. Multiple values can be separated by semi-colons" => "Module enabled or disabled depending on the theme file name (e.g. \"thenews.css\"). Specified themes can be either included or excluded. Theme names prefixed by \"!\" are in the exclusion list. Multiple values can be separated by semi-colons",
// "Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module" => "Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module",
// "Contributor" => "Contributor",
// "Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module" => "Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module",
// "Flip" => "Flip",
// "Users can shade module" => "Users can shade module",
"Style" => "Estilo",
// "CSS styling for positioning the module" => "CSS styling for positioning the module",
// "Class" => "Class",
// "Custom CSS class" => "Custom CSS class",
// "Containing Class" => "Containing Class",
// "Custom CSS class around" => "Custom CSS class around",
// "No Numbers" => "No Numbers",
// "If set to \"y\", the module will not number list items" => "If set to \"y\", the module will not number list items",
"Rows" => "Filas",
// "Number of rows, or items, to display" => "Number of rows, or items, to display",
// "Default: 10" => "Default: 10",
// "Failed to execute \"%0\" module" => "Failed to execute \"%0\" module",
// "Missing dependencies" => "Missing dependencies",
// "Contact the system administrator" => "Contact the system administrator",
"Newsletter subscription information at" => "Subscripción al boletín de información en",
"Error" => "Error",
// "Limiting the email send rate. Resuming in %0 seconds" => "Limiting the email send rate. Resuming in %0 seconds",
// "invalid email" => "invalid email",
// "Sending to" => "Sending to",
"A user registers" => "Un usuario se registra",
"A user submits an article" => "Un usuario envía una colaboración",
// "A user edits an article" => "A user edits an article",
// "A user deletes an article" => "A user deletes an article",
// "An article is submitted, edited, deleted or commented on" => "An article is submitted, edited, deleted or commented on",
// "A new blog post is published" => "A new blog post is published",
// "A wiki page is created, deleted or edited, except for minor changes" => "A wiki page is created, deleted or edited, except for minor changes",
// "A wiki page is created, deleted or edited, even for minor changes" => "A wiki page is created, deleted or edited, even for minor changes",
// "A comment in a wiki page is posted or edited" => "A comment in a wiki page is posted or edited",
// "A comment in an article is posted or edited" => "A comment in an article is posted or edited",
// "Token is called" => "Token is called",
// "User joins a group" => "User joins a group",
"section edit" => "sección de edición",
"Edit Section" => "Edita Sección",
"index" => "índice",
"Table of contents" => "Tabla de contenidos",
"Show/Hide" => "Mostrar/Ocultar",
// "smiling" => "smiling",
"sad" => "triste",
// "grinning" => "grinning",
"confused" => "confundido",
"cool" => "cool",
// "crying" => "crying",
// "frightened" => "frightened",
// "evil stuff" => "evil stuff",
// "exclamation mark " => "exclamation mark ",
// "frowning" => "frowning",
// "light bulb" => "light bulb",
// "idea " => "idea ",
// "LOL" => "LOL",
// "laughing out loud " => "laughing out loud ",
"mad" => "loco",
// "Mr. Green laughing" => "Mr. Green laughing",
// "Payment sent but verification not currently available. (Work in progress)" => "Payment sent but verification not currently available. (Work in progress)",
// "Gift card is not valid for products in cart" => "Gift card is not valid for products in cart",
// "Bundled Product" => "Bundled Product",
// "Product" => "Product",
// "Quantity" => "Quantity",
// "Unit Price" => "Unit Price",
// "There is not enough inventory left for your request" => "There is not enough inventory left for your request",
// "Registration Check-Out" => "Registration Check-Out",
// "Gift Certificate: " => "Gift Certificate: ",
// "Gift Certificate Amount Used: " => "Gift Certificate Amount Used: ",
// "No registries specified in admin/payment/cclite" => "No registries specified in admin/payment/cclite",
// "Cclite payment initiated on %0" => "Cclite payment initiated on %0",
// "Connection to cclite server %0 failed for %1<br />\"%2\"" => "Connection to cclite server %0 failed for %1<br />\"%2\"",
// "Tiki credits payment done on %0 for %1 (using %2)" => "Tiki credits payment done on %0 for %1 (using %2)",
// "No category jail set in any perspective" => "No category jail set in any perspective",
// "Areas root category id" => "Areas root category id",
// "is invalid" => "is invalid",
// "Ajax auto-save" => "Ajax auto-save",
// "Saves your edits as you go along enabling you to recover your work after an \"interruption\". Also enables \"Live\" preview and is required for wysiwyg plugin processing" => "Saves your edits as you go along enabling you to recover your work after an \"interruption\". Also enables \"Live\" preview and is required for wysiwyg plugin processing",
"Users accept internal messages by default" => "Los usuarios aceptan mensajes internos por defecto",
// "Users can opt-out of internal messages" => "Users can opt-out of internal messages",
// "Id of category whose children are bound to a perspective by areas" => "Id of category whose children are bound to a perspective by areas",
"Newest first" => "Más nuevos primero",
"ascending" => "ascendente",
"descending" => "descendente",
// "Article ordering" => "Article ordering",
// "Default sort mode for the articles on the article listing" => "Default sort mode for the articles on the article listing",
// "Title of articles home page" => "Title of articles home page",
"Topic" => "Tema",
"Title" => "Título",
// "Title length" => "Title length",
// "Publication date" => "Publication date",
// "Expiration date" => "Expiration date",
"Visible" => "Visible",
"Author" => "Autor",
// "Author Rating" => "Author Rating",
"Reads" => "Lecturas",
"Id" => "Id",
// "Trailer position" => "Trailer position",
"Top" => "Top",
// "Between heading and body" => "Between heading and body",
// "Header text position" => "Header text position",
// "Requires a smaller image for list view" => "Requires a smaller image for list view",
// "Next image" => "Next image",
// "Below image" => "Below image",
"Oldest first" => "Más viejos primero",
"Points" => "Puntos",
// "Default number per page" => "Default number per page",
// "Default Ordering" => "Default Ordering",
// "Paginate articles" => "Paginate articles",
// "Divide articles into multiple pages with pagebreak markers" => "Divide articles into multiple pages with pagebreak markers",
// "User ratings on articles" => "User ratings on articles",
// "Allows users to rate the articles" => "Allows users to rate the articles",
// "Article rating options" => "Article rating options",
// "List of options available for the rating of articles" => "List of options available for the rating of articles",
// "Default maximum width for custom article images" => "Default maximum width for custom article images",
// "Number of pixels, 0 for no maximum" => "Number of pixels, 0 for no maximum",
// "Default maximum height for custom article images" => "Default maximum height for custom article images",
// "Default maximum width for custom article images in list mode (on View Articles)" => "Default maximum width for custom article images in list mode (on View Articles)",
// "Number of pixels, 0 to fallback to the view mode maximum" => "Number of pixels, 0 to fallback to the view mode maximum",
// "Default maximum height for custom article images in list mode (on View Articles)" => "Default maximum height for custom article images in list mode (on View Articles)",
// "Custom attributes for article types" => "Custom attributes for article types",
// "Allow additional custom fields for article types" => "Allow additional custom fields for article types",
// "Your ShareThis publisher identifier (optional)" => "Your ShareThis publisher identifier (optional)",
// "Related articles" => "Related articles",
// "Display a list of related articles at the bottom of the article page" => "Display a list of related articles at the bottom of the article page",
"Authentication method" => "Método de autenticacion",
// "Tiki supports several authentication methods. The default value is to use the internal user database" => "Tiki supports several authentication methods. The default value is to use the internal user database",
// "Tiki" => "Tiki",
// "Tiki and OpenID" => "Tiki and OpenID",
"Tiki and PAM" => "Tiki y PAM",
// "Tiki and LDAP" => "Tiki and LDAP",
"CAS (Central Authentication Service)" => "CAS (Servicio de Autenticación Central)",
"Shibboleth" => "Shibboleth",
"Web Server" => "Servidor Web",
// "phpBB" => "phpBB",
// "Token Access" => "Token Access",
// "Allow to access the content with superior rights with the presentation of a token. The primary use of this authentication method is to grant temporary access to content to an external service" => "Allow to access the content with superior rights with the presentation of a token. The primary use of this authentication method is to grant temporary access to content to an external service",
// "Token Access Max Timeout" => "Token Access Max Timeout",
// "The maximum duration for which the generated tokens will be valid" => "The maximum duration for which the generated tokens will be valid",
// "(seconds)" => "(seconds)",
// "Token Access Max Hits" => "Token Access Max Hits",
// "The maximum amount of times a token can be used before it expires" => "The maximum amount of times a token can be used before it expires",
// "Share access rights with friends when using Tell a friend" => "Share access rights with friends when using Tell a friend",
// "Allow users to share their access rights on the current page with a friend when sending the link by email. Lifespan of the links is defined by the site" => "Allow users to share their access rights on the current page with a friend when sending the link by email. Lifespan of the links is defined by the site",
// "Share access rights with friends when using Share" => "Share access rights with friends when using Share",
// "Allow users to share their access rights on the current page with a friend when sending the link by email/Twitter/Facebook. Lifespan of the links is defined by the site" => "Allow users to share their access rights on the current page with a friend when sending the link by email/Twitter/Facebook. Lifespan of the links is defined by the site",
// "Create user if not in Tiki" => "Create user if not in Tiki",
// "Use Tiki authentication for Admin login" => "Use Tiki authentication for Admin login",
// "phpBB Version" => "phpBB Version",
"3" => "3",
// "phpBB Database Hostname" => "phpBB Database Hostname",
// "phpBB Database Username" => "phpBB Database Username",
// "phpBB Database Password" => "phpBB Database Password",
// "phpBB Database Name" => "phpBB Database Name",
// "phpBB Table Prefix" => "phpBB Table Prefix",
// "Use Tiki authentication for users created in Tiki" => "Use Tiki authentication for users created in Tiki",
// "Host" => "Host",
"Port" => "Puerto",
// "Write LDAP debug Information in Tiki Logs" => "Write LDAP debug Information in Tiki Logs",
// "Use SSL (ldaps)" => "Use SSL (ldaps)",
// "Use TLS" => "Use TLS",
// "LDAP Bind Type" => "LDAP Bind Type",
// "Default: Anonymous Bind" => "Default: Anonymous Bind",
// "Full: userattr=username,UserDN,BaseDN" => "Full: userattr=username,UserDN,BaseDN",
// "OpenLDAP: cn=username,BaseDN" => "OpenLDAP: cn=username,BaseDN",
// "Active Directory (username@domain)" => "Active Directory (username@domain)",
// "Plain Username" => "Plain Username",
// "Search scope" => "Search scope",
// "Subtree" => "Subtree",
// "One level" => "One level",
// "Base object" => "Base object",
// "LDAP version" => "LDAP version",
// "Base DN" => "Base DN",
// "User DN" => "User DN",
// "User attribute" => "User attribute",
// "User OC" => "User OC",
// "Realname attribute" => "Realname attribute",
// "Country attribute" => "Country attribute",
// "E-mail attribute" => "E-mail attribute",
// "Group DN" => "Group DN",
// "Group name attribute" => "Group name attribute",
// "Group description attribute" => "Group description attribute",
// "Group OC" => "Group OC",
// "Member attribute" => "Member attribute",
// "Member is DN" => "Member is DN",
// "Group attribute" => "Group attribute",
// "Group attribute in group entry" => "Group attribute in group entry",
// "(Leave this empty if the group name is already given in the user attribute)" => "(Leave this empty if the group name is already given in the user attribute)",
// "Admin user" => "Admin user",
// "Admin password" => "Admin password",
// "Use an external LDAP server for groups" => "Use an external LDAP server for groups",
// "Corresponding user attribute in 1st directory" => "Corresponding user attribute in 1st directory",
// "Disable Tiki users who don't have a phpBB login. (They could have been deleted)" => "Disable Tiki users who don't have a phpBB login. (They could have been deleted)",
// "Available languages" => "Available languages",
// "By default, all languages supported by tikiwiki are available on multilingual sites. This option allows to limit the languages to a subset" => "By default, all languages supported by tikiwiki are available on multilingual sites. This option allows to limit the languages to a subset",
// "Available styles" => "Available styles",
// "BigBlueButton Web Conferencing" => "BigBlueButton Web Conferencing",
// "Integration with the BigBlueButton collaboration server for web conference and screen sharing" => "Integration with the BigBlueButton collaboration server for web conference and screen sharing",
// "BigBlueButton server location" => "BigBlueButton server location",
// "Full URL to the BigBlueButton installation" => "Full URL to the BigBlueButton installation",
// "http://host.example.com/" => "http://host.example.com/",
// "BigBlueButton server salt" => "BigBlueButton server salt",
// "A salt key used to generate checksums for the BigBlueButton server to know the requests are authentic" => "A salt key used to generate checksums for the BigBlueButton server to know the requests are authentic",
// "BigBlueButton recording maximum duration" => "BigBlueButton recording maximum duration",
// "A maximum duration for the meetings must be provided to BigBlueButton to prevent the recordings to be excessively long if a user leaves the window open too long" => "A maximum duration for the meetings must be provided to BigBlueButton to prevent the recordings to be excessively long if a user leaves the window open too long",
"minutes" => "minutos",
// "Default ordering" => "Default ordering",
"Creation Date (desc)" => "Fecha de creación (desc)",
"Last modification date (desc)" => "Fecha de última modificación (desc)",
"Blog title (asc)" => "Título del blog (asc)",
"Number of posts (desc)" => "Número de posts (desc)",
"Visits (desc)" => "Visitas (desc)",
"Activity (desc)" => "Actividad (desc)",
"Last modified" => "Última modificación",
"Disabled" => "Deshabilitado",
"Link to user information" => "Enlace a información de usuario",
"User avatar" => "Avatar de usuario",
"Posts" => "Mensajes",
"Visits" => "Visitas",
"Activity" => "Actividad",
// "Module (box) shadow start" => "Module (box) shadow start",
// "Module (box) shadow end" => "Module (box) shadow end",
// "Days to display in the Calendar" => "Days to display in the Calendar",
// "Default view mode" => "Default view mode",
"Day" => "Día",
"Week" => "Semana",
"Month" => "Mes",
"Quarter" => "Cuatrimestre",
"Semester" => "Semestre",
"Year" => "Año",
// "View list begins" => "View list begins",
// "Focus Date" => "Focus Date",
// "Period beginning" => "Period beginning",
// "First day of the week" => "First day of the week",
"Depends user language" => "Depende del idioma del usuario",
// "Split hours in periods of" => "Split hours in periods of",
// "1 minute" => "1 minute",
"5 minutes" => "5 minutos",
// "10 minutes" => "10 minutes",
"15 minutes" => "15 minutos",
"30 minutes" => "30 minutos",
// "First year in the dropdown" => "First year in the dropdown",
// "Enter a year or use +/- N to specify a year relative to the current year" => "Enter a year or use +/- N to specify a year relative to the current year",
// "Last year in the dropdown" => "Last year in the dropdown",
// "Sticky popup" => "Sticky popup",
// "Item view tab" => "Item view tab",
// "Show Add to Google Calendar icon" => "Show Add to Google Calendar icon",
// "Show Export Calendars button" => "Show Export Calendars button",
// "Use FullCalendar to display Calendars" => "Use FullCalendar to display Calendars",
// "Treat calendar item descriptions as HTML" => "Treat calendar item descriptions as HTML",
// "Use this if you use the WYSIWYG editor for calendars. This is to handle legacy data from Tiki pre 7.0" => "Use this if you use the WYSIWYG editor for calendars. This is to handle legacy data from Tiki pre 7.0",
// "Word length of the captcha image" => "Word length of the captcha image",
// "Default" => "Default",
// "Width of the captcha image in pixels" => "Width of the captcha image in pixels",
// "Level of noise of the captcha image" => "Level of noise of the captcha image",
// "Choose a smaller number for less noise and easier reading" => "Choose a smaller number for less noise and easier reading",
// "Try automatically to connect SSO" => "Try automatically to connect SSO",
// "Force CAS log-out when the user logs out from Tiki" => "Force CAS log-out when the user logs out from Tiki",
// "Show Alternate Login Method in Header" => "Show Alternate Login Method in Header",
"CAS server version" => "Versión de servidor CAS",
"none" => "ning",
"Version 1.0" => "Versión 1.0",
"Version 2.0" => "Versión 2.0",
// "Hostname" => "Hostname",
// "Hostname of the CAS server" => "Hostname of the CAS server",
// "Port of the CAS server" => "Port of the CAS server",
// "Path for the CAS server" => "Path for the CAS server",
// "CAS Extra Parameter" => "CAS Extra Parameter",
// "Extra Parameter to pass to the CAS Server" => "Extra Parameter to pass to the CAS Server",
// "CAS Authentication Verification Timeout" => "CAS Authentication Verification Timeout",
// "Verify authentication with the CAS server every N seconds. Null value means never reverify" => "Verify authentication with the CAS server every N seconds. Null value means never reverify",
"Never" => "Nunca",
// "2 minutes" => "2 minutes",
"1 hour" => "1 hora",
// "Categories used in templates (TPL)" => "Categories used in templates (TPL)",
// "Permits to show alternate content depending on category of current object" => "Permits to show alternate content depending on category of current object",
// "Category Jail" => "Category Jail",
// "Limits the visibility of objects to those in these category IDs. Used mainly for creating workspaces from perspectives" => "Limits the visibility of objects to those in these category IDs. Used mainly for creating workspaces from perspectives",
// "Category Defaults" => "Category Defaults",
// "Force certain categories to be present. If none of the categories in a given set are provided, assign a category by default" => "Force certain categories to be present. If none of the categories in a given set are provided, assign a category by default",
// "Use *7 to specify all the categories in the subtree of 7 + category 7" => "Use *7 to specify all the categories in the subtree of 7 + category 7",
// "Can do only this for objectname matching the regex (Example: /^RND_/ = name beginning by RND_)(Optional)" => "Can do only this for objectname matching the regex (Example: /^RND_/ = name beginning by RND_)(Optional)",
// "Can do for wiki only (optional)" => "Can do for wiki only (optional)",
// "Rename will only reassign the categories for wiki pages" => "Rename will only reassign the categories for wiki pages",
// "One per line. ex:1,4,6,*7/4:/^RND_/:wiki page" => "One per line. ex:1,4,6,*7/4:/^RND_/:wiki page",
// "Synchronize multilingual categories" => "Synchronize multilingual categories",
// "Make sure that the categories on the translations are synchronized when modified on any version" => "Make sure that the categories on the translations are synchronized when modified on any version",
// "Only those specified" => "Only those specified",
// "All but those specified" => "All but those specified",
// "Synchronized categories" => "Synchronized categories",
// "List of categories affected by the multilingual synchronization. Depending on the parent feature, this list will be used as a white list (only categories allows) or as a black list (all except thoses specified)" => "List of categories affected by the multilingual synchronization. Depending on the parent feature, this list will be used as a white list (only categories allows) or as a black list (all except thoses specified)",
// "Sort categories by legacy ASCII sequence" => "Sort categories by legacy ASCII sequence",
// "If turned on, will sort categories taking into account all characters as upper case, in ASCII sequence, will only consider limited set of accented characters. Might be needed to be able to override the normal sort by prepending punctuation characters to category names, such as \"-\" to sort at the beginning and \"[\" to sort at the end" => "If turned on, will sort categories taking into account all characters as upper case, in ASCII sequence, will only consider limited set of accented characters. Might be needed to be able to override the normal sort by prepending punctuation characters to category names, such as \"-\" to sort at the beginning and \"[\" to sort at the end",
// "Automatically geocode items when categorized in" => "Automatically geocode items when categorized in",
// "Automatically geocode items based on category name when categorized in the sub-categories of this category ID" => "Automatically geocode items based on category name when categorized in the sub-categories of this category ID",
// "Replace existing geocode if any" => "Replace existing geocode if any",
// "When automatically geocoding items based on category name, replace existing geocode if any" => "When automatically geocoding items based on category name, replace existing geocode if any",
// "Use approximate geocode location" => "Use approximate geocode location",
// "When automatically geocoding items based on category name, use randomly approximated location instead of precise location" => "When automatically geocoding items based on category name, use randomly approximated location instead of precise location",
// "\"More Like This\" algorithm for categories" => "\"More Like This\" algorithm for categories",
// "Basic" => "Basic",
// "Weighted" => "Weighted",
// "Minimum number of categories in common" => "Minimum number of categories in common",
"1" => "1",
"2" => "2",
"4" => "4",
"5" => "5",
// "6" => "6",
// "7" => "7",
// "8" => "8",
// "9" => "9",
// "10" => "10",
// "Or look for the maximum less categories in common if no objects with the above number of common categories" => "Or look for the maximum less categories in common if no objects with the above number of common categories",
// "Maximum of objects more like this, otherwise use the default max records" => "Maximum of objects more like this, otherwise use the default max records",
// "Exclude these category IDs" => "Exclude these category IDs",
// "Category path won't appear for these category IDs" => "Category path won't appear for these category IDs",
// "Center shadow start" => "Center shadow start",
// "Center shadow end" => "Center shadow end",
// "Users can change site language" => "Users can change site language",
// "Allow users to change the language of the menus and labels" => "Allow users to change the language of the menus and labels",
"Users can change theme" => "Usuarios registrados pueden cambiar tema",
// "Users can change their password" => "Users can change their password",
// "Disable title for comments" => "Disable title for comments",
// "Hide the title field on comments and their replies" => "Hide the title field on comments and their replies",
// "Email field" => "Email field",
// "Email field for comments (only for anonymous users)" => "Email field for comments (only for anonymous users)",
// "Website field" => "Website field",
// "Website field for comments (only for anonymous users)" => "Website field for comments (only for anonymous users)",
// "Use vote system for comments" => "Use vote system for comments",
// "Allows users with permission tiki_p_vote_comments to vote comments" => "Allows users with permission tiki_p_vote_comments to vote comments",
// "Archive comments" => "Archive comments",
// "If a comment is archived, only admins can see it" => "If a comment is archived, only admins can see it",
// "Use Akismet to filter comments" => "Use Akismet to filter comments",
// "Prevent comment spam by using the Akismet service to determine if the comment is spam. If comment moderation is enabled, the Akismet will indicate if the comment is to be moderated or not. If there is no comment moderation, the comment will be rejected if considered as spam" => "Prevent comment spam by using the Akismet service to determine if the comment is spam. If comment moderation is enabled, the Akismet will indicate if the comment is to be moderated or not. If there is no comment moderation, the comment will be rejected if considered as spam",
// "Akismet API Key" => "Akismet API Key",
// "Key required for the Akismet comment spam prevention to work" => "Key required for the Akismet comment spam prevention to work",
// "Obtain this key by registering your site on [%0]" => "Obtain this key by registering your site on [%0]",
// "Filter spam for registered users" => "Filter spam for registered users",
// "Enable spam filtering for registered users as well. Useful if your site allows for anyone to register without much validation" => "Enable spam filtering for registered users as well. Useful if your site allows for anyone to register without much validation",
// "Allow comments to be corrected by their author" => "Allow comments to be corrected by their author",
// "Allow comments to be modified by their author shortly after posting it, allowing to correct broken links or typos for a period of 30 minutes" => "Allow comments to be modified by their author shortly after posting it, allowing to correct broken links or typos for a period of 30 minutes",
// "Tiki Connect" => "Tiki Connect",
// "Connect your Tiki with the community by sending anonymised statistical data to tiki.org" => "Connect your Tiki with the community by sending anonymised statistical data to tiki.org",
// "Experimental. This feature is still under development" => "Experimental. This feature is still under development",
// "Send Site Information" => "Send Site Information",
// "Additionally send keywords, location etc to tiki.org so you can connect with Tikis near you" => "Additionally send keywords, location etc to tiki.org so you can connect with Tikis near you",
// "Site Title" => "Site Title",
// "Name of site on Tiki Connect" => "Name of site on Tiki Connect",
// "Email Contact" => "Email Contact",
// "Email to register" => "Email to register",
// "URL to register" => "URL to register",
// "Key Words" => "Key Words",
// "Key words or tags describing your site" => "Key words or tags describing your site",
// "Site Location" => "Site Location",
// "Site location as longitude,latitude,zoom" => "Site location as longitude,latitude,zoom",
// "Send Anonymous Information" => "Send Anonymous Information",
// "Send anonymous usage information" => "Send anonymous usage information",
// "Connection frequency" => "Connection frequency",
// "How often to send information (in hours)" => "How often to send information (in hours)",
// "weekly" => "weekly",
// "Experimental. Currently unused, click \"Send Info\" to connect" => "Experimental. Currently unused, click \"Send Info\" to connect",
// "Tiki Connect Server URL" => "Tiki Connect Server URL",
// "Where to send the information" => "Where to send the information",
// "Last connection" => "Last connection",
// "Connect Server Mode" => "Connect Server Mode",
// "For use by mother.tiki.org" => "For use by mother.tiki.org",
// "Connect GUID" => "Connect GUID",
// "For use by mother.tiki.org. Do not modify" => "For use by mother.tiki.org. Do not modify",
// "Allow anonymous visitors to use the \"Contact Us\" feature" => "Allow anonymous visitors to use the \"Contact Us\" feature",
"Contact user" => "Contactar usuario",
// "Cookie name" => "Cookie name",
// "Domain" => "Domain",
"Count admin pageviews" => "Contar pageviews de admin",
// "Include pageviews by the Admin when reporting stats" => "Include pageviews by the Admin when reporting stats",
// "Enable daily reports for new users" => "Enable daily reports for new users",
// "Default charset for sending mail" => "Default charset for sending mail",
"utf-8" => "utf-8",
"iso-8859-1" => "iso-8859-1",
"default mapfile" => "archivo de mapa por defecto",
// "Default diff style" => "Default diff style",
"Only with last version" => "Sólo con ultima versión",
// "HTML diff" => "HTML diff",
"Side-by-side diff" => "diff lado a lado",
// "Side-by-side diff by characters" => "Side-by-side diff by characters",
// "Inline diff" => "Inline diff",
// "Inline diff by characters" => "Inline diff by characters",
"Full side-by-side diff" => "diff lado a lado completo",
// "Full side-by-side diff by characters" => "Full side-by-side diff by characters",
// "Full inline diff" => "Full inline diff",
// "Full inline diff by characters" => "Full inline diff by characters",
"Unified diff" => "diff unificado",
"Side-by-side view" => "Vista lado a lado",
"rows" => "líneas",
// "Default number of rows for comment box" => "Default number of rows for comment box",
"Forum" => "Foro",
// "Forum reply" => "Forum reply",
// "Default Editor" => "Default Editor",
"Simple" => "Simple",
"Advanced" => "Avanzado",
// "Disable browser's autocomplete feature for username and password fields" => "Disable browser's autocomplete feature for username and password fields",
"Use direct pagination links" => "Usar enlaces de paginación directa",
// "Max. number of links around the current item" => "Max. number of links around the current item",
// "Max. number of links after the first or before the last item" => "Max. number of links after the first or before the last item",
// "Show Country Flag" => "Show Country Flag",
// "Show the country flag" => "Show the country flag",
// "Enable cool sites" => "Enable cool sites",
"Validate URLs" => "Validar URLs",
// "Number of columns per page when listing directory categories" => "Number of columns per page when listing directory categories",
"Links per page" => "Enlaces por página",
// "Method to Open Directory Links" => "Method to Open Directory Links",
"Method to open directory links" => "Método para abrir enlaces del directorio",
"replace current window" => "reemplazar ventana actual",
"new window" => "nueva ventana",
"inline frame" => "marco embebido",
// "Fields display order" => "Fields display order",
"Re-validate user by email after" => "Re-valida a los usuarios por correo-e despues de",
"days" => "días",
"Use \"-1\" for never" => "Usa \"-1\" para nunca",
"Email footer" => "Pie de página de los correos-e",
"Text appended to outgoing emails" => "Texto a añadir a los correos salientes",
"PHP errors visible to admin only" => "Los errores de PHP visibles sólo a los administradores",
// "For development purposes, it's better to display errors for all users. However, in production settings, they should only be displayed to administrators" => "For development purposes, it's better to display errors for all users. However, in production settings, they should only be displayed to administrators",
"PHP Error reporting level" => "Nivel de informe de errores PHP",
"Level from which errors should be reported" => "Nivel para el cual se debe informar de errores",
"No error reporting" => "Sin informes de errores",
"Report all PHP errors except strict" => "Informa de todos los errores PHP menos los estrictos",
"Report all PHP errors" => "Informa de todos los errores de PHP",
"Report all PHP errors except notices" => "Informa de todos los errores PHP menos los avisos",
"According to PHP configuration" => "De acuerdo con la configuración de PHP",
"Default number of comments per page" => "Cantidad por defecto de comentarios por página",
"Comments default ordering" => "Orden por defecto para comentarios",
// "Question and Answer prefix on Answers" => "Question and Answer prefix on Answers",
"Q and A" => "Preguntas y Respuesta",
"Question ID" => "ID de la Pregunta",
"Blog" => "Blog",
// "Force and limit categorization to within subtree of" => "Force and limit categorization to within subtree of",
// "If you get an error message indicating a mandatory category is required when editing a blog post, this is the option to blame. Set it to None" => "If you get an error message indicating a mandatory category is required when editing a blog post, this is the option to blame. Set it to None",
// "Areas" => "Areas",
// "Binding categories and perspectives to each other" => "Binding categories and perspectives to each other",
// "Collaboratively authored documents with history of changes" => "Collaboratively authored documents with history of changes",
// "Online diaries or journals" => "Online diaries or journals",
// "Collections of graphic images for viewing or downloading (photo album)" => "Collections of graphic images for viewing or downloading (photo album)",
// "You can use file galleries instead" => "You can use file galleries instead",
// "Machine Translation (by Google Translate)" => "Machine Translation (by Google Translate)",
// "Uses Google Translate to translate the content of wiki pages to other languages" => "Uses Google Translate to translate the content of wiki pages to other languages",
// "Experimental" => "Experimental",
"Database & form generator" => "Generador de Formularios y Bases de Datos (BD)",
"Reports" => "Informes",
"Reports Generator" => "Generador de Informes",
// "Online discussions on a variety of topics. Threaded or flat" => "Online discussions on a variety of topics. Threaded or flat",
// "Computer files, videos or software for downloading. With check-in & check-out (lock)" => "Computer files, videos or software for downloading. With check-in & check-out (lock)",
// "Save files as drafts" => "Save files as drafts",
// "File Galleries configuration templates" => "File Galleries configuration templates",
"template" => "plantilla",
// "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"" => "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"",
"Polls" => "Votaciones",
// "Brief list of votable options; appears in module (left or right column)" => "Brief list of votable options; appears in module (left or right column)",
"Newsletters" => "Boletines",
// "Content mailed to registered users" => "Content mailed to registered users",
"Calendar" => "Calendario",
// "Events calendar with public, private and group channels" => "Events calendar with public, private and group channels",
"Banners" => "Banners",
// "Insert, track, and manage advertising banners" => "Insert, track, and manage advertising banners",
// "Global category system. Items of different types (wiki pages, articles, tracker items, etc) can be added to one or many categories. Categories can have permissions" => "Global category system. Items of different types (wiki pages, articles, tracker items, etc) can be added to one or many categories. Categories can have permissions",
"Score" => "Puntuación",
// "Score is a game to motivate participants to increase their contribution by comparing to other users" => "Score is a game to motivate participants to increase their contribution by comparing to other users",
// "Unified Search" => "Unified Search",
// "Enables searching for content on the website, using Tiki-managed index" => "Enables searching for content on the website, using Tiki-managed index",
// "Allows to set tags on pages and various objects within the website and generate tag cloud navigation patterns" => "Allows to set tags on pages and various objects within the website and generate tag cloud navigation patterns",
"Action Log" => "Registro de acciones",
// "Allows to keep track of what users are doing and produce reports on a per-user or per-category basis" => "Allows to keep track of what users are doing and produce reports on a per-user or per-category basis",
// "Contribution" => "Contribution",
// "Allows users to specify the type of contribution they are making while editing objects. The contributions are then displayed as color-coded in history and other reports" => "Allows users to specify the type of contribution they are making while editing objects. The contributions are then displayed as color-coded in history and other reports",
"Multilingual" => "Multilingual",
// "Enables internationalization features and multilingual support for then entire site" => "Enables internationalization features and multilingual support for then entire site",
"FAQ" => "FAQ",
// "Frequently asked questions and answers" => "Frequently asked questions and answers",
// "You can use wiki pages instead" => "You can use wiki pages instead",
"Surveys" => "Encuestas",
// "Questionnaire with multiple choice or open ended question" => "Questionnaire with multiple choice or open ended question",
// "User-submitted Web links" => "User-submitted Web links",
// "Timed questionnaire with recorded scores" => "Timed questionnaire with recorded scores",
"Featured Links" => "Enlaces destacados",
// "Simple menu system which can optionally add an external web page in an iframe" => "Simple menu system which can optionally add an external web page in an iframe",
"Copyright" => "Copyright",
// "The Copyright Management System (or ©MS) is a way of licensing your content" => "The Copyright Management System (or ©MS) is a way of licensing your content",
"Shoutbox" => "Shoutbox",
// "Quick comment (graffiti) box. Like a group chat, but not in real time" => "Quick comment (graffiti) box. Like a group chat, but not in real time",
// "MapServer" => "MapServer",
// "Navigable, interactive maps with user-selectable layers" => "Navigable, interactive maps with user-selectable layers",
// "Requires MapServer" => "Requires MapServer",
// "Google Maps" => "Google Maps",
// "Interactive use of Google Maps" => "Interactive use of Google Maps",
"Live support system" => "Sistema de soporte Live",
// "One-on-one chatting with customer" => "One-on-one chatting with customer",
// "Tell a Friend" => "Tell a Friend",
// "Add a link \"Email this page\" in all the pages" => "Add a link \"Email this page\" in all the pages",
// "Share" => "Share",
// "Add a \"Share\" link in all pages to send it via e-mail, Twitter, Facebook, message or forums" => "Add a \"Share\" link in all pages to send it via e-mail, Twitter, Facebook, message or forums",
// "be careful when allowing to anonymous to activate the antibot feature" => "be careful when allowing to anonymous to activate the antibot feature",
// "HTML pages" => "HTML pages",
// "Static and dynamic HTML content" => "Static and dynamic HTML content",
// "HTML can be used in wiki pages. This is a separate feature" => "HTML can be used in wiki pages. This is a separate feature",
"Contact Us" => "Contáctenos",
// "Basic form from visitor to admin" => "Basic form from visitor to admin",
// "Minichat" => "Minichat",
// "Real-time group text chatting" => "Real-time group text chatting",
// "Comments Moderation" => "Comments Moderation",
// "An admin must validate a comment before it is visible" => "An admin must validate a comment before it is visible",
// "Comments Locking" => "Comments Locking",
// "Comments can be closed (no new comments)" => "Comments can be closed (no new comments)",
// "Allow logged in users to pretend to be anonymous when posting a commment" => "Allow logged in users to pretend to be anonymous when posting a commment",
// "This can be used to encourage honest feedback with the opportunity to voice an opinion anonymously. Like in a forum where you ask feedback on what is done wrong or should be improved internally" => "This can be used to encourage honest feedback with the opportunity to voice an opinion anonymously. Like in a forum where you ask feedback on what is done wrong or should be improved internally",
// "Display page description" => "Display page description",
// "Display the page description below the heading when viewing the page" => "Display the page description below the heading when viewing the page",
// "Display page name as page title" => "Display page name as page title",
// "Display the page name at the top of each page as page title. If not enabled, the page content should be structured to contain a header" => "Display the page name at the top of each page as page title. If not enabled, the page content should be structured to contain a header",
// "Display page ID" => "Display page ID",
// "Display the internal page ID when viewing the page" => "Display the internal page ID when viewing the page",
// "Individual wiki cache" => "Individual wiki cache",
// "Allow users to change the duration of the cache on a per-page basis" => "Allow users to change the duration of the cache on a per-page basis",
// "JS Calendar" => "JS Calendar",
// "JavaScript popup date selector. Will use jQuery UI DatePicker if enabled" => "JavaScript popup date selector. Will use jQuery UI DatePicker if enabled",
// "Output should be HTML Purified" => "Output should be HTML Purified",
// "This enables HTML Purifier on outputs to filter potential remaining security problems like XSS" => "This enables HTML Purifier on outputs to filter potential remaining security problems like XSS",
"Full Screen" => "Pantalla Completa",
// "Allow users to activate fullscreen mode" => "Allow users to activate fullscreen mode",
// "CSS Menus" => "CSS Menus",
// "CSS Menus (suckerfish)" => "CSS Menus (suckerfish)",
// "Shadowbox / ColorBox" => "Shadowbox / ColorBox",
// "\"Displaying content with Eye Candy\". <br />Uses jQuery plugin \"ColorBox\". e.g. <code>{img fileId=\"42\" thumb=\"y\" alt=\"\" rel=\"box[g]\"}</code>" => "\"Displaying content with Eye Candy\". <br />Uses jQuery plugin \"ColorBox\". e.g. <code>{img fileId=\"42\" thumb=\"y\" alt=\"\" rel=\"box[g]\"}</code>",
// "Quick Permission Assignment" => "Quick Permission Assignment",
// "Quickperms allow to define classes of privileges and grant them to roles on objects" => "Quickperms allow to define classes of privileges and grant them to roles on objects",
// "HTML Purifier" => "HTML Purifier",
// "If you are trying to use HTML in your pages and it gets stripped out, you should make sure your HTML is valid or de-activate this feature" => "If you are trying to use HTML in your pages and it gets stripped out, you should make sure your HTML is valid or de-activate this feature",
// "Ajax" => "Ajax",
// "Morcego 3D browser" => "Morcego 3D browser",
// "Visualize relationships between wiki pages, in a 3D applet" => "Visualize relationships between wiki pages, in a 3D applet",
"Webmail" => "Webmail",
// "Intertiki" => "Intertiki",
// "Allows several Tiki sites (slaves) to get authentication from a master Tiki site" => "Allows several Tiki sites (slaves) to get authentication from a master Tiki site",
"Mail-in" => "Mail-in",
// "Populate wiki pages and articles by email" => "Populate wiki pages and articles by email",
// "Mindmap" => "Mindmap",
// "Print Indexed" => "Print Indexed",
// "Spreadsheet" => "Spreadsheet",
// "Datasheets with calculations and charts" => "Datasheets with calculations and charts",
// "Slideshow (jQuery.s5)" => "Slideshow (jQuery.s5)",
// "Web based slideshow" => "Web based slideshow",
// "Slideshow (jQuery.s5) PDF Export" => "Slideshow (jQuery.s5) PDF Export",
// "Web based slideshow to pdf export" => "Web based slideshow to pdf export",
// "Invoice" => "Invoice",
// "Invoice system" => "Invoice system",
"Wysiwyg editor" => "Editor wysiwyg",
// "WYSIWYG is an acronym for What You See Is What You Get. Uses CKEditor" => "WYSIWYG is an acronym for What You See Is What You Get. Uses CKEditor",
// "Kaltura Video Management" => "Kaltura Video Management",
// "Integration to the Kaltura video management platform" => "Integration to the Kaltura video management platform",
"Friendship Network" => "Círculo de Amistad",
// "Users can identify other users as their friends" => "Users can identify other users as their friends",
// "Neglected feature" => "Neglected feature",
"Banning system" => "Sistema de Banning",
// "Deny access to specific users based on username, IP, and date/time range" => "Deny access to specific users based on username, IP, and date/time range",
"Stats" => "Estadísticas",
// "Record basic statistics about major Tiki features (number of wiki pages, size of file galleries, etc.)" => "Record basic statistics about major Tiki features (number of wiki pages, size of file galleries, etc.)",
// "Action Calendar" => "Action Calendar",
"Referer Stats" => "Estadísticas de referers",
// "Record domain name of sites that send visitors to this Tiki" => "Record domain name of sites that send visitors to this Tiki",
// "Redirect On Error" => "Redirect On Error",
// "On error, goto the HomePage as configured in Admin->General" => "On error, goto the HomePage as configured in Admin->General",
"Communications (send/receive objects)" => "Comunicaciones (enviar/recibir objetos)",
// "Send/receive wiki pages and articles between Tiki-powered sites" => "Send/receive wiki pages and articles between Tiki-powered sites",
"Custom Home" => "Inicio Configurable",
"Mini Calendar" => "Mini Calendario",
"User Preferences Screen" => "Pantalla de Preferencias de Usuario",
"User Notepad" => "Cuaderno de notas",
"My Bookmarks" => "Marcadores del usuario",
// "User Contacts" => "User Contacts",
"User Watches" => "Suscripciones de Usuario",
// "Receive email notification of changes" => "Receive email notification of changes",
// "Group Watches" => "Group Watches",
// "Daily Reports for User Watches" => "Daily Reports for User Watches",
"User Watches Translations" => "Suscripciones de Usuario de Traducciones",
// "User Watches Languages" => "User Watches Languages",
// "Watch language-specific changes within a category" => "Watch language-specific changes within a category",
"User Menu" => "Menú de Usuario",
"User Tasks" => "Tareas del usuario",
"User Messages" => "Mensajes",
"User Files" => "Archivos de usuario",
// "Menu User Levels" => "Menu User Levels",
// "Allows to control the menu options that can be seen by a user" => "Allows to control the menu options that can be seen by a user",
// "Group Alert" => "Group Alert",
"Integrator" => "Integrator",
"XMLRPC API" => "XMLRPC API",
"Debugger Console" => "Consola del Depurador",
// "TikiTests" => "TikiTests",
// "Permits recording and playback of functional tests" => "Permits recording and playback of functional tests",
// "Check for updates automatically" => "Check for updates automatically",
// "Tiki will check for updates when you access the main Administration page" => "Tiki will check for updates when you access the main Administration page",
// "Require confirmation if possible CSRF detected" => "Require confirmation if possible CSRF detected",
"Protect against CSRF with a ticket" => "Proteger contra CSRF con un ticket",
"Detect browser language" => "Detectar lenguaje del navegador",
// "Lookup the user's preferred language through browser preferences" => "Lookup the user's preferred language through browser preferences",
// "Show pages in user's preferred language" => "Show pages in user's preferred language",
// "When accessing a page which has an equivalent in the user's preferred language, favor the translated page" => "When accessing a page which has an equivalent in the user's preferred language, favor the translated page",
// "Changing the page language also changes the site language" => "Changing the page language also changes the site language",
// "Translation assistant" => "Translation assistant",
// "Track translation operations between pages" => "Track translation operations between pages",
// "Urgent translation notifications" => "Urgent translation notifications",
// "Allow to flag changes as urgent, leading translations to be marked with a notice visible to all users" => "Allow to flag changes as urgent, leading translations to be marked with a notice visible to all users",
// "Incomplete translation notice" => "Incomplete translation notice",
// "When a page is translated to a new language, a notice will be automatically inserted into the page to indicate that the translation is not yet complete" => "When a page is translated to a new language, a notice will be automatically inserted into the page to indicate that the translation is not yet complete",
// "Multilingual structures" => "Multilingual structures",
// "Structures to lookup equivalent pages in other languages. May cause performance problems on larger structures" => "Structures to lookup equivalent pages in other languages. May cause performance problems on larger structures",
// "Display all languages in a single page" => "Display all languages in a single page",
// "List all languages as a language option in the page language drop list to see all languages at once" => "List all languages as a language option in the page language drop list to see all languages at once",
// "GZip output" => "GZip output",
// "Compress your pages on-the-fly, if the requesting browser supports this" => "Compress your pages on-the-fly, if the requesting browser supports this",
"Help System" => "Sistema de Ayuda",
// "Yahoo! Babel Fish Translation URLs" => "Yahoo! Babel Fish Translation URLs",
// "Show clickable URLs to translate the page to another language using Babel Fish website" => "Show clickable URLs to translate the page to another language using Babel Fish website",
// "You need to assign somewhere on the page via a module" => "You need to assign somewhere on the page via a module",
// "Yahoo! Babel Fish Translation icons" => "Yahoo! Babel Fish Translation icons",
// "Show clickable icons to translate the page to another language using Babel Fish website" => "Show clickable icons to translate the page to another language using Babel Fish website",
"Smileys" => "Emoticones",
// "Also known as emoticons" => "Also known as emoticons",
// "Draw (SVG-edit)" => "Draw (SVG-edit)",
// "Draw gives you the ability to edit SVG images all around Tiki" => "Draw gives you the ability to edit SVG images all around Tiki",
// "Draw (SVG-edit) Hide Buttons" => "Draw (SVG-edit) Hide Buttons",
// "Hide buttons found in Tiki Draw, HTML id, comma-delimited.  Example: \"tool_select,tool_fhpath,tools_line_show,tools_rect_show,tools_ellipse_show,tool_path,tools_shapelib_show,tool_text,tool_image,tool_zoom,tool_eyedropper\"" => "Hide buttons found in Tiki Draw, HTML id, comma-delimited.  Example: \"tool_select,tool_fhpath,tools_line_show,tools_rect_show,tools_ellipse_show,tool_path,tools_shapelib_show,tool_text,tool_image,tool_zoom,tool_eyedropper\"",
// "Docs (WebODF)" => "Docs (WebODF)",
// "Docs gives you the ability to view/edit Open Document Format" => "Docs gives you the ability to view/edit Open Document Format",
"Dynamic Content System" => "Systema de Contenido Dinámico",
// "Bloc of content which can be reused and programmed (timed)" => "Bloc of content which can be reused and programmed (timed)",
// "Use File Galleries to store pictures" => "Use File Galleries to store pictures",
// "If disabled, pictures will be stored in ../img/wiki_up/.. instead" => "If disabled, pictures will be stored in ../img/wiki_up/.. instead",
// "External link icon" => "External link icon",
// "External links will be identifed with an icon. Use the ../img/icons/external_link.gif image to customize the icon" => "External links will be identifed with an icon. Use the ../img/icons/external_link.gif image to customize the icon",
// "Add \"rel=nofollow\" on external links" => "Add \"rel=nofollow\" on external links",
// "Semantic links" => "Semantic links",
// "Going beyond Backlinks, allows to define some semantic relationships between wiki pages" => "Going beyond Backlinks, allows to define some semantic relationships between wiki pages",
// "Web Services" => "Web Services",
// "Can consume webservices in JSON or YAML" => "Can consume webservices in JSON or YAML",
"Display menus as folders" => "Desplegar menús como carpetas",
// "Breadcrumbs" => "Breadcrumbs",
// "Attempts to show you where you are" => "Attempts to show you where you are",
// "Anonymous editors must enter anti-bot code (CAPTCHA)" => "Anonymous editors must enter anti-bot code (CAPTCHA)",
// "Protect email against spam" => "Protect email against spam",
// "Protect email against spam currently does not operate in pages edited in WYSIWYG mode (Tiki 6.1)" => "Protect email against spam currently does not operate in pages edited in WYSIWYG mode (Tiki 6.1)",
"Activate" => "Activar",
// "Anonymous voting" => "Anonymous voting",
// "Allow re-voting" => "Allow re-voting",
// "Comments for polls" => "Comments for polls",
// "Comments for FAQs" => "Comments for FAQs",
// "Search engine friendly URL" => "Search engine friendly URL",
// "If you are using Apache, you can copy _htaccess to .htaccess to get Short URLs. On IIS, copy web_config to web.config" => "If you are using Apache, you can copy _htaccess to .htaccess to get Short URLs. On IIS, copy web_config to web.config",
// "Search engine friendly url Postfilter" => "Search engine friendly url Postfilter",
// "Display article title in the sefurl" => "Display article title in the sefurl",
// "Display blog title in the SEFURL" => "Display blog title in the SEFURL",
// "Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page" => "Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page",
// "This redirection uses the wiki prefix alias feature" => "This redirection uses the wiki prefix alias feature",
// "Canonical URL tag" => "Canonical URL tag",
// "Indicates to search engines which URL to use which prevents duplicate listings" => "Indicates to search engines which URL to use which prevents duplicate listings",
// "Show module controls" => "Show module controls",
// "Perspectives" => "Perspectives",
// "Permits to override preferences" => "Permits to override preferences",
// "Search and replace" => "Search and replace",
// "Permits find and replace of content in the edit box" => "Permits find and replace of content in the edit box",
"Submissions" => "Colaboraciones",
// "Submissions are sent in but need to be approved before they go live" => "Submissions are sent in but need to be approved before they go live",
"Rankings" => "Rankings",
// "Comments for articles" => "Comments for articles",
// "Article content templates" => "Article content templates",
// "template article news" => "template article news",
// "Predefined content for a news article" => "Predefined content for a news article",
"Print" => "Imprimir",
// "Specify notification emails when creating articles" => "Specify notification emails when creating articles",
// "ShareThis buttons" => "ShareThis buttons",
// "Insert a ShareThis button from www.sharethis.com" => "Insert a ShareThis button from www.sharethis.com",
"Category Path" => "Ruta de la Categoría",
// "Show category tree, above wiki pages" => "Show category tree, above wiki pages",
// "Show category objects" => "Show category objects",
// "Show objects sharing the same category, below wiki pages" => "Show objects sharing the same category, below wiki pages",
"Ignore category viewing restrictions" => "Ignorar restricciones de visualización de categoría",
// "Will improve performance, but may show forbidden results" => "Will improve performance, but may show forbidden results",
"List pages" => "Listar páginas",
"Latest Changes" => "Últimas modificaciones",
"Orphan pages" => "Páginas huérfanas",
// "MySQL Full-Text Search" => "MySQL Full-Text Search",
// "This search uses the MySQL Full-Text Search feature. The indexation is continuously updated" => "This search uses the MySQL Full-Text Search feature. The indexation is continuously updated",
"Referer Search Highlighting" => "Destacar Búsqueda",
"Search stats" => "Estadísticas de búsquedas",
"Ignore individual object permissions" => "Ignorar permisos individuales de objetos",
// "Object filter" => "Object filter",
// "Search box" => "Search box",
// "Pertinence" => "Pertinence",
// "Object type" => "Object type",
// "Last modified date" => "Last modified date",
// "Custom blog headings" => "Custom blog headings",
// "Using custom blog headings will use significantly more server resources. Unless you need per-blog templates, you should use a customize the template file" => "Using custom blog headings will use significantly more server resources. Unless you need per-blog templates, you should use a customize the template file",
// "Publish dates can be modified" => "Publish dates can be modified",
// "Comments on blog posts" => "Comments on blog posts",
// "Insert a ShareThis button from [http://www.sharethis.com]" => "Insert a ShareThis button from [http://www.sharethis.com]",
// "File Gallery Comments" => "File Gallery Comments",
// "Use file galleries for user files" => "Use file galleries for user files",
// "experimental" => "experimental",
// "Use file galleries for wiki attachments" => "Use file galleries for wiki attachments",
// "Batch uploading" => "Batch uploading",
// "Direct import of local files into a File Gallery. Can handle large files. User can upload file via FTP to target folder" => "Direct import of local files into a File Gallery. Can handle large files. User can upload file via FTP to target folder",
// "Use batch uploading to integrate large files into File Galleries" => "Use batch uploading to integrate large files into File Galleries",
"Accept wiki syntax" => "Aceptar sintaxis wiki",
// "Topic archiving" => "Topic archiving",
// "Quick jumps" => "Quick jumps",
// "Replies are empty" => "Replies are empty",
// "If disabled, replies will quote the original post" => "If disabled, replies will quote the original post",
// "First post of a thread can have an empty body" => "First post of a thread can have an empty body",
// "Will be a thread title" => "Will be a thread title",
// "Forum name search" => "Forum name search",
// "When listing forums" => "When listing forums",
// "Forum content search" => "Forum content search",
// "Topic content search" => "Topic content search",
// "Tiki-indexed search" => "Tiki-indexed search",
// "Use database (full-text) search" => "Use database (full-text) search",
// "Store password as plain text" => "Store password as plain text",
// "Encryption method" => "Encryption method",
"tikihash (old)" => "tikihash (old)",
"Edit CSS" => "Editar CSS",
"Theme Control" => "Control de temas",
// "Assign different themes to different sections, categories, and objects" => "Assign different themes to different sections, categories, and objects",
// "design themes" => "design themes",
"Tiki Template Viewing" => "Vista de Plantilla de Tiki",
"Edit Templates" => "Editar plantillas",
// "Custom HTML <head> Content" => "Custom HTML <head> Content",
"Example" => "Ejemplo",
// "Use to include custom &lt;meta&gt; or &lt;link&gt; tags" => "Use to include custom &lt;meta&gt; or &lt;link&gt; tags",
// "Add BASE tag in the page HEAD" => "Add BASE tag in the page HEAD",
// "The &lt;base&gt; tag specifies a default address for all links on a page" => "The &lt;base&gt; tag specifies a default address for all links on a page",
// "Site Logo and Title" => "Site Logo and Title",
// "Expected to be migrated to modules entirely and made obsolete" => "Expected to be migrated to modules entirely and made obsolete",
"Left column" => "Columna izquierda",
// "Controls visibility of the left column of modules" => "Controls visibility of the left column of modules",
// "side bar" => "side bar",
// "Only if module" => "Only if module",
// "Always" => "Always",
// "User Decides" => "User Decides",
// "Right Column" => "Right Column",
// "Controls visibility of the right column of modules" => "Controls visibility of the right column of modules",
// "Prefix breadcrumbs with \"Location : \"" => "Prefix breadcrumbs with \"Location : \"",
"Site location bar" => "Barra de ubicación del sitio",
// "Use breadcrumbs module" => "Use breadcrumbs module",
// "Top of center column (legacy mode)" => "Top of center column (legacy mode)",
"Larger font for" => "Fuente más grande para",
// "Entire location" => "Entire location",
"Page name" => "Nombre de página",
"Use page description" => "Usar descripciones",
// "Top of page" => "Top of page",
// "Top of center column" => "Top of center column",
// "Custom End of <body> Code" => "Custom End of <body> Code",
// "Webmaster Report" => "Webmaster Report",
// "Webmaster Email" => "Webmaster Email",
// "Leave blank to use the default sender email" => "Leave blank to use the default sender email",
"Email this page" => "Envia por correo-e esta página",
// "Add a link at the bottom if set, otherwise add a link at the top" => "Add a link at the bottom if set, otherwise add a link at the top",
// "Shadow layer" => "Shadow layer",
// "Additional layers for shadows, rounded corners or other decorative styling" => "Additional layers for shadows, rounded corners or other decorative styling",
// "Tooltips" => "Tooltips",
// "Make tooltips such as this appear in a custom style. Use CSS to change their appearance" => "Make tooltips such as this appear in a custom style. Use CSS to change their appearance",
// "Provides various drop-down menus on many text input boxes for page names, user names, groups, tags etc" => "Provides various drop-down menus on many text input boxes for page names, user names, groups, tags etc",
// "Superfish" => "Superfish",
// "Adds animation effects to CSS \"Suckerfish\" menus" => "Adds animation effects to CSS \"Suckerfish\" menus",
// "Reflection" => "Reflection",
// "Allows images to have a reflection effect below them. See the admin icons above for an example" => "Allows images to have a reflection effect below them. See the admin icons above for an example",
// "JQuery UI" => "JQuery UI",
// "Include jQuery UI library. Enables many user interface features" => "Include jQuery UI library. Enables many user interface features",
// "jQuery UI Theme" => "jQuery UI Theme",
// "jQuery UI Theme. Used in spreadsheet, for example" => "jQuery UI Theme. Used in spreadsheet, for example",
// "Validation" => "Validation",
// "Provides various validation possibilities like in Trackers" => "Provides various validation possibilities like in Trackers",
// "jQuery Infinite Carousel" => "jQuery Infinite Carousel",
// "Image \"carousel\" plugin (coming soon)" => "Image \"carousel\" plugin (coming soon)",
// "jQuery Sortable Tables" => "jQuery Sortable Tables",
// "Sort in fancytable plugin" => "Sort in fancytable plugin",
// "This feature can cause problems with JS minify on some systems" => "This feature can cause problems with JS minify on some systems",
// "jQuery Media" => "jQuery Media",
// "Media player" => "Media player",
"Use Tabs" => "Usar Tabs",
// "Makes pages shorter by splitting the content in different tabs" => "Makes pages shorter by splitting the content in different tabs",
// "Correct PNG images alpha transparency in IE6 (experimental)" => "Correct PNG images alpha transparency in IE6 (experimental)",
// "Wiki content templates" => "Wiki content templates",
// "Predefined content for a wiki page" => "Predefined content for a wiki page",
"Warn on edit conflict" => "Advertir en conflictos de edición",
// "Tiki will warn users who attempt to edit a page that another user is currenly editing" => "Tiki will warn users who attempt to edit a page that another user is currenly editing",
"Undo" => "Deshacer",
"Footnotes" => "Notas al pie",
// "Create private notes for a page that are visible only by the author" => "Create private notes for a page that are visible only by the author",
"Allow HTML" => "Permitir HTML",
// "Log bytes changes (+/-) in action logs" => "Log bytes changes (+/-) in action logs",
// "May impact performance" => "May impact performance",
"Sandbox" => "Sandbox",
// "A special wiki page for testing. Users can edit, but not save the Sandbox" => "A special wiki page for testing. Users can edit, but not save the Sandbox",
// "Comments below wiki pages" => "Comments below wiki pages",
// "Allow users (with permission) to post threaded comments to a page" => "Allow users (with permission) to post threaded comments to a page",
"Pictures" => "Imágenes",
// "Allow users to upload images (pictures) to a page" => "Allow users to upload images (pictures) to a page",
"Export" => "Exportar",
// "WikiWords" => "WikiWords",
// "Automatically convert words with UpPeR and LoWeR-case letters into wiki links" => "Automatically convert words with UpPeR and LoWeR-case letters into wiki links",
"Link plural WikiWords to their singular forms" => "Enlaza WikiWords en plural con su forma singular",
"Accept dashes and underscores in WikiWords" => "Aceptar guiones y subrayado en WikiWords",
"History" => "Historial",
// "Display IP address" => "Display IP address",
// "Record all versions, rather than only when page content or description changes or when an edit comment is given" => "Record all versions, rather than only when page content or description changes or when an edit comment is given",
// "View page contributions by author" => "View page contributions by author",
// "Visualize the contributions of different authors made to a wiki page" => "Visualize the contributions of different authors made to a wiki page",
"Discuss pages on forums" => "Discutir páginas en foro",
// "Include a link on each page to a forum topic" => "Include a link on each page to a forum topic",
// "View source" => "View source",
// "Similar (like pages)" => "Similar (like pages)",
"Structures" => "Estructuras",
// "Structures Drill Down Menu" => "Structures Drill Down Menu",
// "Ajax style drill down menu for structures" => "Ajax style drill down menu for structures",
"Open page as structure" => "Abrir página como estructura",
// "Make structure from page" => "Make structure from page",
// "Categorize structure pages together" => "Categorize structure pages together",
// "Disable inheritance of direct object permissions when adding pages from a structure" => "Disable inheritance of direct object permissions when adding pages from a structure",
// "Create webhelp from structure" => "Create webhelp from structure",
"Import HTML" => "Importar HTML",
// "Use date parameter" => "Use date parameter",
// "Report it in wiki links" => "Report it in wiki links",
// "Import pages" => "Import pages",
// "A personal page for the user to manage" => "A personal page for the user to manage",
"UserPage prefix" => "Prefijo de Página de Usuario",
// "All user pages share a common prefix. The concatenation of the prefix and the username will generate the page name. The prefix cannot be empty" => "All user pages share a common prefix. The concatenation of the prefix and the username will generate the page name. The prefix cannot be empty",
// "Users can lock pages" => "Users can lock pages",
"MultiPrint" => "PrintMultiple",
// "Pages not in structure" => "Pages not in structure",
"Attachments" => "Archivos adjuntos",
// "Allow users to upload (attach) files to a page" => "Allow users to upload (attach) files to a page",
"Dumps" => "Volcados",
// "If you get an error message indicating a mandatory category is required when editing a wiki page, this is the option to blame. Set it to None" => "If you get an error message indicating a mandatory category is required when editing a wiki page, this is the option to blame. Set it to None",
// "If you get an error message indicating a mandatory category is required when editing an image (in an image gallery), this is the option to blame. Set it to None" => "If you get an error message indicating a mandatory category is required when editing an image (in an image gallery), this is the option to blame. Set it to None",
// "Display show/hide icon displayed before headings" => "Display show/hide icon displayed before headings",
// "Metrics Dashboard" => "Metrics Dashboard",
// "Generate automated statistics from configured database queries" => "Generate automated statistics from configured database queries",
// "Wiki argument variables" => "Wiki argument variables",
// "Allow to write request variables inside wiki content using {{paramname}} or {{paramname|default}} - special case {{page}} {{user}}" => "Allow to write request variables inside wiki content using {{paramname}} or {{paramname|default}} - special case {{page}} {{user}}",
"Use challenge/response authentication" => "Autenticación por challenge/response",
// "Confirm that the Admin account has a valid email address or you will not be permitted to login" => "Confirm that the Admin account has a valid email address or you will not be permitted to login",
// "Users can choose to stay in SSL mode after an HTTPS login" => "Users can choose to stay in SSL mode after an HTTPS login",
// "Users can switch between secured or standard mode at login" => "Users can switch between secured or standard mode at login",
// "Wiki paragraph formatting" => "Wiki paragraph formatting",
// "Because the Wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines" => "Because the Wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines",
// "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line" => "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line",
// "...but still create line breaks within paragraphs" => "...but still create line breaks within paragraphs",
"Automonospaced text" => "Texto Automonoespaciado",
"Tables syntax" => "Sintaxis de tablas",
"|| for rows" => "|| para filas",
"<return> for rows" => "\\n para filas",
"AutoLinks" => "AutoLinks",
// "Tiki will automatically convert http:// and email addresses into links" => "Tiki will automatically convert http:// and email addresses into links",
"Hotwords" => "Palabras clave",
// "Open Hotwords in new window" => "Open Hotwords in new window",
// "Characters that limit a hotword" => "Characters that limit a hotword",
// "Use Quote plugin rather than \">\" for quoting" => "Use Quote plugin rather than \">\" for quoting",
// "Use three colons instead of two to center text. Avoids conflict with C++ resolution scope operator" => "Use three colons instead of two to center text. Avoids conflict with C++ resolution scope operator",
// "String to use to delimit simplebox" => "String to use to delimit simplebox",
// "Users can choose to show their gender" => "Users can choose to show their gender",
// "Real name" => "Real name",
"Gender" => "Género",
// "Picture (avatar)" => "Picture (avatar)",
"Number of friends" => "Número de amigos",
"Country" => "País",
"E-mail" => "Correo",
"Last login" => "Última conexión",
"Distance" => "Distancia",
// "Manual selection of time/date" => "Manual selection of time/date",
// "WebDAV access to Tiki" => "WebDAV access to Tiki",
// "Allow to access File Galleries with WebDAV" => "Allow to access File Galleries with WebDAV",
// "use tiki-webdav.php as the URI of the WebDAV repository" => "use tiki-webdav.php as the URI of the WebDAV repository",
// "Fixed width" => "Fixed width",
// "Constrains the width of the site" => "Constrains the width of the site",
"Social networks" => "Redes sociales",
// "Integration with different social networks like Twitter or Facebook" => "Integration with different social networks like Twitter or Facebook",
// "Group Transition" => "Group Transition",
// "Enables transitions for users between different groups. Transitions will create a user approval workflow" => "Enables transitions for users between different groups. Transitions will create a user approval workflow",
// "Category Transition" => "Category Transition",
// "Enables transitions on objects between different categories. Transitions will create a document workflow" => "Enables transitions on objects between different categories. Transitions will create a document workflow",
// "Ustream Watershed live video streaming" => "Ustream Watershed live video streaming",
// "Integration to Ustream Watershed live video streaming" => "Integration to Ustream Watershed live video streaming",
// "Tiki User Credits" => "Tiki User Credits",
// "Invite users" => "Invite users",
// "Allow users to invite new users by mail to register on this tiki" => "Allow users to invite new users by mail to register on this tiki",
// "Alternate Registration Page" => "Alternate Registration Page",
// "Makes any access to tiki-register.php redirect to an alternate page for registration" => "Makes any access to tiki-register.php redirect to an alternate page for registration",
// "Load Balancer" => "Load Balancer",
// "Enable this only if the server is behind a load balancer (or reverse proxy), this allow tiki to log the IP of the user, instead of the IP of the proxy server" => "Enable this only if the server is behind a load balancer (or reverse proxy), this allow tiki to log the IP of the user, instead of the IP of the proxy server",
// "Accounting" => "Accounting",
// "Double-entry accounting system" => "Double-entry accounting system",
// "Syntax Highlighter (CodeMirror)" => "Syntax Highlighter (CodeMirror)",
// "Enables syntax highlighting with the use of CodeMirror" => "Enables syntax highlighting with the use of CodeMirror",
// "Syntax Highlighter (CodeMirror) Theme" => "Syntax Highlighter (CodeMirror) Theme",
// "Code Mirror Themes (clear cache when you change)" => "Code Mirror Themes (clear cache when you change)",
// "Jison Wiki Parser" => "Jison Wiki Parser",
// "Is a new strategy for parsing wiki pages more like a programming language" => "Is a new strategy for parsing wiki pages more like a programming language",
// "Dummy preference" => "Dummy preference",
// "This is useful for developers to learn how to create a new preference" => "This is useful for developers to learn how to create a new preference",
// "This is the detail" => "This is the detail",
// "This is the warning" => "This is the warning",
// "This is the hint" => "This is the hint",
// "This is the shorthint" => "This is the shorthint",
// "Time Sheet" => "Time Sheet",
// "A project time manager" => "A project time manager",
// "Html Feed" => "Html Feed",
// "A way to push and pull html bits around from one site to another" => "A way to push and pull html bits around from one site to another",
// "ForwardLink-Protocol" => "ForwardLink-Protocol",
// "A Dynamic Compendia" => "A Dynamic Compendia",
// "Unified Search requires more server processing ressources, and that you properly set the server permissions. Also, it's recommended to set a cron job to periodically rebuild the search index" => "Unified Search requires more server processing ressources, and that you properly set the server permissions. Also, it's recommended to set a cron job to periodically rebuild the search index",
// "HTML Purifier is a standards-compliant HTML filter library written in PHP and integrated in Tiki. HTML Purifier will not only remove all malicious code (better known as XSS) with a thoroughly audited, secure yet permissive whitelist, it will also make sure your documents are standards compliant, something only achievable with a comprehensive knowledge of W3C's specifications" => "HTML Purifier is a standards-compliant HTML filter library written in PHP and integrated in Tiki. HTML Purifier will not only remove all malicious code (better known as XSS) with a thoroughly audited, secure yet permissive whitelist, it will also make sure your documents are standards compliant, something only achievable with a comprehensive knowledge of W3C's specifications",
// "Display 'MyTiki' in the application menu" => "Display 'MyTiki' in the application menu",
// "Show user's contribution on the user information page" => "Show user's contribution on the user information page",
// "nofollow is used to instruct some search engines that links should not influence search engines. It can reduce search engine spam and prevent 'spamdexing'" => "nofollow is used to instruct some search engines that links should not influence search engines. It can reduce search engine spam and prevent 'spamdexing'",
// "InnoDB doesn't support Full-Text Search until 5.6, so if this is your case, use Unified Search" => "InnoDB doesn't support Full-Text Search until 5.6, so if this is your case, use Unified Search",
// "Require file author's name for anonymous uploads" => "Require file author's name for anonymous uploads",
// "Redirect to similar wiki page" => "Redirect to similar wiki page",
// "If a requested page doesn't exist, redirect to a similarly named page" => "If a requested page doesn't exist, redirect to a similarly named page",
// "Redirect to page alias, if any" => "Redirect to page alias, if any",
// "If a requested page doesn't exist, redirect to an alias page, if specified using an alias semantic link" => "If a requested page doesn't exist, redirect to an alias page, if specified using an alias semantic link",
// "User's page" => "User's page",
// "Show user's information on mouseover" => "Show user's information on mouseover",
// "Requires user's information to be public" => "Requires user's information to be public",
// "Default feed format" => "Default feed format",
// "ATOM 1.0" => "ATOM 1.0",
// "RSS 2.0" => "RSS 2.0",
// "Feed author name" => "Feed author name",
// "This field is mandatory unless both feed author email and homepage are empty" => "This field is mandatory unless both feed author email and homepage are empty",
// "Feeed author email" => "Feeed author email",
// "Feed author homepage" => "Feed author homepage",
// "Feed editor email" => "Feed editor email",
// "Email address for person responsible for editorial content" => "Email address for person responsible for editorial content",
// "Feed webmaster email" => "Feed webmaster email",
// "Email address for person responsible for technical issues relating to channel" => "Email address for person responsible for technical issues relating to channel",
// "Feed Image path" => "Feed Image path",
// "Specifies a GIF, JPEG or PNG image that can be displayed with the feed" => "Specifies a GIF, JPEG or PNG image that can be displayed with the feed",
// "Feed Language" => "Feed Language",
// "RSS basic Authentication" => "RSS basic Authentication",
// "Propose basic http authentication if the user has no permission to see the feed" => "Propose basic http authentication if the user has no permission to see the feed",
// "Feed Caching time" => "Feed Caching time",
"seconds" => "segundos",
// "Use 0 for no caching" => "Use 0 for no caching",
// "Feed caching is done for anonymous users only" => "Feed caching is done for anonymous users only",
// "RSS for articles" => "RSS for articles",
// "RSS feeds for articles" => "RSS feeds for articles",
// "RSS for blogs" => "RSS for blogs",
// "RSS feeds for blogs" => "RSS feeds for blogs",
// "RSS for individual blogs" => "RSS for individual blogs",
// "RSS feed for individual blogs" => "RSS feed for individual blogs",
// "RSS for image galleries" => "RSS for image galleries",
// "RSS feed for image galleries" => "RSS feed for image galleries",
// "RSS for individual image galleries" => "RSS for individual image galleries",
// "RSS feed for individual image galleries" => "RSS feed for individual image galleries",
// "RSS for file galleries" => "RSS for file galleries",
// "RSS feed for file galleries" => "RSS feed for file galleries",
// "RSS for individual file galleries" => "RSS for individual file galleries",
// "RSS feed for individual file galleries" => "RSS feed for individual file galleries",
// "RSS for wiki pages" => "RSS for wiki pages",
// "RSS feed for wiki" => "RSS feed for wiki",
// "RSS for forums" => "RSS for forums",
// "RSS feed for forums" => "RSS feed for forums",
// "RSS for individual forums" => "RSS for individual forums",
// "RSS feed for individual forums" => "RSS feed for individual forums",
"RSS per tracker" => "RSS por formulario-bd",
"RSS feed per tracker" => "Alimentación RSS por formulario-bd",
// "RSS for calendar events" => "RSS for calendar events",
// "RSS feed for calendar events" => "RSS feed for calendar events",
// "RSS for directories" => "RSS for directories",
// "RSS feed for directories" => "RSS feed for directories",
// "RSS for shoutbox" => "RSS for shoutbox",
// "RSS feed for shoutbox" => "RSS feed for shoutbox",
// "Maximum number of items to display" => "Maximum number of items to display",
// "Show Author" => "Show Author",
// "Homepage URL" => "Homepage URL",
"Tiki RSS feed for articles" => "Tiki RSS feed para artículos",
"Tiki RSS feed for weblogs" => "Tiki RSS feed para weblogs",
// "Title to be prepended to the blog title for all blogs. If this field is empty only the blog title will be used" => "Title to be prepended to the blog title for all blogs. If this field is empty only the blog title will be used",
"Tiki RSS feed for image galleries" => "Tiki RSS feed para galerías de imágenes",
"Tiki RSS feed for the image gallery: " => "Tiki RSS feed para la galería de imágenes: ",
"Tiki RSS feed for file galleries" => "Tiki RSS feed para galerías de archivos",
"Tiki RSS feed for the file gallery: " => "Tiki RSS feed para la galería de archivos: ",
"Tiki RSS feed for the wiki pages" => "Tiki RSS feed para las páginas wiki",
"Tiki RSS feed for forums" => "Tiki RSS feed para foros",
"Tiki RSS feed for forum: " => "Tiki RSS feed para foro: ",
"Tiki RSS feed for individual trackers: " => "Alimentación de RSS de Tiki para formularios-bd individuales: ",
// "Tiki RSS feed for calendars" => "Tiki RSS feed for calendars",
"Tiki RSS feed for directory sites" => "Tiki RSS feed para directorio de sitios",
// "Tiki RSS feed for shoutbox messages" => "Tiki RSS feed for shoutbox messages",
// "Article RSS Description" => "Article RSS Description",
// "Description to be published as part of the RSS feed for articles" => "Description to be published as part of the RSS feed for articles",
"Last articles." => "Últimos artículos.",
// "Blogs RSS Description" => "Blogs RSS Description",
// "Description to be published as part of the RSS feed for blogs" => "Description to be published as part of the RSS feed for blogs",
"Last posts to weblogs." => "Últimos posts en weblogs.",
// "Blog RSS Description" => "Blog RSS Description",
// "Description to be prepended to the blog description and published as part of the RSS feed for individual blogs. If this field is empty only the blog description will be used" => "Description to be prepended to the blog description and published as part of the RSS feed for individual blogs. If this field is empty only the blog description will be used",
// "Image galleries RSS Description" => "Image galleries RSS Description",
// "Description to be published as part of the RSS feed for image galleries" => "Description to be published as part of the RSS feed for image galleries",
"Last images uploaded to the image galleries." => "Últimas imágenes subidas a las galerías de imágenes.",
// "Individual image galleries RSS Description" => "Individual image galleries RSS Description",
// "Description to be published as part of the RSS feed for individual image galleries" => "Description to be published as part of the RSS feed for individual image galleries",
// "Last images uploaded to this image gallery. " => "Last images uploaded to this image gallery. ",
// "File galleries RSS Description" => "File galleries RSS Description",
// "Description to be published as part of the RSS feed for file galleries" => "Description to be published as part of the RSS feed for file galleries",
"Last files uploaded to the file galleries." => "Últimos archivos subidos a las galerías de archivos.",
// "Individual file galleries RSS Description" => "Individual file galleries RSS Description",
// "Description to be published as part of the RSS feed for individual file galleries" => "Description to be published as part of the RSS feed for individual file galleries",
// "Last files uploaded to this file gallery. " => "Last files uploaded to this file gallery. ",
// "Wiki pages RSS Description" => "Wiki pages RSS Description",
// "Description to be published as part of the RSS feed for wiki pages" => "Description to be published as part of the RSS feed for wiki pages",
"Last modifications to the Wiki." => "Últimas modificaciones para el Wiki.",
// "Forums RSS Description" => "Forums RSS Description",
// "Description to be published as part of the RSS feed for forums" => "Description to be published as part of the RSS feed for forums",
"Last topics in forums." => "Últimos temas en foros.",
// "Individual forums RSS Description" => "Individual forums RSS Description",
// "Description to be published as part of the RSS feed for individual forums" => "Description to be published as part of the RSS feed for individual forums",
// "Last posts to this forum. " => "Last posts to this forum. ",
// "Individual trackers RSS Description" => "Individual trackers RSS Description",
// "Description to be published as part of the RSS feed for individual trackers" => "Description to be published as part of the RSS feed for individual trackers",
"Last items published on this tracker" => "Últimos ítems publicados en este formulario-bd",
// "Calendar events RSS Description" => "Calendar events RSS Description",
// "Description to be published as part of the RSS feed for calendar events" => "Description to be published as part of the RSS feed for calendar events",
"Upcoming Events" => "Próximos eventos",
// "Directories RSS Description" => "Directories RSS Description",
// "Description to be published as part of the RSS feed for directories" => "Description to be published as part of the RSS feed for directories",
"Last sites." => "Últimos sitios.",
// "Shoutbox RSS Description" => "Shoutbox RSS Description",
// "Description to be published as part of the RSS feed for shoutbox messages" => "Description to be published as part of the RSS feed for shoutbox messages",
// "Last shoutbox messages" => "Last shoutbox messages",
// "Podcast directory" => "Podcast directory",
// "The server must be able to read/write the directory" => "The server must be able to read/write the directory",
// "Required for podcasts" => "Required for podcasts",
// "If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload files in that dir, either by scp, ftp, or other protocols" => "If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload files in that dir, either by scp, ftp, or other protocols",
// "The server must be able to read the directory" => "The server must be able to read the directory",
// "The directory can be outside the web space" => "The directory can be outside the web space",
// "Prevent download if score becomes negative" => "Prevent download if score becomes negative",
// "Allow download limit per file" => "Allow download limit per file",
"Allow same file to be uploaded more than once" => "Permitir el mismo archivo ser subido más de una vez",
// "Yes, even in the same gallery" => "Yes, even in the same gallery",
// "Only in different galleries" => "Only in different galleries",
// "Display zip option in gallery" => "Display zip option in gallery",
// "Display in the gallery the zip option (in upload and gallery file)" => "Display in the gallery the zip option (in upload and gallery file)",
// "Upload progressbar" => "Upload progressbar",
// "Ajax / Flash (Browser-based)" => "Ajax / Flash (Browser-based)",
// "Must match" => "Must match",
// "Cannot match" => "Cannot match",
// "Quota for all the files and archives" => "Quota for all the files and archives",
"Mb" => "Mb",
// "(0 for unlimited)" => "(0 for unlimited)",
// "Quota can be defined for each file gallery" => "Quota can be defined for each file gallery",
// "Default quota for each new gallery" => "Default quota for each new gallery",
// "Show quota bar in the list page" => "Show quota bar in the list page",
// "Yes, display bar and detail text" => "Yes, display bar and detail text",
// "Yes, display only bar" => "Yes, display only bar",
// "Yes, display only text" => "Yes, display only text",
"Storage" => "Almacenamiento",
// "Store in database" => "Store in database",
// "Store in directory" => "Store in directory",
// "Path to store files in the file gallery" => "Path to store files in the file gallery",
// "Include the search box on the current gallery files just after the find div" => "Include the search box on the current gallery files just after the find div",
// "Include a search box on file galleries" => "Include a search box on file galleries",
// "Display hits with a ratio between hits / maxhits" => "Display hits with a ratio between hits / maxhits",
// "Display properties in the context menu" => "Display properties in the context menu",
// "Display replace menu in context menu" => "Display replace menu in context menu",
// "Automatic deletion of old files" => "Automatic deletion of old files",
// "The user will have an option when uploading a file to specify the time after which the file is deleted" => "The user will have an option when uploading a file to specify the time after which the file is deleted",
// "Allow action on multiple files or galleries" => "Allow action on multiple files or galleries",
// "The check button on file gallery can be remove" => "The check button on file gallery can be remove",
// "Deletion emails notification" => "Deletion emails notification",
// "These emails will receive a copy of each deleted file. Emails are separated with comma" => "These emails will receive a copy of each deleted file. Emails are separated with comma",
// "Keep the same fileId for the latest version of a file" => "Keep the same fileId for the latest version of a file",
// "If checked, the fileId of the latest version of a file stays the same. Link to a file will always give you the latest version. If not checked, the fileId is attached to the file for ever, link to file will give you the precise version of a file" => "If checked, the fileId of the latest version of a file stays the same. Link to a file will always give you the latest version. If not checked, the fileId is attached to the file for ever, link to file will give you the precise version of a file",
// "Show thumbnail actions" => "Show thumbnail actions",
// "Show the checkbox and wrench icon for file actions menu when not displaying details" => "Show the checkbox and wrench icon for file actions menu when not displaying details",
// "Max thumbnail size" => "Max thumbnail size",
// "Maximum width or height for image thumbnails" => "Maximum width or height for image thumbnails",
// "In pixels" => "In pixels",
// "Automatic indexing of file content" => "Automatic indexing of file content",
// "Uses command line tools to extract the information from the files based on their MIME types" => "Uses command line tools to extract the information from the files based on their MIME types",
// "Upload files from remote source" => "Upload files from remote source",
// "Allow to create files in file galleries using a URL that will be polled for new revisions" => "Allow to create files in file galleries using a URL that will be polled for new revisions",
// "Remote source refresh frequency limit" => "Remote source refresh frequency limit",
// "Minimum amount of seconds to be ellapsed between source checks to prevent flooding servers" => "Minimum amount of seconds to be ellapsed between source checks to prevent flooding servers",
// "Display controls to attempt refresh" => "Display controls to attempt refresh",
// "Let users trigger a refresh attempt from the remote host" => "Let users trigger a refresh attempt from the remote host",
// "Allow searching for existing files in the tracker files field" => "Allow searching for existing files in the tracker files field",
// "Search files using the search index" => "Search files using the search index",
// "Fix mime types based on file suffix" => "Fix mime types based on file suffix",
// "Fixes mime type of image files based on file suffixes when they are incorrectly detected as application/octet-stream" => "Fixes mime type of image files based on file suffixes when they are incorrectly detected as application/octet-stream",
// "Max Name Length" => "Max Name Length",
// "Length to truncate file names to in browse view" => "Length to truncate file names to in browse view",
// "Set a directory on your server. Ex.: /var/www/  It's recommended that this directory not be web accessible. PHP must be able to read/write to the directory" => "Set a directory on your server. Ex.: /var/www/  It's recommended that this directory not be web accessible. PHP must be able to read/write to the directory",
// "Revision Approval" => "Revision Approval",
// "Uses flagged revisions to hide unapproved wiki page revisions from users with lower privileges" => "Uses flagged revisions to hide unapproved wiki page revisions from users with lower privileges",
// "Revision Approval Categories" => "Revision Approval Categories",
// "List of category IDs on which revision approval is required" => "List of category IDs on which revision approval is required",
// "Footer shadow start" => "Footer shadow start",
// "Footer shadow end" => "Footer shadow end",
"Uploaded filenames must match regex" => "Archivos subidos deben matchear esta regex",
// "Manage thread defaults per-forum" => "Manage thread defaults per-forum",
// "Display thread configuration bar" => "Display thread configuration bar",
// "Allows users to override the defaults" => "Allows users to override the defaults",
// "Display thread configuration bar only when number of posts exceed" => "Display thread configuration bar only when number of posts exceed",
// "Keep settings for all forums during the user session" => "Keep settings for all forums during the user session",
// "Default style" => "Default style",
"Plain" => "Plano",
"Threaded" => "Hilado",
"Headers Only" => "Sólo Cabezales",
// "Default sort mode" => "Default sort mode",
"Title (desc)" => "Título (desc)",
"Title (asc)" => "Título (asc)",
"Topics" => "Temas",
"Posts per day" => "Mensajes por día",
"Last post" => "Último post",
// "Description length" => "Description length",
// "Hide titles for forum threads" => "Hide titles for forum threads",
// "Most titles are left untouched because they are a direct reply to the parent thread. This feature hides the title altogether from the forms and display" => "Most titles are left untouched because they are a direct reply to the parent thread. This feature hides the title altogether from the forms and display",
// "Force title in reply" => "Force title in reply",
// "Shows a blank title box and requires it to be filled before submission of forum post" => "Shows a blank title box and requires it to be filled before submission of forum post",
// "Do not prefix messages titles by 'Re: '" => "Do not prefix messages titles by 'Re: '",
"Creation Date (asc)" => "Fecha de Creación (asc)",
"Topics (desc)" => "Temas (desc)",
"Threads (desc)" => "Mensajes (desc)",
"Last post (desc)" => "Último mensaje (desc)",
"Name (desc)" => "Nombre (desc)",
"Name (asc)" => "Nombre (asc)",
// "Multilingual tags" => "Multilingual tags",
// "Permits translation management of tags" => "Permits translation management of tags",
// "Show tag cloud" => "Show tag cloud",
// "Maximum number of tags in cloud" => "Maximum number of tags in cloud",
// "Show freetags in middle column" => "Show freetags in middle column",
// "Preload freetag random tag" => "Preload freetag random tag",
// "Number of Tags to show in Tag Suggestions" => "Number of Tags to show in Tag Suggestions",
// "Valid characters pattern" => "Valid characters pattern",
// "Lowercase tags only" => "Lowercase tags only",
// "Enable freetags 3D browser" => "Enable freetags 3D browser",
// "3D autoload" => "3D autoload",
"Browser width" => "Ancho del navegador",
"Browser height" => "Altura del navegador",
"Navigation depth" => "Profundidad de navegación",
// "Node size" => "Node size",
// "Text size" => "Text size",
// "Spring (connection) size" => "Spring (connection) size",
"Existing page node color" => "Color de nodo de página existente",
"Missing page node color" => "Color de nodo de página no existente",
// "Camera distance adjusted relative to nearest node" => "Camera distance adjusted relative to nearest node",
// "Camera distance" => "Camera distance",
// "Field of view" => "Field of view",
"Feed animation interval (milisecs)" => "Intervalo de animación del feed  (milisegs)",
// "Friction constant" => "Friction constant",
// "Elastic constant" => "Elastic constant",
// "Electrostatic constant" => "Electrostatic constant",
// "Node mass" => "Node mass",
// "Node charge" => "Node charge",
// "Include \"Generate Password\" option on registration form" => "Include \"Generate Password\" option on registration form",
// "Geolocate wiki pages" => "Geolocate wiki pages",
// "Provide controls to geolocate wiki pages from the edit functionality" => "Provide controls to geolocate wiki pages from the edit functionality",
// "Geolocate articles" => "Geolocate articles",
// "Provide controls to geolocate articles from the edit functionality" => "Provide controls to geolocate articles from the edit functionality",
// "Geolocate blog posts" => "Geolocate blog posts",
// "Provide controls to geolocate blog posts from the edit functionality" => "Provide controls to geolocate blog posts from the edit functionality",
// "Available tile layers on maps" => "Available tile layers on maps",
// "Allows to replace the default OpenStreetMap tiles for tiles from other mapping services, such as Google or Bing" => "Allows to replace the default OpenStreetMap tiles for tiles from other mapping services, such as Google or Bing",
// "Valid options are: %0" => "Valid options are: %0",
// "Google Street View" => "Google Street View",
// "Open up Google Street View in a window to see the visible coordinates" => "Open up Google Street View in a window to see the visible coordinates",
// "Google Street View Overlay" => "Google Street View Overlay",
// "This is not guaranteed to work" => "This is not guaranteed to work",
// "Always load OpenLayers" => "Always load OpenLayers",
// "Load the OpenLayers library even if no map is explicitly included in the page" => "Load the OpenLayers library even if no map is explicitly included in the page",
// "Style of the site, sometimes called a skin or CSS. See http://themes.tiki.org for more Tiki themes" => "Style of the site, sometimes called a skin or CSS. See http://themes.tiki.org for more Tiki themes",
"Browser title" => "Título (ventana del navegador)",
// "Label visible in the browser's title bar on all pages. Also appears in search engines" => "Label visible in the browser's title bar on all pages. Also appears in search engines",
// "Validate new user registrations by email" => "Validate new user registrations by email",
// "Upon registration, the new user will receive an email containing a link to confirm validity" => "Upon registration, the new user will receive an email containing a link to confirm validity",
"Home page" => "Página inicio",
// "Landing page used for the wiki when no page is specified. The page will be created if it does not exist" => "Landing page used for the wiki when no page is specified. The page will be created if it does not exist",
"Use group homepages" => "Usar páginas inicio de grupo",
// "Users can be sent to different pages upon login, depending on their default group" => "Users can be sent to different pages upon login, depending on their default group",
"Go to group homepage only if login from default homepage" => "Ir a página inicial de grupo sólo si se identifica desde la página inicio por defecto",
// "Default language" => "Default language",
// "Site language used when no other language is specified by the user" => "Site language used when no other language is specified by the user",
// "Cache external pages" => "Cache external pages",
// "Cache external images" => "Cache external images",
"Temporary directory" => "Directorio temporal",
// "Tiki requires full read and write access to this directory" => "Tiki requires full read and write access to this directory",
"Help URL" => "URL de Ayuda",
// "The default help system may not be complete. You can help with the Tiki documentation" => "The default help system may not be complete. You can help with the Tiki documentation",
"Open external links in new window" => "Abrir enlaces externos en una ventana nueva",
// "License page" => "License page",
// "Submit notice" => "Submit notice",
"Full path to gdaltindex" => "Camino completo a gdaltindex",
"Full path to ogr2ogr" => "Camino completo a ogr2ogr",
"Map Zone" => "Zona de Mapa",
"Display modules to all groups always" => "Mostrar siempre módulos a todos los grupos",
"Hide anonymous-only modules from registered users" => "Ocultar módulos solo para usuarios anónimos a los usuarios registrados",
// "Hide anonymous-only modules from Admins" => "Hide anonymous-only modules from Admins",
// "Maximum number of articles on articles home page" => "Maximum number of articles on articles home page",
// "Site Ads and Banners Content" => "Site Ads and Banners Content",
// "Test" => "Test",
// "URL to go to when clicking on a username" => "URL to go to when clicking on a username",
// "Use %user% for login name and %userId% for userId)" => "Use %user% for login name and %userId% for userId)",
// "Forgot password" => "Forgot password",
// "Users can request to reset password. They will receive a link by email" => "Users can request to reset password. They will receive a link by email",
// "Each group can have its theme" => "Each group can have its theme",
// "Site title" => "Site title",
"Subtitle" => "Subtítulo",
"Maximum number of records in listings" => "Cantidad máxima de registros en listados",
// "Maximum number of versions" => "Maximum number of versions",
// "0 for unlimited versions" => "0 for unlimited versions",
"Users can register" => "Usuarios pueden registrarse",
// "Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server" => "Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server",
// "Require validation by Admin" => "Require validation by Admin",
// "The administrator will receive an email for each new user registration, and must validate the user before the user can login" => "The administrator will receive an email for each new user registration, and must validate the user before the user can login",
// "Require passcode to register" => "Require passcode to register",
// "Users must enter a code to register.  You must inform users of this code. Use to restrict registration to invited users only" => "Users must enter a code to register.  You must inform users of this code. Use to restrict registration to invited users only",
// "Passcode" => "Passcode",
// "Alphanumeric code required to complete the registration" => "Alphanumeric code required to complete the registration",
// "Show passcode on registration form" => "Show passcode on registration form",
// "Use tracker to collect more user information" => "Use tracker to collect more user information",
// "Display a tracker (form) for the user to complete, as part of the registration process. Use this tracker to store additional information about each user" => "Display a tracker (form) for the user to complete, as part of the registration process. Use this tracker to store additional information about each user",
// "Use the \"Admin Groups\" page to select which tracker and fields to display" => "Use the \"Admin Groups\" page to select which tracker and fields to display",
// "Use tracker to collect more group information" => "Use tracker to collect more group information",
// "Create a new group for each user" => "Create a new group for each user",
// "Synchronize Tiki groups with a directory" => "Synchronize Tiki groups with a directory",
// "Define the directory within the \"LDAP\" tab" => "Define the directory within the \"LDAP\" tab",
// "Synchronize Tiki users with a directory" => "Synchronize Tiki users with a directory",
"Remember me" => "Recordarme",
"Duration" => "Duración",
"hour" => "hora",
"hours" => "horas",
"day" => "día",
"week" => "semana",
"month" => "mes",
"year" => "año",
// "Use custom homepage" => "Use custom homepage",
// "Use a Tiki feature homepage or another homepage" => "Use a Tiki feature homepage or another homepage",
// "Use Tiki feature as homepage" => "Use Tiki feature as homepage",
// "Select the Tiki feature to use as the site homepage. Only enabled features are listed" => "Select the Tiki feature to use as the site homepage. Only enabled features are listed",
// "Disable JavaScript" => "Disable JavaScript",
// "Disable JavaScript for testing purpose even if the browser allows it" => "Disable JavaScript for testing purpose even if the browser allows it",
// "Partner ID" => "Partner ID",
// "Kaltura Partner ID" => "Kaltura Partner ID",
// "User secret" => "User secret",
// "Kaltura partner setting user secret" => "Kaltura partner setting user secret",
// "Admin secret" => "Admin secret",
// "Kaltura partner setting admin secret" => "Kaltura partner setting admin secret",
// "KDP UI Configuration ID" => "KDP UI Configuration ID",
// "Kaltura Dynamic Player (KDP) user interface configuration ID" => "Kaltura Dynamic Player (KDP) user interface configuration ID",
// "KDP Widget ID" => "KDP Widget ID",
// "Kaltura Dynamic Player (KDP) Widget ID. This configuration is specific to your account" => "Kaltura Dynamic Player (KDP) Widget ID. This configuration is specific to your account",
// "KCW UI Configuration ID" => "KCW UI Configuration ID",
// "Kaltura Configuration Wizard (KCW) user interface configuration ID" => "Kaltura Configuration Wizard (KCW) user interface configuration ID",
// "Kaltura Simple Editor UI Configuration ID" => "Kaltura Simple Editor UI Configuration ID",
// "Kaltura Advanced Editor UI Configuration ID" => "Kaltura Advanced Editor UI Configuration ID",
// "Kaltura \"User\"" => "Kaltura \"User\"",
// "Owner of content shared by all Tiki users on this site. If empty then each Tiki user can only see their own media entries" => "Owner of content shared by all Tiki users on this site. If empty then each Tiki user can only see their own media entries",
// "Kaltura Service URL" => "Kaltura Service URL",
// "e.g. http://www.kaltura.com/" => "e.g. http://www.kaltura.com/",
// "Set blogs homepage first" => "Set blogs homepage first",
// "Set Image gal homepage first" => "Set Image gal homepage first",
// "Set Forum homepage first" => "Set Forum homepage first",
"Custom home" => "Inicio propio",
// "Since passwords are encrypted, it's not possible to tell the user what the password is. It's only possible to change it" => "Since passwords are encrypted, it's not possible to tell the user what the password is. It's only possible to change it",
// "Validate user's email server" => "Validate user's email server",
// "Displays the required passcode on the registration form. This is helpful for legitimate users who want to register while making it difficult for automated robots because the passcode is unique for each site and because it is displayed in JavaScript" => "Displays the required passcode on the registration form. This is helpful for legitimate users who want to register while making it difficult for automated robots because the passcode is unique for each site and because it is displayed in JavaScript",
// "The group will be named identical to the user's username" => "The group will be named identical to the user's username",
// "User's choice" => "User's choice",
// "If you don't know better, use '_yourPartnerID'" => "If you don't know better, use '_yourPartnerID'",
// "You could use your server name for this. e.g. %0" => "You could use your server name for this. e.g. %0",
// "Google Maps API Key" => "Google Maps API Key",
// "Default x for map center" => "Default x for map center",
// "Default y for map center" => "Default y for map center",
// "Default zoom level" => "Default zoom level",
// "whole earth" => "whole earth",
// "country size" => "country size",
// "city size" => "city size",
// "village size" => "village size",
// "max zoom" => "max zoom",
// "Show map mode buttons in articles list" => "Show map mode buttons in articles list",
// "Show map mode buttons in page list" => "Show map mode buttons in page list",
// "Header shadow start" => "Header shadow start",
// "Header shadow end" => "Header shadow end",
// "Custom CSS" => "Custom CSS",
// "Includes a custom block of CSS inline in all pages" => "Includes a custom block of CSS inline in all pages",
// "Custom JavaScript" => "Custom JavaScript",
// "Includes a custom block of inline JavaScript in all pages" => "Includes a custom block of inline JavaScript in all pages",
// "Do not include the <script> and </script> tags" => "Do not include the <script> and </script> tags",
// "Highlight group" => "Highlight group",
"Home Blog (main blog)" => "Blog principal",
"Home Forum (main forum)" => "Foro principal",
// "Home File Gallery (main file gallery)" => "Home File Gallery (main file gallery)",
"Home Gallery (main gallery)" => "Galería principal",
// "No image gallery available (create one first)" => "No image gallery available (create one first)",
// "No file gallery available (create one first)" => "No file gallery available (create one first)",
// "No forum available (create one first)" => "No forum available (create one first)",
// "No blog available (create one first)" => "No blog available (create one first)",
"HTTP port" => "puerto HTTP",
// "If left empty, port 80 will be used" => "If left empty, port 80 will be used",
// "HTTP Lookup Skip Framesets" => "HTTP Lookup Skip Framesets",
// "When performing and HTTP request to an external source, verify if the result is a frameset and use heuristic to provide the real content" => "When performing and HTTP request to an external source, verify if the result is a frameset and use heuristic to provide the real content",
// "Registration referrer check" => "Registration referrer check",
// "Use the HTTP referrer to check registration POST is sent from same host. (May not work on some setups.)" => "Use the HTTP referrer to check registration POST is sent from same host. (May not work on some setups.)",
// "Use HTTPS when building user-specific links" => "Use HTTPS when building user-specific links",
// "When building notification emails, RSS feeds or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server" => "When building notification emails, RSS feeds or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server",
"HTTPS port" => "puerto HTTPS",
// "If left empty, port 443 will be used" => "If left empty, port 443 will be used",
// "Use HTTPS login" => "Use HTTPS login",
// "Increase security by allowing to transmit authentication credentials over SSL. Certificates must be configured on the server" => "Increase security by allowing to transmit authentication credentials over SSL. Certificates must be configured on the server",
"Allow secure (https) login" => "Permitir login seguro (https)",
"Encourage secure (https) login" => "Intentar acceso seguro (https)",
"Consider we are always in HTTPS, but do not check" => "Considere que siempre trabajamos con HTTPS, pero no comprobar ",
"Require secure (https) login" => "Requerir login seguro (https)",
// "Do not require HTTPS until you have setup and tested the connection, otherwise, you will make your whole site unaccessible" => "Do not require HTTPS until you have setup and tested the connection, otherwise, you will make your whole site unaccessible",
// "CSS selectors to be fixed" => "CSS selectors to be fixed",
// "Separate multiple elements with a comma (,)" => "Separate multiple elements with a comma (,)",
// "HTMLDomElements to be fixed" => "HTMLDomElements to be fixed",
// "IP can be checked" => "IP can be checked",
// "Check anonymous votes by user's IP" => "Check anonymous votes by user's IP",
// "Use CDN for JavaScript" => "Use CDN for JavaScript",
// "Obtain jQuery and jQuery UI libraries through a content delivery network" => "Obtain jQuery and jQuery UI libraries through a content delivery network",
// "Google (supports SSL via HTTPS)" => "Google (supports SSL via HTTPS)",
// "jQuery" => "jQuery",
// "Slide" => "Slide",
// "Fade" => "Fade",
// "Blind (UI)" => "Blind (UI)",
// "Clip (UI)" => "Clip (UI)",
// "Drop (UI)" => "Drop (UI)",
// "Explode (UI)" => "Explode (UI)",
// "Fold (UI)" => "Fold (UI)",
// "Puff (UI)" => "Puff (UI)",
// "Slide (UI)" => "Slide (UI)",
// "Effect for modules" => "Effect for modules",
// "Effect for tabs" => "Effect for tabs",
// "Speed" => "Speed",
// "Fast" => "Fast",
"Normal" => "Normal",
// "Slow" => "Slow",
"Direction" => "Dirección",
// "Vertical" => "Vertical",
// "Horizontal" => "Horizontal",
// "Left" => "Left",
// "Right" => "Right",
"Up" => "Subir",
"Down" => "Bajar",
// "jQuery-ui Select Menu" => "jQuery-ui Select Menu",
// "Styled replacement for dropdown select menus" => "Styled replacement for dropdown select menus",
// "Use Select Menu on all select elements" => "Use Select Menu on all select elements",
// "Applies jQuery-ui Select Menu to every select menu" => "Applies jQuery-ui Select Menu to every select menu",
// "Experimental. This feature is under development" => "Experimental. This feature is under development",
// "Never delete versions younger than" => "Never delete versions younger than",
"Use database for translation" => "Usar la base para traducciones",
// "Use the database to store the translated strings and allow using interactive translation" => "Use the database to store the translated strings and allow using interactive translation",
// "[%0|Edit or export/import Languages]" => "[%0|Edit or export/import Languages]",
// "Language inclusion threshold" => "Language inclusion threshold",
// "When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages" => "When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages",
"Layout per section" => "Diseño por sección",
// "Layout Width" => "Layout Width",
// "Constrains the site display width (default: 990px)" => "Constrains the site display width (default: 990px)",
// "ex.: 800px" => "ex.: 800px",
// "Users can choose not to have tabs" => "Users can choose not to have tabs",
// "Add group CSS info" => "Add group CSS info",
// "Add classes to the page BODY tag to indicate group membership" => "Add classes to the page BODY tag to indicate group membership",
// "Either grp_Anonymous or grp_Registered and possibly grp_Admins as well" => "Either grp_Anonymous or grp_Registered and possibly grp_Admins as well",
// "If user does not exist in Tiki" => "If user does not exist in Tiki",
// "Create the user" => "Create the user",
// "Deny access" => "Deny access",
// "Create user if not in LDAP" => "Create user if not in LDAP",
// "Maximum average server load threshold in the last minute" => "Maximum average server load threshold in the last minute",
// "Log mail in Tiki logs" => "Log mail in Tiki logs",
// "Smarty Template usage indicator" => "Smarty Template usage indicator",
"Add HTML comment at start and end of each Smarty template (TPL)" => "Añade un comentario HTML al principio y final de cada plantilla Smarty (TPL)",
// "Use only for development, not in production because these warnings are added to emails as well, and visible to the users" => "Use only for development, not in production because these warnings are added to emails as well, and visible to the users",
// "You need to clear your Tiki template cache for this change to take effect" => "You need to clear your Tiki template cache for this change to take effect",
// "Log SQL" => "Log SQL",
// "Log SQL queries" => "Log SQL queries",
// "Log queries using more than (seconds)" => "Log queries using more than (seconds)",
// "This may impact performance" => "This may impact performance",
// "Use email as username" => "Use email as username",
// "Instead of creating new usernames, use the user's email address for authentication" => "Instead of creating new usernames, use the user's email address for authentication",
// "Obscure email when using email as username if possible (coverage will not be complete)" => "Obscure email when using email as username if possible (coverage will not be complete)",
// "This will attempt as much as possible to hide the email, showing the realname or the truncated email instead" => "This will attempt as much as possible to hide the email, showing the realname or the truncated email instead",
// "HTTP Basic Authentication" => "HTTP Basic Authentication",
// "Check credentials from HTTP Basic Authentication, useful to allow webservices to use credentials" => "Check credentials from HTTP Basic Authentication, useful to allow webservices to use credentials",
// "SSL Only (Recommended)" => "SSL Only (Recommended)",
"Long date format" => "Formato de fechas largas",
"Long time format" => "Formato largo para horas",
"%A %d of %B, %Y" => "%A %d de %B, %Y",
"%H:%M:%S %Z" => "%H:%M:%S %Z",
// "%A %d of %B, %Y %H:%M:%S %Z" => "%A %d of %B, %Y %H:%M:%S %Z",
// "Force lowercase" => "Force lowercase",
// "Mail end of line" => "Mail end of line",
"CRLF (standard)" => "CRLF-nueva línea (estándar)",
"LF (some Unix MTA)" => "LF-salto de línea (algunos Agentes de Transferencia de Correo (MTA) Unix)",
// "Main shadow start" => "Main shadow start",
// "Main shadow end" => "Main shadow end",
"full path to mapfiles" => "camino completo a archivos de mapa",
"Wiki Page for Help" => "Página Wiki para Ayuda",
"Wiki Page for Comments" => "Página Wiki para comentarios",
// "Maximum length" => "Maximum length",
// "Memcache" => "Memcache",
// "Enable connection to memcached servers to store temporary information" => "Enable connection to memcached servers to store temporary information",
// "Requires the PHP memcache extension" => "Requires the PHP memcache extension",
// "Memcache compression" => "Memcache compression",
// "Enable compression for memcache storage" => "Enable compression for memcache storage",
// "Memcache servers" => "Memcache servers",
// "Server list which may be accessed. For each server, the address, port and weight must be specified" => "Server list which may be accessed. For each server, the address, port and weight must be specified",
// "One per line. address:port (weight)" => "One per line. address:port (weight)",
// "Memcache key prefix" => "Memcache key prefix",
// "When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoiding conflicts" => "When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoiding conflicts",
// "Memcache expiration" => "Memcache expiration",
// "Duration for which the data will be kept" => "Duration for which the data will be kept",
// "Cache wiki data in memcache" => "Cache wiki data in memcache",
// "Cache wiki output in memcache" => "Cache wiki output in memcache",
// "Cache forum output in memcache" => "Cache forum output in memcache",
// "Menu icons" => "Menu icons",
// "Allows to define icons for menu entries" => "Allows to define icons for menu entries",
// "Default path for the icons" => "Default path for the icons",
// "Allow HTML in menu option names and URLs" => "Allow HTML in menu option names and URLs",
// "If enabled, menu option names and URL-s are treated as HTML content and they are not escaped (no replacement of HTML special characters). This allows the use of HTML to insert images for example. Code must be valid. This allows menu item editors to put arbitrary HTML; only enable if you know what you are doing" => "If enabled, menu option names and URL-s are treated as HTML content and they are not escaped (no replacement of HTML special characters). This allows the use of HTML to insert images for example. Code must be valid. This allows menu item editors to put arbitrary HTML; only enable if you know what you are doing",
// "REALLY allow HTML (INSECURE)" => "REALLY allow HTML (INSECURE)",
// "This needs to be checked for the parent preference to be actually enabled. This allows menu item editors to put arbitrary HTML, which could allow session hijacking; only enable if you know what you are doing" => "This needs to be checked for the parent preference to be actually enabled. This allows menu item editors to put arbitrary HTML, which could allow session hijacking; only enable if you know what you are doing",
"Maximum mailbox size (messages, 0=unlimited)" => "Tamaño máximo de casilla (mensajes, 0=ilimitado)",
"Maximum mail archive size (messages, 0=unlimited)" => "Tamaño máximo de archivo de mails (mensajes, 0=ilimitado)",
"Maximum sent box size (messages, 0=unlimited)" => "Tamaño máximo de carpeta de enviados (mensajes, 0=ilimitado)",
// "Keywords" => "Keywords",
// "A list of key words (separated by commas) that describe your site" => "A list of key words (separated by commas) that describe your site",
// "Include freetags" => "Include freetags",
// "If the freetags feature is enabled, use the freetags in the meta keywords for each page with freetags set. This allows individual pages on the site to carry different meta tags" => "If the freetags feature is enabled, use the freetags in the meta keywords for each page with freetags set. This allows individual pages on the site to carry different meta tags",
// "Use thread title instead" => "Use thread title instead",
// "Use the forum thread title in the meta title tag" => "Use the forum thread title in the meta title tag",
// "Use image title instead" => "Use image title instead",
// "Use the image title in the meta title tag" => "Use the image title in the meta title tag",
// "A short description of your site. Some search engines display this information with your site's listing" => "A short description of your site. Some search engines display this information with your site's listing",
// "Page Description" => "Page Description",
// "Use individual page description as a met tag for the page" => "Use individual page description as a met tag for the page",
// "The author of your site. Typically this will be the Admin or Webmaster" => "The author of your site. Typically this will be the Admin or Webmaster",
"geo.position" => "geo.posición",
// "The latitude and longitude of the physical location of the site. For example \"38.898748, -77.037684\"" => "The latitude and longitude of the physical location of the site. For example \"38.898748, -77.037684\"",
"geo.region" => "geo.región",
// "The ISO-3166 Country and Region Codes for your location. For example, \"US-NY\"" => "The ISO-3166 Country and Region Codes for your location. For example, \"US-NY\"",
"geo.placename" => "geo.nombrelugar",
// "A free-text description of your location" => "A free-text description of your location",
// "Meta robots" => "Meta robots",
// "Specify how web-bots should index your site. Valid values include: INDEX or NOINDEX, and FOLLOW or NOFOLLOW" => "Specify how web-bots should index your site. Valid values include: INDEX or NOINDEX, and FOLLOW or NOFOLLOW",
// "Revisit after" => "Revisit after",
// "Specify how often (in days) web-bots should visit your site" => "Specify how often (in days) web-bots should visit your site",
// "Show past metrics results" => "Show past metrics results",
// "In the metrics dashboard, identify if the previously collected metrics should be displayed" => "In the metrics dashboard, identify if the previously collected metrics should be displayed",
// "Past metrics count" => "Past metrics count",
// "Amount of past results to display" => "Amount of past results to display",
// "No metric trend value" => "No metric trend value",
// "Value to display when no trend is available for the metric" => "Value to display when no trend is available for the metric",
// "Metric trend prefix" => "Metric trend prefix",
// "Portion of text to display before the metric trend value" => "Portion of text to display before the metric trend value",
// "Metric trend suffix" => "Metric trend suffix",
// "Portion of text to display after the metric trend value" => "Portion of text to display after the metric trend value",
// "Metric name length" => "Metric name length",
// "Metric tab name length" => "Metric tab name length",
// "Cache metrics output" => "Cache metrics output",
// "Most metrics are expensive to generate. Because they tend to evolve slowly, some delay between update and generation can be tolerated. Disabling cache is not recommended" => "Most metrics are expensive to generate. Because they tend to evolve slowly, some delay between update and generation can be tolerated. Disabling cache is not recommended",
// "Middle shadow start" => "Middle shadow start",
// "Middle shadow end" => "Middle shadow end",
// "Minimum length" => "Minimum length",
// "Mobile Access" => "Mobile Access",
// "New mobile feature for Tiki 7" => "New mobile feature for Tiki 7",
// "Mobile Perspectives" => "Mobile Perspectives",
// "Header Theme" => "Header Theme",
// "jQuery Mobile Theme" => "jQuery Mobile Theme",
// "Content Theme" => "Content Theme",
// "Footer Theme" => "Footer Theme",
// "Modules Theme" => "Modules Theme",
// "Menus Theme" => "Menus Theme",
// "Use Latest Library" => "Use Latest Library",
// "Use latest version of the jquery.mobile" => "Use latest version of the jquery.mobile",
// "Uses latest build from jquery.com CDN" => "Uses latest build from jquery.com CDN",
// "Top module zone" => "Top module zone",
// "Visibility of area to keep modules such as logo, login etc (header)" => "Visibility of area to keep modules such as logo, login etc (header)",
// "Topbar module zone" => "Topbar module zone",
// "Visibility of area for modules such as main horizontal menu, search form, page-wide content, etc" => "Visibility of area for modules such as main horizontal menu, search form, page-wide content, etc",
// "topbar" => "topbar",
// "Page top module zone" => "Page top module zone",
// "Visibility of area to keep modules such as share etc" => "Visibility of area to keep modules such as share etc",
// "Bottom module zone" => "Bottom module zone",
// "Visibility of area to keep modules such as \"powered by\" and \"rss list\" (footer)" => "Visibility of area to keep modules such as \"powered by\" and \"rss list\" (footer)",
// "Page bottom module zone" => "Page bottom module zone",
// "Visibility of area to keep modules at the foot of each page" => "Visibility of area to keep modules at the foot of each page",
// "\"More Like This\" algorithm" => "\"More Like This\" algorithm",
// "Minimum number of tags in common" => "Minimum number of tags in common",
// "Multi-domain" => "Multi-domain",
// "Allows to map domain names to perspectives and simulate multiple domains hosted on the same instance" => "Allows to map domain names to perspectives and simulate multiple domains hosted on the same instance",
// "Multi-domain Configuration" => "Multi-domain Configuration",
// "Comma-separated values mapping the domain name to the perspective ID" => "Comma-separated values mapping the domain name to the perspective ID",
// "One domain per line. Comma separated with perspective ID. Ex.: tiki.org,1" => "One domain per line. Comma separated with perspective ID. Ex.: tiki.org,1",
// "Switch domain when switching perspective" => "Switch domain when switching perspective",
// "Remember that different domains have different login sessions and even in the case of subdomains you need to have an understanding of session cookies to make it work" => "Remember that different domains have different login sessions and even in the case of subdomains you need to have an understanding of session cookies to make it work",
// "Throttle newsletter send rate" => "Throttle newsletter send rate",
// "Pause for a given amount of seconds before each batch to avoid overloading the mail server" => "Pause for a given amount of seconds before each batch to avoid overloading the mail server",
// "Newsletter pause length" => "Newsletter pause length",
// "Amount of seconds on wait before each batch" => "Amount of seconds on wait before each batch",
// "Newsletter batch size" => "Newsletter batch size",
// "Amount of emails to send in each batch" => "Amount of emails to send in each batch",
// "Allow sending newsletters through external clients" => "Allow sending newsletters through external clients",
// "Generate mailto links using the recipients as the BCC list" => "Generate mailto links using the recipients as the BCC list",
// "This will expose the list if email addresses to all users allowed to send newsletters" => "This will expose the list if email addresses to all users allowed to send newsletters",
// "Use relative (next / previous) pagination links" => "Use relative (next / previous) pagination links",
// "Wiki buttons" => "Wiki buttons",
// "Page description, icons, backlinks, .." => "Page description, icons, backlinks, ..",
// "Top " => "Top ",
// "Bottom" => "Bottom",
// "Neither" => "Neither",
// "A page can occur multiple times in a structure" => "A page can occur multiple times in a structure",
// "Display fast move links (by 10 percent of the total number of pages) " => "Display fast move links (by 10 percent of the total number of pages) ",
// "Hide pagination when there is only one page" => "Hide pagination when there is only one page",
// "Use Icons" => "Use Icons",
// "Display 'First' and 'Last' links" => "Display 'First' and 'Last' links",
"PAM service" => "Servicio PAM",
"Currently unused" => "Actualmente no usado",
// "Require characters and numerals" => "Require characters and numerals",
// "For improved security, require users to include a mix of characters and numerals in passwords" => "For improved security, require users to include a mix of characters and numerals in passwords",
// "Password expires after" => "Password expires after",
// "Require alphabetical characters in lower and upper case" => "Require alphabetical characters in lower and upper case",
// "Password must contain at least one alphabetical character in lower case like a and one in upper case like A" => "Password must contain at least one alphabetical character in lower case like a and one in upper case like A",
// "Require special characters" => "Require special characters",
// "Password must contain at least one special character in lower case like \" / \$ % ? & * ( ) _ + .." => "Password must contain at least one special character in lower case like \" / \$ % ? & * ( ) _ + ..",
// "Require no consecutive repetition of the same character" => "Require no consecutive repetition of the same character",
// "Password must contain no consecutive repetition of the same character as 111 or aab" => "Password must contain no consecutive repetition of the same character as 111 or aab",
// "Password must be different from the user login" => "Password must be different from the user login",
// "Payment" => "Payment",
// "Feature to manage and track payment requests" => "Feature to manage and track payment requests",
// "Payment System" => "Payment System",
// "Currently a choice between PayPal, and Cclite (in development), or Tiki User Credits" => "Currently a choice between PayPal, and Cclite (in development), or Tiki User Credits",
// "PayPal: see PayPal.com - Cclite: Community currency" => "PayPal: see PayPal.com - Cclite: Community currency",
// "PayPal" => "PayPal",
// "Cclite" => "Cclite",
// "Paypal Business ID" => "Paypal Business ID",
// "Enable payments through paypal" => "Enable payments through paypal",
"Email address" => "Dirección de correo",
// "Paypal Environment" => "Paypal Environment",
// "Used to switch between the paypal sandbox, used for testing and development and the live environment" => "Used to switch between the paypal sandbox, used for testing and development and the live environment",
// "Production" => "Production",
// "Paypal Instant Payment Notification (IPN)" => "Paypal Instant Payment Notification (IPN)",
// "Enable IPN for automatic payment completion. When enabled, Paypal will ping back the site when a payment is confirmed. The payment will then be entered automatically. This may not be possible if the server is not on a public server" => "Enable IPN for automatic payment completion. When enabled, Paypal will ping back the site when a payment is confirmed. The payment will then be entered automatically. This may not be possible if the server is not on a public server",
// "Currency used when entering payments" => "Currency used when entering payments",
// "Default acceptable payment delay" => "Default acceptable payment delay",
// "Amount of days before the payment requests becomes overdue. This can be changed per payment request" => "Amount of days before the payment requests becomes overdue. This can be changed per payment request",
// "Cclite Registries" => "Cclite Registries",
// "Registries in Cclite" => "Registries in Cclite",
// "Registry names in Cclite" => "Registry names in Cclite",
// "Cclite Registry Currencies" => "Cclite Registry Currencies",
// "Currencies in Cclite" => "Currencies in Cclite",
// "Each registry in Cclite can have it's own currency. Must be one per registry. (case sensitive)" => "Each registry in Cclite can have it's own currency. Must be one per registry. (case sensitive)",
// "Cclite Server URL" => "Cclite Server URL",
// "Full URL of the repository" => "Full URL of the repository",
// "e.g. https://cclite.yourdomain.org/cclite/" => "e.g. https://cclite.yourdomain.org/cclite/",
// "Cclite Merchant Key" => "Cclite Merchant Key",
// "Corresponds with Merchant Key setting in Cclite" => "Corresponds with Merchant Key setting in Cclite",
// "Cclite Merchant User" => "Cclite Merchant User",
// "User name in Cclite representing \"the management\". Defaults to \"manager\"" => "User name in Cclite representing \"the management\". Defaults to \"manager\"",
// "Cclite Enable Payments" => "Cclite Enable Payments",
// "Test or Live operation" => "Test or Live operation",
// "Live" => "Live",
// "Hashing Algorithm" => "Hashing Algorithm",
// "Encryption type" => "Encryption type",
// "SHA1" => "SHA1",
// "SHA256" => "SHA256",
// "SHA512" => "SHA512",
// "Cclite Payment Notification" => "Cclite Payment Notification",
// "TODO" => "TODO",
// "Wiki page containing the instruction to send manual payment like check" => "Wiki page containing the instruction to send manual payment like check",
// "Wiki page" => "Wiki page",
// "Prefix to the invoice" => "Prefix to the invoice",
// "Prefix must be set and unique if the same paypal account is used for different tiki sites as paypal checks that the invoice is not paid twice" => "Prefix must be set and unique if the same paypal account is used for different tiki sites as paypal checks that the invoice is not paid twice",
// "Types of credit to use" => "Types of credit to use",
// "This is a list of the types of Tiki user credits to accept to pay with" => "This is a list of the types of Tiki user credits to accept to pay with",
// "Exchange rate for types of credit to use" => "Exchange rate for types of credit to use",
// "This is a corresponding list of amount of credits equivalent to 1 of the payment currency" => "This is a corresponding list of amount of credits equivalent to 1 of the payment currency",
// "User can only see his own outstanding payments" => "User can only see his own outstanding payments",
// "Unless with administer payment permissions, a user can only see his own outstanding payments" => "Unless with administer payment permissions, a user can only see his own outstanding payments",
// "User can only see his own past or cancelled payments" => "User can only see his own past or cancelled payments",
// "Unless with administer payment permissions, a user can only see his own past or cancelled payments" => "Unless with administer payment permissions, a user can only see his own past or cancelled payments",
// "Manage product inventory" => "Manage product inventory",
// "Activate product inventory feature, needs Products tracker to be set up properly, the itemId must be the product code" => "Activate product inventory feature, needs Products tracker to be set up properly, the itemId must be the product code",
// "Products Tracker ID" => "Products Tracker ID",
// "Tracker ID of tracker that is the Products tracker, needed for advanced cart features, the itemId will be the product code" => "Tracker ID of tracker that is the Products tracker, needed for advanced cart features, the itemId will be the product code",
// "Products Tracker Name" => "Products Tracker Name",
// "Name of tracker that is the Products tracker, needed for advanced cart features, the itemId will be the product code" => "Name of tracker that is the Products tracker, needed for advanced cart features, the itemId will be the product code",
// "Inventory Type Field ID" => "Inventory Type Field ID",
// "Field ID in Products tracker to store the inventory type, the value of the field must be \"none\" or \"internal\"" => "Field ID in Products tracker to store the inventory type, the value of the field must be \"none\" or \"internal\"",
// "Inventory Total Field ID" => "Inventory Total Field ID",
// "Field ID in Products tracker to store the total inventory of product" => "Field ID in Products tracker to store the total inventory of product",
// "Inventory Total Less Hold Field ID" => "Inventory Total Less Hold Field ID",
// "Field ID in Products tracker to store the total inventory of product less the amount on hold because they are currently in carts" => "Field ID in Products tracker to store the total inventory of product less the amount on hold because they are currently in carts",
// "Inventory Hold Timeout (minutes)" => "Inventory Hold Timeout (minutes)",
// "Minutes to hold inventory before making it available again when there is no user cart action" => "Minutes to hold inventory before making it available again when there is no user cart action",
// "Bundled products feature for cart" => "Bundled products feature for cart",
// "Activate bundled products feature, needs Products tracker to be set up properly, the itemId must be the product code" => "Activate bundled products feature, needs Products tracker to be set up properly, the itemId must be the product code",
// "Product Name Field Name" => "Product Name Field Name",
// "Field Name in Products tracker of the product name that will be used as the label of the product, e.g. in a bundle" => "Field Name in Products tracker of the product name that will be used as the label of the product, e.g. in a bundle",
// "Items in Bundle Field Name" => "Items in Bundle Field Name",
// "Field Name in Products tracker of a comma separated list of product IDs of products in the bundle (i.e. if the field contains anything, then this product is a bundle), you can also specify the number of the sub-products, e.g. 23:(\"colon\")2,24 means item 23 (x2) + item 24 (x1)" => "Field Name in Products tracker of a comma separated list of product IDs of products in the bundle (i.e. if the field contains anything, then this product is a bundle), you can also specify the number of the sub-products, e.g. 23:(\"colon\")2,24 means item 23 (x2) + item 24 (x1)",
// "Product Price Field Name" => "Product Price Field Name",
// "Field Name in Products tracker of the product price" => "Field Name in Products tracker of the product price",
// "Associated Event ID Field Name" => "Associated Event ID Field Name",
// "Field Name in Products tracker of the Associated Event ID, needed for the Associated Events cart feature, requires an Events tracker to be setup where the item ID there is the event ID to associate to" => "Field Name in Products tracker of the Associated Event ID, needed for the Associated Events cart feature, requires an Events tracker to be setup where the item ID there is the event ID to associate to",
// "Product Class ID Field Name" => "Product Class ID Field Name",
// "Field Name in Products tracker of the Product Class ID, needed for the Gift Certificates cart feature" => "Field Name in Products tracker of the Product Class ID, needed for the Gift Certificates cart feature",
// "Gift Certificate Template Field Name" => "Gift Certificate Template Field Name",
// "Field Name in Products tracker of the Gift Cert Template, needed for the Gift Certificates cart feature" => "Field Name in Products tracker of the Gift Cert Template, needed for the Gift Certificates cart feature",
// "Record cart orders in trackers (registered users)" => "Record cart orders in trackers (registered users)",
// "This feature requires 2 trackers, and Orders tracker and an Orders Item tracker to be configured. It also needs profiles to be configured to do the recording" => "This feature requires 2 trackers, and Orders tracker and an Orders Item tracker to be configured. It also needs profiles to be configured to do the recording",
// "Orders Profile" => "Orders Profile",
// "Wiki page where the profile for creating orders is (page name must be without spaces)" => "Wiki page where the profile for creating orders is (page name must be without spaces)",
// "Order Item Profile" => "Order Item Profile",
// "Wiki page where the profile for creating orders items is (page name must be without spaces)" => "Wiki page where the profile for creating orders items is (page name must be without spaces)",
// "Allow anonymous shopping and record their orders in trackers" => "Allow anonymous shopping and record their orders in trackers",
// "Allows shopping as anonymous user" => "Allows shopping as anonymous user",
// "Anonymous Orders Profile" => "Anonymous Orders Profile",
// "Wiki page where the profile for creating orders for Anonymous users is (page name must be without spaces)" => "Wiki page where the profile for creating orders for Anonymous users is (page name must be without spaces)",
// "Anonymous Order Item Profile" => "Anonymous Order Item Profile",
// "Wiki page where the profile for creating orders items for Anonymous users is (page name must be without spaces)" => "Wiki page where the profile for creating orders items for Anonymous users is (page name must be without spaces)",
// "Anonymous Shopper Info Profile" => "Anonymous Shopper Info Profile",
// "Anonymous Users Order Review Page" => "Anonymous Users Order Review Page",
// "Wiki page where Anonymous users can review their orders)" => "Wiki page where Anonymous users can review their orders)",
// "Temporary Shopper Group to Access Review Page via Token" => "Temporary Shopper Group to Access Review Page via Token",
// "Group name of group with perms to access review page via token" => "Group name of group with perms to access review page via token",
// "Allow association of product orders to events (or projects etc...)" => "Allow association of product orders to events (or projects etc...)",
// "Allow association of products to events (or projects etc...)" => "Allow association of products to events (or projects etc...)",
// "Events Tracker ID" => "Events Tracker ID",
// "Tracker ID of tracker that is the Events tracker" => "Tracker ID of tracker that is the Events tracker",
// "Events Tracker Name" => "Events Tracker Name",
// "Name of tracker that is the Events tracker" => "Name of tracker that is the Events tracker",
// "Event Start Field Name" => "Event Start Field Name",
// "Field Name in Events tracker of start date/time" => "Field Name in Events tracker of start date/time",
// "Event End Field Name" => "Event End Field Name",
// "Field Name in Events tracker of end date/time" => "Field Name in Events tracker of end date/time",
// "Allow exchange of products" => "Allow exchange of products",
// "Order Items Tracker ID" => "Order Items Tracker ID",
// "Tracker ID of tracker that is the Order Items tracker" => "Tracker ID of tracker that is the Order Items tracker",
// "Gift certificates" => "Gift certificates",
// "Gift Certificates" => "Gift Certificates",
// "Gift Certificate Tracker ID" => "Gift Certificate Tracker ID",
// "Tracker ID of tracker that is the Gift Certificate tracker" => "Tracker ID of tracker that is the Gift Certificate tracker",
// "Gift Certificate Tracker Name" => "Gift Certificate Tracker Name",
// "Name of tracker that is the Gift Certificate tracker" => "Name of tracker that is the Gift Certificate tracker",
// "Orders Tracker Name" => "Orders Tracker Name",
// "Name of tracker that is the Orders tracker" => "Name of tracker that is the Orders tracker",
// "Order Items Tracker Name" => "Order Items Tracker Name",
// "Name of tracker that is the Order Items tracker" => "Name of tracker that is the Order Items tracker",
// "Product Classes Tracker Name" => "Product Classes Tracker Name",
// "Name of tracker that is the Product Classes tracker" => "Name of tracker that is the Product Classes tracker",
// "Send to URL" => "Send to URL",
// "On permission denied, display login module (for Anonymous)" => "On permission denied, display login module (for Anonymous)",
// "PHP libxml extension" => "PHP libxml extension",
// "This extension requires the libxml PHP extension.\n\t\t\t\t\t\t\tThis means that passing in --enable-libxml is also required, although this is\n\t\t\t\t\t\t\timplicitly accomplished because libxml is enabled by default" => "This extension requires the libxml PHP extension.\n\t\t\t\t\t\t\tThis means that passing in --enable-libxml is also required, although this is\n\t\t\t\t\t\t\timplicitly accomplished because libxml is enabled by default",
// "PHP DateTime" => "PHP DateTime",
// "DateTime class (and related functions) are enabled\n\t\t\t\t\t\t\tby default since PHP 5.2.0, it is possible to add experimental support into PHP\n\t\t\t\t\t\t\t5.1.x by using the following flag before configure/compile:\n\t\t\t\t\t\t\tCFLAGS=-DEXPERIMENTAL_DATE_SUPPORT=1" => "DateTime class (and related functions) are enabled\n\t\t\t\t\t\t\tby default since PHP 5.2.0, it is possible to add experimental support into PHP\n\t\t\t\t\t\t\t5.1.x by using the following flag before configure/compile:\n\t\t\t\t\t\t\tCFLAGS=-DEXPERIMENTAL_DATE_SUPPORT=1",
// "Show categories" => "Show categories",
// "Show objects" => "Show objects",
// "Multiple polls per object" => "Multiple polls per object",
// "When used with the rating features, allow multiple polls to be attached to a single object" => "When used with the rating features, allow multiple polls to be attached to a single object",
// "PDF from URL" => "PDF from URL",
// "Using extenal tools, generate PDF document from web URLs" => "Using extenal tools, generate PDF document from web URLs",
// "WebKit (wkhtmltopdf)" => "WebKit (wkhtmltopdf)",
// "Webservice URL" => "Webservice URL",
// "URL to a service taking a URL as the query string and returns a PDF document" => "URL to a service taking a URL as the query string and returns a PDF document",
// "WebKit path" => "WebKit path",
// "Full path to the wkhtmltopdf executable to generate the PDF document with" => "Full path to the wkhtmltopdf executable to generate the PDF document with",
// "Repository URLs" => "Repository URLs",
// "List of URLs for the profile repositories that will be used" => "List of URLs for the profile repositories that will be used",
// "Enter multiple repository URLs, one per line" => "Enter multiple repository URLs, one per line",
// "Data Channels" => "Data Channels",
// "Data channels are templates that can be applied from a post request. They can be used to automate work on more complex installations" => "Data channels are templates that can be applied from a post request. They can be used to automate work on more complex installations",
// "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain __channel name, domain, profile, allowed groups, (optional) \$profilerequest:input\$ matches to groups__" => "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain __channel name, domain, profile, allowed groups, (optional) \$profilerequest:input\$ matches to groups__",
// "There are security considerations related to using data channels. Make sure the profile page is controlled by administrators only" => "There are security considerations related to using data channels. Make sure the profile page is controlled by administrators only",
// "Developer mode" => "Developer mode",
// "For profiles under an approval workflow, always use the latest version, even if not approved" => "For profiles under an approval workflow, always use the latest version, even if not approved",
// "Make sure you review the profiles you install" => "Make sure you review the profiles you install",
// "Proxy host name" => "Proxy host name",
// "Proxy host - without http:// or similar, just the host name" => "Proxy host - without http:// or similar, just the host name",
"Proxy port" => "Puerto Proxy",
// "Proxy username" => "Proxy username",
// "Proxy password" => "Proxy password",
// "Quantify change size" => "Quantify change size",
// "In addition to tracking the changes, track the change size and display the approximate up-to-date-ness of the page" => "In addition to tracking the changes, track the change size and display the approximate up-to-date-ness of the page",
// "Advanced Rating" => "Advanced Rating",
// "Rating system allowing for options and calculation method to be configured" => "Rating system allowing for options and calculation method to be configured",
// "Rating recalculation mode" => "Rating recalculation mode",
// "Determines when and how rating aggregates are recalculated. Depending on the site load, some options may be preferred to others. On large volume sites, it should be done as a cron job. On vote recalculation may be inaccurate if rating calculation depends time" => "Determines when and how rating aggregates are recalculated. Depending on the site load, some options may be preferred to others. On large volume sites, it should be done as a cron job. On vote recalculation may be inaccurate if rating calculation depends time",
// "Recalculate on vote" => "Recalculate on vote",
// "Randomly recalculate oldest ratings (on load)" => "Randomly recalculate oldest ratings (on load)",
// "Randomly recalculate oldest ratings (on vote)" => "Randomly recalculate oldest ratings (on vote)",
// "Cron job (must be set manually)" => "Cron job (must be set manually)",
// "Recalculation odds (1 in X)" => "Recalculation odds (1 in X)",
// "Dice roll performed on every request. When successful, will recalculate a certain number of votes" => "Dice roll performed on every request. When successful, will recalculate a certain number of votes",
// "Recalculation count" => "Recalculation count",
// "How many ratings should be recalculated when odds strike" => "How many ratings should be recalculated when odds strike",
// "Use ReCaptcha" => "Use ReCaptcha",
// "Use ReCaptcha, a specialized captcha service, instead of default CAPTCHA" => "Use ReCaptcha, a specialized captcha service, instead of default CAPTCHA",
// "You will need to register at [http://www.google.com/recaptcha]" => "You will need to register at [http://www.google.com/recaptcha]",
// "Public Key" => "Public Key",
// "ReCaptcha public key" => "ReCaptcha public key",
// "Private Key" => "Private Key",
// "ReCaptcha private key" => "ReCaptcha private key",
"Record untranslated strings" => "Registrar cadenas no traducidos",
// "Keep track of the unsuccessful attemps to translate strings" => "Keep track of the unsuccessful attemps to translate strings",
// "Restrict supported languages" => "Restrict supported languages",
// "Limit the languages made available on the site" => "Limit the languages made available on the site",
// "SCORM Support" => "SCORM Support",
// "Handle SCORM package files on upload. SCORM is a standard used in Learning Management Systems" => "Handle SCORM package files on upload. SCORM is a standard used in Learning Management Systems",
"SCORM Tracker" => "Formulario-bd de SCORM",
"Tracker ID to use to store the SCORM metadata" => "ID del Formulario-bd a usar para guardar las metadatos de SCORM",
// "Parse the results" => "Parse the results",
// "Default where" => "Default where",
// "When object filter is not on, limit to search one type of object" => "When object filter is not on, limit to search one type of object",
// "Entire site" => "Entire site",
"Wiki Pages" => "Páginas del wiki",
"Blog Posts" => "Blog Posts",
"Tracker Items" => "Ítems de Formularios-bd",
"Spreadsheets" => "Hojas de cálculo",
// "Restrict search language by default" => "Restrict search language by default",
// "If enabled, only search content in the interface language, otherwise show language menu" => "If enabled, only search content in the interface language, otherwise show language menu",
// "Autocomplete on page names" => "Autocomplete on page names",
// "Category filter" => "Category filter",
// "Tag filter" => "Tag filter",
// "Parse wiki syntax in comments in all sections apart from Forums" => "Parse wiki syntax in comments in all sections apart from Forums",
// "Use \"Accept wiki syntax\" for forums in admin forums page" => "Use \"Accept wiki syntax\" for forums in admin forums page",
"Sender email" => "Correo-e del enviador",
// "Email address that will be used as the sender for outgoing emails" => "Email address that will be used as the sender for outgoing emails",
// "Time zone" => "Time zone",
// "Indicates the default time zone to use for the server" => "Indicates the default time zone to use for the server",
// "Session storage location" => "Session storage location",
// "Select where the session information should be stored. Memcache sessions require memcache to be configured" => "Select where the session information should be stored. Memcache sessions require memcache to be configured",
// "Default (from php.ini)" => "Default (from php.ini)",
"Database" => "Base de datos",
// "Session lifetime" => "Session lifetime",
// "Value provided in minutes. It will be the minimum time you are logged in. If you want it to be the exact time, you need to adjust in .htaccess session.gc_probability and session.gc_divisor to 1. Be careful that changing the probability will affect the server performance" => "Value provided in minutes. It will be the minimum time you are logged in. If you want it to be the exact time, you need to adjust in .htaccess session.gc_probability and session.gc_divisor to 1. Be careful that changing the probability will affect the server performance",
// "Silent session" => "Silent session",
// "Do not automatically start sessions" => "Do not automatically start sessions",
// "Users will only have a session if they log in. So anonymous users will lose the capacity to have things like Switch Language (a session is needed for this)" => "Users will only have a session if they log in. So anonymous users will lose the capacity to have things like Switch Language (a session is needed for this)",
// "Session cookie name" => "Session cookie name",
// "Session cookie name used instead of the PHP default configuration" => "Session cookie name used instead of the PHP default configuration",
// "Protect all sessions with HTTPS" => "Protect all sessions with HTTPS",
// "Always redirect to HTTPS to prevent session hijack through network sniffing" => "Always redirect to HTTPS to prevent session hijack through network sniffing",
// "Only activate if you have already configured SSL, otherwise, your will lock yourself out of Tiki" => "Only activate if you have already configured SSL, otherwise, your will lock yourself out of Tiki",
// "Display links in the share page" => "Display links in the share page",
// "Token notification" => "Token notification",
// "Users can subscribe to the notifications of consultation of the token" => "Users can subscribe to the notifications of consultation of the token",
// "Add contact" => "Add contact",
// "If not exist, recipients are add in the list of contacts" => "If not exist, recipients are add in the list of contacts",
// "Display name and email" => "Display name and email",
// "If user is connect, name and email display in the page" => "If user is connect, name and email display in the page",
// "How many times accessed" => "How many times accessed",
// "User can choose how many times the share page can be consulted" => "User can choose how many times the share page can be consulted",
// "Max how many times accessed" => "Max how many times accessed",
// "Maximum number of times that the shared page can be consulted" => "Maximum number of times that the shared page can be consulted",
// "Default group" => "Default group",
// "Create with default group" => "Create with default group",
// "Valid affiliations" => "Valid affiliations",
// "Separate multiple affiliations with commas" => "Separate multiple affiliations with commas",
// "Shipping Service" => "Shipping Service",
// "Expose a JSON shipping rate estimation service. Accounts from providers may be required (FedEx, UPS, ...)" => "Expose a JSON shipping rate estimation service. Accounts from providers may be required (FedEx, UPS, ...)",
// "FedEx API" => "FedEx API",
// "Enable shipping rate calculation through FedEx APIs" => "Enable shipping rate calculation through FedEx APIs",
// "FedEx Key" => "FedEx Key",
// "Developer Key" => "Developer Key",
// "FedEx Password" => "FedEx Password",
// "FedEx Meter Number" => "FedEx Meter Number",
// "FedEx Account Number" => "FedEx Account Number",
// "UPS API" => "UPS API",
// "Enable shipping rate calculation using the UPS carrier" => "Enable shipping rate calculation using the UPS carrier",
// "UPS Username" => "UPS Username",
// "UPS credentials" => "UPS credentials",
// "UPS Password" => "UPS Password",
// "UPS Access Key" => "UPS Access Key",
// "Custom Shipping Provider" => "Custom Shipping Provider",
"Short date format" => "Formato de fechas cortas",
"Short time format" => "Formato corto para horas",
// "%Y-%m-%d" => "%Y-%m-%d",
// "%H:%M" => "%H:%M",
// "%Y-%m-%d %H:%M" => "%Y-%m-%d %H:%M",
// "Display available translations" => "Display available translations",
// "" => "",
// "Close site (except for those with permission)" => "Close site (except for those with permission)",
// "Message to display" => "Message to display",
// "Locations (breadcrumbs)" => "Locations (breadcrumbs)",
// "Choices" => "Choices",
// "Site title location" => "Site title location",
// "Location of the site title in the browser title bar relative to the current page's descriptor" => "Location of the site title in the browser title bar relative to the current page's descriptor",
"After" => "Después de",
"Before" => "Antes de",
// "Browser title display mode" => "Browser title display mode",
// "When breadcrumbs are used, method in which the browser title should be displayed" => "When breadcrumbs are used, method in which the browser title should be displayed",
// "Most specific first" => "Most specific first",
// "Least specific first (site)" => "Least specific first (site)",
// "Current only" => "Current only",
// "Favicon icon file name" => "Favicon icon file name",
// "Favicon MIME type" => "Favicon MIME type",
// "Typical file extensions:<table><tr><td>image/jpeg</td><td><strong>.jpg</strong></td></tr><tr><td>imp/png</td><td><strong>.png</strong></td></tr><tr><td>img/gif</td><td><strong>.gif</strong></td></tr><tr><td>image/vnd.microsoft.icon</td><td><strong>.ico</strong></td></tr></table>" => "Typical file extensions:<table><tr><td>image/jpeg</td><td><strong>.jpg</strong></td></tr><tr><td>imp/png</td><td><strong>.png</strong></td></tr><tr><td>img/gif</td><td><strong>.gif</strong></td></tr><tr><td>image/vnd.microsoft.icon</td><td><strong>.ico</strong></td></tr></table>",
// "image/jpeg" => "image/jpeg",
"image/png" => "image/png",
// "image/gif" => "image/gif",
// "image/vnd.microsoft.icon" => "image/vnd.microsoft.icon",
// "Site Terminal" => "Site Terminal",
// "Allows to direct users to a specific perspective depending on the origin IP address. Can be used inside intranets to use different configurations for users depending on their departements or discriminate people in web contexts. Unspecified IPs will fall back to default behavior, including multi-domain handling. Manually selected perspectives take precedence over this" => "Allows to direct users to a specific perspective depending on the origin IP address. Can be used inside intranets to use different configurations for users depending on their departements or discriminate people in web contexts. Unspecified IPs will fall back to default behavior, including multi-domain handling. Manually selected perspectives take precedence over this",
// "Site Terminal Configuration" => "Site Terminal Configuration",
// "Provides the mapping from subnets to perspective" => "Provides the mapping from subnets to perspective",
// "One per line. Network prefix in CIDR notation (address/mask size), separated by comma with the perspective ID" => "One per line. Network prefix in CIDR notation (address/mask size), separated by comma with the perspective ID",
"Publish" => "Publicar",
// "Logo source (image path)" => "Logo source (image path)",
// "Logo background color" => "Logo background color",
// "Examples" => "Examples",
// "Logo title (on mouse over)" => "Logo title (on mouse over)",
"Alt. description (e.g. for text browsers)" => "Descripción alt. (p/ej para browsers de texto)",
// "Include smarty notices in PHP error report" => "Include smarty notices in PHP error report",
// "In most cases, smarty notices can be safely ignored. However, they may be useful in the development process when strange issues occur" => "In most cases, smarty notices can be safely ignored. However, they may be useful in the development process when strange issues occur",
// "Smarty Security" => "Smarty Security",
// "Do not allow php code in smarty templates" => "Do not allow php code in smarty templates",
// "You should leave this on unless you know what you are doing" => "You should leave this on unless you know what you are doing",
// "Smarty Compilation" => "Smarty Compilation",
// "Indicates when the template cache should be refreshed" => "Indicates when the template cache should be refreshed",
"Modified" => "Modificado",
// "Never check (performance)" => "Never check (performance)",
// "Always (development, slow)" => "Always (development, slow)",
// "Consumer key" => "Consumer key",
// "Consumer key generated by registering your site as an application at Twitter" => "Consumer key generated by registering your site as an application at Twitter",
// "Consumer secret" => "Consumer secret",
// "Consumer secret generated by registering your site as an application at Twitter" => "Consumer secret generated by registering your site as an application at Twitter",
// "Application secret" => "Application secret",
// "Application secret generated by registering your site as an application at Facebook" => "Application secret generated by registering your site as an application at Facebook",
// "Application ID" => "Application ID",
// "Application id generated by registering your site as an application at Facebook" => "Application id generated by registering your site as an application at Facebook",
// "Login using Facebook" => "Login using Facebook",
// "Allow users to login using Facebook" => "Allow users to login using Facebook",
// "Auto-create Tiki user" => "Auto-create Tiki user",
// "Automatically create a Tiki user by the username of fb_xxxxxxxx for users logging in using Facebook if they do not yet have a Tiki account. If not, they will be asked to link or register a Tiki account" => "Automatically create a Tiki user by the username of fb_xxxxxxxx for users logging in using Facebook if they do not yet have a Tiki account. If not, they will be asked to link or register a Tiki account",
// "Require Facebook users to enter local account info" => "Require Facebook users to enter local account info",
// "Require Facebook users to enter local account info, specifically email and local login name" => "Require Facebook users to enter local account info, specifically email and local login name",
// "Tiki can access Facebook at any time" => "Tiki can access Facebook at any time",
// "Even when user is not logged onto Facebook, Tiki can access it" => "Even when user is not logged onto Facebook, Tiki can access it",
// "Tiki can post to Wall" => "Tiki can post to Wall",
// "Tiki may post status messages, notes, photos, and videos to Facebook Wall" => "Tiki may post status messages, notes, photos, and videos to Facebook Wall",
// "Tiki can manage events" => "Tiki can manage events",
// "Tiki may create and RSVP to Facebook events" => "Tiki may create and RSVP to Facebook events",
// "Tiki can manage pages" => "Tiki can manage pages",
// "Tiki may manage user pages" => "Tiki may manage user pages",
// "Tiki can SMS" => "Tiki can SMS",
// "Tiki may SMS via Facebook" => "Tiki may SMS via Facebook",
// "bit.ly Login" => "bit.ly Login",
// "Site wide login (username) for bit.ly" => "Site wide login (username) for bit.ly",
// "bit.ly Key" => "bit.ly Key",
// "Site wide API key for bit.ly" => "Site wide API key for bit.ly",
// "Use site-wide account" => "Use site-wide account",
// "When setting this option to yes, only the site wide account will be used for all users" => "When setting this option to yes, only the site wide account will be used for all users",
// "Theme options" => "Theme options",
// "Style options" => "Style options",
// "New.." => "New..",
// "Theme Generator" => "Theme Generator",
// "Permits to adjust colors and fonts via the browser" => "Permits to adjust colors and fonts via the browser",
// "Custom Theme" => "Custom Theme",
// "Description needed" => "Description needed",
// "Check frequency" => "Check frequency",
"Each day" => "Cada día",
"Each week" => "Cada semana",
"Each month" => "Cada mes",
// "Minify JavaScript" => "Minify JavaScript",
// "Compress JavaScript files used in the page into a single file to be distributed statically. Changes to JavaScript files will require cache to be cleared. Uses http://code.google.com/p/minify/" => "Compress JavaScript files used in the page into a single file to be distributed statically. Changes to JavaScript files will require cache to be cleared. Uses http://code.google.com/p/minify/",
// "Minify CSS" => "Minify CSS",
// "Compress CSS files by removing additional spaces and grouping multiple files into one. Changes to CSS files will require cache to be cleared. Uses http://code.google.com/p/minify/" => "Compress CSS files by removing additional spaces and grouping multiple files into one. Changes to CSS files will require cache to be cleared. Uses http://code.google.com/p/minify/",
// "Minify CSS into a single file" => "Minify CSS into a single file",
// "In addition to reducing the size of the CSS, reduce the number of included files" => "In addition to reducing the size of the CSS, reduce the number of included files",
// "This setting may not work out of the box for all styles. import needs to use @import url(\"...\") and not @import \"...\"" => "This setting may not work out of the box for all styles. import needs to use @import url(\"...\") and not @import \"...\"",
// "Skip date for same day" => "Skip date for same day",
// "When displaying short date and time, skip date for today. Only time will be displayed" => "When displaying short date and time, skip date for today. Only time will be displayed",
// "Cache-Control header" => "Cache-Control header",
// "Custom HTTP header to use when a session is active" => "Custom HTTP header to use when a session is active",
// "Example: no-cache, pre-check=0, post-check=0" => "Example: no-cache, pre-check=0, post-check=0",
// "Cache-Control header (no session)" => "Cache-Control header (no session)",
// "Custom HTTP header to use when no session is active" => "Custom HTTP header to use when no session is active",
// "Content Delivery Network" => "Content Delivery Network",
// "Use an alternate domain name to serve static files from tiki to avoid sending cookies, improve local caching and generally improve user experience performance" => "Use an alternate domain name to serve static files from tiki to avoid sending cookies, improve local caching and generally improve user experience performance",
// "Prefix to include before the static files, for example: http://cdn.example.com" => "Prefix to include before the static files, for example: http://cdn.example.com",
// "Content Delivery Network (in SSL)" => "Content Delivery Network (in SSL)",
// "Use an alternate domain name to serve static files from tiki to avoid sending cookies, improve local caching and generally improve user experience performance. Leave empty to disable CDN in SSL mode" => "Use an alternate domain name to serve static files from tiki to avoid sending cookies, improve local caching and generally improve user experience performance. Leave empty to disable CDN in SSL mode",
// "Prefix to include before the static files, for example: https://cdn.example.com" => "Prefix to include before the static files, for example: https://cdn.example.com",
// "Domain prefix handling" => "Domain prefix handling",
// "Strip or automatically add the \"www.\" prefix on domain names to standardize URLs" => "Strip or automatically add the \"www.\" prefix on domain names to standardize URLs",
// "Leave as-is" => "Leave as-is",
// "Remove the www" => "Remove the www",
// "Add the www" => "Add the www",
// "Domain redirects" => "Domain redirects",
// "When the site is accessed through specific domain names, redirect to an alternate domain preserving the URL. Useful for domain name transitions, like tikiwiki.org to tiki.org" => "When the site is accessed through specific domain names, redirect to an alternate domain preserving the URL. Useful for domain name transitions, like tikiwiki.org to tiki.org",
// "One entry per line. Comma separated list: old, new" => "One entry per line. Comma separated list: old, new",
// "Validate uploaded file content" => "Validate uploaded file content",
// "Do not trust user input and open the files to verify their content" => "Do not trust user input and open the files to verify their content",
// "Allow the tiki_p_trust_input permission" => "Allow the tiki_p_trust_input permission",
// "Bypasses user input filtering" => "Bypasses user input filtering",
// "Note, all permissions are granted to the Admins group including this one, so if you enable this you may expose your site to XSS (Cross Site Scripting) attacks for admin users" => "Note, all permissions are granted to the Admins group including this one, so if you enable this you may expose your site to XSS (Cross Site Scripting) attacks for admin users",
"Synchronize Remote Tracker" => "Sincroniza el Formulario-bd Remoto",
// "Allows to clone a tracker on a remote host and synchronize the data locally on demand" => "Allows to clone a tracker on a remote host and synchronize the data locally on demand",
// "Refresh item link items when master is modified" => "Refresh item link items when master is modified",
// "To be used when item link is used in trackers so that the index remains in good shape when data on the master that is indexed with the detail is modified and used to search on" => "To be used when item link is used in trackers so that the index remains in good shape when data on the master that is indexed with the detail is modified and used to search on",
// "Unified Search Engine" => "Unified Search Engine",
// "Search engine used to index the content of your Tiki. Some engines are more suitable for larger sites, but require additional software on the server" => "Search engine used to index the content of your Tiki. Some engines are more suitable for larger sites, but require additional software on the server",
// "Lucene (PHP Implementation)" => "Lucene (PHP Implementation)",
// "Lucene Index Location" => "Lucene Index Location",
// "Path to the location of the Lucene search index. The index must be on a local filesystem with enough space to contain the volume of the database" => "Path to the location of the Lucene search index. The index must be on a local filesystem with enough space to contain the volume of the database",
// "Highlight results snippets" => "Highlight results snippets",
// "Highlight the result snippet based on the search query. Enabling this option will impact performance, but improve user experience" => "Highlight the result snippet based on the search query. Enabling this option will impact performance, but improve user experience",
// "Lucene Maximum Results" => "Lucene Maximum Results",
// "Maximum amount of results to expose. Results further than these will need a more refined query to be reached" => "Maximum amount of results to expose. Results further than these will need a more refined query to be reached",
// "Lucene Maximum Result Set Limit" => "Lucene Maximum Result Set Limit",
// "Maximum size of result set to consider. Default 1000, 0 = unlimited" => "Maximum size of result set to consider. Default 1000, 0 = unlimited",
// "This is used when calculating result scores and sort order which can lead to out of memory errors on large data sets. The default of 1000 is safe with the PHP memory_limit set to 128M" => "This is used when calculating result scores and sort order which can lead to out of memory errors on large data sets. The default of 1000 is safe with the PHP memory_limit set to 128M",
// "Lucene Terms Per Query Limit" => "Lucene Terms Per Query Limit",
// "Maximum number of terms to be generated. Try increasing this value if you get errors saying \"Terms per query limit is reached\" espescially with wildcard, range and fuzzy searches" => "Maximum number of terms to be generated. Try increasing this value if you get errors saying \"Terms per query limit is reached\" espescially with wildcard, range and fuzzy searches",
// "Lucene Max Buffered Documents" => "Lucene Max Buffered Documents",
// "Number of documents required before the buffered in-memory documents are written into a new segment" => "Number of documents required before the buffered in-memory documents are written into a new segment",
// "Lucene Max Merge Documents" => "Lucene Max Merge Documents",
// "Largest number of documents ever merged by addDocument(). Small values (e.g., less than 10,000) are best for interactive indexing, as this limits the length of pauses while indexing to a few seconds. Larger values are best for batched indexing and speedier searches" => "Largest number of documents ever merged by addDocument(). Small values (e.g., less than 10,000) are best for interactive indexing, as this limits the length of pauses while indexing to a few seconds. Larger values are best for batched indexing and speedier searches",
// "Small values (e.g., less than 10,000) are best for interactive indexing. Use 0 for the Lucene default, which is practically infinite" => "Small values (e.g., less than 10,000) are best for interactive indexing. Use 0 for the Lucene default, which is practically infinite",
// "Lucene Default Boolean Operator" => "Lucene Default Boolean Operator",
// "Use OR (default) or AND as the default search operator" => "Use OR (default) or AND as the default search operator",
// "OR" => "OR",
// "AND" => "AND",
// "Lucene Merge Factor" => "Lucene Merge Factor",
// "How often segment indices are merged by addDocument(). With smaller values, less RAM is used while indexing, and searches on unoptimized indices are faster, but indexing speed is slower. With larger values, more RAM is used during indexing, and while searches on unoptimized indices are slower, indexing is faster. Thus larger values (> 10) are best for batch index creation, and smaller values (< 10) for indices that are interactively maintained" => "How often segment indices are merged by addDocument(). With smaller values, less RAM is used while indexing, and searches on unoptimized indices are faster, but indexing speed is slower. With larger values, more RAM is used during indexing, and while searches on unoptimized indices are slower, indexing is faster. Thus larger values (> 10) are best for batch index creation, and smaller values (< 10) for indices that are interactively maintained",
// "Large values (> 10) are best for batch index creation, and smaller values (< 10) for indices that are interactively maintained" => "Large values (> 10) are best for batch index creation, and smaller values (< 10) for indices that are interactively maintained",
// "Incremental Index Update" => "Incremental Index Update",
// "Update the index incrementally as the site content is modified. This may lead to lower performance and accuracy than processing the index on a periodic basis" => "Update the index incrementally as the site content is modified. This may lead to lower performance and accuracy than processing the index on a periodic basis",
// "Field Weights" => "Field Weights",
// "Allows to set the field weights that apply when ranking the pages for search listing. The weight only applies when the field is in the query. To nullify the value of a field, use an insignificant amount, not 0, which may lead to unexpected behaviors, such as stripping results" => "Allows to set the field weights that apply when ranking the pages for search listing. The weight only applies when the field is in the query. To nullify the value of a field, use an insignificant amount, not 0, which may lead to unexpected behaviors, such as stripping results",
// "One field per line, field_name__:__5.3" => "One field per line, field_name__:__5.3",
// "Default content fields" => "Default content fields",
// "All of the content is aggregated in the contents field. For custom weighting to apply, the fields must be included in the query. This option allows to include other fields in the default content search" => "All of the content is aggregated in the contents field. For custom weighting to apply, the fields must be included in the query. This option allows to include other fields in the default content search",
// "Tokenize version numbers" => "Tokenize version numbers",
// "Tokenize version number strings so that major versions are found when sub-versions are mentionned. For example, searching for 2.7 would return documents containing 2.7.4, but not 1.2.7" => "Tokenize version number strings so that major versions are found when sub-versions are mentionned. For example, searching for 2.7 would return documents containing 2.7.4, but not 1.2.7",
// "Cache per user and query" => "Cache per user and query",
// "Time in minutes a user has a same query cached " => "Time in minutes a user has a same query cached ",
// "In minutes" => "In minutes",
// "Index forum replies together with root post" => "Index forum replies together with root post",
// "If enabled, forum replies will be indexed together with the root post as a single document instead of being separately indexed" => "If enabled, forum replies will be indexed together with the root post as a single document instead of being separately indexed",
// "Search formatters to cache" => "Search formatters to cache",
// "Search formatters to cache the output of" => "Search formatters to cache the output of",
// "Format to use for tracker field keys" => "Format to use for tracker field keys",
// "Choose between field ids and permanent names for the tracker indexing" => "Choose between field ids and permanent names for the tracker indexing",
// "Permanent Name" => "Permanent Name",
// "Field ID (Backward compatibility mode with Tiki 7 and 8)" => "Field ID (Backward compatibility mode with Tiki 7 and 8)",
// "Excluded categories" => "Excluded categories",
// "List of category ids to exclude from the search index" => "List of category ids to exclude from the search index",
// "unsuccessful login attempts" => "unsuccessful login attempts",
// "After a certain number of consecutive unsuccessfull login attempts, the user will receive a mail with instruction to validate his account. However the user can still log-in with his old password" => "After a certain number of consecutive unsuccessfull login attempts, the user will receive a mail with instruction to validate his account. However the user can still log-in with his old password",
// "Suspend account after" => "Suspend account after",
// "After a certain number of consecutive unsuccessfull login attempts, the account is suspended . An admin must revalidate the account before the user can use it again" => "After a certain number of consecutive unsuccessfull login attempts, the account is suspended . An admin must revalidate the account before the user can use it again",
// "URL a user is redirected to after account validation" => "URL a user is redirected to after account validation",
"Account validated successfully." => "Cuenta validada exitosamente.",
// "URL an anonymous is redirected when page not found" => "URL an anonymous is redirected when page not found",
// "Close site when server load is above the threshold  (except for those with permission)" => "Close site when server load is above the threshold  (except for those with permission)",
"Use proxy" => "Usar proxy",
// "Use context menus for actions (icons)" => "Use context menus for actions (icons)",
// "Use context menus for actions (text)" => "Use context menus for actions (text)",
// "Show user's real name instead of login (when possible)" => "Show user's real name instead of login (when possible)",
"Display UserTracker information on the user information page" => "Muestra la información del Formulario-bd del usuario en la página de información del usuario",
// "Input the user tracker ID then field IDs to be shown, all separated by commas. Example: 1,1,2,3,4 (user tracker ID 1 followed by field IDs 1-4)" => "Input the user tracker ID then field IDs to be shown, all separated by commas. Example: 1,1,2,3,4 (user tracker ID 1 followed by field IDs 1-4)",
// "Users can configure modules" => "Users can configure modules",
// "Users can shade modules" => "Users can shade modules",
// "Allows users to hide/show modules" => "Allows users to hide/show modules",
// "Module decides" => "Module decides",
// "Store full-size copy of avatar in file gallery" => "Store full-size copy of avatar in file gallery",
// "File gallery to store full-size copy of avatar in" => "File gallery to store full-size copy of avatar in",
// "Enter the gallery id here. Please create a dedicated gallery that is admin-only for security, or make sure gallery permissions are set so that only admins can edit" => "Enter the gallery id here. Please create a dedicated gallery that is admin-only for security, or make sure gallery permissions are set so that only admins can edit",
// "File ID of default avatar image" => "File ID of default avatar image",
// "File ID of image to use in file gallery as the avatar if user has no avatar image in file galleries" => "File ID of image to use in file gallery as the avatar if user has no avatar image in file galleries",
// "Display who viewed my stuff on the user information page" => "Display who viewed my stuff on the user information page",
// "You will need to activate tracking of views for various items in the action log for this to work" => "You will need to activate tracking of views for various items in the action log for this to work",
// "Number of days to consider who viewed my stuff" => "Number of days to consider who viewed my stuff",
// "Number of days before current time to consider when showing who viewed my stuff" => "Number of days before current time to consider when showing who viewed my stuff",
// "Show to others who viewed my stuff on the user information page" => "Show to others who viewed my stuff on the user information page",
// "Show to others who viewed my stuff on the user information page. Admins can always see this information" => "Show to others who viewed my stuff on the user information page. Admins can always see this information",
// "Maximum number of users to show in drop down lists" => "Maximum number of users to show in drop down lists",
// "Prevents out of memory and performance issues when user list is very large by using a jQuery autocomplete text input box" => "Prevents out of memory and performance issues when user list is very large by using a jQuery autocomplete text input box",
// "Use pretty trackers for registration form" => "Use pretty trackers for registration form",
// "Registration pretty tracker template" => "Registration pretty tracker template",
// "Use wiki page name or template file with .tpl extension" => "Use wiki page name or template file with .tpl extension",
// "Output the registration results" => "Output the registration results",
// "Use a wiki page as template to output the registration results to" => "Use a wiki page as template to output the registration results to",
// "Output registration pretty tracker template" => "Output registration pretty tracker template",
// "Wiki page only" => "Wiki page only",
// "Page name fieldId" => "Page name fieldId",
// "User trackers field id whose value is used as output page name" => "User trackers field id whose value is used as output page name",
// "User tracker IDs to sync prefs from" => "User tracker IDs to sync prefs from",
// "Enter the IDs separated by commas of trackers to sync user prefs from" => "Enter the IDs separated by commas of trackers to sync user prefs from",
// "Tracker field IDs to sync Real Name pref from" => "Tracker field IDs to sync Real Name pref from",
// "Enter the IDs separated by commas in priority of being chosen, each item can concatenate multiple fields using +, e.g. 2+3,4" => "Enter the IDs separated by commas in priority of being chosen, each item can concatenate multiple fields using +, e.g. 2+3,4",
// "Synchronize long/lat/zoom to location field" => "Synchronize long/lat/zoom to location field",
// "Synchronize user geolocation prefs to main location field" => "Synchronize user geolocation prefs to main location field",
"Synchronize categories of user tracker item to user groups" => "Sincroniza las categorías del ítem del formulario-bd del usuario a grupos de usuarios",
"Will add the user tracker item to the category of the same name as the user groups and vice versa" => "Añadirá el  ítem de formulario-bd del usuario a la categoría con el mismo nombre que los grupos de usuarios y viceversa",
// "Put user in group only if categorized within" => "Put user in group only if categorized within",
// "Change user system language when changing user tracker item language" => "Change user system language when changing user tracker item language",
// "Show user's real name instead of login in autocomplete selector in trackers feature" => "Show user's real name instead of login in autocomplete selector in trackers feature",
// "Use user's real name instead of login in autocomplete selector in trackers feature" => "Use user's real name instead of login in autocomplete selector in trackers feature",
// "Show user's real name instead of login in autocomplete selector in messaging feature" => "Show user's real name instead of login in autocomplete selector in messaging feature",
// "Use user's real name instead of login in autocomplete selector in messaging feature" => "Use user's real name instead of login in autocomplete selector in messaging feature",
// "User Favorites" => "User Favorites",
// "Allows for users to flag content as their favorite" => "Allows for users to flag content as their favorite",
// "Users must choose a group at registration" => "Users must choose a group at registration",
// "Users cannot register without choosing one of the groups defined above" => "Users cannot register without choosing one of the groups defined above",
"Score ascending" => "Puntuación ascendente",
"Score descending" => "Puntuación descendente",
"Name ascending" => "Nombre ascendente",
"Name descending" => "Nombre descendente",
"Login ascending" => "Login ascendente",
"Login descending" => "Login descendente",
// "Quota (MB)" => "Quota (MB)",
"Private" => "Privado",
// "Users can see each other's files" => "Users can see each other's files",
// "Username pattern" => "Username pattern",
// "Serve avatar images statically" => "Serve avatar images statically",
// "When enabled, feature checks and permission checks will be skipped" => "When enabled, feature checks and permission checks will be skipped",
"Displayed time zone" => "Zona horaria a mostrar",
// "Always the site default time zone" => "Always the site default time zone",
// "Use time zone set from user preferences, or the automatically detected time zone for anonymous (if browser allows). Site default is used as fallback" => "Use time zone set from user preferences, or the automatically detected time zone for anonymous (if browser allows). Site default is used as fallback",
"Number of visited pages to remember" => "Cantidad de páginas visitadas a recordar",
"User information" => "Información de usuario",
"Public" => "Público",
"Use double-click to edit pages" => "Usar doble-clic para editar páginas",
// "Use 12-hour clock for time selectors" => "Use 12-hour clock for time selectors",
// "Use the 12-hour clock (with AM and PM) for time selectors used in some edit windows to set the time for publishing new or edited blog posts, articles, etc" => "Use the 12-hour clock (with AM and PM) for time selectors used in some edit windows to set the time for publishing new or edited blog posts, articles, etc",
// "Use new diff any version interface" => "Use new diff any version interface",
"Tasks per page" => "Tareas por página",
// "20" => "20",
// "30" => "30",
// "40" => "40",
// "50" => "50",
"Messages per page" => "Mensajes por página",
"Allow messages from other users" => "Permitir mensajes de otros usuarios",
// "Notify sender when reading mail" => "Notify sender when reading mail",
"Send me an email for messages with priority equal or greater than" => "Envíeme un correo por mensajes con prioridad mayor o igual a",
// "Auto-archive read messages after" => "Auto-archive read messages after",
// "60" => "60",
"My pages" => "Mis páginas",
"My blogs" => "Mis blogs",
"My galleries" => "Mis galerías",
"My messages" => "Mis mensajes",
"My tasks" => "Mis tareas",
"My forum topics" => "Mis temas de foros",
"My forum replies" => "Mis respuestas en foros",
"My items" => "Mis items",
// "Character set for mail" => "Character set for mail",
"Show user's info on mouseover" => "Mostrar info de usuario on mouseover",
// "Validator emails (separated by comma) if different than the sender email" => "Validator emails (separated by comma) if different than the sender email",
// "Display by default" => "Display by default",
// "Path (if stored in directory)" => "Path (if stored in directory)",
"Edit idle timeout" => "Tiempo límite de espera de edición",
// "15" => "15",
// "Log errors to Tiki log" => "Log errors to Tiki log",
// "Errors will be logged to the Tiki log" => "Errors will be logged to the Tiki log",
"Tracker ID of Channel tracker" => "ID del Formulario-bd del formulario-bd Canal",
// "There must be a tracker to store info of each channel you create" => "There must be a tracker to store info of each channel you create",
// "Field ID of BrandId" => "Field ID of BrandId",
// "The Channel tracker must have a text field for the Watershed BrandId" => "The Channel tracker must have a text field for the Watershed BrandId",
// "Field ID of ChannelCode" => "Field ID of ChannelCode",
// "The Channel tracker must have a text field for the Watershed ChannelCode" => "The Channel tracker must have a text field for the Watershed ChannelCode",
"Tracker ID of Archive tracker" => "ID del Formulario-bd del of formulario-bd archivo",
// "There must be a tracker to store Archive info" => "There must be a tracker to store Archive info",
// "Field ID of videoId" => "Field ID of videoId",
// "The Archive tracker must have a text field for the videoId of each archive" => "The Archive tracker must have a text field for the videoId of each archive",
// "Field ID of BrandId for Archive" => "Field ID of BrandId for Archive",
// "The Archive tracker must have a text field for the BrandId of each archive" => "The Archive tracker must have a text field for the BrandId of each archive",
// "Field ID of ChannelCode for Archive" => "Field ID of ChannelCode for Archive",
// "The Archive tracker must have a text field for the ChannelCode of each archive" => "The Archive tracker must have a text field for the ChannelCode of each archive",
// "Field ID of rtmpURL for Archive (url field type)" => "Field ID of rtmpURL for Archive (url field type)",
// "The Archive tracker must have a url field for storing the RTMP URL to access the archive" => "The Archive tracker must have a url field for storing the RTMP URL to access the archive",
// "Field ID of flvURL for Archive (url field type)" => "Field ID of flvURL for Archive (url field type)",
// "The Archive tracker must have a url field for storing the FLV URL to access the archive" => "The Archive tracker must have a url field for storing the FLV URL to access the archive",
// "Field ID of Date string for Archive" => "Field ID of Date string for Archive",
// "The Archive tracker can have a text field for storing the time the recording completed" => "The Archive tracker can have a text field for storing the time the recording completed",
// "Field ID of Duration for Archive" => "Field ID of Duration for Archive",
// "The Archive tracker can have a text field for storing the duration of the recording" => "The Archive tracker can have a text field for storing the duration of the recording",
// "Field ID of Filesize for Archive" => "Field ID of Filesize for Archive",
// "The Archive tracker can have a text field for storing the filesize of the recording" => "The Archive tracker can have a text field for storing the filesize of the recording",
// "Field ID of Title for Archive" => "Field ID of Title for Archive",
// "The Archive tracker could have a text field for storing the title of the recording" => "The Archive tracker could have a text field for storing the title of the recording",
// "Field ID of Description for Archive (textarea field type)" => "Field ID of Description for Archive (textarea field type)",
// "The Archive tracker could have a textarea field for storing the description of the recording" => "The Archive tracker could have a textarea field for storing the description of the recording",
// "Field ID of Tags for Archive (freetags field type)" => "Field ID of Tags for Archive (freetags field type)",
// "The Archive tracker could have a freetags field for storing the tags of the recording" => "The Archive tracker could have a freetags field for storing the tags of the recording",
// "Flash Media Encoder shared secret" => "Flash Media Encoder shared secret",
// "Shared key for authenticating Flash Media Encoder" => "Shared key for authenticating Flash Media Encoder",
"Allow viewing HTML mails?" => "¿Permitir ver correos HTML?",
"Maximum size for each attachment" => "Tamaño máximo de archivos adjuntos",
// "500Kb" => "500Kb",
// "1Mb" => "1Mb",
// "1.5Mb" => "1.5Mb",
// "2Mb" => "2Mb",
// "2.5Mb" => "2.5Mb",
// "3Mb" => "3Mb",
"Unlimited" => "Ilimitado",
// "Include a flag by each e-mail to quickly flag/un-flag them" => "Include a flag by each e-mail to quickly flag/un-flag them",
"LastModif" => "Última modificación",
"Last editor" => "Último editor",
// "Wiki link format" => "Wiki link format",
// "What level of special characters are accepted as wiki links for page names. Ex.: ((Page &eacute;&agrave;&icirc;))" => "What level of special characters are accepted as wiki links for page names. Ex.: ((Page &eacute;&agrave;&icirc;))",
// "Strict will only be basic characters like a-z and 0-9. If you have accented or special characters in page names, you should not use strict" => "Strict will only be basic characters like a-z and 0-9. If you have accented or special characters in page names, you should not use strict",
"Complete" => "Completo",
// "Relaxed" => "Relaxed",
// "Strict" => "Strict",
// "Display page version" => "Display page version",
// "Display the page version information when viewing the page" => "Display the page version information when viewing the page",
// "Display page name above page" => "Display page name above page",
// "Display page name above page instead of inside page" => "Display page name above page instead of inside page",
// "Page name display stripper" => "Page name display stripper",
// "Character to use as a delimiter in the page name. The portion of the name after this character will not be displayed" => "Character to use as a delimiter in the page name. The portion of the name after this character will not be displayed",
// "Wiki author list style" => "Wiki author list style",
// "Changes the list format used to display the authors of the page" => "Changes the list format used to display the authors of the page",
// "Creator & Author" => "Creator & Author",
"Business style" => "Estilo de negocios",
"Collaborative style" => "Estilo colaborativo",
"Page last modified on" => "Página última modificacion en",
// "none (disabled)" => "none (disabled)",
// "Specify wiki author list style per page" => "Specify wiki author list style per page",
// "Allows to modify the style in which the author list is displayed on a per-page basis" => "Allows to modify the style in which the author list is displayed on a per-page basis",
// "Wiki action bar location" => "Wiki action bar location",
// "Buttons: Save, Preview, Cancel, .." => "Buttons: Save, Preview, Cancel, ..",
// "Both" => "Both",
// "Wiki navigation bar location" => "Wiki navigation bar location",
// "When using the ...page... page break wiki syntax" => "When using the ...page... page break wiki syntax",
// "Wiki top line location" => "Wiki top line location",
"Cache wiki pages (global)" => "Cachear páginas wiki (global)",
// "Enable page cache globally for wiki pages" => "Enable page cache globally for wiki pages",
"no cache" => "no cachear",
"minute" => "minuto",
// "Allow comments per wiki page" => "Allow comments per wiki page",
// "Enable control for comments on wiki pages individually" => "Enable control for comments on wiki pages individually",
// "Enable (default On)" => "Enable (default On)",
// "Enable (default Off)" => "Enable (default Off)",
// "Enable edit plugin icons" => "Enable edit plugin icons",
// "Permits editing of a plugin, via a popup form, without needing to edit the whole page" => "Permits editing of a plugin, via a popup form, without needing to edit the whole page",
// "Requires JavaScript" => "Requires JavaScript",
// "Prevent special characters in page names" => "Prevent special characters in page names",
// "Some characters may prevent the pages from being easily accessible from the URL or through wiki links. This option prevents from creating pages with such characters" => "Some characters may prevent the pages from being easily accessible from the URL or through wiki links. This option prevents from creating pages with such characters",
// "Page ranking reload probability" => "Page ranking reload probability",
// "Calculation of page rankings is an expensive task that cannot be performed at every page load. It will be calculated at random page loads based on a dice roll. This option indicates the amount of faces on the dice. Larger numbers lead to less load, but less accurate ranking" => "Calculation of page rankings is an expensive task that cannot be performed at every page load. It will be calculated at random page loads based on a dice roll. This option indicates the amount of faces on the dice. Larger numbers lead to less load, but less accurate ranking",
// "Encourage contribution to wiki pages by anonymous" => "Encourage contribution to wiki pages by anonymous",
// "When a page is not editable and the user is anonymous, display the edit links anyway. The visitor will be prompted with a login screen and be encouraged to register" => "When a page is not editable and the user is anonymous, display the edit links anyway. The visitor will be prompted with a login screen and be encouraged to register",
// "Warn before page lock timeout" => "Warn before page lock timeout",
// "Provide a JavaScript alert before the user's lock on a page times out" => "Provide a JavaScript alert before the user's lock on a page times out",
"Dynamic variables" => "Variables dinámicas",
// "Global snippets of text that can be included in wiki pages and edited in place" => "Global snippets of text that can be included in wiki pages and edited in place",
// "Single (%varname%)" => "Single (%varname%)",
// "Double (%%varname%%)" => "Double (%%varname%%)",
// "Multilingual dynamic variables" => "Multilingual dynamic variables",
// "Make dynamic variable content language specific" => "Make dynamic variable content language specific",
// "Edit section" => "Edit section",
// "Edit section level" => "Edit section level",
// "Toggle display of section and plugin edit icons" => "Toggle display of section and plugin edit icons",
// "Allow minor edits" => "Allow minor edits",
// "Add a slideshow button on wiki pages" => "Add a slideshow button on wiki pages",
"Page creators are admin of their pages" => "Creadores de páginas son administradores para sus páginas",
"Create watch for author on page creation" => "Subscribir al autor en el momento de crear la página",
"Enable watches on comments" => "Activar watches en comentarios",
"Enable watch events when I am the editor" => "Activar eventos de watch cuando soy el editor",
// "Watch minor edits" => "Watch minor edits",
// "Page ID" => "Page ID",
// "Name length" => "Name length",
"Last modified by" => "Ultima modificación por",
// "Edit comments" => "Edit comments",
// "Edit Comment length" => "Edit Comment length",
"Versions" => "Versiones",
"Categories" => "Categorías",
// "Categories path" => "Categories path",
"Default sort order" => "Orden por defecto",
// "Sort Direction" => "Sort Direction",
"Descending" => "Descendente",
"Ascending" => "Ascendente",
"Enable wiki 3D browser" => "Activar navegador wiki 3D",
// "Load page on navigation" => "Load page on navigation",
// "Forum for discussion" => "Forum for discussion",
// "Allow to manage keywords on a per-page basis" => "Allow to manage keywords on a per-page basis",
// "Similar pages only listed in same language" => "Similar pages only listed in same language",
// "When listing similar pages, such as in missing page 404, only display pages in the same language as the request" => "When listing similar pages, such as in missing page 404, only display pages in the same language as the request",
// "Mandatory edit summary on wiki pages" => "Mandatory edit summary on wiki pages",
// "Reject save attempts not providing an edit summary to describe the changes made" => "Reject save attempts not providing an edit summary to describe the changes made",
// "Choose position of freetags selection" => "Choose position of freetags selection",
// "If you wish to place freetags selection more prominently than in the properties tab" => "If you wish to place freetags selection more prominently than in the properties tab",
// "Properties tab" => "Properties tab",
// "Edit tab" => "Edit tab",
// "Freetags tab" => "Freetags tab",
// "Structure navigation bar location" => "Structure navigation bar location",
// "Displays Next/Back buttons, breadcrumbs, and form to add a new page" => "Displays Next/Back buttons, breadcrumbs, and form to add a new page",
// "Maximum length (characters) to display/truncate for backlink page names. Use \"0\" for no truncation" => "Maximum length (characters) to display/truncate for backlink page names. Use \"0\" for no truncation",
// "Simple wiki ratings" => "Simple wiki ratings",
// "Enable users to rate articles based on a simple numeric scale" => "Enable users to rate articles based on a simple numeric scale",
// "Wiki rating options" => "Wiki rating options",
// "List of options available for the rating of wiki pages" => "List of options available for the rating of wiki pages",
// "Semantic link types to use as page alias markers" => "Semantic link types to use as page alias markers",
// "Comma separated list of semantic links to use to identify a page as an alias to another" => "Comma separated list of semantic links to use to identify a page as an alias to another",
// "Redirect pages using these prefix alias semantic links" => "Redirect pages using these prefix alias semantic links",
// "Comma separated list of prefixes of which pages will be redirected to page with semantic link" => "Comma separated list of prefixes of which pages will be redirected to page with semantic link",
// "Plugin %0" => "Plugin %0",
// "Global cache time for the plugin snarf in seconds" => "Global cache time for the plugin snarf in seconds",
// "Default cache time for the plugin snarf" => "Default cache time for the plugin snarf",
// "0 for no cache" => "0 for no cache",
// "Inline plugin %0" => "Inline plugin %0",
// "Plugin pending approval notification" => "Plugin pending approval notification",
// "Alert by e-mail users with permission to approve plugin when a plugin is pending approval" => "Alert by e-mail users with permission to approve plugin when a plugin is pending approval",
// "Wysiwyg Editor is optional" => "Wysiwyg Editor is optional",
// "Wysiwyg Editor is displayed by default" => "Wysiwyg Editor is displayed by default",
// "Reopen with the same editor" => "Reopen with the same editor",
// "Content is parsed like wiki page" => "Content is parsed like wiki page",
// "This allows a mixture of wiki and HTML. All wiki syntax is parsed" => "This allows a mixture of wiki and HTML. All wiki syntax is parsed",
// "Content is partially wiki parsed" => "Content is partially wiki parsed",
// "This also allows a mixture of wiki and HTML. Only some wiki syntax is parsed, such as plugins (not inline character styles etc)" => "This also allows a mixture of wiki and HTML. Only some wiki syntax is parsed, such as plugins (not inline character styles etc)",
// "Neglected. This feature can have unpredicable results and may be removed in future versions" => "Neglected. This feature can have unpredicable results and may be removed in future versions",
// "Wysiwyg editor skin" => "Wysiwyg editor skin",
// "Kama (Default)" => "Kama (Default)",
// "Office 2003" => "Office 2003",
// "V2 (FCKEditor appearance)" => "V2 (FCKEditor appearance)",
// "Use Wiki syntax in WYSIWYG" => "Use Wiki syntax in WYSIWYG",
// "Experimental, new : Allow to keep the wiki syntax with the WYSIWYG editor. WARNING: plugin edit is not working in that case in WYSIWYG mode, use the Source mode instead " => "Experimental, new : Allow to keep the wiki syntax with the WYSIWYG editor. WARNING: plugin edit is not working in that case in WYSIWYG mode, use the Source mode instead ",
// "Font names" => "Font names",
// "List of font names separated by" => "List of font names separated by",
// "SMTP Server" => "SMTP Server",
"Username" => "Usuario",
"Security" => "Securidad",
// "SSL" => "SSL",
// "TLS" => "TLS",
// "Mail Sender" => "Mail Sender",
// "Sendmail" => "Sendmail",
// "SMTP" => "SMTP",
// "Authentication" => "Authentication",
// "Mail server authentication" => "Mail server authentication",
// "LOGIN" => "LOGIN",
// "PLAIN" => "PLAIN",
// "CRAM-MD5" => "CRAM-MD5",
// "Zotero Bibliography" => "Zotero Bibliography",
// "Connect Tiki to the Zotero online bibliography management system" => "Connect Tiki to the Zotero online bibliography management system",
// "Zotero Client Key" => "Zotero Client Key",
// "Required identification key. Registration required" => "Required identification key. Registration required",
// "Zotero Client Secret" => "Zotero Client Secret",
// "Zotero Group ID" => "Zotero Group ID",
// "Numeric ID of the group, can be found in the URL" => "Numeric ID of the group, can be found in the URL",
// "Zotero Reference Style" => "Zotero Reference Style",
// "Use an alternate Zotero reference style when formatting the references. The reference formats must be installed on the Zotero server" => "Use an alternate Zotero reference style when formatting the references. The reference formats must be installed on the Zotero server",
// "Unmatched system requirement. Missing php extension among %0" => "Unmatched system requirement. Missing php extension among %0",
// "Unmatched system requirement. The database you are using does not support this feature" => "Unmatched system requirement. The database you are using does not support this feature",
// "Missing default for preference \"%0\"" => "Missing default for preference \"%0\"",
// "Configuration forced by host" => "Configuration forced by host",
// "Disabled by host" => "Disabled by host",
"Actions" => "Acciones",
"Admin" => "Admin",
"Permissions" => "Permisos",
"View" => "Ver",
"Module" => "Módulo",
// "Plugin" => "Plugin",
// "Like" => "Like",
// "Fix me" => "Fix me",
"Unavailable" => "No disponibles",
// "Don't like" => "Don't like",
// "Don't fix me" => "Don't fix me",
// "What's this for" => "What's this for",
// "Nothing was changed, please check profile for errors" => "Nothing was changed, please check profile for errors",
// "An error occurred: " => "An error occurred: ",
// "Applying profile" => "Applying profile",
// "Preference set" => "Preference set",
// "Added (or modified)" => "Added (or modified)",
// "Group changed (or modified)" => "Group changed (or modified)",
// "Modified permission %s for %s" => "Modified permission %s for %s",
// "Modified permission %s on %s/%s for %s" => "Modified permission %s on %s/%s for %s",
// "User %0 was added to %1" => "User %0 was added to %1",
"Created by profile installer" => "Creado por el instalador de perfiles",
"Page updated by profile installer" => "Página actualizada por el instalador de perfiles",
// "File gallery does not exist" => "File gallery does not exist",
// "File gallery already exists" => "File gallery already exists",
// "Calendar does not exist" => "Calendar does not exist",
// "Calendar already exists" => "Calendar already exists",
"Page cannot be found" => "La página no pudo ser encontrada",
// "Syntax error: " => "Syntax error: ",
// "Circular reference" => "Circular reference",
// "No name" => "No name",
// "Bad object" => "Bad object",
// "Permissions' object must have a field 'type' and 'id'" => "Permissions' object must have a field 'type' and 'id'",
// "Needs a 'type' and 'data' field" => "Needs a 'type' and 'data' field",
"Wiki top pages" => "Wiki páginas top",
"Most relevant pages" => "Páginas más relevantes",
"Relevance" => "Relevancia",
"Wiki last pages" => "Wiki últimas páginas",
"Forums last posts" => "Últimos mensajes en foros",
"Topic date" => "Fecha del tema",
"Forums most read topics" => "Foros temas más leídos",
"Forums best topics" => "Foros mejores temas",
"Forums most visited forums" => "Foros más visitados",
"Forums with most posts" => "Foros con más mensajes",
"Wiki top galleries" => "Wiki principales galerías",
"Wiki top file galleries" => "Wiki principales galerías de archivos",
"Wiki top images" => "Wiki principales imágenes",
"Wiki top files" => "Wiki principales archivos",
"Downloads" => "Descargas",
"Wiki last images" => "Wiki últimas imágenes",
"Upload date" => "Fecha de subida",
"Wiki last files" => "Wiki últimos archivos",
"Top Articles" => "Artículos más leídos",
"Most visited blogs" => "Blogs más visitados",
"Most-active Blogs" => "Blogs más activos",
"Blogs last posts" => "Blogs últimos posts",
"Post date" => "Fecha post",
"Wiki top authors" => "Wiki principales autores",
"Pages" => "Páginas",
"Top article authors" => "Artículos principales autores",
// "Expecting three arguments for article-info" => "Expecting three arguments for article-info",
// "Unsupported property. Supported properties are: " => "Unsupported property. Supported properties are: ",
// "Articles feature not enabled" => "Articles feature not enabled",
// "Unexpected values: %0" => "Unexpected values: %0",
// "Object must be provided and contain two arguments: type and object" => "Object must be provided and contain two arguments: type and object",
// "Invalid property" => "Invalid property",
// "Invalid range" => "Invalid range",
// "Invalid revote period" => "Invalid revote period",
// "Expecting \"keep\" to be \"latest\" or \"oldest\"" => "Expecting \"keep\" to be \"latest\" or \"oldest\"",
// "Unknown variables referenced: %0" => "Unknown variables referenced: %0",
// "Username is required" => "Username is required",
"Password is required" => "Contraseña es requerida",
"User already exists" => "El usuario ya existe",
"Registered" => "Registrado",
"Invalid username" => "Nombre de usuario no válido",
"Username is too long" => "El nombre del usuario es demasiado largo",
// "Username cannot contain uppercase letters" => "Username cannot contain uppercase letters",
"Wrong passcode. You need to know the passcode to register at this site" => "Código de registro no válido, necesita un código de registro válido",
// "You must choose a group" => "You must choose a group",
// "Email not valid. Should be in the format \"mailbox@example.com\"" => "Email not valid. Should be in the format \"mailbox@example.com\"",
"The passwords don't match" => "Las contraseñas no coinciden",
// "Username must be at least %0 characters long" => "Username must be at least %0 characters long",
// "Username cannot contain more than %0 characters" => "Username cannot contain more than %0 characters",
// "This invitation does not exist or is deprecated or wrong email" => "This invitation does not exist or is deprecated or wrong email",
// "The fields title and description are mandatory to generate a feed" => "The fields title and description are mandatory to generate a feed",
// "To fix this error go to Admin -> Feeds" => "To fix this error go to Admin -> Feeds",
// "Please contact the site administrator and ask him to fix this error" => "Please contact the site administrator and ask him to fix this error",
// "If you set feed author email or URL, you must set feed author name" => "If you set feed author email or URL, you must set feed author name",
// "Feed logo" => "Feed logo",
// "Unspecified" => "Unspecified",
"Log In" => "Conéctate",
"See other users' profiles" => "Ver perfil de otro usuario",
"Have your profile seen" => "Tiene su perfil visto",
"Make friends" => "Hacer amigos",
"Receive message" => "Recibir mensaje",
"Send message" => "Enviar mensaje",
"Read an article" => "Leer un artículo",
"Publish an article" => "Publicar un artículo",
"Have your article read" => "Tiene su artículo leído",
// "Create New File Gallery" => "Create New File Gallery",
"Upload new file to gallery" => "Subir nuevo archivo a la galería",
"Download other user's file" => "Bajar otros archivos del usuario",
"Have your file downloaded" => "Tenga su archivo bajado",
"Create a new image gallery" => "Crear nueva galería de imágenes",
"Upload new image to gallery" => "Subir nueva imagen a la galería",
"See other users' galleries" => "Ver la galería de otro usuario",
"See other users' images" => "Ver la imagen de otro usuario",
"Have your gallery seen by other users" => "Tenga su imagen vista por otro usuario",
"Have your image seen" => "Tenga su imagen vista",
"Create new blog" => "Crear nuevo blog",
"Post in a blog" => "Postear en un blog",
"Read other users' blogs" => "Leer el blog de otro usuario",
"Have your blog read" => "Tenga su blog leído",
"Create a new wiki page" => "Crear nueva página wiki",
"Edit an existing page" => "Editar una página existente",
"Attach file" => "Adjuntar archivo",
// "try rebuilding or optimizing the index on the search admin page" => "try rebuilding or optimizing the index on the search admin page",
// "Search index could not be updated: %0" => "Search index could not be updated: %0",
"Wiki Comment" => "Comentario Wiki",
"Calendar item" => "Elemento del calendario",
"Gallery" => "Galería",
"Article" => "Artículo",
"Blog post" => "Publicación de Bitácora - blog",
"Tracker item" => "Ítem de formulario-bd",
// "Search index could not be updated. The site is misconfigured. Contact an administrator" => "Search index could not be updated. The site is misconfigured. Contact an administrator",
"blog post" => "publicación de blog",
"file" => "archivo",
"forum post" => "publicación de foro",
"trackeritem" => "itemdeformulario-bd",
"sheet" => "hoja de cálculo",
"comment" => "comentario",
// " has accessed your temporary shared content" => " has accessed your temporary shared content",
// "has accessed the following shared content" => "has accessed the following shared content",
"Your access to this page has expired" => "Tu acceso a esta página ha caducado",
// "Handling actions of plugin \"%s\" failed" => "Handling actions of plugin \"%s\" failed",
"You must choose an option" => "Has de escoger una opción",
"For you to vote, cookies must be allowed" => "Las Cookies deben estar habilitadas para poder votar",
"This poll is closed" => "Esta encuesta está cerrada",
"Thank you for installing Tiki" => "Gracias por instalar Tiki",
"The entire Tiki Community would like to thank you and help you get introduced to Tiki" => "La comunidad entera de Tiki te querría ayudar a introducirte en Tiki",
"How To Get Started" => "Como ponerse en marcha",
"Tiki has more than 1000 features and settings" => "Tiki tiene más de 1000 funcionalidades y parámetros de configuración",
"This allows you to create both very simple and complex websites" => "Esto te permite crear tanto sitios web muy simples como muy complejos",
"We understand that so many features might seem overwhelming at first. This is why we offer you two different ways to __Get Started__ with Tiki" => "Entendemos que tantas funcionalidades pueden parecer un poco abrumador inicialmente. Por esta razón te ofrecemos dos formas diferentes de __Ponerte en marcha__ con Tiki",
"Manual Setup using Admin Panel" => "Configuración Manual usando el Panel de Administración",
"Get Started using Admin Panel" => "Empieza usando el Panel de Administración",
"Who Should Use This" => "Quien debería esar esto",
"You are familiar with software Admin Panels" => "Estás familiarizado con Paneles de Administración",
"You enjoy exploring and playing with many options" => "Te gusta explorar y jugar con muchas opciones",
"You already know Tiki" => "Ya conoces Tiki",
"Easy Setup using Profiles" => "Configuración Fácil usando Perfiles de Configuración",
"Get Started using Profiles" => "Empieza usando Perfiles de configuración",
"You want to get started quickly" => "Quieres ponerte en marcha de inmediato",
"Featured Profiles" => "Perfiles Destacados",
"__Collaborative Community__ ([%0|apply profile now])" => "__Collaborative Community__ ([%0|aplica el perfil ahora])",
"Setup to help subject experts and enthusiasts work together to build a Knowledge Base" => "Configuración para ayudar a expertos y entusiastas a trabajar juntos para construir una Base de Conocimiento",
"Wiki Editing" => "Edición Wiki",
"Personal Member Spaces" => "Espacios Personales de los Miembros",
"__Personal Blog and Profile__ ([%0|apply profile now])" => "__Personal Blog and Profile__ ([%0|aplica el perfil ahora])",
"Setup with many cool features to help you integrate the Social Web and establish a strong presence in the Blogosphere" => "Configuración con muchas funcionalidades para ayudar a integrarte en la Web Social y establecer una presencia sólida en la Blogosfera",
"Blog (Full set of blog related features)" => "Blog (Conjunto completo de funcionalidades relacionadas con bitácoras - blogs)",
"RSS Integration" => "Integración de RSS",
"Video Log" => "Archivo de Videos",
"__Company Intranet__ ([%0|apply profile now])" => "__Company Intranet__ ([%0|aplica el perfil ahora])",
"Setup for a Corporate Intranet of a typical medium-sized business" => "Configuración para una Intranet Corporativa de una típica empresa de tamaño medio",
"Company News Articles" => "Artículos de Noticias de la Empresa",
"Executive Blog" => "Blog Ejecutivo",
"File Repository & Management" => "Repositorio & Gestión de archivos",
"Collaborative Wiki" => "Wiki Colaborativo",
"__Small Organization Web Presence__ ([%0|apply profile now])" => "__Small Organization Web Presence__ ([%0|aplica el perfil ahora])",
"Setup for a Web Presence of a typical small business or non-profit" => "Configuración para dar presencia web a un típico negocio pequeño o ONG",
"Company News & Updates" => "Noticias y Actualizaciones de la Empresa",
"File Gallery (great for Media Kit)" => "Galería de Archivos (adecuada para un kit multimedia)",
"Contact Form" => "formulario-bd de Contacto",
"Congratulations" => "Felicidades",
"This is the default homepage for your Tiki. If you are seeing this page, your installation was successful" => "Esta es la página de inicio por omisión para tu Tiki. Si estás viendo esta página, tu instalación se ha realizado con éxito.",
"You can change this page after logging in. Please review the [http://doc.tiki.org/wiki+syntax|wiki syntax] for editing details" => "Puedes cambiar esta página después de conectarte. Por favor, revisa la [http://doc.tiki.org/wiki+syntax|sintaxis wiki] para los detalles de edición",
"{img src=img/icons/star.png alt=\\\"Star\\\"} Get started" => "{img src=img/icons/star.png alt=\\\"Star\\\"} Ponte en marcha",
"To begin configuring your site" => "Para empezar a configurar tu sitio",
"1) Log in with your newly created password" => "1) Conéctate con la contraseña nueva que has creado",
"2) Manually Enable specific Tiki features" => "2) Habilita manualmente algunas funcionalidades de Tiki concretas",
"3) Run Tiki Profiles to quickly get up and running" => "3) Ejecuta Perfiles de Configuración de Tiki para ponerte en marcha de forma ágil",
"{img src=img/icons/help.png alt=\\\"Help\\\"} Need help" => "{img src=img/icons/help.png alt=\\\"Help\\\"} Necesitas ayuda",
"For more information" => "Para más información",
"[http://info.tiki.org/Learn+More|Learn more about Tiki]" => "[http://info.tiki.org/Learn+More|Aprende más sobre Tiki]",
"[http://info.tiki.org/Help+Others|Get help], including the [http://doc.tiki.org|official documentation] and [http://tiki.org/forums|support forums]" => "[http://info.tiki.org/Help+Others|Obtén ayuda], incluyendo las [http://doc.tiki.org|documentación oficial] y los [http://tiki.org/forums|foros de ayuda]",
"[http://info.tiki.org/Join+the+community|Join the Tiki community]" => "[http://info.tiki.org/Join+the+community|Súmate a la Comunidad de Tiki]",
"You don't feel like learning the Admin Panel right away" => "No te ves aprendiendo a configurar el Panel de Administración justo ahora",
"You want to quickly test out some of Tiki's Features" => "Quieres probar de forma rápida algunas funcionalidades de Tiki",
"Highlight Company's Products and Services" => "Resaltar los Productos y Servicios de la Compañía",
"new" => "nuevo",
"Saved" => "Guardada",
"Save failed" => "Ha fallado el guardado",
// "Standard Shipping" => "Standard Shipping",
// "3 to 5 working days" => "3 to 5 working days",
// "Express Shipping" => "Express Shipping",
// "Next day delivery" => "Next day delivery",
// "Custom Shipping Example" => "Custom Shipping Example",
// "UPS_CODE_%0" => "UPS_CODE_%0",
// "Problem reading custom shipping provider \"%0\"" => "Problem reading custom shipping provider \"%0\"",
"Click for Help" => "Haz clic para la Ayuda",
// "You are not in group of friends to have the content of this block displayed for you" => "You are not in group of friends to have the content of this block displayed for you",
"<!-- jq smarty plugin inactive: feature_jquery off -->" => "<!-- jq smarty plugin desactivado: feature_jquery off -->",
"No records to display" => "No hay registros que mostrar",
"Fast Next" => "Siguiente Rápido",
"Fast Prev" => "Anterior Rápido",
"Prev" => "Anterior",
"Next" => "Próximo",
// "More results may be available. Refine criteria to access the estimated %0 results" => "More results may be available. Refine criteria to access the estimated %0 results",
"First %0" => "Primeros %0",
"Last %0" => "Últimos %0",
"Next %0" => "Siguientes %0",
"Prev %0" => "Anteriores %0",
"tip" => "consejo",
"warning" => "aviso",
"confirm" => "confirmación",
"note" => "nota",
"errors" => "errores",
"information" => "información",
"Tab View" => "Vista por pestañas",
"No Tabs" => "Sin pestañas",
"Tip" => "Consejo",
"This edit session will expire in" => "Esta sesión de edición caducará en",
"<strong>Preview</strong> (if available) or <strong>Save</strong> your work to restart the edit session timer" => "<strong>Previsualiza</strong> (si está disponible) o <strong>Guarda</strong> tu trabajo para reiniciar el cronómetro de la sesión de edición",
"There is an autosaved draft of your recent edits, to use it instead of what is current displayed" => "Hay un borrador autoguardado de tus ediciones recientes, para usarlo en vez de lo que se muestra actualmente",
"If you want the original version instead of the autosaved draft of your edits" => "Si quieres la versión original en vez de el borrador autoguardado de tus ediciones",
"click here" => "haz click aquí",
"AutoSave" => "AutoGuardado",
// "<strong>Thank you for trying the new ckeditor implementation for Tiki 6</strong><br /><br />" => "<strong>Thank you for trying the new ckeditor implementation for Tiki 6</strong><br /><br />",
// "Some of the settings at this site should be set differently for this to work best. Please ask the administrator to try this" => "Some of the settings at this site should be set differently for this to work best. Please ask the administrator to try this",
// "Ckeditor Development Notice" => "Ckeditor Development Notice",
"Your edit session has expired" => "Tu sesión de edición ha caducado",
"Your edit session will expire in" => "Tu sesión de edición caducará en",
"You must PREVIEW or SAVE your work now, to avoid losing your edits" => "Has de PREVISUALIZAR o GUARDAR tu trabajo ahora, para evitar perder tus cambios",
"You are about to leave this page. Changes since your last save will be lost. Are you sure you want to exit this page" => "Estás a punto de dejar esta página. Los cambios desde tu último guardado se perderán. ¿Seguro que quieres dejar esta página",
// "Some of your preferences should be set differently for this to work at it's best. Please click this to apply the recommended profile" => "Some of your preferences should be set differently for this to work at it's best. Please click this to apply the recommended profile",
"Help page" => "Página de ayuda",
// "View or edit tpl" => "View or edit tpl",
"Edit Template" => "Editar plantilla",
"View tpl" => "Ver tpl",
// "View Template" => "View Template",
// "Admin page" => "Admin page",
"Admin Feature" => "Administrar Característica",
// "Plugin name not specified" => "Plugin name not specified",
// "Wrong attachments gallery" => "Wrong attachments gallery",
// "You are attempting to display a gallery that is not a valid attachment gallery" => "You are attempting to display a gallery that is not a valid attachment gallery",
// "Error(s)" => "Error(s)",
// "Clear errors" => "Clear errors",
// "Favorite" => "Favorite",
// "Hour" => "Hour",
// "Minute" => "Minute",
// "a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z" => "a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z",
// "Click here to go to Edit Languages" => "Click here to go to Edit Languages",
"The text is" => "El texto es",
"character(s) too long - please edit it." => "caracter(es) demasiado largo - por favor edítelo.",
"Date Selector" => "Selector de Fecha",
// "Month beginning" => "Month beginning",
// "Week beginning" => "Week beginning",
// "Data (change %)" => "Data (change %)",
"No records found." => "No se encontraron registros",
// "No object information provided" => "No object information provided",
// "No title specified" => "No title specified",
// "Relation not found" => "Relation not found",
// "freetags disabled" => "freetags disabled",
// "Currency in payment (%0) does not match the currency for that registry (%1)" => "Currency in payment (%0) does not match the currency for that registry (%1)",
// "This invoice does not exist or is in limited access" => "This invoice does not exist or is in limited access",
// " (found in " => " (found in ",
// "(not found in an admin panel)" => "(not found in an admin panel)",
// "Preference %0 is not defined" => "Preference %0 is not defined",
// "Drag this out of the perspective and resave it" => "Drag this out of the perspective and resave it",
// "No object information provided for rating" => "No object information provided for rating",
// "An error occurred" => "An error occurred",
"Invert Sort" => "Ordenar Invertido",
// "No rows found" => "No rows found",
// "Toggle sections" => "Toggle sections",
// "Show only selected" => "Show only selected",
// "You might want to also set the tiki_p_modify_object_categories permission under the tiki section" => "You might want to also set the tiki_p_modify_object_categories permission under the tiki section",
// "You are already logged in" => "You are already logged in",
// "Request not from this host" => "Request not from this host",
// "One of these groups is required" => "One of these groups is required",
"This field is required" => "Es obligatorio rellenar este campo del formulario",
"Please enter a valid %s.  No spaces, more than %d characters and contain %s" => "Por favor introduce un valor en el campo %s que sea válido. Sin espacios, más de %d caracteres y que contenga %s",
"username" => "usuario",
"password" => "contraseña",
"You have to enable cookies to be able to login to this site" => "Tiene que activar cookies para poder conectarse en este sitio",
"second" => "segundos",
"years" => "años",
"months" => "meses",
"weeks" => "semanas",
"done" => "listo",
"Text cut here" => "Corte del texto aquí",
"Task" => "Tarea",
"Priority" => "Prioridad",
"Start date:" => "Fecha inicial:",
"End date:" => "Fecha final:",
"in %s days, the %s" => "en %s días, el/la %s",
"in %s day, the %s" => "en %s día, el/la %s",
"Friend" => "Amigo/a",
"km" => "km",
"Last seen on" => "Visto por última vez en",
"(idle for %s seconds)" => "(inactivo por %s segundos)",
"User information - Click for more info" => "Información de Usuario - Haz clic para más info",
"More info about %0 (idle for %1)" => "Más información sobre %0 (inactivo durante %1)",
" seconds" => " segundos",
// "Permission denied: the specified wiki page cannot be used as Smarty template resource" => "Permission denied: the specified wiki page cannot be used as Smarty template resource",
// "No WSDL found" => "No WSDL found",
"pvs" => "pvs",
// "Days with the most pageviews" => "Days with the most pageviews",
// "Day with the most pageviews" => "Day with the most pageviews",
// "Days with the least pageviews" => "Days with the least pageviews",
// "Day with the least pageviews" => "Day with the least pageviews",
// "No pageviews yet" => "No pageviews yet",
// "n/a" => "n/a",
"Use this tree to copy the structure" => "Use este árbol para copiar la estructura",
"created from structure" => "crear desde estructura",
"You have to make %d choice(s) for the question" => "Tiene que elegir %d opción/opciones para la pregunta",
"You have to make at least %d choice(s) for the question" => "Tiene que elegir al menos %d opción/opciones para la pregunta",
"You have to make less than %d choice(s) for the question" => "Tiene que elegir menos de %d opción/opciones para la pregunta",
"You have to choose at least %d choice(s) for the question" => "Tiene que elegir al menos %d opción/opciones para la pregunta",
// "Foreground Colors" => "Foreground Colors",
// "Background Colors" => "Background Colors",
"Colors" => "Colores",
// "Border Colors" => "Border Colors",
// "Border Widths" => "Border Widths",
// "Border Styles" => "Border Styles",
// "Border Radii" => "Border Radii",
// "Borders" => "Borders",
// "Font Sizes" => "Font Sizes",
// "Line Heights" => "Line Heights",
"Font" => "Fuente",
// "Font Families" => "Font Families",
// "Typography" => "Typography",
// "Select.." => "Select..",
// "Required features: <b>%0</b>. If you do not have the privileges to activate these features, ask the site administrator" => "Required features: <b>%0</b>. If you do not have the privileges to activate these features, ask the site administrator",
"Sea Surfing (CSRF) detected. Operation blocked." => "Sea Surfing (CSRF) detectado. Operación bloqueada.",
"unknown error" => "error desconocido",
"You are not logged in" => "No estás conectado",
"This script cannot be called directly" => "Este script no puede ser llamado directamente",
"Page '%0' cannot be found" => "Página '%0' no puede ser encontrada",
"You do not have permission to view this section" => "Permiso denegado para acceder a esta sección",
"For the security of your password direct access to the feed is only available via https" => "Para la seguridad de su contraseña el acceso directo al feed está disponible solo a través de https",
"Help link" => "Enlace de ayuda",
"You are banned from" => "Está baneado de",
"wiki" => "wiki",
"img-g" => "img-g",
"file-g" => "file-g",
"faqs" => "faqs",
"quizzes" => "cuestionarios",
"arts" => "arts",
"blogs" => "blogs",
"forums" => "foros",
"The file was uploaded with success" => "El archivo se ha subido con éxito",
"The file you are trying upload was only partially uploaded" => "El fichero que estaba intentando subir fue subido parcialmente",
// "No file was uploaded. Was a file selected " => "No file was uploaded. Was a file selected ",
// "A temporary folder is missing" => "A temporary folder is missing",
// "Unknown error" => "Unknown error",
"Flash player not available" => "Reproductor Flash no disponible",
"%d points" => "%d puntos",
"Removed" => "Eliminado",
"at" => "en",
// "Plugin %0 pending approval" => "Plugin %0 pending approval",
"Unknown language" => "Lenguaje desconocido",
"Click here to confirm your action" => "Haz clic aquí para confirmar tu acción",
// "Bold" => "Bold",
// "img/icons/text_bold.png" => "img/icons/text_bold.png",
// "Italic" => "Italic",
// "img/icons/text_italic.png" => "img/icons/text_italic.png",
// "Underline" => "Underline",
// "img/icons/text_underline.png" => "img/icons/text_underline.png",
// "Strikethrough" => "Strikethrough",
// "img/icons/text_strikethrough.png" => "img/icons/text_strikethrough.png",
// "Non-parsed (Wiki syntax does not apply)" => "Non-parsed (Wiki syntax does not apply)",
// "img/icons/noparse.png" => "img/icons/noparse.png",
// "Align Center" => "Align Center",
// "img/icons/text_align_center.png" => "img/icons/text_align_center.png",
// "Horizontal Bar" => "Horizontal Bar",
// "img/icons/page.png" => "img/icons/page.png",
// "Page Break" => "Page Break",
// "img/icons/page_break.png" => "img/icons/page_break.png",
"Box" => "Caja",
// "img/icons/box.png" => "img/icons/box.png",
// "img/icons/email.png" => "img/icons/email.png",
"Heading" => "Encabezado",
"Title bar" => "Barra de título",
// "img/icons/book.png" => "img/icons/book.png",
// "Unordered List" => "Unordered List",
// "img/icons/text_list_bullets.png" => "img/icons/text_list_bullets.png",
// "Ordered List" => "Ordered List",
// "img/icons/text_list_numbers.png" => "img/icons/text_list_numbers.png",
// "Special Characters" => "Special Characters",
// "lib/ckeditor_tiki/ckeditor-icons/specialchar.gif" => "lib/ckeditor_tiki/ckeditor-icons/specialchar.gif",
// "img/smiles/icon_smile.gif" => "img/smiles/icon_smile.gif",
// "Foreground color" => "Foreground color",
// "img/icons/palette.png" => "img/icons/palette.png",
// "Background Color" => "Background Color",
// "img/icons/palette_bg.png" => "img/icons/palette_bg.png",
"Wiki Link" => "Enlaces Wiki",
// "img/icons/page_link.png" => "img/icons/page_link.png",
"External Link" => "Enlaces Externos",
// "img/icons/world_link.png" => "img/icons/world_link.png",
// "img/icons/table.png" => "img/icons/table.png",
// "Table Builder" => "Table Builder",
// "img/icons/find.png" => "img/icons/find.png",
"Find Text" => "Encuentra texto",
// "img/icons/text_replace.png" => "img/icons/text_replace.png",
"Text Replace" => "Remplaza texto",
"Full Screen Edit" => "Edición a Pantalla Completa",
"Wiki Help" => "Ayuda Wiki",
// "Wiki Wysiwyg Help" => "Wiki Wysiwyg Help",
// "Wysiwyg Help" => "Wysiwyg Help",
"Choose or upload images" => "Escoge o sube imágenes",
// "img/icons/pictures.png" => "img/icons/pictures.png",
"Choose or upload files" => "Escoge o sube archivos",
// "img/icons/file-manager-add.png" => "img/icons/file-manager-add.png",
"Switch Editor (wiki or WYSIWYG)" => "Cambia el Editor (wiki o WYSIWYG)",
// "img/icons/pencil_go.png" => "img/icons/pencil_go.png",
"Save Sheet" => "Guarda la Hoja",
// "img/icons/disk.png" => "img/icons/disk.png",
// "Add Row After Selection Or To End If No Selection" => "Add Row After Selection Or To End If No Selection",
// "img/icons/sheet_row_add.png" => "img/icons/sheet_row_add.png",
// "Add Multiple Rows After Selection Or To End If No Selection" => "Add Multiple Rows After Selection Or To End If No Selection",
// "img/icons/sheet_row_add_multi.png" => "img/icons/sheet_row_add_multi.png",
// "Add Row Before Selection Or To End If No Selection" => "Add Row Before Selection Or To End If No Selection",
// "Delete Selected Row" => "Delete Selected Row",
// "img/icons/sheet_row_delete.png" => "img/icons/sheet_row_delete.png",
// "Add Column After Selection Or To End If No Selection" => "Add Column After Selection Or To End If No Selection",
// "img/icons/sheet_col_add.png" => "img/icons/sheet_col_add.png",
// "Delete Selected Column" => "Delete Selected Column",
// "img/icons/sheet_col_delete.png" => "img/icons/sheet_col_delete.png",
// "Add Multiple Columns After Selection Or To End If No Selection" => "Add Multiple Columns After Selection Or To End If No Selection",
// "img/icons/sheet_col_add_multi.png" => "img/icons/sheet_col_add_multi.png",
// "Add Column Before Selection Or To End If No Selection" => "Add Column Before Selection Or To End If No Selection",
// "Get Cell Range" => "Get Cell Range",
// "img/icons/sheet_get_range.png" => "img/icons/sheet_get_range.png",
"Find" => "Buscar",
// "Refresh Calculations" => "Refresh Calculations",
// "img/icons/arrow_refresh.png" => "img/icons/arrow_refresh.png",
// "Finish Editing" => "Finish Editing",
// "img/icons/close.png" => "img/icons/close.png",
// "Admin Toolbars" => "Admin Toolbars",
"Reset Colors" => "Re-especificar Colors",
"Reset" => "Re-especificar",
"*** ERROR: Tracker ID not set ***" => "*** ERROR: No se ha especificado el ID del Formulario-bd ***",
// "*** ERROR: Field ID not set ***" => "*** ERROR: Field ID not set ***",
// "*** ERROR: Tracker %0 not found ***" => "*** ERROR: Tracker %0 not found ***",
// "*** ERROR: Field %0 not found ***" => "*** ERROR: Field %0 not found ***",
"Problem inserting tracker item: trackerId=%0, created=%1, lastModif=%2, status=%3" => "Ha habido un problema insertando el ítem del formulario-bd: trackerId=%0, created=%1, lastModif=%2, status=%3",
"Problem converting tracker item link field: trackerId=%0, fieldId=%1, itemId=%2" => "Ha habido un problema convirtiendo el campo de enlace del ítem (itemlink) del formulario-bd: trackerId=%0, fieldId=%1, itemId=%2",
"Field is not numeric" => "El campo no es numérico",
"Function" => "Función",
"Tracker field setup error - display field not found: " => "Error de inicialización del campo del formulario-bd - no se ha encontrado el campo del formulario-bd: ",
"Item Modification" => "Modificación de ítem",
"Item creation" => "Creación de ítem",
"Item" => "Item",
"Subject" => "Tema",
"Tracker was modified at %0 by %1" => "%1 ha modificado el Formulario-bd en %0",
"View the tracker item at:" => "Ver el ítem de formulario-bd en:",
"Tracker field not enabled: fieldId=%0 type=%1" => "No está habilitado el campo del Formulario-bd: fieldId=%0 type=%1",
"Message" => "Mensaje",
"No extra information for that attached file. " => "No hay información extra para ese archivo asociado. ",
"(AT)" => "(EN)",
"(DOT)" => "(PUNTO)",
// "Can create/close a book" => "Can create/close a book",
// "Can create/edit/lock accounts" => "Can create/edit/lock accounts",
// "Create a new transaction" => "Create a new transaction",
// "Permission to view the journal" => "Permission to view the journal",
// "Can book into the stack where statements can be changed" => "Can book into the stack where statements can be changed",
// "Can import statements from external accounts" => "Can import statements from external accounts",
// "Can manage templates for recurring transactions" => "Can manage templates for recurring transactions",
// "Can admin the articles" => "Can admin the articles",
// "Can approve submissions" => "Can approve submissions",
// "Can admin article topics" => "Can admin article topics",
// "Can admin article types" => "Can admin article types",
// "Can read article headings" => "Can read article headings",
// "Submitted articles automatically approved" => "Submitted articles automatically approved",
// "Can edit articles" => "Can edit articles",
// "Can edit submissions" => "Can edit submissions",
// "Can read articles" => "Can read articles",
// "Can remove articles" => "Can remove articles",
// "Can remove submissions" => "Can remove submissions",
// "Can submit articles" => "Can submit articles",
// "Can rate articles" => "Can rate articles",
// "Can read a topic (Applies only to individual topic perms)" => "Can read a topic (Applies only to individual topic perms)",
// "Can view recordings from past meetings" => "Can view recordings from past meetings",
// "Can join a meeting" => "Can join a meeting",
// "Can moderate a meeting" => "Can moderate a meeting",
// "Can create a meeting" => "Can create a meeting",
// "Can admin blogs" => "Can admin blogs",
// "Can assign perms to blog" => "Can assign perms to blog",
// "Can post to a blog" => "Can post to a blog",
// "Can create a blog" => "Can create a blog",
// "Can read blogs" => "Can read blogs",
// "Can view in module and feed the blog posts" => "Can view in module and feed the blog posts",
// "Can view in module and feed the blog" => "Can view in module and feed the blog",
// "Can create/admin calendars" => "Can create/admin calendars",
// "Can add events in the calendar" => "Can add events in the calendar",
// "Can change events in the calendar" => "Can change events in the calendar",
// "Can browse the calendar" => "Can browse the calendar",
// "Can view events details" => "Can view events details",
// "Can add own user to the participants" => "Can add own user to the participants",
// "Can add guest to the participants" => "Can add guest to the participants",
// "Can view Tiki tools calendar" => "Can view Tiki tools calendar",
// "Can admin categories" => "Can admin categories",
// "Can see the category in a listing" => "Can see the category in a listing",
// "Can add objects to the category (needs tiki_p_modify_object_categories)" => "Can add objects to the category (needs tiki_p_modify_object_categories)",
// "Can remove objects from the category (needs tiki_p_modify_object_categories)" => "Can remove objects from the category (needs tiki_p_modify_object_categories)",
// "Can assign perms to category)" => "Can assign perms to category)",
// "Administrator can create channels, remove channels, etc" => "Administrator can create channels, remove channels, etc",
// "Can use the chat system" => "Can use the chat system",
// "Can admin received articles" => "Can admin received articles",
// "Can admin received pages" => "Can admin received pages",
// "Can send articles to other sites" => "Can send articles to other sites",
// "Can send articles to this site" => "Can send articles to this site",
// "Can send pages to this site" => "Can send pages to this site",
// "Can send pages to other sites" => "Can send pages to other sites",
// "Can post new comments" => "Can post new comments",
// "Can read comments" => "Can read comments",
// "Can admin comments" => "Can admin comments",
// "Can edit all comments" => "Can edit all comments",
// "Can delete comments" => "Can delete comments",
// "Can vote comments" => "Can vote comments",
// "Can admin content templates" => "Can admin content templates",
// "Can edit content templates" => "Can edit content templates",
// "Can use content templates" => "Can use content templates",
// "Can admin contributions" => "Can admin contributions",
// "Can admin the directory" => "Can admin the directory",
// "Can admin directory categories" => "Can admin directory categories",
// "Can admin directory sites" => "Can admin directory sites",
// "Submitted links are valid" => "Submitted links are valid",
// "Can submit sites to the directory" => "Can submit sites to the directory",
// "Can validate submitted links" => "Can validate submitted links",
// "Can use the directory" => "Can use the directory",
// "Can execute arbitrary queries on a given DSN" => "Can execute arbitrary queries on a given DSN",
// "Can admin faqs" => "Can admin faqs",
// "Can suggest faq questions" => "Can suggest faq questions",
// "Can view faqs" => "Can view faqs",
// "Can download files" => "Can download files",
// "Can upload files" => "Can upload files",
// "Can list file galleries" => "Can list file galleries",
// "Can view file galleries" => "Can view file galleries",
// "Can admin file galleries" => "Can admin file galleries",
// "Can assign perms to file gallery" => "Can assign perms to file gallery",
// "Can use Directory Batch Load" => "Can use Directory Batch Load",
// "Can upload zip files with files" => "Can upload zip files with files",
// "Can create file galleries" => "Can create file galleries",
// "Can edit a gallery file" => "Can edit a gallery file",
// "Can remove files" => "Can remove files",
// "Can view file galleries explorer" => "Can view file galleries explorer",
// "Can view file galleries path" => "Can view file galleries path",
// "Can admin forums" => "Can admin forums",
// "Can attach to forum posts" => "Can attach to forum posts",
// "Auto approve forum posts" => "Auto approve forum posts",
// "Can edit own forum posts" => "Can edit own forum posts",
// "Can post in forums" => "Can post in forums",
// "Can start threads in forums" => "Can start threads in forums",
// "Can read forums" => "Can read forums",
// "Can report posts to moderator" => "Can report posts to moderator",
// "Can vote comments in forums" => "Can vote comments in forums",
// "Can browse freetags" => "Can browse freetags",
// "Can admin freetags" => "Can admin freetags",
// "Can tag objects" => "Can tag objects",
// "Can unassign tags from an object" => "Can unassign tags from an object",
// "Can subscribe to groups" => "Can subscribe to groups",
// "Can invite user to my groups" => "Can invite user to my groups",
// "Can view the group" => "Can view the group",
// "Can view the group members" => "Can view the group members",
// "Can add group members" => "Can add group members",
// "Can remove group members" => "Can remove group members",
// "Can join or leave the group" => "Can join or leave the group",
// "Can edit HTML pages" => "Can edit HTML pages",
// "Can view HTML pages" => "Can view HTML pages",
// "Can admin Image Galleries" => "Can admin Image Galleries",
// "Can assign perms to image gallery" => "Can assign perms to image gallery",
// "Can upload zip files with images" => "Can upload zip files with images",
// "Can create image galleries" => "Can create image galleries",
// "Can list image galleries" => "Can list image galleries",
// "Can upload images" => "Can upload images",
// "Can view image galleries" => "Can view image galleries",
// "Can admin Kaltura video feature" => "Can admin Kaltura video feature",
// "Can upload video or record from webcam" => "Can upload video or record from webcam",
// "Can edit media information" => "Can edit media information",
// "Can create kaltura remix video" => "Can create kaltura remix video",
// "Can delete media" => "Can delete media",
// "Can download media" => "Can download media",
// "Can list media" => "Can list media",
// "Can view media" => "Can view media",
// "Can create new mapfile" => "Can create new mapfile",
// "Can delete mapfiles" => "Can delete mapfiles",
// "Can edit mapfiles" => "Can edit mapfiles",
// "Can view mapfiles" => "Can view mapfiles",
// "Can view contents of mapfiles" => "Can view contents of mapfiles",
// "Can broadcast messages to all user" => "Can broadcast messages to all user",
// "Can broadcast messages to groups" => "Can broadcast messages to groups",
// "Can use the messaging system" => "Can use the messaging system",
// "Can admin newsletters" => "Can admin newsletters",
// "Can subscribe many e-mails at once (requires tiki_p_subscribe email)" => "Can subscribe many e-mails at once (requires tiki_p_subscribe email)",
// "Can send newsletters" => "Can send newsletters",
// "Can subscribe any email to newsletters" => "Can subscribe any email to newsletters",
// "Can subscribe to newsletters" => "Can subscribe to newsletters",
// "Can view the archive of a newsletters" => "Can view the archive of a newsletters",
// "Can list newsletters" => "Can list newsletters",
// "Can administer payments" => "Can administer payments",
// "Can view payment requests and details" => "Can view payment requests and details",
// "Can enter manual payments" => "Can enter manual payments",
// "Can request a payment" => "Can request a payment",
// "Can view the perspective" => "Can view the perspective",
// "Can edit the perspective" => "Can edit the perspective",
// "Can create a perspective" => "Can create a perspective",
// "Can admin perspectives" => "Can admin perspectives",
// "Can admin polls" => "Can admin polls",
// "Can view poll results" => "Can view poll results",
// "Can vote polls" => "Can vote polls",
// "Can view poll voters" => "Can view poll voters",
// "Can admin quizzes" => "Can admin quizzes",
// "Can take quizzes" => "Can take quizzes",
// "Can view quiz stats" => "Can view quiz stats",
// "Can view user quiz results" => "Can view user quiz results",
// "Can admin sheet" => "Can admin sheet",
// "Can create and edit sheets" => "Can create and edit sheets",
// "Can view sheet" => "Can view sheet",
// "Can view sheet history" => "Can view sheet history",
// "Can admin shoutbox (Edit/remove messages)" => "Can admin shoutbox (Edit/remove messages)",
// "Can post messages in shoutbox" => "Can post messages in shoutbox",
// "Can view shoutbox" => "Can view shoutbox",
// "user can use social network integration" => "user can use social network integration",
// "user can register this site with social networks" => "user can register this site with social networks",
// "Admin live support system" => "Admin live support system",
// "Can use live support system" => "Can use live support system",
// "Can admin surveys" => "Can admin surveys",
// "Can take surveys" => "Can take surveys",
// "Can view survey stats" => "Can view survey stats",
// "Can admin the TikiTests" => "Can admin the TikiTests",
// "Can edit TikiTests" => "Can edit TikiTests",
// "Can replay the TikiTests" => "Can replay the TikiTests",
// "Can admin trackers" => "Can admin trackers",
// "Can attach files to tracker items" => "Can attach files to tracker items",
// "Can view tracker items attachments and download" => "Can view tracker items attachments and download",
// "Can insert comments for tracker items" => "Can insert comments for tracker items",
// "Can view tracker items comments" => "Can view tracker items comments",
// "Can create new items for trackers" => "Can create new items for trackers",
// "Can list trackers" => "Can list trackers",
// "Can change tracker items" => "Can change tracker items",
// "Can change pending tracker items" => "Can change pending tracker items",
// "Can change closed tracker items" => "Can change closed tracker items",
// "Can remove tracker items" => "Can remove tracker items",
// "Can remove pending tracker items" => "Can remove pending tracker items",
// "Can remove closed tracker items" => "Can remove closed tracker items",
// "Can view rating result for tracker items" => "Can view rating result for tracker items",
// "Can vote a rating for tracker items" => "Can vote a rating for tracker items",
// "Can re-vote a rating for tracker items" => "Can re-vote a rating for tracker items",
// "Can view trackers" => "Can view trackers",
// "Can view closed trackers items" => "Can view closed trackers items",
// "Can view pending trackers items" => "Can view pending trackers items",
// "Can watch tracker" => "Can watch tracker",
// "Can export tracker items" => "Can export tracker items",
// "Can save a .CSV backup of entire trackers" => "Can save a .CSV backup of entire trackers",
// "Can trigger the transition between two states" => "Can trigger the transition between two states",
// "Can admin users" => "Can admin users",
// "Can cache user bookmarks" => "Can cache user bookmarks",
// "Can configure modules" => "Can configure modules",
// "Can create user bookmarks" => "Can create user bookmarks",
// "Can use the mini event calendar" => "Can use the mini event calendar",
// "Can use the notepad" => "Can use the notepad",
// "Can admin public tasks" => "Can admin public tasks",
// "Can use tasks" => "Can use tasks",
// "Can receive tasks from other users" => "Can receive tasks from other users",
// "Can send tasks to other users" => "Can send tasks to other users",
// "Can upload personal files" => "Can upload personal files",
// "Can create items in personal menu" => "Can create items in personal menu",
// "Can list registered users" => "Can list registered users",
// "Can invite users by email, and include them in groups" => "Can invite users by email, and include them in groups",
// "Can use webmail" => "Can use webmail",
// "Can use group webmail" => "Can use group webmail",
// "Can admin group webmail accounts" => "Can admin group webmail accounts",
// "Can use personal webmail accounts" => "Can use personal webmail accounts",
// "Can admin personal webmail accounts" => "Can admin personal webmail accounts",
// "Can view page/pages" => "Can view page/pages",
// "Can edit pages" => "Can edit pages",
// "Can view wiki history" => "Can view wiki history",
// "Can admin the wiki" => "Can admin the wiki",
// "Can assign perms to wiki pages" => "Can assign perms to wiki pages",
// "Can edit copyright notices" => "Can edit copyright notices",
// "Can edit dynamic variables" => "Can edit dynamic variables",
// "Can create and edit structures" => "Can create and edit structures",
// "Can export wiki pages using the export feature" => "Can export wiki pages using the export feature",
// "Can lock pages" => "Can lock pages",
// "Can save as minor edit" => "Can save as minor edit",
// "Can remove" => "Can remove",
// "Can rename pages" => "Can rename pages",
// "Can rollback pages" => "Can rollback pages",
// "Can upload pictures to wiki pages" => "Can upload pictures to wiki pages",
// "Can use the page as a tracker template" => "Can use the page as a tracker template",
// "Can view in module and feed the wiki pages reference" => "Can view in module and feed the wiki pages reference",
// "Can watch structure" => "Can watch structure",
// "Can admin attachments on wiki pages" => "Can admin attachments on wiki pages",
// "Can add and change ratings on wiki pages" => "Can add and change ratings on wiki pages",
// "Can attach files to wiki pages" => "Can attach files to wiki pages",
// "Can view wiki attachments and download" => "Can view wiki attachments and download",
// "Can view wiki comments" => "Can view wiki comments",
// "Can view rating of wiki pages" => "Can view rating of wiki pages",
// "Can view source of wiki pages" => "Can view source of wiki pages",
// "Can participate to rating of wiki pages" => "Can participate to rating of wiki pages",
// "Can view similar wiki pages" => "Can view similar wiki pages",
// "View page backlinks" => "View page backlinks",
// "Can view unapproved revisions of pages" => "Can view unapproved revisions of pages",
// "Can approve revisions of pages" => "Can approve revisions of pages",
// "Can view contributions to a page" => "Can view contributions to a page",
// "Administrator can manage users, groups and permissions and all features" => "Administrator can manage users, groups and permissions and all features",
// "Can access site when closed" => "Can access site when closed",
// "Administrator can admin banners" => "Administrator can admin banners",
// "Can ban users or ips" => "Can ban users or ips",
// "Can admin the dynamic content system" => "Can admin the dynamic content system",
// "Can admin integrator repositories and rules" => "Can admin integrator repositories and rules",
// "Can admin mail-in accounts" => "Can admin mail-in accounts",
// "Can edit object permissions" => "Can edit object permissions",
// "Can admin external feeds" => "Can admin external feeds",
// "Can clean cache" => "Can clean cache",
// "Can create new css suffixed with -user" => "Can create new css suffixed with -user",
// "Can remove association between two pages in a translation set" => "Can remove association between two pages in a translation set",
// "Can admin cookies" => "Can admin cookies",
// "Can edit translations and create new languages" => "Can edit translations and create new languages",
// "Can edit menu" => "Can edit menu",
// "Can edit menu option" => "Can edit menu option",
// "Can edit site templates" => "Can edit site templates",
// "Can search" => "Can search",
// "Can report a link to the webmaster" => "Can report a link to the webmaster",
// "Can send a link to a friend" => "Can send a link to a friend",
// "Can share a page (email, Twitter, Facebook, message, forums)" => "Can share a page (email, Twitter, Facebook, message, forums)",
// "Can use HTML in pages" => "Can use HTML in pages",
// "Can view action log" => "Can view action log",
// "Can view action log for users of his own groups" => "Can view action log for users of his own groups",
// "Can view integrated repositories" => "Can view integrated repositories",
// "Can view referrer stats" => "Can view referrer stats",
// "Can view site stats" => "Can view site stats",
// "Can view site templates" => "Can view site templates",
// "Can admin toolbars" => "Can admin toolbars",
// "Trust all user inputs including plugins (no security checks)" => "Trust all user inputs including plugins (no security checks)",
// "Can view unapproved plugin details" => "Can view unapproved plugin details",
// "Can execute unapproved plugin registered" => "Can execute unapproved plugin registered",
// "Can approve plugin execution" => "Can approve plugin execution",
// "Can admin mail notifications" => "Can admin mail notifications",
// "Can delete his/her own account" => "Can delete his/her own account",
// "Can use the importer" => "Can use the importer",
// "Can change the categories of the object" => "Can change the categories of the object",
// "User can administer modules" => "User can administer modules",
// "Can switch between wiki and WYSIWYG modes while editing" => "Can switch between wiki and WYSIWYG modes while editing",
// "User \"%0\" is banned from the group \"%1\"" => "User \"%0\" is banned from the group \"%1\"",
// "Do you want to unban them and continue" => "Do you want to unban them and continue",
// "Password should be at least %0 characters long" => "Password should be at least %0 characters long",
"Password must contain both letters and numbers" => "La contraseña debe tener letras y números",
"The administrator has not yet validated your account. Please wait" => "El administrador todavía no ha validado su cuenta. Por favor, espere",
"You must validate your account first. An email has been sent to you" => "Debe validar su cuenta primero. Un email le ha sido enviado",
"The registration mail can't be sent. Contact the administrator" => "El correo de registro no puede ser enviado. Contacte con el administrador",
"The registration mail can't be sent because there is no server email address set, and this feature is disabled" => "El email de registro no puede ser enviado porque no se establecido la dirección del servidor de correo, y esta característica está deshabilitada",
"The user email confirmation can't be sent. Contact the administrator" => "La confirmación del email del usuario no pudo ser enviada. Contacte con el administrador",
// "Edit field: (Parameter needs to be 'trackerId=XX&fileId=YY' or be empty to use the current field)" => "Edit field: (Parameter needs to be 'trackerId=XX&fileId=YY' or be empty to use the current field)",
// "Edit field: (Incorrect validation parameter)" => "Edit field: (Incorrect validation parameter)",
"Page already exists" => "Página ya existe",
// "Page does not exist" => "Page does not exist",
// "Invalid character combination for username" => "Invalid character combination for username",
// "here" => "here",
// "Could not establish Kaltura session. Try again" => "Could not establish Kaltura session. Try again",
// "You need to set your Kaltura account details: " => "You need to set your Kaltura account details: ",
// "Cannot connect with web service" => "Cannot connect with web service",
// "No permission to broadcast to channel" => "No permission to broadcast to channel",
// "Broadcaster successfully authenticated" => "Broadcaster successfully authenticated",
// "No permission to broadcast to any channel" => "No permission to broadcast to any channel",
// "Successfully logged in mobile broadcaster" => "Successfully logged in mobile broadcaster",
// "No viewable channels available for mobile" => "No viewable channels available for mobile",
// "Failed to log in mobile broadcaster" => "Failed to log in mobile broadcaster",
// "Successfully logged in FME" => "Successfully logged in FME",
// "Failed to log in FME" => "Failed to log in FME",
// "No permission to view channel" => "No permission to view channel",
// "Viewer successfully authenticated" => "Viewer successfully authenticated",
// "No permission to view any channel" => "No permission to view any channel",
"Successfully stored archive in tracker" => "Se ha guardado el archivo en el formulario-bd con éxito",
"Failed to stored archive in tracker" => "No se ha podido guardar el archivo en el formulario-bd",
"Personal Phone" => "Teléfono Personal",
"Personal Mobile" => "Móvil Personal",
"Personal Fax" => "Fax Personal",
"Work Phone" => "Teléfono del Trabajo",
"Work Mobile" => "Móvil del Trabajo",
"Work Fax" => "Fax del Trabajo",
"Company" => "Compañía",
"Organization" => "Organización",
"Department" => "Departamento",
"Division" => "División",
"Job Title" => "Puesto de Trabajo",
"Street Address" => "Calle",
"City" => "Ciudad",
"State" => "Estado",
"Zip Code" => "Código Postal",
// "Mailbox uninitialised??" => "Mailbox uninitialised??",
"No subject" => "Sin tema",
// "No mail body found" => "No mail body found",
// "Cannot create aliased page" => "Cannot create aliased page",
// "You attempted to create the following page" => "You attempted to create the following page",
// "That page is an alias for the following pages" => "That page is an alias for the following pages",
// "If you want to create the page, you must first edit each the pages above, and remove the alias link it may contain. This link should look something like this" => "If you want to create the page, you must first edit each the pages above, and remove the alias link it may contain. This link should look something like this",
// "Can't parse HTML data - no grammar file" => "Can't parse HTML data - no grammar file",
// "Removed version \$version" => "Removed version \$version",
// "rollback version " => "rollback version ",
// "Changed actual version to \$version" => "Changed actual version to \$version",
"No version indicated" => "No se indica una versión",
// "Plugin " => "Plugin ",
"failed" => "fallo",
// "Required parameters are in</em> <b>bold</b>" => "Required parameters are in</em> <b>bold</b>",
// "Parameter Info" => "Parameter Info",
// "There are no approved versions of this page" => "There are no approved versions of this page",
// "Semantic token already exists" => "Semantic token already exists",
// "Invalid semantic token name" => "Invalid semantic token name",
// "Semantic token not found" => "Semantic token not found",
// "Page locked" => "Page locked",
// "Page unlocked" => "Page unlocked",
// "Removed last version" => "Removed last version",
// "Add Freetag" => "Add Freetag",
// "Add a single freetag to specified object" => "Add a single freetag to specified object",
"Object" => "Objeto",
// "Object type and id, as in type:id, if unset, will use current object" => "Object type and id, as in type:id, if unset, will use current object",
// "Add Relation" => "Add Relation",
// "Displays a simple button that toggles i.e. adds or removes a pre-specified relation" => "Displays a simple button that toggles i.e. adds or removes a pre-specified relation",
// "Qualifier" => "Qualifier",
// "Relation qualifier. Usually a three part string separated by 2 periods" => "Relation qualifier. Usually a three part string separated by 2 periods",
// "Source Object" => "Source Object",
// "Object identifier as type:itemId to start the relation from, will use the current object if left blank" => "Object identifier as type:itemId to start the relation from, will use the current object if left blank",
// "Target Object" => "Target Object",
// "Object identifier as type:itemId to end the relation to, will use the current object if left blank" => "Object identifier as type:itemId to end the relation to, will use the current object if left blank",
// "Button Text for Add" => "Button Text for Add",
// "Text to show on the button to add relation" => "Text to show on the button to add relation",
// "Button Text for Already Added State" => "Button Text for Already Added State",
// "Text to show on the button when relation is already added" => "Text to show on the button when relation is already added",
// "Relation Added" => "Relation Added",
// "Mouseover Button Text for Remove" => "Mouseover Button Text for Remove",
// "Text to show on the button to remove relation" => "Text to show on the button to remove relation",
// "Remove Relation" => "Remove Relation",
// "Button Id" => "Button Id",
// "A unique ID to distinguish the button from others on the page if there is more than one" => "A unique ID to distinguish the button from others on the page if there is more than one",
// "Source and target object cannot be the same" => "Source and target object cannot be the same",
// "Add to cart" => "Add to cart",
// "PluginAddToCart" => "PluginAddToCart",
// "Adds a product to the virtual cart. The cart can be manipulated using the cart module" => "Adds a product to the virtual cart. The cart can be manipulated using the cart module",
// "Product code" => "Product code",
// "Unique identifier for the product. Two products with the same code will be the same and the information used will be the one of the first in" => "Unique identifier for the product. Two products with the same code will be the same and the information used will be the one of the first in",
// "Label for the product in the cart" => "Label for the product in the cart",
// "Product Type" => "Product Type",
// "The product type that is being sold, which will affect fulfillment, e.g. standard product, gift certificate, event ticket" => "The product type that is being sold, which will affect fulfillment, e.g. standard product, gift certificate, event ticket",
// "Product Class" => "Product Class",
// "The class the product belongs to, can be used to limit how gift cards are used" => "The class the product belongs to, can be used to limit how gift cards are used",
// "Product Bundle" => "Product Bundle",
// "The bundle the product belongs to, can be used to limit how gift cards are used, will automatically add other products in same class to cart" => "The bundle the product belongs to, can be used to limit how gift cards are used, will automatically add other products in same class to cart",
// "Bundle Class" => "Bundle Class",
// "The class the bundle belongs to, can be used to limit how gift cards are used" => "The class the bundle belongs to, can be used to limit how gift cards are used",
// "Price" => "Price",
// "The price to charge for the item" => "The price to charge for the item",
// "URL of the product's information. The URL may be relative or absolute (begin with http://)" => "URL of the product's information. The URL may be relative or absolute (begin with http://)",
// "Button label" => "Button label",
// "Text for the submit button. default: \"Add to cart\"" => "Text for the submit button. default: \"Add to cart\"",
// "Associated event code" => "Associated event code",
// "Unique identifier for the event that is associated to the product" => "Unique identifier for the event that is associated to the product",
// "Automatically checkout" => "Automatically checkout",
// "Automatically checkout for purchase and send user to pay (this is disabled when there is already something in the cart)" => "Automatically checkout for purchase and send user to pay (this is disabled when there is already something in the cart)",
// "Buy on behalf of" => "Buy on behalf of",
// "Allows the selection of user to make purchase on behalf of" => "Allows the selection of user to make purchase on behalf of",
// "Shop as anonymous always" => "Shop as anonymous always",
// "Add to cart as anonymous shopper even if logged in" => "Add to cart as anonymous shopper even if logged in",
// "Forward to this URL after free purchase" => "Forward to this URL after free purchase",
// "Gift certificate" => "Gift certificate",
// "Allows user to add gift certificate from the product view" => "Allows user to add gift certificate from the product view",
// "Order Item ID to exchange product" => "Order Item ID to exchange product",
// "Used in conjunction with exchange feature" => "Used in conjunction with exchange feature",
// "Product ID to exchange to" => "Product ID to exchange to",
// "Amount of new product to exchange for" => "Amount of new product to exchange for",
// "Should normally be set to the amount of products in the order being exchanged" => "Should normally be set to the amount of products in the order being exchanged",
// "Ajax add to cart feature" => "Ajax add to cart feature",
// "Attempts to turn ajax for cart on" => "Attempts to turn ajax for cart on",
// "A session must be active to use the cart" => "A session must be active to use the cart",
// "Please enter your shopper information first" => "Please enter your shopper information first",
// "The order was recorded and is now awaiting payment. Reference number is %0" => "The order was recorded and is now awaiting payment. Reference number is %0",
// "Your free order of %0 (%1) has been processed. An email has been sent to you for your records" => "Your free order of %0 (%1) has been processed. An email has been sent to you for your records",
// "Your free order of %0 (%1) has been processed" => "Your free order of %0 (%1) has been processed",
// "%0 (%1) was added to your cart" => "%0 (%1) was added to your cart",
// "Invalid gift certificate: " => "Invalid gift certificate: ",
// "Add to Google Calendar" => "Add to Google Calendar",
// "Add a calendar item to a Google calendar" => "Add a calendar item to a Google calendar",
// "Calendar item ID" => "Calendar item ID",
// "The item ID of the calendar to add to Google calendar" => "The item ID of the calendar to add to Google calendar",
// "A calendar item ID number" => "A calendar item ID number",
// "Icon Style" => "Icon Style",
// "Choose the icon style" => "Choose the icon style",
// "Either 1, 2 or 3" => "Either 1, 2 or 3",
// "One" => "One",
// "Two" => "Two",
// "Three" => "Three",
// "Adjust Inventory" => "Adjust Inventory",
// "PluginAdjustInventory" => "PluginAdjustInventory",
// "Modifies inventory of a product" => "Modifies inventory of a product",
// "Product ID" => "Product ID",
// "Product ID of item in the cart tracker" => "Product ID of item in the cart tracker",
// "Show add" => "Show add",
// "y|n" => "y|n",
// "Show subtract" => "Show subtract",
// "Inventory was adjusted by %0" => "Inventory was adjusted by %0",
// "User Agent Info" => "User Agent Info",
// "Show user's browser and server information" => "Show user's browser and server information",
"Info" => "Info",
// "Display's the visitor's IP address (IP or default), browser information (BROWSER), or server software (SVRSW)" => "Display's the visitor's IP address (IP or default), browser information (BROWSER), or server software (SVRSW)",
// "IP address" => "IP address",
// "Server software" => "Server software",
// "Browser" => "Browser",
"Anchor Link" => "Enlace a Marca",
// "Create a link to an anchor" => "Create a link to an anchor",
"Anchor link label" => "Etiqueta del enlace a la marca",
"Anchor Name" => "Nombre de la Marca",
"The anchor name as defined in the ANAME plugin" => "El nombre de la marca definido como en el plugin ANAME",
// "The name of the wiki page containing the anchor. If empty, the anchor name will be searched for on the wiki page where the plugin is used" => "The name of the wiki page containing the anchor. If empty, the anchor name will be searched for on the wiki page where the plugin is used",
// "Create an anchor that can be linked to" => "Create an anchor that can be linked to",
"The name of the anchor" => "Nombre de la marca",
"Image Annotation" => "Anotación de la imagen",
// "Annotate an image" => "Annotate an image",
"Autogenerated content. Leave blank initially" => "Contenido Autogenerado. Déjelo en blanco inicialmente",
// "Absolute URL to the image or relative path from tiki root" => "Absolute URL to the image or relative path from tiki root",
// "Image width in pixels" => "Image width in pixels",
// "Image height in pixels" => "Image height in pixels",
"Alignment" => "Alineado",
// "Image alignment. Possible values: left, right, center. Default is left" => "Image alignment. Possible values: left, right, center. Default is left",
"Center" => "Centrar",
"Save changes to annotations" => "Guardar cambios en anotaciones",
"Image annotations changed" => "Las anotaciones de la imagen cambiaron",
// "Application Frame" => "Application Frame",
// "Creates a frame to assemble custom applications in. Components in the frame will be various wiki pages and modules" => "Creates a frame to assemble custom applications in. Components in the frame will be various wiki pages and modules",
// "Application layout" => "Application layout",
// "Minimal height" => "Minimal height",
// "Prevent the frame from becoming any shorter than the specified size" => "Prevent the frame from becoming any shorter than the specified size",
// "Hide left column" => "Hide left column",
// "Hide the left column when the application frame is in use to provide more space to the application" => "Hide the left column when the application frame is in use to provide more space to the application",
// "Hide right column" => "Hide right column",
// "Hide the right column when the application frame is in use to provide more space to the application" => "Hide the right column when the application frame is in use to provide more space to the application",
// "Full page" => "Full page",
// "Occupy the complete content area of the page" => "Occupy the complete content area of the page",
// "Absolute Position" => "Absolute Position",
// "Position the app frame to use absolute position and really use all available space" => "Position the app frame to use absolute position and really use all available space",
// "When using absolute mode, leave some space for the header at the top" => "When using absolute mode, leave some space for the header at the top",
// "Template file not found: %0" => "Template file not found: %0",
// "Pan/Zoom" => "Pan/Zoom",
"Select" => "Seleccionar",
// "Select/Modify" => "Select/Modify",
// "Draw Polygon" => "Draw Polygon",
// "Draw Path" => "Draw Path",
// "Reset Zoom" => "Reset Zoom",
// "Archive Builder" => "Archive Builder",
// "Build a zip archive that can be downloaded" => "Build a zip archive that can be downloaded",
// "Description of the archive content. Multiple handlers are available for content types. One per line. Ex: page-as-pdf:some-folder/foo.pdf:HomePage , tracker-attachments:target-folder/:3435" => "Description of the archive content. Multiple handlers are available for content types. One per line. Ex: page-as-pdf:some-folder/foo.pdf:HomePage , tracker-attachments:target-folder/:3435",
// "Archive Name" => "Archive Name",
// "Upon download, the name of the file that will be provided" => "Upon download, the name of the file that will be provided",
// "Missing extension zip" => "Missing extension zip",
// "Incorrect parameter" => "Incorrect parameter",
// "Download archive" => "Download archive",
// "Display a field of an article" => "Display a field of an article",
"The article field to display. Default field is Heading" => "Campo del artículo a mostrar. El título es el campo por defecto",
"Article ID" => "ID del Artículo",
"The article to display. If no value is provided, most recent article will be used" => "Artículo a mostrar. Si no se define ningún valor, se utilizará el artículo más reciente",
"Article List" => "Lista de Artículos",
// "Display multiple articles" => "Display multiple articles",
// "Use Pagination" => "Use Pagination",
// "Activate pagination when articles listing are long. Default is n" => "Activate pagination when articles listing are long. Default is n",
// "Maximum Displayed" => "Maximum Displayed",
// "The number of articles to display in the list (no max set by default)" => "The number of articles to display in the list (no max set by default)",
// "If Pagination is set to y (Yes), this will determine the amount of articles per page" => "If Pagination is set to y (Yes), this will determine the amount of articles per page",
// "Topic Name Filter" => "Topic Name Filter",
// "Filter the list of articles by topic. Example: " => "Filter the list of articles by topic. Example: ",
// "Topic ID Filter" => "Topic ID Filter",
// "Filter the list of articles by topic ID. Example: " => "Filter the list of articles by topic ID. Example: ",
// "Type Filter" => "Type Filter",
// "Filter the list of articles by types. Example: " => "Filter the list of articles by types. Example: ",
"Category ID" => "ID de la Categoría",
// "The ID of the category that articles need to be in to be listed" => "The ID of the category that articles need to be in to be listed",
// "List only articles in this language" => "List only articles in this language",
"Sort order" => "Tipo de ordenación",
// "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")" => "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")",
// "Use random to have random items" => "Use random to have random items",
// "Specific order" => "Specific order",
// "List of ArticleId that must appear in this order if present" => "List of ArticleId that must appear in this order if present",
// "Only these articles" => "Only these articles",
// "List of ArticleId to display separated by |" => "List of ArticleId to display separated by |",
// "Not these articles" => "Not these articles",
// "List of ArticleId that can not be displayed separated by |" => "List of ArticleId that can not be displayed separated by |",
"Quiet" => "Silencioso",
// "Whether to not report when there are no articles (no reporting by default)" => "Whether to not report when there are no articles (no reporting by default)",
// "Title Only" => "Title Only",
// "Whether to only show the title of the articles (not set to title only by default)" => "Whether to only show the title of the articles (not set to title only by default)",
// "Body Only" => "Body Only",
// "Whether to only show the body of the articles or just the heading and title. (not set to body only by default)" => "Whether to only show the body of the articles or just the heading and title. (not set to body only by default)",
// "Starting Article" => "Starting Article",
// "The article number that the list should start with (starts with first article by default)" => "The article number that the list should start with (starts with first article by default)",
// "This will not work if Pagination is used" => "This will not work if Pagination is used",
// "Start Date" => "Start Date",
// "Earliest date to select articles from" => "Earliest date to select articles from",
// " (YYYY-MM-DD)" => " (YYYY-MM-DD)",
// "End date" => "End date",
// "Latest date to select articles from" => "Latest date to select articles from",
// "Period quantity" => "Period quantity",
// "Numeric value to display only last articles published within a user defined time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how many of those units are to be considered to define the time frame. If this parameter is set, \"Start Date\" and \"End date\" are ignored" => "Numeric value to display only last articles published within a user defined time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how many of those units are to be considered to define the time frame. If this parameter is set, \"Start Date\" and \"End date\" are ignored",
// "Period unit" => "Period unit",
// "Time unit used with \"Period quantity\"" => "Time unit used with \"Period quantity\"",
// "Override Dates" => "Override Dates",
// "Whether to obey article type's \"show before publish\" and \"show after expiry\" settings (not obeyed by default)" => "Whether to obey article type's \"show before publish\" and \"show after expiry\" settings (not obeyed by default)",
// "Container class" => "Container class",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")",
// "Large First Image" => "Large First Image",
// "If set to y (Yes), the first image will be displayed with the dimension used to view of the article" => "If set to y (Yes), the first image will be displayed with the dimension used to view of the article",
// "Additional URL Param to the link to read article" => "Additional URL Param to the link to read article",
// "Show actions (buttons and links)" => "Show actions (buttons and links)",
// "Whether to show the buttons and links to do actions on each article (for the actions you have permission to do" => "Whether to show the buttons and links to do actions on each article (for the actions you have permission to do",
// "No translation" => "No translation",
// "User or pipe separated list of two letter language codes for additional languages to display. List pages with no language or with a missing translation in one of the language" => "User or pipe separated list of two letter language codes for additional languages to display. List pages with no language or with a missing translation in one of the language",
"Displays an attachment or a list of them" => "Muestra un archivo asociado o una lista de ellos",
// "File name of the attached file to link to. Either name, file, id or num can be used to identify a single attachment" => "File name of the attached file to link to. Either name, file, id or num can be used to identify a single attachment",
"File" => "Archivo",
"Same as name" => "Igual que el nombre",
// "Name of the wiki page the file is attached to. If left empty when the plugin is used on a wiki page, this defaults to that wiki page" => "Name of the wiki page the file is attached to. If left empty when the plugin is used on a wiki page, this defaults to that wiki page",
// "Show Description" => "Show Description",
// "Shows the description as the link text instead of the file name (not used by default)" => "Shows the description as the link text instead of the file name (not used by default)",
"Bullets" => "Puntos",
// "Makes the list of attachments a bulleted list (not set by default)" => "Makes the list of attachments a bulleted list (not set by default)",
// "Indicates that this file is an image, and should be displayed inline using the img tag (not set by default)" => "Indicates that this file is an image, and should be displayed inline using the img tag (not set by default)",
// "Custom Label" => "Custom Label",
// "Makes the text between the {ATTACH} tags the link text instead of the file name or description. Only the first attachment will be listed" => "Makes the text between the {ATTACH} tags the link text instead of the file name or description. Only the first attachment will be listed",
// "Lists links to all attachments for the entire tiki site together with pages they are attached to when set to 1 (Yes)" => "Lists links to all attachments for the entire tiki site together with pages they are attached to when set to 1 (Yes)",
// "Order Number" => "Order Number",
// "Identifies the attachment to link to by the order of the attachment in the list of attachments to a page instead of by file name or ID. Either name, file, id or num can be used to identify a single attachment" => "Identifies the attachment to link to by the order of the attachment in the list of attachments to a page instead of by file name or ID. Either name, file, id or num can be used to identify a single attachment",
// "Identifies the attachment to link to by id number instead of by file name or order number. Either name, file, id or num can be used to identify a single attachment" => "Identifies the attachment to link to by id number instead of by file name or order number. Either name, file, id or num can be used to identify a single attachment",
// "The alt text that pops up on mouseover will include the number of downloads of the attachment at the end when set to 1 (Yes)" => "The alt text that pops up on mouseover will include the number of downloads of the attachment at the end when set to 1 (Yes)",
// "File Type Icon" => "File Type Icon",
// "A file type icon is displayed in front of the attachment link when this is set to 1" => "A file type icon is displayed in front of the attachment link when this is set to 1",
// "Page \"%0\" does not exist" => "Page \"%0\" does not exist",
"No such attachment on this page" => "No esta ese archivo asociado a esta página",
// "Attributes" => "Attributes",
// "Assign generic attributes to the current object" => "Assign generic attributes to the current object",
// "View author contributions to a wiki page" => "View author contributions to a wiki page",
"text" => "texto",
// "User name of the user who wrote the text" => "User name of the user who wrote the text",
// "Deleted by User" => "Deleted by User",
// "User name of the user who deleted the text" => "User name of the user who deleted the text",
// "Make Visible" => "Make Visible",
// "Show popup with author/deleted by" => "Show popup with author/deleted by",
// "Generate a popup with names of author(s) (default: no)" => "Generate a popup with names of author(s) (default: no)",
// "deleted by" => "deleted by",
// "Should this author's contribution be visible (default: no)" => "Should this author's contribution be visible (default: no)",
"Avatar" => "Avatar",
// "Display a user's avatar" => "Display a user's avatar",
// "The wiki page the avatar will link to. If empty and the user's information is public, \n\t\t\t\t\t\t\t\tthen the avatar will link automatically the that user's user information page" => "The wiki page the avatar will link to. If empty and the user's information is public, \n\t\t\t\t\t\t\t\tthen the avatar will link automatically the that user's user information page",
"Float" => "Flotante",
// "Align the avatar on the page" => "Align the avatar on the page",
"Back" => "Atrás",
// "Displays a link that goes back one page in the browser history" => "Displays a link that goes back one page in the browser history",
// "Lists all pages that link to a particular page" => "Lists all pages that link to a particular page",
"The page links will point to. Default value is the current page" => "Hacia dónde apuntarán los enlaces de la página. EL valor por defecto es la página actual",
// "Displayed Information" => "Displayed Information",
"Pipe separated list of fields to display. ex: hits|user" => "Muestra la lista de campos separados con |. Por ejemplo: hits|user",
"Excluded pages" => "Páginas excluidas",
"Pipe separated list of pages to be excluded from the listing. ex: HomePage|Sandbox" => "Muestra las páginas excluidas del listado separadas con |. Por ejemplo: HomePage|Sandbox",
"Include Self" => "Incluir en la lista la página a las que las otras enlazan",
// "With or without self-link (default is without)" => "With or without self-link (default is without)",
// "With or without header (default is with header)" => "With or without header (default is with header)",
// "With header" => "With header",
// "Without header" => "Without header",
// "No pages link to" => "No pages link to",
"One page links to" => "Una página tiene enlace a",
"pages link to" => "páginas tienen enlace a",
"Banner" => "Banner",
// "Add a banner" => "Add a banner",
"Zone" => "Zona",
// "Name of the zone created in Admin > Banners" => "Name of the zone created in Admin > Banners",
"Target" => "Objetivo",
// "Determines the browser behavior once the banner is clicked" => "Determines the browser behavior once the banner is clicked",
"missing parameter" => "falta un parámetro",
// "BigBlueButton" => "BigBlueButton",
// "Starts a video/audio/chat/presentation session using BigBlueButton" => "Starts a video/audio/chat/presentation session using BigBlueButton",
// "Meeting" => "Meeting",
// "MeetingID for BigBlueButton. This is a 5 digit number, starting with a 7. Ex.: 77777 or 71111" => "MeetingID for BigBlueButton. This is a 5 digit number, starting with a 7. Ex.: 77777 or 71111",
// "Anonymous prefix" => "Anonymous prefix",
// "Unregistered users will get this token prepended to their name" => "Unregistered users will get this token prepended to their name",
// "Welcome Message" => "Welcome Message",
// "A message to be provided when someone enters the room" => "A message to be provided when someone enters the room",
// "Dial Number" => "Dial Number",
// "The phone-in support number to join from traditional phones" => "The phone-in support number to join from traditional phones",
// "Voice Bridge" => "Voice Bridge",
// "Code to enter for phone attendees to join the room. Typically, the same 5 digits of the MeetingID" => "Code to enter for phone attendees to join the room. Typically, the same 5 digits of the MeetingID",
// "Log-out URL" => "Log-out URL",
// "URL to which the user will be redirected when logging out from BigBlueButton" => "URL to which the user will be redirected when logging out from BigBlueButton",
// "Record meetings" => "Record meetings",
// "Requires BBB >= 0.8" => "Requires BBB >= 0.8",
// "Off" => "Off",
"On" => "En",
// "BigBlueButton misconfigured or unaccessible" => "BigBlueButton misconfigured or unaccessible",
// "Bliptv" => "Bliptv",
// "Display a Blip.tv video" => "Display a Blip.tv video",
// "Blip.tv embed URL. Example: http://blip.tv/play/AYGd_GAC" => "Blip.tv embed URL. Example: http://blip.tv/play/AYGd_GAC",
// "Width in pixels (default is 425" => "Width in pixels (default is 425",
// "Height in pixels (default is 350)" => "Height in pixels (default is 350)",
"Blog List" => "Lista de Blogs",
// "Display posts from a site blog" => "Display posts from a site blog",
"Blog ID" => "Blog ID",
// "The ID number of the blog on the site you wish to list posts from" => "The ID number of the blog on the site you wish to list posts from",
// "Maximum Items" => "Maximum Items",
// "Maximum number of entries to list (no maximum set by default)" => "Maximum number of entries to list (no maximum set by default)",
// "Only display posts created by this user (all posts listed by default)" => "Only display posts created by this user (all posts listed by default)",
// "Simple List" => "Simple List",
// "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)" => "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)",
// "Earliest date to select posts from" => "Earliest date to select posts from",
// "End Date" => "End Date",
// "Latest date to select posts from" => "Latest date to select posts from",
// "Container Class" => "Container Class",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")",
// "Contains Html" => "Contains Html",
// "Body of the blog posts should be parsed as containing HTML (default=n)" => "Body of the blog posts should be parsed as containing HTML (default=n)",
// "Creates a formatted box with a title bar" => "Creates a formatted box with a title bar",
"Box title" => "Título de la caja",
"Displayed above the content" => "Mostrar el contenido encima",
"Background color" => "Color de fondo",
"As defined by CSS, name or Hex code" => "Igual que el definido en la CSS, nombre o código hexadecimal",
"Box width" => "Ancho de la caja",
"In pixels or percentage. Default value is 100%" => "En píxeles o como porcentaje. Valor por defecto: 100",
"Text Alignment" => "Alineado del Texto",
// "Aligns the text within the box (left aligned by default)" => "Aligns the text within the box (left aligned by default)",
"Float Position" => "Posición Flotante",
// "Set the alignment for the entire box. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)" => "Set the alignment for the entire box. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)",
"Clear" => "Limpiar",
// "Items are not allowed to wrap around the box if this parameter is set to.1 (Yes)" => "Items are not allowed to wrap around the box if this parameter is set to.1 (Yes)",
"CSS Class" => "Clase CSS",
"Apply custom CSS class to the box" => "Aplicar una CSS adecuada a la caja",
// "Button" => "Button",
// "Add a link formatted as a button" => "Add a link formatted as a button",
"Url" => "Url",
// "URL to be produced by the button. You can use wiki argument variables like {{itemId}} in it" => "URL to be produced by the button. You can use wiki argument variables like {{itemId}} in it",
// "CSS class for the button" => "CSS class for the button",
"Label" => "Etiqueta",
// "Label for the button" => "Label for the button",
// "lib/smarty_tiki/function.button.php is missing or unreadable" => "lib/smarty_tiki/function.button.php is missing or unreadable",
// "Display a calendar and its events" => "Display a calendar and its events",
// "Calendar IDs" => "Calendar IDs",
// "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by commas (\",\")" => "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by commas (\",\")",
// "Example values" => "Example values",
// "Not set by default" => "Not set by default",
// "View Type" => "View Type",
// "Determines how to show events" => "Determines how to show events",
// "Possible values" => "Possible values",
// "\"table\" shows events in a calendar" => "\"table\" shows events in a calendar",
"List" => "Lista",
"Table" => "Tabla",
// "View Time Span" => "View Time Span",
// "If in calendar (or \"table\") view type, determines the time span displayed by the calendar" => "If in calendar (or \"table\") view type, determines the time span displayed by the calendar",
// "Default is month" => "Default is month",
// "Navigation Bar" => "Navigation Bar",
// "Decide or not to show the navigation bar (not shown by default)" => "Decide or not to show the navigation bar (not shown by default)",
// "Carousel" => "Carousel",
// "Display images in a self-advancing carousel" => "Display images in a self-advancing carousel",
// "File Gallery ID" => "File Gallery ID",
// "ID number of the file gallery that contains the images to be displayed" => "ID number of the file gallery that contains the images to be displayed",
// "Sort Mode" => "Sort Mode",
// "Sort by database table field name, ascending or descending. Examples: fileId_asc or name_desc" => "Sort by database table field name, ascending or descending. Examples: fileId_asc or name_desc",
// "Transition time" => "Transition time",
// "The time (in milliseconds) it will take to transition between two images" => "The time (in milliseconds) it will take to transition between two images",
// "number" => "number",
// "Display time" => "Display time",
// "The time (in milliseconds) to display each image" => "The time (in milliseconds) to display each image",
// "Caption height" => "Caption height",
// "The height of the caption. This is a fraction of the height of the images" => "The height of the caption. This is a fraction of the height of the images",
// "real between 0 and 1" => "real between 0 and 1",
// "Display progress ring" => "Display progress ring",
// "Display thumbnails" => "Display thumbnails",
// "Display thumbnails, number, count etc" => "Display thumbnails, number, count etc",
// "Buttons" => "Buttons",
// "Numbers" => "Numbers",
// "Thumbnail box width" => "Thumbnail box width",
// "Width of thumbnail box in CSS units (default \"20px\")" => "Width of thumbnail box in CSS units (default \"20px\")",
// "Thumbnail box height" => "Thumbnail box height",
// "Height of thumbnail box in CSS units (default \"20px\")" => "Height of thumbnail box in CSS units (default \"20px\")",
// "Start automatically" => "Start automatically",
// "Move the carousel automatically when the page loads (default Yes)" => "Move the carousel automatically when the page loads (default Yes)",
// "Legacy v2 param" => "Legacy v2 param",
// "Display place numbers in the thumbnail boxes" => "Display place numbers in the thumbnail boxes",
// "Use corresponding image as background for a thumbnail box" => "Use corresponding image as background for a thumbnail box",
// "Thumbnail box font size" => "Thumbnail box font size",
// "Font size of thumbnail box in CSS units (default \".7em\")" => "Font size of thumbnail box in CSS units (default \".7em\")",
// "Size of picture" => "Size of picture",
// "In case your picture is too large, you can specify a scale between 0 and 1 to reduce it" => "In case your picture is too large, you can specify a scale between 0 and 1 to reduce it",
// "Cart Missing User Info" => "Cart Missing User Info",
// "PluginCartMissingUserInfo" => "PluginCartMissingUserInfo",
// "Check if user still has missing info to enter" => "Check if user still has missing info to enter",
// "Type of Information" => "Type of Information",
// "Post Purchase" => "Post Purchase",
// "Required before purchase" => "Required before purchase",
// "Product Class ID" => "Product Class ID",
// "Missing parameters" => "Missing parameters",
// "List categories and objects assigned to them" => "List categories and objects assigned to them",
"Category IDs" => "IDs de las Categorías",
"List of category IDs separated by + signs. ex: 1+2+3. Default will use category of the current page" => "Lista de categorías separadas por IDs y el signo +. Ejemplo: 1+2+3. Por defecto se utilizará la categoría de la página actual",
"Types" => "Tipos",
// "List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal<br />+forum+igal+newsletter<br />+event+poll+quiz+survey<br />+tracker+wiki+img" => "List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal<br />+forum+igal+newsletter<br />+event+poll+quiz+survey<br />+tracker+wiki+img",
// "Sort ascending or descending based on various attributes (sorted ascending by name by default)" => "Sort ascending or descending based on various attributes (sorted ascending by name by default)",
// "Created Ascending" => "Created Ascending",
// "Created Descending" => "Created Descending",
// "Hits Ascending" => "Hits Ascending",
// "Hits Descending" => "Hits Descending",
// "Item ID Ascending" => "Item ID Ascending",
// "Item ID Descending" => "Item ID Descending",
// "Name Ascending" => "Name Ascending",
// "Name Descending" => "Name Descending",
// "Type Ascending" => "Type Ascending",
// "Type Descending" => "Type Descending",
// "Random" => "Random",
"Split" => "Separar",
// "Whether multiple categories will be listed on different lines (default is to split them)" => "Whether multiple categories will be listed on different lines (default is to split them)",
"And" => "Y",
// "If set to y (Yes), only objects in all of the categories will be shown (default is to show objects in any of the categories)" => "If set to y (Yes), only objects in all of the categories will be shown (default is to show objects in any of the categories)",
// "With Sub-categories" => "With Sub-categories",
// "Also list objects in sub-categories of the categories given (default is to list sub-category objects)" => "Also list objects in sub-categories of the categories given (default is to list sub-category objects)",
// "Show descriptions (not shown by default)" => "Show descriptions (not shown by default)",
// "Show Name" => "Show Name",
// "Show object names (shown by default)" => "Show object names (shown by default)",
// "Show type" => "Show type",
// "Show type (shown by default)" => "Show type (shown by default)",
// "One Per Line" => "One Per Line",
// "Show one object per line (multiple per line shown by default)" => "Show one object per line (multiple per line shown by default)",
// "Show Child Links" => "Show Child Links",
// "Show children category links (shown by default)" => "Show children category links (shown by default)",
// "Show Top Link" => "Show Top Link",
// "Show top category link (shown by default)" => "Show top category link (shown by default)",
// "Max Records" => "Max Records",
// "Maximum number of objects to list (default is 50)" => "Maximum number of objects to list (default is 50)",
// "Show Title" => "Show Title",
// "Show title text above category object lists (shown by default)" => "Show title text above category object lists (shown by default)",
// "List only objects in this language" => "List only objects in this language",
// "Only apply if type=wiki" => "Only apply if type=wiki",
"Categories are disabled" => "Las categorías están desactivadas",
// "PluginCategoryTransition" => "PluginCategoryTransition",
// "Displays controls to trigger category transitions for any object" => "Displays controls to trigger category transitions for any object",
// "Object Type" => "Object Type",
// "Object ID" => "Object ID",
// "Redirect URL" => "Redirect URL",
// "URL the user is sent to after transition is done" => "URL the user is sent to after transition is done",
"Category Orphans" => "Categorías Huérfanas",
// "List objects that are not categorized" => "List objects that are not categorized",
// "Currently, only works with wiki pages (set to wiki (Wiki Pages) by default)" => "Currently, only works with wiki pages (set to wiki (Wiki Pages) by default)",
"Max" => "Máx",
// "Maximum number of items. Use -1 for unlimited. Default is the site admin setting for maximum records" => "Maximum number of items. Use -1 for unlimited. Default is the site admin setting for maximum records",
// "Result Offset" => "Result Offset",
// "Result number at which the listing should start (default is no offset)" => "Result number at which the listing should start (default is no offset)",
// "Show the full category path for a wiki page" => "Show the full category path for a wiki page",
"Separator" => "Separador",
"String used to separate the categories in the path. Default character is >" => "Caracter utilizado para separar categorías en la ruta. Por defecto se utiliza el caracter >",
// "Display Top Category" => "Display Top Category",
// "Show the top category as part of the path name (not shown by default)" => "Show the top category as part of the path name (not shown by default)",
// "General purpose cclite utility plugin" => "General purpose cclite utility plugin",
// "Mode of operation - summary or recent. Default: summary" => "Mode of operation - summary or recent. Default: summary",
// "Account summary" => "Account summary",
// "Recent transactions" => "Recent transactions",
// "Registry" => "Registry",
// "Registry to query. Default: site preference (or first in list when more than one)" => "Registry to query. Default: site preference (or first in list when more than one)",
// "You need to be logged in to view this information" => "You need to be logged in to view this information",
// "Center text" => "Center text",
"Chart" => "Chart",
// "Display a chart from TikiSheet" => "Display a chart from TikiSheet",
"Chart caption" => "Título del gráfico",
"Sheet ID" => "Sheet ID",
"Data sheet ID" => "Data sheet ID",
"Chart Type" => "Tipo de gráfico",
"Chart Width" => "Ancho del gráfico",
"Width in pixels" => "Ancho en pixels",
"Chart Height" => "Alto del gráfico",
"Height in pixels" => "Alto pixels",
"Value series" => "Series de valores",
"Required for pie charts" => "Requerido por los gráficos de sectores",
"Independant series" => "Series independientes",
"Required for types other than pie chart" => "Requeridos por otros tipos de gráficos diferentes al de sectores",
"Dependant series" => "Series dependientes",
"List of colors to use" => "Lista de colores a utilizar",
"Styles" => "Estilos",
"List of styles to use" => "Lista de estilos a utilizar",
"Labels for the series or values in the legend" => "Etiquetas para las series o los valores en la leyenda",
"Chart as PDF" => "Gráfico como PDF",
"Chart as PostScript" => "Gráfico como PostScript",
"Code" => "Código",
// "Display code syntax with line numbers and color highlights" => "Display code syntax with line numbers and color highlights",
// "Code to be displayed" => "Code to be displayed",
"Caption" => "Título",
"Code snippet label" => "Trozo de código para la etiqueta",
// "Word Wrap" => "Word Wrap",
// "Enable word wrapping on the code to avoid breaking the layout" => "Enable word wrapping on the code to avoid breaking the layout",
// "Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus.." => "Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus..",
// "Line Numbers" => "Line Numbers",
// "Show line numbers for each line of code. May not be used with colors unless GeSHI is installed" => "Show line numbers for each line of code. May not be used with colors unless GeSHI is installed",
// "Right to Left" => "Right to Left",
// "Switch the text display from left to right to right to left  (left to right by default)" => "Switch the text display from left to right to right to left  (left to right by default)",
// "Code Tag" => "Code Tag",
// "Encloses the code in an HTML code tag, for example: &lt;code&gt;user input&lt;code&gt" => "Encloses the code in an HTML code tag, for example: &lt;code&gt;user input&lt;code&gt",
// "Colorbox" => "Colorbox",
// "Display a gallery of images in a popup slideshow" => "Display a gallery of images in a popup slideshow",
// "Image Gallery ID" => "Image Gallery ID",
// "ID number of the image gallery that contains the images to be displayed" => "ID number of the image gallery that contains the images to be displayed",
// "File ID Filter" => "File ID Filter",
// "Filter on fileIds in a file gallery to only show those images. Separate each fileId with ':'" => "Filter on fileIds in a file gallery to only show those images. Separate each fileId with ':'",
// "Thumb" => "Thumb",
// "Display as a thumbnail (y) or full size (n)" => "Display as a thumbnail (y) or full size (n)",
// "Show File Title" => "Show File Title",
// "Show file title" => "Show file title",
// "Show File Name" => "Show File Name",
// "Show file name" => "Show file name",
// "Show All Thumbs" => "Show All Thumbs",
// "Show thumbnails of all the images in the gallery" => "Show thumbnails of all the images in the gallery",
// "Parse Descriptions" => "Parse Descriptions",
// "Parse the file descriptions as wiki syntax" => "Parse the file descriptions as wiki syntax",
// "Display a comment area for any specified object" => "Display a comment area for any specified object",
// "The current wiki page you have added the plugin to" => "The current wiki page you have added the plugin to",
"Dynamic Content" => "Contenido dinámico",
// "Display content from dynamic content repository" => "Display content from dynamic content repository",
// "Content ID" => "Content ID",
// "Dynamic content ID. The value can be obtained in the listing" => "Dynamic content ID. The value can be obtained in the listing",
// "Content Label" => "Content Label",
// "Label of the dynamic content to display" => "Label of the dynamic content to display",
// "Contributions Dashboard" => "Contributions Dashboard",
// "List users contributions to your work" => "List users contributions to your work",
// "Notice" => "Notice",
// "Default Beginning Date" => "Default Beginning Date",
// "Default Ending Date" => "Default Ending Date",
// "Dashboard Types" => "Dashboard Types",
// "The type of charts that will be rendered seperated by comma" => "The type of charts that will be rendered seperated by comma",
// "Date Range" => "Date Range",
"Update" => "Actualizar",
// "Convene" => "Convene",
// "Convene an event with schedule and members" => "Convene an event with schedule and members",
// "Convene data generated from user input" => "Convene data generated from user input",
// "Title of Event" => "Title of Event",
// "Calendar ID" => "Calendar ID",
// "ID number for the site calendar where to store the date for the events with maximum votes" => "ID number for the site calendar where to store the date for the events with maximum votes",
// "Minimum Number of votes to show Add-to-Calendar icon" => "Minimum Number of votes to show Add-to-Calendar icon",
// "Minimum Number of votes needed to show Add-to-Calendar icon, so that new users do not see a potentially confusing icon before the convene has enough information on it" => "Minimum Number of votes needed to show Add-to-Calendar icon, so that new users do not see a potentially confusing icon before the convene has enough information on it",
// "Date and time format" => "Date and time format",
// "Display date and time in short or long format, according to the site wide setting" => "Display date and time in short or long format, according to the site wide setting",
// "Short" => "Short",
// "Long" => "Long",
// "Not ok" => "Not ok",
// "Unconfirmed" => "Unconfirmed",
// "Add User" => "Add User",
// "Add Date" => "Add Date",
// "Delete Date" => "Delete Date",
// "Edit User/Save changes" => "Edit User/Save changes",
// "Delete User" => "Delete User",
// "Selected Date" => "Selected Date",
// "Add as Calendar Event" => "Add as Calendar Event",
// "Add User & Date" => "Add User & Date",
// "Login to edit Convene" => "Login to edit Convene",
"Add" => "Añade",
"Cookie" => "Cookie",
// "Display a rotating set of taglines or quotes (also known as fortune cookies)" => "Display a rotating set of taglines or quotes (also known as fortune cookies)",
"Insert copyright notices" => "Inserta aviso de copyright",
// "Pattern to display the copyright in. May contain ~title~, ~year~ and ~authors~" => "Pattern to display the copyright in. May contain ~title~, ~year~ and ~authors~",
// "Countdown" => "Countdown",
// "Display a countdown to a specified date" => "Display a countdown to a specified date",
// "Text to append to the countdown" => "Text to append to the countdown",
// "Target date and time. Multiple formats accepted" => "Target date and time. Multiple formats accepted",
// "Items to Show" => "Items to Show",
// "Select: y=years, o=months, d=days, h=hours, m=minutes, s=seconds. \n\t\t\t\t\t\t\t\tEnter multiple values as: yodhms. Must be in the order of descending length, and a time unit should not be skipped. \n\t\t\t\t\t\t\t\tIf blank, the time is shown down to the hour if not zero" => "Select: y=years, o=months, d=days, h=hours, m=minutes, s=seconds. \n\t\t\t\t\t\t\t\tEnter multiple values as: yodhms. Must be in the order of descending length, and a time unit should not be skipped. \n\t\t\t\t\t\t\t\tIf blank, the time is shown down to the hour if not zero",
// "Years" => "Years",
// "Years, Months" => "Years, Months",
// "Years, Months, Days" => "Years, Months, Days",
// "Years, Months, Days, Hours" => "Years, Months, Days, Hours",
// "Years, Months, Days, Hours, Minutes" => "Years, Months, Days, Hours, Minutes",
// "Years, Months, Days, Hours, Minutes & Seconds" => "Years, Months, Days, Hours, Minutes & Seconds",
// "Months" => "Months",
// "Months, Days" => "Months, Days",
// "Months, Days, Hours" => "Months, Days, Hours",
// "Months, Days, Hours, Minutes" => "Months, Days, Hours, Minutes",
// "Months, Days, Hours, Minutes & Seconds" => "Months, Days, Hours, Minutes & Seconds",
"Days" => "Días",
// "Days & Hours" => "Days & Hours",
// "Days, Hours & Minutes" => "Days, Hours & Minutes",
// "Days, Hours, Minutes & Seconds" => "Days, Hours, Minutes & Seconds",
"Hours" => "Horas",
// "Hours & Minutes" => "Hours & Minutes",
// "Hours, Minutes & Seconds" => "Hours, Minutes & Seconds",
"Minutes" => "Minutos",
// "Minutes & Seconds" => "Minutes & Seconds",
// "Seconds" => "Seconds",
// "Calendar Days" => "Calendar Days",
// "Will use calendar day difference when set to Yes (y) and time units are not shown. \n\t\t\t\t\t\t\t\tResult is that tomorrow, for example, is always shown as a one day away even if less than 24 hours from now. No (n) is the default" => "Will use calendar day difference when set to Yes (y) and time units are not shown. \n\t\t\t\t\t\t\t\tResult is that tomorrow, for example, is always shown as a one day away even if less than 24 hours from now. No (n) is the default",
// "Handle Past Events" => "Handle Past Events",
// "If Yes (y), will display amount of time since the event (default). \n\t\t\t\t\t\t\t\tIf No (n) and if there is body text, will display \"is over\" or custom text set in text parameter after body text" => "If Yes (y), will display amount of time since the event (default). \n\t\t\t\t\t\t\t\tIf No (n) and if there is body text, will display \"is over\" or custom text set in text parameter after body text",
"Text" => "Texto",
// "Text that will show with the countdown and body text. \n\t\t\t\t\t\t\t\tSet to \"default\" or leave empty to show \"xxx days until/since [body text]\", except that if\n\t\t\t\t\t\t\t\t the since parameter is set to No (n), \"[body text] is over\" will show after the end date has passed.\n\t\t\t\t\t\t\t\tAlso, if no time is shown because of the time units being displayed (for example, only years are shown and it's\n\t\t\t\t\t\t\t\tless than a year before/after the end date) then \"[body text] will happen in less than a year/happened in the last year\" will show.\n\t\t\t\t\t\t\t\tOr set pipe-separated custom text as follows: before date|before date by less than shortest time unit shown|after date\n\t\t\t\t\t\t\t\t|after date by less than shortest time unit shown|after date and since set to No (n).\n\t\t\t\t\t\t\t\tSet to silent for no text" => "Text that will show with the countdown and body text. \n\t\t\t\t\t\t\t\tSet to \"default\" or leave empty to show \"xxx days until/since [body text]\", except that if\n\t\t\t\t\t\t\t\t the since parameter is set to No (n), \"[body text] is over\" will show after the end date has passed.\n\t\t\t\t\t\t\t\tAlso, if no time is shown because of the time units being displayed (for example, only years are shown and it's\n\t\t\t\t\t\t\t\tless than a year before/after the end date) then \"[body text] will happen in less than a year/happened in the last year\" will show.\n\t\t\t\t\t\t\t\tOr set pipe-separated custom text as follows: before date|before date by less than shortest time unit shown|after date\n\t\t\t\t\t\t\t\t|after date by less than shortest time unit shown|after date and since set to No (n).\n\t\t\t\t\t\t\t\tSet to silent for no text",
// "default, silent, custom: before event|after event|after event when time not shown" => "default, silent, custom: before event|after event|after event when time not shown",
// "Thousands Separator" => "Thousands Separator",
// "Set the thousands separator for results of 1,000 or more. \n\t\t\t\t\t\t\t\tChoices are comma (c), decimal (d), space (s), or leave blank for no separator" => "Set the thousands separator for results of 1,000 or more. \n\t\t\t\t\t\t\t\tChoices are comma (c), decimal (d), space (s), or leave blank for no separator",
// "Comma" => "Comma",
// "Period" => "Period",
// "Space" => "Space",
// "COUNTDOWN: Missing \"enddate\" parameter for plugin" => "COUNTDOWN: Missing \"enddate\" parameter for plugin",
"and" => "y",
// "will happen in less than a year" => "will happen in less than a year",
// "will happen in less than a month" => "will happen in less than a month",
// "will happen in less than a day" => "will happen in less than a day",
// "will happen in less than an hour" => "will happen in less than an hour",
// "will happen in less than a minute" => "will happen in less than a minute",
// "is happening this second" => "is happening this second",
// "happened in the last year" => "happened in the last year",
// "happened in the last month" => "happened in the last month",
// "happened in the last day" => "happened in the last day",
// "happened in the last hour" => "happened in the last hour",
// "happened in the last minute" => "happened in the last minute",
// "until" => "until",
"since" => "desde",
// "is over" => "is over",
// "Custom Search" => "Custom Search",
// "Custom Search Interface that displays results using the LIST plugin" => "Custom Search Interface that displays results using the LIST plugin",
// "LIST plugin configuration information" => "LIST plugin configuration information",
// "Template wiki page" => "Template wiki page",
// "Wiki page where search user interface template is found" => "Wiki page where search user interface template is found",
// "Alphanumeric Unique Identifier for search" => "Alphanumeric Unique Identifier for search",
// "A unique identifier to distinguish custom searches for storing of previous search criteria entered by users" => "A unique identifier to distinguish custom searches for storing of previous search criteria entered by users",
// "Autotrigger AJAX search on criteria change" => "Autotrigger AJAX search on criteria change",
// "Delay in milliseconds before automatically triggering search after change (0 disables)" => "Delay in milliseconds before automatically triggering search after change (0 disables)",
// "Div to fade when AJAX search in progress" => "Div to fade when AJAX search in progress",
// "The specific ID of the specific div to fade out when AJAX search is in progress, if not set will attempt to fade the whole area or if failing simply show the spinner" => "The specific ID of the specific div to fade out when AJAX search is in progress, if not set will attempt to fade the whole area or if failing simply show the spinner",
// "Return users to same search parameters on coming back to the search page after leaving" => "Return users to same search parameters on coming back to the search page after leaving",
// "In the same session, return users to same search parameters on coming back to the search page after leaving" => "In the same session, return users to same search parameters on coming back to the search page after leaving",
// "Custom JavaScript wiki page" => "Custom JavaScript wiki page",
// "The wiki page on which custom JavaScript that is to be executed on return of AJAX results" => "The wiki page on which custom JavaScript that is to be executed on return of AJAX results",
// "Destination Div" => "Destination Div",
// "Id of a pre-existing div to contain the search results" => "Id of a pre-existing div to contain the search results",
// "Search On Load" => "Search On Load",
// "Execute the search when the page loads (default: Yes)" => "Execute the search when the page loads (default: Yes)",
// "Template is not specified" => "Template is not specified",
// "Template page not found" => "Template page not found",
// "Searching.." => "Searching..",
// "_group is needed to be set if _style is checkbox or radio" => "_group is needed to be set if _style is checkbox or radio",
// "Data Channel" => "Data Channel",
// "Display a form to access data channels" => "Display a form to access data channels",
// "List of fields to display. One field per line. Comma delimited: fieldname,label" => "List of fields to display. One field per line. Comma delimited: fieldname,label",
// "To use values from other forms on the same page as parameters for the data-channel use \"fieldname, external=fieldid\"" => "To use values from other forms on the same page as parameters for the data-channel use \"fieldname, external=fieldid\"",
// "Where \"fieldid\" is the id (important) of the external input to use, and \"fieldname\" is the name of the parameter in the data-channel" => "Where \"fieldid\" is the id (important) of the external input to use, and \"fieldname\" is the name of the parameter in the data-channel",
// "To use fixed hidden preset values use \"fieldname, hidden=value.\"" => "To use fixed hidden preset values use \"fieldname, hidden=value.\"",
// "Channel Name" => "Channel Name",
// "Name of the channel as registered by the administrator" => "Name of the channel as registered by the administrator",
// "Return URL" => "Return URL",
// "URL to go to after data channel has run. Defaults to current page" => "URL to go to after data channel has run. Defaults to current page",
// "Do not use returnURI but instead return true quietly" => "Do not use returnURI but instead return true quietly",
// "If set to y, will return quietly after data channel has run which would be needed if plugin is used in non-wiki page context" => "If set to y, will return quietly after data channel has run which would be needed if plugin is used in non-wiki page context",
// "Button Label" => "Button Label",
// "Label for the submit button. Default: \"Go\"" => "Label for the submit button. Default: \"Go\"",
// "CSS class for this form" => "CSS class for this form",
// "Empty Caches" => "Empty Caches",
// "Which caches to empty. Default \"Clear all Tiki caches\"" => "Which caches to empty. Default \"Clear all Tiki caches\"",
// "Clear all Tiki caches" => "Clear all Tiki caches",
// "All user prefs sessions" => "All user prefs sessions",
// "Price to execute the datachannel (%0)" => "Price to execute the datachannel (%0)",
// "Payment Label" => "Payment Label",
// "Debug" => "Debug",
// "Be careful, if debug is on, the page will not be refreshed and previous modules can be obsolete (not on by default)" => "Be careful, if debug is on, the page will not be refreshed and previous modules can be obsolete (not on by default)",
// "Multiple Values" => "Multiple Values",
// "Accept arrays of multiple values in the POST. e.g. itemId[]=42&itemId=43 etc. (multiple values not accepted by default)" => "Accept arrays of multiple values in the POST. e.g. itemId[]=42&itemId=43 etc. (multiple values not accepted by default)",
// "Datachannel" => "Datachannel",
// "DB Report" => "DB Report",
// "Query a database and display results (only works with ADOdb, does not work with PDO)" => "Query a database and display results (only works with ADOdb, does not work with PDO)",
// "report definition" => "report definition",
// "Full DSN" => "Full DSN",
// "A full DSN (Data Source Name) connection string. eg: mysql://user:pass@server/database" => "A full DSN (Data Source Name) connection string. eg: mysql://user:pass@server/database",
// "Wiki DSN Name" => "Wiki DSN Name",
// "The name of a DSN connection defined by the Wiki administrator" => "The name of a DSN connection defined by the Wiki administrator",
"Wiki Syntax" => "Sintaxis Wiki",
// "Parse wiki syntax within the report (not parsed by default)" => "Parse wiki syntax within the report (not parsed by default)",
// "Display the parsed report definition (not displayed by default)" => "Display the parsed report definition (not displayed by default)",
// "Missing db or dsn parameter" => "Missing db or dsn parameter",
// "No DSN connection string found" => "No DSN connection string found",
// "Run a database report" => "Run a database report",
// "Dialog" => "Dialog",
// "Create a jQuery-UI dialog" => "Create a jQuery-UI dialog",
// "Button labels separated by commas" => "Button labels separated by commas",
// "Button actions" => "Button actions",
// "JS to perform on 1st button click" => "JS to perform on 1st button click",
// "Dialog width" => "Dialog width",
// "HTML ID" => "HTML ID",
// "Automatically generated if left empty in the form \"wpdialog_XX\" (must be unique per page)" => "Automatically generated if left empty in the form \"wpdialog_XX\" (must be unique per page)",
// "Show animation" => "Show animation",
// "Hide animation" => "Hide animation",
// "Auto open" => "Auto open",
// "y/n" => "y/n",
// "Modal" => "Modal",
// "Wiki page to use as dialog body" => "Wiki page to use as dialog body",
// "Open Action" => "Open Action",
// "JS to execute when dialog opens" => "JS to execute when dialog opens",
// "Div" => "Div",
// "Define and format sections of a page or text" => "Define and format sections of a page or text",
// "Indicate the type of HTML tag to use (default is div)" => "Indicate the type of HTML tag to use (default is div)",
// "Span" => "Span",
"Pre" => "Pre",
// "Teletype" => "Teletype",
// "Paragraph" => "Paragraph",
// "Block quote" => "Block quote",
// "In pixels or percentage. Default is original size" => "In pixels or percentage. Default is original size",
// "Aligns the text within the element" => "Aligns the text within the element",
// "Justify" => "Justify",
// "Set the alignment for the entire element. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)" => "Set the alignment for the entire element. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)",
// "Items are not allowed to wrap around the side(s) this parameter is set to" => "Items are not allowed to wrap around the side(s) this parameter is set to",
// "Apply custom CSS class to the div" => "Apply custom CSS class to the div",
// "Sets the div's id attribute, as defined by HTML" => "Sets the div's id attribute, as defined by HTML",
// "Title attribute" => "Title attribute",
// "Title for the div, usually displayed as a tooltip" => "Title for the div, usually displayed as a tooltip",
// "Definition List" => "Definition List",
// "Create a definition list" => "Create a definition list",
// "One entry per line. Each line is in \"Term: Definition\" format" => "One entry per line. Each line is in \"Term: Definition\" format",
// "Draw" => "Draw",
// "Display or create an image from TikiDraw that is stored into the File Gallery" => "Display or create an image from TikiDraw that is stored into the File Gallery",
// "Drawing ID" => "Drawing ID",
// "Internal ID of the file id" => "Internal ID of the file id",
// "Width in pixels or percentage. Default value is page width. e.g. \"200px\" or \"100%\"" => "Width in pixels or percentage. Default value is page width. e.g. \"200px\" or \"100%\"",
// "Height in pixels or percentage. Default value is complete drawing height" => "Height in pixels or percentage. Default value is complete drawing height",
// "Force Display Archive" => "Force Display Archive",
// "The latest revision of file is automatically shown, by setting archive to y, it bypasses this check and shows the archive rather than the latest revision" => "The latest revision of file is automatically shown, by setting archive to y, it bypasses this check and shows the archive rather than the latest revision",
// "Draw New SVG Image" => "Draw New SVG Image",
// "Edit SVG Image" => "Edit SVG Image",
// " in " => " in ",
"File not found" => "Archivo no encontrado",
// "Equation" => "Equation",
// "Render an equation written in LaTeX syntax as an image" => "Render an equation written in LaTeX syntax as an image",
// "equation" => "equation",
// "Size expressed as a percentage of the normal size. 100 produces the default size. 200 produces an image twice as large" => "Size expressed as a percentage of the normal size. 100 produces the default size. 200 produces an image twice as large",
"Events" => "Eventos",
// "Display upcoming events from calendars" => "Display upcoming events from calendars",
// "ID numbers for the site calendars whose events are to be displayed, separated by vertical bars (|)" => "ID numbers for the site calendars whose events are to be displayed, separated by vertical bars (|)",
// "Maximum Days" => "Maximum Days",
// "Events occurring within this number of days in the future from today will be included in the list (unless limited by other parameter settings). Default is 365 days" => "Events occurring within this number of days in the future from today will be included in the list (unless limited by other parameter settings). Default is 365 days",
// "Maximum Events" => "Maximum Events",
// "Maximum number of events to display. Default is 10. Set to 0 to display all (unless limited by other parameter settings)" => "Maximum number of events to display. Default is 10. Set to 0 to display all (unless limited by other parameter settings)",
// "Show Time" => "Show Time",
// "Show the time along with the date (shown by default)" => "Show the time along with the date (shown by default)",
// "Show the description of the event (shown by default)" => "Show the description of the event (shown by default)",
// "Exercise" => "Exercise",
// "PluginExercise" => "PluginExercise",
// "Creates exercises within a wiki page for students to test their new skills. The plugin allows to define inline questions and optional answers to be selected from. A score is given for multiple exercises within a page" => "Creates exercises within a wiki page for students to test their new skills. The plugin allows to define inline questions and optional answers to be selected from. A score is given for multiple exercises within a page",
"Answer" => "Respuesta",
// "Used inline to specify the right answer to the question and propose an input field" => "Used inline to specify the right answer to the question and propose an input field",
// "Incorrect" => "Incorrect",
// "Alternative answers to provide" => "Alternative answers to provide",
// "Check your score" => "Check your score",
// "You scored %0 out of %1" => "You scored %0 out of %1",
// "Good" => "Good",
// "Oops" => "Oops",
// "Extend Cart Inventory Hold" => "Extend Cart Inventory Hold",
// "PluginExtendCartHold" => "PluginExtendCartHold",
// "Extends the time that items are held in the shop before timing out" => "Extends the time that items are held in the shop before timing out",
// "Create a link that shows/hides initially hidden content" => "Create a link that shows/hides initially hidden content",
// "Wiki syntax containing the content that can be hidden or shown" => "Wiki syntax containing the content that can be hidden or shown",
// "Label for link that shows and hides the content when clicked" => "Label for link that shows and hides the content when clicked",
// "Unspecified label" => "Unspecified label",
// "Arrow icon showing that content can be hidden or shown" => "Arrow icon showing that content can be hidden or shown",
// "Show Speed" => "Show Speed",
// "Speed of animation in milliseconds when showing content (200 is fast and 600 is slow. 1000 equals 1 second)" => "Speed of animation in milliseconds when showing content (200 is fast and 600 is slow. 1000 equals 1 second)",
// "Integer greater than 0 and less than or equal to 1000, or 'fast' or 'slow'" => "Integer greater than 0 and less than or equal to 1000, or 'fast' or 'slow'",
// "Hide Speed" => "Hide Speed",
// "Speed of animation in milliseconds when hiding content (200 is fast and 600 is slow. 1000 equals 1 second)" => "Speed of animation in milliseconds when hiding content (200 is fast and 600 is slow. 1000 equals 1 second)",
// "Fancy List" => "Fancy List",
// "Create a fancy-looking list" => "Create a fancy-looking list",
// "One item per line starting with anything followed by \")\"" => "One item per line starting with anything followed by \")\"",
// "Use Div" => "Use Div",
// "Use the HTML tag div instead of the HTML tag for lists (ol)" => "Use the HTML tag div instead of the HTML tag for lists (ol)",
// "CSS class for the fancylist" => "CSS class for the fancylist",
// "Fancy Table" => "Fancy Table",
// "Create a formatted table" => "Create a formatted table",
// "Rows separated by >> in the header; for the table body, one row per line. Cells separated by | in both cases" => "Rows separated by >> in the header; for the table body, one row per line. Cells separated by | in both cases",
// "Heading Row" => "Heading Row",
// "Header rows of the table. Use >> to separate multiple rows" => "Header rows of the table. Use >> to separate multiple rows",
// "Heading CSS Class" => "Heading CSS Class",
// "CSS class to apply to the heading row" => "CSS class to apply to the heading row",
// "Header Horizontal Align" => "Header Horizontal Align",
// "Horizontal alignments for header cells separated by |. Choices: left, right, center, justify" => "Horizontal alignments for header cells separated by |. Choices: left, right, center, justify",
// "Header Vertical Align" => "Header Vertical Align",
// "Vertical alignments for header cells separated by |. Choices: top, middle, bottom, baseline" => "Vertical alignments for header cells separated by |. Choices: top, middle, bottom, baseline",
// "Column Sort" => "Column Sort",
// "Indicate whether columns are sortable or not (not sortable by default)" => "Indicate whether columns are sortable or not (not sortable by default)",
// "Pre-sorted Columns" => "Pre-sorted Columns",
// "Bracketed numbers for column number and sort direction (0 = ascending, 1 = descending), for example: [0,0],[1,0]" => "Bracketed numbers for column number and sort direction (0 = ascending, 1 = descending), for example: [0,0],[1,0]",
// "Column Widths" => "Column Widths",
// "Column widths followed by px for pixels or % for percentages. Each column separated by |" => "Column widths followed by px for pixels or % for percentages. Each column separated by |",
// "Cell Horizontal Align" => "Cell Horizontal Align",
// "Table body column horizontal alignments separated by |. Choices: left, right, center, justify" => "Table body column horizontal alignments separated by |. Choices: left, right, center, justify",
// "Cell Vertical Align" => "Cell Vertical Align",
// "Table body column vertical alignments separated by |. Choices: top, middle, bottom, baseline" => "Table body column vertical alignments separated by |. Choices: top, middle, bottom, baseline",
// "The feature must be activated" => "The feature must be activated",
// "Shows if item is user favorite or not and provide the way to set it" => "Shows if item is user favorite or not and provide the way to set it",
// "Link to a file that's attached or in a file gallery or archive. See PluginFiles for more functionality" => "Link to a file that's attached or in a file gallery or archive. See PluginFiles for more functionality",
// "Label for the link to the file (ignored if the file is a wiki attachment)" => "Label for the link to the file (ignored if the file is a wiki attachment)",
// "Indicate whether the file is in a file gallery or is a wiki page attachment" => "Indicate whether the file is in a file gallery or is a wiki page attachment",
// "Identify an attachment by entering its file name, which will show as a link to the file.\n\t\t\t\t\t\t\t\t If the page parameter is empty, it must be a file name of an attachment to the page where the plugin is used" => "Identify an attachment by entering its file name, which will show as a link to the file.\n\t\t\t\t\t\t\t\t If the page parameter is empty, it must be a file name of an attachment to the page where the plugin is used",
// "Custom Description" => "Custom Description",
// "Custom text that will be used for the link instead of the file name or file description" => "Custom text that will be used for the link instead of the file name or file description",
// "Name of the wiki page the file is attached to. Defaults to the wiki page where the plugin is used if empty" => "Name of the wiki page the file is attached to. Defaults to the wiki page where the plugin is used if empty",
// "Attachment Description" => "Attachment Description",
// "Show the attachment description as the link label instead of the attachment file name" => "Show the attachment description as the link label instead of the attachment file name",
// "Indicates that this attachment is an image, and should be displayed inline using the img tag" => "Indicates that this attachment is an image, and should be displayed inline using the img tag",
// "File ID" => "File ID",
// "File ID of a file in a file gallery or an archive" => "File ID of a file in a file gallery or an archive",
// "Example value" => "Example value",
// "For an archive file, the archive created just before this date will be linked to. Special values : PAGE_LAST_MOD and PAGE_VIEW_DATE" => "For an archive file, the archive created just before this date will be linked to. Special values : PAGE_LAST_MOD and PAGE_VIEW_DATE",
// "Show Icon" => "Show Icon",
// "Show an icon version of the file or file type with the link to the file" => "Show an icon version of the file or file type with the link to the file",
// "File Gallery File/Archive" => "File Gallery File/Archive",
// "Wiki Page Attachment" => "Wiki Page Attachment",
// "The date has not been set" => "The date has not been set",
// "Incorrect date format" => "Incorrect date format",
// "No such file" => "No such file",
// "Wiki attachments are disabled" => "Wiki attachments are disabled",
// "List files by ID, gallery or category, or show a slideshow of image files" => "List files by ID, gallery or category, or show a slideshow of image files",
// "Title for the file listing, or the link text when slideshow = y" => "Title for the file listing, or the link text when slideshow = y",
// "File Galleries ID" => "File Galleries ID",
// "To list only files contained in these file galleries (multiple IDs separated by colon)" => "To list only files contained in these file galleries (multiple IDs separated by colon)",
// "Or enter a username for user files (hint: enter {{user}} for current logged in user)" => "Or enter a username for user files (hint: enter {{user}} for current logged in user)",
// "To restrict files listed to those belonging to one or more categories. Enter a single category or ID or list of them separated by colon" => "To restrict files listed to those belonging to one or more categories. Enter a single category or ID or list of them separated by colon",
// "To list only specified files, enter their file IDs separated by colon" => "To list only specified files, enter their file IDs separated by colon",
// "Order ascending or descending based on any field in the file gallery table. Default is name_asc" => "Order ascending or descending based on any field in the file gallery table. Default is name_asc",
// "Show Action" => "Show Action",
// "Show a column with icons for the various actions the user can take with each file (not shown by default)" => "Show a column with icons for the various actions the user can take with each file (not shown by default)",
// "Show Find" => "Show Find",
// "Show a search box above the list (not shown by default)" => "Show a search box above the list (not shown by default)",
// "Show the title of the file gallery (shown by default). Also shown on slide show pop up window if a single galleryId is used" => "Show the title of the file gallery (shown by default). Also shown on slide show pop up window if a single galleryId is used",
// "Show ID" => "Show ID",
// "Show the ID number of each file (shown by default)" => "Show the ID number of each file (shown by default)",
// "Show an icon for each file depicting the file type" => "Show an icon for each file depicting the file type",
// "Show the name given to the file upon upload into the file gallery (shown by default). Set to Yes (y) to show as a caption in a slide show" => "Show the name given to the file upon upload into the file gallery (shown by default). Set to Yes (y) to show as a caption in a slide show",
// "Show Filename" => "Show Filename",
// "Show each file's filename (shown by default except in slide show). Set to Yes (y) to show as a caption in a slide show" => "Show each file's filename (shown by default except in slide show). Set to Yes (y) to show as a caption in a slide show",
// "Show Size" => "Show Size",
// "Show the size of each file in kilobytes (shown by default except in slide show)" => "Show the size of each file in kilobytes (shown by default except in slide show)",
// "Show the description of the file given upon upload into the file gallery (shown by default except in slide show). Set to Yes (y) to show as a caption in a slide show" => "Show the description of the file given upon upload into the file gallery (shown by default except in slide show). Set to Yes (y) to show as a caption in a slide show",
// "Show Creation Date" => "Show Creation Date",
// "Show the date each file was created (not shown by default)" => "Show the date each file was created (not shown by default)",
// "Show Last Modification Date" => "Show Last Modification Date",
// "Show the date each file was last modified (shown by default)" => "Show the date each file was last modified (shown by default)",
// "Show Hits" => "Show Hits",
// "Show the number of hits each file has received (not shown by default)" => "Show the number of hits each file has received (not shown by default)",
// "Show Locked By" => "Show Locked By",
// "For locked files, show the user name of the user who locked it (not shown by default)" => "For locked files, show the user name of the user who locked it (not shown by default)",
// "Show the user name of the user who is the author of the file (not shown by default)" => "Show the user name of the user who is the author of the file (not shown by default)",
// "Show Creator" => "Show Creator",
// "Show the user name of the user who is the creator of the file (not shown by default)" => "Show the user name of the user who is the creator of the file (not shown by default)",
// "Show Parent Gallery Name" => "Show Parent Gallery Name",
// "Show the name of the parent gallery" => "Show the name of the parent gallery",
// "Show File Count" => "Show File Count",
// "For galleries included in the list (where the file gallery includes other galleries), show the number of files in each of those galleries (not shown by default)" => "For galleries included in the list (where the file gallery includes other galleries), show the number of files in each of those galleries (not shown by default)",
// "Show Slideshow" => "Show Slideshow",
// "Show a link that produces a pop-up slide show when clicked (not set by default)" => "Show a link that produces a pop-up slide show when clicked (not set by default)",
// "Slideshow Width" => "Slideshow Width",
// "Set width of slideshow popup" => "Set width of slideshow popup",
// "Slideshow Height" => "Slideshow Height",
// "Set height of slideshow popup" => "Set height of slideshow popup",
// "Show Comment" => "Show Comment",
// "Show comments for each file (not shown by default)" => "Show comments for each file (not shown by default)",
// "Show Last Editor" => "Show Last Editor",
// "Show the user name of the user who last modified the file (shown by default)" => "Show the user name of the user who last modified the file (shown by default)",
// "Show Image Thumb" => "Show Image Thumb",
// "Show Image thumb" => "Show Image thumb",
// "Show only files created by this user" => "Show only files created by this user",
// "Show Upload" => "Show Upload",
// "Show a simple upload form to the gallery (not shown by default)" => "Show a simple upload form to the gallery (not shown by default)",
// "Number of rows (default: -1 = all)" => "Number of rows (default: -1 = all)",
// "Recursive" => "Recursive",
// "With sub-galleries" => "With sub-galleries",
// "Flash Video" => "Flash Video",
// "Embed a video or audio file" => "Embed a video or audio file",
// "Flash Type" => "Flash Type",
// "Whether you want to insert a Flash from a URL, a fileId from a podcast file gallery or a link to a specific service like Youtube or Vimeo" => "Whether you want to insert a Flash from a URL, a fileId from a podcast file gallery or a link to a specific service like Youtube or Vimeo",
// "Select an option" => "Select an option",
// "Blip.tv" => "Blip.tv",
// "File Gallery Podcast" => "File Gallery Podcast",
// "Movie URL" => "Movie URL",
// "Vimeo" => "Vimeo",
// "Youtube" => "Youtube",
// "Complete URL to the movie to include. e.g. files/test.swf" => "Complete URL to the movie to include. e.g. files/test.swf",
// "File Gallery Podcast ID" => "File Gallery Podcast ID",
// "Id of a file from a podcast gallery - will work only with podcast gallery" => "Id of a file from a podcast gallery - will work only with podcast gallery",
// "YouTube URL" => "YouTube URL",
// "Entire URL to the YouTube video" => "Entire URL to the YouTube video",
// "Vimeo URL" => "Vimeo URL",
// "Entire URL to the Vimeo video" => "Entire URL to the Vimeo video",
// "Blip.tv URL" => "Blip.tv URL",
// "Blip.tv embed URL" => "Blip.tv embed URL",
// "Width of movie in pixels (default is 425)" => "Width of movie in pixels (default is 425)",
// "Height of movie in pixels (default is 350)" => "Height of movie in pixels (default is 350)",
// "Quality" => "Quality",
// "Flash video quality. Default value: high" => "Flash video quality. Default value: high",
"High" => "Alto/a",
"Medium" => "Medio/a",
"Low" => "Bajo/a",
// "Alternative image URL" => "Alternative image URL",
// "Image to display if Flash is not available" => "Image to display if Flash is not available",
// "Invalid URL" => "Invalid URL",
// "Missing parameter movie to the plugin flash" => "Missing parameter movie to the plugin flash",
// "FONT" => "FONT",
// "Experimental: Font family and font size" => "Experimental: Font family and font size",
"Content" => "Contenido",
// "Font Family" => "Font Family",
// "Select the font family to display the content" => "Select the font family to display the content",
// "Font Size" => "Font Size",
// "Define the size of the font in pixels (enter '12' to get a font of 12px)" => "Define the size of the font in pixels (enter '12' to get a font of 12px)",
// "Footnote" => "Footnote",
// "Create automatically numbered footnotes (together with PluginFootnoteArea)" => "Create automatically numbered footnotes (together with PluginFootnoteArea)",
// "The footnote" => "The footnote",
// "Sameas" => "Sameas",
// "Tag to existing footnote" => "Tag to existing footnote",
// "Footnote Area" => "Footnote Area",
// "Create automatically numbered footnotes (together with PluginFootnote)" => "Create automatically numbered footnotes (together with PluginFootnote)",
// "Freetagged" => "Freetagged",
// "List similarly tagged objects" => "List similarly tagged objects",
// "Tags to find similar to" => "Tags to find similar to",
// "Leave blank to use the object's own tags" => "Leave blank to use the object's own tags",
// "Type of objects to extract. Set to All to find all types" => "Type of objects to extract. Set to All to find all types",
// "Same" => "Same",
// "Faqs" => "Faqs",
// "Offset" => "Offset",
// "Start record" => "Start record",
// "Default -1 (all)" => "Default -1 (all)",
// "Choose from:  objectId, type, itemId, description, created, name, href, hits, comments_locked (Default: created_desc)" => "Choose from:  objectId, type, itemId, description, created, name, href, hits, comments_locked (Default: created_desc)",
// "Comments Locked Ascending" => "Comments Locked Ascending",
// "Comments Locked Descending" => "Comments Locked Descending",
// "Description Ascending" => "Description Ascending",
// "Description Descending" => "Description Descending",
// "Href Ascending" => "Href Ascending",
// "Href Descending" => "Href Descending",
// "Object ID Ascending" => "Object ID Ascending",
// "Object ID Descending" => "Object ID Descending",
// "Show objects with names or descriptions similar to the text entered here" => "Show objects with names or descriptions similar to the text entered here",
// "Broaden" => "Broaden",
// "n|y" => "n|y",
// "Choose the header level for formatting. Default is 3 (for header level h3). Set to -1 for no header tags" => "Choose the header level for formatting. Default is 3 (for header level h3). Set to -1 for no header tags",
// "Show Titles Only" => "Show Titles Only",
// "Choose whether to show titles only (not shown by default)" => "Choose whether to show titles only (not shown by default)",
// "Maximum Image Size" => "Maximum Image Size",
// "Height or width in pixels. Default = 0 (no maximum)" => "Height or width in pixels. Default = 0 (no maximum)",
// "FTP" => "FTP",
// "Create a button for downloading a file from an FTP server" => "Create a button for downloading a file from an FTP server",
// "file name" => "file name",
// "Server Name" => "Server Name",
// "Name of the server where the FTP account is housed. Example: " => "Name of the server where the FTP account is housed. Example: ",
// "User name needed to access the FTP account" => "User name needed to access the FTP account",
// "Password needed to access the FTP account" => "Password needed to access the FTP account",
// "Download Button Label" => "Download Button Label",
// "Label for the FTP download button" => "Label for the FTP download button",
// "missing parameters" => "missing parameters",
// "Connection failed" => "Connection failed",
// "Galleriffic" => "Galleriffic",
// "Displays images in galleriffic" => "Displays images in galleriffic",
// "Thumbs div width" => "Thumbs div width",
// "Width in pixels or percentage. (e.g. \"200px\" or \"100%\")" => "Width in pixels or percentage. (e.g. \"200px\" or \"100%\")",
// "Image slideshow width" => "Image slideshow width",
// "Width in pixels or percentage of the largest image. (e.g. \"200px\" or \"100%\")" => "Width in pixels or percentage of the largest image. (e.g. \"200px\" or \"100%\")",
// "Image slideshow height" => "Image slideshow height",
// "Height in pixels or percentage of the largest images. (e.g. \"200px\" or \"100%\")" => "Height in pixels or percentage of the largest images. (e.g. \"200px\" or \"100%\")",
// "Start Slideshow" => "Start Slideshow",
// "Automatically start the slideshow" => "Automatically start the slideshow",
// "Delay" => "Delay",
// "Delay in milliseconds between each transition" => "Delay in milliseconds between each transition",
// "Number of Thumbnails" => "Number of Thumbnails",
// "The number of thumbnails to show per page" => "The number of thumbnails to show per page",
// "Show top pager" => "Show top pager",
// "Display thumbnail pager at top" => "Display thumbnail pager at top",
// "Show bottom pager" => "Show bottom pager",
// "Display thumbnail pager at bottom" => "Display thumbnail pager at bottom",
// "Play Slideshow" => "Play Slideshow",
// "Pause SlideShow" => "Pause SlideShow",
// "Previous Photo" => "Previous Photo",
// "Next Photo" => "Next Photo",
// "Gauge" => "Gauge",
// "Display a horizontal bar gauge" => "Display a horizontal bar gauge",
"description" => "descripción",
// "Current value to be represented by the gauge" => "Current value to be represented by the gauge",
// "Maximum Value" => "Maximum Value",
// "Maximum possible value. Default: 100" => "Maximum possible value. Default: 100",
// "Label displayed on the left side of the gauge" => "Label displayed on the left side of the gauge",
// "Color" => "Color",
// "Main color of the gauge. Use HTML color codes or names" => "Main color of the gauge. Use HTML color codes or names",
// "Background color of the gauge. Use HTML color codes or names" => "Background color of the gauge. Use HTML color codes or names",
// "Bar width in pixels" => "Bar width in pixels",
// "Label Width" => "Label Width",
// "Width in pixels allocated to the label" => "Width in pixels allocated to the label",
// "Display Percentage" => "Display Percentage",
// "Set to true (Yes) to display a percentage of the maximum" => "Set to true (Yes) to display a percentage of the maximum",
// "Display Value" => "Display Value",
// "Set to false (No) to hide the numeric value (shown by default)" => "Set to false (No) to hide the numeric value (shown by default)",
// "Bar height in pixels" => "Bar height in pixels",
// "Get Security Token" => "Get Security Token",
// "PluginGetAccessToken" => "PluginGetAccessToken",
// "Get security token for specified parameters" => "Get security token for specified parameters",
// "Entry point path or part of it" => "Entry point path or part of it",
// "The path of part of the path for which the token is for" => "The path of part of the path for which the token is for",
// "Query string parameter keys" => "Query string parameter keys",
// "Query string parameter keys for which the token is for, separated by " => "Query string parameter keys for which the token is for, separated by ",
// "Query string parameter Values" => "Query string parameter Values",
// "Query string parameter values for which the token is for, separated by " => "Query string parameter values for which the token is for, separated by ",
// "Google Analytics" => "Google Analytics",
// "Add the tracking code for Google Analytics" => "Add the tracking code for Google Analytics",
// "Account Number" => "Account Number",
// "The account number for the site. Your account number from google looks like UA-XXXXXXX-YY. All you need to enter is XXXXXXX-YY" => "The account number for the site. Your account number from google looks like UA-XXXXXXX-YY. All you need to enter is XXXXXXX-YY",
// "Missing parameter" => "Missing parameter",
// "Google Doc" => "Google Doc",
// "Display a Google document" => "Display a Google document",
// "Leave this empty" => "Leave this empty",
// "Type of Google document" => "Type of Google document",
// "Document" => "Document",
// "Presentation" => "Presentation",
// "key" => "key",
// "Google doc key - for example: pXsHENf1bGGY92X1iEeJJI" => "Google doc key - for example: pXsHENf1bGGY92X1iEeJJI",
// "Name of iframe. Default is \"Frame\" + the key" => "Name of iframe. Default is \"Frame\" + the key",
// "Size of frame. Use instead of width and height. The sizes will fit the Google presentations sizes exactly" => "Size of frame. Use instead of width and height. The sizes will fit the Google presentations sizes exactly",
// "Small" => "Small",
// "Large" => "Large",
// "Width in pixels or %" => "Width in pixels or %",
// "Height in pixels or %" => "Height in pixels or %",
// "Middle" => "Middle",
// "Frame Border" => "Frame Border",
// "Choose whether to show a border around the iframe" => "Choose whether to show a border around the iframe",
// "Margin Height" => "Margin Height",
// "Margin height in pixels" => "Margin height in pixels",
// "Margin Width" => "Margin Width",
// "Margin width in pixels" => "Margin width in pixels",
// "Scrolling" => "Scrolling",
// "Choose whether to add a scroll bar" => "Choose whether to add a scroll bar",
// "Auto" => "Auto",
// "Edit Link" => "Edit Link",
// "Choose whether to show an edit link and set its location" => "Choose whether to show an edit link and set its location",
// "Required parameter \"type\" missing" => "Required parameter \"type\" missing",
// "Required parameter \"key\" missing" => "Required parameter \"key\" missing",
// "Google Map" => "Google Map",
// "Display a Google map" => "Display a Google map",
// "Type of items to show on google map" => "Type of items to show on google map",
// "Locator" => "Locator",
// "Object List" => "Object List",
"Tracker Field" => "Campo del Formulario-bd",
// "Display Mode" => "Display Mode",
// "Map display mode" => "Map display mode",
// "Satellite" => "Satellite",
// "Hybrid" => "Hybrid",
// "API Key" => "API Key",
// "Google maps key. Not needed if set in user preferences" => "Google maps key. Not needed if set in user preferences",
// "Valid key for the website, which can be obtained at http://code.google.com/apis/maps/signup.html" => "Valid key for the website, which can be obtained at http://code.google.com/apis/maps/signup.html",
// "Map ID" => "Map ID",
// "Id suffix of Google map div to avoid conflicts with other maps on same page" => "Id suffix of Google map div to avoid conflicts with other maps on same page",
// "Single \"word\" which must begin with a letter and may be followed by any number of digits, hyphens, underscores, colons and periods" => "Single \"word\" which must begin with a letter and may be followed by any number of digits, hyphens, underscores, colons and periods",
// "A plain number will be interpreted as pixels. Add a % symbol after the number to indicate percentage" => "A plain number will be interpreted as pixels. Add a % symbol after the number to indicate percentage",
// "Show Border" => "Show Border",
// "Choose whether to show a frame border around the map (no border shown by default)" => "Choose whether to show a frame border around the map (no border shown by default)",
// "Default Center Longitude" => "Default Center Longitude",
// "Default longitude value used to center the map, e.g. -79.39. Default is the default set in the Gmap feature" => "Default longitude value used to center the map, e.g. -79.39. Default is the default set in the Gmap feature",
// "An integer between -180 and 180" => "An integer between -180 and 180",
// "Default Center Latitude" => "Default Center Latitude",
// "Default latitude value used to center the map, e.g. 43.7. Default is the default set in the Gmap feature" => "Default latitude value used to center the map, e.g. 43.7. Default is the default set in the Gmap feature",
// "Default Zoom" => "Default Zoom",
// "Use an integer between 1 and 21 to set a default zoom level for the map. Default is the default set in the Gmap feature" => "Use an integer between 1 and 21 to set a default zoom level for the map. Default is the default set in the Gmap feature",
// "Save View" => "Save View",
// "Allow user to set current map view as default view for himself only" => "Allow user to set current map view as default view for himself only",
// "Marker" => "Marker",
// "Add a marker when only the default or no coordinates are set. No marker by default" => "Add a marker when only the default or no coordinates are set. No marker by default",
// "Text Bubble" => "Text Bubble",
// "Text for bubble for marker. Tiki wiki-syntax can be used" => "Text for bubble for marker. Tiki wiki-syntax can be used",
// "Plain text or Tiki wiki-syntax" => "Plain text or Tiki wiki-syntax",
// "Show/Hide Marker Text" => "Show/Hide Marker Text",
// "Set whether the marker text bubble is shown or hidden initially. Default is to hide" => "Set whether the marker text bubble is shown or hidden initially. Default is to hide",
// "Item Type" => "Item Type",
// "Type of item being geotagged (user, wiki page, blog, etc). Will attempt to use current object if not specified. Tracker items must be categorized" => "Type of item being geotagged (user, wiki page, blog, etc). Will attempt to use current object if not specified. Tracker items must be categorized",
// "Item ID or Name" => "Item ID or Name",
// "ID of item being geotagged (name of page, blog ID, etc). Will attempt to use current object if not specified" => "ID of item being geotagged (name of page, blog ID, etc). Will attempt to use current object if not specified",
// "Any ID number or name for an existing object of the type specified in the Item Type field" => "Any ID number or name for an existing object of the type specified in the Item Type field",
// "Hide If No Markers" => "Hide If No Markers",
// "Hide map if there are no markers to be shown. Default is to show the map" => "Hide map if there are no markers to be shown. Default is to show the map",
// "Visibility Toggle" => "Visibility Toggle",
// "Add ability to toggle visibility. No toggle by default" => "Add ability to toggle visibility. No toggle by default",
// "Toggle Link Align" => "Toggle Link Align",
// "Alignment for the show/hide toggle link" => "Alignment for the show/hide toggle link",
// "Start Hidden" => "Start Hidden",
// "Choose whether to keep the map hidden initially. Default is to show the map initially" => "Choose whether to keep the map hidden initially. Default is to show the map initially",
// "Auto Zoom" => "Auto Zoom",
// "Use an integer between 1 and 21 to auto zoom to this level on address find" => "Use an integer between 1 and 21 to auto zoom to this level on address find",
// "Show Controls" => "Show Controls",
// "Show map controls (shown by default)" => "Show map controls (shown by default)",
// "Zoom Only" => "Zoom Only",
// "Zoom and Type" => "Zoom and Type",
// "Zoom and Scale" => "Zoom and Scale",
// "Type Only" => "Type Only",
// "Type and Scale" => "Type and Scale",
// "Scale Only" => "Scale Only",
"Tracker Field ID" => "ID del Campo del Formulario-bd",
// "Field ID of tracker field if type is Item, Tracker Field or Locator, Item Type is trackeritem and Item ID is the tracker item ID. Tracker item must be categorized" => "Field ID of tracker field if type is Item, Tracker Field or Locator, Item Type is trackeritem and Item ID is the tracker item ID. Tracker item must be categorized",
// "Numeric ID of a location type tracker field" => "Numeric ID of a location type tracker field",
"Tracker HTML ID" => "ID Html del Formulario-bd",
// "HTML ID of tracker field input box where value is copied to by Javascript. Auto set if used as part of entry forms" => "HTML ID of tracker field input box where value is copied to by Javascript. Auto set if used as part of entry forms",
// "In Form" => "In Form",
// "Set to 1 (Yes) if this is embedded inside a form. Needed to prevent nested forms which is not allowed in HTML" => "Set to 1 (Yes) if this is embedded inside a form. Needed to prevent nested forms which is not allowed in HTML",
// "Show location map" => "Show location map",
// "Hide location map" => "Hide location map",
// "Google Maps API key not set" => "Google Maps API key not set",
// "No such user" => "No such user",
"The user has chosen to make his information private" => "El usuario eligió hacer su información privada",
// "No such object" => "No such object",
"Group" => "Grupo",
// "Display content based on the user's groups or friends" => "Display content based on the user's groups or friends",
// "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the conditions" => "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the conditions",
// "Allowed User Friends" => "Allowed User Friends",
// "Pipe separated list of users whose friends are allowed to view the block. ex: admin|johndoe|foo" => "Pipe separated list of users whose friends are allowed to view the block. ex: admin|johndoe|foo",
// "Allowed Groups" => "Allowed Groups",
// "Pipe separated list of groups allowed to view the block. ex: Admins|Developers" => "Pipe separated list of groups allowed to view the block. ex: Admins|Developers",
// "Denied Groups" => "Denied Groups",
// "Pipe separated list of groups denied from viewing the block. ex: Anonymous|Managers" => "Pipe separated list of groups denied from viewing the block. ex: Anonymous|Managers",
// "Group Expiry" => "Group Expiry",
// "Show the expiry date of a group membership of the current user" => "Show the expiry date of a group membership of the current user",
// "not in group" => "not in group",
// "never expires" => "never expires",
// "Group List" => "Group List",
// "List all groups or just groups that include a certain group" => "List all groups or just groups that include a certain group",
// "If empty, all groups will be listed. Entering a group name will cause only groups that include this group to be listed" => "If empty, all groups will be listed. Entering a group name will cause only groups that include this group to be listed",
// "Group Home Page" => "Group Home Page",
// "Link the group name to the group home page, if there is one (not linked by default)" => "Link the group name to the group home page, if there is one (not linked by default)",
// "Recursively List Groups" => "Recursively List Groups",
// "Recurse on the included groups (default is not to recurse)" => "Recurse on the included groups (default is not to recurse)",
// "GroupMail Core" => "GroupMail Core",
// "Displays GroupMail functions on a wiki page. Usually set up using a plugin alias created by the GroupMail profile" => "Displays GroupMail functions on a wiki page. Usually set up using a plugin alias created by the GroupMail profile",
// "From Email" => "From Email",
// "Email address to report" => "Email address to report",
"Tracker Id" => "Id del Formulario-bd",
// "Id of GroupMail Logs tracker (set up in alias by profile)" => "Id of GroupMail Logs tracker (set up in alias by profile)",
// "From Field Id" => "From Field Id",
// "Id of GroupMail Logs tracker field (usually set up in alias by profile)" => "Id of GroupMail Logs tracker field (usually set up in alias by profile)",
// "Operator Field Id" => "Operator Field Id",
// "Subject Field Id" => "Subject Field Id",
// "Message Field Id" => "Message Field Id",
// "Content Field Id" => "Content Field Id",
// "Account Field Id" => "Account Field Id",
// "Datetime Field Id" => "Datetime Field Id",
// "Group Stats" => "Group Stats",
// "Show the distribution of users among groups" => "Show the distribution of users among groups",
"Groups" => "Grupos",
// "Groups separated by :. If empty, all groups will be listed" => "Groups separated by :. If empty, all groups will be listed",
// "Percentage of" => "Percentage of",
// "Show percentage out of all users in site, or just specified groups if any" => "Show percentage out of all users in site, or just specified groups if any",
// "Users in specified groups, if any" => "Users in specified groups, if any",
// "Site users" => "Site users",
// "Show Percentage" => "Show Percentage",
// "Show the percentage of total users that are members of each group (percentages are shown by default)" => "Show the percentage of total users that are members of each group (percentages are shown by default)",
// "Show Bar" => "Show Bar",
// "Represent the percentage of total users that are members of each group in a bar graph (default is not to show the bar graph)" => "Represent the percentage of total users that are members of each group in a bar graph (default is not to show the bar graph)",
// "Has Bought" => "Has Bought",
// "Check if user has bought certain item or if it is in cart" => "Check if user has bought certain item or if it is in cart",
// "PluginHasBought" => "PluginHasBought",
// "Session key names to be collected" => "Session key names to be collected",
// "Key name of passcode to be checked" => "Key name of passcode to be checked",
// "Labels for the key names to be collected" => "Labels for the key names to be collected",
// "Label of the key name of passcode to be checked" => "Label of the key name of passcode to be checked",
"Tracker from which to get passcode to check against" => "Formulario-bd del cual obtener el código de acceso contra el cual hacer la comprobación",
// "Field ID from which to get passcode to check against" => "Field ID from which to get passcode to check against",
// "Item ID from which to get passcode to check against" => "Item ID from which to get passcode to check against",
// "Please fill in all fields" => "Please fill in all fields",
// "HTML" => "HTML",
// "Add HTML to a page" => "Add HTML to a page",
"HTML code" => "código HTML",
// "Parse wiki syntax within the HTML code" => "Parse wiki syntax within the HTML code",
// "Textlink" => "Textlink",
// "Adds an item to HTML feed" => "Adds an item to HTML feed",
// "HTML Feed Link" => "HTML Feed Link",
// "Display remote content" => "Display remote content",
// "Initial Value" => "Initial Value",
// "Feed location" => "Feed location",
// "Name of content" => "Name of content",
// "Style of content" => "Style of content",
// "Highlight" => "Highlight",
// "Asterisk" => "Asterisk",
// "HTML Feed Link Type" => "HTML Feed Link Type",
"Replace" => "Reemplazar",
// "Backlink" => "Backlink",
// "Popup" => "Popup",
// "Hover" => "Hover",
// "Is the HTML feed moderated" => "Is the HTML feed moderated",
// "Date of last accepted HTML item, not used if not moderated" => "Date of last accepted HTML item, not used if not moderated",
// "Iframe" => "Iframe",
// "Include another web page within a frame" => "Include another web page within a frame",
// "Frame title" => "Frame title",
// "Pixels or %" => "Pixels or %",
// "Align the iframe on the page" => "Align the iframe on the page",
// "Display custom formatted images" => "Display custom formatted images",
// "Image source" => "Image source",
// "Full URL to the image to display. \"src\", id\", \"fileId\", \"attId\" or \"randomGalleryId\" required" => "Full URL to the image to display. \"src\", id\", \"fileId\", \"attId\" or \"randomGalleryId\" required",
"Image ID" => "ID de imagen",
// "Numeric ID of an image in an Image Gallery (or list separated by commas or |)" => "Numeric ID of an image in an Image Gallery (or list separated by commas or |)",
// "Numeric ID of an image in a File Gallery (or list separated by commas or |)" => "Numeric ID of an image in a File Gallery (or list separated by commas or |)",
// "Numeric ID of a file gallery. Displays a random image from that gallery" => "Numeric ID of a file gallery. Displays a random image from that gallery",
// "Numeric ID of a file gallery. Displays all images from that gallery" => "Numeric ID of a file gallery. Displays all images from that gallery",
// "File Name Ascending" => "File Name Ascending",
// "File Name Descending" => "File Name Descending",
// "Comment Ascending" => "Comment Ascending",
// "Comment Descending" => "Comment Descending",
// "Max Hits Ascending" => "Max Hits Ascending",
// "Max Hits Descending" => "Max Hits Descending",
// "File Size Ascending" => "File Size Ascending",
// "File Size Descending" => "File Size Descending",
// "File Type Ascending" => "File Type Ascending",
// "File Type Descending" => "File Type Descending",
// "User Ascending" => "User Ascending",
// "User Descending" => "User Descending",
// "Author Ascending" => "Author Ascending",
// "Author Descending" => "Author Descending",
// "Locked By Ascending" => "Locked By Ascending",
// "Locked By Descending" => "Locked By Descending",
// "Last Modified User Ascending" => "Last Modified User Ascending",
// "Last Modified User Descending" => "Last Modified User Descending",
// "Last Modified Date Ascending" => "Last Modified Date Ascending",
// "Last Modified Date Descending" => "Last Modified Date Descending",
// "Last Download Ascending" => "Last Download Ascending",
// "Last Download Descending" => "Last Download Descending",
// "Delete After Ascending" => "Delete After Ascending",
// "Delete After Descending" => "Delete After Descending",
// "Votes Ascending" => "Votes Ascending",
// "Votes Descending" => "Votes Descending",
// "Points Ascending" => "Points Ascending",
// "Points Descending" => "Points Descending",
// "Archive ID Ascending" => "Archive ID Ascending",
// "Archive ID Descending" => "Archive ID Descending",
// "Attachment ID" => "Attachment ID",
// "Numeric ID of an image attached to a wiki page (or list separated by commas or |)" => "Numeric ID of an image attached to a wiki page (or list separated by commas or |)",
"Thumbnail" => "Miniatura",
// "Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery or attachments" => "Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery or attachments",
// "Full size image appears when thumbnail is clicked" => "Full size image appears when thumbnail is clicked",
// "Mouseover" => "Mouseover",
// "Full size image will pop up while cursor is over the thumbnail (and disappear when not)" => "Full size image will pop up while cursor is over the thumbnail (and disappear when not)",
// "Mouseover (Sticky)" => "Mouseover (Sticky)",
// "Full size image will pop up once cursor passes over thumbnail and will remain up unless cursor passes over full size popup" => "Full size image will pop up once cursor passes over thumbnail and will remain up unless cursor passes over full size popup",
// "Full size image will open in a separate winow or tab (depending on browser settings) when thumbnail is clicked" => "Full size image will open in a separate winow or tab (depending on browser settings) when thumbnail is clicked",
"Browse" => "Visitar",
// "Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery" => "Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery",
// "Browse Popup" => "Browse Popup",
// "Same as \"browse\" except that the page opens in a new window or tab" => "Same as \"browse\" except that the page opens in a new window or tab",
// "Download dialog box will appear for file gallery and attachment images when thumbnail is clicked" => "Download dialog box will appear for file gallery and attachment images when thumbnail is clicked",
// "Enlarge button" => "Enlarge button",
// "Button for enlarging image" => "Button for enlarging image",
// "Enter a URL to the address the image should link to. Not needed if thumb parameter is set; overrides thumb setting" => "Enter a URL to the address the image should link to. Not needed if thumb parameter is set; overrides thumb setting",
// "Link relation" => "Link relation",
// "Enter \"box\" for colorbox effect (like shadowbox and lightbox) or appropriate syntax for link relation" => "Enter \"box\" for colorbox effect (like shadowbox and lightbox) or appropriate syntax for link relation",
// "Image map" => "Image map",
// "Name of the image map to use for the image" => "Name of the image map to use for the image",
"Image height" => "Alto de la imagen",
// "Height in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent" => "Height in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent",
"Image width" => "Ancho de la imagen",
// "Width in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent" => "Width in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent",
// "Maximum height or width in pixels (largest dimension is scaled). Overrides height and width settings" => "Maximum height or width in pixels (largest dimension is scaled). Overrides height and width settings",
// "Align image" => "Align image",
// "Aligns the image itself. If the image is inside a box (because of other settings), use the align parameter to align the box" => "Aligns the image itself. If the image is inside a box (because of other settings), use the align parameter to align the box",
// "Image style" => "Image style",
// "Enter \"border\" to place a dark gray border around the image. Otherwise enter CSS styling syntax for other style effects" => "Enter \"border\" to place a dark gray border around the image. Otherwise enter CSS styling syntax for other style effects",
// "Align image block" => "Align image block",
// "Aligns the box containing the image" => "Aligns the box containing the image",
// "Image block style" => "Image block style",
// "Enter \"border\" to place a dark gray border frame around the image. Otherwise enter CSS styling syntax for other style effects" => "Enter \"border\" to place a dark gray border frame around the image. Otherwise enter CSS styling syntax for other style effects",
// "Description style" => "Description style",
// "Enter \"right\" or \"left\" to align text accordingly. Otherwise enter CSS styling syntax for other style effects" => "Enter \"right\" or \"left\" to align text accordingly. Otherwise enter CSS styling syntax for other style effects",
// "Wrapping control" => "Wrapping control",
// "Control how other items wrap around the image" => "Control how other items wrap around the image",
// "CSS class to apply to the image" => "CSS class to apply to the image",
// "Image caption. \"desc\" or \"name\" or \"namedesc\" for tiki images, \"idesc\" or \"ititle\" for iptc data, otherwise enter your own description" => "Image caption. \"desc\" or \"name\" or \"namedesc\" for tiki images, \"idesc\" or \"ititle\" for iptc data, otherwise enter your own description",
// "Link title" => "Link title",
// "Title text. \"desc\" or \"name\" or \"namedesc\", otherwise enter your own title" => "Title text. \"desc\" or \"name\" or \"namedesc\", otherwise enter your own title",
// "Metadata" => "Metadata",
// "Display the image metadata (IPTC and EXIF information)" => "Display the image metadata (IPTC and EXIF information)",
// "Alternate text" => "Alternate text",
// "Alternate text that displays when image does not load. Set to \"Image\" by default" => "Alternate text that displays when image does not load. Set to \"Image\" by default",
// "Default config settings" => "Default config settings",
// "Default configuration settings (usually set by admin in the source code or through Plugin Alias)" => "Default configuration settings (usually set by admin in the source code or through Plugin Alias)",
// "Mandatory admin setting" => "Mandatory admin setting",
// "Mandatory configuration settings (usually set by admin in the source code or through Plugin Alias)" => "Mandatory configuration settings (usually set by admin in the source code or through Plugin Alias)",
// "PluginImg: User lacks permission to view image" => "PluginImg: User lacks permission to view image",
// "File is not an image" => "File is not an image",
// "Server does not support image manipulation" => "Server does not support image manipulation",
// "Enlarge" => "Enlarge",
// "''No image specified. One of the following parameters must be set: fileId, randomGalleryId, fgalId, attId, id.''" => "''No image specified. One of the following parameters must be set: fileId, randomGalleryId, fgalId, attId, id.''",
// "''Use one and only one of the following parameters: fileId, randomGalleryId, fgalId, attId, id, or src.''" => "''Use one and only one of the following parameters: fileId, randomGalleryId, fgalId, attId, id, or src.''",
// "Edit: Image" => "Edit: Image",
// "(experimental)" => "(experimental)",
"Include" => "Incluir",
// "Include content from a wiki page" => "Include content from a wiki page",
// "Wiki page name to include" => "Wiki page name to include",
// "When only a portion of the page should be included, specify the marker from which inclusion should start" => "When only a portion of the page should be included, specify the marker from which inclusion should start",
"Stop" => "Detener",
// "When only a portion of the page should be included, specify the marker at which inclusion should end" => "When only a portion of the page should be included, specify the marker at which inclusion should end",
// "Nopage Text" => "Nopage Text",
// "Text to show when no page is found" => "Text to show when no page is found",
// "Page Denied Text" => "Page Denied Text",
// "Text to show when the page exists but is denied to the user" => "Text to show when the page exists but is denied to the user",
// "Include Plugin" => "Include Plugin",
// "Edit the included page" => "Edit the included page",
// "Invite" => "Invite",
// "Invite a user to join your groups" => "Invite a user to join your groups",
// "Confirmation message after posting form" => "Confirmation message after posting form",
// "Including Group" => "Including Group",
// "Will list only the groups that include this group" => "Will list only the groups that include this group",
"Default Group" => "Grupo por Defecto",
// "Dropdown list will show this group by default" => "Dropdown list will show this group by default",
// "Dropdown list will show the group related to this item ID (in group selector or creator field) by default" => "Dropdown list will show the group related to this item ID (in group selector or creator field) by default",
// "Following mandatory fields are missing" => "Following mandatory fields are missing",
// "Jabber" => "Jabber",
// "Chat using Jabber" => "Chat using Jabber",
// "Applet height in pixels" => "Applet height in pixels",
// "Applet width in pixels" => "Applet width in pixels",
// "XML Host Name" => "XML Host Name",
// "Web site where XML is hosted. Default is jabber.org" => "Web site where XML is hosted. Default is jabber.org",
// "Default Color" => "Default Color",
// "Set default color. Default is 255,255,255" => "Set default color. Default is 255,255,255",
// "Add JavaScript code" => "Add JavaScript code",
// "JavaScript code" => "JavaScript code",
// "Not On Ready" => "Not On Ready",
// "Do not execute on document ready (execute inline)" => "Do not execute on document ready (execute inline)",
// "No JavaScript" => "No JavaScript",
// "Optional markup for when JavaScript is off" => "Optional markup for when JavaScript is off",
// "<!-- jq plugin inactive: JavaScript off -->" => "<!-- jq plugin inactive: JavaScript off -->",
// "JavaScript" => "JavaScript",
// "JavaScript filename" => "JavaScript filename",
// "Late Load" => "Late Load",
// "Late load, use headerlib" => "Late load, use headerlib",
// "Kaltura Video" => "Kaltura Video",
// "Display a video created through the Kaltura feature" => "Display a video created through the Kaltura feature",
// "Kaltura Entry ID" => "Kaltura Entry ID",
// "Kaltura entry ID of the video to be displayed" => "Kaltura entry ID of the video to be displayed",
// "Vary text based on the page language" => "Vary text based on the page language",
// "List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs",
// "Not Language" => "Not Language",
// "List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs",
// "Show the last modification date for a page" => "Show the last modification date for a page",
// "Page name to display information of. Default value is current page" => "Page name to display information of. Default value is current page",
// "Create lists of Tiki objects based on custom search criteria and formatting" => "Create lists of Tiki objects based on custom search criteria and formatting",
// "List configuration information" => "List configuration information",
// "Missing template \"%0\"" => "Missing template \"%0\"",
// "No results for query" => "No results for query",
// "Missing objectype or qualifier for relation filter" => "Missing objectype or qualifier for relation filter",
// "Missing from or to for range filter" => "Missing from or to for range filter",
"List Pages" => "Listar páginas",
// "List pages based on various criteria" => "List pages based on various criteria",
// "Result number at which the listing should start" => "Result number at which the listing should start",
// "Limit number of items displayed in the list. Default is to display all" => "Limit number of items displayed in the list. Default is to display all",
// "Initial" => "Initial",
// "txt" => "txt",
// "Show Name Only" => "Show Name Only",
// "Show only the page names" => "Show only the page names",
// "If set to a category identifier, restrict the pages displayed to those in the specified category" => "If set to a category identifier, restrict the pages displayed to those in the specified category",
// "If set to a list of category identifiers separated by colons (:), restrict the pages to those in any of the specified categories" => "If set to a list of category identifiers separated by colons (:), restrict the pages to those in any of the specified categories",
// "If set to a list of category identifiers separated by plus signs (+), only display a page if it is in all of the specified categories" => "If set to a list of category identifiers separated by plus signs (+), only display a page if it is in all of the specified categories",
// "If set to a list of category identifiers separated by minus signs (-), only display a page if it is in the first specified category and not in any of the following categories" => "If set to a list of category identifiers separated by minus signs (-), only display a page if it is in the first specified category and not in any of the following categories",
// "Structure Head" => "Structure Head",
// "Filter by structure head" => "Filter by structure head",
// "Show Page Alias" => "Show Page Alias",
// "Show page alias in the list" => "Show page alias in the list",
// "Only pages with names similar the text entered for this parameter will be listed" => "Only pages with names similar the text entered for this parameter will be listed",
// "Two letter language code to filter pages listed" => "Two letter language code to filter pages listed",
// "Orphan Language" => "Orphan Language",
// "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed" => "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed",
// "Load Translations" => "Load Translations",
// "User or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter" => "User or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter",
// "Page name and text entered for the filter parameter must match exactly to be listed" => "Page name and text entered for the filter parameter must match exactly to be listed",
// "Only Orphan Pages" => "Only Orphan Pages",
// "Only list orphan pages" => "Only list orphan pages",
// "For List Pages" => "For List Pages",
// "Sort ascending or descending on any field in the tiki_pages table. Syntax is field name followed by _asc or _desc. Example: " => "Sort ascending or descending on any field in the tiki_pages table. Syntax is field name followed by _asc or _desc. Example: ",
"or" => "o",
// "Length" => "Length",
// "Number of characters to display" => "Number of characters to display",
// "Show checkboxes" => "Show checkboxes",
// "List Directory" => "List Directory",
"Lists files in a directory" => "Lista archivos en un directorio",
// "Full path to the server-local directory. Default is the document root" => "Full path to the server-local directory. Default is the document root",
// "URL Prefix" => "URL Prefix",
// "Make the file name a link to the file by adding the URL path preceding the file name. Example: http://yoursite.com/tiki/" => "Make the file name a link to the file by adding the URL path preceding the file name. Example: http://yoursite.com/tiki/",
// "Set the sort order of the file list" => "Set the sort order of the file list",
"File Name" => "Nombre de Archivo",
// "File Size" => "File Size",
// "Last Access" => "Last Access",
// "Last Metadata Change" => "Last Metadata Change",
// "Only list files with filenames that contain this filter. Example: \".jpg\"" => "Only list files with filenames that contain this filter. Example: \".jpg\"",
// "Maximum amount of files to display. Default is no limit" => "Maximum amount of files to display. Default is no limit",
"could not be opened because it doesn't exist or permission was denied" => "no puede abrirse porque no existe o el permiso fue denegado",
"Mail" => "Correo",
// "Directly mail other users or groups" => "Directly mail other users or groups",
// "Limit the list of groups to the groups including each group" => "Limit the list of groups to the groups including each group",
// "Show Group Dropdown" => "Show Group Dropdown",
// "Show a dropdown list of groups (not shown by default)" => "Show a dropdown list of groups (not shown by default)",
// "Recurse on groups" => "Recurse on groups",
// "show each group and each group included in this group" => "show each group and each group included in this group",
// "Recurse on groups to have the users" => "Recurse on groups to have the users",
// "Collect the users of a selected group and the users of each included groups. If 0 do not recurse, if 1, recurse one time, 2 two times..." => "Collect the users of a selected group and the users of each included groups. If 0 do not recurse, if 1, recurse one time, 2 two times...",
// "Show User Dropdown" => "Show User Dropdown",
// "Show a dropdown list of users (not shown by default)" => "Show a dropdown list of users (not shown by default)",
// "User Autocomplete" => "User Autocomplete",
// "Show an autocomplete box on user name" => "Show an autocomplete box on user name",
// "Real Name Dropdown" => "Real Name Dropdown",
// "Show a dropdown list of user real names (not shown by default)" => "Show a dropdown list of user real names (not shown by default)",
"Map" => "Mapear",
// "Display a map" => "Display a map",
// "Instructions to load content" => "Instructions to load content",
// "Scope" => "Scope",
// "Display the geolocated items represented in the page (all, center, or custom as a CSS selector). Default: center" => "Display the geolocated items represented in the page (all, center, or custom as a CSS selector). Default: center",
// "Controls" => "Controls",
// "Allows to specify which map controls will be displayed on the map and around it (controls, layers, search_location, levels, current_location, scale, streetview, navigation, coordinates, overview)" => "Allows to specify which map controls will be displayed on the map and around it (controls, layers, search_location, levels, current_location, scale, streetview, navigation, coordinates, overview)",
// "Width of the map in pixels" => "Width of the map in pixels",
// "Height of the map in pixels" => "Height of the map in pixels",
// "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19" => "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19",
// "MapServer File" => "MapServer File",
// "MapServer file identifier. Only fill this in if you are using MapServer" => "MapServer file identifier. Only fill this in if you are using MapServer",
// "Extents" => "Extents",
// "Size of the map" => "Size of the map",
// "Color Picker" => "Color Picker",
// "Mayan Calendars" => "Mayan Calendars",
// "Convert a Gregorian date to a Mayan calendar date" => "Convert a Gregorian date to a Mayan calendar date",
"Template" => "Plantilla",
// "You must use the variable substitution" => "You must use the variable substitution",
// "LongCount: " => "LongCount: ",
// "Tzolkin: " => "Tzolkin: ",
// "Haab: " => "Haab: ",
// "Misc: " => "Misc: ",
// "Example: template " => "Example: template ",
// "for 22.05.2009 will return 12.19.16.6.11, 8 CHUEN, 9 SIP" => "for 22.05.2009 will return 12.19.16.6.11, 8 CHUEN, 9 SIP",
// "Default template: " => "Default template: ",
// "Gregorian date" => "Gregorian date",
// "Gregorian date for convert. Format: DD.MM.YYYY. Default: Today date" => "Gregorian date for convert. Format: DD.MM.YYYY. Default: Today date",
// " is not a valid date format. should be dd.mm.yyyy" => " is not a valid date format. should be dd.mm.yyyy",
// "Media Player" => "Media Player",
// "Add a media player to a page" => "Add a media player to a page",
// "Allow Fullscreen" => "Allow Fullscreen",
// "Allow fullscreen mode" => "Allow fullscreen mode",
// " true|false" => " true|false",
// "MP3 URL" => "MP3 URL",
// "Complete URL to the mp3 to include" => "Complete URL to the mp3 to include",
// "FLV URL" => "FLV URL",
// "Complete URL to the flv to include" => "Complete URL to the flv to include",
// "Complete URL to the media to include" => "Complete URL to the media to include",
// "One of" => "One of",
// "Flash Window Mode" => "Flash Window Mode",
// "Sets the Window Mode property of the Flash movie. Transparent lets what's behind the movie show through and allows the movie to be covered Opaque hides what's behind the movie and Window plays the movie in its own window. Default value: " => "Sets the Window Mode property of the Flash movie. Transparent lets what's behind the movie show through and allows the movie to be covered Opaque hides what's behind the movie and Window plays the movie in its own window. Default value: ",
// "Transparent" => "Transparent",
// "Opaque" => "Opaque",
// "Window" => "Window",
// "Member List" => "Member List",
// "List and allow editing of group members" => "List and allow editing of group members",
// "List of groups to handle through the interface (use \"*\" for all). Colon separated" => "List of groups to handle through the interface (use \"*\" for all). Colon separated",
// "Show Descriptions" => "Show Descriptions",
// "Display group descriptions below list name" => "Display group descriptions below list name",
// "Display mode" => "Display mode",
// "How to show the member lists" => "How to show the member lists",
"Tabs" => "Pestañas",
// "Maximum" => "Maximum",
// "Maximum number of users to list in each group (default 100)" => "Maximum number of users to list in each group (default 100)",
// "Members Only" => "Members Only",
// "Only shows groups containing a certain user. Enter \"%user%\" to show groups for the current logged in user" => "Only shows groups containing a certain user. Enter \"%user%\" to show groups for the current logged in user",
// "Sort mode" => "Sort mode",
// "Sort mode for member listing" => "Sort mode for member listing",
// "Read only" => "Read only",
// "Read only mode. All ability to modify membership is hidden" => "Read only mode. All ability to modify membership is hidden",
// "Set as Default Group" => "Set as Default Group",
// "Adds possibility to set group as default group. This automatically adds the user to the group. \"Forced\" option will not propose simple addition in group" => "Adds possibility to set group as default group. This automatically adds the user to the group. \"Forced\" option will not propose simple addition in group",
// "Not suggested" => "Not suggested",
// "Suggested" => "Suggested",
// "Forced" => "Forced",
// "Only groups including the group that you specify will be listed" => "Only groups including the group that you specify will be listed",
// "Member Payment" => "Member Payment",
// "Receive payments from a member to extend membership to a group" => "Receive payments from a member to extend membership to a group",
// "Name of the group for which the subscription should be added or extended" => "Name of the group for which the subscription should be added or extended",
// "Price per period (%0)" => "Price per period (%0)",
// "Current User Member" => "Current User Member",
// "Membership only for the current user" => "Membership only for the current user",
// "Input Title" => "Input Title",
// "Title of the input form" => "Title of the input form",
// "Use %0 for the group name" => "Use %0 for the group name",
// "Supports wiki syntax" => "Supports wiki syntax",
// "Tiki Payments Invoice Title" => "Tiki Payments Invoice Title",
// "Use %0 for the group name, %4 for the number of days or %5 for the number of years" => "Use %0 for the group name, %4 for the number of days or %5 for the number of years",
// "Prevent double request" => "Prevent double request",
// "Prevent user from extended if there is already a pending request" => "Prevent user from extended if there is already a pending request",
// "Give specified numbers of free periods" => "Give specified numbers of free periods",
// "Give specified numbers of free periods, the first one could be prorated, in addition to those bought" => "Give specified numbers of free periods, the first one could be prorated, in addition to those bought",
// "Periods Label" => "Periods Label",
// "Give the period a label" => "Give the period a label",
// "The user " => "The user ",
// " already has a pending extension request payment invoice " => " already has a pending extension request payment invoice ",
// "Membership to %0 for %1 (x%2)" => "Membership to %0 for %1 (x%2)",
// "Membership to %0 for %1 users (x%2)" => "Membership to %0 for %1 users (x%2)",
// "The group " => "The group ",
// " does not have a membership term" => " does not have a membership term",
// " Go to " => " Go to ",
// "Admin > Groups" => "Admin > Groups",
// " to specify a term for this group by automatically unassigning users after a certain number of days" => " to specify a term for this group by automatically unassigning users after a certain number of days",
// " does not exist" => " does not exist",
// "Mini Quiz" => "Mini Quiz",
// "Create a quiz using a tracker" => "Create a quiz using a tracker",
// "Instructions::Feedback" => "Instructions::Feedback",
// "Numeric value representing the miniquiz tracker ID" => "Numeric value representing the miniquiz tracker ID",
// "Insert Module" => "Insert Module",
// "Display a module" => "Display a module",
"Module Name" => "Nombre de módulo",
// "Module name as known in Tiki" => "Module name as known in Tiki",
// "Select Yes (y) to hide the title (default is to show the title)" => "Select Yes (y) to hide the title (default is to show the title)",
// "Title to display at the top of the box, assuming No Title is not set to Yes (y)" => "Title to display at the top of the box, assuming No Title is not set to Yes (y)",
// "Align the module to the left or right on the page allowing other elements to align against it" => "Align the module to the left or right on the page allowing other elements to align against it",
// "Number of rows (default: 10)" => "Number of rows (default: 10)",
// "Parse" => "Parse",
// "Parse wiki syntax" => "Parse wiki syntax",
// "Show only the content with no box surrounding it" => "Show only the content with no box surrounding it",
// "Decoration" => "Decoration",
// "Show box decorations (default is to show them)" => "Show box decorations (default is to show them)",
// "Add ability to show/hide the content of the module (default is the site admin setting for modules)" => "Add ability to show/hide the content of the module (default is the site admin setting for modules)",
// "Title Background" => "Title Background",
// "Override the background color for the title (if the title is shown). The value can be a color name (ex: bgcolor=blue) or a hexadecimal value (ex: bgcolor=#FFEBCD)" => "Override the background color for the title (if the title is shown). The value can be a color name (ex: bgcolor=blue) or a hexadecimal value (ex: bgcolor=#FFEBCD)",
// "Module Style" => "Module Style",
// "Inline CSS for the containing DIV element, e.g. \"max-width:80%\"" => "Inline CSS for the containing DIV element, e.g. \"max-width:80%\"",
// "CSS styling for the module data itself" => "CSS styling for the module data itself",
"Please choose a module" => "Por favor elija un módulo",
"to be used as argument" => "para ser usado como argumento",
"Sorry, no such module" => "Lo siento no existe módulo",
// "Monospace" => "Monospace",
// "Display text in a monospace font" => "Display text in a monospace font",
// "Font name as known in browsers" => "Font name as known in browsers",
// "Display hidden content by mousing over a text" => "Display hidden content by mousing over a text",
// "Hidden content, unless the label parameter is undefined, in which case this is the label" => "Hidden content, unless the label parameter is undefined, in which case this is the label",
// "Text displayed on the page. The body is the hidden content" => "Text displayed on the page. The body is the hidden content",
// "Destination link when mouseover text is clicked. Use http:// for external links" => "Destination link when mouseover text is clicked. Use http:// for external links",
// "DEPRECATED" => "DEPRECATED",
// "Hidden content. The body contains the label" => "Hidden content. The body contains the label",
// "Mouseover box width. Default: 400px" => "Mouseover box width. Default: 400px",
// "Mouseover box height. Default: 200px" => "Mouseover box height. Default: 200px",
// "Offset X" => "Offset X",
// "Shifts the overlay to the right by the specified number of pixels relative to the cursor. Default: 5" => "Shifts the overlay to the right by the specified number of pixels relative to the cursor. Default: 5",
// "Offset Y" => "Offset Y",
// "Shifts the overlay lower by the specified number of pixels relative to the cursor. Default: 0" => "Shifts the overlay lower by the specified number of pixels relative to the cursor. Default: 0",
// "Parse Body" => "Parse Body",
// "Parse the body of the plugin as wiki content (parsed by default)" => "Parse the body of the plugin as wiki content (parsed by default)",
// "Parse Label" => "Parse Label",
// "Parse the label as wiki content (parsed by default)" => "Parse the label as wiki content (parsed by default)",
// "CSS class to apply" => "CSS class to apply",
// "Background color to apply to the popup" => "Background color to apply to the popup",
// "Text Color" => "Text Color",
// "Color to apply to the text in the popup" => "Color to apply to the text in the popup",
"Sticky" => "Sticky",
// "When enabled, popup stays visible until it is clicked" => "When enabled, popup stays visible until it is clicked",
// "Padding" => "Padding",
// "Padding size in pixels" => "Padding size in pixels",
// "Effect" => "Effect",
// "Set the type of show/hide animation that will be used" => "Set the type of show/hide animation that will be used",
// "Effect Speed" => "Effect Speed",
// "Set the speed of the animation" => "Set the speed of the animation",
// "Close Delay" => "Close Delay",
// "Number of seconds before popup closes" => "Number of seconds before popup closes",
// "Tag" => "Tag",
// "HTML tag to use for the label. Default \"a\"" => "HTML tag to use for the label. Default \"a\"",
// "No label specified" => "No label specified",
// "MediaWiki Table" => "MediaWiki Table",
// "Display a table using MediaWiki syntax (experimental - may change in future versions)" => "Display a table using MediaWiki syntax (experimental - may change in future versions)",
// "Fancy" => "Fancy",
// "Set to true to apply additional formatting to the table (header style, odd/even rows, etc.)" => "Set to true to apply additional formatting to the table (header style, odd/even rows, etc.)",
// "True" => "True",
// "False" => "False",
// "Wiki Classes" => "Wiki Classes",
// "Determines whether wiki style classes will be used for the table and cells (used by default)" => "Determines whether wiki style classes will be used for the table and cells (used by default)",
// "MySpace" => "MySpace",
// "Display a MySpace Flash mp3 playlist" => "Display a MySpace Flash mp3 playlist",
// "MySpace Page" => "MySpace Page",
// "MySpace page name" => "MySpace page name",
// "Now" => "Now",
// "Display the current date or time" => "Display the current date or time",
// "Format" => "Format",
// "Time format" => "Time format",
// "Object Hits" => "Object Hits",
// "Display the number of hits for certain objects" => "Display the number of hits for certain objects",
// "For a wiki page, the page name, for other object types: ID number + ? + object title" => "For a wiki page, the page name, for other object types: ID number + ? + object title",
// "Object type, such as wiki, file gallery, file, article, etc. Default is \"wiki\"" => "Object type, such as wiki, file gallery, file, article, etc. Default is \"wiki\"",
// "Show the number of hits over the past number of days indicated. Default is to show all hits" => "Show the number of hits over the past number of days indicated. Default is to show all hits",
// "Page Tabs" => "Page Tabs",
// "PluginPageTabs" => "PluginPageTabs",
// "Display page content in a set of tabs" => "Display page content in a set of tabs",
// "Wiki page names" => "Wiki page names",
// "The wiki pages you would like to use in this plugin, optional, separate with pipe \"|\".  Or a table with the class of \"pagetabs\" on the main page. On child pages use as a way to redirect to the parent" => "The wiki pages you would like to use in this plugin, optional, separate with pipe \"|\".  Or a table with the class of \"pagetabs\" on the main page. On child pages use as a way to redirect to the parent",
// "Param" => "Param",
// "Display content based on URL parameters" => "Display content based on URL parameters",
// "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed if conditions are not met" => "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed if conditions are not met",
// "Names of parameter required to display text" => "Names of parameter required to display text",
// "Source where the parameter is checked. Possible values : request .." => "Source where the parameter is checked. Possible values : request ..",
// "Show details of a payment request or invoice" => "Show details of a payment request or invoice",
// "Payment Request Number" => "Payment Request Number",
// "Unique identifier of the payment request" => "Unique identifier of the payment request",
// "Display content based on permission settings" => "Display content based on permission settings",
// "Possible Permissions" => "Possible Permissions",
// "Pipe separated list of permissions, one of which is needed to view the default text" => "Pipe separated list of permissions, one of which is needed to view the default text",
// "Forbidden Permissions" => "Forbidden Permissions",
// "Pipe separated list of permissions, any of which will cause the default text not to show" => "Pipe separated list of permissions, any of which will cause the default text not to show",
// "Display content based on the reader's current perspective" => "Display content based on the reader's current perspective",
// "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the condition" => "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the condition",
// "Allowed Perspectives" => "Allowed Perspectives",
// "Pipe-separated list of identifiers of perspectives in which the block is shown" => "Pipe-separated list of identifiers of perspectives in which the block is shown",
// "Denied Perspectives" => "Denied Perspectives",
// "Pipe-separated list of identifiers of perspectives in which the block is not shown" => "Pipe-separated list of identifiers of perspectives in which the block is not shown",
// "The module or plugin parameter must be set, but not both" => "The module or plugin parameter must be set, but not both",
// "Plugin Manager error: %0%1 not found" => "Plugin Manager error: %0%1 not found",
// "Plugin Manager error: %0%1%2%3%4 not found" => "Plugin Manager error: %0%1%2%3%4 not found",
// "Plugin Manager error:  %0%1 not found" => "Plugin Manager error:  %0%1 not found",
"Options" => "Opciones",
// "Introduced in Tiki version %0" => "Introduced in Tiki version %0",
// "Accepted Values" => "Accepted Values",
// "(body of plugin)" => "(body of plugin)",
// "(blank)" => "(blank)",
// "any string except for HTML and PHP tags" => "any string except for HTML and PHP tags",
// "Since" => "Since",
// "no parameters" => "no parameters",
// "Preferences required" => "Preferences required",
// "Required parameters are in%0 %1bold%2" => "Required parameters are in%0 %1bold%2",
// "Plugin Manager" => "Plugin Manager",
// "List wiki plugin or module information for the site" => "List wiki plugin or module information for the site",
"Information" => "Información",
// "Determines what information is shown. Values separated with | . Ignored when singletitle is set to top or none" => "Determines what information is shown. Values separated with | . Ignored when singletitle is set to top or none",
// "One or more of: description | parameters | paraminfo" => "One or more of: description | parameters | paraminfo",
// "Description & Parameters" => "Description & Parameters",
// "Description & Parameter Info" => "Description & Parameter Info",
// "Parameters & Parameter Info" => "Parameters & Parameter Info",
// "Name of a plugin (e.g., backlinks), or list separated by |, or range separated by \"-\". Single plugin can be used with limit parameter" => "Name of a plugin (e.g., backlinks), or list separated by |, or range separated by \"-\". Single plugin can be used with limit parameter",
// "Name of a module (e.g., calendar_new), or list separated by |, or range separated by \"-\". Single module can be used with limit parameter" => "Name of a module (e.g., calendar_new), or list separated by |, or range separated by \"-\". Single module can be used with limit parameter",
// "Single Title" => "Single Title",
// "Set placement of plugin name and description when displaying information for only one plugin" => "Set placement of plugin name and description when displaying information for only one plugin",
// "Title Heading" => "Title Heading",
// "Sets the heading size for the title, e.g., h2" => "Sets the heading size for the title, e.g., h2",
// "Start with this plugin record number (must be an integer 1 or greater)" => "Start with this plugin record number (must be an integer 1 or greater)",
// "Number of plugins to show. Can be used either with start or plugin as the starting point. Must be an integer 1 or greater" => "Number of plugins to show. Can be used either with start or plugin as the starting point. Must be an integer 1 or greater",
"Poll" => "Poll",
// "Display a poll" => "Display a poll",
// "Numeric value representing the poll ID" => "Numeric value representing the poll ID",
// "Show poll title (shown by default)" => "Show poll title (shown by default)",
// "Show result" => "Show result",
// "Show total votes" => "Show total votes",
"Pretty Tracker View Tracking" => "Rastreo de visualización de Formulario-bd bonito (PluginPrettyTrackerViews)",
"PluginPrettyTrackerViews" => "PluginPrettyTrackerViews",
// "Stores tiki.tracker.pretty.views attribute for trackeritem" => "Stores tiki.tracker.pretty.views attribute for trackeritem",
// "set to y to record view each time this is loaded" => "set to y to record view each time this is loaded",
// "set to n to hide showing of attribute" => "set to n to hide showing of attribute",
"Set to ID of tracker item" => "Fijado al ID del ítem de formulario-bd",
// "Profile Application" => "Profile Application",
// "Add a button for applying a profile" => "Add a button for applying a profile",
// "Profile repository domain. Default value is profiles.tiki.org" => "Profile repository domain. Default value is profiles.tiki.org",
// "Profile Name" => "Profile Name",
// "Name of the profile to be applied" => "Name of the profile to be applied",
// "Profile plugin only available to administrators" => "Profile plugin only available to administrators",
// "Profile %0/%1 not found" => "Profile %0/%1 not found",
// "Proposal" => "Proposal",
// "Allow users to vote on a proposal and view the results" => "Allow users to vote on a proposal and view the results",
// "The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username" => "The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username",
// "Short description of the proposal to vote on. Will be displayed above the result table" => "Short description of the proposal to vote on. Will be displayed above the result table",
// "Accept proposal" => "Accept proposal",
// "Still undecided" => "Still undecided",
// "Reject proposal" => "Reject proposal",
// "Quote" => "Quote",
// "Format text as a quote" => "Format text as a quote",
// "Quoted text" => "Quoted text",
// "Reply To" => "Reply To",
// "Name of the quoted person" => "Name of the quoted person",
"wrote:" => "escribió:",
"Quote:" => "Cita:",
// "Random Include" => "Random Include",
// "Include a random page's content" => "Include a random page's content",
// "Random Dynamic Content" => "Random Dynamic Content",
// "Display pre-programmed changing content" => "Display pre-programmed changing content",
// "Numeric value representing the content ID" => "Numeric value representing the content ID",
// "User List with Real Names" => "User List with Real Names",
// "Show user real names for members of a group" => "Show user real names for members of a group",
// " (experimental, should be merged with UserList)" => " (experimental, should be merged with UserList)",
// "Group name - only users belonging to a group or groups with group names containing this text will be included in the list. If empty all site users will be included" => "Group name - only users belonging to a group or groups with group names containing this text will be included in the list. If empty all site users will be included",
// "String to use between elements of the list if table layout is not used" => "String to use between elements of the list if table layout is not used",
// "Result limit" => "Result limit",
// "Set to sort in ascending or descending order (unsorted by default" => "Set to sort in ascending or descending order (unsorted by default",
// "Layout" => "Layout",
// "Set to table to show results in a table (not shown in a table by default)" => "Set to table to show results in a table (not shown in a table by default)",
// "Make the listed names links to various types of user information" => "Make the listed names links to various types of user information",
"User Information" => "Información del usuario",
// "User Page" => "User Page",
"User Preferences" => "Preferencias del usuario",
// "Exclude" => "Exclude",
// "Exclude certain test or admin names from the list" => "Exclude certain test or admin names from the list",
"admin" => "admin",
// "admin-test" => "admin-test",
// "test" => "test",
// "test-admin" => "test-admin",
"Preferences" => "Preferencias",
// "Redirect" => "Redirect",
// "Redirect to another page" => "Redirect to another page",
// "Wiki page name to redirect to" => "Wiki page name to redirect to",
// "Complete URL, internal or external" => "Complete URL, internal or external",
// "The ID of a perspective to switch to (requires feature_perspective)" => "The ID of a perspective to switch to (requires feature_perspective)",
// "perspective " => "perspective ",
// "nowhere" => "nowhere",
// "REDIRECT plugin: The redirection to '%s' is disabled just after saving the page" => "REDIRECT plugin: The redirection to '%s' is disabled just after saving the page",
// "REDIRECT plugin: The redirection to '%s' is disabled in preview mode. " => "REDIRECT plugin: The redirection to '%s' is disabled in preview mode. ",
// "REDIRECT plugin: redirect loop detected" => "REDIRECT plugin: redirect loop detected",
// "Regular Expression" => "Regular Expression",
// "Perform a regular expression search and replace" => "Perform a regular expression search and replace",
// "Each line of content is evaluated separately" => "Each line of content is evaluated separately",
// "Name of page containing search and replace expressions separated by two colons. Example of syntax on that page: /search pattern/::replacement text" => "Name of page containing search and replace expressions separated by two colons. Example of syntax on that page: /search pattern/::replacement text",
// "Register Member Payment" => "Register Member Payment",
// "Allows user to register and make member payment at the same time" => "Allows user to register and make member payment at the same time",
// "NA" => "NA",
// "Fixed Periods" => "Fixed Periods",
// "Give specific periods that can be chosen with a dropdown list.  Example - \"name:value;name:value;value;value;\"" => "Give specific periods that can be chosen with a dropdown list.  Example - \"name:value;name:value;value;value;\"",
// "Insufficient Privileges" => "Insufficient Privileges",
"Submit" => "Enviar",
// "You will be redirected in 5 seconds" => "You will be redirected in 5 seconds",
// "Displays the relations between the current object or a specified one and the rest of Tiki" => "Displays the relations between the current object or a specified one and the rest of Tiki",
// "Qualifiers" => "Qualifiers",
// "Comma-separated list of relation qualifiers" => "Comma-separated list of relation qualifiers",
// "Object identifier as type:itemId" => "Object identifier as type:itemId",
// "Single List" => "Single List",
// "Render all qualifiers into a single list without displaying the qualifier name" => "Render all qualifiers into a single list without displaying the qualifier name",
// "Remarks Box" => "Remarks Box",
// "Displays a comment, tip, note or warning box" => "Displays a comment, tip, note or warning box",
// "remarks text" => "remarks text",
// "Select type of remarksbox, which determines what icon and style will be displayed" => "Select type of remarksbox, which determines what icon and style will be displayed",
// "Confirm" => "Confirm",
// "Errors" => "Errors",
// "Note" => "Note",
"Warning" => "Cuidado",
// "Label displayed above the remark" => "Label displayed above the remark",
// "Use the highlight class for formatting (not used by default)" => "Use the highlight class for formatting (not used by default)",
// "Custom Icon" => "Custom Icon",
// "Enter a Tiki icon file name (with or without extension) or path to display a custom icon" => "Enter a Tiki icon file name (with or without extension) or path to display a custom icon",
"Close" => "Cerrar",
// "Show a close button (not shown by default)" => "Show a close button (not shown by default)",
// "Width (e.g. 100% or 250px - default \"\")" => "Width (e.g. 100% or 250px - default \"\")",
// "Report" => "Report",
// "Build a report, and store it in a wiki page" => "Build a report, and store it in a wiki page",
// "The wiki syntax report settings" => "The wiki syntax report settings",
// "Report View" => "Report View",
// "Report Plugin View" => "Report Plugin View",
// "Sheet" => "Sheet",
// "Report Name" => "Report Name",
// "Report Plugin Name, sometimes used headings and reference" => "Report Plugin Name, sometimes used headings and reference",
// "Edit Report" => "Edit Report",
// "RSS Feed" => "RSS Feed",
// "Display items from an RSS feed" => "Display items from an RSS feed",
// "IDs" => "IDs",
// "List of feed IDs separated by colons. ex: feedId:feedId2" => "List of feed IDs separated by colons. ex: feedId:feedId2",
// "Result Count" => "Result Count",
// "Number of results displayed" => "Number of results displayed",
// "Show date of each item (not shown by default)" => "Show date of each item (not shown by default)",
// "Show feed descriptions (not shown by default)" => "Show feed descriptions (not shown by default)",
// "Show authors (not shown by default)" => "Show authors (not shown by default)",
// "Url to a favicon to put before each entry" => "Url to a favicon to put before each entry",
// "Show the title of the feed (shown by default)" => "Show the title of the feed (shown by default)",
// "Scroll" => "Scroll",
// "Show animated text that scrolls up or down" => "Show animated text that scrolls up or down",
// "Width in pixels. Example: 600px" => "Width in pixels. Example: 600px",
// "Number of pixels followed by \"px\". Example: 600px" => "Number of pixels followed by \"px\". Example: 600px",
// "Height in pixels. Example: 450px" => "Height in pixels. Example: 450px",
// "Number of pixels followed by \"px\". Example: 450px" => "Number of pixels followed by \"px\". Example: 450px",
// "Scroll speed in number of seconds (default is 8 seconds)" => "Scroll speed in number of seconds (default is 8 seconds)",
// "SourceForge" => "SourceForge",
// "Creates a link to SourceForge tracker items" => "Creates a link to SourceForge tracker items",
// "Group ID" => "Group ID",
// "SourceForge project ID (shows as group_id in the URL of a tracker item" => "SourceForge project ID (shows as group_id in the URL of a tracker item",
// "SourceForge tracker ID (shows as atid in the URL of a tracker item" => "SourceForge tracker ID (shows as atid in the URL of a tracker item",
// "SourceForge item ID (shows as aid in the URL of a tracker item" => "SourceForge item ID (shows as aid in the URL of a tracker item",
// "First part of link tooltip identifying the type of tracker item (bug, feature request, patch or support request)" => "First part of link tooltip identifying the type of tracker item (bug, feature request, patch or support request)",
// "ShareThis" => "ShareThis",
// "Add a ShareThis button" => "Add a ShareThis button",
// "Send Services" => "Send Services",
// "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services" => "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services",
// "Aim" => "Aim",
// "Aim \$ Email" => "Aim \$ Email",
// "Aim \$ Sms" => "Aim \$ Sms",
// "Email \$ Sms" => "Email \$ Sms",
// "Button Style" => "Button Style",
// "Set button style: horizontal, vertical or rotate" => "Set button style: horizontal, vertical or rotate",
// "Rotate" => "Rotate",
// "Rotate Image" => "Rotate Image",
// "A value of y (Yes) will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping" => "A value of y (Yes) will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping",
// "Multiple Icons" => "Multiple Icons",
// "Enter list: email | facebook | twitter | sharethis, depending on which icons you'd like" => "Enter list: email | facebook | twitter | sharethis, depending on which icons you'd like",
// "First Services Shown" => "First Services Shown",
// "Input a list of post services (like Facebook, Myspace, Digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget" => "Input a list of post services (like Facebook, Myspace, Digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget",
// "Button Text" => "Button Text",
// "Custom link text for the button" => "Custom link text for the button",
// "Header Title" => "Header Title",
// "Optional header title text for the widget" => "Optional header title text for the widget",
// "Header Background" => "Header Background",
// "HTML color code (not color name) for the background color for the header if an optional header title is used" => "HTML color code (not color name) for the background color for the header if an optional header title is used",
// "Header Text Color" => "Header Text Color",
// "HTML color code (not color name) for the header text if an optional header title is used" => "HTML color code (not color name) for the header text if an optional header title is used",
// "Link text color for services" => "Link text color for services",
// "HTML color code (not color name) for the link text for all send and post services shown in the widget" => "HTML color code (not color name) for the link text for all send and post services shown in the widget",
"Pop-up" => "Pop-up",
// "A value of true will cause the widget to show in a pop-up window" => "A value of true will cause the widget to show in a pop-up window",
// "Embedded Elements" => "Embedded Elements",
// "A value of true will allow embedded elements (like flash) to be seen while iframe is loading" => "A value of true will allow embedded elements (like flash) to be seen while iframe is loading",
// "Display data from a TikiSheet" => "Display data from a TikiSheet",
"Sheet Heading" => "Cabecera de la Planilla",
// "Internal ID of the TikiSheet.  Either id or url MUST be used" => "Internal ID of the TikiSheet.  Either id or url MUST be used",
// "Sheet Url Location" => "Sheet Url Location",
// "Internal URL of the Table to use as a spreadsheet.  Either id or url MUST be used" => "Internal URL of the Table to use as a spreadsheet.  Either id or url MUST be used",
// "Simple table view y/n (Default: n = jquery.sheet view if feature enabled)" => "Simple table view y/n (Default: n = jquery.sheet view if feature enabled)",
// "Height in pixels or percentage. Default value is complete spreadsheet height" => "Height in pixels or percentage. Default value is complete spreadsheet height",
// "Editable" => "Editable",
// "Show edit button. Default 'y' depending on user's permissions" => "Show edit button. Default 'y' depending on user's permissions",
// "Show subsheets" => "Show subsheets",
// "y/n. Show multi-sheets. Default 'y'" => "y/n. Show multi-sheets. Default 'y'",
// "Range" => "Range",
// "Show a range of cells (or single cell). Default shows all. e.g. \"D1:F3\" or \"e14:e14\"" => "Show a range of cells (or single cell). Default shows all. e.g. \"D1:F3\" or \"e14:e14\"",
// "Apply custom CSS class to the containing div" => "Apply custom CSS class to the containing div",
// "New sheet in page: " => "New sheet in page: ",
"Create New Sheet" => "Crear nueva planilla",
// "Error loading spreadsheet" => "Error loading spreadsheet",
"Edit Sheet" => "Editar Hoja",
// "Collect Anonymous Shopper Info" => "Collect Anonymous Shopper Info",
// "PluginShopperinfo" => "PluginShopperinfo",
// "Collect Anonymous Shopper Info for Shopping Cart" => "Collect Anonymous Shopper Info for Shopping Cart",
// "Values to be collected" => "Values to be collected",
// "Names of values to be collected separated by : as defined in shopper profile" => "Names of values to be collected separated by : as defined in shopper profile",
// "Labels for the values to be collected" => "Labels for the values to be collected",
// "Labels of the values to be collected separated by " => "Labels of the values to be collected separated by ",
// "Show even if logged in" => "Show even if logged in",
// "Normally this is used for anonymous users but sometimes may be used when logged in also" => "Normally this is used for anonymous users but sometimes may be used when logged in also",
// "Show Pages" => "Show Pages",
// "Find pages by searching within page names" => "Find pages by searching within page names",
// "Search criteria" => "Search criteria",
// "Maximum amount of results displayed" => "Maximum amount of results displayed",
// "Display page name and/or description. Both displayed by default" => "Display page name and/or description. Both displayed by default",
// "Name & Description" => "Name & Description",
// "Skype" => "Skype",
// "Clickable Skype link" => "Clickable Skype link",
// "Name or number to call or chat with" => "Name or number to call or chat with",
// "Set whether to call or chat. Default is chat" => "Set whether to call or chat. Default is chat",
// "Call" => "Call",
"Chat" => "Chat",
"Show status" => "Mostrar estado",
// "Show a status icon or not i.e. if online/offline/etc. Default is no" => "Show a status icon or not i.e. if online/offline/etc. Default is no",
"yes" => "sí",
"no" => "no",
// "do not forget to check the tools / options/ privacy / allow my status to be show on the web" => "do not forget to check the tools / options/ privacy / allow my status to be show on the web",
// "click to" => "click to",
// "Slider" => "Slider",
// "Arrange content in a sliding area" => "Arrange content in a sliding area",
// "Content separated by /////" => "Content separated by /////",
// "Slider Titles" => "Slider Titles",
// "Pipe separated list of slider titles. Ex: slider 1|slider 2|slider 3" => "Pipe separated list of slider titles. Ex: slider 1|slider 2|slider 3",
// "Height in pixels or percentage. Default value is complete slider height" => "Height in pixels or percentage. Default value is complete slider height",
// "The theme to use in slider" => "The theme to use in slider",
// "Expand" => "Expand",
// "if y, the entire slider will expand to fit the parent element" => "if y, the entire slider will expand to fit the parent element",
// "Resize Contents" => "Resize Contents",
// "if y, solitary images/objects in the panel will expand to fit the viewport" => "if y, solitary images/objects in the panel will expand to fit the viewport",
// "Show Multiple" => "Show Multiple",
// "Set this value to a number and it will show that many slides at once" => "Set this value to a number and it will show that many slides at once",
// "Build Arrows" => "Build Arrows",
// "if y, builds the forwards and backwards buttons" => "if y, builds the forwards and backwards buttons",
// "Build Navigation" => "Build Navigation",
// "if y, builds a list of anchor links to link to each panel" => "if y, builds a list of anchor links to link to each panel",
// "Build Start Stop" => "Build Start Stop",
// "if y, builds the start/stop button and adds slideshow functionality" => "if y, builds the start/stop button and adds slideshow functionality",
// "Toggle Arrows" => "Toggle Arrows",
// "if y, side navigation arrows will slide out on hovering & hide @ other times" => "if y, side navigation arrows will slide out on hovering & hide @ other times",
// "Toggle Controls" => "Toggle Controls",
// "if y, slide in controls (navigation + play/stop button) on hover and slide change, hide @ other times" => "if y, slide in controls (navigation + play/stop button) on hover and slide change, hide @ other times",
// "Enable Arrows" => "Enable Arrows",
// "if n, arrows will be visible, but not clickable" => "if n, arrows will be visible, but not clickable",
// "Enable Navigation" => "Enable Navigation",
// "if n, navigation links will still be visible, but not clickable" => "if n, navigation links will still be visible, but not clickable",
// "Enable Start Stop" => "Enable Start Stop",
// "if n, the play/stop button will still be visible, but not clickable. Previously \"enablePlay\"" => "if n, the play/stop button will still be visible, but not clickable. Previously \"enablePlay\"",
// "Enable Keyboard" => "Enable Keyboard",
// "if n, keyboard arrow keys will not work for this slider" => "if n, keyboard arrow keys will not work for this slider",
// "Auto Play" => "Auto Play",
// "if y, the slideshow will start running; replaces \"startStopped\" option" => "if y, the slideshow will start running; replaces \"startStopped\" option",
// "Auto Play Locked" => "Auto Play Locked",
// "if y, user changing slides will not stop the slideshow" => "if y, user changing slides will not stop the slideshow",
// "Auto Play Delayed" => "Auto Play Delayed",
// "if y, starting a slideshow will delay advancing slides; if n, the slider will immediately advance to the next slide when slideshow starts" => "if y, starting a slideshow will delay advancing slides; if n, the slider will immediately advance to the next slide when slideshow starts",
// "Pause On Hover" => "Pause On Hover",
// "if y & the slideshow is active, the slideshow will pause on hover" => "if y & the slideshow is active, the slideshow will pause on hover",
// "Stop At End" => "Stop At End",
// "if y & the slideshow is active, the slideshow will stop on the last page. This also stops the rewind effect when infiniteSlides is false" => "if y & the slideshow is active, the slideshow will stop on the last page. This also stops the rewind effect when infiniteSlides is false",
// "Play Right To Left" => "Play Right To Left",
// "if y, the slideshow will move right-to-left" => "if y, the slideshow will move right-to-left",
// "Resume On Video End" => "Resume On Video End",
// "if y & the slideshow is active & a supported video is playing, it will pause the autoplay until the video is complete" => "if y & the slideshow is active & a supported video is playing, it will pause the autoplay until the video is complete",
// "Configure a slideshow. Extends the existing wiki page slideshow with notes & styles" => "Configure a slideshow. Extends the existing wiki page slideshow with notes & styles",
// "Slideshow notes - Separate with \"/////\"" => "Slideshow notes - Separate with \"/////\"",
// "The theme you want to use for the slideshow, default will be what you choose from the admin panel under Look and Feel for jQuery UI" => "The theme you want to use for the slideshow, default will be what you choose from the admin panel under Look and Feel for jQuery UI",
// "Tiki jQuery UI Theme" => "Tiki jQuery UI Theme",
// "Background Url Location" => "Background Url Location",
// "URL of the background image to use in your slideshow, overrides backgroundcolor" => "URL of the background image to use in your slideshow, overrides backgroundcolor",
// "Valid url" => "Valid url",
// "Background color to use in your slideshow, default " => "Background color to use in your slideshow, default ",
// "Any valid CSS class" => "Any valid CSS class",
// "Header font color" => "Header font color",
// "Apply a color to the headers of your slideshow" => "Apply a color to the headers of your slideshow",
// "Any HTML color" => "Any HTML color",
// "Header background color" => "Header background color",
// "Slide font color" => "Slide font color",
// "Apply a color to the slides of your slideshow" => "Apply a color to the slides of your slideshow",
// "Line Item highlight color" => "Line Item highlight color",
// "Apply a color to the line item when mouse over" => "Apply a color to the line item when mouse over",
// "Slide Seconds" => "Slide Seconds",
// "How many seconds a slide will be open while playing, overridden when slideduration is set" => "How many seconds a slide will be open while playing, overridden when slideduration is set",
// "Second count" => "Second count",
// "Slide Milliseconds" => "Slide Milliseconds",
// "How many milliseconds a slide will be open while playing" => "How many milliseconds a slide will be open while playing",
// "Text Side" => "Text Side",
// "The side on which you would like to display text if there are images that are resized or present" => "The side on which you would like to display text if there are images that are resized or present",
// "Smarty function" => "Smarty function",
// "Insert a Smarty function" => "Insert a Smarty function",
// "The name of the Smarty function that the button will activate. Available functions are: lib/smarty/libs/plugins/function.[name].php" => "The name of the Smarty function that the button will activate. Available functions are: lib/smarty/libs/plugins/function.[name].php",
// "Snarf" => "Snarf",
// "Display the contents of another web page" => "Display the contents of another web page",
// "Full URL to the page to include" => "Full URL to the page to include",
// "Regular Expression Pattern" => "Regular Expression Pattern",
// "PCRE-compliant regular expression pattern to find the parts you want changed" => "PCRE-compliant regular expression pattern to find the parts you want changed",
// "Regular Expression Replacement" => "Regular Expression Replacement",
// "PCRE-compliant regular expression replacement syntax showing what the content should be changed to" => "PCRE-compliant regular expression replacement syntax showing what the content should be changed to",
// "Enable/disable word wrapping of snippets of code (enabled by default)" => "Enable/disable word wrapping of snippets of code (enabled by default)",
// "Syntax highlighting to use for code snippets. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, .." => "Syntax highlighting to use for code snippets. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, ..",
// "Set to 1 (Yes) to add line numbers to code snippets (not shown by default)" => "Set to 1 (Yes) to add line numbers to code snippets (not shown by default)",
// "Parse wiki syntax within the code snippet (not parsed by default)" => "Parse wiki syntax within the code snippet (not parsed by default)",
// "Switch the text display from left to right to right to left" => "Switch the text display from left to right to right to left",
// "HTML Content" => "HTML Content",
// "Set to 1 (Yes) to display the content as is instead of escaping HTML special chars (not set by default)" => "Set to 1 (Yes) to display the content as is instead of escaping HTML special chars (not set by default)",
// "Cache Url" => "Cache Url",
// "Cache time in minutes. Default is to use site preference, Set to 0 for no cache" => "Cache time in minutes. Default is to use site preference, Set to 0 for no cache",
// "Text to click on to fetch the url via ajax" => "Text to click on to fetch the url via ajax",
// "Sort lines of text" => "Sort lines of text",
// "Data to sort, one entry per line" => "Data to sort, one entry per line",
"Order" => "Orden",
// "Set the sort order of lines of content (default is ascending)" => "Set the sort order of lines of content (default is ascending)",
// "Reverse" => "Reverse",
// "Shuffle" => "Shuffle",
// "Easily arrange content on a page into rows and columns" => "Easily arrange content on a page into rows and columns",
// "Join Columns" => "Join Columns",
// "Generate the colspan attribute if columns are missing" => "Generate the colspan attribute if columns are missing",
// "Fixed Size" => "Fixed Size",
// "Generate the width attribute for the columns" => "Generate the width attribute for the columns",
// "Column Sizes" => "Column Sizes",
// "Specify all column widths in number of pixels or percent, separating each width by a pipe (|)" => "Specify all column widths in number of pixels or percent, separating each width by a pipe (|)",
"First" => "Primero",
// "Cells specified are ordered first left to right across rows (default) or top to bottom down columns" => "Cells specified are ordered first left to right across rows (default) or top to bottom down columns",
"Column" => "Columna",
// "Line" => "Line",
// "Display edit icon for each section" => "Display edit icon for each section",
// "Custom Class" => "Custom Class",
// "Add a class to customize the design" => "Add a class to customize the design",
// "SQL" => "SQL",
// "Query a MySQL database and display the results" => "Query a MySQL database and display the results",
// "The SQL query goes in the body. Example: SELECT column1, column2 FROM table" => "The SQL query goes in the body. Example: SELECT column1, column2 FROM table",
// "DSN Name" => "DSN Name",
// "DSN name of the database being queried. The DSN name needs to first be defined at tiki-admin_dsn.php" => "DSN name of the database being queried. The DSN name needs to first be defined at tiki-admin_dsn.php",
"Missing db param" => "Falta parámetro de db",
// "Could not obtain valid DSN connection" => "Could not obtain valid DSN connection",
// "Stat" => "Stat",
// "Show various statistics for an object" => "Show various statistics for an object",
// "Object type to show stats for. Choices are article, trackeritem or wiki, or a combination of these separated by colons" => "Object type to show stats for. Choices are article, trackeritem or wiki, or a combination of these separated by colons",
"Article & Tracker Item" => "Artículo & Ítem de Formulario-bd",
"Article & Tracker Item & Wiki" => "Artículo & Ítem de Formulario-bd & Wiki",
"Article & Wiki" => "Artículo & Wiki",
"Article & Wiki & Tracker Item" => "Artículo & Wiki & Ítem de Formulario-bd",
"Tracker Item" => "Ítem de Formulario-bd",
"Tracker Item & Article" => "Ítem de Formulario-bd & Artículo",
"Tracker Item & Article & Wiki" => "Ítem de Formulario-bd & Artículo & Wiki",
"Tracker Item & Wiki" => "Ítem de Formulario-bd & Wiki",
"Tracker Item & Wiki & Article" => "Ítem de Formulario-bd & Wiki & Artículo",
"Wiki & Article" => "Wiki & Article",
"Wiki & Article & Tracker Item" => "Wiki & Artículo & Ítem de Formulario-bd",
"Wiki & Tracker Item" => "Wiki & Ítem de Formulario-bd",
"Wiki & Tracker Item & Article" => "Wiki & Ítem de Formulario-bd & Artículo",
"Parent ID" => "ID Parental",
// "Enter a tracker ID to restrict stats to that tracker (for use with trackeritems only)" => "Enter a tracker ID to restrict stats to that tracker (for use with trackeritems only)",
// "Last 24 Hours" => "Last 24 Hours",
// "Added and/or viewed in the last 24 hours (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed in the last 24 hours (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
"Added" => "Añadida",
// "Added and Viewed" => "Added and Viewed",
// "Viewed" => "Viewed",
// "Viewed & Added" => "Viewed & Added",
"Today" => "Hoy",
// "Added and/or viewed since the beginning of the day (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the day (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Last 7 Days" => "Last 7 Days",
// "Added and/or viewed in the last 7 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed in the last 7 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "This Week" => "This Week",
// "Added and/or viewed since the beginning of the week (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the week (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Last Month" => "Last Month",
// "Added and/or viewed last month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed last month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "This Month" => "This Month",
// "Added and/or viewed since the beginning of the month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Last Year" => "Last Year",
// "Added and/or viewed in the last 365 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed in the last 365 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "This Year" => "This Year",
// "Added and/or viewed since the beginning of the year (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the year (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Incorrect parameter: " => "Incorrect parameter: ",
// "Subscript" => "Subscript",
// "Apply subscript font to text" => "Apply subscript font to text",
// "Subscribe Group" => "Subscribe Group",
// "Allow users to subscribe to a group" => "Allow users to subscribe to a group",
// "text displayed before the button" => "text displayed before the button",
// "Group name to subscribe to or unsubscribe from" => "Group name to subscribe to or unsubscribe from",
// "Subscribe Text" => "Subscribe Text",
// "Subscribe text, containing %s as the placeholder for the group name" => "Subscribe text, containing %s as the placeholder for the group name",
"Subscribe" => "Suscribir",
// "Unsubscribe Text" => "Unsubscribe Text",
// "Unsubscribe text, containing %s as the placeholder for the group name" => "Unsubscribe text, containing %s as the placeholder for the group name",
// "Unsubscribe" => "Unsubscribe",
// "Subscribe Action" => "Subscribe Action",
// "Subscribe button label, containing %s as the placeholder for the group name" => "Subscribe button label, containing %s as the placeholder for the group name",
// "Unsubscribe Action" => "Unsubscribe Action",
// "Unsubscribe button label, containing %s as the placeholder for the group name" => "Unsubscribe button label, containing %s as the placeholder for the group name",
// "Postsubscribe URL" => "Postsubscribe URL",
// "URL to send the user to after subscribing, if required" => "URL to send the user to after subscribing, if required",
// "Postunsubscribe URL" => "Postunsubscribe URL",
// "URL to send the user to after unsubscribing, if required" => "URL to send the user to after unsubscribing, if required",
// "Make this the default group text, containing %s as the placeholder for the group name." => "Make this the default group text, containing %s as the placeholder for the group name.",
// "Not Default Group" => "Not Default Group",
// "Stop this being default group text, containing %s as the placeholder for the group name." => "Stop this being default group text, containing %s as the placeholder for the group name.",
// "Default Group Action" => "Default Group Action",
// "Default group button label. Will subscribe to the group first if not already a member" => "Default group button label. Will subscribe to the group first if not already a member",
// "Not Default Group Action" => "Not Default Group Action",
// "Stop this being default group button label. Does not unsubscribe from the group" => "Stop this being default group button label. Does not unsubscribe from the group",
// "Group To Set When Not Default" => "Group To Set When Not Default",
// "Group name to set as default when user stops this group being it" => "Group name to set as default when user stops this group being it",
// "Go To Default Group Home" => "Go To Default Group Home",
// "Redirect to new home page after default group change. (Default y)" => "Redirect to new home page after default group change. (Default y)",
// "Subscribe Groups" => "Subscribe Groups",
// "Allow users to subscribe to a list of groups" => "Allow users to subscribe to a list of groups",
// "Text shown in the dropdown box. Default: \"Subscribe to a group\"" => "Text shown in the dropdown box. Default: \"Subscribe to a group\"",
// "Show Subscribe Box" => "Show Subscribe Box",
// "Show the subscribe box (shown by default). Will not show if there are no other groups the user may register for" => "Show the subscribe box (shown by default). Will not show if there are no other groups the user may register for",
// "Subscribe Box Style" => "Subscribe Box Style",
// "Style to show the subscribe box, either dropdown or table" => "Style to show the subscribe box, either dropdown or table",
// "Show Default" => "Show Default",
// "Shows which group is the user's default group (if any) and allows the user to change his default group" => "Shows which group is the user's default group (if any) and allows the user to change his default group",
// "Group Description" => "Group Description",
// "Show the description of the group (not shown by default)" => "Show the description of the group (not shown by default)",
// "Colon separated list of groups. By default the list of groups available to the user" => "Colon separated list of groups. By default the list of groups available to the user",
// "Only list groups that include the group being specified here" => "Only list groups that include the group being specified here",
// "Default URL" => "Default URL",
// "Page user will be directed to after clicking on icon to change default group" => "Page user will be directed to after clicking on icon to change default group",
// "Leader Group Name" => "Leader Group Name",
// "Name of group for leaders of the group, where \"groupName\" will be substituted by the group name" => "Name of group for leaders of the group, where \"groupName\" will be substituted by the group name",
// "Pending Users Group Name" => "Pending Users Group Name",
// "Name of group for users that are waiting for approval to enter the group, where \"groupName\" will be substituted by the group name" => "Name of group for users that are waiting for approval to enter the group, where \"groupName\" will be substituted by the group name",
// "Group Management Page Name" => "Group Management Page Name",
// "Name of wiki page for group management by leaders, where \"groupName\" will be substituted by the group name" => "Name of wiki page for group management by leaders, where \"groupName\" will be substituted by the group name",
// "Hide link for groups including" => "Hide link for groups including",
// "Hide link to group home page for groups that include the group being specified here" => "Hide link to group home page for groups that include the group being specified here",
// "Always allow leaving group" => "Always allow leaving group",
// "Always allow leaving group even if userChoice for group is set to n" => "Always allow leaving group even if userChoice for group is set to n",
// "You do not have permission to subscribe to groups" => "You do not have permission to subscribe to groups",
// "Subscribe newsletter" => "Subscribe newsletter",
// "Allow users to subscribe to a newsletter" => "Allow users to subscribe to a newsletter",
// "Invitation message" => "Invitation message",
// "Newsletter ID" => "Newsletter ID",
// "Identification number (nlId) of the Newsletter that you want to allow the users to subscribe to" => "Identification number (nlId) of the Newsletter that you want to allow the users to subscribe to",
// "Confirmation Message" => "Confirmation Message",
// "Confirmation message after posting form. The plugin body is then the button label" => "Confirmation message after posting form. The plugin body is then the button label",
// "Button label. The plugin body is then the confirmation message" => "Button label. The plugin body is then the confirmation message",
// "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)" => "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)",
// "Already subscribed" => "Already subscribed",
// "Superscript" => "Superscript",
// "Apply superscript font to text" => "Apply superscript font to text",
// "Display a survey" => "Display a survey",
// "Wiki Page to redirect the user after his vote" => "Wiki Page to redirect the user after his vote",
// "Arrange content in tabs" => "Arrange content in tabs",
// "Tabs content separated by /////" => "Tabs content separated by /////",
// "Tabset Name" => "Tabset Name",
// "Unique tabset name (if you want it to remember its last state). Ex: user_profile_tabs" => "Unique tabset name (if you want it to remember its last state). Ex: user_profile_tabs",
// "Tab Titles" => "Tab Titles",
// "Pipe separated list of tab titles. Ex: tab 1|tab 2|tab 3" => "Pipe separated list of tab titles. Ex: tab 1|tab 2|tab 3",
// "Toggle Tabs" => "Toggle Tabs",
// "Allows to toggle from tabs to no tabs view" => "Allows to toggle from tabs to no tabs view",
"Inside Pretty Tracker" => "Dentro del Formulario-bd bonito",
// "Parse pretty tracker variables within tabs" => "Parse pretty tracker variables within tabs",
// "No tab title specified. At least one has to be set to make the tabs appear" => "No tab title specified. At least one has to be set to make the tabs appear",
// "Apply an HTML tag to content" => "Apply an HTML tag to content",
// "Tag Name" => "Tag Name",
// "Any valid HTML tag, span by default" => "Any valid HTML tag, span by default",
// "CSS Style" => "CSS Style",
// "Equivalent to the style attribute of an HTML tag" => "Equivalent to the style attribute of an HTML tag",
// "TextLink" => "TextLink",
// "Links your article to a site using forwardlink protocol" => "Links your article to a site using forwardlink protocol",
// "Text to link to forwardlink" => "Text to link to forwardlink",
// "ClipboardData" => "ClipboardData",
// "ForwardLinks To: " => "ForwardLinks To: ",
// "Timeline" => "Timeline",
// "Display a timeline" => "Display a timeline",
// "Display the eventlist items represented in the page. (all, center, or custom as a CSS selector)" => "Display the eventlist items represented in the page. (all, center, or custom as a CSS selector)",
// "Width of the timeline as CSS units (default: \"100%\")" => "Width of the timeline as CSS units (default: \"100%\")",
// "Height of the timeline as CSS units (default: \"400px\")" => "Height of the timeline as CSS units (default: \"400px\")",
// "Lower Bound" => "Lower Bound",
// "Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format",
// "Upper Bound" => "Upper Bound",
// "Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format",
// "Primary Scale Unit" => "Primary Scale Unit",
// "Unit of time to use for the primary scale (default to Month)" => "Unit of time to use for the primary scale (default to Month)",
// "Decade" => "Decade",
// "Century" => "Century",
// "Secondary Scale Unit" => "Secondary Scale Unit",
// "Unit of time to use for the secondary scale (default to empty)" => "Unit of time to use for the secondary scale (default to empty)",
// "TimeSheet" => "TimeSheet",
// "A portable timesheet usable in a webpage" => "A portable timesheet usable in a webpage",
// "Title Search" => "Title Search",
// "Search pages by title" => "Search pages by title",
// "Search Criteria" => "Search Criteria",
// "Portion of a page name" => "Portion of a page name",
// "Also show page hits or user" => "Also show page hits or user",
// "Pipe-separated list of page names to exclude from results" => "Pipe-separated list of page names to exclude from results",
"No Header" => "Sin Cabecera",
// "Set to 1 (Yes) to have no header for the search results" => "Set to 1 (Yes) to have no header for the search results",
"No pages found for title search" => "No se encontraron páginas en la búsqueda por título",
"One page found for title search" => "Se encontró una página en la búsqueda por título",
"pages found for title search" => "páginas encontradas en la búsqueda por título",
// "Table of Contents (Structure)" => "Table of Contents (Structure)",
// "Display a table of contents of pages or sub-pages" => "Display a table of contents of pages or sub-pages",
// "Maximum Depth" => "Maximum Depth",
// "Maximum number of levels to display. On very large structures, this should be limited. Zero means no limit (and is the default)" => "Maximum number of levels to display. On very large structures, this should be limited. Zero means no limit (and is the default)",
"Structure ID" => "ID de la Estructura",
// "By default, structure for the current page will be displayed. Alternate structure may be provided" => "By default, structure for the current page will be displayed. Alternate structure may be provided",
// "Order items in ascending or descending order (default is ascending)" => "Order items in ascending or descending order (default is ascending)",
// "Show the page description instead of the page name" => "Show the page description instead of the page name",
// "Show Numbering" => "Show Numbering",
// "Display the section numbers or not" => "Display the section numbers or not",
// "Style to apply" => "Style to apply",
// "By default, the table of contents for the current page will be displayed. Alternate page may be provided" => "By default, the table of contents for the current page will be displayed. Alternate page may be provided",
// "Top Friends" => "Top Friends",
// "List top-scoring users" => "List top-scoring users",
// "Maximum result count" => "Maximum result count",
// "Set whether public or not" => "Set whether public or not",
"Translate" => "Traducir",
// "Translate text to the user language" => "Translate text to the user language",
// "Create a form in a wiki page to populate a tracker" => "Create a form in a wiki page to populate a tracker",
// "Numeric value representing the tracker ID" => "Numeric value representing the tracker ID",
// "Colon-separated list of field IDs to be displayed. Example: 2:4:5  If empty, all fields will be shown" => "Colon-separated list of field IDs to be displayed. Example: 2:4:5  If empty, all fields will be shown",
// "Label on the submit button. Default is \"Save\"" => "Label on the submit button. Default is \"Save\"",
// "Display the title of the tracker (not shown by default)" => "Display the title of the tracker (not shown by default)",
// "Show the tracker's description (not shown by default)" => "Show the tracker's description (not shown by default)",
// "Mark Mandatory" => "Mark Mandatory",
// "Indicate mandatory fields with an asterisk (shown by default)" => "Indicate mandatory fields with an asterisk (shown by default)",
// "Show Status" => "Show Status",
// "Show the status of the items (not shown by default)" => "Show the status of the items (not shown by default)",
// "Embedded" => "Embedded",
// "To send an email once the tracker item has been created. Format: from" => "To send an email once the tracker item has been created. Format: from",
"to" => "a",
// "Email format" => "Email format",
// "Text or HTML setting" => "Text or HTML setting",
// "URL the user is sent to after the form is submitted" => "URL the user is sent to after the form is submitted",
// "URL Target" => "URL Target",
// "Set the target parameter for the url (determines whether target will open in a new page, etc.)" => "Set the target parameter for the url (determines whether target will open in a new page, etc.)",
"Parent" => "Superior",
// "Self" => "Self",
// "Values" => "Values",
// "Colon-separated list of default values for the fields. First value corresponds to first field, second value to second field, etc" => "Colon-separated list of default values for the fields. First value corresponds to first field, second value to second field, etc",
"Overwrite" => "Sobrescribir",
// "Overwrite current field values of the item with the input values" => "Overwrite current field values of the item with the input values",
// "Display columns in the order listed in the fields parameter instead of by field ID (field ID order is used by default" => "Display columns in the order listed in the fields parameter instead of by field ID (field ID order is used by default",
"Preview" => "Vista previa",
// "Label for the preview button. Default" => "Label for the preview button. Default",
// "Label for the reset button, to return all fields to their default values" => "Label for the reset button, to return all fields to their default values",
"reset" => "reiniciar",
// "Status of the item used in combination with" => "Status of the item used in combination with",
// "ItemId" => "ItemId",
// "ItemId allowing for editing an item" => "ItemId allowing for editing an item",
// "Ignore ItemId" => "Ignore ItemId",
// "Do not filter on the parameter itemId if in the url" => "Do not filter on the parameter itemId if in the url",
// "Template File" => "Template File",
"Name of the template used to display the tracker items" => "Nnombre de la plantilla usada para mostrar los ítems de formulario-bd",
"Name of the wiki page containing the template to display the tracker items" => "Nnombre de la página wiki que contiene la plantilla para mostrar los ítems de formularios-bd",
// "New Status" => "New Status",
// "Default status applied to newly created items" => "Default status applied to newly created items",
// "Pending" => "Pending",
// "Specify the width in pixels or percentage of the first column (the labels) in the tracker form" => "Specify the width in pixels or percentage of the first column (the labels) in the tracker form",
// "Autosave fields" => "Autosave fields",
// "Colon-separated list of field IDs to be automatically filled with values" => "Colon-separated list of field IDs to be automatically filled with values",
// "Autosavevalue" => "Autosavevalue",
// "Colon-separated values corresponding to autosavefields" => "Colon-separated values corresponding to autosavefields",
// "Increase-only autosave fields" => "Increase-only autosave fields",
// "Colon-separated list of field IDs being autosaved whose value can only go up, not down" => "Colon-separated list of field IDs being autosaved whose value can only go up, not down",
// "Registration Fields" => "Registration Fields",
// "Add registration fields such as Username and Password" => "Add registration fields such as Username and Password",
// "Output To Wiki" => "Output To Wiki",
// "Output result to a new wiki page with the name taken from the input for the specified fieldId" => "Output result to a new wiki page with the name taken from the input for the specified fieldId",
// "Discard After Output" => "Discard After Output",
// "Used when results are output to a wiki page to discard the tracker item itself once the wiki page is created" => "Used when results are output to a wiki page to discard the tracker item itself once the wiki page is created",
// "Template Page" => "Template Page",
// "Name of the wiki page containing the template to format the output to wiki page" => "Name of the wiki page containing the template to format the output to wiki page",
// "Multiple Fill Fields" => "Multiple Fill Fields",
// "Colon-separated list of field IDs to be filled with multiple values, to create multiple items in one save. Example: 2:4:5  If empty, only one item will be created. Only for item creation" => "Colon-separated list of field IDs to be filled with multiple values, to create multiple items in one save. Example: 2:4:5  If empty, only one item will be created. Only for item creation",
// "Separator for Multiple Fill Fields" => "Separator for Multiple Fill Fields",
// "Choose separator between fields in each line of the Multiple Fill text area. Default is pipe (|)" => "Choose separator between fields in each line of the Multiple Fill text area. Default is pipe (|)",
// "Multiple Fill Fields defaults" => "Multiple Fill Fields defaults",
// "Colon-separated list of default values for Multiple Fill Fields" => "Colon-separated list of default values for Multiple Fill Fields",
// "Embed the tracker in a form tag" => "Embed the tracker in a form tag",
// "If set to Yes, the tracker is contained in a <form> tag and has action buttons" => "If set to Yes, the tracker is contained in a <form> tag and has action buttons",
// "The page to output the results to already exists. Try another name" => "The page to output the results to already exists. Try another name",
"Tracker was modified at " => "El Formulario-bd fue modificado en ",
// "Incorrect fieldId" => "Incorrect fieldId",
// "Following fields are incorrect" => "Following fields are incorrect",
// "Each line is a list of %d field values separated with: %s" => "Each line is a list of %d field values separated with: %s",
// "Missing wiki template page \"%0\"" => "Missing wiki template page \"%0\"",
// "You do not have permission to insert an item" => "You do not have permission to insert an item",
// "Incorrect item" => "Incorrect item",
// "You do not have permission to modify an item" => "You do not have permission to modify an item",
// "The page to output the results to contains the following prohibited characters: %0. Try another name" => "The page to output the results to contains the following prohibited characters: %0. Try another name",
"Invalid email" => "Correo-e inválido",
"Passwords do not match" => "No coinciden las dos contraseñas",
"Insert one item per line" => "Inserta un ítem por linea",
"Fields marked with a * are mandatory." => "Los campos marcados con un * son obligatorios.",
"Tracker Comments" => "Comentarios de Formularios-bd",
"Display the number of tracker comments" => "Muestra el número de comentarios del formulario-bd",
"Item Count" => "Recuento de ítems",
// "Determines whether the number of items will be shown (not shown by default)" => "Determines whether the number of items will be shown (not shown by default)",
// "Enter a user name to select the items of the current user" => "Enter a user name to select the items of the current user",
// "a user name" => "a user name",
// "Comments found" => "Comments found",
"Filters" => "Filtros",
// "The list of fields that can be used as filters along with their formats. The field number and format are separated by a / and multile fields are separated by \":\". Format choices are: d - dropdown; r - radio buttons; m - multiple choice dropdown; c - checkbox; t - text with wild characters; T - exact text match; i - initials; sqlsearch - advanced search; >, <, >=, <= - greater than, less than, greater than or equal, less than or equal. Example" => "The list of fields that can be used as filters along with their formats. The field number and format are separated by a / and multile fields are separated by \":\". Format choices are: d - dropdown; r - radio buttons; m - multiple choice dropdown; c - checkbox; t - text with wild characters; T - exact text match; i - initials; sqlsearch - advanced search; >, <, >=, <= - greater than, less than, greater than or equal, less than or equal. Example",
// "Label on the submit button. Default: \"Filter\". Use a space character to omit the button (for use in datachannels etc)" => "Label on the submit button. Default: \"Filter\". Use a space character to omit the button (for use in datachannels etc)",
// "Display List" => "Display List",
// "Show the full list (before filtering) initially (filtered list shown by default)" => "Show the full list (before filtering) initially (filtered list shown by default)",
// "Displays all the filters on the same line (not shown on same line by default)" => "Displays all the filters on the same line (not shown on same line by default)",
// "Yes with field label in dropdown" => "Yes with field label in dropdown",
// "No Toggle" => "No Toggle",
// "The toggle button to show/hide filters will not be shown if set to y (Yes). Default is to show the toggle" => "The toggle button to show/hide filters will not be shown if set to y (Yes). Default is to show the toggle",
// "Export CSV" => "Export CSV",
// "Label for an export button. Leave blank to show the usual \"Filter\" button instead" => "Label for an export button. Leave blank to show the usual \"Filter\" button instead",
// "Google Map Buttons" => "Google Map Buttons",
// "Display Mapview and Listview buttons" => "Display Mapview and Listview buttons",
"Tracker Filter" => "Filtro del Formulario-bd",
// "Create a form to filter tracker fields" => "Create a form to filter tracker fields",
// "notice" => "notice",
// "tracker field type not processed yet" => "tracker field type not processed yet",
"Tracker If" => "Formulario-bd Si",
// "Display content based on results of a tracker field test" => "Display content based on results of a tracker field test",
// "Ignore" => "Ignore",
// "Ignore test in edit mode" => "Ignore test in edit mode",
"Copy Tracker Item" => "Copia el Ítem del Formulario-bd",
// "PluginTrackerItemCopy" => "PluginTrackerItemCopy",
// "Will not work with category or certain special fields, copies only data from specified fields" => "Will not work with category or certain special fields, copies only data from specified fields",
// "Tracker from which to copy item, joined tracker ids separated by " => "Tracker from which to copy item, joined tracker ids separated by ",
// "Fields links that are related to this tracker that you would like to join on, separated by " => "Fields links that are related to this tracker that you would like to join on, separated by ",
// "Field IDs to copy" => "Field IDs to copy",
// "Field IDs to copy old value of, separated by :, joined fields separated by |" => "Field IDs to copy old value of, separated by :, joined fields separated by |",
// "Field IDs to update values with" => "Field IDs to update values with",
// "Field IDs to update with new values specified, separated by :, joined fields separated by |" => "Field IDs to update with new values specified, separated by :, joined fields separated by |",
// "New Values" => "New Values",
// "New Values to replace for the field IDs specified, separated by :, joined fields separated by |, -randomstring- will generate random string; and f_xx to use value of field xx of itemId" => "New Values to replace for the field IDs specified, separated by :, joined fields separated by |, -randomstring- will generate random string; and f_xx to use value of field xx of itemId",
// "ID of item to make copy of, otherwise input is asked for" => "ID of item to make copy of, otherwise input is asked for",
// "Make this number of copies on load" => "Make this number of copies on load",
// "Set the number of copies to make on load of plugin automatically" => "Set the number of copies to make on load of plugin automatically",
// "Returns array non-interactively" => "Returns array non-interactively",
// "If y, returns array of new information instead of displaying results to screen, used in non-interactive mode" => "If y, returns array of new information instead of displaying results to screen, used in non-interactive mode",
// "Missing mandatory parameters" => "Missing mandatory parameters",
// "Number of update fields do not match new values" => "Number of update fields do not match new values",
"Tracker Item Field" => "Campo del Ítem del Formulario-bd",
// "Display or test the value of a tracker item field" => "Display or test the value of a tracker item field",
// "Wiki text containing an {ELSE} marker" => "Wiki text containing an {ELSE} marker",
// "Numeric value representing the item ID. Default is the user tracker item for the current user" => "Numeric value representing the item ID. Default is the user tracker item for the current user",
// "Numeric value representing the field ID displayed or tested" => "Numeric value representing the field ID displayed or tested",
// "Colon separated list of field IDs. Default is all fields" => "Colon separated list of field IDs. Default is all fields",
"Status of the tracker item" => "Estatus del ítem del formulario-bd",
// "Open & Pending" => "Open & Pending",
// "Open & Closed" => "Open & Closed",
// "Pending & Closed" => "Pending & Closed",
// "Open, Pending & Closed" => "Open, Pending & Closed",
// "Set to 1 (Yes) to test whether a field is empty (if value parameter is empty) or has a value the same as the value parameter" => "Set to 1 (Yes) to test whether a field is empty (if value parameter is empty) or has a value the same as the value parameter",
// "Value to compare against" => "Value to compare against",
// "You are not allowed to view this item" => "You are not allowed to view this item",
// "You are not allowed to view this field" => "You are not allowed to view this field",
"Tracker List" => "Lista de Formulario-bd",
// "List, filter and sort the items in a tracker" => "List, filter and sort the items in a tracker",
// "Colon-separated list of field IDs for the fields to be displayed. Example: 2:4:5" => "Colon-separated list of field IDs for the fields to be displayed. Example: 2:4:5",
// "Colon-separated list of fields which will display in a tooltip on mouse over. Example: 6:7" => "Colon-separated list of fields which will display in a tooltip on mouse over. Example: 6:7",
// "Sticky Popup" => "Sticky Popup",
// "Choose whether the tooltip will stay displayed on mouse out (does not stay open by default)" => "Choose whether the tooltip will stay displayed on mouse out (does not stay open by default)",
// "Show Links" => "Show Links",
// "Show links to each tracker item (not shown by default)" => "Show links to each tracker item (not shown by default)",
// "Show Item Count" => "Show Item Count",
// "Show the number of items found (not shown by default)" => "Show the number of items found (not shown by default)",
// "Show Initials" => "Show Initials",
// "Show an alphabetical index by first letter to assist in navigation (not shown by default)" => "Show an alphabetical index by first letter to assist in navigation (not shown by default)",
// "Creation date display is based on tracker settings unless overriden here" => "Creation date display is based on tracker settings unless overriden here",
// "Last Modification Date" => "Last Modification Date",
// "Last modification date display is based on tracker settings unless overriden here" => "Last modification date display is based on tracker settings unless overriden here",
// "Show Field Name" => "Show Field Name",
// "Use the field names as column titles (used by default)" => "Use the field names as column titles (used by default)",
// "Show Item Rank" => "Show Item Rank",
// "Show item ranks (not shown by default)" => "Show item ranks (not shown by default)",
// "Only show items matching certain status filters (only items with open status shown by default)" => "Only show items matching certain status filters (only items with open status shown by default)",
// "Sort rows in ascending or descending order based on field ID, date created or date last modified using these values: " => "Sort rows in ascending or descending order based on field ID, date created or date last modified using these values: ",
// "(replacing fieldId with the field ID number)" => "(replacing fieldId with the field ID number)",
// "Sort Choice" => "Sort Choice",
// "Add a dropdown of sorting choices. Example with two sorting choices: created_desc|Newest first: lastModif_desc|Last modified first" => "Add a dropdown of sorting choices. Example with two sorting choices: created_desc|Newest first: lastModif_desc|Last modified first",
// "Maximum number of items to display or -1 for all values. Defaults to max records preference, if set" => "Maximum number of items to display or -1 for all values. Defaults to max records preference, if set",
// "Offset of first item. Default is no offset" => "Offset of first item. Default is no offset",
// "Fix offset always (no pagination)" => "Fix offset always (no pagination)",
// "Fix offset to that specified, disallow pagination" => "Fix offset to that specified, disallow pagination",
// "Show Pagination" => "Show Pagination",
// "Determines whether pagination will be shown (shown by default)" => "Determines whether pagination will be shown (shown by default)",
// "Filter Field" => "Filter Field",
// "Colon separated list of fields to allow filtering on" => "Colon separated list of fields to allow filtering on",
// "Filter Value" => "Filter Value",
// "Filter value of the filterfield. For better performance, use exactvalue instead" => "Filter value of the filterfield. For better performance, use exactvalue instead",
// "Exact Value" => "Exact Value",
// "Exact value of the filter" => "Exact value of the filter",
// "Adds a checkbox on each line to be able to do an action" => "Adds a checkbox on each line to be able to do an action",
// "e.g. fieldId/postName/Title/Submit/ActionUrl/tpl/radio|dropdown" => "e.g. fieldId/postName/Title/Submit/ActionUrl/tpl/radio|dropdown",
// "goIfOne" => "goIfOne",
// "Go directly to tiki-view_tracker_item.php if only one item is found" => "Go directly to tiki-view_tracker_item.php if only one item is found",
// "More" => "More",
// "Show a 'more' button that links to tiki-view_tracker.php (not shown by default)" => "Show a 'more' button that links to tiki-view_tracker.php (not shown by default)",
// "More URL" => "More URL",
// "More link pointing to specified URL instead of default tracker item link" => "More link pointing to specified URL instead of default tracker item link",
// "Display only the items of the current user, the current page name or the current IP address" => "Display only the items of the current user, the current page name or the current IP address",
// "Use content of the tpl file as template to display the item" => "Use content of the tpl file as template to display the item",
// "Wiki Page" => "Wiki Page",
// "Use content of the wiki page as template to display the item. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins" => "Use content of the wiki page as template to display the item. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins",
// "Template file in a Wiki page" => "Template file in a Wiki page",
// "Use content of the wiki page as template to display the item but with as little parsing on the content as with a tpl on disk. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins" => "Use content of the wiki page as template to display the item but with as little parsing on the content as with a tpl on disk. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins",
// "View User" => "View User",
// "Will display the items of the specified user" => "Will display the items of the specified user",
// "Item ID separated with " => "Item ID separated with ",
// "To restrict the list to these item IDs" => "To restrict the list to these item IDs",
// "Ignore the itemId url parameter when filtering list (not ignored by default)" => "Ignore the itemId url parameter when filtering list (not ignored by default)",
// "The link that will be on each main field" => "The link that will be on each main field",
// "Left Deliminator" => "Left Deliminator",
// "Smarty left delimiter for Latex generation" => "Smarty left delimiter for Latex generation",
// "Right Deliminator" => "Right Deliminator",
// "Smarty right delimiter for Latex generation" => "Smarty right delimiter for Latex generation",
// "List Mode" => "List Mode",
// "Set output format. Yes (y) displays tracker list view with truncated values (default); \n\t\t\t\t\t\t\t\tNo (n) displays in tracker item view; Comma Separated Values (csv) outputs without any HTML formatting" => "Set output format. Yes (y) displays tracker list view with truncated values (default); \n\t\t\t\t\t\t\t\tNo (n) displays in tracker item view; Comma Separated Values (csv) outputs without any HTML formatting",
// "Comma Separated Values" => "Comma Separated Values",
// "Export Button" => "Export Button",
// "Show an export button (not shown by default)" => "Show an export button (not shown by default)",
// "Compute" => "Compute",
// "Sum or average all the values of a field and displays it at the bottom of the table" => "Sum or average all the values of a field and displays it at the bottom of the table",
// "fieldId" => "fieldId",
// "Silent" => "Silent",
// "Show nothing if no items found (the table header and a 'No records found' message is shown by default)" => "Show nothing if no items found (the table header and a 'No records found' message is shown by default)",
// "Show Delete" => "Show Delete",
// "Show a delete option (not shown by default)" => "Show a delete option (not shown by default)",
// "Show Open Item" => "Show Open Item",
// "Show an open item  option (not shown by default)" => "Show an open item  option (not shown by default)",
// "Show Close Item" => "Show Close Item",
// "Show a close item option (not shown by default)" => "Show a close item option (not shown by default)",
// "Show Pending Item" => "Show Pending Item",
// "Show a pending item option (not shown by default)" => "Show a pending item option (not shown by default)",
// "Show Watch Button" => "Show Watch Button",
// "Show a watch button (not shown by default)" => "Show a watch button (not shown by default)",
// "Show Feed Button" => "Show Feed Button",
// "Show an RSS feed button (not shown by default)" => "Show an RSS feed button (not shown by default)",
// "Show Google Map" => "Show Google Map",
// "Show Google Map of results (not shown by default)" => "Show Google Map of results (not shown by default)",
// "Google Map Icon" => "Google Map Icon",
// "Url of default icon to use for markers on the map" => "Url of default icon to use for markers on the map",
// "Calendar Field IDs" => "Calendar Field IDs",
// "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds separated with : for start:end" => "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds separated with : for start:end",
// "Calendar View Mode" => "Calendar View Mode",
// "Calendar view type time span (default is month)" => "Calendar view type time span (default is month)",
// "Bimester" => "Bimester",
// "Trimester" => "Trimester",
// "Calendar Popup" => "Calendar Popup",
// "Calendar items will pop-up, overrides Sticky Popup if turned off. Set to y (Yes) by default" => "Calendar items will pop-up, overrides Sticky Popup if turned off. Set to y (Yes) by default",
// "Calendar item pop-ups will stay open if set to y (Yes). Set to n (No) by default" => "Calendar item pop-ups will stay open if set to y (Yes). Set to n (No) by default",
// "Beginning of Month" => "Beginning of Month",
// "Set whether calendar will begin at the beginning of the month (does by default)" => "Set whether calendar will begin at the beginning of the month (does by default)",
// "Show calendar navigation bar (shown by default)" => "Show calendar navigation bar (shown by default)",
// "Partial" => "Partial",
// "Calendar Title" => "Calendar Title",
// "Enter a title to display a calendar title (not set by default)" => "Enter a title to display a calendar title (not set by default)",
// "Calendar Delta" => "Calendar Delta",
// "Set the calendar delta that will be shown (not set by default)" => "Set the calendar delta that will be shown (not set by default)",
// "Plus Month" => "Plus Month",
// "Minus Month" => "Minus Month",
// "Plus Bimester" => "Plus Bimester",
// "Minus Bimester" => "Minus Bimester",
// "Display Spreadsheet" => "Display Spreadsheet",
// "Display tracker as a spreadsheet (not used by default)" => "Display tracker as a spreadsheet (not used by default)",
// "Force Compile" => "Force Compile",
// "Force Smarty to recompile the templates for each tracker item when using a wiki page as a template. Default=n (best performance)" => "Force Smarty to recompile the templates for each tracker item when using a wiki page as a template. Default=n (best performance)",
// "Numeric value to display only last tracker items created within a user defined time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how many of those units are to be considered to define the time frame. Use in conjunction with \"max=-1\" to list all items (by default \"max\" is set to 10)" => "Numeric value to display only last tracker items created within a user defined time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how many of those units are to be considered to define the time frame. Use in conjunction with \"max=-1\" to list all items (by default \"max\" is set to 10)",
// "Period type" => "Period type",
// "Time period after creation or after modification" => "Time period after creation or after modification",
// "Creation" => "Creation",
// "Modification" => "Modification",
// "incorrect filterfield" => "incorrect filterfield",
"Error in tracker ID" => "Error en ID de formulario-bd",
"No field indicated" => "No se indicó campo",
"Check Tracker Passcodes" => "Comprueba los códigos de acceso de Formulario-bd",
// "PluginTrackerpasscode" => "PluginTrackerpasscode",
"Tracker Prefill" => "Relleno de Formulario-bd",
// "Create a button to prefill tracker fields" => "Create a button to prefill tracker fields",
"Tracker Page Name" => "Nombre de la página del Formulario-bd",
// "URL Parameters" => "URL Parameters",
// "Parameters to pass in the url, e.g. &my_parameter1=123&my_parameter2=q" => "Parameters to pass in the url, e.g. &my_parameter1=123&my_parameter2=q",
// "Field 1" => "Field 1",
// "Field ID for the first field" => "Field ID for the first field",
// "Value 1" => "Value 1",
// "Content that should be used to prefill the field" => "Content that should be used to prefill the field",
// "Field 2" => "Field 2",
// "Field ID for the second field" => "Field ID for the second field",
// "Value 2" => "Value 2",
// "Field 3" => "Field 3",
// "Field ID for the third field" => "Field ID for the third field",
// "Value 3" => "Value 3",
// "Field 4" => "Field 4",
// "Field ID for the fourth field" => "Field ID for the fourth field",
// "Value 4" => "Value 4",
// "Field 5" => "Field 5",
// "Field ID for the fifth field" => "Field ID for the fifth field",
// "Value 5" => "Value 5",
// "Field 6" => "Field 6",
// "Field ID for the sixth field" => "Field ID for the sixth field",
// "Value 6" => "Value 6",
// "Field 7" => "Field 7",
// "Field ID for the seventh field" => "Field ID for the seventh field",
// "Value 7" => "Value 7",
// "Field 8" => "Field 8",
// "Field ID for the eighth field" => "Field ID for the eighth field",
// "Value 8" => "Value 8",
"Tracker Stats" => "Estads. de Formulario-bd",
// "Display statistics about a tracker" => "Display statistics about a tracker",
// "Colon-separated list of field IDs to be displayed. Example: 2:4:5" => "Colon-separated list of field IDs to be displayed. Example: 2:4:5",
// "Show Count" => "Show Count",
// "Choose whether to show the count of votes each option received (shown by default)" => "Choose whether to show the count of votes each option received (shown by default)",
// "Choose whether to show the percentage of the vote each option received (not shown by default)" => "Choose whether to show the percentage of the vote each option received (not shown by default)",
// "Choose whether to show a bar representing the number of votes each option received (not shown by default)" => "Choose whether to show a bar representing the number of votes each option received (not shown by default)",
// "Only show items matching certain status filters" => "Only show items matching certain status filters",
// "Show Link" => "Show Link",
// "Show link to tiki-view_tracker" => "Show link to tiki-view_tracker",
// "Show last modification date of a tracker. Set to y to use site setting or use PHP\\s format (www.php.net/strftime)" => "Show last modification date of a tracker. Set to y to use site setting or use PHP\\s format (www.php.net/strftime)",
// "y to use the site setting for short date format. Otherwise, use PHP format (www.php.net/strftime), Example: \"%A %d of %B, %Y\"" => "y to use the site setting for short date format. Otherwise, use PHP format (www.php.net/strftime), Example: \"%A %d of %B, %Y\"",
// "invalid status" => "invalid status",
// "incorrect fieldId" => "incorrect fieldId",
"Tracker Timeline" => "Linia de tiempo de Formularios-bd",
"Show a timeline view of a tracker" => "Muestra la visualización en linea de tiempo de un formulario-bd",
// "Title Field" => "Title Field",
"Tracker Field ID containing the item title" => "ID del campo del Formulario-bd que contiene el título del ítem",
// "Summary Field" => "Summary Field",
// "Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused" => "Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused",
// "Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field" => "Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field",
// "Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field" => "Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field",
// "Element Group" => "Element Group",
// "Tracker Field ID containing the element's group. Elements of a same group are displayed on the same row" => "Tracker Field ID containing the element's group. Elements of a same group are displayed on the same row",
// "Unit of time to use for the primary scale (default to hour - * SIMILE only)" => "Unit of time to use for the primary scale (default to hour - * SIMILE only)",
// "Decade *" => "Decade *",
// "Century *" => "Century *",
// "Unit of time to use for the secondary scale (default to empty - * SIMILE only)" => "Unit of time to use for the secondary scale (default to empty - * SIMILE only)",
// "Timeline height" => "Timeline height",
// "Height of the timeline band as a CSS unit (default: 250px -  - * SIMILE only)" => "Height of the timeline band as a CSS unit (default: 250px -  - * SIMILE only)",
// "Lower band height" => "Lower band height",
// "Height of the lower timeline band as a percentage (default: 30 -  - * SIMILE only)" => "Height of the lower timeline band as a percentage (default: 30 -  - * SIMILE only)",
// "Link Group Name" => "Link Group Name",
// "Convert the group name to a link" => "Convert the group name to a link",
// "Page Link Field" => "Page Link Field",
// "Tracker Field ID containing the page name for item details" => "Tracker Field ID containing the page name for item details",
// "SIMILE Timeline" => "SIMILE Timeline",
// "Use the SIMILE Timeline Widget" => "Use the SIMILE Timeline Widget",
// "Image Field" => "Image Field",
// "Tracker Field ID containing in image" => "Tracker Field ID containing in image",
// "Missing parameter: %0" => "Missing parameter: %0",
// "Start date after end date" => "Start date after end date",
// "Tracker Toggle" => "Tracker Toggle",
// "Toggle element display on a field value" => "Toggle element display on a field value",
// "Numeric value representing the field ID tested" => "Numeric value representing the field ID tested",
// "Element visibility" => "Element visibility",
// "If y, is visible when the field has the value" => "If y, is visible when the field has the value",
// "Html ID of the element that is toggled" => "Html ID of the element that is toggled",
// "Use the field of specific item. The URL param itemId is used if this parameter is not set" => "Use the field of specific item. The URL param itemId is used if this parameter is not set",
// "Trade" => "Trade",
// "Send or receive payments from one member to another. (for cclite only so far, experimental)" => "Send or receive payments from one member to another. (for cclite only so far, experimental)",
// "Currency depends on the selected registry" => "Currency depends on the selected registry",
// "Registry to trade in. Default: site preference (or first in list when more than one)" => "Registry to trade in. Default: site preference (or first in list when more than one)",
// "Currency to trade in. Default: Cclite currency preference for registry set above" => "Currency to trade in. Default: Cclite currency preference for registry set above",
// "Other User" => "Other User",
// "Name of the user to recieve or send the payment" => "Name of the user to recieve or send the payment",
// "Leave empty to display an input box" => "Leave empty to display an input box",
// "Offered or wanted item" => "Offered or wanted item",
// "Offered" => "Offered",
// "Wanted" => "Wanted",
"Continue" => "Continúa",
// "Use %0 for the amount, %1 for currency, %2 for your user name, %3 for the other user" => "Use %0 for the amount, %1 for currency, %2 for your user name, %3 for the other user",
// "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user %2 from %3\" for wanted" => "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user %2 from %3\" for wanted",
// "Please log in" => "Please log in",
// " needs to validate their account" => " needs to validate their account",
// "Transclude" => "Transclude",
// "PluginTransclude" => "PluginTransclude",
// "Include the content of another page with certain changes" => "Include the content of another page with certain changes",
// "Name of the wiki page to use as a template for the values" => "Name of the wiki page to use as a template for the values",
// "Attempt to include a page that cannot be viewed" => "Attempt to include a page that cannot be viewed",
// "Page not found" => "Page not found",
// "Page named \"%0\" does not exist at this time" => "Page named \"%0\" does not exist at this time",
// "Translated" => "Translated",
// "Create multi-lingual links" => "Create multi-lingual links",
// "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)" => "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)",
// "Two letter language code of the language, ex: fr" => "Two letter language code of the language, ex: fr",
"Flag" => "Flag",
// "Country name, ex: France" => "Country name, ex: France",
// "Twitter" => "Twitter",
// "Display the activity for a twitter account" => "Display the activity for a twitter account",
// "Account Name" => "Account Name",
// "Name of the twitter account" => "Name of the twitter account",
// "Shell Background Color" => "Shell Background Color",
// "Background color for the overall widget, i.e., header, footer and outside border. Default is red (color code #15a2b)" => "Background color for the overall widget, i.e., header, footer and outside border. Default is red (color code #15a2b)",
// "Valid HTML color codes (with beginning #) or names" => "Valid HTML color codes (with beginning #) or names",
// "Shell Text Color" => "Shell Text Color",
// "Text color for the widget header and footer. Default is white (color code #ffffff)" => "Text color for the widget header and footer. Default is white (color code #ffffff)",
// "Tweet Background Color" => "Tweet Background Color",
// "Background color for individual tweets. Default is white" => "Background color for individual tweets. Default is white",
// "Tweet Text Color" => "Tweet Text Color",
// "Text color for individual tweets. Default is black" => "Text color for individual tweets. Default is black",
// "Height of widget in pixels. Default is 300" => "Height of widget in pixels. Default is 300",
// "Width of widget in pixels or 'auto' to fit to width of page. Default is auto" => "Width of widget in pixels or 'auto' to fit to width of page. Default is auto",
// "Number of pixels or the word 'auto'" => "Number of pixels or the word 'auto'",
// "User Count" => "User Count",
// "Display number of users for a site or group" => "Display number of users for a site or group",
// "Group name" => "Group name",
// "User Link" => "User Link",
// "Display a link to a user's information page" => "Display a link to a user's information page",
// "User account name (which can be an email address)" => "User account name (which can be an email address)",
"User List" => "Lista de Usuarios",
// "Display a list of registered users" => "Display a list of registered users",
// "Login Filter" => "Login Filter",
// "Separator to use between users in the list. Default: comma" => "Separator to use between users in the list. Default: comma",
// "User info" => "User info",
// "User page" => "User page",
// "User pref" => "User pref",
"Real Name" => "Nombre real",
// "Display the user's real name (when available) instead of login name" => "Display the user's real name (when available) instead of login name",
// "Filter on a group" => "Filter on a group",
"users" => "usuarios",
// "Display contents based on user preference settings" => "Display contents based on user preference settings",
// "Create tabs for showing alternate versions of content" => "Create tabs for showing alternate versions of content",
// "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default" => "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default",
// "Navigation" => "Navigation",
// "Displays a navigation box that allows users to select a specific version to display" => "Displays a navigation box that allows users to select a specific version to display",
// "Display the current version name as the title. No title shows when nav=>y; otherwise shows by default" => "Display the current version name as the title. No title shows when nav=>y; otherwise shows by default",
// "Default Label" => "Default Label",
// "Specifies version label to show when displaying the page for the first time. Default label is 'Default'" => "Specifies version label to show when displaying the page for the first time. Default label is 'Default'",
// "Display a Vimeo video" => "Display a Vimeo video",
// "Entire URL to the Vimeo video. Example: http://vimeo.com/3319966" => "Entire URL to the Vimeo video. Example: http://vimeo.com/3319966",
// "Quality of the video" => "Quality of the video",
// "Full screen" => "Full screen",
// "Expand to full screen" => "Expand to full screen",
"Vote" => "Votar",
// "Create a tracker for voting" => "Create a tracker for voting",
// "Show Stats" => "Show Stats",
// "Choose whether to show the voting results (shown by default)" => "Choose whether to show the voting results (shown by default)",
// "Show Stats After" => "Show Stats After",
// "Choose whether to show the voting results only after the date given in the tracker configuration (not set by default)" => "Choose whether to show the voting results only after the date given in the tracker configuration (not set by default)",
// "Choose whether to display the user name of the creator of the voting tracker (not shown by default)" => "Choose whether to display the user name of the creator of the voting tracker (not shown by default)",
// "Align the plugin on the page, allowing other elements to wrap around it (not set by default)" => "Align the plugin on the page, allowing other elements to wrap around it (not set by default)",
// "Votings" => "Votings",
// "Saves voting information in Smarty variables for display" => "Saves voting information in Smarty variables for display",
// "Object Key" => "Object Key",
// "Object key that is used to record votes" => "Object key that is used to record votes",
// "Return value" => "Return value",
// "Value to display as output of plugin" => "Value to display as output of plugin",
// "Wanted Pages" => "Wanted Pages",
// "Show location of links to pages not yet created" => "Show location of links to pages not yet created",
// "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom). Possible values: a valid regex-expression (PCRE)" => "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom). Possible values: a valid regex-expression (PCRE)",
// "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)" => "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)",
// "a valid regex-expression (PCRE)" => "a valid regex-expression (PCRE)",
// "Split By" => "Split By",
// "The character by which ignored patterns are separated" => "The character by which ignored patterns are separated",
// "Skip Extension" => "Skip Extension",
// "Whether to include external wikis in the list (not included by default)" => "Whether to include external wikis in the list (not included by default)",
// "Collect" => "Collect",
// "Collect either originating (from) or wanted pages (to) in a cell and display them in the second column" => "Collect either originating (from) or wanted pages (to) in a cell and display them in the second column",
"From" => "Desde",
"To" => "A",
// "Switch on debug output with details about the items (debug not on by default)" => "Switch on debug output with details about the items (debug not on by default)",
// "Memory Saver" => "Memory Saver",
// "Multiple collected items are separated in distinct table rows (default), or by comma or line break in one cell" => "Multiple collected items are separated in distinct table rows (default), or by comma or line break in one cell",
// "Line break" => "Line break",
// "Separate Row" => "Separate Row",
// "Level" => "Level",
// "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex" => "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex",
// "Custom" => "Custom",
// "Full" => "Full",
// "non-valid custom regex" => "non-valid custom regex",
// ", " => ", ",
// "ignored" => "ignored",
"External Wiki" => "Wiki Externo",
// "dash-WikiWord" => "dash-WikiWord",
// "WikiWord" => "WikiWord",
// "not in level" => "not in level",
"valid" => "válido",
// "End of debug output" => "End of debug output",
// "Wanted Page" => "Wanted Page",
// "Referenced By Page" => "Referenced By Page",
// "Watershed" => "Watershed",
// "Viewer for UStream Watershed Embed" => "Viewer for UStream Watershed Embed",
// "Specify archive, broadcaster, chat or viewer" => "Specify archive, broadcaster, chat or viewer",
"Archive" => "Archivo",
"Broadcaster" => "Difusor",
"Viewer" => "Visualizador",
// "Channel code" => "Channel code",
// "Specify the channel code to search in the tracker for a channel to use" => "Specify the channel code to search in the tracker for a channel to use",
// "Brand ID" => "Brand ID",
// "Specify the brand id to search in the tracker for a channel to use" => "Specify the brand id to search in the tracker for a channel to use",
// "Brand prefix" => "Brand prefix",
// "Copy the prefix from the chat embed, e.g. Name-of-Brand-" => "Copy the prefix from the chat embed, e.g. Name-of-Brand-",
// "Video ID" => "Video ID",
// "Video ID of archive which can be found in the tracker" => "Video ID of archive which can be found in the tracker",
// "Locale specified in viewer embed, default is en_US" => "Locale specified in viewer embed, default is en_US",
// "More than one channel found for specified criteria. Please be more specific" => "More than one channel found for specified criteria. Please be more specific",
// "No videoId specified for archive" => "No videoId specified for archive",
// "Web Service" => "Web Service",
// "Display remote information exposed in JSON or YAML" => "Display remote information exposed in JSON or YAML",
// "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter" => "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter",
// "Complete service URL" => "Complete service URL",
// "Registered service name" => "Registered service name",
// "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided" => "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided",
// "Body as Parameter" => "Body as Parameter",
// "Name of the argument to send the body as for services with complex input. Named service required for this to be useful" => "Name of the argument to send the body as for services with complex input. Named service required for this to be useful",
// "Parameters formatted like a query : param1=value1&amp;param2=value2" => "Parameters formatted like a query : param1=value1&amp;param2=value2",
// "Unknown Template" => "Unknown Template",
// "Unknown Service" => "Unknown Service",
// "Permits to have a WYSIWYG section for part of a page" => "Permits to have a WYSIWYG section for part of a page",
// "Minimum width for DIV. Default:500px" => "Minimum width for DIV. Default:500px",
// "Minimum height for DIV. Default:300px" => "Minimum height for DIV. Default:300px",
// "You have unsaved changes in this WYSIWYG section.\nDo you want to save your changes" => "You have unsaved changes in this WYSIWYG section.\nDo you want to save your changes",
// "YouTube" => "YouTube",
// "Display a YouTube video" => "Display a YouTube video",
// "Movie" => "Movie",
// "Entire URL to the YouTube video or last part (after www.youtube.com/v/ and before the first question mark)" => "Entire URL to the YouTube video or last part (after www.youtube.com/v/ and before the first question mark)",
// "Quality of the video. Default is high" => "Quality of the video. Default is high",
// "Enlarge video to full screen size" => "Enlarge video to full screen size",
"Related" => "Relacionados",
// "Show related videos (shown by default)" => "Show related videos (shown by default)",
// "Background" => "Background",
// "Toolbar background color. Use an HTML color code. Example: ffffff" => "Toolbar background color. Use an HTML color code. Example: ffffff",
// "HTML color code, e.g. ffffff" => "HTML color code, e.g. ffffff",
// "Toolbar border colors. Use an HTML color code. Example: ffffff" => "Toolbar border colors. Use an HTML color code. Example: ffffff",
// "Plugin YouTube error: the movie parameter is empty" => "Plugin YouTube error: the movie parameter is empty",
// "Missing parameter movie to the Youtube plugin" => "Missing parameter movie to the Youtube plugin",
// "Zotero Citation" => "Zotero Citation",
// "Retrieves and includes a Zotero reference in the page" => "Retrieves and includes a Zotero reference in the page",
// "Reference Key" => "Reference Key",
// "Unique reference for the group associated to the site. Can be retrieved from the Zotero Bibliography module" => "Unique reference for the group associated to the site. Can be retrieved from the Zotero Bibliography module",
// "Reference Tag" => "Reference Tag",
// "Uses the first result using the specified tag. Useful when the tag mechanism is coerced into creating unique human memorizable keys" => "Uses the first result using the specified tag. Useful when the tag mechanism is coerced into creating unique human memorizable keys",
// "Append a note to the reference for additional information, like page numbers or other sub-references" => "Append a note to the reference for additional information, like page numbers or other sub-references",
// "Zotero Reference List" => "Zotero Reference List",
// "Produces the complete reference list from the Zotero server" => "Produces the complete reference list from the Zotero server",
// "Provide the list of references with a given tag" => "Provide the list of references with a given tag",
// "No results obtained. The Zotero citation server may be down" => "No results obtained. The Zotero citation server may be down",
"ERROR: Either the subject or body must be non-empty" => "ERROR: Tanto el tema o el cuerpo no deben estar vacíos",
// "User %s does not have the permission" => "User %s does not have the permission",
"The message has been sent to" => "Se ha enviado el mensaje a",
"The message will be sent to" => "Se enviará el mensaje a",
"ERROR: No valid users to send the message" => "ERROR: Sin usuarios válidos para enviarles el mensaje",
"User %s does not want to receive messages" => "El usuario/a %s no quiere recibir mensajes",
"Invalid user" => "Usuario no válido",
"Sent box is full. Archive or delete some sent messages first if you want to send more messages." => "La carpeta de enviados esta llena. Archive o borre algunos mensajes enviados si quiere enviar más mensajes.",
"An error occurred, please check your mail settings and try again" => "Ha ocurrido un error, por favor comprueba la configuraciòń de tu correo y prueba de nuevo",
"You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'" => "Tienes que permitir recibir mensajes si quieres poder enviarlos. Ve a las preferencias de tu usuario/a y habilita 'Permite mensajes de otros usuarios'",
"User %s can not receive messages, mailbox is full" => "El usuario %s no puede recibir mensajes, sy buzón de mensajes está lleno",
"User %s can not receive messages" => "El usuario %s no puede recibir mensajes",
"Invalid user: %s" => "Usuario no válido: %s",
"Message has been sent to: " => "Se ha enviado el mensaje a: ",
"Archive is full. Delete some messages from archive first." => "Archivo lleno, borre algunos mensajes del archivo primero.",
"No more messages" => "No hay más mensajes",
// "ERROR: " => "ERROR: ",
// "ERROR: Invalid tab_id received. Numeric format expected, got %0" => "ERROR: Invalid tab_id received. Numeric format expected, got %0",
// "Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page" => "Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page",
// "Item types filter" => "Item types filter",
// "If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes" => "If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes",
// "Possible item type values" => "Possible item type values",
"Similar Content" => "Contenido similar",
"Find similar content based on FreeTags" => "Encuentra contenido similar basado en marcas libres comunes",
// "Similar Content Filter" => "Similar Content Filter",
// "Display only similar content of type specified" => "Display only similar content of type specified",
// "Default: \"All Content Type\"" => "Default: \"All Content Type\"",
// "Options: \"article, wiki page, blog post\"" => "Options: \"article, wiki page, blog post\"",
// "Broaden FreeTag Search" => "Broaden FreeTag Search",
// "Find similar content that contains one of the Tags or All of the Tags" => "Find similar content that contains one of the Tags or All of the Tags",
// "Default: \"n - needs to contain all of the Tags\"" => "Default: \"n - needs to contain all of the Tags\"",
// "Options: \"n - Needs to contain All Tags / y - Needs to contain one of the Tags\"" => "Options: \"n - Needs to contain All Tags / y - Needs to contain one of the Tags\"",
// "Google AdSense" => "Google AdSense",
// "Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code" => "Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code",
// "ad_channel" => "ad_channel",
// "Advertisement channel, as optionally provided by Google" => "Advertisement channel, as optionally provided by Google",
// "client" => "client",
// "As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"" => "As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"",
// "display" => "display",
// "Global banner format as provided by Google. For example: \"display=468*60_as\"" => "Global banner format as provided by Google. For example: \"display=468*60_as\"",
// "color_bg" => "color_bg",
// "Background color, as optionally provided by Google" => "Background color, as optionally provided by Google",
// "color_border" => "color_border",
// "Border color, as optionally provided by Google" => "Border color, as optionally provided by Google",
// "color_link" => "color_link",
// "Link color, as optionally provided by Google" => "Link color, as optionally provided by Google",
// "color_text" => "color_text",
// "Text color, as optionally provided by Google" => "Text color, as optionally provided by Google",
// "color_url" => "color_url",
// "URL color, as optionally provided by Google" => "URL color, as optionally provided by Google",
// "Article Archives" => "Article Archives",
// "Shows links to the published articles for each month" => "Shows links to the published articles for each month",
// "If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles" => "If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles",
// "Default: \"n\"" => "Default: \"n\"",
// "If set to a category identifier, only consider the articles in the specified category" => "If set to a category identifier, only consider the articles in the specified category",
// "Example value: 13" => "Example value: 13",
// "Topic filter (by names)" => "Topic filter (by names)",
// "If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered",
// "Topic filter (by identifiers)" => "Topic filter (by identifiers)",
// "If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered",
// "Example values: 13, !13, 1+3, !1+5+7" => "Example values: 13, !13, 1+3, !1+5+7",
// "Types filter" => "Types filter",
// "If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered" => "If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered",
// "Example values: Event, !Event, Event+Review, !Event+Classified+Article" => "Example values: Event, !Event, Event+Review, !Event+Classified+Article",
// "Language filter" => "Language filter",
// "If set to a language code, only consider the articles in the specified language" => "If set to a language code, only consider the articles in the specified language",
// "Article Topics" => "Article Topics",
// "Lists all article topics with links to their articles" => "Lists all article topics with links to their articles",
// "Lists the specified number of published articles in the specified order" => "Lists the specified number of published articles in the specified order",
// "Show publication time" => "Show publication time",
// "If set to \"y\", article publication times are shown" => "If set to \"y\", article publication times are shown",
// "Show creation time" => "Show creation time",
// "If set to \"y\", article creation times are shown" => "If set to \"y\", article creation times are shown",
// "Show rating selector" => "Show rating selector",
// "If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating" => "If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating",
// "If set, displays an image for each article if one applies, with the given width (in pixels). The article's own image is used, with a fallback to the article's topic image" => "If set, displays an image for each article if one applies, with the given width (in pixels). The article's own image is used, with a fallback to the article's topic image",
// "If set to a category identifier, only lists the articles in the specified category" => "If set to a category identifier, only lists the articles in the specified category",
// "If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed",
// "If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed",
// "If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed" => "If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed",
// "If set to a language code, only lists the articles in the specified language" => "If set to a language code, only lists the articles in the specified language",
// "Specifies how the articles should be sorted" => "Specifies how the articles should be sorted",
// "Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date" => "Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date",
// "If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead" => "If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead",
// "If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles" => "If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles",
// "Absolute URL" => "Absolute URL",
// "If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example" => "If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example",
// "If set to 0, will take the topicId of the article if in an article" => "If set to 0, will take the topicId of the article if in an article",
// "Tiki Assistant" => "Tiki Assistant",
// "Display an assistant to guide new Tiki admins" => "Display an assistant to guide new Tiki admins",
// "Babel Fish Links" => "Babel Fish Links",
// "Offers a link to the Yahoo! Babel Fish translation service" => "Offers a link to the Yahoo! Babel Fish translation service",
// "Babel Fish Icon Link" => "Babel Fish Icon Link",
// "Display an icon linked to the Yahoo! Babel Fish translation service" => "Display an icon linked to the Yahoo! Babel Fish translation service",
// "Newest Blog Post Comments" => "Newest Blog Post Comments",
// "Displays the specified number of the blog post comments most recently added" => "Displays the specified number of the blog post comments most recently added",
// "No date" => "No date",
// "If set to \"y\", the date of comments is not displayed in the module box" => "If set to \"y\", the date of comments is not displayed in the module box",
// "Verbose tooltips" => "Verbose tooltips",
// "If set to \"y\", blog post title is only visible as a tooltip and not displayed" => "If set to \"y\", blog post title is only visible as a tooltip and not displayed",
// "Options: \"y,n\"" => "Options: \"y,n\"",
// "Last-Visited Pages" => "Last-Visited Pages",
// "Displays the last Wiki pages visited by the user" => "Displays the last Wiki pages visited by the user",
// "Maximum number of characters in page names allowed before truncating" => "Maximum number of characters in page names allowed before truncating",
// "A hierarchy of where you are. Ex.: Home > Section1 > Subsection C" => "A hierarchy of where you are. Ex.: Home > Section1 > Subsection C",
// "Label preceding the crumbs" => "Label preceding the crumbs",
// "Menu Id" => "Menu Id",
// "Menu to take the crumb trail from" => "Menu to take the crumb trail from",
// "Menu Start Level" => "Menu Start Level",
// "Lowest level of the menu to display" => "Lowest level of the menu to display",
// "Menu Stop Level" => "Menu Stop Level",
// "Highest level of the menu to display" => "Highest level of the menu to display",
// "Show Site Crumb" => "Show Site Crumb",
// "Display the first crumb, usually the site, when using menu crumbs" => "Display the first crumb, usually the site, when using menu crumbs",
// "Show Page Crumb" => "Show Page Crumb",
// "Display the last crumb, usually the page, when using menu crumbs" => "Display the last crumb, usually the page, when using menu crumbs",
// "Show Crumb Links" => "Show Crumb Links",
// "Display links on the crumbs" => "Display links on the crumbs",
// "Includes a calendar or a list of calendar events" => "Includes a calendar or a list of calendar events",
// "Calendars filter" => "Calendars filter",
// "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\"). Example values: \"13\", \"4,7\", \"31:49\". Not set by default" => "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\"). Example values: \"13\", \"4,7\", \"31:49\". Not set by default",
// "Displayed month (relative)" => "Displayed month (relative)",
// "Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span. Example values: 2, 0, -2, -12" => "Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span. Example values: 2, 0, -2, -12",
// "View type" => "View type",
// "Determines how to show events. Possible values: %0, %1" => "Determines how to show events. Possible values: %0, %1",
// "Calendar view type time span" => "Calendar view type time span",
// "If in calendar (or \"table\") view type, determines the time span displayed by the calendar. Possible values: %0, %1, %2, %3 ,%4, %5. A user changing this time span in the calendar can change the time span the module displays for him" => "If in calendar (or \"table\") view type, determines the time span displayed by the calendar. Possible values: %0, %1, %2, %3 ,%4, %5. A user changing this time span in the calendar can change the time span the module displays for him",
// "Show action" => "Show action",
// "Viewmode when clicking on a day" => "Viewmode when clicking on a day",
// "Put a link on all the days , not only those with event" => "Put a link on all the days , not only those with event",
// "View navigation bar" => "View navigation bar",
// "Cart" => "Cart",
// "Displays the content of the cart, allows to modify quantities and proceed to payment" => "Displays the content of the cart, allows to modify quantities and proceed to payment",
// "The quantities in your cart were updated" => "The quantities in your cart were updated",
// "Gift card added" => "Gift card added",
// "Gift card not found" => "Gift card not found",
// "Gift card removed" => "Gift card removed",
// "Displays links to categories as a tree" => "Displays links to categories as a tree",
// "Object type filter" => "Object type filter",
// "Object type filter to apply when accessing a linked category. Example values" => "Object type filter to apply when accessing a linked category. Example values",
// "Deep" => "Deep",
// "Show subcategories objects when accessing a linked category. Possible values: on (default), off" => "Show subcategories objects when accessing a linked category. Possible values: on (default), off",
// "Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don't limit display)" => "Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don't limit display)",
// "Show these categories and their children" => "Show these categories and their children",
// "Show only these categories and the immediate child categories of these in the order the parameter specifies. Example values: 3,5,6" => "Show only these categories and the immediate child categories of these in the order the parameter specifies. Example values: 3,5,6",
// "Category links to a page named as the category" => "Category links to a page named as the category",
// "If y, category links to a page named as the category" => "If y, category links to a page named as the category",
// "Category Transitions" => "Category Transitions",
// "Displays controls to trigger category transitions and change the page's state according to predefined rules" => "Displays controls to trigger category transitions and change the page's state according to predefined rules",
// "Example Transition" => "Example Transition",
// "Change Category" => "Change Category",
// "Enables to categorize an object" => "Enables to categorize an object",
// "This module currently only supports Wiki pages. Some combinations of Multiple categories, Detailed, Unassign and Assign may challenge intuition or be simply broken" => "This module currently only supports Wiki pages. Some combinations of Multiple categories, Detailed, Unassign and Assign may challenge intuition or be simply broken",
// "Category identifier" => "Category identifier",
// "Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier" => "Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier",
// "Note that the root category is not displayed" => "Note that the root category is not displayed",
// "Defaults to 0 (root)" => "Defaults to 0 (root)",
// "No top" => "No top",
// "In non-detailed view, disallow uncategorizing. Example value: 1" => "In non-detailed view, disallow uncategorizing. Example value: 1",
// "Display path" => "Display path",
// "Unless set to \"n\", display relative category paths in the category tree rather than category names" => "Unless set to \"n\", display relative category paths in the category tree rather than category names",
// "Paths are relative to the root category, which is not displayed" => "Paths are relative to the root category, which is not displayed",
// "Multiple categories" => "Multiple categories",
// "If set to \"n\", only allows categorizing in one category (from those displayed)" => "If set to \"n\", only allows categorizing in one category (from those displayed)",
"Categorize" => "Categorizar",
// "String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize" => "String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize",
// "Shy" => "Shy",
// "If set to \"y\", the module is not shown on pages which are not already categorized" => "If set to \"y\", the module is not shown on pages which are not already categorized",
// "Detailed" => "Detailed",
// "If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list" => "If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list",
"Unassign" => "Inhabilitar",
// "If set to \"n\", the detailed list of categories will not offer to unassign a category" => "If set to \"n\", the detailed list of categories will not offer to unassign a category",
// "If set to \"y\", allow to assign new categories" => "If set to \"y\", allow to assign new categories",
// "Example values: y, n" => "Example values: y, n",
// "Default value: y" => "Default value: y",
// "Group filter" => "Group filter",
// "Very particular filter option. If set to \"y\", only categories with a name matching one of the user's groups are shown, and descendants of these matching categories" => "Very particular filter option. If set to \"y\", only categories with a name matching one of the user's groups are shown, and descendants of these matching categories",
// "Default value: n" => "Default value: n",
// "Image URL not in category" => "Image URL not in category",
// "Very particular parameter. If both this and \"Image URL in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category" => "Very particular parameter. If both this and \"Image URL in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category",
// "Image URL in category" => "Image URL in category",
// "Very particular parameter. If both this and \"Image URL not in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category" => "Very particular parameter. If both this and \"Image URL not in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category",
// "Categorize %s" => "Categorize %s",
// "Categorize %s in %s" => "Categorize %s in %s",
"Received Objects" => "Objetos recibidos",
// "Displays the number of pages received (via Communications)" => "Displays the number of pages received (via Communications)",
// "Contributors" => "Contributors",
// "Lists the contributors to the wiki page being viewed and some information on them" => "Lists the contributors to the wiki page being viewed and some information on them",
// "Shows the credits a user has" => "Shows the credits a user has",
// "Newest Directory Sites" => "Newest Directory Sites",
// "Displays the specified number of the directory sites most recently added" => "Displays the specified number of the directory sites most recently added",
// "Directory category identifier" => "Directory category identifier",
// "If set to a directory category identifier, only displays the sites in the specified directory category" => "If set to a directory category identifier, only displays the sites in the specified directory category",
// "If set to \"y\", displays a button labelled \"More\" that links to the directory" => "If set to \"y\", displays a button labelled \"More\" that links to the directory",
"Show description" => "Ver descripción",
// "If set to \"y\", the description of the directory site appears" => "If set to \"y\", the description of the directory site appears",
// "Maximum length of description" => "Maximum length of description",
// "If desc = \"y\", use maxdesc to set the maximum length of the directory site (in characters). Leave blank to set no maximum (show the entire description)" => "If desc = \"y\", use maxdesc to set the maximum length of the directory site (in characters). Leave blank to set no maximum (show the entire description)",
// "Default: blank" => "Default: blank",
// "Directory Statistics" => "Directory Statistics",
// "Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links" => "Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links",
// "Top Directory Sites" => "Top Directory Sites",
// "Displays the specified number of the directory sites from most visited to least visited" => "Displays the specified number of the directory sites from most visited to least visited",
// "Displays the site's first featured links" => "Displays the site's first featured links",
// "Displays links to file galleries" => "Displays links to file galleries",
// "Top-Rated Topics" => "Top-Rated Topics",
// "Displays the specified number of the forum topics with the best ratings" => "Displays the specified number of the forum topics with the best ratings",
"Newest Forum Posts" => "Últimos mensajes en foro",
// "Displays the latest forum posts" => "Displays the latest forum posts",
"Topics only" => "Sólo temas",
// "If set to \"y\", only displays topics" => "If set to \"y\", only displays topics",
// "List of forum identifiers" => "List of forum identifiers",
// "If set to a list of forum identifiers, restricts the posts to those in the identified forums. Identifiers are separated by colons (\":\")" => "If set to a list of forum identifiers, restricts the posts to those in the identified forums. Identifiers are separated by colons (\":\")",
// "Show date" => "Show date",
// "If set to \"y\", show post date directly instead of as tooltip" => "If set to \"y\", show post date directly instead of as tooltip",
// "Show time" => "Show time",
// "Show times after dates" => "Show times after dates",
"Show author" => "Mostrar autor",
// "If set to \"y\", show post author directly instead of as tooltip" => "If set to \"y\", show post author directly instead of as tooltip",
"Most Commented Forums" => "Foros con más mensajes",
// "Display the specified number of the forums with the most comments" => "Display the specified number of the forums with the most comments",
// "Top Visited Forum Topics" => "Top Visited Forum Topics",
// "Display the specified number of the forum topics with the most reads" => "Display the specified number of the forum topics with the most reads",
// "Top Visited Forums" => "Top Visited Forums",
// "Display the specified number of the forums with the most visits" => "Display the specified number of the forums with the most visits",
"Tags Editor" => "Editor de Marcas",
// "Shows current freetags and enables to add and remove some if permissions allow" => "Shows current freetags and enables to add and remove some if permissions allow",
"Wiki Page Tags" => "Marcas de Páginas Wiki",
// "Displays current freetags on wiki pages and enables to add tags if permissions allow" => "Displays current freetags on wiki pages and enables to add tags if permissions allow",
"Similar-Tag Items" => "Ítems con Marcas Similares",
// "Shows content with multiple freetags in common" => "Shows content with multiple freetags in common",
// "Type of objects to extract" => "Type of objects to extract",
"Similar pages" => "Páginas similares",
"Most Popular Tags" => "Marcas Más Populares",
// "Shows the most popular freetags. More popularity is indicated by a larger font" => "Shows the most popular freetags. More popularity is indicated by a larger font",
// "Display type" => "Display type",
// "If set to \"cloud\", links are displayed as a cloud" => "If set to \"cloud\", links are displayed as a cloud",
// "Default: \"list\"" => "Default: \"list\"",
"Maximum elements" => "Elementos máximos",
// "If set to a number, limits the number of tags displayed" => "If set to a number, limits the number of tags displayed",
"My Preferred Tags" => "Mis Marcas Preferidas",
// "Displays to registered users the freetags they prefer, based on the number of objects they added the tag to. More preference is indicated by a larger font" => "Displays to registered users the freetags they prefer, based on the number of objects they added the tag to. More preference is indicated by a larger font",
"My preferred tags" => "Mis marcas preferidas",
"Google Search" => "Buscar en Google",
// "Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site" => "Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site",
// "Groups Emulation" => "Groups Emulation",
// "Enables temporarily changing one's group memberships to see how users in fewer groups experience the site" => "Enables temporarily changing one's group memberships to see how users in fewer groups experience the site",
// "Emulate Groups" => "Emulate Groups",
"Last Actions" => "Últimas acciones",
// "Displays the specified number of last actions" => "Displays the specified number of last actions",
// "Show user" => "Show user",
// "If set to \"y\", user names are displayed in the module box" => "If set to \"y\", user names are displayed in the module box",
// "If set to \"y\", action dates are displayed in the module box" => "If set to \"y\", action dates are displayed in the module box",
// "Maximum number of characters in action descriptions before truncating" => "Maximum number of characters in action descriptions before truncating",
"Newest Blog Posts" => "Últimos posts en blogs",
// "Lists the specified number of blogs posts from newest to oldest" => "Lists the specified number of blogs posts from newest to oldest",
// "If set to \"y\", the date of posts is not displayed in the module box" => "If set to \"y\", the date of posts is not displayed in the module box",
// "Blog identifier" => "Blog identifier",
// "If set to a blog identifier, restricts the blog posts to those in the identified blog" => "If set to a blog identifier, restricts the blog posts to those in the identified blog",
// "Newest Category Items" => "Newest Category Items",
// "Lists the specified number of objects of the given type in the given category, starting from the most recently created" => "Lists the specified number of objects of the given type in the given category, starting from the most recently created",
// "Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed" => "Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed",
// "Maximum number of characters in object names allowed before truncating" => "Maximum number of characters in object names allowed before truncating",
// "Type of the objects to list. Example values" => "Type of the objects to list. Example values",
"no object here yet" => "no hay objetos aquí aún",
"Newest Blogs" => "Últimos blogs creados",
// "Displays the specified number of blogs from newest to oldest" => "Displays the specified number of blogs from newest to oldest",
"Newest FAQs" => "Últimos FAQs creadas",
// "Displays the specified number of FAQs from newest to oldest" => "Displays the specified number of FAQs from newest to oldest",
"Newest Quizzes" => "Últimos Cuestionarios",
// "Displays the specified number of quizzes from newest to oldest" => "Displays the specified number of quizzes from newest to oldest",
// "Last-Modified File Galleries" => "Last-Modified File Galleries",
// "Display the specified number of file galleries, starting from the most recently modified" => "Display the specified number of file galleries, starting from the most recently modified",
"Newest Files" => "Últimos archivos",
// "List the specified number of files, starting from the most recently added" => "List the specified number of files, starting from the most recently added",
// "Gallery identifiers" => "Gallery identifiers",
// "If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers" => "If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers",
// "Example value: 13, 2:13, 1:2:3:5:6" => "Example value: 13, 2:13, 1:2:3:5:6",
// "Last-Modified Image Galleries" => "Last-Modified Image Galleries",
// "Displays the specified number of image galleries, starting from the most recently modified" => "Displays the specified number of image galleries, starting from the most recently modified",
"Newest Images" => "Últimas Imágenes",
// "List the specified number of images, starting from the most recently added" => "List the specified number of images, starting from the most recently added",
// "Gallery identifier" => "Gallery identifier",
// "If set to an image gallery identifier, restricts the images to those in the identified gallery" => "If set to an image gallery identifier, restricts the images to those in the identified gallery",
// "Link content" => "Link content",
// "Display the links as image names or thumbnails" => "Display the links as image names or thumbnails",
// "Possible values: \"names\" or \"thumbnails\". Default value: \"names\"" => "Possible values: \"names\" or \"thumbnails\". Default value: \"names\"",
// "Last-Modified Events" => "Last-Modified Events",
// "Display the specified number of calendar events, starting from the most recently modified" => "Display the specified number of calendar events, starting from the most recently modified",
// "Calendar Identifier" => "Calendar Identifier",
// "If set to a calendar identifier, restricts the events to those in the identified calendar" => "If set to a calendar identifier, restricts the events to those in the identified calendar",
// "Maximum number of characters in event names allowed before truncating" => "Maximum number of characters in event names allowed before truncating",
// "Hide Date" => "Hide Date",
// "If set to \"y\", it will hide date" => "If set to \"y\", it will hide date",
// "List the specified number of pages, starting from the most recently modified" => "List the specified number of pages, starting from the most recently modified",
// "Link Target" => "Link Target",
// "Target URL of the \"...more\" link at the bottom of the module" => "Target URL of the \"...more\" link at the bottom of the module",
"Last-Modified Blogs" => "Blogs recientemente modificados",
// "Displays the specified number of blogs, starting from the most recently modified" => "Displays the specified number of blogs, starting from the most recently modified",
// "Newest Podcasts" => "Newest Podcasts",
// "Displays Podcasts" => "Displays Podcasts",
// "File galleries IDs" => "File galleries IDs",
// "List of IDs of file galleries of type \"Podcast (Audio)\". Identifiers are separated by a colon (\":\"). If none, all file galleries will be scanned" => "List of IDs of file galleries of type \"Podcast (Audio)\". Identifiers are separated by a colon (\":\"). If none, all file galleries will be scanned",
"width" => "ancho",
// "Width of mediaplayer in pixels" => "Width of mediaplayer in pixels",
"height" => "altura",
// "Height of mediaplayer in pixels" => "Height of mediaplayer in pixels",
// "Path to mp3 player. For instance media/player_mp3_maxi.swf if you downloaded player_mp3_maxi.swf from http://flash-mp3-player.net/players/maxi/download/ to directory media/ (directory needs to be created or you can chose another place)" => "Path to mp3 player. For instance media/player_mp3_maxi.swf if you downloaded player_mp3_maxi.swf from http://flash-mp3-player.net/players/maxi/download/ to directory media/ (directory needs to be created or you can chose another place)",
// "Bottom Link URL" => "Bottom Link URL",
// "URL for a link at bottom of module" => "URL for a link at bottom of module",
// "Bottom Link URL Text" => "Bottom Link URL Text",
// "Text for link if Bottom Link URL is set" => "Text for link if Bottom Link URL is set",
// "More Podcasts" => "More Podcasts",
// "Verbose" => "Verbose",
// "Display description of podcast below player if \"y\", and on title mouseover if \"n\"" => "Display description of podcast below player if \"y\", and on title mouseover if \"n\"",
"Newest Article Submissions" => "Últimas colaboraciones",
// "Lists the specified number of article submissions from newest to oldest" => "Lists the specified number of article submissions from newest to oldest",
"Newest Tracker Comments" => "Comentarios más recientes de Formularios-bd",
// "Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted" => "Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted",
"Tracker identifier" => "Identificador del Formulario-bd",
// "If set to a tracker identifier, only displays the comments on the given tracker" => "If set to a tracker identifier, only displays the comments on the given tracker",
// "Item identifier" => "Item identifier",
// "If set to an item identifier, only displays the comments on the given item" => "If set to an item identifier, only displays the comments on the given item",
"Newest Tracker Items" => "Ítems más recientes de Formularios-bd",
// "Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required" => "Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required",
// "Identifier of the tracker from which items are listed" => "Identifier of the tracker from which items are listed",
// "Field identifier" => "Field identifier",
// "Identifier of the field from which values are listed. If Field name is set, this parameter is ignored" => "Identifier of the field from which values are listed. If Field name is set, this parameter is ignored",
// "Field name" => "Field name",
// "Name of the field from which values are listed" => "Name of the field from which values are listed",
// "Example value: age" => "Example value: age",
// "Specifies how the items should be sorted" => "Specifies how the items should be sorted",
// "Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date" => "Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date",
// "Status filter" => "Status filter",
// "If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values" => "If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values",
// "Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set" => "Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set",
// "You do not have permission to view this tracker" => "You do not have permission to view this tracker",
"Last Items" => "Últimos ítems",
"Last Modified Items" => "Items recientemente modificados",
// "Newest Validated FAQ Questions" => "Newest Validated FAQ Questions",
// "Displays the specified number of validated questions FAQs from newest to oldest" => "Displays the specified number of validated questions FAQs from newest to oldest",
// "Faq identifier" => "Faq identifier",
// "If set to a faq identifier, restricts the chosen questions to those in the identified faq" => "If set to a faq identifier, restricts the chosen questions to those in the identified faq",
"Last Visitors" => "Últimos visitantes",
// "Displays information about the specified number of users in decreasing order of last login time" => "Displays information about the specified number of users in decreasing order of last login time",
// "Show avatars" => "Show avatars",
// "If set to \"y\", show user avatars" => "If set to \"y\", show user avatars",
// "Maximum number of characters in user names allowed before truncating" => "Maximum number of characters in user names allowed before truncating",
// "Don't show date" => "Don't show date",
// "YouTube Playlist" => "YouTube Playlist",
// "Display a YouTube playlist" => "Display a YouTube playlist",
// "Playlist ID" => "Playlist ID",
// "ID of the YouTube playlist to display (not the complete URL). Example: id=4DE69387D46DA2F6" => "ID of the YouTube playlist to display (not the complete URL). Example: id=4DE69387D46DA2F6",
// "Width of each video in pixels" => "Width of each video in pixels",
// "Height of each video in pixels" => "Height of each video in pixels",
// "Allow FullScreen" => "Allow FullScreen",
// "Bottom Link" => "Bottom Link",
// "Url for a link at bottom of module. Example: link_url=http://www.youtube.com/CouncilofEurope#grid/user/E57D0D93BA3A56C8" => "Url for a link at bottom of module. Example: link_url=http://www.youtube.com/CouncilofEurope#grid/user/E57D0D93BA3A56C8",
// "Bottom Link Text" => "Bottom Link Text",
// "Text for link if link_url is set, otherwise 'More Videos'" => "Text for link if link_url is set, otherwise 'More Videos'",
// "Video Descriptions" => "Video Descriptions",
// "Display description of video on title mouseover if 'y'. Default is 'y'" => "Display description of video on title mouseover if 'y'. Default is 'y'",
// "Order by" => "Order by",
// "Criteria to order by the videos in the list. Default is 'position'" => "Criteria to order by the videos in the list. Default is 'position'",
// "position" => "position",
// "commentCount" => "commentCount",
"duration" => "duración",
// "published" => "published",
// "reversedPosition" => "reversedPosition",
// "title" => "title",
// "viewCount" => "viewCount",
// "No Playlist found" => "No Playlist found",
// "No Playlist ID was provided" => "No Playlist ID was provided",
"Live Support" => "Soporte Live",
// "Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console" => "Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console",
// "Server Load" => "Server Load",
// "Report of server resources used" => "Report of server resources used",
// "Presents a map with the geolocated content within the page" => "Presents a map with the geolocated content within the page",
// "Log-in box" => "Log-in box",
// "Input size" => "Input size",
// "Number of characters for username and password input fields" => "Number of characters for username and password input fields",
// "Display mode: module, header or popup. Leave empty for module mode" => "Display mode: module, header or popup. Leave empty for module mode",
// "Show Register" => "Show Register",
// "Show the register link" => "Show the register link",
// "Show I Forgot" => "Show I Forgot",
// "Show the \"I forgot my password\" link" => "Show the \"I forgot my password\" link",
// "Show Remember me" => "Show Remember me",
// "Show the \"Remember me\" checkbox" => "Show the \"Remember me\" checkbox",
// "Logo" => "Logo",
// "Site logo, title and subtitle" => "Site logo, title and subtitle",
// "Map Feature Editor" => "Map Feature Editor",
// "Allows to draw shapes over the map" => "Allows to draw shapes over the map",
"Tracker to store the feature in" => "Formulario-bd en el que guardar las funcionalidad",
// "Hidden Input" => "Hidden Input",
// "Hidden values to be sent over to the dialog. fieldName(value)" => "Hidden values to be sent over to the dialog. fieldName(value)",
// "Standard controls" => "Standard controls",
// "Dispay the standard draw controls" => "Dispay the standard draw controls",
// "Layer Selector" => "Layer Selector",
// "Replace the map's built-in layer controls" => "Replace the map's built-in layer controls",
// "Mode Selector" => "Mode Selector",
// "Toggle input modes for the map" => "Toggle input modes for the map",
// "Map location search" => "Map location search",
// "Simple search controls for the map" => "Simple search controls for the map",
"Menu" => "Menú",
// "Displays a menu or a structure as a menu" => "Displays a menu or a structure as a menu",
// "Identifier of a menu (from tiki-admin_menus.php)" => "Identifier of a menu (from tiki-admin_menus.php)",
"Structure" => "Estuctura",
// "Identifier of a structure of wiki pages (name or number from tiki-admin_structures.php)" => "Identifier of a structure of wiki pages (name or number from tiki-admin_structures.php)",
// "Direction for menu: horiz or vert (default vert)" => "Direction for menu: horiz or vert (default vert)",
// "CSS/Superfish" => "CSS/Superfish",
// "Use CSS Superfish menu. y|n (default y)" => "Use CSS Superfish menu. y|n (default y)",
// "DOM #id" => "DOM #id",
// "Id of the menu in the DOM" => "Id of the menu in the DOM",
// "CSS class" => "CSS class",
// "Class of the menu container" => "Class of the menu container",
// "Limit low visibles levels" => "Limit low visibles levels",
// "All the submenus beginning at this level will be displayed if the url matches one of the option of this level or above or below" => "All the submenus beginning at this level will be displayed if the url matches one of the option of this level or above or below",
// "Limit top visible levels" => "Limit top visible levels",
// "Do not display options higher than this level" => "Do not display options higher than this level",
// "Link on Section" => "Link on Section",
// "Create links on menu sections" => "Create links on menu sections",
// "(y/n default y)" => "(y/n default y)",
// "Translate labels" => "Translate labels",
// "Menu Cookie" => "Menu Cookie",
// "Open the menu to show current option if possible" => "Open the menu to show current option if possible",
// "One of these parameters has to be set" => "One of these parameters has to be set",
// "Menu Page" => "Menu Page",
// "Displays a Wiki page" => "Displays a Wiki page",
// "Page to display in the menu. Example value: HomePage" => "Page to display in the menu. Example value: HomePage",
// "Wiki Structure Menu" => "Wiki Structure Menu",
// "Displays a structure" => "Displays a structure",
// "N.B. Deprecated, use the Menu module instead" => "N.B. Deprecated, use the Menu module instead",
// "Structure to display in the menu" => "Structure to display in the menu",
// "Unread Inter-User Messages" => "Unread Inter-User Messages",
// "Displays to users their number of new inter-user messages and a link to their message box" => "Displays to users their number of new inter-user messages and a link to their message box",
// "Show If Empty" => "Show If Empty",
// "Show the module when there are no messages waiting. y|n " => "Show the module when there are no messages waiting. y|n ",
// "Default=y" => "Default=y",
"Messages" => "Mensajes",
// "Small live chat box" => "Small live chat box",
// "Channels" => "Channels",
// "List of chat channels. Channel names are separated by a comma (\",\")" => "List of chat channels. Channel names are separated by a comma (\",\")",
// "By default, a single channel named \"default\" exists" => "By default, a single channel named \"default\" exists",
"Mobile" => "Móvil",
// "Currently only shows switch to and from mobile mode" => "Currently only shows switch to and from mobile mode",
// "To Label" => "To Label",
// "Switch to normal site label" => "Switch to normal site label",
// "From Label" => "From Label",
"Switch to mobile site label" => "Etiqueta de cambiar a sitio móvil",
// "Switch Perspective" => "Switch Perspective",
// "Also switch perspective back to this one when leaving mobile mode" => "Also switch perspective back to this one when leaving mobile mode",
// "Stay" => "Stay",
// "Stay on same page" => "Stay on same page",
"Switch to mobile site" => "Cambiar a sitio móvil",
"Switch to normal site" => "Cambiar a sitio normal",
"Months Links" => "Enlaces Mensuales",
// "Link to articles or blog posts for the current month and those preceding it" => "Link to articles or blog posts for the current month and those preceding it",
// "Type of objects to link to" => "Type of objects to link to",
// "\"blogs\" for blog posts, \"cms\" for published articles" => "\"blogs\" for blog posts, \"cms\" for published articles",
// "Object Identifier" => "Object Identifier",
// "Identifier of an object with children to link to" => "Identifier of an object with children to link to",
// "This is required for the blog Object type" => "This is required for the blog Object type",
// "For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3" => "For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3",
// "List by month" => "List by month",
// "Most Commented" => "Most Commented",
// "Display the most commented objects of a certain type" => "Display the most commented objects of a certain type",
// "Type of objects to consider" => "Type of objects to consider",
// "Possible values: wiki (Wiki pages), blog (blog posts), article (articles)" => "Possible values: wiki (Wiki pages), blog (blog posts), article (articles)",
// "Language Filter" => "Language Filter",
// "If set to a RFC1766 language tag, restricts the objects considered to those in the specified language" => "If set to a RFC1766 language tag, restricts the objects considered to those in the specified language",
"Pending Article Submissions" => "Colaboraciones en espera",
// "Displays the number of article submissions waiting examination and a link to the list" => "Displays the number of article submissions waiting examination and a link to the list",
"Old Articles" => "Artículos viejos",
// "Displays the specified number of old articles (which do not show on articles home page anymore)" => "Displays the specified number of old articles (which do not show on articles home page anymore)",
// "Payments Outstanding" => "Payments Outstanding",
// "Displays the payments outstanding for the current user" => "Displays the payments outstanding for the current user",
// "Enables to change current perspective" => "Enables to change current perspective",
// "Powered By" => "Powered By",
// "Powered by Tiki, and others" => "Powered by Tiki, and others",
// "Shows \"Powered by Tiki Wiki CMS Groupware\" message" => "Shows \"Powered by Tiki Wiki CMS Groupware\" message",
// "Tiki version info" => "Tiki version info",
// "Credits" => "Credits",
// "Shows theme credits (contents of credits.tpl)" => "Shows theme credits (contents of credits.tpl)",
// "Icons" => "Icons",
// "Shows various \"powered by\" icons" => "Shows various \"powered by\" icons",
// "Quick Edit" => "Quick Edit",
// "Enables to quickly create or edit Wiki pages" => "Enables to quickly create or edit Wiki pages",
// "Deprecated - use the Search module instead" => "Deprecated - use the Search module instead",
// "Template identifier" => "Template identifier",
// "If set to a template identifier, the specified template is used for creating new Wiki pages" => "If set to a template identifier, the specified template is used for creating new Wiki pages",
// "If set, send the form to the given location (relative to Tiki's root) for processing" => "If set, send the form to the given location (relative to Tiki's root) for processing",
// "SUBMIT label" => "SUBMIT label",
// "The label on the button to submit the form" => "The label on the button to submit the form",
"Create/Edit" => "Crear/editar",
// "INPUT SIZE" => "INPUT SIZE",
// "Size attribute (horizontal, in characters) of the text input field for page names" => "Size attribute (horizontal, in characters) of the text input field for page names",
// "Optional heading to display at the top of the module's content" => "Optional heading to display at the top of the module's content",
// "Category to preselect" => "Category to preselect",
// "If set, pages created through the module have this category prechecked to be categorized in" => "If set, pages created through the module have this category prechecked to be categorized in",
// "Tip to be shown" => "Tip to be shown",
// "Custom text to be shown as a tip at the top of the edit page" => "Custom text to be shown as a tip at the top of the edit page",
// "Title of tip to be shown" => "Title of tip to be shown",
// "Custom title to be shown for the tip at the top of the edit page" => "Custom title to be shown for the tip at the top of the edit page",
// "Custom header template" => "Custom header template",
// "Wiki page to be used as a template to show content on top of edit page" => "Wiki page to be used as a template to show content on top of edit page",
"Quick Edit a Wiki Page" => "Editar una página del wiki",
// "Quick Search" => "Quick Search",
// "Performs a search query and persists the results in the module for quick navigation access" => "Performs a search query and persists the results in the module for quick navigation access",
// "Filter object type" => "Filter object type",
// "Limit search results to a specific object type. Enter an object type to use a static filter or write \"selector\" to provide an input" => "Limit search results to a specific object type. Enter an object type to use a static filter or write \"selector\" to provide an input",
// "Filter category" => "Filter category",
// "Limit search results to a specific category. Enter the comma separated list of category IDs to include in the selector. Single category will display no controls" => "Limit search results to a specific category. Enter the comma separated list of category IDs to include in the selector. Single category will display no controls",
"Quick Admin" => "Admin. rápida",
// "Some helpful tools for admins" => "Some helpful tools for admins",
// "Display mode: module or header. Leave empty for module mode" => "Display mode: module or header. Leave empty for module mode",
"Random Image" => "Imagen aletoria",
// "Displays a random image" => "Displays a random image",
// "If set to an image gallery identifier, restricts the chosen images to those in the identified gallery" => "If set to an image gallery identifier, restricts the chosen images to those in the identified gallery",
// "Show link" => "Show link",
// "If set to \"n\", the image thumbnail does not link to the image" => "If set to \"n\", the image thumbnail does not link to the image",
// "Default: \"y\"" => "Default: \"y\"",
// "Show name" => "Show name",
// "If set to \"y\", the name of the image is displayed" => "If set to \"y\", the name of the image is displayed",
// "If set to \"y\", the description of the image is displayed" => "If set to \"y\", the description of the image is displayed",
"Random Pages" => "Páginas aleatorias",
// "Displays the specified number of random wiki pages" => "Displays the specified number of random wiki pages",
// "New User Registration" => "New User Registration",
// "Permit anonymous visitors to create an account on the site" => "Permit anonymous visitors to create an account on the site",
// "News Feeds" => "News Feeds",
// "List of feeds available on this site" => "List of feeds available on this site",
// "Multi-purpose search module (go or edit page by name and/or search site)" => "Multi-purpose search module (go or edit page by name and/or search site)",
// "Legacy Mode" => "Legacy Mode",
// "Setting to emulate previous behaviour" => "Setting to emulate previous behaviour",
// "If set to \"y\" the search performed is a \"Tiki search\"" => "If set to \"y\" the search performed is a \"Tiki search\"",
// " (full text search)" => " (full text search)",
// "Show Object Type Filter" => "Show Object Type Filter",
// "If set to \"y\" shows a dropdown of sections to search" => "If set to \"y\" shows a dropdown of sections to search",
// " (no object filter)" => " (no object filter)",
// "Use autocomplete" => "Use autocomplete",
// "If set to \"y\" input uses autocomplete for pagenames if applicable" => "If set to \"y\" input uses autocomplete for pagenames if applicable",
// " (use autocomplete)" => " (use autocomplete)",
// "Advanced search" => "Advanced search",
// "Use advanced (boolean) search (full text search only)" => "Use advanced (boolean) search (full text search only)",
// " (use advanced search)" => " (use advanced search)",
// "Advanced search checkbox" => "Advanced search checkbox",
// "Show advanced search checkbox (full text search only)" => "Show advanced search checkbox (full text search only)",
// " (advanced search checkbox off)" => " (advanced search checkbox off)",
// "Advanced search help" => "Advanced search help",
// "Show advanced search help icon (full text search only)" => "Show advanced search help icon (full text search only)",
// " (advanced search help off)" => " (advanced search help off)",
// "Show Search Button" => "Show Search Button",
// "Show search button" => "Show search button",
// " (do show search button)" => " (do show search button)",
// "Show Go Button" => "Show Go Button",
// "Show go to page button" => "Show go to page button",
// " (do show go button)" => " (do show go button)",
// "Show Edit Button" => "Show Edit Button",
// "Show edit button" => "Show edit button",
// " (do show edit button)" => " (do show edit button)",
// "Default Button" => "Default Button",
// "Action to perform on entering <return>" => "Action to perform on entering <return>",
// " (search|go|edit)" => " (search|go|edit)",
// "Search Form Action" => "Search Form Action",
// " tiki-searchresults.php or tiki-searchindex.php (for Tiki search)" => " tiki-searchresults.php or tiki-searchindex.php (for Tiki search)",
// "Edit Submit Label" => "Edit Submit Label",
// "Go Form Action" => "Go Form Action",
"Go" => "Hazlo",
// "Edit Form Action" => "Edit Form Action",
// "Input field width" => "Input field width",
// "Width of the text input field (in characters)" => "Width of the text input field (in characters)",
// " 0 (leave automatic width)" => " 0 (leave automatic width)",
// "Select size" => "Select size",
// "Size of the Search Filter dropdown list" => "Size of the Search Filter dropdown list",
// "Edit Template identifier" => "Edit Template identifier",
// "If set to a category identifier, pages created through the module are automatically categorized in the specified category" => "If set to a category identifier, pages created through the module are automatically categorized in the specified category",
// "Compact mode" => "Compact mode",
// "Makes the three buttons only appear on mouse-over" => "Makes the three buttons only appear on mouse-over",
"Search is disabled" => "La búsqueda está deshabilitada",
"Titles" => "Títulos",
"Search for Wiki Page" => "Busca una página Wiki",
"Search Box" => "Caja de Búsqueda",
// "Small search form for wiki, articles, blogs, etc" => "Small search form for wiki, articles, blogs, etc",
// "If set to \"y\", the search performed is a \"Tiki search\". Default: \"n\" (full text search)" => "If set to \"y\", the search performed is a \"Tiki search\". Default: \"n\" (full text search)",
"Search For a Wiki Page" => "Busca una Página Wiki",
"Search for a wiki page by name" => "Busca una página Wiki por su nombre",
// "Exact match checkbox checked by default if set to \"y\"" => "Exact match checkbox checked by default if set to \"y\"",
"Semantic Links" => "Enlaces Semánticos",
// "List the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from" => "List the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from",
// "Links for sharing, reporting etc" => "Links for sharing, reporting etc",
"Report to Webmaster" => "Informa al Webmaster",
"Share this page" => "Comparte esta página",
// "Use icons for report, share and email links" => "Use icons for report, share and email links",
// "Facebook" => "Facebook",
// "Show Facebook \"Like\" button on the current page" => "Show Facebook \"Like\" button on the current page",
// "Facebook: URL" => "Facebook: URL",
// "URL to \"Like\" (leave blank for current URL)" => "URL to \"Like\" (leave blank for current URL)",
// "Facebook: Send" => "Facebook: Send",
// "Show Facebook \"Send\" button" => "Show Facebook \"Send\" button",
// "Facebook: Layout" => "Facebook: Layout",
// "Size, layout and amount of social context" => "Size, layout and amount of social context",
// "Facebook: Width" => "Facebook: Width",
// "Facebook: Height" => "Facebook: Height",
// "Container height in CSS units (e.g. \"120px\" or \"2em\")" => "Container height in CSS units (e.g. \"120px\" or \"2em\")",
// "Facebook: Show Faces" => "Facebook: Show Faces",
// "Show pictures of others who like this" => "Show pictures of others who like this",
// "Facebook: Verb" => "Facebook: Verb",
// "Verb to display in button" => "Verb to display in button",
// "Facebook: Colors" => "Facebook: Colors",
// "Color scheme" => "Color scheme",
// "Facebook: Font" => "Facebook: Font",
// "Font to display" => "Font to display",
// "Facebook: Locale" => "Facebook: Locale",
// "Locale in the format ll_CC (default \"en_US\")" => "Locale in the format ll_CC (default \"en_US\")",
// "Facebook: Referrals" => "Facebook: Referrals",
// "Label for tracking referrals (optional)" => "Label for tracking referrals (optional)",
// "Facebook: App Id" => "Facebook: App Id",
// "ID of your Facebook app (optional)" => "ID of your Facebook app (optional)",
// "Show Twitter Follow Button on the current page" => "Show Twitter Follow Button on the current page",
// "Twitter: User Name" => "Twitter: User Name",
// "Twitter user name to quote as \"via\"" => "Twitter user name to quote as \"via\"",
// "Twitter: Label" => "Twitter: Label",
// "Text to display. Default \"Tweet\"" => "Text to display. Default \"Tweet\"",
// "Twitter: URL" => "Twitter: URL",
// "URL to \"Tweet\" (leave blank for current URL)" => "URL to \"Tweet\" (leave blank for current URL)",
// "Twitter: Show Count" => "Twitter: Show Count",
// "Position of Tweet count" => "Position of Tweet count",
// "Twitter: Language" => "Twitter: Language",
// "Two letter language code" => "Two letter language code",
// "Twitter: Width" => "Twitter: Width",
// "Width in pixels or percentage (e.g. 300px)" => "Width in pixels or percentage (e.g. 300px)",
// "Twitter: Height" => "Twitter: Height",
// "Twitter: Text" => "Twitter: Text",
// "Tweet text (leave empty to use page title" => "Tweet text (leave empty to use page title",
// "LinkedIn" => "LinkedIn",
// "Linked in share button" => "Linked in share button",
// "LinkedIn: URL" => "LinkedIn: URL",
// "URL to share (leave blank for current URL)" => "URL to share (leave blank for current URL)",
// "LinkedIn: Count Mode" => "LinkedIn: Count Mode",
// "Position of count" => "Position of count",
// "Google +1" => "Google +1",
// "Google +1 button" => "Google +1 button",
// "Google: Size" => "Google: Size",
// "Google button size" => "Google button size",
// "Google: Annotation" => "Google: Annotation",
// "Google annotation" => "Google annotation",
// "Google: Language" => "Google: Language",
// "Google language" => "Google language",
// "Google: URL" => "Google: URL",
// "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows to send messages" => "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows to send messages",
// "If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content" => "If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content",
// "Label on the button to post a message" => "Label on the button to post a message",
// "Wait label" => "Wait label",
// "Label on the button to post a message when the message is being posted if AJAX is enabled" => "Label on the button to post a message when the message is being posted if AJAX is enabled",
// "Please wait.." => "Please wait..",
// "Maximum messages shown" => "Maximum messages shown",
// "Number of messages to display" => "Number of messages to display",
// "Tweet" => "Tweet",
// "If set to \"1\" and the user has authorized us to tweet messages with Twitter, the user can decide, if he wants to shout via Twitter" => "If set to \"1\" and the user has authorized us to tweet messages with Twitter, the user can decide, if he wants to shout via Twitter",
// "If set to \"1\" and the user has authorized us with Facebook, the user can decide, if he wants to add the shout to his Facebook wall" => "If set to \"1\" and the user has authorized us with Facebook, the user can decide, if he wants to add the shout to his Facebook wall",
// "Since Last Visit (Simple)" => "Since Last Visit (Simple)",
// "Displays to logged in users the number of new or updated objects since their last login date and time" => "Displays to logged in users the number of new or updated objects since their last login date and time",
"Since your last visit" => "Desde su última visita",
"Since Last Visit" => "Desde la última visita",
// "Displays to logged in users new or updated objects since a point in time, by default their last login date and time" => "Displays to logged in users new or updated objects since a point in time, by default their last login date and time",
// "Show users" => "Show users",
// "If set to \"n\", do not show new users" => "If set to \"n\", do not show new users",
// "Show trackers" => "Show trackers",
// "If set to \"n\", do not show tracker changes" => "If set to \"n\", do not show tracker changes",
// "Calendar focus" => "Calendar focus",
// "Unless set to \"ignore\", the module changes the reference point in time from the user's last login date and time to a day where users browse to using the calendar" => "Unless set to \"ignore\", the module changes the reference point in time from the user's last login date and time to a day where users browse to using the calendar",
// "Show date as a calendar link" => "Show date as a calendar link",
// "If set to \"n\", do not add a link to tiki calendar on the date in the header (even if feature calendar is set)" => "If set to \"n\", do not add a link to tiki calendar on the date in the header (even if feature calendar is set)",
// "Fold sections by default" => "Fold sections by default",
// "If set to \"y\", fold automatically sections and show only the title (user has to click on each section in order to see the details of modifications)" => "If set to \"y\", fold automatically sections and show only the title (user has to click on each section in order to see the details of modifications)",
// "Use jQuery presentation" => "Use jQuery presentation",
// "If set to \"y\", use jQuery to show the result" => "If set to \"y\", use jQuery to show the result",
// "Minimum timespan" => "Minimum timespan",
// "Instead of the last login time, go back this minimum time, specified in days, in case the last login time is more recent" => "Instead of the last login time, go back this minimum time, specified in days, in case the last login time is more recent",
"Changes since" => "Cambios desde",
"Since your last visit.." => "Desde tu última visita..",
"In the last %0 days.." => "En los últimos %0 días..",
"new comments" => "comentarios nuevos",
" (archived)" => " (archivado/s)",
"new posts" => "publicaciones nuevas",
"wiki pages changed" => "páginas wiki modificadas",
"new articles" => "artículos nuevos",
"new FAQs" => "FAQs nuevos",
"new blogs" => "blogs nuevos",
"new blog posts" => "posts nuevos en blogs",
"new image galleries" => "galerías nuevas de imágenes",
"new images" => "imágenes nuevas",
"new file galleries" => "galerías nuevas de archivos",
"new files" => "archivos nuevos",
"new polls" => "votaciones nuevas",
"new users" => "usuarios nuevos",
"new tracker items" => "items de tracker nuevos",
"updated tracker items" => "items de tracker actualizados",
// "SVN Up Info" => "SVN Up Info",
// "SVN Version and last update information" => "SVN Version and last update information",
"Switch Language" => "Cambia Idioma",
// "Displays a language picker to change the language of the site" => "Displays a language picker to change the language of the site",
// "Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist" => "Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist",
"Switch Theme" => "Cambia Tema",
// "Enables to quickly change the theme" => "Enables to quickly change the theme",
// "Terminology" => "Terminology",
// "Support for multilingual terminology" => "Support for multilingual terminology",
"Root category" => "Categoría raíz",
// "All terms will automatically be put in that category. " => "All terms will automatically be put in that category. ",
// "Note that the category must already exist. " => "Note that the category must already exist. ",
// "Defaults to 'Term'" => "Defaults to 'Term'",
// "Tiki Tests" => "Tiki Tests",
// "Tiki test suite helper" => "Tiki test suite helper",
"Most Active blogs" => "Blogs más activos",
// "Displays the specified number of blogs with links to them, from the most active one to the least" => "Displays the specified number of blogs with links to them, from the most active one to the least",
// "Blog activity measurement can be more or less accurate" => "Blog activity measurement can be more or less accurate",
// "Lists the specified number of articles with links to them, from the most visited one to the least" => "Lists the specified number of articles with links to them, from the most visited one to the least",
"Top File Galleries" => "Galerías de archivos Top",
// "Displays the specified number of file galleries with links to them, starting with the one with most hits" => "Displays the specified number of file galleries with links to them, starting with the one with most hits",
// "Top Files" => "Top Files",
// "Displays the specified number of files with links to them, starting with the one with most hits" => "Displays the specified number of files with links to them, starting with the one with most hits",
"Top Forum Posters" => "Principales Participantes en Foros",
// "Displays the specified number of users who posted to forums, starting with the one having most posts" => "Displays the specified number of users who posted to forums, starting with the one having most posts",
// "Top Image Galleries" => "Top Image Galleries",
// "Displays the specified number of image galleries with links to them, starting with the one with most hits" => "Displays the specified number of image galleries with links to them, starting with the one with most hits",
"Top Images" => "Imágenes Top",
// "Displays the specified number of images with links to them, from the most visited one to the least" => "Displays the specified number of images with links to them, from the most visited one to the least",
// "Top Objects" => "Top Objects",
// "Displays the specified number of objects, starting with the one having the most hits" => "Displays the specified number of objects, starting with the one having the most hits",
"Top Pages" => "Páginas Top",
// "Displays the specified number of wiki pages with links to them, starting with the one having the most hits" => "Displays the specified number of wiki pages with links to them, starting with the one having the most hits",
"Top Quizzes" => "Top Cuestionarios",
// "Displays the specified number of quizzes with links to them, starting with the one having the most hits" => "Displays the specified number of quizzes with links to them, starting with the one having the most hits",
"Top Visited Blogs" => "Blogs más visitados",
// "Display the specified number of blogs with links to them, from the most visited one to the least" => "Display the specified number of blogs with links to them, from the most visited one to the least",
// "Show Last Post" => "Show Last Post",
// "Top Visited FAQs" => "Top Visited FAQs",
// "Display the specified number of FAQs with links to them, from the most visited one to the least" => "Display the specified number of FAQs with links to them, from the most visited one to the least",
"Tracker Input" => "Input del Formulario-bd",
"Allows to open a dialog to create new tracker items" => "PErmite crear un diálogo para crear nuevos ítems de formularios-bd",
"Tracker ID to render" => "ID del Formulario-bd a procesar",
// "Text Input" => "Text Input",
// "Multiple text fields to display as part of the main form along with the label. Field names map to the permanent names in the tracker field definitions. ex: groupName(Group Name) relatedTask(Task)" => "Multiple text fields to display as part of the main form along with the label. Field names map to the permanent names in the tracker field definitions. ex: groupName(Group Name) relatedTask(Task)",
// "Location Field" => "Location Field",
// "Obtain the coordinates from a nearby map and send them to the location field. In addition to the field name, :marker or :viewport can be used as the suffix. Default is :marker" => "Obtain the coordinates from a nearby map and send them to the location field. In addition to the field name, :marker or :viewport can be used as the suffix. Default is :marker",
// "Capture StreetView" => "Capture StreetView",
// "Include a button on the StreetView interface to create tracker items from the location. Requires upload image from URL and location parameter" => "Include a button on the StreetView interface to create tracker items from the location. Requires upload image from URL and location parameter",
// "Alter the submit button label" => "Alter the submit button label",
// "Operation to perform on success" => "Operation to perform on success",
// "Operation to perform in the following format: operationName(argument). Current operations are redirect with the URL template as the argument. @valueName@ will be replaced by the appropriate value where valueName is itemId, status or a permanent name" => "Operation to perform in the following format: operationName(argument). Current operations are redirect with the URL template as the argument. @valueName@ will be replaced by the appropriate value where valueName is itemId, status or a permanent name",
"Create" => "Crear",
"Tracker Help" => "Ayuda del Formulario-bd",
// "Display the fields of a tracker (name and identifier)" => "Display the fields of a tracker (name and identifier)",
// "Text field height" => "Text field height",
// "Number of lines" => "Number of lines",
// "Text field width" => "Text field width",
// "Number of characters" => "Number of characters",
// "Translate Updates" => "Translate Updates",
// "Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed" => "Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed",
// "Reference language" => "Reference language",
// "If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed" => "If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed",
// "Show language" => "Show language",
// "If \"y\" the page language will be shown instead of the page name" => "If \"y\" the page language will be shown instead of the page name",
// "Default = \"y\"" => "Default = \"y\"",
// "Lists the specified number of calendar events, ordered by their start date" => "Lists the specified number of calendar events, ordered by their start date",
// "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")" => "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")",
// "Maximum days in the future" => "Maximum days in the future",
// "Maximum distance to event start dates in days (looking forward)" => "Maximum distance to event start dates in days (looking forward)",
// "Maximum days in the past" => "Maximum days in the past",
// "Maximum distance to event end dates in days (looking backward)" => "Maximum distance to event end dates in days (looking backward)",
// "cellpadding" => "cellpadding",
// "If set to an integer, apply this cellpadding to the HTML table generated" => "If set to an integer, apply this cellpadding to the HTML table generated",
// "cellspacing" => "cellspacing",
// "If set to an integer, apply this cellspacing to the HTML table generated" => "If set to an integer, apply this cellspacing to the HTML table generated",
// "If set to \"y\", event descriptions are displayed" => "If set to \"y\", event descriptions are displayed",
"Show end date and time" => "Muestra la fecha y hora final",
// "If set to \"y\", event end dates and times are displayed, when appropriate" => "If set to \"y\", event end dates and times are displayed, when appropriate",
// "Use custom calendar background colors" => "Use custom calendar background colors",
// "If set to \"y\", events are displayed with their calendar's custom background color (if one is set)" => "If set to \"y\", events are displayed with their calendar's custom background color (if one is set)",
// "Show information in tooltips" => "Show information in tooltips",
// "If set to \"n\", event tooltips will not display event information" => "If set to \"n\", event tooltips will not display event information",
// "Date format" => "Date format",
// "Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>" => "Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>",
// "site preference for short date format followed by site preference for short time format" => "site preference for short date format followed by site preference for short time format",
// "If set to an integer, event names are allowed that number of characters as a maximum before being truncated" => "If set to an integer, event names are allowed that number of characters as a maximum before being truncated",
// "My Blogs" => "My Blogs",
// "Displays to registered users their blogs" => "Displays to registered users their blogs",
// "Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed" => "Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed",
// "My Image Galleries" => "My Image Galleries",
// "Displays to registered users their image galleries" => "Displays to registered users their image galleries",
"User Pages" => "Páginas del usuario",
// "Displays to registered users the specified number of wiki pages which they were the last to edit" => "Displays to registered users the specified number of wiki pages which they were the last to edit",
"My Pages" => "Mis páginas",
"My Tasks" => "Tareas de Usuario",
// "Lightweight interface to user tasks, enabling to view them concisely and do some manipulations" => "Lightweight interface to user tasks, enabling to view them concisely and do some manipulations",
"The task title must have at least 3 characters" => "El título de la tarea debe tener al menos 3 caracteres",
"Public Tasks" => "Tareas públicas",
// "Lists the public user tasks of a chosen group, with links to tasks" => "Lists the public user tasks of a chosen group, with links to tasks",
"User-Group Tracker" => "Formulario-bd de Usuario-Grupo",
// "User and Group tracker links" => "User and Group tracker links",
// "My Score" => "My Score",
// "Display the logged user's rank and score" => "Display the logged user's rank and score",
"Most Active Users" => "Principales usuarios",
// "Display the specified number of users and their score, starting from the one with the highest score" => "Display the specified number of users and their score, starting from the one with the highest score",
// "Webmail Inbox" => "Webmail Inbox",
// "Displays Webmail Inbox" => "Displays Webmail Inbox",
// "Account Id" => "Account Id",
// "Webmail account identifier (if not set uses user's current account)" => "Webmail account identifier (if not set uses user's current account)",
// "GroupMail: Group (e.g. \"Help Team\")" => "GroupMail: Group (e.g. \"Help Team\")",
// "GroupMail: Tracker Id (to store GroupMail activity)" => "GroupMail: Tracker Id (to store GroupMail activity)",
// "GroupMail: From Field (Id of field in tracker to store email From header)" => "GroupMail: From Field (Id of field in tracker to store email From header)",
// "GroupMail: Subject Field (Id of field in tracker to store email Subject header)" => "GroupMail: Subject Field (Id of field in tracker to store email Subject header)",
// "GroupMail: Message Field (Id of field in tracker to store email message identifier)" => "GroupMail: Message Field (Id of field in tracker to store email message identifier)",
// "GroupMail: Content Field (Id of field in tracker to store email message body content)" => "GroupMail: Content Field (Id of field in tracker to store email message body content)",
// "GroupMail: Account Field (Id of field in tracker to store Webmail account name)" => "GroupMail: Account Field (Id of field in tracker to store Webmail account name)",
// "DateTime Field Id" => "DateTime Field Id",
// "GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)" => "GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)",
// "GroupMail: Operator Field (Id of field in tracker to store operator name (username))" => "GroupMail: Operator Field (Id of field in tracker to store operator name (username))",
// "Maximum number of characters in subjects allowed before truncating" => "Maximum number of characters in subjects allowed before truncating",
// "Webmail error" => "Webmail error",
// "No accounts set up (or no current account set)" => "No accounts set up (or no current account set)",
// "Related Items" => "Related Items",
// "Lists objects which share a category with the viewed object" => "Lists objects which share a category with the viewed object",
"Online Users" => "Usuarios online",
// "Display information about users currently logged in" => "Display information about users currently logged in",
// "List Type" => "List Type",
// "Display the number of users logged in, the list of users logged in, or both" => "Display the number of users logged in, the list of users logged in, or both",
// "Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"" => "Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"",
// "Cluster Mode" => "Cluster Mode",
// "If set to \"1\", separate users based on which host/server they logged on" => "If set to \"1\", separate users based on which host/server they logged on",
// "Newest Comments" => "Newest Comments",
// "Lists the specified number of comments starting from the most recently posted" => "Lists the specified number of comments starting from the most recently posted",
// "More in tooltips" => "More in tooltips",
// "If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item's tooltip" => "If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item's tooltip",
// "Type of the objects from which comments will be listed. Possible values" => "Type of the objects from which comments will be listed. Possible values",
// "Comments about objects in this language only" => "Comments about objects in this language only",
// "Last article comments" => "Last article comments",
"Last wiki comments" => "Últimos comentarios wiki",
// "Displays YouTube videos and/or a link to a YouTube user's page" => "Displays YouTube videos and/or a link to a YouTube user's page",
// "Video identifiers" => "Video identifiers",
// "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")" => "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")",
// "YouTube user identifier" => "YouTube user identifier",
// "If set to a YouTube user identifier, display a link to the videos of this user" => "If set to a YouTube user identifier, display a link to the videos of this user",
// "Videos on YouTube" => "Videos on YouTube",
// "Bibliography Search" => "Bibliography Search",
// "Search the group's Zotero library for entries with the specified tags" => "Search the group's Zotero library for entries with the specified tags",
// "Invalid server key" => "Invalid server key",
"Invalid username or password" => "Usuario o contraseña no válidos",
// "Cookie not found" => "Cookie not found",
// "Select <a href=\"tiki-list_banners.php\" title=\"Banners\">Admin &gt; Banners</a> from the menu to create and edit banner zones" => "Select <a href=\"tiki-list_banners.php\" title=\"Banners\">Admin &gt; Banners</a> from the menu to create and edit banner zones",
"Cancel Edit" => "Cancelar edición",
"Change preferences" => "Cambiar preferencias",
// "Activate the feature" => "Activate the feature",
// "Plugins" => "Plugins",
"Site Ads and Banners" => "Publicidad y Banners del Sitio",
// "<strong>Activate</strong> will display content for Admin only. Select <strong>Publish</strong> to display for all users" => "<strong>Activate</strong> will display content for Admin only. Select <strong>Publish</strong> to display for all users",
"Settings" => "Opciones",
// "Areas Overview" => "Areas Overview",
// "Nothing was updated" => "Nothing was updated",
// "Edit perspective" => "Edit perspective",
// "No category found in area" => "No category found in area",
// "Hint" => "Hint",
// "This tab shows you an overview of categories affected by the areas feature. The category with the smallest id should be the category set as areas root in the settings tab. If not so, update this overview with the button below" => "This tab shows you an overview of categories affected by the areas feature. The category with the smallest id should be the category set as areas root in the settings tab. If not so, update this overview with the button below",
// "Update areas" => "Update areas",
// "How to setup" => "How to setup",
// "You have to enable the perspective and the categories feature. Then set a structure of categories with a common parent. Set that parent as areas root in the settings tab. Then go to " => "You have to enable the perspective and the categories feature. Then set a structure of categories with a common parent. Set that parent as areas root in the settings tab. Then go to ",
// "perspectives" => "perspectives",
// "There you can create a set of perspectives to bind the children of areas root to. Change for every perspective you want the category jail to another child. It is designed that every child category is bind to one perspective only. If you do otherwise, the first found perspective is used" => "There you can create a set of perspectives to bind the children of areas root to. Change for every perspective you want the category jail to another child. It is designed that every child category is bind to one perspective only. If you do otherwise, the first found perspective is used",
"Look under \"Articles\" on the application menu for links to" => "Busque bajo \"Artículos\" en el menú de aplicación para enlaces a",
// "Admin topics" => "Admin topics",
// "Admin types" => "Admin types",
"General Settings" => "Configuraciones Generales",
"Features" => "Funcionalidades",
// "Article properties" => "Article properties",
// "Default maximum dimensions of custom images" => "Default maximum dimensions of custom images",
// "General (view mode)" => "General (view mode)",
// "List mode" => "List mode",
// "Sharing on social networks" => "Sharing on social networks",
"Import CSV file" => "Importar archivo CSV",
// "Batch upload (CSV file)" => "Batch upload (CSV file)",
// "File format: title,authorName,heading,body,lang,user" => "File format: title,authorName,heading,body,lang,user",
"Import" => "Importar",
// "Articles Listing" => "Articles Listing",
"List Articles" => "Listar Artículos",
// "Select which items to display when listing articles" => "Select which items to display when listing articles",
// "Article View" => "Article View",
"To add/remove blogs, go to \"Create/Edit Blog\" under \"Blogs\" on the application menu, or" => "Para agregar/borrar globs, vaya a \"Crear/Editar\" blogs bajo \"Blogs\" en el menú de aplicación, o ",
"Click Here" => "Haga click acá",
"Comments" => "Comentarios",
// "Blogs Listings" => "Blogs Listings",
// "Select which items to display when listing blogs" => "Select which items to display when listing blogs",
// "To add/remove calendars, look for \"Calendar\" under \"Admin\" on the application menu, or" => "To add/remove calendars, look for \"Calendar\" under \"Admin\" on the application menu, or",
"Change settings" => "Cambiar configuración",
// "General settings" => "General settings",
// "Default calendars to display" => "Default calendars to display",
// "All calendars" => "All calendars",
// "A subset of available calendars" => "A subset of available calendars",
// "Create calendar" => "Create calendar",
// "Year selection is valid when the JS Calendar <strong>is not</strong> enabled" => "Year selection is valid when the JS Calendar <strong>is not</strong> enabled",
// "Browse categories" => "Browse categories",
// "Administer categories" => "Administer categories",
// "Organize Objects" => "Organize Objects",
// "Feedback" => "Feedback",
// "Category objects" => "Category objects",
// "Re-apply the last saved category defaults to the wiki pages" => "Re-apply the last saved category defaults to the wiki pages",
// "List comments" => "List comments",
"General Preferences" => "Preferencias Generales",
// "Site-wide features" => "Site-wide features",
// "Display options" => "Display options",
"Permission" => "Permiso",
// "Inline comments" => "Inline comments",
// "The feature below must be activated for this feature to work" => "The feature below must be activated for this feature to work",
// "Using comments in various features" => "Using comments in various features",
"Admin Groups" => "Admin grupos",
"Admin Users" => "Admin usuarios",
// "Manage permissions" => "Manage permissions",
// "User features" => "User features",
"Community" => "Comunidad",
// "Default user preferences" => "Default user preferences",
// "Users Default Preferences" => "Users Default Preferences",
// "User messages" => "User messages",
"My Tiki" => "Mi Tiki",
// "Select which items to display when listing users" => "Select which items to display when listing users",
// "Join the community" => "Join the community",
// "Tiki Wiki CMS Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU" => "Tiki Wiki CMS Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU",
// "Join the Community" => "Join the Community",
// "Tiki news" => "Tiki news",
// "Embedded RSS feed from info.tiki.org TODO, meanwhile" => "Embedded RSS feed from info.tiki.org TODO, meanwhile",
// "Tiki Newsletter" => "Tiki Newsletter",
// "Promote your site" => "Promote your site",
// "Add your site to the Tiki diretory" => "Add your site to the Tiki diretory",
// "Submit your site" => "Submit your site",
// "Spread the word" => "Spread the word",
// "Add the \"Powered by\" module to your site. " => "Add the \"Powered by\" module to your site. ",
// "Manage Modules" => "Manage Modules",
// "Help improve Tiki" => "Help improve Tiki",
// "Submit a feature request or bug report" => "Submit a feature request or bug report",
// "Click here to go to our development site" => "Click here to go to our development site",
// "Make a financial contribution to the Tiki Association" => "Make a financial contribution to the Tiki Association",
// "Contribute to Tiki" => "Contribute to Tiki",
// "New Feature" => "New Feature",
// "Please note: Experimental - work in progress" => "Please note: Experimental - work in progress",
// "Tiki Connect is a way to let the Tiki project know how it is being used, and which parts people like or would like fixing (or explaining)" => "Tiki Connect is a way to let the Tiki project know how it is being used, and which parts people like or would like fixing (or explaining)",
// "When you click the \"Send Info\" below you will be connected with mother.tiki.org, which is where the data will be collected" => "When you click the \"Send Info\" below you will be connected with mother.tiki.org, which is where the data will be collected",
// "You can also send feedback about Tiki by checking the \"Feedback\" checkbox above. Icons will appear next to all the preferences where you can \"like\", request a \"fix\" or ask \"what's this for?\"" => "You can also send feedback about Tiki by checking the \"Feedback\" checkbox above. Icons will appear next to all the preferences where you can \"like\", request a \"fix\" or ask \"what's this for?\"",
// "Your votes are sent when you connect with mother.tiki.org (currently only be clicking the \"Send Info\" button)" => "Your votes are sent when you connect with mother.tiki.org (currently only be clicking the \"Send Info\" button)",
// "For more info" => "For more info",
// "Send Info" => "Send Info",
// "Send the data" => "Send the data",
// "Preview info" => "Preview info",
// "See what is going to be sent" => "See what is going to be sent",
// "Fill form" => "Fill form",
// "Fill this form in based on other preferences" => "Fill this form in based on other preferences",
// "Site Title is required" => "Site Title is required",
// "Advanced settings" => "Advanced settings",
// "Exposed to assist testing and development" => "Exposed to assist testing and development",
// "Connections received" => "Connections received",
// "Recent connections" => "Recent connections",
// "Rebuild Index" => "Rebuild Index",
// "Rebuild received connections index" => "Rebuild received connections index",
// "<strong>Server stats:</strong> %0 reports received from %1 Tikis" => "<strong>Server stats:</strong> %0 reports received from %1 Tikis",
// "Copyright allows to determine a copyright for all the objects of tiki" => "Copyright allows to determine a copyright for all the objects of tiki",
// "Enable copyright management for" => "Enable copyright management for",
"To configure your directory, find \"Admin Directory\" under \"Directory\" on the application menu, or" => "Para configurar su directorio, busque \"Admin directorio\" bajo \"Directorio\" en el menú de aplicación, o",
"To add/remove FAQs, look for \"Admin FAQs\" under \"FAQs\" on the application menu, or" => "Para agregar/borrar FAQs, busque \"Admin FAQs\" bajo \"FAQs\" en el menú de aplicación, o",
// "Please see the <a class='rbox-link' target='tikihelp' href='http://doc.tiki.org/Features'>evaluation of each feature</a> on Tiki's developer site" => "Please see the <a class='rbox-link' target='tikihelp' href='http://doc.tiki.org/Features'>evaluation of each feature</a> on Tiki's developer site",
"Apply" => "Aplícalo",
// "Global features" => "Global features",
// "Main feature" => "Main feature",
// "Additional" => "Additional",
// "Interaction with online services or other software" => "Interaction with online services or other software",
// "Configuration completed" => "Configuration completed",
// "Authenticate with Zotero" => "Authenticate with Zotero",
"Watches" => "Watches",
// "Interface" => "Interface",
// "jQuery plugins and add-ons" => "jQuery plugins and add-ons",
// "Mobile Themes" => "Mobile Themes",
// "Programmer" => "Programmer",
"Logging and Reporting" => "Registros e Informes",
"Visible to admin only" => "Visible sólo a administradores",
"Include Smarty notices" => "Incluye avisos del gestor de plantillas Smarty",
"Custom Code" => "Código Configurable",
// "Event Hooks" => "Event Hooks",
// "Please note that this is a relatively new feature that still needs to be deployed all around. Expect more events to be added over time" => "Please note that this is a relatively new feature that still needs to be deployed all around. Expect more events to be added over time",
// "If you need to add behaviors to Tiki, there are several event hooks you can attach to. Here are the events and the inheritance" => "If you need to add behaviors to Tiki, there are several event hooks you can attach to. Here are the events and the inheritance",
// "Draw Event Diagram" => "Draw Event Diagram",
// "To create or remove file galleries, select" => "To create or remove file galleries, select",
// "from the application menu" => "from the application menu",
"If you decide to store files in a directory you must ensure that the user cannot access directly to the directory." => "Si decide guardar archivos en un directorio debe asegurarse que el usuario no puede acceder directamente al directorio.",
"You have two options to accomplish this:<br /><ul><li>Use a directory outside your document root, make sure your php script can read and write to that directory</li><li>Use a directory inside the document root and use .htaccess to prevent the user from listing the directory contents</li></ul>" => "Tiene 2 opciones para lograr esto:<br /><ul><li>Usar un directorio fuera del document root, asegurandose que su script en php puede leer y escribir en ese directorio</li><li>Usar un directorio dentro del document root y usar  .htaccess para evitar que los usuarios listen el contenido del directorio</li></ul>",
"To configure the directory path use UNIX like paths for example files/ or c:/foo/files or /www/files/" => "Para configurar el camino al directorio use caminos similares a los de UNIX, p/ej archivos/ o c:/foo/archivos o /www/archivos/",
// "Move files from database to directory" => "Move files from database to directory",
// "Move files from directory to database" => "Move files from directory to database",
// "Manage comment settings" => "Manage comment settings",
// "You are highly recommended to use a file directory as the File Gallery storage, when using this feature" => "You are highly recommended to use a file directory as the File Gallery storage, when using this feature",
// "A cron job must be set up in order to delete the files" => "A cron job must be set up in order to delete the files",
// "Update mime of all non archived octet-stream files" => "Update mime of all non archived octet-stream files",
// "Quota" => "Quota",
// "Used" => "Used",
// "Upload Regex" => "Upload Regex",
// "Gallery Listings" => "Gallery Listings",
// "Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries" => "Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries",
// "Select which items to display when listing galleries: " => "Select which items to display when listing galleries: ",
// "Admin Gallery Listings" => "Admin Gallery Listings",
// "Select which items to display when admin galleries: " => "Select which items to display when admin galleries: ",
// "Search Indexing" => "Search Indexing",
// "Handlers" => "Handlers",
// "Add custom handlers to make your files &quot;searchable&quot; content" => "Add custom handlers to make your files &quot;searchable&quot; content",
// "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command" => "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command",
// "To delete a handler, leave the <strong>System Command</strong> field blank" => "To delete a handler, leave the <strong>System Command</strong> field blank",
// "Tiki is pre-configured to handle many common types. If any of those are listed here, it is because the command line tool is unavailable" => "Tiki is pre-configured to handle many common types. If any of those are listed here, it is because the command line tool is unavailable",
// "Missing Handlers" => "Missing Handlers",
"MIME Type" => "Tipo MIME",
// "System Command" => "System Command",
"Reindex all files for search" => "Reindexar todos los archivos para búsqueda",
// "SCORM" => "SCORM",
"To add/remove forums, look for \"Admin forums\" under \"Forums\" on the application menu, or" => "Para agregar/borrar foros, busque por \"Admin foros\" bajo \"Foros\" en el menú de aplicación, o",
// "Threads" => "Threads",
"Searches" => "Busquedas",
// "Forums Listing" => "Forums Listing",
// "Select which items to display when listing forums" => "Select which items to display when listing forums",
// "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>" => "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>",
// "Random tag cloud colors" => "Random tag cloud colors",
// "Separate colors with a comma (,)" => "Separate colors with a comma (,)",
// "Alphanumeric ASCII characters only" => "Alphanumeric ASCII characters only",
// "No accents or special characters" => "No accents or special characters",
// "Accept all characters" => "Accept all characters",
// "Tag Management" => "Tag Management",
// "Cleanup unused tags" => "Cleanup unused tags",
// "3D Tag Browser Configuration" => "3D Tag Browser Configuration",
"General" => "General",
// "Graph appearance" => "Graph appearance",
// "Camera settings" => "Camera settings",
// "Physics engine" => "Physics engine",
"To add/remove image galleries, go to \"Image Galleries\" on the application menu, or" => "Para agregar/borrar galerías de imágenes, vaya a \"Galerías de Imágenes\" en el menú de aplicación, o",
"You can upload images of a size of " => "Puede subir imágenes de un tamaño de ",
"Alter the php.ini variables file_uploads, upload_max_filesize, post_max_size and database variables (max_allowed_packet for mysql) to change this value" => "Modifique las variables del php.ini file_uploads, upload_max_filesize, post_max_size y variables de la base de datos  (max_allowed_packet para mysql) para cambiar este valor",
"Home Gallery" => "Galería Inicial",
"Galleries features" => "Preferencias de galerías",
"Uses Slideshow" => "Usa Diapositivas",
"Use database to store images" => "Usar base de datos para guardar imágenes",
"Use a directory to store images" => "Usar directorio para guardar imágenes",
"Directory path" => "Directorio",
// "Note: if you change this directory, you have to move the contents to the new directory. You can also use the 'Mover' below" => "Note: if you change this directory, you have to move the contents to the new directory. You can also use the 'Mover' below",
"Library to use for processing images" => "Libreria a usar para procesar imágenes",
"Uploaded image names must match regex" => "Nombres de imágenes deben matchear esta regex",
"Uploaded image names cannot match regex" => "Nombres de imágenes no deben matchear esta regex",
"Directory Batch Loading" => "Carga en lote de Directorio",
"If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload images in that dir, either by scp, ftp, or other protocols" => "Si activa Carga en lote de Directorio, debe configurar un directorio legible desde el servidor (fuera del espacio de páginas es preferible). Después configure una forma de subir imágenes en ese directorio, ya sea por scp, ftp u otros protocolos",
"Enable directory batch loading" => "Activar subida en lote por directorio",
"Batch loading directory" => "Directorio de subida en lote",
// "Display image information in a mouseover box" => "Display image information in a mouseover box",
// "yes, and don't display that information under the image" => "yes, and don't display that information under the image",
// "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)" => "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)",
"Max Rows per page" => "Cantidad máxima de filas por página",
"Images per row" => "Imágenes por fila",
"Thumbnails size X" => "Tamaño X para miniaturas",
// "Pixels Default" => "Pixels Default",
"Thumbnails size Y" => "Tamaño Y para miniaturas",
// "Default scale size" => "Default scale size",
"pixels" => "pixels",
"Set features" => "Establecer funcionalidades",
"Exterminator" => "Exterminador",
"Remove images in the system gallery not being used in Wiki pages, articles or blog posts" => "Quitar imágenes en la galería del sistema que no son usadas",
"Remove" => "Eliminar",
"Mover" => "Movedor/a",
// "Move images from database storage to filesystem storage" => "Move images from database storage to filesystem storage",
// "Move images from filesystem storage to database storage" => "Move images from filesystem storage to database storage",
"All galleries" => "Todas las galerías",
"System Gallery" => "Galería del sistema",
"Move" => "Mueve",
// "Move images from old filesystem store to new directory" => "Move images from old filesystem store to new directory",
// "Moved" => "Moved",
"Gallery listing configuration" => "Configuración del listado de galerías",
"Change configuration" => "Cambiar configuración",
"Image galleries comments settings" => "Configuración para los comentarios en galerías de imágenes",
// "Server Fitness" => "Server Fitness",
// "Release Check" => "Release Check",
// "Last update from SVN" => "Last update from SVN",
// "Reset or upgrade your database" => "Reset or upgrade your database",
// "Check for updates now" => "Check for updates now",
"Site Identity" => "Identidad del Sitio",
// "Go to <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look & Feel</strong></a> section for additional site related customization preferences" => "Go to <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look & Feel</strong></a> section for additional site related customization preferences",
// "These values will be stored in plain text in the database" => "These values will be stored in plain text in the database",
// "Email to send a test mail" => "Email to send a test mail",
// "Sessions" => "Sessions",
// "Advanced configuration warning" => "Advanced configuration warning",
// "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects" => "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects",
// "Changing this feature will immediately log you out when you save this preference" => "Changing this feature will immediately log you out when you save this preference",
// "Enable now" => "Enable now",
// "Contact" => "Contact",
// "Miscellaneous" => "Miscellaneous",
"Menus" => "Menús",
// "Create and edit menus " => "Create and edit menus ",
"Home Page" => "Página Inicial",
// "Redirects" => "Redirects",
// "Site Access" => "Site Access",
// "Sample" => "Sample",
"Date and Time Format Help" => "Ayuda de Formatos de Fecha y Hora",
"Change admin password" => "Cambiar contraseña de administrador",
// "Change the <strong>Admin</strong> password" => "Change the <strong>Admin</strong> password",
// "User administration" => "User administration",
// "To use Google Maps, you must generate a Google Maps API Key for your web site. See <a href=\"http://code.google.com/intl/fr/apis/maps/signup.html\">http://code.google.com/intl/fr/apis/maps/signup.html</a> for details" => "To use Google Maps, you must generate a Google Maps API Key for your web site. See <a href=\"http://code.google.com/intl/fr/apis/maps/signup.html\">http://code.google.com/intl/fr/apis/maps/signup.html</a> for details",
// "Defaults" => "Defaults",
// "Map mode in listings" => "Map mode in listings",
// "Internationalization" => "Internationalization",
// "Babelfish links" => "Babelfish links",
// "Customized String Translation" => "Customized String Translation",
"Syntax error" => "Error de sintaxis",
// "Cannot open/write this file" => "Cannot open/write this file",
// "Custom translation will not be saved. Ask your administration to change the permission" => "Custom translation will not be saved. Ask your administration to change the permission",
"ok" => "ok",
// "The file has been saved" => "The file has been saved",
"Translation" => "Traducción",
// "Intertiki client" => "Intertiki client",
// "Tiki Unique key" => "Tiki Unique key",
// "InterTiki Slave mode" => "InterTiki Slave mode",
// "Warning: overrides manually registered local users" => "Warning: overrides manually registered local users",
// "as master" => "as master",
// "Import user preferences" => "Import user preferences",
// "Import user groups" => "Import user groups",
// "Limit group import (comma-separated list of imported groups, leave empty to avoid limitation)" => "Limit group import (comma-separated list of imported groups, leave empty to avoid limitation)",
// "Intertiki shared cookie for sliding auth under same domain" => "Intertiki shared cookie for sliding auth under same domain",
// "InterTiki Server" => "InterTiki Server",
// "host" => "host",
"port" => "puerto",
// "Add new server" => "Add new server",
// "Intertiki server" => "Intertiki server",
// "Intertiki Server enabled" => "Intertiki Server enabled",
// "Access Log file" => "Access Log file",
// "Errors Log file" => "Errors Log file",
// "Known hosts" => "Known hosts",
// "Key" => "Key",
"IP" => "IP",
"Enable/disable Tiki features in " => "Activa/desactiva funcionalidades de Tiki en ",
", but configure them elsewhere" => ", pero configúralas en otro lado",
"Registration" => "Registro",
"Log in" => "Conéctate",
// "Generate a passcode" => "Generate a passcode",
// "Requires PHP GD library" => "Requires PHP GD library",
// "Users can select a group to join at registration" => "Users can select a group to join at registration",
// "By default, new users automatically join the Registered group" => "By default, new users automatically join the Registered group",
// "Store passwords in plain text is activated. You should never set this unless you know what you are doing" => "Store passwords in plain text is activated. You should never set this unless you know what you are doing",
// "Assign users to group function of email pattern" => "Assign users to group function of email pattern",
// "You must change the Authentication Method to LDAP for these changes to take effect" => "You must change the Authentication Method to LDAP for these changes to take effect",
// "LDAP Bind settings" => "LDAP Bind settings",
// "LDAP User" => "LDAP User",
// "LDAP Admin" => "LDAP Admin",
// "LDAP external groups" => "LDAP external groups",
// "LDAP Group" => "LDAP Group",
// "LDAP Group Member - if group membership can be found in group attributes" => "LDAP Group Member - if group membership can be found in group attributes",
// "LDAP User Group - if group membership can be found in user attributes" => "LDAP User Group - if group membership can be found in user attributes",
"PAM" => "PAM",
// "You must change the Authentication Method to PAM for these changes to take effect" => "You must change the Authentication Method to PAM for these changes to take effect",
// "Shibboleth Authentication " => "Shibboleth Authentication ",
// "You must change the Authentication Method to Shibboleth for these changes to take effect" => "You must change the Authentication Method to Shibboleth for these changes to take effect",
// "CAS" => "CAS",
// "You must change the Authentication Method to CAS for these changes to take effect" => "You must change the Authentication Method to CAS for these changes to take effect",
// "CAS Server" => "CAS Server",
// "CAS Server Name" => "CAS Server Name",
// "CAS Server Port" => "CAS Server Port",
// "CAS Server Path" => "CAS Server Path",
// "phpBB User Database Authentication " => "phpBB User Database Authentication ",
// "You must change the Authentication Method to phpBB for these changes to take effect" => "You must change the Authentication Method to phpBB for these changes to take effect",
// "You must turn Users can register off for phpBB Authentication to function properly" => "You must turn Users can register off for phpBB Authentication to function properly",
// "MySql only (for now)" => "MySql only (for now)",
// "Web Server Authentication " => "Web Server Authentication ",
// "You must change the Authentication Method to Web Server for these changes to take effect" => "You must change the Authentication Method to Web Server for these changes to take effect",
// "Theme Screenshot" => "Theme Screenshot",
// "The \"users can change theme\" feature will override the theme displayed" => "The \"users can change theme\" feature will override the theme displayed",
// "Theme not saved yet - click \"Apply\"" => "Theme not saved yet - click \"Apply\"",
"Restrict available themes" => "Restringir temas disponibles",
// "General Layout" => "General Layout",
// "&quot;Modules&quot; are the items of content at the top &amp; bottom and in the right &amp; left columns of the site" => "&quot;Modules&quot; are the items of content at the top &amp; bottom and in the right &amp; left columns of the site",
// "Admin &gt; Modules" => "Admin &gt; Modules",
// "from the menu to create and edit modules" => "from the menu to create and edit modules",
// "Module zone visibility" => "Module zone visibility",
// "Site Report Bar" => "Site Report Bar",
// "Pagination" => "Pagination",
// "UI Effects" => "UI Effects",
// "Standard UI effects" => "Standard UI effects",
// "Tab UI effects" => "Tab UI effects",
// "Customization" => "Customization",
// "Open editor" => "Open editor",
// "Preview Theme" => "Preview Theme",
// "Custom Codes" => "Custom Codes",
// "Experimental: CSS assistant (work in progress - click the x to remove)" => "Experimental: CSS assistant (work in progress - click the x to remove)",
// "Editing" => "Editing",
// "View Templates" => "View Templates",
"Admin layout per section" => "Administrar diseño por sección",
// "Favicon" => "Favicon",
// "Context Menus" => "Context Menus",
// "Currently used in File Galleries only" => "Currently used in File Galleries only",
// "Separators" => "Separators",
// "MapServer settings" => "MapServer settings",
"Generate User Map" => "Generar Mapa de Usuarios",
// "See also" => "See also",
"Search Engine Friendly URLs" => "URLs Amigables a Motores de Búsqueda",
// "Meta tags" => "Meta tags",
// "Geo URL" => "Geo URL",
"Robots" => "Robots",
// "Configure metrics" => "Configure metrics",
// "Show past results" => "Show past results",
// "Past results count" => "Past results count",
// "{\$crumbs[\$crumb]->description}" => "{\$crumbs[\$crumb]->description}",
// "If you lose your login module, use tiki-login_scr.php to be able to login" => "If you lose your login module, use tiki-login_scr.php to be able to login",
// "Payments" => "Payments",
// "Choose payment system" => "Choose payment system",
// "You can use only one payment method: PayPal or Cclite or Tiki User Credits" => "You can use only one payment method: PayPal or Cclite or Tiki User Credits",
// "PayPal is working at the moment. See PayPal.com" => "PayPal is working at the moment. See PayPal.com",
// "Cclite: Community currency accounting for local exchange trading systems (LETS). See " => "Cclite: Community currency accounting for local exchange trading systems (LETS). See ",
// "sourceforge.net" => "sourceforge.net",
// "Tiki User Credits: Requires this other feature to be configured" => "Tiki User Credits: Requires this other feature to be configured",
// "Cclite is for creating and managing alternative or complementary trading currencies and groups" => "Cclite is for creating and managing alternative or complementary trading currencies and groups",
// "Work in progress since Tiki 6" => "Work in progress since Tiki 6",
// "Advanced Shopping Cart" => "Advanced Shopping Cart",
// "Advanced Cart Tracker Names Setup" => "Advanced Cart Tracker Names Setup",
// "Products Tracker Setup" => "Products Tracker Setup",
// "Depending on which feature you are using, you may need some or all of the following fields to be setup" => "Depending on which feature you are using, you may need some or all of the following fields to be setup",
// "Shipping" => "Shipping",
// "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Performance page</a> on Tiki's developer site" => "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Performance page</a> on Tiki's developer site",
"Performance" => "Rendimiento",
// "Output compression is active" => "Output compression is active",
// "Compression is handled by" => "Compression is handled by",
// "Bytecode Cache" => "Bytecode Cache",
// "Using <strong>%0</strong>.These stats affect all PHP applications running on the server" => "Using <strong>%0</strong>.These stats affect all PHP applications running on the server",
// "Configuration setting <em>xcache.admin.enable_auth</em> prevents from accessing statistics. This will also prevent the cache from being cleared when clearing template cache" => "Configuration setting <em>xcache.admin.enable_auth</em> prevents from accessing statistics. This will also prevent the cache from being cleared when clearing template cache",
// "Available" => "Available",
"Memory" => "Memoria",
// "Miss" => "Miss",
"Hit" => "Impacto",
// "Cache Hits" => "Cache Hits",
// "Memory Used" => "Memory Used",
// "Misses" => "Misses",
// "Few hits recorded. Statistics may not be representative" => "Few hits recorded. Statistics may not be representative",
// "Low hit ratio. %0 may be misconfigured and not used" => "Low hit ratio. %0 may be misconfigured and not used",
// "Little memory available. Thrashing likely to occur" => "Little memory available. Thrashing likely to occur",
// "The values to increase are apc.shm_size (for APC) or xcache.size (for XCache)" => "The values to increase are apc.shm_size (for APC) or xcache.size (for XCache)",
// "Small amount of memory allocated to %0. Verify the configuration" => "Small amount of memory allocated to %0. Verify the configuration",
// "Configuration <em>%0</em> is enabled. Disabling modification checks can improve performance, but will require manual clear on file updates" => "Configuration <em>%0</em> is enabled. Disabling modification checks can improve performance, but will require manual clear on file updates",
// "<em>%0</em> should not be disabled due to authentication on XCache" => "<em>%0</em> should not be disabled due to authentication on XCache",
// "Bytecode cache is not used. Using a bytecode cache (APC, XCache, WinCache) is highly recommended for production environments" => "Bytecode cache is not used. Using a bytecode cache (APC, XCache, WinCache) is highly recommended for production environments",
// "Major slow down" => "Major slow down",
// "These are reported to slow down Tiki. If you have a high-volume site, you may want to deactivate them" => "These are reported to slow down Tiki. If you have a high-volume site, you may want to deactivate them",
// "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\">Search admin panel</a>" => "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\">Search admin panel</a>",
"To add/remove polls, look for \"Polls\" under \"Admin\" on the application menu, or" => "Para agregar/quitar votaciones, busque \"Votaciones\" bajo \"Admin\" en el menú de aplicación, o",
"Loading profile" => "Cargando el perfil",
"Are you sure you want to apply the profile" => "¿Seguro que quieres aplicar el perfil",
"Are you sure you want to re-apply the profile" => "¿Seguro que quieres re-aplicar el perfil",
"Sending" => "Enviando",
"Waiting" => "Esperando",
// "Tiki Configuration Profiles" => "Tiki Configuration Profiles",
"The following list of changes has been applied" => "La siguiente lista de cambios ha sido aplicada",
"Apply Profiles" => "Aplica Perfiles",
"Configure Tiki in 3 easy steps using Profiles" => "Configura Tiki en 3 pasos fáciles usando Perfiles",
// "A Friendly Warning" => "A Friendly Warning",
// "Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles" => "Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles",
"Profiles" => "Perfiles (de Configuración)",
// "Step 1: Use the Quick or Manual Filter option to see a list of Configuration Profiles you can apply" => "Step 1: Use the Quick or Manual Filter option to see a list of Configuration Profiles you can apply",
"Option 1: Quick Filter" => "Opción 1: Filtro rápido",
"Option 2: Manual Filter" => "Opción 2: Filtro manual",
"Featured Profiles is a list of applications that are maintained by the Tiki community and are a great way to get started" => "Los Perfiles Destacados son una lista de aplicaciones que son mantenidas por la comunidad de Tiki y que son una fantástica manera de ponese en marcha",
// "Full Profiles" => "Full Profiles",
// "Full Profiles are full featured out of the box solutions" => "Full Profiles are full featured out of the box solutions",
// "Mini Profiles" => "Mini Profiles",
// "Mini Profiles will configure specific features and are a great way to add more functionality to an existing configuration" => "Mini Profiles will configure specific features and are a great way to add more functionality to an existing configuration",
// "Learning Profiles" => "Learning Profiles",
// "Learning Profiles will allow you to quickly evaluate specific features in Tiki" => "Learning Profiles will allow you to quickly evaluate specific features in Tiki",
"Filter the list of profiles" => "Filtra la lista de perfiles",
// "Profile name" => "Profile name",
// "Profile types" => "Profile types",
// "Repository" => "Repository",
// "Step 2: Click on a Configuration Profile Name below to review it and to be able to apply it on your Web site" => "Step 2: Click on a Configuration Profile Name below to review it and to be able to apply it on your Web site",
// "Profile type" => "Profile type",
"applied" => "aplicado",
"Profile repository" => "Repositorio de Perfiles de configuración",
"Last update" => "Última actualización",
"Refresh" => "Refrescar",
// "JavaScript must be turned <strong>ON</strong> in order to apply Profiles. Please enable your JavaScript and try again" => "JavaScript must be turned <strong>ON</strong> in order to apply Profiles. Please enable your JavaScript and try again",
// "Export YAML" => "Export YAML",
"Modules" => "Módulos",
// "Export modified preferences as YAML" => "Export modified preferences as YAML",
// "Toggle Visible" => "Toggle Visible",
// "Show added preferences" => "Show added preferences",
// "no default" => "no default",
// "Repositories" => "Repositories",
// "Profile tester" => "Profile tester",
// "Paste or type wiki markup and YAML (with or without the {literal}{CODE}{/literal} tags) into the text area below" => "Paste or type wiki markup and YAML (with or without the {literal}{CODE}{/literal} tags) into the text area below",
// "This will run the profile and make potentially unrecoverable changes in your database" => "This will run the profile and make potentially unrecoverable changes in your database",
// "Test Profile Name" => "Test Profile Name",
// "Global configuration" => "Global configuration",
// "Cache duration" => "Cache duration",
"Create New" => "Crear nueva",
// "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use the <strong>Admin</strong> &gt; <strong>External Feeds</strong> menu option, or" => "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use the <strong>Admin</strong> &gt; <strong>External Feeds</strong> menu option, or",
// "External feeds" => "External feeds",
// "Feeds" => "Feeds",
// "Feed for articles" => "Feed for articles",
// "Feed for blogs" => "Feed for blogs",
// "Feed for individual blogs" => "Feed for individual blogs",
// "Feed for image galleries" => "Feed for image galleries",
// "Feed for individual image galleries" => "Feed for individual image galleries",
// "Feed for file galleries" => "Feed for file galleries",
// "Feed for individual file galleries" => "Feed for individual file galleries",
// "Feed for wiki pages (with diff)" => "Feed for wiki pages (with diff)",
// "Feed for wiki pages (no diff)" => "Feed for wiki pages (no diff)",
// "Feed for forums" => "Feed for forums",
// "Feed for individual forums" => "Feed for individual forums",
// "Feed for trackers" => "Feed for trackers",
// "Feed for calendars" => "Feed for calendars",
"Feed for directories" => "Feed para directorios",
// "Feed for shoutbox" => "Feed for shoutbox",
"You can see users rank by score in the module users_rank, for that go to" => "Puede ver calificación de usuarios por puntuación en el módulousers_rank, para eso vaya a ",
"Admin modules" => "Admin módulos",
"Expiration" => "Expiración",
// "{\$events[e].category}" => "{\$events[e].category}",
// "{\$events[e].description}" => "{\$events[e].description}",
// "can be seen on page" => "can be seen on page",
// "in Admin menu" => "in Admin menu",
// "Also see the Search Indexing tab here" => "Also see the Search Indexing tab here",
// "File Gallery admin panel" => "File Gallery admin panel",
// "Basic Search" => "Basic Search",
// "Advanced Search" => "Advanced Search",
// "Search Engine Settings" => "Search Engine Settings",
// "Index maintenance" => "Index maintenance",
// "Optimize" => "Optimize",
// "From the command line" => "From the command line",
// "Log rebuild" => "Log rebuild",
// "Log file is saved as temp/Search_Indexer.log" => "Log file is saved as temp/Search_Indexer.log",
// "Indexation" => "Indexation",
// "Queue size" => "Queue size",
"Process" => "Proceso",
// "Uses JavaScript to reload this page until queue is processed" => "Uses JavaScript to reload this page until queue is processed",
// "Forum searches" => "Forum searches",
// "Search Results" => "Search Results",
// "Select the items to display on the search results page" => "Select the items to display on the search results page",
// "Select the information to display for each result" => "Select the information to display for each result",
// "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Security'>Security page</a> on Tiki's developer site" => "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Security'>Security page</a> on Tiki's developer site",
// "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings" => "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings",
// "General Security" => "General Security",
// "Please also see" => "Please also see",
// "HTTPS (SSL) and other login preferences" => "HTTPS (SSL) and other login preferences",
// "CSRF Security" => "CSRF Security",
// "Use these options to protect against cross-site request forgeries (CSRF)" => "Use these options to protect against cross-site request forgeries (CSRF)",
// "Spam protection" => "Spam protection",
"Search results" => "Resultados de la búsqueda",
// "Tokens" => "Tokens",
// "To manage tokens go to <a href=\"tiki-admin_tokens.php\">Admin Tokens</a> page" => "To manage tokens go to <a href=\"tiki-admin_tokens.php\">Admin Tokens</a> page",
// "Clipperz online password management" => "Clipperz online password management",
// "Tiki doesn't offer a built-in password management feature" => "Tiki doesn't offer a built-in password management feature",
// "Learn more about Clipperz" => "Learn more about Clipperz",
// "Meta-tags" => "Meta-tags",
// "SEFURL requires the <strong>URL Rewrite module</strong> for IIS. You do not seem to have this module installed" => "SEFURL requires the <strong>URL Rewrite module</strong> for IIS. You do not seem to have this module installed",
// "Please see <a href=\"http://doc.tiki.org/Windows+Server+Install\">Windows Server Install</a> on tiki.org for more information" => "Please see <a href=\"http://doc.tiki.org/Windows+Server+Install\">Windows Server Install</a> on tiki.org for more information",
// "SEFURL will not work unless Tiki specific directives are deployed to the %0 file" => "SEFURL will not work unless Tiki specific directives are deployed to the %0 file",
// "To enable this file, simply copy the %0 file (located in the main directory of your Tiki installation) to %1" => "To enable this file, simply copy the %0 file (located in the main directory of your Tiki installation) to %1",
// "If you need to keep an existing (non Tiki) %0 file, just add Tiki directives to it" => "If you need to keep an existing (non Tiki) %0 file, just add Tiki directives to it",
// "When you upgrade Tiki (e.g. from version 7 to version 8), make sure to make use of the new URL rewriting configuration file" => "When you upgrade Tiki (e.g. from version 7 to version 8), make sure to make use of the new URL rewriting configuration file",
// "%0 file is missing" => "%0 file is missing",
// "Unable to verify that your URL rewriting configuration is up to date" => "Unable to verify that your URL rewriting configuration is up to date",
// "SEFURL may not work completely or correctly if Tiki URL rewriting configuration is not current" => "SEFURL may not work completely or correctly if Tiki URL rewriting configuration is not current",
// "%0 is not in the expected format" => "%0 is not in the expected format",
// "%0 may simply be outdated" => "%0 may simply be outdated",
// "To update this file, if it was not customized, copy the %0 file (located in the main directory of your Tiki installation) to %1, overwriting the latter" => "To update this file, if it was not customized, copy the %0 file (located in the main directory of your Tiki installation) to %1, overwriting the latter",
// "%0 file is out of date" => "%0 file is out of date",
// "The RewriteBase directive seems not to be set up correctly. This is required for sefurl to function correctly" => "The RewriteBase directive seems not to be set up correctly. This is required for sefurl to function correctly",
// "The current value in %0 is %1 but the base url for this site is %2" => "The current value in %0 is %1 but the base url for this site is %2",
// "List of Url Parameters that should go in the path" => "List of Url Parameters that should go in the path",
// "Known Types" => "Known Types",
// "Token" => "Token",
// "Invert" => "Invert",
// "Show Usage" => "Show Usage",
// "Delete &amp; Unreference" => "Delete &amp; Unreference",
// "Invert Relation" => "Invert Relation",
// "New Types" => "New Types",
// "Fix" => "Fix",
// "No occurences found" => "No occurences found",
// "If you don't want to limit it, an input box will be displayed; otherwise, it will be checkbox" => "If you don't want to limit it, an input box will be displayed; otherwise, it will be checkbox",
// "Twitter Settings" => "Twitter Settings",
// "To use Twitter integration, you must register this site as an application at" => "To use Twitter integration, you must register this site as an application at",
// "and allow write access for the application" => "and allow write access for the application",
// "Enter &lt;your site URL&gt;tiki-socialnetworks.php as callback URL" => "Enter &lt;your site URL&gt;tiki-socialnetworks.php as callback URL",
// "Facebook Settings" => "Facebook Settings",
// "To use Facebook integration, you must register this site as an application at" => "To use Facebook integration, you must register this site as an application at",
// "and allow extended access for the application" => "and allow extended access for the application",
// "Enter &lt;your site URL&gt;tiki-socialnetworks.php?request_facebook as Site URL and &lt;your site&gt; as Site Domain" => "Enter &lt;your site URL&gt;tiki-socialnetworks.php?request_facebook as Site URL and &lt;your site&gt; as Site Domain",
// "The following preferences affect what permissions the user is asked to allow Tiki to do by Facebook when authorizing it" => "The following preferences affect what permissions the user is asked to allow Tiki to do by Facebook when authorizing it",
// "bit.ly Settings" => "bit.ly Settings",
// "There is no need to set up a site-wide bit.ly account; every user can have his or her own, but this allows for site-wide statistics" => "There is no need to set up a site-wide bit.ly account; every user can have his or her own, but this allows for site-wide statistics",
// "Go to" => "Go to",
// "to sign up for an account" => "to sign up for an account",
// "to retrieve the API key" => "to retrieve the API key",
// "Text area (that apply throughout many features)" => "Text area (that apply throughout many features)",
"Wiki syntax" => "Sintaxis wiki",
// "Default size" => "Default size",
// "External links and images" => "External links and images",
// "External links will be identified with" => "External links will be identified with",
// "About plugins" => "About plugins",
// "Tiki plugins add functionality to wiki pages, articles, blogs, and so on. You can enable and disable them below" => "Tiki plugins add functionality to wiki pages, articles, blogs, and so on. You can enable and disable them below",
// "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>" => "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>",
// "The edit-plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below" => "The edit-plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below",
// "Check disabled plugins used in wiki pages" => "Check disabled plugins used in wiki pages",
// "Disabled used plugins" => "Disabled used plugins",
// "Plugin preferences" => "Plugin preferences",
// "Edit plugin icons" => "Edit plugin icons",
// "Disable edit plugin icon (make plugin inline)" => "Disable edit plugin icon (make plugin inline)",
// "Plugin Aliases" => "Plugin Aliases",
// "About plugin aliases" => "About plugin aliases",
// "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}" => "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}",
// "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}" => "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}",
// "Available Alias" => "Available Alias",
// "Enable Plugins" => "Enable Plugins",
// "Delete Plugins" => "Delete Plugins",
// "Click on the plugin name to edit it" => "Click on the plugin name to edit it",
// "Click on the + icon to add a new one" => "Click on the + icon to add a new one",
// "General Information" => "General Information",
// "Plugin Name" => "Plugin Name",
// "Base Plugin" => "Base Plugin",
"Name:" => "Nombre:",
"Description:" => "Descripción:",
// "Body Label" => "Body Label",
// "Dependencies" => "Dependencies",
// "Inline (No Plugin Edit UI)" => "Inline (No Plugin Edit UI)",
// "Simple Plugin Arguments" => "Simple Plugin Arguments",
// "Argument" => "Argument",
// "New Argument" => "New Argument",
// "Plugin Parameter Documentation" => "Plugin Parameter Documentation",
"Required" => "Requerido",
// "Safe" => "Safe",
// "Plugin Body" => "Plugin Body",
// "Ignore User Input" => "Ignore User Input",
// "Default Content" => "Default Content",
// "Encoding" => "Encoding",
// "Argument Source (if different)" => "Argument Source (if different)",
// "Default Value" => "Default Value",
// "Composed Plugin Arguments" => "Composed Plugin Arguments",
// "Pattern" => "Pattern",
// "To configure your trackers, select \"Trackers\" in the application menu, or" => "To configure your trackers, select \"Trackers\" in the application menu, or",
"Tracker settings" => "Parámetros de Formulario-bd",
"Tracker attachment preferences" => "Preferencias de adjuntos a Formulario-bd",
"Use database to store files" => "Usar base de datos para guardar archivos",
"Use a directory to store files" => "Usar un directorio para almacenar archivos",
// "Field Types" => "Field Types",
"Tracker attachments" => "Adjuntos de Formulario-bd",
"dls" => "bjds",
// "Switch storage" => "Switch storage",
"Change all to db" => "Cambiar todo a bd",
"Change all to file" => "Cambiar todo a archivos",
"Use database to store userfiles" => "Usar base de datos para guardar archivos de usuario",
"Use a directory to store userfiles" => "Usar directorio para guardar archivos de usuario",
// "Kaltura" => "Kaltura",
// "Kaltura Registration" => "Kaltura Registration",
// "To get a Kaltura Partner ID" => "To get a Kaltura Partner ID",
// "Setup your own instance of Kaltura Community Edition (CE)" => "Setup your own instance of Kaltura Community Edition (CE)",
// "get an account via Kaltura.com" => "get an account via Kaltura.com",
// "List Media Entries" => "List Media Entries",
// "List Remix Entries" => "List Remix Entries",
// "Add New Media" => "Add New Media",
// "Kaltura / Tiki config" => "Kaltura / Tiki config",
// "Kaltura Partner Settings" => "Kaltura Partner Settings",
// "Kaltura Dynamic Player" => "Kaltura Dynamic Player",
// "Kaltura Contribution Wizard" => "Kaltura Contribution Wizard",
// "Kaltura Remix Editors" => "Kaltura Remix Editors",
// "Ustream Watershed" => "Ustream Watershed",
// "Ustream Watershed Registration" => "Ustream Watershed Registration",
// "If you don't have a Watershed account, " => "If you don't have a Watershed account, ",
// "you can find out more about it here" => "you can find out more about it here",
// "Configuration within Watershed" => "Configuration within Watershed",
// "Set the webservice to point to tiki-watershed_service.php on your site, and turn on Authentication Lock" => "Set the webservice to point to tiki-watershed_service.php on your site, and turn on Authentication Lock",
// "Watershed Wiki plugins" => "Watershed Wiki plugins",
// "Use Wiki plugins WatershedBroadcaster, WatershedViewer and WatershedChat to embed your broadcaster, viewer or chat" => "Use Wiki plugins WatershedBroadcaster, WatershedViewer and WatershedChat to embed your broadcaster, viewer or chat",
// "Basic tracker settings" => "Basic tracker settings",
// "Information for each channel is stored in a tracker. Tracker item view/modify permissions will determine which channels users will be able to view or broadcast to respectively. You can find the Brand Id and Channel Code from the embed codes provided by Watershed, looking for the cid variable which will be \"brandId%2Fchannelcode\"" => "Information for each channel is stored in a tracker. Tracker item view/modify permissions will determine which channels users will be able to view or broadcast to respectively. You can find the Brand Id and Channel Code from the embed codes provided by Watershed, looking for the cid variable which will be \"brandId%2Fchannelcode\"",
// "Archive settings" => "Archive settings",
// "Information on archived clips are stored in a tracker. Tracker item view permissions will determine which archives users will be able to view. Note that recordings set to private in the broadcaster are not added to Tiki. Also, there is a delay for information to be received which could be quite long (30 min)" => "Information on archived clips are stored in a tracker. Tracker item view permissions will determine which archives users will be able to view. Note that recordings set to private in the broadcaster are not added to Tiki. Also, there is a delay for information to be received which could be quite long (30 min)",
// "Archive settings (optional)" => "Archive settings (optional)",
// "Flash Media Encoder" => "Flash Media Encoder",
// "This is only needed if you are using Flash Media Encoder for higher-quality broadcasting which support only shared secret authentication" => "This is only needed if you are using Flash Media Encoder for higher-quality broadcasting which support only shared secret authentication",
// "Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used" => "Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used",
"URL:" => "URL:",
// "Parameters (%name%)" => "Parameters (%name%)",
"Operation" => "Operación",
// "Lookup" => "Lookup",
// "{\$url} requires no parameter" => "{\$url} requires no parameter",
// "Test Input" => "Test Input",
// "Response Information" => "Response Information",
// "OIntegrate Version" => "OIntegrate Version",
// "Not supported" => "Not supported",
// "Schema Version" => "Schema Version",
// "Schema Documentation" => "Schema Documentation",
"Cache" => "Cache",
// "Not specified, default used" => "Not specified, default used",
// "Content Type" => "Content Type",
// "Not specified" => "Not specified",
// "Returned Data" => "Returned Data",
// "Proposed Templates" => "Proposed Templates",
// "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters" => "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters",
// "Register Service" => "Register Service",
// "Registered Templates" => "Registered Templates",
// "Engine" => "Engine",
// "Output" => "Output",
// "Register Template" => "Register Template",
// "The following pages were modified" => "The following pages were modified",
// "Nothing was changed (no images in wiki_up were found in Wiki pages)" => "Nothing was changed (no images in wiki_up were found in Wiki pages)",
// "Use the 'Quick Edit' module to easily create or edit wiki pages" => "Use the 'Quick Edit' module to easily create or edit wiki pages",
// "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules" => "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules",
// "Page display" => "Page display",
// "Page version" => "Page version",
"List authors" => "Listar autores",
// "Allow override per page" => "Allow override per page",
// "Minor edits do not flag new content for translation and do not send watch notifications (unless \"Watch minor edits\" is enabled)" => "Minor edits do not flag new content for translation and do not send watch notifications (unless \"Watch minor edits\" is enabled)",
// "Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled" => "Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled",
// "If you change storage, it is better to move all the files for easy backup.." => "If you change storage, it is better to move all the files for easy backup..",
// "Tag for current wiki" => "Tag for current wiki",
// "Restore wiki to tag" => "Restore wiki to tag",
// "Restore" => "Restore",
// "Remove a tag" => "Remove a tag",
"Generate dump" => "Generar volcado",
"Download last dump" => "Descargar último volcado",
"Remove unused pictures" => "Quitar imágenes no usadas",
// "Move images from wiki_up to the home file gallery" => "Move images from wiki_up to the home file gallery",
// "If you use these buttons please make sure to have a backup of the database and the directory wiki_up" => "If you use these buttons please make sure to have a backup of the database and the directory wiki_up",
"Export Wiki Pages" => "Exportar páginas wiki",
// "Wiki watch" => "Wiki watch",
// "Flagged Revision" => "Flagged Revision",
// "Page Listings" => "Page Listings",
// "Configuration" => "Configuration",
// "Select which items to display when listing pages" => "Select which items to display when listing pages",
"Wiki 3D Browser Configuration" => "Configuración del Navegador Wiki 3D ",
// "Tools" => "Tools",
// "Mass search and replace" => "Mass search and replace",
"Wiki attachments" => "Adjuntos al Wiki",
"Change" => "Cambiar",
// "WYSIWYG means What You See Is What You Get, and is handled in Tiki by <a href=\"http://ckeditor.com/\">CKEditor</a>" => "WYSIWYG means What You See Is What You Get, and is handled in Tiki by <a href=\"http://ckeditor.com/\">CKEditor</a>",
// "Page links" => "Page links",
// "Note that if the SEFURL feature is on, page links created using wysiwyg might not be automatically updated when pages are renamed. This is planned to be addressed through the future \"Use Wiki syntax in WYSIWYG\" feature" => "Note that if the SEFURL feature is on, page links created using wysiwyg might not be automatically updated when pages are renamed. This is planned to be addressed through the future \"Use Wiki syntax in WYSIWYG\" feature",
// "Wysiwyg Editor Features" => "Wysiwyg Editor Features",
// "Related features" => "Related features",
// "{\$sect|capitalize}" => "{\$sect|capitalize}",
"Position" => "Posición",
// "Topbar" => "Topbar",
// "Page Top" => "Page Top",
// "Page Bottom" => "Page Bottom",
"Cache Time" => "Tiempo en cache",
"secs" => "segs",
// "Use Ctrl+Click to select multiple options" => "Use Ctrl+Click to select multiple options",
// "The" => "The",
// "Display Modules to All Groups" => "Display Modules to All Groups",
// "setting will override your selection of specific groups" => "setting will override your selection of specific groups",
"Visibility" => "Visibilidad",
"Displayed now for all eligible users even with personal assigned modules" => "Mostrado para todos los usuarios elegibles aún con módulos personales asignados",
"Displayed for the eligible users with no personal assigned modules" => "Mostrado para los usuarios elegibles sin módulos personales asignados",
"Displayed now, can't be unassigned" => "Mostrado ahora, no puede ser desasignado",
"Not displayed until a user chooses it" => "No mostrado hasta que el usuario lo elije",
// "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either" => "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either",
// "to make sure users will notice any newly assigned modules" => "to make sure users will notice any newly assigned modules",
"required" => "requerido",
// "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y" => "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y",
// "Enter the parameters in URL format, e.g. 'nobox=y&class=rbox-data'" => "Enter the parameters in URL format, e.g. 'nobox=y&class=rbox-data'",
// "Edit custom module" => "Edit custom module",
// "Non Advanced Search or Natural Search" => "Non Advanced Search or Natural Search",
// "The documents are returned sorted on relevance depending on order, proximity, frequency of terms. " => "The documents are returned sorted on relevance depending on order, proximity, frequency of terms. ",
// "Advanced Search or Boolean Search" => "Advanced Search or Boolean Search",
// "Default search behavior" => "Default search behavior",
// "By default, all search terms are <em>optional</em>" => "By default, all search terms are <em>optional</em>",
// "It behaves like an OR logic" => "It behaves like an OR logic",
// "Objects that contain the more terms are rated higher in the results and will appear first in their type" => "Objects that contain the more terms are rated higher in the results and will appear first in their type",
// "For example, <strong>wiki forum</strong> will find" => "For example, <strong>wiki forum</strong> will find",
// "objects that include both terms" => "objects that include both terms",
// "objects that include the term <strong>wiki</strong>" => "objects that include the term <strong>wiki</strong>",
// "objects that include the term <strong>forum</strong>" => "objects that include the term <strong>forum</strong>",
// "Requiring terms" => "Requiring terms",
// "Add a plus sign ( + ) before a term to indicate that the term <em>must</em> appear in results" => "Add a plus sign ( + ) before a term to indicate that the term <em>must</em> appear in results",
// "Example: <strong>+wiki forum</strong> will find objects containing at least <strong>wiki</strong>. Objects with both terms and many occurences of the terms will appear first" => "Example: <strong>+wiki forum</strong> will find objects containing at least <strong>wiki</strong>. Objects with both terms and many occurences of the terms will appear first",
// "Excluding terms" => "Excluding terms",
// "Add a minus sign ( - ) before a term to indicate that the term <em>must not</em> appear in the results" => "Add a minus sign ( - ) before a term to indicate that the term <em>must not</em> appear in the results",
// "To reduce a term's value without completely excluding it, <a href=\"#reducing\" title=\"{tr}Reducing a term's value" => "To reduce a term's value without completely excluding it, <a href=\"#reducing\" title=\"{tr}Reducing a term's value",
// "Example: <strong>-wiki forum</strong> will find objects that do not contain <strong>wiki</strong> but contain <strong>forum</strong>" => "Example: <strong>-wiki forum</strong> will find objects that do not contain <strong>wiki</strong> but contain <strong>forum</strong>",
// "Grouping terms" => "Grouping terms",
// "Use parenthesis ( ) to group terms into subexpressions" => "Use parenthesis ( ) to group terms into subexpressions",
// "Example: <strong>+wiki +(forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order" => "Example: <strong>+wiki +(forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order",
// "Finding phrases" => "Finding phrases",
// "Use double quotes ( \" \" ) around a phrase to find terms in the exact order, exactly as typed" => "Use double quotes ( \" \" ) around a phrase to find terms in the exact order, exactly as typed",
// "Example: <strong>\"Alex Bell\"</strong> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong>. " => "Example: <strong>\"Alex Bell\"</strong> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong>. ",
// "Using wildcards" => "Using wildcards",
// "Add an asterisk ( * ) after a term to find objects that include the root word" => "Add an asterisk ( * ) after a term to find objects that include the root word",
// "For example, <strong>run*</strong> will find" => "For example, <strong>run*</strong> will find",
// "objects that include the term <strong>run</strong>" => "objects that include the term <strong>run</strong>",
// "objects that include the term <strong>runner</strong>" => "objects that include the term <strong>runner</strong>",
// "objects that include the term <strong>running</strong>" => "objects that include the term <strong>running</strong>",
// "Reducing a term's value" => "Reducing a term's value",
// "Add a tilde ( ~ ) before a term to reduce its value indicate to the ranking of the results" => "Add a tilde ( ~ ) before a term to reduce its value indicate to the ranking of the results",
// "Objects that contain the term will appear lower than other objects (unlike the <a href=\"#excluding\" title=\"{tr}Excluding terms" => "Objects that contain the term will appear lower than other objects (unlike the <a href=\"#excluding\" title=\"{tr}Excluding terms",
// "Example: <strong>+wiki ~forum</strong> will rate an object with only <strong>wiki</strong> higher that an object with <strong>wiki</strong> and  <strong>forum</strong>" => "Example: <strong>+wiki ~forum</strong> will rate an object with only <strong>wiki</strong> higher that an object with <strong>wiki</strong> and  <strong>forum</strong>",
// "Changing relevance value" => "Changing relevance value",
// "Add a less than ( &lt; ) or greater than ( &gt; ) sign before a term to change the term's contribution to the overall relevance value assigned to a object" => "Add a less than ( &lt; ) or greater than ( &gt; ) sign before a term to change the term's contribution to the overall relevance value assigned to a object",
// "Example: <strong>+wiki +(&gt;forum &lt; blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or <strong>wiki</strong> and <strong>blog</strong> in any order. <strong>wiki forum</strong> will be rated higher" => "Example: <strong>+wiki +(&gt;forum &lt; blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or <strong>wiki</strong> and <strong>blog</strong> in any order. <strong>wiki forum</strong> will be rated higher",
"Anti-Bot verification code image" => "Imagen del código de verificación Anti-Robots",
"Enter the code you see above" => "Introduce el código que ves arriba",
"Try another code" => "Prueba otro código",
"Expires At" => "Caduca en",
// "star" => "star",
// "half star" => "half star",
// "{\$topicName}" => "{\$topicName}",
"List all articles of this same topic" => "Lista todos los artículos con el mismo tema",
// "{\$topicName|escape}" => "{\$topicName|escape}",
// "{\$topics[\$topicId].name|escape}" => "{\$topics[\$topicId].name|escape}",
"You do not have permission to read complete articles" => "No tienes permiso para leer los artículos enteros",
"First page" => "Primer página",
"Previous page" => "Página anterior",
"page" => "página",
"Next page" => "Siguiente página",
"Last page" => "Última página",
"Related content" => "Contenido relacionado",
"bytes" => "bytes",
"Share page" => "Comparte esta página",
"Share This" => "Comparte Esto",
// "ShareThis via AIM, social bookmarking and networking sites, etc" => "ShareThis via AIM, social bookmarking and networking sites, etc",
"Send a link" => "Enviar enlace",
"List of attached files" => "Lista de archivos adjuntos",
"desc" => "descripción",
"uploaded" => "subida",
"Upload file" => "Subir archivo",
"Comment:" => "Comentario:",
"Attach" => "Adjuntar",
"Attach a file to this item" => "Adjuntar archivo al item",
// "{\$attfields[ix]}" => "{\$attfields[ix]}",
"more info" => "más info",
"No attachments for this item" => "No hay archivos adjuntos",
"debug" => "depurar",
"Fatal error" => "Error fatal",
"Save to notepad" => "Salvar a bloc de notas",
"Published " => "Publicado ",
"on" => "en",
"Previous post" => "Publicación previa",
"Next post" => "Publicación siguiente",
"Read more" => "Leer más",
"More.." => "Más..",
"pages" => "páginas",
"Permalink" => "Enlace permanente (Permalink)",
"Leave a comment" => "Deja un comentario",
"%0 comment" => "%0 comentario",
"%0 comments" => "%0 comentarios",
"Parent Gallery" => "Galería Madre",
"Properties" => "Propiedades",
"Click Here to Insert in Wiki Syntax" => "Haz click aquí para Insertar en Sintaxis Wiki",
"No records found" => "No se encontraron registros",
"Select Categories" => "Selecciona categorías",
"Admin Categories" => "Admin categorías",
"Select/deselect all categories" => "Selecciona/deselecciona todas las categorías",
"No categories defined" => "No se definieron categorías",
"Browse Category" => "Navega por la categoría",
// "Are you sure you want to archive this comment" => "Are you sure you want to archive this comment",
// "Are you sure you want to unarchive this comment" => "Are you sure you want to unarchive this comment",
// "Return" => "Return",
"Title:" => "Título:",
// "Do you really want to lock comments" => "Do you really want to lock comments",
"Lock" => "Desbloquear",
// "Do you really want to unlock comments" => "Do you really want to unlock comments",
"Unlock" => "Desbloquear",
// "Are you sure you want to remove this comment" => "Are you sure you want to remove this comment",
// "Unarchive" => "Unarchive",
// "Are you sure you want to approve this comment" => "Are you sure you want to approve this comment",
"Approve" => "Aprobar",
// "Are you sure you want to reject this comment" => "Are you sure you want to reject this comment",
"Reject" => "Rechazar",
"Comment posted by %0 on %1" => "Comentario publicado por %0 en %1",
"Reply" => "Responder",
"No comments" => "Sin comentarios",
"There are no comments at this time" => "No hay comentarios por ahora",
"Post new comment" => "Escribir un comentario",
"Add Comment" => "Añadir un comentario",
// "Are you sure you want to lock comments on this object" => "Are you sure you want to lock comments on this object",
"Your comment was posted" => "Se ha publicado tu comentario",
"Identity" => "Identidad",
// "You are currently registered on this site. This section is <strong>optional</strong>. By filling it, you will not link this post to your account and preserve your anonymity" => "You are currently registered on this site. This section is <strong>optional</strong>. By filling it, you will not link this post to your account and preserve your anonymity",
"Pseudonym" => "Pseudónimo",
"Email:" => "Correo-e:",
"Website" => "Sitio web",
// "Are you sure you want to unlock comments on this object" => "Are you sure you want to unlock comments on this object",
"Posted by" => "Publicado por",
"posts:" => "mensajes:",
"stars" => "estrellas",
"User Level" => "Nivel de usuario",
"private message" => "mensaje privado",
"Send eMail to User" => "Enviar correo a usuario",
"user online" => "usuario en línea",
"user offline" => "usuario fuera de línea",
"top of page" => "inicio de la página",
"Report this post" => "Avisa de esta publicación",
"Monitor this Topic" => "Monitorizar este tema",
"Stop Monitoring this Topic" => "Dejar de monitorizar este tema",
"Group Monitor" => "Subscribe a un grupo a seguir esta página por correo-e",
"Watched by categories" => "Seguido a través de las categorías",
"Moderator actions" => "Acciones de moderador",
"reported:" => "reportado:",
"queued:" => "en cola:",
"Move to topic:" => "Mover al tema:",
"Delete Selected" => "Borrar seleccionados",
"Threshold" => "Puntuación mínima",
"Replies" => "Respuestas",
"below your current threshold" => "por debajo de su umbral actual",
"New Reply" => "Nueva respuesta",
"Editing reply" => "Editar respuesta",
"Reply to the selected post" => "Responder al mensaje elegido",
"Post new message" => "Publica un mensaje nuevo",
"If you would like to be notified when someone replies to this topic<br />please tell us your e-mail address" => "Si quieres ser notificado/a cuando alguien responda a este tema<br />ppor favor indica tu dirección de correo-e",
"Send me an e-mail when someone replies" => "Envíame un mensaje de correo-e cuando alguien responda",
"Maximum size" => "Tamaño máximo",
"Reply to parent post" => "Responder al mensaje padre",
"Post new reply" => "Escribir nueva respuesta",
"Post as Anonymous" => "Publica como anónimo",
"Please note that the preview does not keep the attached file which you will have to choose before posting" => "Por favor, ten en cuenta que la previsualización no guarda el archivo adjunto que tendrás que volver a seleeccionar antes de publicar definitivamente",
"Posting replies" => "Escribir respuestas",
"Please enter a title" => "Por favor, introduce in título",
"1 comment" => "1 comentario",
"Go back" => "Atrás",
"Return to home page" => "Volver al inicio",
"Type of contribution" => "Tipo de contribución",
"Copyrights" => "Copyrights",
"Year:" => "Año:",
"Authors:" => "Autores:",
// "System error" => "System error",
// "Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue" => "Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue",
// "If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation" => "If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation",
// "The query was" => "The query was",
// "The built query was likely" => "The built query was likely",
// "Stacktrace" => "Stacktrace",
// "Tiki is unable to connect to the database" => "Tiki is unable to connect to the database",
// "An error occurred while performing the request" => "An error occurred while performing the request",
"Current URL" => "URL actual",
"Command" => "Comando",
"exec" => "ejecutar",
"Type <code>help</code> to get list of available commands" => "Ponga <code>help</code> para obtener la lista de comandos disponibles",
"Syntax" => "Sintaxis",
"Page generation debugging log" => "Registro de depuración de generación de página",
"Features state" => "Estado de funcionalidades",
"Total" => "Total",
"features matched" => "funcionalidades coincidentes",
"Watchlist" => "Watchlist",
// "Duplicate File Gallery" => "Duplicate File Gallery",
"File gallery" => "Galería de archivos",
// "Duplicate categories" => "Duplicate categories",
// "Duplicate permissions" => "Duplicate permissions",
// "Duplicate" => "Duplicate",
"There are individual permissions set for this file gallery" => "Hay permisos individuales configurados para esta galería de archivos",
// "View inserted gallery" => "View inserted gallery",
// "{\$gal_info.name}" => "{\$gal_info.name}",
// "System" => "System",
// "Other (%0)" => "Other (%0)",
// "Any file" => "Any file",
// "Podcast (audio)" => "Podcast (audio)",
// "Podcast (video)" => "Podcast (video)",
// "Gallery is visible to non-admin users" => "Gallery is visible to non-admin users",
// "Gallery is public" => "Gallery is public",
// "Any user with permission (not only the gallery owner) can upload files" => "Any user with permission (not only the gallery owner) can upload files",
// "Perms of the backlinks are checked to view a file" => "Perms of the backlinks are checked to view a file",
// "Files can be locked at download" => "Files can be locked at download",
// "Maximum number of archives for each file" => "Maximum number of archives for each file",
"Use" => "Use",
"unlimited" => "ilimitado",
"Parent gallery" => "Galería superior",
// "Owner of the gallery" => "Owner of the gallery",
"Max:" => "Máx:",
// "Min" => "Min",
// "Group of users alerted when file gallery is modified" => "Group of users alerted when file gallery is modified",
// "Allows to select each user for small groups" => "Allows to select each user for small groups",
// "Maximum width for images in gallery" => "Maximum width for images in gallery",
// "If an image is wider than this, it will be resized" => "If an image is wider than this, it will be resized",
// "Attention: In this case, the original image will be lost" => "Attention: In this case, the original image will be lost",
// "Maximum height for images in gallery" => "Maximum height for images in gallery",
// "If an image is higher than this, it will be resized" => "If an image is higher than this, it will be resized",
// "Wiki markup to enter when image selected from \"file gallery manager\"" => "Wiki markup to enter when image selected from \"file gallery manager\"",
// "The default is " => "The default is ",
// "Field names will be replaced when enclosed in % chars. e.g. %fileId%, %name%, %filename%, %description%" => "Field names will be replaced when enclosed in % chars. e.g. %fileId%, %name%, %filename%, %description%",
// "Display Properties" => "Display Properties",
"Max description display size" => "Tamaño máximo de descripción",
// "Max rows per page" => "Max rows per page",
// "Select which items to display when listing galleries" => "Select which items to display when listing galleries",
// "File error" => "File error",
"Perhaps you are looking for" => "Quizás estabas buscando",
"There are no wiki pages similar to '{\$page|escape}'" => "No hay páginas Wiki similares a '{\$page|escape}'",
// "Token Error" => "Token Error",
"Go to Log in Page" => "Ves a la página de Conexión",
"Change them here" => "Cámbialos aquí",
"Create this page" => "Crear ésta página",
"(page will be orphaned)" => "(la página quedará huérfana)",
"Close Window" => "Cerrar Ventana",
// "Attached files" => "Attached files",
// "Private Gallery" => "Private Gallery",
"Active Perms" => "Perms activos",
"Perms" => "Perms",
// "Open as WebFolder" => "Open as WebFolder",
"Edit: " => "Edítalo/a: ",
"Download current version" => "Descarga la versión actual",
"Archives" => "Histórico de versiones del archivo",
"Upload New Version" => "Sube una nueva versión",
"Replace your draft" => "Reemplaza tu borrador",
"Upload your draft" => "Sube un nuevo borrador",
"Validate your draft" => "Valida tu borrador",
"Delete your draft" => "Elimina tu borrador",
"Download and lock" => "Descarga y bloquea",
"Open your draft in WebDAV" => "Abre tu borrador en WebDAV",
"Open in WebDAV" => "Abre en WebDAV",
"Share a link to this file" => "Comparte un enlace a este archivo",
"Email a link to this file" => "Envía por correo un enlace a este archivo",
// "Enter the ID of any file in any gallery to be used as the icon for this gallery in browse view" => "Enter the ID of any file in any gallery to be used as the icon for this gallery in browse view",
// "The checkbox is disabled because this preference is disabled globally" => "The checkbox is disabled because this preference is disabled globally",
// "Please, enable the preference globally first" => "Please, enable the preference globally first",
// "You can ask your site Admin to enable the preference" => "You can ask your site Admin to enable the preference",
"Name-filename" => "Nombre-Nombre de archivo",
"Filename only" => "Sólo nombre de archivo",
// "Show as a column" => "Show as a column",
// "Show in popup box" => "Show in popup box",
// "Show an icon in a column" => "Show an icon in a column",
// "Upload from URL" => "Upload from URL",
"File added" => "Archivo añadido",
// "{\$file_backlinks_title}" => "{\$file_backlinks_title}",
"Start the Slideshow" => "Empieza el Pase de diapositivas",
"Pause the Slideshow" => "Pausa el Pase de diapositivas",
"There are no images to display" => "No hay imágenes que mostrar",
"Search Help" => "Ayuda de la búsqueda",
"Any" => "Cualquiera",
"Deep search" => "Busca a fondo",
"Tags" => "Marcas",
"Select Tags" => "Selecciona Marcas",
"Include objects without a specified language" => "Incluye objetos sin un lenguaje especificado",
"Add to filter" => "Añade al filtro",
// "{\$whatlabel}" => "{\$whatlabel}",
"Find in" => "Encuentra en",
"Exact match" => "Correspondencia exacta",
"and all the sub-objects" => "y todos los subobjetos",
"any type" => "de cualquier tipo",
"any topic" => "con cualquier tema",
"any language" => "en cualquier idioma",
"not in" => "no en",
"any category" => "cualquier categoría",
"Multiple select" => "Seleción Múltiple",
"in:" => "en:",
// "{\$value}" => "{\$value}",
// "{\$duration.label}" => "{\$duration.label}",
"Orphans" => "Huérfanos/as",
// "{\$find_other}" => "{\$find_other}",
"Number of displayed rows" => "Número de filas mostradas",
"Clear Filter" => "Limpia el filtro",
// "Map View" => "Map View",
"Show php error messages" => "Muestra los mensajes de errores php",
"Folksonomy Tags" => "Marcas de folcsonomía",
"Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes" => "Pon las marcas separadas por espacios. Si quieres poner marcas de más de una palabra, pon las palabras juntas sin espacios o bien ponlo con espacios si quieres pero rodeado de dobles comillas",
"Folksonomy Language" => "Idioma de folcsonomía",
"Untag" => "Desmarca",
// "Translate tags" => "Translate tags",
"Images Galleries" => "Galerías de imágenes",
"Edit this page" => "Editar esta página",
"RSS Wiki" => "RSS de Wiki",
"RSS Blogs" => "RSS de Blogs",
"RSS Articles" => "RSS de Artículos",
"RSS Image Galleries" => "RSS de Galerías de Imágenes",
"RSS File Galleries" => "RSS de Galerías de Archivos",
"RSS Forums" => "RSS del Foro",
"RSS Maps" => "RSS de Mapas",
"RSS Directories" => "RSS de Directorios",
"RSS Calendars" => "RSS de Calendarios",
"RSS Tracker" => "RSS del Formulario-bd",
// "Interactive Translation" => "Interactive Translation",
// "Once checked, click on any string to translate it" => "Once checked, click on any string to translate it",
// "Couldn't find any translatable string" => "Couldn't find any translatable string",
// "Save translations" => "Save translations",
// "Changes will be applied on next page load only" => "Changes will be applied on next page load only",
"Show Tree" => "Muestra el árbol",
"Hide Tree" => "Oculta el árbol",
"Perform action with checked:" => "Ejecutar acción con los marcados:",
"Move Selected Files" => "Mover archivos seleccionados",
"Are you sure you want to delete the selected files" => "¿Estás seguro de que quieres borrar los siguientes archivos",
// "Are you sure you want to reset the default gallery list table settings" => "Are you sure you want to reset the default gallery list table settings",
// "Reset to default gallery list table settings" => "Reset to default gallery list table settings",
// "Download the zip" => "Download the zip",
// "Assign permissions to file galleries" => "Assign permissions to file galleries",
"Move to" => "Mover a",
// "Other Sorts" => "Other Sorts",
// "No Additional Sort" => "No Additional Sort",
"No information" => "Sin información",
"Hi {\$mail_user|username} has sent you this link" => "Hola, {\$mail_user|username} te ha enviado este enlace",
"Blog post:" => "Publicación en Blog:",
"at:" => "en:",
// "Gift Certificate Information" => "Gift Certificate Information",
// "Percentage Discount" => "Percentage Discount",
// "Value of Gift Certificate" => "Value of Gift Certificate",
// "Redeem Code" => "Redeem Code",
// "Your Gift Certificate Purchase" => "Your Gift Certificate Purchase",
// "Your cart order has been received. Please note that orders are not finalized until payment has been made" => "Your cart order has been received. Please note that orders are not finalized until payment has been made",
// "You can review your order at" => "You can review your order at",
// "Your cart order" => "Your cart order",
"Somebody or you tried to subscribe this email address at our site:" => "Alguien o usted intentaron suscribir esta dirección de correo en nuestro sitio:",
"To the newsletter:" => "Al boletín:",
"In order to confirm your subscription you must access the following URL:" => "Para confirmar su suscripción debe acceder a la siguiente URL:",
"To validate your account and login to the site, please click on the following link" => "Para validar su suscripción y conectarse al sitio, haga clic por favor en el siguiente enlace",
"The administrator approved your account" => "Las personas administradoras han aprobado su cuenta",
"Confirm your email at %s" => "Confirme su correo-e en %s",
// "Remove file" => "Remove file",
// "GalleryId" => "GalleryId",
// "Identifier" => "Identifier",
"User:" => "Usuario:",
"A new message was posted to forum" => "Un nuevo mensaje en el foro",
"New topic:" => "Nuevo tema:",
// "An anonymous user" => "An anonymous user",
"has posted a reply to a thread you're watching. \nYou can view the thread and reply at the following URL" => "ha publicado una respuesta a un hilo de discusión que estás siguiendo por correo-e. \nPuedes ver el hilo y responder en la siguiente URL",
// "You are invited by" => "You are invited by",
// "You join this group" => "You join this group",
// "Join me on %s" => "Join me on %s",
"You sent a request with the subject:" => "Envió un pedido con el tema:",
"Use the subject to indicate the operation to apply:" => "Use el tema para indicar la operación a usar:",
"GET:WikiName to get a wiki page" => "GET:WikiName para obtener una página wiki page",
"PUT:WikiName to update/create a wiki page (use the body for the page data)" => "PUT:WikiName para actualizar/crear una página wiki (use el cuerpo para el contenido de la página",
"APPEND:WikiName to append data to a Wiki page (use the body for the data to add)" => "APPEND:WikiName para agregar datos a una página Wiki (use el cuerpo para el contenido a agregar",
"PREPEND:WikiName to append the data at the top" => "PREPEND:WikiName a agregar contenido al principio",
"Tiki mail-in instructions" => "Instrucciones del mail-in de Tiki",
"Tiki mail-in auto-reply." => "Tiki mail-in auto-respuesta.",
"Page not found:" => "Página no encontrada:",
"A new message was posted to you at {\$mail_machine}" => "Un nuevo mensaje te fue enviado en {\$mail_machine}",
"New message arrived from %s" => "Nuevo mensaje recibido desde %s",
"Hi" => "Hola",
"Your account registration request for {\$mail_site} was validated by the site admin and your account is active now" => "La petición de registro de nueva cuenta de usuario/a en {\$mail_site} ha sido validada per una persona administradora de este sitio web y ahora tu cuenta ya está activa",
"To login with your username and password, please follow this link" => "Para conectarte con tu nombre de usuario/a y contraseña, sigue este enlace por favor",
"Enjoy the site!" => "¡Disfrute el sitio!",
"User Account Activated" => "Cuenta de Usuario/a Activada",
"{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first" => "{\$mail_user} <{\$mail_email}> ha pedido una nueva contraseña en {\$mail_site}, pero primero necesita que le valides su cuenta",
"has requested an account on" => "ha pedido una cuenta en",
"User Tracker" => "Formulario-bd del Usuario",
"To validate that account, please follow the link:" => "Para validar esa cuenta, siga el enlace:",
"Assign to a group" => "Asignar a algun grupo",
"View user's data" => "Ver los datos del usuario/a",
"Best regards" => "Saludos",
"User Registration Request" => "Petición de Registro de Usuario/a",
"Go to your friendship network to accept or refuse this request" => "Ve a tu red de amistad para aceptar o rechazar esta petición",
"You're invited to join my network of friends!" => "¡Está invitado a unirse a mi círculo de amigos!",
"The user" => "El usuario",
"registered at your site" => "se registró en su sitio",
"New user registration" => "Registro de nuevo usuario",
"Published" => "Publicada",
"By:" => "Por:",
"Bye bye!" => "¡Adiós!",
"This email address has been removed to the list of subscriptors of:" => "Esta dirección de correo ha sido borrada de la lista de los suscriptores de:",
"Newsletter:" => "Boletín:",
"Bye bye from %s at %s" => "Adiós desde  %s en %s",
"You can unsubscribe from this newsletter following this link" => "Puede desuscribirse de este boletín siguiendo este enlace",
"Welcome to our newsletter!" => "Bienvenido a nuestro boletín!",
"This email address has been added to the list of subscriptors of:" => "Esta dirección de correo fue añadida a la lista de suscriptores de:",
"You can always cancel your subscription using:" => "Siempre puede cancelar su suscripción usando:",
"Welcome to %s at %s" => "Bienvenido a %s en %s",
"Reply notification" => "Notificación de respuesta",
"Email notification" => "Tiki correo de notificación",
"Someone" => "Alguien",
"requested a reminder of the password for your account" => "ha pedido un recordatorio de contraseña para tu cuenta",
"requested password reset for your account" => "ha pedido una nueva contraseña para tu cuenta",
"Since this is your registered email address we inform that the password for this account is" => "Ya que esta es su dirección de correo registrada le informamos que la clave para esta cuenta es",
"Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else" => "Por favor, clica en el siguiente enlace para confirmar que deseas que se cambie tu contraseña e ir a la pantalla donde introducir una \"nueva contraseña\". Por favor, escoge una contraseña que sólo sepas tu, y no la compartas con nadie más",
"Important: Username & password are CaSe SenSitiVe" => "Importante: el nombre de usuario y la contraseña son SensIbLes a MayúsCulaS",
"Important: The old password remains active if you don't click the link above" => "Importante: La contraseña antigua permanece activa mientras no cliques en el enlace de más arriba",
"Your account information for %s" => "Su información de cuenta Tiki para %s",
// "}Plugin %0 is pending approval on %1" => "}Plugin %0 is pending approval on %1",
// "tiki-plugins.php\"}See all the pending plugins in the <a href='%0'>plugin approval page</a>" => "tiki-plugins.php\"}See all the pending plugins in the <a href='%0'>plugin approval page</a>",
// "Plugin arguments" => "Plugin arguments",
// "Plugin body" => "Plugin body",
"Report for %0" => "Informe para %0",
"Last Report sent on %0" => "Último informe enviado el %0",
"Changes in detail" => "Cambios detallados",
"You are receiving notification emails grouped in a periodic digest. To receive them individually when posted instead, change your preferences at %0" => "Estás recibiendo correos-e con notificaciones agrupados en un resumen periódico. Para recibirlos, en cambio, individualmente cuando se publiquen, cambia tus preferencias en %0",
// "Look at this link" => "Look at this link",
// "A friend sends you a link from: " => "A friend sends you a link from: ",
// "A new article was submitted by {\$mail_user|username} to {\$mail_site} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "A new article was submitted by {\$mail_user|username} to {\$mail_site} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"You can edit the submission following this link:" => "Puede editar el envío siguiendo este enlace:",
"Heading:" => "Encabezado:",
"Body:" => "Cuerpo:",
"New article submitted at %s" => "Nuevo artículo enviado en %s",
// "ItemID {\$mail_itemId} {\$mail_item_desc} was deleted in the tracker {\$mail_trackerName}" => "ItemID {\$mail_itemId} {\$mail_item_desc} was deleted in the tracker {\$mail_trackerName}",
// "New status for ItemID {\$mail_itemId} {\$mail_item_desc} for the tracker {\$mail_trackerName}" => "New status for ItemID {\$mail_itemId} {\$mail_item_desc} for the tracker {\$mail_trackerName}",
// "Download the file at" => "Download the file at",
"item" => "item",
"was modified at" => "fue modificado en",
"Please visit this link before login again" => "Por favor, visita este enlace antes de conectarte de nuevo",
"Last attempt" => "Último intento",
"Confirm your account at %s" => "Confirma tu cuenta en %s",
"Site" => "Sitio",
"Account suspended" => "Cuenta suspendida",
"An administrator of the site below has added you as a new user" => "Una persona administradora del sitio de más abajo te ha añadido como usuario/a nuevo/a",
"If you want to confirm your membership in this site, click on the following link to login for the first time" => "Si quieres confirmar que quieres ser miembro de este sitio, haz click en el siguiente enlace para conectarte por primera vez",
"Your authentication credentials are" => "Las credenciales para entrar son",
"Welcome to the site" => "Bienvenido/a al sitio",
"Your personal access to" => "Tu acceso personal a",
"joined the group" => "se unió al grupo",
"User joined group" => "El usuario/a se ha unido al grupo",
"You or someone registered this email address at" => "usted o alguien registró esta dirección de correo en",
"If you want to be a registered user in this site you will have to use the following link to login for the first time:" => "Si desea ser un usuario registrado en este sitio debe seguir el siguiente enlace para conectarse por primera vez:",
"Your registration confirmation" => "Su información de registro en Tiki",
"You will receive an email with the information needed to log into this site the first time" => "Recibirás un correo-e con la información necesaria para conectarte por primera vez en este sitio web",
"Your account request has been stored and will be activated by the admin as soon as possible." => "Su pedido de cuenta fue almacenado y será activado por el administrador lo más pronto posible.",
"You'll receive email notification once your account is activated" => "Recibirás una notificación por correo-e una vez se haya activado tu cuenta",
"Please do not attempt to login until you receive the email notification" => "Por favor, no no intentes conectarte hasta que hayas recibido esa notificación",
// "{\$mail_action} article post" => "{\$mail_action} article post",
// "{\$mail_title} by {\$mail_user|username} at" => "{\$mail_title} by {\$mail_user|username} at",
"View the article at:" => "Ver el artículo en:",
"If you don't want to receive these notifications follow this link:" => "Si no desea recibir estas notificaciones siga este enlace:",
"Publish Date" => "Fecha publicación",
"Expiration Date" => "Fecha Expiración",
// "The old article follows" => "The old article follows",
// "{\$mail_action}" => "{\$mail_action}",
"article post at" => "publicación de artículo en",
"New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "Nueva publicación en blog: {\$mail_title}, \"{\$mail_post_title}\", por {\$mail_user|username} en {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"View the blog at:" => "Ver el blog en:",
"New blog post at %s" => "Nueva publicación en blog en %s",
"View item calendar at" => "Visualiza el ítem de la agenda en",
"Modified calendar item" => "Ítem modificado en la agenda",
"New calendar item" => "Nuevo ítem de la agenda",
"changed" => "modificado/a",
"A new category was created in" => "Se ha creado una nueva categoría en",
"Created by" => "Creado/a por",
"created" => "creado/a",
// "A category was removed in" => "A category was removed in",
"Removed by" => "Borrado/a por",
"removed" => "eliminado",
// "A category was updated" => "A category was updated",
"Updated by" => "Actualizado por",
"Old" => "Antiguo",
"updated" => "actualizado",
"The Wiki page {\$mail_objectname} was commented on by" => "La página Wiki {\$mail_objectname} ha sido comentada por",
"an anonymous user" => "como usuario anónimo",
"The article {\$mail_objectname} was commented on by" => "El artículo {\$mail_objectname} ha sido comentado por",
"The tracker item {\$mail_item_title} of tracker {\$mail_objectname} was commented on by" => "El ítem {\$mail_item_title} del formulario-bd {\$mail_objectname}  ha sido comentado por",
"You can view the comment by following this link" => "Puedes ver el comentario si sigues el siguiente enlace",
"File Gallery %s changed" => "Galería de Archivos %s cambiada",
"A file was removed from the file gallery" => "Un archivo fue borrado de la galería de archivos",
"A new file was posted to file gallery" => "Un nuevo archivo ha sido subido en la galería de archivos",
"File Description" => "Descripción del archivo",
"New forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "Nuevo tema de foro en <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}",
"New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "Nueva publicación de foro en <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}",
// "Image Gallery {\$galleryName} changed" => "Image Gallery {\$galleryName} changed",
// "A new file was posted to image gallery" => "A new file was posted to image gallery",
// "The map {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The map {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"You can view the updated map following this link:" => "Puede ver el mapa actualizado siguiendo este enlace:",
"You can edit the map following this link:" => "Puede editar el mapa siguiendo este enlace:",
"An object was added to category" => "Se ha añadido un objeto a la categoría",
"Added by" => "Añadido por",
"An object was removed from category" => "Se ha eliminado un objeto de la categoría",
"A page has been added to your watched sub-structure" => "Se ha añadido una página a la sub-estructura que estás vigilando",
"A page has been removed from your watched sub-structure" => "Se ha eliminado una página de la sub-estructura que estás vigilando",
"A page has been promoted out your watched sub-structure" => "Se ha subido de nivel una página de la sub-estructura que estás vigilando",
"A page has been demoted to your watched structure" => "Se ha bajado de nivel una página de la sub-estructura que estás vigilando",
"Structure modified" => "Estructura modificada",
"has consulted your" => "ha consultado tu",
"Go to the File Gallery" => "Ves a la Galería de Archivos",
"Download the file" => "Descarga el archivo",
"A new file have been attached to page" => "Se ha añadido un nuevo archivo a la página",
"File name" => "Nombre de archivo",
"New attachment on %s, page" => "Nuevo adjunto en %s, página",
// "The page {\$mail_page} was created by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The page {\$mail_page} was created by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "The page {\$mail_page} was deleted by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The page {\$mail_page} was deleted by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "A file was attached to {\$mail_page}" => "A file was attached to {\$mail_page}",
"The page {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "La página {\$mail_page} ha sido cambiada por {\$mail_user|username} el {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "The page {\$mail_page} was deleted but used to be here" => "The page {\$mail_page} was deleted but used to be here",
"You can view the page by following this link:" => "Puede ver la página siguiendo este enlace:",
"You can view a diff back to the previous version by following this link:" => "Puede ver un diferencial con las versiones previas siguiendo el siguiente enlace:",
"The changes in this version follow below, followed after by the current full page text." => "Los cambios en esta version siguen debajo, seguido por del texto completo actual.",
"-Lines: {\$oldd} changed to +Lines: {\$newd}" => "-Líneas: {\$oldd} cambiadas a +Líneas: {\$newd}",
// "The old page content follows below" => "The old page content follows below",
"The new page content follows below." => "El nuevo contenido de la página sigue debajo.",
"Wiki page %s created by {\$mail_user|username}" => "La página Wiki %s ha sido creada por {\$mail_user|username}",
"Wiki page %s deleted by {\$mail_user|username}" => "La página Wiki %s ha sido borrada por {\$mail_user|username}",
"A file was attached to %s" => "Se ha adjuntado un archivo a %s",
"Wiki page %s changed by {\$mail_user|username}" => "La página Wiki %s ha sido cambiada por {\$mail_user|username}",
"Wiki page renamed" => "Página Wiki renombrada",
"Old name" => "Nombre antiguo",
"New name" => "Nombre nuevo",
"Thank you for your registration" => "Gracias por registrarte",
"You may log in now." => "Ahora ya puedes conectarte.",
"click on the map to zoom or pan, do not drag" => "haz clic en el mapa para ampliar o poner en vista panorámica, no arrastres",
// "Query Results" => "Query Results",
// "Querying" => "Querying",
// "Scroll Up" => "Scroll Up",
// "Scroll Down" => "Scroll Down",
"Scale" => "Escale",
"Zoom out" => "Aléjarse",
"Query" => "Consulta",
"Pan" => "Panorámica",
"Zoom in" => "Acercarse",
"Redraw" => "Redibujar",
"select zoom/pan/query and image size" => "elija zoom/pan/consulta y tamaño de imagen",
"View the Map Only" => "Ver Sólo el Mapa",
"Reset Map" => "Reiniciar Mapa",
"Click on the map or click redraw" => "Haz clic en el mapa o haz clic redibujar",
"Overview" => "Resumen",
"Legend" => "Leyenda",
"Layer Manager" => "Manejador de Capas",
"Layer" => "Capa",
// "{\$my_layers[j]->group}" => "{\$my_layers[j]->group}",
// "{\$layer_wiki[i]}" => "{\$layer_wiki[i]}",
// "{\$layer_wiki[j]}" => "{\$layer_wiki[j]}",
"Download Layer" => "Bajar Capa",
"This layer has been set by the maps administrator to not be downloadable" => "Esta capa fue configurada por el administrador de mapas como no descargable",
"you have requested to download the layer:" => "solicitó bajar la capa:",
// "from the mapfile" => "from the mapfile",
"Here are the files to download, do not forget to rename them:" => "Aquí están los archivos a bajar, no olvide renombrarlos:",
"Mapfiles" => "Archivos de mapas",
"Mapfile" => "Archivo de mapa",
"Available mapfiles" => "Archivos de mapas disponibles",
"hits last 7 days" => "visitas en los últimos 7 días",
"monitor this map" => "suscribirse a este mapa",
"Stop Monitoring this Map" => "Dejar de monitorizar este mapa",
"Create a new mapfile" => "Crear nuevo archivo de mapa",
"Mapfile listing" => "Listado de archivos de mapa",
"Reload" => "Recargar",
"You can view this map in your browser using" => "Puede ver este mapa en su navegador usando",
"Zoom out x2" => "Alejar x2",
"Zoom in x2" => "Acercar x2",
"Mapfile History" => "Historia del Archivo de Mapa",
"of" => "de",
"Version:" => "Versión:",
"Compare" => "Comparar",
"Comparing version {\$old.version} with version {\$new.version}" => "Comparar versión {\$old.version} con versión {\$new.version}",
"Current" => "Actual",
"Versions are identical" => "Las versiones son idénticas",
"Legend:" => "Leyenda:",
"v=view" => "v=ver",
"c=compare" => "c=comparar",
"d=diff" => "d=diff",
"Ip" => "Ip",
"Diff" => "Diff",
"Older Version" => "Versión más vieja",
// "{\$dir}" => "{\$dir}",
"Directories" => "Directorios",
"back to" => "volver a",
"Upload From Disk:" => "Subir desde disco:",
"Upload Files" => "Subir Archivos",
"Bytes maximum" => "Máximo de bytes",
"Create Directory:" => "Crear Directorio:",
"index file (.shp):" => "archivo índice (.shp):",
"files to index (regexp):" => "archivos a indexar (regexp):",
"Message Archive" => "Archivo de Mensajes",
"messages" => "mensajes",
"Archive is full!" => "¡El archivo esta lleno!",
"Read" => "Leer",
"Unread" => "No leídos",
"Flagged" => "Marcados",
"Unflagged" => "Desmarcado",
"Containing" => "Conteniendo",
"Sender" => "Enviado por",
"No messages to display" => "Sin mensajes para mostrar",
"Broadcast message" => "Difundir mensaje",
"Confirmation" => "Confirmación",
"Please Confirm" => "Por favor, confírmalo",
"All users" => "Todos los usuarios/as",
"Lowest" => "Mínimo/a",
"Very High" => "Superior",
"Send" => "Enviar",
"Compose message" => "Componer mensaje",
"If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences" => "Se deseas permitir que otras personas te puedan responder, habilita la opción <a href='tiki-user_preferences.php'>Permite mensajes de otros usuarios/as</a> en tus preferencias",
"ERROR" => "ERROR",
"Invalid" => "No válido",
"To: Multiple addresses can be separated with semicolons (\";\") or commas (\",\")" => "To: Puedes poner múltiples direcciones separadas por punto y coma (\";\") o coma (\",\")",
"CC" => "CC",
"CC: Multiple addresses can be separated with semicolons (\";\") or commas (\",\")" => "CC: Puedes poner múltiples direcciones separadas por punto y coma (\";\") o coma (\",\")",
"BCC" => "BCC",
"BCC: Multiple addresses can be separated with semicolons (\";\") or commas (\",\")" => "BCC: Puedes poner múltiples direcciones separadas por punto y coma (\";\") o coma (\",\")",
"Reply-to my email" => "Respóndeme en mi correo-e",
"The user will be able to reply to you directly via email" => "El usuario podrá responderte directamente por correo-e",
"Send me a copy" => "Envíame una copia",
"You will be sent a copy of this email" => "Se te enviará copia de este correo-e",
"No messages to download" => "Sin mensajes para bajar",
"Mailbox is full! Delete or archive some messages if you want to receive more messages." => "¡El Buzón de mensajes está lleno! Borre o archive algunos mensajes si desea recibir más mensajes.",
"is reply to" => "es una respuesta a",
"Find replied message" => "buscar mensaje respondido",
"Mark as read" => "Marcar como leído",
"Mark as unread" => "Marcar como no leído",
"Mark as flagged" => "Poner como marcado",
"Mark as unflagged" => "Desmarcar",
"Mark" => "marcar",
"Mailbox" => "Buzón de mensajes",
"Compose" => "Componer",
"Broadcast" => "Difundir",
"Auto-archive age for read messages:" => "Edad de autoarchivado para mensajes leídos:",
"Read message" => "Leer mensaje",
"Return to mailbox" => "Volver al buzón de mensajes",
"replyall" => "responderatodos",
"Unflag" => "Desmarcar",
"Flag this message" => "Marcar este mensaje",
"From:" => "Desde:",
"Cc" => "Cc",
"Return to archive" => "Volver al archivo",
"Return to outbox" => "Volver a la casilla",
"Sent Messages" => "Enviar Mensajes",
"Replied" => "Respondidos",
"Not replied" => "No respondidos",
"move to archive" => "mover a archivo",
"receiver" => "receptor",
"Move module up" => "Mover módulo arriba",
"Move module down" => "Mover módulo abajo",
"Move module to opposite side" => "Mover módulo al lado opuesto",
"opp side" => "lado op",
"Unassign this module" => "Inhabilitar este módulo",
"Are you sure you want to unassign this module?" => "¿Está seguro que quiere inhabilitar este módulo?",
// "Toggle module contents" => "Toggle module contents",
// "toggle" => "toggle",
// "Toggle Vertically" => "Toggle Vertically",
// "Display type unknown, you have to enter the banner type" => "Display type unknown, you have to enter the banner type",
// "You forgot your Google ad_client number " => "You forgot your Google ad_client number ",
// "To configure your Tiki" => "To configure your Tiki",
"Admin Home" => "Admin Inicio",
// "from the menu" => "from the menu",
// "Read the <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Tiki Documentation\" target=\"_blank\">configuration documentation</a>" => "Read the <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Tiki Documentation\" target=\"_blank\">configuration documentation</a>",
// "Watch the <a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies" => "Watch the <a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies",
// "To remove this module" => "To remove this module",
"Admin Modules" => "Admin Módulos",
// "and remove the assistant module" => "and remove the assistant module",
// "You can also add other modules" => "You can also add other modules",
// "To customize the menu" => "To customize the menu",
"Admin Menus" => "Admin Menús",
// "and edit menu ID 42" => "and edit menu ID 42",
// "Or, create your own menu and add it to a module" => "Or, create your own menu and add it to a module",
// "Login" => "Login",
// "To begin configuring Tiki, please" => "To begin configuring Tiki, please",
"login" => "conéctate",
// "as admin" => "as admin",
// "The Tiki Community" => "The Tiki Community",
// "To learn more, visit: <a href=\"http://tiki.org\" title=\"The Tiki Community\" target=\"_blank\">http://tiki.org</a>" => "To learn more, visit: <a href=\"http://tiki.org\" title=\"The Tiki Community\" target=\"_blank\">http://tiki.org</a>",
// "Tiki Documentation" => "Tiki Documentation",
// "For help, visit <a href=\"http://doc.tiki.org\" title=\"Tiki Documentation\" target=\"_blank\">http://doc.tiki.org</a>" => "For help, visit <a href=\"http://doc.tiki.org\" title=\"Tiki Documentation\" target=\"_blank\">http://doc.tiki.org</a>",
"Published on" => "Publicado en",
"private" => "privado",
"on blogpost" => "en la publicación de la bitácora-blog",
"Untitled" => "Sin título",
// "{\$module_params.label|escape:\"html\"}" => "{\$module_params.label|escape:\"html\"}",
// "{\$crumbs[0]->description}" => "{\$crumbs[0]->description}",
"Add event" => "Añade evento",
// "Unit cost" => "Unit cost",
// "Qty" => "Qty",
// "Gift Certificate" => "Gift Certificate",
// "Remove Gift Certificate" => "Remove Gift Certificate",
// "Add Gift Certificate" => "Add Gift Certificate",
// "Check-out" => "Check-out",
// "Your cart is empty" => "Your cart is empty",
// "Missing %0 of the following categories" => "Missing %0 of the following categories",
// "%0 extra of the following categories" => "%0 extra of the following categories",
// "Unknown comparison" => "Unknown comparison",
// "Impossible condition, %0 of" => "Impossible condition, %0 of",
// "Assign into category" => "Assign into category",
// "{\$modcatlist[\$k].name|escape}" => "{\$modcatlist[\$k].name|escape}",
// "Unassign category" => "Unassign category",
// "{\$module_params.categorize}" => "{\$module_params.categorize}",
"Pages:" => "Páginas:",
// "{\$contributor.country|stringfix}" => "{\$contributor.country|stringfix}",
"Homepage" => "Inicio",
// "1 more contributor" => "1 more contributor",
// "{\$hiddenContributors} more contributors" => "{\$hiddenContributors} more contributors",
"empty" => "vacío",
"low" => "baja",
"Sites" => "Sitios",
"Sites to validate" => "Sitios a validar",
"Categories:" => "Categorías:",
"Visited links" => "Enlaces visitados",
"By" => "Por",
// "hits" => "hits",
"Add tags" => "Añade marcas",
"List everything tagged" => "Lista todo lo marcado",
// "All Groups" => "All Groups",
// "Your Groups" => "Your Groups",
// "Emulated Groups" => "Emulated Groups",
// "Switch to Groups" => "Switch to Groups",
// "Simulate" => "Simulate",
"Add Post" => "Añade publicación",
// "insert original" => "insert original",
// "insert thumbnail" => "insert thumbnail",
"more" => "más",
// "Last %0 Podcasts" => "Last %0 Podcasts",
// "This is likely not a podcast file" => "This is likely not a podcast file",
// "The path to a podcast player is required" => "The path to a podcast player is required",
// "{\$link_text}" => "{\$link_text}",
"No avatar" => "Sin avatar",
"You" => "Tu",
// "{\$data.info.title|escape:\"html\"}" => "{\$data.info.title|escape:\"html\"}",
"Open operator console" => "Abrir consola de operador",
"Execution time" => "Tiempo de ejecución",
"Memory usage" => "Uso de memoria",
// "database queries used in " => "database queries used in ",
"Server load" => "Carga del servidor",
"Logged in as" => "Conectado como",
"Log out" => "Desconéctate",
"Switch User" => "Cambia el Usuario",
// "Enter user name and click 'Switch'.<br />Useful for testing permissions" => "Enter user name and click 'Switch'.<br />Useful for testing permissions",
"Switch" => "Cambiar",
"Switch user" => "Cambia el usuario",
// "Log in through CAS" => "Log in through CAS",
// "Log in as admin" => "Log in as admin",
// "Log in through Shibboleth" => "Log in through Shibboleth",
"eMail" => "Correo",
"CapsLock is on" => "La tecla de bloqueo de mayúsculas está activa",
"Click here if you've forgotten your password" => "Haz clic aquí si se olvidó su contraseña",
"I forgot my password" => "Olvidé mi contraseña",
"Click here to register" => "Haz clic aquí para registrarse",
"Click here to login using the default security protocol" => "Haz clic aquí para conectarse usando el protocolo por defecto de seguridad",
"Standard" => "Standard",
"Click here to login using a secure protocol" => "Haz clic aquí para conectarse usando un protocolo seguro",
"Secure" => "Seguro",
"Stay in SSL mode" => "Permanecer en modo ssl",
"local account" => "cuenta local",
"OpenID Log in" => "Conexión con OpenID",
"What is OpenID" => "Qué es OpenID",
// "No acceptable field to store the feature was found in the specified tracker" => "No acceptable field to store the feature was found in the specified tracker",
"You have" => "Tiene",
"new messages" => "nuevos mensajes",
"new message" => "nuevo mensaje",
"You have 0 new messages" => "Tiene 0 mensajes nuevos",
"No article found" => "No se encuentra ningún artículo",
"No blog post found" => "No se encuentra ningúna publicación de bitácora (blog)",
"We have" => "Tenemos",
"submissions waiting to be examined" => "colaboraciones esperando ser examinadas",
"Stay on this page" => "Permanece en esta página",
// "Edit perspectives" => "Edit perspectives",
"Powered by" => "Basado en",
// "Tiki Wiki CMS Groupware" => "Tiki Wiki CMS Groupware",
"Made with" => "Hecho con",
// "Search Terms" => "Search Terms",
// "Any type" => "Any type",
// "Admin home" => "Admin home",
// "Modify the look &amp; feel (logo, theme, etc.)" => "Modify the look &amp; feel (logo, theme, etc.)",
"Users" => "Usuarios",
// "Toggle interactive translation off" => "Toggle interactive translation off",
// "Toggle interactive translation on" => "Toggle interactive translation on",
// "Theme Generator Editor" => "Theme Generator Editor",
// "Rebuild Search index" => "Rebuild Search index",
// "Plugin Approval" => "Plugin Approval",
// "SysLogs" => "SysLogs",
// "Open Smarty debug window" => "Open Smarty debug window",
// "Wiki feed" => "Wiki feed",
// "Feed" => "Feed",
// "Blogs feed" => "Blogs feed",
// "Articles feed" => "Articles feed",
// "Image Galleries feed" => "Image Galleries feed",
"Image Galleries" => "Galerías de imágenes",
// "File Galleries feed" => "File Galleries feed",
// "Forums feed" => "Forums feed",
// "Maps feed" => "Maps feed",
"Maps" => "Mapas",
"Calendars" => "Calendarios",
// "{\$tracker.name}" => "{\$tracker.name}",
"Entire Site" => "Sitio completo",
"Image Gals" => "Gals de Imágenes",
// "Search for text throughout the site" => "Search for text throughout the site",
// "Go directly to a page, or search in page titles if exact match is not found" => "Go directly to a page, or search in page titles if exact match is not found",
// "Edit existing page or create a new one" => "Edit existing page or create a new one",
// "Page Relations" => "Page Relations",
// "Are you sure you want to delete this shout" => "Are you sure you want to delete this shout",
// "Tweet with Twitter" => "Tweet with Twitter",
// "Post on my Facebook wall" => "Post on my Facebook wall",
// "Shout date" => "Shout date",
// "Delete this shout" => "Delete this shout",
// "Edit this shout" => "Edit this shout",
"Read More" => "Leer más",
"Since your last visit on" => "Desde su última visita el",
"New Images" => "Imágenes nuevas",
"Wiki Pages Changed" => "Páginas wiki modificadas",
"New Files" => "Nuevos archivos",
"New Comments" => "Comentarios",
"New Tracker Items" => "Nuevos Ítems de Formularios-bd",
"New Calendar Events" => "Nuevos enventos en la agenda",
"New Users" => "Nuevos usuarios",
"click to edit" => "clic para editar",
"Nothing has changed" => "Nada ha cambiado",
// "Updated" => "Updated",
"Multiple" => "Múltiples",
"including" => "incluyendo",
"Site default" => "El que hay por omisión en este sitio",
"Find term" => "Encuentra término",
// "{\$user_languages[ix].name}" => "{\$user_languages[ix].name}",
"If not found, you will be given a chance to create it" => "Si no se encuentra, tendrás la oportunidad de crearlo",
// "TikiTests Menu" => "TikiTests Menu",
// "List Tests" => "List Tests",
// "Create Test" => "Create Test",
"Top galleries" => "Galerías Top",
"Posted to" => "Publicado en",
"(Read More)" => "(Leer más)",
// "Missing values" => "Missing values",
// "Add Marker" => "Add Marker",
"Tracker name" => "Nombre de Formulario-bd",
// "Insert fields in wiki textarea" => "Insert fields in wiki textarea",
// "There are no translations of this page" => "There are no translations of this page",
// "Up-to-date-ness" => "Up-to-date-ness",
// "Incoming" => "Incoming",
// "To <strong>continue translating</strong>, select the language to translate from" => "To <strong>continue translating</strong>, select the language to translate from",
// "update from it" => "update from it",
// "None match your" => "None match your",
// "Set your preferred languages" => "Set your preferred languages",
// "preferred languages" => "preferred languages",
"view" => "ver",
// "Outgoing" => "Outgoing",
"update it" => "actualízalo",
"click to view" => "haz clic para verlo",
"Add Event" => "Añade Evento",
"Bookmarks" => "Marcadores",
"Create Bookmark" => "Crea un marcador",
"New Folder" => "Nueva carpeta",
"Done" => "Hecho",
"Del" => "Del",
"select" => "seleccionar",
// "{\$user_groups[ix].groupName|escape}" => "{\$user_groups[ix].groupName|escape}",
// "Group information" => "Group information",
// "You need to activate user and/or group trackers" => "You need to activate user and/or group trackers",
// "%0 out of %1 users" => "%0 out of %1 users",
// "Webmail inbox" => "Webmail inbox",
// "Refresh (non-ajax)" => "Refresh (non-ajax)",
// "TAKE" => "TAKE",
// "View contact" => "View contact",
"online users" => "usuarios en línea",
"online user" => "usuario en línea",
// "on host" => "on host",
// "User does not accept messages" => "User does not accept messages",
"Send a message to" => "Enviar un mensaje a",
// "Send a message" => "Send a message",
// "More Videos" => "More Videos",
// "No results" => "No results",
// "No results were found. Are you sure you searched for a tag" => "No results were found. Are you sure you searched for a tag",
// "We are not autorized to access the group at this time. If you have access to the Zotero group, you can grant this site read access" => "We are not autorized to access the group at this time. If you have access to the Zotero group, you can grant this site read access",
// "No individual permissions, category permissions apply" => "No individual permissions, category permissions apply",
// "There are individual permissions set for this object" => "There are individual permissions set for this object",
"No individual permissions. Global permissions apply." => "No hay permisos individuales, aplican los permisos globales",
// "Session" => "Session",
// "Old Session" => "Old Session",
// "Old Version" => "Old Version",
// "New Session" => "New Session",
// "New Version" => "New Version",
// "Minimum %0 characters long" => "Minimum %0 characters long",
"[-]" => "[-]",
"vote" => "votar",
// "Requires" => "Requires",
"You need to set" => "Has de habilitar ",
// "Separator is " => "Separator is ",
"Reset to default" => "Rehabilita a los valores por omisión",
"Restore current value" => "Rehabilita a los valores actuales",
"Rate" => "Calificación",
"A valid email is mandatory to register" => "Un correo válido es obligatorio para registrarse",
// "{\$customfields[ir].label}" => "{\$customfields[ir].label}",
// "{\$gr.groupDesc|escape}" => "{\$gr.groupDesc|escape}",
// "Use your email as login" => "Use your email as login",
"Lowercase only" => "Sólo minúsculas",
"Repeat password" => "Repetir la contraseña",
"Generate a password" => "Generar una contraseña",
"Passcode to register" => "Código de paso para registrase",
"Not your password" => "No es tu contraseña",
// "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}" => "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}",
// "The passcode (to block robots from registration) is" => "The passcode (to block robots from registration) is",
// "{\$remarksbox_type}" => "{\$remarksbox_type}",
// "{\$result.object_type|escape}" => "{\$result.object_type|escape}",
"Last modification" => "Última modificación",
"No pages matched the search criteria" => "No se encontraron páginas para el criterio de búsqueda",
// "Download Log File" => "Download Log File",
"Send Newsletter" => "Enviar boletín",
"To edit the copyright notices" => "Para editar los avisos de copyright",
"The content on this page is licensed under the terms of the" => "El contenido de esta página esta licenciado bajo los términos del",
"Page alias.." => "Alias de Página",
"Monitor the Sub-Structure" => "Sigue la Sub-estructura por correo-e",
"Stop Monitoring the Sub-Structure" => "Deja de seguir por correo-e la sub-estructura",
// "locked by %0" => "locked by %0",
"Locked" => "Bloqueado",
"Edit page" => "Edita la página",
"Add new child page" => "Añade una página hija nueva",
// "Jump to Content" => "Jump to Content",
"Fullscreen" => "Pantalla Completa",
"Cancel Fullscreen" => "Cancela la Pantalla Completa",
"Show/Hide Left Column" => "Mostrar/Ocultar Menús de la Izquierda",
"Show/Hide Right Column" => "Mostrar/Ocultar Menús de la Derecha",
// "Module errors" => "Module errors",
// "The following modules could not be loaded" => "The following modules could not be loaded",
// "absE" => "absE",
// "Design by" => "Design by",
"comments" => "comentarios",
// "More search options" => "More search options",
// "View latest version before editing" => "View latest version before editing",
"Rename" => "Renombrar",
"Contributions by author" => "Contribuciones por autor",
"Similar" => "Similares",
"Make Structure" => "Haz estructura",
"Discuss" => "Discutir",
"Attach File" => "Adjuntar archivo",
"1 File Attached" => "1 archivo adjuntado",
// "{\$atts|@count} files attached" => "{\$atts|@count} files attached",
// "Bookmark" => "Bookmark",
"Edit This Tracker" => "Edita este Formulario-bd",
"Edit Fields" => "Editar campos",
"Create Item" => "Crea un Ítem",
"View Items" => "Visualiza Ítems",
"Preview your changes" => "Previsualiza tus cambios",
"Edit wiki page" => "Edita la página wiki",
// "Save the page as a partial translation" => "Save the page as a partial translation",
// "Partial Translation" => "Partial Translation",
// "Save the page as a completed translation" => "Save the page as a completed translation",
// "Complete Translation" => "Complete Translation",
// "Save the page, but do not count it as new content to be translated" => "Save the page, but do not count it as new content to be translated",
// "Save the page, but do not send notifications and do not count it as new content to be translated" => "Save the page, but do not send notifications and do not count it as new content to be translated",
"Save Minor Edit" => "Menor",
"Save the page" => "Guarda la página",
"Cancel the edit, you will lose your changes" => "Cancela la edición, perderás tus cambios",
// "Designed originally by" => "Designed originally by",
"* PREVIEW *" => "* PREVISUALIZACIÓN *",
// "Modifying" => "Modifying",
"Toggle checkboxes" => "Conmuta las casillas de verificación",
"Toggle changed" => "Conmuta los cambiados",
"Live preview" => "Previsualización en vivo",
"Reset selected" => "Vuelve a especificar los seleccionados/as",
"Found in" => "Encontrado en",
// "Changed from %0 to %1" => "Changed from %0 to %1",
"Unchanged" => "Sin cambios",
// "No definitions found" => "No definitions found",
// "No types found" => "No types found",
// "This book" => "This book",
// "Start date" => "Start date",
// "before" => "before",
// "after" => "after",
// "don't display" => "don't display",
// "Decimals" => "Decimals",
// "Decimal Point" => "Decimal Point",
// "Auto Tax" => "Auto Tax",
"Tasks" => "Tareas",
// "Book new entries" => "Book new entries",
// "Confirm stack entries" => "Confirm stack entries",
// "Book into Stack" => "Book into Stack",
// "Accounts" => "Accounts",
// "Bank acounts" => "Bank acounts",
// "Journal" => "Journal",
// "Fetch all" => "Fetch all",
"Account" => "Cuenta",
// "Successfully deleted account %0 %1" => "Successfully deleted account %0 %1",
// "Return to main accounting page" => "Return to main accounting page",
// "Create new account" => "Create new account",
// "Edit Account" => "Edit Account",
// "Account number" => "Account number",
"Account name" => "Nombre de cuenta",
"Notes" => "Notas",
// "Budget" => "Budget",
// "Create account" => "Create account",
// "Modify account" => "Modify account",
// "Delete this account" => "Delete this account",
// "Back to book page" => "Back to book page",
// "Debit" => "Debit",
// "Credit" => "Credit",
// "Tax" => "Tax",
// "edit account" => "edit account",
// "unlock account" => "unlock account",
// "Are you sure you want to unlock this account" => "Are you sure you want to unlock this account",
// "lock account" => "lock account",
// "Are you sure you want to lock this account" => "Are you sure you want to lock this account",
// "delete account" => "delete account",
// "Are you sure, you want to delete this account" => "Are you sure, you want to delete this account",
// "Create a new account" => "Create a new account",
// "printable version" => "printable version",
// "export table" => "export table",
// "View account" => "View account",
// "Edit this account" => "Edit this account",
// "My books" => "My books",
// "Tax automation" => "Tax automation",
"hide" => "ocultar",
// "behind" => "behind",
// "Are you sure, you want to close this book" => "Are you sure, you want to close this book",
// "close book" => "close book",
// "Create a book" => "Create a book",
// "Book properties" => "Book properties",
// "Name of the book" => "Name of the book",
// "First date in journal" => "First date in journal",
// "Last date in journal" => "Last date in journal",
// "Currency settings" => "Currency settings",
// "Currency (up to 3 letters) " => "Currency (up to 3 letters) ",
// "Position of the currency " => "Position of the currency ",
// "Show no currency" => "Show no currency",
// "Show currency in front of numbers" => "Show currency in front of numbers",
// "Show currency behind numbers" => "Show currency behind numbers",
// "Decimal point" => "Decimal point",
// "Decimal" => "Decimal",
// "Thousands separator" => "Thousands separator",
// "Quote strings with" => "Quote strings with",
// "End of Line" => "End of Line",
// "Carriage return" => "Carriage return",
// "Line feed" => "Line feed",
// "Carriage Return/Line feed" => "Carriage Return/Line feed",
// "Automatic Tax Calculation" => "Automatic Tax Calculation",
// "Allow automatic tax calculation" => "Allow automatic tax calculation",
// "Create a new book" => "Create a new book",
// "The following transaction has been cancelled" => "The following transaction has been cancelled",
"id" => "id",
// "booking date" => "booking date",
// "Amount" => "Amount",
// "Book a transaction" => "Book a transaction",
// "Add entry" => "Add entry",
// "Book" => "Book",
// "Export {\$what}" => "Export {\$what}",
// "Export CSV settings" => "Export CSV settings",
// "Separator between fields" => "Separator between fields",
// "Quote character for text" => "Quote character for text",
// "Export as CSV" => "Export as CSV",
// "cancel this transaction" => "cancel this transaction",
// "Are you sure you want to cancel this transaction" => "Are you sure you want to cancel this transaction",
// "Balance" => "Balance",
// "Deleted" => "Deleted",
// "Debit Account" => "Debit Account",
// "Debit Amount" => "Debit Amount",
// "Debit Text" => "Debit Text",
// "Credit Account" => "Credit Account",
// "Credit Amount" => "Credit Amount",
// "Credit Text" => "Credit Text",
// "Book a transaction into the stack" => "Book a transaction into the stack",
// "delete this transaction from the stack" => "delete this transaction from the stack",
// "Are you sure you want to delete this transaction from stack" => "Are you sure you want to delete this transaction from stack",
// "confirm this transaction" => "confirm this transaction",
// "Are you sure you want to confirm this transaction" => "Are you sure you want to confirm this transaction",
// "Do not group by item" => "Do not group by item",
// "Group by item" => "Group by item",
"Calendar View" => "Vista de calendario",
// "Tiki Action Calendar" => "Tiki Action Calendar",
"Tools Calendars" => "Herramientas de Calendarios",
"Check / Uncheck All" => "Marcar / desmarcar todos",
// "Your sender email is not set. You can set it <a href=\"%0\">here</a>" => "Your sender email is not set. You can set it <a href=\"%0\">here</a>",
"Preference Filters" => "Filtros de Preferencias",
"Set as my default" => "Fijar como los míos por omisión",
"Configuration search" => "Búsqueda en la configuración",
// "Note: The search index needs rebuilding, this will take a few minutes" => "Note: The search index needs rebuilding, this will take a few minutes",
// "Potential Cross-Site Request Forgery" => "Potential Cross-Site Request Forgery",
// "Search error" => "Search error",
// "Preferences Search Results" => "Preferences Search Results",
// "No preferences were found for your search query" => "No preferences were found for your search query",
// "Database Version Problem" => "Database Version Problem",
// "Your database requires an update to match the current Tiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provokes errors" => "Your database requires an update to match the current Tiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provokes errors",
// "A new version of Tiki, <b>{\$prefs.tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tiki.org/Download\">tiki.org/Download</a>" => "A new version of Tiki, <b>{\$prefs.tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tiki.org/Download\">tiki.org/Download</a>",
"Enabled" => "Activado",
// "Changed" => "Changed",
// "Preference" => "Preference",
// "{\$tikifeedback[n].mes|stringfix}" => "{\$tikifeedback[n].mes|stringfix}",
// "Preference name" => "Preference name",
// "Crosslinks to other features and settings" => "Crosslinks to other features and settings",
// "Administration features" => "Administration features",
// "TikiCache/System" => "TikiCache/System",
"phpinfo" => "phpinfo",
// "Mods" => "Mods",
// "Transversal features" => "Transversal features",
// "which apply to more than one section" => "which apply to more than one section",
"Mail Notifications" => "Notificaciones por correo",
// "Navigation features" => "Navigation features",
// "Text area features" => "Text area features",
// "features you can use in all text areas, like wiki pages, blogs, articles, forums, etc" => "features you can use in all text areas, like wiki pages, blogs, articles, forums, etc",
"Cookies" => "Cookies",
// "External Pages Cache" => "External Pages Cache",
// "External Wikis" => "External Wikis",
// "Please select some actions to be reported" => "Please select some actions to be reported",
// "Users and Groups" => "Users and Groups",
"Misc" => "Misc",
// "Units" => "Units",
// "kb" => "kb",
// "Contibution Time" => "Contibution Time",
// "Graph Contributions" => "Graph Contributions",
// "Group Bar Plot" => "Group Bar Plot",
// "Accumulated Bar Plot" => "Accumulated Bar Plot",
// "{\$color}" => "{\$color}",
// "Legend background color" => "Legend background color",
// "Save graphs to image gallery" => "Save graphs to image gallery",
// "See Statistics" => "See Statistics",
// "Records" => "Records",
// "contribution" => "contribution",
// "contributor" => "contributor",
// "{\$actionlog.action|escape}" => "{\$actionlog.action|escape}",
// "{\$actionlog.objectType}" => "{\$actionlog.objectType}",
// "{\$actionlog.ip}" => "{\$actionlog.ip}",
// "Ban" => "Ban",
// "Edit Action" => "Edit Action",
// "Save Action" => "Save Action",
"Statistics" => "Estadísticas",
// "Volumes are equally distributed on each contributors/author" => "Volumes are equally distributed on each contributors/author",
// "connection time" => "connection time",
// "connection seconds" => "connection seconds",
// "mns" => "mns",
// "Volume per category" => "Volume per category",
// "Volume per category and per user" => "Volume per category and per user",
// "Number of actions per user" => "Number of actions per user",
// "Total number of users" => "Total number of users",
// "Number of actions per object" => "Number of actions per object",
// "Total number of objects" => "Total number of objects",
// "Number of actions per category" => "Number of actions per category",
// "Number of actions per category and per user" => "Number of actions per category and per user",
// "Volume per the users' group and per contribution" => "Volume per the users' group and per contribution",
// "Volume per group and per contribution" => "Volume per group and per contribution",
// "Volume per user and per contribution" => "Volume per user and per contribution",
// "Volume per users' contribution and time" => "Volume per users' contribution and time",
// "Volume per contribution and time" => "Volume per contribution and time",
"Weeks" => "Semanas",
"Setting" => "Opción",
// "How" => "How",
// "You need to check out the recorded box for each action type we may be interested to have some report later. To see a report of some action types, select the reported checkboxes of these action types, goto the Report tab and select additional filters. The report will only contains the actions that occurred since the action type has been set to recorded" => "You need to check out the recorded box for each action type we may be interested to have some report later. To see a report of some action types, select the reported checkboxes of these action types, goto the Report tab and select additional filters. The report will only contains the actions that occurred since the action type has been set to recorded",
// "Wiki page actions except viewed will always be recorded but can be not reported" => "Wiki page actions except viewed will always be recorded but can be not reported",
// "Recorded" => "Recorded",
// "Reported" => "Reported",
// "{\$actionlog.action}" => "{\$actionlog.action}",
// "Import as CSV" => "Import as CSV",
// "Banning rules have been updated" => "Banning rules have been updated",
// "Add or edit rules" => "Add or edit rules",
"Rule title" => "Título de regla",
"Username regex matching" => "Regex matching de usuario",
// "Multiple IP regex matching" => "Multiple IP regex matching",
"IP regex matching" => "Regex matching de IP",
"Banned from sections" => "Banneado de secciones",
// "{\$sec}" => "{\$sec}",
"Rule activated by dates" => "Activación de reglas por fechas",
"Rule active from" => "Regla activa desde",
"Rule active until" => "Regla activa hasta",
"Custom message to the user" => "Mensaje personalizado al usuario",
// "Import rules as CSV" => "Import rules as CSV",
"CSV File" => "Archivo CSV",
// "Column names on the first line" => "Column names on the first line",
// "Sections format" => "Sections format",
// "section names are splitted by pipes (vertical bars). To see an example and use it as template, add one rule by hand, and export it as csv" => "section names are splitted by pipes (vertical bars). To see an example and use it as template, add one rule by hand, and export it as csv",
// "See" => "See",
// "Import as new rules" => "Import as new rules",
"import" => "importar",
"Find:" => "Encontrar:",
"Rules" => "Reglas",
"x" => "x",
"User/IP" => "Usuario/IP",
"Sections" => "Secciones",
"Admin Calendars" => "Admin Calendarios",
"Create Calendar" => "Crea un Calendario",
"View Calendars" => "Visualiza los Calendarios",
"List of Calendars" => "Lista de Calendarios",
"Calendar name" => "Nombre del Calendario",
"Loc" => "Lug",
"Participants" => "Participantes",
"Cat" => "Cat",
"Lang" => "Leng",
"Prio" => "Prio",
"Subscription" => "Subscripción",
"Perso" => "Perso",
"View Calendar" => "Visualiza el calendario",
"Edit Calendar" => "Edita el Calendario",
"Custom Locations" => "Ubicaciones personalizadas",
"Custom Participants" => "Participantes Personalizables",
"Custom Classifications" => "Clasificaciones a medida",
"Custom Languages" => "Lenguajes personalizados",
"Custom URL" => "URL a medida",
"Custom Subscription List" => "Lista de subscripción personalizable",
"Custom Priorities" => "Prioridades personalizadas",
"Personal Calendar" => "Calendario Personal",
"Start of day" => "Inicio del día",
"End of day" => "Final del día",
// "Days to display" => "Days to display",
// "Standard Colors" => "Standard Colors",
// "Green" => "Green",
// "Blue" => "Blue",
// "Purple" => "Purple",
"Red" => "Rojo",
// "Orange" => "Orange",
// "Yellow" => "Yellow",
// "Custom foreground color" => "Custom foreground color",
// "Ex" => "Ex",
// "Custom background color" => "Custom background color",
// "Default event status" => "Default event status",
// "Show in calendar view" => "Show in calendar view",
// "Group of users alerted when calendar event is modified" => "Group of users alerted when calendar event is modified",
// "Default event to all day" => "Default event to all day",
// "Event name on each day in calendar view" => "Event name on each day in calendar view",
// "Delete events older than" => "Delete events older than",
// "Browse the category system" => "Browse the category system",
"Current category" => "Categoría actual",
// "Current Category ID" => "Current Category ID",
// "Create/Edit category" => "Create/Edit category",
"Edit this category:" => "Editar esta categoría:",
"Add new category" => "Añadir nueva categoría",
// "Apply parent category permissions" => "Apply parent category permissions",
"Batch upload" => "Subida batch",
"Objects in category" => "Objectos en la categoría",
// "Remove from this Category" => "Remove from this Category",
// "{\$objects[ix].type}" => "{\$objects[ix].type}",
// "Moving objects between categories" => "Moving objects between categories",
// "Unassign all objects from this category" => "Unassign all objects from this category",
// "Move all the objects from this category to this one" => "Move all the objects from this category to this one",
// "Assign all objects of this category to this one" => "Assign all objects of this category to this one",
"Add objects to category" => "Añadir objetos a la categoría",
"image gal" => "gal imágenes",
// "File gal" => "File gal",
"Admin templates" => "Admin plantillas",
// "Use the Administration page of each enabled feature to allow the use of content templates" => "Use the Administration page of each enabled feature to allow the use of content templates",
"Edit this template:" => "Editar esta plantilla:",
"Create new template" => "Crear nueva plantilla",
// "Name field is mandatory" => "Name field is mandatory",
// "Use in" => "Use in",
"CMS" => "CMS",
"HTML Pages" => "Páginas HTML",
// "No features are configured to use templates" => "No features are configured to use templates",
// "Template Type" => "Template Type",
// "Text area" => "Text area",
// "Is HTML" => "Is HTML",
"Templates" => "Plantillas",
// "Visible in no sections" => "Visible in no sections",
// "Remove section" => "Remove section",
// "Admin Contributions" => "Admin Contributions",
// "Edit the contribution" => "Edit the contribution",
// "Contributions are mandatory in wiki pages" => "Contributions are mandatory in wiki pages",
// "Contributions are mandatory in forums" => "Contributions are mandatory in forums",
// "Contributions are mandatory in comments" => "Contributions are mandatory in comments",
// "Contributions are mandatory in blogs" => "Contributions are mandatory in blogs",
// "Contributions are displayed in the comment/post" => "Contributions are displayed in the comment/post",
// "Create a new contribution" => "Create a new contribution",
// "List of contributions" => "List of contributions",
"Admin cookies" => "Administrar cookies",
// "To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}" => "To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}",
"Create/edit cookies" => "Crear/editar cookies",
"Upload Cookies from textfile" => "Subir cookies desde un archivo de texto",
"Upload from disk:" => "Subir desde el disco:",
"Upload" => "Subir",
"Remove all cookies" => "Borrar todas las cookies",
"cookie" => "cookie",
// "Manage Credits" => "Manage Credits",
// "(YYYY-MM-DD HH:MM:SS)" => "(YYYY-MM-DD HH:MM:SS)",
// "(level credits always 0)" => "(level credits always 0)",
// "Delete Checked" => "Delete Checked",
// "User Credits Expiry Summary (Plans)" => "User Credits Expiry Summary (Plans)",
// "User Plan" => "User Plan",
// "Start of Latest Plan" => "Start of Latest Plan",
// "Start of Next Plan" => "Start of Next Plan",
// "Expiry" => "Expiry",
// "Use User Credits" => "Use User Credits",
// "Restore User Level Credits" => "Restore User Level Credits",
// "Historical Usage Report" => "Historical Usage Report",
"all types" => "todos los tipos",
"filter" => "filtrar",
// "Usage Date" => "Usage Date",
// "Amount Used" => "Amount Used",
// "Manage Credit Types" => "Manage Credit Types",
// "Display Text" => "Display Text",
// "Unit Text" => "Unit Text",
// "Is Static Level Credit" => "Is Static Level Credit",
// "Display Bar Length Scaling Divisor" => "Display Bar Length Scaling Divisor",
// "Purge Expired and Used Credits (All Users)" => "Purge Expired and Used Credits (All Users)",
// "Purge" => "Purge",
// "Admin Content Sources" => "Admin Content Sources",
// "Use Admin DSN to define the database to be used by the SQL plugin" => "Use Admin DSN to define the database to be used by the SQL plugin",
// "Create/edit DSN" => "Create/edit DSN",
// "Local (Tiki database)" => "Local (Tiki database)",
// "See db/local.php" => "See db/local.php",
// "Content Authentication" => "Content Authentication",
// "Identification" => "Identification",
// "HTTP Basic" => "HTTP Basic",
// "HTTP Session / Login" => "HTTP Session / Login",
// "HTTP Session / Visit" => "HTTP Session / Visit",
// "Admin External Wikis" => "Admin External Wikis",
"Create/Edit External Wiki" => "Crear/Editar Wiki Externo",
"URL (use \$page to be replaced by the page name in the URL example: http://www.example.com/tiki-index.php?page=\$page)" => "URL (use \$page para ser reemplazado por el nombre de página en la URL ejemplo: http://www.ejemplo.com/tiki-index.php?page=\$page)",
"ExtWiki" => "Extwiki",
"Admin Forums" => "Admin Foros",
"Create New Forum" => "Crear Nuevo Foro",
// "Duplicate Forum" => "Duplicate Forum",
// "View this forum" => "View this forum",
// "Import forums" => "Import forums",
"List forums" => "Listar foros",
"Coms" => "Coms",
"Age" => "Edad",
"PPD" => "Ppd",
// ".." => "..",
// "Create/Edit Forums" => "Create/Edit Forums",
"Edit this Forum:" => "Editar este Foro:",
"Prevent flooding" => "Prevenir flooding",
"Minimum time between posts" => "Tiempo mínimo entre mensajes",
"Create new" => "Crear nuevo",
"Moderator user" => "Usuario moderador",
"Moderator group" => "Grupo moderador",
"Password protected" => "Protegido por contraseña",
"Forum password" => "Contraseña de foro",
// "Only allow replies to the first message (flat forum)" => "Only allow replies to the first message (flat forum)",
"Send this forums posts to this email" => "Enviar mensajes de este foro a este correo",
"Prune unreplied messages after" => "Eliminar mensajes sin respuestas después de",
"Prune old messages after" => "Eliminar viejos mensajes después de",
"Topic list configuration" => "Configuración de listado de temas",
// "Last post title" => "Last post title",
// "Last post avatar" => "Last post avatar",
// "Author avatar" => "Author avatar",
"Posts can be rated" => "Mensajes pueden ser calificados",
"Display last post titles" => "Desplegar últimos títulos de mensajes",
"Forward messages to this forum to this e-mail address, in a format that can be used for sending back to the inbound forum e-mail address" => "Reenviar mensajes a este foro a esta direcde correo, en un formato que puede ser usado para enviar para retornar a la dirección entrante de correo del foro",
"Send mails even when the post is generated by inbound mail" => "Enviar correos aun cuando el envío es generado por un mensaje entrante",
"Append a reply link to outbound mails" => "Agregar un enlace a la respuesta de mensajes salientes",
"Originating e-mail address for mails from this forum" => "Dirección origen de correo para correos de este foro",
"Add messages from this email to the forum" => "Añadir mensajes para este correo a el foro",
"POP3 server" => "Servidor POP3",
"Use topic smileys" => "Usar emoticones del tema",
"Show topic summary" => "Mostrar sumario del tema",
"User information display" => "Desplegar información de usuario",
"Online" => "En línea",
"Approval type" => "Tipo de aprobación",
"Store attachments in:" => "Guardar adjuntos en:",
"Max attachment size (bytes)" => "Tamaño máximo del adjunto (bytes)",
// "Shows number of attachments of the all thread in forum list" => "Shows number of attachments of the all thread in forum list",
// "Set topics preferences" => "Set topics preferences",
// "Show topics preferences" => "Show topics preferences",
// "hide topics preferences" => "hide topics preferences",
"Default ordering for topics" => "Orden por defecto para temas",
"Topics per page" => "Temas por página",
// "Set thread preferences" => "Set thread preferences",
// "Show threads preferences" => "Show threads preferences",
// "hide threads preferences" => "hide threads preferences",
"Default ordering for threads" => "Orden por defecto para mensajes",
// "Default style for threads" => "Default style for threads",
// "Duplicate perms" => "Duplicate perms",
"Admin Hotwords" => "Admin Palabras clave",
"Add Hotword" => "Añadir Palabra clave",
"Word" => "Palabra",
// "Admin HTML Page Dynamic Zones" => "Admin HTML Page Dynamic Zones",
"Admin HTML pages" => "Administrar páginas HTML",
"View page" => "Ver página",
"Edit zone" => "Editar sección",
"Dynamic zones" => "Secciones dinámicas",
"zone" => "sección",
"content" => "contenido",
"Mass update" => "Actualización masiva",
"Create new HTML page" => "Crear nueva página HTML",
// "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones" => "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones",
"Edit this HTML page:" => "Editar esta página HTML:",
"Apply template" => "Aplicar plantilla",
// "{\$templates[ix].name}" => "{\$templates[ix].name}",
"Dynamic" => "Dinámica",
"Static" => "Estática",
// "Refresh rate (if dynamic)" => "Refresh rate (if dynamic)",
"Last Modif" => "últ modif",
// "Admin dynamic zones" => "Admin dynamic zones",
// "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> feature" => "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> feature",
"Edit Repository:" => "Editar Repositorio:",
"Create New Repository" => "Crear Nuevo Repositorio",
"List Repositories" => "Listar repositorios",
"New Repository" => "Nuevo repositorio",
"View Repository" => "Ver repositorio",
"Human-readable repository name" => "Descripción legible del repositorio",
"Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')" => "Camino al repositorio (filesystem local: relativo/absoluto respecto a raíz de web, remoto: prefijado con 'http://')",
"File name of start page" => "Archivo de la página inicial",
"Start page" => "Página inicial",
"CSS file to load when browse this repository" => "Archivo CSS a cargar cuando se navegue este repositorio",
"CSS File" => "Archivo CSS",
"Is repository visible to users" => "Es el repositorio visible para usuarios",
"Can files from repository be cached" => "Pueden ser cacheados archivos del repositorio",
"Cacheable" => "Cacheable",
"Are files from repository can be cached" => "Los archivos del repositorio pueden ser cacheados",
"Clear all cached pages of this repository" => "Borrar todas las páginas cacheadas del repositorio",
"Clear cache" => "Borrar cache",
"Seconds count 'till cached page will be expired" => "Cuenta de segundos hasta que expiren las páginas cacheadas",
"Cache expiration" => "Expiración de cache",
"Human-readable text description of repository" => "Descripción legible del repositorio",
"Available Repositories" => "Repositorios disponibles",
"Edit rules" => "Editar reglas",
"Edit Rules for Repository:" => "Editar Reglas para Repositorio:",
"Configure Repositories" => "Configurar repositorios",
"Configure this Repository" => "Configure este repositorio",
"View this Repository" => "Ver este repositorio",
"New Rule" => "Nueva regla",
"Copy Rules" => "Copiar reglas",
"view/hide copy rules dialog" => "ver/ocultar diálogo de copia de reglas",
"Source repository" => "Repositorio origen",
"Copy" => "Copiar",
"According this order rules will be applied ('0' or empty = auto)" => "De acuerdo a este órden las reglas serán aplicadas ('0' o vacío = auto)",
"Rule order" => "Órden de reglas",
"Text to search for" => "Texto a buscar",
"Text to replace" => "Texto a reemplazar",
"Is this regular expression or simple search/replacer" => "Es ésta una expresión regular o una simple búsqueda/substitución",
"Regex" => "Regex",
"Is case sensitive (for simple replacer)" => "Es sensible a mayúsc/minúsc (para reemplazo simple)",
"Case sensitive" => "Mayúsc/Minúsc",
"subset of chars: imsxeADSXUu, which is regex modifiers" => "subconjunto de caracteres: imsxeADSXUu, que son modificadores de regex",
"Regex modifiers" => "Modificadores de Regex ",
"Human-readable text description of rule" => "Descripción legible de la regla",
"Check to enable this rule" => "Chequee para habilitar esta regla",
"Preview options" => "Previsualizar opciones",
"Apply all rules or just this to generate preview" => "Aplicar todas las reglas o sólo ésta para generar la previsualización",
"Apply all rules" => "Aplicar todas las reglas",
"View source code after rules applied" => "Ver código fuente después de que las reglas sean aplicadas",
"Code preview" => "Vista previa de código",
"Generate HTML preview" => "Generar vista previa HTML",
"HTML preview" => "HTML vista previa",
"Test file from repository to generate preview for (empty = configured start page)" => "Archivo de prueba del repositorio para la cual generar vista previa (vacío = página inicial configurada)",
"Preview Results" => "Resultados de vista previa",
"Rules List" => "Lista de Reglas",
"Case" => "Case",
"Configure/Options" => "Configurar/Opciones",
// "Admin Invoices" => "Admin Invoices",
// "Admin keywords" => "Admin keywords",
// "Keywords have been updated" => "Keywords have been updated",
// "Updating keywords has failed. Page probably doesn't exist" => "Updating keywords has failed. Page probably doesn't exist",
// "Edit page keywords" => "Edit page keywords",
// "Current Page Keywords" => "Current Page Keywords",
// "Search by page" => "Search by page",
// "results found" => "results found",
"No pages found" => "No se encontraron páginas",
"Admin layout" => "Admin diseño",
"Theme control" => "Control de temas",
"layout options" => "opciones de diseño",
// "{\$sections[ix].name}" => "{\$sections[ix].name}",
"Right column" => "Columna derecha",
"Top bar" => "Barra de encabezado",
"Bottom bar" => "Barra al pie",
// "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>" => "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>",
"Generate positions by hits" => "Ordenar automáticamente por hits",
"List of featured links" => "Lista de enlaces destacados",
"Add Featured Link" => "Añadir un enlace",
"Edit this Featured Link:" => "Editar este enlace destacado:",
"Create new Featured Link" => "Crear nuevo enlace destacado",
"disables the link" => "deshabilita el enlace",
"Link type" => "Tipo de enlace",
"replace current page" => "reemplazar la página actual",
"framed" => "en un marco",
"open new window" => "abrir nueva ventana",
"Mail-in accounts" => "Cuentas Mail-in",
// "{\$accounts[ix].type}" => "{\$accounts[ix].type}",
"Add new Mail-in account" => "Añada una nueva cuenta Mail-in",
"Edit Mail-in account" => "Editar cuenta Mail-in",
"POP server" => "Servidor POP",
"SMTP server" => "Servidor SMTP",
"SMTP requires authentication" => "SMTP requiere autenticación",
"article-put" => "article-put",
"wiki-get" => "wiki-get",
"wiki-put" => "wiki-put",
"wiki-append" => "wiki-append",
"Article Topic" => "Tema de Artículo",
"Admin Topics" => "Administrar temas",
"Article Type" => "Tipo de Artículo",
// "{\$types[t].type}" => "{\$types[t].type}",
"Admin Types" => "Admin tipos",
"Active" => "Activo",
"Allow anonymous access" => "Permitir usuarios anónimos",
"Allow attachments" => "Permitir archivos asociados",
"Discard to the end from" => "Descartar hasta el fin desde",
"Check Mail-in accounts" => "Chequear cuentas Mail-in",
"Check automatically" => "Chequear automáticamente",
"Frequency" => "Frecuencia",
// "mn" => "mn",
"Admin Menu" => "Menú admin",
"List menus" => "Listar menús",
"Edit this menu" => "Editar menú",
// "Manage menu" => "Manage menu",
"Menu options" => "Opciones de menú",
// "switch with previous option" => "switch with previous option",
// "switch with next option" => "switch with next option",
// "Create menu option" => "Create menu option",
// "Edit menu option" => "Edit menu option",
"Show Quick Urls" => "Mostrar URLs Rápidas",
"Some useful URLs" => "Algunas URLs útiles",
"Hide Quick Urls" => "Ocultar URLs Rápidas",
"Home" => "Inicio",
"Choose" => "Elegir",
"Home Blog" => "Blog principal",
"Home Image Gal" => "Galería de imgs ppal",
"Home Image Gallery" => "Galería de imgs ppal",
"Home File Gal" => "Galería de archivos ppal",
"Home File Gallery" => "Galería de archivos ppal",
"User preferences" => "Preferencias del usuario",
"User prefs" => "Prefs del usuario",
"Wiki Home" => "Inicio Wiki",
"List galleries" => "Listar galerías",
"List image galleries" => "Listar galerías de imágenes",
"Upload image" => "Subir imagen",
"Gallery Rankings" => "Rankings de galerías",
"Browse a gallery" => "Visitar una galería",
"Articles home" => "Inicio de artículos",
"All articles" => "Listado de artículos",
"List articles" => "Listar artículos",
"List Blogs" => "Listar Blogs",
"Create Blog" => "Crear Blog",
"View a forum" => "Ver foro",
"View a thread" => "Ver mensaje",
"View a FAQ" => "Ver FAQ",
"Take a quiz" => "Tomar cuestionario",
"Quiz stats" => "Estadísticas de Cuestionario",
"Stats for a Quiz" => "Estadistícas del Cuestionario ",
// "For wiki page, use ((PageName))" => "For wiki page, use ((PageName))",
"option" => "opción",
// "section level 0" => "section level 0",
// "section level 1" => "section level 1",
// "section level 2" => "section level 2",
// "section level 3" => "section level 3",
// "sorted section level 0" => "sorted section level 0",
"separator" => "separador",
// "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each" => "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each",
// "If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed" => "If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed",
// "Separate multiple feature/preferences with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple feature/preferences with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
// "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
"Preview menu" => "Previsualizar menú",
// "Appearance" => "Appearance",
// "Import/export menu" => "Import/export menu",
// "Export CSV data" => "Export CSV data",
// "Import CSV data" => "Import CSV data",
// "To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'" => "To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'",
// "RESET" => "RESET",
// "Clone this menu and its options" => "Clone this menu and its options",
// "Create/Edit Menu" => "Create/Edit Menu",
"Edit this Menu:" => "Editar este Menú:",
"Create new Menu" => "Crear nuevo Menú",
"dynamic collapsed" => "dinámico colapsado",
"dynamic extended" => "dinámico expandido",
"fixed" => "estático",
// "Labels of all options will be wiki parsed" => "Labels of all options will be wiki parsed",
// "Folder Icon" => "Folder Icon",
// "Path and filename of closed folder icon" => "Path and filename of closed folder icon",
// "To use custom folder icons in menus, enter the path to the icon for the <strong>closed</strong> folder" => "To use custom folder icons in menus, enter the path to the icon for the <strong>closed</strong> folder",
// "In the same directory, include an icon for the opened folder" => "In the same directory, include an icon for the opened folder",
// "The \"opened folder\" icon name must be identical to the \"closed folder\" icon name, prefixed with the letter <strong>o</strong>" => "The \"opened folder\" icon name must be identical to the \"closed folder\" icon name, prefixed with the letter <strong>o</strong>",
// "For example, the default icon is: img/icons/folder.png" => "For example, the default icon is: img/icons/folder.png",
// "The name of the \"open folder\" icon is: img/icons/ofolder.png" => "The name of the \"open folder\" icon is: img/icons/ofolder.png",
// "Configure icons for menu entries" => "Configure icons for menu entries",
// "You can use menus by assigning the menu <a href=\"tiki-admin_modules.php\">module</a> (to the top, left, right, etc.), or you can customize a template, using {literal}{menu id=x}{/literal}, where x is the ID of the menu" => "You can use menus by assigning the menu <a href=\"tiki-admin_modules.php\">module</a> (to the top, left, right, etc.), or you can customize a template, using {literal}{menu id=x}{/literal}, where x is the ID of the menu",
// "To use a menu in a tiki format" => "To use a menu in a tiki format",
// "To use menu in a css/suckerfish format" => "To use menu in a css/suckerfish format",
// "To customize the menu's CSS id (#)" => "To customize the menu's CSS id (#)",
// "Admin Metrics" => "Admin Metrics",
// "Metrics" => "Metrics",
// "Assign Metrics" => "Assign Metrics",
// "Assigned Metrics" => "Assigned Metrics",
// "Edit/Create Metrics" => "Edit/Create Metrics",
// "Edit/Create Tab" => "Edit/Create Tab",
// "Data Type" => "Data Type",
// "Weight" => "Weight",
// "Metric Name" => "Metric Name",
// "Tab Name" => "Tab Name",
// "Assign metric" => "Assign metric",
// "Edit this assigned metric" => "Edit this assigned metric",
// "Tab for metric" => "Tab for metric",
// "Create new metric" => "Create new metric",
// "Edit this metric" => "Edit this metric",
// "Hints" => "Hints",
// "For list-based metrics, include the \"LIMIT #\" in your query" => "For list-based metrics, include the \"LIMIT #\" in your query",
// "Name (must be unique)" => "Name (must be unique)",
// "Create Metric" => "Create Metric",
// "Edit Metric" => "Edit Metric",
// "Create new tab" => "Create new tab",
// "Edit this tab" => "Edit this tab",
// "Weight (must be integer)" => "Weight (must be integer)",
// "Create Tab" => "Create Tab",
// "Edit Tab" => "Edit Tab",
"Clear Cache" => "Limpiar cache",
// "Show hidden modules" => "Show hidden modules",
// "Hide hidden modules" => "Hide hidden modules",
// "Exit Modules" => "Exit Modules",
// "Modules Parameters" => "Modules Parameters",
// "The following required parameters are missing" => "The following required parameters are missing",
// "Drag the modules around to re-order then click save when ready" => "Drag the modules around to re-order then click save when ready",
// "Double click them to edit" => "Double click them to edit",
// "Modules with \"position: absolute\" in their style can be dragged in to position" => "Modules with \"position: absolute\" in their style can be dragged in to position",
// "New modules can be dragged from the \"All Modules\" tab" => "New modules can be dragged from the \"All Modules\" tab",
// "Links and buttons in modules, apart from the Application Menu, have been deliberately disabled on this page to make drag and drop more reliable. Click here to return <a href=\"./\">HOME</a>" => "Links and buttons in modules, apart from the Application Menu, have been deliberately disabled on this page to make drag and drop more reliable. Click here to return <a href=\"./\">HOME</a>",
// "More info here" => "More info here",
// "Assigned modules" => "Assigned modules",
// "Assign/Edit modules" => "Assign/Edit modules",
"Assigned Modules" => "Módulos Asignados",
// "Add module" => "Add module",
// "Move Up" => "Move Up",
// "Move Down" => "Move Down",
// "Edit module" => "Edit module",
"Assign new module" => "Asignar nuevo módulo",
"Edit this assigned module:" => "Editar el módulo asignado:",
// "Module Options" => "Module Options",
// "Custom Modules" => "Custom Modules",
// "Create new custom module" => "Create new custom module",
// "Edit this custom module" => "Edit this custom module",
// "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\">assigning it</a>. Using HTML, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site" => "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\">assigning it</a>. Using HTML, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site",
"Must be wiki parsed" => "Debe ser parseado por wiki",
"Objects that can be included" => "Objetos que pueden incluirse",
"Available polls" => "Votaciones disponibles",
"Random active poll" => "Votación activa aletoria",
"Random current poll" => "Votación actual aletoria",
"Use Poll" => "Usar votación",
"Random image from" => "Imagen aletoria de",
"Use Gallery" => "Usar galería",
"Dynamic content blocks" => "Bloques de contenido dinámico",
"Use Dynamic Content" => "Usar contenido dinámico",
"Use RSS Module" => "Usar módulo RSS",
// "Default Tiki menus" => "Default Tiki menus",
"Use Menu" => "Usar menú",
// "CSS menus" => "CSS menus",
// "Use CSS menu" => "Use CSS menu",
"Banner zones" => "Zonas de banners",
"Use Banner Zone" => "Usar zona de banners",
"Structures:" => "Estructuras:",
// "Use Wiki Structure" => "Use Wiki Structure",
// "To use a <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\">CSS (Superfish) menu</a>, use one of these syntaxes" => "To use a <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\">CSS (Superfish) menu</a>, use one of these syntaxes",
// "To use a default Tiki menu" => "To use a default Tiki menu",
"Data" => "Data",
// "All Modules" => "All Modules",
// "Show all modules" => "Show all modules",
"Admin newsletter subscriptions" => "Admin suscripciones al boletín",
"List Newsletters" => "Listar boletines",
"Edit Newsletter" => "Edita bloetines",
"Admin Newsletters" => "Admin boletines",
"Send Newsletters" => "Enviar Boletines",
"Subscriptions" => "Suscripciones",
// "Groups included through inheritence" => "Groups included through inheritence",
// "Wiki Page Name" => "Wiki Page Name",
// "Validate Addresses" => "Validate Addresses",
// "Add To List" => "Add To List",
"Valid" => "Válido",
"Subscribed" => "suscrito",
"Unsubscribed" => "De-suscrito",
"Add subscribers" => "Añade suscriptores",
// "You can add several email addresses by separating them with commas" => "You can add several email addresses by separating them with commas",
"Add email:" => "Añadir correo:",
"Add user:" => "Añadir usuario:",
// "Users from group" => "Users from group",
"Group subscription also subscribes included groups" => "Subscripción de grupo también subscribe grupos incluídos",
"Don't send confirmation mail" => "No enviar correo de confirmación",
"The user email will be refreshed at each newsletter sending" => "El correo de usuario será refrescado ante cada envío de boletín",
// "Import emails from file" => "Import emails from file",
// "txt file, one e-mail per line" => "txt file, one e-mail per line",
// "Don't send confirmation mails" => "Don't send confirmation mails",
// "Import emails from wiki page" => "Import emails from wiki page",
// "Wiki page, one e-mail per line" => "Wiki page, one e-mail per line",
"Subscribe group" => "Subscribir grupo",
// "Including group inheritence" => "Including group inheritence",
// "Including group, group users and emails will be refreshed at each newsletter sending" => "Including group, group users and emails will be refreshed at each newsletter sending",
// "Use subscribers of another newsletter" => "Use subscribers of another newsletter",
// "Use emails from wiki page" => "Use emails from wiki page",
// "Emails on a wiki page which will be added at each newsletter sending, one e-mail per line" => "Emails on a wiki page which will be added at each newsletter sending, one e-mail per line",
// "Don't subscribe emails" => "Don't subscribe emails",
// "Export Subscriber Emails" => "Export Subscriber Emails",
"Admin newsletters" => "Admin boletines",
"Create Newsletter" => "Crea Boletín",
"Editions" => "Ediciones",
"Drafts" => "Borradores",
"Last Sent" => "última edición",
"Assign Permissions" => "Asignar Permisos",
"Create/Edit Newsletters" => "Crear/editar boletín",
"There are individual permissions set for this newsletter" => "Existen permisos individuales para este boletín",
"Users can subscribe/unsubscribe to this list" => "Usuarios pueden suscribirse/desuscribirse a esta lista",
"Users can subscribe any email address" => "Usuarios pueden suscribir cualquier dirección de correo",
"Add unsubscribe instructions to each newsletter" => "Añadir instrucciones de desuscripción a cada boletín",
"Validate email addresses" => "Validar dirección de correo",
// "Allow customized text message to be sent with the HTML version" => "Allow customized text message to be sent with the HTML version",
// "Allow clipping of articles into newsletter" => "Allow clipping of articles into newsletter",
// "Automatically clip articles into newsletter" => "Automatically clip articles into newsletter",
// "Clip articles published in the past number of days" => "Clip articles published in the past number of days",
// "Article types to clip" => "Article types to clip",
// "Mail notifications" => "Mail notifications",
// "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications" => "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications",
"Add notification" => "Añadir notificación",
// "Alert" => "Alert",
"Event" => "Evento",
// "Destination" => "Destination",
// "Myself" => "Myself",
// "Note that a user is not notified for his own action" => "Note that a user is not notified for his own action",
// "User / Group" => "User / Group",
"Trackers Outbound Emails" => "Correos-e de salida de Formularios-bd",
// "Forums Outbound Emails" => "Forums Outbound Emails",
"Admin Polls" => "Admin Votaciones",
"List polls" => "Listar votaciones",
"Edit this poll" => "Editar votación",
"Preview poll" => "Previsualizar votación",
// "Add poll option" => "Add poll option",
// "Edit poll option" => "Edit poll option",
"Poll options" => "Opciones de votaciones",
"Votes" => "Votos",
"Set last poll as current" => "Poner última votación como actual",
"Close all polls but last" => "Cerrar todas las votaciones menos la última",
"Activate all polls" => "Activar todas las votaciones",
// "Create poll" => "Create poll",
// "Edit poll" => "Edit poll",
"active" => "activo",
"current" => "actual",
"object" => "objeto",
// "Toggle Quick Options" => "Toggle Quick Options",
// "Add Option" => "Add Option",
// "Leave box empty to delete an option" => "Leave box empty to delete an option",
// "Votes older than these days are not considered" => "Votes older than these days are not considered",
// "0 for no limit" => "0 for no limit",
"Objects" => "Objetos",
"Results" => "Resultados",
// "Add poll to pages" => "Add poll to pages",
// "{\$channels[ix].title}" => "{\$channels[ix].title}",
// "This menu shows only Polls with 'status': \"template\"" => "This menu shows only Polls with 'status': \"template\"",
"Wiki pages" => "páginas wiki",
// "{\$listPages[ix].pageName|escape}" => "{\$listPages[ix].pageName|escape}",
// "Lock the pages" => "Lock the pages",
// "Admin External Feeds" => "Admin External Feeds",
// "Tips" => "Tips",
// "This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or" => "This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or",
// "To use feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed" => "To use feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed",
"Content for the feed" => "Contenido del feed",
"External Feeds" => "Alimentaciones externas",
// "Show Date" => "Show Date",
"Refresh rate" => "Tiempo de refresco",
// "View feed" => "View feed",
// "Article Generator" => "Article Generator",
// "Edit Feed" => "Edit Feed",
// "Create Feed" => "Create Feed",
// "Create new external feed" => "Create new external feed",
"show feed title" => "mostrar título del feed",
"show publish date" => "mostrar fecha de publicación",
// "The article generator will create a new article for every item read in the RSS feed" => "The article generator will create a new article for every item read in the RSS feed",
// "Use Article Submission System" => "Use Article Submission System",
// "Publish in the future" => "Publish in the future",
// "-1 to use original publishing date from the feed" => "-1 to use original publishing date from the feed",
// "Configure" => "Configure",
"Security Admin" => "Admin Seguridad",
// "To <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">report any security issues</a>" => "To <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">report any security issues</a>",
// "For additional security checks, please visit <a href=\"tiki-check.php\">Tiki Server Compatibility Check</a>" => "For additional security checks, please visit <a href=\"tiki-check.php\">Tiki Server Compatibility Check</a>",
// "Tiki settings" => "Tiki settings",
"Tiki variable" => "Tiki variable",
"Risk Factor" => "Factor de Riesgo",
"Explanation" => "Explicación",
// "About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors" => "About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors",
// "You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)" => "You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)",
// "Security checks" => "Security checks",
"Check all tiki files" => "Chequear todos los archivos tiki",
"Note, that this can take a very long time. You should check your max_execution_time setting in php.ini." => "Note que esto puede tomar un tiempo muy largo. Deberia chequear el valor de max_execution_time en php.ini.",
"File checks" => "Chequeo de archivos",
// "Check file permissions" => "Check file permissions",
// "This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments" => "This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments",
// "See end of table for detailed explanations" => "See end of table for detailed explanations",
// "owner" => "owner",
// "special" => "special",
"user" => "usuario",
"group" => "grupo",
// "other" => "other",
// "uid" => "uid",
// "gid" => "gid",
// "suid" => "suid",
// "sgid" => "sgid",
"sticky" => "sticky",
// "r" => "r",
// "w" => "w",
// "Set User ID (suid) files" => "Set User ID (suid) files",
// "World writable files or directories" => "World writable files or directories",
// "Files or directories the Webserver can write to" => "Files or directories the Webserver can write to",
// "Strange Inodes (not file, not link, not directory)" => "Strange Inodes (not file, not link, not directory)",
// "Executable files" => "Executable files",
// "What to do with these check results" => "What to do with these check results",
// "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"" => "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"",
// "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content" => "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content",
// "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information" => "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information",
// "Inodes that are not files or directories are not part of tiki. Review these Inodes" => "Inodes that are not files or directories are not part of tiki. Review these Inodes",
// "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod" => "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod",
"Admin Shoutbox Words" => "Admin Palabras de Shoutbox",
"Add Banned Word" => "Agregar Palabra Prohibida",
"Are you sure you want to delete this word?" => "Está seguro que quiere borrar esta palabra?",
// "XML Zip Import" => "XML Zip Import",
// "The structure" => "The structure",
// "has just been created" => "has just been created",
// "You will remove structure" => "You will remove structure",
"Destroy the structure leaving the wiki pages" => "Destruir la estructura dejando las páginas wiki",
"Destroy the structure and remove the pages" => "Destruir la estructura y borrar las páginas",
// "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict" => "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict",
// "The following pages have automatically been categorized with the same categories as the structure" => "The following pages have automatically been categorized with the same categories as the structure",
// "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent" => "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent",
// "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent" => "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent",
// "Edit structure" => "Edit structure",
// "View structure" => "View structure",
"Export Pages" => "Exportar páginas",
// "PDF" => "PDF",
"Dump Tree" => "Volcar árbol",
"Create WebHelp" => "Crear WebHelp",
"View WebHelp" => "Ver webhelp",
// "XML Zip" => "XML Zip",
// "Delete with the pages" => "Delete with the pages",
"Create New Structure" => "Crear nueva estructura",
"Alias" => "Alias",
"Tree" => "árbol",
"Use single spaces to indent structure levels" => "Usar espacios simples para indentar niveles de estructura",
"Edit survey questions" => "Editar preguntas de encuestas",
// "Add a New Question" => "Add a New Question",
"List surveys" => "Listar encuestas",
"Survey Stats" => "Estadisticas",
// "This survey stats" => "This survey stats",
"Edit this Survey" => "Editar encuesta",
"Admin Surveys" => "Admin encuestas",
// "Edit Survey Question" => "Edit Survey Question",
// "Add a New Question to this survey" => "Add a New Question to this survey",
"Question" => "Pregunta",
"One choice" => "Una opción",
"Multiple choices" => "Múltiples opciones",
// "Multiple choices of thumbnails from a file gallery" => "Multiple choices of thumbnails from a file gallery",
"Short text" => "Texto breve",
// "Wiki textarea" => "Wiki textarea",
"Rate (1..5)" => "Calificar (1..5)",
"Rate (1..10)" => "Calificar (1..10)",
// "Answer is mandatory" => "Answer is mandatory",
// "Number of required answers (for multiple choices)" => "Number of required answers (for multiple choices)",
// "For a multiple answer question put the answers into the following field, separated by a comma. Example: one,two,many,lots" => "For a multiple answer question put the answers into the following field, separated by a comma. Example: one,two,many,lots",
// "For a rate, you can give the maximum value" => "For a rate, you can give the maximum value",
// "For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4" => "For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4",
// "For the 'wiki textarea' type, options are: rows,columns. Example: 10,60" => "For the 'wiki textarea' type, options are: rows,columns. Example: 10,60",
"Options (if apply)" => "Opciones (si aplica)",
"Questions" => "Preguntas",
"Admin surveys" => "Admin encuestas",
"List Surveys" => "Listar Encuestas",
// "Create Survey" => "Create Survey",
// "Create/Edit Surveys" => "Create/Edit Surveys",
"Edit this Survey:" => "Editar esta encuesta:",
"Create New Survey" => "Crear nueva encuesta",
"There are individual permissions set for this survey" => "Existen permisos individuales para esta encuesta",
// "Tiki Cache/System Admin" => "Tiki Cache/System Admin",
// "If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed)" => "If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed)",
// "Also see \"Rebuild Index\" in the <a href=\"tiki-admin.php?page=search\">Search Admin Panel</a>" => "Also see \"Rebuild Index\" in the <a href=\"tiki-admin.php?page=search\">Search Admin Panel</a>",
// "Clear cached content" => "Clear cached content",
// "Directory to clear" => "Directory to clear",
"Empty" => "Vaciar",
// "Directories to save" => "Directories to save",
// "Full Path to the Zip File" => "Full Path to the Zip File",
// "Generate a zip of those directories" => "Generate a zip of those directories",
// "A zip has been written to %0" => "A zip has been written to %0",
// "Directory is not writeable" => "Directory is not writeable",
// "Clean" => "Clean",
// "Groups still used in the database but no more defined" => "Groups still used in the database but no more defined",
// "Click to remove" => "Click to remove",
// "Admin Tokens" => "Admin Tokens",
// "List tokens" => "List tokens",
// "Entry" => "Entry",
// "Timeout" => "Timeout",
// "Max hits" => "Max hits",
// "Add new token" => "Add new token",
// "Token successfully created" => "Token successfully created",
// "Full URL" => "Full URL",
// "Timeout in seconds (-1 for unlimited)" => "Timeout in seconds (-1 for unlimited)",
// "Maximum number of hits (-1 for unlimited)" => "Maximum number of hits (-1 for unlimited)",
// "Groups (separated by comma)" => "Groups (separated by comma)",
// "View mode" => "View mode",
// "Wiki and WYSIWYG" => "Wiki and WYSIWYG",
// "Wiki only" => "Wiki only",
// "WYSIWYG only" => "WYSIWYG only",
// "Visual Wiki" => "Visual Wiki",
// "Load" => "Load",
// "Reset to Global" => "Reset to Global",
// "Reset to defaults" => "Reset to defaults",
// "Auto Reloading" => "Auto Reloading",
// "Row" => "Row",
// "Formatting Tools" => "Formatting Tools",
// "Plugin Tools" => "Plugin Tools",
// "Edit tool" => "Edit tool",
// "Wysiwyg Token" => "Wysiwyg Token",
// "Plugin name" => "Plugin name",
// "Custom Tools" => "Custom Tools",
// "Add a new custom tool" => "Add a new custom tool",
// "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br />\nDrag icons back from the toolbar rows onto the full list to remove them.<br />\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br />\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save" => "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br />\nDrag icons back from the toolbar rows onto the full list to remove them.<br />\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br />\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save",
// "If you are experiencing problems with this page after upgrading from Tiki 4 please use this link to delete all your customised tools" => "If you are experiencing problems with this page after upgrading from Tiki 4 please use this link to delete all your customised tools",
// "Delete all custom tools" => "Delete all custom tools",
// "Warning: There is no undo" => "Warning: There is no undo",
// "Admin Article Topics" => "Admin Article Topics",
// "Add topic" => "Add topic",
"topic image" => "imagen de tema",
"Active Permissions" => "Activar permisos",
// "Inactive - Click to Activate" => "Inactive - Click to Activate",
"Deactivate" => "Desactivar",
// "Active - Click to Deactivate" => "Active - Click to Deactivate",
"Remove with articles" => "Borrar con artículos",
"Admin Tracker" => "Admin formulario-bd",
"Tracker fields" => "Campos de formulario-bd",
"Mandatory" => "Obligatorio",
"Save All" => "Guardalo Todo",
"Remove Selected" => "Borra los seleccionados",
"Export Selected" => "Exporta los seleccionados",
"Add Field" => "Añade un campo",
"Import Tracker Fields" => "Importa los campos del Formulario-bd",
// "Raw Fields" => "Raw Fields",
// "Preserve Field IDs" => "Preserve Field IDs",
// "Transitions" => "Transitions",
// "Subset Selection" => "Subset Selection",
// "Category Selection" => "Category Selection",
// "Group Selection" => "Group Selection",
// "Type in a group name and click \"enter\"" => "Type in a group name and click \"enter\"",
// "Once you have selected at least two, click" => "Once you have selected at least two, click",
// "and then, click the \"New/Edit\" tab which will appear above" => "and then, click the \"New/Edit\" tab which will appear above",
// "Draw Transition Diagram" => "Draw Transition Diagram",
// "Guards" => "Guards",
// "preserved" => "preserved",
// "Assign permissions for transition" => "Assign permissions for transition",
// "No transitions" => "No transitions",
// "New / Edit" => "New / Edit",
// "Edit <em>%0</em>" => "Edit <em>%0</em>",
// "New transition" => "New transition",
// "Upon trigger, preserve the initial state" => "Upon trigger, preserve the initial state",
"Members" => "Miembros",
// "No guards on this transition" => "No guards on this transition",
// "New Guard" => "New Guard",
// "Exactly" => "Exactly",
// "At Least" => "At Least",
// "At Most" => "At Most",
// "States" => "States",
"Admin groups" => "Admin grupos",
"Admin users" => "Admin usuarios",
"Add new group" => "Añadir nuevo grupo",
// "Invitation List" => "Invitation List",
"List of existing groups" => "Lista de grupos existentes",
// "Inherits Permissions from" => "Inherits Permissions from",
// "User Choice" => "User Choice",
// "{\$users[user].groupDesc|escape|nl2br}" => "{\$users[user].groupDesc|escape|nl2br}",
"Group Homepage" => "Página inicio de Grupo",
// "{\$users[user].groupHome}" => "{\$users[user].groupHome}",
// "{\$users[user].userChoice}" => "{\$users[user].userChoice}",
"Edit group" => "Editar grupo",
"Add a New Group" => "Agregar nuevo grupo",
// "Group is NOT being monitored. Click icon to START monitoring" => "Group is NOT being monitored. Click icon to START monitoring",
// "Group IS being monitored. Click icon to STOP monitoring" => "Group IS being monitored. Click icon to STOP monitoring",
// "Inherit permissions directly from following groups" => "Inherit permissions directly from following groups",
// "Also inheriting permissions from the following groups (indirect inheritance through the groups selected above)" => "Also inheriting permissions from the following groups (indirect inheritance through the groups selected above)",
// "Group Homepage or Url" => "Group Homepage or Url",
"Use wiki page name or full URL" => "Use página wiki o URL completa",
// "For other Tiki features, use links relative to the Tiki root (such as <em>/tiki-forums.php</em>)" => "For other Tiki features, use links relative to the Tiki root (such as <em>/tiki-forums.php</em>)",
// "Default category assigned to uncategorized objects edited by a user with this default group" => "Default category assigned to uncategorized objects edited by a user with this default group",
// "Group Theme" => "Group Theme",
// "Use site default" => "Use site default",
"Group Information Tracker" => "Formulario-bd de Información de Grupo",
"choose a group tracker ..." => "elija un tracker de grupo ...",
"choose a field ..." => "elija un campo ...",
"Users Information Tracker" => "Formulario-bd de Información de Usuarios",
"choose a users tracker ..." => "elija un tracker de usuarios ...",
// "Users Information Tracker Fields Asked at Registration Time<br />(fieldIds separated with :)" => "Users Information Tracker Fields Asked at Registration Time<br />(fieldIds separated with :)",
// "User can assign to the group himself" => "User can assign to the group himself",
// "Users are automatically unassigned from the group after" => "Users are automatically unassigned from the group after",
// "0 or empty for never" => "0 or empty for never",
// "Or, users are automatically unassigned from the group at an anniversary date" => "Or, users are automatically unassigned from the group at an anniversary date",
// "MMDD for annual or DD for monthly" => "MMDD for annual or DD for monthly",
// "Payment for membership extension is prorated at a minimum interval of a" => "Payment for membership extension is prorated at a minimum interval of a",
// "Users are automatically assigned at registration in the group if their emails match the pattern" => "Users are automatically assigned at registration in the group if their emails match the pattern",
// "Example: " => "Example: ",
// "Assign group <em>management</em> permissions" => "Assign group <em>management</em> permissions",
"Group tracker item : {\$groupitemid}" => "Item de tracker de grupo : {\$groupitemid}",
"Edit Item" => "Editar item",
"Group tracker item not found" => "Item de tracker de grupo no encontrado",
// "Choose a field .." => "Choose a field ..",
"Members List" => "Lista de Miembros",
// "Expire" => "Expire",
// "Remove from Group" => "Remove from Group",
"users in group" => "usuarios en grupo",
// "Banned members List" => "Banned members List",
// "Unban user" => "Unban user",
// "Add or Ban members to" => "Add or Ban members to",
// "Add to group" => "Add to group",
// "Ban user from group" => "Ban user from group",
"Import/Export" => "Importar/exportar",
// "Download CSV export" => "Download CSV export",
// "Charset encoding" => "Charset encoding",
// "UTF-8" => "UTF-8",
// "ISO-8859-1" => "ISO-8859-1",
// "Assign users to group" => "Assign users to group",
// "Each user in the file must already exist" => "Each user in the file must already exist",
// "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>" => "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>",
"Add a New User" => "Añadir un nuevo usuario",
// "Since this Tiki site is in slave mode and imports groups, the master groups will be automatically reimported at each login" => "Since this Tiki site is in slave mode and imports groups, the master groups will be automatically reimported at each login",
// "Since this Tiki site is in slave mode and imports preferences, the master user preferences will be automatically reimported at each login" => "Since this Tiki site is in slave mode and imports preferences, the master user preferences will be automatically reimported at each login",
// "{\$tikifeedback[n].mes|escape}" => "{\$tikifeedback[n].mes|escape}",
"Batch Upload Results" => "Resultados de la Subida en Lote",
// "Updated users" => "Updated users",
"Rejected users" => "Usuarios rechazados",
"Reason" => "Razón",
"More Criteria" => "Más Criterios",
"Group (direct)" => "Grupo (directo)",
// "OpenID" => "OpenID",
"Edit Account Settings" => "Editar opciones de cuenta",
// "N" => "N",
// "Registered %0 ago" => "Registered %0 ago",
// "Need to validate email" => "Need to validate email",
// "Edit Included Group" => "Edit Included Group",
// "Edit Group" => "Edit Group",
"default" => "por defecto",
// "Remove %0 from %1" => "Remove %0 from %1",
// "Assign to group" => "Assign to group",
// "Assign %0 to groups" => "Assign %0 to groups",
// "Edit Account Settings: %0" => "Edit Account Settings: %0",
// "Change user preferences: %0" => "Change user preferences: %0",
// "User Information: %0" => "User Information: %0",
// "Validate user: %0" => "Validate user: %0",
// "Confirm user email: %0" => "Confirm user email: %0",
// "Invalidate email" => "Invalidate email",
// "Remove link with OpenID account" => "Remove link with OpenID account",
// "Remove Users and their Userpages" => "Remove Users and their Userpages",
"Manage Group Assignments" => "Manejar asignación de grupo",
"Set Default Groups" => "Poner grupos por defecto",
// "Send a wiki page by Email" => "Send a wiki page by Email",
"Assign selected to" => "Asignar elegidos a",
"Remove selected from" => "Borrar seleccionado de",
"the following groups:" => "los siguientes grupos:",
"Set the default group of the selected users to" => "Ponga el grupo por defecto de los usuarios seleccionados en",
"bcc" => "bcc",
"Edit user" => "Editar usuario",
// "Assign user to Groups" => "Assign user to Groups",
// "Use the email as username" => "Use the email as username",
// "Warning: changing the username could require the user to change his password (for user registered with an old Tiki&lt;=1.8)" => "Warning: changing the username could require the user to change his password (for user registered with an old Tiki&lt;=1.8)",
// "Warning: it will mess with slave intertiki sites that use this one as master" => "Warning: it will mess with slave intertiki sites that use this one as master",
// "No password is required" => "No password is required",
// "Tiki is configured to delegate the password managment to LDAP" => "Tiki is configured to delegate the password managment to LDAP",
"Repeat Password" => "Repite la Contraseña",
// "User must change password at next login" => "User must change password at next login",
// "Send an email to the user in order to allow him to validate his account" => "Send an email to the user in order to allow him to validate his account",
// "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a>" => "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a>",
// "Pass confirmed" => "Pass confirmed",
// "Email confirmed" => "Email confirmed",
// "%0 days ago" => "%0 days ago",
// "Current Login" => "Current Login",
// "Last Login" => "Last Login",
"User tracker item : {\$usersitemid}" => "Usar ítem de tracker : {\$usersitemid}",
// "You do not have permission to edit this user" => "You do not have permission to edit this user",
// "CSV file layout" => "CSV file layout",
// "login,password,email,groups,default_group,realName<br />user1,pass1,email1,group1,group1<br />user2,pass2,email2,\\\"group1,group2\\\",group1" => "login,password,email,groups,default_group,realName<br />user1,pass1,email1,group1,group1<br />user2,pass2,email2,\\\"group1,group2\\\",group1",
// "Only login, password, email are mandatory.Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma" => "Only login, password, email are mandatory.Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma",
// "Don't overwrite" => "Don't overwrite",
// "Overwrite groups" => "Overwrite groups",
// "Create groups" => "Create groups",
// "User must change password at first login" => "User must change password at first login",
// "You can export users of a group in <a href=\"tiki-admingroups.php\">admin->groups->a_group</a>" => "You can export users of a group in <a href=\"tiki-admingroups.php\">admin->groups->a_group</a>",
// "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences" => "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences",
"Admin Article Types" => "Admin Tipos de Artículo",
// "Article Types" => "Article Types",
// "{\$types[user].type|escape}" => "{\$types[user].type|escape}",
// "View articles with this type" => "View articles with this type",
// "Author rating" => "Author rating",
"Show before publish date" => "Mostrar antes de la fecha de publicación",
"Show after expire date" => "Mostrar después de la fecha de expiración",
"Heading only" => "Sólo encabezado",
// "Comment can rate article" => "Comment can rate article",
"Show image" => "Mostrar imagen",
"Show avatar" => "Mostrar avatar",
"Show publish date" => "Mostrar fecha de publicación",
"Show expire date" => "Mostrar fecha de expiración",
"Show reads" => "Mostrar lecturas",
"Show size" => "Mostrar tamaño",
"Show topline" => "Muestra línea superior",
"Show subtitle" => "Muestra subtítulo",
"Show source" => "Muestra fuente",
// "Show image caption" => "Show image caption",
"Creator can edit" => "Creador puede editar",
// "Custom attribute" => "Custom attribute",
// "Add Type" => "Add Type",
// "Add article type" => "Add article type",
// "Assign User %0 to Groups" => "Assign User %0 to Groups",
// "{\$users[user].groupDesc|escape}" => "{\$users[user].groupDesc|escape}",
// "Assign User to Group" => "Assign User to Group",
"backlinks to" => "backlinks hacia",
"No backlinks to this page" => "No hay backlinks hacia esta página",
"Directory batch upload" => "Subida en lote de directorio",
"Browse Gallery" => "Visitar galería",
"Upload From Disk" => "Subir desde disco local",
"available images" => "imágenes disponibles",
"Filesize" => "Tamaño de archivo",
"Filetype" => "Tipo de archivo",
"Remove File Extension from Image Name" => "Borre la extensión del archivo del nombre de la imágen",
"eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field" => "ej de \"digicam0001.jpg\" el nombre digicam0001 será usado para el campo nombre",
// "Convert the last sub directory to a sub gallery" => "Convert the last sub directory to a sub gallery",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created",
// "Use the last sub directory name as description" => "Use the last sub directory name as description",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created",
"Select a Gallery" => "Seleccione una Galería",
// "Browse File Gallery" => "Browse File Gallery",
// "Please do not use this feature to upload data into the database" => "Please do not use this feature to upload data into the database",
// "Available Files" => "Available Files",
// "Remove extension from filename" => "Remove extension from filename",
// "Select a File Gallery" => "Select a File Gallery",
// "Process files" => "Process files",
"Edit Post" => "Editar la Publicación",
"New Post" => "Nueva Publicación",
"View post" => "Visualizar la Publicación",
"View Blog" => "Ver blog",
"Note: Remember that this is only a preview, and has not yet been saved!" => "Nota: ¡Recuerde que esto es sólo una previsualización, no ha sido salvado aún!",
"Excerpt" => "Extracto",
"Trash" => "Basura",
"Mark entry as private:" => "Marcar entrada como privada:",
"Admin Category" => "Admin categoría",
"Admin the Category System" => "Admin el sistema de categorías",
"Browse in" => "Navegar en",
"Image galleries" => "Galerías de imágenes",
"Trackers Items" => "Ítems de Formularios-bd",
"Sheets" => "Hojas de cálculo",
"in the current category - and its subcategories: " => "en la categoría actual - y sus subcategorías: ",
"Hide subcategories objects" => "Ocultar objetos de subcategorías",
"Show subcategories objects" => "Mostrar objetos de subcategorías",
"Upper level" => "Nivel superior",
// "{\$objects[ix].type|replace:\"wiki page\":\"wiki\"|replace:\"trackeritem\":\"tracker item\"}" => "{\$objects[ix].type|replace:\"wiki page\":\"wiki\"|replace:\"trackeritem\":\"tracker item\"}",
"Browse related tags" => "Navega por la Marcas relacionadas",
"Network of Tags related to" => "Red de marcas relacionadas con",
"With all selected tags" => "Con todas las marcas relacionadas",
"With one selected tag" => "Con una marca relacionada",
"With last selected tag" => "Con la última marca relacionada",
"More Popular Tags" => "Marcas más populares",
"Alphabetically" => "Alfabeticamente",
"By Size" => "Por Tamaño",
"Cloud" => "Nube",
// "{\$feature_label}" => "{\$feature_label}",
"No result found" => "No se han encontrado resultados",
"result found" => "resultado encontrado",
// "{\$objects[ix].type|replace:\"wiki page\":\"Wiki\"|replace:\"article\":\"Article\"|regex_replace:\"/tracker [0-9]*/\":\"tracker item\"}" => "{\$objects[ix].type|replace:\"wiki page\":\"Wiki\"|replace:\"article\":\"Article\"|regex_replace:\"/tracker [0-9]*/\":\"tracker item\"}",
"Browsing Gallery" => "Visitando Galería",
"List Galleries" => "Listar galerías",
"Edit Gallery" => "Editar galería",
"Rebuild Thumbnails" => "Reconstruir miniaturas",
"Upload Image" => "Subir imagen",
"Directory Batch" => "Directory batch",
"List Gallery" => "Listar la galería",
"All Images" => "Todas las Imágenes",
"RSS" => "RSS",
"Monitor this Gallery" => "Monitorizar esta galería",
"Stop Monitoring this Gallery" => "Dejar de monitorizar esta galería",
// "{\$advice}" => "{\$advice}",
"Sort Images by" => "Ordenar imágenes por",
"subgallery" => "subgalería",
"Subgallery" => "Subgalería",
"Original Size" => "Tamaño original",
"rotate right" => "rotar derecha",
"rotate" => "rotar",
"Details" => "Detalles",
"popup" => "popup",
// "You can view this gallery's configured image (first, random, etc.) in your browser using" => "You can view this gallery's configured image (first, random, etc.) in your browser using",
// "You can include the gallery's image in an HTML page using" => "You can include the gallery's image in an HTML page using",
// "You can include the image in a tiki page using" => "You can include the image in a tiki page using",
"Browsing Image" => "Visitando imagen",
"Return to Gallery" => "Volver a la galería",
"Edit Image" => "Editar imagen",
"First Image" => "Primer imágen",
"Prev Image" => "Imágen previa",
"Smaller" => "Menor",
"Bigger" => "Mayor",
"Popup window" => "Ventana popup ",
"Next Image" => "Próxima imágen",
"Slideshow Forward" => "Presentación adelante",
"Last Image" => "última imágen",
"Cyclic" => "Cíclico/a",
"Click to zoom" => "Clic para agrandar",
"Image Name" => "Nombre de la imagen",
"Image size" => "Tamaño de la imagen",
"Image Scale" => "Imagescale",
"Latitude (WGS84/decimal degrees)" => "Latitud (WGS84/grados decimales)",
"Longitude (WGS84/decimal degrees)" => "Longitud (WGS84/grados decimales)",
"Move image" => "Mover la imagen",
// "Include the image in a tiki page using the following syntax" => "Include the image in a tiki page using the following syntax",
// "To include the image in an HTML page" => "To include the image in an HTML page",
// "To link to this page from another tiki page" => "To link to this page from another tiki page",
"Stop Monitoring this Page" => "Dejar de monitorizar esta página",
"Monitor this Page" => "Monitorizar esta página",
"Export Calendars" => "Exporta Calendarios",
"Click to export calendars" => "Haz clic para exportar calendarios",
"Visible Calendars" => "Calendarios Visibles",
"Click to select visible calendars" => "Haz clic para seleccionar los calendarios visibles",
"Group Calendars" => "Calendarios Grupales",
"Export calendars" => "Exporta calendarios",
"advanced parameters" => "parámetros avanzados",
"Export as iCal" => "Exporta como iCal",
"January" => "Enero",
"February" => "Febrero",
"March" => "Marzo",
"April" => "Abril",
"May" => "Mayo",
"June" => "Junio",
"July" => "Julio",
"August" => "Agosto",
"September" => "Septiembre",
"October" => "Octubre",
"November" => "Noviembre",
"December" => "Diciembre",
"Jan" => "Ene",
// "Feb" => "Feb",
// "Mar" => "Mar",
"Apr" => "Abr",
// "Jun" => "Jun",
// "Jul" => "Jul",
"Aug" => "Ago",
// "Sep" => "Sep",
// "Oct" => "Oct",
// "Nov" => "Nov",
"Dec" => "Dic",
"Sun" => "Dom",
"Mon" => "Lun",
"Tue" => "Mar",
"Wed" => "Mié",
"Thu" => "Jue",
"Fri" => "Vie",
"Sat" => "Sáb",
"today" => "hoy",
"all-day" => "día-completo",
"Export event" => "Exporta evento",
"Edit event" => "Edita evento",
"Delete event" => "Borra evento",
"View event" => "Visualiza evento",
"Organized by" => "Organizado por",
"Classification" => "Clasificación",
"Tentative" => "Tentativo",
"Confirmed" => "Confirmado",
"Cancelled" => "Cancelado",
"View this Week" => "Visualiza esta semana",
"Change Focus" => "Cambiar foco",
"+" => "+",
"View this Day" => "Visualiza este día",
"o" => "ó",
"Calendar event : " => "Evento del calendario : ",
"New event" => "Nuevo evento",
"Edit/Delete event" => "Edita/Borra evento",
"Edit Calendar Item" => "Editar Ítem de Calendario",
"New Calendar Item" => "Nuevo Ítem de Calendario",
"Recurrence" => "Recurrencia",
"This event depends on a recurrence rule" => "Este evento depende de una regla de recurrencia",
"This event is not recurrent" => "Este evento no es recurrente",
"On a weekly basis" => "En base semanal",
"Each" => "Cada",
"of the week" => "de la semana",
"On a monthly basis" => "En base mensual",
"of the month" => "del mes",
"On a yearly basis" => "En base anual",
"Starting on" => "Empezando el",
"ending by" => "acabando el",
"ending after" => "acabando después de",
"events" => "eventos",
"Start period" => "Empieza período",
"End after" => "Acaba después de",
"occurrences" => "ocurrencias",
"occurrence" => "occurencia",
"End before" => "Acaba antes de",
"Event occurs once on" => "El evento ocurre una vez el",
"Event is repeated" => "El evento se repite",
"times" => "veces",
// "{\$daysnames[\$recurrence.weekday]}s" => "{\$daysnames[\$recurrence.weekday]}s",
"of every month" => "de cada mes",
"on each" => "en cada",
// "{\$monthnames[\$recurrence.dateOfYear_month]}" => "{\$monthnames[\$recurrence.dateOfYear_month]}",
"starting" => "empezando el",
"ending" => "acabando el",
"Show duration" => "Muestra la duración",
"Events cannot end before they start" => "Los eventos no pueden empezar antes de que acaben",
"No description" => "Sin descripción",
"or new" => "o nuevo/a",
"Choose users to alert" => "Escoge a qué usuarios alertar",
"Withdraw me from the list of participants" => "Sácame de la lista de partipantes",
"Add me to the list of participants" => "Añádeme a la lista de participantes",
"Participant names separated by comma" => "Nombres de participantes separados por comas",
"Roles" => "Roles",
// "chair" => "chair",
// "default role" => "default role",
// "required participant" => "required participant",
// "optional participant" => "optional participant",
// "non participant" => "non participant",
// "Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in" => "Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in",
// "role:login_or_email,login_or_email" => "role:login_or_email,login_or_email",
// "If no role is provided, default role will be \"Chair participant\"" => "If no role is provided, default role will be \"Chair participant\"",
"Update this event only" => "Actualizar sólo este evento",
"Update every unchanged events of this recurrence rule" => "Actualizar cada evento sin cambios de esta regla de recurrencia",
"Update every events of this recurrence rule" => "Actualizar todos los eventos de esta regla de recurrencia",
"Delete Recurrent events" => "Borrar los eventos recurrentes",
"Calendar import" => "Importar un calendario",
"Calendar has been updated" => "El calendario fue actualizado",
// "%0 column name can be used instead of %1" => "%0 column name can be used instead of %1",
"D" => "D",
"W" => "S",
"M" => "M",
// "%d/%m" => "%d/%m",
"%m/%d" => "%m/%d",
// "Advanced parameters for iCal export" => "Advanced parameters for iCal export",
"Calendars to be exported" => "Calendarios a exportar",
"Export calendars iCal" => "Exporta calendarios iCal",
"Export calendars CSV" => "Exporta calendarios CSV",
"Your account has been validated" => "Tu cuenta ha sido validada",
"You have to choose a password to use this account" => "Has de elegir una contraseña para usar esta cuenta",
"Change password enforced" => "Cambio de contraseña forzoso",
"Change your password" => "Cambia tu contraseña",
"Old password" => "Contraseña actual",
"New password" => "Nueva contraseña ",
// "Server Check" => "Server Check",
// "MySQL or MariaDB Database Properties" => "MySQL or MariaDB Database Properties",
// "Property" => "Property",
// "Tiki Fitness" => "Tiki Fitness",
// "Be careful" => "Be careful",
// "Server Information" => "Server Information",
// "Server Properties" => "Server Properties",
// "Fitness" => "Fitness",
// "Apache properties" => "Apache properties",
// "IIS properties" => "IIS properties",
// "PHP scripting language properties" => "PHP scripting language properties",
// "PHP Security properties" => "PHP Security properties",
// "MySQL Variable Information" => "MySQL Variable Information",
// "PHP Info" => "PHP Info",
"Please choose the language for this page" => "Por favor, elige idioma para esta página",
"Page: \"%0\"" => "Página: \"%0\"",
"Choose language" => "Elige idioma",
"Success" => "Éxito",
"Send a message to us" => "Envíanos un mensaje",
"Your email" => "Tu correo-e",
"Contact us by email" => "Contáctanos por correo",
"Click here to send us an email" => "Haz clic aquí para enviarnos un correo",
"Send another message" => "Envía otro mensaje",
"Contacts" => "Contactos",
// "Group View" => "Group View",
"Create/edit contacts" => "Crear/editar contactos",
"First Name" => "Nombre",
// "Publish this contact to groups" => "Publish this contact to groups",
"Last Name" => "Apellido",
"Nickname" => "Apodo",
// "Copy page" => "Copy page",
// "Invalid page name" => "Invalid page name",
// "The page name specified contains unallowed characters. It will not be possible to save the page until those are removed: <strong>%0</strong>" => "The page name specified contains unallowed characters. It will not be possible to save the page until those are removed: <strong>%0</strong>",
// "The page name specified contains characters that may render the page hard to access. You may want to consider removing those: <strong>%0</strong>" => "The page name specified contains characters that may render the page hard to access. You may want to consider removing those: <strong>%0</strong>",
// "Use this name anyway" => "Use this name anyway",
// "Quick Create Multilanguage Pages" => "Quick Create Multilanguage Pages",
// "Following pages were created, as translations of each other" => "Following pages were created, as translations of each other",
// "Following pages were not created" => "Following pages were not created",
// "page already exists" => "page already exists",
// "Enter the names of a new page page in various languages" => "Enter the names of a new page page in various languages",
// "Preferred languages" => "Preferred languages",
// "Other languages" => "Other languages",
// "Create pages" => "Create pages",
// "View generated WebHelp" => "View generated WebHelp",
// "No structure" => "No structure",
"Top page" => "Página principal",
"Add a new site" => "Añadir nuevo sitio",
"You cannot add sites until Directory Categories are setup." => "No puede añadir sitios hasta que las Categorias de Directorio esten configuradas.",
"Please contact the Site Administrator" => "Por favor contacte el Administrador del Sitio",
// "<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>" => "<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>",
"Site added" => "Sitio añadido",
// "The following site was added, but may require validation by the admin before appearing on the lists" => "The following site was added, but may require validation by the admin before appearing on the lists",
// "{\$msg}" => "{\$msg}",
// "Edit a site" => "Edit a site",
"Add a Site" => "Añadir un sitio",
// "Directory Categories" => "Directory Categories",
// "{\$countries[ux]}" => "{\$countries[ux]}",
"Directory Administration" => "Administración de Directorio",
"There are" => "Hay",
"invalid sites" => "sitios no válidos",
"valid sites" => "sitios válidos",
"Users have visited" => "Usuarios visitaron",
"sites from the directory" => "sitios desde el directorio",
"Users have searched" => "Usuarios buscaron",
"times from the directory" => "veces desde el directorio",
"Validate" => "Validar",
"Admin directory categories" => "Admin categorías de directorio",
// "Parent directory category" => "Parent directory category",
"Add a directory category" => "Añadir una categoría de directorio",
"Edit this directory category" => "Editar esta categoría de directorio",
// "Add a Directory Category" => "Add a Directory Category",
"Children type" => "Tipo de descendiente",
// "Most visited directory sub-categories" => "Most visited directory sub-categories",
// "Directory Category description" => "Directory Category description",
// "Random directory sub-categories" => "Random directory sub-categories",
"Maximum number of children to show" => "Número máximo de hijos a mostrar",
// "Allow sites in this directory category" => "Allow sites in this directory category",
// "Show number of sites in this directory category" => "Show number of sites in this directory category",
"Editor group" => "Grupo editor",
// "Directory Subcategories" => "Directory Subcategories",
"cType" => "cType",
"allow" => "permitir",
"count" => "cuenta",
"editor" => "editor",
"relate" => "relacionada",
// "Admin related directory categories" => "Admin related directory categories",
// "Add a related directory category" => "Add a related directory category",
// "Directory Category" => "Directory Category",
"Mutual" => "Mutual",
// "Related directory categories" => "Related directory categories",
"Admin sites" => "Admin sitios",
"Is valid" => "es válida",
"Perform action with selected" => "Realiza la acción con la selección",
"New Sites" => "Nuevos sitios",
"Cool Sites" => "Sitios cool",
"any" => "todos",
"in entire directory" => "en todo el directorio",
// "in current directory category" => "in current directory category",
"Sort by" => "Ordernar por",
// "Hits (desc)" => "Hits (desc)",
// "Hits (asc)" => "Hits (asc)",
// "Last updated (desc)" => "Last updated (desc)",
// "Last updated (asc)" => "Last updated (asc)",
"sort" => "ordenar",
"Last updated" => "Modificado",
"No records" => "Sin registros",
// "Total directory categories" => "Total directory categories",
"Total links" => "Total enlaces",
"Links to validate" => "Enlaces a validar",
"Searches performed" => "Búsquedas hechas",
"Total links visited" => "Total enlaces visitados",
"Directory ranking" => "Ranking de directorios",
"Validate sites" => "Validar sitios",
"country" => "país",
// "Discounts" => "Discounts",
// "Max time the discount can be used in the first phase of payment" => "Max time the discount can be used in the first phase of payment",
// "-1 for illimited" => "-1 for illimited",
// "Translation of this page is incomplete" => "Translation of this page is incomplete",
// "To add <strong>new content</strong> to the page" => "To add <strong>new content</strong> to the page",
// "use the editor" => "use the editor",
"Edit article" => "Editar artículo",
"View Articles" => "Ver artículos",
// "One of the email addresses you typed is invalid" => "One of the email addresses you typed is invalid",
"Topline" => "LineaTope",
// "To translate, do not change the language and the content.\n\t\t\t\t\t\tInstead, <a href=\"%0\">create a new translation</a> in the new language" => "To translate, do not change the language and the content.\n\t\t\t\t\t\tInstead, <a href=\"%0\">create a new translation</a> in the new language",
// "Edit Translations" => "Edit Translations",
// "Attach existing article ID as translation" => "Attach existing article ID as translation",
"Author Name" => "Nombre del autor",
// "{\$typei|escape}" => "{\$typei|escape}",
"Own Image" => "Imagen propia",
// "If not the topic image" => "If not the topic image",
"Article image" => "Imagen de Artículo",
"Use own image" => "Usar imagen propia",
"Float text around image" => "Texto flotante alrededor de la imagen",
// "Maximum dimensions of custom image in view mode (Read Article)" => "Maximum dimensions of custom image in view mode (Read Article)",
// "If different than the uploaded image" => "If different than the uploaded image",
// "Maximum dimensions of custom image in list mode (View Articles)" => "Maximum dimensions of custom image in list mode (View Articles)",
// "If different than in view mode" => "If different than in view mode",
"Image caption" => "Título de imagen",
// "If not the topic name" => "If not the topic name",
// "Allow full HTML" => "Allow full HTML",
// "Keep any HTML tag" => "Keep any HTML tag",
// "If not enabled, Tiki will retain some HTML tags (a, p, pre, img, hr, b, i)" => "If not enabled, Tiki will retain some HTML tags (a, p, pre, img, hr, b, i)",
// "Emails to be notified (separated with commas)" => "Emails to be notified (separated with commas)",
"Edit or create banners" => "Editar o crear banners",
"List banners" => "Listar banners",
"URL to link the banner" => "URL a dónde enlaza el banner",
"Client" => "Cliente",
"Max impressions" => "Impresiones máximas",
// "-1 for unlimited" => "-1 for unlimited",
// "Max impressions for a user" => "Max impressions for a user",
// "Max clicks" => "Max clicks",
// "URIs where the banner appears only" => "URIs where the banner appears only",
// "Type each URI enclosed with the # character. Exemple:#/this_page#/tiki-index.php?page=this_page#" => "Type each URI enclosed with the # character. Exemple:#/this_page#/tiki-index.php?page=this_page#",
// "URIs where the banner will not appear " => "URIs where the banner will not appear ",
// "Or, create a new zone" => "Or, create a new zone",
"Show the banner only between these dates" => "Mostrar el banner solo entre estas fechas",
"From date" => "Desde fecha",
"To date" => "Hasta fecha",
"Use dates" => "Usar fechas",
"Show the banner only in this hours" => "Mostrar el banner solo en este horario",
"Show the banner only on" => "Mostrar el banner solo en",
"Select ONE method for the banner" => "Seleccione UN método para el banner",
"Use HTML" => "Usar HTML",
"Use image" => "Usar imagen",
"Image:" => "Imagen:",
"Current Image" => "Imagen actual",
"Use image generated by URL (the image will be requested at the URL for each impression)" => "Usar contenido desde una URL (el contenido será descargado por cada impresión desde la URL indicada)",
// "Use Flash" => "Use Flash",
// "Movie Size" => "Movie Size",
// "Pixels" => "Pixels",
// "FlashPlugin min version" => "FlashPlugin min version",
// "ex" => "ex",
"Use text" => "Usar texto",
"Save the Banner" => "Guardar el banner",
"Remove Zones (you lose entered info for the banner)" => "Borrar Zonas (perderá información ingresada para el banner)",
"Edit Blog" => "Editar Blog",
// "A category is mandatory" => "A category is mandatory",
"There are individual permissions set for this blog" => "Hay permisios individuales configurados para este blog",
// "Allow other users to post in this blog" => "Allow other users to post in this blog",
// "If others post to blog, author should always be owner" => "If others post to blog, author should always be owner",
"Allow search" => "Permitir busqueda",
"Allow comments" => "Permitir comentarios",
// "Display Options" => "Display Options",
// "Number of posts to show per page" => "Number of posts to show per page",
// "Display blog title in posts list page" => "Display blog title in posts list page",
// "Display blog title in post page" => "Display blog title in post page",
// "Display blog description" => "Display blog description",
// "Display breadcrumbs" => "Display breadcrumbs",
// "Display author in blog posts" => "Display author in blog posts",
// "Display published date in blog posts" => "Display published date in blog posts",
"Show user avatar" => "Mostrar avatar de usuario",
// "Show post related content" => "Show post related content",
// "The checkbox is disabled because feature_freetags is disabled globally" => "The checkbox is disabled because feature_freetags is disabled globally",
// "Maximum number of related posts to display" => "Maximum number of related posts to display",
// "Use post excerpt" => "Use post excerpt",
"Blog heading" => "Encabezado del Blog",
// "Heading preview" => "Heading preview",
// "Blog post heading" => "Blog post heading",
// "Organizer" => "Organizer",
// "Move objects between categories" => "Move objects between categories",
// "Click on the category name you want to list. The list of objects in that category will become visible" => "Click on the category name you want to list. The list of objects in that category will become visible",
// "Select the objects you want to affect. Controls will appear in the category browser" => "Select the objects you want to affect. Controls will appear in the category browser",
// "Use the plus and minus signs to add or remove the categories on selected objects" => "Use the plus and minus signs to add or remove the categories on selected objects",
// "More results available. Please refine the search criterias" => "More results available. Please refine the search criterias",
// "Select all" => "Select all",
// "Unselect all" => "Unselect all",
"Edit Style Sheet" => "Editar Hoja de Estilo",
"Style Sheet" => "Hoja de Estilo",
// "The file will be saved in" => "The file will be saved in",
"choose a stylesheet" => "elija una hoja de estilo",
"Try" => "Probar",
// "Tiki Docs" => "Tiki Docs",
// "Save file" => "Save file",
// "Cancel editing file" => "Cancel editing file",
// "Editing file" => "Editing file",
// "Save and Back" => "Save and Back",
// "Toggle Fullscreen" => "Toggle Fullscreen",
// "For more information, please see" => "For more information, please see",
// "Wiki Page Editor" => "Wiki Page Editor",
// "More help on editing wiki pages" => "More help on editing wiki pages",
// "The syntax system used for creating pages in Tiki" => "The syntax system used for creating pages in Tiki",
// "Bold text" => "Bold text",
// "Italic text" => "Italic text",
// "single quotes" => "single quotes",
// "Underlined text" => "Underlined text",
"Colored text" => "Texto en colores",
// "Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background" => "Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background",
// "Deleted text" => "Deleted text",
// "2 dashes" => "2 dashes",
"Headings" => "Encabezados",
"show/hide heading section. + (shown) or - (hidden) by default" => "mostrar/ocultar sección de encabezados. + (mostrar) o - (ocultar) por defecto",
// "Autonumbered Headings" => "Autonumbered Headings",
// "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)",
// "Common optional parameters for maketoc are: title|maxdepth|levels|nums, and for toc are: order|showdesc|shownum|structId|maxdepth|pagename" => "Common optional parameters for maketoc are: title|maxdepth|levels|nums, and for toc are: order|showdesc|shownum|structId|maxdepth|pagename",
// "Horizontal rule" => "Horizontal rule",
// "Text box" => "Text box",
"Box content" => "Contenido de la caja",
// "Centered text" => "Centered text",
"Inserts an editable variable" => "Inserta una variable editable",
"External links" => "Enlaces externos",
// "use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)" => "use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)",
"For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))" => "Para un Wiki externo, use NombreExternoWiki:NombrePagina o ((Nombre Externo Wiki: Nombre Pagina))",
"Square Brackets" => "Paréntesis rectos",
"Use [[foo] to show [foo]." => "Usar [[foo] para mostrar [foo].",
"Wiki References" => "Referencias Wiki",
"JoinCapitalizedWords or use" => "JuntarPalabrasEnMayusculas o usar",
"page|description" => "página|desc",
"for wiki references" => "para referencias en el wiki",
// "page|#anchor" => "page|#anchor",
// "page|#anchor|desc" => "page|#anchor|desc",
// "for wiki heading/anchor references" => "for wiki heading/anchor references",
"SomeName" => "AlgúnNombre",
"prevents referencing" => "impide referenciar",
"Lists" => "Listas",
"for bullet lists" => "para listas de bullets",
"for numbered lists" => "para listas numeradas",
"definition" => "definición",
"for definiton lists" => "para listas de definiciones",
// "Indentation" => "Indentation",
// "Creates an indentation for each plus (useful in list to continue at the same level)" => "Creates an indentation for each plus (useful in list to continue at the same level)",
"Tables" => "Tablas",
// "row" => "row",
// "col" => "col",
// "Monospace font" => "Monospace font",
// "Code sample" => "Code sample",
// "(very useful especially in tables)" => "(very useful especially in tables)",
"Multi-page pages" => "Páginas multi-página",
// "to separate pages" => "to separate pages",
"Non parsed sections" => "Secciones no parseadas",
"data" => "datos",
"Prevents wiki parsing of the enclosed data." => "Previene el parseo del wiki de los datos encerrados.",
"Preformated sections" => "Secciones preformateadas",
// "~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text" => "~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text",
// "~tc~ Tiki Comment ~/tc~ makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  ~hc~ HTML Comment ~/hc~ makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar" => "~tc~ Tiki Comment ~/tc~ makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  ~hc~ HTML Comment ~/hc~ makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar",
"Block Preformatting" => "Preformateo de Bloque",
"Indent text with any number of spaces to turn it into a monospaced block that still follows other Wiki formatting instructions. It will be indended with the same number of spaces that you used.  Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that." => "Indente texto con un número de espacios para convertirlo en un bloque monoespaciado que sigue otras instrucciones de formateo de Wiki. Será indentado con el mismo número de espacios que use. Note que este modo no preserva espaciado exacto y saltos de línea, use ~pp~...~/pp~ para eso.",
// "Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew" => "Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew",
// "Special characters" => "Special characters",
// "hard space" => "hard space",
// "numeric between ~ for HTML numeric characters entity" => "numeric between ~ for HTML numeric characters entity",
"Plugin Help" => "Ayuda de Plugins",
"Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt" => "Fíjate que los argumentos de los plugins se pueden rodear de dobles comillas (&quot;); estos les permite contener , o = o &gt",
"More help here" => "Más ayuda aquí",
"Wiki plugins extend the function of wiki syntax with more specialized commands" => "Los plugings Wiki extienden la función de la sintaxis wiki con comandos más especializados",
"Activate/deactivate plugins" => "Activa/desactiva plugins",
"No description available" => "Sin descripción disponible",
// "Spreadsheet Creation" => "Spreadsheet Creation",
// "Spreadsheet Interface" => "Spreadsheet Interface",
// "Tiki uses jQuery.sheet for displaying spreadsheets, below you will see a list of usable functions and how to enhance how you use it" => "Tiki uses jQuery.sheet for displaying spreadsheets, below you will see a list of usable functions and how to enhance how you use it",
// "Wysiwyg Editor" => "Wysiwyg Editor",
// "More help on wysiwyg editing" => "More help on wysiwyg editing",
// "WYSIWYG in wiki mode is an experimental feature in Tiki 7+ and uses\n\t<a href=\"http://ckeditor.com\">CKEditor</a>" => "WYSIWYG in wiki mode is an experimental feature in Tiki 7+ and uses\n\t<a href=\"http://ckeditor.com\">CKEditor</a>",
// "To switch modes between WYSIWYG and Wiki edit modes click the {icon _id=\"pencil_go\"} button on the toolbar" => "To switch modes between WYSIWYG and Wiki edit modes click the {icon _id=\"pencil_go\"} button on the toolbar",
// "<strong>N.B. </strong>Using this button changes the editor between WYSIWYG and the usual wiki editor, but leaves the page source in wiki syntax" => "<strong>N.B. </strong>Using this button changes the editor between WYSIWYG and the usual wiki editor, but leaves the page source in wiki syntax",
// "Wiki plugins can be used and edited in WYSIWYG mode, double click the plugin to bring up the plugin edit popup form.<br />\n\tHere is an example of the {ldelim}BOX{rdelim} plugin" => "Wiki plugins can be used and edited in WYSIWYG mode, double click the plugin to bring up the plugin edit popup form.<br />\n\tHere is an example of the {ldelim}BOX{rdelim} plugin",
// "This is the text in the box which is justified; the box has a cream background, takes 80% of the screen width and is centred" => "This is the text in the box which is justified; the box has a cream background, takes 80% of the screen width and is centred",
// "<strong>Caution:</strong> This is a new feature and still work in progress.<br />\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br />\n\tCurrently (in Tiki 9.0) drag and drop of plugins in WYSIWYG does not work" => "<strong>Caution:</strong> This is a new feature and still work in progress.<br />\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br />\n\tCurrently (in Tiki 9.0) drag and drop of plugins in WYSIWYG does not work",
// "<strong>Admins:</strong><br />\n\t\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way.\n\t\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">wysiwyg admin page</a>.\n\t\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a>\n\t\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>" => "<strong>Admins:</strong><br />\n\t\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way.\n\t\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">wysiwyg admin page</a>.\n\t\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a>\n\t\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>",
// "The WYSIWYG editor in Tiki 6+ is\n\t<a href=\"http://ckeditor.com\">CKEditor</a>,\n\tthe new version of FCKEditor (used in Tiki since version 2.0)" => "The WYSIWYG editor in Tiki 6+ is\n\t<a href=\"http://ckeditor.com\">CKEditor</a>,\n\tthe new version of FCKEditor (used in Tiki since version 2.0)",
// "<strong>N.B. </strong>Using this button converts the page source from wiki to HTML, or vice versa.\n\tThe conversion process is not entirely transparent, meaning that you may notice differences between the look of a page in different modes.\n\tThis will improve in future updates but as the two systems have significant differences in what they can do it is unlikely to ever be totally transparent" => "<strong>N.B. </strong>Using this button converts the page source from wiki to HTML, or vice versa.\n\tThe conversion process is not entirely transparent, meaning that you may notice differences between the look of a page in different modes.\n\tThis will improve in future updates but as the two systems have significant differences in what they can do it is unlikely to ever be totally transparent",
// "<strong>Caution:</strong> This is a new feature and still work in progress.<br />\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br />\n\tCurrently (still in Tiki 9.0) drag and drop of plugins in WYSIWYG does not work" => "<strong>Caution:</strong> This is a new feature and still work in progress.<br />\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br />\n\tCurrently (still in Tiki 9.0) drag and drop of plugins in WYSIWYG does not work",
"Browse Images" => "Ver imágen",
"Edit successful!" => "Editado exitosamente",
"The following image was successfully edited" => "La siguiente imagen fue editada exitosamente",
"Image Description" => "Descripción",
// "Upload from disk to change the image" => "Upload from disk to change the image",
// "Save and Go Next" => "Save and Go Next",
// "Edit Invoice" => "Edit Invoice",
// "Invoice Number" => "Invoice Number",
// "Date Issued" => "Date Issued",
// "Work Description" => "Work Description",
// "Taxable" => "Taxable",
// "New Item" => "New Item",
// "Invoice Note" => "Invoice Note",
// "Save Invoice" => "Save Invoice",
// "Edit or export languages" => "Edit or export languages",
"Edit languages" => "Editar idiomas",
"Select the language to edit" => "Elija lenguaje a editar",
"Add a translation" => "Añadir traducción",
"Edit translations" => "Editar traducción",
// "Show only database stored translations" => "Show only database stored translations",
// "Untranslated strings" => "Untranslated strings",
// "Show only database stored untranslated strings" => "Show only database stored untranslated strings",
"Original" => "Original",
// "Original translation" => "Original translation",
// "Last changed by %0 on %1" => "Last changed by %0 on %1",
"Translate all" => "Tradúcelo todo",
"Delete all" => "Bórralo todo",
// "Are you sure you want to delete all untranslated strings from database" => "Are you sure you want to delete all untranslated strings from database",
// "Are you sure you want to delete all translations from database" => "Are you sure you want to delete all translations from database",
// "Export languages" => "Export languages",
// "No translations in the database available to export. First translate strings using interactive translation or \"Edit languages\" tab" => "No translations in the database available to export. First translate strings using interactive translation or \"Edit languages\" tab",
"Select the language to Export" => "Elija el lenguaje a exportar",
// "If you click \"Download database translations\", you will download a file with all the translations in the database" => "If you click \"Download database translations\", you will download a file with all the translations in the database",
// "If you click \"Write to language.php\", the translations in the database will be merged with the other translations in language.php. Note that after writing translations to language.php they are removed from the database" => "If you click \"Write to language.php\", the translations in the database will be merged with the other translations in language.php. Note that after writing translations to language.php they are removed from the database",
// "To be able to write your translations back to language.php make sure that the web server has write permission in the lang/ directory" => "To be able to write your translations back to language.php make sure that the web server has write permission in the lang/ directory",
// "Download database translations" => "Download database translations",
// "Write to language.php" => "Write to language.php",
// "Return to default perspective" => "Return to default perspective",
// "Switch to" => "Switch to",
// "Configurations" => "Configurations",
// "Search for configurations below and drag them in to the configuration section above" => "Search for configurations below and drag them in to the configuration section above",
"Program dynamic content for block" => "Programar contenido dinámico para el bloque",
"Create New Block" => "Crear nuevo bloque",
"Return to block listing" => "Volver a la lista de bloques",
"Block description: " => "Descripción del bloque: ",
"You are editing block:" => "Está editando el bloque:",
"Publishing date" => "Fecha de publicación",
"Publishing Date" => "Fecha de Publicación",
"Edit question options" => "Editar opciones de pregunta",
"List Quizzes" => "Listar Cuestionarios",
"Quiz Stats" => "Estadísticas de Cuestionarios",
"This Quiz Stats" => "Estadísticas de este cuestionario",
"Edit this Quiz" => "Editar este cuestionario",
"Admin Quizzes" => "Admin cuestionarios",
"Create/edit options for question" => "Crear/editar opciones para pregunta",
"points" => "puntos",
"Quiz" => "Cuestionario",
"canRepeat" => "puedeRepetir",
"timeLimit" => "tiempoLimite",
"Create/edit quizzes" => "Crear/editar cuestionarios",
"There are individual permissions set for this quiz" => "Existen permisos individuales para este cuestionario",
"Quiz can be repeated" => "El cuestionario puede repetirse",
"Store quiz results" => "Guardar resultados de este cuestionario",
"Quiz is time limited" => "El cuestionario tiene un tiempo límite",
"Maximum time" => "Tiempo máximo",
"Passing Percentage" => "Por ciento de pasado",
"%" => "%",
"Edit quiz questions" => "Editar preguntas de cuestionario",
"Create/edit questions for quiz" => "Crear/editar preguntas para cuestionario",
"Question Type" => "Tipo de Pregunta",
"Import questions from text" => "Importar preguntas desde texto",
"Instructions: Type, or paste, your multiple choice questions below.  One line for the question, then start answer choices on subsequent lines.  Separate additional questions with a blank line.  Indicate correct answers by starting them with a \"*\" (without the quotes) character." => "Instrucciones: Escriba o pegue sus preguntas de múltiple opcion debajo. Una línea para la pregunta, después comienzan las opciones de respuesta en las líneas subsiguientes. Separe preguntas adicionales con líneas en blanco. Indique respuestas correctas comenzándolas con un carácter \"*\" (sin las comillas).",
"Input" => "Entrada",
"maxScore" => "Puntuación máxima",
// "Edit quiz results" => "Edit quiz results",
"From Points" => "Desde puntos",
"To Points" => "Hasta puntos",
// "Report Builder" => "Report Builder",
// "Report Type" => "Report Type",
// "Select Report Type" => "Select Report Type",
// "Wiki Data" => "Wiki Data",
// "Export As CSV" => "Export As CSV",
"Modify Structure" => "Modificar Estructura",
"You will remove" => "Usted borrará",
"and its subpages from the structure, now you have two options:" => "y sus subpáginas de la estructura, ahora tiene dos opciones:",
// "and its subpages from the structure" => "and its subpages from the structure",
// "\n\t\t\tRemove only from structure" => "\n\t\t\tRemove only from structure",
// "\n\t\t\t\tRemove from structure and remove page too" => "\n\t\t\t\tRemove from structure and remove page too",
// "The page already exists. The page that has been added to the structure is the existing one" => "The page already exists. The page that has been added to the structure is the existing one",
// "The following pages added have automatically been categorized with the same categories as the structure" => "The following pages added have automatically been categorized with the same categories as the structure",
"Structure Layout" => "Diseño de la Estructura",
"Add pages" => "Añade páginas",
"Use pre-existing page by dragging into the structure above" => "Usa páginas pre-existentes pinchando y arrastrándolas a la estructura de arriba",
// "{\$catix.categpath}" => "{\$catix.categpath}",
// "Categorize all pages in structure together" => "Categorize all pages in structure together",
// "Remove existing categories from ALL pages before recategorizing" => "Remove existing categories from ALL pages before recategorizing",
"Move to another structure" => "Mueve a otra estructura",
"at the beginning" => "al principio",
"at the end" => "al final",
"Submit article" => "Enviar artículo",
"List Submissions" => "Listar colaboraciones",
"Use ...page... to separate pages in a multi-page post" => "Usa ...page... para separar páginas en un post multi-página",
"<b>*</b>=optional" => "<b>*</b>=opcional",
"<b>Topline</b>=small line above Title" => "<b>Topline</b>=pequeña línea sobre el Título",
"<b>Subtitle</b>=small line below Title" => "<b>Subtítulo</b>=pequeña línea debajo de Título",
"<b>Source</b>=URL to article source" => "<b>Origen</b>=URL del artículo fuente",
"Own image size x" => "Imagen propia tamaño x",
"Own image size y" => "Imagen propia tamaño y",
"Submit Article" => "Envía el Artículo",
"Auto-Approve Article" => "Auto-Aprueba el Artículo",
"View template" => "Ver plantilla",
"Edit template" => "Editar plantilla",
"Edit templates" => "Editar plantillas",
"Template listing" => "Lista de plantillas",
"Available templates" => "Plantillas disponibles",
"Important" => "Importante",
// "If you edit this (or any TPL) file via the built-in editor below, any JavaScript may be sanitized or completely stripped out \n\t\t\t\t\tby Tiki security filtering, which would cause certain functions to stop working (e.g. menus no longer collapse or expand)" => "If you edit this (or any TPL) file via the built-in editor below, any JavaScript may be sanitized or completely stripped out \n\t\t\t\t\tby Tiki security filtering, which would cause certain functions to stop working (e.g. menus no longer collapse or expand)",
// "You should only modify default header.tpl and other important files via a text code editor, through console, \n\t\t\t\t\tor SSH, or FTP edit commands--and only if you know what you are doing! ;-)" => "You should only modify default header.tpl and other important files via a text code editor, through console, \n\t\t\t\t\tor SSH, or FTP edit commands--and only if you know what you are doing! ;-)",
// "Extensive customizations can be made safely through the <a href=\"tiki-admin.php?page=look\" class=\"titletips\" \n\t\t\t\t\ttitle=\"Look & Feel\">Look & Feel</a> admin panel custom code or general layout areas" => "Extensive customizations can be made safely through the <a href=\"tiki-admin.php?page=look\" class=\"titletips\" \n\t\t\t\t\ttitle=\"Look & Feel\">Look & Feel</a> admin panel custom code or general layout areas",
// "To be safe and to make upgrades easier, it is recommended that you create a custom theme before modifying tpl files.\n\t\t\t\t\tSee <a href=\"http://doc.tiki.org/Customizing+Themes\" class=\"titletips\" title=\"Customizing Themes help page\">\n\t\t\t\t\tdoc.tiki.org/Customizing+Themes</a> for how to do that" => "To be safe and to make upgrades easier, it is recommended that you create a custom theme before modifying tpl files.\n\t\t\t\t\tSee <a href=\"http://doc.tiki.org/Customizing+Themes\" class=\"titletips\" title=\"Customizing Themes help page\">\n\t\t\t\t\tdoc.tiki.org/Customizing+Themes</a> for how to do that",
// "Save Only in the Theme" => "Save Only in the Theme",
// "Delete the copy in the theme" => "Delete the copy in the theme",
// "Edit topic" => "Edit topic",
// "Notification Email" => "Notification Email",
// "Admin notifications" => "Admin notifications",
// "View Page" => "View Page",
// "View Article" => "View Article",
"You must specify the object language" => "Debe especificar el lenguaje del objeto",
"The object doesn't exist" => "El objeto no existe",
"The object doesn't have a language" => "El objeto no tiene un lenguaje",
"The object has already a translation for this language" => "El objeto ya tiene una traducción para este lenguaje",
"The object is already in the set of translations" => "El conjunto ya está en el conjunto de traducciones",
// "Translate updates made on this page or one of its translations" => "Translate updates made on this page or one of its translations",
// "Translate this page to a new language" => "Translate this page to a new language",
// "Attach or detach existing translations of this page" => "Attach or detach existing translations of this page",
// "Change language for this page" => "Change language for this page",
// "Select language to translate to" => "Select language to translate to",
// "Enter the page title" => "Enter the page title",
// "Below, assign categories to this new translation (Note: they should probably be the same as the categories of the page being translate)" => "Below, assign categories to this new translation (Note: they should probably be the same as the categories of the page being translate)",
// "Create translation" => "Create translation",
// "\"You forgot to specify the language of the translation. Please choose a language in the picklist.\"" => "\"You forgot to specify the language of the translation. Please choose a language in the picklist.\"",
// "\"The page already exists. It was selected in the list below.\"" => "\"The page already exists. It was selected in the list below.\"",
// "Change Language" => "Change Language",
// "No language is assigned to this page" => "No language is assigned to this page",
// "Please select a language before performing translation" => "Please select a language before performing translation",
// "Set Current Page's Language" => "Set Current Page's Language",
// "Manage translations" => "Manage translations",
// "{\$customTip|escape}" => "{\$customTip|escape}",
// "Update '{\$page}'" => "Update '{\$page}'",
// "Draft written on" => "Draft written on",
// "Warning: new versions of this page have been made after this draft" => "Warning: new versions of this page have been made after this draft",
"The SandBox is a page where you can practice your editing skills, use the preview feature to preview the appearance of the page, no versions are stored for this page." => "El SandBox es una página de donde puede practicar su edición, use la vista previa para ver la apariencia de la página, no seran guardaran versiones para esta página.",
// "An edit summary is mandatory" => "An edit summary is mandatory",
// "Translate from" => "Translate from",
// "Changes that need to be translated are highlighted below" => "Changes that need to be translated are highlighted below",
// "No comment" => "No comment",
// "All Versions" => "All Versions",
// "Select the style used to display differences to be translated" => "Select the style used to display differences to be translated",
// "html" => "html",
// "text full" => "text full",
// "Change the style used to display differences to be translated" => "Change the style used to display differences to be translated",
// "Change diff styles" => "Change diff styles",
"Translate to" => "Traduce a",
"Reproduce the changes highlighted on the left using the editor below" => "Reproduce los cambios destacados en la izquierda usando el editor de debaj",
"Describe the change you made" => "Describe el cambio que has hecho",
"Edit comment: Enter some text to describe the changes you are currently making" => "Comentario de edición: Introduce un texto para describir los cambios que estás haciendo actualmente",
"Monitor this page" => "Sigue esta página por correo-e",
"Upload picture" => "Subir imagen",
"Add another image" => "Añade otra imagen",
// "Categorization has been preset for this edit" => "Categorization has been preset for this edit",
// "Categories will be inherited from the structure top page" => "Categories will be inherited from the structure top page",
// "{\$templates[ix].name|escape}" => "{\$templates[ix].name|escape}",
"Admin Content Templates" => "Admin plantillas de contenido",
// "Lock this page" => "Lock this page",
// "Allow comments on this page" => "Allow comments on this page",
"Try to convert HTML to wiki" => "Intentar convertir HTML a wiki",
"Import page" => "Importar página",
"export all versions" => "exportar todas las versiones",
// "Only cache a page if it should look the same to all groups authorized to see it" => "Only cache a page if it should look the same to all groups authorized to see it",
"Manage structures" => "Gestionar estructuras",
"License" => "Licencia",
// "{\$prefs.wikiLicensePage}" => "{\$prefs.wikiLicensePage}",
// "{\$prefs.wikiSubmitNotice}" => "{\$prefs.wikiSubmitNotice}",
// "Authors' style" => "Authors' style",
// "Description (used for metatags)" => "Description (used for metatags)",
"My Footnotes" => "Notas al pie",
"Use rating" => "Usar calificaciones",
// "{\$template.title|escape}" => "{\$template.title|escape}",
"There is no available poll template." => "No hay plantilla disponible de votación.",
"You should ask an admin to create them." => "Debe pedirle al administrador que las cree.",
// "\"}To translate, do not change the language and the content.\n\t\t\t\t\t\t\t\t\tInstead, <a href=\"%0\">create a new translation</a> in the new language" => "\"}To translate, do not change the language and the content.\n\t\t\t\t\t\t\t\t\tInstead, <a href=\"%0\">create a new translation</a> in the new language",
// "Translation request" => "Translation request",
// "Send urgent translation request" => "Send urgent translation request",
// "Admin wiki preferences" => "Admin wiki preferences",
// "{\$title}" => "{\$title}",
"List Sheets" => "Listar hojas",
// "Graph" => "Graph",
// "Export to file" => "Export to file",
// "Autodetect" => "Autodetect",
"Admin FAQ" => "Admin FAQ",
"List FAQs" => "Listar FAQs",
"View FAQ" => "Ver FAQ",
"Edit this FAQ" => "Editar esta FAQ",
"New Question" => "Nueva pregunta",
// "Edit FAQ question" => "Edit FAQ question",
// "Add FAQ question" => "Add FAQ question",
"Use a question from another FAQ" => "Usar pregunta de otra FAQ",
"FAQ questions" => "Preguntas frecuentes",
"Suggested questions" => "Preguntas sugeridas",
"No suggested questions" => "No hay preguntas sugeridas",
// "File Archive" => "File Archive",
"Upload File" => "Subir archivo",
"File Galleries tpl" => "Galerías de Archivos tpl",
// "Be careful to set the right permissions on the files you link to" => "Be careful to set the right permissions on the files you link to",
"You can access the file gallery using the following URL" => "Puede acceder a la galería usando esta URL",
// "Size (width x height)" => "Size (width x height)",
// "Newer content available" => "Newer content available",
// "You are currently viewing the latest version of the page" => "You are currently viewing the latest version of the page",
// "You can also view the {self_link}latest approved version{/self_link}" => "You can also view the {self_link}latest approved version{/self_link}",
// "You can approve this revision and make it available to a wider audience. Make sure you review all the changes before approving" => "You can approve this revision and make it available to a wider audience. Make sure you review all the changes before approving",
// "Show changes since last approved revision" => "Show changes since last approved revision",
// "This page has no prior approved revision. <strong>All of the content must be reviewed.</strong>" => "This page has no prior approved revision. <strong>All of the content must be reviewed.</strong>",
// "Approve current revision" => "Approve current revision",
// "Content waiting for approval" => "Content waiting for approval",
// "You are currently viewing the approved version of the page" => "You are currently viewing the approved version of the page",
// "You can also view the {self_link latest=1}latest version{/self_link}" => "You can also view the {self_link latest=1}latest version{/self_link}",
// "View the {self_link latest=1}latest version{/self_link}" => "View the {self_link latest=1}latest version{/self_link}",
// "Forum Importer" => "Forum Importer",
"Admin forums" => "Admin foros",
// "Import from a Local SQL File" => "Import from a Local SQL File",
// "Forum Type" => "Forum Type",
// "DB Prefix" => "DB Prefix",
// "Local SQL Filename on Server (path will be stripped)" => "Local SQL Filename on Server (path will be stripped)",
// "Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up" => "Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up",
// "Get Forum List" => "Get Forum List",
// "Verification" => "Verification",
// "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>" => "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>",
// "File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred" => "File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred",
// "Proceed" => "Proceed",
// "Go Back" => "Go Back",
// "Select a Forum You Wish to Move (ONE at a time!)" => "Select a Forum You Wish to Move (ONE at a time!)",
// "Which Forum Do You Wish to Import this Into" => "Which Forum Do You Wish to Import this Into",
// "Message queue for forum" => "Message queue for forum",
// "Back to forum" => "Back to forum",
"Edit queued message" => "Editar mensajes en cola",
"make this a thread of" => "hacer de ésto un hilo",
"None, this is a thread message" => "Ninguno, éste es un mensaje de un hilo",
"summary" => "sumario",
"Announce" => "Anuncio",
"Hot" => "Hot",
"no feeling" => "sin emoción",
"frown" => "ceño",
"exclaim" => "exclamar",
"idea" => "idea",
"neutral" => "neutral",
"question" => "pregunta",
"happy" => "contento",
"wink" => "guiño",
"Save and Approve" => "Salve y apruebe",
"convert to topic" => "convertir a tema",
"List of messages" => "Lista de mensajes",
"Topic:" => "Tema:",
"New Topic" => "Nuevo tema",
"no summary" => "sin sumario",
"No messages queued yet" => "Sin mensajes en cola aún",
"Search by name" => "Busca por nombre de foro",
"Search in content" => "Busca en el contenido de los foros",
"Last Post" => "último mensaje",
"Configure Forum" => "Configurar foro",
// "Reported messages for forum" => "Reported messages for forum",
"Reported by" => "Reportado por",
// "Perfom action with checked" => "Perfom action with checked",
// "Un-report" => "Un-report",
// "Tag translation" => "Tag translation",
// "Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag" => "Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag",
// "Until then, they cannot be translated" => "Until then, they cannot be translated",
// "Show checkboxes to clear language information on tags" => "Show checkboxes to clear language information on tags",
"Previous" => "Previo",
// "There are no tags on this page in your preferred languages" => "There are no tags on this page in your preferred languages",
// "Set language" => "Set language",
// "Universal" => "Universal",
// "Show the following languages" => "Show the following languages",
"Pending requests" => "Pedidos pendientes",
"Request Time" => "Hora de pedido",
"Accept" => "Aceptado",
"Refuse" => "Rechazar",
"Waiting requests" => "Pedidos en espera",
// "Cancel friendship request" => "Cancel friendship request",
"Your friends" => "Sus amigos",
"break friendship" => "romper amistad",
"Galleries" => "Galerías",
"Create New Gallery" => "Crear nueva galería",
"Create a gallery" => "Crear una galería",
"Edit this gallery:" => "Editar esta galería:",
"There are individual permissions set for this gallery" => "Hay permisos individuales configurados para esta galería",
"Gallery is visible to non-admin users?" => "¿Galería visible para usuarios no-admin?",
"Geographic" => "Geográfico",
"Fields to show during browsing the gallery" => "Campos a mostrar mientras se recorre la galería",
"XY-Size" => "XY-Size",
"Gallery Image" => "Imagen de Galería",
"Available scales" => "Escalas disponibles",
// "Global default" => "Global default",
"Bounding box" => "Bounding box",
"default scale" => "escala por defecto",
"No scales available" => "No hay escalas disponibles",
"Original image is default scale" => "Imagen original es la escala por defecto",
"Add scaled images with bounding box of square size" => "Agregar imágenes escaladas con cajas vinculadores de tamaño cuadrado",
"Other users can upload images to this gallery" => "Permitir a otros usuarios añadir imágenes en esta galería",
"You can access the gallery using the following URL" => "Puede acceder a la galería usando la URL",
"Available Galleries" => "Galerías disponibles",
"Choose a filter" => "Elija un filtro",
"Imgs" => "Imgs",
"Make Map" => "Hacer Mapa",
// "Google Map Locator" => "Google Map Locator",
// "Back to preferences" => "Back to preferences",
// "enter address" => "enter address",
// "Find address" => "Find address",
// "Save clicked point" => "Save clicked point",
// "Reset view to default" => "Reset view to default",
// "Save current view as default" => "Save current view as default",
// "Center map to saved point" => "Center map to saved point",
// "Reset view to site default" => "Reset view to site default",
// "Users Map" => "Users Map",
// "Select Graphic Type" => "Select Graphic Type",
// "Pie Chart" => "Pie Chart",
// "Multiline" => "Multiline",
// "Multibar" => "Multibar",
// "Bar Stack" => "Bar Stack",
// "Landscape" => "Landscape",
// "Portrait" => "Portrait",
// "Independant Scale" => "Independant Scale",
// "Horizontal Scale" => "Horizontal Scale",
// "Vertical Scale" => "Vertical Scale",
// "Series" => "Series",
// "Edit Spreadsheet" => "Edit Spreadsheet",
// "List Spreadsheets" => "List Spreadsheets",
// "Wiki plug-in" => "Wiki plug-in",
// "Spreadsheet History" => "Spreadsheet History",
// "Clone" => "Clone",
"Rollback" => "Rollback",
"Toggle Full Screen" => "Conmuta la pantalla completa",
// "Date Selection" => "Date Selection",
// "Edit Date" => "Edit Date",
// "View Spreadsheet" => "View Spreadsheet",
// "Clone Spreadsheet" => "Clone Spreadsheet",
// "Roll Back Spreadsheet" => "Roll Back Spreadsheet",
// "Roll-Back" => "Roll-Back",
// "Ical import / Export" => "Ical import / Export",
// "Select The calendar to export" => "Select The calendar to export",
// "Calendar Import" => "Calendar Import",
// "ICal File" => "ICal File",
"Import From File" => "Importar Desde Archivo",
"Grab Wiki Tables" => "Obtener Tablas Wiki",
"Import pages from a Structured Text Dump" => "Importar páginas desde Volcado de Texto Estructurado",
"Name of the dump file (it has to be in dump/)" => "Nombre del archivo de volcado (tiene que estar en dump/)",
"Overwrite existing pages if the name is the same" => "Sobrescribir páginas si el nombre coincide",
"Previously remove existing page versions" => "Borrar versiones de páginas existentes previamente",
"excerpt" => "desc",
"Result" => "Resultado",
"body" => "cuerpo",
// "Or" => "Or",
// "Name of the zip file on the server" => "Name of the zip file on the server",
// "Tiki Importer" => "Tiki Importer",
// "If you are NOT running a new Tiki installation, make a backup of your database before using this importer" => "If you are NOT running a new Tiki installation, make a backup of your database before using this importer",
// "If your pages contain XML code, the HTML purifier will delete it. Deactivate this feature" => "If your pages contain XML code, the HTML purifier will delete it. Deactivate this feature",
// "Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibility to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode" => "Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibility to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode",
// "Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)" => "Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)",
// "Select the software to import from" => "Select the software to import from",
// "WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button" => "WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button",
// "Congratulations! You have successful imported your data to Tiki" => "Congratulations! You have successful imported your data to Tiki",
// "%0 pages imported from a total of %1" => "%0 pages imported from a total of %1",
// "%0 pages imported" => "%0 pages imported",
// "(you can see the list of wiki pages in your site <a href=\"tiki-listpages.php\">here</a>)" => "(you can see the list of wiki pages in your site <a href=\"tiki-listpages.php\">here</a>)",
// "%0 posts imported" => "%0 posts imported",
// "%0 tags imported" => "%0 tags imported",
// "%0 categories imported" => "%0 categories imported",
// "Importer log" => "Importer log",
// "Suggested .htaccess rules" => "Suggested .htaccess rules",
// "Locked by %0" => "Locked by %0",
"Tiki installer" => "Instalador de Tiki",
"Welcome" => "Bienvenido",
"Welcome to the Tiki installation and upgrade script" => "Bienvenido al script de instalación y actualización de Tiki",
"Use this script to install a new Tiki database or upgrade your existing database to release" => "Utilice este script para instalar una nueva base de datos Tiki o para actualizar su base de datos actual a la versión",
"For the latest information about this release, please read the" => "Para la última información sobre esta versión, por favor consulte las",
"Release Notes" => "Notas de la Versión",
"For complete documentation, please visit" => "Para una documentación más completa, por favor visite",
"For more information about Tiki, please visit" => "Para más información sobre Tiki, por favor visite",
"Select your language" => "Seleccione su lenguaje",
"Read the License" => "Leer la Licencia",
"Tiki is software distributed under the LGPL license" => "Tiki es un software distribuído bajo la licencia LGPL",
"Review the System Requirements" => "Revisar los Requisitos del Sistema",
"Review" => "Revisión",
"Before installing Tiki, <a href=\"http://doc.tiki.org/Requirements\" target=\"_blank\">review the documentation</a> and confirm that your system meets the minimum requirements" => "Antes de instalar Tiki, <a href=\"http://doc.tiki.org/Requirements\" target=\"_blank\">revisa la documentación</a> y confirma que tu sistema cumple con los requisitos mínimos",
"This installer will perform some basic checks automatically" => "Este instalador realizará algunas comprobaciones básicas",
// "Please see: " => "Please see: ",
// "a detailed report about your server" => "a detailed report about your server",
"Tiki has not detected your PHP memory_limit" => "Tiki no ha podido detectar su límite de memoria PHP (memory_limit)",
"This probably means you have no set limit (all is well)" => "Esto probablemente signifique que usted no ha especificado in límite (perfecto!)",
"Tiki has detected your PHP memory limit at" => "Tiki ha detectado que su límite de memoria PHP (memory limit) es",
// "Tiki requires <strong>at least</strong> 128MB of PHP memory for script execution" => "Tiki requires <strong>at least</strong> 128MB of PHP memory for script execution",
"Allocating too little memory will cause Tiki to display blank pages" => "Asignar poca memoria causará que Tiki muestre páginas en blanco",
// "To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 128M) and restart your webserver" => "To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 128M) and restart your webserver",
"Tiki has detected your PHP memory_limit at" => "Tiki ha detectado que su límite de memoria PHP (memory limit) es",
"Tiki uses the PHP <strong>mail</strong> function to send email notifications and messages" => "Tiki utiliza la función de PHP <strong>mail</strong> para enviar notificaciones y mensajes por email",
"To test your system configuration, Tiki will attempt to send a test message to you" => "Para probar la configuración de su sistema, Tiki intentará enviarte un mensaje de prueba",
"Test email" => "Correo-e para la prueba",
"Email address to send test to" => "Dirección de correo-e a la que enviar la prueba",
"Copy test mail to " => "¿Copia el mensaje de prueba a ",
"Send Test Message" => "Enviar Mensaje de Prueba",
"Tiki was able to send a test message to" => "Tiki ha podido enviar el mensaje de prueba a",
"Tiki was not able to send a test message" => "Tiki no pudo enviar el mensaje de prueba",
"Review your mail log for details" => "Revise sus logs del mail para más detalles",
"Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)" => "Revise las configuración de mail en su fichero <strong>php.ini</strong> (por ejemplo: confirme que <strong>sendmail_path</strong> es correcto)",
"If your host requires SMTP authentication, additional configuration may be necessary" => "Si su servidor requiere de autenticación por SMTP, puede que necesite realizar alguna configuración adicional",
"Image Processing" => "Procesado de Imágenes",
"Tiki detected" => "Tiki detectó",
"Tiki can create images" => "Tiki puede crear imágenes",
"Tiki was not able to create a sample image. Please check your GD library configuration" => "Tiki no ha podido crear una imagen de prueba. Por favor, comprueba la configuración de a librería GD",
"Tiki was not able to detect the GD library" => "Tiki no pudo detectar la librería GD",
"Tiki uses the GD library to process images for the Image Gallery and CAPTCHA support" => "Tiki utiliza la librería GD para procesar las imágenes en las Galerías de Imágenes y para el soporte de CAPTCHA",
"Set the Database Connection" => "Configurar Conexión con la Base de Datos",
"Tiki requires an active database connection" => "Tiki necesita una conexión activa a una base de datos",
"You must create the database and user <em>before</em> completing this page" => "Usted debe crear una base de datos y un usuario <em>antes</em> de completar este paso de la instalación",
"Tiki cannot find a database connection" => "Tiki no puede encontrar una conexión a la base de datos",
"This is normal for a new installation" => "Esto es lo normal en una nueva instalación",
"Tiki found an existing database connection in your local.php file" => "Tiki encontró una conexión existente a la base de datos en su fichero local.php file",
"Database name: &quot;%0&quot" => "Nombre de la Base de Datos: &quot;%0&quot",
"Use Existing Connection" => "Utilizar Conexión Existente",
"Modify database connection" => "Modifica la conexión a la base de datos",
"Use this page to create a new database connection, or use the <a href=\"http://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>" => "Usa esta página para crear una conexión nueva a base de datos, o usa el <a href=\"http://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">proceso de instalación manual</a>",
"Database information" => "Información de la Base de Datos",
"Enter your database connection information" => "Introduzca la información de su conexión con la base de datos",
"Database type" => "Tipo de base de datos",
"Select the type of database to use with Tiki" => "Seleccione el tipo de base de datos para utilizar con Tiki",
"Only databases supported by your PHP installation are listed here. If your database is not in the list, try to install the appropriate PHP extension" => "Únicamente las bases de datos soportadas por su instalación de PHP son listadas aquí. Si su base de datos no está en la lista, intente instalar la extensión de PHP apropiada",
"Host name" => "Nombre del Servidor",
"Enter the host name or IP for your database" => "Introduzca el nombre del servidor o la dirección IP para su base de datos",
"Use <strong>localhost</strong> if the database is running on the same machine as Tiki" => "Utilize <strong>localhost</strong> si la base de datos se encuentra en el mismo servidor que Tiki",
// "For non-default port number use <strong>example.com;port=3307</strong>" => "For non-default port number use <strong>example.com;port=3307</strong>",
"Database name" => "Nombre de la Base de datos",
"Enter the name of the database that Tiki will use (if already created) or create (if permitted)" => "Introduzca el nombre de la base de datos que Tiki usará (si ya existe) o que creará (si tiene permisos)",
// "You can create the database using mysqladmin, phpMyAdmin, cPanel, or ask your hosting provider. If the database doesn't exist and the supplied username has permissions, the database will be created" => "You can create the database using mysqladmin, phpMyAdmin, cPanel, or ask your hosting provider. If the database doesn't exist and the supplied username has permissions, the database will be created",
// "If you are using a database which is already being used for something else (not recommended), check db/tiki.sql to make sure the table names used by Tiki are not already used" => "If you are using a database which is already being used for something else (not recommended), check db/tiki.sql to make sure the table names used by Tiki are not already used",
"Database user" => "Usuario de la base de datos",
"Enter a database user with administrator permission for the Database" => "Introduzca el nombre de usuario de la base datos con permisos de administración en la misma",
"User name" => "Nombre de usuario",
"Character set" => "Conjunto de carateres",
"Highly recommended for new installations. However, if you are upgrading or migrating a previous tiki database, you are recommended to uncheck this box" => "Altamente recomenado para instalaciones nuevas. Sin embargo, si estás actualizando o migrando una database de un tiki previo, es mejor que desmarques esta casilla",
"Always force connection to use UTF-8" => "Fuerza siempre a la conexión a usar UTF-8",
"More information" => "Más información",
"Install &amp; Upgrade" => "Instalar &amp; Actualizar",
"Install" => "Instalar",
// "Failed to set max_execution_time for PHP. You may experience problems when creating/upgrading the database using this installer on a slow system. This can manifest itself by a blank page" => "Failed to set max_execution_time for PHP. You may experience problems when creating/upgrading the database using this installer on a slow system. This can manifest itself by a blank page",
"This install will populate (or upgrade) the database" => "Esta instalación llenará (o actualizará) la base de datos",
"If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"http://doc.tiki.org/Upgrade\" target=\"_blank\">Upgrade instructions</a>" => "Si quieres actualizar desde una versión previa de Tiki, asegúrate de haber leído y entendido las <a href=\"http://doc.tiki.org/Upgrade\" target=\"_blank\">instrucciones de Actualización</a>",
"A new install will populate the database" => "La base de datos será llenada por el proceso de instalación",
"Encoding Issue" => "Cuestión de la codificación de caracteres",
// "<p>Your database encoding is <strong>not</strong> in UTF-8.</p><p>Current encoding is <em>%0</em>. The languages that will be available for content on the site will be limited. If you plan on using languages not covered by the character set, you should re-create or alter the database so the default encoding is <em>utf8</em>.</p>" => "<p>Your database encoding is <strong>not</strong> in UTF-8.</p><p>Current encoding is <em>%0</em>. The languages that will be available for content on the site will be limited. If you plan on using languages not covered by the character set, you should re-create or alter the database so the default encoding is <em>utf8</em>.</p>",
// "Character Set Conversion" => "Character Set Conversion",
// "Use at your own risk. If the data in the database currently contains improperly converted data, this may make matters worse. Suitable for new installations. Requires ALTER privilege on the database" => "Use at your own risk. If the data in the database currently contains improperly converted data, this may make matters worse. Suitable for new installations. Requires ALTER privilege on the database",
// "Convert database and tables to UTF-8" => "Convert database and tables to UTF-8",
"This will destroy your current database &quot;%0&quot;" => "Esto destruirá tu actual base de datos &quot;%0&quot;",
"Reinstall the database" => "Reinstalar la base de datos",
"Select database engine" => "Selecciona el motor de la base de datos",
"MyISAM" => "MyISAM",
// "InnoDB" => "InnoDB",
"Reinstall" => "Reinstalar",
"Upgrade" => "Actualizar",
"Warning: Category Permissions Will Not Be Upgraded" => "Aviso: No se actualizarán los permisos de categorías que pudieras tener puestos",
"Category permissions have been revamped since version 3. If you have been using category permissions, note that they may not work properly after upgrading to version 4 onwards, and it will be necessary to reconfigure them" => "Se ha cambiado el sistema de permisos de categorías desde la version 3. Si has estado usando permisos de categorías, toma nota de que puede que no funcionen tal y como estaban después de actualizar a la versión 4 o siguientes, y será necesario que los reconfigures",
"Automatically upgrade your existing database to v" => "Actualiza automáticamente tu base de datos existente a la v",
"This site has an admin account configured" => "Este sitio tiene una cuenta de administración configurada",
"Please log in with your admin password to continue" => "Por favor, conéctate con tu contraseña de administrador para continuar",
"Pass" => "Contraseña",
"Review the Upgrade" => "Revisar la Actualización",
"Review the Installation" => "Revisar la Instalación",
"Upgrade complete" => "Actualización completada",
"Installation complete" => "Instalación completada",
"Your database has been configured and Tiki is ready to run" => "¡Su base de datos ha sido configurada y Tiki está listo para ser ejecutado",
"If this is your first install, your admin password is <strong>admin</strong>" => "Si esta es su primera instalación, su contraseña de administrador es <strong>admin</strong>",
"You can now log in into Tiki as user <strong>admin</strong> and start configuring the application" => "Usted puede ahora entrar en Tiki como usuario <strong>admin</strong> y comenzar a configurar la aplicación",
"Upgrade operations executed successfully" => "Operaciones de actualización completadas con éxito",
"Installation operations executed successfully" => "Operaciones de instalación ejecutadas con éxito",
"SQL queries" => "consultas SQL",
"Database was left unchanged" => "La Base de datos no fue modificada",
"Failed" => "Falló",
"Operations failed" => "Las operaciones fallaron",
"Display details" => "Mostrar detalles",
"During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages" => "Durante una actualización, es normal obtener fallos SQL que provocan mensajes de <strong>Table already exists</strong>",
// "Check all errors" => "Check all errors",
".htaccess File" => "Fichero .htaccess",
"We recommend enabling the <strong>.htaccess</strong> file for your Tiki" => "Recomendamos habilitar el fichero <strong>.htaccess</strong> para su Tiki",
"This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security" => "Esto le permitirá utilizar SEFURLs (search engine friendly URLs) y ayudará a mejorar la seguridad de su sitio",
"Configure General Settings" => "Configuraciones Generales",
"Complete these fields to configure common, general settings for your site" => "Rellene estos campos para realizar unas configuraciones generales de su sitio",
"The information you enter here can be changed later" => "La información que introduzca aquí podrá ser modificada después",
"Refer to the <a href=\"http://doc.tiki.org/Admin+Panels\" target=\"_blank\">documentation</a> for complete information on these, and other, settings" => "Consulte la  <a href=\"http://doc.tiki.org/Admin+Panels\" target=\"_blank\">documentación</a> para una completa información sobre estas y otras configuraciones",
"This will appear in the browser title bar" => "Esto aparecerá en la barra de título del navegador",
"Email sent by your site will use this address" => "Los correos-e enviados por su sitio utilizarán esta dirección",
"Secure Log in" => "Conexión segura",
// "It is recommended to choose the \"Require secure (https) login\" option for better security. A security certificate and dedicated IP address are required to implement a secure login" => "It is recommended to choose the \"Require secure (https) login\" option for better security. A security certificate and dedicated IP address are required to implement a secure login",
"HTTPS login" => "Registro HTTPS",
"PHP error reporting level" => "Nivel de informe de errores PHP",
"Report all errors except notices" => "Informa de todos los errores excepto notificaciones",
"Visible to Admin only" => "Visible sólo a Administradores",
"Administrator" => "Administrador",
"Admin email" => "Correo-e del Administrador",
"This is the email address for your administrator account" => "Éste es el correo-e para la cuenta de administración",
// "Upgrade fix" => "Upgrade fix",
// "Experiencing problems with the upgrade? Your administrator account lost its privileges? This may occur if you upgraded from a very old version of Tiki.</p>\n\t\t\t<p>We can fix it! Doing so will" => "Experiencing problems with the upgrade? Your administrator account lost its privileges? This may occur if you upgraded from a very old version of Tiki.</p>\n\t\t\t<p>We can fix it! Doing so will",
// "Create the <em>Admins</em> group, if missing" => "Create the <em>Admins</em> group, if missing",
// "Grant <em>tiki_p_admin</em> to the group, if missing" => "Grant <em>tiki_p_admin</em> to the group, if missing",
// "Add the administrator account to the group, if missing" => "Add the administrator account to the group, if missing",
// "To do so enter the name of the main admin account in the field below" => "To do so enter the name of the main admin account in the field below",
// "Administrator account (optional): <input type=\"text\" name=\"admin_account\"/> <em>The default account is <strong>admin</strong></em>" => "Administrator account (optional): <input type=\"text\" name=\"admin_account\"/> <em>The default account is <strong>admin</strong></em>",
// "Check this box if you have a lot of disabled accounts after an upgrade to tiki4" => "Check this box if you have a lot of disabled accounts after an upgrade to tiki4",
// "List of accounts that will be enabled" => "List of accounts that will be enabled",
"Enter Your Tiki" => "Entre en Tiki",
"The installation is complete" => "¡La instalación ha sido completada",
"Tiki is an open source project, <em>you</em> can <a href='http://info.tiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tiki.org/Develop+Tiki' target='_blank'>develop Tiki</a>" => "Tiki es un proyecto de software libre, <em>tu</em> puedes <a href='http://info.tiki.org/Join+the+Community' target='_blank'>ser miembro de la comunidad</a> y ayudar <a href='http://info.tiki.org/Develop+Tiki' target='_blank'>a desarrollar Tiki</a>",
"Installation" => "Instalación",
"If this is a first time installation, go to <strong>tiki-admin.php</strong> after login to start configuring your new Tiki installation" => "Si esta es una nueva instalación de Tiki, ve a <strong>tiki-admin.php</strong> después de registrarte para comenzar a configurar la aplicación",
"If this is an upgrade, clean the Tiki caches manually (the <strong>templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu" => "Si esto es una actualización, limpia las memorias caché de Tiki manualmente (el directorio <strong>templates_c</strong>) o utilizando la opción  <strong>Admin &gt; System</strong> desde el menú de Administración",
"Enter Tiki and Lock Installer" => "Entrar en Tiki y Bloquear el Instalador",
"Recommended" => "Recomendado",
"Enter Tiki Without Locking Installer" => "Entrar en Tiki sin Bloquear el Instalador",
// "Not recommended due to security risk" => "Not recommended due to security risk",
// "Stay up-to-date" => "Stay up-to-date",
// "Subscribe to the <a href=\"http://tiki.org/Newsletter\" title=\"Subscribe\" target=\"_blank\">Tiki newsletter</a> or <a href=\"http://info.tiki.org/tiki-articles_rss.php\" title=\"RSS\" target=\"_blank\">RSS feed</a> to learn about new releases, security updates, and community news" => "Subscribe to the <a href=\"http://tiki.org/Newsletter\" title=\"Subscribe\" target=\"_blank\">Tiki newsletter</a> or <a href=\"http://info.tiki.org/tiki-articles_rss.php\" title=\"RSS\" target=\"_blank\">RSS feed</a> to learn about new releases, security updates, and community news",
// "You can now access the site normally. Report back any issues that you might find (if any) to the Tiki forums or bug tracker" => "You can now access the site normally. Report back any issues that you might find (if any) to the Tiki forums or bug tracker",
// "Are you sure you want to attempt to fix the encoding of your entire database" => "Are you sure you want to attempt to fix the encoding of your entire database",
// "Upgrading and running into encoding issues" => "Upgrading and running into encoding issues",
// "We can try to fix it, but <strong>make sure you have backups, and can restore them</strong>" => "We can try to fix it, but <strong>make sure you have backups, and can restore them</strong>",
// "Previous table encoding" => "Previous table encoding",
// "Please select" => "Please select",
// "Dangerous: Fix double encoding" => "Dangerous: Fix double encoding",
// "Oops. You need to make sure client charset is forced to UTF-8. Reset the database connection to continue" => "Oops. You need to make sure client charset is forced to UTF-8. Reset the database connection to continue",
"MultiTiki Setup" => "Instalación MultiTiki",
"Default Installation" => "Instalación por omisión",
"DB OK" => "BD OK",
"No DB" => "Sin BD",
"Adding a new host" => "Añadir un nuevo tiki virtual",
// "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter" => "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter",
"MultiTiki" => "MultiTiki",
"Are you upgrading an existing Tiki site" => "Estás actualizando un sitio Tiki existente",
"Go directly to the <strong>Install/Upgrade</strong> step" => "Ve directamente al paso de <strong>Instalación / Actualización</strong>",
"Install/Upgrade" => "Instalación / Actualización",
"Restart the installer" => "Reinicia el instalador",
"Database Connection" => "Conexión a la base de datos",
"Reset the Database Connection" => "Configurar la Conexión con la Base de datos",
"Configure the General Settings" => "Configuraciones Generales",
"Tiki Icon" => "Icono de Tiki",
"Tiki Project Web Site" => "Sitio Web del Proyecto Tiki",
"Documentation" => "Documentación",
"Support Forums" => "Foros de Ayuda",
"Powered by Tiki Wiki CMS Groupware" => "Potenciado por Tiki Wiki CMS Groupware",
"Clear cached version and refresh cache" => "Limpiar versión en caché y refrescar",
"configure rules" => "configurar reglas",
"Edit Repository" => "Editar repositorio",
// "Invitation" => "Invitation",
// "Invitations list" => "Invitations list",
// "The mail has been sent to: " => "The mail has been sent to: ",
// "You are about to send an invitation to theses people, please confirm" => "You are about to send an invitation to theses people, please confirm",
// "Fill this box with the list of e-mails you want to invite " => "Fill this box with the list of e-mails you want to invite ",
// "Format of the list above " => "Format of the list above ",
// "CSV Style: One line per invitation, with the format: lastname,firstname,email" => "CSV Style: One line per invitation, with the format: lastname,firstname,email",
// "Everything that appear as an email in the text will be detected and used (in that case, {literal}{firstname} and {lastname}{/literal} will be ignored in the email content)" => "Everything that appear as an email in the text will be detected and used (in that case, {literal}{firstname} and {lastname}{/literal} will be ignored in the email content)",
// "Type here the e-mail subject you'll want to be sent to them " => "Type here the e-mail subject you'll want to be sent to them ",
// "Type here the e-mail content you'll want to be sent to them (and let the {literal}{link}{/literal} word, it will be replaced with the good link for registering) " => "Type here the e-mail content you'll want to be sent to them (and let the {literal}{link}{/literal} word, it will be replaced with the good link for registering) ",
// "Type here the content that the user will see when he'll click on the link from the mail " => "Type here the content that the user will see when he'll click on the link from the mail ",
// "Choose one or more group you want theses suscribtion to be in. Don't choose any if you don't want anything special " => "Choose one or more group you want theses suscribtion to be in. Don't choose any if you don't want anything special ",
// "Invoices" => "Invoices",
// "New Invoice" => "New Invoice",
// "Clients" => "Clients",
// "New Client" => "New Client",
// "Invoice Reports" => "Invoice Reports",
// "Upload to Kaltura" => "Upload to Kaltura",
// "Upload Successful" => "Upload Successful",
// "You have successfully added {\$count} new entry/entries" => "You have successfully added {\$count} new entry/entries",
// "Add more media" => "Add more media",
// "Change Details" => "Change Details",
// "Remix" => "Remix",
// "Media Entries" => "Media Entries",
// "Advanced Editor" => "Advanced Editor",
// "Simple Editor" => "Simple Editor",
// "Video Title" => "Video Title",
"Editor" => "Editor",
// "Embed code" => "Embed code",
// "Plays" => "Plays",
// "No action specified" => "No action specified",
"Last Changes" => "Últimas modificaciones",
"Last 2 days" => "Últimos 2 días",
"Last 3 days" => "Últimos 3 días",
"Last 5 days" => "Últimos 5 días",
"Last week" => "Última semana",
"Last 2 weeks" => "Últimas 2 semanas",
"Last month" => "Último mes",
"Search by Date" => "Buscar por fecha",
"Found" => "Encontrado el texto",
"LastChanges" => "ÚltimosCambios",
// "{\$lastchanges[changes].action|escape}" => "{\$lastchanges[changes].action|escape}",
"v" => "v",
"Pages like" => "Páginas similares",
"New Article" => "Nuevo artículo",
"View Submissions" => "Ver colaboraciones",
// "Expiry Date" => "Expiry Date",
// "{\$listpages[changes].type|escape}" => "{\$listpages[changes].type|escape}",
// "{\$listpages[changes].disp_article}" => "{\$listpages[changes].disp_article}",
// "{\$listpages[changes].lang}" => "{\$listpages[changes].lang}",
// "{\$listpages[changes].hasImage}" => "{\$listpages[changes].hasImage}",
// "{\$listpages[changes].useImage}" => "{\$listpages[changes].useImage}",
// "Permissons" => "Permissons",
// "Select Duplicates" => "Select Duplicates",
// "To use a banner in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone" => "To use a banner in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone",
"Create banner" => "Crear banner",
"Method" => "Método",
"Use Dates?" => "¿Usar Fechas?",
"Max Impressions" => "Máximo de Impresiones",
"Impressions" => "Impresiones",
// "Max Clicks" => "Max Clicks",
"Clicks" => "Clicks",
"Create New Blog" => "Crear nuevo blog",
"List all comments" => "Lista todos los comentarios",
// "The cache is used by" => "The cache is used by",
// "{\$headerName}" => "{\$headerName}",
// "Approval" => "Approval",
// "More info" => "More info",
// "(no title)" => "(no title)",
// "{\$val|ucwords}" => "{\$val|ucwords}",
// "Approved" => "Approved",
// "Rejected" => "Rejected",
// "Delete & Ban" => "Delete & Ban",
// "To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block" => "To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block",
// "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block" => "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block",
"Available content blocks" => "Bloques disponibles",
// "Current Value" => "Current Value",
"Current ver" => "Versión actual",
"Next ver" => "Próxima versión",
"Future vers" => "Versiones futuras",
"Program" => "Programar",
// "Create/Edit content block" => "Create/Edit content block",
// "Edit content block" => "Edit content block",
// "Create content block" => "Create content block",
"Available FAQs" => "FAQs disponibles",
"Edit/Create" => "Editar/Crear",
"Edit this FAQ:" => "Editar este FAQ:",
"Create new FAQ" => "Crear nueva FAQ",
"Create New FAQ:" => "Crear Nueva FAQ:",
"Users can suggest questions" => "Los usuarios pueden sugerir preguntas",
"Create a File Gallery" => "Crear galería de archivos",
"RSS feed" => "RSS feed",
// "Admin View" => "Admin View",
// "Create a drawing" => "Create a drawing",
// "SlideShow" => "SlideShow",
// "Keep gallery window open" => "Keep gallery window open",
"Your comment" => "Tu comentario",
"optional" => "opcional",
// "Modifications" => "Modifications",
// "Property <b>{\$fgp_name}</b> Changed" => "Property <b>{\$fgp_name}</b> Changed",
// "Gallery of this fileId" => "Gallery of this fileId",
// "space use on" => "space use on",
"Gallery Images" => "Imágenes de Galería",
// "Inviter" => "Inviter",
// "Only successful invitations" => "Only successful invitations",
// "Only pending invitations" => "Only pending invitations",
// "Number of invitations" => "Number of invitations",
// "Invoice Clients" => "Invoice Clients",
// "Tax Status" => "Tax Status",
// "New Contact" => "New Contact",
// "Client Name" => "Client Name",
// "Kaltura Remix Entries" => "Kaltura Remix Entries",
// "Kaltura Media Entries" => "Kaltura Media Entries",
// "Loads" => "Loads",
// "List Remixes" => "List Remixes",
// "Browse Media Entries" => "Browse Media Entries",
// "Browse Remixes" => "Browse Remixes",
// "Create Remix" => "Create Remix",
// "Please select some media entries to use" => "Please select some media entries to use",
// "Remix Video" => "Remix Video",
"Additional Info" => "Información adicional",
// "Media Id" => "Media Id",
// "Wiki plugin code" => "Wiki plugin code",
// "Media Type" => "Media Type",
"More Information" => "Más Información",
"No entries" => "Sin entradas",
// "No media entries found" => "No media entries found",
"Click here" => "Haz clic aquí",
// "to upload" => "to upload",
"Modified By" => "Modificado por",
// "No mix entries found" => "No mix entries found",
// "to create a new mix" => "to create a new mix",
// "Mix Entries" => "Mix Entries",
// "Playlist Type" => "Playlist Type",
// "No playlists found. " => "No playlists found. ",
// "Click here " => "Click here ",
// "to create a playlist" => "to create a playlist",
// "Object Permissions List" => "Object Permissions List",
// "Manage Permissions" => "Manage Permissions",
// "\$type" => "\$type",
// "global permissions" => "global permissions",
// "object permissions" => "object permissions",
// "category permissions" => "category permissions",
// "Global Permissions" => "Global Permissions",
// "Delete the selected permissions" => "Delete the selected permissions",
// "Duplicate the selected permissions on this group" => "Duplicate the selected permissions on this group",
// "Object Permissions" => "Object Permissions",
// "If an object is not listed in this section nor in the Category Permissions section, then only the global permissions apply to it" => "If an object is not listed in this section nor in the Category Permissions section, then only the global permissions apply to it",
// "Category Permissions" => "Category Permissions",
// "If an object is not listed in this section nor in the Object Permissions section, then only the global permissions apply to it" => "If an object is not listed in this section nor in the Object Permissions section, then only the global permissions apply to it",
// "{\$special.reason|escape}" => "{\$special.reason|escape}",
// "Blog: %0" => "Blog: %0",
// "New Blog Post" => "New Blog Post",
// "Post Title" => "Post Title",
"Blog Title" => "Título Blog",
// "New Submission" => "New Submission",
"Survey stats" => "Estadísticas de encuesta",
"Take Survey" => "Tomar encuesta",
// "trackers" => "trackers",
"Items" => "Items",
// "Export %0" => "Export %0",
// "Import in %0" => "Import in %0",
"Stop Monitor" => "Deja de seguir por correo-e",
"Monitor" => "Suscribirse",
"Create tracker" => "Crea un formulario-bd",
// "Do you really remove this tracker" => "Do you really remove this tracker",
// "Do you really want to clear all the items from this tracker? (N.B. there is no undo and notifications will not be sent)" => "Do you really want to clear all the items from this tracker? (N.B. there is no undo and notifications will not be sent)",
"Duplicate/Import Tracker" => "Duplica/Importa  un Formulario-bd",
"Duplicate Tracker" => "Duplica un Formulario-bd",
"Duplicate Remote Tracker" => "Duplicate un Formulario-bd Remoto",
"Search for trackers to clone" => "Busca los formularios-bd a clonar",
"Import From Export" => "Importa del Exportado",
// "Raw data" => "Raw data",
"Preserve tracker ID" => "Preserva el ID de formulario-bd",
"users registered" => "usuarios registrados",
"like" => "como",
"Distance (km)" => "Distancia (km)",
// "{\$listuserscountry[changes]}" => "{\$listuserscountry[changes]}",
// "List Wiki Pages" => "List Wiki Pages",
// "Page aliases found" => "Page aliases found",
"Create a Wiki Page" => "Crea una Página Wiki",
"Insert name of the page you wish to create" => "Inserta el nombre de la página que deseas crear",
"Last mod" => "Últ mod",
"Page creator" => "Creador de la página",
"Last author" => "Último autor",
"Last version" => "Última versión",
"Last ver" => "Últ ver",
// "Status of the page" => "Status of the page",
"Vers" => "Vers",
// "Links to other items in page" => "Links to other items in page",
// "Links to this page in other pages" => "Links to this page in other pages",
// "Backl" => "Backl",
// "Page size" => "Page size",
// "Ratings" => "Ratings",
"unlocked" => "desbloqueada",
// "No page" => "No page",
// "No pages found with" => "No pages found with",
// "Xml Zip" => "Xml Zip",
// "Add page name as a header ! at the beginning of the page content" => "Add page name as a header ! at the beginning of the page content",
"Open client window" => "Abrir ventana cliente",
"Generate HTML" => "Generar HTML",
"Transcripts" => "Transcripciones",
"Online operators" => "Operadores en línea",
"Operator" => "Operador",
"Accepted requests" => "Aceptar pedidos",
// "{\$online_operators[ix].status}" => "{\$online_operators[ix].status}",
"transcripts" => "transcripciones",
// "offline" => "offline",
"Offline operators" => "Operadores fuera de línea",
// "{\$offline_operators[ix].status}" => "{\$offline_operators[ix].status}",
"Add an operator to the system" => "Añadir un operador al sistema",
"Operators must be tiki users" => "Los operadores deben ser usuarios del tiki",
"Set as Operator" => "Poner como operador",
"Chat started" => "Charla comenzada",
"Operator:" => "Operador:",
"Live support:User window" => "Soporte Live:ventana de usuario",
"Request live support" => "Pedir soporte live",
"Request support" => "Pedir soporte",
"Open a support ticket instead" => "Abrir un ticket de soporte en su lugar",
"Your request is being processed" => "Su pedido está siendo procesado",
"cancel request and exit" => "cancelar pedido y salir",
"cancel request and leave a message" => "cancelar pedido y dejar mensaje",
"Live support:Console" => "Soporte Live:Consola",
// "{\$status}" => "{\$status}",
"be online" => "quedar en línea",
"be offline" => "quedar fuera de línea",
// "You are not an operator" => "You are not an operator",
"Support requests" => "Pedidos de soporte",
"Requested" => "Pedido",
"Join" => "Unirse",
// "No support requests" => "No support requests",
"Support chat transcripts" => "Soporte de transcripciones de charla",
// "Back to admin" => "Back to admin",
"operator" => "operador",
"started" => "comenzado",
"reason" => "razón",
"msgs" => "msjs",
"Transcript" => "Transcripción",
// "For security purposes we must periodically validate your email address to allow continued access to this site" => "For security purposes we must periodically validate your email address to allow continued access to this site",
// "A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site" => "A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site",
// "Thank you" => "Thank you",
"Mail-in feature" => "Función Mail-in",
// "You do not have any mailin accounts set up" => "You do not have any mailin accounts set up",
// "Click here to go to mailin admin" => "Click here to go to mailin admin",
// "Change to" => "Change to",
// "Week containing" => "Week containing",
// "Month containing" => "Month containing",
// "{\$metrics_range_prefix}" => "{\$metrics_range_prefix}",
// "{\$metrics_range_suffix}" => "{\$metrics_range_suffix}",
// "Missing dependency. Obtain <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/" => "Missing dependency. Obtain <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/",
"Prefs" => "Prefs",
"Daily" => "Diario",
"Weekly" => "Semanal",
"Remove old events" => "Borrar eventos viejos",
"h" => "h",
"mins" => "minutos",
// "Edit Event" => "Edit Event",
"Mini Calendar: Preferences" => "Mini Calendario: Preferencias",
"Calendar Interval in daily view" => "Intervalo de calendario en vista diaria",
"Start hour for days" => "Hora de inicio para días",
"End hour for days" => "Hora final para días",
"Reminders" => "Recordatorios",
"no reminders" => "sin recordatorios",
"min" => "min",
"Or enter path or URL" => "O entre camino o URL",
"Add Topic" => "Añadir tema",
// "Tiki Mods" => "Tiki Mods",
// "Mods Configuration" => "Mods Configuration",
"Update remote index" => "Actualizar índice remoto",
"Rebuild local list" => "Reconstruir lista local",
"Republish all" => "Republicar todo",
"Publish all" => "Publicar todo",
"Unpublish all" => "Despublicar todo",
// "Tiki \"mods\" are additional features not included in the public release. Learn more at <a target=\"tikihelp\" href=\"http://mods.tiki.org\">mods.tiki.org</a>" => "Tiki \"mods\" are additional features not included in the public release. Learn more at <a target=\"tikihelp\" href=\"http://mods.tiki.org\">mods.tiki.org</a>",
// "Tiki \"mods\" are undergoing refurbishment" => "Tiki \"mods\" are undergoing refurbishment",
// "You will probably find mods shown as being compatible with older versions of Tiki will work with later versions with little or no modification" => "You will probably find mods shown as being compatible with older versions of Tiki will work with later versions with little or no modification",
// "Your help is needed! Please visit <a href=\"http://dev.tiki.org/Mods\">dev.tiki.org</a> to find out more" => "Your help is needed! Please visit <a href=\"http://dev.tiki.org/Mods\">dev.tiki.org</a> to find out more",
"Attention" => "Atención",
// "Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"sh setup.sh\" for example)" => "Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"sh setup.sh\" for example)",
// "To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"sh setup.sh open\" to set it up). After installation you need to remove that permission (using \"sh setup.sh\")" => "To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"sh setup.sh open\" to set it up). After installation you need to remove that permission (using \"sh setup.sh\")",
// "for version" => "for version",
// "All versions" => "All versions",
// "or later" => "or later",
// "No mods found" => "No mods found",
"Display only this type" => "Mostrar solo este tipo",
"Unpublish" => "Despublicar",
"Republish" => "Republicar",
// "licence" => "licence",
// "Tiki Mods Configuration" => "Tiki Mods Configuration",
// "Mods Install/uninstall" => "Mods Install/uninstall",
"Enable Mods providing" => "Activar proveer Mods",
"Mods local directory" => "Directorio local de Mods",
"Mods remote server" => "Servidor remoto de Mods",
"Package Config" => "Config de Paquete",
"y" => "s",
"Edit: %0" => "Edita: %0",
"User Galleries" => "Galerías de usuario",
"My Articles" => "Mis Artículos",
"User Articles" => "Artículos del Usuario/a",
"My User Items" => "Mis ítems de usuario/a",
"User Items" => "Ítems del Usuario/a",
"Unread Messages" => "Mensajes no leídos",
"User forum topics" => "Temas de usuario en el foro",
"Forum topics" => "Temas del foro",
"Date of post" => "Fecha de publicación",
"User forum replies" => "Respuestas del usuario en foros",
"Forum replies" => "Respuestas en foros",
"User Blogs" => "Blogs del usuario",
// "To display the objects you created or contributed to" => "To display the objects you created or contributed to",
"MyTiki" => "MiTiki",
"MyInfo" => "MiInfo",
"Contacts Preferences" => "Preferencias de Contactos",
"Notepad" => "Bloc de notas",
"MyFiles" => "MisArchivos",
"My Watches" => "Mis suscripciones",
"Sent editions" => "Ediciones enviadas",
// "HTML version" => "HTML version",
// "Text version" => "Text version",
"The newsletter was sent to {\$sent} email addresses" => "El boletín fue enviado a {\$sent} direcciones de correo",
// "Delete errors" => "Delete errors",
// "Not sent" => "Not sent",
"Thanks for your subscription. You will receive an email soon to confirm your subscription. No newsletters will be sent to you until the subscription is confirmed." => "Gracias por subscribirse. Pronto recibirá un correo para confirmar su suscripción. No se enviarán boletines hasta que la subscripción sea confirmada.",
"Your email address was removed from the list of subscriptors." => "Su dirección de correo ha sido borrada de la lista de suscriptores.",
// "Removal of your email address failed" => "Removal of your email address failed",
"Subscription confirmed!" => "¡Suscripción confirmada!",
// "Subscription failed" => "Subscription failed",
"Subscribe to Newsletter" => "Suscribirse al boletín",
"Subscribe to this Newsletter" => "Suscribir",
"Available Newsletters" => "Boletines Disponibles",
"Write a note" => "Escribir una nota",
"quota" => "quota",
"No notes yet" => "Sin notas aún",
"Merge selected notes into" => "unir notas seleccionadas en",
"Reading note:" => "Leyendo nota:",
"List notes" => "Listar notas",
"Write note" => "Escribir nota",
"Wiki Create" => "Crear wiki",
"Wiki Overwrite" => "Sobrescribir wiki",
"Object Watches:" => "Seguimientos por correo-e de objetos:",
"Object Watches" => "Seguimientos por correo-e de objetos",
// "Changes to groups watching" => "Changes to groups watching",
// "These changes to group watches" => "These changes to group watches",
// "were made to these descendants" => "were made to these descendants",
// "Groups watching" => "Groups watching",
// "This Category" => "This Category",
// "All Descendants" => "All Descendants",
// "Assign global permissions" => "Assign global permissions",
"Assign permissions to " => "Asignar permisos a ",
// "Edit Permissions" => "Edit Permissions",
// "Currently editing Global permissions" => "Currently editing Global permissions",
// "This object's direct permissions override any global permissions or category permissions affecting this object" => "This object's direct permissions override any global permissions or category permissions affecting this object",
// "This category's direct permissions override any global permissions affecting objects in it" => "This category's direct permissions override any global permissions affecting objects in it",
// "To edit global permissions" => "To edit global permissions",
// "No permissions yet applied to this object but category permissions affect this object and are displayed below" => "No permissions yet applied to this object but category permissions affect this object and are displayed below",
// "To edit category permissions" => "To edit category permissions",
// "No direct permissions yet applied to this object. Global permissions apply" => "No direct permissions yet applied to this object. Global permissions apply",
// "Currently inherited permissions displayed" => "Currently inherited permissions displayed",
// "Assign permissions to this category" => "Assign permissions to this category",
"Assign permissions to this object" => "Asignar permisos al objeto",
// "Delete category permissions" => "Delete category permissions",
// "Delete object permissions" => "Delete object permissions",
// "Reset Perms" => "Reset Perms",
// "This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions" => "This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions",
// "This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions" => "This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions",
// "Permissions Clipboard" => "Permissions Clipboard",
// "Copy the permissions set here" => "Copy the permissions set here",
// "Paste" => "Paste",
// "Paste copied permissions from " => "Paste copied permissions from ",
// "Assign or remove permissions on <em>all</em> child categories" => "Assign or remove permissions on <em>all</em> child categories",
// "Are you sure you want to affect all child categories?\\nThere is no undo" => "Are you sure you want to affect all child categories?\\nThere is no undo",
// "Assign or remove permissions on all pages of the sub-structure" => "Assign or remove permissions on all pages of the sub-structure",
// "Are you sure you want to affect all pages in this sub-structure?\\nThere is no undo" => "Are you sure you want to affect all pages in this sub-structure?\\nThere is no undo",
// "You must select at least one feature" => "You must select at least one feature",
// "View Differences" => "View Differences",
// "Permissions added" => "Permissions added",
// "Permissions removed" => "Permissions removed",
// "Select groups" => "Select groups",
// "Some of your groups have been automatically hidden.<br /> Select the groups below to assign permissions for" => "Some of your groups have been automatically hidden.<br /> Select the groups below to assign permissions for",
// "These groups are not the groups that have permissions on the object. It is only the groups you can see in the columns of the first tab" => "These groups are not the groups that have permissions on the object. It is only the groups you can see in the columns of the first tab",
// "Select only groups that have a perm with the object" => "Select only groups that have a perm with the object",
// "Select features" => "Select features",
// "Some of your features have been automatically hidden.<br /> Select the features below to assign permissions for" => "Some of your features have been automatically hidden.<br /> Select the features below to assign permissions for",
// "Show permissions for disabled features" => "Show permissions for disabled features",
// "Feature name" => "Feature name",
// "Quick Permissions" => "Quick Permissions",
// "Assign Quick-Permissions to this object" => "Assign Quick-Permissions to this object",
// "A couple of userdefined permissions are currently assigned (See tab Assign Permissions)" => "A couple of userdefined permissions are currently assigned (See tab Assign Permissions)",
// "<em>Quick permissions</em> should be considered as an experimental feature" => "<em>Quick permissions</em> should be considered as an experimental feature",
// "Although permissions will be set as expected using this form, it doesn't necessarily show the current permissions reliably" => "Although permissions will be set as expected using this form, it doesn't necessarily show the current permissions reliably",
// "There is also no undo - <strong>Use with care!</strong>" => "There is also no undo - <strong>Use with care!</strong>",
// "Your OpenID identity is valid" => "Your OpenID identity is valid",
// "Your identity gives you access to multiple user accounts" => "Your identity gives you access to multiple user accounts",
// "Select account" => "Select account",
"Orphan Pages" => "Páginas huérfanas",
"Browser not supported" => "Navegador no soportado",
// "Contributions to" => "Contributions to",
// "current version" => "current version",
"version" => "versión",
// "Words" => "Words",
// "Whitespaces" => "Whitespaces",
// "Characters" => "Characters",
// "Printable characters" => "Printable characters",
// "Page changes" => "Page changes",
// "Original wiki text" => "Original wiki text",
// "Parsed Text (HTML)" => "Parsed Text (HTML)",
// "Output text only (No HTML tags)" => "Output text only (No HTML tags)",
// "Show statistics" => "Show statistics",
// "Visualize page changes" => "Visualize page changes",
// "Show popups" => "Show popups",
// "Escape HTML / Wiki syntax in page changes" => "Escape HTML / Wiki syntax in page changes",
// "Show contributions" => "Show contributions",
// "Show Edit Sessions" => "Show Edit Sessions",
// "Show All Versions" => "Show All Versions",
"Preview of version" => "Previsualización de la versión",
"(current)" => "(actual)",
"Rollback to this version" => "Revertir a esta versión",
// "Content Approval" => "Content Approval",
// "This revision is currently marked as approved" => "This revision is currently marked as approved",
// "Remove Approval" => "Remove Approval",
// "This revision has not been approved" => "This revision has not been approved",
// "Approve Revision" => "Approve Revision",
"Source of version" => "Fuente de versión",
"s=source" => "s=fuente",
"b=rollback" => "b=revertir",
// "by %0" => "by %0",
// "from %0" => "from %0",
// "approved" => "approved",
// "Updated from" => "Updated from",
// "Used to update" => "Used to update",
// "Wiki Wysiwyg" => "Wiki Wysiwyg",
// "Update Translation" => "Update Translation",
// "Hide translation history" => "Hide translation history",
// "Show translation history" => "Show translation history",
// "Enable pagination" => "Enable pagination",
// "per page" => "per page",
// "Payment Date" => "Payment Date",
// "Payment Type" => "Payment Type",
// "Payer" => "Payer",
// "View payment info" => "View payment info",
// "Assign permissions for payments" => "Assign permissions for payments",
// "Cancel this payment request" => "Cancel this payment request",
// "Request Date" => "Request Date",
// "View payment request" => "View payment request",
// "Paypal" => "Paypal",
// "Transaction ID" => "Transaction ID",
// "Payment made by <em>%0, %1</em> (%2)" => "Payment made by <em>%0, %1</em> (%2)",
// "{\$wp_member_title}" => "{\$wp_member_title}",
// "{\$payment_info.state|escape}" => "{\$payment_info.state|escape}",
// "Paid amount" => "Paid amount",
// "Initial amount" => "Initial amount",
// "Amount remaining" => "Amount remaining",
// "Payment request was sent on %0 and is due by %1" => "Payment request was sent on %0 and is due by %1",
// "Pay with Credit Card through Paypal" => "Pay with Credit Card through Paypal",
// "Pay with Paypal" => "Pay with Paypal",
// "Refresh page" => "Refresh page",
// "Payment info" => "Payment info",
// "Trade with Cclite" => "Trade with Cclite",
// "Payment problem" => "Payment problem",
// "Pay with Tiki User Credits" => "Pay with Tiki User Credits",
// "Credit type" => "Credit type",
// "Credits left" => "Credits left",
// "Amount to pay" => "Amount to pay",
// "Pay using" => "Pay using",
// "Manual payment entry" => "Manual payment entry",
// "Enter payment" => "Enter payment",
// "using" => "using",
// "Payment information" => "Payment information",
// "Outstanding" => "Outstanding",
// "Overdue" => "Overdue",
// "Past" => "Past",
// "Request" => "Request",
// "Detail" => "Detail",
// "Payable within" => "Payable within",
"Pick your avatar" => "Elegir avatar",
"Your current avatar" => "Su avatar actual",
// "Full size" => "Full size",
"no avatar" => "sin avatar",
"Pick avatar from the library" => "Elija avatar de la biblioteca",
"Pick user Avatar" => "Elegir avatar",
"Hide all" => "Ocultar todo",
"icons" => "iconos",
"Show all" => "Mostrar todo",
"Avatar Image" => "Imagen de Avatar",
"random" => "aletorio",
"Upload your own avatar" => "Subir avatar o foto",
// "File (only .gif, .jpg and .png images approximately 45px × 45px)" => "File (only .gif, .jpg and .png images approximately 45px × 45px)",
// "File (only .gif, .jpg and .png images)" => "File (only .gif, .jpg and .png images)",
// "Plugin execution was denied" => "Plugin execution was denied",
// "Plugin execution pending approval" => "Plugin execution pending approval",
// "After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected" => "After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected",
// "This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible" => "This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible",
// "You are allowed to" => "You are allowed to",
// "View arguments" => "View arguments",
// "Execute the plugin in preview mode (may be dangerous)" => "Execute the plugin in preview mode (may be dangerous)",
// "Approve the plugin for public execution" => "Approve the plugin for public execution",
"View Details" => "Ver Detalles",
// "This plugin does not contain any arguments" => "This plugin does not contain any arguments",
"Body" => "Cuerpo",
// "This plugin's body is empty" => "This plugin's body is empty",
"Insert" => "Insertar",
// "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups" => "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups",
// "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins" => "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins",
// "This page lists the plugins that require validation, the first time they are encountered" => "This page lists the plugins that require validation, the first time they are encountered",
// "Each plugin contains a unique <em>signature</em> that is preserved" => "Each plugin contains a unique <em>signature</em> that is preserved",
// "When you upgrade from an old version, you may need to reparse all the pages" => "When you upgrade from an old version, you may need to reparse all the pages",
// "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list" => "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list",
// "The plugin will automatically be added if it is encountered" => "The plugin will automatically be added if it is encountered",
// "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin" => "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin",
// "For security, you should review each plugin to ensure it is safe to approve" => "For security, you should review each plugin to ensure it is safe to approve",
// "Added By" => "Added By",
// "Signature" => "Signature",
// "Wiki page: <a href=\"%0#%2\" title=\"{tr}View this page" => "Wiki page: <a href=\"%0#%2\" title=\"{tr}View this page",
// "<a href=\"%0#%2\" title=\"{tr}View this page" => "<a href=\"%0#%2\" title=\"{tr}View this page",
// "Approve all pending plugins" => "Approve all pending plugins",
// "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins" => "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins",
// "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe" => "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe",
// "No plugins pending approval" => "No plugins pending approval",
// "{\$channels[ix].title|escape}" => "{\$channels[ix].title|escape}",
"View Results" => "Ver Resultados",
"Vote poll" => "Votar",
"Other Polls" => "Otras votaciones",
// "Poll Results" => "Poll Results",
// "Top Voted Polls" => "Top Voted Polls",
// "Edit Poll" => "Edit Poll",
// "Find the poll" => "Find the poll",
// "{\$what}" => "{\$what}",
// "Number of top voted polls to show" => "Number of top voted polls to show",
// "Vote range displayed" => "Vote range displayed",
// "All votes with no span consideration" => "All votes with no span consideration",
// "All votes with span consideration" => "All votes with span consideration",
// "All votes" => "All votes",
// "List Votes" => "List Votes",
"votes" => "votos",
// "Popup preview" => "Popup preview",
// "Close preview" => "Close preview",
"Topic image" => "Imagen de tema",
"The original document is available at" => "El documento original está disponible en",
"Print multiple pages" => "Imprimir múltiples páginas",
// "Selected Structures" => "Selected Structures",
// "Add Structure" => "Add Structure",
// "No structures" => "No structures",
// "Available Pages" => "Available Pages",
// "No pages" => "No pages",
// "All pages selected" => "All pages selected",
"Add Page" => "Añadir Página",
"Remove Page" => "Eliminar página",
// "Selected Pages" => "Selected Pages",
// "No pages selected" => "No pages selected",
// "Add Pages from Structures" => "Add Pages from Structures",
"Edit quiz" => "Editar cuestionario",
"Current Version" => "Versión Actual",
"General Options" => "Opciones Generales",
"Publication Date" => "Fecha de Publicación",
"at " => "en ",
"Use " => "Use ",
"randomly selected questions." => "preguntas seleccionadas aletoriamente.",
"Test-time Options" => "Opciones durante el test",
"Shuffle questions" => "Revolver preguntas",
"Shuffle answers" => "Revolver respuestas",
"Limit questions displayed per page to " => "Limitar preguntas desplegadas por página a ",
"  question(s)." => "  pregunta(s).",
"Impose a time limit of " => "Imponga un límite de tiempo de ",
"Allow students to store partial results and return to quiz." => "Permitir a estudiantes guardar resultados parciales y volver al cuestionario.",
"Allow students to retake this quiz " => "Permitir a estudiantes retomar cuestionarios ",
"Grading and Feedback" => "Calificación y Respuesta",
"Grading method " => "Método de calificación ",
"Show students their score " => "Mostrar puntuación a estudiantes ",
"Show students the correct answers " => "Mostrar las respuestas correctas a estudiantes ",
"Publish statistics " => "Publicar estadísticas ",
"Extra Options" => "Opciones Extra",
"Solicit additional questions from students" => "Pedir preguntas adicionales de estudiantes",
"Link quiz to forum named: " => "Enlazar cuestionario a foro llamado: ",
"Prologue:" => "Prólogo:",
"Epilogue:" => "Epílogo:",
"Quiz result stats" => "Estadísticas de resultados de cuestionarios",
"Time" => "Tiempo",
"User answers" => "Respuestas de usuario",
"Stats for quizzes" => "Estadisticas de cuestionarios",
"taken" => "tomado",
"Av score" => "Puntuación promedio",
"Av time" => "Tiempo promedio",
"Stats for quiz" => "Estadísticas para cuestionario",
"Clear Stats" => "Borrar estadísticas",
"time taken" => "tiempo tomado",
// "P/F" => "P/F",
// "Passed" => "Passed",
"Stats for this quiz Questions " => "Estadísticas para las preguntas de este cuestionario ",
"Top 10" => "Top 10",
"Top 20" => "Top 20",
"Top 50" => "Top 50",
"Top 100" => "Top 100",
// "Rank" => "Rank",
// "Not Published" => "Not Published",
// "This Article is currently not published and only visible by Editors" => "This Article is currently not published and only visible by Editors",
"Received articles" => "Artículos recibidos",
"Edit received article" => "Editar artículo recibido",
"Use Image" => "Usar imagen",
"Image x size" => "Tamaño x de la imagen",
"Image y size" => "Tamaño y de la imagen",
"Image name" => "Nombre de la imagen",
"Accept Article" => "Aceptar Artículo",
// "Received Pages" => "Received Pages",
// "{\$error.error}" => "{\$error.error}",
// "Edit Received Page" => "Edit Received Page",
// "The highlight pages already exist" => "The highlight pages already exist",
// "Please, change the name if you want the page to be uploaded" => "Please, change the name if you want the page to be uploaded",
// "Received Structures" => "Received Structures",
// "Prefix the checked" => "Prefix the checked",
// "Postfix the checked" => "Postfix the checked",
"Referer stats" => "Estadísticas de referers",
"Last" => "Último",
"Register as a new user" => "Registarse como un nuevo usuario",
"Tiki site registered" => "Sitio Tiki registrado",
"The following site was added and validation by admin may be needed before appearing on the lists" => "El siguiente sitio fue añadido aunque una validación por el administrador puede requerirse antes de aparecer en las listas",
"You don't have permission to use this feature." => "No tiene permiso para usar esta función.",
"Please register." => "Por favor regístrese.",
// "Register this site at Tiki.org" => "Register this site at Tiki.org",
"Read this first!" => "¡Lea esto primero!",
// "On this page you can make your tiki site known to Tiki.org. It will get shown there in a list of known tiki sites" => "On this page you can make your tiki site known to Tiki.org. It will get shown there in a list of known tiki sites",
"Registering is voluntary." => "Registrarse es voluntario.",
"Registering does not give you any benefits except one more link to your site." => "Registrarse no le dara ningún beneficio excepto un enlace más a su sitio.",
"You don't get any emails, we don't sell the data about your site." => "No recibirá correos, no venderemos los datos acerca de su sitio.",
"Registering is just for us to get an overview of Tiki's usage." => "Registrarse es sólo para que nosotros tengamos una idea acerca del uso de Tiki.",
"If your site is private or inside your intranet, you should not register!" => "Si su sitio es privado o dentro de una intranet, ¡no debería registrarse!",
"tiki.org" => "tiki.org",
"Information about your site" => "Información acerca de su sitio",
// "Enter your username or email" => "Enter your username or email",
// "Enter your email" => "Enter your email",
"Send me my Password" => "Enviar mi contraseña",
// "Request Password Reset" => "Request Password Reset",
"Remove page" => "Eliminar página",
"Last Version" => "última versión",
// "Back to page" => "Back to page",
"You are about to remove the page" => "Esta a punto de eliminar la página",
"permanently" => "permanentemente",
"Remove all versions of this page" => "Eliminar todas las versiones de esta página",
"Rename page" => "Renombrar página",
"Rollback page" => "Restablecer versión",
// "to version" => "to version",
// "This feature currently searches and replaces within wiki pages only" => "This feature currently searches and replaces within wiki pages only",
// "Max number of pages at a time" => "Max number of pages at a time",
// "Number of surrounding chars to preview" => "Number of surrounding chars to preview",
// "Replace selected" => "Replace selected",
"Searched" => "Buscado",
"Search in" => "Buscar en",
// "Date Search" => "Date Search",
// "All dates" => "All dates",
// "{\$languages[ix].name}" => "{\$languages[ix].name}",
// "Calendar Items" => "Calendar Items",
// "{\$where|escape}" => "{\$where|escape}",
// "{\$where_label|escape}" => "{\$where_label|escape}",
// "{\$results[search].type|escape}" => "{\$results[search].type|escape}",
"Simple search" => "Búsqueda simple",
// "You can also send newsletters using an external client" => "You can also send newsletters using an external client",
"This newsletter will be sent to {\$subscribers} email addresses." => "Este boletín será enviando a {\$subscribers} direcciones de correo.",
// "Reply to" => "Reply to",
// "Recipients" => "Recipients",
// "Validated" => "Validated",
// "Is user" => "Is user",
// "Sending Newsletter" => "Sending Newsletter",
"Prepare a newsletter to be sent" => "Preparar boletín para ser enviado",
"Apply content template" => "Aplicar plantilla de contenido",
// "Data HTML" => "Data HTML",
// "Data Txt" => "Data Txt",
// "Article Clip (read only)" => "Article Clip (read only)",
// "Clip Now" => "Clip Now",
// "Clip Articles" => "Clip Articles",
// "To include the article clipping into your newsletter, cut and paste it into the contents" => "To include the article clipping into your newsletter, cut and paste it into the contents",
// "If autoclipping is enabled, you can also enter \"~~~articleclip~~~\" which will be replaced with the latest\tclip when sending" => "If autoclipping is enabled, you can also enter \"~~~articleclip~~~\" which will be replaced with the latest\tclip when sending",
// "Be careful not to paste articles that must not be seen by the recipients" => "Be careful not to paste articles that must not be seen by the recipients",
// "Attached Files" => "Attached Files",
"remove" => "eliminar",
// "octets" => "octets",
// "To add a file, click here" => "To add a file, click here",
// "Reply To Email" => "Reply To Email",
// "if not" => "if not",
// "Sender email not set" => "Sender email not set",
// "Save as Draft" => "Save as Draft",
// "Save your changes" => "Save your changes",
// "Save any changes and send to all subscribers" => "Save any changes and send to all subscribers",
// "Drafts (%0)" => "Drafts (%0)",
// "Sent Editions (%0)" => "Sent Editions (%0)",
"Send objects" => "Enviar objetos",
"Transmission results" => "Resultados de la transmisión",
"Send Wiki Pages" => "Enviar páginas Wiki",
// "Send a structure" => "Send a structure",
"Send Articles" => "Enviar artículos",
"Add Article" => "Añadir artículo",
"Send objects to this site" => "Enviar objetos a este sitio",
// "Ex: http://tiki.org or localhost" => "Ex: http://tiki.org or localhost",
// "Use /commxmlrpc.php if your Tiki site is installed at the root, otherwise adapt /tiki to your need" => "Use /commxmlrpc.php if your Tiki site is installed at the root, otherwise adapt /tiki to your need",
// "Report this page" => "Report this page",
// "Page shared" => "Page shared",
// "The link was sent via e-Mail to the following addresses" => "The link was sent via e-Mail to the following addresses",
// "The link was sent via Twitter" => "The link was sent via Twitter",
// "The link was posted on your Facebook wall" => "The link was posted on your Facebook wall",
// "The link was sent as message to" => "The link was sent as message to",
// "The link was published in a" => "The link was published in a",
// "Short link" => "Short link",
// "Have a look at this page" => "Have a look at this page",
// "Your message" => "Your message",
"I found an interesting page that I thought you would like." => "Encontré una página interesante que pensé que te gustaría ver.",
// "e-Mail" => "e-Mail",
// "Send via e-Mail" => "Send via e-Mail",
// "Recipient(s)" => "Recipient(s)",
// "Separate multiple email addresses with a comma and a space" => "Separate multiple email addresses with a comma and a space",
"Separate multiple email addresses with a comma." => "Separa múltiples direcciones de correo-e con comas",
"Your name" => "Tu nombre",
// "Tweet via Twitter" => "Tweet via Twitter",
// "Authorize with Twitter first" => "Authorize with Twitter first",
// "Have a look at " => "Have a look at ",
// "Put on my Facebook wall" => "Put on my Facebook wall",
// "Authorize with Facebook first" => "Authorize with Facebook first",
// "Link text" => "Link text",
// "This will be the title for the URL" => "This will be the title for the URL",
// "Like this post" => "Like this post",
// "Subscribe notification" => "Subscribe notification",
// "How much time recipients can access to this page" => "How much time recipients can access to this page",
"time" => "tiempo",
// "You do not have the permission to send messages or you did not allow other users to send you messages" => "You do not have the permission to send messages or you did not allow other users to send you messages",
// "Separate multiple recipients with a semicolon" => "Separate multiple recipients with a semicolon",
// "Post on forum" => "Post on forum",
// "There is no forum where you can post a message" => "There is no forum where you can post a message",
// "password-protected" => "password-protected",
"Share access rights" => "Comparte los permisos de acceso a la página ",
// "Return to previous page" => "Return to previous page",
"Create a sheet" => "Crear una planilla",
// "Configure this sheet" => "Configure this sheet",
"There are individual permissions set for this sheet" => "Hay permisos individuales configurados para esta planilla",
"Class Name" => "Nombre de Clase",
"Header Rows" => "Filas de Cabecera",
"Footer Rows" => "Filas de Pie",
// "Wiki Parse Values" => "Wiki Parse Values",
// "Parent Spreadsheet" => "Parent Spreadsheet",
// "Makes this sheet a \"child\" sheet of a multi-sheet set" => "Makes this sheet a \"child\" sheet of a multi-sheet set",
"You can access the sheet using the following URL" => "Puede acceder a la planilla usando la siguiente URL",
// "Banned Words" => "Banned Words",
"Change shoutbox general settings" => "Cambiar opciones general del shoutbox",
"auto-link urls" => "auto-linkear urls",
"Post or edit a message" => "Escribir o editar mensaje",
"Location : " => "Ubicación : ",
// "Content may be out of date" => "Content may be out of date",
// "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages" => "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages",
// "page: %0/%1" => "page: %0/%1",
// "This text was automatically translated by Google Translate from the following page: " => "This text was automatically translated by Google Translate from the following page: ",
"Last edited by" => "Ultima edición por",
"based on work by" => "basado en trabajo de",
"Contributors to this page" => "Contribuyentes a esta página",
// "First Slide" => "First Slide",
// "Previous Slide" => "Previous Slide",
// "Previous Point" => "Previous Point",
// "Next Point" => "Next Point",
// "Next Slide" => "Next Slide",
// "Last Slide" => "Last Slide",
// "Jump To Slide" => "Jump To Slide",
// "Play" => "Play",
// "Pause" => "Pause",
// "Toggle Loop" => "Toggle Loop",
// "Export to PDF" => "Export to PDF",
// "Exit" => "Exit",
// "Change Theme" => "Change Theme",
// "To use Twitter integration, the site admin must register this site as an application at <a href=\"http://twitter.com/oauth_clients/\" target=\"_blank\">http://twitter.com/oauth_clients/</a> and allow write access for the application" => "To use Twitter integration, the site admin must register this site as an application at <a href=\"http://twitter.com/oauth_clients/\" target=\"_blank\">http://twitter.com/oauth_clients/</a> and allow write access for the application",
// "Twitter authorisation" => "Twitter authorisation",
// "to manage your authorisations at Twitter" => "to manage your authorisations at Twitter",
// "this site with twitter.com to use Twitter integration of this site" => "this site with twitter.com to use Twitter integration of this site",
// "To use Facebook integration, the site admin must register this site as an application at <a href=\"http://developers.facebook.com/setup/\" target=\"_blank\">http://developers.facebook.com/setup/</a> first" => "To use Facebook integration, the site admin must register this site as an application at <a href=\"http://developers.facebook.com/setup/\" target=\"_blank\">http://developers.facebook.com/setup/</a> first",
// "Facebook authorisation" => "Facebook authorisation",
// "to manage your authorisations at Facebook" => "to manage your authorisations at Facebook",
// "this site with facebook.com to use Facebook integration of this site" => "this site with facebook.com to use Facebook integration of this site",
// "The site admin has set up a global account which will be used for this site" => "The site admin has set up a global account which will be used for this site",
"Save changes" => "Guarda los cambios",
// "You will be redirected to the home page shortly" => "You will be redirected to the home page shortly",
// "to go to the home page immediately" => "to go to the home page immediately",
// "Please provide local account information" => "Please provide local account information",
// "Do you already have a local account for this site? Login to link to it using the following form instead" => "Do you already have a local account for this site? Login to link to it using the following form instead",
// "Link to Existing Account" => "Link to Existing Account",
// "You will not see the latest queries" => "You will not see the latest queries",
// "Params" => "Params",
// "Most viewed objects" => "Most viewed objects",
// "Most viewed objects in the last 7 days" => "Most viewed objects in the last 7 days",
"Site Stats" => "Estadísticas del sitio",
// "Date of first pageview" => "Date of first pageview",
// "Days since first pageview" => "Days since first pageview",
"Total pageviews" => "Páginas vistas en total",
"Average pageviews per day" => "Promedio de Páginas vistas por día",
"Wiki Stats" => "Estadísticas del Wiki",
"Size of Wiki Pages" => "Tamaño de las páginas",
"Average page length" => "Tamaño promedio",
"Average versions per page" => "Versiones promedio por página",
"Visits to wiki pages" => "Visitas a páginas del wiki",
"Average links per page" => "Cantidad promedio de enlaces por página",
"Image galleries Stats" => "Estadísticas de galerías de imágenes",
"Average images per gallery" => "Promedio de imágenes por galería",
"Total size of images" => "Tamaño total de imágenes",
"Average image size" => "Tamaño promedio de imagen",
"Visits to image galleries" => "Visitas a galerías de imágenes",
"File galleries Stats" => "Estadísticas de galerías de archivos",
"Average files per gallery" => "Promedio de archivos por galería",
"Total size of files" => "Cantidad total de archivos",
"Average file size" => "Tamaño promedio de archivo",
"Visits to file galleries" => "Cantidad de visitas a galerías de archivos",
// "Articles Stats" => "Articles Stats",
"Total reads" => "Cantidad de notas leídas",
"Average reads per article" => "Lecturas promedio por artículo",
"Total articles size" => "Tamaño total de artículos",
"Average article size" => "Tamaño promedio de un artículo",
"Forum Stats" => "Estadísticas de foros",
"Total topics" => "Cantidad de temas",
"Average topics per forums" => "Cantidad promedio de temas por foro",
// "Total replies" => "Total replies",
// "Average number of replies per topic" => "Average number of replies per topic",
"Visits to forums" => "Visitas a los foros",
"Blog Stats" => "Estadísticas de Weblogs",
"Weblogs" => "Cantidad de weblogs",
"Total posts" => "Cantidad de posts en total",
"Average posts per weblog" => "Posts promedio por weblog",
"Total size of blog posts" => "Tamaño total de los posts",
"Average posts size" => "Tamaño promedio de un post",
"Visits to weblogs" => "Visitas a los weblogs",
"Poll Stats" => "Estadísticas de votaciones",
"Total votes" => "Cantidad total de votos",
"Average votes per poll" => "Promedio de votos por votación",
// "FAQ Stats" => "FAQ Stats",
"Total questions" => "Preguntas en total",
"Average questions per FAQ" => "Promedio de preguntas por FAQ",
"User Stats" => "Estadísticas de usuarios",
"Average bookmarks per user" => "Cantidad de marcadores por usuario",
"Average questions per quiz" => "Preguntas promedio por cuestionario",
"Quizzes taken" => "Cuestionarios tomados",
"Average quiz score" => "Puntuación promedio",
"Average time per quiz" => "Tiempo promedio",
// "Most viewed objects in period" => "Most viewed objects in period",
// "{\$best_objects_stats_between[i]->type}" => "{\$best_objects_stats_between[i]->type}",
// "{\$best_objects_stats_lastweek[i]->type}" => "{\$best_objects_stats_lastweek[i]->type}",
// "Usage chart" => "Usage chart",
// "Usage chart image" => "Usage chart image",
// "Daily Usage" => "Daily Usage",
"Stats for surveys" => "Estadisticas de encuestas",
"Last taken" => "Última respuesta",
"Stats for survey" => "Estadísticas de encuesta",
// "Tiki Logs" => "Tiki Logs",
// "Export through Action Log" => "Export through Action Log",
// "Clean logs older than" => "Clean logs older than",
"Time Left" => "Tiempo",
"Send Answers" => "Enviar respuestas",
"Thank you for your submission" => "Gracias por su envío",
"Send a link to a friend" => "Envía un enlace a un amigo/a",
"Your email was sent" => "Su correo ha sido enviado",
// "The link was sent to the following addresses" => "The link was sent to the following addresses",
// "Friend's email" => "Friend's email",
// "TikiTests Edit" => "TikiTests Edit",
// "Summary mode" => "Summary mode",
// "Show Page Differences" => "Show Page Differences",
// "Show Tidy Errors and Warnings" => "Show Tidy Errors and Warnings",
// "Show POST Data" => "Show POST Data",
// "Use Current Session/Log out" => "Use Current Session/Log out",
// "Recorded Links" => "Recorded Links",
// "Element to compare (Xpath expression)" => "Element to compare (Xpath expression)",
// "Test Xpath Expression" => "Test Xpath Expression",
// "Post Variables" => "Post Variables",
// "Tidy Results" => "Tidy Results",
// "Delete this link" => "Delete this link",
// "TikiTests List" => "TikiTests List",
// "Config" => "Config",
// "Replay" => "Replay",
// "Tidy extension not present" => "Tidy extension not present",
// "PECL HTTP extension present" => "PECL HTTP extension present",
// "cURL extension present" => "cURL extension present",
// "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible" => "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible",
// "List TikiTests" => "List TikiTests",
// "Create a TikiTest" => "Create a TikiTest",
// "Replay the TikiTest" => "Replay the TikiTest",
// "Edit the TikiTest" => "Edit the TikiTest",
// "TikiTests Record Configuration" => "TikiTests Record Configuration",
// "Start Recording Test" => "Start Recording Test",
// "TikiTests Replay Configuration" => "TikiTests Replay Configuration",
// "Failure" => "Failure",
// "Reference" => "Reference",
// "The pages are different" => "The pages are different",
// "The pages are identical" => "The pages are identical",
// "Recording to pause press the pause button" => "Recording to pause press the pause button",
// "Pause the recording" => "Pause the recording",
// "Paused to resume press the play button" => "Paused to resume press the play button",
// "Resume the recording" => "Resume the recording",
// "Stop the recording" => "Stop the recording",
// "Theme Control Center: Categories" => "Theme Control Center: Categories",
"Theme is selected as follows" => "El tema fue seleccionado como sigue",
"If a theme is assigned to the individual object that theme is used." => "Si un tema esta asignado a un objeto individual ese tema es usado.",
"If not then if a theme is assigned to the object's category that theme is used" => "Si no entonces si un tema es asignado a la categoría del objeto ese tema es usado",
"If not then a theme for the section is used" => "Si no entonces el tema para la sección es usado",
"If none of the above was selected the user theme is used" => "Si nada de lo anterior fue seleccionado se usara el tema del usuario",
"Finally if the user didn't select a theme the default theme is used" => "Finalmente si el usuario no eligio un tema el tema por defecto será usado",
"Control by Objects" => "Control por Objetos",
"Control by Sections" => "Control por Secciones",
"Assign themes to categories" => "Asignar temas a categorías",
"Assigned categories" => "Categorías asignadas",
"Theme Control Center: Objects" => "Centro de Control de Temas: Objectos",
"Control by Categories" => "Control por Categorías",
"Assign themes to objects" => "Asignar temas a objetos",
"Assigned objects" => "Objetos asignados",
// "Theme Control Center: Sections" => "Theme Control Center: Sections",
"Assign themes to sections" => "Asignar temas a secciones",
"Assigned sections" => "Secciones asignadas",
"Apply the following profile for enhancements: " => "Aplica el siguiente perfil para mejoras: ",
"Time Tracker" => "Formulario-bd de Tiempo",
"Local Cache (Not Committed)" => "Cache Local (No enviado)",
"Saved (Committed)" => "Guardado (Enviado)",
"New task" => "+ tarea",
"Toggle completed" => "Conmuta las completadas",
"Toggle archived" => "Conmuta las archivadas",
"Task name" => "Nombre de tarea",
"Estimate (in min.)" => "Estimación (en min.)",
"Estimate" => "Estimación",
"Task is completed" => "Tarea completada",
"Task is archived" => "Tarea archivada",
"Created at" => "Creada el",
"Are you sure you want to delete all tasks" => "¿Estás seguro de que quieres borrar todas las tareas",
"Commit Time Sheet Items" => "Envía los ítems de la hoja de tiempo (timesheet)",
"View All" => "Visualízalos todos",
"View My Items" => "Visualiza mis ítems",
"Summary" => "Resumen",
"Time Spent" => "Tiempo invertido",
"Done By" => "Hecho por",
"Add Tracker" => "Añade Formulario-bd",
"Add Tracker To Tracker Report" => "Añade Formulario-bd al Informe de Formulario-bd",
"View Tracker Report" => "Visualiza el Informe del Formulario-bd",
"Pick tracker to join" => "Elige el formulario-bd a juntar",
"Pick fields to join on" => "Escoge los campos por los que juntarlo",
"Join inner" => "Junta por dentro",
"Join outer" => "Junta por fuera",
"Tracker - Open" => "Formulario-bd - Abierto",
"Tracker - Pending" => "Formulario-bd - Pendiente",
"Tracker - Closed" => "Formulario-bd - Cerrado",
"Tracker Item History" => "Historia del Ítem de Formulario-bd",
"View Tracker Item" => "Visualiza el Ítem de Formulario-bd",
"Not logging" => "No se están registrando las acciones",
"Tracker changes are not being logged: Go to <a href=\"tiki-admin_actionlog.php?action_log_type=trackeritem&cookietab=2\" >Action log admin</a> to enable" => "Los cambios en el Formulario-bd no se están registrando: Ve a <a href=\"tiki-admin_actionlog.php?action_log_type=trackeritem&cookietab=2\" >Admin Registro de Acciones</a> para habilitarlo",
"Edit File:" => "Edita Archivo:",
"Advanced mode" => "Modo avanzado",
"Simple mode" => "Modo simple",
"Retry" => "Vuelve a intentarlo",
"The following file was successfully uploaded" => "El siguiente archivo ha sido subido exitósamente",
"The following files have been successfully uploaded" => "Los siguientes archivos han sido subidos exitósamente",
"You can download this file using" => "Puedes bajar el archivo usando",
"You can link to the file from a Wiki page using" => "Puedes enlazar al archivo desde una página wiki usando",
"You can display an image in a Wiki page using" => "Puedes mostrar una imagen en una página Wiki usando",
// "Or using as a thumbnail with ShadowBox" => "Or using as a thumbnail with ShadowBox",
"You can link to the file from an HTML page using" => "Puedes enlazar al archivo desde una página HTML usando",
// "You locked the file" => "You locked the file",
// "The file is locked by {\$fileInfo.lockedby}" => "The file is locked by {\$fileInfo.lockedby}",
"File title" => "Título del archivo",
// "required field for podcasts" => "required field for podcasts",
"File description" => "Descripción del archivo",
// "We're sorry" => "We're sorry",
// "Upload interface could not load.  You must have JavaScript enabled to enjoy Upload interface" => "Upload interface could not load.  You must have JavaScript enabled to enjoy Upload interface",
// "Upload interface is loading" => "Upload interface is loading",
// "Please wait a moment.." => "Please wait a moment..",
// "Upload interface is taking a long time to load or the load has failed" => "Upload interface is taking a long time to load or the load has failed",
// "Please make sure that the Flash Plugin is enabled and that a working version of the Adobe Flash Player is installed" => "Please make sure that the Flash Plugin is enabled and that a working version of the Adobe Flash Player is installed",
// "We are sorry: Upload interface could not load.  You may need to install or upgrade Flash Player" => "We are sorry: Upload interface could not load.  You may need to install or upgrade Flash Player",
// "Visit the Adobe Website to get the Flash Player" => "Visit the Adobe Website to get the Flash Player",
// "Unzip zip files" => "Unzip zip files",
// "File can be deleted after" => "File can be deleted after",
// "Root" => "Root",
// "Creator of file, if different from the 'Uploaded by' user" => "Creator of file, if different from the 'Uploaded by' user",
// "Maximum number of downloads" => "Maximum number of downloads",
// "-1 for no limit" => "-1 for no limit",
"Upload File(s)" => "Sube archivo(s)",
"Cancel Upload" => "Cancela la subida",
"Add Another File" => "Añade otro archivo",
"Maximum file size is around" => "El tamaño máximo del archivo es del orden de",
"Uploading file.." => "Subiendo archivo..",
"No File to Upload.." => "Ningún archivo que subir..",
" Syntax tips" => " Pistas de sintaxis",
"Link to file from a Wiki page" => "Enlace al archivo desde una página Wiki",
"In addition, for image files" => "Adicionalmente, para archivos que sean imágenes",
"To display full size in a Wiki page" => "Para mostrarlo/s a tamaño completo en una página Wiki",
"Display thumbnail that enlarges" => "Muestra un contacto que se hace más grande",
"Upload successful!" => "¡Imagen recibida correctamente!",
"The following image was successfully uploaded" => "La siguiente imagen ha sido recibida con éxito",
"Image ID thumb" => "Miniatura ID de imagen",
"You can view this image in your browser using" => "Puede visualizar esta imagen en su navegador usando",
"You can include the image in an Wiki page using" => "Puede incluir la imagen en una página wiki usando",
"or use filename" => "o use nombre de archivo",
"Now enter the image URL" => "Ingrese la URL de la imagen",
"or upload a local image from your disk" => "o suba una imagen desde su disco local",
"Batch Upload" => "Subida batch",
"Thumbnail (optional, overrides automatic thumbnail generation)" => "Miniatura (opcional, impide que se genere automaticamente)",
// "No gallery available" => "No gallery available",
"You have to create a gallery first!" => "Debe crear una galería primero!",
"User assigned modules" => "Módulos asignados por el usuario",
"Restore defaults" => "Recuperar valores por defecto",
// "The column is disabled" => "The column is disabled",
"#" => "#",
"act" => "act",
"Move to Right Column" => "Mover a columna derecha",
"Move to Left Column" => "Mover a columna izquierda",
"Assign module" => "Asignar módulo",
"top" => "top",
"Current folder" => "Carpeta actual",
"Folders" => "Carpetas",
"Folder in" => "Carpeta entrada",
"Remove Folder" => "Borrar carpeta",
"Refresh Cache" => "Refrescar cache",
"Admin folders and bookmarks" => "Admin carpetas y marcadores",
// "a folder" => "a folder",
// "a bookmark" => "a bookmark",
// "User Contacts Preferences" => "User Contacts Preferences",
// "Manage Fields" => "Manage Fields",
// "{\$ext.fieldname|escape}" => "{\$ext.fieldname|escape}",
// "{if \$escape_menu_labels}{\$chdata.name|escape}{else}{\$chdata.name}{/if}" => "{if \$escape_menu_labels}{\$chdata.name|escape}{else}{\$chdata.name}{/if}",
"Send me a message" => "Envíame un mensaje",
"Basic Data" => "Datos básicos",
"Assign Group" => "Asignar Grupo",
"Change user preferences" => "Cambiar preferencias de usuarios",
// "User Icon" => "User Icon",
// "{\$gender}" => "{\$gender}",
// "(non public)" => "(non public)",
// "{\$country|stringfix}" => "{\$country|stringfix}",
"User's homepage" => "Página inicial del usuario/a",
"Personal Wiki Page" => "Página Wiki Personal",
// "This user is your friend " => "This user is your friend ",
// "The user requested friendship with you" => "The user requested friendship with you",
// "Accept friendship from this user" => "Accept friendship from this user",
// "Refuse friendship from this user" => "Refuse friendship from this user",
// "Currently waiting for user approval" => "Currently waiting for user approval",
// "Cancel friendship request towards this user" => "Cancel friendship request towards this user",
"Request friendship from this user" => "Solicitar amistad de este usuario",
"Additional Information" => "Información adicional",
// "Change user information" => "Change user information",
"User Contribution" => "Contribuciones del usuario",
"has contributed to the following content" => "ha contribuido el siguiente contenido",
"has not contributed to any content yet" => "no ha contribuido con ningún contenido aún",
"Forum comments" => "Comentarios de foros",
"Who Looks At Stuff" => "Quien lo mira",
"Who Looks At Your Stuff" => "Quien mira tus cosas",
"Who Looks At His Stuff" => "Quien mira sus cosas",
"Send Me A Message" => "Envíame Un Mensaje",
"Send me a message " => "Envíame un mensaje ",
"The following message will be sent to user" => "Se enviará el siguiente mensaje al usuario",
"Message Body" => "Cuerpo del mensaje",
"Toggle" => "Conmuta",
"Toggle options" => "Cambiar opciones",
"Personal Information" => "Información Personal",
"Male" => "Hombre",
"Female" => "Mujer",
"Hidden" => "Oculto",
// "{\$flags[ix]|stringfix}" => "{\$flags[ix]|stringfix}",
"Your personal Wiki Page" => "Su página personal en el Wiki",
"User's personal tracker information" => "Información del formulario-bd personal del usuario/a",
"View extra information" => "Ver información extra",
"Your personal tracker information" => "Su tracker de información personal",
"Is email public? (uses scrambling to prevent spam)" => "¿Es el correo público? (usa cifrado para prevenir spam)",
"Unavailable - please set your e-mail below" => "No disponible - configure su correo debajo",
"Does your mail reader need a special charset" => "Su lector de correo requiere un conjunto de caracteres especial",
"Preferred language" => "Idioma preferido",
"Can you read more languages" => "Puedes leer más idiomas",
"Other languages you can read (select on the left to add to the list on the right)" => "Otros idiomas que puedes leer (selecciona en la izquierda para añadirlos a la lista de la derecha)",
"Select language.." => "Selecciona idioma..",
// "Detect user time zone if browser allows, otherwise site default" => "Detect user time zone if browser allows, otherwise site default",
"Use 12-hour clock in time selectors" => "Usa reloj de 12-horas en selectores de tiempo",
"Display info tooltip on mouseover for every user who allows his/her information to be public" => "Muestra recuadros emergentes con información al pasar el ratón por encima de cada usuario que permite que su información sea pública",
"Notify sender when reading his mail" => "Notifique al autor cuando lea su correo",
"Auto-archive read messages after x days" => "Auto-archivar mensajes leídos después de x días",
"never" => "nunca",
"My user items" => "Mis ítems de usario/a",
"My level" => "Mi nivel",
"Account Information" => "Información de cuenta",
"Leave \"New password\" and \"Confirm new password\" fields blank to keep current password" => "Deje los campos \"Nueva contraseña\" y \"Confirmar contraseña\" en blanco para conservar la contraseña actual",
"Confirm new password" => "Confirmar nueva contraseña",
"Current password (required)" => "Contraseña actual (requerido)",
"Account Deletion" => "Borrado de cuenta",
"Are you really sure you want to delete the account %0" => "¿Estás seguro de querer borrar la cuenta %0",
"Check this box if you really want to delete the account" => "Marca esta casilla si quieres realmente borrar esta cuenta",
"Delete the account" => "Borra la cuenta",
"Delete my account" => "Borra mi cuenta",
"Task list" => "Lista de tareas",
"Admin mode off" => "Modo admin activado",
"Admin mode on" => "Modo admin desactivado",
"Task help" => "Ayuda de tareas",
"Empty Trash" => "Vaciar papelera",
// "Task received" => "Task received",
// "You received this task" => "You received this task",
// "Task sent" => "Task sent",
// "You sent this task to another user" => "You sent this task to another user",
// "Task shared by a group" => "Task shared by a group",
// "Task is shared by a group" => "Task is shared by a group",
// "Accepted by task user and creator" => "Accepted by task user and creator",
// "Task has been accepted by user and creator" => "Task has been accepted by user and creator",
// "Rejected by a user" => "Rejected by a user",
// "Task has been rejected by a user" => "Task has been rejected by a user",
// "Waiting for me" => "Waiting for me",
// "Task has not yet been accepted or rejected by you" => "Task has not yet been accepted or rejected by you",
// "Waiting for other user" => "Waiting for other user",
// "Task has not yet been accepted or rejected by another user" => "Task has not yet been accepted or rejected by another user",
"Admin Mode" => "Modo admin",
"Edit Task" => "Editar Tarea",
"NOT accept" => "NO acepta",
"Remove from Trash" => "Sacar de papelera",
// "Move to trash" => "Move to trash",
// "Move to Trash" => "Move to Trash",
"Task saved" => "Tarea guardada",
"View Task" => "Ver Tarea",
"Open a new task" => "Abrir nueva tarea",
"taskId" => "taskId",
"Task user" => "Usuario de tarea",
"Only the creator can delete this task" => "Solo el creador puede borrar esta tarea",
"Use start date and time" => "Usar fecha y hora de comienzo",
"Use end date and time" => "Usar fecha y hora de fin",
"Open / In Process" => "Abierta / en proceso",
"Waiting / Not Started" => "Esperando / no empezada",
"Percentage completed" => "Porcentaje de completada",
"Shared for Group" => "Compartida para grupo",
"Accepted by User" => "Aceptada por usuario",
"No / Rejected" => "No / rechazada",
"Accepted by Creator" => "Aceptada por creado",
"This message will be send to users if you are makeing changes of assigned tasks" => "Este mensaje será enviado a usuarios si está haciendo cambios a tareas asignadas",
"Send message with changes" => "Enviar mensaje con cambios",
"Modified by" => "Modificado por",
"Marked as deleted" => "Marcado como borrado",
"Inform task user by email" => "Informar usuario de tarea por correo",
"You can only view this task" => "Solo puede ver esta tarea",
"Completed" => "Completada",
// "In the trash" => "In the trash",
"Not Accepted by One User" => "No aceptada por un usuario",
"Not Accepted User" => "Usuario no aceptado",
"No tasks entered" => "No se entraron tareas",
"Select One" => "Seleccione una",
"Undo Trash" => "Deshacer papelera",
"Show:" => "Mostrar:",
"Received" => "Recivido",
"Submitted" => "Enviado",
"Shared" => "Compartida",
"All Shared Tasks" => "Todas las tareas compartidas",
"completed (100%)" => "completada (100%)",
"Public for group" => "Publica para grupo",
"User Watches and preferences" => "Avisos de usuario y preferencias",
"You need to set your email to receive email notifications" => "Necesitas poner tu correo-e para recibir notificaciones por correo-e",
"Report Preferences" => "Preferencias de los Informes",
"You are not allowed to remove this notification " => "No tienes permiso para eliminar esta notificación ",
"Use reports to summarise notifications about objects you are watching" => "Usa informes periódicos para resumir las notificaciones sobre los objetos que estás siguiendo",
"Use reports" => "Usa informes periódicos",
"Interval in which you want to get the reports" => "Intervalo en el que quieres recibir los informes periódicos",
"Monthly" => "Mensual",
"Short report" => "Informe breve",
"Detailed report" => "Informe detallado",
"HTML-Email" => "Correo en HTML",
"Send me an email also if nothing happened" => "Envíame un correo-e también si no ocurre nada",
"My watches" => "Mis alertas por correo-e",
"Use \"watches\" to monitor wiki pages or other objects" => "Usa \"alertas por correo-e\" para monitorizar cambios en páginas wiki u otros objetos",
"Watch new items by clicking the {icon _id=eye} button on specific pages" => "Sigue por correo-e los ítems nuevos a través de clicar en el botón del ojo {icon _id=eye} sobre páginas específicas",
"Add Watch" => "Añade Alerta por correo-e",
"Select event type" => "Selecciona tipo de evento",
"All watched events" => "Todos los eventos seguidos por correo-e",
"A user submits a blog post" => "Un usuario envía una publicación en un blog",
"A user posts a forum thread" => "Un usario escribe un mensaje en un foro",
"A user posts a forum topic" => "Un usuario inicia un tema en un foro",
"A user edited or commented on a wiki page" => "Un usuario edita o comenta una página wiki",
"A user edited a wiki page" => "Un usuario editó una página wiki",
// "{\$w.type}" => "{\$w.type}",
"Used space" => "Espacio usado",
"up to" => "hasta",
"no limit for admin" => "sín límite para administradores",
"May need to refresh twice to see changes" => "Puede tener que refrescar 2 veces para ver cambios",
"Add top level bookmarks to menu" => "Añadir marcadores del nivel principal al menú",
"Add or edit an item" => "Añadir o editar un item",
"New Window" => "Nueva ventana",
"replace window" => "reemplazar ventana",
"Pos" => "Pos",
"User_versions_for" => "Versiones del usuario para",
// "{\$topic|escape}" => "{\$topic|escape}",
// "{\$type|escape}" => "{\$type|escape}",
"Monitor Articles" => " Sigue por Correo-e los Artículos",
"Stop Monitoring Articles" => "Deja de Seguir por Correo-e los Artículos",
"Published At" => "Publicado el",
// "{\$listpages[ix].topicName}" => "{\$listpages[ix].topicName}",
"No articles yet" => "Sin artículos aún",
"Add an article" => "Añade un artículo",
"Banner stats" => "Estadisticas de Banner",
"Create new banner" => "Crear nuevo banner",
"Banner Information" => "Información de Banner",
"Click ratio" => "Click ratio",
"Weekdays" => "Días de semana",
"mon" => "lun",
"tue" => "mar",
"wed" => "mié",
"thu" => "jue",
"fri" => "vie",
"sat" => "sáb",
"sun" => "dom",
"Banner raw data" => "Datos crudos del banner",
"Monitor this Blog" => "Monitorizar este blog",
"Stop Monitoring this Blog" => "Dejar de monitorizar este blog",
"Cached" => "Cacheado",
"This is a cached version of the page." => "Esta es la versión cacheada de la página.",
"Click here to view the Google cache of the page instead." => "Click aquí para ver el cache de Google de la página.",
// "{\$faq_info.title}" => "{\$faq_info.title}",
// "There are no questions in this FAQ" => "There are no questions in this FAQ",
"Answers" => "Respuestas",
"Add Suggestion" => "Agregar sugerencia",
"Forum List" => "Lista de foros",
"Edit Forum" => "Editar Foro",
// "Manage Message Queue" => "Manage Message Queue",
// "Manage Reported Messages" => "Manage Reported Messages",
"Monitor Topics of this Forum" => "Sigue por correo-e los temas de este Foro",
"Stop Monitoring Topics of this Forum" => "Deja de seguir por correo-e los temas de este Foro",
"Monitor Topics and Threads of this Forum" => "Sigue por correo-e los temas nuevos e hilos de discusión (sus respuestas) de este Foro",
"Stop Monitoring Topics and Threads of this Forum" => "Deja de seguir por correo-e los temas nuevos e hilos de discusión (sus respuestas) de este Foro",
"Group Monitor Topics of this Forum" => "Fuerza a un grupo a seguir por correo-e los temas de este Foro",
"Group Monitor Topics and Threads of this Forum" => "Fuerza a un grupo a seguir por correo-e los temas e hilos de discusión (sus respuestas) de este Foro",
"Post New" => "Nueva publicación",
"Watch for replies" => "Sigue las respuestas",
"Send me an e-mail when someone replies to my topic" => "Envíame un mensaje de correo-e cuando alguien responda al mi tema",
"Don't send me any e-mails" => "No me envíes ningún mensaje de correo-e",
"Enter your name" => "Introduce tu nombre",
"Editing posts" => "Edición de publicaciones",
"for links" => "para enlaces",
"HTML tags are not allowed inside posts" => "Etiquetas HTML no estan permitidos dentro de mensajes",
"Moderator Actions" => "Acciones de moderador",
"Move Selected Topics" => "Mover temas seleccionados",
"Unlock Selected Topics" => "Desbloquear temas seleccionados",
"Lock Selected Topics" => "Bloquear temas seleccionados",
"Delete Selected Topics" => "Borrar temas seleccionados",
"Merge" => "Combinar",
"Merge Selected Topics" => "Combinar temas seleccionados",
"Reported Messages:" => "Mensajes reportados:",
"Queued Messages:" => "Mensajes en cola:",
"Merge into topic" => "Combinar en tema",
"Emot" => "Emot",
"pts" => "pts",
// "Atts" => "Atts",
// "Forum Lock" => "Forum Lock",
"posts in this forum" => "publicaciones en este foro",
"Filter Posts" => "Filtra publicaciones",
"Jump to forum" => "Saltar a foro",
"Posts Filtering" => "Filtrado de Publicaciones",
"Last post date" => "Fecha de la última publicación",
"All posts" => "Todos los mensajes",
"Last hour" => "Última hora",
"Last 24 hours" => "Últimas 24 horas",
"Last 48 hours" => "Últimas 48 horas",
// "Show archived posts" => "Show archived posts",
"Containing posts by" => "Conteniendo publicaciones por",
"Me" => "Mi",
"normal" => "normal",
"announce" => "anuncio",
"hot" => "hot",
"Posts with no replies" => "Publicaciones sin respuesta",
// "Archived" => "Archived",
"Topic List" => "Lista de Temas",
// "The post has been reported and will be reviewed by a moderator" => "The post has been reported and will be reviewed by a moderator",
"prev topic" => "tema ant",
"next topic" => "tema sig",
"You are viewing a reply to" => "Estás viendo una respuesta a",
"Print this page only" => "Imprime sólo esta página",
"Print all pages" => "Imprime todas las páginas",
"Show posts" => "Mostrar mensajes",
// "View Invoice" => "View Invoice",
// "Invoice %0" => "Invoice %0",
// "Date Issued %0" => "Date Issued %0",
// "Amount: %0" => "Amount: %0",
// "Total: %0" => "Total: %0",
// "Payment Terms: %0" => "Payment Terms: %0",
// "Back to Page" => "Back to Page",
"Already being edited by" => "Ya está siendo editada por",
"Tiki Sheet" => "Planilla Tiki",
"Save current spreadsheet" => "Guarda la hoja de cálculo actual",
"Cancel editing current spreadsheet" => "Cancela la edición de la horja de cálculo actual",
"No parse" => "Sin interpretación",
"What would you like to add" => "¿Qué querrías añadir",
"New spreadsheet" => "Nueva Hoja de cálculo",
"Existing spreadsheet" => "Hoja de cálculo existente",
"Tracker as a spreadsheet" => "Formulario-bd como hoja de cálculo",
"Spreadsheet from file gallery" => "Hoja de cálculo de galería de archivos",
"Cell" => "Celda",
"Set Reference" => "Fija la Referencia",
"Un-Merge" => "Des-fusiona",
"Adds an additional row to bottom of the spreadsheet" => "Añade una fila adicional al final de la Hoja de cálculo",
"Add Row" => "Añadir fila",
"Adds an additional rows to bottom of the spreadsheet" => "Añade filas adicionales al final de la Hoja de cálculo",
"Add Multi-Rows" => "Añadir Multi-Filas",
// "Delets the current row thats highlighted" => "Delets the current row thats highlighted",
// "Delete Row" => "Delete Row",
// "Inserts an additional row after currently selected row" => "Inserts an additional row after currently selected row",
// "Insert Row Before" => "Insert Row Before",
// "Insert Row After" => "Insert Row After",
// "Unhides all the hidden rows" => "Unhides all the hidden rows",
"Show All" => "Mostrar todo",
// "Hides or shows the currently selected row" => "Hides or shows the currently selected row",
// "Toggle Hide Row" => "Toggle Hide Row",
// "Adds an additional column to the right of the spreadsheet" => "Adds an additional column to the right of the spreadsheet",
// "Add Column" => "Add Column",
// "Adds an additional columns to the right of the spreadsheet" => "Adds an additional columns to the right of the spreadsheet",
// "Add Multi-Columns" => "Add Multi-Columns",
// "Deletes the current column thats highlighted" => "Deletes the current column thats highlighted",
// "Delete Column" => "Delete Column",
// "Inserts an additional column after currently selected column" => "Inserts an additional column after currently selected column",
// "Insert Column Before" => "Insert Column Before",
// "Insert Column After" => "Insert Column After",
// "Fill down current cell value" => "Fill down current cell value",
// "Fill Down" => "Fill Down",
// "Fill up current cell value" => "Fill up current cell value",
// "Fill Up" => "Fill Up",
// "Unhides all the hidden columns" => "Unhides all the hidden columns",
// "Hides or shows the currently selected column" => "Hides or shows the currently selected column",
// "Toggle Hide Column" => "Toggle Hide Column",
// "Add new spreadsheet" => "Add new spreadsheet",
// "Add Spreadsheet" => "Add Spreadsheet",
// "Delete the current spreadsheet" => "Delete the current spreadsheet",
// "Delete Spreadsheet" => "Delete Spreadsheet",
// "Recompiles the current sheet" => "Recompiles the current sheet",
// "Change the title of the sheet" => "Change the title of the sheet",
// "Wrap Cell Range" => "Wrap Cell Range",
// "Wrap with SUM" => "Wrap with SUM",
// "Wrap with CEILING" => "Wrap with CEILING",
// "Wrap with COUNT" => "Wrap with COUNT",
// "Wrap with MAX" => "Wrap with MAX",
// "Wrap with MIN" => "Wrap with MIN",
// "Redo" => "Redo",
// "Toggle State" => "Toggle State",
// "Function Reference" => "Function Reference",
// "Usage Example: =SUM(SUM(A1:B1) + SUM(D7))" => "Usage Example: =SUM(SUM(A1:B1) + SUM(D7))",
// "=(TRUE(N(A1)) || FALSE(N(B1)))" => "=(TRUE(N(A1)) || FALSE(N(B1)))",
// "Returns the absolute value of a number" => "Returns the absolute value of a number",
// "Returns a rounded number" => "Returns a rounded number",
// "Returns a number rounded up based on a multiple of significance" => "Returns a number rounded up based on a multiple of significance",
// "Counts the number of cells that contain a value" => "Counts the number of cells that contain a value",
// "Counts full days from a specific date - format(YYYY,MM,DD)" => "Counts full days from a specific date - format(YYYY,MM,DD)",
// "Converts a number to text, using a currency format - options(number, decimals, symbol)" => "Converts a number to text, using a currency format - options(number, decimals, symbol)",
// "Returns a logical value of FALSE" => "Returns a logical value of FALSE",
// "Returns a text representation of a number rounded to a specified number of decimal places - options(number, decimals, useCommas)" => "Returns a text representation of a number rounded to a specified number of decimal places - options(number, decimals, useCommas)",
// "Returns a number rounded down based on a multiple of significance" => "Returns a number rounded down based on a multiple of significance",
// "Returns the integer portion of a number" => "Returns the integer portion of a number",
// "Returns the largest value from the numbers provided" => "Returns the largest value from the numbers provided",
// "Returns the smallest value from the numbers provided" => "Returns the smallest value from the numbers provided",
// "Converts a value to a number" => "Converts a value to a number",
// "Gets full date of today" => "Gets full date of today",
// "Returns the mathematical constant called pi, which is 3.14159265358979" => "Returns the mathematical constant called pi, which is 3.14159265358979",
// "Returns the result of a number raised to a given power" => "Returns the result of a number raised to a given power",
// "Returns a random number that is greater than or equal to 0 and less than 1" => "Returns a random number that is greater than or equal to 0 and less than 1",
// "Returns a number rounded to a specified number of digits" => "Returns a number rounded to a specified number of digits",
// "Returns all of the values in each of the specified cells and added together" => "Returns all of the values in each of the specified cells and added together",
// "Returns a logical value of TRUE" => "Returns a logical value of TRUE",
// "Converts a text value that represents a number to a number" => "Converts a text value that represents a number to a number",
// "Italics" => "Italics",
// "Uppercase" => "Uppercase",
// "Capitalize" => "Capitalize",
// "Lowercase" => "Lowercase",
// "Font Size +" => "Font Size +",
// "Font Size -" => "Font Size -",
"Items found:" => "Ítems encontrados:",
"lastModif" => "última modificación",
"atts" => "adjuntos",
"List Attachments" => "Listar Archivos asociados",
"View/Edit" => "Visualizar/Editar",
"Insert New Item" => "Insertar item",
"View inserted item" => "Ver ítem insertado",
"Insert new item" => "Insertar item",
// "Synchronization" => "Synchronization",
// "This tracker is a remote copy of <a href=\"%0\">%0</a>" => "This tracker is a remote copy of <a href=\"%0\">%0</a>",
// "It was last updated on %0" => "It was last updated on %0",
// "Reload field definitions" => "Reload field definitions",
// "Items added locally" => "Items added locally",
// "Push new items" => "Push new items",
// "Safe modifications (no remote conflict)" => "Safe modifications (no remote conflict)",
// "Dangerous modifications (remote conflict)" => "Dangerous modifications (remote conflict)",
// "On push, local items will be removed until data reload" => "On push, local items will be removed until data reload",
// "Push local changes" => "Push local changes",
// "Local changes will be lost" => "Local changes will be lost",
// "When reloading the data from the source, all local changes will be lost" => "When reloading the data from the source, all local changes will be lost",
// "New items that must be preserved should be pushed using the above controls" => "New items that must be preserved should be pushed using the above controls",
// "Modifications that must be preserved should be replicated" => "Modifications that must be preserved should be replicated",
// "Without conflicts: Using the above controls" => "Without conflicts: Using the above controls",
// "With conflicts: Manually on the source" => "With conflicts: Manually on the source",
// "Using the above controls will cause information loss" => "Using the above controls will cause information loss",
// "Reload data from source" => "Reload data from source",
"Local" => "Local",
// "Remote" => "Remote",
"View Item" => "Ver Ítem",
// "Translations" => "Translations",
"Move to another tracker" => "Mover a otro formulario-bd",
"Back to Items list" => "Regresar a la lista de Ítems",
"Back to Items List" => "Regresar a la Lista de Ítems",
"Special Operations" => "Operaciones Especiales",
"close" => "cerrar",
// "Open Tiki WebDAV (Wiki pages) as WebFolder" => "Open Tiki WebDAV (Wiki pages) as WebFolder",
// "Open Tiki WebDAV as WebFolder" => "Open Tiki WebDAV as WebFolder",
// "Personal e-mail accounts" => "Personal e-mail accounts",
// "This is the active account" => "This is the active account",
// "IMAP" => "IMAP",
// "Mbox" => "Mbox",
// "Maildir" => "Maildir",
// "POP3" => "POP3",
// "Group e-mail accounts" => "Group e-mail accounts",
// "Incoming servers (used in this order)" => "Incoming servers (used in this order)",
// "IMAP server" => "IMAP server",
// "Mbox filepath" => "Mbox filepath",
// "Maildir mail directory" => "Maildir mail directory",
// "Use SSL" => "Use SSL",
// "Outgoing server" => "Outgoing server",
// "From email" => "From email",
// "Uses current in preferences if empty" => "Uses current in preferences if empty",
// "No email set" => "No email set",
// "Account details" => "Account details",
// "Group (shared mail inbox) or private" => "Group (shared mail inbox) or private",
// "This will be a group mail account" => "This will be a group mail account",
// "This will be a personal mail account" => "This will be a personal mail account",
// "Auto-refresh page time" => "Auto-refresh page time",
// "seconds (0 = no auto refresh)" => "seconds (0 = no auto refresh)",
// "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission" => "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission",
// "Show Unread" => "Show Unread",
// "Show Flagged" => "Show Flagged",
// "Auto refresh set for every \$autoRefresh seconds" => "Auto refresh set for every \$autoRefresh seconds",
// "Refresh now" => "Refresh now",
// "Group messages" => "Group messages",
// "unFlagged" => "unFlagged",
"Clip" => "clip",
"Back To Mailbox" => "volver a buzón de correo",
"Full Headers" => "ver cabeceras",
"Normal Headers" => "cabeceras normales",
"Reply To All" => "responder a todos",
"Forward" => "enviar",
// "Part" => "Part",
"Select from address book" => "elegir desde libreta de direcciones",
"Use HTML mail" => "Usar correo HTML",
"The following addresses are not in your address book" => "Las siguientes direcciones no están en su libreta de direcciones",
"Add Contacts" => "Añadir contactos",
"Attachment 1" => "Adjunto 1",
"Attachment 2" => "Adjunto 2",
"Attachment 3" => "Adjunto 3",
"Address book" => "Libreta de direcciones",
// "TOC" => "TOC",
"Parent page" => "Página superior",
"Child" => "Hijo/a",
"page id" => "id de página",
// "View edit icons" => "View edit icons",
"3d browser" => "navegador 3d",
"Page is NOT being monitored. Click icon to START monitoring." => "NO estás siguiendo está página por correo-e. Haz clic en el icono para EMPEZAR a seguirla.",
"Page IS being monitored. Click icon to STOP monitoring." => "ESTÁS siguiendo está página por correo-e. Haz clic en el icono para DEJAR de seguirla.",
"Group Monitor on Structure" => "Subscribe a un grupo a seguir esta estructura de páginas por correo-e",
// "Hide structure bar" => "Hide structure bar",
// "Hide structure" => "Hide structure",
"More types available" => "Más tipos disponibles",
"More field types may be enabled from the <a href=\"%0\">administration panel</a>" => "Se pueden habilitar más tipos de campos de formularios-bd desde el <a href=\"%0\">panel de administración</a>",
"Contact your administrator to see if they can be enabled. The complete field type list is available in the <a rel=\"external\" class=\"external\" href=\"%0\">documentation</a>" => "Contacta a los administradores para ver si los pueden habilitar. La lista completa de campos está disponible en la <a rel=\"external\" class=\"external\" href=\"%0\">documentación</a>",
"Description contains wiki syntax" => "La descripción contiene sintaxis wiki",
"Restrict visibility to administrators" => "Restringe visibilidad a los administradores",
"Useful if you are working on a live tracker" => "Útil si estás trabajando en un formulario funcionando en vivo",
"Add Field &amp; Edit Advanced Options" => "Añade el Campo &amp; Edita las Opciones Avanzadas",
"New tracker created" => "Se ha creado el nuevo Formulario-bd",
"Return to Trackers" => "Regresa a los Formularios-bd",
"Options for %0" => "Opciones para %0",
"Separate multiple with commas" => "Separa multiples valores con comas",
"Error Message" => "Mensaje de Error",
"Visible by all" => "Visible por todos",
"Visible by administrators only" => "Visible sólo por administradores",
"Editable by administrators only" => "Editable sólo por administradores",
"Editable by administrators and creator only" => "Editable sólo por administradores y creador/a",
"Creator requires a user field with auto-assign to creator (1)" => "La opción relacionada con Creador requiere un campo de usuario con la opció de auto-asignado al creador (1)",
"Visible by" => "Visible por",
"Editable by" => "Editable por",
// "Changing the permanent name may have consequences in integrated systems" => "Changing the permanent name may have consequences in integrated systems",
"Quick Export" => "Exportación Rápida",
"Produce a CSV with basic formatting" => "Produce un CSV con formato básico",
"Export Tracker Items" => "Exporta Ítems de Formularios-bd",
// "ISO-8859-1 Latin" => "ISO-8859-1 Latin",
// "Delimitor (left)" => "Delimitor (left)",
// "Delimitor (right)" => "Delimitor (right)",
// "Carriage return inside field value" => "Carriage return inside field value",
// "Export dates as UNIX Timestamps to facilitate importing" => "Export dates as UNIX Timestamps to facilitate importing",
// "Export ItemLink type fields as the itemId of the linked item (to facilitate importing)" => "Export ItemLink type fields as the itemId of the linked item (to facilitate importing)",
// "Export country type fields as the system name of the country (to facilitate importing)" => "Export country type fields as the system name of the country (to facilitate importing)",
// "Parse as wiki text" => "Parse as wiki text",
// "Generic information" => "Generic information",
// "Number of records" => "Number of records",
// "First record" => "First record",
"Tracker Export" => "Exporta Formulario-bd",
// "Profile Export" => "Profile Export",
// "Produce YAML for a profile" => "Produce YAML for a profile",
// "Linked tracker and field IDs (such as those referenced in ItemLink, ItemsList field options, for instance) are not currently converted to profile object references, so will need manual replacement" => "Linked tracker and field IDs (such as those referenced in ItemLink, ItemsList field options, for instance) are not currently converted to profile object references, so will need manual replacement",
// "For example: \$profileobject:field_ref\$" => "For example: \$profileobject:field_ref\$",
// "Export Profile" => "Export Profile",
// "YAML Export" => "YAML Export",
// "Profile for trackerId %0" => "Profile for trackerId %0",
// "Import fields for this tracker" => "Import fields for this tracker",
// "Imported file '%0'" => "Imported file '%0'",
// "Import completed with '%0'" => "Import completed with '%0'",
// "The order of the fields does not matter, but you need to add a header with the field names" => "The order of the fields does not matter, but you need to add a header with the field names",
// "Add \" -- \" to the end of the fields in the header that you would like to import" => "Add \" -- \" to the end of the fields in the header that you would like to import",
// "Auto-incremented itemid fields shall be included with no matter what values" => "Auto-incremented itemid fields shall be included with no matter what values",
// "UNIX Timestamp" => "UNIX Timestamp",
// "Character encoding" => "Character encoding",
// "Create as new items" => "Create as new items",
// "Update lastModif date if updating items (status and created are updated only if the fields are specified in the csv)" => "Update lastModif date if updating items (status and created are updated only if the fields are specified in the csv)",
// "Convert values of ItemLink type fields from the value in the CSV file to the itemId of the linked item. Requires the linked item to be correctly set up in advance" => "Convert values of ItemLink type fields from the value in the CSV file to the itemId of the linked item. Requires the linked item to be correctly set up in advance",
// "Do you really want to remove the %0 tracker" => "Do you really want to remove the %0 tracker",
// "Back to tracker list" => "Back to tracker list",
// "Are you sure you want to remove the fields? Data will be lost" => "Are you sure you want to remove the fields? Data will be lost",
// "Remove Fields" => "Remove Fields",
// "Return to field administration" => "Return to field administration",
// "Are you sure you want to delete this item" => "Are you sure you want to delete this item",
// "Delete item" => "Delete item",
// "Description is wiki-parsed" => "Description is wiki-parsed",
// "Allow ratings (deprecated, use rating field)" => "Allow ratings (deprecated, use rating field)",
// "Rating options" => "Rating options",
// "Show ratings in listing" => "Show ratings in listing",
// "Show comments in listing" => "Show comments in listing",
// "Display last comment author and date" => "Display last comment author and date",
// "Display attachments in listing" => "Display attachments in listing",
// "Attachment attributes (sortable)" => "Attachment attributes (sortable)",
// "Show status to tracker administrator only" => "Show status to tracker administrator only",
// "Show creation date when listing items" => "Show creation date when listing items",
// "Creation date format" => "Creation date format",
// "Show item creator" => "Show item creator",
// "Show creation date when viewing items" => "Show creation date when viewing items",
// "Show last modification date when listing items" => "Show last modification date when listing items",
// "Show item last modifier" => "Show item last modifier",
// "Modification date format" => "Modification date format",
// "Show last modification date when viewing items" => "Show last modification date when viewing items",
// "Default sort direction" => "Default sort direction",
// "Hide empty fields from item view" => "Hide empty fields from item view",
// "List detail pop-up" => "List detail pop-up",
// "Comma-separated list of field IDs" => "Comma-separated list of field IDs",
// "Template to display an item" => "Template to display an item",
// "wiki:pageName for a wiki page or tpl:tplName for a template" => "wiki:pageName for a wiki page or tpl:tplName for a template",
// "Template to edit an item" => "Template to edit an item",
// "New item status" => "New item status",
// "Modified item status" => "Modified item status",
"No change" => "No cambiar",
"Default status displayed in list mode" => "Estado por defecto mostrado en modalidad de lista",
"Notifications" => "Notificaciones",
// "Copy activity to email" => "Copy activity to email",
"Use simplified e-mail format" => "Usar formato simplificado de correo",
// "The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender" => "The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender",
// "Publish RSS feed for this tracker" => "Publish RSS feed for this tracker",
// "Requires \"RSS per tracker\" to be set in Admin/RSS" => "Requires \"RSS per tracker\" to be set in Admin/RSS",
// "(Currently set)" => "(Currently set)",
// "(Currently not set)" => "(Currently not set)",
// "Group alerted on item modification" => "Group alerted on item modification",
// "Allow user selection for small groups" => "Allow user selection for small groups",
// "Item creator can modify his items" => "Item creator can modify his items",
// "The tracker needs a user field with the auto-assign activated" => "The tracker needs a user field with the auto-assign activated",
// "Item creator can remove his items" => "Item creator can remove his items",
// "User can take ownership of item created by anonymous" => "User can take ownership of item created by anonymous",
// "Only one item per user or IP" => "Only one item per user or IP",
// "The tracker needs a user or IP address field with the auto-assign activated" => "The tracker needs a user or IP address field with the auto-assign activated",
// "Members of the creator group can modify items" => "Members of the creator group can modify items",
// "The tracker needs a group field with the auto-assign activated" => "The tracker needs a group field with the auto-assign activated",
// "Members of the creator group can remove items" => "Members of the creator group can remove items",
// "Creation date constraint" => "Creation date constraint",
// "Auto-create corresponding categories" => "Auto-create corresponding categories",
// "Create a group for each item" => "Create a group for each item",
// "Groups will include" => "Groups will include",
// "Creator is assigned to the group" => "Creator is assigned to the group",
// "Will become the creator's default group" => "Will become the creator's default group",
// "Will become the new item's group creator" => "Will become the new item's group creator",
// "Copy the default group in the field ID before updating the group" => "Copy the default group in the field ID before updating the group",
// "{\$sc.label|escape}" => "{\$sc.label|escape}",
// "Admin Fields" => "Admin Fields",
// "It is very likely that authentication will be required to access this data on the remote site. Configure the authentication source from Admin DSN" => "It is very likely that authentication will be required to access this data on the remote site. Configure the authentication source from Admin DSN",
// "Notification" => "Notification",
// "Do you really want to remove the scheduled event" => "Do you really want to remove the scheduled event",
// "No events registered" => "No events registered",
// "Reference date" => "Reference date",
// "After creation" => "After creation",
// "After last modification" => "After last modification",
// "Delay prior to status change" => "Delay prior to status change",
// "Mail subject text" => "Mail subject text",
// "Mail body ressource" => "Mail body ressource",
// "wiki:pageName for a wiki page or tplName.tpl for a template" => "wiki:pageName for a wiki page or tplName.tpl for a template",
"(automatically generated after item creation)" => "(generado automáticamente después de la creación del ítem)",
"Hold \"Ctrl\" in order to select multiple values" => "Mantén presionada la tecla \"Ctrl\" para poder seleccionar valores múltiples",
"Upload files" => "Subir archivos",
"Attached files limitation" => "Limitación para los archivos adjuntos",
"The amount of files that can be attached is limited to <strong>%0</strong>. Additional files uploaded will still be uploaded to the server and searchable, but they will not be attached to this item. Make sure you remove the files no longer required before you save your changes" => "Se ha limitado a <strong>%0</strong> la cantidad de archivos que pueden ser adjuntados. Los archivos adicionales que se suban  serán guardados en el servidor y serán buscables, pero no serán mostrados como adjuntos a este ítem. Asegúrate que eliminas los archivos que ya no sean requeridos antes de guardar tus cambios",
"Drop files from your desktop here or browse for them" => "Deja caer aquí desde tu escritorio los archivos o navega a través del botón de debajo para escógelos",
"Existing files" => "Archivos existentes",
"Search query" => "Texto a buscar",
"Select Icon" => "Select Icon",
"Remove Image" => "Elimina Imagen",
"Are you sure you want to delete this image" => "¿Estás seguro que quieres borrar esta imagen",
"Character Count:" => "Recuento de caracteres:",
// "Administrator intervention required" => "Administrator intervention required",
// "Freetags is not enabled" => "Freetags is not enabled",
"You did not vote yet" => "No has votado todavía",
"My rating" => "Mi valoración",
// "{\$field.labels[i]}" => "{\$field.labels[i]}",
"Click to vote for this value" => "Haz clic para votar por este valor",
"Click to delete your vote" => "Haz clic para borrar tu voto",
// "Language: %0" => "Language: %0",
"You have ever subscribed" => "Ya te has suscrito alguna vez",
"You have not yet subscribed" => "Aún no te has suscrito",
"with" => "con",
"friends" => "amistades",
// "Current language" => "Current language",
// "Show all translations of this page on a single page" => "Show all translations of this page on a single page",
// "All languages" => "All languages",
// "Google translate" => "Google translate",
// "Machine translations" => "Machine translations",
// "Translate page" => "Translate page",
// "Manage page translations" => "Manage page translations",
// "Translate article" => "Translate article",
// "Manage article translations" => "Manage article translations",
// "Maintenance" => "Maintenance",
// "Are you sure you want to detach these translations" => "Are you sure you want to detach these translations",
// "Current translation set" => "Current translation set",
// "Are you sure you want to detach the translation" => "Are you sure you want to detach the translation",
// "No translations available at this time" => "No translations available at this time",
// "Add a new object to the set" => "Add a new object to the set",
// "All possible translations exist" => "All possible translations exist",
// "Objects that contain the more terms are rated higher in the results and will appear first" => "Objects that contain the more terms are rated higher in the results and will appear first",
// "objects that include both tokenized terms" => "objects that include both tokenized terms",
// "Boolean operators" => "Boolean operators",
// "You can use AND or OR or NOT also to do a boolean search" => "You can use AND or OR or NOT also to do a boolean search",
// "Example: <strong>wiki and forum</strong> will find objects with both terms" => "Example: <strong>wiki and forum</strong> will find objects with both terms",
// "Example: <strong>wiki or forum</strong> will find objects with one of the term" => "Example: <strong>wiki or forum</strong> will find objects with one of the term",
// "Example: <strong>wiki and (forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order" => "Example: <strong>wiki and (forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order",
// "Use double quotes ( \" \" ) around a phrase to find terms in the exact order, next to each other" => "Use double quotes ( \" \" ) around a phrase to find terms in the exact order, next to each other",
// "Example: <strong>\"Alex Bell\"</strong> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong> but <strong>Alex Bells</strong>. " => "Example: <strong>\"Alex Bell\"</strong> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong> but <strong>Alex Bells</strong>. ",
// "However, no account is associated to the OpenID identifier" => "However, no account is associated to the OpenID identifier",
// "If you use an email filter, be sure to add %0 to your accepted list" => "If you use an email filter, be sure to add %0 to your accepted list",
// "Associate OpenID with an existing Tiki account" => "Associate OpenID with an existing Tiki account",
// "Use this thread to discuss the page" => "Use this thread to discuss the page",
// "Missing or incorrect trackerId parameter for the plugin" => "Missing or incorrect trackerId parameter for the plugin",
"List Trackers" => "Listar Formularios-bd",
"Add Tag" => "Añade una marca (tag)",
"Subtract" => "Eliminar",
"Meeting ID" => "ID del Encuentro",
"Current attendees" => "Asistentes actuales",
"No attendees at this time" => "Sin asistentes en este momento",
"Last time we checked, the room you requested did not exist" => "La última vez que lo comprobamos, la sala que has pedido no se había creado aún",
"Current recordings" => "Grabaciones actuales",
"On %0 from %1 to %2" => "El %0 desde la/s %1 hasta la/s %2",
// "{\$button_label}" => "{\$button_label}",
"list" => "lista",
// "{\$ftptitle}" => "{\$ftptitle}",
// "Lon." => "Lon.",
// "Lat." => "Lat.",
"Zoom" => "Zoom",
"saving.." => "guardando..",
"Save current map view as user default" => "Guarda la visualizaación actual del mapa como la que se muestre por omisión al usuario/a",
"Save as user location" => "Guarda como la localización del usuario",
"Save as object location" => "Guarda como la localización del objeto",
"Number of Users" => "Número de usuarios",
"Percentage of Total" => "Porcentaje del Total",
"Email address the person you want to invite" => "Correo-e de la persona a la que quieres invitar",
"Set in these groups" => "Fijar en estos grupos",
"Message sent to" => "Mensaje enviado a",
"Email sent to" => "Correo-e enviado a",
"Emails number" => "Número de correos-e",
"Send Mail" => "Envía Correo-e",
"Send to users" => "Envía a los usuarios/as",
"Send to" => "Envía a",
"Email separated by comma" => "Correos-e separados por comas",
"Send to groups" => "Envía a grupos",
"Preview Mail" => "Previsualiza correo-e",
// "Check to remove" => "Check to remove",
// "Add in group" => "Add in group",
// "Set as default group for users" => "Set as default group for users",
// "Join myself" => "Join myself",
// "Leave myself" => "Leave myself",
// "%0 year" => "%0 year",
// "%0 years" => "%0 years",
// "%0 days" => "%0 days",
// "Membership term commences on %0-%1 each year" => "Membership term commences on %0-%1 each year",
// "Membership commences on %0 day of each month" => "Membership commences on %0 day of each month",
// "Cost for one period" => "Cost for one period",
// "Free for the rest of the current period, a prorated value of" => "Free for the rest of the current period, a prorated value of",
// "Prorated cost for first period" => "Prorated cost for first period",
// "Special offer! Free additional periods" => "Special offer! Free additional periods",
// "Membership to %0 for %1 year at %2 %3" => "Membership to %0 for %1 year at %2 %3",
// "Membership to %0 for %1 years at %2 %3" => "Membership to %0 for %1 years at %2 %3",
// "Membership to %0 for %1 days at %2 %3" => "Membership to %0 for %1 days at %2 %3",
// "separated by |" => "separated by |",
// "{\$periodslabel}" => "{\$periodslabel}",
// "Re-Apply" => "Re-Apply",
// "Undecided" => "Undecided",
// "No relations found" => "No relations found",
// "{\$snarfParams.ajax|escape:html}" => "{\$snarfParams.ajax|escape:html}",
// "Last Day" => "Last Day",
// "Last Week" => "Last Week",
// "{\$action}" => "{\$action}",
// "Groups you are in" => "Groups you are in",
// "(This is an included group)" => "(This is an included group)",
// "(You are a leader)" => "(You are a leader)",
// "Your default group" => "Your default group",
// "Leave Group" => "Leave Group",
// "Manage Group" => "Manage Group",
// "Change default group" => "Change default group",
// "Subscribe to a group" => "Subscribe to a group",
// "Groups you can join" => "Groups you can join",
// "This group requires approval to join" => "This group requires approval to join",
// "Subscribe to groups" => "Subscribe to groups",
// "Subscribe to the newsletter" => "Subscribe to the newsletter",
"Mini TimeSheet" => "Mini HojadeTiempo",
"Full View" => "Vista completa",
// "{\$export_action}" => "{\$export_action}",
"Tracker - " => "Formulario-bd - ",
// "{\$checkbox.title}" => "{\$checkbox.title}",
// "Export Tracker" => "Export Tracker",
"Close item" => "Cierra ítem",
"Open item" => "Abre ítem",
"Pend item" => "Deja ítem como pendiente",
// "{\$params.label}" => "{\$params.label}",
"Please login first" => "Por favor, conéctate primero",
"Toggle display" => "Conmuta la visualización",
"Page last modified on %0 by %1" => "Última modificación de la página el %0 por %1",
"Created by %0" => "Creado/a por %0",
"Last Modification: %0 by %1" => "Última modificación: %0 por %1",
"Creator &amp; Last Editor" => "Creador &amp; Último editor",
"as Creator &amp; Last Editor" => "cómo Creador &amp; Último Editor",
"no (disabled)" => "no (desactivado)",
// "Missing book id" => "Missing book id",
// "You do not have the right view this page" => "You do not have the right view this page",
// "Missing account id" => "Missing account id",
// "You do not have the rights to view this account" => "You do not have the rights to view this account",
// "You do not have the rights to manage accounts" => "You do not have the rights to manage accounts",
// "You do not have permissions to create a book" => "You do not have permissions to create a book",
// "You do not have permissions to close this book" => "You do not have permissions to close this book",
// "Missing journal id" => "Missing journal id",
// "You do not have the right to cancel transactions" => "You do not have the right to cancel transactions",
// "Error retrieving data from journal" => "Error retrieving data from journal",
// "You do not have the right to book" => "You do not have the right to book",
// "Don't know what to export" => "Don't know what to export",
// "You do not have the right export/view this data" => "You do not have the right export/view this data",
// "You do not have the right to book into the stack" => "You do not have the right to book into the stack",
// "Tiki Calendar" => "Tiki Calendar",
// "%0 enabled" => "%0 enabled",
// "%0 disabled" => "%0 disabled",
// "%0 set" => "%0 set",
// "%0 unset" => "%0 unset",
"Administration" => "Administración",
// "Help on Configuration Sections" => "Help on Configuration Sections",
// "%0 reset" => "%0 reset",
// "Bad request - potential cross-site request forgery (CSRF) detected. Operation blocked" => "Bad request - potential cross-site request forgery (CSRF) detected. Operation blocked",
// "Global site configuration, date formats, admin password etc" => "Global site configuration, date formats, admin password etc",
// "Switches for major features" => "Switches for major features",
// "User registration, remember me cookie settings and authentication methods" => "User registration, remember me cookie settings and authentication methods",
// "User specific features and settings" => "User specific features and settings",
// "Repository configuration, browse and apply profiles" => "Repository configuration, browse and apply profiles",
"Look & Feel" => "Apariencia",
// "Theme selection, layout settings and UI effect controls" => "Theme selection, layout settings and UI effect controls",
"Editing and Plugins" => "Edición y Plugins",
// "Text editing settings applicable to many areas. Plugin activation and plugin alias management" => "Text editing settings applicable to many areas. Plugin activation and plugin alias management",
// "Module appearance settings" => "Module appearance settings",
"Meta Tags" => "Meta Tags",
// "Information to include in the header of each page" => "Information to include in the header of each page",
// "i18n" => "i18n",
// "Internationalization and localization - mulitlingual features" => "Internationalization and localization - mulitlingual features",
// "Settings and features for maps" => "Settings and features for maps",
// "Server performance settings" => "Server performance settings",
// "Site security settings" => "Site security settings",
// "Comments settings" => "Comments settings",
// "Outgoing RSS feed setup" => "Outgoing RSS feed setup",
// "Connect" => "Connect",
// "Tiki Connect - join in" => "Tiki Connect - join in",
// "Search configuration" => "Search configuration",
// "Wiki page settings and features" => "Wiki page settings and features",
// "Defaults and configuration for file galleries" => "Defaults and configuration for file galleries",
// "Settings for blogs" => "Settings for blogs",
// "Defaults and configuration for image galleries (will be phased out in favour of file galleries)" => "Defaults and configuration for image galleries (will be phased out in favour of file galleries)",
// "Settings and features for articles" => "Settings and features for articles",
// "Settings and features for forums" => "Settings and features for forums",
// "Settings and features for trackers" => "Settings and features for trackers",
// "Settings and features for polls" => "Settings and features for polls",
// "Settings and features for calendars" => "Settings and features for calendars",
// "Settings and features for categories" => "Settings and features for categories",
// "Configure areas feature" => "Configure areas feature",
// "Values of actions for users rank score" => "Values of actions for users rank score",
// "Settings and features for freetags" => "Settings and features for freetags",
// "Settings and features for FAQs" => "Settings and features for FAQs",
// "Settings and features for directory of links" => "Settings and features for directory of links",
// "Defaults and API key for Google Maps" => "Defaults and API key for Google Maps",
// "Site-wide copyright information" => "Site-wide copyright information",
// "Message settings" => "Message settings",
"User files" => "Mis Archivos",
// "User files settings" => "User files settings",
// "Webmail settings" => "Webmail settings",
// "Wysiwyg" => "Wysiwyg",
// "Options for WYSIWYG editor" => "Options for WYSIWYG editor",
// "Banners are a common way to display advertisements and notices on a Web page" => "Banners are a common way to display advertisements and notices on a Web page",
// "InterTiki" => "InterTiki",
// "Set up links between Tiki servers" => "Set up links between Tiki servers",
// "Manage semantic wiki links" => "Manage semantic wiki links",
// "Webservices" => "Webservices",
// "Register and manage web services" => "Register and manage web services",
// "Search engine friendly url" => "Search engine friendly url",
// "Video streaming integration" => "Video streaming integration",
// "Video integration configuration" => "Video integration configuration",
// "Configure social networks integration" => "Configure social networks integration",
// "Configure share feature" => "Configure share feature",
// "Current version is up to date : <b>%0</b>" => "Current version is up to date : <b>%0</b>",
// "A new %0 major release branch is available" => "A new %0 major release branch is available",
// "Help on %0 Config" => "Help on %0 Config",
// "Must specify actionId" => "Must specify actionId",
// "Users Contributions: Addition" => "Users Contributions: Addition",
// "%s Contributions: Addition" => "%s Contributions: Addition",
// "Users Contributions: Suppression" => "Users Contributions: Suppression",
// "%s Contributions: Suppression" => "%s Contributions: Suppression",
// "Total Contributions Addition per Day" => "Total Contributions Addition per Day",
// "Total Contributions Addition per Week" => "Total Contributions Addition per Week",
// "Total Contributions Suppression per Day" => "Total Contributions Suppression per Day",
// "Total Contributions Suppression per Week" => "Total Contributions Suppression per Week",
// "Total Contributions: Addition" => "Total Contributions: Addition",
// "Total Contributions: Suppression" => "Total Contributions: Suppression",
// "Groups Contributions: Addition" => "Groups Contributions: Addition",
// "Groups Contributions: Suppression" => "Groups Contributions: Suppression",
// "white" => "white",
// "gray" => "gray",
// "silver" => "silver",
// "ivory" => "ivory",
// "whitesmoke" => "whitesmoke",
// "beige" => "beige",
// "darkgrey" => "darkgrey",
// "Multiple IP Banning" => "Multiple IP Banning",
// "Access from your localization was forbidden due to excessive spamming" => "Access from your localization was forbidden due to excessive spamming",
// "Delete comments then set banning rules" => "Delete comments then set banning rules",
// "Are you sure you want to unassign the objects of this category: " => "Are you sure you want to unassign the objects of this category: ",
// "Click here to delete the category" => "Click here to delete the category",
// "The file does not have the required header" => "The file does not have the required header",
"Edit permissions for this category" => "Editar permisos para esta categoría",
"Category can`t be parent of itself" => "Categoría no puede ser superior a si misma",
"Content Templates" => "Plantillas de contenido",
"Upload failed" => "Subida errónea",
// "Admin credits" => "Admin credits",
"All posted" => "Todos los mensajes",
"Queue anonymous posts" => "Encolar mensajes anónimos",
"Queue all posts" => "Encolar todos los mensajes",
"No attachments" => "Sin adjuntos",
"Everybody can attach" => "Todos pueden adjuntar",
"Only users with attach permission" => "Solo usuarios con permiso de adjuntar",
"Moderators and admin can attach" => "Moderadores y admin pueden adjuntar",
// "No display" => "No display",
"Date (desc)" => "Fecha (desc)",
"Date (asc)" => "Fecha (asc)",
"Score (desc)" => "Puntos (desc)",
"Replies (desc)" => "Respuestas (desc)",
"Reads (desc)" => "Lecturas (desc)",
"You have to provide a hotword and a URL" => "Tiene que proveer una palabra clave y una URL",
"Requested action is not supported on repository" => "Acción requerida no está soportada por el repositorio",
"Repository name can't be an empty" => "El nombre del repositorio no puede estar vacío",
"No repository" => "Sin repositorio",
"Search is mandatory field" => "Buscar es un campo requerido",
"File not found " => "Archivo no encontrado ",
"Requested action in not supported on repository" => "Acción requerida no esta soportada en el repositorio",
// "You need to apply the \"Invoice\" profile" => "You need to apply the \"Invoice\" profile",
"Non-existent link" => "Enlace inexistente",
"Mail-in account %s incorrect" => "Cuenta de Mail-in %s incorrecta",
"Mail-in account %s saved" => "Cuenta de mail-in %s guardada",
"Frequency should be a positive integer!" => "¡Frecuencia debe de ser un entero positivo!",
"Mail-in accounts set to be checked every %s minutes" => "Las cuentas de mail-in configuradas para chequear cada %s minutos",
"Automatic Mail-in accounts checking disabled" => "Chequeo automático de cuentas Mail-in desactivado",
"No menu indicated" => "No se indica menú",
// "Are you sure you want to delete menu id" => "Are you sure you want to delete menu id",
// "Are you sure you want to reset the Application Menu to the current system default" => "Are you sure you want to reset the Application Menu to the current system default",
// "metric_remove must be a numeric value" => "metric_remove must be a numeric value",
// "tab_remove must be a numeric value" => "tab_remove must be a numeric value",
// "assign_remove must be a numeric value" => "assign_remove must be a numeric value",
// "metric_edit must be a numeric value" => "metric_edit must be a numeric value",
// "tab_edit must be a numeric value" => "tab_edit must be a numeric value",
// "Memcache is disabled for metrics" => "Memcache is disabled for metrics",
// "tab_clearcache must be a numeric value" => "tab_clearcache must be a numeric value",
// "assign_metric must be a numeric value" => "assign_metric must be a numeric value",
// "assign_metric_edit must be a numeric value" => "assign_metric_edit must be a numeric value",
// "Assign: Invalid metric value" => "Assign: Invalid metric value",
// "Assign: Invalid tab value" => "Assign: Invalid tab value",
// "Cannot create or update metric: You need to specify a name for the metric" => "Cannot create or update metric: You need to specify a name for the metric",
// "Cannot create or update metric: Metric name must be under %0 characters in length" => "Cannot create or update metric: Metric name must be under %0 characters in length",
// "Cannot create or update metric: You need to specify a range for the metric" => "Cannot create or update metric: You need to specify a range for the metric",
// "Cannot create or update metric: You need to specify a data type for the metric" => "Cannot create or update metric: You need to specify a data type for the metric",
// "Cannot create or update metric: You need to specify a query for the metric" => "Cannot create or update metric: You need to specify a query for the metric",
// "Cannot create or update tab: You need to specify a name for the tab" => "Cannot create or update tab: You need to specify a name for the tab",
// "Cannot create or update tab: Tab name must be under %0 characters in length" => "Cannot create or update tab: Tab name must be under %0 characters in length",
// "Cannot create or update tab: You need to specify an integer range for the tab order" => "Cannot create or update tab: You need to specify an integer range for the tab order",
// "Cannot create or update tab: Tab content cannot be empty" => "Cannot create or update tab: Tab content cannot be empty",
// "Cannot create or update module: You need to specify a name for the module" => "Cannot create or update module: You need to specify a name for the module",
// "Cannot create or update module: You cannot leave the data field empty" => "Cannot create or update module: You cannot leave the data field empty",
// "A module with that \"name\" already exists, please choose another" => "A module with that \"name\" already exists, please choose another",
// "There is a problem with your custom module \"%0\": ' . '<br><br><em>' . \$e->getMessage() . '</em><br><br>' .\n\t\t\t\t\t'<span class=\"button\"><a href=\"tiki-admin_modules.php?um_edit=' . \$_REQUEST['assign_name'] . '&cookietab=2#editcreate\">' .\n\t\t\t\t\ttr('Click here to edit the module" => "There is a problem with your custom module \"%0\": ' . '<br><br><em>' . \$e->getMessage() . '</em><br><br>' .\n\t\t\t\t\t'<span class=\"button\"><a href=\"tiki-admin_modules.php?um_edit=' . \$_REQUEST['assign_name'] . '&cookietab=2#editcreate\">' .\n\t\t\t\t\ttr('Click here to edit the module",
// "Are you sure you want to delete this Custom Module" => "Are you sure you want to delete this Custom Module",
"No newsletter indicated" => "No se indica boletín",
// "Newsletter does not exist" => "Newsletter does not exist",
// "Error importing from wiki page: " => "Error importing from wiki page: ",
// "Error opening uploaded file" => "Error opening uploaded file",
// "You need to provide a username or an email" => "You need to provide a username or an email",
// "The user has no email set. No notifications will be sent" => "The user has no email set. No notifications will be sent",
"No poll indicated" => "No se indica votación",
"unsafe" => "inseguro",
"The Path to store files in the filegallery should be outside the tiki root directory" => "El camino para guardar archivos en la galería de archivos deberia estar fuera de la raiz del directorio de tiki",
"The Path to store files in the imagegallery should be outside the tiki root directory" => "El camino para guardar archivos en la galería de imágenes debe estar fuera del directorio raiz de tiki",
// "The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code" => "The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code",
// "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any HTML" => "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any HTML",
// "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement" => "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement",
// "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory" => "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory",
// "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts" => "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts",
// "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)" => "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)",
// "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users" => "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users",
// "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users" => "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users",
// "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands" => "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands",
// "Path disclosure" => "Path disclosure",
// "Path disclosure through error message" => "Path disclosure through error message",
// "SQL injection" => "SQL injection",
// "SQL injection by authenticated user" => "SQL injection by authenticated user",
// "SQL injection by authenticated user with special privileges" => "SQL injection by authenticated user with special privileges",
// "SQL injection without authentication" => "SQL injection without authentication",
// "PHP command injection" => "PHP command injection",
// "PHP command injection by authenticated user" => "PHP command injection by authenticated user",
// "PHP command injection by authenticated user with special privileges" => "PHP command injection by authenticated user with special privileges",
// "PHP command injection without authentication" => "PHP command injection without authentication",
// "File upload" => "File upload",
"File is not readable. Unable to check." => "Archivo no legible, incapaz de comprobar.",
// "This is not a Tiki file. Check if this file was uploaded and if it is dangerous" => "This is not a Tiki file. Check if this file was uploaded and if it is dangerous",
// "This is a modified File. Cannot check version. Check if it is dangerous" => "This is a modified File. Cannot check version. Check if it is dangerous",
// "This file is from another Tiki version: " => "This file is from another Tiki version: ",
// "Shoutbox Words" => "Shoutbox Words",
"You have to provide a word" => "Debe proveer una palabra",
"You do not have permission to view this page." => "No tiene permiso para acceder a la página",
"You do not have permission to edit this page." => "No se puede editar esta página",
"You must specify a page name, it will be created if it doesn't exist." => "Debe especificar un nombre de página, será creada si no existe.",
"page not added (Exists)" => "página no añadida (Existe)",
"No survey indicated" => "No se indica encuesta",
// "Tiki Cache/Sys Admin" => "Tiki Cache/Sys Admin",
// "Global" => "Global",
// "WYSIWYG Plugin" => "WYSIWYG Plugin",
// "Are you sure you want to delete all your custom tools" => "Are you sure you want to delete all your custom tools",
// "Are you sure you want to delete this custom tool" => "Are you sure you want to delete this custom tool",
// "Are you sure you want to remove this topic" => "Are you sure you want to remove this topic",
// "Are you sure you want to remove this topic AND all the articles related" => "Are you sure you want to remove this topic AND all the articles related",
"No tracker indicated" => "No se ha indicado ningún formulario-bd",
"You don't have permission to use this feature" => "No tiene permiso para usar esta función",
// "Are you sure you want to create a new group" => "Are you sure you want to create a new group",
// "Are you sure you want to add this user" => "Are you sure you want to add this user",
// "Are you sure you want to ban the user \"%0\" from the group \"%1\"" => "Are you sure you want to ban the user \"%0\" from the group \"%1\"",
// "Are you sure you want to unban the user \"%0\" from the group \"%1\"" => "Are you sure you want to unban the user \"%0\" from the group \"%1\"",
"Group already exists" => "El grupo ya existe",
// "Remove group: " => "Remove group: ",
// "Are you sure you want to delete these groups" => "Are you sure you want to delete these groups",
// "Group name can not be empty" => "Group name can not be empty",
"User doesn't exist" => "El usuario no existe",
"No records were found. Check the file please!" => "No se encontraron registros. ¡Compruebe el archivo por favor!",
// "User login or email is required" => "User login or email is required",
// "User does not exist on master" => "User does not exist on master",
"User login is required" => "Login de usuario requerido",
"Email is required" => "Correo es requerido",
"User is duplicated" => "El usuario está duplicado",
"Created account %s <%s>" => "Creada cuenta %s <%s>",
"Assigned %s in group %s" => "Asignado %s a grupo %s",
// "Are you sure you want to add this new user" => "Are you sure you want to add this new user",
// "Email validation requested but email address not set" => "Email validation requested but email address not set",
"The passwords do not match" => "Las contraseñas no coinciden",
// "Password not set" => "Password not set",
"User %s already exists" => "Usuario %s ya existe",
// "User login contains invalid characters" => "User login contains invalid characters",
// "New user created with username %s" => "New user created with username %s",
"Impossible to create new %s with %s %s." => "Imposible crear nuevo %s con %s %s.",
// "Are you sure you want to delete this user" => "Are you sure you want to delete this user",
"%s %s successfully deleted." => "%s %s exitosamente borrado.",
// "Deleted account %s" => "Deleted account %s",
// "Are you sure you want to remove the admin user from the Admins group? You may not be able to administer your Tiki any more if you do this" => "Are you sure you want to remove the admin user from the Admins group? You may not be able to administer your Tiki any more if you do this",
// "Are you sure you want to remove this user from this group" => "Are you sure you want to remove this user from this group",
"%s %s removed from %s %s." => "%s %s eliminado desde %s %s.",
// "Are you sure you want to reset email due for this user" => "Are you sure you want to reset email due for this user",
// "Are you sure you want to remove the link with OpenID for this user" => "Are you sure you want to remove the link with OpenID for this user",
// "Are you sure you want to delete these users" => "Are you sure you want to delete these users",
// "Are you sure you want to add this user to these groups" => "Are you sure you want to add this user to these groups",
// "%s %s assigned to %s %s" => "%s %s assigned to %s %s",
// "Are you sure you want to remove this user from these groups" => "Are you sure you want to remove this user from these groups",
// "Are you sure you want to set the default groups for these users" => "Are you sure you want to set the default groups for these users",
// "group %s set as the default group of user %s" => "group %s set as the default group of user %s",
// "Are you sure you want to send a wiki page as an email to these users" => "Are you sure you want to send a wiki page as an email to these users",
// "The description is mandatory as it is used as mail subject" => "The description is mandatory as it is used as mail subject",
// "Invalid or unknown email" => "Invalid or unknown email",
// "Login contains invalid characters" => "Login contains invalid characters",
"%s changed from %s to %s" => "%s cambiado de %s a %s",
"%s modified successfully." => "%s modificado exitosamente.",
"%s modification failed." => "falló modificación de %s.",
"email" => "correo",
"Impossible to change %s from %s to %s" => "Imposible cambiar %s de %s a %s",
// "Please go back and try again" => "Please go back and try again",
// "Could not create user" => "Could not create user",
// "Are you sure you want to modify this user's data" => "Are you sure you want to modify this user's data",
"Classified" => "Clasificado",
// "Failed to add attribute" => "Failed to add attribute",
"rss feed disabled" => "rss feed desactivado",
"You have to indicate a group" => "Debe indicar un grupo",
"This group is invalid" => "Este grupo no es válido",
"The page cannot be found" => "La página no pudo ser encontrada",
"Image Galleries Admin Panel" => "Panel de Admin de Galería de Imágenes",
"Could not read image %s." => "No puedo leer imagen %s.",
"Image %s upload failed." => "Fallo subida de imagen %s.",
"Image %s uploaded successfully." => "Imagen %s subida exitosamente.",
"Image %s removed from Batch directory." => "Imagen %s borrada de directorio por lotes.",
"Impossible to remove image %s from Batch directory." => "Imposible borrar imagen%s de directorio por lotes.",
"Incorrect directory chosen for batch upload of images." => "Directorio incorrecto elegido para subida en lote de imágenes.",
"Please setup that dir on " => "Por favor configure ese directorio en ",
"Please contact the website administrator." => "Por favor contáctese con el administrador del sitio web.",
"Invalid directory name" => "Nombre de directorio no válido",
"Directory batch" => "Directory batch",
// "File Galleries Admin Panel" => "File Galleries Admin Panel",
// "Upload was not successful for %0 (%1)" => "Upload was not successful for %0 (%1)",
// "Upload was successful" => "Upload was successful",
// "File %s removed from Batch directory" => "File %s removed from Batch directory",
// "Impossible to remove file %s from Batch directory" => "Impossible to remove file %s from Batch directory",
// "Incorrect directory chosen for batch upload of files" => "Incorrect directory chosen for batch upload of files",
"It isn't possible to post in any blog. You may need to create a blog first." => "No puede postear, deberia crear un blog antes",
"You do not have permission to edit this post" => "No puede editar este post",
"Top visited blogs" => "Blogs más visitados",
"Last posts" => "Últimos posts",
"Top active blogs" => "Blogs más activos",
"No blogId specified" => "No se especificó blogId",
// "Stop watching all categories" => "Stop watching all categories",
// "Watch all categories" => "Watch all categories",
// "Group watches for all categories" => "Group watches for all categories",
// "Stop watching this category and its descendants" => "Stop watching this category and its descendants",
// "Watch this category and its descendants" => "Watch this category and its descendants",
// "Group watches for this category" => "Group watches for this category",
// "Stop watching this category" => "Stop watching this category",
// "Watch this category" => "Watch this category",
// "Nothing tagged yet" => "Nothing tagged yet",
// "You must clear your browser cache" => "You must clear your browser cache",
"You do not have permission to access this gallery" => "No tiene permisos para acceder a esta galería o la galería no existe",
"No gallery indicated" => "No se indica la galería",
"You do not have permission to remove images from this gallery" => "No tiene permiso para quitar imágenes de la galería",
"You do not have permission to rebuild thumbnails in this gallery" => "Permiso denegado no puede reconstruir miniaturas en esta galería",
"You do not have permission to rotate images in this gallery" => "Permiso denegado no puede rotar imágenes en esta galería",
"No image indicated" => "No se indica imagen",
"picture not found" => "dibujo no encontrado",
"You do not have permission to move images from this gallery" => "No tiene permisos para mover imágenes de esta galería",
"You do not have permission to view the calendar" => "Permiso denegado no puede ver el calendario",
// "You need to <a href=\"tiki-admin_calendars.php?cookietab=2\">create a calendar</a>" => "You need to <a href=\"tiki-admin_calendars.php?cookietab=2\">create a calendar</a>",
// "There's no such date as" => "There's no such date as",
"event without name" => "evento sin nombre",
// "You do not have permission to view this page" => "You do not have permission to view this page",
// "Invalid date format" => "Invalid date format",
// "Your PHP installation does not have calendar enabled" => "Your PHP installation does not have calendar enabled",
"%H:%M %Z" => "%H:%M %Z",
// "Invalid username or activation code. Maybe this code has already been used" => "Invalid username or activation code. Maybe this code has already been used",
// "Your email could not be validated; make sure you email is correct" => "Your email could not be validated; make sure you email is correct",
"You can not use the same password again" => "No puede usar la misma contraseña otra vez",
"Invalid old password" => "La contraseña ingresada no es válida",
// "Invalid request. Expecting channels array" => "Invalid request. Expecting channels array",
// "Missing channel name" => "Missing channel name",
// "Authentication required" => "Authentication required",
// "One of the requested channels cannot be requested. It does not exist or permission is denied" => "One of the requested channels cannot be requested. It does not exist or permission is denied",
// "One of the install profiles could not be obtained" => "One of the install profiles could not be obtained",
// "info" => "info",
// "You will get no errors reported, because error_reporting and display_errors are both turned off. This might be the right thing for a production site, but in case of problems enable these in php.ini to get more information" => "You will get no errors reported, because error_reporting and display_errors are both turned off. This might be the right thing for a production site, but in case of problems enable these in php.ini to get more information",
// "You will get no errors reported although display_errors is On, because the error_reporting level is set to 0. This might be the right thing for a production site, but in case of problems raise the value in php.ini to get more information" => "You will get no errors reported although display_errors is On, because the error_reporting level is set to 0. This might be the right thing for a production site, but in case of problems raise the value in php.ini to get more information",
// "You will get no errors reported, because display_errors is turned off. This might be the right thing for a production site, but in case of problems enable it in php.ini to get more information. Your error_reporting level is decent at '.\$e.'" => "You will get no errors reported, because display_errors is turned off. This might be the right thing for a production site, but in case of problems enable it in php.ini to get more information. Your error_reporting level is decent at '.\$e.'",
// "You will not get all errors reported as your error_reporting level is at '.\$e.'. '.'This is not necessarily a bad thing (and it might be just right for production sites) as you will still get critical errors reported, but sometimes it can be handy to get more information. Check your error_reporting level in php.ini in case of having issues" => "You will not get all errors reported as your error_reporting level is at '.\$e.'. '.'This is not necessarily a bad thing (and it might be just right for production sites) as you will still get critical errors reported, but sometimes it can be handy to get more information. Check your error_reporting level in php.ini in case of having issues",
// "You will get no errors reported although your error_reporting level is all the way up at '.\$e" => "You will get no errors reported although your error_reporting level is all the way up at '.\$e",
// "You will get all errors reported as your error_reporting level is all the way up at '.\$e.' and display_errors is on. Way to go in case of problems as the error reports usually contain some valuable hints" => "You will get all errors reported as your error_reporting level is all the way up at '.\$e.' and display_errors is on. Way to go in case of problems as the error reports usually contain some valuable hints",
// "good" => "good",
// "ini_set is used in some places to accomodate for special needs of some Tiki features" => "ini_set is used in some places to accomodate for special needs of some Tiki features",
// "ugly" => "ugly",
// "ini_set is used in some places to accomodate for special needs of some Tiki features. Check disable_functions in your php.ini" => "ini_set is used in some places to accomodate for special needs of some Tiki features. Check disable_functions in your php.ini",
// "The PDO extension is the suggested database driver/abstraction layer" => "The PDO extension is the suggested database driver/abstraction layer",
// "You do not have the recommended PDO database driver/abstraction layer. You do have the MySQLi driver though, so we will to fall back to the AdoDB abstraction layer that is bundled with Tiki" => "You do not have the recommended PDO database driver/abstraction layer. You do have the MySQLi driver though, so we will to fall back to the AdoDB abstraction layer that is bundled with Tiki",
// "You do not have the recommended PDO database driver/abstraction layer. You do have the MySQL driver though, so we will to fall back to the AdoDB abstraction layer that is bundled with Tiki" => "You do not have the recommended PDO database driver/abstraction layer. You do have the MySQL driver though, so we will to fall back to the AdoDB abstraction layer that is bundled with Tiki",
// "bad" => "bad",
// "You do not have any of the supported database drivers (PDO/mysqli/mysql) loaded. Tiki will not work" => "You do not have any of the supported database drivers (PDO/mysqli/mysql) loaded. Tiki will not work",
// "N/A" => "N/A",
// "You have less than 200 megs of free disk space. Tiki will not fit on this disk drive" => "You have less than 200 megs of free disk space. Tiki will not fit on this disk drive",
// "You have less than 250 megs of free disk space. This is quite tight. Tiki needs disk space for compiling templates and for uploading files" => "You have less than 250 megs of free disk space. This is quite tight. Tiki needs disk space for compiling templates and for uploading files",
// "When the disk runs full you will not be able to log into your Tiki any more" => "When the disk runs full you will not be able to log into your Tiki any more",
// "We can not reliably check for quotas, so be warned that if your server makes use of them you might have less disk space available" => "We can not reliably check for quotas, so be warned that if your server makes use of them you might have less disk space available",
// "You have more than 251 megs of free disk space. Tiki will run nicely, but you may run into issues when your site grows (e.g. file uploads)" => "You have more than 251 megs of free disk space. Tiki will run nicely, but you may run into issues when your site grows (e.g. file uploads)",
// "The PHP function disk_free_space is not available on your server, so we can't check for this" => "The PHP function disk_free_space is not available on your server, so we can't check for this",
// "You are running PHP as CGI. Feel free to use a threaded Apache MPM to increase performance" => "You are running PHP as CGI. Feel free to use a threaded Apache MPM to increase performance",
// "You are running PHP using FPM (Fastcgi Process Manager). Feel free to use a threaded Apache MPM to increase performance" => "You are running PHP using FPM (Fastcgi Process Manager). Feel free to use a threaded Apache MPM to increase performance",
// "You are not running PHP as CGI. Be aware that PHP is not thread-safe and you should not use a threaded Apache MPM (like worker)" => "You are not running PHP as CGI. Be aware that PHP is not thread-safe and you should not use a threaded Apache MPM (like worker)",
// "You are using APC as your ByteCode Cache which increases performance, if correctly configured. See Admin->Performance in your Tiki for more details" => "You are using APC as your ByteCode Cache which increases performance, if correctly configured. See Admin->Performance in your Tiki for more details",
// "You are using xCache as your ByteCode Cache which increases performance, if correctly configured. See Admin->Performance in your Tiki for more details" => "You are using xCache as your ByteCode Cache which increases performance, if correctly configured. See Admin->Performance in your Tiki for more details",
// "You are using WinCache as your ByteCode Cache which increases performance, if correctly configured. See Admin->Performance in your Tiki for more details" => "You are using WinCache as your ByteCode Cache which increases performance, if correctly configured. See Admin->Performance in your Tiki for more details",
// "You are using WinCache as your ByteCode Cache, but you do not seem to use the required CGI/FastCGI server API" => "You are using WinCache as your ByteCode Cache, but you do not seem to use the required CGI/FastCGI server API",
// "You are using neither APC, WinCache nor xCache as your ByteCode Cache which would increase performance, if correctly configured. See Admin->Performance in your Tiki for more details" => "You are using neither APC, WinCache nor xCache as your ByteCode Cache which would increase performance, if correctly configured. See Admin->Performance in your Tiki for more details",
// "You are using neither APC nor xCache as your ByteCode Cache which would increase performance, if correctly configured. See Admin->Performance in your Tiki for more details" => "You are using neither APC nor xCache as your ByteCode Cache which would increase performance, if correctly configured. See Admin->Performance in your Tiki for more details",
// "Your memory_limit is at" => "Your memory_limit is at",
// "This is known to behave well even for bigger sites" => "This is known to behave well even for bigger sites",
// "This will normally work, but you might run into problems when your site grows" => "This will normally work, but you might run into problems when your site grows",
// "This is known to cause issues! You should raise your memory_limit to at least 128M, which is the default of PHP" => "This is known to cause issues! You should raise your memory_limit to at least 128M, which is the default of PHP",
// "Your session.save_handler must be set to 'files'" => "Your session.save_handler must be set to 'files'",
// "Well set! the default setting of 'files' is needed for Tiki" => "Well set! the default setting of 'files' is needed for Tiki",
// "You have zlib output compression turned on. This saves bandwidth. Turning it off would in turn reduce CPU usage. Choose your poison" => "You have zlib output compression turned on. This saves bandwidth. Turning it off would in turn reduce CPU usage. Choose your poison",
// "You have zlib output compression turned off. This reduces CPU usage. Turning it on would in turn save bandwidth. Choose your poison" => "You have zlib output compression turned off. This reduces CPU usage. Turning it on would in turn save bandwidth. Choose your poison",
// "register_globals should be off by default. See the PHP manual for details" => "register_globals should be off by default. See the PHP manual for details",
// "Well set! And you are future proof also as register_globals is deprecated" => "Well set! And you are future proof also as register_globals is deprecated",
// "safe_mode is deprecated and should be off by default. See the <a href=\"http://www.php.net/manual/de/features.safe-mode.php\">PHP manual</a> for details" => "safe_mode is deprecated and should be off by default. See the <a href=\"http://www.php.net/manual/de/features.safe-mode.php\">PHP manual</a> for details",
// "Well set! And you are future proof also as safe_mode is deprecated" => "Well set! And you are future proof also as safe_mode is deprecated",
// "Some features like assigning perms to a group with a name containing a quote will not work with this being on. magic_quotes_gpc is also deprecated and should be off by default. See the PHP manual for details. You may experience weird behaviour of your Tiki" => "Some features like assigning perms to a group with a name containing a quote will not work with this being on. magic_quotes_gpc is also deprecated and should be off by default. See the PHP manual for details. You may experience weird behaviour of your Tiki",
// "Well set! Some features like assigning perms to a group with a name containing a quote will not work with this being on. And you are future proof also as magic_quotes_gpc is deprecated" => "Well set! Some features like assigning perms to a group with a name containing a quote will not work with this being on. And you are future proof also as magic_quotes_gpc is deprecated",
// "Well set! Tiki is fully UTF-8 and so should your installation be" => "Well set! Tiki is fully UTF-8 and so should your installation be",
// "default_charset should be UTF-8 as Tiki is fully UTF-8. Please check your php.ini" => "default_charset should be UTF-8 as Tiki is fully UTF-8. Please check your php.ini",
// "You have no timezone set! While there are a lot of fallbacks in PHP to determine the timezone, the only reliable solution is to set it explicitly in php.ini! Please check the value of date.timezone in php.ini" => "You have no timezone set! While there are a lot of fallbacks in PHP to determine the timezone, the only reliable solution is to set it explicitly in php.ini! Please check the value of date.timezone in php.ini",
// "Well done! Having a timezone set protects you from many weird errors" => "Well done! Having a timezone set protects you from many weird errors",
// "You can upload files to your Tiki" => "You can upload files to your Tiki",
// "You will not be able to upload any files to your Tiki" => "You will not be able to upload any files to your Tiki",
// "Your max_execution_time is at" => "Your max_execution_time is at",
// "This is a good value for production sites. If you experience timeouts (such as when performing admin functions) you may need to increase this nevertheless" => "This is a good value for production sites. If you experience timeouts (such as when performing admin functions) you may need to increase this nevertheless",
// "Your max_execution_time is unlimited" => "Your max_execution_time is unlimited",
// "This is not necessarily bad, but it's a good idea to limit this time on productions servers in order to eliminate unexpectedly long running scripts" => "This is not necessarily bad, but it's a good idea to limit this time on productions servers in order to eliminate unexpectedly long running scripts",
// "It is likely that some scripts, e.g. admin functions will not finish in this time! You should raise your max_execution_time to at least 30s" => "It is likely that some scripts, e.g. admin functions will not finish in this time! You should raise your max_execution_time to at least 30s",
// "Your max_input_time is at" => "Your max_input_time is at",
// "Your max_input_time is unlimited" => "Your max_input_time is unlimited",
// "It is likely that some scripts, e.g. admin functions will not finish in this time! You should raise your max_input_time to at least 30 seconds" => "It is likely that some scripts, e.g. admin functions will not finish in this time! You should raise your max_input_time to at least 30 seconds",
// "Your upload_max_filesize is at" => "Your upload_max_filesize is at",
// "You can upload quite big files, but keep in mind to set your script timeouts accordingly" => "You can upload quite big files, but keep in mind to set your script timeouts accordingly",
// "Nothing wrong with that, but some users might want to upload something bigger" => "Nothing wrong with that, but some users might want to upload something bigger",
// "Your post_max_size is at" => "Your post_max_size is at",
// "The GD extension is needed for manipulation of images, e.g. also for CAPTCHAs" => "The GD extension is needed for manipulation of images, e.g. also for CAPTCHAs",
// "The GD extension is loaded, and Tiki can create images, but the FreeType extension is needed for CAPTCHA text generation" => "The GD extension is loaded, and Tiki can create images, but the FreeType extension is needed for CAPTCHA text generation",
// "The GD extension is loaded, but Tiki is unable to create images. Please check your GD library configuration" => "The GD extension is loaded, but Tiki is unable to create images. Please check your GD library configuration",
// "ImageMagick is used as a fallback in case that GD is not available" => "ImageMagick is used as a fallback in case that GD is not available",
// "ImageMagick is available, but unable to create images. Please check your ImageMagick configuration" => "ImageMagick is available, but unable to create images. Please check your ImageMagick configuration",
// "The mbstring extension is needed for an UTF-8 compatible lower case filter in the admin search for example" => "The mbstring extension is needed for an UTF-8 compatible lower case filter in the admin search for example",
// "The mbstring extension is loaded, but mbstring.func_overload = '.' '.\$func_overload.'.'.' '.'Tiki only works with mbsring.func_overload = 0. Please check your php.ini" => "The mbstring extension is loaded, but mbstring.func_overload = '.' '.\$func_overload.'.'.' '.'Tiki only works with mbsring.func_overload = 0. Please check your php.ini",
// "The mbstring extension is loaded, but missing important functions as for example mb_split(). You need to reinstall it with --enable-mbregex or ask your hoster do do it" => "The mbstring extension is loaded, but missing important functions as for example mb_split(). You need to reinstall it with --enable-mbregex or ask your hoster do do it",
// "The mbstring extension is needed for an UTF-8 compatible lower case filter" => "The mbstring extension is needed for an UTF-8 compatible lower case filter",
// "calendar extension is needed by Tiki" => "calendar extension is needed by Tiki",
// "You will not be able to use the calendar feature of Tiki" => "You will not be able to use the calendar feature of Tiki",
// "ctype extension is needed by Tiki" => "ctype extension is needed by Tiki",
// "This extension is needed for WebDAV" => "This extension is needed for WebDAV",
// "This extension is needed to connect your Tiki to an LDAP server. More info at: http://doc.tiki.org/LDAP " => "This extension is needed to connect your Tiki to an LDAP server. More info at: http://doc.tiki.org/LDAP ",
// "You will not be able to connect your Tiki to an LDAP server as the needed PHP extension is missing. More info at: http://doc.tiki.org/LDAP" => "You will not be able to connect your Tiki to an LDAP server as the needed PHP extension is missing. More info at: http://doc.tiki.org/LDAP",
// "This extension can be used to speed up your Tiki by saving sessions as well as wiki and forum data on a memcached server" => "This extension can be used to speed up your Tiki by saving sessions as well as wiki and forum data on a memcached server",
// "This extension is used to interpret SVN information for TortoiseSVN 1.7 or higher" => "This extension is used to interpret SVN information for TortoiseSVN 1.7 or higher",
// "The eval() function is required by the Smarty templating engine" => "The eval() function is required by the Smarty templating engine",
// "You will get \"Please contact support about\" messages instead of modules. eval() is most probably disabled via Suhosin" => "You will get \"Please contact support about\" messages instead of modules. eval() is most probably disabled via Suhosin",
// "The ZipArchive class is needed for features such as XML Wiki Import/Export and PluginArchiveBuilder" => "The ZipArchive class is needed for features such as XML Wiki Import/Export and PluginArchiveBuilder",
// "The DateTime class is needed for the WebDAV feature" => "The DateTime class is needed for the WebDAV feature",
// "Tiki requires MySQL >= 5.x" => "Tiki requires MySQL >= 5.x",
// "Your max_allowed_packet setting is at" => "Your max_allowed_packet setting is at",
// "This limits the size of binary files that can be added to Tiki, when storing files in the database. Please see: <a href=\"http://doc.tiki.org/File+Storage\">file storage</a>" => "This limits the size of binary files that can be added to Tiki, when storing files in the database. Please see: <a href=\"http://doc.tiki.org/File+Storage\">file storage</a>",
// "Tiki is fully UTF-8 and so should every part of your stack be" => "Tiki is fully UTF-8 and so should every part of your stack be",
// "On a fresh install you should have everything set to UTF-8 to not run into any suprises. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>" => "On a fresh install you should have everything set to UTF-8 to not run into any suprises. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>",
// "Tiki is fully UTF-8 and so should every part of your stack be. utf8_unicode_ci is the default collation for Tiki" => "Tiki is fully UTF-8 and so should every part of your stack be. utf8_unicode_ci is the default collation for Tiki",
// "On a fresh install you should have everything set to UTF-8 to not run into any suprises. utf8_unicode_ci is the default collation for Tiki. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>" => "On a fresh install you should have everything set to UTF-8 to not run into any suprises. utf8_unicode_ci is the default collation for Tiki. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>",
// "Your MySQL doesn't log slow queries. If you have performance issues, you might want to enable this, but keep in mind that the logging itself slows MySQL down" => "Your MySQL doesn't log slow queries. If you have performance issues, you might want to enable this, but keep in mind that the logging itself slows MySQL down",
// "Your MySQL logs slow queries. If you don't have performance issues, you should disable this on a production site as it slows MySQL down" => "Your MySQL logs slow queries. If you don't have performance issues, you should disable this on a production site as it slows MySQL down",
// "Tiki needs this module for Search Engine Friendly URLs via .htaccess. We can't check though, if your web server respects configurations made in .htaccess. For further information go to Admin->SefURL in your Tiki" => "Tiki needs this module for Search Engine Friendly URLs via .htaccess. We can't check though, if your web server respects configurations made in .htaccess. For further information go to Admin->SefURL in your Tiki",
// "Tiki needs this module for Search Engine Friendly URLs. For further information go to Admin->SefURL in your Tiki" => "Tiki needs this module for Search Engine Friendly URLs. For further information go to Admin->SefURL in your Tiki",
// "Your RewriteBase is set correctly in .htaccess. Search Engine Friendly URLs should work. Beware though that we can't check if Apache really loads .htaccess" => "Your RewriteBase is set correctly in .htaccess. Search Engine Friendly URLs should work. Beware though that we can't check if Apache really loads .htaccess",
// "Your RewriteBase is not set correctly in .htaccess. Search Engine Friendly URLs are not going to work like that. It should be set to \"" => "Your RewriteBase is not set correctly in .htaccess. Search Engine Friendly URLs are not going to work like that. It should be set to \"",
// "You haven't activated .htaccess. So this check is useless. If you want to use Search Engine Friendly URLs, you will have to activate .htaccess by copying _htaccess into its place (or a symlink if supported by your Operating System). Then come back to have a look at this check again" => "You haven't activated .htaccess. So this check is useless. If you want to use Search Engine Friendly URLs, you will have to activate .htaccess by copying _htaccess into its place (or a symlink if supported by your Operating System). Then come back to have a look at this check again",
// "With this module you can set the HTTP Expires header and therefore increase performance. We can't check though, if mod_expires is configured correctly" => "With this module you can set the HTTP Expires header and therefore increase performance. We can't check though, if mod_expires is configured correctly",
// "With this module you can set the HTTP Expires header and therefore increase performance. Once you install it, you still need to configure it correctly" => "With this module you can set the HTTP Expires header and therefore increase performance. Once you install it, you still need to configure it correctly",
// "With this module you can compress the data your webserver sends out and therefore decrease used bandwidth and increase performance. We can't check though, if mod_deflate is configured correctly" => "With this module you can compress the data your webserver sends out and therefore decrease used bandwidth and increase performance. We can't check though, if mod_deflate is configured correctly",
// "With this module you can compress the data your webserver sends out and therefore decrease used bandwidth and increase performance. Once you install it, you still need to configure it correctly" => "With this module you can compress the data your webserver sends out and therefore decrease used bandwidth and increase performance. Once you install it, you still need to configure it correctly",
// "This module can increase security of your Tiki and therefore your server, but be warned that it is very tricky to configure it correctly. A misconfiguration can lead to failed page saves or other hard to trace bugs" => "This module can increase security of your Tiki and therefore your server, but be warned that it is very tricky to configure it correctly. A misconfiguration can lead to failed page saves or other hard to trace bugs",
// "The URL Rewrite Module is required to use SEFURL on IIS" => "The URL Rewrite Module is required to use SEFURL on IIS",
// "upload_tmp_dir is probably within your Tiki directory. There is a risk that someone can upload any file to this directory and access them via web browser" => "upload_tmp_dir is probably within your Tiki directory. There is a risk that someone can upload any file to this directory and access them via web browser",
// "Can't reliably determine, if your upload_tmp_dir is accessible via a web browser. To make sure you should check your webserver config" => "Can't reliably determine, if your upload_tmp_dir is accessible via a web browser. To make sure you should check your webserver config",
"register_globals should be off by default. See the php manual for details." => "register_globals debería estar desactivado por defecto. Vea el manual de php por detalles.",
"safe" => "seguro",
// "WebKit is enabled" => "WebKit is enabled",
// "Blogs is enabled" => "Blogs is enabled",
// "Exec can potentially be used to execute arbitrary code on your server" => "Exec can potentially be used to execute arbitrary code on your server",
// "Tiki does not need it, you may want to disable it" => "Tiki does not need it, you may want to disable it",
// "Exec can be potentially be used to execute arbitrary code on your server" => "Exec can be potentially be used to execute arbitrary code on your server",
// "Tiki does not need it, you are wise to have it disabled" => "Tiki does not need it, you are wise to have it disabled",
// "Passthru is similar to exec" => "Passthru is similar to exec",
// "Shell_exec is similar to exec" => "Shell_exec is similar to exec",
// "Tiki needs it to run PDF from URL: WebKit (wkhtmltopdf). '.\$pdf_webkit.'If you need this and trust the other PHP software on your server, you should enable it" => "Tiki needs it to run PDF from URL: WebKit (wkhtmltopdf). '.\$pdf_webkit.'If you need this and trust the other PHP software on your server, you should enable it",
// "System is similar to exec" => "System is similar to exec",
// "Proc_open is similar to exec" => "Proc_open is similar to exec",
// "Curl_exec can potentially be abused to write malicious code" => "Curl_exec can potentially be abused to write malicious code",
// "Tiki needs it to run features like Kaltura, CAS login, CClite and the myspace and sf wiki-plugins. If you need these and trust the other PHP software on your server, you should enable it" => "Tiki needs it to run features like Kaltura, CAS login, CClite and the myspace and sf wiki-plugins. If you need these and trust the other PHP software on your server, you should enable it",
// "Curl_multi_exec can potentially be abused to write malicious code" => "Curl_multi_exec can potentially be abused to write malicious code",
// "It is probably an urban myth that this is dangerous. Tiki team will reconsider this check, but be warned" => "It is probably an urban myth that this is dangerous. Tiki team will reconsider this check, but be warned",
// "risky" => "risky",
"session.use_trans_sid should be off by default. See the php manual for details." => "session.use_trans_sid debería estar desactivado por defecto. Vea el manual de php por detalles.",
// "setting the xbithack option is unsafe. Depending on the file handling of your webserver and your tiki settings, it may be possible that an attacker can upload scripts to file gallery and execute them" => "setting the xbithack option is unsafe. Depending on the file handling of your webserver and your tiki settings, it may be possible that an attacker can upload scripts to file gallery and execute them",
// "allow_url_fopen may potentially be used to upload remote data or scripts. '.\$feature_blogs.'If you dont use the blog feature, you can switch it off" => "allow_url_fopen may potentially be used to upload remote data or scripts. '.\$feature_blogs.'If you dont use the blog feature, you can switch it off",
// "Test mail from Tiki Server Compatibility Test" => "Test mail from Tiki Server Compatibility Test",
// "We were able to send an e-mail. This only means that a mail server accepted the mail for delivery. We don't know, if that server really delivers the mail. Please check the inbox of '.\$_POST['email_test_to'].' to see, if the delivery really works" => "We were able to send an e-mail. This only means that a mail server accepted the mail for delivery. We don't know, if that server really delivers the mail. Please check the inbox of '.\$_POST['email_test_to'].' to see, if the delivery really works",
// "We were not able to send an e-mail. It may be that there is no mail server installed on this machine or that it is badly configured. If you absolutely can't get the local mail server to work, you can setup a regular mail account and set SMTP settings in tiki-admin.php" => "We were not able to send an e-mail. It may be that there is no mail server installed on this machine or that it is badly configured. If you absolutely can't get the local mail server to work, you can setup a regular mail account and set SMTP settings in tiki-admin.php",
// "The fileinfo extension is needed for the 'Validate uploaded file content' preference" => "The fileinfo extension is needed for the 'Validate uploaded file content' preference",
"Top authors" => "Principales autores",
// "Problem. Try to log in again to receive new confirmation instructions" => "Problem. Try to log in again to receive new confirmation instructions",
// "You must include a subject or a message" => "You must include a subject or a message",
// "You must make sure to have a valid e-mail address in the From field" => "You must make sure to have a valid e-mail address in the From field",
// "%0 sent you a message" => "%0 sent you a message",
"last version" => "última versión",
"Cannot rename page because the new name begins with reserved prefix" => "No puede renombrar página porque el nuevo nombre comienza con un prefijo reservado",
// "Cannot copy page because maybe new page name already exists" => "Cannot copy page because maybe new page name already exists",
// "TikiHelp WebHelp generation engine. Generating WebHelp using" => "TikiHelp WebHelp generation engine. Generating WebHelp using",
// "Eliminating previous files" => "Eliminating previous files",
// "Index: <strong>%0</strong>" => "Index: <strong>%0</strong>",
// "Directory: <strong>%0</strong>" => "Directory: <strong>%0</strong>",
"You need to change chmod 'whelp' manually to 777" => "Debe cambiar chmod 'whelp' manualmente a 777",
// "Creating directory structure in <strong>%0</strong>" => "Creating directory structure in <strong>%0</strong>",
// "Submit a new link" => "Submit a new link",
"Must enter a name to add a site. " => "Debe ingresar un nombre para añadir un sitio. ",
"Must enter a url to add a site. " => "Debe ingresar una URL para añadir un sitio. ",
"URL already added to the directory. Duplicate site? " => "La URL ya había sido añadida al directorio. ¿Duplicar sitio? ",
"URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. " => "La URL no puede ser accedida URL incorrecta o sitio fuera de línea y no puede ser añadido al directorio. ",
"Must select a category. " => "Debe elegir una categoría. ",
"Must enter a name to add a site" => "Debe introducir un nombre para añadir un sitio",
"Must enter a url to add a site" => "Debe introducir una URL para añadir un sitio",
"URL already added to the directory. Duplicate site?" => "URL ya añadida al directorio. ¿Duplicar sitio?",
"URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory" => "La URL no puede ser accedida: URL incorrecta o sitio fuera de línea y no puede añadirse al directorio",
"Admin Directory" => "Admin directorio",
"Must select a category" => "Debe elegir una categoría",
"Browse Directory" => "Navegar Directorio",
// "How to use Directory" => "How to use Directory",
"No site indicated" => "No se indicó sitio",
// "This feature is disabled: %0" => "This feature is disabled: %0",
"No parent specified" => "No se especificó superior",
// "Last sites of directory %0" => "Last sites of directory %0",
// "Discount code already exists" => "Discount code already exists",
// "File has been deleted" => "File has been deleted",
// "You cannot download this file right now. Your score is low or file limit was reached" => "You cannot download this file right now. Your score is low or file limit was reached",
// "Error : The file %s doesn't exist" => "Error : The file %s doesn't exist",
"Article not found" => "Artículo no encontrado",
"You do not have permission to edit this article" => "No tiene permiso para editar el artículo",
"The language can't be changed as its set of translations has already this language" => "El lenguage no puede ser cambiado ya que su conjunto de traducciones ya tiene ese lenguaje",
"Banner not found" => "Banner no encontrado",
"You do not have permission to edit this banner" => "No tiene permiso para editar este banner",
"You do not have permission to edit this blog" => "No tiene permiso para editar este blog",
// "Incorrect name" => "Incorrect name",
"You do not have permission to write the style sheet" => "No tiene permiso para escribir la hoja de estilo",
// "Wrong file type, expected %0" => "Wrong file type, expected %0",
// "You do not have permission to view/edit this file" => "You do not have permission to view/edit this file",
// "New Svg Image" => "New Svg Image",
"Invalid request to edit an image" => "No puede editar esta imagen",
"You have permission to edit images but not in this gallery" => "No puede editar imágenes de esta galería",
"Failed to edit the image" => "Error al editar imagen",
// "Wrote %d new strings and updated %d to lang/%s/language.php" => "Wrote %d new strings and updated %d to lang/%s/language.php",
// "Edit Perspectives" => "Edit Perspectives",
"No content id indicated" => "No se indica bloque de contenido a editar",
"No question indicated" => "No se indica pregunta",
"No quiz indicated" => "No se indica cuestionario",
"No structure indicated" => "No se indicó estructura",
"Invalid structure_id or page_ref_id" => "structure_id o page_ref_id no válidas",
"You do not have permission to edit submissions" => "No tiene permiso para editar colaboraciones",
"You have to create a topic first" => "Tiene que crear un tema primero",
// "Template directory %0 unknown" => "Template directory %0 unknown",
"You do not have permission to do that" => "No tiene permisos",
"You do not have permission to write the template" => "No tiene permiso para escribir la plantilla",
"You do not have permission to read the template" => "No tiene permiso para leer la plantilla",
"No topic id specified" => "No se especificó id de tema",
"Invalid topic id specified" => "Id de tema especificado no válido",
"No object indicated" => "No se indicó objeto",
// "Only wiki pages are supported" => "Only wiki pages are supported",
// "Not enable for this type of object" => "Not enable for this type of object",
// "Override lock and carry on with edit" => "Override lock and carry on with edit",
// "Page is currently being edited" => "Page is currently being edited",
"page imported" => "página importada",
"created from import" => "creada desde importación",
// "This page is being edited by %0. Please check with the user before editing the page,\totherwise the changes will be stored as two separate versions in the history and you will have to manually merge them later" => "This page is being edited by %0. Please check with the user before editing the page,\totherwise the changes will be stored as two separate versions in the history and you will have to manually merge them later",
"Can't import remote HTML page" => "No puedo importar página HTML remota",
"The SandBox is disabled" => "El SandBox esta deshabilitado",
"Cannot edit page because it is locked" => "No se puede editar la página pues se encuentra bloqueada",
// "Page already exists. Go back and choose a different name" => "Page already exists. Go back and choose a different name",
// "Page name is" => "Page name is",
// "The translation set already contains a page in this language" => "The translation set already contains a page in this language",
// "Can not open the file" => "Can not open the file",
// "Problem zip initialisation" => "Problem zip initialisation",
// "Problem zip" => "Problem zip",
// "Another user is currently exporting that tracker, please try again later" => "Another user is currently exporting that tracker, please try again later",
"No questions group indicated" => "No se indicó grupo de preguntas",
// "Remove archive: " => "Remove archive: ",
// "Remove file gallery: " => "Remove file gallery: ",
"Top visited file galleries" => "Galerías más visitadas",
"Most downloaded files" => "Archivos más descargados",
"Last files" => "Últimos archivos",
"No galleryId specified" => "No se especificó galleryId",
// "Form error - no import method selected for some reason" => "Form error - no import method selected for some reason",
// "Form error - no server-side filename entered for selected import method" => "Form error - no server-side filename entered for selected import method",
"No forum indicated" => "No se indica foro",
"Last forum topics" => "Últimos temas en foros",
// "Last replied forum topics" => "Last replied forum topics",
"Most-Read Forum Topics" => "Temas más leídos",
"Top topics" => "Top temas",
"Forum posts" => "Mensajes de Foros",
"Most-Visited Forums" => "Foros más visitados",
"No forumId specified" => "No se especificó forumId",
"List Forums" => "Listar Foros",
// "Not supported yet" => "Not supported yet",
"Accepted friendship request from %s" => "Aceptado pedido de amistad de %s",
"Refused friendship request from %s" => "Rehusado pedido de amistad de %s",
// "Canceled friendship request with %s" => "Canceled friendship request with %s",
"Broke friendship with %s" => "Romper amistad con %s",
"I have broken our friendship!" => "¡He roto nuestra amistad!",
"Friendship request sent to %s" => "Solicitud de Amistad enviada a %s",
"You're already friend of %s" => "Ya era amigo de %s",
"I have accepted your friendship request!" => "¡Acepté su pedido de amistad!",
// "I have refused your friendship request" => "I have refused your friendship request",
// "I have canceled my friendship request" => "I have canceled my friendship request",
"first uploaded image" => "primera imagen subida",
"last uploaded image" => "última imagen subida",
"first image" => "primera imagen",
"last image" => "última imagen",
"random image" => "imagen aletoria",
"You do not have permission to create galleries and so you cannot edit them" => "Permiso rechazado, no puede crear galerías ni editar galerías",
"You do not have permission to edit this gallery" => "No tiene permiso para editar esta galería",
"You do not have permission to remove this gallery" => "No puede quitar esta galería",
"You do not have permission to make the map of this gallery" => "Permiso denegado no puede hacer el mapa para esta galería",
"Top images" => "Principales imágenes",
"Last images" => "Últimas imágenes",
// "Back to item" => "Back to item",
// "No valid renderer found. GD or PDFLib required" => "No valid renderer found. GD or PDFLib required",
// "No sheet specified" => "No sheet specified",
// "You must select a renderer" => "You must select a renderer",
// "Invalid Series for current graphic" => "Invalid Series for current graphic",
"overwriting old page" => "sobrescribiendo vieja página",
"updated from structured text import" => "actualizado desde importación de texto estructurado",
"page created" => "página creada",
"created from structured text import" => "creado desde importación de texto estructurado",
// "Operations executed successfully" => "Operations executed successfully",
// "Invalid software name" => "Invalid software name",
"No name indicated for wiki page" => "No se indicó nombre para la página wiki",
// "This version does not exist" => "This version does not exist",
// "There is more than one item in the tracker with this title" => "There is more than one item in the tracker with this title",
// "There are no items in the tracker with this title" => "There are no items in the tracker with this title",
// "Page saved (version %d)" => "Page saved (version %d)",
// "You have requested that this page be machine translated" => "You have requested that this page be machine translated",
// "However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it" => "However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it",
"No repository given" => "No se dió repositorio",
// "This invitation does not exist or is deprecated" => "This invitation does not exist or is deprecated",
// "Congratulations! You are now part of this invitation group(s)" => "Congratulations! You are now part of this invitation group(s)",
// "Upload Media" => "Upload Media",
// "Communication error" => "Communication error",
// "Invalid response provided by the Kaltura server. Please retry" => "Invalid response provided by the Kaltura server. Please retry",
// "Are you sure you want to permanently remove the article with identifier %0" => "Are you sure you want to permanently remove the article with identifier %0",
// "Are you sure you want to permanently remove these %0 articles" => "Are you sure you want to permanently remove these %0 articles",
"You do not have permission to remove articles" => "No tiene permiso para eliminar el artículo",
"You do not have permission to remove banners" => "Permiso denegado no puede eliminar banners",
// "List Blog Posts" => "List Blog Posts",
"You do not have permission to remove this blog" => "No puede quitar este blog",
// "You do not have permission to view the comments for this blog" => "You do not have permission to view the comments for this blog",
// "Delete comments" => "Delete comments",
// "Approved Status" => "Approved Status",
// "Queued" => "Queued",
// "This blog has no posts" => "This blog has no posts",
// "Dynamic content" => "Dynamic content",
// "Admin FAQs" => "Admin FAQs",
"Non-existent gallery" => "Galería inexistente",
// "You do not have permission to view this gallery" => "You do not have permission to view this gallery",
// "The file is already locked by %s" => "The file is already locked by %s",
// "Permission denied you cannot validate files from this gallery" => "Permission denied you cannot validate files from this gallery",
// "Validate draft: " => "Validate draft: ",
// "Quota too big" => "Quota too big",
// "Quota too small" => "Quota too small",
"You have permission to upload files but not to this file gallery" => "No puede subir archivos a esta galería",
// "Not modified since" => "Not modified since",
// "Not downloaded since" => "Not downloaded since",
"You do not have permission to upload files so you cannot edit them" => "Permiso denegado no puede subir archivos así que no puede editarlos",
// "This gallery does not exist" => "This gallery does not exist",
// "List Entries" => "List Entries",
// "Error importing" => "Error importing",
// "Error converting" => "Error converting",
// "Importing" => "Importing",
// "Processing" => "Processing",
// "Ready" => "Ready",
// "Pending moderation" => "Pending moderation",
// "Blocked" => "Blocked",
// "Invalid action" => "Invalid action",
// "Remove permission %0 from %1" => "Remove permission %0 from %1",
// "Assign permission %0 to %1" => "Assign permission %0 to %1",
// "Delete posts" => "Delete posts",
// "View submissions" => "View submissions",
// "Are you sure you want to permanently remove the submitted article with identifier %0" => "Are you sure you want to permanently remove the submitted article with identifier %0",
// "Are you sure you want to permanently remove these %0 submitted articles" => "Are you sure you want to permanently remove these %0 submitted articles",
// "Are you sure you want to approve these %0 submitted articles" => "Are you sure you want to approve these %0 submitted articles",
// "Are you sure you want to remove the %0 selected pages" => "Are you sure you want to remove the %0 selected pages",
// "Are you sure you want to print the %0 selected pages" => "Are you sure you want to print the %0 selected pages",
// "Are you sure you want to unlock the %0 selected pages" => "Are you sure you want to unlock the %0 selected pages",
// "Are you sure you want to lock the %0 selected pages" => "Are you sure you want to lock the %0 selected pages",
// "Are you sure you want to download a zip of the %0 selected pages" => "Are you sure you want to download a zip of the %0 selected pages",
// "Are you sure you want to modify the %0 pages" => "Are you sure you want to modify the %0 pages",
// "No history will be created" => "No history will be created",
// "You are neither an administrator nor an operator of live support" => "You are neither an administrator nor an operator of live support",
// "Username field cannot be empty. Please go back and try again" => "Username field cannot be empty. Please go back and try again",
// "Unable to contact remote server" => "Unable to contact remote server",
// "XMLRPC Error: " => "XMLRPC Error: ",
// "Unable to create login" => "Unable to create login",
"More than %d unsuccessful login attempts have been made" => "Se han producido más de %d intentos de conexión fallidos",
"Your account has been suspended" => "Se ha suspendido tu cuenta (al menos temporalmente)",
"A site administrator will reactivate it" => "Una persona administradora del sitio web lo reactivará",
"An email has been sent to you with the instructions to follow" => "Se te ha envio un correo-econ instrucciones a seguir",
"Account disabled" => "Cuenta deshabilitada",
"You did not validate your account" => "No has validado tu cuenta",
"Resend" => "Reenvíalo",
"You should have received an email. Check your mailbox and your spam box. Otherwise click on the button to resend the email" => "Deberías haber recibido un correo-e. Comprueba tu buzón de correo-e y tu carpeta de correo no deseado (spam). Alternativamente, haz clic en el botón para reenviarte el correo-e",
"You must use the right case for your user name" => "Has de usar mayúsculas y minúsculas exactamente como hiciste al escoger tu nombre de usuario",
"You are not yet validated" => "Aún no estás validado/a",
"The mail can't be sent. Contact the administrator" => "No se puede enviar el correo-e. Contacta a la/s persona/s administradora/s",
"Your default nickname is already in use. A new one has to be selected" => "El nombre de usuario que has escogido ya está siendo usado por otra persona. Tienes que escoger uno nuevo",
"Verification cancelled" => "Se ha cancelado la verificación",
// "The selected account is not associated with your identity" => "The selected account is not associated with your identity",
// "unknown action" => "unknown action",
// "Authentication method is not OpenID" => "Authentication method is not OpenID",
// "Authentication error; probably not a valid OpenID" => "Authentication error; probably not a valid OpenID",
// "Could not redirect to server: " => "Could not redirect to server: ",
// "OpenID authentication failed: " => "OpenID authentication failed: ",
// "You have already validated your account. Please log in" => "You have already validated your account. Please log in",
"Tiki mail-in auto-reply" => "Tiki mail-in auto-respuesta",
"Sorry, you can't use this feature." => "Lo siento, no puede usar esta característica.",
// "You must first setup MapServer" => "You must first setup MapServer",
// "invalid mapfile name" => "invalid mapfile name",
// "An error as occurred with the mapfile" => "An error as occurred with the mapfile",
"edit" => "editar",
// "Please create a directory named %0 to hold your map files" => "Please create a directory named %0 to hold your map files",
"Maps feature is not correctly setup : Maps path is missing." => "La función de Mapas no esta correctamente configurada: falta directorio para los mapas.",
"mapfile name incorrect" => "Nombre de mapa incorrecto",
"This mapfile already exists" => "Este mapa ya existe",
"You do not have permission to write to the mapfile" => "No tiene permiso para escribir en el mapa",
"You do not have permission to delete the mapfile" => "No tiene permiso para borrar el mapa",
"I could not make a copy" => "No puedo hacer una copia",
"You do not have permission to read the mapfile" => "No tiene permiso para leer el mapa",
// "map edit" => "map edit",
"You dont have permission to do that" => "No tiene permiso para hacer eso",
"Tiki RSS feed for maps" => "Tiki RSS feed para mapas",
"List of maps available." => "Lista de mapas disponibles.",
"Layer Management" => "Manejo de capas",
"The Directory is not empty" => "El Directorio no está vacío",
"Invalid file name" => "Nombre de archivo no válido",
"Invalid files to index" => "Archivos no válidos a indexar",
"I do not know where is gdaltindex. Set correctly the Map feature" => "No se donde se encuentra gdaltindex. Configure correctamente la función de Mapas",
"I could not create the index file" => "No puedo crear el archivo de índice",
// " to " => " to ",
// "No page provided" => "No page provided",
"You need to run setup.sh :<br />./setup.sh \$APACHEUSER all<br />Common Apache users are www-data, apache or nobody" => "Debe correr setup.sh :<br />./setup.sh \$APACHEUSER all<br />Usuarios comunes de Apache son www-data, apache or nobody",
"Your PHP installation does not have zlib enabled." => "Su instalación de PHP no tiene zlib habilitado.",
"You must log in to use this feature" => "Debe estar conectado para usar esta característica",
"MyTiki Home" => "MiTiki inicio",
"You do not have permission to view other users data" => "No tiene permiso para ver datos de otros usuarios",
"You must be logged in to subscribe to newsletters" => "Debe estar conectado para poder suscribirse a boletines",
"No note indicated" => "No se indicó nota",
"merged note:" => "nota combinada:",
"File is too big" => "Archivo demasiado grande",
"No item indicated" => "No se indicó item",
// "Are you sure you want to delete this note" => "Are you sure you want to delete this note",
"created from notepad" => "creado desde el bloc de notas",
// "Note not found" => "Note not found",
"Not enough information to display this page" => "No hay información suficiente para mostrar esta página",
// "You do not have permission to assign permissions for this object" => "You do not have permission to assign permissions for this object",
// "Are you sure you want to remove the direct permissions from this object" => "Are you sure you want to remove the direct permissions from this object",
// "Are you sure you want paste the copied permissions onto this object" => "Are you sure you want paste the copied permissions onto this object",
// "Manual payment entered" => "Manual payment entered",
// "You do not have permission to enter payment" => "You do not have permission to enter payment",
// "New payment requested" => "New payment requested",
// "Cancel payment %0" => "Cancel payment %0",
// "Payment canceled" => "Payment canceled",
"No article indicated" => "No se indica un artículo",
"Article is not published yet" => "El artículo no ha sido publicado",
"No post indicated" => "No indica post",
"Blog not found" => "No se encuentra el blog",
// "Missing object list type argument" => "Missing object list type argument",
// "Index" => "Index",
// "Index (%0)" => "Index (%0)",
"No pages indicated" => "No se indican páginas",
"Multiple Print" => "Impresión múltiple",
"Pageviews" => "Pageviews",
"No result indicated" => "No se indica resultado",
"Invalid or unknown username" => "Nombre de usuario no válido o desconocido",
"Unable to send mail. User has not configured email" => "No se puede enviar correo. El usuario no configuró su correo electrónico",
// "Please provide a username or email" => "Please provide a username or email",
// "Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password" => "Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password",
// "A password reminder email has been sent " => "A password reminder email has been sent ",
// "An email with a link to reset your password has been sent " => "An email with a link to reset your password has been sent ",
// "to the email" => "to the email",
"to the registered email address for" => "a la dirección registrada de correo para",
"Non-existent version" => "Versión inexistente",
// "Tiki RSS Feed Error Message: %0" => "Tiki RSS Feed Error Message: %0",
// "This match was not case sensitive" => "This match was not case sensitive",
// "No items selected" => "No items selected",
// "Page cannot be found: " => "Page cannot be found: ",
// "Page has changed since preview: " => "Page has changed since preview: ",
// "Page not updated due to error in replacing: " => "Page not updated due to error in replacing: ",
// "Page updated: " => "Page updated: ",
// "Search Stats" => "Search Stats",
// "%0: Results for \"%1\"" => "%0: Results for \"%1\"",
// "Searchindex" => "Searchindex",
// "A problem occurred during file uploading" => "A problem occurred during file uploading",
// "File which was causing trouble was at rank" => "File which was causing trouble was at rank",
// "The error was" => "The error was",
// "Error: You can't send the same newsletter by refreshing this frame content" => "Error: You can't send the same newsletter by refreshing this frame content",
// "Newsletter successfully sent to %s users" => "Newsletter successfully sent to %s users",
// "There was %s errors" => "There was %s errors",
"No newsletters available." => "No hay boletines disponibles.",
// "Cannot login to server maybe the server is down" => "Cannot login to server maybe the server is down",
"successfully sent" => "exitosamente enviada",
"not sent" => "no enviado",
"Error: " => "Error: ",
"Send Pages" => "Enviar páginas",
// "Notice: this variable may not be empty" => "Notice: this variable may not be empty",
// "Notice: invalid variable value" => "Notice: invalid variable value",
// "Report to the webmaster" => "Report to the webmaster",
// "Token called" => "Token called",
// "Error sending tweet" => "Error sending tweet",
// "Your link was sent" => "Your link was sent",
// "Your email is mandatory" => "Your email is mandatory",
// "Error sending mail to" => "Error sending mail to",
// "Permission to post in forum denied" => "Permission to post in forum denied",
// "No text given for tweet" => "No text given for tweet",
// "Spreadsheet - " => "Spreadsheet - ",
// "Are you sure you want to delete this spreadsheet" => "Are you sure you want to delete this spreadsheet",
// "You do not have permission to edit messages %0" => "You do not have permission to edit messages %0",
// "Permission denied. You cannot view this page" => "Permission denied. You cannot view this page",
// "Updating Theme.." => "Updating Theme..",
// "Update slideshow theme" => "Update slideshow theme",
"Page must be defined inside a structure to use this feature" => "La página debe estar definida dentro de una estructura para usar esa función",
// "Username and email are mandatory" => "Username and email are mandatory",
// "Email is invalid" => "Email is invalid",
// "Clean the sql logs" => "Clean the sql logs",
// "Are you sure you want to clear all statistics and data for this survey" => "Are you sure you want to clear all statistics and data for this survey",
"You cannot take this quiz twice" => "No puede rellenar el cuestionario dos veces",
"Quiz time limit exceeded quiz cannot be computed" => "Se excedió el tiempo límite",
"You cannot take this survey twice" => "No puede volver a responder la encuesta",
"Please create a category first" => "Por favor cree una categoría primero",
// "Committing.." => "Committing..",
// "Could not save" => "Could not save",
"Tracker item:" => "Ítem de Formulario-bd:",
"No trackerId specified" => "No se especificó trackerId",
// "Incorrect file gallery" => "Incorrect file gallery",
// "You must lock the file before editing it" => "You must lock the file before editing it",
"Error processing zipped image package" => "Error procesando paquete de imágenes zipeado",
"No permission to upload zipped image packages" => "Sin permiso para subir paquete de imágenes zipeado",
"The uploaded file ist not recognized as a image" => "El archivo subido no es reconocido como una imagen",
"You do not have permission to upload images" => "No tiene permisos para subir imágenes",
"You have permission to upload images but not to this gallery" => "Tiene permisos para subir imágenes pero no a esta galería",
"Cannot get image from URL" => "No se pudo leer imagen a partir de la URL",
"That is not an image (or you have php < 4.0.5)" => "Esta no es una imagen (o tiene php < 4.0.5)",
"Usage" => "Uso",
"TOP" => "TOP",
"No url indicated" => "No se indica url",
"Unknown user" => "Usuario desconocido",
// "Password has been changed" => "Password has been changed",
// "Invalid password. Your current password is required to change administrative information" => "Invalid password. Your current password is required to change administrative information",
"Email is set to %s" => "Correo esta configurado a %s",
"The passwords did not match" => "Las contraseñas no coinciden",
// "If you really want to delete your account, you must check the checkbox" => "If you really want to delete your account, you must check the checkbox",
"unicode" => "unicode",
"was moved into trash" => "fue movido a la papelera",
"trashed by" => "borrado por",
"open / in process" => "abierta / en proceso",
"Rights by creator" => "Derechos por creador",
"END" => "FIN",
"Percentage" => "Porcentaje",
"Task accepted by creator" => "Tarea aceptada por creador",
"Task accepted by task user" => "Tarea aceptada por usuario de tarea",
"Task NOT accepted by creator" => "Tarea NO aceptada por creador",
"Task NOT accepted by task user" => "Tarea NO aceptada por usuario de tarea",
"Sorry this task does not exist or you have no rights to view this task" => "Lo siento esta tarea no existe o usted no tiene derecho a ver esa tarea",
"Task entries:" => "Entradas de tareas:",
"Changes:" => "Cambios:",
"Info message" => "Mensaje de Info message",
"NEW Task" => "NUEVA Tarea",
"Sorry you are not allowed to send tasks to other users, or the user is not allowed to receive tasks!" => "Lo siento usted no tiene permitido enviar tareas a otros usuarios, ¡o el usuario no tiene permitido recibirlas!",
"Changes on Task" => "Cambios en Tareas",
"You received a new task" => "Usted recibió una nueva tarea",
"The priority is" => "La prioridad es",
"very low" => "muy baja",
"high" => "alta",
"very high" => "muy alta",
"You've to start your work at least on" => "Usted debe empezar su trabajo al menos en",
"You've to finish your work on" => "Debe terminar su trabajo en",
"Login and click the link below" => "Identifícate y haz clic el enlace siguiente",
"Please read the task and work on it!" => "¡Por favor lea la tarea y trabaje en ella!",
"Sorry, there was an error while trying to write data into the database" => "Lo siento, hubo un error intentando escribir datos en la base de datos",
// "A new page is created in a language" => "A new page is created in a language",
// "Category change in a language" => "Category change in a language",
// "Remove the notification email" => "Remove the notification email",
// "Language watch" => "Language watch",
// "Category watch: %0, Language: %1" => "Category watch: %0, Language: %1",
"Cannot upload this file not enough quota" => "No puede subir este archivo, cuota insuficiente",
"No user indicated" => "No se indica usuario",
"Non-existent user" => "Usuario inexistente",
"Articles Home" => "Inicio Artículos",
"No banner indicated" => "No se indica un banner",
"No blog indicated" => "No se indica un blog",
// "Post not found" => "Post not found",
// "You do not have permission to view this blog post while it is marked as private" => "You do not have permission to view this blog post while it is marked as private",
"No cache information available" => "No hay información en el caché disponible",
// "You must suggest a question; please try again" => "You must suggest a question; please try again",
"No faq indicated" => "No se indica faq",
"You are not permitted to remove someone else's post!" => "¡No tiene permitido borrar el post de otro usuario!",
// "Incorrect thread" => "Incorrect thread",
"No thread indicated" => "No se indica mensaje",
// "Files are read only at this time" => "Files are read only at this time",
// "Are you sure you want to clone this spreadsheet" => "Are you sure you want to clone this spreadsheet",
// "Clone Error" => "Clone Error",
// "Are you sure you want to rollback this spreadsheet" => "Are you sure you want to rollback this spreadsheet",
// "Rollback Error" => "Rollback Error",
"Tracker Added To Spreadsheet" => "Se ha añadido el Formulario-bd a la Hoja de Cálculo",
"Tracker Removed From Spreadsheet" => "Se ha eliminado el Formulario-bd a la Hoja de Cálculo",
// "Spreadsheet added" => "Spreadsheet added",
// "Spreadsheet removed" => "Spreadsheet removed",
// "File removed" => "File removed",
// "Spreadsheet truncated" => "Spreadsheet truncated",
"Create tracker item" => "Crea ítem de formulario-bd",
// "Are you sure you want to remove this attachment" => "Are you sure you want to remove this attachment",
"Edit/Delete" => "Editar/Borrar",
// "You don't have a personal tracker item yet. Click here to make one" => "You don't have a personal tracker item yet. Click here to make one",
"That tracker don't use extras." => "Este tracker no usa extras.",
// "Tiki WebDAV access" => "Tiki WebDAV access",
// "You do not have permission to admin the requested webmail account" => "You do not have permission to admin the requested webmail account",
// "You do not have permission to use the requested webmail account" => "You do not have permission to use the requested webmail account",
// "You no longer have permission to use your active webmail account" => "You no longer have permission to use your active webmail account",
// "There was a problem connecting to that account" => "There was a problem connecting to that account",
// "There was a problem deleting that mail" => "There was a problem deleting that mail",
// "Mail ID" => "Mail ID",
// "There was a problem while trying to delete these mails" => "There was a problem while trying to delete these mails",
// "There was a problem while trying to delete that mail" => "There was a problem while trying to delete that mail",
// "Are you sure you want to delete this account" => "Are you sure you want to delete this account",
// "Taking" => "Taking",
// "Putting back" => "Putting back",
// "Checking" => "Checking",
"Aborted" => "Abortado",
"Top pages" => "Principales páginas",
"Last pages" => "Últimas páginas",
// "Plugin modified by editor" => "Plugin modified by editor",
// "Tidy Extension not present" => "Tidy Extension not present",
// "The TikiTests Replay File is Empty" => "The TikiTests Replay File is Empty",
// "The TikiTests Replay File has an error" => "The TikiTests Replay File has an error",
// "You are about to delete a TikiTest file, do you want to continue " => "You are about to delete a TikiTest file, do you want to continue ",
// "Error deleting the file" => "Error deleting the file",
// "TikiTest List" => "TikiTest List",
// "TikiTest Record" => "TikiTest Record",
// "You need one of the extension pecl HTTP or Curl to replay the TikiTest" => "You need one of the extension pecl HTTP or Curl to replay the TikiTest",
// "The TikiTest Replay File is Empty" => "The TikiTest Replay File is Empty",
// "TikiTest Replay" => "TikiTest Replay",
// "The page is empty" => "The page is empty",
"You do not have permissions to view the maps" => "No tiene permiso para ver los mapas",
);
