<?php
// (c) Copyright 2002-2012 by authors of the Tiki Wiki CMS Groupware Project
// 
// All Rights Reserved. See copyright.txt for details and a complete list of authors.
// Licensed under the GNU LESSER GENERAL PUBLIC LICENSE. See license.txt for details.

// Note for translators about translation of text ending with punctuation
// 
// The current list of concerned punctuation can be found in 'lib/init/tra.php'
// On 2009-03-02, it is: (':', '!', ';', '.', ',', '?')
// For clarity, we explain here only for colons: ':' but it is the same for the rest
// 
// Short version: it is not a problem that string "Login:" has no translation. Only "Login" needs to be translated.
// 
// Technical justification:
// If a string ending with colon needs translating (like "{tr}Login:{/tr}")
// then Tiki tries to translate 'Login' and ':' separately.
// This allows to have only one translation for "{tr}Login{/tr}" and "{tr}Login:{/tr}"
// and it still allows to translate ":" as " :" for languages that
// need it (like French)
// Note: the difference is invisible but " :" has an UTF-8 non-breaking-space, not a regular space, but the UTF-8 equivalent of the HTML &nbsp;.
// This allows correctly displaying emails and JavaScript messages, not only web pages as would happen with &nbsp;.

$lang = array(
// "You must specify a directory" => "You must specify a directory",
"Creation Date" => "Létrehozás dátuma",
"Name" => "Név",
"Last modification date" => "Utolsó módosítás dátuma",
"Hits" => "Megtekintések",
"Owner" => "Tulajdonos",
"Description" => "Leírás",
// "ID" => "ID",
// "moved %d images, %d errors occurred" => "moved %d images, %d errors occurred",
// "a timeout occurred. Hit the reload button to move the rest" => "a timeout occurred. Hit the reload button to move the rest",
"Detected, Version:" => "Felismerve, Verzió:",
// "Test Image" => "Test Image",
"Not detected." => "Nem található",
"Unknown" => "Ismeretlen",
// "Tiki Email Test" => "Tiki Email Test",
// "Tiki Test email from" => "Tiki Test email from",
// "Unable to send mail" => "Unable to send mail",
// "Test mail sent to" => "Test mail sent to",
// "%d user-group assignments" => "%d user-group assignments",
"None" => "Nincs",
// "All Fields except gdaltindex must be filled" => "All Fields except gdaltindex must be filled",
// "Path to mapfiles is invalid" => "Path to mapfiles is invalid",
// "No valid gdaltindex executable" => "No valid gdaltindex executable",
// "No valid ogr2ogr executable" => "No valid ogr2ogr executable",
// "New configuration created (id %0)" => "New configuration created (id %0)",
// "Configuration updated" => "Configuration updated",
// "You must set a home file gallery" => "You must set a home file gallery",
"Tag already exists" => "A tag már létezik ",
"Tag not found" => "nem találom a tag-ot",
"Welsh" => "walesi",
"Slovene" => "szlovén",
"Arabic" => "arab",
// "Bulgarian" => "Bulgarian",
"Catalan" => "katalán",
"Simplified Chinese" => "kínai (egyszerűsített)",
"Czech" => "cseh",
"Danish" => "dán",
"German" => "német",
"English" => "angol",
"English British" => "angol (Brit)",
"Spanish" => "spanyol",
"Greek" => "görög",
"Farsi" => "farszi",
"Finnish" => "finn",
// "Fijian" => "Fijian",
"French" => "francia",
"Frisian Netherlands" => "holland (fríz)",
"Galician" => "galíciai",
"Hebrew" => "jiddis",
"Croatian" => "horvát",
"Indonesian" => "indonéz",
"Icelandic" => "izlandi",
"Italian" => "olasz",
"Inuktitut" => "inuktitut",
"Japanese" => "japán",
"Korean" => "koreai",
"Hungarian" => "magyar",
"Lithuanian" => "litván",
// "Low German" => "Low German",
"Dutch" => "holland",
"Norwegian" => "norvég",
"Polish" => "lengyel",
// "Portuguese" => "Portuguese",
"Brazilian Portuguese" => "portugál (brazil)",
"Romanian" => "román",
// "Romansh" => "Romansh",
"Russian" => "orosz",
"Pijin Solomon" => "pijin solomon",
"Sinhala" => "sinhala",
"Slovak" => "szlovák",
"Albanian" => "albán",
"Serbian Latin" => "szerb (latin)",
"Swedish" => "svéd",
"Tuvaluan" => "tuvaluan",
"Turkish" => "török",
"Traditional Chinese" => "kínai (hagyományos)",
"Ukrainian" => "ukrán",
"Vietnamese" => "vietnámi",
"Afghanistan" => "Afganisztán",
"Aland Islands" => "Aland Szigetek",
// "Aland_Islands" => "Aland_Islands",
"Albania" => "Albánia",
"Algeria" => "Algéria",
"American Samoa" => "Amerikai Samoa",
// "American_Samoa" => "American_Samoa",
"Andorra" => "Andorra",
"Angola" => "Angola",
"Anguilla" => "Anguilla",
"Antigua" => "Antigua",
"Argentina" => "Argentína",
"Armenia" => "Örményország",
"Aruba" => "Aruba",
"Australia" => "Ausztrália",
"Austria" => "Ausztria",
"Azerbaijan" => "Azerbajdzsán",
"Bahamas" => "Bahamák",
"Bahrain" => "Bahrein",
"Bangladesh" => "Banglades",
"Barbados" => "Barbadosz",
"Belarus" => "Fehéroroszország",
"Belgium" => "Belgium",
"Belize" => "Belize",
"Benin" => "Benin",
"Bermuda" => "Bermuda",
"Bhutan" => "Bhutan",
"Bolivia" => "Bolívia",
"Bosnia and Herzegovina" => "Bosznia Hercegovina",
// "Bosnia_and_Herzegovina" => "Bosnia_and_Herzegovina",
"Botswana" => "Botswána",
"Bouvet Island" => "Bouvet Sziget",
// "Bouvet_Island" => "Bouvet_Island",
"Brazil" => "Brazilia",
// "British Indian Ocean Territory" => "British Indian Ocean Territory",
// "British Virgin Islands" => "British Virgin Islands",
// "British_Indian_Ocean_Territory" => "British_Indian_Ocean_Territory",
// "British_Virgin_Islands" => "British_Virgin_Islands",
"Brunei" => "Brunei",
"Bulgaria" => "Bulgária",
"Burkina Faso" => "Burkina Faso",
// "Burkina_Faso" => "Burkina_Faso",
"Burundi" => "Burundi",
"Cambodia" => "Kambodzsa",
"Cameroon" => "Kamerum",
"Canada" => "Kanada",
"Cape Verde" => "Zöld-foki Köztársaság",
// "Cape_Verde" => "Cape_Verde",
// "Catalan Countries" => "Catalan Countries",
// "Catalan_Countries" => "Catalan_Countries",
"Cayman Islands" => "Kajmán-szigetek",
// "Cayman_Islands" => "Cayman_Islands",
// "Central African Republic" => "Central African Republic",
// "Central_African_Republic" => "Central_African_Republic",
"Chad" => "Csád",
"Chile" => "Chile",
"China" => "Kína",
"Christmas Island" => "Karácsony-sziget",
// "Christmas_Island" => "Christmas_Island",
// "Cocos Islands" => "Cocos Islands",
// "Cocos_Islands" => "Cocos_Islands",
"Colombia" => "Kolumbia",
// "Comoros" => "Comoros",
// "Congo Democratic" => "Congo Democratic",
"Congo" => "Kongó",
// "Congo_Democratic" => "Congo_Democratic",
// "Cook Islands" => "Cook Islands",
// "Cook_Islands" => "Cook_Islands",
"Costa Rica" => "Costa Rica",
// "Costa_Rica" => "Costa_Rica",
"Croatia" => "Horvátország",
"Cuba" => "Kuba",
"Cyprus" => "Ciprus",
"Czech Republic" => "Csehország",
// "Czech_Republic" => "Czech_Republic",
"Denmark" => "Dánia",
// "Djibouti" => "Djibouti",
"Dominica" => "Dominika",
"Dominican Republic" => "Dominikai Köztársaság",
// "Dominican_Republic" => "Dominican_Republic",
"Ecuador" => "Ecuador",
"Egypt" => "Egyiptom",
"El Salvador" => "El Salvador",
// "El_Salvador" => "El_Salvador",
"Equatorial Guinea" => "Egyenlítői Guinea",
// "Equatorial_Guinea" => "Equatorial_Guinea",
"Eritrea" => "Eritrea",
"Estonia" => "Észtország",
"Ethiopia" => "Etiópia",
"Europe" => "Európa",
"Falkland Islands" => "Falkland-szigetek",
// "Falkland_Islands" => "Falkland_Islands",
"Faroe Islands" => "Faröe-szigetek",
// "Faroe_Islands" => "Faroe_Islands",
// "Federated States of Micronesia" => "Federated States of Micronesia",
// "Federated_States_of_Micronesia" => "Federated_States_of_Micronesia",
"Fiji" => "Fidzsi",
"Finland" => "Finnország",
"France" => "Franciaország",
"French Guiana" => "Francia Guayana",
"French Polynesia" => "Francia Polinézia",
// "French Southern Territories" => "French Southern Territories",
// "French_Guiana" => "French_Guiana",
// "French_Polynesia" => "French_Polynesia",
// "French_Southern_Territories" => "French_Southern_Territories",
"Gabon" => "Gabon",
"Gambia" => "Gambia",
// "Georgia" => "Georgia",
"Germany" => "Németország",
"Ghana" => "Ghána",
"Gibraltar" => "Gibraltár",
"Greece" => "Görögország",
"Greenland" => "Grönland",
"Grenada" => "Grenada",
// "Guadeloupe" => "Guadeloupe",
// "Guam" => "Guam",
"Guatemala" => "Guatemala",
// "Guernsey" => "Guernsey",
// "Guinea Bissau" => "Guinea Bissau",
"Guinea" => "Guinea",
// "Guinea_Bissau" => "Guinea_Bissau",
// "Guyana" => "Guyana",
"Haiti" => "Haiti",
// "Heard Island and McDonald Islands" => "Heard Island and McDonald Islands",
// "Heard_Island_and_McDonald_Islands" => "Heard_Island_and_McDonald_Islands",
"Honduras" => "Honduras",
"Hong Kong" => "Hong Kong",
// "Hong_Kong" => "Hong_Kong",
"Hungary" => "Magyarország",
"Iceland" => "Izland",
"India" => "India",
"Indonesia" => "Indonézia",
"Iran" => "Irán",
"Iraq" => "Irák",
"Ireland" => "Írország",
// "Isle of Man" => "Isle of Man",
"Israel" => "Izrael",
"Italy" => "Olaszország",
// "Ivory Coast" => "Ivory Coast",
// "Ivory_Coast" => "Ivory_Coast",
"Jamaica" => "Jamaika",
"Japan" => "Japán",
// "Jersey" => "Jersey",
"Jordan" => "Jordánia",
"Kazakstan" => "Kazaksztán",
"Kenya" => "Kenya",
"Kiribati" => "Kiribati",
"Kuwait" => "Kuwait",
"Kyrgyzstan" => "Kirgizisztán",
"Laos" => "Laosz",
"Latvia" => "Lettország",
"Lebanon" => "Libanon",
// "Lesotho" => "Lesotho",
"Liberia" => "Libéria",
"Libya" => "Líbia",
"Liechtenstein" => "Liechtenstein",
"Lithuania" => "Litvánia",
"Luxemburg" => "Luxemburg",
"Macao" => "Makao",
"Macedonia" => "Macedónia",
"Madagascar" => "Madagaszkár",
"Malawi" => "Malawi",
"Malaysia" => "Malázia",
"Maldives" => "Maldív-szigetek",
"Mali" => "Mali",
"Malta" => "Málta",
// "Marshall Islands" => "Marshall Islands",
// "Marshall_Islands" => "Marshall_Islands",
// "Martinique" => "Martinique",
"Mauritania" => "Mauritánia",
// "Mauritius" => "Mauritius",
// "Mayotte" => "Mayotte",
"Mexico" => "Mexikó",
"Moldova" => "Moldova",
"Monaco" => "Monaco",
"Mongolia" => "Mongólia",
"Montenegro" => "Montenegro",
// "Montserrat" => "Montserrat",
"Morocco" => "Marokkó",
"Mozambique" => "Mozambik",
"Myanmar" => "Burma (Myanmar)",
"Namibia" => "Namíbia",
"Nauru" => "Nauru",
"Nepal" => "Nepál",
"Netherlands Antilles" => "Holland Antillák",
"Netherlands" => "Hollandia",
// "Netherlands_Antilles" => "Netherlands_Antilles",
"New Caledonia" => "Új Kaledónia",
"New Zealand" => "Új-Zéland",
// "New_Caledonia" => "New_Caledonia",
// "New_Zealand" => "New_Zealand",
"Nicaragua" => "Nicaragua",
"Niger" => "Niger",
"Nigeria" => "Nigéria",
"Niue" => "Niue",
"Norfolk Island" => "Norfolk-szigetek",
// "Norfolk_Island" => "Norfolk_Island",
"North Korea" => "Észak Korea",
// "North_Korea" => "North_Korea",
// "Northern Mariana Islands" => "Northern Mariana Islands",
// "Northern_Mariana_Islands" => "Northern_Mariana_Islands",
"Norway" => "Norvégia",
"Oman" => "Oman",
"Other" => "Egyéb",
"Pakistan" => "Pakisztán",
"Palau" => "Palau",
"Palestine" => "Palesztina",
"Panama" => "Panama",
"Papua New Guinea" => "Papua Új Guinea",
// "Papua_New_Guinea" => "Papua_New_Guinea",
// "Paraguay" => "Paraguay",
// "Peru" => "Peru",
// "Philippines" => "Philippines",
// "Pitcairn" => "Pitcairn",
// "Poland" => "Poland",
"Portugal" => "Portugália",
// "Puerto Rico" => "Puerto Rico",
// "Puerto_Rico" => "Puerto_Rico",
// "Quatar" => "Quatar",
// "Republic of Macedonia" => "Republic of Macedonia",
// "Republic_of_Macedonia" => "Republic_of_Macedonia",
// "Reunion" => "Reunion",
// "Romania" => "Romania",
// "Russia" => "Russia",
// "Russian Federation" => "Russian Federation",
// "Russian_Federation" => "Russian_Federation",
// "Rwanda" => "Rwanda",
// "Saint Helena" => "Saint Helena",
// "Saint Kitts and Nevis" => "Saint Kitts and Nevis",
// "Saint Lucia" => "Saint Lucia",
// "Saint Pierre and Miquelon" => "Saint Pierre and Miquelon",
// "Saint_Helena" => "Saint_Helena",
// "Saint_Kitts_and_Nevis" => "Saint_Kitts_and_Nevis",
// "Saint_Lucia" => "Saint_Lucia",
// "Saint_Pierre_and_Miquelon" => "Saint_Pierre_and_Miquelon",
// "Samoa" => "Samoa",
// "San Marino" => "San Marino",
// "San_Marino" => "San_Marino",
// "Sao Tome and Principe" => "Sao Tome and Principe",
// "Sao_Tome_and_Principe" => "Sao_Tome_and_Principe",
// "Saudi Arabia" => "Saudi Arabia",
// "Saudi_Arabia" => "Saudi_Arabia",
// "Senegal" => "Senegal",
// "Serbia" => "Serbia",
// "Seychelles" => "Seychelles",
// "Sierra Leone" => "Sierra Leone",
// "Sierra_Leone" => "Sierra_Leone",
// "Singapore" => "Singapore",
"Slovakia" => "Szlovákia",
"Slovenia" => "Szlovénia",
// "Solomon Islands" => "Solomon Islands",
// "Solomon_Islands" => "Solomon_Islands",
// "Somalia" => "Somalia",
// "South Africa" => "South Africa",
"South Georgia and South Sandwich Islands" => "South Georgia és South Sandwich Szigetek",
"South Korea" => "Dél Korea",
// "South_Africa" => "South_Africa",
// "South_Georgia_and_South_Sandwich_Islands" => "South_Georgia_and_South_Sandwich_Islands",
// "South_Korea" => "South_Korea",
"Spain" => "Spanyolország",
// "Sri Lanka" => "Sri Lanka",
// "Sri_Lanka" => "Sri_Lanka",
// "St Vincent Grenadines" => "St Vincent Grenadines",
// "St_Vincent_Grenadines" => "St_Vincent_Grenadines",
"Sudan" => "Szudán",
// "Surinam" => "Surinam",
// "Svalbard and Jan Mayen" => "Svalbard and Jan Mayen",
// "Svalbard_and_Jan_Mayen" => "Svalbard_and_Jan_Mayen",
// "Swaziland" => "Swaziland",
"Sweden" => "Svédország",
"Switzerland" => "Svájc",
"Syria" => "Szíria",
// "Taiwan" => "Taiwan",
"Tajikistan" => "Tadzsikisztán",
"Tanzania" => "Tanzánia",
"Thailand" => "Thaiföld",
// "Timor-Leste" => "Timor-Leste",
// "Togo" => "Togo",
// "Tokelau" => "Tokelau",
// "Tonga" => "Tonga",
// "Trinidad Tobago" => "Trinidad Tobago",
// "Trinidad_Tobago" => "Trinidad_Tobago",
"Tunisia" => "Tunézia",
// "Turkey" => "Turkey",
"Turkmenistan" => "Türkmenisztán",
// "Turks and Caicos Islands" => "Turks and Caicos Islands",
// "Turks_and_Caicos_Islands" => "Turks_and_Caicos_Islands",
// "Tuvalu" => "Tuvalu",
// "US Virgin Islands" => "US Virgin Islands",
// "US_Virgin_Islands" => "US_Virgin_Islands",
// "Uganda" => "Uganda",
// "Ukraine" => "Ukraine",
// "United Arab Emirates" => "United Arab Emirates",
"United Kingdom" => "Egyesült Királyság",
// "United Nations Organization" => "United Nations Organization",
// "United States Minor Outlying Islands" => "United States Minor Outlying Islands",
// "United States" => "United States",
// "United_Arab_Emirates" => "United_Arab_Emirates",
// "United_Kingdom" => "United_Kingdom",
// "United_Kingdom_-_England_and_Wales" => "United_Kingdom_-_England_and_Wales",
// "United_Kingdom_-_Northern_Ireland" => "United_Kingdom_-_Northern_Ireland",
// "United_Kingdom_-_Scotland" => "United_Kingdom_-_Scotland",
// "United_Nations_Organization" => "United_Nations_Organization",
// "United_States" => "United_States",
// "United_States_Minor_Outlying_Islands" => "United_States_Minor_Outlying_Islands",
// "Uruguay" => "Uruguay",
"Uzbekistan" => "Üzbegisztán",
// "Vanuatu" => "Vanuatu",
// "Vatican" => "Vatican",
// "Venezuela" => "Venezuela",
"Viet Nam" => "Vietnám",
// "Viet_Nam" => "Viet_Nam",
// "Wales" => "Wales",
// "Wallis and Futuna" => "Wallis and Futuna",
// "Wallis_and_Futuna" => "Wallis_and_Futuna",
// "Western Sahara" => "Western Sahara",
// "Western_Sahara" => "Western_Sahara",
"World" => "Világ",
// "Yemen" => "Yemen",
"Yugoslavia" => "Jugoszlávia",
// "Zambia" => "Zambia",
// "Zimbabwe" => "Zimbabwe",
"the former Yugoslav Republic of Macedonia" => "a korábbi Macedón Jugoszláv Köztársaság",
// "the_former_Yugoslav_Republic_of_Macedonia" => "the_former_Yugoslav_Republic_of_Macedonia",
// "Re" => "Re",
// "This forum is flat and doesn't allow replies to other replies" => "This forum is flat and doesn't allow replies to other replies",
"Copyright management" => "Szerzői jogok kezelése",
"No page indicated" => "Nincs megadva oldal",
"You must supply all the information, including title and year." => "Minden információt meg kell adni (különösen címet és az évet)",
// "Tiki was unable to retrieve login data from the database " => "Tiki was unable to retrieve login data from the database ",
// "The following error message was returned" => "The following error message was returned",
// "Things to check" => "Things to check",
// "Are your database login credentials correct" => "Are your database login credentials correct",
// "Did you complete the <a href='tiki-install.php' >Tiki Installer" => "Did you complete the <a href='tiki-install.php' >Tiki Installer",
// "Please see <a href=\"http://doc.tiki.org/\">the documentation</a> for more information" => "Please see <a href=\"http://doc.tiki.org/\">the documentation</a> for more information",
"You do not have permission to use this feature" => "Magasabb csoportszintű jogosultágra van szükséged, hogy ezt a funkciót használhasd",
// "This feature is for admins only" => "This feature is for admins only",
"Type" => "Típus",
"Size" => "Méret",
"Created" => "Létrehozás",
"Uploaded" => "Feltöltés",
"Last Modified" => "Utolsó módosítás",
// "Uploaded by" => "Uploaded by",
"Creator" => "Létrehozó",
// "Last Modified by" => "Last Modified by",
"Comment" => "Komment",
"Files" => "Fájlok",
"Last download" => "Legutóbbi letöltés",
"Locked by" => "Zárolta",
"Backlinks" => "Hivatkozások",
// "Delete After" => "Delete After",
// "Share with" => "Share with",
"Source" => "Forrás",
"Explorer" => "Böngésző",
"Path" => "Útvonal",
"Slideshow" => "Vetítés",
"Default View" => "Alapértelmezett nézet",
// "Gallery Icon" => "Gallery Icon",
"Register" => "Regisztráció",
// "Tiki Installer" => "Tiki Installer",
// "MySQL Improved (mysqli)" => "MySQL Improved (mysqli)",
// "MySQL classic (mysql)" => "MySQL classic (mysql)",
// "Email address not valid, test mail not sent" => "Email address not valid, test mail not sent",
// "Email address empty and \"copy\" checkbox not set, test mail not sent" => "Email address empty and \"copy\" checkbox not set, test mail not sent",
// "Test mail from Tiki installer %0" => "Test mail from Tiki installer %0",
// "Tiki version" => "Tiki version",
// "PHP version" => "PHP version",
"Server" => "Szerver",
"Sent" => "Elküldve",
// "Some invalid characters were detected in database name. Please use alphanumeric characters or _ or -" => "Some invalid characters were detected in database name. Please use alphanumeric characters or _ or -",
// "Database `%0` was created" => "Database `%0` was created",
// "Database `%0` creation failed. You need to create the database" => "Database `%0` creation failed. You need to create the database",
// "No database name specified" => "No database name specified",
// "Congratulations!\n\nYour server can send emails.\n\n" => "Congratulations!\n\nYour server can send emails.\n\n",
// "No automated tax" => "No automated tax",
// "Account name must not be empty" => "Account name must not be empty",
// "Budget is not a valid amount: " => "Budget is not a valid amount: ",
// "Locked must be either 0 or 1" => "Locked must be either 0 or 1",
// "Error creating account" => "Error creating account",
// "AccountId %0 is already in use and must not be changed. Please disable it if it is no longer needed" => "AccountId %0 is already in use and must not be changed. Please disable it if it is no longer needed",
// "Error updating account" => "Error updating account",
// "Account is already in use and must not be deleted. Please disable it, if it is no longer needed" => "Account is already in use and must not be deleted. Please disable it, if it is no longer needed",
// "Rollback failed, inconsistent database: Cleanup needed for journalId %0 in book %1" => "Rollback failed, inconsistent database: Cleanup needed for journalId %0 in book %1",
// "successfully rolled back #" => "successfully rolled back #",
// "Booking error creating journal entry" => "Booking error creating journal entry",
// "Booking error creating debit entry" => "Booking error creating debit entry",
// "Booking error creating credit entry" => "Booking error creating credit entry",
// "Number of debit entries differ: " => "Number of debit entries differ: ",
// "Number of credit entries differ: " => "Number of credit entries differ: ",
// "Splitting is only allowed on one side" => "Splitting is only allowed on one side",
// "Invalid debit amount " => "Invalid debit amount ",
// "Invalid debit account number " => "Invalid debit account number ",
// "Invalid credit amount " => "Invalid credit amount ",
// "Invalid credit account number " => "Invalid credit account number ",
// "Difference between debit and credit amounts " => "Difference between debit and credit amounts ",
// "Rollback failed, inconsistent database: Cleanup needed for stackId %0 in book %1" => "Rollback failed, inconsistent database: Cleanup needed for stackId %0 in book %1",
// "Booking error creating stack entry" => "Booking error creating stack entry",
// "Booking error creating stack debit entry" => "Booking error creating stack debit entry",
// "Booking error creating stack credit entry" => "Booking error creating stack credit entry",
// "Error deleting entry from stack" => "Error deleting entry from stack",
// "Booking error confirming stack entry" => "Booking error confirming stack entry",
// "Booking error cconfirming stack entry" => "Booking error cconfirming stack entry",
// "Error while updating statement" => "Error while updating statement",
// "is is not a number" => "is is not a number",
// "must be > 0" => "must be > 0",
// "Invalid transaction - please contact administrator" => "Invalid transaction - please contact administrator",
// "Error checking" => "Error checking",
// "does not exist" => "does not exist",
// "already exists" => "already exists",
// "This book has been closed. You can't create new accounts" => "This book has been closed. You can't create new accounts",
// "This book has been closed. You can't modify the account" => "This book has been closed. You can't modify the account",
// "This book has been closed. You can't delete the account" => "This book has been closed. You can't delete the account",
// "The date for the transaction is before this books start date" => "The date for the transaction is before this books start date",
// "The date for the transaction is after this books end date" => "The date for the transaction is after this books end date",
// "This book has been closed. You can't book into it any more" => "This book has been closed. You can't book into it any more",
// "Invalid booking date" => "Invalid booking date",
// "This book has been closed. You can't cancel transactions in it any more" => "This book has been closed. You can't cancel transactions in it any more",
// "New article post" => "New article post",
// "Edited article post" => "Edited article post",
// "Deleted article post" => "Deleted article post",
"The file is not a CSV file or has not a correct syntax" => "Ez vagy nem egy vesszővel elválasztott (CSV) fájl, vagy rossz a fájl belső formátuma",
// "Error line: %d" => "Error line: %d",
// "Spam is not welcome here" => "Spam is not welcome here",
// "anonymous" => "anonymous",
// "Blog cannot be found" => "Blog cannot be found",
"locked" => "zárolva",
"locked by" => "zárolta",
"refresh" => "frissítés",
// "go back to this crumb" => "go back to this crumb",
"Administration:" => "Adminisztráció:",
"All day" => "egész nap",
// "First day of week: Sunday (its ID is 0) - translators you need to localize this string" => "First day of week: Sunday (its ID is 0) - translators you need to localize this string",
"Sunday" => "Vasárnap",
// "Su" => "Su",
"Monday" => "Hétfő",
"Tuesday" => "Kedd",
"Wednesday" => "Szerda",
"Thursday" => "Csütörtök",
"Friday" => "Péntek",
"Saturday" => "Szombat",
"Mo" => "Hétfő",
"Tu" => "Kedd",
"We" => "Szerda",
// "Th" => "Th",
"Fr" => "Péntek",
// "Sa" => "Sa",
"in" => "itt",
"continued" => "bővebben",
"New Image Uploaded by" => "Az új képet feltöltötte:",
// "New Subscriptions" => "New Subscriptions",
// "New Item in Tracker" => "New Item in Tracker",
"tracker" => "űrlap",
"by" => " ",
// "Wiki" => "Wiki",
"Image Gallery" => "Képgaléria",
"Articles" => "Cikkek",
"Blogs" => "Blogok",
"Forums" => "Fórumok",
"Directory" => "Linktár",
"File Gallery" => "Fájlgaléria",
"FAQs" => "GYIK-ek",
"Quizzes" => "Kvízek",
"Trackers" => "Űrlapok",
"Survey" => "Kérdőív",
"Newsletter" => "Hírlevél",
// "Empty captcha value" => "Empty captcha value",
// "You have mistyped the anti-bot verification code. Please try again" => "You have mistyped the anti-bot verification code. Please try again",
// "Failed to validate captcha" => "Failed to validate captcha",
// "Captcha ID field is missing" => "Captcha ID field is missing",
// "Get a visual challenge" => "Get a visual challenge",
// "Get an audio challenge" => "Get an audio challenge",
// "Get a new challenge" => "Get a new challenge",
// "Type the two words" => "Type the two words",
// "Type what you hear" => "Type what you hear",
"Help" => "Súgó",
// "Play sound again" => "Play sound again",
// "Download sound as MP3" => "Download sound as MP3",
// "Incorrect. Try again" => "Incorrect. Try again",
// "A category named %0 already exists in %1" => "A category named %0 already exists in %1",
"article" => "cikk",
"blog" => "blog",
"directory" => "könytár",
"faq" => "gyik",
"file gallery" => "fájlgaléria",
"forum" => "fórum",
"image gallery" => "képgaléria",
// "newsletter" => "newsletter",
"poll" => "szavazás",
"quiz" => "kvíz",
"survey" => "kérdőív",
"wiki page" => "wiki oldal",
"image" => "kép",
"calendar" => "naptár",
"Permission denied" => "Hozzáférés megtagadva, magasabb szintű jogosultságra van szükség",
// "Invalid filename (using filters for filenames)" => "Invalid filename (using filters for filenames)",
"Cannot upload this file - maximum upload size exceeded" => "Túl nagy a fájl, nem tudom feltölteni",
"Cannot write to this file:" => "Nem tudok írni ebbe a fájlba:",
// "(not registered)" => "(not registered)",
// "Anonymous" => "Anonymous",
// "Your comment was rejected" => "Your comment was rejected",
// "Cannot perform spam check: %0" => "Cannot perform spam check: %0",
// "Please wait %0 seconds between posts" => "Please wait %0 seconds between posts",
"Wrong password. Cannot post comment" => "Rossz jelszó! A komment nem lett elküldve.",
// "A contribution is mandatory" => "A contribution is mandatory",
// "You have to enter a title and text" => "You have to enter a title and text",
// "Invalid Email" => "Invalid Email",
// "Your message has been queued for approval and will be posted after a moderator approves it" => "Your message has been queued for approval and will be posted after a moderator approves it",
// "This forum is locked" => "This forum is locked",
// "This thread is locked" => "This thread is locked",
// "This can happen if the page you are linking to has changed since you obtained the forwardlink or if the page is not viewable by the public" => "This can happen if the page you are linking to has changed since you obtained the forwardlink or if the page is not viewable by the public",
// "If you are logged in, try loggin out and then recreate the forwardlink" => "If you are logged in, try loggin out and then recreate the forwardlink",
// "Phrase not found" => "Phrase not found",
"Date" => "Dátum",
// "Click below to read Citing blocks" => "Click below to read Citing blocks",
// "Apply Profile \"Simple Wiki Attributes\" To Add ForwardLink Questions" => "Apply Profile \"Simple Wiki Attributes\" To Add ForwardLink Questions",
// "Saving.." => "Saving..",
// "Editing: " => "Editing: ",
"OK" => "OK",
"Cancel" => "Visszavonás",
"New" => "Új",
"Save" => "Mentés",
// "Create ForwardLink" => "Create ForwardLink",
// "Highlight text to be linked" => "Highlight text to be linked",
// "Accept TextLink & ForwardLink" => "Accept TextLink & ForwardLink",
// "Ok" => "Ok",
// "You selected" => "You selected",
// "Suggested selection" => "Suggested selection",
// "Copy To Clipboard" => "Copy To Clipboard",
// "TextLink & ForwardLink data copied to your clipboard" => "TextLink & ForwardLink data copied to your clipboard",
"Loading.." => "Betöltés..",
// "Edit ForwardLink Questions" => "Edit ForwardLink Questions",
"Edit" => "Szerkesztés",
"Delete" => "Törlés",
// "Are you sure" => "Are you sure",
// "Suggestion" => "Suggestion",
// "Please fill in the questions below" => "Please fill in the questions below",
// "Copy This" => "Copy This",
// "New File" => "New File",
// "%0 near \"%1\"" => "%0 near \"%1\"",
// "Expecting \"(\"" => "Expecting \"(\"",
// "Unexpected \"%0\"" => "Unexpected \"%0\"",
// "Expecting \")\"" => "Expecting \")\"",
// "No formula provided" => "No formula provided",
// "Variable not found \"%0\"" => "Variable not found \"%0\"",
// "Unknown operation \"%0\"" => "Unknown operation \"%0\"",
"All" => "Összes",
// "Count" => "Count",
// "Count By Date" => "Count By Date",
// "Count By Date Filter Id" => "Count By Date Filter Id",
// "Count Users Filter Id" => "Count Users Filter Id",
// "Count Users IP Filter Id" => "Count Users IP Filter Id",
// "Ascending By Date" => "Ascending By Date",
// "Descending By Date" => "Descending By Date",
// "Logs" => "Logs",
"Action" => "Akció",
"Start" => "Kezdés",
"End" => "Befejezés",
"Fields" => "Mezők",
// "Grouping" => "Grouping",
"Sort" => "Rendezés",
"Limit" => "Limit",
"Tracker" => "Űrlap",
// " Join Tracker " => " Join Tracker ",
// " on " => " on ",
// " equals " => " equals ",
// "Item Id" => "Item Id",
"Search" => "Keresés",
// " for " => " for ",
"Status" => "Státusz",
// "Articles deleted" => "Articles deleted",
// "removed the article" => "removed the article",
// "Edited articles" => "Edited articles",
// "edited the article" => "edited the article",
// "New articles submited" => "New articles submited",
// "created the article" => "created the article",
// "New blog posts" => "New blog posts",
// "replied to the blog" => "replied to the blog",
// "New calendar events" => "New calendar events",
// "%0 added or updated event %1" => "%0 added or updated event %1",
// "Changes in categories" => "Changes in categories",
// "added the %0 %1 to the category %2" => "added the %0 %1 to the category %2",
// "created the subcategory" => "created the subcategory",
// "removed the subcategory" => "removed the subcategory",
"from" => "tól",
// "edited the category" => "edited the category",
// "removed the %0 %1 from the category %2" => "removed the %0 %1 from the category %2",
// "File galleries changed" => "File galleries changed",
// "%0 edited the file gallery %1" => "%0 edited the file gallery %1",
// "%0 uploaded the file %1" => "%0 uploaded the file %1",
// "onto" => "onto",
// "%0 removed the file %1 from %2" => "%0 removed the file %1 from %2",
// "New replies in forum topics" => "New replies in forum topics",
// "%0 <a href=%1>replied</a> to the topic %2" => "%0 <a href=%1>replied</a> to the topic %2",
// "New posts in forums" => "New posts in forums",
// "%0 created the topic %1 at forum %2" => "%0 created the topic %1 at forum %2",
// "Image galleries changed" => "Image galleries changed",
// "changed the picture gallery" => "changed the picture gallery",
// "uploaded the picture" => "uploaded the picture",
// "removed the picture" => "removed the picture",
// "Comments in tracker items" => "Comments in tracker items",
// "%0 added a new comment to %1 on tracker %2" => "%0 added a new comment to %1 on tracker %2",
// "%0 added a new comment to item id %1 on tracker %2" => "%0 added a new comment to item id %1 on tracker %2",
// "Tracker items modified" => "Tracker items modified",
// "%0 added or updated tracker item %1 on tracker %2" => "%0 added or updated tracker item %1 on tracker %2",
// "%0 added or updated tracker item id %1 on tracker %2" => "%0 added or updated tracker item id %1 on tracker %2",
// "New attachments in wiki pages" => "New attachments in wiki pages",
// "%0 uploaded the file %1 onto %2" => "%0 uploaded the file %1 onto %2",
// "Wiki pages updated" => "Wiki pages updated",
// "%0 edited the wikipage %1 (<a href=%2>this history</a>, <a href=%3>all history</a>)" => "%0 edited the wikipage %1 (<a href=%2>this history</a>, <a href=%3>all history</a>)",
// "and %0 more changes of the same type" => "and %0 more changes of the same type",
// "Nothing has happened" => "Nothing has happened",
// "Report from %0 (1 change)" => "Report from %0 (1 change)",
// "Report from %0 (%1 changes)" => "Report from %0 (%1 changes)",
// "Report from %0 (no changes)" => "Report from %0 (no changes)",
// "%0 (latest)" => "%0 (latest)",
// "No value for '%0'" => "No value for '%0'",
// "Unknown formatting rule '%0' for '%1'" => "Unknown formatting rule '%0' for '%1'",
// "Indexing failed while processing \"%0\" (type %1) with the error \"%2\"" => "Indexing failed while processing \"%0\" (type %1) with the error \"%2\"",
// "filterRange: \"from\" value not parsed" => "filterRange: \"from\" value not parsed",
// "filterRange: \"to\" value not parsed" => "filterRange: \"to\" value not parsed",
// "Permission Denied" => "Permission Denied",
// "Invalid data" => "Invalid data",
// "Action not found (%0 in %1)" => "Action not found (%0 in %1)",
// "Controller not found (%0)" => "Controller not found (%0)",
// "Comments not allowed on this page" => "Comments not allowed on this page",
// "Parent is locked" => "Parent is locked",
// "Pseudonym must be specified" => "Pseudonym must be specified",
// "Email must be specified" => "Email must be specified",
// "Title is empty" => "Title is empty",
// "Content is empty" => "Content is empty",
// "Permissions denied" => "Permissions denied",
// "Comment not found" => "Comment not found",
// "Comment already approved" => "Comment already approved",
// "Invalid argument" => "Invalid argument",
// "Thread not specified" => "Thread not specified",
"Feature disabled" => "A szolgáltatás ki van kapcsolva",
// "Reserved to administrators during development" => "Reserved to administrators during development",
// "Tiki not connected. Please click \"Send Info\" to join in" => "Tiki not connected. Please click \"Send Info\" to join in",
// "Something went wrong. Tiki Connect is still experimental. Please try again" => "Something went wrong. Tiki Connect is still experimental. Please try again",
// "registration" => "registration",
// "confirmation" => "confirmation",
// "Connect Feature disabled" => "Connect Feature disabled",
// "Connect Server Mode disabled" => "Connect Server Mode disabled",
// "Please confirm you want to participate in Tiki Connect" => "Please confirm you want to participate in Tiki Connect",
// "Welcome to Tiki Connect, please click \"Send Info\" when you want to make a connection" => "Welcome to Tiki Connect, please click \"Send Info\" when you want to make a connection",
// "Something went wrong on the server. Tiki Connect is still experimental" => "Something went wrong on the server. Tiki Connect is still experimental",
// "Captcha code problem" => "Captcha code problem",
// "Connect data received, thanks" => "Connect data received, thanks",
// "Your Tiki is not registered here yet, please try again" => "Your Tiki is not registered here yet, please try again",
// "Feature disabled: %0" => "Feature disabled: %0",
// "\"%0\" already exists" => "\"%0\" already exists",
// "Field Required" => "Field Required",
// "Not found" => "Not found",
// "Must be authenticated" => "Must be authenticated",
// "Invalid input" => "Invalid input",
// "File could not be uploaded. Restrictions apply" => "File could not be uploaded. Restrictions apply",
// "Upload from source disabled" => "Upload from source disabled",
// "Data could not be obtained" => "Data could not be obtained",
// "Manual refresh disabled" => "Manual refresh disabled",
// "Requested gallery does not exist" => "Requested gallery does not exist",
// "Feature Disabled" => "Feature Disabled",
// "Translation not supported for the specified object type" => "Translation not supported for the specified object type",
// "No source provided" => "No source provided",
// "No source or target provided" => "No source or target provided",
// "Not allowed to attach the selected translations" => "Not allowed to attach the selected translations",
// "Could not attach the translations" => "Could not attach the translations",
// "Not allowed to detach the selected translations" => "Not allowed to detach the selected translations",
// "Object has no language and cannot be translated" => "Object has no language and cannot be translated",
// "No box available for %0" => "No box available for %0",
// "Remote service unaccessible (%0)" => "Remote service unaccessible (%0)",
// "Reserved to tracker administrators" => "Reserved to tracker administrators",
// "Type does not exist" => "Type does not exist",
// "Not allowed to view the tracker" => "Not allowed to view the tracker",
// "Warning: Required field types not enabled: %0" => "Warning: Required field types not enabled: %0",
// "Tracker contains no listed field, no meaningful information will be provided in the default list" => "Tracker contains no listed field, no meaningful information will be provided in the default list",
// "Tracker contains no field in the title, no link will be generated" => "Tracker contains no field in the title, no link will be generated",
// "Captcha" => "Captcha",
// "Distinct" => "Distinct",
"Page Name" => "Oldal neve",
"Password" => "Jelszó",
// "Regular Expression (Pattern)" => "Regular Expression (Pattern)",
// "User Name" => "User Name",
// "Invalid data provided" => "Invalid data provided",
// "Item could not be created" => "Item could not be created",
// "Not allowed to export" => "Not allowed to export",
// "No valid field selected for export" => "No valid field selected for export",
// "File upload failed" => "File upload failed",
// "Uploaded file could not be read" => "Uploaded file could not be read",
"Last Modification" => "Utolsó módosítás",
"Item ID" => "Tétel ID",
"Filename" => "Fájlnév",
"Creation date" => "Létrehozás dátuma",
// "Views" => "Views",
// "File size" => "File size",
"Version" => "Verzió",
// "File type" => "File type",
// "Long description" => "Long description",
"User" => "Felhasználó",
// "Error in search query" => "Error in search query",
// "Remote Source" => "Remote Source",
// "Automatically generated field for synchronized trackers. Contains the itemId of the remote item" => "Automatically generated field for synchronized trackers. Contains the itemId of the remote item",
// "Tracker does not exist" => "Tracker does not exist",
// "Tracker is not synchronized with a remote source" => "Tracker is not synchronized with a remote source",
// "Operation reserved for tracker administrators" => "Operation reserved for tracker administrators",
// "Following mandatory fields are missing: %0" => "Following mandatory fields are missing: %0",
// "Invalid value in %0: %1" => "Invalid value in %0: %1",
// "Invalid value in %0" => "Invalid value in %0",
// "Field does not exist in tracker" => "Field does not exist in tracker",
// "secure connection required" => "secure connection required",
// "Create a form which will be posted somewhere, not necessarily trackers or even Tiki" => "Create a form which will be posted somewhere, not necessarily trackers or even Tiki",
// "The title of the button" => "The title of the button",
"Post" => "Poszt",
// "The protocol to use at the form: either get or post" => "The protocol to use at the form: either get or post",
// "Script" => "Script",
// "The arbitrary url of the destination of the form" => "The arbitrary url of the destination of the form",
"Parameters" => "Paraméterek",
// "Here page:fieldname can be repeated several times, it specifies the variable names to pass in the form, as well as value taken from the current item from field named fieldname. highlight=test can also be repeated and is useful for fixed values as params to pass to the form" => "Here page:fieldname can be repeated several times, it specifies the variable names to pass in the form, as well as value taken from the current item from field named fieldname. highlight=test can also be repeated and is useful for fixed values as params to pass to the form",
// "Auto-Increment" => "Auto-Increment",
// "Allows an incrementing value field, or itemId field" => "Allows an incrementing value field, or itemId field",
// "The starting value for the field" => "The starting value for the field",
// "Prepend" => "Prepend",
// "Text that will be displayed before the field" => "Text that will be displayed before the field",
// "Append" => "Append",
// "Text that will be displayed after the field" => "Text that will be displayed after the field",
// "If set to \"itemId\", will set this field to match the value of the actual database itemId field value" => "If set to \"itemId\", will set this field to match the value of the actual database itemId field value",
"Category" => "Kategória",
// "Allows for one or multiple categories under the specified main category to be affected to the tracker item" => "Allows for one or multiple categories under the specified main category to be affected to the tracker item",
// "Parent Category" => "Parent Category",
// "Child categories will be provided as options for the field" => "Child categories will be provided as options for the field",
// "Input Type" => "Input Type",
// "User interface control to be used" => "User interface control to be used",
// "Drop Down" => "Drop Down",
// "Radio buttons" => "Radio buttons",
// "List box" => "List box",
// "Multiple-selection check-boxes" => "Multiple-selection check-boxes",
"Select All" => "Összes kijelölése",
// "Includes a control to select all available options for multi-selection controls" => "Includes a control to select all available options for multi-selection controls",
// "No controls" => "No controls",
// "Include controls" => "Include controls",
// "All descendants" => "All descendants",
// "Display all descendants instead of only first-level ones" => "Display all descendants instead of only first-level ones",
// "First level only" => "First level only",
// "Displays the field description in a help tooltip" => "Displays the field description in a help tooltip",
// "No help" => "No help",
// "Tooltip" => "Tooltip",
"Checkbox" => "Checkbox",
// "Provides a checkbox field for yes/no, on/off input" => "Provides a checkbox field for yes/no, on/off input",
"Yes" => "Igen",
"No" => "Nem",
// "Computed Field" => "Computed Field",
// "Provides a computed value based on numeric field values. Consider using webservices or JavaScript to perform the task instead of using this type" => "Provides a computed value based on numeric field values. Consider using webservices or JavaScript to perform the task instead of using this type",
// "This feature is still in place for backwards compatibility. While there are no flaws associated to it, it could be used as a vector for attacks causing a lot of damage. Webservice field or custom JavaScript is recommended instead of this field" => "This feature is still in place for backwards compatibility. While there are no flaws associated to it, it could be used as a vector for attacks causing a lot of damage. Webservice field or custom JavaScript is recommended instead of this field",
"Formula" => "Képlet",
// "The formula to be computed supporting various operators (+ - * / and parenthesis), references to other field made using the field id preceeded by #" => "The formula to be computed supporting various operators (+ - * / and parenthesis), references to other field made using the field id preceeded by #",
// "Country Selector" => "Country Selector",
// "Allows a selection from a specified list of countries" => "Allows a selection from a specified list of countries",
"Display" => "Leírás",
// "Specify the rendering type for the field" => "Specify the rendering type for the field",
// "Name and flag" => "Name and flag",
// "Name only" => "Name only",
// "Flag only" => "Flag only",
"Sort Order" => "Rendezési sorrend",
// "Determines whether the ordering should be based on the translated name or the English name" => "Determines whether the ordering should be based on the translated name or the English name",
// "Translated name" => "Translated name",
// "English name" => "English name",
// "Currency Field" => "Currency Field",
// "Provides a one-line field for numeric input only. Prepend or append values may be alphanumeric" => "Provides a one-line field for numeric input only. Prepend or append values may be alphanumeric",
// "Same Row" => "Same Row",
// "Displays the next field on the same line" => "Displays the next field on the same line",
// "Display Size" => "Display Size",
// "Visible size of the field in characters. Does not affect the numeric length" => "Visible size of the field in characters. Does not affect the numeric length",
// "Text to be displayed prior to the currency amount" => "Text to be displayed prior to the currency amount",
// "Text to be displayed after the numeric value" => "Text to be displayed after the numeric value",
// "Locale" => "Locale",
// "Set locale for currency formatting, for example en_US or en_US.UTF-8 or en_US.ISO-8559-1. Default is en_US" => "Set locale for currency formatting, for example en_US or en_US.UTF-8 or en_US.ISO-8559-1. Default is en_US",
// "Currency" => "Currency",
// "A custom alphanumeric currency code. Not needed if locale is set and a standard code is desired. Default is USD" => "A custom alphanumeric currency code. Not needed if locale is set and a standard code is desired. Default is USD",
// "Symbol" => "Symbol",
// "Set whether the currency code (for example USD) or symbol (for example \$) will display. Defaults to symbol" => "Set whether the currency code (for example USD) or symbol (for example \$) will display. Defaults to symbol",
// "Currency code" => "Currency code",
// "Currency symbol" => "Currency symbol",
// "First or all" => "First or all",
// "Set whether the currency code or symbol will be displayed against all amounts or only the first amount" => "Set whether the currency code or symbol will be displayed against all amounts or only the first amount",
// "First item only" => "First item only",
// "Date and Time" => "Date and Time",
// "Provides drop-down options to accurately select a date and/or time" => "Provides drop-down options to accurately select a date and/or time",
// "Components to be included" => "Components to be included",
// "Date only" => "Date only",
// "Start Year" => "Start Year",
// "Year to allow selecting from" => "Year to allow selecting from",
// "End Year" => "End Year",
// "Year to allow selecting to" => "Year to allow selecting to",
// "Default selection" => "Default selection",
// "Indicates if blank dates should be allowed" => "Indicates if blank dates should be allowed",
// "Current Date" => "Current Date",
// "Blank" => "Blank",
// "Allows users to select only from a specified set of options" => "Allows users to select only from a specified set of options",
"Option" => "Opció",
// "An option, if containing an equal sign, the prior part will be used as the value while the later as the label" => "An option, if containing an equal sign, the prior part will be used as the value while the later as the label",
// "Drop Down with Other field" => "Drop Down with Other field",
// "Allows users to select from a specified set of options or to enter an alternate option" => "Allows users to select from a specified set of options or to enter an alternate option",
// "An option, if containing an equal sign, the prior part will be used as the value while the later as the label. It is recommended to add an \"other\" option" => "An option, if containing an equal sign, the prior part will be used as the value while the later as the label. It is recommended to add an \"other\" option",
// "Radio Buttons" => "Radio Buttons",
// "Multiselect" => "Multiselect",
// "Allows a user to select multiple values from a specified set of options" => "Allows a user to select multiple values from a specified set of options",
// "Dynamic Items List" => "Dynamic Items List",
// "Dynamically updates a selection list based on linked data from another tracker" => "Dynamically updates a selection list based on linked data from another tracker",
"Tracker ID" => "Űrlap ID",
// "Tracker to link with" => "Tracker to link with",
// "Field ID (Other tracker)" => "Field ID (Other tracker)",
// "Field ID to link with in the other tracker" => "Field ID to link with in the other tracker",
// "Field ID (This tracker)" => "Field ID (This tracker)",
// "Field ID to link with in the current tracker" => "Field ID to link with in the current tracker",
// "Listed Field" => "Listed Field",
// "Field ID to be displayed in the drop list" => "Field ID to be displayed in the drop list",
"Status Filter" => "Státusz szűrő",
// "Restrict listed items to specific statuses" => "Restrict listed items to specific statuses",
"all" => "összes",
"open" => "nyitva",
"pending" => "függőben",
"closed" => "lezárva",
// "open, pending" => "open, pending",
// "pending, closed" => "pending, closed",
// "Tracker Field Factory Error: Pref \"%0\" required for field type \"%1\"" => "Tracker Field Factory Error: Pref \"%0\" required for field type \"%1\"",
"Attachment" => "Melléklet",
// "Allows a file to be attached to the tracker item" => "Allows a file to be attached to the tracker item",
"List View" => "Lista nézet",
// "Defines how attachments will be displayed within the field" => "Defines how attachments will be displayed within the field",
"name" => "név",
"type" => "típus",
// "name, size" => "name, size",
// "name, type, size" => "name, type, size",
// "uploader" => "uploader",
// "mediaplayer" => "mediaplayer",
"Download" => "Letöltés",
// "Attached and upload files stored in the file galleries to the tracker item" => "Attached and upload files stored in the file galleries to the tracker item",
"Gallery ID" => "Galéria ID",
// "File gallery to upload new files into" => "File gallery to upload new files into",
// "MIME Type Filter" => "MIME Type Filter",
// "Mask for accepted MIME types in the field" => "Mask for accepted MIME types in the field",
// "File Count" => "File Count",
// "Maximum number of files to be attached on the field" => "Maximum number of files to be attached on the field",
// "Display Images" => "Display Images",
// "Show files as images or object links" => "Show files as images or object links",
"Links" => "Linkek",
"Images" => "Képek",
// "Image parameters" => "Image parameters",
// "URL encoded params used as in the {img} plugin. e.g" => "URL encoded params used as in the {img} plugin. e.g",
// "Image parameters for lists" => "Image parameters for lists",
// "Include Child Galleries" => "Include Child Galleries",
// "Use files from child galleries as well" => "Use files from child galleries as well",
// "Replace Existing File" => "Replace Existing File",
// "Replace existing file if any, instead of uploading new one" => "Replace existing file if any, instead of uploading new one",
// "Problem with uploaded file: \"%0\"" => "Problem with uploaded file: \"%0\"",
// "No gallery for uploaded file, galleryId=%0" => "No gallery for uploaded file, galleryId=%0",
// "No permissions to upload file to gallery \"%0\"" => "No permissions to upload file to gallery \"%0\"",
"Freetags" => "Címkék",
// "Allows freetags to be shown or added for tracker items" => "Allows freetags to be shown or added for tracker items",
// "Visible size of the input field" => "Visible size of the input field",
// "Hide or show the input help" => "Hide or show the input help",
"Show" => "Megjelenítés",
"Hide" => "Elrejtés",
// "Suggest" => "Suggest",
// "Hide or show the freetag suggestions" => "Hide or show the freetag suggestions",
// "Geographic Feature" => "Geographic Feature",
// "Stores a geographic feature on a map" => "Stores a geographic feature on a map",
// "Feature cannot be set or modified through this interface" => "Feature cannot be set or modified through this interface",
// "Feature cannot be viewed" => "Feature cannot be viewed",
// "Group Selector" => "Group Selector",
// "Allows a selection from a specified list of user groups" => "Allows a selection from a specified list of user groups",
// "Auto-Assign" => "Auto-Assign",
// "Determines if any group should be automatically assigned to the field" => "Determines if any group should be automatically assigned to the field",
// "Modifier" => "Modifier",
// "Group Filter" => "Group Filter",
// "Limit listed groups to those including the specified group" => "Limit listed groups to those including the specified group",
// "Assign to the group" => "Assign to the group",
// "For no autoaassigned field, the user (user selector if exsits or user) will be assigned to the group and it will be his default group. The group must have the user choice setting on" => "For no autoaassigned field, the user (user selector if exsits or user) will be assigned to the group and it will be his default group. The group must have the user choice setting on",
"Assign" => "Hozzárendelés",
// "Header" => "Header",
// "Displays a header between fields to delimit a section and allow folding the fields" => "Displays a header between fields to delimit a section and allow folding the fields",
// "Header Level" => "Header Level",
// "Level of the header to use for complex tracker structures needing multiple heading levels" => "Level of the header to use for complex tracker structures needing multiple heading levels",
// "Default State" => "Default State",
// "Controls the section toggles" => "Controls the section toggles",
"Open" => "Nyitva",
"Closed" => "Lezárva",
"Icon" => "Ikon",
// "Allows to select an image as an icon attached to the tracker item from file galleries" => "Allows to select an image as an icon attached to the tracker item from file galleries",
// "Default image" => "Default image",
// "Path to the default icon used" => "Path to the default icon used",
"Image" => "Kép",
// "Allow users to upload images on the tracker item" => "Allow users to upload images on the tracker item",
// "List image width" => "List image width",
// "Display size in pixels" => "Display size in pixels",
// "List image height" => "List image height",
// "Detail image width" => "Detail image width",
// "Detail image height" => "Detail image height",
// "Maximum image size" => "Maximum image size",
// "Maximum image width or height in pixels" => "Maximum image width or height in pixels",
"Shadowbox" => "Shadowbox",
// "Shadowbox usage on this field" => "Shadowbox usage on this field",
// "Do not use" => "Do not use",
// "One box per item" => "One box per item",
// "Use the same box for all images" => "Use the same box for all images",
// "Missing Icon" => "Missing Icon",
// "Icon to use when no images have been uploaded" => "Icon to use when no images have been uploaded",
// "Invalid imagename (using filters for filenames)" => "Invalid imagename (using filters for filenames)",
// "In Group" => "In Group",
// "Indicates if the user associated to the item is member of a specified group" => "Indicates if the user associated to the item is member of a specified group",
"Group Name" => "Csoport neve",
// "Name of the group to verify" => "Name of the group to verify",
// "How to display the result" => "How to display the result",
// "Yes/No" => "Yes/No",
// "Join date" => "Join date",
// "IP Selector" => "IP Selector",
// "IP address input field" => "IP address input field",
// "Auto-assign" => "Auto-assign",
// "Automatically assign the value on creation or edit" => "Automatically assign the value on creation or edit",
// "Item Link" => "Item Link",
// "Link to an other item, similar to a foreign key" => "Link to an other item, similar to a foreign key",
// "Tracker to link to" => "Tracker to link to",
"Field ID" => "Mező ID",
// "Default field to display" => "Default field to display",
// "How the link to the item should be rendered" => "How the link to the item should be rendered",
"Value" => "Érték",
// "Link" => "Link",
// "Multiple Fields" => "Multiple Fields",
// "Display the values from multiple fields instead of a single one, separated by |" => "Display the values from multiple fields instead of a single one, separated by |",
// "Limit the available items to a selected set" => "Limit the available items to a selected set",
// "Link Page" => "Link Page",
// "Link to a wiki page instead of directly to the item" => "Link to a wiki page instead of directly to the item",
// "Add Items" => "Add Items",
// "Display text to allow new items to be added - e.g. \"Add item...\" (requires jQuery-UI)" => "Display text to allow new items to be added - e.g. \"Add item...\" (requires jQuery-UI)",
// "Add Item Template Page" => "Add Item Template Page",
// "Wiki page to use as a Pretty Tracker template" => "Wiki page to use as a Pretty Tracker template",
// "Preselect item based on value in this field" => "Preselect item based on value in this field",
// "Preselect item based on value in specified field ID of item being edited" => "Preselect item based on value in specified field ID of item being edited",
// "Preselect based on value in this remote field" => "Preselect based on value in this remote field",
// "Match preselect item with this field ID in tracker that is being linked to" => "Match preselect item with this field ID in tracker that is being linked to",
// "Preselection matching method" => "Preselection matching method",
// "Method to use to match fields for preselection purposes" => "Method to use to match fields for preselection purposes",
"Exact Match" => "Pontos egyezés",
// "Field here is part of field there" => "Field here is part of field there",
// "Match domain, used for URL fields" => "Match domain, used for URL fields",
// "One item per value" => "One item per value",
// "Display only one random item per value" => "Display only one random item per value",
// "Only one random item for each value" => "Only one random item for each value",
// "Displays all the items for a same value with a notation value (itemId)" => "Displays all the items for a same value with a notation value (itemId)",
// "Select multiple values" => "Select multiple values",
// "Allow the user to select multiple values" => "Allow the user to select multiple values",
// "Index remote fields" => "Index remote fields",
// "Index one or multiple fields from the master tracker along with the child, separated by |" => "Index one or multiple fields from the master tracker along with the child, separated by |",
// "Items List" => "Items List",
// "Displays a list of field values from another tracker that has a relation with this tracker" => "Displays a list of field values from another tracker that has a relation with this tracker",
// "Tracker to list items from" => "Tracker to list items from",
// "Link Field ID" => "Link Field ID",
// "Field ID from the other tracker containing an item link pointing to the item in this tracker or some other value to be matched" => "Field ID from the other tracker containing an item link pointing to the item in this tracker or some other value to be matched",
// "Value Field ID" => "Value Field ID",
// "Field ID from this tracker matching the value in the link field ID from the other tracker if the field above is not an item link" => "Field ID from this tracker matching the value in the link field ID from the other tracker if the field above is not an item link",
// "Fields to display" => "Fields to display",
// "Display alternate fields from the other tracker instead of the item title" => "Display alternate fields from the other tracker instead of the item title",
// "How the link to the items should be rendered" => "How the link to the items should be rendered",
// "Read Only" => "Read Only",
// "Date and Time (Date Picker)" => "Date and Time (Date Picker)",
// "Provides jQuery-UI date picker select a date and optionally time" => "Provides jQuery-UI date picker select a date and optionally time",
// "Default value" => "Default value",
// "Default date and time for new items" => "Default date and time for new items",
// "None (undefined)" => "None (undefined)",
// "Item creation date and time" => "Item creation date and time",
"Language" => "Nyelv",
// "Assign a language to the tracker item to enable multilingual trackers" => "Assign a language to the tracker item to enable multilingual trackers",
// "Indicates if the language should be assigned as the item's language" => "Indicates if the language should be assigned as the item's language",
"LDAP" => "LDAP",
// "Display a field value from a specific user in LDAP" => "Display a field value from a specific user in LDAP",
"Filter" => "Szűrő",
// "LDAP filter, can contain the %field_name% placeholder to be replaced with the current field's name" => "LDAP filter, can contain the %field_name% placeholder to be replaced with the current field's name",
"Field" => "Mező",
// "Field name returned by LDAP" => "Field name returned by LDAP",
// "DSN" => "DSN",
// "Data source name registered in Tiki" => "Data source name registered in Tiki",
"Location" => "Lokáció",
// "Allows to select a geolocation for the item and displays it on a map" => "Allows to select a geolocation for the item and displays it on a map",
// "Use as item location" => "Use as item location",
// "When enabled, records the field's value as the item's geolocation to be displayed on locator maps" => "When enabled, records the field's value as the item's geolocation to be displayed on locator maps",
// "Numeric Field" => "Numeric Field",
// "Text to be displayed prior to the numeric value" => "Text to be displayed prior to the numeric value",
// "Decimal Places" => "Decimal Places",
// "Amount of decimals to preserve before rounding" => "Amount of decimals to preserve before rounding",
// "Decimal separator when displaying data" => "Decimal separator when displaying data",
// "Single character. Use c for comma, d for dot or s for space. The valid decimal separator when inserting numbers may depend on site language and web browser. See documentation for more details" => "Single character. Use c for comma, d for dot or s for space. The valid decimal separator when inserting numbers may depend on site language and web browser. See documentation for more details",
// "Thousand separator when displaying data" => "Thousand separator when displaying data",
// "Single character,  Use c for comma, d for dot or s for space.  When inserting data no thousands separator is needed" => "Single character,  Use c for comma, d for dot or s for space.  When inserting data no thousands separator is needed",
// "Page Selector" => "Page Selector",
// "Allows a selection from the list of pages" => "Allows a selection from the list of pages",
// "Will auto-assign the creator of the item" => "Will auto-assign the creator of the item",
// "Visible size of the input in characters" => "Visible size of the input in characters",
"Create Page" => "Oldal létrehozása",
// "Create missing pages using the page name in this file as the template" => "Create missing pages using the page name in this file as the template",
// "Display the value as a link to the page" => "Display the value as a link to the page",
"Rating" => "Értékelés",
// "A rating of the tracker item" => "A rating of the tracker item",
// "The possible options (comma separated integers) for the rating" => "The possible options (comma separated integers) for the rating",
"Mode" => "Mód",
// "Display rating options as" => "Display rating options as",
// "Stars" => "Stars",
// "Single Option: e.g. Like" => "Single Option: e.g. Like",
"Labels" => "Feliratok",
// "The text labels (comma separated) for the possible options" => "The text labels (comma separated) for the possible options",
// "Stars (deprecated)" => "Stars (deprecated)",
// "Displays a star rating" => "Displays a star rating",
// "A possible option for the rating" => "A possible option for the rating",
// "Stars (system)" => "Stars (system)",
"Average" => "Átlag",
// "Number of votes" => "Number of votes",
// "Your rating" => "Your rating",
// "Relations" => "Relations",
// "Allows to create arbitrary relations between the trackers and other objects in the system" => "Allows to create arbitrary relations between the trackers and other objects in the system",
// "Relation" => "Relation",
// "Relation qualifier. Must be a three-part qualifier containing letters and separated by dots" => "Relation qualifier. Must be a three-part qualifier containing letters and separated by dots",
// "URL-encoded list of filters to be applied on object selection" => "URL-encoded list of filters to be applied on object selection",
// "Read-only" => "Read-only",
// "Only display the incoming relations instead of manipulating them" => "Only display the incoming relations instead of manipulating them",
// "Include Invert" => "Include Invert",
// "Include invert relations in the list" => "Include invert relations in the list",
"Email" => "E-mail",
// "Allows to input an email address with options of making it active" => "Allows to input an email address with options of making it active",
// "Link Type" => "Link Type",
// "How the email address will be rendered" => "How the email address will be rendered",
"Plain text" => "Egyszerű szöveg",
// "Encoded mailto link" => "Encoded mailto link",
// "Simple mailto link" => "Simple mailto link",
// "Watch Open" => "Watch Open",
// "Notify this address every time the status changes to open" => "Notify this address every time the status changes to open",
// "Watch Pending" => "Watch Pending",
// "Notify this address every time the status changes to pending" => "Notify this address every time the status changes to pending",
// "Watch Closed" => "Watch Closed",
// "Notify this address every time the status changes to closed" => "Notify this address every time the status changes to closed",
// "Static Text" => "Static Text",
// "Displays the field description as static text that can be used to display notes or additional instructions" => "Displays the field description as static text that can be used to display notes or additional instructions",
// "Wiki Parse" => "Wiki Parse",
// "Indicates if the description should be parsed as wiki syntax for formatting" => "Indicates if the description should be parsed as wiki syntax for formatting",
// "Handle line breaks as new lines only" => "Handle line breaks as new lines only",
// "Maximum Length (List)" => "Maximum Length (List)",
// "Maximum amount of characters to be displayed in list mode" => "Maximum amount of characters to be displayed in list mode",
// "Text Field" => "Text Field",
// "Single-line text input" => "Single-line text input",
// "Display the next field on the same row" => "Display the next field on the same row",
// "Visible size of the field in characters" => "Visible size of the field in characters",
// "Text to prepend when displaying the value" => "Text to prepend when displaying the value",
// "Maximum Length" => "Maximum Length",
// "Maximum amount of characters to store" => "Maximum amount of characters to store",
// "Autocomplete" => "Autocomplete",
// "Enable autocompletion while typing in the field" => "Enable autocompletion while typing in the field",
// "Index exact value" => "Index exact value",
// "In addition to indexing the content of the field, also index it as an identifier in tracker_field_{perm name}_exact. This option is not available for multilingual fields. Mostly for identifiers like product codes or ISBN numbers" => "In addition to indexing the content of the field, also index it as an identifier in tracker_field_{perm name}_exact. This option is not available for multilingual fields. Mostly for identifiers like product codes or ISBN numbers",
"Text Area" => "Szöveges terület",
// "Multi-line text input" => "Multi-line text input",
"Toolbars" => "Quicktag-ek",
// "Enable the toolbars as syntax helpers" => "Enable the toolbars as syntax helpers",
"Disable" => "Kikapcsolás",
"Enable" => "Bekapcsolás",
"Width" => "Szélesség",
// "Size of the text area in characters" => "Size of the text area in characters",
"Height" => "Magasság",
// "Size of the text area in lines" => "Size of the text area in lines",
// "Character Limit" => "Character Limit",
// "Maximum amount of characters to be stored" => "Maximum amount of characters to be stored",
// "Display Limit (List)" => "Display Limit (List)",
// "Maximum amount of characters to be displayed in list mode before the value gets truncated" => "Maximum amount of characters to be displayed in list mode before the value gets truncated",
// "Word Count" => "Word Count",
// "Limit the length of the text in words" => "Limit the length of the text in words",
// "Distinct Values" => "Distinct Values",
// "All values in the field must be different" => "All values in the field must be different",
// "Use WYSIWYG" => "Use WYSIWYG",
// "Use a rich text editor instead of a plain text box" => "Use a rich text editor instead of a plain text box",
// "Word Limit Exceeded" => "Word Limit Exceeded",
// "Character Limit Exceeded" => "Character Limit Exceeded",
"URL" => "URL",
// "Creates a link to a specified URL" => "Creates a link to a specified URL",
// "How the URL should be rendered" => "How the URL should be rendered",
// "URL as link" => "URL as link",
// "Site title as link" => "Site title as link",
// "URL as link plus site title" => "URL as link plus site title",
// "User Groups" => "User Groups",
// "Displays the list of groups for the user associated with the tracker items" => "Displays the list of groups for the user associated with the tracker items",
// "User Preference" => "User Preference",
// "Allows user preference changes from a tracker" => "Allows user preference changes from a tracker",
// "Preference Name" => "Preference Name",
// "Name of the preference to manipulate. password and email are not preferences, but are also valid values that will modify the user's profile" => "Name of the preference to manipulate. password and email are not preferences, but are also valid values that will modify the user's profile",
// "User Selector" => "User Selector",
// "Allows the selection of a user from a list" => "Allows the selection of a user from a list",
// "Assign the value based on the creator or modifier" => "Assign the value based on the creator or modifier",
// "Email Notification" => "Email Notification",
// "Send an email notification to the user every time the item is modified" => "Send an email notification to the user every time the item is modified",
// "Only when other users modify the item" => "Only when other users modify the item",
// "Group IDs" => "Group IDs",
// "Limit the list of users to members of specific groups" => "Limit the list of users to members of specific groups",
// "User Subscription" => "User Subscription",
// "Allows registered users to subscribe themselves to a tracker item. The item should ideally only be editable by the creator or administrators. Prepend the maximum amount of subscribers to the field value foloowed by # if such a limit is desired. E.g. 50# means that 50 subscriptions will be allowed for this item" => "Allows registered users to subscribe themselves to a tracker item. The item should ideally only be editable by the creator or administrators. Prepend the maximum amount of subscribers to the field value foloowed by # if such a limit is desired. E.g. 50# means that 50 subscriptions will be allowed for this item",
// "Webservice" => "Webservice",
// "Displays the result of a registered webservice call" => "Displays the result of a registered webservice call",
"Service Name" => "Szolgáltatás neve",
// "Webservice name as registered in Tiki" => "Webservice name as registered in Tiki",
"Template Name" => "Sablon neve",
// "Template name to use for rendering as registered with the webservice" => "Template name to use for rendering as registered with the webservice",
// "URL-encoded list of parameters to send to the webservice. %field_name% can be used in the string to be replaced with the values in the tracker item" => "URL-encoded list of parameters to send to the webservice. %field_name% can be used in the string to be replaced with the values in the tracker item",
"Create page:" => "Oldal létrehozása:",
// "Internal error" => "Internal error",
// "User error" => "User error",
// "Plugin argument(s) missing" => "Plugin argument(s) missing",
// "Plugin <strong>%0</strong> cannot be executed" => "Plugin <strong>%0</strong> cannot be executed",
"Set" => "Beállítás",
"Plugin disabled" => "Plugin kikapcsolva",
// "Line" => "Line",
// "Lines" => "Lines",
// "WikiDiff::apply: line count mismatch: %s != %s" => "WikiDiff::apply: line count mismatch: %s != %s",
// "WikiDiff::_check: failed" => "WikiDiff::_check: failed",
// "WikiDiff::_check: edit sequence is non-optimal" => "WikiDiff::_check: edit sequence is non-optimal",
// "WikiDiff Okay: LCS = %s" => "WikiDiff Okay: LCS = %s",
// "`%0` does not match acceptable naming patterns" => "`%0` does not match acceptable naming patterns",
// "Cannot open this file" => "Cannot open this file",
// "User File Galleries" => "User File Galleries",
// "Wiki Attachment File Galleries" => "Wiki Attachment File Galleries",
"File Galleries" => "Fájlgalériák",
"My Files" => "Fájljaim",
// "Files of " => "Files of ",
// "The upload has not been done" => "The upload has not been done",
// "Reason: The global quota has been reached" => "Reason: The global quota has been reached",
// "Reason: The quota has been reached in \"%s\"" => "Reason: The quota has been reached in \"%s\"",
"File gallery quota exceeded" => "Fájlgaléria kvóta túllépése",
// "Number of files transferred to the database" => "Number of files transferred to the database",
// "Number of files transferred to the file system" => "Number of files transferred to the file system",
// "Old File deleted" => "Old File deleted",
"Incorrect param" => "Hibás paraméter",
// "You do not have permission to remove files from this gallery" => "You do not have permission to remove files from this gallery",
// "WARNING: The file is used in" => "WARNING: The file is used in",
// "Remove file draft: " => "Remove file draft: ",
"Remove file: " => "Fájl eltávolítása: ",
// "You are trying to edit multiple files in different galleries, which is not supported yet" => "You are trying to edit multiple files in different galleries, which is not supported yet",
// "The specified file does not exist" => "The specified file does not exist",
// "Upload was not successful" => "Upload was not successful",
// "An exception occurred" => "An exception occurred",
// "Batch file processed" => "Batch file processed",
// "No permission to upload zipped file packages" => "No permission to upload zipped file packages",
"Errors detected" => "Hiba lépett fel",
// "Check that these paths exist and are writable by the web server" => "Check that these paths exist and are writable by the web server",
// "File added: " => "File added: ",
// "Cannot read the file" => "Cannot read the file",
// "Incorrect file extension" => "Incorrect file extension",
// "Warning: Empty file" => "Warning: Empty file",
// "Please re-upload your file" => "Please re-upload your file",
// "Upload was not successful. Duplicate file content" => "Upload was not successful. Duplicate file content",
// "File update was successful" => "File update was successful",
// "Cannot resize the file" => "Cannot resize the file",
// "Cannot write the file" => "Cannot write the file",
// "Image was reduced: %s x %s -> %s x %s" => "Image was reduced: %s x %s -> %s x %s",
// "Could not upload the file" => "Could not upload the file",
// "Could not find the file requested" => "Could not find the file requested",
// "The file is locked by %s" => "The file is locked by %s",
// "You do not have permission to edit this file" => "You do not have permission to edit this file",
// "Cannot read uploaded file" => "Cannot read uploaded file",
// "Cannot read file on disk" => "Cannot read file on disk",
"unknown" => "ismeretlen",
// "Automatic revision from source" => "Automatic revision from source",
"Page:" => "Oldal:",
// "Cannot upload this file" => "Cannot upload this file",
// "This is an approximation based on your server memory limit" => "This is an approximation based on your server memory limit",
// "This is the value of your server's PHP '%s' setting" => "This is the value of your server's PHP '%s' setting",
// "You are alerted by the server " => "You are alerted by the server ",
// "You can check the modifications at : " => "You can check the modifications at : ",
// "You are alerted of a change on " => "You are alerted of a change on ",
"No image yet, sorry." => "Még nincs kép",
// "unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>" => "unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>",
// "unlink failed" => "unlink failed",
// "The uploaded file exceeds the upload_max_filesize directive in php.ini" => "The uploaded file exceeds the upload_max_filesize directive in php.ini",
// "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form" => "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form",
// "The uploaded file was only partially uploaded. Please try again" => "The uploaded file was only partially uploaded. Please try again",
// "No file was uploaded" => "No file was uploaded",
// "Missing a temporary folder" => "Missing a temporary folder",
// "Failed to write file to disk" => "Failed to write file to disk",
// "File upload stopped by extension" => "File upload stopped by extension",
// "Set new blog as Tiki homepage" => "Set new blog as Tiki homepage",
// "Importation completed" => "Importation completed",
// "<a href=\"tiki-importer.php\">Click here</a> to finish the import process" => "<a href=\"tiki-importer.php\">Click here</a> to finish the import process",
// "Found %0 posts, %1 pages, %2 tags and %3 categories. Inserting them into Tiki" => "Found %0 posts, %1 pages, %2 tags and %3 categories. Inserting them into Tiki",
// "Item \"%0\" NOT imported (there was already a item with the same name)" => "Item \"%0\" NOT imported (there was already a item with the same name)",
// "Page \"%0\" sucessfully imported" => "Page \"%0\" sucessfully imported",
// "Post \"%0\" sucessfully imported" => "Post \"%0\" sucessfully imported",
// "Import images and other attachments" => "Import images and other attachments",
// "Update internal links (experimental)" => "Update internal links (experimental)",
// "Suggest .htaccess rules to redirect from old WP URLs to new Tiki URLs (experimental)" => "Suggest .htaccess rules to redirect from old WP URLs to new Tiki URLs (experimental)",
// "Class DOMDocument not available, check your PHP installation. For more information see http://php.net/manual/en/book.dom.php" => "Class DOMDocument not available, check your PHP installation. For more information see http://php.net/manual/en/book.dom.php",
// "Invalid file mime type" => "Invalid file mime type",
// "Error while loading XML file. Probably your XML file is malformed. Some versions of Wordpress generate a malformed XML file. See the Tiki Importer documentation for more information" => "Error while loading XML file. Probably your XML file is malformed. Some versions of Wordpress generate a malformed XML file. See the Tiki Importer documentation for more information",
// "Invalid Wordpress XML file" => "Invalid Wordpress XML file",
// "No attachments found to import" => "No attachments found to import",
// "Importing attachments" => "Importing attachments",
// "Attachment %0 successfully imported" => "Attachment %0 successfully imported",
// "Unable to download attachment %0. Error message was: %1 %2" => "Unable to download attachment %0. Error message was: %1 %2",
// "%0 attachments imported and %1 errors" => "%0 attachments imported and %1 errors",
// "Page \"%0\" successfully extracted" => "Page \"%0\" successfully extracted",
// "Post \"%0\" successfully extracted" => "Post \"%0\" successfully extracted",
// "Extracting data from XML file" => "Extracting data from XML file",
// "Number of page revisions to import (0 for all revisions)" => "Number of page revisions to import (0 for all revisions)",
// "What to do with page names that already exists in Tiki" => "What to do with page names that already exists in Tiki",
// "Do not import" => "Do not import",
// "Override" => "Override",
// "Append software name as prefix to the page name" => "Append software name as prefix to the page name",
// "Page %0 sucessfully imported" => "Page %0 sucessfully imported",
// "Page %0 NOT imported (there was already a page with the same name)" => "Page %0 NOT imported (there was already a page with the same name)",
// "%0 pages parsed. Starting to insert those pages into Tiki" => "%0 pages parsed. Starting to insert those pages into Tiki",
// "Import images and attachments (see documentation for more information)" => "Import images and attachments (see documentation for more information)",
// "Add a maketoc at the top of each page" => "Add a maketoc at the top of each page",
// "XML file does not validate against the Mediawiki XML schema" => "XML file does not validate against the Mediawiki XML schema",
// "ABORTING: destination directory for attachments (%0) does no exist. Fix the problem or try to import without the attachments" => "ABORTING: destination directory for attachments (%0) does no exist. Fix the problem or try to import without the attachments",
// "ABORTING: destination directory for attachments (%0) is not writable. Fix the problem or try to import without attachments" => "ABORTING: destination directory for attachments (%0) is not writable. Fix the problem or try to import without attachments",
// "NOT importing file %0 as there is already a file with the same name in the destination directory (%1)" => "NOT importing file %0 as there is already a file with the same name in the destination directory (%1)",
// "File %0 successfully imported" => "File %0 successfully imported",
// "Unable to download file %0. File not found" => "Unable to download file %0. File not found",
// "Error while parsing revision %0 of the page \"%1\". Or there is a problem on the page syntax or on the Text_Wiki parser (the parser used by the importer)" => "Error while parsing revision %0 of the page \"%1\". Or there is a problem on the page syntax or on the Text_Wiki parser (the parser used by the importer)",
// "Page \"%0\" successfully parsed with %1 revisions (from a total of %2 revisions)" => "Page \"%0\" successfully parsed with %1 revisions (from a total of %2 revisions)",
// "Page \"%0\" is NOT going to be imported. It was not possible to parse any of the page revisions" => "Page \"%0\" is NOT going to be imported. It was not possible to parse any of the page revisions",
// "Mediawiki XML file version %0 is not supported" => "Mediawiki XML file version %0 is not supported",
// "ABORTING: you need to enable the PHP setting 'allow_url_fopen' to be able to import attachments. Fix the problem or try to import without the attachments" => "ABORTING: you need to enable the PHP setting 'allow_url_fopen' to be able to import attachments. Fix the problem or try to import without the attachments",
// "Parsing pages" => "Parsing pages",
// "No attachments found to import! Make sure you have created your XML file with the dumpDump.php script and with the option --uploads. This is the only way to import attachment" => "No attachments found to import! Make sure you have created your XML file with the dumpDump.php script and with the option --uploads. This is the only way to import attachment",
"string" => "sztring",
// "ERROR: unable to write to lang/%s/language.php" => "ERROR: unable to write to lang/%s/language.php",
// "The file lang/%0/language.php is not well formated. Run get_strings.php?lang=%0 and then try to export the translations again" => "The file lang/%0/language.php is not well formated. Run get_strings.php?lang=%0 and then try to export the translations again",
"Contributions" => "Hozzájárulások",
// "Query point" => "Query point",
// "layer" => "layer",
// "Record" => "Record",
"This feature is disabled" => "Ez a funkció most nincs bekapcsolva",
// "Could not create \$tdo.mif in data directory" => "Could not create \$tdo.mif in data directory",
// "Could not create \$tdo.mid in data directory" => "Could not create \$tdo.mid in data directory",
// "User Map Generated in" => "User Map Generated in",
// "Image Map Generated in" => "Image Map Generated in",
// "(copy)" => "(copy)",
// "You can only use optionId = 0 to create a new option or optionId equal an id that already belongs to the menu to update it" => "You can only use optionId = 0 to create a new option or optionId equal an id that already belongs to the menu to update it",
// "menu" => "menu",
// "NONE" => "NONE",
// "Stored IPTC Digest" => "Stored IPTC Digest",
// "Calculated IPTC Digest" => "Calculated IPTC Digest",
// "The file is empty" => "The file is empty",
// "The file is not readable" => "The file is not readable",
// "File type not handled by Tiki - only basic metadata available" => "File type not handled by Tiki - only basic metadata available",
// "Photographer Data (IPTC)" => "Photographer Data (IPTC)",
// "No IPTC data" => "No IPTC data",
// "File Data (EXIF)" => "File Data (EXIF)",
// "No EXIF data" => "No EXIF data",
// "Not processed" => "Not processed",
// "Unixtime" => "Unixtime",
// "XMP Data" => "XMP Data",
// "No XMP data" => "No XMP data",
// "File type not handled by Tiki" => "File type not handled by Tiki",
// "Invalid \"from\" date received" => "Invalid \"from\" date received",
// "Invalid \"to\" date received" => "Invalid \"to\" date received",
// "Sorry, \"from\" date must precede \"to\" date" => "Sorry, \"from\" date must precede \"to\" date",
// "Sorry, no data available for the future" => "Sorry, no data available for the future",
// "for month of" => "for month of",
"for" => "",
// "for week of" => "for week of",
// "Integer (i)" => "Integer (i)",
// "Percentage (%)" => "Percentage (%)",
// "Float (f)" => "Float (f)",
// "List (L)" => "List (L)",
// "Daily (+)" => "Daily (+)",
// "Monthly and weekly (@)" => "Monthly and weekly (@)",
// "Weekly (-)" => "Weekly (-)",
// "File %s not found" => "File %s not found",
// "File %s is not a valid archive" => "File %s is not a valid archive",
// "Impossible to open %s : %s" => "Impossible to open %s : %s",
// "The content retrieved at %s is not a list of mods" => "The content retrieved at %s is not a list of mods",
// "Can't chdir to '%s'" => "Can't chdir to '%s'",
// "%s impossible to remove" => "%s impossible to remove",
// "Description not available" => "Description not available",
// "Module Title" => "Module Title",
// "Title to display at the top of the box" => "Title to display at the top of the box",
// "No Box" => "No Box",
// "Show only the content" => "Show only the content",
// "Decorations" => "Decorations",
// "Show module decorations" => "Show module decorations",
// "No Title" => "No Title",
// "Show module title" => "Show module title",
// "Module displayed depending on category. Multiple category ids or names can be separated by semi-colons" => "Module displayed depending on category. Multiple category ids or names can be separated by semi-colons",
// "No Category" => "No Category",
// "Module hidden depending on category. Multiple category ids or names can be separated by semi-colons. This takes precedence over the category parameter above" => "Module hidden depending on category. Multiple category ids or names can be separated by semi-colons. This takes precedence over the category parameter above",
"Perspective" => "Perspektíva",
// "Only display the module if in one of the listed perspective IDs. Semi-colon separated" => "Only display the module if in one of the listed perspective IDs. Semi-colon separated",
// "Module only applicable for the specified languages. Languages are defined as two character language codes. Multiple values can be separated by semi-colons" => "Module only applicable for the specified languages. Languages are defined as two character language codes. Multiple values can be separated by semi-colons",
"Section" => "Szekció",
// "Module only applicable for the specified sections. Multiple values can be separated by semi-colons" => "Module only applicable for the specified sections. Multiple values can be separated by semi-colons",
// "Page Filter" => "Page Filter",
// "Module only applicable on the specified page names. Multiple values can be separated by semi-colons" => "Module only applicable on the specified page names. Multiple values can be separated by semi-colons",
// "No Page" => "No Page",
// "Module not applicable on the specified page names. Multiple values can be separated by semi-colons" => "Module not applicable on the specified page names. Multiple values can be separated by semi-colons",
"Theme" => "Stílus",
// "Module enabled or disabled depending on the theme file name (e.g. \"thenews.css\"). Specified themes can be either included or excluded. Theme names prefixed by \"!\" are in the exclusion list. Multiple values can be separated by semi-colons" => "Module enabled or disabled depending on the theme file name (e.g. \"thenews.css\"). Specified themes can be either included or excluded. Theme names prefixed by \"!\" are in the exclusion list. Multiple values can be separated by semi-colons",
// "Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module" => "Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module",
// "Contributor" => "Contributor",
// "Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module" => "Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module",
"Flip" => "Flip",
// "Users can shade module" => "Users can shade module",
"Style" => "Stílus",
// "CSS styling for positioning the module" => "CSS styling for positioning the module",
"Class" => "Osztály",
// "Custom CSS class" => "Custom CSS class",
// "Containing Class" => "Containing Class",
// "Custom CSS class around" => "Custom CSS class around",
// "No Numbers" => "No Numbers",
// "If set to \"y\", the module will not number list items" => "If set to \"y\", the module will not number list items",
"Rows" => "Sor",
// "Number of rows, or items, to display" => "Number of rows, or items, to display",
// "Default: 10" => "Default: 10",
// "Failed to execute \"%0\" module" => "Failed to execute \"%0\" module",
// "Missing dependencies" => "Missing dependencies",
// "Contact the system administrator" => "Contact the system administrator",
// "Newsletter subscription information at" => "Newsletter subscription information at",
"Error" => "Hiba",
// "Limiting the email send rate. Resuming in %0 seconds" => "Limiting the email send rate. Resuming in %0 seconds",
// "invalid email" => "invalid email",
// "Sending to" => "Sending to",
"A user registers" => "Egy felhasználó regisztrál",
"A user submits an article" => "Felhasználó cikket küld",
"A user edits an article" => "Egy felhasználó cikket szerkeszt",
"A user deletes an article" => "Egy felhasználó cikket töröl",
// "An article is submitted, edited, deleted or commented on" => "An article is submitted, edited, deleted or commented on",
// "A new blog post is published" => "A new blog post is published",
// "A wiki page is created, deleted or edited, except for minor changes" => "A wiki page is created, deleted or edited, except for minor changes",
// "A wiki page is created, deleted or edited, even for minor changes" => "A wiki page is created, deleted or edited, even for minor changes",
"A comment in a wiki page is posted or edited" => "Wiki oldal komment létrehozásakor vagy szerkesztésekor",
// "A comment in an article is posted or edited" => "A comment in an article is posted or edited",
// "Token is called" => "Token is called",
// "User joins a group" => "User joins a group",
// "section edit" => "section edit",
"Edit Section" => "Szekció szerkesztése",
"index" => "index",
"Table of contents" => "Tartalomjegyzék",
"Show/Hide" => "Megjelenítés/Elrejtés",
// "smiling" => "smiling",
"sad" => "szomorú",
// "grinning" => "grinning",
// "confused" => "confused",
"cool" => "király",
// "crying" => "crying",
// "frightened" => "frightened",
// "evil stuff" => "evil stuff",
// "exclamation mark " => "exclamation mark ",
// "frowning" => "frowning",
// "light bulb" => "light bulb",
// "idea " => "idea ",
// "LOL" => "LOL",
// "laughing out loud " => "laughing out loud ",
"mad" => "mérges",
// "Mr. Green laughing" => "Mr. Green laughing",
// "Payment sent but verification not currently available. (Work in progress)" => "Payment sent but verification not currently available. (Work in progress)",
// "Gift card is not valid for products in cart" => "Gift card is not valid for products in cart",
// "Bundled Product" => "Bundled Product",
// "Product" => "Product",
// "Quantity" => "Quantity",
// "Unit Price" => "Unit Price",
// "There is not enough inventory left for your request" => "There is not enough inventory left for your request",
// "Registration Check-Out" => "Registration Check-Out",
// "Gift Certificate: " => "Gift Certificate: ",
// "Gift Certificate Amount Used: " => "Gift Certificate Amount Used: ",
// "No registries specified in admin/payment/cclite" => "No registries specified in admin/payment/cclite",
// "Cclite payment initiated on %0" => "Cclite payment initiated on %0",
// "Connection to cclite server %0 failed for %1<br />\"%2\"" => "Connection to cclite server %0 failed for %1<br />\"%2\"",
// "Tiki credits payment done on %0 for %1 (using %2)" => "Tiki credits payment done on %0 for %1 (using %2)",
// "No category jail set in any perspective" => "No category jail set in any perspective",
// "Areas root category id" => "Areas root category id",
// "is invalid" => "is invalid",
"Ajax auto-save" => "Ajax automatikus mentés",
// "Saves your edits as you go along enabling you to recover your work after an \"interruption\". Also enables \"Live\" preview and is required for wysiwyg plugin processing" => "Saves your edits as you go along enabling you to recover your work after an \"interruption\". Also enables \"Live\" preview and is required for wysiwyg plugin processing",
"Users accept internal messages by default" => "Alapértelmezés szerint a felhasználók fogadhatnak üzeneteket",
// "Users can opt-out of internal messages" => "Users can opt-out of internal messages",
// "Id of category whose children are bound to a perspective by areas" => "Id of category whose children are bound to a perspective by areas",
"Newest first" => "Időben csökkenő",
"ascending" => "növekvő",
"descending" => "csökkenő",
// "Article ordering" => "Article ordering",
// "Default sort mode for the articles on the article listing" => "Default sort mode for the articles on the article listing",
"Title of articles home page" => "Cikkek kezdőlapja",
"Topic" => "Téma",
"Title" => "Cím",
"Title length" => "Cím hossza",
"Publication date" => "Publikálás dátuma",
"Expiration date" => "Lejárat dátuma",
"Visible" => "Látható",
"Author" => "Szerző",
"Author Rating" => "Szerző értékelése",
"Reads" => "Olvasás",
"Id" => "ID",
// "Trailer position" => "Trailer position",
"Top" => "Legfelső szint",
// "Between heading and body" => "Between heading and body",
// "Header text position" => "Header text position",
// "Requires a smaller image for list view" => "Requires a smaller image for list view",
// "Next image" => "Next image",
// "Below image" => "Below image",
"Oldest first" => "Időben növekvő",
"Points" => "Pontok",
"Default number per page" => "Alapértelmezett szám oldalanként",
"Default Ordering" => "Alapértelmezett rendezés",
// "Paginate articles" => "Paginate articles",
// "Divide articles into multiple pages with pagebreak markers" => "Divide articles into multiple pages with pagebreak markers",
// "User ratings on articles" => "User ratings on articles",
// "Allows users to rate the articles" => "Allows users to rate the articles",
// "Article rating options" => "Article rating options",
// "List of options available for the rating of articles" => "List of options available for the rating of articles",
// "Default maximum width for custom article images" => "Default maximum width for custom article images",
// "Number of pixels, 0 for no maximum" => "Number of pixels, 0 for no maximum",
// "Default maximum height for custom article images" => "Default maximum height for custom article images",
// "Default maximum width for custom article images in list mode (on View Articles)" => "Default maximum width for custom article images in list mode (on View Articles)",
// "Number of pixels, 0 to fallback to the view mode maximum" => "Number of pixels, 0 to fallback to the view mode maximum",
// "Default maximum height for custom article images in list mode (on View Articles)" => "Default maximum height for custom article images in list mode (on View Articles)",
// "Custom attributes for article types" => "Custom attributes for article types",
// "Allow additional custom fields for article types" => "Allow additional custom fields for article types",
// "Your ShareThis publisher identifier (optional)" => "Your ShareThis publisher identifier (optional)",
// "Related articles" => "Related articles",
// "Display a list of related articles at the bottom of the article page" => "Display a list of related articles at the bottom of the article page",
"Authentication method" => "Azonosítási módszer",
// "Tiki supports several authentication methods. The default value is to use the internal user database" => "Tiki supports several authentication methods. The default value is to use the internal user database",
// "Tiki" => "Tiki",
// "Tiki and OpenID" => "Tiki and OpenID",
"Tiki and PAM" => "Tiki és PAM",
// "Tiki and LDAP" => "Tiki and LDAP",
"CAS (Central Authentication Service)" => "CAS (Central Authentication Service)",
"Shibboleth" => "Shibboleth",
"Web Server" => "Webszerver",
// "phpBB" => "phpBB",
// "Token Access" => "Token Access",
// "Allow to access the content with superior rights with the presentation of a token. The primary use of this authentication method is to grant temporary access to content to an external service" => "Allow to access the content with superior rights with the presentation of a token. The primary use of this authentication method is to grant temporary access to content to an external service",
// "Token Access Max Timeout" => "Token Access Max Timeout",
// "The maximum duration for which the generated tokens will be valid" => "The maximum duration for which the generated tokens will be valid",
// "(seconds)" => "(seconds)",
// "Token Access Max Hits" => "Token Access Max Hits",
// "The maximum amount of times a token can be used before it expires" => "The maximum amount of times a token can be used before it expires",
// "Share access rights with friends when using Tell a friend" => "Share access rights with friends when using Tell a friend",
// "Allow users to share their access rights on the current page with a friend when sending the link by email. Lifespan of the links is defined by the site" => "Allow users to share their access rights on the current page with a friend when sending the link by email. Lifespan of the links is defined by the site",
// "Share access rights with friends when using Share" => "Share access rights with friends when using Share",
// "Allow users to share their access rights on the current page with a friend when sending the link by email/Twitter/Facebook. Lifespan of the links is defined by the site" => "Allow users to share their access rights on the current page with a friend when sending the link by email/Twitter/Facebook. Lifespan of the links is defined by the site",
// "Create user if not in Tiki" => "Create user if not in Tiki",
// "Use Tiki authentication for Admin login" => "Use Tiki authentication for Admin login",
"phpBB Version" => "phpBB verzió",
"3" => "3",
// "phpBB Database Hostname" => "phpBB Database Hostname",
// "phpBB Database Username" => "phpBB Database Username",
// "phpBB Database Password" => "phpBB Database Password",
// "phpBB Database Name" => "phpBB Database Name",
// "phpBB Table Prefix" => "phpBB Table Prefix",
// "Use Tiki authentication for users created in Tiki" => "Use Tiki authentication for users created in Tiki",
"Host" => "Hoszt",
"Port" => "Port",
// "Write LDAP debug Information in Tiki Logs" => "Write LDAP debug Information in Tiki Logs",
// "Use SSL (ldaps)" => "Use SSL (ldaps)",
"Use TLS" => "TLS használata",
// "LDAP Bind Type" => "LDAP Bind Type",
// "Default: Anonymous Bind" => "Default: Anonymous Bind",
// "Full: userattr=username,UserDN,BaseDN" => "Full: userattr=username,UserDN,BaseDN",
// "OpenLDAP: cn=username,BaseDN" => "OpenLDAP: cn=username,BaseDN",
// "Active Directory (username@domain)" => "Active Directory (username@domain)",
// "Plain Username" => "Plain Username",
"Search scope" => "Keresési kör",
"Subtree" => "Alárendelt fa",
"One level" => "Egy szint",
"Base object" => "Alap objektum",
"LDAP version" => "LDAP verzió",
// "Base DN" => "Base DN",
// "User DN" => "User DN",
"User attribute" => "Felhasználói atrribútum",
// "User OC" => "User OC",
// "Realname attribute" => "Realname attribute",
// "Country attribute" => "Country attribute",
// "E-mail attribute" => "E-mail attribute",
// "Group DN" => "Group DN",
// "Group name attribute" => "Group name attribute",
// "Group description attribute" => "Group description attribute",
// "Group OC" => "Group OC",
// "Member attribute" => "Member attribute",
// "Member is DN" => "Member is DN",
// "Group attribute" => "Group attribute",
// "Group attribute in group entry" => "Group attribute in group entry",
// "(Leave this empty if the group name is already given in the user attribute)" => "(Leave this empty if the group name is already given in the user attribute)",
"Admin user" => "Adminisztrátor felhasználó",
"Admin password" => "Adminisztrátori jelszó",
// "Use an external LDAP server for groups" => "Use an external LDAP server for groups",
// "Corresponding user attribute in 1st directory" => "Corresponding user attribute in 1st directory",
// "Disable Tiki users who don't have a phpBB login. (They could have been deleted)" => "Disable Tiki users who don't have a phpBB login. (They could have been deleted)",
"Available languages" => "Rendelkezésre álló nyelvek",
// "By default, all languages supported by tikiwiki are available on multilingual sites. This option allows to limit the languages to a subset" => "By default, all languages supported by tikiwiki are available on multilingual sites. This option allows to limit the languages to a subset",
// "Available styles" => "Available styles",
// "BigBlueButton Web Conferencing" => "BigBlueButton Web Conferencing",
// "Integration with the BigBlueButton collaboration server for web conference and screen sharing" => "Integration with the BigBlueButton collaboration server for web conference and screen sharing",
// "BigBlueButton server location" => "BigBlueButton server location",
// "Full URL to the BigBlueButton installation" => "Full URL to the BigBlueButton installation",
// "http://host.example.com/" => "http://host.example.com/",
// "BigBlueButton server salt" => "BigBlueButton server salt",
// "A salt key used to generate checksums for the BigBlueButton server to know the requests are authentic" => "A salt key used to generate checksums for the BigBlueButton server to know the requests are authentic",
// "BigBlueButton recording maximum duration" => "BigBlueButton recording maximum duration",
// "A maximum duration for the meetings must be provided to BigBlueButton to prevent the recordings to be excessively long if a user leaves the window open too long" => "A maximum duration for the meetings must be provided to BigBlueButton to prevent the recordings to be excessively long if a user leaves the window open too long",
"minutes" => "perc",
"Default ordering" => "Alapértelmezett rendezés",
"Creation Date (desc)" => "Keletkezés dátuma (csökk)",
"Last modification date (desc)" => "Utolsó módositás dátuma (csökk)",
"Blog title (asc)" => "Blog címe (növ)",
"Number of posts (desc)" => "Posztok száma (csökk)",
"Visits (desc)" => "Látogatottság (csökk)",
"Activity (desc)" => "Aktivitás (csökk)",
"Last modified" => "Utolsó módositás",
"Disabled" => "Letiltva",
"Link to user information" => "Link a felhasználói információkhoz",
"User avatar" => "Felhasználói avatár",
"Posts" => "Hozzászólások",
"Visits" => "Látogatások",
"Activity" => "Aktivitás",
"Module (box) shadow start" => "Modul (doboz) árnyék kezdete",
// "Module (box) shadow end" => "Module (box) shadow end",
// "Days to display in the Calendar" => "Days to display in the Calendar",
"Default view mode" => "Alapértelmezett megjelenítési mód",
"Day" => "Nap",
"Week" => "Hét",
"Month" => "Hónap",
"Quarter" => "Negyedév",
"Semester" => "Félév",
"Year" => "Év",
// "View list begins" => "View list begins",
// "Focus Date" => "Focus Date",
// "Period beginning" => "Period beginning",
"First day of the week" => "Hét első napja",
"Depends user language" => "Felhasználó nyelvétől függ",
"Split hours in periods of" => "Óra felosztása a következő periódusokra",
"1 minute" => "1 perc",
"5 minutes" => "5 perc",
"10 minutes" => "10 perc",
"15 minutes" => "15 perc",
"30 minutes" => "30 perc",
"First year in the dropdown" => "Első év a legördülő menüben",
// "Enter a year or use +/- N to specify a year relative to the current year" => "Enter a year or use +/- N to specify a year relative to the current year",
"Last year in the dropdown" => "Utolsó év a legördülő menüben",
"Sticky popup" => "'Ragadós' felugró ablak",
"Item view tab" => "Tétel nézet fül",
// "Show Add to Google Calendar icon" => "Show Add to Google Calendar icon",
// "Show Export Calendars button" => "Show Export Calendars button",
// "Use FullCalendar to display Calendars" => "Use FullCalendar to display Calendars",
// "Treat calendar item descriptions as HTML" => "Treat calendar item descriptions as HTML",
// "Use this if you use the WYSIWYG editor for calendars. This is to handle legacy data from Tiki pre 7.0" => "Use this if you use the WYSIWYG editor for calendars. This is to handle legacy data from Tiki pre 7.0",
// "Word length of the captcha image" => "Word length of the captcha image",
"Default:" => "Alapértelmezett:",
// "Width of the captcha image in pixels" => "Width of the captcha image in pixels",
// "Level of noise of the captcha image" => "Level of noise of the captcha image",
// "Choose a smaller number for less noise and easier reading" => "Choose a smaller number for less noise and easier reading",
// "Try automatically to connect SSO" => "Try automatically to connect SSO",
// "Force CAS log-out when the user logs out from Tiki" => "Force CAS log-out when the user logs out from Tiki",
// "Show Alternate Login Method in Header" => "Show Alternate Login Method in Header",
"CAS server version" => "CAS szerver verzió",
"none" => "nincs",
"Version 1.0" => "Verzió 1.0",
"Version 2.0" => "Verzió 2.0",
"Hostname" => "Hoszt neve",
// "Hostname of the CAS server" => "Hostname of the CAS server",
// "Port of the CAS server" => "Port of the CAS server",
// "Path for the CAS server" => "Path for the CAS server",
// "CAS Extra Parameter" => "CAS Extra Parameter",
// "Extra Parameter to pass to the CAS Server" => "Extra Parameter to pass to the CAS Server",
// "CAS Authentication Verification Timeout" => "CAS Authentication Verification Timeout",
// "Verify authentication with the CAS server every N seconds. Null value means never reverify" => "Verify authentication with the CAS server every N seconds. Null value means never reverify",
"Never" => "Soha",
// "2 minutes" => "2 minutes",
// "1 hour" => "1 hour",
"Categories used in templates (TPL)" => "Sablonokban (TPL) használt kategóriák",
// "Permits to show alternate content depending on category of current object" => "Permits to show alternate content depending on category of current object",
// "Category Jail" => "Category Jail",
// "Limits the visibility of objects to those in these category IDs. Used mainly for creating workspaces from perspectives" => "Limits the visibility of objects to those in these category IDs. Used mainly for creating workspaces from perspectives",
// "Category Defaults" => "Category Defaults",
// "Force certain categories to be present. If none of the categories in a given set are provided, assign a category by default" => "Force certain categories to be present. If none of the categories in a given set are provided, assign a category by default",
// "Use *7 to specify all the categories in the subtree of 7 + category 7" => "Use *7 to specify all the categories in the subtree of 7 + category 7",
// "Can do only this for objectname matching the regex (Example: /^RND_/ = name beginning by RND_)(Optional)" => "Can do only this for objectname matching the regex (Example: /^RND_/ = name beginning by RND_)(Optional)",
// "Can do for wiki only (optional)" => "Can do for wiki only (optional)",
// "Rename will only reassign the categories for wiki pages" => "Rename will only reassign the categories for wiki pages",
// "One per line. ex:1,4,6,*7/4:/^RND_/:wiki page" => "One per line. ex:1,4,6,*7/4:/^RND_/:wiki page",
"Synchronize multilingual categories" => "Többnyelvű kategóriák szinkronizálása",
// "Make sure that the categories on the translations are synchronized when modified on any version" => "Make sure that the categories on the translations are synchronized when modified on any version",
"Only those specified" => "Csak a kiválasztottak",
"All but those specified" => "Minden a kiválasztottakon kívűl",
"Synchronized categories" => "Szinkronizált kategóriák",
// "List of categories affected by the multilingual synchronization. Depending on the parent feature, this list will be used as a white list (only categories allows) or as a black list (all except thoses specified)" => "List of categories affected by the multilingual synchronization. Depending on the parent feature, this list will be used as a white list (only categories allows) or as a black list (all except thoses specified)",
// "Sort categories by legacy ASCII sequence" => "Sort categories by legacy ASCII sequence",
// "If turned on, will sort categories taking into account all characters as upper case, in ASCII sequence, will only consider limited set of accented characters. Might be needed to be able to override the normal sort by prepending punctuation characters to category names, such as \"-\" to sort at the beginning and \"[\" to sort at the end" => "If turned on, will sort categories taking into account all characters as upper case, in ASCII sequence, will only consider limited set of accented characters. Might be needed to be able to override the normal sort by prepending punctuation characters to category names, such as \"-\" to sort at the beginning and \"[\" to sort at the end",
// "Automatically geocode items when categorized in" => "Automatically geocode items when categorized in",
// "Automatically geocode items based on category name when categorized in the sub-categories of this category ID" => "Automatically geocode items based on category name when categorized in the sub-categories of this category ID",
// "Replace existing geocode if any" => "Replace existing geocode if any",
// "When automatically geocoding items based on category name, replace existing geocode if any" => "When automatically geocoding items based on category name, replace existing geocode if any",
// "Use approximate geocode location" => "Use approximate geocode location",
// "When automatically geocoding items based on category name, use randomly approximated location instead of precise location" => "When automatically geocoding items based on category name, use randomly approximated location instead of precise location",
// "\"More Like This\" algorithm for categories" => "\"More Like This\" algorithm for categories",
// "Basic" => "Basic",
// "Weighted" => "Weighted",
// "Minimum number of categories in common" => "Minimum number of categories in common",
"1" => "1",
"2" => "2",
"4" => "4",
"5" => "5",
// "6" => "6",
// "7" => "7",
// "8" => "8",
// "9" => "9",
// "10" => "10",
// "Or look for the maximum less categories in common if no objects with the above number of common categories" => "Or look for the maximum less categories in common if no objects with the above number of common categories",
// "Maximum of objects more like this, otherwise use the default max records" => "Maximum of objects more like this, otherwise use the default max records",
// "Exclude these category IDs" => "Exclude these category IDs",
// "Category path won't appear for these category IDs" => "Category path won't appear for these category IDs",
// "Center shadow start" => "Center shadow start",
// "Center shadow end" => "Center shadow end",
"Users can change site language" => "Felhasználól változtathatják a weblap nyelvét",
// "Allow users to change the language of the menus and labels" => "Allow users to change the language of the menus and labels",
"Users can change theme" => "Regisztrált felhasználók megváltoztathatják a stílust",
// "Users can change their password" => "Users can change their password",
"Disable title for comments" => "Kommentek címének kikapcsolása",
// "Hide the title field on comments and their replies" => "Hide the title field on comments and their replies",
"Email field" => "E-mail mező",
// "Email field for comments (only for anonymous users)" => "Email field for comments (only for anonymous users)",
"Website field" => "Weboldal mező",
// "Website field for comments (only for anonymous users)" => "Website field for comments (only for anonymous users)",
"Use vote system for comments" => "Szavazási rendszer használata kommentekhez",
// "Allows users with permission tiki_p_vote_comments to vote comments" => "Allows users with permission tiki_p_vote_comments to vote comments",
// "Archive comments" => "Archive comments",
// "If a comment is archived, only admins can see it" => "If a comment is archived, only admins can see it",
// "Use Akismet to filter comments" => "Use Akismet to filter comments",
// "Prevent comment spam by using the Akismet service to determine if the comment is spam. If comment moderation is enabled, the Akismet will indicate if the comment is to be moderated or not. If there is no comment moderation, the comment will be rejected if considered as spam" => "Prevent comment spam by using the Akismet service to determine if the comment is spam. If comment moderation is enabled, the Akismet will indicate if the comment is to be moderated or not. If there is no comment moderation, the comment will be rejected if considered as spam",
// "Akismet API Key" => "Akismet API Key",
// "Key required for the Akismet comment spam prevention to work" => "Key required for the Akismet comment spam prevention to work",
// "Obtain this key by registering your site on [%0]" => "Obtain this key by registering your site on [%0]",
// "Filter spam for registered users" => "Filter spam for registered users",
// "Enable spam filtering for registered users as well. Useful if your site allows for anyone to register without much validation" => "Enable spam filtering for registered users as well. Useful if your site allows for anyone to register without much validation",
// "Allow comments to be corrected by their author" => "Allow comments to be corrected by their author",
// "Allow comments to be modified by their author shortly after posting it, allowing to correct broken links or typos for a period of 30 minutes" => "Allow comments to be modified by their author shortly after posting it, allowing to correct broken links or typos for a period of 30 minutes",
// "Tiki Connect" => "Tiki Connect",
// "Connect your Tiki with the community by sending anonymised statistical data to tiki.org" => "Connect your Tiki with the community by sending anonymised statistical data to tiki.org",
// "Experimental. This feature is still under development" => "Experimental. This feature is still under development",
// "Send Site Information" => "Send Site Information",
// "Additionally send keywords, location etc to tiki.org so you can connect with Tikis near you" => "Additionally send keywords, location etc to tiki.org so you can connect with Tikis near you",
// "Site Title" => "Site Title",
// "Name of site on Tiki Connect" => "Name of site on Tiki Connect",
// "Email Contact" => "Email Contact",
// "Email to register" => "Email to register",
// "URL to register" => "URL to register",
// "Key Words" => "Key Words",
// "Key words or tags describing your site" => "Key words or tags describing your site",
// "Site Location" => "Site Location",
// "Site location as longitude,latitude,zoom" => "Site location as longitude,latitude,zoom",
// "Send Anonymous Information" => "Send Anonymous Information",
// "Send anonymous usage information" => "Send anonymous usage information",
// "Connection frequency" => "Connection frequency",
// "How often to send information (in hours)" => "How often to send information (in hours)",
// "weekly" => "weekly",
// "Experimental. Currently unused, click \"Send Info\" to connect" => "Experimental. Currently unused, click \"Send Info\" to connect",
// "Tiki Connect Server URL" => "Tiki Connect Server URL",
// "Where to send the information" => "Where to send the information",
// "Last connection" => "Last connection",
// "Connect Server Mode" => "Connect Server Mode",
// "For use by mother.tiki.org" => "For use by mother.tiki.org",
// "Connect GUID" => "Connect GUID",
// "For use by mother.tiki.org. Do not modify" => "For use by mother.tiki.org. Do not modify",
"Allow anonymous visitors to use the \"Contact Us\" feature." => "Anonim látogatók használhatják a Kapcsolatfelvétel funkciót",
"Contact user" => "Kapcsolattartó felhasználó",
"Cookie name" => "Cookie név",
// "Domain" => "Domain",
"Count admin pageviews" => "Adminisztrátori lapnézések számolása",
// "Include pageviews by the Admin when reporting stats" => "Include pageviews by the Admin when reporting stats",
// "Enable daily reports for new users" => "Enable daily reports for new users",
"Default charset for sending mail" => "Levélküldés alapértelmezett karakterkészlete",
// "utf-8" => "utf-8",
// "iso-8859-1" => "iso-8859-1",
"default mapfile" => "Alapértelmezett térképfájl",
"Default diff style" => "Eltérés alapértelmezett stílusa",
"Only with last version" => "Csak a legutóbbi verzióval",
"HTML diff" => "HTML formátumú eltérés",
"Side-by-side diff" => "Egymás melletti diff",
"Side-by-side diff by characters" => "Karakterenkénti eltérés egymás mellett",
"Inline diff" => "Tartalmon belüli eltérés",
"Inline diff by characters" => "Tartalmon belüli eltérés karakterenként",
"Full side-by-side diff" => "Teljes egymás melletti diff",
"Full side-by-side diff by characters" => "Eltérések teljes összehasonlítása egymás mellett",
"Full inline diff" => "Teljes diff (szövegben)",
// "Full inline diff by characters" => "Full inline diff by characters",
"Unified diff" => "Egységes diff",
"Side-by-side view" => "Egymás melletti nézet",
"rows" => "sor",
"Default number of rows for comment box" => "Sorok alapértelmezett száma a komment dobozhoz",
"Forum" => "Fórum",
"Forum reply" => "Fórum válasz",
"Default Editor" => "Alapértelmezett szerkesztő",
"Simple" => "Egyszerű",
"Advanced" => "Haladó",
// "Disable browser's autocomplete feature for username and password fields" => "Disable browser's autocomplete feature for username and password fields",
"Use direct pagination links" => "Direkt oldalléptetési linkek használata",
// "Max. number of links around the current item" => "Max. number of links around the current item",
// "Max. number of links after the first or before the last item" => "Max. number of links after the first or before the last item",
"Show Country Flag" => "Országzászló mutatása",
// "Show the country flag" => "Show the country flag",
// "Enable cool sites" => "Enable cool sites",
"Validate URLs" => "URL-ek hitelesítése",
// "Number of columns per page when listing directory categories" => "Number of columns per page when listing directory categories",
"Links per page" => "Laponkénti hivatkozások (linkek)",
// "Method to Open Directory Links" => "Method to Open Directory Links",
"Method to open directory links" => "Könyvtárban szereplő linkek megnyitásának módja",
"replace current window" => "jelenlegi ablak kicserélése",
"new window" => "új ablak",
"inline frame" => "belső keret",
"Fields display order" => "Mezők megjelenítési sorrendje",
// "Re-validate user by email after" => "Re-validate user by email after",
"days" => "nap",
// "Use \"-1\" for never" => "Use \"-1\" for never",
// "Email footer" => "Email footer",
// "Text appended to outgoing emails" => "Text appended to outgoing emails",
// "PHP errors visible to admin only" => "PHP errors visible to admin only",
// "For development purposes, it's better to display errors for all users. However, in production settings, they should only be displayed to administrators" => "For development purposes, it's better to display errors for all users. However, in production settings, they should only be displayed to administrators",
"PHP Error reporting level" => "PHP hiba jelentési szint",
// "Level from which errors should be reported" => "Level from which errors should be reported",
"No error reporting" => "Nincs hibajelentés",
// "Report all PHP errors except strict" => "Report all PHP errors except strict",
"Report all PHP errors" => "Minden PHP hiba jelentése",
// "Report all PHP errors except notices" => "Report all PHP errors except notices",
"According to PHP configuration" => "PHP konfigurációnak megfelelően",
"Default number of comments per page" => "Kommentek alapértelmezett száma oldalanként",
"Comments default ordering" => "Kommentek alapértelmezett rendezési elve",
"Question and Answer prefix on Answers" => "Kérdés és Válasz előtag válaszoknál",
"Q and A" => "K & V",
"Question ID" => "Kérdés azonosító",
"Blog" => "Blog",
"Force and limit categorization to within subtree of" => "Kategorizálás kényszerítése és korlátozása ezen kategóriaág alá",
// "If you get an error message indicating a mandatory category is required when editing a blog post, this is the option to blame. Set it to None" => "If you get an error message indicating a mandatory category is required when editing a blog post, this is the option to blame. Set it to None",
// "Areas" => "Areas",
// "Binding categories and perspectives to each other" => "Binding categories and perspectives to each other",
// "Collaboratively authored documents with history of changes" => "Collaboratively authored documents with history of changes",
// "Online diaries or journals" => "Online diaries or journals",
// "Collections of graphic images for viewing or downloading (photo album)" => "Collections of graphic images for viewing or downloading (photo album)",
// "You can use file galleries instead" => "You can use file galleries instead",
"Machine Translation (by Google Translate)" => "Gépi fordítás  (Google Translate)",
// "Uses Google Translate to translate the content of wiki pages to other languages" => "Uses Google Translate to translate the content of wiki pages to other languages",
"Experimental" => "Kísérleti",
// "Database & form generator" => "Database & form generator",
// "Reports" => "Reports",
// "Reports Generator" => "Reports Generator",
// "Online discussions on a variety of topics. Threaded or flat" => "Online discussions on a variety of topics. Threaded or flat",
// "Computer files, videos or software for downloading. With check-in & check-out (lock)" => "Computer files, videos or software for downloading. With check-in & check-out (lock)",
// "Save files as drafts" => "Save files as drafts",
// "File Galleries configuration templates" => "File Galleries configuration templates",
"template" => "sablon",
// "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"" => "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"",
"Polls" => "Szavazások",
// "Brief list of votable options; appears in module (left or right column)" => "Brief list of votable options; appears in module (left or right column)",
"Newsletters" => "Hírlevelek",
// "Content mailed to registered users" => "Content mailed to registered users",
"Calendar" => "Naptár",
// "Events calendar with public, private and group channels" => "Events calendar with public, private and group channels",
"Banners" => "Bannerek",
// "Insert, track, and manage advertising banners" => "Insert, track, and manage advertising banners",
// "Global category system. Items of different types (wiki pages, articles, tracker items, etc) can be added to one or many categories. Categories can have permissions" => "Global category system. Items of different types (wiki pages, articles, tracker items, etc) can be added to one or many categories. Categories can have permissions",
"Score" => "Pontszám",
// "Score is a game to motivate participants to increase their contribution by comparing to other users" => "Score is a game to motivate participants to increase their contribution by comparing to other users",
// "Unified Search" => "Unified Search",
// "Enables searching for content on the website, using Tiki-managed index" => "Enables searching for content on the website, using Tiki-managed index",
// "Allows to set tags on pages and various objects within the website and generate tag cloud navigation patterns" => "Allows to set tags on pages and various objects within the website and generate tag cloud navigation patterns",
"Action Log" => "Akció log",
// "Allows to keep track of what users are doing and produce reports on a per-user or per-category basis" => "Allows to keep track of what users are doing and produce reports on a per-user or per-category basis",
"Contribution" => "Hozzájárulás",
// "Allows users to specify the type of contribution they are making while editing objects. The contributions are then displayed as color-coded in history and other reports" => "Allows users to specify the type of contribution they are making while editing objects. The contributions are then displayed as color-coded in history and other reports",
"Multilingual" => "Többnyelvű",
// "Enables internationalization features and multilingual support for then entire site" => "Enables internationalization features and multilingual support for then entire site",
"FAQ" => "GYIK",
// "Frequently asked questions and answers" => "Frequently asked questions and answers",
// "You can use wiki pages instead" => "You can use wiki pages instead",
"Surveys" => "Kérdőívek",
// "Questionnaire with multiple choice or open ended question" => "Questionnaire with multiple choice or open ended question",
// "User-submitted Web links" => "User-submitted Web links",
// "Timed questionnaire with recorded scores" => "Timed questionnaire with recorded scores",
"Featured Links" => "Kiemelt linkek",
// "Simple menu system which can optionally add an external web page in an iframe" => "Simple menu system which can optionally add an external web page in an iframe",
"Copyright" => "Szerzői jogok",
// "The Copyright Management System (or ©MS) is a way of licensing your content" => "The Copyright Management System (or ©MS) is a way of licensing your content",
"Shoutbox" => "Üzenőfal",
// "Quick comment (graffiti) box. Like a group chat, but not in real time" => "Quick comment (graffiti) box. Like a group chat, but not in real time",
// "MapServer" => "MapServer",
// "Navigable, interactive maps with user-selectable layers" => "Navigable, interactive maps with user-selectable layers",
// "Requires MapServer" => "Requires MapServer",
"Google Maps" => "Google térképek",
// "Interactive use of Google Maps" => "Interactive use of Google Maps",
"Live support system" => "Élő támogatási rendszer",
// "One-on-one chatting with customer" => "One-on-one chatting with customer",
"Tell a Friend" => "Szólj egy barátodnak",
// "Add a link \"Email this page\" in all the pages" => "Add a link \"Email this page\" in all the pages",
"Share" => "Megosztás",
// "Add a \"Share\" link in all pages to send it via e-mail, Twitter, Facebook, message or forums" => "Add a \"Share\" link in all pages to send it via e-mail, Twitter, Facebook, message or forums",
// "be careful when allowing to anonymous to activate the antibot feature" => "be careful when allowing to anonymous to activate the antibot feature",
"HTML pages" => "HTML oldalak",
// "Static and dynamic HTML content" => "Static and dynamic HTML content",
// "HTML can be used in wiki pages. This is a separate feature" => "HTML can be used in wiki pages. This is a separate feature",
"Contact Us" => "Kapcsolatfelvétel",
// "Basic form from visitor to admin" => "Basic form from visitor to admin",
"Minichat" => "Minichat",
// "Real-time group text chatting" => "Real-time group text chatting",
"Comments Moderation" => "Kommentek moderálása",
// "An admin must validate a comment before it is visible" => "An admin must validate a comment before it is visible",
"Comments Locking" => "Kommentek zárolása",
// "Comments can be closed (no new comments)" => "Comments can be closed (no new comments)",
// "Allow logged in users to pretend to be anonymous when posting a commment" => "Allow logged in users to pretend to be anonymous when posting a commment",
// "This can be used to encourage honest feedback with the opportunity to voice an opinion anonymously. Like in a forum where you ask feedback on what is done wrong or should be improved internally" => "This can be used to encourage honest feedback with the opportunity to voice an opinion anonymously. Like in a forum where you ask feedback on what is done wrong or should be improved internally",
// "Display page description" => "Display page description",
// "Display the page description below the heading when viewing the page" => "Display the page description below the heading when viewing the page",
"Display page name as page title" => "Oldal nevének megjelenítése oldal címeként",
// "Display the page name at the top of each page as page title. If not enabled, the page content should be structured to contain a header" => "Display the page name at the top of each page as page title. If not enabled, the page content should be structured to contain a header",
// "Display page ID" => "Display page ID",
// "Display the internal page ID when viewing the page" => "Display the internal page ID when viewing the page",
"Individual wiki cache" => "Egyedi wiki cache",
// "Allow users to change the duration of the cache on a per-page basis" => "Allow users to change the duration of the cache on a per-page basis",
"JS Calendar" => "JS naptár",
// "JavaScript popup date selector. Will use jQuery UI DatePicker if enabled" => "JavaScript popup date selector. Will use jQuery UI DatePicker if enabled",
// "Output should be HTML Purified" => "Output should be HTML Purified",
// "This enables HTML Purifier on outputs to filter potential remaining security problems like XSS" => "This enables HTML Purifier on outputs to filter potential remaining security problems like XSS",
// "Full Screen" => "Full Screen",
"Allow users to activate fullscreen mode" => "Felhasználók aktiválhatják a teljesképernyős módot",
// "CSS Menus" => "CSS Menus",
// "CSS Menus (suckerfish)" => "CSS Menus (suckerfish)",
// "Shadowbox / ColorBox" => "Shadowbox / ColorBox",
// "\"Displaying content with Eye Candy\". <br />Uses jQuery plugin \"ColorBox\". e.g. <code>{img fileId=\"42\" thumb=\"y\" alt=\"\" rel=\"box[g]\"}</code>" => "\"Displaying content with Eye Candy\". <br />Uses jQuery plugin \"ColorBox\". e.g. <code>{img fileId=\"42\" thumb=\"y\" alt=\"\" rel=\"box[g]\"}</code>",
// "Quick Permission Assignment" => "Quick Permission Assignment",
// "Quickperms allow to define classes of privileges and grant them to roles on objects" => "Quickperms allow to define classes of privileges and grant them to roles on objects",
"HTML Purifier" => "HTML tisztító",
// "If you are trying to use HTML in your pages and it gets stripped out, you should make sure your HTML is valid or de-activate this feature" => "If you are trying to use HTML in your pages and it gets stripped out, you should make sure your HTML is valid or de-activate this feature",
"Ajax" => "Ajax",
"Morcego 3D browser" => "Morcego 3D böngésző",
// "Visualize relationships between wiki pages, in a 3D applet" => "Visualize relationships between wiki pages, in a 3D applet",
"Webmail" => "Webes levelezés",
// "Intertiki" => "Intertiki",
// "Allows several Tiki sites (slaves) to get authentication from a master Tiki site" => "Allows several Tiki sites (slaves) to get authentication from a master Tiki site",
"Mail-in" => "Bejövő levelezés",
// "Populate wiki pages and articles by email" => "Populate wiki pages and articles by email",
"Mindmap" => "Mindmap",
// "Print Indexed" => "Print Indexed",
"Spreadsheet" => "Táblázat",
// "Datasheets with calculations and charts" => "Datasheets with calculations and charts",
// "Slideshow (jQuery.s5)" => "Slideshow (jQuery.s5)",
// "Web based slideshow" => "Web based slideshow",
// "Slideshow (jQuery.s5) PDF Export" => "Slideshow (jQuery.s5) PDF Export",
// "Web based slideshow to pdf export" => "Web based slideshow to pdf export",
// "Invoice" => "Invoice",
// "Invoice system" => "Invoice system",
"Wysiwyg editor" => "WYSIWYG szerkesztő",
// "WYSIWYG is an acronym for What You See Is What You Get. Uses CKEditor" => "WYSIWYG is an acronym for What You See Is What You Get. Uses CKEditor",
// "Kaltura Video Management" => "Kaltura Video Management",
// "Integration to the Kaltura video management platform" => "Integration to the Kaltura video management platform",
"Friendship Network" => "Baráti körök",
// "Users can identify other users as their friends" => "Users can identify other users as their friends",
// "Neglected feature" => "Neglected feature",
"Banning system" => "Kitiltási rendszer",
// "Deny access to specific users based on username, IP, and date/time range" => "Deny access to specific users based on username, IP, and date/time range",
"Stats" => "Statisztika",
// "Record basic statistics about major Tiki features (number of wiki pages, size of file galleries, etc.)" => "Record basic statistics about major Tiki features (number of wiki pages, size of file galleries, etc.)",
"Action Calendar" => "Akció naptár",
"Referer Stats" => "Hivatkozási statisztika",
// "Record domain name of sites that send visitors to this Tiki" => "Record domain name of sites that send visitors to this Tiki",
"Redirect On Error" => "Átirányítás hiba esetén",
// "On error, goto the HomePage as configured in Admin->General" => "On error, goto the HomePage as configured in Admin->General",
"Communications (send/receive objects)" => "Kommunikáció (objektum küldése/fogadás)",
// "Send/receive wiki pages and articles between Tiki-powered sites" => "Send/receive wiki pages and articles between Tiki-powered sites",
"Custom Home" => "Saját kezdőlap",
"Mini Calendar" => "Mini Naptár",
"User Preferences Screen" => "Felhasználói preferenciák képernyő",
"User Notepad" => "Felhasználói jegyzettömb",
"My Bookmarks" => "Felhasználói könyvjelzők",
"User Contacts" => "Felhasználó kapcsolatai",
"User Watches" => "Felhasználói figyelések",
// "Receive email notification of changes" => "Receive email notification of changes",
"Group Watches" => "Csoport figyelések",
"Daily Reports for User Watches" => "Napi felhasználói figyelések riport",
"User Watches Translations" => "Felhasználó figyeli a fordításokat",
// "User Watches Languages" => "User Watches Languages",
// "Watch language-specific changes within a category" => "Watch language-specific changes within a category",
"User Menu" => "Felhasználói menü",
"User Tasks" => "Felhasználói feladatok",
"User Messages" => "Felhasználói üzenetek",
"User Files" => "Felhasználói fájlok",
// "Menu User Levels" => "Menu User Levels",
// "Allows to control the menu options that can be seen by a user" => "Allows to control the menu options that can be seen by a user",
"Group Alert" => "Csoport figyelmeztetés",
"Integrator" => "Integrátor",
"XMLRPC API" => "XMLRPC API",
"Debugger Console" => "Debug konzol",
"TikiTests" => "TikiTest",
// "Permits recording and playback of functional tests" => "Permits recording and playback of functional tests",
"Check for updates automatically" => "Frissítések automatikus ellenőrzése",
// "Tiki will check for updates when you access the main Administration page" => "Tiki will check for updates when you access the main Administration page",
// "Require confirmation if possible CSRF detected" => "Require confirmation if possible CSRF detected",
"Protect against CSRF with a ticket" => "CSRF elleni védekezés jeggyel",
"Detect browser language" => "Böngésző nyelvének felismerése",
// "Lookup the user's preferred language through browser preferences" => "Lookup the user's preferred language through browser preferences",
"Show pages in user's preferred language" => "Oldal mutatása a felhasználó által preferált nyelven",
// "When accessing a page which has an equivalent in the user's preferred language, favor the translated page" => "When accessing a page which has an equivalent in the user's preferred language, favor the translated page",
"Changing the page language also changes the site language" => "Oldal nyelvének változtatása változtassa a weblap nyelvét is",
"Translation assistant" => "Fordítási asszisztens",
// "Track translation operations between pages" => "Track translation operations between pages",
"Urgent translation notifications" => "Sürgős fordítási figyelmeztetések",
// "Allow to flag changes as urgent, leading translations to be marked with a notice visible to all users" => "Allow to flag changes as urgent, leading translations to be marked with a notice visible to all users",
"Incomplete translation notice" => "Figyelmeztetés be nem fejezett fordításokról",
// "When a page is translated to a new language, a notice will be automatically inserted into the page to indicate that the translation is not yet complete" => "When a page is translated to a new language, a notice will be automatically inserted into the page to indicate that the translation is not yet complete",
"Multilingual structures" => "Többnyelvű struktúrák",
// "Structures to lookup equivalent pages in other languages. May cause performance problems on larger structures" => "Structures to lookup equivalent pages in other languages. May cause performance problems on larger structures",
"Display all languages in a single page" => "Összes nyelv megjelenítése egy oldalon",
// "List all languages as a language option in the page language drop list to see all languages at once" => "List all languages as a language option in the page language drop list to see all languages at once",
"GZip output" => "GZip kimenet",
// "Compress your pages on-the-fly, if the requesting browser supports this" => "Compress your pages on-the-fly, if the requesting browser supports this",
"Help System" => "Segítségnyújtás",
// "Yahoo! Babel Fish Translation URLs" => "Yahoo! Babel Fish Translation URLs",
// "Show clickable URLs to translate the page to another language using Babel Fish website" => "Show clickable URLs to translate the page to another language using Babel Fish website",
// "You need to assign somewhere on the page via a module" => "You need to assign somewhere on the page via a module",
// "Yahoo! Babel Fish Translation icons" => "Yahoo! Babel Fish Translation icons",
// "Show clickable icons to translate the page to another language using Babel Fish website" => "Show clickable icons to translate the page to another language using Babel Fish website",
"Smileys" => "Mosolyok",
// "Also known as emoticons" => "Also known as emoticons",
// "Draw (SVG-edit)" => "Draw (SVG-edit)",
// "Draw gives you the ability to edit SVG images all around Tiki" => "Draw gives you the ability to edit SVG images all around Tiki",
// "Draw (SVG-edit) Hide Buttons" => "Draw (SVG-edit) Hide Buttons",
// "Hide buttons found in Tiki Draw, HTML id, comma-delimited.  Example: \"tool_select,tool_fhpath,tools_line_show,tools_rect_show,tools_ellipse_show,tool_path,tools_shapelib_show,tool_text,tool_image,tool_zoom,tool_eyedropper\"" => "Hide buttons found in Tiki Draw, HTML id, comma-delimited.  Example: \"tool_select,tool_fhpath,tools_line_show,tools_rect_show,tools_ellipse_show,tool_path,tools_shapelib_show,tool_text,tool_image,tool_zoom,tool_eyedropper\"",
// "Docs (WebODF)" => "Docs (WebODF)",
// "Docs gives you the ability to view/edit Open Document Format" => "Docs gives you the ability to view/edit Open Document Format",
"Dynamic Content System" => "Dinamikus tartalomkezelő rendszer",
// "Bloc of content which can be reused and programmed (timed)" => "Bloc of content which can be reused and programmed (timed)",
"Use File Galleries to store pictures" => "Képek tárolása fájlgalériában",
// "If disabled, pictures will be stored in ../img/wiki_up/.. instead" => "If disabled, pictures will be stored in ../img/wiki_up/.. instead",
"External link icon" => "Külső link ikon",
// "External links will be identifed with an icon. Use the ../img/icons/external_link.gif image to customize the icon" => "External links will be identifed with an icon. Use the ../img/icons/external_link.gif image to customize the icon",
// "Add \"rel=nofollow\" on external links" => "Add \"rel=nofollow\" on external links",
"Semantic links" => "Szemantikus linkek",
// "Going beyond Backlinks, allows to define some semantic relationships between wiki pages" => "Going beyond Backlinks, allows to define some semantic relationships between wiki pages",
// "Web Services" => "Web Services",
// "Can consume webservices in JSON or YAML" => "Can consume webservices in JSON or YAML",
"Display menus as folders" => "A menüket megjelenítése mappaként",
// "Breadcrumbs" => "Breadcrumbs",
// "Attempts to show you where you are" => "Attempts to show you where you are",
"Anonymous editors must enter anti-bot code (CAPTCHA)" => "Anonim szerkesztőknek anti-bot kódot (CAPTCHA) kell megadniuk",
"Protect email against spam" => "E-mail védése spam ellen",
// "Protect email against spam currently does not operate in pages edited in WYSIWYG mode (Tiki 6.1)" => "Protect email against spam currently does not operate in pages edited in WYSIWYG mode (Tiki 6.1)",
"Activate" => "Aktiválás",
"Anonymous voting" => "Anonim szavazás",
"Allow re-voting" => "Újboli szavazás megengedése",
"Comments for polls" => "Szavazás kommentek",
"Comments for FAQs" => "GYIK kommentek",
// "Search engine friendly URL" => "Search engine friendly URL",
// "If you are using Apache, you can copy _htaccess to .htaccess to get Short URLs. On IIS, copy web_config to web.config" => "If you are using Apache, you can copy _htaccess to .htaccess to get Short URLs. On IIS, copy web_config to web.config",
// "Search engine friendly url Postfilter" => "Search engine friendly url Postfilter",
// "Display article title in the sefurl" => "Display article title in the sefurl",
// "Display blog title in the SEFURL" => "Display blog title in the SEFURL",
// "Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page" => "Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page",
// "This redirection uses the wiki prefix alias feature" => "This redirection uses the wiki prefix alias feature",
// "Canonical URL tag" => "Canonical URL tag",
// "Indicates to search engines which URL to use which prevents duplicate listings" => "Indicates to search engines which URL to use which prevents duplicate listings",
"Show module controls" => "Modul vezérlők megjelenítése",
"Perspectives" => "Perspektívák",
// "Permits to override preferences" => "Permits to override preferences",
"Search and replace" => "Keresés és kicserélés",
// "Permits find and replace of content in the edit box" => "Permits find and replace of content in the edit box",
"Submissions" => "Beküldések",
// "Submissions are sent in but need to be approved before they go live" => "Submissions are sent in but need to be approved before they go live",
"Rankings" => "Rangsor",
"Comments for articles" => "Cikk kommentek",
// "Article content templates" => "Article content templates",
// "template article news" => "template article news",
// "Predefined content for a news article" => "Predefined content for a news article",
"Print" => "Nyomtatás",
"Specify notification emails when creating articles" => "Értesítési E-mail címek megadása cikk létrehozásakor",
// "ShareThis buttons" => "ShareThis buttons",
// "Insert a ShareThis button from www.sharethis.com" => "Insert a ShareThis button from www.sharethis.com",
"Category Path" => "Kategória útvonal",
// "Show category tree, above wiki pages" => "Show category tree, above wiki pages",
"Show category objects" => "Kategória objektumok megjelenítése",
// "Show objects sharing the same category, below wiki pages" => "Show objects sharing the same category, below wiki pages",
"Ignore category viewing restrictions" => "Kategória megtekintési korlátozások figyelmen kívűl hagyása",
"Will improve performance, but may show forbidden results" => "Javítja a teljesítményt de megjeleníthet tiltott (jogosultság nélküli) eredményeket",
"List pages" => "Oldalak listázása",
"Latest Changes" => "Legutóbbi változások",
"Orphan pages" => "Forrás oldalak",
// "MySQL Full-Text Search" => "MySQL Full-Text Search",
// "This search uses the MySQL Full-Text Search feature. The indexation is continuously updated" => "This search uses the MySQL Full-Text Search feature. The indexation is continuously updated",
"Referer Search Highlighting" => "Hivatkozott keresés kiemelése",
"Search stats" => "Keresési statisztika",
"Ignore individual object permissions" => "Egyedi objektumjogosultságok ignorálása",
"Object filter" => "Objektum szűrő",
"Search box" => "Keresődoboz",
"Pertinence" => "Helyesség (relevancia)",
"Object type" => "Objektum típusa",
"Last modified date" => "Utolsó módosítás dátuma",
// "Custom blog headings" => "Custom blog headings",
// "Using custom blog headings will use significantly more server resources. Unless you need per-blog templates, you should use a customize the template file" => "Using custom blog headings will use significantly more server resources. Unless you need per-blog templates, you should use a customize the template file",
// "Publish dates can be modified" => "Publish dates can be modified",
"Comments on blog posts" => "Blog poszt kommentek",
// "Insert a ShareThis button from [http://www.sharethis.com]" => "Insert a ShareThis button from [http://www.sharethis.com]",
"File Gallery Comments" => "Fájlgaléria kommentek",
// "Use file galleries for user files" => "Use file galleries for user files",
// "experimental" => "experimental",
// "Use file galleries for wiki attachments" => "Use file galleries for wiki attachments",
"Batch uploading" => "Kötegelt feltöltés",
// "Direct import of local files into a File Gallery. Can handle large files. User can upload file via FTP to target folder" => "Direct import of local files into a File Gallery. Can handle large files. User can upload file via FTP to target folder",
// "Use batch uploading to integrate large files into File Galleries" => "Use batch uploading to integrate large files into File Galleries",
"Accept wiki syntax" => "Wiki szintakszis elfogadása",
"Topic archiving" => "Téma archiválás",
"Quick jumps" => "Gyors ugrások",
"Replies are empty" => "Válaszok üresek",
"If disabled, replies will quote the original post" => "Ha ki van kapcsolva akkor a válaszok idézik az eredeti posztot",
"First post of a thread can have an empty body" => "Egy thread első posztjának törzse lehet üres",
"Will be a thread title" => "Thread cím lesz",
"Forum name search" => "Fórum név keresés",
"When listing forums" => "Fórumok listázásakor",
"Forum content search" => "Fórum tartalom keresés",
"Topic content search" => "Téma tartalom keresés",
// "Tiki-indexed search" => "Tiki-indexed search",
"Use database (full-text) search" => "Adatbázis (full-text) keresés",
// "Store password as plain text" => "Store password as plain text",
// "Encryption method" => "Encryption method",
"tikihash (old)" => "tikihash (régi)",
"Edit CSS" => "CSS szerkesztése",
"Theme Control" => "Stílus kontroll",
// "Assign different themes to different sections, categories, and objects" => "Assign different themes to different sections, categories, and objects",
// "design themes" => "design themes",
"Tiki Template Viewing" => "Tiki sablon megtekintés",
"Edit Templates" => "Sablonok szerkesztése",
"Custom HTML <head> Content" => "Saját HTML <head> tartalom",
"Example:" => "Például:",
// "Use to include custom &lt;meta&gt; or &lt;link&gt; tags" => "Use to include custom &lt;meta&gt; or &lt;link&gt; tags",
// "Add BASE tag in the page HEAD" => "Add BASE tag in the page HEAD",
// "The &lt;base&gt; tag specifies a default address for all links on a page" => "The &lt;base&gt; tag specifies a default address for all links on a page",
"Site Logo and Title" => "Weblap logó és cím",
// "Expected to be migrated to modules entirely and made obsolete" => "Expected to be migrated to modules entirely and made obsolete",
"Left column" => "Bal oszlop",
// "Controls visibility of the left column of modules" => "Controls visibility of the left column of modules",
// "side bar" => "side bar",
// "Only if module" => "Only if module",
"Always" => "Mindig",
"User Decides" => "Felhasználó dönt",
// "Right Column" => "Right Column",
// "Controls visibility of the right column of modules" => "Controls visibility of the right column of modules",
// "Prefix breadcrumbs with \"Location : \"" => "Prefix breadcrumbs with \"Location : \"",
"Site location bar" => "Weblap lokáció sor",
// "Use breadcrumbs module" => "Use breadcrumbs module",
// "Top of center column (legacy mode)" => "Top of center column (legacy mode)",
"Larger font for" => "Nagyobb betűméret itt",
// "Entire location" => "Entire location",
"Page name" => "Lap neve",
"Use page description" => "Oldalak leírásának felhasználása",
"Top of page" => "Oldal teteje",
// "Top of center column" => "Top of center column",
// "Custom End of <body> Code" => "Custom End of <body> Code",
"Webmaster Report" => "Webmester riport",
"Webmaster Email" => "Webmester E-mail",
"Leave blank to use the default sender email" => "Üresen kell hagyni az alapértelmezett küldési cím használatához",
"Email this page" => "Oldal küldése E-mailben",
// "Add a link at the bottom if set, otherwise add a link at the top" => "Add a link at the bottom if set, otherwise add a link at the top",
// "Shadow layer" => "Shadow layer",
// "Additional layers for shadows, rounded corners or other decorative styling" => "Additional layers for shadows, rounded corners or other decorative styling",
// "Tooltips" => "Tooltips",
// "Make tooltips such as this appear in a custom style. Use CSS to change their appearance" => "Make tooltips such as this appear in a custom style. Use CSS to change their appearance",
// "Provides various drop-down menus on many text input boxes for page names, user names, groups, tags etc" => "Provides various drop-down menus on many text input boxes for page names, user names, groups, tags etc",
// "Superfish" => "Superfish",
// "Adds animation effects to CSS \"Suckerfish\" menus" => "Adds animation effects to CSS \"Suckerfish\" menus",
// "Reflection" => "Reflection",
// "Allows images to have a reflection effect below them. See the admin icons above for an example" => "Allows images to have a reflection effect below them. See the admin icons above for an example",
"JQuery UI" => "JQuery UI",
// "Include jQuery UI library. Enables many user interface features" => "Include jQuery UI library. Enables many user interface features",
// "jQuery UI Theme" => "jQuery UI Theme",
// "jQuery UI Theme. Used in spreadsheet, for example" => "jQuery UI Theme. Used in spreadsheet, for example",
"Validation" => "Validálás",
// "Provides various validation possibilities like in Trackers" => "Provides various validation possibilities like in Trackers",
// "jQuery Infinite Carousel" => "jQuery Infinite Carousel",
// "Image \"carousel\" plugin (coming soon)" => "Image \"carousel\" plugin (coming soon)",
"jQuery Sortable Tables" => "jQuery rendezhető táblák",
// "Sort in fancytable plugin" => "Sort in fancytable plugin",
// "This feature can cause problems with JS minify on some systems" => "This feature can cause problems with JS minify on some systems",
// "jQuery Media" => "jQuery Media",
// "Media player" => "Media player",
"Use Tabs" => "Fülek használata",
// "Makes pages shorter by splitting the content in different tabs" => "Makes pages shorter by splitting the content in different tabs",
"Correct PNG images alpha transparency in IE6 (experimental)" => "PNG képek alfa transparenciájának javítása IE6-ban (kísérleti)",
// "Wiki content templates" => "Wiki content templates",
// "Predefined content for a wiki page" => "Predefined content for a wiki page",
"Warn on edit conflict" => "Figyelmeztessen szerkesztési konfliktusnál",
// "Tiki will warn users who attempt to edit a page that another user is currenly editing" => "Tiki will warn users who attempt to edit a page that another user is currenly editing",
"Undo" => "Visszaállítás (undo)",
"Footnotes" => "Lábjegyzetek",
// "Create private notes for a page that are visible only by the author" => "Create private notes for a page that are visible only by the author",
"Allow HTML" => "HTML engedélyezése",
"Log bytes changes (+/-) in action logs" => "Bájt változások (+/-) az akció logban",
"May impact performance" => "Hatással lehet a teljesítményre",
"Sandbox" => "Homokozó",
// "A special wiki page for testing. Users can edit, but not save the Sandbox" => "A special wiki page for testing. Users can edit, but not save the Sandbox",
"Comments below wiki pages" => "Komment wiki oldalak alatt",
// "Allow users (with permission) to post threaded comments to a page" => "Allow users (with permission) to post threaded comments to a page",
"Pictures" => "Képek",
// "Allow users to upload images (pictures) to a page" => "Allow users to upload images (pictures) to a page",
"Export" => "Exportálás",
"WikiWords" => "WikiSzavak",
// "Automatically convert words with UpPeR and LoWeR-case letters into wiki links" => "Automatically convert words with UpPeR and LoWeR-case letters into wiki links",
"Link plural WikiWords to their singular forms" => "Többesszámú WikiWord hozzákötése az egyes számú formához (angolul)",
"Accept dashes and underscores in WikiWords" => "Kötőjelek és aláhúzások elfogadás WikiWordben",
"History" => "Előzmények",
"Display IP address" => "IP cím megjelenítése",
// "Record all versions, rather than only when page content or description changes or when an edit comment is given" => "Record all versions, rather than only when page content or description changes or when an edit comment is given",
"View page contributions by author" => "Oldalhoz történt hozzájárulások szerzőnként",
// "Visualize the contributions of different authors made to a wiki page" => "Visualize the contributions of different authors made to a wiki page",
"Discuss pages on forums" => "Oldalak megbeszélése fórumokban",
// "Include a link on each page to a forum topic" => "Include a link on each page to a forum topic",
"View source" => "Forrás megtekintése",
"Similar (like pages)" => "Hasonló oldalak",
"Structures" => "Struktúrák",
// "Structures Drill Down Menu" => "Structures Drill Down Menu",
// "Ajax style drill down menu for structures" => "Ajax style drill down menu for structures",
"Open page as structure" => "Oldal megnyitása struktúraként",
"Make structure from page" => "Struktúra készítése oldalból",
"Categorize structure pages together" => "Struktúra oldalainak közös kategóriába helyezése",
// "Disable inheritance of direct object permissions when adding pages from a structure" => "Disable inheritance of direct object permissions when adding pages from a structure",
"Create webhelp from structure" => "Websúgó készítése struktúrából",
"Import HTML" => "HTML importálása",
// "Use date parameter" => "Use date parameter",
// "Report it in wiki links" => "Report it in wiki links",
"Import pages" => "Oldalak importálása",
// "A personal page for the user to manage" => "A personal page for the user to manage",
"UserPage prefix" => "Felhasználói oldal prefix",
// "All user pages share a common prefix. The concatenation of the prefix and the username will generate the page name. The prefix cannot be empty" => "All user pages share a common prefix. The concatenation of the prefix and the username will generate the page name. The prefix cannot be empty",
"Users can lock pages" => "Felhasználók zárolhatják az oldalakat",
"MultiPrint" => "Tömeges nyomtatás",
"Pages not in structure" => "Nem Struktúrában nem szereplő oldalak",
"Attachments" => "Mellékletek",
// "Allow users to upload (attach) files to a page" => "Allow users to upload (attach) files to a page",
"Dumps" => "Dump-ok",
// "If you get an error message indicating a mandatory category is required when editing a wiki page, this is the option to blame. Set it to None" => "If you get an error message indicating a mandatory category is required when editing a wiki page, this is the option to blame. Set it to None",
// "If you get an error message indicating a mandatory category is required when editing an image (in an image gallery), this is the option to blame. Set it to None" => "If you get an error message indicating a mandatory category is required when editing an image (in an image gallery), this is the option to blame. Set it to None",
"Display show/hide icon displayed before headings" => "Megjelenítés/elrejtés ikon megjelenítése címsorok előtt",
"Metrics Dashboard" => "Mérőszámok",
// "Generate automated statistics from configured database queries" => "Generate automated statistics from configured database queries",
// "Wiki argument variables" => "Wiki argument variables",
// "Allow to write request variables inside wiki content using {{paramname}} or {{paramname|default}} - special case {{page}} {{user}}" => "Allow to write request variables inside wiki content using {{paramname}} or {{paramname|default}} - special case {{page}} {{user}}",
"Use challenge/response authentication" => "Kérdés/válasz azonosítás használata",
// "Confirm that the Admin account has a valid email address or you will not be permitted to login" => "Confirm that the Admin account has a valid email address or you will not be permitted to login",
"Users can choose to stay in SSL mode after an HTTPS login" => "Felhasználók választhatnak hogy SSL módban maradnak HTTPS bejelentkezés után",
"Users can switch between secured or standard mode at login" => "Felhasználók választhatnak standard és biztonságos mód között bejelentkezéskor",
"Wiki paragraph formatting" => "Wiki bekezdés formázás",
"Because the Wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines." => "Mivel a Wiki bekezdés formázás be van kapcsolva ezért a nem üres sorok összes csoportja bekezdésbe van összegyűjtve. A sorok bármilyen hosszúságúak lehetnek és egybe lesznek tördelve a következő sorral. A bekezdéseket üres sorok választják el.",
"Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line." => "Mivel a Wiki bekezdés formázás ki van kapcsolva ezért minden sor úgy jelenik meg ahogy írjuk. Ez azt jelenti hogy ha szeretnénk hogy a sorok rendesen legyenek tördelve akkor a teljes bekezdés egy sorból álljon.",
"...but still create line breaks within paragraphs" => "...de mégis hozzon létre sortöréseket bekezdéseken belül",
"Automonospaced text" => "Automonospaced szöveg",
"Tables syntax" => "Táblázat szintaxis",
"|| for rows" => "|| sorokhoz",
"<return> for rows" => "<return> sorokhoz",
"AutoLinks" => "Automatikus linkek (AutoLink-ek)",
// "Tiki will automatically convert http:// and email addresses into links" => "Tiki will automatically convert http:// and email addresses into links",
"Hotwords" => "Kulcsszavak",
"Open Hotwords in new window" => "Hotword megnyitása új ablakban",
// "Characters that limit a hotword" => "Characters that limit a hotword",
// "Use Quote plugin rather than \">\" for quoting" => "Use Quote plugin rather than \">\" for quoting",
// "Use three colons instead of two to center text. Avoids conflict with C++ resolution scope operator" => "Use three colons instead of two to center text. Avoids conflict with C++ resolution scope operator",
// "String to use to delimit simplebox" => "String to use to delimit simplebox",
"Users can choose to show their gender" => "Felhasználók megmutathatják nemüket",
"Real name" => "Valódi név",
"Gender" => "Nem",
"Picture (avatar)" => "Kép (avatár)",
"Number of friends" => "Barátok száma",
"Country" => "Ország",
// "E-mail" => "E-mail",
"Last login" => "Legutóbbi bejelentkezés",
"Distance" => "Távolság",
"Manual selection of time/date" => "Idő/dátum manuális kiválasztása",
// "WebDAV access to Tiki" => "WebDAV access to Tiki",
// "Allow to access File Galleries with WebDAV" => "Allow to access File Galleries with WebDAV",
// "use tiki-webdav.php as the URI of the WebDAV repository" => "use tiki-webdav.php as the URI of the WebDAV repository",
"Fixed width" => "Fix szélesség",
// "Constrains the width of the site" => "Constrains the width of the site",
"Social networks" => "Közösségi hálózatok",
// "Integration with different social networks like Twitter or Facebook" => "Integration with different social networks like Twitter or Facebook",
"Group Transition" => "Csoport tranzíció",
// "Enables transitions for users between different groups. Transitions will create a user approval workflow" => "Enables transitions for users between different groups. Transitions will create a user approval workflow",
// "Category Transition" => "Category Transition",
// "Enables transitions on objects between different categories. Transitions will create a document workflow" => "Enables transitions on objects between different categories. Transitions will create a document workflow",
// "Ustream Watershed live video streaming" => "Ustream Watershed live video streaming",
// "Integration to Ustream Watershed live video streaming" => "Integration to Ustream Watershed live video streaming",
"Tiki User Credits" => "Tiki felhasználói kreditek",
// "Invite users" => "Invite users",
// "Allow users to invite new users by mail to register on this tiki" => "Allow users to invite new users by mail to register on this tiki",
// "Alternate Registration Page" => "Alternate Registration Page",
// "Makes any access to tiki-register.php redirect to an alternate page for registration" => "Makes any access to tiki-register.php redirect to an alternate page for registration",
// "Load Balancer" => "Load Balancer",
// "Enable this only if the server is behind a load balancer (or reverse proxy), this allow tiki to log the IP of the user, instead of the IP of the proxy server" => "Enable this only if the server is behind a load balancer (or reverse proxy), this allow tiki to log the IP of the user, instead of the IP of the proxy server",
// "Accounting" => "Accounting",
// "Double-entry accounting system" => "Double-entry accounting system",
// "Syntax Highlighter (CodeMirror)" => "Syntax Highlighter (CodeMirror)",
// "Enables syntax highlighting with the use of CodeMirror" => "Enables syntax highlighting with the use of CodeMirror",
// "Syntax Highlighter (CodeMirror) Theme" => "Syntax Highlighter (CodeMirror) Theme",
// "Code Mirror Themes (clear cache when you change)" => "Code Mirror Themes (clear cache when you change)",
// "Jison Wiki Parser" => "Jison Wiki Parser",
// "Is a new strategy for parsing wiki pages more like a programming language" => "Is a new strategy for parsing wiki pages more like a programming language",
// "Dummy preference" => "Dummy preference",
// "This is useful for developers to learn how to create a new preference" => "This is useful for developers to learn how to create a new preference",
// "This is the detail" => "This is the detail",
// "This is the warning" => "This is the warning",
// "This is the hint" => "This is the hint",
// "This is the shorthint" => "This is the shorthint",
// "Time Sheet" => "Time Sheet",
// "A project time manager" => "A project time manager",
// "Html Feed" => "Html Feed",
// "A way to push and pull html bits around from one site to another" => "A way to push and pull html bits around from one site to another",
// "ForwardLink-Protocol" => "ForwardLink-Protocol",
// "A Dynamic Compendia" => "A Dynamic Compendia",
// "Unified Search requires more server processing ressources, and that you properly set the server permissions. Also, it's recommended to set a cron job to periodically rebuild the search index" => "Unified Search requires more server processing ressources, and that you properly set the server permissions. Also, it's recommended to set a cron job to periodically rebuild the search index",
// "HTML Purifier is a standards-compliant HTML filter library written in PHP and integrated in Tiki. HTML Purifier will not only remove all malicious code (better known as XSS) with a thoroughly audited, secure yet permissive whitelist, it will also make sure your documents are standards compliant, something only achievable with a comprehensive knowledge of W3C's specifications" => "HTML Purifier is a standards-compliant HTML filter library written in PHP and integrated in Tiki. HTML Purifier will not only remove all malicious code (better known as XSS) with a thoroughly audited, secure yet permissive whitelist, it will also make sure your documents are standards compliant, something only achievable with a comprehensive knowledge of W3C's specifications",
"Display 'MyTiki' in the application menu" => "MyTiki megjelenítése az alkalmazás fő menüjében",
"Show user's contribution on the user information page" => "Felhasználó hozzájárulásainak megjelenítése a felhasználó információs oldalán",
// "nofollow is used to instruct some search engines that links should not influence search engines. It can reduce search engine spam and prevent 'spamdexing'" => "nofollow is used to instruct some search engines that links should not influence search engines. It can reduce search engine spam and prevent 'spamdexing'",
// "InnoDB doesn't support Full-Text Search until 5.6, so if this is your case, use Unified Search" => "InnoDB doesn't support Full-Text Search until 5.6, so if this is your case, use Unified Search",
"Require file author's name for anonymous uploads" => "Fájl szerzőjének megadása kötelező anonim feltöltéskor",
"Redirect to similar wiki page" => "Átirányítás hasonló wiki oldalra",
// "If a requested page doesn't exist, redirect to a similarly named page" => "If a requested page doesn't exist, redirect to a similarly named page",
// "Redirect to page alias, if any" => "Redirect to page alias, if any",
// "If a requested page doesn't exist, redirect to an alias page, if specified using an alias semantic link" => "If a requested page doesn't exist, redirect to an alias page, if specified using an alias semantic link",
"User's page" => "Felhasználói oldal",
"Show user's information on mouseover" => "Felhasználói információk megjelenítése egér felhasználói név felé mozgatásakor",
"Requires user's information to be public" => "A felhasználói információknak publikusnak kell lennie",
"Default feed format" => "Alapértelmezett feed formátum",
// "ATOM 1.0" => "ATOM 1.0",
// "RSS 2.0" => "RSS 2.0",
"Feed author name" => "Feed szerző neve",
"This field is mandatory unless both feed author email and homepage are empty." => "Ez a mező kötelező, kivéve ha a feed szerző e-mail és honlap mezők üresek",
"Feeed author email" => "Feed szerző e-mail",
"Feed author homepage" => "Feed szerző honlapja",
"Feed editor email" => "Feed szerkesztő  e-mail",
// "Email address for person responsible for editorial content" => "Email address for person responsible for editorial content",
"Feed webmaster email" => "Feed webmester e-mail",
// "Email address for person responsible for technical issues relating to channel" => "Email address for person responsible for technical issues relating to channel",
// "Feed Image path" => "Feed Image path",
// "Specifies a GIF, JPEG or PNG image that can be displayed with the feed" => "Specifies a GIF, JPEG or PNG image that can be displayed with the feed",
// "Feed Language" => "Feed Language",
"RSS basic Authentication" => "RSS azonosítás",
// "Propose basic http authentication if the user has no permission to see the feed" => "Propose basic http authentication if the user has no permission to see the feed",
// "Feed Caching time" => "Feed Caching time",
"seconds" => "másodperc",
"Use 0 for no caching" => "0 esetén nincs cache",
// "Feed caching is done for anonymous users only" => "Feed caching is done for anonymous users only",
// "RSS for articles" => "RSS for articles",
// "RSS feeds for articles" => "RSS feeds for articles",
// "RSS for blogs" => "RSS for blogs",
// "RSS feeds for blogs" => "RSS feeds for blogs",
// "RSS for individual blogs" => "RSS for individual blogs",
// "RSS feed for individual blogs" => "RSS feed for individual blogs",
// "RSS for image galleries" => "RSS for image galleries",
// "RSS feed for image galleries" => "RSS feed for image galleries",
// "RSS for individual image galleries" => "RSS for individual image galleries",
// "RSS feed for individual image galleries" => "RSS feed for individual image galleries",
// "RSS for file galleries" => "RSS for file galleries",
// "RSS feed for file galleries" => "RSS feed for file galleries",
// "RSS for individual file galleries" => "RSS for individual file galleries",
// "RSS feed for individual file galleries" => "RSS feed for individual file galleries",
// "RSS for wiki pages" => "RSS for wiki pages",
// "RSS feed for wiki" => "RSS feed for wiki",
// "RSS for forums" => "RSS for forums",
// "RSS feed for forums" => "RSS feed for forums",
// "RSS for individual forums" => "RSS for individual forums",
// "RSS feed for individual forums" => "RSS feed for individual forums",
// "RSS per tracker" => "RSS per tracker",
// "RSS feed per tracker" => "RSS feed per tracker",
// "RSS for calendar events" => "RSS for calendar events",
// "RSS feed for calendar events" => "RSS feed for calendar events",
// "RSS for directories" => "RSS for directories",
// "RSS feed for directories" => "RSS feed for directories",
// "RSS for shoutbox" => "RSS for shoutbox",
// "RSS feed for shoutbox" => "RSS feed for shoutbox",
"Maximum number of items to display" => "Megjelenítendő tételek maximális száma",
"Show Author" => "Szerző megjelenítése",
// "Homepage URL" => "Homepage URL",
// "Tiki RSS feed for articles" => "Tiki RSS feed for articles",
// "Tiki RSS feed for weblogs" => "Tiki RSS feed for weblogs",
// "Title to be prepended to the blog title for all blogs. If this field is empty only the blog title will be used" => "Title to be prepended to the blog title for all blogs. If this field is empty only the blog title will be used",
// "Tiki RSS feed for image galleries" => "Tiki RSS feed for image galleries",
// "Tiki RSS feed for the image gallery: " => "Tiki RSS feed for the image gallery: ",
// "Tiki RSS feed for file galleries" => "Tiki RSS feed for file galleries",
// "Tiki RSS feed for the file gallery: " => "Tiki RSS feed for the file gallery: ",
// "Tiki RSS feed for the wiki pages" => "Tiki RSS feed for the wiki pages",
// "Tiki RSS feed for forums" => "Tiki RSS feed for forums",
// "Tiki RSS feed for forum: " => "Tiki RSS feed for forum: ",
// "Tiki RSS feed for individual trackers: " => "Tiki RSS feed for individual trackers: ",
// "Tiki RSS feed for calendars" => "Tiki RSS feed for calendars",
// "Tiki RSS feed for directory sites" => "Tiki RSS feed for directory sites",
// "Tiki RSS feed for shoutbox messages" => "Tiki RSS feed for shoutbox messages",
"Article RSS Description" => "Cikk RSS leírása",
// "Description to be published as part of the RSS feed for articles" => "Description to be published as part of the RSS feed for articles",
"Last articles" => "Legutóbbi cikkek",
"Blogs RSS Description" => "Blogok RSS leírása",
// "Description to be published as part of the RSS feed for blogs" => "Description to be published as part of the RSS feed for blogs",
// "Last posts to weblogs" => "Last posts to weblogs",
"Blog RSS Description" => "Blog RSS leírás",
// "Description to be prepended to the blog description and published as part of the RSS feed for individual blogs. If this field is empty only the blog description will be used" => "Description to be prepended to the blog description and published as part of the RSS feed for individual blogs. If this field is empty only the blog description will be used",
"Image galleries RSS Description" => "Képgalériák RSS leírása",
// "Description to be published as part of the RSS feed for image galleries" => "Description to be published as part of the RSS feed for image galleries",
// "Last images uploaded to the image galleries" => "Last images uploaded to the image galleries",
"Individual image galleries RSS Description" => "Egyedi képgalériák RSS leírása",
// "Description to be published as part of the RSS feed for individual image galleries" => "Description to be published as part of the RSS feed for individual image galleries",
// "Last images uploaded to this image gallery. " => "Last images uploaded to this image gallery. ",
"File galleries RSS Description" => "Fájlgalériák RSS leírása",
// "Description to be published as part of the RSS feed for file galleries" => "Description to be published as part of the RSS feed for file galleries",
// "Last files uploaded to the file galleries" => "Last files uploaded to the file galleries",
"Individual file galleries RSS Description" => "Egyedi fájlgalériák RSS leírása",
// "Description to be published as part of the RSS feed for individual file galleries" => "Description to be published as part of the RSS feed for individual file galleries",
// "Last files uploaded to this file gallery. " => "Last files uploaded to this file gallery. ",
"Wiki pages RSS Description" => "Wiki oldalak RSS leírása",
// "Description to be published as part of the RSS feed for wiki pages" => "Description to be published as part of the RSS feed for wiki pages",
// "Last modifications to the Wiki" => "Last modifications to the Wiki",
"Forums RSS Description" => "Fórumok RSS leírása",
// "Description to be published as part of the RSS feed for forums" => "Description to be published as part of the RSS feed for forums",
// "Last topics in forums" => "Last topics in forums",
"Individual forums RSS Description" => "Egyedi fórumok RSS leírása",
// "Description to be published as part of the RSS feed for individual forums" => "Description to be published as part of the RSS feed for individual forums",
// "Last posts to this forum. " => "Last posts to this forum. ",
"Individual trackers RSS Description" => "Egyedi űrlapok RSS leírása",
// "Description to be published as part of the RSS feed for individual trackers" => "Description to be published as part of the RSS feed for individual trackers",
// "Last items published on this tracker" => "Last items published on this tracker",
"Calendar events RSS Description" => "Naptári események RSS leírása",
// "Description to be published as part of the RSS feed for calendar events" => "Description to be published as part of the RSS feed for calendar events",
"Upcoming Events" => "Jövőbeli események",
"Directories RSS Description" => "Linktárak RSS leírása",
// "Description to be published as part of the RSS feed for directories" => "Description to be published as part of the RSS feed for directories",
// "Last sites" => "Last sites",
"Shoutbox RSS Description" => "Üzenőfal RSS leírása",
// "Description to be published as part of the RSS feed for shoutbox messages" => "Description to be published as part of the RSS feed for shoutbox messages",
// "Last shoutbox messages" => "Last shoutbox messages",
"Podcast directory" => "Podcast könyvtár",
"The server must be able to read/write the directory." => "A szervernek tudnia kell olvasni/írni a könyvtárat",
"Required for podcasts" => "Podcastokhoz szükséges",
"If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload files in that dir, either by scp, ftp, or other protocols" => "Ha bekapcsoljuk a Kötegelt könyvtár feltöltést akkor létre kell hoznunk egy weben keresztül olvasható könyvtárat, lehetőleg a webes könyvtárterületen kívűl. Ezután hozzunk létre egy módszert a feltöltés végrehajtására (scp, ftp vagy más protokoll)",
"The server must be able to read the directory." => "A szervernek tudnia kell olvasni könyvtárat",
"The directory can be outside the web space." => "A könyvtár lehet a webes területen kívűl",
"Prevent download if score becomes negative" => "Letöltés tiltása ha a pontszám negatív",
"Allow download limit per file" => "Fájlonkénti letöltési limit engedélyezése",
"Allow same file to be uploaded more than once" => "Egyazon fájl többszöri feltöltésének engedélyezése",
"Yes, even in the same gallery" => "Igen, még ugyanabba a galériába is",
"Only in different galleries" => "Csak más galériákba",
// "Display zip option in gallery" => "Display zip option in gallery",
// "Display in the gallery the zip option (in upload and gallery file)" => "Display in the gallery the zip option (in upload and gallery file)",
// "Upload progressbar" => "Upload progressbar",
// "Ajax / Flash (Browser-based)" => "Ajax / Flash (Browser-based)",
"Must match" => "Egyeznie kell",
"Cannot match" => "Nem egyezhet",
// "Quota for all the files and archives" => "Quota for all the files and archives",
"Mb" => "Mb",
// "(0 for unlimited)" => "(0 for unlimited)",
// "Quota can be defined for each file gallery" => "Quota can be defined for each file gallery",
// "Default quota for each new gallery" => "Default quota for each new gallery",
// "Show quota bar in the list page" => "Show quota bar in the list page",
// "Yes, display bar and detail text" => "Yes, display bar and detail text",
// "Yes, display only bar" => "Yes, display only bar",
// "Yes, display only text" => "Yes, display only text",
"Storage" => "Tárolás",
"Store in database" => "Tárolás adatbázisban",
"Store in directory" => "Tárolás könyvtárban",
// "Path to store files in the file gallery" => "Path to store files in the file gallery",
// "Include the search box on the current gallery files just after the find div" => "Include the search box on the current gallery files just after the find div",
// "Include a search box on file galleries" => "Include a search box on file galleries",
// "Display hits with a ratio between hits / maxhits" => "Display hits with a ratio between hits / maxhits",
// "Display properties in the context menu" => "Display properties in the context menu",
// "Display replace menu in context menu" => "Display replace menu in context menu",
// "Automatic deletion of old files" => "Automatic deletion of old files",
// "The user will have an option when uploading a file to specify the time after which the file is deleted" => "The user will have an option when uploading a file to specify the time after which the file is deleted",
// "Allow action on multiple files or galleries" => "Allow action on multiple files or galleries",
// "The check button on file gallery can be remove" => "The check button on file gallery can be remove",
// "Deletion emails notification" => "Deletion emails notification",
// "These emails will receive a copy of each deleted file. Emails are separated with comma" => "These emails will receive a copy of each deleted file. Emails are separated with comma",
// "Keep the same fileId for the latest version of a file" => "Keep the same fileId for the latest version of a file",
// "If checked, the fileId of the latest version of a file stays the same. Link to a file will always give you the latest version. If not checked, the fileId is attached to the file for ever, link to file will give you the precise version of a file" => "If checked, the fileId of the latest version of a file stays the same. Link to a file will always give you the latest version. If not checked, the fileId is attached to the file for ever, link to file will give you the precise version of a file",
// "Show thumbnail actions" => "Show thumbnail actions",
// "Show the checkbox and wrench icon for file actions menu when not displaying details" => "Show the checkbox and wrench icon for file actions menu when not displaying details",
// "Max thumbnail size" => "Max thumbnail size",
// "Maximum width or height for image thumbnails" => "Maximum width or height for image thumbnails",
// "In pixels" => "In pixels",
// "Automatic indexing of file content" => "Automatic indexing of file content",
// "Uses command line tools to extract the information from the files based on their MIME types" => "Uses command line tools to extract the information from the files based on their MIME types",
// "Upload files from remote source" => "Upload files from remote source",
// "Allow to create files in file galleries using a URL that will be polled for new revisions" => "Allow to create files in file galleries using a URL that will be polled for new revisions",
// "Remote source refresh frequency limit" => "Remote source refresh frequency limit",
// "Minimum amount of seconds to be ellapsed between source checks to prevent flooding servers" => "Minimum amount of seconds to be ellapsed between source checks to prevent flooding servers",
// "Display controls to attempt refresh" => "Display controls to attempt refresh",
// "Let users trigger a refresh attempt from the remote host" => "Let users trigger a refresh attempt from the remote host",
// "Allow searching for existing files in the tracker files field" => "Allow searching for existing files in the tracker files field",
// "Search files using the search index" => "Search files using the search index",
// "Fix mime types based on file suffix" => "Fix mime types based on file suffix",
// "Fixes mime type of image files based on file suffixes when they are incorrectly detected as application/octet-stream" => "Fixes mime type of image files based on file suffixes when they are incorrectly detected as application/octet-stream",
// "Max Name Length" => "Max Name Length",
// "Length to truncate file names to in browse view" => "Length to truncate file names to in browse view",
// "Set a directory on your server. Ex.: /var/www/  It's recommended that this directory not be web accessible. PHP must be able to read/write to the directory" => "Set a directory on your server. Ex.: /var/www/  It's recommended that this directory not be web accessible. PHP must be able to read/write to the directory",
// "Revision Approval" => "Revision Approval",
// "Uses flagged revisions to hide unapproved wiki page revisions from users with lower privileges" => "Uses flagged revisions to hide unapproved wiki page revisions from users with lower privileges",
// "Revision Approval Categories" => "Revision Approval Categories",
// "List of category IDs on which revision approval is required" => "List of category IDs on which revision approval is required",
// "Footer shadow start" => "Footer shadow start",
// "Footer shadow end" => "Footer shadow end",
"Uploaded filenames must match regex" => "A feltöltött fájl nevének egyeznie kell a kifejezéssel",
// "Manage thread defaults per-forum" => "Manage thread defaults per-forum",
// "Display thread configuration bar" => "Display thread configuration bar",
"Allows users to override the defaults" => "Felhasználók felülírhatják az alapértelmezéseket",
// "Display thread configuration bar only when number of posts exceed" => "Display thread configuration bar only when number of posts exceed",
"Keep settings for all forums during the user session" => "Beállítások megtartása az összes fórumban a felhasználói munkamenet alatt",
"Default style" => "Alapértelmezett stílus",
"Plain" => "Normál",
"Threaded" => "Témák",
"Headers Only" => "Csak a fejlécek látszanak",
"Default sort mode" => "Alapértelmezett rendezési mód",
"Title (desc)" => "Cím (csökk)",
"Title (asc)" => "Cím (növ)",
"Topics" => "Témák",
"Posts per day" => "Napi posztok száma",
"Last post" => "Legutóbbi poszt",
"Description length" => "Leírás hossza",
// "Hide titles for forum threads" => "Hide titles for forum threads",
// "Most titles are left untouched because they are a direct reply to the parent thread. This feature hides the title altogether from the forms and display" => "Most titles are left untouched because they are a direct reply to the parent thread. This feature hides the title altogether from the forms and display",
// "Force title in reply" => "Force title in reply",
// "Shows a blank title box and requires it to be filled before submission of forum post" => "Shows a blank title box and requires it to be filled before submission of forum post",
"Do not prefix messages titles by 'Re: '" => "Az üzenetek ne kapjanak 'Re:' előtagot",
"Creation Date (asc)" => "Létrehozás dátuma (növ.)",
"Topics (desc)" => "Témák (csökk)",
"Threads (desc)" => "Fórumtémák (csökk)",
"Last post (desc)" => "Legutóbbi poszt (csökk)",
"Name (desc)" => "Név (csökk)",
"Name (asc)" => "Név (növ)",
"Multilingual tags" => "Többnyelvű címkék",
// "Permits translation management of tags" => "Permits translation management of tags",
"Show tag cloud" => "Címke felhő megjelenítése",
"Maximum number of tags in cloud" => "Címkék maximális száma a felhőben",
"Show freetags in middle column" => "Szabad címkék (freetagek) megjelenítése a középső oszlopban",
"Preload freetag random tag" => "Véletlenszerű freetag előtöltése",
"Number of Tags to show in Tag Suggestions" => "Címke javaslatok között megjelenítendő címkék száma",
"Valid characters pattern" => "Érvényes kartakterek mintája",
"Lowercase tags only" => "Csak kisbetűs címkék",
"Enable freetags 3D browser" => "3D címkeböngésző bekapcsolása",
// "3D autoload" => "3D autoload",
"Browser width" => "Böngésző szélessége",
"Browser height" => "Böngésző magassága",
"Navigation depth" => "Navigáció mélysége",
"Node size" => "Csopont méret",
"Text size" => "Szöveg méret",
// "Spring (connection) size" => "Spring (connection) size",
// "Existing page node color" => "Existing page node color",
// "Missing page node color" => "Missing page node color",
"Camera distance adjusted relative to nearest node" => "Kamera távolság hozzáigazítva a legközelebbi csomóponthoz",
"Camera distance" => "Kamera távolság",
"Field of view" => "Nézet mező",
// "Feed animation interval (milisecs)" => "Feed animation interval (milisecs)",
// "Friction constant" => "Friction constant",
"Elastic constant" => "Elasztikai konstans",
// "Electrostatic constant" => "Electrostatic constant",
// "Node mass" => "Node mass",
// "Node charge" => "Node charge",
// "Include \"Generate Password\" option on registration form" => "Include \"Generate Password\" option on registration form",
// "Geolocate wiki pages" => "Geolocate wiki pages",
// "Provide controls to geolocate wiki pages from the edit functionality" => "Provide controls to geolocate wiki pages from the edit functionality",
// "Geolocate articles" => "Geolocate articles",
// "Provide controls to geolocate articles from the edit functionality" => "Provide controls to geolocate articles from the edit functionality",
// "Geolocate blog posts" => "Geolocate blog posts",
// "Provide controls to geolocate blog posts from the edit functionality" => "Provide controls to geolocate blog posts from the edit functionality",
// "Available tile layers on maps" => "Available tile layers on maps",
// "Allows to replace the default OpenStreetMap tiles for tiles from other mapping services, such as Google or Bing" => "Allows to replace the default OpenStreetMap tiles for tiles from other mapping services, such as Google or Bing",
// "Valid options are: %0" => "Valid options are: %0",
// "Google Street View" => "Google Street View",
// "Open up Google Street View in a window to see the visible coordinates" => "Open up Google Street View in a window to see the visible coordinates",
// "Google Street View Overlay" => "Google Street View Overlay",
// "This is not guaranteed to work" => "This is not guaranteed to work",
// "Always load OpenLayers" => "Always load OpenLayers",
// "Load the OpenLayers library even if no map is explicitly included in the page" => "Load the OpenLayers library even if no map is explicitly included in the page",
// "Style of the site, sometimes called a skin or CSS. See http://themes.tiki.org for more Tiki themes" => "Style of the site, sometimes called a skin or CSS. See http://themes.tiki.org for more Tiki themes",
"Browser title" => "Böngésző címsora",
// "Label visible in the browser's title bar on all pages. Also appears in search engines" => "Label visible in the browser's title bar on all pages. Also appears in search engines",
// "Validate new user registrations by email" => "Validate new user registrations by email",
// "Upon registration, the new user will receive an email containing a link to confirm validity" => "Upon registration, the new user will receive an email containing a link to confirm validity",
"Home page" => "Kezdőlap",
// "Landing page used for the wiki when no page is specified. The page will be created if it does not exist" => "Landing page used for the wiki when no page is specified. The page will be created if it does not exist",
"Use group homepages" => "Csoportkezdőlapok használata",
// "Users can be sent to different pages upon login, depending on their default group" => "Users can be sent to different pages upon login, depending on their default group",
"Go to group homepage only if login from default homepage" => "Csak akkor menjen a csoportkezdőlapra ha a bejelentkezés az alapértelmezett kezdőlapról történt",
"Default language" => "Alapértelmezett nyelv",
// "Site language used when no other language is specified by the user" => "Site language used when no other language is specified by the user",
"Cache external pages" => "Külső oldalak cache-elése",
"Cache external images" => "Külső képek cache-elése",
"Temporary directory" => "Ideiglenes könyvtár",
// "Tiki requires full read and write access to this directory" => "Tiki requires full read and write access to this directory",
"Help URL" => "Súgó URL",
// "The default help system may not be complete. You can help with the Tiki documentation" => "The default help system may not be complete. You can help with the Tiki documentation",
"Open external links in new window" => "Külső linkek megnyitása új ablakban",
"License page" => "Licensz lap",
"Submit notice" => "Megjegyzés küldése",
"Full path to gdaltindex" => "Teljes útvonal a gdaltindex-hez",
"Full path to ogr2ogr" => "Teljes útvonal az ogr2ogr-hoz",
"Map Zone" => "Térkép zóna",
"Display modules to all groups always" => "Minden modult mindig mutasson minden csoportnak",
"Hide anonymous-only modules from registered users" => "A csak anonim látogatók számára megjelenítésre kerülő modulok elrejtése a regisztrált felhasználók elől",
// "Hide anonymous-only modules from Admins" => "Hide anonymous-only modules from Admins",
"Maximum number of articles on articles home page" => "Cikkek maximális száma a cikkek kezdőlapján",
// "Site Ads and Banners Content" => "Site Ads and Banners Content",
"Test" => "Teszt",
// "URL to go to when clicking on a username" => "URL to go to when clicking on a username",
"Default" => "Alapértelmezés",
// "Use %user% for login name and %userId% for userId)" => "Use %user% for login name and %userId% for userId)",
// "Forgot password" => "Forgot password",
// "Users can request to reset password. They will receive a link by email" => "Users can request to reset password. They will receive a link by email",
"Each group can have its theme" => "Minden csoportnak saját stílusa lehet",
"Site title" => "Weblap címe",
"Subtitle" => "Alcím",
"Maximum number of records in listings" => "A rekordok maximum száma listázásnál",
"Maximum number of versions:" => "Verziók maximális száma:",
// "0 for unlimited versions" => "0 for unlimited versions",
"Users can register" => "A felhasználók regisztrálhatnak",
// "Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server" => "Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server",
// "Require validation by Admin" => "Require validation by Admin",
// "The administrator will receive an email for each new user registration, and must validate the user before the user can login" => "The administrator will receive an email for each new user registration, and must validate the user before the user can login",
// "Require passcode to register" => "Require passcode to register",
// "Users must enter a code to register.  You must inform users of this code. Use to restrict registration to invited users only" => "Users must enter a code to register.  You must inform users of this code. Use to restrict registration to invited users only",
"Passcode" => "Belépési kód",
// "Alphanumeric code required to complete the registration" => "Alphanumeric code required to complete the registration",
// "Show passcode on registration form" => "Show passcode on registration form",
"Use tracker to collect more user information" => "Űrlap használata további felhasználói információk gyűjtéséhez",
// "Display a tracker (form) for the user to complete, as part of the registration process. Use this tracker to store additional information about each user" => "Display a tracker (form) for the user to complete, as part of the registration process. Use this tracker to store additional information about each user",
// "Use the \"Admin Groups\" page to select which tracker and fields to display" => "Use the \"Admin Groups\" page to select which tracker and fields to display",
// "Use tracker to collect more group information" => "Use tracker to collect more group information",
// "Create a new group for each user" => "Create a new group for each user",
// "Synchronize Tiki groups with a directory" => "Synchronize Tiki groups with a directory",
// "Define the directory within the \"LDAP\" tab" => "Define the directory within the \"LDAP\" tab",
// "Synchronize Tiki users with a directory" => "Synchronize Tiki users with a directory",
"Remember me" => "Emlékezz rám",
"Duration" => "Időtartam",
"hour" => "óra",
"hours" => "óra",
"day" => "nap",
"week" => "hét",
"month" => "hónap",
"year" => "év",
// "Use custom homepage" => "Use custom homepage",
// "Use a Tiki feature homepage or another homepage" => "Use a Tiki feature homepage or another homepage",
"Use Tiki feature as homepage" => "Tiki funkció használata kezdőlapként",
// "Select the Tiki feature to use as the site homepage. Only enabled features are listed" => "Select the Tiki feature to use as the site homepage. Only enabled features are listed",
// "Disable JavaScript" => "Disable JavaScript",
// "Disable JavaScript for testing purpose even if the browser allows it" => "Disable JavaScript for testing purpose even if the browser allows it",
// "Partner ID" => "Partner ID",
// "Kaltura Partner ID" => "Kaltura Partner ID",
"User secret" => "Felhasználói titok",
// "Kaltura partner setting user secret" => "Kaltura partner setting user secret",
"Admin secret" => "Adminisztrátori titok",
// "Kaltura partner setting admin secret" => "Kaltura partner setting admin secret",
"KDP UI Configuration ID" => "KDP UI konfiguráció ID",
// "Kaltura Dynamic Player (KDP) user interface configuration ID" => "Kaltura Dynamic Player (KDP) user interface configuration ID",
// "KDP Widget ID" => "KDP Widget ID",
// "Kaltura Dynamic Player (KDP) Widget ID. This configuration is specific to your account" => "Kaltura Dynamic Player (KDP) Widget ID. This configuration is specific to your account",
"KCW UI Configuration ID" => "KCW UI konfiguráció ID",
// "Kaltura Configuration Wizard (KCW) user interface configuration ID" => "Kaltura Configuration Wizard (KCW) user interface configuration ID",
// "Kaltura Simple Editor UI Configuration ID" => "Kaltura Simple Editor UI Configuration ID",
// "Kaltura Advanced Editor UI Configuration ID" => "Kaltura Advanced Editor UI Configuration ID",
"Kaltura \"User\"" => "Kaltura \"Felhasználó\"",
// "Owner of content shared by all Tiki users on this site. If empty then each Tiki user can only see their own media entries" => "Owner of content shared by all Tiki users on this site. If empty then each Tiki user can only see their own media entries",
"Kaltura Service URL" => "Kaltura szolgáltatás URL",
// "e.g. http://www.kaltura.com/" => "e.g. http://www.kaltura.com/",
// "Set blogs homepage first" => "Set blogs homepage first",
// "Set Image gal homepage first" => "Set Image gal homepage first",
"File Gallery:" => "Fájlgaléria:",
// "Set Forum homepage first" => "Set Forum homepage first",
"Forum:" => "Fórum:",
"Custom home" => "Egyedi kezdőlap",
// "Since passwords are encrypted, it's not possible to tell the user what the password is. It's only possible to change it" => "Since passwords are encrypted, it's not possible to tell the user what the password is. It's only possible to change it",
// "Validate user's email server" => "Validate user's email server",
// "Displays the required passcode on the registration form. This is helpful for legitimate users who want to register while making it difficult for automated robots because the passcode is unique for each site and because it is displayed in JavaScript" => "Displays the required passcode on the registration form. This is helpful for legitimate users who want to register while making it difficult for automated robots because the passcode is unique for each site and because it is displayed in JavaScript",
// "The group will be named identical to the user's username" => "The group will be named identical to the user's username",
"User's choice" => "Felhasználó választása",
// "If you don't know better, use '_yourPartnerID'" => "If you don't know better, use '_yourPartnerID'",
// "You could use your server name for this. e.g. %0" => "You could use your server name for this. e.g. %0",
// "Google Maps API Key" => "Google Maps API Key",
"Default x for map center" => "Alapértelmezett x koordináta a térkép közepéhez",
// "Default y for map center" => "Default y for map center",
"Default zoom level" => "Alapértelmezett zoom szint",
"whole earth" => "teljes Föld",
"country size" => "ország méret",
"city size" => "város méret",
// "village size" => "village size",
"max zoom" => "maximális zoom",
// "Show map mode buttons in articles list" => "Show map mode buttons in articles list",
// "Show map mode buttons in page list" => "Show map mode buttons in page list",
// "Header shadow start" => "Header shadow start",
// "Header shadow end" => "Header shadow end",
"Custom CSS" => "CSS testreszabása",
// "Includes a custom block of CSS inline in all pages" => "Includes a custom block of CSS inline in all pages",
// "Custom JavaScript" => "Custom JavaScript",
// "Includes a custom block of inline JavaScript in all pages" => "Includes a custom block of inline JavaScript in all pages",
// "Do not include the <script> and </script> tags" => "Do not include the <script> and </script> tags",
"Highlight group" => "Csoport kiemelése",
"Home Blog (main blog)" => "Kezdőblog (fő blog)",
"Home Forum (main forum)" => "Kezdő fórum (fő fórum)",
// "Home File Gallery (main file gallery)" => "Home File Gallery (main file gallery)",
"Home Gallery (main gallery)" => "Kezdőgaléria (fő galéria)",
// "No image gallery available (create one first)" => "No image gallery available (create one first)",
// "No file gallery available (create one first)" => "No file gallery available (create one first)",
// "No forum available (create one first)" => "No forum available (create one first)",
// "No blog available (create one first)" => "No blog available (create one first)",
"HTTP port" => "HTTP port",
// "If left empty, port 80 will be used" => "If left empty, port 80 will be used",
// "HTTP Lookup Skip Framesets" => "HTTP Lookup Skip Framesets",
// "When performing and HTTP request to an external source, verify if the result is a frameset and use heuristic to provide the real content" => "When performing and HTTP request to an external source, verify if the result is a frameset and use heuristic to provide the real content",
// "Registration referrer check" => "Registration referrer check",
// "Use the HTTP referrer to check registration POST is sent from same host. (May not work on some setups.)" => "Use the HTTP referrer to check registration POST is sent from same host. (May not work on some setups.)",
// "Use HTTPS when building user-specific links" => "Use HTTPS when building user-specific links",
// "When building notification emails, RSS feeds or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server" => "When building notification emails, RSS feeds or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server",
"HTTPS port" => "HTTPS port",
// "If left empty, port 443 will be used" => "If left empty, port 443 will be used",
// "Use HTTPS login" => "Use HTTPS login",
// "Increase security by allowing to transmit authentication credentials over SSL. Certificates must be configured on the server" => "Increase security by allowing to transmit authentication credentials over SSL. Certificates must be configured on the server",
"Allow secure (https) login" => "Biztonságos (https) bejelentkezés engedélyezése",
"Encourage secure (https) login" => "Biztonságos (https) bejelentkezés bátorítása",
// "Consider we are always in HTTPS, but do not check" => "Consider we are always in HTTPS, but do not check",
"Require secure (https) login" => "Biztonságos (https) bejelentkezés szükséges",
// "Do not require HTTPS until you have setup and tested the connection, otherwise, you will make your whole site unaccessible" => "Do not require HTTPS until you have setup and tested the connection, otherwise, you will make your whole site unaccessible",
// "CSS selectors to be fixed" => "CSS selectors to be fixed",
// "Separate multiple elements with a comma (,)" => "Separate multiple elements with a comma (,)",
"HTMLDomElements to be fixed" => "Fixálandó HTMLDomElements",
// "IP can be checked" => "IP can be checked",
// "Check anonymous votes by user's IP" => "Check anonymous votes by user's IP",
// "Use CDN for JavaScript" => "Use CDN for JavaScript",
// "Obtain jQuery and jQuery UI libraries through a content delivery network" => "Obtain jQuery and jQuery UI libraries through a content delivery network",
// "Google (supports SSL via HTTPS)" => "Google (supports SSL via HTTPS)",
// "jQuery" => "jQuery",
// "Slide" => "Slide",
"Fade" => "Előtűnés",
// "Blind (UI)" => "Blind (UI)",
// "Clip (UI)" => "Clip (UI)",
// "Drop (UI)" => "Drop (UI)",
// "Explode (UI)" => "Explode (UI)",
// "Fold (UI)" => "Fold (UI)",
// "Puff (UI)" => "Puff (UI)",
// "Slide (UI)" => "Slide (UI)",
// "Effect for modules" => "Effect for modules",
"Effect for tabs" => "Effektus fülekhez",
"Speed" => "Sebesség",
"Fast" => "Gyors",
"Normal" => "Normál",
"Slow" => "Lassú",
"Direction" => "Irány",
"Vertical" => "Vertikális",
"Horizontal" => "Horizontális",
"Left" => "Bal",
"Right" => "Jobb",
"Up" => "Fel",
"Down" => "Le",
// "jQuery-ui Select Menu" => "jQuery-ui Select Menu",
// "Styled replacement for dropdown select menus" => "Styled replacement for dropdown select menus",
// "Use Select Menu on all select elements" => "Use Select Menu on all select elements",
// "Applies jQuery-ui Select Menu to every select menu" => "Applies jQuery-ui Select Menu to every select menu",
// "Experimental. This feature is under development" => "Experimental. This feature is under development",
"Never delete versions younger than" => "Ennél fiatalabb verziók nem törölhetőek",
"Use database for translation" => "Adatbázis használata fordításhoz",
// "Use the database to store the translated strings and allow using interactive translation" => "Use the database to store the translated strings and allow using interactive translation",
// "[%0|Edit or export/import Languages]" => "[%0|Edit or export/import Languages]",
"Language inclusion threshold" => "Nyelv küszöb",
// "When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages" => "When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages",
"Layout per section" => "Szekciónkénti kinézet",
// "Layout Width" => "Layout Width",
// "Constrains the site display width (default: 990px)" => "Constrains the site display width (default: 990px)",
// "ex.: 800px" => "ex.: 800px",
// "Users can choose not to have tabs" => "Users can choose not to have tabs",
// "Add group CSS info" => "Add group CSS info",
// "Add classes to the page BODY tag to indicate group membership" => "Add classes to the page BODY tag to indicate group membership",
// "Either grp_Anonymous or grp_Registered and possibly grp_Admins as well" => "Either grp_Anonymous or grp_Registered and possibly grp_Admins as well",
// "If user does not exist in Tiki" => "If user does not exist in Tiki",
// "Create the user" => "Create the user",
// "Deny access" => "Deny access",
// "Create user if not in LDAP" => "Create user if not in LDAP",
"Maximum average server load threshold in the last minute" => "Maximális átlagos szerver terheltség a legutóbbi percben",
"Log mail in Tiki logs" => "Levelek naplózása a Tiki logban",
"Smarty Template usage indicator" => "Smarty Template használat kijelzése",
// "Add HTML comment at start and end of each Smarty template (TPL)" => "Add HTML comment at start and end of each Smarty template (TPL)",
// "Use only for development, not in production because these warnings are added to emails as well, and visible to the users" => "Use only for development, not in production because these warnings are added to emails as well, and visible to the users",
// "You need to clear your Tiki template cache for this change to take effect" => "You need to clear your Tiki template cache for this change to take effect",
"Log SQL" => "SQL naplózása",
// "Log SQL queries" => "Log SQL queries",
// "Log queries using more than (seconds)" => "Log queries using more than (seconds)",
"This may impact performance" => "Ez hatással lehet a teljesítményre",
// "Use email as username" => "Use email as username",
// "Instead of creating new usernames, use the user's email address for authentication" => "Instead of creating new usernames, use the user's email address for authentication",
// "Obscure email when using email as username if possible (coverage will not be complete)" => "Obscure email when using email as username if possible (coverage will not be complete)",
// "This will attempt as much as possible to hide the email, showing the realname or the truncated email instead" => "This will attempt as much as possible to hide the email, showing the realname or the truncated email instead",
// "HTTP Basic Authentication" => "HTTP Basic Authentication",
// "Check credentials from HTTP Basic Authentication, useful to allow webservices to use credentials" => "Check credentials from HTTP Basic Authentication, useful to allow webservices to use credentials",
// "SSL Only (Recommended)" => "SSL Only (Recommended)",
"Long date format" => "Hosszú dátum formátum",
"Long time format" => "Hosszú időformátum",
// "%A %d of %B, %Y" => "%A %d of %B, %Y",
// "%H:%M:%S %Z" => "%H:%M:%S %Z",
// "%A %d of %B, %Y %H:%M:%S %Z" => "%A %d of %B, %Y %H:%M:%S %Z",
// "Force lowercase" => "Force lowercase",
"Mail end of line" => "Levél sor vég",
// "CRLF (standard)" => "CRLF (standard)",
"LF (some Unix MTA)" => "LF (Unix MTA féle)",
// "Main shadow start" => "Main shadow start",
// "Main shadow end" => "Main shadow end",
"full path to mapfiles" => "Teljes útvonal a térképfájlokhoz",
"Wiki Page for Help" => "Súgó wikioldal",
"Wiki Page for Comments" => "Kommentek wikioldala",
"Maximum length" => "Maximum hossz",
// "Memcache" => "Memcache",
// "Enable connection to memcached servers to store temporary information" => "Enable connection to memcached servers to store temporary information",
// "Requires the PHP memcache extension" => "Requires the PHP memcache extension",
"Memcache compression" => "Memcache tömörítés",
// "Enable compression for memcache storage" => "Enable compression for memcache storage",
"Memcache servers" => "Memcache szerverek",
// "Server list which may be accessed. For each server, the address, port and weight must be specified" => "Server list which may be accessed. For each server, the address, port and weight must be specified",
// "One per line. address:port (weight)" => "One per line. address:port (weight)",
"Memcache key prefix" => "Memcache kulcs prefix",
// "When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoiding conflicts" => "When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoiding conflicts",
"Memcache expiration" => "Memcache lejárat",
// "Duration for which the data will be kept" => "Duration for which the data will be kept",
// "Cache wiki data in memcache" => "Cache wiki data in memcache",
// "Cache wiki output in memcache" => "Cache wiki output in memcache",
// "Cache forum output in memcache" => "Cache forum output in memcache",
// "Menu icons" => "Menu icons",
// "Allows to define icons for menu entries" => "Allows to define icons for menu entries",
"Default path for the icons" => "Ikonok alapértelmezett útvonala",
// "Allow HTML in menu option names and URLs" => "Allow HTML in menu option names and URLs",
// "If enabled, menu option names and URL-s are treated as HTML content and they are not escaped (no replacement of HTML special characters). This allows the use of HTML to insert images for example. Code must be valid. This allows menu item editors to put arbitrary HTML; only enable if you know what you are doing" => "If enabled, menu option names and URL-s are treated as HTML content and they are not escaped (no replacement of HTML special characters). This allows the use of HTML to insert images for example. Code must be valid. This allows menu item editors to put arbitrary HTML; only enable if you know what you are doing",
// "REALLY allow HTML (INSECURE)" => "REALLY allow HTML (INSECURE)",
// "This needs to be checked for the parent preference to be actually enabled. This allows menu item editors to put arbitrary HTML, which could allow session hijacking; only enable if you know what you are doing" => "This needs to be checked for the parent preference to be actually enabled. This allows menu item editors to put arbitrary HTML, which could allow session hijacking; only enable if you know what you are doing",
"Maximum mailbox size (messages, 0=unlimited)" => "Levelezőfiók maximális mérete (üzenetek, 0=nincs határ)",
"Maximum mail archive size (messages, 0=unlimited)" => "Levél arhívum maximális mérete (üzenetek, 0=nincs határ)",
"Maximum sent box size (messages, 0=unlimited)" => "Elküldött levelek mappa maximális mérete (üzenetek, 0=nincs határ)",
"Keywords" => "Kulcsszavak",
// "A list of key words (separated by commas) that describe your site" => "A list of key words (separated by commas) that describe your site",
"Include freetags" => "Freetag-ek belefoglalása",
// "If the freetags feature is enabled, use the freetags in the meta keywords for each page with freetags set. This allows individual pages on the site to carry different meta tags" => "If the freetags feature is enabled, use the freetags in the meta keywords for each page with freetags set. This allows individual pages on the site to carry different meta tags",
"Use thread title instead" => "Thread használata inkább",
// "Use the forum thread title in the meta title tag" => "Use the forum thread title in the meta title tag",
"Use image title instead" => "Kép címének használat inkább",
// "Use the image title in the meta title tag" => "Use the image title in the meta title tag",
// "A short description of your site. Some search engines display this information with your site's listing" => "A short description of your site. Some search engines display this information with your site's listing",
// "Page Description" => "Page Description",
// "Use individual page description as a met tag for the page" => "Use individual page description as a met tag for the page",
// "The author of your site. Typically this will be the Admin or Webmaster" => "The author of your site. Typically this will be the Admin or Webmaster",
"geo.position" => "geo.position",
// "The latitude and longitude of the physical location of the site. For example \"38.898748, -77.037684\"" => "The latitude and longitude of the physical location of the site. For example \"38.898748, -77.037684\"",
"geo.region" => "geo.region",
// "The ISO-3166 Country and Region Codes for your location. For example, \"US-NY\"" => "The ISO-3166 Country and Region Codes for your location. For example, \"US-NY\"",
"geo.placename" => "geo.placename",
// "A free-text description of your location" => "A free-text description of your location",
"Meta robots" => "Meta robotok",
// "Specify how web-bots should index your site. Valid values include: INDEX or NOINDEX, and FOLLOW or NOFOLLOW" => "Specify how web-bots should index your site. Valid values include: INDEX or NOINDEX, and FOLLOW or NOFOLLOW",
"Revisit after" => "Újralátogatás ennyi után",
// "Specify how often (in days) web-bots should visit your site" => "Specify how often (in days) web-bots should visit your site",
// "Show past metrics results" => "Show past metrics results",
// "In the metrics dashboard, identify if the previously collected metrics should be displayed" => "In the metrics dashboard, identify if the previously collected metrics should be displayed",
// "Past metrics count" => "Past metrics count",
// "Amount of past results to display" => "Amount of past results to display",
// "No metric trend value" => "No metric trend value",
// "Value to display when no trend is available for the metric" => "Value to display when no trend is available for the metric",
// "Metric trend prefix" => "Metric trend prefix",
// "Portion of text to display before the metric trend value" => "Portion of text to display before the metric trend value",
// "Metric trend suffix" => "Metric trend suffix",
// "Portion of text to display after the metric trend value" => "Portion of text to display after the metric trend value",
// "Metric name length" => "Metric name length",
// "Metric tab name length" => "Metric tab name length",
// "Cache metrics output" => "Cache metrics output",
// "Most metrics are expensive to generate. Because they tend to evolve slowly, some delay between update and generation can be tolerated. Disabling cache is not recommended" => "Most metrics are expensive to generate. Because they tend to evolve slowly, some delay between update and generation can be tolerated. Disabling cache is not recommended",
// "Middle shadow start" => "Middle shadow start",
// "Middle shadow end" => "Middle shadow end",
"Minimum length" => "Minimum hossz",
// "Mobile Access" => "Mobile Access",
// "New mobile feature for Tiki 7" => "New mobile feature for Tiki 7",
// "Mobile Perspectives" => "Mobile Perspectives",
// "Header Theme" => "Header Theme",
// "jQuery Mobile Theme" => "jQuery Mobile Theme",
// "Content Theme" => "Content Theme",
// "Footer Theme" => "Footer Theme",
// "Modules Theme" => "Modules Theme",
// "Menus Theme" => "Menus Theme",
// "Use Latest Library" => "Use Latest Library",
// "Use latest version of the jquery.mobile" => "Use latest version of the jquery.mobile",
// "Uses latest build from jquery.com CDN" => "Uses latest build from jquery.com CDN",
// "Top module zone" => "Top module zone",
// "Visibility of area to keep modules such as logo, login etc (header)" => "Visibility of area to keep modules such as logo, login etc (header)",
// "Topbar module zone" => "Topbar module zone",
// "Visibility of area for modules such as main horizontal menu, search form, page-wide content, etc" => "Visibility of area for modules such as main horizontal menu, search form, page-wide content, etc",
// "topbar" => "topbar",
// "Page top module zone" => "Page top module zone",
// "Visibility of area to keep modules such as share etc" => "Visibility of area to keep modules such as share etc",
// "Bottom module zone" => "Bottom module zone",
// "Visibility of area to keep modules such as \"powered by\" and \"rss list\" (footer)" => "Visibility of area to keep modules such as \"powered by\" and \"rss list\" (footer)",
// "Page bottom module zone" => "Page bottom module zone",
// "Visibility of area to keep modules at the foot of each page" => "Visibility of area to keep modules at the foot of each page",
// "\"More Like This\" algorithm" => "\"More Like This\" algorithm",
"Minimum number of tags in common" => "Közös címkék miniális száma",
// "Multi-domain" => "Multi-domain",
// "Allows to map domain names to perspectives and simulate multiple domains hosted on the same instance" => "Allows to map domain names to perspectives and simulate multiple domains hosted on the same instance",
"Multi-domain Configuration" => "Multi-domain konfiguráció",
// "Comma-separated values mapping the domain name to the perspective ID" => "Comma-separated values mapping the domain name to the perspective ID",
"One domain per line. Comma separated with perspective ID. Ex.: tiki.org,1" => "Egy domain soronként vesszővel elválasztva perspektíva ID-val. Példa: tiki.org,1",
// "Switch domain when switching perspective" => "Switch domain when switching perspective",
// "Remember that different domains have different login sessions and even in the case of subdomains you need to have an understanding of session cookies to make it work" => "Remember that different domains have different login sessions and even in the case of subdomains you need to have an understanding of session cookies to make it work",
// "Throttle newsletter send rate" => "Throttle newsletter send rate",
// "Pause for a given amount of seconds before each batch to avoid overloading the mail server" => "Pause for a given amount of seconds before each batch to avoid overloading the mail server",
// "Newsletter pause length" => "Newsletter pause length",
// "Amount of seconds on wait before each batch" => "Amount of seconds on wait before each batch",
// "Newsletter batch size" => "Newsletter batch size",
// "Amount of emails to send in each batch" => "Amount of emails to send in each batch",
// "Allow sending newsletters through external clients" => "Allow sending newsletters through external clients",
// "Generate mailto links using the recipients as the BCC list" => "Generate mailto links using the recipients as the BCC list",
// "This will expose the list if email addresses to all users allowed to send newsletters" => "This will expose the list if email addresses to all users allowed to send newsletters",
"Use relative (next / previous) pagination links" => "Relatív (következő/előző) oldalléptetési linkek használata",
"Wiki buttons" => "Wiki gombok",
"Page description, icons, backlinks, .." => "Oldal leírása, ikonok, backlinkek, ..",
"Top " => "Fent",
"Bottom" => "Lent",
"Neither" => "Egyik sem",
"A page can occur multiple times in a structure" => "Egy oldal többször is előfordulhat egy struktúrában",
"Display fast move links (by 10 percent of the total number of pages) " => "Gyorsugrási linkek megjelnítése (az oldalak teljes számának 10%-ánál) ",
"Hide pagination when there is only one page" => "Oldalléptetés elrejtése ha csak egy oldal van",
"Use Icons" => "Ikonok használata",
"Display 'First' and 'Last' links" => "'Első' és 'Utolsó' linkek megjelenítése",
"PAM service" => "PAM szolgáltatás",
"Currently unused" => "Jelenleg nem használt",
// "Require characters and numerals" => "Require characters and numerals",
// "For improved security, require users to include a mix of characters and numerals in passwords" => "For improved security, require users to include a mix of characters and numerals in passwords",
// "Password expires after" => "Password expires after",
// "Require alphabetical characters in lower and upper case" => "Require alphabetical characters in lower and upper case",
// "Password must contain at least one alphabetical character in lower case like a and one in upper case like A" => "Password must contain at least one alphabetical character in lower case like a and one in upper case like A",
// "Require special characters" => "Require special characters",
// "Password must contain at least one special character in lower case like \" / \$ % ? & * ( ) _ + .." => "Password must contain at least one special character in lower case like \" / \$ % ? & * ( ) _ + ..",
// "Require no consecutive repetition of the same character" => "Require no consecutive repetition of the same character",
// "Password must contain no consecutive repetition of the same character as 111 or aab" => "Password must contain no consecutive repetition of the same character as 111 or aab",
// "Password must be different from the user login" => "Password must be different from the user login",
"Payment" => "Fizetés",
// "Feature to manage and track payment requests" => "Feature to manage and track payment requests",
// "Payment System" => "Payment System",
// "Currently a choice between PayPal, and Cclite (in development), or Tiki User Credits" => "Currently a choice between PayPal, and Cclite (in development), or Tiki User Credits",
// "PayPal: see PayPal.com - Cclite: Community currency" => "PayPal: see PayPal.com - Cclite: Community currency",
// "PayPal" => "PayPal",
// "Cclite" => "Cclite",
// "Paypal Business ID" => "Paypal Business ID",
// "Enable payments through paypal" => "Enable payments through paypal",
"Email address" => "E-mail cím",
// "Paypal Environment" => "Paypal Environment",
// "Used to switch between the paypal sandbox, used for testing and development and the live environment" => "Used to switch between the paypal sandbox, used for testing and development and the live environment",
// "Production" => "Production",
// "Paypal Instant Payment Notification (IPN)" => "Paypal Instant Payment Notification (IPN)",
// "Enable IPN for automatic payment completion. When enabled, Paypal will ping back the site when a payment is confirmed. The payment will then be entered automatically. This may not be possible if the server is not on a public server" => "Enable IPN for automatic payment completion. When enabled, Paypal will ping back the site when a payment is confirmed. The payment will then be entered automatically. This may not be possible if the server is not on a public server",
// "Currency used when entering payments" => "Currency used when entering payments",
// "Default acceptable payment delay" => "Default acceptable payment delay",
// "Amount of days before the payment requests becomes overdue. This can be changed per payment request" => "Amount of days before the payment requests becomes overdue. This can be changed per payment request",
// "Cclite Registries" => "Cclite Registries",
// "Registries in Cclite" => "Registries in Cclite",
// "Registry names in Cclite" => "Registry names in Cclite",
// "Cclite Registry Currencies" => "Cclite Registry Currencies",
// "Currencies in Cclite" => "Currencies in Cclite",
// "Each registry in Cclite can have it's own currency. Must be one per registry. (case sensitive)" => "Each registry in Cclite can have it's own currency. Must be one per registry. (case sensitive)",
// "Cclite Server URL" => "Cclite Server URL",
// "Full URL of the repository" => "Full URL of the repository",
// "e.g. https://cclite.yourdomain.org/cclite/" => "e.g. https://cclite.yourdomain.org/cclite/",
// "Cclite Merchant Key" => "Cclite Merchant Key",
// "Corresponds with Merchant Key setting in Cclite" => "Corresponds with Merchant Key setting in Cclite",
// "Cclite Merchant User" => "Cclite Merchant User",
// "User name in Cclite representing \"the management\". Defaults to \"manager\"" => "User name in Cclite representing \"the management\". Defaults to \"manager\"",
// "Cclite Enable Payments" => "Cclite Enable Payments",
// "Test or Live operation" => "Test or Live operation",
// "Live" => "Live",
// "Hashing Algorithm" => "Hashing Algorithm",
// "Encryption type" => "Encryption type",
// "SHA1" => "SHA1",
// "SHA256" => "SHA256",
// "SHA512" => "SHA512",
// "Cclite Payment Notification" => "Cclite Payment Notification",
// "TODO" => "TODO",
// "Wiki page containing the instruction to send manual payment like check" => "Wiki page containing the instruction to send manual payment like check",
"Wiki page" => "Wiki lap",
// "Prefix to the invoice" => "Prefix to the invoice",
// "Prefix must be set and unique if the same paypal account is used for different tiki sites as paypal checks that the invoice is not paid twice" => "Prefix must be set and unique if the same paypal account is used for different tiki sites as paypal checks that the invoice is not paid twice",
// "Types of credit to use" => "Types of credit to use",
// "This is a list of the types of Tiki user credits to accept to pay with" => "This is a list of the types of Tiki user credits to accept to pay with",
// "Exchange rate for types of credit to use" => "Exchange rate for types of credit to use",
// "This is a corresponding list of amount of credits equivalent to 1 of the payment currency" => "This is a corresponding list of amount of credits equivalent to 1 of the payment currency",
// "User can only see his own outstanding payments" => "User can only see his own outstanding payments",
// "Unless with administer payment permissions, a user can only see his own outstanding payments" => "Unless with administer payment permissions, a user can only see his own outstanding payments",
// "User can only see his own past or cancelled payments" => "User can only see his own past or cancelled payments",
// "Unless with administer payment permissions, a user can only see his own past or cancelled payments" => "Unless with administer payment permissions, a user can only see his own past or cancelled payments",
// "Manage product inventory" => "Manage product inventory",
// "Activate product inventory feature, needs Products tracker to be set up properly, the itemId must be the product code" => "Activate product inventory feature, needs Products tracker to be set up properly, the itemId must be the product code",
// "Products Tracker ID" => "Products Tracker ID",
// "Tracker ID of tracker that is the Products tracker, needed for advanced cart features, the itemId will be the product code" => "Tracker ID of tracker that is the Products tracker, needed for advanced cart features, the itemId will be the product code",
// "Products Tracker Name" => "Products Tracker Name",
// "Name of tracker that is the Products tracker, needed for advanced cart features, the itemId will be the product code" => "Name of tracker that is the Products tracker, needed for advanced cart features, the itemId will be the product code",
// "Inventory Type Field ID" => "Inventory Type Field ID",
// "Field ID in Products tracker to store the inventory type, the value of the field must be \"none\" or \"internal\"" => "Field ID in Products tracker to store the inventory type, the value of the field must be \"none\" or \"internal\"",
// "Inventory Total Field ID" => "Inventory Total Field ID",
// "Field ID in Products tracker to store the total inventory of product" => "Field ID in Products tracker to store the total inventory of product",
// "Inventory Total Less Hold Field ID" => "Inventory Total Less Hold Field ID",
// "Field ID in Products tracker to store the total inventory of product less the amount on hold because they are currently in carts" => "Field ID in Products tracker to store the total inventory of product less the amount on hold because they are currently in carts",
// "Inventory Hold Timeout (minutes)" => "Inventory Hold Timeout (minutes)",
// "Minutes to hold inventory before making it available again when there is no user cart action" => "Minutes to hold inventory before making it available again when there is no user cart action",
// "Bundled products feature for cart" => "Bundled products feature for cart",
// "Activate bundled products feature, needs Products tracker to be set up properly, the itemId must be the product code" => "Activate bundled products feature, needs Products tracker to be set up properly, the itemId must be the product code",
// "Product Name Field Name" => "Product Name Field Name",
// "Field Name in Products tracker of the product name that will be used as the label of the product, e.g. in a bundle" => "Field Name in Products tracker of the product name that will be used as the label of the product, e.g. in a bundle",
// "Items in Bundle Field Name" => "Items in Bundle Field Name",
// "Field Name in Products tracker of a comma separated list of product IDs of products in the bundle (i.e. if the field contains anything, then this product is a bundle), you can also specify the number of the sub-products, e.g. 23:(\"colon\")2,24 means item 23 (x2) + item 24 (x1)" => "Field Name in Products tracker of a comma separated list of product IDs of products in the bundle (i.e. if the field contains anything, then this product is a bundle), you can also specify the number of the sub-products, e.g. 23:(\"colon\")2,24 means item 23 (x2) + item 24 (x1)",
// "Product Price Field Name" => "Product Price Field Name",
// "Field Name in Products tracker of the product price" => "Field Name in Products tracker of the product price",
// "Associated Event ID Field Name" => "Associated Event ID Field Name",
// "Field Name in Products tracker of the Associated Event ID, needed for the Associated Events cart feature, requires an Events tracker to be setup where the item ID there is the event ID to associate to" => "Field Name in Products tracker of the Associated Event ID, needed for the Associated Events cart feature, requires an Events tracker to be setup where the item ID there is the event ID to associate to",
// "Product Class ID Field Name" => "Product Class ID Field Name",
// "Field Name in Products tracker of the Product Class ID, needed for the Gift Certificates cart feature" => "Field Name in Products tracker of the Product Class ID, needed for the Gift Certificates cart feature",
// "Gift Certificate Template Field Name" => "Gift Certificate Template Field Name",
// "Field Name in Products tracker of the Gift Cert Template, needed for the Gift Certificates cart feature" => "Field Name in Products tracker of the Gift Cert Template, needed for the Gift Certificates cart feature",
// "Record cart orders in trackers (registered users)" => "Record cart orders in trackers (registered users)",
// "This feature requires 2 trackers, and Orders tracker and an Orders Item tracker to be configured. It also needs profiles to be configured to do the recording" => "This feature requires 2 trackers, and Orders tracker and an Orders Item tracker to be configured. It also needs profiles to be configured to do the recording",
// "Orders Profile" => "Orders Profile",
// "Wiki page where the profile for creating orders is (page name must be without spaces)" => "Wiki page where the profile for creating orders is (page name must be without spaces)",
// "Order Item Profile" => "Order Item Profile",
// "Wiki page where the profile for creating orders items is (page name must be without spaces)" => "Wiki page where the profile for creating orders items is (page name must be without spaces)",
// "Allow anonymous shopping and record their orders in trackers" => "Allow anonymous shopping and record their orders in trackers",
// "Allows shopping as anonymous user" => "Allows shopping as anonymous user",
// "Anonymous Orders Profile" => "Anonymous Orders Profile",
// "Wiki page where the profile for creating orders for Anonymous users is (page name must be without spaces)" => "Wiki page where the profile for creating orders for Anonymous users is (page name must be without spaces)",
// "Anonymous Order Item Profile" => "Anonymous Order Item Profile",
// "Wiki page where the profile for creating orders items for Anonymous users is (page name must be without spaces)" => "Wiki page where the profile for creating orders items for Anonymous users is (page name must be without spaces)",
// "Anonymous Shopper Info Profile" => "Anonymous Shopper Info Profile",
// "Anonymous Users Order Review Page" => "Anonymous Users Order Review Page",
// "Wiki page where Anonymous users can review their orders)" => "Wiki page where Anonymous users can review their orders)",
// "Temporary Shopper Group to Access Review Page via Token" => "Temporary Shopper Group to Access Review Page via Token",
// "Group name of group with perms to access review page via token" => "Group name of group with perms to access review page via token",
// "Allow association of product orders to events (or projects etc...)" => "Allow association of product orders to events (or projects etc...)",
// "Allow association of products to events (or projects etc...)" => "Allow association of products to events (or projects etc...)",
// "Events Tracker ID" => "Events Tracker ID",
// "Tracker ID of tracker that is the Events tracker" => "Tracker ID of tracker that is the Events tracker",
// "Events Tracker Name" => "Events Tracker Name",
// "Name of tracker that is the Events tracker" => "Name of tracker that is the Events tracker",
// "Event Start Field Name" => "Event Start Field Name",
// "Field Name in Events tracker of start date/time" => "Field Name in Events tracker of start date/time",
// "Event End Field Name" => "Event End Field Name",
// "Field Name in Events tracker of end date/time" => "Field Name in Events tracker of end date/time",
// "Allow exchange of products" => "Allow exchange of products",
// "Order Items Tracker ID" => "Order Items Tracker ID",
// "Tracker ID of tracker that is the Order Items tracker" => "Tracker ID of tracker that is the Order Items tracker",
// "Gift certificates" => "Gift certificates",
// "Gift Certificates" => "Gift Certificates",
// "Gift Certificate Tracker ID" => "Gift Certificate Tracker ID",
// "Tracker ID of tracker that is the Gift Certificate tracker" => "Tracker ID of tracker that is the Gift Certificate tracker",
// "Gift Certificate Tracker Name" => "Gift Certificate Tracker Name",
// "Name of tracker that is the Gift Certificate tracker" => "Name of tracker that is the Gift Certificate tracker",
// "Orders Tracker Name" => "Orders Tracker Name",
// "Name of tracker that is the Orders tracker" => "Name of tracker that is the Orders tracker",
// "Order Items Tracker Name" => "Order Items Tracker Name",
// "Name of tracker that is the Order Items tracker" => "Name of tracker that is the Order Items tracker",
// "Product Classes Tracker Name" => "Product Classes Tracker Name",
// "Name of tracker that is the Product Classes tracker" => "Name of tracker that is the Product Classes tracker",
"Send to URL" => "Küldés erre az URL-re",
"On permission denied, display login module (for Anonymous)" => "Jogosultság hiány esetén a bejelentkezési  modul megjelenítése anonim felhasználóknak",
// "PHP libxml extension" => "PHP libxml extension",
// "This extension requires the libxml PHP extension.\n\t\t\t\t\t\t\tThis means that passing in --enable-libxml is also required, although this is\n\t\t\t\t\t\t\timplicitly accomplished because libxml is enabled by default" => "This extension requires the libxml PHP extension.\n\t\t\t\t\t\t\tThis means that passing in --enable-libxml is also required, although this is\n\t\t\t\t\t\t\timplicitly accomplished because libxml is enabled by default",
// "PHP DateTime" => "PHP DateTime",
// "DateTime class (and related functions) are enabled\n\t\t\t\t\t\t\tby default since PHP 5.2.0, it is possible to add experimental support into PHP\n\t\t\t\t\t\t\t5.1.x by using the following flag before configure/compile:\n\t\t\t\t\t\t\tCFLAGS=-DEXPERIMENTAL_DATE_SUPPORT=1" => "DateTime class (and related functions) are enabled\n\t\t\t\t\t\t\tby default since PHP 5.2.0, it is possible to add experimental support into PHP\n\t\t\t\t\t\t\t5.1.x by using the following flag before configure/compile:\n\t\t\t\t\t\t\tCFLAGS=-DEXPERIMENTAL_DATE_SUPPORT=1",
"Show categories" => "Kategóriák megjelenítése",
"Show objects" => "Objektumok megjelenítése",
// "Multiple polls per object" => "Multiple polls per object",
// "When used with the rating features, allow multiple polls to be attached to a single object" => "When used with the rating features, allow multiple polls to be attached to a single object",
// "PDF from URL" => "PDF from URL",
// "Using extenal tools, generate PDF document from web URLs" => "Using extenal tools, generate PDF document from web URLs",
// "WebKit (wkhtmltopdf)" => "WebKit (wkhtmltopdf)",
// "Webservice URL" => "Webservice URL",
// "URL to a service taking a URL as the query string and returns a PDF document" => "URL to a service taking a URL as the query string and returns a PDF document",
// "WebKit path" => "WebKit path",
// "Full path to the wkhtmltopdf executable to generate the PDF document with" => "Full path to the wkhtmltopdf executable to generate the PDF document with",
"Repository URLs" => "Gyűjtemény URLek",
// "List of URLs for the profile repositories that will be used" => "List of URLs for the profile repositories that will be used",
"Enter multiple repository URLs, one per line" => "Több gyűjtemény URL megadása, soronként egy",
"Data Channels" => "Adat csatornák",
// "Data channels are templates that can be applied from a post request. They can be used to automate work on more complex installations" => "Data channels are templates that can be applied from a post request. They can be used to automate work on more complex installations",
// "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain __channel name, domain, profile, allowed groups, (optional) \$profilerequest:input\$ matches to groups__" => "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain __channel name, domain, profile, allowed groups, (optional) \$profilerequest:input\$ matches to groups__",
// "There are security considerations related to using data channels. Make sure the profile page is controlled by administrators only" => "There are security considerations related to using data channels. Make sure the profile page is controlled by administrators only",
// "Developer mode" => "Developer mode",
// "For profiles under an approval workflow, always use the latest version, even if not approved" => "For profiles under an approval workflow, always use the latest version, even if not approved",
// "Make sure you review the profiles you install" => "Make sure you review the profiles you install",
// "Proxy host name" => "Proxy host name",
// "Proxy host - without http:// or similar, just the host name" => "Proxy host - without http:// or similar, just the host name",
"Proxy port" => "Proxy Port",
// "Proxy username" => "Proxy username",
// "Proxy password" => "Proxy password",
"Quantify change size" => "Méret változásának számszerűsítése",
// "In addition to tracking the changes, track the change size and display the approximate up-to-date-ness of the page" => "In addition to tracking the changes, track the change size and display the approximate up-to-date-ness of the page",
"Advanced Rating" => "Értékelés",
// "Rating system allowing for options and calculation method to be configured" => "Rating system allowing for options and calculation method to be configured",
// "Rating recalculation mode" => "Rating recalculation mode",
// "Determines when and how rating aggregates are recalculated. Depending on the site load, some options may be preferred to others. On large volume sites, it should be done as a cron job. On vote recalculation may be inaccurate if rating calculation depends time" => "Determines when and how rating aggregates are recalculated. Depending on the site load, some options may be preferred to others. On large volume sites, it should be done as a cron job. On vote recalculation may be inaccurate if rating calculation depends time",
// "Recalculate on vote" => "Recalculate on vote",
// "Randomly recalculate oldest ratings (on load)" => "Randomly recalculate oldest ratings (on load)",
// "Randomly recalculate oldest ratings (on vote)" => "Randomly recalculate oldest ratings (on vote)",
// "Cron job (must be set manually)" => "Cron job (must be set manually)",
// "Recalculation odds (1 in X)" => "Recalculation odds (1 in X)",
// "Dice roll performed on every request. When successful, will recalculate a certain number of votes" => "Dice roll performed on every request. When successful, will recalculate a certain number of votes",
// "Recalculation count" => "Recalculation count",
// "How many ratings should be recalculated when odds strike" => "How many ratings should be recalculated when odds strike",
// "Use ReCaptcha" => "Use ReCaptcha",
// "Use ReCaptcha, a specialized captcha service, instead of default CAPTCHA" => "Use ReCaptcha, a specialized captcha service, instead of default CAPTCHA",
// "You will need to register at [http://www.google.com/recaptcha]" => "You will need to register at [http://www.google.com/recaptcha]",
// "Public Key" => "Public Key",
// "ReCaptcha public key" => "ReCaptcha public key",
// "Private Key" => "Private Key",
// "ReCaptcha private key" => "ReCaptcha private key",
"Record untranslated strings" => "Nem lefordítottak rögzítése",
// "Keep track of the unsuccessful attemps to translate strings" => "Keep track of the unsuccessful attemps to translate strings",
"Restrict supported languages" => "Támogatott nyelvek korlátozása",
// "Limit the languages made available on the site" => "Limit the languages made available on the site",
// "SCORM Support" => "SCORM Support",
// "Handle SCORM package files on upload. SCORM is a standard used in Learning Management Systems" => "Handle SCORM package files on upload. SCORM is a standard used in Learning Management Systems",
// "SCORM Tracker" => "SCORM Tracker",
// "Tracker ID to use to store the SCORM metadata" => "Tracker ID to use to store the SCORM metadata",
"Parse the results" => "Eredmények elemzése",
// "Default where" => "Default where",
// "When object filter is not on, limit to search one type of object" => "When object filter is not on, limit to search one type of object",
// "Entire site" => "Entire site",
"Wiki Pages" => "Wiki oldalak",
"Blog Posts" => "Blogposztok",
"Tracker Items" => "Űrlap tételek",
"Spreadsheets" => "Táblázatok",
"Restrict search language by default" => "Keresési nyelv korlátozása alapértelmezésben",
// "If enabled, only search content in the interface language, otherwise show language menu" => "If enabled, only search content in the interface language, otherwise show language menu",
// "Autocomplete on page names" => "Autocomplete on page names",
// "Category filter" => "Category filter",
// "Tag filter" => "Tag filter",
// "Parse wiki syntax in comments in all sections apart from Forums" => "Parse wiki syntax in comments in all sections apart from Forums",
// "Use \"Accept wiki syntax\" for forums in admin forums page" => "Use \"Accept wiki syntax\" for forums in admin forums page",
"Sender email" => "Levélküldési E-mail cím",
// "Email address that will be used as the sender for outgoing emails" => "Email address that will be used as the sender for outgoing emails",
"Time zone" => "Időzóna",
// "Indicates the default time zone to use for the server" => "Indicates the default time zone to use for the server",
"Session storage location" => "Munkamenet tárolásának helye",
// "Select where the session information should be stored. Memcache sessions require memcache to be configured" => "Select where the session information should be stored. Memcache sessions require memcache to be configured",
"Default (from php.ini)" => "Alapértelmezés (php.ini-ből)",
"Database" => "Adatbázis",
"Session lifetime" => "Munkamenet ideje",
// "Value provided in minutes. It will be the minimum time you are logged in. If you want it to be the exact time, you need to adjust in .htaccess session.gc_probability and session.gc_divisor to 1. Be careful that changing the probability will affect the server performance" => "Value provided in minutes. It will be the minimum time you are logged in. If you want it to be the exact time, you need to adjust in .htaccess session.gc_probability and session.gc_divisor to 1. Be careful that changing the probability will affect the server performance",
"Silent session" => "Csendes munkamenet",
// "Do not automatically start sessions" => "Do not automatically start sessions",
// "Users will only have a session if they log in. So anonymous users will lose the capacity to have things like Switch Language (a session is needed for this)" => "Users will only have a session if they log in. So anonymous users will lose the capacity to have things like Switch Language (a session is needed for this)",
"Session cookie name" => "Munkamenet cookie név",
// "Session cookie name used instead of the PHP default configuration" => "Session cookie name used instead of the PHP default configuration",
// "Protect all sessions with HTTPS" => "Protect all sessions with HTTPS",
// "Always redirect to HTTPS to prevent session hijack through network sniffing" => "Always redirect to HTTPS to prevent session hijack through network sniffing",
// "Only activate if you have already configured SSL, otherwise, your will lock yourself out of Tiki" => "Only activate if you have already configured SSL, otherwise, your will lock yourself out of Tiki",
// "Display links in the share page" => "Display links in the share page",
// "Token notification" => "Token notification",
// "Users can subscribe to the notifications of consultation of the token" => "Users can subscribe to the notifications of consultation of the token",
// "Add contact" => "Add contact",
// "If not exist, recipients are add in the list of contacts" => "If not exist, recipients are add in the list of contacts",
// "Display name and email" => "Display name and email",
// "If user is connect, name and email display in the page" => "If user is connect, name and email display in the page",
// "How many times accessed" => "How many times accessed",
// "User can choose how many times the share page can be consulted" => "User can choose how many times the share page can be consulted",
// "Max how many times accessed" => "Max how many times accessed",
// "Maximum number of times that the shared page can be consulted" => "Maximum number of times that the shared page can be consulted",
"Default group" => "Alapértelmezett csoport",
// "Create with default group" => "Create with default group",
// "Valid affiliations" => "Valid affiliations",
// "Separate multiple affiliations with commas" => "Separate multiple affiliations with commas",
// "Shipping Service" => "Shipping Service",
// "Expose a JSON shipping rate estimation service. Accounts from providers may be required (FedEx, UPS, ...)" => "Expose a JSON shipping rate estimation service. Accounts from providers may be required (FedEx, UPS, ...)",
// "FedEx API" => "FedEx API",
// "Enable shipping rate calculation through FedEx APIs" => "Enable shipping rate calculation through FedEx APIs",
// "FedEx Key" => "FedEx Key",
// "Developer Key" => "Developer Key",
// "FedEx Password" => "FedEx Password",
// "FedEx Meter Number" => "FedEx Meter Number",
// "FedEx Account Number" => "FedEx Account Number",
// "UPS API" => "UPS API",
// "Enable shipping rate calculation using the UPS carrier" => "Enable shipping rate calculation using the UPS carrier",
// "UPS Username" => "UPS Username",
// "UPS credentials" => "UPS credentials",
// "UPS Password" => "UPS Password",
// "UPS Access Key" => "UPS Access Key",
// "Custom Shipping Provider" => "Custom Shipping Provider",
"Short date format" => "Rövid dátum formátum",
"Short time format" => "Rövid időformátum",
// "%Y-%m-%d" => "%Y-%m-%d",
// "%H:%M" => "%H:%M",
// "%Y-%m-%d %H:%M" => "%Y-%m-%d %H:%M",
"Display available translations" => "Rendelkezésre álló fordítások megjelenítése",
// "" => "",
// "Close site (except for those with permission)" => "Close site (except for those with permission)",
"Message to display" => "Megjelenítendő üzenet",
// "Locations (breadcrumbs)" => "Locations (breadcrumbs)",
"Choices" => "Választási lehetőségek",
"Site title location" => "Weblap nevének elhelyezkedése",
// "Location of the site title in the browser title bar relative to the current page's descriptor" => "Location of the site title in the browser title bar relative to the current page's descriptor",
"After" => "Után",
// "Before" => "Before",
"Browser title display mode" => "Böngésző címsor megjelenítési módja",
// "When breadcrumbs are used, method in which the browser title should be displayed" => "When breadcrumbs are used, method in which the browser title should be displayed",
"Most specific first" => "Először a legspecifikusabb",
"Least specific first (site)" => "Legkevésbé specifikus először (oldal)",
// "Current only" => "Current only",
// "Favicon icon file name" => "Favicon icon file name",
// "Favicon MIME type" => "Favicon MIME type",
// "Typical file extensions:<table><tr><td>image/jpeg</td><td><strong>.jpg</strong></td></tr><tr><td>imp/png</td><td><strong>.png</strong></td></tr><tr><td>img/gif</td><td><strong>.gif</strong></td></tr><tr><td>image/vnd.microsoft.icon</td><td><strong>.ico</strong></td></tr></table>" => "Typical file extensions:<table><tr><td>image/jpeg</td><td><strong>.jpg</strong></td></tr><tr><td>imp/png</td><td><strong>.png</strong></td></tr><tr><td>img/gif</td><td><strong>.gif</strong></td></tr><tr><td>image/vnd.microsoft.icon</td><td><strong>.ico</strong></td></tr></table>",
// "image/jpeg" => "image/jpeg",
"image/png" => "kép/png",
// "image/gif" => "image/gif",
// "image/vnd.microsoft.icon" => "image/vnd.microsoft.icon",
// "Site Terminal" => "Site Terminal",
// "Allows to direct users to a specific perspective depending on the origin IP address. Can be used inside intranets to use different configurations for users depending on their departements or discriminate people in web contexts. Unspecified IPs will fall back to default behavior, including multi-domain handling. Manually selected perspectives take precedence over this" => "Allows to direct users to a specific perspective depending on the origin IP address. Can be used inside intranets to use different configurations for users depending on their departements or discriminate people in web contexts. Unspecified IPs will fall back to default behavior, including multi-domain handling. Manually selected perspectives take precedence over this",
// "Site Terminal Configuration" => "Site Terminal Configuration",
// "Provides the mapping from subnets to perspective" => "Provides the mapping from subnets to perspective",
// "One per line. Network prefix in CIDR notation (address/mask size), separated by comma with the perspective ID" => "One per line. Network prefix in CIDR notation (address/mask size), separated by comma with the perspective ID",
"Publish" => "Publikálás",
// "Logo source (image path)" => "Logo source (image path)",
// "Logo background color" => "Logo background color",
"Examples:" => "Példák:",
"Logo title (on mouse over)" => "Logó neve (egér rámozgatására jelenik meg)",
"Alt. description (e.g. for text browsers)" => "Képleírás (pld szöveges böngészés számára)",
// "Include smarty notices in PHP error report" => "Include smarty notices in PHP error report",
// "In most cases, smarty notices can be safely ignored. However, they may be useful in the development process when strange issues occur" => "In most cases, smarty notices can be safely ignored. However, they may be useful in the development process when strange issues occur",
"Smarty Security" => "Smarty biztonság",
// "Do not allow php code in smarty templates" => "Do not allow php code in smarty templates",
// "You should leave this on unless you know what you are doing" => "You should leave this on unless you know what you are doing",
"Smarty Compilation" => "Smarty forgatás",
// "Indicates when the template cache should be refreshed" => "Indicates when the template cache should be refreshed",
"Modified" => "Módosítva",
"Never check (performance)" => "Sose ellenőrizze (teljesítmény)",
"Always (development, slow)" => "Mindig (fejlesztés, lassú)",
"Consumer key" => "Ügyfél kulcs",
// "Consumer key generated by registering your site as an application at Twitter" => "Consumer key generated by registering your site as an application at Twitter",
"Consumer secret" => "Ügyfél titok",
// "Consumer secret generated by registering your site as an application at Twitter" => "Consumer secret generated by registering your site as an application at Twitter",
"Application secret" => "Alkalmazás titok",
// "Application secret generated by registering your site as an application at Facebook" => "Application secret generated by registering your site as an application at Facebook",
"Application ID" => "Alkalmazás ID",
// "Application id generated by registering your site as an application at Facebook" => "Application id generated by registering your site as an application at Facebook",
"Login using Facebook" => "Bejelentkezés Facebook-on keresztül",
// "Allow users to login using Facebook" => "Allow users to login using Facebook",
"Auto-create Tiki user" => "Tiki felhasználó automatikus létrehozása",
// "Automatically create a Tiki user by the username of fb_xxxxxxxx for users logging in using Facebook if they do not yet have a Tiki account. If not, they will be asked to link or register a Tiki account" => "Automatically create a Tiki user by the username of fb_xxxxxxxx for users logging in using Facebook if they do not yet have a Tiki account. If not, they will be asked to link or register a Tiki account",
"Require Facebook users to enter local account info" => "Facebook felhasználóknak kötelező megadniuk a helyi fiók adatokat",
// "Require Facebook users to enter local account info, specifically email and local login name" => "Require Facebook users to enter local account info, specifically email and local login name",
"Tiki can access Facebook at any time" => "Tiki mindig beléphet a Facebook-ra",
// "Even when user is not logged onto Facebook, Tiki can access it" => "Even when user is not logged onto Facebook, Tiki can access it",
"Tiki can post to Wall" => "Tiki posztolhat az üzenőfalra",
// "Tiki may post status messages, notes, photos, and videos to Facebook Wall" => "Tiki may post status messages, notes, photos, and videos to Facebook Wall",
"Tiki can manage events" => "Tiki kezelhet eseményeket",
// "Tiki may create and RSVP to Facebook events" => "Tiki may create and RSVP to Facebook events",
"Tiki can manage pages" => "Tiki kezelheti az oldalakat",
// "Tiki may manage user pages" => "Tiki may manage user pages",
"Tiki can SMS" => "Tiki küldhet SMS-t",
// "Tiki may SMS via Facebook" => "Tiki may SMS via Facebook",
"bit.ly Login" => "bit.ly felhasználó név",
// "Site wide login (username) for bit.ly" => "Site wide login (username) for bit.ly",
"bit.ly Key" => "bit.ly kulcs",
// "Site wide API key for bit.ly" => "Site wide API key for bit.ly",
"Use site-wide account" => "Egész weblapra kiterjedő fiók használata",
// "When setting this option to yes, only the site wide account will be used for all users" => "When setting this option to yes, only the site wide account will be used for all users",
"Theme options" => "Stílus opciók",
// "Style options" => "Style options",
// "New.." => "New..",
// "Theme Generator" => "Theme Generator",
// "Permits to adjust colors and fonts via the browser" => "Permits to adjust colors and fonts via the browser",
// "Custom Theme" => "Custom Theme",
// "Description needed" => "Description needed",
"Check frequency" => "Ellenőrzés gyakorisága",
"Each day" => "Minden nap",
"Each week" => "Minden héten",
"Each month" => "Minden hónapban",
// "Minify JavaScript" => "Minify JavaScript",
// "Compress JavaScript files used in the page into a single file to be distributed statically. Changes to JavaScript files will require cache to be cleared. Uses http://code.google.com/p/minify/" => "Compress JavaScript files used in the page into a single file to be distributed statically. Changes to JavaScript files will require cache to be cleared. Uses http://code.google.com/p/minify/",
// "Minify CSS" => "Minify CSS",
// "Compress CSS files by removing additional spaces and grouping multiple files into one. Changes to CSS files will require cache to be cleared. Uses http://code.google.com/p/minify/" => "Compress CSS files by removing additional spaces and grouping multiple files into one. Changes to CSS files will require cache to be cleared. Uses http://code.google.com/p/minify/",
// "Minify CSS into a single file" => "Minify CSS into a single file",
// "In addition to reducing the size of the CSS, reduce the number of included files" => "In addition to reducing the size of the CSS, reduce the number of included files",
// "This setting may not work out of the box for all styles. import needs to use @import url(\"...\") and not @import \"...\"" => "This setting may not work out of the box for all styles. import needs to use @import url(\"...\") and not @import \"...\"",
"Skip date for same day" => "Dátum kihagyása ugyanazon nap esetén",
// "When displaying short date and time, skip date for today. Only time will be displayed" => "When displaying short date and time, skip date for today. Only time will be displayed",
"Cache-Control header" => "Cache-Control fejléc",
// "Custom HTTP header to use when a session is active" => "Custom HTTP header to use when a session is active",
// "Example: no-cache, pre-check=0, post-check=0" => "Example: no-cache, pre-check=0, post-check=0",
// "Cache-Control header (no session)" => "Cache-Control header (no session)",
// "Custom HTTP header to use when no session is active" => "Custom HTTP header to use when no session is active",
// "Content Delivery Network" => "Content Delivery Network",
// "Use an alternate domain name to serve static files from tiki to avoid sending cookies, improve local caching and generally improve user experience performance" => "Use an alternate domain name to serve static files from tiki to avoid sending cookies, improve local caching and generally improve user experience performance",
// "Prefix to include before the static files, for example: http://cdn.example.com" => "Prefix to include before the static files, for example: http://cdn.example.com",
// "Content Delivery Network (in SSL)" => "Content Delivery Network (in SSL)",
// "Use an alternate domain name to serve static files from tiki to avoid sending cookies, improve local caching and generally improve user experience performance. Leave empty to disable CDN in SSL mode" => "Use an alternate domain name to serve static files from tiki to avoid sending cookies, improve local caching and generally improve user experience performance. Leave empty to disable CDN in SSL mode",
// "Prefix to include before the static files, for example: https://cdn.example.com" => "Prefix to include before the static files, for example: https://cdn.example.com",
// "Domain prefix handling" => "Domain prefix handling",
// "Strip or automatically add the \"www.\" prefix on domain names to standardize URLs" => "Strip or automatically add the \"www.\" prefix on domain names to standardize URLs",
// "Leave as-is" => "Leave as-is",
"Remove the www" => "www eltávolítása",
"Add the www" => "www hozzáadása",
"Domain redirects" => "Domain átirányítások",
// "When the site is accessed through specific domain names, redirect to an alternate domain preserving the URL. Useful for domain name transitions, like tikiwiki.org to tiki.org" => "When the site is accessed through specific domain names, redirect to an alternate domain preserving the URL. Useful for domain name transitions, like tikiwiki.org to tiki.org",
// "One entry per line. Comma separated list: old, new" => "One entry per line. Comma separated list: old, new",
// "Validate uploaded file content" => "Validate uploaded file content",
// "Do not trust user input and open the files to verify their content" => "Do not trust user input and open the files to verify their content",
// "Allow the tiki_p_trust_input permission" => "Allow the tiki_p_trust_input permission",
// "Bypasses user input filtering" => "Bypasses user input filtering",
// "Note, all permissions are granted to the Admins group including this one, so if you enable this you may expose your site to XSS (Cross Site Scripting) attacks for admin users" => "Note, all permissions are granted to the Admins group including this one, so if you enable this you may expose your site to XSS (Cross Site Scripting) attacks for admin users",
// "Synchronize Remote Tracker" => "Synchronize Remote Tracker",
// "Allows to clone a tracker on a remote host and synchronize the data locally on demand" => "Allows to clone a tracker on a remote host and synchronize the data locally on demand",
// "Refresh item link items when master is modified" => "Refresh item link items when master is modified",
// "To be used when item link is used in trackers so that the index remains in good shape when data on the master that is indexed with the detail is modified and used to search on" => "To be used when item link is used in trackers so that the index remains in good shape when data on the master that is indexed with the detail is modified and used to search on",
// "Unified Search Engine" => "Unified Search Engine",
// "Search engine used to index the content of your Tiki. Some engines are more suitable for larger sites, but require additional software on the server" => "Search engine used to index the content of your Tiki. Some engines are more suitable for larger sites, but require additional software on the server",
// "Lucene (PHP Implementation)" => "Lucene (PHP Implementation)",
// "Lucene Index Location" => "Lucene Index Location",
// "Path to the location of the Lucene search index. The index must be on a local filesystem with enough space to contain the volume of the database" => "Path to the location of the Lucene search index. The index must be on a local filesystem with enough space to contain the volume of the database",
// "Highlight results snippets" => "Highlight results snippets",
// "Highlight the result snippet based on the search query. Enabling this option will impact performance, but improve user experience" => "Highlight the result snippet based on the search query. Enabling this option will impact performance, but improve user experience",
// "Lucene Maximum Results" => "Lucene Maximum Results",
// "Maximum amount of results to expose. Results further than these will need a more refined query to be reached" => "Maximum amount of results to expose. Results further than these will need a more refined query to be reached",
// "Lucene Maximum Result Set Limit" => "Lucene Maximum Result Set Limit",
// "Maximum size of result set to consider. Default 1000, 0 = unlimited" => "Maximum size of result set to consider. Default 1000, 0 = unlimited",
// "This is used when calculating result scores and sort order which can lead to out of memory errors on large data sets. The default of 1000 is safe with the PHP memory_limit set to 128M" => "This is used when calculating result scores and sort order which can lead to out of memory errors on large data sets. The default of 1000 is safe with the PHP memory_limit set to 128M",
// "Lucene Terms Per Query Limit" => "Lucene Terms Per Query Limit",
// "Maximum number of terms to be generated. Try increasing this value if you get errors saying \"Terms per query limit is reached\" espescially with wildcard, range and fuzzy searches" => "Maximum number of terms to be generated. Try increasing this value if you get errors saying \"Terms per query limit is reached\" espescially with wildcard, range and fuzzy searches",
// "Lucene Max Buffered Documents" => "Lucene Max Buffered Documents",
// "Number of documents required before the buffered in-memory documents are written into a new segment" => "Number of documents required before the buffered in-memory documents are written into a new segment",
// "Lucene Max Merge Documents" => "Lucene Max Merge Documents",
// "Largest number of documents ever merged by addDocument(). Small values (e.g., less than 10,000) are best for interactive indexing, as this limits the length of pauses while indexing to a few seconds. Larger values are best for batched indexing and speedier searches" => "Largest number of documents ever merged by addDocument(). Small values (e.g., less than 10,000) are best for interactive indexing, as this limits the length of pauses while indexing to a few seconds. Larger values are best for batched indexing and speedier searches",
// "Small values (e.g., less than 10,000) are best for interactive indexing. Use 0 for the Lucene default, which is practically infinite" => "Small values (e.g., less than 10,000) are best for interactive indexing. Use 0 for the Lucene default, which is practically infinite",
// "Lucene Default Boolean Operator" => "Lucene Default Boolean Operator",
// "Use OR (default) or AND as the default search operator" => "Use OR (default) or AND as the default search operator",
// "OR" => "OR",
// "AND" => "AND",
// "Lucene Merge Factor" => "Lucene Merge Factor",
// "How often segment indices are merged by addDocument(). With smaller values, less RAM is used while indexing, and searches on unoptimized indices are faster, but indexing speed is slower. With larger values, more RAM is used during indexing, and while searches on unoptimized indices are slower, indexing is faster. Thus larger values (> 10) are best for batch index creation, and smaller values (< 10) for indices that are interactively maintained" => "How often segment indices are merged by addDocument(). With smaller values, less RAM is used while indexing, and searches on unoptimized indices are faster, but indexing speed is slower. With larger values, more RAM is used during indexing, and while searches on unoptimized indices are slower, indexing is faster. Thus larger values (> 10) are best for batch index creation, and smaller values (< 10) for indices that are interactively maintained",
// "Large values (> 10) are best for batch index creation, and smaller values (< 10) for indices that are interactively maintained" => "Large values (> 10) are best for batch index creation, and smaller values (< 10) for indices that are interactively maintained",
// "Incremental Index Update" => "Incremental Index Update",
// "Update the index incrementally as the site content is modified. This may lead to lower performance and accuracy than processing the index on a periodic basis" => "Update the index incrementally as the site content is modified. This may lead to lower performance and accuracy than processing the index on a periodic basis",
// "Field Weights" => "Field Weights",
// "Allows to set the field weights that apply when ranking the pages for search listing. The weight only applies when the field is in the query. To nullify the value of a field, use an insignificant amount, not 0, which may lead to unexpected behaviors, such as stripping results" => "Allows to set the field weights that apply when ranking the pages for search listing. The weight only applies when the field is in the query. To nullify the value of a field, use an insignificant amount, not 0, which may lead to unexpected behaviors, such as stripping results",
// "One field per line, field_name__:__5.3" => "One field per line, field_name__:__5.3",
// "Default content fields" => "Default content fields",
// "All of the content is aggregated in the contents field. For custom weighting to apply, the fields must be included in the query. This option allows to include other fields in the default content search" => "All of the content is aggregated in the contents field. For custom weighting to apply, the fields must be included in the query. This option allows to include other fields in the default content search",
// "Tokenize version numbers" => "Tokenize version numbers",
// "Tokenize version number strings so that major versions are found when sub-versions are mentionned. For example, searching for 2.7 would return documents containing 2.7.4, but not 1.2.7" => "Tokenize version number strings so that major versions are found when sub-versions are mentionned. For example, searching for 2.7 would return documents containing 2.7.4, but not 1.2.7",
// "Cache per user and query" => "Cache per user and query",
// "Time in minutes a user has a same query cached " => "Time in minutes a user has a same query cached ",
// "In minutes" => "In minutes",
// "Index forum replies together with root post" => "Index forum replies together with root post",
// "If enabled, forum replies will be indexed together with the root post as a single document instead of being separately indexed" => "If enabled, forum replies will be indexed together with the root post as a single document instead of being separately indexed",
// "Search formatters to cache" => "Search formatters to cache",
// "Search formatters to cache the output of" => "Search formatters to cache the output of",
// "Format to use for tracker field keys" => "Format to use for tracker field keys",
// "Choose between field ids and permanent names for the tracker indexing" => "Choose between field ids and permanent names for the tracker indexing",
// "Permanent Name" => "Permanent Name",
// "Field ID (Backward compatibility mode with Tiki 7 and 8)" => "Field ID (Backward compatibility mode with Tiki 7 and 8)",
// "Excluded categories" => "Excluded categories",
// "List of category ids to exclude from the search index" => "List of category ids to exclude from the search index",
// "unsuccessful login attempts" => "unsuccessful login attempts",
// "After a certain number of consecutive unsuccessfull login attempts, the user will receive a mail with instruction to validate his account. However the user can still log-in with his old password" => "After a certain number of consecutive unsuccessfull login attempts, the user will receive a mail with instruction to validate his account. However the user can still log-in with his old password",
// "Suspend account after" => "Suspend account after",
// "After a certain number of consecutive unsuccessfull login attempts, the account is suspended . An admin must revalidate the account before the user can use it again" => "After a certain number of consecutive unsuccessfull login attempts, the account is suspended . An admin must revalidate the account before the user can use it again",
// "URL a user is redirected to after account validation" => "URL a user is redirected to after account validation",
"Account validated successfully." => "A felhasználói fiók sikeresen validálásra került.",
// "URL an anonymous is redirected when page not found" => "URL an anonymous is redirected when page not found",
"Close site when server load is above the threshold  (except for those with permission)" => "Weblap lezárása ha a szerver leterheltsége a küszöb felett van (a megfelelő jogosultsággal rendelkezők továbbra is beléphetnek)",
"Use proxy" => "Proxy használata",
// "Use context menus for actions (icons)" => "Use context menus for actions (icons)",
// "Use context menus for actions (text)" => "Use context menus for actions (text)",
"Show user's real name instead of login (when possible)" => "Felhasználó valódi nevének megjelenítése (ahol lehetséges)",
"Display UserTracker information on the user information page" => "Felhasználói űrlap információinak megjelenítése a felhasználó információs oldalán",
// "Input the user tracker ID then field IDs to be shown, all separated by commas. Example: 1,1,2,3,4 (user tracker ID 1 followed by field IDs 1-4)" => "Input the user tracker ID then field IDs to be shown, all separated by commas. Example: 1,1,2,3,4 (user tracker ID 1 followed by field IDs 1-4)",
"Users can configure modules" => "Felhasználók konfigurálhatják a modulokat",
"Users can shade modules" => "Felhasználók elrejthetik a modulokat",
// "Allows users to hide/show modules" => "Allows users to hide/show modules",
"Module decides" => "Modultól függ",
"Store full-size copy of avatar in file gallery" => "Teljes méretű avatár tárolása fájlgalériában",
"File gallery to store full-size copy of avatar in" => "Teljes méretű avatar tárolása ebben a fájlgalériában",
// "Enter the gallery id here. Please create a dedicated gallery that is admin-only for security, or make sure gallery permissions are set so that only admins can edit" => "Enter the gallery id here. Please create a dedicated gallery that is admin-only for security, or make sure gallery permissions are set so that only admins can edit",
// "File ID of default avatar image" => "File ID of default avatar image",
// "File ID of image to use in file gallery as the avatar if user has no avatar image in file galleries" => "File ID of image to use in file gallery as the avatar if user has no avatar image in file galleries",
"Display who viewed my stuff on the user information page" => "Annak megjelenítése hogy ki nézte meg a dolgaimat a felhasználó információs oldalán",
// "You will need to activate tracking of views for various items in the action log for this to work" => "You will need to activate tracking of views for various items in the action log for this to work",
"Number of days to consider who viewed my stuff" => "A megtekintéseknél figyelembe veendő napok száma",
// "Number of days before current time to consider when showing who viewed my stuff" => "Number of days before current time to consider when showing who viewed my stuff",
"Show to others who viewed my stuff on the user information page" => "Mások láthatják hogy ki nézte meg a dolgaimat a felhasználói információs oldalon",
// "Show to others who viewed my stuff on the user information page. Admins can always see this information" => "Show to others who viewed my stuff on the user information page. Admins can always see this information",
// "Maximum number of users to show in drop down lists" => "Maximum number of users to show in drop down lists",
// "Prevents out of memory and performance issues when user list is very large by using a jQuery autocomplete text input box" => "Prevents out of memory and performance issues when user list is very large by using a jQuery autocomplete text input box",
// "Use pretty trackers for registration form" => "Use pretty trackers for registration form",
// "Registration pretty tracker template" => "Registration pretty tracker template",
// "Use wiki page name or template file with .tpl extension" => "Use wiki page name or template file with .tpl extension",
// "Output the registration results" => "Output the registration results",
// "Use a wiki page as template to output the registration results to" => "Use a wiki page as template to output the registration results to",
// "Output registration pretty tracker template" => "Output registration pretty tracker template",
// "Wiki page only" => "Wiki page only",
// "Page name fieldId" => "Page name fieldId",
// "User trackers field id whose value is used as output page name" => "User trackers field id whose value is used as output page name",
// "User tracker IDs to sync prefs from" => "User tracker IDs to sync prefs from",
// "Enter the IDs separated by commas of trackers to sync user prefs from" => "Enter the IDs separated by commas of trackers to sync user prefs from",
// "Tracker field IDs to sync Real Name pref from" => "Tracker field IDs to sync Real Name pref from",
// "Enter the IDs separated by commas in priority of being chosen, each item can concatenate multiple fields using +, e.g. 2+3,4" => "Enter the IDs separated by commas in priority of being chosen, each item can concatenate multiple fields using +, e.g. 2+3,4",
// "Synchronize long/lat/zoom to location field" => "Synchronize long/lat/zoom to location field",
// "Synchronize user geolocation prefs to main location field" => "Synchronize user geolocation prefs to main location field",
// "Synchronize categories of user tracker item to user groups" => "Synchronize categories of user tracker item to user groups",
// "Will add the user tracker item to the category of the same name as the user groups and vice versa" => "Will add the user tracker item to the category of the same name as the user groups and vice versa",
// "Put user in group only if categorized within" => "Put user in group only if categorized within",
// "Change user system language when changing user tracker item language" => "Change user system language when changing user tracker item language",
// "Show user's real name instead of login in autocomplete selector in trackers feature" => "Show user's real name instead of login in autocomplete selector in trackers feature",
// "Use user's real name instead of login in autocomplete selector in trackers feature" => "Use user's real name instead of login in autocomplete selector in trackers feature",
// "Show user's real name instead of login in autocomplete selector in messaging feature" => "Show user's real name instead of login in autocomplete selector in messaging feature",
// "Use user's real name instead of login in autocomplete selector in messaging feature" => "Use user's real name instead of login in autocomplete selector in messaging feature",
// "User Favorites" => "User Favorites",
// "Allows for users to flag content as their favorite" => "Allows for users to flag content as their favorite",
// "Users must choose a group at registration" => "Users must choose a group at registration",
// "Users cannot register without choosing one of the groups defined above" => "Users cannot register without choosing one of the groups defined above",
"Score ascending" => "Pontszám alapján emelkedő",
"Score descending" => "Pontszám alapján csökkenő",
"Name ascending" => "Név alapján emelkedő",
"Name descending" => "Név alapján csökkenő",
"Login ascending" => "Bejelentkezési név alapján emelkedő",
"Login descending" => "Bejelentkezési név alapján  csökkenő",
// "Quota (MB)" => "Quota (MB)",
"Private" => "privát",
// "Users can see each other's files" => "Users can see each other's files",
// "Username pattern" => "Username pattern",
// "Serve avatar images statically" => "Serve avatar images statically",
// "When enabled, feature checks and permission checks will be skipped" => "When enabled, feature checks and permission checks will be skipped",
"Displayed time zone" => "Használt időzóna",
// "Always the site default time zone" => "Always the site default time zone",
// "Use time zone set from user preferences, or the automatically detected time zone for anonymous (if browser allows). Site default is used as fallback" => "Use time zone set from user preferences, or the automatically detected time zone for anonymous (if browser allows). Site default is used as fallback",
"Number of visited pages to remember" => "A nyilvántartott látogatott lapok száma",
"User information" => "Felhasználói információ",
"Public" => "Publikus",
"Use double-click to edit pages" => "Oldal szerkesztése duplakattintással",
// "Use 12-hour clock for time selectors" => "Use 12-hour clock for time selectors",
// "Use the 12-hour clock (with AM and PM) for time selectors used in some edit windows to set the time for publishing new or edited blog posts, articles, etc" => "Use the 12-hour clock (with AM and PM) for time selectors used in some edit windows to set the time for publishing new or edited blog posts, articles, etc",
// "Use new diff any version interface" => "Use new diff any version interface",
"Tasks per page" => "Laponkénti feladatok",
// "20" => "20",
// "30" => "30",
// "40" => "40",
// "50" => "50",
"Messages per page" => "Üzenetek száma oldalanként",
"Allow messages from other users" => "Más felhasználók üzenhetnek nekem",
"Notify sender when reading mail" => "Küldő értesítése a levél elolvasásáról",
"Send me an email for messages with priority equal or greater than" => "E-mail küldése azokról az üzenetekről melyek prioritása legalább:",
"Auto-archive read messages after" => "Olvasott üzenetek automatikus archiválása",
// "60" => "60",
"My pages" => "Lapjaim",
"My blogs" => "Blogjaim",
"My galleries" => "Galériáim",
"My messages" => "Üzeneteim",
"My tasks" => "Feladataim",
"My forum topics" => "Fórum témáim",
"My forum replies" => "Fórum válaszaim",
"My items" => "Tételeim",
"Character set for mail" => "Levelezés karakter készlete",
"Show user's info on mouseover" => "Felhasználói információk mutatása egér felhasználói név felé mozgatásakor",
// "Validator emails (separated by comma) if different than the sender email" => "Validator emails (separated by comma) if different than the sender email",
"Display by default" => "Alapértelmezésben megjelenítve",
"Path (if stored in directory)" => "Útvonal (ha merevlemezen kerül tárolásra)",
"Edit idle timeout" => "Nem tevékeny szerkesztés időkorlátja",
// "15" => "15",
"Log errors to Tiki log" => "Hibák loggolása Tiki log-ba",
// "Errors will be logged to the Tiki log" => "Errors will be logged to the Tiki log",
// "Tracker ID of Channel tracker" => "Tracker ID of Channel tracker",
// "There must be a tracker to store info of each channel you create" => "There must be a tracker to store info of each channel you create",
"Field ID of BrandId" => "Brand ID-hoz tartozó Field ID",
// "The Channel tracker must have a text field for the Watershed BrandId" => "The Channel tracker must have a text field for the Watershed BrandId",
// "Field ID of ChannelCode" => "Field ID of ChannelCode",
// "The Channel tracker must have a text field for the Watershed ChannelCode" => "The Channel tracker must have a text field for the Watershed ChannelCode",
// "Tracker ID of Archive tracker" => "Tracker ID of Archive tracker",
// "There must be a tracker to store Archive info" => "There must be a tracker to store Archive info",
"Field ID of videoId" => "Video ID-hoz tartotó Field ID",
// "The Archive tracker must have a text field for the videoId of each archive" => "The Archive tracker must have a text field for the videoId of each archive",
// "Field ID of BrandId for Archive" => "Field ID of BrandId for Archive",
// "The Archive tracker must have a text field for the BrandId of each archive" => "The Archive tracker must have a text field for the BrandId of each archive",
// "Field ID of ChannelCode for Archive" => "Field ID of ChannelCode for Archive",
// "The Archive tracker must have a text field for the ChannelCode of each archive" => "The Archive tracker must have a text field for the ChannelCode of each archive",
// "Field ID of rtmpURL for Archive (url field type)" => "Field ID of rtmpURL for Archive (url field type)",
// "The Archive tracker must have a url field for storing the RTMP URL to access the archive" => "The Archive tracker must have a url field for storing the RTMP URL to access the archive",
// "Field ID of flvURL for Archive (url field type)" => "Field ID of flvURL for Archive (url field type)",
// "The Archive tracker must have a url field for storing the FLV URL to access the archive" => "The Archive tracker must have a url field for storing the FLV URL to access the archive",
// "Field ID of Date string for Archive" => "Field ID of Date string for Archive",
// "The Archive tracker can have a text field for storing the time the recording completed" => "The Archive tracker can have a text field for storing the time the recording completed",
// "Field ID of Duration for Archive" => "Field ID of Duration for Archive",
// "The Archive tracker can have a text field for storing the duration of the recording" => "The Archive tracker can have a text field for storing the duration of the recording",
// "Field ID of Filesize for Archive" => "Field ID of Filesize for Archive",
// "The Archive tracker can have a text field for storing the filesize of the recording" => "The Archive tracker can have a text field for storing the filesize of the recording",
// "Field ID of Title for Archive" => "Field ID of Title for Archive",
// "The Archive tracker could have a text field for storing the title of the recording" => "The Archive tracker could have a text field for storing the title of the recording",
// "Field ID of Description for Archive (textarea field type)" => "Field ID of Description for Archive (textarea field type)",
// "The Archive tracker could have a textarea field for storing the description of the recording" => "The Archive tracker could have a textarea field for storing the description of the recording",
// "Field ID of Tags for Archive (freetags field type)" => "Field ID of Tags for Archive (freetags field type)",
// "The Archive tracker could have a freetags field for storing the tags of the recording" => "The Archive tracker could have a freetags field for storing the tags of the recording",
// "Flash Media Encoder shared secret" => "Flash Media Encoder shared secret",
// "Shared key for authenticating Flash Media Encoder" => "Shared key for authenticating Flash Media Encoder",
"Allow viewing HTML mails?" => "HTML levelek megtekintésének engedélyezése?",
"Maximum size for each attachment" => "Csatolt állomány maximum mérete",
// "500Kb" => "500Kb",
// "1Mb" => "1Mb",
// "1.5Mb" => "1.5Mb",
// "2Mb" => "2Mb",
// "2.5Mb" => "2.5Mb",
// "3Mb" => "3Mb",
"Unlimited" => "Nincs korlát",
"Include a flag by each e-mail to quickly flag/un-flag them" => "Minden E-mail megjelőlése gyors be/kijelölés céljából",
"LastModif" => "Utolsó módosítás",
"Last editor" => "Legutóbbi szerkesztő",
"Wiki link format" => "Wiki link formátum",
// "What level of special characters are accepted as wiki links for page names. Ex.: ((Page &eacute;&agrave;&icirc;))" => "What level of special characters are accepted as wiki links for page names. Ex.: ((Page &eacute;&agrave;&icirc;))",
"Strict will only be basic characters like a-z and 0-9. If you have accented or special characters in page names, you should not use strict." => "Szigorú esetén csak a-z és 0-9 karakterek engedélyezettek, amennyiben ékezetes vagy speciális karakterekre is szükség van az oldalak nevében, akkor ne használjuk.",
"Complete" => "Teljes",
"Relaxed" => "Laza",
"Strict" => "Szigorú",
// "Display page version" => "Display page version",
// "Display the page version information when viewing the page" => "Display the page version information when viewing the page",
"Display page name above page" => "Oldal nevének megjelenítése az oldal felett",
// "Display page name above page instead of inside page" => "Display page name above page instead of inside page",
"Page name display stripper" => "Oldalnév stripper",
// "Character to use as a delimiter in the page name. The portion of the name after this character will not be displayed" => "Character to use as a delimiter in the page name. The portion of the name after this character will not be displayed",
// "Wiki author list style" => "Wiki author list style",
// "Changes the list format used to display the authors of the page" => "Changes the list format used to display the authors of the page",
"Creator & Author" => "Létrehozó & Szerző",
"Business style" => "Üzleti stílus",
"Collaborative style" => "Kollaboratív stílus",
"Page last modified on" => "Oldal legutóbbi módosítása:",
"none (disabled)" => "nincs (kikapcsolva)",
// "Specify wiki author list style per page" => "Specify wiki author list style per page",
// "Allows to modify the style in which the author list is displayed on a per-page basis" => "Allows to modify the style in which the author list is displayed on a per-page basis",
// "Wiki action bar location" => "Wiki action bar location",
"Buttons: Save, Preview, Cancel, .." => "Gombok: Mentés, Előnézet, Visszavonás, ..",
"Both" => "Mindkettő",
// "Wiki navigation bar location" => "Wiki navigation bar location",
"When using the ...page... page break wiki syntax" => "A '...page...' oldaltörési wiki szintakszis használata esetén",
"Wiki top line location" => "Wiki felső sor helye",
"Cache wiki pages (global)" => "Wiki oldalak cache-elése (globális)",
// "Enable page cache globally for wiki pages" => "Enable page cache globally for wiki pages",
"no cache" => "nincs cache",
"minute" => "perc",
"Allow comments per wiki page" => "Kommentek engedélyezése wiki oldalanként",
// "Enable control for comments on wiki pages individually" => "Enable control for comments on wiki pages individually",
"Enable (default On)" => "Bekapcsolás (alapértelmezésben bekapcsolva)",
"Enable (default Off)" => "Bekapcsolás (alapértelemésben kikapcsolva)",
// "Enable edit plugin icons" => "Enable edit plugin icons",
// "Permits editing of a plugin, via a popup form, without needing to edit the whole page" => "Permits editing of a plugin, via a popup form, without needing to edit the whole page",
// "Requires JavaScript" => "Requires JavaScript",
// "Prevent special characters in page names" => "Prevent special characters in page names",
// "Some characters may prevent the pages from being easily accessible from the URL or through wiki links. This option prevents from creating pages with such characters" => "Some characters may prevent the pages from being easily accessible from the URL or through wiki links. This option prevents from creating pages with such characters",
// "Page ranking reload probability" => "Page ranking reload probability",
// "Calculation of page rankings is an expensive task that cannot be performed at every page load. It will be calculated at random page loads based on a dice roll. This option indicates the amount of faces on the dice. Larger numbers lead to less load, but less accurate ranking" => "Calculation of page rankings is an expensive task that cannot be performed at every page load. It will be calculated at random page loads based on a dice roll. This option indicates the amount of faces on the dice. Larger numbers lead to less load, but less accurate ranking",
// "Encourage contribution to wiki pages by anonymous" => "Encourage contribution to wiki pages by anonymous",
// "When a page is not editable and the user is anonymous, display the edit links anyway. The visitor will be prompted with a login screen and be encouraged to register" => "When a page is not editable and the user is anonymous, display the edit links anyway. The visitor will be prompted with a login screen and be encouraged to register",
// "Warn before page lock timeout" => "Warn before page lock timeout",
// "Provide a JavaScript alert before the user's lock on a page times out" => "Provide a JavaScript alert before the user's lock on a page times out",
"Dynamic variables" => "Dinamikus változók",
// "Global snippets of text that can be included in wiki pages and edited in place" => "Global snippets of text that can be included in wiki pages and edited in place",
"Single (%varname%)" => "Egyedi (%varname%)",
"Double (%%varname%%)" => "Dupla (%%varname%%)",
"Multilingual dynamic variables" => "Többnyelvű dinamikus változók",
// "Make dynamic variable content language specific" => "Make dynamic variable content language specific",
"Edit section" => "Szekció szerkesztése",
"Edit section level" => "Szekció szint szerkesztése",
"Toggle display of section and plugin edit icons" => "Szekció és plugin szerkesztési ikonok megjelenítése",
"Allow minor edits" => "Kisebb szerkesztések engedélyezése",
// "Add a slideshow button on wiki pages" => "Add a slideshow button on wiki pages",
"Page creators are admin of their pages" => "A lap készítője saját lapjának adminisztrátora",
"Create watch for author on page creation" => "Figyelés bekapcsolása az oldal létrehozójának az oldal létrehozásakor",
"Enable watches on comments" => "Kommentek figyelése",
"Enable watch events when I am the editor" => "Figyelés bekapcsolása a szerkesztőnek",
"Watch minor edits" => "Kisebb szerkesztések figyelése",
"Page ID" => "Oldal ID (azonosító)",
"Name length" => "Név hossza",
"Last modified by" => "Utoljára módosította",
"Edit comments" => "Kommentek szerkesztése",
"Edit Comment length" => "Szerkesztési megjegyzés hossza",
"Versions" => "Verziók",
"Categories" => "Kategóriák",
"Categories path" => "Kategória útvonala",
"Default sort order" => "Alapértelmezett rendezési sorrend",
"Sort Direction" => "Rendezés iránya",
"Descending" => "Csökkenő",
"Ascending" => "Növekvő",
// "Enable wiki 3D browser" => "Enable wiki 3D browser",
// "Load page on navigation" => "Load page on navigation",
"Forum for discussion" => "Kapcsolódó fórum",
// "Allow to manage keywords on a per-page basis" => "Allow to manage keywords on a per-page basis",
"Similar pages only listed in same language" => "Hasonló oldalak listázása csak ugyanazon a nyelven",
// "When listing similar pages, such as in missing page 404, only display pages in the same language as the request" => "When listing similar pages, such as in missing page 404, only display pages in the same language as the request",
"Mandatory edit summary on wiki pages" => "Kötelező összefoglalót írni a változásokról",
// "Reject save attempts not providing an edit summary to describe the changes made" => "Reject save attempts not providing an edit summary to describe the changes made",
// "Choose position of freetags selection" => "Choose position of freetags selection",
// "If you wish to place freetags selection more prominently than in the properties tab" => "If you wish to place freetags selection more prominently than in the properties tab",
// "Properties tab" => "Properties tab",
// "Edit tab" => "Edit tab",
// "Freetags tab" => "Freetags tab",
"Structure navigation bar location" => "Struktúra navigációs sor elhelyezkedése",
// "Displays Next/Back buttons, breadcrumbs, and form to add a new page" => "Displays Next/Back buttons, breadcrumbs, and form to add a new page",
// "Maximum length (characters) to display/truncate for backlink page names. Use \"0\" for no truncation" => "Maximum length (characters) to display/truncate for backlink page names. Use \"0\" for no truncation",
"Simple wiki ratings" => "Egyszerű wiki értékelések",
// "Enable users to rate articles based on a simple numeric scale" => "Enable users to rate articles based on a simple numeric scale",
"Wiki rating options" => "Wiki értékelés beállításai",
// "List of options available for the rating of wiki pages" => "List of options available for the rating of wiki pages",
// "Semantic link types to use as page alias markers" => "Semantic link types to use as page alias markers",
// "Comma separated list of semantic links to use to identify a page as an alias to another" => "Comma separated list of semantic links to use to identify a page as an alias to another",
// "Redirect pages using these prefix alias semantic links" => "Redirect pages using these prefix alias semantic links",
// "Comma separated list of prefixes of which pages will be redirected to page with semantic link" => "Comma separated list of prefixes of which pages will be redirected to page with semantic link",
"Plugin %0" => "Snarf plugin",
// "Global cache time for the plugin snarf in seconds" => "Global cache time for the plugin snarf in seconds",
// "Default cache time for the plugin snarf" => "Default cache time for the plugin snarf",
// "0 for no cache" => "0 for no cache",
// "Inline plugin %0" => "Inline plugin %0",
// "Plugin pending approval notification" => "Plugin pending approval notification",
// "Alert by e-mail users with permission to approve plugin when a plugin is pending approval" => "Alert by e-mail users with permission to approve plugin when a plugin is pending approval",
"Wysiwyg Editor is optional" => "WYSIWYG szerkesztő opcionális",
"Wysiwyg Editor is displayed by default" => "WYSIWYG szerkesztő jelenik meg alapértelmezésben",
"Reopen with the same editor" => "Újranyitás ugyanazzal a szerkesztővel",
"Content is parsed like wiki page" => "Tartalom wiki oldalként elemzett",
// "This allows a mixture of wiki and HTML. All wiki syntax is parsed" => "This allows a mixture of wiki and HTML. All wiki syntax is parsed",
"Content is partially wiki parsed" => "A tartalom részben wiki által elemzett",
// "This also allows a mixture of wiki and HTML. Only some wiki syntax is parsed, such as plugins (not inline character styles etc)" => "This also allows a mixture of wiki and HTML. Only some wiki syntax is parsed, such as plugins (not inline character styles etc)",
// "Neglected. This feature can have unpredicable results and may be removed in future versions" => "Neglected. This feature can have unpredicable results and may be removed in future versions",
"Wysiwyg editor skin" => "WYSIWYG szerkesztő stílusa",
"Kama (Default)" => "Kama (alapértelmezett)",
// "Office 2003" => "Office 2003",
"V2 (FCKEditor appearance)" => "V2 (FCKEditor megjelenítés)",
"Use Wiki syntax in WYSIWYG" => "Wiki szintakszis használata WYSIWYG módban",
// "Experimental, new : Allow to keep the wiki syntax with the WYSIWYG editor. WARNING: plugin edit is not working in that case in WYSIWYG mode, use the Source mode instead " => "Experimental, new : Allow to keep the wiki syntax with the WYSIWYG editor. WARNING: plugin edit is not working in that case in WYSIWYG mode, use the Source mode instead ",
"Font names" => "Betűtípusok",
// "List of font names separated by" => "List of font names separated by",
"SMTP Server" => "SMTP szerver",
"Username" => "Felhasználónév",
"Security" => "Biztonság",
// "SSL" => "SSL",
// "TLS" => "TLS",
"Mail Sender" => "Levél küldő",
"Sendmail" => "Levélküldés",
// "SMTP" => "SMTP",
// "Authentication" => "Authentication",
// "Mail server authentication" => "Mail server authentication",
// "LOGIN" => "LOGIN",
// "PLAIN" => "PLAIN",
// "CRAM-MD5" => "CRAM-MD5",
// "Zotero Bibliography" => "Zotero Bibliography",
// "Connect Tiki to the Zotero online bibliography management system" => "Connect Tiki to the Zotero online bibliography management system",
// "Zotero Client Key" => "Zotero Client Key",
// "Required identification key. Registration required" => "Required identification key. Registration required",
// "Zotero Client Secret" => "Zotero Client Secret",
// "Zotero Group ID" => "Zotero Group ID",
// "Numeric ID of the group, can be found in the URL" => "Numeric ID of the group, can be found in the URL",
// "Zotero Reference Style" => "Zotero Reference Style",
// "Use an alternate Zotero reference style when formatting the references. The reference formats must be installed on the Zotero server" => "Use an alternate Zotero reference style when formatting the references. The reference formats must be installed on the Zotero server",
// "Unmatched system requirement. Missing php extension among %0" => "Unmatched system requirement. Missing php extension among %0",
// "Unmatched system requirement. The database you are using does not support this feature" => "Unmatched system requirement. The database you are using does not support this feature",
// "Missing default for preference \"%0\"" => "Missing default for preference \"%0\"",
// "Configuration forced by host" => "Configuration forced by host",
// "Disabled by host" => "Disabled by host",
"Actions" => "Akciók",
"Admin" => "Adminisztráció",
"Permissions" => "Jogosultságok",
"View" => "Megtekintés",
"Module" => "Modul",
"Plugin" => "Plugin",
// "Like" => "Like",
// "Fix me" => "Fix me",
// "Unavailable" => "Unavailable",
// "Don't like" => "Don't like",
// "Don't fix me" => "Don't fix me",
// "What's this for" => "What's this for",
// "Nothing was changed, please check profile for errors" => "Nothing was changed, please check profile for errors",
// "An error occurred: " => "An error occurred: ",
// "Applying profile" => "Applying profile",
// "Preference set" => "Preference set",
// "Added (or modified)" => "Added (or modified)",
// "Group changed (or modified)" => "Group changed (or modified)",
// "Modified permission %s for %s" => "Modified permission %s for %s",
// "Modified permission %s on %s/%s for %s" => "Modified permission %s on %s/%s for %s",
// "User %0 was added to %1" => "User %0 was added to %1",
// "Created by profile installer" => "Created by profile installer",
// "Page updated by profile installer" => "Page updated by profile installer",
// "File gallery does not exist" => "File gallery does not exist",
// "File gallery already exists" => "File gallery already exists",
// "Calendar does not exist" => "Calendar does not exist",
// "Calendar already exists" => "Calendar already exists",
"Page cannot be found" => "Ez az oldal nem található!",
// "Syntax error: " => "Syntax error: ",
// "Circular reference" => "Circular reference",
// "No name" => "No name",
// "Bad object" => "Bad object",
// "Permissions' object must have a field 'type' and 'id'" => "Permissions' object must have a field 'type' and 'id'",
// "Needs a 'type' and 'data' field" => "Needs a 'type' and 'data' field",
"Wiki top pages" => "Leglátogatottabb wiki oldalak",
"Most relevant pages" => "Legrelevánsabb oldalak",
"Relevance" => "Relevancia",
"Wiki last pages" => "Legutóbbi wiki oldalak",
// "Forums last posts" => "Forums last posts",
"Topic date" => "Téma dátuma",
"Forums most read topics" => "A legolvasottabb fórum topic-ok",
"Forums best topics" => "A legjobb topic-ok",
"Forums most visited forums" => "Leglátogatottabb fórumok",
"Forums with most posts" => "A legtöbb üzenettel rendelkező fórumok",
"Wiki top galleries" => "Wiki leglátogatottabb galériái",
"Wiki top file galleries" => "Wiki leglátogatottabb fájlgalériái",
"Wiki top images" => "Wiki legjobb képek",
"Wiki top files" => "Wiki legjobb fájlok",
"Downloads" => "Letöltések",
"Wiki last images" => "Wiki utóbbi képek",
"Upload date" => "Feltöltés dátuma",
// "Wiki last files" => "Wiki last files",
"Top Articles" => "Legolvasottabb cikkek",
"Most visited blogs" => "Legtöbbet látogatott blogok",
// "Most-active Blogs" => "Most-active Blogs",
// "Blogs last posts" => "Blogs last posts",
"Post date" => "Beküldés időpontja:",
"Wiki top authors" => "A wiki oldalak kiemelkedő szerzői",
"Pages" => "Oldalak",
// "Top article authors" => "Top article authors",
// "Expecting three arguments for article-info" => "Expecting three arguments for article-info",
// "Unsupported property. Supported properties are: " => "Unsupported property. Supported properties are: ",
// "Articles feature not enabled" => "Articles feature not enabled",
// "Unexpected values: %0" => "Unexpected values: %0",
// "Object must be provided and contain two arguments: type and object" => "Object must be provided and contain two arguments: type and object",
// "Invalid property" => "Invalid property",
// "Invalid range" => "Invalid range",
// "Invalid revote period" => "Invalid revote period",
// "Expecting \"keep\" to be \"latest\" or \"oldest\"" => "Expecting \"keep\" to be \"latest\" or \"oldest\"",
// "Unknown variables referenced: %0" => "Unknown variables referenced: %0",
// "Username is required" => "Username is required",
"Password is required" => "Szükséges a jelszó megadása",
"User already exists" => "Ez felhasználónév már létezik ebben a rendszerben",
"Registered" => "Regisztrált",
// "Invalid username" => "Invalid username",
// "Username is too long" => "Username is too long",
// "Username cannot contain uppercase letters" => "Username cannot contain uppercase letters",
// "Wrong passcode. You need to know the passcode to register at this site" => "Wrong passcode. You need to know the passcode to register at this site",
// "You must choose a group" => "You must choose a group",
// "Email not valid. Should be in the format \"mailbox@example.com\"" => "Email not valid. Should be in the format \"mailbox@example.com\"",
"The passwords don't match" => "Figyelem, hogy egyezzenenek a megadott jelszavak!",
// "Username must be at least %0 characters long" => "Username must be at least %0 characters long",
// "Username cannot contain more than %0 characters" => "Username cannot contain more than %0 characters",
// "This invitation does not exist or is deprecated or wrong email" => "This invitation does not exist or is deprecated or wrong email",
// "The fields title and description are mandatory to generate a feed" => "The fields title and description are mandatory to generate a feed",
// "To fix this error go to Admin -> Feeds" => "To fix this error go to Admin -> Feeds",
// "Please contact the site administrator and ask him to fix this error" => "Please contact the site administrator and ask him to fix this error",
// "If you set feed author email or URL, you must set feed author name" => "If you set feed author email or URL, you must set feed author name",
// "Feed logo" => "Feed logo",
"Unspecified" => "Nem meghatározott",
"Log In" => "Bejelentkezés",
"See other users' profiles" => "Más felhasználó profijának megtekintése",
"Have your profile seen" => "Más felhasználó megtekinti a profilomat",
"Make friends" => "Barátságkötés",
"Receive message" => "Üzenet fogadása",
"Send message" => "Üzenet küldése",
"Read an article" => "Cikk olvasása",
"Publish an article" => "Cikk publikálása",
"Have your article read" => "Más felhasználó olvassa egy cikkemet",
"Create New File Gallery" => "Új fájlgaléria létrehozása",
"Upload new file to gallery" => "Új fájl feltöltése galériába",
"Download other user's file" => "Más felhasználó fájljának letöltése",
"Have your file downloaded" => "Más felhasználó letölti egy fájlomat",
"Create a new image gallery" => "Új képgaléria létrehozása",
"Upload new image to gallery" => "Új kép feltöltése galériába",
"See other users' galleries" => "Más felhasználó galériájának megtekintése",
"See other users' images" => "Más felhasználó képének megtekintése",
"Have your gallery seen by other users" => "Más felhasználó megtekinti egy galériámat",
"Have your image seen" => "Más felhasználó megnézi egy képemet",
"Create new blog" => "Új blog létrehozása",
"Post in a blog" => "Posztolás egy blogba",
"Read other users' blogs" => "Más felhasználó blogjának olvasása",
"Have your blog read" => "Más felhasználó olvassa egy blogomat",
"Create a new wiki page" => "Új wikioldal létrehozása",
"Edit an existing page" => "Létező oldal szerkesztése",
"Attach file" => "Mellékletek",
// "try rebuilding or optimizing the index on the search admin page" => "try rebuilding or optimizing the index on the search admin page",
// "Search index could not be updated: %0" => "Search index could not be updated: %0",
"Wiki Comment" => "Wiki komment",
"Calendar item" => "Naptár tétel",
"Gallery" => "Galéria",
"Article" => "Cikk",
"Blog post" => "Blog poszt",
"Tracker item" => "Űrlap tétel",
// "Search index could not be updated. The site is misconfigured. Contact an administrator" => "Search index could not be updated. The site is misconfigured. Contact an administrator",
// "blog post" => "blog post",
// "file" => "file",
// "forum post" => "forum post",
// "trackeritem" => "trackeritem",
"sheet" => "ív",
"comment" => "komment",
// " has accessed your temporary shared content" => " has accessed your temporary shared content",
// "has accessed the following shared content" => "has accessed the following shared content",
// "Your access to this page has expired" => "Your access to this page has expired",
// "Handling actions of plugin \"%s\" failed" => "Handling actions of plugin \"%s\" failed",
// "You must choose an option" => "You must choose an option",
// "For you to vote, cookies must be allowed" => "For you to vote, cookies must be allowed",
// "This poll is closed" => "This poll is closed",
// "Thank you for installing Tiki" => "Thank you for installing Tiki",
// "The entire Tiki Community would like to thank you and help you get introduced to Tiki" => "The entire Tiki Community would like to thank you and help you get introduced to Tiki",
// "How To Get Started" => "How To Get Started",
// "Tiki has more than 1000 features and settings" => "Tiki has more than 1000 features and settings",
// "This allows you to create both very simple and complex websites" => "This allows you to create both very simple and complex websites",
// "We understand that so many features might seem overwhelming at first. This is why we offer you two different ways to __Get Started__ with Tiki" => "We understand that so many features might seem overwhelming at first. This is why we offer you two different ways to __Get Started__ with Tiki",
// "Manual Setup using Admin Panel" => "Manual Setup using Admin Panel",
// "Get Started using Admin Panel" => "Get Started using Admin Panel",
// "Who Should Use This" => "Who Should Use This",
// "You are familiar with software Admin Panels" => "You are familiar with software Admin Panels",
// "You enjoy exploring and playing with many options" => "You enjoy exploring and playing with many options",
// "You already know Tiki" => "You already know Tiki",
// "Easy Setup using Profiles" => "Easy Setup using Profiles",
// "Get Started using Profiles" => "Get Started using Profiles",
// "You want to get started quickly" => "You want to get started quickly",
// "Featured Profiles" => "Featured Profiles",
// "__Collaborative Community__ ([%0|apply profile now])" => "__Collaborative Community__ ([%0|apply profile now])",
// "Setup to help subject experts and enthusiasts work together to build a Knowledge Base" => "Setup to help subject experts and enthusiasts work together to build a Knowledge Base",
// "Wiki Editing" => "Wiki Editing",
// "Personal Member Spaces" => "Personal Member Spaces",
// "__Personal Blog and Profile__ ([%0|apply profile now])" => "__Personal Blog and Profile__ ([%0|apply profile now])",
// "Setup with many cool features to help you integrate the Social Web and establish a strong presence in the Blogosphere" => "Setup with many cool features to help you integrate the Social Web and establish a strong presence in the Blogosphere",
// "Blog (Full set of blog related features)" => "Blog (Full set of blog related features)",
// "RSS Integration" => "RSS Integration",
// "Video Log" => "Video Log",
// "__Company Intranet__ ([%0|apply profile now])" => "__Company Intranet__ ([%0|apply profile now])",
// "Setup for a Corporate Intranet of a typical medium-sized business" => "Setup for a Corporate Intranet of a typical medium-sized business",
// "Company News Articles" => "Company News Articles",
// "Executive Blog" => "Executive Blog",
// "File Repository & Management" => "File Repository & Management",
// "Collaborative Wiki" => "Collaborative Wiki",
// "__Small Organization Web Presence__ ([%0|apply profile now])" => "__Small Organization Web Presence__ ([%0|apply profile now])",
// "Setup for a Web Presence of a typical small business or non-profit" => "Setup for a Web Presence of a typical small business or non-profit",
// "Company News & Updates" => "Company News & Updates",
// "File Gallery (great for Media Kit)" => "File Gallery (great for Media Kit)",
// "Contact Form" => "Contact Form",
// "Congratulations" => "Congratulations",
// "This is the default homepage for your Tiki. If you are seeing this page, your installation was successful" => "This is the default homepage for your Tiki. If you are seeing this page, your installation was successful",
// "You can change this page after logging in. Please review the [http://doc.tiki.org/wiki+syntax|wiki syntax] for editing details" => "You can change this page after logging in. Please review the [http://doc.tiki.org/wiki+syntax|wiki syntax] for editing details",
// "{img src=img/icons/star.png alt=\\\"Star\\\"} Get started" => "{img src=img/icons/star.png alt=\\\"Star\\\"} Get started",
// "To begin configuring your site" => "To begin configuring your site",
// "1) Log in with your newly created password" => "1) Log in with your newly created password",
// "2) Manually Enable specific Tiki features" => "2) Manually Enable specific Tiki features",
// "3) Run Tiki Profiles to quickly get up and running" => "3) Run Tiki Profiles to quickly get up and running",
// "{img src=img/icons/help.png alt=\\\"Help\\\"} Need help" => "{img src=img/icons/help.png alt=\\\"Help\\\"} Need help",
// "For more information" => "For more information",
// "[http://info.tiki.org/Learn+More|Learn more about Tiki]" => "[http://info.tiki.org/Learn+More|Learn more about Tiki]",
// "[http://info.tiki.org/Help+Others|Get help], including the [http://doc.tiki.org|official documentation] and [http://tiki.org/forums|support forums]" => "[http://info.tiki.org/Help+Others|Get help], including the [http://doc.tiki.org|official documentation] and [http://tiki.org/forums|support forums]",
// "[http://info.tiki.org/Join+the+community|Join the Tiki community]" => "[http://info.tiki.org/Join+the+community|Join the Tiki community]",
// "You don't feel like learning the Admin Panel right away" => "You don't feel like learning the Admin Panel right away",
// "You want to quickly test out some of Tiki's Features" => "You want to quickly test out some of Tiki's Features",
// "Highlight Company's Products and Services" => "Highlight Company's Products and Services",
"new" => "új",
// "Saved" => "Saved",
// "Save failed" => "Save failed",
// "Standard Shipping" => "Standard Shipping",
// "3 to 5 working days" => "3 to 5 working days",
// "Express Shipping" => "Express Shipping",
// "Next day delivery" => "Next day delivery",
// "Custom Shipping Example" => "Custom Shipping Example",
// "UPS_CODE_%0" => "UPS_CODE_%0",
// "Problem reading custom shipping provider \"%0\"" => "Problem reading custom shipping provider \"%0\"",
"Click for Help" => "Súgó",
// "You are not in group of friends to have the content of this block displayed for you" => "You are not in group of friends to have the content of this block displayed for you",
// "<!-- jq smarty plugin inactive: feature_jquery off -->" => "<!-- jq smarty plugin inactive: feature_jquery off -->",
// "No records to display" => "No records to display",
// "Fast Next" => "Fast Next",
// "Fast Prev" => "Fast Prev",
"Prev" => "Előző",
"Next" => "Következő",
// "More results may be available. Refine criteria to access the estimated %0 results" => "More results may be available. Refine criteria to access the estimated %0 results",
// "First %0" => "First %0",
// "Last %0" => "Last %0",
// "Next %0" => "Next %0",
// "Prev %0" => "Prev %0",
"tip" => "tipp",
// "warning" => "warning",
// "confirm" => "confirm",
"note" => "megjegyzés",
"errors" => "hiba",
"information" => "információ",
"Tab View" => "Füles nézet",
"No Tabs" => "Fülek nélkül",
"Tip" => "Tipp",
"This edit session will expire in" => "A szerkesztési munkamenet ennyi idő múlva jár le:",
// "<strong>Preview</strong> (if available) or <strong>Save</strong> your work to restart the edit session timer" => "<strong>Preview</strong> (if available) or <strong>Save</strong> your work to restart the edit session timer",
// "There is an autosaved draft of your recent edits, to use it instead of what is current displayed" => "There is an autosaved draft of your recent edits, to use it instead of what is current displayed",
// "If you want the original version instead of the autosaved draft of your edits" => "If you want the original version instead of the autosaved draft of your edits",
"click here" => "klikk ide",
// "AutoSave" => "AutoSave",
// "<strong>Thank you for trying the new ckeditor implementation for Tiki 6</strong><br /><br />" => "<strong>Thank you for trying the new ckeditor implementation for Tiki 6</strong><br /><br />",
// "Some of the settings at this site should be set differently for this to work best. Please ask the administrator to try this" => "Some of the settings at this site should be set differently for this to work best. Please ask the administrator to try this",
// "Ckeditor Development Notice" => "Ckeditor Development Notice",
// "Your edit session has expired" => "Your edit session has expired",
"Your edit session will expire in" => "A szerkesztési munkamenet lejár ennyi perc múlva:",
// "You must PREVIEW or SAVE your work now, to avoid losing your edits" => "You must PREVIEW or SAVE your work now, to avoid losing your edits",
// "You are about to leave this page. Changes since your last save will be lost. Are you sure you want to exit this page" => "You are about to leave this page. Changes since your last save will be lost. Are you sure you want to exit this page",
// "Some of your preferences should be set differently for this to work at it's best. Please click this to apply the recommended profile" => "Some of your preferences should be set differently for this to work at it's best. Please click this to apply the recommended profile",
"Help page" => "Súgó oldal",
// "View or edit tpl" => "View or edit tpl",
"Edit Template" => "Sablon szerkesztése",
"View tpl" => "Tpl megtekintése",
// "View Template" => "View Template",
// "Admin page" => "Admin page",
"Admin Feature" => "Funkció adminisztrálása",
// "Plugin name not specified" => "Plugin name not specified",
// "Wrong attachments gallery" => "Wrong attachments gallery",
// "You are attempting to display a gallery that is not a valid attachment gallery" => "You are attempting to display a gallery that is not a valid attachment gallery",
// "Error(s)" => "Error(s)",
// "Clear errors" => "Clear errors",
// "Favorite" => "Favorite",
// "Hour" => "Hour",
// "Minute" => "Minute",
// "a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z" => "a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z",
// "Click here to go to Edit Languages" => "Click here to go to Edit Languages",
// "The text is" => "The text is",
// "character(s) too long - please edit it" => "character(s) too long - please edit it",
"Date Selector" => "Dátum kiválasztó",
"Filter:" => "Szűrő:",
// "Month beginning" => "Month beginning",
// "Week beginning" => "Week beginning",
// "Data (change %)" => "Data (change %)",
"No records found." => "Nincs rekord",
// "No object information provided" => "No object information provided",
// "No title specified" => "No title specified",
// "Relation not found" => "Relation not found",
// "freetags disabled" => "freetags disabled",
// "Currency in payment (%0) does not match the currency for that registry (%1)" => "Currency in payment (%0) does not match the currency for that registry (%1)",
// "This invoice does not exist or is in limited access" => "This invoice does not exist or is in limited access",
// " (found in " => " (found in ",
// "(not found in an admin panel)" => "(not found in an admin panel)",
// "Preference %0 is not defined" => "Preference %0 is not defined",
// "Drag this out of the perspective and resave it" => "Drag this out of the perspective and resave it",
// "No object information provided for rating" => "No object information provided for rating",
// "An error occurred" => "An error occurred",
// "Invert Sort" => "Invert Sort",
// "No rows found" => "No rows found",
"Toggle sections" => "Szekciók megjelenítése",
"Show only selected" => "Kijelöltek mutatása",
// "You might want to also set the tiki_p_modify_object_categories permission under the tiki section" => "You might want to also set the tiki_p_modify_object_categories permission under the tiki section",
"You are already logged in" => "Már be van jelentkezve",
// "Request not from this host" => "Request not from this host",
// "One of these groups is required" => "One of these groups is required",
// "This field is required" => "This field is required",
// "Please enter a valid %s.  No spaces, more than %d characters and contain %s" => "Please enter a valid %s.  No spaces, more than %d characters and contain %s",
"username" => "felhasználónév",
"password" => "jelszó",
"You have to enable cookies to be able to login to this site" => "Engedélyezni kell a sütiket az oldal használatához",
"second" => "másodperc",
// "years" => "years",
"months" => "hónap",
"weeks" => "hét",
"done" => "kész",
// "Text cut here" => "Text cut here",
"Task" => "Feladat",
"Priority" => "Prioritás",
"Start date" => "Kezdés dátuma",
"End date" => "Befejezés dátuma",
// "in %s days, the %s" => "in %s days, the %s",
// "in %s day, the %s" => "in %s day, the %s",
"Friend" => "Barát",
"Gender:" => "Nem:",
"km" => "km",
"Last seen on" => "Legutóbbi bejelentkezés",
// "(idle for %s seconds)" => "(idle for %s seconds)",
"User information - Click for more info" => "Felhasználói adatok - Kattintás további információkért",
// "More info about %0 (idle for %1)" => "More info about %0 (idle for %1)",
// " seconds" => " seconds",
// "Permission denied: the specified wiki page cannot be used as Smarty template resource" => "Permission denied: the specified wiki page cannot be used as Smarty template resource",
// "No WSDL found" => "No WSDL found",
"pvs" => "oldalmegtekintés",
// "Days with the most pageviews" => "Days with the most pageviews",
// "Day with the most pageviews" => "Day with the most pageviews",
// "Days with the least pageviews" => "Days with the least pageviews",
// "Day with the least pageviews" => "Day with the least pageviews",
// "No pageviews yet" => "No pageviews yet",
// "n/a" => "n/a",
// "Use this tree to copy the structure" => "Use this tree to copy the structure",
// "created from structure" => "created from structure",
// "You have to make %d choice(s) for the question" => "You have to make %d choice(s) for the question",
// "You have to make at least %d choice(s) for the question" => "You have to make at least %d choice(s) for the question",
// "You have to make less than %d choice(s) for the question" => "You have to make less than %d choice(s) for the question",
// "You have to choose at least %d choice(s) for the question" => "You have to choose at least %d choice(s) for the question",
// "Foreground Colors" => "Foreground Colors",
// "Background Colors" => "Background Colors",
"Colors" => "Színek",
// "Border Colors" => "Border Colors",
// "Border Widths" => "Border Widths",
// "Border Styles" => "Border Styles",
// "Border Radii" => "Border Radii",
// "Borders" => "Borders",
// "Font Sizes" => "Font Sizes",
// "Line Heights" => "Line Heights",
"Font" => "Betűtípus",
// "Font Families" => "Font Families",
// "Typography" => "Typography",
// "Select.." => "Select..",
// "Required features: <b>%0</b>. If you do not have the privileges to activate these features, ask the site administrator" => "Required features: <b>%0</b>. If you do not have the privileges to activate these features, ask the site administrator",
"Sea Surfing (CSRF) detected. Operation blocked" => "CSRF tevékenység, a művelet átmenetileg bokkolva",
"unknown error" => "ismeretlen hiba",
"You are not logged in" => "Először <a href=\"tiki-login_scr.php\">be kell jelentkezni</a> ehhez!",
// "This script cannot be called directly" => "This script cannot be called directly",
// "Page '%0' cannot be found" => "Page '%0' cannot be found",
"You do not have permission to view this section" => "Magasabb szintű jogosultágra van szükség a szekció megtekintéséhez",
// "For the security of your password direct access to the feed is only available via https" => "For the security of your password direct access to the feed is only available via https",
"Help link" => "Súgó",
"You are banned from" => "Kitiltottak innen:",
"wiki" => "wiki",
// "img-g" => "img-g",
// "file-g" => "file-g",
"faqs" => "gyakran intézett kérdések",
"quizzes" => "kvízek",
// "arts" => "arts",
"blogs" => "blogok",
"forums" => "fórumok",
// "The file was uploaded with success" => "The file was uploaded with success",
// "The file you are trying upload was only partially uploaded" => "The file you are trying upload was only partially uploaded",
// "No file was uploaded. Was a file selected " => "No file was uploaded. Was a file selected ",
// "A temporary folder is missing" => "A temporary folder is missing",
// "Unknown error" => "Unknown error",
"Flash player not available" => "Flash lejátszó nem elérhető",
// "%d points" => "%d points",
"Removed" => "Eltávolítva",
"at" => "ekkor",
// "Plugin %0 pending approval" => "Plugin %0 pending approval",
"Unknown language" => "Ismeretlen nyelv",
"Click here to confirm your action" => "Akció megerősítése",
"Bold" => "Félkövér",
// "img/icons/text_bold.png" => "img/icons/text_bold.png",
"Italic" => "Dőlt",
// "img/icons/text_italic.png" => "img/icons/text_italic.png",
"Underline" => "Aláhúzás",
// "img/icons/text_underline.png" => "img/icons/text_underline.png",
"Strikethrough" => "Áthúzás",
// "img/icons/text_strikethrough.png" => "img/icons/text_strikethrough.png",
"Non-parsed (Wiki syntax does not apply)" => "Nem elemzett (a Wiki szintakszis nem érvenyesül)",
// "img/icons/noparse.png" => "img/icons/noparse.png",
"Align Center" => "Középre igazít",
// "img/icons/text_align_center.png" => "img/icons/text_align_center.png",
"Horizontal Bar" => "Horizontális eszköztár",
// "img/icons/page.png" => "img/icons/page.png",
"Page Break" => "Oldaltörés",
// "img/icons/page_break.png" => "img/icons/page_break.png",
"Box" => "Doboz",
// "img/icons/box.png" => "img/icons/box.png",
// "img/icons/email.png" => "img/icons/email.png",
"Heading" => "Fejléc",
"Title bar" => "Címléc",
// "img/icons/book.png" => "img/icons/book.png",
"Unordered List" => "Rendezetlen lista",
// "img/icons/text_list_bullets.png" => "img/icons/text_list_bullets.png",
"Ordered List" => "Rendezett lista",
// "img/icons/text_list_numbers.png" => "img/icons/text_list_numbers.png",
"Special Characters" => "Speciális karakterek",
// "lib/ckeditor_tiki/ckeditor-icons/specialchar.gif" => "lib/ckeditor_tiki/ckeditor-icons/specialchar.gif",
// "img/smiles/icon_smile.gif" => "img/smiles/icon_smile.gif",
"Foreground color" => "Előtér szín",
// "img/icons/palette.png" => "img/icons/palette.png",
"Background Color" => "Háttérszín",
// "img/icons/palette_bg.png" => "img/icons/palette_bg.png",
"Wiki Link" => "Wiki link",
// "img/icons/page_link.png" => "img/icons/page_link.png",
"External Link" => "Külső link",
// "img/icons/world_link.png" => "img/icons/world_link.png",
// "img/icons/table.png" => "img/icons/table.png",
"Table Builder" => "Táblázat",
// "img/icons/find.png" => "img/icons/find.png",
"Find Text" => "Szöveg keresés",
// "img/icons/text_replace.png" => "img/icons/text_replace.png",
"Text Replace" => "Szöveg kicserélés",
"Full Screen Edit" => "Teljes képernyő",
"Wiki Help" => "Wiki súgó",
// "Wiki Wysiwyg Help" => "Wiki Wysiwyg Help",
"Wysiwyg Help" => "Wysiwyg súgó",
"Choose or upload images" => "Kép kiválasztása vagy feltöltése",
// "img/icons/pictures.png" => "img/icons/pictures.png",
// "Choose or upload files" => "Choose or upload files",
// "img/icons/file-manager-add.png" => "img/icons/file-manager-add.png",
"Switch Editor (wiki or WYSIWYG)" => "Szerkesztő váltása (wiki vagy WYSIWYG)",
// "img/icons/pencil_go.png" => "img/icons/pencil_go.png",
// "Save Sheet" => "Save Sheet",
// "img/icons/disk.png" => "img/icons/disk.png",
// "Add Row After Selection Or To End If No Selection" => "Add Row After Selection Or To End If No Selection",
// "img/icons/sheet_row_add.png" => "img/icons/sheet_row_add.png",
// "Add Multiple Rows After Selection Or To End If No Selection" => "Add Multiple Rows After Selection Or To End If No Selection",
// "img/icons/sheet_row_add_multi.png" => "img/icons/sheet_row_add_multi.png",
// "Add Row Before Selection Or To End If No Selection" => "Add Row Before Selection Or To End If No Selection",
// "Delete Selected Row" => "Delete Selected Row",
// "img/icons/sheet_row_delete.png" => "img/icons/sheet_row_delete.png",
// "Add Column After Selection Or To End If No Selection" => "Add Column After Selection Or To End If No Selection",
// "img/icons/sheet_col_add.png" => "img/icons/sheet_col_add.png",
// "Delete Selected Column" => "Delete Selected Column",
// "img/icons/sheet_col_delete.png" => "img/icons/sheet_col_delete.png",
// "Add Multiple Columns After Selection Or To End If No Selection" => "Add Multiple Columns After Selection Or To End If No Selection",
// "img/icons/sheet_col_add_multi.png" => "img/icons/sheet_col_add_multi.png",
// "Add Column Before Selection Or To End If No Selection" => "Add Column Before Selection Or To End If No Selection",
"Get Cell Range" => "Mező határ",
// "img/icons/sheet_get_range.png" => "img/icons/sheet_get_range.png",
"Find" => "Keresés",
"Refresh Calculations" => "Számítások frissítése",
// "img/icons/arrow_refresh.png" => "img/icons/arrow_refresh.png",
// "Finish Editing" => "Finish Editing",
// "img/icons/close.png" => "img/icons/close.png",
"Admin Toolbars" => "Eszköztárak szerkesztése",
// "Reset Colors" => "Reset Colors",
"Reset" => "Visszaállítás",
// "*** ERROR: Tracker ID not set ***" => "*** ERROR: Tracker ID not set ***",
// "*** ERROR: Field ID not set ***" => "*** ERROR: Field ID not set ***",
// "*** ERROR: Tracker %0 not found ***" => "*** ERROR: Tracker %0 not found ***",
// "*** ERROR: Field %0 not found ***" => "*** ERROR: Field %0 not found ***",
// "Problem inserting tracker item: trackerId=%0, created=%1, lastModif=%2, status=%3" => "Problem inserting tracker item: trackerId=%0, created=%1, lastModif=%2, status=%3",
// "Problem converting tracker item link field: trackerId=%0, fieldId=%1, itemId=%2" => "Problem converting tracker item link field: trackerId=%0, fieldId=%1, itemId=%2",
"Field is not numeric" => "A mező nem numerikus",
// "Function" => "Function",
// "Tracker field setup error - display field not found: " => "Tracker field setup error - display field not found: ",
"Item Modification" => "Tétel módosítása",
"Item creation" => "Tétel létrehozása",
"Item" => "Tétel",
"Subject" => "Tárgy",
// "Tracker was modified at %0 by %1" => "Tracker was modified at %0 by %1",
// "View the tracker item at" => "View the tracker item at",
// "Tracker field not enabled: fieldId=%0 type=%1" => "Tracker field not enabled: fieldId=%0 type=%1",
"Message" => "Üzenet",
// "No extra information for that attached file. " => "No extra information for that attached file. ",
// "(AT)" => "(AT)",
// "(DOT)" => "(DOT)",
// "Can create/close a book" => "Can create/close a book",
// "Can create/edit/lock accounts" => "Can create/edit/lock accounts",
// "Create a new transaction" => "Create a new transaction",
// "Permission to view the journal" => "Permission to view the journal",
// "Can book into the stack where statements can be changed" => "Can book into the stack where statements can be changed",
// "Can import statements from external accounts" => "Can import statements from external accounts",
// "Can manage templates for recurring transactions" => "Can manage templates for recurring transactions",
// "Can admin the articles" => "Can admin the articles",
// "Can approve submissions" => "Can approve submissions",
// "Can admin article topics" => "Can admin article topics",
// "Can admin article types" => "Can admin article types",
// "Can read article headings" => "Can read article headings",
// "Submitted articles automatically approved" => "Submitted articles automatically approved",
// "Can edit articles" => "Can edit articles",
// "Can edit submissions" => "Can edit submissions",
// "Can read articles" => "Can read articles",
"Can remove articles" => "Eltávolíthat cikket",
// "Can remove submissions" => "Can remove submissions",
"Can submit articles" => "Beküldhet cikket",
// "Can rate articles" => "Can rate articles",
// "Can read a topic (Applies only to individual topic perms)" => "Can read a topic (Applies only to individual topic perms)",
// "Can view recordings from past meetings" => "Can view recordings from past meetings",
// "Can join a meeting" => "Can join a meeting",
// "Can moderate a meeting" => "Can moderate a meeting",
// "Can create a meeting" => "Can create a meeting",
// "Can admin blogs" => "Can admin blogs",
// "Can assign perms to blog" => "Can assign perms to blog",
// "Can post to a blog" => "Can post to a blog",
// "Can create a blog" => "Can create a blog",
"Can read blogs" => "Olvashat blogot",
// "Can view in module and feed the blog posts" => "Can view in module and feed the blog posts",
// "Can view in module and feed the blog" => "Can view in module and feed the blog",
// "Can create/admin calendars" => "Can create/admin calendars",
// "Can add events in the calendar" => "Can add events in the calendar",
// "Can change events in the calendar" => "Can change events in the calendar",
// "Can browse the calendar" => "Can browse the calendar",
// "Can view events details" => "Can view events details",
// "Can add own user to the participants" => "Can add own user to the participants",
// "Can add guest to the participants" => "Can add guest to the participants",
// "Can view Tiki tools calendar" => "Can view Tiki tools calendar",
"Can admin categories" => "Karbantarthat kategóriát",
// "Can see the category in a listing" => "Can see the category in a listing",
// "Can add objects to the category (needs tiki_p_modify_object_categories)" => "Can add objects to the category (needs tiki_p_modify_object_categories)",
// "Can remove objects from the category (needs tiki_p_modify_object_categories)" => "Can remove objects from the category (needs tiki_p_modify_object_categories)",
// "Can assign perms to category)" => "Can assign perms to category)",
// "Administrator can create channels, remove channels, etc" => "Administrator can create channels, remove channels, etc",
// "Can use the chat system" => "Can use the chat system",
// "Can admin received articles" => "Can admin received articles",
// "Can admin received pages" => "Can admin received pages",
// "Can send articles to other sites" => "Can send articles to other sites",
// "Can send articles to this site" => "Can send articles to this site",
// "Can send pages to this site" => "Can send pages to this site",
// "Can send pages to other sites" => "Can send pages to other sites",
"Can post new comments" => "Posztolhat új kommenteket",
"Can read comments" => "Olvashat oldalakat",
"Can admin comments" => "Adminisztrálhat kommentket",
"Can edit all comments" => "Szerkesztheti az összes kommentet",
"Can delete comments" => "Törölhet kommentet",
"Can vote comments" => "Szavazhat kommentekről",
// "Can admin content templates" => "Can admin content templates",
// "Can edit content templates" => "Can edit content templates",
// "Can use content templates" => "Can use content templates",
// "Can admin contributions" => "Can admin contributions",
// "Can admin the directory" => "Can admin the directory",
// "Can admin directory categories" => "Can admin directory categories",
// "Can admin directory sites" => "Can admin directory sites",
// "Submitted links are valid" => "Submitted links are valid",
// "Can submit sites to the directory" => "Can submit sites to the directory",
// "Can validate submitted links" => "Can validate submitted links",
"Can use the directory" => "Használhatja a linktárat",
"Can execute arbitrary queries on a given DSN" => "Végrehajthat lekérdezéseket bizonyos DSN-eken",
"Can admin faqs" => "Adminisztrálhat GYIKet",
// "Can suggest faq questions" => "Can suggest faq questions",
"Can view faqs" => "Megtekinthet GYIK-et",
"Can download files" => "Letölthet fájlokat",
"Can upload files" => "Feltölthet fájlt",
"Can list file galleries" => "Listázhat fájlgalériákat",
"Can view file galleries" => "Megtekinthet fájlgalériákat",
"Can admin file galleries" => "Adminisztrálhat fájlgalériákat",
"Can assign perms to file gallery" => "Oszthat  jogosultságokat fájlgalériához",
"Can use Directory Batch Load" => "Használhatja a tömeges fájlfeltöltést",
"Can upload zip files with files" => "Feltölthet ZIP fájlt",
"Can create file galleries" => "Létrehozhat fájlgalériákat",
"Can edit a gallery file" => "Szerkeszthet fájlgalériákat",
// "Can remove files" => "Can remove files",
"Can view file galleries explorer" => "Megtekintheti a fájlgaléria böngészőt",
"Can view file galleries path" => "Megtekintheti fájlgalériák útvonalát",
"Can admin forums" => "Adminisztrálhat fórumokat",
"Can attach to forum posts" => "Csatolhat fórum posztokhoz",
"Auto approve forum posts" => "Automatikusan jóváhagyhat fórum posztokat",
"Can edit own forum posts" => "Szerkesztheti saját fórum posztjait",
"Can post in forums" => "Posztolhat fórumba",
"Can start threads in forums" => "Témákat nyithat a fórumokban",
"Can read forums" => "Olvashat fórumokat",
// "Can report posts to moderator" => "Can report posts to moderator",
"Can vote comments in forums" => "Szavazhat kommentekre a fórumokban",
"Can browse freetags" => "Böngészhet a címkéket",
// "Can admin freetags" => "Can admin freetags",
// "Can tag objects" => "Can tag objects",
// "Can unassign tags from an object" => "Can unassign tags from an object",
"Can subscribe to groups" => "Feliratkozhat csoportokra",
// "Can invite user to my groups" => "Can invite user to my groups",
"Can view the group" => "Megtekinthet csoportokat",
"Can view the group members" => "Megtekintheti csoportok tagjait",
"Can add group members" => "Hozzáadhat csoporttagokat",
"Can remove group members" => "Eltávolíthat csoporttagokat",
"Can join or leave the group" => "Csatlakozhat vagy elhagyhat csoportokat",
// "Can edit HTML pages" => "Can edit HTML pages",
// "Can view HTML pages" => "Can view HTML pages",
// "Can admin Image Galleries" => "Can admin Image Galleries",
// "Can assign perms to image gallery" => "Can assign perms to image gallery",
// "Can upload zip files with images" => "Can upload zip files with images",
// "Can create image galleries" => "Can create image galleries",
// "Can list image galleries" => "Can list image galleries",
// "Can upload images" => "Can upload images",
// "Can view image galleries" => "Can view image galleries",
// "Can admin Kaltura video feature" => "Can admin Kaltura video feature",
// "Can upload video or record from webcam" => "Can upload video or record from webcam",
// "Can edit media information" => "Can edit media information",
// "Can create kaltura remix video" => "Can create kaltura remix video",
// "Can delete media" => "Can delete media",
// "Can download media" => "Can download media",
// "Can list media" => "Can list media",
// "Can view media" => "Can view media",
// "Can create new mapfile" => "Can create new mapfile",
"Can delete mapfiles" => "Törölhet térkép fájlt",
// "Can edit mapfiles" => "Can edit mapfiles",
// "Can view mapfiles" => "Can view mapfiles",
// "Can view contents of mapfiles" => "Can view contents of mapfiles",
"Can broadcast messages to all user" => "Üzenetet küldhet az összes felhasználó részére",
"Can broadcast messages to groups" => "Üzeneteket küldhet csoportoknak",
"Can use the messaging system" => "Használhatja az üzenőrendszert",
"Can admin newsletters" => "Karbantarthat hírlevelet",
// "Can subscribe many e-mails at once (requires tiki_p_subscribe email)" => "Can subscribe many e-mails at once (requires tiki_p_subscribe email)",
"Can send newsletters" => "Kiküldhet hírlevelet",
// "Can subscribe any email to newsletters" => "Can subscribe any email to newsletters",
// "Can subscribe to newsletters" => "Can subscribe to newsletters",
// "Can view the archive of a newsletters" => "Can view the archive of a newsletters",
"Can list newsletters" => "Listázhat hírlevelet",
// "Can administer payments" => "Can administer payments",
// "Can view payment requests and details" => "Can view payment requests and details",
// "Can enter manual payments" => "Can enter manual payments",
// "Can request a payment" => "Can request a payment",
// "Can view the perspective" => "Can view the perspective",
// "Can edit the perspective" => "Can edit the perspective",
// "Can create a perspective" => "Can create a perspective",
"Can admin perspectives" => "Karbantarthat perspektívát",
// "Can admin polls" => "Can admin polls",
// "Can view poll results" => "Can view poll results",
"Can vote polls" => "Szavazhat kérdőíveken",
"Can view poll voters" => "Megnézheti szavazás szavazóit",
// "Can admin quizzes" => "Can admin quizzes",
// "Can take quizzes" => "Can take quizzes",
// "Can view quiz stats" => "Can view quiz stats",
// "Can view user quiz results" => "Can view user quiz results",
// "Can admin sheet" => "Can admin sheet",
// "Can create and edit sheets" => "Can create and edit sheets",
"Can view sheet" => "Megtekinthet Tiki táblázatot",
// "Can view sheet history" => "Can view sheet history",
// "Can admin shoutbox (Edit/remove messages)" => "Can admin shoutbox (Edit/remove messages)",
// "Can post messages in shoutbox" => "Can post messages in shoutbox",
// "Can view shoutbox" => "Can view shoutbox",
"user can use social network integration" => "Használhatja a közösségi hálózat integrációt",
// "user can register this site with social networks" => "user can register this site with social networks",
// "Admin live support system" => "Admin live support system",
// "Can use live support system" => "Can use live support system",
// "Can admin surveys" => "Can admin surveys",
// "Can take surveys" => "Can take surveys",
// "Can view survey stats" => "Can view survey stats",
// "Can admin the TikiTests" => "Can admin the TikiTests",
// "Can edit TikiTests" => "Can edit TikiTests",
// "Can replay the TikiTests" => "Can replay the TikiTests",
"Can admin trackers" => "Karbantarthat űrlapot",
// "Can attach files to tracker items" => "Can attach files to tracker items",
// "Can view tracker items attachments and download" => "Can view tracker items attachments and download",
// "Can insert comments for tracker items" => "Can insert comments for tracker items",
// "Can view tracker items comments" => "Can view tracker items comments",
// "Can create new items for trackers" => "Can create new items for trackers",
// "Can list trackers" => "Can list trackers",
// "Can change tracker items" => "Can change tracker items",
// "Can change pending tracker items" => "Can change pending tracker items",
// "Can change closed tracker items" => "Can change closed tracker items",
// "Can remove tracker items" => "Can remove tracker items",
// "Can remove pending tracker items" => "Can remove pending tracker items",
// "Can remove closed tracker items" => "Can remove closed tracker items",
// "Can view rating result for tracker items" => "Can view rating result for tracker items",
// "Can vote a rating for tracker items" => "Can vote a rating for tracker items",
// "Can re-vote a rating for tracker items" => "Can re-vote a rating for tracker items",
// "Can view trackers" => "Can view trackers",
// "Can view closed trackers items" => "Can view closed trackers items",
// "Can view pending trackers items" => "Can view pending trackers items",
// "Can watch tracker" => "Can watch tracker",
// "Can export tracker items" => "Can export tracker items",
// "Can save a .CSV backup of entire trackers" => "Can save a .CSV backup of entire trackers",
// "Can trigger the transition between two states" => "Can trigger the transition between two states",
"Can admin users" => "Adminisztrálhat felhasználókat",
"Can cache user bookmarks" => "Cache-elhet felhasználói könyvjelzőket",
// "Can configure modules" => "Can configure modules",
"Can create user bookmarks" => "Létrehozhat felhasználói kedvenceket",
// "Can use the mini event calendar" => "Can use the mini event calendar",
// "Can use the notepad" => "Can use the notepad",
// "Can admin public tasks" => "Can admin public tasks",
"Can use tasks" => "Használhat feladatokat",
// "Can receive tasks from other users" => "Can receive tasks from other users",
// "Can send tasks to other users" => "Can send tasks to other users",
// "Can upload personal files" => "Can upload personal files",
// "Can create items in personal menu" => "Can create items in personal menu",
// "Can list registered users" => "Can list registered users",
// "Can invite users by email, and include them in groups" => "Can invite users by email, and include them in groups",
// "Can use webmail" => "Can use webmail",
// "Can use group webmail" => "Can use group webmail",
// "Can admin group webmail accounts" => "Can admin group webmail accounts",
// "Can use personal webmail accounts" => "Can use personal webmail accounts",
// "Can admin personal webmail accounts" => "Can admin personal webmail accounts",
"Can view page/pages" => "Megtekinthet oldalakat",
"Can edit pages" => "Szerkeszthet oldalakat",
"Can view wiki history" => "Megtekintheti az előzményeket",
"Can admin the wiki" => "Adminisztrálhatja a wikit",
"Can assign perms to wiki pages" => "Jogosultságokat oszthat wiki oldalakhoz",
// "Can edit copyright notices" => "Can edit copyright notices",
"Can edit dynamic variables" => "Szerkeszthet dinamikus változókat",
// "Can create and edit structures" => "Can create and edit structures",
// "Can export wiki pages using the export feature" => "Can export wiki pages using the export feature",
"Can lock pages" => "Zárolhat oldalakat",
"Can save as minor edit" => "Végezhet kis módosítást",
"Can remove" => "Eltávolíthat",
"Can rename pages" => "Átnevezhet oldalt",
"Can rollback pages" => "Visszaállíthat oldalakat",
"Can upload pictures to wiki pages" => "Képeket tölthet fel wiki oldalakhoz",
"Can use the page as a tracker template" => "Használhatja az oldalt űrlap sablonként",
"Can view in module and feed the wiki pages reference" => "Megtekintheti modulban és feed-elheti a wiki oldalak hivatkozását",
"Can watch structure" => "Figyelhet struktúrát",
// "Can admin attachments on wiki pages" => "Can admin attachments on wiki pages",
// "Can add and change ratings on wiki pages" => "Can add and change ratings on wiki pages",
// "Can attach files to wiki pages" => "Can attach files to wiki pages",
// "Can view wiki attachments and download" => "Can view wiki attachments and download",
"Can view wiki comments" => "Megtekinthet wiki kommentet",
// "Can view rating of wiki pages" => "Can view rating of wiki pages",
"Can view source of wiki pages" => "Megtekintheti wiki oldalak forrását",
// "Can participate to rating of wiki pages" => "Can participate to rating of wiki pages",
"Can view similar wiki pages" => "Megtekinthet hasonló wiki oldalakat",
"View page backlinks" => "Megtekinthet oldal visszahivatkozásokat",
// "Can view unapproved revisions of pages" => "Can view unapproved revisions of pages",
// "Can approve revisions of pages" => "Can approve revisions of pages",
"Can view contributions to a page" => "Megtekintheti egy oldalhoz tartozó hozzájárulásokat",
// "Administrator can manage users, groups and permissions and all features" => "Administrator can manage users, groups and permissions and all features",
"Can access site when closed" => "Beléphet a lezárt weblapra",
// "Administrator can admin banners" => "Administrator can admin banners",
"Can ban users or ips" => "Letilthat felhasználókat és IP címeket",
"Can admin the dynamic content system" => "Adminisztrálhatja a dinamikus tartalmakat",
"Can admin integrator repositories and rules" => "Adminisztrálhat integrálási lerakatokat és szabályokat",
"Can admin mail-in accounts" => "Adminisztrálhat bejövő E-mail címeket",
"Can edit object permissions" => "Adminisztrálhat objektum jogosultságokat",
"Can admin external feeds" => "Adminisztrálhat külső feed-eket",
"Can clean cache" => "Cache-t üríthet",
"Can create new css suffixed with -user" => "Létrehozhat új CSS-t -user suffix-szel",
"Can remove association between two pages in a translation set" => "Eltávolíthat kapcsolatot két oldal között egy fordítási készletben",
"Can admin cookies" => "Adminisztrálhat cookie-kat",
"Can edit translations and create new languages" => "Szerkesztheti a fordításokat és létrehozhat új nyelveket",
"Can edit menu" => "Szerkeszthet menüt",
"Can edit menu option" => "Adminisztrálhat menü opciókat",
"Can edit site templates" => "Szerkeszthet oldal sablonkat",
"Can search" => "Kereshet",
"Can report a link to the webmaster" => "Jelenthet linket a webmesternek",
"Can send a link to a friend" => "Linket küldhet barát részére",
"Can share a page (email, Twitter, Facebook, message, forums)" => "Megoszthat egy oldalt (E-mail, Twitter, Facebook, üzenet, fórumok)",
"Can use HTML in pages" => "Használhat  HTML-t a wiki oldalakon",
"Can view action log" => "Megtekintheti az akció logot",
"Can view action log for users of his own groups" => "Megtekintheti a saját csoportjába tartozó felhasználó akció naplóját",
"Can view integrated repositories" => "Megtekinthet integrált lerakatokat",
// "Can view referrer stats" => "Can view referrer stats",
"Can view site stats" => "Megtekinthet oldal statisztikákat",
"Can view site templates" => "Megtekinthet oldal sablonokat",
"Can admin toolbars" => "Szerkeszthet eszközsorokat",
"Trust all user inputs including plugins (no security checks)" => "Megbízhat az összes felhasználói inputban beleértve a pluginokat. (nincs biztonsági ellenőrzés)",
"Can view unapproved plugin details" => "Megtekintheti a nem jóváhagyott plugin-ok részleteit",
// "Can execute unapproved plugin registered" => "Can execute unapproved plugin registered",
"Can approve plugin execution" => "Jóváhagyhat plugin végrehajtást",
"Can admin mail notifications" => "Adminisztrálhatja az E-mailes értesítéseket",
// "Can delete his/her own account" => "Can delete his/her own account",
// "Can use the importer" => "Can use the importer",
// "Can change the categories of the object" => "Can change the categories of the object",
// "User can administer modules" => "User can administer modules",
// "Can switch between wiki and WYSIWYG modes while editing" => "Can switch between wiki and WYSIWYG modes while editing",
// "User \"%0\" is banned from the group \"%1\"" => "User \"%0\" is banned from the group \"%1\"",
// "Do you want to unban them and continue" => "Do you want to unban them and continue",
// "Password should be at least %0 characters long" => "Password should be at least %0 characters long",
"Password must contain both letters and numbers" => "A jelszónak betűket és számjegyeket is tartalmaznia kell!",
// "The administrator has not yet validated your account. Please wait" => "The administrator has not yet validated your account. Please wait",
// "You must validate your account first. An email has been sent to you" => "You must validate your account first. An email has been sent to you",
// "The registration mail can't be sent. Contact the administrator" => "The registration mail can't be sent. Contact the administrator",
// "The registration mail can't be sent because there is no server email address set, and this feature is disabled" => "The registration mail can't be sent because there is no server email address set, and this feature is disabled",
// "The user email confirmation can't be sent. Contact the administrator" => "The user email confirmation can't be sent. Contact the administrator",
// "Edit field: (Parameter needs to be 'trackerId=XX&fileId=YY' or be empty to use the current field)" => "Edit field: (Parameter needs to be 'trackerId=XX&fileId=YY' or be empty to use the current field)",
// "Edit field: (Incorrect validation parameter)" => "Edit field: (Incorrect validation parameter)",
// "Page already exists" => "Page already exists",
// "Page does not exist" => "Page does not exist",
// "Invalid character combination for username" => "Invalid character combination for username",
"here" => "itt",
// "Could not establish Kaltura session. Try again" => "Could not establish Kaltura session. Try again",
"You need to set your Kaltura account details: " => "Be kell állítani a Kaltura fiókot, lásd: ",
// "Cannot connect with web service" => "Cannot connect with web service",
// "No permission to broadcast to channel" => "No permission to broadcast to channel",
// "Broadcaster successfully authenticated" => "Broadcaster successfully authenticated",
// "No permission to broadcast to any channel" => "No permission to broadcast to any channel",
// "Successfully logged in mobile broadcaster" => "Successfully logged in mobile broadcaster",
// "No viewable channels available for mobile" => "No viewable channels available for mobile",
// "Failed to log in mobile broadcaster" => "Failed to log in mobile broadcaster",
// "Successfully logged in FME" => "Successfully logged in FME",
// "Failed to log in FME" => "Failed to log in FME",
// "No permission to view channel" => "No permission to view channel",
// "Viewer successfully authenticated" => "Viewer successfully authenticated",
// "No permission to view any channel" => "No permission to view any channel",
// "Successfully stored archive in tracker" => "Successfully stored archive in tracker",
// "Failed to stored archive in tracker" => "Failed to stored archive in tracker",
"Personal Phone" => "Személyes telefon",
"Personal Mobile" => "Személyes mobil",
"Personal Fax" => "Személyes fax",
"Work Phone" => "Munkahelyi telefon",
"Work Mobile" => "Munkahelyi mobil",
"Work Fax" => "Munkahelyi fax",
"Company" => "Vállalat",
"Organization" => "Szervezet",
"Department" => "Részleg",
"Division" => "Divízió",
"Job Title" => "Munkakör",
"Street Address" => "Utca cím",
"City" => "Város",
"State" => "Régió",
"Zip Code" => "irányítószám",
// "Mailbox uninitialised??" => "Mailbox uninitialised??",
// "No subject" => "No subject",
// "No mail body found" => "No mail body found",
// "Cannot create aliased page" => "Cannot create aliased page",
// "You attempted to create the following page" => "You attempted to create the following page",
// "That page is an alias for the following pages" => "That page is an alias for the following pages",
// "If you want to create the page, you must first edit each the pages above, and remove the alias link it may contain. This link should look something like this" => "If you want to create the page, you must first edit each the pages above, and remove the alias link it may contain. This link should look something like this",
// "Can't parse HTML data - no grammar file" => "Can't parse HTML data - no grammar file",
"Removed version \$version" => "Eltávolított verzió \$version",
"rollback version " => "verzió visszaállítása",
// "Changed actual version to \$version" => "Changed actual version to \$version",
"No version indicated" => "Nincs verzió feltüntetve",
"Plugin " => "Plugin ",
"failed" => "sikertelen",
// "Required parameters are in</em> <b>bold</b>" => "Required parameters are in</em> <b>bold</b>",
// "Parameter Info" => "Parameter Info",
// "There are no approved versions of this page" => "There are no approved versions of this page",
// "Semantic token already exists" => "Semantic token already exists",
// "Invalid semantic token name" => "Invalid semantic token name",
// "Semantic token not found" => "Semantic token not found",
"Page locked" => "Oldal zárolva",
"Page unlocked" => "Oldal feloldva",
"Removed last version" => "Legutóbbi verzió eltávolítva",
// "Add Freetag" => "Add Freetag",
// "Add a single freetag to specified object" => "Add a single freetag to specified object",
"Object" => "Objektum",
// "Object type and id, as in type:id, if unset, will use current object" => "Object type and id, as in type:id, if unset, will use current object",
// "Add Relation" => "Add Relation",
// "Displays a simple button that toggles i.e. adds or removes a pre-specified relation" => "Displays a simple button that toggles i.e. adds or removes a pre-specified relation",
// "Qualifier" => "Qualifier",
// "Relation qualifier. Usually a three part string separated by 2 periods" => "Relation qualifier. Usually a three part string separated by 2 periods",
// "Source Object" => "Source Object",
// "Object identifier as type:itemId to start the relation from, will use the current object if left blank" => "Object identifier as type:itemId to start the relation from, will use the current object if left blank",
// "Target Object" => "Target Object",
// "Object identifier as type:itemId to end the relation to, will use the current object if left blank" => "Object identifier as type:itemId to end the relation to, will use the current object if left blank",
// "Button Text for Add" => "Button Text for Add",
// "Text to show on the button to add relation" => "Text to show on the button to add relation",
// "Button Text for Already Added State" => "Button Text for Already Added State",
// "Text to show on the button when relation is already added" => "Text to show on the button when relation is already added",
// "Relation Added" => "Relation Added",
// "Mouseover Button Text for Remove" => "Mouseover Button Text for Remove",
// "Text to show on the button to remove relation" => "Text to show on the button to remove relation",
// "Remove Relation" => "Remove Relation",
// "Button Id" => "Button Id",
// "A unique ID to distinguish the button from others on the page if there is more than one" => "A unique ID to distinguish the button from others on the page if there is more than one",
// "Source and target object cannot be the same" => "Source and target object cannot be the same",
"Add to cart" => "Kosárba tesz",
// "PluginAddToCart" => "PluginAddToCart",
// "Adds a product to the virtual cart. The cart can be manipulated using the cart module" => "Adds a product to the virtual cart. The cart can be manipulated using the cart module",
// "Product code" => "Product code",
// "Unique identifier for the product. Two products with the same code will be the same and the information used will be the one of the first in" => "Unique identifier for the product. Two products with the same code will be the same and the information used will be the one of the first in",
// "Label for the product in the cart" => "Label for the product in the cart",
// "Product Type" => "Product Type",
// "The product type that is being sold, which will affect fulfillment, e.g. standard product, gift certificate, event ticket" => "The product type that is being sold, which will affect fulfillment, e.g. standard product, gift certificate, event ticket",
// "Product Class" => "Product Class",
// "The class the product belongs to, can be used to limit how gift cards are used" => "The class the product belongs to, can be used to limit how gift cards are used",
// "Product Bundle" => "Product Bundle",
// "The bundle the product belongs to, can be used to limit how gift cards are used, will automatically add other products in same class to cart" => "The bundle the product belongs to, can be used to limit how gift cards are used, will automatically add other products in same class to cart",
// "Bundle Class" => "Bundle Class",
// "The class the bundle belongs to, can be used to limit how gift cards are used" => "The class the bundle belongs to, can be used to limit how gift cards are used",
// "Price" => "Price",
// "The price to charge for the item" => "The price to charge for the item",
// "URL of the product's information. The URL may be relative or absolute (begin with http://)" => "URL of the product's information. The URL may be relative or absolute (begin with http://)",
"Button label" => "Gomb felirat",
// "Text for the submit button. default: \"Add to cart\"" => "Text for the submit button. default: \"Add to cart\"",
// "Associated event code" => "Associated event code",
// "Unique identifier for the event that is associated to the product" => "Unique identifier for the event that is associated to the product",
// "Automatically checkout" => "Automatically checkout",
// "Automatically checkout for purchase and send user to pay (this is disabled when there is already something in the cart)" => "Automatically checkout for purchase and send user to pay (this is disabled when there is already something in the cart)",
// "Buy on behalf of" => "Buy on behalf of",
// "Allows the selection of user to make purchase on behalf of" => "Allows the selection of user to make purchase on behalf of",
// "Shop as anonymous always" => "Shop as anonymous always",
// "Add to cart as anonymous shopper even if logged in" => "Add to cart as anonymous shopper even if logged in",
// "Forward to this URL after free purchase" => "Forward to this URL after free purchase",
// "Gift certificate" => "Gift certificate",
// "Allows user to add gift certificate from the product view" => "Allows user to add gift certificate from the product view",
// "Order Item ID to exchange product" => "Order Item ID to exchange product",
// "Used in conjunction with exchange feature" => "Used in conjunction with exchange feature",
// "Product ID to exchange to" => "Product ID to exchange to",
// "Amount of new product to exchange for" => "Amount of new product to exchange for",
// "Should normally be set to the amount of products in the order being exchanged" => "Should normally be set to the amount of products in the order being exchanged",
// "Ajax add to cart feature" => "Ajax add to cart feature",
// "Attempts to turn ajax for cart on" => "Attempts to turn ajax for cart on",
// "A session must be active to use the cart" => "A session must be active to use the cart",
// "Please enter your shopper information first" => "Please enter your shopper information first",
// "The order was recorded and is now awaiting payment. Reference number is %0" => "The order was recorded and is now awaiting payment. Reference number is %0",
// "Your free order of %0 (%1) has been processed. An email has been sent to you for your records" => "Your free order of %0 (%1) has been processed. An email has been sent to you for your records",
// "Your free order of %0 (%1) has been processed" => "Your free order of %0 (%1) has been processed",
// "%0 (%1) was added to your cart" => "%0 (%1) was added to your cart",
// "Invalid gift certificate: " => "Invalid gift certificate: ",
// "Add to Google Calendar" => "Add to Google Calendar",
// "Add a calendar item to a Google calendar" => "Add a calendar item to a Google calendar",
// "Calendar item ID" => "Calendar item ID",
// "The item ID of the calendar to add to Google calendar" => "The item ID of the calendar to add to Google calendar",
// "A calendar item ID number" => "A calendar item ID number",
// "Icon Style" => "Icon Style",
// "Choose the icon style" => "Choose the icon style",
// "Either 1, 2 or 3" => "Either 1, 2 or 3",
// "One" => "One",
// "Two" => "Two",
// "Three" => "Three",
// "Adjust Inventory" => "Adjust Inventory",
// "PluginAdjustInventory" => "PluginAdjustInventory",
// "Modifies inventory of a product" => "Modifies inventory of a product",
// "Product ID" => "Product ID",
// "Product ID of item in the cart tracker" => "Product ID of item in the cart tracker",
// "Show add" => "Show add",
// "y|n" => "y|n",
// "Show subtract" => "Show subtract",
// "Inventory was adjusted by %0" => "Inventory was adjusted by %0",
// "User Agent Info" => "User Agent Info",
// "Show user's browser and server information" => "Show user's browser and server information",
// "Info" => "Info",
// "Display's the visitor's IP address (IP or default), browser information (BROWSER), or server software (SVRSW)" => "Display's the visitor's IP address (IP or default), browser information (BROWSER), or server software (SVRSW)",
// "IP address" => "IP address",
// "Server software" => "Server software",
// "Browser" => "Browser",
"Anchor Link" => "Horgony link",
// "Create a link to an anchor" => "Create a link to an anchor",
// "Anchor link label" => "Anchor link label",
"Anchor Name" => "Horgony név",
// "The anchor name as defined in the ANAME plugin" => "The anchor name as defined in the ANAME plugin",
// "The name of the wiki page containing the anchor. If empty, the anchor name will be searched for on the wiki page where the plugin is used" => "The name of the wiki page containing the anchor. If empty, the anchor name will be searched for on the wiki page where the plugin is used",
// "Create an anchor that can be linked to" => "Create an anchor that can be linked to",
"The name of the anchor" => "A horgony neve",
"Image Annotation" => "Kép annotáció",
// "Annotate an image" => "Annotate an image",
"Autogenerated content. Leave blank initially" => "Automatikusan generált tartalom. Először hagyjuk üresen",
// "Absolute URL to the image or relative path from tiki root" => "Absolute URL to the image or relative path from tiki root",
// "Image width in pixels" => "Image width in pixels",
// "Image height in pixels" => "Image height in pixels",
"Alignment" => "Igazítás",
// "Image alignment. Possible values: left, right, center. Default is left" => "Image alignment. Possible values: left, right, center. Default is left",
"Center" => "Középre",
"Save changes to annotations" => "Menti az annotációk válozásait",
// "Image annotations changed" => "Image annotations changed",
// "Application Frame" => "Application Frame",
// "Creates a frame to assemble custom applications in. Components in the frame will be various wiki pages and modules" => "Creates a frame to assemble custom applications in. Components in the frame will be various wiki pages and modules",
// "Application layout" => "Application layout",
// "Minimal height" => "Minimal height",
// "Prevent the frame from becoming any shorter than the specified size" => "Prevent the frame from becoming any shorter than the specified size",
// "Hide left column" => "Hide left column",
// "Hide the left column when the application frame is in use to provide more space to the application" => "Hide the left column when the application frame is in use to provide more space to the application",
// "Hide right column" => "Hide right column",
// "Hide the right column when the application frame is in use to provide more space to the application" => "Hide the right column when the application frame is in use to provide more space to the application",
// "Full page" => "Full page",
// "Occupy the complete content area of the page" => "Occupy the complete content area of the page",
// "Absolute Position" => "Absolute Position",
// "Position the app frame to use absolute position and really use all available space" => "Position the app frame to use absolute position and really use all available space",
// "When using absolute mode, leave some space for the header at the top" => "When using absolute mode, leave some space for the header at the top",
// "Template file not found: %0" => "Template file not found: %0",
// "Pan/Zoom" => "Pan/Zoom",
"Select" => "Kiválasztás",
// "Select/Modify" => "Select/Modify",
// "Draw Polygon" => "Draw Polygon",
// "Draw Path" => "Draw Path",
// "Reset Zoom" => "Reset Zoom",
"Archive Builder" => "Arhív készítő",
// "Build a zip archive that can be downloaded" => "Build a zip archive that can be downloaded",
// "Description of the archive content. Multiple handlers are available for content types. One per line. Ex: page-as-pdf:some-folder/foo.pdf:HomePage , tracker-attachments:target-folder/:3435" => "Description of the archive content. Multiple handlers are available for content types. One per line. Ex: page-as-pdf:some-folder/foo.pdf:HomePage , tracker-attachments:target-folder/:3435",
// "Archive Name" => "Archive Name",
// "Upon download, the name of the file that will be provided" => "Upon download, the name of the file that will be provided",
// "Missing extension zip" => "Missing extension zip",
// "Incorrect parameter" => "Incorrect parameter",
// "Download archive" => "Download archive",
// "Display a field of an article" => "Display a field of an article",
"The article field to display. Default field is Heading" => "A megjelenítendő cikk mező. Alapértelmezett mező a cikk fejléce",
"Article ID" => "Cikk ID",
"The article to display. If no value is provided, most recent article will be used" => "A megjelenítendő cikk azonosítója. Ha nincs érték megadva akkor a legutóbbi cikkek kerülnek listázásra",
"Article List" => "Cikk lista",
// "Display multiple articles" => "Display multiple articles",
// "Use Pagination" => "Use Pagination",
// "Activate pagination when articles listing are long. Default is n" => "Activate pagination when articles listing are long. Default is n",
// "Maximum Displayed" => "Maximum Displayed",
// "The number of articles to display in the list (no max set by default)" => "The number of articles to display in the list (no max set by default)",
// "If Pagination is set to y (Yes), this will determine the amount of articles per page" => "If Pagination is set to y (Yes), this will determine the amount of articles per page",
// "Topic Name Filter" => "Topic Name Filter",
// "Filter the list of articles by topic. Example: " => "Filter the list of articles by topic. Example: ",
// "Topic ID Filter" => "Topic ID Filter",
// "Filter the list of articles by topic ID. Example: " => "Filter the list of articles by topic ID. Example: ",
// "Type Filter" => "Type Filter",
// "Filter the list of articles by types. Example: " => "Filter the list of articles by types. Example: ",
"Category ID" => "Kategória ID",
// "The ID of the category that articles need to be in to be listed" => "The ID of the category that articles need to be in to be listed",
// "List only articles in this language" => "List only articles in this language",
"Sort order" => "Rendezés módja",
// "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")" => "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")",
// "Use random to have random items" => "Use random to have random items",
// "Specific order" => "Specific order",
// "List of ArticleId that must appear in this order if present" => "List of ArticleId that must appear in this order if present",
// "Only these articles" => "Only these articles",
// "List of ArticleId to display separated by |" => "List of ArticleId to display separated by |",
// "Not these articles" => "Not these articles",
// "List of ArticleId that can not be displayed separated by |" => "List of ArticleId that can not be displayed separated by |",
"Quiet" => "Csendes",
// "Whether to not report when there are no articles (no reporting by default)" => "Whether to not report when there are no articles (no reporting by default)",
// "Title Only" => "Title Only",
// "Whether to only show the title of the articles (not set to title only by default)" => "Whether to only show the title of the articles (not set to title only by default)",
// "Body Only" => "Body Only",
// "Whether to only show the body of the articles or just the heading and title. (not set to body only by default)" => "Whether to only show the body of the articles or just the heading and title. (not set to body only by default)",
// "Starting Article" => "Starting Article",
// "The article number that the list should start with (starts with first article by default)" => "The article number that the list should start with (starts with first article by default)",
// "This will not work if Pagination is used" => "This will not work if Pagination is used",
"Start Date" => "Kezdés dátuma",
// "Earliest date to select articles from" => "Earliest date to select articles from",
// " (YYYY-MM-DD)" => " (YYYY-MM-DD)",
// "Latest date to select articles from" => "Latest date to select articles from",
// "Period quantity" => "Period quantity",
// "Numeric value to display only last articles published within a user defined time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how many of those units are to be considered to define the time frame. If this parameter is set, \"Start Date\" and \"End date\" are ignored" => "Numeric value to display only last articles published within a user defined time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how many of those units are to be considered to define the time frame. If this parameter is set, \"Start Date\" and \"End date\" are ignored",
// "Period unit" => "Period unit",
// "Time unit used with \"Period quantity\"" => "Time unit used with \"Period quantity\"",
// "Override Dates" => "Override Dates",
// "Whether to obey article type's \"show before publish\" and \"show after expiry\" settings (not obeyed by default)" => "Whether to obey article type's \"show before publish\" and \"show after expiry\" settings (not obeyed by default)",
// "Container class" => "Container class",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")",
// "Large First Image" => "Large First Image",
// "If set to y (Yes), the first image will be displayed with the dimension used to view of the article" => "If set to y (Yes), the first image will be displayed with the dimension used to view of the article",
// "Additional URL Param to the link to read article" => "Additional URL Param to the link to read article",
// "Show actions (buttons and links)" => "Show actions (buttons and links)",
// "Whether to show the buttons and links to do actions on each article (for the actions you have permission to do" => "Whether to show the buttons and links to do actions on each article (for the actions you have permission to do",
// "No translation" => "No translation",
// "User or pipe separated list of two letter language codes for additional languages to display. List pages with no language or with a missing translation in one of the language" => "User or pipe separated list of two letter language codes for additional languages to display. List pages with no language or with a missing translation in one of the language",
"Displays an attachment or a list of them" => "Megjelenít egy mellékletet vagy a mellékletek listáját",
// "File name of the attached file to link to. Either name, file, id or num can be used to identify a single attachment" => "File name of the attached file to link to. Either name, file, id or num can be used to identify a single attachment",
"File" => "Fájl",
"Same as name" => "Ugyanaz mint a név",
"Page" => "Oldal",
// "Name of the wiki page the file is attached to. If left empty when the plugin is used on a wiki page, this defaults to that wiki page" => "Name of the wiki page the file is attached to. If left empty when the plugin is used on a wiki page, this defaults to that wiki page",
"Show Description" => "Leírás megjelenítése",
// "Shows the description as the link text instead of the file name (not used by default)" => "Shows the description as the link text instead of the file name (not used by default)",
// "Bullets" => "Bullets",
// "Makes the list of attachments a bulleted list (not set by default)" => "Makes the list of attachments a bulleted list (not set by default)",
// "Indicates that this file is an image, and should be displayed inline using the img tag (not set by default)" => "Indicates that this file is an image, and should be displayed inline using the img tag (not set by default)",
// "Custom Label" => "Custom Label",
// "Makes the text between the {ATTACH} tags the link text instead of the file name or description. Only the first attachment will be listed" => "Makes the text between the {ATTACH} tags the link text instead of the file name or description. Only the first attachment will be listed",
// "Lists links to all attachments for the entire tiki site together with pages they are attached to when set to 1 (Yes)" => "Lists links to all attachments for the entire tiki site together with pages they are attached to when set to 1 (Yes)",
// "Order Number" => "Order Number",
// "Identifies the attachment to link to by the order of the attachment in the list of attachments to a page instead of by file name or ID. Either name, file, id or num can be used to identify a single attachment" => "Identifies the attachment to link to by the order of the attachment in the list of attachments to a page instead of by file name or ID. Either name, file, id or num can be used to identify a single attachment",
// "Identifies the attachment to link to by id number instead of by file name or order number. Either name, file, id or num can be used to identify a single attachment" => "Identifies the attachment to link to by id number instead of by file name or order number. Either name, file, id or num can be used to identify a single attachment",
// "The alt text that pops up on mouseover will include the number of downloads of the attachment at the end when set to 1 (Yes)" => "The alt text that pops up on mouseover will include the number of downloads of the attachment at the end when set to 1 (Yes)",
// "File Type Icon" => "File Type Icon",
// "A file type icon is displayed in front of the attachment link when this is set to 1" => "A file type icon is displayed in front of the attachment link when this is set to 1",
// "Page \"%0\" does not exist" => "Page \"%0\" does not exist",
"No such attachment on this page" => "Nincs ilyen melléklet ezen az oldalon",
"Attributes" => "Attribútumok",
// "Assign generic attributes to the current object" => "Assign generic attributes to the current object",
// "View author contributions to a wiki page" => "View author contributions to a wiki page",
"text" => "szöveg",
// "User name of the user who wrote the text" => "User name of the user who wrote the text",
// "Deleted by User" => "Deleted by User",
// "User name of the user who deleted the text" => "User name of the user who deleted the text",
// "Make Visible" => "Make Visible",
// "Show popup with author/deleted by" => "Show popup with author/deleted by",
// "Generate a popup with names of author(s) (default: no)" => "Generate a popup with names of author(s) (default: no)",
// "deleted by" => "deleted by",
// "Should this author's contribution be visible (default: no)" => "Should this author's contribution be visible (default: no)",
"Avatar" => "Avatár",
// "Display a user's avatar" => "Display a user's avatar",
// "The wiki page the avatar will link to. If empty and the user's information is public, \n\t\t\t\t\t\t\t\tthen the avatar will link automatically the that user's user information page" => "The wiki page the avatar will link to. If empty and the user's information is public, \n\t\t\t\t\t\t\t\tthen the avatar will link automatically the that user's user information page",
"Float" => "Lebegés",
// "Align the avatar on the page" => "Align the avatar on the page",
"Back" => "Vissza",
// "Displays a link that goes back one page in the browser history" => "Displays a link that goes back one page in the browser history",
// "Lists all pages that link to a particular page" => "Lists all pages that link to a particular page",
// "The page links will point to. Default value is the current page" => "The page links will point to. Default value is the current page",
// "Displayed Information" => "Displayed Information",
// "Pipe separated list of fields to display. ex: hits|user" => "Pipe separated list of fields to display. ex: hits|user",
// "Excluded pages" => "Excluded pages",
// "Pipe separated list of pages to be excluded from the listing. ex: HomePage|Sandbox" => "Pipe separated list of pages to be excluded from the listing. ex: HomePage|Sandbox",
// "Include Self" => "Include Self",
// "With or without self-link (default is without)" => "With or without self-link (default is without)",
// "With or without header (default is with header)" => "With or without header (default is with header)",
// "With header" => "With header",
// "Without header" => "Without header",
// "No pages link to" => "No pages link to",
"One page links to" => "Egy oldal mutat ide",
"pages link to" => "idemutató oldal",
"Banner" => "Banner",
// "Add a banner" => "Add a banner",
"Zone" => "Zóna",
// "Name of the zone created in Admin > Banners" => "Name of the zone created in Admin > Banners",
"Target" => "Cél",
// "Determines the browser behavior once the banner is clicked" => "Determines the browser behavior once the banner is clicked",
"missing parameter" => "hiányzó paraméter",
// "BigBlueButton" => "BigBlueButton",
// "Starts a video/audio/chat/presentation session using BigBlueButton" => "Starts a video/audio/chat/presentation session using BigBlueButton",
// "Meeting" => "Meeting",
// "MeetingID for BigBlueButton. This is a 5 digit number, starting with a 7. Ex.: 77777 or 71111" => "MeetingID for BigBlueButton. This is a 5 digit number, starting with a 7. Ex.: 77777 or 71111",
// "Anonymous prefix" => "Anonymous prefix",
// "Unregistered users will get this token prepended to their name" => "Unregistered users will get this token prepended to their name",
// "Welcome Message" => "Welcome Message",
// "A message to be provided when someone enters the room" => "A message to be provided when someone enters the room",
// "Dial Number" => "Dial Number",
// "The phone-in support number to join from traditional phones" => "The phone-in support number to join from traditional phones",
// "Voice Bridge" => "Voice Bridge",
// "Code to enter for phone attendees to join the room. Typically, the same 5 digits of the MeetingID" => "Code to enter for phone attendees to join the room. Typically, the same 5 digits of the MeetingID",
// "Log-out URL" => "Log-out URL",
// "URL to which the user will be redirected when logging out from BigBlueButton" => "URL to which the user will be redirected when logging out from BigBlueButton",
// "Record meetings" => "Record meetings",
// "Requires BBB >= 0.8" => "Requires BBB >= 0.8",
// "Off" => "Off",
// "On" => "On",
// "BigBlueButton misconfigured or unaccessible" => "BigBlueButton misconfigured or unaccessible",
// "Bliptv" => "Bliptv",
"Display a Blip.tv video" => "Blip.tv videó megjelenítése",
// "Blip.tv embed URL. Example: http://blip.tv/play/AYGd_GAC" => "Blip.tv embed URL. Example: http://blip.tv/play/AYGd_GAC",
// "Width in pixels (default is 425" => "Width in pixels (default is 425",
// "Height in pixels (default is 350)" => "Height in pixels (default is 350)",
"Blog List" => "Blog lista",
// "Display posts from a site blog" => "Display posts from a site blog",
"Blog ID" => "Blog ID",
// "The ID number of the blog on the site you wish to list posts from" => "The ID number of the blog on the site you wish to list posts from",
// "Maximum Items" => "Maximum Items",
// "Maximum number of entries to list (no maximum set by default)" => "Maximum number of entries to list (no maximum set by default)",
// "Only display posts created by this user (all posts listed by default)" => "Only display posts created by this user (all posts listed by default)",
// "Simple List" => "Simple List",
// "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)" => "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)",
// "Earliest date to select posts from" => "Earliest date to select posts from",
"End Date" => "Befejezés dátuma",
// "Latest date to select posts from" => "Latest date to select posts from",
// "Container Class" => "Container Class",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")",
// "Contains Html" => "Contains Html",
// "Body of the blog posts should be parsed as containing HTML (default=n)" => "Body of the blog posts should be parsed as containing HTML (default=n)",
// "Creates a formatted box with a title bar" => "Creates a formatted box with a title bar",
"Box title" => "Doboz címe",
"Displayed above the content" => "A tartalom felett kerül megjelenítésre",
"Background color" => "Háttérszín",
"As defined by CSS, name or Hex code" => "CSS, név vagy Hex kód által definiálva",
"Box width" => "Doboz szélesség",
"In pixels or percentage. Default value is 100%" => "Pixelszámban vagy százalékban kifejezve. Az alapértelmezett érték 100%",
"Text Alignment" => "Szöveg igazítása",
// "Aligns the text within the box (left aligned by default)" => "Aligns the text within the box (left aligned by default)",
"Float Position" => "Lebegő pozíció",
// "Set the alignment for the entire box. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)" => "Set the alignment for the entire box. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)",
"Clear" => "Kiürítés",
// "Items are not allowed to wrap around the box if this parameter is set to.1 (Yes)" => "Items are not allowed to wrap around the box if this parameter is set to.1 (Yes)",
"CSS Class" => "CSS osztály",
"Apply custom CSS class to the box" => "Saját CSS osztály alkalmazása a dobozhoz",
"Button" => "Gomb",
// "Add a link formatted as a button" => "Add a link formatted as a button",
// "Url" => "Url",
// "URL to be produced by the button. You can use wiki argument variables like {{itemId}} in it" => "URL to be produced by the button. You can use wiki argument variables like {{itemId}} in it",
// "CSS class for the button" => "CSS class for the button",
"Label" => "Címke",
// "Label for the button" => "Label for the button",
// "lib/smarty_tiki/function.button.php is missing or unreadable" => "lib/smarty_tiki/function.button.php is missing or unreadable",
// "Display a calendar and its events" => "Display a calendar and its events",
// "Calendar IDs" => "Calendar IDs",
// "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by commas (\",\")" => "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by commas (\",\")",
// "Example values" => "Example values",
// "Not set by default" => "Not set by default",
// "View Type" => "View Type",
// "Determines how to show events" => "Determines how to show events",
// "Possible values" => "Possible values",
// "\"table\" shows events in a calendar" => "\"table\" shows events in a calendar",
"List" => "Lista",
"Table" => "Tábla",
// "View Time Span" => "View Time Span",
// "If in calendar (or \"table\") view type, determines the time span displayed by the calendar" => "If in calendar (or \"table\") view type, determines the time span displayed by the calendar",
// "Default is month" => "Default is month",
// "Navigation Bar" => "Navigation Bar",
// "Decide or not to show the navigation bar (not shown by default)" => "Decide or not to show the navigation bar (not shown by default)",
// "Carousel" => "Carousel",
// "Display images in a self-advancing carousel" => "Display images in a self-advancing carousel",
// "File Gallery ID" => "File Gallery ID",
// "ID number of the file gallery that contains the images to be displayed" => "ID number of the file gallery that contains the images to be displayed",
"Sort Mode" => "Rendezés módja",
// "Sort by database table field name, ascending or descending. Examples: fileId_asc or name_desc" => "Sort by database table field name, ascending or descending. Examples: fileId_asc or name_desc",
// "Transition time" => "Transition time",
// "The time (in milliseconds) it will take to transition between two images" => "The time (in milliseconds) it will take to transition between two images",
// "number" => "number",
// "Display time" => "Display time",
// "The time (in milliseconds) to display each image" => "The time (in milliseconds) to display each image",
// "Caption height" => "Caption height",
// "The height of the caption. This is a fraction of the height of the images" => "The height of the caption. This is a fraction of the height of the images",
// "real between 0 and 1" => "real between 0 and 1",
// "Display progress ring" => "Display progress ring",
// "Display thumbnails" => "Display thumbnails",
// "Display thumbnails, number, count etc" => "Display thumbnails, number, count etc",
// "Buttons" => "Buttons",
// "Numbers" => "Numbers",
// "Thumbnail box width" => "Thumbnail box width",
// "Width of thumbnail box in CSS units (default \"20px\")" => "Width of thumbnail box in CSS units (default \"20px\")",
// "Thumbnail box height" => "Thumbnail box height",
// "Height of thumbnail box in CSS units (default \"20px\")" => "Height of thumbnail box in CSS units (default \"20px\")",
// "Start automatically" => "Start automatically",
// "Move the carousel automatically when the page loads (default Yes)" => "Move the carousel automatically when the page loads (default Yes)",
// "Legacy v2 param" => "Legacy v2 param",
// "Display place numbers in the thumbnail boxes" => "Display place numbers in the thumbnail boxes",
// "Use corresponding image as background for a thumbnail box" => "Use corresponding image as background for a thumbnail box",
// "Thumbnail box font size" => "Thumbnail box font size",
// "Font size of thumbnail box in CSS units (default \".7em\")" => "Font size of thumbnail box in CSS units (default \".7em\")",
// "Size of picture" => "Size of picture",
// "In case your picture is too large, you can specify a scale between 0 and 1 to reduce it" => "In case your picture is too large, you can specify a scale between 0 and 1 to reduce it",
// "Cart Missing User Info" => "Cart Missing User Info",
// "PluginCartMissingUserInfo" => "PluginCartMissingUserInfo",
// "Check if user still has missing info to enter" => "Check if user still has missing info to enter",
// "Type of Information" => "Type of Information",
// "Post Purchase" => "Post Purchase",
// "Required before purchase" => "Required before purchase",
// "Product Class ID" => "Product Class ID",
"Missing parameters" => "Hiányzó paraméterek",
// "List categories and objects assigned to them" => "List categories and objects assigned to them",
"Category IDs" => "Kategória azonosítók (ID-k)",
"List of category IDs separated by + signs. ex: 1+2+3. Default will use category of the current page" => "Kategótia ID-k listája + jellel elválasztva. Pld: 1+2+3. Alapértelmezés az adott oldal kategóriája",
"Types" => "Típusok",
// "List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal<br />+forum+igal+newsletter<br />+event+poll+quiz+survey<br />+tracker+wiki+img" => "List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal<br />+forum+igal+newsletter<br />+event+poll+quiz+survey<br />+tracker+wiki+img",
// "Sort ascending or descending based on various attributes (sorted ascending by name by default)" => "Sort ascending or descending based on various attributes (sorted ascending by name by default)",
// "Created Ascending" => "Created Ascending",
// "Created Descending" => "Created Descending",
// "Hits Ascending" => "Hits Ascending",
// "Hits Descending" => "Hits Descending",
// "Item ID Ascending" => "Item ID Ascending",
// "Item ID Descending" => "Item ID Descending",
// "Name Ascending" => "Name Ascending",
// "Name Descending" => "Name Descending",
// "Type Ascending" => "Type Ascending",
// "Type Descending" => "Type Descending",
// "Random" => "Random",
"Split" => "Felosztás",
// "Whether multiple categories will be listed on different lines (default is to split them)" => "Whether multiple categories will be listed on different lines (default is to split them)",
"And" => "És",
// "If set to y (Yes), only objects in all of the categories will be shown (default is to show objects in any of the categories)" => "If set to y (Yes), only objects in all of the categories will be shown (default is to show objects in any of the categories)",
// "With Sub-categories" => "With Sub-categories",
// "Also list objects in sub-categories of the categories given (default is to list sub-category objects)" => "Also list objects in sub-categories of the categories given (default is to list sub-category objects)",
// "Show descriptions (not shown by default)" => "Show descriptions (not shown by default)",
// "Show Name" => "Show Name",
// "Show object names (shown by default)" => "Show object names (shown by default)",
// "Show type" => "Show type",
// "Show type (shown by default)" => "Show type (shown by default)",
// "One Per Line" => "One Per Line",
// "Show one object per line (multiple per line shown by default)" => "Show one object per line (multiple per line shown by default)",
// "Show Child Links" => "Show Child Links",
// "Show children category links (shown by default)" => "Show children category links (shown by default)",
// "Show Top Link" => "Show Top Link",
// "Show top category link (shown by default)" => "Show top category link (shown by default)",
// "Max Records" => "Max Records",
// "Maximum number of objects to list (default is 50)" => "Maximum number of objects to list (default is 50)",
"Show Title" => "Cím megjelenítése",
// "Show title text above category object lists (shown by default)" => "Show title text above category object lists (shown by default)",
// "List only objects in this language" => "List only objects in this language",
// "Only apply if type=wiki" => "Only apply if type=wiki",
"Categories are disabled" => "Kategória funkció nincs aktiválva",
// "PluginCategoryTransition" => "PluginCategoryTransition",
// "Displays controls to trigger category transitions for any object" => "Displays controls to trigger category transitions for any object",
"Object Type" => "Objektum típusa",
"Object ID" => "Objektum ID",
// "Redirect URL" => "Redirect URL",
// "URL the user is sent to after transition is done" => "URL the user is sent to after transition is done",
"Category Orphans" => "Kategória nélküliek",
// "List objects that are not categorized" => "List objects that are not categorized",
// "Currently, only works with wiki pages (set to wiki (Wiki Pages) by default)" => "Currently, only works with wiki pages (set to wiki (Wiki Pages) by default)",
"Max" => "Max",
// "Maximum number of items. Use -1 for unlimited. Default is the site admin setting for maximum records" => "Maximum number of items. Use -1 for unlimited. Default is the site admin setting for maximum records",
// "Result Offset" => "Result Offset",
// "Result number at which the listing should start (default is no offset)" => "Result number at which the listing should start (default is no offset)",
// "Show the full category path for a wiki page" => "Show the full category path for a wiki page",
"Separator" => "Szeparátor",
"String used to separate the categories in the path. Default character is >" => "Kategóriák elválasztásához használt sztring az útvonalban. Alapértelmezett karakter: >",
// "Display Top Category" => "Display Top Category",
// "Show the top category as part of the path name (not shown by default)" => "Show the top category as part of the path name (not shown by default)",
// "General purpose cclite utility plugin" => "General purpose cclite utility plugin",
// "Mode of operation - summary or recent. Default: summary" => "Mode of operation - summary or recent. Default: summary",
// "Account summary" => "Account summary",
// "Recent transactions" => "Recent transactions",
// "Registry" => "Registry",
// "Registry to query. Default: site preference (or first in list when more than one)" => "Registry to query. Default: site preference (or first in list when more than one)",
// "You need to be logged in to view this information" => "You need to be logged in to view this information",
// "Center text" => "Center text",
"Chart" => "Grafikon",
// "Display a chart from TikiSheet" => "Display a chart from TikiSheet",
"Chart caption" => "Ábra felirata",
"Sheet ID" => "Ív ID",
"Data sheet ID" => "Adatív ID",
"Chart Type" => "Ábta típus",
"Chart Width" => "Ábra szélesség",
"Width in pixels" => "Szélesség pixelben",
"Chart Height" => "Ábra magasság",
"Height in pixels" => "Magasság pixelben",
"Value series" => "Érték sorozat",
"Required for pie charts" => "Torta ábrához szükséges",
"Independant series" => "Független sorozat",
"Required for types other than pie chart" => "Nem torta ábrákhoz szükséges",
"Dependant series" => "Függő sorozatok",
"List of colors to use" => "Használandó színek listája",
"Styles" => "Stílusok",
"List of styles to use" => "Használandó stílusok listája",
"Labels for the series or values in the legend" => "Jelmagyarázat feliratai sorozatokhoz vagy értékekhez",
"Chart as PDF" => "Grafikon PDF-ként",
"Chart as PostScript" => "Grafikon PostScript-ként",
"Code" => "Kód",
// "Display code syntax with line numbers and color highlights" => "Display code syntax with line numbers and color highlights",
// "Code to be displayed" => "Code to be displayed",
"Caption" => "Képfelirat",
"Code snippet label" => "Kódrészlet felirata",
"Word Wrap" => "Szövegtörés",
// "Enable word wrapping on the code to avoid breaking the layout" => "Enable word wrapping on the code to avoid breaking the layout",
// "Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus.." => "Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus..",
// "Line Numbers" => "Line Numbers",
// "Show line numbers for each line of code. May not be used with colors unless GeSHI is installed" => "Show line numbers for each line of code. May not be used with colors unless GeSHI is installed",
// "Right to Left" => "Right to Left",
// "Switch the text display from left to right to right to left  (left to right by default)" => "Switch the text display from left to right to right to left  (left to right by default)",
// "Code Tag" => "Code Tag",
// "Encloses the code in an HTML code tag, for example: &lt;code&gt;user input&lt;code&gt" => "Encloses the code in an HTML code tag, for example: &lt;code&gt;user input&lt;code&gt",
// "Colorbox" => "Colorbox",
// "Display a gallery of images in a popup slideshow" => "Display a gallery of images in a popup slideshow",
// "Image Gallery ID" => "Image Gallery ID",
// "ID number of the image gallery that contains the images to be displayed" => "ID number of the image gallery that contains the images to be displayed",
// "File ID Filter" => "File ID Filter",
// "Filter on fileIds in a file gallery to only show those images. Separate each fileId with ':'" => "Filter on fileIds in a file gallery to only show those images. Separate each fileId with ':'",
// "Thumb" => "Thumb",
// "Display as a thumbnail (y) or full size (n)" => "Display as a thumbnail (y) or full size (n)",
// "Show File Title" => "Show File Title",
// "Show file title" => "Show file title",
// "Show File Name" => "Show File Name",
// "Show file name" => "Show file name",
// "Show All Thumbs" => "Show All Thumbs",
// "Show thumbnails of all the images in the gallery" => "Show thumbnails of all the images in the gallery",
// "Parse Descriptions" => "Parse Descriptions",
// "Parse the file descriptions as wiki syntax" => "Parse the file descriptions as wiki syntax",
// "Display a comment area for any specified object" => "Display a comment area for any specified object",
// "The current wiki page you have added the plugin to" => "The current wiki page you have added the plugin to",
"Dynamic Content" => "Dinamikus tartalom",
// "Display content from dynamic content repository" => "Display content from dynamic content repository",
"Content ID" => "Tartalom ID",
// "Dynamic content ID. The value can be obtained in the listing" => "Dynamic content ID. The value can be obtained in the listing",
// "Content Label" => "Content Label",
// "Label of the dynamic content to display" => "Label of the dynamic content to display",
// "Contributions Dashboard" => "Contributions Dashboard",
// "List users contributions to your work" => "List users contributions to your work",
"Notice" => "Megjegyzés",
// "Default Beginning Date" => "Default Beginning Date",
// "Default Ending Date" => "Default Ending Date",
// "Dashboard Types" => "Dashboard Types",
// "The type of charts that will be rendered seperated by comma" => "The type of charts that will be rendered seperated by comma",
// "Date Range" => "Date Range",
"Update" => "Frissítés",
// "Convene" => "Convene",
// "Convene an event with schedule and members" => "Convene an event with schedule and members",
// "Convene data generated from user input" => "Convene data generated from user input",
// "Title of Event" => "Title of Event",
// "Calendar ID" => "Calendar ID",
// "ID number for the site calendar where to store the date for the events with maximum votes" => "ID number for the site calendar where to store the date for the events with maximum votes",
// "Minimum Number of votes to show Add-to-Calendar icon" => "Minimum Number of votes to show Add-to-Calendar icon",
// "Minimum Number of votes needed to show Add-to-Calendar icon, so that new users do not see a potentially confusing icon before the convene has enough information on it" => "Minimum Number of votes needed to show Add-to-Calendar icon, so that new users do not see a potentially confusing icon before the convene has enough information on it",
// "Date and time format" => "Date and time format",
// "Display date and time in short or long format, according to the site wide setting" => "Display date and time in short or long format, according to the site wide setting",
// "Short" => "Short",
// "Long" => "Long",
// "Not ok" => "Not ok",
// "Unconfirmed" => "Unconfirmed",
// "Add User" => "Add User",
// "Add Date" => "Add Date",
// "Delete Date" => "Delete Date",
// "Edit User/Save changes" => "Edit User/Save changes",
// "Delete User" => "Delete User",
// "Selected Date" => "Selected Date",
// "Add as Calendar Event" => "Add as Calendar Event",
// "Add User & Date" => "Add User & Date",
// "Login to edit Convene" => "Login to edit Convene",
"Add" => "Hozzáadás",
"Cookie" => "Süti",
// "Display a rotating set of taglines or quotes (also known as fortune cookies)" => "Display a rotating set of taglines or quotes (also known as fortune cookies)",
"Insert copyright notices" => "Szerzői jogi információt szúr be",
"Pattern to display the copyright in. May contain ~title~, ~year~ and ~authors~" => "Minta a szerzői jog megjelenítéséhez. Lehetőségek: ~title~, ~year~ és ~authors~",
"Countdown" => "Visszaszámlálás",
// "Display a countdown to a specified date" => "Display a countdown to a specified date",
"Text to append to the countdown" => "Visszaszámláláshoz tartozó szöveg",
// "Target date and time. Multiple formats accepted" => "Target date and time. Multiple formats accepted",
// "Items to Show" => "Items to Show",
// "Select: y=years, o=months, d=days, h=hours, m=minutes, s=seconds. \n\t\t\t\t\t\t\t\tEnter multiple values as: yodhms. Must be in the order of descending length, and a time unit should not be skipped. \n\t\t\t\t\t\t\t\tIf blank, the time is shown down to the hour if not zero" => "Select: y=years, o=months, d=days, h=hours, m=minutes, s=seconds. \n\t\t\t\t\t\t\t\tEnter multiple values as: yodhms. Must be in the order of descending length, and a time unit should not be skipped. \n\t\t\t\t\t\t\t\tIf blank, the time is shown down to the hour if not zero",
// "Years" => "Years",
// "Years, Months" => "Years, Months",
// "Years, Months, Days" => "Years, Months, Days",
// "Years, Months, Days, Hours" => "Years, Months, Days, Hours",
// "Years, Months, Days, Hours, Minutes" => "Years, Months, Days, Hours, Minutes",
// "Years, Months, Days, Hours, Minutes & Seconds" => "Years, Months, Days, Hours, Minutes & Seconds",
// "Months" => "Months",
// "Months, Days" => "Months, Days",
// "Months, Days, Hours" => "Months, Days, Hours",
// "Months, Days, Hours, Minutes" => "Months, Days, Hours, Minutes",
// "Months, Days, Hours, Minutes & Seconds" => "Months, Days, Hours, Minutes & Seconds",
"Days" => "Nap",
// "Days & Hours" => "Days & Hours",
// "Days, Hours & Minutes" => "Days, Hours & Minutes",
// "Days, Hours, Minutes & Seconds" => "Days, Hours, Minutes & Seconds",
"Hours" => "Órák",
// "Hours & Minutes" => "Hours & Minutes",
// "Hours, Minutes & Seconds" => "Hours, Minutes & Seconds",
"Minutes" => "Percek",
// "Minutes & Seconds" => "Minutes & Seconds",
// "Seconds" => "Seconds",
// "Calendar Days" => "Calendar Days",
// "Will use calendar day difference when set to Yes (y) and time units are not shown. \n\t\t\t\t\t\t\t\tResult is that tomorrow, for example, is always shown as a one day away even if less than 24 hours from now. No (n) is the default" => "Will use calendar day difference when set to Yes (y) and time units are not shown. \n\t\t\t\t\t\t\t\tResult is that tomorrow, for example, is always shown as a one day away even if less than 24 hours from now. No (n) is the default",
// "Handle Past Events" => "Handle Past Events",
// "If Yes (y), will display amount of time since the event (default). \n\t\t\t\t\t\t\t\tIf No (n) and if there is body text, will display \"is over\" or custom text set in text parameter after body text" => "If Yes (y), will display amount of time since the event (default). \n\t\t\t\t\t\t\t\tIf No (n) and if there is body text, will display \"is over\" or custom text set in text parameter after body text",
"Text" => "Szöveg",
// "Text that will show with the countdown and body text. \n\t\t\t\t\t\t\t\tSet to \"default\" or leave empty to show \"xxx days until/since [body text]\", except that if\n\t\t\t\t\t\t\t\t the since parameter is set to No (n), \"[body text] is over\" will show after the end date has passed.\n\t\t\t\t\t\t\t\tAlso, if no time is shown because of the time units being displayed (for example, only years are shown and it's\n\t\t\t\t\t\t\t\tless than a year before/after the end date) then \"[body text] will happen in less than a year/happened in the last year\" will show.\n\t\t\t\t\t\t\t\tOr set pipe-separated custom text as follows: before date|before date by less than shortest time unit shown|after date\n\t\t\t\t\t\t\t\t|after date by less than shortest time unit shown|after date and since set to No (n).\n\t\t\t\t\t\t\t\tSet to silent for no text" => "Text that will show with the countdown and body text. \n\t\t\t\t\t\t\t\tSet to \"default\" or leave empty to show \"xxx days until/since [body text]\", except that if\n\t\t\t\t\t\t\t\t the since parameter is set to No (n), \"[body text] is over\" will show after the end date has passed.\n\t\t\t\t\t\t\t\tAlso, if no time is shown because of the time units being displayed (for example, only years are shown and it's\n\t\t\t\t\t\t\t\tless than a year before/after the end date) then \"[body text] will happen in less than a year/happened in the last year\" will show.\n\t\t\t\t\t\t\t\tOr set pipe-separated custom text as follows: before date|before date by less than shortest time unit shown|after date\n\t\t\t\t\t\t\t\t|after date by less than shortest time unit shown|after date and since set to No (n).\n\t\t\t\t\t\t\t\tSet to silent for no text",
// "default, silent, custom: before event|after event|after event when time not shown" => "default, silent, custom: before event|after event|after event when time not shown",
// "Thousands Separator" => "Thousands Separator",
// "Set the thousands separator for results of 1,000 or more. \n\t\t\t\t\t\t\t\tChoices are comma (c), decimal (d), space (s), or leave blank for no separator" => "Set the thousands separator for results of 1,000 or more. \n\t\t\t\t\t\t\t\tChoices are comma (c), decimal (d), space (s), or leave blank for no separator",
// "Comma" => "Comma",
// "Period" => "Period",
// "Space" => "Space",
// "COUNTDOWN: Missing \"enddate\" parameter for plugin" => "COUNTDOWN: Missing \"enddate\" parameter for plugin",
"and" => "és",
// "will happen in less than a year" => "will happen in less than a year",
// "will happen in less than a month" => "will happen in less than a month",
// "will happen in less than a day" => "will happen in less than a day",
// "will happen in less than an hour" => "will happen in less than an hour",
// "will happen in less than a minute" => "will happen in less than a minute",
// "is happening this second" => "is happening this second",
// "happened in the last year" => "happened in the last year",
// "happened in the last month" => "happened in the last month",
// "happened in the last day" => "happened in the last day",
// "happened in the last hour" => "happened in the last hour",
// "happened in the last minute" => "happened in the last minute",
// "until" => "until",
"since" => "óta",
// "is over" => "is over",
// "Custom Search" => "Custom Search",
// "Custom Search Interface that displays results using the LIST plugin" => "Custom Search Interface that displays results using the LIST plugin",
// "LIST plugin configuration information" => "LIST plugin configuration information",
// "Template wiki page" => "Template wiki page",
// "Wiki page where search user interface template is found" => "Wiki page where search user interface template is found",
// "Alphanumeric Unique Identifier for search" => "Alphanumeric Unique Identifier for search",
// "A unique identifier to distinguish custom searches for storing of previous search criteria entered by users" => "A unique identifier to distinguish custom searches for storing of previous search criteria entered by users",
// "Autotrigger AJAX search on criteria change" => "Autotrigger AJAX search on criteria change",
// "Delay in milliseconds before automatically triggering search after change (0 disables)" => "Delay in milliseconds before automatically triggering search after change (0 disables)",
// "Div to fade when AJAX search in progress" => "Div to fade when AJAX search in progress",
// "The specific ID of the specific div to fade out when AJAX search is in progress, if not set will attempt to fade the whole area or if failing simply show the spinner" => "The specific ID of the specific div to fade out when AJAX search is in progress, if not set will attempt to fade the whole area or if failing simply show the spinner",
// "Return users to same search parameters on coming back to the search page after leaving" => "Return users to same search parameters on coming back to the search page after leaving",
// "In the same session, return users to same search parameters on coming back to the search page after leaving" => "In the same session, return users to same search parameters on coming back to the search page after leaving",
// "Custom JavaScript wiki page" => "Custom JavaScript wiki page",
// "The wiki page on which custom JavaScript that is to be executed on return of AJAX results" => "The wiki page on which custom JavaScript that is to be executed on return of AJAX results",
// "Destination Div" => "Destination Div",
// "Id of a pre-existing div to contain the search results" => "Id of a pre-existing div to contain the search results",
// "Search On Load" => "Search On Load",
// "Execute the search when the page loads (default: Yes)" => "Execute the search when the page loads (default: Yes)",
// "Template is not specified" => "Template is not specified",
// "Template page not found" => "Template page not found",
// "Searching.." => "Searching..",
// "_group is needed to be set if _style is checkbox or radio" => "_group is needed to be set if _style is checkbox or radio",
"Data Channel" => "Adatcsatorna",
// "Display a form to access data channels" => "Display a form to access data channels",
// "List of fields to display. One field per line. Comma delimited: fieldname,label" => "List of fields to display. One field per line. Comma delimited: fieldname,label",
// "To use values from other forms on the same page as parameters for the data-channel use \"fieldname, external=fieldid\"" => "To use values from other forms on the same page as parameters for the data-channel use \"fieldname, external=fieldid\"",
// "Where \"fieldid\" is the id (important) of the external input to use, and \"fieldname\" is the name of the parameter in the data-channel" => "Where \"fieldid\" is the id (important) of the external input to use, and \"fieldname\" is the name of the parameter in the data-channel",
// "To use fixed hidden preset values use \"fieldname, hidden=value.\"" => "To use fixed hidden preset values use \"fieldname, hidden=value.\"",
// "Channel Name" => "Channel Name",
// "Name of the channel as registered by the administrator" => "Name of the channel as registered by the administrator",
// "Return URL" => "Return URL",
// "URL to go to after data channel has run. Defaults to current page" => "URL to go to after data channel has run. Defaults to current page",
// "Do not use returnURI but instead return true quietly" => "Do not use returnURI but instead return true quietly",
// "If set to y, will return quietly after data channel has run which would be needed if plugin is used in non-wiki page context" => "If set to y, will return quietly after data channel has run which would be needed if plugin is used in non-wiki page context",
// "Button Label" => "Button Label",
// "Label for the submit button. Default: \"Go\"" => "Label for the submit button. Default: \"Go\"",
// "CSS class for this form" => "CSS class for this form",
// "Empty Caches" => "Empty Caches",
// "Which caches to empty. Default \"Clear all Tiki caches\"" => "Which caches to empty. Default \"Clear all Tiki caches\"",
"Clear all Tiki caches" => "Összes Tiki cache kiürítése",
"All user prefs sessions" => "Összes felhasználói preferencia munkamenet",
// "Price to execute the datachannel (%0)" => "Price to execute the datachannel (%0)",
// "Payment Label" => "Payment Label",
"Debug" => "Hibakeresés",
// "Be careful, if debug is on, the page will not be refreshed and previous modules can be obsolete (not on by default)" => "Be careful, if debug is on, the page will not be refreshed and previous modules can be obsolete (not on by default)",
// "Multiple Values" => "Multiple Values",
// "Accept arrays of multiple values in the POST. e.g. itemId[]=42&itemId=43 etc. (multiple values not accepted by default)" => "Accept arrays of multiple values in the POST. e.g. itemId[]=42&itemId=43 etc. (multiple values not accepted by default)",
// "Datachannel" => "Datachannel",
// "DB Report" => "DB Report",
// "Query a database and display results (only works with ADOdb, does not work with PDO)" => "Query a database and display results (only works with ADOdb, does not work with PDO)",
"report definition" => "riport definíció",
"Full DSN" => "Teljes DSN",
"A full DSN (Data Source Name) connection string. eg: mysql://user:pass@server/database" => "Teljes DSN (Data Source Name) kapcsolódási sztring. Pld: mysql://user:pass@server/database",
// "Wiki DSN Name" => "Wiki DSN Name",
"The name of a DSN connection defined by the Wiki administrator" => "A Wiki adminisztrátora által definiált DSN kapcsolat",
"Wiki Syntax" => "Wiki szintakszis",
// "Parse wiki syntax within the report (not parsed by default)" => "Parse wiki syntax within the report (not parsed by default)",
// "Display the parsed report definition (not displayed by default)" => "Display the parsed report definition (not displayed by default)",
"Missing db or dsn parameter" => "Hiányzó db vagy dsn paraméter",
"No DSN connection string found" => "Nem található DSN kapcsolat sztring",
"Run a database report" => "Adatbázis riportot futtat",
// "Dialog" => "Dialog",
// "Create a jQuery-UI dialog" => "Create a jQuery-UI dialog",
// "Button labels separated by commas" => "Button labels separated by commas",
// "Button actions" => "Button actions",
// "JS to perform on 1st button click" => "JS to perform on 1st button click",
// "Dialog width" => "Dialog width",
// "HTML ID" => "HTML ID",
// "Automatically generated if left empty in the form \"wpdialog_XX\" (must be unique per page)" => "Automatically generated if left empty in the form \"wpdialog_XX\" (must be unique per page)",
// "Show animation" => "Show animation",
// "Hide animation" => "Hide animation",
// "Auto open" => "Auto open",
// "y/n" => "y/n",
// "Modal" => "Modal",
// "Wiki page to use as dialog body" => "Wiki page to use as dialog body",
// "Open Action" => "Open Action",
// "JS to execute when dialog opens" => "JS to execute when dialog opens",
"Div" => "Div",
// "Define and format sections of a page or text" => "Define and format sections of a page or text",
// "Indicate the type of HTML tag to use (default is div)" => "Indicate the type of HTML tag to use (default is div)",
// "Span" => "Span",
// "Pre" => "Pre",
// "Teletype" => "Teletype",
// "Paragraph" => "Paragraph",
// "Block quote" => "Block quote",
// "In pixels or percentage. Default is original size" => "In pixels or percentage. Default is original size",
// "Aligns the text within the element" => "Aligns the text within the element",
// "Justify" => "Justify",
// "Set the alignment for the entire element. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)" => "Set the alignment for the entire element. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)",
// "Items are not allowed to wrap around the side(s) this parameter is set to" => "Items are not allowed to wrap around the side(s) this parameter is set to",
// "Apply custom CSS class to the div" => "Apply custom CSS class to the div",
// "Sets the div's id attribute, as defined by HTML" => "Sets the div's id attribute, as defined by HTML",
// "Title attribute" => "Title attribute",
// "Title for the div, usually displayed as a tooltip" => "Title for the div, usually displayed as a tooltip",
"Definition List" => "Definíciós lista",
// "Create a definition list" => "Create a definition list",
"One entry per line. Each line is in \"Term: Definition\" format" => "Egy bejegyzés soronként. Minden sor ebben a formátumban legyen: \"Term: Definition\"",
"Draw" => "Rajz",
// "Display or create an image from TikiDraw that is stored into the File Gallery" => "Display or create an image from TikiDraw that is stored into the File Gallery",
// "Drawing ID" => "Drawing ID",
// "Internal ID of the file id" => "Internal ID of the file id",
// "Width in pixels or percentage. Default value is page width. e.g. \"200px\" or \"100%\"" => "Width in pixels or percentage. Default value is page width. e.g. \"200px\" or \"100%\"",
// "Height in pixels or percentage. Default value is complete drawing height" => "Height in pixels or percentage. Default value is complete drawing height",
// "Force Display Archive" => "Force Display Archive",
// "The latest revision of file is automatically shown, by setting archive to y, it bypasses this check and shows the archive rather than the latest revision" => "The latest revision of file is automatically shown, by setting archive to y, it bypasses this check and shows the archive rather than the latest revision",
// "Draw New SVG Image" => "Draw New SVG Image",
// "Edit SVG Image" => "Edit SVG Image",
// " in " => " in ",
"File not found" => "Fájl nem található",
"Equation" => "Egyenlet",
// "Render an equation written in LaTeX syntax as an image" => "Render an equation written in LaTeX syntax as an image",
"equation" => "egyenlet",
// "Size expressed as a percentage of the normal size. 100 produces the default size. 200 produces an image twice as large" => "Size expressed as a percentage of the normal size. 100 produces the default size. 200 produces an image twice as large",
"Events" => "Események",
// "Display upcoming events from calendars" => "Display upcoming events from calendars",
// "ID numbers for the site calendars whose events are to be displayed, separated by vertical bars (|)" => "ID numbers for the site calendars whose events are to be displayed, separated by vertical bars (|)",
// "Maximum Days" => "Maximum Days",
// "Events occurring within this number of days in the future from today will be included in the list (unless limited by other parameter settings). Default is 365 days" => "Events occurring within this number of days in the future from today will be included in the list (unless limited by other parameter settings). Default is 365 days",
// "Maximum Events" => "Maximum Events",
// "Maximum number of events to display. Default is 10. Set to 0 to display all (unless limited by other parameter settings)" => "Maximum number of events to display. Default is 10. Set to 0 to display all (unless limited by other parameter settings)",
// "Show Time" => "Show Time",
// "Show the time along with the date (shown by default)" => "Show the time along with the date (shown by default)",
// "Show the description of the event (shown by default)" => "Show the description of the event (shown by default)",
// "Exercise" => "Exercise",
// "PluginExercise" => "PluginExercise",
// "Creates exercises within a wiki page for students to test their new skills. The plugin allows to define inline questions and optional answers to be selected from. A score is given for multiple exercises within a page" => "Creates exercises within a wiki page for students to test their new skills. The plugin allows to define inline questions and optional answers to be selected from. A score is given for multiple exercises within a page",
// "Answer" => "Answer",
// "Used inline to specify the right answer to the question and propose an input field" => "Used inline to specify the right answer to the question and propose an input field",
// "Incorrect" => "Incorrect",
// "Alternative answers to provide" => "Alternative answers to provide",
// "Check your score" => "Check your score",
// "You scored %0 out of %1" => "You scored %0 out of %1",
// "Good" => "Good",
// "Oops" => "Oops",
// "Extend Cart Inventory Hold" => "Extend Cart Inventory Hold",
// "PluginExtendCartHold" => "PluginExtendCartHold",
// "Extends the time that items are held in the shop before timing out" => "Extends the time that items are held in the shop before timing out",
// "Create a link that shows/hides initially hidden content" => "Create a link that shows/hides initially hidden content",
// "Wiki syntax containing the content that can be hidden or shown" => "Wiki syntax containing the content that can be hidden or shown",
// "Label for link that shows and hides the content when clicked" => "Label for link that shows and hides the content when clicked",
"Unspecified label" => "Nincs felirat megadva",
// "Arrow icon showing that content can be hidden or shown" => "Arrow icon showing that content can be hidden or shown",
// "Show Speed" => "Show Speed",
// "Speed of animation in milliseconds when showing content (200 is fast and 600 is slow. 1000 equals 1 second)" => "Speed of animation in milliseconds when showing content (200 is fast and 600 is slow. 1000 equals 1 second)",
// "Integer greater than 0 and less than or equal to 1000, or 'fast' or 'slow'" => "Integer greater than 0 and less than or equal to 1000, or 'fast' or 'slow'",
// "Hide Speed" => "Hide Speed",
// "Speed of animation in milliseconds when hiding content (200 is fast and 600 is slow. 1000 equals 1 second)" => "Speed of animation in milliseconds when hiding content (200 is fast and 600 is slow. 1000 equals 1 second)",
"Fancy List" => "Puccos lista",
// "Create a fancy-looking list" => "Create a fancy-looking list",
"One item per line starting with anything followed by \")\"" => "Egy tétel soronként, kezdődhet bármivel \")\" után",
// "Use Div" => "Use Div",
// "Use the HTML tag div instead of the HTML tag for lists (ol)" => "Use the HTML tag div instead of the HTML tag for lists (ol)",
"CSS class for the fancylist" => "CSS osztály a puccos listához",
"Fancy Table" => "Puccos tábla",
// "Create a formatted table" => "Create a formatted table",
// "Rows separated by >> in the header; for the table body, one row per line. Cells separated by | in both cases" => "Rows separated by >> in the header; for the table body, one row per line. Cells separated by | in both cases",
// "Heading Row" => "Heading Row",
// "Header rows of the table. Use >> to separate multiple rows" => "Header rows of the table. Use >> to separate multiple rows",
"Heading CSS Class" => "Fejléc CSS osztály",
"CSS class to apply to the heading row" => "Fejléc soron alkalmazandó CSS osztály",
// "Header Horizontal Align" => "Header Horizontal Align",
// "Horizontal alignments for header cells separated by |. Choices: left, right, center, justify" => "Horizontal alignments for header cells separated by |. Choices: left, right, center, justify",
// "Header Vertical Align" => "Header Vertical Align",
// "Vertical alignments for header cells separated by |. Choices: top, middle, bottom, baseline" => "Vertical alignments for header cells separated by |. Choices: top, middle, bottom, baseline",
// "Column Sort" => "Column Sort",
// "Indicate whether columns are sortable or not (not sortable by default)" => "Indicate whether columns are sortable or not (not sortable by default)",
// "Pre-sorted Columns" => "Pre-sorted Columns",
// "Bracketed numbers for column number and sort direction (0 = ascending, 1 = descending), for example: [0,0],[1,0]" => "Bracketed numbers for column number and sort direction (0 = ascending, 1 = descending), for example: [0,0],[1,0]",
// "Column Widths" => "Column Widths",
// "Column widths followed by px for pixels or % for percentages. Each column separated by |" => "Column widths followed by px for pixels or % for percentages. Each column separated by |",
// "Cell Horizontal Align" => "Cell Horizontal Align",
// "Table body column horizontal alignments separated by |. Choices: left, right, center, justify" => "Table body column horizontal alignments separated by |. Choices: left, right, center, justify",
// "Cell Vertical Align" => "Cell Vertical Align",
// "Table body column vertical alignments separated by |. Choices: top, middle, bottom, baseline" => "Table body column vertical alignments separated by |. Choices: top, middle, bottom, baseline",
"The feature must be activated" => "A funkciót aktiválni kell",
// "Shows if item is user favorite or not and provide the way to set it" => "Shows if item is user favorite or not and provide the way to set it",
// "Link to a file that's attached or in a file gallery or archive. See PluginFiles for more functionality" => "Link to a file that's attached or in a file gallery or archive. See PluginFiles for more functionality",
// "Label for the link to the file (ignored if the file is a wiki attachment)" => "Label for the link to the file (ignored if the file is a wiki attachment)",
// "Indicate whether the file is in a file gallery or is a wiki page attachment" => "Indicate whether the file is in a file gallery or is a wiki page attachment",
// "Identify an attachment by entering its file name, which will show as a link to the file.\n\t\t\t\t\t\t\t\t If the page parameter is empty, it must be a file name of an attachment to the page where the plugin is used" => "Identify an attachment by entering its file name, which will show as a link to the file.\n\t\t\t\t\t\t\t\t If the page parameter is empty, it must be a file name of an attachment to the page where the plugin is used",
// "Custom Description" => "Custom Description",
// "Custom text that will be used for the link instead of the file name or file description" => "Custom text that will be used for the link instead of the file name or file description",
// "Name of the wiki page the file is attached to. Defaults to the wiki page where the plugin is used if empty" => "Name of the wiki page the file is attached to. Defaults to the wiki page where the plugin is used if empty",
// "Attachment Description" => "Attachment Description",
// "Show the attachment description as the link label instead of the attachment file name" => "Show the attachment description as the link label instead of the attachment file name",
// "Indicates that this attachment is an image, and should be displayed inline using the img tag" => "Indicates that this attachment is an image, and should be displayed inline using the img tag",
"File ID" => "Fájl ID",
// "File ID of a file in a file gallery or an archive" => "File ID of a file in a file gallery or an archive",
// "Example value" => "Example value",
// "For an archive file, the archive created just before this date will be linked to. Special values : PAGE_LAST_MOD and PAGE_VIEW_DATE" => "For an archive file, the archive created just before this date will be linked to. Special values : PAGE_LAST_MOD and PAGE_VIEW_DATE",
// "Show Icon" => "Show Icon",
// "Show an icon version of the file or file type with the link to the file" => "Show an icon version of the file or file type with the link to the file",
// "File Gallery File/Archive" => "File Gallery File/Archive",
// "Wiki Page Attachment" => "Wiki Page Attachment",
// "The date has not been set" => "The date has not been set",
// "Incorrect date format" => "Incorrect date format",
// "No such file" => "No such file",
// "Wiki attachments are disabled" => "Wiki attachments are disabled",
// "List files by ID, gallery or category, or show a slideshow of image files" => "List files by ID, gallery or category, or show a slideshow of image files",
// "Title for the file listing, or the link text when slideshow = y" => "Title for the file listing, or the link text when slideshow = y",
// "File Galleries ID" => "File Galleries ID",
// "To list only files contained in these file galleries (multiple IDs separated by colon)" => "To list only files contained in these file galleries (multiple IDs separated by colon)",
// "Or enter a username for user files (hint: enter {{user}} for current logged in user)" => "Or enter a username for user files (hint: enter {{user}} for current logged in user)",
// "To restrict files listed to those belonging to one or more categories. Enter a single category or ID or list of them separated by colon" => "To restrict files listed to those belonging to one or more categories. Enter a single category or ID or list of them separated by colon",
// "To list only specified files, enter their file IDs separated by colon" => "To list only specified files, enter their file IDs separated by colon",
// "Order ascending or descending based on any field in the file gallery table. Default is name_asc" => "Order ascending or descending based on any field in the file gallery table. Default is name_asc",
// "Show Action" => "Show Action",
// "Show a column with icons for the various actions the user can take with each file (not shown by default)" => "Show a column with icons for the various actions the user can take with each file (not shown by default)",
// "Show Find" => "Show Find",
// "Show a search box above the list (not shown by default)" => "Show a search box above the list (not shown by default)",
// "Show the title of the file gallery (shown by default). Also shown on slide show pop up window if a single galleryId is used" => "Show the title of the file gallery (shown by default). Also shown on slide show pop up window if a single galleryId is used",
// "Show ID" => "Show ID",
// "Show the ID number of each file (shown by default)" => "Show the ID number of each file (shown by default)",
// "Show an icon for each file depicting the file type" => "Show an icon for each file depicting the file type",
// "Show the name given to the file upon upload into the file gallery (shown by default). Set to Yes (y) to show as a caption in a slide show" => "Show the name given to the file upon upload into the file gallery (shown by default). Set to Yes (y) to show as a caption in a slide show",
// "Show Filename" => "Show Filename",
// "Show each file's filename (shown by default except in slide show). Set to Yes (y) to show as a caption in a slide show" => "Show each file's filename (shown by default except in slide show). Set to Yes (y) to show as a caption in a slide show",
// "Show Size" => "Show Size",
// "Show the size of each file in kilobytes (shown by default except in slide show)" => "Show the size of each file in kilobytes (shown by default except in slide show)",
// "Show the description of the file given upon upload into the file gallery (shown by default except in slide show). Set to Yes (y) to show as a caption in a slide show" => "Show the description of the file given upon upload into the file gallery (shown by default except in slide show). Set to Yes (y) to show as a caption in a slide show",
"Show Creation Date" => "Létrehozás dátumának megjelenítése",
// "Show the date each file was created (not shown by default)" => "Show the date each file was created (not shown by default)",
// "Show Last Modification Date" => "Show Last Modification Date",
// "Show the date each file was last modified (shown by default)" => "Show the date each file was last modified (shown by default)",
// "Show Hits" => "Show Hits",
// "Show the number of hits each file has received (not shown by default)" => "Show the number of hits each file has received (not shown by default)",
// "Show Locked By" => "Show Locked By",
// "For locked files, show the user name of the user who locked it (not shown by default)" => "For locked files, show the user name of the user who locked it (not shown by default)",
// "Show the user name of the user who is the author of the file (not shown by default)" => "Show the user name of the user who is the author of the file (not shown by default)",
"Show Creator" => "Létrehozó megjelenítése",
// "Show the user name of the user who is the creator of the file (not shown by default)" => "Show the user name of the user who is the creator of the file (not shown by default)",
// "Show Parent Gallery Name" => "Show Parent Gallery Name",
// "Show the name of the parent gallery" => "Show the name of the parent gallery",
// "Show File Count" => "Show File Count",
// "For galleries included in the list (where the file gallery includes other galleries), show the number of files in each of those galleries (not shown by default)" => "For galleries included in the list (where the file gallery includes other galleries), show the number of files in each of those galleries (not shown by default)",
// "Show Slideshow" => "Show Slideshow",
// "Show a link that produces a pop-up slide show when clicked (not set by default)" => "Show a link that produces a pop-up slide show when clicked (not set by default)",
// "Slideshow Width" => "Slideshow Width",
// "Set width of slideshow popup" => "Set width of slideshow popup",
// "Slideshow Height" => "Slideshow Height",
// "Set height of slideshow popup" => "Set height of slideshow popup",
// "Show Comment" => "Show Comment",
// "Show comments for each file (not shown by default)" => "Show comments for each file (not shown by default)",
// "Show Last Editor" => "Show Last Editor",
// "Show the user name of the user who last modified the file (shown by default)" => "Show the user name of the user who last modified the file (shown by default)",
// "Show Image Thumb" => "Show Image Thumb",
// "Show Image thumb" => "Show Image thumb",
// "Show only files created by this user" => "Show only files created by this user",
// "Show Upload" => "Show Upload",
// "Show a simple upload form to the gallery (not shown by default)" => "Show a simple upload form to the gallery (not shown by default)",
// "Number of rows (default: -1 = all)" => "Number of rows (default: -1 = all)",
// "Recursive" => "Recursive",
// "With sub-galleries" => "With sub-galleries",
// "Flash Video" => "Flash Video",
// "Embed a video or audio file" => "Embed a video or audio file",
// "Flash Type" => "Flash Type",
// "Whether you want to insert a Flash from a URL, a fileId from a podcast file gallery or a link to a specific service like Youtube or Vimeo" => "Whether you want to insert a Flash from a URL, a fileId from a podcast file gallery or a link to a specific service like Youtube or Vimeo",
// "Select an option" => "Select an option",
// "Blip.tv" => "Blip.tv",
// "File Gallery Podcast" => "File Gallery Podcast",
"Movie URL" => "Film URL",
// "Vimeo" => "Vimeo",
"Youtube" => "Youtube",
// "Complete URL to the movie to include. e.g. files/test.swf" => "Complete URL to the movie to include. e.g. files/test.swf",
// "File Gallery Podcast ID" => "File Gallery Podcast ID",
// "Id of a file from a podcast gallery - will work only with podcast gallery" => "Id of a file from a podcast gallery - will work only with podcast gallery",
// "YouTube URL" => "YouTube URL",
// "Entire URL to the YouTube video" => "Entire URL to the YouTube video",
// "Vimeo URL" => "Vimeo URL",
// "Entire URL to the Vimeo video" => "Entire URL to the Vimeo video",
// "Blip.tv URL" => "Blip.tv URL",
// "Blip.tv embed URL" => "Blip.tv embed URL",
// "Width of movie in pixels (default is 425)" => "Width of movie in pixels (default is 425)",
// "Height of movie in pixels (default is 350)" => "Height of movie in pixels (default is 350)",
"Quality" => "Minőség",
"Flash video quality. Default value: high" => "Flash video minőség. Alapértelmezett érték: 'high'",
"High" => "Magas",
"Medium" => "Közepes",
"Low" => "Alacsony",
// "Alternative image URL" => "Alternative image URL",
// "Image to display if Flash is not available" => "Image to display if Flash is not available",
// "Invalid URL" => "Invalid URL",
"Missing parameter movie to the plugin flash" => "Hiányzó film paraméter a flash pluginhez",
// "FONT" => "FONT",
// "Experimental: Font family and font size" => "Experimental: Font family and font size",
"Content" => "Tartalom",
// "Font Family" => "Font Family",
// "Select the font family to display the content" => "Select the font family to display the content",
// "Font Size" => "Font Size",
// "Define the size of the font in pixels (enter '12' to get a font of 12px)" => "Define the size of the font in pixels (enter '12' to get a font of 12px)",
"Footnote" => "Lábjegyzet",
// "Create automatically numbered footnotes (together with PluginFootnoteArea)" => "Create automatically numbered footnotes (together with PluginFootnoteArea)",
"The footnote" => "A lábjegyzet",
// "Sameas" => "Sameas",
// "Tag to existing footnote" => "Tag to existing footnote",
// "Footnote Area" => "Footnote Area",
// "Create automatically numbered footnotes (together with PluginFootnote)" => "Create automatically numbered footnotes (together with PluginFootnote)",
"Freetagged" => "Felcímkézett",
// "List similarly tagged objects" => "List similarly tagged objects",
// "Tags to find similar to" => "Tags to find similar to",
// "Leave blank to use the object's own tags" => "Leave blank to use the object's own tags",
// "Type of objects to extract. Set to All to find all types" => "Type of objects to extract. Set to All to find all types",
// "Same" => "Same",
"Faqs" => "GYIK-ek",
"Offset" => "Eltolás",
// "Start record" => "Start record",
// "Default -1 (all)" => "Default -1 (all)",
// "Choose from:  objectId, type, itemId, description, created, name, href, hits, comments_locked (Default: created_desc)" => "Choose from:  objectId, type, itemId, description, created, name, href, hits, comments_locked (Default: created_desc)",
// "Comments Locked Ascending" => "Comments Locked Ascending",
// "Comments Locked Descending" => "Comments Locked Descending",
// "Description Ascending" => "Description Ascending",
// "Description Descending" => "Description Descending",
// "Href Ascending" => "Href Ascending",
// "Href Descending" => "Href Descending",
// "Object ID Ascending" => "Object ID Ascending",
// "Object ID Descending" => "Object ID Descending",
// "Show objects with names or descriptions similar to the text entered here" => "Show objects with names or descriptions similar to the text entered here",
// "Broaden" => "Broaden",
// "n|y" => "n|y",
// "Choose the header level for formatting. Default is 3 (for header level h3). Set to -1 for no header tags" => "Choose the header level for formatting. Default is 3 (for header level h3). Set to -1 for no header tags",
// "Show Titles Only" => "Show Titles Only",
// "Choose whether to show titles only (not shown by default)" => "Choose whether to show titles only (not shown by default)",
// "Maximum Image Size" => "Maximum Image Size",
// "Height or width in pixels. Default = 0 (no maximum)" => "Height or width in pixels. Default = 0 (no maximum)",
// "FTP" => "FTP",
// "Create a button for downloading a file from an FTP server" => "Create a button for downloading a file from an FTP server",
"file name" => "fájl név",
// "Server Name" => "Server Name",
// "Name of the server where the FTP account is housed. Example: " => "Name of the server where the FTP account is housed. Example: ",
// "User name needed to access the FTP account" => "User name needed to access the FTP account",
// "Password needed to access the FTP account" => "Password needed to access the FTP account",
// "Download Button Label" => "Download Button Label",
// "Label for the FTP download button" => "Label for the FTP download button",
"missing parameters" => "hiányzó paraméterek",
"Connection failed" => "Sikertelen kapcsolat",
// "Galleriffic" => "Galleriffic",
// "Displays images in galleriffic" => "Displays images in galleriffic",
// "Thumbs div width" => "Thumbs div width",
// "Width in pixels or percentage. (e.g. \"200px\" or \"100%\")" => "Width in pixels or percentage. (e.g. \"200px\" or \"100%\")",
// "Image slideshow width" => "Image slideshow width",
// "Width in pixels or percentage of the largest image. (e.g. \"200px\" or \"100%\")" => "Width in pixels or percentage of the largest image. (e.g. \"200px\" or \"100%\")",
// "Image slideshow height" => "Image slideshow height",
// "Height in pixels or percentage of the largest images. (e.g. \"200px\" or \"100%\")" => "Height in pixels or percentage of the largest images. (e.g. \"200px\" or \"100%\")",
// "Start Slideshow" => "Start Slideshow",
// "Automatically start the slideshow" => "Automatically start the slideshow",
// "Delay" => "Delay",
// "Delay in milliseconds between each transition" => "Delay in milliseconds between each transition",
// "Number of Thumbnails" => "Number of Thumbnails",
// "The number of thumbnails to show per page" => "The number of thumbnails to show per page",
// "Show top pager" => "Show top pager",
// "Display thumbnail pager at top" => "Display thumbnail pager at top",
// "Show bottom pager" => "Show bottom pager",
// "Display thumbnail pager at bottom" => "Display thumbnail pager at bottom",
// "Play Slideshow" => "Play Slideshow",
// "Pause SlideShow" => "Pause SlideShow",
// "Previous Photo" => "Previous Photo",
// "Next Photo" => "Next Photo",
// "Gauge" => "Gauge",
// "Display a horizontal bar gauge" => "Display a horizontal bar gauge",
"description" => "leírás",
// "Current value to be represented by the gauge" => "Current value to be represented by the gauge",
"Maximum Value" => "Maximális érték",
"Maximum possible value. Default: 100" => "Maximális lehetséges érték. Alapértelmezés: 100",
// "Label displayed on the left side of the gauge" => "Label displayed on the left side of the gauge",
"Color" => "Szín",
// "Main color of the gauge. Use HTML color codes or names" => "Main color of the gauge. Use HTML color codes or names",
// "Background color of the gauge. Use HTML color codes or names" => "Background color of the gauge. Use HTML color codes or names",
"Bar width in pixels" => "Sor szélessége pixelben",
"Label Width" => "Címke szélesség",
// "Width in pixels allocated to the label" => "Width in pixels allocated to the label",
"Display Percentage" => "Százalék megjelenítése",
// "Set to true (Yes) to display a percentage of the maximum" => "Set to true (Yes) to display a percentage of the maximum",
"Display Value" => "Érték megjelenítése",
// "Set to false (No) to hide the numeric value (shown by default)" => "Set to false (No) to hide the numeric value (shown by default)",
// "Bar height in pixels" => "Bar height in pixels",
// "Get Security Token" => "Get Security Token",
// "PluginGetAccessToken" => "PluginGetAccessToken",
// "Get security token for specified parameters" => "Get security token for specified parameters",
// "Entry point path or part of it" => "Entry point path or part of it",
// "The path of part of the path for which the token is for" => "The path of part of the path for which the token is for",
// "Query string parameter keys" => "Query string parameter keys",
// "Query string parameter keys for which the token is for, separated by " => "Query string parameter keys for which the token is for, separated by ",
// "Query string parameter Values" => "Query string parameter Values",
// "Query string parameter values for which the token is for, separated by " => "Query string parameter values for which the token is for, separated by ",
"Google Analytics" => "Google analitika",
"Add the tracking code for Google Analytics" => "Google Analytics nyomonkövetési kódjának hozzáadása",
// "Account Number" => "Account Number",
// "The account number for the site. Your account number from google looks like UA-XXXXXXX-YY. All you need to enter is XXXXXXX-YY" => "The account number for the site. Your account number from google looks like UA-XXXXXXX-YY. All you need to enter is XXXXXXX-YY",
"Missing parameter" => "Hiányzó paraméter",
// "Google Doc" => "Google Doc",
// "Display a Google document" => "Display a Google document",
"Leave this empty" => "Hagyjuk üresen",
"Type of Google document" => "Google dokumentum típus",
// "Document" => "Document",
// "Presentation" => "Presentation",
"key" => "kulcs",
"Google doc key - for example: pXsHENf1bGGY92X1iEeJJI" => "Google dokumentum kulcs - például pXsHENf1bGGY92X1iEeJJI",
// "Name of iframe. Default is \"Frame\" + the key" => "Name of iframe. Default is \"Frame\" + the key",
// "Size of frame. Use instead of width and height. The sizes will fit the Google presentations sizes exactly" => "Size of frame. Use instead of width and height. The sizes will fit the Google presentations sizes exactly",
// "Small" => "Small",
// "Large" => "Large",
// "Width in pixels or %" => "Width in pixels or %",
// "Height in pixels or %" => "Height in pixels or %",
// "Middle" => "Middle",
// "Frame Border" => "Frame Border",
// "Choose whether to show a border around the iframe" => "Choose whether to show a border around the iframe",
"Margin Height" => "Margó magasság",
// "Margin height in pixels" => "Margin height in pixels",
"Margin Width" => "Margó szélesség",
// "Margin width in pixels" => "Margin width in pixels",
"Scrolling" => "Görgetés",
// "Choose whether to add a scroll bar" => "Choose whether to add a scroll bar",
// "Auto" => "Auto",
// "Edit Link" => "Edit Link",
// "Choose whether to show an edit link and set its location" => "Choose whether to show an edit link and set its location",
// "Required parameter \"type\" missing" => "Required parameter \"type\" missing",
// "Required parameter \"key\" missing" => "Required parameter \"key\" missing",
// "Google Map" => "Google Map",
// "Display a Google map" => "Display a Google map",
// "Type of items to show on google map" => "Type of items to show on google map",
// "Locator" => "Locator",
// "Object List" => "Object List",
// "Tracker Field" => "Tracker Field",
// "Display Mode" => "Display Mode",
// "Map display mode" => "Map display mode",
// "Satellite" => "Satellite",
// "Hybrid" => "Hybrid",
// "API Key" => "API Key",
// "Google maps key. Not needed if set in user preferences" => "Google maps key. Not needed if set in user preferences",
// "Valid key for the website, which can be obtained at http://code.google.com/apis/maps/signup.html" => "Valid key for the website, which can be obtained at http://code.google.com/apis/maps/signup.html",
// "Map ID" => "Map ID",
// "Id suffix of Google map div to avoid conflicts with other maps on same page" => "Id suffix of Google map div to avoid conflicts with other maps on same page",
// "Single \"word\" which must begin with a letter and may be followed by any number of digits, hyphens, underscores, colons and periods" => "Single \"word\" which must begin with a letter and may be followed by any number of digits, hyphens, underscores, colons and periods",
// "A plain number will be interpreted as pixels. Add a % symbol after the number to indicate percentage" => "A plain number will be interpreted as pixels. Add a % symbol after the number to indicate percentage",
// "Show Border" => "Show Border",
// "Choose whether to show a frame border around the map (no border shown by default)" => "Choose whether to show a frame border around the map (no border shown by default)",
// "Default Center Longitude" => "Default Center Longitude",
// "Default longitude value used to center the map, e.g. -79.39. Default is the default set in the Gmap feature" => "Default longitude value used to center the map, e.g. -79.39. Default is the default set in the Gmap feature",
// "An integer between -180 and 180" => "An integer between -180 and 180",
// "Default Center Latitude" => "Default Center Latitude",
// "Default latitude value used to center the map, e.g. 43.7. Default is the default set in the Gmap feature" => "Default latitude value used to center the map, e.g. 43.7. Default is the default set in the Gmap feature",
// "Default Zoom" => "Default Zoom",
// "Use an integer between 1 and 21 to set a default zoom level for the map. Default is the default set in the Gmap feature" => "Use an integer between 1 and 21 to set a default zoom level for the map. Default is the default set in the Gmap feature",
// "Save View" => "Save View",
// "Allow user to set current map view as default view for himself only" => "Allow user to set current map view as default view for himself only",
// "Marker" => "Marker",
// "Add a marker when only the default or no coordinates are set. No marker by default" => "Add a marker when only the default or no coordinates are set. No marker by default",
// "Text Bubble" => "Text Bubble",
// "Text for bubble for marker. Tiki wiki-syntax can be used" => "Text for bubble for marker. Tiki wiki-syntax can be used",
// "Plain text or Tiki wiki-syntax" => "Plain text or Tiki wiki-syntax",
// "Show/Hide Marker Text" => "Show/Hide Marker Text",
// "Set whether the marker text bubble is shown or hidden initially. Default is to hide" => "Set whether the marker text bubble is shown or hidden initially. Default is to hide",
// "Item Type" => "Item Type",
// "Type of item being geotagged (user, wiki page, blog, etc). Will attempt to use current object if not specified. Tracker items must be categorized" => "Type of item being geotagged (user, wiki page, blog, etc). Will attempt to use current object if not specified. Tracker items must be categorized",
// "Item ID or Name" => "Item ID or Name",
// "ID of item being geotagged (name of page, blog ID, etc). Will attempt to use current object if not specified" => "ID of item being geotagged (name of page, blog ID, etc). Will attempt to use current object if not specified",
// "Any ID number or name for an existing object of the type specified in the Item Type field" => "Any ID number or name for an existing object of the type specified in the Item Type field",
// "Hide If No Markers" => "Hide If No Markers",
// "Hide map if there are no markers to be shown. Default is to show the map" => "Hide map if there are no markers to be shown. Default is to show the map",
// "Visibility Toggle" => "Visibility Toggle",
// "Add ability to toggle visibility. No toggle by default" => "Add ability to toggle visibility. No toggle by default",
// "Toggle Link Align" => "Toggle Link Align",
// "Alignment for the show/hide toggle link" => "Alignment for the show/hide toggle link",
// "Start Hidden" => "Start Hidden",
// "Choose whether to keep the map hidden initially. Default is to show the map initially" => "Choose whether to keep the map hidden initially. Default is to show the map initially",
// "Auto Zoom" => "Auto Zoom",
// "Use an integer between 1 and 21 to auto zoom to this level on address find" => "Use an integer between 1 and 21 to auto zoom to this level on address find",
// "Show Controls" => "Show Controls",
// "Show map controls (shown by default)" => "Show map controls (shown by default)",
// "Zoom Only" => "Zoom Only",
// "Zoom and Type" => "Zoom and Type",
// "Zoom and Scale" => "Zoom and Scale",
// "Type Only" => "Type Only",
// "Type and Scale" => "Type and Scale",
// "Scale Only" => "Scale Only",
// "Tracker Field ID" => "Tracker Field ID",
// "Field ID of tracker field if type is Item, Tracker Field or Locator, Item Type is trackeritem and Item ID is the tracker item ID. Tracker item must be categorized" => "Field ID of tracker field if type is Item, Tracker Field or Locator, Item Type is trackeritem and Item ID is the tracker item ID. Tracker item must be categorized",
// "Numeric ID of a location type tracker field" => "Numeric ID of a location type tracker field",
// "Tracker HTML ID" => "Tracker HTML ID",
// "HTML ID of tracker field input box where value is copied to by Javascript. Auto set if used as part of entry forms" => "HTML ID of tracker field input box where value is copied to by Javascript. Auto set if used as part of entry forms",
// "In Form" => "In Form",
// "Set to 1 (Yes) if this is embedded inside a form. Needed to prevent nested forms which is not allowed in HTML" => "Set to 1 (Yes) if this is embedded inside a form. Needed to prevent nested forms which is not allowed in HTML",
// "Show location map" => "Show location map",
// "Hide location map" => "Hide location map",
"Google Maps API key not set" => "Google Maps API kulcs nincs beállítva",
// "No such user" => "No such user",
// "The user has chosen to make his information private" => "The user has chosen to make his information private",
// "No such object" => "No such object",
"Group" => "Csoport",
// "Display content based on the user's groups or friends" => "Display content based on the user's groups or friends",
// "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the conditions" => "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the conditions",
// "Allowed User Friends" => "Allowed User Friends",
// "Pipe separated list of users whose friends are allowed to view the block. ex: admin|johndoe|foo" => "Pipe separated list of users whose friends are allowed to view the block. ex: admin|johndoe|foo",
"Allowed Groups" => "Engedélyzett csoportok",
"Pipe separated list of groups allowed to view the block. ex: Admins|Developers" => "A blokkot megtekinthető csoportok listája függőleges vonallal elválasztva. Pld: Admins|Developers",
"Denied Groups" => "Tiltott csoportok",
"Pipe separated list of groups denied from viewing the block. ex: Anonymous|Managers" => "A blokk megtekintésétől tiltott csoportok listája függőleges vonallal elválasztva. Pld: Anonymous|Managers",
// "Group Expiry" => "Group Expiry",
// "Show the expiry date of a group membership of the current user" => "Show the expiry date of a group membership of the current user",
// "not in group" => "not in group",
// "never expires" => "never expires",
"Group List" => "Csoport lista",
// "List all groups or just groups that include a certain group" => "List all groups or just groups that include a certain group",
// "If empty, all groups will be listed. Entering a group name will cause only groups that include this group to be listed" => "If empty, all groups will be listed. Entering a group name will cause only groups that include this group to be listed",
// "Group Home Page" => "Group Home Page",
// "Link the group name to the group home page, if there is one (not linked by default)" => "Link the group name to the group home page, if there is one (not linked by default)",
// "Recursively List Groups" => "Recursively List Groups",
// "Recurse on the included groups (default is not to recurse)" => "Recurse on the included groups (default is not to recurse)",
// "GroupMail Core" => "GroupMail Core",
// "Displays GroupMail functions on a wiki page. Usually set up using a plugin alias created by the GroupMail profile" => "Displays GroupMail functions on a wiki page. Usually set up using a plugin alias created by the GroupMail profile",
// "From Email" => "From Email",
// "Email address to report" => "Email address to report",
// "Tracker Id" => "Tracker Id",
// "Id of GroupMail Logs tracker (set up in alias by profile)" => "Id of GroupMail Logs tracker (set up in alias by profile)",
// "From Field Id" => "From Field Id",
// "Id of GroupMail Logs tracker field (usually set up in alias by profile)" => "Id of GroupMail Logs tracker field (usually set up in alias by profile)",
// "Operator Field Id" => "Operator Field Id",
// "Subject Field Id" => "Subject Field Id",
// "Message Field Id" => "Message Field Id",
// "Content Field Id" => "Content Field Id",
// "Account Field Id" => "Account Field Id",
// "Datetime Field Id" => "Datetime Field Id",
"Group Stats" => "Csoport statisztika",
// "Show the distribution of users among groups" => "Show the distribution of users among groups",
"Groups" => "Csoportok",
// "Groups separated by :. If empty, all groups will be listed" => "Groups separated by :. If empty, all groups will be listed",
// "Percentage of" => "Percentage of",
// "Show percentage out of all users in site, or just specified groups if any" => "Show percentage out of all users in site, or just specified groups if any",
// "Users in specified groups, if any" => "Users in specified groups, if any",
// "Site users" => "Site users",
"Show Percentage" => "Százalék megjelenítése",
// "Show the percentage of total users that are members of each group (percentages are shown by default)" => "Show the percentage of total users that are members of each group (percentages are shown by default)",
"Show Bar" => "Sáv megjelenítése",
// "Represent the percentage of total users that are members of each group in a bar graph (default is not to show the bar graph)" => "Represent the percentage of total users that are members of each group in a bar graph (default is not to show the bar graph)",
// "Has Bought" => "Has Bought",
// "Check if user has bought certain item or if it is in cart" => "Check if user has bought certain item or if it is in cart",
// "PluginHasBought" => "PluginHasBought",
// "Session key names to be collected" => "Session key names to be collected",
// "Key name of passcode to be checked" => "Key name of passcode to be checked",
// "Labels for the key names to be collected" => "Labels for the key names to be collected",
// "Label of the key name of passcode to be checked" => "Label of the key name of passcode to be checked",
// "Tracker from which to get passcode to check against" => "Tracker from which to get passcode to check against",
// "Field ID from which to get passcode to check against" => "Field ID from which to get passcode to check against",
// "Item ID from which to get passcode to check against" => "Item ID from which to get passcode to check against",
// "Please fill in all fields" => "Please fill in all fields",
"HTML" => "HTML",
// "Add HTML to a page" => "Add HTML to a page",
"HTML code" => "HTML kód",
// "Parse wiki syntax within the HTML code" => "Parse wiki syntax within the HTML code",
// "Textlink" => "Textlink",
// "Adds an item to HTML feed" => "Adds an item to HTML feed",
// "HTML Feed Link" => "HTML Feed Link",
// "Display remote content" => "Display remote content",
// "Initial Value" => "Initial Value",
// "Feed location" => "Feed location",
// "Name of content" => "Name of content",
// "Style of content" => "Style of content",
"Highlight" => "Kiemelés",
// "Asterisk" => "Asterisk",
// "HTML Feed Link Type" => "HTML Feed Link Type",
"Replace" => "Kicserélés",
// "Backlink" => "Backlink",
"Popup" => "Popup",
// "Hover" => "Hover",
// "Is the HTML feed moderated" => "Is the HTML feed moderated",
// "Date of last accepted HTML item, not used if not moderated" => "Date of last accepted HTML item, not used if not moderated",
"Iframe" => "Iframe",
// "Include another web page within a frame" => "Include another web page within a frame",
// "Frame title" => "Frame title",
"Pixels or %" => "Pixel vagy %",
// "Align the iframe on the page" => "Align the iframe on the page",
// "Display custom formatted images" => "Display custom formatted images",
// "Image source" => "Image source",
// "Full URL to the image to display. \"src\", id\", \"fileId\", \"attId\" or \"randomGalleryId\" required" => "Full URL to the image to display. \"src\", id\", \"fileId\", \"attId\" or \"randomGalleryId\" required",
"Image ID" => "Kép ID",
// "Numeric ID of an image in an Image Gallery (or list separated by commas or |)" => "Numeric ID of an image in an Image Gallery (or list separated by commas or |)",
// "Numeric ID of an image in a File Gallery (or list separated by commas or |)" => "Numeric ID of an image in a File Gallery (or list separated by commas or |)",
// "Numeric ID of a file gallery. Displays a random image from that gallery" => "Numeric ID of a file gallery. Displays a random image from that gallery",
// "Numeric ID of a file gallery. Displays all images from that gallery" => "Numeric ID of a file gallery. Displays all images from that gallery",
// "File Name Ascending" => "File Name Ascending",
// "File Name Descending" => "File Name Descending",
// "Comment Ascending" => "Comment Ascending",
// "Comment Descending" => "Comment Descending",
// "Max Hits Ascending" => "Max Hits Ascending",
// "Max Hits Descending" => "Max Hits Descending",
// "File Size Ascending" => "File Size Ascending",
// "File Size Descending" => "File Size Descending",
// "File Type Ascending" => "File Type Ascending",
// "File Type Descending" => "File Type Descending",
// "User Ascending" => "User Ascending",
// "User Descending" => "User Descending",
// "Author Ascending" => "Author Ascending",
// "Author Descending" => "Author Descending",
// "Locked By Ascending" => "Locked By Ascending",
// "Locked By Descending" => "Locked By Descending",
// "Last Modified User Ascending" => "Last Modified User Ascending",
// "Last Modified User Descending" => "Last Modified User Descending",
// "Last Modified Date Ascending" => "Last Modified Date Ascending",
// "Last Modified Date Descending" => "Last Modified Date Descending",
// "Last Download Ascending" => "Last Download Ascending",
// "Last Download Descending" => "Last Download Descending",
// "Delete After Ascending" => "Delete After Ascending",
// "Delete After Descending" => "Delete After Descending",
// "Votes Ascending" => "Votes Ascending",
// "Votes Descending" => "Votes Descending",
// "Points Ascending" => "Points Ascending",
// "Points Descending" => "Points Descending",
// "Archive ID Ascending" => "Archive ID Ascending",
// "Archive ID Descending" => "Archive ID Descending",
// "Attachment ID" => "Attachment ID",
// "Numeric ID of an image attached to a wiki page (or list separated by commas or |)" => "Numeric ID of an image attached to a wiki page (or list separated by commas or |)",
"Thumbnail" => "Előnézet",
// "Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery or attachments" => "Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery or attachments",
// "Full size image appears when thumbnail is clicked" => "Full size image appears when thumbnail is clicked",
"Mouseover" => "Egérmozgatás felirata",
// "Full size image will pop up while cursor is over the thumbnail (and disappear when not)" => "Full size image will pop up while cursor is over the thumbnail (and disappear when not)",
// "Mouseover (Sticky)" => "Mouseover (Sticky)",
// "Full size image will pop up once cursor passes over thumbnail and will remain up unless cursor passes over full size popup" => "Full size image will pop up once cursor passes over thumbnail and will remain up unless cursor passes over full size popup",
// "Full size image will open in a separate winow or tab (depending on browser settings) when thumbnail is clicked" => "Full size image will open in a separate winow or tab (depending on browser settings) when thumbnail is clicked",
"Browse" => "Tallózás",
// "Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery" => "Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery",
// "Browse Popup" => "Browse Popup",
// "Same as \"browse\" except that the page opens in a new window or tab" => "Same as \"browse\" except that the page opens in a new window or tab",
// "Download dialog box will appear for file gallery and attachment images when thumbnail is clicked" => "Download dialog box will appear for file gallery and attachment images when thumbnail is clicked",
// "Enlarge button" => "Enlarge button",
// "Button for enlarging image" => "Button for enlarging image",
// "Enter a URL to the address the image should link to. Not needed if thumb parameter is set; overrides thumb setting" => "Enter a URL to the address the image should link to. Not needed if thumb parameter is set; overrides thumb setting",
// "Link relation" => "Link relation",
// "Enter \"box\" for colorbox effect (like shadowbox and lightbox) or appropriate syntax for link relation" => "Enter \"box\" for colorbox effect (like shadowbox and lightbox) or appropriate syntax for link relation",
// "Image map" => "Image map",
"Name of the image map to use for the image" => "A kép térkép neve mely a képhez használva lesz",
"Image height" => "Kép magasság",
// "Height in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent" => "Height in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent",
"Image width" => "Kép szélesség",
// "Width in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent" => "Width in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent",
// "Maximum height or width in pixels (largest dimension is scaled). Overrides height and width settings" => "Maximum height or width in pixels (largest dimension is scaled). Overrides height and width settings",
// "Align image" => "Align image",
// "Aligns the image itself. If the image is inside a box (because of other settings), use the align parameter to align the box" => "Aligns the image itself. If the image is inside a box (because of other settings), use the align parameter to align the box",
// "Image style" => "Image style",
// "Enter \"border\" to place a dark gray border around the image. Otherwise enter CSS styling syntax for other style effects" => "Enter \"border\" to place a dark gray border around the image. Otherwise enter CSS styling syntax for other style effects",
// "Align image block" => "Align image block",
// "Aligns the box containing the image" => "Aligns the box containing the image",
// "Image block style" => "Image block style",
// "Enter \"border\" to place a dark gray border frame around the image. Otherwise enter CSS styling syntax for other style effects" => "Enter \"border\" to place a dark gray border frame around the image. Otherwise enter CSS styling syntax for other style effects",
// "Description style" => "Description style",
// "Enter \"right\" or \"left\" to align text accordingly. Otherwise enter CSS styling syntax for other style effects" => "Enter \"right\" or \"left\" to align text accordingly. Otherwise enter CSS styling syntax for other style effects",
// "Wrapping control" => "Wrapping control",
// "Control how other items wrap around the image" => "Control how other items wrap around the image",
// "CSS class to apply to the image" => "CSS class to apply to the image",
// "Image caption. \"desc\" or \"name\" or \"namedesc\" for tiki images, \"idesc\" or \"ititle\" for iptc data, otherwise enter your own description" => "Image caption. \"desc\" or \"name\" or \"namedesc\" for tiki images, \"idesc\" or \"ititle\" for iptc data, otherwise enter your own description",
"Link title" => "Link címe",
// "Title text. \"desc\" or \"name\" or \"namedesc\", otherwise enter your own title" => "Title text. \"desc\" or \"name\" or \"namedesc\", otherwise enter your own title",
// "Metadata" => "Metadata",
// "Display the image metadata (IPTC and EXIF information)" => "Display the image metadata (IPTC and EXIF information)",
// "Alternate text" => "Alternate text",
// "Alternate text that displays when image does not load. Set to \"Image\" by default" => "Alternate text that displays when image does not load. Set to \"Image\" by default",
// "Default config settings" => "Default config settings",
// "Default configuration settings (usually set by admin in the source code or through Plugin Alias)" => "Default configuration settings (usually set by admin in the source code or through Plugin Alias)",
// "Mandatory admin setting" => "Mandatory admin setting",
// "Mandatory configuration settings (usually set by admin in the source code or through Plugin Alias)" => "Mandatory configuration settings (usually set by admin in the source code or through Plugin Alias)",
// "PluginImg: User lacks permission to view image" => "PluginImg: User lacks permission to view image",
"File is not an image" => "A fájl nem kép",
"Server does not support image manipulation" => "Szerver nem támogatja a képek manipulálását",
// "Enlarge" => "Enlarge",
// "''No image specified. One of the following parameters must be set: fileId, randomGalleryId, fgalId, attId, id.''" => "''No image specified. One of the following parameters must be set: fileId, randomGalleryId, fgalId, attId, id.''",
// "''Use one and only one of the following parameters: fileId, randomGalleryId, fgalId, attId, id, or src.''" => "''Use one and only one of the following parameters: fileId, randomGalleryId, fgalId, attId, id, or src.''",
// "Edit: Image" => "Edit: Image",
// "(experimental)" => "(experimental)",
"Include" => "Tartalmazza",
// "Include content from a wiki page" => "Include content from a wiki page",
"Wiki page name to include" => "A wikioldal neve amely megjelenítésre kerül",
"When only a portion of the page should be included, specify the marker from which inclusion should start" => "Ha az oldalnak csak egy részét szeretnénk megjeleníteni akkor meg kell adni a kezdés helyét",
"Stop" => "Stop",
"When only a portion of the page should be included, specify the marker at which inclusion should end" => "Ha az oldalnak csak egy részét szeretnénk megjeleníteni akkor meg kell adni a befejezés helyét",
// "Nopage Text" => "Nopage Text",
// "Text to show when no page is found" => "Text to show when no page is found",
// "Page Denied Text" => "Page Denied Text",
// "Text to show when the page exists but is denied to the user" => "Text to show when the page exists but is denied to the user",
// "Include Plugin" => "Include Plugin",
// "Edit the included page" => "Edit the included page",
"Invite" => "Meghívás",
// "Invite a user to join your groups" => "Invite a user to join your groups",
"Confirmation message after posting form" => "Űrlap elküldése után megjelenő üzenet",
// "Including Group" => "Including Group",
// "Will list only the groups that include this group" => "Will list only the groups that include this group",
"Default Group" => "Alapértelmezett csoport",
// "Dropdown list will show this group by default" => "Dropdown list will show this group by default",
// "Dropdown list will show the group related to this item ID (in group selector or creator field) by default" => "Dropdown list will show the group related to this item ID (in group selector or creator field) by default",
"Following mandatory fields are missing" => "A következő kötelező mezők hiányoznak",
"Jabber" => "Jabber",
// "Chat using Jabber" => "Chat using Jabber",
"Applet height in pixels" => "Applet magassága pixelben",
// "Applet width in pixels" => "Applet width in pixels",
// "XML Host Name" => "XML Host Name",
// "Web site where XML is hosted. Default is jabber.org" => "Web site where XML is hosted. Default is jabber.org",
"Default Color" => "Alapértelmezett szín",
// "Set default color. Default is 255,255,255" => "Set default color. Default is 255,255,255",
// "Add JavaScript code" => "Add JavaScript code",
// "JavaScript code" => "JavaScript code",
// "Not On Ready" => "Not On Ready",
// "Do not execute on document ready (execute inline)" => "Do not execute on document ready (execute inline)",
// "No JavaScript" => "No JavaScript",
// "Optional markup for when JavaScript is off" => "Optional markup for when JavaScript is off",
// "<!-- jq plugin inactive: JavaScript off -->" => "<!-- jq plugin inactive: JavaScript off -->",
"JavaScript" => "Javascript",
// "JavaScript filename" => "JavaScript filename",
// "Late Load" => "Late Load",
// "Late load, use headerlib" => "Late load, use headerlib",
"Kaltura Video" => "Kaltura Videó",
// "Display a video created through the Kaltura feature" => "Display a video created through the Kaltura feature",
// "Kaltura Entry ID" => "Kaltura Entry ID",
// "Kaltura entry ID of the video to be displayed" => "Kaltura entry ID of the video to be displayed",
// "Vary text based on the page language" => "Vary text based on the page language",
"List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "Nyelvek listája melyeken a blokk megjelenik. Kétbetűs nyelvkódot használjunk (pld: hu, en, fr, es, ...). Több nyelvet plusz jellel elválasztva lehet megadni",
"Not Language" => "Nyelv kizárása",
"List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "Nyelvek listája melyeken a blokk nem jelenik meg. Kétbetűs nyelvkódot használjunk (pld: hu, en, fr, es, ...). Több nyelvet plusz jellel elválasztva lehet megadni",
// "Show the last modification date for a page" => "Show the last modification date for a page",
// "Page name to display information of. Default value is current page" => "Page name to display information of. Default value is current page",
// "Create lists of Tiki objects based on custom search criteria and formatting" => "Create lists of Tiki objects based on custom search criteria and formatting",
// "List configuration information" => "List configuration information",
// "Missing template \"%0\"" => "Missing template \"%0\"",
// "No results for query" => "No results for query",
// "Missing objectype or qualifier for relation filter" => "Missing objectype or qualifier for relation filter",
// "Missing from or to for range filter" => "Missing from or to for range filter",
"List Pages" => "Oldal lista",
// "List pages based on various criteria" => "List pages based on various criteria",
// "Result number at which the listing should start" => "Result number at which the listing should start",
// "Limit number of items displayed in the list. Default is to display all" => "Limit number of items displayed in the list. Default is to display all",
// "Initial" => "Initial",
// "txt" => "txt",
"Show Name Only" => "Csak név megjelenítése",
// "Show only the page names" => "Show only the page names",
// "If set to a category identifier, restrict the pages displayed to those in the specified category" => "If set to a category identifier, restrict the pages displayed to those in the specified category",
// "If set to a list of category identifiers separated by colons (:), restrict the pages to those in any of the specified categories" => "If set to a list of category identifiers separated by colons (:), restrict the pages to those in any of the specified categories",
// "If set to a list of category identifiers separated by plus signs (+), only display a page if it is in all of the specified categories" => "If set to a list of category identifiers separated by plus signs (+), only display a page if it is in all of the specified categories",
// "If set to a list of category identifiers separated by minus signs (-), only display a page if it is in the first specified category and not in any of the following categories" => "If set to a list of category identifiers separated by minus signs (-), only display a page if it is in the first specified category and not in any of the following categories",
// "Structure Head" => "Structure Head",
// "Filter by structure head" => "Filter by structure head",
"Show Page Alias" => "Oldal álnév megjelenítése",
// "Show page alias in the list" => "Show page alias in the list",
// "Only pages with names similar the text entered for this parameter will be listed" => "Only pages with names similar the text entered for this parameter will be listed",
// "Two letter language code to filter pages listed" => "Two letter language code to filter pages listed",
"Orphan Language" => "Árva nyelv",
// "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed" => "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed",
// "Load Translations" => "Load Translations",
// "User or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter" => "User or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter",
// "Page name and text entered for the filter parameter must match exactly to be listed" => "Page name and text entered for the filter parameter must match exactly to be listed",
"Only Orphan Pages" => "Csak árva oldalak",
// "Only list orphan pages" => "Only list orphan pages",
// "For List Pages" => "For List Pages",
// "Sort ascending or descending on any field in the tiki_pages table. Syntax is field name followed by _asc or _desc. Example: " => "Sort ascending or descending on any field in the tiki_pages table. Syntax is field name followed by _asc or _desc. Example: ",
"or" => "vagy",
// "Length" => "Length",
// "Number of characters to display" => "Number of characters to display",
// "Show checkboxes" => "Show checkboxes",
"List Directory" => "Könyvtár listázása",
"Lists files in a directory" => "Könyvtárban lévő fájlok listája",
// "Full path to the server-local directory. Default is the document root" => "Full path to the server-local directory. Default is the document root",
"URL Prefix" => "URL előtag",
// "Make the file name a link to the file by adding the URL path preceding the file name. Example: http://yoursite.com/tiki/" => "Make the file name a link to the file by adding the URL path preceding the file name. Example: http://yoursite.com/tiki/",
// "Set the sort order of the file list" => "Set the sort order of the file list",
"File Name" => "Fájl név",
// "File Size" => "File Size",
// "Last Access" => "Last Access",
// "Last Metadata Change" => "Last Metadata Change",
// "Only list files with filenames that contain this filter. Example: \".jpg\"" => "Only list files with filenames that contain this filter. Example: \".jpg\"",
// "Maximum amount of files to display. Default is no limit" => "Maximum amount of files to display. Default is no limit",
// "could not be opened because it doesn't exist or permission was denied" => "could not be opened because it doesn't exist or permission was denied",
"Mail" => "Levelezés",
// "Directly mail other users or groups" => "Directly mail other users or groups",
// "Limit the list of groups to the groups including each group" => "Limit the list of groups to the groups including each group",
// "Show Group Dropdown" => "Show Group Dropdown",
// "Show a dropdown list of groups (not shown by default)" => "Show a dropdown list of groups (not shown by default)",
// "Recurse on groups" => "Recurse on groups",
// "show each group and each group included in this group" => "show each group and each group included in this group",
// "Recurse on groups to have the users" => "Recurse on groups to have the users",
// "Collect the users of a selected group and the users of each included groups. If 0 do not recurse, if 1, recurse one time, 2 two times..." => "Collect the users of a selected group and the users of each included groups. If 0 do not recurse, if 1, recurse one time, 2 two times...",
// "Show User Dropdown" => "Show User Dropdown",
// "Show a dropdown list of users (not shown by default)" => "Show a dropdown list of users (not shown by default)",
// "User Autocomplete" => "User Autocomplete",
// "Show an autocomplete box on user name" => "Show an autocomplete box on user name",
// "Real Name Dropdown" => "Real Name Dropdown",
// "Show a dropdown list of user real names (not shown by default)" => "Show a dropdown list of user real names (not shown by default)",
"Map" => "Térkép",
// "Display a map" => "Display a map",
// "Instructions to load content" => "Instructions to load content",
// "Scope" => "Scope",
// "Display the geolocated items represented in the page (all, center, or custom as a CSS selector). Default: center" => "Display the geolocated items represented in the page (all, center, or custom as a CSS selector). Default: center",
// "Controls" => "Controls",
// "Allows to specify which map controls will be displayed on the map and around it (controls, layers, search_location, levels, current_location, scale, streetview, navigation, coordinates, overview)" => "Allows to specify which map controls will be displayed on the map and around it (controls, layers, search_location, levels, current_location, scale, streetview, navigation, coordinates, overview)",
// "Width of the map in pixels" => "Width of the map in pixels",
// "Height of the map in pixels" => "Height of the map in pixels",
// "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19" => "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19",
// "MapServer File" => "MapServer File",
// "MapServer file identifier. Only fill this in if you are using MapServer" => "MapServer file identifier. Only fill this in if you are using MapServer",
// "Extents" => "Extents",
// "Size of the map" => "Size of the map",
// "Color Picker" => "Color Picker",
// "Mayan Calendars" => "Mayan Calendars",
// "Convert a Gregorian date to a Mayan calendar date" => "Convert a Gregorian date to a Mayan calendar date",
"Template" => "Sablon",
// "You must use the variable substitution" => "You must use the variable substitution",
// "LongCount: " => "LongCount: ",
// "Tzolkin: " => "Tzolkin: ",
// "Haab: " => "Haab: ",
// "Misc: " => "Misc: ",
// "Example: template " => "Example: template ",
// "for 22.05.2009 will return 12.19.16.6.11, 8 CHUEN, 9 SIP" => "for 22.05.2009 will return 12.19.16.6.11, 8 CHUEN, 9 SIP",
// "Default template: " => "Default template: ",
// "Gregorian date" => "Gregorian date",
// "Gregorian date for convert. Format: DD.MM.YYYY. Default: Today date" => "Gregorian date for convert. Format: DD.MM.YYYY. Default: Today date",
// " is not a valid date format. should be dd.mm.yyyy" => " is not a valid date format. should be dd.mm.yyyy",
// "Media Player" => "Media Player",
// "Add a media player to a page" => "Add a media player to a page",
// "Allow Fullscreen" => "Allow Fullscreen",
// "Allow fullscreen mode" => "Allow fullscreen mode",
// " true|false" => " true|false",
"MP3 URL" => "MP3 URL",
// "Complete URL to the mp3 to include" => "Complete URL to the mp3 to include",
"FLV URL" => "FLV URL",
// "Complete URL to the flv to include" => "Complete URL to the flv to include",
// "Complete URL to the media to include" => "Complete URL to the media to include",
// "One of" => "One of",
// "Flash Window Mode" => "Flash Window Mode",
// "Sets the Window Mode property of the Flash movie. Transparent lets what's behind the movie show through and allows the movie to be covered Opaque hides what's behind the movie and Window plays the movie in its own window. Default value: " => "Sets the Window Mode property of the Flash movie. Transparent lets what's behind the movie show through and allows the movie to be covered Opaque hides what's behind the movie and Window plays the movie in its own window. Default value: ",
// "Transparent" => "Transparent",
// "Opaque" => "Opaque",
// "Window" => "Window",
"Member List" => "Tagok listája",
// "List and allow editing of group members" => "List and allow editing of group members",
// "List of groups to handle through the interface (use \"*\" for all). Colon separated" => "List of groups to handle through the interface (use \"*\" for all). Colon separated",
// "Show Descriptions" => "Show Descriptions",
// "Display group descriptions below list name" => "Display group descriptions below list name",
// "Display mode" => "Display mode",
// "How to show the member lists" => "How to show the member lists",
"Tabs" => "Fülek",
"Maximum" => "Maximum",
// "Maximum number of users to list in each group (default 100)" => "Maximum number of users to list in each group (default 100)",
// "Members Only" => "Members Only",
// "Only shows groups containing a certain user. Enter \"%user%\" to show groups for the current logged in user" => "Only shows groups containing a certain user. Enter \"%user%\" to show groups for the current logged in user",
// "Sort mode" => "Sort mode",
// "Sort mode for member listing" => "Sort mode for member listing",
// "Read only" => "Read only",
// "Read only mode. All ability to modify membership is hidden" => "Read only mode. All ability to modify membership is hidden",
// "Set as Default Group" => "Set as Default Group",
// "Adds possibility to set group as default group. This automatically adds the user to the group. \"Forced\" option will not propose simple addition in group" => "Adds possibility to set group as default group. This automatically adds the user to the group. \"Forced\" option will not propose simple addition in group",
// "Not suggested" => "Not suggested",
// "Suggested" => "Suggested",
// "Forced" => "Forced",
// "Only groups including the group that you specify will be listed" => "Only groups including the group that you specify will be listed",
"Member Payment" => "Tag fizetés",
// "Receive payments from a member to extend membership to a group" => "Receive payments from a member to extend membership to a group",
// "Name of the group for which the subscription should be added or extended" => "Name of the group for which the subscription should be added or extended",
// "Price per period (%0)" => "Price per period (%0)",
// "Current User Member" => "Current User Member",
// "Membership only for the current user" => "Membership only for the current user",
// "Input Title" => "Input Title",
// "Title of the input form" => "Title of the input form",
// "Use %0 for the group name" => "Use %0 for the group name",
// "Supports wiki syntax" => "Supports wiki syntax",
// "Tiki Payments Invoice Title" => "Tiki Payments Invoice Title",
// "Use %0 for the group name, %4 for the number of days or %5 for the number of years" => "Use %0 for the group name, %4 for the number of days or %5 for the number of years",
// "Prevent double request" => "Prevent double request",
// "Prevent user from extended if there is already a pending request" => "Prevent user from extended if there is already a pending request",
// "Give specified numbers of free periods" => "Give specified numbers of free periods",
// "Give specified numbers of free periods, the first one could be prorated, in addition to those bought" => "Give specified numbers of free periods, the first one could be prorated, in addition to those bought",
// "Periods Label" => "Periods Label",
// "Give the period a label" => "Give the period a label",
// "The user " => "The user ",
// " already has a pending extension request payment invoice " => " already has a pending extension request payment invoice ",
// "Membership to %0 for %1 (x%2)" => "Membership to %0 for %1 (x%2)",
// "Membership to %0 for %1 users (x%2)" => "Membership to %0 for %1 users (x%2)",
// "The group " => "The group ",
// " does not have a membership term" => " does not have a membership term",
// " Go to " => " Go to ",
// "Admin > Groups" => "Admin > Groups",
// " to specify a term for this group by automatically unassigning users after a certain number of days" => " to specify a term for this group by automatically unassigning users after a certain number of days",
// " does not exist" => " does not exist",
"Mini Quiz" => "Minikvíz",
// "Create a quiz using a tracker" => "Create a quiz using a tracker",
"Instructions::Feedback" => "Instructions::Feedback",
// "Numeric value representing the miniquiz tracker ID" => "Numeric value representing the miniquiz tracker ID",
"Insert Module" => "Modul beszúrása",
// "Display a module" => "Display a module",
"Module Name" => "Modul neve",
// "Module name as known in Tiki" => "Module name as known in Tiki",
// "Select Yes (y) to hide the title (default is to show the title)" => "Select Yes (y) to hide the title (default is to show the title)",
// "Title to display at the top of the box, assuming No Title is not set to Yes (y)" => "Title to display at the top of the box, assuming No Title is not set to Yes (y)",
// "Align the module to the left or right on the page allowing other elements to align against it" => "Align the module to the left or right on the page allowing other elements to align against it",
// "Number of rows (default: 10)" => "Number of rows (default: 10)",
"Parse" => "Wiki elemzés",
// "Parse wiki syntax" => "Parse wiki syntax",
// "Show only the content with no box surrounding it" => "Show only the content with no box surrounding it",
"Decoration" => "Dekoráció",
// "Show box decorations (default is to show them)" => "Show box decorations (default is to show them)",
// "Add ability to show/hide the content of the module (default is the site admin setting for modules)" => "Add ability to show/hide the content of the module (default is the site admin setting for modules)",
// "Title Background" => "Title Background",
// "Override the background color for the title (if the title is shown). The value can be a color name (ex: bgcolor=blue) or a hexadecimal value (ex: bgcolor=#FFEBCD)" => "Override the background color for the title (if the title is shown). The value can be a color name (ex: bgcolor=blue) or a hexadecimal value (ex: bgcolor=#FFEBCD)",
// "Module Style" => "Module Style",
// "Inline CSS for the containing DIV element, e.g. \"max-width:80%\"" => "Inline CSS for the containing DIV element, e.g. \"max-width:80%\"",
// "CSS styling for the module data itself" => "CSS styling for the module data itself",
"Please choose a module" => "Kérem válasszon egy modult",
"to be used as argument" => "amit használni fog paraméterként",
"Sorry, no such module" => "Sajnálom, nincs ilyen modul",
"Monospace" => "Monospace",
// "Display text in a monospace font" => "Display text in a monospace font",
"Font name as known in browsers" => "Betű böngészők által ismert neve",
// "Display hidden content by mousing over a text" => "Display hidden content by mousing over a text",
// "Hidden content, unless the label parameter is undefined, in which case this is the label" => "Hidden content, unless the label parameter is undefined, in which case this is the label",
// "Text displayed on the page. The body is the hidden content" => "Text displayed on the page. The body is the hidden content",
"Destination link when mouseover text is clicked. Use http:// for external links" => "Egérmozgatási szövegre való kattintáskor megjelenő cél link. Használjuk a http:// kezdést külső linkekhez",
"DEPRECATED" => "NEM MŰKÖDIK",
// "Hidden content. The body contains the label" => "Hidden content. The body contains the label",
"Mouseover box width. Default: 400px" => "Egérdoboz szélessége. Alapértelmezés: 400px",
"Mouseover box height. Default: 200px" => "Egérdoboz magassága. Alapértelmezés: 200px",
"Offset X" => "Eltolás X",
// "Shifts the overlay to the right by the specified number of pixels relative to the cursor. Default: 5" => "Shifts the overlay to the right by the specified number of pixels relative to the cursor. Default: 5",
"Offset Y" => "Eltolás Y",
// "Shifts the overlay lower by the specified number of pixels relative to the cursor. Default: 0" => "Shifts the overlay lower by the specified number of pixels relative to the cursor. Default: 0",
"Parse Body" => "Törzs elemzése",
// "Parse the body of the plugin as wiki content (parsed by default)" => "Parse the body of the plugin as wiki content (parsed by default)",
// "Parse Label" => "Parse Label",
// "Parse the label as wiki content (parsed by default)" => "Parse the label as wiki content (parsed by default)",
// "CSS class to apply" => "CSS class to apply",
// "Background color to apply to the popup" => "Background color to apply to the popup",
// "Text Color" => "Text Color",
// "Color to apply to the text in the popup" => "Color to apply to the text in the popup",
"Sticky" => "Ragadós",
// "When enabled, popup stays visible until it is clicked" => "When enabled, popup stays visible until it is clicked",
// "Padding" => "Padding",
// "Padding size in pixels" => "Padding size in pixels",
// "Effect" => "Effect",
// "Set the type of show/hide animation that will be used" => "Set the type of show/hide animation that will be used",
// "Effect Speed" => "Effect Speed",
// "Set the speed of the animation" => "Set the speed of the animation",
// "Close Delay" => "Close Delay",
// "Number of seconds before popup closes" => "Number of seconds before popup closes",
"Tag" => "HTML tag",
// "HTML tag to use for the label. Default \"a\"" => "HTML tag to use for the label. Default \"a\"",
"No label specified" => "Nincs felirat megadva",
// "MediaWiki Table" => "MediaWiki Table",
// "Display a table using MediaWiki syntax (experimental - may change in future versions)" => "Display a table using MediaWiki syntax (experimental - may change in future versions)",
// "Fancy" => "Fancy",
// "Set to true to apply additional formatting to the table (header style, odd/even rows, etc.)" => "Set to true to apply additional formatting to the table (header style, odd/even rows, etc.)",
// "True" => "True",
// "False" => "False",
// "Wiki Classes" => "Wiki Classes",
// "Determines whether wiki style classes will be used for the table and cells (used by default)" => "Determines whether wiki style classes will be used for the table and cells (used by default)",
"MySpace" => "MySpace",
// "Display a MySpace Flash mp3 playlist" => "Display a MySpace Flash mp3 playlist",
"MySpace Page" => "MySpace oldal",
// "MySpace page name" => "MySpace page name",
// "Now" => "Now",
// "Display the current date or time" => "Display the current date or time",
"Format" => "Formátum",
// "Time format" => "Time format",
"Object Hits" => "Objektum találatok",
// "Display the number of hits for certain objects" => "Display the number of hits for certain objects",
// "For a wiki page, the page name, for other object types: ID number + ? + object title" => "For a wiki page, the page name, for other object types: ID number + ? + object title",
// "Object type, such as wiki, file gallery, file, article, etc. Default is \"wiki\"" => "Object type, such as wiki, file gallery, file, article, etc. Default is \"wiki\"",
// "Show the number of hits over the past number of days indicated. Default is to show all hits" => "Show the number of hits over the past number of days indicated. Default is to show all hits",
// "Page Tabs" => "Page Tabs",
// "PluginPageTabs" => "PluginPageTabs",
// "Display page content in a set of tabs" => "Display page content in a set of tabs",
// "Wiki page names" => "Wiki page names",
// "The wiki pages you would like to use in this plugin, optional, separate with pipe \"|\".  Or a table with the class of \"pagetabs\" on the main page. On child pages use as a way to redirect to the parent" => "The wiki pages you would like to use in this plugin, optional, separate with pipe \"|\".  Or a table with the class of \"pagetabs\" on the main page. On child pages use as a way to redirect to the parent",
// "Param" => "Param",
// "Display content based on URL parameters" => "Display content based on URL parameters",
// "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed if conditions are not met" => "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed if conditions are not met",
// "Names of parameter required to display text" => "Names of parameter required to display text",
// "Source where the parameter is checked. Possible values : request .." => "Source where the parameter is checked. Possible values : request ..",
// "Show details of a payment request or invoice" => "Show details of a payment request or invoice",
// "Payment Request Number" => "Payment Request Number",
// "Unique identifier of the payment request" => "Unique identifier of the payment request",
// "Display content based on permission settings" => "Display content based on permission settings",
// "Possible Permissions" => "Possible Permissions",
// "Pipe separated list of permissions, one of which is needed to view the default text" => "Pipe separated list of permissions, one of which is needed to view the default text",
// "Forbidden Permissions" => "Forbidden Permissions",
// "Pipe separated list of permissions, any of which will cause the default text not to show" => "Pipe separated list of permissions, any of which will cause the default text not to show",
// "Display content based on the reader's current perspective" => "Display content based on the reader's current perspective",
"Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the condition" => "A feltételek esetén megjelenítendő wiki szöveg. A szövegtörzs tartalmazhat {ELSE}-t. A marker utáni szöveg csak azon felhasználóknak kerül megjeleníŧésre akik nem felelnek meg a feltételnek",
// "Allowed Perspectives" => "Allowed Perspectives",
// "Pipe-separated list of identifiers of perspectives in which the block is shown" => "Pipe-separated list of identifiers of perspectives in which the block is shown",
// "Denied Perspectives" => "Denied Perspectives",
// "Pipe-separated list of identifiers of perspectives in which the block is not shown" => "Pipe-separated list of identifiers of perspectives in which the block is not shown",
// "The module or plugin parameter must be set, but not both" => "The module or plugin parameter must be set, but not both",
// "Plugin Manager error: %0%1 not found" => "Plugin Manager error: %0%1 not found",
// "Plugin Manager error: %0%1%2%3%4 not found" => "Plugin Manager error: %0%1%2%3%4 not found",
// "Plugin Manager error:  %0%1 not found" => "Plugin Manager error:  %0%1 not found",
"Options" => "Opciók",
// "Introduced in Tiki version %0" => "Introduced in Tiki version %0",
// "Accepted Values" => "Accepted Values",
// "(body of plugin)" => "(body of plugin)",
// "(blank)" => "(blank)",
// "any string except for HTML and PHP tags" => "any string except for HTML and PHP tags",
// "Since" => "Since",
// "no parameters" => "no parameters",
// "Preferences required" => "Preferences required",
// "Required parameters are in%0 %1bold%2" => "Required parameters are in%0 %1bold%2",
"Plugin Manager" => "Pluginok kezelése",
// "List wiki plugin or module information for the site" => "List wiki plugin or module information for the site",
"Information" => "Információ",
// "Determines what information is shown. Values separated with | . Ignored when singletitle is set to top or none" => "Determines what information is shown. Values separated with | . Ignored when singletitle is set to top or none",
// "One or more of: description | parameters | paraminfo" => "One or more of: description | parameters | paraminfo",
// "Description & Parameters" => "Description & Parameters",
// "Description & Parameter Info" => "Description & Parameter Info",
// "Parameters & Parameter Info" => "Parameters & Parameter Info",
// "Name of a plugin (e.g., backlinks), or list separated by |, or range separated by \"-\". Single plugin can be used with limit parameter" => "Name of a plugin (e.g., backlinks), or list separated by |, or range separated by \"-\". Single plugin can be used with limit parameter",
// "Name of a module (e.g., calendar_new), or list separated by |, or range separated by \"-\". Single module can be used with limit parameter" => "Name of a module (e.g., calendar_new), or list separated by |, or range separated by \"-\". Single module can be used with limit parameter",
// "Single Title" => "Single Title",
// "Set placement of plugin name and description when displaying information for only one plugin" => "Set placement of plugin name and description when displaying information for only one plugin",
// "Title Heading" => "Title Heading",
// "Sets the heading size for the title, e.g., h2" => "Sets the heading size for the title, e.g., h2",
// "Start with this plugin record number (must be an integer 1 or greater)" => "Start with this plugin record number (must be an integer 1 or greater)",
// "Number of plugins to show. Can be used either with start or plugin as the starting point. Must be an integer 1 or greater" => "Number of plugins to show. Can be used either with start or plugin as the starting point. Must be an integer 1 or greater",
"Poll" => "Szavazás",
// "Display a poll" => "Display a poll",
// "Numeric value representing the poll ID" => "Numeric value representing the poll ID",
// "Show poll title (shown by default)" => "Show poll title (shown by default)",
// "Show result" => "Show result",
// "Show total votes" => "Show total votes",
// "Pretty Tracker View Tracking" => "Pretty Tracker View Tracking",
// "PluginPrettyTrackerViews" => "PluginPrettyTrackerViews",
// "Stores tiki.tracker.pretty.views attribute for trackeritem" => "Stores tiki.tracker.pretty.views attribute for trackeritem",
// "set to y to record view each time this is loaded" => "set to y to record view each time this is loaded",
// "set to n to hide showing of attribute" => "set to n to hide showing of attribute",
// "Set to ID of tracker item" => "Set to ID of tracker item",
// "Profile Application" => "Profile Application",
// "Add a button for applying a profile" => "Add a button for applying a profile",
// "Profile repository domain. Default value is profiles.tiki.org" => "Profile repository domain. Default value is profiles.tiki.org",
// "Profile Name" => "Profile Name",
// "Name of the profile to be applied" => "Name of the profile to be applied",
// "Profile plugin only available to administrators" => "Profile plugin only available to administrators",
// "Profile %0/%1 not found" => "Profile %0/%1 not found",
"Proposal" => "Ajánlat",
// "Allow users to vote on a proposal and view the results" => "Allow users to vote on a proposal and view the results",
// "The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username" => "The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username",
// "Short description of the proposal to vote on. Will be displayed above the result table" => "Short description of the proposal to vote on. Will be displayed above the result table",
"Accept proposal" => "Ajánlat elfogadása",
"Still undecided" => "Még nincs eldöntve",
"Reject proposal" => "Ajánlat elutasítása",
"Quote" => "Idézet",
// "Format text as a quote" => "Format text as a quote",
"Quoted text" => "Idézett szöveg",
// "Reply To" => "Reply To",
"Name of the quoted person" => "Az idézett személy neve",
"wrote" => "írta",
"Quote:" => "Idézet:",
// "Random Include" => "Random Include",
// "Include a random page's content" => "Include a random page's content",
"Random Dynamic Content" => "Véletlenszerű dinamikus tartalom",
// "Display pre-programmed changing content" => "Display pre-programmed changing content",
// "Numeric value representing the content ID" => "Numeric value representing the content ID",
// "User List with Real Names" => "User List with Real Names",
// "Show user real names for members of a group" => "Show user real names for members of a group",
// " (experimental, should be merged with UserList)" => " (experimental, should be merged with UserList)",
// "Group name - only users belonging to a group or groups with group names containing this text will be included in the list. If empty all site users will be included" => "Group name - only users belonging to a group or groups with group names containing this text will be included in the list. If empty all site users will be included",
// "String to use between elements of the list if table layout is not used" => "String to use between elements of the list if table layout is not used",
"Result limit" => "Eredmény limit",
// "Set to sort in ascending or descending order (unsorted by default" => "Set to sort in ascending or descending order (unsorted by default",
"Layout" => "Kinézet",
// "Set to table to show results in a table (not shown in a table by default)" => "Set to table to show results in a table (not shown in a table by default)",
// "Make the listed names links to various types of user information" => "Make the listed names links to various types of user information",
"User Information" => "Felhasználói információk",
// "User Page" => "User Page",
"User Preferences" => "Felhasználói beállítások",
"Exclude" => "Kizárás",
// "Exclude certain test or admin names from the list" => "Exclude certain test or admin names from the list",
// "admin" => "admin",
// "admin-test" => "admin-test",
// "test" => "test",
// "test-admin" => "test-admin",
"Preferences" => "Beállítások",
"Redirect" => "Átirányítás",
// "Redirect to another page" => "Redirect to another page",
"Wiki page name to redirect to" => "Átirányítás erre a wiki oldalra",
"Complete URL, internal or external" => "Teljes URL, internal vagy external",
// "The ID of a perspective to switch to (requires feature_perspective)" => "The ID of a perspective to switch to (requires feature_perspective)",
// "perspective " => "perspective ",
// "nowhere" => "nowhere",
// "REDIRECT plugin: The redirection to '%s' is disabled just after saving the page" => "REDIRECT plugin: The redirection to '%s' is disabled just after saving the page",
// "REDIRECT plugin: The redirection to '%s' is disabled in preview mode. " => "REDIRECT plugin: The redirection to '%s' is disabled in preview mode. ",
// "REDIRECT plugin: redirect loop detected" => "REDIRECT plugin: redirect loop detected",
// "Regular Expression" => "Regular Expression",
// "Perform a regular expression search and replace" => "Perform a regular expression search and replace",
// "Each line of content is evaluated separately" => "Each line of content is evaluated separately",
// "Name of page containing search and replace expressions separated by two colons. Example of syntax on that page: /search pattern/::replacement text" => "Name of page containing search and replace expressions separated by two colons. Example of syntax on that page: /search pattern/::replacement text",
// "Register Member Payment" => "Register Member Payment",
// "Allows user to register and make member payment at the same time" => "Allows user to register and make member payment at the same time",
// "NA" => "NA",
// "Fixed Periods" => "Fixed Periods",
// "Give specific periods that can be chosen with a dropdown list.  Example - \"name:value;name:value;value;value;\"" => "Give specific periods that can be chosen with a dropdown list.  Example - \"name:value;name:value;value;value;\"",
// "Insufficient Privileges" => "Insufficient Privileges",
"Submit" => "Elküld",
// "You will be redirected in 5 seconds" => "You will be redirected in 5 seconds",
// "Displays the relations between the current object or a specified one and the rest of Tiki" => "Displays the relations between the current object or a specified one and the rest of Tiki",
// "Qualifiers" => "Qualifiers",
// "Comma-separated list of relation qualifiers" => "Comma-separated list of relation qualifiers",
// "Object identifier as type:itemId" => "Object identifier as type:itemId",
// "Single List" => "Single List",
// "Render all qualifiers into a single list without displaying the qualifier name" => "Render all qualifiers into a single list without displaying the qualifier name",
"Remarks Box" => "Megjegyzés doboz",
"Displays a comment, tip, note or warning box" => "Megjelenít egy kommentet, tippet, megjegyzést vagy figyelmeztető dobozt",
"remarks text" => "megjegyzés szövege",
// "Select type of remarksbox, which determines what icon and style will be displayed" => "Select type of remarksbox, which determines what icon and style will be displayed",
// "Confirm" => "Confirm",
"Errors" => "Hibák",
"Note" => "Megjegyzés",
"Warning" => "Figyelmeztetés",
"Label displayed above the remark" => "Megjegyzés felett megjelenő címke",
// "Use the highlight class for formatting (not used by default)" => "Use the highlight class for formatting (not used by default)",
// "Custom Icon" => "Custom Icon",
// "Enter a Tiki icon file name (with or without extension) or path to display a custom icon" => "Enter a Tiki icon file name (with or without extension) or path to display a custom icon",
"Close" => "Bezárás",
// "Show a close button (not shown by default)" => "Show a close button (not shown by default)",
// "Width (e.g. 100% or 250px - default \"\")" => "Width (e.g. 100% or 250px - default \"\")",
"Report" => "Riport",
// "Build a report, and store it in a wiki page" => "Build a report, and store it in a wiki page",
// "The wiki syntax report settings" => "The wiki syntax report settings",
// "Report View" => "Report View",
// "Report Plugin View" => "Report Plugin View",
"Sheet" => "Tiki táblázat",
// "Report Name" => "Report Name",
// "Report Plugin Name, sometimes used headings and reference" => "Report Plugin Name, sometimes used headings and reference",
// "Edit Report" => "Edit Report",
"RSS Feed" => "RSS feed",
// "Display items from an RSS feed" => "Display items from an RSS feed",
"IDs" => "ID-k",
"List of feed IDs separated by colons. ex: feedId:feedId2" => "Feed ID-k kettőspont által elválasztott listája. Pld: feedId:feedId2",
"Result Count" => "Eredmények száma",
"Number of results displayed" => "Megjelenítendő eredmények száma",
// "Show date of each item (not shown by default)" => "Show date of each item (not shown by default)",
// "Show feed descriptions (not shown by default)" => "Show feed descriptions (not shown by default)",
// "Show authors (not shown by default)" => "Show authors (not shown by default)",
// "Url to a favicon to put before each entry" => "Url to a favicon to put before each entry",
// "Show the title of the feed (shown by default)" => "Show the title of the feed (shown by default)",
"Scroll" => "Görgetés",
// "Show animated text that scrolls up or down" => "Show animated text that scrolls up or down",
// "Width in pixels. Example: 600px" => "Width in pixels. Example: 600px",
// "Number of pixels followed by \"px\". Example: 600px" => "Number of pixels followed by \"px\". Example: 600px",
// "Height in pixels. Example: 450px" => "Height in pixels. Example: 450px",
// "Number of pixels followed by \"px\". Example: 450px" => "Number of pixels followed by \"px\". Example: 450px",
// "Scroll speed in number of seconds (default is 8 seconds)" => "Scroll speed in number of seconds (default is 8 seconds)",
"SourceForge" => "SourceForge",
// "Creates a link to SourceForge tracker items" => "Creates a link to SourceForge tracker items",
// "Group ID" => "Group ID",
// "SourceForge project ID (shows as group_id in the URL of a tracker item" => "SourceForge project ID (shows as group_id in the URL of a tracker item",
// "SourceForge tracker ID (shows as atid in the URL of a tracker item" => "SourceForge tracker ID (shows as atid in the URL of a tracker item",
// "SourceForge item ID (shows as aid in the URL of a tracker item" => "SourceForge item ID (shows as aid in the URL of a tracker item",
// "First part of link tooltip identifying the type of tracker item (bug, feature request, patch or support request)" => "First part of link tooltip identifying the type of tracker item (bug, feature request, patch or support request)",
// "ShareThis" => "ShareThis",
// "Add a ShareThis button" => "Add a ShareThis button",
// "Send Services" => "Send Services",
// "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services" => "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services",
// "Aim" => "Aim",
// "Aim \$ Email" => "Aim \$ Email",
// "Aim \$ Sms" => "Aim \$ Sms",
// "Email \$ Sms" => "Email \$ Sms",
// "Button Style" => "Button Style",
// "Set button style: horizontal, vertical or rotate" => "Set button style: horizontal, vertical or rotate",
// "Rotate" => "Rotate",
// "Rotate Image" => "Rotate Image",
// "A value of y (Yes) will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping" => "A value of y (Yes) will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping",
// "Multiple Icons" => "Multiple Icons",
// "Enter list: email | facebook | twitter | sharethis, depending on which icons you'd like" => "Enter list: email | facebook | twitter | sharethis, depending on which icons you'd like",
// "First Services Shown" => "First Services Shown",
// "Input a list of post services (like Facebook, Myspace, Digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget" => "Input a list of post services (like Facebook, Myspace, Digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget",
// "Button Text" => "Button Text",
// "Custom link text for the button" => "Custom link text for the button",
// "Header Title" => "Header Title",
// "Optional header title text for the widget" => "Optional header title text for the widget",
// "Header Background" => "Header Background",
// "HTML color code (not color name) for the background color for the header if an optional header title is used" => "HTML color code (not color name) for the background color for the header if an optional header title is used",
// "Header Text Color" => "Header Text Color",
// "HTML color code (not color name) for the header text if an optional header title is used" => "HTML color code (not color name) for the header text if an optional header title is used",
// "Link text color for services" => "Link text color for services",
// "HTML color code (not color name) for the link text for all send and post services shown in the widget" => "HTML color code (not color name) for the link text for all send and post services shown in the widget",
"Pop-up" => "Pop-up",
// "A value of true will cause the widget to show in a pop-up window" => "A value of true will cause the widget to show in a pop-up window",
// "Embedded Elements" => "Embedded Elements",
// "A value of true will allow embedded elements (like flash) to be seen while iframe is loading" => "A value of true will allow embedded elements (like flash) to be seen while iframe is loading",
// "Display data from a TikiSheet" => "Display data from a TikiSheet",
"Sheet Heading" => "Ív címsor",
// "Internal ID of the TikiSheet.  Either id or url MUST be used" => "Internal ID of the TikiSheet.  Either id or url MUST be used",
// "Sheet Url Location" => "Sheet Url Location",
// "Internal URL of the Table to use as a spreadsheet.  Either id or url MUST be used" => "Internal URL of the Table to use as a spreadsheet.  Either id or url MUST be used",
// "Simple table view y/n (Default: n = jquery.sheet view if feature enabled)" => "Simple table view y/n (Default: n = jquery.sheet view if feature enabled)",
// "Height in pixels or percentage. Default value is complete spreadsheet height" => "Height in pixels or percentage. Default value is complete spreadsheet height",
"Editable" => "Szerkeszthető",
// "Show edit button. Default 'y' depending on user's permissions" => "Show edit button. Default 'y' depending on user's permissions",
// "Show subsheets" => "Show subsheets",
// "y/n. Show multi-sheets. Default 'y'" => "y/n. Show multi-sheets. Default 'y'",
// "Range" => "Range",
// "Show a range of cells (or single cell). Default shows all. e.g. \"D1:F3\" or \"e14:e14\"" => "Show a range of cells (or single cell). Default shows all. e.g. \"D1:F3\" or \"e14:e14\"",
// "Apply custom CSS class to the containing div" => "Apply custom CSS class to the containing div",
"New sheet in page: " => "Új ív ezen az oldalon: ",
"Create New Sheet" => "Új ív létrehozása",
// "Error loading spreadsheet" => "Error loading spreadsheet",
"Edit Sheet" => "Ív szerkesztése",
// "Collect Anonymous Shopper Info" => "Collect Anonymous Shopper Info",
// "PluginShopperinfo" => "PluginShopperinfo",
// "Collect Anonymous Shopper Info for Shopping Cart" => "Collect Anonymous Shopper Info for Shopping Cart",
// "Values to be collected" => "Values to be collected",
// "Names of values to be collected separated by : as defined in shopper profile" => "Names of values to be collected separated by : as defined in shopper profile",
// "Labels for the values to be collected" => "Labels for the values to be collected",
// "Labels of the values to be collected separated by " => "Labels of the values to be collected separated by ",
// "Show even if logged in" => "Show even if logged in",
// "Normally this is used for anonymous users but sometimes may be used when logged in also" => "Normally this is used for anonymous users but sometimes may be used when logged in also",
"Show Pages" => "Oldalak megjelnítése",
// "Find pages by searching within page names" => "Find pages by searching within page names",
"Search criteria" => "Keresési kritérium",
"Maximum amount of results displayed" => "Megjelenítendő eredmények maximális száma",
// "Display page name and/or description. Both displayed by default" => "Display page name and/or description. Both displayed by default",
// "Name & Description" => "Name & Description",
"Skype" => "Skype",
"Clickable Skype link" => "Klikkelhető Skype link",
// "Name or number to call or chat with" => "Name or number to call or chat with",
// "Set whether to call or chat. Default is chat" => "Set whether to call or chat. Default is chat",
// "Call" => "Call",
// "Chat" => "Chat",
"Show status" => "Státusz megjelenítése",
// "Show a status icon or not i.e. if online/offline/etc. Default is no" => "Show a status icon or not i.e. if online/offline/etc. Default is no",
"yes" => "igen",
"no" => "nem",
// "do not forget to check the tools / options/ privacy / allow my status to be show on the web" => "do not forget to check the tools / options/ privacy / allow my status to be show on the web",
// "click to" => "click to",
// "Slider" => "Slider",
// "Arrange content in a sliding area" => "Arrange content in a sliding area",
// "Content separated by /////" => "Content separated by /////",
// "Slider Titles" => "Slider Titles",
// "Pipe separated list of slider titles. Ex: slider 1|slider 2|slider 3" => "Pipe separated list of slider titles. Ex: slider 1|slider 2|slider 3",
// "Height in pixels or percentage. Default value is complete slider height" => "Height in pixels or percentage. Default value is complete slider height",
// "The theme to use in slider" => "The theme to use in slider",
// "Expand" => "Expand",
// "if y, the entire slider will expand to fit the parent element" => "if y, the entire slider will expand to fit the parent element",
// "Resize Contents" => "Resize Contents",
// "if y, solitary images/objects in the panel will expand to fit the viewport" => "if y, solitary images/objects in the panel will expand to fit the viewport",
// "Show Multiple" => "Show Multiple",
// "Set this value to a number and it will show that many slides at once" => "Set this value to a number and it will show that many slides at once",
// "Build Arrows" => "Build Arrows",
// "if y, builds the forwards and backwards buttons" => "if y, builds the forwards and backwards buttons",
// "Build Navigation" => "Build Navigation",
// "if y, builds a list of anchor links to link to each panel" => "if y, builds a list of anchor links to link to each panel",
// "Build Start Stop" => "Build Start Stop",
// "if y, builds the start/stop button and adds slideshow functionality" => "if y, builds the start/stop button and adds slideshow functionality",
// "Toggle Arrows" => "Toggle Arrows",
// "if y, side navigation arrows will slide out on hovering & hide @ other times" => "if y, side navigation arrows will slide out on hovering & hide @ other times",
// "Toggle Controls" => "Toggle Controls",
// "if y, slide in controls (navigation + play/stop button) on hover and slide change, hide @ other times" => "if y, slide in controls (navigation + play/stop button) on hover and slide change, hide @ other times",
// "Enable Arrows" => "Enable Arrows",
// "if n, arrows will be visible, but not clickable" => "if n, arrows will be visible, but not clickable",
// "Enable Navigation" => "Enable Navigation",
// "if n, navigation links will still be visible, but not clickable" => "if n, navigation links will still be visible, but not clickable",
// "Enable Start Stop" => "Enable Start Stop",
// "if n, the play/stop button will still be visible, but not clickable. Previously \"enablePlay\"" => "if n, the play/stop button will still be visible, but not clickable. Previously \"enablePlay\"",
// "Enable Keyboard" => "Enable Keyboard",
// "if n, keyboard arrow keys will not work for this slider" => "if n, keyboard arrow keys will not work for this slider",
// "Auto Play" => "Auto Play",
// "if y, the slideshow will start running; replaces \"startStopped\" option" => "if y, the slideshow will start running; replaces \"startStopped\" option",
// "Auto Play Locked" => "Auto Play Locked",
// "if y, user changing slides will not stop the slideshow" => "if y, user changing slides will not stop the slideshow",
// "Auto Play Delayed" => "Auto Play Delayed",
// "if y, starting a slideshow will delay advancing slides; if n, the slider will immediately advance to the next slide when slideshow starts" => "if y, starting a slideshow will delay advancing slides; if n, the slider will immediately advance to the next slide when slideshow starts",
// "Pause On Hover" => "Pause On Hover",
// "if y & the slideshow is active, the slideshow will pause on hover" => "if y & the slideshow is active, the slideshow will pause on hover",
// "Stop At End" => "Stop At End",
// "if y & the slideshow is active, the slideshow will stop on the last page. This also stops the rewind effect when infiniteSlides is false" => "if y & the slideshow is active, the slideshow will stop on the last page. This also stops the rewind effect when infiniteSlides is false",
// "Play Right To Left" => "Play Right To Left",
// "if y, the slideshow will move right-to-left" => "if y, the slideshow will move right-to-left",
// "Resume On Video End" => "Resume On Video End",
// "if y & the slideshow is active & a supported video is playing, it will pause the autoplay until the video is complete" => "if y & the slideshow is active & a supported video is playing, it will pause the autoplay until the video is complete",
// "Configure a slideshow. Extends the existing wiki page slideshow with notes & styles" => "Configure a slideshow. Extends the existing wiki page slideshow with notes & styles",
// "Slideshow notes - Separate with \"/////\"" => "Slideshow notes - Separate with \"/////\"",
// "The theme you want to use for the slideshow, default will be what you choose from the admin panel under Look and Feel for jQuery UI" => "The theme you want to use for the slideshow, default will be what you choose from the admin panel under Look and Feel for jQuery UI",
// "Tiki jQuery UI Theme" => "Tiki jQuery UI Theme",
// "Background Url Location" => "Background Url Location",
// "URL of the background image to use in your slideshow, overrides backgroundcolor" => "URL of the background image to use in your slideshow, overrides backgroundcolor",
// "Valid url" => "Valid url",
// "Background color to use in your slideshow, default " => "Background color to use in your slideshow, default ",
// "Any valid CSS class" => "Any valid CSS class",
// "Header font color" => "Header font color",
// "Apply a color to the headers of your slideshow" => "Apply a color to the headers of your slideshow",
// "Any HTML color" => "Any HTML color",
// "Header background color" => "Header background color",
// "Slide font color" => "Slide font color",
// "Apply a color to the slides of your slideshow" => "Apply a color to the slides of your slideshow",
// "Line Item highlight color" => "Line Item highlight color",
// "Apply a color to the line item when mouse over" => "Apply a color to the line item when mouse over",
// "Slide Seconds" => "Slide Seconds",
// "How many seconds a slide will be open while playing, overridden when slideduration is set" => "How many seconds a slide will be open while playing, overridden when slideduration is set",
// "Second count" => "Second count",
// "Slide Milliseconds" => "Slide Milliseconds",
// "How many milliseconds a slide will be open while playing" => "How many milliseconds a slide will be open while playing",
// "Text Side" => "Text Side",
// "The side on which you would like to display text if there are images that are resized or present" => "The side on which you would like to display text if there are images that are resized or present",
"Smarty function" => "Smarty funkció",
// "Insert a Smarty function" => "Insert a Smarty function",
// "The name of the Smarty function that the button will activate. Available functions are: lib/smarty/libs/plugins/function.[name].php" => "The name of the Smarty function that the button will activate. Available functions are: lib/smarty/libs/plugins/function.[name].php",
// "Snarf" => "Snarf",
// "Display the contents of another web page" => "Display the contents of another web page",
// "Full URL to the page to include" => "Full URL to the page to include",
// "Regular Expression Pattern" => "Regular Expression Pattern",
// "PCRE-compliant regular expression pattern to find the parts you want changed" => "PCRE-compliant regular expression pattern to find the parts you want changed",
// "Regular Expression Replacement" => "Regular Expression Replacement",
// "PCRE-compliant regular expression replacement syntax showing what the content should be changed to" => "PCRE-compliant regular expression replacement syntax showing what the content should be changed to",
// "Enable/disable word wrapping of snippets of code (enabled by default)" => "Enable/disable word wrapping of snippets of code (enabled by default)",
// "Syntax highlighting to use for code snippets. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, .." => "Syntax highlighting to use for code snippets. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, ..",
// "Set to 1 (Yes) to add line numbers to code snippets (not shown by default)" => "Set to 1 (Yes) to add line numbers to code snippets (not shown by default)",
// "Parse wiki syntax within the code snippet (not parsed by default)" => "Parse wiki syntax within the code snippet (not parsed by default)",
// "Switch the text display from left to right to right to left" => "Switch the text display from left to right to right to left",
// "HTML Content" => "HTML Content",
// "Set to 1 (Yes) to display the content as is instead of escaping HTML special chars (not set by default)" => "Set to 1 (Yes) to display the content as is instead of escaping HTML special chars (not set by default)",
// "Cache Url" => "Cache Url",
// "Cache time in minutes. Default is to use site preference, Set to 0 for no cache" => "Cache time in minutes. Default is to use site preference, Set to 0 for no cache",
// "Text to click on to fetch the url via ajax" => "Text to click on to fetch the url via ajax",
// "Sort lines of text" => "Sort lines of text",
"Data to sort, one entry per line" => "Rendezendő adatok, egy tétel soronként",
"Order" => "Sorrend",
// "Set the sort order of lines of content (default is ascending)" => "Set the sort order of lines of content (default is ascending)",
// "Reverse" => "Reverse",
// "Shuffle" => "Shuffle",
// "Easily arrange content on a page into rows and columns" => "Easily arrange content on a page into rows and columns",
"Join Columns" => "Oszlopok egyesítése",
"Generate the colspan attribute if columns are missing" => "Generálja a colspan attribútumot ha hiányoznak oszlopok",
"Fixed Size" => "Rögzített méret",
// "Generate the width attribute for the columns" => "Generate the width attribute for the columns",
// "Column Sizes" => "Column Sizes",
// "Specify all column widths in number of pixels or percent, separating each width by a pipe (|)" => "Specify all column widths in number of pixels or percent, separating each width by a pipe (|)",
"First" => "Első",
// "Cells specified are ordered first left to right across rows (default) or top to bottom down columns" => "Cells specified are ordered first left to right across rows (default) or top to bottom down columns",
// "Column" => "Column",
"Display edit icon for each section" => "Szerkesztési ikon megjelenítése minden egyes szekciónál",
// "Custom Class" => "Custom Class",
// "Add a class to customize the design" => "Add a class to customize the design",
"SQL" => "SQL",
// "Query a MySQL database and display the results" => "Query a MySQL database and display the results",
// "The SQL query goes in the body. Example: SELECT column1, column2 FROM table" => "The SQL query goes in the body. Example: SELECT column1, column2 FROM table",
// "DSN Name" => "DSN Name",
// "DSN name of the database being queried. The DSN name needs to first be defined at tiki-admin_dsn.php" => "DSN name of the database being queried. The DSN name needs to first be defined at tiki-admin_dsn.php",
"Missing db param" => "Hiányzó db paraméter",
// "Could not obtain valid DSN connection" => "Could not obtain valid DSN connection",
// "Stat" => "Stat",
// "Show various statistics for an object" => "Show various statistics for an object",
// "Object type to show stats for. Choices are article, trackeritem or wiki, or a combination of these separated by colons" => "Object type to show stats for. Choices are article, trackeritem or wiki, or a combination of these separated by colons",
// "Article & Tracker Item" => "Article & Tracker Item",
// "Article & Tracker Item & Wiki" => "Article & Tracker Item & Wiki",
// "Article & Wiki" => "Article & Wiki",
// "Article & Wiki & Tracker Item" => "Article & Wiki & Tracker Item",
"Tracker Item" => "Űrlap tétel",
// "Tracker Item & Article" => "Tracker Item & Article",
// "Tracker Item & Article & Wiki" => "Tracker Item & Article & Wiki",
// "Tracker Item & Wiki" => "Tracker Item & Wiki",
// "Tracker Item & Wiki & Article" => "Tracker Item & Wiki & Article",
// "Wiki & Article" => "Wiki & Article",
// "Wiki & Article & Tracker Item" => "Wiki & Article & Tracker Item",
// "Wiki & Tracker Item" => "Wiki & Tracker Item",
// "Wiki & Tracker Item & Article" => "Wiki & Tracker Item & Article",
// "Parent ID" => "Parent ID",
// "Enter a tracker ID to restrict stats to that tracker (for use with trackeritems only)" => "Enter a tracker ID to restrict stats to that tracker (for use with trackeritems only)",
// "Last 24 Hours" => "Last 24 Hours",
// "Added and/or viewed in the last 24 hours (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed in the last 24 hours (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
"Added" => "Hozzáadva",
// "Added and Viewed" => "Added and Viewed",
"Viewed" => "Megtekintés",
// "Viewed & Added" => "Viewed & Added",
"Today" => "Ma",
// "Added and/or viewed since the beginning of the day (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the day (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Last 7 Days" => "Last 7 Days",
// "Added and/or viewed in the last 7 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed in the last 7 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "This Week" => "This Week",
// "Added and/or viewed since the beginning of the week (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the week (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Last Month" => "Last Month",
// "Added and/or viewed last month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed last month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "This Month" => "This Month",
// "Added and/or viewed since the beginning of the month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Last Year" => "Last Year",
// "Added and/or viewed in the last 365 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed in the last 365 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "This Year" => "This Year",
// "Added and/or viewed since the beginning of the year (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the year (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Incorrect parameter: " => "Incorrect parameter: ",
"Subscript" => "Alsó index",
// "Apply subscript font to text" => "Apply subscript font to text",
"Subscribe Group" => "Feliratkozás csoportra",
// "Allow users to subscribe to a group" => "Allow users to subscribe to a group",
// "text displayed before the button" => "text displayed before the button",
// "Group name to subscribe to or unsubscribe from" => "Group name to subscribe to or unsubscribe from",
"Subscribe Text" => "Feliratkozás szövege",
"Subscribe text, containing %s as the placeholder for the group name" => "Feliratkozás szövege (%s a csoport nevének használatához)",
"Subscribe" => "Feliratkozás",
"Unsubscribe Text" => "Leiratkozás szövege",
"Unsubscribe text, containing %s as the placeholder for the group name" => "Leiratkozás szövege (%s a csoport nevének használatához)",
// "Unsubscribe" => "Unsubscribe",
"Subscribe Action" => "Felirtakozási akció",
"Subscribe button label, containing %s as the placeholder for the group name" => "Feliratkozási gomb felirata (%s a csoport nevének használatához)",
"Unsubscribe Action" => "Leiratkozási akció",
"Unsubscribe button label, containing %s as the placeholder for the group name" => "Leiratkozási gomb felirata (%s a csoport nevének használatához)",
// "Postsubscribe URL" => "Postsubscribe URL",
// "URL to send the user to after subscribing, if required" => "URL to send the user to after subscribing, if required",
// "Postunsubscribe URL" => "Postunsubscribe URL",
// "URL to send the user to after unsubscribing, if required" => "URL to send the user to after unsubscribing, if required",
// "Make this the default group text, containing %s as the placeholder for the group name." => "Make this the default group text, containing %s as the placeholder for the group name.",
// "Not Default Group" => "Not Default Group",
// "Stop this being default group text, containing %s as the placeholder for the group name." => "Stop this being default group text, containing %s as the placeholder for the group name.",
// "Default Group Action" => "Default Group Action",
// "Default group button label. Will subscribe to the group first if not already a member" => "Default group button label. Will subscribe to the group first if not already a member",
// "Not Default Group Action" => "Not Default Group Action",
// "Stop this being default group button label. Does not unsubscribe from the group" => "Stop this being default group button label. Does not unsubscribe from the group",
// "Group To Set When Not Default" => "Group To Set When Not Default",
// "Group name to set as default when user stops this group being it" => "Group name to set as default when user stops this group being it",
// "Go To Default Group Home" => "Go To Default Group Home",
// "Redirect to new home page after default group change. (Default y)" => "Redirect to new home page after default group change. (Default y)",
"Subscribe Groups" => "Feliratkozás csoportokra",
// "Allow users to subscribe to a list of groups" => "Allow users to subscribe to a list of groups",
// "Text shown in the dropdown box. Default: \"Subscribe to a group\"" => "Text shown in the dropdown box. Default: \"Subscribe to a group\"",
// "Show Subscribe Box" => "Show Subscribe Box",
// "Show the subscribe box (shown by default). Will not show if there are no other groups the user may register for" => "Show the subscribe box (shown by default). Will not show if there are no other groups the user may register for",
// "Subscribe Box Style" => "Subscribe Box Style",
// "Style to show the subscribe box, either dropdown or table" => "Style to show the subscribe box, either dropdown or table",
// "Show Default" => "Show Default",
// "Shows which group is the user's default group (if any) and allows the user to change his default group" => "Shows which group is the user's default group (if any) and allows the user to change his default group",
// "Group Description" => "Group Description",
// "Show the description of the group (not shown by default)" => "Show the description of the group (not shown by default)",
// "Colon separated list of groups. By default the list of groups available to the user" => "Colon separated list of groups. By default the list of groups available to the user",
// "Only list groups that include the group being specified here" => "Only list groups that include the group being specified here",
// "Default URL" => "Default URL",
// "Page user will be directed to after clicking on icon to change default group" => "Page user will be directed to after clicking on icon to change default group",
// "Leader Group Name" => "Leader Group Name",
// "Name of group for leaders of the group, where \"groupName\" will be substituted by the group name" => "Name of group for leaders of the group, where \"groupName\" will be substituted by the group name",
// "Pending Users Group Name" => "Pending Users Group Name",
// "Name of group for users that are waiting for approval to enter the group, where \"groupName\" will be substituted by the group name" => "Name of group for users that are waiting for approval to enter the group, where \"groupName\" will be substituted by the group name",
// "Group Management Page Name" => "Group Management Page Name",
// "Name of wiki page for group management by leaders, where \"groupName\" will be substituted by the group name" => "Name of wiki page for group management by leaders, where \"groupName\" will be substituted by the group name",
// "Hide link for groups including" => "Hide link for groups including",
// "Hide link to group home page for groups that include the group being specified here" => "Hide link to group home page for groups that include the group being specified here",
// "Always allow leaving group" => "Always allow leaving group",
// "Always allow leaving group even if userChoice for group is set to n" => "Always allow leaving group even if userChoice for group is set to n",
// "You do not have permission to subscribe to groups" => "You do not have permission to subscribe to groups",
"Subscribe newsletter" => "Feliratkozás hírlevélre",
// "Allow users to subscribe to a newsletter" => "Allow users to subscribe to a newsletter",
// "Invitation message" => "Invitation message",
// "Newsletter ID" => "Newsletter ID",
// "Identification number (nlId) of the Newsletter that you want to allow the users to subscribe to" => "Identification number (nlId) of the Newsletter that you want to allow the users to subscribe to",
// "Confirmation Message" => "Confirmation Message",
// "Confirmation message after posting form. The plugin body is then the button label" => "Confirmation message after posting form. The plugin body is then the button label",
// "Button label. The plugin body is then the confirmation message" => "Button label. The plugin body is then the confirmation message",
// "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)" => "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)",
// "Already subscribed" => "Already subscribed",
"Superscript" => "Felső index",
// "Apply superscript font to text" => "Apply superscript font to text",
// "Display a survey" => "Display a survey",
"Wiki Page to redirect the user after his vote" => "Wiki oldal neve melyre a felhasználó átirányításra kerül a szavazata leadása utána",
// "Arrange content in tabs" => "Arrange content in tabs",
// "Tabs content separated by /////" => "Tabs content separated by /////",
// "Tabset Name" => "Tabset Name",
// "Unique tabset name (if you want it to remember its last state). Ex: user_profile_tabs" => "Unique tabset name (if you want it to remember its last state). Ex: user_profile_tabs",
// "Tab Titles" => "Tab Titles",
// "Pipe separated list of tab titles. Ex: tab 1|tab 2|tab 3" => "Pipe separated list of tab titles. Ex: tab 1|tab 2|tab 3",
// "Toggle Tabs" => "Toggle Tabs",
// "Allows to toggle from tabs to no tabs view" => "Allows to toggle from tabs to no tabs view",
// "Inside Pretty Tracker" => "Inside Pretty Tracker",
// "Parse pretty tracker variables within tabs" => "Parse pretty tracker variables within tabs",
// "No tab title specified. At least one has to be set to make the tabs appear" => "No tab title specified. At least one has to be set to make the tabs appear",
// "Apply an HTML tag to content" => "Apply an HTML tag to content",
"Tag Name" => "Tag neve",
"Any valid HTML tag, span by default" => "Bármilyen valid HTML tag, alapértelemezé: span",
"CSS Style" => "CSS stílus",
"Equivalent to the style attribute of an HTML tag" => "Megegyezik a HTML tag stílus attribútumával",
// "TextLink" => "TextLink",
// "Links your article to a site using forwardlink protocol" => "Links your article to a site using forwardlink protocol",
// "Text to link to forwardlink" => "Text to link to forwardlink",
// "ClipboardData" => "ClipboardData",
// "ForwardLinks To: " => "ForwardLinks To: ",
// "Timeline" => "Timeline",
// "Display a timeline" => "Display a timeline",
// "Display the eventlist items represented in the page. (all, center, or custom as a CSS selector)" => "Display the eventlist items represented in the page. (all, center, or custom as a CSS selector)",
// "Width of the timeline as CSS units (default: \"100%\")" => "Width of the timeline as CSS units (default: \"100%\")",
// "Height of the timeline as CSS units (default: \"400px\")" => "Height of the timeline as CSS units (default: \"400px\")",
"Lower Bound" => "Alsó határ",
"Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "A dátum melytől kezdve az elemek megjelenítésre kerülnek. A dátumot a következő formátumban kell megadni: YYYY-MM-DD HH:mm:ss",
"Upper Bound" => "Felső határ",
"Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "A dátum ameddig az elemek megjelenítésre kerülnek. A dátumot a következő formátumban kell megadni: YYYY-MM-DD HH:mm:ss",
"Primary Scale Unit" => "Elsődleges mérési egység",
// "Unit of time to use for the primary scale (default to Month)" => "Unit of time to use for the primary scale (default to Month)",
// "Decade" => "Decade",
// "Century" => "Century",
"Secondary Scale Unit" => "Másodlagos mérési egység",
// "Unit of time to use for the secondary scale (default to empty)" => "Unit of time to use for the secondary scale (default to empty)",
// "TimeSheet" => "TimeSheet",
// "A portable timesheet usable in a webpage" => "A portable timesheet usable in a webpage",
"Title Search" => "Cím keresése",
// "Search pages by title" => "Search pages by title",
"Search Criteria" => "Keresési kritérium",
"Portion of a page name" => "Oldanév egy része",
// "Also show page hits or user" => "Also show page hits or user",
"Pipe-separated list of page names to exclude from results" => "Az eredményekbők kizárandó oldalak listája függőleges vonallal elválasztva",
"No Header" => "Nincs fejléc",
// "Set to 1 (Yes) to have no header for the search results" => "Set to 1 (Yes) to have no header for the search results",
"No pages found for title search" => "Nem található a kritériumoknak megfelelő oldal",
"One page found for title search" => "A keresés egy találatot adott",
"pages found for title search" => "oldal felelt meg a keresési kritériumoknak",
"Table of Contents (Structure)" => "Tartalomjegyzék (Struktúra)",
// "Display a table of contents of pages or sub-pages" => "Display a table of contents of pages or sub-pages",
"Maximum Depth" => "Maximális mélység",
// "Maximum number of levels to display. On very large structures, this should be limited. Zero means no limit (and is the default)" => "Maximum number of levels to display. On very large structures, this should be limited. Zero means no limit (and is the default)",
"Structure ID" => "Struktúra neve",
"By default, structure for the current page will be displayed. Alternate structure may be provided" => "Alapértelmezéskénz az adott oldalhoz tartozó struktúra kerül megjelenítésre de meg lehet adni más struktúrát is",
// "Order items in ascending or descending order (default is ascending)" => "Order items in ascending or descending order (default is ascending)",
// "Show the page description instead of the page name" => "Show the page description instead of the page name",
"Show Numbering" => "Számozás megjelenítése",
// "Display the section numbers or not" => "Display the section numbers or not",
// "Style to apply" => "Style to apply",
// "By default, the table of contents for the current page will be displayed. Alternate page may be provided" => "By default, the table of contents for the current page will be displayed. Alternate page may be provided",
"Top Friends" => "Top barátok",
"List top-scoring users." => "Legtöbb pontot szerző felhasználók listázása.",
// "Maximum result count" => "Maximum result count",
// "Set whether public or not" => "Set whether public or not",
"Translate" => "Fordítás",
// "Translate text to the user language" => "Translate text to the user language",
// "Create a form in a wiki page to populate a tracker" => "Create a form in a wiki page to populate a tracker",
// "Numeric value representing the tracker ID" => "Numeric value representing the tracker ID",
// "Colon-separated list of field IDs to be displayed. Example: 2:4:5  If empty, all fields will be shown" => "Colon-separated list of field IDs to be displayed. Example: 2:4:5  If empty, all fields will be shown",
// "Label on the submit button. Default is \"Save\"" => "Label on the submit button. Default is \"Save\"",
// "Display the title of the tracker (not shown by default)" => "Display the title of the tracker (not shown by default)",
// "Show the tracker's description (not shown by default)" => "Show the tracker's description (not shown by default)",
// "Mark Mandatory" => "Mark Mandatory",
// "Indicate mandatory fields with an asterisk (shown by default)" => "Indicate mandatory fields with an asterisk (shown by default)",
"Show Status" => "Státusz megjelenítése",
// "Show the status of the items (not shown by default)" => "Show the status of the items (not shown by default)",
"Embedded" => "Beépített",
// "To send an email once the tracker item has been created. Format: from" => "To send an email once the tracker item has been created. Format: from",
"to" => "ig",
// "Email format" => "Email format",
// "Text or HTML setting" => "Text or HTML setting",
// "URL the user is sent to after the form is submitted" => "URL the user is sent to after the form is submitted",
// "URL Target" => "URL Target",
// "Set the target parameter for the url (determines whether target will open in a new page, etc.)" => "Set the target parameter for the url (determines whether target will open in a new page, etc.)",
"Parent" => "Szülő",
"Self" => "Self",
"Values" => "Értékek",
// "Colon-separated list of default values for the fields. First value corresponds to first field, second value to second field, etc" => "Colon-separated list of default values for the fields. First value corresponds to first field, second value to second field, etc",
"Overwrite" => "Felülírás",
// "Overwrite current field values of the item with the input values" => "Overwrite current field values of the item with the input values",
// "Display columns in the order listed in the fields parameter instead of by field ID (field ID order is used by default" => "Display columns in the order listed in the fields parameter instead of by field ID (field ID order is used by default",
"Preview" => "Előnézet",
// "Label for the preview button. Default" => "Label for the preview button. Default",
// "Label for the reset button, to return all fields to their default values" => "Label for the reset button, to return all fields to their default values",
// "reset" => "reset",
// "Status of the item used in combination with" => "Status of the item used in combination with",
"ItemId" => "Tétel ID",
// "ItemId allowing for editing an item" => "ItemId allowing for editing an item",
// "Ignore ItemId" => "Ignore ItemId",
// "Do not filter on the parameter itemId if in the url" => "Do not filter on the parameter itemId if in the url",
"Template File" => "Sablon fájl",
"Name of the template used to display the tracker items" => "Űralptételek megjelenítésekor használandó sablon neve",
"Name of the wiki page containing the template to display the tracker items" => "Az űrlaptételek megjelenítésére használandó sablont tartalmazó oldal neve",
"New Status" => "Új státusz",
"Default status applied to newly created items" => "Újonnan létrehozott tételek alapértelmezett státusza",
"Pending" => "Függő",
// "Specify the width in pixels or percentage of the first column (the labels) in the tracker form" => "Specify the width in pixels or percentage of the first column (the labels) in the tracker form",
// "Autosave fields" => "Autosave fields",
// "Colon-separated list of field IDs to be automatically filled with values" => "Colon-separated list of field IDs to be automatically filled with values",
// "Autosavevalue" => "Autosavevalue",
// "Colon-separated values corresponding to autosavefields" => "Colon-separated values corresponding to autosavefields",
// "Increase-only autosave fields" => "Increase-only autosave fields",
// "Colon-separated list of field IDs being autosaved whose value can only go up, not down" => "Colon-separated list of field IDs being autosaved whose value can only go up, not down",
// "Registration Fields" => "Registration Fields",
// "Add registration fields such as Username and Password" => "Add registration fields such as Username and Password",
// "Output To Wiki" => "Output To Wiki",
// "Output result to a new wiki page with the name taken from the input for the specified fieldId" => "Output result to a new wiki page with the name taken from the input for the specified fieldId",
// "Discard After Output" => "Discard After Output",
// "Used when results are output to a wiki page to discard the tracker item itself once the wiki page is created" => "Used when results are output to a wiki page to discard the tracker item itself once the wiki page is created",
// "Template Page" => "Template Page",
// "Name of the wiki page containing the template to format the output to wiki page" => "Name of the wiki page containing the template to format the output to wiki page",
// "Multiple Fill Fields" => "Multiple Fill Fields",
// "Colon-separated list of field IDs to be filled with multiple values, to create multiple items in one save. Example: 2:4:5  If empty, only one item will be created. Only for item creation" => "Colon-separated list of field IDs to be filled with multiple values, to create multiple items in one save. Example: 2:4:5  If empty, only one item will be created. Only for item creation",
// "Separator for Multiple Fill Fields" => "Separator for Multiple Fill Fields",
// "Choose separator between fields in each line of the Multiple Fill text area. Default is pipe (|)" => "Choose separator between fields in each line of the Multiple Fill text area. Default is pipe (|)",
// "Multiple Fill Fields defaults" => "Multiple Fill Fields defaults",
// "Colon-separated list of default values for Multiple Fill Fields" => "Colon-separated list of default values for Multiple Fill Fields",
// "Embed the tracker in a form tag" => "Embed the tracker in a form tag",
// "If set to Yes, the tracker is contained in a <form> tag and has action buttons" => "If set to Yes, the tracker is contained in a <form> tag and has action buttons",
// "The page to output the results to already exists. Try another name" => "The page to output the results to already exists. Try another name",
// "Tracker was modified at " => "Tracker was modified at ",
"Incorrect fieldId:" => "Hibás mezőID:",
"Following fields are incorrect" => "A következő mezők hibásak",
// "Each line is a list of %d field values separated with: %s" => "Each line is a list of %d field values separated with: %s",
// "Missing wiki template page \"%0\"" => "Missing wiki template page \"%0\"",
"You do not have permission to insert an item" => "Nincs elegendő jogosultság tétel beszúrásához",
// "Incorrect item" => "Incorrect item",
"You do not have permission to modify an item" => "Nincs elegendő jogosultság tétel megváltoztatásához",
// "The page to output the results to contains the following prohibited characters: %0. Try another name" => "The page to output the results to contains the following prohibited characters: %0. Try another name",
"Invalid email" => "Érvénytelen E-mail",
// "Passwords do not match" => "Passwords do not match",
// "Insert one item per line" => "Insert one item per line",
"Fields marked with a * are mandatory." => "A *-gal jelölt mezőket kötelező kitölteni",
"Tracker Comments" => "Űrlap kommentek",
// "Display the number of tracker comments" => "Display the number of tracker comments",
// "Item Count" => "Item Count",
// "Determines whether the number of items will be shown (not shown by default)" => "Determines whether the number of items will be shown (not shown by default)",
// "Enter a user name to select the items of the current user" => "Enter a user name to select the items of the current user",
// "a user name" => "a user name",
// "Comments found" => "Comments found",
"Filters" => "Szűrők",
// "The list of fields that can be used as filters along with their formats. The field number and format are separated by a / and multile fields are separated by \":\". Format choices are: d - dropdown; r - radio buttons; m - multiple choice dropdown; c - checkbox; t - text with wild characters; T - exact text match; i - initials; sqlsearch - advanced search; >, <, >=, <= - greater than, less than, greater than or equal, less than or equal. Example" => "The list of fields that can be used as filters along with their formats. The field number and format are separated by a / and multile fields are separated by \":\". Format choices are: d - dropdown; r - radio buttons; m - multiple choice dropdown; c - checkbox; t - text with wild characters; T - exact text match; i - initials; sqlsearch - advanced search; >, <, >=, <= - greater than, less than, greater than or equal, less than or equal. Example",
// "Label on the submit button. Default: \"Filter\". Use a space character to omit the button (for use in datachannels etc)" => "Label on the submit button. Default: \"Filter\". Use a space character to omit the button (for use in datachannels etc)",
"Display List" => "Lista megjelenítése",
// "Show the full list (before filtering) initially (filtered list shown by default)" => "Show the full list (before filtering) initially (filtered list shown by default)",
// "Displays all the filters on the same line (not shown on same line by default)" => "Displays all the filters on the same line (not shown on same line by default)",
// "Yes with field label in dropdown" => "Yes with field label in dropdown",
// "No Toggle" => "No Toggle",
// "The toggle button to show/hide filters will not be shown if set to y (Yes). Default is to show the toggle" => "The toggle button to show/hide filters will not be shown if set to y (Yes). Default is to show the toggle",
// "Export CSV" => "Export CSV",
// "Label for an export button. Leave blank to show the usual \"Filter\" button instead" => "Label for an export button. Leave blank to show the usual \"Filter\" button instead",
// "Google Map Buttons" => "Google Map Buttons",
// "Display Mapview and Listview buttons" => "Display Mapview and Listview buttons",
"Tracker Filter" => "Űrlap szűrő",
// "Create a form to filter tracker fields" => "Create a form to filter tracker fields",
"notice" => "megjegyzés",
"tracker field type not processed yet" => "űrlap mező típusa még nem került feldolgozásra",
// "Tracker If" => "Tracker If",
// "Display content based on results of a tracker field test" => "Display content based on results of a tracker field test",
// "Ignore" => "Ignore",
// "Ignore test in edit mode" => "Ignore test in edit mode",
// "Copy Tracker Item" => "Copy Tracker Item",
// "PluginTrackerItemCopy" => "PluginTrackerItemCopy",
// "Will not work with category or certain special fields, copies only data from specified fields" => "Will not work with category or certain special fields, copies only data from specified fields",
// "Tracker from which to copy item, joined tracker ids separated by " => "Tracker from which to copy item, joined tracker ids separated by ",
// "Fields links that are related to this tracker that you would like to join on, separated by " => "Fields links that are related to this tracker that you would like to join on, separated by ",
// "Field IDs to copy" => "Field IDs to copy",
// "Field IDs to copy old value of, separated by :, joined fields separated by |" => "Field IDs to copy old value of, separated by :, joined fields separated by |",
// "Field IDs to update values with" => "Field IDs to update values with",
// "Field IDs to update with new values specified, separated by :, joined fields separated by |" => "Field IDs to update with new values specified, separated by :, joined fields separated by |",
// "New Values" => "New Values",
// "New Values to replace for the field IDs specified, separated by :, joined fields separated by |, -randomstring- will generate random string; and f_xx to use value of field xx of itemId" => "New Values to replace for the field IDs specified, separated by :, joined fields separated by |, -randomstring- will generate random string; and f_xx to use value of field xx of itemId",
// "ID of item to make copy of, otherwise input is asked for" => "ID of item to make copy of, otherwise input is asked for",
// "Make this number of copies on load" => "Make this number of copies on load",
// "Set the number of copies to make on load of plugin automatically" => "Set the number of copies to make on load of plugin automatically",
// "Returns array non-interactively" => "Returns array non-interactively",
// "If y, returns array of new information instead of displaying results to screen, used in non-interactive mode" => "If y, returns array of new information instead of displaying results to screen, used in non-interactive mode",
// "Missing mandatory parameters" => "Missing mandatory parameters",
// "Number of update fields do not match new values" => "Number of update fields do not match new values",
"Tracker Item Field" => "Űrlap tétel mező",
// "Display or test the value of a tracker item field" => "Display or test the value of a tracker item field",
"Wiki text containing an {ELSE} marker" => "{ELSE} markert tartalmazó wiki szöveg",
// "Numeric value representing the item ID. Default is the user tracker item for the current user" => "Numeric value representing the item ID. Default is the user tracker item for the current user",
// "Numeric value representing the field ID displayed or tested" => "Numeric value representing the field ID displayed or tested",
// "Colon separated list of field IDs. Default is all fields" => "Colon separated list of field IDs. Default is all fields",
// "Status of the tracker item" => "Status of the tracker item",
// "Open & Pending" => "Open & Pending",
// "Open & Closed" => "Open & Closed",
// "Pending & Closed" => "Pending & Closed",
// "Open, Pending & Closed" => "Open, Pending & Closed",
// "Set to 1 (Yes) to test whether a field is empty (if value parameter is empty) or has a value the same as the value parameter" => "Set to 1 (Yes) to test whether a field is empty (if value parameter is empty) or has a value the same as the value parameter",
"Value to compare against" => "Ezzel az értékkel kell összehasonlítani",
// "You are not allowed to view this item" => "You are not allowed to view this item",
// "You are not allowed to view this field" => "You are not allowed to view this field",
"Tracker List" => "Űrlap lista",
// "List, filter and sort the items in a tracker" => "List, filter and sort the items in a tracker",
// "Colon-separated list of field IDs for the fields to be displayed. Example: 2:4:5" => "Colon-separated list of field IDs for the fields to be displayed. Example: 2:4:5",
// "Colon-separated list of fields which will display in a tooltip on mouse over. Example: 6:7" => "Colon-separated list of fields which will display in a tooltip on mouse over. Example: 6:7",
"Sticky Popup" => "Ragadós popup",
// "Choose whether the tooltip will stay displayed on mouse out (does not stay open by default)" => "Choose whether the tooltip will stay displayed on mouse out (does not stay open by default)",
"Show Links" => "Linkek megjelenítése",
// "Show links to each tracker item (not shown by default)" => "Show links to each tracker item (not shown by default)",
// "Show Item Count" => "Show Item Count",
// "Show the number of items found (not shown by default)" => "Show the number of items found (not shown by default)",
"Show Initials" => "Kezdőbetűk megjelenítése",
// "Show an alphabetical index by first letter to assist in navigation (not shown by default)" => "Show an alphabetical index by first letter to assist in navigation (not shown by default)",
// "Creation date display is based on tracker settings unless overriden here" => "Creation date display is based on tracker settings unless overriden here",
// "Last Modification Date" => "Last Modification Date",
// "Last modification date display is based on tracker settings unless overriden here" => "Last modification date display is based on tracker settings unless overriden here",
"Show Field Name" => "Mezőnév megjelenítése",
// "Use the field names as column titles (used by default)" => "Use the field names as column titles (used by default)",
// "Show Item Rank" => "Show Item Rank",
// "Show item ranks (not shown by default)" => "Show item ranks (not shown by default)",
// "Only show items matching certain status filters (only items with open status shown by default)" => "Only show items matching certain status filters (only items with open status shown by default)",
// "Sort rows in ascending or descending order based on field ID, date created or date last modified using these values: " => "Sort rows in ascending or descending order based on field ID, date created or date last modified using these values: ",
// "(replacing fieldId with the field ID number)" => "(replacing fieldId with the field ID number)",
// "Sort Choice" => "Sort Choice",
// "Add a dropdown of sorting choices. Example with two sorting choices: created_desc|Newest first: lastModif_desc|Last modified first" => "Add a dropdown of sorting choices. Example with two sorting choices: created_desc|Newest first: lastModif_desc|Last modified first",
// "Maximum number of items to display or -1 for all values. Defaults to max records preference, if set" => "Maximum number of items to display or -1 for all values. Defaults to max records preference, if set",
// "Offset of first item. Default is no offset" => "Offset of first item. Default is no offset",
// "Fix offset always (no pagination)" => "Fix offset always (no pagination)",
// "Fix offset to that specified, disallow pagination" => "Fix offset to that specified, disallow pagination",
// "Show Pagination" => "Show Pagination",
// "Determines whether pagination will be shown (shown by default)" => "Determines whether pagination will be shown (shown by default)",
"Filter Field" => "Szűrő mező",
"Colon separated list of fields to allow filtering on" => "Szűrőként használható mezők listája kettősponttal elválasztva",
"Filter Value" => "Szűrő érték",
// "Filter value of the filterfield. For better performance, use exactvalue instead" => "Filter value of the filterfield. For better performance, use exactvalue instead",
"Exact Value" => "Pontos érték",
// "Exact value of the filter" => "Exact value of the filter",
// "Adds a checkbox on each line to be able to do an action" => "Adds a checkbox on each line to be able to do an action",
// "e.g. fieldId/postName/Title/Submit/ActionUrl/tpl/radio|dropdown" => "e.g. fieldId/postName/Title/Submit/ActionUrl/tpl/radio|dropdown",
"goIfOne" => "goIfOne",
// "Go directly to tiki-view_tracker_item.php if only one item is found" => "Go directly to tiki-view_tracker_item.php if only one item is found",
"More" => "Több",
// "Show a 'more' button that links to tiki-view_tracker.php (not shown by default)" => "Show a 'more' button that links to tiki-view_tracker.php (not shown by default)",
"More URL" => "Több URL",
// "More link pointing to specified URL instead of default tracker item link" => "More link pointing to specified URL instead of default tracker item link",
// "Display only the items of the current user, the current page name or the current IP address" => "Display only the items of the current user, the current page name or the current IP address",
// "Use content of the tpl file as template to display the item" => "Use content of the tpl file as template to display the item",
"Wiki Page" => "Wiki oldal",
// "Use content of the wiki page as template to display the item. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins" => "Use content of the wiki page as template to display the item. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins",
// "Template file in a Wiki page" => "Template file in a Wiki page",
// "Use content of the wiki page as template to display the item but with as little parsing on the content as with a tpl on disk. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins" => "Use content of the wiki page as template to display the item but with as little parsing on the content as with a tpl on disk. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins",
"View User" => "Felhasználó megtekintése",
// "Will display the items of the specified user" => "Will display the items of the specified user",
"Item ID separated with " => "Tétel ID ezzel elválasztva",
// "To restrict the list to these item IDs" => "To restrict the list to these item IDs",
// "Ignore the itemId url parameter when filtering list (not ignored by default)" => "Ignore the itemId url parameter when filtering list (not ignored by default)",
// "The link that will be on each main field" => "The link that will be on each main field",
"Left Deliminator" => "Bal deliminator",
// "Smarty left delimiter for Latex generation" => "Smarty left delimiter for Latex generation",
"Right Deliminator" => "Jobb deliminator",
// "Smarty right delimiter for Latex generation" => "Smarty right delimiter for Latex generation",
// "List Mode" => "List Mode",
// "Set output format. Yes (y) displays tracker list view with truncated values (default); \n\t\t\t\t\t\t\t\tNo (n) displays in tracker item view; Comma Separated Values (csv) outputs without any HTML formatting" => "Set output format. Yes (y) displays tracker list view with truncated values (default); \n\t\t\t\t\t\t\t\tNo (n) displays in tracker item view; Comma Separated Values (csv) outputs without any HTML formatting",
// "Comma Separated Values" => "Comma Separated Values",
"Export Button" => "Export gomb",
// "Show an export button (not shown by default)" => "Show an export button (not shown by default)",
"Compute" => "Számítás",
"Sum or average all the values of a field and displays it at the bottom of the table" => "Egy mező összes értékének összege vagy átlaga a tábla alján megjelenítve",
"fieldId" => "fieldId",
// "Silent" => "Silent",
// "Show nothing if no items found (the table header and a 'No records found' message is shown by default)" => "Show nothing if no items found (the table header and a 'No records found' message is shown by default)",
// "Show Delete" => "Show Delete",
// "Show a delete option (not shown by default)" => "Show a delete option (not shown by default)",
// "Show Open Item" => "Show Open Item",
// "Show an open item  option (not shown by default)" => "Show an open item  option (not shown by default)",
// "Show Close Item" => "Show Close Item",
// "Show a close item option (not shown by default)" => "Show a close item option (not shown by default)",
// "Show Pending Item" => "Show Pending Item",
// "Show a pending item option (not shown by default)" => "Show a pending item option (not shown by default)",
// "Show Watch Button" => "Show Watch Button",
// "Show a watch button (not shown by default)" => "Show a watch button (not shown by default)",
// "Show Feed Button" => "Show Feed Button",
// "Show an RSS feed button (not shown by default)" => "Show an RSS feed button (not shown by default)",
// "Show Google Map" => "Show Google Map",
// "Show Google Map of results (not shown by default)" => "Show Google Map of results (not shown by default)",
// "Google Map Icon" => "Google Map Icon",
// "Url of default icon to use for markers on the map" => "Url of default icon to use for markers on the map",
// "Calendar Field IDs" => "Calendar Field IDs",
// "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds separated with : for start:end" => "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds separated with : for start:end",
// "Calendar View Mode" => "Calendar View Mode",
// "Calendar view type time span (default is month)" => "Calendar view type time span (default is month)",
// "Bimester" => "Bimester",
// "Trimester" => "Trimester",
// "Calendar Popup" => "Calendar Popup",
// "Calendar items will pop-up, overrides Sticky Popup if turned off. Set to y (Yes) by default" => "Calendar items will pop-up, overrides Sticky Popup if turned off. Set to y (Yes) by default",
// "Calendar item pop-ups will stay open if set to y (Yes). Set to n (No) by default" => "Calendar item pop-ups will stay open if set to y (Yes). Set to n (No) by default",
// "Beginning of Month" => "Beginning of Month",
// "Set whether calendar will begin at the beginning of the month (does by default)" => "Set whether calendar will begin at the beginning of the month (does by default)",
// "Show calendar navigation bar (shown by default)" => "Show calendar navigation bar (shown by default)",
// "Partial" => "Partial",
// "Calendar Title" => "Calendar Title",
// "Enter a title to display a calendar title (not set by default)" => "Enter a title to display a calendar title (not set by default)",
// "Calendar Delta" => "Calendar Delta",
// "Set the calendar delta that will be shown (not set by default)" => "Set the calendar delta that will be shown (not set by default)",
// "Plus Month" => "Plus Month",
// "Minus Month" => "Minus Month",
// "Plus Bimester" => "Plus Bimester",
// "Minus Bimester" => "Minus Bimester",
// "Display Spreadsheet" => "Display Spreadsheet",
// "Display tracker as a spreadsheet (not used by default)" => "Display tracker as a spreadsheet (not used by default)",
// "Force Compile" => "Force Compile",
// "Force Smarty to recompile the templates for each tracker item when using a wiki page as a template. Default=n (best performance)" => "Force Smarty to recompile the templates for each tracker item when using a wiki page as a template. Default=n (best performance)",
// "Numeric value to display only last tracker items created within a user defined time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how many of those units are to be considered to define the time frame. Use in conjunction with \"max=-1\" to list all items (by default \"max\" is set to 10)" => "Numeric value to display only last tracker items created within a user defined time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how many of those units are to be considered to define the time frame. Use in conjunction with \"max=-1\" to list all items (by default \"max\" is set to 10)",
// "Period type" => "Period type",
// "Time period after creation or after modification" => "Time period after creation or after modification",
// "Creation" => "Creation",
// "Modification" => "Modification",
"incorrect filterfield" => "hibás szűrőmező",
"Error in tracker ID" => "Hiba az űrlap ID-ban",
"No field indicated" => "Nincs mező megadva",
// "Check Tracker Passcodes" => "Check Tracker Passcodes",
// "PluginTrackerpasscode" => "PluginTrackerpasscode",
"Tracker Prefill" => "Űrlap előzetes kitöltése",
// "Create a button to prefill tracker fields" => "Create a button to prefill tracker fields",
// "Tracker Page Name" => "Tracker Page Name",
// "URL Parameters" => "URL Parameters",
// "Parameters to pass in the url, e.g. &my_parameter1=123&my_parameter2=q" => "Parameters to pass in the url, e.g. &my_parameter1=123&my_parameter2=q",
"Field 1" => "Mező 1",
// "Field ID for the first field" => "Field ID for the first field",
"Value 1" => "Érték 1",
// "Content that should be used to prefill the field" => "Content that should be used to prefill the field",
"Field 2" => "Mező 2",
// "Field ID for the second field" => "Field ID for the second field",
"Value 2" => "Érték 2",
"Field 3" => "Mező 3",
// "Field ID for the third field" => "Field ID for the third field",
"Value 3" => "Érték 3",
"Field 4" => "Mező 4",
// "Field ID for the fourth field" => "Field ID for the fourth field",
"Value 4" => "Érték 4",
"Field 5" => "Mező 5",
// "Field ID for the fifth field" => "Field ID for the fifth field",
"Value 5" => "Érték 5",
// "Field 6" => "Field 6",
// "Field ID for the sixth field" => "Field ID for the sixth field",
// "Value 6" => "Value 6",
// "Field 7" => "Field 7",
// "Field ID for the seventh field" => "Field ID for the seventh field",
// "Value 7" => "Value 7",
// "Field 8" => "Field 8",
// "Field ID for the eighth field" => "Field ID for the eighth field",
// "Value 8" => "Value 8",
"Tracker Stats" => "Űrlap statisztika",
// "Display statistics about a tracker" => "Display statistics about a tracker",
"Colon-separated list of field IDs to be displayed. Example: 2:4:5" => "Megjelenítendő mező ID-k kettősponttal elválasztott listája. Például: 2:4:5",
// "Show Count" => "Show Count",
// "Choose whether to show the count of votes each option received (shown by default)" => "Choose whether to show the count of votes each option received (shown by default)",
// "Choose whether to show the percentage of the vote each option received (not shown by default)" => "Choose whether to show the percentage of the vote each option received (not shown by default)",
// "Choose whether to show a bar representing the number of votes each option received (not shown by default)" => "Choose whether to show a bar representing the number of votes each option received (not shown by default)",
// "Only show items matching certain status filters" => "Only show items matching certain status filters",
// "Show Link" => "Show Link",
"Show link to tiki-view_tracker" => "Link mutatása a tiki-view_tracker-hez",
// "Show last modification date of a tracker. Set to y to use site setting or use PHP\\s format (www.php.net/strftime)" => "Show last modification date of a tracker. Set to y to use site setting or use PHP\\s format (www.php.net/strftime)",
// "y to use the site setting for short date format. Otherwise, use PHP format (www.php.net/strftime), Example: \"%A %d of %B, %Y\"" => "y to use the site setting for short date format. Otherwise, use PHP format (www.php.net/strftime), Example: \"%A %d of %B, %Y\"",
// "invalid status" => "invalid status",
"incorrect fieldId" => "hibás mezőID",
"Tracker Timeline" => "Űrlap idő",
// "Show a timeline view of a tracker" => "Show a timeline view of a tracker",
"Title Field" => "Név mező",
"Tracker Field ID containing the item title" => "Azon űrlap mező ID mely a tétel nevét tartalmazza",
"Summary Field" => "Összegző mező",
"Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused" => "Azon űrlap mező ID-ja melyben a tétel leírása található. Ez a leíró mező jelenik meg mikor a tételre fókuszálunk",
"Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field" => "Azon űrlap mező ID-ja mely az elem kezdési dátumát tartalmazza. A mezőnek datetime/jscalendar mezőnek kell lennie",
"Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field" => "Azon űrlap mező ID-ja mely az elem befejezési dátumát tartalmazza. A mezőnek datetime/jscalendar mezőnek kell lennie",
"Element Group" => "Elem csoport",
"Tracker Field ID containing the element's group. Elements of a same group are displayed on the same row" => "Azon űrlap mező ID-ja mely az elem csoportját tartalmazza. Egy csoportba tartozó elemek ugyanabban a sorban jelennek meg",
// "Unit of time to use for the primary scale (default to hour - * SIMILE only)" => "Unit of time to use for the primary scale (default to hour - * SIMILE only)",
// "Decade *" => "Decade *",
// "Century *" => "Century *",
// "Unit of time to use for the secondary scale (default to empty - * SIMILE only)" => "Unit of time to use for the secondary scale (default to empty - * SIMILE only)",
// "Timeline height" => "Timeline height",
// "Height of the timeline band as a CSS unit (default: 250px -  - * SIMILE only)" => "Height of the timeline band as a CSS unit (default: 250px -  - * SIMILE only)",
// "Lower band height" => "Lower band height",
// "Height of the lower timeline band as a percentage (default: 30 -  - * SIMILE only)" => "Height of the lower timeline band as a percentage (default: 30 -  - * SIMILE only)",
"Link Group Name" => "Csoportnév link",
// "Convert the group name to a link" => "Convert the group name to a link",
"Page Link Field" => "Oldallink mező",
"Tracker Field ID containing the page name for item details" => "Azon űrlap mező ID-ja mely a tétel részleteit leíró oldal nevét tartalmazza",
// "SIMILE Timeline" => "SIMILE Timeline",
// "Use the SIMILE Timeline Widget" => "Use the SIMILE Timeline Widget",
// "Image Field" => "Image Field",
// "Tracker Field ID containing in image" => "Tracker Field ID containing in image",
"Missing parameter: %0" => "Hiányzó paraméter: %0",
"Start date after end date" => "Kezdési dátuma a befejezési dátum után van",
// "Tracker Toggle" => "Tracker Toggle",
// "Toggle element display on a field value" => "Toggle element display on a field value",
// "Numeric value representing the field ID tested" => "Numeric value representing the field ID tested",
// "Element visibility" => "Element visibility",
// "If y, is visible when the field has the value" => "If y, is visible when the field has the value",
// "Html ID of the element that is toggled" => "Html ID of the element that is toggled",
// "Use the field of specific item. The URL param itemId is used if this parameter is not set" => "Use the field of specific item. The URL param itemId is used if this parameter is not set",
"Trade" => "Kereskedés",
// "Send or receive payments from one member to another. (for cclite only so far, experimental)" => "Send or receive payments from one member to another. (for cclite only so far, experimental)",
// "Currency depends on the selected registry" => "Currency depends on the selected registry",
// "Registry to trade in. Default: site preference (or first in list when more than one)" => "Registry to trade in. Default: site preference (or first in list when more than one)",
// "Currency to trade in. Default: Cclite currency preference for registry set above" => "Currency to trade in. Default: Cclite currency preference for registry set above",
// "Other User" => "Other User",
// "Name of the user to recieve or send the payment" => "Name of the user to recieve or send the payment",
// "Leave empty to display an input box" => "Leave empty to display an input box",
// "Offered or wanted item" => "Offered or wanted item",
// "Offered" => "Offered",
// "Wanted" => "Wanted",
"Continue" => "Tovább",
// "Use %0 for the amount, %1 for currency, %2 for your user name, %3 for the other user" => "Use %0 for the amount, %1 for currency, %2 for your user name, %3 for the other user",
// "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user %2 from %3\" for wanted" => "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user %2 from %3\" for wanted",
// "Please log in" => "Please log in",
// " needs to validate their account" => " needs to validate their account",
// "Transclude" => "Transclude",
// "PluginTransclude" => "PluginTransclude",
// "Include the content of another page with certain changes" => "Include the content of another page with certain changes",
// "Name of the wiki page to use as a template for the values" => "Name of the wiki page to use as a template for the values",
// "Attempt to include a page that cannot be viewed" => "Attempt to include a page that cannot be viewed",
"Page not found" => "Az oldal nem található",
// "Page named \"%0\" does not exist at this time" => "Page named \"%0\" does not exist at this time",
"Translated" => "Fordítás",
// "Create multi-lingual links" => "Create multi-lingual links",
"[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)" => "[url] vagy ((wikiname)) vagy ((inter:interwiki)) (wiki szintakszist használ)",
"Two letter language code of the language, ex: fr" => "A nyelv két betűs kódja, pld: hu",
"Flag" => "Zászló",
"Country name, ex: France" => "Ország neve, pld: Franciaország",
// "Twitter" => "Twitter",
// "Display the activity for a twitter account" => "Display the activity for a twitter account",
// "Account Name" => "Account Name",
// "Name of the twitter account" => "Name of the twitter account",
// "Shell Background Color" => "Shell Background Color",
// "Background color for the overall widget, i.e., header, footer and outside border. Default is red (color code #15a2b)" => "Background color for the overall widget, i.e., header, footer and outside border. Default is red (color code #15a2b)",
// "Valid HTML color codes (with beginning #) or names" => "Valid HTML color codes (with beginning #) or names",
// "Shell Text Color" => "Shell Text Color",
// "Text color for the widget header and footer. Default is white (color code #ffffff)" => "Text color for the widget header and footer. Default is white (color code #ffffff)",
// "Tweet Background Color" => "Tweet Background Color",
// "Background color for individual tweets. Default is white" => "Background color for individual tweets. Default is white",
// "Tweet Text Color" => "Tweet Text Color",
// "Text color for individual tweets. Default is black" => "Text color for individual tweets. Default is black",
// "Height of widget in pixels. Default is 300" => "Height of widget in pixels. Default is 300",
// "Width of widget in pixels or 'auto' to fit to width of page. Default is auto" => "Width of widget in pixels or 'auto' to fit to width of page. Default is auto",
// "Number of pixels or the word 'auto'" => "Number of pixels or the word 'auto'",
"User Count" => "Felhasználók száma",
// "Display number of users for a site or group" => "Display number of users for a site or group",
"Group name" => "Csoport neve",
// "User Link" => "User Link",
// "Display a link to a user's information page" => "Display a link to a user's information page",
// "User account name (which can be an email address)" => "User account name (which can be an email address)",
"User List" => "Felhasználók listája",
// "Display a list of registered users" => "Display a list of registered users",
"Login Filter" => "Felhasználói név szűrő",
// "Separator to use between users in the list. Default: comma" => "Separator to use between users in the list. Default: comma",
// "User info" => "User info",
// "User page" => "User page",
// "User pref" => "User pref",
"Real Name" => "Valódi név",
// "Display the user's real name (when available) instead of login name" => "Display the user's real name (when available) instead of login name",
// "Filter on a group" => "Filter on a group",
"users" => "felhasználók",
// "Display contents based on user preference settings" => "Display contents based on user preference settings",
// "Create tabs for showing alternate versions of content" => "Create tabs for showing alternate versions of content",
// "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default" => "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default",
"Navigation" => "Navigáció",
// "Displays a navigation box that allows users to select a specific version to display" => "Displays a navigation box that allows users to select a specific version to display",
// "Display the current version name as the title. No title shows when nav=>y; otherwise shows by default" => "Display the current version name as the title. No title shows when nav=>y; otherwise shows by default",
// "Default Label" => "Default Label",
// "Specifies version label to show when displaying the page for the first time. Default label is 'Default'" => "Specifies version label to show when displaying the page for the first time. Default label is 'Default'",
// "Display a Vimeo video" => "Display a Vimeo video",
// "Entire URL to the Vimeo video. Example: http://vimeo.com/3319966" => "Entire URL to the Vimeo video. Example: http://vimeo.com/3319966",
// "Quality of the video" => "Quality of the video",
// "Full screen" => "Full screen",
// "Expand to full screen" => "Expand to full screen",
"Vote" => "Szavazás",
// "Create a tracker for voting" => "Create a tracker for voting",
"Show Stats" => "Statisztika megjelenítése",
// "Choose whether to show the voting results (shown by default)" => "Choose whether to show the voting results (shown by default)",
"Show Stats After" => "Statisztika megjelenítése utána",
// "Choose whether to show the voting results only after the date given in the tracker configuration (not set by default)" => "Choose whether to show the voting results only after the date given in the tracker configuration (not set by default)",
// "Choose whether to display the user name of the creator of the voting tracker (not shown by default)" => "Choose whether to display the user name of the creator of the voting tracker (not shown by default)",
// "Align the plugin on the page, allowing other elements to wrap around it (not set by default)" => "Align the plugin on the page, allowing other elements to wrap around it (not set by default)",
// "Votings" => "Votings",
// "Saves voting information in Smarty variables for display" => "Saves voting information in Smarty variables for display",
// "Object Key" => "Object Key",
// "Object key that is used to record votes" => "Object key that is used to record votes",
// "Return value" => "Return value",
// "Value to display as output of plugin" => "Value to display as output of plugin",
"Wanted Pages" => "Wanted oldalak",
// "Show location of links to pages not yet created" => "Show location of links to pages not yet created",
// "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom). Possible values: a valid regex-expression (PCRE)" => "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom). Possible values: a valid regex-expression (PCRE)",
// "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)" => "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)",
"a valid regex-expression (PCRE)" => "egy valid regex-expression (PCRE)",
// "Split By" => "Split By",
// "The character by which ignored patterns are separated" => "The character by which ignored patterns are separated",
// "Skip Extension" => "Skip Extension",
// "Whether to include external wikis in the list (not included by default)" => "Whether to include external wikis in the list (not included by default)",
// "Collect" => "Collect",
// "Collect either originating (from) or wanted pages (to) in a cell and display them in the second column" => "Collect either originating (from) or wanted pages (to) in a cell and display them in the second column",
"From" => "Feladó",
"To" => "Címzett",
// "Switch on debug output with details about the items (debug not on by default)" => "Switch on debug output with details about the items (debug not on by default)",
// "Memory Saver" => "Memory Saver",
// "Multiple collected items are separated in distinct table rows (default), or by comma or line break in one cell" => "Multiple collected items are separated in distinct table rows (default), or by comma or line break in one cell",
"Line break" => "Sortörés",
// "Separate Row" => "Separate Row",
"Level" => "Szint",
"Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex." => "Keresett oldalak listájának szűrése page_regex vagy saját szűrő alapján. Az alapértelmezett érték a weblaphoz tartozó __current__ page_regex",
// "Custom" => "Custom",
// "Full" => "Full",
"non-valid custom regex" => "nem valid custom regex",
// ", " => ", ",
"ignored" => "ignorálva",
"External Wiki" => "External Wiki",
"dash-WikiWord" => "elválasztás-WikiWord",
"WikiWord" => "WikiWord",
"not in level" => "nincs szintben",
"valid" => "érvényes",
"End of debug output." => "Hibakeresési adatok vége",
"Wanted Page" => "Wanted oldal",
"Referenced By Page" => "Oldal által hivatkozva",
// "Watershed" => "Watershed",
// "Viewer for UStream Watershed Embed" => "Viewer for UStream Watershed Embed",
// "Specify archive, broadcaster, chat or viewer" => "Specify archive, broadcaster, chat or viewer",
"Archive" => "Archívum",
// "Broadcaster" => "Broadcaster",
// "Viewer" => "Viewer",
// "Channel code" => "Channel code",
// "Specify the channel code to search in the tracker for a channel to use" => "Specify the channel code to search in the tracker for a channel to use",
// "Brand ID" => "Brand ID",
// "Specify the brand id to search in the tracker for a channel to use" => "Specify the brand id to search in the tracker for a channel to use",
// "Brand prefix" => "Brand prefix",
// "Copy the prefix from the chat embed, e.g. Name-of-Brand-" => "Copy the prefix from the chat embed, e.g. Name-of-Brand-",
// "Video ID" => "Video ID",
// "Video ID of archive which can be found in the tracker" => "Video ID of archive which can be found in the tracker",
// "Locale specified in viewer embed, default is en_US" => "Locale specified in viewer embed, default is en_US",
// "More than one channel found for specified criteria. Please be more specific" => "More than one channel found for specified criteria. Please be more specific",
// "No videoId specified for archive" => "No videoId specified for archive",
// "Web Service" => "Web Service",
// "Display remote information exposed in JSON or YAML" => "Display remote information exposed in JSON or YAML",
// "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter" => "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter",
// "Complete service URL" => "Complete service URL",
"Registered service name" => "Solgáltatás regisztrált neve",
// "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided" => "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided",
// "Body as Parameter" => "Body as Parameter",
// "Name of the argument to send the body as for services with complex input. Named service required for this to be useful" => "Name of the argument to send the body as for services with complex input. Named service required for this to be useful",
// "Parameters formatted like a query : param1=value1&amp;param2=value2" => "Parameters formatted like a query : param1=value1&amp;param2=value2",
"Unknown Template" => "Ismeretlen sablon",
"Unknown Service" => "Ismeretlen szolgáltatás",
// "Permits to have a WYSIWYG section for part of a page" => "Permits to have a WYSIWYG section for part of a page",
// "Minimum width for DIV. Default:500px" => "Minimum width for DIV. Default:500px",
// "Minimum height for DIV. Default:300px" => "Minimum height for DIV. Default:300px",
// "You have unsaved changes in this WYSIWYG section.\nDo you want to save your changes" => "You have unsaved changes in this WYSIWYG section.\nDo you want to save your changes",
// "YouTube" => "YouTube",
// "Display a YouTube video" => "Display a YouTube video",
// "Movie" => "Movie",
// "Entire URL to the YouTube video or last part (after www.youtube.com/v/ and before the first question mark)" => "Entire URL to the YouTube video or last part (after www.youtube.com/v/ and before the first question mark)",
// "Quality of the video. Default is high" => "Quality of the video. Default is high",
// "Enlarge video to full screen size" => "Enlarge video to full screen size",
"Related" => "Kapcsolódó",
// "Show related videos (shown by default)" => "Show related videos (shown by default)",
// "Background" => "Background",
// "Toolbar background color. Use an HTML color code. Example: ffffff" => "Toolbar background color. Use an HTML color code. Example: ffffff",
// "HTML color code, e.g. ffffff" => "HTML color code, e.g. ffffff",
// "Toolbar border colors. Use an HTML color code. Example: ffffff" => "Toolbar border colors. Use an HTML color code. Example: ffffff",
// "Plugin YouTube error: the movie parameter is empty" => "Plugin YouTube error: the movie parameter is empty",
// "Missing parameter movie to the Youtube plugin" => "Missing parameter movie to the Youtube plugin",
// "Zotero Citation" => "Zotero Citation",
// "Retrieves and includes a Zotero reference in the page" => "Retrieves and includes a Zotero reference in the page",
// "Reference Key" => "Reference Key",
// "Unique reference for the group associated to the site. Can be retrieved from the Zotero Bibliography module" => "Unique reference for the group associated to the site. Can be retrieved from the Zotero Bibliography module",
// "Reference Tag" => "Reference Tag",
// "Uses the first result using the specified tag. Useful when the tag mechanism is coerced into creating unique human memorizable keys" => "Uses the first result using the specified tag. Useful when the tag mechanism is coerced into creating unique human memorizable keys",
// "Append a note to the reference for additional information, like page numbers or other sub-references" => "Append a note to the reference for additional information, like page numbers or other sub-references",
// "Zotero Reference List" => "Zotero Reference List",
// "Produces the complete reference list from the Zotero server" => "Produces the complete reference list from the Zotero server",
// "Provide the list of references with a given tag" => "Provide the list of references with a given tag",
// "No results obtained. The Zotero citation server may be down" => "No results obtained. The Zotero citation server may be down",
"ERROR: Either the subject or body must be non-empty" => "Az üzenet tárgya vagy az üzenet törzse nem lehet üres!",
// "User %s does not have the permission" => "User %s does not have the permission",
// "The message has been sent to" => "The message has been sent to",
// "The message will be sent to" => "The message will be sent to",
"ERROR: No valid users to send the message" => "HIBA: Nincs érvényes felhasználó akinek el lehetne küldeni az üzenetet",
// "User %s does not want to receive messages" => "User %s does not want to receive messages",
"Invalid user" => "Érvénytelen felhasználó",
"Sent box is full. Archive or delete some sent messages first if you want to send more messages." => "Kimenő üzenetek fiókja betelt. Levélküldés előtt törölni vagy archíválni kellene pár üzenetet.",
// "An error occurred, please check your mail settings and try again" => "An error occurred, please check your mail settings and try again",
"You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'" => "Üzenetek küldéséhez előbb lehetővé kell tenni üzenetek fogadását. Ezt a lehetőséget a felhasználói preferenciák között a 'Más felhasználók üzenhetnek nekem' opció bekapcsolásával lehet aktiválni",
"User %s can not receive messages, mailbox is full" => "%s felhasználó nem tud üzeneteket fogadni mert betelt a postafiókja",
"User %s can not receive messages" => "%s felhasználó nem tud üzeneteket fogadni",
"Invalid user: %s" => "Érvénytelen felhasználó: %s",
// "Message has been sent to: " => "Message has been sent to: ",
"Archive is full. Delete some messages from archive first." => "Az archívum megtelt. Először törölni kell néhány üzenetet az archívumból.",
"No more messages" => "Nincs több üzenet",
// "ERROR: " => "ERROR: ",
// "ERROR: Invalid tab_id received. Numeric format expected, got %0" => "ERROR: Invalid tab_id received. Numeric format expected, got %0",
// "Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page" => "Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page",
// "Item types filter" => "Item types filter",
// "If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes" => "If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes",
// "Possible item type values" => "Possible item type values",
"Similar Content" => "Hasonló tartalom",
// "Find similar content based on FreeTags" => "Find similar content based on FreeTags",
// "Similar Content Filter" => "Similar Content Filter",
// "Display only similar content of type specified" => "Display only similar content of type specified",
// "Default: \"All Content Type\"" => "Default: \"All Content Type\"",
// "Options: \"article, wiki page, blog post\"" => "Options: \"article, wiki page, blog post\"",
// "Broaden FreeTag Search" => "Broaden FreeTag Search",
// "Find similar content that contains one of the Tags or All of the Tags" => "Find similar content that contains one of the Tags or All of the Tags",
// "Default: \"n - needs to contain all of the Tags\"" => "Default: \"n - needs to contain all of the Tags\"",
// "Options: \"n - Needs to contain All Tags / y - Needs to contain one of the Tags\"" => "Options: \"n - Needs to contain All Tags / y - Needs to contain one of the Tags\"",
// "Google AdSense" => "Google AdSense",
// "Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code" => "Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code",
// "ad_channel" => "ad_channel",
// "Advertisement channel, as optionally provided by Google" => "Advertisement channel, as optionally provided by Google",
// "client" => "client",
// "As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"" => "As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"",
// "display" => "display",
// "Global banner format as provided by Google. For example: \"display=468*60_as\"" => "Global banner format as provided by Google. For example: \"display=468*60_as\"",
// "color_bg" => "color_bg",
// "Background color, as optionally provided by Google" => "Background color, as optionally provided by Google",
// "color_border" => "color_border",
// "Border color, as optionally provided by Google" => "Border color, as optionally provided by Google",
// "color_link" => "color_link",
// "Link color, as optionally provided by Google" => "Link color, as optionally provided by Google",
// "color_text" => "color_text",
// "Text color, as optionally provided by Google" => "Text color, as optionally provided by Google",
// "color_url" => "color_url",
// "URL color, as optionally provided by Google" => "URL color, as optionally provided by Google",
"Article Archives" => "Cikk arhívum",
// "Shows links to the published articles for each month" => "Shows links to the published articles for each month",
// "If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles" => "If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles",
// "Default: \"n\"" => "Default: \"n\"",
// "If set to a category identifier, only consider the articles in the specified category" => "If set to a category identifier, only consider the articles in the specified category",
// "Example value: 13" => "Example value: 13",
// "Topic filter (by names)" => "Topic filter (by names)",
// "If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered",
// "Topic filter (by identifiers)" => "Topic filter (by identifiers)",
// "If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered",
// "Example values: 13, !13, 1+3, !1+5+7" => "Example values: 13, !13, 1+3, !1+5+7",
// "Types filter" => "Types filter",
// "If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered" => "If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered",
// "Example values: Event, !Event, Event+Review, !Event+Classified+Article" => "Example values: Event, !Event, Event+Review, !Event+Classified+Article",
// "Language filter" => "Language filter",
// "If set to a language code, only consider the articles in the specified language" => "If set to a language code, only consider the articles in the specified language",
"Article Topics" => "Cikk témák",
// "Lists all article topics with links to their articles" => "Lists all article topics with links to their articles",
// "Lists the specified number of published articles in the specified order" => "Lists the specified number of published articles in the specified order",
// "Show publication time" => "Show publication time",
// "If set to \"y\", article publication times are shown" => "If set to \"y\", article publication times are shown",
// "Show creation time" => "Show creation time",
// "If set to \"y\", article creation times are shown" => "If set to \"y\", article creation times are shown",
// "Show rating selector" => "Show rating selector",
// "If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating" => "If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating",
// "If set, displays an image for each article if one applies, with the given width (in pixels). The article's own image is used, with a fallback to the article's topic image" => "If set, displays an image for each article if one applies, with the given width (in pixels). The article's own image is used, with a fallback to the article's topic image",
// "If set to a category identifier, only lists the articles in the specified category" => "If set to a category identifier, only lists the articles in the specified category",
// "If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed",
// "If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed",
// "If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed" => "If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed",
// "If set to a language code, only lists the articles in the specified language" => "If set to a language code, only lists the articles in the specified language",
// "Specifies how the articles should be sorted" => "Specifies how the articles should be sorted",
// "Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date" => "Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date",
// "If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead" => "If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead",
// "If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles" => "If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles",
// "Absolute URL" => "Absolute URL",
// "If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example" => "If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example",
// "If set to 0, will take the topicId of the article if in an article" => "If set to 0, will take the topicId of the article if in an article",
// "Tiki Assistant" => "Tiki Assistant",
// "Display an assistant to guide new Tiki admins" => "Display an assistant to guide new Tiki admins",
// "Babel Fish Links" => "Babel Fish Links",
// "Offers a link to the Yahoo! Babel Fish translation service" => "Offers a link to the Yahoo! Babel Fish translation service",
// "Babel Fish Icon Link" => "Babel Fish Icon Link",
// "Display an icon linked to the Yahoo! Babel Fish translation service" => "Display an icon linked to the Yahoo! Babel Fish translation service",
"Newest Blog Post Comments" => "Legutóbbi blog kommentek",
// "Displays the specified number of the blog post comments most recently added" => "Displays the specified number of the blog post comments most recently added",
// "No date" => "No date",
// "If set to \"y\", the date of comments is not displayed in the module box" => "If set to \"y\", the date of comments is not displayed in the module box",
// "Verbose tooltips" => "Verbose tooltips",
// "If set to \"y\", blog post title is only visible as a tooltip and not displayed" => "If set to \"y\", blog post title is only visible as a tooltip and not displayed",
// "Options: \"y,n\"" => "Options: \"y,n\"",
"Last-Visited Pages" => "Legutóbb látogatott oldalak",
// "Displays the last Wiki pages visited by the user" => "Displays the last Wiki pages visited by the user",
// "Maximum number of characters in page names allowed before truncating" => "Maximum number of characters in page names allowed before truncating",
// "A hierarchy of where you are. Ex.: Home > Section1 > Subsection C" => "A hierarchy of where you are. Ex.: Home > Section1 > Subsection C",
// "Label preceding the crumbs" => "Label preceding the crumbs",
// "Menu Id" => "Menu Id",
// "Menu to take the crumb trail from" => "Menu to take the crumb trail from",
// "Menu Start Level" => "Menu Start Level",
// "Lowest level of the menu to display" => "Lowest level of the menu to display",
// "Menu Stop Level" => "Menu Stop Level",
// "Highest level of the menu to display" => "Highest level of the menu to display",
// "Show Site Crumb" => "Show Site Crumb",
// "Display the first crumb, usually the site, when using menu crumbs" => "Display the first crumb, usually the site, when using menu crumbs",
// "Show Page Crumb" => "Show Page Crumb",
// "Display the last crumb, usually the page, when using menu crumbs" => "Display the last crumb, usually the page, when using menu crumbs",
// "Show Crumb Links" => "Show Crumb Links",
// "Display links on the crumbs" => "Display links on the crumbs",
// "Includes a calendar or a list of calendar events" => "Includes a calendar or a list of calendar events",
// "Calendars filter" => "Calendars filter",
// "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\"). Example values: \"13\", \"4,7\", \"31:49\". Not set by default" => "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\"). Example values: \"13\", \"4,7\", \"31:49\". Not set by default",
// "Displayed month (relative)" => "Displayed month (relative)",
// "Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span. Example values: 2, 0, -2, -12" => "Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span. Example values: 2, 0, -2, -12",
// "View type" => "View type",
// "Determines how to show events. Possible values: %0, %1" => "Determines how to show events. Possible values: %0, %1",
// "Calendar view type time span" => "Calendar view type time span",
// "If in calendar (or \"table\") view type, determines the time span displayed by the calendar. Possible values: %0, %1, %2, %3 ,%4, %5. A user changing this time span in the calendar can change the time span the module displays for him" => "If in calendar (or \"table\") view type, determines the time span displayed by the calendar. Possible values: %0, %1, %2, %3 ,%4, %5. A user changing this time span in the calendar can change the time span the module displays for him",
// "Show action" => "Show action",
// "Viewmode when clicking on a day" => "Viewmode when clicking on a day",
// "Put a link on all the days , not only those with event" => "Put a link on all the days , not only those with event",
// "View navigation bar" => "View navigation bar",
"Cart" => "Bevásárló kocsi",
// "Displays the content of the cart, allows to modify quantities and proceed to payment" => "Displays the content of the cart, allows to modify quantities and proceed to payment",
// "The quantities in your cart were updated" => "The quantities in your cart were updated",
// "Gift card added" => "Gift card added",
// "Gift card not found" => "Gift card not found",
// "Gift card removed" => "Gift card removed",
// "Displays links to categories as a tree" => "Displays links to categories as a tree",
// "Object type filter" => "Object type filter",
// "Object type filter to apply when accessing a linked category. Example values" => "Object type filter to apply when accessing a linked category. Example values",
// "Deep" => "Deep",
// "Show subcategories objects when accessing a linked category. Possible values: on (default), off" => "Show subcategories objects when accessing a linked category. Possible values: on (default), off",
// "Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don't limit display)" => "Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don't limit display)",
// "Show these categories and their children" => "Show these categories and their children",
// "Show only these categories and the immediate child categories of these in the order the parameter specifies. Example values: 3,5,6" => "Show only these categories and the immediate child categories of these in the order the parameter specifies. Example values: 3,5,6",
// "Category links to a page named as the category" => "Category links to a page named as the category",
// "If y, category links to a page named as the category" => "If y, category links to a page named as the category",
"Category Transitions" => "Kategória tranzíciók",
// "Displays controls to trigger category transitions and change the page's state according to predefined rules" => "Displays controls to trigger category transitions and change the page's state according to predefined rules",
// "Example Transition" => "Example Transition",
"Change Category" => "Kategória változtatása",
// "Enables to categorize an object" => "Enables to categorize an object",
// "This module currently only supports Wiki pages. Some combinations of Multiple categories, Detailed, Unassign and Assign may challenge intuition or be simply broken" => "This module currently only supports Wiki pages. Some combinations of Multiple categories, Detailed, Unassign and Assign may challenge intuition or be simply broken",
// "Category identifier" => "Category identifier",
// "Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier" => "Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier",
// "Note that the root category is not displayed" => "Note that the root category is not displayed",
// "Defaults to 0 (root)" => "Defaults to 0 (root)",
// "No top" => "No top",
// "In non-detailed view, disallow uncategorizing. Example value: 1" => "In non-detailed view, disallow uncategorizing. Example value: 1",
// "Display path" => "Display path",
// "Unless set to \"n\", display relative category paths in the category tree rather than category names" => "Unless set to \"n\", display relative category paths in the category tree rather than category names",
// "Paths are relative to the root category, which is not displayed" => "Paths are relative to the root category, which is not displayed",
// "Multiple categories" => "Multiple categories",
// "If set to \"n\", only allows categorizing in one category (from those displayed)" => "If set to \"n\", only allows categorizing in one category (from those displayed)",
"Categorize" => "Kategorizálás",
// "String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize" => "String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize",
// "Shy" => "Shy",
// "If set to \"y\", the module is not shown on pages which are not already categorized" => "If set to \"y\", the module is not shown on pages which are not already categorized",
// "Detailed" => "Detailed",
// "If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list" => "If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list",
// "Unassign" => "Unassign",
// "If set to \"n\", the detailed list of categories will not offer to unassign a category" => "If set to \"n\", the detailed list of categories will not offer to unassign a category",
// "If set to \"y\", allow to assign new categories" => "If set to \"y\", allow to assign new categories",
// "Example values: y, n" => "Example values: y, n",
// "Default value: y" => "Default value: y",
// "Group filter" => "Group filter",
// "Very particular filter option. If set to \"y\", only categories with a name matching one of the user's groups are shown, and descendants of these matching categories" => "Very particular filter option. If set to \"y\", only categories with a name matching one of the user's groups are shown, and descendants of these matching categories",
// "Default value: n" => "Default value: n",
// "Image URL not in category" => "Image URL not in category",
// "Very particular parameter. If both this and \"Image URL in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category" => "Very particular parameter. If both this and \"Image URL in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category",
// "Image URL in category" => "Image URL in category",
// "Very particular parameter. If both this and \"Image URL not in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category" => "Very particular parameter. If both this and \"Image URL not in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category",
// "Categorize %s" => "Categorize %s",
// "Categorize %s in %s" => "Categorize %s in %s",
"Received Objects" => "Fogadott objektumok",
// "Displays the number of pages received (via Communications)" => "Displays the number of pages received (via Communications)",
"Contributors" => "Hozzájárulók",
// "Lists the contributors to the wiki page being viewed and some information on them" => "Lists the contributors to the wiki page being viewed and some information on them",
// "Shows the credits a user has" => "Shows the credits a user has",
"Newest Directory Sites" => "Legutóbbi oldalak a könyvtárban",
// "Displays the specified number of the directory sites most recently added" => "Displays the specified number of the directory sites most recently added",
// "Directory category identifier" => "Directory category identifier",
// "If set to a directory category identifier, only displays the sites in the specified directory category" => "If set to a directory category identifier, only displays the sites in the specified directory category",
// "If set to \"y\", displays a button labelled \"More\" that links to the directory" => "If set to \"y\", displays a button labelled \"More\" that links to the directory",
"Show description" => "Leírás megjelenítése",
// "If set to \"y\", the description of the directory site appears" => "If set to \"y\", the description of the directory site appears",
// "Maximum length of description" => "Maximum length of description",
// "If desc = \"y\", use maxdesc to set the maximum length of the directory site (in characters). Leave blank to set no maximum (show the entire description)" => "If desc = \"y\", use maxdesc to set the maximum length of the directory site (in characters). Leave blank to set no maximum (show the entire description)",
// "Default: blank" => "Default: blank",
"Directory Statistics" => "Könyvtár statisztikák",
// "Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links" => "Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links",
"Top Directory Sites" => "Top könyvtári oldalak",
// "Displays the specified number of the directory sites from most visited to least visited" => "Displays the specified number of the directory sites from most visited to least visited",
// "Displays the site's first featured links" => "Displays the site's first featured links",
// "Displays links to file galleries" => "Displays links to file galleries",
"Top-Rated Topics" => "Legjobbra értékelt témák",
// "Displays the specified number of the forum topics with the best ratings" => "Displays the specified number of the forum topics with the best ratings",
"Newest Forum Posts" => "Legutóbbi fórum posztok",
// "Displays the latest forum posts" => "Displays the latest forum posts",
"Topics only" => "Csak témák",
// "If set to \"y\", only displays topics" => "If set to \"y\", only displays topics",
// "List of forum identifiers" => "List of forum identifiers",
// "If set to a list of forum identifiers, restricts the posts to those in the identified forums. Identifiers are separated by colons (\":\")" => "If set to a list of forum identifiers, restricts the posts to those in the identified forums. Identifiers are separated by colons (\":\")",
// "Show date" => "Show date",
// "If set to \"y\", show post date directly instead of as tooltip" => "If set to \"y\", show post date directly instead of as tooltip",
// "Show time" => "Show time",
// "Show times after dates" => "Show times after dates",
"Show author" => "Szerző megjelenítése",
// "If set to \"y\", show post author directly instead of as tooltip" => "If set to \"y\", show post author directly instead of as tooltip",
"Most Commented Forums" => "Legtöbbet kommentált fórumok",
// "Display the specified number of the forums with the most comments" => "Display the specified number of the forums with the most comments",
// "Top Visited Forum Topics" => "Top Visited Forum Topics",
// "Display the specified number of the forum topics with the most reads" => "Display the specified number of the forum topics with the most reads",
// "Top Visited Forums" => "Top Visited Forums",
// "Display the specified number of the forums with the most visits" => "Display the specified number of the forums with the most visits",
"Tags Editor" => "Címkék szerkesztése",
// "Shows current freetags and enables to add and remove some if permissions allow" => "Shows current freetags and enables to add and remove some if permissions allow",
"Wiki Page Tags" => "Wiki címkék",
// "Displays current freetags on wiki pages and enables to add tags if permissions allow" => "Displays current freetags on wiki pages and enables to add tags if permissions allow",
"Similar-Tag Items" => "Hasonló tartalom (címkék)",
// "Shows content with multiple freetags in common" => "Shows content with multiple freetags in common",
// "Type of objects to extract" => "Type of objects to extract",
// "Similar pages" => "Similar pages",
"Most Popular Tags" => "Legnépszerűbb címkék",
// "Shows the most popular freetags. More popularity is indicated by a larger font" => "Shows the most popular freetags. More popularity is indicated by a larger font",
// "Display type" => "Display type",
// "If set to \"cloud\", links are displayed as a cloud" => "If set to \"cloud\", links are displayed as a cloud",
// "Default: \"list\"" => "Default: \"list\"",
// "Maximum elements" => "Maximum elements",
// "If set to a number, limits the number of tags displayed" => "If set to a number, limits the number of tags displayed",
"My Preferred Tags" => "Felhasználó által preferált címkék",
// "Displays to registered users the freetags they prefer, based on the number of objects they added the tag to. More preference is indicated by a larger font" => "Displays to registered users the freetags they prefer, based on the number of objects they added the tag to. More preference is indicated by a larger font",
// "My preferred tags" => "My preferred tags",
"Google Search" => "Google keresés",
// "Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site" => "Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site",
"Groups Emulation" => "Csoportok emulációja",
// "Enables temporarily changing one's group memberships to see how users in fewer groups experience the site" => "Enables temporarily changing one's group memberships to see how users in fewer groups experience the site",
"Emulate Groups" => "Csomortok szimulálása",
"Last Actions" => "Legutóbbi akciók",
// "Displays the specified number of last actions" => "Displays the specified number of last actions",
// "Show user" => "Show user",
// "If set to \"y\", user names are displayed in the module box" => "If set to \"y\", user names are displayed in the module box",
// "If set to \"y\", action dates are displayed in the module box" => "If set to \"y\", action dates are displayed in the module box",
// "Maximum number of characters in action descriptions before truncating" => "Maximum number of characters in action descriptions before truncating",
"Newest Blog Posts" => "Legutóbbi blogposztok",
// "Lists the specified number of blogs posts from newest to oldest" => "Lists the specified number of blogs posts from newest to oldest",
// "If set to \"y\", the date of posts is not displayed in the module box" => "If set to \"y\", the date of posts is not displayed in the module box",
// "Blog identifier" => "Blog identifier",
// "If set to a blog identifier, restricts the blog posts to those in the identified blog" => "If set to a blog identifier, restricts the blog posts to those in the identified blog",
"Newest Category Items" => "Legutóbbi kategorizált objektumok",
// "Lists the specified number of objects of the given type in the given category, starting from the most recently created" => "Lists the specified number of objects of the given type in the given category, starting from the most recently created",
// "Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed" => "Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed",
// "Maximum number of characters in object names allowed before truncating" => "Maximum number of characters in object names allowed before truncating",
// "Type of the objects to list. Example values" => "Type of the objects to list. Example values",
// "no object here yet" => "no object here yet",
"Newest Blogs" => "Legutóbb létrehozott blogok",
// "Displays the specified number of blogs from newest to oldest" => "Displays the specified number of blogs from newest to oldest",
"Newest FAQs" => "Legutóbbi Gyakori kérdések",
// "Displays the specified number of FAQs from newest to oldest" => "Displays the specified number of FAQs from newest to oldest",
"Newest Quizzes" => "Legutóbb készült kvízek",
// "Displays the specified number of quizzes from newest to oldest" => "Displays the specified number of quizzes from newest to oldest",
// "Last-Modified File Galleries" => "Last-Modified File Galleries",
// "Display the specified number of file galleries, starting from the most recently modified" => "Display the specified number of file galleries, starting from the most recently modified",
"Newest Files" => "Legutóbbi fájlok",
// "List the specified number of files, starting from the most recently added" => "List the specified number of files, starting from the most recently added",
// "Gallery identifiers" => "Gallery identifiers",
// "If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers" => "If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers",
// "Example value: 13, 2:13, 1:2:3:5:6" => "Example value: 13, 2:13, 1:2:3:5:6",
// "Last-Modified Image Galleries" => "Last-Modified Image Galleries",
// "Displays the specified number of image galleries, starting from the most recently modified" => "Displays the specified number of image galleries, starting from the most recently modified",
"Newest Images" => "Legutóbbi képek",
// "List the specified number of images, starting from the most recently added" => "List the specified number of images, starting from the most recently added",
// "Gallery identifier" => "Gallery identifier",
// "If set to an image gallery identifier, restricts the images to those in the identified gallery" => "If set to an image gallery identifier, restricts the images to those in the identified gallery",
// "Link content" => "Link content",
// "Display the links as image names or thumbnails" => "Display the links as image names or thumbnails",
// "Possible values: \"names\" or \"thumbnails\". Default value: \"names\"" => "Possible values: \"names\" or \"thumbnails\". Default value: \"names\"",
// "Last-Modified Events" => "Last-Modified Events",
// "Display the specified number of calendar events, starting from the most recently modified" => "Display the specified number of calendar events, starting from the most recently modified",
// "Calendar Identifier" => "Calendar Identifier",
// "If set to a calendar identifier, restricts the events to those in the identified calendar" => "If set to a calendar identifier, restricts the events to those in the identified calendar",
// "Maximum number of characters in event names allowed before truncating" => "Maximum number of characters in event names allowed before truncating",
// "Hide Date" => "Hide Date",
// "If set to \"y\", it will hide date" => "If set to \"y\", it will hide date",
// "List the specified number of pages, starting from the most recently modified" => "List the specified number of pages, starting from the most recently modified",
// "Link Target" => "Link Target",
// "Target URL of the \"...more\" link at the bottom of the module" => "Target URL of the \"...more\" link at the bottom of the module",
"Last-Modified Blogs" => "Legutóbb módosított blogok",
// "Displays the specified number of blogs, starting from the most recently modified" => "Displays the specified number of blogs, starting from the most recently modified",
"Newest Podcasts" => "Legutóbbi Podcast-ok",
// "Displays Podcasts" => "Displays Podcasts",
// "File galleries IDs" => "File galleries IDs",
// "List of IDs of file galleries of type \"Podcast (Audio)\". Identifiers are separated by a colon (\":\"). If none, all file galleries will be scanned" => "List of IDs of file galleries of type \"Podcast (Audio)\". Identifiers are separated by a colon (\":\"). If none, all file galleries will be scanned",
"width" => "szélesség",
// "Width of mediaplayer in pixels" => "Width of mediaplayer in pixels",
// "height" => "height",
// "Height of mediaplayer in pixels" => "Height of mediaplayer in pixels",
// "Path to mp3 player. For instance media/player_mp3_maxi.swf if you downloaded player_mp3_maxi.swf from http://flash-mp3-player.net/players/maxi/download/ to directory media/ (directory needs to be created or you can chose another place)" => "Path to mp3 player. For instance media/player_mp3_maxi.swf if you downloaded player_mp3_maxi.swf from http://flash-mp3-player.net/players/maxi/download/ to directory media/ (directory needs to be created or you can chose another place)",
// "Bottom Link URL" => "Bottom Link URL",
// "URL for a link at bottom of module" => "URL for a link at bottom of module",
// "Bottom Link URL Text" => "Bottom Link URL Text",
// "Text for link if Bottom Link URL is set" => "Text for link if Bottom Link URL is set",
// "More Podcasts" => "More Podcasts",
// "Verbose" => "Verbose",
// "Display description of podcast below player if \"y\", and on title mouseover if \"n\"" => "Display description of podcast below player if \"y\", and on title mouseover if \"n\"",
"Newest Article Submissions" => "Legutóbbi hozzászólások",
// "Lists the specified number of article submissions from newest to oldest" => "Lists the specified number of article submissions from newest to oldest",
"Newest Tracker Comments" => "Legutóbbi űrlap kommentek",
// "Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted" => "Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted",
// "Tracker identifier" => "Tracker identifier",
// "If set to a tracker identifier, only displays the comments on the given tracker" => "If set to a tracker identifier, only displays the comments on the given tracker",
// "Item identifier" => "Item identifier",
// "If set to an item identifier, only displays the comments on the given item" => "If set to an item identifier, only displays the comments on the given item",
"Newest Tracker Items" => "Legutóbbi űrlaptételek",
// "Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required" => "Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required",
// "Identifier of the tracker from which items are listed" => "Identifier of the tracker from which items are listed",
// "Field identifier" => "Field identifier",
// "Identifier of the field from which values are listed. If Field name is set, this parameter is ignored" => "Identifier of the field from which values are listed. If Field name is set, this parameter is ignored",
// "Field name" => "Field name",
// "Name of the field from which values are listed" => "Name of the field from which values are listed",
// "Example value: age" => "Example value: age",
// "Specifies how the items should be sorted" => "Specifies how the items should be sorted",
// "Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date" => "Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date",
// "Status filter" => "Status filter",
// "If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values" => "If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values",
// "Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set" => "Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set",
// "You do not have permission to view this tracker" => "You do not have permission to view this tracker",
"Last Items" => "Legutóbbi elemek",
"Last Modified Items" => "Legutóbbi módosított elemek",
"Newest Validated FAQ Questions" => "Legutóbb validált Gyakori Kérdések",
// "Displays the specified number of validated questions FAQs from newest to oldest" => "Displays the specified number of validated questions FAQs from newest to oldest",
// "Faq identifier" => "Faq identifier",
// "If set to a faq identifier, restricts the chosen questions to those in the identified faq" => "If set to a faq identifier, restricts the chosen questions to those in the identified faq",
"Last Visitors" => "Legutóbbi látogatók",
// "Displays information about the specified number of users in decreasing order of last login time" => "Displays information about the specified number of users in decreasing order of last login time",
// "Show avatars" => "Show avatars",
// "If set to \"y\", show user avatars" => "If set to \"y\", show user avatars",
// "Maximum number of characters in user names allowed before truncating" => "Maximum number of characters in user names allowed before truncating",
// "Don't show date" => "Don't show date",
// "YouTube Playlist" => "YouTube Playlist",
// "Display a YouTube playlist" => "Display a YouTube playlist",
// "Playlist ID" => "Playlist ID",
// "ID of the YouTube playlist to display (not the complete URL). Example: id=4DE69387D46DA2F6" => "ID of the YouTube playlist to display (not the complete URL). Example: id=4DE69387D46DA2F6",
// "Width of each video in pixels" => "Width of each video in pixels",
// "Height of each video in pixels" => "Height of each video in pixels",
// "Allow FullScreen" => "Allow FullScreen",
// "Bottom Link" => "Bottom Link",
// "Url for a link at bottom of module. Example: link_url=http://www.youtube.com/CouncilofEurope#grid/user/E57D0D93BA3A56C8" => "Url for a link at bottom of module. Example: link_url=http://www.youtube.com/CouncilofEurope#grid/user/E57D0D93BA3A56C8",
// "Bottom Link Text" => "Bottom Link Text",
// "Text for link if link_url is set, otherwise 'More Videos'" => "Text for link if link_url is set, otherwise 'More Videos'",
// "Video Descriptions" => "Video Descriptions",
// "Display description of video on title mouseover if 'y'. Default is 'y'" => "Display description of video on title mouseover if 'y'. Default is 'y'",
// "Order by" => "Order by",
// "Criteria to order by the videos in the list. Default is 'position'" => "Criteria to order by the videos in the list. Default is 'position'",
// "position" => "position",
// "commentCount" => "commentCount",
"duration" => "időtartam",
// "published" => "published",
// "reversedPosition" => "reversedPosition",
// "title" => "title",
// "viewCount" => "viewCount",
// "No Playlist found" => "No Playlist found",
// "No Playlist ID was provided" => "No Playlist ID was provided",
"Live Support" => "Élő támogatás",
// "Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console" => "Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console",
// "Server Load" => "Server Load",
// "Report of server resources used" => "Report of server resources used",
// "Presents a map with the geolocated content within the page" => "Presents a map with the geolocated content within the page",
// "Log-in box" => "Log-in box",
// "Input size" => "Input size",
// "Number of characters for username and password input fields" => "Number of characters for username and password input fields",
// "Display mode: module, header or popup. Leave empty for module mode" => "Display mode: module, header or popup. Leave empty for module mode",
// "Show Register" => "Show Register",
// "Show the register link" => "Show the register link",
// "Show I Forgot" => "Show I Forgot",
// "Show the \"I forgot my password\" link" => "Show the \"I forgot my password\" link",
// "Show Remember me" => "Show Remember me",
// "Show the \"Remember me\" checkbox" => "Show the \"Remember me\" checkbox",
"Logo" => "Logó",
// "Site logo, title and subtitle" => "Site logo, title and subtitle",
// "Map Feature Editor" => "Map Feature Editor",
// "Allows to draw shapes over the map" => "Allows to draw shapes over the map",
// "Tracker to store the feature in" => "Tracker to store the feature in",
// "Hidden Input" => "Hidden Input",
// "Hidden values to be sent over to the dialog. fieldName(value)" => "Hidden values to be sent over to the dialog. fieldName(value)",
// "Standard controls" => "Standard controls",
// "Dispay the standard draw controls" => "Dispay the standard draw controls",
// "Layer Selector" => "Layer Selector",
// "Replace the map's built-in layer controls" => "Replace the map's built-in layer controls",
// "Mode Selector" => "Mode Selector",
// "Toggle input modes for the map" => "Toggle input modes for the map",
// "Map location search" => "Map location search",
// "Simple search controls for the map" => "Simple search controls for the map",
"Menu" => "Menü",
// "Displays a menu or a structure as a menu" => "Displays a menu or a structure as a menu",
// "Identifier of a menu (from tiki-admin_menus.php)" => "Identifier of a menu (from tiki-admin_menus.php)",
"Structure" => "Struktúra",
// "Identifier of a structure of wiki pages (name or number from tiki-admin_structures.php)" => "Identifier of a structure of wiki pages (name or number from tiki-admin_structures.php)",
// "Direction for menu: horiz or vert (default vert)" => "Direction for menu: horiz or vert (default vert)",
// "CSS/Superfish" => "CSS/Superfish",
// "Use CSS Superfish menu. y|n (default y)" => "Use CSS Superfish menu. y|n (default y)",
// "DOM #id" => "DOM #id",
// "Id of the menu in the DOM" => "Id of the menu in the DOM",
// "CSS class" => "CSS class",
// "Class of the menu container" => "Class of the menu container",
// "Limit low visibles levels" => "Limit low visibles levels",
// "All the submenus beginning at this level will be displayed if the url matches one of the option of this level or above or below" => "All the submenus beginning at this level will be displayed if the url matches one of the option of this level or above or below",
// "Limit top visible levels" => "Limit top visible levels",
// "Do not display options higher than this level" => "Do not display options higher than this level",
// "Link on Section" => "Link on Section",
// "Create links on menu sections" => "Create links on menu sections",
// "(y/n default y)" => "(y/n default y)",
// "Translate labels" => "Translate labels",
// "Menu Cookie" => "Menu Cookie",
// "Open the menu to show current option if possible" => "Open the menu to show current option if possible",
// "One of these parameters has to be set" => "One of these parameters has to be set",
"Menu Page" => "Menü oldal",
// "Displays a Wiki page" => "Displays a Wiki page",
// "Page to display in the menu. Example value: HomePage" => "Page to display in the menu. Example value: HomePage",
// "Wiki Structure Menu" => "Wiki Structure Menu",
// "Displays a structure" => "Displays a structure",
// "N.B. Deprecated, use the Menu module instead" => "N.B. Deprecated, use the Menu module instead",
// "Structure to display in the menu" => "Structure to display in the menu",
// "Unread Inter-User Messages" => "Unread Inter-User Messages",
// "Displays to users their number of new inter-user messages and a link to their message box" => "Displays to users their number of new inter-user messages and a link to their message box",
// "Show If Empty" => "Show If Empty",
// "Show the module when there are no messages waiting. y|n " => "Show the module when there are no messages waiting. y|n ",
// "Default=y" => "Default=y",
"Messages" => "Üzenetek",
// "Small live chat box" => "Small live chat box",
// "Channels" => "Channels",
// "List of chat channels. Channel names are separated by a comma (\",\")" => "List of chat channels. Channel names are separated by a comma (\",\")",
// "By default, a single channel named \"default\" exists" => "By default, a single channel named \"default\" exists",
"Mobile" => "Mobil",
// "Currently only shows switch to and from mobile mode" => "Currently only shows switch to and from mobile mode",
// "To Label" => "To Label",
// "Switch to normal site label" => "Switch to normal site label",
// "From Label" => "From Label",
// "Switch to mobile site label" => "Switch to mobile site label",
// "Switch Perspective" => "Switch Perspective",
// "Also switch perspective back to this one when leaving mobile mode" => "Also switch perspective back to this one when leaving mobile mode",
// "Stay" => "Stay",
// "Stay on same page" => "Stay on same page",
// "Switch to mobile site" => "Switch to mobile site",
// "Switch to normal site" => "Switch to normal site",
"Months Links" => "Havi linkek",
// "Link to articles or blog posts for the current month and those preceding it" => "Link to articles or blog posts for the current month and those preceding it",
// "Type of objects to link to" => "Type of objects to link to",
// "\"blogs\" for blog posts, \"cms\" for published articles" => "\"blogs\" for blog posts, \"cms\" for published articles",
// "Object Identifier" => "Object Identifier",
// "Identifier of an object with children to link to" => "Identifier of an object with children to link to",
// "This is required for the blog Object type" => "This is required for the blog Object type",
// "For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3" => "For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3",
// "List by month" => "List by month",
"Most Commented" => "Legtöbbet kommentált",
// "Display the most commented objects of a certain type" => "Display the most commented objects of a certain type",
// "Type of objects to consider" => "Type of objects to consider",
// "Possible values: wiki (Wiki pages), blog (blog posts), article (articles)" => "Possible values: wiki (Wiki pages), blog (blog posts), article (articles)",
// "Language Filter" => "Language Filter",
// "If set to a RFC1766 language tag, restricts the objects considered to those in the specified language" => "If set to a RFC1766 language tag, restricts the objects considered to those in the specified language",
"Pending Article Submissions" => "Várakozó beküldések",
// "Displays the number of article submissions waiting examination and a link to the list" => "Displays the number of article submissions waiting examination and a link to the list",
"Old Articles" => "Régi cikkek",
// "Displays the specified number of old articles (which do not show on articles home page anymore)" => "Displays the specified number of old articles (which do not show on articles home page anymore)",
// "Payments Outstanding" => "Payments Outstanding",
// "Displays the payments outstanding for the current user" => "Displays the payments outstanding for the current user",
// "Enables to change current perspective" => "Enables to change current perspective",
// "Powered By" => "Powered By",
// "Powered by Tiki, and others" => "Powered by Tiki, and others",
// "Shows \"Powered by Tiki Wiki CMS Groupware\" message" => "Shows \"Powered by Tiki Wiki CMS Groupware\" message",
// "Tiki version info" => "Tiki version info",
// "Credits" => "Credits",
// "Shows theme credits (contents of credits.tpl)" => "Shows theme credits (contents of credits.tpl)",
// "Icons" => "Icons",
// "Shows various \"powered by\" icons" => "Shows various \"powered by\" icons",
"Quick Edit" => "Gyors szerkesztés",
// "Enables to quickly create or edit Wiki pages" => "Enables to quickly create or edit Wiki pages",
// "Deprecated - use the Search module instead" => "Deprecated - use the Search module instead",
// "Template identifier" => "Template identifier",
// "If set to a template identifier, the specified template is used for creating new Wiki pages" => "If set to a template identifier, the specified template is used for creating new Wiki pages",
// "If set, send the form to the given location (relative to Tiki's root) for processing" => "If set, send the form to the given location (relative to Tiki's root) for processing",
// "SUBMIT label" => "SUBMIT label",
// "The label on the button to submit the form" => "The label on the button to submit the form",
"Create/Edit" => "Létrehozás/szerkesztés",
// "INPUT SIZE" => "INPUT SIZE",
// "Size attribute (horizontal, in characters) of the text input field for page names" => "Size attribute (horizontal, in characters) of the text input field for page names",
// "Optional heading to display at the top of the module's content" => "Optional heading to display at the top of the module's content",
// "Category to preselect" => "Category to preselect",
// "If set, pages created through the module have this category prechecked to be categorized in" => "If set, pages created through the module have this category prechecked to be categorized in",
// "Tip to be shown" => "Tip to be shown",
// "Custom text to be shown as a tip at the top of the edit page" => "Custom text to be shown as a tip at the top of the edit page",
// "Title of tip to be shown" => "Title of tip to be shown",
// "Custom title to be shown for the tip at the top of the edit page" => "Custom title to be shown for the tip at the top of the edit page",
// "Custom header template" => "Custom header template",
// "Wiki page to be used as a template to show content on top of edit page" => "Wiki page to be used as a template to show content on top of edit page",
"Quick Edit a Wiki Page" => "Wiki oldal szerkesztése",
// "Quick Search" => "Quick Search",
// "Performs a search query and persists the results in the module for quick navigation access" => "Performs a search query and persists the results in the module for quick navigation access",
// "Filter object type" => "Filter object type",
// "Limit search results to a specific object type. Enter an object type to use a static filter or write \"selector\" to provide an input" => "Limit search results to a specific object type. Enter an object type to use a static filter or write \"selector\" to provide an input",
// "Filter category" => "Filter category",
// "Limit search results to a specific category. Enter the comma separated list of category IDs to include in the selector. Single category will display no controls" => "Limit search results to a specific category. Enter the comma separated list of category IDs to include in the selector. Single category will display no controls",
"Quick Admin" => "Adminisztráció",
// "Some helpful tools for admins" => "Some helpful tools for admins",
// "Display mode: module or header. Leave empty for module mode" => "Display mode: module or header. Leave empty for module mode",
"Random Image" => "Véletlenszerű kép",
// "Displays a random image" => "Displays a random image",
// "If set to an image gallery identifier, restricts the chosen images to those in the identified gallery" => "If set to an image gallery identifier, restricts the chosen images to those in the identified gallery",
// "Show link" => "Show link",
// "If set to \"n\", the image thumbnail does not link to the image" => "If set to \"n\", the image thumbnail does not link to the image",
// "Default: \"y\"" => "Default: \"y\"",
// "Show name" => "Show name",
// "If set to \"y\", the name of the image is displayed" => "If set to \"y\", the name of the image is displayed",
// "If set to \"y\", the description of the image is displayed" => "If set to \"y\", the description of the image is displayed",
"Random Pages" => "Véletlenszerű lapok",
// "Displays the specified number of random wiki pages" => "Displays the specified number of random wiki pages",
// "New User Registration" => "New User Registration",
// "Permit anonymous visitors to create an account on the site" => "Permit anonymous visitors to create an account on the site",
"News Feeds" => "Feed-ek listája",
// "List of feeds available on this site" => "List of feeds available on this site",
// "Multi-purpose search module (go or edit page by name and/or search site)" => "Multi-purpose search module (go or edit page by name and/or search site)",
// "Legacy Mode" => "Legacy Mode",
// "Setting to emulate previous behaviour" => "Setting to emulate previous behaviour",
// "If set to \"y\" the search performed is a \"Tiki search\"" => "If set to \"y\" the search performed is a \"Tiki search\"",
// " (full text search)" => " (full text search)",
// "Show Object Type Filter" => "Show Object Type Filter",
// "If set to \"y\" shows a dropdown of sections to search" => "If set to \"y\" shows a dropdown of sections to search",
// " (no object filter)" => " (no object filter)",
// "Use autocomplete" => "Use autocomplete",
// "If set to \"y\" input uses autocomplete for pagenames if applicable" => "If set to \"y\" input uses autocomplete for pagenames if applicable",
// " (use autocomplete)" => " (use autocomplete)",
"Advanced search" => "Részletes keresés",
// "Use advanced (boolean) search (full text search only)" => "Use advanced (boolean) search (full text search only)",
// " (use advanced search)" => " (use advanced search)",
// "Advanced search checkbox" => "Advanced search checkbox",
// "Show advanced search checkbox (full text search only)" => "Show advanced search checkbox (full text search only)",
// " (advanced search checkbox off)" => " (advanced search checkbox off)",
// "Advanced search help" => "Advanced search help",
// "Show advanced search help icon (full text search only)" => "Show advanced search help icon (full text search only)",
// " (advanced search help off)" => " (advanced search help off)",
// "Show Search Button" => "Show Search Button",
// "Show search button" => "Show search button",
// " (do show search button)" => " (do show search button)",
// "Show Go Button" => "Show Go Button",
// "Show go to page button" => "Show go to page button",
// " (do show go button)" => " (do show go button)",
// "Show Edit Button" => "Show Edit Button",
// "Show edit button" => "Show edit button",
// " (do show edit button)" => " (do show edit button)",
// "Default Button" => "Default Button",
// "Action to perform on entering <return>" => "Action to perform on entering <return>",
// " (search|go|edit)" => " (search|go|edit)",
// "Search Form Action" => "Search Form Action",
// " tiki-searchresults.php or tiki-searchindex.php (for Tiki search)" => " tiki-searchresults.php or tiki-searchindex.php (for Tiki search)",
// "Edit Submit Label" => "Edit Submit Label",
// "Go Form Action" => "Go Form Action",
"Go" => "Indítás",
// "Edit Form Action" => "Edit Form Action",
// "Input field width" => "Input field width",
// "Width of the text input field (in characters)" => "Width of the text input field (in characters)",
// " 0 (leave automatic width)" => " 0 (leave automatic width)",
// "Select size" => "Select size",
// "Size of the Search Filter dropdown list" => "Size of the Search Filter dropdown list",
// "Edit Template identifier" => "Edit Template identifier",
// "If set to a category identifier, pages created through the module are automatically categorized in the specified category" => "If set to a category identifier, pages created through the module are automatically categorized in the specified category",
// "Compact mode" => "Compact mode",
// "Makes the three buttons only appear on mouse-over" => "Makes the three buttons only appear on mouse-over",
"Search is disabled" => "Keresés ki van kapcsolva",
"Titles" => "Oldalnév",
"Search for Wiki Page" => "Wiki oldal keresése",
// "Search Box" => "Search Box",
// "Small search form for wiki, articles, blogs, etc" => "Small search form for wiki, articles, blogs, etc",
// "If set to \"y\", the search performed is a \"Tiki search\". Default: \"n\" (full text search)" => "If set to \"y\", the search performed is a \"Tiki search\". Default: \"n\" (full text search)",
// "Search For a Wiki Page" => "Search For a Wiki Page",
// "Search for a wiki page by name" => "Search for a wiki page by name",
// "Exact match checkbox checked by default if set to \"y\"" => "Exact match checkbox checked by default if set to \"y\"",
// "Semantic Links" => "Semantic Links",
// "List the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from" => "List the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from",
// "Links for sharing, reporting etc" => "Links for sharing, reporting etc",
// "Report to Webmaster" => "Report to Webmaster",
"Share this page" => "Oldal megosztása",
// "Use icons for report, share and email links" => "Use icons for report, share and email links",
// "Facebook" => "Facebook",
// "Show Facebook \"Like\" button on the current page" => "Show Facebook \"Like\" button on the current page",
// "Facebook: URL" => "Facebook: URL",
// "URL to \"Like\" (leave blank for current URL)" => "URL to \"Like\" (leave blank for current URL)",
// "Facebook: Send" => "Facebook: Send",
// "Show Facebook \"Send\" button" => "Show Facebook \"Send\" button",
// "Facebook: Layout" => "Facebook: Layout",
// "Size, layout and amount of social context" => "Size, layout and amount of social context",
// "Facebook: Width" => "Facebook: Width",
// "Facebook: Height" => "Facebook: Height",
// "Container height in CSS units (e.g. \"120px\" or \"2em\")" => "Container height in CSS units (e.g. \"120px\" or \"2em\")",
// "Facebook: Show Faces" => "Facebook: Show Faces",
// "Show pictures of others who like this" => "Show pictures of others who like this",
// "Facebook: Verb" => "Facebook: Verb",
// "Verb to display in button" => "Verb to display in button",
// "Facebook: Colors" => "Facebook: Colors",
// "Color scheme" => "Color scheme",
// "Facebook: Font" => "Facebook: Font",
// "Font to display" => "Font to display",
// "Facebook: Locale" => "Facebook: Locale",
// "Locale in the format ll_CC (default \"en_US\")" => "Locale in the format ll_CC (default \"en_US\")",
// "Facebook: Referrals" => "Facebook: Referrals",
// "Label for tracking referrals (optional)" => "Label for tracking referrals (optional)",
// "Facebook: App Id" => "Facebook: App Id",
// "ID of your Facebook app (optional)" => "ID of your Facebook app (optional)",
// "Show Twitter Follow Button on the current page" => "Show Twitter Follow Button on the current page",
// "Twitter: User Name" => "Twitter: User Name",
// "Twitter user name to quote as \"via\"" => "Twitter user name to quote as \"via\"",
// "Twitter: Label" => "Twitter: Label",
// "Text to display. Default \"Tweet\"" => "Text to display. Default \"Tweet\"",
// "Twitter: URL" => "Twitter: URL",
// "URL to \"Tweet\" (leave blank for current URL)" => "URL to \"Tweet\" (leave blank for current URL)",
// "Twitter: Show Count" => "Twitter: Show Count",
// "Position of Tweet count" => "Position of Tweet count",
// "Twitter: Language" => "Twitter: Language",
// "Two letter language code" => "Two letter language code",
// "Twitter: Width" => "Twitter: Width",
// "Width in pixels or percentage (e.g. 300px)" => "Width in pixels or percentage (e.g. 300px)",
// "Twitter: Height" => "Twitter: Height",
// "Twitter: Text" => "Twitter: Text",
// "Tweet text (leave empty to use page title" => "Tweet text (leave empty to use page title",
// "LinkedIn" => "LinkedIn",
// "Linked in share button" => "Linked in share button",
// "LinkedIn: URL" => "LinkedIn: URL",
// "URL to share (leave blank for current URL)" => "URL to share (leave blank for current URL)",
// "LinkedIn: Count Mode" => "LinkedIn: Count Mode",
// "Position of count" => "Position of count",
// "Google +1" => "Google +1",
// "Google +1 button" => "Google +1 button",
// "Google: Size" => "Google: Size",
// "Google button size" => "Google button size",
// "Google: Annotation" => "Google: Annotation",
// "Google annotation" => "Google annotation",
// "Google: Language" => "Google: Language",
// "Google language" => "Google language",
// "Google: URL" => "Google: URL",
// "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows to send messages" => "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows to send messages",
// "If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content" => "If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content",
// "Label on the button to post a message" => "Label on the button to post a message",
// "Wait label" => "Wait label",
// "Label on the button to post a message when the message is being posted if AJAX is enabled" => "Label on the button to post a message when the message is being posted if AJAX is enabled",
// "Please wait.." => "Please wait..",
// "Maximum messages shown" => "Maximum messages shown",
// "Number of messages to display" => "Number of messages to display",
// "Tweet" => "Tweet",
// "If set to \"1\" and the user has authorized us to tweet messages with Twitter, the user can decide, if he wants to shout via Twitter" => "If set to \"1\" and the user has authorized us to tweet messages with Twitter, the user can decide, if he wants to shout via Twitter",
// "If set to \"1\" and the user has authorized us with Facebook, the user can decide, if he wants to add the shout to his Facebook wall" => "If set to \"1\" and the user has authorized us with Facebook, the user can decide, if he wants to add the shout to his Facebook wall",
"Since Last Visit (Simple)" => "Legutóbbi látogatás óta (egyszerű)",
// "Displays to logged in users the number of new or updated objects since their last login date and time" => "Displays to logged in users the number of new or updated objects since their last login date and time",
"Since your last visit" => "Utolsó látogatás óta",
"Since Last Visit" => "Legutóbbi látogatás óta",
// "Displays to logged in users new or updated objects since a point in time, by default their last login date and time" => "Displays to logged in users new or updated objects since a point in time, by default their last login date and time",
// "Show users" => "Show users",
// "If set to \"n\", do not show new users" => "If set to \"n\", do not show new users",
// "Show trackers" => "Show trackers",
// "If set to \"n\", do not show tracker changes" => "If set to \"n\", do not show tracker changes",
// "Calendar focus" => "Calendar focus",
// "Unless set to \"ignore\", the module changes the reference point in time from the user's last login date and time to a day where users browse to using the calendar" => "Unless set to \"ignore\", the module changes the reference point in time from the user's last login date and time to a day where users browse to using the calendar",
// "Show date as a calendar link" => "Show date as a calendar link",
// "If set to \"n\", do not add a link to tiki calendar on the date in the header (even if feature calendar is set)" => "If set to \"n\", do not add a link to tiki calendar on the date in the header (even if feature calendar is set)",
// "Fold sections by default" => "Fold sections by default",
// "If set to \"y\", fold automatically sections and show only the title (user has to click on each section in order to see the details of modifications)" => "If set to \"y\", fold automatically sections and show only the title (user has to click on each section in order to see the details of modifications)",
// "Use jQuery presentation" => "Use jQuery presentation",
// "If set to \"y\", use jQuery to show the result" => "If set to \"y\", use jQuery to show the result",
// "Minimum timespan" => "Minimum timespan",
// "Instead of the last login time, go back this minimum time, specified in days, in case the last login time is more recent" => "Instead of the last login time, go back this minimum time, specified in days, in case the last login time is more recent",
"Changes since" => "Változások",
"Since your last visit..." => "Legutóbbi látogatás óta",
// "In the last %0 days.." => "In the last %0 days..",
"new comments" => "új komment",
// " (archived)" => " (archived)",
"new posts" => "új poszt",
"wiki pages changed" => "módosított wiki lap",
"new articles" => "új cikk",
"new FAQs" => "új GYIK",
"new blogs" => "új blog",
"new blog posts" => "új blogposzt",
"new image galleries" => "új képgaléris",
"new images" => "új kép",
"new file galleries" => "új fájlgaléria",
"new files" => "új fájl",
"new polls" => "új szavazás",
"new users" => "új felhasználó",
"new tracker items" => "új űrlaptétel",
"updated tracker items" => "frissített űrlap tétel",
// "SVN Up Info" => "SVN Up Info",
// "SVN Version and last update information" => "SVN Version and last update information",
"Switch Language" => "Nyelv váltása",
// "Displays a language picker to change the language of the site" => "Displays a language picker to change the language of the site",
// "Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist" => "Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist",
"Switch Theme" => "Téma váltása",
// "Enables to quickly change the theme" => "Enables to quickly change the theme",
"Terminology" => "Terminológia",
// "Support for multilingual terminology" => "Support for multilingual terminology",
// "Root category" => "Root category",
// "All terms will automatically be put in that category. " => "All terms will automatically be put in that category. ",
// "Note that the category must already exist. " => "Note that the category must already exist. ",
// "Defaults to 'Term'" => "Defaults to 'Term'",
"Tiki Tests" => "Tiki tesztek",
// "Tiki test suite helper" => "Tiki test suite helper",
"Most Active blogs" => "Legaktívabb blogok",
// "Displays the specified number of blogs with links to them, from the most active one to the least" => "Displays the specified number of blogs with links to them, from the most active one to the least",
// "Blog activity measurement can be more or less accurate" => "Blog activity measurement can be more or less accurate",
// "Lists the specified number of articles with links to them, from the most visited one to the least" => "Lists the specified number of articles with links to them, from the most visited one to the least",
"Top File Galleries" => "Top fájlgalériák",
// "Displays the specified number of file galleries with links to them, starting with the one with most hits" => "Displays the specified number of file galleries with links to them, starting with the one with most hits",
// "Top Files" => "Top Files",
// "Displays the specified number of files with links to them, starting with the one with most hits" => "Displays the specified number of files with links to them, starting with the one with most hits",
"Top Forum Posters" => "Top fórum posztolók",
// "Displays the specified number of users who posted to forums, starting with the one having most posts" => "Displays the specified number of users who posted to forums, starting with the one having most posts",
// "Top Image Galleries" => "Top Image Galleries",
// "Displays the specified number of image galleries with links to them, starting with the one with most hits" => "Displays the specified number of image galleries with links to them, starting with the one with most hits",
"Top Images" => "Top képek",
// "Displays the specified number of images with links to them, from the most visited one to the least" => "Displays the specified number of images with links to them, from the most visited one to the least",
"Top Objects" => "Top objektumok",
// "Displays the specified number of objects, starting with the one having the most hits" => "Displays the specified number of objects, starting with the one having the most hits",
"Top Pages" => "Top lapok",
// "Displays the specified number of wiki pages with links to them, starting with the one having the most hits" => "Displays the specified number of wiki pages with links to them, starting with the one having the most hits",
"Top Quizzes" => "Top kvízek",
// "Displays the specified number of quizzes with links to them, starting with the one having the most hits" => "Displays the specified number of quizzes with links to them, starting with the one having the most hits",
"Top Visited Blogs" => "Legtöbbet látogatott blogok",
// "Display the specified number of blogs with links to them, from the most visited one to the least" => "Display the specified number of blogs with links to them, from the most visited one to the least",
// "Show Last Post" => "Show Last Post",
// "Top Visited FAQs" => "Top Visited FAQs",
// "Display the specified number of FAQs with links to them, from the most visited one to the least" => "Display the specified number of FAQs with links to them, from the most visited one to the least",
// "Tracker Input" => "Tracker Input",
// "Allows to open a dialog to create new tracker items" => "Allows to open a dialog to create new tracker items",
// "Tracker ID to render" => "Tracker ID to render",
// "Text Input" => "Text Input",
// "Multiple text fields to display as part of the main form along with the label. Field names map to the permanent names in the tracker field definitions. ex: groupName(Group Name) relatedTask(Task)" => "Multiple text fields to display as part of the main form along with the label. Field names map to the permanent names in the tracker field definitions. ex: groupName(Group Name) relatedTask(Task)",
// "Location Field" => "Location Field",
// "Obtain the coordinates from a nearby map and send them to the location field. In addition to the field name, :marker or :viewport can be used as the suffix. Default is :marker" => "Obtain the coordinates from a nearby map and send them to the location field. In addition to the field name, :marker or :viewport can be used as the suffix. Default is :marker",
// "Capture StreetView" => "Capture StreetView",
// "Include a button on the StreetView interface to create tracker items from the location. Requires upload image from URL and location parameter" => "Include a button on the StreetView interface to create tracker items from the location. Requires upload image from URL and location parameter",
// "Alter the submit button label" => "Alter the submit button label",
// "Operation to perform on success" => "Operation to perform on success",
// "Operation to perform in the following format: operationName(argument). Current operations are redirect with the URL template as the argument. @valueName@ will be replaced by the appropriate value where valueName is itemId, status or a permanent name" => "Operation to perform in the following format: operationName(argument). Current operations are redirect with the URL template as the argument. @valueName@ will be replaced by the appropriate value where valueName is itemId, status or a permanent name",
"Create" => "Létrehozás",
"Tracker Help" => "Űrlap súgó",
// "Display the fields of a tracker (name and identifier)" => "Display the fields of a tracker (name and identifier)",
// "Text field height" => "Text field height",
// "Number of lines" => "Number of lines",
// "Text field width" => "Text field width",
// "Number of characters" => "Number of characters",
"Translate Updates" => "Frissítések lefordítása",
// "Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed" => "Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed",
// "Reference language" => "Reference language",
// "If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed" => "If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed",
// "Show language" => "Show language",
// "If \"y\" the page language will be shown instead of the page name" => "If \"y\" the page language will be shown instead of the page name",
// "Default = \"y\"" => "Default = \"y\"",
// "Lists the specified number of calendar events, ordered by their start date" => "Lists the specified number of calendar events, ordered by their start date",
// "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")" => "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")",
// "Maximum days in the future" => "Maximum days in the future",
// "Maximum distance to event start dates in days (looking forward)" => "Maximum distance to event start dates in days (looking forward)",
// "Maximum days in the past" => "Maximum days in the past",
// "Maximum distance to event end dates in days (looking backward)" => "Maximum distance to event end dates in days (looking backward)",
// "cellpadding" => "cellpadding",
// "If set to an integer, apply this cellpadding to the HTML table generated" => "If set to an integer, apply this cellpadding to the HTML table generated",
// "cellspacing" => "cellspacing",
// "If set to an integer, apply this cellspacing to the HTML table generated" => "If set to an integer, apply this cellspacing to the HTML table generated",
// "If set to \"y\", event descriptions are displayed" => "If set to \"y\", event descriptions are displayed",
// "Show end date and time" => "Show end date and time",
// "If set to \"y\", event end dates and times are displayed, when appropriate" => "If set to \"y\", event end dates and times are displayed, when appropriate",
// "Use custom calendar background colors" => "Use custom calendar background colors",
// "If set to \"y\", events are displayed with their calendar's custom background color (if one is set)" => "If set to \"y\", events are displayed with their calendar's custom background color (if one is set)",
// "Show information in tooltips" => "Show information in tooltips",
// "If set to \"n\", event tooltips will not display event information" => "If set to \"n\", event tooltips will not display event information",
// "Date format" => "Date format",
// "Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>" => "Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>",
// "site preference for short date format followed by site preference for short time format" => "site preference for short date format followed by site preference for short time format",
// "If set to an integer, event names are allowed that number of characters as a maximum before being truncated" => "If set to an integer, event names are allowed that number of characters as a maximum before being truncated",
// "My Blogs" => "My Blogs",
// "Displays to registered users their blogs" => "Displays to registered users their blogs",
// "Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed" => "Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed",
"My Image Galleries" => "Felhasználói képgalériák",
// "Displays to registered users their image galleries" => "Displays to registered users their image galleries",
"User Pages" => "Felhasználói lapok",
// "Displays to registered users the specified number of wiki pages which they were the last to edit" => "Displays to registered users the specified number of wiki pages which they were the last to edit",
"My Pages" => "Oldalaim",
"My Tasks" => "Felhasználói feladatok",
// "Lightweight interface to user tasks, enabling to view them concisely and do some manipulations" => "Lightweight interface to user tasks, enabling to view them concisely and do some manipulations",
// "The task title must have at least 3 characters" => "The task title must have at least 3 characters",
"Public Tasks" => "Nyilvános feladatok",
// "Lists the public user tasks of a chosen group, with links to tasks" => "Lists the public user tasks of a chosen group, with links to tasks",
"User-Group Tracker" => "Felhasználó-Csoport űrlap",
// "User and Group tracker links" => "User and Group tracker links",
// "My Score" => "My Score",
// "Display the logged user's rank and score" => "Display the logged user's rank and score",
"Most Active Users" => "Top felhasználók",
// "Display the specified number of users and their score, starting from the one with the highest score" => "Display the specified number of users and their score, starting from the one with the highest score",
// "Webmail Inbox" => "Webmail Inbox",
// "Displays Webmail Inbox" => "Displays Webmail Inbox",
// "Account Id" => "Account Id",
// "Webmail account identifier (if not set uses user's current account)" => "Webmail account identifier (if not set uses user's current account)",
// "GroupMail: Group (e.g. \"Help Team\")" => "GroupMail: Group (e.g. \"Help Team\")",
// "GroupMail: Tracker Id (to store GroupMail activity)" => "GroupMail: Tracker Id (to store GroupMail activity)",
// "GroupMail: From Field (Id of field in tracker to store email From header)" => "GroupMail: From Field (Id of field in tracker to store email From header)",
// "GroupMail: Subject Field (Id of field in tracker to store email Subject header)" => "GroupMail: Subject Field (Id of field in tracker to store email Subject header)",
// "GroupMail: Message Field (Id of field in tracker to store email message identifier)" => "GroupMail: Message Field (Id of field in tracker to store email message identifier)",
// "GroupMail: Content Field (Id of field in tracker to store email message body content)" => "GroupMail: Content Field (Id of field in tracker to store email message body content)",
// "GroupMail: Account Field (Id of field in tracker to store Webmail account name)" => "GroupMail: Account Field (Id of field in tracker to store Webmail account name)",
// "DateTime Field Id" => "DateTime Field Id",
// "GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)" => "GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)",
// "GroupMail: Operator Field (Id of field in tracker to store operator name (username))" => "GroupMail: Operator Field (Id of field in tracker to store operator name (username))",
// "Maximum number of characters in subjects allowed before truncating" => "Maximum number of characters in subjects allowed before truncating",
// "Webmail error" => "Webmail error",
// "No accounts set up (or no current account set)" => "No accounts set up (or no current account set)",
"Related Items" => "Kapcsolódó tartalom",
// "Lists objects which share a category with the viewed object" => "Lists objects which share a category with the viewed object",
// "Online Users" => "Online Users",
// "Display information about users currently logged in" => "Display information about users currently logged in",
// "List Type" => "List Type",
// "Display the number of users logged in, the list of users logged in, or both" => "Display the number of users logged in, the list of users logged in, or both",
// "Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"" => "Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"",
// "Cluster Mode" => "Cluster Mode",
// "If set to \"1\", separate users based on which host/server they logged on" => "If set to \"1\", separate users based on which host/server they logged on",
"Newest Comments" => "Legutóbbi kommentek",
// "Lists the specified number of comments starting from the most recently posted" => "Lists the specified number of comments starting from the most recently posted",
// "More in tooltips" => "More in tooltips",
// "If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item's tooltip" => "If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item's tooltip",
// "Type of the objects from which comments will be listed. Possible values" => "Type of the objects from which comments will be listed. Possible values",
// "Comments about objects in this language only" => "Comments about objects in this language only",
// "Last article comments" => "Last article comments",
// "Last wiki comments" => "Last wiki comments",
// "Displays YouTube videos and/or a link to a YouTube user's page" => "Displays YouTube videos and/or a link to a YouTube user's page",
// "Video identifiers" => "Video identifiers",
// "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")" => "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")",
// "YouTube user identifier" => "YouTube user identifier",
// "If set to a YouTube user identifier, display a link to the videos of this user" => "If set to a YouTube user identifier, display a link to the videos of this user",
// "Videos on YouTube" => "Videos on YouTube",
// "Bibliography Search" => "Bibliography Search",
// "Search the group's Zotero library for entries with the specified tags" => "Search the group's Zotero library for entries with the specified tags",
// "Invalid server key" => "Invalid server key",
"Invalid username or password" => "Nem megfelelő felhasználónév vagy jelszó",
// "Cookie not found" => "Cookie not found",
"Select <a href=\"tiki-list_banners.php\" title=\"Banners\">Admin &gt; Banners</a> from the menu to create and edit banner zones" => "Kattintsunk a <a href=\"tiki-list_banners.php\" title=\"Banners\">Adminisztráció &gt; Bannerek</a> menüpontra banner zónák létrehozásához és szerkesztéséhez",
"Cancel Edit" => "Mégse",
"Change preferences" => "Beállítások megváltoztatása",
"Activate the feature" => "Funkció bekapcsolása",
"Plugins" => "Plugin-ok",
"Site Ads and Banners" => "Hirdetések és bannerek",
"<strong>Activate</strong> will display content for Admin only. Select <strong>Publish</strong> to display for all users" => "<strong>Aktiválás</strong> bejelölésével a tartalom csak az adminisztrátorok számára jelenik meg. A <strong>Publikálás</strong> bejelölésével lesz elérhető az összes felhasználó számára",
"Settings" => "Beállítások",
// "Areas Overview" => "Areas Overview",
// "Nothing was updated" => "Nothing was updated",
// "Edit perspective" => "Edit perspective",
// "No category found in area" => "No category found in area",
// "Hint" => "Hint",
// "This tab shows you an overview of categories affected by the areas feature. The category with the smallest id should be the category set as areas root in the settings tab. If not so, update this overview with the button below" => "This tab shows you an overview of categories affected by the areas feature. The category with the smallest id should be the category set as areas root in the settings tab. If not so, update this overview with the button below",
// "Update areas" => "Update areas",
// "How to setup" => "How to setup",
// "You have to enable the perspective and the categories feature. Then set a structure of categories with a common parent. Set that parent as areas root in the settings tab. Then go to " => "You have to enable the perspective and the categories feature. Then set a structure of categories with a common parent. Set that parent as areas root in the settings tab. Then go to ",
// "perspectives" => "perspectives",
// "There you can create a set of perspectives to bind the children of areas root to. Change for every perspective you want the category jail to another child. It is designed that every child category is bind to one perspective only. If you do otherwise, the first found perspective is used" => "There you can create a set of perspectives to bind the children of areas root to. Change for every perspective you want the category jail to another child. It is designed that every child category is bind to one perspective only. If you do otherwise, the first found perspective is used",
"Look under \"Articles\" on the application menu for links to" => "Lásd a \"Cikkek\" menüpontot az alkalmazás fő menüjében, link:",
"Admin topics" => "Témák beállítása",
"Admin types" => "Típusok beállítása",
"General Settings" => "Általános beállítások",
"Features" => "Funkciók",
// "Article properties" => "Article properties",
// "Default maximum dimensions of custom images" => "Default maximum dimensions of custom images",
// "General (view mode)" => "General (view mode)",
"List mode" => "Listázási mód",
// "Sharing on social networks" => "Sharing on social networks",
"Import CSV file" => "CSV fájl importálása",
"Batch upload (CSV file):" => "Tömeges feltöltés (CSV fájlból)",
"File format: title,authorName,heading,body,lang,user" => "Fájlformátum: cím,szerző neve,fejléc,törzs,nyelv,felhasználó,stb",
"Import" => "Importálás",
"Articles Listing" => "Cikkek listázása",
"List Articles" => "Cikk lista",
"Select which items to display when listing articles" => "Cikkek listázásakor megjelenítendő tételek",
// "Article View" => "Article View",
// "To add/remove blogs, go to \"Create/Edit Blog\" under \"Blogs\" on the application menu, or" => "To add/remove blogs, go to \"Create/Edit Blog\" under \"Blogs\" on the application menu, or",
"Click Here" => "Klikk ide",
"Comments" => "Komment",
// "Blogs Listings" => "Blogs Listings",
// "Select which items to display when listing blogs" => "Select which items to display when listing blogs",
"To add/remove calendars, look for \"Calendar\" under \"Admin\" on the application menu, or" => "Naptárak hozzáadásához/eltávolításához lásd a \"Naptár\" menüpontot az \"Adminisztráció\" menü alatt az alkalmazás menüjében, vagy",
"Change settings" => "Beállítások megváltoztatása",
"General settings" => "Általános beállítások",
"Default calendars to display" => "Alapértelmezésben megjelenített naptárak",
// "All calendars" => "All calendars",
// "A subset of available calendars" => "A subset of available calendars",
"Create calendar" => "Naptár létrehozása",
// "Year selection is valid when the JS Calendar <strong>is not</strong> enabled" => "Year selection is valid when the JS Calendar <strong>is not</strong> enabled",
"Browse categories" => "Kategóriák böngészése",
"Administer categories" => "Kategóriák adminisztrálása",
// "Organize Objects" => "Organize Objects",
// "Feedback" => "Feedback",
// "Category objects" => "Category objects",
// "Re-apply the last saved category defaults to the wiki pages" => "Re-apply the last saved category defaults to the wiki pages",
"List comments" => "Kommentek listázása",
"General Preferences" => "Általános beállítások",
"Site-wide features" => "Weblap szintű funkciók",
"Display options" => "Opciók megjelenítése",
"Permission" => "Jogosultság",
"Inline comments" => "Szövegbe foglalt kommentek",
"The feature below must be activated for this feature to work." => "alábbi funkciókat be kell kapcsolni hogy ez a funkció működjön",
"Using comments in various features" => "Kommentek használata különböző funkciókban",
"Admin Groups" => "Csoportok adminisztrálása",
"Admin Users" => "Felhasználók adminisztrálása",
"Manage permissions" => "Jogosultságok kezelése",
"User features" => "Felhasználói funkciók",
"Community" => "Társaság",
"Default user preferences" => "Alapértelmezett felhasználói preferenciák",
"Users Default Preferences" => "Alapértelmezett felhasználói preferenciák",
"User messages" => "Felhasználói üzenetek",
"My Tiki" => "Saját Tikim",
"Select which items to display when listing users" => "Felhasználók listázásakor megjelenítendő tételek kiválasztása",
// "Join the community" => "Join the community",
// "Tiki Wiki CMS Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU" => "Tiki Wiki CMS Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU",
// "Join the Community" => "Join the Community",
// "Tiki news" => "Tiki news",
// "Embedded RSS feed from info.tiki.org TODO, meanwhile" => "Embedded RSS feed from info.tiki.org TODO, meanwhile",
// "Tiki Newsletter" => "Tiki Newsletter",
// "Promote your site" => "Promote your site",
// "Add your site to the Tiki diretory" => "Add your site to the Tiki diretory",
// "Submit your site" => "Submit your site",
// "Spread the word" => "Spread the word",
// "Add the \"Powered by\" module to your site. " => "Add the \"Powered by\" module to your site. ",
// "Manage Modules" => "Manage Modules",
// "Help improve Tiki" => "Help improve Tiki",
// "Submit a feature request or bug report" => "Submit a feature request or bug report",
// "Click here to go to our development site" => "Click here to go to our development site",
// "Make a financial contribution to the Tiki Association" => "Make a financial contribution to the Tiki Association",
// "Contribute to Tiki" => "Contribute to Tiki",
// "New Feature" => "New Feature",
// "Please note: Experimental - work in progress" => "Please note: Experimental - work in progress",
// "Tiki Connect is a way to let the Tiki project know how it is being used, and which parts people like or would like fixing (or explaining)" => "Tiki Connect is a way to let the Tiki project know how it is being used, and which parts people like or would like fixing (or explaining)",
// "When you click the \"Send Info\" below you will be connected with mother.tiki.org, which is where the data will be collected" => "When you click the \"Send Info\" below you will be connected with mother.tiki.org, which is where the data will be collected",
// "You can also send feedback about Tiki by checking the \"Feedback\" checkbox above. Icons will appear next to all the preferences where you can \"like\", request a \"fix\" or ask \"what's this for?\"" => "You can also send feedback about Tiki by checking the \"Feedback\" checkbox above. Icons will appear next to all the preferences where you can \"like\", request a \"fix\" or ask \"what's this for?\"",
// "Your votes are sent when you connect with mother.tiki.org (currently only be clicking the \"Send Info\" button)" => "Your votes are sent when you connect with mother.tiki.org (currently only be clicking the \"Send Info\" button)",
// "For more info" => "For more info",
// "Send Info" => "Send Info",
// "Send the data" => "Send the data",
// "Preview info" => "Preview info",
// "See what is going to be sent" => "See what is going to be sent",
// "Fill form" => "Fill form",
// "Fill this form in based on other preferences" => "Fill this form in based on other preferences",
// "Site Title is required" => "Site Title is required",
// "Advanced settings" => "Advanced settings",
// "Exposed to assist testing and development" => "Exposed to assist testing and development",
// "Connections received" => "Connections received",
// "Recent connections" => "Recent connections",
// "Rebuild Index" => "Rebuild Index",
// "Rebuild received connections index" => "Rebuild received connections index",
// "<strong>Server stats:</strong> %0 reports received from %1 Tikis" => "<strong>Server stats:</strong> %0 reports received from %1 Tikis",
// "Copyright allows to determine a copyright for all the objects of tiki" => "Copyright allows to determine a copyright for all the objects of tiki",
"Enable copyright management for" => "Szerzői jogok kezelésének bekapcsolása",
"To configure your directory, find \"Admin Directory\" under \"Directory\" on the application menu, or" => "Könyvtár beállításához lásd a \"Könyvtár adminisztrálása\" menüpontot a \"Könyvtár\" menü alatt az alkalmazás menüjében, vagy",
"To add/remove FAQs, look for \"Admin FAQs\" under \"FAQs\" on the application menu, or" => "GYIK-ek hozzáadásához/eltávolításához lásd\"Gyakori kérdések adminisztrálása\" menüpontot a \"Gyakori kérdések\" menü alatt az alkalmazás menüjében, vagy",
"Please see the <a class='rbox-link' target='tikihelp' href='http://doc.tiki.org/Features'>evaluation of each feature</a> on Tiki's developer site." => "Az <a class='rbox-link' target='tikihelp' href='http://doc.tiki.org/Features'>egyes funkciók értékelése</a> megtalálható a Tiki fejlesztői weblapján",
"Apply" => "Alkalmazás",
// "Global features" => "Global features",
// "Main feature" => "Main feature",
// "Additional" => "Additional",
// "Interaction with online services or other software" => "Interaction with online services or other software",
// "Configuration completed" => "Configuration completed",
// "Authenticate with Zotero" => "Authenticate with Zotero",
"Watches" => "Figyelések",
// "Interface" => "Interface",
// "jQuery plugins and add-ons" => "jQuery plugins and add-ons",
// "Mobile Themes" => "Mobile Themes",
"Programmer" => "Programozás",
"Logging and Reporting" => "Loggolás és riportolás",
"Visible to admin only" => "Csak adminisztrátor láthatja",
"Include Smarty notices" => "Tartalmazzon Smarty megjegyzéseket",
"Custom Code" => "Saját kód",
// "Event Hooks" => "Event Hooks",
// "Please note that this is a relatively new feature that still needs to be deployed all around. Expect more events to be added over time" => "Please note that this is a relatively new feature that still needs to be deployed all around. Expect more events to be added over time",
// "If you need to add behaviors to Tiki, there are several event hooks you can attach to. Here are the events and the inheritance" => "If you need to add behaviors to Tiki, there are several event hooks you can attach to. Here are the events and the inheritance",
// "Draw Event Diagram" => "Draw Event Diagram",
// "To create or remove file galleries, select" => "To create or remove file galleries, select",
// "from the application menu" => "from the application menu",
"If you decide to store files in a directory you must ensure that the user cannot access directly to the directory." => "Ha úgy döntünk hogy a fájlokat könyvtárban tároljuk akkor biztosítsuk hogy a felhasználók közvetlenül nem érhetik el az adott könyvtárat",
"You have two options to accomplish this:<br /><ul><li>Use a directory outside your document root, make sure your php script can read and write to that directory</li><li>Use a directory inside the document root and use .htaccess to prevent the user from listing the directory contents</li></ul>" => "Ennek megoldására két lehetőség van:<br /><ul><li>Használjunk a dokumentum gyökéren kívűli könyvtárat és biztosítsuk hogy a php szkript olvashatja és írhatja könyvtárat</li><li>Használjunk a dokumentum gyökerén belüli könyvtárat és használjuk .htaccess fájlt annak megakadályozására hogy a felhasználók listázhassák a könyvtár tartalmát</li></ul>",
"To configure the directory path use UNIX like paths for example files/ or c:/foo/files or /www/files/" => "A könyvtár útvonalának konfigurálásához használjunk UNIX jellegű útvonalat, például: files/ vagy c:/foo/files vagy /www/files/",
// "Move files from database to directory" => "Move files from database to directory",
// "Move files from directory to database" => "Move files from directory to database",
// "Manage comment settings" => "Manage comment settings",
// "You are highly recommended to use a file directory as the File Gallery storage, when using this feature" => "You are highly recommended to use a file directory as the File Gallery storage, when using this feature",
// "A cron job must be set up in order to delete the files" => "A cron job must be set up in order to delete the files",
// "Update mime of all non archived octet-stream files" => "Update mime of all non archived octet-stream files",
// "Quota" => "Quota",
"Used" => "Használt",
"Upload Regex" => "Feltöltési Regex",
"Gallery Listings" => "Galéria listázás",
"Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries" => "Ezen beállítások megváltoztatása  <em>nincs</em> hatással a létező fájlgalériákra. Ezen változások <em>csak</em> az új galériákra lesznek hatással",
"Default sort order:" => "Alapértelmezett rendezési sorrend:",
"Select which items to display when listing galleries: " => "Galériák listázásakor megjelenítendő tételek",
// "Admin Gallery Listings" => "Admin Gallery Listings",
// "Select which items to display when admin galleries: " => "Select which items to display when admin galleries: ",
"Search Indexing" => "Keresés indexelése",
// "Handlers" => "Handlers",
// "Add custom handlers to make your files &quot;searchable&quot; content" => "Add custom handlers to make your files &quot;searchable&quot; content",
// "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command" => "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command",
// "To delete a handler, leave the <strong>System Command</strong> field blank" => "To delete a handler, leave the <strong>System Command</strong> field blank",
// "Tiki is pre-configured to handle many common types. If any of those are listed here, it is because the command line tool is unavailable" => "Tiki is pre-configured to handle many common types. If any of those are listed here, it is because the command line tool is unavailable",
// "Missing Handlers" => "Missing Handlers",
"MIME Type" => "MIME típus",
// "System Command" => "System Command",
"Reindex all files for search" => "Összes fájl újraindexelése kereséshez",
// "SCORM" => "SCORM",
"To add/remove forums, look for \"Admin forums\" under \"Forums\" on the application menu, or" => "Fórumok hozzáadásához/eltávolításához lásd a \"Fórumok adminisztrálása\" menüpontot a \"Fórumok\" menüben vagy",
"Threads" => "Threadek",
"Searches" => "Keresések",
"Forums Listing" => "Fórumok listázása",
"Select which items to display when listing forums" => "Fórumok listázásakor megjelenítendő tételek",
// "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>" => "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>",
"Random tag cloud colors" => "Véletlenszerű címkefelhő színek",
"Separate colors with a comma (,)" => "Színek elválasztása vesszővel (,)",
// "Alphanumeric ASCII characters only" => "Alphanumeric ASCII characters only",
// "No accents or special characters" => "No accents or special characters",
// "Accept all characters" => "Accept all characters",
"Tag Management" => "Címkék kezelése",
"Cleanup unused tags" => "Nem használt címkék kitakarítása",
// "3D Tag Browser Configuration" => "3D Tag Browser Configuration",
"General" => "Általános",
"Graph appearance" => "Grafika megjelenése",
// "Camera settings" => "Camera settings",
"Physics engine" => "Fizikai engine",
"To add/remove image galleries, go to \"Image Galleries\" on the application menu, or" => "Képgalériák hozzáadásához /eltávolításához lásd a \"Képgalériák\" menüpontot az alkalmazás fő menüjében, vagy",
"You can upload images of a size of " => "A feltölthető képek maximális mérete ",
"Alter the php.ini variables file_uploads, upload_max_filesize, post_max_size and database variables (max_allowed_packet for mysql) to change this value" => "Ezen érték megváltoztatásához módosítsuk a php.ini-ben található file_uploads, upload_max_filesize, post_max_size és adatbázi változókat (max_allowed_packet mysql esetén)",
"Home Gallery" => "Kezdőgaléria",
"Galleries features" => "Galériák beállításai",
"Rankings:" => "Rangsor:",
"Comments:" => "Kommentek:",
"Uses Slideshow:" => "Bemutató használata:",
"Use database to store images" => "Adatbázisban tárolja a képeket",
"Use a directory to store images" => "Könyvtárban tárolja a képeket",
"Directory path" => "Könyvtár útvonala",
"Note: if you change this directory, you have to move the contents to the new directory. You can also use the 'Mover' below." => "Megjegyzés: ha megváltoztatjuk ezt a könyvtárat akkor a tartalmat át kell mozgatni az új könyvtárba. Ehhez használhatjuk a lentebb található 'Mozgató'-t is.",
"Library to use for processing images" => "A képek átalakitásához használt programkönyvtár",
"Uploaded image names must match regex" => "A feltöltött kép nevének egyezni kell a kifejezéssel",
"Uploaded image names cannot match regex" => "A feltöltött kép neve nem egyezhet a kifejezéssel",
"Directory Batch Loading" => "Kötegelt könyvtár feltöltés",
"If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload images in that dir, either by scp, ftp, or other protocols" => "Ha bekapcsoljuk a Kötegelt könyvtár feltöltést akkor létre kell hoznunk egy weben keresztül olvasható könyvtárat, lehetőleg a webes könyvtárterületen kívűl. Ezután hozzunk létre egy módszert a feltöltés végrehajtására (scp, ftp vagy más protokoll)",
"Enable directory batch loading" => "Kötegelt könyvtár feltöltés engedélyzése",
"Batch loading directory" => "Köteg feltöltési könyvtára",
"Force and limit categorization to within subtree of:" => "Kategorizálás erőltetése és korlátozása ezen alkategóriákra:",
"Display image information in a mouseover box" => "Képinformációk megjelenítése dobozban mikor az egér a kép felett van",
"yes, and don't display that information under the image" => "Igen, és ezen információk ne a kép alatt jelenjenek meg",
"Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)" => "Alapértelmezett maximális sor, képek soronként, előnézet méret és arány használata minden galériánál (értékek beállítása lentebb)",
"Max Rows per page" => "Sorok max száma oldalanként",
"Images per row" => "Soronkénti képek",
"Thumbnails size X" => "Előnézet X mérete",
// "Pixels Default" => "Pixels Default",
"Thumbnails size Y" => "Előnézet Y mérete",
"Default scale size" => "Alapértelmezett arány mérete",
"pixels" => "pixel",
"Set features" => "Tulajdonságok beállítása",
"Exterminator" => "Exterminátor",
"Remove images in the system gallery not being used in Wiki pages, articles or blog posts" => "Wiki oldalak, blog posztok, cikkek által nem használt képek eltávolitása a rendszergalériából",
"Remove" => "Eltávolítás",
"Mover" => "Mozgató",
"Move images from database storage to filesystem storage" => "Képek mozgatása adatbázisból fájlrendszerbe",
"Move images from filesystem storage to database storage" => "Képek mozgatása fájlrendszerből adatbázisba",
"All galleries" => "Összes galéria",
"System Gallery" => "Rendszergaléria",
"Move" => "Mozgatás",
"Move images from old filesystem store to new directory" => "Képek mozgatása régi fájlrendszerbeli helyről új fájlrendszerbeli helyre",
"Moved" => "Mozgatásra került",
"Gallery listing configuration" => "Galériák listázásának beállítása",
"Change configuration" => "Beállítások megváltoztatása",
"Image galleries comments settings" => "Képgalériák kommentjeinek beállítása",
"Default number of comments per page:" => "Kommentek alapértelmezett száma oldalanként:",
// "Server Fitness" => "Server Fitness",
"Release Check" => "Kiadási verzió ellenőrzése",
"Last update from SVN" => "Legutóbbi frissítés SVN-ből",
"Reset or upgrade your database" => "Adatbázis visszaállítása vagy frissítése",
"Check for updates now" => "Frissítések keresése most",
"Site Identity" => "Weblap identitás",
// "Go to <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look & Feel</strong></a> section for additional site related customization preferences" => "Go to <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look & Feel</strong></a> section for additional site related customization preferences",
// "These values will be stored in plain text in the database" => "These values will be stored in plain text in the database",
"Email to send a test mail" => "Teszt E-mail küldése",
"Sessions" => "Munkamenetek",
// "Advanced configuration warning" => "Advanced configuration warning",
// "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects" => "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects",
// "Changing this feature will immediately log you out when you save this preference" => "Changing this feature will immediately log you out when you save this preference",
"Enable now" => "Bekapcsolás most",
"Contact" => "Kontakt",
"Miscellaneous" => "Egyéb",
"Menus" => "Menük",
"Create and edit menus " => "Menük létrehozása és szerkesztése",
"Home Page" => "Főoldal",
// "Redirects" => "Redirects",
"Site Access" => "Weblap hozzáférés",
"Sample:" => "Minta:",
"Date and Time Format Help" => "Dátum és idő formátum segítség",
"Change admin password" => "Admin jelszó megváltoztatása",
"Change the <strong>Admin</strong> password" => "<strong>Adminisztrátori</strong> jelszó megváltoztatása",
"User administration" => "Felhasználók adminisztrálása",
// "To use Google Maps, you must generate a Google Maps API Key for your web site. See <a href=\"http://code.google.com/intl/fr/apis/maps/signup.html\">http://code.google.com/intl/fr/apis/maps/signup.html</a> for details" => "To use Google Maps, you must generate a Google Maps API Key for your web site. See <a href=\"http://code.google.com/intl/fr/apis/maps/signup.html\">http://code.google.com/intl/fr/apis/maps/signup.html</a> for details",
"Defaults" => "Alapértelmezések",
// "Map mode in listings" => "Map mode in listings",
"Internationalization" => "i18n",
"Babelfish links" => "Babelfish linkek",
"Customized String Translation" => "Egyéni fordítások",
// "Syntax error" => "Syntax error",
// "Cannot open/write this file" => "Cannot open/write this file",
// "Custom translation will not be saved. Ask your administration to change the permission" => "Custom translation will not be saved. Ask your administration to change the permission",
// "ok" => "ok",
// "The file has been saved" => "The file has been saved",
"Translation" => "Fordítás",
"Intertiki client" => "Intertiki kliens",
"Tiki Unique key" => "Tiki egyedi kulcs",
"InterTiki Slave mode" => "InterTiki Slave mód",
"Warning: overrides manually registered local users" => "Figyelmeztetés: felülírja a manuálisan regisztrált felhasználókat",
"as master" => "master-ként",
"Import user preferences" => "Felhasználói preferenciák importálása",
"Import user groups" => "Felhasználói csoportok importálása",
"Limit group import (comma-separated list of imported groups, leave empty to avoid limitation)" => "Csoport importálás szűkítése (vesszővel elválasztott lista az importált csoportokról, hagyjuk üresen ha nem akarunk szűkíteni)",
"Intertiki shared cookie for sliding auth under same domain" => "Intertiki megosztott cookie azonosítás átengedéséhez ugyanazon domain alatt",
"InterTiki Server" => "InterTiki szerver",
"host" => "hoszt",
"port" => "port",
"Add new server" => "Új szerver hozzáadása",
"Intertiki server" => "Intertiki szerver",
"Intertiki Server enabled" => "Intertiki szerver bekapcsolva",
"Access Log file" => "Hozzáférés log fájl",
"Errors Log file" => "Hiba log fájl",
"Known hosts" => "Ismert hosztok",
"Key" => "Kulcs",
"IP" => "IP",
"Enable/disable Tiki features in " => "Tiki funkciók bekapcsolása/kikapcsolása itt végezhető el:",
", but configure them elsewhere" => " (az egyes funkciók konfigurálását máshol kell elvégezni)",
"Registration" => "Regisztráció",
"Log in" => "Bejelentkezés",
// "Generate a passcode" => "Generate a passcode",
// "Requires PHP GD library" => "Requires PHP GD library",
// "Users can select a group to join at registration" => "Users can select a group to join at registration",
// "By default, new users automatically join the Registered group" => "By default, new users automatically join the Registered group",
// "Store passwords in plain text is activated. You should never set this unless you know what you are doing" => "Store passwords in plain text is activated. You should never set this unless you know what you are doing",
// "Assign users to group function of email pattern" => "Assign users to group function of email pattern",
// "You must change the Authentication Method to LDAP for these changes to take effect" => "You must change the Authentication Method to LDAP for these changes to take effect",
// "LDAP Bind settings" => "LDAP Bind settings",
// "LDAP User" => "LDAP User",
// "LDAP Admin" => "LDAP Admin",
// "LDAP external groups" => "LDAP external groups",
// "LDAP Group" => "LDAP Group",
// "LDAP Group Member - if group membership can be found in group attributes" => "LDAP Group Member - if group membership can be found in group attributes",
// "LDAP User Group - if group membership can be found in user attributes" => "LDAP User Group - if group membership can be found in user attributes",
"PAM" => "PAM",
// "You must change the Authentication Method to PAM for these changes to take effect" => "You must change the Authentication Method to PAM for these changes to take effect",
"Shibboleth Authentication " => "Shibboleth autentikáció",
// "You must change the Authentication Method to Shibboleth for these changes to take effect" => "You must change the Authentication Method to Shibboleth for these changes to take effect",
// "CAS" => "CAS",
// "You must change the Authentication Method to CAS for these changes to take effect" => "You must change the Authentication Method to CAS for these changes to take effect",
// "CAS Server" => "CAS Server",
// "CAS Server Name" => "CAS Server Name",
// "CAS Server Port" => "CAS Server Port",
// "CAS Server Path" => "CAS Server Path",
// "phpBB User Database Authentication " => "phpBB User Database Authentication ",
// "You must change the Authentication Method to phpBB for these changes to take effect" => "You must change the Authentication Method to phpBB for these changes to take effect",
// "You must turn Users can register off for phpBB Authentication to function properly" => "You must turn Users can register off for phpBB Authentication to function properly",
// "MySql only (for now)" => "MySql only (for now)",
// "Web Server Authentication " => "Web Server Authentication ",
// "You must change the Authentication Method to Web Server for these changes to take effect" => "You must change the Authentication Method to Web Server for these changes to take effect",
// "Theme Screenshot" => "Theme Screenshot",
"The \"users can change theme\" feature will override the theme displayed" => "A \"Felhasználók változtathatják a stílust\" funkció felülírja a megjelenített stílust",
"Theme not saved yet - click \"Apply\"" => "A stílus még nincs elmentve - kattintani kell az \"Alkalmazás\" gombra",
"Restrict available themes" => "Rendelkezésre álló stílusok korlátozása",
"General Layout" => "Általános kinézet",
// "&quot;Modules&quot; are the items of content at the top &amp; bottom and in the right &amp; left columns of the site" => "&quot;Modules&quot; are the items of content at the top &amp; bottom and in the right &amp; left columns of the site",
"Admin &gt; Modules" => "Adminisztráció &gt; Modulok",
"from the menu to create and edit modules" => "menüt modulok létrehozására és szerkesztésére",
// "Module zone visibility" => "Module zone visibility",
"Site Report Bar" => "Weblap riport sor",
// "Pagination" => "Pagination",
"UI Effects" => "UI effektusok",
"Standard UI effects" => "Sztenderd UI effektusok",
"Tab UI effects" => "Fülek UI effektusai",
// "Customization" => "Customization",
// "Open editor" => "Open editor",
// "Preview Theme" => "Preview Theme",
// "Custom Codes" => "Custom Codes",
// "Experimental: CSS assistant (work in progress - click the x to remove)" => "Experimental: CSS assistant (work in progress - click the x to remove)",
"Editing" => "Szerkesztés",
"View Templates" => "Sablonok megtekintése",
"Admin layout per section" => "Kinézet adminisztrálása szekciónként",
// "Favicon" => "Favicon",
// "Context Menus" => "Context Menus",
"Currently used in File Galleries only" => "Jelenleg csak Fájlgalériákban használt",
"Separators" => "Szeparátorok",
// "MapServer settings" => "MapServer settings",
"Generate User Map" => "Felhasználói térkép generálása",
// "See also" => "See also",
// "Search Engine Friendly URLs" => "Search Engine Friendly URLs",
"Meta tags" => "Meta címkék",
"Geo URL" => "Geo URL",
"Robots" => "Robotok",
// "Configure metrics" => "Configure metrics",
// "Show past results" => "Show past results",
// "Past results count" => "Past results count",
// "{\$crumbs[\$crumb]->description}" => "{\$crumbs[\$crumb]->description}",
// "If you lose your login module, use tiki-login_scr.php to be able to login" => "If you lose your login module, use tiki-login_scr.php to be able to login",
// "Payments" => "Payments",
// "Choose payment system" => "Choose payment system",
// "You can use only one payment method: PayPal or Cclite or Tiki User Credits" => "You can use only one payment method: PayPal or Cclite or Tiki User Credits",
// "PayPal is working at the moment. See PayPal.com" => "PayPal is working at the moment. See PayPal.com",
// "Cclite: Community currency accounting for local exchange trading systems (LETS). See " => "Cclite: Community currency accounting for local exchange trading systems (LETS). See ",
// "sourceforge.net" => "sourceforge.net",
// "Tiki User Credits: Requires this other feature to be configured" => "Tiki User Credits: Requires this other feature to be configured",
// "Cclite is for creating and managing alternative or complementary trading currencies and groups" => "Cclite is for creating and managing alternative or complementary trading currencies and groups",
// "Work in progress since Tiki 6" => "Work in progress since Tiki 6",
// "Advanced Shopping Cart" => "Advanced Shopping Cart",
// "Advanced Cart Tracker Names Setup" => "Advanced Cart Tracker Names Setup",
// "Products Tracker Setup" => "Products Tracker Setup",
// "Depending on which feature you are using, you may need some or all of the following fields to be setup" => "Depending on which feature you are using, you may need some or all of the following fields to be setup",
// "Shipping" => "Shipping",
// "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Performance page</a> on Tiki's developer site" => "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Performance page</a> on Tiki's developer site",
"Performance" => "Teljesítmény",
"Output compression is active" => "Kimeneti tömörítés aktív",
"Compression is handled by" => "Tömörítés kezelője",
// "Bytecode Cache" => "Bytecode Cache",
// "Using <strong>%0</strong>.These stats affect all PHP applications running on the server" => "Using <strong>%0</strong>.These stats affect all PHP applications running on the server",
// "Configuration setting <em>xcache.admin.enable_auth</em> prevents from accessing statistics. This will also prevent the cache from being cleared when clearing template cache" => "Configuration setting <em>xcache.admin.enable_auth</em> prevents from accessing statistics. This will also prevent the cache from being cleared when clearing template cache",
// "Available" => "Available",
"Memory" => "Memória",
// "Miss" => "Miss",
// "Hit" => "Hit",
// "Cache Hits" => "Cache Hits",
// "Memory Used" => "Memory Used",
// "Misses" => "Misses",
// "Few hits recorded. Statistics may not be representative" => "Few hits recorded. Statistics may not be representative",
"Low hit ratio. %0 may be misconfigured and not used." => "Low hit ratio. APC may be misconfigured and not used.",
// "Little memory available. Thrashing likely to occur" => "Little memory available. Thrashing likely to occur",
// "The values to increase are apc.shm_size (for APC) or xcache.size (for XCache)" => "The values to increase are apc.shm_size (for APC) or xcache.size (for XCache)",
"Small amount of memory allocated to %0. Verify the configuration." => "Small amount of memory allocated to APC. Verify the configuration.",
// "Configuration <em>%0</em> is enabled. Disabling modification checks can improve performance, but will require manual clear on file updates" => "Configuration <em>%0</em> is enabled. Disabling modification checks can improve performance, but will require manual clear on file updates",
// "<em>%0</em> should not be disabled due to authentication on XCache" => "<em>%0</em> should not be disabled due to authentication on XCache",
// "Bytecode cache is not used. Using a bytecode cache (APC, XCache, WinCache) is highly recommended for production environments" => "Bytecode cache is not used. Using a bytecode cache (APC, XCache, WinCache) is highly recommended for production environments",
"Major slow down" => "Jelentős lassulás",
// "These are reported to slow down Tiki. If you have a high-volume site, you may want to deactivate them" => "These are reported to slow down Tiki. If you have a high-volume site, you may want to deactivate them",
// "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\">Search admin panel</a>" => "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\">Search admin panel</a>",
"To add/remove polls, look for \"Polls\" under \"Admin\" on the application menu, or" => "Szavazások hozzáadásához/eltávolításához lásd a \"Szavazások\" menüpontot az \"Adminisztráció\" menü alatt az alkalmazás menüjében, vagy",
// "Loading profile" => "Loading profile",
// "Are you sure you want to apply the profile" => "Are you sure you want to apply the profile",
// "Are you sure you want to re-apply the profile" => "Are you sure you want to re-apply the profile",
// "Sending" => "Sending",
"Waiting" => "Várakozó",
// "Tiki Configuration Profiles" => "Tiki Configuration Profiles",
"The following list of changes has been applied" => "Az alábbi változások kerültek beállításra",
// "Apply Profiles" => "Apply Profiles",
// "Configure Tiki in 3 easy steps using Profiles" => "Configure Tiki in 3 easy steps using Profiles",
// "A Friendly Warning" => "A Friendly Warning",
// "Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles" => "Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles",
"Profiles" => "Profilok",
// "Step 1: Use the Quick or Manual Filter option to see a list of Configuration Profiles you can apply" => "Step 1: Use the Quick or Manual Filter option to see a list of Configuration Profiles you can apply",
// "Option 1: Quick Filter" => "Option 1: Quick Filter",
// "Option 2: Manual Filter" => "Option 2: Manual Filter",
// "Featured Profiles is a list of applications that are maintained by the Tiki community and are a great way to get started" => "Featured Profiles is a list of applications that are maintained by the Tiki community and are a great way to get started",
// "Full Profiles" => "Full Profiles",
// "Full Profiles are full featured out of the box solutions" => "Full Profiles are full featured out of the box solutions",
// "Mini Profiles" => "Mini Profiles",
// "Mini Profiles will configure specific features and are a great way to add more functionality to an existing configuration" => "Mini Profiles will configure specific features and are a great way to add more functionality to an existing configuration",
// "Learning Profiles" => "Learning Profiles",
// "Learning Profiles will allow you to quickly evaluate specific features in Tiki" => "Learning Profiles will allow you to quickly evaluate specific features in Tiki",
"Filter the list of profiles" => "Profilok listájának szűrése",
// "Profile name" => "Profile name",
// "Profile types" => "Profile types",
"Repository" => "Gyűjtemény",
// "Step 2: Click on a Configuration Profile Name below to review it and to be able to apply it on your Web site" => "Step 2: Click on a Configuration Profile Name below to review it and to be able to apply it on your Web site",
// "Profile type" => "Profile type",
// "applied" => "applied",
"Profile repository" => "Profil gyűjtemény",
"Last update" => "Legutóbbi frissítés",
"Refresh" => "Frissítés",
// "JavaScript must be turned <strong>ON</strong> in order to apply Profiles. Please enable your JavaScript and try again" => "JavaScript must be turned <strong>ON</strong> in order to apply Profiles. Please enable your JavaScript and try again",
// "Export YAML" => "Export YAML",
"Modules" => "Modulok",
// "Export modified preferences as YAML" => "Export modified preferences as YAML",
// "Toggle Visible" => "Toggle Visible",
// "Show added preferences" => "Show added preferences",
// "no default" => "no default",
"Repositories" => "Gyűjtemények",
// "Profile tester" => "Profile tester",
// "Paste or type wiki markup and YAML (with or without the {literal}{CODE}{/literal} tags) into the text area below" => "Paste or type wiki markup and YAML (with or without the {literal}{CODE}{/literal} tags) into the text area below",
// "This will run the profile and make potentially unrecoverable changes in your database" => "This will run the profile and make potentially unrecoverable changes in your database",
// "Test Profile Name" => "Test Profile Name",
// "Global configuration" => "Global configuration",
// "Cache duration" => "Cache duration",
"Create New" => "új létrehozása",
"Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use the <strong>Admin</strong> &gt; <strong>External Feeds</strong> menu option, or" => "Ezen az oldalon a Tiki által generált feed-ek beállítása végezhető el. Más oldalakról származó feed-ek szindikálásához lásd az  <strong>Adminisztráció</strong> > <strong>Külső feed-ek</strong> menüpontot, vagy",
"External feeds" => "Külső feed-ek",
"Feeds" => "Feed-ek",
// "Feed for articles" => "Feed for articles",
// "Feed for blogs" => "Feed for blogs",
// "Feed for individual blogs" => "Feed for individual blogs",
// "Feed for image galleries" => "Feed for image galleries",
// "Feed for individual image galleries" => "Feed for individual image galleries",
// "Feed for file galleries" => "Feed for file galleries",
// "Feed for individual file galleries" => "Feed for individual file galleries",
// "Feed for wiki pages (with diff)" => "Feed for wiki pages (with diff)",
// "Feed for wiki pages (no diff)" => "Feed for wiki pages (no diff)",
// "Feed for forums" => "Feed for forums",
// "Feed for individual forums" => "Feed for individual forums",
// "Feed for trackers" => "Feed for trackers",
// "Feed for calendars" => "Feed for calendars",
// "Feed for directories" => "Feed for directories",
// "Feed for shoutbox" => "Feed for shoutbox",
"You can see users rank by score in the module users_rank, for that go to" => "A felhasználók pontszámon alapuló rangsorát a users_rank modulban lehet megtekinteni itt",
// "Admin modules" => "Admin modules",
"Expiration" => "Lejárat",
// "{\$events[e].category}" => "{\$events[e].category}",
// "{\$events[e].description}" => "{\$events[e].description}",
"can be seen on page" => "megtekinthető a",
"in Admin menu" => "menüpont alatt az Adminisztráció menüben",
// "Also see the Search Indexing tab here" => "Also see the Search Indexing tab here",
// "File Gallery admin panel" => "File Gallery admin panel",
// "Basic Search" => "Basic Search",
// "Advanced Search" => "Advanced Search",
// "Search Engine Settings" => "Search Engine Settings",
// "Index maintenance" => "Index maintenance",
// "Optimize" => "Optimize",
// "From the command line" => "From the command line",
// "Log rebuild" => "Log rebuild",
// "Log file is saved as temp/Search_Indexer.log" => "Log file is saved as temp/Search_Indexer.log",
// "Indexation" => "Indexation",
// "Queue size" => "Queue size",
"Process" => "Folyamat",
// "Uses JavaScript to reload this page until queue is processed" => "Uses JavaScript to reload this page until queue is processed",
// "Forum searches" => "Forum searches",
"Search Results" => "Keresési eredmények",
"Select the items to display on the search results page" => "Találatokat soroló oldalakon megjelenítendő tételek kiválasztása",
"Select the information to display for each result" => "Minden egyes találatnál megjelenítendő információk kiválasztása",
// "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Security'>Security page</a> on Tiki's developer site" => "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Security'>Security page</a> on Tiki's developer site",
// "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings" => "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings",
// "General Security" => "General Security",
"Please also see" => "Továbbá ajánljuk tekintsd meg a ",
// "HTTPS (SSL) and other login preferences" => "HTTPS (SSL) and other login preferences",
"CSRF Security" => "CSRF biztonság",
// "Use these options to protect against cross-site request forgeries (CSRF)" => "Use these options to protect against cross-site request forgeries (CSRF)",
// "Spam protection" => "Spam protection",
"Search results" => "Keresés eredménye",
// "Tokens" => "Tokens",
// "To manage tokens go to <a href=\"tiki-admin_tokens.php\">Admin Tokens</a> page" => "To manage tokens go to <a href=\"tiki-admin_tokens.php\">Admin Tokens</a> page",
// "Clipperz online password management" => "Clipperz online password management",
// "Tiki doesn't offer a built-in password management feature" => "Tiki doesn't offer a built-in password management feature",
// "Learn more about Clipperz" => "Learn more about Clipperz",
// "Meta-tags" => "Meta-tags",
// "SEFURL requires the <strong>URL Rewrite module</strong> for IIS. You do not seem to have this module installed" => "SEFURL requires the <strong>URL Rewrite module</strong> for IIS. You do not seem to have this module installed",
// "Please see <a href=\"http://doc.tiki.org/Windows+Server+Install\">Windows Server Install</a> on tiki.org for more information" => "Please see <a href=\"http://doc.tiki.org/Windows+Server+Install\">Windows Server Install</a> on tiki.org for more information",
// "SEFURL will not work unless Tiki specific directives are deployed to the %0 file" => "SEFURL will not work unless Tiki specific directives are deployed to the %0 file",
// "To enable this file, simply copy the %0 file (located in the main directory of your Tiki installation) to %1" => "To enable this file, simply copy the %0 file (located in the main directory of your Tiki installation) to %1",
// "If you need to keep an existing (non Tiki) %0 file, just add Tiki directives to it" => "If you need to keep an existing (non Tiki) %0 file, just add Tiki directives to it",
// "When you upgrade Tiki (e.g. from version 7 to version 8), make sure to make use of the new URL rewriting configuration file" => "When you upgrade Tiki (e.g. from version 7 to version 8), make sure to make use of the new URL rewriting configuration file",
// "%0 file is missing" => "%0 file is missing",
// "Unable to verify that your URL rewriting configuration is up to date" => "Unable to verify that your URL rewriting configuration is up to date",
// "SEFURL may not work completely or correctly if Tiki URL rewriting configuration is not current" => "SEFURL may not work completely or correctly if Tiki URL rewriting configuration is not current",
// "%0 is not in the expected format" => "%0 is not in the expected format",
// "%0 may simply be outdated" => "%0 may simply be outdated",
// "To update this file, if it was not customized, copy the %0 file (located in the main directory of your Tiki installation) to %1, overwriting the latter" => "To update this file, if it was not customized, copy the %0 file (located in the main directory of your Tiki installation) to %1, overwriting the latter",
// "%0 file is out of date" => "%0 file is out of date",
// "The RewriteBase directive seems not to be set up correctly. This is required for sefurl to function correctly" => "The RewriteBase directive seems not to be set up correctly. This is required for sefurl to function correctly",
// "The current value in %0 is %1 but the base url for this site is %2" => "The current value in %0 is %1 but the base url for this site is %2",
// "List of Url Parameters that should go in the path" => "List of Url Parameters that should go in the path",
"Known Types" => "Ismert típusok",
"Token" => "Token",
"Invert" => "Invert",
"Show Usage" => "Használat megjelenítése",
"Delete &amp; Unreference" => "Törlés &amp; Hivatkozás visszavonása",
"Invert Relation" => "Kapcsolat megfordítása",
"New Types" => "Új típusok",
"Fix" => "Javítás",
"No occurences found" => "Nem található előfordulás",
// "If you don't want to limit it, an input box will be displayed; otherwise, it will be checkbox" => "If you don't want to limit it, an input box will be displayed; otherwise, it will be checkbox",
"Twitter Settings" => "Twitter beállítások",
"To use Twitter integration, you must register this site as an application at" => "Twitter integrációhoz regisztrálni kell az oldalt mint alkalmazást itt:",
"and allow write access for the application" => "valamint írási jogot kell adni az alkalmazásnak",
// "Enter &lt;your site URL&gt;tiki-socialnetworks.php as callback URL" => "Enter &lt;your site URL&gt;tiki-socialnetworks.php as callback URL",
"Facebook Settings" => "Facebook beállítások",
"To use Facebook integration, you must register this site as an application at" => "Facebook integrációhoz regisztrálni kell az oldalt mint alkalmazást itt:",
"and allow extended access for the application" => "valamint kiterjesztett hozzáférést kell adni az alkalmazásnak",
// "Enter &lt;your site URL&gt;tiki-socialnetworks.php?request_facebook as Site URL and &lt;your site&gt; as Site Domain" => "Enter &lt;your site URL&gt;tiki-socialnetworks.php?request_facebook as Site URL and &lt;your site&gt; as Site Domain",
// "The following preferences affect what permissions the user is asked to allow Tiki to do by Facebook when authorizing it" => "The following preferences affect what permissions the user is asked to allow Tiki to do by Facebook when authorizing it",
"bit.ly Settings" => "bit.ly beállítások",
// "There is no need to set up a site-wide bit.ly account; every user can have his or her own, but this allows for site-wide statistics" => "There is no need to set up a site-wide bit.ly account; every user can have his or her own, but this allows for site-wide statistics",
"Go to" => "Ugrás",
"to sign up for an account" => "fiók létrehozásához",
"to retrieve the API key" => "az API kulcs lekérdezéséhez",
"Text area (that apply throughout many features)" => "Szöveges terület beállításait több funkció is használja",
"Wiki syntax" => "Wiki szintakszis",
"Default size" => "Alapértelmezett nézet",
"External links and images" => "Külső linkek és képek",
"External links will be identified with" => "Külső linkek azonosítója",
// "About plugins" => "About plugins",
// "Tiki plugins add functionality to wiki pages, articles, blogs, and so on. You can enable and disable them below" => "Tiki plugins add functionality to wiki pages, articles, blogs, and so on. You can enable and disable them below",
// "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>" => "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>",
// "The edit-plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below" => "The edit-plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below",
// "Check disabled plugins used in wiki pages" => "Check disabled plugins used in wiki pages",
// "Disabled used plugins" => "Disabled used plugins",
// "Plugin preferences" => "Plugin preferences",
"Edit plugin icons" => "Plugin szerkesztés ikonok",
// "Disable edit plugin icon (make plugin inline)" => "Disable edit plugin icon (make plugin inline)",
"Plugin Aliases" => "Plugin álnevek",
"About plugin aliases" => "Plugin álnevekről",
// "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}" => "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}",
// "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}" => "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}",
"Available Alias" => "Rendelkezésre álló alias",
"Enable Plugins" => "Pluginok bekapcsolása",
// "Delete Plugins" => "Delete Plugins",
// "Click on the plugin name to edit it" => "Click on the plugin name to edit it",
// "Click on the + icon to add a new one" => "Click on the + icon to add a new one",
"General Information" => "Általános információ",
"Plugin Name" => "Plugin neve",
"Base Plugin" => "Alap plugin",
"Name:" => "Név:",
"Description:" => "Leírás:",
"Body Label" => "Törzs címke",
"Dependencies" => "Függőségek",
"Inline (No Plugin Edit UI)" => "Szövegben (nincs plugin szerkesztési felület)",
"Simple Plugin Arguments" => "Egyszerű plugin argumentumok",
// "Argument" => "Argument",
"New Argument" => "Új argumentum",
"Plugin Parameter Documentation" => "Plugin paraméter dokumentáció",
"Required" => "Szükséges",
"Safe" => "Biztonságos",
"Plugin Body" => "Plugin törzs",
"Ignore User Input" => "Felhasználói bevitel ignorálása",
"Default Content" => "Alapértelmezett tartalom",
"Encoding" => "Kódolás",
// "Argument Source (if different)" => "Argument Source (if different)",
"Default Value" => "Alapértelmezett érték",
"Composed Plugin Arguments" => "Szerkesztett plugin argumentumok",
"Pattern" => "Minta",
// "To configure your trackers, select \"Trackers\" in the application menu, or" => "To configure your trackers, select \"Trackers\" in the application menu, or",
// "Tracker settings" => "Tracker settings",
"Tracker attachment preferences" => "Űrlap mellékletek beállítása",
"Use database to store files:" => "Fájlok tárolása adatbázisban:",
"Use a directory to store files:" => "Fájlok tárolása könytárban:",
"Path:" => "Útvonal:",
// "Field Types" => "Field Types",
"Tracker attachments" => "Űrlap mellékletek",
"dls" => "Letöltések",
// "Switch storage" => "Switch storage",
"Change all to db" => "Összes átváltása adatbázisba",
"Change all to file" => "Összes átváltása fájlba",
"Use database to store userfiles" => "Adatbázis használata a felhasználói fájlok tárolásához",
"Use a directory to store userfiles" => "Könyvtár használata a felhasználói fájlok tárolásához",
// "Kaltura" => "Kaltura",
"Kaltura Registration" => "Kaltura regisztráció",
// "To get a Kaltura Partner ID" => "To get a Kaltura Partner ID",
// "Setup your own instance of Kaltura Community Edition (CE)" => "Setup your own instance of Kaltura Community Edition (CE)",
// "get an account via Kaltura.com" => "get an account via Kaltura.com",
"List Media Entries" => "Média tételek listája",
"List Remix Entries" => "Remix tételek listája",
"Add New Media" => "Új média hozzáadása",
"Kaltura / Tiki config" => "Kaltura / Tiki configuráció",
// "Kaltura Partner Settings" => "Kaltura Partner Settings",
"Kaltura Dynamic Player" => "Kaltura Dinamikus lejátszó",
// "Kaltura Contribution Wizard" => "Kaltura Contribution Wizard",
"Kaltura Remix Editors" => "Kaltura Remix szerkesztők",
// "Ustream Watershed" => "Ustream Watershed",
// "Ustream Watershed Registration" => "Ustream Watershed Registration",
// "If you don't have a Watershed account, " => "If you don't have a Watershed account, ",
// "you can find out more about it here" => "you can find out more about it here",
// "Configuration within Watershed" => "Configuration within Watershed",
// "Set the webservice to point to tiki-watershed_service.php on your site, and turn on Authentication Lock" => "Set the webservice to point to tiki-watershed_service.php on your site, and turn on Authentication Lock",
"Watershed Wiki plugins" => "Watershed Wiki pluginok",
// "Use Wiki plugins WatershedBroadcaster, WatershedViewer and WatershedChat to embed your broadcaster, viewer or chat" => "Use Wiki plugins WatershedBroadcaster, WatershedViewer and WatershedChat to embed your broadcaster, viewer or chat",
// "Basic tracker settings" => "Basic tracker settings",
// "Information for each channel is stored in a tracker. Tracker item view/modify permissions will determine which channels users will be able to view or broadcast to respectively. You can find the Brand Id and Channel Code from the embed codes provided by Watershed, looking for the cid variable which will be \"brandId%2Fchannelcode\"" => "Information for each channel is stored in a tracker. Tracker item view/modify permissions will determine which channels users will be able to view or broadcast to respectively. You can find the Brand Id and Channel Code from the embed codes provided by Watershed, looking for the cid variable which will be \"brandId%2Fchannelcode\"",
"Archive settings" => "Archívum beállításai",
// "Information on archived clips are stored in a tracker. Tracker item view permissions will determine which archives users will be able to view. Note that recordings set to private in the broadcaster are not added to Tiki. Also, there is a delay for information to be received which could be quite long (30 min)" => "Information on archived clips are stored in a tracker. Tracker item view permissions will determine which archives users will be able to view. Note that recordings set to private in the broadcaster are not added to Tiki. Also, there is a delay for information to be received which could be quite long (30 min)",
// "Archive settings (optional)" => "Archive settings (optional)",
"Flash Media Encoder" => "Flash Média Encoder",
// "This is only needed if you are using Flash Media Encoder for higher-quality broadcasting which support only shared secret authentication" => "This is only needed if you are using Flash Media Encoder for higher-quality broadcasting which support only shared secret authentication",
"Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used" => "JSON-t vagy YAML-t visszaadó webes szolgáltatás URL-jét kell megadni. Paramétereket százalékjel közé zárva lehet megadni, de például: %name%. %service% és %template% foglalt kulcsszavak és nem szabad használni őket",
"URL:" => "URL:",
"Type:" => "Típus:",
// "Parameters (%name%)" => "Parameters (%name%)",
// "Operation" => "Operation",
"Lookup" => "Keresés",
// "{\$url} requires no parameter" => "{\$url} requires no parameter",
// "Test Input" => "Test Input",
// "Response Information" => "Response Information",
// "OIntegrate Version" => "OIntegrate Version",
// "Not supported" => "Not supported",
// "Schema Version" => "Schema Version",
// "Schema Documentation" => "Schema Documentation",
"Cache" => "Gyorsítótár",
// "Not specified, default used" => "Not specified, default used",
// "Content Type" => "Content Type",
// "Not specified" => "Not specified",
// "Returned Data" => "Returned Data",
// "Proposed Templates" => "Proposed Templates",
// "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters" => "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters",
"Register Service" => "Szolgáltatás regisztrálása",
"Registered Templates" => "Regisztrált sablonok",
// "Engine" => "Engine",
"Output" => "Kimenet",
"Register Template" => "Sablon regisztrálása",
// "The following pages were modified" => "The following pages were modified",
// "Nothing was changed (no images in wiki_up were found in Wiki pages)" => "Nothing was changed (no images in wiki_up were found in Wiki pages)",
// "Use the 'Quick Edit' module to easily create or edit wiki pages" => "Use the 'Quick Edit' module to easily create or edit wiki pages",
// "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules" => "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules",
"Page display" => "Oldal megjelenítés",
"Page version" => "Oldal verzió",
"List authors" => "Szerzők listázása",
"Allow override per page" => "Oldalanként változtatható",
"Minor edits do not flag new content for translation and do not send watch notifications (unless \"Watch minor edits\" is enabled)." => "Kisebb szerkesztések nem számítanak lefordítandó új tartalomnak és értesítés sem kerül kiküldésre (kivéve ha az erre vonatkozó preferencia be van állítva)",
"Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled." => "Csak a tiki_p_minor jogosultsággal rendelkező csoportok és az adminisztrátorok végezhetnek kisebb mentéseket a funkció bekapcsolásakor.",
// "If you change storage, it is better to move all the files for easy backup.." => "If you change storage, it is better to move all the files for easy backup..",
"Tag for current wiki" => "Címke a jelenlegi wikihez",
"Restore wiki to tag" => "Wiki címke visszaállítása",
"Restore" => "Visszaállítás",
"Remove a tag" => "Címke eltávolítása",
"Generate dump" => "Dump generálása",
"Download last dump" => "Legutóbbi dump letöltése",
"Remove unused pictures" => "Nem használt képek eltávolítása",
// "Move images from wiki_up to the home file gallery" => "Move images from wiki_up to the home file gallery",
// "If you use these buttons please make sure to have a backup of the database and the directory wiki_up" => "If you use these buttons please make sure to have a backup of the database and the directory wiki_up",
"Export Wiki Pages" => "Wiki oldalak exportálása",
"Wiki watch" => "Wiki figyelés",
// "Flagged Revision" => "Flagged Revision",
"Page Listings" => "Oldalak listázása",
"Configuration" => "Konfiguráció",
"Select which items to display when listing pages" => "Oldalak listázásakor megjelenítendő tételek kiválasztása",
// "Wiki 3D Browser Configuration" => "Wiki 3D Browser Configuration",
"Tools" => "Eszközök",
// "Mass search and replace" => "Mass search and replace",
"Wiki attachments" => "Wiki mellékletek",
"Change" => "Változás",
// "WYSIWYG means What You See Is What You Get, and is handled in Tiki by <a href=\"http://ckeditor.com/\">CKEditor</a>" => "WYSIWYG means What You See Is What You Get, and is handled in Tiki by <a href=\"http://ckeditor.com/\">CKEditor</a>",
"Page links" => "Oldal hivatkozások",
// "Note that if the SEFURL feature is on, page links created using wysiwyg might not be automatically updated when pages are renamed. This is planned to be addressed through the future \"Use Wiki syntax in WYSIWYG\" feature" => "Note that if the SEFURL feature is on, page links created using wysiwyg might not be automatically updated when pages are renamed. This is planned to be addressed through the future \"Use Wiki syntax in WYSIWYG\" feature",
"Wysiwyg Editor Features" => "WYSIWYG szerkesztő funkciói",
"Related features" => "Kapcsolódó funkciók",
// "{\$sect|capitalize}" => "{\$sect|capitalize}",
"Position" => "Pozíció",
// "Topbar" => "Topbar",
// "Page Top" => "Page Top",
// "Page Bottom" => "Page Bottom",
"Cache Time" => "Gyorsítótár idő",
"secs" => "másodperc",
"Use Ctrl+Click to select multiple options" => "Ctrl+kattintásra több lehetőség is kiválasztható",
// "The" => "The",
// "Display Modules to All Groups" => "Display Modules to All Groups",
// "setting will override your selection of specific groups" => "setting will override your selection of specific groups",
// "Visibility" => "Visibility",
// "Displayed now for all eligible users even with personal assigned modules" => "Displayed now for all eligible users even with personal assigned modules",
// "Displayed for the eligible users with no personal assigned modules" => "Displayed for the eligible users with no personal assigned modules",
// "Displayed now, can't be unassigned" => "Displayed now, can't be unassigned",
// "Not displayed until a user chooses it" => "Not displayed until a user chooses it",
// "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either" => "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either",
// "to make sure users will notice any newly assigned modules" => "to make sure users will notice any newly assigned modules",
"required" => "szükséges",
// "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y" => "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y",
// "Enter the parameters in URL format, e.g. 'nobox=y&class=rbox-data'" => "Enter the parameters in URL format, e.g. 'nobox=y&class=rbox-data'",
// "Edit custom module" => "Edit custom module",
// "Non Advanced Search or Natural Search" => "Non Advanced Search or Natural Search",
// "The documents are returned sorted on relevance depending on order, proximity, frequency of terms. " => "The documents are returned sorted on relevance depending on order, proximity, frequency of terms. ",
// "Advanced Search or Boolean Search" => "Advanced Search or Boolean Search",
// "Default search behavior" => "Default search behavior",
// "By default, all search terms are <em>optional</em>" => "By default, all search terms are <em>optional</em>",
// "It behaves like an OR logic" => "It behaves like an OR logic",
// "Objects that contain the more terms are rated higher in the results and will appear first in their type" => "Objects that contain the more terms are rated higher in the results and will appear first in their type",
// "For example, <strong>wiki forum</strong> will find" => "For example, <strong>wiki forum</strong> will find",
// "objects that include both terms" => "objects that include both terms",
// "objects that include the term <strong>wiki</strong>" => "objects that include the term <strong>wiki</strong>",
// "objects that include the term <strong>forum</strong>" => "objects that include the term <strong>forum</strong>",
// "Requiring terms" => "Requiring terms",
// "Add a plus sign ( + ) before a term to indicate that the term <em>must</em> appear in results" => "Add a plus sign ( + ) before a term to indicate that the term <em>must</em> appear in results",
// "Example: <strong>+wiki forum</strong> will find objects containing at least <strong>wiki</strong>. Objects with both terms and many occurences of the terms will appear first" => "Example: <strong>+wiki forum</strong> will find objects containing at least <strong>wiki</strong>. Objects with both terms and many occurences of the terms will appear first",
// "Excluding terms" => "Excluding terms",
// "Add a minus sign ( - ) before a term to indicate that the term <em>must not</em> appear in the results" => "Add a minus sign ( - ) before a term to indicate that the term <em>must not</em> appear in the results",
// "To reduce a term's value without completely excluding it, <a href=\"#reducing\" title=\"{tr}Reducing a term's value" => "To reduce a term's value without completely excluding it, <a href=\"#reducing\" title=\"{tr}Reducing a term's value",
// "Example: <strong>-wiki forum</strong> will find objects that do not contain <strong>wiki</strong> but contain <strong>forum</strong>" => "Example: <strong>-wiki forum</strong> will find objects that do not contain <strong>wiki</strong> but contain <strong>forum</strong>",
// "Grouping terms" => "Grouping terms",
// "Use parenthesis ( ) to group terms into subexpressions" => "Use parenthesis ( ) to group terms into subexpressions",
// "Example: <strong>+wiki +(forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order" => "Example: <strong>+wiki +(forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order",
// "Finding phrases" => "Finding phrases",
// "Use double quotes ( \" \" ) around a phrase to find terms in the exact order, exactly as typed" => "Use double quotes ( \" \" ) around a phrase to find terms in the exact order, exactly as typed",
// "Example: <strong>\"Alex Bell\"</strong> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong>. " => "Example: <strong>\"Alex Bell\"</strong> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong>. ",
// "Using wildcards" => "Using wildcards",
// "Add an asterisk ( * ) after a term to find objects that include the root word" => "Add an asterisk ( * ) after a term to find objects that include the root word",
// "For example, <strong>run*</strong> will find" => "For example, <strong>run*</strong> will find",
// "objects that include the term <strong>run</strong>" => "objects that include the term <strong>run</strong>",
// "objects that include the term <strong>runner</strong>" => "objects that include the term <strong>runner</strong>",
// "objects that include the term <strong>running</strong>" => "objects that include the term <strong>running</strong>",
// "Reducing a term's value" => "Reducing a term's value",
// "Add a tilde ( ~ ) before a term to reduce its value indicate to the ranking of the results" => "Add a tilde ( ~ ) before a term to reduce its value indicate to the ranking of the results",
// "Objects that contain the term will appear lower than other objects (unlike the <a href=\"#excluding\" title=\"{tr}Excluding terms" => "Objects that contain the term will appear lower than other objects (unlike the <a href=\"#excluding\" title=\"{tr}Excluding terms",
// "Example: <strong>+wiki ~forum</strong> will rate an object with only <strong>wiki</strong> higher that an object with <strong>wiki</strong> and  <strong>forum</strong>" => "Example: <strong>+wiki ~forum</strong> will rate an object with only <strong>wiki</strong> higher that an object with <strong>wiki</strong> and  <strong>forum</strong>",
// "Changing relevance value" => "Changing relevance value",
// "Add a less than ( &lt; ) or greater than ( &gt; ) sign before a term to change the term's contribution to the overall relevance value assigned to a object" => "Add a less than ( &lt; ) or greater than ( &gt; ) sign before a term to change the term's contribution to the overall relevance value assigned to a object",
// "Example: <strong>+wiki +(&gt;forum &lt; blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or <strong>wiki</strong> and <strong>blog</strong> in any order. <strong>wiki forum</strong> will be rated higher" => "Example: <strong>+wiki +(&gt;forum &lt; blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or <strong>wiki</strong> and <strong>blog</strong> in any order. <strong>wiki forum</strong> will be rated higher",
// "Anti-Bot verification code image" => "Anti-Bot verification code image",
"Enter the code you see above" => "Képen látható kód megadása",
"Try another code" => "Új kód kérése",
// "Expires At" => "Expires At",
"Rating:" => "Értékelés:",
"star" => "csillag",
"half star" => "fél csillag",
// "{\$topicName}" => "{\$topicName}",
// "List all articles of this same topic" => "List all articles of this same topic",
// "{\$topicName|escape}" => "{\$topicName|escape}",
// "{\$topics[\$topicId].name|escape}" => "{\$topics[\$topicId].name|escape}",
// "You do not have permission to read complete articles" => "You do not have permission to read complete articles",
"First page" => "Első oldal",
"Previous page" => "Előző oldal",
"page" => "oldal",
"Next page" => "Következő oldal",
"Last page" => "Utolsó oldal",
// "Related content" => "Related content",
"bytes" => "bájt",
// "Share page" => "Share page",
// "Share This" => "Share This",
// "ShareThis via AIM, social bookmarking and networking sites, etc" => "ShareThis via AIM, social bookmarking and networking sites, etc",
"Send a link" => "Link küldése",
"List of attached files" => "Mellékletek listája",
"desc" => "Leírás",
"uploaded" => "Feltöltés ideje",
"Upload file" => "Fájl feltöltése",
"Comment:" => "Komment:",
"Attach" => "Csatolás",
"Attach a file to this item" => "Fájl csatolása az űrlaptételhez",
// "{\$attfields[ix]}" => "{\$attfields[ix]}",
"more info" => "további információ",
"No attachments for this item" => "Nincsenek mellékletek csatolva ehhez a tételhez",
"debug" => "hibakereső",
"Fatal error" => "Hiba",
"Save to notepad" => "Mentés jegyzettömbbe",
"Published " => "Publikálta",
"on" => "Dátum",
"Previous post" => "Előző poszt",
"Next post" => "Következő poszt",
"Read more" => "Bővebben",
"More..." => "Több...",
"pages" => "oldal",
// "Permalink" => "Permalink",
"Leave a comment" => "Komment",
// "%0 comment" => "%0 comment",
// "%0 comments" => "%0 comments",
// "Parent Gallery" => "Parent Gallery",
"Properties" => "Tulajdonságok",
// "Click Here to Insert in Wiki Syntax" => "Click Here to Insert in Wiki Syntax",
"No records found" => "Nincs megjeleníthető rekord",
"Select Categories" => "Kategóriák kiválasztása",
"Admin Categories" => "Kategóriák beállítása",
"Select/deselect all categories" => "Összes kategória be/kijelölése",
"No categories defined" => "Nincsenek még létrehozva kategóriák",
"Browse Category" => "Kategóriák böngészése",
// "Are you sure you want to archive this comment" => "Are you sure you want to archive this comment",
// "Are you sure you want to unarchive this comment" => "Are you sure you want to unarchive this comment",
// "Return" => "Return",
"Title:" => "Cím:",
// "Do you really want to lock comments" => "Do you really want to lock comments",
"Lock" => "Zárolás",
// "Do you really want to unlock comments" => "Do you really want to unlock comments",
"Unlock" => "Feloldás",
// "Are you sure you want to remove this comment" => "Are you sure you want to remove this comment",
"Unarchive" => "Visszaállítás archívumból",
// "Are you sure you want to approve this comment" => "Are you sure you want to approve this comment",
"Approve" => "Jóváhagyás",
// "Are you sure you want to reject this comment" => "Are you sure you want to reject this comment",
"Reject" => "Elutasítás",
// "Comment posted by %0 on %1" => "Comment posted by %0 on %1",
"Reply" => "Válasz",
// "No comments" => "No comments",
// "There are no comments at this time" => "There are no comments at this time",
"Post new comment" => "Új komment küldése",
"Add Comment" => "Kommentek",
// "Are you sure you want to lock comments on this object" => "Are you sure you want to lock comments on this object",
// "Your comment was posted" => "Your comment was posted",
// "Identity" => "Identity",
// "You are currently registered on this site. This section is <strong>optional</strong>. By filling it, you will not link this post to your account and preserve your anonymity" => "You are currently registered on this site. This section is <strong>optional</strong>. By filling it, you will not link this post to your account and preserve your anonymity",
// "Pseudonym" => "Pseudonym",
"Email:" => "E-mail:",
// "Website" => "Website",
// "Are you sure you want to unlock comments on this object" => "Are you sure you want to unlock comments on this object",
"Posted by" => "Szerző",
"posts:" => "posztok száma:",
"stars" => "csillagok",
"User Level" => "Felhasználói szint",
"private message" => "privát üzenet",
"Send eMail to User" => "E-mail küldése felhasználónak",
"user online" => "felhasználó online",
"user offline" => "felhasználó offline",
// "top of page" => "top of page",
// "Report this post" => "Report this post",
"Monitor this Topic" => "Téma figyelése",
"Stop Monitoring this Topic" => "Téma figyelésének felfüggesztése",
"Group Monitor" => "Csoport figyelés",
// "Watched by categories" => "Watched by categories",
"Moderator actions" => "Moderátori akciók",
"reported:" => "jelentve:",
"queued:" => "sorban áll:",
"Move to topic:" => "Mozgatás ebbe a témába:",
"Delete Selected" => "Kijelöltek törlése",
"Sort:" => "Rendezési elv:",
"Threshold" => "Küszöb",
"Replies" => "Válaszok",
"below your current threshold" => "küszöbérték alatt van",
"New Reply" => "Új válasz",
"Editing reply" => "Válasz szerkesztése",
// "Reply to the selected post" => "Reply to the selected post",
"Post new message" => "Új üzenet küldése",
// "If you would like to be notified when someone replies to this topic<br />please tell us your e-mail address" => "If you would like to be notified when someone replies to this topic<br />please tell us your e-mail address",
// "Send me an e-mail when someone replies" => "Send me an e-mail when someone replies",
"Maximum size" => "Maximális méret",
// "Reply to parent post" => "Reply to parent post",
"Post new reply" => "Új válasz küldése",
// "Post as Anonymous" => "Post as Anonymous",
// "Please note that the preview does not keep the attached file which you will have to choose before posting" => "Please note that the preview does not keep the attached file which you will have to choose before posting",
"Posting replies" => " Általános tudnivalók",
// "Please enter a title" => "Please enter a title",
"1 comment" => "1 komment",
"Go back" => "Vissza",
"Return to home page" => "Vissza a kezdőlaphoz",
"Type of contribution:" => "Hozzájárulás típusa:",
"Copyrights" => "Szerzői jogok",
"Year:" => "Év:",
"Authors:" => "Szerzők:",
// "System error" => "System error",
// "Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue" => "Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue",
"If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation:" => "Ha van Shell (SSH) hozzáférés, akkor lehet használni az alábbiakat is a parancssorból a Tiki telepítés root könyvtárából:",
// "The query was" => "The query was",
// "The built query was likely" => "The built query was likely",
// "Stacktrace" => "Stacktrace",
// "Tiki is unable to connect to the database" => "Tiki is unable to connect to the database",
// "An error occurred while performing the request" => "An error occurred while performing the request",
"Current URL" => "Jelenlegi URL",
"Command" => "Parancs",
// "exec" => "exec",
"Type <code>help</code> to get list of available commands" => "Írd be <code>help</code> a rendelkezésre álló parancsok listázásához",
// "Syntax" => "Syntax",
// "Page generation debugging log" => "Page generation debugging log",
// "Features state" => "Features state",
"Total" => "Összesen",
// "features matched" => "features matched",
// "Watchlist" => "Watchlist",
"Duplicate File Gallery" => "Fájlgaléria duplikálása",
"File gallery:" => "Fájlgaléria:",
"Duplicate categories" => "Kategóriák duplikálása",
// "Duplicate permissions" => "Duplicate permissions",
"Duplicate" => "Duplikálás",
// "There are individual permissions set for this file gallery" => "There are individual permissions set for this file gallery",
"View inserted gallery" => "Létrehozott galéria megtekintése",
// "{\$gal_info.name}" => "{\$gal_info.name}",
"System" => "Rendszer",
// "Other (%0)" => "Other (%0)",
"Any file" => "Bármilyen fájl",
// "Podcast (audio)" => "Podcast (audio)",
"Podcast (video)" => "Podcast (videó)",
"Gallery is visible to non-admin users" => "Galériát láthatják nem adminisztrátor felhasználók is",
"Gallery is public" => "A galéria publikus",
"Any user with permission (not only the gallery owner) can upload files" => "A megfelelő jogosultságokkal rendelkező bármely felhasználó tölthet fel fájlokat (tehát nem csak a galéria adminisztrátora)",
"Perms of the backlinks are checked to view a file" => "Visszahivatkozási linkekhez tartozó jogosultságok ellenőrzése fájl megtekintéséhez",
"Files can be locked at download" => "Fájlokat zárolni lehet letöltéskor",
"Maximum number of archives for each file" => "Archívumok maximális száma fájlonként",
"Use" => "Használat",
"unlimited" => "nincs korlát",
"Parent gallery" => "Szülő (felettes) galéria",
"Owner of the gallery" => "Galéria tulajdonosa",
// "Min" => "Min",
"Group of users alerted when file gallery is modified" => "Galéria módosításakor értesítendő felhasználói csoport",
"Allows to select each user for small groups" => "Kisebb csoportok esetén az egyes felhasználók kiválasztása",
"Maximum width for images in gallery" => "Képek maximális szélessége",
"If an image is wider than this, it will be resized." => "Ha egy kép ennél az értéknél szélesebb, akkor átméretezésre kerül",
"Attention: In this case, the original image will be lost." => "Figyelem: ebben az esetben a kép  eredeti tulajdonságai elvesznek",
"Maximum height for images in gallery" => "Képek maximális magassága",
"If an image is higher than this, it will be resized." => "Ha egy kép ennél az értéknél magasabb, akkor átméretezésre kerül",
"Wiki markup to enter when image selected from \"file gallery manager\"" => "Megadandó Wiki mark-up kép fájlgaléria menedzser funkción keresztüli kiválasztásakor",
"The default is " => "Alapértelmezés: ",
// "Field names will be replaced when enclosed in % chars. e.g. %fileId%, %name%, %filename%, %description%" => "Field names will be replaced when enclosed in % chars. e.g. %fileId%, %name%, %filename%, %description%",
"Display Properties" => "Tulajdonságok megjelenítése",
"Max description display size" => "Leírás megjelenítésének maximális hossza",
"Max rows per page" => "Sorok maximális száma oldalanként",
"Select which items to display when listing galleries" => "Fájlgaléria elemeinek listázásakor megjelenítendő adatok",
// "File error" => "File error",
"Perhaps you are looking for:" => "Hasonló oldalak:",
// "There are no wiki pages similar to '{\$page|escape}'" => "There are no wiki pages similar to '{\$page|escape}'",
// "Token Error" => "Token Error",
"You are not logged in." => "Be kell jelentkezni",
"Go to Log in Page" => "Ugrás a bejelentkezési oldalra",
// "Change them here" => "Change them here",
"Create this page" => "Oldal létrehozása",
"(page will be orphaned)" => "(árva oldalként)",
"Close Window" => "Ablak bezárása",
// "Attached files" => "Attached files",
"Private Gallery" => "Privát galéria",
// "Active Perms" => "Active Perms",
"Perms" => "Jogosultságok",
"Open as WebFolder" => "Megnyitás Webmappaként",
// "Edit: " => "Edit: ",
// "Download current version" => "Download current version",
"Archives" => "Archivumok",
// "Upload New Version" => "Upload New Version",
// "Replace your draft" => "Replace your draft",
// "Upload your draft" => "Upload your draft",
// "Validate your draft" => "Validate your draft",
// "Delete your draft" => "Delete your draft",
// "Download and lock" => "Download and lock",
// "Open your draft in WebDAV" => "Open your draft in WebDAV",
// "Open in WebDAV" => "Open in WebDAV",
// "Share a link to this file" => "Share a link to this file",
// "Email a link to this file" => "Email a link to this file",
// "Enter the ID of any file in any gallery to be used as the icon for this gallery in browse view" => "Enter the ID of any file in any gallery to be used as the icon for this gallery in browse view",
"The checkbox is disabled because this preference is disabled globally." => "A jelölőnégyzet nincs bekapcsolva mivel a ez a preferencia globálisan ki van kapcsolva",
"Please, enable the preference globally first." => "Először a globális preferenciát kell bekapcsolni",
// "You can ask your site Admin to enable the preference" => "You can ask your site Admin to enable the preference",
"Name-filename" => "Név-fájlnév",
"Filename only" => "Csak fájlnév",
"Show as a column" => "Megjelenítés oszlopként",
"Show in popup box" => "Megjelenítés felugró dobozban",
"Show an icon in a column" => "Ikon megjelenítése oszlopban",
// "Upload from URL" => "Upload from URL",
// "File added" => "File added",
// "{\$file_backlinks_title}" => "{\$file_backlinks_title}",
// "Start the Slideshow" => "Start the Slideshow",
// "Pause the Slideshow" => "Pause the Slideshow",
// "There are no images to display" => "There are no images to display",
// "Search Help" => "Search Help",
// "Any" => "Any",
// "Deep search" => "Deep search",
"Tags" => "Címkék",
// "Select Tags" => "Select Tags",
// "Include objects without a specified language" => "Include objects without a specified language",
// "Add to filter" => "Add to filter",
// "{\$whatlabel}" => "{\$whatlabel}",
// "Find in" => "Find in",
"Exact match" => "Pontos egyezés",
"and all the sub-objects" => "és az összes al-objektum",
"any type" => "bármely típus",
// "any topic" => "any topic",
"any language" => "bármely nyelv",
"not in" => "de nem",
"any category" => "bármely kategória",
"Multiple select" => "Többszörös kijelölés",
"in:" => "itt:",
// "{\$value}" => "{\$value}",
// "{\$duration.label}" => "{\$duration.label}",
// "Orphans" => "Orphans",
// "{\$find_other}" => "{\$find_other}",
"Number of displayed rows" => "Megjelenített sorok száma",
// "Clear Filter" => "Clear Filter",
"Map View" => "Térkép nézet",
// "Show php error messages" => "Show php error messages",
"Folksonomy Tags" => "Címkézés",
"Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes." => "A címkéket szóköz elválasztással kell megadni. A több szóból álló címkéket szóköz nélkül egybeírva vagy idézőjelbe (\") kell rakni.",
"Folksonomy Language" => "Nyelv",
// "Untag" => "Untag",
// "Translate tags" => "Translate tags",
// "Images Galleries" => "Images Galleries",
"Edit this page" => "Szerkesztés",
// "RSS Wiki" => "RSS Wiki",
// "RSS Blogs" => "RSS Blogs",
// "RSS Articles" => "RSS Articles",
// "RSS Image Galleries" => "RSS Image Galleries",
// "RSS File Galleries" => "RSS File Galleries",
// "RSS Forums" => "RSS Forums",
// "RSS Maps" => "RSS Maps",
// "RSS Directories" => "RSS Directories",
// "RSS Calendars" => "RSS Calendars",
// "RSS Tracker" => "RSS Tracker",
"Interactive Translation" => "Interaktív fordítás",
"Once checked, click on any string to translate it." => "Bejelölés után kattintani kell a kiszemelt szövegdarabra",
// "Couldn't find any translatable string" => "Couldn't find any translatable string",
"Save translations" => "Fordítás mentése",
"Changes will be applied on next page load only." => "A változások csak az oldal újboli betöltése után lesznek láthatóak.",
"Show Tree" => "Fastruktúra megjelenítése",
"Hide Tree" => "Fastruktúra elrejtése",
"Perform action with checked:" => "Akció végrehajtása a kijelöltekkel:",
"Move Selected Files" => "A kijelölt fájlok mozgatása",
// "Are you sure you want to delete the selected files" => "Are you sure you want to delete the selected files",
// "Are you sure you want to reset the default gallery list table settings" => "Are you sure you want to reset the default gallery list table settings",
// "Reset to default gallery list table settings" => "Reset to default gallery list table settings",
"Download the zip" => "Zip fájl letöltése",
// "Assign permissions to file galleries" => "Assign permissions to file galleries",
"Move to" => "Mozgatás ide",
"Other Sorts" => "Egyéb rendezések",
// "No Additional Sort" => "No Additional Sort",
"No information" => "Nincs információ",
// "Hi {\$mail_user|username} has sent you this link" => "Hi {\$mail_user|username} has sent you this link",
// "Gift Certificate Information" => "Gift Certificate Information",
// "Percentage Discount" => "Percentage Discount",
// "Value of Gift Certificate" => "Value of Gift Certificate",
// "Redeem Code" => "Redeem Code",
// "Your Gift Certificate Purchase" => "Your Gift Certificate Purchase",
// "Your cart order has been received. Please note that orders are not finalized until payment has been made" => "Your cart order has been received. Please note that orders are not finalized until payment has been made",
// "You can review your order at" => "You can review your order at",
// "Your cart order" => "Your cart order",
// "Somebody or you tried to subscribe this email address at our site" => "Somebody or you tried to subscribe this email address at our site",
// "To the newsletter" => "To the newsletter",
// "In order to confirm your subscription you must access the following URL" => "In order to confirm your subscription you must access the following URL",
// "To validate your account and login to the site, please click on the following link" => "To validate your account and login to the site, please click on the following link",
// "The administrator approved your account" => "The administrator approved your account",
// "Confirm your email at %s" => "Confirm your email at %s",
// "Remove file" => "Remove file",
// "GalleryId" => "GalleryId",
// "Identifier" => "Identifier",
"Creator:" => "Létrehozó:",
"User:" => "Felhasználó:",
// "A new message was posted to forum" => "A new message was posted to forum",
"New topic:" => "Új téma:",
// "An anonymous user" => "An anonymous user",
// "has posted a reply to a thread you're watching. \nYou can view the thread and reply at the following URL" => "has posted a reply to a thread you're watching. \nYou can view the thread and reply at the following URL",
// "You are invited by" => "You are invited by",
// "You join this group" => "You join this group",
// "Join me on %s" => "Join me on %s",
// "You sent a request with the subject" => "You sent a request with the subject",
// "Use the subject to indicate the operation to apply" => "Use the subject to indicate the operation to apply",
// "GET:WikiName to get a wiki page" => "GET:WikiName to get a wiki page",
// "PUT:WikiName to update/create a wiki page (use the body for the page data)" => "PUT:WikiName to update/create a wiki page (use the body for the page data)",
// "APPEND:WikiName to append data to a Wiki page (use the body for the data to add)" => "APPEND:WikiName to append data to a Wiki page (use the body for the data to add)",
// "PREPEND:WikiName to append the data at the top" => "PREPEND:WikiName to append the data at the top",
// "Tiki mail-in instructions" => "Tiki mail-in instructions",
// "Tiki mail-in auto-reply" => "Tiki mail-in auto-reply",
// "A new message was posted to you at {\$mail_machine}" => "A new message was posted to you at {\$mail_machine}",
// "New message arrived from %s" => "New message arrived from %s",
// "Hi" => "Hi",
// "Your account registration request for {\$mail_site} was validated by the site admin and your account is active now" => "Your account registration request for {\$mail_site} was validated by the site admin and your account is active now",
// "To login with your username and password, please follow this link" => "To login with your username and password, please follow this link",
// "Enjoy the site" => "Enjoy the site",
// "User Account Activated" => "User Account Activated",
// "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first" => "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first",
// "has requested an account on" => "has requested an account on",
"Group:" => "Csoport:",
// "User Tracker" => "User Tracker",
// "To validate that account, please follow the link" => "To validate that account, please follow the link",
// "Assign to a group" => "Assign to a group",
// "View user's data" => "View user's data",
// "Best regards" => "Best regards",
// "User Registration Request" => "User Registration Request",
// "Go to your friendship network to accept or refuse this request" => "Go to your friendship network to accept or refuse this request",
// "You're invited to join my network of friends" => "You're invited to join my network of friends",
// "The user" => "The user",
// "registered at your site" => "registered at your site",
"New user registration" => "Új felhasználói regisztrációk",
"Published" => "Publikálva",
"By:" => "Szerző:",
// "Bye bye" => "Bye bye",
// "This email address has been removed to the list of subscriptors of" => "This email address has been removed to the list of subscriptors of",
"Newsletter:" => "Hírlevél:",
// "Bye bye from %s at %s" => "Bye bye from %s at %s",
// "You can unsubscribe from this newsletter following this link" => "You can unsubscribe from this newsletter following this link",
// "Welcome to our newsletter" => "Welcome to our newsletter",
// "This email address has been added to the list of subscriptors of" => "This email address has been added to the list of subscriptors of",
// "You can always cancel your subscription using" => "You can always cancel your subscription using",
// "Welcome to %s at %s" => "Welcome to %s at %s",
// "Reply notification" => "Reply notification",
"Email notification" => "Tiki E-mail értesítés",
// "Someone" => "Someone",
// "requested a reminder of the password for your account" => "requested a reminder of the password for your account",
// "requested password reset for your account" => "requested password reset for your account",
// "Since this is your registered email address we inform that the password for this account is" => "Since this is your registered email address we inform that the password for this account is",
// "Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else" => "Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else",
// "Important: Username & password are CaSe SenSitiVe" => "Important: Username & password are CaSe SenSitiVe",
// "Important: The old password remains active if you don't click the link above" => "Important: The old password remains active if you don't click the link above",
// "Your account information for %s" => "Your account information for %s",
// "}Plugin %0 is pending approval on %1" => "}Plugin %0 is pending approval on %1",
// "tiki-plugins.php\"}See all the pending plugins in the <a href='%0'>plugin approval page</a>" => "tiki-plugins.php\"}See all the pending plugins in the <a href='%0'>plugin approval page</a>",
// "Plugin arguments" => "Plugin arguments",
// "Plugin body" => "Plugin body",
// "Report for %0" => "Report for %0",
// "Last Report sent on %0" => "Last Report sent on %0",
// "Changes in detail" => "Changes in detail",
// "You are receiving notification emails grouped in a periodic digest. To receive them individually when posted instead, change your preferences at %0" => "You are receiving notification emails grouped in a periodic digest. To receive them individually when posted instead, change your preferences at %0",
// "Look at this link" => "Look at this link",
// "A friend sends you a link from: " => "A friend sends you a link from: ",
// "A new article was submitted by {\$mail_user|username} to {\$mail_site} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "A new article was submitted by {\$mail_user|username} to {\$mail_site} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "You can edit the submission following this link" => "You can edit the submission following this link",
"Heading:" => "Fejléc:",
"Body:" => "Törzs:",
// "New article submitted at %s" => "New article submitted at %s",
// "ItemID {\$mail_itemId} {\$mail_item_desc} was deleted in the tracker {\$mail_trackerName}" => "ItemID {\$mail_itemId} {\$mail_item_desc} was deleted in the tracker {\$mail_trackerName}",
// "New status for ItemID {\$mail_itemId} {\$mail_item_desc} for the tracker {\$mail_trackerName}" => "New status for ItemID {\$mail_itemId} {\$mail_item_desc} for the tracker {\$mail_trackerName}",
// "Download the file at" => "Download the file at",
// "item" => "item",
// "was modified at" => "was modified at",
// "Please visit this link before login again" => "Please visit this link before login again",
// "Last attempt" => "Last attempt",
"Password:" => "Jelszó:",
// "Confirm your account at %s" => "Confirm your account at %s",
"Site" => "Oldal",
// "Account suspended" => "Account suspended",
// "An administrator of the site below has added you as a new user" => "An administrator of the site below has added you as a new user",
// "If you want to confirm your membership in this site, click on the following link to login for the first time" => "If you want to confirm your membership in this site, click on the following link to login for the first time",
// "Your authentication credentials are" => "Your authentication credentials are",
// "Welcome to the site" => "Welcome to the site",
// "Your personal access to" => "Your personal access to",
// "joined the group" => "joined the group",
// "User joined group" => "User joined group",
// "You or someone registered this email address at" => "You or someone registered this email address at",
// "If you want to be a registered user in this site you will have to use the following link to login for the first time" => "If you want to be a registered user in this site you will have to use the following link to login for the first time",
// "Your registration confirmation" => "Your registration confirmation",
// "You will receive an email with the information needed to log into this site the first time" => "You will receive an email with the information needed to log into this site the first time",
// "Your account request has been stored and will be activated by the admin as soon as possible" => "Your account request has been stored and will be activated by the admin as soon as possible",
// "You'll receive email notification once your account is activated" => "You'll receive email notification once your account is activated",
// "Please do not attempt to login until you receive the email notification" => "Please do not attempt to login until you receive the email notification",
// "{\$mail_action} article post" => "{\$mail_action} article post",
// "{\$mail_title} by {\$mail_user|username} at" => "{\$mail_title} by {\$mail_user|username} at",
// "View the article at" => "View the article at",
// "If you don't want to receive these notifications follow this link" => "If you don't want to receive these notifications follow this link",
"Publish Date" => "Publikálás dátuma",
"Expiration Date" => "Lejárat dátuma",
// "The old article follows" => "The old article follows",
// "{\$mail_action}" => "{\$mail_action}",
// "article post at" => "article post at",
// "New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "View the blog at" => "View the blog at",
// "New blog post at %s" => "New blog post at %s",
// "View item calendar at" => "View item calendar at",
// "Modified calendar item" => "Modified calendar item",
// "New calendar item" => "New calendar item",
// "changed" => "changed",
// "A new category was created in" => "A new category was created in",
"Created by" => "Létrehozó",
"created" => "létrehozva",
// "A category was removed in" => "A category was removed in",
// "Removed by" => "Removed by",
// "removed" => "removed",
// "A category was updated" => "A category was updated",
// "Updated by" => "Updated by",
"Old" => "Régi",
// "updated" => "updated",
// "The Wiki page {\$mail_objectname} was commented on by" => "The Wiki page {\$mail_objectname} was commented on by",
"an anonymous user" => "egy anonim felhasználó",
// "The article {\$mail_objectname} was commented on by" => "The article {\$mail_objectname} was commented on by",
// "The tracker item {\$mail_item_title} of tracker {\$mail_objectname} was commented on by" => "The tracker item {\$mail_item_title} of tracker {\$mail_objectname} was commented on by",
// "You can view the comment by following this link" => "You can view the comment by following this link",
// "File Gallery %s changed" => "File Gallery %s changed",
// "A file was removed from the file gallery" => "A file was removed from the file gallery",
// "A new file was posted to file gallery" => "A new file was posted to file gallery",
"File Description" => "Fájl leírása",
// "New forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "New forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}",
// "New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}",
// "Image Gallery {\$galleryName} changed" => "Image Gallery {\$galleryName} changed",
// "A new file was posted to image gallery" => "A new file was posted to image gallery",
// "The map {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The map {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "You can view the updated map following this link" => "You can view the updated map following this link",
// "You can edit the map following this link" => "You can edit the map following this link",
"An object was added to category" => "Egy objektum hozzáadásra került a kategóriához",
"Added by" => "Hozzáadta:",
"An object was removed from category" => "Egy objektum eltávolításra került a kategóriából",
// "A page has been added to your watched sub-structure" => "A page has been added to your watched sub-structure",
// "A page has been removed from your watched sub-structure" => "A page has been removed from your watched sub-structure",
// "A page has been promoted out your watched sub-structure" => "A page has been promoted out your watched sub-structure",
// "A page has been demoted to your watched structure" => "A page has been demoted to your watched structure",
"Structure modified" => "Struktúraváltozás",
// "has consulted your" => "has consulted your",
// "Go to the File Gallery" => "Go to the File Gallery",
// "Download the file" => "Download the file",
"A new file have been attached to page" => "Új fájl lett csatolva az oldalhoz",
"File name" => "Fájlnév",
"New attachment on %s, page" => "Új melléklet, %s, oldal:",
// "The page {\$mail_page} was created by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The page {\$mail_page} was created by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "The page {\$mail_page} was deleted by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The page {\$mail_page} was deleted by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "A file was attached to {\$mail_page}" => "A file was attached to {\$mail_page}",
// "The page {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The page {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "The page {\$mail_page} was deleted but used to be here" => "The page {\$mail_page} was deleted but used to be here",
// "You can view the page by following this link" => "You can view the page by following this link",
// "You can view a diff back to the previous version by following this link" => "You can view a diff back to the previous version by following this link",
// "The changes in this version follow below, followed after by the current full page text" => "The changes in this version follow below, followed after by the current full page text",
// "-Lines: {\$oldd} changed to +Lines: {\$newd}" => "-Lines: {\$oldd} changed to +Lines: {\$newd}",
// "The old page content follows below" => "The old page content follows below",
"The new page content follows below." => "Az oldal új tartalma az alábbiakban található:",
// "Wiki page %s created by {\$mail_user|username}" => "Wiki page %s created by {\$mail_user|username}",
// "Wiki page %s deleted by {\$mail_user|username}" => "Wiki page %s deleted by {\$mail_user|username}",
// "A file was attached to %s" => "A file was attached to %s",
// "Wiki page %s changed by {\$mail_user|username}" => "Wiki page %s changed by {\$mail_user|username}",
"Wiki page renamed" => "Wiki oldal átnevezve",
"Old name" => "Régi név",
"New name" => "Új név",
"Thank you for your registration." => "Köszönjük a regisztrálást.",
"You may log in now." => "Mostmár be lehet jelentkezni.",
// "click on the map to zoom or pan, do not drag" => "click on the map to zoom or pan, do not drag",
// "Query Results" => "Query Results",
// "Querying" => "Querying",
// "Scroll Up" => "Scroll Up",
// "Scroll Down" => "Scroll Down",
// "Scale" => "Scale",
// "Zoom out" => "Zoom out",
// "Query" => "Query",
// "Pan" => "Pan",
// "Zoom in" => "Zoom in",
// "Redraw" => "Redraw",
// "select zoom/pan/query and image size" => "select zoom/pan/query and image size",
// "View the Map Only" => "View the Map Only",
// "Reset Map" => "Reset Map",
// "Click on the map or click redraw" => "Click on the map or click redraw",
// "Overview" => "Overview",
"Legend" => "Rövidítések értelmezése",
// "Layer Manager" => "Layer Manager",
// "Layer" => "Layer",
// "{\$my_layers[j]->group}" => "{\$my_layers[j]->group}",
// "{\$layer_wiki[i]}" => "{\$layer_wiki[i]}",
// "{\$layer_wiki[j]}" => "{\$layer_wiki[j]}",
// "Download Layer" => "Download Layer",
// "This layer has been set by the maps administrator to not be downloadable" => "This layer has been set by the maps administrator to not be downloadable",
// "you have requested to download the layer" => "you have requested to download the layer",
// "from the mapfile" => "from the mapfile",
// "Here are the files to download, do not forget to rename them" => "Here are the files to download, do not forget to rename them",
"Mapfiles" => "Térkép fájlok",
// "Mapfile" => "Mapfile",
"Available mapfiles" => "Jelenlegi térképfájlok",
// "hits last 7 days" => "hits last 7 days",
// "monitor this map" => "monitor this map",
// "Stop Monitoring this Map" => "Stop Monitoring this Map",
// "Create a new mapfile" => "Create a new mapfile",
// "Mapfile listing" => "Mapfile listing",
"Reload" => "Újratöltés",
// "You can view this map in your browser using" => "You can view this map in your browser using",
// "Zoom out x2" => "Zoom out x2",
// "Zoom in x2" => "Zoom in x2",
// "Mapfile History" => "Mapfile History",
"of" => " ",
"Compare" => "Összehasonlítás",
// "Comparing version {\$old.version} with version {\$new.version}" => "Comparing version {\$old.version} with version {\$new.version}",
"Current" => "Jelenlegi",
"Versions are identical" => "A verziók megegyeznek!",
"v=view" => "v=view (megtekintés)",
"c=compare" => "c=compare (összehasonlítás)",
"d=diff" => "d=diff (eltérés)",
"Ip" => "IP",
"Diff" => "Eltérések",
"Older Version" => "Régebbi verzió",
// "{\$dir}" => "{\$dir}",
"Directories" => "Könyvtárak",
// "back to" => "back to",
"Upload From Disk" => "Feltöltés lemezről",
"Upload Files" => "Fájlok feltöltése",
// "Bytes maximum" => "Bytes maximum",
"Create Directory" => "Könyvtár létrehozása",
// "index file (.shp)" => "index file (.shp)",
// "files to index (regexp)" => "files to index (regexp)",
// "Message Archive" => "Message Archive",
"messages" => "üzenetek",
"Archive is full" => "Az archívum megtelt",
"Read" => "Olvasás",
"Unread" => "Nem olvasott",
"Flagged" => "Jelölt",
"Unflagged" => "Nem jelölt",
"Containing" => "Tartalmazza",
"Sender" => "Feladó",
"No messages to display" => "Nincs megjeleníthető üzenet",
"Broadcast message" => "Körüzenet",
// "Confirmation" => "Confirmation",
// "Please Confirm" => "Please Confirm",
"All users" => "Összes felhasználó",
"Lowest" => "Legalacsonyabb",
"Very High" => "Legmagasabb",
"Subject:" => "Tárgy:",
"Send" => "Küldés",
"Compose message" => "Üzenet írása",
// "If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences" => "If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences",
"ERROR" => "HIBA",
"Invalid" => "Invalid",
// "To: Multiple addresses can be separated with semicolons (\";\") or commas (\",\")" => "To: Multiple addresses can be separated with semicolons (\";\") or commas (\",\")",
"CC" => "CC",
// "CC: Multiple addresses can be separated with semicolons (\";\") or commas (\",\")" => "CC: Multiple addresses can be separated with semicolons (\";\") or commas (\",\")",
"BCC" => "BCC",
// "BCC: Multiple addresses can be separated with semicolons (\";\") or commas (\",\")" => "BCC: Multiple addresses can be separated with semicolons (\";\") or commas (\",\")",
"Reply-to my email" => "Válasz E-mail",
// "The user will be able to reply to you directly via email" => "The user will be able to reply to you directly via email",
"Send me a copy" => "Küldj nekem másolatot",
// "You will be sent a copy of this email" => "You will be sent a copy of this email",
"No messages to download" => "Nincs letölthető üzenet",
"Mailbox is full! Delete or archive some messages if you want to receive more messages" => "A postafiók megtelt! Törölni vagy archiválni kéne hogy legyen hely új üzeneteknek",
// "is reply to" => "is reply to",
// "Find replied message" => "Find replied message",
"Mark as read" => "Olvasottként jelöl",
"Mark as unread" => "Olvasatlanként jelöl",
"Mark as flagged" => "Flagged-ként jelöl",
"Mark as unflagged" => "Unflagged-ként jelöl",
"Mark" => "Megjelöl",
"Mailbox" => "Postaláda",
"Compose" => "Levélírás",
"Broadcast" => "Körüzenet",
// "Auto-archive age for read messages" => "Auto-archive age for read messages",
"Read message" => "Üzenet olvasása",
// "Return to mailbox" => "Return to mailbox",
"replyall" => "válasz mindenkinek",
// "Unflag" => "Unflag",
"Flag this message" => "Üzenet megjelölése",
// "Cc" => "Cc",
// "Return to archive" => "Return to archive",
// "Return to outbox" => "Return to outbox",
// "Sent Messages" => "Sent Messages",
"Replied" => "Megválaszolás",
// "Not replied" => "Not replied",
// "move to archive" => "move to archive",
// "receiver" => "receiver",
// "Move module up" => "Move module up",
// "Move module down" => "Move module down",
// "Move module to opposite side" => "Move module to opposite side",
// "opp side" => "opp side",
// "Unassign this module" => "Unassign this module",
// "Are you sure you want to unassign this module" => "Are you sure you want to unassign this module",
// "Toggle module contents" => "Toggle module contents",
"toggle" => "előhívás",
// "Toggle Vertically" => "Toggle Vertically",
// "Display type unknown, you have to enter the banner type" => "Display type unknown, you have to enter the banner type",
// "You forgot your Google ad_client number " => "You forgot your Google ad_client number ",
// "To configure your Tiki" => "To configure your Tiki",
"Admin Home" => "Adminisztrációs központ",
// "from the menu" => "from the menu",
// "Read the <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Tiki Documentation\" target=\"_blank\">configuration documentation</a>" => "Read the <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Tiki Documentation\" target=\"_blank\">configuration documentation</a>",
// "Watch the <a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies" => "Watch the <a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies",
// "To remove this module" => "To remove this module",
"Admin Modules" => "Modulok adminisztrálása",
// "and remove the assistant module" => "and remove the assistant module",
// "You can also add other modules" => "You can also add other modules",
// "To customize the menu" => "To customize the menu",
"Admin Menus" => "Menü karbantartás",
// "and edit menu ID 42" => "and edit menu ID 42",
// "Or, create your own menu and add it to a module" => "Or, create your own menu and add it to a module",
// "Login" => "Login",
// "To begin configuring Tiki, please" => "To begin configuring Tiki, please",
"login" => "bejelentkezés",
// "as admin" => "as admin",
// "The Tiki Community" => "The Tiki Community",
// "To learn more, visit: <a href=\"http://tiki.org\" title=\"The Tiki Community\" target=\"_blank\">http://tiki.org</a>" => "To learn more, visit: <a href=\"http://tiki.org\" title=\"The Tiki Community\" target=\"_blank\">http://tiki.org</a>",
// "Tiki Documentation" => "Tiki Documentation",
// "For help, visit <a href=\"http://doc.tiki.org\" title=\"Tiki Documentation\" target=\"_blank\">http://doc.tiki.org</a>" => "For help, visit <a href=\"http://doc.tiki.org\" title=\"Tiki Documentation\" target=\"_blank\">http://doc.tiki.org</a>",
// "Published on" => "Published on",
"private" => "privát",
// "on blogpost" => "on blogpost",
// "Untitled" => "Untitled",
// "{\$module_params.label|escape:\"html\"}" => "{\$module_params.label|escape:\"html\"}",
// "{\$crumbs[0]->description}" => "{\$crumbs[0]->description}",
"Add event" => "Esemény hozzáadása",
// "Unit cost" => "Unit cost",
// "Qty" => "Qty",
// "Gift Certificate" => "Gift Certificate",
// "Remove Gift Certificate" => "Remove Gift Certificate",
// "Add Gift Certificate" => "Add Gift Certificate",
// "Check-out" => "Check-out",
// "Your cart is empty" => "Your cart is empty",
// "Missing %0 of the following categories" => "Missing %0 of the following categories",
// "%0 extra of the following categories" => "%0 extra of the following categories",
// "Unknown comparison" => "Unknown comparison",
// "Impossible condition, %0 of" => "Impossible condition, %0 of",
// "Assign into category" => "Assign into category",
// "{\$modcatlist[\$k].name|escape}" => "{\$modcatlist[\$k].name|escape}",
// "Unassign category" => "Unassign category",
// "{\$module_params.categorize}" => "{\$module_params.categorize}",
"Pages:" => "Lapok:",
// "{\$contributor.country|stringfix}" => "{\$contributor.country|stringfix}",
// "Homepage" => "Homepage",
// "1 more contributor" => "1 more contributor",
// "{\$hiddenContributors} more contributors" => "{\$hiddenContributors} more contributors",
"empty" => "üres",
// "low" => "low",
"Sites" => "Weblapok",
"Sites to validate" => "Érvényesítendő oldalcímek",
"Categories:" => "Kategóriák:",
"Visited links" => "Látogatott linkek",
// "By" => "By",
// "hits" => "hits",
// "Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes" => "Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes",
"Add tags" => "Címkék hozzáadása",
"List everything tagged" => "Összes felcímkézett listázása",
"All Groups" => "Összes csoport",
"Your Groups" => "Csoportjaim",
// "Emulated Groups" => "Emulated Groups",
"Switch to Groups" => "Átváltás csoportra",
"Simulate" => "Szimulálás",
// "Add Post" => "Add Post",
"insert original" => "eredeti beszúrása",
"insert thumbnail" => "előnézeti kép beszúrása",
"more" => "több",
// "Last %0 Podcasts" => "Last %0 Podcasts",
// "This is likely not a podcast file" => "This is likely not a podcast file",
// "The path to a podcast player is required" => "The path to a podcast player is required",
// "{\$link_text}" => "{\$link_text}",
"No avatar" => "Nincs avatár",
"You" => "Jelen felhasználó",
// "{\$data.info.title|escape:\"html\"}" => "{\$data.info.title|escape:\"html\"}",
"Open operator console" => "Operátor konzol megnyitása",
// "Execution time" => "Execution time",
// "Memory usage" => "Memory usage",
// "database queries used in " => "database queries used in ",
// "Server load" => "Server load",
"Logged in as" => "Bejelentkezve mint",
"Log out" => "Kijelentkezés",
"Switch User" => "Felhasználó váltása",
// "Enter user name and click 'Switch'.<br />Useful for testing permissions" => "Enter user name and click 'Switch'.<br />Useful for testing permissions",
"Switch" => "Csere",
"Switch user" => "Felhasználó váltása",
// "Log in through CAS" => "Log in through CAS",
// "Log in as admin" => "Log in as admin",
// "Log in through Shibboleth" => "Log in through Shibboleth",
"eMail" => "E-mail",
// "CapsLock is on" => "CapsLock is on",
// "Click here if you've forgotten your password" => "Click here if you've forgotten your password",
"I forgot my password" => "Jelszó emlékeztető",
// "Click here to register" => "Click here to register",
// "Click here to login using the default security protocol" => "Click here to login using the default security protocol",
// "Standard" => "Standard",
// "Click here to login using a secure protocol" => "Click here to login using a secure protocol",
"Secure" => "Biztonságos",
"Stay in SSL mode" => "Maradok titkosított módban",
// "local account" => "local account",
// "OpenID Log in" => "OpenID Log in",
// "What is OpenID" => "What is OpenID",
// "No acceptable field to store the feature was found in the specified tracker" => "No acceptable field to store the feature was found in the specified tracker",
"You have" => "",
"new messages" => "új üzenetek",
"new message" => "új üzenet",
"You have 0 new messages" => "Nincs új üzenet",
// "No article found" => "No article found",
// "No blog post found" => "No blog post found",
"We have" => "Itt van",
"submissions waiting to be examined" => "megvizsgálásra váró beadványok",
// "Stay on this page" => "Stay on this page",
// "Edit perspectives" => "Edit perspectives",
"Powered by" => "Powered by",
// "Tiki Wiki CMS Groupware" => "Tiki Wiki CMS Groupware",
"Made with" => "Készült",
// "Search Terms" => "Search Terms",
// "Any type" => "Any type",
// "Admin home" => "Admin home",
"Modify the look &amp; feel (logo, theme, etc.)" => "Stílus módosítása (logó, stílus témák, stb)",
"Users" => "Felhasználók",
"Toggle interactive translation off" => "Interaktív fordítás kikapcsolása",
"Toggle interactive translation on" => "Interaktív fordítás bekapcsolása",
// "Theme Generator Editor" => "Theme Generator Editor",
// "Rebuild Search index" => "Rebuild Search index",
"Plugin Approval" => "Plugin jóváhagyása",
"SysLogs" => "Rendszernaplók",
// "Open Smarty debug window" => "Open Smarty debug window",
// "Wiki feed" => "Wiki feed",
// "Feed" => "Feed",
// "Blogs feed" => "Blogs feed",
// "Articles feed" => "Articles feed",
// "Image Galleries feed" => "Image Galleries feed",
"Image Galleries" => "Képgalériák",
// "File Galleries feed" => "File Galleries feed",
// "Forums feed" => "Forums feed",
// "Maps feed" => "Maps feed",
"Maps" => "Térképek",
"Calendars" => "Naptárak",
// "{\$tracker.name}" => "{\$tracker.name}",
"Entire Site" => "Teljes weblap",
"Image Gals" => "Képgalériák",
// "Search for text throughout the site" => "Search for text throughout the site",
// "Go directly to a page, or search in page titles if exact match is not found" => "Go directly to a page, or search in page titles if exact match is not found",
// "Edit existing page or create a new one" => "Edit existing page or create a new one",
// "Page Relations" => "Page Relations",
// "Are you sure you want to delete this shout" => "Are you sure you want to delete this shout",
// "Tweet with Twitter" => "Tweet with Twitter",
// "Post on my Facebook wall" => "Post on my Facebook wall",
// "Shout date" => "Shout date",
// "Delete this shout" => "Delete this shout",
// "Edit this shout" => "Edit this shout",
"Read More" => "Bővebben",
"Since your last visit on" => "Utolsó látogatás óta a",
"New Images" => "új kép",
"Wiki Pages Changed" => "Módosított wiki lapok",
"New Files" => "Új fájl",
"New Comments" => "Új komment",
// "New Tracker Items" => "New Tracker Items",
// "New Calendar Events" => "New Calendar Events",
"New Users" => "Új felhasználó",
"click to edit" => "Kattintás a szerkesztéshez",
"Nothing has changed" => "Nincs változás",
// "Updated" => "Updated",
"Multiple" => "Több",
"including" => "belefoglalva",
"Site default" => "Weblap alapértelmezettje",
// "Find term" => "Find term",
// "{\$user_languages[ix].name}" => "{\$user_languages[ix].name}",
// "If not found, you will be given a chance to create it" => "If not found, you will be given a chance to create it",
// "TikiTests Menu" => "TikiTests Menu",
// "List Tests" => "List Tests",
// "Create Test" => "Create Test",
"Top galleries" => "Leglátogatottabb galériák",
// "Posted to" => "Posted to",
// "(Read More)" => "(Read More)",
// "Missing values" => "Missing values",
// "Add Marker" => "Add Marker",
// "Tracker name" => "Tracker name",
// "Insert fields in wiki textarea" => "Insert fields in wiki textarea",
"There are no translations of this page." => "Ennek az oldalnak nincsenek fordításai",
"Up-to-date-ness" => "Naprakészség",
"Incoming" => "Bejövő",
// "To <strong>continue translating</strong>, select the language to translate from" => "To <strong>continue translating</strong>, select the language to translate from",
"update from it" => "oldal frissítése ebből",
"None match your" => "Egyik sem egyezik a",
"Set your preferred languages." => "Preferált nyelvek beállítása",
"preferred languages" => "preferált nyelvekkel",
"view" => "megtekintés",
"Outgoing" => "Kimenő",
"update it" => "frissítés",
// "click to view" => "click to view",
"Add Event" => "Esemény hozzáadása",
"Bookmarks" => "Könyvjelzők",
// "Create Bookmark" => "Create Bookmark",
// "New Folder" => "New Folder",
// "Done" => "Done",
"Del" => "Törlés",
// "select" => "select",
// "{\$user_groups[ix].groupName|escape}" => "{\$user_groups[ix].groupName|escape}",
"User information:" => "Felhasználói információ:",
// "Group information" => "Group information",
// "You need to activate user and/or group trackers" => "You need to activate user and/or group trackers",
// "%0 out of %1 users" => "%0 out of %1 users",
// "Webmail inbox" => "Webmail inbox",
// "Refresh (non-ajax)" => "Refresh (non-ajax)",
// "TAKE" => "TAKE",
// "View contact" => "View contact",
"online users" => "online felhasználó",
"online user" => "online felhasználó",
// "on host" => "on host",
// "User does not accept messages" => "User does not accept messages",
"Send a message to" => "Üzenet küldése:",
// "Send a message" => "Send a message",
// "More Videos" => "More Videos",
// "No results" => "No results",
// "No results were found. Are you sure you searched for a tag" => "No results were found. Are you sure you searched for a tag",
// "We are not autorized to access the group at this time. If you have access to the Zotero group, you can grant this site read access" => "We are not autorized to access the group at this time. If you have access to the Zotero group, you can grant this site read access",
"No individual permissions, category permissions apply" => "Nincsenek egyedi jogosultságok, a kategóriajogosultságok érvényesek",
// "There are individual permissions set for this object" => "There are individual permissions set for this object",
"No individual permissions. Global permissions apply." => "Nincsenek egyéni jogosultságok megadva ezért a globális jogosultságok érvényesek",
"Session" => "Munkamenet",
// "Old Session" => "Old Session",
// "Old Version" => "Old Version",
// "New Session" => "New Session",
// "New Version" => "New Version",
// "Minimum %0 characters long" => "Minimum %0 characters long",
// "[-]" => "[-]",
"vote" => "szavazás",
"Requires" => "Szükséges hozzá",
"You need to set" => "Szükséges:",
// "Separator is " => "Separator is ",
"Warning:" => "Figyelmeztetés:",
// "Reset to default" => "Reset to default",
// "Restore current value" => "Restore current value",
"Rate" => "Értékelés",
"A valid email is mandatory to register" => "A regisztrációhoz szükséges egy valid E-mail cím megadása",
// "{\$customfields[ir].label}" => "{\$customfields[ir].label}",
// "{\$gr.groupDesc|escape}" => "{\$gr.groupDesc|escape}",
"Use your email as login" => "E-mail cím használata felhasználónévként",
// "Lowercase only" => "Lowercase only",
"Repeat password" => "Jelszó ismét",
"Generate a password" => "Jelszó generálása",
// "Passcode to register" => "Passcode to register",
// "Not your password" => "Not your password",
// "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}" => "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}",
// "The passcode (to block robots from registration) is" => "The passcode (to block robots from registration) is",
// "{\$remarksbox_type}" => "{\$remarksbox_type}",
// "{\$result.object_type|escape}" => "{\$result.object_type|escape}",
"Last modification" => "Utolsó módosítás",
"No pages matched the search criteria" => "Nincs a keresési kritériumoknak megfelelő oldal",
// "Download Log File" => "Download Log File",
"Send Newsletter" => "Hírlevelek küldése",
// "To edit the copyright notices" => "To edit the copyright notices",
// "The content on this page is licensed under the terms of the" => "The content on this page is licensed under the terms of the",
// "Page alias.." => "Page alias..",
"Monitor the Sub-Structure" => "Alstruktúra figyelése",
"Stop Monitoring the Sub-Structure" => "Alstruktúra figyelésének felfüggesztése",
// "locked by %0" => "locked by %0",
"Locked" => "Zárolva",
"Edit page" => "Oldal szerkesztése",
// "Add new child page" => "Add new child page",
// "Jump to Content" => "Jump to Content",
"Fullscreen" => "Teljes képernyő",
// "Cancel Fullscreen" => "Cancel Fullscreen",
"Show/Hide Left Column" => "Baloldali menü +/-",
"Show/Hide Right Column" => "Jobboldali menü +/-",
// "Module errors" => "Module errors",
// "The following modules could not be loaded" => "The following modules could not be loaded",
// "absE" => "absE",
// "Design by" => "Design by",
"comments" => "komment",
// "More search options" => "More search options",
// "View latest version before editing" => "View latest version before editing",
"Rename" => "Átnevezés",
"Contributions by author" => "Hozzájárulások szerzőnként",
"Similar" => "Hasonló",
"Make Structure" => "Struktúra létrehozása",
"Discuss" => "Megbeszélés",
"Attach File" => "Mellékletek",
"1 File Attached" => "1 csatolt fájl",
"{\$atts|@count} files attached" => "{\$atts|@count} melléklet",
"Bookmark" => "Könyvjelző",
// "Edit This Tracker" => "Edit This Tracker",
"Edit Fields" => "Mezők szerkesztése",
// "Create Item" => "Create Item",
// "View Items" => "View Items",
"Preview your changes." => "Változások előnézete",
"Edit wiki page" => "Wiki oldal szerkesztése",
"Save the page as a partial translation." => "Oldal mentése részleges fordításként",
"Partial Translation" => "Részleges fordítás",
"Save the page as a completed translation." => "Oldal mentése teljes fordításként",
"Complete Translation" => "Teljes fordítás",
"Save the page, but do not count it as new content to be translated." => "Menti az oldal változásait, de azok nem számítanak lefordítandó új tartalomnak",
"Save the page, but do not send notifications and do not count it as new content to be translated." => "Oldal mentése, de a kapcsolódó üzenetek nem kerülnek kiküldésre és nem számít lefordítandó tartalomnak",
"Save Minor Edit" => "Kis mentés",
"Save the page." => "Az oldal mentése",
"Cancel the edit, you will lose your changes." => "Szerkesztés visszavonása (a változások elvesznek)",
// "Designed originally by" => "Designed originally by",
// "* PREVIEW *" => "* PREVIEW *",
// "Modifying" => "Modifying",
// "Toggle checkboxes" => "Toggle checkboxes",
// "Toggle changed" => "Toggle changed",
// "Live preview" => "Live preview",
// "Reset selected" => "Reset selected",
// "Found in" => "Found in",
// "Changed from %0 to %1" => "Changed from %0 to %1",
// "Unchanged" => "Unchanged",
// "No definitions found" => "No definitions found",
// "No types found" => "No types found",
// "This book" => "This book",
// "before" => "before",
// "after" => "after",
// "don't display" => "don't display",
// "Decimals" => "Decimals",
// "Decimal Point" => "Decimal Point",
// "Auto Tax" => "Auto Tax",
"Tasks" => "Feladatok",
// "Book new entries" => "Book new entries",
// "Confirm stack entries" => "Confirm stack entries",
// "Book into Stack" => "Book into Stack",
"Accounts" => "Fiókok",
// "Bank acounts" => "Bank acounts",
// "Journal" => "Journal",
// "Fetch all" => "Fetch all",
"Account" => "Fiók",
// "Successfully deleted account %0 %1" => "Successfully deleted account %0 %1",
// "Return to main accounting page" => "Return to main accounting page",
// "Create new account" => "Create new account",
// "Edit Account" => "Edit Account",
"Account number" => "Számla szám",
"Account name" => "Postaláda neve",
"Notes" => "Jegyzetek",
// "Budget" => "Budget",
// "Create account" => "Create account",
// "Modify account" => "Modify account",
// "Delete this account" => "Delete this account",
// "Back to book page" => "Back to book page",
// "Debit" => "Debit",
// "Credit" => "Credit",
// "Tax" => "Tax",
// "edit account" => "edit account",
// "unlock account" => "unlock account",
// "Are you sure you want to unlock this account" => "Are you sure you want to unlock this account",
// "lock account" => "lock account",
// "Are you sure you want to lock this account" => "Are you sure you want to lock this account",
// "delete account" => "delete account",
// "Are you sure, you want to delete this account" => "Are you sure, you want to delete this account",
// "Create a new account" => "Create a new account",
// "printable version" => "printable version",
// "export table" => "export table",
// "View account" => "View account",
// "Edit this account" => "Edit this account",
// "My books" => "My books",
// "Tax automation" => "Tax automation",
// "hide" => "hide",
// "behind" => "behind",
// "Are you sure, you want to close this book" => "Are you sure, you want to close this book",
// "close book" => "close book",
// "Create a book" => "Create a book",
// "Book properties" => "Book properties",
// "Name of the book" => "Name of the book",
// "First date in journal" => "First date in journal",
// "Last date in journal" => "Last date in journal",
// "Currency settings" => "Currency settings",
// "Currency (up to 3 letters) " => "Currency (up to 3 letters) ",
// "Position of the currency " => "Position of the currency ",
// "Show no currency" => "Show no currency",
// "Show currency in front of numbers" => "Show currency in front of numbers",
// "Show currency behind numbers" => "Show currency behind numbers",
// "Decimal point" => "Decimal point",
// "Decimal" => "Decimal",
// "Thousands separator" => "Thousands separator",
// "Quote strings with" => "Quote strings with",
// "End of Line" => "End of Line",
// "Carriage return" => "Carriage return",
// "Line feed" => "Line feed",
// "Carriage Return/Line feed" => "Carriage Return/Line feed",
// "Automatic Tax Calculation" => "Automatic Tax Calculation",
// "Allow automatic tax calculation" => "Allow automatic tax calculation",
// "Create a new book" => "Create a new book",
// "The following transaction has been cancelled" => "The following transaction has been cancelled",
"id" => "id",
// "booking date" => "booking date",
// "Amount" => "Amount",
// "Book a transaction" => "Book a transaction",
// "Add entry" => "Add entry",
// "Book" => "Book",
// "Export {\$what}" => "Export {\$what}",
// "Export CSV settings" => "Export CSV settings",
// "Separator between fields" => "Separator between fields",
// "Quote character for text" => "Quote character for text",
"Export as CSV" => "CSV export",
// "cancel this transaction" => "cancel this transaction",
// "Are you sure you want to cancel this transaction" => "Are you sure you want to cancel this transaction",
// "Balance" => "Balance",
"Deleted" => "Törölt",
// "Debit Account" => "Debit Account",
// "Debit Amount" => "Debit Amount",
// "Debit Text" => "Debit Text",
// "Credit Account" => "Credit Account",
// "Credit Amount" => "Credit Amount",
// "Credit Text" => "Credit Text",
// "Book a transaction into the stack" => "Book a transaction into the stack",
// "delete this transaction from the stack" => "delete this transaction from the stack",
// "Are you sure you want to delete this transaction from stack" => "Are you sure you want to delete this transaction from stack",
// "confirm this transaction" => "confirm this transaction",
// "Are you sure you want to confirm this transaction" => "Are you sure you want to confirm this transaction",
"Do not group by item" => "Ne csoportosítson tételenként",
"Group by item" => "Csoportosítás tételenként",
"Calendar View" => "Naptár nézet",
"Tiki Action Calendar" => "Tiki akció naptár",
"Tools Calendars" => "Naptár eszközök",
"Check / Uncheck All" => "Összes kijelölése / kijelölés eltávolítása",
// "Your sender email is not set. You can set it <a href=\"%0\">here</a>" => "Your sender email is not set. You can set it <a href=\"%0\">here</a>",
// "Preference Filters" => "Preference Filters",
// "Set as my default" => "Set as my default",
"Configuration search" => "Konfiguráció keresés",
// "Note: The search index needs rebuilding, this will take a few minutes" => "Note: The search index needs rebuilding, this will take a few minutes",
// "Potential Cross-Site Request Forgery" => "Potential Cross-Site Request Forgery",
// "Search error" => "Search error",
// "Preferences Search Results" => "Preferences Search Results",
// "No preferences were found for your search query" => "No preferences were found for your search query",
"Database Version Problem" => "Adatbázis verzió probléma",
"Your database requires an update to match the current Tiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provokes errors." => "Az adatbázis frissítésre szorul hogy megegyezzen a használt Tiki verzió elvárásaival. Futtatni kell a <a href=\"tiki-install.php\">telepítőt</a>! Az adott Tiki verzióhoz nem illő adatbázis struktúra hibákhoz fog vezetni a mindennapi használat során.",
// "A new version of Tiki, <b>{\$prefs.tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tiki.org/Download\">tiki.org/Download</a>" => "A new version of Tiki, <b>{\$prefs.tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tiki.org/Download\">tiki.org/Download</a>",
// "Enabled" => "Enabled",
// "Changed" => "Changed",
"Preference" => "Preferencia",
// "{\$tikifeedback[n].mes|stringfix}" => "{\$tikifeedback[n].mes|stringfix}",
// "Preference name" => "Preference name",
"Crosslinks to other features and settings" => "Linkek más funkciókhoz és beállításokhoz",
"Administration features" => "Funkciók adminisztrálása",
"TikiCache/System" => "Tiki Cache/Rendszer",
// "phpinfo" => "phpinfo",
"Mods" => "Mod-ok",
"Transversal features" => "Átfogó funkciók",
"which apply to more than one section" => "több mint egy szekcióra vonatkoznak",
"Mail Notifications" => "E-mailes értesítések",
"Navigation features" => "Navigációs funkciók",
"Text area features" => "Szövegmezővel kapcsolatos funkciók",
"features you can use in all text areas, like wiki pages, blogs, articles, forums, etc" => "ezeket a funkciókat lehet használni az összes szöveges területen, mint például wiki oldalak, blogok, cikkek, fórumok, stb",
"Cookies" => "Cookie-k",
"External Pages Cache" => "Cache külső oldalakhoz",
"External Wikis" => "Külső wikik",
// "Please select some actions to be reported" => "Please select some actions to be reported",
// "Users and Groups" => "Users and Groups",
"Misc" => "Különleges",
// "Units" => "Units",
// "kb" => "kb",
// "Contibution Time" => "Contibution Time",
"Graph Contributions" => "Hozzájárulások grafikon",
// "Group Bar Plot" => "Group Bar Plot",
// "Accumulated Bar Plot" => "Accumulated Bar Plot",
// "{\$color}" => "{\$color}",
// "Legend background color" => "Legend background color",
// "Save graphs to image gallery" => "Save graphs to image gallery",
// "See Statistics" => "See Statistics",
"Records:" => "Rekordok száma:",
"contribution" => "hozzájárulás",
"contributor" => "hozzájáruló",
// "{\$actionlog.action|escape}" => "{\$actionlog.action|escape}",
// "{\$actionlog.objectType}" => "{\$actionlog.objectType}",
// "{\$actionlog.ip}" => "{\$actionlog.ip}",
// "Ban" => "Ban",
"Edit Action" => "Akció szerkesztése",
"Save Action" => "Akció mentése",
"Statistics" => "Statisztika",
"Volumes are equally distributed on each contributors/author" => "A mennyiségek egyenletesen kerülnek elosztásra minden egyes szerzőre/hozzájárulóra",
// "connection time" => "connection time",
// "connection seconds" => "connection seconds",
// "mns" => "mns",
// "Volume per category" => "Volume per category",
// "Volume per category and per user" => "Volume per category and per user",
"Number of actions per user" => "Akciók száma felhasználónként",
"Total number of users:" => "Felhasználók teljes száma",
"Number of actions per object" => "Akciók száma objektumonként",
"Total number of objects:" => "Objektumok teljes száma",
// "Number of actions per category" => "Number of actions per category",
// "Number of actions per category and per user" => "Number of actions per category and per user",
// "Volume per the users' group and per contribution" => "Volume per the users' group and per contribution",
// "Volume per group and per contribution" => "Volume per group and per contribution",
// "Volume per user and per contribution" => "Volume per user and per contribution",
// "Volume per users' contribution and time" => "Volume per users' contribution and time",
"Volume per contribution and time" => "Mennyiség hozzájárulás és idő alapján",
"Weeks" => "Hét",
"Setting" => "Beállítások",
// "How" => "How",
// "You need to check out the recorded box for each action type we may be interested to have some report later. To see a report of some action types, select the reported checkboxes of these action types, goto the Report tab and select additional filters. The report will only contains the actions that occurred since the action type has been set to recorded" => "You need to check out the recorded box for each action type we may be interested to have some report later. To see a report of some action types, select the reported checkboxes of these action types, goto the Report tab and select additional filters. The report will only contains the actions that occurred since the action type has been set to recorded",
"Wiki page actions except viewed will always be recorded but can be not reported" => "Wiki oldal akciók - a megtekintés kivételével - mindig rögzítésre kerülnek de nem riportálhatóak",
// "Recorded" => "Recorded",
// "Reported" => "Reported",
// "{\$actionlog.action}" => "{\$actionlog.action}",
// "Import as CSV" => "Import as CSV",
"Note:" => "Megjegyzés:",
// "Banning rules have been updated" => "Banning rules have been updated",
// "Add or edit rules" => "Add or edit rules",
"Rule title" => "Szabály neve",
"Username regex matching" => "Felhasználói név egyezik a kifejezéssel",
// "Multiple IP regex matching" => "Multiple IP regex matching",
"IP regex matching" => "IP egyezik a kifejezéssel",
"Banned from sections" => "Az alábbi szekciókból van kitiltva",
// "{\$sec}" => "{\$sec}",
"Rule activated by dates" => "A szabályt dátumok aktiválják",
"Rule active from" => "Érvényesség kezdete",
"Rule active until" => "Érvényesség vége",
"Custom message to the user" => "Egyedi üzenet a felhasználónak",
// "Import rules as CSV" => "Import rules as CSV",
"CSV File" => "CSV fájl",
// "Column names on the first line" => "Column names on the first line",
// "Sections format" => "Sections format",
// "section names are splitted by pipes (vertical bars). To see an example and use it as template, add one rule by hand, and export it as csv" => "section names are splitted by pipes (vertical bars). To see an example and use it as template, add one rule by hand, and export it as csv",
// "See" => "See",
// "Import as new rules" => "Import as new rules",
"import" => "importálás",
"Find:" => "Keresés:",
"Rules" => "Szabályok",
"x" => "törlés",
"User/IP" => "Felhasználó/IP",
"Sections" => "Szekciók",
"Admin Calendars" => "Naptár karbantartás",
"Create Calendar" => "Naptár létrehozása",
"View Calendars" => "Naptárak megtekintése",
"List of Calendars" => "Naptár lista",
// "Calendar name" => "Calendar name",
"Loc" => "Hely",
"Participants" => "Résztvevők",
"Cat" => "Kat",
"Lang" => "Nyelv",
"Prio" => "Prioritás",
"Subscription" => "Előfizetés",
"Perso" => "Személy",
"View Calendar" => "Naptár megtekintése",
"Edit Calendar" => "Naptár szerkesztése",
"Custom Locations" => "Egyedi hely",
"Custom Participants" => "Saját résztvevők",
"Custom Classifications" => "Saját besorolások",
"Custom Languages" => "Egyedi nyelv",
"Custom URL" => "Saját URL",
"Custom Subscription List" => "Saját feliratkozási lista",
"Custom Priorities" => "Egyedi prioritás",
"Personal Calendar" => "Személyes naptár",
"Start of day" => "Nap kezdete",
"End of day" => "Nap vége",
"Days to display" => "Megjelenítendő napok",
"Standard Colors" => "Alap színek",
"Green" => "Zöld",
"Blue" => "Kék",
"Purple" => "Lila",
"Red" => "Piros",
"Orange" => "Narancs",
"Yellow" => "Sárga",
"Custom foreground color" => "Saját szín",
"Ex:" => "Pld:",
"Custom background color" => "Saját háttérszín",
"Default event status" => "Esemény alapértelmezett státusza",
"Show in calendar view" => "Megjelenítés naptár nézetben",
"Group of users alerted when calendar event is modified" => "Naptári esemény módosításakor értesítendő felhasználói csoport",
// "Default event to all day" => "Default event to all day",
// "Event name on each day in calendar view" => "Event name on each day in calendar view",
"Delete events older than:" => "Ennél régebbi események törlése:",
"Browse the category system" => "Kategóriarendszer böngészése",
"Current category" => "Jelenlegi kategória",
"Current Category ID:" => "Jelenlegi kategória azonosítója:",
"Create/Edit category" => "Kategória karbantartás",
"Edit this category:" => "Ezen kategória szerkesztése",
"Add new category" => "Új kategória hozzáadása",
// "Apply parent category permissions" => "Apply parent category permissions",
"Batch upload" => "Tömeges feltöltés",
"Batch upload (CSV file)" => "Tömeges feltöltés (CSV fájl)",
"Objects in category" => "Kategória objektumai",
"Objects in category:" => "Objektumok ebben a kategóriában:",
"Remove from this Category" => "Eltávolítás ebből a kategóriából",
// "{\$objects[ix].type}" => "{\$objects[ix].type}",
"Moving objects between categories" => "Objektumok mozgatása kategóriák között",
"Unassign all objects from this category" => "Összes objektum eltávolítása ebből a kategóriából",
"Move all the objects from this category to this one" => "Összes objektum mozgatása ebből a kategóriából ebbe a kategóriába",
"Assign all objects of this category to this one" => "Kategória összes objektumának hozzárendelése ehhez a kategóriához",
"Add objects to category" => "Elemek hozzáadása a kategóriához",
"Add objects to category:" => "Elemek hozzáadása a kategóriához:",
"image gal" => "képgaléria",
"File gal:" => "Fájlgaléria:",
"Tracker:" => "Űrlap:",
"Admin templates" => "Sablonok adminisztrálása",
"Use the Administration page of each enabled feature to allow the use of content templates." => "A bekapcsolt funkciók saját adminisztrációs oldalán lehet engedélyezni a sablonok használatát",
"Edit this template:" => "Ezen sablon szerkesztése:",
"Create new template" => "Új sablon létrehozása",
// "Name field is mandatory" => "Name field is mandatory",
"Use in" => "Használat itt",
"CMS" => "Hírek",
"HTML Pages" => "HTML oldalak",
"No features are configured to use templates." => "Egy funkcióhoz sincs beállítva a sablonok használata",
// "Template Type" => "Template Type",
"Text area" => "Szöveges terület",
// "Is HTML" => "Is HTML",
"Templates" => "Sablonok",
// "Visible in no sections" => "Visible in no sections",
// "Remove section" => "Remove section",
"Admin Contributions" => "Hozzájárulások adminisztrálása",
"Edit the contribution:" => "Hozzájárulás szerkesztése:",
"Contributions are mandatory in wiki pages" => "Hozzájárulások kötelezőek wiki oldalakon",
"Contributions are mandatory in forums" => "Hozzájárulások kötelezőek fórumokban",
"Contributions are mandatory in comments" => "Hozzájárulások kötelezőek kommentekben",
"Contributions are mandatory in blogs" => "Hozzájárulások kötelezőek blogokban",
"Contributions are displayed in the comment/post" => "Hozzájárulások megjelenítésre kerülnek a kommentben/posztban",
"Create a new contribution" => "Új hozzájárulás létrehozása",
"List of contributions" => "Hozzájárulások listája",
"Admin cookies" => "Cookiek adminisztrálása",
// "To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}" => "To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}",
"Create/edit cookies" => "Cookie létrehozása/szerkesztése",
"Upload Cookies from textfile" => "Cookie feltöltése szöveges fájlból",
"Upload from disk:" => "Feltöltés lemezről",
"Upload" => "Feltöltés",
"Remove all cookies" => "Minden cookie eltávolítása",
// "cookie" => "cookie",
// "Manage Credits" => "Manage Credits",
// "(YYYY-MM-DD HH:MM:SS)" => "(YYYY-MM-DD HH:MM:SS)",
// "(level credits always 0)" => "(level credits always 0)",
// "Delete Checked" => "Delete Checked",
// "User Credits Expiry Summary (Plans)" => "User Credits Expiry Summary (Plans)",
// "User Plan" => "User Plan",
// "Start of Latest Plan" => "Start of Latest Plan",
// "Start of Next Plan" => "Start of Next Plan",
// "Expiry" => "Expiry",
// "Use User Credits" => "Use User Credits",
// "Restore User Level Credits" => "Restore User Level Credits",
// "Historical Usage Report" => "Historical Usage Report",
"all types" => "összes típus",
"filter" => "szűrés",
// "Usage Date" => "Usage Date",
// "Amount Used" => "Amount Used",
// "Manage Credit Types" => "Manage Credit Types",
// "Display Text" => "Display Text",
// "Unit Text" => "Unit Text",
// "Is Static Level Credit" => "Is Static Level Credit",
// "Display Bar Length Scaling Divisor" => "Display Bar Length Scaling Divisor",
// "Purge Expired and Used Credits (All Users)" => "Purge Expired and Used Credits (All Users)",
// "Purge" => "Purge",
// "Admin Content Sources" => "Admin Content Sources",
"Use Admin DSN to define the database to be used by the SQL plugin." => "DSN (Data Source Name - Adatforrás neve) adatbáziskapcsolatok megadásával lehet megadni az SQL plugin által használt adatbázisokat",
// "Create/edit DSN" => "Create/edit DSN",
// "Local (Tiki database)" => "Local (Tiki database)",
// "See db/local.php" => "See db/local.php",
// "Content Authentication" => "Content Authentication",
// "Identification" => "Identification",
// "HTTP Basic" => "HTTP Basic",
// "HTTP Session / Login" => "HTTP Session / Login",
// "HTTP Session / Visit" => "HTTP Session / Visit",
// "Admin External Wikis" => "Admin External Wikis",
// "Create/Edit External Wiki" => "Create/Edit External Wiki",
"URL (use \$page to be replaced by the page name in the URL example: http://www.example.com/tiki-index.php?page=\$page)" => "URL (használjon \$lap kifejezést a lap nevével, mint az alábbi példában: http://www.example.com/tiki-index.php?page=\$page)",
// "ExtWiki" => "ExtWiki",
"Admin Forums" => "Fórum karbantartás",
"Create New Forum" => "Új fórum létrehozása",
"Duplicate Forum" => "Fórum duplikálás",
"View this forum" => "Fórum megtekintése",
"Import forums" => "Fórum importálás",
"List forums" => "Fórum lista",
"Coms" => "Kommentek",
"Age" => "Életkor",
// "PPD" => "PPD",
// ".." => "..",
"Create/Edit Forums" => "Fórum létrehozása/módosítása",
"Edit this Forum:" => "Fórum szerkesztése:",
"Show description:" => "Leírás megjelenítése:",
"Prevent flooding:" => "Flood megakadályozása:",
"Minimum time between posts:" => "Hozzászólások közti minimum idő:",
"Section:" => "Szekció:",
"Create new" => "Új készítése",
"Moderator user:" => "Moderátor felhasználó:",
"Moderator group:" => "Moderátor csoport:",
"Password protected" => "Jelszóval védett",
"Forum password" => "Fórum jelszó",
"Only allow replies to the first message (flat forum):" => "Csak az első üzenetre küldhető válasz (lapos fórum):",
"Send this forums posts to this email:" => "Fórum hozzászólásainak elküldése az alábbi E-mail címre:",
"Prune unreplied messages after:" => "Válasz nélküli üzenetek eltávolítása ennyi idő után:",
"Prune old messages after:" => "Régi üzenetek eltávolítása ennyi idő után:",
"Topic list configuration" => "Témalista beállítása",
"Last post title" => "Legutóbbi poszt címe",
"Last post avatar" => "Legutóbbi poszt avatárja",
"Author avatar" => "Szerző avatárja",
"Posts can be rated" => "A hozzászólások pontozhatóak",
"Display last post titles" => "Legutóbbi posztok címeinek megjelenítése",
"Forward messages to this forum to this e-mail address, in a format that can be used for sending back to the inbound forum e-mail address" => "Üzenetek továbbítása erre e fórumra erre az E-mail címre olyan formátumban mely felhasználható visszaküldésre a beérkező fórum E-mail címre",
"Send mails even when the post is generated by inbound mail" => "Levelek küldése ha a hozzászólást beérkező levél generálta",
"Append a reply link to outbound mails" => "Válaszlink hozzáadása a kimenő levelekhez",
"Originating e-mail address for mails from this forum" => "Ezen fórum leveleihez tartozó forrás E-mail cím",
"Add messages from this email to the forum" => "Alábbi E-mail üzeneteket hozzáadása a fórumhoz",
"POP3 server:" => "POP3 szerver:",
"Use topic smileys" => "Mosolyok használata a témákban is legyen engedélyezett",
"Show topic summary" => "Témaösszesítő",
"User information display" => "Felhasználói információs képernyő",
// "Online" => "Online",
"Approval type" => "Jóváhagyás típusa",
"Store attachments in:" => "Mellékletek tárolása itt:",
"Max attachment size (bytes):" => "Melléklet maximális mérete (bájt):",
"Shows number of attachments of the all thread in forum list" => "Mellékletek számának megjelenítése a fórum összes témájában",
"Set topics preferences" => "Témapreferenciák beállítása",
"Show topics preferences" => "Témapreferenciák megjelenítése",
"hide topics preferences" => "Témapreferenciák elrejtése",
"Default ordering for topics:" => "Témák rendezésének alapbeállítása:",
"Topics per page:" => "Témák száma laponként:",
// "Set thread preferences" => "Set thread preferences",
// "Show threads preferences" => "Show threads preferences",
// "hide threads preferences" => "hide threads preferences",
"Default ordering for threads" => "A szálak alap rendezési beállítása",
// "Default style for threads" => "Default style for threads",
"Duplicate perms" => "Jogosultságok duplikálása",
"Admin Hotwords" => "Hotword adminisztráció",
"Add Hotword" => "Hotword hozzáadása",
"Word" => "Szó",
"Admin HTML Page Dynamic Zones" => "HTML oldalak dinamikus zónáinak adminisztrálása",
"Admin HTML pages" => "HTML oldalak adminisztrálása",
"View page" => "Oldal megtekintése",
"Edit zone" => "Zóna szerkesztése",
"Dynamic zones" => "Dinamikus zónák",
"zone" => "zóna",
"content" => "tartalom",
"Mass update" => "Tömeges frissítés",
"Create new HTML page" => "Új HTML oldal létrehozása",
"Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones" => "Használjuk a {literal}{ed id=name}{/literal} vagy {literal}{ted id=name}{/literal} formulát dinamikus zónák beszúrásához",
"Edit this HTML page:" => "Ezen HTML oldal szerkesztése:",
"Apply template" => "Sablon alkalmazása",
// "{\$templates[ix].name}" => "{\$templates[ix].name}",
"Dynamic" => "Dinamikus",
"Static" => "Statikus",
"Refresh rate (if dynamic)" => "Frissítési ráta (ha dinamikus)",
"Last Modif" => "Utolsó módosítás",
"Admin dynamic zones" => "Dinamikus zónák adminisztrálása",
// "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> feature" => "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> feature",
// "Edit Repository" => "Edit Repository",
// "Create New Repository" => "Create New Repository",
// "List Repositories" => "List Repositories",
// "New Repository" => "New Repository",
// "View Repository" => "View Repository",
// "Human-readable repository name" => "Human-readable repository name",
// "Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')" => "Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')",
// "File name of start page" => "File name of start page",
"Start page" => "Kezdő oldal",
// "CSS file to load when browse this repository" => "CSS file to load when browse this repository",
"CSS File" => "CSS fájl",
// "Is repository visible to users" => "Is repository visible to users",
// "Can files from repository be cached" => "Can files from repository be cached",
// "Cacheable" => "Cacheable",
// "Are files from repository can be cached" => "Are files from repository can be cached",
// "Clear all cached pages of this repository" => "Clear all cached pages of this repository",
"Clear cache" => "Cache ürítése",
// "Seconds count 'till cached page will be expired" => "Seconds count 'till cached page will be expired",
// "Cache expiration" => "Cache expiration",
// "Human-readable text description of repository" => "Human-readable text description of repository",
// "Available Repositories" => "Available Repositories",
// "Edit rules" => "Edit rules",
// "Edit Rules for Repository" => "Edit Rules for Repository",
// "Configure Repositories" => "Configure Repositories",
// "Configure this Repository" => "Configure this Repository",
// "View this Repository" => "View this Repository",
"New Rule" => "Új szabály",
"Copy Rules" => "Szabályok másolása",
// "view/hide copy rules dialog" => "view/hide copy rules dialog",
// "Source repository" => "Source repository",
"Copy" => "Másolás",
// "According this order rules will be applied ('0' or empty = auto)" => "According this order rules will be applied ('0' or empty = auto)",
// "Rule order" => "Rule order",
// "Text to search for" => "Text to search for",
// "Text to replace" => "Text to replace",
// "Is this regular expression or simple search/replacer" => "Is this regular expression or simple search/replacer",
// "Regex" => "Regex",
// "Is case sensitive (for simple replacer)" => "Is case sensitive (for simple replacer)",
// "Case sensitive" => "Case sensitive",
// "subset of chars: imsxeADSXUu, which is regex modifiers" => "subset of chars: imsxeADSXUu, which is regex modifiers",
// "Regex modifiers" => "Regex modifiers",
// "Human-readable text description of rule" => "Human-readable text description of rule",
// "Check to enable this rule" => "Check to enable this rule",
// "Preview options" => "Preview options",
// "Apply all rules or just this to generate preview" => "Apply all rules or just this to generate preview",
// "Apply all rules" => "Apply all rules",
// "View source code after rules applied" => "View source code after rules applied",
// "Code preview" => "Code preview",
// "Generate HTML preview" => "Generate HTML preview",
// "HTML preview" => "HTML preview",
// "Test file from repository to generate preview for (empty = configured start page)" => "Test file from repository to generate preview for (empty = configured start page)",
// "Preview Results" => "Preview Results",
// "Rules List" => "Rules List",
// "Case" => "Case",
"Configure/Options" => "Konfigurálás",
// "Admin Invoices" => "Admin Invoices",
// "Admin keywords" => "Admin keywords",
// "Keywords have been updated" => "Keywords have been updated",
// "Updating keywords has failed. Page probably doesn't exist" => "Updating keywords has failed. Page probably doesn't exist",
// "Edit page keywords" => "Edit page keywords",
// "Current Page Keywords" => "Current Page Keywords",
// "Search by page" => "Search by page",
"results found" => "találat",
"No pages found" => "Nincs megfelelő lap",
"Admin layout" => "Kinézet adminisztrálása",
"Theme control" => "Stílusvezérlés",
"layout options" => "kinézet beállítások",
// "{\$sections[ix].name}" => "{\$sections[ix].name}",
"Right column" => "Jobb oszlop",
"Top bar" => "Felső sáv",
"Bottom bar" => "Alsó sáv",
// "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>" => "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>",
"Generate positions by hits" => "A helyeket a találatok alapján alakítsa ki",
"List of featured links" => "Kiemelt linkek listáa",
"Add Featured Link" => "Kiemelt link hozzáadása",
"Edit this Featured Link:" => "Ezen kiemelt link szerkesztése:",
"Create new Featured Link" => "Új kiemelt link készítése",
"disables the link" => "link letiltása",
"Link type" => "Link típusa",
"replace current page" => "A jelenlegi lap lecserélése",
"framed" => "frame-ben",
"open new window" => "új ablak nyitása",
"Mail-in accounts" => "Bejövő levelezési fiókok",
// "{\$accounts[ix].type}" => "{\$accounts[ix].type}",
"Add new Mail-in account" => "Bejövő levelezési fiók hozzáadása",
"Edit Mail-in account" => "Bejövő levelezési fiók szerkesztése",
"POP server" => "POP szerver",
"SMTP server" => "SMTP szerver",
"SMTP requires authentication" => "SMTP felhasználóazonosítást igényel",
"article-put" => "cikk-put",
"wiki-get" => "wiki-leszed",
"wiki-put" => "wiki-felrak",
"wiki-append" => "wiki-hozzáfűz",
"Article Topic" => "Cikk téma",
"Admin Topics" => "Témák beállítása",
"Article Type" => "Cikk típus",
// "{\$types[t].type}" => "{\$types[t].type}",
"Admin Types" => "Típusok beállítása",
"Active" => "Aktív",
"Allow anonymous access" => "Anonymus hozzáférés engedélyezése",
"Allow attachments" => "Mellékletek engedélyezése",
// "Discard to the end from" => "Discard to the end from",
"Check Mail-in accounts" => "Bejövő levelezési fiókok ellenőrzése",
"Check automatically" => "Automatikus ellenőrzés",
"Frequency" => "Gyakoriság",
// "mn" => "mn",
"Admin Menu:" => "Menü adminisztrálása:",
"List menus" => "Menük listája",
"Edit this menu" => "Szerkesztés",
// "Manage menu" => "Manage menu",
"Menu options" => "Menü opciók",
"Sections:" => "Szekciók:",
"Permissions:" => "Jogosultságok:",
"Groups:" => "Csoportok:",
// "switch with previous option" => "switch with previous option",
// "switch with next option" => "switch with next option",
// "Create menu option" => "Create menu option",
// "Edit menu option" => "Edit menu option",
"Show Quick Urls" => "Gyors URL-ek megjelenítése",
"Some useful URLs" => "Néhány hasznos URL",
"Hide Quick Urls" => "Gyors URL-ek elrejtése",
"Home:" => "Főoldal:",
"Choose" => "Kiválasztás",
"Home Blog" => "Kezdőblog",
"Home Image Gal" => "Fő képgaléria",
"Home Image Gallery" => "Fő képgaléria",
"Home File Gal" => "Fő fájlgaléria",
"Home File Gallery" => "Fő fájlgaléria",
"General:" => "Általános:",
"User preferences" => "Felhasználói beállítások",
"User prefs" => "Felhasználói beáll.",
"Wiki Home" => "Wiki főoldal",
"List galleries" => "Galériák listázása",
"List image galleries" => "Képgalériák listázása",
"Upload image" => "Kép feltöltése",
"Gallery Rankings" => "Galéria rangok",
"Browse a gallery" => "Galéria böngészése",
"Articles home" => "Cikkek főoldala",
"All articles" => "összes cikk",
"List articles" => "Cikkek listázása",
"List Blogs" => "Blog lista",
"Create Blog" => "Blog létrehozása",
"Files:" => "Fájlok:",
"View a forum" => "Fórum megtekintése",
"View a thread" => "Egy fórumtéma megtekintése",
"View a FAQ" => "Gyakori kérdések megtekintése",
"Take a quiz" => "Kvíz kitöltése",
"Quiz stats" => "Kvízek statisztikái",
"Stats for a Quiz" => "Statisztikák a kvízekhez",
"For wiki page, use ((PageName))." => "Wiki oldalhoz használjuk az ((OldalNév)) szintakszist.",
"option" => "opció",
"section level 0" => "szekció szint 0",
"section level 1" => "szekció szint 1",
"section level 2" => "szekció szint 2",
"section level 3" => "szekció szint 3",
"sorted section level 0" => "rendezett szekció, szint 0",
"separator" => "szeparátor",
"Position:" => "Pozíció:",
// "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each" => "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each",
// "If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed" => "If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed",
// "Separate multiple feature/preferences with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple feature/preferences with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
"Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR." => "Több jogosultság esetén: a jogosultságokat vesszővel ( , ) válasszuk el AND (ÉS) jellegű logikai kapcsolathoz, OR (VAGY) jellegű logikai kapcsolathoz pedig használjunk függőleges elválasztót ( | ).",
"Icon:" => "Ikon",
"Preview menu" => "Menü előnézet",
// "Appearance" => "Appearance",
// "Import/export menu" => "Import/export menu",
"Export CSV data" => "CSV adat exportálása",
"Import CSV data" => "CSV adat importálása",
"To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'." => "Új menüopció hozzáadásához az optionId mezőt 0-ra kell állítani. Opció eltávolításához a mező eltávolítása mezőnek 'y' értéket kell adni.",
"File:" => "Fájl:",
// "RESET" => "RESET",
// "Clone this menu and its options" => "Clone this menu and its options",
"Create/Edit Menu" => "Menü létrehozása/szerkesztése",
"Edit this Menu:" => "Ezen menü szerkesztése:",
"Create new Menu" => "Új menü készítése",
"dynamic collapsed" => "dinamikus összezárt",
"dynamic extended" => "dinamikus nyitott",
"fixed" => "rögzített",
// "Labels of all options will be wiki parsed" => "Labels of all options will be wiki parsed",
"Icons:" => "Ikonok:",
"Folder Icon" => "Mappa ikon",
"Path and filename of closed folder icon" => "A bezárt mappa ikonjának útvonala és fájlneve",
"To use custom folder icons in menus, enter the path to the icon for the <strong>closed</strong> folder" => "Saját ikonok használatához menükben adjuk meg az útvonalat az <strong>összezárt</strong> mappa ikonjához",
"In the same directory, include an icon for the opened folder." => "Ugyanabban a könyvtárban adjunk meg egy ikont a kinyitott mappához.",
"The \"opened folder\" icon name must be identical to the \"closed folder\" icon name, prefixed with the letter <strong>o</strong>" => "A \"kinyitott mappa\" ikon nevének meg kell egyeznie az \"összezárt\" ikon nevével, előtte az <strong>o</strong> előtaggal",
// "For example, the default icon is: img/icons/folder.png" => "For example, the default icon is: img/icons/folder.png",
// "The name of the \"open folder\" icon is: img/icons/ofolder.png" => "The name of the \"open folder\" icon is: img/icons/ofolder.png",
// "Configure icons for menu entries" => "Configure icons for menu entries",
// "You can use menus by assigning the menu <a href=\"tiki-admin_modules.php\">module</a> (to the top, left, right, etc.), or you can customize a template, using {literal}{menu id=x}{/literal}, where x is the ID of the menu" => "You can use menus by assigning the menu <a href=\"tiki-admin_modules.php\">module</a> (to the top, left, right, etc.), or you can customize a template, using {literal}{menu id=x}{/literal}, where x is the ID of the menu",
"To use a menu in a tiki format:" => "Menü használata tiki formátumban:",
"To use menu in a css/suckerfish format:" => "Menü használata css/suckerfish formátumban: ",
"To customize the menu's CSS id (#):" => "Menü CSS id-jának testreszabása:",
// "Admin Metrics" => "Admin Metrics",
// "Metrics" => "Metrics",
// "Assign Metrics" => "Assign Metrics",
// "Assigned Metrics" => "Assigned Metrics",
// "Edit/Create Metrics" => "Edit/Create Metrics",
// "Edit/Create Tab" => "Edit/Create Tab",
// "Data Type" => "Data Type",
// "Weight" => "Weight",
// "Metric Name" => "Metric Name",
// "Tab Name" => "Tab Name",
// "Assign metric" => "Assign metric",
// "Edit this assigned metric" => "Edit this assigned metric",
// "Tab for metric" => "Tab for metric",
// "Create new metric" => "Create new metric",
// "Edit this metric" => "Edit this metric",
// "Hints" => "Hints",
// "For list-based metrics, include the \"LIMIT #\" in your query" => "For list-based metrics, include the \"LIMIT #\" in your query",
// "Name (must be unique)" => "Name (must be unique)",
// "Create Metric" => "Create Metric",
// "Edit Metric" => "Edit Metric",
// "Create new tab" => "Create new tab",
// "Edit this tab" => "Edit this tab",
// "Weight (must be integer)" => "Weight (must be integer)",
// "Create Tab" => "Create Tab",
// "Edit Tab" => "Edit Tab",
"Clear Cache" => "Gyorsítótár kiürítése",
// "Show hidden modules" => "Show hidden modules",
// "Hide hidden modules" => "Hide hidden modules",
// "Exit Modules" => "Exit Modules",
// "Modules Parameters" => "Modules Parameters",
// "The following required parameters are missing" => "The following required parameters are missing",
// "Drag the modules around to re-order then click save when ready" => "Drag the modules around to re-order then click save when ready",
// "Double click them to edit" => "Double click them to edit",
// "Modules with \"position: absolute\" in their style can be dragged in to position" => "Modules with \"position: absolute\" in their style can be dragged in to position",
// "New modules can be dragged from the \"All Modules\" tab" => "New modules can be dragged from the \"All Modules\" tab",
// "Links and buttons in modules, apart from the Application Menu, have been deliberately disabled on this page to make drag and drop more reliable. Click here to return <a href=\"./\">HOME</a>" => "Links and buttons in modules, apart from the Application Menu, have been deliberately disabled on this page to make drag and drop more reliable. Click here to return <a href=\"./\">HOME</a>",
// "More info here" => "More info here",
// "Assigned modules" => "Assigned modules",
"Assign/Edit modules" => "Modul karbantartás",
"Assigned Modules" => "Hozzárendelt modulok",
// "Add module" => "Add module",
// "Move Up" => "Move Up",
// "Move Down" => "Move Down",
// "Edit module" => "Edit module",
"Assign new module" => "Új modul hozzárendelése",
"Edit this assigned module:" => "Ezen hozzárendelt modult szerkesztése:",
"Module Options" => "Modul opciók",
// "Custom Modules" => "Custom Modules",
// "Create new custom module" => "Create new custom module",
// "Edit this custom module" => "Edit this custom module",
"Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\">assigning it</a>. Using HTML, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site." => "Saját modult itt hozhatunk létre. Tekintsük meg előnézetben és bizonyosodjunk meg arról hogy nincs benne hiba mielőtt <a href=\"#assign\">hozzárendelnénk</a>. HTML-t használva elkerülhetőek a problémák, de wiki szintakszis vagy Smarty kód helytelen használata során akár még az oldalról is kizárhatjuk magunkat (ilyenkor 'hátulról', azaz az adatbázis közvetlen módosításán keresztül lehet csak visszajutni.) Szóval csak óvatosan.",
"Must be wiki parsed" => "Wiki által elemzettnek kell lennie",
"Objects that can be included" => "Felhasználható objektumok",
"Available polls" => "Rendelkezésre álló szavazások",
// "Random active poll" => "Random active poll",
// "Random current poll" => "Random current poll",
"Use Poll" => "Szavazás használata",
"Random image from" => "Véletlenszerű kép innen",
"Use Gallery" => "Galéria használata",
"Dynamic content blocks" => "Dinamikus tartalmú rész",
"Use Dynamic Content" => "Dinamikus tartalom használata",
"Use RSS Module" => "Rss modul használata",
"Default Tiki menus:" => "Alapértelmezett Tiki menük:",
"Use Menu" => "Menü használata",
"CSS menus:" => "CSS menük:",
// "Use CSS menu" => "Use CSS menu",
"Banner zones" => "Banner zónák",
"Use Banner Zone" => "Banner zónák használata",
"Structures:" => "Struktúrák:",
// "Use Wiki Structure" => "Use Wiki Structure",
// "To use a <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\">CSS (Superfish) menu</a>, use one of these syntaxes" => "To use a <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\">CSS (Superfish) menu</a>, use one of these syntaxes",
"To use a default Tiki menu:" => "Alapértelmezett Tiki menü használatához:",
"Data" => "Adat",
// "All Modules" => "All Modules",
// "Show all modules" => "Show all modules",
"Admin newsletter subscriptions" => "Hírlevél előfizetések adminisztrálása",
"List Newsletters" => "Hírlevél lista",
// "Edit Newsletter" => "Edit Newsletter",
"Admin Newsletters" => "Hírlevél karbantartás",
"Send Newsletters" => "Hírlevél küldés",
"Subscriptions" => "Előfizetések",
// "Groups included through inheritence" => "Groups included through inheritence",
// "Wiki Page Name" => "Wiki Page Name",
// "Validate Addresses" => "Validate Addresses",
// "Add To List" => "Add To List",
"Valid" => "Valid",
"Subscribed" => "Feliratkozva",
// "Unsubscribed" => "Unsubscribed",
// "Add subscribers" => "Add subscribers",
"You can add several email addresses by separating them with commas." => "Több E-mail cím is megadható vesszővel elválasztva",
"Add email" => "E-mail hozzáadása",
"Add user" => "Felhasználó hozzáadása",
// "Users from group" => "Users from group",
"Group subscription also subscribes included groups" => "Csoportos előfizetés a kiválasztott csoportokat is tartalmazza",
"Don't send confirmation mail" => "Ne küldjön megerősítési E-mailt",
"The user email will be refreshed at each newsletter sending" => "A felhasználói E-mail az egyes kiküldések alkalmával kerül frissítésre",
// "Import emails from file" => "Import emails from file",
"txt file, one e-mail per line" => "txt fájl, egy E-mail soronként",
// "Don't send confirmation mails" => "Don't send confirmation mails",
// "Import emails from wiki page" => "Import emails from wiki page",
// "Wiki page, one e-mail per line" => "Wiki page, one e-mail per line",
"Subscribe group" => "Csoport feliratkozása",
// "Including group inheritence" => "Including group inheritence",
// "Including group, group users and emails will be refreshed at each newsletter sending" => "Including group, group users and emails will be refreshed at each newsletter sending",
// "Use subscribers of another newsletter" => "Use subscribers of another newsletter",
// "Use emails from wiki page" => "Use emails from wiki page",
// "Emails on a wiki page which will be added at each newsletter sending, one e-mail per line" => "Emails on a wiki page which will be added at each newsletter sending, one e-mail per line",
// "Don't subscribe emails" => "Don't subscribe emails",
"Export Subscriber Emails" => "Feliratkozók E-mail címének exportálása",
"Admin newsletters" => "Hírlevél karbantartás",
"Create Newsletter" => "Hírlevél létrehozás",
"Editions" => "Kiadások",
"Drafts" => "Piszkozatok",
"Last Sent" => "Legutóbbi küldés",
"Assign Permissions" => "Jogosultságok kiosztása",
"Create/Edit Newsletters" => "Hírlevél létrehozás/szerkesztés",
"There are individual permissions set for this newsletter" => "Ennél a hírlevélnél egyéni jogosultságok vannak beállítva",
"Users can subscribe/unsubscribe to this list" => "A listára a felhasználók fel/leiratkozhatnak",
"Users can subscribe any email address" => "A felhasználók bármely E-mail címre feliratkozhatnak",
"Add unsubscribe instructions to each newsletter" => "Leiratkozási instrukciók hozzáadása minden egyes hírlevélhez",
"Validate email addresses" => "E-mail címek validálása",
"Allow customized text message to be sent with the HTML version" => "Testreszabott szöveges üzenet küldésének engedélyezése a HTML verzióval",
"Allow clipping of articles into newsletter" => "Cikkek beillesztésének engedélyezése hírlevélbe",
"Automatically clip articles into newsletter" => "Cikkek automatikus beillesztése hírlevélbe",
"Clip articles published in the past number of days" => "Az elmúlt napokban publikált cikkek beillesztése",
"Article types to clip" => "Csatolandó cikk típusok",
"Mail notifications" => "E-mailes értesítések",
"You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications." => "Be kell állítani a <a href=\"tiki-admin.php?page=general\">Küldési E-mail címet</a> az E-mailes értesítések létrehozása előtt",
"Add notification" => "Értesítés hozzáadása",
"Alert" => "Riasztás",
"Event:" => "Esemény:",
// "Destination" => "Destination",
// "Myself" => "Myself",
// "Note that a user is not notified for his own action" => "Note that a user is not notified for his own action",
"Event" => "Esemény",
"User / Group" => "Felhasználó / Csoport",
// "Trackers Outbound Emails" => "Trackers Outbound Emails",
// "Forums Outbound Emails" => "Forums Outbound Emails",
"Admin Polls" => "Szavazások adminisztrálása",
"List polls" => "Szavazások listázása",
"Edit this poll" => "Ezen szavazást szerkesztése",
"Preview poll" => "Szavazás előnézet",
// "Add poll option" => "Add poll option",
// "Edit poll option" => "Edit poll option",
"Poll options" => "Szavazás opciók",
"Votes" => "szavazatok",
"Set last poll as current" => "Az utolsó szavazás jelenlegivé tétele",
"Close all polls but last" => "Minden szavazás bezárása az utolsó kivételével",
"Activate all polls" => "Minden szavazás aktiválása",
"Create poll" => "Kérdőív létrehozása",
"Edit poll" => "Kérdőív szerkesztése",
"active" => "aktív",
"current" => "jelenlegi",
"object" => "objektum",
// "Toggle Quick Options" => "Toggle Quick Options",
"Add Option" => "Opció hozzáadása",
// "Leave box empty to delete an option" => "Leave box empty to delete an option",
// "Votes older than these days are not considered" => "Votes older than these days are not considered",
"0 for no limit" => "0 ha nincs szükség határra",
"Objects" => "Objektumok",
"Results" => "Eredmények",
"Add poll to pages" => "Kérdőív hozzáadása oldalakhoz",
// "{\$channels[ix].title}" => "{\$channels[ix].title}",
// "This menu shows only Polls with 'status': \"template\"" => "This menu shows only Polls with 'status': \"template\"",
"Wiki pages" => "Wiki oldalak",
// "{\$listPages[ix].pageName|escape}" => "{\$listPages[ix].pageName|escape}",
"Lock the pages" => "Oldalak zárolása",
"Admin External Feeds" => "Külső feed-ek adminisztrálása",
"Tips" => "Tippek",
"This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or" => "Ezen az oldalon a Tiki által beolvasott/importált külső feed-ek beállítását lehet elvégezni. Feed-ek generálása/exportálása az Adminisztrációs Központ oldalán található Feed-ek pont alatt végezhető el, gyors linkhez",
// "To use feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed" => "To use feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed",
"Content for the feed" => "Az adatfolyam tartalma",
"External Feeds" => "Külső feed-ek",
"Show Title?" => "Cím megjelenítése?",
"Show Date?" => "Dátum megjelenítése?",
"Refresh rate:" => "Frissítés gyakorisága:",
"View feed" => "Feed megtekintése",
"Article Generator" => "Cikk generátor",
// "Edit Feed" => "Edit Feed",
// "Create Feed" => "Create Feed",
"Create new external feed" => "Új külső feed létrehozása",
"show feed title:" => "Feed címének megjelenítése:",
"show publish date:" => "Publikálás dátumának megjelenítése:",
// "The article generator will create a new article for every item read in the RSS feed" => "The article generator will create a new article for every item read in the RSS feed",
// "Use Article Submission System" => "Use Article Submission System",
// "Publish in the future" => "Publish in the future",
// "-1 to use original publishing date from the feed" => "-1 to use original publishing date from the feed",
// "Configure" => "Configure",
"Security Admin" => "Biztonsági beállítások",
"To <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">report any security issues</a>." => "<a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">Biztonsággal kapcsolatos események jelentése itt</a>",
// "For additional security checks, please visit <a href=\"tiki-check.php\">Tiki Server Compatibility Check</a>" => "For additional security checks, please visit <a href=\"tiki-check.php\">Tiki Server Compatibility Check</a>",
// "Tiki settings" => "Tiki settings",
"Tiki variable" => "Tiki változó",
"Risk Factor" => "Kockázati faktor",
"Explanation" => "Magyarázat",
"About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors" => "WikiPluginok és biztonság: Csak a  \"tiki_p_plugin_approve\" jogosultságot adjuk meg azoknak a szerkesztőknek akikben megbízunk",
"You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)" => "Kockázatos pluginokat itt deaktiválhatjuk: (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)",
"Security checks" => "Biztonsági ellenőrzések",
"Check all tiki files" => "Összes tiki fájl ellenőrzése",
"Note, that this can take a very long time. You should check your max_execution_time setting in php.ini." => "Ez a művelet nagyon sokáig eltarthat, érdemes előtte ellenőrizni a max_execution_time beállítást a php.ini-ben",
"File checks" => "Fájlok ellenőrzése",
"Check file permissions" => "Fájl jogosultságok ellenőrzése",
"This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments." => "Ez az ellenőrzés igyekszik megtalálni a problematikusnak tűno jogosultsági beállításokkal rendelkező fájlokat. Megeshet hogy az itt problematikusnak feltüntetett fájlhoz kötodő jogosultságok bizonyos környezetekben nem számítanak problematikusnak vagy éppen elkerülhetetlenek (mivel abban a környezetben nem változtathatóak).",
"See end of table for detailed explanations." => "A tábla végén részletes magyarázat található",
"owner" => "tulajdonos",
"special" => "speciális",
"user" => "felhasználó",
"group" => "csoport",
"other" => "egyéb",
// "uid" => "uid",
// "gid" => "gid",
// "suid" => "suid",
// "sgid" => "sgid",
"sticky" => "ragadós",
// "r" => "r",
// "w" => "w",
// "Set User ID (suid) files" => "Set User ID (suid) files",
// "World writable files or directories" => "World writable files or directories",
// "Files or directories the Webserver can write to" => "Files or directories the Webserver can write to",
// "Strange Inodes (not file, not link, not directory)" => "Strange Inodes (not file, not link, not directory)",
// "Executable files" => "Executable files",
// "What to do with these check results" => "What to do with these check results",
// "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"" => "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"",
// "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content" => "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content",
// "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information" => "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information",
// "Inodes that are not files or directories are not part of tiki. Review these Inodes" => "Inodes that are not files or directories are not part of tiki. Review these Inodes",
// "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod" => "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod",
"Admin Shoutbox Words" => "Az üzenőfal szóhasználatának beállításai",
"Add Banned Word" => "Tiltott szó hozzáadása",
// "Are you sure you want to delete this word" => "Are you sure you want to delete this word",
// "XML Zip Import" => "XML Zip Import",
"The structure" => "A struktúra",
"has just been created." => "létrejött",
"You will remove structure" => "A struktúra eltávolításra kerül",
"Destroy the structure leaving the wiki pages" => "A struktúra megsemmisítése meghagyva a wiki lapokat",
"Destroy the structure and remove the pages" => "A struktúra megsemmisítése és a lapok eltávolítása",
// "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict" => "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict",
// "The following pages have automatically been categorized with the same categories as the structure" => "The following pages have automatically been categorized with the same categories as the structure",
// "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent" => "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent",
// "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent" => "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent",
"Edit structure" => "Struktúra szerkesztése",
"View structure" => "Struktúra megtekintése",
"Export Pages" => "Oldalak exportálása",
"PDF" => "PDF",
"Dump Tree" => "Struktúra kimentése",
"Create WebHelp" => "Websúgó létrehozása",
"View WebHelp" => "Websúgó megjelenítése",
"XML Zip" => "XML Zip",
// "Delete with the pages" => "Delete with the pages",
"Create New Structure" => "Új struktúra létrehozása",
"Alias" => "Megjelenített neve",
"Tree" => "Fa",
"Use single spaces to indent structure levels" => "Szóköz használatával lehetséges a struktúra szintjeinek megadása",
"Edit survey questions:" => "Kérdőív kérdések szerkesztése:",
"Add a New Question" => "Új kérdés hozzáadása",
"List surveys" => "Kérdőív lista",
"Survey Stats" => "Kérdőív statisztika",
"This survey stats" => "Ezen kérdőív statisztikája",
"Edit this Survey" => "Kérdőív szerkesztése",
"Admin Surveys" => "Kérdőív karbantartás",
// "Edit Survey Question" => "Edit Survey Question",
"Add a New Question to this survey" => "Kérdés hozzáadása a kérdőívhez",
"Question" => "Kérdés",
"One choice" => "Egy válasz",
"Multiple choices" => "Több válasz",
"Multiple choices of thumbnails from a file gallery" => "Több előnézeti kép kiválasztása fájlgalériából",
"Short text" => "Rövid szöveg",
"Wiki textarea" => "Wiki szöveges terület",
"Rate (1..5)" => "Súlyozás (1..5)",
"Rate (1..10)" => "Súlyozás (1..10)",
"Answer is mandatory:" => "Kötelező válasz",
"Number of required answers (for multiple choices):" => "Szükséges válaszok száma (többszörös választás esetén):",
// "For a multiple answer question put the answers into the following field, separated by a comma. Example: one,two,many,lots" => "For a multiple answer question put the answers into the following field, separated by a comma. Example: one,two,many,lots",
"For a rate, you can give the maximum value." => "Értékelés maximális értéke",
// "For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4" => "For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4",
"For the 'wiki textarea' type, options are: rows,columns. Example: 10,60" => "A 'wiki szövegterület' típushoz, opciók: sor, oszlop. Például: 10,60",
"Options (if apply)" => "Beállítások (ha szükséges)",
"Questions" => "Kérdések",
"Admin surveys" => "Kérdőívek adminisztrálása",
"List Surveys" => "Kérdőív lista",
"Create Survey" => "Kérdőív létrehozása",
"Create/Edit Surveys" => "Kérdőív létrehozása / szerkesztése",
"Edit this Survey:" => "Ezt a kérdőívet szerkeszd:",
"Create New Survey" => "Új kérdőív létrehozása",
"There are individual permissions set for this survey" => "Ehhez a kérdőívhez egyéni jogosultságok vannak beállítva",
"Tiki Cache/System Admin" => "Cache/rendszer",
"If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed)." => "Ürítsük ki a cache-t ha a Tiki furcsán kezd viselkedni. Nagyon fontos a cache törlése (ha kell FTP/SSH segítségével) rendszerfrissítés (upgrade) után is",
// "Also see \"Rebuild Index\" in the <a href=\"tiki-admin.php?page=search\">Search Admin Panel</a>" => "Also see \"Rebuild Index\" in the <a href=\"tiki-admin.php?page=search\">Search Admin Panel</a>",
// "Clear cached content" => "Clear cached content",
// "Directory to clear" => "Directory to clear",
"Empty" => "Kiürítés",
"Directories to save" => "Mentendő könyvtárak",
"Full Path to the Zip File" => "Zip fájl teljes útvonala",
"Generate a zip of those directories" => "Zip fájl generálása könyvtárakból",
"A zip has been written to %0" => "A zip fájl kiírásra került ide: %0",
"Directory is not writeable" => "A könyvtár nem írható",
"Clean" => "Törlés",
// "Groups still used in the database but no more defined" => "Groups still used in the database but no more defined",
// "Click to remove" => "Click to remove",
// "Admin Tokens" => "Admin Tokens",
// "List tokens" => "List tokens",
// "Entry" => "Entry",
// "Timeout" => "Timeout",
// "Max hits" => "Max hits",
// "Add new token" => "Add new token",
// "Token successfully created" => "Token successfully created",
// "Full URL" => "Full URL",
// "Timeout in seconds (-1 for unlimited)" => "Timeout in seconds (-1 for unlimited)",
// "Maximum number of hits (-1 for unlimited)" => "Maximum number of hits (-1 for unlimited)",
// "Groups (separated by comma)" => "Groups (separated by comma)",
"View mode" => "Megtekintési mód",
"Wiki and WYSIWYG" => "Wiki és WYSIWYG",
"Wiki only" => "Csak Wiki",
"WYSIWYG only" => "Csak WYSIWYG",
// "Visual Wiki" => "Visual Wiki",
"Load" => "Betöltés",
// "Reset to Global" => "Reset to Global",
// "Reset to defaults" => "Reset to defaults",
"Auto Reloading" => "Automatikus újratöltés",
"Row" => "Sor",
"Formatting Tools:" => "Formázó eszközök:",
"Plugin Tools:" => "Plugin eszközök:",
// "Edit tool" => "Edit tool",
"Label:" => "Címke:",
// "Wysiwyg Token" => "Wysiwyg Token",
// "Plugin name" => "Plugin name",
"Custom Tools:" => "Saját eszközök:",
// "Add a new custom tool" => "Add a new custom tool",
"To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br />\nDrag icons back from the toolbar rows onto the full list to remove them.<br />\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br />\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save." => "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br /> Drag icons back from the toolbar rows onto the full list to remove them.<br /> Icons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br /> To save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save.",
// "If you are experiencing problems with this page after upgrading from Tiki 4 please use this link to delete all your customised tools" => "If you are experiencing problems with this page after upgrading from Tiki 4 please use this link to delete all your customised tools",
"Delete all custom tools" => "Összes saját eszköz törlése",
"Warning: There is no undo!" => "Figyelem: Nem lehet visszaállítani!",
// "Admin Article Topics" => "Admin Article Topics",
// "Add topic" => "Add topic",
"topic image" => "téma kép",
// "Active Permissions" => "Active Permissions",
"Inactive - Click to Activate" => "Inaktív - Klikk az aktiváláshoz",
"Deactivate" => "Deaktiválás",
"Active - Click to Deactivate" => "Aktív - Klikk a deaktiváláshoz",
"Remove with articles" => "Eltávolítás cikkekkel együtt",
"Admin Tracker" => "Űrlap adminisztrálása",
"Tracker fields" => "Űrlapmezők",
"Mandatory" => "Kötelező",
// "Save All" => "Save All",
// "Remove Selected" => "Remove Selected",
// "Export Selected" => "Export Selected",
// "Add Field" => "Add Field",
// "Import Tracker Fields" => "Import Tracker Fields",
// "Raw Fields" => "Raw Fields",
// "Preserve Field IDs" => "Preserve Field IDs",
"Transitions" => "Tranzíciók",
// "Subset Selection" => "Subset Selection",
// "Category Selection" => "Category Selection",
// "Group Selection" => "Group Selection",
// "Type in a group name and click \"enter\"" => "Type in a group name and click \"enter\"",
// "Once you have selected at least two, click" => "Once you have selected at least two, click",
// "and then, click the \"New/Edit\" tab which will appear above" => "and then, click the \"New/Edit\" tab which will appear above",
// "Draw Transition Diagram" => "Draw Transition Diagram",
// "Guards" => "Guards",
// "preserved" => "preserved",
// "Assign permissions for transition" => "Assign permissions for transition",
// "No transitions" => "No transitions",
// "New / Edit" => "New / Edit",
// "Edit <em>%0</em>" => "Edit <em>%0</em>",
// "New transition" => "New transition",
// "Upon trigger, preserve the initial state" => "Upon trigger, preserve the initial state",
"Members" => "Tagok",
// "No guards on this transition" => "No guards on this transition",
// "New Guard" => "New Guard",
// "Exactly" => "Exactly",
// "At Least" => "At Least",
// "At Most" => "At Most",
// "States" => "States",
"Admin groups" => "Csoportok adminisztrálása",
"Admin users" => "Felhasználók adminisztrálása",
"Add new group" => "Új csoport hozzáadása",
// "Invitation List" => "Invitation List",
"List of existing groups" => "Létező csoportok listája",
"Inherits Permissions from" => "Jogosultságokat örök innen:",
"User Choice" => "Felhasználó kiválasztása",
// "{\$users[user].groupDesc|escape|nl2br}" => "{\$users[user].groupDesc|escape|nl2br}",
"Group Homepage" => "Csoport kezdőlapja",
// "{\$users[user].groupHome}" => "{\$users[user].groupHome}",
// "{\$users[user].userChoice}" => "{\$users[user].userChoice}",
"Edit group" => "Csoport szerkesztése",
"Add a New Group" => "Új csoport hozzáadása",
// "Group is NOT being monitored. Click icon to START monitoring" => "Group is NOT being monitored. Click icon to START monitoring",
// "Group IS being monitored. Click icon to STOP monitoring" => "Group IS being monitored. Click icon to STOP monitoring",
"Inherit permissions directly from following groups." => "Jogosultságok közvetlen öröklése a következő csoportoktól",
"Also inheriting permissions from the following groups (indirect inheritance through the groups selected above)." => "Jogosultságok öröklése az alábbi csoportoktól (indirekt öröklés a fentebb kiválasztott  csoportok alapján)",
// "Group Homepage or Url" => "Group Homepage or Url",
"Use wiki page name or full URL" => "Egy Wiki oldal nevét vagy teljes elérési utat (URL-t) kell használni",
// "For other Tiki features, use links relative to the Tiki root (such as <em>/tiki-forums.php</em>)" => "For other Tiki features, use links relative to the Tiki root (such as <em>/tiki-forums.php</em>)",
"Default category assigned to uncategorized objects edited by a user with this default group" => "Alapértelmezett kategória melybe a nem kategorizált objektumok kerülnek melyeket az itt megadott alapértelmezett csoport egy felhasználója szerkesztett",
"Group Theme:" => "Csoport stílusa",
// "Use site default" => "Use site default",
// "Group Information Tracker" => "Group Information Tracker",
"choose a group tracker ..." => "csoportűrlap kiválasztása...",
// "choose a field .." => "choose a field ..",
// "Users Information Tracker" => "Users Information Tracker",
"choose a users tracker ..." => "felhasználói űrlap kiválasztása...",
"Users Information Tracker Fields Asked at Registration Time<br />(fieldIds separated with :)" => "Regisztrációkor kért felhasználói űrlap mezők <br />(mezőId-k elválasztója :)",
"User can assign to the group himself" => "Felhasználó felveheti magát a csoportba",
"Users are automatically unassigned from the group after" => "A felhasználók automatikusan kikerülnek a csoportból ennyi idő után:",
"0 or empty for never" => "0 vagy üresen hagyni (=soha)",
// "Or, users are automatically unassigned from the group at an anniversary date" => "Or, users are automatically unassigned from the group at an anniversary date",
// "MMDD for annual or DD for monthly" => "MMDD for annual or DD for monthly",
// "Payment for membership extension is prorated at a minimum interval of a" => "Payment for membership extension is prorated at a minimum interval of a",
"Users are automatically assigned at registration in the group if their emails match the pattern" => "A mintának megfelelő E-mail címmel rendelkező felhasználók a regisztráció során automatikusan bekerülnek a csoportba",
"Example: " => "Például:",
// "Assign group <em>management</em> permissions" => "Assign group <em>management</em> permissions",
// "Group tracker item : {\$groupitemid}" => "Group tracker item : {\$groupitemid}",
"Edit Item" => "Tétel szerkesztése",
// "Group tracker item not found" => "Group tracker item not found",
// "Choose a field .." => "Choose a field ..",
// "Members List" => "Members List",
// "Expire" => "Expire",
// "Remove from Group" => "Remove from Group",
// "users in group" => "users in group",
// "Banned members List" => "Banned members List",
// "Unban user" => "Unban user",
// "Add or Ban members to" => "Add or Ban members to",
// "Add to group" => "Add to group",
// "Ban user from group" => "Ban user from group",
"Import/Export" => "Importálás/Exportálás",
// "Download CSV export" => "Download CSV export",
"Charset encoding" => "Karakterkódolás",
// "UTF-8" => "UTF-8",
// "ISO-8859-1" => "ISO-8859-1",
// "Assign users to group" => "Assign users to group",
// "Each user in the file must already exist" => "Each user in the file must already exist",
// "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>" => "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>",
"Add a New User" => "Új felhasználó hozzáadása",
// "Since this Tiki site is in slave mode and imports groups, the master groups will be automatically reimported at each login" => "Since this Tiki site is in slave mode and imports groups, the master groups will be automatically reimported at each login",
// "Since this Tiki site is in slave mode and imports preferences, the master user preferences will be automatically reimported at each login" => "Since this Tiki site is in slave mode and imports preferences, the master user preferences will be automatically reimported at each login",
// "{\$tikifeedback[n].mes|escape}" => "{\$tikifeedback[n].mes|escape}",
"Batch Upload Results" => "Tömeges (kötegelt) feltöltés eredménye",
// "Updated users" => "Updated users",
"Rejected users" => "Elutasított felhasználók",
"Reason" => "Ok",
"More Criteria" => "További kritériumok",
"Group (direct)" => "Csoport (közvetlen)",
// "OpenID" => "OpenID",
"Edit Account Settings" => "Fiókadatok szerkesztése",
// "N" => "N",
// "Registered %0 ago" => "Registered %0 ago",
// "Need to validate email" => "Need to validate email",
// "Edit Included Group" => "Edit Included Group",
// "Edit Group" => "Edit Group",
"default" => "alapértelmezett",
// "Remove %0 from %1" => "Remove %0 from %1",
// "Assign to group" => "Assign to group",
// "Assign %0 to groups" => "Assign %0 to groups",
// "Edit Account Settings: %0" => "Edit Account Settings: %0",
// "Change user preferences: %0" => "Change user preferences: %0",
// "User Information: %0" => "User Information: %0",
// "Validate user: %0" => "Validate user: %0",
// "Confirm user email: %0" => "Confirm user email: %0",
// "Invalidate email" => "Invalidate email",
// "Remove link with OpenID account" => "Remove link with OpenID account",
"Remove Users and their Userpages" => "Felhasználók és felhasználói oldalaik eltávolítása",
"Manage Group Assignments" => "Csoporthozzárendelések kezelése",
"Set Default Groups" => "Alapértelmezett csoportok megadása",
"Send a wiki page by Email" => "Wiki oldal küldése E-mailben",
"Assign selected to" => "Kiválasztottak hozzárendelése",
"Remove selected from" => "Kiválasztottak eltávolítása",
"the following groups:" => "a következő csoportokhoz/csoportokból:",
// "Set the default group of the selected users to" => "Set the default group of the selected users to",
// "bcc" => "bcc",
// "Edit user" => "Edit user",
// "Assign user to Groups" => "Assign user to Groups",
// "Use the email as username" => "Use the email as username",
// "Warning: changing the username could require the user to change his password (for user registered with an old Tiki&lt;=1.8)" => "Warning: changing the username could require the user to change his password (for user registered with an old Tiki&lt;=1.8)",
// "Warning: it will mess with slave intertiki sites that use this one as master" => "Warning: it will mess with slave intertiki sites that use this one as master",
// "No password is required" => "No password is required",
// "Tiki is configured to delegate the password managment to LDAP" => "Tiki is configured to delegate the password managment to LDAP",
"Repeat Password:" => "Jelszó újra:",
"User must change password at next login" => "A felhasználónak meg kell változtatnia a jelszavát a legközelebbi bejelentkezéskor",
"Send an email to the user in order to allow him to validate his account." => "E-mail küldése a felhasználó részére hogy validálhassa fiókját",
"You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a>" => "Be kell állítani a <a href=\"tiki-admin.php?page=general\">Küldési E-mail cím</a>et",
// "Pass confirmed" => "Pass confirmed",
// "Email confirmed" => "Email confirmed",
// "%0 days ago" => "%0 days ago",
// "Current Login" => "Current Login",
"Last Login" => "Legutolsó bejelentkezés",
"User tracker item : {\$usersitemid}" => "Felhasználói űrlap tétel : {\$usersitemid}",
// "You do not have permission to edit this user" => "You do not have permission to edit this user",
// "CSV file layout" => "CSV file layout",
// "login,password,email,groups,default_group,realName<br />user1,pass1,email1,group1,group1<br />user2,pass2,email2,\\\"group1,group2\\\",group1" => "login,password,email,groups,default_group,realName<br />user1,pass1,email1,group1,group1<br />user2,pass2,email2,\\\"group1,group2\\\",group1",
// "Only login, password, email are mandatory.Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma" => "Only login, password, email are mandatory.Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma",
"Don't overwrite" => "Ne írja felül",
"Overwrite groups:" => "Csoportok felülírása:",
"Create groups:" => "Csoportok létrehozása:",
"User must change password at first login:" => "A felhasználónak meg kell változtatnia a jelszavát első bejelentkezéskor:",
"You can export users of a group in <a href=\"tiki-admingroups.php\">admin->groups->a_group</a>" => "Egy adott csoportba tartozó felhasználókat itt lehet exportálni <a href=\"tiki-admingroups.php\">Adminisztráció->Csoportok->a_group</a>",
// "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences" => "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences",
"Admin Article Types" => "Cikk típusok adminisztrálása",
// "Article Types" => "Article Types",
// "{\$types[user].type|escape}" => "{\$types[user].type|escape}",
// "View articles with this type" => "View articles with this type",
// "Author rating" => "Author rating",
"Show before publish date" => "Megjelenítés a publikálás dátuma előtt",
"Show after expire date" => "Megjelenítés lejárat dátuma után",
"Heading only" => "Csak fejléc",
// "Comment can rate article" => "Comment can rate article",
"Show image" => "Kép megjelenítése",
"Show avatar" => "Avatár megjelenítése",
"Show publish date" => "Publikálás dátumának megjelenítése",
"Show expire date" => "Lejárati dátum megjelenítése",
"Show reads" => "Olvasások megjelenítése",
"Show size" => "Méret megjelenítése",
"Show topline" => "Felső vonal megjelenítése",
"Show subtitle" => "Felirat megjelenítése",
"Show source" => "Forrás megjelenítése",
// "Show image caption" => "Show image caption",
"Creator can edit" => "Létrehozó szerkesztheti",
"Custom attribute" => "Saját attribútum",
// "Add Type" => "Add Type",
// "Add article type" => "Add article type",
// "Assign User %0 to Groups" => "Assign User %0 to Groups",
// "{\$users[user].groupDesc|escape}" => "{\$users[user].groupDesc|escape}",
"Assign User to Group" => "Felhasználó hozzárendelése csoporthoz",
"backlinks to" => "hivatkozások a",
"No backlinks to this page" => "Erre az oldalra nem hivatkozik másik oldal",
// "Directory batch upload" => "Directory batch upload",
"Browse Gallery" => "Galéria böngészése",
"available images" => "rendelkezésre álló képek",
"Filesize" => "Fájlméret",
"Filetype" => "Fájltípus",
// "Remove File Extension from Image Name" => "Remove File Extension from Image Name",
// "eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field" => "eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field",
// "Convert the last sub directory to a sub gallery" => "Convert the last sub directory to a sub gallery",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created",
// "Use the last sub directory name as description" => "Use the last sub directory name as description",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created",
// "Select a Gallery" => "Select a Gallery",
// "Browse File Gallery" => "Browse File Gallery",
// "Please do not use this feature to upload data into the database" => "Please do not use this feature to upload data into the database",
// "Available Files" => "Available Files",
// "Remove extension from filename" => "Remove extension from filename",
// "Select a File Gallery" => "Select a File Gallery",
// "Process files" => "Process files",
"Edit Post" => "Poszt szerkesztése",
"New Post" => "Új poszt",
"View post" => "Poszt megtekintése",
"View Blog" => "Blog megtekintése",
"Note: Remember that this is only a preview, and has not yet been saved" => "Figyelem: Ez csak előnézet, még nem történt mentés",
"Excerpt:" => "Kivonat:",
"Trash" => "Lomtár",
"Mark entry as private:" => "Privát bejegyzés",
"Admin Category" => "Kategóriák beállítása",
"Admin the Category System" => "Kategória rendszer adminisztrálása",
"Browse in" => "Böngészés",
"Image galleries" => "Képgalériák",
"Trackers Items" => "Űrlap tételek",
"Sheets" => "Táblázatok",
"in the current category - and its subcategories: " => "a jelenlegi kategóriában - és annak alkategóriáiban:",
"Hide subcategories objects" => "Alkategóriák objektumainak elrejtése",
"Show subcategories objects" => "Alkategóriák objektumainak megjelenítése",
// "Upper level" => "Upper level",
// "{\$objects[ix].type|replace:\"wiki page\":\"wiki\"|replace:\"trackeritem\":\"tracker item\"}" => "{\$objects[ix].type|replace:\"wiki page\":\"wiki\"|replace:\"trackeritem\":\"tracker item\"}",
"Browse related tags" => "Címkék böngészése",
"Network of Tags related to" => "Kapcsolódó címkék",
"With all selected tags" => "Összes kiválasztott címke",
"With one selected tag" => "Egyik kiválasztott címke",
"With last selected tag" => "Legutolsó kiválasztott címke",
"More Popular Tags" => "További népszerű címkék",
"Alphabetically" => "Abc sorrend",
"By Size" => "Méret",
"Cloud" => "Felhő",
// "{\$feature_label}" => "{\$feature_label}",
// "No result found" => "No result found",
// "result found" => "result found",
// "{\$objects[ix].type|replace:\"wiki page\":\"Wiki\"|replace:\"article\":\"Article\"|regex_replace:\"/tracker [0-9]*/\":\"tracker item\"}" => "{\$objects[ix].type|replace:\"wiki page\":\"Wiki\"|replace:\"article\":\"Article\"|regex_replace:\"/tracker [0-9]*/\":\"tracker item\"}",
"Browsing Gallery" => "Galériák böngészése",
"List Galleries" => "Galéria lista",
"Edit Gallery" => "Galéria szerkesztése",
"Rebuild Thumbnails" => "Előnézeti képek újraépítése",
"Upload Image" => "Kép feltöltése",
// "Directory Batch" => "Directory Batch",
"List Gallery" => "Galéria listázása",
"All Images" => "Összes kép",
// "RSS" => "RSS",
"Monitor this Gallery" => "Galéria figyelése",
"Stop Monitoring this Gallery" => "Galéria figyelésének felfüggesztése",
// "{\$advice}" => "{\$advice}",
"Sort Images by" => "A képek rendezése",
"subgallery" => "algaléria",
"Subgallery" => "Algaléria",
"Original Size" => "Eredeti méret",
"rotate right" => "jobbra forgatás",
"rotate" => "forgatás",
"Details" => "Részletek",
"popup" => "előugró",
// "You can view this gallery's configured image (first, random, etc.) in your browser using" => "You can view this gallery's configured image (first, random, etc.) in your browser using",
// "You can include the gallery's image in an HTML page using" => "You can include the gallery's image in an HTML page using",
// "You can include the image in a tiki page using" => "You can include the image in a tiki page using",
"Browsing Image" => "Képek böngészése",
"Return to Gallery" => "Vissza a galériához",
// "Edit Image" => "Edit Image",
"First Image" => "Első kép",
"Prev Image" => "Előző kép",
"Smaller" => "Kisebb",
"Bigger" => "Nagyobb",
"Popup window" => "Előugró ablak",
"Next Image" => "Következő kép",
// "Slideshow Forward" => "Slideshow Forward",
"Last Image" => "Utolsó kép",
// "Cyclic" => "Cyclic",
// "Click to zoom" => "Click to zoom",
"Image Name" => "Kép neve",
"Image size" => "Kép méret",
// "Image Scale" => "Image Scale",
"Latitude (WGS84/decimal degrees)" => "Szélességi fok (WGS84/decimális fokokban kifejezve)",
"Longitude (WGS84/decimal degrees)" => "Hosszúsági fok (WGS84/decimális fokokban kifejezve)",
"Move image" => "Kép mozgatása",
// "Include the image in a tiki page using the following syntax" => "Include the image in a tiki page using the following syntax",
// "To include the image in an HTML page" => "To include the image in an HTML page",
// "To link to this page from another tiki page" => "To link to this page from another tiki page",
"Stop Monitoring this Page" => "Oldal figyelésének felfüggesztése",
"Monitor this Page" => "Oldal figyelése",
"Export Calendars" => "Naptárak exportálása",
// "Click to export calendars" => "Click to export calendars",
"Visible Calendars" => "Látható naptárak",
// "Click to select visible calendars" => "Click to select visible calendars",
"Group Calendars" => "Csoport naptárak",
"Export calendars" => "Naptárak exportálása",
"advanced parameters" => "További paraméterek",
"Export as iCal" => "iCal export",
"January" => "Január",
"February" => "Február",
"March" => "Március",
"April" => "Április",
"May" => "Május",
"June" => "Június",
"July" => "Július",
"August" => "Augusztus",
"September" => "Szeptember",
"October" => "Október",
"November" => "November",
"December" => "December",
"Jan" => "Jan.",
"Feb" => "Febr.",
"Mar" => "Márc.",
"Apr" => "Ápr.",
"Jun" => "Jún",
"Jul" => "Júl.",
"Aug" => "Aug.",
"Sep" => "Szept.",
"Oct" => "Okt.",
"Nov" => "Nov.",
// "Dec" => "Dec",
"Sun" => "Vasárnap",
"Mon" => "Hétfő",
"Tue" => "Kedd",
"Wed" => "Szerda",
"Thu" => "Csütörtök",
"Fri" => "Péntek",
"Sat" => "Szombat",
"today" => "ma",
// "all-day" => "all-day",
// "Export event" => "Export event",
"Edit event" => "Esemény szerkesztése",
"Delete event" => "Esemény törlése",
"View event" => "Esemény megtekintése",
"Organized by" => "Szervező",
"Classification" => "Besorolás",
"Tentative" => "Függő",
"Confirmed" => "Megerősítve",
"Cancelled" => "Visszavonva",
// "View this Week" => "View this Week",
// "Change Focus" => "Change Focus",
// "+" => "+",
"View this Day" => "Ezen nap megtekintése",
// "o" => "o",
// "Calendar event : " => "Calendar event : ",
"New event" => "Új esemény",
"Edit/Delete event" => "Esemény szerkesztése",
"Edit Calendar Item" => "Naptár tétel szerkesztése",
// "New Calendar Item" => "New Calendar Item",
"Recurrence" => "Ismétlődés",
"This event depends on a recurrence rule" => "Az esemény ismétlődik",
"This event is not recurrent" => "Ez az esemény nem ismétlődik",
"On a weekly basis" => "Hetente",
"Each" => "Minden",
"of the week" => "a héten",
"On a monthly basis" => "Havonta",
"of the month" => "napja a hónapnak",
"On a yearly basis" => "Évente",
// "Starting on" => "Starting on",
// "ending by" => "ending by",
// "ending after" => "ending after",
// "events" => "events",
// "Start period" => "Start period",
"End after" => "Befejezés ennyi előfordulás után",
"occurrences" => "előfordulás",
// "occurrence" => "occurrence",
"End before" => "Befejezés ez előtt",
// "Event occurs once on" => "Event occurs once on",
// "Event is repeated" => "Event is repeated",
// "times" => "times",
// "{\$daysnames[\$recurrence.weekday]}s" => "{\$daysnames[\$recurrence.weekday]}s",
// "of every month" => "of every month",
// "on each" => "on each",
// "{\$monthnames[\$recurrence.dateOfYear_month]}" => "{\$monthnames[\$recurrence.dateOfYear_month]}",
// "starting" => "starting",
// "ending" => "ending",
// "Show duration" => "Show duration",
// "Events cannot end before they start" => "Events cannot end before they start",
"No description" => "Nincs leírás",
"or new" => "vagy új",
// "Choose users to alert" => "Choose users to alert",
// "Withdraw me from the list of participants" => "Withdraw me from the list of participants",
// "Add me to the list of participants" => "Add me to the list of participants",
// "Participant names separated by comma" => "Participant names separated by comma",
"Roles" => "Szerepek",
"chair" => "vezető",
// "default role" => "default role",
"required participant" => "kötelező résztvevő",
"optional participant" => "opcionális résztvevő",
"non participant" => "nem résztvevő",
// "Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in" => "Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in",
// "role:login_or_email,login_or_email" => "role:login_or_email,login_or_email",
// "If no role is provided, default role will be \"Chair participant\"" => "If no role is provided, default role will be \"Chair participant\"",
"Update this event only" => "Csak ezen esemény frissítése",
"Update every unchanged events of this recurrence rule" => "Az ismétlődési szabály összes változatlan eseményének frissítése",
"Update every events of this recurrence rule" => "Ezen ismétlődési szabály összes eseményének frissítése",
"Delete Recurrent events" => "Ismétlődő események törlése",
"Calendar import" => "Naptár importálása",
"Calendar has been updated" => "Naptár frissítésre került",
// "%0 column name can be used instead of %1" => "%0 column name can be used instead of %1",
"D" => "N",
"W" => "H",
"M" => "Hó",
// "%d/%m" => "%d/%m",
// "%m/%d" => "%m/%d",
"Advanced parameters for iCal export" => "iCal exportálás további paraméterei",
"Calendars to be exported" => "Exportálásra kerülő naptárak",
"Export calendars iCal" => "Exportálás iCal formátumban",
"Export calendars CSV" => "Exportálás CSV formátumban",
// "Your account has been validated" => "Your account has been validated",
// "You have to choose a password to use this account" => "You have to choose a password to use this account",
"Change password enforced" => "Jelszócsere kötelező",
// "Change your password" => "Change your password",
"Old password" => "Régi jelszó",
"New password:" => "Új jelszó:",
// "Server Check" => "Server Check",
// "MySQL or MariaDB Database Properties" => "MySQL or MariaDB Database Properties",
// "Property" => "Property",
// "Tiki Fitness" => "Tiki Fitness",
// "Be careful" => "Be careful",
// "Server Information" => "Server Information",
// "Server Properties" => "Server Properties",
// "Fitness" => "Fitness",
// "Apache properties" => "Apache properties",
// "IIS properties" => "IIS properties",
// "PHP scripting language properties" => "PHP scripting language properties",
// "PHP Security properties" => "PHP Security properties",
// "MySQL Variable Information" => "MySQL Variable Information",
// "PHP Info" => "PHP Info",
"Please choose the language for this page:" => "Oldal nyelvének kiválasztása:",
// "Page: \"%0\"" => "Page: \"%0\"",
"Choose language" => "Nyelv kiválasztása",
"Success" => "Sikeres",
"Send a message to us" => "Üzenet küldése nekünk",
"Your email" => "Küldő E-mail címe",
"Contact us by email" => "Kapcsolatfelvétel E-mail-en keresztül",
"Click here to send us an email" => "E-mail küldéshez klikk az E-mail címre",
"Send another message" => "Másik üzenet küldése",
"Contacts" => "Kontaktok",
"Group View" => "Csoport nézet",
"Create/edit contacts" => "Kontaktok létrehozása/szerkesztése",
"First Name" => "Keresztnév",
"Publish this contact to groups" => "Kontakt publikálása csoportok felé",
"Last Name" => "Vezetéknév",
"Nickname" => "Becenév",
// "Copy page" => "Copy page",
// "Invalid page name" => "Invalid page name",
// "The page name specified contains unallowed characters. It will not be possible to save the page until those are removed: <strong>%0</strong>" => "The page name specified contains unallowed characters. It will not be possible to save the page until those are removed: <strong>%0</strong>",
// "The page name specified contains characters that may render the page hard to access. You may want to consider removing those: <strong>%0</strong>" => "The page name specified contains characters that may render the page hard to access. You may want to consider removing those: <strong>%0</strong>",
// "Use this name anyway" => "Use this name anyway",
// "Quick Create Multilanguage Pages" => "Quick Create Multilanguage Pages",
// "Following pages were created, as translations of each other" => "Following pages were created, as translations of each other",
// "Following pages were not created" => "Following pages were not created",
// "page already exists" => "page already exists",
// "Enter the names of a new page page in various languages" => "Enter the names of a new page page in various languages",
// "Preferred languages" => "Preferred languages",
// "Other languages" => "Other languages",
// "Create pages" => "Create pages",
// "View generated WebHelp" => "View generated WebHelp",
// "No structure" => "No structure",
// "Top page" => "Top page",
"Add a new site" => "Új weblap hozzáadása",
"You cannot add sites until Directory Categories are setup." => "Weblapok hozzáadása nem lehetséges amíg a könyvtár kategóriák nicsenek beállítva",
"Please contact the Site Administrator" => "Kapcsolatfelvétel az oldal adminisztrátorával",
// "<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>" => "<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>",
"Site added" => "Weblap hozzáadva",
"The following site was added, but may require validation by the admin before appearing on the lists." => "A weblap hozzáadásra került de lehet hogy még adminisztrátori validálásra szorul mielőtt megjelenne a listákban",
"Country:" => "Ország:",
// "{\$msg}" => "{\$msg}",
"Edit a site" => "Weblap szerkesztése",
"Add a Site" => "Weblap hozzáadása",
// "Directory Categories" => "Directory Categories",
// "{\$countries[ux]}" => "{\$countries[ux]}",
"Directory Administration" => "Könyvtár adminisztrálása",
"There are" => "Összesen",
"invalid sites" => "érvénytelen weblap van",
"valid sites" => "érvényes weblap van",
"Users have visited" => "A felhasználók",
"sites from the directory" => "könyvtári weblapot látogattak meg",
"Users have searched" => "A felhasználók",
"times from the directory" => "alkalommal kerestek a könyvtárban",
"Validate" => "Validálás",
"Admin directory categories" => "Könyvtári kategóriák adminisztrálása",
// "Parent directory category" => "Parent directory category",
"Add a directory category" => "Könyvtári kategória hozzáadása",
"Edit this directory category" => "Könyvtárkategória szerkesztése",
"Add a Directory Category" => "Linktár kategória hozzáadása",
"Children type" => "Gyerekek típusa",
// "Most visited directory sub-categories" => "Most visited directory sub-categories",
// "Directory Category description" => "Directory Category description",
// "Random directory sub-categories" => "Random directory sub-categories",
"Maximum number of children to show" => "Megjelenítendő alkategóriák száma",
// "Allow sites in this directory category" => "Allow sites in this directory category",
// "Show number of sites in this directory category" => "Show number of sites in this directory category",
"Editor group" => "Szerkesztő csoport",
// "Directory Subcategories" => "Directory Subcategories",
"cType" => "Kategória típusa",
"allow" => "engedélyezés",
"count" => "számosság",
"editor" => "szerkesztő",
"relate" => "kapcsolás",
// "Admin related directory categories" => "Admin related directory categories",
// "Add a related directory category" => "Add a related directory category",
// "Directory Category" => "Directory Category",
"Mutual" => "Kölcsönös",
// "Related directory categories" => "Related directory categories",
"Admin sites" => "Weblapok adminisztrálása",
"Is valid" => "Valid",
"Perform action with selected:" => "Akció végrehajtása a kijelöltekkel:",
"New Sites" => "Új weblapok",
"Cool Sites" => "Népszerű weblapok",
"any" => "bármely",
"in entire directory" => "teljes könyvtárban",
// "in current directory category" => "in current directory category",
"Sort by" => "Rendezési elv",
// "Hits (desc)" => "Hits (desc)",
// "Hits (asc)" => "Hits (asc)",
// "Last updated (desc)" => "Last updated (desc)",
// "Last updated (asc)" => "Last updated (asc)",
"sort" => "rendezés",
"Last updated" => "Legutóbbi frissítés",
"No records." => "Nincsenek rekordok",
"Total directory categories" => "Linktár kategóriák összesen",
"Total links" => "Összes link",
"Links to validate" => "Validálásra váró linkek",
"Searches performed" => "Végrehajtott keresések",
"Total links visited" => "Összes látogatott link",
"Directory ranking" => "Linktár rangsor",
"Validate sites" => "Weblapok validálása",
// "country" => "country",
// "Discounts" => "Discounts",
// "Max time the discount can be used in the first phase of payment" => "Max time the discount can be used in the first phase of payment",
// "-1 for illimited" => "-1 for illimited",
"Translation of this page is incomplete." => "Az oldal fordítása nem teljes",
// "To add <strong>new content</strong> to the page" => "To add <strong>new content</strong> to the page",
// "use the editor" => "use the editor",
"Edit article" => "Cikk szerkesztése",
"View Articles" => "Cikk megtekintés",
// "One of the email addresses you typed is invalid" => "One of the email addresses you typed is invalid",
// "Topline" => "Topline",
// "To translate, do not change the language and the content.\n\t\t\t\t\t\tInstead, <a href=\"%0\">create a new translation</a> in the new language" => "To translate, do not change the language and the content.\n\t\t\t\t\t\tInstead, <a href=\"%0\">create a new translation</a> in the new language",
// "Edit Translations" => "Edit Translations",
// "Attach existing article ID as translation" => "Attach existing article ID as translation",
"Author Name" => "Szerző neve",
// "{\$typei|escape}" => "{\$typei|escape}",
"Own Image" => "Saját kép",
// "If not the topic image" => "If not the topic image",
// "Article image" => "Article image",
"Use own image" => "Saját kép használata",
"Float text around image" => "Szöveg körbefolyatása a kép körül",
// "Maximum dimensions of custom image in view mode (Read Article)" => "Maximum dimensions of custom image in view mode (Read Article)",
// "If different than the uploaded image" => "If different than the uploaded image",
// "Maximum dimensions of custom image in list mode (View Articles)" => "Maximum dimensions of custom image in list mode (View Articles)",
// "If different than in view mode" => "If different than in view mode",
"Image caption" => "Képfelirat",
// "If not the topic name" => "If not the topic name",
// "Allow full HTML" => "Allow full HTML",
// "Keep any HTML tag" => "Keep any HTML tag",
// "If not enabled, Tiki will retain some HTML tags (a, p, pre, img, hr, b, i)" => "If not enabled, Tiki will retain some HTML tags (a, p, pre, img, hr, b, i)",
"Emails to be notified (separated with commas)" => "Értesítés küldése (E-mail címek vesszővel elválasztva)",
"Edit or create banners" => "Banner létrehozása és szerkesztése",
"List banners" => "Banner lista",
"URL to link the banner" => "URL melyre a banner mutat",
"Client" => "Kliens",
"Max impressions" => "Max impresszió",
"-1 for unlimited" => "-1 esetén nincs határ",
// "Max impressions for a user" => "Max impressions for a user",
"Max clicks" => "Max kattintás",
// "URIs where the banner appears only" => "URIs where the banner appears only",
// "Type each URI enclosed with the # character. Exemple:#/this_page#/tiki-index.php?page=this_page#" => "Type each URI enclosed with the # character. Exemple:#/this_page#/tiki-index.php?page=this_page#",
// "URIs where the banner will not appear " => "URIs where the banner will not appear ",
"Or, create a new zone" => "Vagy új zóna létrehozása",
"Show the banner only between these dates" => "Banner megjelenítése csak ezen dátumok között",
"From date" => "Kezdés dátuma",
"To date" => "Befejezés dátuma",
"Use dates" => "Dátumok használata",
"Show the banner only in this hours" => "Banner megjelenítése csak ezen órák között",
"Show the banner only on" => "Banner megjelenítése csak ekkor",
"Select ONE method for the banner" => "EGY módszer kiválasztása a bannerhez",
"Use HTML" => "HTML használata",
"Use image" => "Kép használata",
"Image:" => "Kép:",
"Current Image" => "Jelenlegi kép",
"Use image generated by URL (the image will be requested at the URL for each impression)" => "URL által generált kép használata (a kép minden egyes impressziónál kérésre kerül az URL-ről)",
"Use Flash" => "Flash használata",
"Movie Size" => "Film mérete",
"Pixels" => "Pixel",
"FlashPlugin min version" => "FlashPlugin min verzió",
"ex" => "pld",
"Use text" => "Szöveg használata",
"Save the Banner" => "Banner mentése",
"Remove Zones (you lose entered info for the banner)" => "Zónák eltávolítása (a bannerbe bevitt információ elveszik)",
"Edit Blog" => "Blog szerkesztése",
// "A category is mandatory" => "A category is mandatory",
"There are individual permissions set for this blog" => "Ehhez a bloghoz egyedi jogosultságok vannak beálllítva",
"Allow other users to post in this blog" => "Más felhasználók is posztolhatnak ebbe a blogba",
// "If others post to blog, author should always be owner" => "If others post to blog, author should always be owner",
"Allow search" => "Keresés engedélyezése",
"Allow comments" => "Kommentek engedélyezése",
"Display Options" => "Megjelenítési beállítások",
"Number of posts to show per page" => "Posztok száma oldalanként",
"Display blog title in posts list page" => "Blog címének megjelenítése a posztokat listázó oldalon",
"Display blog title in post page" => "Blog címének megjelenítése a poszt oldalon",
"Display blog description" => "Blog leírásának megjelenítése",
"Display breadcrumbs" => "Breadcrumb megjelenítése",
"Display author in blog posts" => "Szerző megjelenítése blog posztokban",
"Display published date in blog posts" => "Publikálás dátumának megjelenítése blog posztokban",
"Show user avatar" => "Felhasználó avatárjának megjelenítése",
"Show post related content" => "Poszthoz kapcsolódó tartalom megjelenítése",
// "The checkbox is disabled because feature_freetags is disabled globally" => "The checkbox is disabled because feature_freetags is disabled globally",
"Maximum number of related posts to display" => "Megjelenítendő kapcsolódó posztok maximális száma",
"Use post excerpt" => "Poszt kivonat használata",
"Blog heading" => "Blog fejléc",
"Heading preview" => "Fejléc előnézet",
"Blog post heading" => "Blog poszt fejléc",
// "Organizer" => "Organizer",
// "Move objects between categories" => "Move objects between categories",
// "Click on the category name you want to list. The list of objects in that category will become visible" => "Click on the category name you want to list. The list of objects in that category will become visible",
// "Select the objects you want to affect. Controls will appear in the category browser" => "Select the objects you want to affect. Controls will appear in the category browser",
// "Use the plus and minus signs to add or remove the categories on selected objects" => "Use the plus and minus signs to add or remove the categories on selected objects",
// "More results available. Please refine the search criterias" => "More results available. Please refine the search criterias",
"Select all" => "Összes kiválasztása",
// "Unselect all" => "Unselect all",
// "Edit Style Sheet" => "Edit Style Sheet",
// "Style Sheet" => "Style Sheet",
// "The file will be saved in" => "The file will be saved in",
// "choose a stylesheet" => "choose a stylesheet",
// "Try" => "Try",
// "Tiki Docs" => "Tiki Docs",
// "Save file" => "Save file",
// "Cancel editing file" => "Cancel editing file",
// "Editing file" => "Editing file",
// "Save and Back" => "Save and Back",
// "Toggle Fullscreen" => "Toggle Fullscreen",
"For more information, please see" => "További információkért lásd",
"Wiki Page Editor" => "Wiki oldal szerkesztése",
// "More help on editing wiki pages" => "More help on editing wiki pages",
// "The syntax system used for creating pages in Tiki" => "The syntax system used for creating pages in Tiki",
"Bold text" => "Félkövér szöveg",
"Italic text" => "Dőlt szöveg",
"single quotes" => "idézőjel",
"Underlined text" => "Aláhúzott szöveg",
"Colored text" => "Színezett szöveg",
"Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background." => "A megadott HTML színkódnak vagy színnévnek megfelelő színben jeleníti meg a szöveget. Szín neve két színt is tartalmazhat vesszővel elválasztva. Ebben az esetben az első szín adja meg a karakter színét, a második a háttérszínt.",
"Deleted text" => "Törölt szöveg",
"2 dashes" => "2 kötőjel",
"Headings" => "Címsorok",
"show/hide heading section. + (shown) or - (hidden) by default" => "felsorolási szekció megjelenítése/elrejtése. + (megjelenítve) vagy - (elrejtve) alapértelmezés szerint",
"Autonumbered Headings" => "Automatikusan számozott címsorok",
// "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)",
"Common optional parameters for maketoc are: title|maxdepth|levels|nums, and for toc are: order|showdesc|shownum|structId|maxdepth|pagename." => "Általános, opcionális MAKETOC paraméterek: title|maxdepth|levels|nums, and for toc are: order|showdesc|shownum|structId|maxdepth|pagename.",
"Horizontal rule" => "Vízszintes vonal",
"Text box" => "Szöveges doboz",
"Box content" => "Doboz tartalma",
"Centered text" => "Középre rendezett szöveg",
"Inserts an editable variable" => "Beilleszt egy szerkeszthető változót",
"External links" => "Külső linkek",
"use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)." => "Használjunk szögletes zárójeleket külső linkhez: [URL], [URL|link_leírás],[URL|link_leírás|reláció] vagy [URL|leírás|reláció|nocache] (ez utóbbi megakadályozza hogy a helyi wiki cache-elje a linkelt oldalt; reláció a rel attribútum használatát teszi lehetővé a link számára - hasznos lehet pld. shadowbox funkció számára).",
"For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))" => "Külső Wikihez használjuk a KülsőWikiNeve:Oldalnév vagy ((Külső Wiki Neve: Oldal Neve)) szintakszist",
"Square Brackets" => "Szögletes zárójelek",
"Use [[foo] to show [foo]." => "Használjuk a [[foo] formátumot hogy ez jelenjen meg: [foo]",
"Wiki References" => "Wiki hivatkozások",
"JoinCapitalizedWords or use" => "NagybetűsSzavakEgyesítése vagy használjuk az",
"page|description" => "oldalnév|megjelenő leírás",
"for wiki references" => "formátumot wiki hivatkozásokhoz",
"page|#anchor" => "oldal|#horgony",
"page|#anchor|desc" => "oldal|#horgony|leírás",
"for wiki heading/anchor references" => "címsor/horgony hivatkozásokhoz",
"SomeName" => "Valamilyen név",
"prevents referencing" => "megakadályozza a hivatkozást",
"Lists" => "Listák",
"for bullet lists" => "felsorolásos listákhoz",
"for numbered lists" => "számozott listákhoz",
"definition" => "definíció",
"for definiton lists" => "defincíciós listákhoz",
"Indentation" => "Behúzás",
"Creates an indentation for each plus (useful in list to continue at the same level)" => "Minden + jellel eggyel beljebb húzza (hasznos listázások ugyanazon szinten történő folytatására)",
"Tables" => "Táblák",
"row" => "sor",
"col" => "oszlop",
"Monospace font" => "Monospace betű",
"Code sample" => "Kód minta",
"(very useful especially in tables)" => "(nagyon hasznos például táblázatok esetén)",
"Multi-page pages" => "Többoldalas oldalak",
"to separate pages" => "szintakszist az oldalak elválasztásához",
"Non parsed sections" => "Nem elemzett szekciók",
"data" => "adat",
"Prevents wiki parsing of the enclosed data." => "Megakadályozza a belefoglalt adatok wiki általi elemzését",
"Preformated sections" => "Előformázott szekciók",
// "~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text" => "~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text",
"~tc~ Tiki Comment ~/tc~ makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  ~hc~ HTML Comment ~/hc~ makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar." => "~tc~ Tiki komment ~/tc~ Tiki kommentet készít. Nem kerül megjelenítésre, de mentésre kerül a fájlba a visszakereshetőség kedvéért.  ~hc~ HTML komment ~/hc~ HTML kommentet készít, mely megjelenik kommentként a végleges HTML-ben. Általában ezek nem kerülnek megjelenítésre a böngészőkben de a például a \"Forrás megtekintése\" vagy hasonló funkció által láthatóvá válnak.",
"Block Preformatting" => "Blokk előformázása",
"Indent text with any number of spaces to turn it into a monospaced block that still follows other Wiki formatting instructions. It will be indended with the same number of spaces that you used.  Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that." => "Lehetőséget nyújt tetszőleges számú szóközt tartalmazó szöveg bekezdéssel indítására és átformálására monospaced blokká úgy, hogy az továbbra is kövesse a Wiki formázási utasításokat. Amennyi szóközt használtunk annyival lesz behúzva. Vegyük figyelembe hogy ez a módszer nem őrzi meg a pontos szóközöléseket és sortöréseket ; ehhez használjuk a ~pp~...~/pp~ szintakszist",
"Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew." => "Jobbról-balra illetbe balról-jobbra írás lehetőségét teremti meg DIV beszúrásával a szöveg végéig, valamint jelzéseket rak be arab, héber és hasonló nyelveknél",
"Special characters" => "Speciális karakterek",
"hard space" => "kemény szóköz",
"numeric between ~ for HTML numeric characters entity" => "numerikus ~ között html numerikus entitásokhoz",
"Plugin Help" => "Plugin súgó",
"Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt;" => "Plugin argumentumok dupla idézőjel közé tehetők (\"); lehetővé téve így hogy = vagy > operandusokat tartalmazzanak",
"More help here" => "További súgó",
// "Wiki plugins extend the function of wiki syntax with more specialized commands" => "Wiki plugins extend the function of wiki syntax with more specialized commands",
"Activate/deactivate plugins" => "Pluginok be/kikapcsolása",
"No description available" => "Nincs elérhető leírás",
// "Spreadsheet Creation" => "Spreadsheet Creation",
// "Spreadsheet Interface" => "Spreadsheet Interface",
// "Tiki uses jQuery.sheet for displaying spreadsheets, below you will see a list of usable functions and how to enhance how you use it" => "Tiki uses jQuery.sheet for displaying spreadsheets, below you will see a list of usable functions and how to enhance how you use it",
"Wysiwyg Editor" => "WYSIWYG szerkesztő",
// "More help on wysiwyg editing" => "More help on wysiwyg editing",
// "WYSIWYG in wiki mode is an experimental feature in Tiki 7+ and uses\n\t<a href=\"http://ckeditor.com\">CKEditor</a>" => "WYSIWYG in wiki mode is an experimental feature in Tiki 7+ and uses\n\t<a href=\"http://ckeditor.com\">CKEditor</a>",
// "To switch modes between WYSIWYG and Wiki edit modes click the {icon _id=\"pencil_go\"} button on the toolbar" => "To switch modes between WYSIWYG and Wiki edit modes click the {icon _id=\"pencil_go\"} button on the toolbar",
// "<strong>N.B. </strong>Using this button changes the editor between WYSIWYG and the usual wiki editor, but leaves the page source in wiki syntax" => "<strong>N.B. </strong>Using this button changes the editor between WYSIWYG and the usual wiki editor, but leaves the page source in wiki syntax",
// "Wiki plugins can be used and edited in WYSIWYG mode, double click the plugin to bring up the plugin edit popup form.<br />\n\tHere is an example of the {ldelim}BOX{rdelim} plugin" => "Wiki plugins can be used and edited in WYSIWYG mode, double click the plugin to bring up the plugin edit popup form.<br />\n\tHere is an example of the {ldelim}BOX{rdelim} plugin",
// "This is the text in the box which is justified; the box has a cream background, takes 80% of the screen width and is centred" => "This is the text in the box which is justified; the box has a cream background, takes 80% of the screen width and is centred",
// "<strong>Caution:</strong> This is a new feature and still work in progress.<br />\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br />\n\tCurrently (in Tiki 9.0) drag and drop of plugins in WYSIWYG does not work" => "<strong>Caution:</strong> This is a new feature and still work in progress.<br />\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br />\n\tCurrently (in Tiki 9.0) drag and drop of plugins in WYSIWYG does not work",
"<strong>Admins:</strong><br />\n\t\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way.\n\t\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">wysiwyg admin page</a>.\n\t\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a>\n\t\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>" => "<strong>Admins:</strong><br /> \t\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way. \t\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">wysiwyg admin page</a>. \t\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a> \t\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>",
"The WYSIWYG editor in Tiki 6+ is\n\t<a href=\"http://ckeditor.com\">CKEditor</a>,\n\tthe new version of FCKEditor (used in Tiki since version 2.0)" => "The WYSIWYG editor in Tiki 6+ is \t<a href=\"http://ckeditor.com\">CKEditor</a>, \tthe new version of FCKEditor (used in Tiki since version 2.0)",
"<strong>N.B. </strong>Using this button converts the page source from wiki to HTML, or vice versa.\n\tThe conversion process is not entirely transparent, meaning that you may notice differences between the look of a page in different modes.\n\tThis will improve in future updates but as the two systems have significant differences in what they can do it is unlikely to ever be totally transparent." => "<strong>N.B. </strong>Using this button converts the page source from wiki to HTML, or vice versa. \tThe conversion process is not entirely transparent, meaning that you may notice differences between the look of a page in different modes. \tThis will improve in future updates but as the two systems have significant differences in what they can do it is unlikely to ever be totally transparent.",
// "<strong>Caution:</strong> This is a new feature and still work in progress.<br />\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br />\n\tCurrently (still in Tiki 9.0) drag and drop of plugins in WYSIWYG does not work" => "<strong>Caution:</strong> This is a new feature and still work in progress.<br />\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br />\n\tCurrently (still in Tiki 9.0) drag and drop of plugins in WYSIWYG does not work",
"Browse Images" => "Képek böngészése",
"Edit successful" => "Sikeres szerkesztés",
// "The following image was successfully edited" => "The following image was successfully edited",
"Image Description" => "Kép leírása",
// "Upload from disk to change the image" => "Upload from disk to change the image",
// "Save and Go Next" => "Save and Go Next",
// "Edit Invoice" => "Edit Invoice",
// "Invoice Number" => "Invoice Number",
// "Date Issued" => "Date Issued",
// "Work Description" => "Work Description",
// "Taxable" => "Taxable",
// "New Item" => "New Item",
// "Invoice Note" => "Invoice Note",
// "Save Invoice" => "Save Invoice",
"Edit or export languages" => "Nyelvek szerkesztése/exportálása",
"Edit languages" => "Nyelvek szerkesztése",
"Select the language to edit" => "Szerkesztendő nyelv kiválasztása",
"Add a translation" => "Fordítás hozzáadása",
"Edit translations" => "Fordítások szerkesztése",
"Show only database stored translations" => "Csak az adatbázisban tárolt fordítások megjelenítése",
// "Untranslated strings" => "Untranslated strings",
// "Show only database stored untranslated strings" => "Show only database stored untranslated strings",
"Original:" => "Eredeti:",
"Translation:" => "Fordítás:",
"Edit translations:" => "Fordítások szerkesztése:",
// "Original translation" => "Original translation",
// "Last changed by %0 on %1" => "Last changed by %0 on %1",
"Translate all" => "Összes lefordítása",
"Delete all" => "Összes törlése",
// "Are you sure you want to delete all untranslated strings from database" => "Are you sure you want to delete all untranslated strings from database",
// "Are you sure you want to delete all translations from database" => "Are you sure you want to delete all translations from database",
"Export languages" => "Nyelvek exportálása",
// "No translations in the database available to export. First translate strings using interactive translation or \"Edit languages\" tab" => "No translations in the database available to export. First translate strings using interactive translation or \"Edit languages\" tab",
"Select the language to Export" => "Exportálandó nyelv kiválasztása",
// "If you click \"Download database translations\", you will download a file with all the translations in the database" => "If you click \"Download database translations\", you will download a file with all the translations in the database",
// "If you click \"Write to language.php\", the translations in the database will be merged with the other translations in language.php. Note that after writing translations to language.php they are removed from the database" => "If you click \"Write to language.php\", the translations in the database will be merged with the other translations in language.php. Note that after writing translations to language.php they are removed from the database",
// "To be able to write your translations back to language.php make sure that the web server has write permission in the lang/ directory" => "To be able to write your translations back to language.php make sure that the web server has write permission in the lang/ directory",
"Download database translations" => "Adatbázisban lévő fordítások letöltése",
"Write to language.php" => "Kiírás language.php fájlba",
// "Return to default perspective" => "Return to default perspective",
// "Switch to" => "Switch to",
// "Configurations" => "Configurations",
// "Search for configurations below and drag them in to the configuration section above" => "Search for configurations below and drag them in to the configuration section above",
// "Program dynamic content for block" => "Program dynamic content for block",
"Create New Block" => "Új blokk létrehozása",
// "Return to block listing" => "Return to block listing",
// "Block description: " => "Block description: ",
// "You are editing block" => "You are editing block",
// "Publishing date" => "Publishing date",
// "Publishing Date" => "Publishing Date",
// "Edit question options" => "Edit question options",
"List Quizzes" => "Kvíz lista",
"Quiz Stats" => "Kvíz statisztika",
"This Quiz Stats" => "Ezen kvíz statisztikája",
"Edit this Quiz" => "Ezen kvíz szerkesztése",
"Admin Quizzes" => "Kvíz karbantartás",
"Create/edit options for question" => "Opciók létrehozása / szerkesztése a kérdéshez",
"points" => "pontok",
"Quiz" => "Kvíz",
// "canRepeat" => "canRepeat",
"timeLimit" => "Időkorlát",
"Create/edit quizzes" => "Kvíz létrehozása/szerkesztése",
"There are individual permissions set for this quiz" => "Ezen kvízhez egyedi jogosultságok tartoznak",
"Quiz can be repeated" => "Kvízt meg lehet ismételni",
"Store quiz results" => "Kvíz eredményeinek tárolása",
"Quiz is time limited" => "Kvíz idő korlátozása",
"Maximum time" => "Maximális idő",
"Passing Percentage" => "Megfelelés százaléka",
// "%" => "%",
// "Edit quiz questions" => "Edit quiz questions",
// "Create/edit questions for quiz" => "Create/edit questions for quiz",
// "Question Type" => "Question Type",
// "Import questions from text" => "Import questions from text",
// "Instructions: Type, or paste, your multiple choice questions below.  One line for the question, then start answer choices on subsequent lines.  Separate additional questions with a blank line.  Indicate correct answers by starting them with a \"*\" (without the quotes) character" => "Instructions: Type, or paste, your multiple choice questions below.  One line for the question, then start answer choices on subsequent lines.  Separate additional questions with a blank line.  Indicate correct answers by starting them with a \"*\" (without the quotes) character",
// "Input" => "Input",
// "maxScore" => "maxScore",
// "Edit quiz results" => "Edit quiz results",
// "From Points" => "From Points",
// "To Points" => "To Points",
// "Report Builder" => "Report Builder",
// "Report Type" => "Report Type",
// "Select Report Type" => "Select Report Type",
// "Wiki Data" => "Wiki Data",
// "Export As CSV" => "Export As CSV",
"Modify Structure" => "Struktúra szerkesztése",
"You will remove" => "Eltávolításra kerül a(z)",
"and its subpages from the structure, now you have two options:" => "oldalt és aloldalait e struktúrából, 2 opció áll rendelkezésre:",
"and its subpages from the structure" => "és aloldalait a struktúrából",
// "\n\t\t\tRemove only from structure" => "\n\t\t\tRemove only from structure",
// "\n\t\t\t\tRemove from structure and remove page too" => "\n\t\t\t\tRemove from structure and remove page too",
// "The page already exists. The page that has been added to the structure is the existing one" => "The page already exists. The page that has been added to the structure is the existing one",
"The following pages added have automatically been categorized with the same categories as the structure:" => "A következő hozzáadott oldalak a struktúra kategóriabeállításainak megfelelően automatikusan kategorizálásra kerültek",
"Structure Layout" => "Struktúra felépítése",
// "Add pages" => "Add pages",
// "Use pre-existing page by dragging into the structure above" => "Use pre-existing page by dragging into the structure above",
// "{\$catix.categpath}" => "{\$catix.categpath}",
"Categorize all pages in structure together" => "Struktúra összes oldalának egy kategóriába rendezése",
"Remove existing categories from ALL pages before recategorizing" => "Eltávolítás az összes kategóriából az újrakategorizálás előtt",
"Move to another structure" => "Átmozgatás másik struktúrába",
"at the beginning" => "elejére",
"at the end" => "végére",
"Submit article" => "Cikk beküldése",
"List Submissions" => "Beküldött hírek listázása",
"Use ...page... to separate pages in a multi-page post" => "Használjuk a '...page...' szintaxist oldalak elválasztásához többoldalas posztok esetén",
"<b>*</b>=optional" => "<b>*</b>=opcionális",
// "<b>Topline</b>=small line above Title" => "<b>Topline</b>=small line above Title",
// "<b>Subtitle</b>=small line below Title" => "<b>Subtitle</b>=small line below Title",
// "<b>Source</b>=URL to article source" => "<b>Source</b>=URL to article source",
"Own image size x" => "Saját kép mérete x",
"Own image size y" => "Saját kép mérete y",
"Allow HTML:" => "HTML engedélyezése:",
"Submit Article" => "Cikk beküldése",
"Auto-Approve Article" => "Cikk automatikus jóváhagyása",
"View template" => "Sablon megtekintése",
"Edit template" => "Sablon szerkesztése",
"Edit templates" => "Sablonok szerkesztése",
// "Template listing" => "Template listing",
// "Available templates" => "Available templates",
"Important" => "Fontos",
// "If you edit this (or any TPL) file via the built-in editor below, any JavaScript may be sanitized or completely stripped out \n\t\t\t\t\tby Tiki security filtering, which would cause certain functions to stop working (e.g. menus no longer collapse or expand)" => "If you edit this (or any TPL) file via the built-in editor below, any JavaScript may be sanitized or completely stripped out \n\t\t\t\t\tby Tiki security filtering, which would cause certain functions to stop working (e.g. menus no longer collapse or expand)",
// "You should only modify default header.tpl and other important files via a text code editor, through console, \n\t\t\t\t\tor SSH, or FTP edit commands--and only if you know what you are doing! ;-)" => "You should only modify default header.tpl and other important files via a text code editor, through console, \n\t\t\t\t\tor SSH, or FTP edit commands--and only if you know what you are doing! ;-)",
// "Extensive customizations can be made safely through the <a href=\"tiki-admin.php?page=look\" class=\"titletips\" \n\t\t\t\t\ttitle=\"Look & Feel\">Look & Feel</a> admin panel custom code or general layout areas" => "Extensive customizations can be made safely through the <a href=\"tiki-admin.php?page=look\" class=\"titletips\" \n\t\t\t\t\ttitle=\"Look & Feel\">Look & Feel</a> admin panel custom code or general layout areas",
// "To be safe and to make upgrades easier, it is recommended that you create a custom theme before modifying tpl files.\n\t\t\t\t\tSee <a href=\"http://doc.tiki.org/Customizing+Themes\" class=\"titletips\" title=\"Customizing Themes help page\">\n\t\t\t\t\tdoc.tiki.org/Customizing+Themes</a> for how to do that" => "To be safe and to make upgrades easier, it is recommended that you create a custom theme before modifying tpl files.\n\t\t\t\t\tSee <a href=\"http://doc.tiki.org/Customizing+Themes\" class=\"titletips\" title=\"Customizing Themes help page\">\n\t\t\t\t\tdoc.tiki.org/Customizing+Themes</a> for how to do that",
// "Save Only in the Theme" => "Save Only in the Theme",
// "Delete the copy in the theme" => "Delete the copy in the theme",
// "Edit topic" => "Edit topic",
// "Notification Email" => "Notification Email",
"Admin notifications" => "Értesítések adminisztrálása",
"Translate:" => "Fordítás:",
"View Page" => "Oldal megtekintése",
"View Article" => "Cikk megtekintése",
"You must specify the object language" => "Meg kell adni az objektum nyelvét",
"The object doesn't exist" => "Az objektum nem létezik",
"The object doesn't have a language" => "Az objektumhoz nincs nyelv rendelve",
"The object has already a translation for this language" => "Az objektumhoz már létezik fordítás ezen a nyelven",
"The object is already in the set of translations" => "Az objektum már szerepel a fordítások között",
"Translate updates made on this page or one of its translations" => "Az oldal vagy egy fordítás frissített tartalmának lefordítása",
"Translate this page to a new language" => "Oldal lefordítása új nyelvre",
"Attach or detach existing translations of this page" => "Oldal létező fordításainak hozzácsatolása vagy leválasztása",
"Change language for this page" => "Oldal nyelvének megváltoztatása",
"Select language to translate to:" => "Fordítás nyelve:",
"Enter the page title:" => "Oldal címe:",
"Below, assign categories to this new translation (Note: they should probably be the same as the categories of the page being translate)" => "Alább lehetséges az új fordítás kategóriákba rendezése (Megjegyzés: valószínűleg megegyezik a forrás oldal beállításaival)",
"Create translation" => "Fordítás létrehozása",
// "\"You forgot to specify the language of the translation. Please choose a language in the picklist.\"" => "\"You forgot to specify the language of the translation. Please choose a language in the picklist.\"",
// "\"The page already exists. It was selected in the list below.\"" => "\"The page already exists. It was selected in the list below.\"",
"Change Language" => "Nyelv megváltoztatása",
"No language is assigned to this page." => "Ehhez az oldalhoz nincs nyelv rendelve",
"Please select a language before performing translation." => "Fordítás elvégzése előtt ki kell választani egy nyelvet",
"Set Current Page's Language" => "Jelen oldal nyelvének megadása",
// "Manage translations" => "Manage translations",
// "{\$customTip|escape}" => "{\$customTip|escape}",
// "Update '{\$page}'" => "Update '{\$page}'",
// "Draft written on" => "Draft written on",
// "Warning: new versions of this page have been made after this draft" => "Warning: new versions of this page have been made after this draft",
"The SandBox is a page where you can practice your editing skills, use the preview feature to preview the appearance of the page, no versions are stored for this page." => "A Homokozó egy oldal ahol gyakorolni lehet az oldalszerkesztést. Az előnézet gombbal megtekinthető a szerkesztési munka eredménye. A Homokozónak nincsenek tárolt verziói.",
// "An edit summary is mandatory" => "An edit summary is mandatory",
// "Translate from" => "Translate from",
// "Changes that need to be translated are highlighted below" => "Changes that need to be translated are highlighted below",
// "No comment" => "No comment",
"All Versions" => "Összes verzió",
// "Select the style used to display differences to be translated" => "Select the style used to display differences to be translated",
// "html" => "html",
// "text full" => "text full",
// "Change the style used to display differences to be translated" => "Change the style used to display differences to be translated",
// "Change diff styles" => "Change diff styles",
// "Translate to" => "Translate to",
// "Reproduce the changes highlighted on the left using the editor below" => "Reproduce the changes highlighted on the left using the editor below",
"Describe the change you made:" => "Változások rövid összefoglalása:",
// "Edit comment: Enter some text to describe the changes you are currently making" => "Edit comment: Enter some text to describe the changes you are currently making",
"Monitor this page:" => "Oldal figyelése",
"Upload picture" => "Kép feltöltése",
"Add another image" => "További kép hozzáadása",
// "Categorization has been preset for this edit" => "Categorization has been preset for this edit",
"Categories will be inherited from the structure top page" => "Kategorizálás a struktúra legfelső oldalának kategóriái alapján történik",
// "{\$templates[ix].name|escape}" => "{\$templates[ix].name|escape}",
"Admin Content Templates" => "Tartalomsablonok adminisztrálása",
"Lock this page" => "Oldal zárolása",
// "Allow comments on this page" => "Allow comments on this page",
"Import HTML:" => "HTML importálása:",
"Try to convert HTML to wiki" => "Próbálja átkonvertálni a HTML kódot wikivé",
"Import page" => "Lap importálása",
"export all versions" => "összes verzió exportálása",
// "Only cache a page if it should look the same to all groups authorized to see it" => "Only cache a page if it should look the same to all groups authorized to see it",
"Manage structures" => "Struktúrák kezelése",
"License" => "Licensz",
// "{\$prefs.wikiLicensePage}" => "{\$prefs.wikiLicensePage}",
// "{\$prefs.wikiSubmitNotice}" => "{\$prefs.wikiSubmitNotice}",
// "Authors' style" => "Authors' style",
// "Description (used for metatags)" => "Description (used for metatags)",
"My Footnotes" => "Lábjegyzeteim",
"Use rating" => "Értékelés használata",
// "{\$template.title|escape}" => "{\$template.title|escape}",
"There is no available poll template." => "Nincs elérhető kérdőív sablon",
// "You should ask an admin to create them" => "You should ask an admin to create them",
"Language:" => "Nyelv:",
// "\"}To translate, do not change the language and the content.\n\t\t\t\t\t\t\t\t\tInstead, <a href=\"%0\">create a new translation</a> in the new language" => "\"}To translate, do not change the language and the content.\n\t\t\t\t\t\t\t\t\tInstead, <a href=\"%0\">create a new translation</a> in the new language",
"Translation request" => "Fordítási kérés",
"Send urgent translation request." => "Fordítási kérés küldése",
"Admin wiki preferences" => "Wiki preferenciák adminisztrálása",
// "{\$title}" => "{\$title}",
"List Sheets" => "Táblázat lista",
"Graph" => "Grafikon",
// "Export to file" => "Export to file",
// "Autodetect" => "Autodetect",
"Admin FAQ" => "Gyakori kérdések beállításai",
"List FAQs" => "GYIK lista",
// "View FAQ" => "View FAQ",
// "Edit this FAQ" => "Edit this FAQ",
// "New Question" => "New Question",
// "Edit FAQ question" => "Edit FAQ question",
// "Add FAQ question" => "Add FAQ question",
// "Use a question from another FAQ" => "Use a question from another FAQ",
// "FAQ questions" => "FAQ questions",
// "Suggested questions" => "Suggested questions",
// "No suggested questions" => "No suggested questions",
// "File Archive" => "File Archive",
"Upload File" => "Fájl feltöltése",
// "File Galleries tpl" => "File Galleries tpl",
"Be careful to set the right permissions on the files you link to" => "Győződjünk meg róla hogy jól lettek beállítva a jogosultságok a fájlhoz melyre a link mutat",
"You can access the file gallery using the following URL" => "A fájlgaléria a következő URL-lel érhető el",
// "Size (width x height)" => "Size (width x height)",
// "Newer content available" => "Newer content available",
// "You are currently viewing the latest version of the page" => "You are currently viewing the latest version of the page",
// "You can also view the {self_link}latest approved version{/self_link}" => "You can also view the {self_link}latest approved version{/self_link}",
// "You can approve this revision and make it available to a wider audience. Make sure you review all the changes before approving" => "You can approve this revision and make it available to a wider audience. Make sure you review all the changes before approving",
// "Show changes since last approved revision" => "Show changes since last approved revision",
// "This page has no prior approved revision. <strong>All of the content must be reviewed.</strong>" => "This page has no prior approved revision. <strong>All of the content must be reviewed.</strong>",
// "Approve current revision" => "Approve current revision",
// "Content waiting for approval" => "Content waiting for approval",
// "You are currently viewing the approved version of the page" => "You are currently viewing the approved version of the page",
// "You can also view the {self_link latest=1}latest version{/self_link}" => "You can also view the {self_link latest=1}latest version{/self_link}",
// "View the {self_link latest=1}latest version{/self_link}" => "View the {self_link latest=1}latest version{/self_link}",
"Forum Importer" => "Fórumok importálása",
"Admin forums" => "Fórum karbantartás",
"Import from a Local SQL File" => "Importálás lokális SQL fájlból",
"Forum Type" => "Fórum típusa",
"DB Prefix" => "Adatbázis előtag",
"Local SQL Filename on Server (path will be stripped)" => "Lokális SQL fájlnév a szerveren (az útvonalat le lesz csupaszítva)",
"Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up" => "Helye a tiki gyökérkönyvtár /{\$tmpdir} vagy tiki gyökérkönyvtár/img/wiki_up",
"Get Forum List" => "Fórumlista importálása",
// "Verification" => "Verification",
// "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>" => "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>",
// "File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred" => "File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred",
// "Proceed" => "Proceed",
"Go Back" => "Vissza",
// "Select a Forum You Wish to Move (ONE at a time!)" => "Select a Forum You Wish to Move (ONE at a time!)",
// "Which Forum Do You Wish to Import this Into" => "Which Forum Do You Wish to Import this Into",
"Message queue for forum" => "Fórum sorbanálló posztjai",
"Back to forum" => "Vissza a fórumhoz",
// "Edit queued message" => "Edit queued message",
// "make this a thread of" => "make this a thread of",
// "None, this is a thread message" => "None, this is a thread message",
"summary" => "összefoglaló",
"Announce" => "Hirdetmény",
"Hot" => "Forró",
"no feeling" => "nincs érzelem",
"frown" => "haragos",
"exclaim" => "felkiáltás",
"idea" => "ötlet",
"neutral" => "semleges",
"question" => "kérdés",
"happy" => "boldog",
"wink" => "kacsintás",
"Save and Approve" => "Mentés és jóváhagyás",
"convert to topic" => "témává konvertálás",
"List of messages" => "Üzenetek listája",
"Topic:" => "Téma:",
"New Topic" => "Új téma",
"no summary" => "nincs összefoglaló",
"No messages queued yet" => "Nincsenek sorbanálló posztok",
"Search by name" => "Keresés név szerint",
"Search in content" => "Keresés a tartalomban",
"Last Post" => "Legutóbbi poszt",
"Configure Forum" => "Fórum konfigurálása",
// "Reported messages for forum" => "Reported messages for forum",
// "Reported by" => "Reported by",
// "Perfom action with checked" => "Perfom action with checked",
// "Un-report" => "Un-report",
"Tag translation" => "Címke fordítása",
// "Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag" => "Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag",
// "Until then, they cannot be translated" => "Until then, they cannot be translated",
// "Show checkboxes to clear language information on tags" => "Show checkboxes to clear language information on tags",
"Previous" => "Előző",
// "There are no tags on this page in your preferred languages" => "There are no tags on this page in your preferred languages",
"Set language" => "Nyelv beállítása",
// "Universal" => "Universal",
// "Show the following languages" => "Show the following languages",
// "Pending requests" => "Pending requests",
// "Request Time" => "Request Time",
"Accept" => "Elfogadás",
"Refuse" => "Visszautasítás",
"Waiting requests" => "Függő kérések",
// "Cancel friendship request" => "Cancel friendship request",
"Your friends" => "Barátaim",
"break friendship" => "megszakítom a barátságot vele",
"Galleries" => "Galériák",
"Create New Gallery" => "Új galéria létrehozása",
"Create a gallery" => "Galéria létrehozása",
"Edit this gallery:" => "Ezen galéria szerkesztése:",
"There are individual permissions set for this gallery" => "Ehhez a galériához egyéni jogosultságok vannak beállítva",
"Gallery is visible to non-admin users?" => "A galéria látható a nem admin felhasználók számára?",
// "Geographic" => "Geographic",
"Fields to show during browsing the gallery" => "Galéria böngészésekor megjelenítendő mezők",
"XY-Size" => "XY-méret",
"Gallery Image" => "Galéria képe",
"Available scales" => "Elérhető méretarányok",
"Global default" => "Globális alapértelmezés",
"Bounding box" => "Határoló doboz",
"default scale" => "alapértelmezett arány",
"No scales available" => "Nincs elérhető méretarány",
"Original image is default scale" => "Eredeti kép az alapértelmezett arány",
"Add scaled images with bounding box of square size" => "Arányosított képek hozzáadása négyzetes határoló dobozzal",
"Other users can upload images to this gallery" => "Más felhasználók is tölthetnek fel képet ebbe a galériába",
"You can access the gallery using the following URL" => "A galéria a következő URL-en érhető el:",
"Available Galleries" => "Rendelkezésre álló galériák",
"Choose a filter" => "Szűrő kiválasztása",
"Imgs" => "Képek",
// "Make Map" => "Make Map",
"Google Map Locator" => "Google Map lokátor",
"Back to preferences" => "Vissza a beállításokhoz",
// "enter address" => "enter address",
// "Find address" => "Find address",
"Save clicked point" => "Klikkelt pont mentése",
// "Reset view to default" => "Reset view to default",
"Save current view as default" => "Jelen nézet mentése alapértelmezettként",
"Center map to saved point" => "Térkép beállítása a mentett pontra",
// "Reset view to site default" => "Reset view to site default",
"Users Map" => "Felhasználói térkép",
// "Select Graphic Type" => "Select Graphic Type",
// "Pie Chart" => "Pie Chart",
// "Multiline" => "Multiline",
// "Multibar" => "Multibar",
// "Bar Stack" => "Bar Stack",
// "Landscape" => "Landscape",
// "Portrait" => "Portrait",
// "Independant Scale" => "Independant Scale",
// "Horizontal Scale" => "Horizontal Scale",
// "Vertical Scale" => "Vertical Scale",
// "Series" => "Series",
// "Edit Spreadsheet" => "Edit Spreadsheet",
// "List Spreadsheets" => "List Spreadsheets",
// "Wiki plug-in" => "Wiki plug-in",
// "Spreadsheet History" => "Spreadsheet History",
// "Clone" => "Clone",
"Rollback" => "Visszagörgetés",
// "Toggle Full Screen" => "Toggle Full Screen",
// "Date Selection" => "Date Selection",
// "Edit Date" => "Edit Date",
// "View Spreadsheet" => "View Spreadsheet",
// "Clone Spreadsheet" => "Clone Spreadsheet",
// "Roll Back Spreadsheet" => "Roll Back Spreadsheet",
// "Roll-Back" => "Roll-Back",
// "Ical import / Export" => "Ical import / Export",
// "Select The calendar to export" => "Select The calendar to export",
// "Calendar Import" => "Calendar Import",
// "ICal File" => "ICal File",
// "Import From File" => "Import From File",
// "Grab Wiki Tables" => "Grab Wiki Tables",
// "Import pages from a Structured Text Dump" => "Import pages from a Structured Text Dump",
// "Name of the dump file (it has to be in dump/)" => "Name of the dump file (it has to be in dump/)",
// "Overwrite existing pages if the name is the same" => "Overwrite existing pages if the name is the same",
// "Previously remove existing page versions" => "Previously remove existing page versions",
// "excerpt" => "excerpt",
"Result" => "Eredmény",
"body" => "törzs",
"Or" => "Vagy",
// "Name of the zip file on the server" => "Name of the zip file on the server",
"Tiki Importer" => "Tiki importáló",
// "If you are NOT running a new Tiki installation, make a backup of your database before using this importer" => "If you are NOT running a new Tiki installation, make a backup of your database before using this importer",
// "If your pages contain XML code, the HTML purifier will delete it. Deactivate this feature" => "If your pages contain XML code, the HTML purifier will delete it. Deactivate this feature",
// "Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibility to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode" => "Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibility to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode",
// "Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)" => "Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)",
// "Select the software to import from" => "Select the software to import from",
// "WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button" => "WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button",
// "Congratulations! You have successful imported your data to Tiki" => "Congratulations! You have successful imported your data to Tiki",
// "%0 pages imported from a total of %1" => "%0 pages imported from a total of %1",
// "%0 pages imported" => "%0 pages imported",
// "(you can see the list of wiki pages in your site <a href=\"tiki-listpages.php\">here</a>)" => "(you can see the list of wiki pages in your site <a href=\"tiki-listpages.php\">here</a>)",
// "%0 posts imported" => "%0 posts imported",
// "%0 tags imported" => "%0 tags imported",
// "%0 categories imported" => "%0 categories imported",
// "Importer log" => "Importer log",
// "Suggested .htaccess rules" => "Suggested .htaccess rules",
// "Locked by %0" => "Locked by %0",
"Tiki installer" => "Tiki telepítés",
"Welcome" => "Üdvözlet",
"Welcome to the Tiki installation and upgrade script" => "Üdvözlet a Tiki telepítő és frissítő szkriptjében",
"Use this script to install a new Tiki database or upgrade your existing database to release" => "Ezt a szkriptet új Tiki adatbázis telepítéséhez vagy egy létező adatbázis legújabb kiadásra történő frissítéséhez lehet felhasználni:",
"For the latest information about this release, please read the" => "Tiki kiadás részleteit lásd itt:",
"Release Notes" => "Kiadási megjegyzések",
"For complete documentation, please visit" => "Teljes dokumentációt lásd itt:",
"For more information about Tiki, please visit" => "További információk a Tikiről itt:",
"Select your language" => "Nyelv kiválasztása",
"Read the License" => "Licensz elolvasása",
"Tiki is software distributed under the LGPL license" => "A Tiki szoftver LGPL licensz alatt használható",
"Review the System Requirements" => "Rendszerkövetelmények áttekintése",
"Review" => "Átnézés",
// "Before installing Tiki, <a href=\"http://doc.tiki.org/Requirements\" target=\"_blank\">review the documentation</a> and confirm that your system meets the minimum requirements" => "Before installing Tiki, <a href=\"http://doc.tiki.org/Requirements\" target=\"_blank\">review the documentation</a> and confirm that your system meets the minimum requirements",
"This installer will perform some basic checks automatically" => "A telepítő automatikusan végrehajtott pár ellenőrzést melyek eredménye alább található",
// "Please see: " => "Please see: ",
// "a detailed report about your server" => "a detailed report about your server",
"Tiki has not detected your PHP memory_limit" => "A Tiki nem tudta megállapítani a PHP memory_limit értékét",
"This probably means you have no set limit (all is well)" => "Ez valószínűleg azt jelenti hogy nincs határ beállítva (vagyis minden rendben)",
"Tiki has detected your PHP memory limit at" => "A Tiki a következő PHP memory_limit értéket találta",
// "Tiki requires <strong>at least</strong> 128MB of PHP memory for script execution" => "Tiki requires <strong>at least</strong> 128MB of PHP memory for script execution",
"Allocating too little memory will cause Tiki to display blank pages" => "Túl kevés memória allokálása esetén a Tiki üres oldalak fog megjeleníteni",
// "To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 128M) and restart your webserver" => "To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 128M) and restart your webserver",
"Tiki has detected your PHP memory_limit at" => "A Tiki a következő PHP memory_limit értéket találta",
"Tiki uses the PHP <strong>mail</strong> function to send email notifications and messages" => "A Tiki a PHP <strong>mail</strong> funkciót használja E-mail értesítések és üzenetek kiküldésére",
"To test your system configuration, Tiki will attempt to send a test message to you" => "A rendszerbeállítások tesztelésére a Tiki megpróbál tesztüzenetet küldeni",
"Test email" => "Teszt E-mail",
"Email address to send test to" => "E-mail üzenet címzettje",
"Copy test mail to " => "Másolat küldése a teszt E-mailről ide:",
"Send Test Message" => "Tesztüzenet küldése",
"Tiki was able to send a test message to" => "A Tiki sikeresen kiküldte a tesztüzenetet erre a címre:",
"Tiki was not able to send a test message" => "A Tiki nem tudta kiküldeni a tesztüzenetet",
"Review your mail log for details" => "Nézzük meg a levelezési log-ot további részletekért",
"Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)" => "Tekintsük át a <strong>php.ini</strong> fájlban található mail beállításokat (például nézzük meg hogy a <strong>sendmail_path</strong> helyesen van-e beállítva)",
"If your host requires SMTP authentication, additional configuration may be necessary" => "Ha a hoszt SMTP azonosítást igényel akkor további konfiguráció is szükséges lehet",
"Image Processing" => "Képek feldolgozása",
"Tiki detected" => "A Tiki felismerte a következőt",
// "Tiki can create images" => "Tiki can create images",
// "Tiki was not able to create a sample image. Please check your GD library configuration" => "Tiki was not able to create a sample image. Please check your GD library configuration",
"Tiki was not able to detect the GD library" => "A Tiki nem tudta felismerni a GD könyvtárat",
"Tiki uses the GD library to process images for the Image Gallery and CAPTCHA support" => "A Tiki a GD könyvtárat használja képek feldolgozásához és a CAPTCHA támogatáshoz",
"Set the Database Connection" => "Adatbázis kapcsolat megadása",
"Tiki requires an active database connection" => "A Tiki aktív adatbázis kapcsolatot igényel",
"You must create the database and user <em>before</em> completing this page" => "Létre kell hozni az adatbázist és az adatbázishoz tartozó felhasználó nevet az alábbi adatok megadása <em>előtt</em>",
"Tiki cannot find a database connection" => "A Tiki nem talált adatbázis kapcsolatot",
"This is normal for a new installation" => "Ez így van rendjén új telepítés esetén",
"Tiki found an existing database connection in your local.php file" => "A Tiki talált egy létező adatbázis kapcsolatot a local.php fájlban",
// "Database name: &quot;%0&quot" => "Database name: &quot;%0&quot",
"Use Existing Connection" => "Létező kapcsolat használata",
// "Modify database connection" => "Modify database connection",
"Use this page to create a new database connection, or use the <a href=\"http://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>" => "Használjuk ezt az oldalt új kapcsolat létrehozására, vagy használjuk a <a href=\"http://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manuális telepítés\">manuális telepítés folyamatot</a>",
"Database information" => "Adatbázis információ",
"Enter your database connection information" => "Adatbázis kapcsolat megadása",
"Database type" => "Adatbázis típusa",
"Select the type of database to use with Tiki" => "Tikihez használandó adatbázis kiválasztása",
"Only databases supported by your PHP installation are listed here. If your database is not in the list, try to install the appropriate PHP extension" => "Csak a PHP telepítés által támogatott adatbázisok láthatóak itt. Ha a kívánt adatbázis nem szerepel a listában akkor telepíteni kell a szükséges PHP kiterjesztést",
"Host name" => "Hoszt neve",
"Enter the host name or IP for your database" => "Adatbázis hoszt nevének vagy IP címének megadása",
"Use <strong>localhost</strong> if the database is running on the same machine as Tiki" => "Használjuk a <strong>localhost</strong> kifejezést ha az adatbázis ugyanazon a gépen fut ahol a Tiki",
// "For non-default port number use <strong>example.com;port=3307</strong>" => "For non-default port number use <strong>example.com;port=3307</strong>",
"Database name" => "Adatbázis neve",
// "Enter the name of the database that Tiki will use (if already created) or create (if permitted)" => "Enter the name of the database that Tiki will use (if already created) or create (if permitted)",
// "You can create the database using mysqladmin, phpMyAdmin, cPanel, or ask your hosting provider. If the database doesn't exist and the supplied username has permissions, the database will be created" => "You can create the database using mysqladmin, phpMyAdmin, cPanel, or ask your hosting provider. If the database doesn't exist and the supplied username has permissions, the database will be created",
// "If you are using a database which is already being used for something else (not recommended), check db/tiki.sql to make sure the table names used by Tiki are not already used" => "If you are using a database which is already being used for something else (not recommended), check db/tiki.sql to make sure the table names used by Tiki are not already used",
"Database user" => "Adatbázis felhasználó",
"Enter a database user with administrator permission for the Database" => "Az adatbázishoz adminisztrátori jogokkal rendelkező adatbázis felhasználó nevének megadása",
"User name" => "Felhasználói név",
// "Character set" => "Character set",
// "Highly recommended for new installations. However, if you are upgrading or migrating a previous tiki database, you are recommended to uncheck this box" => "Highly recommended for new installations. However, if you are upgrading or migrating a previous tiki database, you are recommended to uncheck this box",
// "Always force connection to use UTF-8" => "Always force connection to use UTF-8",
"More information" => "További információ",
// "Install &amp; Upgrade" => "Install &amp; Upgrade",
"Install" => "Telepítés",
// "Failed to set max_execution_time for PHP. You may experience problems when creating/upgrading the database using this installer on a slow system. This can manifest itself by a blank page" => "Failed to set max_execution_time for PHP. You may experience problems when creating/upgrading the database using this installer on a slow system. This can manifest itself by a blank page",
// "This install will populate (or upgrade) the database" => "This install will populate (or upgrade) the database",
// "If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"http://doc.tiki.org/Upgrade\" target=\"_blank\">Upgrade instructions</a>" => "If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"http://doc.tiki.org/Upgrade\" target=\"_blank\">Upgrade instructions</a>",
// "A new install will populate the database" => "A new install will populate the database",
// "Encoding Issue" => "Encoding Issue",
// "<p>Your database encoding is <strong>not</strong> in UTF-8.</p><p>Current encoding is <em>%0</em>. The languages that will be available for content on the site will be limited. If you plan on using languages not covered by the character set, you should re-create or alter the database so the default encoding is <em>utf8</em>.</p>" => "<p>Your database encoding is <strong>not</strong> in UTF-8.</p><p>Current encoding is <em>%0</em>. The languages that will be available for content on the site will be limited. If you plan on using languages not covered by the character set, you should re-create or alter the database so the default encoding is <em>utf8</em>.</p>",
// "Character Set Conversion" => "Character Set Conversion",
// "Use at your own risk. If the data in the database currently contains improperly converted data, this may make matters worse. Suitable for new installations. Requires ALTER privilege on the database" => "Use at your own risk. If the data in the database currently contains improperly converted data, this may make matters worse. Suitable for new installations. Requires ALTER privilege on the database",
// "Convert database and tables to UTF-8" => "Convert database and tables to UTF-8",
// "This will destroy your current database &quot;%0&quot;" => "This will destroy your current database &quot;%0&quot;",
"Reinstall the database" => "Az adatbázis újratelepítése",
"Select database engine" => "Adatbázis motore kiválasztása",
"MyISAM" => "MyISAM",
// "InnoDB" => "InnoDB",
"Reinstall" => "Újratelepítés",
"Upgrade" => "Frissítés",
// "Warning: Category Permissions Will Not Be Upgraded" => "Warning: Category Permissions Will Not Be Upgraded",
// "Category permissions have been revamped since version 3. If you have been using category permissions, note that they may not work properly after upgrading to version 4 onwards, and it will be necessary to reconfigure them" => "Category permissions have been revamped since version 3. If you have been using category permissions, note that they may not work properly after upgrading to version 4 onwards, and it will be necessary to reconfigure them",
"Automatically upgrade your existing database to v" => "Létező adatbázis frissítése erre a verzióra:",
"This site has an admin account configured" => "Ez a weblap már rendelkezik egy adminisztrátori fiókkal",
// "Please log in with your admin password to continue" => "Please log in with your admin password to continue",
"Pass" => "Jelszó",
"Review the Upgrade" => "Frissítés áttekintése",
"Review the Installation" => "Telepítés áttekintése",
"Upgrade complete" => "Frissítés befejezve",
"Installation complete" => "Telepítés befejezve",
"Your database has been configured and Tiki is ready to run" => "Az adatbázis konfigurálásra került és használatra kész",
"If this is your first install, your admin password is <strong>admin</strong>" => "Ha ez az első telepítés volt akkor az adminisztrátori jelszó <strong>admin</strong>",
"You can now log in into Tiki as user <strong>admin</strong> and start configuring the application" => "Be lehet jelentkezni a Tikibe <strong>admin</strong> felhasználó névvel és el lehet kezdeni az alkalmazás konfigurálását",
"Upgrade operations executed successfully" => "A frissítési műveletek sikeresen lefutottak",
"Installation operations executed successfully" => "A telepítési műveletek sikeresen lefutottak",
"SQL queries" => "SQL lekérdezés",
"Database was left unchanged" => "Az adatbázis nem változott",
"Failed" => "Nem sikerült",
"Operations failed" => "Sikertelen műveletek",
"Display details" => "Részletek megjelenítése",
"During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages" => "Frissítés során normális ha <strong>Table already exists</strong> SQL hibaüzeneteket kapunk ",
"Check all errors" => "Összes hiba kijelölése",
".htaccess File" => ".htaccess fájl",
// "We recommend enabling the <strong>.htaccess</strong> file for your Tiki" => "We recommend enabling the <strong>.htaccess</strong> file for your Tiki",
// "This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security" => "This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security",
"Configure General Settings" => "Általános beállítások megadása",
"Complete these fields to configure common, general settings for your site" => "Ezen mezők kitöltésével az oldalra vonatkozó általános beállítások adhatóak meg",
"The information you enter here can be changed later" => "Az itt megadott adatok később megváltoztathatóak",
"Refer to the <a href=\"http://doc.tiki.org/Admin+Panels\" target=\"_blank\">documentation</a> for complete information on these, and other, settings" => "Bővebb információ a beállításokról <a href=\"http://doc.tiki.org/Admin+Panels\" target=\"_blank\">itt</a>",
"This will appear in the browser title bar" => "Ez jelenik majd meg a böngésző címsorában",
"Email sent by your site will use this address" => "A weblap által küldött E-mailek ezen címet fogják használni",
// "Secure Log in" => "Secure Log in",
// "It is recommended to choose the \"Require secure (https) login\" option for better security. A security certificate and dedicated IP address are required to implement a secure login" => "It is recommended to choose the \"Require secure (https) login\" option for better security. A security certificate and dedicated IP address are required to implement a secure login",
"HTTPS login" => "HTTPS bejelentkezés",
"PHP error reporting level:" => "PHP hibajelentés szinje:",
"Report all errors except notices" => "Figyelemeztetéseken kívűl minden hiba jelentése",
"Visible to Admin only" => "Csak adminisztrátor számára látható",
"Administrator" => "Adminisztrátor",
"Admin email" => "Adminisztrátor E-mail",
"This is the email address for your administrator account" => "Ez az adminisztrátori fiók E-mail címe",
// "Upgrade fix" => "Upgrade fix",
// "Experiencing problems with the upgrade? Your administrator account lost its privileges? This may occur if you upgraded from a very old version of Tiki.</p>\n\t\t\t<p>We can fix it! Doing so will" => "Experiencing problems with the upgrade? Your administrator account lost its privileges? This may occur if you upgraded from a very old version of Tiki.</p>\n\t\t\t<p>We can fix it! Doing so will",
// "Create the <em>Admins</em> group, if missing" => "Create the <em>Admins</em> group, if missing",
// "Grant <em>tiki_p_admin</em> to the group, if missing" => "Grant <em>tiki_p_admin</em> to the group, if missing",
// "Add the administrator account to the group, if missing" => "Add the administrator account to the group, if missing",
// "To do so enter the name of the main admin account in the field below" => "To do so enter the name of the main admin account in the field below",
// "Administrator account (optional): <input type=\"text\" name=\"admin_account\"/> <em>The default account is <strong>admin</strong></em>" => "Administrator account (optional): <input type=\"text\" name=\"admin_account\"/> <em>The default account is <strong>admin</strong></em>",
// "Check this box if you have a lot of disabled accounts after an upgrade to tiki4" => "Check this box if you have a lot of disabled accounts after an upgrade to tiki4",
// "List of accounts that will be enabled" => "List of accounts that will be enabled",
"Enter Your Tiki" => "Belépés a Tiki-be",
"The installation is complete" => "A telepítés véget ért",
// "Tiki is an open source project, <em>you</em> can <a href='http://info.tiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tiki.org/Develop+Tiki' target='_blank'>develop Tiki</a>" => "Tiki is an open source project, <em>you</em> can <a href='http://info.tiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tiki.org/Develop+Tiki' target='_blank'>develop Tiki</a>",
"Installation" => "Telepítés",
"If this is a first time installation, go to <strong>tiki-admin.php</strong> after login to start configuring your new Tiki installation" => "Ha ez egy első telepítés akkor konfiguráljuk a Tiki-t a <strong>tiki-admin.php</strong> oldal segítségével bejelentkezés után",
"If this is an upgrade, clean the Tiki caches manually (the <strong>templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu" => "Ha egy meglévő telepítést frissítettünk akkor vagy manuálisan ürítsük ki a cache-t (a <strong>templates_c</strong> könyvtárat) vagy használjuk a <strong>Cache/rendszer</strong> menüpontot az Adminszitráció menüben",
"Enter Tiki and Lock Installer" => "Belépés a Tikibe és a telepítő zárolása",
"Recommended" => "Ajánlott",
"Enter Tiki Without Locking Installer" => "Belépés a Tikibe a telepítő zárolása nélkül",
// "Not recommended due to security risk" => "Not recommended due to security risk",
// "Stay up-to-date" => "Stay up-to-date",
// "Subscribe to the <a href=\"http://tiki.org/Newsletter\" title=\"Subscribe\" target=\"_blank\">Tiki newsletter</a> or <a href=\"http://info.tiki.org/tiki-articles_rss.php\" title=\"RSS\" target=\"_blank\">RSS feed</a> to learn about new releases, security updates, and community news" => "Subscribe to the <a href=\"http://tiki.org/Newsletter\" title=\"Subscribe\" target=\"_blank\">Tiki newsletter</a> or <a href=\"http://info.tiki.org/tiki-articles_rss.php\" title=\"RSS\" target=\"_blank\">RSS feed</a> to learn about new releases, security updates, and community news",
// "You can now access the site normally. Report back any issues that you might find (if any) to the Tiki forums or bug tracker" => "You can now access the site normally. Report back any issues that you might find (if any) to the Tiki forums or bug tracker",
// "Are you sure you want to attempt to fix the encoding of your entire database" => "Are you sure you want to attempt to fix the encoding of your entire database",
// "Upgrading and running into encoding issues" => "Upgrading and running into encoding issues",
// "We can try to fix it, but <strong>make sure you have backups, and can restore them</strong>" => "We can try to fix it, but <strong>make sure you have backups, and can restore them</strong>",
// "Previous table encoding" => "Previous table encoding",
// "Please select" => "Please select",
// "Dangerous: Fix double encoding" => "Dangerous: Fix double encoding",
// "Oops. You need to make sure client charset is forced to UTF-8. Reset the database connection to continue" => "Oops. You need to make sure client charset is forced to UTF-8. Reset the database connection to continue",
"MultiTiki Setup" => "MultiTiki beállítás",
"Default Installation" => "Alapértelmezett telepítés",
"DB OK" => "Adatbátis OK",
"No DB" => "Nincs adatbázis",
"Adding a new host" => "Új hoszt hozzáadása",
// "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter" => "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter",
"MultiTiki" => "MultiTiki",
"Are you upgrading an existing Tiki site" => "Már létező Tiki weblap frissítéséről van szó",
"Go directly to the <strong>Install/Upgrade</strong> step" => "Ebben az esetben ugorjunk a <strong>Telepítés/Frissítés</strong> lépésre",
"Install/Upgrade" => "Telepítés/Frissítés",
"Restart the installer" => "Telepítő újraindítása",
"Database Connection" => "Adatbázis kapcsolat",
"Reset the Database Connection" => "Adatbázis kapcsolat beállítása",
"Configure the General Settings" => "Általános beállítások",
"Tiki Icon" => "Tiki ikon",
"Tiki Project Web Site" => "Tiki projekt weboldala",
"Documentation" => "Dokumentáció",
"Support Forums" => "Támogató fórumok",
// "Powered by Tiki Wiki CMS Groupware" => "Powered by Tiki Wiki CMS Groupware",
"Clear cached version and refresh cache" => "Cache-elt verzió kiürítése és cache frissítése",
"configure rules" => "szabályok konfigurálása",
// "Invitation" => "Invitation",
// "Invitations list" => "Invitations list",
// "The mail has been sent to: " => "The mail has been sent to: ",
// "You are about to send an invitation to theses people, please confirm" => "You are about to send an invitation to theses people, please confirm",
// "Fill this box with the list of e-mails you want to invite " => "Fill this box with the list of e-mails you want to invite ",
// "Format of the list above " => "Format of the list above ",
// "CSV Style: One line per invitation, with the format: lastname,firstname,email" => "CSV Style: One line per invitation, with the format: lastname,firstname,email",
// "Everything that appear as an email in the text will be detected and used (in that case, {literal}{firstname} and {lastname}{/literal} will be ignored in the email content)" => "Everything that appear as an email in the text will be detected and used (in that case, {literal}{firstname} and {lastname}{/literal} will be ignored in the email content)",
// "Type here the e-mail subject you'll want to be sent to them " => "Type here the e-mail subject you'll want to be sent to them ",
// "Type here the e-mail content you'll want to be sent to them (and let the {literal}{link}{/literal} word, it will be replaced with the good link for registering) " => "Type here the e-mail content you'll want to be sent to them (and let the {literal}{link}{/literal} word, it will be replaced with the good link for registering) ",
// "Type here the content that the user will see when he'll click on the link from the mail " => "Type here the content that the user will see when he'll click on the link from the mail ",
// "Choose one or more group you want theses suscribtion to be in. Don't choose any if you don't want anything special " => "Choose one or more group you want theses suscribtion to be in. Don't choose any if you don't want anything special ",
// "Invoices" => "Invoices",
// "New Invoice" => "New Invoice",
// "Clients" => "Clients",
// "New Client" => "New Client",
// "Invoice Reports" => "Invoice Reports",
// "Upload to Kaltura" => "Upload to Kaltura",
// "Upload Successful" => "Upload Successful",
// "You have successfully added {\$count} new entry/entries" => "You have successfully added {\$count} new entry/entries",
// "Add more media" => "Add more media",
// "Change Details" => "Change Details",
// "Remix" => "Remix",
// "Media Entries" => "Media Entries",
// "Advanced Editor" => "Advanced Editor",
// "Simple Editor" => "Simple Editor",
// "Video Title" => "Video Title",
"Editor" => "Szerkesztő",
// "Embed code" => "Embed code",
// "Plays" => "Plays",
// "No action specified" => "No action specified",
"Last Changes" => "Legutóbbi változások",
"Last 2 days" => "Elmúlt 2 nap",
"Last 3 days" => "Elmúlt 3 nap",
"Last 5 days" => "Elmúlt 5 nap",
"Last week" => "Múlt hét",
"Last 2 weeks" => "Elmúlt 2 hét",
"Last month" => "Múlt hónap",
"Search by Date" => "Keresés dátum szerint",
"Found" => "Találat",
"LastChanges" => "Legutóbbi változások",
// "{\$lastchanges[changes].action|escape}" => "{\$lastchanges[changes].action|escape}",
// "v" => "v",
"Pages like" => "Hasonló nevű oldalak",
"New Article" => "Új cikk",
"View Submissions" => "Beküldések megtekintése",
// "Expiry Date" => "Expiry Date",
// "{\$listpages[changes].type|escape}" => "{\$listpages[changes].type|escape}",
// "{\$listpages[changes].disp_article}" => "{\$listpages[changes].disp_article}",
// "{\$listpages[changes].lang}" => "{\$listpages[changes].lang}",
// "{\$listpages[changes].hasImage}" => "{\$listpages[changes].hasImage}",
// "{\$listpages[changes].useImage}" => "{\$listpages[changes].useImage}",
// "Permissons" => "Permissons",
// "Select Duplicates" => "Select Duplicates",
"To use a banner in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone." => "Banner használatához egy <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">modulban</a> vagy egy sablonban alkalmazzuk a  {literal}{banner zone=ABC}{/literal} formulát, ahol ABC a zóna neve",
"Create banner" => "Banner készítése",
"Method" => "Metódus",
"Use Dates?" => "Dátumok használata?",
"Max Impressions" => "Max nézőszám",
"Impressions" => "Nézőszám",
"Max Clicks" => "Max klikkek",
"Clicks" => "Kattintások",
"Create New Blog" => "Blog létrehozása",
"List all comments" => "Komment lista",
"The cache is used by" => "A cache-t használja:",
// "{\$headerName}" => "{\$headerName}",
"Approval" => "Jóváhagyás",
// "More info" => "More info",
// "(no title)" => "(no title)",
// "{\$val|ucwords}" => "{\$val|ucwords}",
"Approved" => "Jóváhagyva",
"Rejected" => "Elutasítva",
// "Delete & Ban" => "Delete & Ban",
// "To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block" => "To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block",
// "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block" => "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block",
"Available content blocks" => "Elérhető tartalom blokkok",
"Current Value" => "Jelenlegi érték",
"Current ver" => "Jelenlegi verzió",
"Next ver" => "Következő verzió",
"Future vers" => "Jövőbeli verzió",
"Program" => "Program",
// "Create/Edit content block" => "Create/Edit content block",
"Edit content block" => "Tartalom blokk szerkesztése",
"Create content block" => "Tartalom blokk létrehozása",
"Available FAQs" => "Jelenlegi GYIK-ek",
"Edit/Create" => "Létrehozás/szerkesztés",
"Edit this FAQ:" => "GYIK szerkesztése:",
"Create new FAQ" => "Új GYIK létrehozása",
"Create New FAQ:" => "Új GYIK létrehozása",
"Users can suggest questions" => "Felhasználók javasolhatnak kérdéseket",
"Create a File Gallery" => "Fájlgaléria létrehozása",
// "RSS feed" => "RSS feed",
"Admin View" => "Adminsztrátori nézet",
// "Create a drawing" => "Create a drawing",
"SlideShow" => "Bemutató",
"Keep gallery window open" => "Galériaablak nyitva tartása",
"Your comment" => "Megjegyzés",
"optional" => "opcionális",
"Modifications" => "Módosítások",
"Property <b>{\$fgp_name}</b> Changed" => "Megváltoztatott tulajdonság: <b>{\$fgp_name}</b>",
// "Gallery of this fileId" => "Gallery of this fileId",
// "space use on" => "space use on",
"Gallery Images" => "Galéria képek",
// "Inviter" => "Inviter",
// "Only successful invitations" => "Only successful invitations",
// "Only pending invitations" => "Only pending invitations",
// "Number of invitations" => "Number of invitations",
// "Invoice Clients" => "Invoice Clients",
// "Tax Status" => "Tax Status",
// "New Contact" => "New Contact",
// "Client Name" => "Client Name",
// "Kaltura Remix Entries" => "Kaltura Remix Entries",
// "Kaltura Media Entries" => "Kaltura Media Entries",
// "Loads" => "Loads",
// "List Remixes" => "List Remixes",
// "Browse Media Entries" => "Browse Media Entries",
// "Browse Remixes" => "Browse Remixes",
// "Create Remix" => "Create Remix",
// "Please select some media entries to use" => "Please select some media entries to use",
// "Remix Video" => "Remix Video",
"Additional Info" => "További információ",
// "Media Id" => "Media Id",
// "Wiki plugin code" => "Wiki plugin code",
// "Media Type" => "Media Type",
// "More Information" => "More Information",
// "No entries" => "No entries",
// "No media entries found" => "No media entries found",
// "Click here" => "Click here",
// "to upload" => "to upload",
// "Modified By" => "Modified By",
// "No mix entries found" => "No mix entries found",
// "to create a new mix" => "to create a new mix",
// "Mix Entries" => "Mix Entries",
// "Playlist Type" => "Playlist Type",
// "No playlists found. " => "No playlists found. ",
// "Click here " => "Click here ",
// "to create a playlist" => "to create a playlist",
"Object Permissions List" => "Objektum jogosultságok listája",
"Manage Permissions" => "Jogosultságok kezelése",
// "\$type" => "\$type",
"global permissions" => "globális jogosultságok",
// "object permissions" => "object permissions",
// "category permissions" => "category permissions",
// "Global Permissions" => "Global Permissions",
// "Delete the selected permissions" => "Delete the selected permissions",
// "Duplicate the selected permissions on this group" => "Duplicate the selected permissions on this group",
// "Object Permissions" => "Object Permissions",
// "If an object is not listed in this section nor in the Category Permissions section, then only the global permissions apply to it" => "If an object is not listed in this section nor in the Category Permissions section, then only the global permissions apply to it",
// "Category Permissions" => "Category Permissions",
// "If an object is not listed in this section nor in the Object Permissions section, then only the global permissions apply to it" => "If an object is not listed in this section nor in the Object Permissions section, then only the global permissions apply to it",
// "{\$special.reason|escape}" => "{\$special.reason|escape}",
// "Blog: %0" => "Blog: %0",
"New Blog Post" => "Új blog poszt",
"Post Title" => "Poszt címe",
"Blog Title" => "Blog neve",
// "New Submission" => "New Submission",
"Survey stats" => "Kérdőív statisztika",
"Take Survey" => "Kérdőív kitöltése",
"trackers" => "űrlapok",
"Items" => "Tétel",
// "Export %0" => "Export %0",
// "Import in %0" => "Import in %0",
"Stop Monitor" => "Figyelés felfüggesztése",
// "Monitor" => "Monitor",
// "Create tracker" => "Create tracker",
// "Do you really remove this tracker" => "Do you really remove this tracker",
// "Do you really want to clear all the items from this tracker? (N.B. there is no undo and notifications will not be sent)" => "Do you really want to clear all the items from this tracker? (N.B. there is no undo and notifications will not be sent)",
// "Duplicate/Import Tracker" => "Duplicate/Import Tracker",
"Duplicate Tracker" => "Űrlap duplikálása",
// "Duplicate Remote Tracker" => "Duplicate Remote Tracker",
// "Search for trackers to clone" => "Search for trackers to clone",
// "Import From Export" => "Import From Export",
// "Raw data" => "Raw data",
// "Preserve tracker ID" => "Preserve tracker ID",
// "users registered" => "users registered",
"like" => "hasonló",
// "Distance (km)" => "Distance (km)",
// "{\$listuserscountry[changes]}" => "{\$listuserscountry[changes]}",
"List Wiki Pages" => "Wiki oldalak listája",
// "Page aliases found" => "Page aliases found",
"Create a Wiki Page" => "Oldal létrehozása",
"Insert name of the page you wish to create" => "Létrehozandó oldal neve",
"Last mod" => "Utolsó módosítás",
"Page creator" => "Oldal létrehozója",
"Last author" => "Utolsó szerző",
"Last version" => "Legutóbbi verzió",
"Last ver" => "összes változat",
"Status of the page" => "Oldal státusza",
"Vers." => "Verzió.",
// "Links to other items in page" => "Links to other items in page",
// "Links to this page in other pages" => "Links to this page in other pages",
"Backl." => "Visszahiv.",
"Page size" => "Oldal mérete",
// "Ratings" => "Ratings",
"unlocked" => "feloldva",
// "No page" => "No page",
// "No pages found with" => "No pages found with",
"Xml Zip" => "Xml Zip",
// "Add page name as a header ! at the beginning of the page content" => "Add page name as a header ! at the beginning of the page content",
"Open client window" => "Kliens ablak megnyitása",
"Generate HTML" => "HTML generálása",
"Transcripts" => "Leíratok",
"Online operators" => "Elérhető operátorok",
"Operator" => "Operátor",
"Accepted requests" => "Elfogadott kérések",
// "{\$online_operators[ix].status}" => "{\$online_operators[ix].status}",
"transcripts" => "leiratok",
"offline" => "nem elérhető",
"Offline operators" => "Nem elérhető operátorok",
// "{\$offline_operators[ix].status}" => "{\$offline_operators[ix].status}",
"Add an operator to the system" => "Operátor hozzáadása a rendszerhez",
"Operators must be tiki users" => "Csak Tiki felhasználók lehetnek operátorok",
"Set as Operator" => "Beállítás operátorként",
"Chat started" => "Csevegés elindítva",
"Operator:" => "Operátor:",
"Live support:User window" => "Élő támogatás:Felhasználói ablak",
"Request live support" => "Élő támogatás kérése",
"Request support" => "Támogatás kérése",
"Open a support ticket instead" => "Inkább egy támogatási jegy megnyitása",
"Your request is being processed" => "A kérés feldolgozás alatt",
"cancel request and exit" => "kérés visszavonása és kilépés",
"cancel request and leave a message" => "kérés visszavonása és üzenet hagyása",
"Live support:Console" => "Élő támogatás:Konzol",
// "{\$status}" => "{\$status}",
"be online" => "elérhetővé válás",
"be offline" => "elérhetetlenné válás",
// "You are not an operator" => "You are not an operator",
"Support requests" => "Támogatási kérések",
"Requested" => "Kérve",
"Join" => "Csatlakozás",
// "No support requests" => "No support requests",
"Support chat transcripts" => "Támogatási csevegés leiratok",
// "Back to admin" => "Back to admin",
"operator" => "operátor",
"started" => "kezdve",
"reason" => "ok",
"msgs" => "üzenetek",
"Transcript" => "Leirat",
"For security purposes we must periodically validate your email address to allow continued access to this site." => "Biztonsági okokból időszakosan validálnunk kell az E-mail címet hogy továbbrais elérhető maradjon az oldal",
"A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site." => "A validálási E-mail elküldésre került. A megadott címen megtekinthető a levél tartalma és a benne található információkat követve az oldal újra elérhetővé válik.",
"Thank you" => "Köszönöm",
"Mail-in feature" => "Mail-in funkció",
// "You do not have any mailin accounts set up" => "You do not have any mailin accounts set up",
// "Click here to go to mailin admin" => "Click here to go to mailin admin",
// "Change to" => "Change to",
// "Week containing" => "Week containing",
// "Month containing" => "Month containing",
// "{\$metrics_range_prefix}" => "{\$metrics_range_prefix}",
// "{\$metrics_range_suffix}" => "{\$metrics_range_suffix}",
"Missing dependency. Obtain <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/" => "Hiányzó előfeltétel, szerezzük be a <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> fájlt és töltsük fel a files/ könyvtárba",
"Prefs" => "Beállítások",
"Daily" => "Napi",
"Weekly" => "Heti",
"Remove old events" => "Régi események eltávolítása",
"h" => "ó",
"mins" => "perc",
// "Edit Event" => "Edit Event",
"Mini Calendar: Preferences" => "Mini Naptár: Beállítások",
"Calendar Interval in daily view" => "Naptár intervallum napi nézetben",
"Start hour for days" => "A nap kezdőóráa",
"End hour for days" => "A nap utolsó óráa",
"Reminders" => "Emlékeztető",
"no reminders" => "nincs emlékeztető",
"min" => "perc",
"Or enter path or URL" => "vagy útvonal / URL megadása",
"Add Topic" => "Téma hozzáadása",
// "Tiki Mods" => "Tiki Mods",
"Mods Configuration" => "Mods konfiguráció",
"Update remote index" => "Távoli index frissítése",
"Rebuild local list" => "Lokális lista újraépítése",
"Republish all" => "Összes újrapublikálása",
"Publish all" => "Összes publikálása",
"Unpublish all" => "Összes publikálásának visszavonása",
"Tiki \"mods\" are additional features not included in the public release. Learn more at <a target=\"tikihelp\" href=\"http://mods.tiki.org\">mods.tiki.org</a>." => "Tiki \"mods\" kiegészítő funkciókat tartalmaz melyek nem beépített részei a hivatalos csomagnak. Több információ róluk itt: <a target=\"tikihelp\" href=\"http://mods.tiki.org\">mods.tiki.org</a>.",
// "Tiki \"mods\" are undergoing refurbishment" => "Tiki \"mods\" are undergoing refurbishment",
// "You will probably find mods shown as being compatible with older versions of Tiki will work with later versions with little or no modification" => "You will probably find mods shown as being compatible with older versions of Tiki will work with later versions with little or no modification",
// "Your help is needed! Please visit <a href=\"http://dev.tiki.org/Mods\">dev.tiki.org</a> to find out more" => "Your help is needed! Please visit <a href=\"http://dev.tiki.org/Mods\">dev.tiki.org</a> to find out more",
"Attention" => "Figyelem",
// "Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"sh setup.sh\" for example)" => "Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"sh setup.sh\" for example)",
// "To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"sh setup.sh open\" to set it up). After installation you need to remove that permission (using \"sh setup.sh\")" => "To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"sh setup.sh open\" to set it up). After installation you need to remove that permission (using \"sh setup.sh\")",
// "for version" => "for version",
// "All versions" => "All versions",
// "or later" => "or later",
// "No mods found" => "No mods found",
"Display only this type" => "Csak ezen típus megjelenítése",
"Unpublish" => "Publikálás visszavonása",
"Republish" => "Újrapublikálás",
"licence" => "licensz",
// "Tiki Mods Configuration" => "Tiki Mods Configuration",
"Mods Install/uninstall" => "Mods telepítés/eltávolítás",
"Enable Mods providing" => "Mods nyújtás aktiválása",
"Mods local directory" => "Mods helyi könyvtár",
"Mods remote server" => "Mods távoli szerver",
"Package Config" => "Csomag beállítás",
"y" => "i",
// "Edit: %0" => "Edit: %0",
"User Galleries" => "Felhasználói galériák",
"My Articles" => "Cikkeim",
"User Articles" => "Felhasználói cikkek",
"My User Items" => "Tételeim",
"User Items" => "Felhasználói tételek",
"Unread Messages" => "Olvasatlan üzenetek",
"User forum topics" => "Felhasználó fórum témái",
"Forum topics" => "Fórum témák",
"Date of post" => "Hozzászólás ideje",
"User forum replies" => "Felhasználó fórum válaszai",
"Forum replies" => "Fórum válaszok",
"User Blogs" => "Felhasználói blogok",
// "To display the objects you created or contributed to" => "To display the objects you created or contributed to",
"MyTiki" => "MyTiki",
"MyInfo" => "Személyes információim",
"Contacts Preferences" => "Kontakt preferenciák",
"Notepad" => "Jegyzettömb",
"MyFiles" => "Fájljaim",
"My Watches" => "Figyeléseim",
"Sent editions" => "Kiküldött változatok",
"HTML version" => "HTML verzió",
"Text version" => "Szöveges verzió",
// "The newsletter was sent to {\$sent} email addresses" => "The newsletter was sent to {\$sent} email addresses",
"Delete errors" => "Hibák törlése",
"Not sent" => "Nem került elküldésre",
// "Thanks for your subscription. You will receive an email soon to confirm your subscription. No newsletters will be sent to you until the subscription is confirmed" => "Thanks for your subscription. You will receive an email soon to confirm your subscription. No newsletters will be sent to you until the subscription is confirmed",
// "Your email address was removed from the list of subscriptors" => "Your email address was removed from the list of subscriptors",
// "Removal of your email address failed" => "Removal of your email address failed",
"Subscription confirmed!" => "Feliratkozás megerősítve!",
"Subscription failed" => "Feliratkozás nem sikerült",
"Subscribe to Newsletter" => "Feliratkozás Hírlevélre",
"Subscribe to this Newsletter" => "Feliratkozás erre a hírlevélre",
"Available Newsletters" => "Elérhető hírlevelek",
"Write a note" => "Jegyzet írása",
"quota" => "Kvóta",
"No notes yet" => "Nincsenek még jegyzeteim",
"Merge selected notes into" => "A kiválasztott jegyzeteket egyesítésem ebben:",
"Reading note:" => "Jegyzet olvasása:",
"List notes" => "Jegyzetek listázása",
"Write note" => "Jegyzet írása",
"Wiki Create" => "Wiki létrehozása",
"Wiki Overwrite" => "Wiki felülírása",
"Object Watches:" => "Objektum figyelések:",
"Object Watches" => "Objektum figyelések",
// "Changes to groups watching" => "Changes to groups watching",
// "These changes to group watches" => "These changes to group watches",
// "were made to these descendants" => "were made to these descendants",
// "Groups watching" => "Groups watching",
// "This Category" => "This Category",
// "All Descendants" => "All Descendants",
"Assign global permissions" => "Globális jogosultságok kiosztása",
"Assign permissions to " => "Jogosultságok megadása: ",
"Edit Permissions" => "Jogosultságok szerkesztése",
"Currently editing Global permissions." => "Globális jogosultságok szerkesztése folyamatban",
// "This object's direct permissions override any global permissions or category permissions affecting this object" => "This object's direct permissions override any global permissions or category permissions affecting this object",
// "This category's direct permissions override any global permissions affecting objects in it" => "This category's direct permissions override any global permissions affecting objects in it",
"To edit global permissions" => "Globális jogosultságok szerkesztéséhez",
// "No permissions yet applied to this object but category permissions affect this object and are displayed below" => "No permissions yet applied to this object but category permissions affect this object and are displayed below",
// "To edit category permissions" => "To edit category permissions",
// "No direct permissions yet applied to this object. Global permissions apply" => "No direct permissions yet applied to this object. Global permissions apply",
// "Currently inherited permissions displayed" => "Currently inherited permissions displayed",
"Assign permissions to this category" => "Jogosultságok kiosztása a kategóriában",
"Assign permissions to this object" => "Jogosultságok hozzárendelése ehhez az objektumhoz",
// "Delete category permissions" => "Delete category permissions",
// "Delete object permissions" => "Delete object permissions",
// "Reset Perms" => "Reset Perms",
// "This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions" => "This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions",
// "This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions" => "This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions",
// "Permissions Clipboard" => "Permissions Clipboard",
// "Copy the permissions set here" => "Copy the permissions set here",
"Paste" => "Beillesztés",
// "Paste copied permissions from " => "Paste copied permissions from ",
"Assign or remove permissions on <em>all</em> child categories" => "Jogosutlságok hozzárendelése/eltávolítása az <em>összes</em> alárendelt kategóriában",
// "Are you sure you want to affect all child categories?\\nThere is no undo" => "Are you sure you want to affect all child categories?\\nThere is no undo",
// "Assign or remove permissions on all pages of the sub-structure" => "Assign or remove permissions on all pages of the sub-structure",
// "Are you sure you want to affect all pages in this sub-structure?\\nThere is no undo" => "Are you sure you want to affect all pages in this sub-structure?\\nThere is no undo",
// "You must select at least one feature" => "You must select at least one feature",
// "View Differences" => "View Differences",
// "Permissions added" => "Permissions added",
// "Permissions removed" => "Permissions removed",
"Select groups" => "Csoportok kiválasztása",
// "Some of your groups have been automatically hidden.<br /> Select the groups below to assign permissions for" => "Some of your groups have been automatically hidden.<br /> Select the groups below to assign permissions for",
"These groups are not the groups that have permissions on the object. It is only the groups you can see in the columns of the first tab." => "Ezen csoportoknak nincs jogosultságok az objektumhoz, ezek mindössze azon csoportok melyek az első fülön is láthatóak",
"Select only groups that have a perm with the object" => "Az objektumhoz jogosultsággal rendelkező csoportok kiválasztása",
"Select features" => "Funkciók kiválasztása",
// "Some of your features have been automatically hidden.<br /> Select the features below to assign permissions for" => "Some of your features have been automatically hidden.<br /> Select the features below to assign permissions for",
"Show permissions for disabled features" => "Kikapcsolt funkciók jogosultságainak megjelenítése",
"Feature name" => "Funkció neve",
"Quick Permissions" => "Gyors jogosultág kiosztás",
// "Assign Quick-Permissions to this object" => "Assign Quick-Permissions to this object",
// "A couple of userdefined permissions are currently assigned (See tab Assign Permissions)" => "A couple of userdefined permissions are currently assigned (See tab Assign Permissions)",
// "<em>Quick permissions</em> should be considered as an experimental feature" => "<em>Quick permissions</em> should be considered as an experimental feature",
// "Although permissions will be set as expected using this form, it doesn't necessarily show the current permissions reliably" => "Although permissions will be set as expected using this form, it doesn't necessarily show the current permissions reliably",
// "There is also no undo - <strong>Use with care!</strong>" => "There is also no undo - <strong>Use with care!</strong>",
"Your OpenID identity is valid" => "Az OpenID identitás valid",
"Your identity gives you access to multiple user accounts" => "Az azonosító hozzáférést biztosít több felhasználói fiókhoz",
"Select account" => "Fiók kiválasztása",
"Orphan Pages" => "Árva oldalak",
"Browser not supported" => "Nem támogatott böngésző",
"Contributions to" => "Hozzájárulások:",
"current version" => "jelenlegi verzió",
"version" => "verzió",
"Words" => "Szavak",
"Whitespaces" => "Whitespace",
"Characters" => "Karakterek",
"Printable characters" => "Nyomtatható karakterek",
"Page changes" => "Oldalváltozások",
"Original wiki text" => "Eredeti wiki szöveg",
"Parsed Text (HTML)" => "Elemzett szöveg (HTML)",
"Output text only (No HTML tags)" => "Csak szöveg (Nincs HTML tag)",
"Show statistics" => "Statisztika megjelenítése",
"Visualize page changes" => "Oldalváltozások megjelenítése",
"Show popups" => "Felugró ablakok megjelenítése",
"Escape HTML / Wiki syntax in page changes" => "HTML / Wiki szintakszis kihagyása oldalváltozásoknál",
"Show contributions" => "Hozzájárulások megjelenítése",
"History:" => "Előzmények:",
"Show Edit Sessions" => "Szerkesztési munkamenetek megjelenítése",
// "Show All Versions" => "Show All Versions",
"Preview of version" => "Verzió előnézete",
"(current)" => "(jelenlegi)",
"Rollback to this version" => "Visszaállítás erre a verzióra",
// "Content Approval" => "Content Approval",
// "This revision is currently marked as approved" => "This revision is currently marked as approved",
// "Remove Approval" => "Remove Approval",
// "This revision has not been approved" => "This revision has not been approved",
// "Approve Revision" => "Approve Revision",
"Source of version" => "Verzió forrása",
"s=source" => "s=source (forrás)",
"b=rollback" => "b=rollback (visszaállítás)",
// "by %0" => "by %0",
// "from %0" => "from %0",
// "approved" => "approved",
// "Updated from" => "Updated from",
// "Used to update" => "Used to update",
// "Wiki Wysiwyg" => "Wiki Wysiwyg",
"Update Translation" => "Fordítás frissítése",
"Hide translation history" => "Fordítási változások elrejtése",
"Show translation history" => "Fordítási változások megjelenítése",
// "Enable pagination" => "Enable pagination",
// "per page" => "per page",
// "Payment Date" => "Payment Date",
// "Payment Type" => "Payment Type",
// "Payer" => "Payer",
// "View payment info" => "View payment info",
// "Assign permissions for payments" => "Assign permissions for payments",
// "Cancel this payment request" => "Cancel this payment request",
// "Request Date" => "Request Date",
// "View payment request" => "View payment request",
// "Paypal" => "Paypal",
// "Transaction ID" => "Transaction ID",
// "Payment made by <em>%0, %1</em> (%2)" => "Payment made by <em>%0, %1</em> (%2)",
// "{\$wp_member_title}" => "{\$wp_member_title}",
// "{\$payment_info.state|escape}" => "{\$payment_info.state|escape}",
// "Paid amount" => "Paid amount",
// "Initial amount" => "Initial amount",
// "Amount remaining" => "Amount remaining",
// "Payment request was sent on %0 and is due by %1" => "Payment request was sent on %0 and is due by %1",
// "Pay with Credit Card through Paypal" => "Pay with Credit Card through Paypal",
// "Pay with Paypal" => "Pay with Paypal",
// "Refresh page" => "Refresh page",
// "Payment info" => "Payment info",
// "Trade with Cclite" => "Trade with Cclite",
// "Payment problem" => "Payment problem",
// "Pay with Tiki User Credits" => "Pay with Tiki User Credits",
// "Credit type" => "Credit type",
// "Credits left" => "Credits left",
// "Amount to pay" => "Amount to pay",
// "Pay using" => "Pay using",
// "Manual payment entry" => "Manual payment entry",
// "Enter payment" => "Enter payment",
// "using" => "using",
// "Payment information" => "Payment information",
// "Outstanding" => "Outstanding",
// "Overdue" => "Overdue",
// "Past" => "Past",
"Request" => "Kérés",
// "Detail" => "Detail",
// "Payable within" => "Payable within",
"Avatar:" => "Avatár:",
"Pick your avatar" => "Avatar kiválasztása",
"Your current avatar" => "Jelenlegi avatárom",
// "Full size" => "Full size",
"no avatar" => "Nincs avatár",
"Pick avatar from the library" => "Avatár kiválasztása könyvtárból",
"Pick user Avatar" => "Felhasználói avatár kiválasztása",
"Hide all" => "Összes elrejtése",
"icons" => "ikon",
"Show all" => "Összes mutatása",
"Avatar Image" => "Avatár kép",
"random" => "véletlenszerű",
"Upload your own avatar" => "Saját avatár feltöltése",
"File (only .gif, .jpg and .png images approximately 45px × 45px)" => "Fájl (csak .gif, .jpg és .png kitejesztésű képek kb 45px × 45px méretben)",
// "File (only .gif, .jpg and .png images)" => "File (only .gif, .jpg and .png images)",
// "Plugin execution was denied" => "Plugin execution was denied",
// "Plugin execution pending approval" => "Plugin execution pending approval",
// "After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected" => "After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected",
// "This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible" => "This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible",
// "You are allowed to" => "You are allowed to",
// "View arguments" => "View arguments",
// "Execute the plugin in preview mode (may be dangerous)" => "Execute the plugin in preview mode (may be dangerous)",
// "Approve the plugin for public execution" => "Approve the plugin for public execution",
// "View Details" => "View Details",
// "This plugin does not contain any arguments" => "This plugin does not contain any arguments",
"Body" => "Törzs",
// "This plugin's body is empty" => "This plugin's body is empty",
"Insert" => "Beszúrás",
// "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups" => "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups",
// "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins" => "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins",
// "This page lists the plugins that require validation, the first time they are encountered" => "This page lists the plugins that require validation, the first time they are encountered",
// "Each plugin contains a unique <em>signature</em> that is preserved" => "Each plugin contains a unique <em>signature</em> that is preserved",
// "When you upgrade from an old version, you may need to reparse all the pages" => "When you upgrade from an old version, you may need to reparse all the pages",
// "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list" => "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list",
// "The plugin will automatically be added if it is encountered" => "The plugin will automatically be added if it is encountered",
// "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin" => "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin",
// "For security, you should review each plugin to ensure it is safe to approve" => "For security, you should review each plugin to ensure it is safe to approve",
// "Added By" => "Added By",
// "Signature" => "Signature",
// "Wiki page: <a href=\"%0#%2\" title=\"{tr}View this page" => "Wiki page: <a href=\"%0#%2\" title=\"{tr}View this page",
// "<a href=\"%0#%2\" title=\"{tr}View this page" => "<a href=\"%0#%2\" title=\"{tr}View this page",
// "Approve all pending plugins" => "Approve all pending plugins",
// "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins" => "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins",
// "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe" => "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe",
// "No plugins pending approval" => "No plugins pending approval",
// "{\$channels[ix].title|escape}" => "{\$channels[ix].title|escape}",
"View Results" => "Eredmények megtekintése",
"Vote poll" => "Szavazás",
"Other Polls" => "Egyéb szavazások",
// "Poll Results" => "Poll Results",
// "Top Voted Polls" => "Top Voted Polls",
// "Edit Poll" => "Edit Poll",
// "Find the poll" => "Find the poll",
// "{\$what}" => "{\$what}",
// "Number of top voted polls to show" => "Number of top voted polls to show",
// "Vote range displayed" => "Vote range displayed",
// "All votes with no span consideration" => "All votes with no span consideration",
// "All votes with span consideration" => "All votes with span consideration",
// "All votes" => "All votes",
// "List Votes" => "List Votes",
"votes" => "szavazat",
// "Popup preview" => "Popup preview",
// "Close preview" => "Close preview",
"Topic image" => "Téma kép",
"The original document is available at" => "Az eredeti dokumentum itt érhető el:",
"Print multiple pages" => "Oldalak tömeges nyomtatása",
"Selected Structures" => "Kiválasztott struktúrák",
"Add Structure" => "Struktúra hozzáadása",
"No structures" => "Nincsenek struktúrák",
// "Available Pages" => "Available Pages",
"No pages" => "Nincsnek oldalak",
// "All pages selected" => "All pages selected",
"Add Page" => "Oldal hozzáadása",
"Remove Page" => "Oldal eltávolítása",
"Selected Pages" => "Kiválaszott oldalak",
"No pages selected." => "Nincsenek oldalak kiválasztva",
"Add Pages from Structures" => "Oldalak hozzáadása struktúrákból",
// "Edit quiz" => "Edit quiz",
"Current Version" => "Jelen verzió",
"General Options" => "Általános beállítások",
"Publication Date" => "Publikálás dátuma",
// "at " => "at ",
// "Use " => "Use ",
// "randomly selected questions" => "randomly selected questions",
// "Test-time Options" => "Test-time Options",
"Shuffle questions" => "Kérdések véletlenszerű sorrendje",
"Shuffle answers" => "Válaszok véletlenszerű sorrendje",
// "Limit questions displayed per page to " => "Limit questions displayed per page to ",
// "  question(s)" => "  question(s)",
// "Impose a time limit of " => "Impose a time limit of ",
// "Allow students to store partial results and return to quiz" => "Allow students to store partial results and return to quiz",
// "Allow students to retake this quiz " => "Allow students to retake this quiz ",
// "Grading and Feedback" => "Grading and Feedback",
"Grading method " => "Osztályozási módszer",
// "Show students their score " => "Show students their score ",
// "Show students the correct answers " => "Show students the correct answers ",
"Publish statistics " => "Statisztikák publikálása",
"Extra Options" => "Extra opciók",
// "Solicit additional questions from students" => "Solicit additional questions from students",
// "Link quiz to forum named: " => "Link quiz to forum named: ",
"Prologue" => "Prológus",
"Epilogue" => "Epilógus",
"Quiz result stats" => "Kvíz eredményeinek statisztikája",
"Time" => "Idő",
"User answers" => "Felhasználói válaszok",
"Stats for quizzes" => "Kvízek statisztikája",
"taken" => "kitöltött kvíz",
"Av score" => "Átlagos eredmény",
"Av time" => "Átlagos idő",
"Stats for quiz" => "Kvíz statisztika",
"Clear Stats" => "Statisztika törlése",
"time taken" => "eltöltött idő",
// "P/F" => "P/F",
// "Passed" => "Passed",
// "Stats for this quiz Questions " => "Stats for this quiz Questions ",
"Top 10" => "Első 10",
"Top 20" => "Első 20",
"Top 50" => "Első 50",
"Top 100" => "Első 100",
"Rank" => "Rang",
// "Not Published" => "Not Published",
// "This Article is currently not published and only visible by Editors" => "This Article is currently not published and only visible by Editors",
"Received articles" => "Fogadott cikkek",
"Edit received article" => "Beérkezett cikk szerkesztése",
"Use Image" => "Kép használata",
"Image x size" => "Kép x méret",
"Image y size" => "Kép y méret",
"Image name" => "Kép neve",
"Accept Article" => "Cikk elfogadása",
"Received Pages" => "Oldal fogadása",
// "{\$error.error}" => "{\$error.error}",
"Edit Received Page" => "Beérkezett oldal szerkesztése",
"The highlight pages already exist" => "A kiemelt oldalak már léteznek",
// "Please, change the name if you want the page to be uploaded" => "Please, change the name if you want the page to be uploaded",
"Received Structures" => "Beérkezett struktúrák",
"Prefix the checked" => "Kijelöltek kiegészítése ezen előtaggal",
"Postfix the checked" => "Kijelöltek kiegészítése ezen utótaggal",
"Referer stats" => "Hivatkozási statisztika",
"Last" => "Utolsó",
"Register as a new user" => "Regisztrálás új felhasználóként",
// "Tiki site registered" => "Tiki site registered",
// "The following site was added and validation by admin may be needed before appearing on the lists" => "The following site was added and validation by admin may be needed before appearing on the lists",
"You don't have permission to use this feature" => "A funkció használatához magasabb szintű jogosultágra van szükség",
"Please register" => "Regisztráció szükséges",
// "Register this site at Tiki.org" => "Register this site at Tiki.org",
// "Read this first" => "Read this first",
// "On this page you can make your tiki site known to Tiki.org. It will get shown there in a list of known tiki sites" => "On this page you can make your tiki site known to Tiki.org. It will get shown there in a list of known tiki sites",
// "Registering is voluntary" => "Registering is voluntary",
// "Registering does not give you any benefits except one more link to your site" => "Registering does not give you any benefits except one more link to your site",
// "You don't get any emails, we don't sell the data about your site" => "You don't get any emails, we don't sell the data about your site",
// "Registering is just for us to get an overview of Tiki's usage" => "Registering is just for us to get an overview of Tiki's usage",
// "If your site is private or inside your intranet, you should not register" => "If your site is private or inside your intranet, you should not register",
"tiki.org" => "tiki.org",
// "Information about your site" => "Information about your site",
// "Enter your username or email" => "Enter your username or email",
"Enter your email" => "E-mail cím megadása",
"Send me my Password" => "Küldd el a jelszóm",
"Request Password Reset" => "Jelszóváltoztatás kérése",
"Remove page" => "Oldal eltávolítása",
"Last Version" => "Legutóbbi verzió",
"Back to page" => "Vissza az oldalra",
"You are about to remove the page" => "Ezzel eltávolításra kerül a lap",
"permanently" => "oldalt",
"Remove all versions of this page" => "Az oldal összes verziójának eltávolítása",
"Rename page" => "Oldal átnevezése",
// "Rollback page" => "Rollback page",
"to version" => "verzióra",
// "This feature currently searches and replaces within wiki pages only" => "This feature currently searches and replaces within wiki pages only",
// "Max number of pages at a time" => "Max number of pages at a time",
// "Number of surrounding chars to preview" => "Number of surrounding chars to preview",
// "Replace selected" => "Replace selected",
"Searched" => "Keresések száma",
"Search in" => "Keresés itt",
"Date Search" => "Dátum keresés",
"All dates" => "Összes dátum",
// "{\$languages[ix].name}" => "{\$languages[ix].name}",
"Calendar Items" => "Naptár tételek",
// "{\$where|escape}" => "{\$where|escape}",
// "{\$where_label|escape}" => "{\$where_label|escape}",
// "{\$results[search].type|escape}" => "{\$results[search].type|escape}",
"Simple search" => "Egyszerű keresés",
// "You can also send newsletters using an external client" => "You can also send newsletters using an external client",
// "This newsletter will be sent to {\$subscribers} email addresses" => "This newsletter will be sent to {\$subscribers} email addresses",
"Reply to" => "Válasz",
// "Recipients" => "Recipients",
// "Validated" => "Validated",
// "Is user" => "Is user",
// "Sending Newsletter" => "Sending Newsletter",
"Prepare a newsletter to be sent" => "Kiküldendő hírlevél szerkesztése",
// "Apply content template" => "Apply content template",
"Data HTML:" => "Adat HTML:",
"Must be wiki parsed:" => "Wiki által elemzettnek kell lennie:",
"Data Txt:" => "Adat Txt:",
"Article Clip (read only):" => "Cikk csatolás (csak olvasható):",
"Clip Now" => "Csatolás most",
// "Clip Articles" => "Clip Articles",
"To include the article clipping into your newsletter, cut and paste it into the contents." => "Cikkek beillesztésének lehetőségéhez ki kell vágni és be kell illeszteni a tartalomba.",
"If autoclipping is enabled, you can also enter \"~~~articleclip~~~\" which will be replaced with the latest\tclip when sending." => "Amennyiben az automatikus cikk csatolás be van kapcsolva akkor elég megadni ezt a formulát: \"~~~articleclip~~~\" (kiküldés során automatikusan beillesztésre kerül a legutóbbi tartalom)",
// "Be careful not to paste articles that must not be seen by the recipients" => "Be careful not to paste articles that must not be seen by the recipients",
"Attached Files" => "Mellékelt fájlok",
"remove" => "eltávolítás",
// "octets" => "octets",
"To add a file, click here" => "Kattintás ide fájl hozzáadásához",
"Reply To Email" => "Válasz E-mail cím",
"if not:" => "egyébként",
// "Sender email not set" => "Sender email not set",
"Save as Draft" => "Mentés piszkozatként",
// "Save your changes" => "Save your changes",
// "Save any changes and send to all subscribers" => "Save any changes and send to all subscribers",
// "Drafts (%0)" => "Drafts (%0)",
// "Sent Editions (%0)" => "Sent Editions (%0)",
"Send objects" => "Objektumok küldése",
"Transmission results" => "Átvitel eredménye",
"Send Wiki Pages" => "Wiki oldalak küldése",
"Send a structure" => "Struktúra küldése",
"Send Articles" => "Cikkek küldése",
"Add Article" => "Cikk hozzáadása",
"Send objects to this site" => "Objektumok küldése erre az oldalra",
// "Ex: http://tiki.org or localhost" => "Ex: http://tiki.org or localhost",
// "Use /commxmlrpc.php if your Tiki site is installed at the root, otherwise adapt /tiki to your need" => "Use /commxmlrpc.php if your Tiki site is installed at the root, otherwise adapt /tiki to your need",
// "Report this page" => "Report this page",
// "Page shared" => "Page shared",
// "The link was sent via e-Mail to the following addresses" => "The link was sent via e-Mail to the following addresses",
// "The link was sent via Twitter" => "The link was sent via Twitter",
// "The link was posted on your Facebook wall" => "The link was posted on your Facebook wall",
// "The link was sent as message to" => "The link was sent as message to",
// "The link was published in a" => "The link was published in a",
"Short link" => "Rövid link",
// "Have a look at this page" => "Have a look at this page",
"Your message" => "Üzenet szövege",
"I found an interesting page that I thought you would like." => "Találtam itt egy oldalt ami szerintem érdekelni fog, ha van időd, nézz rá, üdv,",
// "e-Mail" => "e-Mail",
"Send via e-Mail" => "Küldés E-mailben ",
"Recipient(s)" => "Címzett(ek)",
// "Separate multiple email addresses with a comma and a space" => "Separate multiple email addresses with a comma and a space",
"Separate multiple email addresses with a comma." => "Több E-mail cím is megadható vesszőkkel elválasztva",
"Your name" => "Küldő neve",
// "Tweet via Twitter" => "Tweet via Twitter",
// "Authorize with Twitter first" => "Authorize with Twitter first",
// "Have a look at " => "Have a look at ",
// "Put on my Facebook wall" => "Put on my Facebook wall",
// "Authorize with Facebook first" => "Authorize with Facebook first",
// "Link text" => "Link text",
// "This will be the title for the URL" => "This will be the title for the URL",
// "Like this post" => "Like this post",
// "Subscribe notification" => "Subscribe notification",
// "How much time recipients can access to this page" => "How much time recipients can access to this page",
// "time" => "time",
// "You do not have the permission to send messages or you did not allow other users to send you messages" => "You do not have the permission to send messages or you did not allow other users to send you messages",
// "Separate multiple recipients with a semicolon" => "Separate multiple recipients with a semicolon",
// "Post on forum" => "Post on forum",
// "There is no forum where you can post a message" => "There is no forum where you can post a message",
// "password-protected" => "password-protected",
"Share access rights" => "Hozzáférési jogok megosztása",
// "Return to previous page" => "Return to previous page",
"Create a sheet" => "Táblázat létrehozása",
// "Configure this sheet" => "Configure this sheet",
// "There are individual permissions set for this sheet" => "There are individual permissions set for this sheet",
"Class Name" => "Osztály neve",
"Header Rows" => "Fejléc sorok",
"Footer Rows" => "Lábléc sorok",
"Wiki Parse Values" => "Wiki értékek elemzése",
// "Parent Spreadsheet" => "Parent Spreadsheet",
"Makes this sheet a \"child\" sheet of a multi-sheet set" => "Táblázat gyűjtemény \"gyermek\" táblázatává teszi ezt a táblázatot",
// "You can access the sheet using the following URL" => "You can access the sheet using the following URL",
// "Banned Words" => "Banned Words",
"Change shoutbox general settings" => "Az üzenőfal általános beállításai",
"auto-link urls" => "URL-ek automatikus linkelése",
"Post or edit a message" => "Üzenet szerkesztése vagy elküldése",
"Location : " => "Hely : ",
// "Content may be out of date" => "Content may be out of date",
// "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages" => "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages",
"page: %0/%1" => "oldal: %0/%1",
// "This text was automatically translated by Google Translate from the following page: " => "This text was automatically translated by Google Translate from the following page: ",
"Last edited by" => "Utoljára szerkesztette:",
"based on work by" => "a következő felhasználó munkája alapján:",
"Contributors to this page:" => "Hozzájárulók az oldal szerkesztéséhez",
// "First Slide" => "First Slide",
// "Previous Slide" => "Previous Slide",
// "Previous Point" => "Previous Point",
// "Next Point" => "Next Point",
// "Next Slide" => "Next Slide",
// "Last Slide" => "Last Slide",
// "Jump To Slide" => "Jump To Slide",
// "Play" => "Play",
// "Pause" => "Pause",
// "Toggle Loop" => "Toggle Loop",
// "Export to PDF" => "Export to PDF",
// "Exit" => "Exit",
// "Change Theme" => "Change Theme",
// "To use Twitter integration, the site admin must register this site as an application at <a href=\"http://twitter.com/oauth_clients/\" target=\"_blank\">http://twitter.com/oauth_clients/</a> and allow write access for the application" => "To use Twitter integration, the site admin must register this site as an application at <a href=\"http://twitter.com/oauth_clients/\" target=\"_blank\">http://twitter.com/oauth_clients/</a> and allow write access for the application",
// "Twitter authorisation" => "Twitter authorisation",
// "to manage your authorisations at Twitter" => "to manage your authorisations at Twitter",
// "this site with twitter.com to use Twitter integration of this site" => "this site with twitter.com to use Twitter integration of this site",
// "To use Facebook integration, the site admin must register this site as an application at <a href=\"http://developers.facebook.com/setup/\" target=\"_blank\">http://developers.facebook.com/setup/</a> first" => "To use Facebook integration, the site admin must register this site as an application at <a href=\"http://developers.facebook.com/setup/\" target=\"_blank\">http://developers.facebook.com/setup/</a> first",
// "Facebook authorisation" => "Facebook authorisation",
// "to manage your authorisations at Facebook" => "to manage your authorisations at Facebook",
// "this site with facebook.com to use Facebook integration of this site" => "this site with facebook.com to use Facebook integration of this site",
// "The site admin has set up a global account which will be used for this site" => "The site admin has set up a global account which will be used for this site",
"Save changes" => "Változások mentése",
// "You will be redirected to the home page shortly" => "You will be redirected to the home page shortly",
// "to go to the home page immediately" => "to go to the home page immediately",
// "Please provide local account information" => "Please provide local account information",
// "Do you already have a local account for this site? Login to link to it using the following form instead" => "Do you already have a local account for this site? Login to link to it using the following form instead",
// "Link to Existing Account" => "Link to Existing Account",
// "You will not see the latest queries" => "You will not see the latest queries",
// "Params" => "Params",
"Most viewed objects" => "Leglátogatottabb objektumok",
"Most viewed objects in the last 7 days" => "Leglátogatottabb objektumok az elmúlt 7 napban",
"Site Stats" => "Általános weblap statisztika",
// "Date of first pageview" => "Date of first pageview",
// "Days since first pageview" => "Days since first pageview",
"Total pageviews" => "Összesen ennyiszer tekintették meg az oldalakat",
"Average pageviews per day" => "Naponta átlagosan ennyiszer tekintették meg az oldalakat",
"Wiki Stats" => "Wiki oldal statisztika",
"Size of Wiki Pages" => "Wiki oldalak mérete",
"Average page length" => "Wiki oldalak átlagos mérete (forrásban)",
"Average versions per page" => "Az oldalaknak átlagosan ennyi verziójuk van",
"Visits to wiki pages" => "Látogatások a Wiki oldalakban",
"Average links per page" => "Wiki oldalak átlagos hivatkozásainak száma",
"Image galleries Stats" => "Képgaléria statisztika",
"Average images per gallery" => "Képek átlagos száma galériánként",
"Total size of images" => "Képek összes mérete",
"Average image size" => "Egy kép átlagos mérete",
"Visits to image galleries" => "Látogatások a képgalériákban",
"File galleries Stats" => "Fájlgaléria statisztika",
"Average files per gallery" => "Fájlok átlagos száma galériánként",
"Total size of files" => "Fájlok összes mérete",
"Average file size" => "Egy fájl átlagos mérete",
"Visits to file galleries" => "Látogatások a fájlgalériákban",
// "Articles Stats" => "Articles Stats",
"Total reads" => "Összes olvasás",
"Average reads per article" => "Cikkek átlagos olvasottsága",
"Total articles size" => "Cikkek teljes mérete",
"Average article size" => "Cikkek átlagos mérete",
"Forum Stats" => "Fórum statisztika",
"Total topics" => "Összes téma",
"Average topics per forums" => "Átlagos témák száma fórumonként",
"Total replies" => "Összes válasz",
"Average number of replies per topic" => "Válaszok átlagos száma témánként",
"Visits to forums" => "Látogatások a Fórumokon",
"Blog Stats" => "Blog statisztika",
"Weblogs" => "Webblogok",
"Total posts" => "Összes poszt",
"Average posts per weblog" => "Posztok átlagos száma blogonként",
"Total size of blog posts" => "Blogposztok teljes mérete",
"Average posts size" => "Posztok átlagos mérete",
"Visits to weblogs" => "Webblogok látogatottsága",
"Poll Stats" => "Szavazás statisztika",
"Total votes" => "Összes szavazat",
"Average votes per poll" => "Szavazatok átlagos száma szavazásonként",
"FAQ Stats" => "Gyik statisztika",
"Total questions" => "Összes kérdés",
"Average questions per FAQ" => "Kérdések átlagos száma témánként",
"User Stats" => "Felhasználó statisztika",
"Average bookmarks per user" => "Könyvjelzők átlagos száma felhasználónként",
"Average questions per quiz" => " Kérdések átlagos száma kvízenként",
"Quizzes taken" => "Kitöltött kvízek száma",
"Average quiz score" => "Kvízek átlagos eredménye",
"Average time per quiz" => "Átlagos idő kvízenként",
// "Most viewed objects in period" => "Most viewed objects in period",
// "{\$best_objects_stats_between[i]->type}" => "{\$best_objects_stats_between[i]->type}",
// "{\$best_objects_stats_lastweek[i]->type}" => "{\$best_objects_stats_lastweek[i]->type}",
"Usage chart" => "Használati diagram",
"Usage chart image" => "Használati diagram kép",
"Daily Usage" => "Napi használat",
// "Stats for surveys" => "Stats for surveys",
// "Last taken" => "Last taken",
// "Stats for survey" => "Stats for survey",
"Tiki Logs" => "Tiki logok",
// "Export through Action Log" => "Export through Action Log",
"Clean logs older than" => "Összes olyan log törlése mely idősebb mint",
"Time Left" => "Hátralévő idő",
"Send Answers" => "Kérések küldése",
"Thank you for your submission" => "Köszönjük a beküldést",
"Send a link to a friend" => "Link küldése ismerősnek",
"Your email was sent" => "Az E-mail elküldésre került",
"The link was sent to the following addresses:" => "A link a következp címekre került elküldésre:",
"Friend's email" => "Ismerős E-mail címe",
// "TikiTests Edit" => "TikiTests Edit",
// "Summary mode" => "Summary mode",
"Show Page Differences" => "Oldaleltérések megjelenítése",
// "Show Tidy Errors and Warnings" => "Show Tidy Errors and Warnings",
// "Show POST Data" => "Show POST Data",
// "Use Current Session/Log out" => "Use Current Session/Log out",
// "Recorded Links" => "Recorded Links",
// "Element to compare (Xpath expression)" => "Element to compare (Xpath expression)",
// "Test Xpath Expression" => "Test Xpath Expression",
// "Post Variables" => "Post Variables",
// "Tidy Results" => "Tidy Results",
"Delete this link" => "Ezen link törlése",
// "TikiTests List" => "TikiTests List",
// "Config" => "Config",
// "Replay" => "Replay",
// "Tidy extension not present" => "Tidy extension not present",
// "PECL HTTP extension present" => "PECL HTTP extension present",
// "cURL extension present" => "cURL extension present",
// "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible" => "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible",
// "List TikiTests" => "List TikiTests",
// "Create a TikiTest" => "Create a TikiTest",
// "Replay the TikiTest" => "Replay the TikiTest",
// "Edit the TikiTest" => "Edit the TikiTest",
// "TikiTests Record Configuration" => "TikiTests Record Configuration",
// "Start Recording Test" => "Start Recording Test",
// "TikiTests Replay Configuration" => "TikiTests Replay Configuration",
// "Failure" => "Failure",
// "Reference" => "Reference",
// "The pages are different" => "The pages are different",
// "The pages are identical" => "The pages are identical",
// "Recording to pause press the pause button" => "Recording to pause press the pause button",
// "Pause the recording" => "Pause the recording",
// "Paused to resume press the play button" => "Paused to resume press the play button",
// "Resume the recording" => "Resume the recording",
// "Stop the recording" => "Stop the recording",
// "Theme Control Center: Categories" => "Theme Control Center: Categories",
"Theme is selected as follows:" => "A stílus a következő sorrendben kerül kiválasztásra:",
"If a theme is assigned to the individual object that theme is used." => "Ha az adott objektumhoz stílus van megadva, akkor az lesz használva",
"If not then if a theme is assigned to the object's category that theme is used" => "Ha nincs megadva, akkor az objektum kategóriájához rendelt,",
"If not then a theme for the section is used" => "Ha az sincs, akkor a szekció stílusa, ",
"If none of the above was selected the user theme is used" => "Ha az sincs akkor a felhasználó általi preferált stílus,",
"Finally if the user didn't select a theme the default theme is used" => "és végül ha az sincs megadva akkor az oldal alapértelmezett stílusa kerül felhasználásra",
"Control by Objects" => "Objektumonkénti vezérlés",
"Control by Sections" => "Szekciónkénti vezérlés",
"Assign themes to categories" => "Stílusok hozzárendelése kategóriákhoz",
"Assigned categories" => "Hozzárendelt kategóriák",
"Theme Control Center: Objects" => "Stílusvezérlés: Objektumok",
"Control by Categories" => "Kategóriánkénti vezérlés",
"Assign themes to objects" => "Stílus hozzárendelése objektumokhoz",
"Assigned objects" => "Hozzárendelt objektumok",
// "Theme Control Center: Sections" => "Theme Control Center: Sections",
"Assign themes to sections" => "Stílus hozzárendelése szekciókhoz",
"Assigned sections" => "Hozzárendelt szekciók",
// "Apply the following profile for enhancements: " => "Apply the following profile for enhancements: ",
// "Time Tracker" => "Time Tracker",
// "Local Cache (Not Committed)" => "Local Cache (Not Committed)",
// "Saved (Committed)" => "Saved (Committed)",
"New task" => "Új feladat",
// "Toggle completed" => "Toggle completed",
// "Toggle archived" => "Toggle archived",
// "Task name" => "Task name",
// "Estimate (in min.)" => "Estimate (in min.)",
// "Estimate" => "Estimate",
// "Task is completed" => "Task is completed",
// "Task is archived" => "Task is archived",
// "Created at" => "Created at",
// "Are you sure you want to delete all tasks" => "Are you sure you want to delete all tasks",
// "Commit Time Sheet Items" => "Commit Time Sheet Items",
// "View All" => "View All",
// "View My Items" => "View My Items",
"Summary" => "Összefoglalás",
// "Time Spent" => "Time Spent",
// "Done By" => "Done By",
// "Add Tracker" => "Add Tracker",
// "Add Tracker To Tracker Report" => "Add Tracker To Tracker Report",
// "View Tracker Report" => "View Tracker Report",
// "Pick tracker to join" => "Pick tracker to join",
// "Pick fields to join on" => "Pick fields to join on",
// "Join inner" => "Join inner",
// "Join outer" => "Join outer",
// "Tracker - Open" => "Tracker - Open",
// "Tracker - Pending" => "Tracker - Pending",
// "Tracker - Closed" => "Tracker - Closed",
// "Tracker Item History" => "Tracker Item History",
// "View Tracker Item" => "View Tracker Item",
// "Not logging" => "Not logging",
// "Tracker changes are not being logged: Go to <a href=\"tiki-admin_actionlog.php?action_log_type=trackeritem&cookietab=2\" >Action log admin</a> to enable" => "Tracker changes are not being logged: Go to <a href=\"tiki-admin_actionlog.php?action_log_type=trackeritem&cookietab=2\" >Action log admin</a> to enable",
// "Edit File" => "Edit File",
// "Advanced mode" => "Advanced mode",
"Simple mode" => "Egyszerű mód",
// "Retry" => "Retry",
"The following file was successfully uploaded" => "A következő fájl sikeresen feltöltésre került",
"The following files have been successfully uploaded" => "A következő fájlok sikeresen feltöltésre kerültek",
"You can download this file using" => "Link a fájl letöltéséhez",
"You can link to the file from a Wiki page using" => "Link a fájlhoz Wiki oldalról",
"You can display an image in a Wiki page using" => "Kép megjelenítéséhez Wiki oldalon",
// "Or using as a thumbnail with ShadowBox" => "Or using as a thumbnail with ShadowBox",
"You can link to the file from an HTML page using" => "Link a fájlhoz HTML oldalról",
"You locked the file" => "A fájl zárolásra került",
// "The file is locked by {\$fileInfo.lockedby}" => "The file is locked by {\$fileInfo.lockedby}",
"File title:" => "Fájl neve:",
"required field for podcasts" => "podcast-okhoz szükséges",
"File description:" => "Fájl leírása:",
// "We're sorry" => "We're sorry",
// "Upload interface could not load.  You must have JavaScript enabled to enjoy Upload interface" => "Upload interface could not load.  You must have JavaScript enabled to enjoy Upload interface",
// "Upload interface is loading" => "Upload interface is loading",
// "Please wait a moment.." => "Please wait a moment..",
// "Upload interface is taking a long time to load or the load has failed" => "Upload interface is taking a long time to load or the load has failed",
// "Please make sure that the Flash Plugin is enabled and that a working version of the Adobe Flash Player is installed" => "Please make sure that the Flash Plugin is enabled and that a working version of the Adobe Flash Player is installed",
// "We are sorry: Upload interface could not load.  You may need to install or upgrade Flash Player" => "We are sorry: Upload interface could not load.  You may need to install or upgrade Flash Player",
// "Visit the Adobe Website to get the Flash Player" => "Visit the Adobe Website to get the Flash Player",
"Unzip zip files" => "Zip fájlok kitömörítése",
// "File can be deleted after" => "File can be deleted after",
// "Root" => "Root",
// "Creator of file, if different from the 'Uploaded by' user" => "Creator of file, if different from the 'Uploaded by' user",
// "Maximum number of downloads" => "Maximum number of downloads",
// "-1 for no limit" => "-1 for no limit",
// "Upload File(s)" => "Upload File(s)",
// "Cancel Upload" => "Cancel Upload",
// "Add Another File" => "Add Another File",
"Maximum file size is around:" => "Maximális fájlméret (körülbelül):",
// "Uploading file.." => "Uploading file..",
// "No File to Upload.." => "No File to Upload..",
// " Syntax tips" => " Syntax tips",
// "Link to file from a Wiki page" => "Link to file from a Wiki page",
// "In addition, for image files" => "In addition, for image files",
// "To display full size in a Wiki page" => "To display full size in a Wiki page",
// "Display thumbnail that enlarges" => "Display thumbnail that enlarges",
"Upload successful!" => "A feltöltés sikeres!",
"The following image was successfully uploaded" => "Az alábbi kép sikeresen feltöltésre került",
// "Image ID thumb" => "Image ID thumb",
"You can view this image in your browser using" => "Ezt a képet meg lehet nézni a böngészőből ennek használatával",
// "You can include the image in an Wiki page using" => "You can include the image in an Wiki page using",
"or use filename" => "vagy fájlnév használata",
"Now enter the image URL" => "A kép URL-jének beírása",
// "or upload a local image from your disk" => "or upload a local image from your disk",
// "Batch Upload" => "Batch Upload",
"Thumbnail (optional, overrides automatic thumbnail generation)" => "Előnézeti kép (opcionális, felülírja az automatikusan generáltat)",
"No gallery available." => "Nincs elérhető galéria.",
"You have to create a gallery first!" => "Először létre kell hozni egy galériát!",
// "User assigned modules" => "User assigned modules",
"Restore defaults" => "Alapértékek visszaállítása",
// "The column is disabled" => "The column is disabled",
// "#" => "#",
// "act" => "act",
// "Move to Right Column" => "Move to Right Column",
// "Move to Left Column" => "Move to Left Column",
// "Assign module" => "Assign module",
"top" => "felülre",
"Current folder" => "Jelenlegi mappa",
"Folders" => "Mappák",
// "Folder in" => "Folder in",
"Remove Folder" => "Mappa eltávolítása",
"Refresh Cache" => "Cache frissítése",
"Admin folders and bookmarks" => "Mappák és könyvjelzők beállítása",
"a folder" => "(mappa)",
"a bookmark" => "(könyvjelző)",
"User Contacts Preferences" => "Felhasználói kontaktok beállításai",
"Manage Fields" => "Mezők kezelése",
// "{\$ext.fieldname|escape}" => "{\$ext.fieldname|escape}",
// "{if \$escape_menu_labels}{\$chdata.name|escape}{else}{\$chdata.name}{/if}" => "{if \$escape_menu_labels}{\$chdata.name|escape}{else}{\$chdata.name}{/if}",
"Send me a message" => "Üzenj nekem!",
"Basic Data" => "Alapadatok",
"Assign Group" => "Csoport hozzárendelése",
"Change user preferences" => "Felhasználói preferenciák megváltoztatása",
// "User Icon" => "User Icon",
"Real Name:" => "Valódi név:",
// "{\$gender}" => "{\$gender}",
"(non public)" => "(nem publikus)",
// "{\$country|stringfix}" => "{\$country|stringfix}",
// "User's homepage" => "User's homepage",
"Personal Wiki Page" => "Személyes Wiki oldal",
"Last login:" => "Legutóbbi bejelentkezés:",
// "This user is your friend " => "This user is your friend ",
// "The user requested friendship with you" => "The user requested friendship with you",
// "Accept friendship from this user" => "Accept friendship from this user",
// "Refuse friendship from this user" => "Refuse friendship from this user",
// "Currently waiting for user approval" => "Currently waiting for user approval",
// "Cancel friendship request towards this user" => "Cancel friendship request towards this user",
// "Request friendship from this user" => "Request friendship from this user",
// "Additional Information" => "Additional Information",
// "Change user information" => "Change user information",
"User Contribution" => "Felhasználói hozzájárulások",
"has contributed to the following content" => "a következőket hozta létre",
// "has not contributed to any content yet" => "has not contributed to any content yet",
"Forum comments" => "Fórum kommentek",
// "Who Looks At Stuff" => "Who Looks At Stuff",
// "Who Looks At Your Stuff" => "Who Looks At Your Stuff",
// "Who Looks At His Stuff" => "Who Looks At His Stuff",
"Send Me A Message" => "Üzenj nekem",
"Send me a message !" => "Üzenj nekem !",
"The following message will be sent to user" => "Az alábbi üzenet kerül elküldésre a felhasználóhoz",
"Message Body" => "Üzenet szövege",
// "Toggle" => "Toggle",
// "Toggle options" => "Toggle options",
"Personal Information" => "Személyes adatok",
"Male" => "Férfi",
"Female" => "Nő",
"Hidden" => "Rejtett",
// "{\$flags[ix]|stringfix}" => "{\$flags[ix]|stringfix}",
"Your personal Wiki Page" => "Személyes Wiki oldalam",
// "User's personal tracker information" => "User's personal tracker information",
// "View extra information" => "View extra information",
"Your personal tracker information" => "Személyes űrlap adataim",
"Is email public? (uses scrambling to prevent spam)" => "E-mail nyilvános? (van spamvédelem)",
"Unavailable - please set your e-mail below" => "Nem elérhető - be kell állítani az E-mail címet lentebb",
"Does your mail reader need a special charset" => "Levelezőkliens speciális karakterkészlete:",
// "Preferred language" => "Preferred language",
"Can you read more languages?" => "További nyelvek amiket értek",
"Other languages you can read (select on the left to add to the list on the right):" => "További olyan nyelvek megadása amiket tudok olvasni (bal oldalon kiválasztás, jobb oldalon a lista):",
"Select language..." => "Nyelv kiválasztása..",
"Number of visited pages to remember:" => "A nyilvántartott látogatott lapok száma:",
"Displayed time zone:" => "Megjelenített időzóna:",
"Detect user time zone if browser allows, otherwise site default" => "Felhasználói időzóna felismerése (ha a böngésző lehetővé teszi), egyébként az oldal alapértelmezettje",
// "Use 12-hour clock in time selectors" => "Use 12-hour clock in time selectors",
"Display info tooltip on mouseover for every user who allows his/her information to be public" => "Felhasználói információk megjelenítése egér felhasználói név felé mozgatásakor minden olyan felhasználónál aki publikussá teszi adatait",
"Use double-click to edit pages:" => "Oldal szerkesztése duplakattintással:",
"Notify sender when reading his mail" => "Szerző értesítése levél olvasásakor",
"Send me an email for messages with priority equal or greater than:" => "E-mail küldése azokról az üzenetekről melyek prioritása legalább::",
"Auto-archive read messages after x days" => "Olvasott üzenetek automatikus arhíválása X nap után",
"never" => "soha",
"My user items" => "Felhasználói tételeim",
"My level" => "Szintem",
"Account Information" => "Felhasználói fiók információ",
"Leave \"New password\" and \"Confirm new password\" fields blank to keep current password" => "A jelenlegi jelszó megtartásához az \"Új jelszó\" és az \"Új jelszó megerősítése\" mezőket üresen kell hagyni",
"Email address:" => "E-mail cím:",
"Confirm new password:" => "Új jelszó megerősítése:",
"Current password (required):" => "Jelenlegi jelszó (kötelező):",
"Account Deletion" => "Fiók törlése",
// "Are you really sure you want to delete the account %0" => "Are you really sure you want to delete the account %0",
"Check this box if you really want to delete the account" => "Be kell jelölni ha tényleg törölni szeretnénk a fiókot",
"Delete the account:" => "Fiók törlése:",
// "Delete my account" => "Delete my account",
"Task list" => "Feladat lista",
"Admin mode off" => "Adminisztrátor mód ki",
"Admin mode on" => "Adminisztrátor mód be",
"Task help" => "Feladat súgó",
"Empty Trash" => "Lomtár ürítése",
// "Task received" => "Task received",
// "You received this task" => "You received this task",
// "Task sent" => "Task sent",
// "You sent this task to another user" => "You sent this task to another user",
// "Task shared by a group" => "Task shared by a group",
// "Task is shared by a group" => "Task is shared by a group",
// "Accepted by task user and creator" => "Accepted by task user and creator",
// "Task has been accepted by user and creator" => "Task has been accepted by user and creator",
// "Rejected by a user" => "Rejected by a user",
// "Task has been rejected by a user" => "Task has been rejected by a user",
// "Waiting for me" => "Waiting for me",
// "Task has not yet been accepted or rejected by you" => "Task has not yet been accepted or rejected by you",
// "Waiting for other user" => "Waiting for other user",
// "Task has not yet been accepted or rejected by another user" => "Task has not yet been accepted or rejected by another user",
"Admin Mode" => "Adminisztrátor mód",
"Edit Task" => "Feladat szerkesztése",
"NOT accept" => "Visszautasítás",
"Remove from Trash" => "Eltávolítás lomtárból",
// "Move to trash" => "Move to trash",
// "Move to Trash" => "Move to Trash",
"Task saved" => "Feladat elmentve",
"View Task" => "Feladat megtekintése",
"Open a new task" => "Új feladat megnyitása",
"taskId" => "feladat azonosítója",
"Task user" => "Feladat felhasználója",
"Only the creator can delete this task" => "Csak a feladat létrehozója törölheti a feladatot",
"Use start date and time" => "Kezdési dátum és idő használata",
"Use end date and time" => "Befejezési dátum és idő használata",
"Open / In Process" => "Nyitva / Folyamatban",
"Waiting / Not Started" => "Várakozó / Nincs elkezdve",
"Percentage completed" => "Kész (százalékban)",
"Shared for Group" => "Megosztva csoport részére",
"Accepted by User" => "Felhasználó által elfogadva",
"No / Rejected" => "Nem / Elutasítva",
"Accepted by Creator" => "Létrehozó által elfogadva",
"This message will be send to users if you are makeing changes of assigned tasks" => "Ez az üzenet kerül kiküldésre a felhasználók felé ha módosítjuk a kiosztott feladatokat",
"Send message with changes" => "Üzenet küldése a változásokkal együtt",
"Modified by" => "Módosította",
"Marked as deleted" => "Megjelölve töröltként",
"Inform task user by email" => "Feladat felhasználójának tájékoztatása E-mailben",
"You can only view this task" => "Csak a feladat megtekintéséhez elegendő a jogosultság",
"Completed" => "Befejezve",
// "In the trash" => "In the trash",
"Not Accepted by One User" => "Egy felhasználó nem fogadta el",
// "Not Accepted User" => "Not Accepted User",
"No tasks entered" => "Nincs bevitt feladat",
"Select One" => "Egy kiválasztása",
"Undo Trash" => "Lomtár visszaállítása",
"Show:" => "Megjelenítés:",
"Received" => "Fogadott",
"Submitted" => "Elküldött",
"Shared" => "Megosztott",
"All Shared Tasks" => "Összes megosztott feladat",
"completed (100%)" => "kész (100%)",
"Public for group" => "Publikus csoport részére",
// "User Watches and preferences" => "User Watches and preferences",
// "You need to set your email to receive email notifications" => "You need to set your email to receive email notifications",
// "Report Preferences" => "Report Preferences",
// "You are not allowed to remove this notification " => "You are not allowed to remove this notification ",
// "Use reports to summarise notifications about objects you are watching" => "Use reports to summarise notifications about objects you are watching",
// "Use reports" => "Use reports",
// "Interval in which you want to get the reports" => "Interval in which you want to get the reports",
"Monthly" => "Havi",
// "Short report" => "Short report",
// "Detailed report" => "Detailed report",
// "HTML-Email" => "HTML-Email",
// "Send me an email also if nothing happened" => "Send me an email also if nothing happened",
"My watches" => "Figyelések",
"Use \"watches\" to monitor wiki pages or other objects." => "Használjuk a \"Figyelés\" funkciót wiki oldalak vagy más objektumok monitorozására.",
"Watch new items by clicking the {icon _id=eye} button on specific pages." => "Új figyelendő tételeket a {icon _id=eye} ikonra kattintva vehetünk fel a meghatározott oldalakon",
"Add Watch" => "Figyelés hozzáadása",
"Select event type" => "Esemény típus kiválasztása",
"All watched events" => "Összes figyelt esemény",
"A user submits a blog post" => "Felhasználó blogot küld be",
"A user posts a forum thread" => "Felhasználó fórumtémát (thread) nyit",
"A user posts a forum topic" => "Felhasználó fórumtémát (topic) nyit",
// "A user edited or commented on a wiki page" => "A user edited or commented on a wiki page",
"A user edited a wiki page" => "Felhasználó wiki oldalt szerkeszt",
// "{\$w.type}" => "{\$w.type}",
"Used space:" => "Felhasznált terület:",
"up to" => "határ",
"no limit for admin" => "adminisztrátor számára nincs határ",
"May need to refresh twice to see changes" => "Lehet, hogy kétszer is frissíteni kell az oldalt a változások láthatóvá tételéhez",
"Add top level bookmarks to menu" => "Felsőszintű könyvjelzők hozzáadása menühöz",
"Add or edit an item" => "Elem hozzáadása/szerkesztése",
"New Window" => "Új ablak",
"replace window" => "ablak lecserélése",
"Pos" => "Pozíció",
// "User_versions_for" => "User_versions_for",
// "{\$topic|escape}" => "{\$topic|escape}",
// "{\$type|escape}" => "{\$type|escape}",
// "Monitor Articles" => "Monitor Articles",
// "Stop Monitoring Articles" => "Stop Monitoring Articles",
// "Published At" => "Published At",
// "{\$listpages[ix].topicName}" => "{\$listpages[ix].topicName}",
"No articles yet." => "Nincsenek még létrehozva cikkek.",
"Add an article" => "Cikk létrehozása",
// "Banner stats" => "Banner stats",
// "Create new banner" => "Create new banner",
// "Banner Information" => "Banner Information",
// "Click ratio" => "Click ratio",
"Weekdays" => "Hétköznapok",
"mon" => "hétfő",
"tue" => "kedd",
"wed" => "szerda",
"thu" => "csütörtök",
"fri" => "péntek",
"sat" => "szombat",
"sun" => "vasárnap",
// "Banner raw data" => "Banner raw data",
"Monitor this Blog" => "Blog figyelése",
"Stop Monitoring this Blog" => "Blog figyelésének felfüggesztése",
// "Cached" => "Cached",
// "This is a cached version of the page" => "This is a cached version of the page",
// "Click here to view the Google cache of the page instead" => "Click here to view the Google cache of the page instead",
// "{\$faq_info.title}" => "{\$faq_info.title}",
// "There are no questions in this FAQ" => "There are no questions in this FAQ",
"Answers" => "Válaszok",
// "Add Suggestion" => "Add Suggestion",
"Forum List" => "Fórum lista",
"Edit Forum" => "Fórum szerkesztése",
// "Manage Message Queue" => "Manage Message Queue",
// "Manage Reported Messages" => "Manage Reported Messages",
// "Monitor Topics of this Forum" => "Monitor Topics of this Forum",
// "Stop Monitoring Topics of this Forum" => "Stop Monitoring Topics of this Forum",
// "Monitor Topics and Threads of this Forum" => "Monitor Topics and Threads of this Forum",
// "Stop Monitoring Topics and Threads of this Forum" => "Stop Monitoring Topics and Threads of this Forum",
// "Group Monitor Topics of this Forum" => "Group Monitor Topics of this Forum",
// "Group Monitor Topics and Threads of this Forum" => "Group Monitor Topics and Threads of this Forum",
"Editing:" => "Szerkesztés:",
"Post New" => "Új feladása",
// "Watch for replies" => "Watch for replies",
// "Send me an e-mail when someone replies to my topic" => "Send me an e-mail when someone replies to my topic",
// "Don't send me any e-mails" => "Don't send me any e-mails",
// "Enter your name" => "Enter your name",
"Editing posts:" => "Posztok szerkesztése",
"for links" => "formátumot linkek megadásához",
"HTML tags are not allowed inside posts" => "HTML tag-ek nem szerepelhetnek a posztokban",
"Moderator Actions" => "Moderátori akciók",
"Move Selected Topics" => "Kiválasztott témák mozgatása",
"Unlock Selected Topics" => "Kiválasztott témák feloldása",
"Lock Selected Topics" => "Kiválasztott témák zárolása",
"Delete Selected Topics" => "Kiválasztott témák törlése",
"Merge" => "Összeolvasztás",
"Merge Selected Topics" => "Kiválasztott témák egyesitése",
// "Reported Messages" => "Reported Messages",
"Queued Messages:" => "Sorbanálló hozzászólások:",
// "Merge into topic" => "Merge into topic",
// "Emot" => "Emot",
// "pts" => "pts",
// "Atts" => "Atts",
"Forum Lock" => "Fórum zárolása",
// "posts in this forum" => "posts in this forum",
"Filter Posts" => "Posztok szűrése",
"Jump to forum" => "Ugorj a fórumra",
"Posts Filtering" => "Posztok szűrése",
"Last post date" => "Legutóbbi poszt dátuma",
"All posts" => "Minden üzenet",
"Last hour" => "Utóbbi óra",
"Last 24 hours" => "Utóbbi 24 óra",
"Last 48 hours" => "Utóbbi 48 óra",
// "Show archived posts" => "Show archived posts",
"Containing posts by" => "Posztoló",
// "Me" => "Me",
"normal" => "normál",
"announce" => "kihirdetés",
"hot" => "forró",
"Posts with no replies" => "Válasz nélküli posztok",
// "Archived" => "Archived",
"Topic List" => "Téma lista",
// "The post has been reported and will be reviewed by a moderator" => "The post has been reported and will be reviewed by a moderator",
"prev topic" => "előző téma",
"next topic" => "következő téma",
// "You are viewing a reply to" => "You are viewing a reply to",
"Print this page only" => "Csak ezen oldal nyomtatása",
"Print all pages" => "Összes oldal nyomtatása",
"Show posts" => "Bejegyzések megjelenítése",
// "View Invoice" => "View Invoice",
// "Invoice %0" => "Invoice %0",
// "Date Issued %0" => "Date Issued %0",
// "Amount: %0" => "Amount: %0",
// "Total: %0" => "Total: %0",
// "Payment Terms: %0" => "Payment Terms: %0",
// "Back to Page" => "Back to Page",
// "Already being edited by" => "Already being edited by",
"Tiki Sheet" => "Tiki ív",
// "Save current spreadsheet" => "Save current spreadsheet",
// "Cancel editing current spreadsheet" => "Cancel editing current spreadsheet",
"No parse" => "Nincs wiki elemzés",
// "What would you like to add" => "What would you like to add",
// "New spreadsheet" => "New spreadsheet",
// "Existing spreadsheet" => "Existing spreadsheet",
// "Tracker as a spreadsheet" => "Tracker as a spreadsheet",
// "Spreadsheet from file gallery" => "Spreadsheet from file gallery",
// "Cell" => "Cell",
// "Set Reference" => "Set Reference",
// "Un-Merge" => "Un-Merge",
// "Adds an additional row to bottom of the spreadsheet" => "Adds an additional row to bottom of the spreadsheet",
// "Add Row" => "Add Row",
// "Adds an additional rows to bottom of the spreadsheet" => "Adds an additional rows to bottom of the spreadsheet",
// "Add Multi-Rows" => "Add Multi-Rows",
// "Delets the current row thats highlighted" => "Delets the current row thats highlighted",
// "Delete Row" => "Delete Row",
// "Inserts an additional row after currently selected row" => "Inserts an additional row after currently selected row",
// "Insert Row Before" => "Insert Row Before",
// "Insert Row After" => "Insert Row After",
// "Unhides all the hidden rows" => "Unhides all the hidden rows",
"Show All" => "Összes megjelenítése",
// "Hides or shows the currently selected row" => "Hides or shows the currently selected row",
// "Toggle Hide Row" => "Toggle Hide Row",
// "Adds an additional column to the right of the spreadsheet" => "Adds an additional column to the right of the spreadsheet",
// "Add Column" => "Add Column",
// "Adds an additional columns to the right of the spreadsheet" => "Adds an additional columns to the right of the spreadsheet",
// "Add Multi-Columns" => "Add Multi-Columns",
// "Deletes the current column thats highlighted" => "Deletes the current column thats highlighted",
// "Delete Column" => "Delete Column",
// "Inserts an additional column after currently selected column" => "Inserts an additional column after currently selected column",
// "Insert Column Before" => "Insert Column Before",
// "Insert Column After" => "Insert Column After",
// "Fill down current cell value" => "Fill down current cell value",
// "Fill Down" => "Fill Down",
// "Fill up current cell value" => "Fill up current cell value",
// "Fill Up" => "Fill Up",
// "Unhides all the hidden columns" => "Unhides all the hidden columns",
// "Hides or shows the currently selected column" => "Hides or shows the currently selected column",
// "Toggle Hide Column" => "Toggle Hide Column",
// "Add new spreadsheet" => "Add new spreadsheet",
// "Add Spreadsheet" => "Add Spreadsheet",
// "Delete the current spreadsheet" => "Delete the current spreadsheet",
// "Delete Spreadsheet" => "Delete Spreadsheet",
// "Recompiles the current sheet" => "Recompiles the current sheet",
// "Change the title of the sheet" => "Change the title of the sheet",
// "Wrap Cell Range" => "Wrap Cell Range",
// "Wrap with SUM" => "Wrap with SUM",
// "Wrap with CEILING" => "Wrap with CEILING",
// "Wrap with COUNT" => "Wrap with COUNT",
// "Wrap with MAX" => "Wrap with MAX",
// "Wrap with MIN" => "Wrap with MIN",
// "Redo" => "Redo",
// "Toggle State" => "Toggle State",
// "Function Reference" => "Function Reference",
// "Usage Example: =SUM(SUM(A1:B1) + SUM(D7))" => "Usage Example: =SUM(SUM(A1:B1) + SUM(D7))",
// "=(TRUE(N(A1)) || FALSE(N(B1)))" => "=(TRUE(N(A1)) || FALSE(N(B1)))",
// "Returns the absolute value of a number" => "Returns the absolute value of a number",
// "Returns a rounded number" => "Returns a rounded number",
// "Returns a number rounded up based on a multiple of significance" => "Returns a number rounded up based on a multiple of significance",
// "Counts the number of cells that contain a value" => "Counts the number of cells that contain a value",
// "Counts full days from a specific date - format(YYYY,MM,DD)" => "Counts full days from a specific date - format(YYYY,MM,DD)",
// "Converts a number to text, using a currency format - options(number, decimals, symbol)" => "Converts a number to text, using a currency format - options(number, decimals, symbol)",
// "Returns a logical value of FALSE" => "Returns a logical value of FALSE",
// "Returns a text representation of a number rounded to a specified number of decimal places - options(number, decimals, useCommas)" => "Returns a text representation of a number rounded to a specified number of decimal places - options(number, decimals, useCommas)",
// "Returns a number rounded down based on a multiple of significance" => "Returns a number rounded down based on a multiple of significance",
// "Returns the integer portion of a number" => "Returns the integer portion of a number",
// "Returns the largest value from the numbers provided" => "Returns the largest value from the numbers provided",
// "Returns the smallest value from the numbers provided" => "Returns the smallest value from the numbers provided",
// "Converts a value to a number" => "Converts a value to a number",
// "Gets full date of today" => "Gets full date of today",
// "Returns the mathematical constant called pi, which is 3.14159265358979" => "Returns the mathematical constant called pi, which is 3.14159265358979",
// "Returns the result of a number raised to a given power" => "Returns the result of a number raised to a given power",
// "Returns a random number that is greater than or equal to 0 and less than 1" => "Returns a random number that is greater than or equal to 0 and less than 1",
// "Returns a number rounded to a specified number of digits" => "Returns a number rounded to a specified number of digits",
// "Returns all of the values in each of the specified cells and added together" => "Returns all of the values in each of the specified cells and added together",
// "Returns a logical value of TRUE" => "Returns a logical value of TRUE",
// "Converts a text value that represents a number to a number" => "Converts a text value that represents a number to a number",
// "Italics" => "Italics",
// "Uppercase" => "Uppercase",
// "Capitalize" => "Capitalize",
// "Lowercase" => "Lowercase",
// "Font Size +" => "Font Size +",
// "Font Size -" => "Font Size -",
"Items found:" => "Talált tételek:",
"lastModif" => "Legutóbbi módosítás",
"atts" => "mellékletek",
"List Attachments" => "Mellékletek listázása",
// "View/Edit" => "View/Edit",
"Insert New Item" => "Új tétel hozzáadása",
"View inserted item" => "Hozzáadott tétel megtekintése",
// "Insert new item" => "Insert new item",
// "Synchronization" => "Synchronization",
// "This tracker is a remote copy of <a href=\"%0\">%0</a>" => "This tracker is a remote copy of <a href=\"%0\">%0</a>",
// "It was last updated on %0" => "It was last updated on %0",
// "Reload field definitions" => "Reload field definitions",
// "Items added locally" => "Items added locally",
// "Push new items" => "Push new items",
// "Safe modifications (no remote conflict)" => "Safe modifications (no remote conflict)",
// "Dangerous modifications (remote conflict)" => "Dangerous modifications (remote conflict)",
// "On push, local items will be removed until data reload" => "On push, local items will be removed until data reload",
// "Push local changes" => "Push local changes",
// "Local changes will be lost" => "Local changes will be lost",
// "When reloading the data from the source, all local changes will be lost" => "When reloading the data from the source, all local changes will be lost",
// "New items that must be preserved should be pushed using the above controls" => "New items that must be preserved should be pushed using the above controls",
// "Modifications that must be preserved should be replicated" => "Modifications that must be preserved should be replicated",
// "Without conflicts: Using the above controls" => "Without conflicts: Using the above controls",
// "With conflicts: Manually on the source" => "With conflicts: Manually on the source",
// "Using the above controls will cause information loss" => "Using the above controls will cause information loss",
// "Reload data from source" => "Reload data from source",
"Local" => "Helyi",
// "Remote" => "Remote",
"View Item" => "Tétel megtekintése",
// "Translations" => "Translations",
// "Move to another tracker" => "Move to another tracker",
// "Back to Items list" => "Back to Items list",
// "Back to Items List" => "Back to Items List",
// "Special Operations" => "Special Operations",
"close" => "bezárás",
// "Open Tiki WebDAV (Wiki pages) as WebFolder" => "Open Tiki WebDAV (Wiki pages) as WebFolder",
// "Open Tiki WebDAV as WebFolder" => "Open Tiki WebDAV as WebFolder",
// "Personal e-mail accounts" => "Personal e-mail accounts",
// "This is the active account" => "This is the active account",
// "IMAP" => "IMAP",
// "Mbox" => "Mbox",
// "Maildir" => "Maildir",
// "POP3" => "POP3",
// "Group e-mail accounts" => "Group e-mail accounts",
// "Incoming servers (used in this order)" => "Incoming servers (used in this order)",
// "IMAP server" => "IMAP server",
// "Mbox filepath" => "Mbox filepath",
// "Maildir mail directory" => "Maildir mail directory",
// "Use SSL" => "Use SSL",
// "Outgoing server" => "Outgoing server",
// "From email" => "From email",
// "Uses current in preferences if empty" => "Uses current in preferences if empty",
// "No email set" => "No email set",
// "Account details" => "Account details",
// "Group (shared mail inbox) or private" => "Group (shared mail inbox) or private",
// "This will be a group mail account" => "This will be a group mail account",
// "This will be a personal mail account" => "This will be a personal mail account",
// "Auto-refresh page time" => "Auto-refresh page time",
// "seconds (0 = no auto refresh)" => "seconds (0 = no auto refresh)",
// "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission" => "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission",
// "Show Unread" => "Show Unread",
// "Show Flagged" => "Show Flagged",
// "Auto refresh set for every \$autoRefresh seconds" => "Auto refresh set for every \$autoRefresh seconds",
"Refresh now" => "Frissítés most",
// "Group messages" => "Group messages",
// "unFlagged" => "unFlagged",
// "Clip" => "Clip",
// "Back To Mailbox" => "Back To Mailbox",
// "Full Headers" => "Full Headers",
// "Normal Headers" => "Normal Headers",
// "Reply To All" => "Reply To All",
// "Forward" => "Forward",
// "Part" => "Part",
// "Select from address book" => "Select from address book",
// "Use HTML mail" => "Use HTML mail",
// "The following addresses are not in your address book" => "The following addresses are not in your address book",
// "Add Contacts" => "Add Contacts",
// "Attachment 1" => "Attachment 1",
// "Attachment 2" => "Attachment 2",
// "Attachment 3" => "Attachment 3",
// "Address book" => "Address book",
"TOC" => "TOC",
"Parent page" => "Felettes oldal",
"Child" => "Alárendelt oldal",
// "page id" => "page id",
"View edit icons" => "Szerkesztési ikonok megtekintése",
"3d browser" => "3D böngésző",
"Page is NOT being monitored. Click icon to START monitoring." => "Oldal figyelése kikapcsolva, indításhoz katt az ikonra",
"Page IS being monitored. Click icon to STOP monitoring." => "Figyelés bekapcsolva, leállításhoz katt az ikonra",
// "Group Monitor on Structure" => "Group Monitor on Structure",
// "Hide structure bar" => "Hide structure bar",
// "Hide structure" => "Hide structure",
// "More types available" => "More types available",
// "More field types may be enabled from the <a href=\"%0\">administration panel</a>" => "More field types may be enabled from the <a href=\"%0\">administration panel</a>",
// "Contact your administrator to see if they can be enabled. The complete field type list is available in the <a rel=\"external\" class=\"external\" href=\"%0\">documentation</a>" => "Contact your administrator to see if they can be enabled. The complete field type list is available in the <a rel=\"external\" class=\"external\" href=\"%0\">documentation</a>",
// "Description contains wiki syntax" => "Description contains wiki syntax",
// "Restrict visibility to administrators" => "Restrict visibility to administrators",
// "Useful if you are working on a live tracker" => "Useful if you are working on a live tracker",
// "Add Field &amp; Edit Advanced Options" => "Add Field &amp; Edit Advanced Options",
// "New tracker created" => "New tracker created",
// "Return to Trackers" => "Return to Trackers",
// "Options for %0" => "Options for %0",
// "Separate multiple with commas" => "Separate multiple with commas",
"Error Message" => "Hibaüzenet",
// "Visible by all" => "Visible by all",
// "Visible by administrators only" => "Visible by administrators only",
// "Editable by administrators only" => "Editable by administrators only",
// "Editable by administrators and creator only" => "Editable by administrators and creator only",
// "Creator requires a user field with auto-assign to creator (1)" => "Creator requires a user field with auto-assign to creator (1)",
// "Visible by" => "Visible by",
// "Editable by" => "Editable by",
// "Changing the permanent name may have consequences in integrated systems" => "Changing the permanent name may have consequences in integrated systems",
// "Quick Export" => "Quick Export",
// "Produce a CSV with basic formatting" => "Produce a CSV with basic formatting",
"Export Tracker Items" => "Űrlaptételek exportálása",
// "ISO-8859-1 Latin" => "ISO-8859-1 Latin",
// "Delimitor (left)" => "Delimitor (left)",
// "Delimitor (right)" => "Delimitor (right)",
// "Carriage return inside field value" => "Carriage return inside field value",
// "Export dates as UNIX Timestamps to facilitate importing" => "Export dates as UNIX Timestamps to facilitate importing",
// "Export ItemLink type fields as the itemId of the linked item (to facilitate importing)" => "Export ItemLink type fields as the itemId of the linked item (to facilitate importing)",
// "Export country type fields as the system name of the country (to facilitate importing)" => "Export country type fields as the system name of the country (to facilitate importing)",
// "Parse as wiki text" => "Parse as wiki text",
// "Generic information" => "Generic information",
// "Number of records" => "Number of records",
// "First record" => "First record",
// "Tracker Export" => "Tracker Export",
// "Profile Export" => "Profile Export",
// "Produce YAML for a profile" => "Produce YAML for a profile",
// "Linked tracker and field IDs (such as those referenced in ItemLink, ItemsList field options, for instance) are not currently converted to profile object references, so will need manual replacement" => "Linked tracker and field IDs (such as those referenced in ItemLink, ItemsList field options, for instance) are not currently converted to profile object references, so will need manual replacement",
// "For example: \$profileobject:field_ref\$" => "For example: \$profileobject:field_ref\$",
// "Export Profile" => "Export Profile",
// "YAML Export" => "YAML Export",
// "Profile for trackerId %0" => "Profile for trackerId %0",
// "Import fields for this tracker" => "Import fields for this tracker",
// "Imported file '%0'" => "Imported file '%0'",
// "Import completed with '%0'" => "Import completed with '%0'",
// "The order of the fields does not matter, but you need to add a header with the field names" => "The order of the fields does not matter, but you need to add a header with the field names",
// "Add \" -- \" to the end of the fields in the header that you would like to import" => "Add \" -- \" to the end of the fields in the header that you would like to import",
// "Auto-incremented itemid fields shall be included with no matter what values" => "Auto-incremented itemid fields shall be included with no matter what values",
// "UNIX Timestamp" => "UNIX Timestamp",
// "Character encoding" => "Character encoding",
// "Create as new items" => "Create as new items",
// "Update lastModif date if updating items (status and created are updated only if the fields are specified in the csv)" => "Update lastModif date if updating items (status and created are updated only if the fields are specified in the csv)",
// "Convert values of ItemLink type fields from the value in the CSV file to the itemId of the linked item. Requires the linked item to be correctly set up in advance" => "Convert values of ItemLink type fields from the value in the CSV file to the itemId of the linked item. Requires the linked item to be correctly set up in advance",
// "Do you really want to remove the %0 tracker" => "Do you really want to remove the %0 tracker",
// "Back to tracker list" => "Back to tracker list",
// "Are you sure you want to remove the fields? Data will be lost" => "Are you sure you want to remove the fields? Data will be lost",
// "Remove Fields" => "Remove Fields",
// "Return to field administration" => "Return to field administration",
// "Are you sure you want to delete this item" => "Are you sure you want to delete this item",
// "Delete item" => "Delete item",
// "Description is wiki-parsed" => "Description is wiki-parsed",
// "Allow ratings (deprecated, use rating field)" => "Allow ratings (deprecated, use rating field)",
// "Rating options" => "Rating options",
// "Show ratings in listing" => "Show ratings in listing",
// "Show comments in listing" => "Show comments in listing",
// "Display last comment author and date" => "Display last comment author and date",
// "Display attachments in listing" => "Display attachments in listing",
// "Attachment attributes (sortable)" => "Attachment attributes (sortable)",
// "Show status to tracker administrator only" => "Show status to tracker administrator only",
// "Show creation date when listing items" => "Show creation date when listing items",
// "Creation date format" => "Creation date format",
// "Show item creator" => "Show item creator",
// "Show creation date when viewing items" => "Show creation date when viewing items",
// "Show last modification date when listing items" => "Show last modification date when listing items",
// "Show item last modifier" => "Show item last modifier",
// "Modification date format" => "Modification date format",
// "Show last modification date when viewing items" => "Show last modification date when viewing items",
// "Default sort direction" => "Default sort direction",
// "Hide empty fields from item view" => "Hide empty fields from item view",
// "List detail pop-up" => "List detail pop-up",
// "Comma-separated list of field IDs" => "Comma-separated list of field IDs",
// "Template to display an item" => "Template to display an item",
// "wiki:pageName for a wiki page or tpl:tplName for a template" => "wiki:pageName for a wiki page or tpl:tplName for a template",
// "Template to edit an item" => "Template to edit an item",
// "New item status" => "New item status",
// "Modified item status" => "Modified item status",
"No change" => "Nincs változás",
"Default status displayed in list mode" => "Alapértelmezett státusz megjelenítése listázási nézetben",
// "Notifications" => "Notifications",
// "Copy activity to email" => "Copy activity to email",
"Use simplified e-mail format" => "Egyszerűsített E-mail formátum használata",
"The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender" => "Az űrlap a Tárgy mező tartalmát fogja használni a tárgy megadásához, valamint a felhasználó E-mail címét vagy anonim küldő esetén az E-mail mező tartalmát a küldő megadásához",
// "Publish RSS feed for this tracker" => "Publish RSS feed for this tracker",
// "Requires \"RSS per tracker\" to be set in Admin/RSS" => "Requires \"RSS per tracker\" to be set in Admin/RSS",
// "(Currently set)" => "(Currently set)",
// "(Currently not set)" => "(Currently not set)",
// "Group alerted on item modification" => "Group alerted on item modification",
// "Allow user selection for small groups" => "Allow user selection for small groups",
// "Item creator can modify his items" => "Item creator can modify his items",
// "The tracker needs a user field with the auto-assign activated" => "The tracker needs a user field with the auto-assign activated",
// "Item creator can remove his items" => "Item creator can remove his items",
// "User can take ownership of item created by anonymous" => "User can take ownership of item created by anonymous",
"Only one item per user or IP" => "Felhasználónként vagy IP-nként egy tétel lehetséges",
// "The tracker needs a user or IP address field with the auto-assign activated" => "The tracker needs a user or IP address field with the auto-assign activated",
// "Members of the creator group can modify items" => "Members of the creator group can modify items",
// "The tracker needs a group field with the auto-assign activated" => "The tracker needs a group field with the auto-assign activated",
// "Members of the creator group can remove items" => "Members of the creator group can remove items",
// "Creation date constraint" => "Creation date constraint",
// "Auto-create corresponding categories" => "Auto-create corresponding categories",
// "Create a group for each item" => "Create a group for each item",
// "Groups will include" => "Groups will include",
// "Creator is assigned to the group" => "Creator is assigned to the group",
// "Will become the creator's default group" => "Will become the creator's default group",
// "Will become the new item's group creator" => "Will become the new item's group creator",
// "Copy the default group in the field ID before updating the group" => "Copy the default group in the field ID before updating the group",
// "{\$sc.label|escape}" => "{\$sc.label|escape}",
// "Admin Fields" => "Admin Fields",
// "It is very likely that authentication will be required to access this data on the remote site. Configure the authentication source from Admin DSN" => "It is very likely that authentication will be required to access this data on the remote site. Configure the authentication source from Admin DSN",
// "Notification" => "Notification",
// "Do you really want to remove the scheduled event" => "Do you really want to remove the scheduled event",
// "No events registered" => "No events registered",
// "Reference date" => "Reference date",
// "After creation" => "After creation",
// "After last modification" => "After last modification",
// "Delay prior to status change" => "Delay prior to status change",
// "Mail subject text" => "Mail subject text",
// "Mail body ressource" => "Mail body ressource",
// "wiki:pageName for a wiki page or tplName.tpl for a template" => "wiki:pageName for a wiki page or tplName.tpl for a template",
// "(automatically generated after item creation)" => "(automatically generated after item creation)",
// "Hold \"Ctrl\" in order to select multiple values" => "Hold \"Ctrl\" in order to select multiple values",
"Other:" => "Egyéb:",
// "Upload files" => "Upload files",
// "Attached files limitation" => "Attached files limitation",
// "The amount of files that can be attached is limited to <strong>%0</strong>. Additional files uploaded will still be uploaded to the server and searchable, but they will not be attached to this item. Make sure you remove the files no longer required before you save your changes" => "The amount of files that can be attached is limited to <strong>%0</strong>. Additional files uploaded will still be uploaded to the server and searchable, but they will not be attached to this item. Make sure you remove the files no longer required before you save your changes",
// "Drop files from your desktop here or browse for them" => "Drop files from your desktop here or browse for them",
// "Existing files" => "Existing files",
// "Search query" => "Search query",
// "Select Icon" => "Select Icon",
// "Remove Image" => "Remove Image",
// "Are you sure you want to delete this image" => "Are you sure you want to delete this image",
// "Character Count" => "Character Count",
// "Administrator intervention required" => "Administrator intervention required",
// "Freetags is not enabled" => "Freetags is not enabled",
// "You did not vote yet" => "You did not vote yet",
// "My rating" => "My rating",
// "{\$field.labels[i]}" => "{\$field.labels[i]}",
// "Click to vote for this value" => "Click to vote for this value",
// "Click to delete your vote" => "Click to delete your vote",
// "Language: %0" => "Language: %0",
// "You have ever subscribed" => "You have ever subscribed",
// "You have not yet subscribed" => "You have not yet subscribed",
// "with" => "with",
// "friends" => "friends",
// "Current language" => "Current language",
// "Show all translations of this page on a single page" => "Show all translations of this page on a single page",
// "All languages" => "All languages",
// "Google translate" => "Google translate",
// "Machine translations" => "Machine translations",
// "Translate page" => "Translate page",
// "Manage page translations" => "Manage page translations",
// "Translate article" => "Translate article",
// "Manage article translations" => "Manage article translations",
// "Maintenance" => "Maintenance",
// "Are you sure you want to detach these translations" => "Are you sure you want to detach these translations",
// "Current translation set" => "Current translation set",
// "Are you sure you want to detach the translation" => "Are you sure you want to detach the translation",
// "No translations available at this time" => "No translations available at this time",
// "Add a new object to the set" => "Add a new object to the set",
// "All possible translations exist" => "All possible translations exist",
// "Objects that contain the more terms are rated higher in the results and will appear first" => "Objects that contain the more terms are rated higher in the results and will appear first",
// "objects that include both tokenized terms" => "objects that include both tokenized terms",
// "Boolean operators" => "Boolean operators",
// "You can use AND or OR or NOT also to do a boolean search" => "You can use AND or OR or NOT also to do a boolean search",
// "Example: <strong>wiki and forum</strong> will find objects with both terms" => "Example: <strong>wiki and forum</strong> will find objects with both terms",
// "Example: <strong>wiki or forum</strong> will find objects with one of the term" => "Example: <strong>wiki or forum</strong> will find objects with one of the term",
// "Example: <strong>wiki and (forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order" => "Example: <strong>wiki and (forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order",
// "Use double quotes ( \" \" ) around a phrase to find terms in the exact order, next to each other" => "Use double quotes ( \" \" ) around a phrase to find terms in the exact order, next to each other",
// "Example: <strong>\"Alex Bell\"</strong> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong> but <strong>Alex Bells</strong>. " => "Example: <strong>\"Alex Bell\"</strong> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong> but <strong>Alex Bells</strong>. ",
// "However, no account is associated to the OpenID identifier" => "However, no account is associated to the OpenID identifier",
// "If you use an email filter, be sure to add %0 to your accepted list" => "If you use an email filter, be sure to add %0 to your accepted list",
// "Associate OpenID with an existing Tiki account" => "Associate OpenID with an existing Tiki account",
// "Use this thread to discuss the page" => "Use this thread to discuss the page",
// "Missing or incorrect trackerId parameter for the plugin" => "Missing or incorrect trackerId parameter for the plugin",
"List Trackers" => "Űrlap lista",
// "Add Tag" => "Add Tag",
// "Subtract" => "Subtract",
// "Meeting ID" => "Meeting ID",
// "Current attendees" => "Current attendees",
// "No attendees at this time" => "No attendees at this time",
// "Last time we checked, the room you requested did not exist" => "Last time we checked, the room you requested did not exist",
// "Current recordings" => "Current recordings",
// "On %0 from %1 to %2" => "On %0 from %1 to %2",
// "{\$button_label}" => "{\$button_label}",
// "list" => "list",
// "{\$ftptitle}" => "{\$ftptitle}",
// "Lon." => "Lon.",
// "Lat." => "Lat.",
// "Zoom" => "Zoom",
// "saving.." => "saving..",
// "Save current map view as user default" => "Save current map view as user default",
// "Save as user location" => "Save as user location",
// "Save as object location" => "Save as object location",
// "Number of Users" => "Number of Users",
// "Percentage of Total" => "Percentage of Total",
// "Email address the person you want to invite" => "Email address the person you want to invite",
// "Set in these groups" => "Set in these groups",
"Message sent to" => "Az üzeneted elküldve. Címzettje:",
// "Email sent to" => "Email sent to",
// "Emails number" => "Emails number",
// "Send Mail" => "Send Mail",
// "Send to users" => "Send to users",
// "Send to" => "Send to",
// "Email separated by comma" => "Email separated by comma",
// "Send to groups" => "Send to groups",
// "Preview Mail" => "Preview Mail",
// "Check to remove" => "Check to remove",
// "Add in group" => "Add in group",
// "Set as default group for users" => "Set as default group for users",
// "Join myself" => "Join myself",
// "Leave myself" => "Leave myself",
// "%0 year" => "%0 year",
// "%0 years" => "%0 years",
// "%0 days" => "%0 days",
// "Membership term commences on %0-%1 each year" => "Membership term commences on %0-%1 each year",
// "Membership commences on %0 day of each month" => "Membership commences on %0 day of each month",
// "Cost for one period" => "Cost for one period",
// "Free for the rest of the current period, a prorated value of" => "Free for the rest of the current period, a prorated value of",
// "Prorated cost for first period" => "Prorated cost for first period",
// "Special offer! Free additional periods" => "Special offer! Free additional periods",
// "Membership to %0 for %1 year at %2 %3" => "Membership to %0 for %1 year at %2 %3",
// "Membership to %0 for %1 years at %2 %3" => "Membership to %0 for %1 years at %2 %3",
// "Membership to %0 for %1 days at %2 %3" => "Membership to %0 for %1 days at %2 %3",
// "separated by |" => "separated by |",
// "{\$periodslabel}" => "{\$periodslabel}",
// "Re-Apply" => "Re-Apply",
// "Undecided" => "Undecided",
// "No relations found" => "No relations found",
// "{\$snarfParams.ajax|escape:html}" => "{\$snarfParams.ajax|escape:html}",
// "Last Day" => "Last Day",
// "Last Week" => "Last Week",
// "{\$action}" => "{\$action}",
// "Groups you are in" => "Groups you are in",
// "(This is an included group)" => "(This is an included group)",
// "(You are a leader)" => "(You are a leader)",
// "Your default group" => "Your default group",
// "Leave Group" => "Leave Group",
// "Manage Group" => "Manage Group",
// "Change default group" => "Change default group",
// "Subscribe to a group" => "Subscribe to a group",
// "Groups you can join" => "Groups you can join",
// "This group requires approval to join" => "This group requires approval to join",
// "Subscribe to groups" => "Subscribe to groups",
// "Subscribe to the newsletter" => "Subscribe to the newsletter",
// "Mini TimeSheet" => "Mini TimeSheet",
// "Full View" => "Full View",
"Before:" => "Befejezés:",
"After:" => "Kezdés:",
// "{\$export_action}" => "{\$export_action}",
// "Tracker - " => "Tracker - ",
// "{\$checkbox.title}" => "{\$checkbox.title}",
// "Export Tracker" => "Export Tracker",
// "Close item" => "Close item",
// "Open item" => "Open item",
// "Pend item" => "Pend item",
// "{\$params.label}" => "{\$params.label}",
// "Please login first" => "Please login first",
// "Toggle display" => "Toggle display",
"Page last modified on %0 by %1" => "Oldal legutóbbi módosítása: %0 %1 által",
"Created by %0" => "Létrehozta %0",
"Last Modification: %0 by %1" => "Legutóbbi módosítás: %0 %1 által",
"List authors:" => "Szerzők listázása:",
// "Creator &amp; Last Editor" => "Creator &amp; Last Editor",
"as Creator &amp; Last Editor" => "Létrehozó &amp; Legutóbbi szerkesztő",
"no (disabled)" => "nincs (kikapcsolva)",
// "Missing book id" => "Missing book id",
// "You do not have the right view this page" => "You do not have the right view this page",
// "Missing account id" => "Missing account id",
// "You do not have the rights to view this account" => "You do not have the rights to view this account",
// "You do not have the rights to manage accounts" => "You do not have the rights to manage accounts",
// "You do not have permissions to create a book" => "You do not have permissions to create a book",
// "You do not have permissions to close this book" => "You do not have permissions to close this book",
// "Missing journal id" => "Missing journal id",
// "You do not have the right to cancel transactions" => "You do not have the right to cancel transactions",
// "Error retrieving data from journal" => "Error retrieving data from journal",
// "You do not have the right to book" => "You do not have the right to book",
// "Don't know what to export" => "Don't know what to export",
// "You do not have the right export/view this data" => "You do not have the right export/view this data",
// "You do not have the right to book into the stack" => "You do not have the right to book into the stack",
// "Tiki Calendar" => "Tiki Calendar",
// "%0 enabled" => "%0 enabled",
// "%0 disabled" => "%0 disabled",
// "%0 set" => "%0 set",
// "%0 unset" => "%0 unset",
"Administration" => "Adminisztráció",
// "Help on Configuration Sections" => "Help on Configuration Sections",
// "%0 reset" => "%0 reset",
// "Bad request - potential cross-site request forgery (CSRF) detected. Operation blocked" => "Bad request - potential cross-site request forgery (CSRF) detected. Operation blocked",
// "Global site configuration, date formats, admin password etc" => "Global site configuration, date formats, admin password etc",
// "Switches for major features" => "Switches for major features",
// "User registration, remember me cookie settings and authentication methods" => "User registration, remember me cookie settings and authentication methods",
// "User specific features and settings" => "User specific features and settings",
// "Repository configuration, browse and apply profiles" => "Repository configuration, browse and apply profiles",
"Look & Feel" => "Stílus",
// "Theme selection, layout settings and UI effect controls" => "Theme selection, layout settings and UI effect controls",
"Editing and Plugins" => "Szerkesztés és Plugin-ek",
// "Text editing settings applicable to many areas. Plugin activation and plugin alias management" => "Text editing settings applicable to many areas. Plugin activation and plugin alias management",
// "Module appearance settings" => "Module appearance settings",
"Meta Tags" => "Meta címkék",
// "Information to include in the header of each page" => "Information to include in the header of each page",
// "i18n" => "i18n",
// "Internationalization and localization - mulitlingual features" => "Internationalization and localization - mulitlingual features",
// "Settings and features for maps" => "Settings and features for maps",
// "Server performance settings" => "Server performance settings",
// "Site security settings" => "Site security settings",
// "Comments settings" => "Comments settings",
// "Outgoing RSS feed setup" => "Outgoing RSS feed setup",
"Connect" => "Kapcsolódás",
// "Tiki Connect - join in" => "Tiki Connect - join in",
// "Search configuration" => "Search configuration",
// "Wiki page settings and features" => "Wiki page settings and features",
// "Defaults and configuration for file galleries" => "Defaults and configuration for file galleries",
// "Settings for blogs" => "Settings for blogs",
// "Defaults and configuration for image galleries (will be phased out in favour of file galleries)" => "Defaults and configuration for image galleries (will be phased out in favour of file galleries)",
// "Settings and features for articles" => "Settings and features for articles",
// "Settings and features for forums" => "Settings and features for forums",
// "Settings and features for trackers" => "Settings and features for trackers",
// "Settings and features for polls" => "Settings and features for polls",
// "Settings and features for calendars" => "Settings and features for calendars",
// "Settings and features for categories" => "Settings and features for categories",
// "Configure areas feature" => "Configure areas feature",
// "Values of actions for users rank score" => "Values of actions for users rank score",
// "Settings and features for freetags" => "Settings and features for freetags",
// "Settings and features for FAQs" => "Settings and features for FAQs",
// "Settings and features for directory of links" => "Settings and features for directory of links",
// "Defaults and API key for Google Maps" => "Defaults and API key for Google Maps",
// "Site-wide copyright information" => "Site-wide copyright information",
// "Message settings" => "Message settings",
"User files" => "Felhasználói fájlok",
// "User files settings" => "User files settings",
// "Webmail settings" => "Webmail settings",
// "Wysiwyg" => "Wysiwyg",
// "Options for WYSIWYG editor" => "Options for WYSIWYG editor",
// "Banners are a common way to display advertisements and notices on a Web page" => "Banners are a common way to display advertisements and notices on a Web page",
// "InterTiki" => "InterTiki",
// "Set up links between Tiki servers" => "Set up links between Tiki servers",
// "Manage semantic wiki links" => "Manage semantic wiki links",
"Webservices" => "Webes szolgáltatások",
// "Register and manage web services" => "Register and manage web services",
"Search engine friendly url" => "Keresőmotor-barát URL",
// "Video streaming integration" => "Video streaming integration",
// "Video integration configuration" => "Video integration configuration",
// "Configure social networks integration" => "Configure social networks integration",
// "Configure share feature" => "Configure share feature",
// "Current version is up to date : <b>%0</b>" => "Current version is up to date : <b>%0</b>",
// "A new %0 major release branch is available" => "A new %0 major release branch is available",
// "Help on %0 Config" => "Help on %0 Config",
// "Must specify actionId" => "Must specify actionId",
// "Users Contributions: Addition" => "Users Contributions: Addition",
// "%s Contributions: Addition" => "%s Contributions: Addition",
// "Users Contributions: Suppression" => "Users Contributions: Suppression",
// "%s Contributions: Suppression" => "%s Contributions: Suppression",
// "Total Contributions Addition per Day" => "Total Contributions Addition per Day",
// "Total Contributions Addition per Week" => "Total Contributions Addition per Week",
// "Total Contributions Suppression per Day" => "Total Contributions Suppression per Day",
// "Total Contributions Suppression per Week" => "Total Contributions Suppression per Week",
// "Total Contributions: Addition" => "Total Contributions: Addition",
// "Total Contributions: Suppression" => "Total Contributions: Suppression",
// "Groups Contributions: Addition" => "Groups Contributions: Addition",
// "Groups Contributions: Suppression" => "Groups Contributions: Suppression",
// "white" => "white",
// "gray" => "gray",
"silver" => "ezüst",
// "ivory" => "ivory",
// "whitesmoke" => "whitesmoke",
// "beige" => "beige",
// "darkgrey" => "darkgrey",
// "Multiple IP Banning" => "Multiple IP Banning",
// "Access from your localization was forbidden due to excessive spamming" => "Access from your localization was forbidden due to excessive spamming",
// "Delete comments then set banning rules" => "Delete comments then set banning rules",
// "Are you sure you want to unassign the objects of this category: " => "Are you sure you want to unassign the objects of this category: ",
"Click here to delete the category:" => "Kategória törlésének megerősítése:",
// "The file does not have the required header" => "The file does not have the required header",
"Edit permissions for this category" => "Kategóriához tartozó jogosultságok szerkesztése",
// "Category can`t be parent of itself" => "Category can`t be parent of itself",
// "Content Templates" => "Content Templates",
"Upload failed" => "Sikertelen feltöltés",
// "Admin credits" => "Admin credits",
"All posted" => "Minden elküldött",
"Queue anonymous posts" => "Névtelen hozzászólások sorbaállítása",
"Queue all posts" => "Összes hozzászólás sorbaállítása",
"No attachments" => "Nincsenek mellékletek",
"Everybody can attach" => "Bárki csatolhat",
"Only users with attach permission" => "Csak csatolási jogosultsággal rendelkezők csatolhatnak",
"Moderators and admin can attach" => "Moderátorok és adminisztrátorok csatolhatnak",
"No display" => "Nincs megjelenítés",
"Date (desc)" => "Dátum (csökk)",
"Date (asc)" => "Dátum (növ)",
"Score (desc)" => "Pontszám (csökk)",
"Replies (desc)" => "Válaszok (csökk)",
"Reads (desc)" => "Olvasottság (csökk)",
// "You have to provide a hotword and a URL" => "You have to provide a hotword and a URL",
// "Requested action is not supported on repository" => "Requested action is not supported on repository",
// "Repository name can't be an empty" => "Repository name can't be an empty",
// "No repository" => "No repository",
// "Search is mandatory field" => "Search is mandatory field",
// "File not found " => "File not found ",
// "Requested action in not supported on repository" => "Requested action in not supported on repository",
// "You need to apply the \"Invoice\" profile" => "You need to apply the \"Invoice\" profile",
// "Non-existent link" => "Non-existent link",
// "Mail-in account %s incorrect" => "Mail-in account %s incorrect",
// "Mail-in account %s saved" => "Mail-in account %s saved",
// "Frequency should be a positive integer" => "Frequency should be a positive integer",
// "Mail-in accounts set to be checked every %s minutes" => "Mail-in accounts set to be checked every %s minutes",
// "Automatic Mail-in accounts checking disabled" => "Automatic Mail-in accounts checking disabled",
"No menu indicated" => "Nincs megjeleníthető menü",
// "Are you sure you want to delete menu id" => "Are you sure you want to delete menu id",
// "Are you sure you want to reset the Application Menu to the current system default" => "Are you sure you want to reset the Application Menu to the current system default",
// "metric_remove must be a numeric value" => "metric_remove must be a numeric value",
// "tab_remove must be a numeric value" => "tab_remove must be a numeric value",
// "assign_remove must be a numeric value" => "assign_remove must be a numeric value",
// "metric_edit must be a numeric value" => "metric_edit must be a numeric value",
// "tab_edit must be a numeric value" => "tab_edit must be a numeric value",
// "Memcache is disabled for metrics" => "Memcache is disabled for metrics",
// "tab_clearcache must be a numeric value" => "tab_clearcache must be a numeric value",
// "assign_metric must be a numeric value" => "assign_metric must be a numeric value",
// "assign_metric_edit must be a numeric value" => "assign_metric_edit must be a numeric value",
// "Assign: Invalid metric value" => "Assign: Invalid metric value",
// "Assign: Invalid tab value" => "Assign: Invalid tab value",
// "Cannot create or update metric: You need to specify a name for the metric" => "Cannot create or update metric: You need to specify a name for the metric",
// "Cannot create or update metric: Metric name must be under %0 characters in length" => "Cannot create or update metric: Metric name must be under %0 characters in length",
// "Cannot create or update metric: You need to specify a range for the metric" => "Cannot create or update metric: You need to specify a range for the metric",
// "Cannot create or update metric: You need to specify a data type for the metric" => "Cannot create or update metric: You need to specify a data type for the metric",
// "Cannot create or update metric: You need to specify a query for the metric" => "Cannot create or update metric: You need to specify a query for the metric",
// "Cannot create or update tab: You need to specify a name for the tab" => "Cannot create or update tab: You need to specify a name for the tab",
// "Cannot create or update tab: Tab name must be under %0 characters in length" => "Cannot create or update tab: Tab name must be under %0 characters in length",
// "Cannot create or update tab: You need to specify an integer range for the tab order" => "Cannot create or update tab: You need to specify an integer range for the tab order",
// "Cannot create or update tab: Tab content cannot be empty" => "Cannot create or update tab: Tab content cannot be empty",
// "Cannot create or update module: You need to specify a name for the module" => "Cannot create or update module: You need to specify a name for the module",
// "Cannot create or update module: You cannot leave the data field empty" => "Cannot create or update module: You cannot leave the data field empty",
// "A module with that \"name\" already exists, please choose another" => "A module with that \"name\" already exists, please choose another",
// "There is a problem with your custom module \"%0\": ' . '<br><br><em>' . \$e->getMessage() . '</em><br><br>' .\n\t\t\t\t\t'<span class=\"button\"><a href=\"tiki-admin_modules.php?um_edit=' . \$_REQUEST['assign_name'] . '&cookietab=2#editcreate\">' .\n\t\t\t\t\ttr('Click here to edit the module" => "There is a problem with your custom module \"%0\": ' . '<br><br><em>' . \$e->getMessage() . '</em><br><br>' .\n\t\t\t\t\t'<span class=\"button\"><a href=\"tiki-admin_modules.php?um_edit=' . \$_REQUEST['assign_name'] . '&cookietab=2#editcreate\">' .\n\t\t\t\t\ttr('Click here to edit the module",
// "Are you sure you want to delete this Custom Module" => "Are you sure you want to delete this Custom Module",
"No newsletter indicated" => "Nincs megjeleníthető hírlevél",
// "Newsletter does not exist" => "Newsletter does not exist",
// "Error importing from wiki page: " => "Error importing from wiki page: ",
// "Error opening uploaded file" => "Error opening uploaded file",
// "You need to provide a username or an email" => "You need to provide a username or an email",
// "The user has no email set. No notifications will be sent" => "The user has no email set. No notifications will be sent",
"No poll indicated" => "Nincs megjeleníthető szavazás",
// "unsafe" => "unsafe",
// "The Path to store files in the filegallery should be outside the tiki root directory" => "The Path to store files in the filegallery should be outside the tiki root directory",
// "The Path to store files in the imagegallery should be outside the tiki root directory" => "The Path to store files in the imagegallery should be outside the tiki root directory",
// "The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code" => "The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code",
// "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any HTML" => "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any HTML",
// "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement" => "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement",
// "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory" => "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory",
// "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts" => "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts",
// "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)" => "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)",
// "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users" => "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users",
// "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users" => "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users",
// "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands" => "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands",
// "Path disclosure" => "Path disclosure",
// "Path disclosure through error message" => "Path disclosure through error message",
// "SQL injection" => "SQL injection",
// "SQL injection by authenticated user" => "SQL injection by authenticated user",
// "SQL injection by authenticated user with special privileges" => "SQL injection by authenticated user with special privileges",
// "SQL injection without authentication" => "SQL injection without authentication",
// "PHP command injection" => "PHP command injection",
// "PHP command injection by authenticated user" => "PHP command injection by authenticated user",
// "PHP command injection by authenticated user with special privileges" => "PHP command injection by authenticated user with special privileges",
// "PHP command injection without authentication" => "PHP command injection without authentication",
// "File upload" => "File upload",
// "File is not readable. Unable to check" => "File is not readable. Unable to check",
// "This is not a Tiki file. Check if this file was uploaded and if it is dangerous" => "This is not a Tiki file. Check if this file was uploaded and if it is dangerous",
// "This is a modified File. Cannot check version. Check if it is dangerous" => "This is a modified File. Cannot check version. Check if it is dangerous",
// "This file is from another Tiki version: " => "This file is from another Tiki version: ",
// "Shoutbox Words" => "Shoutbox Words",
// "You have to provide a word" => "You have to provide a word",
"You do not have permission to view this page." => "Magasabb szintű jogosultágra van szükség az oldal megtekintéséhez",
"You do not have permission to edit this page." => "Magasabb szintű jogosultágra van szükség az oldal szerkesztéséhez",
"You must specify a page name, it will be created if it doesn't exist." => "Meg kell adni egy oldalnevet. Ha nincs még ilyen nevű oldal akkor új oldal lesz létrehozva ezen a néven.",
"page not added (Exists)" => "a lap nincs hozzáadva (létezik)",
"No survey indicated" => "Nincs megjeleníthető kérdoív",
"Tiki Cache/Sys Admin" => "Cache/rendszer",
// "Global" => "Global",
// "WYSIWYG Plugin" => "WYSIWYG Plugin",
// "Are you sure you want to delete all your custom tools" => "Are you sure you want to delete all your custom tools",
// "Are you sure you want to delete this custom tool" => "Are you sure you want to delete this custom tool",
// "Are you sure you want to remove this topic" => "Are you sure you want to remove this topic",
"Are you sure you want to remove this topic AND all the articles related?" => "Törlésre kerüljön a téma ÉS az összes kapcsolódó cikk?",
"No tracker indicated" => "Nincs megjeleníthető űrlap",
// "Are you sure you want to create a new group" => "Are you sure you want to create a new group",
// "Are you sure you want to add this user" => "Are you sure you want to add this user",
// "Are you sure you want to ban the user \"%0\" from the group \"%1\"" => "Are you sure you want to ban the user \"%0\" from the group \"%1\"",
// "Are you sure you want to unban the user \"%0\" from the group \"%1\"" => "Are you sure you want to unban the user \"%0\" from the group \"%1\"",
"Group already exists" => "A csoport már létezik",
// "Remove group: " => "Remove group: ",
// "Are you sure you want to delete these groups" => "Are you sure you want to delete these groups",
// "Group name can not be empty" => "Group name can not be empty",
"User doesn't exist" => "A felhasználó nem létezik",
"No records were found. Check the file please!" => "Nincsenek rekordok. Ellenőrizzük a fájlt!",
// "User login or email is required" => "User login or email is required",
// "User does not exist on master" => "User does not exist on master",
"User login is required" => "Ehhez be kell jelentkezni",
"Email is required" => "Szükséges az E-mail cím megadása",
"User is duplicated" => "A felhasználó többször létezik",
// "Created account %s <%s>" => "Created account %s <%s>",
// "Assigned %s in group %s" => "Assigned %s in group %s",
// "Are you sure you want to add this new user" => "Are you sure you want to add this new user",
// "Email validation requested but email address not set" => "Email validation requested but email address not set",
// "The passwords do not match" => "The passwords do not match",
// "Password not set" => "Password not set",
// "User %s already exists" => "User %s already exists",
// "User login contains invalid characters" => "User login contains invalid characters",
// "New user created with username %s" => "New user created with username %s",
"Impossible to create new %s with %s %s." => "Nem lehetséges létrehozni %s ezzel: %s %s.",
// "Are you sure you want to delete this user" => "Are you sure you want to delete this user",
// "%s %s successfully deleted" => "%s %s successfully deleted",
// "Deleted account %s" => "Deleted account %s",
// "Are you sure you want to remove the admin user from the Admins group? You may not be able to administer your Tiki any more if you do this" => "Are you sure you want to remove the admin user from the Admins group? You may not be able to administer your Tiki any more if you do this",
// "Are you sure you want to remove this user from this group" => "Are you sure you want to remove this user from this group",
// "%s %s removed from %s %s" => "%s %s removed from %s %s",
// "Are you sure you want to reset email due for this user" => "Are you sure you want to reset email due for this user",
// "Are you sure you want to remove the link with OpenID for this user" => "Are you sure you want to remove the link with OpenID for this user",
// "Are you sure you want to delete these users" => "Are you sure you want to delete these users",
// "Are you sure you want to add this user to these groups" => "Are you sure you want to add this user to these groups",
// "%s %s assigned to %s %s" => "%s %s assigned to %s %s",
// "Are you sure you want to remove this user from these groups" => "Are you sure you want to remove this user from these groups",
// "Are you sure you want to set the default groups for these users" => "Are you sure you want to set the default groups for these users",
// "group %s set as the default group of user %s" => "group %s set as the default group of user %s",
// "Are you sure you want to send a wiki page as an email to these users" => "Are you sure you want to send a wiki page as an email to these users",
// "The description is mandatory as it is used as mail subject" => "The description is mandatory as it is used as mail subject",
// "Invalid or unknown email" => "Invalid or unknown email",
// "Login contains invalid characters" => "Login contains invalid characters",
// "%s changed from %s to %s" => "%s changed from %s to %s",
// "%s modified successfully" => "%s modified successfully",
// "%s modification failed" => "%s modification failed",
"email" => "E-mail",
// "Impossible to change %s from %s to %s" => "Impossible to change %s from %s to %s",
// "Please go back and try again" => "Please go back and try again",
// "Could not create user" => "Could not create user",
// "Are you sure you want to modify this user's data" => "Are you sure you want to modify this user's data",
"Classified" => "Titkos",
// "Failed to add attribute" => "Failed to add attribute",
"rss feed disabled" => "az rss adagoló ki van kapcsolva",
// "You have to indicate a group" => "You have to indicate a group",
// "This group is invalid" => "This group is invalid",
"The page cannot be found" => "A lap nem található",
// "Image Galleries Admin Panel" => "Image Galleries Admin Panel",
// "Could not read image %s" => "Could not read image %s",
// "Image %s upload failed" => "Image %s upload failed",
// "Image %s uploaded successfully" => "Image %s uploaded successfully",
// "Image %s removed from Batch directory" => "Image %s removed from Batch directory",
// "Impossible to remove image %s from Batch directory" => "Impossible to remove image %s from Batch directory",
// "Incorrect directory chosen for batch upload of images" => "Incorrect directory chosen for batch upload of images",
// "Please setup that dir on " => "Please setup that dir on ",
// "Please contact the website administrator" => "Please contact the website administrator",
// "Invalid directory name" => "Invalid directory name",
// "Directory batch" => "Directory batch",
// "File Galleries Admin Panel" => "File Galleries Admin Panel",
// "Upload was not successful for %0 (%1)" => "Upload was not successful for %0 (%1)",
// "Upload was successful" => "Upload was successful",
// "File %s removed from Batch directory" => "File %s removed from Batch directory",
// "Impossible to remove file %s from Batch directory" => "Impossible to remove file %s from Batch directory",
// "Incorrect directory chosen for batch upload of files" => "Incorrect directory chosen for batch upload of files",
"It isn't possible to post in any blog. You may need to create a blog first." => "Új blogot kell készíteni a posztoláshoz!",
"You do not have permission to edit this post" => "Magasabb szintű jogosultágra van szükség a poszt szerkesztéséhez",
"Top visited blogs" => "Leglátogatottabb blogok",
"Last posts" => "Legutóbbi posztok",
"Top active blogs" => "Legaktívabb blogok",
// "No blogId specified" => "No blogId specified",
// "Stop watching all categories" => "Stop watching all categories",
// "Watch all categories" => "Watch all categories",
// "Group watches for all categories" => "Group watches for all categories",
// "Stop watching this category and its descendants" => "Stop watching this category and its descendants",
"Watch this category and its descendants" => "Kategória és hozzá tartozó alkategóriák figyelése",
"Group watches for this category" => "Kategória csoportok általi figyelése",
// "Stop watching this category" => "Stop watching this category",
"Watch this category" => "Kategória figyelése",
"Nothing tagged yet" => "Még nincs felcímkézett tartalom",
// "You must clear your browser cache" => "You must clear your browser cache",
"You do not have permission to access this gallery" => "Magasabb szintű jogosultágra van szükség a galériához való hozzáféréshez",
// "No gallery indicated" => "No gallery indicated",
"You do not have permission to remove images from this gallery" => "Magasabb szintű jogosultágra van szükség képek eltávolításához ebbol a galériából",
"You do not have permission to rebuild thumbnails in this gallery" => "Magasabb szintű jogosultágra van szükség az elonézetek Újraépítéséhez",
"You do not have permission to rotate images in this gallery" => "Magasabb szintű jogosultágra van szükség a képek forgatásához ebben a galériában",
"No image indicated" => "Nincs kép feltüntetve",
"picture not found" => "a kép nem található",
"You do not have permission to move images from this gallery" => "Magasabb szintű jogosultágra van szükség képek mozgatásához ebbol a galériából",
// "You do not have permission to view the calendar" => "You do not have permission to view the calendar",
// "You need to <a href=\"tiki-admin_calendars.php?cookietab=2\">create a calendar</a>" => "You need to <a href=\"tiki-admin_calendars.php?cookietab=2\">create a calendar</a>",
// "There's no such date as" => "There's no such date as",
// "event without name" => "event without name",
// "You do not have permission to view this page" => "You do not have permission to view this page",
// "Invalid date format" => "Invalid date format",
// "Your PHP installation does not have calendar enabled" => "Your PHP installation does not have calendar enabled",
// "%H:%M %Z" => "%H:%M %Z",
// "Invalid username or activation code. Maybe this code has already been used" => "Invalid username or activation code. Maybe this code has already been used",
// "Your email could not be validated; make sure you email is correct" => "Your email could not be validated; make sure you email is correct",
// "You can not use the same password again" => "You can not use the same password again",
// "Invalid old password" => "Invalid old password",
// "Invalid request. Expecting channels array" => "Invalid request. Expecting channels array",
// "Missing channel name" => "Missing channel name",
// "Authentication required" => "Authentication required",
// "One of the requested channels cannot be requested. It does not exist or permission is denied" => "One of the requested channels cannot be requested. It does not exist or permission is denied",
// "One of the install profiles could not be obtained" => "One of the install profiles could not be obtained",
// "info" => "info",
// "You will get no errors reported, because error_reporting and display_errors are both turned off. This might be the right thing for a production site, but in case of problems enable these in php.ini to get more information" => "You will get no errors reported, because error_reporting and display_errors are both turned off. This might be the right thing for a production site, but in case of problems enable these in php.ini to get more information",
// "You will get no errors reported although display_errors is On, because the error_reporting level is set to 0. This might be the right thing for a production site, but in case of problems raise the value in php.ini to get more information" => "You will get no errors reported although display_errors is On, because the error_reporting level is set to 0. This might be the right thing for a production site, but in case of problems raise the value in php.ini to get more information",
// "You will get no errors reported, because display_errors is turned off. This might be the right thing for a production site, but in case of problems enable it in php.ini to get more information. Your error_reporting level is decent at '.\$e.'" => "You will get no errors reported, because display_errors is turned off. This might be the right thing for a production site, but in case of problems enable it in php.ini to get more information. Your error_reporting level is decent at '.\$e.'",
// "You will not get all errors reported as your error_reporting level is at '.\$e.'. '.'This is not necessarily a bad thing (and it might be just right for production sites) as you will still get critical errors reported, but sometimes it can be handy to get more information. Check your error_reporting level in php.ini in case of having issues" => "You will not get all errors reported as your error_reporting level is at '.\$e.'. '.'This is not necessarily a bad thing (and it might be just right for production sites) as you will still get critical errors reported, but sometimes it can be handy to get more information. Check your error_reporting level in php.ini in case of having issues",
// "You will get no errors reported although your error_reporting level is all the way up at '.\$e" => "You will get no errors reported although your error_reporting level is all the way up at '.\$e",
// "You will get all errors reported as your error_reporting level is all the way up at '.\$e.' and display_errors is on. Way to go in case of problems as the error reports usually contain some valuable hints" => "You will get all errors reported as your error_reporting level is all the way up at '.\$e.' and display_errors is on. Way to go in case of problems as the error reports usually contain some valuable hints",
// "good" => "good",
// "ini_set is used in some places to accomodate for special needs of some Tiki features" => "ini_set is used in some places to accomodate for special needs of some Tiki features",
// "ugly" => "ugly",
// "ini_set is used in some places to accomodate for special needs of some Tiki features. Check disable_functions in your php.ini" => "ini_set is used in some places to accomodate for special needs of some Tiki features. Check disable_functions in your php.ini",
// "The PDO extension is the suggested database driver/abstraction layer" => "The PDO extension is the suggested database driver/abstraction layer",
// "You do not have the recommended PDO database driver/abstraction layer. You do have the MySQLi driver though, so we will to fall back to the AdoDB abstraction layer that is bundled with Tiki" => "You do not have the recommended PDO database driver/abstraction layer. You do have the MySQLi driver though, so we will to fall back to the AdoDB abstraction layer that is bundled with Tiki",
// "You do not have the recommended PDO database driver/abstraction layer. You do have the MySQL driver though, so we will to fall back to the AdoDB abstraction layer that is bundled with Tiki" => "You do not have the recommended PDO database driver/abstraction layer. You do have the MySQL driver though, so we will to fall back to the AdoDB abstraction layer that is bundled with Tiki",
// "bad" => "bad",
// "You do not have any of the supported database drivers (PDO/mysqli/mysql) loaded. Tiki will not work" => "You do not have any of the supported database drivers (PDO/mysqli/mysql) loaded. Tiki will not work",
// "N/A" => "N/A",
// "You have less than 200 megs of free disk space. Tiki will not fit on this disk drive" => "You have less than 200 megs of free disk space. Tiki will not fit on this disk drive",
// "You have less than 250 megs of free disk space. This is quite tight. Tiki needs disk space for compiling templates and for uploading files" => "You have less than 250 megs of free disk space. This is quite tight. Tiki needs disk space for compiling templates and for uploading files",
// "When the disk runs full you will not be able to log into your Tiki any more" => "When the disk runs full you will not be able to log into your Tiki any more",
// "We can not reliably check for quotas, so be warned that if your server makes use of them you might have less disk space available" => "We can not reliably check for quotas, so be warned that if your server makes use of them you might have less disk space available",
// "You have more than 251 megs of free disk space. Tiki will run nicely, but you may run into issues when your site grows (e.g. file uploads)" => "You have more than 251 megs of free disk space. Tiki will run nicely, but you may run into issues when your site grows (e.g. file uploads)",
// "The PHP function disk_free_space is not available on your server, so we can't check for this" => "The PHP function disk_free_space is not available on your server, so we can't check for this",
// "You are running PHP as CGI. Feel free to use a threaded Apache MPM to increase performance" => "You are running PHP as CGI. Feel free to use a threaded Apache MPM to increase performance",
// "You are running PHP using FPM (Fastcgi Process Manager). Feel free to use a threaded Apache MPM to increase performance" => "You are running PHP using FPM (Fastcgi Process Manager). Feel free to use a threaded Apache MPM to increase performance",
// "You are not running PHP as CGI. Be aware that PHP is not thread-safe and you should not use a threaded Apache MPM (like worker)" => "You are not running PHP as CGI. Be aware that PHP is not thread-safe and you should not use a threaded Apache MPM (like worker)",
// "You are using APC as your ByteCode Cache which increases performance, if correctly configured. See Admin->Performance in your Tiki for more details" => "You are using APC as your ByteCode Cache which increases performance, if correctly configured. See Admin->Performance in your Tiki for more details",
// "You are using xCache as your ByteCode Cache which increases performance, if correctly configured. See Admin->Performance in your Tiki for more details" => "You are using xCache as your ByteCode Cache which increases performance, if correctly configured. See Admin->Performance in your Tiki for more details",
// "You are using WinCache as your ByteCode Cache which increases performance, if correctly configured. See Admin->Performance in your Tiki for more details" => "You are using WinCache as your ByteCode Cache which increases performance, if correctly configured. See Admin->Performance in your Tiki for more details",
// "You are using WinCache as your ByteCode Cache, but you do not seem to use the required CGI/FastCGI server API" => "You are using WinCache as your ByteCode Cache, but you do not seem to use the required CGI/FastCGI server API",
// "You are using neither APC, WinCache nor xCache as your ByteCode Cache which would increase performance, if correctly configured. See Admin->Performance in your Tiki for more details" => "You are using neither APC, WinCache nor xCache as your ByteCode Cache which would increase performance, if correctly configured. See Admin->Performance in your Tiki for more details",
// "You are using neither APC nor xCache as your ByteCode Cache which would increase performance, if correctly configured. See Admin->Performance in your Tiki for more details" => "You are using neither APC nor xCache as your ByteCode Cache which would increase performance, if correctly configured. See Admin->Performance in your Tiki for more details",
// "Your memory_limit is at" => "Your memory_limit is at",
// "This is known to behave well even for bigger sites" => "This is known to behave well even for bigger sites",
// "This will normally work, but you might run into problems when your site grows" => "This will normally work, but you might run into problems when your site grows",
// "This is known to cause issues! You should raise your memory_limit to at least 128M, which is the default of PHP" => "This is known to cause issues! You should raise your memory_limit to at least 128M, which is the default of PHP",
// "Your session.save_handler must be set to 'files'" => "Your session.save_handler must be set to 'files'",
// "Well set! the default setting of 'files' is needed for Tiki" => "Well set! the default setting of 'files' is needed for Tiki",
// "You have zlib output compression turned on. This saves bandwidth. Turning it off would in turn reduce CPU usage. Choose your poison" => "You have zlib output compression turned on. This saves bandwidth. Turning it off would in turn reduce CPU usage. Choose your poison",
// "You have zlib output compression turned off. This reduces CPU usage. Turning it on would in turn save bandwidth. Choose your poison" => "You have zlib output compression turned off. This reduces CPU usage. Turning it on would in turn save bandwidth. Choose your poison",
// "register_globals should be off by default. See the PHP manual for details" => "register_globals should be off by default. See the PHP manual for details",
// "Well set! And you are future proof also as register_globals is deprecated" => "Well set! And you are future proof also as register_globals is deprecated",
// "safe_mode is deprecated and should be off by default. See the <a href=\"http://www.php.net/manual/de/features.safe-mode.php\">PHP manual</a> for details" => "safe_mode is deprecated and should be off by default. See the <a href=\"http://www.php.net/manual/de/features.safe-mode.php\">PHP manual</a> for details",
// "Well set! And you are future proof also as safe_mode is deprecated" => "Well set! And you are future proof also as safe_mode is deprecated",
// "Some features like assigning perms to a group with a name containing a quote will not work with this being on. magic_quotes_gpc is also deprecated and should be off by default. See the PHP manual for details. You may experience weird behaviour of your Tiki" => "Some features like assigning perms to a group with a name containing a quote will not work with this being on. magic_quotes_gpc is also deprecated and should be off by default. See the PHP manual for details. You may experience weird behaviour of your Tiki",
// "Well set! Some features like assigning perms to a group with a name containing a quote will not work with this being on. And you are future proof also as magic_quotes_gpc is deprecated" => "Well set! Some features like assigning perms to a group with a name containing a quote will not work with this being on. And you are future proof also as magic_quotes_gpc is deprecated",
// "Well set! Tiki is fully UTF-8 and so should your installation be" => "Well set! Tiki is fully UTF-8 and so should your installation be",
// "default_charset should be UTF-8 as Tiki is fully UTF-8. Please check your php.ini" => "default_charset should be UTF-8 as Tiki is fully UTF-8. Please check your php.ini",
// "You have no timezone set! While there are a lot of fallbacks in PHP to determine the timezone, the only reliable solution is to set it explicitly in php.ini! Please check the value of date.timezone in php.ini" => "You have no timezone set! While there are a lot of fallbacks in PHP to determine the timezone, the only reliable solution is to set it explicitly in php.ini! Please check the value of date.timezone in php.ini",
// "Well done! Having a timezone set protects you from many weird errors" => "Well done! Having a timezone set protects you from many weird errors",
// "You can upload files to your Tiki" => "You can upload files to your Tiki",
// "You will not be able to upload any files to your Tiki" => "You will not be able to upload any files to your Tiki",
// "Your max_execution_time is at" => "Your max_execution_time is at",
// "This is a good value for production sites. If you experience timeouts (such as when performing admin functions) you may need to increase this nevertheless" => "This is a good value for production sites. If you experience timeouts (such as when performing admin functions) you may need to increase this nevertheless",
// "Your max_execution_time is unlimited" => "Your max_execution_time is unlimited",
// "This is not necessarily bad, but it's a good idea to limit this time on productions servers in order to eliminate unexpectedly long running scripts" => "This is not necessarily bad, but it's a good idea to limit this time on productions servers in order to eliminate unexpectedly long running scripts",
// "It is likely that some scripts, e.g. admin functions will not finish in this time! You should raise your max_execution_time to at least 30s" => "It is likely that some scripts, e.g. admin functions will not finish in this time! You should raise your max_execution_time to at least 30s",
// "Your max_input_time is at" => "Your max_input_time is at",
// "Your max_input_time is unlimited" => "Your max_input_time is unlimited",
// "It is likely that some scripts, e.g. admin functions will not finish in this time! You should raise your max_input_time to at least 30 seconds" => "It is likely that some scripts, e.g. admin functions will not finish in this time! You should raise your max_input_time to at least 30 seconds",
// "Your upload_max_filesize is at" => "Your upload_max_filesize is at",
// "You can upload quite big files, but keep in mind to set your script timeouts accordingly" => "You can upload quite big files, but keep in mind to set your script timeouts accordingly",
// "Nothing wrong with that, but some users might want to upload something bigger" => "Nothing wrong with that, but some users might want to upload something bigger",
// "Your post_max_size is at" => "Your post_max_size is at",
// "The GD extension is needed for manipulation of images, e.g. also for CAPTCHAs" => "The GD extension is needed for manipulation of images, e.g. also for CAPTCHAs",
// "The GD extension is loaded, and Tiki can create images, but the FreeType extension is needed for CAPTCHA text generation" => "The GD extension is loaded, and Tiki can create images, but the FreeType extension is needed for CAPTCHA text generation",
// "The GD extension is loaded, but Tiki is unable to create images. Please check your GD library configuration" => "The GD extension is loaded, but Tiki is unable to create images. Please check your GD library configuration",
// "ImageMagick is used as a fallback in case that GD is not available" => "ImageMagick is used as a fallback in case that GD is not available",
// "ImageMagick is available, but unable to create images. Please check your ImageMagick configuration" => "ImageMagick is available, but unable to create images. Please check your ImageMagick configuration",
// "The mbstring extension is needed for an UTF-8 compatible lower case filter in the admin search for example" => "The mbstring extension is needed for an UTF-8 compatible lower case filter in the admin search for example",
// "The mbstring extension is loaded, but mbstring.func_overload = '.' '.\$func_overload.'.'.' '.'Tiki only works with mbsring.func_overload = 0. Please check your php.ini" => "The mbstring extension is loaded, but mbstring.func_overload = '.' '.\$func_overload.'.'.' '.'Tiki only works with mbsring.func_overload = 0. Please check your php.ini",
// "The mbstring extension is loaded, but missing important functions as for example mb_split(). You need to reinstall it with --enable-mbregex or ask your hoster do do it" => "The mbstring extension is loaded, but missing important functions as for example mb_split(). You need to reinstall it with --enable-mbregex or ask your hoster do do it",
// "The mbstring extension is needed for an UTF-8 compatible lower case filter" => "The mbstring extension is needed for an UTF-8 compatible lower case filter",
// "calendar extension is needed by Tiki" => "calendar extension is needed by Tiki",
// "You will not be able to use the calendar feature of Tiki" => "You will not be able to use the calendar feature of Tiki",
// "ctype extension is needed by Tiki" => "ctype extension is needed by Tiki",
// "This extension is needed for WebDAV" => "This extension is needed for WebDAV",
// "This extension is needed to connect your Tiki to an LDAP server. More info at: http://doc.tiki.org/LDAP " => "This extension is needed to connect your Tiki to an LDAP server. More info at: http://doc.tiki.org/LDAP ",
// "You will not be able to connect your Tiki to an LDAP server as the needed PHP extension is missing. More info at: http://doc.tiki.org/LDAP" => "You will not be able to connect your Tiki to an LDAP server as the needed PHP extension is missing. More info at: http://doc.tiki.org/LDAP",
// "This extension can be used to speed up your Tiki by saving sessions as well as wiki and forum data on a memcached server" => "This extension can be used to speed up your Tiki by saving sessions as well as wiki and forum data on a memcached server",
// "This extension is used to interpret SVN information for TortoiseSVN 1.7 or higher" => "This extension is used to interpret SVN information for TortoiseSVN 1.7 or higher",
// "The eval() function is required by the Smarty templating engine" => "The eval() function is required by the Smarty templating engine",
// "You will get \"Please contact support about\" messages instead of modules. eval() is most probably disabled via Suhosin" => "You will get \"Please contact support about\" messages instead of modules. eval() is most probably disabled via Suhosin",
// "The ZipArchive class is needed for features such as XML Wiki Import/Export and PluginArchiveBuilder" => "The ZipArchive class is needed for features such as XML Wiki Import/Export and PluginArchiveBuilder",
// "The DateTime class is needed for the WebDAV feature" => "The DateTime class is needed for the WebDAV feature",
// "Tiki requires MySQL >= 5.x" => "Tiki requires MySQL >= 5.x",
// "Your max_allowed_packet setting is at" => "Your max_allowed_packet setting is at",
// "This limits the size of binary files that can be added to Tiki, when storing files in the database. Please see: <a href=\"http://doc.tiki.org/File+Storage\">file storage</a>" => "This limits the size of binary files that can be added to Tiki, when storing files in the database. Please see: <a href=\"http://doc.tiki.org/File+Storage\">file storage</a>",
// "Tiki is fully UTF-8 and so should every part of your stack be" => "Tiki is fully UTF-8 and so should every part of your stack be",
// "On a fresh install you should have everything set to UTF-8 to not run into any suprises. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>" => "On a fresh install you should have everything set to UTF-8 to not run into any suprises. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>",
// "Tiki is fully UTF-8 and so should every part of your stack be. utf8_unicode_ci is the default collation for Tiki" => "Tiki is fully UTF-8 and so should every part of your stack be. utf8_unicode_ci is the default collation for Tiki",
// "On a fresh install you should have everything set to UTF-8 to not run into any suprises. utf8_unicode_ci is the default collation for Tiki. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>" => "On a fresh install you should have everything set to UTF-8 to not run into any suprises. utf8_unicode_ci is the default collation for Tiki. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>",
// "Your MySQL doesn't log slow queries. If you have performance issues, you might want to enable this, but keep in mind that the logging itself slows MySQL down" => "Your MySQL doesn't log slow queries. If you have performance issues, you might want to enable this, but keep in mind that the logging itself slows MySQL down",
// "Your MySQL logs slow queries. If you don't have performance issues, you should disable this on a production site as it slows MySQL down" => "Your MySQL logs slow queries. If you don't have performance issues, you should disable this on a production site as it slows MySQL down",
// "Tiki needs this module for Search Engine Friendly URLs via .htaccess. We can't check though, if your web server respects configurations made in .htaccess. For further information go to Admin->SefURL in your Tiki" => "Tiki needs this module for Search Engine Friendly URLs via .htaccess. We can't check though, if your web server respects configurations made in .htaccess. For further information go to Admin->SefURL in your Tiki",
// "Tiki needs this module for Search Engine Friendly URLs. For further information go to Admin->SefURL in your Tiki" => "Tiki needs this module for Search Engine Friendly URLs. For further information go to Admin->SefURL in your Tiki",
// "Your RewriteBase is set correctly in .htaccess. Search Engine Friendly URLs should work. Beware though that we can't check if Apache really loads .htaccess" => "Your RewriteBase is set correctly in .htaccess. Search Engine Friendly URLs should work. Beware though that we can't check if Apache really loads .htaccess",
// "Your RewriteBase is not set correctly in .htaccess. Search Engine Friendly URLs are not going to work like that. It should be set to \"" => "Your RewriteBase is not set correctly in .htaccess. Search Engine Friendly URLs are not going to work like that. It should be set to \"",
// "You haven't activated .htaccess. So this check is useless. If you want to use Search Engine Friendly URLs, you will have to activate .htaccess by copying _htaccess into its place (or a symlink if supported by your Operating System). Then come back to have a look at this check again" => "You haven't activated .htaccess. So this check is useless. If you want to use Search Engine Friendly URLs, you will have to activate .htaccess by copying _htaccess into its place (or a symlink if supported by your Operating System). Then come back to have a look at this check again",
// "With this module you can set the HTTP Expires header and therefore increase performance. We can't check though, if mod_expires is configured correctly" => "With this module you can set the HTTP Expires header and therefore increase performance. We can't check though, if mod_expires is configured correctly",
// "With this module you can set the HTTP Expires header and therefore increase performance. Once you install it, you still need to configure it correctly" => "With this module you can set the HTTP Expires header and therefore increase performance. Once you install it, you still need to configure it correctly",
// "With this module you can compress the data your webserver sends out and therefore decrease used bandwidth and increase performance. We can't check though, if mod_deflate is configured correctly" => "With this module you can compress the data your webserver sends out and therefore decrease used bandwidth and increase performance. We can't check though, if mod_deflate is configured correctly",
// "With this module you can compress the data your webserver sends out and therefore decrease used bandwidth and increase performance. Once you install it, you still need to configure it correctly" => "With this module you can compress the data your webserver sends out and therefore decrease used bandwidth and increase performance. Once you install it, you still need to configure it correctly",
// "This module can increase security of your Tiki and therefore your server, but be warned that it is very tricky to configure it correctly. A misconfiguration can lead to failed page saves or other hard to trace bugs" => "This module can increase security of your Tiki and therefore your server, but be warned that it is very tricky to configure it correctly. A misconfiguration can lead to failed page saves or other hard to trace bugs",
// "The URL Rewrite Module is required to use SEFURL on IIS" => "The URL Rewrite Module is required to use SEFURL on IIS",
// "upload_tmp_dir is probably within your Tiki directory. There is a risk that someone can upload any file to this directory and access them via web browser" => "upload_tmp_dir is probably within your Tiki directory. There is a risk that someone can upload any file to this directory and access them via web browser",
// "Can't reliably determine, if your upload_tmp_dir is accessible via a web browser. To make sure you should check your webserver config" => "Can't reliably determine, if your upload_tmp_dir is accessible via a web browser. To make sure you should check your webserver config",
// "register_globals should be off by default. See the php manual for details" => "register_globals should be off by default. See the php manual for details",
"safe" => "biztonságos",
// "WebKit is enabled" => "WebKit is enabled",
// "Blogs is enabled" => "Blogs is enabled",
// "Exec can potentially be used to execute arbitrary code on your server" => "Exec can potentially be used to execute arbitrary code on your server",
// "Tiki does not need it, you may want to disable it" => "Tiki does not need it, you may want to disable it",
// "Exec can be potentially be used to execute arbitrary code on your server" => "Exec can be potentially be used to execute arbitrary code on your server",
// "Tiki does not need it, you are wise to have it disabled" => "Tiki does not need it, you are wise to have it disabled",
// "Passthru is similar to exec" => "Passthru is similar to exec",
// "Shell_exec is similar to exec" => "Shell_exec is similar to exec",
// "Tiki needs it to run PDF from URL: WebKit (wkhtmltopdf). '.\$pdf_webkit.'If you need this and trust the other PHP software on your server, you should enable it" => "Tiki needs it to run PDF from URL: WebKit (wkhtmltopdf). '.\$pdf_webkit.'If you need this and trust the other PHP software on your server, you should enable it",
// "System is similar to exec" => "System is similar to exec",
// "Proc_open is similar to exec" => "Proc_open is similar to exec",
// "Curl_exec can potentially be abused to write malicious code" => "Curl_exec can potentially be abused to write malicious code",
// "Tiki needs it to run features like Kaltura, CAS login, CClite and the myspace and sf wiki-plugins. If you need these and trust the other PHP software on your server, you should enable it" => "Tiki needs it to run features like Kaltura, CAS login, CClite and the myspace and sf wiki-plugins. If you need these and trust the other PHP software on your server, you should enable it",
// "Curl_multi_exec can potentially be abused to write malicious code" => "Curl_multi_exec can potentially be abused to write malicious code",
// "It is probably an urban myth that this is dangerous. Tiki team will reconsider this check, but be warned" => "It is probably an urban myth that this is dangerous. Tiki team will reconsider this check, but be warned",
"risky" => "kockázatos",
// "session.use_trans_sid should be off by default. See the php manual for details" => "session.use_trans_sid should be off by default. See the php manual for details",
// "setting the xbithack option is unsafe. Depending on the file handling of your webserver and your tiki settings, it may be possible that an attacker can upload scripts to file gallery and execute them" => "setting the xbithack option is unsafe. Depending on the file handling of your webserver and your tiki settings, it may be possible that an attacker can upload scripts to file gallery and execute them",
// "allow_url_fopen may potentially be used to upload remote data or scripts. '.\$feature_blogs.'If you dont use the blog feature, you can switch it off" => "allow_url_fopen may potentially be used to upload remote data or scripts. '.\$feature_blogs.'If you dont use the blog feature, you can switch it off",
// "Test mail from Tiki Server Compatibility Test" => "Test mail from Tiki Server Compatibility Test",
// "We were able to send an e-mail. This only means that a mail server accepted the mail for delivery. We don't know, if that server really delivers the mail. Please check the inbox of '.\$_POST['email_test_to'].' to see, if the delivery really works" => "We were able to send an e-mail. This only means that a mail server accepted the mail for delivery. We don't know, if that server really delivers the mail. Please check the inbox of '.\$_POST['email_test_to'].' to see, if the delivery really works",
// "We were not able to send an e-mail. It may be that there is no mail server installed on this machine or that it is badly configured. If you absolutely can't get the local mail server to work, you can setup a regular mail account and set SMTP settings in tiki-admin.php" => "We were not able to send an e-mail. It may be that there is no mail server installed on this machine or that it is badly configured. If you absolutely can't get the local mail server to work, you can setup a regular mail account and set SMTP settings in tiki-admin.php",
// "The fileinfo extension is needed for the 'Validate uploaded file content' preference" => "The fileinfo extension is needed for the 'Validate uploaded file content' preference",
"Top authors" => "Remeklo szerzők",
// "Problem. Try to log in again to receive new confirmation instructions" => "Problem. Try to log in again to receive new confirmation instructions",
// "You must include a subject or a message" => "You must include a subject or a message",
// "You must make sure to have a valid e-mail address in the From field" => "You must make sure to have a valid e-mail address in the From field",
// "%0 sent you a message" => "%0 sent you a message",
"last version" => "legutóbbi verzió",
// "Cannot rename page because the new name begins with reserved prefix" => "Cannot rename page because the new name begins with reserved prefix",
// "Cannot copy page because maybe new page name already exists" => "Cannot copy page because maybe new page name already exists",
// "TikiHelp WebHelp generation engine. Generating WebHelp using" => "TikiHelp WebHelp generation engine. Generating WebHelp using",
// "Eliminating previous files" => "Eliminating previous files",
// "Index: <strong>%0</strong>" => "Index: <strong>%0</strong>",
// "Directory: <strong>%0</strong>" => "Directory: <strong>%0</strong>",
// "You need to change chmod 'whelp' manually to 777" => "You need to change chmod 'whelp' manually to 777",
// "Creating directory structure in <strong>%0</strong>" => "Creating directory structure in <strong>%0</strong>",
"Submit a new link" => "Új link beküldése",
// "Must enter a name to add a site. " => "Must enter a name to add a site. ",
// "Must enter a url to add a site. " => "Must enter a url to add a site. ",
// "URL already added to the directory. Duplicate site? " => "URL already added to the directory. Duplicate site? ",
// "URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. " => "URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. ",
// "Must select a category. " => "Must select a category. ",
"Must enter a name to add a site" => "Meg kell adni egy nevet új weblap hozzáadásához",
"Must enter a url to add a site" => "Meg kell adni egy URL-t új weblap hozzáadásához",
"URL already added to the directory. Duplicate site?" => "Ez az URL már egyszer fel lett véve! Szerepeljen mégegyszer?",
// "URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory" => "URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory",
"Admin Directory" => "Linktár karbantartás",
"Must select a category" => "Ki kell választani egy kategóriát",
"Browse Directory" => "Linktár böngészés",
// "How to use Directory" => "How to use Directory",
// "No site indicated" => "No site indicated",
// "This feature is disabled: %0" => "This feature is disabled: %0",
// "No parent specified" => "No parent specified",
// "Last sites of directory %0" => "Last sites of directory %0",
// "Discount code already exists" => "Discount code already exists",
// "File has been deleted" => "File has been deleted",
// "You cannot download this file right now. Your score is low or file limit was reached" => "You cannot download this file right now. Your score is low or file limit was reached",
// "Error : The file %s doesn't exist" => "Error : The file %s doesn't exist",
"Article not found" => "Cikk nem található",
"You do not have permission to edit this article" => "Magasabb szintű jogosultágra van szükség a cikk szerkesztéséhez",
// "The language can't be changed as its set of translations has already this language" => "The language can't be changed as its set of translations has already this language",
"Banner not found" => "Banner nem található",
"You do not have permission to edit this banner" => "Nincs Elegendő a jogosultság a banner szerkesztéséhez",
"You do not have permission to edit this blog" => "Magasabb szintű jogosultágra van szükség a blog szerkesztéséhez",
// "Incorrect name" => "Incorrect name",
// "You do not have permission to write the style sheet" => "You do not have permission to write the style sheet",
// "Wrong file type, expected %0" => "Wrong file type, expected %0",
// "You do not have permission to view/edit this file" => "You do not have permission to view/edit this file",
// "New Svg Image" => "New Svg Image",
"Invalid request to edit an image" => "A kép szerkesztéséhez érvénytelen kérés érkezett",
"You have permission to edit images but not in this gallery" => "A jogosultság általában elég képek szerkesztéséhez de ebben a galériában sajnos nem",
"Failed to edit the image" => "A kép módosítási kísérlete sikertelen",
// "Wrote %d new strings and updated %d to lang/%s/language.php" => "Wrote %d new strings and updated %d to lang/%s/language.php",
// "Edit Perspectives" => "Edit Perspectives",
// "No content id indicated" => "No content id indicated",
"No question indicated" => "Nincs kérdés feltüntetve",
// "No quiz indicated" => "No quiz indicated",
// "No structure indicated" => "No structure indicated",
// "Invalid structure_id or page_ref_id" => "Invalid structure_id or page_ref_id",
// "You do not have permission to edit submissions" => "You do not have permission to edit submissions",
"You have to create a topic first" => "Először témát kell létrehoznod",
// "Template directory %0 unknown" => "Template directory %0 unknown",
"You do not have permission to do that" => "Ehhez több jogosultságra van szükség",
"You do not have permission to write the template" => "A sablon szerkesztéséhez több jogosultságra van szükség",
"You do not have permission to read the template" => "A sablonok megtekintéséhez több jogosultságra van szükség",
// "No topic id specified" => "No topic id specified",
// "Invalid topic id specified" => "Invalid topic id specified",
// "No object indicated" => "No object indicated",
// "Only wiki pages are supported" => "Only wiki pages are supported",
// "Not enable for this type of object" => "Not enable for this type of object",
// "Override lock and carry on with edit" => "Override lock and carry on with edit",
// "Page is currently being edited" => "Page is currently being edited",
// "page imported" => "page imported",
// "created from import" => "created from import",
// "Describe the change you made" => "Describe the change you made",
// "This page is being edited by %0. Please check with the user before editing the page,\totherwise the changes will be stored as two separate versions in the history and you will have to manually merge them later" => "This page is being edited by %0. Please check with the user before editing the page,\totherwise the changes will be stored as two separate versions in the history and you will have to manually merge them later",
// "Can't import remote HTML page" => "Can't import remote HTML page",
"The SandBox is disabled" => "A Homokozó ki van kapcsolva",
"Cannot edit page because it is locked" => "Ezt az oldalt nem lehet szerkeszteni mivel zárolva van",
"Page already exists. Go back and choose a different name." => "Ilyen nevű oldal már létezik ezért más nevet kell választani",
// "Page name is" => "Page name is",
"The translation set already contains a page in this language." => "A fordítási készlet már tartalmaz egy oldalt ezen a nyelven.",
// "Can not open the file" => "Can not open the file",
// "Problem zip initialisation" => "Problem zip initialisation",
// "Problem zip" => "Problem zip",
// "Another user is currently exporting that tracker, please try again later" => "Another user is currently exporting that tracker, please try again later",
// "No questions group indicated" => "No questions group indicated",
// "Remove archive: " => "Remove archive: ",
// "Remove file gallery: " => "Remove file gallery: ",
"Top visited file galleries" => "Leglátogatottabb fájlgalériák",
"Most downloaded files" => "Legtöbbször letöltött fájlok",
// "Last files" => "Last files",
// "No galleryId specified" => "No galleryId specified",
// "Form error - no import method selected for some reason" => "Form error - no import method selected for some reason",
// "Form error - no server-side filename entered for selected import method" => "Form error - no server-side filename entered for selected import method",
"No forum indicated" => "Nincs fórum feltüntetve",
"Last forum topics" => "Legutóbbi fórum témák",
// "Last replied forum topics" => "Last replied forum topics",
"Most-Read Forum Topics" => "Legtöbbet olvasott témák",
"Top topics" => "Top témák",
"Forum posts" => "Fórum hozzászólások",
"Most-Visited Forums" => "Leglátogatottabb fórumok",
// "No forumId specified" => "No forumId specified",
"List Forums" => "Fórum lista",
// "Not supported yet" => "Not supported yet",
// "Accepted friendship request from %s" => "Accepted friendship request from %s",
// "Refused friendship request from %s" => "Refused friendship request from %s",
// "Canceled friendship request with %s" => "Canceled friendship request with %s",
// "Broke friendship with %s" => "Broke friendship with %s",
// "I have broken our friendship" => "I have broken our friendship",
// "Friendship request sent to %s" => "Friendship request sent to %s",
// "You're already friend of %s" => "You're already friend of %s",
// "I have accepted your friendship request" => "I have accepted your friendship request",
// "I have refused your friendship request" => "I have refused your friendship request",
// "I have canceled my friendship request" => "I have canceled my friendship request",
"first uploaded image" => "először feltöltött kép",
"last uploaded image" => "utoljára feltöltött kép",
"first image" => "első kép",
"last image" => "utolsó kép",
"random image" => "véletlenszerű kép",
"You do not have permission to create galleries and so you cannot edit them" => "Magasabb szintű jogosultágra van szükség galéria létrehozásához és szerkesztéséhez",
"You do not have permission to edit this gallery" => "Magasabb szintű jogosultágra van szükség a galéria szerkesztéséhez",
"You do not have permission to remove this gallery" => "Magasabb szintű jogosultágra van szükség a galéria eltávolításához",
// "You do not have permission to make the map of this gallery" => "You do not have permission to make the map of this gallery",
"Top images" => "Legjobb képek",
"Last images" => "Új képek",
// "Back to item" => "Back to item",
// "No valid renderer found. GD or PDFLib required" => "No valid renderer found. GD or PDFLib required",
// "No sheet specified" => "No sheet specified",
// "You must select a renderer" => "You must select a renderer",
// "Invalid Series for current graphic" => "Invalid Series for current graphic",
"overwriting old page" => "régi lap felülírása",
// "updated from structured text import" => "updated from structured text import",
// "page created" => "page created",
// "created from structured text import" => "created from structured text import",
// "Operations executed successfully" => "Operations executed successfully",
// "Invalid software name" => "Invalid software name",
// "No name indicated for wiki page" => "No name indicated for wiki page",
// "This version does not exist" => "This version does not exist",
// "There is more than one item in the tracker with this title" => "There is more than one item in the tracker with this title",
// "There are no items in the tracker with this title" => "There are no items in the tracker with this title",
"Page saved (version %d)" => "Oldal elmentve (verzió %d)",
// "You have requested that this page be machine translated" => "You have requested that this page be machine translated",
// "However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it" => "However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it",
// "No repository given" => "No repository given",
// "This invitation does not exist or is deprecated" => "This invitation does not exist or is deprecated",
// "Congratulations! You are now part of this invitation group(s)" => "Congratulations! You are now part of this invitation group(s)",
// "Upload Media" => "Upload Media",
// "Communication error" => "Communication error",
// "Invalid response provided by the Kaltura server. Please retry" => "Invalid response provided by the Kaltura server. Please retry",
// "Are you sure you want to permanently remove the article with identifier %0" => "Are you sure you want to permanently remove the article with identifier %0",
// "Are you sure you want to permanently remove these %0 articles" => "Are you sure you want to permanently remove these %0 articles",
"You do not have permission to remove articles" => "Magasabb szintű jogosultágra van szükség a cikkek eltávolításához",
"You do not have permission to remove banners" => "Nem távolíthatsz el banner-eket! Hozzáférés megtagadva...",
// "List Blog Posts" => "List Blog Posts",
"You do not have permission to remove this blog" => "Magasabb szintű jogosultágra van szükség a blog törléséhez",
// "You do not have permission to view the comments for this blog" => "You do not have permission to view the comments for this blog",
"Delete comments" => "Kommentek letöltése",
"Approved Status" => "Jóváhagyási státusz",
"Queued" => "Sorban áll",
// "This blog has no posts" => "This blog has no posts",
"Dynamic content" => "Dinamikus tartalom",
// "Admin FAQs" => "Admin FAQs",
"Non-existent gallery" => "Nem létező galéria",
// "You do not have permission to view this gallery" => "You do not have permission to view this gallery",
"The file is already locked by %s" => "A fájlt már zárolta: %s",
// "Permission denied you cannot validate files from this gallery" => "Permission denied you cannot validate files from this gallery",
// "Validate draft: " => "Validate draft: ",
// "Quota too big" => "Quota too big",
// "Quota too small" => "Quota too small",
// "You have permission to upload files but not to this file gallery" => "You have permission to upload files but not to this file gallery",
// "Not modified since" => "Not modified since",
// "Not downloaded since" => "Not downloaded since",
// "You do not have permission to upload files so you cannot edit them" => "You do not have permission to upload files so you cannot edit them",
// "This gallery does not exist" => "This gallery does not exist",
// "List Entries" => "List Entries",
// "Error importing" => "Error importing",
// "Error converting" => "Error converting",
// "Importing" => "Importing",
// "Processing" => "Processing",
// "Ready" => "Ready",
// "Pending moderation" => "Pending moderation",
// "Blocked" => "Blocked",
// "Invalid action" => "Invalid action",
// "Remove permission %0 from %1" => "Remove permission %0 from %1",
// "Assign permission %0 to %1" => "Assign permission %0 to %1",
// "Delete posts" => "Delete posts",
// "View submissions" => "View submissions",
// "Are you sure you want to permanently remove the submitted article with identifier %0" => "Are you sure you want to permanently remove the submitted article with identifier %0",
// "Are you sure you want to permanently remove these %0 submitted articles" => "Are you sure you want to permanently remove these %0 submitted articles",
// "Are you sure you want to approve these %0 submitted articles" => "Are you sure you want to approve these %0 submitted articles",
// "Are you sure you want to remove the %0 selected pages" => "Are you sure you want to remove the %0 selected pages",
// "Are you sure you want to print the %0 selected pages" => "Are you sure you want to print the %0 selected pages",
// "Are you sure you want to unlock the %0 selected pages" => "Are you sure you want to unlock the %0 selected pages",
// "Are you sure you want to lock the %0 selected pages" => "Are you sure you want to lock the %0 selected pages",
// "Are you sure you want to download a zip of the %0 selected pages" => "Are you sure you want to download a zip of the %0 selected pages",
// "Are you sure you want to modify the %0 pages" => "Are you sure you want to modify the %0 pages",
// "No history will be created" => "No history will be created",
// "You are neither an administrator nor an operator of live support" => "You are neither an administrator nor an operator of live support",
// "Username field cannot be empty. Please go back and try again" => "Username field cannot be empty. Please go back and try again",
// "Unable to contact remote server" => "Unable to contact remote server",
// "XMLRPC Error: " => "XMLRPC Error: ",
// "Unable to create login" => "Unable to create login",
// "More than %d unsuccessful login attempts have been made" => "More than %d unsuccessful login attempts have been made",
// "Your account has been suspended" => "Your account has been suspended",
// "A site administrator will reactivate it" => "A site administrator will reactivate it",
// "An email has been sent to you with the instructions to follow" => "An email has been sent to you with the instructions to follow",
// "Account disabled" => "Account disabled",
// "You did not validate your account" => "You did not validate your account",
// "Resend" => "Resend",
// "You should have received an email. Check your mailbox and your spam box. Otherwise click on the button to resend the email" => "You should have received an email. Check your mailbox and your spam box. Otherwise click on the button to resend the email",
// "You must use the right case for your user name" => "You must use the right case for your user name",
// "You are not yet validated" => "You are not yet validated",
// "The mail can't be sent. Contact the administrator" => "The mail can't be sent. Contact the administrator",
// "Your default nickname is already in use. A new one has to be selected" => "Your default nickname is already in use. A new one has to be selected",
// "Verification cancelled" => "Verification cancelled",
// "The selected account is not associated with your identity" => "The selected account is not associated with your identity",
// "unknown action" => "unknown action",
// "Authentication method is not OpenID" => "Authentication method is not OpenID",
// "Authentication error; probably not a valid OpenID" => "Authentication error; probably not a valid OpenID",
// "Could not redirect to server: " => "Could not redirect to server: ",
// "OpenID authentication failed: " => "OpenID authentication failed: ",
// "You have already validated your account. Please log in" => "You have already validated your account. Please log in",
// "Sorry, you can't use this feature" => "Sorry, you can't use this feature",
"You must first setup MapServer" => "Először be kell állítani a Térképszervert",
"invalid mapfile name" => "érvénytelen mapfile név",
// "An error as occurred with the mapfile" => "An error as occurred with the mapfile",
"edit" => "szerkesztés",
// "Please create a directory named %0 to hold your map files" => "Please create a directory named %0 to hold your map files",
"Maps feature is not correctly setup : Maps path is missing." => "Térkép funkció nincs megfelelően beállítva, hiányzik az útvonal",
"mapfile name incorrect" => "mapfile név nem megfelelő",
"This mapfile already exists" => "Ez a mapfile már létezik",
"You do not have permission to write to the mapfile" => "Nincs elegendő jogosultság a mapfile írásához",
"You do not have permission to delete the mapfile" => "Nincs elegendő jogosultság a mapfile törléséhez",
"I could not make a copy" => "Másolat létrehozása nem sikerült",
"You do not have permission to read the mapfile" => "Nincs elegendő jogosultság a mapfile olvasásához",
"map edit" => "térkép szerkesztése",
"You dont have permission to do that" => "Nincs elegendő jogosultság ehhez az akcióhoz",
"Tiki RSS feed for maps" => "Tiki RSS feed térképek számára",
"List of maps available." => "Rendelkezésre álló térképek listája",
// "Layer Management" => "Layer Management",
"The Directory is not empty" => "A könyvtár nem üres",
"Invalid file name" => "Érvénytelen fájlnév",
"Invalid files to index" => "Érvénytelen indexelendő fájlok",
"I do not know where is gdaltindex. Set correctly the Map feature" => "Gdaltindex nem található. Állítsuk be helyesen a Térkép funkciót",
"I could not create the index file" => "Az index fájl létrehozása nem sikerült",
// " to " => " to ",
// "No page provided" => "No page provided",
// "You need to run setup.sh :<br />./setup.sh \$APACHEUSER all<br />Common Apache users are www-data, apache or nobody" => "You need to run setup.sh :<br />./setup.sh \$APACHEUSER all<br />Common Apache users are www-data, apache or nobody",
// "Your PHP installation does not have zlib enabled" => "Your PHP installation does not have zlib enabled",
"You must log in to use this feature" => "Először <a href=\"tiki-login_scr.php\">be kell jelentkezni</a> ehhez!",
"MyTiki Home" => "MyTiki kezdőlap",
"You do not have permission to view other users data" => "Nincs Elegendő jogosultság más felhasználók adatainak a megtekintéséhez",
"You must be logged in to subscribe to newsletters" => "Először <a href=\"tiki-login_scr.php\" alt=\"Login\">be kell jelentkezni</a> hírlevelekre való feliratkozáshoz",
// "No note indicated" => "No note indicated",
// "merged note" => "merged note",
"File is too big" => "A megadott fájl túl nagy!",
// "No item indicated" => "No item indicated",
// "Are you sure you want to delete this note" => "Are you sure you want to delete this note",
// "created from notepad" => "created from notepad",
// "Note not found" => "Note not found",
// "Not enough information to display this page" => "Not enough information to display this page",
// "You do not have permission to assign permissions for this object" => "You do not have permission to assign permissions for this object",
// "Are you sure you want to remove the direct permissions from this object" => "Are you sure you want to remove the direct permissions from this object",
// "Are you sure you want paste the copied permissions onto this object" => "Are you sure you want paste the copied permissions onto this object",
// "Manual payment entered" => "Manual payment entered",
// "You do not have permission to enter payment" => "You do not have permission to enter payment",
// "New payment requested" => "New payment requested",
// "Cancel payment %0" => "Cancel payment %0",
// "Payment canceled" => "Payment canceled",
"No article indicated" => "Nincs ilyen cikk",
"Article is not published yet" => "A cikk még nincs publikálva",
"No post indicated" => "Nincs hozzászólás feltüntetve",
"Blog not found" => "Nincs találat",
// "Missing object list type argument" => "Missing object list type argument",
// "Index" => "Index",
// "Index (%0)" => "Index (%0)",
"No pages indicated" => "Nincs oldal feltüntetve",
"Multiple Print" => "Tömeges nyomtatás",
// "Pageviews" => "Pageviews",
// "No result indicated" => "No result indicated",
// "Invalid or unknown username" => "Invalid or unknown username",
// "Unable to send mail. User has not configured email" => "Unable to send mail. User has not configured email",
// "Please provide a username or email" => "Please provide a username or email",
// "Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password" => "Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password",
// "A password reminder email has been sent " => "A password reminder email has been sent ",
// "An email with a link to reset your password has been sent " => "An email with a link to reset your password has been sent ",
// "to the email" => "to the email",
// "to the registered email address for" => "to the registered email address for",
// "Non-existent version" => "Non-existent version",
// "Tiki RSS Feed Error Message: %0" => "Tiki RSS Feed Error Message: %0",
// "This match was not case sensitive" => "This match was not case sensitive",
// "No items selected" => "No items selected",
// "Page cannot be found: " => "Page cannot be found: ",
// "Page has changed since preview: " => "Page has changed since preview: ",
// "Page not updated due to error in replacing: " => "Page not updated due to error in replacing: ",
// "Page updated: " => "Page updated: ",
// "Search Stats" => "Search Stats",
// "%0: Results for \"%1\"" => "%0: Results for \"%1\"",
// "Searchindex" => "Searchindex",
// "A problem occurred during file uploading" => "A problem occurred during file uploading",
// "File which was causing trouble was at rank" => "File which was causing trouble was at rank",
// "The error was" => "The error was",
// "Error: You can't send the same newsletter by refreshing this frame content" => "Error: You can't send the same newsletter by refreshing this frame content",
// "Newsletter successfully sent to %s users" => "Newsletter successfully sent to %s users",
// "There was %s errors" => "There was %s errors",
"No newsletters available" => "Nincs elérhető hírlevél",
// "Cannot login to server maybe the server is down" => "Cannot login to server maybe the server is down",
// "successfully sent" => "successfully sent",
// "not sent" => "not sent",
// "Error: " => "Error: ",
"Send Pages" => "Oldal küldése",
// "Notice: this variable may not be empty" => "Notice: this variable may not be empty",
// "Notice: invalid variable value" => "Notice: invalid variable value",
// "Report to the webmaster" => "Report to the webmaster",
// "Token called" => "Token called",
// "Error sending tweet" => "Error sending tweet",
// "Your link was sent" => "Your link was sent",
// "Your email is mandatory" => "Your email is mandatory",
// "Error sending mail to" => "Error sending mail to",
// "Permission to post in forum denied" => "Permission to post in forum denied",
// "No text given for tweet" => "No text given for tweet",
// "Spreadsheet - " => "Spreadsheet - ",
// "Are you sure you want to delete this spreadsheet" => "Are you sure you want to delete this spreadsheet",
// "You do not have permission to edit messages %0" => "You do not have permission to edit messages %0",
// "Permission denied. You cannot view this page" => "Permission denied. You cannot view this page",
// "Updating Theme.." => "Updating Theme..",
// "Update slideshow theme" => "Update slideshow theme",
"Page must be defined inside a structure to use this feature" => "Az oldalt egy struktúrán belül kell elhelyezni ahhoz hogy ezt a funkció használni lehessen",
// "Username and email are mandatory" => "Username and email are mandatory",
// "Email is invalid" => "Email is invalid",
// "Clean the sql logs" => "Clean the sql logs",
// "Are you sure you want to clear all statistics and data for this survey" => "Are you sure you want to clear all statistics and data for this survey",
"You cannot take this quiz twice" => "Ezt a kvízt nem lehet kétszer kitölteni!",
// "Quiz time limit exceeded quiz cannot be computed" => "Quiz time limit exceeded quiz cannot be computed",
// "You cannot take this survey twice" => "You cannot take this survey twice",
"Please create a category first" => "Előbb létre kell hozni egy kategóriát",
// "Committing.." => "Committing..",
// "Could not save" => "Could not save",
// "No trackerId specified" => "No trackerId specified",
// "Incorrect file gallery" => "Incorrect file gallery",
// "You must lock the file before editing it" => "You must lock the file before editing it",
// "Error processing zipped image package" => "Error processing zipped image package",
// "No permission to upload zipped image packages" => "No permission to upload zipped image packages",
// "The uploaded file ist not recognized as a image" => "The uploaded file ist not recognized as a image",
// "You do not have permission to upload images" => "You do not have permission to upload images",
// "You have permission to upload images but not to this gallery" => "You have permission to upload images but not to this gallery",
// "Cannot get image from URL" => "Cannot get image from URL",
// "That is not an image (or you have php < 4.0.5)" => "That is not an image (or you have php < 4.0.5)",
// "Usage" => "Usage",
"TOP" => "Forrás",
// "No url indicated" => "No url indicated",
"Unknown user" => "Ismeretlen felhasználó",
"Password has been changed" => "A jelszó megváltoztatásra került",
// "Invalid password. Your current password is required to change administrative information" => "Invalid password. Your current password is required to change administrative information",
"Email is set to %s" => "E-mail beállítva: %s",
"The passwords did not match" => "A jelszavak nem egyeznek",
// "If you really want to delete your account, you must check the checkbox" => "If you really want to delete your account, you must check the checkbox",
// "unicode" => "unicode",
// "was moved into trash" => "was moved into trash",
// "trashed by" => "trashed by",
// "open / in process" => "open / in process",
// "Rights by creator" => "Rights by creator",
// "END" => "END",
// "Percentage" => "Percentage",
// "Task accepted by creator" => "Task accepted by creator",
// "Task accepted by task user" => "Task accepted by task user",
// "Task NOT accepted by creator" => "Task NOT accepted by creator",
// "Task NOT accepted by task user" => "Task NOT accepted by task user",
// "Sorry this task does not exist or you have no rights to view this task" => "Sorry this task does not exist or you have no rights to view this task",
// "Task entries" => "Task entries",
// "Changes" => "Changes",
// "Info message" => "Info message",
// "NEW Task" => "NEW Task",
// "Sorry you are not allowed to send tasks to other users, or the user is not allowed to receive tasks" => "Sorry you are not allowed to send tasks to other users, or the user is not allowed to receive tasks",
// "Changes on Task" => "Changes on Task",
// "You received a new task" => "You received a new task",
// "The priority is" => "The priority is",
// "very low" => "very low",
// "high" => "high",
// "very high" => "very high",
// "You've to start your work at least on" => "You've to start your work at least on",
// "You've to finish your work on" => "You've to finish your work on",
// "Login and click the link below" => "Login and click the link below",
// "Please read the task and work on it" => "Please read the task and work on it",
// "Sorry, there was an error while trying to write data into the database" => "Sorry, there was an error while trying to write data into the database",
"A new page is created in a language" => "Új oldal jött létre egy adott nyelven",
// "Category change in a language" => "Category change in a language",
// "Remove the notification email" => "Remove the notification email",
// "Language watch" => "Language watch",
// "Category watch: %0, Language: %1" => "Category watch: %0, Language: %1",
// "Cannot upload this file not enough quota" => "Cannot upload this file not enough quota",
"No user indicated" => "Nincs felhasználó feltüntetve",
// "Non-existent user" => "Non-existent user",
"Articles Home" => "Cikk főoldal",
// "No banner indicated" => "No banner indicated",
"No blog indicated" => "Nincs blog feltüntetve",
// "Post not found" => "Post not found",
// "You do not have permission to view this blog post while it is marked as private" => "You do not have permission to view this blog post while it is marked as private",
"No cache information available" => "Nincs cache-információ",
// "You must suggest a question; please try again" => "You must suggest a question; please try again",
// "No faq indicated" => "No faq indicated",
// "You are not permitted to remove someone else's post" => "You are not permitted to remove someone else's post",
// "Incorrect thread" => "Incorrect thread",
"No thread indicated" => "Nincs fórumtéma feltüntetve",
// "Files are read only at this time" => "Files are read only at this time",
// "Are you sure you want to clone this spreadsheet" => "Are you sure you want to clone this spreadsheet",
// "Clone Error" => "Clone Error",
// "Are you sure you want to rollback this spreadsheet" => "Are you sure you want to rollback this spreadsheet",
// "Rollback Error" => "Rollback Error",
// "Tracker Added To Spreadsheet" => "Tracker Added To Spreadsheet",
// "Tracker Removed From Spreadsheet" => "Tracker Removed From Spreadsheet",
// "Spreadsheet added" => "Spreadsheet added",
// "Spreadsheet removed" => "Spreadsheet removed",
// "File removed" => "File removed",
// "Spreadsheet truncated" => "Spreadsheet truncated",
// "Create tracker item" => "Create tracker item",
// "Are you sure you want to remove this attachment" => "Are you sure you want to remove this attachment",
"Edit/Delete" => "Szerkesztés / Törlés",
// "You don't have a personal tracker item yet. Click here to make one" => "You don't have a personal tracker item yet. Click here to make one",
// "That tracker don't use extras" => "That tracker don't use extras",
// "Tiki WebDAV access" => "Tiki WebDAV access",
// "You do not have permission to admin the requested webmail account" => "You do not have permission to admin the requested webmail account",
// "You do not have permission to use the requested webmail account" => "You do not have permission to use the requested webmail account",
// "You no longer have permission to use your active webmail account" => "You no longer have permission to use your active webmail account",
// "There was a problem connecting to that account" => "There was a problem connecting to that account",
// "There was a problem deleting that mail" => "There was a problem deleting that mail",
// "Mail ID" => "Mail ID",
// "There was a problem while trying to delete these mails" => "There was a problem while trying to delete these mails",
// "There was a problem while trying to delete that mail" => "There was a problem while trying to delete that mail",
// "Are you sure you want to delete this account" => "Are you sure you want to delete this account",
// "Taking" => "Taking",
// "Putting back" => "Putting back",
// "Checking" => "Checking",
// "Aborted" => "Aborted",
"Top pages" => "Leglátogatottabb oldalak",
"Last pages" => "Legutóbbi oldalak",
// "Plugin modified by editor" => "Plugin modified by editor",
// "Tidy Extension not present" => "Tidy Extension not present",
// "The TikiTests Replay File is Empty" => "The TikiTests Replay File is Empty",
// "The TikiTests Replay File has an error" => "The TikiTests Replay File has an error",
// "You are about to delete a TikiTest file, do you want to continue " => "You are about to delete a TikiTest file, do you want to continue ",
// "Error deleting the file" => "Error deleting the file",
// "TikiTest List" => "TikiTest List",
// "TikiTest Record" => "TikiTest Record",
// "You need one of the extension pecl HTTP or Curl to replay the TikiTest" => "You need one of the extension pecl HTTP or Curl to replay the TikiTest",
// "The TikiTest Replay File is Empty" => "The TikiTest Replay File is Empty",
// "TikiTest Replay" => "TikiTest Replay",
// "The page is empty" => "The page is empty",
"You do not have permissions to view the maps" => "Nincs elegendő jogosultság a térképek megtekintéséhez",
);
