<?php
// (c) Copyright 2002-2012 by authors of the Tiki Wiki CMS Groupware Project
// 
// All Rights Reserved. See copyright.txt for details and a complete list of authors.
// Licensed under the GNU LESSER GENERAL PUBLIC LICENSE. See license.txt for details.

// Note for translators about translation of text ending with punctuation
// 
// The current list of concerned punctuation can be found in 'lib/init/tra.php'
// On 2009-03-02, it is: (':', '!', ';', '.', ',', '?')
// For clarity, we explain here only for colons: ':' but it is the same for the rest
// 
// Short version: it is not a problem that string "Login:" has no translation. Only "Login" needs to be translated.
// 
// Technical justification:
// If a string ending with colon needs translating (like "{tr}Login:{/tr}")
// then Tiki tries to translate 'Login' and ':' separately.
// This allows to have only one translation for "{tr}Login{/tr}" and "{tr}Login:{/tr}"
// and it still allows to translate ":" as " :" for languages that
// need it (like French)
// Note: the difference is invisible but " :" has an UTF-8 non-breaking-space, not a regular space, but the UTF-8 equivalent of the HTML &nbsp;.
// This allows correctly displaying emails and JavaScript messages, not only web pages as would happen with &nbsp;.

$lang = array(
"You must specify a directory" => "Você deve especificar um diretório",
"Creation Date" => "Data de criação",
"Name" => "Nome",
"Last modification date" => "Data da última modificação",
"Hits" => "Visitas",
"Owner" => "Dono",
"Description" => "Descrição",
"ID" => "ID",
// "moved %d images, %d errors occurred" => "moved %d images, %d errors occurred",
// "a timeout occurred. Hit the reload button to move the rest" => "a timeout occurred. Hit the reload button to move the rest",
"Detected, Version:" => "Versão detectada:",
// "Test Image" => "Test Image",
"Not detected." => "Não detectada.",
"Unknown" => "Desconhecido",
// "Tiki Email Test" => "Tiki Email Test",
// "Tiki Test email from" => "Tiki Test email from",
"Unable to send mail" => "Não foi possível enviar o e-mail",
"Test mail sent to" => "E-mail de test enviado para",
// "%d user-group assignments" => "%d user-group assignments",
"None" => "Nenhum",
"All Fields except gdaltindex must be filled" => "Todos os campos exceto gdaltindex devem ser preenchidos",
// "Path to mapfiles is invalid" => "Path to mapfiles is invalid",
"No valid gdaltindex executable" => "Executável gdaltindex não é válido",
"No valid ogr2ogr executable" => "Executável ogr2ogr não é válido",
"New configuration created (id %0)" => "Nova configuração criada (id %0)",
"Configuration updated" => "Configuração atualizada",
"You must set a home file gallery" => "Você deve definir uma galeria de arquivos principal",
"Tag already exists" => "O tag já existe",
"Tag not found" => "Tag não encontrado",
"Welsh" => "Galês",
"Slovene" => "Esloveno",
"Arabic" => "Arábico",
"Bulgarian" => "Búlgaro",
"Catalan" => "Catalão",
"Simplified Chinese" => "Chinês Simplificado",
"Czech" => "Theco",
"Danish" => "Holandês",
"German" => "Alemão",
"English" => "Inglês",
"English British" => "Inglês Britânico",
"Spanish" => "Espanhol",
"Greek" => "Grego",
"Farsi" => "Persa",
"Finnish" => "Finlandês",
// "Fijian" => "Fijian",
"French" => "Francês",
// "Frisian Netherlands" => "Frisian Netherlands",
"Galician" => "Galego",
"Hebrew" => "Hebreu",
"Croatian" => "Croata",
// "Indonesian" => "Indonesian",
// "Icelandic" => "Icelandic",
"Italian" => "Italiano",
// "Inuktitut" => "Inuktitut",
"Japanese" => "Japonês",
"Korean" => "Coreano",
"Hungarian" => "Hungaro",
// "Lithuanian" => "Lithuanian",
// "Low German" => "Low German",
"Dutch" => "Dinamarquês",
"Norwegian" => "Norueguês",
"Polish" => "Polonês",
"Portuguese" => "Português",
"Brazilian Portuguese" => "Português do Brasil",
"Romanian" => "Romeno",
// "Romansh" => "Romansh",
"Russian" => "Russo",
"Pijin Solomon" => "Salomão de Pijin",
// "Sinhala" => "Sinhala",
"Slovak" => "Eslovaco",
// "Albanian" => "Albanian",
"Serbian Latin" => "Latim Sérvio",
"Swedish" => "Sueco",
"Tuvaluan" => "Tuvaluano",
"Turkish" => "Turco",
"Traditional Chinese" => "Chinês Tradicional",
"Ukrainian" => "Ucraniano",
"Vietnamese" => "Vietnamita",
"Afghanistan" => "Afeganistão",
// "Aland Islands" => "Aland Islands",
// "Aland_Islands" => "Aland_Islands",
"Albania" => "Albania",
"Algeria" => "Algeria",
"American Samoa" => "Samoa  Americana",
// "American_Samoa" => "American_Samoa",
// "Andorra" => "Andorra",
"Angola" => "Angola",
// "Anguilla" => "Anguilla",
"Antigua" => "Antigua",
"Argentina" => "Argentina",
"Armenia" => "Arménia",
// "Aruba" => "Aruba",
"Australia" => "Austrália",
"Austria" => "Áustria",
// "Azerbaijan" => "Azerbaijan",
"Bahamas" => "Bahamas",
"Bahrain" => "Barém",
"Bangladesh" => "Bangladesh",
"Barbados" => "Barbados",
"Belarus" => "Bielorrúsia",
"Belgium" => "Bélgica",
// "Belize" => "Belize",
// "Benin" => "Benin",
"Bermuda" => "Bermuda",
// "Bhutan" => "Bhutan",
"Bolivia" => "Bolívia",
// "Bosnia and Herzegovina" => "Bosnia and Herzegovina",
// "Bosnia_and_Herzegovina" => "Bosnia_and_Herzegovina",
// "Botswana" => "Botswana",
// "Bouvet Island" => "Bouvet Island",
// "Bouvet_Island" => "Bouvet_Island",
"Brazil" => "Brasil",
// "British Indian Ocean Territory" => "British Indian Ocean Territory",
// "British Virgin Islands" => "British Virgin Islands",
// "British_Indian_Ocean_Territory" => "British_Indian_Ocean_Territory",
// "British_Virgin_Islands" => "British_Virgin_Islands",
"Brunei" => "Brunei",
// "Bulgaria" => "Bulgaria",
// "Burkina Faso" => "Burkina Faso",
// "Burkina_Faso" => "Burkina_Faso",
// "Burundi" => "Burundi",
// "Cambodia" => "Cambodia",
"Cameroon" => "Camarões",
"Canada" => "Canadá",
// "Cape Verde" => "Cape Verde",
// "Cape_Verde" => "Cape_Verde",
// "Catalan Countries" => "Catalan Countries",
// "Catalan_Countries" => "Catalan_Countries",
"Cayman Islands" => "Ilhas  Cayman",
// "Cayman_Islands" => "Cayman_Islands",
// "Central African Republic" => "Central African Republic",
// "Central_African_Republic" => "Central_African_Republic",
// "Chad" => "Chad",
"Chile" => "Chile",
"China" => "China",
// "Christmas Island" => "Christmas Island",
// "Christmas_Island" => "Christmas_Island",
// "Cocos Islands" => "Cocos Islands",
// "Cocos_Islands" => "Cocos_Islands",
"Colombia" => "Colômbia",
// "Comoros" => "Comoros",
// "Congo Democratic" => "Congo Democratic",
"Congo" => "Congo",
// "Congo_Democratic" => "Congo_Democratic",
"Cook Islands" => "Ilhas Cook",
// "Cook_Islands" => "Cook_Islands",
"Costa Rica" => "Costa Rica",
// "Costa_Rica" => "Costa_Rica",
"Croatia" => "Croácia",
"Cuba" => "Cuba",
"Cyprus" => "Chipre",
"Czech Republic" => "República Tcheca",
// "Czech_Republic" => "Czech_Republic",
"Denmark" => "Dinamarca",
// "Djibouti" => "Djibouti",
// "Dominica" => "Dominica",
"Dominican Republic" => "Republica Dominicana",
// "Dominican_Republic" => "Dominican_Republic",
"Ecuador" => "Equador",
"Egypt" => "Egito",
"El Salvador" => "El Salvador",
// "El_Salvador" => "El_Salvador",
// "Equatorial Guinea" => "Equatorial Guinea",
// "Equatorial_Guinea" => "Equatorial_Guinea",
// "Eritrea" => "Eritrea",
"Estonia" => "Estónia",
"Ethiopia" => "Etiópia",
"Europe" => "Europa",
// "Falkland Islands" => "Falkland Islands",
// "Falkland_Islands" => "Falkland_Islands",
// "Faroe Islands" => "Faroe Islands",
// "Faroe_Islands" => "Faroe_Islands",
"Federated States of Micronesia" => "Estados Federados da Micronésia",
// "Federated_States_of_Micronesia" => "Federated_States_of_Micronesia",
"Fiji" => "Fiji",
"Finland" => "Finlândia",
"France" => "França",
"French Guiana" => "Guiana Francesa",
"French Polynesia" => "Polinésia Francesa",
// "French Southern Territories" => "French Southern Territories",
// "French_Guiana" => "French_Guiana",
// "French_Polynesia" => "French_Polynesia",
// "French_Southern_Territories" => "French_Southern_Territories",
// "Gabon" => "Gabon",
// "Gambia" => "Gambia",
// "Georgia" => "Georgia",
"Germany" => "Alemanha",
// "Ghana" => "Ghana",
// "Gibraltar" => "Gibraltar",
"Greece" => "Grécia",
"Greenland" => "Groelândia",
// "Grenada" => "Grenada",
// "Guadeloupe" => "Guadeloupe",
"Guam" => "Guam",
"Guatemala" => "Guatemala",
// "Guernsey" => "Guernsey",
"Guinea Bissau" => "Guiné Bissao",
"Guinea" => "Guiné",
// "Guinea_Bissau" => "Guinea_Bissau",
"Guyana" => "Guiana",
"Haiti" => "Haiti",
// "Heard Island and McDonald Islands" => "Heard Island and McDonald Islands",
// "Heard_Island_and_McDonald_Islands" => "Heard_Island_and_McDonald_Islands",
"Honduras" => "Honduras",
"Hong Kong" => "Hong Kong",
// "Hong_Kong" => "Hong_Kong",
"Hungary" => "Hungria",
"Iceland" => "Islândia",
"India" => "Índia",
"Indonesia" => "Indonésia",
"Iran" => "Irã",
"Iraq" => "Iraq",
"Ireland" => "Ireland",
// "Isle of Man" => "Isle of Man",
"Israel" => "Israel",
"Italy" => "Italia",
"Ivory Coast" => "Costa do Marfim",
// "Ivory_Coast" => "Ivory_Coast",
"Jamaica" => "Jamaica",
"Japan" => "Japão",
// "Jersey" => "Jersey",
"Jordan" => "Jordânia",
"Kazakstan" => "Cazaquistão",
"Kenya" => "Quênia",
// "Kiribati" => "Kiribati",
"Kuwait" => "Kuwait",
// "Kyrgyzstan" => "Kyrgyzstan",
// "Laos" => "Laos",
"Latvia" => "Letônia",
"Lebanon" => "Líbano",
// "Lesotho" => "Lesotho",
// "Liberia" => "Liberia",
// "Libya" => "Libya",
// "Liechtenstein" => "Liechtenstein",
"Lithuania" => "Lituânia",
"Luxemburg" => "Luxemburgo",
// "Macao" => "Macao",
"Macedonia" => "Macedônia",
// "Madagascar" => "Madagascar",
// "Malawi" => "Malawi",
"Malaysia" => "Malásia",
// "Maldives" => "Maldives",
// "Mali" => "Mali",
"Malta" => "Malta",
"Marshall Islands" => "Ilhas Marshall",
// "Marshall_Islands" => "Marshall_Islands",
// "Martinique" => "Martinique",
// "Mauritania" => "Mauritania",
"Mauritius" => "Mauricius",
// "Mayotte" => "Mayotte",
"Mexico" => "México",
// "Moldova" => "Moldova",
"Monaco" => "Mônaco",
"Mongolia" => "Mongólia",
// "Montenegro" => "Montenegro",
// "Montserrat" => "Montserrat",
"Morocco" => "Marrócos",
"Mozambique" => "Moçambique",
// "Myanmar" => "Myanmar",
// "Namibia" => "Namibia",
// "Nauru" => "Nauru",
"Nepal" => "Nepal",
// "Netherlands Antilles" => "Netherlands Antilles",
"Netherlands" => "Holanda",
// "Netherlands_Antilles" => "Netherlands_Antilles",
"New Caledonia" => "Nova Caledonia",
"New Zealand" => "Nova Zelândia",
// "New_Caledonia" => "New_Caledonia",
// "New_Zealand" => "New_Zealand",
"Nicaragua" => "Nicarágua",
"Niger" => "Níger",
"Nigeria" => "Nigéria",
// "Niue" => "Niue",
// "Norfolk Island" => "Norfolk Island",
// "Norfolk_Island" => "Norfolk_Island",
// "North Korea" => "North Korea",
// "North_Korea" => "North_Korea",
// "Northern Mariana Islands" => "Northern Mariana Islands",
// "Northern_Mariana_Islands" => "Northern_Mariana_Islands",
"Norway" => "Noruéga",
// "Oman" => "Oman",
"Other" => "Outro",
"Pakistan" => "Paquistão",
// "Palau" => "Palau",
"Palestine" => "Palestina",
"Panama" => "Panama",
"Papua New Guinea" => "Papua Nova Guiné",
// "Papua_New_Guinea" => "Papua_New_Guinea",
"Paraguay" => "Paraguai",
"Peru" => "Perú",
// "Philippines" => "Philippines",
// "Pitcairn" => "Pitcairn",
"Poland" => "Polonia",
"Portugal" => "Portugal",
"Puerto Rico" => "Porto Rico",
// "Puerto_Rico" => "Puerto_Rico",
"Quatar" => "Quatar",
// "Republic of Macedonia" => "Republic of Macedonia",
// "Republic_of_Macedonia" => "Republic_of_Macedonia",
// "Reunion" => "Reunion",
"Romania" => "Romênia",
"Russia" => "Russia",
// "Russian Federation" => "Russian Federation",
// "Russian_Federation" => "Russian_Federation",
// "Rwanda" => "Rwanda",
// "Saint Helena" => "Saint Helena",
// "Saint Kitts and Nevis" => "Saint Kitts and Nevis",
// "Saint Lucia" => "Saint Lucia",
// "Saint Pierre and Miquelon" => "Saint Pierre and Miquelon",
// "Saint_Helena" => "Saint_Helena",
// "Saint_Kitts_and_Nevis" => "Saint_Kitts_and_Nevis",
// "Saint_Lucia" => "Saint_Lucia",
// "Saint_Pierre_and_Miquelon" => "Saint_Pierre_and_Miquelon",
"Samoa" => "Samoa",
// "San Marino" => "San Marino",
// "San_Marino" => "San_Marino",
// "Sao Tome and Principe" => "Sao Tome and Principe",
// "Sao_Tome_and_Principe" => "Sao_Tome_and_Principe",
"Saudi Arabia" => "Arábia Saudita",
// "Saudi_Arabia" => "Saudi_Arabia",
// "Senegal" => "Senegal",
// "Serbia" => "Serbia",
// "Seychelles" => "Seychelles",
// "Sierra Leone" => "Sierra Leone",
// "Sierra_Leone" => "Sierra_Leone",
"Singapore" => "Singapura",
"Slovakia" => "Slovakia",
"Slovenia" => "Slovenia",
"Solomon Islands" => "Ilhas Salomão",
// "Solomon_Islands" => "Solomon_Islands",
"Somalia" => "Somália",
"South Africa" => "África do Sul",
// "South Georgia and South Sandwich Islands" => "South Georgia and South Sandwich Islands",
"South Korea" => "Coréia do Sul",
// "South_Africa" => "South_Africa",
// "South_Georgia_and_South_Sandwich_Islands" => "South_Georgia_and_South_Sandwich_Islands",
// "South_Korea" => "South_Korea",
"Spain" => "Espanha",
"Sri Lanka" => "Sri Lanka",
// "Sri_Lanka" => "Sri_Lanka",
"St Vincent Grenadines" => "São Vicente e Granadinas",
// "St_Vincent_Grenadines" => "St_Vincent_Grenadines",
"Sudan" => "Sudão",
"Surinam" => "Suriname",
// "Svalbard and Jan Mayen" => "Svalbard and Jan Mayen",
// "Svalbard_and_Jan_Mayen" => "Svalbard_and_Jan_Mayen",
// "Swaziland" => "Swaziland",
"Sweden" => "Suécia",
"Switzerland" => "Suíça",
// "Syria" => "Syria",
"Taiwan" => "Taiwan",
// "Tajikistan" => "Tajikistan",
// "Tanzania" => "Tanzania",
"Thailand" => "Tailândia",
// "Timor-Leste" => "Timor-Leste",
// "Togo" => "Togo",
// "Tokelau" => "Tokelau",
"Tonga" => "Tonga",
"Trinidad Tobago" => "Trinidá e Tobago",
// "Trinidad_Tobago" => "Trinidad_Tobago",
"Tunisia" => "Tunísia",
"Turkey" => "Turquía",
// "Turkmenistan" => "Turkmenistan",
// "Turks and Caicos Islands" => "Turks and Caicos Islands",
// "Turks_and_Caicos_Islands" => "Turks_and_Caicos_Islands",
// "Tuvalu" => "Tuvalu",
// "US Virgin Islands" => "US Virgin Islands",
// "US_Virgin_Islands" => "US_Virgin_Islands",
// "Uganda" => "Uganda",
"Ukraine" => "Ucrânia",
"United Arab Emirates" => "Emirados Árabes Unidos",
"United Kingdom" => "Reino Unido",
// "United Nations Organization" => "United Nations Organization",
// "United States Minor Outlying Islands" => "United States Minor Outlying Islands",
"United States" => "Estados Unidos",
// "United_Arab_Emirates" => "United_Arab_Emirates",
// "United_Kingdom" => "United_Kingdom",
// "United_Kingdom_-_England_and_Wales" => "United_Kingdom_-_England_and_Wales",
// "United_Kingdom_-_Northern_Ireland" => "United_Kingdom_-_Northern_Ireland",
// "United_Kingdom_-_Scotland" => "United_Kingdom_-_Scotland",
// "United_Nations_Organization" => "United_Nations_Organization",
// "United_States" => "United_States",
// "United_States_Minor_Outlying_Islands" => "United_States_Minor_Outlying_Islands",
"Uruguay" => "Uruguai",
// "Uzbekistan" => "Uzbekistan",
// "Vanuatu" => "Vanuatu",
"Vatican" => "Vaticano",
"Venezuela" => "Venezuela",
// "Viet Nam" => "Viet Nam",
// "Viet_Nam" => "Viet_Nam",
"Wales" => "País de Gales",
// "Wallis and Futuna" => "Wallis and Futuna",
// "Wallis_and_Futuna" => "Wallis_and_Futuna",
// "Western Sahara" => "Western Sahara",
// "Western_Sahara" => "Western_Sahara",
// "World" => "World",
// "Yemen" => "Yemen",
"Yugoslavia" => "Iugoslávia",
"Zambia" => "Zambia",
"Zimbabwe" => "Zimbábue",
// "the former Yugoslav Republic of Macedonia" => "the former Yugoslav Republic of Macedonia",
// "the_former_Yugoslav_Republic_of_Macedonia" => "the_former_Yugoslav_Republic_of_Macedonia",
"Re:" => "Re:",
"This forum is flat and doesn't allow replies to other replies" => "Esse fórum não permite respostas às respostas",
"Copyright management" => "Gereciamento de copyright",
"No page indicated" => "Nenhuma página indicada",
"You must supply all the information, including title and year." => "Você precisa fornecer toda a informação, incluindo título e ano.",
// "Tiki was unable to retrieve login data from the database " => "Tiki was unable to retrieve login data from the database ",
"The following error message was returned" => "O sistema retornou a seguinte mensagem de erro",
// "Things to check" => "Things to check",
// "Are your database login credentials correct" => "Are your database login credentials correct",
// "Did you complete the <a href='tiki-install.php' >Tiki Installer" => "Did you complete the <a href='tiki-install.php' >Tiki Installer",
// "Please see <a href=\"http://doc.tiki.org/\">the documentation</a> for more information" => "Please see <a href=\"http://doc.tiki.org/\">the documentation</a> for more information",
"You do not have permission to use this feature" => "Permissão negada para usar este recurso.",
"This feature is for admins only" => "Este recurso é apenas para administradores",
"Type" => "Tipo",
"Size" => "Tamanho",
"Created" => "Criado em",
"Uploaded" => "Enviado",
"Last Modified" => "Última Modificação",
"Uploaded by" => "Enviado por",
"Creator" => "Criador",
"Last Modified by" => "Última modificação por",
"Comment" => "Comentário",
"Files" => "Arquivos",
"Last download" => "Último download",
"Locked by" => "Travado por",
"Backlinks" => "Referências",
// "Delete After" => "Delete After",
// "Share with" => "Share with",
"Source" => "Fonte",
// "Explorer" => "Explorer",
"Path" => "Caminho",
"Slideshow" => "Slideshow",
"Default View" => "Visão padrão",
// "Gallery Icon" => "Gallery Icon",
"Register" => "Registrar-se",
"Tiki Installer" => "Instalador do Tiki",
"MySQL Improved (mysqli)" => "MySQL Improved (mysqli)",
"MySQL classic (mysql)" => "MySQL clássico (mysql)",
"Email address not valid, test mail not sent" => "Endereço de e-mail inválido, e-mail de teste não enviado",
// "Email address empty and \"copy\" checkbox not set, test mail not sent" => "Email address empty and \"copy\" checkbox not set, test mail not sent",
"Test mail from Tiki installer %0" => "Email de test do Tiki versão %0",
"Tiki version" => "Versão do Tiki",
"PHP version" => "Versão do PHP",
"Server" => "Servidor",
"Sent" => "Enviado",
// "Some invalid characters were detected in database name. Please use alphanumeric characters or _ or -" => "Some invalid characters were detected in database name. Please use alphanumeric characters or _ or -",
// "Database `%0` was created" => "Database `%0` was created",
// "Database `%0` creation failed. You need to create the database" => "Database `%0` creation failed. You need to create the database",
"No database name specified" => "Nenhuma base de dados especificada",
"Congratulations!\n\nYour server can send emails.\n\n" => "Parabéns!\n\nSeu servidor pode enviar e-mails.\n\n",
// "No automated tax" => "No automated tax",
// "Account name must not be empty" => "Account name must not be empty",
// "Budget is not a valid amount: " => "Budget is not a valid amount: ",
// "Locked must be either 0 or 1" => "Locked must be either 0 or 1",
// "Error creating account" => "Error creating account",
// "AccountId %0 is already in use and must not be changed. Please disable it if it is no longer needed" => "AccountId %0 is already in use and must not be changed. Please disable it if it is no longer needed",
// "Error updating account" => "Error updating account",
// "Account is already in use and must not be deleted. Please disable it, if it is no longer needed" => "Account is already in use and must not be deleted. Please disable it, if it is no longer needed",
// "Rollback failed, inconsistent database: Cleanup needed for journalId %0 in book %1" => "Rollback failed, inconsistent database: Cleanup needed for journalId %0 in book %1",
// "successfully rolled back #" => "successfully rolled back #",
// "Booking error creating journal entry" => "Booking error creating journal entry",
// "Booking error creating debit entry" => "Booking error creating debit entry",
// "Booking error creating credit entry" => "Booking error creating credit entry",
// "Number of debit entries differ: " => "Number of debit entries differ: ",
// "Number of credit entries differ: " => "Number of credit entries differ: ",
// "Splitting is only allowed on one side" => "Splitting is only allowed on one side",
// "Invalid debit amount " => "Invalid debit amount ",
// "Invalid debit account number " => "Invalid debit account number ",
// "Invalid credit amount " => "Invalid credit amount ",
// "Invalid credit account number " => "Invalid credit account number ",
// "Difference between debit and credit amounts " => "Difference between debit and credit amounts ",
// "Rollback failed, inconsistent database: Cleanup needed for stackId %0 in book %1" => "Rollback failed, inconsistent database: Cleanup needed for stackId %0 in book %1",
// "Booking error creating stack entry" => "Booking error creating stack entry",
// "Booking error creating stack debit entry" => "Booking error creating stack debit entry",
// "Booking error creating stack credit entry" => "Booking error creating stack credit entry",
// "Error deleting entry from stack" => "Error deleting entry from stack",
// "Booking error confirming stack entry" => "Booking error confirming stack entry",
// "Booking error cconfirming stack entry" => "Booking error cconfirming stack entry",
// "Error while updating statement" => "Error while updating statement",
// "is is not a number" => "is is not a number",
// "must be > 0" => "must be > 0",
// "Invalid transaction - please contact administrator" => "Invalid transaction - please contact administrator",
// "Error checking" => "Error checking",
// "does not exist" => "does not exist",
// "already exists" => "already exists",
// "This book has been closed. You can't create new accounts" => "This book has been closed. You can't create new accounts",
// "This book has been closed. You can't modify the account" => "This book has been closed. You can't modify the account",
// "This book has been closed. You can't delete the account" => "This book has been closed. You can't delete the account",
// "The date for the transaction is before this books start date" => "The date for the transaction is before this books start date",
// "The date for the transaction is after this books end date" => "The date for the transaction is after this books end date",
// "This book has been closed. You can't book into it any more" => "This book has been closed. You can't book into it any more",
// "Invalid booking date" => "Invalid booking date",
// "This book has been closed. You can't cancel transactions in it any more" => "This book has been closed. You can't cancel transactions in it any more",
// "New article post" => "New article post",
// "Edited article post" => "Edited article post",
// "Deleted article post" => "Deleted article post",
"The file is not a CSV file or has not a correct syntax" => "O arquivo não é um arquivo CSV ou não possui o formato correto",
"Error line: %d" => "Linha do erro: %d",
// "Spam is not welcome here" => "Spam is not welcome here",
"anonymous" => "anônimo",
"Blog cannot be found" => "Blog não foi encontrado",
"locked" => "travada",
"locked by" => "travado por",
"refresh" => "atualizar",
// "go back to this crumb" => "go back to this crumb",
"Administration:" => "Administração:",
"All day" => "Dia inteiro",
"First day of week: Sunday (its ID is 0) - translators you need to localize this string!" => "Primeiro dia da semana: Domingo (o ID é 0)",
"Sunday" => "Domingo",
"Su" => "Do",
"Monday" => "Segunda-feira",
"Tuesday" => "Terça-feira",
"Wednesday" => "Quarta-feira",
"Thursday" => "Quinta-feira",
"Friday" => "Sexta-feira",
"Saturday" => "Sábado",
"Mo" => "Se",
"Tu" => "Te",
"We" => "Qa",
"Th" => "Qi",
"Fr" => "Se",
"Sa" => "Sa",
"in" => "em",
"continued" => "continuação",
"New Image Uploaded by" => "Nova imagem carregada por",
"New Subscriptions" => "Nova assinatura",
"New Item in Tracker" => "Novo item no formulário",
"tracker" => "formulário",
"by" => "por",
"Wiki" => "Wiki",
"Image Gallery" => "Imagem da galeria",
"Articles" => "Artigos",
"Blogs" => "Blogs",
"Forums" => "Fóruns",
"Directory" => "Diretórios",
"File Gallery" => "Galeria de arquivos",
"FAQs" => "FAQs",
"Quizzes" => "Testes",
"Trackers" => "Formulários",
"Survey" => "Pesquisa",
"Newsletter" => "Comunicado",
"Empty captcha value" => "Valor vazio para o captcha",
"You have mistyped the anti-bot verification code. Please try again" => "Você digitou incorretamente o valor do anti-bot. Por favor tente de novo",
// "Failed to validate captcha" => "Failed to validate captcha",
// "Captcha ID field is missing" => "Captcha ID field is missing",
"Get a visual challenge" => "CAPTCHA visual",
"Get an audio challenge" => "CAPTCHA sonoro",
"Get a new challenge" => "Gerar novo CAPTCHA",
"Type the two words" => "Digite as duas palavras",
"Type what you hear" => "Digite o que você escuta",
"Help" => "Ajuda",
"Play sound again" => "Tocar novamente",
"Download sound as MP3" => "Baixar áudio como MP3",
"Incorrect. Try again" => "Incorreto. Tente de novo",
"A category named %0 already exists in %1" => "Uma categoria chamada %0 já existe em %1",
"article" => "artigo",
"blog" => "blog",
"directory" => "diretório",
"faq" => "faq",
"file gallery" => "galeria de arquivos",
"forum" => "fórum",
"image gallery" => "galeria de imagens",
"newsletter" => "comunicado",
"poll" => "enquete",
"quiz" => "teste",
"survey" => "pesquisa",
"wiki page" => "página wiki",
"image" => "imagem",
"calendar" => "calendário",
"Permission denied" => "Permissão negada",
"Invalid filename (using filters for filenames)" => "Nome inválido de arquivo (usando filtros para nomes de arquivos)",
"Cannot upload this file - maximum upload size exceeded" => "Impossível carregar este arquivo: tamanho máximo para arquivo atingido",
"Cannot write to this file" => "Não foi possível escrever neste arquivo",
"(not registered)" => "(não registrado)",
"Anonymous" => "Anônimo",
"Your comment was rejected" => "Seu comentário foi rejeitado",
// "Cannot perform spam check: %0" => "Cannot perform spam check: %0",
"Please wait %0 seconds between posts" => "Por favor espere %0 segundos entre os posts",
"Wrong password. Cannot post comment" => "Senha incorreta. Impossível enviar comentário",
// "A contribution is mandatory" => "A contribution is mandatory",
"You have to enter a title and text" => "Você precisa digitar um título e um texto",
"Invalid Email" => "E-mail inválido",
"Your message has been queued for approval and will be posted after a moderator approves it." => "Sua mensagem está aguardando aprovação. A mensagem será postada após aprovação por um moderador.",
"This forum is locked" => "Esse fórum está travado",
"This thread is locked" => "Essa conversa está travada",
// "This can happen if the page you are linking to has changed since you obtained the forwardlink or if the page is not viewable by the public" => "This can happen if the page you are linking to has changed since you obtained the forwardlink or if the page is not viewable by the public",
// "If you are logged in, try loggin out and then recreate the forwardlink" => "If you are logged in, try loggin out and then recreate the forwardlink",
// "Phrase not found" => "Phrase not found",
"Date" => "Data",
// "Click below to read Citing blocks" => "Click below to read Citing blocks",
// "Apply Profile \"Simple Wiki Attributes\" To Add ForwardLink Questions" => "Apply Profile \"Simple Wiki Attributes\" To Add ForwardLink Questions",
// "Saving.." => "Saving..",
// "Editing: " => "Editing: ",
"OK" => "Ok",
"Cancel" => "Cancelar",
"New" => "Novo",
"Save" => "Salvar",
// "Create ForwardLink" => "Create ForwardLink",
// "Highlight text to be linked" => "Highlight text to be linked",
// "Accept TextLink & ForwardLink" => "Accept TextLink & ForwardLink",
"Ok" => "Ok",
// "You selected" => "You selected",
// "Suggested selection" => "Suggested selection",
// "Copy To Clipboard" => "Copy To Clipboard",
// "TextLink & ForwardLink data copied to your clipboard" => "TextLink & ForwardLink data copied to your clipboard",
"Loading..." => "Carregando...",
// "Edit ForwardLink Questions" => "Edit ForwardLink Questions",
"Edit" => "Editar",
"Delete" => "Apagar",
// "Are you sure" => "Are you sure",
// "Suggestion" => "Suggestion",
// "Please fill in the questions below" => "Please fill in the questions below",
// "Copy This" => "Copy This",
"New File" => "Novo arquivo",
// "%0 near \"%1\"" => "%0 near \"%1\"",
// "Expecting \"(\"" => "Expecting \"(\"",
// "Unexpected \"%0\"" => "Unexpected \"%0\"",
// "Expecting \")\"" => "Expecting \")\"",
// "No formula provided" => "No formula provided",
// "Variable not found \"%0\"" => "Variable not found \"%0\"",
// "Unknown operation \"%0\"" => "Unknown operation \"%0\"",
"All" => "Todos",
// "Count" => "Count",
// "Count By Date" => "Count By Date",
// "Count By Date Filter Id" => "Count By Date Filter Id",
// "Count Users Filter Id" => "Count Users Filter Id",
// "Count Users IP Filter Id" => "Count Users IP Filter Id",
// "Ascending By Date" => "Ascending By Date",
// "Descending By Date" => "Descending By Date",
// "Logs" => "Logs",
"Action" => "Ação",
"Start" => "Início",
"End" => "Fim",
"Fields" => "Campos",
// "Grouping" => "Grouping",
"Sort" => "Ordenar",
// "Limit" => "Limit",
"Tracker" => "Formulário",
// " Join Tracker " => " Join Tracker ",
// " on " => " on ",
// " equals " => " equals ",
// "Item Id" => "Item Id",
"Search" => "Busca",
// " for " => " for ",
"Status" => "Estado",
// "Articles deleted" => "Articles deleted",
// "removed the article" => "removed the article",
// "Edited articles" => "Edited articles",
// "edited the article" => "edited the article",
// "New articles submited" => "New articles submited",
// "created the article" => "created the article",
// "New blog posts" => "New blog posts",
// "replied to the blog" => "replied to the blog",
// "New calendar events" => "New calendar events",
"%0 added or updated event %1" => "%0 adicionou ou atualizou um evento %1",
// "Changes in categories" => "Changes in categories",
// "added the %0 %1 to the category %2" => "added the %0 %1 to the category %2",
// "created the subcategory" => "created the subcategory",
// "removed the subcategory" => "removed the subcategory",
"from" => "de",
// "edited the category" => "edited the category",
// "removed the %0 %1 from the category %2" => "removed the %0 %1 from the category %2",
// "File galleries changed" => "File galleries changed",
// "%0 edited the file gallery %1" => "%0 edited the file gallery %1",
// "%0 uploaded the file %1" => "%0 uploaded the file %1",
// "onto" => "onto",
// "%0 removed the file %1 from %2" => "%0 removed the file %1 from %2",
// "New replies in forum topics" => "New replies in forum topics",
// "%0 <a href=%1>replied</a> to the topic %2" => "%0 <a href=%1>replied</a> to the topic %2",
// "New posts in forums" => "New posts in forums",
// "%0 created the topic %1 at forum %2" => "%0 created the topic %1 at forum %2",
// "Image galleries changed" => "Image galleries changed",
// "changed the picture gallery" => "changed the picture gallery",
// "uploaded the picture" => "uploaded the picture",
// "removed the picture" => "removed the picture",
// "Comments in tracker items" => "Comments in tracker items",
// "%0 added a new comment to %1 on tracker %2" => "%0 added a new comment to %1 on tracker %2",
// "%0 added a new comment to item id %1 on tracker %2" => "%0 added a new comment to item id %1 on tracker %2",
// "Tracker items modified" => "Tracker items modified",
// "%0 added or updated tracker item %1 on tracker %2" => "%0 added or updated tracker item %1 on tracker %2",
// "%0 added or updated tracker item id %1 on tracker %2" => "%0 added or updated tracker item id %1 on tracker %2",
// "New attachments in wiki pages" => "New attachments in wiki pages",
// "%0 uploaded the file %1 onto %2" => "%0 uploaded the file %1 onto %2",
// "Wiki pages updated" => "Wiki pages updated",
// "%0 edited the wikipage %1 (<a href=%2>this history</a>, <a href=%3>all history</a>)" => "%0 edited the wikipage %1 (<a href=%2>this history</a>, <a href=%3>all history</a>)",
// "and %0 more changes of the same type" => "and %0 more changes of the same type",
"Nothing has happened" => "Nada aconteceu",
"Report from %0 (1 change)" => "Notificações de %0 (1 mudança)",
"Report from %0 (%1 changes)" => "Notificações de %0 (%1 mudanças)",
"Report from %0 (no changes)" => "Notificações de %0 (sem mudanças)",
// "%0 (latest)" => "%0 (latest)",
// "No value for '%0'" => "No value for '%0'",
// "Unknown formatting rule '%0' for '%1'" => "Unknown formatting rule '%0' for '%1'",
// "Indexing failed while processing \"%0\" (type %1) with the error \"%2\"" => "Indexing failed while processing \"%0\" (type %1) with the error \"%2\"",
// "filterRange: \"from\" value not parsed" => "filterRange: \"from\" value not parsed",
// "filterRange: \"to\" value not parsed" => "filterRange: \"to\" value not parsed",
"Permission Denied" => "Permissão negada",
// "Invalid data" => "Invalid data",
// "Action not found (%0 in %1)" => "Action not found (%0 in %1)",
// "Controller not found (%0)" => "Controller not found (%0)",
// "Comments not allowed on this page" => "Comments not allowed on this page",
// "Parent is locked" => "Parent is locked",
// "Pseudonym must be specified" => "Pseudonym must be specified",
// "Email must be specified" => "Email must be specified",
"Title is empty" => "O título está vazio",
"Content is empty" => "O conteúdo está vazio",
"Permissions denied" => "Permissões negadas",
"Comment not found" => "Comentário não encontrado",
"Comment already approved" => "Comentário já aprovado",
"Invalid argument" => "Argumento inválido",
// "Thread not specified" => "Thread not specified",
"Feature disabled" => "Recurso desabilitado",
// "Reserved to administrators during development" => "Reserved to administrators during development",
// "Tiki not connected. Please click \"Send Info\" to join in" => "Tiki not connected. Please click \"Send Info\" to join in",
// "Something went wrong. Tiki Connect is still experimental. Please try again" => "Something went wrong. Tiki Connect is still experimental. Please try again",
// "registration" => "registration",
// "confirmation" => "confirmation",
// "Connect Feature disabled" => "Connect Feature disabled",
// "Connect Server Mode disabled" => "Connect Server Mode disabled",
// "Please confirm you want to participate in Tiki Connect" => "Please confirm you want to participate in Tiki Connect",
// "Welcome to Tiki Connect, please click \"Send Info\" when you want to make a connection" => "Welcome to Tiki Connect, please click \"Send Info\" when you want to make a connection",
// "Something went wrong on the server. Tiki Connect is still experimental" => "Something went wrong on the server. Tiki Connect is still experimental",
// "Captcha code problem" => "Captcha code problem",
// "Connect data received, thanks" => "Connect data received, thanks",
// "Your Tiki is not registered here yet, please try again" => "Your Tiki is not registered here yet, please try again",
"Feature disabled: %0" => "Recurso desabilitado: %0",
"\"%0\" already exists" => "\"%0\" já existe",
"Field Required" => "Campo obrigatório",
"Not found" => "Não encontrado",
// "Must be authenticated" => "Must be authenticated",
// "Invalid input" => "Invalid input",
// "File could not be uploaded. Restrictions apply" => "File could not be uploaded. Restrictions apply",
// "Upload from source disabled" => "Upload from source disabled",
// "Data could not be obtained" => "Data could not be obtained",
// "Manual refresh disabled" => "Manual refresh disabled",
// "Requested gallery does not exist" => "Requested gallery does not exist",
// "Feature Disabled" => "Feature Disabled",
// "Translation not supported for the specified object type" => "Translation not supported for the specified object type",
// "No source provided" => "No source provided",
// "No source or target provided" => "No source or target provided",
// "Not allowed to attach the selected translations" => "Not allowed to attach the selected translations",
// "Could not attach the translations" => "Could not attach the translations",
// "Not allowed to detach the selected translations" => "Not allowed to detach the selected translations",
// "Object has no language and cannot be translated" => "Object has no language and cannot be translated",
// "No box available for %0" => "No box available for %0",
// "Remote service unaccessible (%0)" => "Remote service unaccessible (%0)",
// "Reserved to tracker administrators" => "Reserved to tracker administrators",
// "Type does not exist" => "Type does not exist",
// "Not allowed to view the tracker" => "Not allowed to view the tracker",
// "Warning: Required field types not enabled: %0" => "Warning: Required field types not enabled: %0",
// "Tracker contains no listed field, no meaningful information will be provided in the default list" => "Tracker contains no listed field, no meaningful information will be provided in the default list",
// "Tracker contains no field in the title, no link will be generated" => "Tracker contains no field in the title, no link will be generated",
// "Captcha" => "Captcha",
// "Distinct" => "Distinct",
"Page Name" => "Nome da página",
"Password" => "Senha",
// "Regular Expression (Pattern)" => "Regular Expression (Pattern)",
// "User Name" => "User Name",
// "Invalid data provided" => "Invalid data provided",
// "Item could not be created" => "Item could not be created",
// "Not allowed to export" => "Not allowed to export",
// "No valid field selected for export" => "No valid field selected for export",
// "File upload failed" => "File upload failed",
// "Uploaded file could not be read" => "Uploaded file could not be read",
"Last Modification" => "última modificação em",
// "Item ID" => "Item ID",
"Filename" => "Nome do arquivo",
"Creation date" => "Data de criação",
// "Views" => "Views",
"File size" => "Tamanho do arquivo",
"Version" => "Versão",
"File type" => "Tipo do arquivo",
// "Long description" => "Long description",
"User" => "Usuário",
// "Error in search query" => "Error in search query",
// "Remote Source" => "Remote Source",
// "Automatically generated field for synchronized trackers. Contains the itemId of the remote item" => "Automatically generated field for synchronized trackers. Contains the itemId of the remote item",
// "Tracker does not exist" => "Tracker does not exist",
// "Tracker is not synchronized with a remote source" => "Tracker is not synchronized with a remote source",
// "Operation reserved for tracker administrators" => "Operation reserved for tracker administrators",
// "Following mandatory fields are missing: %0" => "Following mandatory fields are missing: %0",
// "Invalid value in %0: %1" => "Invalid value in %0: %1",
// "Invalid value in %0" => "Invalid value in %0",
// "Field does not exist in tracker" => "Field does not exist in tracker",
// "secure connection required" => "secure connection required",
// "Create a form which will be posted somewhere, not necessarily trackers or even Tiki" => "Create a form which will be posted somewhere, not necessarily trackers or even Tiki",
// "The title of the button" => "The title of the button",
"Post" => "Enviar",
// "The protocol to use at the form: either get or post" => "The protocol to use at the form: either get or post",
// "Script" => "Script",
// "The arbitrary url of the destination of the form" => "The arbitrary url of the destination of the form",
"Parameters" => "Parâmetros",
// "Here page:fieldname can be repeated several times, it specifies the variable names to pass in the form, as well as value taken from the current item from field named fieldname. highlight=test can also be repeated and is useful for fixed values as params to pass to the form" => "Here page:fieldname can be repeated several times, it specifies the variable names to pass in the form, as well as value taken from the current item from field named fieldname. highlight=test can also be repeated and is useful for fixed values as params to pass to the form",
// "Auto-Increment" => "Auto-Increment",
// "Allows an incrementing value field, or itemId field" => "Allows an incrementing value field, or itemId field",
// "The starting value for the field" => "The starting value for the field",
// "Prepend" => "Prepend",
// "Text that will be displayed before the field" => "Text that will be displayed before the field",
// "Append" => "Append",
// "Text that will be displayed after the field" => "Text that will be displayed after the field",
// "If set to \"itemId\", will set this field to match the value of the actual database itemId field value" => "If set to \"itemId\", will set this field to match the value of the actual database itemId field value",
"Category" => "Categoria",
// "Allows for one or multiple categories under the specified main category to be affected to the tracker item" => "Allows for one or multiple categories under the specified main category to be affected to the tracker item",
// "Parent Category" => "Parent Category",
// "Child categories will be provided as options for the field" => "Child categories will be provided as options for the field",
// "Input Type" => "Input Type",
// "User interface control to be used" => "User interface control to be used",
// "Drop Down" => "Drop Down",
// "Radio buttons" => "Radio buttons",
// "List box" => "List box",
// "Multiple-selection check-boxes" => "Multiple-selection check-boxes",
"Select All" => "Selecionar todos",
// "Includes a control to select all available options for multi-selection controls" => "Includes a control to select all available options for multi-selection controls",
// "No controls" => "No controls",
// "Include controls" => "Include controls",
// "All descendants" => "All descendants",
// "Display all descendants instead of only first-level ones" => "Display all descendants instead of only first-level ones",
// "First level only" => "First level only",
// "Displays the field description in a help tooltip" => "Displays the field description in a help tooltip",
// "No help" => "No help",
// "Tooltip" => "Tooltip",
// "Checkbox" => "Checkbox",
// "Provides a checkbox field for yes/no, on/off input" => "Provides a checkbox field for yes/no, on/off input",
"Yes" => "Sim",
"No" => "Não",
// "Computed Field" => "Computed Field",
// "Provides a computed value based on numeric field values. Consider using webservices or JavaScript to perform the task instead of using this type" => "Provides a computed value based on numeric field values. Consider using webservices or JavaScript to perform the task instead of using this type",
// "This feature is still in place for backwards compatibility. While there are no flaws associated to it, it could be used as a vector for attacks causing a lot of damage. Webservice field or custom JavaScript is recommended instead of this field" => "This feature is still in place for backwards compatibility. While there are no flaws associated to it, it could be used as a vector for attacks causing a lot of damage. Webservice field or custom JavaScript is recommended instead of this field",
// "Formula" => "Formula",
// "The formula to be computed supporting various operators (+ - * / and parenthesis), references to other field made using the field id preceeded by #" => "The formula to be computed supporting various operators (+ - * / and parenthesis), references to other field made using the field id preceeded by #",
// "Country Selector" => "Country Selector",
// "Allows a selection from a specified list of countries" => "Allows a selection from a specified list of countries",
"Display" => "Mostrar",
// "Specify the rendering type for the field" => "Specify the rendering type for the field",
// "Name and flag" => "Name and flag",
// "Name only" => "Name only",
// "Flag only" => "Flag only",
// "Sort Order" => "Sort Order",
// "Determines whether the ordering should be based on the translated name or the English name" => "Determines whether the ordering should be based on the translated name or the English name",
// "Translated name" => "Translated name",
// "English name" => "English name",
// "Currency Field" => "Currency Field",
// "Provides a one-line field for numeric input only. Prepend or append values may be alphanumeric" => "Provides a one-line field for numeric input only. Prepend or append values may be alphanumeric",
// "Same Row" => "Same Row",
// "Displays the next field on the same line" => "Displays the next field on the same line",
// "Display Size" => "Display Size",
// "Visible size of the field in characters. Does not affect the numeric length" => "Visible size of the field in characters. Does not affect the numeric length",
// "Text to be displayed prior to the currency amount" => "Text to be displayed prior to the currency amount",
// "Text to be displayed after the numeric value" => "Text to be displayed after the numeric value",
// "Locale" => "Locale",
// "Set locale for currency formatting, for example en_US or en_US.UTF-8 or en_US.ISO-8559-1. Default is en_US" => "Set locale for currency formatting, for example en_US or en_US.UTF-8 or en_US.ISO-8559-1. Default is en_US",
"Currency" => "Moeda",
// "A custom alphanumeric currency code. Not needed if locale is set and a standard code is desired. Default is USD" => "A custom alphanumeric currency code. Not needed if locale is set and a standard code is desired. Default is USD",
// "Symbol" => "Symbol",
// "Set whether the currency code (for example USD) or symbol (for example \$) will display. Defaults to symbol" => "Set whether the currency code (for example USD) or symbol (for example \$) will display. Defaults to symbol",
// "Currency code" => "Currency code",
// "Currency symbol" => "Currency symbol",
// "First or all" => "First or all",
// "Set whether the currency code or symbol will be displayed against all amounts or only the first amount" => "Set whether the currency code or symbol will be displayed against all amounts or only the first amount",
// "First item only" => "First item only",
"Date and Time" => "Data e hora",
// "Provides drop-down options to accurately select a date and/or time" => "Provides drop-down options to accurately select a date and/or time",
// "Components to be included" => "Components to be included",
// "Date only" => "Date only",
// "Start Year" => "Start Year",
// "Year to allow selecting from" => "Year to allow selecting from",
// "End Year" => "End Year",
// "Year to allow selecting to" => "Year to allow selecting to",
// "Default selection" => "Default selection",
// "Indicates if blank dates should be allowed" => "Indicates if blank dates should be allowed",
// "Current Date" => "Current Date",
// "Blank" => "Blank",
// "Allows users to select only from a specified set of options" => "Allows users to select only from a specified set of options",
"Option" => "Opções",
// "An option, if containing an equal sign, the prior part will be used as the value while the later as the label" => "An option, if containing an equal sign, the prior part will be used as the value while the later as the label",
// "Drop Down with Other field" => "Drop Down with Other field",
// "Allows users to select from a specified set of options or to enter an alternate option" => "Allows users to select from a specified set of options or to enter an alternate option",
// "An option, if containing an equal sign, the prior part will be used as the value while the later as the label. It is recommended to add an \"other\" option" => "An option, if containing an equal sign, the prior part will be used as the value while the later as the label. It is recommended to add an \"other\" option",
// "Radio Buttons" => "Radio Buttons",
// "Multiselect" => "Multiselect",
// "Allows a user to select multiple values from a specified set of options" => "Allows a user to select multiple values from a specified set of options",
// "Dynamic Items List" => "Dynamic Items List",
// "Dynamically updates a selection list based on linked data from another tracker" => "Dynamically updates a selection list based on linked data from another tracker",
// "Tracker ID" => "Tracker ID",
// "Tracker to link with" => "Tracker to link with",
// "Field ID (Other tracker)" => "Field ID (Other tracker)",
// "Field ID to link with in the other tracker" => "Field ID to link with in the other tracker",
// "Field ID (This tracker)" => "Field ID (This tracker)",
// "Field ID to link with in the current tracker" => "Field ID to link with in the current tracker",
// "Listed Field" => "Listed Field",
// "Field ID to be displayed in the drop list" => "Field ID to be displayed in the drop list",
// "Status Filter" => "Status Filter",
// "Restrict listed items to specific statuses" => "Restrict listed items to specific statuses",
"all" => "todos",
"open" => "aberto",
"pending" => "pendente",
"closed" => "fechado",
// "open, pending" => "open, pending",
// "pending, closed" => "pending, closed",
// "Tracker Field Factory Error: Pref \"%0\" required for field type \"%1\"" => "Tracker Field Factory Error: Pref \"%0\" required for field type \"%1\"",
"Attachment" => "Anexo",
// "Allows a file to be attached to the tracker item" => "Allows a file to be attached to the tracker item",
"List View" => "Ver em forma de lista",
// "Defines how attachments will be displayed within the field" => "Defines how attachments will be displayed within the field",
"name" => "nome",
"type" => "tipo",
// "name, size" => "name, size",
// "name, type, size" => "name, type, size",
// "uploader" => "uploader",
// "mediaplayer" => "mediaplayer",
"Download" => "Download",
// "Attached and upload files stored in the file galleries to the tracker item" => "Attached and upload files stored in the file galleries to the tracker item",
// "Gallery ID" => "Gallery ID",
// "File gallery to upload new files into" => "File gallery to upload new files into",
// "MIME Type Filter" => "MIME Type Filter",
// "Mask for accepted MIME types in the field" => "Mask for accepted MIME types in the field",
// "File Count" => "File Count",
// "Maximum number of files to be attached on the field" => "Maximum number of files to be attached on the field",
// "Display Images" => "Display Images",
// "Show files as images or object links" => "Show files as images or object links",
"Links" => "Links",
"Images" => "Imagens",
// "Image parameters" => "Image parameters",
// "URL encoded params used as in the {img} plugin. e.g" => "URL encoded params used as in the {img} plugin. e.g",
// "Image parameters for lists" => "Image parameters for lists",
// "Include Child Galleries" => "Include Child Galleries",
// "Use files from child galleries as well" => "Use files from child galleries as well",
// "Replace Existing File" => "Replace Existing File",
// "Replace existing file if any, instead of uploading new one" => "Replace existing file if any, instead of uploading new one",
// "Problem with uploaded file: \"%0\"" => "Problem with uploaded file: \"%0\"",
// "No gallery for uploaded file, galleryId=%0" => "No gallery for uploaded file, galleryId=%0",
// "No permissions to upload file to gallery \"%0\"" => "No permissions to upload file to gallery \"%0\"",
"Freetags" => "Tags",
// "Allows freetags to be shown or added for tracker items" => "Allows freetags to be shown or added for tracker items",
// "Visible size of the input field" => "Visible size of the input field",
// "Hide or show the input help" => "Hide or show the input help",
"Show" => "Mostrar",
"Hide" => "Esconder",
// "Suggest" => "Suggest",
// "Hide or show the freetag suggestions" => "Hide or show the freetag suggestions",
// "Geographic Feature" => "Geographic Feature",
// "Stores a geographic feature on a map" => "Stores a geographic feature on a map",
// "Feature cannot be set or modified through this interface" => "Feature cannot be set or modified through this interface",
// "Feature cannot be viewed" => "Feature cannot be viewed",
// "Group Selector" => "Group Selector",
// "Allows a selection from a specified list of user groups" => "Allows a selection from a specified list of user groups",
// "Auto-Assign" => "Auto-Assign",
// "Determines if any group should be automatically assigned to the field" => "Determines if any group should be automatically assigned to the field",
// "Modifier" => "Modifier",
// "Group Filter" => "Group Filter",
// "Limit listed groups to those including the specified group" => "Limit listed groups to those including the specified group",
// "Assign to the group" => "Assign to the group",
// "For no autoaassigned field, the user (user selector if exsits or user) will be assigned to the group and it will be his default group. The group must have the user choice setting on" => "For no autoaassigned field, the user (user selector if exsits or user) will be assigned to the group and it will be his default group. The group must have the user choice setting on",
"Assign" => "Atribuir",
// "Header" => "Header",
// "Displays a header between fields to delimit a section and allow folding the fields" => "Displays a header between fields to delimit a section and allow folding the fields",
// "Header Level" => "Header Level",
// "Level of the header to use for complex tracker structures needing multiple heading levels" => "Level of the header to use for complex tracker structures needing multiple heading levels",
// "Default State" => "Default State",
// "Controls the section toggles" => "Controls the section toggles",
"Open" => "Aberto",
"Closed" => "Fechado",
"Icon" => "Ícone",
// "Allows to select an image as an icon attached to the tracker item from file galleries" => "Allows to select an image as an icon attached to the tracker item from file galleries",
// "Default image" => "Default image",
// "Path to the default icon used" => "Path to the default icon used",
"Image" => "Imagem",
// "Allow users to upload images on the tracker item" => "Allow users to upload images on the tracker item",
// "List image width" => "List image width",
// "Display size in pixels" => "Display size in pixels",
// "List image height" => "List image height",
// "Detail image width" => "Detail image width",
// "Detail image height" => "Detail image height",
"Maximum image size" => "Tamanho máximo",
// "Maximum image width or height in pixels" => "Maximum image width or height in pixels",
"Shadowbox" => "Shadowbox",
// "Shadowbox usage on this field" => "Shadowbox usage on this field",
// "Do not use" => "Do not use",
// "One box per item" => "One box per item",
// "Use the same box for all images" => "Use the same box for all images",
// "Missing Icon" => "Missing Icon",
// "Icon to use when no images have been uploaded" => "Icon to use when no images have been uploaded",
"Invalid imagename (using filters for filenames)" => "Nome inválido de imagem (usando filtros para nomes de arquivos)",
// "In Group" => "In Group",
// "Indicates if the user associated to the item is member of a specified group" => "Indicates if the user associated to the item is member of a specified group",
// "Group Name" => "Group Name",
// "Name of the group to verify" => "Name of the group to verify",
// "How to display the result" => "How to display the result",
// "Yes/No" => "Yes/No",
// "Join date" => "Join date",
// "IP Selector" => "IP Selector",
// "IP address input field" => "IP address input field",
// "Auto-assign" => "Auto-assign",
// "Automatically assign the value on creation or edit" => "Automatically assign the value on creation or edit",
// "Item Link" => "Item Link",
// "Link to an other item, similar to a foreign key" => "Link to an other item, similar to a foreign key",
// "Tracker to link to" => "Tracker to link to",
// "Field ID" => "Field ID",
// "Default field to display" => "Default field to display",
// "How the link to the item should be rendered" => "How the link to the item should be rendered",
"Value" => "Valor",
"Link" => "Link",
// "Multiple Fields" => "Multiple Fields",
// "Display the values from multiple fields instead of a single one, separated by |" => "Display the values from multiple fields instead of a single one, separated by |",
// "Limit the available items to a selected set" => "Limit the available items to a selected set",
// "Link Page" => "Link Page",
// "Link to a wiki page instead of directly to the item" => "Link to a wiki page instead of directly to the item",
// "Add Items" => "Add Items",
// "Display text to allow new items to be added - e.g. \"Add item...\" (requires jQuery-UI)" => "Display text to allow new items to be added - e.g. \"Add item...\" (requires jQuery-UI)",
// "Add Item Template Page" => "Add Item Template Page",
// "Wiki page to use as a Pretty Tracker template" => "Wiki page to use as a Pretty Tracker template",
// "Preselect item based on value in this field" => "Preselect item based on value in this field",
// "Preselect item based on value in specified field ID of item being edited" => "Preselect item based on value in specified field ID of item being edited",
// "Preselect based on value in this remote field" => "Preselect based on value in this remote field",
// "Match preselect item with this field ID in tracker that is being linked to" => "Match preselect item with this field ID in tracker that is being linked to",
// "Preselection matching method" => "Preselection matching method",
// "Method to use to match fields for preselection purposes" => "Method to use to match fields for preselection purposes",
// "Exact Match" => "Exact Match",
// "Field here is part of field there" => "Field here is part of field there",
// "Match domain, used for URL fields" => "Match domain, used for URL fields",
// "One item per value" => "One item per value",
// "Display only one random item per value" => "Display only one random item per value",
// "Only one random item for each value" => "Only one random item for each value",
// "Displays all the items for a same value with a notation value (itemId)" => "Displays all the items for a same value with a notation value (itemId)",
// "Select multiple values" => "Select multiple values",
// "Allow the user to select multiple values" => "Allow the user to select multiple values",
// "Index remote fields" => "Index remote fields",
// "Index one or multiple fields from the master tracker along with the child, separated by |" => "Index one or multiple fields from the master tracker along with the child, separated by |",
// "Items List" => "Items List",
// "Displays a list of field values from another tracker that has a relation with this tracker" => "Displays a list of field values from another tracker that has a relation with this tracker",
// "Tracker to list items from" => "Tracker to list items from",
// "Link Field ID" => "Link Field ID",
// "Field ID from the other tracker containing an item link pointing to the item in this tracker or some other value to be matched" => "Field ID from the other tracker containing an item link pointing to the item in this tracker or some other value to be matched",
// "Value Field ID" => "Value Field ID",
// "Field ID from this tracker matching the value in the link field ID from the other tracker if the field above is not an item link" => "Field ID from this tracker matching the value in the link field ID from the other tracker if the field above is not an item link",
// "Fields to display" => "Fields to display",
// "Display alternate fields from the other tracker instead of the item title" => "Display alternate fields from the other tracker instead of the item title",
// "How the link to the items should be rendered" => "How the link to the items should be rendered",
// "Read Only" => "Read Only",
// "Date and Time (Date Picker)" => "Date and Time (Date Picker)",
// "Provides jQuery-UI date picker select a date and optionally time" => "Provides jQuery-UI date picker select a date and optionally time",
// "Default value" => "Default value",
// "Default date and time for new items" => "Default date and time for new items",
// "None (undefined)" => "None (undefined)",
// "Item creation date and time" => "Item creation date and time",
"Language" => "Idioma",
// "Assign a language to the tracker item to enable multilingual trackers" => "Assign a language to the tracker item to enable multilingual trackers",
// "Indicates if the language should be assigned as the item's language" => "Indicates if the language should be assigned as the item's language",
// "LDAP" => "LDAP",
// "Display a field value from a specific user in LDAP" => "Display a field value from a specific user in LDAP",
"Filter" => "Filtrar",
// "LDAP filter, can contain the %field_name% placeholder to be replaced with the current field's name" => "LDAP filter, can contain the %field_name% placeholder to be replaced with the current field's name",
"Field" => "Campo",
// "Field name returned by LDAP" => "Field name returned by LDAP",
"DSN" => "DSN",
// "Data source name registered in Tiki" => "Data source name registered in Tiki",
"Location" => "Local",
// "Allows to select a geolocation for the item and displays it on a map" => "Allows to select a geolocation for the item and displays it on a map",
// "Use as item location" => "Use as item location",
// "When enabled, records the field's value as the item's geolocation to be displayed on locator maps" => "When enabled, records the field's value as the item's geolocation to be displayed on locator maps",
// "Numeric Field" => "Numeric Field",
// "Text to be displayed prior to the numeric value" => "Text to be displayed prior to the numeric value",
// "Decimal Places" => "Decimal Places",
// "Amount of decimals to preserve before rounding" => "Amount of decimals to preserve before rounding",
// "Decimal separator when displaying data" => "Decimal separator when displaying data",
// "Single character. Use c for comma, d for dot or s for space. The valid decimal separator when inserting numbers may depend on site language and web browser. See documentation for more details" => "Single character. Use c for comma, d for dot or s for space. The valid decimal separator when inserting numbers may depend on site language and web browser. See documentation for more details",
// "Thousand separator when displaying data" => "Thousand separator when displaying data",
// "Single character,  Use c for comma, d for dot or s for space.  When inserting data no thousands separator is needed" => "Single character,  Use c for comma, d for dot or s for space.  When inserting data no thousands separator is needed",
// "Page Selector" => "Page Selector",
// "Allows a selection from the list of pages" => "Allows a selection from the list of pages",
// "Will auto-assign the creator of the item" => "Will auto-assign the creator of the item",
// "Visible size of the input in characters" => "Visible size of the input in characters",
"Create Page" => "Criar página",
// "Create missing pages using the page name in this file as the template" => "Create missing pages using the page name in this file as the template",
// "Display the value as a link to the page" => "Display the value as a link to the page",
"Rating" => "Nota",
// "A rating of the tracker item" => "A rating of the tracker item",
// "The possible options (comma separated integers) for the rating" => "The possible options (comma separated integers) for the rating",
"Mode" => "Modo",
// "Display rating options as" => "Display rating options as",
// "Stars" => "Stars",
// "Single Option: e.g. Like" => "Single Option: e.g. Like",
// "Labels" => "Labels",
// "The text labels (comma separated) for the possible options" => "The text labels (comma separated) for the possible options",
// "Stars (deprecated)" => "Stars (deprecated)",
// "Displays a star rating" => "Displays a star rating",
// "A possible option for the rating" => "A possible option for the rating",
// "Stars (system)" => "Stars (system)",
"Average" => "Média",
// "Number of votes" => "Number of votes",
// "Your rating" => "Your rating",
// "Relations" => "Relations",
// "Allows to create arbitrary relations between the trackers and other objects in the system" => "Allows to create arbitrary relations between the trackers and other objects in the system",
// "Relation" => "Relation",
// "Relation qualifier. Must be a three-part qualifier containing letters and separated by dots" => "Relation qualifier. Must be a three-part qualifier containing letters and separated by dots",
// "URL-encoded list of filters to be applied on object selection" => "URL-encoded list of filters to be applied on object selection",
// "Read-only" => "Read-only",
// "Only display the incoming relations instead of manipulating them" => "Only display the incoming relations instead of manipulating them",
// "Include Invert" => "Include Invert",
// "Include invert relations in the list" => "Include invert relations in the list",
"Email" => "E-mail",
// "Allows to input an email address with options of making it active" => "Allows to input an email address with options of making it active",
// "Link Type" => "Link Type",
// "How the email address will be rendered" => "How the email address will be rendered",
"Plain text" => "Texto não formatado",
// "Encoded mailto link" => "Encoded mailto link",
// "Simple mailto link" => "Simple mailto link",
// "Watch Open" => "Watch Open",
// "Notify this address every time the status changes to open" => "Notify this address every time the status changes to open",
// "Watch Pending" => "Watch Pending",
// "Notify this address every time the status changes to pending" => "Notify this address every time the status changes to pending",
// "Watch Closed" => "Watch Closed",
// "Notify this address every time the status changes to closed" => "Notify this address every time the status changes to closed",
"Static Text" => "Text estático",
// "Displays the field description as static text that can be used to display notes or additional instructions" => "Displays the field description as static text that can be used to display notes or additional instructions",
// "Wiki Parse" => "Wiki Parse",
// "Indicates if the description should be parsed as wiki syntax for formatting" => "Indicates if the description should be parsed as wiki syntax for formatting",
// "Handle line breaks as new lines only" => "Handle line breaks as new lines only",
// "Maximum Length (List)" => "Maximum Length (List)",
// "Maximum amount of characters to be displayed in list mode" => "Maximum amount of characters to be displayed in list mode",
"Text Field" => "Campo de texto",
"Single-line text input" => "Campo de texto de apenas uma linha",
// "Display the next field on the same row" => "Display the next field on the same row",
// "Visible size of the field in characters" => "Visible size of the field in characters",
// "Text to prepend when displaying the value" => "Text to prepend when displaying the value",
"Maximum Length" => "Tamanho máximo",
// "Maximum amount of characters to store" => "Maximum amount of characters to store",
// "Autocomplete" => "Autocomplete",
// "Enable autocompletion while typing in the field" => "Enable autocompletion while typing in the field",
// "Index exact value" => "Index exact value",
// "In addition to indexing the content of the field, also index it as an identifier in tracker_field_{perm name}_exact. This option is not available for multilingual fields. Mostly for identifiers like product codes or ISBN numbers" => "In addition to indexing the content of the field, also index it as an identifier in tracker_field_{perm name}_exact. This option is not available for multilingual fields. Mostly for identifiers like product codes or ISBN numbers",
"Text Area" => "Área de texto",
"Multi-line text input" => "Campo de texto com múltiplas linhas",
"Toolbars" => "Barras de ferramentas",
// "Enable the toolbars as syntax helpers" => "Enable the toolbars as syntax helpers",
"Disable" => "Disabilitar",
"Enable" => "Habilitar",
"Width" => "Largura",
// "Size of the text area in characters" => "Size of the text area in characters",
"Height" => "Altura",
// "Size of the text area in lines" => "Size of the text area in lines",
// "Character Limit" => "Character Limit",
// "Maximum amount of characters to be stored" => "Maximum amount of characters to be stored",
// "Display Limit (List)" => "Display Limit (List)",
// "Maximum amount of characters to be displayed in list mode before the value gets truncated" => "Maximum amount of characters to be displayed in list mode before the value gets truncated",
// "Word Count" => "Word Count",
// "Limit the length of the text in words" => "Limit the length of the text in words",
// "Distinct Values" => "Distinct Values",
// "All values in the field must be different" => "All values in the field must be different",
// "Use WYSIWYG" => "Use WYSIWYG",
// "Use a rich text editor instead of a plain text box" => "Use a rich text editor instead of a plain text box",
// "Word Limit Exceeded" => "Word Limit Exceeded",
// "Character Limit Exceeded" => "Character Limit Exceeded",
"URL" => "Endereço",
// "Creates a link to a specified URL" => "Creates a link to a specified URL",
// "How the URL should be rendered" => "How the URL should be rendered",
// "URL as link" => "URL as link",
// "Site title as link" => "Site title as link",
// "URL as link plus site title" => "URL as link plus site title",
// "User Groups" => "User Groups",
// "Displays the list of groups for the user associated with the tracker items" => "Displays the list of groups for the user associated with the tracker items",
"User Preference" => "Preferência do usuário",
// "Allows user preference changes from a tracker" => "Allows user preference changes from a tracker",
"Preference Name" => "Nome da preferência",
// "Name of the preference to manipulate. password and email are not preferences, but are also valid values that will modify the user's profile" => "Name of the preference to manipulate. password and email are not preferences, but are also valid values that will modify the user's profile",
// "User Selector" => "User Selector",
// "Allows the selection of a user from a list" => "Allows the selection of a user from a list",
// "Assign the value based on the creator or modifier" => "Assign the value based on the creator or modifier",
// "Email Notification" => "Email Notification",
// "Send an email notification to the user every time the item is modified" => "Send an email notification to the user every time the item is modified",
// "Only when other users modify the item" => "Only when other users modify the item",
// "Group IDs" => "Group IDs",
// "Limit the list of users to members of specific groups" => "Limit the list of users to members of specific groups",
// "User Subscription" => "User Subscription",
// "Allows registered users to subscribe themselves to a tracker item. The item should ideally only be editable by the creator or administrators. Prepend the maximum amount of subscribers to the field value foloowed by # if such a limit is desired. E.g. 50# means that 50 subscriptions will be allowed for this item" => "Allows registered users to subscribe themselves to a tracker item. The item should ideally only be editable by the creator or administrators. Prepend the maximum amount of subscribers to the field value foloowed by # if such a limit is desired. E.g. 50# means that 50 subscriptions will be allowed for this item",
// "Webservice" => "Webservice",
// "Displays the result of a registered webservice call" => "Displays the result of a registered webservice call",
// "Service Name" => "Service Name",
// "Webservice name as registered in Tiki" => "Webservice name as registered in Tiki",
// "Template Name" => "Template Name",
// "Template name to use for rendering as registered with the webservice" => "Template name to use for rendering as registered with the webservice",
// "URL-encoded list of parameters to send to the webservice. %field_name% can be used in the string to be replaced with the values in the tracker item" => "URL-encoded list of parameters to send to the webservice. %field_name% can be used in the string to be replaced with the values in the tracker item",
"Create page:" => "Criar página:",
"Internal error" => "Erro interno",
"User error" => "Erro do usuário",
"Plugin argument(s) missing" => "Falta algum argumento para o plugin",
"Plugin <strong>%0</strong> cannot be executed" => "O plugin <strong>%0</strong> não pode ser executado",
"Set" => "Definir",
"Plugin disabled" => "Plugin desabilitado",
"Line:" => "Linha:",
"Lines:" => "Linhas:",
// "WikiDiff::apply: line count mismatch: %s != %s" => "WikiDiff::apply: line count mismatch: %s != %s",
// "WikiDiff::_check: failed" => "WikiDiff::_check: failed",
// "WikiDiff::_check: edit sequence is non-optimal" => "WikiDiff::_check: edit sequence is non-optimal",
// "WikiDiff Okay: LCS = %s" => "WikiDiff Okay: LCS = %s",
// "`%0` does not match acceptable naming patterns" => "`%0` does not match acceptable naming patterns",
"Cannot open this file:" => "Não foi possível abrir este arquivo:",
// "User File Galleries" => "User File Galleries",
// "Wiki Attachment File Galleries" => "Wiki Attachment File Galleries",
"File Galleries" => "Galerias de Arquivos",
"My Files" => "Meus arquivos",
// "Files of " => "Files of ",
"The upload has not been done" => "O upload não foi concluído",
// "Reason: The global quota has been reached" => "Reason: The global quota has been reached",
// "Reason: The quota has been reached in \"%s\"" => "Reason: The quota has been reached in \"%s\"",
"File gallery quota exceeded" => "Galeria de arquivos excedeu a quota",
"Number of files transferred to the database" => "Número de arquivos transferido para a base de dados",
"Number of files transferred to the file system" => "Número de arquivos tranferido para o sistema de arquivos",
"Old File deleted" => "Arquivo antigo deletado",
"Incorrect param" => "Parâmetro incorreto",
"You do not have permission to remove files from this gallery" => "Permissão negada: você não pode remover arquivos desta galeria",
// "WARNING: The file is used in" => "WARNING: The file is used in",
// "Remove file draft: " => "Remove file draft: ",
"Remove file: " => "Remover arquivo: ",
// "You are trying to edit multiple files in different galleries, which is not supported yet" => "You are trying to edit multiple files in different galleries, which is not supported yet",
"The specified file does not exist" => "O arquivo especificado não existe",
"Upload was not successful" => "Carga interrompida com falha",
// "An exception occurred" => "An exception occurred",
"Batch file processed" => "Arquivo em lote processado",
"No permission to upload zipped file packages" => "Sem permissão para carregar arquivos zipados",
"Errors detected" => "Erros detectados",
// "Check that these paths exist and are writable by the web server" => "Check that these paths exist and are writable by the web server",
"File added: " => "Arquivo adicionao: ",
"Cannot read the file" => "Não foi possível ler o arquivo",
"Incorrect file extension" => "Extensão do arquivo incorreta",
"Warning: Empty file" => "Atenção: arquivo vazio",
"Please re-upload your file" => "Por favor reenvie seu arquivo",
"Upload was not successful. Duplicate file content" => "Não foi possível enviar o arquivo. Já existe outro arquivo com o mesmo nome nessa galeria",
"File update was successful" => "Arquivo atualizado com sucesso",
"Cannot resize the file" => "Não foi possível redimensionar o arquivo",
"Cannot write the file" => "Não foi possível criar o arquivo",
// "Image was reduced: %s x %s -> %s x %s" => "Image was reduced: %s x %s -> %s x %s",
"Could not upload the file" => "Não é possível carregar o arquivo",
"Could not find the file requested" => "Não foi possível achar o arquivo requisitado",
// "The file is locked by %s" => "The file is locked by %s",
"You do not have permission to edit this file" => "Permissão negada: você não pode editar este arquivo",
// "Cannot read uploaded file" => "Cannot read uploaded file",
// "Cannot read file on disk" => "Cannot read file on disk",
"unknown" => "desconhecido",
// "Automatic revision from source" => "Automatic revision from source",
"Page" => "Página",
"Cannot upload this file" => "Não foi possível fazer o upload deste arquivo",
"This is an approximation based on your server memory limit" => "Valor aproximado baseado nas configurações do seu servidor",
// "This is the value of your server's PHP '%s' setting" => "This is the value of your server's PHP '%s' setting",
// "You are alerted by the server " => "You are alerted by the server ",
// "You can check the modifications at : " => "You can check the modifications at : ",
// "You are alerted of a change on " => "You are alerted of a change on ",
"No image yet, sorry." => "Sinto muito, sem nenhuma imagem ainda.",
// "unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>" => "unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>",
// "unlink failed" => "unlink failed",
// "The uploaded file exceeds the upload_max_filesize directive in php.ini" => "The uploaded file exceeds the upload_max_filesize directive in php.ini",
// "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form" => "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form",
// "The uploaded file was only partially uploaded. Please try again" => "The uploaded file was only partially uploaded. Please try again",
"No file was uploaded" => "Nenhum arquivo foi enviado",
"Missing a temporary folder" => "Diretório temporário não encontrado",
"Failed to write file to disk" => "Não foi possível escrever o arquivo no disco",
// "File upload stopped by extension" => "File upload stopped by extension",
"Set new blog as Tiki homepage" => "Definir o novo blog com a página inicial do Tiki",
// "Importation completed" => "Importation completed",
// "<a href=\"tiki-importer.php\">Click here</a> to finish the import process" => "<a href=\"tiki-importer.php\">Click here</a> to finish the import process",
"Found %0 posts, %1 pages, %2 tags and %3 categories. Inserting them into Tiki" => "Foram encontrados %0 posts, %1 páginas, %2 tags e %3 categorias. Inserindo eles no Tiki",
// "Item \"%0\" NOT imported (there was already a item with the same name)" => "Item \"%0\" NOT imported (there was already a item with the same name)",
"Page \"%0\" sucessfully imported" => "Página \"%0\" importada com sucesso",
"Post \"%0\" sucessfully imported" => "Post \"%0\" importado com sucesso",
"Import images and other attachments" => "Importar imagens e outros anexos",
"Update internal links (experimental)" => "Substituir links internos (experimental)",
// "Suggest .htaccess rules to redirect from old WP URLs to new Tiki URLs (experimental)" => "Suggest .htaccess rules to redirect from old WP URLs to new Tiki URLs (experimental)",
// "Class DOMDocument not available, check your PHP installation. For more information see http://php.net/manual/en/book.dom.php" => "Class DOMDocument not available, check your PHP installation. For more information see http://php.net/manual/en/book.dom.php",
"Invalid file mime type" => "Tipo do arquivo inválido",
// "Error while loading XML file. Probably your XML file is malformed. Some versions of Wordpress generate a malformed XML file. See the Tiki Importer documentation for more information" => "Error while loading XML file. Probably your XML file is malformed. Some versions of Wordpress generate a malformed XML file. See the Tiki Importer documentation for more information",
// "Invalid Wordpress XML file" => "Invalid Wordpress XML file",
"No attachments found to import" => "Nenhum anexo encontrado para importar",
// "Importing attachments" => "Importing attachments",
// "Attachment %0 successfully imported" => "Attachment %0 successfully imported",
// "Unable to download attachment %0. Error message was: %1 %2" => "Unable to download attachment %0. Error message was: %1 %2",
// "%0 attachments imported and %1 errors" => "%0 attachments imported and %1 errors",
// "Page \"%0\" successfully extracted" => "Page \"%0\" successfully extracted",
// "Post \"%0\" successfully extracted" => "Post \"%0\" successfully extracted",
// "Extracting data from XML file" => "Extracting data from XML file",
// "Number of page revisions to import (0 for all revisions)" => "Number of page revisions to import (0 for all revisions)",
// "What to do with page names that already exists in Tiki" => "What to do with page names that already exists in Tiki",
"Do not import" => "Não importar",
// "Override" => "Override",
// "Append software name as prefix to the page name" => "Append software name as prefix to the page name",
// "Page %0 sucessfully imported" => "Page %0 sucessfully imported",
// "Page %0 NOT imported (there was already a page with the same name)" => "Page %0 NOT imported (there was already a page with the same name)",
// "%0 pages parsed. Starting to insert those pages into Tiki" => "%0 pages parsed. Starting to insert those pages into Tiki",
// "Import images and attachments (see documentation for more information)" => "Import images and attachments (see documentation for more information)",
// "Add a maketoc at the top of each page" => "Add a maketoc at the top of each page",
// "XML file does not validate against the Mediawiki XML schema" => "XML file does not validate against the Mediawiki XML schema",
// "ABORTING: destination directory for attachments (%0) does no exist. Fix the problem or try to import without the attachments" => "ABORTING: destination directory for attachments (%0) does no exist. Fix the problem or try to import without the attachments",
// "ABORTING: destination directory for attachments (%0) is not writable. Fix the problem or try to import without attachments" => "ABORTING: destination directory for attachments (%0) is not writable. Fix the problem or try to import without attachments",
// "NOT importing file %0 as there is already a file with the same name in the destination directory (%1)" => "NOT importing file %0 as there is already a file with the same name in the destination directory (%1)",
// "File %0 successfully imported" => "File %0 successfully imported",
// "Unable to download file %0. File not found" => "Unable to download file %0. File not found",
// "Error while parsing revision %0 of the page \"%1\". Or there is a problem on the page syntax or on the Text_Wiki parser (the parser used by the importer)" => "Error while parsing revision %0 of the page \"%1\". Or there is a problem on the page syntax or on the Text_Wiki parser (the parser used by the importer)",
// "Page \"%0\" successfully parsed with %1 revisions (from a total of %2 revisions)" => "Page \"%0\" successfully parsed with %1 revisions (from a total of %2 revisions)",
// "Page \"%0\" is NOT going to be imported. It was not possible to parse any of the page revisions" => "Page \"%0\" is NOT going to be imported. It was not possible to parse any of the page revisions",
// "Mediawiki XML file version %0 is not supported" => "Mediawiki XML file version %0 is not supported",
// "ABORTING: you need to enable the PHP setting 'allow_url_fopen' to be able to import attachments. Fix the problem or try to import without the attachments" => "ABORTING: you need to enable the PHP setting 'allow_url_fopen' to be able to import attachments. Fix the problem or try to import without the attachments",
// "Parsing pages" => "Parsing pages",
// "No attachments found to import! Make sure you have created your XML file with the dumpDump.php script and with the option --uploads. This is the only way to import attachment" => "No attachments found to import! Make sure you have created your XML file with the dumpDump.php script and with the option --uploads. This is the only way to import attachment",
// "string" => "string",
// "ERROR: unable to write to lang/%s/language.php" => "ERROR: unable to write to lang/%s/language.php",
// "The file lang/%0/language.php is not well formated. Run get_strings.php?lang=%0 and then try to export the translations again" => "The file lang/%0/language.php is not well formated. Run get_strings.php?lang=%0 and then try to export the translations again",
"Contributions" => "Contribuições",
// "Query point" => "Query point",
// "layer" => "layer",
// "Record" => "Record",
"This feature is disabled" => "Este recurso está desabilitado",
"Could not create \$tdo.mif in data directory" => "Não foi possível criar \$tdo.mif no diretório data",
"Could not create \$tdo.mid in data directory" => "Não foi possível criar \$tdo.mid no diretório data",
"User Map Generated in:" => "Mapa do usuário Gerado em:",
"Image Map Generated in:" => "Mapa da imagem Gerado em:",
// "(copy)" => "(copy)",
// "You can only use optionId = 0 to create a new option or optionId equal an id that already belongs to the menu to update it" => "You can only use optionId = 0 to create a new option or optionId equal an id that already belongs to the menu to update it",
"menu" => "menu",
"NONE" => "NENHUM",
// "Stored IPTC Digest" => "Stored IPTC Digest",
// "Calculated IPTC Digest" => "Calculated IPTC Digest",
// "The file is empty" => "The file is empty",
// "The file is not readable" => "The file is not readable",
// "File type not handled by Tiki - only basic metadata available" => "File type not handled by Tiki - only basic metadata available",
// "Photographer Data (IPTC)" => "Photographer Data (IPTC)",
// "No IPTC data" => "No IPTC data",
// "File Data (EXIF)" => "File Data (EXIF)",
// "No EXIF data" => "No EXIF data",
// "Not processed" => "Not processed",
// "Unixtime" => "Unixtime",
// "XMP Data" => "XMP Data",
// "No XMP data" => "No XMP data",
// "File type not handled by Tiki" => "File type not handled by Tiki",
// "Invalid \"from\" date received" => "Invalid \"from\" date received",
// "Invalid \"to\" date received" => "Invalid \"to\" date received",
// "Sorry, \"from\" date must precede \"to\" date" => "Sorry, \"from\" date must precede \"to\" date",
// "Sorry, no data available for the future" => "Sorry, no data available for the future",
// "for month of" => "for month of",
"for" => "para",
// "for week of" => "for week of",
// "Integer (i)" => "Integer (i)",
// "Percentage (%)" => "Percentage (%)",
// "Float (f)" => "Float (f)",
// "List (L)" => "List (L)",
// "Daily (+)" => "Daily (+)",
// "Monthly and weekly (@)" => "Monthly and weekly (@)",
// "Weekly (-)" => "Weekly (-)",
"File %s not found" => "Arquivos %s não encontrados",
"File %s is not a valid archive" => "Arquivo %s não é um arquivo válido",
"Impossible to open %s : %s" => "Impossível abrir %s : %s",
// "The content retrieved at %s is not a list of mods" => "The content retrieved at %s is not a list of mods",
// "Can't chdir to '%s'" => "Can't chdir to '%s'",
// "%s impossible to remove" => "%s impossible to remove",
// "Description not available" => "Description not available",
// "Module Title" => "Module Title",
// "Title to display at the top of the box" => "Title to display at the top of the box",
// "No Box" => "No Box",
"Show only the content" => "Mostrar apenas o conteúdo",
// "Decorations" => "Decorations",
// "Show module decorations" => "Show module decorations",
"No Title" => "Sem título",
"Show module title" => "Exibir título do módulo",
// "Module displayed depending on category. Multiple category ids or names can be separated by semi-colons" => "Module displayed depending on category. Multiple category ids or names can be separated by semi-colons",
// "No Category" => "No Category",
// "Module hidden depending on category. Multiple category ids or names can be separated by semi-colons. This takes precedence over the category parameter above" => "Module hidden depending on category. Multiple category ids or names can be separated by semi-colons. This takes precedence over the category parameter above",
"Perspective" => "Perspectiva",
// "Only display the module if in one of the listed perspective IDs. Semi-colon separated" => "Only display the module if in one of the listed perspective IDs. Semi-colon separated",
// "Module only applicable for the specified languages. Languages are defined as two character language codes. Multiple values can be separated by semi-colons" => "Module only applicable for the specified languages. Languages are defined as two character language codes. Multiple values can be separated by semi-colons",
"Section" => "Seção",
// "Module only applicable for the specified sections. Multiple values can be separated by semi-colons" => "Module only applicable for the specified sections. Multiple values can be separated by semi-colons",
// "Page Filter" => "Page Filter",
// "Module only applicable on the specified page names. Multiple values can be separated by semi-colons" => "Module only applicable on the specified page names. Multiple values can be separated by semi-colons",
"No Page" => "Nenhuma página",
// "Module not applicable on the specified page names. Multiple values can be separated by semi-colons" => "Module not applicable on the specified page names. Multiple values can be separated by semi-colons",
"Theme" => "Tema",
// "Module enabled or disabled depending on the theme file name (e.g. \"thenews.css\"). Specified themes can be either included or excluded. Theme names prefixed by \"!\" are in the exclusion list. Multiple values can be separated by semi-colons" => "Module enabled or disabled depending on the theme file name (e.g. \"thenews.css\"). Specified themes can be either included or excluded. Theme names prefixed by \"!\" are in the exclusion list. Multiple values can be separated by semi-colons",
// "Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module" => "Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module",
// "Contributor" => "Contributor",
// "Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module" => "Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module",
// "Flip" => "Flip",
// "Users can shade module" => "Users can shade module",
"Style" => "Estilo",
// "CSS styling for positioning the module" => "CSS styling for positioning the module",
// "Class" => "Class",
// "Custom CSS class" => "Custom CSS class",
// "Containing Class" => "Containing Class",
// "Custom CSS class around" => "Custom CSS class around",
// "No Numbers" => "No Numbers",
// "If set to \"y\", the module will not number list items" => "If set to \"y\", the module will not number list items",
"Rows" => "Linhas",
// "Number of rows, or items, to display" => "Number of rows, or items, to display",
"Default: 10" => "Padrão: 10",
// "Failed to execute \"%0\" module" => "Failed to execute \"%0\" module",
// "Missing dependencies" => "Missing dependencies",
// "Contact the system administrator" => "Contact the system administrator",
// "Newsletter subscription information at" => "Newsletter subscription information at",
"Error" => "Erro",
// "Limiting the email send rate. Resuming in %0 seconds" => "Limiting the email send rate. Resuming in %0 seconds",
"invalid email" => "e-mail inválido",
// "Sending to" => "Sending to",
"A user registers" => "Um usuário se registrou",
"A user submits an article" => "Um usuário submeteu um artigo",
// "A user edits an article" => "A user edits an article",
// "A user deletes an article" => "A user deletes an article",
// "An article is submitted, edited, deleted or commented on" => "An article is submitted, edited, deleted or commented on",
// "A new blog post is published" => "A new blog post is published",
// "A wiki page is created, deleted or edited, except for minor changes" => "A wiki page is created, deleted or edited, except for minor changes",
// "A wiki page is created, deleted or edited, even for minor changes" => "A wiki page is created, deleted or edited, even for minor changes",
// "A comment in a wiki page is posted or edited" => "A comment in a wiki page is posted or edited",
// "A comment in an article is posted or edited" => "A comment in an article is posted or edited",
// "Token is called" => "Token is called",
// "User joins a group" => "User joins a group",
// "section edit" => "section edit",
"Edit Section" => "Editar Seção",
// "index" => "index",
"Table of contents" => "Tabela de conteúdo",
"Show/Hide" => "Mostrar/esconder",
// "smiling" => "smiling",
"sad" => "triste",
// "grinning" => "grinning",
"confused" => "confuso",
"cool" => "legal",
// "crying" => "crying",
// "frightened" => "frightened",
// "evil stuff" => "evil stuff",
// "exclamation mark " => "exclamation mark ",
// "frowning" => "frowning",
// "light bulb" => "light bulb",
// "idea " => "idea ",
// "LOL" => "LOL",
// "laughing out loud " => "laughing out loud ",
"mad" => "furioso",
// "Mr. Green laughing" => "Mr. Green laughing",
// "Payment sent but verification not currently available. (Work in progress)" => "Payment sent but verification not currently available. (Work in progress)",
// "Gift card is not valid for products in cart" => "Gift card is not valid for products in cart",
// "Bundled Product" => "Bundled Product",
// "Product" => "Product",
// "Quantity" => "Quantity",
// "Unit Price" => "Unit Price",
// "There is not enough inventory left for your request" => "There is not enough inventory left for your request",
// "Registration Check-Out" => "Registration Check-Out",
// "Gift Certificate: " => "Gift Certificate: ",
// "Gift Certificate Amount Used: " => "Gift Certificate Amount Used: ",
// "No registries specified in admin/payment/cclite" => "No registries specified in admin/payment/cclite",
// "Cclite payment initiated on %0" => "Cclite payment initiated on %0",
// "Connection to cclite server %0 failed for %1<br />\"%2\"" => "Connection to cclite server %0 failed for %1<br />\"%2\"",
// "Tiki credits payment done on %0 for %1 (using %2)" => "Tiki credits payment done on %0 for %1 (using %2)",
// "No category jail set in any perspective" => "No category jail set in any perspective",
// "Areas root category id" => "Areas root category id",
// "is invalid" => "is invalid",
"Ajax auto-save" => "Salvar automaticamente via ajax",
// "Saves your edits as you go along enabling you to recover your work after an \"interruption\". Also enables \"Live\" preview and is required for wysiwyg plugin processing" => "Saves your edits as you go along enabling you to recover your work after an \"interruption\". Also enables \"Live\" preview and is required for wysiwyg plugin processing",
// "Users accept internal messages by default" => "Users accept internal messages by default",
// "Users can opt-out of internal messages" => "Users can opt-out of internal messages",
// "Id of category whose children are bound to a perspective by areas" => "Id of category whose children are bound to a perspective by areas",
"Newest first" => "Mais novos em primeiro",
"ascending" => "crescente",
"descending" => "decrescente",
// "Article ordering" => "Article ordering",
// "Default sort mode for the articles on the article listing" => "Default sort mode for the articles on the article listing",
// "Title of articles home page" => "Title of articles home page",
"Topic" => "Assunto",
"Title" => "Título",
"Title length" => "Tamanho do título",
"Publication date" => "Data de publicação",
// "Expiration date" => "Expiration date",
"Visible" => "Visível",
"Author" => "Autor",
// "Author Rating" => "Author Rating",
"Reads" => "Leituras",
"Id" => "Id",
// "Trailer position" => "Trailer position",
"Top" => "Topo",
"Between heading and body" => "Entre o cabeçalho e o corpo",
// "Header text position" => "Header text position",
// "Requires a smaller image for list view" => "Requires a smaller image for list view",
"Next image" => "Próxima imagem",
// "Below image" => "Below image",
"Oldest first" => "Mais antigos em primeiro",
"Points" => "Pontos",
"Default number per page" => "Número por página padrão",
// "Default Ordering" => "Default Ordering",
"Paginate articles" => "Paginar artigos",
// "Divide articles into multiple pages with pagebreak markers" => "Divide articles into multiple pages with pagebreak markers",
// "User ratings on articles" => "User ratings on articles",
// "Allows users to rate the articles" => "Allows users to rate the articles",
// "Article rating options" => "Article rating options",
// "List of options available for the rating of articles" => "List of options available for the rating of articles",
// "Default maximum width for custom article images" => "Default maximum width for custom article images",
// "Number of pixels, 0 for no maximum" => "Number of pixels, 0 for no maximum",
// "Default maximum height for custom article images" => "Default maximum height for custom article images",
// "Default maximum width for custom article images in list mode (on View Articles)" => "Default maximum width for custom article images in list mode (on View Articles)",
// "Number of pixels, 0 to fallback to the view mode maximum" => "Number of pixels, 0 to fallback to the view mode maximum",
// "Default maximum height for custom article images in list mode (on View Articles)" => "Default maximum height for custom article images in list mode (on View Articles)",
// "Custom attributes for article types" => "Custom attributes for article types",
// "Allow additional custom fields for article types" => "Allow additional custom fields for article types",
// "Your ShareThis publisher identifier (optional)" => "Your ShareThis publisher identifier (optional)",
// "Related articles" => "Related articles",
// "Display a list of related articles at the bottom of the article page" => "Display a list of related articles at the bottom of the article page",
"Authentication method" => "Método de autenticação",
// "Tiki supports several authentication methods. The default value is to use the internal user database" => "Tiki supports several authentication methods. The default value is to use the internal user database",
"Tiki" => "Tiki",
"Tiki and OpenID" => "Tiki e OpenID",
"Tiki and PAM" => "Tiki e PAM",
"Tiki and LDAP" => "Tiki e LDAP",
"CAS (Central Authentication Service)" => "CAS (Sistema de Autenticação Central)",
// "Shibboleth" => "Shibboleth",
"Web Server" => "Servidor Web",
"phpBB" => "phpBB",
// "Token Access" => "Token Access",
// "Allow to access the content with superior rights with the presentation of a token. The primary use of this authentication method is to grant temporary access to content to an external service" => "Allow to access the content with superior rights with the presentation of a token. The primary use of this authentication method is to grant temporary access to content to an external service",
// "Token Access Max Timeout" => "Token Access Max Timeout",
// "The maximum duration for which the generated tokens will be valid" => "The maximum duration for which the generated tokens will be valid",
// "(seconds)" => "(seconds)",
// "Token Access Max Hits" => "Token Access Max Hits",
// "The maximum amount of times a token can be used before it expires" => "The maximum amount of times a token can be used before it expires",
// "Share access rights with friends when using Tell a friend" => "Share access rights with friends when using Tell a friend",
// "Allow users to share their access rights on the current page with a friend when sending the link by email. Lifespan of the links is defined by the site" => "Allow users to share their access rights on the current page with a friend when sending the link by email. Lifespan of the links is defined by the site",
// "Share access rights with friends when using Share" => "Share access rights with friends when using Share",
// "Allow users to share their access rights on the current page with a friend when sending the link by email/Twitter/Facebook. Lifespan of the links is defined by the site" => "Allow users to share their access rights on the current page with a friend when sending the link by email/Twitter/Facebook. Lifespan of the links is defined by the site",
// "Create user if not in Tiki" => "Create user if not in Tiki",
// "Use Tiki authentication for Admin login" => "Use Tiki authentication for Admin login",
// "phpBB Version" => "phpBB Version",
"3" => "3",
// "phpBB Database Hostname" => "phpBB Database Hostname",
// "phpBB Database Username" => "phpBB Database Username",
// "phpBB Database Password" => "phpBB Database Password",
// "phpBB Database Name" => "phpBB Database Name",
// "phpBB Table Prefix" => "phpBB Table Prefix",
// "Use Tiki authentication for users created in Tiki" => "Use Tiki authentication for users created in Tiki",
// "Host" => "Host",
"Port" => "Porta",
// "Write LDAP debug Information in Tiki Logs" => "Write LDAP debug Information in Tiki Logs",
// "Use SSL (ldaps)" => "Use SSL (ldaps)",
// "Use TLS" => "Use TLS",
// "LDAP Bind Type" => "LDAP Bind Type",
// "Default: Anonymous Bind" => "Default: Anonymous Bind",
// "Full: userattr=username,UserDN,BaseDN" => "Full: userattr=username,UserDN,BaseDN",
// "OpenLDAP: cn=username,BaseDN" => "OpenLDAP: cn=username,BaseDN",
// "Active Directory (username@domain)" => "Active Directory (username@domain)",
// "Plain Username" => "Plain Username",
// "Search scope" => "Search scope",
// "Subtree" => "Subtree",
// "One level" => "One level",
// "Base object" => "Base object",
// "LDAP version" => "LDAP version",
// "Base DN" => "Base DN",
// "User DN" => "User DN",
// "User attribute" => "User attribute",
// "User OC" => "User OC",
// "Realname attribute" => "Realname attribute",
// "Country attribute" => "Country attribute",
// "E-mail attribute" => "E-mail attribute",
// "Group DN" => "Group DN",
// "Group name attribute" => "Group name attribute",
// "Group description attribute" => "Group description attribute",
// "Group OC" => "Group OC",
// "Member attribute" => "Member attribute",
// "Member is DN" => "Member is DN",
// "Group attribute" => "Group attribute",
// "Group attribute in group entry" => "Group attribute in group entry",
// "(Leave this empty if the group name is already given in the user attribute)" => "(Leave this empty if the group name is already given in the user attribute)",
"Admin user" => "Usuário admin",
"Admin password" => "Senha do admin",
// "Use an external LDAP server for groups" => "Use an external LDAP server for groups",
// "Corresponding user attribute in 1st directory" => "Corresponding user attribute in 1st directory",
// "Disable Tiki users who don't have a phpBB login. (They could have been deleted)" => "Disable Tiki users who don't have a phpBB login. (They could have been deleted)",
"Available languages" => "Idiomas disponíveis",
// "By default, all languages supported by tikiwiki are available on multilingual sites. This option allows to limit the languages to a subset" => "By default, all languages supported by tikiwiki are available on multilingual sites. This option allows to limit the languages to a subset",
// "Available styles" => "Available styles",
// "BigBlueButton Web Conferencing" => "BigBlueButton Web Conferencing",
// "Integration with the BigBlueButton collaboration server for web conference and screen sharing" => "Integration with the BigBlueButton collaboration server for web conference and screen sharing",
// "BigBlueButton server location" => "BigBlueButton server location",
// "Full URL to the BigBlueButton installation" => "Full URL to the BigBlueButton installation",
// "http://host.example.com/" => "http://host.example.com/",
// "BigBlueButton server salt" => "BigBlueButton server salt",
// "A salt key used to generate checksums for the BigBlueButton server to know the requests are authentic" => "A salt key used to generate checksums for the BigBlueButton server to know the requests are authentic",
// "BigBlueButton recording maximum duration" => "BigBlueButton recording maximum duration",
// "A maximum duration for the meetings must be provided to BigBlueButton to prevent the recordings to be excessively long if a user leaves the window open too long" => "A maximum duration for the meetings must be provided to BigBlueButton to prevent the recordings to be excessively long if a user leaves the window open too long",
"minutes" => "minutos",
// "Default ordering" => "Default ordering",
"Creation Date (desc)" => "Data de criação (desc)",
"Last modification date (desc)" => "última data de modificação (desc)",
"Blog title (asc)" => "Título do Blog (asc)",
"Number of posts (desc)" => "Número de mensagens (desc)",
"Visits (desc)" => "Visitas (desc)",
"Activity (desc)" => "Atividade (desc)",
"Last modified" => "Última modificação em",
"Disabled" => "Desabilitado",
"Link to user information" => "Link para informações do usuário",
"User avatar" => "Fotografia do usuário",
"Posts" => "Mensagens",
"Visits" => "Visitas",
"Activity" => "Atividade",
// "Module (box) shadow start" => "Module (box) shadow start",
// "Module (box) shadow end" => "Module (box) shadow end",
// "Days to display in the Calendar" => "Days to display in the Calendar",
"Default view mode" => "Visualização padrão",
"Day" => "Dia",
"Week" => "Semana",
"Month" => "Mês",
"Quarter" => "Bimestre",
"Semester" => "Semestre",
"Year" => "Ano",
// "View list begins" => "View list begins",
// "Focus Date" => "Focus Date",
// "Period beginning" => "Period beginning",
"First day of the week" => "Primeiro dia da semana",
"Depends user language" => "Depende do idioma do usuário",
"Split hours in periods of" => "Dividir horas em períodos de",
"1 minute" => "1 minuto",
"5 minutes" => "5 minutos",
"10 minutes" => "10 minutos",
"15 minutes" => "15 minutos",
"30 minutes" => "30 minutos",
// "First year in the dropdown" => "First year in the dropdown",
// "Enter a year or use +/- N to specify a year relative to the current year" => "Enter a year or use +/- N to specify a year relative to the current year",
// "Last year in the dropdown" => "Last year in the dropdown",
// "Sticky popup" => "Sticky popup",
// "Item view tab" => "Item view tab",
// "Show Add to Google Calendar icon" => "Show Add to Google Calendar icon",
// "Show Export Calendars button" => "Show Export Calendars button",
// "Use FullCalendar to display Calendars" => "Use FullCalendar to display Calendars",
// "Treat calendar item descriptions as HTML" => "Treat calendar item descriptions as HTML",
// "Use this if you use the WYSIWYG editor for calendars. This is to handle legacy data from Tiki pre 7.0" => "Use this if you use the WYSIWYG editor for calendars. This is to handle legacy data from Tiki pre 7.0",
// "Word length of the captcha image" => "Word length of the captcha image",
"Default:" => "Padrão:",
// "Width of the captcha image in pixels" => "Width of the captcha image in pixels",
// "Level of noise of the captcha image" => "Level of noise of the captcha image",
// "Choose a smaller number for less noise and easier reading" => "Choose a smaller number for less noise and easier reading",
// "Try automatically to connect SSO" => "Try automatically to connect SSO",
// "Force CAS log-out when the user logs out from Tiki" => "Force CAS log-out when the user logs out from Tiki",
// "Show Alternate Login Method in Header" => "Show Alternate Login Method in Header",
"CAS server version" => "Versão do servidor CAS",
"none" => "nenhum",
"Version 1.0" => "Versão 1.0",
"Version 2.0" => "Versão 2.0",
// "Hostname" => "Hostname",
// "Hostname of the CAS server" => "Hostname of the CAS server",
// "Port of the CAS server" => "Port of the CAS server",
// "Path for the CAS server" => "Path for the CAS server",
// "CAS Extra Parameter" => "CAS Extra Parameter",
// "Extra Parameter to pass to the CAS Server" => "Extra Parameter to pass to the CAS Server",
// "CAS Authentication Verification Timeout" => "CAS Authentication Verification Timeout",
// "Verify authentication with the CAS server every N seconds. Null value means never reverify" => "Verify authentication with the CAS server every N seconds. Null value means never reverify",
"Never" => "Nunca",
"2 minutes" => "2 minutos",
"1 hour" => "1 hora",
// "Categories used in templates (TPL)" => "Categories used in templates (TPL)",
// "Permits to show alternate content depending on category of current object" => "Permits to show alternate content depending on category of current object",
// "Category Jail" => "Category Jail",
// "Limits the visibility of objects to those in these category IDs. Used mainly for creating workspaces from perspectives" => "Limits the visibility of objects to those in these category IDs. Used mainly for creating workspaces from perspectives",
// "Category Defaults" => "Category Defaults",
// "Force certain categories to be present. If none of the categories in a given set are provided, assign a category by default" => "Force certain categories to be present. If none of the categories in a given set are provided, assign a category by default",
// "Use *7 to specify all the categories in the subtree of 7 + category 7" => "Use *7 to specify all the categories in the subtree of 7 + category 7",
// "Can do only this for objectname matching the regex (Example: /^RND_/ = name beginning by RND_)(Optional)" => "Can do only this for objectname matching the regex (Example: /^RND_/ = name beginning by RND_)(Optional)",
// "Can do for wiki only (optional)" => "Can do for wiki only (optional)",
// "Rename will only reassign the categories for wiki pages" => "Rename will only reassign the categories for wiki pages",
// "One per line. ex:1,4,6,*7/4:/^RND_/:wiki page" => "One per line. ex:1,4,6,*7/4:/^RND_/:wiki page",
// "Synchronize multilingual categories" => "Synchronize multilingual categories",
// "Make sure that the categories on the translations are synchronized when modified on any version" => "Make sure that the categories on the translations are synchronized when modified on any version",
// "Only those specified" => "Only those specified",
// "All but those specified" => "All but those specified",
// "Synchronized categories" => "Synchronized categories",
// "List of categories affected by the multilingual synchronization. Depending on the parent feature, this list will be used as a white list (only categories allows) or as a black list (all except thoses specified)" => "List of categories affected by the multilingual synchronization. Depending on the parent feature, this list will be used as a white list (only categories allows) or as a black list (all except thoses specified)",
// "Sort categories by legacy ASCII sequence" => "Sort categories by legacy ASCII sequence",
// "If turned on, will sort categories taking into account all characters as upper case, in ASCII sequence, will only consider limited set of accented characters. Might be needed to be able to override the normal sort by prepending punctuation characters to category names, such as \"-\" to sort at the beginning and \"[\" to sort at the end" => "If turned on, will sort categories taking into account all characters as upper case, in ASCII sequence, will only consider limited set of accented characters. Might be needed to be able to override the normal sort by prepending punctuation characters to category names, such as \"-\" to sort at the beginning and \"[\" to sort at the end",
// "Automatically geocode items when categorized in" => "Automatically geocode items when categorized in",
// "Automatically geocode items based on category name when categorized in the sub-categories of this category ID" => "Automatically geocode items based on category name when categorized in the sub-categories of this category ID",
// "Replace existing geocode if any" => "Replace existing geocode if any",
// "When automatically geocoding items based on category name, replace existing geocode if any" => "When automatically geocoding items based on category name, replace existing geocode if any",
// "Use approximate geocode location" => "Use approximate geocode location",
// "When automatically geocoding items based on category name, use randomly approximated location instead of precise location" => "When automatically geocoding items based on category name, use randomly approximated location instead of precise location",
// "\"More Like This\" algorithm for categories" => "\"More Like This\" algorithm for categories",
// "Basic" => "Basic",
// "Weighted" => "Weighted",
// "Minimum number of categories in common" => "Minimum number of categories in common",
"1" => "1",
"2" => "2",
"4" => "4",
"5" => "5",
"6" => "6",
"7" => "7",
"8" => "8",
"9" => "9",
// "10" => "10",
// "Or look for the maximum less categories in common if no objects with the above number of common categories" => "Or look for the maximum less categories in common if no objects with the above number of common categories",
// "Maximum of objects more like this, otherwise use the default max records" => "Maximum of objects more like this, otherwise use the default max records",
// "Exclude these category IDs" => "Exclude these category IDs",
// "Category path won't appear for these category IDs" => "Category path won't appear for these category IDs",
// "Center shadow start" => "Center shadow start",
// "Center shadow end" => "Center shadow end",
"Users can change site language" => "Usuários podem mudar o idioma do site",
// "Allow users to change the language of the menus and labels" => "Allow users to change the language of the menus and labels",
"Users can change theme" => "Usuários comuns podem alterar tema",
"Users can change their password" => "Usuários podem mudar sua senha",
"Disable title for comments" => "Desabilitar título para comentários",
// "Hide the title field on comments and their replies" => "Hide the title field on comments and their replies",
// "Email field" => "Email field",
// "Email field for comments (only for anonymous users)" => "Email field for comments (only for anonymous users)",
// "Website field" => "Website field",
// "Website field for comments (only for anonymous users)" => "Website field for comments (only for anonymous users)",
// "Use vote system for comments" => "Use vote system for comments",
// "Allows users with permission tiki_p_vote_comments to vote comments" => "Allows users with permission tiki_p_vote_comments to vote comments",
// "Archive comments" => "Archive comments",
// "If a comment is archived, only admins can see it" => "If a comment is archived, only admins can see it",
// "Use Akismet to filter comments" => "Use Akismet to filter comments",
// "Prevent comment spam by using the Akismet service to determine if the comment is spam. If comment moderation is enabled, the Akismet will indicate if the comment is to be moderated or not. If there is no comment moderation, the comment will be rejected if considered as spam" => "Prevent comment spam by using the Akismet service to determine if the comment is spam. If comment moderation is enabled, the Akismet will indicate if the comment is to be moderated or not. If there is no comment moderation, the comment will be rejected if considered as spam",
// "Akismet API Key" => "Akismet API Key",
// "Key required for the Akismet comment spam prevention to work" => "Key required for the Akismet comment spam prevention to work",
// "Obtain this key by registering your site on [%0]" => "Obtain this key by registering your site on [%0]",
// "Filter spam for registered users" => "Filter spam for registered users",
// "Enable spam filtering for registered users as well. Useful if your site allows for anyone to register without much validation" => "Enable spam filtering for registered users as well. Useful if your site allows for anyone to register without much validation",
// "Allow comments to be corrected by their author" => "Allow comments to be corrected by their author",
// "Allow comments to be modified by their author shortly after posting it, allowing to correct broken links or typos for a period of 30 minutes" => "Allow comments to be modified by their author shortly after posting it, allowing to correct broken links or typos for a period of 30 minutes",
// "Tiki Connect" => "Tiki Connect",
// "Connect your Tiki with the community by sending anonymised statistical data to tiki.org" => "Connect your Tiki with the community by sending anonymised statistical data to tiki.org",
// "Experimental. This feature is still under development" => "Experimental. This feature is still under development",
// "Send Site Information" => "Send Site Information",
// "Additionally send keywords, location etc to tiki.org so you can connect with Tikis near you" => "Additionally send keywords, location etc to tiki.org so you can connect with Tikis near you",
// "Site Title" => "Site Title",
// "Name of site on Tiki Connect" => "Name of site on Tiki Connect",
// "Email Contact" => "Email Contact",
// "Email to register" => "Email to register",
// "URL to register" => "URL to register",
// "Key Words" => "Key Words",
// "Key words or tags describing your site" => "Key words or tags describing your site",
// "Site Location" => "Site Location",
// "Site location as longitude,latitude,zoom" => "Site location as longitude,latitude,zoom",
// "Send Anonymous Information" => "Send Anonymous Information",
// "Send anonymous usage information" => "Send anonymous usage information",
// "Connection frequency" => "Connection frequency",
// "How often to send information (in hours)" => "How often to send information (in hours)",
// "weekly" => "weekly",
// "Experimental. Currently unused, click \"Send Info\" to connect" => "Experimental. Currently unused, click \"Send Info\" to connect",
// "Tiki Connect Server URL" => "Tiki Connect Server URL",
// "Where to send the information" => "Where to send the information",
// "Last connection" => "Last connection",
// "Connect Server Mode" => "Connect Server Mode",
// "For use by mother.tiki.org" => "For use by mother.tiki.org",
// "Connect GUID" => "Connect GUID",
// "For use by mother.tiki.org. Do not modify" => "For use by mother.tiki.org. Do not modify",
// "Allow anonymous visitors to use the \"Contact Us\" feature" => "Allow anonymous visitors to use the \"Contact Us\" feature",
"Contact user" => "Usuário para contato",
// "Cookie name" => "Cookie name",
"Domain" => "Domínio",
"Count admin pageviews" => "Contar visitas do admin",
// "Include pageviews by the Admin when reporting stats" => "Include pageviews by the Admin when reporting stats",
// "Enable daily reports for new users" => "Enable daily reports for new users",
// "Default charset for sending mail" => "Default charset for sending mail",
"utf-8" => "utf-8",
"iso-8859-1" => "iso-8859-1",
"default mapfile" => "arquivo de mapa padrão",
// "Default diff style" => "Default diff style",
"Only with last version" => "Apenas com a última versão",
// "HTML diff" => "HTML diff",
"Side-by-side diff" => "Comparar diferentes versões lado-a-lado",
// "Side-by-side diff by characters" => "Side-by-side diff by characters",
// "Inline diff" => "Inline diff",
// "Inline diff by characters" => "Inline diff by characters",
"Full side-by-side diff" => "Comparar diferentes versões lado-a-lado completo",
// "Full side-by-side diff by characters" => "Full side-by-side diff by characters",
// "Full inline diff" => "Full inline diff",
// "Full inline diff by characters" => "Full inline diff by characters",
"Unified diff" => "Comparar diferentes versões unificado",
"Side-by-side view" => "Visualizar lado a lado",
"rows" => "linhas",
// "Default number of rows for comment box" => "Default number of rows for comment box",
"Forum" => "Fórum",
// "Forum reply" => "Forum reply",
// "Default Editor" => "Default Editor",
"Simple" => "Simples",
"Advanced" => "Avançado",
// "Disable browser's autocomplete feature for username and password fields" => "Disable browser's autocomplete feature for username and password fields",
"Use direct pagination links" => "Links de paginação direta",
// "Max. number of links around the current item" => "Max. number of links around the current item",
// "Max. number of links after the first or before the last item" => "Max. number of links after the first or before the last item",
"Show Country Flag" => "Mostrar bandeira do país",
"Show the country flag" => "Mostrar bandeira do país",
// "Enable cool sites" => "Enable cool sites",
"Validate URLs" => "Validar Endereços",
// "Number of columns per page when listing directory categories" => "Number of columns per page when listing directory categories",
"Links per page" => "Links por página",
// "Method to Open Directory Links" => "Method to Open Directory Links",
"Method to open directory links" => "Abrindo links do diretório",
"replace current window" => "substituir a janela atual",
"new window" => "nova janela",
"inline frame" => "frame interno",
"Fields display order" => "Ordem de exibição dos campos",
// "Re-validate user by email after" => "Re-validate user by email after",
"days" => "dias",
"Use \"-1\" for never" => "Use \"-1\" para nunca",
// "Email footer" => "Email footer",
// "Text appended to outgoing emails" => "Text appended to outgoing emails",
"PHP errors visible to admin only" => "Erros do PHP visíveis apenas para admins",
// "For development purposes, it's better to display errors for all users. However, in production settings, they should only be displayed to administrators" => "For development purposes, it's better to display errors for all users. However, in production settings, they should only be displayed to administrators",
// "PHP Error reporting level" => "PHP Error reporting level",
// "Level from which errors should be reported" => "Level from which errors should be reported",
"No error reporting" => "Não reportar erros",
// "Report all PHP errors except strict" => "Report all PHP errors except strict",
"Report all PHP errors" => "Reportar todos os erros de PHP",
// "Report all PHP errors except notices" => "Report all PHP errors except notices",
// "According to PHP configuration" => "According to PHP configuration",
"Default number of comments per page" => "Número padrão de comentários por página",
"Comments default ordering" => "Ordenação padrão para comentários",
// "Question and Answer prefix on Answers" => "Question and Answer prefix on Answers",
// "Q and A" => "Q and A",
// "Question ID" => "Question ID",
"Blog" => "Blog",
// "Force and limit categorization to within subtree of" => "Force and limit categorization to within subtree of",
// "If you get an error message indicating a mandatory category is required when editing a blog post, this is the option to blame. Set it to None" => "If you get an error message indicating a mandatory category is required when editing a blog post, this is the option to blame. Set it to None",
// "Areas" => "Areas",
// "Binding categories and perspectives to each other" => "Binding categories and perspectives to each other",
// "Collaboratively authored documents with history of changes" => "Collaboratively authored documents with history of changes",
// "Online diaries or journals" => "Online diaries or journals",
// "Collections of graphic images for viewing or downloading (photo album)" => "Collections of graphic images for viewing or downloading (photo album)",
// "You can use file galleries instead" => "You can use file galleries instead",
// "Machine Translation (by Google Translate)" => "Machine Translation (by Google Translate)",
// "Uses Google Translate to translate the content of wiki pages to other languages" => "Uses Google Translate to translate the content of wiki pages to other languages",
"Experimental" => "Experimental",
// "Database & form generator" => "Database & form generator",
// "Reports" => "Reports",
// "Reports Generator" => "Reports Generator",
// "Online discussions on a variety of topics. Threaded or flat" => "Online discussions on a variety of topics. Threaded or flat",
// "Computer files, videos or software for downloading. With check-in & check-out (lock)" => "Computer files, videos or software for downloading. With check-in & check-out (lock)",
// "Save files as drafts" => "Save files as drafts",
// "File Galleries configuration templates" => "File Galleries configuration templates",
"template" => "padrão",
// "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"" => "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"",
"Polls" => "Enquetes",
// "Brief list of votable options; appears in module (left or right column)" => "Brief list of votable options; appears in module (left or right column)",
"Newsletters" => "Comunicados",
// "Content mailed to registered users" => "Content mailed to registered users",
"Calendar" => "Calendário",
// "Events calendar with public, private and group channels" => "Events calendar with public, private and group channels",
"Banners" => "Banners",
// "Insert, track, and manage advertising banners" => "Insert, track, and manage advertising banners",
// "Global category system. Items of different types (wiki pages, articles, tracker items, etc) can be added to one or many categories. Categories can have permissions" => "Global category system. Items of different types (wiki pages, articles, tracker items, etc) can be added to one or many categories. Categories can have permissions",
"Score" => "Pontuação",
// "Score is a game to motivate participants to increase their contribution by comparing to other users" => "Score is a game to motivate participants to increase their contribution by comparing to other users",
// "Unified Search" => "Unified Search",
// "Enables searching for content on the website, using Tiki-managed index" => "Enables searching for content on the website, using Tiki-managed index",
// "Allows to set tags on pages and various objects within the website and generate tag cloud navigation patterns" => "Allows to set tags on pages and various objects within the website and generate tag cloud navigation patterns",
"Action Log" => "Log de atividades",
// "Allows to keep track of what users are doing and produce reports on a per-user or per-category basis" => "Allows to keep track of what users are doing and produce reports on a per-user or per-category basis",
"Contribution" => "Contribuição",
// "Allows users to specify the type of contribution they are making while editing objects. The contributions are then displayed as color-coded in history and other reports" => "Allows users to specify the type of contribution they are making while editing objects. The contributions are then displayed as color-coded in history and other reports",
"Multilingual" => "Multilíngüe",
// "Enables internationalization features and multilingual support for then entire site" => "Enables internationalization features and multilingual support for then entire site",
"FAQ" => "FAQ",
// "Frequently asked questions and answers" => "Frequently asked questions and answers",
// "You can use wiki pages instead" => "You can use wiki pages instead",
"Surveys" => "Pesquisas",
// "Questionnaire with multiple choice or open ended question" => "Questionnaire with multiple choice or open ended question",
// "User-submitted Web links" => "User-submitted Web links",
// "Timed questionnaire with recorded scores" => "Timed questionnaire with recorded scores",
"Featured Links" => "Links oferecidos",
// "Simple menu system which can optionally add an external web page in an iframe" => "Simple menu system which can optionally add an external web page in an iframe",
"Copyright" => "Copyright",
// "The Copyright Management System (or ©MS) is a way of licensing your content" => "The Copyright Management System (or ©MS) is a way of licensing your content",
"Shoutbox" => "Mural",
// "Quick comment (graffiti) box. Like a group chat, but not in real time" => "Quick comment (graffiti) box. Like a group chat, but not in real time",
// "MapServer" => "MapServer",
// "Navigable, interactive maps with user-selectable layers" => "Navigable, interactive maps with user-selectable layers",
// "Requires MapServer" => "Requires MapServer",
"Google Maps" => "Google Maps",
// "Interactive use of Google Maps" => "Interactive use of Google Maps",
"Live support system" => "Sistema de auxílio on-line",
// "One-on-one chatting with customer" => "One-on-one chatting with customer",
"Tell a Friend" => "Envie para um amigo",
// "Add a link \"Email this page\" in all the pages" => "Add a link \"Email this page\" in all the pages",
"Share" => "Compartilhar",
// "Add a \"Share\" link in all pages to send it via e-mail, Twitter, Facebook, message or forums" => "Add a \"Share\" link in all pages to send it via e-mail, Twitter, Facebook, message or forums",
// "be careful when allowing to anonymous to activate the antibot feature" => "be careful when allowing to anonymous to activate the antibot feature",
"HTML pages" => "Páginas HTML",
"Static and dynamic HTML content" => "Conteúdo HTML estático e dinâmico",
// "HTML can be used in wiki pages. This is a separate feature" => "HTML can be used in wiki pages. This is a separate feature",
"Contact Us" => "Entre em Contato",
// "Basic form from visitor to admin" => "Basic form from visitor to admin",
// "Minichat" => "Minichat",
// "Real-time group text chatting" => "Real-time group text chatting",
"Comments Moderation" => "Moderação de comentários",
// "An admin must validate a comment before it is visible" => "An admin must validate a comment before it is visible",
// "Comments Locking" => "Comments Locking",
// "Comments can be closed (no new comments)" => "Comments can be closed (no new comments)",
// "Allow logged in users to pretend to be anonymous when posting a commment" => "Allow logged in users to pretend to be anonymous when posting a commment",
// "This can be used to encourage honest feedback with the opportunity to voice an opinion anonymously. Like in a forum where you ask feedback on what is done wrong or should be improved internally" => "This can be used to encourage honest feedback with the opportunity to voice an opinion anonymously. Like in a forum where you ask feedback on what is done wrong or should be improved internally",
"Display page description" => "Mostrar descrição da página",
// "Display the page description below the heading when viewing the page" => "Display the page description below the heading when viewing the page",
"Display page name as page title" => "Mostrar nome da página como título da página",
// "Display the page name at the top of each page as page title. If not enabled, the page content should be structured to contain a header" => "Display the page name at the top of each page as page title. If not enabled, the page content should be structured to contain a header",
"Display page ID" => "Mostrar ID da página",
// "Display the internal page ID when viewing the page" => "Display the internal page ID when viewing the page",
// "Individual wiki cache" => "Individual wiki cache",
// "Allow users to change the duration of the cache on a per-page basis" => "Allow users to change the duration of the cache on a per-page basis",
// "JS Calendar" => "JS Calendar",
// "JavaScript popup date selector. Will use jQuery UI DatePicker if enabled" => "JavaScript popup date selector. Will use jQuery UI DatePicker if enabled",
// "Output should be HTML Purified" => "Output should be HTML Purified",
// "This enables HTML Purifier on outputs to filter potential remaining security problems like XSS" => "This enables HTML Purifier on outputs to filter potential remaining security problems like XSS",
"Full Screen" => "Tela cheia",
"Allow users to activate fullscreen mode" => "Permitir que usuários ativem o modo tela cheia",
// "CSS Menus" => "CSS Menus",
// "CSS Menus (suckerfish)" => "CSS Menus (suckerfish)",
// "Shadowbox / ColorBox" => "Shadowbox / ColorBox",
// "\"Displaying content with Eye Candy\". <br />Uses jQuery plugin \"ColorBox\". e.g. <code>{img fileId=\"42\" thumb=\"y\" alt=\"\" rel=\"box[g]\"}</code>" => "\"Displaying content with Eye Candy\". <br />Uses jQuery plugin \"ColorBox\". e.g. <code>{img fileId=\"42\" thumb=\"y\" alt=\"\" rel=\"box[g]\"}</code>",
// "Quick Permission Assignment" => "Quick Permission Assignment",
// "Quickperms allow to define classes of privileges and grant them to roles on objects" => "Quickperms allow to define classes of privileges and grant them to roles on objects",
// "HTML Purifier" => "HTML Purifier",
// "If you are trying to use HTML in your pages and it gets stripped out, you should make sure your HTML is valid or de-activate this feature" => "If you are trying to use HTML in your pages and it gets stripped out, you should make sure your HTML is valid or de-activate this feature",
"Ajax" => "Ajax",
// "Morcego 3D browser" => "Morcego 3D browser",
// "Visualize relationships between wiki pages, in a 3D applet" => "Visualize relationships between wiki pages, in a 3D applet",
"Webmail" => "Webmail",
"Intertiki" => "Intertiki",
// "Allows several Tiki sites (slaves) to get authentication from a master Tiki site" => "Allows several Tiki sites (slaves) to get authentication from a master Tiki site",
"Mail-in" => "Mail-in",
// "Populate wiki pages and articles by email" => "Populate wiki pages and articles by email",
// "Mindmap" => "Mindmap",
// "Print Indexed" => "Print Indexed",
"Spreadsheet" => "Planilha",
// "Datasheets with calculations and charts" => "Datasheets with calculations and charts",
// "Slideshow (jQuery.s5)" => "Slideshow (jQuery.s5)",
// "Web based slideshow" => "Web based slideshow",
// "Slideshow (jQuery.s5) PDF Export" => "Slideshow (jQuery.s5) PDF Export",
// "Web based slideshow to pdf export" => "Web based slideshow to pdf export",
// "Invoice" => "Invoice",
// "Invoice system" => "Invoice system",
"Wysiwyg editor" => "Editor Wysiwyg",
// "WYSIWYG is an acronym for What You See Is What You Get. Uses CKEditor" => "WYSIWYG is an acronym for What You See Is What You Get. Uses CKEditor",
// "Kaltura Video Management" => "Kaltura Video Management",
// "Integration to the Kaltura video management platform" => "Integration to the Kaltura video management platform",
"Friendship Network" => "Rede de amigos",
// "Users can identify other users as their friends" => "Users can identify other users as their friends",
// "Neglected feature" => "Neglected feature",
"Banning system" => "Sistema de banimento",
// "Deny access to specific users based on username, IP, and date/time range" => "Deny access to specific users based on username, IP, and date/time range",
"Stats" => "Estatísticas",
// "Record basic statistics about major Tiki features (number of wiki pages, size of file galleries, etc.)" => "Record basic statistics about major Tiki features (number of wiki pages, size of file galleries, etc.)",
// "Action Calendar" => "Action Calendar",
"Referer Stats" => "Estatísticas de Referências",
// "Record domain name of sites that send visitors to this Tiki" => "Record domain name of sites that send visitors to this Tiki",
"Redirect On Error" => "Redirecionar em caso de erro",
// "On error, goto the HomePage as configured in Admin->General" => "On error, goto the HomePage as configured in Admin->General",
"Communications (send/receive objects)" => "Comunicação (enviar/receber objetos)",
// "Send/receive wiki pages and articles between Tiki-powered sites" => "Send/receive wiki pages and articles between Tiki-powered sites",
"Custom Home" => "Página Inicial Personalizada",
"Mini Calendar" => "Mini-Calendário",
"User Preferences Screen" => "Tela de Preferências do Usuário",
"User Notepad" => "Bloco de notas do usuário",
"My Bookmarks" => "Bookmarks de usuários",
"User Contacts" => "Contatos do usuário",
"User Watches" => "Notificações do usuário",
// "Receive email notification of changes" => "Receive email notification of changes",
// "Group Watches" => "Group Watches",
// "Daily Reports for User Watches" => "Daily Reports for User Watches",
"User Watches Translations" => "Usuários acompanham as traduções",
// "User Watches Languages" => "User Watches Languages",
// "Watch language-specific changes within a category" => "Watch language-specific changes within a category",
"User Menu" => "Menu do Usuário",
"User Tasks" => "Tarefas do usuário",
"User Messages" => "Mensagens do usuário",
"User Files" => "Arquivos do usuário",
// "Menu User Levels" => "Menu User Levels",
// "Allows to control the menu options that can be seen by a user" => "Allows to control the menu options that can be seen by a user",
// "Group Alert" => "Group Alert",
"Integrator" => "Integrador",
"XMLRPC API" => "API de XMLRPC",
"Debugger Console" => "Console de depuração",
// "TikiTests" => "TikiTests",
// "Permits recording and playback of functional tests" => "Permits recording and playback of functional tests",
"Check for updates automatically" => "Verificar atualizações automaticamente",
// "Tiki will check for updates when you access the main Administration page" => "Tiki will check for updates when you access the main Administration page",
// "Require confirmation if possible CSRF detected" => "Require confirmation if possible CSRF detected",
"Protect against CSRF with a ticket" => "Proteger contar CSRF com um ticket",
"Detect browser language" => "Detectar idioma do navegador",
// "Lookup the user's preferred language through browser preferences" => "Lookup the user's preferred language through browser preferences",
"Show pages in user's preferred language" => "Mostrar páginas no idioma padrão do usuário",
// "When accessing a page which has an equivalent in the user's preferred language, favor the translated page" => "When accessing a page which has an equivalent in the user's preferred language, favor the translated page",
// "Changing the page language also changes the site language" => "Changing the page language also changes the site language",
// "Translation assistant" => "Translation assistant",
// "Track translation operations between pages" => "Track translation operations between pages",
// "Urgent translation notifications" => "Urgent translation notifications",
// "Allow to flag changes as urgent, leading translations to be marked with a notice visible to all users" => "Allow to flag changes as urgent, leading translations to be marked with a notice visible to all users",
// "Incomplete translation notice" => "Incomplete translation notice",
// "When a page is translated to a new language, a notice will be automatically inserted into the page to indicate that the translation is not yet complete" => "When a page is translated to a new language, a notice will be automatically inserted into the page to indicate that the translation is not yet complete",
// "Multilingual structures" => "Multilingual structures",
// "Structures to lookup equivalent pages in other languages. May cause performance problems on larger structures" => "Structures to lookup equivalent pages in other languages. May cause performance problems on larger structures",
// "Display all languages in a single page" => "Display all languages in a single page",
// "List all languages as a language option in the page language drop list to see all languages at once" => "List all languages as a language option in the page language drop list to see all languages at once",
// "GZip output" => "GZip output",
// "Compress your pages on-the-fly, if the requesting browser supports this" => "Compress your pages on-the-fly, if the requesting browser supports this",
"Help System" => "Sistema de Ajuda",
// "Yahoo! Babel Fish Translation URLs" => "Yahoo! Babel Fish Translation URLs",
// "Show clickable URLs to translate the page to another language using Babel Fish website" => "Show clickable URLs to translate the page to another language using Babel Fish website",
// "You need to assign somewhere on the page via a module" => "You need to assign somewhere on the page via a module",
// "Yahoo! Babel Fish Translation icons" => "Yahoo! Babel Fish Translation icons",
// "Show clickable icons to translate the page to another language using Babel Fish website" => "Show clickable icons to translate the page to another language using Babel Fish website",
"Smileys" => "Emoticons",
// "Also known as emoticons" => "Also known as emoticons",
// "Draw (SVG-edit)" => "Draw (SVG-edit)",
// "Draw gives you the ability to edit SVG images all around Tiki" => "Draw gives you the ability to edit SVG images all around Tiki",
// "Draw (SVG-edit) Hide Buttons" => "Draw (SVG-edit) Hide Buttons",
// "Hide buttons found in Tiki Draw, HTML id, comma-delimited.  Example: \"tool_select,tool_fhpath,tools_line_show,tools_rect_show,tools_ellipse_show,tool_path,tools_shapelib_show,tool_text,tool_image,tool_zoom,tool_eyedropper\"" => "Hide buttons found in Tiki Draw, HTML id, comma-delimited.  Example: \"tool_select,tool_fhpath,tools_line_show,tools_rect_show,tools_ellipse_show,tool_path,tools_shapelib_show,tool_text,tool_image,tool_zoom,tool_eyedropper\"",
// "Docs (WebODF)" => "Docs (WebODF)",
// "Docs gives you the ability to view/edit Open Document Format" => "Docs gives you the ability to view/edit Open Document Format",
"Dynamic Content System" => "Sistema de Conteúdo Dinâmico",
// "Bloc of content which can be reused and programmed (timed)" => "Bloc of content which can be reused and programmed (timed)",
// "Use File Galleries to store pictures" => "Use File Galleries to store pictures",
// "If disabled, pictures will be stored in ../img/wiki_up/.. instead" => "If disabled, pictures will be stored in ../img/wiki_up/.. instead",
// "External link icon" => "External link icon",
// "External links will be identifed with an icon. Use the ../img/icons/external_link.gif image to customize the icon" => "External links will be identifed with an icon. Use the ../img/icons/external_link.gif image to customize the icon",
// "Add \"rel=nofollow\" on external links" => "Add \"rel=nofollow\" on external links",
// "Semantic links" => "Semantic links",
// "Going beyond Backlinks, allows to define some semantic relationships between wiki pages" => "Going beyond Backlinks, allows to define some semantic relationships between wiki pages",
// "Web Services" => "Web Services",
// "Can consume webservices in JSON or YAML" => "Can consume webservices in JSON or YAML",
"Display menus as folders" => "Exibir menus como pastas",
// "Breadcrumbs" => "Breadcrumbs",
// "Attempts to show you where you are" => "Attempts to show you where you are",
// "Anonymous editors must enter anti-bot code (CAPTCHA)" => "Anonymous editors must enter anti-bot code (CAPTCHA)",
// "Protect email against spam" => "Protect email against spam",
// "Protect email against spam currently does not operate in pages edited in WYSIWYG mode (Tiki 6.1)" => "Protect email against spam currently does not operate in pages edited in WYSIWYG mode (Tiki 6.1)",
"Activate" => "Ativar",
// "Anonymous voting" => "Anonymous voting",
// "Allow re-voting" => "Allow re-voting",
// "Comments for polls" => "Comments for polls",
// "Comments for FAQs" => "Comments for FAQs",
// "Search engine friendly URL" => "Search engine friendly URL",
// "If you are using Apache, you can copy _htaccess to .htaccess to get Short URLs. On IIS, copy web_config to web.config" => "If you are using Apache, you can copy _htaccess to .htaccess to get Short URLs. On IIS, copy web_config to web.config",
// "Search engine friendly url Postfilter" => "Search engine friendly url Postfilter",
// "Display article title in the sefurl" => "Display article title in the sefurl",
// "Display blog title in the SEFURL" => "Display blog title in the SEFURL",
// "Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page" => "Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page",
// "This redirection uses the wiki prefix alias feature" => "This redirection uses the wiki prefix alias feature",
// "Canonical URL tag" => "Canonical URL tag",
// "Indicates to search engines which URL to use which prevents duplicate listings" => "Indicates to search engines which URL to use which prevents duplicate listings",
// "Show module controls" => "Show module controls",
// "Perspectives" => "Perspectives",
// "Permits to override preferences" => "Permits to override preferences",
// "Search and replace" => "Search and replace",
// "Permits find and replace of content in the edit box" => "Permits find and replace of content in the edit box",
"Submissions" => "Artigos submetidos",
// "Submissions are sent in but need to be approved before they go live" => "Submissions are sent in but need to be approved before they go live",
"Rankings" => "Rankings",
// "Comments for articles" => "Comments for articles",
// "Article content templates" => "Article content templates",
// "template article news" => "template article news",
// "Predefined content for a news article" => "Predefined content for a news article",
"Print" => "Imprimir",
// "Specify notification emails when creating articles" => "Specify notification emails when creating articles",
// "ShareThis buttons" => "ShareThis buttons",
// "Insert a ShareThis button from www.sharethis.com" => "Insert a ShareThis button from www.sharethis.com",
// "Category Path" => "Category Path",
// "Show category tree, above wiki pages" => "Show category tree, above wiki pages",
// "Show category objects" => "Show category objects",
// "Show objects sharing the same category, below wiki pages" => "Show objects sharing the same category, below wiki pages",
"Ignore category viewing restrictions" => "Ignorar restrições para visualizar categorias",
// "Will improve performance, but may show forbidden results" => "Will improve performance, but may show forbidden results",
"List pages" => "Listar páginas",
"Latest Changes" => "Últimas alterações",
"Orphan pages" => "Páginas órfãs",
// "MySQL Full-Text Search" => "MySQL Full-Text Search",
// "This search uses the MySQL Full-Text Search feature. The indexation is continuously updated" => "This search uses the MySQL Full-Text Search feature. The indexation is continuously updated",
"Referer Search Highlighting" => "Destacar busca",
"Search stats" => "Estatísticas de busca",
"Ignore individual object permissions" => "Ignorar permissões individuais para objeto",
"Object filter" => "Filtro de objetos",
"Search box" => "Busca",
// "Pertinence" => "Pertinence",
// "Object type" => "Object type",
"Last modified date" => "Data da última modificação",
// "Custom blog headings" => "Custom blog headings",
// "Using custom blog headings will use significantly more server resources. Unless you need per-blog templates, you should use a customize the template file" => "Using custom blog headings will use significantly more server resources. Unless you need per-blog templates, you should use a customize the template file",
// "Publish dates can be modified" => "Publish dates can be modified",
// "Comments on blog posts" => "Comments on blog posts",
// "Insert a ShareThis button from [http://www.sharethis.com]" => "Insert a ShareThis button from [http://www.sharethis.com]",
// "File Gallery Comments" => "File Gallery Comments",
// "Use file galleries for user files" => "Use file galleries for user files",
// "experimental" => "experimental",
// "Use file galleries for wiki attachments" => "Use file galleries for wiki attachments",
"Batch uploading" => "Envio de arquivos em lote",
// "Direct import of local files into a File Gallery. Can handle large files. User can upload file via FTP to target folder" => "Direct import of local files into a File Gallery. Can handle large files. User can upload file via FTP to target folder",
// "Use batch uploading to integrate large files into File Galleries" => "Use batch uploading to integrate large files into File Galleries",
"Accept wiki syntax" => "Aceitar sintaxe Wiki",
// "Topic archiving" => "Topic archiving",
// "Quick jumps" => "Quick jumps",
// "Replies are empty" => "Replies are empty",
// "If disabled, replies will quote the original post" => "If disabled, replies will quote the original post",
// "First post of a thread can have an empty body" => "First post of a thread can have an empty body",
// "Will be a thread title" => "Will be a thread title",
// "Forum name search" => "Forum name search",
// "When listing forums" => "When listing forums",
// "Forum content search" => "Forum content search",
// "Topic content search" => "Topic content search",
// "Tiki-indexed search" => "Tiki-indexed search",
// "Use database (full-text) search" => "Use database (full-text) search",
// "Store password as plain text" => "Store password as plain text",
// "Encryption method" => "Encryption method",
// "tikihash (old)" => "tikihash (old)",
"Edit CSS" => "Editar CSS",
"Theme Control" => "Controle de temas",
// "Assign different themes to different sections, categories, and objects" => "Assign different themes to different sections, categories, and objects",
// "design themes" => "design themes",
"Tiki Template Viewing" => "Visualização de Modelos Tiki",
"Edit Templates" => "Editar padrões",
// "Custom HTML <head> Content" => "Custom HTML <head> Content",
"Example:" => "Exemplo:",
// "Use to include custom &lt;meta&gt; or &lt;link&gt; tags" => "Use to include custom &lt;meta&gt; or &lt;link&gt; tags",
// "Add BASE tag in the page HEAD" => "Add BASE tag in the page HEAD",
// "The &lt;base&gt; tag specifies a default address for all links on a page" => "The &lt;base&gt; tag specifies a default address for all links on a page",
"Site Logo and Title" => "Logo e título do site",
// "Expected to be migrated to modules entirely and made obsolete" => "Expected to be migrated to modules entirely and made obsolete",
"Left column" => "Coluna da esquerda",
"Controls visibility of the left column of modules" => "Controla a visibilidade da coluna de módulos da esquerda",
// "side bar" => "side bar",
"Only if module" => "Somente se houver um módulo",
"Always" => "Sempre",
"User Decides" => "Usuário decide",
"Right Column" => "Coluna da direita",
"Controls visibility of the right column of modules" => "Controla a visibilidade da coluna de módulos da direita",
// "Prefix breadcrumbs with \"Location : \"" => "Prefix breadcrumbs with \"Location : \"",
"Site location bar" => "Barra de localização do site",
// "Use breadcrumbs module" => "Use breadcrumbs module",
// "Top of center column (legacy mode)" => "Top of center column (legacy mode)",
"Larger font for" => "Maior fonte para",
// "Entire location" => "Entire location",
"Page name" => "Nome da página",
"Use page description" => "Usar descrição de página",
"Top of page" => "Topo da página",
"Top of center column" => "Topo da coluna central",
// "Custom End of <body> Code" => "Custom End of <body> Code",
// "Webmaster Report" => "Webmaster Report",
// "Webmaster Email" => "Webmaster Email",
// "Leave blank to use the default sender email" => "Leave blank to use the default sender email",
"Email this page" => "Enviar para um amigo",
// "Add a link at the bottom if set, otherwise add a link at the top" => "Add a link at the bottom if set, otherwise add a link at the top",
// "Shadow layer" => "Shadow layer",
// "Additional layers for shadows, rounded corners or other decorative styling" => "Additional layers for shadows, rounded corners or other decorative styling",
// "Tooltips" => "Tooltips",
// "Make tooltips such as this appear in a custom style. Use CSS to change their appearance" => "Make tooltips such as this appear in a custom style. Use CSS to change their appearance",
// "Provides various drop-down menus on many text input boxes for page names, user names, groups, tags etc" => "Provides various drop-down menus on many text input boxes for page names, user names, groups, tags etc",
// "Superfish" => "Superfish",
// "Adds animation effects to CSS \"Suckerfish\" menus" => "Adds animation effects to CSS \"Suckerfish\" menus",
// "Reflection" => "Reflection",
// "Allows images to have a reflection effect below them. See the admin icons above for an example" => "Allows images to have a reflection effect below them. See the admin icons above for an example",
// "JQuery UI" => "JQuery UI",
// "Include jQuery UI library. Enables many user interface features" => "Include jQuery UI library. Enables many user interface features",
// "jQuery UI Theme" => "jQuery UI Theme",
// "jQuery UI Theme. Used in spreadsheet, for example" => "jQuery UI Theme. Used in spreadsheet, for example",
// "Validation" => "Validation",
// "Provides various validation possibilities like in Trackers" => "Provides various validation possibilities like in Trackers",
// "jQuery Infinite Carousel" => "jQuery Infinite Carousel",
// "Image \"carousel\" plugin (coming soon)" => "Image \"carousel\" plugin (coming soon)",
// "jQuery Sortable Tables" => "jQuery Sortable Tables",
// "Sort in fancytable plugin" => "Sort in fancytable plugin",
// "This feature can cause problems with JS minify on some systems" => "This feature can cause problems with JS minify on some systems",
// "jQuery Media" => "jQuery Media",
// "Media player" => "Media player",
"Use Tabs" => "Usar Tabs",
// "Makes pages shorter by splitting the content in different tabs" => "Makes pages shorter by splitting the content in different tabs",
// "Correct PNG images alpha transparency in IE6 (experimental)" => "Correct PNG images alpha transparency in IE6 (experimental)",
// "Wiki content templates" => "Wiki content templates",
// "Predefined content for a wiki page" => "Predefined content for a wiki page",
"Warn on edit conflict" => "Avisar quando houver conflito de edição",
// "Tiki will warn users who attempt to edit a page that another user is currenly editing" => "Tiki will warn users who attempt to edit a page that another user is currenly editing",
"Undo" => "Desfazer",
"Footnotes" => "Notas de rodapé",
// "Create private notes for a page that are visible only by the author" => "Create private notes for a page that are visible only by the author",
"Allow HTML" => "Permitir HTML",
// "Log bytes changes (+/-) in action logs" => "Log bytes changes (+/-) in action logs",
// "May impact performance" => "May impact performance",
"Sandbox" => "Bancada de testes",
// "A special wiki page for testing. Users can edit, but not save the Sandbox" => "A special wiki page for testing. Users can edit, but not save the Sandbox",
// "Comments below wiki pages" => "Comments below wiki pages",
// "Allow users (with permission) to post threaded comments to a page" => "Allow users (with permission) to post threaded comments to a page",
"Pictures" => "Imagens",
// "Allow users to upload images (pictures) to a page" => "Allow users to upload images (pictures) to a page",
"Export" => "Exportar",
// "WikiWords" => "WikiWords",
// "Automatically convert words with UpPeR and LoWeR-case letters into wiki links" => "Automatically convert words with UpPeR and LoWeR-case letters into wiki links",
"Link plural WikiWords to their singular forms" => "Conectar plurais de PalavrasWiki para suas formas singulares",
"Accept dashes and underscores in WikiWords" => "Aceitar hífen e travessão em PalavrasWiki",
"History" => "Histórico",
// "Display IP address" => "Display IP address",
// "Record all versions, rather than only when page content or description changes or when an edit comment is given" => "Record all versions, rather than only when page content or description changes or when an edit comment is given",
// "View page contributions by author" => "View page contributions by author",
// "Visualize the contributions of different authors made to a wiki page" => "Visualize the contributions of different authors made to a wiki page",
"Discuss pages on forums" => "Discutir páginas nos fóruns",
// "Include a link on each page to a forum topic" => "Include a link on each page to a forum topic",
"View source" => "Ver fonte",
// "Similar (like pages)" => "Similar (like pages)",
"Structures" => "Estruturas",
// "Structures Drill Down Menu" => "Structures Drill Down Menu",
// "Ajax style drill down menu for structures" => "Ajax style drill down menu for structures",
"Open page as structure" => "Abrir página como estrutura",
// "Make structure from page" => "Make structure from page",
// "Categorize structure pages together" => "Categorize structure pages together",
// "Disable inheritance of direct object permissions when adding pages from a structure" => "Disable inheritance of direct object permissions when adding pages from a structure",
// "Create webhelp from structure" => "Create webhelp from structure",
"Import HTML" => "Importar HTML",
// "Use date parameter" => "Use date parameter",
// "Report it in wiki links" => "Report it in wiki links",
// "Import pages" => "Import pages",
// "A personal page for the user to manage" => "A personal page for the user to manage",
"UserPage prefix" => "Prefixo da página do usuário (UserPage)",
// "All user pages share a common prefix. The concatenation of the prefix and the username will generate the page name. The prefix cannot be empty" => "All user pages share a common prefix. The concatenation of the prefix and the username will generate the page name. The prefix cannot be empty",
// "Users can lock pages" => "Users can lock pages",
"MultiPrint" => "MultiImpressão",
// "Pages not in structure" => "Pages not in structure",
"Attachments" => "Arquivos anexados",
// "Allow users to upload (attach) files to a page" => "Allow users to upload (attach) files to a page",
"Dumps" => "Exportações",
// "If you get an error message indicating a mandatory category is required when editing a wiki page, this is the option to blame. Set it to None" => "If you get an error message indicating a mandatory category is required when editing a wiki page, this is the option to blame. Set it to None",
// "If you get an error message indicating a mandatory category is required when editing an image (in an image gallery), this is the option to blame. Set it to None" => "If you get an error message indicating a mandatory category is required when editing an image (in an image gallery), this is the option to blame. Set it to None",
// "Display show/hide icon displayed before headings" => "Display show/hide icon displayed before headings",
// "Metrics Dashboard" => "Metrics Dashboard",
// "Generate automated statistics from configured database queries" => "Generate automated statistics from configured database queries",
// "Wiki argument variables" => "Wiki argument variables",
// "Allow to write request variables inside wiki content using {{paramname}} or {{paramname|default}} - special case {{page}} {{user}}" => "Allow to write request variables inside wiki content using {{paramname}} or {{paramname|default}} - special case {{page}} {{user}}",
"Use challenge/response authentication" => "Utilizar autenticação desafio/resposta",
// "Confirm that the Admin account has a valid email address or you will not be permitted to login" => "Confirm that the Admin account has a valid email address or you will not be permitted to login",
// "Users can choose to stay in SSL mode after an HTTPS login" => "Users can choose to stay in SSL mode after an HTTPS login",
"Users can switch between secured or standard mode at login" => "Usuários podem escolher entre modo de login padrão e seguro",
// "Wiki paragraph formatting" => "Wiki paragraph formatting",
// "Because the Wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines" => "Because the Wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines",
// "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line" => "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line",
// "...but still create line breaks within paragraphs" => "...but still create line breaks within paragraphs",
"Automonospaced text" => "Texto auto-monoespaçado",
"Tables syntax" => "Sintaxe de tabelas",
"|| for rows" => "|| para linhas",
"<return> for rows" => "\n para linhas",
"AutoLinks" => "AutoLinks",
// "Tiki will automatically convert http:// and email addresses into links" => "Tiki will automatically convert http:// and email addresses into links",
"Hotwords" => "Palavras-chaves",
// "Open Hotwords in new window" => "Open Hotwords in new window",
// "Characters that limit a hotword" => "Characters that limit a hotword",
// "Use Quote plugin rather than \">\" for quoting" => "Use Quote plugin rather than \">\" for quoting",
// "Use three colons instead of two to center text. Avoids conflict with C++ resolution scope operator" => "Use three colons instead of two to center text. Avoids conflict with C++ resolution scope operator",
// "String to use to delimit simplebox" => "String to use to delimit simplebox",
// "Users can choose to show their gender" => "Users can choose to show their gender",
// "Real name" => "Real name",
// "Gender" => "Gender",
// "Picture (avatar)" => "Picture (avatar)",
"Number of friends" => "Número de amigos",
"Country" => "País",
"E-mail" => "E-mail",
"Last login" => "Último login",
"Distance" => "Distância",
// "Manual selection of time/date" => "Manual selection of time/date",
// "WebDAV access to Tiki" => "WebDAV access to Tiki",
// "Allow to access File Galleries with WebDAV" => "Allow to access File Galleries with WebDAV",
// "use tiki-webdav.php as the URI of the WebDAV repository" => "use tiki-webdav.php as the URI of the WebDAV repository",
// "Fixed width" => "Fixed width",
// "Constrains the width of the site" => "Constrains the width of the site",
"Social networks" => "Redes Sociais",
// "Integration with different social networks like Twitter or Facebook" => "Integration with different social networks like Twitter or Facebook",
// "Group Transition" => "Group Transition",
// "Enables transitions for users between different groups. Transitions will create a user approval workflow" => "Enables transitions for users between different groups. Transitions will create a user approval workflow",
// "Category Transition" => "Category Transition",
// "Enables transitions on objects between different categories. Transitions will create a document workflow" => "Enables transitions on objects between different categories. Transitions will create a document workflow",
// "Ustream Watershed live video streaming" => "Ustream Watershed live video streaming",
// "Integration to Ustream Watershed live video streaming" => "Integration to Ustream Watershed live video streaming",
"Tiki User Credits" => "Créditos de Usuários do Tiki",
// "Invite users" => "Invite users",
// "Allow users to invite new users by mail to register on this tiki" => "Allow users to invite new users by mail to register on this tiki",
// "Alternate Registration Page" => "Alternate Registration Page",
// "Makes any access to tiki-register.php redirect to an alternate page for registration" => "Makes any access to tiki-register.php redirect to an alternate page for registration",
// "Load Balancer" => "Load Balancer",
// "Enable this only if the server is behind a load balancer (or reverse proxy), this allow tiki to log the IP of the user, instead of the IP of the proxy server" => "Enable this only if the server is behind a load balancer (or reverse proxy), this allow tiki to log the IP of the user, instead of the IP of the proxy server",
// "Accounting" => "Accounting",
// "Double-entry accounting system" => "Double-entry accounting system",
// "Syntax Highlighter (CodeMirror)" => "Syntax Highlighter (CodeMirror)",
// "Enables syntax highlighting with the use of CodeMirror" => "Enables syntax highlighting with the use of CodeMirror",
// "Syntax Highlighter (CodeMirror) Theme" => "Syntax Highlighter (CodeMirror) Theme",
// "Code Mirror Themes (clear cache when you change)" => "Code Mirror Themes (clear cache when you change)",
// "Jison Wiki Parser" => "Jison Wiki Parser",
// "Is a new strategy for parsing wiki pages more like a programming language" => "Is a new strategy for parsing wiki pages more like a programming language",
// "Dummy preference" => "Dummy preference",
// "This is useful for developers to learn how to create a new preference" => "This is useful for developers to learn how to create a new preference",
// "This is the detail" => "This is the detail",
// "This is the warning" => "This is the warning",
// "This is the hint" => "This is the hint",
// "This is the shorthint" => "This is the shorthint",
// "Time Sheet" => "Time Sheet",
// "A project time manager" => "A project time manager",
// "Html Feed" => "Html Feed",
// "A way to push and pull html bits around from one site to another" => "A way to push and pull html bits around from one site to another",
// "ForwardLink-Protocol" => "ForwardLink-Protocol",
// "A Dynamic Compendia" => "A Dynamic Compendia",
// "Unified Search requires more server processing ressources, and that you properly set the server permissions. Also, it's recommended to set a cron job to periodically rebuild the search index" => "Unified Search requires more server processing ressources, and that you properly set the server permissions. Also, it's recommended to set a cron job to periodically rebuild the search index",
// "HTML Purifier is a standards-compliant HTML filter library written in PHP and integrated in Tiki. HTML Purifier will not only remove all malicious code (better known as XSS) with a thoroughly audited, secure yet permissive whitelist, it will also make sure your documents are standards compliant, something only achievable with a comprehensive knowledge of W3C's specifications" => "HTML Purifier is a standards-compliant HTML filter library written in PHP and integrated in Tiki. HTML Purifier will not only remove all malicious code (better known as XSS) with a thoroughly audited, secure yet permissive whitelist, it will also make sure your documents are standards compliant, something only achievable with a comprehensive knowledge of W3C's specifications",
// "Display 'MyTiki' in the application menu" => "Display 'MyTiki' in the application menu",
// "Show user's contribution on the user information page" => "Show user's contribution on the user information page",
// "nofollow is used to instruct some search engines that links should not influence search engines. It can reduce search engine spam and prevent 'spamdexing'" => "nofollow is used to instruct some search engines that links should not influence search engines. It can reduce search engine spam and prevent 'spamdexing'",
// "InnoDB doesn't support Full-Text Search until 5.6, so if this is your case, use Unified Search" => "InnoDB doesn't support Full-Text Search until 5.6, so if this is your case, use Unified Search",
"Require file author's name for anonymous uploads" => "Campo autor do arquivo é obrigatório para uploads anônimos",
// "Redirect to similar wiki page" => "Redirect to similar wiki page",
// "If a requested page doesn't exist, redirect to a similarly named page" => "If a requested page doesn't exist, redirect to a similarly named page",
// "Redirect to page alias, if any" => "Redirect to page alias, if any",
// "If a requested page doesn't exist, redirect to an alias page, if specified using an alias semantic link" => "If a requested page doesn't exist, redirect to an alias page, if specified using an alias semantic link",
// "User's page" => "User's page",
// "Show user's information on mouseover" => "Show user's information on mouseover",
// "Requires user's information to be public" => "Requires user's information to be public",
// "Default feed format" => "Default feed format",
// "ATOM 1.0" => "ATOM 1.0",
// "RSS 2.0" => "RSS 2.0",
// "Feed author name" => "Feed author name",
// "This field is mandatory unless both feed author email and homepage are empty" => "This field is mandatory unless both feed author email and homepage are empty",
// "Feeed author email" => "Feeed author email",
// "Feed author homepage" => "Feed author homepage",
// "Feed editor email" => "Feed editor email",
// "Email address for person responsible for editorial content" => "Email address for person responsible for editorial content",
// "Feed webmaster email" => "Feed webmaster email",
// "Email address for person responsible for technical issues relating to channel" => "Email address for person responsible for technical issues relating to channel",
// "Feed Image path" => "Feed Image path",
// "Specifies a GIF, JPEG or PNG image that can be displayed with the feed" => "Specifies a GIF, JPEG or PNG image that can be displayed with the feed",
// "Feed Language" => "Feed Language",
// "RSS basic Authentication" => "RSS basic Authentication",
// "Propose basic http authentication if the user has no permission to see the feed" => "Propose basic http authentication if the user has no permission to see the feed",
// "Feed Caching time" => "Feed Caching time",
"seconds" => "segundos",
// "Use 0 for no caching" => "Use 0 for no caching",
// "Feed caching is done for anonymous users only" => "Feed caching is done for anonymous users only",
// "RSS for articles" => "RSS for articles",
// "RSS feeds for articles" => "RSS feeds for articles",
// "RSS for blogs" => "RSS for blogs",
// "RSS feeds for blogs" => "RSS feeds for blogs",
// "RSS for individual blogs" => "RSS for individual blogs",
// "RSS feed for individual blogs" => "RSS feed for individual blogs",
// "RSS for image galleries" => "RSS for image galleries",
// "RSS feed for image galleries" => "RSS feed for image galleries",
// "RSS for individual image galleries" => "RSS for individual image galleries",
// "RSS feed for individual image galleries" => "RSS feed for individual image galleries",
// "RSS for file galleries" => "RSS for file galleries",
// "RSS feed for file galleries" => "RSS feed for file galleries",
// "RSS for individual file galleries" => "RSS for individual file galleries",
// "RSS feed for individual file galleries" => "RSS feed for individual file galleries",
// "RSS for wiki pages" => "RSS for wiki pages",
// "RSS feed for wiki" => "RSS feed for wiki",
// "RSS for forums" => "RSS for forums",
// "RSS feed for forums" => "RSS feed for forums",
// "RSS for individual forums" => "RSS for individual forums",
// "RSS feed for individual forums" => "RSS feed for individual forums",
// "RSS per tracker" => "RSS per tracker",
// "RSS feed per tracker" => "RSS feed per tracker",
// "RSS for calendar events" => "RSS for calendar events",
// "RSS feed for calendar events" => "RSS feed for calendar events",
// "RSS for directories" => "RSS for directories",
// "RSS feed for directories" => "RSS feed for directories",
// "RSS for shoutbox" => "RSS for shoutbox",
// "RSS feed for shoutbox" => "RSS feed for shoutbox",
"Maximum number of items to display" => "Número máximo de itens a serem exibidos",
// "Show Author" => "Show Author",
// "Homepage URL" => "Homepage URL",
"Tiki RSS feed for articles" => "Fonte RSS para artigos",
"Tiki RSS feed for weblogs" => "Fonte RSS do tiki para weblogs",
// "Title to be prepended to the blog title for all blogs. If this field is empty only the blog title will be used" => "Title to be prepended to the blog title for all blogs. If this field is empty only the blog title will be used",
"Tiki RSS feed for image galleries" => "Fonte RSS do tiki para a galeria de imagens",
"Tiki RSS feed for the image gallery: " => "Fonte RSS para galeria de imagens: ",
"Tiki RSS feed for file galleries" => "Fonte RSS do tiki para galeria de arquivos",
"Tiki RSS feed for the file gallery: " => "Fonte RSS para galeria de arquivos: ",
"Tiki RSS feed for the wiki pages" => "Fonte RSS para páginas wiki",
"Tiki RSS feed for forums" => "Fonte RSS para fóruns",
"Tiki RSS feed for forum: " => "Fonte RSS para fórum: ",
"Tiki RSS feed for individual trackers: " => "Fontes RSS do tiki para formulários individuais: ",
// "Tiki RSS feed for calendars" => "Tiki RSS feed for calendars",
"Tiki RSS feed for directory sites" => "Fonte RSS para diretório de sites",
// "Tiki RSS feed for shoutbox messages" => "Tiki RSS feed for shoutbox messages",
// "Article RSS Description" => "Article RSS Description",
// "Description to be published as part of the RSS feed for articles" => "Description to be published as part of the RSS feed for articles",
"Last articles." => "Últimos Artigos.",
// "Blogs RSS Description" => "Blogs RSS Description",
// "Description to be published as part of the RSS feed for blogs" => "Description to be published as part of the RSS feed for blogs",
"Last posts to weblogs." => "Últimas mensagens para weblogs.",
// "Blog RSS Description" => "Blog RSS Description",
// "Description to be prepended to the blog description and published as part of the RSS feed for individual blogs. If this field is empty only the blog description will be used" => "Description to be prepended to the blog description and published as part of the RSS feed for individual blogs. If this field is empty only the blog description will be used",
// "Image galleries RSS Description" => "Image galleries RSS Description",
// "Description to be published as part of the RSS feed for image galleries" => "Description to be published as part of the RSS feed for image galleries",
"Last images uploaded to the image galleries." => "Últimas imagens enviadas para a galeria de imagens.",
// "Individual image galleries RSS Description" => "Individual image galleries RSS Description",
// "Description to be published as part of the RSS feed for individual image galleries" => "Description to be published as part of the RSS feed for individual image galleries",
// "Last images uploaded to this image gallery. " => "Last images uploaded to this image gallery. ",
// "File galleries RSS Description" => "File galleries RSS Description",
// "Description to be published as part of the RSS feed for file galleries" => "Description to be published as part of the RSS feed for file galleries",
"Last files uploaded to the file galleries." => "Últimos arquivos enviados para a galeria de arquivos.",
// "Individual file galleries RSS Description" => "Individual file galleries RSS Description",
// "Description to be published as part of the RSS feed for individual file galleries" => "Description to be published as part of the RSS feed for individual file galleries",
// "Last files uploaded to this file gallery. " => "Last files uploaded to this file gallery. ",
// "Wiki pages RSS Description" => "Wiki pages RSS Description",
// "Description to be published as part of the RSS feed for wiki pages" => "Description to be published as part of the RSS feed for wiki pages",
"Last modifications to the Wiki." => "Últimas modificações no wiki.",
// "Forums RSS Description" => "Forums RSS Description",
// "Description to be published as part of the RSS feed for forums" => "Description to be published as part of the RSS feed for forums",
"Last topics in forums." => "Últimos tópicos nos Fóruns.",
// "Individual forums RSS Description" => "Individual forums RSS Description",
// "Description to be published as part of the RSS feed for individual forums" => "Description to be published as part of the RSS feed for individual forums",
// "Last posts to this forum. " => "Last posts to this forum. ",
// "Individual trackers RSS Description" => "Individual trackers RSS Description",
// "Description to be published as part of the RSS feed for individual trackers" => "Description to be published as part of the RSS feed for individual trackers",
// "Last items published on this tracker" => "Last items published on this tracker",
// "Calendar events RSS Description" => "Calendar events RSS Description",
// "Description to be published as part of the RSS feed for calendar events" => "Description to be published as part of the RSS feed for calendar events",
"Upcoming Events." => "Próximos eventos.",
// "Directories RSS Description" => "Directories RSS Description",
// "Description to be published as part of the RSS feed for directories" => "Description to be published as part of the RSS feed for directories",
"Last sites." => "Últimos sites.",
// "Shoutbox RSS Description" => "Shoutbox RSS Description",
// "Description to be published as part of the RSS feed for shoutbox messages" => "Description to be published as part of the RSS feed for shoutbox messages",
// "Last shoutbox messages" => "Last shoutbox messages",
"Podcast directory" => "Diretório dos podcasts",
"The server must be able to read/write the directory." => "O servidor precisa ter permissão de leitura e escrita no diretório.",
"Required for podcasts" => "Obrigatório para podcasts",
// "If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload files in that dir, either by scp, ftp, or other protocols" => "If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload files in that dir, either by scp, ftp, or other protocols",
"The server must be able to read the directory." => "O servidor precisa ter acesso de leitura ao diretório.",
"The directory can be outside the web space." => "O diretório pode ser fora do espaço web.",
"Prevent download if score becomes negative" => "Não permite download se a pontuação for negativa",
"Allow download limit per file" => "Permitir limite de download por arquivo",
"Allow same file to be uploaded more than once" => "Permitir que o mesmo arquivo seja enviado mais de uma vez",
"Yes, even in the same gallery" => "Sim, inclusive na mesma galeria",
"Only in different galleries" => "Apenas em galerias diferentes",
// "Display zip option in gallery" => "Display zip option in gallery",
// "Display in the gallery the zip option (in upload and gallery file)" => "Display in the gallery the zip option (in upload and gallery file)",
// "Upload progressbar" => "Upload progressbar",
// "Ajax / Flash (Browser-based)" => "Ajax / Flash (Browser-based)",
"Must match" => "Precisar casar",
"Cannot match" => "Não pode casar",
"Quota for all the files and archives" => "Quota para todos os arquivos",
"Mb" => "Mb",
// "(0 for unlimited)" => "(0 for unlimited)",
"Quota can be defined for each file gallery" => "Quota pode ser definida para cada galeria de arquivos",
"Default quota for each new gallery" => "Valor padrão da quota para cada nova galeria",
"Show quota bar in the list page" => "Mostrar barra de uso da quota na página de listagem",
// "Yes, display bar and detail text" => "Yes, display bar and detail text",
// "Yes, display only bar" => "Yes, display only bar",
// "Yes, display only text" => "Yes, display only text",
"Storage" => "Armazenar",
"Store in database" => "Armanezar na base de dados",
"Store in directory" => "Armazenar no sistema de arquivos",
// "Path to store files in the file gallery" => "Path to store files in the file gallery",
// "Include the search box on the current gallery files just after the find div" => "Include the search box on the current gallery files just after the find div",
// "Include a search box on file galleries" => "Include a search box on file galleries",
// "Display hits with a ratio between hits / maxhits" => "Display hits with a ratio between hits / maxhits",
// "Display properties in the context menu" => "Display properties in the context menu",
// "Display replace menu in context menu" => "Display replace menu in context menu",
// "Automatic deletion of old files" => "Automatic deletion of old files",
// "The user will have an option when uploading a file to specify the time after which the file is deleted" => "The user will have an option when uploading a file to specify the time after which the file is deleted",
// "Allow action on multiple files or galleries" => "Allow action on multiple files or galleries",
// "The check button on file gallery can be remove" => "The check button on file gallery can be remove",
// "Deletion emails notification" => "Deletion emails notification",
// "These emails will receive a copy of each deleted file. Emails are separated with comma" => "These emails will receive a copy of each deleted file. Emails are separated with comma",
// "Keep the same fileId for the latest version of a file" => "Keep the same fileId for the latest version of a file",
// "If checked, the fileId of the latest version of a file stays the same. Link to a file will always give you the latest version. If not checked, the fileId is attached to the file for ever, link to file will give you the precise version of a file" => "If checked, the fileId of the latest version of a file stays the same. Link to a file will always give you the latest version. If not checked, the fileId is attached to the file for ever, link to file will give you the precise version of a file",
// "Show thumbnail actions" => "Show thumbnail actions",
// "Show the checkbox and wrench icon for file actions menu when not displaying details" => "Show the checkbox and wrench icon for file actions menu when not displaying details",
// "Max thumbnail size" => "Max thumbnail size",
// "Maximum width or height for image thumbnails" => "Maximum width or height for image thumbnails",
// "In pixels" => "In pixels",
// "Automatic indexing of file content" => "Automatic indexing of file content",
// "Uses command line tools to extract the information from the files based on their MIME types" => "Uses command line tools to extract the information from the files based on their MIME types",
// "Upload files from remote source" => "Upload files from remote source",
// "Allow to create files in file galleries using a URL that will be polled for new revisions" => "Allow to create files in file galleries using a URL that will be polled for new revisions",
// "Remote source refresh frequency limit" => "Remote source refresh frequency limit",
// "Minimum amount of seconds to be ellapsed between source checks to prevent flooding servers" => "Minimum amount of seconds to be ellapsed between source checks to prevent flooding servers",
// "Display controls to attempt refresh" => "Display controls to attempt refresh",
// "Let users trigger a refresh attempt from the remote host" => "Let users trigger a refresh attempt from the remote host",
// "Allow searching for existing files in the tracker files field" => "Allow searching for existing files in the tracker files field",
// "Search files using the search index" => "Search files using the search index",
// "Fix mime types based on file suffix" => "Fix mime types based on file suffix",
// "Fixes mime type of image files based on file suffixes when they are incorrectly detected as application/octet-stream" => "Fixes mime type of image files based on file suffixes when they are incorrectly detected as application/octet-stream",
// "Max Name Length" => "Max Name Length",
// "Length to truncate file names to in browse view" => "Length to truncate file names to in browse view",
// "Set a directory on your server. Ex.: /var/www/  It's recommended that this directory not be web accessible. PHP must be able to read/write to the directory" => "Set a directory on your server. Ex.: /var/www/  It's recommended that this directory not be web accessible. PHP must be able to read/write to the directory",
// "Revision Approval" => "Revision Approval",
// "Uses flagged revisions to hide unapproved wiki page revisions from users with lower privileges" => "Uses flagged revisions to hide unapproved wiki page revisions from users with lower privileges",
// "Revision Approval Categories" => "Revision Approval Categories",
// "List of category IDs on which revision approval is required" => "List of category IDs on which revision approval is required",
// "Footer shadow start" => "Footer shadow start",
// "Footer shadow end" => "Footer shadow end",
"Uploaded filenames must match regex" => "Arquivos carregados devem seguir a expressão regular",
// "Manage thread defaults per-forum" => "Manage thread defaults per-forum",
// "Display thread configuration bar" => "Display thread configuration bar",
// "Allows users to override the defaults" => "Allows users to override the defaults",
// "Display thread configuration bar only when number of posts exceed" => "Display thread configuration bar only when number of posts exceed",
// "Keep settings for all forums during the user session" => "Keep settings for all forums during the user session",
// "Default style" => "Default style",
"Plain" => "Plano",
// "Threaded" => "Threaded",
"Headers Only" => "Cabeçalho apenas",
// "Default sort mode" => "Default sort mode",
"Title (desc)" => "Título (desc)",
"Title (asc)" => "Título (asc)",
"Topics" => "Assuntos",
"Posts per day" => "Mensagens por dia",
"Last post" => "Última mensagem",
// "Description length" => "Description length",
// "Hide titles for forum threads" => "Hide titles for forum threads",
// "Most titles are left untouched because they are a direct reply to the parent thread. This feature hides the title altogether from the forms and display" => "Most titles are left untouched because they are a direct reply to the parent thread. This feature hides the title altogether from the forms and display",
// "Force title in reply" => "Force title in reply",
// "Shows a blank title box and requires it to be filled before submission of forum post" => "Shows a blank title box and requires it to be filled before submission of forum post",
"Do not prefix messages titles by 'Re: '" => "Não adicione prefixo em mensagens com titulo 'Re: '",
// "Creation Date (asc)" => "Creation Date (asc)",
"Topics (desc)" => "Assuntos (desc)",
"Threads (desc)" => "Seqüências (desc)",
"Last post (desc)" => "Última mensagem (desc)",
"Name (desc)" => "Nome (desc)",
"Name (asc)" => "Nome (asc)",
// "Multilingual tags" => "Multilingual tags",
// "Permits translation management of tags" => "Permits translation management of tags",
// "Show tag cloud" => "Show tag cloud",
// "Maximum number of tags in cloud" => "Maximum number of tags in cloud",
// "Show freetags in middle column" => "Show freetags in middle column",
// "Preload freetag random tag" => "Preload freetag random tag",
"Number of Tags to show in Tag Suggestions" => "Número de tags para mostrar na sugestão de tags",
"Valid characters pattern" => "Padrão de caracteres válidos",
// "Lowercase tags only" => "Lowercase tags only",
// "Enable freetags 3D browser" => "Enable freetags 3D browser",
// "3D autoload" => "3D autoload",
"Browser width" => "Largura da janela do navegador",
"Browser height" => "Altura da janela do navegador",
"Navigation depth" => "Profundidade da navegação",
// "Node size" => "Node size",
"Text size" => "Tamanho do texto",
// "Spring (connection) size" => "Spring (connection) size",
"Existing page node color" => "Cor das páginas existentes",
"Missing page node color" => "Cor das páginas inexistentes",
// "Camera distance adjusted relative to nearest node" => "Camera distance adjusted relative to nearest node",
"Camera distance" => "Distância da câmera",
"Field of view" => "Campo de vista",
"Feed animation interval (milisecs)" => "Intervalo de popup dos páginas (milisegundos)",
// "Friction constant" => "Friction constant",
// "Elastic constant" => "Elastic constant",
// "Electrostatic constant" => "Electrostatic constant",
// "Node mass" => "Node mass",
// "Node charge" => "Node charge",
// "Include \"Generate Password\" option on registration form" => "Include \"Generate Password\" option on registration form",
// "Geolocate wiki pages" => "Geolocate wiki pages",
// "Provide controls to geolocate wiki pages from the edit functionality" => "Provide controls to geolocate wiki pages from the edit functionality",
// "Geolocate articles" => "Geolocate articles",
// "Provide controls to geolocate articles from the edit functionality" => "Provide controls to geolocate articles from the edit functionality",
// "Geolocate blog posts" => "Geolocate blog posts",
// "Provide controls to geolocate blog posts from the edit functionality" => "Provide controls to geolocate blog posts from the edit functionality",
// "Available tile layers on maps" => "Available tile layers on maps",
// "Allows to replace the default OpenStreetMap tiles for tiles from other mapping services, such as Google or Bing" => "Allows to replace the default OpenStreetMap tiles for tiles from other mapping services, such as Google or Bing",
// "Valid options are: %0" => "Valid options are: %0",
// "Google Street View" => "Google Street View",
// "Open up Google Street View in a window to see the visible coordinates" => "Open up Google Street View in a window to see the visible coordinates",
// "Google Street View Overlay" => "Google Street View Overlay",
// "This is not guaranteed to work" => "This is not guaranteed to work",
// "Always load OpenLayers" => "Always load OpenLayers",
// "Load the OpenLayers library even if no map is explicitly included in the page" => "Load the OpenLayers library even if no map is explicitly included in the page",
// "Style of the site, sometimes called a skin or CSS. See http://themes.tiki.org for more Tiki themes" => "Style of the site, sometimes called a skin or CSS. See http://themes.tiki.org for more Tiki themes",
"Browser title" => "Título no navegador",
// "Label visible in the browser's title bar on all pages. Also appears in search engines" => "Label visible in the browser's title bar on all pages. Also appears in search engines",
// "Validate new user registrations by email" => "Validate new user registrations by email",
// "Upon registration, the new user will receive an email containing a link to confirm validity" => "Upon registration, the new user will receive an email containing a link to confirm validity",
"Home page" => "Página inicial",
// "Landing page used for the wiki when no page is specified. The page will be created if it does not exist" => "Landing page used for the wiki when no page is specified. The page will be created if it does not exist",
"Use group homepages" => "Página inicial por grupo",
// "Users can be sent to different pages upon login, depending on their default group" => "Users can be sent to different pages upon login, depending on their default group",
"Go to group homepage only if login from default homepage" => "Ir para a página inicial do grupo apenas se o login for feito a partir da página inicial padrão",
// "Default language" => "Default language",
// "Site language used when no other language is specified by the user" => "Site language used when no other language is specified by the user",
// "Cache external pages" => "Cache external pages",
// "Cache external images" => "Cache external images",
"Temporary directory" => "Diretório temporário",
// "Tiki requires full read and write access to this directory" => "Tiki requires full read and write access to this directory",
"Help URL" => "URL de ajuda",
// "The default help system may not be complete. You can help with the Tiki documentation" => "The default help system may not be complete. You can help with the Tiki documentation",
"Open external links in new window" => "Links externos em nova janela",
// "License page" => "License page",
// "Submit notice" => "Submit notice",
"Full path to gdaltindex" => "Caminho completo para o gdaltindex",
"Full path to ogr2ogr" => "Path completo para ogr2ogr",
"Map Zone" => "Zona do mapa",
"Display modules to all groups always" => "Módulos acessíveis por todos grupos",
"Hide anonymous-only modules from registered users" => "Esconder módulos exclusivos dos usuários anônimos de usuários registrados",
// "Hide anonymous-only modules from Admins" => "Hide anonymous-only modules from Admins",
// "Maximum number of articles on articles home page" => "Maximum number of articles on articles home page",
// "Site Ads and Banners Content" => "Site Ads and Banners Content",
// "Test" => "Test",
// "URL to go to when clicking on a username" => "URL to go to when clicking on a username",
// "Default" => "Default",
// "Use %user% for login name and %userId% for userId)" => "Use %user% for login name and %userId% for userId)",
// "Forgot password" => "Forgot password",
// "Users can request to reset password. They will receive a link by email" => "Users can request to reset password. They will receive a link by email",
// "Each group can have its theme" => "Each group can have its theme",
"Site title" => "Título do site",
"Subtitle" => "Sub-título",
"Maximum number of records in listings" => "Número máximo de registros em listagens",
// "Maximum number of versions" => "Maximum number of versions",
// "0 for unlimited versions" => "0 for unlimited versions",
"Users can register" => "Usuários podem se cadastrar",
// "Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server" => "Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server",
// "Require validation by Admin" => "Require validation by Admin",
// "The administrator will receive an email for each new user registration, and must validate the user before the user can login" => "The administrator will receive an email for each new user registration, and must validate the user before the user can login",
// "Require passcode to register" => "Require passcode to register",
// "Users must enter a code to register.  You must inform users of this code. Use to restrict registration to invited users only" => "Users must enter a code to register.  You must inform users of this code. Use to restrict registration to invited users only",
// "Passcode" => "Passcode",
// "Alphanumeric code required to complete the registration" => "Alphanumeric code required to complete the registration",
// "Show passcode on registration form" => "Show passcode on registration form",
// "Use tracker to collect more user information" => "Use tracker to collect more user information",
// "Display a tracker (form) for the user to complete, as part of the registration process. Use this tracker to store additional information about each user" => "Display a tracker (form) for the user to complete, as part of the registration process. Use this tracker to store additional information about each user",
// "Use the \"Admin Groups\" page to select which tracker and fields to display" => "Use the \"Admin Groups\" page to select which tracker and fields to display",
// "Use tracker to collect more group information" => "Use tracker to collect more group information",
// "Create a new group for each user" => "Create a new group for each user",
// "Synchronize Tiki groups with a directory" => "Synchronize Tiki groups with a directory",
// "Define the directory within the \"LDAP\" tab" => "Define the directory within the \"LDAP\" tab",
// "Synchronize Tiki users with a directory" => "Synchronize Tiki users with a directory",
"Remember me" => "Lembre-se de mim",
"Duration" => "Duração",
"hour" => "hora",
"hours" => "horas",
"day" => "dia",
"week" => "semana",
"month" => "mês",
"year" => "ano",
// "Use custom homepage" => "Use custom homepage",
// "Use a Tiki feature homepage or another homepage" => "Use a Tiki feature homepage or another homepage",
// "Use Tiki feature as homepage" => "Use Tiki feature as homepage",
// "Select the Tiki feature to use as the site homepage. Only enabled features are listed" => "Select the Tiki feature to use as the site homepage. Only enabled features are listed",
// "Disable JavaScript" => "Disable JavaScript",
// "Disable JavaScript for testing purpose even if the browser allows it" => "Disable JavaScript for testing purpose even if the browser allows it",
// "Partner ID" => "Partner ID",
// "Kaltura Partner ID" => "Kaltura Partner ID",
// "User secret" => "User secret",
// "Kaltura partner setting user secret" => "Kaltura partner setting user secret",
// "Admin secret" => "Admin secret",
// "Kaltura partner setting admin secret" => "Kaltura partner setting admin secret",
// "KDP UI Configuration ID" => "KDP UI Configuration ID",
// "Kaltura Dynamic Player (KDP) user interface configuration ID" => "Kaltura Dynamic Player (KDP) user interface configuration ID",
// "KDP Widget ID" => "KDP Widget ID",
// "Kaltura Dynamic Player (KDP) Widget ID. This configuration is specific to your account" => "Kaltura Dynamic Player (KDP) Widget ID. This configuration is specific to your account",
// "KCW UI Configuration ID" => "KCW UI Configuration ID",
// "Kaltura Configuration Wizard (KCW) user interface configuration ID" => "Kaltura Configuration Wizard (KCW) user interface configuration ID",
// "Kaltura Simple Editor UI Configuration ID" => "Kaltura Simple Editor UI Configuration ID",
// "Kaltura Advanced Editor UI Configuration ID" => "Kaltura Advanced Editor UI Configuration ID",
// "Kaltura \"User\"" => "Kaltura \"User\"",
// "Owner of content shared by all Tiki users on this site. If empty then each Tiki user can only see their own media entries" => "Owner of content shared by all Tiki users on this site. If empty then each Tiki user can only see their own media entries",
// "Kaltura Service URL" => "Kaltura Service URL",
// "e.g. http://www.kaltura.com/" => "e.g. http://www.kaltura.com/",
// "Set blogs homepage first" => "Set blogs homepage first",
// "Set Image gal homepage first" => "Set Image gal homepage first",
// "Set Forum homepage first" => "Set Forum homepage first",
"Custom home" => "Página inicial personalizada",
// "Since passwords are encrypted, it's not possible to tell the user what the password is. It's only possible to change it" => "Since passwords are encrypted, it's not possible to tell the user what the password is. It's only possible to change it",
// "Validate user's email server" => "Validate user's email server",
// "Displays the required passcode on the registration form. This is helpful for legitimate users who want to register while making it difficult for automated robots because the passcode is unique for each site and because it is displayed in JavaScript" => "Displays the required passcode on the registration form. This is helpful for legitimate users who want to register while making it difficult for automated robots because the passcode is unique for each site and because it is displayed in JavaScript",
// "The group will be named identical to the user's username" => "The group will be named identical to the user's username",
// "User's choice" => "User's choice",
// "If you don't know better, use '_yourPartnerID'" => "If you don't know better, use '_yourPartnerID'",
// "You could use your server name for this. e.g. %0" => "You could use your server name for this. e.g. %0",
"Google Maps API Key" => "Chave da API do Google Maps",
// "Default x for map center" => "Default x for map center",
// "Default y for map center" => "Default y for map center",
"Default zoom level" => "Nível de zoom padrão",
"whole earth" => "toda terra",
"country size" => "tamanho do país",
"city size" => "tamanho da cidade",
// "village size" => "village size",
"max zoom" => "zoom máximo",
// "Show map mode buttons in articles list" => "Show map mode buttons in articles list",
// "Show map mode buttons in page list" => "Show map mode buttons in page list",
// "Header shadow start" => "Header shadow start",
// "Header shadow end" => "Header shadow end",
// "Custom CSS" => "Custom CSS",
// "Includes a custom block of CSS inline in all pages" => "Includes a custom block of CSS inline in all pages",
// "Custom JavaScript" => "Custom JavaScript",
// "Includes a custom block of inline JavaScript in all pages" => "Includes a custom block of inline JavaScript in all pages",
// "Do not include the <script> and </script> tags" => "Do not include the <script> and </script> tags",
// "Highlight group" => "Highlight group",
"Home Blog (main blog)" => "Blog Inicial (Blog principal)",
"Home Forum (main forum)" => "Fórum Inicial (fórum principal)",
// "Home File Gallery (main file gallery)" => "Home File Gallery (main file gallery)",
"Home Gallery (main gallery)" => "Galeria Inicial (galeria principal)",
// "No image gallery available (create one first)" => "No image gallery available (create one first)",
// "No file gallery available (create one first)" => "No file gallery available (create one first)",
// "No forum available (create one first)" => "No forum available (create one first)",
// "No blog available (create one first)" => "No blog available (create one first)",
"HTTP port" => "Porta HTTP",
// "If left empty, port 80 will be used" => "If left empty, port 80 will be used",
// "HTTP Lookup Skip Framesets" => "HTTP Lookup Skip Framesets",
// "When performing and HTTP request to an external source, verify if the result is a frameset and use heuristic to provide the real content" => "When performing and HTTP request to an external source, verify if the result is a frameset and use heuristic to provide the real content",
// "Registration referrer check" => "Registration referrer check",
// "Use the HTTP referrer to check registration POST is sent from same host. (May not work on some setups.)" => "Use the HTTP referrer to check registration POST is sent from same host. (May not work on some setups.)",
// "Use HTTPS when building user-specific links" => "Use HTTPS when building user-specific links",
// "When building notification emails, RSS feeds or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server" => "When building notification emails, RSS feeds or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server",
"HTTPS port" => "Porta HTTPS",
// "If left empty, port 443 will be used" => "If left empty, port 443 will be used",
// "Use HTTPS login" => "Use HTTPS login",
// "Increase security by allowing to transmit authentication credentials over SSL. Certificates must be configured on the server" => "Increase security by allowing to transmit authentication credentials over SSL. Certificates must be configured on the server",
"Allow secure (https) login" => "Permitir login seguro (https)",
// "Encourage secure (https) login" => "Encourage secure (https) login",
// "Consider we are always in HTTPS, but do not check" => "Consider we are always in HTTPS, but do not check",
"Require secure (https) login" => "Exigir login seguro (https)",
// "Do not require HTTPS until you have setup and tested the connection, otherwise, you will make your whole site unaccessible" => "Do not require HTTPS until you have setup and tested the connection, otherwise, you will make your whole site unaccessible",
// "CSS selectors to be fixed" => "CSS selectors to be fixed",
// "Separate multiple elements with a comma (,)" => "Separate multiple elements with a comma (,)",
// "HTMLDomElements to be fixed" => "HTMLDomElements to be fixed",
// "IP can be checked" => "IP can be checked",
// "Check anonymous votes by user's IP" => "Check anonymous votes by user's IP",
// "Use CDN for JavaScript" => "Use CDN for JavaScript",
// "Obtain jQuery and jQuery UI libraries through a content delivery network" => "Obtain jQuery and jQuery UI libraries through a content delivery network",
// "Google (supports SSL via HTTPS)" => "Google (supports SSL via HTTPS)",
// "jQuery" => "jQuery",
// "Slide" => "Slide",
// "Fade" => "Fade",
// "Blind (UI)" => "Blind (UI)",
// "Clip (UI)" => "Clip (UI)",
// "Drop (UI)" => "Drop (UI)",
// "Explode (UI)" => "Explode (UI)",
// "Fold (UI)" => "Fold (UI)",
// "Puff (UI)" => "Puff (UI)",
// "Slide (UI)" => "Slide (UI)",
// "Effect for modules" => "Effect for modules",
// "Effect for tabs" => "Effect for tabs",
"Speed" => "Velocidade",
"Fast" => "Rápido",
"Normal" => "Normal",
"Slow" => "Lento",
"Direction" => "Direção",
"Vertical" => "Vertical",
"Horizontal" => "Horizontal",
"Left" => "Esquerda",
"Right" => "Direita",
"Up" => "Para cima",
"Down" => "Para baixo",
// "jQuery-ui Select Menu" => "jQuery-ui Select Menu",
// "Styled replacement for dropdown select menus" => "Styled replacement for dropdown select menus",
// "Use Select Menu on all select elements" => "Use Select Menu on all select elements",
// "Applies jQuery-ui Select Menu to every select menu" => "Applies jQuery-ui Select Menu to every select menu",
// "Experimental. This feature is under development" => "Experimental. This feature is under development",
// "Never delete versions younger than" => "Never delete versions younger than",
"Use database for translation" => "Usar banco de dados para tradução",
// "Use the database to store the translated strings and allow using interactive translation" => "Use the database to store the translated strings and allow using interactive translation",
// "[%0|Edit or export/import Languages]" => "[%0|Edit or export/import Languages]",
// "Language inclusion threshold" => "Language inclusion threshold",
// "When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages" => "When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages",
"Layout per section" => "Layout por sessão",
// "Layout Width" => "Layout Width",
// "Constrains the site display width (default: 990px)" => "Constrains the site display width (default: 990px)",
// "ex.: 800px" => "ex.: 800px",
// "Users can choose not to have tabs" => "Users can choose not to have tabs",
// "Add group CSS info" => "Add group CSS info",
// "Add classes to the page BODY tag to indicate group membership" => "Add classes to the page BODY tag to indicate group membership",
// "Either grp_Anonymous or grp_Registered and possibly grp_Admins as well" => "Either grp_Anonymous or grp_Registered and possibly grp_Admins as well",
// "If user does not exist in Tiki" => "If user does not exist in Tiki",
// "Create the user" => "Create the user",
// "Deny access" => "Deny access",
// "Create user if not in LDAP" => "Create user if not in LDAP",
// "Maximum average server load threshold in the last minute" => "Maximum average server load threshold in the last minute",
// "Log mail in Tiki logs" => "Log mail in Tiki logs",
// "Smarty Template usage indicator" => "Smarty Template usage indicator",
// "Add HTML comment at start and end of each Smarty template (TPL)" => "Add HTML comment at start and end of each Smarty template (TPL)",
// "Use only for development, not in production because these warnings are added to emails as well, and visible to the users" => "Use only for development, not in production because these warnings are added to emails as well, and visible to the users",
// "You need to clear your Tiki template cache for this change to take effect" => "You need to clear your Tiki template cache for this change to take effect",
// "Log SQL" => "Log SQL",
// "Log SQL queries" => "Log SQL queries",
// "Log queries using more than (seconds)" => "Log queries using more than (seconds)",
// "This may impact performance" => "This may impact performance",
// "Use email as username" => "Use email as username",
// "Instead of creating new usernames, use the user's email address for authentication" => "Instead of creating new usernames, use the user's email address for authentication",
// "Obscure email when using email as username if possible (coverage will not be complete)" => "Obscure email when using email as username if possible (coverage will not be complete)",
// "This will attempt as much as possible to hide the email, showing the realname or the truncated email instead" => "This will attempt as much as possible to hide the email, showing the realname or the truncated email instead",
// "HTTP Basic Authentication" => "HTTP Basic Authentication",
// "Check credentials from HTTP Basic Authentication, useful to allow webservices to use credentials" => "Check credentials from HTTP Basic Authentication, useful to allow webservices to use credentials",
// "SSL Only (Recommended)" => "SSL Only (Recommended)",
"Long date format" => "Formato longo para datas",
"Long time format" => "Formato longo para horas",
"%A %d of %B, %Y" => "%A, %d de %B de %Y",
"%H:%M:%S %Z" => "%H:%M:%S %Z",
// "%A %d of %B, %Y %H:%M:%S %Z" => "%A %d of %B, %Y %H:%M:%S %Z",
// "Force lowercase" => "Force lowercase",
// "Mail end of line" => "Mail end of line",
// "CRLF (standard)" => "CRLF (standard)",
// "LF (some Unix MTA)" => "LF (some Unix MTA)",
// "Main shadow start" => "Main shadow start",
// "Main shadow end" => "Main shadow end",
"full path to mapfiles" => "caminho completo para os arquivos de mapas",
"Wiki Page for Help" => "Página Wiki para Ajuda",
"Wiki Page for Comments" => "Página Wiki para Comentários",
// "Maximum length" => "Maximum length",
// "Memcache" => "Memcache",
// "Enable connection to memcached servers to store temporary information" => "Enable connection to memcached servers to store temporary information",
// "Requires the PHP memcache extension" => "Requires the PHP memcache extension",
// "Memcache compression" => "Memcache compression",
// "Enable compression for memcache storage" => "Enable compression for memcache storage",
// "Memcache servers" => "Memcache servers",
// "Server list which may be accessed. For each server, the address, port and weight must be specified" => "Server list which may be accessed. For each server, the address, port and weight must be specified",
// "One per line. address:port (weight)" => "One per line. address:port (weight)",
// "Memcache key prefix" => "Memcache key prefix",
// "When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoiding conflicts" => "When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoiding conflicts",
// "Memcache expiration" => "Memcache expiration",
// "Duration for which the data will be kept" => "Duration for which the data will be kept",
// "Cache wiki data in memcache" => "Cache wiki data in memcache",
// "Cache wiki output in memcache" => "Cache wiki output in memcache",
// "Cache forum output in memcache" => "Cache forum output in memcache",
// "Menu icons" => "Menu icons",
// "Allows to define icons for menu entries" => "Allows to define icons for menu entries",
// "Default path for the icons" => "Default path for the icons",
// "Allow HTML in menu option names and URLs" => "Allow HTML in menu option names and URLs",
// "If enabled, menu option names and URL-s are treated as HTML content and they are not escaped (no replacement of HTML special characters). This allows the use of HTML to insert images for example. Code must be valid. This allows menu item editors to put arbitrary HTML; only enable if you know what you are doing" => "If enabled, menu option names and URL-s are treated as HTML content and they are not escaped (no replacement of HTML special characters). This allows the use of HTML to insert images for example. Code must be valid. This allows menu item editors to put arbitrary HTML; only enable if you know what you are doing",
// "REALLY allow HTML (INSECURE)" => "REALLY allow HTML (INSECURE)",
// "This needs to be checked for the parent preference to be actually enabled. This allows menu item editors to put arbitrary HTML, which could allow session hijacking; only enable if you know what you are doing" => "This needs to be checked for the parent preference to be actually enabled. This allows menu item editors to put arbitrary HTML, which could allow session hijacking; only enable if you know what you are doing",
"Maximum mailbox size (messages, 0=unlimited)" => "Tamanho máximo da caixa de entrada (mensagens, 0=ilimitado)",
"Maximum mail archive size (messages, 0=unlimited)" => "Tamanho máximo do arquivo de e-mail (mensagens, 0=ilimitado)",
"Maximum sent box size (messages, 0=unlimited)" => "Tamanho máximo da caixa de saída (mensagens, 0=ilimitado)",
// "Keywords" => "Keywords",
// "A list of key words (separated by commas) that describe your site" => "A list of key words (separated by commas) that describe your site",
// "Include freetags" => "Include freetags",
// "If the freetags feature is enabled, use the freetags in the meta keywords for each page with freetags set. This allows individual pages on the site to carry different meta tags" => "If the freetags feature is enabled, use the freetags in the meta keywords for each page with freetags set. This allows individual pages on the site to carry different meta tags",
// "Use thread title instead" => "Use thread title instead",
// "Use the forum thread title in the meta title tag" => "Use the forum thread title in the meta title tag",
// "Use image title instead" => "Use image title instead",
// "Use the image title in the meta title tag" => "Use the image title in the meta title tag",
// "A short description of your site. Some search engines display this information with your site's listing" => "A short description of your site. Some search engines display this information with your site's listing",
// "Page Description" => "Page Description",
// "Use individual page description as a met tag for the page" => "Use individual page description as a met tag for the page",
// "The author of your site. Typically this will be the Admin or Webmaster" => "The author of your site. Typically this will be the Admin or Webmaster",
"geo.position" => "geo.posição",
// "The latitude and longitude of the physical location of the site. For example \"38.898748, -77.037684\"" => "The latitude and longitude of the physical location of the site. For example \"38.898748, -77.037684\"",
"geo.region" => "geo.região",
// "The ISO-3166 Country and Region Codes for your location. For example, \"US-NY\"" => "The ISO-3166 Country and Region Codes for your location. For example, \"US-NY\"",
"geo.placename" => "geo.nome_do_local",
// "A free-text description of your location" => "A free-text description of your location",
// "Meta robots" => "Meta robots",
// "Specify how web-bots should index your site. Valid values include: INDEX or NOINDEX, and FOLLOW or NOFOLLOW" => "Specify how web-bots should index your site. Valid values include: INDEX or NOINDEX, and FOLLOW or NOFOLLOW",
// "Revisit after" => "Revisit after",
// "Specify how often (in days) web-bots should visit your site" => "Specify how often (in days) web-bots should visit your site",
// "Show past metrics results" => "Show past metrics results",
// "In the metrics dashboard, identify if the previously collected metrics should be displayed" => "In the metrics dashboard, identify if the previously collected metrics should be displayed",
// "Past metrics count" => "Past metrics count",
// "Amount of past results to display" => "Amount of past results to display",
// "No metric trend value" => "No metric trend value",
// "Value to display when no trend is available for the metric" => "Value to display when no trend is available for the metric",
// "Metric trend prefix" => "Metric trend prefix",
// "Portion of text to display before the metric trend value" => "Portion of text to display before the metric trend value",
// "Metric trend suffix" => "Metric trend suffix",
// "Portion of text to display after the metric trend value" => "Portion of text to display after the metric trend value",
// "Metric name length" => "Metric name length",
// "Metric tab name length" => "Metric tab name length",
// "Cache metrics output" => "Cache metrics output",
// "Most metrics are expensive to generate. Because they tend to evolve slowly, some delay between update and generation can be tolerated. Disabling cache is not recommended" => "Most metrics are expensive to generate. Because they tend to evolve slowly, some delay between update and generation can be tolerated. Disabling cache is not recommended",
// "Middle shadow start" => "Middle shadow start",
// "Middle shadow end" => "Middle shadow end",
// "Minimum length" => "Minimum length",
// "Mobile Access" => "Mobile Access",
// "New mobile feature for Tiki 7" => "New mobile feature for Tiki 7",
// "Mobile Perspectives" => "Mobile Perspectives",
// "Header Theme" => "Header Theme",
// "jQuery Mobile Theme" => "jQuery Mobile Theme",
// "Content Theme" => "Content Theme",
// "Footer Theme" => "Footer Theme",
// "Modules Theme" => "Modules Theme",
// "Menus Theme" => "Menus Theme",
// "Use Latest Library" => "Use Latest Library",
// "Use latest version of the jquery.mobile" => "Use latest version of the jquery.mobile",
// "Uses latest build from jquery.com CDN" => "Uses latest build from jquery.com CDN",
// "Top module zone" => "Top module zone",
// "Visibility of area to keep modules such as logo, login etc (header)" => "Visibility of area to keep modules such as logo, login etc (header)",
// "Topbar module zone" => "Topbar module zone",
// "Visibility of area for modules such as main horizontal menu, search form, page-wide content, etc" => "Visibility of area for modules such as main horizontal menu, search form, page-wide content, etc",
// "topbar" => "topbar",
// "Page top module zone" => "Page top module zone",
// "Visibility of area to keep modules such as share etc" => "Visibility of area to keep modules such as share etc",
// "Bottom module zone" => "Bottom module zone",
// "Visibility of area to keep modules such as \"powered by\" and \"rss list\" (footer)" => "Visibility of area to keep modules such as \"powered by\" and \"rss list\" (footer)",
// "Page bottom module zone" => "Page bottom module zone",
// "Visibility of area to keep modules at the foot of each page" => "Visibility of area to keep modules at the foot of each page",
// "\"More Like This\" algorithm" => "\"More Like This\" algorithm",
// "Minimum number of tags in common" => "Minimum number of tags in common",
"Multi-domain" => "Multi-domínio",
// "Allows to map domain names to perspectives and simulate multiple domains hosted on the same instance" => "Allows to map domain names to perspectives and simulate multiple domains hosted on the same instance",
// "Multi-domain Configuration" => "Multi-domain Configuration",
// "Comma-separated values mapping the domain name to the perspective ID" => "Comma-separated values mapping the domain name to the perspective ID",
// "One domain per line. Comma separated with perspective ID. Ex.: tiki.org,1" => "One domain per line. Comma separated with perspective ID. Ex.: tiki.org,1",
// "Switch domain when switching perspective" => "Switch domain when switching perspective",
// "Remember that different domains have different login sessions and even in the case of subdomains you need to have an understanding of session cookies to make it work" => "Remember that different domains have different login sessions and even in the case of subdomains you need to have an understanding of session cookies to make it work",
// "Throttle newsletter send rate" => "Throttle newsletter send rate",
// "Pause for a given amount of seconds before each batch to avoid overloading the mail server" => "Pause for a given amount of seconds before each batch to avoid overloading the mail server",
// "Newsletter pause length" => "Newsletter pause length",
// "Amount of seconds on wait before each batch" => "Amount of seconds on wait before each batch",
// "Newsletter batch size" => "Newsletter batch size",
// "Amount of emails to send in each batch" => "Amount of emails to send in each batch",
// "Allow sending newsletters through external clients" => "Allow sending newsletters through external clients",
// "Generate mailto links using the recipients as the BCC list" => "Generate mailto links using the recipients as the BCC list",
// "This will expose the list if email addresses to all users allowed to send newsletters" => "This will expose the list if email addresses to all users allowed to send newsletters",
"Use relative (next / previous) pagination links" => "Usar links de paginação relativos (próximo / anterior)",
// "Wiki buttons" => "Wiki buttons",
// "Page description, icons, backlinks, .." => "Page description, icons, backlinks, ..",
// "Top " => "Top ",
"Bottom" => "Fundo",
// "Neither" => "Neither",
// "A page can occur multiple times in a structure" => "A page can occur multiple times in a structure",
// "Display fast move links (by 10 percent of the total number of pages) " => "Display fast move links (by 10 percent of the total number of pages) ",
// "Hide pagination when there is only one page" => "Hide pagination when there is only one page",
"Use Icons" => "Usar ícones",
"Display 'First' and 'Last' links" => "Exibir links 'Primeiro' e 'Último'",
"PAM service" => "Serviço PAM",
"Currently unused" => "Atualmente sem uso",
// "Require characters and numerals" => "Require characters and numerals",
// "For improved security, require users to include a mix of characters and numerals in passwords" => "For improved security, require users to include a mix of characters and numerals in passwords",
// "Password expires after" => "Password expires after",
// "Require alphabetical characters in lower and upper case" => "Require alphabetical characters in lower and upper case",
// "Password must contain at least one alphabetical character in lower case like a and one in upper case like A" => "Password must contain at least one alphabetical character in lower case like a and one in upper case like A",
// "Require special characters" => "Require special characters",
// "Password must contain at least one special character in lower case like \" / \$ % ? & * ( ) _ + .." => "Password must contain at least one special character in lower case like \" / \$ % ? & * ( ) _ + ..",
// "Require no consecutive repetition of the same character" => "Require no consecutive repetition of the same character",
// "Password must contain no consecutive repetition of the same character as 111 or aab" => "Password must contain no consecutive repetition of the same character as 111 or aab",
// "Password must be different from the user login" => "Password must be different from the user login",
"Payment" => "Pagamento",
// "Feature to manage and track payment requests" => "Feature to manage and track payment requests",
"Payment System" => "Sistema de Pagamento",
// "Currently a choice between PayPal, and Cclite (in development), or Tiki User Credits" => "Currently a choice between PayPal, and Cclite (in development), or Tiki User Credits",
"PayPal: see PayPal.com - Cclite: Community currency" => "PayPal: Veja PayPal.com - Cclite: Moeda Comunitária",
// "PayPal" => "PayPal",
// "Cclite" => "Cclite",
// "Paypal Business ID" => "Paypal Business ID",
// "Enable payments through paypal" => "Enable payments through paypal",
"Email address" => "E-mail",
// "Paypal Environment" => "Paypal Environment",
// "Used to switch between the paypal sandbox, used for testing and development and the live environment" => "Used to switch between the paypal sandbox, used for testing and development and the live environment",
// "Production" => "Production",
// "Paypal Instant Payment Notification (IPN)" => "Paypal Instant Payment Notification (IPN)",
// "Enable IPN for automatic payment completion. When enabled, Paypal will ping back the site when a payment is confirmed. The payment will then be entered automatically. This may not be possible if the server is not on a public server" => "Enable IPN for automatic payment completion. When enabled, Paypal will ping back the site when a payment is confirmed. The payment will then be entered automatically. This may not be possible if the server is not on a public server",
// "Currency used when entering payments" => "Currency used when entering payments",
"Default acceptable payment delay" => "Padrão aceitável de atraso de pagamento",
// "Amount of days before the payment requests becomes overdue. This can be changed per payment request" => "Amount of days before the payment requests becomes overdue. This can be changed per payment request",
// "Cclite Registries" => "Cclite Registries",
// "Registries in Cclite" => "Registries in Cclite",
// "Registry names in Cclite" => "Registry names in Cclite",
// "Cclite Registry Currencies" => "Cclite Registry Currencies",
// "Currencies in Cclite" => "Currencies in Cclite",
// "Each registry in Cclite can have it's own currency. Must be one per registry. (case sensitive)" => "Each registry in Cclite can have it's own currency. Must be one per registry. (case sensitive)",
// "Cclite Server URL" => "Cclite Server URL",
// "Full URL of the repository" => "Full URL of the repository",
// "e.g. https://cclite.yourdomain.org/cclite/" => "e.g. https://cclite.yourdomain.org/cclite/",
// "Cclite Merchant Key" => "Cclite Merchant Key",
// "Corresponds with Merchant Key setting in Cclite" => "Corresponds with Merchant Key setting in Cclite",
// "Cclite Merchant User" => "Cclite Merchant User",
// "User name in Cclite representing \"the management\". Defaults to \"manager\"" => "User name in Cclite representing \"the management\". Defaults to \"manager\"",
// "Cclite Enable Payments" => "Cclite Enable Payments",
// "Test or Live operation" => "Test or Live operation",
// "Live" => "Live",
// "Hashing Algorithm" => "Hashing Algorithm",
// "Encryption type" => "Encryption type",
// "SHA1" => "SHA1",
// "SHA256" => "SHA256",
// "SHA512" => "SHA512",
// "Cclite Payment Notification" => "Cclite Payment Notification",
// "TODO" => "TODO",
// "Wiki page containing the instruction to send manual payment like check" => "Wiki page containing the instruction to send manual payment like check",
"Wiki page" => "Página Wiki",
// "Prefix to the invoice" => "Prefix to the invoice",
// "Prefix must be set and unique if the same paypal account is used for different tiki sites as paypal checks that the invoice is not paid twice" => "Prefix must be set and unique if the same paypal account is used for different tiki sites as paypal checks that the invoice is not paid twice",
// "Types of credit to use" => "Types of credit to use",
// "This is a list of the types of Tiki user credits to accept to pay with" => "This is a list of the types of Tiki user credits to accept to pay with",
// "Exchange rate for types of credit to use" => "Exchange rate for types of credit to use",
// "This is a corresponding list of amount of credits equivalent to 1 of the payment currency" => "This is a corresponding list of amount of credits equivalent to 1 of the payment currency",
// "User can only see his own outstanding payments" => "User can only see his own outstanding payments",
// "Unless with administer payment permissions, a user can only see his own outstanding payments" => "Unless with administer payment permissions, a user can only see his own outstanding payments",
// "User can only see his own past or cancelled payments" => "User can only see his own past or cancelled payments",
// "Unless with administer payment permissions, a user can only see his own past or cancelled payments" => "Unless with administer payment permissions, a user can only see his own past or cancelled payments",
// "Manage product inventory" => "Manage product inventory",
// "Activate product inventory feature, needs Products tracker to be set up properly, the itemId must be the product code" => "Activate product inventory feature, needs Products tracker to be set up properly, the itemId must be the product code",
// "Products Tracker ID" => "Products Tracker ID",
// "Tracker ID of tracker that is the Products tracker, needed for advanced cart features, the itemId will be the product code" => "Tracker ID of tracker that is the Products tracker, needed for advanced cart features, the itemId will be the product code",
// "Products Tracker Name" => "Products Tracker Name",
// "Name of tracker that is the Products tracker, needed for advanced cart features, the itemId will be the product code" => "Name of tracker that is the Products tracker, needed for advanced cart features, the itemId will be the product code",
// "Inventory Type Field ID" => "Inventory Type Field ID",
// "Field ID in Products tracker to store the inventory type, the value of the field must be \"none\" or \"internal\"" => "Field ID in Products tracker to store the inventory type, the value of the field must be \"none\" or \"internal\"",
// "Inventory Total Field ID" => "Inventory Total Field ID",
// "Field ID in Products tracker to store the total inventory of product" => "Field ID in Products tracker to store the total inventory of product",
// "Inventory Total Less Hold Field ID" => "Inventory Total Less Hold Field ID",
// "Field ID in Products tracker to store the total inventory of product less the amount on hold because they are currently in carts" => "Field ID in Products tracker to store the total inventory of product less the amount on hold because they are currently in carts",
// "Inventory Hold Timeout (minutes)" => "Inventory Hold Timeout (minutes)",
// "Minutes to hold inventory before making it available again when there is no user cart action" => "Minutes to hold inventory before making it available again when there is no user cart action",
// "Bundled products feature for cart" => "Bundled products feature for cart",
// "Activate bundled products feature, needs Products tracker to be set up properly, the itemId must be the product code" => "Activate bundled products feature, needs Products tracker to be set up properly, the itemId must be the product code",
// "Product Name Field Name" => "Product Name Field Name",
// "Field Name in Products tracker of the product name that will be used as the label of the product, e.g. in a bundle" => "Field Name in Products tracker of the product name that will be used as the label of the product, e.g. in a bundle",
// "Items in Bundle Field Name" => "Items in Bundle Field Name",
// "Field Name in Products tracker of a comma separated list of product IDs of products in the bundle (i.e. if the field contains anything, then this product is a bundle), you can also specify the number of the sub-products, e.g. 23:(\"colon\")2,24 means item 23 (x2) + item 24 (x1)" => "Field Name in Products tracker of a comma separated list of product IDs of products in the bundle (i.e. if the field contains anything, then this product is a bundle), you can also specify the number of the sub-products, e.g. 23:(\"colon\")2,24 means item 23 (x2) + item 24 (x1)",
// "Product Price Field Name" => "Product Price Field Name",
// "Field Name in Products tracker of the product price" => "Field Name in Products tracker of the product price",
// "Associated Event ID Field Name" => "Associated Event ID Field Name",
// "Field Name in Products tracker of the Associated Event ID, needed for the Associated Events cart feature, requires an Events tracker to be setup where the item ID there is the event ID to associate to" => "Field Name in Products tracker of the Associated Event ID, needed for the Associated Events cart feature, requires an Events tracker to be setup where the item ID there is the event ID to associate to",
// "Product Class ID Field Name" => "Product Class ID Field Name",
// "Field Name in Products tracker of the Product Class ID, needed for the Gift Certificates cart feature" => "Field Name in Products tracker of the Product Class ID, needed for the Gift Certificates cart feature",
// "Gift Certificate Template Field Name" => "Gift Certificate Template Field Name",
// "Field Name in Products tracker of the Gift Cert Template, needed for the Gift Certificates cart feature" => "Field Name in Products tracker of the Gift Cert Template, needed for the Gift Certificates cart feature",
// "Record cart orders in trackers (registered users)" => "Record cart orders in trackers (registered users)",
// "This feature requires 2 trackers, and Orders tracker and an Orders Item tracker to be configured. It also needs profiles to be configured to do the recording" => "This feature requires 2 trackers, and Orders tracker and an Orders Item tracker to be configured. It also needs profiles to be configured to do the recording",
// "Orders Profile" => "Orders Profile",
// "Wiki page where the profile for creating orders is (page name must be without spaces)" => "Wiki page where the profile for creating orders is (page name must be without spaces)",
// "Order Item Profile" => "Order Item Profile",
// "Wiki page where the profile for creating orders items is (page name must be without spaces)" => "Wiki page where the profile for creating orders items is (page name must be without spaces)",
// "Allow anonymous shopping and record their orders in trackers" => "Allow anonymous shopping and record their orders in trackers",
// "Allows shopping as anonymous user" => "Allows shopping as anonymous user",
// "Anonymous Orders Profile" => "Anonymous Orders Profile",
// "Wiki page where the profile for creating orders for Anonymous users is (page name must be without spaces)" => "Wiki page where the profile for creating orders for Anonymous users is (page name must be without spaces)",
// "Anonymous Order Item Profile" => "Anonymous Order Item Profile",
// "Wiki page where the profile for creating orders items for Anonymous users is (page name must be without spaces)" => "Wiki page where the profile for creating orders items for Anonymous users is (page name must be without spaces)",
// "Anonymous Shopper Info Profile" => "Anonymous Shopper Info Profile",
// "Anonymous Users Order Review Page" => "Anonymous Users Order Review Page",
// "Wiki page where Anonymous users can review their orders)" => "Wiki page where Anonymous users can review their orders)",
// "Temporary Shopper Group to Access Review Page via Token" => "Temporary Shopper Group to Access Review Page via Token",
// "Group name of group with perms to access review page via token" => "Group name of group with perms to access review page via token",
// "Allow association of product orders to events (or projects etc...)" => "Allow association of product orders to events (or projects etc...)",
// "Allow association of products to events (or projects etc...)" => "Allow association of products to events (or projects etc...)",
// "Events Tracker ID" => "Events Tracker ID",
// "Tracker ID of tracker that is the Events tracker" => "Tracker ID of tracker that is the Events tracker",
// "Events Tracker Name" => "Events Tracker Name",
// "Name of tracker that is the Events tracker" => "Name of tracker that is the Events tracker",
// "Event Start Field Name" => "Event Start Field Name",
// "Field Name in Events tracker of start date/time" => "Field Name in Events tracker of start date/time",
// "Event End Field Name" => "Event End Field Name",
// "Field Name in Events tracker of end date/time" => "Field Name in Events tracker of end date/time",
// "Allow exchange of products" => "Allow exchange of products",
// "Order Items Tracker ID" => "Order Items Tracker ID",
// "Tracker ID of tracker that is the Order Items tracker" => "Tracker ID of tracker that is the Order Items tracker",
// "Gift certificates" => "Gift certificates",
// "Gift Certificates" => "Gift Certificates",
// "Gift Certificate Tracker ID" => "Gift Certificate Tracker ID",
// "Tracker ID of tracker that is the Gift Certificate tracker" => "Tracker ID of tracker that is the Gift Certificate tracker",
// "Gift Certificate Tracker Name" => "Gift Certificate Tracker Name",
// "Name of tracker that is the Gift Certificate tracker" => "Name of tracker that is the Gift Certificate tracker",
// "Orders Tracker Name" => "Orders Tracker Name",
// "Name of tracker that is the Orders tracker" => "Name of tracker that is the Orders tracker",
// "Order Items Tracker Name" => "Order Items Tracker Name",
// "Name of tracker that is the Order Items tracker" => "Name of tracker that is the Order Items tracker",
// "Product Classes Tracker Name" => "Product Classes Tracker Name",
// "Name of tracker that is the Product Classes tracker" => "Name of tracker that is the Product Classes tracker",
// "Send to URL" => "Send to URL",
// "On permission denied, display login module (for Anonymous)" => "On permission denied, display login module (for Anonymous)",
// "PHP libxml extension" => "PHP libxml extension",
// "This extension requires the libxml PHP extension.\n\t\t\t\t\t\t\tThis means that passing in --enable-libxml is also required, although this is\n\t\t\t\t\t\t\timplicitly accomplished because libxml is enabled by default" => "This extension requires the libxml PHP extension.\n\t\t\t\t\t\t\tThis means that passing in --enable-libxml is also required, although this is\n\t\t\t\t\t\t\timplicitly accomplished because libxml is enabled by default",
// "PHP DateTime" => "PHP DateTime",
// "DateTime class (and related functions) are enabled\n\t\t\t\t\t\t\tby default since PHP 5.2.0, it is possible to add experimental support into PHP\n\t\t\t\t\t\t\t5.1.x by using the following flag before configure/compile:\n\t\t\t\t\t\t\tCFLAGS=-DEXPERIMENTAL_DATE_SUPPORT=1" => "DateTime class (and related functions) are enabled\n\t\t\t\t\t\t\tby default since PHP 5.2.0, it is possible to add experimental support into PHP\n\t\t\t\t\t\t\t5.1.x by using the following flag before configure/compile:\n\t\t\t\t\t\t\tCFLAGS=-DEXPERIMENTAL_DATE_SUPPORT=1",
"Show categories" => "Mostrar categorias",
"Show objects" => "Mostrar objetos",
// "Multiple polls per object" => "Multiple polls per object",
// "When used with the rating features, allow multiple polls to be attached to a single object" => "When used with the rating features, allow multiple polls to be attached to a single object",
// "PDF from URL" => "PDF from URL",
// "Using extenal tools, generate PDF document from web URLs" => "Using extenal tools, generate PDF document from web URLs",
// "WebKit (wkhtmltopdf)" => "WebKit (wkhtmltopdf)",
// "Webservice URL" => "Webservice URL",
// "URL to a service taking a URL as the query string and returns a PDF document" => "URL to a service taking a URL as the query string and returns a PDF document",
// "WebKit path" => "WebKit path",
// "Full path to the wkhtmltopdf executable to generate the PDF document with" => "Full path to the wkhtmltopdf executable to generate the PDF document with",
// "Repository URLs" => "Repository URLs",
// "List of URLs for the profile repositories that will be used" => "List of URLs for the profile repositories that will be used",
// "Enter multiple repository URLs, one per line" => "Enter multiple repository URLs, one per line",
// "Data Channels" => "Data Channels",
// "Data channels are templates that can be applied from a post request. They can be used to automate work on more complex installations" => "Data channels are templates that can be applied from a post request. They can be used to automate work on more complex installations",
// "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain __channel name, domain, profile, allowed groups, (optional) \$profilerequest:input\$ matches to groups__" => "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain __channel name, domain, profile, allowed groups, (optional) \$profilerequest:input\$ matches to groups__",
// "There are security considerations related to using data channels. Make sure the profile page is controlled by administrators only" => "There are security considerations related to using data channels. Make sure the profile page is controlled by administrators only",
// "Developer mode" => "Developer mode",
// "For profiles under an approval workflow, always use the latest version, even if not approved" => "For profiles under an approval workflow, always use the latest version, even if not approved",
// "Make sure you review the profiles you install" => "Make sure you review the profiles you install",
// "Proxy host name" => "Proxy host name",
// "Proxy host - without http:// or similar, just the host name" => "Proxy host - without http:// or similar, just the host name",
"Proxy port" => "Porta do Proxy",
// "Proxy username" => "Proxy username",
// "Proxy password" => "Proxy password",
// "Quantify change size" => "Quantify change size",
// "In addition to tracking the changes, track the change size and display the approximate up-to-date-ness of the page" => "In addition to tracking the changes, track the change size and display the approximate up-to-date-ness of the page",
// "Advanced Rating" => "Advanced Rating",
// "Rating system allowing for options and calculation method to be configured" => "Rating system allowing for options and calculation method to be configured",
// "Rating recalculation mode" => "Rating recalculation mode",
// "Determines when and how rating aggregates are recalculated. Depending on the site load, some options may be preferred to others. On large volume sites, it should be done as a cron job. On vote recalculation may be inaccurate if rating calculation depends time" => "Determines when and how rating aggregates are recalculated. Depending on the site load, some options may be preferred to others. On large volume sites, it should be done as a cron job. On vote recalculation may be inaccurate if rating calculation depends time",
// "Recalculate on vote" => "Recalculate on vote",
// "Randomly recalculate oldest ratings (on load)" => "Randomly recalculate oldest ratings (on load)",
// "Randomly recalculate oldest ratings (on vote)" => "Randomly recalculate oldest ratings (on vote)",
// "Cron job (must be set manually)" => "Cron job (must be set manually)",
// "Recalculation odds (1 in X)" => "Recalculation odds (1 in X)",
// "Dice roll performed on every request. When successful, will recalculate a certain number of votes" => "Dice roll performed on every request. When successful, will recalculate a certain number of votes",
// "Recalculation count" => "Recalculation count",
// "How many ratings should be recalculated when odds strike" => "How many ratings should be recalculated when odds strike",
// "Use ReCaptcha" => "Use ReCaptcha",
// "Use ReCaptcha, a specialized captcha service, instead of default CAPTCHA" => "Use ReCaptcha, a specialized captcha service, instead of default CAPTCHA",
// "You will need to register at [http://www.google.com/recaptcha]" => "You will need to register at [http://www.google.com/recaptcha]",
// "Public Key" => "Public Key",
// "ReCaptcha public key" => "ReCaptcha public key",
// "Private Key" => "Private Key",
// "ReCaptcha private key" => "ReCaptcha private key",
"Record untranslated strings" => "Gravar sem tradução",
// "Keep track of the unsuccessful attemps to translate strings" => "Keep track of the unsuccessful attemps to translate strings",
"Restrict supported languages" => "Restringir idiomas disponíveis",
// "Limit the languages made available on the site" => "Limit the languages made available on the site",
// "SCORM Support" => "SCORM Support",
// "Handle SCORM package files on upload. SCORM is a standard used in Learning Management Systems" => "Handle SCORM package files on upload. SCORM is a standard used in Learning Management Systems",
// "SCORM Tracker" => "SCORM Tracker",
// "Tracker ID to use to store the SCORM metadata" => "Tracker ID to use to store the SCORM metadata",
// "Parse the results" => "Parse the results",
// "Default where" => "Default where",
// "When object filter is not on, limit to search one type of object" => "When object filter is not on, limit to search one type of object",
// "Entire site" => "Entire site",
"Wiki Pages" => "Páginas Wiki",
"Blog Posts" => "Mensagens de Blogs",
"Tracker Items" => "itens do formulário",
"Spreadsheets" => "Planilhas",
// "Restrict search language by default" => "Restrict search language by default",
// "If enabled, only search content in the interface language, otherwise show language menu" => "If enabled, only search content in the interface language, otherwise show language menu",
// "Autocomplete on page names" => "Autocomplete on page names",
// "Category filter" => "Category filter",
// "Tag filter" => "Tag filter",
// "Parse wiki syntax in comments in all sections apart from Forums" => "Parse wiki syntax in comments in all sections apart from Forums",
// "Use \"Accept wiki syntax\" for forums in admin forums page" => "Use \"Accept wiki syntax\" for forums in admin forums page",
"Sender email" => "Remetente dos e-mails",
// "Email address that will be used as the sender for outgoing emails" => "Email address that will be used as the sender for outgoing emails",
"Time zone" => "Fuso horário",
// "Indicates the default time zone to use for the server" => "Indicates the default time zone to use for the server",
// "Session storage location" => "Session storage location",
// "Select where the session information should be stored. Memcache sessions require memcache to be configured" => "Select where the session information should be stored. Memcache sessions require memcache to be configured",
// "Default (from php.ini)" => "Default (from php.ini)",
"Database" => "Banco de dados",
// "Session lifetime" => "Session lifetime",
// "Value provided in minutes. It will be the minimum time you are logged in. If you want it to be the exact time, you need to adjust in .htaccess session.gc_probability and session.gc_divisor to 1. Be careful that changing the probability will affect the server performance" => "Value provided in minutes. It will be the minimum time you are logged in. If you want it to be the exact time, you need to adjust in .htaccess session.gc_probability and session.gc_divisor to 1. Be careful that changing the probability will affect the server performance",
// "Silent session" => "Silent session",
// "Do not automatically start sessions" => "Do not automatically start sessions",
// "Users will only have a session if they log in. So anonymous users will lose the capacity to have things like Switch Language (a session is needed for this)" => "Users will only have a session if they log in. So anonymous users will lose the capacity to have things like Switch Language (a session is needed for this)",
// "Session cookie name" => "Session cookie name",
// "Session cookie name used instead of the PHP default configuration" => "Session cookie name used instead of the PHP default configuration",
// "Protect all sessions with HTTPS" => "Protect all sessions with HTTPS",
// "Always redirect to HTTPS to prevent session hijack through network sniffing" => "Always redirect to HTTPS to prevent session hijack through network sniffing",
// "Only activate if you have already configured SSL, otherwise, your will lock yourself out of Tiki" => "Only activate if you have already configured SSL, otherwise, your will lock yourself out of Tiki",
// "Display links in the share page" => "Display links in the share page",
// "Token notification" => "Token notification",
// "Users can subscribe to the notifications of consultation of the token" => "Users can subscribe to the notifications of consultation of the token",
// "Add contact" => "Add contact",
// "If not exist, recipients are add in the list of contacts" => "If not exist, recipients are add in the list of contacts",
// "Display name and email" => "Display name and email",
// "If user is connect, name and email display in the page" => "If user is connect, name and email display in the page",
// "How many times accessed" => "How many times accessed",
// "User can choose how many times the share page can be consulted" => "User can choose how many times the share page can be consulted",
// "Max how many times accessed" => "Max how many times accessed",
// "Maximum number of times that the shared page can be consulted" => "Maximum number of times that the shared page can be consulted",
"Default group" => "Grupo padrão",
// "Create with default group" => "Create with default group",
// "Valid affiliations" => "Valid affiliations",
// "Separate multiple affiliations with commas" => "Separate multiple affiliations with commas",
// "Shipping Service" => "Shipping Service",
// "Expose a JSON shipping rate estimation service. Accounts from providers may be required (FedEx, UPS, ...)" => "Expose a JSON shipping rate estimation service. Accounts from providers may be required (FedEx, UPS, ...)",
// "FedEx API" => "FedEx API",
// "Enable shipping rate calculation through FedEx APIs" => "Enable shipping rate calculation through FedEx APIs",
// "FedEx Key" => "FedEx Key",
// "Developer Key" => "Developer Key",
// "FedEx Password" => "FedEx Password",
// "FedEx Meter Number" => "FedEx Meter Number",
"FedEx Account Number" => "Número de Conta FedEx",
// "UPS API" => "UPS API",
// "Enable shipping rate calculation using the UPS carrier" => "Enable shipping rate calculation using the UPS carrier",
"UPS Username" => "Nome de Usuário UPS",
// "UPS credentials" => "UPS credentials",
"UPS Password" => "Senha UPS",
// "UPS Access Key" => "UPS Access Key",
// "Custom Shipping Provider" => "Custom Shipping Provider",
"Short date format" => "Formato curto para datas",
"Short time format" => "Formato curto para horas",
// "%Y-%m-%d" => "%Y-%m-%d",
// "%H:%M" => "%H:%M",
// "%Y-%m-%d %H:%M" => "%Y-%m-%d %H:%M",
// "Display available translations" => "Display available translations",
// "" => "",
"Close site (except for those with permission)" => "Fechar site (exceto para aqueles com permissão)",
// "Message to display" => "Message to display",
// "Locations (breadcrumbs)" => "Locations (breadcrumbs)",
// "Choices" => "Choices",
"Site title location" => "Localização do título do site",
// "Location of the site title in the browser title bar relative to the current page's descriptor" => "Location of the site title in the browser title bar relative to the current page's descriptor",
"After" => "Depois",
"Before" => "Antes",
"Browser title display mode" => "Modo para exibir título no navegador",
// "When breadcrumbs are used, method in which the browser title should be displayed" => "When breadcrumbs are used, method in which the browser title should be displayed",
"Most specific first" => "Mais específico primeiro",
"Least specific first (site)" => "Menos específico primeiro (site)",
"Current only" => "Atual apenas",
// "Favicon icon file name" => "Favicon icon file name",
// "Favicon MIME type" => "Favicon MIME type",
// "Typical file extensions:<table><tr><td>image/jpeg</td><td><strong>.jpg</strong></td></tr><tr><td>imp/png</td><td><strong>.png</strong></td></tr><tr><td>img/gif</td><td><strong>.gif</strong></td></tr><tr><td>image/vnd.microsoft.icon</td><td><strong>.ico</strong></td></tr></table>" => "Typical file extensions:<table><tr><td>image/jpeg</td><td><strong>.jpg</strong></td></tr><tr><td>imp/png</td><td><strong>.png</strong></td></tr><tr><td>img/gif</td><td><strong>.gif</strong></td></tr><tr><td>image/vnd.microsoft.icon</td><td><strong>.ico</strong></td></tr></table>",
// "image/jpeg" => "image/jpeg",
"image/png" => "imagem/png",
// "image/gif" => "image/gif",
// "image/vnd.microsoft.icon" => "image/vnd.microsoft.icon",
// "Site Terminal" => "Site Terminal",
// "Allows to direct users to a specific perspective depending on the origin IP address. Can be used inside intranets to use different configurations for users depending on their departements or discriminate people in web contexts. Unspecified IPs will fall back to default behavior, including multi-domain handling. Manually selected perspectives take precedence over this" => "Allows to direct users to a specific perspective depending on the origin IP address. Can be used inside intranets to use different configurations for users depending on their departements or discriminate people in web contexts. Unspecified IPs will fall back to default behavior, including multi-domain handling. Manually selected perspectives take precedence over this",
// "Site Terminal Configuration" => "Site Terminal Configuration",
// "Provides the mapping from subnets to perspective" => "Provides the mapping from subnets to perspective",
// "One per line. Network prefix in CIDR notation (address/mask size), separated by comma with the perspective ID" => "One per line. Network prefix in CIDR notation (address/mask size), separated by comma with the perspective ID",
"Publish" => "publicação",
// "Logo source (image path)" => "Logo source (image path)",
"Logo background color" => "Cor de fundo do logo",
"Examples" => "Exemplos",
"Logo title (on mouse over)" => "Título do logo (quando o mouse estiver em cima da imagem)",
"Alt. description (e.g. for text browsers)" => "Descrição alternativa (ex: para navegadores modo texto",
// "Include smarty notices in PHP error report" => "Include smarty notices in PHP error report",
// "In most cases, smarty notices can be safely ignored. However, they may be useful in the development process when strange issues occur" => "In most cases, smarty notices can be safely ignored. However, they may be useful in the development process when strange issues occur",
// "Smarty Security" => "Smarty Security",
// "Do not allow php code in smarty templates" => "Do not allow php code in smarty templates",
// "You should leave this on unless you know what you are doing" => "You should leave this on unless you know what you are doing",
// "Smarty Compilation" => "Smarty Compilation",
// "Indicates when the template cache should be refreshed" => "Indicates when the template cache should be refreshed",
"Modified" => "Modificado",
// "Never check (performance)" => "Never check (performance)",
// "Always (development, slow)" => "Always (development, slow)",
// "Consumer key" => "Consumer key",
// "Consumer key generated by registering your site as an application at Twitter" => "Consumer key generated by registering your site as an application at Twitter",
// "Consumer secret" => "Consumer secret",
// "Consumer secret generated by registering your site as an application at Twitter" => "Consumer secret generated by registering your site as an application at Twitter",
// "Application secret" => "Application secret",
// "Application secret generated by registering your site as an application at Facebook" => "Application secret generated by registering your site as an application at Facebook",
// "Application ID" => "Application ID",
// "Application id generated by registering your site as an application at Facebook" => "Application id generated by registering your site as an application at Facebook",
// "Login using Facebook" => "Login using Facebook",
// "Allow users to login using Facebook" => "Allow users to login using Facebook",
// "Auto-create Tiki user" => "Auto-create Tiki user",
// "Automatically create a Tiki user by the username of fb_xxxxxxxx for users logging in using Facebook if they do not yet have a Tiki account. If not, they will be asked to link or register a Tiki account" => "Automatically create a Tiki user by the username of fb_xxxxxxxx for users logging in using Facebook if they do not yet have a Tiki account. If not, they will be asked to link or register a Tiki account",
// "Require Facebook users to enter local account info" => "Require Facebook users to enter local account info",
// "Require Facebook users to enter local account info, specifically email and local login name" => "Require Facebook users to enter local account info, specifically email and local login name",
// "Tiki can access Facebook at any time" => "Tiki can access Facebook at any time",
// "Even when user is not logged onto Facebook, Tiki can access it" => "Even when user is not logged onto Facebook, Tiki can access it",
// "Tiki can post to Wall" => "Tiki can post to Wall",
// "Tiki may post status messages, notes, photos, and videos to Facebook Wall" => "Tiki may post status messages, notes, photos, and videos to Facebook Wall",
// "Tiki can manage events" => "Tiki can manage events",
// "Tiki may create and RSVP to Facebook events" => "Tiki may create and RSVP to Facebook events",
// "Tiki can manage pages" => "Tiki can manage pages",
// "Tiki may manage user pages" => "Tiki may manage user pages",
// "Tiki can SMS" => "Tiki can SMS",
// "Tiki may SMS via Facebook" => "Tiki may SMS via Facebook",
// "bit.ly Login" => "bit.ly Login",
// "Site wide login (username) for bit.ly" => "Site wide login (username) for bit.ly",
// "bit.ly Key" => "bit.ly Key",
// "Site wide API key for bit.ly" => "Site wide API key for bit.ly",
// "Use site-wide account" => "Use site-wide account",
// "When setting this option to yes, only the site wide account will be used for all users" => "When setting this option to yes, only the site wide account will be used for all users",
// "Theme options" => "Theme options",
// "Style options" => "Style options",
// "New.." => "New..",
// "Theme Generator" => "Theme Generator",
// "Permits to adjust colors and fonts via the browser" => "Permits to adjust colors and fonts via the browser",
// "Custom Theme" => "Custom Theme",
// "Description needed" => "Description needed",
"Check frequency" => "Checar frequência",
"Each day" => "Cada dia",
"Each week" => "Cada semana",
"Each month" => "Cada mês",
// "Minify JavaScript" => "Minify JavaScript",
// "Compress JavaScript files used in the page into a single file to be distributed statically. Changes to JavaScript files will require cache to be cleared. Uses http://code.google.com/p/minify/" => "Compress JavaScript files used in the page into a single file to be distributed statically. Changes to JavaScript files will require cache to be cleared. Uses http://code.google.com/p/minify/",
// "Minify CSS" => "Minify CSS",
// "Compress CSS files by removing additional spaces and grouping multiple files into one. Changes to CSS files will require cache to be cleared. Uses http://code.google.com/p/minify/" => "Compress CSS files by removing additional spaces and grouping multiple files into one. Changes to CSS files will require cache to be cleared. Uses http://code.google.com/p/minify/",
// "Minify CSS into a single file" => "Minify CSS into a single file",
// "In addition to reducing the size of the CSS, reduce the number of included files" => "In addition to reducing the size of the CSS, reduce the number of included files",
// "This setting may not work out of the box for all styles. import needs to use @import url(\"...\") and not @import \"...\"" => "This setting may not work out of the box for all styles. import needs to use @import url(\"...\") and not @import \"...\"",
"Skip date for same day" => "Exibir apenas hora para mesmo dia",
// "When displaying short date and time, skip date for today. Only time will be displayed" => "When displaying short date and time, skip date for today. Only time will be displayed",
// "Cache-Control header" => "Cache-Control header",
// "Custom HTTP header to use when a session is active" => "Custom HTTP header to use when a session is active",
// "Example: no-cache, pre-check=0, post-check=0" => "Example: no-cache, pre-check=0, post-check=0",
// "Cache-Control header (no session)" => "Cache-Control header (no session)",
// "Custom HTTP header to use when no session is active" => "Custom HTTP header to use when no session is active",
// "Content Delivery Network" => "Content Delivery Network",
// "Use an alternate domain name to serve static files from tiki to avoid sending cookies, improve local caching and generally improve user experience performance" => "Use an alternate domain name to serve static files from tiki to avoid sending cookies, improve local caching and generally improve user experience performance",
// "Prefix to include before the static files, for example: http://cdn.example.com" => "Prefix to include before the static files, for example: http://cdn.example.com",
// "Content Delivery Network (in SSL)" => "Content Delivery Network (in SSL)",
// "Use an alternate domain name to serve static files from tiki to avoid sending cookies, improve local caching and generally improve user experience performance. Leave empty to disable CDN in SSL mode" => "Use an alternate domain name to serve static files from tiki to avoid sending cookies, improve local caching and generally improve user experience performance. Leave empty to disable CDN in SSL mode",
// "Prefix to include before the static files, for example: https://cdn.example.com" => "Prefix to include before the static files, for example: https://cdn.example.com",
// "Domain prefix handling" => "Domain prefix handling",
// "Strip or automatically add the \"www.\" prefix on domain names to standardize URLs" => "Strip or automatically add the \"www.\" prefix on domain names to standardize URLs",
// "Leave as-is" => "Leave as-is",
// "Remove the www" => "Remove the www",
// "Add the www" => "Add the www",
// "Domain redirects" => "Domain redirects",
// "When the site is accessed through specific domain names, redirect to an alternate domain preserving the URL. Useful for domain name transitions, like tikiwiki.org to tiki.org" => "When the site is accessed through specific domain names, redirect to an alternate domain preserving the URL. Useful for domain name transitions, like tikiwiki.org to tiki.org",
// "One entry per line. Comma separated list: old, new" => "One entry per line. Comma separated list: old, new",
// "Validate uploaded file content" => "Validate uploaded file content",
// "Do not trust user input and open the files to verify their content" => "Do not trust user input and open the files to verify their content",
// "Allow the tiki_p_trust_input permission" => "Allow the tiki_p_trust_input permission",
// "Bypasses user input filtering" => "Bypasses user input filtering",
// "Note, all permissions are granted to the Admins group including this one, so if you enable this you may expose your site to XSS (Cross Site Scripting) attacks for admin users" => "Note, all permissions are granted to the Admins group including this one, so if you enable this you may expose your site to XSS (Cross Site Scripting) attacks for admin users",
// "Synchronize Remote Tracker" => "Synchronize Remote Tracker",
// "Allows to clone a tracker on a remote host and synchronize the data locally on demand" => "Allows to clone a tracker on a remote host and synchronize the data locally on demand",
// "Refresh item link items when master is modified" => "Refresh item link items when master is modified",
// "To be used when item link is used in trackers so that the index remains in good shape when data on the master that is indexed with the detail is modified and used to search on" => "To be used when item link is used in trackers so that the index remains in good shape when data on the master that is indexed with the detail is modified and used to search on",
// "Unified Search Engine" => "Unified Search Engine",
// "Search engine used to index the content of your Tiki. Some engines are more suitable for larger sites, but require additional software on the server" => "Search engine used to index the content of your Tiki. Some engines are more suitable for larger sites, but require additional software on the server",
// "Lucene (PHP Implementation)" => "Lucene (PHP Implementation)",
// "Lucene Index Location" => "Lucene Index Location",
// "Path to the location of the Lucene search index. The index must be on a local filesystem with enough space to contain the volume of the database" => "Path to the location of the Lucene search index. The index must be on a local filesystem with enough space to contain the volume of the database",
// "Highlight results snippets" => "Highlight results snippets",
// "Highlight the result snippet based on the search query. Enabling this option will impact performance, but improve user experience" => "Highlight the result snippet based on the search query. Enabling this option will impact performance, but improve user experience",
// "Lucene Maximum Results" => "Lucene Maximum Results",
// "Maximum amount of results to expose. Results further than these will need a more refined query to be reached" => "Maximum amount of results to expose. Results further than these will need a more refined query to be reached",
// "Lucene Maximum Result Set Limit" => "Lucene Maximum Result Set Limit",
// "Maximum size of result set to consider. Default 1000, 0 = unlimited" => "Maximum size of result set to consider. Default 1000, 0 = unlimited",
// "This is used when calculating result scores and sort order which can lead to out of memory errors on large data sets. The default of 1000 is safe with the PHP memory_limit set to 128M" => "This is used when calculating result scores and sort order which can lead to out of memory errors on large data sets. The default of 1000 is safe with the PHP memory_limit set to 128M",
// "Lucene Terms Per Query Limit" => "Lucene Terms Per Query Limit",
// "Maximum number of terms to be generated. Try increasing this value if you get errors saying \"Terms per query limit is reached\" espescially with wildcard, range and fuzzy searches" => "Maximum number of terms to be generated. Try increasing this value if you get errors saying \"Terms per query limit is reached\" espescially with wildcard, range and fuzzy searches",
// "Lucene Max Buffered Documents" => "Lucene Max Buffered Documents",
// "Number of documents required before the buffered in-memory documents are written into a new segment" => "Number of documents required before the buffered in-memory documents are written into a new segment",
// "Lucene Max Merge Documents" => "Lucene Max Merge Documents",
// "Largest number of documents ever merged by addDocument(). Small values (e.g., less than 10,000) are best for interactive indexing, as this limits the length of pauses while indexing to a few seconds. Larger values are best for batched indexing and speedier searches" => "Largest number of documents ever merged by addDocument(). Small values (e.g., less than 10,000) are best for interactive indexing, as this limits the length of pauses while indexing to a few seconds. Larger values are best for batched indexing and speedier searches",
// "Small values (e.g., less than 10,000) are best for interactive indexing. Use 0 for the Lucene default, which is practically infinite" => "Small values (e.g., less than 10,000) are best for interactive indexing. Use 0 for the Lucene default, which is practically infinite",
// "Lucene Default Boolean Operator" => "Lucene Default Boolean Operator",
// "Use OR (default) or AND as the default search operator" => "Use OR (default) or AND as the default search operator",
// "OR" => "OR",
// "AND" => "AND",
// "Lucene Merge Factor" => "Lucene Merge Factor",
// "How often segment indices are merged by addDocument(). With smaller values, less RAM is used while indexing, and searches on unoptimized indices are faster, but indexing speed is slower. With larger values, more RAM is used during indexing, and while searches on unoptimized indices are slower, indexing is faster. Thus larger values (> 10) are best for batch index creation, and smaller values (< 10) for indices that are interactively maintained" => "How often segment indices are merged by addDocument(). With smaller values, less RAM is used while indexing, and searches on unoptimized indices are faster, but indexing speed is slower. With larger values, more RAM is used during indexing, and while searches on unoptimized indices are slower, indexing is faster. Thus larger values (> 10) are best for batch index creation, and smaller values (< 10) for indices that are interactively maintained",
// "Large values (> 10) are best for batch index creation, and smaller values (< 10) for indices that are interactively maintained" => "Large values (> 10) are best for batch index creation, and smaller values (< 10) for indices that are interactively maintained",
// "Incremental Index Update" => "Incremental Index Update",
// "Update the index incrementally as the site content is modified. This may lead to lower performance and accuracy than processing the index on a periodic basis" => "Update the index incrementally as the site content is modified. This may lead to lower performance and accuracy than processing the index on a periodic basis",
// "Field Weights" => "Field Weights",
// "Allows to set the field weights that apply when ranking the pages for search listing. The weight only applies when the field is in the query. To nullify the value of a field, use an insignificant amount, not 0, which may lead to unexpected behaviors, such as stripping results" => "Allows to set the field weights that apply when ranking the pages for search listing. The weight only applies when the field is in the query. To nullify the value of a field, use an insignificant amount, not 0, which may lead to unexpected behaviors, such as stripping results",
// "One field per line, field_name__:__5.3" => "One field per line, field_name__:__5.3",
// "Default content fields" => "Default content fields",
// "All of the content is aggregated in the contents field. For custom weighting to apply, the fields must be included in the query. This option allows to include other fields in the default content search" => "All of the content is aggregated in the contents field. For custom weighting to apply, the fields must be included in the query. This option allows to include other fields in the default content search",
// "Tokenize version numbers" => "Tokenize version numbers",
// "Tokenize version number strings so that major versions are found when sub-versions are mentionned. For example, searching for 2.7 would return documents containing 2.7.4, but not 1.2.7" => "Tokenize version number strings so that major versions are found when sub-versions are mentionned. For example, searching for 2.7 would return documents containing 2.7.4, but not 1.2.7",
// "Cache per user and query" => "Cache per user and query",
// "Time in minutes a user has a same query cached " => "Time in minutes a user has a same query cached ",
// "In minutes" => "In minutes",
// "Index forum replies together with root post" => "Index forum replies together with root post",
// "If enabled, forum replies will be indexed together with the root post as a single document instead of being separately indexed" => "If enabled, forum replies will be indexed together with the root post as a single document instead of being separately indexed",
// "Search formatters to cache" => "Search formatters to cache",
// "Search formatters to cache the output of" => "Search formatters to cache the output of",
// "Format to use for tracker field keys" => "Format to use for tracker field keys",
// "Choose between field ids and permanent names for the tracker indexing" => "Choose between field ids and permanent names for the tracker indexing",
// "Permanent Name" => "Permanent Name",
// "Field ID (Backward compatibility mode with Tiki 7 and 8)" => "Field ID (Backward compatibility mode with Tiki 7 and 8)",
// "Excluded categories" => "Excluded categories",
// "List of category ids to exclude from the search index" => "List of category ids to exclude from the search index",
// "unsuccessful login attempts" => "unsuccessful login attempts",
// "After a certain number of consecutive unsuccessfull login attempts, the user will receive a mail with instruction to validate his account. However the user can still log-in with his old password" => "After a certain number of consecutive unsuccessfull login attempts, the user will receive a mail with instruction to validate his account. However the user can still log-in with his old password",
// "Suspend account after" => "Suspend account after",
// "After a certain number of consecutive unsuccessfull login attempts, the account is suspended . An admin must revalidate the account before the user can use it again" => "After a certain number of consecutive unsuccessfull login attempts, the account is suspended . An admin must revalidate the account before the user can use it again",
// "URL a user is redirected to after account validation" => "URL a user is redirected to after account validation",
"Account validated successfully." => "Validação da conta confirmada.",
// "URL an anonymous is redirected when page not found" => "URL an anonymous is redirected when page not found",
"Close site when server load is above the threshold  (except for those with permission)" => "Fechar site quando a carga do servidor estiver além do limite (exceto para aqueles com permissão)",
"Use proxy" => "Usar proxy",
// "Use context menus for actions (icons)" => "Use context menus for actions (icons)",
// "Use context menus for actions (text)" => "Use context menus for actions (text)",
// "Show user's real name instead of login (when possible)" => "Show user's real name instead of login (when possible)",
// "Display UserTracker information on the user information page" => "Display UserTracker information on the user information page",
// "Input the user tracker ID then field IDs to be shown, all separated by commas. Example: 1,1,2,3,4 (user tracker ID 1 followed by field IDs 1-4)" => "Input the user tracker ID then field IDs to be shown, all separated by commas. Example: 1,1,2,3,4 (user tracker ID 1 followed by field IDs 1-4)",
// "Users can configure modules" => "Users can configure modules",
// "Users can shade modules" => "Users can shade modules",
// "Allows users to hide/show modules" => "Allows users to hide/show modules",
// "Module decides" => "Module decides",
// "Store full-size copy of avatar in file gallery" => "Store full-size copy of avatar in file gallery",
// "File gallery to store full-size copy of avatar in" => "File gallery to store full-size copy of avatar in",
// "Enter the gallery id here. Please create a dedicated gallery that is admin-only for security, or make sure gallery permissions are set so that only admins can edit" => "Enter the gallery id here. Please create a dedicated gallery that is admin-only for security, or make sure gallery permissions are set so that only admins can edit",
// "File ID of default avatar image" => "File ID of default avatar image",
// "File ID of image to use in file gallery as the avatar if user has no avatar image in file galleries" => "File ID of image to use in file gallery as the avatar if user has no avatar image in file galleries",
// "Display who viewed my stuff on the user information page" => "Display who viewed my stuff on the user information page",
// "You will need to activate tracking of views for various items in the action log for this to work" => "You will need to activate tracking of views for various items in the action log for this to work",
// "Number of days to consider who viewed my stuff" => "Number of days to consider who viewed my stuff",
// "Number of days before current time to consider when showing who viewed my stuff" => "Number of days before current time to consider when showing who viewed my stuff",
// "Show to others who viewed my stuff on the user information page" => "Show to others who viewed my stuff on the user information page",
// "Show to others who viewed my stuff on the user information page. Admins can always see this information" => "Show to others who viewed my stuff on the user information page. Admins can always see this information",
// "Maximum number of users to show in drop down lists" => "Maximum number of users to show in drop down lists",
// "Prevents out of memory and performance issues when user list is very large by using a jQuery autocomplete text input box" => "Prevents out of memory and performance issues when user list is very large by using a jQuery autocomplete text input box",
// "Use pretty trackers for registration form" => "Use pretty trackers for registration form",
// "Registration pretty tracker template" => "Registration pretty tracker template",
// "Use wiki page name or template file with .tpl extension" => "Use wiki page name or template file with .tpl extension",
// "Output the registration results" => "Output the registration results",
// "Use a wiki page as template to output the registration results to" => "Use a wiki page as template to output the registration results to",
// "Output registration pretty tracker template" => "Output registration pretty tracker template",
// "Wiki page only" => "Wiki page only",
// "Page name fieldId" => "Page name fieldId",
// "User trackers field id whose value is used as output page name" => "User trackers field id whose value is used as output page name",
// "User tracker IDs to sync prefs from" => "User tracker IDs to sync prefs from",
// "Enter the IDs separated by commas of trackers to sync user prefs from" => "Enter the IDs separated by commas of trackers to sync user prefs from",
// "Tracker field IDs to sync Real Name pref from" => "Tracker field IDs to sync Real Name pref from",
// "Enter the IDs separated by commas in priority of being chosen, each item can concatenate multiple fields using +, e.g. 2+3,4" => "Enter the IDs separated by commas in priority of being chosen, each item can concatenate multiple fields using +, e.g. 2+3,4",
// "Synchronize long/lat/zoom to location field" => "Synchronize long/lat/zoom to location field",
// "Synchronize user geolocation prefs to main location field" => "Synchronize user geolocation prefs to main location field",
// "Synchronize categories of user tracker item to user groups" => "Synchronize categories of user tracker item to user groups",
// "Will add the user tracker item to the category of the same name as the user groups and vice versa" => "Will add the user tracker item to the category of the same name as the user groups and vice versa",
// "Put user in group only if categorized within" => "Put user in group only if categorized within",
// "Change user system language when changing user tracker item language" => "Change user system language when changing user tracker item language",
// "Show user's real name instead of login in autocomplete selector in trackers feature" => "Show user's real name instead of login in autocomplete selector in trackers feature",
// "Use user's real name instead of login in autocomplete selector in trackers feature" => "Use user's real name instead of login in autocomplete selector in trackers feature",
// "Show user's real name instead of login in autocomplete selector in messaging feature" => "Show user's real name instead of login in autocomplete selector in messaging feature",
// "Use user's real name instead of login in autocomplete selector in messaging feature" => "Use user's real name instead of login in autocomplete selector in messaging feature",
// "User Favorites" => "User Favorites",
// "Allows for users to flag content as their favorite" => "Allows for users to flag content as their favorite",
// "Users must choose a group at registration" => "Users must choose a group at registration",
// "Users cannot register without choosing one of the groups defined above" => "Users cannot register without choosing one of the groups defined above",
// "Score ascending" => "Score ascending",
// "Score descending" => "Score descending",
// "Name ascending" => "Name ascending",
// "Name descending" => "Name descending",
// "Login ascending" => "Login ascending",
// "Login descending" => "Login descending",
// "Quota (MB)" => "Quota (MB)",
"Private" => "Privada",
// "Users can see each other's files" => "Users can see each other's files",
// "Username pattern" => "Username pattern",
// "Serve avatar images statically" => "Serve avatar images statically",
// "When enabled, feature checks and permission checks will be skipped" => "When enabled, feature checks and permission checks will be skipped",
"Displayed time zone" => "Fuso horário exibido",
// "Always the site default time zone" => "Always the site default time zone",
// "Use time zone set from user preferences, or the automatically detected time zone for anonymous (if browser allows). Site default is used as fallback" => "Use time zone set from user preferences, or the automatically detected time zone for anonymous (if browser allows). Site default is used as fallback",
"Number of visited pages to remember" => "Número de páginas visitadas a lembrar",
"User information" => "Informação do Usuário",
"Public" => "Público",
"Use double-click to edit pages" => "Clique-duplo para editar páginas",
// "Use 12-hour clock for time selectors" => "Use 12-hour clock for time selectors",
// "Use the 12-hour clock (with AM and PM) for time selectors used in some edit windows to set the time for publishing new or edited blog posts, articles, etc" => "Use the 12-hour clock (with AM and PM) for time selectors used in some edit windows to set the time for publishing new or edited blog posts, articles, etc",
// "Use new diff any version interface" => "Use new diff any version interface",
"Tasks per page" => "Tarefas por página",
"20" => "20",
"30" => "30",
"40" => "40",
"50" => "50",
"Messages per page" => "Mensagens por página",
"Allow messages from other users" => "Permitir mensagens de outros usuários",
// "Notify sender when reading mail" => "Notify sender when reading mail",
"Send me an email for messages with priority equal or greater than" => "Envie-me um email para mensagens com prioridade igual ou maior que",
// "Auto-archive read messages after" => "Auto-archive read messages after",
"60" => "60",
"My pages" => "Minhas páginas",
"My blogs" => "Meus Blogs",
"My galleries" => "Minhas galerias",
"My messages" => "Minhas mensagens",
"My tasks" => "Minhas tarefas",
"My forum topics" => "Meus tópicos nos fóruns",
"My forum replies" => "Minhas respostas nos fóruns",
"My items" => "Meus itens",
// "Character set for mail" => "Character set for mail",
"Show user's info on mouseover" => "Mouseover mostra informações do usuário",
// "Validator emails (separated by comma) if different than the sender email" => "Validator emails (separated by comma) if different than the sender email",
// "Display by default" => "Display by default",
// "Path (if stored in directory)" => "Path (if stored in directory)",
"Edit idle timeout" => "Tempo limite de espera para edição",
"15" => "15",
// "Log errors to Tiki log" => "Log errors to Tiki log",
// "Errors will be logged to the Tiki log" => "Errors will be logged to the Tiki log",
// "Tracker ID of Channel tracker" => "Tracker ID of Channel tracker",
// "There must be a tracker to store info of each channel you create" => "There must be a tracker to store info of each channel you create",
// "Field ID of BrandId" => "Field ID of BrandId",
// "The Channel tracker must have a text field for the Watershed BrandId" => "The Channel tracker must have a text field for the Watershed BrandId",
// "Field ID of ChannelCode" => "Field ID of ChannelCode",
// "The Channel tracker must have a text field for the Watershed ChannelCode" => "The Channel tracker must have a text field for the Watershed ChannelCode",
// "Tracker ID of Archive tracker" => "Tracker ID of Archive tracker",
// "There must be a tracker to store Archive info" => "There must be a tracker to store Archive info",
// "Field ID of videoId" => "Field ID of videoId",
// "The Archive tracker must have a text field for the videoId of each archive" => "The Archive tracker must have a text field for the videoId of each archive",
// "Field ID of BrandId for Archive" => "Field ID of BrandId for Archive",
// "The Archive tracker must have a text field for the BrandId of each archive" => "The Archive tracker must have a text field for the BrandId of each archive",
// "Field ID of ChannelCode for Archive" => "Field ID of ChannelCode for Archive",
// "The Archive tracker must have a text field for the ChannelCode of each archive" => "The Archive tracker must have a text field for the ChannelCode of each archive",
// "Field ID of rtmpURL for Archive (url field type)" => "Field ID of rtmpURL for Archive (url field type)",
// "The Archive tracker must have a url field for storing the RTMP URL to access the archive" => "The Archive tracker must have a url field for storing the RTMP URL to access the archive",
// "Field ID of flvURL for Archive (url field type)" => "Field ID of flvURL for Archive (url field type)",
// "The Archive tracker must have a url field for storing the FLV URL to access the archive" => "The Archive tracker must have a url field for storing the FLV URL to access the archive",
// "Field ID of Date string for Archive" => "Field ID of Date string for Archive",
// "The Archive tracker can have a text field for storing the time the recording completed" => "The Archive tracker can have a text field for storing the time the recording completed",
// "Field ID of Duration for Archive" => "Field ID of Duration for Archive",
// "The Archive tracker can have a text field for storing the duration of the recording" => "The Archive tracker can have a text field for storing the duration of the recording",
// "Field ID of Filesize for Archive" => "Field ID of Filesize for Archive",
// "The Archive tracker can have a text field for storing the filesize of the recording" => "The Archive tracker can have a text field for storing the filesize of the recording",
// "Field ID of Title for Archive" => "Field ID of Title for Archive",
// "The Archive tracker could have a text field for storing the title of the recording" => "The Archive tracker could have a text field for storing the title of the recording",
// "Field ID of Description for Archive (textarea field type)" => "Field ID of Description for Archive (textarea field type)",
// "The Archive tracker could have a textarea field for storing the description of the recording" => "The Archive tracker could have a textarea field for storing the description of the recording",
// "Field ID of Tags for Archive (freetags field type)" => "Field ID of Tags for Archive (freetags field type)",
// "The Archive tracker could have a freetags field for storing the tags of the recording" => "The Archive tracker could have a freetags field for storing the tags of the recording",
// "Flash Media Encoder shared secret" => "Flash Media Encoder shared secret",
// "Shared key for authenticating Flash Media Encoder" => "Shared key for authenticating Flash Media Encoder",
"Allow viewing HTML mails?" => "Permitir visualização de mensagens HTML?",
"Maximum size for each attachment" => "Tamanho máximo para cada arquivo anexado",
"500Kb" => "500Kb",
"1Mb" => "1Mb",
"1.5Mb" => "1.5Mb",
"2Mb" => "2Mb",
"2.5Mb" => "2.5Mb",
"3Mb" => "3Mb",
"Unlimited" => "Ilimitado",
// "Include a flag by each e-mail to quickly flag/un-flag them" => "Include a flag by each e-mail to quickly flag/un-flag them",
"LastModif" => "Última modificação",
"Last editor" => "Último editor",
// "Wiki link format" => "Wiki link format",
// "What level of special characters are accepted as wiki links for page names. Ex.: ((Page &eacute;&agrave;&icirc;))" => "What level of special characters are accepted as wiki links for page names. Ex.: ((Page &eacute;&agrave;&icirc;))",
// "Strict will only be basic characters like a-z and 0-9. If you have accented or special characters in page names, you should not use strict" => "Strict will only be basic characters like a-z and 0-9. If you have accented or special characters in page names, you should not use strict",
"Complete" => "Completo",
// "Relaxed" => "Relaxed",
// "Strict" => "Strict",
// "Display page version" => "Display page version",
// "Display the page version information when viewing the page" => "Display the page version information when viewing the page",
// "Display page name above page" => "Display page name above page",
// "Display page name above page instead of inside page" => "Display page name above page instead of inside page",
// "Page name display stripper" => "Page name display stripper",
// "Character to use as a delimiter in the page name. The portion of the name after this character will not be displayed" => "Character to use as a delimiter in the page name. The portion of the name after this character will not be displayed",
// "Wiki author list style" => "Wiki author list style",
// "Changes the list format used to display the authors of the page" => "Changes the list format used to display the authors of the page",
"Creator & Author" => "Criador & autor",
"Business style" => "Estilo de negócios",
"Collaborative style" => "Estilo colaborativo",
"Page last modified on" => "Última modificação em",
"none (disabled)" => "nenhum (desativado)",
// "Specify wiki author list style per page" => "Specify wiki author list style per page",
// "Allows to modify the style in which the author list is displayed on a per-page basis" => "Allows to modify the style in which the author list is displayed on a per-page basis",
// "Wiki action bar location" => "Wiki action bar location",
// "Buttons: Save, Preview, Cancel, .." => "Buttons: Save, Preview, Cancel, ..",
"Both" => "Ambos",
// "Wiki navigation bar location" => "Wiki navigation bar location",
// "When using the ...page... page break wiki syntax" => "When using the ...page... page break wiki syntax",
// "Wiki top line location" => "Wiki top line location",
"Cache wiki pages (global)" => "Armazenamento de páginas wiki (global)",
// "Enable page cache globally for wiki pages" => "Enable page cache globally for wiki pages",
"no cache" => "sem cache",
"minute" => "minuto",
// "Allow comments per wiki page" => "Allow comments per wiki page",
// "Enable control for comments on wiki pages individually" => "Enable control for comments on wiki pages individually",
// "Enable (default On)" => "Enable (default On)",
// "Enable (default Off)" => "Enable (default Off)",
// "Enable edit plugin icons" => "Enable edit plugin icons",
// "Permits editing of a plugin, via a popup form, without needing to edit the whole page" => "Permits editing of a plugin, via a popup form, without needing to edit the whole page",
// "Requires JavaScript" => "Requires JavaScript",
// "Prevent special characters in page names" => "Prevent special characters in page names",
// "Some characters may prevent the pages from being easily accessible from the URL or through wiki links. This option prevents from creating pages with such characters" => "Some characters may prevent the pages from being easily accessible from the URL or through wiki links. This option prevents from creating pages with such characters",
// "Page ranking reload probability" => "Page ranking reload probability",
// "Calculation of page rankings is an expensive task that cannot be performed at every page load. It will be calculated at random page loads based on a dice roll. This option indicates the amount of faces on the dice. Larger numbers lead to less load, but less accurate ranking" => "Calculation of page rankings is an expensive task that cannot be performed at every page load. It will be calculated at random page loads based on a dice roll. This option indicates the amount of faces on the dice. Larger numbers lead to less load, but less accurate ranking",
// "Encourage contribution to wiki pages by anonymous" => "Encourage contribution to wiki pages by anonymous",
// "When a page is not editable and the user is anonymous, display the edit links anyway. The visitor will be prompted with a login screen and be encouraged to register" => "When a page is not editable and the user is anonymous, display the edit links anyway. The visitor will be prompted with a login screen and be encouraged to register",
// "Warn before page lock timeout" => "Warn before page lock timeout",
// "Provide a JavaScript alert before the user's lock on a page times out" => "Provide a JavaScript alert before the user's lock on a page times out",
"Dynamic variables" => "Variáveis dinâmicas",
// "Global snippets of text that can be included in wiki pages and edited in place" => "Global snippets of text that can be included in wiki pages and edited in place",
// "Single (%varname%)" => "Single (%varname%)",
// "Double (%%varname%%)" => "Double (%%varname%%)",
// "Multilingual dynamic variables" => "Multilingual dynamic variables",
// "Make dynamic variable content language specific" => "Make dynamic variable content language specific",
// "Edit section" => "Edit section",
// "Edit section level" => "Edit section level",
// "Toggle display of section and plugin edit icons" => "Toggle display of section and plugin edit icons",
// "Allow minor edits" => "Allow minor edits",
// "Add a slideshow button on wiki pages" => "Add a slideshow button on wiki pages",
"Page creators are admin of their pages" => "Autores são admins de suas páginas",
"Create watch for author on page creation" => "Criar notificações para autor na criação da página",
"Enable watches on comments" => "Habilitar notificações em comentários",
"Enable watch events when I am the editor" => "Habilitar notificações de eventos quando eu for o editor",
"Watch minor edits" => "Acompanhar edições menores (minor edits)",
// "Page ID" => "Page ID",
// "Name length" => "Name length",
"Last modified by" => "Última modificação por",
// "Edit comments" => "Edit comments",
// "Edit Comment length" => "Edit Comment length",
"Versions" => "Versões",
"Categories" => "Categorias",
// "Categories path" => "Categories path",
"Default sort order" => "Ordem de listagem padrão",
// "Sort Direction" => "Sort Direction",
"Descending" => "Descendente",
"Ascending" => "Ascendente",
"Enable wiki 3D browser" => "Habilitar navegador wiki 3D",
// "Load page on navigation" => "Load page on navigation",
// "Forum for discussion" => "Forum for discussion",
// "Allow to manage keywords on a per-page basis" => "Allow to manage keywords on a per-page basis",
// "Similar pages only listed in same language" => "Similar pages only listed in same language",
// "When listing similar pages, such as in missing page 404, only display pages in the same language as the request" => "When listing similar pages, such as in missing page 404, only display pages in the same language as the request",
// "Mandatory edit summary on wiki pages" => "Mandatory edit summary on wiki pages",
// "Reject save attempts not providing an edit summary to describe the changes made" => "Reject save attempts not providing an edit summary to describe the changes made",
// "Choose position of freetags selection" => "Choose position of freetags selection",
// "If you wish to place freetags selection more prominently than in the properties tab" => "If you wish to place freetags selection more prominently than in the properties tab",
// "Properties tab" => "Properties tab",
// "Edit tab" => "Edit tab",
// "Freetags tab" => "Freetags tab",
// "Structure navigation bar location" => "Structure navigation bar location",
// "Displays Next/Back buttons, breadcrumbs, and form to add a new page" => "Displays Next/Back buttons, breadcrumbs, and form to add a new page",
// "Maximum length (characters) to display/truncate for backlink page names. Use \"0\" for no truncation" => "Maximum length (characters) to display/truncate for backlink page names. Use \"0\" for no truncation",
// "Simple wiki ratings" => "Simple wiki ratings",
// "Enable users to rate articles based on a simple numeric scale" => "Enable users to rate articles based on a simple numeric scale",
// "Wiki rating options" => "Wiki rating options",
// "List of options available for the rating of wiki pages" => "List of options available for the rating of wiki pages",
// "Semantic link types to use as page alias markers" => "Semantic link types to use as page alias markers",
// "Comma separated list of semantic links to use to identify a page as an alias to another" => "Comma separated list of semantic links to use to identify a page as an alias to another",
// "Redirect pages using these prefix alias semantic links" => "Redirect pages using these prefix alias semantic links",
// "Comma separated list of prefixes of which pages will be redirected to page with semantic link" => "Comma separated list of prefixes of which pages will be redirected to page with semantic link",
// "Plugin %0" => "Plugin %0",
// "Global cache time for the plugin snarf in seconds" => "Global cache time for the plugin snarf in seconds",
// "Default cache time for the plugin snarf" => "Default cache time for the plugin snarf",
// "0 for no cache" => "0 for no cache",
// "Inline plugin %0" => "Inline plugin %0",
// "Plugin pending approval notification" => "Plugin pending approval notification",
// "Alert by e-mail users with permission to approve plugin when a plugin is pending approval" => "Alert by e-mail users with permission to approve plugin when a plugin is pending approval",
// "Wysiwyg Editor is optional" => "Wysiwyg Editor is optional",
// "Wysiwyg Editor is displayed by default" => "Wysiwyg Editor is displayed by default",
// "Reopen with the same editor" => "Reopen with the same editor",
// "Content is parsed like wiki page" => "Content is parsed like wiki page",
// "This allows a mixture of wiki and HTML. All wiki syntax is parsed" => "This allows a mixture of wiki and HTML. All wiki syntax is parsed",
// "Content is partially wiki parsed" => "Content is partially wiki parsed",
// "This also allows a mixture of wiki and HTML. Only some wiki syntax is parsed, such as plugins (not inline character styles etc)" => "This also allows a mixture of wiki and HTML. Only some wiki syntax is parsed, such as plugins (not inline character styles etc)",
// "Neglected. This feature can have unpredicable results and may be removed in future versions" => "Neglected. This feature can have unpredicable results and may be removed in future versions",
// "Wysiwyg editor skin" => "Wysiwyg editor skin",
// "Kama (Default)" => "Kama (Default)",
// "Office 2003" => "Office 2003",
// "V2 (FCKEditor appearance)" => "V2 (FCKEditor appearance)",
// "Use Wiki syntax in WYSIWYG" => "Use Wiki syntax in WYSIWYG",
// "Experimental, new : Allow to keep the wiki syntax with the WYSIWYG editor. WARNING: plugin edit is not working in that case in WYSIWYG mode, use the Source mode instead " => "Experimental, new : Allow to keep the wiki syntax with the WYSIWYG editor. WARNING: plugin edit is not working in that case in WYSIWYG mode, use the Source mode instead ",
// "Font names" => "Font names",
// "List of font names separated by" => "List of font names separated by",
// "SMTP Server" => "SMTP Server",
"Username" => "Usuário",
"Security" => "Segurança",
// "SSL" => "SSL",
// "TLS" => "TLS",
// "Mail Sender" => "Mail Sender",
// "Sendmail" => "Sendmail",
// "SMTP" => "SMTP",
// "Authentication" => "Authentication",
// "Mail server authentication" => "Mail server authentication",
// "LOGIN" => "LOGIN",
// "PLAIN" => "PLAIN",
// "CRAM-MD5" => "CRAM-MD5",
// "Zotero Bibliography" => "Zotero Bibliography",
// "Connect Tiki to the Zotero online bibliography management system" => "Connect Tiki to the Zotero online bibliography management system",
// "Zotero Client Key" => "Zotero Client Key",
// "Required identification key. Registration required" => "Required identification key. Registration required",
// "Zotero Client Secret" => "Zotero Client Secret",
// "Zotero Group ID" => "Zotero Group ID",
// "Numeric ID of the group, can be found in the URL" => "Numeric ID of the group, can be found in the URL",
// "Zotero Reference Style" => "Zotero Reference Style",
// "Use an alternate Zotero reference style when formatting the references. The reference formats must be installed on the Zotero server" => "Use an alternate Zotero reference style when formatting the references. The reference formats must be installed on the Zotero server",
// "Unmatched system requirement. Missing php extension among %0" => "Unmatched system requirement. Missing php extension among %0",
// "Unmatched system requirement. The database you are using does not support this feature" => "Unmatched system requirement. The database you are using does not support this feature",
// "Missing default for preference \"%0\"" => "Missing default for preference \"%0\"",
// "Configuration forced by host" => "Configuration forced by host",
// "Disabled by host" => "Disabled by host",
"Actions" => "Ações",
"Admin" => "Administrar",
"Permissions" => "Permissões",
"View" => "Ver",
"Module" => "Módulo",
"Plugin" => "Plugin",
// "Like" => "Like",
// "Fix me" => "Fix me",
// "Unavailable" => "Unavailable",
// "Don't like" => "Don't like",
// "Don't fix me" => "Don't fix me",
// "What's this for" => "What's this for",
// "Nothing was changed, please check profile for errors" => "Nothing was changed, please check profile for errors",
// "An error occurred: " => "An error occurred: ",
// "Applying profile" => "Applying profile",
// "Preference set" => "Preference set",
// "Added (or modified)" => "Added (or modified)",
// "Group changed (or modified)" => "Group changed (or modified)",
// "Modified permission %s for %s" => "Modified permission %s for %s",
// "Modified permission %s on %s/%s for %s" => "Modified permission %s on %s/%s for %s",
// "User %0 was added to %1" => "User %0 was added to %1",
// "Created by profile installer" => "Created by profile installer",
// "Page updated by profile installer" => "Page updated by profile installer",
// "File gallery does not exist" => "File gallery does not exist",
// "File gallery already exists" => "File gallery already exists",
// "Calendar does not exist" => "Calendar does not exist",
// "Calendar already exists" => "Calendar already exists",
"Page cannot be found" => "A página não foi encontrada",
// "Syntax error: " => "Syntax error: ",
// "Circular reference" => "Circular reference",
// "No name" => "No name",
// "Bad object" => "Bad object",
// "Permissions' object must have a field 'type' and 'id'" => "Permissions' object must have a field 'type' and 'id'",
// "Needs a 'type' and 'data' field" => "Needs a 'type' and 'data' field",
"Wiki top pages" => "Páginas Wiki mais populares",
"Most relevant pages" => "Páginas mais relevantes",
"Relevance" => "Relevância",
"Wiki last pages" => "Páginas Wiki recentes",
"Forums last posts" => "Últimas inserções nos fóruns",
"Topic date" => "Data do tópico",
"Forums most read topics" => "Tópicos mais lidos nos fóruns",
"Forums best topics" => "Melhores tópicos nos fóruns",
"Forums most visited forums" => "Fóruns mais visitados",
"Forums with most posts" => "Fóruns com mais mensagens",
"Wiki top galleries" => "Galerias Wiki mais populares",
"Wiki top file galleries" => "Galerias de arquivos mais populares",
"Wiki top images" => "Imagens mais populares",
"Wiki top files" => "Arquivos mais populares",
"Downloads" => "Downloads",
"Wiki last images" => "Imagens mais recentes",
"Upload date" => "Data de carga",
"Wiki last files" => "Arquivos recentes",
"Top Articles" => "Artigos mais lidos",
"Most visited blogs" => "Blogs mais visitados",
"Most-active Blogs" => "Blogs mais ativos",
"Blogs last posts" => "Últimas mensagens em blogs",
"Post date" => "Data de envio",
"Wiki top authors" => "Autores de Wiki mais produtivos",
"Pages" => "Páginas",
"Top article authors" => "Autores de artigos mais produtivos",
// "Expecting three arguments for article-info" => "Expecting three arguments for article-info",
// "Unsupported property. Supported properties are: " => "Unsupported property. Supported properties are: ",
// "Articles feature not enabled" => "Articles feature not enabled",
// "Unexpected values: %0" => "Unexpected values: %0",
// "Object must be provided and contain two arguments: type and object" => "Object must be provided and contain two arguments: type and object",
// "Invalid property" => "Invalid property",
// "Invalid range" => "Invalid range",
// "Invalid revote period" => "Invalid revote period",
// "Expecting \"keep\" to be \"latest\" or \"oldest\"" => "Expecting \"keep\" to be \"latest\" or \"oldest\"",
// "Unknown variables referenced: %0" => "Unknown variables referenced: %0",
"Username is required" => "Nome do usuário é obrigatório",
"Password is required" => "A senha é obrigatória",
"User already exists" => "O usuário já existe",
"Registered" => "Registrado",
"Invalid username" => "Usuário inválido",
"Username is too long" => "Identificador de usuário muito longo",
"Username cannot contain uppercase letters" => "O nome do usuário não pode conter letras maiúsculas",
"Wrong passcode. You need to know the passcode to register at this site" => "Código de registro incorreto; você precisa fornecer um código válido para registrar-se neste site",
"You must choose a group" => "Você precisa escolher um grupo",
// "Email not valid. Should be in the format \"mailbox@example.com\"" => "Email not valid. Should be in the format \"mailbox@example.com\"",
"The passwords don't match" => "A senha não confere",
"Username must be at least %0 characters long" => "O nome do usuário deve ter pelo menos %0 letras",
"Username cannot contain more than %0 characters" => "O nome do usuário não pode ter mais de %0 letras",
// "This invitation does not exist or is deprecated or wrong email" => "This invitation does not exist or is deprecated or wrong email",
// "The fields title and description are mandatory to generate a feed" => "The fields title and description are mandatory to generate a feed",
// "To fix this error go to Admin -> Feeds" => "To fix this error go to Admin -> Feeds",
// "Please contact the site administrator and ask him to fix this error" => "Please contact the site administrator and ask him to fix this error",
// "If you set feed author email or URL, you must set feed author name" => "If you set feed author email or URL, you must set feed author name",
// "Feed logo" => "Feed logo",
"Unspecified" => "Não especificado",
"Log In" => "Entrar",
"See other users' profiles" => "Veja outro perfil de usuário",
"Have your profile seen" => "Mostre o seu perfil para outros",
"Make friends" => "Fazer amigos",
"Receive message" => "Receber mensagem",
"Send message" => "Enviar mensagem",
"Read an article" => "Ler um artigo",
"Publish an article" => "Publicar um artigo",
"Have your article read" => "Mostre seus artigos para outros",
"Create New File Gallery" => "Criar uma nova galeria de arquivos",
"Upload new file to gallery" => "Subir novo arquivo para a galeria",
"Download other user's file" => "Baixar outro arquivo do usuário",
"Have your file downloaded" => "Permita que outros baixem seus arquivos",
"Create a new image gallery" => "Criar nova galeria de imagem",
"Upload new image to gallery" => "Subir um novo arquivo para a galeria",
"See other users' galleries" => "Veja outra galeria do usuário",
"See other users' images" => "Veja outra imagem do usuário",
"Have your gallery seen by other users" => "Mostre sua galeria para outros usuários",
"Have your image seen" => "Mostre sua imagem para outros",
"Create new blog" => "Criar novo blog",
"Post in a blog" => "Postar no blog",
"Read other users' blogs" => "Ler o blog de outro usuário",
"Have your blog read" => "Mostre seu blog para outros",
"Create a new wiki page" => "Criar nova página wiki",
"Edit an existing page" => "Editar uma página existente",
"Attach file" => "Anexar um arquivo",
// "try rebuilding or optimizing the index on the search admin page" => "try rebuilding or optimizing the index on the search admin page",
// "Search index could not be updated: %0" => "Search index could not be updated: %0",
// "Wiki Comment" => "Wiki Comment",
// "Calendar item" => "Calendar item",
"Gallery" => "Galeria",
"Article" => "Artigo",
"Blog post" => "Mensagem de blog",
"Tracker item" => "Item do formulário",
// "Search index could not be updated. The site is misconfigured. Contact an administrator" => "Search index could not be updated. The site is misconfigured. Contact an administrator",
// "blog post" => "blog post",
// "file" => "file",
// "forum post" => "forum post",
// "trackeritem" => "trackeritem",
// "sheet" => "sheet",
"comment" => "comentário",
// " has accessed your temporary shared content" => " has accessed your temporary shared content",
// "has accessed the following shared content" => "has accessed the following shared content",
// "Your access to this page has expired" => "Your access to this page has expired",
// "Handling actions of plugin \"%s\" failed" => "Handling actions of plugin \"%s\" failed",
// "You must choose an option" => "You must choose an option",
"For you to vote, cookies must be allowed" => "Você precisa habilitar cookies no seu navegador para poder votar",
"This poll is closed." => "Esta enquete está fechada.",
"Thank you for installing Tiki" => "Obrigado por instalar o Tiki",
"The entire Tiki Community would like to thank you and help you get introduced to Tiki" => "A comunidade do software lhe dá as boas-vindas. Abaixo você encontra algumas informações básicas",
"How To Get Started" => "Como começar",
"Tiki has more than 1000 features and settings" => "O Tiki tem mais de 1000 recursos e configurações",
"This allows you to create both very simple and complex websites" => "Isso permite que você crie sites simples e complexos",
"We understand that so many features might seem overwhelming at first. This is why we offer you two different ways to __Get Started__ with Tiki" => "Um número tão grande de opções pode parecer confuso no começo. É por isso que oferecemos duas maneiras diferentes para você configurar o software",
"Manual Setup using Admin Panel" => "Configuração manual usando o painel de administração",
"Get Started using Admin Panel" => "Configure o Tiki usando o painel de administração",
"Who Should Use This" => "Quem deve usar essa opção",
"You are familiar with software Admin Panels" => "Você está acostumado com painéis de administração de outros softwares",
"You enjoy exploring and playing with many options" => "Você gosto de explorar e experimentar diferentes opções",
"You already know Tiki" => "Você já conhece o Tiki",
"Easy Setup using Profiles" => "Configure o Tiki de maneira fácil usando os Perfis",
// "Get Started using Profiles" => "Get Started using Profiles",
// "You want to get started quickly" => "You want to get started quickly",
// "Featured Profiles" => "Featured Profiles",
// "__Collaborative Community__ ([%0|apply profile now])" => "__Collaborative Community__ ([%0|apply profile now])",
// "Setup to help subject experts and enthusiasts work together to build a Knowledge Base" => "Setup to help subject experts and enthusiasts work together to build a Knowledge Base",
// "Wiki Editing" => "Wiki Editing",
// "Personal Member Spaces" => "Personal Member Spaces",
// "__Personal Blog and Profile__ ([%0|apply profile now])" => "__Personal Blog and Profile__ ([%0|apply profile now])",
// "Setup with many cool features to help you integrate the Social Web and establish a strong presence in the Blogosphere" => "Setup with many cool features to help you integrate the Social Web and establish a strong presence in the Blogosphere",
// "Blog (Full set of blog related features)" => "Blog (Full set of blog related features)",
// "RSS Integration" => "RSS Integration",
// "Video Log" => "Video Log",
// "__Company Intranet__ ([%0|apply profile now])" => "__Company Intranet__ ([%0|apply profile now])",
// "Setup for a Corporate Intranet of a typical medium-sized business" => "Setup for a Corporate Intranet of a typical medium-sized business",
// "Company News Articles" => "Company News Articles",
// "Executive Blog" => "Executive Blog",
// "File Repository & Management" => "File Repository & Management",
// "Collaborative Wiki" => "Collaborative Wiki",
// "__Small Organization Web Presence__ ([%0|apply profile now])" => "__Small Organization Web Presence__ ([%0|apply profile now])",
// "Setup for a Web Presence of a typical small business or non-profit" => "Setup for a Web Presence of a typical small business or non-profit",
// "Company News & Updates" => "Company News & Updates",
// "File Gallery (great for Media Kit)" => "File Gallery (great for Media Kit)",
// "Contact Form" => "Contact Form",
// "Congratulations" => "Congratulations",
// "This is the default homepage for your Tiki. If you are seeing this page, your installation was successful" => "This is the default homepage for your Tiki. If you are seeing this page, your installation was successful",
// "You can change this page after logging in. Please review the [http://doc.tiki.org/wiki+syntax|wiki syntax] for editing details" => "You can change this page after logging in. Please review the [http://doc.tiki.org/wiki+syntax|wiki syntax] for editing details",
// "{img src=img/icons/star.png alt=\\\"Star\\\"} Get started" => "{img src=img/icons/star.png alt=\\\"Star\\\"} Get started",
// "To begin configuring your site" => "To begin configuring your site",
// "1) Log in with your newly created password" => "1) Log in with your newly created password",
// "2) Manually Enable specific Tiki features" => "2) Manually Enable specific Tiki features",
// "3) Run Tiki Profiles to quickly get up and running" => "3) Run Tiki Profiles to quickly get up and running",
// "{img src=img/icons/help.png alt=\\\"Help\\\"} Need help" => "{img src=img/icons/help.png alt=\\\"Help\\\"} Need help",
// "For more information" => "For more information",
// "[http://info.tiki.org/Learn+More|Learn more about Tiki]" => "[http://info.tiki.org/Learn+More|Learn more about Tiki]",
// "[http://info.tiki.org/Help+Others|Get help], including the [http://doc.tiki.org|official documentation] and [http://tiki.org/forums|support forums]" => "[http://info.tiki.org/Help+Others|Get help], including the [http://doc.tiki.org|official documentation] and [http://tiki.org/forums|support forums]",
// "[http://info.tiki.org/Join+the+community|Join the Tiki community]" => "[http://info.tiki.org/Join+the+community|Join the Tiki community]",
// "You don't feel like learning the Admin Panel right away" => "You don't feel like learning the Admin Panel right away",
// "You want to quickly test out some of Tiki's Features" => "You want to quickly test out some of Tiki's Features",
// "Highlight Company's Products and Services" => "Highlight Company's Products and Services",
"new" => "novo",
// "Saved" => "Saved",
// "Save failed" => "Save failed",
// "Standard Shipping" => "Standard Shipping",
// "3 to 5 working days" => "3 to 5 working days",
// "Express Shipping" => "Express Shipping",
// "Next day delivery" => "Next day delivery",
// "Custom Shipping Example" => "Custom Shipping Example",
// "UPS_CODE_%0" => "UPS_CODE_%0",
// "Problem reading custom shipping provider \"%0\"" => "Problem reading custom shipping provider \"%0\"",
"Click for Help" => "Ajuda",
// "You are not in group of friends to have the content of this block displayed for you" => "You are not in group of friends to have the content of this block displayed for you",
// "<!-- jq smarty plugin inactive: feature_jquery off -->" => "<!-- jq smarty plugin inactive: feature_jquery off -->",
"No records to display" => "Nenhum registro",
// "Fast Next" => "Fast Next",
// "Fast Prev" => "Fast Prev",
"Prev" => "Ant",
"Next" => "Próx",
// "More results may be available. Refine criteria to access the estimated %0 results" => "More results may be available. Refine criteria to access the estimated %0 results",
// "First %0" => "First %0",
// "Last %0" => "Last %0",
// "Next %0" => "Next %0",
// "Prev %0" => "Prev %0",
"tip" => "dica",
"warning" => "atenção",
"confirm" => "confirmar",
"note" => "nota",
"errors" => "erros",
"information" => "informação",
"Tab View" => "Com abas",
"No Tabs" => "Sem abas",
"Tip" => "Dica",
"This edit session will expire in" => "Essa sessão de edição irá acabar em",
// "<strong>Preview</strong> (if available) or <strong>Save</strong> your work to restart the edit session timer" => "<strong>Preview</strong> (if available) or <strong>Save</strong> your work to restart the edit session timer",
"There is an autosaved draft of your recent edits, to use it instead of what is current displayed" => "Existe uma versão desta página salva automaticamente, para usá-la ao invés da versão exibida atualmente",
"If you want the original version instead of the autosaved draft of your edits" => "Se quiser usar a versão original ao invés da versão salva automaticamente",
"click here" => "clique aqui",
"AutoSave" => "Salvamento automático",
// "<strong>Thank you for trying the new ckeditor implementation for Tiki 6</strong><br /><br />" => "<strong>Thank you for trying the new ckeditor implementation for Tiki 6</strong><br /><br />",
// "Some of the settings at this site should be set differently for this to work best. Please ask the administrator to try this" => "Some of the settings at this site should be set differently for this to work best. Please ask the administrator to try this",
// "Ckeditor Development Notice" => "Ckeditor Development Notice",
// "Your edit session has expired" => "Your edit session has expired",
"Your edit session will expire in" => "Sua sessão de edição vai expirar em",
// "You must PREVIEW or SAVE your work now, to avoid losing your edits" => "You must PREVIEW or SAVE your work now, to avoid losing your edits",
// "You are about to leave this page. Changes since your last save will be lost. Are you sure you want to exit this page" => "You are about to leave this page. Changes since your last save will be lost. Are you sure you want to exit this page",
// "Some of your preferences should be set differently for this to work at it's best. Please click this to apply the recommended profile" => "Some of your preferences should be set differently for this to work at it's best. Please click this to apply the recommended profile",
"Help page:" => "Página de ajuda:",
// "View or edit tpl" => "View or edit tpl",
"Edit Template" => "Editar modelo",
"View tpl" => "Exibir tpl",
// "View Template" => "View Template",
"Admin page" => "Página de administração",
"Admin Feature" => "Administrar Recurso",
"Plugin name not specified" => "Nome do plugin não definido",
// "Wrong attachments gallery" => "Wrong attachments gallery",
// "You are attempting to display a gallery that is not a valid attachment gallery" => "You are attempting to display a gallery that is not a valid attachment gallery",
"Error(s)" => "Erro(s)",
"Clear errors" => "Limpar erros",
// "Favorite" => "Favorite",
"Hour" => "Hora",
"Minute" => "Minuto",
// "a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z" => "a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z",
"Click here to go to Edit Languages" => "Clique aqui para ir para a página Editar idiomas",
"The text is" => "O texto é",
"character(s) too long - please edit it." => "caracter(es) muito grandes - por favor edite-os.",
"Date Selector" => "Seletor de Data",
// "Month beginning" => "Month beginning",
// "Week beginning" => "Week beginning",
// "Data (change %)" => "Data (change %)",
"No records found." => "Nenhum registro encontrado.",
// "No object information provided" => "No object information provided",
// "No title specified" => "No title specified",
// "Relation not found" => "Relation not found",
// "freetags disabled" => "freetags disabled",
// "Currency in payment (%0) does not match the currency for that registry (%1)" => "Currency in payment (%0) does not match the currency for that registry (%1)",
// "This invoice does not exist or is in limited access" => "This invoice does not exist or is in limited access",
// " (found in " => " (found in ",
"(not found in an admin panel)" => "(não encontrado em um dos painéis de administração)",
// "Preference %0 is not defined" => "Preference %0 is not defined",
// "Drag this out of the perspective and resave it" => "Drag this out of the perspective and resave it",
// "No object information provided for rating" => "No object information provided for rating",
"An error occurred" => "Ocorreu um erro",
"Invert Sort" => "Inverter ordem",
"No rows found" => "Nenhuma entrada encontrada",
"Toggle sections" => "Selecionar tudo",
"Show only selected" => "Mostrar apenas o que estiver selecionado",
// "You might want to also set the tiki_p_modify_object_categories permission under the tiki section" => "You might want to also set the tiki_p_modify_object_categories permission under the tiki section",
"You are already logged in" => "Você já está logado",
// "Request not from this host" => "Request not from this host",
// "One of these groups is required" => "One of these groups is required",
// "This field is required" => "This field is required",
"Please enter a valid %s.  No spaces, more than %d characters and contain %s" => "Por favor digite um e-mail válido %s.  Sem espaçoes, com mais de %d caracteres e que contenha %s",
"username" => "usuário",
"password" => "senha",
"You have to enable cookies to be able to login to this site" => "Você deve habilitar os cookies para se autenticar neste site",
"second" => "segundo",
"years" => "anos",
"months" => "meses",
"weeks" => "semanas",
"done" => "pronto",
"Text cut here" => "Corte o texto aqui",
"Task" => "Tarefa",
"Priority" => "Prioridade",
"Start date:" => "Data inicial:",
"End date:" => "Data final:",
// "in %s days, the %s" => "in %s days, the %s",
// "in %s day, the %s" => "in %s day, the %s",
"Friend" => "Amigo",
"km" => "km",
"Last seen on" => "Visto pela última vez em",
"(idle for %s seconds)" => "(inativo por %s segundos)",
"User information - Click for more info" => "Informação do usuário - Clique para saber mais",
// "More info about %0 (idle for %1)" => "More info about %0 (idle for %1)",
" seconds" => " segundos",
// "Permission denied: the specified wiki page cannot be used as Smarty template resource" => "Permission denied: the specified wiki page cannot be used as Smarty template resource",
// "No WSDL found" => "No WSDL found",
"pvs" => "pvs",
// "Days with the most pageviews" => "Days with the most pageviews",
// "Day with the most pageviews" => "Day with the most pageviews",
// "Days with the least pageviews" => "Days with the least pageviews",
// "Day with the least pageviews" => "Day with the least pageviews",
// "No pageviews yet" => "No pageviews yet",
// "n/a" => "n/a",
"Use this tree to copy the structure" => "Use esta árvore para copiar a estrutura",
"created from structure" => "criar da estrutura",
// "You have to make %d choice(s) for the question" => "You have to make %d choice(s) for the question",
// "You have to make at least %d choice(s) for the question" => "You have to make at least %d choice(s) for the question",
// "You have to make less than %d choice(s) for the question" => "You have to make less than %d choice(s) for the question",
// "You have to choose at least %d choice(s) for the question" => "You have to choose at least %d choice(s) for the question",
// "Foreground Colors" => "Foreground Colors",
// "Background Colors" => "Background Colors",
"Colors" => "Cores",
// "Border Colors" => "Border Colors",
// "Border Widths" => "Border Widths",
// "Border Styles" => "Border Styles",
// "Border Radii" => "Border Radii",
"Borders" => "Bordas",
// "Font Sizes" => "Font Sizes",
// "Line Heights" => "Line Heights",
"Font" => "Fonte",
// "Font Families" => "Font Families",
// "Typography" => "Typography",
// "Select.." => "Select..",
"Required features: <b>%0</b>. If you do not have the privileges to activate these features, ask the site administrator" => "Recursos necessários: <b>%0</b>. Se você não tem permissão para habilitá-los, entre em contato com um administrador do site",
"Sea Surfing (CSRF) detected. Operation blocked." => "Detectado um Sea Surfing (CSRF). Operação bloqueada.",
"unknown error" => "erro desconhecido",
"You are not logged in" => "Você não está logado(a)",
"This script cannot be called directly" => "Este script não pode ser chamado diretamente",
"Page '%0' cannot be found" => "Não foi possível encontrar a página '%0'",
"You do not have permission to view this section" => "Permissão negada: você não pode ver esta seção",
// "For the security of your password direct access to the feed is only available via https" => "For the security of your password direct access to the feed is only available via https",
// "Help link" => "Help link",
"You are banned from" => "Você foi banido(a) de",
"wiki" => "wiki",
// "img-g" => "img-g",
// "file-g" => "file-g",
"faqs" => "faqs",
"quizzes" => "testes",
// "arts" => "arts",
"blogs" => "blogs",
"forums" => "fóruns",
"The file was uploaded with success" => "O arquivo foi enviado com sucesso",
"The file you are trying upload was only partially uploaded" => "O arquivo foi apenas parcialmente enviado",
"No file was uploaded. Was a file selected " => "Nenhum arquivo enviado. Você selecionou um arquivo ",
// "A temporary folder is missing" => "A temporary folder is missing",
"Unknown error" => "Erro desconhecido",
"Flash player not available" => "Flash não disponível",
"%d points" => "%d pontos",
"Removed" => "Removido",
"at" => "em",
// "Plugin %0 pending approval" => "Plugin %0 pending approval",
"Unknown language" => "Idioma desconhecido",
"Click here to confirm your action" => "Clique aqui para confirmar sua ação",
"Bold" => "Negrito",
// "img/icons/text_bold.png" => "img/icons/text_bold.png",
"Italic" => "Itálico",
// "img/icons/text_italic.png" => "img/icons/text_italic.png",
"Underline" => "Sublinhado",
// "img/icons/text_underline.png" => "img/icons/text_underline.png",
"Strikethrough" => "Tachado",
// "img/icons/text_strikethrough.png" => "img/icons/text_strikethrough.png",
"Non-parsed (Wiki syntax does not apply)" => "Ignorar sintaxe wiki",
// "img/icons/noparse.png" => "img/icons/noparse.png",
"Align Center" => "Centralizar",
// "img/icons/text_align_center.png" => "img/icons/text_align_center.png",
"Horizontal Bar" => "Barra horizontal",
// "img/icons/page.png" => "img/icons/page.png",
"Page Break" => "Quebra de página",
// "img/icons/page_break.png" => "img/icons/page_break.png",
"Box" => "Caixa",
// "img/icons/box.png" => "img/icons/box.png",
// "img/icons/email.png" => "img/icons/email.png",
"Heading" => "Cabeçalho",
"Title bar" => "Barra de título",
// "img/icons/book.png" => "img/icons/book.png",
"Unordered List" => "Lista",
// "img/icons/text_list_bullets.png" => "img/icons/text_list_bullets.png",
"Ordered List" => "Lista numerada",
// "img/icons/text_list_numbers.png" => "img/icons/text_list_numbers.png",
"Special Characters" => "Caracteres especiais",
// "lib/ckeditor_tiki/ckeditor-icons/specialchar.gif" => "lib/ckeditor_tiki/ckeditor-icons/specialchar.gif",
// "img/smiles/icon_smile.gif" => "img/smiles/icon_smile.gif",
"Foreground color" => "Cor do texto",
// "img/icons/palette.png" => "img/icons/palette.png",
// "Background Color" => "Background Color",
// "img/icons/palette_bg.png" => "img/icons/palette_bg.png",
"Wiki Link" => "Link wiki",
// "img/icons/page_link.png" => "img/icons/page_link.png",
"External Link" => "Link externo",
// "img/icons/world_link.png" => "img/icons/world_link.png",
// "img/icons/table.png" => "img/icons/table.png",
"Table Builder" => "Construtor de tabela",
// "img/icons/find.png" => "img/icons/find.png",
"Find Text" => "Procurar",
// "img/icons/text_replace.png" => "img/icons/text_replace.png",
"Text Replace" => "Substituir texto",
"Full Screen Edit" => "Modo tela cheia",
"Wiki Help" => "Ajuda wiki",
// "Wiki Wysiwyg Help" => "Wiki Wysiwyg Help",
// "Wysiwyg Help" => "Wysiwyg Help",
"Choose or upload images" => "Selecionar ou enviar imagens",
// "img/icons/pictures.png" => "img/icons/pictures.png",
// "Choose or upload files" => "Choose or upload files",
// "img/icons/file-manager-add.png" => "img/icons/file-manager-add.png",
"Switch Editor (wiki or WYSIWYG)" => "Trocar editor (wiki ou WYSIWYG)",
// "img/icons/pencil_go.png" => "img/icons/pencil_go.png",
// "Save Sheet" => "Save Sheet",
// "img/icons/disk.png" => "img/icons/disk.png",
// "Add Row After Selection Or To End If No Selection" => "Add Row After Selection Or To End If No Selection",
// "img/icons/sheet_row_add.png" => "img/icons/sheet_row_add.png",
// "Add Multiple Rows After Selection Or To End If No Selection" => "Add Multiple Rows After Selection Or To End If No Selection",
// "img/icons/sheet_row_add_multi.png" => "img/icons/sheet_row_add_multi.png",
// "Add Row Before Selection Or To End If No Selection" => "Add Row Before Selection Or To End If No Selection",
// "Delete Selected Row" => "Delete Selected Row",
// "img/icons/sheet_row_delete.png" => "img/icons/sheet_row_delete.png",
// "Add Column After Selection Or To End If No Selection" => "Add Column After Selection Or To End If No Selection",
// "img/icons/sheet_col_add.png" => "img/icons/sheet_col_add.png",
// "Delete Selected Column" => "Delete Selected Column",
// "img/icons/sheet_col_delete.png" => "img/icons/sheet_col_delete.png",
// "Add Multiple Columns After Selection Or To End If No Selection" => "Add Multiple Columns After Selection Or To End If No Selection",
// "img/icons/sheet_col_add_multi.png" => "img/icons/sheet_col_add_multi.png",
// "Add Column Before Selection Or To End If No Selection" => "Add Column Before Selection Or To End If No Selection",
// "Get Cell Range" => "Get Cell Range",
// "img/icons/sheet_get_range.png" => "img/icons/sheet_get_range.png",
"Find" => "Buscar",
// "Refresh Calculations" => "Refresh Calculations",
// "img/icons/arrow_refresh.png" => "img/icons/arrow_refresh.png",
// "Finish Editing" => "Finish Editing",
// "img/icons/close.png" => "img/icons/close.png",
"Admin Toolbars" => "Adminstrar barra de ferramentas",
// "Reset Colors" => "Reset Colors",
"Reset" => "Reiniciar",
// "*** ERROR: Tracker ID not set ***" => "*** ERROR: Tracker ID not set ***",
// "*** ERROR: Field ID not set ***" => "*** ERROR: Field ID not set ***",
// "*** ERROR: Tracker %0 not found ***" => "*** ERROR: Tracker %0 not found ***",
// "*** ERROR: Field %0 not found ***" => "*** ERROR: Field %0 not found ***",
// "Problem inserting tracker item: trackerId=%0, created=%1, lastModif=%2, status=%3" => "Problem inserting tracker item: trackerId=%0, created=%1, lastModif=%2, status=%3",
// "Problem converting tracker item link field: trackerId=%0, fieldId=%1, itemId=%2" => "Problem converting tracker item link field: trackerId=%0, fieldId=%1, itemId=%2",
"Field is not numeric" => "Campo não é numérico",
// "Function" => "Function",
// "Tracker field setup error - display field not found: " => "Tracker field setup error - display field not found: ",
"Item Modification" => "Modificação de Item",
"Item creation" => "Criação de Item",
"Item" => "Item",
"Subject" => "Assunto",
// "Tracker was modified at %0 by %1" => "Tracker was modified at %0 by %1",
"View the tracker item at:" => "Visualizar item do formulário em:",
// "Tracker field not enabled: fieldId=%0 type=%1" => "Tracker field not enabled: fieldId=%0 type=%1",
"Message" => "Mensagem",
"No extra information for that attached file. " => "Sem informações extras para o arquivo anexado. ",
"(AT)" => "(ARROBA)",
"(DOT)" => "(PONTO)",
// "Can create/close a book" => "Can create/close a book",
// "Can create/edit/lock accounts" => "Can create/edit/lock accounts",
// "Create a new transaction" => "Create a new transaction",
// "Permission to view the journal" => "Permission to view the journal",
// "Can book into the stack where statements can be changed" => "Can book into the stack where statements can be changed",
// "Can import statements from external accounts" => "Can import statements from external accounts",
// "Can manage templates for recurring transactions" => "Can manage templates for recurring transactions",
"Can admin the articles" => "Pode administrar artigos",
// "Can approve submissions" => "Can approve submissions",
"Can admin article topics" => "Pode administrar os tópicos dos artigos",
"Can admin article types" => "Pode administrar os tipos dos artigos",
"Can read article headings" => "Pode ler o cabeçalho dos artigos",
"Submitted articles automatically approved" => "Artigos enviados são aprovados automaticamente",
"Can edit articles" => "Pode editar artigos",
// "Can edit submissions" => "Can edit submissions",
"Can read articles" => "Pode ler artigos",
"Can remove articles" => "Pode remover artigos",
// "Can remove submissions" => "Can remove submissions",
"Can submit articles" => "Pode enviar artigos para aprovação",
"Can rate articles" => "Pode avaliar artigos",
// "Can read a topic (Applies only to individual topic perms)" => "Can read a topic (Applies only to individual topic perms)",
// "Can view recordings from past meetings" => "Can view recordings from past meetings",
// "Can join a meeting" => "Can join a meeting",
// "Can moderate a meeting" => "Can moderate a meeting",
// "Can create a meeting" => "Can create a meeting",
"Can admin blogs" => "Pode administrar os blogs",
"Can assign perms to blog" => "Pode definir as permissões dos blogs",
"Can post to a blog" => "Pode postar em um blog",
"Can create a blog" => "Pode criar um blog",
"Can read blogs" => "Pode ler os blogs",
// "Can view in module and feed the blog posts" => "Can view in module and feed the blog posts",
// "Can view in module and feed the blog" => "Can view in module and feed the blog",
"Can create/admin calendars" => "Pode criar e administrar calendários",
"Can add events in the calendar" => "Pode adicionar eventos nos calendários",
"Can change events in the calendar" => "Pode alterar eventos nos calendários",
"Can browse the calendar" => "Pode ver os calendários",
"Can view events details" => "Pode ver os detalhes de um evento",
// "Can add own user to the participants" => "Can add own user to the participants",
// "Can add guest to the participants" => "Can add guest to the participants",
// "Can view Tiki tools calendar" => "Can view Tiki tools calendar",
"Can admin categories" => "Pode administrar as categorias",
// "Can see the category in a listing" => "Can see the category in a listing",
// "Can add objects to the category (needs tiki_p_modify_object_categories)" => "Can add objects to the category (needs tiki_p_modify_object_categories)",
// "Can remove objects from the category (needs tiki_p_modify_object_categories)" => "Can remove objects from the category (needs tiki_p_modify_object_categories)",
// "Can assign perms to category)" => "Can assign perms to category)",
// "Administrator can create channels, remove channels, etc" => "Administrator can create channels, remove channels, etc",
// "Can use the chat system" => "Can use the chat system",
// "Can admin received articles" => "Can admin received articles",
// "Can admin received pages" => "Can admin received pages",
// "Can send articles to other sites" => "Can send articles to other sites",
// "Can send articles to this site" => "Can send articles to this site",
// "Can send pages to this site" => "Can send pages to this site",
// "Can send pages to other sites" => "Can send pages to other sites",
"Can post new comments" => "Pode enviar novos comentários",
"Can read comments" => "Pode ler os comentários",
"Can admin comments" => "Pode administrar os comentários",
"Can edit all comments" => "Pode editar todos os comentários",
"Can delete comments" => "Pode deletar comentários",
"Can vote comments" => "Pode votar em comentários",
// "Can admin content templates" => "Can admin content templates",
// "Can edit content templates" => "Can edit content templates",
// "Can use content templates" => "Can use content templates",
// "Can admin contributions" => "Can admin contributions",
// "Can admin the directory" => "Can admin the directory",
// "Can admin directory categories" => "Can admin directory categories",
// "Can admin directory sites" => "Can admin directory sites",
// "Submitted links are valid" => "Submitted links are valid",
// "Can submit sites to the directory" => "Can submit sites to the directory",
// "Can validate submitted links" => "Can validate submitted links",
// "Can use the directory" => "Can use the directory",
// "Can execute arbitrary queries on a given DSN" => "Can execute arbitrary queries on a given DSN",
// "Can admin faqs" => "Can admin faqs",
// "Can suggest faq questions" => "Can suggest faq questions",
// "Can view faqs" => "Can view faqs",
"Can download files" => "Pode fazer o download de arquivos",
"Can upload files" => "Pode fazer o upload de arquivos",
"Can list file galleries" => "Pode listar as galerias de arquivos",
"Can view file galleries" => "Pode ver as galerias de arquivos",
"Can admin file galleries" => "Pode administrar galerias de arquivos",
// "Can assign perms to file gallery" => "Can assign perms to file gallery",
// "Can use Directory Batch Load" => "Can use Directory Batch Load",
"Can upload zip files with files" => "Pode fazer upload em lote através de arquivos zip",
"Can create file galleries" => "Pode criar uma galeria de arquivos",
"Can edit a gallery file" => "Pode editar o arquivo de uma galeria",
"Can remove files" => "Pode remover arquivos",
// "Can view file galleries explorer" => "Can view file galleries explorer",
// "Can view file galleries path" => "Can view file galleries path",
"Can admin forums" => "Pode administrar os fóruns",
// "Can attach to forum posts" => "Can attach to forum posts",
"Auto approve forum posts" => "Aprovar automaticamente mensagens no fórum",
// "Can edit own forum posts" => "Can edit own forum posts",
// "Can post in forums" => "Can post in forums",
// "Can start threads in forums" => "Can start threads in forums",
// "Can read forums" => "Can read forums",
// "Can report posts to moderator" => "Can report posts to moderator",
// "Can vote comments in forums" => "Can vote comments in forums",
// "Can browse freetags" => "Can browse freetags",
// "Can admin freetags" => "Can admin freetags",
// "Can tag objects" => "Can tag objects",
// "Can unassign tags from an object" => "Can unassign tags from an object",
// "Can subscribe to groups" => "Can subscribe to groups",
// "Can invite user to my groups" => "Can invite user to my groups",
// "Can view the group" => "Can view the group",
// "Can view the group members" => "Can view the group members",
// "Can add group members" => "Can add group members",
// "Can remove group members" => "Can remove group members",
// "Can join or leave the group" => "Can join or leave the group",
// "Can edit HTML pages" => "Can edit HTML pages",
// "Can view HTML pages" => "Can view HTML pages",
// "Can admin Image Galleries" => "Can admin Image Galleries",
// "Can assign perms to image gallery" => "Can assign perms to image gallery",
// "Can upload zip files with images" => "Can upload zip files with images",
// "Can create image galleries" => "Can create image galleries",
// "Can list image galleries" => "Can list image galleries",
// "Can upload images" => "Can upload images",
// "Can view image galleries" => "Can view image galleries",
// "Can admin Kaltura video feature" => "Can admin Kaltura video feature",
// "Can upload video or record from webcam" => "Can upload video or record from webcam",
// "Can edit media information" => "Can edit media information",
// "Can create kaltura remix video" => "Can create kaltura remix video",
// "Can delete media" => "Can delete media",
// "Can download media" => "Can download media",
// "Can list media" => "Can list media",
// "Can view media" => "Can view media",
// "Can create new mapfile" => "Can create new mapfile",
// "Can delete mapfiles" => "Can delete mapfiles",
// "Can edit mapfiles" => "Can edit mapfiles",
// "Can view mapfiles" => "Can view mapfiles",
// "Can view contents of mapfiles" => "Can view contents of mapfiles",
// "Can broadcast messages to all user" => "Can broadcast messages to all user",
// "Can broadcast messages to groups" => "Can broadcast messages to groups",
// "Can use the messaging system" => "Can use the messaging system",
// "Can admin newsletters" => "Can admin newsletters",
// "Can subscribe many e-mails at once (requires tiki_p_subscribe email)" => "Can subscribe many e-mails at once (requires tiki_p_subscribe email)",
// "Can send newsletters" => "Can send newsletters",
// "Can subscribe any email to newsletters" => "Can subscribe any email to newsletters",
// "Can subscribe to newsletters" => "Can subscribe to newsletters",
// "Can view the archive of a newsletters" => "Can view the archive of a newsletters",
// "Can list newsletters" => "Can list newsletters",
// "Can administer payments" => "Can administer payments",
// "Can view payment requests and details" => "Can view payment requests and details",
// "Can enter manual payments" => "Can enter manual payments",
// "Can request a payment" => "Can request a payment",
// "Can view the perspective" => "Can view the perspective",
// "Can edit the perspective" => "Can edit the perspective",
// "Can create a perspective" => "Can create a perspective",
// "Can admin perspectives" => "Can admin perspectives",
// "Can admin polls" => "Can admin polls",
// "Can view poll results" => "Can view poll results",
// "Can vote polls" => "Can vote polls",
// "Can view poll voters" => "Can view poll voters",
// "Can admin quizzes" => "Can admin quizzes",
// "Can take quizzes" => "Can take quizzes",
// "Can view quiz stats" => "Can view quiz stats",
// "Can view user quiz results" => "Can view user quiz results",
// "Can admin sheet" => "Can admin sheet",
// "Can create and edit sheets" => "Can create and edit sheets",
// "Can view sheet" => "Can view sheet",
// "Can view sheet history" => "Can view sheet history",
// "Can admin shoutbox (Edit/remove messages)" => "Can admin shoutbox (Edit/remove messages)",
// "Can post messages in shoutbox" => "Can post messages in shoutbox",
// "Can view shoutbox" => "Can view shoutbox",
// "user can use social network integration" => "user can use social network integration",
// "user can register this site with social networks" => "user can register this site with social networks",
// "Admin live support system" => "Admin live support system",
// "Can use live support system" => "Can use live support system",
// "Can admin surveys" => "Can admin surveys",
// "Can take surveys" => "Can take surveys",
// "Can view survey stats" => "Can view survey stats",
// "Can admin the TikiTests" => "Can admin the TikiTests",
// "Can edit TikiTests" => "Can edit TikiTests",
// "Can replay the TikiTests" => "Can replay the TikiTests",
// "Can admin trackers" => "Can admin trackers",
// "Can attach files to tracker items" => "Can attach files to tracker items",
// "Can view tracker items attachments and download" => "Can view tracker items attachments and download",
// "Can insert comments for tracker items" => "Can insert comments for tracker items",
// "Can view tracker items comments" => "Can view tracker items comments",
// "Can create new items for trackers" => "Can create new items for trackers",
// "Can list trackers" => "Can list trackers",
// "Can change tracker items" => "Can change tracker items",
// "Can change pending tracker items" => "Can change pending tracker items",
// "Can change closed tracker items" => "Can change closed tracker items",
// "Can remove tracker items" => "Can remove tracker items",
// "Can remove pending tracker items" => "Can remove pending tracker items",
// "Can remove closed tracker items" => "Can remove closed tracker items",
// "Can view rating result for tracker items" => "Can view rating result for tracker items",
// "Can vote a rating for tracker items" => "Can vote a rating for tracker items",
// "Can re-vote a rating for tracker items" => "Can re-vote a rating for tracker items",
// "Can view trackers" => "Can view trackers",
// "Can view closed trackers items" => "Can view closed trackers items",
// "Can view pending trackers items" => "Can view pending trackers items",
// "Can watch tracker" => "Can watch tracker",
// "Can export tracker items" => "Can export tracker items",
// "Can save a .CSV backup of entire trackers" => "Can save a .CSV backup of entire trackers",
// "Can trigger the transition between two states" => "Can trigger the transition between two states",
// "Can admin users" => "Can admin users",
// "Can cache user bookmarks" => "Can cache user bookmarks",
// "Can configure modules" => "Can configure modules",
// "Can create user bookmarks" => "Can create user bookmarks",
// "Can use the mini event calendar" => "Can use the mini event calendar",
// "Can use the notepad" => "Can use the notepad",
// "Can admin public tasks" => "Can admin public tasks",
// "Can use tasks" => "Can use tasks",
// "Can receive tasks from other users" => "Can receive tasks from other users",
// "Can send tasks to other users" => "Can send tasks to other users",
// "Can upload personal files" => "Can upload personal files",
// "Can create items in personal menu" => "Can create items in personal menu",
// "Can list registered users" => "Can list registered users",
// "Can invite users by email, and include them in groups" => "Can invite users by email, and include them in groups",
// "Can use webmail" => "Can use webmail",
// "Can use group webmail" => "Can use group webmail",
// "Can admin group webmail accounts" => "Can admin group webmail accounts",
// "Can use personal webmail accounts" => "Can use personal webmail accounts",
// "Can admin personal webmail accounts" => "Can admin personal webmail accounts",
// "Can view page/pages" => "Can view page/pages",
// "Can edit pages" => "Can edit pages",
// "Can view wiki history" => "Can view wiki history",
// "Can admin the wiki" => "Can admin the wiki",
// "Can assign perms to wiki pages" => "Can assign perms to wiki pages",
// "Can edit copyright notices" => "Can edit copyright notices",
// "Can edit dynamic variables" => "Can edit dynamic variables",
// "Can create and edit structures" => "Can create and edit structures",
// "Can export wiki pages using the export feature" => "Can export wiki pages using the export feature",
// "Can lock pages" => "Can lock pages",
// "Can save as minor edit" => "Can save as minor edit",
// "Can remove" => "Can remove",
// "Can rename pages" => "Can rename pages",
// "Can rollback pages" => "Can rollback pages",
// "Can upload pictures to wiki pages" => "Can upload pictures to wiki pages",
// "Can use the page as a tracker template" => "Can use the page as a tracker template",
// "Can view in module and feed the wiki pages reference" => "Can view in module and feed the wiki pages reference",
// "Can watch structure" => "Can watch structure",
// "Can admin attachments on wiki pages" => "Can admin attachments on wiki pages",
// "Can add and change ratings on wiki pages" => "Can add and change ratings on wiki pages",
// "Can attach files to wiki pages" => "Can attach files to wiki pages",
// "Can view wiki attachments and download" => "Can view wiki attachments and download",
// "Can view wiki comments" => "Can view wiki comments",
// "Can view rating of wiki pages" => "Can view rating of wiki pages",
// "Can view source of wiki pages" => "Can view source of wiki pages",
// "Can participate to rating of wiki pages" => "Can participate to rating of wiki pages",
// "Can view similar wiki pages" => "Can view similar wiki pages",
// "View page backlinks" => "View page backlinks",
// "Can view unapproved revisions of pages" => "Can view unapproved revisions of pages",
// "Can approve revisions of pages" => "Can approve revisions of pages",
// "Can view contributions to a page" => "Can view contributions to a page",
// "Administrator can manage users, groups and permissions and all features" => "Administrator can manage users, groups and permissions and all features",
// "Can access site when closed" => "Can access site when closed",
// "Administrator can admin banners" => "Administrator can admin banners",
// "Can ban users or ips" => "Can ban users or ips",
// "Can admin the dynamic content system" => "Can admin the dynamic content system",
// "Can admin integrator repositories and rules" => "Can admin integrator repositories and rules",
// "Can admin mail-in accounts" => "Can admin mail-in accounts",
// "Can edit object permissions" => "Can edit object permissions",
// "Can admin external feeds" => "Can admin external feeds",
// "Can clean cache" => "Can clean cache",
// "Can create new css suffixed with -user" => "Can create new css suffixed with -user",
// "Can remove association between two pages in a translation set" => "Can remove association between two pages in a translation set",
// "Can admin cookies" => "Can admin cookies",
// "Can edit translations and create new languages" => "Can edit translations and create new languages",
// "Can edit menu" => "Can edit menu",
// "Can edit menu option" => "Can edit menu option",
// "Can edit site templates" => "Can edit site templates",
// "Can search" => "Can search",
// "Can report a link to the webmaster" => "Can report a link to the webmaster",
// "Can send a link to a friend" => "Can send a link to a friend",
// "Can share a page (email, Twitter, Facebook, message, forums)" => "Can share a page (email, Twitter, Facebook, message, forums)",
// "Can use HTML in pages" => "Can use HTML in pages",
// "Can view action log" => "Can view action log",
// "Can view action log for users of his own groups" => "Can view action log for users of his own groups",
// "Can view integrated repositories" => "Can view integrated repositories",
// "Can view referrer stats" => "Can view referrer stats",
// "Can view site stats" => "Can view site stats",
// "Can view site templates" => "Can view site templates",
// "Can admin toolbars" => "Can admin toolbars",
// "Trust all user inputs including plugins (no security checks)" => "Trust all user inputs including plugins (no security checks)",
// "Can view unapproved plugin details" => "Can view unapproved plugin details",
// "Can execute unapproved plugin registered" => "Can execute unapproved plugin registered",
// "Can approve plugin execution" => "Can approve plugin execution",
// "Can admin mail notifications" => "Can admin mail notifications",
// "Can delete his/her own account" => "Can delete his/her own account",
// "Can use the importer" => "Can use the importer",
// "Can change the categories of the object" => "Can change the categories of the object",
// "User can administer modules" => "User can administer modules",
// "Can switch between wiki and WYSIWYG modes while editing" => "Can switch between wiki and WYSIWYG modes while editing",
// "User \"%0\" is banned from the group \"%1\"" => "User \"%0\" is banned from the group \"%1\"",
// "Do you want to unban them and continue" => "Do you want to unban them and continue",
"Password should be at least %0 characters long" => "A senha deve ter pelo menos %0 letras",
"Password must contain both letters and numbers" => "A senha deve ser composta de letras e algarismos",
"The administrator has not yet validated your account. Please wait." => "O administrador ainda não validou sua conta. Por favor aguarde.",
"You must validate your account first. An email has been sent to you" => "Primeiro você precisa validar sua conta. Um e-mail foi enviado para o endereço fornecido",
"The registration mail can't be sent. Contact the administrator" => "O e-mail para registro não pode ser enviado. Contate o administrador",
// "The registration mail can't be sent because there is no server email address set, and this feature is disabled" => "The registration mail can't be sent because there is no server email address set, and this feature is disabled",
"The user email confirmation can't be sent. Contact the administrator" => "O e-mail de confirmação do usuário não pode ser enviado. Por favor entre em contato com o administrador.",
// "Edit field: (Parameter needs to be 'trackerId=XX&fileId=YY' or be empty to use the current field)" => "Edit field: (Parameter needs to be 'trackerId=XX&fileId=YY' or be empty to use the current field)",
// "Edit field: (Incorrect validation parameter)" => "Edit field: (Incorrect validation parameter)",
"Page already exists" => "Página já existe",
// "Page does not exist" => "Page does not exist",
// "Invalid character combination for username" => "Invalid character combination for username",
"here" => "aqui",
// "Could not establish Kaltura session. Try again" => "Could not establish Kaltura session. Try again",
// "You need to set your Kaltura account details: " => "You need to set your Kaltura account details: ",
// "Cannot connect with web service" => "Cannot connect with web service",
// "No permission to broadcast to channel" => "No permission to broadcast to channel",
// "Broadcaster successfully authenticated" => "Broadcaster successfully authenticated",
// "No permission to broadcast to any channel" => "No permission to broadcast to any channel",
// "Successfully logged in mobile broadcaster" => "Successfully logged in mobile broadcaster",
// "No viewable channels available for mobile" => "No viewable channels available for mobile",
// "Failed to log in mobile broadcaster" => "Failed to log in mobile broadcaster",
// "Successfully logged in FME" => "Successfully logged in FME",
// "Failed to log in FME" => "Failed to log in FME",
// "No permission to view channel" => "No permission to view channel",
// "Viewer successfully authenticated" => "Viewer successfully authenticated",
// "No permission to view any channel" => "No permission to view any channel",
// "Successfully stored archive in tracker" => "Successfully stored archive in tracker",
// "Failed to stored archive in tracker" => "Failed to stored archive in tracker",
"Personal Phone" => "Telefone residencial",
"Personal Mobile" => "Celular (pessoal)",
"Personal Fax" => "Fax",
"Work Phone" => "Telefone do trabalho",
"Work Mobile" => "Celular (trabalho)",
"Work Fax" => "Fax (trabalho)",
"Company" => "Empresa",
"Organization" => "Organização",
"Department" => "Departamento",
"Division" => "Divisão",
"Job Title" => "Cargo",
"Street Address" => "Endereço",
"City" => "Cidade",
"State" => "Estado",
"Zip Code" => "CEP",
// "Mailbox uninitialised??" => "Mailbox uninitialised??",
"No subject" => "Sem assunto",
// "No mail body found" => "No mail body found",
// "Cannot create aliased page" => "Cannot create aliased page",
// "You attempted to create the following page" => "You attempted to create the following page",
// "That page is an alias for the following pages" => "That page is an alias for the following pages",
// "If you want to create the page, you must first edit each the pages above, and remove the alias link it may contain. This link should look something like this" => "If you want to create the page, you must first edit each the pages above, and remove the alias link it may contain. This link should look something like this",
// "Can't parse HTML data - no grammar file" => "Can't parse HTML data - no grammar file",
"Removed version \$version" => "Versão removida \$version",
"rollback version " => "reverter para versão ",
"Changed actual version to \$version" => "Versão atual alterada para versão \$version",
"No version indicated" => "Nenhuma versão indicada",
// "Plugin " => "Plugin ",
"failed" => "falhou",
// "Required parameters are in</em> <b>bold</b>" => "Required parameters are in</em> <b>bold</b>",
// "Parameter Info" => "Parameter Info",
// "There are no approved versions of this page" => "There are no approved versions of this page",
// "Semantic token already exists" => "Semantic token already exists",
// "Invalid semantic token name" => "Invalid semantic token name",
// "Semantic token not found" => "Semantic token not found",
"Page locked" => "Página travada",
"Page unlocked" => "Página destravada",
"Removed last version" => "Última versão removida",
// "Add Freetag" => "Add Freetag",
// "Add a single freetag to specified object" => "Add a single freetag to specified object",
"Object" => "Objeto",
// "Object type and id, as in type:id, if unset, will use current object" => "Object type and id, as in type:id, if unset, will use current object",
// "Add Relation" => "Add Relation",
// "Displays a simple button that toggles i.e. adds or removes a pre-specified relation" => "Displays a simple button that toggles i.e. adds or removes a pre-specified relation",
// "Qualifier" => "Qualifier",
// "Relation qualifier. Usually a three part string separated by 2 periods" => "Relation qualifier. Usually a three part string separated by 2 periods",
// "Source Object" => "Source Object",
// "Object identifier as type:itemId to start the relation from, will use the current object if left blank" => "Object identifier as type:itemId to start the relation from, will use the current object if left blank",
// "Target Object" => "Target Object",
// "Object identifier as type:itemId to end the relation to, will use the current object if left blank" => "Object identifier as type:itemId to end the relation to, will use the current object if left blank",
// "Button Text for Add" => "Button Text for Add",
// "Text to show on the button to add relation" => "Text to show on the button to add relation",
// "Button Text for Already Added State" => "Button Text for Already Added State",
// "Text to show on the button when relation is already added" => "Text to show on the button when relation is already added",
// "Relation Added" => "Relation Added",
// "Mouseover Button Text for Remove" => "Mouseover Button Text for Remove",
// "Text to show on the button to remove relation" => "Text to show on the button to remove relation",
// "Remove Relation" => "Remove Relation",
// "Button Id" => "Button Id",
// "A unique ID to distinguish the button from others on the page if there is more than one" => "A unique ID to distinguish the button from others on the page if there is more than one",
// "Source and target object cannot be the same" => "Source and target object cannot be the same",
// "Add to cart" => "Add to cart",
// "PluginAddToCart" => "PluginAddToCart",
// "Adds a product to the virtual cart. The cart can be manipulated using the cart module" => "Adds a product to the virtual cart. The cart can be manipulated using the cart module",
// "Product code" => "Product code",
// "Unique identifier for the product. Two products with the same code will be the same and the information used will be the one of the first in" => "Unique identifier for the product. Two products with the same code will be the same and the information used will be the one of the first in",
// "Label for the product in the cart" => "Label for the product in the cart",
// "Product Type" => "Product Type",
// "The product type that is being sold, which will affect fulfillment, e.g. standard product, gift certificate, event ticket" => "The product type that is being sold, which will affect fulfillment, e.g. standard product, gift certificate, event ticket",
// "Product Class" => "Product Class",
// "The class the product belongs to, can be used to limit how gift cards are used" => "The class the product belongs to, can be used to limit how gift cards are used",
// "Product Bundle" => "Product Bundle",
// "The bundle the product belongs to, can be used to limit how gift cards are used, will automatically add other products in same class to cart" => "The bundle the product belongs to, can be used to limit how gift cards are used, will automatically add other products in same class to cart",
// "Bundle Class" => "Bundle Class",
// "The class the bundle belongs to, can be used to limit how gift cards are used" => "The class the bundle belongs to, can be used to limit how gift cards are used",
// "Price" => "Price",
// "The price to charge for the item" => "The price to charge for the item",
// "URL of the product's information. The URL may be relative or absolute (begin with http://)" => "URL of the product's information. The URL may be relative or absolute (begin with http://)",
// "Button label" => "Button label",
// "Text for the submit button. default: \"Add to cart\"" => "Text for the submit button. default: \"Add to cart\"",
// "Associated event code" => "Associated event code",
// "Unique identifier for the event that is associated to the product" => "Unique identifier for the event that is associated to the product",
// "Automatically checkout" => "Automatically checkout",
// "Automatically checkout for purchase and send user to pay (this is disabled when there is already something in the cart)" => "Automatically checkout for purchase and send user to pay (this is disabled when there is already something in the cart)",
// "Buy on behalf of" => "Buy on behalf of",
// "Allows the selection of user to make purchase on behalf of" => "Allows the selection of user to make purchase on behalf of",
// "Shop as anonymous always" => "Shop as anonymous always",
// "Add to cart as anonymous shopper even if logged in" => "Add to cart as anonymous shopper even if logged in",
// "Forward to this URL after free purchase" => "Forward to this URL after free purchase",
// "Gift certificate" => "Gift certificate",
// "Allows user to add gift certificate from the product view" => "Allows user to add gift certificate from the product view",
// "Order Item ID to exchange product" => "Order Item ID to exchange product",
// "Used in conjunction with exchange feature" => "Used in conjunction with exchange feature",
// "Product ID to exchange to" => "Product ID to exchange to",
// "Amount of new product to exchange for" => "Amount of new product to exchange for",
// "Should normally be set to the amount of products in the order being exchanged" => "Should normally be set to the amount of products in the order being exchanged",
// "Ajax add to cart feature" => "Ajax add to cart feature",
// "Attempts to turn ajax for cart on" => "Attempts to turn ajax for cart on",
// "A session must be active to use the cart" => "A session must be active to use the cart",
// "Please enter your shopper information first" => "Please enter your shopper information first",
// "The order was recorded and is now awaiting payment. Reference number is %0" => "The order was recorded and is now awaiting payment. Reference number is %0",
// "Your free order of %0 (%1) has been processed. An email has been sent to you for your records" => "Your free order of %0 (%1) has been processed. An email has been sent to you for your records",
// "Your free order of %0 (%1) has been processed" => "Your free order of %0 (%1) has been processed",
// "%0 (%1) was added to your cart" => "%0 (%1) was added to your cart",
// "Invalid gift certificate: " => "Invalid gift certificate: ",
"Add to Google Calendar" => "Adicionar ao Google Calendar",
// "Add a calendar item to a Google calendar" => "Add a calendar item to a Google calendar",
// "Calendar item ID" => "Calendar item ID",
// "The item ID of the calendar to add to Google calendar" => "The item ID of the calendar to add to Google calendar",
// "A calendar item ID number" => "A calendar item ID number",
// "Icon Style" => "Icon Style",
// "Choose the icon style" => "Choose the icon style",
// "Either 1, 2 or 3" => "Either 1, 2 or 3",
// "One" => "One",
// "Two" => "Two",
// "Three" => "Three",
// "Adjust Inventory" => "Adjust Inventory",
// "PluginAdjustInventory" => "PluginAdjustInventory",
// "Modifies inventory of a product" => "Modifies inventory of a product",
// "Product ID" => "Product ID",
// "Product ID of item in the cart tracker" => "Product ID of item in the cart tracker",
// "Show add" => "Show add",
// "y|n" => "y|n",
// "Show subtract" => "Show subtract",
// "Inventory was adjusted by %0" => "Inventory was adjusted by %0",
// "User Agent Info" => "User Agent Info",
// "Show user's browser and server information" => "Show user's browser and server information",
"Info" => "Informações",
// "Display's the visitor's IP address (IP or default), browser information (BROWSER), or server software (SVRSW)" => "Display's the visitor's IP address (IP or default), browser information (BROWSER), or server software (SVRSW)",
// "IP address" => "IP address",
// "Server software" => "Server software",
// "Browser" => "Browser",
// "Anchor Link" => "Anchor Link",
// "Create a link to an anchor" => "Create a link to an anchor",
// "Anchor link label" => "Anchor link label",
// "Anchor Name" => "Anchor Name",
// "The anchor name as defined in the ANAME plugin" => "The anchor name as defined in the ANAME plugin",
// "The name of the wiki page containing the anchor. If empty, the anchor name will be searched for on the wiki page where the plugin is used" => "The name of the wiki page containing the anchor. If empty, the anchor name will be searched for on the wiki page where the plugin is used",
// "Create an anchor that can be linked to" => "Create an anchor that can be linked to",
// "The name of the anchor" => "The name of the anchor",
// "Image Annotation" => "Image Annotation",
// "Annotate an image" => "Annotate an image",
// "Autogenerated content. Leave blank initially" => "Autogenerated content. Leave blank initially",
// "Absolute URL to the image or relative path from tiki root" => "Absolute URL to the image or relative path from tiki root",
// "Image width in pixels" => "Image width in pixels",
// "Image height in pixels" => "Image height in pixels",
"Alignment" => "Alinhamento",
// "Image alignment. Possible values: left, right, center. Default is left" => "Image alignment. Possible values: left, right, center. Default is left",
"Center" => "Centralizar",
// "Save changes to annotations" => "Save changes to annotations",
// "Image annotations changed" => "Image annotations changed",
// "Application Frame" => "Application Frame",
// "Creates a frame to assemble custom applications in. Components in the frame will be various wiki pages and modules" => "Creates a frame to assemble custom applications in. Components in the frame will be various wiki pages and modules",
// "Application layout" => "Application layout",
// "Minimal height" => "Minimal height",
// "Prevent the frame from becoming any shorter than the specified size" => "Prevent the frame from becoming any shorter than the specified size",
// "Hide left column" => "Hide left column",
// "Hide the left column when the application frame is in use to provide more space to the application" => "Hide the left column when the application frame is in use to provide more space to the application",
// "Hide right column" => "Hide right column",
// "Hide the right column when the application frame is in use to provide more space to the application" => "Hide the right column when the application frame is in use to provide more space to the application",
// "Full page" => "Full page",
// "Occupy the complete content area of the page" => "Occupy the complete content area of the page",
// "Absolute Position" => "Absolute Position",
// "Position the app frame to use absolute position and really use all available space" => "Position the app frame to use absolute position and really use all available space",
// "When using absolute mode, leave some space for the header at the top" => "When using absolute mode, leave some space for the header at the top",
// "Template file not found: %0" => "Template file not found: %0",
// "Pan/Zoom" => "Pan/Zoom",
"Select" => "Selecionar",
// "Select/Modify" => "Select/Modify",
// "Draw Polygon" => "Draw Polygon",
// "Draw Path" => "Draw Path",
// "Reset Zoom" => "Reset Zoom",
// "Archive Builder" => "Archive Builder",
// "Build a zip archive that can be downloaded" => "Build a zip archive that can be downloaded",
// "Description of the archive content. Multiple handlers are available for content types. One per line. Ex: page-as-pdf:some-folder/foo.pdf:HomePage , tracker-attachments:target-folder/:3435" => "Description of the archive content. Multiple handlers are available for content types. One per line. Ex: page-as-pdf:some-folder/foo.pdf:HomePage , tracker-attachments:target-folder/:3435",
// "Archive Name" => "Archive Name",
// "Upon download, the name of the file that will be provided" => "Upon download, the name of the file that will be provided",
// "Missing extension zip" => "Missing extension zip",
// "Incorrect parameter" => "Incorrect parameter",
// "Download archive" => "Download archive",
"Display a field of an article" => "Exibe um campo de um artigo",
"The article field to display. Default field is Heading" => "O campo do artigo que deve ser exibido. O padrão é exibir o cabeçalho",
"Article ID" => "Id do artigo",
"The article to display. If no value is provided, most recent article will be used" => "O artigo que deve ser exibido. Se deixado em branco, o artigo mais recente será usado",
"Article List" => "Lista de artigos",
"Display multiple articles" => "Exibe múltilos artigos",
// "Use Pagination" => "Use Pagination",
// "Activate pagination when articles listing are long. Default is n" => "Activate pagination when articles listing are long. Default is n",
// "Maximum Displayed" => "Maximum Displayed",
// "The number of articles to display in the list (no max set by default)" => "The number of articles to display in the list (no max set by default)",
// "If Pagination is set to y (Yes), this will determine the amount of articles per page" => "If Pagination is set to y (Yes), this will determine the amount of articles per page",
// "Topic Name Filter" => "Topic Name Filter",
// "Filter the list of articles by topic. Example: " => "Filter the list of articles by topic. Example: ",
// "Topic ID Filter" => "Topic ID Filter",
// "Filter the list of articles by topic ID. Example: " => "Filter the list of articles by topic ID. Example: ",
// "Type Filter" => "Type Filter",
// "Filter the list of articles by types. Example: " => "Filter the list of articles by types. Example: ",
// "Category ID" => "Category ID",
// "The ID of the category that articles need to be in to be listed" => "The ID of the category that articles need to be in to be listed",
// "List only articles in this language" => "List only articles in this language",
// "Sort order" => "Sort order",
// "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")" => "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")",
// "Use random to have random items" => "Use random to have random items",
// "Specific order" => "Specific order",
// "List of ArticleId that must appear in this order if present" => "List of ArticleId that must appear in this order if present",
// "Only these articles" => "Only these articles",
// "List of ArticleId to display separated by |" => "List of ArticleId to display separated by |",
// "Not these articles" => "Not these articles",
// "List of ArticleId that can not be displayed separated by |" => "List of ArticleId that can not be displayed separated by |",
// "Quiet" => "Quiet",
// "Whether to not report when there are no articles (no reporting by default)" => "Whether to not report when there are no articles (no reporting by default)",
// "Title Only" => "Title Only",
// "Whether to only show the title of the articles (not set to title only by default)" => "Whether to only show the title of the articles (not set to title only by default)",
// "Body Only" => "Body Only",
// "Whether to only show the body of the articles or just the heading and title. (not set to body only by default)" => "Whether to only show the body of the articles or just the heading and title. (not set to body only by default)",
// "Starting Article" => "Starting Article",
// "The article number that the list should start with (starts with first article by default)" => "The article number that the list should start with (starts with first article by default)",
// "This will not work if Pagination is used" => "This will not work if Pagination is used",
// "Start Date" => "Start Date",
// "Earliest date to select articles from" => "Earliest date to select articles from",
// " (YYYY-MM-DD)" => " (YYYY-MM-DD)",
// "End date" => "End date",
// "Latest date to select articles from" => "Latest date to select articles from",
// "Period quantity" => "Period quantity",
// "Numeric value to display only last articles published within a user defined time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how many of those units are to be considered to define the time frame. If this parameter is set, \"Start Date\" and \"End date\" are ignored" => "Numeric value to display only last articles published within a user defined time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how many of those units are to be considered to define the time frame. If this parameter is set, \"Start Date\" and \"End date\" are ignored",
// "Period unit" => "Period unit",
// "Time unit used with \"Period quantity\"" => "Time unit used with \"Period quantity\"",
// "Override Dates" => "Override Dates",
// "Whether to obey article type's \"show before publish\" and \"show after expiry\" settings (not obeyed by default)" => "Whether to obey article type's \"show before publish\" and \"show after expiry\" settings (not obeyed by default)",
// "Container class" => "Container class",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")",
// "Large First Image" => "Large First Image",
// "If set to y (Yes), the first image will be displayed with the dimension used to view of the article" => "If set to y (Yes), the first image will be displayed with the dimension used to view of the article",
// "Additional URL Param to the link to read article" => "Additional URL Param to the link to read article",
// "Show actions (buttons and links)" => "Show actions (buttons and links)",
// "Whether to show the buttons and links to do actions on each article (for the actions you have permission to do" => "Whether to show the buttons and links to do actions on each article (for the actions you have permission to do",
// "No translation" => "No translation",
// "User or pipe separated list of two letter language codes for additional languages to display. List pages with no language or with a missing translation in one of the language" => "User or pipe separated list of two letter language codes for additional languages to display. List pages with no language or with a missing translation in one of the language",
"Displays an attachment or a list of them" => "Mostra um anexo ou uma lista deles",
// "File name of the attached file to link to. Either name, file, id or num can be used to identify a single attachment" => "File name of the attached file to link to. Either name, file, id or num can be used to identify a single attachment",
"File" => "Arquivo",
// "Same as name" => "Same as name",
// "Name of the wiki page the file is attached to. If left empty when the plugin is used on a wiki page, this defaults to that wiki page" => "Name of the wiki page the file is attached to. If left empty when the plugin is used on a wiki page, this defaults to that wiki page",
// "Show Description" => "Show Description",
// "Shows the description as the link text instead of the file name (not used by default)" => "Shows the description as the link text instead of the file name (not used by default)",
// "Bullets" => "Bullets",
// "Makes the list of attachments a bulleted list (not set by default)" => "Makes the list of attachments a bulleted list (not set by default)",
// "Indicates that this file is an image, and should be displayed inline using the img tag (not set by default)" => "Indicates that this file is an image, and should be displayed inline using the img tag (not set by default)",
// "Custom Label" => "Custom Label",
// "Makes the text between the {ATTACH} tags the link text instead of the file name or description. Only the first attachment will be listed" => "Makes the text between the {ATTACH} tags the link text instead of the file name or description. Only the first attachment will be listed",
// "Lists links to all attachments for the entire tiki site together with pages they are attached to when set to 1 (Yes)" => "Lists links to all attachments for the entire tiki site together with pages they are attached to when set to 1 (Yes)",
// "Order Number" => "Order Number",
// "Identifies the attachment to link to by the order of the attachment in the list of attachments to a page instead of by file name or ID. Either name, file, id or num can be used to identify a single attachment" => "Identifies the attachment to link to by the order of the attachment in the list of attachments to a page instead of by file name or ID. Either name, file, id or num can be used to identify a single attachment",
// "Identifies the attachment to link to by id number instead of by file name or order number. Either name, file, id or num can be used to identify a single attachment" => "Identifies the attachment to link to by id number instead of by file name or order number. Either name, file, id or num can be used to identify a single attachment",
// "The alt text that pops up on mouseover will include the number of downloads of the attachment at the end when set to 1 (Yes)" => "The alt text that pops up on mouseover will include the number of downloads of the attachment at the end when set to 1 (Yes)",
// "File Type Icon" => "File Type Icon",
"A file type icon is displayed in front of the attachment link when this is set to 1" => "Um ícone indicando o tipo do arquivo é exibido junto com o link para o anexo quando essa opção tem valor igual a 1",
// "Page \"%0\" does not exist" => "Page \"%0\" does not exist",
"No such attachment on this page" => "Nenhum anexo nessa página",
// "Attributes" => "Attributes",
// "Assign generic attributes to the current object" => "Assign generic attributes to the current object",
"View author contributions to a wiki page" => "Ver as contribuições de um autor para uma página wiki",
"text" => "texto",
// "User name of the user who wrote the text" => "User name of the user who wrote the text",
// "Deleted by User" => "Deleted by User",
// "User name of the user who deleted the text" => "User name of the user who deleted the text",
// "Make Visible" => "Make Visible",
// "Show popup with author/deleted by" => "Show popup with author/deleted by",
// "Generate a popup with names of author(s) (default: no)" => "Generate a popup with names of author(s) (default: no)",
// "deleted by" => "deleted by",
// "Should this author's contribution be visible (default: no)" => "Should this author's contribution be visible (default: no)",
"Avatar" => "Fotografia",
// "Display a user's avatar" => "Display a user's avatar",
// "The wiki page the avatar will link to. If empty and the user's information is public, \n\t\t\t\t\t\t\t\tthen the avatar will link automatically the that user's user information page" => "The wiki page the avatar will link to. If empty and the user's information is public, \n\t\t\t\t\t\t\t\tthen the avatar will link automatically the that user's user information page",
// "Float" => "Float",
// "Align the avatar on the page" => "Align the avatar on the page",
"Back" => "Voltar",
// "Displays a link that goes back one page in the browser history" => "Displays a link that goes back one page in the browser history",
// "Lists all pages that link to a particular page" => "Lists all pages that link to a particular page",
// "The page links will point to. Default value is the current page" => "The page links will point to. Default value is the current page",
// "Displayed Information" => "Displayed Information",
// "Pipe separated list of fields to display. ex: hits|user" => "Pipe separated list of fields to display. ex: hits|user",
// "Excluded pages" => "Excluded pages",
// "Pipe separated list of pages to be excluded from the listing. ex: HomePage|Sandbox" => "Pipe separated list of pages to be excluded from the listing. ex: HomePage|Sandbox",
// "Include Self" => "Include Self",
// "With or without self-link (default is without)" => "With or without self-link (default is without)",
// "With or without header (default is with header)" => "With or without header (default is with header)",
// "With header" => "With header",
// "Without header" => "Without header",
// "No pages link to" => "No pages link to",
"One page links to" => "Uma página com link para",
"pages link to" => "páginas com links para",
// "Banner" => "Banner",
"Add a banner" => "Adicionar um banner",
"Zone" => "Zona",
// "Name of the zone created in Admin > Banners" => "Name of the zone created in Admin > Banners",
// "Target" => "Target",
// "Determines the browser behavior once the banner is clicked" => "Determines the browser behavior once the banner is clicked",
// "missing parameter" => "missing parameter",
"BigBlueButton" => "BigBlueButton",
// "Starts a video/audio/chat/presentation session using BigBlueButton" => "Starts a video/audio/chat/presentation session using BigBlueButton",
// "Meeting" => "Meeting",
// "MeetingID for BigBlueButton. This is a 5 digit number, starting with a 7. Ex.: 77777 or 71111" => "MeetingID for BigBlueButton. This is a 5 digit number, starting with a 7. Ex.: 77777 or 71111",
// "Anonymous prefix" => "Anonymous prefix",
// "Unregistered users will get this token prepended to their name" => "Unregistered users will get this token prepended to their name",
// "Welcome Message" => "Welcome Message",
// "A message to be provided when someone enters the room" => "A message to be provided when someone enters the room",
// "Dial Number" => "Dial Number",
// "The phone-in support number to join from traditional phones" => "The phone-in support number to join from traditional phones",
// "Voice Bridge" => "Voice Bridge",
// "Code to enter for phone attendees to join the room. Typically, the same 5 digits of the MeetingID" => "Code to enter for phone attendees to join the room. Typically, the same 5 digits of the MeetingID",
// "Log-out URL" => "Log-out URL",
// "URL to which the user will be redirected when logging out from BigBlueButton" => "URL to which the user will be redirected when logging out from BigBlueButton",
// "Record meetings" => "Record meetings",
// "Requires BBB >= 0.8" => "Requires BBB >= 0.8",
// "Off" => "Off",
"On" => "Ligado",
// "BigBlueButton misconfigured or unaccessible" => "BigBlueButton misconfigured or unaccessible",
// "Bliptv" => "Bliptv",
// "Display a Blip.tv video" => "Display a Blip.tv video",
// "Blip.tv embed URL. Example: http://blip.tv/play/AYGd_GAC" => "Blip.tv embed URL. Example: http://blip.tv/play/AYGd_GAC",
// "Width in pixels (default is 425" => "Width in pixels (default is 425",
// "Height in pixels (default is 350)" => "Height in pixels (default is 350)",
// "Blog List" => "Blog List",
// "Display posts from a site blog" => "Display posts from a site blog",
// "Blog ID" => "Blog ID",
// "The ID number of the blog on the site you wish to list posts from" => "The ID number of the blog on the site you wish to list posts from",
// "Maximum Items" => "Maximum Items",
// "Maximum number of entries to list (no maximum set by default)" => "Maximum number of entries to list (no maximum set by default)",
// "Only display posts created by this user (all posts listed by default)" => "Only display posts created by this user (all posts listed by default)",
// "Simple List" => "Simple List",
// "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)" => "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)",
// "Earliest date to select posts from" => "Earliest date to select posts from",
// "End Date" => "End Date",
// "Latest date to select posts from" => "Latest date to select posts from",
// "Container Class" => "Container Class",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")",
// "Contains Html" => "Contains Html",
// "Body of the blog posts should be parsed as containing HTML (default=n)" => "Body of the blog posts should be parsed as containing HTML (default=n)",
"Creates a formatted box with a title bar" => "Cria uma caixa com uma barra de título",
"Box title" => "Título da caixa",
"Displayed above the content" => "Exibida acima do conteúdo",
"Background color" => "Cor de fundo",
// "As defined by CSS, name or Hex code" => "As defined by CSS, name or Hex code",
// "Box width" => "Box width",
// "In pixels or percentage. Default value is 100%" => "In pixels or percentage. Default value is 100%",
"Text Alignment" => "Alinhamento do texto",
// "Aligns the text within the box (left aligned by default)" => "Aligns the text within the box (left aligned by default)",
// "Float Position" => "Float Position",
// "Set the alignment for the entire box. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)" => "Set the alignment for the entire box. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)",
"Clear" => "Limpar",
// "Items are not allowed to wrap around the box if this parameter is set to.1 (Yes)" => "Items are not allowed to wrap around the box if this parameter is set to.1 (Yes)",
// "CSS Class" => "CSS Class",
// "Apply custom CSS class to the box" => "Apply custom CSS class to the box",
// "Button" => "Button",
// "Add a link formatted as a button" => "Add a link formatted as a button",
"Url" => "Endereço",
// "URL to be produced by the button. You can use wiki argument variables like {{itemId}} in it" => "URL to be produced by the button. You can use wiki argument variables like {{itemId}} in it",
// "CSS class for the button" => "CSS class for the button",
"Label" => "Rótulo",
// "Label for the button" => "Label for the button",
// "lib/smarty_tiki/function.button.php is missing or unreadable" => "lib/smarty_tiki/function.button.php is missing or unreadable",
// "Display a calendar and its events" => "Display a calendar and its events",
// "Calendar IDs" => "Calendar IDs",
// "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by commas (\",\")" => "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by commas (\",\")",
// "Example values" => "Example values",
// "Not set by default" => "Not set by default",
// "View Type" => "View Type",
// "Determines how to show events" => "Determines how to show events",
// "Possible values" => "Possible values",
// "\"table\" shows events in a calendar" => "\"table\" shows events in a calendar",
"List" => "Lista",
"Table" => "Tabela",
// "View Time Span" => "View Time Span",
// "If in calendar (or \"table\") view type, determines the time span displayed by the calendar" => "If in calendar (or \"table\") view type, determines the time span displayed by the calendar",
// "Default is month" => "Default is month",
// "Navigation Bar" => "Navigation Bar",
// "Decide or not to show the navigation bar (not shown by default)" => "Decide or not to show the navigation bar (not shown by default)",
// "Carousel" => "Carousel",
// "Display images in a self-advancing carousel" => "Display images in a self-advancing carousel",
// "File Gallery ID" => "File Gallery ID",
// "ID number of the file gallery that contains the images to be displayed" => "ID number of the file gallery that contains the images to be displayed",
"Sort Mode" => "Critério para ordenar a listagem",
"Sort by database table field name, ascending or descending. Examples: fileId_asc or name_desc" => "Ordena a listagem de acordo com o campo escolhido de maneira ascendente ou descendente",
// "Transition time" => "Transition time",
// "The time (in milliseconds) it will take to transition between two images" => "The time (in milliseconds) it will take to transition between two images",
// "number" => "number",
// "Display time" => "Display time",
// "The time (in milliseconds) to display each image" => "The time (in milliseconds) to display each image",
// "Caption height" => "Caption height",
// "The height of the caption. This is a fraction of the height of the images" => "The height of the caption. This is a fraction of the height of the images",
// "real between 0 and 1" => "real between 0 and 1",
// "Display progress ring" => "Display progress ring",
// "Display thumbnails" => "Display thumbnails",
// "Display thumbnails, number, count etc" => "Display thumbnails, number, count etc",
// "Buttons" => "Buttons",
// "Numbers" => "Numbers",
// "Thumbnail box width" => "Thumbnail box width",
// "Width of thumbnail box in CSS units (default \"20px\")" => "Width of thumbnail box in CSS units (default \"20px\")",
// "Thumbnail box height" => "Thumbnail box height",
// "Height of thumbnail box in CSS units (default \"20px\")" => "Height of thumbnail box in CSS units (default \"20px\")",
// "Start automatically" => "Start automatically",
// "Move the carousel automatically when the page loads (default Yes)" => "Move the carousel automatically when the page loads (default Yes)",
// "Legacy v2 param" => "Legacy v2 param",
// "Display place numbers in the thumbnail boxes" => "Display place numbers in the thumbnail boxes",
// "Use corresponding image as background for a thumbnail box" => "Use corresponding image as background for a thumbnail box",
// "Thumbnail box font size" => "Thumbnail box font size",
// "Font size of thumbnail box in CSS units (default \".7em\")" => "Font size of thumbnail box in CSS units (default \".7em\")",
// "Size of picture" => "Size of picture",
// "In case your picture is too large, you can specify a scale between 0 and 1 to reduce it" => "In case your picture is too large, you can specify a scale between 0 and 1 to reduce it",
// "Cart Missing User Info" => "Cart Missing User Info",
// "PluginCartMissingUserInfo" => "PluginCartMissingUserInfo",
// "Check if user still has missing info to enter" => "Check if user still has missing info to enter",
// "Type of Information" => "Type of Information",
// "Post Purchase" => "Post Purchase",
// "Required before purchase" => "Required before purchase",
// "Product Class ID" => "Product Class ID",
// "Missing parameters" => "Missing parameters",
"List categories and objects assigned to them" => "Lista categorias e seus objetos",
"Category IDs" => "Ids das categorias",
// "List of category IDs separated by + signs. ex: 1+2+3. Default will use category of the current page" => "List of category IDs separated by + signs. ex: 1+2+3. Default will use category of the current page",
"Types" => "Tipos",
// "List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal<br />+forum+igal+newsletter<br />+event+poll+quiz+survey<br />+tracker+wiki+img" => "List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal<br />+forum+igal+newsletter<br />+event+poll+quiz+survey<br />+tracker+wiki+img",
// "Sort ascending or descending based on various attributes (sorted ascending by name by default)" => "Sort ascending or descending based on various attributes (sorted ascending by name by default)",
"Created Ascending" => "Data de criação ascendente",
"Created Descending" => "Data de criação descendente",
"Hits Ascending" => "Visitas ascendente",
"Hits Descending" => "Visitas descendente",
"Item ID Ascending" => "Id do item ascendente",
"Item ID Descending" => "Id do item descendente",
"Name Ascending" => "Nome ascendente",
"Name Descending" => "Nome descendente",
"Type Ascending" => "Tipo ascendente",
"Type Descending" => "Tipo descendente",
"Random" => "Aleatório",
// "Split" => "Split",
// "Whether multiple categories will be listed on different lines (default is to split them)" => "Whether multiple categories will be listed on different lines (default is to split them)",
// "And" => "And",
// "If set to y (Yes), only objects in all of the categories will be shown (default is to show objects in any of the categories)" => "If set to y (Yes), only objects in all of the categories will be shown (default is to show objects in any of the categories)",
// "With Sub-categories" => "With Sub-categories",
// "Also list objects in sub-categories of the categories given (default is to list sub-category objects)" => "Also list objects in sub-categories of the categories given (default is to list sub-category objects)",
// "Show descriptions (not shown by default)" => "Show descriptions (not shown by default)",
// "Show Name" => "Show Name",
// "Show object names (shown by default)" => "Show object names (shown by default)",
// "Show type" => "Show type",
// "Show type (shown by default)" => "Show type (shown by default)",
// "One Per Line" => "One Per Line",
// "Show one object per line (multiple per line shown by default)" => "Show one object per line (multiple per line shown by default)",
// "Show Child Links" => "Show Child Links",
// "Show children category links (shown by default)" => "Show children category links (shown by default)",
// "Show Top Link" => "Show Top Link",
// "Show top category link (shown by default)" => "Show top category link (shown by default)",
// "Max Records" => "Max Records",
// "Maximum number of objects to list (default is 50)" => "Maximum number of objects to list (default is 50)",
// "Show Title" => "Show Title",
// "Show title text above category object lists (shown by default)" => "Show title text above category object lists (shown by default)",
// "List only objects in this language" => "List only objects in this language",
// "Only apply if type=wiki" => "Only apply if type=wiki",
"Categories are disabled" => "Categorias estão desabilitadas",
// "PluginCategoryTransition" => "PluginCategoryTransition",
// "Displays controls to trigger category transitions for any object" => "Displays controls to trigger category transitions for any object",
// "Object Type" => "Object Type",
// "Object ID" => "Object ID",
// "Redirect URL" => "Redirect URL",
// "URL the user is sent to after transition is done" => "URL the user is sent to after transition is done",
"Category Orphans" => "Objetos sem categoria",
"List objects that are not categorized" => "Lista objetos que não possuem uma categoria",
// "Currently, only works with wiki pages (set to wiki (Wiki Pages) by default)" => "Currently, only works with wiki pages (set to wiki (Wiki Pages) by default)",
// "Max" => "Max",
// "Maximum number of items. Use -1 for unlimited. Default is the site admin setting for maximum records" => "Maximum number of items. Use -1 for unlimited. Default is the site admin setting for maximum records",
// "Result Offset" => "Result Offset",
// "Result number at which the listing should start (default is no offset)" => "Result number at which the listing should start (default is no offset)",
// "Show the full category path for a wiki page" => "Show the full category path for a wiki page",
// "Separator" => "Separator",
// "String used to separate the categories in the path. Default character is >" => "String used to separate the categories in the path. Default character is >",
// "Display Top Category" => "Display Top Category",
// "Show the top category as part of the path name (not shown by default)" => "Show the top category as part of the path name (not shown by default)",
// "General purpose cclite utility plugin" => "General purpose cclite utility plugin",
// "Mode of operation - summary or recent. Default: summary" => "Mode of operation - summary or recent. Default: summary",
// "Account summary" => "Account summary",
// "Recent transactions" => "Recent transactions",
// "Registry" => "Registry",
// "Registry to query. Default: site preference (or first in list when more than one)" => "Registry to query. Default: site preference (or first in list when more than one)",
// "You need to be logged in to view this information" => "You need to be logged in to view this information",
"Center text" => "Centralizar texto",
"Chart" => "Gráfico",
// "Display a chart from TikiSheet" => "Display a chart from TikiSheet",
// "Chart caption" => "Chart caption",
// "Sheet ID" => "Sheet ID",
// "Data sheet ID" => "Data sheet ID",
// "Chart Type" => "Chart Type",
// "Chart Width" => "Chart Width",
"Width in pixels" => "Largura em pixels",
// "Chart Height" => "Chart Height",
"Height in pixels" => "Altura em pixels",
// "Value series" => "Value series",
// "Required for pie charts" => "Required for pie charts",
// "Independant series" => "Independant series",
// "Required for types other than pie chart" => "Required for types other than pie chart",
// "Dependant series" => "Dependant series",
// "List of colors to use" => "List of colors to use",
"Styles" => "Estilos",
// "List of styles to use" => "List of styles to use",
// "Labels for the series or values in the legend" => "Labels for the series or values in the legend",
// "Chart as PDF" => "Chart as PDF",
// "Chart as PostScript" => "Chart as PostScript",
"Code" => "Código",
"Display code syntax with line numbers and color highlights" => "Exibe código com número das linhas e destaque de sintaxe",
// "Code to be displayed" => "Code to be displayed",
"Caption" => "Legenda",
// "Code snippet label" => "Code snippet label",
// "Word Wrap" => "Word Wrap",
// "Enable word wrapping on the code to avoid breaking the layout" => "Enable word wrapping on the code to avoid breaking the layout",
// "Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus.." => "Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus..",
// "Line Numbers" => "Line Numbers",
// "Show line numbers for each line of code. May not be used with colors unless GeSHI is installed" => "Show line numbers for each line of code. May not be used with colors unless GeSHI is installed",
// "Right to Left" => "Right to Left",
// "Switch the text display from left to right to right to left  (left to right by default)" => "Switch the text display from left to right to right to left  (left to right by default)",
// "Code Tag" => "Code Tag",
// "Encloses the code in an HTML code tag, for example: &lt;code&gt;user input&lt;code&gt" => "Encloses the code in an HTML code tag, for example: &lt;code&gt;user input&lt;code&gt",
// "Colorbox" => "Colorbox",
// "Display a gallery of images in a popup slideshow" => "Display a gallery of images in a popup slideshow",
// "Image Gallery ID" => "Image Gallery ID",
// "ID number of the image gallery that contains the images to be displayed" => "ID number of the image gallery that contains the images to be displayed",
// "File ID Filter" => "File ID Filter",
// "Filter on fileIds in a file gallery to only show those images. Separate each fileId with ':'" => "Filter on fileIds in a file gallery to only show those images. Separate each fileId with ':'",
// "Thumb" => "Thumb",
// "Display as a thumbnail (y) or full size (n)" => "Display as a thumbnail (y) or full size (n)",
// "Show File Title" => "Show File Title",
// "Show file title" => "Show file title",
// "Show File Name" => "Show File Name",
// "Show file name" => "Show file name",
// "Show All Thumbs" => "Show All Thumbs",
// "Show thumbnails of all the images in the gallery" => "Show thumbnails of all the images in the gallery",
// "Parse Descriptions" => "Parse Descriptions",
// "Parse the file descriptions as wiki syntax" => "Parse the file descriptions as wiki syntax",
"Display a comment area for any specified object" => "Exibe uma área de comentários para qualquer objeto especificado",
// "The current wiki page you have added the plugin to" => "The current wiki page you have added the plugin to",
"Dynamic Content" => "Conteúdo dinâmico",
// "Display content from dynamic content repository" => "Display content from dynamic content repository",
// "Content ID" => "Content ID",
// "Dynamic content ID. The value can be obtained in the listing" => "Dynamic content ID. The value can be obtained in the listing",
// "Content Label" => "Content Label",
// "Label of the dynamic content to display" => "Label of the dynamic content to display",
// "Contributions Dashboard" => "Contributions Dashboard",
// "List users contributions to your work" => "List users contributions to your work",
// "Notice" => "Notice",
// "Default Beginning Date" => "Default Beginning Date",
// "Default Ending Date" => "Default Ending Date",
// "Dashboard Types" => "Dashboard Types",
// "The type of charts that will be rendered seperated by comma" => "The type of charts that will be rendered seperated by comma",
// "Date Range" => "Date Range",
"Update" => "Atualizar",
// "Convene" => "Convene",
// "Convene an event with schedule and members" => "Convene an event with schedule and members",
// "Convene data generated from user input" => "Convene data generated from user input",
// "Title of Event" => "Title of Event",
// "Calendar ID" => "Calendar ID",
// "ID number for the site calendar where to store the date for the events with maximum votes" => "ID number for the site calendar where to store the date for the events with maximum votes",
// "Minimum Number of votes to show Add-to-Calendar icon" => "Minimum Number of votes to show Add-to-Calendar icon",
// "Minimum Number of votes needed to show Add-to-Calendar icon, so that new users do not see a potentially confusing icon before the convene has enough information on it" => "Minimum Number of votes needed to show Add-to-Calendar icon, so that new users do not see a potentially confusing icon before the convene has enough information on it",
// "Date and time format" => "Date and time format",
// "Display date and time in short or long format, according to the site wide setting" => "Display date and time in short or long format, according to the site wide setting",
// "Short" => "Short",
// "Long" => "Long",
// "Not ok" => "Not ok",
// "Unconfirmed" => "Unconfirmed",
// "Add User" => "Add User",
// "Add Date" => "Add Date",
// "Delete Date" => "Delete Date",
// "Edit User/Save changes" => "Edit User/Save changes",
// "Delete User" => "Delete User",
// "Selected Date" => "Selected Date",
// "Add as Calendar Event" => "Add as Calendar Event",
// "Add User & Date" => "Add User & Date",
// "Login to edit Convene" => "Login to edit Convene",
"Add" => "Adicionar",
"Cookie" => "Cookie",
// "Display a rotating set of taglines or quotes (also known as fortune cookies)" => "Display a rotating set of taglines or quotes (also known as fortune cookies)",
"Insert copyright notices" => "Inserir informações de copyright",
// "Pattern to display the copyright in. May contain ~title~, ~year~ and ~authors~" => "Pattern to display the copyright in. May contain ~title~, ~year~ and ~authors~",
// "Countdown" => "Countdown",
// "Display a countdown to a specified date" => "Display a countdown to a specified date",
// "Text to append to the countdown" => "Text to append to the countdown",
// "Target date and time. Multiple formats accepted" => "Target date and time. Multiple formats accepted",
// "Items to Show" => "Items to Show",
// "Select: y=years, o=months, d=days, h=hours, m=minutes, s=seconds. \n\t\t\t\t\t\t\t\tEnter multiple values as: yodhms. Must be in the order of descending length, and a time unit should not be skipped. \n\t\t\t\t\t\t\t\tIf blank, the time is shown down to the hour if not zero" => "Select: y=years, o=months, d=days, h=hours, m=minutes, s=seconds. \n\t\t\t\t\t\t\t\tEnter multiple values as: yodhms. Must be in the order of descending length, and a time unit should not be skipped. \n\t\t\t\t\t\t\t\tIf blank, the time is shown down to the hour if not zero",
// "Years" => "Years",
// "Years, Months" => "Years, Months",
// "Years, Months, Days" => "Years, Months, Days",
// "Years, Months, Days, Hours" => "Years, Months, Days, Hours",
// "Years, Months, Days, Hours, Minutes" => "Years, Months, Days, Hours, Minutes",
// "Years, Months, Days, Hours, Minutes & Seconds" => "Years, Months, Days, Hours, Minutes & Seconds",
// "Months" => "Months",
// "Months, Days" => "Months, Days",
// "Months, Days, Hours" => "Months, Days, Hours",
// "Months, Days, Hours, Minutes" => "Months, Days, Hours, Minutes",
// "Months, Days, Hours, Minutes & Seconds" => "Months, Days, Hours, Minutes & Seconds",
"Days" => "Dias",
// "Days & Hours" => "Days & Hours",
// "Days, Hours & Minutes" => "Days, Hours & Minutes",
// "Days, Hours, Minutes & Seconds" => "Days, Hours, Minutes & Seconds",
"Hours" => "Horas",
// "Hours & Minutes" => "Hours & Minutes",
// "Hours, Minutes & Seconds" => "Hours, Minutes & Seconds",
"Minutes" => "Minutos",
// "Minutes & Seconds" => "Minutes & Seconds",
// "Seconds" => "Seconds",
// "Calendar Days" => "Calendar Days",
// "Will use calendar day difference when set to Yes (y) and time units are not shown. \n\t\t\t\t\t\t\t\tResult is that tomorrow, for example, is always shown as a one day away even if less than 24 hours from now. No (n) is the default" => "Will use calendar day difference when set to Yes (y) and time units are not shown. \n\t\t\t\t\t\t\t\tResult is that tomorrow, for example, is always shown as a one day away even if less than 24 hours from now. No (n) is the default",
// "Handle Past Events" => "Handle Past Events",
// "If Yes (y), will display amount of time since the event (default). \n\t\t\t\t\t\t\t\tIf No (n) and if there is body text, will display \"is over\" or custom text set in text parameter after body text" => "If Yes (y), will display amount of time since the event (default). \n\t\t\t\t\t\t\t\tIf No (n) and if there is body text, will display \"is over\" or custom text set in text parameter after body text",
"Text" => "Texto",
// "Text that will show with the countdown and body text. \n\t\t\t\t\t\t\t\tSet to \"default\" or leave empty to show \"xxx days until/since [body text]\", except that if\n\t\t\t\t\t\t\t\t the since parameter is set to No (n), \"[body text] is over\" will show after the end date has passed.\n\t\t\t\t\t\t\t\tAlso, if no time is shown because of the time units being displayed (for example, only years are shown and it's\n\t\t\t\t\t\t\t\tless than a year before/after the end date) then \"[body text] will happen in less than a year/happened in the last year\" will show.\n\t\t\t\t\t\t\t\tOr set pipe-separated custom text as follows: before date|before date by less than shortest time unit shown|after date\n\t\t\t\t\t\t\t\t|after date by less than shortest time unit shown|after date and since set to No (n).\n\t\t\t\t\t\t\t\tSet to silent for no text" => "Text that will show with the countdown and body text. \n\t\t\t\t\t\t\t\tSet to \"default\" or leave empty to show \"xxx days until/since [body text]\", except that if\n\t\t\t\t\t\t\t\t the since parameter is set to No (n), \"[body text] is over\" will show after the end date has passed.\n\t\t\t\t\t\t\t\tAlso, if no time is shown because of the time units being displayed (for example, only years are shown and it's\n\t\t\t\t\t\t\t\tless than a year before/after the end date) then \"[body text] will happen in less than a year/happened in the last year\" will show.\n\t\t\t\t\t\t\t\tOr set pipe-separated custom text as follows: before date|before date by less than shortest time unit shown|after date\n\t\t\t\t\t\t\t\t|after date by less than shortest time unit shown|after date and since set to No (n).\n\t\t\t\t\t\t\t\tSet to silent for no text",
// "default, silent, custom: before event|after event|after event when time not shown" => "default, silent, custom: before event|after event|after event when time not shown",
// "Thousands Separator" => "Thousands Separator",
// "Set the thousands separator for results of 1,000 or more. \n\t\t\t\t\t\t\t\tChoices are comma (c), decimal (d), space (s), or leave blank for no separator" => "Set the thousands separator for results of 1,000 or more. \n\t\t\t\t\t\t\t\tChoices are comma (c), decimal (d), space (s), or leave blank for no separator",
// "Comma" => "Comma",
// "Period" => "Period",
// "Space" => "Space",
// "COUNTDOWN: Missing \"enddate\" parameter for plugin" => "COUNTDOWN: Missing \"enddate\" parameter for plugin",
"and" => "e",
// "will happen in less than a year" => "will happen in less than a year",
// "will happen in less than a month" => "will happen in less than a month",
// "will happen in less than a day" => "will happen in less than a day",
// "will happen in less than an hour" => "will happen in less than an hour",
// "will happen in less than a minute" => "will happen in less than a minute",
// "is happening this second" => "is happening this second",
// "happened in the last year" => "happened in the last year",
// "happened in the last month" => "happened in the last month",
// "happened in the last day" => "happened in the last day",
// "happened in the last hour" => "happened in the last hour",
// "happened in the last minute" => "happened in the last minute",
// "until" => "until",
"since" => "desde",
// "is over" => "is over",
// "Custom Search" => "Custom Search",
// "Custom Search Interface that displays results using the LIST plugin" => "Custom Search Interface that displays results using the LIST plugin",
// "LIST plugin configuration information" => "LIST plugin configuration information",
// "Template wiki page" => "Template wiki page",
// "Wiki page where search user interface template is found" => "Wiki page where search user interface template is found",
// "Alphanumeric Unique Identifier for search" => "Alphanumeric Unique Identifier for search",
// "A unique identifier to distinguish custom searches for storing of previous search criteria entered by users" => "A unique identifier to distinguish custom searches for storing of previous search criteria entered by users",
// "Autotrigger AJAX search on criteria change" => "Autotrigger AJAX search on criteria change",
// "Delay in milliseconds before automatically triggering search after change (0 disables)" => "Delay in milliseconds before automatically triggering search after change (0 disables)",
// "Div to fade when AJAX search in progress" => "Div to fade when AJAX search in progress",
// "The specific ID of the specific div to fade out when AJAX search is in progress, if not set will attempt to fade the whole area or if failing simply show the spinner" => "The specific ID of the specific div to fade out when AJAX search is in progress, if not set will attempt to fade the whole area or if failing simply show the spinner",
// "Return users to same search parameters on coming back to the search page after leaving" => "Return users to same search parameters on coming back to the search page after leaving",
// "In the same session, return users to same search parameters on coming back to the search page after leaving" => "In the same session, return users to same search parameters on coming back to the search page after leaving",
// "Custom JavaScript wiki page" => "Custom JavaScript wiki page",
// "The wiki page on which custom JavaScript that is to be executed on return of AJAX results" => "The wiki page on which custom JavaScript that is to be executed on return of AJAX results",
// "Destination Div" => "Destination Div",
// "Id of a pre-existing div to contain the search results" => "Id of a pre-existing div to contain the search results",
// "Search On Load" => "Search On Load",
// "Execute the search when the page loads (default: Yes)" => "Execute the search when the page loads (default: Yes)",
// "Template is not specified" => "Template is not specified",
// "Template page not found" => "Template page not found",
// "Searching.." => "Searching..",
// "_group is needed to be set if _style is checkbox or radio" => "_group is needed to be set if _style is checkbox or radio",
// "Data Channel" => "Data Channel",
// "Display a form to access data channels" => "Display a form to access data channels",
// "List of fields to display. One field per line. Comma delimited: fieldname,label" => "List of fields to display. One field per line. Comma delimited: fieldname,label",
// "To use values from other forms on the same page as parameters for the data-channel use \"fieldname, external=fieldid\"" => "To use values from other forms on the same page as parameters for the data-channel use \"fieldname, external=fieldid\"",
// "Where \"fieldid\" is the id (important) of the external input to use, and \"fieldname\" is the name of the parameter in the data-channel" => "Where \"fieldid\" is the id (important) of the external input to use, and \"fieldname\" is the name of the parameter in the data-channel",
// "To use fixed hidden preset values use \"fieldname, hidden=value.\"" => "To use fixed hidden preset values use \"fieldname, hidden=value.\"",
// "Channel Name" => "Channel Name",
// "Name of the channel as registered by the administrator" => "Name of the channel as registered by the administrator",
// "Return URL" => "Return URL",
// "URL to go to after data channel has run. Defaults to current page" => "URL to go to after data channel has run. Defaults to current page",
// "Do not use returnURI but instead return true quietly" => "Do not use returnURI but instead return true quietly",
// "If set to y, will return quietly after data channel has run which would be needed if plugin is used in non-wiki page context" => "If set to y, will return quietly after data channel has run which would be needed if plugin is used in non-wiki page context",
// "Button Label" => "Button Label",
// "Label for the submit button. Default: \"Go\"" => "Label for the submit button. Default: \"Go\"",
// "CSS class for this form" => "CSS class for this form",
// "Empty Caches" => "Empty Caches",
// "Which caches to empty. Default \"Clear all Tiki caches\"" => "Which caches to empty. Default \"Clear all Tiki caches\"",
"Clear all Tiki caches" => "Limpar todos os caches do Tiki",
// "All user prefs sessions" => "All user prefs sessions",
// "Price to execute the datachannel (%0)" => "Price to execute the datachannel (%0)",
// "Payment Label" => "Payment Label",
// "Debug" => "Debug",
// "Be careful, if debug is on, the page will not be refreshed and previous modules can be obsolete (not on by default)" => "Be careful, if debug is on, the page will not be refreshed and previous modules can be obsolete (not on by default)",
// "Multiple Values" => "Multiple Values",
// "Accept arrays of multiple values in the POST. e.g. itemId[]=42&itemId=43 etc. (multiple values not accepted by default)" => "Accept arrays of multiple values in the POST. e.g. itemId[]=42&itemId=43 etc. (multiple values not accepted by default)",
// "Datachannel" => "Datachannel",
// "DB Report" => "DB Report",
// "Query a database and display results (only works with ADOdb, does not work with PDO)" => "Query a database and display results (only works with ADOdb, does not work with PDO)",
// "report definition" => "report definition",
// "Full DSN" => "Full DSN",
// "A full DSN (Data Source Name) connection string. eg: mysql://user:pass@server/database" => "A full DSN (Data Source Name) connection string. eg: mysql://user:pass@server/database",
// "Wiki DSN Name" => "Wiki DSN Name",
// "The name of a DSN connection defined by the Wiki administrator" => "The name of a DSN connection defined by the Wiki administrator",
"Wiki Syntax" => "Sintaxe wiki",
// "Parse wiki syntax within the report (not parsed by default)" => "Parse wiki syntax within the report (not parsed by default)",
// "Display the parsed report definition (not displayed by default)" => "Display the parsed report definition (not displayed by default)",
// "Missing db or dsn parameter" => "Missing db or dsn parameter",
// "No DSN connection string found" => "No DSN connection string found",
// "Run a database report" => "Run a database report",
// "Dialog" => "Dialog",
// "Create a jQuery-UI dialog" => "Create a jQuery-UI dialog",
// "Button labels separated by commas" => "Button labels separated by commas",
// "Button actions" => "Button actions",
// "JS to perform on 1st button click" => "JS to perform on 1st button click",
// "Dialog width" => "Dialog width",
// "HTML ID" => "HTML ID",
// "Automatically generated if left empty in the form \"wpdialog_XX\" (must be unique per page)" => "Automatically generated if left empty in the form \"wpdialog_XX\" (must be unique per page)",
// "Show animation" => "Show animation",
// "Hide animation" => "Hide animation",
// "Auto open" => "Auto open",
// "y/n" => "y/n",
// "Modal" => "Modal",
// "Wiki page to use as dialog body" => "Wiki page to use as dialog body",
// "Open Action" => "Open Action",
// "JS to execute when dialog opens" => "JS to execute when dialog opens",
// "Div" => "Div",
// "Define and format sections of a page or text" => "Define and format sections of a page or text",
// "Indicate the type of HTML tag to use (default is div)" => "Indicate the type of HTML tag to use (default is div)",
// "Span" => "Span",
"Pre" => "Ant",
// "Teletype" => "Teletype",
// "Paragraph" => "Paragraph",
// "Block quote" => "Block quote",
// "In pixels or percentage. Default is original size" => "In pixels or percentage. Default is original size",
// "Aligns the text within the element" => "Aligns the text within the element",
// "Justify" => "Justify",
// "Set the alignment for the entire element. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)" => "Set the alignment for the entire element. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)",
// "Items are not allowed to wrap around the side(s) this parameter is set to" => "Items are not allowed to wrap around the side(s) this parameter is set to",
// "Apply custom CSS class to the div" => "Apply custom CSS class to the div",
// "Sets the div's id attribute, as defined by HTML" => "Sets the div's id attribute, as defined by HTML",
// "Title attribute" => "Title attribute",
// "Title for the div, usually displayed as a tooltip" => "Title for the div, usually displayed as a tooltip",
// "Definition List" => "Definition List",
// "Create a definition list" => "Create a definition list",
// "One entry per line. Each line is in \"Term: Definition\" format" => "One entry per line. Each line is in \"Term: Definition\" format",
// "Draw" => "Draw",
// "Display or create an image from TikiDraw that is stored into the File Gallery" => "Display or create an image from TikiDraw that is stored into the File Gallery",
// "Drawing ID" => "Drawing ID",
// "Internal ID of the file id" => "Internal ID of the file id",
// "Width in pixels or percentage. Default value is page width. e.g. \"200px\" or \"100%\"" => "Width in pixels or percentage. Default value is page width. e.g. \"200px\" or \"100%\"",
// "Height in pixels or percentage. Default value is complete drawing height" => "Height in pixels or percentage. Default value is complete drawing height",
// "Force Display Archive" => "Force Display Archive",
// "The latest revision of file is automatically shown, by setting archive to y, it bypasses this check and shows the archive rather than the latest revision" => "The latest revision of file is automatically shown, by setting archive to y, it bypasses this check and shows the archive rather than the latest revision",
// "Draw New SVG Image" => "Draw New SVG Image",
// "Edit SVG Image" => "Edit SVG Image",
// " in " => " in ",
"File not found" => "Arquivo não encontrado",
// "Equation" => "Equation",
// "Render an equation written in LaTeX syntax as an image" => "Render an equation written in LaTeX syntax as an image",
// "equation" => "equation",
// "Size expressed as a percentage of the normal size. 100 produces the default size. 200 produces an image twice as large" => "Size expressed as a percentage of the normal size. 100 produces the default size. 200 produces an image twice as large",
"Events" => "Eventos",
// "Display upcoming events from calendars" => "Display upcoming events from calendars",
// "ID numbers for the site calendars whose events are to be displayed, separated by vertical bars (|)" => "ID numbers for the site calendars whose events are to be displayed, separated by vertical bars (|)",
// "Maximum Days" => "Maximum Days",
// "Events occurring within this number of days in the future from today will be included in the list (unless limited by other parameter settings). Default is 365 days" => "Events occurring within this number of days in the future from today will be included in the list (unless limited by other parameter settings). Default is 365 days",
// "Maximum Events" => "Maximum Events",
// "Maximum number of events to display. Default is 10. Set to 0 to display all (unless limited by other parameter settings)" => "Maximum number of events to display. Default is 10. Set to 0 to display all (unless limited by other parameter settings)",
// "Show Time" => "Show Time",
// "Show the time along with the date (shown by default)" => "Show the time along with the date (shown by default)",
// "Show the description of the event (shown by default)" => "Show the description of the event (shown by default)",
"Upcoming Events" => "Próximos eventos",
// "Exercise" => "Exercise",
// "PluginExercise" => "PluginExercise",
// "Creates exercises within a wiki page for students to test their new skills. The plugin allows to define inline questions and optional answers to be selected from. A score is given for multiple exercises within a page" => "Creates exercises within a wiki page for students to test their new skills. The plugin allows to define inline questions and optional answers to be selected from. A score is given for multiple exercises within a page",
"Answer" => "Resposta",
// "Used inline to specify the right answer to the question and propose an input field" => "Used inline to specify the right answer to the question and propose an input field",
// "Incorrect" => "Incorrect",
// "Alternative answers to provide" => "Alternative answers to provide",
// "Check your score" => "Check your score",
// "You scored %0 out of %1" => "You scored %0 out of %1",
// "Good" => "Good",
// "Oops" => "Oops",
// "Extend Cart Inventory Hold" => "Extend Cart Inventory Hold",
// "PluginExtendCartHold" => "PluginExtendCartHold",
// "Extends the time that items are held in the shop before timing out" => "Extends the time that items are held in the shop before timing out",
// "Create a link that shows/hides initially hidden content" => "Create a link that shows/hides initially hidden content",
// "Wiki syntax containing the content that can be hidden or shown" => "Wiki syntax containing the content that can be hidden or shown",
// "Label for link that shows and hides the content when clicked" => "Label for link that shows and hides the content when clicked",
// "Unspecified label" => "Unspecified label",
// "Arrow icon showing that content can be hidden or shown" => "Arrow icon showing that content can be hidden or shown",
// "Show Speed" => "Show Speed",
// "Speed of animation in milliseconds when showing content (200 is fast and 600 is slow. 1000 equals 1 second)" => "Speed of animation in milliseconds when showing content (200 is fast and 600 is slow. 1000 equals 1 second)",
// "Integer greater than 0 and less than or equal to 1000, or 'fast' or 'slow'" => "Integer greater than 0 and less than or equal to 1000, or 'fast' or 'slow'",
// "Hide Speed" => "Hide Speed",
// "Speed of animation in milliseconds when hiding content (200 is fast and 600 is slow. 1000 equals 1 second)" => "Speed of animation in milliseconds when hiding content (200 is fast and 600 is slow. 1000 equals 1 second)",
// "Fancy List" => "Fancy List",
// "Create a fancy-looking list" => "Create a fancy-looking list",
// "One item per line starting with anything followed by \")\"" => "One item per line starting with anything followed by \")\"",
// "Use Div" => "Use Div",
// "Use the HTML tag div instead of the HTML tag for lists (ol)" => "Use the HTML tag div instead of the HTML tag for lists (ol)",
// "CSS class for the fancylist" => "CSS class for the fancylist",
// "Fancy Table" => "Fancy Table",
// "Create a formatted table" => "Create a formatted table",
// "Rows separated by >> in the header; for the table body, one row per line. Cells separated by | in both cases" => "Rows separated by >> in the header; for the table body, one row per line. Cells separated by | in both cases",
// "Heading Row" => "Heading Row",
// "Header rows of the table. Use >> to separate multiple rows" => "Header rows of the table. Use >> to separate multiple rows",
// "Heading CSS Class" => "Heading CSS Class",
// "CSS class to apply to the heading row" => "CSS class to apply to the heading row",
// "Header Horizontal Align" => "Header Horizontal Align",
// "Horizontal alignments for header cells separated by |. Choices: left, right, center, justify" => "Horizontal alignments for header cells separated by |. Choices: left, right, center, justify",
// "Header Vertical Align" => "Header Vertical Align",
// "Vertical alignments for header cells separated by |. Choices: top, middle, bottom, baseline" => "Vertical alignments for header cells separated by |. Choices: top, middle, bottom, baseline",
// "Column Sort" => "Column Sort",
// "Indicate whether columns are sortable or not (not sortable by default)" => "Indicate whether columns are sortable or not (not sortable by default)",
// "Pre-sorted Columns" => "Pre-sorted Columns",
// "Bracketed numbers for column number and sort direction (0 = ascending, 1 = descending), for example: [0,0],[1,0]" => "Bracketed numbers for column number and sort direction (0 = ascending, 1 = descending), for example: [0,0],[1,0]",
// "Column Widths" => "Column Widths",
// "Column widths followed by px for pixels or % for percentages. Each column separated by |" => "Column widths followed by px for pixels or % for percentages. Each column separated by |",
// "Cell Horizontal Align" => "Cell Horizontal Align",
// "Table body column horizontal alignments separated by |. Choices: left, right, center, justify" => "Table body column horizontal alignments separated by |. Choices: left, right, center, justify",
// "Cell Vertical Align" => "Cell Vertical Align",
// "Table body column vertical alignments separated by |. Choices: top, middle, bottom, baseline" => "Table body column vertical alignments separated by |. Choices: top, middle, bottom, baseline",
"The feature must be activated" => "O recurso precisa ser ativado",
// "Shows if item is user favorite or not and provide the way to set it" => "Shows if item is user favorite or not and provide the way to set it",
"Link to a file that's attached or in a file gallery or archive. See PluginFiles for more functionality" => "Link para um arquivo anexo a página wiki ou em uma galeria de arquivos",
"Label for the link to the file (ignored if the file is a wiki attachment)" => "Nome usado para o link para o arquivo (ignorado se o link for para um anexo de página wiki)",
"Indicate whether the file is in a file gallery or is a wiki page attachment" => "Define se o arquivo está em uma galeria de arquivos ou anexo em uma página wiki",
// "Identify an attachment by entering its file name, which will show as a link to the file.\n\t\t\t\t\t\t\t\t If the page parameter is empty, it must be a file name of an attachment to the page where the plugin is used" => "Identify an attachment by entering its file name, which will show as a link to the file.\n\t\t\t\t\t\t\t\t If the page parameter is empty, it must be a file name of an attachment to the page where the plugin is used",
"Custom Description" => "Descrição personalizada",
// "Custom text that will be used for the link instead of the file name or file description" => "Custom text that will be used for the link instead of the file name or file description",
// "Name of the wiki page the file is attached to. Defaults to the wiki page where the plugin is used if empty" => "Name of the wiki page the file is attached to. Defaults to the wiki page where the plugin is used if empty",
"Attachment Description" => "Descrição do anexo",
// "Show the attachment description as the link label instead of the attachment file name" => "Show the attachment description as the link label instead of the attachment file name",
// "Indicates that this attachment is an image, and should be displayed inline using the img tag" => "Indicates that this attachment is an image, and should be displayed inline using the img tag",
"File ID" => "Id do arquivo",
"File ID of a file in a file gallery or an archive" => "Id (identificador numérico único) do arquivo numa galeria",
"Example value" => "Exemplo",
// "For an archive file, the archive created just before this date will be linked to. Special values : PAGE_LAST_MOD and PAGE_VIEW_DATE" => "For an archive file, the archive created just before this date will be linked to. Special values : PAGE_LAST_MOD and PAGE_VIEW_DATE",
"Show Icon" => "Mostrar ícone",
"Show an icon version of the file or file type with the link to the file" => "Mostrar um ícone do arquivo ou tipo do arquivo junto com um link para ele",
"File Gallery File/Archive" => "Arquivo de uma galeria",
"Wiki Page Attachment" => "Anexo de uma página wiki",
"The date has not been set" => "Você precisa definir a data",
"Incorrect date format" => "Formato incorreto para a data",
"No such file" => "Arquivo não foi encontrado",
"Wiki attachments are disabled" => "O recurso de anexos em páginas wiki está desabilitado",
// "List files by ID, gallery or category, or show a slideshow of image files" => "List files by ID, gallery or category, or show a slideshow of image files",
// "Title for the file listing, or the link text when slideshow = y" => "Title for the file listing, or the link text when slideshow = y",
"File Galleries ID" => "Id da galeria de arquivos",
// "To list only files contained in these file galleries (multiple IDs separated by colon)" => "To list only files contained in these file galleries (multiple IDs separated by colon)",
// "Or enter a username for user files (hint: enter {{user}} for current logged in user)" => "Or enter a username for user files (hint: enter {{user}} for current logged in user)",
// "To restrict files listed to those belonging to one or more categories. Enter a single category or ID or list of them separated by colon" => "To restrict files listed to those belonging to one or more categories. Enter a single category or ID or list of them separated by colon",
// "To list only specified files, enter their file IDs separated by colon" => "To list only specified files, enter their file IDs separated by colon",
// "Order ascending or descending based on any field in the file gallery table. Default is name_asc" => "Order ascending or descending based on any field in the file gallery table. Default is name_asc",
// "Show Action" => "Show Action",
// "Show a column with icons for the various actions the user can take with each file (not shown by default)" => "Show a column with icons for the various actions the user can take with each file (not shown by default)",
// "Show Find" => "Show Find",
// "Show a search box above the list (not shown by default)" => "Show a search box above the list (not shown by default)",
// "Show the title of the file gallery (shown by default). Also shown on slide show pop up window if a single galleryId is used" => "Show the title of the file gallery (shown by default). Also shown on slide show pop up window if a single galleryId is used",
// "Show ID" => "Show ID",
// "Show the ID number of each file (shown by default)" => "Show the ID number of each file (shown by default)",
// "Show an icon for each file depicting the file type" => "Show an icon for each file depicting the file type",
// "Show the name given to the file upon upload into the file gallery (shown by default). Set to Yes (y) to show as a caption in a slide show" => "Show the name given to the file upon upload into the file gallery (shown by default). Set to Yes (y) to show as a caption in a slide show",
// "Show Filename" => "Show Filename",
// "Show each file's filename (shown by default except in slide show). Set to Yes (y) to show as a caption in a slide show" => "Show each file's filename (shown by default except in slide show). Set to Yes (y) to show as a caption in a slide show",
// "Show Size" => "Show Size",
// "Show the size of each file in kilobytes (shown by default except in slide show)" => "Show the size of each file in kilobytes (shown by default except in slide show)",
// "Show the description of the file given upon upload into the file gallery (shown by default except in slide show). Set to Yes (y) to show as a caption in a slide show" => "Show the description of the file given upon upload into the file gallery (shown by default except in slide show). Set to Yes (y) to show as a caption in a slide show",
// "Show Creation Date" => "Show Creation Date",
// "Show the date each file was created (not shown by default)" => "Show the date each file was created (not shown by default)",
// "Show Last Modification Date" => "Show Last Modification Date",
// "Show the date each file was last modified (shown by default)" => "Show the date each file was last modified (shown by default)",
// "Show Hits" => "Show Hits",
// "Show the number of hits each file has received (not shown by default)" => "Show the number of hits each file has received (not shown by default)",
// "Show Locked By" => "Show Locked By",
// "For locked files, show the user name of the user who locked it (not shown by default)" => "For locked files, show the user name of the user who locked it (not shown by default)",
// "Show the user name of the user who is the author of the file (not shown by default)" => "Show the user name of the user who is the author of the file (not shown by default)",
// "Show Creator" => "Show Creator",
// "Show the user name of the user who is the creator of the file (not shown by default)" => "Show the user name of the user who is the creator of the file (not shown by default)",
// "Show Parent Gallery Name" => "Show Parent Gallery Name",
// "Show the name of the parent gallery" => "Show the name of the parent gallery",
// "Show File Count" => "Show File Count",
// "For galleries included in the list (where the file gallery includes other galleries), show the number of files in each of those galleries (not shown by default)" => "For galleries included in the list (where the file gallery includes other galleries), show the number of files in each of those galleries (not shown by default)",
// "Show Slideshow" => "Show Slideshow",
// "Show a link that produces a pop-up slide show when clicked (not set by default)" => "Show a link that produces a pop-up slide show when clicked (not set by default)",
// "Slideshow Width" => "Slideshow Width",
// "Set width of slideshow popup" => "Set width of slideshow popup",
// "Slideshow Height" => "Slideshow Height",
// "Set height of slideshow popup" => "Set height of slideshow popup",
// "Show Comment" => "Show Comment",
// "Show comments for each file (not shown by default)" => "Show comments for each file (not shown by default)",
// "Show Last Editor" => "Show Last Editor",
// "Show the user name of the user who last modified the file (shown by default)" => "Show the user name of the user who last modified the file (shown by default)",
// "Show Image Thumb" => "Show Image Thumb",
// "Show Image thumb" => "Show Image thumb",
// "Show only files created by this user" => "Show only files created by this user",
// "Show Upload" => "Show Upload",
// "Show a simple upload form to the gallery (not shown by default)" => "Show a simple upload form to the gallery (not shown by default)",
// "Number of rows (default: -1 = all)" => "Number of rows (default: -1 = all)",
// "Recursive" => "Recursive",
// "With sub-galleries" => "With sub-galleries",
// "Flash Video" => "Flash Video",
// "Embed a video or audio file" => "Embed a video or audio file",
// "Flash Type" => "Flash Type",
// "Whether you want to insert a Flash from a URL, a fileId from a podcast file gallery or a link to a specific service like Youtube or Vimeo" => "Whether you want to insert a Flash from a URL, a fileId from a podcast file gallery or a link to a specific service like Youtube or Vimeo",
// "Select an option" => "Select an option",
// "Blip.tv" => "Blip.tv",
// "File Gallery Podcast" => "File Gallery Podcast",
"Movie URL" => "URL do arquivo",
"Vimeo" => "Vimeo",
"Youtube" => "Youtube",
// "Complete URL to the movie to include. e.g. files/test.swf" => "Complete URL to the movie to include. e.g. files/test.swf",
// "File Gallery Podcast ID" => "File Gallery Podcast ID",
// "Id of a file from a podcast gallery - will work only with podcast gallery" => "Id of a file from a podcast gallery - will work only with podcast gallery",
"YouTube URL" => "URL do YouTube",
"Entire URL to the YouTube video" => "URL completa para o vídeo no YouTube",
"Vimeo URL" => "URL do Vimeo",
"Entire URL to the Vimeo video" => "URL completa para o vídeo no Vimeo",
// "Blip.tv URL" => "Blip.tv URL",
// "Blip.tv embed URL" => "Blip.tv embed URL",
// "Width of movie in pixels (default is 425)" => "Width of movie in pixels (default is 425)",
// "Height of movie in pixels (default is 350)" => "Height of movie in pixels (default is 350)",
"Quality" => "Qualidade",
// "Flash video quality. Default value: high" => "Flash video quality. Default value: high",
"High" => "Alta",
"Medium" => "Média",
"Low" => "Baixa",
// "Alternative image URL" => "Alternative image URL",
// "Image to display if Flash is not available" => "Image to display if Flash is not available",
"Invalid URL" => "URL inválida",
"Missing parameter movie to the plugin flash" => "O parâmetro movie é obrigatório para o plugin flash",
// "FONT" => "FONT",
// "Experimental: Font family and font size" => "Experimental: Font family and font size",
"Content" => "Conteúdo",
// "Font Family" => "Font Family",
// "Select the font family to display the content" => "Select the font family to display the content",
// "Font Size" => "Font Size",
// "Define the size of the font in pixels (enter '12' to get a font of 12px)" => "Define the size of the font in pixels (enter '12' to get a font of 12px)",
// "Footnote" => "Footnote",
// "Create automatically numbered footnotes (together with PluginFootnoteArea)" => "Create automatically numbered footnotes (together with PluginFootnoteArea)",
// "The footnote" => "The footnote",
// "Sameas" => "Sameas",
// "Tag to existing footnote" => "Tag to existing footnote",
// "Footnote Area" => "Footnote Area",
// "Create automatically numbered footnotes (together with PluginFootnote)" => "Create automatically numbered footnotes (together with PluginFootnote)",
// "Freetagged" => "Freetagged",
// "List similarly tagged objects" => "List similarly tagged objects",
// "Tags to find similar to" => "Tags to find similar to",
// "Leave blank to use the object's own tags" => "Leave blank to use the object's own tags",
// "Type of objects to extract. Set to All to find all types" => "Type of objects to extract. Set to All to find all types",
// "Same" => "Same",
// "Faqs" => "Faqs",
// "Offset" => "Offset",
// "Start record" => "Start record",
// "Default -1 (all)" => "Default -1 (all)",
// "Choose from:  objectId, type, itemId, description, created, name, href, hits, comments_locked (Default: created_desc)" => "Choose from:  objectId, type, itemId, description, created, name, href, hits, comments_locked (Default: created_desc)",
// "Comments Locked Ascending" => "Comments Locked Ascending",
// "Comments Locked Descending" => "Comments Locked Descending",
// "Description Ascending" => "Description Ascending",
// "Description Descending" => "Description Descending",
// "Href Ascending" => "Href Ascending",
// "Href Descending" => "Href Descending",
// "Object ID Ascending" => "Object ID Ascending",
// "Object ID Descending" => "Object ID Descending",
// "Show objects with names or descriptions similar to the text entered here" => "Show objects with names or descriptions similar to the text entered here",
// "Broaden" => "Broaden",
// "n|y" => "n|y",
// "Choose the header level for formatting. Default is 3 (for header level h3). Set to -1 for no header tags" => "Choose the header level for formatting. Default is 3 (for header level h3). Set to -1 for no header tags",
// "Show Titles Only" => "Show Titles Only",
// "Choose whether to show titles only (not shown by default)" => "Choose whether to show titles only (not shown by default)",
// "Maximum Image Size" => "Maximum Image Size",
// "Height or width in pixels. Default = 0 (no maximum)" => "Height or width in pixels. Default = 0 (no maximum)",
// "FTP" => "FTP",
// "Create a button for downloading a file from an FTP server" => "Create a button for downloading a file from an FTP server",
// "file name" => "file name",
// "Server Name" => "Server Name",
// "Name of the server where the FTP account is housed. Example: " => "Name of the server where the FTP account is housed. Example: ",
// "User name needed to access the FTP account" => "User name needed to access the FTP account",
// "Password needed to access the FTP account" => "Password needed to access the FTP account",
// "Download Button Label" => "Download Button Label",
// "Label for the FTP download button" => "Label for the FTP download button",
"missing parameters" => "faltando os parâmetros",
// "Connection failed" => "Connection failed",
// "Galleriffic" => "Galleriffic",
// "Displays images in galleriffic" => "Displays images in galleriffic",
// "Thumbs div width" => "Thumbs div width",
// "Width in pixels or percentage. (e.g. \"200px\" or \"100%\")" => "Width in pixels or percentage. (e.g. \"200px\" or \"100%\")",
// "Image slideshow width" => "Image slideshow width",
// "Width in pixels or percentage of the largest image. (e.g. \"200px\" or \"100%\")" => "Width in pixels or percentage of the largest image. (e.g. \"200px\" or \"100%\")",
// "Image slideshow height" => "Image slideshow height",
// "Height in pixels or percentage of the largest images. (e.g. \"200px\" or \"100%\")" => "Height in pixels or percentage of the largest images. (e.g. \"200px\" or \"100%\")",
// "Start Slideshow" => "Start Slideshow",
// "Automatically start the slideshow" => "Automatically start the slideshow",
// "Delay" => "Delay",
// "Delay in milliseconds between each transition" => "Delay in milliseconds between each transition",
// "Number of Thumbnails" => "Number of Thumbnails",
// "The number of thumbnails to show per page" => "The number of thumbnails to show per page",
// "Show top pager" => "Show top pager",
// "Display thumbnail pager at top" => "Display thumbnail pager at top",
// "Show bottom pager" => "Show bottom pager",
// "Display thumbnail pager at bottom" => "Display thumbnail pager at bottom",
// "Play Slideshow" => "Play Slideshow",
// "Pause SlideShow" => "Pause SlideShow",
// "Previous Photo" => "Previous Photo",
// "Next Photo" => "Next Photo",
// "Gauge" => "Gauge",
// "Display a horizontal bar gauge" => "Display a horizontal bar gauge",
"description" => "descrição",
// "Current value to be represented by the gauge" => "Current value to be represented by the gauge",
// "Maximum Value" => "Maximum Value",
// "Maximum possible value. Default: 100" => "Maximum possible value. Default: 100",
// "Label displayed on the left side of the gauge" => "Label displayed on the left side of the gauge",
// "Color" => "Color",
// "Main color of the gauge. Use HTML color codes or names" => "Main color of the gauge. Use HTML color codes or names",
// "Background color of the gauge. Use HTML color codes or names" => "Background color of the gauge. Use HTML color codes or names",
// "Bar width in pixels" => "Bar width in pixels",
// "Label Width" => "Label Width",
// "Width in pixels allocated to the label" => "Width in pixels allocated to the label",
// "Display Percentage" => "Display Percentage",
// "Set to true (Yes) to display a percentage of the maximum" => "Set to true (Yes) to display a percentage of the maximum",
// "Display Value" => "Display Value",
// "Set to false (No) to hide the numeric value (shown by default)" => "Set to false (No) to hide the numeric value (shown by default)",
// "Bar height in pixels" => "Bar height in pixels",
// "Get Security Token" => "Get Security Token",
// "PluginGetAccessToken" => "PluginGetAccessToken",
// "Get security token for specified parameters" => "Get security token for specified parameters",
// "Entry point path or part of it" => "Entry point path or part of it",
// "The path of part of the path for which the token is for" => "The path of part of the path for which the token is for",
// "Query string parameter keys" => "Query string parameter keys",
// "Query string parameter keys for which the token is for, separated by " => "Query string parameter keys for which the token is for, separated by ",
// "Query string parameter Values" => "Query string parameter Values",
// "Query string parameter values for which the token is for, separated by " => "Query string parameter values for which the token is for, separated by ",
// "Google Analytics" => "Google Analytics",
// "Add the tracking code for Google Analytics" => "Add the tracking code for Google Analytics",
// "Account Number" => "Account Number",
// "The account number for the site. Your account number from google looks like UA-XXXXXXX-YY. All you need to enter is XXXXXXX-YY" => "The account number for the site. Your account number from google looks like UA-XXXXXXX-YY. All you need to enter is XXXXXXX-YY",
"Missing parameter" => "Faltando parâmetro",
// "Google Doc" => "Google Doc",
// "Display a Google document" => "Display a Google document",
// "Leave this empty" => "Leave this empty",
// "Type of Google document" => "Type of Google document",
// "Document" => "Document",
// "Presentation" => "Presentation",
// "key" => "key",
// "Google doc key - for example: pXsHENf1bGGY92X1iEeJJI" => "Google doc key - for example: pXsHENf1bGGY92X1iEeJJI",
// "Name of iframe. Default is \"Frame\" + the key" => "Name of iframe. Default is \"Frame\" + the key",
// "Size of frame. Use instead of width and height. The sizes will fit the Google presentations sizes exactly" => "Size of frame. Use instead of width and height. The sizes will fit the Google presentations sizes exactly",
// "Small" => "Small",
// "Large" => "Large",
// "Width in pixels or %" => "Width in pixels or %",
// "Height in pixels or %" => "Height in pixels or %",
// "Middle" => "Middle",
// "Frame Border" => "Frame Border",
// "Choose whether to show a border around the iframe" => "Choose whether to show a border around the iframe",
// "Margin Height" => "Margin Height",
// "Margin height in pixels" => "Margin height in pixels",
// "Margin Width" => "Margin Width",
// "Margin width in pixels" => "Margin width in pixels",
// "Scrolling" => "Scrolling",
// "Choose whether to add a scroll bar" => "Choose whether to add a scroll bar",
// "Auto" => "Auto",
// "Edit Link" => "Edit Link",
// "Choose whether to show an edit link and set its location" => "Choose whether to show an edit link and set its location",
// "Required parameter \"type\" missing" => "Required parameter \"type\" missing",
// "Required parameter \"key\" missing" => "Required parameter \"key\" missing",
// "Google Map" => "Google Map",
// "Display a Google map" => "Display a Google map",
// "Type of items to show on google map" => "Type of items to show on google map",
// "Locator" => "Locator",
// "Object List" => "Object List",
// "Tracker Field" => "Tracker Field",
// "Display Mode" => "Display Mode",
// "Map display mode" => "Map display mode",
// "Satellite" => "Satellite",
// "Hybrid" => "Hybrid",
"API Key" => "Chave da API",
// "Google maps key. Not needed if set in user preferences" => "Google maps key. Not needed if set in user preferences",
// "Valid key for the website, which can be obtained at http://code.google.com/apis/maps/signup.html" => "Valid key for the website, which can be obtained at http://code.google.com/apis/maps/signup.html",
// "Map ID" => "Map ID",
// "Id suffix of Google map div to avoid conflicts with other maps on same page" => "Id suffix of Google map div to avoid conflicts with other maps on same page",
// "Single \"word\" which must begin with a letter and may be followed by any number of digits, hyphens, underscores, colons and periods" => "Single \"word\" which must begin with a letter and may be followed by any number of digits, hyphens, underscores, colons and periods",
// "A plain number will be interpreted as pixels. Add a % symbol after the number to indicate percentage" => "A plain number will be interpreted as pixels. Add a % symbol after the number to indicate percentage",
// "Show Border" => "Show Border",
// "Choose whether to show a frame border around the map (no border shown by default)" => "Choose whether to show a frame border around the map (no border shown by default)",
// "Default Center Longitude" => "Default Center Longitude",
// "Default longitude value used to center the map, e.g. -79.39. Default is the default set in the Gmap feature" => "Default longitude value used to center the map, e.g. -79.39. Default is the default set in the Gmap feature",
// "An integer between -180 and 180" => "An integer between -180 and 180",
// "Default Center Latitude" => "Default Center Latitude",
// "Default latitude value used to center the map, e.g. 43.7. Default is the default set in the Gmap feature" => "Default latitude value used to center the map, e.g. 43.7. Default is the default set in the Gmap feature",
// "Default Zoom" => "Default Zoom",
// "Use an integer between 1 and 21 to set a default zoom level for the map. Default is the default set in the Gmap feature" => "Use an integer between 1 and 21 to set a default zoom level for the map. Default is the default set in the Gmap feature",
// "Save View" => "Save View",
// "Allow user to set current map view as default view for himself only" => "Allow user to set current map view as default view for himself only",
// "Marker" => "Marker",
// "Add a marker when only the default or no coordinates are set. No marker by default" => "Add a marker when only the default or no coordinates are set. No marker by default",
// "Text Bubble" => "Text Bubble",
// "Text for bubble for marker. Tiki wiki-syntax can be used" => "Text for bubble for marker. Tiki wiki-syntax can be used",
// "Plain text or Tiki wiki-syntax" => "Plain text or Tiki wiki-syntax",
// "Show/Hide Marker Text" => "Show/Hide Marker Text",
// "Set whether the marker text bubble is shown or hidden initially. Default is to hide" => "Set whether the marker text bubble is shown or hidden initially. Default is to hide",
// "Item Type" => "Item Type",
// "Type of item being geotagged (user, wiki page, blog, etc). Will attempt to use current object if not specified. Tracker items must be categorized" => "Type of item being geotagged (user, wiki page, blog, etc). Will attempt to use current object if not specified. Tracker items must be categorized",
// "Item ID or Name" => "Item ID or Name",
// "ID of item being geotagged (name of page, blog ID, etc). Will attempt to use current object if not specified" => "ID of item being geotagged (name of page, blog ID, etc). Will attempt to use current object if not specified",
// "Any ID number or name for an existing object of the type specified in the Item Type field" => "Any ID number or name for an existing object of the type specified in the Item Type field",
// "Hide If No Markers" => "Hide If No Markers",
// "Hide map if there are no markers to be shown. Default is to show the map" => "Hide map if there are no markers to be shown. Default is to show the map",
// "Visibility Toggle" => "Visibility Toggle",
// "Add ability to toggle visibility. No toggle by default" => "Add ability to toggle visibility. No toggle by default",
// "Toggle Link Align" => "Toggle Link Align",
// "Alignment for the show/hide toggle link" => "Alignment for the show/hide toggle link",
// "Start Hidden" => "Start Hidden",
// "Choose whether to keep the map hidden initially. Default is to show the map initially" => "Choose whether to keep the map hidden initially. Default is to show the map initially",
// "Auto Zoom" => "Auto Zoom",
// "Use an integer between 1 and 21 to auto zoom to this level on address find" => "Use an integer between 1 and 21 to auto zoom to this level on address find",
// "Show Controls" => "Show Controls",
// "Show map controls (shown by default)" => "Show map controls (shown by default)",
// "Zoom Only" => "Zoom Only",
// "Zoom and Type" => "Zoom and Type",
// "Zoom and Scale" => "Zoom and Scale",
// "Type Only" => "Type Only",
// "Type and Scale" => "Type and Scale",
// "Scale Only" => "Scale Only",
// "Tracker Field ID" => "Tracker Field ID",
// "Field ID of tracker field if type is Item, Tracker Field or Locator, Item Type is trackeritem and Item ID is the tracker item ID. Tracker item must be categorized" => "Field ID of tracker field if type is Item, Tracker Field or Locator, Item Type is trackeritem and Item ID is the tracker item ID. Tracker item must be categorized",
// "Numeric ID of a location type tracker field" => "Numeric ID of a location type tracker field",
// "Tracker HTML ID" => "Tracker HTML ID",
// "HTML ID of tracker field input box where value is copied to by Javascript. Auto set if used as part of entry forms" => "HTML ID of tracker field input box where value is copied to by Javascript. Auto set if used as part of entry forms",
// "In Form" => "In Form",
// "Set to 1 (Yes) if this is embedded inside a form. Needed to prevent nested forms which is not allowed in HTML" => "Set to 1 (Yes) if this is embedded inside a form. Needed to prevent nested forms which is not allowed in HTML",
// "Show location map" => "Show location map",
// "Hide location map" => "Hide location map",
"Google Maps API key not set" => "Chave da API do Google Maps não definida",
// "No such user" => "No such user",
"The user has chosen to make his information private" => "O usuário preferiu manter sua informação sob sigilo",
// "No such object" => "No such object",
"Group" => "Grupo",
// "Display content based on the user's groups or friends" => "Display content based on the user's groups or friends",
// "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the conditions" => "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the conditions",
// "Allowed User Friends" => "Allowed User Friends",
// "Pipe separated list of users whose friends are allowed to view the block. ex: admin|johndoe|foo" => "Pipe separated list of users whose friends are allowed to view the block. ex: admin|johndoe|foo",
// "Allowed Groups" => "Allowed Groups",
// "Pipe separated list of groups allowed to view the block. ex: Admins|Developers" => "Pipe separated list of groups allowed to view the block. ex: Admins|Developers",
// "Denied Groups" => "Denied Groups",
// "Pipe separated list of groups denied from viewing the block. ex: Anonymous|Managers" => "Pipe separated list of groups denied from viewing the block. ex: Anonymous|Managers",
// "Group Expiry" => "Group Expiry",
// "Show the expiry date of a group membership of the current user" => "Show the expiry date of a group membership of the current user",
// "not in group" => "not in group",
// "never expires" => "never expires",
// "Group List" => "Group List",
// "List all groups or just groups that include a certain group" => "List all groups or just groups that include a certain group",
// "If empty, all groups will be listed. Entering a group name will cause only groups that include this group to be listed" => "If empty, all groups will be listed. Entering a group name will cause only groups that include this group to be listed",
// "Group Home Page" => "Group Home Page",
// "Link the group name to the group home page, if there is one (not linked by default)" => "Link the group name to the group home page, if there is one (not linked by default)",
// "Recursively List Groups" => "Recursively List Groups",
// "Recurse on the included groups (default is not to recurse)" => "Recurse on the included groups (default is not to recurse)",
// "GroupMail Core" => "GroupMail Core",
// "Displays GroupMail functions on a wiki page. Usually set up using a plugin alias created by the GroupMail profile" => "Displays GroupMail functions on a wiki page. Usually set up using a plugin alias created by the GroupMail profile",
// "From Email" => "From Email",
// "Email address to report" => "Email address to report",
// "Tracker Id" => "Tracker Id",
// "Id of GroupMail Logs tracker (set up in alias by profile)" => "Id of GroupMail Logs tracker (set up in alias by profile)",
// "From Field Id" => "From Field Id",
// "Id of GroupMail Logs tracker field (usually set up in alias by profile)" => "Id of GroupMail Logs tracker field (usually set up in alias by profile)",
// "Operator Field Id" => "Operator Field Id",
// "Subject Field Id" => "Subject Field Id",
// "Message Field Id" => "Message Field Id",
// "Content Field Id" => "Content Field Id",
// "Account Field Id" => "Account Field Id",
// "Datetime Field Id" => "Datetime Field Id",
// "Group Stats" => "Group Stats",
// "Show the distribution of users among groups" => "Show the distribution of users among groups",
"Groups" => "Grupos",
// "Groups separated by :. If empty, all groups will be listed" => "Groups separated by :. If empty, all groups will be listed",
// "Percentage of" => "Percentage of",
// "Show percentage out of all users in site, or just specified groups if any" => "Show percentage out of all users in site, or just specified groups if any",
// "Users in specified groups, if any" => "Users in specified groups, if any",
// "Site users" => "Site users",
// "Show Percentage" => "Show Percentage",
// "Show the percentage of total users that are members of each group (percentages are shown by default)" => "Show the percentage of total users that are members of each group (percentages are shown by default)",
// "Show Bar" => "Show Bar",
// "Represent the percentage of total users that are members of each group in a bar graph (default is not to show the bar graph)" => "Represent the percentage of total users that are members of each group in a bar graph (default is not to show the bar graph)",
// "Has Bought" => "Has Bought",
// "Check if user has bought certain item or if it is in cart" => "Check if user has bought certain item or if it is in cart",
// "PluginHasBought" => "PluginHasBought",
// "Session key names to be collected" => "Session key names to be collected",
// "Key name of passcode to be checked" => "Key name of passcode to be checked",
// "Labels for the key names to be collected" => "Labels for the key names to be collected",
// "Label of the key name of passcode to be checked" => "Label of the key name of passcode to be checked",
// "Tracker from which to get passcode to check against" => "Tracker from which to get passcode to check against",
// "Field ID from which to get passcode to check against" => "Field ID from which to get passcode to check against",
// "Item ID from which to get passcode to check against" => "Item ID from which to get passcode to check against",
// "Please fill in all fields" => "Please fill in all fields",
// "HTML" => "HTML",
"Add HTML to a page" => "Adicionar HTML à página",
"HTML code" => "Código HTML",
// "Parse wiki syntax within the HTML code" => "Parse wiki syntax within the HTML code",
// "Textlink" => "Textlink",
// "Adds an item to HTML feed" => "Adds an item to HTML feed",
// "HTML Feed Link" => "HTML Feed Link",
// "Display remote content" => "Display remote content",
// "Initial Value" => "Initial Value",
// "Feed location" => "Feed location",
// "Name of content" => "Name of content",
// "Style of content" => "Style of content",
// "Highlight" => "Highlight",
// "Asterisk" => "Asterisk",
// "HTML Feed Link Type" => "HTML Feed Link Type",
"Replace" => "Trocar",
// "Backlink" => "Backlink",
// "Popup" => "Popup",
// "Hover" => "Hover",
// "Is the HTML feed moderated" => "Is the HTML feed moderated",
// "Date of last accepted HTML item, not used if not moderated" => "Date of last accepted HTML item, not used if not moderated",
// "Iframe" => "Iframe",
// "Include another web page within a frame" => "Include another web page within a frame",
// "Frame title" => "Frame title",
// "Pixels or %" => "Pixels or %",
// "Align the iframe on the page" => "Align the iframe on the page",
"Display custom formatted images" => "Exibe uma imagem",
"Image source" => "Caminho para a imagem",
"Full URL to the image to display. \"src\", id\", \"fileId\", \"attId\" or \"randomGalleryId\" required" => "Caminho completo para a imagem a ser exibida. \"src\", id\", \"fileId\", \"attId\" ou \"randomGalleryId\"",
"Image ID" => "ID da Imagem",
"Numeric ID of an image in an Image Gallery (or list separated by commas or |)" => "ID numérico da imagem em uma galeria de imagens (ou uma lista de IDs separados por vírgula)",
"Numeric ID of an image in a File Gallery (or list separated by commas or |)" => "ID numérico da imagem em uma galeria de arquivos (ou uma lista de IDs separados por vírgula)",
// "Numeric ID of a file gallery. Displays a random image from that gallery" => "Numeric ID of a file gallery. Displays a random image from that gallery",
// "Numeric ID of a file gallery. Displays all images from that gallery" => "Numeric ID of a file gallery. Displays all images from that gallery",
// "File Name Ascending" => "File Name Ascending",
// "File Name Descending" => "File Name Descending",
// "Comment Ascending" => "Comment Ascending",
// "Comment Descending" => "Comment Descending",
// "Max Hits Ascending" => "Max Hits Ascending",
// "Max Hits Descending" => "Max Hits Descending",
// "File Size Ascending" => "File Size Ascending",
// "File Size Descending" => "File Size Descending",
// "File Type Ascending" => "File Type Ascending",
// "File Type Descending" => "File Type Descending",
// "User Ascending" => "User Ascending",
// "User Descending" => "User Descending",
// "Author Ascending" => "Author Ascending",
// "Author Descending" => "Author Descending",
// "Locked By Ascending" => "Locked By Ascending",
// "Locked By Descending" => "Locked By Descending",
// "Last Modified User Ascending" => "Last Modified User Ascending",
// "Last Modified User Descending" => "Last Modified User Descending",
// "Last Modified Date Ascending" => "Last Modified Date Ascending",
// "Last Modified Date Descending" => "Last Modified Date Descending",
// "Last Download Ascending" => "Last Download Ascending",
// "Last Download Descending" => "Last Download Descending",
// "Delete After Ascending" => "Delete After Ascending",
// "Delete After Descending" => "Delete After Descending",
// "Votes Ascending" => "Votes Ascending",
// "Votes Descending" => "Votes Descending",
// "Points Ascending" => "Points Ascending",
// "Points Descending" => "Points Descending",
// "Archive ID Ascending" => "Archive ID Ascending",
// "Archive ID Descending" => "Archive ID Descending",
"Attachment ID" => "ID de um anexo",
"Numeric ID of an image attached to a wiki page (or list separated by commas or |)" => "ID numérico de uma imagem anexada a uma página wiki (ou uma lista de IDs separados por vírgula)",
"Thumbnail" => "Miniatura",
"Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery or attachments" => "Gera uma miniatura da imagem que aumenta para o tamanho original quando cliclada ou quando o mouse passa por cima (exceto quando \"link\" é definido com outro alvo). \"browse\" e \"browsepopup\" funcionam apenas com a galeria de imagens e \"download\" funciona apenas com a galeria de arquivos e anexo de página wiki",
"Full size image appears when thumbnail is clicked" => "Imagem no tamanho original é exibida quando a miniatura é clicada",
"Mouseover" => "Mouseover",
"Full size image will pop up while cursor is over the thumbnail (and disappear when not)" => "Imagem no tamanho original é exibida quando o cursor do mouse estiver em sobre ela",
// "Mouseover (Sticky)" => "Mouseover (Sticky)",
// "Full size image will pop up once cursor passes over thumbnail and will remain up unless cursor passes over full size popup" => "Full size image will pop up once cursor passes over thumbnail and will remain up unless cursor passes over full size popup",
// "Full size image will open in a separate winow or tab (depending on browser settings) when thumbnail is clicked" => "Full size image will open in a separate winow or tab (depending on browser settings) when thumbnail is clicked",
"Browse" => "Navegar",
// "Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery" => "Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery",
// "Browse Popup" => "Browse Popup",
// "Same as \"browse\" except that the page opens in a new window or tab" => "Same as \"browse\" except that the page opens in a new window or tab",
// "Download dialog box will appear for file gallery and attachment images when thumbnail is clicked" => "Download dialog box will appear for file gallery and attachment images when thumbnail is clicked",
"Enlarge button" => "Botão para aumentar",
"Button for enlarging image" => "Exibe um botão para aumentar a imagem",
// "Enter a URL to the address the image should link to. Not needed if thumb parameter is set; overrides thumb setting" => "Enter a URL to the address the image should link to. Not needed if thumb parameter is set; overrides thumb setting",
// "Link relation" => "Link relation",
"Enter \"box\" for colorbox effect (like shadowbox and lightbox) or appropriate syntax for link relation" => "Digite \"box\" para usar o efeito colorbox (similar ao shadowbox ou lightbox) ou utilize alguma sintaxe própria do campo link relation",
// "Image map" => "Image map",
// "Name of the image map to use for the image" => "Name of the image map to use for the image",
"Image height" => "Altura da imagem",
// "Height in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent" => "Height in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent",
"Image width" => "Largura da imagem",
// "Width in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent" => "Width in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent",
"Maximum height or width in pixels (largest dimension is scaled). Overrides height and width settings" => "Largura ou altura máxima para a imagem em pixels. Sobrescreve os parâmetros altura e largura",
"Align image" => "Alinhar imagem",
// "Aligns the image itself. If the image is inside a box (because of other settings), use the align parameter to align the box" => "Aligns the image itself. If the image is inside a box (because of other settings), use the align parameter to align the box",
// "Image style" => "Image style",
// "Enter \"border\" to place a dark gray border around the image. Otherwise enter CSS styling syntax for other style effects" => "Enter \"border\" to place a dark gray border around the image. Otherwise enter CSS styling syntax for other style effects",
// "Align image block" => "Align image block",
// "Aligns the box containing the image" => "Aligns the box containing the image",
// "Image block style" => "Image block style",
// "Enter \"border\" to place a dark gray border frame around the image. Otherwise enter CSS styling syntax for other style effects" => "Enter \"border\" to place a dark gray border frame around the image. Otherwise enter CSS styling syntax for other style effects",
// "Description style" => "Description style",
// "Enter \"right\" or \"left\" to align text accordingly. Otherwise enter CSS styling syntax for other style effects" => "Enter \"right\" or \"left\" to align text accordingly. Otherwise enter CSS styling syntax for other style effects",
// "Wrapping control" => "Wrapping control",
// "Control how other items wrap around the image" => "Control how other items wrap around the image",
// "CSS class to apply to the image" => "CSS class to apply to the image",
"Image caption. \"desc\" or \"name\" or \"namedesc\" for tiki images, \"idesc\" or \"ititle\" for iptc data, otherwise enter your own description" => "Legenda da imagem",
// "Link title" => "Link title",
// "Title text. \"desc\" or \"name\" or \"namedesc\", otherwise enter your own title" => "Title text. \"desc\" or \"name\" or \"namedesc\", otherwise enter your own title",
// "Metadata" => "Metadata",
// "Display the image metadata (IPTC and EXIF information)" => "Display the image metadata (IPTC and EXIF information)",
"Alternate text" => "Texto alternativo",
"Alternate text that displays when image does not load. Set to \"Image\" by default" => "Texto alternativo exibido quando não for possível carregar a imagem",
// "Default config settings" => "Default config settings",
// "Default configuration settings (usually set by admin in the source code or through Plugin Alias)" => "Default configuration settings (usually set by admin in the source code or through Plugin Alias)",
// "Mandatory admin setting" => "Mandatory admin setting",
// "Mandatory configuration settings (usually set by admin in the source code or through Plugin Alias)" => "Mandatory configuration settings (usually set by admin in the source code or through Plugin Alias)",
// "PluginImg: User lacks permission to view image" => "PluginImg: User lacks permission to view image",
// "File is not an image" => "File is not an image",
// "Server does not support image manipulation" => "Server does not support image manipulation",
// "Enlarge" => "Enlarge",
// "''No image specified. One of the following parameters must be set: fileId, randomGalleryId, fgalId, attId, id.''" => "''No image specified. One of the following parameters must be set: fileId, randomGalleryId, fgalId, attId, id.''",
// "''Use one and only one of the following parameters: fileId, randomGalleryId, fgalId, attId, id, or src.''" => "''Use one and only one of the following parameters: fileId, randomGalleryId, fgalId, attId, id, or src.''",
// "Edit: Image" => "Edit: Image",
// "(experimental)" => "(experimental)",
"Include" => "Incluir",
// "Include content from a wiki page" => "Include content from a wiki page",
// "Wiki page name to include" => "Wiki page name to include",
// "When only a portion of the page should be included, specify the marker from which inclusion should start" => "When only a portion of the page should be included, specify the marker from which inclusion should start",
"Stop" => "Parar",
// "When only a portion of the page should be included, specify the marker at which inclusion should end" => "When only a portion of the page should be included, specify the marker at which inclusion should end",
// "Nopage Text" => "Nopage Text",
// "Text to show when no page is found" => "Text to show when no page is found",
// "Page Denied Text" => "Page Denied Text",
// "Text to show when the page exists but is denied to the user" => "Text to show when the page exists but is denied to the user",
// "Include Plugin" => "Include Plugin",
// "Edit the included page" => "Edit the included page",
// "Invite" => "Invite",
// "Invite a user to join your groups" => "Invite a user to join your groups",
// "Confirmation message after posting form" => "Confirmation message after posting form",
// "Including Group" => "Including Group",
// "Will list only the groups that include this group" => "Will list only the groups that include this group",
"Default Group" => "Grupo Padrão",
// "Dropdown list will show this group by default" => "Dropdown list will show this group by default",
// "Dropdown list will show the group related to this item ID (in group selector or creator field) by default" => "Dropdown list will show the group related to this item ID (in group selector or creator field) by default",
"Following mandatory fields are missing" => "Os seguintes campos obrigatórios não foram preenchidos",
// "Jabber" => "Jabber",
// "Chat using Jabber" => "Chat using Jabber",
// "Applet height in pixels" => "Applet height in pixels",
// "Applet width in pixels" => "Applet width in pixels",
// "XML Host Name" => "XML Host Name",
// "Web site where XML is hosted. Default is jabber.org" => "Web site where XML is hosted. Default is jabber.org",
// "Default Color" => "Default Color",
// "Set default color. Default is 255,255,255" => "Set default color. Default is 255,255,255",
// "Add JavaScript code" => "Add JavaScript code",
// "JavaScript code" => "JavaScript code",
// "Not On Ready" => "Not On Ready",
// "Do not execute on document ready (execute inline)" => "Do not execute on document ready (execute inline)",
// "No JavaScript" => "No JavaScript",
// "Optional markup for when JavaScript is off" => "Optional markup for when JavaScript is off",
// "<!-- jq plugin inactive: JavaScript off -->" => "<!-- jq plugin inactive: JavaScript off -->",
// "JavaScript" => "JavaScript",
// "JavaScript filename" => "JavaScript filename",
// "Late Load" => "Late Load",
// "Late load, use headerlib" => "Late load, use headerlib",
// "Kaltura Video" => "Kaltura Video",
// "Display a video created through the Kaltura feature" => "Display a video created through the Kaltura feature",
// "Kaltura Entry ID" => "Kaltura Entry ID",
// "Kaltura entry ID of the video to be displayed" => "Kaltura entry ID of the video to be displayed",
// "Vary text based on the page language" => "Vary text based on the page language",
// "List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs",
// "Not Language" => "Not Language",
// "List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs",
// "Show the last modification date for a page" => "Show the last modification date for a page",
// "Page name to display information of. Default value is current page" => "Page name to display information of. Default value is current page",
// "Create lists of Tiki objects based on custom search criteria and formatting" => "Create lists of Tiki objects based on custom search criteria and formatting",
// "List configuration information" => "List configuration information",
// "Missing template \"%0\"" => "Missing template \"%0\"",
// "No results for query" => "No results for query",
// "Missing objectype or qualifier for relation filter" => "Missing objectype or qualifier for relation filter",
// "Missing from or to for range filter" => "Missing from or to for range filter",
"List Pages" => "Listar páginas",
// "List pages based on various criteria" => "List pages based on various criteria",
// "Result number at which the listing should start" => "Result number at which the listing should start",
// "Limit number of items displayed in the list. Default is to display all" => "Limit number of items displayed in the list. Default is to display all",
// "Initial" => "Initial",
// "txt" => "txt",
// "Show Name Only" => "Show Name Only",
// "Show only the page names" => "Show only the page names",
// "If set to a category identifier, restrict the pages displayed to those in the specified category" => "If set to a category identifier, restrict the pages displayed to those in the specified category",
// "If set to a list of category identifiers separated by colons (:), restrict the pages to those in any of the specified categories" => "If set to a list of category identifiers separated by colons (:), restrict the pages to those in any of the specified categories",
// "If set to a list of category identifiers separated by plus signs (+), only display a page if it is in all of the specified categories" => "If set to a list of category identifiers separated by plus signs (+), only display a page if it is in all of the specified categories",
// "If set to a list of category identifiers separated by minus signs (-), only display a page if it is in the first specified category and not in any of the following categories" => "If set to a list of category identifiers separated by minus signs (-), only display a page if it is in the first specified category and not in any of the following categories",
// "Structure Head" => "Structure Head",
// "Filter by structure head" => "Filter by structure head",
// "Show Page Alias" => "Show Page Alias",
// "Show page alias in the list" => "Show page alias in the list",
// "Only pages with names similar the text entered for this parameter will be listed" => "Only pages with names similar the text entered for this parameter will be listed",
// "Two letter language code to filter pages listed" => "Two letter language code to filter pages listed",
// "Orphan Language" => "Orphan Language",
// "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed" => "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed",
// "Load Translations" => "Load Translations",
// "User or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter" => "User or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter",
// "Page name and text entered for the filter parameter must match exactly to be listed" => "Page name and text entered for the filter parameter must match exactly to be listed",
// "Only Orphan Pages" => "Only Orphan Pages",
// "Only list orphan pages" => "Only list orphan pages",
// "For List Pages" => "For List Pages",
// "Sort ascending or descending on any field in the tiki_pages table. Syntax is field name followed by _asc or _desc. Example: " => "Sort ascending or descending on any field in the tiki_pages table. Syntax is field name followed by _asc or _desc. Example: ",
"or" => "ou",
// "Length" => "Length",
// "Number of characters to display" => "Number of characters to display",
// "Show checkboxes" => "Show checkboxes",
// "List Directory" => "List Directory",
"Lists files in a directory" => "Lista de arquivos em um diretório",
// "Full path to the server-local directory. Default is the document root" => "Full path to the server-local directory. Default is the document root",
// "URL Prefix" => "URL Prefix",
// "Make the file name a link to the file by adding the URL path preceding the file name. Example: http://yoursite.com/tiki/" => "Make the file name a link to the file by adding the URL path preceding the file name. Example: http://yoursite.com/tiki/",
// "Set the sort order of the file list" => "Set the sort order of the file list",
"File Name" => "Nome do arquivo",
// "File Size" => "File Size",
// "Last Access" => "Last Access",
// "Last Metadata Change" => "Last Metadata Change",
// "Only list files with filenames that contain this filter. Example: \".jpg\"" => "Only list files with filenames that contain this filter. Example: \".jpg\"",
// "Maximum amount of files to display. Default is no limit" => "Maximum amount of files to display. Default is no limit",
"could not be opened because it doesn't exist or permission was denied" => "não pode ser aberto porque não existe ou porque as permissões foram insuficientes",
"Mail" => "E-mail",
// "Directly mail other users or groups" => "Directly mail other users or groups",
// "Limit the list of groups to the groups including each group" => "Limit the list of groups to the groups including each group",
// "Show Group Dropdown" => "Show Group Dropdown",
// "Show a dropdown list of groups (not shown by default)" => "Show a dropdown list of groups (not shown by default)",
// "Recurse on groups" => "Recurse on groups",
// "show each group and each group included in this group" => "show each group and each group included in this group",
// "Recurse on groups to have the users" => "Recurse on groups to have the users",
// "Collect the users of a selected group and the users of each included groups. If 0 do not recurse, if 1, recurse one time, 2 two times..." => "Collect the users of a selected group and the users of each included groups. If 0 do not recurse, if 1, recurse one time, 2 two times...",
// "Show User Dropdown" => "Show User Dropdown",
// "Show a dropdown list of users (not shown by default)" => "Show a dropdown list of users (not shown by default)",
// "User Autocomplete" => "User Autocomplete",
// "Show an autocomplete box on user name" => "Show an autocomplete box on user name",
// "Real Name Dropdown" => "Real Name Dropdown",
// "Show a dropdown list of user real names (not shown by default)" => "Show a dropdown list of user real names (not shown by default)",
"Map" => "Associar",
// "Display a map" => "Display a map",
// "Instructions to load content" => "Instructions to load content",
// "Scope" => "Scope",
// "Display the geolocated items represented in the page (all, center, or custom as a CSS selector). Default: center" => "Display the geolocated items represented in the page (all, center, or custom as a CSS selector). Default: center",
// "Controls" => "Controls",
// "Allows to specify which map controls will be displayed on the map and around it (controls, layers, search_location, levels, current_location, scale, streetview, navigation, coordinates, overview)" => "Allows to specify which map controls will be displayed on the map and around it (controls, layers, search_location, levels, current_location, scale, streetview, navigation, coordinates, overview)",
// "Width of the map in pixels" => "Width of the map in pixels",
// "Height of the map in pixels" => "Height of the map in pixels",
// "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19" => "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19",
// "MapServer File" => "MapServer File",
// "MapServer file identifier. Only fill this in if you are using MapServer" => "MapServer file identifier. Only fill this in if you are using MapServer",
// "Extents" => "Extents",
// "Size of the map" => "Size of the map",
// "Color Picker" => "Color Picker",
// "Mayan Calendars" => "Mayan Calendars",
// "Convert a Gregorian date to a Mayan calendar date" => "Convert a Gregorian date to a Mayan calendar date",
"Template" => "Padrão",
// "You must use the variable substitution" => "You must use the variable substitution",
// "LongCount: " => "LongCount: ",
// "Tzolkin: " => "Tzolkin: ",
// "Haab: " => "Haab: ",
// "Misc: " => "Misc: ",
// "Example: template " => "Example: template ",
// "for 22.05.2009 will return 12.19.16.6.11, 8 CHUEN, 9 SIP" => "for 22.05.2009 will return 12.19.16.6.11, 8 CHUEN, 9 SIP",
// "Default template: " => "Default template: ",
// "Gregorian date" => "Gregorian date",
// "Gregorian date for convert. Format: DD.MM.YYYY. Default: Today date" => "Gregorian date for convert. Format: DD.MM.YYYY. Default: Today date",
// " is not a valid date format. should be dd.mm.yyyy" => " is not a valid date format. should be dd.mm.yyyy",
// "Media Player" => "Media Player",
// "Add a media player to a page" => "Add a media player to a page",
"Allow Fullscreen" => "Permitir modo tela cheia",
"Allow fullscreen mode" => "Permitir modo tela cheia",
// " true|false" => " true|false",
// "MP3 URL" => "MP3 URL",
// "Complete URL to the mp3 to include" => "Complete URL to the mp3 to include",
// "FLV URL" => "FLV URL",
// "Complete URL to the flv to include" => "Complete URL to the flv to include",
// "Complete URL to the media to include" => "Complete URL to the media to include",
// "One of" => "One of",
// "Flash Window Mode" => "Flash Window Mode",
// "Sets the Window Mode property of the Flash movie. Transparent lets what's behind the movie show through and allows the movie to be covered Opaque hides what's behind the movie and Window plays the movie in its own window. Default value: " => "Sets the Window Mode property of the Flash movie. Transparent lets what's behind the movie show through and allows the movie to be covered Opaque hides what's behind the movie and Window plays the movie in its own window. Default value: ",
// "Transparent" => "Transparent",
// "Opaque" => "Opaque",
// "Window" => "Window",
// "Member List" => "Member List",
// "List and allow editing of group members" => "List and allow editing of group members",
// "List of groups to handle through the interface (use \"*\" for all). Colon separated" => "List of groups to handle through the interface (use \"*\" for all). Colon separated",
// "Show Descriptions" => "Show Descriptions",
// "Display group descriptions below list name" => "Display group descriptions below list name",
// "Display mode" => "Display mode",
// "How to show the member lists" => "How to show the member lists",
// "Tabs" => "Tabs",
// "Maximum" => "Maximum",
// "Maximum number of users to list in each group (default 100)" => "Maximum number of users to list in each group (default 100)",
// "Members Only" => "Members Only",
// "Only shows groups containing a certain user. Enter \"%user%\" to show groups for the current logged in user" => "Only shows groups containing a certain user. Enter \"%user%\" to show groups for the current logged in user",
"Sort mode" => "Critério para ordenar a listagem",
// "Sort mode for member listing" => "Sort mode for member listing",
"Read only" => "Apenas para leitura",
// "Read only mode. All ability to modify membership is hidden" => "Read only mode. All ability to modify membership is hidden",
// "Set as Default Group" => "Set as Default Group",
// "Adds possibility to set group as default group. This automatically adds the user to the group. \"Forced\" option will not propose simple addition in group" => "Adds possibility to set group as default group. This automatically adds the user to the group. \"Forced\" option will not propose simple addition in group",
// "Not suggested" => "Not suggested",
// "Suggested" => "Suggested",
// "Forced" => "Forced",
// "Only groups including the group that you specify will be listed" => "Only groups including the group that you specify will be listed",
// "Member Payment" => "Member Payment",
// "Receive payments from a member to extend membership to a group" => "Receive payments from a member to extend membership to a group",
// "Name of the group for which the subscription should be added or extended" => "Name of the group for which the subscription should be added or extended",
// "Price per period (%0)" => "Price per period (%0)",
// "Current User Member" => "Current User Member",
// "Membership only for the current user" => "Membership only for the current user",
// "Input Title" => "Input Title",
// "Title of the input form" => "Title of the input form",
// "Use %0 for the group name" => "Use %0 for the group name",
// "Supports wiki syntax" => "Supports wiki syntax",
// "Tiki Payments Invoice Title" => "Tiki Payments Invoice Title",
// "Use %0 for the group name, %4 for the number of days or %5 for the number of years" => "Use %0 for the group name, %4 for the number of days or %5 for the number of years",
// "Prevent double request" => "Prevent double request",
// "Prevent user from extended if there is already a pending request" => "Prevent user from extended if there is already a pending request",
// "Give specified numbers of free periods" => "Give specified numbers of free periods",
// "Give specified numbers of free periods, the first one could be prorated, in addition to those bought" => "Give specified numbers of free periods, the first one could be prorated, in addition to those bought",
// "Periods Label" => "Periods Label",
// "Give the period a label" => "Give the period a label",
// "The user " => "The user ",
// " already has a pending extension request payment invoice " => " already has a pending extension request payment invoice ",
// "Membership to %0 for %1 (x%2)" => "Membership to %0 for %1 (x%2)",
// "Membership to %0 for %1 users (x%2)" => "Membership to %0 for %1 users (x%2)",
// "The group " => "The group ",
// " does not have a membership term" => " does not have a membership term",
" Go to " => " Ir para ",
// "Admin > Groups" => "Admin > Groups",
// " to specify a term for this group by automatically unassigning users after a certain number of days" => " to specify a term for this group by automatically unassigning users after a certain number of days",
" does not exist" => " não existe",
// "Mini Quiz" => "Mini Quiz",
// "Create a quiz using a tracker" => "Create a quiz using a tracker",
// "Instructions::Feedback" => "Instructions::Feedback",
// "Numeric value representing the miniquiz tracker ID" => "Numeric value representing the miniquiz tracker ID",
"Insert Module" => "Inserir módulo",
// "Display a module" => "Display a module",
"Module Name" => "Nome do Módulo",
// "Module name as known in Tiki" => "Module name as known in Tiki",
// "Select Yes (y) to hide the title (default is to show the title)" => "Select Yes (y) to hide the title (default is to show the title)",
// "Title to display at the top of the box, assuming No Title is not set to Yes (y)" => "Title to display at the top of the box, assuming No Title is not set to Yes (y)",
// "Align the module to the left or right on the page allowing other elements to align against it" => "Align the module to the left or right on the page allowing other elements to align against it",
// "Number of rows (default: 10)" => "Number of rows (default: 10)",
// "Parse" => "Parse",
// "Parse wiki syntax" => "Parse wiki syntax",
// "Show only the content with no box surrounding it" => "Show only the content with no box surrounding it",
// "Decoration" => "Decoration",
// "Show box decorations (default is to show them)" => "Show box decorations (default is to show them)",
// "Add ability to show/hide the content of the module (default is the site admin setting for modules)" => "Add ability to show/hide the content of the module (default is the site admin setting for modules)",
// "Title Background" => "Title Background",
// "Override the background color for the title (if the title is shown). The value can be a color name (ex: bgcolor=blue) or a hexadecimal value (ex: bgcolor=#FFEBCD)" => "Override the background color for the title (if the title is shown). The value can be a color name (ex: bgcolor=blue) or a hexadecimal value (ex: bgcolor=#FFEBCD)",
// "Module Style" => "Module Style",
// "Inline CSS for the containing DIV element, e.g. \"max-width:80%\"" => "Inline CSS for the containing DIV element, e.g. \"max-width:80%\"",
// "CSS styling for the module data itself" => "CSS styling for the module data itself",
"Please choose a module" => "Por favor, selecione um módulo",
"to be used as argument" => "para ser utilizado como argumento",
"Sorry, no such module" => "Sinto muito, módulo inexistente",
// "Monospace" => "Monospace",
// "Display text in a monospace font" => "Display text in a monospace font",
// "Font name as known in browsers" => "Font name as known in browsers",
// "Display hidden content by mousing over a text" => "Display hidden content by mousing over a text",
// "Hidden content, unless the label parameter is undefined, in which case this is the label" => "Hidden content, unless the label parameter is undefined, in which case this is the label",
// "Text displayed on the page. The body is the hidden content" => "Text displayed on the page. The body is the hidden content",
// "Destination link when mouseover text is clicked. Use http:// for external links" => "Destination link when mouseover text is clicked. Use http:// for external links",
// "DEPRECATED" => "DEPRECATED",
// "Hidden content. The body contains the label" => "Hidden content. The body contains the label",
// "Mouseover box width. Default: 400px" => "Mouseover box width. Default: 400px",
// "Mouseover box height. Default: 200px" => "Mouseover box height. Default: 200px",
// "Offset X" => "Offset X",
// "Shifts the overlay to the right by the specified number of pixels relative to the cursor. Default: 5" => "Shifts the overlay to the right by the specified number of pixels relative to the cursor. Default: 5",
// "Offset Y" => "Offset Y",
// "Shifts the overlay lower by the specified number of pixels relative to the cursor. Default: 0" => "Shifts the overlay lower by the specified number of pixels relative to the cursor. Default: 0",
// "Parse Body" => "Parse Body",
// "Parse the body of the plugin as wiki content (parsed by default)" => "Parse the body of the plugin as wiki content (parsed by default)",
// "Parse Label" => "Parse Label",
// "Parse the label as wiki content (parsed by default)" => "Parse the label as wiki content (parsed by default)",
// "CSS class to apply" => "CSS class to apply",
// "Background color to apply to the popup" => "Background color to apply to the popup",
// "Text Color" => "Text Color",
// "Color to apply to the text in the popup" => "Color to apply to the text in the popup",
"Sticky" => "Persistente",
// "When enabled, popup stays visible until it is clicked" => "When enabled, popup stays visible until it is clicked",
// "Padding" => "Padding",
// "Padding size in pixels" => "Padding size in pixels",
// "Effect" => "Effect",
// "Set the type of show/hide animation that will be used" => "Set the type of show/hide animation that will be used",
// "Effect Speed" => "Effect Speed",
// "Set the speed of the animation" => "Set the speed of the animation",
// "Close Delay" => "Close Delay",
// "Number of seconds before popup closes" => "Number of seconds before popup closes",
// "Tag" => "Tag",
// "HTML tag to use for the label. Default \"a\"" => "HTML tag to use for the label. Default \"a\"",
// "No label specified" => "No label specified",
// "MediaWiki Table" => "MediaWiki Table",
// "Display a table using MediaWiki syntax (experimental - may change in future versions)" => "Display a table using MediaWiki syntax (experimental - may change in future versions)",
// "Fancy" => "Fancy",
// "Set to true to apply additional formatting to the table (header style, odd/even rows, etc.)" => "Set to true to apply additional formatting to the table (header style, odd/even rows, etc.)",
// "True" => "True",
// "False" => "False",
// "Wiki Classes" => "Wiki Classes",
// "Determines whether wiki style classes will be used for the table and cells (used by default)" => "Determines whether wiki style classes will be used for the table and cells (used by default)",
// "MySpace" => "MySpace",
// "Display a MySpace Flash mp3 playlist" => "Display a MySpace Flash mp3 playlist",
// "MySpace Page" => "MySpace Page",
// "MySpace page name" => "MySpace page name",
// "Now" => "Now",
// "Display the current date or time" => "Display the current date or time",
// "Format" => "Format",
// "Time format" => "Time format",
// "Object Hits" => "Object Hits",
// "Display the number of hits for certain objects" => "Display the number of hits for certain objects",
// "For a wiki page, the page name, for other object types: ID number + ? + object title" => "For a wiki page, the page name, for other object types: ID number + ? + object title",
// "Object type, such as wiki, file gallery, file, article, etc. Default is \"wiki\"" => "Object type, such as wiki, file gallery, file, article, etc. Default is \"wiki\"",
// "Show the number of hits over the past number of days indicated. Default is to show all hits" => "Show the number of hits over the past number of days indicated. Default is to show all hits",
// "Page Tabs" => "Page Tabs",
// "PluginPageTabs" => "PluginPageTabs",
// "Display page content in a set of tabs" => "Display page content in a set of tabs",
// "Wiki page names" => "Wiki page names",
// "The wiki pages you would like to use in this plugin, optional, separate with pipe \"|\".  Or a table with the class of \"pagetabs\" on the main page. On child pages use as a way to redirect to the parent" => "The wiki pages you would like to use in this plugin, optional, separate with pipe \"|\".  Or a table with the class of \"pagetabs\" on the main page. On child pages use as a way to redirect to the parent",
// "Param" => "Param",
// "Display content based on URL parameters" => "Display content based on URL parameters",
// "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed if conditions are not met" => "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed if conditions are not met",
// "Names of parameter required to display text" => "Names of parameter required to display text",
// "Source where the parameter is checked. Possible values : request .." => "Source where the parameter is checked. Possible values : request ..",
// "Show details of a payment request or invoice" => "Show details of a payment request or invoice",
// "Payment Request Number" => "Payment Request Number",
// "Unique identifier of the payment request" => "Unique identifier of the payment request",
// "Display content based on permission settings" => "Display content based on permission settings",
// "Possible Permissions" => "Possible Permissions",
// "Pipe separated list of permissions, one of which is needed to view the default text" => "Pipe separated list of permissions, one of which is needed to view the default text",
// "Forbidden Permissions" => "Forbidden Permissions",
// "Pipe separated list of permissions, any of which will cause the default text not to show" => "Pipe separated list of permissions, any of which will cause the default text not to show",
// "Display content based on the reader's current perspective" => "Display content based on the reader's current perspective",
// "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the condition" => "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the condition",
// "Allowed Perspectives" => "Allowed Perspectives",
// "Pipe-separated list of identifiers of perspectives in which the block is shown" => "Pipe-separated list of identifiers of perspectives in which the block is shown",
// "Denied Perspectives" => "Denied Perspectives",
// "Pipe-separated list of identifiers of perspectives in which the block is not shown" => "Pipe-separated list of identifiers of perspectives in which the block is not shown",
// "The module or plugin parameter must be set, but not both" => "The module or plugin parameter must be set, but not both",
// "Plugin Manager error: %0%1 not found" => "Plugin Manager error: %0%1 not found",
// "Plugin Manager error: %0%1%2%3%4 not found" => "Plugin Manager error: %0%1%2%3%4 not found",
// "Plugin Manager error:  %0%1 not found" => "Plugin Manager error:  %0%1 not found",
"Options" => "Opções",
// "Introduced in Tiki version %0" => "Introduced in Tiki version %0",
// "Accepted Values" => "Accepted Values",
// "(body of plugin)" => "(body of plugin)",
// "(blank)" => "(blank)",
// "any string except for HTML and PHP tags" => "any string except for HTML and PHP tags",
// "Since" => "Since",
// "no parameters" => "no parameters",
// "Preferences required" => "Preferences required",
// "Required parameters are in%0 %1bold%2" => "Required parameters are in%0 %1bold%2",
// "Plugin Manager" => "Plugin Manager",
// "List wiki plugin or module information for the site" => "List wiki plugin or module information for the site",
"Information" => "Informação",
// "Determines what information is shown. Values separated with | . Ignored when singletitle is set to top or none" => "Determines what information is shown. Values separated with | . Ignored when singletitle is set to top or none",
// "One or more of: description | parameters | paraminfo" => "One or more of: description | parameters | paraminfo",
// "Description & Parameters" => "Description & Parameters",
// "Description & Parameter Info" => "Description & Parameter Info",
// "Parameters & Parameter Info" => "Parameters & Parameter Info",
// "Name of a plugin (e.g., backlinks), or list separated by |, or range separated by \"-\". Single plugin can be used with limit parameter" => "Name of a plugin (e.g., backlinks), or list separated by |, or range separated by \"-\". Single plugin can be used with limit parameter",
// "Name of a module (e.g., calendar_new), or list separated by |, or range separated by \"-\". Single module can be used with limit parameter" => "Name of a module (e.g., calendar_new), or list separated by |, or range separated by \"-\". Single module can be used with limit parameter",
// "Single Title" => "Single Title",
// "Set placement of plugin name and description when displaying information for only one plugin" => "Set placement of plugin name and description when displaying information for only one plugin",
// "Title Heading" => "Title Heading",
// "Sets the heading size for the title, e.g., h2" => "Sets the heading size for the title, e.g., h2",
// "Start with this plugin record number (must be an integer 1 or greater)" => "Start with this plugin record number (must be an integer 1 or greater)",
// "Number of plugins to show. Can be used either with start or plugin as the starting point. Must be an integer 1 or greater" => "Number of plugins to show. Can be used either with start or plugin as the starting point. Must be an integer 1 or greater",
// "Poll" => "Poll",
// "Display a poll" => "Display a poll",
// "Numeric value representing the poll ID" => "Numeric value representing the poll ID",
// "Show poll title (shown by default)" => "Show poll title (shown by default)",
// "Show result" => "Show result",
// "Show total votes" => "Show total votes",
// "Pretty Tracker View Tracking" => "Pretty Tracker View Tracking",
// "PluginPrettyTrackerViews" => "PluginPrettyTrackerViews",
// "Stores tiki.tracker.pretty.views attribute for trackeritem" => "Stores tiki.tracker.pretty.views attribute for trackeritem",
// "set to y to record view each time this is loaded" => "set to y to record view each time this is loaded",
// "set to n to hide showing of attribute" => "set to n to hide showing of attribute",
// "Set to ID of tracker item" => "Set to ID of tracker item",
// "Profile Application" => "Profile Application",
// "Add a button for applying a profile" => "Add a button for applying a profile",
// "Profile repository domain. Default value is profiles.tiki.org" => "Profile repository domain. Default value is profiles.tiki.org",
// "Profile Name" => "Profile Name",
// "Name of the profile to be applied" => "Name of the profile to be applied",
// "Profile plugin only available to administrators" => "Profile plugin only available to administrators",
// "Profile %0/%1 not found" => "Profile %0/%1 not found",
// "Proposal" => "Proposal",
// "Allow users to vote on a proposal and view the results" => "Allow users to vote on a proposal and view the results",
// "The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username" => "The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username",
// "Short description of the proposal to vote on. Will be displayed above the result table" => "Short description of the proposal to vote on. Will be displayed above the result table",
// "Accept proposal" => "Accept proposal",
// "Still undecided" => "Still undecided",
// "Reject proposal" => "Reject proposal",
// "Quote" => "Quote",
// "Format text as a quote" => "Format text as a quote",
// "Quoted text" => "Quoted text",
// "Reply To" => "Reply To",
// "Name of the quoted person" => "Name of the quoted person",
"wrote:" => " escreveu:",
"Quote:" => "Cita:",
// "Random Include" => "Random Include",
// "Include a random page's content" => "Include a random page's content",
// "Random Dynamic Content" => "Random Dynamic Content",
// "Display pre-programmed changing content" => "Display pre-programmed changing content",
// "Numeric value representing the content ID" => "Numeric value representing the content ID",
// "User List with Real Names" => "User List with Real Names",
// "Show user real names for members of a group" => "Show user real names for members of a group",
// " (experimental, should be merged with UserList)" => " (experimental, should be merged with UserList)",
// "Group name - only users belonging to a group or groups with group names containing this text will be included in the list. If empty all site users will be included" => "Group name - only users belonging to a group or groups with group names containing this text will be included in the list. If empty all site users will be included",
// "String to use between elements of the list if table layout is not used" => "String to use between elements of the list if table layout is not used",
// "Result limit" => "Result limit",
// "Set to sort in ascending or descending order (unsorted by default" => "Set to sort in ascending or descending order (unsorted by default",
// "Layout" => "Layout",
// "Set to table to show results in a table (not shown in a table by default)" => "Set to table to show results in a table (not shown in a table by default)",
// "Make the listed names links to various types of user information" => "Make the listed names links to various types of user information",
"User Information" => "Informações do Usuário",
// "User Page" => "User Page",
"User Preferences" => "Preferências do Usuário",
// "Exclude" => "Exclude",
// "Exclude certain test or admin names from the list" => "Exclude certain test or admin names from the list",
"admin" => "admin",
// "admin-test" => "admin-test",
"test" => "teste",
// "test-admin" => "test-admin",
"Preferences" => "Preferências",
// "Redirect" => "Redirect",
// "Redirect to another page" => "Redirect to another page",
// "Wiki page name to redirect to" => "Wiki page name to redirect to",
// "Complete URL, internal or external" => "Complete URL, internal or external",
// "The ID of a perspective to switch to (requires feature_perspective)" => "The ID of a perspective to switch to (requires feature_perspective)",
// "perspective " => "perspective ",
// "nowhere" => "nowhere",
// "REDIRECT plugin: The redirection to '%s' is disabled just after saving the page" => "REDIRECT plugin: The redirection to '%s' is disabled just after saving the page",
// "REDIRECT plugin: The redirection to '%s' is disabled in preview mode. " => "REDIRECT plugin: The redirection to '%s' is disabled in preview mode. ",
// "REDIRECT plugin: redirect loop detected" => "REDIRECT plugin: redirect loop detected",
// "Regular Expression" => "Regular Expression",
// "Perform a regular expression search and replace" => "Perform a regular expression search and replace",
// "Each line of content is evaluated separately" => "Each line of content is evaluated separately",
// "Name of page containing search and replace expressions separated by two colons. Example of syntax on that page: /search pattern/::replacement text" => "Name of page containing search and replace expressions separated by two colons. Example of syntax on that page: /search pattern/::replacement text",
// "Register Member Payment" => "Register Member Payment",
// "Allows user to register and make member payment at the same time" => "Allows user to register and make member payment at the same time",
// "NA" => "NA",
// "Fixed Periods" => "Fixed Periods",
// "Give specific periods that can be chosen with a dropdown list.  Example - \"name:value;name:value;value;value;\"" => "Give specific periods that can be chosen with a dropdown list.  Example - \"name:value;name:value;value;value;\"",
// "Insufficient Privileges" => "Insufficient Privileges",
"Submit" => "Submeter",
// "You will be redirected in 5 seconds" => "You will be redirected in 5 seconds",
// "Displays the relations between the current object or a specified one and the rest of Tiki" => "Displays the relations between the current object or a specified one and the rest of Tiki",
// "Qualifiers" => "Qualifiers",
// "Comma-separated list of relation qualifiers" => "Comma-separated list of relation qualifiers",
// "Object identifier as type:itemId" => "Object identifier as type:itemId",
// "Single List" => "Single List",
// "Render all qualifiers into a single list without displaying the qualifier name" => "Render all qualifiers into a single list without displaying the qualifier name",
// "Remarks Box" => "Remarks Box",
// "Displays a comment, tip, note or warning box" => "Displays a comment, tip, note or warning box",
// "remarks text" => "remarks text",
// "Select type of remarksbox, which determines what icon and style will be displayed" => "Select type of remarksbox, which determines what icon and style will be displayed",
// "Confirm" => "Confirm",
"Errors" => "Erro",
"Note" => "Nota",
"Warning" => "Aviso",
// "Label displayed above the remark" => "Label displayed above the remark",
// "Use the highlight class for formatting (not used by default)" => "Use the highlight class for formatting (not used by default)",
// "Custom Icon" => "Custom Icon",
// "Enter a Tiki icon file name (with or without extension) or path to display a custom icon" => "Enter a Tiki icon file name (with or without extension) or path to display a custom icon",
"Close" => "Fechar",
// "Show a close button (not shown by default)" => "Show a close button (not shown by default)",
// "Width (e.g. 100% or 250px - default \"\")" => "Width (e.g. 100% or 250px - default \"\")",
// "Report" => "Report",
// "Build a report, and store it in a wiki page" => "Build a report, and store it in a wiki page",
// "The wiki syntax report settings" => "The wiki syntax report settings",
// "Report View" => "Report View",
// "Report Plugin View" => "Report Plugin View",
// "Sheet" => "Sheet",
// "Report Name" => "Report Name",
// "Report Plugin Name, sometimes used headings and reference" => "Report Plugin Name, sometimes used headings and reference",
// "Edit Report" => "Edit Report",
// "RSS Feed" => "RSS Feed",
// "Display items from an RSS feed" => "Display items from an RSS feed",
// "IDs" => "IDs",
// "List of feed IDs separated by colons. ex: feedId:feedId2" => "List of feed IDs separated by colons. ex: feedId:feedId2",
// "Result Count" => "Result Count",
// "Number of results displayed" => "Number of results displayed",
// "Show date of each item (not shown by default)" => "Show date of each item (not shown by default)",
// "Show feed descriptions (not shown by default)" => "Show feed descriptions (not shown by default)",
// "Show authors (not shown by default)" => "Show authors (not shown by default)",
// "Url to a favicon to put before each entry" => "Url to a favicon to put before each entry",
// "Show the title of the feed (shown by default)" => "Show the title of the feed (shown by default)",
// "Scroll" => "Scroll",
// "Show animated text that scrolls up or down" => "Show animated text that scrolls up or down",
// "Width in pixels. Example: 600px" => "Width in pixels. Example: 600px",
// "Number of pixels followed by \"px\". Example: 600px" => "Number of pixels followed by \"px\". Example: 600px",
// "Height in pixels. Example: 450px" => "Height in pixels. Example: 450px",
// "Number of pixels followed by \"px\". Example: 450px" => "Number of pixels followed by \"px\". Example: 450px",
// "Scroll speed in number of seconds (default is 8 seconds)" => "Scroll speed in number of seconds (default is 8 seconds)",
// "SourceForge" => "SourceForge",
// "Creates a link to SourceForge tracker items" => "Creates a link to SourceForge tracker items",
// "Group ID" => "Group ID",
// "SourceForge project ID (shows as group_id in the URL of a tracker item" => "SourceForge project ID (shows as group_id in the URL of a tracker item",
// "SourceForge tracker ID (shows as atid in the URL of a tracker item" => "SourceForge tracker ID (shows as atid in the URL of a tracker item",
// "SourceForge item ID (shows as aid in the URL of a tracker item" => "SourceForge item ID (shows as aid in the URL of a tracker item",
// "First part of link tooltip identifying the type of tracker item (bug, feature request, patch or support request)" => "First part of link tooltip identifying the type of tracker item (bug, feature request, patch or support request)",
// "ShareThis" => "ShareThis",
"Add a ShareThis button" => "Adicionar botão do ShareThis",
// "Send Services" => "Send Services",
// "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services" => "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services",
// "Aim" => "Aim",
// "Aim \$ Email" => "Aim \$ Email",
// "Aim \$ Sms" => "Aim \$ Sms",
// "Email \$ Sms" => "Email \$ Sms",
// "Button Style" => "Button Style",
// "Set button style: horizontal, vertical or rotate" => "Set button style: horizontal, vertical or rotate",
// "Rotate" => "Rotate",
// "Rotate Image" => "Rotate Image",
// "A value of y (Yes) will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping" => "A value of y (Yes) will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping",
// "Multiple Icons" => "Multiple Icons",
// "Enter list: email | facebook | twitter | sharethis, depending on which icons you'd like" => "Enter list: email | facebook | twitter | sharethis, depending on which icons you'd like",
// "First Services Shown" => "First Services Shown",
// "Input a list of post services (like Facebook, Myspace, Digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget" => "Input a list of post services (like Facebook, Myspace, Digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget",
// "Button Text" => "Button Text",
// "Custom link text for the button" => "Custom link text for the button",
// "Header Title" => "Header Title",
// "Optional header title text for the widget" => "Optional header title text for the widget",
// "Header Background" => "Header Background",
// "HTML color code (not color name) for the background color for the header if an optional header title is used" => "HTML color code (not color name) for the background color for the header if an optional header title is used",
// "Header Text Color" => "Header Text Color",
// "HTML color code (not color name) for the header text if an optional header title is used" => "HTML color code (not color name) for the header text if an optional header title is used",
// "Link text color for services" => "Link text color for services",
// "HTML color code (not color name) for the link text for all send and post services shown in the widget" => "HTML color code (not color name) for the link text for all send and post services shown in the widget",
// "Pop-up" => "Pop-up",
// "A value of true will cause the widget to show in a pop-up window" => "A value of true will cause the widget to show in a pop-up window",
// "Embedded Elements" => "Embedded Elements",
// "A value of true will allow embedded elements (like flash) to be seen while iframe is loading" => "A value of true will allow embedded elements (like flash) to be seen while iframe is loading",
// "Display data from a TikiSheet" => "Display data from a TikiSheet",
"Sheet Heading" => "Cabeçalho da planilha",
// "Internal ID of the TikiSheet.  Either id or url MUST be used" => "Internal ID of the TikiSheet.  Either id or url MUST be used",
// "Sheet Url Location" => "Sheet Url Location",
// "Internal URL of the Table to use as a spreadsheet.  Either id or url MUST be used" => "Internal URL of the Table to use as a spreadsheet.  Either id or url MUST be used",
// "Simple table view y/n (Default: n = jquery.sheet view if feature enabled)" => "Simple table view y/n (Default: n = jquery.sheet view if feature enabled)",
// "Height in pixels or percentage. Default value is complete spreadsheet height" => "Height in pixels or percentage. Default value is complete spreadsheet height",
// "Editable" => "Editable",
// "Show edit button. Default 'y' depending on user's permissions" => "Show edit button. Default 'y' depending on user's permissions",
// "Show subsheets" => "Show subsheets",
// "y/n. Show multi-sheets. Default 'y'" => "y/n. Show multi-sheets. Default 'y'",
// "Range" => "Range",
// "Show a range of cells (or single cell). Default shows all. e.g. \"D1:F3\" or \"e14:e14\"" => "Show a range of cells (or single cell). Default shows all. e.g. \"D1:F3\" or \"e14:e14\"",
// "Apply custom CSS class to the containing div" => "Apply custom CSS class to the containing div",
// "New sheet in page: " => "New sheet in page: ",
"Create New Sheet" => "Criar nova planilha",
// "Error loading spreadsheet" => "Error loading spreadsheet",
"Edit Sheet" => "Editar planilha",
// "Collect Anonymous Shopper Info" => "Collect Anonymous Shopper Info",
// "PluginShopperinfo" => "PluginShopperinfo",
// "Collect Anonymous Shopper Info for Shopping Cart" => "Collect Anonymous Shopper Info for Shopping Cart",
// "Values to be collected" => "Values to be collected",
// "Names of values to be collected separated by : as defined in shopper profile" => "Names of values to be collected separated by : as defined in shopper profile",
// "Labels for the values to be collected" => "Labels for the values to be collected",
// "Labels of the values to be collected separated by " => "Labels of the values to be collected separated by ",
// "Show even if logged in" => "Show even if logged in",
// "Normally this is used for anonymous users but sometimes may be used when logged in also" => "Normally this is used for anonymous users but sometimes may be used when logged in also",
// "Show Pages" => "Show Pages",
// "Find pages by searching within page names" => "Find pages by searching within page names",
// "Search criteria" => "Search criteria",
// "Maximum amount of results displayed" => "Maximum amount of results displayed",
// "Display page name and/or description. Both displayed by default" => "Display page name and/or description. Both displayed by default",
// "Name & Description" => "Name & Description",
// "Skype" => "Skype",
// "Clickable Skype link" => "Clickable Skype link",
// "Name or number to call or chat with" => "Name or number to call or chat with",
// "Set whether to call or chat. Default is chat" => "Set whether to call or chat. Default is chat",
// "Call" => "Call",
"Chat" => "Chat",
"Show status" => "Mostrar status",
// "Show a status icon or not i.e. if online/offline/etc. Default is no" => "Show a status icon or not i.e. if online/offline/etc. Default is no",
"yes" => "sim",
"no" => "não",
// "do not forget to check the tools / options/ privacy / allow my status to be show on the web" => "do not forget to check the tools / options/ privacy / allow my status to be show on the web",
// "click to" => "click to",
// "Slider" => "Slider",
// "Arrange content in a sliding area" => "Arrange content in a sliding area",
// "Content separated by /////" => "Content separated by /////",
// "Slider Titles" => "Slider Titles",
// "Pipe separated list of slider titles. Ex: slider 1|slider 2|slider 3" => "Pipe separated list of slider titles. Ex: slider 1|slider 2|slider 3",
// "Height in pixels or percentage. Default value is complete slider height" => "Height in pixels or percentage. Default value is complete slider height",
// "The theme to use in slider" => "The theme to use in slider",
// "Expand" => "Expand",
// "if y, the entire slider will expand to fit the parent element" => "if y, the entire slider will expand to fit the parent element",
// "Resize Contents" => "Resize Contents",
// "if y, solitary images/objects in the panel will expand to fit the viewport" => "if y, solitary images/objects in the panel will expand to fit the viewport",
// "Show Multiple" => "Show Multiple",
// "Set this value to a number and it will show that many slides at once" => "Set this value to a number and it will show that many slides at once",
// "Build Arrows" => "Build Arrows",
// "if y, builds the forwards and backwards buttons" => "if y, builds the forwards and backwards buttons",
// "Build Navigation" => "Build Navigation",
// "if y, builds a list of anchor links to link to each panel" => "if y, builds a list of anchor links to link to each panel",
// "Build Start Stop" => "Build Start Stop",
// "if y, builds the start/stop button and adds slideshow functionality" => "if y, builds the start/stop button and adds slideshow functionality",
// "Toggle Arrows" => "Toggle Arrows",
// "if y, side navigation arrows will slide out on hovering & hide @ other times" => "if y, side navigation arrows will slide out on hovering & hide @ other times",
// "Toggle Controls" => "Toggle Controls",
// "if y, slide in controls (navigation + play/stop button) on hover and slide change, hide @ other times" => "if y, slide in controls (navigation + play/stop button) on hover and slide change, hide @ other times",
// "Enable Arrows" => "Enable Arrows",
// "if n, arrows will be visible, but not clickable" => "if n, arrows will be visible, but not clickable",
// "Enable Navigation" => "Enable Navigation",
// "if n, navigation links will still be visible, but not clickable" => "if n, navigation links will still be visible, but not clickable",
// "Enable Start Stop" => "Enable Start Stop",
// "if n, the play/stop button will still be visible, but not clickable. Previously \"enablePlay\"" => "if n, the play/stop button will still be visible, but not clickable. Previously \"enablePlay\"",
// "Enable Keyboard" => "Enable Keyboard",
// "if n, keyboard arrow keys will not work for this slider" => "if n, keyboard arrow keys will not work for this slider",
// "Auto Play" => "Auto Play",
// "if y, the slideshow will start running; replaces \"startStopped\" option" => "if y, the slideshow will start running; replaces \"startStopped\" option",
// "Auto Play Locked" => "Auto Play Locked",
// "if y, user changing slides will not stop the slideshow" => "if y, user changing slides will not stop the slideshow",
// "Auto Play Delayed" => "Auto Play Delayed",
// "if y, starting a slideshow will delay advancing slides; if n, the slider will immediately advance to the next slide when slideshow starts" => "if y, starting a slideshow will delay advancing slides; if n, the slider will immediately advance to the next slide when slideshow starts",
// "Pause On Hover" => "Pause On Hover",
// "if y & the slideshow is active, the slideshow will pause on hover" => "if y & the slideshow is active, the slideshow will pause on hover",
// "Stop At End" => "Stop At End",
// "if y & the slideshow is active, the slideshow will stop on the last page. This also stops the rewind effect when infiniteSlides is false" => "if y & the slideshow is active, the slideshow will stop on the last page. This also stops the rewind effect when infiniteSlides is false",
// "Play Right To Left" => "Play Right To Left",
// "if y, the slideshow will move right-to-left" => "if y, the slideshow will move right-to-left",
// "Resume On Video End" => "Resume On Video End",
// "if y & the slideshow is active & a supported video is playing, it will pause the autoplay until the video is complete" => "if y & the slideshow is active & a supported video is playing, it will pause the autoplay until the video is complete",
// "Configure a slideshow. Extends the existing wiki page slideshow with notes & styles" => "Configure a slideshow. Extends the existing wiki page slideshow with notes & styles",
// "Slideshow notes - Separate with \"/////\"" => "Slideshow notes - Separate with \"/////\"",
// "The theme you want to use for the slideshow, default will be what you choose from the admin panel under Look and Feel for jQuery UI" => "The theme you want to use for the slideshow, default will be what you choose from the admin panel under Look and Feel for jQuery UI",
// "Tiki jQuery UI Theme" => "Tiki jQuery UI Theme",
// "Background Url Location" => "Background Url Location",
// "URL of the background image to use in your slideshow, overrides backgroundcolor" => "URL of the background image to use in your slideshow, overrides backgroundcolor",
// "Valid url" => "Valid url",
// "Background color to use in your slideshow, default " => "Background color to use in your slideshow, default ",
// "Any valid CSS class" => "Any valid CSS class",
// "Header font color" => "Header font color",
// "Apply a color to the headers of your slideshow" => "Apply a color to the headers of your slideshow",
// "Any HTML color" => "Any HTML color",
// "Header background color" => "Header background color",
// "Slide font color" => "Slide font color",
// "Apply a color to the slides of your slideshow" => "Apply a color to the slides of your slideshow",
// "Line Item highlight color" => "Line Item highlight color",
// "Apply a color to the line item when mouse over" => "Apply a color to the line item when mouse over",
// "Slide Seconds" => "Slide Seconds",
// "How many seconds a slide will be open while playing, overridden when slideduration is set" => "How many seconds a slide will be open while playing, overridden when slideduration is set",
// "Second count" => "Second count",
// "Slide Milliseconds" => "Slide Milliseconds",
// "How many milliseconds a slide will be open while playing" => "How many milliseconds a slide will be open while playing",
// "Text Side" => "Text Side",
// "The side on which you would like to display text if there are images that are resized or present" => "The side on which you would like to display text if there are images that are resized or present",
// "Smarty function" => "Smarty function",
// "Insert a Smarty function" => "Insert a Smarty function",
// "The name of the Smarty function that the button will activate. Available functions are: lib/smarty/libs/plugins/function.[name].php" => "The name of the Smarty function that the button will activate. Available functions are: lib/smarty/libs/plugins/function.[name].php",
// "Snarf" => "Snarf",
// "Display the contents of another web page" => "Display the contents of another web page",
// "Full URL to the page to include" => "Full URL to the page to include",
// "Regular Expression Pattern" => "Regular Expression Pattern",
// "PCRE-compliant regular expression pattern to find the parts you want changed" => "PCRE-compliant regular expression pattern to find the parts you want changed",
// "Regular Expression Replacement" => "Regular Expression Replacement",
// "PCRE-compliant regular expression replacement syntax showing what the content should be changed to" => "PCRE-compliant regular expression replacement syntax showing what the content should be changed to",
// "Enable/disable word wrapping of snippets of code (enabled by default)" => "Enable/disable word wrapping of snippets of code (enabled by default)",
// "Syntax highlighting to use for code snippets. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, .." => "Syntax highlighting to use for code snippets. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, ..",
// "Set to 1 (Yes) to add line numbers to code snippets (not shown by default)" => "Set to 1 (Yes) to add line numbers to code snippets (not shown by default)",
// "Parse wiki syntax within the code snippet (not parsed by default)" => "Parse wiki syntax within the code snippet (not parsed by default)",
// "Switch the text display from left to right to right to left" => "Switch the text display from left to right to right to left",
// "HTML Content" => "HTML Content",
// "Set to 1 (Yes) to display the content as is instead of escaping HTML special chars (not set by default)" => "Set to 1 (Yes) to display the content as is instead of escaping HTML special chars (not set by default)",
// "Cache Url" => "Cache Url",
// "Cache time in minutes. Default is to use site preference, Set to 0 for no cache" => "Cache time in minutes. Default is to use site preference, Set to 0 for no cache",
// "Text to click on to fetch the url via ajax" => "Text to click on to fetch the url via ajax",
// "Sort lines of text" => "Sort lines of text",
// "Data to sort, one entry per line" => "Data to sort, one entry per line",
"Order" => "Ordem",
// "Set the sort order of lines of content (default is ascending)" => "Set the sort order of lines of content (default is ascending)",
// "Reverse" => "Reverse",
// "Shuffle" => "Shuffle",
// "Easily arrange content on a page into rows and columns" => "Easily arrange content on a page into rows and columns",
// "Join Columns" => "Join Columns",
// "Generate the colspan attribute if columns are missing" => "Generate the colspan attribute if columns are missing",
// "Fixed Size" => "Fixed Size",
// "Generate the width attribute for the columns" => "Generate the width attribute for the columns",
// "Column Sizes" => "Column Sizes",
// "Specify all column widths in number of pixels or percent, separating each width by a pipe (|)" => "Specify all column widths in number of pixels or percent, separating each width by a pipe (|)",
"First" => "Primeiro",
// "Cells specified are ordered first left to right across rows (default) or top to bottom down columns" => "Cells specified are ordered first left to right across rows (default) or top to bottom down columns",
"Column" => "Coluna",
// "Line" => "Line",
// "Display edit icon for each section" => "Display edit icon for each section",
// "Custom Class" => "Custom Class",
// "Add a class to customize the design" => "Add a class to customize the design",
// "SQL" => "SQL",
// "Query a MySQL database and display the results" => "Query a MySQL database and display the results",
// "The SQL query goes in the body. Example: SELECT column1, column2 FROM table" => "The SQL query goes in the body. Example: SELECT column1, column2 FROM table",
// "DSN Name" => "DSN Name",
// "DSN name of the database being queried. The DSN name needs to first be defined at tiki-admin_dsn.php" => "DSN name of the database being queried. The DSN name needs to first be defined at tiki-admin_dsn.php",
"Missing db param" => "Parâmetro de banco de dados ausente",
// "Could not obtain valid DSN connection" => "Could not obtain valid DSN connection",
// "Stat" => "Stat",
// "Show various statistics for an object" => "Show various statistics for an object",
// "Object type to show stats for. Choices are article, trackeritem or wiki, or a combination of these separated by colons" => "Object type to show stats for. Choices are article, trackeritem or wiki, or a combination of these separated by colons",
// "Article & Tracker Item" => "Article & Tracker Item",
// "Article & Tracker Item & Wiki" => "Article & Tracker Item & Wiki",
// "Article & Wiki" => "Article & Wiki",
// "Article & Wiki & Tracker Item" => "Article & Wiki & Tracker Item",
// "Tracker Item" => "Tracker Item",
// "Tracker Item & Article" => "Tracker Item & Article",
// "Tracker Item & Article & Wiki" => "Tracker Item & Article & Wiki",
// "Tracker Item & Wiki" => "Tracker Item & Wiki",
// "Tracker Item & Wiki & Article" => "Tracker Item & Wiki & Article",
// "Wiki & Article" => "Wiki & Article",
// "Wiki & Article & Tracker Item" => "Wiki & Article & Tracker Item",
// "Wiki & Tracker Item" => "Wiki & Tracker Item",
// "Wiki & Tracker Item & Article" => "Wiki & Tracker Item & Article",
// "Parent ID" => "Parent ID",
// "Enter a tracker ID to restrict stats to that tracker (for use with trackeritems only)" => "Enter a tracker ID to restrict stats to that tracker (for use with trackeritems only)",
// "Last 24 Hours" => "Last 24 Hours",
// "Added and/or viewed in the last 24 hours (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed in the last 24 hours (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
"Added" => "Adicionado em",
// "Added and Viewed" => "Added and Viewed",
// "Viewed" => "Viewed",
// "Viewed & Added" => "Viewed & Added",
"Today" => "Hoje",
// "Added and/or viewed since the beginning of the day (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the day (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Last 7 Days" => "Last 7 Days",
// "Added and/or viewed in the last 7 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed in the last 7 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "This Week" => "This Week",
// "Added and/or viewed since the beginning of the week (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the week (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Last Month" => "Last Month",
// "Added and/or viewed last month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed last month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "This Month" => "This Month",
// "Added and/or viewed since the beginning of the month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Last Year" => "Last Year",
// "Added and/or viewed in the last 365 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed in the last 365 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "This Year" => "This Year",
// "Added and/or viewed since the beginning of the year (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the year (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Incorrect parameter: " => "Incorrect parameter: ",
// "Subscript" => "Subscript",
// "Apply subscript font to text" => "Apply subscript font to text",
// "Subscribe Group" => "Subscribe Group",
// "Allow users to subscribe to a group" => "Allow users to subscribe to a group",
// "text displayed before the button" => "text displayed before the button",
// "Group name to subscribe to or unsubscribe from" => "Group name to subscribe to or unsubscribe from",
// "Subscribe Text" => "Subscribe Text",
// "Subscribe text, containing %s as the placeholder for the group name" => "Subscribe text, containing %s as the placeholder for the group name",
"Subscribe" => "Inscrever-se",
// "Unsubscribe Text" => "Unsubscribe Text",
// "Unsubscribe text, containing %s as the placeholder for the group name" => "Unsubscribe text, containing %s as the placeholder for the group name",
// "Unsubscribe" => "Unsubscribe",
// "Subscribe Action" => "Subscribe Action",
// "Subscribe button label, containing %s as the placeholder for the group name" => "Subscribe button label, containing %s as the placeholder for the group name",
// "Unsubscribe Action" => "Unsubscribe Action",
// "Unsubscribe button label, containing %s as the placeholder for the group name" => "Unsubscribe button label, containing %s as the placeholder for the group name",
// "Postsubscribe URL" => "Postsubscribe URL",
// "URL to send the user to after subscribing, if required" => "URL to send the user to after subscribing, if required",
// "Postunsubscribe URL" => "Postunsubscribe URL",
// "URL to send the user to after unsubscribing, if required" => "URL to send the user to after unsubscribing, if required",
// "Make this the default group text, containing %s as the placeholder for the group name." => "Make this the default group text, containing %s as the placeholder for the group name.",
// "Not Default Group" => "Not Default Group",
// "Stop this being default group text, containing %s as the placeholder for the group name." => "Stop this being default group text, containing %s as the placeholder for the group name.",
// "Default Group Action" => "Default Group Action",
// "Default group button label. Will subscribe to the group first if not already a member" => "Default group button label. Will subscribe to the group first if not already a member",
// "Not Default Group Action" => "Not Default Group Action",
// "Stop this being default group button label. Does not unsubscribe from the group" => "Stop this being default group button label. Does not unsubscribe from the group",
// "Group To Set When Not Default" => "Group To Set When Not Default",
// "Group name to set as default when user stops this group being it" => "Group name to set as default when user stops this group being it",
// "Go To Default Group Home" => "Go To Default Group Home",
// "Redirect to new home page after default group change. (Default y)" => "Redirect to new home page after default group change. (Default y)",
// "Subscribe Groups" => "Subscribe Groups",
// "Allow users to subscribe to a list of groups" => "Allow users to subscribe to a list of groups",
// "Text shown in the dropdown box. Default: \"Subscribe to a group\"" => "Text shown in the dropdown box. Default: \"Subscribe to a group\"",
// "Show Subscribe Box" => "Show Subscribe Box",
// "Show the subscribe box (shown by default). Will not show if there are no other groups the user may register for" => "Show the subscribe box (shown by default). Will not show if there are no other groups the user may register for",
// "Subscribe Box Style" => "Subscribe Box Style",
// "Style to show the subscribe box, either dropdown or table" => "Style to show the subscribe box, either dropdown or table",
// "Show Default" => "Show Default",
// "Shows which group is the user's default group (if any) and allows the user to change his default group" => "Shows which group is the user's default group (if any) and allows the user to change his default group",
// "Group Description" => "Group Description",
// "Show the description of the group (not shown by default)" => "Show the description of the group (not shown by default)",
// "Colon separated list of groups. By default the list of groups available to the user" => "Colon separated list of groups. By default the list of groups available to the user",
// "Only list groups that include the group being specified here" => "Only list groups that include the group being specified here",
// "Default URL" => "Default URL",
// "Page user will be directed to after clicking on icon to change default group" => "Page user will be directed to after clicking on icon to change default group",
// "Leader Group Name" => "Leader Group Name",
// "Name of group for leaders of the group, where \"groupName\" will be substituted by the group name" => "Name of group for leaders of the group, where \"groupName\" will be substituted by the group name",
// "Pending Users Group Name" => "Pending Users Group Name",
// "Name of group for users that are waiting for approval to enter the group, where \"groupName\" will be substituted by the group name" => "Name of group for users that are waiting for approval to enter the group, where \"groupName\" will be substituted by the group name",
// "Group Management Page Name" => "Group Management Page Name",
// "Name of wiki page for group management by leaders, where \"groupName\" will be substituted by the group name" => "Name of wiki page for group management by leaders, where \"groupName\" will be substituted by the group name",
// "Hide link for groups including" => "Hide link for groups including",
// "Hide link to group home page for groups that include the group being specified here" => "Hide link to group home page for groups that include the group being specified here",
// "Always allow leaving group" => "Always allow leaving group",
// "Always allow leaving group even if userChoice for group is set to n" => "Always allow leaving group even if userChoice for group is set to n",
// "You do not have permission to subscribe to groups" => "You do not have permission to subscribe to groups",
// "Subscribe newsletter" => "Subscribe newsletter",
// "Allow users to subscribe to a newsletter" => "Allow users to subscribe to a newsletter",
// "Invitation message" => "Invitation message",
// "Newsletter ID" => "Newsletter ID",
// "Identification number (nlId) of the Newsletter that you want to allow the users to subscribe to" => "Identification number (nlId) of the Newsletter that you want to allow the users to subscribe to",
// "Confirmation Message" => "Confirmation Message",
// "Confirmation message after posting form. The plugin body is then the button label" => "Confirmation message after posting form. The plugin body is then the button label",
// "Button label. The plugin body is then the confirmation message" => "Button label. The plugin body is then the confirmation message",
// "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)" => "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)",
// "Already subscribed" => "Already subscribed",
// "Superscript" => "Superscript",
// "Apply superscript font to text" => "Apply superscript font to text",
// "Display a survey" => "Display a survey",
// "Wiki Page to redirect the user after his vote" => "Wiki Page to redirect the user after his vote",
// "Arrange content in tabs" => "Arrange content in tabs",
// "Tabs content separated by /////" => "Tabs content separated by /////",
// "Tabset Name" => "Tabset Name",
// "Unique tabset name (if you want it to remember its last state). Ex: user_profile_tabs" => "Unique tabset name (if you want it to remember its last state). Ex: user_profile_tabs",
// "Tab Titles" => "Tab Titles",
// "Pipe separated list of tab titles. Ex: tab 1|tab 2|tab 3" => "Pipe separated list of tab titles. Ex: tab 1|tab 2|tab 3",
// "Toggle Tabs" => "Toggle Tabs",
// "Allows to toggle from tabs to no tabs view" => "Allows to toggle from tabs to no tabs view",
// "Inside Pretty Tracker" => "Inside Pretty Tracker",
// "Parse pretty tracker variables within tabs" => "Parse pretty tracker variables within tabs",
// "No tab title specified. At least one has to be set to make the tabs appear" => "No tab title specified. At least one has to be set to make the tabs appear",
// "Apply an HTML tag to content" => "Apply an HTML tag to content",
"Tag Name" => "Nome do rótulo",
// "Any valid HTML tag, span by default" => "Any valid HTML tag, span by default",
// "CSS Style" => "CSS Style",
// "Equivalent to the style attribute of an HTML tag" => "Equivalent to the style attribute of an HTML tag",
// "TextLink" => "TextLink",
// "Links your article to a site using forwardlink protocol" => "Links your article to a site using forwardlink protocol",
// "Text to link to forwardlink" => "Text to link to forwardlink",
// "ClipboardData" => "ClipboardData",
// "ForwardLinks To: " => "ForwardLinks To: ",
// "Timeline" => "Timeline",
// "Display a timeline" => "Display a timeline",
// "Display the eventlist items represented in the page. (all, center, or custom as a CSS selector)" => "Display the eventlist items represented in the page. (all, center, or custom as a CSS selector)",
// "Width of the timeline as CSS units (default: \"100%\")" => "Width of the timeline as CSS units (default: \"100%\")",
// "Height of the timeline as CSS units (default: \"400px\")" => "Height of the timeline as CSS units (default: \"400px\")",
// "Lower Bound" => "Lower Bound",
// "Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format",
// "Upper Bound" => "Upper Bound",
// "Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format",
// "Primary Scale Unit" => "Primary Scale Unit",
// "Unit of time to use for the primary scale (default to Month)" => "Unit of time to use for the primary scale (default to Month)",
// "Decade" => "Decade",
// "Century" => "Century",
// "Secondary Scale Unit" => "Secondary Scale Unit",
// "Unit of time to use for the secondary scale (default to empty)" => "Unit of time to use for the secondary scale (default to empty)",
// "TimeSheet" => "TimeSheet",
// "A portable timesheet usable in a webpage" => "A portable timesheet usable in a webpage",
// "Title Search" => "Title Search",
// "Search pages by title" => "Search pages by title",
// "Search Criteria" => "Search Criteria",
// "Portion of a page name" => "Portion of a page name",
// "Also show page hits or user" => "Also show page hits or user",
// "Pipe-separated list of page names to exclude from results" => "Pipe-separated list of page names to exclude from results",
// "No Header" => "No Header",
// "Set to 1 (Yes) to have no header for the search results" => "Set to 1 (Yes) to have no header for the search results",
"No pages found for title search" => "Nenhuma página encontrada para a busca de título",
"One page found for title search" => "Uma página encontrada para a busca de título",
"pages found for title search" => "páginas encontradas para a busca de título",
// "Table of Contents (Structure)" => "Table of Contents (Structure)",
// "Display a table of contents of pages or sub-pages" => "Display a table of contents of pages or sub-pages",
// "Maximum Depth" => "Maximum Depth",
// "Maximum number of levels to display. On very large structures, this should be limited. Zero means no limit (and is the default)" => "Maximum number of levels to display. On very large structures, this should be limited. Zero means no limit (and is the default)",
"Structure ID" => "ID de Estrutura",
// "By default, structure for the current page will be displayed. Alternate structure may be provided" => "By default, structure for the current page will be displayed. Alternate structure may be provided",
// "Order items in ascending or descending order (default is ascending)" => "Order items in ascending or descending order (default is ascending)",
// "Show the page description instead of the page name" => "Show the page description instead of the page name",
// "Show Numbering" => "Show Numbering",
// "Display the section numbers or not" => "Display the section numbers or not",
// "Style to apply" => "Style to apply",
// "By default, the table of contents for the current page will be displayed. Alternate page may be provided" => "By default, the table of contents for the current page will be displayed. Alternate page may be provided",
// "Top Friends" => "Top Friends",
"List top-scoring users" => "Listar usuários com maior pontuação",
// "Maximum result count" => "Maximum result count",
// "Set whether public or not" => "Set whether public or not",
"Translate" => "Traduzir",
// "Translate text to the user language" => "Translate text to the user language",
// "Create a form in a wiki page to populate a tracker" => "Create a form in a wiki page to populate a tracker",
// "Numeric value representing the tracker ID" => "Numeric value representing the tracker ID",
// "Colon-separated list of field IDs to be displayed. Example: 2:4:5  If empty, all fields will be shown" => "Colon-separated list of field IDs to be displayed. Example: 2:4:5  If empty, all fields will be shown",
// "Label on the submit button. Default is \"Save\"" => "Label on the submit button. Default is \"Save\"",
// "Display the title of the tracker (not shown by default)" => "Display the title of the tracker (not shown by default)",
// "Show the tracker's description (not shown by default)" => "Show the tracker's description (not shown by default)",
// "Mark Mandatory" => "Mark Mandatory",
// "Indicate mandatory fields with an asterisk (shown by default)" => "Indicate mandatory fields with an asterisk (shown by default)",
// "Show Status" => "Show Status",
// "Show the status of the items (not shown by default)" => "Show the status of the items (not shown by default)",
// "Embedded" => "Embedded",
// "To send an email once the tracker item has been created. Format: from" => "To send an email once the tracker item has been created. Format: from",
"to" => "a",
// "Email format" => "Email format",
// "Text or HTML setting" => "Text or HTML setting",
// "URL the user is sent to after the form is submitted" => "URL the user is sent to after the form is submitted",
// "URL Target" => "URL Target",
// "Set the target parameter for the url (determines whether target will open in a new page, etc.)" => "Set the target parameter for the url (determines whether target will open in a new page, etc.)",
"Parent" => "Pai",
// "Self" => "Self",
// "Values" => "Values",
// "Colon-separated list of default values for the fields. First value corresponds to first field, second value to second field, etc" => "Colon-separated list of default values for the fields. First value corresponds to first field, second value to second field, etc",
"Overwrite" => "Sobrescrever",
// "Overwrite current field values of the item with the input values" => "Overwrite current field values of the item with the input values",
// "Display columns in the order listed in the fields parameter instead of by field ID (field ID order is used by default" => "Display columns in the order listed in the fields parameter instead of by field ID (field ID order is used by default",
"Preview" => "Pré-visualização",
// "Label for the preview button. Default" => "Label for the preview button. Default",
// "Label for the reset button, to return all fields to their default values" => "Label for the reset button, to return all fields to their default values",
"reset" => "reiniciar",
// "Status of the item used in combination with" => "Status of the item used in combination with",
// "ItemId" => "ItemId",
// "ItemId allowing for editing an item" => "ItemId allowing for editing an item",
// "Ignore ItemId" => "Ignore ItemId",
// "Do not filter on the parameter itemId if in the url" => "Do not filter on the parameter itemId if in the url",
// "Template File" => "Template File",
// "Name of the template used to display the tracker items" => "Name of the template used to display the tracker items",
// "Name of the wiki page containing the template to display the tracker items" => "Name of the wiki page containing the template to display the tracker items",
// "New Status" => "New Status",
// "Default status applied to newly created items" => "Default status applied to newly created items",
"Pending" => "Pendente",
// "Specify the width in pixels or percentage of the first column (the labels) in the tracker form" => "Specify the width in pixels or percentage of the first column (the labels) in the tracker form",
// "Autosave fields" => "Autosave fields",
// "Colon-separated list of field IDs to be automatically filled with values" => "Colon-separated list of field IDs to be automatically filled with values",
// "Autosavevalue" => "Autosavevalue",
// "Colon-separated values corresponding to autosavefields" => "Colon-separated values corresponding to autosavefields",
// "Increase-only autosave fields" => "Increase-only autosave fields",
// "Colon-separated list of field IDs being autosaved whose value can only go up, not down" => "Colon-separated list of field IDs being autosaved whose value can only go up, not down",
// "Registration Fields" => "Registration Fields",
// "Add registration fields such as Username and Password" => "Add registration fields such as Username and Password",
// "Output To Wiki" => "Output To Wiki",
// "Output result to a new wiki page with the name taken from the input for the specified fieldId" => "Output result to a new wiki page with the name taken from the input for the specified fieldId",
// "Discard After Output" => "Discard After Output",
// "Used when results are output to a wiki page to discard the tracker item itself once the wiki page is created" => "Used when results are output to a wiki page to discard the tracker item itself once the wiki page is created",
// "Template Page" => "Template Page",
// "Name of the wiki page containing the template to format the output to wiki page" => "Name of the wiki page containing the template to format the output to wiki page",
// "Multiple Fill Fields" => "Multiple Fill Fields",
// "Colon-separated list of field IDs to be filled with multiple values, to create multiple items in one save. Example: 2:4:5  If empty, only one item will be created. Only for item creation" => "Colon-separated list of field IDs to be filled with multiple values, to create multiple items in one save. Example: 2:4:5  If empty, only one item will be created. Only for item creation",
// "Separator for Multiple Fill Fields" => "Separator for Multiple Fill Fields",
// "Choose separator between fields in each line of the Multiple Fill text area. Default is pipe (|)" => "Choose separator between fields in each line of the Multiple Fill text area. Default is pipe (|)",
// "Multiple Fill Fields defaults" => "Multiple Fill Fields defaults",
// "Colon-separated list of default values for Multiple Fill Fields" => "Colon-separated list of default values for Multiple Fill Fields",
// "Embed the tracker in a form tag" => "Embed the tracker in a form tag",
// "If set to Yes, the tracker is contained in a <form> tag and has action buttons" => "If set to Yes, the tracker is contained in a <form> tag and has action buttons",
// "The page to output the results to already exists. Try another name" => "The page to output the results to already exists. Try another name",
"Tracker was modified at " => "Formulário foi modificado em ",
// "Incorrect fieldId" => "Incorrect fieldId",
"Following fields are incorrect" => "Os seguintes campos estão incorretos",
// "Each line is a list of %d field values separated with: %s" => "Each line is a list of %d field values separated with: %s",
// "Missing wiki template page \"%0\"" => "Missing wiki template page \"%0\"",
"You do not have permission to insert an item" => "Você não tem permissão para inserir um item",
// "Incorrect item" => "Incorrect item",
"You do not have permission to modify an item" => "Você não tem permissão para modificar um item",
// "The page to output the results to contains the following prohibited characters: %0. Try another name" => "The page to output the results to contains the following prohibited characters: %0. Try another name",
"Invalid email" => "E-mail inválido",
// "Passwords do not match" => "Passwords do not match",
// "Insert one item per line" => "Insert one item per line",
"Fields marked with a * are mandatory." => "Os campos marcados com * são obrigatórios",
// "Tracker Comments" => "Tracker Comments",
// "Display the number of tracker comments" => "Display the number of tracker comments",
// "Item Count" => "Item Count",
// "Determines whether the number of items will be shown (not shown by default)" => "Determines whether the number of items will be shown (not shown by default)",
// "Enter a user name to select the items of the current user" => "Enter a user name to select the items of the current user",
// "a user name" => "a user name",
// "Comments found" => "Comments found",
"Filters" => "Filtros",
// "The list of fields that can be used as filters along with their formats. The field number and format are separated by a / and multile fields are separated by \":\". Format choices are: d - dropdown; r - radio buttons; m - multiple choice dropdown; c - checkbox; t - text with wild characters; T - exact text match; i - initials; sqlsearch - advanced search; >, <, >=, <= - greater than, less than, greater than or equal, less than or equal. Example" => "The list of fields that can be used as filters along with their formats. The field number and format are separated by a / and multile fields are separated by \":\". Format choices are: d - dropdown; r - radio buttons; m - multiple choice dropdown; c - checkbox; t - text with wild characters; T - exact text match; i - initials; sqlsearch - advanced search; >, <, >=, <= - greater than, less than, greater than or equal, less than or equal. Example",
// "Label on the submit button. Default: \"Filter\". Use a space character to omit the button (for use in datachannels etc)" => "Label on the submit button. Default: \"Filter\". Use a space character to omit the button (for use in datachannels etc)",
// "Display List" => "Display List",
// "Show the full list (before filtering) initially (filtered list shown by default)" => "Show the full list (before filtering) initially (filtered list shown by default)",
// "Displays all the filters on the same line (not shown on same line by default)" => "Displays all the filters on the same line (not shown on same line by default)",
// "Yes with field label in dropdown" => "Yes with field label in dropdown",
// "No Toggle" => "No Toggle",
// "The toggle button to show/hide filters will not be shown if set to y (Yes). Default is to show the toggle" => "The toggle button to show/hide filters will not be shown if set to y (Yes). Default is to show the toggle",
// "Export CSV" => "Export CSV",
// "Label for an export button. Leave blank to show the usual \"Filter\" button instead" => "Label for an export button. Leave blank to show the usual \"Filter\" button instead",
// "Google Map Buttons" => "Google Map Buttons",
// "Display Mapview and Listview buttons" => "Display Mapview and Listview buttons",
// "Tracker Filter" => "Tracker Filter",
// "Create a form to filter tracker fields" => "Create a form to filter tracker fields",
// "notice" => "notice",
// "tracker field type not processed yet" => "tracker field type not processed yet",
// "Tracker If" => "Tracker If",
// "Display content based on results of a tracker field test" => "Display content based on results of a tracker field test",
// "Ignore" => "Ignore",
// "Ignore test in edit mode" => "Ignore test in edit mode",
// "Copy Tracker Item" => "Copy Tracker Item",
// "PluginTrackerItemCopy" => "PluginTrackerItemCopy",
// "Will not work with category or certain special fields, copies only data from specified fields" => "Will not work with category or certain special fields, copies only data from specified fields",
// "Tracker from which to copy item, joined tracker ids separated by " => "Tracker from which to copy item, joined tracker ids separated by ",
// "Fields links that are related to this tracker that you would like to join on, separated by " => "Fields links that are related to this tracker that you would like to join on, separated by ",
// "Field IDs to copy" => "Field IDs to copy",
// "Field IDs to copy old value of, separated by :, joined fields separated by |" => "Field IDs to copy old value of, separated by :, joined fields separated by |",
// "Field IDs to update values with" => "Field IDs to update values with",
// "Field IDs to update with new values specified, separated by :, joined fields separated by |" => "Field IDs to update with new values specified, separated by :, joined fields separated by |",
// "New Values" => "New Values",
// "New Values to replace for the field IDs specified, separated by :, joined fields separated by |, -randomstring- will generate random string; and f_xx to use value of field xx of itemId" => "New Values to replace for the field IDs specified, separated by :, joined fields separated by |, -randomstring- will generate random string; and f_xx to use value of field xx of itemId",
// "ID of item to make copy of, otherwise input is asked for" => "ID of item to make copy of, otherwise input is asked for",
// "Make this number of copies on load" => "Make this number of copies on load",
// "Set the number of copies to make on load of plugin automatically" => "Set the number of copies to make on load of plugin automatically",
// "Returns array non-interactively" => "Returns array non-interactively",
// "If y, returns array of new information instead of displaying results to screen, used in non-interactive mode" => "If y, returns array of new information instead of displaying results to screen, used in non-interactive mode",
// "Missing mandatory parameters" => "Missing mandatory parameters",
// "Number of update fields do not match new values" => "Number of update fields do not match new values",
// "Tracker Item Field" => "Tracker Item Field",
// "Display or test the value of a tracker item field" => "Display or test the value of a tracker item field",
// "Wiki text containing an {ELSE} marker" => "Wiki text containing an {ELSE} marker",
// "Numeric value representing the item ID. Default is the user tracker item for the current user" => "Numeric value representing the item ID. Default is the user tracker item for the current user",
// "Numeric value representing the field ID displayed or tested" => "Numeric value representing the field ID displayed or tested",
// "Colon separated list of field IDs. Default is all fields" => "Colon separated list of field IDs. Default is all fields",
// "Status of the tracker item" => "Status of the tracker item",
// "Open & Pending" => "Open & Pending",
// "Open & Closed" => "Open & Closed",
// "Pending & Closed" => "Pending & Closed",
// "Open, Pending & Closed" => "Open, Pending & Closed",
// "Set to 1 (Yes) to test whether a field is empty (if value parameter is empty) or has a value the same as the value parameter" => "Set to 1 (Yes) to test whether a field is empty (if value parameter is empty) or has a value the same as the value parameter",
// "Value to compare against" => "Value to compare against",
// "You are not allowed to view this item" => "You are not allowed to view this item",
// "You are not allowed to view this field" => "You are not allowed to view this field",
// "Tracker List" => "Tracker List",
// "List, filter and sort the items in a tracker" => "List, filter and sort the items in a tracker",
// "Colon-separated list of field IDs for the fields to be displayed. Example: 2:4:5" => "Colon-separated list of field IDs for the fields to be displayed. Example: 2:4:5",
// "Colon-separated list of fields which will display in a tooltip on mouse over. Example: 6:7" => "Colon-separated list of fields which will display in a tooltip on mouse over. Example: 6:7",
// "Sticky Popup" => "Sticky Popup",
// "Choose whether the tooltip will stay displayed on mouse out (does not stay open by default)" => "Choose whether the tooltip will stay displayed on mouse out (does not stay open by default)",
// "Show Links" => "Show Links",
// "Show links to each tracker item (not shown by default)" => "Show links to each tracker item (not shown by default)",
// "Show Item Count" => "Show Item Count",
// "Show the number of items found (not shown by default)" => "Show the number of items found (not shown by default)",
// "Show Initials" => "Show Initials",
// "Show an alphabetical index by first letter to assist in navigation (not shown by default)" => "Show an alphabetical index by first letter to assist in navigation (not shown by default)",
// "Creation date display is based on tracker settings unless overriden here" => "Creation date display is based on tracker settings unless overriden here",
// "Last Modification Date" => "Last Modification Date",
// "Last modification date display is based on tracker settings unless overriden here" => "Last modification date display is based on tracker settings unless overriden here",
// "Show Field Name" => "Show Field Name",
// "Use the field names as column titles (used by default)" => "Use the field names as column titles (used by default)",
// "Show Item Rank" => "Show Item Rank",
// "Show item ranks (not shown by default)" => "Show item ranks (not shown by default)",
// "Only show items matching certain status filters (only items with open status shown by default)" => "Only show items matching certain status filters (only items with open status shown by default)",
// "Sort rows in ascending or descending order based on field ID, date created or date last modified using these values: " => "Sort rows in ascending or descending order based on field ID, date created or date last modified using these values: ",
// "(replacing fieldId with the field ID number)" => "(replacing fieldId with the field ID number)",
// "Sort Choice" => "Sort Choice",
// "Add a dropdown of sorting choices. Example with two sorting choices: created_desc|Newest first: lastModif_desc|Last modified first" => "Add a dropdown of sorting choices. Example with two sorting choices: created_desc|Newest first: lastModif_desc|Last modified first",
// "Maximum number of items to display or -1 for all values. Defaults to max records preference, if set" => "Maximum number of items to display or -1 for all values. Defaults to max records preference, if set",
// "Offset of first item. Default is no offset" => "Offset of first item. Default is no offset",
// "Fix offset always (no pagination)" => "Fix offset always (no pagination)",
// "Fix offset to that specified, disallow pagination" => "Fix offset to that specified, disallow pagination",
// "Show Pagination" => "Show Pagination",
// "Determines whether pagination will be shown (shown by default)" => "Determines whether pagination will be shown (shown by default)",
// "Filter Field" => "Filter Field",
// "Colon separated list of fields to allow filtering on" => "Colon separated list of fields to allow filtering on",
// "Filter Value" => "Filter Value",
// "Filter value of the filterfield. For better performance, use exactvalue instead" => "Filter value of the filterfield. For better performance, use exactvalue instead",
// "Exact Value" => "Exact Value",
// "Exact value of the filter" => "Exact value of the filter",
// "Adds a checkbox on each line to be able to do an action" => "Adds a checkbox on each line to be able to do an action",
// "e.g. fieldId/postName/Title/Submit/ActionUrl/tpl/radio|dropdown" => "e.g. fieldId/postName/Title/Submit/ActionUrl/tpl/radio|dropdown",
// "goIfOne" => "goIfOne",
// "Go directly to tiki-view_tracker_item.php if only one item is found" => "Go directly to tiki-view_tracker_item.php if only one item is found",
"More" => "Mais",
// "Show a 'more' button that links to tiki-view_tracker.php (not shown by default)" => "Show a 'more' button that links to tiki-view_tracker.php (not shown by default)",
// "More URL" => "More URL",
// "More link pointing to specified URL instead of default tracker item link" => "More link pointing to specified URL instead of default tracker item link",
// "Display only the items of the current user, the current page name or the current IP address" => "Display only the items of the current user, the current page name or the current IP address",
// "Use content of the tpl file as template to display the item" => "Use content of the tpl file as template to display the item",
// "Wiki Page" => "Wiki Page",
// "Use content of the wiki page as template to display the item. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins" => "Use content of the wiki page as template to display the item. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins",
// "Template file in a Wiki page" => "Template file in a Wiki page",
// "Use content of the wiki page as template to display the item but with as little parsing on the content as with a tpl on disk. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins" => "Use content of the wiki page as template to display the item but with as little parsing on the content as with a tpl on disk. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins",
// "View User" => "View User",
// "Will display the items of the specified user" => "Will display the items of the specified user",
// "Item ID separated with " => "Item ID separated with ",
// "To restrict the list to these item IDs" => "To restrict the list to these item IDs",
// "Ignore the itemId url parameter when filtering list (not ignored by default)" => "Ignore the itemId url parameter when filtering list (not ignored by default)",
// "The link that will be on each main field" => "The link that will be on each main field",
// "Left Deliminator" => "Left Deliminator",
// "Smarty left delimiter for Latex generation" => "Smarty left delimiter for Latex generation",
// "Right Deliminator" => "Right Deliminator",
// "Smarty right delimiter for Latex generation" => "Smarty right delimiter for Latex generation",
// "List Mode" => "List Mode",
// "Set output format. Yes (y) displays tracker list view with truncated values (default); \n\t\t\t\t\t\t\t\tNo (n) displays in tracker item view; Comma Separated Values (csv) outputs without any HTML formatting" => "Set output format. Yes (y) displays tracker list view with truncated values (default); \n\t\t\t\t\t\t\t\tNo (n) displays in tracker item view; Comma Separated Values (csv) outputs without any HTML formatting",
// "Comma Separated Values" => "Comma Separated Values",
// "Export Button" => "Export Button",
// "Show an export button (not shown by default)" => "Show an export button (not shown by default)",
// "Compute" => "Compute",
// "Sum or average all the values of a field and displays it at the bottom of the table" => "Sum or average all the values of a field and displays it at the bottom of the table",
// "fieldId" => "fieldId",
// "Silent" => "Silent",
// "Show nothing if no items found (the table header and a 'No records found' message is shown by default)" => "Show nothing if no items found (the table header and a 'No records found' message is shown by default)",
// "Show Delete" => "Show Delete",
// "Show a delete option (not shown by default)" => "Show a delete option (not shown by default)",
// "Show Open Item" => "Show Open Item",
// "Show an open item  option (not shown by default)" => "Show an open item  option (not shown by default)",
// "Show Close Item" => "Show Close Item",
// "Show a close item option (not shown by default)" => "Show a close item option (not shown by default)",
// "Show Pending Item" => "Show Pending Item",
// "Show a pending item option (not shown by default)" => "Show a pending item option (not shown by default)",
// "Show Watch Button" => "Show Watch Button",
// "Show a watch button (not shown by default)" => "Show a watch button (not shown by default)",
// "Show Feed Button" => "Show Feed Button",
// "Show an RSS feed button (not shown by default)" => "Show an RSS feed button (not shown by default)",
// "Show Google Map" => "Show Google Map",
// "Show Google Map of results (not shown by default)" => "Show Google Map of results (not shown by default)",
// "Google Map Icon" => "Google Map Icon",
// "Url of default icon to use for markers on the map" => "Url of default icon to use for markers on the map",
// "Calendar Field IDs" => "Calendar Field IDs",
// "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds separated with : for start:end" => "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds separated with : for start:end",
// "Calendar View Mode" => "Calendar View Mode",
// "Calendar view type time span (default is month)" => "Calendar view type time span (default is month)",
// "Bimester" => "Bimester",
// "Trimester" => "Trimester",
// "Calendar Popup" => "Calendar Popup",
// "Calendar items will pop-up, overrides Sticky Popup if turned off. Set to y (Yes) by default" => "Calendar items will pop-up, overrides Sticky Popup if turned off. Set to y (Yes) by default",
// "Calendar item pop-ups will stay open if set to y (Yes). Set to n (No) by default" => "Calendar item pop-ups will stay open if set to y (Yes). Set to n (No) by default",
// "Beginning of Month" => "Beginning of Month",
// "Set whether calendar will begin at the beginning of the month (does by default)" => "Set whether calendar will begin at the beginning of the month (does by default)",
// "Show calendar navigation bar (shown by default)" => "Show calendar navigation bar (shown by default)",
// "Partial" => "Partial",
// "Calendar Title" => "Calendar Title",
// "Enter a title to display a calendar title (not set by default)" => "Enter a title to display a calendar title (not set by default)",
// "Calendar Delta" => "Calendar Delta",
// "Set the calendar delta that will be shown (not set by default)" => "Set the calendar delta that will be shown (not set by default)",
// "Plus Month" => "Plus Month",
// "Minus Month" => "Minus Month",
// "Plus Bimester" => "Plus Bimester",
// "Minus Bimester" => "Minus Bimester",
// "Display Spreadsheet" => "Display Spreadsheet",
// "Display tracker as a spreadsheet (not used by default)" => "Display tracker as a spreadsheet (not used by default)",
// "Force Compile" => "Force Compile",
// "Force Smarty to recompile the templates for each tracker item when using a wiki page as a template. Default=n (best performance)" => "Force Smarty to recompile the templates for each tracker item when using a wiki page as a template. Default=n (best performance)",
// "Numeric value to display only last tracker items created within a user defined time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how many of those units are to be considered to define the time frame. Use in conjunction with \"max=-1\" to list all items (by default \"max\" is set to 10)" => "Numeric value to display only last tracker items created within a user defined time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how many of those units are to be considered to define the time frame. Use in conjunction with \"max=-1\" to list all items (by default \"max\" is set to 10)",
// "Period type" => "Period type",
// "Time period after creation or after modification" => "Time period after creation or after modification",
// "Creation" => "Creation",
// "Modification" => "Modification",
// "incorrect filterfield" => "incorrect filterfield",
"Error in tracker ID" => "Erro no ID do formulário",
"No field indicated" => "Sem campo indicado",
// "Check Tracker Passcodes" => "Check Tracker Passcodes",
// "PluginTrackerpasscode" => "PluginTrackerpasscode",
// "Tracker Prefill" => "Tracker Prefill",
// "Create a button to prefill tracker fields" => "Create a button to prefill tracker fields",
// "Tracker Page Name" => "Tracker Page Name",
// "URL Parameters" => "URL Parameters",
// "Parameters to pass in the url, e.g. &my_parameter1=123&my_parameter2=q" => "Parameters to pass in the url, e.g. &my_parameter1=123&my_parameter2=q",
// "Field 1" => "Field 1",
// "Field ID for the first field" => "Field ID for the first field",
// "Value 1" => "Value 1",
// "Content that should be used to prefill the field" => "Content that should be used to prefill the field",
// "Field 2" => "Field 2",
// "Field ID for the second field" => "Field ID for the second field",
// "Value 2" => "Value 2",
// "Field 3" => "Field 3",
// "Field ID for the third field" => "Field ID for the third field",
// "Value 3" => "Value 3",
// "Field 4" => "Field 4",
// "Field ID for the fourth field" => "Field ID for the fourth field",
// "Value 4" => "Value 4",
// "Field 5" => "Field 5",
// "Field ID for the fifth field" => "Field ID for the fifth field",
// "Value 5" => "Value 5",
// "Field 6" => "Field 6",
// "Field ID for the sixth field" => "Field ID for the sixth field",
// "Value 6" => "Value 6",
// "Field 7" => "Field 7",
// "Field ID for the seventh field" => "Field ID for the seventh field",
// "Value 7" => "Value 7",
// "Field 8" => "Field 8",
// "Field ID for the eighth field" => "Field ID for the eighth field",
// "Value 8" => "Value 8",
// "Tracker Stats" => "Tracker Stats",
// "Display statistics about a tracker" => "Display statistics about a tracker",
// "Colon-separated list of field IDs to be displayed. Example: 2:4:5" => "Colon-separated list of field IDs to be displayed. Example: 2:4:5",
// "Show Count" => "Show Count",
// "Choose whether to show the count of votes each option received (shown by default)" => "Choose whether to show the count of votes each option received (shown by default)",
// "Choose whether to show the percentage of the vote each option received (not shown by default)" => "Choose whether to show the percentage of the vote each option received (not shown by default)",
// "Choose whether to show a bar representing the number of votes each option received (not shown by default)" => "Choose whether to show a bar representing the number of votes each option received (not shown by default)",
// "Only show items matching certain status filters" => "Only show items matching certain status filters",
// "Show Link" => "Show Link",
// "Show link to tiki-view_tracker" => "Show link to tiki-view_tracker",
// "Show last modification date of a tracker. Set to y to use site setting or use PHP\\s format (www.php.net/strftime)" => "Show last modification date of a tracker. Set to y to use site setting or use PHP\\s format (www.php.net/strftime)",
// "y to use the site setting for short date format. Otherwise, use PHP format (www.php.net/strftime), Example: \"%A %d of %B, %Y\"" => "y to use the site setting for short date format. Otherwise, use PHP format (www.php.net/strftime), Example: \"%A %d of %B, %Y\"",
// "invalid status" => "invalid status",
// "incorrect fieldId" => "incorrect fieldId",
// "Tracker Timeline" => "Tracker Timeline",
// "Show a timeline view of a tracker" => "Show a timeline view of a tracker",
// "Title Field" => "Title Field",
// "Tracker Field ID containing the item title" => "Tracker Field ID containing the item title",
// "Summary Field" => "Summary Field",
// "Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused" => "Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused",
// "Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field" => "Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field",
// "Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field" => "Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field",
// "Element Group" => "Element Group",
// "Tracker Field ID containing the element's group. Elements of a same group are displayed on the same row" => "Tracker Field ID containing the element's group. Elements of a same group are displayed on the same row",
// "Unit of time to use for the primary scale (default to hour - * SIMILE only)" => "Unit of time to use for the primary scale (default to hour - * SIMILE only)",
// "Decade *" => "Decade *",
// "Century *" => "Century *",
// "Unit of time to use for the secondary scale (default to empty - * SIMILE only)" => "Unit of time to use for the secondary scale (default to empty - * SIMILE only)",
// "Timeline height" => "Timeline height",
// "Height of the timeline band as a CSS unit (default: 250px -  - * SIMILE only)" => "Height of the timeline band as a CSS unit (default: 250px -  - * SIMILE only)",
// "Lower band height" => "Lower band height",
// "Height of the lower timeline band as a percentage (default: 30 -  - * SIMILE only)" => "Height of the lower timeline band as a percentage (default: 30 -  - * SIMILE only)",
// "Link Group Name" => "Link Group Name",
// "Convert the group name to a link" => "Convert the group name to a link",
// "Page Link Field" => "Page Link Field",
// "Tracker Field ID containing the page name for item details" => "Tracker Field ID containing the page name for item details",
// "SIMILE Timeline" => "SIMILE Timeline",
// "Use the SIMILE Timeline Widget" => "Use the SIMILE Timeline Widget",
// "Image Field" => "Image Field",
// "Tracker Field ID containing in image" => "Tracker Field ID containing in image",
// "Missing parameter: %0" => "Missing parameter: %0",
// "Start date after end date" => "Start date after end date",
// "Tracker Toggle" => "Tracker Toggle",
// "Toggle element display on a field value" => "Toggle element display on a field value",
// "Numeric value representing the field ID tested" => "Numeric value representing the field ID tested",
// "Element visibility" => "Element visibility",
// "If y, is visible when the field has the value" => "If y, is visible when the field has the value",
// "Html ID of the element that is toggled" => "Html ID of the element that is toggled",
// "Use the field of specific item. The URL param itemId is used if this parameter is not set" => "Use the field of specific item. The URL param itemId is used if this parameter is not set",
// "Trade" => "Trade",
// "Send or receive payments from one member to another. (for cclite only so far, experimental)" => "Send or receive payments from one member to another. (for cclite only so far, experimental)",
// "Currency depends on the selected registry" => "Currency depends on the selected registry",
// "Registry to trade in. Default: site preference (or first in list when more than one)" => "Registry to trade in. Default: site preference (or first in list when more than one)",
// "Currency to trade in. Default: Cclite currency preference for registry set above" => "Currency to trade in. Default: Cclite currency preference for registry set above",
// "Other User" => "Other User",
// "Name of the user to recieve or send the payment" => "Name of the user to recieve or send the payment",
// "Leave empty to display an input box" => "Leave empty to display an input box",
// "Offered or wanted item" => "Offered or wanted item",
// "Offered" => "Offered",
// "Wanted" => "Wanted",
"Continue" => "Continuar",
// "Use %0 for the amount, %1 for currency, %2 for your user name, %3 for the other user" => "Use %0 for the amount, %1 for currency, %2 for your user name, %3 for the other user",
// "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user %2 from %3\" for wanted" => "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user %2 from %3\" for wanted",
// "Please log in" => "Please log in",
// " needs to validate their account" => " needs to validate their account",
// "Transclude" => "Transclude",
// "PluginTransclude" => "PluginTransclude",
// "Include the content of another page with certain changes" => "Include the content of another page with certain changes",
// "Name of the wiki page to use as a template for the values" => "Name of the wiki page to use as a template for the values",
// "Attempt to include a page that cannot be viewed" => "Attempt to include a page that cannot be viewed",
"Page not found" => "Página não encontrada",
// "Page named \"%0\" does not exist at this time" => "Page named \"%0\" does not exist at this time",
// "Translated" => "Translated",
// "Create multi-lingual links" => "Create multi-lingual links",
// "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)" => "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)",
// "Two letter language code of the language, ex: fr" => "Two letter language code of the language, ex: fr",
"Flag" => "Marca",
// "Country name, ex: France" => "Country name, ex: France",
// "Twitter" => "Twitter",
// "Display the activity for a twitter account" => "Display the activity for a twitter account",
// "Account Name" => "Account Name",
// "Name of the twitter account" => "Name of the twitter account",
// "Shell Background Color" => "Shell Background Color",
// "Background color for the overall widget, i.e., header, footer and outside border. Default is red (color code #15a2b)" => "Background color for the overall widget, i.e., header, footer and outside border. Default is red (color code #15a2b)",
// "Valid HTML color codes (with beginning #) or names" => "Valid HTML color codes (with beginning #) or names",
// "Shell Text Color" => "Shell Text Color",
// "Text color for the widget header and footer. Default is white (color code #ffffff)" => "Text color for the widget header and footer. Default is white (color code #ffffff)",
// "Tweet Background Color" => "Tweet Background Color",
// "Background color for individual tweets. Default is white" => "Background color for individual tweets. Default is white",
// "Tweet Text Color" => "Tweet Text Color",
// "Text color for individual tweets. Default is black" => "Text color for individual tweets. Default is black",
// "Height of widget in pixels. Default is 300" => "Height of widget in pixels. Default is 300",
// "Width of widget in pixels or 'auto' to fit to width of page. Default is auto" => "Width of widget in pixels or 'auto' to fit to width of page. Default is auto",
// "Number of pixels or the word 'auto'" => "Number of pixels or the word 'auto'",
// "User Count" => "User Count",
// "Display number of users for a site or group" => "Display number of users for a site or group",
"Group name" => "Nome do grupo",
// "User Link" => "User Link",
// "Display a link to a user's information page" => "Display a link to a user's information page",
// "User account name (which can be an email address)" => "User account name (which can be an email address)",
"User List" => "Lista de usuários",
// "Display a list of registered users" => "Display a list of registered users",
// "Login Filter" => "Login Filter",
// "Separator to use between users in the list. Default: comma" => "Separator to use between users in the list. Default: comma",
// "User info" => "User info",
// "User page" => "User page",
// "User pref" => "User pref",
"Real Name" => "Nome completo",
// "Display the user's real name (when available) instead of login name" => "Display the user's real name (when available) instead of login name",
// "Filter on a group" => "Filter on a group",
"users" => "usuários",
// "Display contents based on user preference settings" => "Display contents based on user preference settings",
// "Create tabs for showing alternate versions of content" => "Create tabs for showing alternate versions of content",
// "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default" => "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default",
"Navigation" => "Navegação",
// "Displays a navigation box that allows users to select a specific version to display" => "Displays a navigation box that allows users to select a specific version to display",
// "Display the current version name as the title. No title shows when nav=>y; otherwise shows by default" => "Display the current version name as the title. No title shows when nav=>y; otherwise shows by default",
// "Default Label" => "Default Label",
// "Specifies version label to show when displaying the page for the first time. Default label is 'Default'" => "Specifies version label to show when displaying the page for the first time. Default label is 'Default'",
"Display a Vimeo video" => "Exibe um vídeo do Vimeo",
"Entire URL to the Vimeo video. Example: http://vimeo.com/3319966" => "Caminho completo para a URL do vídeo no Vimeo. Examplo: http://vimeo.com/3319966",
"Quality of the video" => "Qualidade do vídeo",
"Full screen" => "Tela cheia",
"Expand to full screen" => "Permitir utilizar o modo tela cheia",
"Vote" => "Votar",
// "Create a tracker for voting" => "Create a tracker for voting",
// "Show Stats" => "Show Stats",
// "Choose whether to show the voting results (shown by default)" => "Choose whether to show the voting results (shown by default)",
// "Show Stats After" => "Show Stats After",
// "Choose whether to show the voting results only after the date given in the tracker configuration (not set by default)" => "Choose whether to show the voting results only after the date given in the tracker configuration (not set by default)",
// "Choose whether to display the user name of the creator of the voting tracker (not shown by default)" => "Choose whether to display the user name of the creator of the voting tracker (not shown by default)",
// "Align the plugin on the page, allowing other elements to wrap around it (not set by default)" => "Align the plugin on the page, allowing other elements to wrap around it (not set by default)",
// "Votings" => "Votings",
// "Saves voting information in Smarty variables for display" => "Saves voting information in Smarty variables for display",
// "Object Key" => "Object Key",
// "Object key that is used to record votes" => "Object key that is used to record votes",
// "Return value" => "Return value",
// "Value to display as output of plugin" => "Value to display as output of plugin",
// "Wanted Pages" => "Wanted Pages",
// "Show location of links to pages not yet created" => "Show location of links to pages not yet created",
// "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom). Possible values: a valid regex-expression (PCRE)" => "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom). Possible values: a valid regex-expression (PCRE)",
// "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)" => "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)",
// "a valid regex-expression (PCRE)" => "a valid regex-expression (PCRE)",
// "Split By" => "Split By",
// "The character by which ignored patterns are separated" => "The character by which ignored patterns are separated",
// "Skip Extension" => "Skip Extension",
// "Whether to include external wikis in the list (not included by default)" => "Whether to include external wikis in the list (not included by default)",
// "Collect" => "Collect",
// "Collect either originating (from) or wanted pages (to) in a cell and display them in the second column" => "Collect either originating (from) or wanted pages (to) in a cell and display them in the second column",
"From" => "De",
"To" => "Para",
// "Switch on debug output with details about the items (debug not on by default)" => "Switch on debug output with details about the items (debug not on by default)",
// "Memory Saver" => "Memory Saver",
// "Multiple collected items are separated in distinct table rows (default), or by comma or line break in one cell" => "Multiple collected items are separated in distinct table rows (default), or by comma or line break in one cell",
"Line break" => "Quebra de linha",
// "Separate Row" => "Separate Row",
// "Level" => "Level",
// "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex" => "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex",
// "Custom" => "Custom",
// "Full" => "Full",
// "non-valid custom regex" => "non-valid custom regex",
// ", " => ", ",
"ignored" => "ignorado",
"External Wiki" => "Wiki Externo",
// "dash-WikiWord" => "dash-WikiWord",
// "WikiWord" => "WikiWord",
// "not in level" => "not in level",
"valid" => "válida",
"End of debug output." => "Final da saída de debug.",
"Wanted Page" => "Página desejada",
// "Referenced By Page" => "Referenced By Page",
// "Watershed" => "Watershed",
// "Viewer for UStream Watershed Embed" => "Viewer for UStream Watershed Embed",
// "Specify archive, broadcaster, chat or viewer" => "Specify archive, broadcaster, chat or viewer",
"Archive" => "Arquivo",
// "Broadcaster" => "Broadcaster",
// "Viewer" => "Viewer",
// "Channel code" => "Channel code",
// "Specify the channel code to search in the tracker for a channel to use" => "Specify the channel code to search in the tracker for a channel to use",
// "Brand ID" => "Brand ID",
// "Specify the brand id to search in the tracker for a channel to use" => "Specify the brand id to search in the tracker for a channel to use",
// "Brand prefix" => "Brand prefix",
// "Copy the prefix from the chat embed, e.g. Name-of-Brand-" => "Copy the prefix from the chat embed, e.g. Name-of-Brand-",
// "Video ID" => "Video ID",
// "Video ID of archive which can be found in the tracker" => "Video ID of archive which can be found in the tracker",
// "Locale specified in viewer embed, default is en_US" => "Locale specified in viewer embed, default is en_US",
// "More than one channel found for specified criteria. Please be more specific" => "More than one channel found for specified criteria. Please be more specific",
// "No videoId specified for archive" => "No videoId specified for archive",
// "Web Service" => "Web Service",
// "Display remote information exposed in JSON or YAML" => "Display remote information exposed in JSON or YAML",
// "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter" => "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter",
// "Complete service URL" => "Complete service URL",
// "Registered service name" => "Registered service name",
// "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided" => "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided",
// "Body as Parameter" => "Body as Parameter",
// "Name of the argument to send the body as for services with complex input. Named service required for this to be useful" => "Name of the argument to send the body as for services with complex input. Named service required for this to be useful",
// "Parameters formatted like a query : param1=value1&amp;param2=value2" => "Parameters formatted like a query : param1=value1&amp;param2=value2",
// "Unknown Template" => "Unknown Template",
// "Unknown Service" => "Unknown Service",
// "Permits to have a WYSIWYG section for part of a page" => "Permits to have a WYSIWYG section for part of a page",
// "Minimum width for DIV. Default:500px" => "Minimum width for DIV. Default:500px",
// "Minimum height for DIV. Default:300px" => "Minimum height for DIV. Default:300px",
// "You have unsaved changes in this WYSIWYG section.\nDo you want to save your changes" => "You have unsaved changes in this WYSIWYG section.\nDo you want to save your changes",
"YouTube" => "YouTube",
"Display a YouTube video" => "Exibe um vídeo do YouTube",
"Movie" => "Vídeo",
"Entire URL to the YouTube video or last part (after www.youtube.com/v/ and before the first question mark)" => "URL completa para o vídeo no YouTube ou somente o código identificador do video",
"Quality of the video. Default is high" => "Qualidade do vídeo (padrão: alta)",
"Enlarge video to full screen size" => "Permite usar o modo tela cheia ao assistir o vídeo",
"Related" => "Relacionados",
"Show related videos (shown by default)" => "Exibir vídeos relacionados (padrão: sim)",
"Background" => "Fundo",
"Toolbar background color. Use an HTML color code. Example: ffffff" => "Cor de fundo da barra de ferramentas do vídeo. Utilize uma cor HTML. Por exemplo: ffffff",
// "HTML color code, e.g. ffffff" => "HTML color code, e.g. ffffff",
"Toolbar border colors. Use an HTML color code. Example: ffffff" => "Cor das bordas da barra de ferramentas do vídeo. Utilize uma cor HTML. Por exemplo: ffffff",
"Plugin YouTube error: the movie parameter is empty" => "Erro no plugin YouTube: o parâmetro movie (vídeo) está vazio",
"Missing parameter movie to the Youtube plugin" => "O parâmetro movie (vídeo) é obrigatório para o plugin do Youtube",
// "Zotero Citation" => "Zotero Citation",
// "Retrieves and includes a Zotero reference in the page" => "Retrieves and includes a Zotero reference in the page",
// "Reference Key" => "Reference Key",
// "Unique reference for the group associated to the site. Can be retrieved from the Zotero Bibliography module" => "Unique reference for the group associated to the site. Can be retrieved from the Zotero Bibliography module",
// "Reference Tag" => "Reference Tag",
// "Uses the first result using the specified tag. Useful when the tag mechanism is coerced into creating unique human memorizable keys" => "Uses the first result using the specified tag. Useful when the tag mechanism is coerced into creating unique human memorizable keys",
// "Append a note to the reference for additional information, like page numbers or other sub-references" => "Append a note to the reference for additional information, like page numbers or other sub-references",
// "Zotero Reference List" => "Zotero Reference List",
// "Produces the complete reference list from the Zotero server" => "Produces the complete reference list from the Zotero server",
// "Provide the list of references with a given tag" => "Provide the list of references with a given tag",
// "No results obtained. The Zotero citation server may be down" => "No results obtained. The Zotero citation server may be down",
"ERROR: Either the subject or body must be non-empty" => "ERRO: Ou o assunto ou o corpo tem que ser preenchido",
// "User %s does not have the permission" => "User %s does not have the permission",
// "The message has been sent to" => "The message has been sent to",
// "The message will be sent to" => "The message will be sent to",
"ERROR: No valid users to send the message" => "ERRO: Nenhum destinatário válido para a mensagem",
// "User %s does not want to receive messages" => "User %s does not want to receive messages",
"Invalid user" => "Usuário inválido",
"Sent box is full. Archive or delete some sent messages first if you want to send more messages." => "A caixa de saída esta cheia. Arquive ou delete algumas mensagens antes de enviar novas mensagens.",
// "An error occurred, please check your mail settings and try again" => "An error occurred, please check your mail settings and try again",
"You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'" => "Para poder enviar mensagens, você primeiro precisa habilitar a opção para recebe-las. Nas preferências de usuário habilite 'Permitir mensagens de outros usuários'.",
"User %s can not receive messages, mailbox is full" => "Os usuários %s não podem receber mensagens pois a caixa de entrada deles esta cheia",
"User %s can not receive messages" => "Os usuários %s não podem receber mensagens",
"Invalid user: %s" => "Usuário inválido: %s",
// "Message has been sent to: " => "Message has been sent to: ",
"Archive is full. Delete some messages from archive first." => "O arquivo esta cheio. Delete algumas mensagens antes de arquivar novas.",
"No more messages" => "Nenhuma outra mensagem",
// "ERROR: " => "ERROR: ",
// "ERROR: Invalid tab_id received. Numeric format expected, got %0" => "ERROR: Invalid tab_id received. Numeric format expected, got %0",
// "Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page" => "Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page",
// "Item types filter" => "Item types filter",
// "If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes" => "If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes",
// "Possible item type values" => "Possible item type values",
// "Similar Content" => "Similar Content",
// "Find similar content based on FreeTags" => "Find similar content based on FreeTags",
// "Similar Content Filter" => "Similar Content Filter",
// "Display only similar content of type specified" => "Display only similar content of type specified",
// "Default: \"All Content Type\"" => "Default: \"All Content Type\"",
// "Options: \"article, wiki page, blog post\"" => "Options: \"article, wiki page, blog post\"",
// "Broaden FreeTag Search" => "Broaden FreeTag Search",
// "Find similar content that contains one of the Tags or All of the Tags" => "Find similar content that contains one of the Tags or All of the Tags",
// "Default: \"n - needs to contain all of the Tags\"" => "Default: \"n - needs to contain all of the Tags\"",
// "Options: \"n - Needs to contain All Tags / y - Needs to contain one of the Tags\"" => "Options: \"n - Needs to contain All Tags / y - Needs to contain one of the Tags\"",
// "Google AdSense" => "Google AdSense",
// "Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code" => "Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code",
// "ad_channel" => "ad_channel",
// "Advertisement channel, as optionally provided by Google" => "Advertisement channel, as optionally provided by Google",
// "client" => "client",
// "As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"" => "As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"",
// "display" => "display",
// "Global banner format as provided by Google. For example: \"display=468*60_as\"" => "Global banner format as provided by Google. For example: \"display=468*60_as\"",
// "color_bg" => "color_bg",
// "Background color, as optionally provided by Google" => "Background color, as optionally provided by Google",
// "color_border" => "color_border",
// "Border color, as optionally provided by Google" => "Border color, as optionally provided by Google",
// "color_link" => "color_link",
// "Link color, as optionally provided by Google" => "Link color, as optionally provided by Google",
// "color_text" => "color_text",
// "Text color, as optionally provided by Google" => "Text color, as optionally provided by Google",
// "color_url" => "color_url",
// "URL color, as optionally provided by Google" => "URL color, as optionally provided by Google",
// "Article Archives" => "Article Archives",
// "Shows links to the published articles for each month" => "Shows links to the published articles for each month",
// "If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles" => "If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles",
// "Default: \"n\"" => "Default: \"n\"",
// "If set to a category identifier, only consider the articles in the specified category" => "If set to a category identifier, only consider the articles in the specified category",
// "Example value: 13" => "Example value: 13",
// "Topic filter (by names)" => "Topic filter (by names)",
// "If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered",
// "Topic filter (by identifiers)" => "Topic filter (by identifiers)",
// "If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered",
// "Example values: 13, !13, 1+3, !1+5+7" => "Example values: 13, !13, 1+3, !1+5+7",
// "Types filter" => "Types filter",
// "If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered" => "If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered",
// "Example values: Event, !Event, Event+Review, !Event+Classified+Article" => "Example values: Event, !Event, Event+Review, !Event+Classified+Article",
// "Language filter" => "Language filter",
// "If set to a language code, only consider the articles in the specified language" => "If set to a language code, only consider the articles in the specified language",
"Article Topics" => "Tópicos dos artigos",
// "Lists all article topics with links to their articles" => "Lists all article topics with links to their articles",
// "Lists the specified number of published articles in the specified order" => "Lists the specified number of published articles in the specified order",
// "Show publication time" => "Show publication time",
// "If set to \"y\", article publication times are shown" => "If set to \"y\", article publication times are shown",
// "Show creation time" => "Show creation time",
// "If set to \"y\", article creation times are shown" => "If set to \"y\", article creation times are shown",
// "Show rating selector" => "Show rating selector",
// "If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating" => "If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating",
// "If set, displays an image for each article if one applies, with the given width (in pixels). The article's own image is used, with a fallback to the article's topic image" => "If set, displays an image for each article if one applies, with the given width (in pixels). The article's own image is used, with a fallback to the article's topic image",
// "If set to a category identifier, only lists the articles in the specified category" => "If set to a category identifier, only lists the articles in the specified category",
// "If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed",
// "If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed",
// "If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed" => "If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed",
// "If set to a language code, only lists the articles in the specified language" => "If set to a language code, only lists the articles in the specified language",
// "Specifies how the articles should be sorted" => "Specifies how the articles should be sorted",
// "Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date" => "Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date",
// "If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead" => "If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead",
// "If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles" => "If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles",
"Absolute URL" => "URL absoluta",
// "If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example" => "If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example",
// "If set to 0, will take the topicId of the article if in an article" => "If set to 0, will take the topicId of the article if in an article",
// "Tiki Assistant" => "Tiki Assistant",
// "Display an assistant to guide new Tiki admins" => "Display an assistant to guide new Tiki admins",
// "Babel Fish Links" => "Babel Fish Links",
// "Offers a link to the Yahoo! Babel Fish translation service" => "Offers a link to the Yahoo! Babel Fish translation service",
// "Babel Fish Icon Link" => "Babel Fish Icon Link",
// "Display an icon linked to the Yahoo! Babel Fish translation service" => "Display an icon linked to the Yahoo! Babel Fish translation service",
// "Newest Blog Post Comments" => "Newest Blog Post Comments",
// "Displays the specified number of the blog post comments most recently added" => "Displays the specified number of the blog post comments most recently added",
// "No date" => "No date",
// "If set to \"y\", the date of comments is not displayed in the module box" => "If set to \"y\", the date of comments is not displayed in the module box",
// "Verbose tooltips" => "Verbose tooltips",
// "If set to \"y\", blog post title is only visible as a tooltip and not displayed" => "If set to \"y\", blog post title is only visible as a tooltip and not displayed",
// "Options: \"y,n\"" => "Options: \"y,n\"",
// "Last-Visited Pages" => "Last-Visited Pages",
// "Displays the last Wiki pages visited by the user" => "Displays the last Wiki pages visited by the user",
// "Maximum number of characters in page names allowed before truncating" => "Maximum number of characters in page names allowed before truncating",
// "A hierarchy of where you are. Ex.: Home > Section1 > Subsection C" => "A hierarchy of where you are. Ex.: Home > Section1 > Subsection C",
// "Label preceding the crumbs" => "Label preceding the crumbs",
// "Menu Id" => "Menu Id",
// "Menu to take the crumb trail from" => "Menu to take the crumb trail from",
// "Menu Start Level" => "Menu Start Level",
// "Lowest level of the menu to display" => "Lowest level of the menu to display",
// "Menu Stop Level" => "Menu Stop Level",
// "Highest level of the menu to display" => "Highest level of the menu to display",
// "Show Site Crumb" => "Show Site Crumb",
// "Display the first crumb, usually the site, when using menu crumbs" => "Display the first crumb, usually the site, when using menu crumbs",
// "Show Page Crumb" => "Show Page Crumb",
// "Display the last crumb, usually the page, when using menu crumbs" => "Display the last crumb, usually the page, when using menu crumbs",
// "Show Crumb Links" => "Show Crumb Links",
// "Display links on the crumbs" => "Display links on the crumbs",
// "Includes a calendar or a list of calendar events" => "Includes a calendar or a list of calendar events",
// "Calendars filter" => "Calendars filter",
// "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\"). Example values: \"13\", \"4,7\", \"31:49\". Not set by default" => "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\"). Example values: \"13\", \"4,7\", \"31:49\". Not set by default",
// "Displayed month (relative)" => "Displayed month (relative)",
// "Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span. Example values: 2, 0, -2, -12" => "Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span. Example values: 2, 0, -2, -12",
// "View type" => "View type",
// "Determines how to show events. Possible values: %0, %1" => "Determines how to show events. Possible values: %0, %1",
// "Calendar view type time span" => "Calendar view type time span",
// "If in calendar (or \"table\") view type, determines the time span displayed by the calendar. Possible values: %0, %1, %2, %3 ,%4, %5. A user changing this time span in the calendar can change the time span the module displays for him" => "If in calendar (or \"table\") view type, determines the time span displayed by the calendar. Possible values: %0, %1, %2, %3 ,%4, %5. A user changing this time span in the calendar can change the time span the module displays for him",
// "Show action" => "Show action",
// "Viewmode when clicking on a day" => "Viewmode when clicking on a day",
// "Put a link on all the days , not only those with event" => "Put a link on all the days , not only those with event",
// "View navigation bar" => "View navigation bar",
// "Cart" => "Cart",
// "Displays the content of the cart, allows to modify quantities and proceed to payment" => "Displays the content of the cart, allows to modify quantities and proceed to payment",
// "The quantities in your cart were updated" => "The quantities in your cart were updated",
// "Gift card added" => "Gift card added",
// "Gift card not found" => "Gift card not found",
// "Gift card removed" => "Gift card removed",
// "Displays links to categories as a tree" => "Displays links to categories as a tree",
// "Object type filter" => "Object type filter",
// "Object type filter to apply when accessing a linked category. Example values" => "Object type filter to apply when accessing a linked category. Example values",
// "Deep" => "Deep",
// "Show subcategories objects when accessing a linked category. Possible values: on (default), off" => "Show subcategories objects when accessing a linked category. Possible values: on (default), off",
// "Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don't limit display)" => "Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don't limit display)",
// "Show these categories and their children" => "Show these categories and their children",
// "Show only these categories and the immediate child categories of these in the order the parameter specifies. Example values: 3,5,6" => "Show only these categories and the immediate child categories of these in the order the parameter specifies. Example values: 3,5,6",
// "Category links to a page named as the category" => "Category links to a page named as the category",
// "If y, category links to a page named as the category" => "If y, category links to a page named as the category",
// "Category Transitions" => "Category Transitions",
// "Displays controls to trigger category transitions and change the page's state according to predefined rules" => "Displays controls to trigger category transitions and change the page's state according to predefined rules",
// "Example Transition" => "Example Transition",
// "Change Category" => "Change Category",
// "Enables to categorize an object" => "Enables to categorize an object",
// "This module currently only supports Wiki pages. Some combinations of Multiple categories, Detailed, Unassign and Assign may challenge intuition or be simply broken" => "This module currently only supports Wiki pages. Some combinations of Multiple categories, Detailed, Unassign and Assign may challenge intuition or be simply broken",
// "Category identifier" => "Category identifier",
// "Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier" => "Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier",
// "Note that the root category is not displayed" => "Note that the root category is not displayed",
// "Defaults to 0 (root)" => "Defaults to 0 (root)",
// "No top" => "No top",
// "In non-detailed view, disallow uncategorizing. Example value: 1" => "In non-detailed view, disallow uncategorizing. Example value: 1",
// "Display path" => "Display path",
// "Unless set to \"n\", display relative category paths in the category tree rather than category names" => "Unless set to \"n\", display relative category paths in the category tree rather than category names",
// "Paths are relative to the root category, which is not displayed" => "Paths are relative to the root category, which is not displayed",
// "Multiple categories" => "Multiple categories",
// "If set to \"n\", only allows categorizing in one category (from those displayed)" => "If set to \"n\", only allows categorizing in one category (from those displayed)",
"Categorize" => "Categorização",
// "String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize" => "String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize",
// "Shy" => "Shy",
// "If set to \"y\", the module is not shown on pages which are not already categorized" => "If set to \"y\", the module is not shown on pages which are not already categorized",
// "Detailed" => "Detailed",
// "If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list" => "If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list",
"Unassign" => "Não atribuir mais",
// "If set to \"n\", the detailed list of categories will not offer to unassign a category" => "If set to \"n\", the detailed list of categories will not offer to unassign a category",
// "If set to \"y\", allow to assign new categories" => "If set to \"y\", allow to assign new categories",
// "Example values: y, n" => "Example values: y, n",
// "Default value: y" => "Default value: y",
// "Group filter" => "Group filter",
// "Very particular filter option. If set to \"y\", only categories with a name matching one of the user's groups are shown, and descendants of these matching categories" => "Very particular filter option. If set to \"y\", only categories with a name matching one of the user's groups are shown, and descendants of these matching categories",
// "Default value: n" => "Default value: n",
// "Image URL not in category" => "Image URL not in category",
// "Very particular parameter. If both this and \"Image URL in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category" => "Very particular parameter. If both this and \"Image URL in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category",
// "Image URL in category" => "Image URL in category",
// "Very particular parameter. If both this and \"Image URL not in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category" => "Very particular parameter. If both this and \"Image URL not in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category",
// "Categorize %s" => "Categorize %s",
// "Categorize %s in %s" => "Categorize %s in %s",
"Received Objects" => "Objetos recebidos",
// "Displays the number of pages received (via Communications)" => "Displays the number of pages received (via Communications)",
// "Contributors" => "Contributors",
// "Lists the contributors to the wiki page being viewed and some information on them" => "Lists the contributors to the wiki page being viewed and some information on them",
// "Shows the credits a user has" => "Shows the credits a user has",
// "Newest Directory Sites" => "Newest Directory Sites",
// "Displays the specified number of the directory sites most recently added" => "Displays the specified number of the directory sites most recently added",
// "Directory category identifier" => "Directory category identifier",
// "If set to a directory category identifier, only displays the sites in the specified directory category" => "If set to a directory category identifier, only displays the sites in the specified directory category",
// "If set to \"y\", displays a button labelled \"More\" that links to the directory" => "If set to \"y\", displays a button labelled \"More\" that links to the directory",
"Show description" => "Exibir descrição",
// "If set to \"y\", the description of the directory site appears" => "If set to \"y\", the description of the directory site appears",
// "Maximum length of description" => "Maximum length of description",
// "If desc = \"y\", use maxdesc to set the maximum length of the directory site (in characters). Leave blank to set no maximum (show the entire description)" => "If desc = \"y\", use maxdesc to set the maximum length of the directory site (in characters). Leave blank to set no maximum (show the entire description)",
// "Default: blank" => "Default: blank",
// "Directory Statistics" => "Directory Statistics",
// "Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links" => "Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links",
// "Top Directory Sites" => "Top Directory Sites",
// "Displays the specified number of the directory sites from most visited to least visited" => "Displays the specified number of the directory sites from most visited to least visited",
// "Displays the site's first featured links" => "Displays the site's first featured links",
// "Displays links to file galleries" => "Displays links to file galleries",
// "Top-Rated Topics" => "Top-Rated Topics",
// "Displays the specified number of the forum topics with the best ratings" => "Displays the specified number of the forum topics with the best ratings",
"Newest Forum Posts" => "Últimas mensagens no fórum",
// "Displays the latest forum posts" => "Displays the latest forum posts",
"Topics only" => "Apenas os assuntos",
// "If set to \"y\", only displays topics" => "If set to \"y\", only displays topics",
// "List of forum identifiers" => "List of forum identifiers",
// "If set to a list of forum identifiers, restricts the posts to those in the identified forums. Identifiers are separated by colons (\":\")" => "If set to a list of forum identifiers, restricts the posts to those in the identified forums. Identifiers are separated by colons (\":\")",
// "Show date" => "Show date",
// "If set to \"y\", show post date directly instead of as tooltip" => "If set to \"y\", show post date directly instead of as tooltip",
// "Show time" => "Show time",
// "Show times after dates" => "Show times after dates",
"Show author" => "Mostrar autor",
// "If set to \"y\", show post author directly instead of as tooltip" => "If set to \"y\", show post author directly instead of as tooltip",
"Most Commented Forums" => "Fóruns mais comentados",
// "Display the specified number of the forums with the most comments" => "Display the specified number of the forums with the most comments",
// "Top Visited Forum Topics" => "Top Visited Forum Topics",
// "Display the specified number of the forum topics with the most reads" => "Display the specified number of the forum topics with the most reads",
// "Top Visited Forums" => "Top Visited Forums",
// "Display the specified number of the forums with the most visits" => "Display the specified number of the forums with the most visits",
// "Tags Editor" => "Tags Editor",
// "Shows current freetags and enables to add and remove some if permissions allow" => "Shows current freetags and enables to add and remove some if permissions allow",
// "Wiki Page Tags" => "Wiki Page Tags",
// "Displays current freetags on wiki pages and enables to add tags if permissions allow" => "Displays current freetags on wiki pages and enables to add tags if permissions allow",
// "Similar-Tag Items" => "Similar-Tag Items",
// "Shows content with multiple freetags in common" => "Shows content with multiple freetags in common",
// "Type of objects to extract" => "Type of objects to extract",
// "Similar pages" => "Similar pages",
"Most Popular Tags" => "Palavras-chave mais populares",
// "Shows the most popular freetags. More popularity is indicated by a larger font" => "Shows the most popular freetags. More popularity is indicated by a larger font",
// "Display type" => "Display type",
// "If set to \"cloud\", links are displayed as a cloud" => "If set to \"cloud\", links are displayed as a cloud",
// "Default: \"list\"" => "Default: \"list\"",
// "Maximum elements" => "Maximum elements",
// "If set to a number, limits the number of tags displayed" => "If set to a number, limits the number of tags displayed",
// "My Preferred Tags" => "My Preferred Tags",
// "Displays to registered users the freetags they prefer, based on the number of objects they added the tag to. More preference is indicated by a larger font" => "Displays to registered users the freetags they prefer, based on the number of objects they added the tag to. More preference is indicated by a larger font",
"My preferred tags" => "Minhas tags preferidas",
"Google Search" => "Busca Google",
// "Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site" => "Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site",
// "Groups Emulation" => "Groups Emulation",
// "Enables temporarily changing one's group memberships to see how users in fewer groups experience the site" => "Enables temporarily changing one's group memberships to see how users in fewer groups experience the site",
"Emulate Groups" => "Simular grupo",
"Last Actions" => "Últimas ações",
// "Displays the specified number of last actions" => "Displays the specified number of last actions",
// "Show user" => "Show user",
// "If set to \"y\", user names are displayed in the module box" => "If set to \"y\", user names are displayed in the module box",
// "If set to \"y\", action dates are displayed in the module box" => "If set to \"y\", action dates are displayed in the module box",
// "Maximum number of characters in action descriptions before truncating" => "Maximum number of characters in action descriptions before truncating",
"Newest Blog Posts" => "Últimas mensagens para blogs",
// "Lists the specified number of blogs posts from newest to oldest" => "Lists the specified number of blogs posts from newest to oldest",
// "If set to \"y\", the date of posts is not displayed in the module box" => "If set to \"y\", the date of posts is not displayed in the module box",
// "Blog identifier" => "Blog identifier",
// "If set to a blog identifier, restricts the blog posts to those in the identified blog" => "If set to a blog identifier, restricts the blog posts to those in the identified blog",
// "Newest Category Items" => "Newest Category Items",
// "Lists the specified number of objects of the given type in the given category, starting from the most recently created" => "Lists the specified number of objects of the given type in the given category, starting from the most recently created",
// "Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed" => "Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed",
// "Maximum number of characters in object names allowed before truncating" => "Maximum number of characters in object names allowed before truncating",
// "Type of the objects to list. Example values" => "Type of the objects to list. Example values",
"no object here yet" => "Nenhum objeto aqui",
"Newest Blogs" => "Últimos Blogs Criados",
// "Displays the specified number of blogs from newest to oldest" => "Displays the specified number of blogs from newest to oldest",
"Newest FAQs" => "Últimos FAQs Criados",
// "Displays the specified number of FAQs from newest to oldest" => "Displays the specified number of FAQs from newest to oldest",
"Newest Quizzes" => "Últimos Testes Criados",
// "Displays the specified number of quizzes from newest to oldest" => "Displays the specified number of quizzes from newest to oldest",
// "Last-Modified File Galleries" => "Last-Modified File Galleries",
// "Display the specified number of file galleries, starting from the most recently modified" => "Display the specified number of file galleries, starting from the most recently modified",
"Newest Files" => "Arquivos Recentes",
// "List the specified number of files, starting from the most recently added" => "List the specified number of files, starting from the most recently added",
// "Gallery identifiers" => "Gallery identifiers",
// "If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers" => "If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers",
// "Example value: 13, 2:13, 1:2:3:5:6" => "Example value: 13, 2:13, 1:2:3:5:6",
// "Last-Modified Image Galleries" => "Last-Modified Image Galleries",
// "Displays the specified number of image galleries, starting from the most recently modified" => "Displays the specified number of image galleries, starting from the most recently modified",
"Newest Images" => "Últimas imagens",
// "List the specified number of images, starting from the most recently added" => "List the specified number of images, starting from the most recently added",
// "Gallery identifier" => "Gallery identifier",
// "If set to an image gallery identifier, restricts the images to those in the identified gallery" => "If set to an image gallery identifier, restricts the images to those in the identified gallery",
// "Link content" => "Link content",
// "Display the links as image names or thumbnails" => "Display the links as image names or thumbnails",
// "Possible values: \"names\" or \"thumbnails\". Default value: \"names\"" => "Possible values: \"names\" or \"thumbnails\". Default value: \"names\"",
// "Last-Modified Events" => "Last-Modified Events",
// "Display the specified number of calendar events, starting from the most recently modified" => "Display the specified number of calendar events, starting from the most recently modified",
// "Calendar Identifier" => "Calendar Identifier",
// "If set to a calendar identifier, restricts the events to those in the identified calendar" => "If set to a calendar identifier, restricts the events to those in the identified calendar",
// "Maximum number of characters in event names allowed before truncating" => "Maximum number of characters in event names allowed before truncating",
// "Hide Date" => "Hide Date",
// "If set to \"y\", it will hide date" => "If set to \"y\", it will hide date",
// "List the specified number of pages, starting from the most recently modified" => "List the specified number of pages, starting from the most recently modified",
// "Link Target" => "Link Target",
// "Target URL of the \"...more\" link at the bottom of the module" => "Target URL of the \"...more\" link at the bottom of the module",
"Last-Modified Blogs" => "Últimos blogs modificados",
// "Displays the specified number of blogs, starting from the most recently modified" => "Displays the specified number of blogs, starting from the most recently modified",
// "Newest Podcasts" => "Newest Podcasts",
// "Displays Podcasts" => "Displays Podcasts",
// "File galleries IDs" => "File galleries IDs",
// "List of IDs of file galleries of type \"Podcast (Audio)\". Identifiers are separated by a colon (\":\"). If none, all file galleries will be scanned" => "List of IDs of file galleries of type \"Podcast (Audio)\". Identifiers are separated by a colon (\":\"). If none, all file galleries will be scanned",
"width" => "largura",
// "Width of mediaplayer in pixels" => "Width of mediaplayer in pixels",
"height" => "altura",
// "Height of mediaplayer in pixels" => "Height of mediaplayer in pixels",
// "Path to mp3 player. For instance media/player_mp3_maxi.swf if you downloaded player_mp3_maxi.swf from http://flash-mp3-player.net/players/maxi/download/ to directory media/ (directory needs to be created or you can chose another place)" => "Path to mp3 player. For instance media/player_mp3_maxi.swf if you downloaded player_mp3_maxi.swf from http://flash-mp3-player.net/players/maxi/download/ to directory media/ (directory needs to be created or you can chose another place)",
// "Bottom Link URL" => "Bottom Link URL",
// "URL for a link at bottom of module" => "URL for a link at bottom of module",
// "Bottom Link URL Text" => "Bottom Link URL Text",
// "Text for link if Bottom Link URL is set" => "Text for link if Bottom Link URL is set",
// "More Podcasts" => "More Podcasts",
// "Verbose" => "Verbose",
// "Display description of podcast below player if \"y\", and on title mouseover if \"n\"" => "Display description of podcast below player if \"y\", and on title mouseover if \"n\"",
"Newest Article Submissions" => "Últimos artigos enviados",
// "Lists the specified number of article submissions from newest to oldest" => "Lists the specified number of article submissions from newest to oldest",
"Newest Tracker Comments" => "Novos comentários nos trackers",
// "Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted" => "Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted",
// "Tracker identifier" => "Tracker identifier",
// "If set to a tracker identifier, only displays the comments on the given tracker" => "If set to a tracker identifier, only displays the comments on the given tracker",
// "Item identifier" => "Item identifier",
// "If set to an item identifier, only displays the comments on the given item" => "If set to an item identifier, only displays the comments on the given item",
// "Newest Tracker Items" => "Newest Tracker Items",
// "Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required" => "Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required",
// "Identifier of the tracker from which items are listed" => "Identifier of the tracker from which items are listed",
// "Field identifier" => "Field identifier",
// "Identifier of the field from which values are listed. If Field name is set, this parameter is ignored" => "Identifier of the field from which values are listed. If Field name is set, this parameter is ignored",
// "Field name" => "Field name",
// "Name of the field from which values are listed" => "Name of the field from which values are listed",
// "Example value: age" => "Example value: age",
// "Specifies how the items should be sorted" => "Specifies how the items should be sorted",
// "Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date" => "Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date",
// "Status filter" => "Status filter",
// "If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values" => "If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values",
// "Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set" => "Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set",
// "You do not have permission to view this tracker" => "You do not have permission to view this tracker",
"Last Items" => "Últimos itens",
"Last Modified Items" => "Últimos itens modificados",
// "Newest Validated FAQ Questions" => "Newest Validated FAQ Questions",
// "Displays the specified number of validated questions FAQs from newest to oldest" => "Displays the specified number of validated questions FAQs from newest to oldest",
// "Faq identifier" => "Faq identifier",
// "If set to a faq identifier, restricts the chosen questions to those in the identified faq" => "If set to a faq identifier, restricts the chosen questions to those in the identified faq",
"Last Visitors" => "Últimos visitantes",
// "Displays information about the specified number of users in decreasing order of last login time" => "Displays information about the specified number of users in decreasing order of last login time",
// "Show avatars" => "Show avatars",
// "If set to \"y\", show user avatars" => "If set to \"y\", show user avatars",
// "Maximum number of characters in user names allowed before truncating" => "Maximum number of characters in user names allowed before truncating",
// "Don't show date" => "Don't show date",
// "YouTube Playlist" => "YouTube Playlist",
// "Display a YouTube playlist" => "Display a YouTube playlist",
// "Playlist ID" => "Playlist ID",
// "ID of the YouTube playlist to display (not the complete URL). Example: id=4DE69387D46DA2F6" => "ID of the YouTube playlist to display (not the complete URL). Example: id=4DE69387D46DA2F6",
// "Width of each video in pixels" => "Width of each video in pixels",
// "Height of each video in pixels" => "Height of each video in pixels",
// "Allow FullScreen" => "Allow FullScreen",
// "Bottom Link" => "Bottom Link",
// "Url for a link at bottom of module. Example: link_url=http://www.youtube.com/CouncilofEurope#grid/user/E57D0D93BA3A56C8" => "Url for a link at bottom of module. Example: link_url=http://www.youtube.com/CouncilofEurope#grid/user/E57D0D93BA3A56C8",
// "Bottom Link Text" => "Bottom Link Text",
// "Text for link if link_url is set, otherwise 'More Videos'" => "Text for link if link_url is set, otherwise 'More Videos'",
// "Video Descriptions" => "Video Descriptions",
// "Display description of video on title mouseover if 'y'. Default is 'y'" => "Display description of video on title mouseover if 'y'. Default is 'y'",
// "Order by" => "Order by",
// "Criteria to order by the videos in the list. Default is 'position'" => "Criteria to order by the videos in the list. Default is 'position'",
// "position" => "position",
// "commentCount" => "commentCount",
"duration" => "duração",
// "published" => "published",
// "reversedPosition" => "reversedPosition",
// "title" => "title",
// "viewCount" => "viewCount",
// "No Playlist found" => "No Playlist found",
// "No Playlist ID was provided" => "No Playlist ID was provided",
"Live Support" => "Suporte on-line",
// "Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console" => "Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console",
// "Server Load" => "Server Load",
// "Report of server resources used" => "Report of server resources used",
// "Presents a map with the geolocated content within the page" => "Presents a map with the geolocated content within the page",
// "Log-in box" => "Log-in box",
// "Input size" => "Input size",
// "Number of characters for username and password input fields" => "Number of characters for username and password input fields",
// "Display mode: module, header or popup. Leave empty for module mode" => "Display mode: module, header or popup. Leave empty for module mode",
// "Show Register" => "Show Register",
// "Show the register link" => "Show the register link",
// "Show I Forgot" => "Show I Forgot",
// "Show the \"I forgot my password\" link" => "Show the \"I forgot my password\" link",
// "Show Remember me" => "Show Remember me",
// "Show the \"Remember me\" checkbox" => "Show the \"Remember me\" checkbox",
// "Logo" => "Logo",
// "Site logo, title and subtitle" => "Site logo, title and subtitle",
// "Map Feature Editor" => "Map Feature Editor",
// "Allows to draw shapes over the map" => "Allows to draw shapes over the map",
// "Tracker to store the feature in" => "Tracker to store the feature in",
// "Hidden Input" => "Hidden Input",
// "Hidden values to be sent over to the dialog. fieldName(value)" => "Hidden values to be sent over to the dialog. fieldName(value)",
// "Standard controls" => "Standard controls",
// "Dispay the standard draw controls" => "Dispay the standard draw controls",
// "Layer Selector" => "Layer Selector",
// "Replace the map's built-in layer controls" => "Replace the map's built-in layer controls",
// "Mode Selector" => "Mode Selector",
// "Toggle input modes for the map" => "Toggle input modes for the map",
// "Map location search" => "Map location search",
// "Simple search controls for the map" => "Simple search controls for the map",
"Menu" => "Menu",
// "Displays a menu or a structure as a menu" => "Displays a menu or a structure as a menu",
// "Identifier of a menu (from tiki-admin_menus.php)" => "Identifier of a menu (from tiki-admin_menus.php)",
"Structure" => "Estrutura",
// "Identifier of a structure of wiki pages (name or number from tiki-admin_structures.php)" => "Identifier of a structure of wiki pages (name or number from tiki-admin_structures.php)",
// "Direction for menu: horiz or vert (default vert)" => "Direction for menu: horiz or vert (default vert)",
// "CSS/Superfish" => "CSS/Superfish",
// "Use CSS Superfish menu. y|n (default y)" => "Use CSS Superfish menu. y|n (default y)",
// "DOM #id" => "DOM #id",
// "Id of the menu in the DOM" => "Id of the menu in the DOM",
// "CSS class" => "CSS class",
// "Class of the menu container" => "Class of the menu container",
// "Limit low visibles levels" => "Limit low visibles levels",
// "All the submenus beginning at this level will be displayed if the url matches one of the option of this level or above or below" => "All the submenus beginning at this level will be displayed if the url matches one of the option of this level or above or below",
// "Limit top visible levels" => "Limit top visible levels",
// "Do not display options higher than this level" => "Do not display options higher than this level",
// "Link on Section" => "Link on Section",
// "Create links on menu sections" => "Create links on menu sections",
// "(y/n default y)" => "(y/n default y)",
// "Translate labels" => "Translate labels",
// "Menu Cookie" => "Menu Cookie",
// "Open the menu to show current option if possible" => "Open the menu to show current option if possible",
// "One of these parameters has to be set" => "One of these parameters has to be set",
// "Menu Page" => "Menu Page",
// "Displays a Wiki page" => "Displays a Wiki page",
// "Page to display in the menu. Example value: HomePage" => "Page to display in the menu. Example value: HomePage",
// "Wiki Structure Menu" => "Wiki Structure Menu",
// "Displays a structure" => "Displays a structure",
// "N.B. Deprecated, use the Menu module instead" => "N.B. Deprecated, use the Menu module instead",
// "Structure to display in the menu" => "Structure to display in the menu",
// "Unread Inter-User Messages" => "Unread Inter-User Messages",
// "Displays to users their number of new inter-user messages and a link to their message box" => "Displays to users their number of new inter-user messages and a link to their message box",
// "Show If Empty" => "Show If Empty",
// "Show the module when there are no messages waiting. y|n " => "Show the module when there are no messages waiting. y|n ",
// "Default=y" => "Default=y",
"Messages" => "Mensagens",
// "Small live chat box" => "Small live chat box",
// "Channels" => "Channels",
// "List of chat channels. Channel names are separated by a comma (\",\")" => "List of chat channels. Channel names are separated by a comma (\",\")",
// "By default, a single channel named \"default\" exists" => "By default, a single channel named \"default\" exists",
"Mobile" => "Dispositivos móveis",
// "Currently only shows switch to and from mobile mode" => "Currently only shows switch to and from mobile mode",
// "To Label" => "To Label",
// "Switch to normal site label" => "Switch to normal site label",
// "From Label" => "From Label",
// "Switch to mobile site label" => "Switch to mobile site label",
// "Switch Perspective" => "Switch Perspective",
// "Also switch perspective back to this one when leaving mobile mode" => "Also switch perspective back to this one when leaving mobile mode",
// "Stay" => "Stay",
// "Stay on same page" => "Stay on same page",
// "Switch to mobile site" => "Switch to mobile site",
// "Switch to normal site" => "Switch to normal site",
// "Months Links" => "Months Links",
// "Link to articles or blog posts for the current month and those preceding it" => "Link to articles or blog posts for the current month and those preceding it",
// "Type of objects to link to" => "Type of objects to link to",
// "\"blogs\" for blog posts, \"cms\" for published articles" => "\"blogs\" for blog posts, \"cms\" for published articles",
// "Object Identifier" => "Object Identifier",
// "Identifier of an object with children to link to" => "Identifier of an object with children to link to",
// "This is required for the blog Object type" => "This is required for the blog Object type",
// "For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3" => "For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3",
// "List by month" => "List by month",
// "Most Commented" => "Most Commented",
// "Display the most commented objects of a certain type" => "Display the most commented objects of a certain type",
// "Type of objects to consider" => "Type of objects to consider",
// "Possible values: wiki (Wiki pages), blog (blog posts), article (articles)" => "Possible values: wiki (Wiki pages), blog (blog posts), article (articles)",
// "Language Filter" => "Language Filter",
// "If set to a RFC1766 language tag, restricts the objects considered to those in the specified language" => "If set to a RFC1766 language tag, restricts the objects considered to those in the specified language",
"Pending Article Submissions" => "Artigos Pendentes",
// "Displays the number of article submissions waiting examination and a link to the list" => "Displays the number of article submissions waiting examination and a link to the list",
"Old Articles" => "Artigos antigos",
// "Displays the specified number of old articles (which do not show on articles home page anymore)" => "Displays the specified number of old articles (which do not show on articles home page anymore)",
// "Payments Outstanding" => "Payments Outstanding",
// "Displays the payments outstanding for the current user" => "Displays the payments outstanding for the current user",
// "Enables to change current perspective" => "Enables to change current perspective",
// "Powered By" => "Powered By",
// "Powered by Tiki, and others" => "Powered by Tiki, and others",
// "Shows \"Powered by Tiki Wiki CMS Groupware\" message" => "Shows \"Powered by Tiki Wiki CMS Groupware\" message",
// "Tiki version info" => "Tiki version info",
// "Credits" => "Credits",
// "Shows theme credits (contents of credits.tpl)" => "Shows theme credits (contents of credits.tpl)",
// "Icons" => "Icons",
// "Shows various \"powered by\" icons" => "Shows various \"powered by\" icons",
// "Quick Edit" => "Quick Edit",
// "Enables to quickly create or edit Wiki pages" => "Enables to quickly create or edit Wiki pages",
// "Deprecated - use the Search module instead" => "Deprecated - use the Search module instead",
// "Template identifier" => "Template identifier",
// "If set to a template identifier, the specified template is used for creating new Wiki pages" => "If set to a template identifier, the specified template is used for creating new Wiki pages",
// "If set, send the form to the given location (relative to Tiki's root) for processing" => "If set, send the form to the given location (relative to Tiki's root) for processing",
// "SUBMIT label" => "SUBMIT label",
// "The label on the button to submit the form" => "The label on the button to submit the form",
"Create/Edit" => "Criar/editar",
// "INPUT SIZE" => "INPUT SIZE",
// "Size attribute (horizontal, in characters) of the text input field for page names" => "Size attribute (horizontal, in characters) of the text input field for page names",
// "Optional heading to display at the top of the module's content" => "Optional heading to display at the top of the module's content",
// "Category to preselect" => "Category to preselect",
// "If set, pages created through the module have this category prechecked to be categorized in" => "If set, pages created through the module have this category prechecked to be categorized in",
// "Tip to be shown" => "Tip to be shown",
// "Custom text to be shown as a tip at the top of the edit page" => "Custom text to be shown as a tip at the top of the edit page",
// "Title of tip to be shown" => "Title of tip to be shown",
// "Custom title to be shown for the tip at the top of the edit page" => "Custom title to be shown for the tip at the top of the edit page",
// "Custom header template" => "Custom header template",
// "Wiki page to be used as a template to show content on top of edit page" => "Wiki page to be used as a template to show content on top of edit page",
"Quick Edit a Wiki Page" => "Edição rápida de página Wiki",
// "Quick Search" => "Quick Search",
// "Performs a search query and persists the results in the module for quick navigation access" => "Performs a search query and persists the results in the module for quick navigation access",
// "Filter object type" => "Filter object type",
// "Limit search results to a specific object type. Enter an object type to use a static filter or write \"selector\" to provide an input" => "Limit search results to a specific object type. Enter an object type to use a static filter or write \"selector\" to provide an input",
// "Filter category" => "Filter category",
// "Limit search results to a specific category. Enter the comma separated list of category IDs to include in the selector. Single category will display no controls" => "Limit search results to a specific category. Enter the comma separated list of category IDs to include in the selector. Single category will display no controls",
"Quick Admin" => "Atalhos do admin",
// "Some helpful tools for admins" => "Some helpful tools for admins",
// "Display mode: module or header. Leave empty for module mode" => "Display mode: module or header. Leave empty for module mode",
"Random Image" => "Imagem Aleatória",
// "Displays a random image" => "Displays a random image",
// "If set to an image gallery identifier, restricts the chosen images to those in the identified gallery" => "If set to an image gallery identifier, restricts the chosen images to those in the identified gallery",
// "Show link" => "Show link",
// "If set to \"n\", the image thumbnail does not link to the image" => "If set to \"n\", the image thumbnail does not link to the image",
// "Default: \"y\"" => "Default: \"y\"",
// "Show name" => "Show name",
// "If set to \"y\", the name of the image is displayed" => "If set to \"y\", the name of the image is displayed",
// "If set to \"y\", the description of the image is displayed" => "If set to \"y\", the description of the image is displayed",
"Random Pages" => "Páginas aleatórias",
// "Displays the specified number of random wiki pages" => "Displays the specified number of random wiki pages",
// "New User Registration" => "New User Registration",
// "Permit anonymous visitors to create an account on the site" => "Permit anonymous visitors to create an account on the site",
// "News Feeds" => "News Feeds",
// "List of feeds available on this site" => "List of feeds available on this site",
// "Multi-purpose search module (go or edit page by name and/or search site)" => "Multi-purpose search module (go or edit page by name and/or search site)",
// "Legacy Mode" => "Legacy Mode",
// "Setting to emulate previous behaviour" => "Setting to emulate previous behaviour",
// "If set to \"y\" the search performed is a \"Tiki search\"" => "If set to \"y\" the search performed is a \"Tiki search\"",
// " (full text search)" => " (full text search)",
// "Show Object Type Filter" => "Show Object Type Filter",
// "If set to \"y\" shows a dropdown of sections to search" => "If set to \"y\" shows a dropdown of sections to search",
// " (no object filter)" => " (no object filter)",
// "Use autocomplete" => "Use autocomplete",
// "If set to \"y\" input uses autocomplete for pagenames if applicable" => "If set to \"y\" input uses autocomplete for pagenames if applicable",
// " (use autocomplete)" => " (use autocomplete)",
"Advanced search" => "Busca avançada",
// "Use advanced (boolean) search (full text search only)" => "Use advanced (boolean) search (full text search only)",
// " (use advanced search)" => " (use advanced search)",
// "Advanced search checkbox" => "Advanced search checkbox",
// "Show advanced search checkbox (full text search only)" => "Show advanced search checkbox (full text search only)",
// " (advanced search checkbox off)" => " (advanced search checkbox off)",
// "Advanced search help" => "Advanced search help",
// "Show advanced search help icon (full text search only)" => "Show advanced search help icon (full text search only)",
// " (advanced search help off)" => " (advanced search help off)",
// "Show Search Button" => "Show Search Button",
// "Show search button" => "Show search button",
// " (do show search button)" => " (do show search button)",
// "Show Go Button" => "Show Go Button",
// "Show go to page button" => "Show go to page button",
// " (do show go button)" => " (do show go button)",
// "Show Edit Button" => "Show Edit Button",
// "Show edit button" => "Show edit button",
// " (do show edit button)" => " (do show edit button)",
// "Default Button" => "Default Button",
// "Action to perform on entering <return>" => "Action to perform on entering <return>",
// " (search|go|edit)" => " (search|go|edit)",
// "Search Form Action" => "Search Form Action",
// " tiki-searchresults.php or tiki-searchindex.php (for Tiki search)" => " tiki-searchresults.php or tiki-searchindex.php (for Tiki search)",
// "Edit Submit Label" => "Edit Submit Label",
// "Go Form Action" => "Go Form Action",
"Go" => "Ir",
// "Edit Form Action" => "Edit Form Action",
// "Input field width" => "Input field width",
// "Width of the text input field (in characters)" => "Width of the text input field (in characters)",
// " 0 (leave automatic width)" => " 0 (leave automatic width)",
// "Select size" => "Select size",
// "Size of the Search Filter dropdown list" => "Size of the Search Filter dropdown list",
// "Edit Template identifier" => "Edit Template identifier",
// "If set to a category identifier, pages created through the module are automatically categorized in the specified category" => "If set to a category identifier, pages created through the module are automatically categorized in the specified category",
// "Compact mode" => "Compact mode",
// "Makes the three buttons only appear on mouse-over" => "Makes the three buttons only appear on mouse-over",
"Search is disabled" => "A busca não está habilitada",
"Titles" => "Títulos",
// "Search for Wiki Page" => "Search for Wiki Page",
// "Search Box" => "Search Box",
// "Small search form for wiki, articles, blogs, etc" => "Small search form for wiki, articles, blogs, etc",
// "If set to \"y\", the search performed is a \"Tiki search\". Default: \"n\" (full text search)" => "If set to \"y\", the search performed is a \"Tiki search\". Default: \"n\" (full text search)",
// "Search For a Wiki Page" => "Search For a Wiki Page",
// "Search for a wiki page by name" => "Search for a wiki page by name",
// "Exact match checkbox checked by default if set to \"y\"" => "Exact match checkbox checked by default if set to \"y\"",
// "Semantic Links" => "Semantic Links",
// "List the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from" => "List the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from",
// "Links for sharing, reporting etc" => "Links for sharing, reporting etc",
// "Report to Webmaster" => "Report to Webmaster",
"Share this page" => "Compartilhar esta página",
// "Use icons for report, share and email links" => "Use icons for report, share and email links",
// "Facebook" => "Facebook",
// "Show Facebook \"Like\" button on the current page" => "Show Facebook \"Like\" button on the current page",
// "Facebook: URL" => "Facebook: URL",
// "URL to \"Like\" (leave blank for current URL)" => "URL to \"Like\" (leave blank for current URL)",
// "Facebook: Send" => "Facebook: Send",
// "Show Facebook \"Send\" button" => "Show Facebook \"Send\" button",
// "Facebook: Layout" => "Facebook: Layout",
// "Size, layout and amount of social context" => "Size, layout and amount of social context",
// "Facebook: Width" => "Facebook: Width",
// "Facebook: Height" => "Facebook: Height",
// "Container height in CSS units (e.g. \"120px\" or \"2em\")" => "Container height in CSS units (e.g. \"120px\" or \"2em\")",
// "Facebook: Show Faces" => "Facebook: Show Faces",
// "Show pictures of others who like this" => "Show pictures of others who like this",
// "Facebook: Verb" => "Facebook: Verb",
// "Verb to display in button" => "Verb to display in button",
// "Facebook: Colors" => "Facebook: Colors",
// "Color scheme" => "Color scheme",
// "Facebook: Font" => "Facebook: Font",
// "Font to display" => "Font to display",
// "Facebook: Locale" => "Facebook: Locale",
// "Locale in the format ll_CC (default \"en_US\")" => "Locale in the format ll_CC (default \"en_US\")",
// "Facebook: Referrals" => "Facebook: Referrals",
// "Label for tracking referrals (optional)" => "Label for tracking referrals (optional)",
// "Facebook: App Id" => "Facebook: App Id",
// "ID of your Facebook app (optional)" => "ID of your Facebook app (optional)",
// "Show Twitter Follow Button on the current page" => "Show Twitter Follow Button on the current page",
// "Twitter: User Name" => "Twitter: User Name",
// "Twitter user name to quote as \"via\"" => "Twitter user name to quote as \"via\"",
// "Twitter: Label" => "Twitter: Label",
// "Text to display. Default \"Tweet\"" => "Text to display. Default \"Tweet\"",
// "Twitter: URL" => "Twitter: URL",
// "URL to \"Tweet\" (leave blank for current URL)" => "URL to \"Tweet\" (leave blank for current URL)",
// "Twitter: Show Count" => "Twitter: Show Count",
// "Position of Tweet count" => "Position of Tweet count",
// "Twitter: Language" => "Twitter: Language",
// "Two letter language code" => "Two letter language code",
// "Twitter: Width" => "Twitter: Width",
// "Width in pixels or percentage (e.g. 300px)" => "Width in pixels or percentage (e.g. 300px)",
// "Twitter: Height" => "Twitter: Height",
// "Twitter: Text" => "Twitter: Text",
// "Tweet text (leave empty to use page title" => "Tweet text (leave empty to use page title",
// "LinkedIn" => "LinkedIn",
// "Linked in share button" => "Linked in share button",
// "LinkedIn: URL" => "LinkedIn: URL",
// "URL to share (leave blank for current URL)" => "URL to share (leave blank for current URL)",
// "LinkedIn: Count Mode" => "LinkedIn: Count Mode",
// "Position of count" => "Position of count",
// "Google +1" => "Google +1",
// "Google +1 button" => "Google +1 button",
// "Google: Size" => "Google: Size",
// "Google button size" => "Google button size",
// "Google: Annotation" => "Google: Annotation",
// "Google annotation" => "Google annotation",
// "Google: Language" => "Google: Language",
// "Google language" => "Google language",
// "Google: URL" => "Google: URL",
// "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows to send messages" => "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows to send messages",
// "If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content" => "If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content",
// "Label on the button to post a message" => "Label on the button to post a message",
// "Wait label" => "Wait label",
// "Label on the button to post a message when the message is being posted if AJAX is enabled" => "Label on the button to post a message when the message is being posted if AJAX is enabled",
// "Please wait.." => "Please wait..",
// "Maximum messages shown" => "Maximum messages shown",
// "Number of messages to display" => "Number of messages to display",
// "Tweet" => "Tweet",
// "If set to \"1\" and the user has authorized us to tweet messages with Twitter, the user can decide, if he wants to shout via Twitter" => "If set to \"1\" and the user has authorized us to tweet messages with Twitter, the user can decide, if he wants to shout via Twitter",
// "If set to \"1\" and the user has authorized us with Facebook, the user can decide, if he wants to add the shout to his Facebook wall" => "If set to \"1\" and the user has authorized us with Facebook, the user can decide, if he wants to add the shout to his Facebook wall",
// "Since Last Visit (Simple)" => "Since Last Visit (Simple)",
// "Displays to logged in users the number of new or updated objects since their last login date and time" => "Displays to logged in users the number of new or updated objects since their last login date and time",
"Since your last visit" => "Desde sua última visita",
// "Since Last Visit" => "Since Last Visit",
// "Displays to logged in users new or updated objects since a point in time, by default their last login date and time" => "Displays to logged in users new or updated objects since a point in time, by default their last login date and time",
// "Show users" => "Show users",
// "If set to \"n\", do not show new users" => "If set to \"n\", do not show new users",
// "Show trackers" => "Show trackers",
// "If set to \"n\", do not show tracker changes" => "If set to \"n\", do not show tracker changes",
// "Calendar focus" => "Calendar focus",
// "Unless set to \"ignore\", the module changes the reference point in time from the user's last login date and time to a day where users browse to using the calendar" => "Unless set to \"ignore\", the module changes the reference point in time from the user's last login date and time to a day where users browse to using the calendar",
// "Show date as a calendar link" => "Show date as a calendar link",
// "If set to \"n\", do not add a link to tiki calendar on the date in the header (even if feature calendar is set)" => "If set to \"n\", do not add a link to tiki calendar on the date in the header (even if feature calendar is set)",
// "Fold sections by default" => "Fold sections by default",
// "If set to \"y\", fold automatically sections and show only the title (user has to click on each section in order to see the details of modifications)" => "If set to \"y\", fold automatically sections and show only the title (user has to click on each section in order to see the details of modifications)",
// "Use jQuery presentation" => "Use jQuery presentation",
// "If set to \"y\", use jQuery to show the result" => "If set to \"y\", use jQuery to show the result",
// "Minimum timespan" => "Minimum timespan",
// "Instead of the last login time, go back this minimum time, specified in days, in case the last login time is more recent" => "Instead of the last login time, go back this minimum time, specified in days, in case the last login time is more recent",
"Changes since" => "Mudanças desde",
"Since your last visit..." => "Desde a sua última visita",
// "In the last %0 days.." => "In the last %0 days..",
"new comments" => "novos comentários",
" (archived)" => " (arquivado)",
"new posts" => "novas mensagens",
"wiki pages changed" => "páginas Wiki alteradas",
"new articles" => "Novos Artigos",
"new FAQs" => "novos FAQs",
"new blogs" => "novos blogs",
"new blog posts" => "Novos postagens nos blogs",
"new image galleries" => "Nova galeria de imagens",
"new images" => "novas imagens",
"new file galleries" => "Novas galerias de arquivos",
"new files" => "novos arquivos",
"new polls" => "nova enquete",
"new users" => "novos usuários",
"new tracker items" => "novos itens de formulário",
// "updated tracker items" => "updated tracker items",
// "SVN Up Info" => "SVN Up Info",
// "SVN Version and last update information" => "SVN Version and last update information",
// "Switch Language" => "Switch Language",
// "Displays a language picker to change the language of the site" => "Displays a language picker to change the language of the site",
// "Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist" => "Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist",
// "Switch Theme" => "Switch Theme",
// "Enables to quickly change the theme" => "Enables to quickly change the theme",
// "Terminology" => "Terminology",
// "Support for multilingual terminology" => "Support for multilingual terminology",
// "Root category" => "Root category",
// "All terms will automatically be put in that category. " => "All terms will automatically be put in that category. ",
// "Note that the category must already exist. " => "Note that the category must already exist. ",
// "Defaults to 'Term'" => "Defaults to 'Term'",
// "Tiki Tests" => "Tiki Tests",
// "Tiki test suite helper" => "Tiki test suite helper",
"Most Active blogs" => "Blogs mais ativos",
// "Displays the specified number of blogs with links to them, from the most active one to the least" => "Displays the specified number of blogs with links to them, from the most active one to the least",
// "Blog activity measurement can be more or less accurate" => "Blog activity measurement can be more or less accurate",
// "Lists the specified number of articles with links to them, from the most visited one to the least" => "Lists the specified number of articles with links to them, from the most visited one to the least",
"Top File Galleries" => "Galerias de Arquivos mais visitadas",
// "Displays the specified number of file galleries with links to them, starting with the one with most hits" => "Displays the specified number of file galleries with links to them, starting with the one with most hits",
// "Top Files" => "Top Files",
// "Displays the specified number of files with links to them, starting with the one with most hits" => "Displays the specified number of files with links to them, starting with the one with most hits",
"Top Forum Posters" => "Usuários mais ativos no fórum",
// "Displays the specified number of users who posted to forums, starting with the one having most posts" => "Displays the specified number of users who posted to forums, starting with the one having most posts",
// "Top Image Galleries" => "Top Image Galleries",
// "Displays the specified number of image galleries with links to them, starting with the one with most hits" => "Displays the specified number of image galleries with links to them, starting with the one with most hits",
"Top Images" => "Imagens mais populares",
// "Displays the specified number of images with links to them, from the most visited one to the least" => "Displays the specified number of images with links to them, from the most visited one to the least",
"Top Objects" => "Objetos mais vistos",
// "Displays the specified number of objects, starting with the one having the most hits" => "Displays the specified number of objects, starting with the one having the most hits",
"Top Pages" => "Páginas mais visitadas",
// "Displays the specified number of wiki pages with links to them, starting with the one having the most hits" => "Displays the specified number of wiki pages with links to them, starting with the one having the most hits",
"Top Quizzes" => "Testes mais visitados",
// "Displays the specified number of quizzes with links to them, starting with the one having the most hits" => "Displays the specified number of quizzes with links to them, starting with the one having the most hits",
"Top Visited Blogs" => "Blogs mais visitados",
// "Display the specified number of blogs with links to them, from the most visited one to the least" => "Display the specified number of blogs with links to them, from the most visited one to the least",
// "Show Last Post" => "Show Last Post",
// "Top Visited FAQs" => "Top Visited FAQs",
// "Display the specified number of FAQs with links to them, from the most visited one to the least" => "Display the specified number of FAQs with links to them, from the most visited one to the least",
// "Tracker Input" => "Tracker Input",
// "Allows to open a dialog to create new tracker items" => "Allows to open a dialog to create new tracker items",
// "Tracker ID to render" => "Tracker ID to render",
// "Text Input" => "Text Input",
// "Multiple text fields to display as part of the main form along with the label. Field names map to the permanent names in the tracker field definitions. ex: groupName(Group Name) relatedTask(Task)" => "Multiple text fields to display as part of the main form along with the label. Field names map to the permanent names in the tracker field definitions. ex: groupName(Group Name) relatedTask(Task)",
// "Location Field" => "Location Field",
// "Obtain the coordinates from a nearby map and send them to the location field. In addition to the field name, :marker or :viewport can be used as the suffix. Default is :marker" => "Obtain the coordinates from a nearby map and send them to the location field. In addition to the field name, :marker or :viewport can be used as the suffix. Default is :marker",
// "Capture StreetView" => "Capture StreetView",
// "Include a button on the StreetView interface to create tracker items from the location. Requires upload image from URL and location parameter" => "Include a button on the StreetView interface to create tracker items from the location. Requires upload image from URL and location parameter",
// "Alter the submit button label" => "Alter the submit button label",
// "Operation to perform on success" => "Operation to perform on success",
// "Operation to perform in the following format: operationName(argument). Current operations are redirect with the URL template as the argument. @valueName@ will be replaced by the appropriate value where valueName is itemId, status or a permanent name" => "Operation to perform in the following format: operationName(argument). Current operations are redirect with the URL template as the argument. @valueName@ will be replaced by the appropriate value where valueName is itemId, status or a permanent name",
"Create" => "Criar",
// "Tracker Help" => "Tracker Help",
// "Display the fields of a tracker (name and identifier)" => "Display the fields of a tracker (name and identifier)",
// "Text field height" => "Text field height",
"Number of lines" => "Número de linhas",
// "Text field width" => "Text field width",
// "Number of characters" => "Number of characters",
// "Translate Updates" => "Translate Updates",
// "Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed" => "Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed",
// "Reference language" => "Reference language",
// "If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed" => "If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed",
// "Show language" => "Show language",
// "If \"y\" the page language will be shown instead of the page name" => "If \"y\" the page language will be shown instead of the page name",
// "Default = \"y\"" => "Default = \"y\"",
// "Lists the specified number of calendar events, ordered by their start date" => "Lists the specified number of calendar events, ordered by their start date",
// "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")" => "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")",
// "Maximum days in the future" => "Maximum days in the future",
// "Maximum distance to event start dates in days (looking forward)" => "Maximum distance to event start dates in days (looking forward)",
// "Maximum days in the past" => "Maximum days in the past",
// "Maximum distance to event end dates in days (looking backward)" => "Maximum distance to event end dates in days (looking backward)",
// "cellpadding" => "cellpadding",
// "If set to an integer, apply this cellpadding to the HTML table generated" => "If set to an integer, apply this cellpadding to the HTML table generated",
// "cellspacing" => "cellspacing",
// "If set to an integer, apply this cellspacing to the HTML table generated" => "If set to an integer, apply this cellspacing to the HTML table generated",
// "If set to \"y\", event descriptions are displayed" => "If set to \"y\", event descriptions are displayed",
// "Show end date and time" => "Show end date and time",
// "If set to \"y\", event end dates and times are displayed, when appropriate" => "If set to \"y\", event end dates and times are displayed, when appropriate",
// "Use custom calendar background colors" => "Use custom calendar background colors",
// "If set to \"y\", events are displayed with their calendar's custom background color (if one is set)" => "If set to \"y\", events are displayed with their calendar's custom background color (if one is set)",
// "Show information in tooltips" => "Show information in tooltips",
// "If set to \"n\", event tooltips will not display event information" => "If set to \"n\", event tooltips will not display event information",
// "Date format" => "Date format",
// "Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>" => "Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>",
// "site preference for short date format followed by site preference for short time format" => "site preference for short date format followed by site preference for short time format",
// "If set to an integer, event names are allowed that number of characters as a maximum before being truncated" => "If set to an integer, event names are allowed that number of characters as a maximum before being truncated",
// "My Blogs" => "My Blogs",
// "Displays to registered users their blogs" => "Displays to registered users their blogs",
// "Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed" => "Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed",
// "My Image Galleries" => "My Image Galleries",
// "Displays to registered users their image galleries" => "Displays to registered users their image galleries",
"User Pages" => "Páginas de Usuários",
// "Displays to registered users the specified number of wiki pages which they were the last to edit" => "Displays to registered users the specified number of wiki pages which they were the last to edit",
"My Pages" => "Minhas Páginas",
"My Tasks" => "Tarefas do usuário",
// "Lightweight interface to user tasks, enabling to view them concisely and do some manipulations" => "Lightweight interface to user tasks, enabling to view them concisely and do some manipulations",
"The task title must have at least 3 characters" => "O título da tarefa deve conter pelo menos 3 caracteres",
"Public Tasks" => "Tarefas públicas",
// "Lists the public user tasks of a chosen group, with links to tasks" => "Lists the public user tasks of a chosen group, with links to tasks",
// "User-Group Tracker" => "User-Group Tracker",
// "User and Group tracker links" => "User and Group tracker links",
// "My Score" => "My Score",
// "Display the logged user's rank and score" => "Display the logged user's rank and score",
"Most Active Users" => "Usuários mais ativos",
// "Display the specified number of users and their score, starting from the one with the highest score" => "Display the specified number of users and their score, starting from the one with the highest score",
// "Webmail Inbox" => "Webmail Inbox",
// "Displays Webmail Inbox" => "Displays Webmail Inbox",
// "Account Id" => "Account Id",
// "Webmail account identifier (if not set uses user's current account)" => "Webmail account identifier (if not set uses user's current account)",
// "GroupMail: Group (e.g. \"Help Team\")" => "GroupMail: Group (e.g. \"Help Team\")",
// "GroupMail: Tracker Id (to store GroupMail activity)" => "GroupMail: Tracker Id (to store GroupMail activity)",
// "GroupMail: From Field (Id of field in tracker to store email From header)" => "GroupMail: From Field (Id of field in tracker to store email From header)",
// "GroupMail: Subject Field (Id of field in tracker to store email Subject header)" => "GroupMail: Subject Field (Id of field in tracker to store email Subject header)",
// "GroupMail: Message Field (Id of field in tracker to store email message identifier)" => "GroupMail: Message Field (Id of field in tracker to store email message identifier)",
// "GroupMail: Content Field (Id of field in tracker to store email message body content)" => "GroupMail: Content Field (Id of field in tracker to store email message body content)",
// "GroupMail: Account Field (Id of field in tracker to store Webmail account name)" => "GroupMail: Account Field (Id of field in tracker to store Webmail account name)",
// "DateTime Field Id" => "DateTime Field Id",
// "GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)" => "GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)",
// "GroupMail: Operator Field (Id of field in tracker to store operator name (username))" => "GroupMail: Operator Field (Id of field in tracker to store operator name (username))",
// "Maximum number of characters in subjects allowed before truncating" => "Maximum number of characters in subjects allowed before truncating",
// "Webmail error" => "Webmail error",
// "No accounts set up (or no current account set)" => "No accounts set up (or no current account set)",
// "Related Items" => "Related Items",
// "Lists objects which share a category with the viewed object" => "Lists objects which share a category with the viewed object",
// "Online Users" => "Online Users",
// "Display information about users currently logged in" => "Display information about users currently logged in",
// "List Type" => "List Type",
// "Display the number of users logged in, the list of users logged in, or both" => "Display the number of users logged in, the list of users logged in, or both",
// "Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"" => "Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"",
// "Cluster Mode" => "Cluster Mode",
// "If set to \"1\", separate users based on which host/server they logged on" => "If set to \"1\", separate users based on which host/server they logged on",
// "Newest Comments" => "Newest Comments",
// "Lists the specified number of comments starting from the most recently posted" => "Lists the specified number of comments starting from the most recently posted",
// "More in tooltips" => "More in tooltips",
// "If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item's tooltip" => "If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item's tooltip",
// "Type of the objects from which comments will be listed. Possible values" => "Type of the objects from which comments will be listed. Possible values",
// "Comments about objects in this language only" => "Comments about objects in this language only",
// "Last article comments" => "Last article comments",
"Last wiki comments" => "Últimos comentários no wiki",
// "Displays YouTube videos and/or a link to a YouTube user's page" => "Displays YouTube videos and/or a link to a YouTube user's page",
// "Video identifiers" => "Video identifiers",
// "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")" => "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")",
// "YouTube user identifier" => "YouTube user identifier",
// "If set to a YouTube user identifier, display a link to the videos of this user" => "If set to a YouTube user identifier, display a link to the videos of this user",
// "Videos on YouTube" => "Videos on YouTube",
// "Bibliography Search" => "Bibliography Search",
// "Search the group's Zotero library for entries with the specified tags" => "Search the group's Zotero library for entries with the specified tags",
// "Invalid server key" => "Invalid server key",
"Invalid username or password" => "Usuário ou senha inválidos",
// "Cookie not found" => "Cookie not found",
// "Select <a href=\"tiki-list_banners.php\" title=\"Banners\">Admin &gt; Banners</a> from the menu to create and edit banner zones" => "Select <a href=\"tiki-list_banners.php\" title=\"Banners\">Admin &gt; Banners</a> from the menu to create and edit banner zones",
"Cancel Edit" => "Cancelar edição",
"Change preferences" => "Alterar preferências",
// "Activate the feature" => "Activate the feature",
"Plugins" => "Plugins",
"Site Ads and Banners" => "Publicidade e banners do site",
// "<strong>Activate</strong> will display content for Admin only. Select <strong>Publish</strong> to display for all users" => "<strong>Activate</strong> will display content for Admin only. Select <strong>Publish</strong> to display for all users",
"Settings" => "Configurações",
// "Areas Overview" => "Areas Overview",
// "Nothing was updated" => "Nothing was updated",
// "Edit perspective" => "Edit perspective",
// "No category found in area" => "No category found in area",
// "Hint" => "Hint",
// "This tab shows you an overview of categories affected by the areas feature. The category with the smallest id should be the category set as areas root in the settings tab. If not so, update this overview with the button below" => "This tab shows you an overview of categories affected by the areas feature. The category with the smallest id should be the category set as areas root in the settings tab. If not so, update this overview with the button below",
// "Update areas" => "Update areas",
// "How to setup" => "How to setup",
// "You have to enable the perspective and the categories feature. Then set a structure of categories with a common parent. Set that parent as areas root in the settings tab. Then go to " => "You have to enable the perspective and the categories feature. Then set a structure of categories with a common parent. Set that parent as areas root in the settings tab. Then go to ",
// "perspectives" => "perspectives",
// "There you can create a set of perspectives to bind the children of areas root to. Change for every perspective you want the category jail to another child. It is designed that every child category is bind to one perspective only. If you do otherwise, the first found perspective is used" => "There you can create a set of perspectives to bind the children of areas root to. Change for every perspective you want the category jail to another child. It is designed that every child category is bind to one perspective only. If you do otherwise, the first found perspective is used",
"Look under \"Articles\" on the application menu for links to" => "Procure em \"Articles\" no menu de aplicações por links para",
"Admin topics" => "Administrar tópicos",
"Admin types" => "Administrar tipos",
"General Settings" => "Configurações Gerais",
"Features" => "Recursos",
// "Article properties" => "Article properties",
// "Default maximum dimensions of custom images" => "Default maximum dimensions of custom images",
// "General (view mode)" => "General (view mode)",
"List mode" => "Modo de lista",
// "Sharing on social networks" => "Sharing on social networks",
"Import CSV file" => "Importar arquivo CSV",
"Batch upload (CSV file):" => "Upload em lote (arquivo CSV):",
// "File format: title,authorName,heading,body,lang,user" => "File format: title,authorName,heading,body,lang,user",
"Import" => "Importar",
"Articles Listing" => "Listagem de artigos",
"List Articles" => "Listar Artigos",
// "Select which items to display when listing articles" => "Select which items to display when listing articles",
// "Article View" => "Article View",
"To add/remove blogs, go to \"Create/Edit Blog\" under \"Blogs\" on the application menu, or" => "Para adicionar/remover blogs, va para \"Create/Edit Blog\" em \"Blogs\" no menu de aplicações, ou",
"Click Here" => "Clique aqui",
"Comments" => "Comentários",
// "Blogs Listings" => "Blogs Listings",
// "Select which items to display when listing blogs" => "Select which items to display when listing blogs",
"To add/remove calendars, look for \"Calendar\" under \"Admin\" on the application menu, or" => "Para adicionar/remover calendários, vá em \"Calendário\" em \"Administrar\" no menu principal, ou",
"Change settings" => "Alterar configurações",
// "General settings" => "General settings",
// "Default calendars to display" => "Default calendars to display",
// "All calendars" => "All calendars",
// "A subset of available calendars" => "A subset of available calendars",
// "Create calendar" => "Create calendar",
// "Year selection is valid when the JS Calendar <strong>is not</strong> enabled" => "Year selection is valid when the JS Calendar <strong>is not</strong> enabled",
"Browse categories" => "Navegar nas categorias",
// "Administer categories" => "Administer categories",
// "Organize Objects" => "Organize Objects",
"Feedback" => "Feedback",
// "Category objects" => "Category objects",
// "Re-apply the last saved category defaults to the wiki pages" => "Re-apply the last saved category defaults to the wiki pages",
// "List comments" => "List comments",
"General Preferences" => "Preferências gerais",
// "Site-wide features" => "Site-wide features",
// "Display options" => "Display options",
"Permission" => "Permissão",
// "Inline comments" => "Inline comments",
// "The feature below must be activated for this feature to work" => "The feature below must be activated for this feature to work",
// "Using comments in various features" => "Using comments in various features",
"Admin Groups" => "Administrar grupos",
"Admin Users" => "Administrar usuários",
"Manage permissions" => "Gerenciar permissões",
// "User features" => "User features",
"Community" => "Comunidade",
// "Default user preferences" => "Default user preferences",
// "Users Default Preferences" => "Users Default Preferences",
// "User messages" => "User messages",
"My Tiki" => "Meu Tiki",
// "Select which items to display when listing users" => "Select which items to display when listing users",
// "Join the community" => "Join the community",
// "Tiki Wiki CMS Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU" => "Tiki Wiki CMS Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU",
// "Join the Community" => "Join the Community",
// "Tiki news" => "Tiki news",
// "Embedded RSS feed from info.tiki.org TODO, meanwhile" => "Embedded RSS feed from info.tiki.org TODO, meanwhile",
// "Tiki Newsletter" => "Tiki Newsletter",
// "Promote your site" => "Promote your site",
// "Add your site to the Tiki diretory" => "Add your site to the Tiki diretory",
// "Submit your site" => "Submit your site",
// "Spread the word" => "Spread the word",
// "Add the \"Powered by\" module to your site. " => "Add the \"Powered by\" module to your site. ",
// "Manage Modules" => "Manage Modules",
// "Help improve Tiki" => "Help improve Tiki",
// "Submit a feature request or bug report" => "Submit a feature request or bug report",
// "Click here to go to our development site" => "Click here to go to our development site",
// "Make a financial contribution to the Tiki Association" => "Make a financial contribution to the Tiki Association",
// "Contribute to Tiki" => "Contribute to Tiki",
// "New Feature" => "New Feature",
// "Please note: Experimental - work in progress" => "Please note: Experimental - work in progress",
// "Tiki Connect is a way to let the Tiki project know how it is being used, and which parts people like or would like fixing (or explaining)" => "Tiki Connect is a way to let the Tiki project know how it is being used, and which parts people like or would like fixing (or explaining)",
// "When you click the \"Send Info\" below you will be connected with mother.tiki.org, which is where the data will be collected" => "When you click the \"Send Info\" below you will be connected with mother.tiki.org, which is where the data will be collected",
// "You can also send feedback about Tiki by checking the \"Feedback\" checkbox above. Icons will appear next to all the preferences where you can \"like\", request a \"fix\" or ask \"what's this for?\"" => "You can also send feedback about Tiki by checking the \"Feedback\" checkbox above. Icons will appear next to all the preferences where you can \"like\", request a \"fix\" or ask \"what's this for?\"",
// "Your votes are sent when you connect with mother.tiki.org (currently only be clicking the \"Send Info\" button)" => "Your votes are sent when you connect with mother.tiki.org (currently only be clicking the \"Send Info\" button)",
// "For more info" => "For more info",
// "Send Info" => "Send Info",
// "Send the data" => "Send the data",
// "Preview info" => "Preview info",
// "See what is going to be sent" => "See what is going to be sent",
// "Fill form" => "Fill form",
// "Fill this form in based on other preferences" => "Fill this form in based on other preferences",
// "Site Title is required" => "Site Title is required",
// "Advanced settings" => "Advanced settings",
// "Exposed to assist testing and development" => "Exposed to assist testing and development",
// "Connections received" => "Connections received",
// "Recent connections" => "Recent connections",
// "Rebuild Index" => "Rebuild Index",
// "Rebuild received connections index" => "Rebuild received connections index",
// "<strong>Server stats:</strong> %0 reports received from %1 Tikis" => "<strong>Server stats:</strong> %0 reports received from %1 Tikis",
// "Copyright allows to determine a copyright for all the objects of tiki" => "Copyright allows to determine a copyright for all the objects of tiki",
// "Enable copyright management for" => "Enable copyright management for",
"To configure your directory, find \"Admin Directory\" under \"Directory\" on the application menu, or" => "Para configurar o seu diretório, procure \"Admin Directory\" em \"Directory\" no menu de aplicações, ou",
"To add/remove FAQs, look for \"Admin FAQs\" under \"FAQs\" on the application menu, or" => "Para adicionar/remover FAQs, procure por \"Admin FAQs\" em \"FAQs\" no menu de aplicações, ou",
"Please see the <a class='rbox-link' target='tikihelp' href='http://doc.tiki.org/Features'>evaluation of each feature</a> on Tiki's developer site" => "Por favor veja a <a class='rbox-link' target='tikihelp' href='http://doc.tiki.org/Features'>availação de cada recurso</a> no site de documentação do Tiki",
"Apply" => "Aplicar",
"Global features" => "Recursos globais",
"Main feature" => "Recursos principais",
"Additional" => "Adicional",
// "Interaction with online services or other software" => "Interaction with online services or other software",
// "Configuration completed" => "Configuration completed",
// "Authenticate with Zotero" => "Authenticate with Zotero",
"Watches" => "Notificações",
"Interface" => "Interface",
"jQuery plugins and add-ons" => "jQuery plugins e add-ons",
// "Mobile Themes" => "Mobile Themes",
"Programmer" => "Programador",
// "Logging and Reporting" => "Logging and Reporting",
"Visible to admin only" => "Visível apenas para administradores",
"Include Smarty notices" => "Incluir mensagens do Smarty",
// "Custom Code" => "Custom Code",
// "Event Hooks" => "Event Hooks",
// "Please note that this is a relatively new feature that still needs to be deployed all around. Expect more events to be added over time" => "Please note that this is a relatively new feature that still needs to be deployed all around. Expect more events to be added over time",
// "If you need to add behaviors to Tiki, there are several event hooks you can attach to. Here are the events and the inheritance" => "If you need to add behaviors to Tiki, there are several event hooks you can attach to. Here are the events and the inheritance",
// "Draw Event Diagram" => "Draw Event Diagram",
"To create or remove file galleries, select" => "Para criar ou remover galerias de arquivos, selecione",
"from the application menu" => "no menu principal",
"If you decide to store files in a directory you must ensure that the user cannot access directly to the directory." => "Se você decidir guardar arquivos em um diretório precisa ter certeza de que os usuários não conseguem acessam diretamente o diretório escolhido.",
"You have two options to accomplish this:<br /><ul><li>Use a directory outside your document root, make sure your php script can read and write to that directory</li><li>Use a directory inside the document root and use .htaccess to prevent the user from listing the directory contents</li></ul>" => "Você tem duas opções:<br /><ul><li>Usar um diretório fora do documento root, para isso verifique se o seu script php pode ler e escrever nesse diretório</li><li>Usar um diretório dentro do documento root e usar .htaccess para prevenir que os usuários possam listar o conteúdo do diretório</li></ul>",
"To configure the directory path use UNIX like paths for example files/ or c:/foo/files or /www/files/" => "Para configurar o diretório do patch use patchs do UNIX, por exemplo files/ ou c:/foo/files ou /www/files/",
"Move files from database to directory" => "Mover arquivos da base de dados para o sistema de arquivos",
"Move files from directory to database" => "Mover arquivos do sistema de arquivos para a base de dados",
// "Manage comment settings" => "Manage comment settings",
// "You are highly recommended to use a file directory as the File Gallery storage, when using this feature" => "You are highly recommended to use a file directory as the File Gallery storage, when using this feature",
// "A cron job must be set up in order to delete the files" => "A cron job must be set up in order to delete the files",
// "Update mime of all non archived octet-stream files" => "Update mime of all non archived octet-stream files",
"Quota" => "Quota",
"Used" => "Usado",
"Upload Regex" => "Expressão regular para o envio de arquivos",
"Gallery Listings" => "Listagem das galerias",
"Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries" => "Mudar essas opções <em>não</em> vai afetar galerias de arquivos já existentes. As mudanças serão aplicadas <em>apenas</em> nas galerias de arquivos novas",
"Select which items to display when listing galleries: " => "Selecione quais campos mostrar na listagem de uma galeria: ",
// "Admin Gallery Listings" => "Admin Gallery Listings",
// "Select which items to display when admin galleries: " => "Select which items to display when admin galleries: ",
"Search Indexing" => "Indexação da busca",
"Handlers" => "Handlers",
"Add custom handlers to make your files &quot;searchable&quot; content" => "Adicione handlers customizados para permitir busca dentro do conteúdo dos arquivos",
"Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command" => "Use <strong>%1</strong> como o nome do arquivo. Por exemplo, use <strong>strings %1</strong> para converter o documento para texto, usando o comando Unix <strong>strings</strong>",
"To delete a handler, leave the <strong>System Command</strong> field blank" => "Para deletar um handler, deixe o campo <strong>Comando do sistema</strong> em branco",
// "Tiki is pre-configured to handle many common types. If any of those are listed here, it is because the command line tool is unavailable" => "Tiki is pre-configured to handle many common types. If any of those are listed here, it is because the command line tool is unavailable",
// "Missing Handlers" => "Missing Handlers",
"MIME Type" => "Tipo MIME",
"System Command" => "Comando do sistema",
"Reindex all files for search" => "Reindexar todos os arquivos para busca",
// "SCORM" => "SCORM",
"To add/remove forums, look for \"Admin forums\" under \"Forums\" on the application menu, or" => "Para adicionar/remover forums, procure por \"Admin forums\" em \"Forums\" no menu de aplicações, ou",
// "Threads" => "Threads",
"Searches" => "Buscar",
// "Forums Listing" => "Forums Listing",
// "Select which items to display when listing forums" => "Select which items to display when listing forums",
// "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>" => "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>",
// "Random tag cloud colors" => "Random tag cloud colors",
// "Separate colors with a comma (,)" => "Separate colors with a comma (,)",
// "Alphanumeric ASCII characters only" => "Alphanumeric ASCII characters only",
// "No accents or special characters" => "No accents or special characters",
// "Accept all characters" => "Accept all characters",
// "Tag Management" => "Tag Management",
"Cleanup unused tags" => "Deletar tags não utilizadas",
// "3D Tag Browser Configuration" => "3D Tag Browser Configuration",
"General" => "Geral",
// "Graph appearance" => "Graph appearance",
"Camera settings" => "Configurações da câmera",
// "Physics engine" => "Physics engine",
"To add/remove image galleries, go to \"Image Galleries\" on the application menu, or" => "Para adicionar/remover galerias, vá para \"Acervo de imagens\" no menu de aplicações, ou",
"You can upload images of a size of " => "Você pode fazer upload de imagens nesse tamanho ",
"Alter the php.ini variables file_uploads, upload_max_filesize, post_max_size and database variables (max_allowed_packet for mysql) to change this value" => "Altere as variáveis file_uploads, upload_max_filesize, post_max_size e database variables (max_allowed_packet no mysql) para mudar os valores no arquivo php.ini",
"Home Gallery" => "Página inicial das Galerias",
"Galleries features" => "Recursos das Galerias",
"Comments:" => "Comentários:",
"Uses Slideshow" => "Usar Slideshow",
"Use database to store images" => "Utilizar banco de dados para armazenar imagens",
"Use a directory to store images" => "Utilizar um diretório para armazenar imagens",
"Directory path" => "Caminho do diretório",
// "Note: if you change this directory, you have to move the contents to the new directory. You can also use the 'Mover' below" => "Note: if you change this directory, you have to move the contents to the new directory. You can also use the 'Mover' below",
"Library to use for processing images" => "Biblioteca para processamento de imagens",
"Uploaded image names must match regex" => "Imagens carregadas devem seguir a expressão regular",
"Uploaded image names cannot match regex" => "Imagens carregadas não podem seguir a expressão regular",
"Directory Batch Loading" => "Carregar diretórios em lote",
"If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload images in that dir, either by scp, ftp, or other protocols" => "Se você ativar a opção para carregar diretórios em lote, é necessário configurar um diretório onde seu servidor web possa ler (de preferência fora do seu espaço web). Também é necessário configurar uma forma para fazer o upload de imagens para aquele diretório, isso pode ser por scp, ftp, ou de outras formas",
"Enable directory batch loading" => "Habilitar a função de carregar diretórios em lote",
"Batch loading directory" => "Diretório carregado em lote",
"Display image information in a mouseover box" => "Mostrar informações da imagem no mouseover",
"yes, and don't display that information under the image" => "sim, e também mostrar as informações abaixo da imagem",
// "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)" => "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)",
"Max Rows per page" => "Máximo de linhas por página",
"Images per row" => "Imagens por linha",
"Thumbnails size X" => "Largura das miniaturas",
// "Pixels Default" => "Pixels Default",
"Thumbnails size Y" => "Altura das miniaturas",
// "Default scale size" => "Default scale size",
"pixels" => "pixels",
"Set features" => "Definir recursos",
"Exterminator" => "Exterminador",
"Remove images in the system gallery not being used in Wiki pages, articles or blog posts" => "Remover da galeria do sistema imagens que não estão sendo usados ou páginas Wiki, artigos ou mensagens de Blog",
"Remove" => "Remover",
// "Mover" => "Mover",
"Move images from database storage to filesystem storage" => "Mover imagens da base dados para um diretório no sistema de arquivos",
"Move images from filesystem storage to database storage" => "Mover imagens de um diretório no sistema de arquivos para a banco de dados",
"All galleries" => "Todas as galerias",
"System Gallery" => "Galeria do sistema",
"Move" => "Mover",
"Move images from old filesystem store to new directory" => "Mover imagens de um diretório antigo para um novo diretório no sistema de arquivos",
"Moved" => "Movido",
"Gallery listing configuration" => "Configuração da listagem de galeria",
"Change configuration" => "Alterar configuração",
"Image galleries comments settings" => "Configurações de comentários para galerias de imagens",
"Default number of comments per page:" => "Número padrão de comentários por página:",
// "Server Fitness" => "Server Fitness",
"Release Check" => "Verificar novas versões",
"Last update from SVN" => "Última atualização do SVN",
"Reset or upgrade your database" => "Reinstale ou atualize a base de dados",
"Check for updates now" => "Buscar por atualizações agora",
"Site Identity" => "Identidade do site",
// "Go to <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look & Feel</strong></a> section for additional site related customization preferences" => "Go to <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look & Feel</strong></a> section for additional site related customization preferences",
// "These values will be stored in plain text in the database" => "These values will be stored in plain text in the database",
// "Email to send a test mail" => "Email to send a test mail",
// "Sessions" => "Sessions",
// "Advanced configuration warning" => "Advanced configuration warning",
// "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects" => "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects",
// "Changing this feature will immediately log you out when you save this preference" => "Changing this feature will immediately log you out when you save this preference",
"Enable now" => "Habilite agora",
"Contact" => "Contato",
// "Miscellaneous" => "Miscellaneous",
"Menus" => "Menus",
// "Create and edit menus " => "Create and edit menus ",
"Home Page" => "Página Principal",
// "Redirects" => "Redirects",
// "Site Access" => "Site Access",
"Sample:" => "Exemplo:",
"Date and Time Format Help" => "Auxílio para formatos de data e hora",
"Change admin password" => "Alterar a senha de admin",
// "Change the <strong>Admin</strong> password" => "Change the <strong>Admin</strong> password",
// "User administration" => "User administration",
"To use Google Maps, you must generate a Google Maps API Key for your web site. See <a href=\"http://code.google.com/intl/fr/apis/maps/signup.html\">http://code.google.com/intl/fr/apis/maps/signup.html</a> for details." => "Para usar o Google Maps, você deve gerar uma chave da API do Google Maps para o seu site. Veja <a href=\"http://code.google.com/intl/fr/apis/maps/signup.html\">http://code.google.com/intl/fr/apis/maps/signup.html</a> para mais detalhes.",
"Defaults" => "Padrões",
// "Map mode in listings" => "Map mode in listings",
"Internationalization" => "Internacionalização",
// "Babelfish links" => "Babelfish links",
// "Customized String Translation" => "Customized String Translation",
// "Syntax error" => "Syntax error",
// "Cannot open/write this file" => "Cannot open/write this file",
// "Custom translation will not be saved. Ask your administration to change the permission" => "Custom translation will not be saved. Ask your administration to change the permission",
"ok" => "ok",
// "The file has been saved" => "The file has been saved",
"Translation" => "Tradução",
// "Intertiki client" => "Intertiki client",
// "Tiki Unique key" => "Tiki Unique key",
// "InterTiki Slave mode" => "InterTiki Slave mode",
"Warning: overrides manually registered local users" => "Alerta: sobrescreve usuários locais criados manualmente",
// "as master" => "as master",
"Import user preferences" => "Importar preferências do usuários",
"Import user groups" => "Importar grupos de usuários",
// "Limit group import (comma-separated list of imported groups, leave empty to avoid limitation)" => "Limit group import (comma-separated list of imported groups, leave empty to avoid limitation)",
// "Intertiki shared cookie for sliding auth under same domain" => "Intertiki shared cookie for sliding auth under same domain",
// "InterTiki Server" => "InterTiki Server",
"host" => "servidor",
"port" => "porta",
"Add new server" => "Adicionar novos servidores",
// "Intertiki server" => "Intertiki server",
// "Intertiki Server enabled" => "Intertiki Server enabled",
// "Access Log file" => "Access Log file",
// "Errors Log file" => "Errors Log file",
// "Known hosts" => "Known hosts",
"Key" => "Chave",
"IP" => "IP",
"New:" => "Novo:",
"Enable/disable Tiki features in " => "Habilitar/desabilitar recursos do Tiki em ",
", but configure them elsewhere" => ", mas configure em outro lugar",
"Registration" => "Inscrição",
"Log in" => "Entrar",
// "Generate a passcode" => "Generate a passcode",
// "Requires PHP GD library" => "Requires PHP GD library",
// "Users can select a group to join at registration" => "Users can select a group to join at registration",
// "By default, new users automatically join the Registered group" => "By default, new users automatically join the Registered group",
// "Store passwords in plain text is activated. You should never set this unless you know what you are doing" => "Store passwords in plain text is activated. You should never set this unless you know what you are doing",
// "Assign users to group function of email pattern" => "Assign users to group function of email pattern",
// "You must change the Authentication Method to LDAP for these changes to take effect" => "You must change the Authentication Method to LDAP for these changes to take effect",
// "LDAP Bind settings" => "LDAP Bind settings",
// "LDAP User" => "LDAP User",
// "LDAP Admin" => "LDAP Admin",
// "LDAP external groups" => "LDAP external groups",
// "LDAP Group" => "LDAP Group",
// "LDAP Group Member - if group membership can be found in group attributes" => "LDAP Group Member - if group membership can be found in group attributes",
// "LDAP User Group - if group membership can be found in user attributes" => "LDAP User Group - if group membership can be found in user attributes",
// "PAM" => "PAM",
// "You must change the Authentication Method to PAM for these changes to take effect" => "You must change the Authentication Method to PAM for these changes to take effect",
// "Shibboleth Authentication " => "Shibboleth Authentication ",
// "You must change the Authentication Method to Shibboleth for these changes to take effect" => "You must change the Authentication Method to Shibboleth for these changes to take effect",
// "CAS" => "CAS",
// "You must change the Authentication Method to CAS for these changes to take effect" => "You must change the Authentication Method to CAS for these changes to take effect",
// "CAS Server" => "CAS Server",
// "CAS Server Name" => "CAS Server Name",
// "CAS Server Port" => "CAS Server Port",
// "CAS Server Path" => "CAS Server Path",
// "phpBB User Database Authentication " => "phpBB User Database Authentication ",
// "You must change the Authentication Method to phpBB for these changes to take effect" => "You must change the Authentication Method to phpBB for these changes to take effect",
// "You must turn Users can register off for phpBB Authentication to function properly" => "You must turn Users can register off for phpBB Authentication to function properly",
// "MySql only (for now)" => "MySql only (for now)",
// "Web Server Authentication " => "Web Server Authentication ",
// "You must change the Authentication Method to Web Server for these changes to take effect" => "You must change the Authentication Method to Web Server for these changes to take effect",
// "Theme Screenshot" => "Theme Screenshot",
// "The \"users can change theme\" feature will override the theme displayed" => "The \"users can change theme\" feature will override the theme displayed",
// "Theme not saved yet - click \"Apply\"" => "Theme not saved yet - click \"Apply\"",
"Restrict available themes" => "Restringir temas disponíveis",
"General Layout" => "Layout do site",
// "&quot;Modules&quot; are the items of content at the top &amp; bottom and in the right &amp; left columns of the site" => "&quot;Modules&quot; are the items of content at the top &amp; bottom and in the right &amp; left columns of the site",
// "Admin &gt; Modules" => "Admin &gt; Modules",
// "from the menu to create and edit modules" => "from the menu to create and edit modules",
// "Module zone visibility" => "Module zone visibility",
// "Site Report Bar" => "Site Report Bar",
// "Pagination" => "Pagination",
// "UI Effects" => "UI Effects",
// "Standard UI effects" => "Standard UI effects",
// "Tab UI effects" => "Tab UI effects",
// "Customization" => "Customization",
// "Open editor" => "Open editor",
// "Preview Theme" => "Preview Theme",
// "Custom Codes" => "Custom Codes",
// "Experimental: CSS assistant (work in progress - click the x to remove)" => "Experimental: CSS assistant (work in progress - click the x to remove)",
"Editing" => "Editando",
// "View Templates" => "View Templates",
"Admin layout per section" => "Administrar layout por sessão",
// "Favicon" => "Favicon",
// "Context Menus" => "Context Menus",
// "Currently used in File Galleries only" => "Currently used in File Galleries only",
// "Separators" => "Separators",
// "MapServer settings" => "MapServer settings",
"Generate User Map" => "Gerar mapa do usuário",
// "See also" => "See also",
// "Search Engine Friendly URLs" => "Search Engine Friendly URLs",
// "Meta tags" => "Meta tags",
// "Geo URL" => "Geo URL",
"Robots" => "Robôs",
// "Configure metrics" => "Configure metrics",
// "Show past results" => "Show past results",
// "Past results count" => "Past results count",
// "{\$crumbs[\$crumb]->description}" => "{\$crumbs[\$crumb]->description}",
// "If you lose your login module, use tiki-login_scr.php to be able to login" => "If you lose your login module, use tiki-login_scr.php to be able to login",
// "Payments" => "Payments",
// "Choose payment system" => "Choose payment system",
"You can use only one payment method: PayPal or Cclite or Tiki User Credits" => "Você pode usar apenas um método de pagamento: Papypal ou Cclite ou Créditos de Usuário do Tiki",
"PayPal is working at the moment. See PayPal.com" => "PayPal está funcionando no momento. Veja PayPal.com",
"Cclite: Community currency accounting for local exchange trading systems (LETS). See " => "Cclite: Sistemas contábil de trocas em moeda local para comunidades (LETS). Veja",
// "sourceforge.net" => "sourceforge.net",
"Tiki User Credits: Requires this other feature to be configured" => "Créditos de usuários do Tiki: Requer que outros recursos sejam configurados",
// "Cclite is for creating and managing alternative or complementary trading currencies and groups" => "Cclite is for creating and managing alternative or complementary trading currencies and groups",
// "Work in progress since Tiki 6" => "Work in progress since Tiki 6",
// "Advanced Shopping Cart" => "Advanced Shopping Cart",
// "Advanced Cart Tracker Names Setup" => "Advanced Cart Tracker Names Setup",
// "Products Tracker Setup" => "Products Tracker Setup",
// "Depending on which feature you are using, you may need some or all of the following fields to be setup" => "Depending on which feature you are using, you may need some or all of the following fields to be setup",
// "Shipping" => "Shipping",
// "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Performance page</a> on Tiki's developer site" => "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Performance page</a> on Tiki's developer site",
// "Performance" => "Performance",
// "Output compression is active" => "Output compression is active",
// "Compression is handled by" => "Compression is handled by",
// "Bytecode Cache" => "Bytecode Cache",
// "Using <strong>%0</strong>.These stats affect all PHP applications running on the server" => "Using <strong>%0</strong>.These stats affect all PHP applications running on the server",
// "Configuration setting <em>xcache.admin.enable_auth</em> prevents from accessing statistics. This will also prevent the cache from being cleared when clearing template cache" => "Configuration setting <em>xcache.admin.enable_auth</em> prevents from accessing statistics. This will also prevent the cache from being cleared when clearing template cache",
// "Available" => "Available",
"Memory" => "Memoria",
// "Miss" => "Miss",
// "Hit" => "Hit",
// "Cache Hits" => "Cache Hits",
// "Memory Used" => "Memory Used",
// "Misses" => "Misses",
// "Few hits recorded. Statistics may not be representative" => "Few hits recorded. Statistics may not be representative",
// "Low hit ratio. %0 may be misconfigured and not used" => "Low hit ratio. %0 may be misconfigured and not used",
// "Little memory available. Thrashing likely to occur" => "Little memory available. Thrashing likely to occur",
// "The values to increase are apc.shm_size (for APC) or xcache.size (for XCache)" => "The values to increase are apc.shm_size (for APC) or xcache.size (for XCache)",
// "Small amount of memory allocated to %0. Verify the configuration" => "Small amount of memory allocated to %0. Verify the configuration",
// "Configuration <em>%0</em> is enabled. Disabling modification checks can improve performance, but will require manual clear on file updates" => "Configuration <em>%0</em> is enabled. Disabling modification checks can improve performance, but will require manual clear on file updates",
// "<em>%0</em> should not be disabled due to authentication on XCache" => "<em>%0</em> should not be disabled due to authentication on XCache",
// "Bytecode cache is not used. Using a bytecode cache (APC, XCache, WinCache) is highly recommended for production environments" => "Bytecode cache is not used. Using a bytecode cache (APC, XCache, WinCache) is highly recommended for production environments",
// "Major slow down" => "Major slow down",
// "These are reported to slow down Tiki. If you have a high-volume site, you may want to deactivate them" => "These are reported to slow down Tiki. If you have a high-volume site, you may want to deactivate them",
// "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\">Search admin panel</a>" => "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\">Search admin panel</a>",
"To add/remove polls, look for \"Polls\" under \"Admin\" on the application menu, or" => "Para adicionar/remover enquetes, procure por \"Polls\" em \"Admin\" no menu de aplicações, ou",
// "Loading profile" => "Loading profile",
// "Are you sure you want to apply the profile" => "Are you sure you want to apply the profile",
// "Are you sure you want to re-apply the profile" => "Are you sure you want to re-apply the profile",
// "Sending" => "Sending",
"Waiting" => "Esperando",
// "Tiki Configuration Profiles" => "Tiki Configuration Profiles",
"The following list of changes has been applied" => "Veja abaixo a lista de alterações",
// "Apply Profiles" => "Apply Profiles",
// "Configure Tiki in 3 easy steps using Profiles" => "Configure Tiki in 3 easy steps using Profiles",
// "A Friendly Warning" => "A Friendly Warning",
// "Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles" => "Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles",
"Profiles" => "Perfis",
// "Step 1: Use the Quick or Manual Filter option to see a list of Configuration Profiles you can apply" => "Step 1: Use the Quick or Manual Filter option to see a list of Configuration Profiles you can apply",
// "Option 1: Quick Filter" => "Option 1: Quick Filter",
// "Option 2: Manual Filter" => "Option 2: Manual Filter",
// "Featured Profiles is a list of applications that are maintained by the Tiki community and are a great way to get started" => "Featured Profiles is a list of applications that are maintained by the Tiki community and are a great way to get started",
// "Full Profiles" => "Full Profiles",
// "Full Profiles are full featured out of the box solutions" => "Full Profiles are full featured out of the box solutions",
// "Mini Profiles" => "Mini Profiles",
// "Mini Profiles will configure specific features and are a great way to add more functionality to an existing configuration" => "Mini Profiles will configure specific features and are a great way to add more functionality to an existing configuration",
// "Learning Profiles" => "Learning Profiles",
// "Learning Profiles will allow you to quickly evaluate specific features in Tiki" => "Learning Profiles will allow you to quickly evaluate specific features in Tiki",
// "Filter the list of profiles" => "Filter the list of profiles",
// "Profile name" => "Profile name",
// "Profile types" => "Profile types",
"Repository" => "Repositório",
// "Step 2: Click on a Configuration Profile Name below to review it and to be able to apply it on your Web site" => "Step 2: Click on a Configuration Profile Name below to review it and to be able to apply it on your Web site",
// "Profile type" => "Profile type",
// "applied" => "applied",
// "Profile repository" => "Profile repository",
"Last update" => "Última atualização",
"Refresh" => "Atualizar",
// "JavaScript must be turned <strong>ON</strong> in order to apply Profiles. Please enable your JavaScript and try again" => "JavaScript must be turned <strong>ON</strong> in order to apply Profiles. Please enable your JavaScript and try again",
// "Export YAML" => "Export YAML",
"Modules" => "Módulos",
// "Export modified preferences as YAML" => "Export modified preferences as YAML",
// "Toggle Visible" => "Toggle Visible",
// "Show added preferences" => "Show added preferences",
// "no default" => "no default",
// "Repositories" => "Repositories",
// "Profile tester" => "Profile tester",
// "Paste or type wiki markup and YAML (with or without the {literal}{CODE}{/literal} tags) into the text area below" => "Paste or type wiki markup and YAML (with or without the {literal}{CODE}{/literal} tags) into the text area below",
// "This will run the profile and make potentially unrecoverable changes in your database" => "This will run the profile and make potentially unrecoverable changes in your database",
// "Test Profile Name" => "Test Profile Name",
// "Global configuration" => "Global configuration",
// "Cache duration" => "Cache duration",
"Create New" => "Criar nova",
// "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use the <strong>Admin</strong> &gt; <strong>External Feeds</strong> menu option, or" => "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use the <strong>Admin</strong> &gt; <strong>External Feeds</strong> menu option, or",
// "External feeds" => "External feeds",
// "Feeds" => "Feeds",
"Feed for articles" => "Feed para artigos",
"Feed for blogs" => "Feed para os blogs",
// "Feed for individual blogs" => "Feed for individual blogs",
"Feed for image galleries" => "Feed para as galerias de imagens",
// "Feed for individual image galleries" => "Feed for individual image galleries",
"Feed for file galleries" => "Feed para as galerias de arquivos",
// "Feed for individual file galleries" => "Feed for individual file galleries",
// "Feed for wiki pages (with diff)" => "Feed for wiki pages (with diff)",
// "Feed for wiki pages (no diff)" => "Feed for wiki pages (no diff)",
// "Feed for forums" => "Feed for forums",
// "Feed for individual forums" => "Feed for individual forums",
// "Feed for trackers" => "Feed for trackers",
// "Feed for calendars" => "Feed for calendars",
"Feed for directories" => "Fonte para os diretórios",
// "Feed for shoutbox" => "Feed for shoutbox",
"You can see users rank by score in the module users_rank, for that go to" => "Você pode ver o ranking dos usuários no módulo users_rank, para isso procure por",
"Admin modules" => "Administrar módulos",
"Expiration" => "Expiração",
// "{\$events[e].category}" => "{\$events[e].category}",
// "{\$events[e].description}" => "{\$events[e].description}",
// "can be seen on page" => "can be seen on page",
// "in Admin menu" => "in Admin menu",
// "Also see the Search Indexing tab here" => "Also see the Search Indexing tab here",
// "File Gallery admin panel" => "File Gallery admin panel",
// "Basic Search" => "Basic Search",
// "Advanced Search" => "Advanced Search",
// "Search Engine Settings" => "Search Engine Settings",
// "Index maintenance" => "Index maintenance",
// "Optimize" => "Optimize",
// "From the command line" => "From the command line",
// "Log rebuild" => "Log rebuild",
// "Log file is saved as temp/Search_Indexer.log" => "Log file is saved as temp/Search_Indexer.log",
// "Indexation" => "Indexation",
// "Queue size" => "Queue size",
"Process" => "Processo",
// "Uses JavaScript to reload this page until queue is processed" => "Uses JavaScript to reload this page until queue is processed",
// "Forum searches" => "Forum searches",
// "Search Results" => "Search Results",
// "Select the items to display on the search results page" => "Select the items to display on the search results page",
// "Select the information to display for each result" => "Select the information to display for each result",
// "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Security'>Security page</a> on Tiki's developer site" => "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Security'>Security page</a> on Tiki's developer site",
// "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings" => "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings",
// "General Security" => "General Security",
"Please also see" => "Por favor, veja também",
// "HTTPS (SSL) and other login preferences" => "HTTPS (SSL) and other login preferences",
// "CSRF Security" => "CSRF Security",
// "Use these options to protect against cross-site request forgeries (CSRF)" => "Use these options to protect against cross-site request forgeries (CSRF)",
// "Spam protection" => "Spam protection",
"Search results" => "Resultados da busca",
// "Tokens" => "Tokens",
// "To manage tokens go to <a href=\"tiki-admin_tokens.php\">Admin Tokens</a> page" => "To manage tokens go to <a href=\"tiki-admin_tokens.php\">Admin Tokens</a> page",
// "Clipperz online password management" => "Clipperz online password management",
// "Tiki doesn't offer a built-in password management feature" => "Tiki doesn't offer a built-in password management feature",
// "Learn more about Clipperz" => "Learn more about Clipperz",
// "Meta-tags" => "Meta-tags",
// "SEFURL requires the <strong>URL Rewrite module</strong> for IIS. You do not seem to have this module installed" => "SEFURL requires the <strong>URL Rewrite module</strong> for IIS. You do not seem to have this module installed",
// "Please see <a href=\"http://doc.tiki.org/Windows+Server+Install\">Windows Server Install</a> on tiki.org for more information" => "Please see <a href=\"http://doc.tiki.org/Windows+Server+Install\">Windows Server Install</a> on tiki.org for more information",
// "SEFURL will not work unless Tiki specific directives are deployed to the %0 file" => "SEFURL will not work unless Tiki specific directives are deployed to the %0 file",
// "To enable this file, simply copy the %0 file (located in the main directory of your Tiki installation) to %1" => "To enable this file, simply copy the %0 file (located in the main directory of your Tiki installation) to %1",
// "If you need to keep an existing (non Tiki) %0 file, just add Tiki directives to it" => "If you need to keep an existing (non Tiki) %0 file, just add Tiki directives to it",
// "When you upgrade Tiki (e.g. from version 7 to version 8), make sure to make use of the new URL rewriting configuration file" => "When you upgrade Tiki (e.g. from version 7 to version 8), make sure to make use of the new URL rewriting configuration file",
// "%0 file is missing" => "%0 file is missing",
// "Unable to verify that your URL rewriting configuration is up to date" => "Unable to verify that your URL rewriting configuration is up to date",
// "SEFURL may not work completely or correctly if Tiki URL rewriting configuration is not current" => "SEFURL may not work completely or correctly if Tiki URL rewriting configuration is not current",
// "%0 is not in the expected format" => "%0 is not in the expected format",
// "%0 may simply be outdated" => "%0 may simply be outdated",
// "To update this file, if it was not customized, copy the %0 file (located in the main directory of your Tiki installation) to %1, overwriting the latter" => "To update this file, if it was not customized, copy the %0 file (located in the main directory of your Tiki installation) to %1, overwriting the latter",
// "%0 file is out of date" => "%0 file is out of date",
// "The RewriteBase directive seems not to be set up correctly. This is required for sefurl to function correctly" => "The RewriteBase directive seems not to be set up correctly. This is required for sefurl to function correctly",
// "The current value in %0 is %1 but the base url for this site is %2" => "The current value in %0 is %1 but the base url for this site is %2",
// "List of Url Parameters that should go in the path" => "List of Url Parameters that should go in the path",
// "Known Types" => "Known Types",
// "Token" => "Token",
// "Invert" => "Invert",
// "Show Usage" => "Show Usage",
// "Delete &amp; Unreference" => "Delete &amp; Unreference",
// "Invert Relation" => "Invert Relation",
// "New Types" => "New Types",
// "Fix" => "Fix",
// "No occurences found" => "No occurences found",
// "If you don't want to limit it, an input box will be displayed; otherwise, it will be checkbox" => "If you don't want to limit it, an input box will be displayed; otherwise, it will be checkbox",
"Twitter Settings" => "Configurações do Twitter",
// "To use Twitter integration, you must register this site as an application at" => "To use Twitter integration, you must register this site as an application at",
// "and allow write access for the application" => "and allow write access for the application",
// "Enter &lt;your site URL&gt;tiki-socialnetworks.php as callback URL" => "Enter &lt;your site URL&gt;tiki-socialnetworks.php as callback URL",
// "Facebook Settings" => "Facebook Settings",
// "To use Facebook integration, you must register this site as an application at" => "To use Facebook integration, you must register this site as an application at",
// "and allow extended access for the application" => "and allow extended access for the application",
// "Enter &lt;your site URL&gt;tiki-socialnetworks.php?request_facebook as Site URL and &lt;your site&gt; as Site Domain" => "Enter &lt;your site URL&gt;tiki-socialnetworks.php?request_facebook as Site URL and &lt;your site&gt; as Site Domain",
// "The following preferences affect what permissions the user is asked to allow Tiki to do by Facebook when authorizing it" => "The following preferences affect what permissions the user is asked to allow Tiki to do by Facebook when authorizing it",
// "bit.ly Settings" => "bit.ly Settings",
// "There is no need to set up a site-wide bit.ly account; every user can have his or her own, but this allows for site-wide statistics" => "There is no need to set up a site-wide bit.ly account; every user can have his or her own, but this allows for site-wide statistics",
"Go to" => "Ir para",
// "to sign up for an account" => "to sign up for an account",
// "to retrieve the API key" => "to retrieve the API key",
// "Text area (that apply throughout many features)" => "Text area (that apply throughout many features)",
// "Wiki syntax" => "Wiki syntax",
// "Default size" => "Default size",
// "External links and images" => "External links and images",
// "External links will be identified with" => "External links will be identified with",
// "About plugins" => "About plugins",
// "Tiki plugins add functionality to wiki pages, articles, blogs, and so on. You can enable and disable them below" => "Tiki plugins add functionality to wiki pages, articles, blogs, and so on. You can enable and disable them below",
// "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>" => "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>",
// "The edit-plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below" => "The edit-plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below",
// "Check disabled plugins used in wiki pages" => "Check disabled plugins used in wiki pages",
// "Disabled used plugins" => "Disabled used plugins",
// "Plugin preferences" => "Plugin preferences",
// "Edit plugin icons" => "Edit plugin icons",
// "Disable edit plugin icon (make plugin inline)" => "Disable edit plugin icon (make plugin inline)",
// "Plugin Aliases" => "Plugin Aliases",
// "About plugin aliases" => "About plugin aliases",
// "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}" => "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}",
// "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}" => "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}",
// "Available Alias" => "Available Alias",
// "Enable Plugins" => "Enable Plugins",
// "Delete Plugins" => "Delete Plugins",
// "Click on the plugin name to edit it" => "Click on the plugin name to edit it",
// "Click on the + icon to add a new one" => "Click on the + icon to add a new one",
// "General Information" => "General Information",
// "Plugin Name" => "Plugin Name",
// "Base Plugin" => "Base Plugin",
"Name:" => "Nome:",
"Description:" => "Descrição:",
// "Body Label" => "Body Label",
// "Dependencies" => "Dependencies",
// "Inline (No Plugin Edit UI)" => "Inline (No Plugin Edit UI)",
// "Simple Plugin Arguments" => "Simple Plugin Arguments",
// "Argument" => "Argument",
// "New Argument" => "New Argument",
// "Plugin Parameter Documentation" => "Plugin Parameter Documentation",
"Required" => "Obrigatório",
// "Safe" => "Safe",
// "Plugin Body" => "Plugin Body",
// "Ignore User Input" => "Ignore User Input",
// "Default Content" => "Default Content",
// "Encoding" => "Encoding",
// "Argument Source (if different)" => "Argument Source (if different)",
// "Default Value" => "Default Value",
// "Composed Plugin Arguments" => "Composed Plugin Arguments",
// "Pattern" => "Pattern",
// "To configure your trackers, select \"Trackers\" in the application menu, or" => "To configure your trackers, select \"Trackers\" in the application menu, or",
// "Tracker settings" => "Tracker settings",
// "Tracker attachment preferences" => "Tracker attachment preferences",
"Use database to store files" => "Utilizar o banco de dados para armazenar arquivos",
"Use a directory to store files" => "Utilizar um diretório para armazenar arquivos",
// "Field Types" => "Field Types",
// "Tracker attachments" => "Tracker attachments",
"dls" => "dls",
// "Switch storage" => "Switch storage",
"Change all to db" => "Mudar tudo para a banco de dados",
"Change all to file" => "Mudar tudo para arquivo",
"Use database to store userfiles" => "Utilizar o banco de dados para armazenar arquivos dos usuários",
"Use a directory to store userfiles" => "Utilizar um diretório para armazenar arquivos dos usuários",
"Kaltura" => "Kaltura",
// "Kaltura Registration" => "Kaltura Registration",
// "To get a Kaltura Partner ID" => "To get a Kaltura Partner ID",
// "Setup your own instance of Kaltura Community Edition (CE)" => "Setup your own instance of Kaltura Community Edition (CE)",
// "get an account via Kaltura.com" => "get an account via Kaltura.com",
// "List Media Entries" => "List Media Entries",
// "List Remix Entries" => "List Remix Entries",
// "Add New Media" => "Add New Media",
// "Kaltura / Tiki config" => "Kaltura / Tiki config",
// "Kaltura Partner Settings" => "Kaltura Partner Settings",
// "Kaltura Dynamic Player" => "Kaltura Dynamic Player",
// "Kaltura Contribution Wizard" => "Kaltura Contribution Wizard",
// "Kaltura Remix Editors" => "Kaltura Remix Editors",
// "Ustream Watershed" => "Ustream Watershed",
// "Ustream Watershed Registration" => "Ustream Watershed Registration",
// "If you don't have a Watershed account, " => "If you don't have a Watershed account, ",
// "you can find out more about it here" => "you can find out more about it here",
// "Configuration within Watershed" => "Configuration within Watershed",
// "Set the webservice to point to tiki-watershed_service.php on your site, and turn on Authentication Lock" => "Set the webservice to point to tiki-watershed_service.php on your site, and turn on Authentication Lock",
// "Watershed Wiki plugins" => "Watershed Wiki plugins",
// "Use Wiki plugins WatershedBroadcaster, WatershedViewer and WatershedChat to embed your broadcaster, viewer or chat" => "Use Wiki plugins WatershedBroadcaster, WatershedViewer and WatershedChat to embed your broadcaster, viewer or chat",
// "Basic tracker settings" => "Basic tracker settings",
// "Information for each channel is stored in a tracker. Tracker item view/modify permissions will determine which channels users will be able to view or broadcast to respectively. You can find the Brand Id and Channel Code from the embed codes provided by Watershed, looking for the cid variable which will be \"brandId%2Fchannelcode\"" => "Information for each channel is stored in a tracker. Tracker item view/modify permissions will determine which channels users will be able to view or broadcast to respectively. You can find the Brand Id and Channel Code from the embed codes provided by Watershed, looking for the cid variable which will be \"brandId%2Fchannelcode\"",
// "Archive settings" => "Archive settings",
// "Information on archived clips are stored in a tracker. Tracker item view permissions will determine which archives users will be able to view. Note that recordings set to private in the broadcaster are not added to Tiki. Also, there is a delay for information to be received which could be quite long (30 min)" => "Information on archived clips are stored in a tracker. Tracker item view permissions will determine which archives users will be able to view. Note that recordings set to private in the broadcaster are not added to Tiki. Also, there is a delay for information to be received which could be quite long (30 min)",
// "Archive settings (optional)" => "Archive settings (optional)",
// "Flash Media Encoder" => "Flash Media Encoder",
// "This is only needed if you are using Flash Media Encoder for higher-quality broadcasting which support only shared secret authentication" => "This is only needed if you are using Flash Media Encoder for higher-quality broadcasting which support only shared secret authentication",
// "Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used" => "Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used",
"URL:" => "URL:",
// "Parameters (%name%)" => "Parameters (%name%)",
"Operation" => "Operação",
// "Lookup" => "Lookup",
// "{\$url} requires no parameter" => "{\$url} requires no parameter",
// "Test Input" => "Test Input",
// "Response Information" => "Response Information",
// "OIntegrate Version" => "OIntegrate Version",
// "Not supported" => "Not supported",
// "Schema Version" => "Schema Version",
// "Schema Documentation" => "Schema Documentation",
"Cache" => "Cache",
// "Not specified, default used" => "Not specified, default used",
// "Content Type" => "Content Type",
// "Not specified" => "Not specified",
// "Returned Data" => "Returned Data",
// "Proposed Templates" => "Proposed Templates",
// "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters" => "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters",
// "Register Service" => "Register Service",
// "Registered Templates" => "Registered Templates",
// "Engine" => "Engine",
// "Output" => "Output",
// "Register Template" => "Register Template",
// "The following pages were modified" => "The following pages were modified",
// "Nothing was changed (no images in wiki_up were found in Wiki pages)" => "Nothing was changed (no images in wiki_up were found in Wiki pages)",
// "Use the 'Quick Edit' module to easily create or edit wiki pages" => "Use the 'Quick Edit' module to easily create or edit wiki pages",
// "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules" => "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules",
// "Page display" => "Page display",
// "Page version" => "Page version",
"List authors" => "Lista de autores",
// "Allow override per page" => "Allow override per page",
// "Minor edits do not flag new content for translation and do not send watch notifications (unless \"Watch minor edits\" is enabled)" => "Minor edits do not flag new content for translation and do not send watch notifications (unless \"Watch minor edits\" is enabled)",
// "Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled" => "Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled",
// "If you change storage, it is better to move all the files for easy backup.." => "If you change storage, it is better to move all the files for easy backup..",
// "Tag for current wiki" => "Tag for current wiki",
// "Restore wiki to tag" => "Restore wiki to tag",
// "Restore" => "Restore",
"Remove a tag" => "Remover um rótulo",
"Generate dump" => "Gerar exportação",
"Download last dump" => "Download última exportação",
"Remove unused pictures" => "Remover imagens não utilizadas",
// "Move images from wiki_up to the home file gallery" => "Move images from wiki_up to the home file gallery",
// "If you use these buttons please make sure to have a backup of the database and the directory wiki_up" => "If you use these buttons please make sure to have a backup of the database and the directory wiki_up",
"Export Wiki Pages" => "Exportar páginas Wiki",
"Wiki watch" => "Acompanhamento Wiki",
// "Flagged Revision" => "Flagged Revision",
// "Page Listings" => "Page Listings",
"Configuration" => "Configuração",
// "Select which items to display when listing pages" => "Select which items to display when listing pages",
"Wiki 3D Browser Configuration" => "Configuração do Wiki 3D Browser",
"Tools" => "Ferramentas",
// "Mass search and replace" => "Mass search and replace",
"Wiki attachments" => "Arquivos anexados Wiki",
"Change" => "Mudar",
// "WYSIWYG means What You See Is What You Get, and is handled in Tiki by <a href=\"http://ckeditor.com/\">CKEditor</a>" => "WYSIWYG means What You See Is What You Get, and is handled in Tiki by <a href=\"http://ckeditor.com/\">CKEditor</a>",
// "Page links" => "Page links",
// "Note that if the SEFURL feature is on, page links created using wysiwyg might not be automatically updated when pages are renamed. This is planned to be addressed through the future \"Use Wiki syntax in WYSIWYG\" feature" => "Note that if the SEFURL feature is on, page links created using wysiwyg might not be automatically updated when pages are renamed. This is planned to be addressed through the future \"Use Wiki syntax in WYSIWYG\" feature",
// "Wysiwyg Editor Features" => "Wysiwyg Editor Features",
// "Related features" => "Related features",
// "{\$sect|capitalize}" => "{\$sect|capitalize}",
"Position" => "Posição",
// "Topbar" => "Topbar",
// "Page Top" => "Page Top",
// "Page Bottom" => "Page Bottom",
"Cache Time" => "Tempo de Cache",
"secs" => "s",
// "Use Ctrl+Click to select multiple options" => "Use Ctrl+Click to select multiple options",
// "The" => "The",
"Display Modules to All Groups" => "Exibir módulos para todos os grupos",
// "setting will override your selection of specific groups" => "setting will override your selection of specific groups",
"Visibility" => "Visibilidade",
"Displayed now for all eligible users even with personal assigned modules" => "Mostrando agora para todos os usuários elegíveis com módulos pessoais designados",
"Displayed for the eligible users with no personal assigned modules" => "Mostrado para os usuários elegíveis sem módulos pessoais designados",
"Displayed now, can't be unassigned" => "Mostrando agora, pode não estar designado",
"Not displayed until a user chooses it" => "Não mostrar até um usuário escolher isto",
// "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either" => "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either",
// "to make sure users will notice any newly assigned modules" => "to make sure users will notice any newly assigned modules",
"required" => "obrigatório",
// "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y" => "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y",
// "Enter the parameters in URL format, e.g. 'nobox=y&class=rbox-data'" => "Enter the parameters in URL format, e.g. 'nobox=y&class=rbox-data'",
// "Edit custom module" => "Edit custom module",
// "Non Advanced Search or Natural Search" => "Non Advanced Search or Natural Search",
// "The documents are returned sorted on relevance depending on order, proximity, frequency of terms. " => "The documents are returned sorted on relevance depending on order, proximity, frequency of terms. ",
// "Advanced Search or Boolean Search" => "Advanced Search or Boolean Search",
// "Default search behavior" => "Default search behavior",
// "By default, all search terms are <em>optional</em>" => "By default, all search terms are <em>optional</em>",
// "It behaves like an OR logic" => "It behaves like an OR logic",
// "Objects that contain the more terms are rated higher in the results and will appear first in their type" => "Objects that contain the more terms are rated higher in the results and will appear first in their type",
// "For example, <strong>wiki forum</strong> will find" => "For example, <strong>wiki forum</strong> will find",
// "objects that include both terms" => "objects that include both terms",
// "objects that include the term <strong>wiki</strong>" => "objects that include the term <strong>wiki</strong>",
// "objects that include the term <strong>forum</strong>" => "objects that include the term <strong>forum</strong>",
// "Requiring terms" => "Requiring terms",
// "Add a plus sign ( + ) before a term to indicate that the term <em>must</em> appear in results" => "Add a plus sign ( + ) before a term to indicate that the term <em>must</em> appear in results",
// "Example: <strong>+wiki forum</strong> will find objects containing at least <strong>wiki</strong>. Objects with both terms and many occurences of the terms will appear first" => "Example: <strong>+wiki forum</strong> will find objects containing at least <strong>wiki</strong>. Objects with both terms and many occurences of the terms will appear first",
// "Excluding terms" => "Excluding terms",
// "Add a minus sign ( - ) before a term to indicate that the term <em>must not</em> appear in the results" => "Add a minus sign ( - ) before a term to indicate that the term <em>must not</em> appear in the results",
// "To reduce a term's value without completely excluding it, <a href=\"#reducing\" title=\"{tr}Reducing a term's value" => "To reduce a term's value without completely excluding it, <a href=\"#reducing\" title=\"{tr}Reducing a term's value",
// "Example: <strong>-wiki forum</strong> will find objects that do not contain <strong>wiki</strong> but contain <strong>forum</strong>" => "Example: <strong>-wiki forum</strong> will find objects that do not contain <strong>wiki</strong> but contain <strong>forum</strong>",
// "Grouping terms" => "Grouping terms",
// "Use parenthesis ( ) to group terms into subexpressions" => "Use parenthesis ( ) to group terms into subexpressions",
// "Example: <strong>+wiki +(forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order" => "Example: <strong>+wiki +(forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order",
// "Finding phrases" => "Finding phrases",
// "Use double quotes ( \" \" ) around a phrase to find terms in the exact order, exactly as typed" => "Use double quotes ( \" \" ) around a phrase to find terms in the exact order, exactly as typed",
// "Example: <strong>\"Alex Bell\"</strong> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong>. " => "Example: <strong>\"Alex Bell\"</strong> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong>. ",
// "Using wildcards" => "Using wildcards",
// "Add an asterisk ( * ) after a term to find objects that include the root word" => "Add an asterisk ( * ) after a term to find objects that include the root word",
// "For example, <strong>run*</strong> will find" => "For example, <strong>run*</strong> will find",
// "objects that include the term <strong>run</strong>" => "objects that include the term <strong>run</strong>",
// "objects that include the term <strong>runner</strong>" => "objects that include the term <strong>runner</strong>",
// "objects that include the term <strong>running</strong>" => "objects that include the term <strong>running</strong>",
// "Reducing a term's value" => "Reducing a term's value",
// "Add a tilde ( ~ ) before a term to reduce its value indicate to the ranking of the results" => "Add a tilde ( ~ ) before a term to reduce its value indicate to the ranking of the results",
// "Objects that contain the term will appear lower than other objects (unlike the <a href=\"#excluding\" title=\"{tr}Excluding terms" => "Objects that contain the term will appear lower than other objects (unlike the <a href=\"#excluding\" title=\"{tr}Excluding terms",
// "Example: <strong>+wiki ~forum</strong> will rate an object with only <strong>wiki</strong> higher that an object with <strong>wiki</strong> and  <strong>forum</strong>" => "Example: <strong>+wiki ~forum</strong> will rate an object with only <strong>wiki</strong> higher that an object with <strong>wiki</strong> and  <strong>forum</strong>",
// "Changing relevance value" => "Changing relevance value",
// "Add a less than ( &lt; ) or greater than ( &gt; ) sign before a term to change the term's contribution to the overall relevance value assigned to a object" => "Add a less than ( &lt; ) or greater than ( &gt; ) sign before a term to change the term's contribution to the overall relevance value assigned to a object",
// "Example: <strong>+wiki +(&gt;forum &lt; blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or <strong>wiki</strong> and <strong>blog</strong> in any order. <strong>wiki forum</strong> will be rated higher" => "Example: <strong>+wiki +(&gt;forum &lt; blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or <strong>wiki</strong> and <strong>blog</strong> in any order. <strong>wiki forum</strong> will be rated higher",
// "Anti-Bot verification code image" => "Anti-Bot verification code image",
"Enter the code you see above" => "Digite o código que está acima",
"Try another code" => "Outro código",
"Author:" => "Autor:",
// "Expires At" => "Expires At",
// "star" => "star",
// "half star" => "half star",
// "{\$topicName}" => "{\$topicName}",
// "List all articles of this same topic" => "List all articles of this same topic",
// "{\$topicName|escape}" => "{\$topicName|escape}",
// "{\$topics[\$topicId].name|escape}" => "{\$topics[\$topicId].name|escape}",
// "You do not have permission to read complete articles" => "You do not have permission to read complete articles",
"First page" => "Primeira página",
"Previous page" => "Página anterior",
"page" => "página",
"Next page" => "Próxima página",
"Last page" => "Última página",
"Related content" => "Conteúdo relacionado",
"bytes" => "bytes",
"Share page" => "Compartilhar página",
"Share This" => "Compartilhar",
// "ShareThis via AIM, social bookmarking and networking sites, etc" => "ShareThis via AIM, social bookmarking and networking sites, etc",
"Send a link" => "Enviar link",
"List of attached files" => "Lista de arquivos anexados",
"desc" => "desc",
"uploaded" => "carregado",
"Upload file" => "Carregar arquivo",
"Comment:" => "Comentário:",
"Attach" => "Anexar",
"Attach a file to this item" => "Anexar um arquivo a este item",
// "{\$attfields[ix]}" => "{\$attfields[ix]}",
"more info" => "mais informações",
"No attachments for this item" => "Sem arquivos anexados a este item",
"debug" => "depuração",
"Fatal error" => "Erro crítico",
"Save to notepad" => "Salvar no bloco de notas",
"Published " => "Publicado ",
"on" => "em",
"Previous post" => "Post anterior",
"Next post" => "Próximo post",
"Read more" => "Leia mais",
"More..." => "Mais...",
"pages" => "páginas",
"Permalink" => "Link permanente",
"Leave a comment" => "Deixe um comentário",
"%0 comment" => "%0 comentário",
"%0 comments" => "%0 comentários",
// "Parent Gallery" => "Parent Gallery",
"Properties" => "Propriedades",
"Click Here to Insert in Wiki Syntax" => "Clique aqui para inserir",
"No records found" => "Nenhum registro encontrado",
"Category:" => "Categoria:",
"Select Categories" => "Selecionar categorias",
"Admin Categories" => "Administrar categorias",
"Select/deselect all categories" => "Marcar/desmarcar todas as categorias",
"No categories defined" => "Nenhuma categoria definida",
"Browse Category" => "Navegar na categoria",
"Are you sure you want to archive this comment" => "Você tem certeza de que deseja arquivar esse comentário",
// "Are you sure you want to unarchive this comment" => "Are you sure you want to unarchive this comment",
// "Return" => "Return",
"Title:" => "Título:",
"Do you really want to lock comments" => "Você tem certeza de que deseja travar os comentários",
"Lock" => "Travar",
"Do you really want to unlock comments" => "Você tem certeza de que deseja destravar os comentários",
"Unlock" => "Destravar",
"Are you sure you want to remove this comment" => "Você tem certeza que deseja remover esse comentário",
// "Unarchive" => "Unarchive",
"Are you sure you want to approve this comment" => "Você tem certeza que deseja aprovar esse comentário",
"Approve" => "Aprovar",
"Are you sure you want to reject this comment" => "Você tem certeza que deseja rejeitar esse comentário",
"Reject" => "Rejeitar",
"Comment posted by %0 on %1" => "Comentário enviado por %0 em %1",
"Reply" => "Responder",
"No comments" => "Sem comentários",
"There are no comments at this time" => "Não existem comentários desta vez",
"Post new comment" => "Enviar novo comentário",
"Add Comment" => "Adicionar comentário",
// "Are you sure you want to lock comments on this object" => "Are you sure you want to lock comments on this object",
"Your comment was posted" => "Seu comentário foi enviado",
// "Identity" => "Identity",
// "You are currently registered on this site. This section is <strong>optional</strong>. By filling it, you will not link this post to your account and preserve your anonymity" => "You are currently registered on this site. This section is <strong>optional</strong>. By filling it, you will not link this post to your account and preserve your anonymity",
// "Pseudonym" => "Pseudonym",
"Email:" => "E-mail:",
"Website" => "Site",
// "Are you sure you want to unlock comments on this object" => "Are you sure you want to unlock comments on this object",
"Posted by" => "Enviado por",
"posts:" => "mensagens:",
"stars" => "estrelas",
"User Level" => "Nível de usuário",
"private message" => "mensagem particular",
"Send eMail to User" => "Enviar email ao usuário",
"user online" => "usuário on-line",
"user offline" => "usuário offline",
"top of page" => "topo da página",
"Report this post" => "Solicitar que um moderador revise essa mensagem",
"Monitor this Topic" => "Monitorar este tópico",
"Stop Monitoring this Topic" => "Não monitorar mais este tópico",
"Group Monitor" => "Grupos que monitoram essa página",
// "Watched by categories" => "Watched by categories",
"Moderator actions" => "Ações de moderador",
"reported:" => "enviadas:",
"queued:" => "pendentes:",
"Move to topic:" => "Mover para o tópico:",
"Delete Selected" => "Apagar selecionados",
"Threshold" => "Limite",
"Replies" => "Respostas",
// "below your current threshold" => "below your current threshold",
"New Reply" => "Nova resposta",
"Editing reply" => "Editar resposta",
"Reply to the selected post" => "Responder a mensagem selecionada",
"Post new message" => "Enviar nova mensagem",
// "If you would like to be notified when someone replies to this topic<br />please tell us your e-mail address" => "If you would like to be notified when someone replies to this topic<br />please tell us your e-mail address",
"Send me an e-mail when someone replies" => "Receber e-mail quando alguém responder",
"Maximum size" => "Tamanho máximo",
"Reply to parent post" => "Responder para a mensagem principal",
"Post new reply" => "Enviar nova resposta",
"Post as Anonymous" => "Enviar como anônimo",
// "Please note that the preview does not keep the attached file which you will have to choose before posting" => "Please note that the preview does not keep the attached file which you will have to choose before posting",
"Posting replies" => "Enviar respostas",
"Please enter a title" => "Por favor insira um título",
"1 comment" => "1 comentário",
"Go back" => "Retornar",
"Return to home page" => "Retornar à página inicial",
"Type of contribution:" => "Tipo de contribuição:",
"Copyrights" => "Direitos Autorais",
"Year:" => "Ano:",
"Authors:" => "Autores:",
"System error" => "Erro do sistema",
// "Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue" => "Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue",
// "If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation" => "If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation",
// "The query was" => "The query was",
// "The built query was likely" => "The built query was likely",
// "Stacktrace" => "Stacktrace",
"Tiki is unable to connect to the database" => "O Tiki não consegue conectar a base de dados",
// "An error occurred while performing the request" => "An error occurred while performing the request",
"Current URL" => "Endereço atual",
"Command" => "Comando",
"exec" => "executar",
"Type <code>help</code> to get list of available commands" => "Digite <code>ajuda</code> para obter uma lista de comandos",
"Syntax" => "Formato",
"Page generation debugging log" => "Log de depuração de geração de página",
"Features state" => "Estado de recursos",
"Total" => "Total",
"features matched" => "recursos selecionados",
"Watchlist" => "Lista de Notificações",
"Duplicate File Gallery" => "Duplicar galeria de arquivos",
"File gallery" => "Galeria de arquivos",
"Duplicate categories" => "Duplicar categorias",
"Duplicate permissions" => "Duplicar permissões",
"Duplicate" => "Duplicar",
"There are individual permissions set for this file gallery" => "Existem permissões individuais definidas para esta galeria de arquivos",
"View inserted gallery" => "Ver galeria criada",
// "{\$gal_info.name}" => "{\$gal_info.name}",
"System" => "Sistema",
// "Other (%0)" => "Other (%0)",
"Any file" => "Qualquer arquivo",
"Podcast (audio)" => "Podcast (áudio)",
"Podcast (video)" => "Podcast (vídeo)",
"Gallery is visible to non-admin users" => "Galeria visível para usuários não administradores",
"Gallery is public" => "Galeria pública",
"Any user with permission (not only the gallery owner) can upload files" => "Qualquer usuário com permissão (e não apenas o criador da galeria) pode subir arquivos",
// "Perms of the backlinks are checked to view a file" => "Perms of the backlinks are checked to view a file",
"Files can be locked at download" => "Arquivos podem ser travados no download",
"Maximum number of archives for each file" => "Número máximo de versões para cada arquivo",
"Use" => "Usar",
"unlimited" => "ilimitado",
"Parent gallery" => "Galeria pai",
"Owner of the gallery" => "Dono da galeria",
"Min" => "Min",
"Group of users alerted when file gallery is modified" => "Grupo de usuários avisado quando a galeria de arquivos for modificada",
// "Allows to select each user for small groups" => "Allows to select each user for small groups",
"Maximum width for images in gallery" => "Largura máxima para imagens na galeria",
"If an image is wider than this, it will be resized" => "Se uma imagem for mais larga que esse valor, ela será redimensionada",
"Attention: In this case, the original image will be lost" => "Atenção: nesse caso a imagem original não será guardada",
"Maximum height for images in gallery" => "Altura máxima para imagens na galeria",
"If an image is higher than this, it will be resized" => "Se uma imagem for mais alta que esse valor, ela será redimensionada",
"Wiki markup to enter when image selected from \"file gallery manager\"" => "Sintaxe wiki usada quando a imagem for selecionada usando o \"gerenciador da galeria de arquivos\"",
"The default is " => "O padrão é ",
"Field names will be replaced when enclosed in % chars. e.g. %fileId%, %name%, %filename%, %description%" => "Os valores dos parâmetros serão substituídos quando estiverem entre %. Possíveis valores: %fileId%, %name%, %filename%, %description%",
"Display Properties" => "Configurar visualização",
"Max description display size" => "Tamanho máximo para descrição",
"Max rows per page" => "Número máximo de entradas por página",
"Select which items to display when listing galleries" => "Defina quais campos mostrar na listagem de galerias",
// "File error" => "File error",
"Perhaps you are looking for:" => "Talvez você esteja procurando por:",
// "There are no wiki pages similar to '{\$page|escape}'" => "There are no wiki pages similar to '{\$page|escape}'",
// "Token Error" => "Token Error",
"You are not logged in." => "Você não está logado.",
"Go to Log in Page" => "Ir para a página de login",
"Change them here" => "Mudar eles aqui",
"Create this page" => "Criar esta página",
"(page will be orphaned)" => "(a página será órfã)",
"Close Window" => "Fechar janela",
"Attached files" => "Arquivos anexados",
"Private Gallery" => "Galeria privada",
"Active Perms" => "Permissões ativas",
"Perms" => "Permissões",
// "Open as WebFolder" => "Open as WebFolder",
// "Edit: " => "Edit: ",
"Download current version" => "Baixar versão atual",
"Archives" => "Arquivos",
"Upload New Version" => "Subir nova versão",
// "Replace your draft" => "Replace your draft",
// "Upload your draft" => "Upload your draft",
// "Validate your draft" => "Validate your draft",
// "Delete your draft" => "Delete your draft",
"Download and lock" => "Baixar e travar",
// "Open your draft in WebDAV" => "Open your draft in WebDAV",
// "Open in WebDAV" => "Open in WebDAV",
// "Share a link to this file" => "Share a link to this file",
// "Email a link to this file" => "Email a link to this file",
// "Enter the ID of any file in any gallery to be used as the icon for this gallery in browse view" => "Enter the ID of any file in any gallery to be used as the icon for this gallery in browse view",
"The checkbox is disabled because this preference is disabled globally" => "Esse checkbox está desabilitado pois essa preferência está desabilitada globalmente",
"Please, enable the preference globally first" => "Para usá-la primeiro habilite globalmente",
"You can ask your site Admin to enable the preference" => "Você pode solicitar a um dos administradores do site para habilitar está preferência",
"Name-filename" => "Nome-nome de arquivo",
"Filename only" => "Apenas nome de arquivo",
"Show as a column" => "Mostrar em uma coluna",
"Show in popup box" => "Mostrar numa janela popup",
"Show an icon in a column" => "Mostrar um ícone numa coluna",
// "Upload from URL" => "Upload from URL",
// "File added" => "File added",
// "{\$file_backlinks_title}" => "{\$file_backlinks_title}",
"Start the Slideshow" => "Iniciar o slideshow",
"Pause the Slideshow" => "Pausar o slideshow",
// "There are no images to display" => "There are no images to display",
// "Search Help" => "Search Help",
// "Any" => "Any",
// "Deep search" => "Deep search",
"Tags" => "Tags",
"Select Tags" => "Selecionar tags",
// "Include objects without a specified language" => "Include objects without a specified language",
"Add to filter" => "Adicionar ao filtro",
// "{\$whatlabel}" => "{\$whatlabel}",
// "Find in" => "Find in",
"Exact match" => "Correspondência exata",
"and all the sub-objects" => "incluir objetos descendentes",
"any type" => "qualquer tipo",
// "any topic" => "any topic",
"any language" => "qualquer idioma",
// "not in" => "not in",
"any category" => "qualquer categoria",
"Multiple select" => "Seleção multipla",
"in:" => "em:",
// "{\$value}" => "{\$value}",
// "{\$duration.label}" => "{\$duration.label}",
// "Orphans" => "Orphans",
// "{\$find_other}" => "{\$find_other}",
"Number of displayed rows" => "Número de linhas exibidas",
"Clear Filter" => "Limpar filtro",
// "Map View" => "Map View",
"Show php error messages" => "Mostrar mensagens de erro do PHP",
"Folksonomy Tags" => "Tags",
"Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes." => "Separe as tags com espaços. Para tags com mais de uma palavra use aspas duplas.",
// "Folksonomy Language" => "Folksonomy Language",
// "Untag" => "Untag",
"Translate tags" => "Traduzir tags",
"Images Galleries" => "Galerias de imagem",
"Edit this page!" => "Editar esta página!",
"RSS Wiki" => "RSS Wiki",
"RSS Blogs" => "RSS Blogs",
"RSS Articles" => "RSS Artigos",
"RSS Image Galleries" => "RSS Galeria de imagens",
"RSS File Galleries" => "RSS Galeria de arquivos",
"RSS Forums" => "RSS Fóruns",
"RSS Maps" => "RSS Mapas",
"RSS Directories" => "RSS Diretórios",
"RSS Calendars" => "RSS Calendário",
// "RSS Tracker" => "RSS Tracker",
"Interactive Translation" => "Tradução interativa",
"Once checked, click on any string to translate it." => "Selecione a caixa acima e clique numa frase para traduzi-la.",
// "Couldn't find any translatable string" => "Couldn't find any translatable string",
"Save translations" => "Salvar traduções",
"Changes will be applied on next page load only" => "Alterações serão aplicadas somente quando a página for recarregada",
// "Show Tree" => "Show Tree",
// "Hide Tree" => "Hide Tree",
"Perform action with checked:" => "Ação com o que foi selecionado:",
"Move Selected Files" => "Mover os arquivos selecionados",
"Are you sure you want to delete the selected files?" => "Você tem certeza que deseja remover os arquivos selecionados?",
// "Are you sure you want to reset the default gallery list table settings" => "Are you sure you want to reset the default gallery list table settings",
"Reset to default gallery list table settings" => "Restaurar configurações padrão de listagem da galeria",
"Download the zip" => "Download arquivo zip",
// "Assign permissions to file galleries" => "Assign permissions to file galleries",
"Move to" => "Mover para",
"Other Sorts" => "Outras opções de ordenação",
"No Additional Sort" => "Remover ordenação adicional",
"No information" => "Nenhuma informação",
// "Hi {\$mail_user|username} has sent you this link" => "Hi {\$mail_user|username} has sent you this link",
"Blog post:" => "Mensagem de blog:",
"at:" => "em:",
// "Gift Certificate Information" => "Gift Certificate Information",
// "Percentage Discount" => "Percentage Discount",
// "Value of Gift Certificate" => "Value of Gift Certificate",
// "Redeem Code" => "Redeem Code",
// "Your Gift Certificate Purchase" => "Your Gift Certificate Purchase",
// "Your cart order has been received. Please note that orders are not finalized until payment has been made" => "Your cart order has been received. Please note that orders are not finalized until payment has been made",
// "You can review your order at" => "You can review your order at",
// "Your cart order" => "Your cart order",
"Somebody or you tried to subscribe this email address at our site:" => "Alguém (possivelmente você) tentou registrar este endereço de email no nosso site:",
"To the newsletter:" => "Para o comunicado:",
"In order to confirm your subscription you must access the following URL:" => "Para confirmar esta assinatura, acesse o seguinte endereço:",
"To validate your account and login to the site, please click on the following link:" => "Para validar sua conta e logar no site, por favor clique no seguinte link:",
"The administrator approved your account." => "O administrador ativou a sua conta.",
"Confirm your email at %s" => "Confirme seu e-mail em %s",
"Remove file" => "Remover arquivo",
// "GalleryId" => "GalleryId",
// "Identifier" => "Identifier",
"User:" => "Usuário:",
"A new message was posted to forum" => "Uma nova mensagem foi enviada ao fórum",
"New topic:" => "Novo tópico:",
// "An anonymous user" => "An anonymous user",
// "has posted a reply to a thread you're watching. \nYou can view the thread and reply at the following URL" => "has posted a reply to a thread you're watching. \nYou can view the thread and reply at the following URL",
// "You are invited by" => "You are invited by",
// "You join this group" => "You join this group",
// "Join me on %s" => "Join me on %s",
"You sent a request with the subject:" => "Você mandou uma requisição com o assunto:",
"Use the subject to indicate the operation to apply:" => "Use o assunto para indicar a operação para aplicar:",
// "GET:WikiName to get a wiki page" => "GET:WikiName to get a wiki page",
// "PUT:WikiName to update/create a wiki page (use the body for the page data)" => "PUT:WikiName to update/create a wiki page (use the body for the page data)",
// "APPEND:WikiName to append data to a Wiki page (use the body for the data to add)" => "APPEND:WikiName to append data to a Wiki page (use the body for the data to add)",
// "PREPEND:WikiName to append the data at the top" => "PREPEND:WikiName to append the data at the top",
"Tiki mail-in instructions" => "Instruções para mail-in Tiki",
// "Tiki mail-in auto-reply" => "Tiki mail-in auto-reply",
"Page not found:" => "Página não encontrada:",
"A new message was posted to you at {\$mail_machine}" => "Uma nova mensagem foi enviada para você a partir de {\$mail_machine}",
"New message arrived from %s" => "Nova mensagem chegou de %s",
"Hi" => "Olá",
"Your account registration request for {\$mail_site} was validated by the site admin and your account is active now." => "Seu pedido de registro de conta no Tiki para {\$mail_site} foi validade pelo administrados e sua conta está ativa agora.",
"To login with your username and password, please follow this link:" => "Para entrar usando seu usuário e senha, por favar acesse esse link:",
"Enjoy the site!" => "Esperamos que você aprecie o site!",
"User Account Activated" => "Conta Tiki do usuário ativada",
// "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first" => "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first",
"has requested an account on" => "solicitou uma conta em",
"Group:" => "Grupo:",
// "User Tracker" => "User Tracker",
"To validate that account, please follow the link:" => "Para validar essa conta, por favor siga o link:",
// "Assign to a group" => "Assign to a group",
// "View user's data" => "View user's data",
// "Best regards" => "Best regards",
"User Registration Request" => "Solicitação de registro de usuário tiki",
"Go to your friendship network to accept or refuse this request" => "Vá para a sua rede de amigos para aceitar ou rejeitar esse pedido",
"You're invited to join my network of friends!" => "Convite para entrar na minha rede de amigos!",
"The user" => "O usuário",
"registered at your site" => "registrou-se no seu site",
"New user registration" => "Cadastramento de novo usuário",
"Published" => "Publicado",
"By:" => "Por:",
"Bye bye!" => "Até logo!",
"This email address has been removed to the list of subscriptors of:" => "Este endereço de email foi removido da lista de assinantes de:",
"Newsletter:" => "Comunicado:",
"Bye bye from %s at %s" => "Removido da lista %s em %s",
"You can unsubscribe from this newsletter following this link" => "Você pode cancelar a assinatura deste comunicado clicando abaixo:",
"Welcome to our newsletter!" => "Bem-vindo(a) ao nosso comunicado!",
"This email address has been added to the list of subscriptors of:" => "Este endereço de email foi adicionado à lista de assinantes de:",
"You can always cancel your subscription using:" => "Você pode cancelar sua assinatura a qualquer momento usando:",
"Welcome to %s at %s" => "Bem vindo a %s em %s",
// "Reply notification" => "Reply notification",
"Email notification" => "Notificação de email Tiki",
"Someone" => "Alguém",
"requested a reminder of the password for your account" => "solicitou um lembrete de senha da sua conta",
"requested password reset for your account" => "solicitou que a senha para sua conta fosse recriada",
"Since this is your registered email address we inform that the password for this account is" => "Sendo esse o seu endereço eletrônico a sua senha é",
"Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else" => "Clique no link a seguir para escolher uma nova senha. Escolha uma senha que apenas você saiba e não compartilhe com ninguém",
"Important: Username & password are CaSe SenSitiVe" => "Importante: Usuário e senha são sensíveis a caixa ALTA/baixa",
"Important: The old password remains active if you don't click the link above." => "Importante: a senha velha permanecerá ativa se você não clicar no link acima.",
"Your account information for %s" => "Informações da sua conta no %s",
// "}Plugin %0 is pending approval on %1" => "}Plugin %0 is pending approval on %1",
// "tiki-plugins.php\"}See all the pending plugins in the <a href='%0'>plugin approval page</a>" => "tiki-plugins.php\"}See all the pending plugins in the <a href='%0'>plugin approval page</a>",
// "Plugin arguments" => "Plugin arguments",
// "Plugin body" => "Plugin body",
"Report for %0" => "Notificações para %0",
"Last Report sent on %0" => "Últimas notificações enviadas em %0",
"Changes in detail" => "Lista de notificações",
// "You are receiving notification emails grouped in a periodic digest. To receive them individually when posted instead, change your preferences at %0" => "You are receiving notification emails grouped in a periodic digest. To receive them individually when posted instead, change your preferences at %0",
"Look at this link:" => "Veja esse link:",
"A friend sends you a link from: " => "Um amigo lhe enviou um link de: ",
// "A new article was submitted by {\$mail_user|username} to {\$mail_site} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "A new article was submitted by {\$mail_user|username} to {\$mail_site} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"You can edit the submission following this link:" => "Você pode editar este artigo editando este link:",
"Heading:" => "Cabeçalho:",
"Body:" => "Corpo:",
"New article submitted at %s" => "Novo artigo enviado em %s",
// "ItemID {\$mail_itemId} {\$mail_item_desc} was deleted in the tracker {\$mail_trackerName}" => "ItemID {\$mail_itemId} {\$mail_item_desc} was deleted in the tracker {\$mail_trackerName}",
// "New status for ItemID {\$mail_itemId} {\$mail_item_desc} for the tracker {\$mail_trackerName}" => "New status for ItemID {\$mail_itemId} {\$mail_item_desc} for the tracker {\$mail_trackerName}",
// "Download the file at" => "Download the file at",
"item" => "item",
// "was modified at" => "was modified at",
// "Please visit this link before login again" => "Please visit this link before login again",
"Last attempt" => "Última tentativa",
// "Confirm your account at %s" => "Confirm your account at %s",
"Site" => "Site",
// "Account suspended" => "Account suspended",
// "An administrator of the site below has added you as a new user" => "An administrator of the site below has added you as a new user",
// "If you want to confirm your membership in this site, click on the following link to login for the first time" => "If you want to confirm your membership in this site, click on the following link to login for the first time",
// "Your authentication credentials are" => "Your authentication credentials are",
"Welcome to the site" => "Bem vindo ao site",
// "Your personal access to" => "Your personal access to",
// "joined the group" => "joined the group",
// "User joined group" => "User joined group",
"You or someone registered this email address at" => "alguém (possivelmente você) registrou este endereço de email em",
"If you want to be a registered user in this site you will have to use the following link to login for the first time:" => "Se você deseja ser um usuário registrado neste site, utilize o seguinte link para logar-se pela primeira vez:",
"Your registration confirmation" => "Instruções para cadastramento no Tiki",
// "You will receive an email with the information needed to log into this site the first time" => "You will receive an email with the information needed to log into this site the first time",
"Your account request has been stored and will be activated by the admin as soon as possible." => "Seu pedido de conta foi registrado e será ativado pelo administrador o mais rápido possível.",
"You'll receive email notification once your account is activated." => "Você receberá um e-mail avisando quando a sua conta estiver ativa.",
"Please do not attempt to login until you receive the email notification." => "Por favor não tente se logar enquanto não receber o e-mail de ativação.",
// "{\$mail_action} article post" => "{\$mail_action} article post",
// "{\$mail_title} by {\$mail_user|username} at" => "{\$mail_title} by {\$mail_user|username} at",
"View the article at:" => "Vejo o artigo em:",
"If you don't want to receive these notifications follow this link:" => "Se você não deseja receber estas notificações siga este link:",
"Publish Date" => "Data de Publicação",
"Expiration Date" => "Data de Expiração",
// "The old article follows" => "The old article follows",
// "{\$mail_action}" => "{\$mail_action}",
// "article post at" => "article post at",
// "New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"View the blog at:" => "Veja o blog em:",
"New blog post at %s" => "Novo post no blog em %s",
// "View item calendar at" => "View item calendar at",
"Modified calendar item" => "Item do calendário modificado",
"New calendar item" => "Novo item no calendário",
"changed" => "alterada",
// "A new category was created in" => "A new category was created in",
"Created by:" => "Criado por:",
"created" => "criação",
// "A category was removed in" => "A category was removed in",
"Removed by" => "Removido por",
"removed" => "removido",
"A category was updated" => "Uma categoria foi atualizada",
// "Updated by" => "Updated by",
"Old:" => "Antigo:",
// "updated" => "updated",
// "The Wiki page {\$mail_objectname} was commented on by" => "The Wiki page {\$mail_objectname} was commented on by",
"an anonymous user" => "um usuário anônimo",
// "The article {\$mail_objectname} was commented on by" => "The article {\$mail_objectname} was commented on by",
// "The tracker item {\$mail_item_title} of tracker {\$mail_objectname} was commented on by" => "The tracker item {\$mail_item_title} of tracker {\$mail_objectname} was commented on by",
// "You can view the comment by following this link" => "You can view the comment by following this link",
"File Gallery %s changed" => "Galeria de arquivos %s alterada",
"A file was removed from the file gallery" => "Um arquivo foi removido da galeria de arquivos",
"A new file was posted to file gallery" => "Novo arquivo na galeria de arquivos",
"File Description" => "Descrição do Arquivo",
// "New forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "New forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}",
// "New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}",
"Image Gallery {\$galleryName} changed" => "Galeria de imagem {\$galleryName} modificada",
"A new file was posted to image gallery" => "Um novo arquivo foi enviado para a galeria de imagem",
// "The map {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The map {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"You can view the updated map following this link:" => "Você pode ver o mapa atualizado pelo link:",
"You can edit the map following this link:" => "Você pode editar o mapa pelo seguinte link:",
// "An object was added to category" => "An object was added to category",
// "Added by" => "Added by",
// "An object was removed from category" => "An object was removed from category",
// "A page has been added to your watched sub-structure" => "A page has been added to your watched sub-structure",
// "A page has been removed from your watched sub-structure" => "A page has been removed from your watched sub-structure",
// "A page has been promoted out your watched sub-structure" => "A page has been promoted out your watched sub-structure",
// "A page has been demoted to your watched structure" => "A page has been demoted to your watched structure",
"Structure modified" => "Estrutura modificada",
// "has consulted your" => "has consulted your",
// "Go to the File Gallery" => "Go to the File Gallery",
"Download the file" => "Baixar arquivo",
"A new file have been attached to page" => "Um novo arquivo foi anexado à página",
"File name" => "Nome do arquivo",
"New attachment on %s, page" => "Novos anexos em %s, página",
// "The page {\$mail_page} was created by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The page {\$mail_page} was created by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "The page {\$mail_page} was deleted by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The page {\$mail_page} was deleted by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "A file was attached to {\$mail_page}" => "A file was attached to {\$mail_page}",
// "The page {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The page {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "The page {\$mail_page} was deleted but used to be here" => "The page {\$mail_page} was deleted but used to be here",
"You can view the page by following this link:" => "Você pode acessar a página através desse link:",
"You can view a diff back to the previous version by following this link:" => "Você pode visualizar uma comparação de uma versão anterior através desse link:",
"The changes in this version follow below, followed after by the current full page text." => "As mudanças nessa versão seguem abaixo, em seguida é mostrado a versão atual da página.",
"-Lines: {\$oldd} changed to +Lines: {\$newd}" => "-Linhas: {\$oldd} mudou para +Linhas: {\$newd}",
// "The old page content follows below" => "The old page content follows below",
"The new page content follows below." => "O conteúdo da nova página está abaixo.",
// "Wiki page %s created by {\$mail_user|username}" => "Wiki page %s created by {\$mail_user|username}",
// "Wiki page %s deleted by {\$mail_user|username}" => "Wiki page %s deleted by {\$mail_user|username}",
// "A file was attached to %s" => "A file was attached to %s",
// "Wiki page %s changed by {\$mail_user|username}" => "Wiki page %s changed by {\$mail_user|username}",
"Wiki page renamed" => "Página wiki renomeada",
"Old name" => "Nome antigo",
"New name" => "Novo nome",
"Thank you for your registration." => "Obrigado por se registrar.",
"You may log in now." => "Você já pode ser logar no site.",
"click on the map to zoom or pan, do not drag" => "clique no mapa para um zoom, não para arrastar",
// "Query Results" => "Query Results",
// "Querying" => "Querying",
// "Scroll Up" => "Scroll Up",
// "Scroll Down" => "Scroll Down",
"Scale" => "Escala",
"Zoom out" => "Menos zoom",
"Query" => "Consulta",
"Pan" => "Panorâmica",
"Zoom in" => "Mais zoom",
"Redraw" => "Redesenhar",
"select zoom/pan/query and image size" => "selecione zoom/pan/consulta e tamanho da imagem",
"View the Map Only" => "Veja apenas o mapa",
"Reset Map" => "Reiniciar mapa",
"Click on the map or click redraw" => "Clique no mapa ou clique em redesenhar",
"Overview" => "Visão geral",
"Legend" => "Legenda",
"Layer Manager" => "Gerenciador de Camadas",
"Layer" => "Camada",
// "{\$my_layers[j]->group}" => "{\$my_layers[j]->group}",
// "{\$layer_wiki[i]}" => "{\$layer_wiki[i]}",
// "{\$layer_wiki[j]}" => "{\$layer_wiki[j]}",
"Download Layer" => "Download Camada",
"This layer has been set by the maps administrator to not be downloadable" => "Essa camada foi definida para como impossível de ser baixada pelo administrador dos mapas",
"you have requested to download the layer:" => "você requisitou o download da camada:",
// "from the mapfile" => "from the mapfile",
"Here are the files to download, do not forget to rename them:" => "Aqui estão os arquivos para o download, não esqueça de renomeá-los:",
"Mapfiles" => "Arquivos de Mapas",
"Mapfile" => "Arquivo de Mapa",
"Available mapfiles" => "Arquivos de Mapas disponíveis",
"hits last 7 days" => "cliques nos últimos 7 dias",
"monitor this map" => "monitorar este mapa",
"Stop Monitoring this Map" => "Parar de monitorar este mapa",
"Create a new mapfile" => "Criar um novo arquivo de mapa",
"Mapfile listing" => "Listagem de mapas de arquivos",
"Reload" => "Recarregar",
"You can view this map in your browser using" => "Você pode ver este mapa em seu browser usando",
"Zoom out x2" => "Menos zoom x2",
"Zoom in x2" => "Mais zoom x2",
"Mapfile History" => "Histórico dos arquivos de mapa",
"of" => "de",
"Version:" => "Versão:",
"Compare" => "Comparar",
"Comparing version {\$old.version} with version {\$new.version}" => "Comparando versão {\$old.version} com a versão {\$new.version}",
"Current" => "Atual",
"Versions are identical" => "As versões são idênticas",
"Legend:" => "Legenda:",
"v=view" => "v=visualizar",
"c=compare" => "c=comparar",
"d=diff" => "d=visualizar diferentes versões",
"Ip" => "Ip",
"Diff" => "Difer",
"Older Version" => "Versão antiga",
// "{\$dir}" => "{\$dir}",
"Directories" => "Diretórios",
"back to" => "voltar para",
"Upload From Disk:" => "Carregar Do Disco:",
"Upload Files" => "Carregar Arquivos",
"Bytes maximum" => "Máximo de bytes",
"Create Directory:" => "Criar Diretório:",
"index file (.shp):" => "arquivo índice (.shp):",
"files to index (regexp):" => "arquivos para índice (regexp):",
"Message Archive" => "Arquivo de mensagens",
"messages" => "mensagens",
"Archive is full!" => "Arquivo está cheio!",
"Read" => "Lida",
"Unread" => "Não lida",
"Flagged" => "Selecionada",
"Unflagged" => "Não selecionada",
"Containing" => "Conteúdo",
"Sender" => "remetente",
"No messages to display" => "Nenhuma mensagem a exibir",
"Broadcast message" => "Enviar mensagem global",
// "Confirmation" => "Confirmation",
// "Please Confirm" => "Please Confirm",
"All users" => "Todos os usuários",
"Lowest" => "Mínima",
"Very High" => "Máxima",
"Send" => "Enviar",
"Compose message" => "Escreva mensagem",
"If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences." => "Se você quer receber respostas, habilite <a href='tiki-user_preferences.php'>Permitir mensagens de outros usuários</a> em suas preferencias.",
"ERROR" => "ERRO",
"Invalid" => "Inválido",
// "To: Multiple addresses can be separated with semicolons (\";\") or commas (\",\")" => "To: Multiple addresses can be separated with semicolons (\";\") or commas (\",\")",
"CC" => "CC",
// "CC: Multiple addresses can be separated with semicolons (\";\") or commas (\",\")" => "CC: Multiple addresses can be separated with semicolons (\";\") or commas (\",\")",
"BCC" => "BCC",
// "BCC: Multiple addresses can be separated with semicolons (\";\") or commas (\",\")" => "BCC: Multiple addresses can be separated with semicolons (\";\") or commas (\",\")",
// "Reply-to my email" => "Reply-to my email",
// "The user will be able to reply to you directly via email" => "The user will be able to reply to you directly via email",
// "Send me a copy" => "Send me a copy",
// "You will be sent a copy of this email" => "You will be sent a copy of this email",
"No messages to download" => "Nenhuma mensagem para baixar",
"Mailbox is full! Delete or archive some messages if you want to receive more messages." => "A caixa de entrada esta cheia! Delete ou arquive algumas mensagens para pode receber novas mensagens.",
"is reply to" => "respondendo à",
"Find replied message" => "encontrar mensagens respondidas",
"Mark as read" => "Marcar como lida",
"Mark as unread" => "Marcar como não lida",
"Mark as flagged" => "Marcar como selecionada",
"Mark as unflagged" => "Marcar como não selecionada",
"Mark" => "marca",
"Mailbox" => "Caixa de entrada",
"Compose" => "Escrever",
"Broadcast" => "Enviar para todos",
"Auto-archive age for read messages:" => "Arquivar automaticamente mensagens lidas depois de certo tempo:",
"Read message" => "Ler mensagem",
"Return to mailbox" => "Voltar para a Caixa de Entrada",
"replyall" => "responder a todos",
"Unflag" => "Desmarcar",
"Flag this message" => "Marcar esta mensagem",
"From:" => "De:",
"Cc" => "CC",
"Return to archive" => "Retornar para o arquivo",
"Return to outbox" => "Retornar para a caixa de saída",
"Sent Messages" => "Mensagens enviadas",
"Replied" => "Respondido",
"Not replied" => "Não respondido",
"move to archive" => "mover para o arquivo",
"receiver" => "destinatário",
"Move module up" => "Mover módulo para cima",
"Move module down" => "Mover módulo para baixo",
"Move module to opposite side" => "Mover módulo para o lado oposto",
"opp side" => "lado oposto",
"Unassign this module" => "Desabilitar este módulo",
"Are you sure you want to unassign this module?" => "Você tem certeza que deseja desabilitar este módulo?",
// "Toggle module contents" => "Toggle module contents",
// "toggle" => "toggle",
// "Toggle Vertically" => "Toggle Vertically",
"Display type unknown, you have to enter the banner type" => "Tipo desconhecido, você precisa especificar o tipo do banner",
"You forgot your Google ad_client number !" => "Você esqueceu o seu número ad_client do Google!",
"To configure your Tiki" => "Para configurar o seu Tiki",
"Admin Home" => "Administrar Página Inicial (Home)",
"from the menu" => "pelo menu",
// "Read the <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Tiki Documentation\" target=\"_blank\">configuration documentation</a>" => "Read the <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Tiki Documentation\" target=\"_blank\">configuration documentation</a>",
"Watch the <a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies" => "Assista aos <a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">vídeos de demonstração",
"To remove this module" => "Para remover este módulo",
"Admin Modules" => "Administrar Módulos",
"and remove the assistant module" => "e para remover o módulo de ajuda",
"You can also add other modules" => "Você também pode adicionar outros módulos",
"To customize the menu" => "Para customizar o menu",
"Admin Menus" => "Administrar Menus",
"and edit menu ID 42" => "e edite o menu de Id 42",
"Or, create your own menu and add it to a module" => "Ou crie o seu próprio menu e adicione-o a um módulo",
// "Login" => "Login",
"To begin configuring Tiki, please" => "Para começar a configurar o Tiki, por favor",
"login" => "login",
"as admin" => "como administrador",
// "The Tiki Community" => "The Tiki Community",
// "To learn more, visit: <a href=\"http://tiki.org\" title=\"The Tiki Community\" target=\"_blank\">http://tiki.org</a>" => "To learn more, visit: <a href=\"http://tiki.org\" title=\"The Tiki Community\" target=\"_blank\">http://tiki.org</a>",
// "Tiki Documentation" => "Tiki Documentation",
// "For help, visit <a href=\"http://doc.tiki.org\" title=\"Tiki Documentation\" target=\"_blank\">http://doc.tiki.org</a>" => "For help, visit <a href=\"http://doc.tiki.org\" title=\"Tiki Documentation\" target=\"_blank\">http://doc.tiki.org</a>",
// "Published on" => "Published on",
"private" => "privada",
// "on blogpost" => "on blogpost",
// "Untitled" => "Untitled",
// "{\$module_params.label|escape:\"html\"}" => "{\$module_params.label|escape:\"html\"}",
// "{\$crumbs[0]->description}" => "{\$crumbs[0]->description}",
"Add event" => "Adicionar evento",
// "Unit cost" => "Unit cost",
// "Qty" => "Qty",
// "Gift Certificate" => "Gift Certificate",
// "Remove Gift Certificate" => "Remove Gift Certificate",
// "Add Gift Certificate" => "Add Gift Certificate",
// "Check-out" => "Check-out",
// "Your cart is empty" => "Your cart is empty",
// "Missing %0 of the following categories" => "Missing %0 of the following categories",
// "%0 extra of the following categories" => "%0 extra of the following categories",
// "Unknown comparison" => "Unknown comparison",
// "Impossible condition, %0 of" => "Impossible condition, %0 of",
// "Assign into category" => "Assign into category",
// "{\$modcatlist[\$k].name|escape}" => "{\$modcatlist[\$k].name|escape}",
// "Unassign category" => "Unassign category",
// "{\$module_params.categorize}" => "{\$module_params.categorize}",
"Pages:" => "Páginas:",
// "{\$contributor.country|stringfix}" => "{\$contributor.country|stringfix}",
"Homepage" => "Site pessoal ou institucional",
// "1 more contributor" => "1 more contributor",
// "{\$hiddenContributors} more contributors" => "{\$hiddenContributors} more contributors",
"empty" => "vazio",
"low" => "baixa",
"Sites" => "Sites",
"Sites to validate" => "Sites a validar",
"Categories:" => "Categorias:",
"Visited links" => "Links visitados",
// "By" => "By",
// "hits" => "hits",
// "Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes" => "Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes",
// "Add tags" => "Add tags",
// "List everything tagged" => "List everything tagged",
"All Groups" => "Todos os grupos",
"Your Groups" => "Seus grupos",
// "Emulated Groups" => "Emulated Groups",
"Switch to Groups" => "Mudar para grupo",
"Simulate" => "Simular",
// "Add Post" => "Add Post",
"insert original" => "inserir original",
"insert thumbnail" => "inserir miniatura",
"more" => "mais",
// "Last %0 Podcasts" => "Last %0 Podcasts",
// "This is likely not a podcast file" => "This is likely not a podcast file",
// "The path to a podcast player is required" => "The path to a podcast player is required",
// "{\$link_text}" => "{\$link_text}",
"No avatar" => "Nenhum avatar",
"You" => "Você",
// "{\$data.info.title|escape:\"html\"}" => "{\$data.info.title|escape:\"html\"}",
"Open operator console" => "Abrir o console de operador",
"Execution time" => "Tempo de execução",
"Memory usage" => "Memória usada",
// "database queries used in " => "database queries used in ",
"Server load" => "Carga do servidor",
"Logged in as" => "Usuário:",
"Log out" => "Finalizar a sessão",
"Switch User" => "Trocar de usuário",
// "Enter user name and click 'Switch'.<br />Useful for testing permissions" => "Enter user name and click 'Switch'.<br />Useful for testing permissions",
"Switch" => "Alternar",
"Switch user" => "Trocar de usuário",
// "Log in through CAS" => "Log in through CAS",
"Log in as admin" => "Entrar como admin",
// "Log in through Shibboleth" => "Log in through Shibboleth",
"eMail" => "E-mail",
"CapsLock is on" => "CapsLock ligado",
"Click here if you've forgotten your password" => "Clique aqui se você esqueceu sua senha",
"I forgot my password" => "Esqueci minha senha",
"Click here to register" => "Clique aqui para registrar",
"Click here to login using the default security protocol" => "Clique aqui para autenticar o protocolo padrão",
"Standard" => "Padrão",
"Click here to login using a secure protocol" => "Clique aqui para se autenticar usando um protocolo seguro",
"Secure" => "Seguro",
"Stay in SSL mode" => "Permanecer no modo seguro",
"local account" => "conta local",
"OpenID Log in" => "OpenID",
"What is OpenID?" => "O que é OpenID?",
// "No acceptable field to store the feature was found in the specified tracker" => "No acceptable field to store the feature was found in the specified tracker",
"You have" => "Você possui",
"new messages" => "mensagens novas",
"new message" => "mensagem nova",
"You have 0 new messages" => "Você possui 0 mensagens novas",
// "No article found" => "No article found",
// "No blog post found" => "No blog post found",
"We have" => "Existem",
"submissions waiting to be examined" => "Artigos com aprovação pendente",
// "Stay on this page" => "Stay on this page",
// "Edit perspectives" => "Edit perspectives",
"Powered by" => "Provido por",
// "Tiki Wiki CMS Groupware" => "Tiki Wiki CMS Groupware",
"Made with" => "Criado com",
// "Search Terms" => "Search Terms",
// "Any type" => "Any type",
// "Admin home" => "Admin home",
"Modify the look &amp; feel (logo, theme, etc.)" => "Configurar aparência do site",
"Users" => "Usuários",
"Toggle interactive translation off" => "Desligar modo de tradução interativa",
"Toggle interactive translation on" => "Ligar modo de tradução interativa",
// "Theme Generator Editor" => "Theme Generator Editor",
// "Rebuild Search index" => "Rebuild Search index",
// "Plugin Approval" => "Plugin Approval",
"SysLogs" => "Logs do sistema",
// "Open Smarty debug window" => "Open Smarty debug window",
// "Wiki feed" => "Wiki feed",
"Feed" => "Campo",
// "Blogs feed" => "Blogs feed",
// "Articles feed" => "Articles feed",
// "Image Galleries feed" => "Image Galleries feed",
"Image Galleries" => "Galerias de imagens",
// "File Galleries feed" => "File Galleries feed",
// "Forums feed" => "Forums feed",
// "Maps feed" => "Maps feed",
"Maps" => "Mapas",
"Calendars" => "Calendários",
// "{\$tracker.name}" => "{\$tracker.name}",
"Entire Site" => "Todo o Site",
"Image Gals" => "Galeria de imagens",
// "Search for text throughout the site" => "Search for text throughout the site",
// "Go directly to a page, or search in page titles if exact match is not found" => "Go directly to a page, or search in page titles if exact match is not found",
// "Edit existing page or create a new one" => "Edit existing page or create a new one",
// "Page Relations" => "Page Relations",
// "Are you sure you want to delete this shout" => "Are you sure you want to delete this shout",
// "Tweet with Twitter" => "Tweet with Twitter",
// "Post on my Facebook wall" => "Post on my Facebook wall",
// "Shout date" => "Shout date",
// "Delete this shout" => "Delete this shout",
// "Edit this shout" => "Edit this shout",
"Read More" => "Ler Mais",
"Since your last visit on" => "Desde sua última visita em",
"New Images" => "Novas imagens",
"Wiki Pages Changed" => "Páginas Wiki alteradas",
"New Files" => "Novos arquivos",
"New Comments" => "Novos comentários",
"New Tracker Items" => "Novos itens de formulário",
"New Calendar Events" => "Novos eventos no calendário",
"New Users" => "Novos usuários",
"click to edit" => "clique para editar",
"Nothing has changed" => "Nenhuma alteração",
// "Updated" => "Updated",
"Multiple" => "Múltiplos(as)",
"including" => "incluindo",
// "Site default" => "Site default",
// "Find term" => "Find term",
// "{\$user_languages[ix].name}" => "{\$user_languages[ix].name}",
// "If not found, you will be given a chance to create it" => "If not found, you will be given a chance to create it",
// "TikiTests Menu" => "TikiTests Menu",
// "List Tests" => "List Tests",
"Create Test" => "Criar Teste",
"Top galleries" => "Galerias mais visitadas",
// "Posted to" => "Posted to",
"(Read More)" => "(ler mais)",
// "Missing values" => "Missing values",
// "Add Marker" => "Add Marker",
// "Tracker name" => "Tracker name",
// "Insert fields in wiki textarea" => "Insert fields in wiki textarea",
"There are no translations of this page." => "Não há traduções desta página.",
// "Up-to-date-ness" => "Up-to-date-ness",
// "Incoming" => "Incoming",
// "To <strong>continue translating</strong>, select the language to translate from" => "To <strong>continue translating</strong>, select the language to translate from",
// "update from it" => "update from it",
// "None match your" => "None match your",
// "Set your preferred languages" => "Set your preferred languages",
// "preferred languages" => "preferred languages",
"view" => "ver",
// "Outgoing" => "Outgoing",
// "update it" => "update it",
"click to view" => "clique para ver",
"Add Event" => "Adicionar evento",
"Bookmarks" => "Favoritos",
// "Create Bookmark" => "Create Bookmark",
// "New Folder" => "New Folder",
"Done" => "pronto",
"Del" => "Del",
"select" => "selecionar",
// "{\$user_groups[ix].groupName|escape}" => "{\$user_groups[ix].groupName|escape}",
// "Group information" => "Group information",
"You need to activate user and/or group trackers" => "Você precisa ativar o formulário para usuário e/ou grupo",
// "%0 out of %1 users" => "%0 out of %1 users",
// "Webmail inbox" => "Webmail inbox",
// "Refresh (non-ajax)" => "Refresh (non-ajax)",
// "TAKE" => "TAKE",
// "View contact" => "View contact",
"online users" => "usuários on-line",
"online user" => "usuário on-line",
"on host" => "no servidor",
// "User does not accept messages" => "User does not accept messages",
"Send a message to" => "Enviar uma mensagem para",
"Send a message" => "Enviar mensagem",
// "More Videos" => "More Videos",
// "No results" => "No results",
// "No results were found. Are you sure you searched for a tag" => "No results were found. Are you sure you searched for a tag",
// "We are not autorized to access the group at this time. If you have access to the Zotero group, you can grant this site read access" => "We are not autorized to access the group at this time. If you have access to the Zotero group, you can grant this site read access",
"No individual permissions, category permissions apply" => "Nenhuma permissão individual, utilizando permissões da categoria",
// "There are individual permissions set for this object" => "There are individual permissions set for this object",
"No individual permissions. Global permissions apply." => "Nenhuma permissão individual, permissões globais em efeito",
// "Session" => "Session",
// "Old Session" => "Old Session",
// "Old Version" => "Old Version",
// "New Session" => "New Session",
// "New Version" => "New Version",
"Minimum %0 characters long" => "No mínimo %0 letras",
// "[-]" => "[-]",
"vote" => "votar",
// "Requires" => "Requires",
"You need to set" => "Você precisa definir",
// "Separator is " => "Separator is ",
// "Reset to default" => "Reset to default",
// "Restore current value" => "Restore current value",
"Rate" => "Classificação",
"A valid email is mandatory to register" => "É necessário um e-mail válido para poder se registrar",
// "{\$customfields[ir].label}" => "{\$customfields[ir].label}",
// "{\$gr.groupDesc|escape}" => "{\$gr.groupDesc|escape}",
// "Use your email as login" => "Use your email as login",
"Lowercase only" => "apenas minúsculas",
"Repeat password" => "Confirmação de senha",
"Generate a password" => "Gerar uma senha",
// "Passcode to register" => "Passcode to register",
// "Not your password" => "Not your password",
// "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}" => "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}",
// "The passcode (to block robots from registration) is" => "The passcode (to block robots from registration) is",
// "{\$remarksbox_type}" => "{\$remarksbox_type}",
// "{\$result.object_type|escape}" => "{\$result.object_type|escape}",
"Last modification" => "Última alteração",
"No pages matched the search criteria" => "Nenhuma página atendeu aos seus critérios de busca",
// "Download Log File" => "Download Log File",
"Send Newsletter" => "Enviar newsletter",
"To edit the copyright notices" => "Para editar as mensagens de diretos autorais",
"The content on this page is licensed under the terms of the" => "O conteúdo desta página é licenciado sob os termos do",
// "Page alias.." => "Page alias..",
// "Monitor the Sub-Structure" => "Monitor the Sub-Structure",
// "Stop Monitoring the Sub-Structure" => "Stop Monitoring the Sub-Structure",
// "locked by %0" => "locked by %0",
"Locked" => "Travada",
"Edit page" => "Editar página",
// "Add new child page" => "Add new child page",
// "Jump to Content" => "Jump to Content",
"Fullscreen" => "Modo tela cheia",
"Cancel Fullscreen" => "Sair do modo tela cheia",
"Show/Hide Left Column" => "Mostrar/esconder menus do lado esquerdo",
"Show/Hide Right Column" => "Mostrar/esconder menus do lado direito",
// "Module errors" => "Module errors",
// "The following modules could not be loaded" => "The following modules could not be loaded",
// "absE" => "absE",
// "Design by" => "Design by",
"comments" => "comentários",
// "More search options" => "More search options",
"Edit this page" => "Editar esta página",
// "View latest version before editing" => "View latest version before editing",
"Rename" => "Renomear",
"Contributions by author" => "Contribuições por autor",
"Similar" => "Similar",
"Make Structure" => "Criar estrutura",
"Discuss" => "Discutir",
"Attach File" => "Anexar",
"1 File Attached" => "1 arquivo anexado",
// "{\$atts|@count} files attached" => "{\$atts|@count} files attached",
// "Bookmark" => "Bookmark",
// "Edit This Tracker" => "Edit This Tracker",
"Edit Fields" => "Editar campos",
// "Create Item" => "Create Item",
// "View Items" => "View Items",
"Preview your changes." => "Pré-visualizar suas alterações.",
"Edit wiki page" => "Editar página wiki",
"Save the page as a partial translation." => "Salvar página como tradução parcial.",
"Partial Translation" => "Tradução parcial",
"Save the page as a completed translation." => "Salvar a página como uma tradução completa.",
"Complete Translation" => "Tradução completa",
// "Save the page, but do not count it as new content to be translated" => "Save the page, but do not count it as new content to be translated",
"Save the page, but do not send notifications and do not count it as new content to be translated." => "Salvar a página, mas não enviar notificações e não contar como novo conteúdo a ser traduzido.",
"Save Minor Edit" => "Menor",
"Save the page." => "Salvar página.",
"Cancel the edit, you will lose your changes." => "Cancele a edição, você perderá suas alterações.",
// "Designed originally by" => "Designed originally by",
// "* PREVIEW *" => "* PREVIEW *",
// "Modifying" => "Modifying",
// "Toggle checkboxes" => "Toggle checkboxes",
// "Toggle changed" => "Toggle changed",
// "Live preview" => "Live preview",
// "Reset selected" => "Reset selected",
// "Found in" => "Found in",
// "Changed from %0 to %1" => "Changed from %0 to %1",
// "Unchanged" => "Unchanged",
// "No definitions found" => "No definitions found",
// "No types found" => "No types found",
// "This book" => "This book",
"Start date" => "Data de início",
// "before" => "before",
// "after" => "after",
// "don't display" => "don't display",
// "Decimals" => "Decimals",
// "Decimal Point" => "Decimal Point",
// "Auto Tax" => "Auto Tax",
"Tasks" => "Tarefas",
// "Book new entries" => "Book new entries",
// "Confirm stack entries" => "Confirm stack entries",
// "Book into Stack" => "Book into Stack",
"Accounts" => "Contas",
// "Bank acounts" => "Bank acounts",
// "Journal" => "Journal",
// "Fetch all" => "Fetch all",
"Account" => "Conta",
// "Successfully deleted account %0 %1" => "Successfully deleted account %0 %1",
// "Return to main accounting page" => "Return to main accounting page",
"Create new account" => "Criar nova conta",
"Edit Account" => "Editar conta",
"Account number" => "Número da conta",
"Account name" => "Nome da conta",
"Notes" => "Notas",
// "Budget" => "Budget",
// "Create account" => "Create account",
// "Modify account" => "Modify account",
// "Delete this account" => "Delete this account",
// "Back to book page" => "Back to book page",
// "Debit" => "Debit",
// "Credit" => "Credit",
// "Tax" => "Tax",
// "edit account" => "edit account",
// "unlock account" => "unlock account",
// "Are you sure you want to unlock this account" => "Are you sure you want to unlock this account",
// "lock account" => "lock account",
// "Are you sure you want to lock this account" => "Are you sure you want to lock this account",
// "delete account" => "delete account",
// "Are you sure, you want to delete this account" => "Are you sure, you want to delete this account",
// "Create a new account" => "Create a new account",
// "printable version" => "printable version",
// "export table" => "export table",
// "View account" => "View account",
// "Edit this account" => "Edit this account",
// "My books" => "My books",
// "Tax automation" => "Tax automation",
"hide" => "esconder",
// "behind" => "behind",
// "Are you sure, you want to close this book" => "Are you sure, you want to close this book",
// "close book" => "close book",
// "Create a book" => "Create a book",
// "Book properties" => "Book properties",
// "Name of the book" => "Name of the book",
// "First date in journal" => "First date in journal",
// "Last date in journal" => "Last date in journal",
// "Currency settings" => "Currency settings",
// "Currency (up to 3 letters) " => "Currency (up to 3 letters) ",
// "Position of the currency " => "Position of the currency ",
// "Show no currency" => "Show no currency",
// "Show currency in front of numbers" => "Show currency in front of numbers",
// "Show currency behind numbers" => "Show currency behind numbers",
// "Decimal point" => "Decimal point",
// "Decimal" => "Decimal",
// "Thousands separator" => "Thousands separator",
// "Quote strings with" => "Quote strings with",
// "End of Line" => "End of Line",
// "Carriage return" => "Carriage return",
// "Line feed" => "Line feed",
// "Carriage Return/Line feed" => "Carriage Return/Line feed",
// "Automatic Tax Calculation" => "Automatic Tax Calculation",
// "Allow automatic tax calculation" => "Allow automatic tax calculation",
// "Create a new book" => "Create a new book",
// "The following transaction has been cancelled" => "The following transaction has been cancelled",
"id" => "id",
// "booking date" => "booking date",
// "Amount" => "Amount",
// "Book a transaction" => "Book a transaction",
// "Add entry" => "Add entry",
// "Book" => "Book",
// "Export {\$what}" => "Export {\$what}",
// "Export CSV settings" => "Export CSV settings",
// "Separator between fields" => "Separator between fields",
// "Quote character for text" => "Quote character for text",
"Export as CSV" => "Exportar como CSV",
// "cancel this transaction" => "cancel this transaction",
// "Are you sure you want to cancel this transaction" => "Are you sure you want to cancel this transaction",
// "Balance" => "Balance",
// "Deleted" => "Deleted",
// "Debit Account" => "Debit Account",
// "Debit Amount" => "Debit Amount",
// "Debit Text" => "Debit Text",
// "Credit Account" => "Credit Account",
// "Credit Amount" => "Credit Amount",
// "Credit Text" => "Credit Text",
// "Book a transaction into the stack" => "Book a transaction into the stack",
// "delete this transaction from the stack" => "delete this transaction from the stack",
// "Are you sure you want to delete this transaction from stack" => "Are you sure you want to delete this transaction from stack",
// "confirm this transaction" => "confirm this transaction",
// "Are you sure you want to confirm this transaction" => "Are you sure you want to confirm this transaction",
// "Do not group by item" => "Do not group by item",
// "Group by item" => "Group by item",
"Calendar View" => "Ver em forma de calendário",
// "Tiki Action Calendar" => "Tiki Action Calendar",
"Tools Calendars" => "Calendários de Ferramentas",
"Check / Uncheck All" => "Marcar / desmarcar todos",
// "Your sender email is not set. You can set it <a href=\"%0\">here</a>" => "Your sender email is not set. You can set it <a href=\"%0\">here</a>",
// "Preference Filters" => "Preference Filters",
// "Set as my default" => "Set as my default",
"Configuration search" => "Buscar configuração",
// "Note: The search index needs rebuilding, this will take a few minutes" => "Note: The search index needs rebuilding, this will take a few minutes",
// "Potential Cross-Site Request Forgery" => "Potential Cross-Site Request Forgery",
// "Search error" => "Search error",
// "Preferences Search Results" => "Preferences Search Results",
// "No preferences were found for your search query" => "No preferences were found for your search query",
"Database Version Problem" => "Problema com a versão da base de dados",
// "Your database requires an update to match the current Tiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provokes errors" => "Your database requires an update to match the current Tiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provokes errors",
// "A new version of Tiki, <b>{\$prefs.tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tiki.org/Download\">tiki.org/Download</a>" => "A new version of Tiki, <b>{\$prefs.tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tiki.org/Download\">tiki.org/Download</a>",
"Enabled" => "Habilitado",
"Changed" => "Mudou",
"Preference" => "Preferência",
// "{\$tikifeedback[n].mes|stringfix}" => "{\$tikifeedback[n].mes|stringfix}",
"Preference name" => "Nome da preferência",
"Crosslinks to other features and settings" => "Links para outros recursos e configurações relacionados",
"Administration features" => "Recursos de administração",
"TikiCache/System" => "Tiki Cache/Sistema",
"phpinfo" => "phpinfo",
"Mods" => "Mods",
"Transversal features" => "Recursos transversais",
"which apply to more than one section" => "que se aplicam a mais de uma seção",
"Mail Notifications" => "Notificações por e-mail",
"Navigation features" => "Recursos de navegação",
"Text area features" => "Recursos de área de texto",
"features you can use in all text areas, like wiki pages, blogs, articles, forums, etc" => "recursos que você pode usar em todas as áreas de texto, como páginas wiki, blogs, artigos, fóruns etc",
"Cookies" => "Cookies",
"External Pages Cache" => "Cache de páginas externas",
"External Wikis" => "Wikis externos",
// "Please select some actions to be reported" => "Please select some actions to be reported",
"Start:" => "Início:",
"End:" => "Fim:",
// "Users and Groups" => "Users and Groups",
"Misc" => "Misc",
// "Units" => "Units",
// "kb" => "kb",
// "Contibution Time" => "Contibution Time",
// "Graph Contributions" => "Graph Contributions",
// "Group Bar Plot" => "Group Bar Plot",
// "Accumulated Bar Plot" => "Accumulated Bar Plot",
"Background color:" => "Cor de fundo:",
// "{\$color}" => "{\$color}",
// "Legend background color" => "Legend background color",
// "Save graphs to image gallery" => "Save graphs to image gallery",
// "See Statistics" => "See Statistics",
"Records:" => "Registros:",
// "contribution" => "contribution",
// "contributor" => "contributor",
// "{\$actionlog.action|escape}" => "{\$actionlog.action|escape}",
// "{\$actionlog.objectType}" => "{\$actionlog.objectType}",
// "{\$actionlog.ip}" => "{\$actionlog.ip}",
// "Ban" => "Ban",
"Edit Action" => "Editar ação",
"Save Action" => "Salvar ação",
"Statistics" => "Estatísticas",
// "Volumes are equally distributed on each contributors/author" => "Volumes are equally distributed on each contributors/author",
// "connection time" => "connection time",
// "connection seconds" => "connection seconds",
// "mns" => "mns",
// "Volume per category" => "Volume per category",
// "Volume per category and per user" => "Volume per category and per user",
// "Number of actions per user" => "Number of actions per user",
"Total number of users" => "Número total de usuários",
// "Number of actions per object" => "Number of actions per object",
"Total number of objects" => "Número total de objetos",
// "Number of actions per category" => "Number of actions per category",
// "Number of actions per category and per user" => "Number of actions per category and per user",
// "Volume per the users' group and per contribution" => "Volume per the users' group and per contribution",
// "Volume per group and per contribution" => "Volume per group and per contribution",
// "Volume per user and per contribution" => "Volume per user and per contribution",
// "Volume per users' contribution and time" => "Volume per users' contribution and time",
// "Volume per contribution and time" => "Volume per contribution and time",
"Weeks" => "Semanas",
"Setting" => "Configurar",
// "How" => "How",
// "You need to check out the recorded box for each action type we may be interested to have some report later. To see a report of some action types, select the reported checkboxes of these action types, goto the Report tab and select additional filters. The report will only contains the actions that occurred since the action type has been set to recorded" => "You need to check out the recorded box for each action type we may be interested to have some report later. To see a report of some action types, select the reported checkboxes of these action types, goto the Report tab and select additional filters. The report will only contains the actions that occurred since the action type has been set to recorded",
// "Wiki page actions except viewed will always be recorded but can be not reported" => "Wiki page actions except viewed will always be recorded but can be not reported",
// "Recorded" => "Recorded",
// "Reported" => "Reported",
// "{\$actionlog.action}" => "{\$actionlog.action}",
// "Import as CSV" => "Import as CSV",
// "Banning rules have been updated" => "Banning rules have been updated",
// "Add or edit rules" => "Add or edit rules",
"Rule title" => "Título da regra",
"Username regex matching" => "Identificador de usuário por expressão regular",
// "Multiple IP regex matching" => "Multiple IP regex matching",
"IP regex matching" => "IP por expressão regular",
"Banned from sections" => "Banido(a) das seções",
// "{\$sec}" => "{\$sec}",
"Rule activated by dates" => "Regra ativada por datas",
"Rule active from" => "Regra ativa de",
"Rule active until" => "Regra ativa até",
"Custom message to the user" => "Mensagem personalizada para o usuário",
// "Import rules as CSV" => "Import rules as CSV",
"CSV File" => "Arquivo CSV",
// "Column names on the first line" => "Column names on the first line",
// "Sections format" => "Sections format",
// "section names are splitted by pipes (vertical bars). To see an example and use it as template, add one rule by hand, and export it as csv" => "section names are splitted by pipes (vertical bars). To see an example and use it as template, add one rule by hand, and export it as csv",
// "See" => "See",
// "Import as new rules" => "Import as new rules",
"import" => "importar",
"Find:" => "Localizar:",
"Rules" => "Regras",
"x" => "x",
"User/IP" => "Usuário/IP",
"Sections" => "Seções",
"Admin Calendars" => "Administrar Calendários",
// "Create Calendar" => "Create Calendar",
// "View Calendars" => "View Calendars",
"List of Calendars" => "Lista de Calendários",
// "Calendar name" => "Calendar name",
"Loc" => "Loc",
"Participants" => "Participantes",
"Cat" => "Cat",
"Lang" => "Lang",
"Prio" => "Prio",
"Subscription" => "Inscrições",
// "Perso" => "Perso",
// "View Calendar" => "View Calendar",
"Edit Calendar" => "Editar calendário",
"Custom Locations" => "Locais Personalizados",
"Custom Participants" => "Personalizar participantes",
// "Custom Classifications" => "Custom Classifications",
"Custom Languages" => "Idiomas Personalizados",
// "Custom URL" => "Custom URL",
"Custom Subscription List" => "Personalizar lista de inscrições",
"Custom Priorities" => "Prioridades Personalizadas",
"Personal Calendar" => "Calendário pessoal",
"Start of day" => "Início do dia",
"End of day" => "Fim do dia",
// "Days to display" => "Days to display",
// "Standard Colors" => "Standard Colors",
// "Green" => "Green",
// "Blue" => "Blue",
// "Purple" => "Purple",
"Red" => "Vermelho",
// "Orange" => "Orange",
// "Yellow" => "Yellow",
// "Custom foreground color" => "Custom foreground color",
// "Ex" => "Ex",
// "Custom background color" => "Custom background color",
// "Default event status" => "Default event status",
// "Show in calendar view" => "Show in calendar view",
// "Group of users alerted when calendar event is modified" => "Group of users alerted when calendar event is modified",
// "Default event to all day" => "Default event to all day",
// "Event name on each day in calendar view" => "Event name on each day in calendar view",
// "Delete events older than" => "Delete events older than",
// "Browse the category system" => "Browse the category system",
"Current category" => "Categoria atual",
"Current Category ID" => "ID da categoria atual",
"Create/Edit category" => "Criar/editar categoria",
"Edit this category:" => "Editar esta categoria:",
"Add new category" => "Adicionar uma nova categoria",
// "Apply parent category permissions" => "Apply parent category permissions",
"Batch upload" => "Carga em lote",
"Batch upload (CSV file)" => "Carga em lote (arquivo CSV)",
"Objects in category" => "Objetos na categoria",
"Remove from this Category" => "Remover dessa categoria",
// "{\$objects[ix].type}" => "{\$objects[ix].type}",
"Moving objects between categories" => "Mover objetos entre categorias",
"Unassign all objects from this category" => "Retirar todos os objetos dessa categoria",
// "Move all the objects from this category to this one" => "Move all the objects from this category to this one",
// "Assign all objects of this category to this one" => "Assign all objects of this category to this one",
"Add objects to category" => "Adicionar objetos à categoria",
"image gal" => "gal. imagem",
"File gal" => "Galeria de arquivos",
"Admin templates" => "Administrar padrões",
"Use the Administration page of each enabled feature to allow the use of content templates" => "Use a página de administração de cada recurso para habilitar o uso de padrões de conteúdo",
"Edit this template:" => "Editar este padrão:",
"Create new template" => "Criar um novo padrão",
"Name field is mandatory" => "O campo nome é obrigatório",
"Use in" => "Usar em",
"CMS" => "CMS",
"HTML Pages" => "Páginas HTML",
"No features are configured to use templates." => "Não há recursos configurados para usar templates.",
"Template Type" => "Tipo do padrão",
"Text area" => "Área de texto",
// "Is HTML" => "Is HTML",
"Templates" => "Padrões",
// "Visible in no sections" => "Visible in no sections",
// "Remove section" => "Remove section",
"Admin Contributions" => "Contribuições do Administrador",
// "Edit the contribution" => "Edit the contribution",
// "Contributions are mandatory in wiki pages" => "Contributions are mandatory in wiki pages",
// "Contributions are mandatory in forums" => "Contributions are mandatory in forums",
// "Contributions are mandatory in comments" => "Contributions are mandatory in comments",
// "Contributions are mandatory in blogs" => "Contributions are mandatory in blogs",
// "Contributions are displayed in the comment/post" => "Contributions are displayed in the comment/post",
// "Create a new contribution" => "Create a new contribution",
// "List of contributions" => "List of contributions",
"Admin cookies" => "Administrar cookies",
// "To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}" => "To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}",
"Create/edit cookies" => "Criar/editar cookies",
"Upload Cookies from textfile" => "Carregar Cookies a partir de arquivo texto",
"Upload from disk:" => "Carregar do disco:",
"Upload" => "Carregar",
"Remove all cookies" => "Remover todos cookies",
"cookie" => "cookie",
// "Manage Credits" => "Manage Credits",
// "(YYYY-MM-DD HH:MM:SS)" => "(YYYY-MM-DD HH:MM:SS)",
// "(level credits always 0)" => "(level credits always 0)",
// "Delete Checked" => "Delete Checked",
// "User Credits Expiry Summary (Plans)" => "User Credits Expiry Summary (Plans)",
// "User Plan" => "User Plan",
// "Start of Latest Plan" => "Start of Latest Plan",
// "Start of Next Plan" => "Start of Next Plan",
// "Expiry" => "Expiry",
// "Use User Credits" => "Use User Credits",
// "Restore User Level Credits" => "Restore User Level Credits",
// "Historical Usage Report" => "Historical Usage Report",
"all types" => "todos os tipos",
"filter" => "filtro",
// "Usage Date" => "Usage Date",
// "Amount Used" => "Amount Used",
// "Manage Credit Types" => "Manage Credit Types",
// "Display Text" => "Display Text",
// "Unit Text" => "Unit Text",
// "Is Static Level Credit" => "Is Static Level Credit",
// "Display Bar Length Scaling Divisor" => "Display Bar Length Scaling Divisor",
// "Purge Expired and Used Credits (All Users)" => "Purge Expired and Used Credits (All Users)",
// "Purge" => "Purge",
// "Admin Content Sources" => "Admin Content Sources",
// "Use Admin DSN to define the database to be used by the SQL plugin" => "Use Admin DSN to define the database to be used by the SQL plugin",
// "Create/edit DSN" => "Create/edit DSN",
// "Local (Tiki database)" => "Local (Tiki database)",
// "See db/local.php" => "See db/local.php",
// "Content Authentication" => "Content Authentication",
// "Identification" => "Identification",
// "HTTP Basic" => "HTTP Basic",
// "HTTP Session / Login" => "HTTP Session / Login",
// "HTTP Session / Visit" => "HTTP Session / Visit",
// "Admin External Wikis" => "Admin External Wikis",
"Create/Edit External Wiki" => "Criar/editar Wiki Externo",
"URL (use \$page to be replaced by the page name in the URL example: http://www.example.com/tiki-index.php?page=\$page)" => "Endereço (use \$page para substituir pelo nome da página na URl. Exemplo: http://www.exemplo.com.br/tiki-index.php?page=\$page)",
"ExtWiki" => "Wikiext",
"Admin Forums" => "Administrar Fóruns",
"Create New Forum" => "Criar um Novo Fórum",
// "Duplicate Forum" => "Duplicate Forum",
"View this forum" => "Ver esse fórum",
"Import forums" => "Importar fórum",
"List forums" => "Listar fóruns",
"Coms" => "Coms",
"Age" => "Idade",
"PPD" => "Ppd",
"..." => "...",
// "Create/Edit Forums" => "Create/Edit Forums",
"Edit this Forum:" => "Editar este Fórum:",
"Prevent flooding" => "Prevenir-se contra sobrecarga",
"Minimum time between posts" => "Tempo mínimo entre mensagens",
"Create new" => "Criar nova",
"Moderator user" => "Usuário moderador",
"Moderator group" => "Grupo moderador",
"Password protected" => "Protegido por senha",
"Forum password" => "Senha do fórum",
"Only allow replies to the first message (flat forum)" => "Apenas permitir respostas a primeira mensagem",
"Send this forums posts to this email" => "Enviar as mensagens deste fórum para o seguinte e-mail",
"Prune unreplied messages after" => "Mensagens não respondidas expiram após",
"Prune old messages after" => "Mensagens antigas expiram após",
"Topic list configuration" => "Configuração da lista de assuntos",
// "Last post title" => "Last post title",
// "Last post avatar" => "Last post avatar",
// "Author avatar" => "Author avatar",
"Posts can be rated" => "Mensagens podem receber notas",
"Display last post titles" => "Mostrar os títulos das últimas postagens",
"Forward messages to this forum to this e-mail address, in a format that can be used for sending back to the inbound forum e-mail address" => "Direcionar mensagens deste fórum para este endereço de e-mail, em um formato que possa ser usado para enviar mensagens de volta",
"Send mails even when the post is generated by inbound mail" => "Enviar e-mails mesmo quando a mensagem for gerada por lixo eletrônico",
// "Append a reply link to outbound mails" => "Append a reply link to outbound mails",
"Originating e-mail address for mails from this forum" => "Originar endereços de e-mail para mensagens deste fórum",
"Add messages from this email to the forum" => "Adicionar mensagens do seguinte e-mail para este fórum",
"POP3 server" => "Servidor POP3",
"Use topic smileys" => "Usar emoticons nos assuntos",
"Show topic summary" => "Exibir sumário dos assuntos",
"User information display" => "Exibição de informações dos usuários",
"Online" => "On-line",
"Approval type" => "Tipo de aprovação",
"Store attachments in:" => "Armazenar arquivos anexados em:",
"Max attachment size (bytes)" => "Tamanho máximo para arquivo anexado (bytes)",
// "Shows number of attachments of the all thread in forum list" => "Shows number of attachments of the all thread in forum list",
"Set topics preferences" => "Definir preferências dos tópicos",
"Show topics preferences" => "Mostrar preferências dos tópicos",
"hide topics preferences" => "Esconder preferências dos tópicos",
"Default ordering for topics" => "Ordenação padrão para os assuntos",
"Topics per page" => "Assuntos por página",
// "Set thread preferences" => "Set thread preferences",
// "Show threads preferences" => "Show threads preferences",
// "hide threads preferences" => "hide threads preferences",
"Default ordering for threads" => "Ordenação padrão para as seqüências",
// "Default style for threads" => "Default style for threads",
// "Duplicate perms" => "Duplicate perms",
"Admin Hotwords" => "Administrar Palavras-Chaves",
"Add Hotword" => "Adicionar Palavra-chave",
"Word" => "Palavra",
// "Admin HTML Page Dynamic Zones" => "Admin HTML Page Dynamic Zones",
"Admin HTML pages" => "Administrar páginas HTML",
"View page" => "Ver página",
"Edit zone" => "Editar zona",
"Dynamic zones" => "Zonas dinâmicas",
"zone" => "zona",
"content" => "conteúdo",
"Mass update" => "Atualização em massa",
"Create new HTML page" => "Criar nova página HTML",
// "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones" => "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones",
"Edit this HTML page:" => "Editar esta página HTML:",
"Apply template" => "Aplicar um padrão",
// "{\$templates[ix].name}" => "{\$templates[ix].name}",
"Dynamic" => "Dinâmica",
"Static" => "Estática",
// "Refresh rate (if dynamic)" => "Refresh rate (if dynamic)",
"Last Modif" => "última modificação",
// "Admin dynamic zones" => "Admin dynamic zones",
// "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> feature" => "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> feature",
"Edit Repository:" => "Editar Repositório:",
"Create New Repository" => "Criar Novo Repositório",
"List Repositories" => "Listar repositórios",
"New Repository" => "Novo repositório",
"View Repository" => "Ver repositório",
"Human-readable repository name" => "Nome de repositório humanamente legível",
"Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')" => "Caminho do repositório (sistema de arquivos local: relativo/absoluto, remoto: prefixado com 'http://')",
"File name of start page" => "Nome do arquivo da página de início",
"Start page" => "Página de início",
"CSS file to load when browse this repository" => "Carregar arquivo CSS quando navegar este repositório",
"CSS File" => "Arquivo CSS",
"Is repository visible to users" => "repositório visível para usuários",
"Can files from repository be cached" => "Arquivos do repositório podem ser armazenados",
"Cacheable" => "Armazenáveis",
"Are files from repository can be cached" => "Arquivos do repositório podem ser armazenados",
"Clear all cached pages of this repository" => "Limpar todas as páginas armazenadas deste repositório",
"Clear cache" => "Limpar cache",
"Seconds count 'till cached page will be expired" => "Segundos não podem ser contados até o armazenamento de páginas expirar",
"Cache expiration" => "Expiração do cache",
"Human-readable text description of repository" => "Descrição humanamente legível do repositório",
"Available Repositories" => "Repositórios Disponíveis",
"Edit rules" => "Edit regras",
"Edit Rules for Repository:" => "Editar Regras para o Repositório:",
"Configure Repositories" => "Configurar repositórios",
"Configure this Repository" => "Configurar este repositório",
"View this Repository" => "Ver este repositório",
"New Rule" => "Nova regra",
"Copy Rules" => "Copiar regras",
"view/hide copy rules dialog" => "ver/esconder copiar diálogo de regras",
"Source repository" => "Repositório de origem",
"Copy" => "Copiar",
"According this order rules will be applied ('0' or empty = auto)" => "De acordo com esta ordem de regras pode ser aplicada ('0' ou vazio = auto)",
"Rule order" => "Ordenação de regra",
"Text to search for" => "Buscar por texto",
"Text to replace" => "Texto para trocar",
"Is this regular expression or simple search/replacer" => "É uma expressão regular ou busca simples/alteração",
"Regex" => "Regex",
"Is case sensitive (for simple replacer)" => "É sensível a maiúsculas e minúsculas (para troca simples)",
"Case sensitive" => "Sensível a caixa",
"subset of chars: imsxeADSXUu, which is regex modifiers" => "subconjunto de caracteres: imsxeADSXUu, os quais a expressão regular modifica",
"Regex modifiers" => "Modificadores de Regex",
"Human-readable text description of rule" => "Texto humanamente legível de descrição de regra",
"Check to enable this rule" => "Selecione para habilitar esta regra",
"Preview options" => "Pré-visualizar opções",
"Apply all rules or just this to generate preview" => "Aplicar todas as regras ou somente esta para gerar a pré-visualização",
"Apply all rules" => "Aplicar todas as regras",
"View source code after rules applied" => "Ver o código-fonte depois que as regras foram aplicadas",
"Code preview" => "Pré-visualização de código",
"Generate HTML preview" => "Gerar pré-visualização HTML",
"HTML preview" => "Pré-visualização HTML",
"Test file from repository to generate preview for (empty = configured start page)" => "Testar arquivo do repositório para gerar pré-visualização para (vazio = página de início configurada)",
"Preview Results" => "Resultados de Pré-visualização",
"Rules List" => "Lista de Regras",
"Case" => "Caixa",
"Configure/Options" => "Configurar/Opções",
// "Admin Invoices" => "Admin Invoices",
// "Admin keywords" => "Admin keywords",
// "Keywords have been updated" => "Keywords have been updated",
// "Updating keywords has failed. Page probably doesn't exist" => "Updating keywords has failed. Page probably doesn't exist",
// "Edit page keywords" => "Edit page keywords",
// "Current Page Keywords" => "Current Page Keywords",
// "Search by page" => "Search by page",
"results found" => "resultados encontrados",
"No pages found" => "Nenhuma página encontrada",
"Admin layout" => "Administrar layout",
"Theme control" => "Controle de temas",
"layout options" => "opções de layout",
// "{\$sections[ix].name}" => "{\$sections[ix].name}",
"Right column" => "Coluna da direita",
"Top bar" => "Barra superior",
"Bottom bar" => "Barra inferior",
// "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>" => "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>",
"Generate positions by hits" => "Gerar posições por número de acessos",
"List of featured links" => "Lista de links oferecidos",
"Add Featured Link" => "Adicionar Link Oferecido",
"Edit this Featured Link:" => "Editar este Link Oferecido:",
"Create new Featured Link" => "Criar um novo Link Oferecido",
"disables the link" => "desabilita este link",
"Link type" => "Tipo de link",
"replace current page" => "substituir a página atual",
"framed" => "em frame",
"open new window" => "abrir em nova janela",
"Mail-in accounts" => "Contas de Mail-in",
// "{\$accounts[ix].type}" => "{\$accounts[ix].type}",
"Add new Mail-in account" => "Adicionar nova conta de Mail-in",
"Edit Mail-in account" => "Editar conta de Mail-in",
"POP server" => "Servidor POP",
"SMTP server" => "Servidor SMTP",
"SMTP requires authentication" => "Servidor SMTP requer autenticação",
// "article-put" => "article-put",
"wiki-get" => "wiki-get",
"wiki-put" => "wiki-put",
"wiki-append" => "wiki-append",
"Article Topic" => "Tópico de artigo",
"Admin Topics" => "Administrar Assuntos",
"Article Type" => "Tipo de artigo",
// "{\$types[t].type}" => "{\$types[t].type}",
"Admin Types" => "Administrar tipos de artigos",
"Active" => "Ativo",
"Allow anonymous access" => "Permitir acesso anônimo",
"Allow attachments" => "Permitir anexos",
// "Discard to the end from" => "Discard to the end from",
"Check Mail-in accounts" => "Verificar contas de Mail-in",
"Check automatically" => "Verificar automaticamente",
"Frequency" => "Freqüência",
// "mn" => "mn",
"Admin Menu" => "Administrar Menu",
"List menus" => "Listar menus",
"Edit this menu" => "Editar este menu",
// "Manage menu" => "Manage menu",
"Menu options" => "Opções de menus",
// "switch with previous option" => "switch with previous option",
// "switch with next option" => "switch with next option",
// "Create menu option" => "Create menu option",
// "Edit menu option" => "Edit menu option",
"Show Quick Urls" => "Mostrar Quick Urls",
"Some useful URLs" => "Alguns endereços úteis",
"Hide Quick Urls" => "Esconder Quick Urls",
"Home" => "Página inicial",
"Choose" => "Escolha",
"Home Blog" => "Blog Principal",
"Home Image Gal" => "Gal. Imgs Principal",
"Home Image Gallery" => "Galeria de Imagens Principal",
"Home File Gal" => "Gal. Arqs Principal",
"Home File Gallery" => "Galeria de Arquivos Principal",
"User preferences" => "Preferências do usuário",
"User prefs" => "Preferências",
"Wiki Home" => "Página Inicial Wiki",
"List galleries" => "Listar galerias",
"List image galleries" => "Listar galerias de imagens",
"Upload image" => "Carregar imagem",
"Gallery Rankings" => "Rankings de Galerias",
"Browse a gallery" => "Navegar por uma galeria",
"Articles home" => "Página de artigos",
"All articles" => "Todos artigos",
"List articles" => "Listar artigos",
"List Blogs" => "Listar Blogs",
"Create Blog" => "Criar Blog",
"View a forum" => "Exibir um fórum",
"View a thread" => "Exibir uma seqüência",
"View a FAQ" => "Exibir um FAQ",
"Take a quiz" => "Fazer um teste",
"Quiz stats" => "Estats. Teste",
"Stats for a Quiz" => "Estatísticas de um teste",
"For wiki page, use ((PageName))." => "Para uma página wiki utilize ((NomeDaPagina)).",
"option" => "opções",
"section level 0" => "seção (nível 0)",
"section level 1" => "seção (nível 1)",
"section level 2" => "seção (nível 2)",
"section level 3" => "seção (nível 3)",
"sorted section level 0" => "seção ordenada (nível 0)",
"separator" => "separador",
// "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each" => "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each",
// "If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed" => "If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed",
// "Separate multiple feature/preferences with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple feature/preferences with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
// "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
"Preview menu" => "Pré-visualização do menu",
// "Appearance" => "Appearance",
// "Import/export menu" => "Import/export menu",
"Export CSV data" => "Exportar para arquivo CSV",
"Import CSV data" => "Importar de arquivo CSV",
"To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'." => "Para adicionar novas opções ao menu defina o campo optionId igual a 0. Para remover uma opção defina o campo remove igual a 'y'.",
// "RESET" => "RESET",
// "Clone this menu and its options" => "Clone this menu and its options",
// "Create/Edit Menu" => "Create/Edit Menu",
"Edit this Menu:" => "Editar este Menu:",
"Create new Menu" => "Criar um novo Menu",
"dynamic collapsed" => "contraído dinamicamente",
"dynamic extended" => "expandido dinamicamente",
"fixed" => "fixo",
// "Labels of all options will be wiki parsed" => "Labels of all options will be wiki parsed",
// "Folder Icon" => "Folder Icon",
// "Path and filename of closed folder icon" => "Path and filename of closed folder icon",
// "To use custom folder icons in menus, enter the path to the icon for the <strong>closed</strong> folder" => "To use custom folder icons in menus, enter the path to the icon for the <strong>closed</strong> folder",
// "In the same directory, include an icon for the opened folder" => "In the same directory, include an icon for the opened folder",
// "The \"opened folder\" icon name must be identical to the \"closed folder\" icon name, prefixed with the letter <strong>o</strong>" => "The \"opened folder\" icon name must be identical to the \"closed folder\" icon name, prefixed with the letter <strong>o</strong>",
// "For example, the default icon is: img/icons/folder.png" => "For example, the default icon is: img/icons/folder.png",
// "The name of the \"open folder\" icon is: img/icons/ofolder.png" => "The name of the \"open folder\" icon is: img/icons/ofolder.png",
// "Configure icons for menu entries" => "Configure icons for menu entries",
// "You can use menus by assigning the menu <a href=\"tiki-admin_modules.php\">module</a> (to the top, left, right, etc.), or you can customize a template, using {literal}{menu id=x}{/literal}, where x is the ID of the menu" => "You can use menus by assigning the menu <a href=\"tiki-admin_modules.php\">module</a> (to the top, left, right, etc.), or you can customize a template, using {literal}{menu id=x}{/literal}, where x is the ID of the menu",
"To use a menu in a tiki format" => "Para usar o menu em um formato tiki",
"To use menu in a css/suckerfish format" => "Para usar o menu no formato css/suckerfish",
// "To customize the menu's CSS id (#)" => "To customize the menu's CSS id (#)",
// "Admin Metrics" => "Admin Metrics",
// "Metrics" => "Metrics",
// "Assign Metrics" => "Assign Metrics",
// "Assigned Metrics" => "Assigned Metrics",
// "Edit/Create Metrics" => "Edit/Create Metrics",
// "Edit/Create Tab" => "Edit/Create Tab",
// "Data Type" => "Data Type",
// "Weight" => "Weight",
// "Metric Name" => "Metric Name",
// "Tab Name" => "Tab Name",
// "Assign metric" => "Assign metric",
// "Edit this assigned metric" => "Edit this assigned metric",
// "Tab for metric" => "Tab for metric",
// "Create new metric" => "Create new metric",
// "Edit this metric" => "Edit this metric",
// "Hints" => "Hints",
// "For list-based metrics, include the \"LIMIT #\" in your query" => "For list-based metrics, include the \"LIMIT #\" in your query",
// "Name (must be unique)" => "Name (must be unique)",
// "Create Metric" => "Create Metric",
// "Edit Metric" => "Edit Metric",
// "Create new tab" => "Create new tab",
// "Edit this tab" => "Edit this tab",
// "Weight (must be integer)" => "Weight (must be integer)",
// "Create Tab" => "Create Tab",
// "Edit Tab" => "Edit Tab",
"Clear Cache" => "Limpar o cache",
// "Show hidden modules" => "Show hidden modules",
// "Hide hidden modules" => "Hide hidden modules",
// "Exit Modules" => "Exit Modules",
// "Modules Parameters" => "Modules Parameters",
// "The following required parameters are missing" => "The following required parameters are missing",
// "Drag the modules around to re-order then click save when ready" => "Drag the modules around to re-order then click save when ready",
// "Double click them to edit" => "Double click them to edit",
// "Modules with \"position: absolute\" in their style can be dragged in to position" => "Modules with \"position: absolute\" in their style can be dragged in to position",
// "New modules can be dragged from the \"All Modules\" tab" => "New modules can be dragged from the \"All Modules\" tab",
// "Links and buttons in modules, apart from the Application Menu, have been deliberately disabled on this page to make drag and drop more reliable. Click here to return <a href=\"./\">HOME</a>" => "Links and buttons in modules, apart from the Application Menu, have been deliberately disabled on this page to make drag and drop more reliable. Click here to return <a href=\"./\">HOME</a>",
// "More info here" => "More info here",
"Assigned modules" => "Módulos atribuídos",
// "Assign/Edit modules" => "Assign/Edit modules",
"Assigned Modules" => "Módulos Atribuídos",
"Add module" => "Adicionar módulo",
// "Move Up" => "Move Up",
// "Move Down" => "Move Down",
// "Edit module" => "Edit module",
"Assign new module" => "Atribuir novo módulo",
"Edit this assigned module:" => "Editar este módulo atribuído:",
// "Module Options" => "Module Options",
// "Custom Modules" => "Custom Modules",
// "Create new custom module" => "Create new custom module",
// "Edit this custom module" => "Edit this custom module",
// "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\">assigning it</a>. Using HTML, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site" => "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\">assigning it</a>. Using HTML, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site",
"Must be wiki parsed" => "Interpretar código wiki (selecione se usou um código wiki)",
"Objects that can be included" => "Objetos que podem ser incluídos",
"Available polls" => "Enquetes disponíveis",
"Random active poll" => "Enquete ativa aleatórea",
"Random current poll" => "Enquete atual aleatórea",
"Use Poll" => "Usar a enquete",
"Random image from" => "Imagem aleatória a partir de",
"Use Gallery" => "Usar a galeria",
"Dynamic content blocks" => "Blocos de conteúdo dinâmico",
"Use Dynamic Content" => "Usar conteúdo dinâmico",
"Use RSS Module" => "Utilizar módulo rss",
// "Default Tiki menus" => "Default Tiki menus",
"Use Menu" => "Utilizar o menu",
// "CSS menus" => "CSS menus",
// "Use CSS menu" => "Use CSS menu",
"Banner zones" => "Zonas de Banner",
"Use Banner Zone" => "Utilizar zona de banner",
"Structures:" => "Estruturas:",
// "Use Wiki Structure" => "Use Wiki Structure",
// "To use a <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\">CSS (Superfish) menu</a>, use one of these syntaxes" => "To use a <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\">CSS (Superfish) menu</a>, use one of these syntaxes",
// "To use a default Tiki menu" => "To use a default Tiki menu",
"Data" => "Dados",
"All Modules" => "Todos os módulos",
"Show all modules" => "Mostrar todos os módulos",
"Admin newsletter subscriptions" => "Administrar assinaturas de comunicados",
"List Newsletters" => "Listar comunicados",
// "Edit Newsletter" => "Edit Newsletter",
"Admin Newsletters" => "Administrar comunicados",
"Send Newsletters" => "Enviar Comunicados",
"Subscriptions" => "Assinaturas",
// "Groups included through inheritence" => "Groups included through inheritence",
// "Wiki Page Name" => "Wiki Page Name",
// "Validate Addresses" => "Validate Addresses",
// "Add To List" => "Add To List",
"Valid" => "Válido",
"Subscribed" => "inscrita",
// "Unsubscribed" => "Unsubscribed",
// "Add subscribers" => "Add subscribers",
"You can add several email addresses by separating them with commas." => "É possível adicionar vários endereços de e-mail separando eles com vírgula.",
"Add email:" => "Adicionar email:",
"Add user:" => "Adicionar usuário:",
// "Users from group" => "Users from group",
"Group subscription also subscribes included groups" => "Inscrição do grupo também inscrive grupos incluídos",
"Don't send confirmation mail" => "Não enviar e-mail de confirmação",
"The user email will be refreshed at each newsletter sending" => "O usuário de e-mail vai ser atualizado a cada newsletter que for enviada",
// "Import emails from file" => "Import emails from file",
"txt file, one e-mail per line" => "arquivo de texto, um e-mail por linha",
// "Don't send confirmation mails" => "Don't send confirmation mails",
// "Import emails from wiki page" => "Import emails from wiki page",
// "Wiki page, one e-mail per line" => "Wiki page, one e-mail per line",
"Subscribe group" => "Inscrever grupo",
// "Including group inheritence" => "Including group inheritence",
// "Including group, group users and emails will be refreshed at each newsletter sending" => "Including group, group users and emails will be refreshed at each newsletter sending",
// "Use subscribers of another newsletter" => "Use subscribers of another newsletter",
// "Use emails from wiki page" => "Use emails from wiki page",
// "Emails on a wiki page which will be added at each newsletter sending, one e-mail per line" => "Emails on a wiki page which will be added at each newsletter sending, one e-mail per line",
// "Don't subscribe emails" => "Don't subscribe emails",
// "Export Subscriber Emails" => "Export Subscriber Emails",
"Admin newsletters" => "Administrar comunicados",
// "Create Newsletter" => "Create Newsletter",
"Editions" => "Edições",
"Drafts" => "Rascunhos",
"Last Sent" => "última enviada",
"Assign Permissions" => "Designar Permissões",
"Create/Edit Newsletters" => "Criar/editar comunicados",
"There are individual permissions set for this newsletter" => "Existem permissões individuais definidos para este comunicado",
"Users can subscribe/unsubscribe to this list" => "Usuários podem inscrever/desinscrever nesta lista",
"Users can subscribe any email address" => "Usuários podem inscrever quaisquer endereços de e-mail",
"Add unsubscribe instructions to each newsletter" => "Adicionar instruções de desinscrição em cada newsletter",
"Validate email addresses" => "Validar endereços de e-mail",
// "Allow customized text message to be sent with the HTML version" => "Allow customized text message to be sent with the HTML version",
// "Allow clipping of articles into newsletter" => "Allow clipping of articles into newsletter",
// "Automatically clip articles into newsletter" => "Automatically clip articles into newsletter",
// "Clip articles published in the past number of days" => "Clip articles published in the past number of days",
// "Article types to clip" => "Article types to clip",
// "Mail notifications" => "Mail notifications",
// "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications" => "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications",
"Add notification" => "Adicionar notificação",
// "Alert" => "Alert",
"Event:" => "Evento:",
// "Destination" => "Destination",
// "Myself" => "Myself",
// "Note that a user is not notified for his own action" => "Note that a user is not notified for his own action",
"Event" => "Evento",
// "User / Group" => "User / Group",
// "Trackers Outbound Emails" => "Trackers Outbound Emails",
// "Forums Outbound Emails" => "Forums Outbound Emails",
"Admin Polls" => "Administrar Enquetes",
"List polls" => "Listar enquetes",
"Edit this poll" => "Editar esta enquete",
"Preview poll" => "Pre-visualização da enquete",
// "Add poll option" => "Add poll option",
// "Edit poll option" => "Edit poll option",
"Poll options" => "Opções de enquetes",
"Votes" => "Votos",
"Set last poll as current" => "Definir a última enquete como atual",
"Close all polls but last" => "Fechar todas as enquetes menos a última",
"Activate all polls" => "Ativar todas as enquetes",
// "Create poll" => "Create poll",
// "Edit poll" => "Edit poll",
"active" => "ativo",
"current" => "atual",
"object" => "objeto",
// "Toggle Quick Options" => "Toggle Quick Options",
// "Add Option" => "Add Option",
// "Leave box empty to delete an option" => "Leave box empty to delete an option",
// "Votes older than these days are not considered" => "Votes older than these days are not considered",
"0 for no limit" => "0 para ilimitado",
"Objects" => "Objetos",
"Results" => "Resultados",
// "Add poll to pages" => "Add poll to pages",
// "{\$channels[ix].title}" => "{\$channels[ix].title}",
// "This menu shows only Polls with 'status': \"template\"" => "This menu shows only Polls with 'status': \"template\"",
"Wiki pages" => "Páginas wiki",
// "{\$listPages[ix].pageName|escape}" => "{\$listPages[ix].pageName|escape}",
"Lock the pages" => "Travar as páginas",
// "Admin External Feeds" => "Admin External Feeds",
"Tips" => "Dicas",
// "This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or" => "This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or",
// "To use feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed" => "To use feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed",
"Content for the feed" => "Conteúdo para a fonte",
// "External Feeds" => "External Feeds",
"Show Title?" => "Mostrar título?",
"Show Date?" => "Mostrar data?",
"Refresh rate" => "Taxa de atualização",
"View feed" => "Ver feed",
// "Article Generator" => "Article Generator",
// "Edit Feed" => "Edit Feed",
// "Create Feed" => "Create Feed",
// "Create new external feed" => "Create new external feed",
"show feed title" => "mostrar campo de título",
"show publish date" => "mostrar data de publicação",
// "The article generator will create a new article for every item read in the RSS feed" => "The article generator will create a new article for every item read in the RSS feed",
// "Use Article Submission System" => "Use Article Submission System",
// "Publish in the future" => "Publish in the future",
// "-1 to use original publishing date from the feed" => "-1 to use original publishing date from the feed",
"Configure" => "Configurar",
"Security Admin" => "Administrar segurança",
// "To <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">report any security issues</a>" => "To <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">report any security issues</a>",
// "For additional security checks, please visit <a href=\"tiki-check.php\">Tiki Server Compatibility Check</a>" => "For additional security checks, please visit <a href=\"tiki-check.php\">Tiki Server Compatibility Check</a>",
"Tiki settings" => "Configurações do Tiki",
"Tiki variable" => "Variável Tiki",
"Risk Factor" => "Fator de risco",
"Explanation" => "Explicação",
// "About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors" => "About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors",
// "You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)" => "You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)",
// "Security checks" => "Security checks",
"Check all tiki files" => "Checar todos os arquivos tiki",
"Note, that this can take a very long time. You should check your max_execution_time setting in php.ini." => "Nota: isso pode demorar muito tempo. Cheque o item max_execution_time no arquivo php.ini.",
"File checks" => "Checar arquivo",
"Check file permissions" => "Verificar as permissões do arquivo",
"This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments." => "Essa checagem tenta encontrar arquivos com permissões problemáticas. Algumas permissões de arquivos marcadas como problemáticas podem não ser ou então podem ser inevitáveis em alguns sistemas.",
// "See end of table for detailed explanations" => "See end of table for detailed explanations",
// "owner" => "owner",
// "special" => "special",
"user" => "usuário",
"group" => "grupo",
"other" => "outro",
// "uid" => "uid",
// "gid" => "gid",
// "suid" => "suid",
// "sgid" => "sgid",
"sticky" => "persistente",
// "r" => "r",
// "w" => "w",
// "Set User ID (suid) files" => "Set User ID (suid) files",
// "World writable files or directories" => "World writable files or directories",
// "Files or directories the Webserver can write to" => "Files or directories the Webserver can write to",
// "Strange Inodes (not file, not link, not directory)" => "Strange Inodes (not file, not link, not directory)",
// "Executable files" => "Executable files",
// "What to do with these check results" => "What to do with these check results",
// "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"" => "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"",
// "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content" => "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content",
// "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information" => "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information",
// "Inodes that are not files or directories are not part of tiki. Review these Inodes" => "Inodes that are not files or directories are not part of tiki. Review these Inodes",
// "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod" => "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod",
"Admin Shoutbox Words" => "Administrar palavras do quadro negro",
"Add Banned Word" => "Adicinionar palavras banidas",
"Are you sure you want to delete this word?" => "Você tem certeza que deseja deletar essa palavra?",
// "XML Zip Import" => "XML Zip Import",
// "The structure" => "The structure",
// "has just been created" => "has just been created",
// "You will remove structure" => "You will remove structure",
"Destroy the structure leaving the wiki pages" => "Destruir a estrutura mantendo as páginas Wiki",
"Destroy the structure and remove the pages" => "Destruir a estrutura e remover as páginas",
// "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict" => "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict",
// "The following pages have automatically been categorized with the same categories as the structure" => "The following pages have automatically been categorized with the same categories as the structure",
// "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent" => "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent",
// "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent" => "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent",
"Edit structure" => "Editar estrutura",
// "View structure" => "View structure",
"Export Pages" => "Exportar páginas",
"PDF" => "PDF",
"Dump Tree" => "Exportar árvore",
"Create WebHelp" => "Criar WebHelp",
"View WebHelp" => "Ver webhelp",
// "XML Zip" => "XML Zip",
// "Delete with the pages" => "Delete with the pages",
"Create New Structure" => "Criar nova estrutura",
"Alias" => "Apelido",
"Tree" => "árvore",
"Use single spaces to indent structure levels" => "Usar espaços simples para indentar níveis da estrutura",
"Edit survey questions" => "Editar as perguntas da pesquisa",
// "Add a New Question" => "Add a New Question",
"List surveys" => "Listar pesquisas",
"Survey Stats" => "Estatísticas das pesquisas",
// "This survey stats" => "This survey stats",
"Edit this Survey" => "Editar esta pesquisa",
"Admin Surveys" => "Administrar pesquisas",
// "Edit Survey Question" => "Edit Survey Question",
// "Add a New Question to this survey" => "Add a New Question to this survey",
"Question" => "Pergunta",
"One choice" => "Uma opção",
"Multiple choices" => "Múltipla escolha",
// "Multiple choices of thumbnails from a file gallery" => "Multiple choices of thumbnails from a file gallery",
"Short text" => "Texto curto",
// "Wiki textarea" => "Wiki textarea",
"Rate (1..5)" => "Nota (1..5)",
"Rate (1..10)" => "Nota (1..10)",
// "Answer is mandatory" => "Answer is mandatory",
// "Number of required answers (for multiple choices)" => "Number of required answers (for multiple choices)",
// "For a multiple answer question put the answers into the following field, separated by a comma. Example: one,two,many,lots" => "For a multiple answer question put the answers into the following field, separated by a comma. Example: one,two,many,lots",
// "For a rate, you can give the maximum value" => "For a rate, you can give the maximum value",
// "For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4" => "For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4",
// "For the 'wiki textarea' type, options are: rows,columns. Example: 10,60" => "For the 'wiki textarea' type, options are: rows,columns. Example: 10,60",
"Options (if apply)" => "Opções (se for o caso)",
"Questions" => "Perguntas",
"Admin surveys" => "Administrar pesquisas",
"List Surveys" => "Listar Pesquisas",
// "Create Survey" => "Create Survey",
// "Create/Edit Surveys" => "Create/Edit Surveys",
"Edit this Survey:" => "Editar esta Pesquisa:",
"Create New Survey" => "Criar nova pesquisa",
"There are individual permissions set for this survey" => "Existem permissões individuais definidas para esta pesquisa",
"Tiki Cache/System Admin" => "Administrar Cache",
"If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed)." => "Se o Tiki apresenta alguma comportamento estranho limpar o cache pode resolver o problema. É sempre importante limpar o cache depois de atualizar a versão do sistema.",
// "Also see \"Rebuild Index\" in the <a href=\"tiki-admin.php?page=search\">Search Admin Panel</a>" => "Also see \"Rebuild Index\" in the <a href=\"tiki-admin.php?page=search\">Search Admin Panel</a>",
"Clear cached content" => "Remover conteúdo armazenado em cache",
"Directory to clear" => "Diretório para limpar",
"Empty" => "Esvaziar",
"Directories to save" => "Diretórios para salvar",
"Full Path to the Zip File" => "Caminho completo para o arquivo zip",
"Generate a zip of those directories" => "Gerar um arquivo zip dos diretórios abaixo",
"A zip has been written to %0" => "Um arquivo zip foi criado em %0",
"Directory is not writeable" => "Não é possível escrever no diretório",
// "Clean" => "Clean",
// "Groups still used in the database but no more defined" => "Groups still used in the database but no more defined",
// "Click to remove" => "Click to remove",
// "Admin Tokens" => "Admin Tokens",
// "List tokens" => "List tokens",
// "Entry" => "Entry",
// "Timeout" => "Timeout",
// "Max hits" => "Max hits",
// "Add new token" => "Add new token",
// "Token successfully created" => "Token successfully created",
// "Full URL" => "Full URL",
// "Timeout in seconds (-1 for unlimited)" => "Timeout in seconds (-1 for unlimited)",
// "Maximum number of hits (-1 for unlimited)" => "Maximum number of hits (-1 for unlimited)",
// "Groups (separated by comma)" => "Groups (separated by comma)",
"View mode" => "Modo de visualização",
"Wiki and WYSIWYG" => "Wiki e WYSIWYG",
"Wiki only" => "Apenas Wiki",
"WYSIWYG only" => "Apenas WYSIWYG",
// "Visual Wiki" => "Visual Wiki",
"Load" => "Carregar",
"Reset to Global" => "Restaurar configurações globais",
"Reset to defaults" => "Restaurar configurações padrão",
"Auto Reloading" => "Recarregar automaticamente",
"Row" => "Linha",
"Formatting Tools" => "Ferramentas de formatação",
"Plugin Tools" => "Ferramentas dos plugins",
"Edit tool" => "Editar ferramenta",
"Wysiwyg Token" => "Token do Wysiwyg",
"Plugin name" => "Nome do plugin",
"Custom Tools" => "Ferramentas personalizadas",
"Add a new custom tool" => "Adicionar nova ferramenta personalizada",
// "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br />\nDrag icons back from the toolbar rows onto the full list to remove them.<br />\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br />\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save" => "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br />\nDrag icons back from the toolbar rows onto the full list to remove them.<br />\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br />\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save",
// "If you are experiencing problems with this page after upgrading from Tiki 4 please use this link to delete all your customised tools" => "If you are experiencing problems with this page after upgrading from Tiki 4 please use this link to delete all your customised tools",
// "Delete all custom tools" => "Delete all custom tools",
// "Warning: There is no undo" => "Warning: There is no undo",
// "Admin Article Topics" => "Admin Article Topics",
// "Add topic" => "Add topic",
"topic image" => "imagem do assunto",
"Active Permissions" => "Ativar permissões",
// "Inactive - Click to Activate" => "Inactive - Click to Activate",
"Deactivate" => "Desativar",
// "Active - Click to Deactivate" => "Active - Click to Deactivate",
"Remove with articles" => "Remover com artigos",
"Admin Tracker" => "Administrar",
"Tracker fields" => "Campos do formulário",
"Mandatory" => "Obrigatório",
// "Save All" => "Save All",
// "Remove Selected" => "Remove Selected",
// "Export Selected" => "Export Selected",
// "Add Field" => "Add Field",
// "Import Tracker Fields" => "Import Tracker Fields",
// "Raw Fields" => "Raw Fields",
// "Preserve Field IDs" => "Preserve Field IDs",
// "Transitions" => "Transitions",
// "Subset Selection" => "Subset Selection",
// "Category Selection" => "Category Selection",
// "Group Selection" => "Group Selection",
// "Type in a group name and click \"enter\"" => "Type in a group name and click \"enter\"",
// "Once you have selected at least two, click" => "Once you have selected at least two, click",
// "and then, click the \"New/Edit\" tab which will appear above" => "and then, click the \"New/Edit\" tab which will appear above",
// "Draw Transition Diagram" => "Draw Transition Diagram",
// "Guards" => "Guards",
// "preserved" => "preserved",
// "Assign permissions for transition" => "Assign permissions for transition",
// "No transitions" => "No transitions",
// "New / Edit" => "New / Edit",
// "Edit <em>%0</em>" => "Edit <em>%0</em>",
// "New transition" => "New transition",
// "Upon trigger, preserve the initial state" => "Upon trigger, preserve the initial state",
"Members" => "Membros",
// "No guards on this transition" => "No guards on this transition",
// "New Guard" => "New Guard",
// "Exactly" => "Exactly",
// "At Least" => "At Least",
// "At Most" => "At Most",
// "States" => "States",
"Admin groups" => "Administrar grupos",
"Admin users" => "Administrar usuários",
"Add new group" => "Adicionar novo grupo",
// "Invitation List" => "Invitation List",
"List of existing groups" => "Lista de grupos existentes",
"Inherits Permissions from" => "Herda permissões de",
// "User Choice" => "User Choice",
// "{\$users[user].groupDesc|escape|nl2br}" => "{\$users[user].groupDesc|escape|nl2br}",
"Group Homepage" => "Página principal do grupo",
// "{\$users[user].groupHome}" => "{\$users[user].groupHome}",
// "{\$users[user].userChoice}" => "{\$users[user].userChoice}",
"Edit group" => "Editar grupos",
"Add a New Group" => "Adicionar novo grupo",
// "Group is NOT being monitored. Click icon to START monitoring" => "Group is NOT being monitored. Click icon to START monitoring",
// "Group IS being monitored. Click icon to STOP monitoring" => "Group IS being monitored. Click icon to STOP monitoring",
"Inherit permissions directly from following groups" => "Herda permissões diretamente dos seguintes grupos",
"Also inheriting permissions from the following groups (indirect inheritance through the groups selected above)" => "Também herda permissões indiretamente dos seguintes grupos (herança através dos grupos selecionados acima)",
// "Group Homepage or Url" => "Group Homepage or Url",
"Use wiki page name or full URL" => "Usar nome da página wiki ou URL",
// "For other Tiki features, use links relative to the Tiki root (such as <em>/tiki-forums.php</em>)" => "For other Tiki features, use links relative to the Tiki root (such as <em>/tiki-forums.php</em>)",
// "Default category assigned to uncategorized objects edited by a user with this default group" => "Default category assigned to uncategorized objects edited by a user with this default group",
"Group Theme" => "Tema do grupo",
"Use site default" => "Usar padrão do site",
"Group Information Tracker" => "Informação do grupo de formulários",
"choose a group tracker ..." => "escolher um grupo de formulários ...",
"choose a field ..." => "escolha um campo ...",
"Users Information Tracker" => "Formulário com informações extras dos usuários",
"choose a users tracker ..." => "escolher formulário com informações extras dos usuários ...",
"Users Information Tracker Fields Asked at Registration Time<br />(fieldIds separated with :)" => "Formulário com informações extras dos usuários utilizado no registro<br />(ids dos campos do formulário separados por ':')",
"User can assign to the group himself" => "Usuário pode entrar por conta própria nesse grupo",
"Users are automatically unassigned from the group after" => "Usuários são removidos do grupo automaticamente depois de",
"0 or empty for never" => "0 ou empty para nunca",
// "Or, users are automatically unassigned from the group at an anniversary date" => "Or, users are automatically unassigned from the group at an anniversary date",
// "MMDD for annual or DD for monthly" => "MMDD for annual or DD for monthly",
// "Payment for membership extension is prorated at a minimum interval of a" => "Payment for membership extension is prorated at a minimum interval of a",
// "Users are automatically assigned at registration in the group if their emails match the pattern" => "Users are automatically assigned at registration in the group if their emails match the pattern",
// "Example: " => "Example: ",
// "Assign group <em>management</em> permissions" => "Assign group <em>management</em> permissions",
"Group tracker item : {\$groupitemid}" => "Item do grupo de formulário : {\$groupitemid}",
"Edit Item" => "Editar item",
"Group tracker item not found" => "Item do grupo de formulário não encontrado",
// "Choose a field .." => "Choose a field ..",
"Members List" => "Lista de membros",
// "Expire" => "Expire",
"Remove from Group" => "Remover do grupo",
"users in group" => "usuários no grupo",
// "Banned members List" => "Banned members List",
// "Unban user" => "Unban user",
// "Add or Ban members to" => "Add or Ban members to",
"Add to group" => "Adicionar ao grupo",
// "Ban user from group" => "Ban user from group",
"Import/Export" => "Importar/Exportar",
// "Download CSV export" => "Download CSV export",
// "Charset encoding" => "Charset encoding",
"UTF-8" => "UTF-8",
"ISO-8859-1" => "ISO-8859-1",
"Assign users to group" => "Associar usuários ao grupo",
// "Each user in the file must already exist" => "Each user in the file must already exist",
// "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>" => "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>",
"Add a New User" => "Adicionar um novo usuário",
// "Since this Tiki site is in slave mode and imports groups, the master groups will be automatically reimported at each login" => "Since this Tiki site is in slave mode and imports groups, the master groups will be automatically reimported at each login",
// "Since this Tiki site is in slave mode and imports preferences, the master user preferences will be automatically reimported at each login" => "Since this Tiki site is in slave mode and imports preferences, the master user preferences will be automatically reimported at each login",
// "{\$tikifeedback[n].mes|escape}" => "{\$tikifeedback[n].mes|escape}",
"Batch Upload Results" => "Resultado da Carga em Lote",
"Updated users" => "Usuários atualizados",
"Rejected users" => "Usuários rejeitados",
"Reason" => "Motivo",
// "More Criteria" => "More Criteria",
// "Group (direct)" => "Group (direct)",
// "OpenID" => "OpenID",
"Edit Account Settings" => "Editar configurações da conta",
// "N" => "N",
// "Registered %0 ago" => "Registered %0 ago",
"Need to validate email" => "Precisa validar o e-mail",
"Edit Included Group" => "Editar grupo incluído",
"Edit Group" => "Editar grupo",
"default" => "padrão",
// "Remove %0 from %1" => "Remove %0 from %1",
"Assign to group" => "Associar ao grupo",
// "Assign %0 to groups" => "Assign %0 to groups",
"Edit Account Settings: %0" => "Editar configurações da conta: %0",
"Change user preferences: %0" => "Mudar as preferências do usuário: %0",
"User Information: %0" => "Informações do usuário: %0",
"Validate user: %0" => "Validar usuário: %0",
"Confirm user email: %0" => "Confirmar email do usuário: %0",
// "Invalidate email" => "Invalidate email",
"Remove link with OpenID account" => "Remover link com OpenID",
"Remove Users and their Userpages" => "Remover usuários e suas páginas de usuário",
"Manage Group Assignments" => "Alterar associações do grupo",
"Set Default Groups" => "Definir grupos padrão",
"Send a wiki page by Email" => "Enviar uma página wiki por e-mail",
"Assign selected to" => "Associar selecionados para",
"Remove selected from" => "Remover selecionados de",
"the following groups:" => "os seguintes grupos:",
"Set the default group of the selected users to" => "Definir o grupo padrão dos usuários selecionados para",
"bcc" => "bcc",
"Edit user" => "Editar usuário",
"Assign user to Groups" => "Associar usuário aos grupos",
"Use the email as username" => "Usar o e-mail como nome do usuário",
// "Warning: changing the username could require the user to change his password (for user registered with an old Tiki&lt;=1.8)" => "Warning: changing the username could require the user to change his password (for user registered with an old Tiki&lt;=1.8)",
// "Warning: it will mess with slave intertiki sites that use this one as master" => "Warning: it will mess with slave intertiki sites that use this one as master",
// "No password is required" => "No password is required",
// "Tiki is configured to delegate the password managment to LDAP" => "Tiki is configured to delegate the password managment to LDAP",
"Repeat Password" => "Repetir senha",
"User must change password at next login" => "O usuário precisa mudar sua senha na próxima vez que entrar no site",
"Send an email to the user in order to allow him to validate his account" => "Enviar e-mail para o usuário para validar a conta",
"You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a>" => "Você precisa definir o <a href=\"tiki-admin.php?page=general\">Remetente de e-mail</a>",
// "Pass confirmed" => "Pass confirmed",
// "Email confirmed" => "Email confirmed",
// "%0 days ago" => "%0 days ago",
// "Current Login" => "Current Login",
"Last Login" => "Último login",
"User tracker item : {\$usersitemid}" => "Item do formulário do usuário : {\$usersitemid}",
"You do not have permission to edit this user" => "Você não tem permissão para editar esse usuário",
"CSV file layout" => "Layout do arquivo CSV",
// "login,password,email,groups,default_group,realName<br />user1,pass1,email1,group1,group1<br />user2,pass2,email2,\\\"group1,group2\\\",group1" => "login,password,email,groups,default_group,realName<br />user1,pass1,email1,group1,group1<br />user2,pass2,email2,\\\"group1,group2\\\",group1",
// "Only login, password, email are mandatory.Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma" => "Only login, password, email are mandatory.Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma",
"Don't overwrite" => "Não sobrescrever",
"Overwrite groups:" => "Sobrescrever grupos:",
// "Create groups" => "Create groups",
"User must change password at first login" => "Usuário precisa mudar a senha no primeiro login",
"You can export users of a group in <a href=\"tiki-admingroups.php\">admin->groups->a_group</a>" => "Você pode exportar usuários de um grupo em <a href=\"tiki-admingroups.php\">admin->grupos->um_grupo</a>",
// "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences" => "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences",
"Admin Article Types" => "Administrar Tipos de Artigos",
// "Article Types" => "Article Types",
// "{\$types[user].type|escape}" => "{\$types[user].type|escape}",
// "View articles with this type" => "View articles with this type",
// "Author rating" => "Author rating",
"Show before publish date" => "Mostrar antes da data de publicação",
"Show after expire date" => "Mostrar depois da data de expiração",
"Heading only" => "Somente cabeçalho",
// "Comment can rate article" => "Comment can rate article",
"Show image" => "Mostrar imagem",
"Show avatar" => "Mostrar fotografia",
"Show publish date" => "Mostrar data de publicação",
"Show expire date" => "Mostrar data de expiração",
"Show reads" => "Mostrar lidas",
"Show size" => "Mostrar tamanho",
"Show topline" => "Mostrar linha de cima",
"Show subtitle" => "Mostrar sub-título",
"Show source" => "Mostrar fonte",
// "Show image caption" => "Show image caption",
"Creator can edit" => "Criador pode editar",
// "Custom attribute" => "Custom attribute",
// "Add Type" => "Add Type",
// "Add article type" => "Add article type",
// "Assign User %0 to Groups" => "Assign User %0 to Groups",
// "{\$users[user].groupDesc|escape}" => "{\$users[user].groupDesc|escape}",
// "Assign User to Group" => "Assign User to Group",
"backlinks to" => "refere-se a",
"No backlinks to this page" => "Sem referências para esta página",
"Directory batch upload" => "Diretório para fazer upload em lote",
"Browse Gallery" => "Navegar pela galeria",
"Upload From Disk" => "Carregar do disco",
"available images" => "imagens disponíveis",
"Filesize" => "Tamanho",
"Filetype" => "Tipo do arquivo",
"Remove File Extension from Image Name" => "Remover a extensão quando mostrar o nome da imagem",
"eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field" => "exemplo: de \"digicam0001.jpg\" será mostrado digicam0001 no campo nome",
// "Convert the last sub directory to a sub gallery" => "Convert the last sub directory to a sub gallery",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created",
// "Use the last sub directory name as description" => "Use the last sub directory name as description",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created",
"Select a Gallery" => "Selecionar galeria",
"Browse File Gallery" => "Navegar na galeria de arquivos",
// "Please do not use this feature to upload data into the database" => "Please do not use this feature to upload data into the database",
"Available Files" => "arquivos disponíveis",
// "Remove extension from filename" => "Remove extension from filename",
"Select a File Gallery" => "Selecionar uma galeria de arquivos",
// "Process files" => "Process files",
"Edit Post" => "Editar Mensagem",
// "New Post" => "New Post",
// "View post" => "View post",
"View Blog" => "Ver o blog",
"Note: Remember that this is only a preview, and has not yet been saved!" => "Nota: lembre-se que isto é apenas uma visualização, ainda não foi salvo.",
// "Excerpt" => "Excerpt",
"Trash" => "Lixeira",
"Mark entry as private:" => "Marcar entrada como privada:",
"Admin Category" => "Administrar categoria",
"Admin the Category System" => "Administrar as categorias do sistema",
"Browse in" => "Navegar em",
"Image galleries" => "Galerias de imagens",
"Trackers Items" => "Itens dos formulários",
"Sheets" => "Planilhas",
"in the current category - and its subcategories: " => "na categoria atual e suas sub-categorias:",
"Hide subcategories objects" => "Esconder subcategorias dos objetos",
"Show subcategories objects" => "Mostrar subcategorias dos objetos",
"Upper level" => "Nível superior",
// "{\$objects[ix].type|replace:\"wiki page\":\"wiki\"|replace:\"trackeritem\":\"tracker item\"}" => "{\$objects[ix].type|replace:\"wiki page\":\"wiki\"|replace:\"trackeritem\":\"tracker item\"}",
"Browse related tags" => "Navegar por tags relacionadas",
"Network of Tags related to" => "Rede de tags relacionadas a",
// "With all selected tags" => "With all selected tags",
// "With one selected tag" => "With one selected tag",
// "With last selected tag" => "With last selected tag",
"More Popular Tags" => "Tags mais populares",
// "Alphabetically" => "Alphabetically",
// "By Size" => "By Size",
// "Cloud" => "Cloud",
// "{\$feature_label}" => "{\$feature_label}",
// "No result found" => "No result found",
// "result found" => "result found",
// "{\$objects[ix].type|replace:\"wiki page\":\"Wiki\"|replace:\"article\":\"Article\"|regex_replace:\"/tracker [0-9]*/\":\"tracker item\"}" => "{\$objects[ix].type|replace:\"wiki page\":\"Wiki\"|replace:\"article\":\"Article\"|regex_replace:\"/tracker [0-9]*/\":\"tracker item\"}",
"Browsing Gallery" => "Navegando pela Galeria",
"List Galleries" => "Listar galerias",
"Edit Gallery" => "Editar galeria",
"Rebuild Thumbnails" => "Recriar miniaturas",
"Upload Image" => "Carregar uma Imagem",
"Directory Batch" => "Diretório em lote",
"List Gallery" => "Listar a galeria",
"All Images" => "Todas as imagens",
"RSS" => "RSS",
"Monitor this Gallery" => "Monitorar essa galeria",
"Stop Monitoring this Gallery" => "Parar de monitorar essa galeria",
// "{\$advice}" => "{\$advice}",
"Sort Images by" => "Ordenar imagens por",
"subgallery" => "sub galeria",
"Subgallery" => "Sub-galeria",
"Original Size" => "Tamanho original",
"rotate right" => "girar para a direita",
"rotate" => "girar",
"Details" => "Detalhes",
"popup" => "popup",
// "You can view this gallery's configured image (first, random, etc.) in your browser using" => "You can view this gallery's configured image (first, random, etc.) in your browser using",
// "You can include the gallery's image in an HTML page using" => "You can include the gallery's image in an HTML page using",
// "You can include the image in a tiki page using" => "You can include the image in a tiki page using",
"Browsing Image" => "Visualizando Imagem",
"Return to Gallery" => "Retornar à galeria",
"Edit Image" => "Editar Imagem",
"First Image" => "Primeira imagem",
"Prev Image" => "Imagem anterior",
"Smaller" => "Menor",
"Bigger" => "Maior",
"Popup window" => "Janela de popup",
"Next Image" => "Próxima imagem",
"Slideshow Forward" => "Avançar slide",
"Last Image" => "última imagem",
// "Cyclic" => "Cyclic",
"Click to zoom" => "Clique para dar zoom",
"Image Name" => "Nome da Imagem",
"Image size" => "Tamanho da imagem",
"Image Scale" => "Escaladeimagem",
"Latitude (WGS84/decimal degrees)" => "Latitude (WGS84/decimal graus)",
"Longitude (WGS84/decimal degrees)" => "Longitude (WGS84/decimal graus)",
"Move image" => "Mover a imagem",
// "Include the image in a tiki page using the following syntax" => "Include the image in a tiki page using the following syntax",
// "To include the image in an HTML page" => "To include the image in an HTML page",
// "To link to this page from another tiki page" => "To link to this page from another tiki page",
"Stop Monitoring this Page" => "Não monitorar mais esta página",
"Monitor this Page" => "Monitorar esta página",
"Export Calendars" => "Exportar calendários",
"Click to export calendars" => "Clique para exportar calendários",
"Visible Calendars" => "Calendários visíveis",
"Click to select visible calendars" => "Clique para selecionar todos os calendários visíveis",
"Group Calendars" => "Agrupar Calendários",
"Export calendars" => "Exportar calendários",
"advanced parameters" => "parâmetros avançados",
"Export as iCal" => "Exportar como iCal",
"January" => "Janeiro",
"February" => "Fevereiro",
"March" => "Março",
"April" => "Abril",
"May" => "Maio",
"June" => "Junho",
"July" => "Julho",
"August" => "Agosto",
"September" => "Setembro",
"October" => "Outubro",
"November" => "Novembro",
"December" => "Dezembro",
"Jan" => "Jan",
"Feb" => "Fev",
"Mar" => "Mar",
"Apr" => "Abr",
"Jun" => "Jun",
"Jul" => "Jul",
"Aug" => "Ago",
"Sep" => "Set",
"Oct" => "Out",
"Nov" => "Nov",
"Dec" => "Dez",
"Sun" => "Dom",
"Mon" => "Seg",
"Tue" => "Ter",
"Wed" => "Qua",
"Thu" => "Qui",
"Fri" => "Sex",
"Sat" => "Sáb",
"today" => "hoje",
// "all-day" => "all-day",
// "Export event" => "Export event",
"Edit event" => "Editar item",
// "Delete event" => "Delete event",
"View event" => "Ver item",
"Organized by" => "Ordenado por",
// "Classification" => "Classification",
"Tentative" => "Tentativa",
"Confirmed" => "Confirmada",
"Cancelled" => "Cancelada",
// "View this Week" => "View this Week",
"Change Focus" => "Mudar foco",
"+" => "+",
"View this Day" => "Ver esse dia",
// "o" => "o",
// "Calendar event : " => "Calendar event : ",
"New event" => "Novo item",
// "Edit/Delete event" => "Edit/Delete event",
"Edit Calendar Item" => "Editar o Item do Calendário",
"New Calendar Item" => "Novo Item no Calendário",
// "Recurrence" => "Recurrence",
// "This event depends on a recurrence rule" => "This event depends on a recurrence rule",
// "This event is not recurrent" => "This event is not recurrent",
// "On a weekly basis" => "On a weekly basis",
// "Each" => "Each",
// "of the week" => "of the week",
// "On a monthly basis" => "On a monthly basis",
// "of the month" => "of the month",
// "On a yearly basis" => "On a yearly basis",
// "Starting on" => "Starting on",
// "ending by" => "ending by",
// "ending after" => "ending after",
// "events" => "events",
// "Start period" => "Start period",
// "End after" => "End after",
// "occurrences" => "occurrences",
// "occurrence" => "occurrence",
// "End before" => "End before",
// "Event occurs once on" => "Event occurs once on",
// "Event is repeated" => "Event is repeated",
"times" => "vezes",
// "{\$daysnames[\$recurrence.weekday]}s" => "{\$daysnames[\$recurrence.weekday]}s",
// "of every month" => "of every month",
// "on each" => "on each",
// "{\$monthnames[\$recurrence.dateOfYear_month]}" => "{\$monthnames[\$recurrence.dateOfYear_month]}",
// "starting" => "starting",
// "ending" => "ending",
// "Show duration" => "Show duration",
// "Events cannot end before they start" => "Events cannot end before they start",
// "No description" => "No description",
// "or new" => "or new",
// "Choose users to alert" => "Choose users to alert",
// "Withdraw me from the list of participants" => "Withdraw me from the list of participants",
// "Add me to the list of participants" => "Add me to the list of participants",
// "Participant names separated by comma" => "Participant names separated by comma",
"Roles" => "Perfis",
// "chair" => "chair",
// "default role" => "default role",
// "required participant" => "required participant",
// "optional participant" => "optional participant",
// "non participant" => "non participant",
// "Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in" => "Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in",
// "role:login_or_email,login_or_email" => "role:login_or_email,login_or_email",
// "If no role is provided, default role will be \"Chair participant\"" => "If no role is provided, default role will be \"Chair participant\"",
// "Update this event only" => "Update this event only",
// "Update every unchanged events of this recurrence rule" => "Update every unchanged events of this recurrence rule",
// "Update every events of this recurrence rule" => "Update every events of this recurrence rule",
// "Delete Recurrent events" => "Delete Recurrent events",
"Calendar import" => "Importar calendário",
"Calendar has been updated" => "Calendário foi atualizado",
// "%0 column name can be used instead of %1" => "%0 column name can be used instead of %1",
// "D" => "D",
// "W" => "W",
// "M" => "M",
// "%d/%m" => "%d/%m",
"%m/%d" => "%d/%m",
// "Advanced parameters for iCal export" => "Advanced parameters for iCal export",
// "Calendars to be exported" => "Calendars to be exported",
// "Export calendars iCal" => "Export calendars iCal",
// "Export calendars CSV" => "Export calendars CSV",
// "Your account has been validated" => "Your account has been validated",
// "You have to choose a password to use this account" => "You have to choose a password to use this account",
"Change password enforced" => "Alteração obrigatória de senha",
"Change your password" => "Alterar sua senha",
"Old password" => "Senha antiga",
"New password" => "Nova senha",
// "Server Check" => "Server Check",
// "MySQL or MariaDB Database Properties" => "MySQL or MariaDB Database Properties",
// "Property" => "Property",
// "Tiki Fitness" => "Tiki Fitness",
// "Be careful" => "Be careful",
// "Server Information" => "Server Information",
// "Server Properties" => "Server Properties",
// "Fitness" => "Fitness",
// "Apache properties" => "Apache properties",
// "IIS properties" => "IIS properties",
// "PHP scripting language properties" => "PHP scripting language properties",
// "PHP Security properties" => "PHP Security properties",
// "MySQL Variable Information" => "MySQL Variable Information",
// "PHP Info" => "PHP Info",
"Please choose the language for this page" => "Por favor escolha o idioma desta página",
"Page: \"%0\"" => "Página: \"%0\"",
"Choose language" => "Escolha o idioma",
"Success" => "Sucesso",
"Send a message to us" => "Escreva-nos",
"Your email" => "Seu e-mail",
"Contact us by email" => "Entre em contato por email",
"Click here to send us an email" => "Clique aqui para nos enviar um e-mail",
"Send another message" => "Enviar outra mensagem",
"Contacts" => "Contatos",
// "Group View" => "Group View",
"Create/edit contacts" => "Criar/editar contatos",
"First Name:" => "Nome:",
// "Publish this contact to groups" => "Publish this contact to groups",
"Last Name:" => "Sobrenome:",
"Nickname" => "Apelido",
"First Name" => "Nome",
"Last Name" => "Sobrenome",
"Copy page" => "Copiar página",
"Invalid page name" => "Nome da página inválido",
// "The page name specified contains unallowed characters. It will not be possible to save the page until those are removed: <strong>%0</strong>" => "The page name specified contains unallowed characters. It will not be possible to save the page until those are removed: <strong>%0</strong>",
// "The page name specified contains characters that may render the page hard to access. You may want to consider removing those: <strong>%0</strong>" => "The page name specified contains characters that may render the page hard to access. You may want to consider removing those: <strong>%0</strong>",
// "Use this name anyway" => "Use this name anyway",
// "Quick Create Multilanguage Pages" => "Quick Create Multilanguage Pages",
// "Following pages were created, as translations of each other" => "Following pages were created, as translations of each other",
// "Following pages were not created" => "Following pages were not created",
// "page already exists" => "page already exists",
// "Enter the names of a new page page in various languages" => "Enter the names of a new page page in various languages",
// "Preferred languages" => "Preferred languages",
// "Other languages" => "Other languages",
// "Create pages" => "Create pages",
// "View generated WebHelp" => "View generated WebHelp",
// "No structure" => "No structure",
"Top page" => "Página de Topo",
"Add a new site" => "Adicionar um novo site",
"You cannot add sites until Directory Categories are setup." => "Você não pode adicionar sites porque o diretório das categorias ainda não foi configurado.",
"Please contact the Site Administrator" => "Por favor entre em contato com o administrador do site",
// "<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>" => "<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>",
"Site added" => "Site adicionado",
// "The following site was added, but may require validation by the admin before appearing on the lists" => "The following site was added, but may require validation by the admin before appearing on the lists",
// "{\$msg}" => "{\$msg}",
// "Edit a site" => "Edit a site",
"Add a Site" => "Adicionar um site",
// "Directory Categories" => "Directory Categories",
// "{\$countries[ux]}" => "{\$countries[ux]}",
"Directory Administration" => "Administrar links",
"There are" => "Existem",
"invalid sites" => "sites inválidos",
"valid sites" => "sites válidos",
"Users have visited" => "Usuários visitaram",
"sites from the directory" => "sites do diretório",
"Users have searched" => "Usuários buscaram",
"times from the directory" => "vezes a partir do diretório",
"Validate" => "Validar",
"Admin directory categories" => "Administrar categorias de diretório",
// "Parent directory category" => "Parent directory category",
"Add a directory category" => "Adicionar uma nova categoria",
"Edit this directory category" => "Editar esta categoria",
// "Add a Directory Category" => "Add a Directory Category",
"Children type" => "Tipos de filhos",
// "Most visited directory sub-categories" => "Most visited directory sub-categories",
// "Directory Category description" => "Directory Category description",
// "Random directory sub-categories" => "Random directory sub-categories",
"Maximum number of children to show" => "Número máximo de filhos a exibir",
// "Allow sites in this directory category" => "Allow sites in this directory category",
// "Show number of sites in this directory category" => "Show number of sites in this directory category",
"Editor group" => "Grupo do editor",
// "Directory Subcategories" => "Directory Subcategories",
"cType" => "Tipo",
"allow" => "permitir",
"count" => "contagem",
"editor" => "editor",
"relate" => "relacionadas",
// "Admin related directory categories" => "Admin related directory categories",
// "Add a related directory category" => "Add a related directory category",
// "Directory Category" => "Directory Category",
"Mutual" => "Mútuo",
// "Related directory categories" => "Related directory categories",
"Admin sites" => "Administrar sites",
"Is valid" => "É válido",
"Perform action with selected" => "Ação com o que foi selecionado",
"New Sites" => "Novos sites",
"Cool Sites" => "Sites legais",
"any" => "qualquer",
"in entire directory" => "em todas as categorias",
// "in current directory category" => "in current directory category",
"Sort by" => "Ordenar por",
// "Hits (desc)" => "Hits (desc)",
// "Hits (asc)" => "Hits (asc)",
// "Last updated (desc)" => "Last updated (desc)",
// "Last updated (asc)" => "Last updated (asc)",
"sort" => "ordenar",
"Added:" => "Adicionado:",
"Last updated" => "Última atualização em",
"No records." => "Nenhum registro.",
// "Total directory categories" => "Total directory categories",
"Total links" => "Total de links",
"Links to validate" => "Links a validar",
"Searches performed" => "Buscas realizadas",
"Total links visited" => "Links visitados totais",
"Directory ranking" => "Ranking de links",
"Validate sites" => "Sites validados",
"country" => "país",
// "Discounts" => "Discounts",
// "Max time the discount can be used in the first phase of payment" => "Max time the discount can be used in the first phase of payment",
// "-1 for illimited" => "-1 for illimited",
// "Translation of this page is incomplete" => "Translation of this page is incomplete",
// "To add <strong>new content</strong> to the page" => "To add <strong>new content</strong> to the page",
"use the editor" => "usar o editor",
"Edit article" => "Editar artigo",
"View Articles" => "Ver artigos",
"One of the email addresses you typed is invalid" => "Um dos endereços de e-mail digitados não é válido",
"Topline" => "Topo",
// "To translate, do not change the language and the content.\n\t\t\t\t\t\tInstead, <a href=\"%0\">create a new translation</a> in the new language" => "To translate, do not change the language and the content.\n\t\t\t\t\t\tInstead, <a href=\"%0\">create a new translation</a> in the new language",
// "Edit Translations" => "Edit Translations",
// "Attach existing article ID as translation" => "Attach existing article ID as translation",
"Author Name" => "Nome do Autor",
// "{\$typei|escape}" => "{\$typei|escape}",
"Own Image" => "Imagem própria",
"If not the topic image" => "Se não for a imagem do tópico",
"Article image" => "Imagem do artigo",
"Use own image" => "Usar imagem própria",
"Float text around image" => "Texto flutuante ao redor da imagem",
// "Maximum dimensions of custom image in view mode (Read Article)" => "Maximum dimensions of custom image in view mode (Read Article)",
"If different than the uploaded image" => "Se diferente do tamanho original da imagem",
// "Maximum dimensions of custom image in list mode (View Articles)" => "Maximum dimensions of custom image in list mode (View Articles)",
"If different than in view mode" => "Se diferente do tamanho no modo de visualização",
"Image caption" => "Legenda",
"If not the topic name" => "Se for diferente do nome do tópico",
// "Allow full HTML" => "Allow full HTML",
// "Keep any HTML tag" => "Keep any HTML tag",
// "If not enabled, Tiki will retain some HTML tags (a, p, pre, img, hr, b, i)" => "If not enabled, Tiki will retain some HTML tags (a, p, pre, img, hr, b, i)",
// "Emails to be notified (separated with commas)" => "Emails to be notified (separated with commas)",
"Edit or create banners" => "Editar ou criar banners",
"List banners" => "Listar banners",
"URL to link the banner" => "Endereço para ligar ao banner",
"Client" => "Cliente",
"Max impressions" => "Impressões (máx)",
"-1 for unlimited" => "(-1 para ilimitado)",
// "Max impressions for a user" => "Max impressions for a user",
// "Max clicks" => "Max clicks",
// "URIs where the banner appears only" => "URIs where the banner appears only",
// "Type each URI enclosed with the # character. Exemple:#/this_page#/tiki-index.php?page=this_page#" => "Type each URI enclosed with the # character. Exemple:#/this_page#/tiki-index.php?page=this_page#",
// "URIs where the banner will not appear " => "URIs where the banner will not appear ",
"Or, create a new zone" => "Ou crie uma nova zona de banners",
"Show the banner only between these dates" => "Exibir o banner apenas entre estas datas",
"From date" => "Do dia",
"To date" => "Ao dia",
"Use dates" => "Utilizar datas",
"Show the banner only in this hours" => "Exibir o banner apenas entre estas horas",
"Show the banner only on" => "Exibir o banner apenas às",
"Select ONE method for the banner" => "Selecione UM método para o banner",
"Use HTML" => "Usar HTML",
"Use image" => "Usar a imagem",
"Image:" => "Imagem:",
"Current Image" => "Imagem atual",
"Use image generated by URL (the image will be requested at the URL for each impression)" => "Usar a imagem gerada pelo endereço (a imagem será requisitada no endereço para cada impressão)",
"Use Flash" => "Usar Flash",
"Movie Size" => "Dimensões do arquivo",
// "Pixels" => "Pixels",
"FlashPlugin min version" => "Versão mínina para o plugin Flash",
"ex" => "exemplo",
"Use text" => "Utilizar texto",
"Save the Banner" => "Salvar o banner",
"Remove Zones (you lose entered info for the banner)" => "Remover Zonas (informações editadas para o banner serão perdidas)",
"Edit Blog" => "Editar Blog",
"A category is mandatory" => "É necessário pelo menos uma categoria",
"There are individual permissions set for this blog" => "Existem permissões individuais definidas para este blog",
// "Allow other users to post in this blog" => "Allow other users to post in this blog",
// "If others post to blog, author should always be owner" => "If others post to blog, author should always be owner",
"Allow search" => "Permitir busca",
"Allow comments" => "Permitir comentários",
// "Display Options" => "Display Options",
// "Number of posts to show per page" => "Number of posts to show per page",
// "Display blog title in posts list page" => "Display blog title in posts list page",
// "Display blog title in post page" => "Display blog title in post page",
// "Display blog description" => "Display blog description",
// "Display breadcrumbs" => "Display breadcrumbs",
// "Display author in blog posts" => "Display author in blog posts",
// "Display published date in blog posts" => "Display published date in blog posts",
"Show user avatar" => "Mostrar fotografia dos usuários",
// "Show post related content" => "Show post related content",
// "The checkbox is disabled because feature_freetags is disabled globally" => "The checkbox is disabled because feature_freetags is disabled globally",
// "Maximum number of related posts to display" => "Maximum number of related posts to display",
// "Use post excerpt" => "Use post excerpt",
"Blog heading" => "Cabeçalho do Blog",
// "Heading preview" => "Heading preview",
// "Blog post heading" => "Blog post heading",
// "Organizer" => "Organizer",
// "Move objects between categories" => "Move objects between categories",
// "Click on the category name you want to list. The list of objects in that category will become visible" => "Click on the category name you want to list. The list of objects in that category will become visible",
// "Select the objects you want to affect. Controls will appear in the category browser" => "Select the objects you want to affect. Controls will appear in the category browser",
// "Use the plus and minus signs to add or remove the categories on selected objects" => "Use the plus and minus signs to add or remove the categories on selected objects",
// "More results available. Please refine the search criterias" => "More results available. Please refine the search criterias",
"Select all" => "Selecionar tudo",
// "Unselect all" => "Unselect all",
"Edit Style Sheet" => "Editar Style Sheet",
"Style Sheet" => "Folha de Estilo",
// "The file will be saved in" => "The file will be saved in",
"choose a stylesheet" => "escolher um style sheet",
"Try" => "Experimentar",
// "Tiki Docs" => "Tiki Docs",
// "Save file" => "Save file",
// "Cancel editing file" => "Cancel editing file",
// "Editing file" => "Editing file",
// "Save and Back" => "Save and Back",
// "Toggle Fullscreen" => "Toggle Fullscreen",
"For more information, please see" => "Para mais informações veja",
"Wiki Page Editor" => "Editor",
"More help on editing wiki pages" => "Mais ajuda sobre como editar páginas wiki",
// "The syntax system used for creating pages in Tiki" => "The syntax system used for creating pages in Tiki",
"Bold text" => "Texto em negrito",
"Italic text" => "Texto em itálico",
"single quotes" => "aspas simples",
"Underlined text" => "Texto sublinhado",
"Colored text" => "Texto colorido",
// "Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background" => "Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background",
// "Deleted text" => "Deleted text",
"2 dashes" => "2 travessões",
"Headings" => "Cabeçalhos",
"show/hide heading section. + (shown) or - (hidden) by default" => "mostrar/esconder sessão do cabeçalho. + (mostra) or - (esconde) por padrão",
// "Autonumbered Headings" => "Autonumbered Headings",
// "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)",
// "Common optional parameters for maketoc are: title|maxdepth|levels|nums, and for toc are: order|showdesc|shownum|structId|maxdepth|pagename" => "Common optional parameters for maketoc are: title|maxdepth|levels|nums, and for toc are: order|showdesc|shownum|structId|maxdepth|pagename",
"Horizontal rule" => "Linha horizontal",
"Text box" => "Caixa de texto",
"Box content" => "Conteúdo da caixa",
"Centered text" => "Texto centralizado",
"Inserts an editable variable" => "Inserir uma váriavel editável",
"External links" => "Links externos",
// "use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)" => "use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)",
"For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))" => "Para um Wiki externo, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))",
"Square Brackets" => "Colchetes",
"Use [[foo] to show [foo]." => "Usa [[foo] para mostrar [foo].",
"Wiki References" => "Referências Wiki",
"JoinCapitalizedWords or use" => "UnirPalavrasComMaiusculas ou use",
"page|description" => "página|desc",
"for wiki references" => "para referências Wiki",
// "page|#anchor" => "page|#anchor",
// "page|#anchor|desc" => "page|#anchor|desc",
// "for wiki heading/anchor references" => "for wiki heading/anchor references",
"SomeName" => "AlgumNome",
"prevents referencing" => "prevenir referência",
"Lists" => "Listas",
"for bullet lists" => "para listas de itens",
"for numbered lists" => "para listas numeradas",
"definition" => "definição",
"for definiton lists" => "para listas de definições",
// "Indentation" => "Indentation",
// "Creates an indentation for each plus (useful in list to continue at the same level)" => "Creates an indentation for each plus (useful in list to continue at the same level)",
"Tables" => "Tabelas",
"row" => "linha",
"col" => "coluna",
// "Monospace font" => "Monospace font",
// "Code sample" => "Code sample",
"(very useful especially in tables)" => "(muito útil especialmente em tabelas)",
"Multi-page pages" => "Páginas multi-página",
"to separate pages" => "para separar páginas",
"Non parsed sections" => "Seções não interpretadas",
"data" => "dados",
"Prevents wiki parsing of the enclosed data." => "O conteúdo entre as tags não é interpretado como código wiki.",
"Preformated sections" => "Seções pré-formatadas",
// "~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text" => "~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text",
// "~tc~ Tiki Comment ~/tc~ makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  ~hc~ HTML Comment ~/hc~ makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar" => "~tc~ Tiki Comment ~/tc~ makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  ~hc~ HTML Comment ~/hc~ makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar",
"Block Preformatting" => "Pré-formatar bloca",
// "Indent text with any number of spaces to turn it into a monospaced block that still follows other Wiki formatting instructions. It will be indended with the same number of spaces that you used.  Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that" => "Indent text with any number of spaces to turn it into a monospaced block that still follows other Wiki formatting instructions. It will be indended with the same number of spaces that you used.  Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that",
// "Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew" => "Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew",
// "Special characters" => "Special characters",
// "hard space" => "hard space",
// "numeric between ~ for HTML numeric characters entity" => "numeric between ~ for HTML numeric characters entity",
"Plugin Help" => "Ajuda com plugins",
"Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt;" => "Nota: é possível utilizar aspas duplas (&quot;) enter os argumentos de um plugin; isso permite que o argumento contenha , ou = ou &gt;",
"More help here" => "Mais ajuda aqui",
"Wiki plugins extend the function of wiki syntax with more specialized commands" => "Plugins wiki aumentam as possibilidades da sintaxe wiki com comandos mais especializados",
"Activate/deactivate plugins" => "Ativar ou desativar plugins",
"No description available" => "Descrição não disponível",
// "Spreadsheet Creation" => "Spreadsheet Creation",
// "Spreadsheet Interface" => "Spreadsheet Interface",
// "Tiki uses jQuery.sheet for displaying spreadsheets, below you will see a list of usable functions and how to enhance how you use it" => "Tiki uses jQuery.sheet for displaying spreadsheets, below you will see a list of usable functions and how to enhance how you use it",
// "Wysiwyg Editor" => "Wysiwyg Editor",
// "More help on wysiwyg editing" => "More help on wysiwyg editing",
// "WYSIWYG in wiki mode is an experimental feature in Tiki 7+ and uses\n\t<a href=\"http://ckeditor.com\">CKEditor</a>" => "WYSIWYG in wiki mode is an experimental feature in Tiki 7+ and uses\n\t<a href=\"http://ckeditor.com\">CKEditor</a>",
// "To switch modes between WYSIWYG and Wiki edit modes click the {icon _id=\"pencil_go\"} button on the toolbar" => "To switch modes between WYSIWYG and Wiki edit modes click the {icon _id=\"pencil_go\"} button on the toolbar",
// "<strong>N.B. </strong>Using this button changes the editor between WYSIWYG and the usual wiki editor, but leaves the page source in wiki syntax" => "<strong>N.B. </strong>Using this button changes the editor between WYSIWYG and the usual wiki editor, but leaves the page source in wiki syntax",
// "Wiki plugins can be used and edited in WYSIWYG mode, double click the plugin to bring up the plugin edit popup form.<br />\n\tHere is an example of the {ldelim}BOX{rdelim} plugin" => "Wiki plugins can be used and edited in WYSIWYG mode, double click the plugin to bring up the plugin edit popup form.<br />\n\tHere is an example of the {ldelim}BOX{rdelim} plugin",
// "This is the text in the box which is justified; the box has a cream background, takes 80% of the screen width and is centred" => "This is the text in the box which is justified; the box has a cream background, takes 80% of the screen width and is centred",
// "<strong>Caution:</strong> This is a new feature and still work in progress.<br />\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br />\n\tCurrently (in Tiki 9.0) drag and drop of plugins in WYSIWYG does not work" => "<strong>Caution:</strong> This is a new feature and still work in progress.<br />\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br />\n\tCurrently (in Tiki 9.0) drag and drop of plugins in WYSIWYG does not work",
// "<strong>Admins:</strong><br />\n\t\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way.\n\t\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">wysiwyg admin page</a>.\n\t\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a>\n\t\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>" => "<strong>Admins:</strong><br />\n\t\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way.\n\t\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">wysiwyg admin page</a>.\n\t\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a>\n\t\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>",
// "The WYSIWYG editor in Tiki 6+ is\n\t<a href=\"http://ckeditor.com\">CKEditor</a>,\n\tthe new version of FCKEditor (used in Tiki since version 2.0)" => "The WYSIWYG editor in Tiki 6+ is\n\t<a href=\"http://ckeditor.com\">CKEditor</a>,\n\tthe new version of FCKEditor (used in Tiki since version 2.0)",
// "<strong>N.B. </strong>Using this button converts the page source from wiki to HTML, or vice versa.\n\tThe conversion process is not entirely transparent, meaning that you may notice differences between the look of a page in different modes.\n\tThis will improve in future updates but as the two systems have significant differences in what they can do it is unlikely to ever be totally transparent" => "<strong>N.B. </strong>Using this button converts the page source from wiki to HTML, or vice versa.\n\tThe conversion process is not entirely transparent, meaning that you may notice differences between the look of a page in different modes.\n\tThis will improve in future updates but as the two systems have significant differences in what they can do it is unlikely to ever be totally transparent",
// "<strong>Caution:</strong> This is a new feature and still work in progress.<br />\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br />\n\tCurrently (still in Tiki 9.0) drag and drop of plugins in WYSIWYG does not work" => "<strong>Caution:</strong> This is a new feature and still work in progress.<br />\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br />\n\tCurrently (still in Tiki 9.0) drag and drop of plugins in WYSIWYG does not work",
"Browse Images" => "Navegar na galeria",
"Edit successful!" => "Edição bem-sucedida!",
"The following image was successfully edited" => "A seguinte imagem foi editada com sucesso",
"Image Description" => "Descrição da Imagem",
"Upload from disk to change the image:" => "Carregue uma nova imagem para alterar a atual:",
"Save and Go Next" => "Salvar e ir para a próxima",
// "Edit Invoice" => "Edit Invoice",
// "Invoice Number" => "Invoice Number",
// "Date Issued" => "Date Issued",
// "Work Description" => "Work Description",
// "Taxable" => "Taxable",
// "New Item" => "New Item",
// "Invoice Note" => "Invoice Note",
// "Save Invoice" => "Save Invoice",
"Edit or export languages" => "Editar ou exportar idiomas",
"Edit languages" => "Editar idiomas",
"Select the language to edit" => "Selecione uma língua a editar",
"Add a translation" => "Adicionar uma tradução",
"Edit translations" => "Editar traduções",
"Show only database stored translations" => "Mostrar apenas traduções guardadas na base de dados",
"Untranslated strings" => "Frases não traduzidas",
"Show only database stored untranslated strings" => "Mostrar apenas frases não traduzidas guardadas na base de dados",
"Original" => "Original",
// "Original translation" => "Original translation",
// "Last changed by %0 on %1" => "Last changed by %0 on %1",
"Translate all" => "Traduzir todos",
"Delete all" => "Deletar todos",
// "Are you sure you want to delete all untranslated strings from database" => "Are you sure you want to delete all untranslated strings from database",
// "Are you sure you want to delete all translations from database" => "Are you sure you want to delete all translations from database",
"Export languages" => "Exportar idiomas",
// "No translations in the database available to export. First translate strings using interactive translation or \"Edit languages\" tab" => "No translations in the database available to export. First translate strings using interactive translation or \"Edit languages\" tab",
"Select the language to Export" => "Selecione a língua para exportar",
// "If you click \"Download database translations\", you will download a file with all the translations in the database" => "If you click \"Download database translations\", you will download a file with all the translations in the database",
// "If you click \"Write to language.php\", the translations in the database will be merged with the other translations in language.php. Note that after writing translations to language.php they are removed from the database" => "If you click \"Write to language.php\", the translations in the database will be merged with the other translations in language.php. Note that after writing translations to language.php they are removed from the database",
// "To be able to write your translations back to language.php make sure that the web server has write permission in the lang/ directory" => "To be able to write your translations back to language.php make sure that the web server has write permission in the lang/ directory",
"Download database translations" => "Fazer download das traduções da base de dados",
"Write to language.php" => "Exportar traduções para language.php",
// "Return to default perspective" => "Return to default perspective",
// "Switch to" => "Switch to",
// "Configurations" => "Configurations",
// "Search for configurations below and drag them in to the configuration section above" => "Search for configurations below and drag them in to the configuration section above",
"Program dynamic content for block" => "Programar conteúdo dinâmico para o bloco",
"Create New Block" => "Criar um novo bloco",
"Return to block listing" => "Retornar à listagem de blocos",
"Block description: " => "Descrição do bloco: ",
"You are editing block:" => "Você está editando o bloco:",
"Publishing date" => "Data de publicação",
"Publishing Date" => "Data de Publicação",
"Edit question options" => "Editar opções da pergunta",
"List Quizzes" => "Listar Testes",
"Quiz Stats" => "Estatísticas de testes",
"This Quiz Stats" => "Estatísticas deste teste",
"Edit this Quiz" => "Editar este teste",
"Admin Quizzes" => "Administrar testes",
"Create/edit options for question" => "Criar/editar opções para a pergunta",
"points" => "pontos",
"Quiz" => "Teste",
"canRepeat" => "podeRepetir",
"timeLimit" => "tempoLimite",
"Create/edit quizzes" => "Criar/editar testes",
"There are individual permissions set for this quiz" => "Existem permissões individuais para este teste",
"Quiz can be repeated" => "Teste pode ser repetido",
"Store quiz results" => "Armazenar resultados do teste",
"Quiz is time limited" => "Tempo-limite para o teste",
"Maximum time" => "Tempo máximo",
"Passing Percentage" => "Percentual decorrido",
"%" => "%",
"Edit quiz questions" => "Editar perguntas do teste",
"Create/edit questions for quiz" => "Criar/editar perguntas do teste",
"Question Type" => "Tipo das questões",
"Import questions from text" => "Importar questões do texto",
// "Instructions: Type, or paste, your multiple choice questions below.  One line for the question, then start answer choices on subsequent lines.  Separate additional questions with a blank line.  Indicate correct answers by starting them with a \"*\" (without the quotes) character" => "Instructions: Type, or paste, your multiple choice questions below.  One line for the question, then start answer choices on subsequent lines.  Separate additional questions with a blank line.  Indicate correct answers by starting them with a \"*\" (without the quotes) character",
"Input" => "Entrada",
"maxScore" => "notaMaxima",
// "Edit quiz results" => "Edit quiz results",
"From Points" => "Pontos Mínimos",
"To Points" => "Pontos Máximos",
// "Report Builder" => "Report Builder",
// "Report Type" => "Report Type",
// "Select Report Type" => "Select Report Type",
// "Wiki Data" => "Wiki Data",
// "Export As CSV" => "Export As CSV",
"Modify Structure" => "Modificar Estrutura",
"You will remove" => "Você irá remover",
"and its subpages from the structure, now you have two options:" => "e suas sub-páginas da estrutura, existem duas opções:",
// "and its subpages from the structure" => "and its subpages from the structure",
// "\n\t\t\tRemove only from structure" => "\n\t\t\tRemove only from structure",
// "\n\t\t\t\tRemove from structure and remove page too" => "\n\t\t\t\tRemove from structure and remove page too",
// "The page already exists. The page that has been added to the structure is the existing one" => "The page already exists. The page that has been added to the structure is the existing one",
// "The following pages added have automatically been categorized with the same categories as the structure" => "The following pages added have automatically been categorized with the same categories as the structure",
"Structure Layout" => "Estrutura de Layout",
// "Add pages" => "Add pages",
// "Use pre-existing page by dragging into the structure above" => "Use pre-existing page by dragging into the structure above",
// "{\$catix.categpath}" => "{\$catix.categpath}",
// "Categorize all pages in structure together" => "Categorize all pages in structure together",
// "Remove existing categories from ALL pages before recategorizing" => "Remove existing categories from ALL pages before recategorizing",
// "Move to another structure" => "Move to another structure",
"at the beginning" => "no começo",
"at the end" => "no fim",
"Submit article" => "Enviar artigo",
"List Submissions" => "Listar submissões",
"Use ...page... to separate pages in a multi-page post" => "Utilize ...page... para separar as páginas em uma mensagem multi-página",
"<b>*</b>=optional" => "<b>*</b>=opcional",
"<b>Topline</b>=small line above Title" => "<b>Linha de cima</b>=pequena linha em cima do título",
"<b>Subtitle</b>=small line below Title" => "<b>Subtítulo</b>=pequena linha embaixo do título",
"<b>Source</b>=URL to article source" => "<b>Fonte</b>=indica a fonte do artigo",
"Own image size x" => "Largura da imagem própria",
"Own image size y" => "Altura da imagem própria",
"Allow HTML:" => "Permitir HTML:",
"Submit Article" => "Enviar artigo",
"Auto-Approve Article" => "Aprovar automaticamente um artigo",
"View template" => "Visualizar template",
"Edit template" => "Editar modelo",
"Edit templates" => "Editar padrões",
"Template listing" => "Listagem de padrões",
"Available templates" => "Padrões disponíveis",
"Important" => "Importante",
// "If you edit this (or any TPL) file via the built-in editor below, any JavaScript may be sanitized or completely stripped out \n\t\t\t\t\tby Tiki security filtering, which would cause certain functions to stop working (e.g. menus no longer collapse or expand)" => "If you edit this (or any TPL) file via the built-in editor below, any JavaScript may be sanitized or completely stripped out \n\t\t\t\t\tby Tiki security filtering, which would cause certain functions to stop working (e.g. menus no longer collapse or expand)",
// "You should only modify default header.tpl and other important files via a text code editor, through console, \n\t\t\t\t\tor SSH, or FTP edit commands--and only if you know what you are doing! ;-)" => "You should only modify default header.tpl and other important files via a text code editor, through console, \n\t\t\t\t\tor SSH, or FTP edit commands--and only if you know what you are doing! ;-)",
// "Extensive customizations can be made safely through the <a href=\"tiki-admin.php?page=look\" class=\"titletips\" \n\t\t\t\t\ttitle=\"Look & Feel\">Look & Feel</a> admin panel custom code or general layout areas" => "Extensive customizations can be made safely through the <a href=\"tiki-admin.php?page=look\" class=\"titletips\" \n\t\t\t\t\ttitle=\"Look & Feel\">Look & Feel</a> admin panel custom code or general layout areas",
// "To be safe and to make upgrades easier, it is recommended that you create a custom theme before modifying tpl files.\n\t\t\t\t\tSee <a href=\"http://doc.tiki.org/Customizing+Themes\" class=\"titletips\" title=\"Customizing Themes help page\">\n\t\t\t\t\tdoc.tiki.org/Customizing+Themes</a> for how to do that" => "To be safe and to make upgrades easier, it is recommended that you create a custom theme before modifying tpl files.\n\t\t\t\t\tSee <a href=\"http://doc.tiki.org/Customizing+Themes\" class=\"titletips\" title=\"Customizing Themes help page\">\n\t\t\t\t\tdoc.tiki.org/Customizing+Themes</a> for how to do that",
"Save Only in the Theme:" => "Salvar apenas no tema:",
"Delete the copy in the theme:" => "Deletar a cópia no tema:",
// "Edit topic" => "Edit topic",
// "Notification Email" => "Notification Email",
// "Admin notifications" => "Admin notifications",
"Translate:" => "Traduzir:",
"View Page" => "Ver página",
"View Article" => "Ver artigo",
"You must specify the object language" => "Você precisa especificar o objeto do idioma",
"The object doesn't exist" => "O objeto não existe",
"The object doesn't have a language" => "O objeto não possui um idioma",
"The object has already a translation for this language" => "O objeto já tem uma tradução para esse idioma",
"The object is already in the set of translations" => "O objeto já está selecionado para traduções",
"Translate updates made on this page or one of its translations" => "Traduzir atualizações feitas nessa página ou uma de suas traduções",
"Translate this page to a new language" => "Traduzir essa página para um novo idioma",
"Attach or detach existing translations of this page" => "Adicionar ou remover traduções desta página",
"Change language for this page" => "Mudar idioma desta página",
"Select language to translate to:" => "Selecionar idioma para traduzir página para:",
"Enter the page title:" => "Título da página:",
// "Below, assign categories to this new translation (Note: they should probably be the same as the categories of the page being translate)" => "Below, assign categories to this new translation (Note: they should probably be the same as the categories of the page being translate)",
"Create translation" => "Criar tradução",
// "\"You forgot to specify the language of the translation. Please choose a language in the picklist.\"" => "\"You forgot to specify the language of the translation. Please choose a language in the picklist.\"",
// "\"The page already exists. It was selected in the list below.\"" => "\"The page already exists. It was selected in the list below.\"",
"Change Language" => "Mudar idioma",
"No language is assigned to this page." => "Nenhum idioma associado a esta página.",
"Please select a language before performing translation." => "Por favor, selecione um idioma antes de iniciar a tradução.",
"Set Current Page's Language" => "Definir o idioma desta página",
// "Manage translations" => "Manage translations",
// "{\$customTip|escape}" => "{\$customTip|escape}",
// "Update '{\$page}'" => "Update '{\$page}'",
"Draft written on" => "Rascunho escrito em",
"Warning: new versions of this page have been made after this draft" => "Atenção: novas versões dessa página foram feitas depois desse rascunho",
"The SandBox is a page where you can practice your editing skills, use the preview feature to preview the appearance of the page, no versions are stored for this page." => "A bancada de testes é uma página onde você pode praticar as técnicas de edição, usar o recurso de pré-visualização. Nenhuma versão da bancada de testes é armazenada.",
// "An edit summary is mandatory" => "An edit summary is mandatory",
// "Translate from" => "Translate from",
// "Changes that need to be translated are highlighted below" => "Changes that need to be translated are highlighted below",
// "No comment" => "No comment",
// "All Versions" => "All Versions",
// "Select the style used to display differences to be translated" => "Select the style used to display differences to be translated",
// "html" => "html",
// "text full" => "text full",
// "Change the style used to display differences to be translated" => "Change the style used to display differences to be translated",
// "Change diff styles" => "Change diff styles",
// "Translate to" => "Translate to",
// "Reproduce the changes highlighted on the left using the editor below" => "Reproduce the changes highlighted on the left using the editor below",
"Describe the change you made:" => "Descreva a alteração que você fez:",
"Edit comment: Enter some text to describe the changes you are currently making" => "Comentário da edição: um texto descrevendo as alterações que você fez na página",
"Monitor this page" => "Monitorar essa página",
"Upload picture" => "Carregar uma imagem",
"Add another image" => "Adicionar outra imagem",
// "Categorization has been preset for this edit" => "Categorization has been preset for this edit",
// "Categories will be inherited from the structure top page" => "Categories will be inherited from the structure top page",
// "{\$templates[ix].name|escape}" => "{\$templates[ix].name|escape}",
"Admin Content Templates" => "Administrar padrões de conteúdo",
"Lock this page" => "Travar essa página",
"Allow comments on this page" => "Permitir comentários nessa página",
"Import HTML:" => "Importar HTML:",
"Try to convert HTML to wiki" => "Tentar converter HTML para wiki",
"Import page" => "Importar página",
"export all versions" => "exportar todas as versões",
// "Only cache a page if it should look the same to all groups authorized to see it" => "Only cache a page if it should look the same to all groups authorized to see it",
"Manage structures" => "Administrar estruturas",
"License" => "Licença",
// "{\$prefs.wikiLicensePage}" => "{\$prefs.wikiLicensePage}",
// "{\$prefs.wikiSubmitNotice}" => "{\$prefs.wikiSubmitNotice}",
// "Authors' style" => "Authors' style",
// "Description (used for metatags)" => "Description (used for metatags)",
"My Footnotes" => "Notas de rodapé",
"Use rating" => "Usar classificação",
// "{\$template.title|escape}" => "{\$template.title|escape}",
"There is no available poll template." => "Não existe um modelo de enquete disponível.",
"You should ask an admin to create them." => "Você deve pedir para o administrador cria-los.",
// "\"}To translate, do not change the language and the content.\n\t\t\t\t\t\t\t\t\tInstead, <a href=\"%0\">create a new translation</a> in the new language" => "\"}To translate, do not change the language and the content.\n\t\t\t\t\t\t\t\t\tInstead, <a href=\"%0\">create a new translation</a> in the new language",
"Translation request" => "Atualizar traducação",
"Send urgent translation request." => "Enviar aviso para atualização das traduções desta página.",
"Admin wiki preferences" => "Admin preferências wiki",
// "{\$title}" => "{\$title}",
"List Sheets" => "Listar planilhas",
"Graph" => "Gráfico",
"Export to file" => "Exportar arquivo",
// "Autodetect" => "Autodetect",
"Admin FAQ" => "Administrar FAQ",
"List FAQs" => "Listar FAQs",
"View FAQ" => "Visualizar FAQ",
"Edit this FAQ" => "Editar este FAQ",
"New Question" => "Nova pergunta",
"Edit FAQ question" => "Editar questão do FAQ",
"Add FAQ question" => "Adicionar questão ao FAQ",
"Use a question from another FAQ" => "Utilizar uma pergunta de outro FAQ",
"FAQ questions" => "Perguntas do FAQ",
"Suggested questions" => "Perguntas sugeridas",
"No suggested questions" => "Sem perguntas sugeridas",
// "File Archive" => "File Archive",
"Upload File" => "Carregar arquivo",
"File Galleries tpl" => "Galeria de arquivos tpl",
"Be careful to set the right permissions on the files you link to" => "Tome cuidado para configurar corretamente as permissões dos arquivos para os quais você criar links",
"You can access the file gallery using the following URL" => "Você pode acessar a galeria de arquivos pelo seguinte endereço",
"Size (width x height)" => "Tamanho (largura x altura)",
// "Newer content available" => "Newer content available",
// "You are currently viewing the latest version of the page" => "You are currently viewing the latest version of the page",
// "You can also view the {self_link}latest approved version{/self_link}" => "You can also view the {self_link}latest approved version{/self_link}",
// "You can approve this revision and make it available to a wider audience. Make sure you review all the changes before approving" => "You can approve this revision and make it available to a wider audience. Make sure you review all the changes before approving",
// "Show changes since last approved revision" => "Show changes since last approved revision",
// "This page has no prior approved revision. <strong>All of the content must be reviewed.</strong>" => "This page has no prior approved revision. <strong>All of the content must be reviewed.</strong>",
// "Approve current revision" => "Approve current revision",
// "Content waiting for approval" => "Content waiting for approval",
// "You are currently viewing the approved version of the page" => "You are currently viewing the approved version of the page",
// "You can also view the {self_link latest=1}latest version{/self_link}" => "You can also view the {self_link latest=1}latest version{/self_link}",
// "View the {self_link latest=1}latest version{/self_link}" => "View the {self_link latest=1}latest version{/self_link}",
// "Forum Importer" => "Forum Importer",
"Admin forums" => "Administrar fóruns",
// "Import from a Local SQL File" => "Import from a Local SQL File",
// "Forum Type" => "Forum Type",
// "DB Prefix" => "DB Prefix",
// "Local SQL Filename on Server (path will be stripped)" => "Local SQL Filename on Server (path will be stripped)",
// "Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up" => "Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up",
// "Get Forum List" => "Get Forum List",
// "Verification" => "Verification",
// "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>" => "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>",
// "File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred" => "File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred",
// "Proceed" => "Proceed",
"Go Back" => "Voltar",
// "Select a Forum You Wish to Move (ONE at a time!)" => "Select a Forum You Wish to Move (ONE at a time!)",
// "Which Forum Do You Wish to Import this Into" => "Which Forum Do You Wish to Import this Into",
// "Message queue for forum" => "Message queue for forum",
// "Back to forum" => "Back to forum",
"Edit queued message" => "Editar mensagem na fila",
"make this a thread of" => "transformar em uma seqüência de",
"None, this is a thread message" => "Nenhuma, esta é uma mensagem de uma seqüência",
"summary" => "sumário",
"Announce" => "Anúncio",
"Hot" => "Quente",
"no feeling" => "insensível",
"frown" => "muxoxo",
"exclaim" => "exclamação",
"idea" => "idéia",
"neutral" => "neutro",
"question" => "pergunta",
"happy" => "feliz",
"wink" => "piscadela",
"Save and Approve" => "Salvar e aprovar",
"convert to topic" => "converter em um assunto",
"List of messages" => "Lista de mensagens",
"Topic:" => "Tópico:",
"New Topic" => "Novo assunto",
"no summary" => "sem sumário",
"No messages queued yet" => "Nenhuma mensagem na fila",
"Search by name" => "Procurar por nome",
"Search in content" => "Procurar no conteúdo",
"Last Post" => "Última mensagem",
"Configure Forum" => "Configurar fórum",
// "Reported messages for forum" => "Reported messages for forum",
"Reported by" => "Enviada por",
// "Perfom action with checked" => "Perfom action with checked",
// "Un-report" => "Un-report",
// "Tag translation" => "Tag translation",
// "Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag" => "Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag",
// "Until then, they cannot be translated" => "Until then, they cannot be translated",
// "Show checkboxes to clear language information on tags" => "Show checkboxes to clear language information on tags",
"Previous" => "Anterior",
// "There are no tags on this page in your preferred languages" => "There are no tags on this page in your preferred languages",
"Set language" => "Definir idioma",
// "Universal" => "Universal",
// "Show the following languages" => "Show the following languages",
"Pending requests" => "Solicitações pendentes",
"Request Time" => "Solicitar tempo",
"Accept" => "Aceitar",
"Refuse" => "Recusar",
"Waiting requests" => "Esperando solicitações",
"Cancel friendship request" => "Cancelar pedido de amizade",
"Your friends" => "Seus amigos",
"break friendship" => "romper amizade",
"Galleries" => "Galerias",
"Create New Gallery" => "Criar uma nova galeria",
"Create a gallery" => "Criar uma galeria",
"Edit this gallery:" => "Editar esta galeria:",
"There are individual permissions set for this gallery" => "Existem permissões individuais definidas para esta galeria",
"Gallery is visible to non-admin users?" => "Galeria visível para usuários não administradores?",
"Geographic" => "Geografia",
"Fields to show during browsing the gallery" => "Campos que devem aparecer na navegação da galeria",
"XY-Size" => "XY-tamanho",
"Gallery Image" => "Galeria de imagens",
"Available scales" => "Escalas disponíveis",
// "Global default" => "Global default",
// "Bounding box" => "Bounding box",
"default scale" => "escalar padrão",
"No scales available" => "Nenhuma escala disponível",
"Original image is default scale" => "A imagem original é a escala padrão",
"Add scaled images with bounding box of square size" => "Adicionar escala para imagem",
"Other users can upload images to this gallery" => "Outros usuários podem carregar imagens nesta galeria",
"You can access the gallery using the following URL" => "Você pode acessar esta galeria pelo seguinte endereço",
"Available Galleries" => "Galerias Disponíveis",
"Choose a filter" => "Escolher filtro",
"Imgs" => "Imagens",
"Make Map" => "Fazer mapa",
// "Google Map Locator" => "Google Map Locator",
"Back to preferences" => "Voltar para preferências",
// "enter address" => "enter address",
// "Find address" => "Find address",
// "Save clicked point" => "Save clicked point",
// "Reset view to default" => "Reset view to default",
// "Save current view as default" => "Save current view as default",
// "Center map to saved point" => "Center map to saved point",
// "Reset view to site default" => "Reset view to site default",
"Users Map" => "Mapa dos usuários",
"Select Graphic Type" => "Selecionar tipo gráfico",
// "Pie Chart" => "Pie Chart",
"Multiline" => "Multi-linha",
// "Multibar" => "Multibar",
// "Bar Stack" => "Bar Stack",
"Landscape" => "Paisagem",
"Portrait" => "Retrato",
"Independant Scale" => "Escala independente",
"Horizontal Scale" => "Escala horizontal",
"Vertical Scale" => "Escalar vertical",
"Series" => "Séries",
// "Edit Spreadsheet" => "Edit Spreadsheet",
// "List Spreadsheets" => "List Spreadsheets",
// "Wiki plug-in" => "Wiki plug-in",
// "Spreadsheet History" => "Spreadsheet History",
// "Clone" => "Clone",
"Rollback" => "Restaurar",
// "Toggle Full Screen" => "Toggle Full Screen",
// "Date Selection" => "Date Selection",
// "Edit Date" => "Edit Date",
// "View Spreadsheet" => "View Spreadsheet",
// "Clone Spreadsheet" => "Clone Spreadsheet",
// "Roll Back Spreadsheet" => "Roll Back Spreadsheet",
// "Roll-Back" => "Roll-Back",
// "Ical import / Export" => "Ical import / Export",
// "Select The calendar to export" => "Select The calendar to export",
"Calendar Import" => "Importar calendário",
// "ICal File" => "ICal File",
"Import From File" => "Importar do arquivo",
"Grab Wiki Tables" => "Obter tabelas wiki",
"Import pages from a Structured Text Dump" => "Importar páginas de uma exportação em texto estruturada",
"Name of the dump file (it has to be in dump/)" => "Nome do arquivo de exportação (precisa estar no diretório dump/)",
"Overwrite existing pages if the name is the same" => "Sobrescrever páginas com mesmo nome",
"Previously remove existing page versions" => "Remover versões previamente existentes da página",
"excerpt" => "trecho",
"Result" => "Resultado",
"body" => "corpo",
"Or" => "Ou",
// "Name of the zip file on the server" => "Name of the zip file on the server",
"Tiki Importer" => "Importador Tiki",
"If you are NOT running a new Tiki installation, make a backup of your database before using this importer!" => "Se você NÃO esta rodando uma nova instalação do Tiki, faça um backup do seu banco de dados antes de usar o importador!",
// "If your pages contain XML code, the HTML purifier will delete it. Deactivate this feature" => "If your pages contain XML code, the HTML purifier will delete it. Deactivate this feature",
// "Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibility to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode" => "Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibility to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode",
// "Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)" => "Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)",
// "Select the software to import from" => "Select the software to import from",
// "WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button" => "WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button",
// "Congratulations! You have successful imported your data to Tiki" => "Congratulations! You have successful imported your data to Tiki",
// "%0 pages imported from a total of %1" => "%0 pages imported from a total of %1",
// "%0 pages imported" => "%0 pages imported",
// "(you can see the list of wiki pages in your site <a href=\"tiki-listpages.php\">here</a>)" => "(you can see the list of wiki pages in your site <a href=\"tiki-listpages.php\">here</a>)",
// "%0 posts imported" => "%0 posts imported",
// "%0 tags imported" => "%0 tags imported",
// "%0 categories imported" => "%0 categories imported",
// "Importer log" => "Importer log",
// "Suggested .htaccess rules" => "Suggested .htaccess rules",
// "Locked by %0" => "Locked by %0",
"Tiki installer" => "Instalador do Tiki",
"Welcome" => "Bem-vindo",
"Welcome to the Tiki installation and upgrade script" => "Bem vindo ao script de instalação e atualização do Tiki",
"Use this script to install a new Tiki database or upgrade your existing database to release" => "Use esse script para instalar um Tiki com uma nova base de dados ou para atualizar a base de dados de uma instalação existente para a versão",
"For the latest information about this release, please read the" => "Para mais informações sobre essa versão leia as",
"Release Notes" => "Notas sobre a versão",
"For complete documentation, please visit" => "Para a documentação completa visite",
"For more information about Tiki, please visit" => "Para mais informações sobre o Tiki, por favor visite",
"Select your language" => "Selecione seu idioma",
"Read the License" => "Leia a licença",
"Tiki is software distributed under the LGPL license" => "O Tiki é um software que usa a licença LGPL",
"Review the System Requirements" => "Requisitos do sistema",
"Review" => "Resenha",
"Before installing Tiki, <a href=\"http://doc.tiki.org/Requirements\" target=\"_blank\">review the documentation</a> and confirm that your system meets the minimum requirements" => "Antes de instalar o Tiki, <a href=\"http://doc.tiki.org/Requirements\" target=\"_blank\">verifique a documentação</a> e confirme que se seu sistema possuí os requisitos mínimos",
"This installer will perform some basic checks automatically" => "O instalador verifica automaticamente alguns requisitos básicos",
// "Please see: " => "Please see: ",
// "a detailed report about your server" => "a detailed report about your server",
"Tiki has not detected your PHP memory_limit" => "Não foi possível detectar o valor do memory_limit do PHP",
"This probably means you have no set limit (all is well)" => "Isso provavelmente significa que não há um limite configurado (não há problemas em não ter um limite)",
"Tiki has detected your PHP memory limit at" => "Tiki detectou que seu memory limit do PHP é",
// "Tiki requires <strong>at least</strong> 128MB of PHP memory for script execution" => "Tiki requires <strong>at least</strong> 128MB of PHP memory for script execution",
"Allocating too little memory will cause Tiki to display blank pages" => "Menos do que isso fará com o algumas páginas sejam exibidas em branco",
// "To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 128M) and restart your webserver" => "To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 128M) and restart your webserver",
"Tiki has detected your PHP memory_limit at" => "Tiki detectou que seu memory limit do PHP é",
"Tiki uses the PHP <strong>mail</strong> function to send email notifications and messages" => "O Tiki usa a função <strong>mail</strong> do PHP para enviar e-mails de notificação e mensagens",
"To test your system configuration, Tiki will attempt to send a test message to you" => "Para testar as configurações do sistema, o Tiki vai tentar enviar uma mensagem para você",
"Test email" => "Endereço de teste",
"Email address to send test to" => "O endereço para o qual será enviado o e-mail de teste",
"Copy test mail to " => "Copiar mensagem de test para ",
"Send Test Message" => "Enviar mensagem de teste",
"Tiki was able to send a test message to" => "Foi possível enviar a mensagem de teste para",
"Tiki was not able to send a test message" => "Não foi possível enviar a mensagem de teste",
"Review your mail log for details" => "Verifique o arquivo de log do servidor de e-mail para mais detalhes",
"Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)" => "Verifique as configurações de e-mail no arquivo <strong>php.ini</strong> (por exemplo: confirme que o <strong>sendmail_path</strong> está correto)",
"If your host requires SMTP authentication, additional configuration may be necessary" => "Se o seu servidor utiliza autenticação SMTP, é necessário realizar algumas configurações extras",
"Image Processing" => "Processamento de imagens",
"Tiki detected" => "O Tiki detectou",
"Tiki can create images" => "O Tiki consegue criar imagens",
"Tiki was not able to create a sample image. Please check your GD library configuration" => "Não foi possível criar uma imagem de teste. Por favor verifique as configurações do PHP e GD",
"Tiki was not able to detect the GD library" => "Não foi possível encontrar a biblioteca GD",
"Tiki uses the GD library to process images for the Image Gallery and CAPTCHA support" => "O Tiki usa a biblioteca GD para processar imagens",
"Set the Database Connection" => "Conexão com o banco de dados",
"Tiki requires an active database connection" => "É necessário conectar o Tiki com uma base de dados",
"You must create the database and user <em>before</em> completing this page" => "Você deve criar a base de dados e o usuário <em>antes</em> de preencher as informações abaixo",
"Tiki cannot find a database connection" => "Tiki não conseguiu conectar à banco de dados",
"This is normal for a new installation" => "Isso é normal para uma instalação nova",
"Tiki found an existing database connection in your local.php file" => "O Tiki encontrou uma conexão com o banco de dados no arquivo db/local.php",
// "Database name: &quot;%0&quot" => "Database name: &quot;%0&quot",
"Use Existing Connection" => "Usar a conexão existente",
"Modify database connection" => "Modificar informações de conexão com a base de dados",
"Use this page to create a new database connection, or use the <a href=\"http://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>" => "Use esta página para criar uma nova conexão com a base de dados ou siga os <a href=\"http://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">procedimentos para instalação manual</a>",
"Database information" => "Informações do banco de dados",
"Enter your database connection information" => "Digite as informações da conexão com o banco de dados",
"Database type" => "Tipo do banco de dados",
"Select the type of database to use with Tiki" => "Selecione o tipo do servidor de banco de dados que será usado",
"Only databases supported by your PHP installation are listed here. If your database is not in the list, try to install the appropriate PHP extension" => "Apenas os servidores suportados pela instalação do PHP são listados aqui. Se o seu servidor não está na lista, instale primeira a extensão PHP correspondente",
"Host name" => "Nome do host",
"Enter the host name or IP for your database" => "Coloque o nome ou então o IP do banco de dados",
"Use <strong>localhost</strong> if the database is running on the same machine as Tiki" => "Utilize <strong>localhost</strong> se o banco de dados está na mesma máquina que o Tiki",
// "For non-default port number use <strong>example.com;port=3307</strong>" => "For non-default port number use <strong>example.com;port=3307</strong>",
"Database name" => "Nome do banco de dados",
// "Enter the name of the database that Tiki will use (if already created) or create (if permitted)" => "Enter the name of the database that Tiki will use (if already created) or create (if permitted)",
// "You can create the database using mysqladmin, phpMyAdmin, cPanel, or ask your hosting provider. If the database doesn't exist and the supplied username has permissions, the database will be created" => "You can create the database using mysqladmin, phpMyAdmin, cPanel, or ask your hosting provider. If the database doesn't exist and the supplied username has permissions, the database will be created",
// "If you are using a database which is already being used for something else (not recommended), check db/tiki.sql to make sure the table names used by Tiki are not already used" => "If you are using a database which is already being used for something else (not recommended), check db/tiki.sql to make sure the table names used by Tiki are not already used",
"Database user" => "Usuário do banco de dados",
"Enter a database user with administrator permission for the Database" => "Informe o nome de um usuário com permissões de administrador na base de dados",
"User name" => "Nome do usuário",
"Character set" => "Mapa de caracteres",
"Highly recommended for new installations. However, if you are upgrading or migrating a previous tiki database, you are recommended to uncheck this box" => "Altamente recomendado para novas instalações. Porém, se você está atualizando ou migrando uma instalação antiga é recomendado desmarcar essa opção",
"Always force connection to use UTF-8" => "Forçar conexão do banco de dados para usar UTF-8",
"More information" => "Mais informações",
"Install &amp; Upgrade" => "Instalar &amp; Atualizar",
"Install" => "Instalar",
"Failed to set max_execution_time for PHP. You may experience problems when creating/upgrading the database using this installer on a slow system. This can manifest itself by a blank page" => "Não foi possível alterar o valor da configuração max_execution_time (tempo máximo de execução) do PHP. Isso pode ser um problema quando você tentar criar ou atualizar a base de dados em um sistema lento. Esse problema se manifesta com uma página em branco.",
"This install will populate (or upgrade) the database" => "Nesta página você pode criar (ou atualizar) a base de dados do Tiki",
"If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"http://doc.tiki.org/Upgrade\" target=\"_blank\">Upgrade instructions</a>" => "Se quer atualizar a sua base de dados de uma versão anterior, verifique se você entendeu as <a href=\"http://doc.tiki.org/Upgrade\" target=\"_blank\">instruções de atualização</a>",
"A new install will populate the database" => "Uma nova instalação irá popular a base de dados",
"Encoding Issue" => "Problema de codificação de caracteres",
"<p>Your database encoding is <strong>not</strong> in UTF-8.</p><p>Current encoding is <em>%0</em>. The languages that will be available for content on the site will be limited. If you plan on using languages not covered by the character set, you should re-create or alter the database so the default encoding is <em>utf8</em>.</p>" => "<p>O mapa de caracteres de sua base de dados <strong>não</strong> é UTF-8.</p><p>O mapa atual é <em>%0</em>. Os idiomas disponíveis para o conteúdo do site será limitado. Se você planeja usar um idioma que não seja suportado pelo mapa de caracteres em uso, você deve recriar ou alterar a base de dados para que o mapa de caracteres padrão seja <em>utf8</em>.</p>",
"Character Set Conversion" => "Conversor do mapa de caracteres",
"Use at your own risk. If the data in the database currently contains improperly converted data, this may make matters worse. Suitable for new installations. Requires ALTER privilege on the database" => "Use por conta própria, esta é uma operação arriscada. Recomendado apenas para novas instalações. É necessário ter permissão para executar o comando ALTER na base de dados.",
"Convert database and tables to UTF-8" => "Converter base de dados e tabelas para UTF-8",
// "This will destroy your current database &quot;%0&quot;" => "This will destroy your current database &quot;%0&quot;",
"Reinstall the database" => "Reinstalar a base de dados",
// "Select database engine" => "Select database engine",
// "MyISAM" => "MyISAM",
// "InnoDB" => "InnoDB",
"Reinstall" => "Reinstalar",
"Upgrade" => "Atualização",
"Warning: Category Permissions Will Not Be Upgraded" => "Aviso: as permissões por categoria não serão atualizadas",
"Category permissions have been revamped since version 3. If you have been using category permissions, note that they may not work properly after upgrading to version 4 onwards, and it will be necessary to reconfigure them" => "As permissões por categoria foram reformuladas na versão 4. Se você utilizava permissões por categoria note que depois de atualizar para versão 4 ou maior elas podem deixar de funcionar e será necessário reconfigurá-las manualmente no novo (e melhor) sistema.",
"Automatically upgrade your existing database to v" => "Atualizar automaticamente sua base de dados para v",
"This site has an admin account configured" => "Esse site tem uma conta de administrador configurada",
"Please log in with your admin password to continue" => "Por favor entre com a sua senha de administrador para continuar",
"Pass" => "Senha",
"Review the Upgrade" => "Verificar atualização",
"Review the Installation" => "Verificar a instalação",
"Upgrade complete" => "Atualização completa",
"Installation complete" => "Instalação completa",
"Your database has been configured and Tiki is ready to run" => "Sua base de dados foi configurada e o Tiki está pronto para rodar",
"If this is your first install, your admin password is <strong>admin</strong>" => "Se essa é a primeira vez que você entra no site, a senha do usuário admin é <strong>admin</strong>",
"You can now log in into Tiki as user <strong>admin</strong> and start configuring the application" => "Você pode agora entrar no Tiki com o usuário <strong>admin</strong> e começar a configurar a aplicação",
"Upgrade operations executed successfully" => "Operações de atualização executadas com sucesso",
"Installation operations executed successfully" => "Operações de instalação executadas com sucesso",
"SQL queries" => "queries SQL",
"Database was left unchanged" => "A base de dados não foi alterada",
"Failed" => "Falhou",
"Operations failed" => "Operações falharam",
"Display details" => "Exibir detalhes",
"During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages" => "Durante uma atualização é normal que algumas queries falhem com a mensagem <strong>Table already exists</strong>",
// "Check all errors" => "Check all errors",
".htaccess File" => "arquivo .htaccess",
"We recommend enabling the <strong>.htaccess</strong> file for your Tiki" => "Recomendamos que o arquivo <strong>.htaccess</strong> seja habilitado",
"This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security" => "Isso permite que o recurso SEFURL (URLs amigáveis para sistemas de busca) seja utilizado e também aumenta a segurança do site",
"Configure General Settings" => "Configurações Gerais",
"Complete these fields to configure common, general settings for your site" => "Configure abaixo opções gerais do seu site",
"The information you enter here can be changed later" => "Essas informações podem ser alteradas depois",
"Refer to the <a href=\"http://doc.tiki.org/Admin+Panels\" target=\"_blank\">documentation</a> for complete information on these, and other, settings" => "Verifique a <a href=\"http://doc.tiki.org/Admin+Panels\" target=\"_blank\">documentação</a> para mais informações sobre estas e outras configurações",
"This will appear in the browser title bar" => "Será usado na barra de título do navegador",
"Email sent by your site will use this address" => "E-mails enviados pelo site utilizará esse endereço",
"Secure Log in" => "Log in seguro",
// "It is recommended to choose the \"Require secure (https) login\" option for better security. A security certificate and dedicated IP address are required to implement a secure login" => "It is recommended to choose the \"Require secure (https) login\" option for better security. A security certificate and dedicated IP address are required to implement a secure login",
"HTTPS login" => "Login HTTPS",
"PHP error reporting level:" => "Mensagens de erro do PHP:",
"Report all errors except notices" => "Reportar todos os erros, com exceção das notícias",
"Visible to Admin only" => "Visível apenas para administradores",
"Administrator" => "Administrador",
"Admin email" => "E-mail do administrador",
"This is the email address for your administrator account" => "Endereço de e-mail para a conta do usuário administrador do site",
// "Upgrade fix" => "Upgrade fix",
// "Experiencing problems with the upgrade? Your administrator account lost its privileges? This may occur if you upgraded from a very old version of Tiki.</p>\n\t\t\t<p>We can fix it! Doing so will" => "Experiencing problems with the upgrade? Your administrator account lost its privileges? This may occur if you upgraded from a very old version of Tiki.</p>\n\t\t\t<p>We can fix it! Doing so will",
// "Create the <em>Admins</em> group, if missing" => "Create the <em>Admins</em> group, if missing",
// "Grant <em>tiki_p_admin</em> to the group, if missing" => "Grant <em>tiki_p_admin</em> to the group, if missing",
// "Add the administrator account to the group, if missing" => "Add the administrator account to the group, if missing",
// "To do so enter the name of the main admin account in the field below" => "To do so enter the name of the main admin account in the field below",
// "Administrator account (optional): <input type=\"text\" name=\"admin_account\"/> <em>The default account is <strong>admin</strong></em>" => "Administrator account (optional): <input type=\"text\" name=\"admin_account\"/> <em>The default account is <strong>admin</strong></em>",
// "Check this box if you have a lot of disabled accounts after an upgrade to tiki4" => "Check this box if you have a lot of disabled accounts after an upgrade to tiki4",
// "List of accounts that will be enabled" => "List of accounts that will be enabled",
"Enter Your Tiki" => "Entrar no Tiki",
"The installation is complete" => "A instalação foi completado com sucesso!",
"Tiki is an open source project, <em>you</em> can <a href='http://info.tiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tiki.org/Develop+Tiki' target='_blank'>develop Tiki</a>" => "O Tiki é um projeto de software livre, <em>você</em> pode <a href='http://info.tiki.org/Join+the+Community' target='_blank'>se juntar a comunidade</a> e ajudar no seu <a href='http://info.tiki.org/Develop+Tiki' target='_blank'>desenvolvimento</a>",
"Installation" => "Instalação",
"If this is a first time installation, go to <strong>tiki-admin.php</strong> after login to start configuring your new Tiki installation" => "Se essa é uma instalação, vá para o painel de administração em <strong>tiki-admin.php</strong> e comece a configurar o seu Tiki",
"If this is an upgrade, clean the Tiki caches manually (the <strong>templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu" => "Se essa é uma atualização, limpe os caches do Tiki. Manualmente deletando o conteúdo do diretório <strong>templates_c</strong> ou acessando a opção <strong>Admin &gt; System</strong> no menu de administração",
"Enter Tiki and Lock Installer" => "Entrar no Tiki e travar o script de instalação",
"Recommended" => "Recomendado",
"Enter Tiki Without Locking Installer" => "Entrar no Tiki sem travar o script de instalação",
// "Not recommended due to security risk" => "Not recommended due to security risk",
// "Stay up-to-date" => "Stay up-to-date",
// "Subscribe to the <a href=\"http://tiki.org/Newsletter\" title=\"Subscribe\" target=\"_blank\">Tiki newsletter</a> or <a href=\"http://info.tiki.org/tiki-articles_rss.php\" title=\"RSS\" target=\"_blank\">RSS feed</a> to learn about new releases, security updates, and community news" => "Subscribe to the <a href=\"http://tiki.org/Newsletter\" title=\"Subscribe\" target=\"_blank\">Tiki newsletter</a> or <a href=\"http://info.tiki.org/tiki-articles_rss.php\" title=\"RSS\" target=\"_blank\">RSS feed</a> to learn about new releases, security updates, and community news",
"You can now access the site normally. Report back any issues that you might find (if any) to the Tiki forums or bug tracker" => "Você agora pode acessar seu site normalmente. Se encontrar algum problema ou tiver alguma dúvida entre em contato através dos fóruns e do bug tracker do Tiki",
"Are you sure you want to attempt to fix the encoding of your entire database" => "Você tem certeza de que deseja tentar corrigir a codificação dos caracteres de toda a sua base de dados",
"Upgrading and running into encoding issues" => "Problemas com a codificação de caracteres durante a atualização",
"We can try to fix it, but <strong>make sure you have backups, and can restore them</strong>" => "Esse script pode tentar corrigir esse problema, mas <strong>faça um backup antes e verifique se você pode restaurá-lo</strong>",
"Previous table encoding" => "Codificação de caracteres anterior",
"Please select" => "Selecione",
"Dangerous: Fix double encoding" => "Corrigir codificação dupla de caracteres (use com cuidado)",
"Oops. You need to make sure client charset is forced to UTF-8. Reset the database connection to continue" => "Oops. A conexão do cliente do banco de dados deve usar obrigatoriamente UTF-8. Altere as informações de conexão com a base de dados para continuar",
// "MultiTiki Setup" => "MultiTiki Setup",
// "Default Installation" => "Default Installation",
// "DB OK" => "DB OK",
// "No DB" => "No DB",
// "Adding a new host" => "Adding a new host",
// "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter" => "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter",
"MultiTiki" => "MultiTiki",
"Are you upgrading an existing Tiki site" => "Você está atualizando quer apenas atualizar um Tiki que já existe",
"Go directly to the <strong>Install/Upgrade</strong> step" => "Vá diretamente para <strong>Instalar/Atualizar</strong>",
"Install/Upgrade" => "Instalar/Atualizar",
"Restart the installer" => "Reiniciar o instalador",
"Database Connection" => "Conexão com a base de dados",
"Reset the Database Connection" => "Reiniciar a conexão com o bando de dados",
"Configure the General Settings" => "Configurações gerais",
// "Tiki Icon" => "Tiki Icon",
"Tiki Project Web Site" => "Site do projeto",
"Documentation" => "Documentação",
"Support Forums" => "Fóruns de suporte",
// "Powered by Tiki Wiki CMS Groupware" => "Powered by Tiki Wiki CMS Groupware",
"Clear cached version and refresh cache" => "Limpar versão em cache e recarregar o cache",
"configure rules" => "configurar regras",
"Edit Repository" => "Editar repositório",
// "Invitation" => "Invitation",
// "Invitations list" => "Invitations list",
// "The mail has been sent to: " => "The mail has been sent to: ",
// "You are about to send an invitation to theses people, please confirm" => "You are about to send an invitation to theses people, please confirm",
// "Fill this box with the list of e-mails you want to invite " => "Fill this box with the list of e-mails you want to invite ",
// "Format of the list above " => "Format of the list above ",
// "CSV Style: One line per invitation, with the format: lastname,firstname,email" => "CSV Style: One line per invitation, with the format: lastname,firstname,email",
// "Everything that appear as an email in the text will be detected and used (in that case, {literal}{firstname} and {lastname}{/literal} will be ignored in the email content)" => "Everything that appear as an email in the text will be detected and used (in that case, {literal}{firstname} and {lastname}{/literal} will be ignored in the email content)",
// "Type here the e-mail subject you'll want to be sent to them " => "Type here the e-mail subject you'll want to be sent to them ",
// "Type here the e-mail content you'll want to be sent to them (and let the {literal}{link}{/literal} word, it will be replaced with the good link for registering) " => "Type here the e-mail content you'll want to be sent to them (and let the {literal}{link}{/literal} word, it will be replaced with the good link for registering) ",
// "Type here the content that the user will see when he'll click on the link from the mail " => "Type here the content that the user will see when he'll click on the link from the mail ",
// "Choose one or more group you want theses suscribtion to be in. Don't choose any if you don't want anything special " => "Choose one or more group you want theses suscribtion to be in. Don't choose any if you don't want anything special ",
// "Invoices" => "Invoices",
// "New Invoice" => "New Invoice",
// "Clients" => "Clients",
// "New Client" => "New Client",
// "Invoice Reports" => "Invoice Reports",
// "Upload to Kaltura" => "Upload to Kaltura",
// "Upload Successful" => "Upload Successful",
// "You have successfully added {\$count} new entry/entries" => "You have successfully added {\$count} new entry/entries",
// "Add more media" => "Add more media",
// "Change Details" => "Change Details",
// "Remix" => "Remix",
// "Media Entries" => "Media Entries",
// "Advanced Editor" => "Advanced Editor",
// "Simple Editor" => "Simple Editor",
// "Video Title" => "Video Title",
"Editor" => "Editor",
// "Embed code" => "Embed code",
// "Plays" => "Plays",
// "No action specified" => "No action specified",
"Last Changes" => "Últimas alterações",
// "Last 2 days" => "Last 2 days",
// "Last 3 days" => "Last 3 days",
// "Last 5 days" => "Last 5 days",
// "Last week" => "Last week",
// "Last 2 weeks" => "Last 2 weeks",
// "Last month" => "Last month",
"Search by Date" => "Busca por Data",
"Found" => "Encontrado",
"LastChanges" => "Ultimas alterações",
// "{\$lastchanges[changes].action|escape}" => "{\$lastchanges[changes].action|escape}",
// "v" => "v",
"Pages like" => "Páginas semelhantes",
"New Article" => "Novo artigo",
"View Submissions" => "Ver artigos enviados",
// "Expiry Date" => "Expiry Date",
// "{\$listpages[changes].type|escape}" => "{\$listpages[changes].type|escape}",
// "{\$listpages[changes].disp_article}" => "{\$listpages[changes].disp_article}",
// "{\$listpages[changes].lang}" => "{\$listpages[changes].lang}",
// "{\$listpages[changes].hasImage}" => "{\$listpages[changes].hasImage}",
// "{\$listpages[changes].useImage}" => "{\$listpages[changes].useImage}",
// "Permissons" => "Permissons",
// "Select Duplicates" => "Select Duplicates",
"To use a banner in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone." => "Para usar um banner em um <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">módulo</a> ou em um template, use o código {literal}{banner zone=ABC}{/literal}, onde ABC é o nome da zona de banners.",
"Create banner" => "Criar um banner",
"Method" => "Método",
"Use Dates?" => "Usar datas?",
"Max Impressions" => "Máx. Exibições",
"Impressions" => "Exibições",
// "Max Clicks" => "Max Clicks",
"Clicks" => "Cliques",
"Create New Blog" => "Criar um novo blog",
"List all comments" => "Listar todos os comentários",
// "The cache is used by" => "The cache is used by",
// "{\$headerName}" => "{\$headerName}",
// "Approval" => "Approval",
"More info" => "Mais informações",
"(no title)" => "(sem título)",
// "{\$val|ucwords}" => "{\$val|ucwords}",
"Approved" => "Aprovada",
// "Rejected" => "Rejected",
// "Delete & Ban" => "Delete & Ban",
// "To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block" => "To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block",
// "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block" => "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block",
"Available content blocks" => "Blocos de conteúdo disponíveis",
// "Current Value" => "Current Value",
"Current ver" => "Versão atual",
"Next ver" => "Próxima vers.",
"Future vers" => "Versões futuras",
"Program" => "Programa",
// "Create/Edit content block" => "Create/Edit content block",
// "Edit content block" => "Edit content block",
// "Create content block" => "Create content block",
"Available FAQs" => "FAQs Disponíveis",
"Edit/Create" => "Editar/Criar",
"Edit this FAQ:" => "Editar este FAQ:",
"Create new FAQ" => "Criar um novo FAQ",
"Create New FAQ:" => "Criar um novo FAQ:",
"Users can suggest questions" => "Usuários podem sugerir perguntas",
"Create a File Gallery" => "Criar uma galeria de arquivos",
"RSS feed" => "Fonte RSS",
"Admin View" => "Visão administrativa",
// "Create a drawing" => "Create a drawing",
// "SlideShow" => "SlideShow",
"Keep gallery window open" => "Manter a janela da galeria aberta",
"Your comment" => "Comentário",
"optional" => "opcional",
"Modifications" => "Modificações",
// "Property <b>{\$fgp_name}</b> Changed" => "Property <b>{\$fgp_name}</b> Changed",
// "Gallery of this fileId" => "Gallery of this fileId",
// "space use on" => "space use on",
"Gallery Images" => "Imagens da Galeria",
// "Inviter" => "Inviter",
// "Only successful invitations" => "Only successful invitations",
// "Only pending invitations" => "Only pending invitations",
// "Number of invitations" => "Number of invitations",
// "Invoice Clients" => "Invoice Clients",
// "Tax Status" => "Tax Status",
// "New Contact" => "New Contact",
// "Client Name" => "Client Name",
// "Kaltura Remix Entries" => "Kaltura Remix Entries",
// "Kaltura Media Entries" => "Kaltura Media Entries",
// "Loads" => "Loads",
// "List Remixes" => "List Remixes",
// "Browse Media Entries" => "Browse Media Entries",
// "Browse Remixes" => "Browse Remixes",
// "Create Remix" => "Create Remix",
// "Please select some media entries to use" => "Please select some media entries to use",
// "Remix Video" => "Remix Video",
"Additional Info" => "Informações adicionais",
"Created by" => "Criada por",
// "Media Id" => "Media Id",
// "Wiki plugin code" => "Wiki plugin code",
// "Media Type" => "Media Type",
// "More Information" => "More Information",
// "No entries" => "No entries",
// "No media entries found" => "No media entries found",
// "Click here" => "Click here",
// "to upload" => "to upload",
// "Modified By" => "Modified By",
// "No mix entries found" => "No mix entries found",
// "to create a new mix" => "to create a new mix",
// "Mix Entries" => "Mix Entries",
// "Playlist Type" => "Playlist Type",
// "No playlists found. " => "No playlists found. ",
// "Click here " => "Click here ",
// "to create a playlist" => "to create a playlist",
"Object Permissions List" => "Lista de permissões por objeto",
"Manage Permissions" => "Gerenciar permissões",
// "\$type" => "\$type",
"global permissions" => "permissões globais",
"object permissions" => "permissões do objeto",
"category permissions" => "permissões da categoria",
"Global Permissions" => "Permissões globais",
"Delete the selected permissions" => "Deletar as permissões selecionadas",
"Duplicate the selected permissions on this group" => "Duplicar as permissões selecionadas",
"Object Permissions" => "Permissões do objeto",
"If an object is not listed in this section nor in the Category Permissions section, then only the global permissions apply to it" => "Se um objeto não está listado nesta sessão ou na sessão de permissões da categoria, então apenas permissões globais são aplicadas a ele",
"Category Permissions" => "Permissões da categoria",
"If an object is not listed in this section nor in the Object Permissions section, then only the global permissions apply to it" => "Se um objeto não está listado nesta sessão ou na sessão de permissões do objeto, então apenas permissões globais são aplicadas a ele",
// "{\$special.reason|escape}" => "{\$special.reason|escape}",
"Blog: %0" => "Blog: %0",
"New Blog Post" => "Novo post",
"Post Title" => "Título do post",
"Blog Title" => "Título do Blog",
// "New Submission" => "New Submission",
"Survey stats" => "Estatísticas da pesquisa",
"Take Survey" => "Pegar pesquisa",
"trackers" => "formulários",
"Items" => "Itens",
// "Export %0" => "Export %0",
// "Import in %0" => "Import in %0",
// "Stop Monitor" => "Stop Monitor",
"Monitor" => "Monitorar",
// "Create tracker" => "Create tracker",
// "Do you really remove this tracker" => "Do you really remove this tracker",
// "Do you really want to clear all the items from this tracker? (N.B. there is no undo and notifications will not be sent)" => "Do you really want to clear all the items from this tracker? (N.B. there is no undo and notifications will not be sent)",
// "Duplicate/Import Tracker" => "Duplicate/Import Tracker",
// "Duplicate Tracker" => "Duplicate Tracker",
// "Duplicate Remote Tracker" => "Duplicate Remote Tracker",
// "Search for trackers to clone" => "Search for trackers to clone",
// "Import From Export" => "Import From Export",
// "Raw data" => "Raw data",
// "Preserve tracker ID" => "Preserve tracker ID",
"users registered" => "usuários registrados",
"like" => "como",
"Distance (km)" => "Distância (km)",
// "{\$listuserscountry[changes]}" => "{\$listuserscountry[changes]}",
"List Wiki Pages" => "Listar páginas wiki",
// "Page aliases found" => "Page aliases found",
"Create a Wiki Page" => "Criar página wiki",
"Insert name of the page you wish to create" => "Insira o nome da página que você deseja criar",
"Last mod" => "Última alteração",
"Page creator" => "Criador da página",
"Last author" => "Último autor",
"Last version" => "Última versão",
"Last ver" => "Última versão",
"Status of the page" => "Status da página",
"Vers" => "Vers",
// "Links to other items in page" => "Links to other items in page",
// "Links to this page in other pages" => "Links to this page in other pages",
// "Backl" => "Backl",
"Page size" => "Tamanho da página",
// "Ratings" => "Ratings",
"unlocked" => "destravada",
// "No page" => "No page",
// "No pages found with" => "No pages found with",
// "Xml Zip" => "Xml Zip",
// "Add page name as a header ! at the beginning of the page content" => "Add page name as a header ! at the beginning of the page content",
"Open client window" => "Abrir a janela de cliente",
"Generate HTML" => "Gerar HTML",
"Transcripts" => "Transcrição",
"Online operators" => "Operadores on-line",
"Operator" => "Operador",
"Accepted requests" => "Aceitar requisições",
// "{\$online_operators[ix].status}" => "{\$online_operators[ix].status}",
"transcripts" => "transcrição",
// "offline" => "offline",
"Offline operators" => "Operadores offline",
// "{\$offline_operators[ix].status}" => "{\$offline_operators[ix].status}",
"Add an operator to the system" => "Adicionar um operador ao sistema",
"Operators must be tiki users" => "Operadores devem ser usuários Tiki",
"Set as Operator" => "Definir como operador",
"Chat started" => "Chat iniciado",
"Operator:" => "Operador:",
"Live support:User window" => "Suporte on-line:Janela do usuário",
"Request live support" => "Requisitar suporte on-line",
"Request support" => "Requisitar suporte",
"Open a support ticket instead" => "Obter um bilhete de suporte ao invés disto",
"Your request is being processed" => "Sua requisição está sendo processada",
"cancel request and exit" => "cancelar a requisição e sair",
"cancel request and leave a message" => "cancelar a requisição e deixar uma mensagem",
"Live support:Console" => "Suporte on-line:Console",
"Status:" => "Estado:",
// "{\$status}" => "{\$status}",
"be online" => "ficar on-line",
"be offline" => "ficar offline",
// "You are not an operator" => "You are not an operator",
"Support requests" => "Requisições de suporte",
"Requested" => "Requisitou",
"Join" => "Juntar-se",
// "No support requests" => "No support requests",
"Support chat transcripts" => "Transcrições do chat de suporte",
"Back to admin" => "Voltar ao admin",
"operator" => "operador",
"started" => "iniciou",
"reason" => "motivo",
"msgs" => "msgs",
"Transcript" => "Transcrição",
// "For security purposes we must periodically validate your email address to allow continued access to this site" => "For security purposes we must periodically validate your email address to allow continued access to this site",
// "A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site" => "A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site",
"Thank you" => "Obrigado",
"Mail-in feature" => "Recurso mail-in",
// "You do not have any mailin accounts set up" => "You do not have any mailin accounts set up",
// "Click here to go to mailin admin" => "Click here to go to mailin admin",
// "Change to" => "Change to",
// "Week containing" => "Week containing",
// "Month containing" => "Month containing",
// "{\$metrics_range_prefix}" => "{\$metrics_range_prefix}",
// "{\$metrics_range_suffix}" => "{\$metrics_range_suffix}",
// "Missing dependency. Obtain <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/" => "Missing dependency. Obtain <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/",
"Prefs" => "Prefs",
"Daily" => "Diariamente",
"Weekly" => "Semanalmente",
"Remove old events" => "Remover eventos antigos",
"h" => "h",
"mins" => "min",
// "Edit Event" => "Edit Event",
"Mini Calendar: Preferences" => "Mini-Calendário: Preferências",
"Calendar Interval in daily view" => "Intervalo do calendário na visão diária",
"Start hour for days" => "Hora inicial para os dias",
"End hour for days" => "Hora final para os dias",
"Reminders" => "Lembretes",
"no reminders" => "sem lembretes",
"min" => "min",
"Or enter path or URL" => "Ou entre o caminho ou endereço",
"Add Topic" => "Adicionar assunto",
// "Tiki Mods" => "Tiki Mods",
// "Mods Configuration" => "Mods Configuration",
// "Update remote index" => "Update remote index",
"Rebuild local list" => "Reconstruir lista localRebuild local list",
"Republish all" => "Republicar todos",
"Publish all" => "Publicar todos",
"Unpublish all" => "Despublicar todos",
// "Tiki \"mods\" are additional features not included in the public release. Learn more at <a target=\"tikihelp\" href=\"http://mods.tiki.org\">mods.tiki.org</a>" => "Tiki \"mods\" are additional features not included in the public release. Learn more at <a target=\"tikihelp\" href=\"http://mods.tiki.org\">mods.tiki.org</a>",
// "Tiki \"mods\" are undergoing refurbishment" => "Tiki \"mods\" are undergoing refurbishment",
// "You will probably find mods shown as being compatible with older versions of Tiki will work with later versions with little or no modification" => "You will probably find mods shown as being compatible with older versions of Tiki will work with later versions with little or no modification",
// "Your help is needed! Please visit <a href=\"http://dev.tiki.org/Mods\">dev.tiki.org</a> to find out more" => "Your help is needed! Please visit <a href=\"http://dev.tiki.org/Mods\">dev.tiki.org</a> to find out more",
"Attention" => "Atenção",
// "Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"sh setup.sh\" for example)" => "Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"sh setup.sh\" for example)",
// "To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"sh setup.sh open\" to set it up). After installation you need to remove that permission (using \"sh setup.sh\")" => "To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"sh setup.sh open\" to set it up). After installation you need to remove that permission (using \"sh setup.sh\")",
// "for version" => "for version",
// "All versions" => "All versions",
// "or later" => "or later",
// "No mods found" => "No mods found",
"Display only this type" => "Mostrar apenas esse tipo",
"Unpublish" => "Não publicar",
"Republish" => "Publicar novamente",
// "licence" => "licence",
"Last Modification:" => "última modificação:",
// "Tiki Mods Configuration" => "Tiki Mods Configuration",
// "Mods Install/uninstall" => "Mods Install/uninstall",
// "Enable Mods providing" => "Enable Mods providing",
// "Mods local directory" => "Mods local directory",
// "Mods remote server" => "Mods remote server",
"Package Config" => "Configurar pacote",
"y" => "s",
// "Edit: %0" => "Edit: %0",
"User Galleries" => "Galerias de Usuário",
"My Articles" => "Meus artigos",
// "User Articles" => "User Articles",
"My User Items" => "Meus itens de usuário",
"User Items" => "Itens do usuário",
"Unread Messages" => "Mensagens não lidas",
// "User forum topics" => "User forum topics",
"Forum topics" => "Tópicos dos fóruns",
// "Date of post" => "Date of post",
// "User forum replies" => "User forum replies",
"Forum replies" => "Respostas nos fóruns",
"User Blogs" => "Blogs de Usuários",
// "To display the objects you created or contributed to" => "To display the objects you created or contributed to",
"MyTiki" => "Área pessoal",
"MyInfo" => "Minhas informações",
// "Contacts Preferences" => "Contacts Preferences",
"Notepad" => "Bloco de notas",
"MyFiles" => "Meus Arquivos",
"My Watches" => "Minhas notificações",
"Sent editions" => "Edições enviadas",
// "HTML version" => "HTML version",
// "Text version" => "Text version",
"The newsletter was sent to {\$sent} email addresses" => "O comunicado foi enviado para {\$sent} endereços de email",
// "Delete errors" => "Delete errors",
// "Not sent" => "Not sent",
"Thanks for your subscription. You will receive an email soon to confirm your subscription. No newsletters will be sent to you until the subscription is confirmed." => "Obrigado por sua assinatura. Você receberá um email em breve para confirmar sua assinatura. Nenhum comunicado será enviado até que sua inscrição seja confirmada.",
"Your email address was removed from the list of subscriptors." => "Seu endereço de email foi removido da lista de assinantes.",
// "Removal of your email address failed" => "Removal of your email address failed",
"Subscription confirmed!" => "Assinatura confirmada!",
// "Subscription failed" => "Subscription failed",
// "Subscribe to Newsletter" => "Subscribe to Newsletter",
// "Subscribe to this Newsletter" => "Subscribe to this Newsletter",
"Available Newsletters" => "Newsletters disponíveis",
"Write a note" => "Escrever uma nota",
"quota" => "cota",
"No notes yet" => "Sem notas ainda",
"Merge selected notes into" => "combinar notas selecionadas em",
"Reading note:" => "Lendo nota:",
"List notes" => "Listar notas",
"Write note" => "Escrever nota",
"Wiki Create" => "Criar wiki",
"Wiki Overwrite" => "Sobrescrever wiki",
"Object Watches:" => "Monitorar objetos:",
// "Object Watches" => "Object Watches",
// "Changes to groups watching" => "Changes to groups watching",
// "These changes to group watches" => "These changes to group watches",
// "were made to these descendants" => "were made to these descendants",
// "Groups watching" => "Groups watching",
"This Category" => "Esta categoria",
"All Descendants" => "Todos os descendentes",
"Assign global permissions" => "Designar permissões globais",
"Assign permissions to " => "Definir permissões a ",
"Edit Permissions" => "Editar permissões",
"Currently editing Global permissions" => "Editando permissões globais",
"This object's direct permissions override any global permissions or category permissions affecting this object" => "As permissões aplicadas diretamente a este objeto sobrescrevem qualquer permissão aplicada globalmente ou a uma categoria da qual este objeto faz parte",
"This category's direct permissions override any global permissions affecting objects in it" => "As permissões dessa categoria sobrescrevem quaisquer permissões globais aplicadas aos objetos que fazem parte dela",
"To edit global permissions" => "Para editar permissões globais",
"No permissions yet applied to this object but category permissions affect this object and are displayed below" => "Nenhuma permissão aplicada diretamente a este objeto, porém permissões aplicadas a uma categoria afetam esse objeto e são exibidas abaixo",
"To edit category permissions" => "Para editar permissões da categoria",
"No direct permissions yet applied to this object. Global permissions apply" => "Nenhuma permissão aplicada diretamente a este objeto. Utilizando as permissões globais",
"Currently inherited permissions displayed" => "Exibindo permissões herdadas",
"Assign permissions to this category" => "Definir permissões para esta categoria",
"Assign permissions to this object" => "Definir permissões para este objeto",
"Delete category permissions" => "Deletar permissões da categoria",
"Delete object permissions" => "Deletar permissões do objeto",
"Reset Perms" => "Restaurar permissões",
"This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions" => "Isso vai remover todas as configurações aplicadas aqui e as permissões desse objeto passarão a ser as permissões da categoria ou as permissões globais",
"This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions" => "Isso vai remover todas as configurações aplicadas aqui e as permissões desse objeto passarão a ser as permissões globais",
"Permissions Clipboard" => "Copiar permissões",
"Copy the permissions set here" => "Copiar o conjunto de permissões",
"Paste" => "Colar",
"Paste copied permissions from " => "Colar permissões copiadas de ",
// "Assign or remove permissions on <em>all</em> child categories" => "Assign or remove permissions on <em>all</em> child categories",
// "Are you sure you want to affect all child categories?\\nThere is no undo" => "Are you sure you want to affect all child categories?\\nThere is no undo",
// "Assign or remove permissions on all pages of the sub-structure" => "Assign or remove permissions on all pages of the sub-structure",
// "Are you sure you want to affect all pages in this sub-structure?\\nThere is no undo" => "Are you sure you want to affect all pages in this sub-structure?\\nThere is no undo",
"You must select at least one feature" => "Você deve selecionar pelo menos um recurso",
"View Differences" => "Ver diferenças",
"Permissions added" => "Permissões adicionadas",
"Permissions removed" => "Permissões removidas",
"Select groups" => "Selecionar grupos",
"Some of your groups have been automatically hidden.<br /> Select the groups below to assign permissions for" => "Alguns grupos foram automaticamente escondidos.<br /> Selecione abaixo os grupos aos quais você deseja atribuir permissões",
"These groups are not the groups that have permissions on the object. It is only the groups you can see in the columns of the first tab" => "Esses grupos não são os grupos que possuem permissão no objeto. São apenas os grupos que serão exibidos na primeira aba",
"Select only groups that have a perm with the object" => "Selecionar apenas os grupos que tem alguma permissão no objeto",
"Select features" => "Selecionar recursos",
"Some of your features have been automatically hidden.<br /> Select the features below to assign permissions for" => "Alguns recursos foram automaticamente escondidos.<br /> Selecione os recursos aos quais você deseja atribuir permissões",
"Show permissions for disabled features" => "Exibir permissões de recursos desabilitados",
"Feature name" => "Nome do recurso",
// "Quick Permissions" => "Quick Permissions",
// "Assign Quick-Permissions to this object" => "Assign Quick-Permissions to this object",
// "A couple of userdefined permissions are currently assigned (See tab Assign Permissions)" => "A couple of userdefined permissions are currently assigned (See tab Assign Permissions)",
// "<em>Quick permissions</em> should be considered as an experimental feature" => "<em>Quick permissions</em> should be considered as an experimental feature",
// "Although permissions will be set as expected using this form, it doesn't necessarily show the current permissions reliably" => "Although permissions will be set as expected using this form, it doesn't necessarily show the current permissions reliably",
// "There is also no undo - <strong>Use with care!</strong>" => "There is also no undo - <strong>Use with care!</strong>",
"Your OpenID identity is valid" => "Sua identidade OpenID é válida",
// "Your identity gives you access to multiple user accounts" => "Your identity gives you access to multiple user accounts",
// "Select account" => "Select account",
"Orphan Pages" => "Páginas Órfãs",
"Browser not supported" => "Navegador não suportado",
// "Contributions to" => "Contributions to",
"current version" => "versão atual",
"version" => "versão",
"Words" => "Palavras",
"Whitespaces" => "Espaços",
"Characters" => "Caracteres",
// "Printable characters" => "Printable characters",
// "Page changes" => "Page changes",
// "Original wiki text" => "Original wiki text",
// "Parsed Text (HTML)" => "Parsed Text (HTML)",
// "Output text only (No HTML tags)" => "Output text only (No HTML tags)",
// "Show statistics" => "Show statistics",
// "Visualize page changes" => "Visualize page changes",
// "Show popups" => "Show popups",
// "Escape HTML / Wiki syntax in page changes" => "Escape HTML / Wiki syntax in page changes",
// "Show contributions" => "Show contributions",
// "Show Edit Sessions" => "Show Edit Sessions",
"Show All Versions" => "Mostrar todas as versões",
"Preview of version" => "Visualização prévia da versão",
"(current)" => "(atual)",
"Rollback to this version" => "Restaurar para essa versão",
// "Content Approval" => "Content Approval",
// "This revision is currently marked as approved" => "This revision is currently marked as approved",
// "Remove Approval" => "Remove Approval",
// "This revision has not been approved" => "This revision has not been approved",
// "Approve Revision" => "Approve Revision",
"Source of version" => "Fonte da versão",
"s=source" => "s=fonte",
"b=rollback" => "b=restaurar",
// "by %0" => "by %0",
// "from %0" => "from %0",
// "approved" => "approved",
// "Updated from" => "Updated from",
// "Used to update" => "Used to update",
// "Wiki Wysiwyg" => "Wiki Wysiwyg",
"Update Translation" => "Atualizar tradução",
"Hide translation history" => "Esconder histórico de tradução",
"Show translation history" => "Mostrar histórico de tradução",
"Enable pagination" => "Usar paginação",
"per page" => "por página",
// "Payment Date" => "Payment Date",
// "Payment Type" => "Payment Type",
// "Payer" => "Payer",
// "View payment info" => "View payment info",
// "Assign permissions for payments" => "Assign permissions for payments",
// "Cancel this payment request" => "Cancel this payment request",
// "Request Date" => "Request Date",
// "View payment request" => "View payment request",
// "Paypal" => "Paypal",
// "Transaction ID" => "Transaction ID",
// "Payment made by <em>%0, %1</em> (%2)" => "Payment made by <em>%0, %1</em> (%2)",
// "{\$wp_member_title}" => "{\$wp_member_title}",
// "{\$payment_info.state|escape}" => "{\$payment_info.state|escape}",
// "Paid amount" => "Paid amount",
// "Initial amount" => "Initial amount",
// "Amount remaining" => "Amount remaining",
// "Payment request was sent on %0 and is due by %1" => "Payment request was sent on %0 and is due by %1",
// "Pay with Credit Card through Paypal" => "Pay with Credit Card through Paypal",
// "Pay with Paypal" => "Pay with Paypal",
// "Refresh page" => "Refresh page",
// "Payment info" => "Payment info",
// "Trade with Cclite" => "Trade with Cclite",
// "Payment problem" => "Payment problem",
// "Pay with Tiki User Credits" => "Pay with Tiki User Credits",
// "Credit type" => "Credit type",
// "Credits left" => "Credits left",
// "Amount to pay" => "Amount to pay",
// "Pay using" => "Pay using",
// "Manual payment entry" => "Manual payment entry",
// "Enter payment" => "Enter payment",
// "using" => "using",
// "Payment information" => "Payment information",
// "Outstanding" => "Outstanding",
// "Overdue" => "Overdue",
// "Past" => "Past",
// "Request" => "Request",
// "Detail" => "Detail",
// "Payable within" => "Payable within",
"Pick your avatar" => "Selecione sua fotografia",
"Your current avatar" => "Sua fotografia atual",
// "Full size" => "Full size",
"no avatar" => "sem fotografia",
"Pick avatar from the library" => "Selecionar uma fotografia da biblioteca",
"Pick user Avatar" => "Escolher fotografia do usuário",
"Hide all" => "Esconder todos",
"icons" => "ícones",
"Show all" => "Exibir todos",
"Avatar Image" => "Imagem da fotografia",
"random" => "aleatório",
"Upload your own avatar" => "Carregar sua própria fotografia",
// "File (only .gif, .jpg and .png images approximately 45px × 45px)" => "File (only .gif, .jpg and .png images approximately 45px × 45px)",
// "File (only .gif, .jpg and .png images)" => "File (only .gif, .jpg and .png images)",
// "Plugin execution was denied" => "Plugin execution was denied",
// "Plugin execution pending approval" => "Plugin execution pending approval",
// "After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected" => "After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected",
// "This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible" => "This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible",
// "You are allowed to" => "You are allowed to",
// "View arguments" => "View arguments",
// "Execute the plugin in preview mode (may be dangerous)" => "Execute the plugin in preview mode (may be dangerous)",
// "Approve the plugin for public execution" => "Approve the plugin for public execution",
"View Details" => "Ver detalhes",
// "This plugin does not contain any arguments" => "This plugin does not contain any arguments",
"Body" => "Corpo",
// "This plugin's body is empty" => "This plugin's body is empty",
"Insert" => "Inserir",
// "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups" => "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups",
// "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins" => "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins",
// "This page lists the plugins that require validation, the first time they are encountered" => "This page lists the plugins that require validation, the first time they are encountered",
// "Each plugin contains a unique <em>signature</em> that is preserved" => "Each plugin contains a unique <em>signature</em> that is preserved",
// "When you upgrade from an old version, you may need to reparse all the pages" => "When you upgrade from an old version, you may need to reparse all the pages",
// "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list" => "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list",
// "The plugin will automatically be added if it is encountered" => "The plugin will automatically be added if it is encountered",
// "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin" => "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin",
// "For security, you should review each plugin to ensure it is safe to approve" => "For security, you should review each plugin to ensure it is safe to approve",
// "Added By" => "Added By",
// "Signature" => "Signature",
// "Wiki page: <a href=\"%0#%2\" title=\"{tr}View this page" => "Wiki page: <a href=\"%0#%2\" title=\"{tr}View this page",
// "<a href=\"%0#%2\" title=\"{tr}View this page" => "<a href=\"%0#%2\" title=\"{tr}View this page",
// "Approve all pending plugins" => "Approve all pending plugins",
// "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins" => "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins",
// "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe" => "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe",
"No plugins pending approval" => "Nenhum plugin na fila para ser aprovado",
// "{\$channels[ix].title|escape}" => "{\$channels[ix].title|escape}",
"View Results" => "Ver Resultados",
"Vote poll" => "Votar na enquete",
// "This poll is closed" => "This poll is closed",
"Other Polls" => "Outras enquetes",
// "Poll Results" => "Poll Results",
// "Top Voted Polls" => "Top Voted Polls",
// "Edit Poll" => "Edit Poll",
// "Find the poll" => "Find the poll",
// "{\$what}" => "{\$what}",
// "Number of top voted polls to show" => "Number of top voted polls to show",
// "Vote range displayed" => "Vote range displayed",
// "All votes with no span consideration" => "All votes with no span consideration",
// "All votes with span consideration" => "All votes with span consideration",
"All votes" => "Todos os votos",
"List Votes" => "Listar votos",
"votes" => "votos",
// "Popup preview" => "Popup preview",
// "Close preview" => "Close preview",
"Topic image" => "Imagem do assunto",
"The original document is available at" => "O documento original pode ser encontrado em",
"Print multiple pages" => "Imprimir múltiplas páginas",
// "Selected Structures" => "Selected Structures",
// "Add Structure" => "Add Structure",
// "No structures" => "No structures",
// "Available Pages" => "Available Pages",
// "No pages" => "No pages",
// "All pages selected" => "All pages selected",
"Add Page" => "Adicionar página",
"Remove Page" => "Remover página",
// "Selected Pages" => "Selected Pages",
// "No pages selected" => "No pages selected",
// "Add Pages from Structures" => "Add Pages from Structures",
"Edit quiz" => "Editar quiz",
"Current Version" => "Versão atual",
"General Options" => "Opções gerais",
"Publication Date" => "Data da publicação",
"at " => "às ",
"Use " => "Uso ",
"randomly selected questions." => "selecionar questões aleatoriamente.",
"Test-time Options" => "Opções durante o teste",
"Shuffle questions" => "Embaralhar questões",
"Shuffle answers" => "Embaralhar respostas",
"Limit questions displayed per page to " => "Limitar questões mostradas por página ",
"  question(s)." => "  questão(s).",
"Impose a time limit of " => "Impor um limite de tempo de ",
"Allow students to store partial results and return to quiz." => "Permitir que estudantes guardem resultados parciais e voltem para o quiz.",
"Allow students to retake this quiz " => "Permitir que estudantes reiniciem esse quiz ",
"Grading and Feedback" => "Classificação e retorno",
"Grading method " => "Método de classificação ",
"Show students their score " => "Mostrar para os estudantes sua pontuação ",
"Show students the correct answers " => "Mostrar para os estudantes a resposta correta ",
"Publish statistics " => "Publicar estatísticas ",
"Extra Options" => "Opções extras",
"Solicit additional questions from students" => "Solicitar questões adicionais dos estudantes",
"Link quiz to forum named: " => "Criar um link do quiz para um fórum chamado: ",
"Prologue:" => "Prólogo:",
"Epilogue:" => "Epílogo:",
"Quiz result stats" => "Estatísticas de resultados do Teste",
"Time" => "Tempo",
"User answers" => "Respostas do usuário",
"Stats for quizzes" => "Estats para testes",
"taken" => "feitos",
"Av score" => "Pontuação méd.",
"Av time" => "Tempo méd.",
"Stats for quiz" => "Estats para a pesquisa",
"Clear Stats" => "Limpar estatísticas",
"time taken" => "tempo total",
// "P/F" => "P/F",
// "Passed" => "Passed",
"Stats for this quiz Questions " => "Estatísticas para as perguntas deste teste ",
"Top 10" => "10 Mais",
"Top 20" => "20 Mais",
"Top 50" => "50 Mais",
"Top 100" => "100 Mais",
// "Rank" => "Rank",
// "Not Published" => "Not Published",
// "This Article is currently not published and only visible by Editors" => "This Article is currently not published and only visible by Editors",
"Received articles" => "Artigos recebidos",
"Edit received article" => "Editar o artigo recebido",
"Use Image" => "Usar Imagem",
"Image x size" => "Largura da imagem",
"Image y size" => "Altura da imagem",
"Image name" => "Nome da imagem",
"Accept Article" => "Aceitar o Artigo",
"Received Pages" => "Páginas Recebidas",
// "{\$error.error}" => "{\$error.error}",
// "Edit Received Page" => "Edit Received Page",
// "The highlight pages already exist" => "The highlight pages already exist",
// "Please, change the name if you want the page to be uploaded" => "Please, change the name if you want the page to be uploaded",
// "Received Structures" => "Received Structures",
// "Prefix the checked" => "Prefix the checked",
// "Postfix the checked" => "Postfix the checked",
"Referer stats" => "Estatísticas de referência",
"Last" => "Última",
"Register as a new user" => "Registrar-se como novo usuário",
"Tiki site registered" => "Site Tiki registrado",
"The following site was added and validation by admin may be needed before appearing on the lists" => "O site a seguir foi adicionado mas a validação pelo administrador pode ser necessária antes que apareça nas listas",
"You don't have permission to use this feature." => "Você não tem permissão para usar esse recurso.",
"Please register." => "Por favor faça o registro.",
// "Register this site at Tiki.org" => "Register this site at Tiki.org",
"Read this first!" => "Leia isto em primeiro!",
// "On this page you can make your tiki site known to Tiki.org. It will get shown there in a list of known tiki sites" => "On this page you can make your tiki site known to Tiki.org. It will get shown there in a list of known tiki sites",
"Registering is voluntary." => "O registro é voluntário.",
"Registering does not give you any benefits except one more link to your site." => "O registro não dá à você nenhum benefício exceto o link para seu site.",
"You don't get any emails, we don't sell the data about your site." => "Você não pode pegar nenhum e-mail, nós não vendemos os dados sobre seu site.",
"Registering is just for us to get an overview of Tiki's usage." => "O registro é somente para obtermos uma amostragem do uso do Tiki.",
"If your site is private or inside your intranet, you should not register!" => "Se o seu site é privado ou está dentro de sua intranet, você não deve se registrar!",
"tiki.org" => "tiki.org",
"Information about your site" => "Informação sobre seu site",
"Enter your username or email" => "Digite seu usuário ou e-mail",
"Enter your email" => "Digite seu e-mail",
"Send me my Password" => "Envie minha senha",
"Request Password Reset" => "Solicitar uma nova senha",
"Remove page" => "Remover a página",
"Last Version" => "última versão",
"Back to page" => "Voltar à página",
"You are about to remove the page" => "Você está prestes a remover a página",
"permanently" => "permanentemente",
"Remove all versions of this page" => "Remover todas as versões desta página",
"Rename page" => "Renomear a página",
"Rollback page" => "Restaurar versão da página",
// "to version" => "to version",
// "This feature currently searches and replaces within wiki pages only" => "This feature currently searches and replaces within wiki pages only",
// "Max number of pages at a time" => "Max number of pages at a time",
// "Number of surrounding chars to preview" => "Number of surrounding chars to preview",
// "Replace selected" => "Replace selected",
"Searched" => "Buscadas",
"Search in" => "Buscar em",
"Date Search" => "Busca por data",
"All dates" => "Todas as datas",
// "{\$languages[ix].name}" => "{\$languages[ix].name}",
// "Calendar Items" => "Calendar Items",
// "{\$where|escape}" => "{\$where|escape}",
// "{\$where_label|escape}" => "{\$where_label|escape}",
// "{\$results[search].type|escape}" => "{\$results[search].type|escape}",
"Simple search" => "Busca simples",
// "You can also send newsletters using an external client" => "You can also send newsletters using an external client",
"This newsletter will be sent to {\$subscribers} email addresses." => "Este comunicado será enviado para {\$subscribers} endereços de email.",
// "Reply to" => "Reply to",
// "Recipients" => "Recipients",
// "Validated" => "Validated",
// "Is user" => "Is user",
// "Sending Newsletter" => "Sending Newsletter",
"Prepare a newsletter to be sent" => "Preparar um comunicado para envio",
"Apply content template" => "Aplicar conteúdo do template",
// "Data HTML" => "Data HTML",
// "Data Txt" => "Data Txt",
// "Article Clip (read only)" => "Article Clip (read only)",
// "Clip Now" => "Clip Now",
// "Clip Articles" => "Clip Articles",
// "To include the article clipping into your newsletter, cut and paste it into the contents" => "To include the article clipping into your newsletter, cut and paste it into the contents",
// "If autoclipping is enabled, you can also enter \"~~~articleclip~~~\" which will be replaced with the latest\tclip when sending" => "If autoclipping is enabled, you can also enter \"~~~articleclip~~~\" which will be replaced with the latest\tclip when sending",
// "Be careful not to paste articles that must not be seen by the recipients" => "Be careful not to paste articles that must not be seen by the recipients",
// "Attached Files" => "Attached Files",
"remove" => "remover",
// "octets" => "octets",
// "To add a file, click here" => "To add a file, click here",
// "Reply To Email" => "Reply To Email",
// "if not" => "if not",
// "Sender email not set" => "Sender email not set",
// "Save as Draft" => "Save as Draft",
// "Save your changes" => "Save your changes",
// "Save any changes and send to all subscribers" => "Save any changes and send to all subscribers",
// "Drafts (%0)" => "Drafts (%0)",
// "Sent Editions (%0)" => "Sent Editions (%0)",
"Send objects" => "Enviar objetos",
"Transmission results" => "Resultados da transmissão",
"Send Wiki Pages" => "Enviar Páginas Wiki",
// "Send a structure" => "Send a structure",
"Send Articles" => "Enviar Artigos",
"Add Article" => "Adicionar um artigo",
"Send objects to this site" => "Enviar objetos para este site",
// "Ex: http://tiki.org or localhost" => "Ex: http://tiki.org or localhost",
// "Use /commxmlrpc.php if your Tiki site is installed at the root, otherwise adapt /tiki to your need" => "Use /commxmlrpc.php if your Tiki site is installed at the root, otherwise adapt /tiki to your need",
// "Report this page" => "Report this page",
// "Page shared" => "Page shared",
// "The link was sent via e-Mail to the following addresses" => "The link was sent via e-Mail to the following addresses",
// "The link was sent via Twitter" => "The link was sent via Twitter",
// "The link was posted on your Facebook wall" => "The link was posted on your Facebook wall",
// "The link was sent as message to" => "The link was sent as message to",
// "The link was published in a" => "The link was published in a",
// "Short link" => "Short link",
// "Have a look at this page" => "Have a look at this page",
// "Your message" => "Your message",
"I found an interesting page that I thought you would like." => "Encontrei esta página, imagino que seja do seu interesse.",
// "e-Mail" => "e-Mail",
// "Send via e-Mail" => "Send via e-Mail",
// "Recipient(s)" => "Recipient(s)",
// "Separate multiple email addresses with a comma and a space" => "Separate multiple email addresses with a comma and a space",
"Separate multiple email addresses with a comma." => "Para enviar para mais de um destinatário separe os endereços com vírgula.",
"Your name" => "Seu nome",
// "Tweet via Twitter" => "Tweet via Twitter",
// "Authorize with Twitter first" => "Authorize with Twitter first",
// "Have a look at " => "Have a look at ",
// "Put on my Facebook wall" => "Put on my Facebook wall",
// "Authorize with Facebook first" => "Authorize with Facebook first",
// "Link text" => "Link text",
// "This will be the title for the URL" => "This will be the title for the URL",
// "Like this post" => "Like this post",
// "Subscribe notification" => "Subscribe notification",
// "How much time recipients can access to this page" => "How much time recipients can access to this page",
"time" => "hora",
// "You do not have the permission to send messages or you did not allow other users to send you messages" => "You do not have the permission to send messages or you did not allow other users to send you messages",
// "Separate multiple recipients with a semicolon" => "Separate multiple recipients with a semicolon",
// "Post on forum" => "Post on forum",
// "There is no forum where you can post a message" => "There is no forum where you can post a message",
// "password-protected" => "password-protected",
// "Share access rights" => "Share access rights",
// "Return to previous page" => "Return to previous page",
"Create a sheet" => "Criar uma planilha",
// "Configure this sheet" => "Configure this sheet",
"There are individual permissions set for this sheet" => "Existem permissões individuais definidas para essa planilha",
"Class Name" => "Nome da classe",
"Header Rows" => "Linhas do topo",
"Footer Rows" => "Linhas de baixo",
// "Wiki Parse Values" => "Wiki Parse Values",
// "Parent Spreadsheet" => "Parent Spreadsheet",
// "Makes this sheet a \"child\" sheet of a multi-sheet set" => "Makes this sheet a \"child\" sheet of a multi-sheet set",
"You can access the sheet using the following URL" => "Você pode acessar a planilha através do endereço",
// "Banned Words" => "Banned Words",
"Change shoutbox general settings" => "Alterar configurações gerais do quadro negro",
"auto-link urls" => "auto-link urls",
"Post or edit a message" => "Enviar ou editar uma mensagem",
"Location : " => "Localização : ",
// "Content may be out of date" => "Content may be out of date",
// "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages" => "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages",
// "page: %0/%1" => "page: %0/%1",
// "This text was automatically translated by Google Translate from the following page: " => "This text was automatically translated by Google Translate from the following page: ",
"Last edited by" => "Último edição por",
"based on work by" => "baseado no trabalho de",
"Contributors to this page" => "Contribuíram para esta página",
// "First Slide" => "First Slide",
// "Previous Slide" => "Previous Slide",
// "Previous Point" => "Previous Point",
// "Next Point" => "Next Point",
// "Next Slide" => "Next Slide",
// "Last Slide" => "Last Slide",
// "Jump To Slide" => "Jump To Slide",
// "Play" => "Play",
// "Pause" => "Pause",
// "Toggle Loop" => "Toggle Loop",
// "Export to PDF" => "Export to PDF",
// "Exit" => "Exit",
// "Change Theme" => "Change Theme",
// "To use Twitter integration, the site admin must register this site as an application at <a href=\"http://twitter.com/oauth_clients/\" target=\"_blank\">http://twitter.com/oauth_clients/</a> and allow write access for the application" => "To use Twitter integration, the site admin must register this site as an application at <a href=\"http://twitter.com/oauth_clients/\" target=\"_blank\">http://twitter.com/oauth_clients/</a> and allow write access for the application",
// "Twitter authorisation" => "Twitter authorisation",
// "to manage your authorisations at Twitter" => "to manage your authorisations at Twitter",
// "this site with twitter.com to use Twitter integration of this site" => "this site with twitter.com to use Twitter integration of this site",
// "To use Facebook integration, the site admin must register this site as an application at <a href=\"http://developers.facebook.com/setup/\" target=\"_blank\">http://developers.facebook.com/setup/</a> first" => "To use Facebook integration, the site admin must register this site as an application at <a href=\"http://developers.facebook.com/setup/\" target=\"_blank\">http://developers.facebook.com/setup/</a> first",
// "Facebook authorisation" => "Facebook authorisation",
// "to manage your authorisations at Facebook" => "to manage your authorisations at Facebook",
// "this site with facebook.com to use Facebook integration of this site" => "this site with facebook.com to use Facebook integration of this site",
// "The site admin has set up a global account which will be used for this site" => "The site admin has set up a global account which will be used for this site",
"Save changes" => "Salvar mudanças",
// "You will be redirected to the home page shortly" => "You will be redirected to the home page shortly",
// "to go to the home page immediately" => "to go to the home page immediately",
// "Please provide local account information" => "Please provide local account information",
// "Do you already have a local account for this site? Login to link to it using the following form instead" => "Do you already have a local account for this site? Login to link to it using the following form instead",
// "Link to Existing Account" => "Link to Existing Account",
// "You will not see the latest queries" => "You will not see the latest queries",
// "Params" => "Params",
"Most viewed objects" => "Objetos mais vistos",
"Most viewed objects in the last 7 days" => "Objetos mais vistos nos últimos 7 dias",
"Site Stats" => "Estatísticas do Site",
// "Date of first pageview" => "Date of first pageview",
// "Days since first pageview" => "Days since first pageview",
"Total pageviews" => "Total de visualizações de páginas",
"Average pageviews per day" => "Média de visualizações de páginas diárias",
"Wiki Stats" => "Estatísticas Wiki",
"Size of Wiki Pages" => "Tamanho das Páginas Wiki",
"Average page length" => "Tamanho médio das páginas",
"Average versions per page" => "Média de versões por página",
"Visits to wiki pages" => "Visitas a páginas Wiki",
"Average links per page" => "Média de links por página",
"Image galleries Stats" => "Estatísticas de galerias de imagens",
"Average images per gallery" => "Número médio de imagens por galeria",
"Total size of images" => "Tamanho total das imagens",
"Average image size" => "Tamanho médio das imagens",
"Visits to image galleries" => "Visitas as galerias de imagens",
"File galleries Stats" => "Estatísticas das galerias de arquivos",
"Average files per gallery" => "Número médio de arquivos por galeria",
"Total size of files" => "Tamanho total dos arquivos",
"Average file size" => "Tamanho médio dos arquivos",
"Visits to file galleries" => "Visitas as galerias de arquivos",
// "Articles Stats" => "Articles Stats",
"Total reads" => "Total de leituras",
"Average reads per article" => "Média de leituras por artigos",
"Total articles size" => "Tamanho total dos artigos",
"Average article size" => "Tamanho médio dos artigos",
"Forum Stats" => "Estatísticas dos fóruns",
"Total topics" => "Total de assuntos",
"Average topics per forums" => "Média de assuntos por fórum",
// "Total replies" => "Total replies",
// "Average number of replies per topic" => "Average number of replies per topic",
"Visits to forums" => "Visitas aos fóruns",
"Blog Stats" => "Estatísticas de Blogs",
"Weblogs" => "Weblogs",
"Total posts" => "Total de mensagens",
"Average posts per weblog" => "Média de mensagens por weblog",
"Total size of blog posts" => "Tamanho total das mensagens de blogs",
"Average posts size" => "Tamanho médio das mensagens",
"Visits to weblogs" => "Visitas aos weblogs",
"Poll Stats" => "Estatísticas das enquetes",
"Total votes" => "Total de votos",
"Average votes per poll" => "Média de votos por enquete",
// "FAQ Stats" => "FAQ Stats",
"Total questions" => "Total de perguntas",
"Average questions per FAQ" => "Média de perguntas por FAQ",
"User Stats" => "Estatísticas de usuários",
"Average bookmarks per user" => "Média de bookmarks por usuário",
"Average questions per quiz" => "Média de perguntas por teste",
"Quizzes taken" => "Testes realizados",
"Average quiz score" => "Nota média nos testes",
"Average time per quiz" => "Tempo médio por teste",
// "Most viewed objects in period" => "Most viewed objects in period",
// "{\$best_objects_stats_between[i]->type}" => "{\$best_objects_stats_between[i]->type}",
// "{\$best_objects_stats_lastweek[i]->type}" => "{\$best_objects_stats_lastweek[i]->type}",
"Usage chart" => "Gráfico de uso",
"Usage chart image" => "Imagem do gráfico de uso",
"Daily Usage" => "Uso diário",
"Stats for surveys" => "Estatísticas de pesquisas",
"Last taken" => "Última realização em",
"Stats for survey" => "Estatísticas para a pesquisa",
// "Tiki Logs" => "Tiki Logs",
// "Export through Action Log" => "Export through Action Log",
// "Clean logs older than" => "Clean logs older than",
"Time Left" => "Tempo restante",
"Send Answers" => "Enviar as respostas",
"Thank you for your submission" => "Obrigado por enviar",
"Send a link to a friend" => "Enviar link para um amigo",
"Your email was sent" => "Seu email foi enviado",
"The link was sent to the following addresses:" => "Link enviado para os seguintes endereços:",
"Friend's email" => "Destinatário",
// "TikiTests Edit" => "TikiTests Edit",
// "Summary mode" => "Summary mode",
// "Show Page Differences" => "Show Page Differences",
// "Show Tidy Errors and Warnings" => "Show Tidy Errors and Warnings",
// "Show POST Data" => "Show POST Data",
// "Use Current Session/Log out" => "Use Current Session/Log out",
// "Recorded Links" => "Recorded Links",
// "Element to compare (Xpath expression)" => "Element to compare (Xpath expression)",
// "Test Xpath Expression" => "Test Xpath Expression",
// "Post Variables" => "Post Variables",
// "Tidy Results" => "Tidy Results",
"Delete this link" => "Deletar este link",
// "TikiTests List" => "TikiTests List",
// "Config" => "Config",
// "Replay" => "Replay",
// "Tidy extension not present" => "Tidy extension not present",
// "PECL HTTP extension present" => "PECL HTTP extension present",
// "cURL extension present" => "cURL extension present",
// "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible" => "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible",
// "List TikiTests" => "List TikiTests",
// "Create a TikiTest" => "Create a TikiTest",
// "Replay the TikiTest" => "Replay the TikiTest",
// "Edit the TikiTest" => "Edit the TikiTest",
// "TikiTests Record Configuration" => "TikiTests Record Configuration",
// "Start Recording Test" => "Start Recording Test",
// "TikiTests Replay Configuration" => "TikiTests Replay Configuration",
// "Failure" => "Failure",
// "Reference" => "Reference",
// "The pages are different" => "The pages are different",
// "The pages are identical" => "The pages are identical",
// "Recording to pause press the pause button" => "Recording to pause press the pause button",
// "Pause the recording" => "Pause the recording",
// "Paused to resume press the play button" => "Paused to resume press the play button",
// "Resume the recording" => "Resume the recording",
// "Stop the recording" => "Stop the recording",
// "Theme Control Center: Categories" => "Theme Control Center: Categories",
"Theme is selected as follows" => "Um tema é selecionado da seguinte forma",
"If a theme is assigned to the individual object that theme is used." => "Se um tema for atribuído a um objeto individual o tema é utilizado",
"If not then if a theme is assigned to the object's category that theme is used" => "Senão, então se um tema for atribuído à categoria do objeto o tema é utilizado",
"If not then a theme for the section is used" => "Senão, um tema para a seção é utilizado",
"If none of the above was selected the user theme is used" => "Se nenhum dos itens acima for selecionado, o tema do usuário é utilizado",
"Finally if the user didn't select a theme the default theme is used" => "Finalmente, se o usuário não selecionou um tema o tema padrão é utilizado",
"Control by Objects" => "Controlado por objetos",
"Control by Sections" => "Controlar por seções",
"Assign themes to categories" => "Atribuir temas a categorias",
"Assigned categories" => "Categorias atribuídas",
"Theme Control Center: Objects" => "Centro de Controle de Temas: Objetos",
"Control by Categories" => "Controle por Categorias",
"Assign themes to objects" => "Atribuir temas a objetos",
"Assigned objects" => "Objetos atribuídos",
// "Theme Control Center: Sections" => "Theme Control Center: Sections",
"Assign themes to sections" => "Atribuir temas a seções",
"Assigned sections" => "Seções atribuídas",
// "Apply the following profile for enhancements: " => "Apply the following profile for enhancements: ",
// "Time Tracker" => "Time Tracker",
// "Local Cache (Not Committed)" => "Local Cache (Not Committed)",
// "Saved (Committed)" => "Saved (Committed)",
"New task" => "Nova tarefa",
// "Toggle completed" => "Toggle completed",
// "Toggle archived" => "Toggle archived",
// "Task name" => "Task name",
// "Estimate (in min.)" => "Estimate (in min.)",
// "Estimate" => "Estimate",
// "Task is completed" => "Task is completed",
// "Task is archived" => "Task is archived",
// "Created at" => "Created at",
// "Are you sure you want to delete all tasks" => "Are you sure you want to delete all tasks",
// "Commit Time Sheet Items" => "Commit Time Sheet Items",
// "View All" => "View All",
// "View My Items" => "View My Items",
"Summary" => "Sumário",
// "Time Spent" => "Time Spent",
// "Done By" => "Done By",
// "Add Tracker" => "Add Tracker",
// "Add Tracker To Tracker Report" => "Add Tracker To Tracker Report",
// "View Tracker Report" => "View Tracker Report",
// "Pick tracker to join" => "Pick tracker to join",
// "Pick fields to join on" => "Pick fields to join on",
// "Join inner" => "Join inner",
// "Join outer" => "Join outer",
// "Tracker - Open" => "Tracker - Open",
// "Tracker - Pending" => "Tracker - Pending",
// "Tracker - Closed" => "Tracker - Closed",
// "Tracker Item History" => "Tracker Item History",
// "View Tracker Item" => "View Tracker Item",
// "Not logging" => "Not logging",
// "Tracker changes are not being logged: Go to <a href=\"tiki-admin_actionlog.php?action_log_type=trackeritem&cookietab=2\" >Action log admin</a> to enable" => "Tracker changes are not being logged: Go to <a href=\"tiki-admin_actionlog.php?action_log_type=trackeritem&cookietab=2\" >Action log admin</a> to enable",
// "Old" => "Old",
"Edit File:" => "Editar arquivo:",
"Advanced mode" => "Modo avançado",
"Simple mode" => "Modo simples",
// "Retry" => "Retry",
"The following file was successfully uploaded" => "O seguinte arquivo foi carregado com sucesso",
// "The following files have been successfully uploaded" => "The following files have been successfully uploaded",
"You can download this file using" => "Você pode baixar este arquivo usando",
"You can link to the file from a Wiki page using" => "Você pode criar um link numa página wiki para o arquivo usando",
"You can display an image in a Wiki page using" => "Você pode exibir uma imagem numa página wiki usando",
// "Or using as a thumbnail with ShadowBox" => "Or using as a thumbnail with ShadowBox",
"You can link to the file from an HTML page using" => "Você pode criar um link numa página HTML usando",
// "You locked the file" => "You locked the file",
// "The file is locked by {\$fileInfo.lockedby}" => "The file is locked by {\$fileInfo.lockedby}",
"File title" => "Nome do arquivo",
"required field for podcasts" => "campo obrigatório para podcast",
"File description" => "Descrição do arquivo",
// "We're sorry" => "We're sorry",
// "Upload interface could not load.  You must have JavaScript enabled to enjoy Upload interface" => "Upload interface could not load.  You must have JavaScript enabled to enjoy Upload interface",
// "Upload interface is loading" => "Upload interface is loading",
// "Please wait a moment.." => "Please wait a moment..",
// "Upload interface is taking a long time to load or the load has failed" => "Upload interface is taking a long time to load or the load has failed",
// "Please make sure that the Flash Plugin is enabled and that a working version of the Adobe Flash Player is installed" => "Please make sure that the Flash Plugin is enabled and that a working version of the Adobe Flash Player is installed",
// "We are sorry: Upload interface could not load.  You may need to install or upgrade Flash Player" => "We are sorry: Upload interface could not load.  You may need to install or upgrade Flash Player",
// "Visit the Adobe Website to get the Flash Player" => "Visit the Adobe Website to get the Flash Player",
"Unzip zip files" => "Descompactar zip",
// "File can be deleted after" => "File can be deleted after",
// "Root" => "Root",
// "Creator of file, if different from the 'Uploaded by' user" => "Creator of file, if different from the 'Uploaded by' user",
"Maximum number of downloads" => "Número máximo de downloads",
// "-1 for no limit" => "-1 for no limit",
"Upload File(s)" => "Carregar arquivo(s)",
"Cancel Upload" => "Cancelar envio de arquivos",
"Add Another File" => "Adicionar outro arquivo",
"Maximum file size is around" => "Tamanho limite para cada arquivo é de aproximadamente",
"Uploading file.." => "Enviando arquivo..",
"No File to Upload.." => "Nenhum arquivo para enviar..",
" Syntax tips" => " Dicas de sintaxe",
"Link to file from a Wiki page" => "Criar link para o arquivo numa página wiki",
"In addition, for image files" => "Para imagens você também pode usar",
"To display full size in a Wiki page" => "Para exibir a imagem em tamanho real",
"Display thumbnail that enlarges" => "Para exibir uma miniatura com link para a imagem original",
"Upload successful!" => "Carga bem-sucedida!",
"The following image was successfully uploaded" => "A seguinte imagem foi carregada com sucesso",
"Image ID thumb" => "ID da miniatura da imagem",
"You can view this image in your browser using" => "Você pode visualizar esta imagem em seu navegador usando",
"You can include the image in an Wiki page using" => "Você pode incluir a imagem em uma página Wiki usando",
"or use filename" => "ou use o nome do arquivo",
"Now enter the image URL" => "Agora digite o endereço para a imagem",
"or upload a local image from your disk" => "ou carregue uma imagem local do seu disco",
"Batch Upload" => "Carga em lote",
"Thumbnail (optional, overrides automatic thumbnail generation)" => "Miniatura (opcional, sobrescreve a miniatura automaticamente gerada)",
"No gallery available." => "Nenhuma galeria.",
"You have to create a gallery first!" => "Você precisa criar uma galeria antes de prosseguir!",
"User assigned modules" => "Módulos atribuídos pelo usuário",
"Restore defaults" => "Restaurar padrões",
"The column is disabled" => "A coluna não está habilitada",
"#" => "#",
"act" => "atv",
"Move to Right Column" => "Mover para a coluna direita",
"Move to Left Column" => "Mover para a coluna esquerda",
"Assign module" => "Definir módulo",
"top" => "topo",
"Current folder" => "Pasta atual",
"Folders" => "Pastas",
"Folder in" => "Pasta em",
"Remove Folder" => "Remover pasta",
"Refresh Cache" => "Atualizar cache",
"Admin folders and bookmarks" => "Administrar pastas e favoritos",
"a folder" => "uma pasta",
// "a bookmark" => "a bookmark",
// "User Contacts Preferences" => "User Contacts Preferences",
// "Manage Fields" => "Manage Fields",
// "{\$ext.fieldname|escape}" => "{\$ext.fieldname|escape}",
// "{if \$escape_menu_labels}{\$chdata.name|escape}{else}{\$chdata.name}{/if}" => "{if \$escape_menu_labels}{\$chdata.name|escape}{else}{\$chdata.name}{/if}",
"Send me a message" => "Envie-me uma mensagem",
"Basic Data" => "Informação básica",
"Assign Group" => "Designar Grupo",
"Change user preferences" => "Alterar preferências do usuário",
// "User Icon" => "User Icon",
// "{\$gender}" => "{\$gender}",
"(non public)" => "(não público)",
// "{\$country|stringfix}" => "{\$country|stringfix}",
// "User's homepage" => "User's homepage",
"Personal Wiki Page" => "Página Wiki Pessoal",
"This user is your friend " => "Esse usuário é seu amigo ",
// "The user requested friendship with you" => "The user requested friendship with you",
"Accept friendship from this user" => "Aceitar pedido de amizade desse usuário",
// "Refuse friendship from this user" => "Refuse friendship from this user",
// "Currently waiting for user approval" => "Currently waiting for user approval",
// "Cancel friendship request towards this user" => "Cancel friendship request towards this user",
"Request friendship from this user" => "Solicitação de amizade desse usuário",
// "Additional Information" => "Additional Information",
// "Change user information" => "Change user information",
// "User Contribution" => "User Contribution",
// "has contributed to the following content" => "has contributed to the following content",
// "has not contributed to any content yet" => "has not contributed to any content yet",
// "Forum comments" => "Forum comments",
// "Who Looks At Stuff" => "Who Looks At Stuff",
// "Who Looks At Your Stuff" => "Who Looks At Your Stuff",
// "Who Looks At His Stuff" => "Who Looks At His Stuff",
// "Send Me A Message" => "Send Me A Message",
// "Send me a message " => "Send me a message ",
// "The following message will be sent to user" => "The following message will be sent to user",
// "Message Body" => "Message Body",
// "Toggle" => "Toggle",
"Toggle options" => "Mudar opções",
"Personal Information" => "Informação pessoal",
"Male" => "Masculino",
"Female" => "Feminino",
"Hidden" => "Secreto",
// "{\$flags[ix]|stringfix}" => "{\$flags[ix]|stringfix}",
"Your personal Wiki Page" => "Sua página Wiki pessoal",
// "User's personal tracker information" => "User's personal tracker information",
"View extra information" => "Visualizar informação extra",
"Your personal tracker information" => "Informações do seu formulário pessoal",
"Is email public? (uses scrambling to prevent spam)" => "Endereço de email público? (utilizar ofuscação para evitar spam)",
"Unavailable - please set your e-mail below" => "Não disponível - por favor defina seu e-mail abaixo",
"Does your mail reader need a special charset" => "Seu cliente de e-mail precisa de codificação específica",
// "Preferred language" => "Preferred language",
// "Can you read more languages" => "Can you read more languages",
// "Other languages you can read (select on the left to add to the list on the right)" => "Other languages you can read (select on the left to add to the list on the right)",
"Select language..." => "Selecione o idioma...",
// "Detect user time zone if browser allows, otherwise site default" => "Detect user time zone if browser allows, otherwise site default",
// "Use 12-hour clock in time selectors" => "Use 12-hour clock in time selectors",
// "Display info tooltip on mouseover for every user who allows his/her information to be public" => "Display info tooltip on mouseover for every user who allows his/her information to be public",
"Notify sender when reading his mail" => "Notificar o autor quando ler o e-mail dele",
"Auto-archive read messages after x days" => "Arquivar automaticamente mensagens lidas depois de x dias",
"never" => "nunca",
// "My user items" => "My user items",
// "My level" => "My level",
"Account Information" => "Conta",
"Leave \"New password\" and \"Confirm new password\" fields blank to keep current password" => "Deixe os campos \"Nova senha\" e \"Confirmar nova senha\" em branco para manter a senha atual",
"Confirm new password" => "Confirmar nova senha",
"Current password (required)" => "Senha atual (obrigatório)",
"Account Deletion" => "Deletar conta",
// "Are you really sure you want to delete the account %0" => "Are you really sure you want to delete the account %0",
// "Check this box if you really want to delete the account" => "Check this box if you really want to delete the account",
// "Delete the account" => "Delete the account",
"Delete my account" => "Deletar minha conta",
"Task list" => "Lista de tarefas",
"Admin mode off" => "Administrar modo desligado",
"Admin mode on" => "Administrar modo ligado",
"Task help" => "Ajuda: Tarefas",
"Empty Trash" => "Limpar lixeira",
// "Task received" => "Task received",
// "You received this task" => "You received this task",
// "Task sent" => "Task sent",
// "You sent this task to another user" => "You sent this task to another user",
// "Task shared by a group" => "Task shared by a group",
// "Task is shared by a group" => "Task is shared by a group",
// "Accepted by task user and creator" => "Accepted by task user and creator",
// "Task has been accepted by user and creator" => "Task has been accepted by user and creator",
// "Rejected by a user" => "Rejected by a user",
// "Task has been rejected by a user" => "Task has been rejected by a user",
// "Waiting for me" => "Waiting for me",
// "Task has not yet been accepted or rejected by you" => "Task has not yet been accepted or rejected by you",
// "Waiting for other user" => "Waiting for other user",
// "Task has not yet been accepted or rejected by another user" => "Task has not yet been accepted or rejected by another user",
"Admin Mode" => "Modo de administração",
"Edit Task" => "Editar tarefa",
"NOT accept" => "Não aceito",
"Remove from Trash" => "Remover da lixeira",
// "Move to trash" => "Move to trash",
// "Move to Trash" => "Move to Trash",
"Task saved" => "Tarefas salvas",
"View Task" => "Visualizar tarefa",
"Open a new task" => "Abrir nova tarefa",
"taskId" => "ID da tarefa",
"Task user" => "Usuário da tarefa",
"Only the creator can delete this task" => "Apenas o proprietário pode deletar a tarefa",
"Use start date and time" => "Data e hora do início",
"Use end date and time" => "Data e hora do término",
"Open / In Process" => "Em andamento",
"Waiting / Not Started" => "Esperando para começar",
"Percentage completed" => "Porcentagem de realização",
"Shared for Group" => "Compartilhado para o grupo",
"Accepted by User" => "Aceito pelo usuário",
"No / Rejected" => "Não / rejeitado",
"Accepted by Creator" => "Aceito pelo proprietário",
"This message will be send to users if you are makeing changes of assigned tasks" => "Essa mensagem vai ser enviada para os usuários se você esta fazendo mudanças em tarefas associadas",
"Send message with changes" => "Enviar mensagens com as mudanças",
"Modified by" => "Modificado por",
"Marked as deleted" => "Marcar como deletado",
"Inform task user by email" => "Informar usuário da tarefa por e-mail",
"You can only view this task" => "Você pode apenas visualizar essa tarefa",
"Completed" => "Realizada",
// "In the trash" => "In the trash",
"Not Accepted by One User" => "Não aceito por um usuário",
"Not Accepted User" => "Usuário não aceito",
"No tasks entered" => "Nenhuma tarefa cadastrada",
"Select One" => "Selecionar um",
"Undo Trash" => "Limpar lixeira",
"Show:" => "Mostrar:",
"Received" => "Recebido",
"Submitted" => "Enviado",
"Shared" => "Compartilhado",
"All Shared Tasks" => "Todas as tarefas compartilhadas",
"completed (100%)" => "completa (100%)",
"Public for group" => "Público para o grupo",
"User Watches and preferences" => "Itens monitorados e preferências do usuário",
"You need to set your email to receive email notifications" => "Você precisa definir seu e-mail para receber notificações através dele",
// "Report Preferences" => "Report Preferences",
// "You are not allowed to remove this notification " => "You are not allowed to remove this notification ",
// "Use reports to summarise notifications about objects you are watching" => "Use reports to summarise notifications about objects you are watching",
// "Use reports" => "Use reports",
// "Interval in which you want to get the reports" => "Interval in which you want to get the reports",
"Monthly" => "Mensalmente",
// "Short report" => "Short report",
// "Detailed report" => "Detailed report",
// "HTML-Email" => "HTML-Email",
// "Send me an email also if nothing happened" => "Send me an email also if nothing happened",
// "My watches" => "My watches",
// "Use \"watches\" to monitor wiki pages or other objects" => "Use \"watches\" to monitor wiki pages or other objects",
// "Watch new items by clicking the {icon _id=eye} button on specific pages" => "Watch new items by clicking the {icon _id=eye} button on specific pages",
"Add Watch" => "Adicionar notificação",
// "Select event type" => "Select event type",
// "All watched events" => "All watched events",
"A user submits a blog post" => "Um usuário enviou uma mensagem no blog",
"A user posts a forum thread" => "Um usuário criou um novo assunto no fórum",
"A user posts a forum topic" => "Um usuário enviou um novo tópico no fórum",
// "A user edited or commented on a wiki page" => "A user edited or commented on a wiki page",
"A user edited a wiki page" => "Um usuário editou uma página wiki",
// "{\$w.type}" => "{\$w.type}",
// "Used space" => "Used space",
// "up to" => "up to",
// "no limit for admin" => "no limit for admin",
"May need to refresh twice to see changes" => "Pode ser necessário atualizar duas vezes para ver as alterações",
"Add top level bookmarks to menu" => "Adicionar bookmarks de nível superior ao menu",
"Add or edit an item" => "Adicionar ou editar um item",
"New Window" => "Nova janela",
"replace window" => "substituir a janela",
"Pos" => "Pos",
"User_versions_for" => "Versões_de_usuário_para",
// "{\$topic|escape}" => "{\$topic|escape}",
// "{\$type|escape}" => "{\$type|escape}",
// "Monitor Articles" => "Monitor Articles",
// "Stop Monitoring Articles" => "Stop Monitoring Articles",
// "Published At" => "Published At",
// "{\$listpages[ix].topicName}" => "{\$listpages[ix].topicName}",
"No articles yet" => "Sem nenhum artigo",
"Add an article" => "Clique aqui para adicionar um artigo",
"Banner stats" => "Estatísticas de Banner",
"Create new banner" => "Criar um novo banner",
"Banner Information" => "Informação do Banner",
"Click ratio" => "Taxa de cliques",
"Weekdays" => "Dias da semana",
"mon" => "seg",
"tue" => "ter",
"wed" => "qua",
"thu" => "qui",
"fri" => "sex",
"sat" => "sáb",
"sun" => "dom",
"Banner raw data" => "Dados brutos do Banner",
"Monitor this Blog" => "Monitorar este blog",
"Stop Monitoring this Blog" => "Não monitorar mais este blog",
"Cached" => "Em cache",
"This is a cached version of the page." => "Esta é uma versão em cache da página.",
"Click here to view the Google cache of the page instead." => "Clique aqui para ver, ao invés, o cache do Google.",
// "{\$faq_info.title}" => "{\$faq_info.title}",
// "There are no questions in this FAQ" => "There are no questions in this FAQ",
"Answers" => "Repostas",
"Add Suggestion" => "Adicionar sugestão",
"Forum List" => "Lista de Fóruns",
"Edit Forum" => "Editar Fórum",
"Manage Message Queue" => "Mensagens pendentes",
// "Manage Reported Messages" => "Manage Reported Messages",
// "Monitor Topics of this Forum" => "Monitor Topics of this Forum",
// "Stop Monitoring Topics of this Forum" => "Stop Monitoring Topics of this Forum",
// "Monitor Topics and Threads of this Forum" => "Monitor Topics and Threads of this Forum",
// "Stop Monitoring Topics and Threads of this Forum" => "Stop Monitoring Topics and Threads of this Forum",
// "Group Monitor Topics of this Forum" => "Group Monitor Topics of this Forum",
// "Group Monitor Topics and Threads of this Forum" => "Group Monitor Topics and Threads of this Forum",
"Post New" => "Nova mensagem",
// "Watch for replies" => "Watch for replies",
"Send me an e-mail when someone replies to my topic" => "Envie-me um e-mail quando alguém responder ao meu tópico",
"Don't send me any e-mails" => "Não me envie nenhum e-mail",
"Enter your name" => "Digite seu nome",
"Editing posts" => "Ao editar mensagens",
"for links" => "para links",
"HTML tags are not allowed inside posts" => "Tags HTML não são permitidos dentro de mensagens",
"Moderator Actions" => "Ações de moderador",
"Move Selected Topics" => "Mover os tópicos selecionados",
"Unlock Selected Topics" => "Destravar os tópicos selecionados",
"Lock Selected Topics" => "Travar os tópicos selecionados",
"Delete Selected Topics" => "Apagar os tópicos selecionados",
"Merge" => "Unir",
"Merge Selected Topics" => "Unir os tópicos selecionados",
"Reported Messages:" => "Mensagens enviadas:",
"Queued Messages:" => "Mensagens pendentes:",
"Merge into topic" => "Unir no tópico",
"Emot" => "Emot",
"pts" => "pts",
// "Atts" => "Atts",
// "Forum Lock" => "Forum Lock",
// "posts in this forum" => "posts in this forum",
// "Filter Posts" => "Filter Posts",
"Jump to forum" => "Ir ao fórum",
// "Posts Filtering" => "Posts Filtering",
// "Last post date" => "Last post date",
"All posts" => "Todas as mensagens",
"Last hour" => "Última hora",
"Last 24 hours" => "Últimas 24 horas",
"Last 48 hours" => "Últimas 48 horas",
// "Show archived posts" => "Show archived posts",
// "Containing posts by" => "Containing posts by",
// "Me" => "Me",
"normal" => "normal",
"announce" => "anúncio",
"hot" => "quente",
// "Posts with no replies" => "Posts with no replies",
// "Archived" => "Archived",
// "Topic List" => "Topic List",
"The post has been reported and will be reviewed by a moderator." => "Um moderador será avisado para revisar a mensagem.",
"prev topic" => "tópico anterior",
"next topic" => "próximo tópico",
// "You are viewing a reply to" => "You are viewing a reply to",
"Print this page only" => "Imprimir apenas esta página",
"Print all pages" => "Imprimir todas as páginas",
"Show posts" => "Exibir mensagens",
// "View Invoice" => "View Invoice",
// "Invoice %0" => "Invoice %0",
// "Date Issued %0" => "Date Issued %0",
// "Amount: %0" => "Amount: %0",
// "Total: %0" => "Total: %0",
// "Payment Terms: %0" => "Payment Terms: %0",
// "Back to Page" => "Back to Page",
// "Already being edited by" => "Already being edited by",
"Tiki Sheet" => "Planilha Tiki",
// "Save current spreadsheet" => "Save current spreadsheet",
// "Cancel editing current spreadsheet" => "Cancel editing current spreadsheet",
// "No parse" => "No parse",
// "What would you like to add" => "What would you like to add",
// "New spreadsheet" => "New spreadsheet",
// "Existing spreadsheet" => "Existing spreadsheet",
// "Tracker as a spreadsheet" => "Tracker as a spreadsheet",
// "Spreadsheet from file gallery" => "Spreadsheet from file gallery",
// "Cell" => "Cell",
// "Set Reference" => "Set Reference",
// "Un-Merge" => "Un-Merge",
// "Adds an additional row to bottom of the spreadsheet" => "Adds an additional row to bottom of the spreadsheet",
// "Add Row" => "Add Row",
// "Adds an additional rows to bottom of the spreadsheet" => "Adds an additional rows to bottom of the spreadsheet",
// "Add Multi-Rows" => "Add Multi-Rows",
// "Delets the current row thats highlighted" => "Delets the current row thats highlighted",
// "Delete Row" => "Delete Row",
// "Inserts an additional row after currently selected row" => "Inserts an additional row after currently selected row",
// "Insert Row Before" => "Insert Row Before",
// "Insert Row After" => "Insert Row After",
// "Unhides all the hidden rows" => "Unhides all the hidden rows",
"Show All" => "Mostrar Tudo",
// "Hides or shows the currently selected row" => "Hides or shows the currently selected row",
// "Toggle Hide Row" => "Toggle Hide Row",
// "Adds an additional column to the right of the spreadsheet" => "Adds an additional column to the right of the spreadsheet",
// "Add Column" => "Add Column",
// "Adds an additional columns to the right of the spreadsheet" => "Adds an additional columns to the right of the spreadsheet",
// "Add Multi-Columns" => "Add Multi-Columns",
// "Deletes the current column thats highlighted" => "Deletes the current column thats highlighted",
// "Delete Column" => "Delete Column",
// "Inserts an additional column after currently selected column" => "Inserts an additional column after currently selected column",
// "Insert Column Before" => "Insert Column Before",
// "Insert Column After" => "Insert Column After",
// "Fill down current cell value" => "Fill down current cell value",
// "Fill Down" => "Fill Down",
// "Fill up current cell value" => "Fill up current cell value",
// "Fill Up" => "Fill Up",
// "Unhides all the hidden columns" => "Unhides all the hidden columns",
// "Hides or shows the currently selected column" => "Hides or shows the currently selected column",
// "Toggle Hide Column" => "Toggle Hide Column",
// "Add new spreadsheet" => "Add new spreadsheet",
// "Add Spreadsheet" => "Add Spreadsheet",
// "Delete the current spreadsheet" => "Delete the current spreadsheet",
// "Delete Spreadsheet" => "Delete Spreadsheet",
// "Recompiles the current sheet" => "Recompiles the current sheet",
// "Change the title of the sheet" => "Change the title of the sheet",
// "Wrap Cell Range" => "Wrap Cell Range",
// "Wrap with SUM" => "Wrap with SUM",
// "Wrap with CEILING" => "Wrap with CEILING",
// "Wrap with COUNT" => "Wrap with COUNT",
// "Wrap with MAX" => "Wrap with MAX",
// "Wrap with MIN" => "Wrap with MIN",
// "Redo" => "Redo",
// "Toggle State" => "Toggle State",
// "Function Reference" => "Function Reference",
// "Usage Example: =SUM(SUM(A1:B1) + SUM(D7))" => "Usage Example: =SUM(SUM(A1:B1) + SUM(D7))",
// "=(TRUE(N(A1)) || FALSE(N(B1)))" => "=(TRUE(N(A1)) || FALSE(N(B1)))",
// "Returns the absolute value of a number" => "Returns the absolute value of a number",
// "Returns a rounded number" => "Returns a rounded number",
// "Returns a number rounded up based on a multiple of significance" => "Returns a number rounded up based on a multiple of significance",
// "Counts the number of cells that contain a value" => "Counts the number of cells that contain a value",
// "Counts full days from a specific date - format(YYYY,MM,DD)" => "Counts full days from a specific date - format(YYYY,MM,DD)",
// "Converts a number to text, using a currency format - options(number, decimals, symbol)" => "Converts a number to text, using a currency format - options(number, decimals, symbol)",
// "Returns a logical value of FALSE" => "Returns a logical value of FALSE",
// "Returns a text representation of a number rounded to a specified number of decimal places - options(number, decimals, useCommas)" => "Returns a text representation of a number rounded to a specified number of decimal places - options(number, decimals, useCommas)",
// "Returns a number rounded down based on a multiple of significance" => "Returns a number rounded down based on a multiple of significance",
// "Returns the integer portion of a number" => "Returns the integer portion of a number",
// "Returns the largest value from the numbers provided" => "Returns the largest value from the numbers provided",
// "Returns the smallest value from the numbers provided" => "Returns the smallest value from the numbers provided",
// "Converts a value to a number" => "Converts a value to a number",
// "Gets full date of today" => "Gets full date of today",
// "Returns the mathematical constant called pi, which is 3.14159265358979" => "Returns the mathematical constant called pi, which is 3.14159265358979",
// "Returns the result of a number raised to a given power" => "Returns the result of a number raised to a given power",
// "Returns a random number that is greater than or equal to 0 and less than 1" => "Returns a random number that is greater than or equal to 0 and less than 1",
// "Returns a number rounded to a specified number of digits" => "Returns a number rounded to a specified number of digits",
// "Returns all of the values in each of the specified cells and added together" => "Returns all of the values in each of the specified cells and added together",
// "Returns a logical value of TRUE" => "Returns a logical value of TRUE",
// "Converts a text value that represents a number to a number" => "Converts a text value that represents a number to a number",
// "Italics" => "Italics",
// "Uppercase" => "Uppercase",
// "Capitalize" => "Capitalize",
// "Lowercase" => "Lowercase",
// "Font Size +" => "Font Size +",
// "Font Size -" => "Font Size -",
// "Items found" => "Items found",
"lastModif" => "ultimaModif",
"atts" => "atributos",
"List Attachments" => "Listar anexos",
// "View/Edit" => "View/Edit",
"Insert New Item" => "Inserir novo item",
"View inserted item" => "Visualizar itens inseridos",
"Insert new item" => "Inserir novo item",
// "Synchronization" => "Synchronization",
// "This tracker is a remote copy of <a href=\"%0\">%0</a>" => "This tracker is a remote copy of <a href=\"%0\">%0</a>",
// "It was last updated on %0" => "It was last updated on %0",
// "Reload field definitions" => "Reload field definitions",
// "Items added locally" => "Items added locally",
// "Push new items" => "Push new items",
// "Safe modifications (no remote conflict)" => "Safe modifications (no remote conflict)",
// "Dangerous modifications (remote conflict)" => "Dangerous modifications (remote conflict)",
// "On push, local items will be removed until data reload" => "On push, local items will be removed until data reload",
// "Push local changes" => "Push local changes",
// "Local changes will be lost" => "Local changes will be lost",
// "When reloading the data from the source, all local changes will be lost" => "When reloading the data from the source, all local changes will be lost",
// "New items that must be preserved should be pushed using the above controls" => "New items that must be preserved should be pushed using the above controls",
// "Modifications that must be preserved should be replicated" => "Modifications that must be preserved should be replicated",
// "Without conflicts: Using the above controls" => "Without conflicts: Using the above controls",
// "With conflicts: Manually on the source" => "With conflicts: Manually on the source",
// "Using the above controls will cause information loss" => "Using the above controls will cause information loss",
// "Reload data from source" => "Reload data from source",
"Local" => "Local",
// "Remote" => "Remote",
"View Item" => "Visualizar item",
// "Translations" => "Translations",
// "Move to another tracker" => "Move to another tracker",
// "Back to Items list" => "Back to Items list",
// "Back to Items List" => "Back to Items List",
"Special Operations" => "Operações especiais",
"close" => "fechar",
// "Open Tiki WebDAV (Wiki pages) as WebFolder" => "Open Tiki WebDAV (Wiki pages) as WebFolder",
// "Open Tiki WebDAV as WebFolder" => "Open Tiki WebDAV as WebFolder",
// "Personal e-mail accounts" => "Personal e-mail accounts",
// "This is the active account" => "This is the active account",
// "IMAP" => "IMAP",
// "Mbox" => "Mbox",
// "Maildir" => "Maildir",
// "POP3" => "POP3",
// "Group e-mail accounts" => "Group e-mail accounts",
// "Incoming servers (used in this order)" => "Incoming servers (used in this order)",
// "IMAP server" => "IMAP server",
// "Mbox filepath" => "Mbox filepath",
// "Maildir mail directory" => "Maildir mail directory",
"Use SSL" => "Usar SSL",
// "Outgoing server" => "Outgoing server",
// "From email" => "From email",
// "Uses current in preferences if empty" => "Uses current in preferences if empty",
// "No email set" => "No email set",
"Account details" => "Detalhes da conta",
// "Group (shared mail inbox) or private" => "Group (shared mail inbox) or private",
// "This will be a group mail account" => "This will be a group mail account",
// "This will be a personal mail account" => "This will be a personal mail account",
// "Auto-refresh page time" => "Auto-refresh page time",
// "seconds (0 = no auto refresh)" => "seconds (0 = no auto refresh)",
// "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission" => "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission",
// "Show Unread" => "Show Unread",
// "Show Flagged" => "Show Flagged",
// "Auto refresh set for every \$autoRefresh seconds" => "Auto refresh set for every \$autoRefresh seconds",
// "Refresh now" => "Refresh now",
// "Group messages" => "Group messages",
// "unFlagged" => "unFlagged",
"Clip" => "clip",
"Back To Mailbox" => "retornar à lista de mensagens",
"Full Headers" => "cabeçalhos completos",
"Normal Headers" => "cabeçalhos comuns",
"Reply To All" => "responder a todos",
"Forward" => "remeter",
// "Part" => "Part",
"Select from address book" => "selecionar da agenda de endereços",
"Use HTML mail" => "Usar email HTML",
"The following addresses are not in your address book" => "Os seguintes endereços não estão na sua agenda de endereços",
"Add Contacts" => "Adicionar contatos",
"Attachment 1" => "Anexo 1",
"Attachment 2" => "Anexo 2",
"Attachment 3" => "Anexo 3",
"Address book" => "Agenda de endereços",
// "TOC" => "TOC",
"Parent page" => "Página pai",
"Child" => "Criança",
"page id" => "id da página",
"View edit icons" => "Ver ícones de edição",
"3d browser" => "3",
"Page is NOT being monitored. Click icon to START monitoring." => "Página não monitorada. Clique para monitorar a página.",
"Page IS being monitored. Click icon to STOP monitoring." => "Página monitorada. Clique para não monitorar mais esta página.",
// "Group Monitor on Structure" => "Group Monitor on Structure",
// "Hide structure bar" => "Hide structure bar",
// "Hide structure" => "Hide structure",
// "More types available" => "More types available",
// "More field types may be enabled from the <a href=\"%0\">administration panel</a>" => "More field types may be enabled from the <a href=\"%0\">administration panel</a>",
// "Contact your administrator to see if they can be enabled. The complete field type list is available in the <a rel=\"external\" class=\"external\" href=\"%0\">documentation</a>" => "Contact your administrator to see if they can be enabled. The complete field type list is available in the <a rel=\"external\" class=\"external\" href=\"%0\">documentation</a>",
// "Description contains wiki syntax" => "Description contains wiki syntax",
// "Restrict visibility to administrators" => "Restrict visibility to administrators",
// "Useful if you are working on a live tracker" => "Useful if you are working on a live tracker",
// "Add Field &amp; Edit Advanced Options" => "Add Field &amp; Edit Advanced Options",
// "New tracker created" => "New tracker created",
// "Return to Trackers" => "Return to Trackers",
// "Options for %0" => "Options for %0",
// "Separate multiple with commas" => "Separate multiple with commas",
"Error Message" => "Mensagem de erro",
// "Visible by all" => "Visible by all",
// "Visible by administrators only" => "Visible by administrators only",
// "Editable by administrators only" => "Editable by administrators only",
// "Editable by administrators and creator only" => "Editable by administrators and creator only",
// "Creator requires a user field with auto-assign to creator (1)" => "Creator requires a user field with auto-assign to creator (1)",
// "Visible by" => "Visible by",
// "Editable by" => "Editable by",
// "Changing the permanent name may have consequences in integrated systems" => "Changing the permanent name may have consequences in integrated systems",
// "Quick Export" => "Quick Export",
// "Produce a CSV with basic formatting" => "Produce a CSV with basic formatting",
// "Export Tracker Items" => "Export Tracker Items",
// "ISO-8859-1 Latin" => "ISO-8859-1 Latin",
// "Delimitor (left)" => "Delimitor (left)",
// "Delimitor (right)" => "Delimitor (right)",
// "Carriage return inside field value" => "Carriage return inside field value",
// "Export dates as UNIX Timestamps to facilitate importing" => "Export dates as UNIX Timestamps to facilitate importing",
// "Export ItemLink type fields as the itemId of the linked item (to facilitate importing)" => "Export ItemLink type fields as the itemId of the linked item (to facilitate importing)",
// "Export country type fields as the system name of the country (to facilitate importing)" => "Export country type fields as the system name of the country (to facilitate importing)",
// "Parse as wiki text" => "Parse as wiki text",
// "Generic information" => "Generic information",
// "Number of records" => "Number of records",
// "First record" => "First record",
// "Tracker Export" => "Tracker Export",
// "Profile Export" => "Profile Export",
// "Produce YAML for a profile" => "Produce YAML for a profile",
// "Linked tracker and field IDs (such as those referenced in ItemLink, ItemsList field options, for instance) are not currently converted to profile object references, so will need manual replacement" => "Linked tracker and field IDs (such as those referenced in ItemLink, ItemsList field options, for instance) are not currently converted to profile object references, so will need manual replacement",
// "For example: \$profileobject:field_ref\$" => "For example: \$profileobject:field_ref\$",
// "Export Profile" => "Export Profile",
// "YAML Export" => "YAML Export",
// "Profile for trackerId %0" => "Profile for trackerId %0",
// "Import fields for this tracker" => "Import fields for this tracker",
// "Imported file '%0'" => "Imported file '%0'",
// "Import completed with '%0'" => "Import completed with '%0'",
// "The order of the fields does not matter, but you need to add a header with the field names" => "The order of the fields does not matter, but you need to add a header with the field names",
// "Add \" -- \" to the end of the fields in the header that you would like to import" => "Add \" -- \" to the end of the fields in the header that you would like to import",
// "Auto-incremented itemid fields shall be included with no matter what values" => "Auto-incremented itemid fields shall be included with no matter what values",
// "UNIX Timestamp" => "UNIX Timestamp",
// "Character encoding" => "Character encoding",
// "Create as new items" => "Create as new items",
// "Update lastModif date if updating items (status and created are updated only if the fields are specified in the csv)" => "Update lastModif date if updating items (status and created are updated only if the fields are specified in the csv)",
// "Convert values of ItemLink type fields from the value in the CSV file to the itemId of the linked item. Requires the linked item to be correctly set up in advance" => "Convert values of ItemLink type fields from the value in the CSV file to the itemId of the linked item. Requires the linked item to be correctly set up in advance",
// "Do you really want to remove the %0 tracker" => "Do you really want to remove the %0 tracker",
// "Back to tracker list" => "Back to tracker list",
// "Are you sure you want to remove the fields? Data will be lost" => "Are you sure you want to remove the fields? Data will be lost",
// "Remove Fields" => "Remove Fields",
// "Return to field administration" => "Return to field administration",
// "Are you sure you want to delete this item" => "Are you sure you want to delete this item",
// "Delete item" => "Delete item",
// "Description is wiki-parsed" => "Description is wiki-parsed",
// "Allow ratings (deprecated, use rating field)" => "Allow ratings (deprecated, use rating field)",
// "Rating options" => "Rating options",
// "Show ratings in listing" => "Show ratings in listing",
// "Show comments in listing" => "Show comments in listing",
// "Display last comment author and date" => "Display last comment author and date",
// "Display attachments in listing" => "Display attachments in listing",
// "Attachment attributes (sortable)" => "Attachment attributes (sortable)",
// "Show status to tracker administrator only" => "Show status to tracker administrator only",
// "Show creation date when listing items" => "Show creation date when listing items",
// "Creation date format" => "Creation date format",
// "Show item creator" => "Show item creator",
// "Show creation date when viewing items" => "Show creation date when viewing items",
// "Show last modification date when listing items" => "Show last modification date when listing items",
// "Show item last modifier" => "Show item last modifier",
// "Modification date format" => "Modification date format",
// "Show last modification date when viewing items" => "Show last modification date when viewing items",
// "Default sort direction" => "Default sort direction",
// "Hide empty fields from item view" => "Hide empty fields from item view",
// "List detail pop-up" => "List detail pop-up",
// "Comma-separated list of field IDs" => "Comma-separated list of field IDs",
// "Template to display an item" => "Template to display an item",
// "wiki:pageName for a wiki page or tpl:tplName for a template" => "wiki:pageName for a wiki page or tpl:tplName for a template",
// "Template to edit an item" => "Template to edit an item",
// "New item status" => "New item status",
// "Modified item status" => "Modified item status",
"No change" => "Nenhuma mudança",
"Default status displayed in list mode" => "Status padrão aparente no modo de lista",
"Notifications" => "Notificações",
// "Copy activity to email" => "Copy activity to email",
"Use simplified e-mail format" => "Usar formato de e-mail simplificado",
// "The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender" => "The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender",
// "Publish RSS feed for this tracker" => "Publish RSS feed for this tracker",
// "Requires \"RSS per tracker\" to be set in Admin/RSS" => "Requires \"RSS per tracker\" to be set in Admin/RSS",
// "(Currently set)" => "(Currently set)",
// "(Currently not set)" => "(Currently not set)",
// "Group alerted on item modification" => "Group alerted on item modification",
// "Allow user selection for small groups" => "Allow user selection for small groups",
// "Item creator can modify his items" => "Item creator can modify his items",
// "The tracker needs a user field with the auto-assign activated" => "The tracker needs a user field with the auto-assign activated",
// "Item creator can remove his items" => "Item creator can remove his items",
// "User can take ownership of item created by anonymous" => "User can take ownership of item created by anonymous",
// "Only one item per user or IP" => "Only one item per user or IP",
// "The tracker needs a user or IP address field with the auto-assign activated" => "The tracker needs a user or IP address field with the auto-assign activated",
// "Members of the creator group can modify items" => "Members of the creator group can modify items",
// "The tracker needs a group field with the auto-assign activated" => "The tracker needs a group field with the auto-assign activated",
// "Members of the creator group can remove items" => "Members of the creator group can remove items",
// "Creation date constraint" => "Creation date constraint",
// "Auto-create corresponding categories" => "Auto-create corresponding categories",
// "Create a group for each item" => "Create a group for each item",
// "Groups will include" => "Groups will include",
// "Creator is assigned to the group" => "Creator is assigned to the group",
// "Will become the creator's default group" => "Will become the creator's default group",
// "Will become the new item's group creator" => "Will become the new item's group creator",
// "Copy the default group in the field ID before updating the group" => "Copy the default group in the field ID before updating the group",
// "{\$sc.label|escape}" => "{\$sc.label|escape}",
// "Admin Fields" => "Admin Fields",
// "It is very likely that authentication will be required to access this data on the remote site. Configure the authentication source from Admin DSN" => "It is very likely that authentication will be required to access this data on the remote site. Configure the authentication source from Admin DSN",
// "Notification" => "Notification",
// "Do you really want to remove the scheduled event" => "Do you really want to remove the scheduled event",
// "No events registered" => "No events registered",
// "Reference date" => "Reference date",
// "After creation" => "After creation",
// "After last modification" => "After last modification",
// "Delay prior to status change" => "Delay prior to status change",
// "Mail subject text" => "Mail subject text",
// "Mail body ressource" => "Mail body ressource",
// "wiki:pageName for a wiki page or tplName.tpl for a template" => "wiki:pageName for a wiki page or tplName.tpl for a template",
// "(automatically generated after item creation)" => "(automatically generated after item creation)",
// "Hold \"Ctrl\" in order to select multiple values" => "Hold \"Ctrl\" in order to select multiple values",
"Other:" => "Outro:",
// "Upload files" => "Upload files",
// "Attached files limitation" => "Attached files limitation",
// "The amount of files that can be attached is limited to <strong>%0</strong>. Additional files uploaded will still be uploaded to the server and searchable, but they will not be attached to this item. Make sure you remove the files no longer required before you save your changes" => "The amount of files that can be attached is limited to <strong>%0</strong>. Additional files uploaded will still be uploaded to the server and searchable, but they will not be attached to this item. Make sure you remove the files no longer required before you save your changes",
// "Drop files from your desktop here or browse for them" => "Drop files from your desktop here or browse for them",
// "Existing files" => "Existing files",
// "Search query" => "Search query",
// "Select Icon" => "Select Icon",
"Remove Image" => "Remover imagem",
// "Are you sure you want to delete this image" => "Are you sure you want to delete this image",
// "Character Count" => "Character Count",
// "Administrator intervention required" => "Administrator intervention required",
// "Freetags is not enabled" => "Freetags is not enabled",
// "You did not vote yet" => "You did not vote yet",
// "My rating" => "My rating",
// "{\$field.labels[i]}" => "{\$field.labels[i]}",
// "Click to vote for this value" => "Click to vote for this value",
// "Click to delete your vote" => "Click to delete your vote",
// "Language: %0" => "Language: %0",
// "You have ever subscribed" => "You have ever subscribed",
// "You have not yet subscribed" => "You have not yet subscribed",
"with" => "com",
"friends" => "amigos",
// "Current language" => "Current language",
// "Show all translations of this page on a single page" => "Show all translations of this page on a single page",
// "All languages" => "All languages",
// "Google translate" => "Google translate",
// "Machine translations" => "Machine translations",
// "Translate page" => "Translate page",
// "Manage page translations" => "Manage page translations",
// "Translate article" => "Translate article",
// "Manage article translations" => "Manage article translations",
// "Maintenance" => "Maintenance",
// "Are you sure you want to detach these translations" => "Are you sure you want to detach these translations",
// "Current translation set" => "Current translation set",
// "Are you sure you want to detach the translation" => "Are you sure you want to detach the translation",
// "No translations available at this time" => "No translations available at this time",
// "Add a new object to the set" => "Add a new object to the set",
// "All possible translations exist" => "All possible translations exist",
// "Objects that contain the more terms are rated higher in the results and will appear first" => "Objects that contain the more terms are rated higher in the results and will appear first",
// "objects that include both tokenized terms" => "objects that include both tokenized terms",
// "Boolean operators" => "Boolean operators",
// "You can use AND or OR or NOT also to do a boolean search" => "You can use AND or OR or NOT also to do a boolean search",
// "Example: <strong>wiki and forum</strong> will find objects with both terms" => "Example: <strong>wiki and forum</strong> will find objects with both terms",
// "Example: <strong>wiki or forum</strong> will find objects with one of the term" => "Example: <strong>wiki or forum</strong> will find objects with one of the term",
// "Example: <strong>wiki and (forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order" => "Example: <strong>wiki and (forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order",
// "Use double quotes ( \" \" ) around a phrase to find terms in the exact order, next to each other" => "Use double quotes ( \" \" ) around a phrase to find terms in the exact order, next to each other",
// "Example: <strong>\"Alex Bell\"</strong> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong> but <strong>Alex Bells</strong>. " => "Example: <strong>\"Alex Bell\"</strong> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong> but <strong>Alex Bells</strong>. ",
"However, no account is associated to the OpenID identifier" => "Porém, nenhuma conta no Tiki foi associada a ela",
"If you use an email filter, be sure to add %0 to your accepted list" => "Se você algum filtro de e-mail, lembre de adicionar %0 na lista de endereços válidos",
// "Associate OpenID with an existing Tiki account" => "Associate OpenID with an existing Tiki account",
"Use this thread to discuss the page:" => "Use esse tópico para discutir a página:",
// "Missing or incorrect trackerId parameter for the plugin" => "Missing or incorrect trackerId parameter for the plugin",
"List Trackers" => "Listar",
// "Add Tag" => "Add Tag",
// "Subtract" => "Subtract",
// "Meeting ID" => "Meeting ID",
// "Current attendees" => "Current attendees",
// "No attendees at this time" => "No attendees at this time",
// "Last time we checked, the room you requested did not exist" => "Last time we checked, the room you requested did not exist",
// "Current recordings" => "Current recordings",
// "On %0 from %1 to %2" => "On %0 from %1 to %2",
// "{\$button_label}" => "{\$button_label}",
// "list" => "list",
// "{\$ftptitle}" => "{\$ftptitle}",
// "Lon." => "Lon.",
// "Lat." => "Lat.",
"Zoom" => "Zoom",
// "saving.." => "saving..",
// "Save current map view as user default" => "Save current map view as user default",
// "Save as user location" => "Save as user location",
// "Save as object location" => "Save as object location",
// "Number of Users" => "Number of Users",
// "Percentage of Total" => "Percentage of Total",
// "Email address the person you want to invite" => "Email address the person you want to invite",
// "Set in these groups" => "Set in these groups",
"Message sent to" => "Mensagem enviada para",
// "Email sent to" => "Email sent to",
// "Emails number" => "Emails number",
// "Send Mail" => "Send Mail",
// "Send to users" => "Send to users",
// "Send to" => "Send to",
// "Email separated by comma" => "Email separated by comma",
// "Send to groups" => "Send to groups",
// "Preview Mail" => "Preview Mail",
// "Check to remove" => "Check to remove",
// "Add in group" => "Add in group",
// "Set as default group for users" => "Set as default group for users",
// "Join myself" => "Join myself",
// "Leave myself" => "Leave myself",
"%0 year" => "%0 ano",
"%0 years" => "%0 anos",
"%0 days" => "%0 dias",
// "Membership term commences on %0-%1 each year" => "Membership term commences on %0-%1 each year",
// "Membership commences on %0 day of each month" => "Membership commences on %0 day of each month",
// "Cost for one period" => "Cost for one period",
// "Free for the rest of the current period, a prorated value of" => "Free for the rest of the current period, a prorated value of",
// "Prorated cost for first period" => "Prorated cost for first period",
// "Special offer! Free additional periods" => "Special offer! Free additional periods",
// "Membership to %0 for %1 year at %2 %3" => "Membership to %0 for %1 year at %2 %3",
// "Membership to %0 for %1 years at %2 %3" => "Membership to %0 for %1 years at %2 %3",
// "Membership to %0 for %1 days at %2 %3" => "Membership to %0 for %1 days at %2 %3",
// "separated by |" => "separated by |",
// "{\$periodslabel}" => "{\$periodslabel}",
// "Re-Apply" => "Re-Apply",
// "Undecided" => "Undecided",
// "No relations found" => "No relations found",
// "{\$snarfParams.ajax|escape:html}" => "{\$snarfParams.ajax|escape:html}",
// "Last Day" => "Last Day",
// "Last Week" => "Last Week",
// "{\$action}" => "{\$action}",
// "Groups you are in" => "Groups you are in",
// "(This is an included group)" => "(This is an included group)",
// "(You are a leader)" => "(You are a leader)",
// "Your default group" => "Your default group",
// "Leave Group" => "Leave Group",
// "Manage Group" => "Manage Group",
// "Change default group" => "Change default group",
// "Subscribe to a group" => "Subscribe to a group",
// "Groups you can join" => "Groups you can join",
// "This group requires approval to join" => "This group requires approval to join",
// "Subscribe to groups" => "Subscribe to groups",
// "Subscribe to the newsletter" => "Subscribe to the newsletter",
// "Mini TimeSheet" => "Mini TimeSheet",
// "Full View" => "Full View",
"Before:" => "Antes:",
"After:" => "Depois:",
// "{\$export_action}" => "{\$export_action}",
// "Tracker - " => "Tracker - ",
// "{\$checkbox.title}" => "{\$checkbox.title}",
// "Export Tracker" => "Export Tracker",
// "Close item" => "Close item",
// "Open item" => "Open item",
// "Pend item" => "Pend item",
// "{\$params.label}" => "{\$params.label}",
// "Please login first" => "Please login first",
// "Toggle display" => "Toggle display",
"Close:" => "Fechar:",
"Page last modified on %0 by %1" => "Última modificação da página em %0 por %1",
"Created by %0" => "Criada por %0",
"Last Modification: %0 by %1" => "Última modificação: %0 por %1",
"List authors:" => "Listar autores:",
"Creator &amp; Last Editor" => "Criador &amp; último editor",
"as Creator &amp; Last Editor" => "como criador &amp; Último editor",
"no (disabled)" => "não (disabilitado)",
// "Missing book id" => "Missing book id",
// "You do not have the right view this page" => "You do not have the right view this page",
// "Missing account id" => "Missing account id",
// "You do not have the rights to view this account" => "You do not have the rights to view this account",
// "You do not have the rights to manage accounts" => "You do not have the rights to manage accounts",
// "You do not have permissions to create a book" => "You do not have permissions to create a book",
// "You do not have permissions to close this book" => "You do not have permissions to close this book",
// "Missing journal id" => "Missing journal id",
// "You do not have the right to cancel transactions" => "You do not have the right to cancel transactions",
// "Error retrieving data from journal" => "Error retrieving data from journal",
// "You do not have the right to book" => "You do not have the right to book",
// "Don't know what to export" => "Don't know what to export",
// "You do not have the right export/view this data" => "You do not have the right export/view this data",
// "You do not have the right to book into the stack" => "You do not have the right to book into the stack",
// "Tiki Calendar" => "Tiki Calendar",
// "%0 enabled" => "%0 enabled",
// "%0 disabled" => "%0 disabled",
// "%0 set" => "%0 set",
// "%0 unset" => "%0 unset",
"Administration" => "Administração",
// "Help on Configuration Sections" => "Help on Configuration Sections",
// "%0 reset" => "%0 reset",
// "Bad request - potential cross-site request forgery (CSRF) detected. Operation blocked" => "Bad request - potential cross-site request forgery (CSRF) detected. Operation blocked",
// "Global site configuration, date formats, admin password etc" => "Global site configuration, date formats, admin password etc",
// "Switches for major features" => "Switches for major features",
// "User registration, remember me cookie settings and authentication methods" => "User registration, remember me cookie settings and authentication methods",
// "User specific features and settings" => "User specific features and settings",
// "Repository configuration, browse and apply profiles" => "Repository configuration, browse and apply profiles",
"Look & Feel" => "Aparência",
// "Theme selection, layout settings and UI effect controls" => "Theme selection, layout settings and UI effect controls",
// "Editing and Plugins" => "Editing and Plugins",
// "Text editing settings applicable to many areas. Plugin activation and plugin alias management" => "Text editing settings applicable to many areas. Plugin activation and plugin alias management",
// "Module appearance settings" => "Module appearance settings",
// "Meta Tags" => "Meta Tags",
// "Information to include in the header of each page" => "Information to include in the header of each page",
"i18n" => "Idioma",
// "Internationalization and localization - mulitlingual features" => "Internationalization and localization - mulitlingual features",
// "Settings and features for maps" => "Settings and features for maps",
// "Server performance settings" => "Server performance settings",
// "Site security settings" => "Site security settings",
// "Comments settings" => "Comments settings",
// "Outgoing RSS feed setup" => "Outgoing RSS feed setup",
// "Connect" => "Connect",
// "Tiki Connect - join in" => "Tiki Connect - join in",
// "Search configuration" => "Search configuration",
// "Wiki page settings and features" => "Wiki page settings and features",
// "Defaults and configuration for file galleries" => "Defaults and configuration for file galleries",
// "Settings for blogs" => "Settings for blogs",
// "Defaults and configuration for image galleries (will be phased out in favour of file galleries)" => "Defaults and configuration for image galleries (will be phased out in favour of file galleries)",
// "Settings and features for articles" => "Settings and features for articles",
// "Settings and features for forums" => "Settings and features for forums",
// "Settings and features for trackers" => "Settings and features for trackers",
// "Settings and features for polls" => "Settings and features for polls",
// "Settings and features for calendars" => "Settings and features for calendars",
// "Settings and features for categories" => "Settings and features for categories",
// "Configure areas feature" => "Configure areas feature",
// "Values of actions for users rank score" => "Values of actions for users rank score",
// "Settings and features for freetags" => "Settings and features for freetags",
// "Settings and features for FAQs" => "Settings and features for FAQs",
// "Settings and features for directory of links" => "Settings and features for directory of links",
// "Defaults and API key for Google Maps" => "Defaults and API key for Google Maps",
// "Site-wide copyright information" => "Site-wide copyright information",
// "Message settings" => "Message settings",
"User files" => "Arquivos do usuário",
// "User files settings" => "User files settings",
// "Webmail settings" => "Webmail settings",
"Wysiwyg" => "Wysiwyg",
// "Options for WYSIWYG editor" => "Options for WYSIWYG editor",
// "Banners are a common way to display advertisements and notices on a Web page" => "Banners are a common way to display advertisements and notices on a Web page",
// "InterTiki" => "InterTiki",
// "Set up links between Tiki servers" => "Set up links between Tiki servers",
// "Manage semantic wiki links" => "Manage semantic wiki links",
// "Webservices" => "Webservices",
// "Register and manage web services" => "Register and manage web services",
"Search engine friendly url" => "URL amigável",
// "Video streaming integration" => "Video streaming integration",
// "Video integration configuration" => "Video integration configuration",
// "Configure social networks integration" => "Configure social networks integration",
// "Configure share feature" => "Configure share feature",
// "Current version is up to date : <b>%0</b>" => "Current version is up to date : <b>%0</b>",
// "A new %0 major release branch is available" => "A new %0 major release branch is available",
// "Help on %0 Config" => "Help on %0 Config",
// "Must specify actionId" => "Must specify actionId",
// "Users Contributions: Addition" => "Users Contributions: Addition",
// "%s Contributions: Addition" => "%s Contributions: Addition",
// "Users Contributions: Suppression" => "Users Contributions: Suppression",
// "%s Contributions: Suppression" => "%s Contributions: Suppression",
// "Total Contributions Addition per Day" => "Total Contributions Addition per Day",
// "Total Contributions Addition per Week" => "Total Contributions Addition per Week",
// "Total Contributions Suppression per Day" => "Total Contributions Suppression per Day",
// "Total Contributions Suppression per Week" => "Total Contributions Suppression per Week",
// "Total Contributions: Addition" => "Total Contributions: Addition",
// "Total Contributions: Suppression" => "Total Contributions: Suppression",
// "Groups Contributions: Addition" => "Groups Contributions: Addition",
// "Groups Contributions: Suppression" => "Groups Contributions: Suppression",
"white" => "branco",
"gray" => "cinza",
"silver" => "prata",
// "ivory" => "ivory",
// "whitesmoke" => "whitesmoke",
// "beige" => "beige",
"darkgrey" => "cinza escuro",
// "Multiple IP Banning" => "Multiple IP Banning",
// "Access from your localization was forbidden due to excessive spamming" => "Access from your localization was forbidden due to excessive spamming",
// "Delete comments then set banning rules" => "Delete comments then set banning rules",
// "Are you sure you want to unassign the objects of this category: " => "Are you sure you want to unassign the objects of this category: ",
"Click here to delete the category:" => "Clique aqui para deletar a categoria:",
// "The file does not have the required header" => "The file does not have the required header",
"Edit permissions for this category" => "Editar permissões para essa categoria",
"Category can`t be parent of itself" => "Categoria não pode ser pai dela mesma",
// "Content Templates" => "Content Templates",
"Upload failed" => "A carga falhou",
// "Admin credits" => "Admin credits",
"All posted" => "Todas as mensagens enviadas",
"Queue anonymous posts" => "Enfileirar mensagens anônimas",
"Queue all posts" => "Enfileirar todas as mensagens",
"No attachments" => "Sem arquivos anexados",
"Everybody can attach" => "Todos podem anexar",
"Only users with attach permission" => "Apenas usuários com permissão de anexar",
"Moderators and admin can attach" => "Moderadores e admin podem anexar",
// "No display" => "No display",
"Date (desc)" => "Data (desc)",
"Date (asc)" => "Data (asc)",
"Score (desc)" => "Pontuação (desc)",
"Replies (desc)" => "Respostas (desc)",
"Reads (desc)" => "Leituras (desc)",
"You have to provide a hotword and a URL" => "Você deve informar uma palavra-chave e uma URL",
"Requested action is not supported on repository" => "A ação solicitada não é suportada em repositórios",
"Repository name can't be an empty" => "Nome do Repositório não pode ser vazio",
"No repository" => "Sem repositório",
"Search is mandatory field" => "Busca é um campo mandatório",
"File not found " => "Arquivo não encontrado ",
"Requested action in not supported on repository" => "Ação de requisição não é suportada no repositório",
// "You need to apply the \"Invoice\" profile" => "You need to apply the \"Invoice\" profile",
"Non-existent link" => "Link inexistente",
"Mail-in account %s incorrect" => "Conta %s mail-in incorreta",
"Mail-in account %s saved" => "Conta %s mail-in salva",
"Frequency should be a positive integer!" => "Frequëncia deveria ser um inteiro positivo!",
"Mail-in accounts set to be checked every %s minutes" => "Contas de mail-in configuradas para serem chegas a cada %s minutos",
"Automatic Mail-in accounts checking disabled" => "Checar automaticamente contas de mail-in desabilitado",
"No menu indicated" => "Nenhum menu foi indicado",
// "Are you sure you want to delete menu id" => "Are you sure you want to delete menu id",
// "Are you sure you want to reset the Application Menu to the current system default" => "Are you sure you want to reset the Application Menu to the current system default",
// "metric_remove must be a numeric value" => "metric_remove must be a numeric value",
// "tab_remove must be a numeric value" => "tab_remove must be a numeric value",
// "assign_remove must be a numeric value" => "assign_remove must be a numeric value",
// "metric_edit must be a numeric value" => "metric_edit must be a numeric value",
// "tab_edit must be a numeric value" => "tab_edit must be a numeric value",
// "Memcache is disabled for metrics" => "Memcache is disabled for metrics",
// "tab_clearcache must be a numeric value" => "tab_clearcache must be a numeric value",
// "assign_metric must be a numeric value" => "assign_metric must be a numeric value",
// "assign_metric_edit must be a numeric value" => "assign_metric_edit must be a numeric value",
// "Assign: Invalid metric value" => "Assign: Invalid metric value",
// "Assign: Invalid tab value" => "Assign: Invalid tab value",
// "Cannot create or update metric: You need to specify a name for the metric" => "Cannot create or update metric: You need to specify a name for the metric",
// "Cannot create or update metric: Metric name must be under %0 characters in length" => "Cannot create or update metric: Metric name must be under %0 characters in length",
// "Cannot create or update metric: You need to specify a range for the metric" => "Cannot create or update metric: You need to specify a range for the metric",
// "Cannot create or update metric: You need to specify a data type for the metric" => "Cannot create or update metric: You need to specify a data type for the metric",
// "Cannot create or update metric: You need to specify a query for the metric" => "Cannot create or update metric: You need to specify a query for the metric",
// "Cannot create or update tab: You need to specify a name for the tab" => "Cannot create or update tab: You need to specify a name for the tab",
// "Cannot create or update tab: Tab name must be under %0 characters in length" => "Cannot create or update tab: Tab name must be under %0 characters in length",
// "Cannot create or update tab: You need to specify an integer range for the tab order" => "Cannot create or update tab: You need to specify an integer range for the tab order",
// "Cannot create or update tab: Tab content cannot be empty" => "Cannot create or update tab: Tab content cannot be empty",
"Cannot create or update module: You need to specify a name for the module" => "Não foi possível criar ou atualizar o módulo: você precisa especificar um nome para ele",
"Cannot create or update module: You cannot leave the data field empty" => "Não foi possível criar ou atualizar o módulo: você não pode deixar o campo 'data' em branco",
// "A module with that \"name\" already exists, please choose another" => "A module with that \"name\" already exists, please choose another",
// "There is a problem with your custom module \"%0\": ' . '<br><br><em>' . \$e->getMessage() . '</em><br><br>' .\n\t\t\t\t\t'<span class=\"button\"><a href=\"tiki-admin_modules.php?um_edit=' . \$_REQUEST['assign_name'] . '&cookietab=2#editcreate\">' .\n\t\t\t\t\ttr('Click here to edit the module" => "There is a problem with your custom module \"%0\": ' . '<br><br><em>' . \$e->getMessage() . '</em><br><br>' .\n\t\t\t\t\t'<span class=\"button\"><a href=\"tiki-admin_modules.php?um_edit=' . \$_REQUEST['assign_name'] . '&cookietab=2#editcreate\">' .\n\t\t\t\t\ttr('Click here to edit the module",
// "Are you sure you want to delete this Custom Module" => "Are you sure you want to delete this Custom Module",
"No newsletter indicated" => "Nenhum comunicado foi indicado",
// "Newsletter does not exist" => "Newsletter does not exist",
// "Error importing from wiki page: " => "Error importing from wiki page: ",
// "Error opening uploaded file" => "Error opening uploaded file",
// "You need to provide a username or an email" => "You need to provide a username or an email",
// "The user has no email set. No notifications will be sent" => "The user has no email set. No notifications will be sent",
"No poll indicated" => "Nenhuma enquete foi indicada",
"unsafe" => "inseguro",
"The Path to store files in the filegallery should be outside the tiki root directory" => "O patch para guardar arquivos na galeria de arquivos deve estar fora do diretório principal do tiki",
"The Path to store files in the imagegallery should be outside the tiki root directory" => "O patch para guardar arquivos na galeria de imagens deve estar fora do diretório principal do tiki",
"The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code." => "O recurso \"Editar templates\" está ativado. Não permita que esse recurso seja utilizado por quem você não pode confiar. Com ele pode-se facilmente injetar código PHP.",
// "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any HTML" => "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any HTML",
// "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement" => "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement",
// "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory" => "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory",
// "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts" => "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts",
// "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)" => "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)",
// "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users" => "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users",
// "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users" => "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users",
// "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands" => "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands",
// "Path disclosure" => "Path disclosure",
// "Path disclosure through error message" => "Path disclosure through error message",
"SQL injection" => "Injeção SQL",
"SQL injection by authenticated user" => "Injeção SQL para usuários autenticados",
"SQL injection by authenticated user with special privileges" => "Injeção SQL apenas para usuários autenticados e com privilégios especiais.",
"SQL injection without authentication" => "Injeção SQL sem autenticação",
"PHP command injection" => "Injeção de comando PHP",
"PHP command injection by authenticated user" => "Injeção de comando PHP para usuário autenticado",
"PHP command injection by authenticated user with special privileges" => "Injeção de comando PHP apenas para usuários autenticados e com privilégios especiais.",
"PHP command injection without authentication" => "Injeção de comando PHP sem autenticação",
"File upload" => "Subir arquivo",
"File is not readable. Unable to check." => "Arquivo não esta disponível para a leitura. Impossível checar.",
// "This is not a Tiki file. Check if this file was uploaded and if it is dangerous" => "This is not a Tiki file. Check if this file was uploaded and if it is dangerous",
"This is a modified File. Cannot check version. Check if it is dangerous." => "Esse é um arquivo modificado. Não foi possível checar a versão. Verifique se ele pode ser perigoso.",
// "This file is from another Tiki version: " => "This file is from another Tiki version: ",
// "Shoutbox Words" => "Shoutbox Words",
"You have to provide a word" => "Você precisa especificar uma palavra",
"You do not have permission to view this page." => "Permissão negada, você não pode ver esta página",
"You do not have permission to edit this page." => "Permissão negada: você não pode editar esta página",
"You must specify a page name, it will be created if it doesn't exist." => "Você deve especificar um nome de página, que pode ser criada se não existir.",
"page not added (Exists)" => "página não adicionada (pré-existente)",
"No survey indicated" => "Nenhuma pesquisa foi indicada",
"Tiki Cache/Sys Admin" => "Administrar cache",
"Global" => "Global",
// "WYSIWYG Plugin" => "WYSIWYG Plugin",
// "Are you sure you want to delete all your custom tools" => "Are you sure you want to delete all your custom tools",
// "Are you sure you want to delete this custom tool" => "Are you sure you want to delete this custom tool",
"Are you sure you want to remove this topic" => "Você tem certeza de que deseja remover este tópico",
"Are you sure you want to remove this topic AND all the articles related" => "Você tem certeza de que deseja remover este tópico e todos os artigos relacionados",
"No tracker indicated" => "Nenhum formulário foi indicado",
"You don't have permission to use this feature" => "Você não tem permissão para usar esse recurso",
// "Are you sure you want to create a new group" => "Are you sure you want to create a new group",
// "Are you sure you want to add this user" => "Are you sure you want to add this user",
"Are you sure you want to ban the user \"%0\" from the group \"%1\"" => "Você tem certeza de que deseja banir o usuário \"%0\" do grupo \"%1\"",
"Are you sure you want to unban the user \"%0\" from the group \"%1\"" => "Você tem certeza de que deseja cancelar o banimento do usuário \"%0\" do grupo \"%1\"",
"Group already exists" => "Grupo já existente",
"Remove group: " => "Remover grupo: ",
// "Are you sure you want to delete these groups" => "Are you sure you want to delete these groups",
"Group name can not be empty" => "O nome do grupo não pode estar vazio",
"User doesn't exist" => "O usuário não existe",
"No records were found. Check the file please!" => "Nenhum registro encontrado. Por favor, verifique o arquivo.",
"User login or email is required" => "Nome de usuário ou email é obrigatório",
"User does not exist on master" => "Usuário não existe no servidor principal",
"User login is required" => "O login do usuário é obrigatório",
"Email is required" => "O endereço de e-mail é obrigatório",
"User is duplicated" => "Usuário duplicado",
"Created account %s <%s>" => "Criada a conta %s <%s>",
"Assigned %s in group %s" => "Associado %s no grupo %s",
"Are you sure you want to add this new user" => "Você tem certeza de que deseja adicionar este novo usuário",
"Email validation requested but email address not set" => "A opção para validar o endereço de email foi selecionada mas o campo email está em branco",
"The passwords do not match" => "O valor dos campos senha e confirmação de senha devem ser iguais",
"Password not set" => "Senha não definida",
"User %s already exists" => "Usuário %s já existe",
"User login contains invalid characters" => "O nome do usuário contém caracteres inválidos",
"New user created with username %s" => "Novo usuário criado com o nome %s",
"Impossible to create new %s with %s %s." => "Impossível criar novo %s com %s %s.",
"Are you sure you want to delete this user" => "Você tem certeza de que deseja deletar este usuário",
"%s %s successfully deleted." => "%s %s deletado com sucesso.",
"Deleted account %s" => "Conta %s removida",
// "Are you sure you want to remove the admin user from the Admins group? You may not be able to administer your Tiki any more if you do this" => "Are you sure you want to remove the admin user from the Admins group? You may not be able to administer your Tiki any more if you do this",
"Are you sure you want to remove this user from this group" => "Você tem certeza de que deseja remover este usuário deste grupo",
"%s %s removed from %s %s." => "%s %s removido de %s %s.",
// "Are you sure you want to reset email due for this user" => "Are you sure you want to reset email due for this user",
// "Are you sure you want to remove the link with OpenID for this user" => "Are you sure you want to remove the link with OpenID for this user",
"Are you sure you want to delete these users" => "Você tem certeza de que deseja remover estes usuários",
"Are you sure you want to add this user to these groups" => "Você tem certeza de que deseja adicionar este usuário a este grupo",
// "%s %s assigned to %s %s" => "%s %s assigned to %s %s",
"Are you sure you want to remove this user from these groups" => "Você tem certeza de que deseja remover este usuário destes grupos",
"Are you sure you want to set the default groups for these users" => "Você tem certeza de que deseja definir o grupo padrão destes usuários",
// "group %s set as the default group of user %s" => "group %s set as the default group of user %s",
"Are you sure you want to send a wiki page as an email to these users" => "Você tem certeza de que deseja enviar uma página wiki por email para estes usuários",
"The description is mandatory as it is used as mail subject" => "O campo descrição é obrigatório como é usado como o assunto do email",
"Invalid or unknown email" => "E-mail inválido ou desconhecido",
"Login contains invalid characters" => "Nome do usuário contém caracteres inválidos",
"%s changed from %s to %s" => "%s mudou de %s para %s",
"%s modified successfully." => "%s modificado com sucesso.",
"%s modification failed." => "%s modificação falhou.",
"email" => "e-mail",
"Impossible to change %s from %s to %s" => "Impossível alterar %s de %s para %s",
"Please go back and try again" => "Por favor volte e tente de novo",
"Could not create user" => "Não foi possível criar o usuário",
"Are you sure you want to modify this user's data" => "Você tem certeza de que deseja modificar os dados deste usuário",
"Classified" => "Classificado",
// "Failed to add attribute" => "Failed to add attribute",
"rss feed disabled" => "campo rss desabilitado",
"You have to indicate a group" => "Você precisa indicar um grupo",
"This group is invalid" => "Esse grupo não é válido",
"The page cannot be found" => "A página não pôde ser encontrada",
"Image Galleries Admin Panel" => "Painel de administração da galeria de imagens",
"Could not read image %s." => "Não possível possível ler a imagem %s.",
"Image %s upload failed." => "Upload da imagem %s falhou.",
"Image %s uploaded successfully." => "Imagem %s enviada com sucesso.",
"Image %s removed from Batch directory." => "Imagem %s removida do diretório em lote.",
"Impossible to remove image %s from Batch directory." => "Impossível remover imagem %s do diretório em lote.",
"Incorrect directory chosen for batch upload of images." => "Diretório selecionado incorreto para fazer o upload de imagens em lote.",
"Please setup that dir on " => "Por favor configure aquele diretório ",
"Please contact the website administrator." => "Por favor contate o administrador do site.",
"Invalid directory name" => "Nome de diretório inválido",
"Directory batch" => "Diretório em lote",
// "File Galleries Admin Panel" => "File Galleries Admin Panel",
// "Upload was not successful for %0 (%1)" => "Upload was not successful for %0 (%1)",
// "Upload was successful" => "Upload was successful",
// "File %s removed from Batch directory" => "File %s removed from Batch directory",
// "Impossible to remove file %s from Batch directory" => "Impossible to remove file %s from Batch directory",
// "Incorrect directory chosen for batch upload of files" => "Incorrect directory chosen for batch upload of files",
"It isn't possible to post in any blog. You may need to create a blog first." => "Você não pode escrever em nenhum blog: talvez você deva criar um blog antes",
"You do not have permission to edit this post" => "Permissão negada: você não pode editar esta mensagem",
"Top visited blogs" => "Blogs mais visitados",
"Last posts" => "Últimas mensagens",
"Top active blogs" => "Blogs mais ativos",
"No blogId specified" => "Nenhum ID de blog especificado",
// "Stop watching all categories" => "Stop watching all categories",
// "Watch all categories" => "Watch all categories",
// "Group watches for all categories" => "Group watches for all categories",
// "Stop watching this category and its descendants" => "Stop watching this category and its descendants",
// "Watch this category and its descendants" => "Watch this category and its descendants",
// "Group watches for this category" => "Group watches for this category",
// "Stop watching this category" => "Stop watching this category",
// "Watch this category" => "Watch this category",
"Nothing tagged yet" => "Nenhuma tag criada até o momento",
// "You must clear your browser cache" => "You must clear your browser cache",
"You do not have permission to access this gallery" => "Permissão negada: você não pode acessar esta galeria",
"No gallery indicated" => "Nenhuma galeria foi indicada",
"You do not have permission to remove images from this gallery" => "Permissão negada: você não pode remover imagens desta galeria",
"You do not have permission to rebuild thumbnails in this gallery" => "Permissão negada: você não pode recriar miniaturas nesta galeria",
"You do not have permission to rotate images in this gallery" => "Permissão negada: você não pode rotacionar imagens nesta galeria",
"No image indicated" => "Nenhuma imagem foi indicada",
"picture not found" => "imagem não encontrada",
"You do not have permission to move images from this gallery" => "Permissão negada: você não pode mover imagens desta galeria",
"You do not have permission to view the calendar" => "Permissão negada: você não pode visualizar o calendário",
// "You need to <a href=\"tiki-admin_calendars.php?cookietab=2\">create a calendar</a>" => "You need to <a href=\"tiki-admin_calendars.php?cookietab=2\">create a calendar</a>",
// "There's no such date as" => "There's no such date as",
"event without name" => "evento sem nome",
// "You do not have permission to view this page" => "You do not have permission to view this page",
// "Invalid date format" => "Invalid date format",
// "Your PHP installation does not have calendar enabled" => "Your PHP installation does not have calendar enabled",
"%H:%M %Z" => "%H:%M %Z",
"Invalid username or activation code. Maybe this code has already been used." => "Usuário ou código de ativação inválido. Talvez o código já tenha sido usado.",
// "Your email could not be validated; make sure you email is correct" => "Your email could not be validated; make sure you email is correct",
"You can not use the same password again" => "Esta senha não pode ser novamente utilizada",
"Invalid old password" => "Senha antiga inválida",
// "Invalid request. Expecting channels array" => "Invalid request. Expecting channels array",
// "Missing channel name" => "Missing channel name",
// "Authentication required" => "Authentication required",
// "One of the requested channels cannot be requested. It does not exist or permission is denied" => "One of the requested channels cannot be requested. It does not exist or permission is denied",
// "One of the install profiles could not be obtained" => "One of the install profiles could not be obtained",
// "info" => "info",
// "You will get no errors reported, because error_reporting and display_errors are both turned off. This might be the right thing for a production site, but in case of problems enable these in php.ini to get more information" => "You will get no errors reported, because error_reporting and display_errors are both turned off. This might be the right thing for a production site, but in case of problems enable these in php.ini to get more information",
// "You will get no errors reported although display_errors is On, because the error_reporting level is set to 0. This might be the right thing for a production site, but in case of problems raise the value in php.ini to get more information" => "You will get no errors reported although display_errors is On, because the error_reporting level is set to 0. This might be the right thing for a production site, but in case of problems raise the value in php.ini to get more information",
// "You will get no errors reported, because display_errors is turned off. This might be the right thing for a production site, but in case of problems enable it in php.ini to get more information. Your error_reporting level is decent at '.\$e.'" => "You will get no errors reported, because display_errors is turned off. This might be the right thing for a production site, but in case of problems enable it in php.ini to get more information. Your error_reporting level is decent at '.\$e.'",
// "You will not get all errors reported as your error_reporting level is at '.\$e.'. '.'This is not necessarily a bad thing (and it might be just right for production sites) as you will still get critical errors reported, but sometimes it can be handy to get more information. Check your error_reporting level in php.ini in case of having issues" => "You will not get all errors reported as your error_reporting level is at '.\$e.'. '.'This is not necessarily a bad thing (and it might be just right for production sites) as you will still get critical errors reported, but sometimes it can be handy to get more information. Check your error_reporting level in php.ini in case of having issues",
// "You will get no errors reported although your error_reporting level is all the way up at '.\$e" => "You will get no errors reported although your error_reporting level is all the way up at '.\$e",
// "You will get all errors reported as your error_reporting level is all the way up at '.\$e.' and display_errors is on. Way to go in case of problems as the error reports usually contain some valuable hints" => "You will get all errors reported as your error_reporting level is all the way up at '.\$e.' and display_errors is on. Way to go in case of problems as the error reports usually contain some valuable hints",
// "good" => "good",
// "ini_set is used in some places to accomodate for special needs of some Tiki features" => "ini_set is used in some places to accomodate for special needs of some Tiki features",
// "ugly" => "ugly",
// "ini_set is used in some places to accomodate for special needs of some Tiki features. Check disable_functions in your php.ini" => "ini_set is used in some places to accomodate for special needs of some Tiki features. Check disable_functions in your php.ini",
// "The PDO extension is the suggested database driver/abstraction layer" => "The PDO extension is the suggested database driver/abstraction layer",
// "You do not have the recommended PDO database driver/abstraction layer. You do have the MySQLi driver though, so we will to fall back to the AdoDB abstraction layer that is bundled with Tiki" => "You do not have the recommended PDO database driver/abstraction layer. You do have the MySQLi driver though, so we will to fall back to the AdoDB abstraction layer that is bundled with Tiki",
// "You do not have the recommended PDO database driver/abstraction layer. You do have the MySQL driver though, so we will to fall back to the AdoDB abstraction layer that is bundled with Tiki" => "You do not have the recommended PDO database driver/abstraction layer. You do have the MySQL driver though, so we will to fall back to the AdoDB abstraction layer that is bundled with Tiki",
// "bad" => "bad",
// "You do not have any of the supported database drivers (PDO/mysqli/mysql) loaded. Tiki will not work" => "You do not have any of the supported database drivers (PDO/mysqli/mysql) loaded. Tiki will not work",
// "N/A" => "N/A",
// "You have less than 200 megs of free disk space. Tiki will not fit on this disk drive" => "You have less than 200 megs of free disk space. Tiki will not fit on this disk drive",
// "You have less than 250 megs of free disk space. This is quite tight. Tiki needs disk space for compiling templates and for uploading files" => "You have less than 250 megs of free disk space. This is quite tight. Tiki needs disk space for compiling templates and for uploading files",
// "When the disk runs full you will not be able to log into your Tiki any more" => "When the disk runs full you will not be able to log into your Tiki any more",
// "We can not reliably check for quotas, so be warned that if your server makes use of them you might have less disk space available" => "We can not reliably check for quotas, so be warned that if your server makes use of them you might have less disk space available",
// "You have more than 251 megs of free disk space. Tiki will run nicely, but you may run into issues when your site grows (e.g. file uploads)" => "You have more than 251 megs of free disk space. Tiki will run nicely, but you may run into issues when your site grows (e.g. file uploads)",
// "The PHP function disk_free_space is not available on your server, so we can't check for this" => "The PHP function disk_free_space is not available on your server, so we can't check for this",
// "You are running PHP as CGI. Feel free to use a threaded Apache MPM to increase performance" => "You are running PHP as CGI. Feel free to use a threaded Apache MPM to increase performance",
// "You are running PHP using FPM (Fastcgi Process Manager). Feel free to use a threaded Apache MPM to increase performance" => "You are running PHP using FPM (Fastcgi Process Manager). Feel free to use a threaded Apache MPM to increase performance",
// "You are not running PHP as CGI. Be aware that PHP is not thread-safe and you should not use a threaded Apache MPM (like worker)" => "You are not running PHP as CGI. Be aware that PHP is not thread-safe and you should not use a threaded Apache MPM (like worker)",
// "You are using APC as your ByteCode Cache which increases performance, if correctly configured. See Admin->Performance in your Tiki for more details" => "You are using APC as your ByteCode Cache which increases performance, if correctly configured. See Admin->Performance in your Tiki for more details",
// "You are using xCache as your ByteCode Cache which increases performance, if correctly configured. See Admin->Performance in your Tiki for more details" => "You are using xCache as your ByteCode Cache which increases performance, if correctly configured. See Admin->Performance in your Tiki for more details",
// "You are using WinCache as your ByteCode Cache which increases performance, if correctly configured. See Admin->Performance in your Tiki for more details" => "You are using WinCache as your ByteCode Cache which increases performance, if correctly configured. See Admin->Performance in your Tiki for more details",
// "You are using WinCache as your ByteCode Cache, but you do not seem to use the required CGI/FastCGI server API" => "You are using WinCache as your ByteCode Cache, but you do not seem to use the required CGI/FastCGI server API",
// "You are using neither APC, WinCache nor xCache as your ByteCode Cache which would increase performance, if correctly configured. See Admin->Performance in your Tiki for more details" => "You are using neither APC, WinCache nor xCache as your ByteCode Cache which would increase performance, if correctly configured. See Admin->Performance in your Tiki for more details",
// "You are using neither APC nor xCache as your ByteCode Cache which would increase performance, if correctly configured. See Admin->Performance in your Tiki for more details" => "You are using neither APC nor xCache as your ByteCode Cache which would increase performance, if correctly configured. See Admin->Performance in your Tiki for more details",
// "Your memory_limit is at" => "Your memory_limit is at",
// "This is known to behave well even for bigger sites" => "This is known to behave well even for bigger sites",
// "This will normally work, but you might run into problems when your site grows" => "This will normally work, but you might run into problems when your site grows",
// "This is known to cause issues! You should raise your memory_limit to at least 128M, which is the default of PHP" => "This is known to cause issues! You should raise your memory_limit to at least 128M, which is the default of PHP",
// "Your session.save_handler must be set to 'files'" => "Your session.save_handler must be set to 'files'",
// "Well set! the default setting of 'files' is needed for Tiki" => "Well set! the default setting of 'files' is needed for Tiki",
// "You have zlib output compression turned on. This saves bandwidth. Turning it off would in turn reduce CPU usage. Choose your poison" => "You have zlib output compression turned on. This saves bandwidth. Turning it off would in turn reduce CPU usage. Choose your poison",
// "You have zlib output compression turned off. This reduces CPU usage. Turning it on would in turn save bandwidth. Choose your poison" => "You have zlib output compression turned off. This reduces CPU usage. Turning it on would in turn save bandwidth. Choose your poison",
// "register_globals should be off by default. See the PHP manual for details" => "register_globals should be off by default. See the PHP manual for details",
// "Well set! And you are future proof also as register_globals is deprecated" => "Well set! And you are future proof also as register_globals is deprecated",
// "safe_mode is deprecated and should be off by default. See the <a href=\"http://www.php.net/manual/de/features.safe-mode.php\">PHP manual</a> for details" => "safe_mode is deprecated and should be off by default. See the <a href=\"http://www.php.net/manual/de/features.safe-mode.php\">PHP manual</a> for details",
// "Well set! And you are future proof also as safe_mode is deprecated" => "Well set! And you are future proof also as safe_mode is deprecated",
// "Some features like assigning perms to a group with a name containing a quote will not work with this being on. magic_quotes_gpc is also deprecated and should be off by default. See the PHP manual for details. You may experience weird behaviour of your Tiki" => "Some features like assigning perms to a group with a name containing a quote will not work with this being on. magic_quotes_gpc is also deprecated and should be off by default. See the PHP manual for details. You may experience weird behaviour of your Tiki",
// "Well set! Some features like assigning perms to a group with a name containing a quote will not work with this being on. And you are future proof also as magic_quotes_gpc is deprecated" => "Well set! Some features like assigning perms to a group with a name containing a quote will not work with this being on. And you are future proof also as magic_quotes_gpc is deprecated",
// "Well set! Tiki is fully UTF-8 and so should your installation be" => "Well set! Tiki is fully UTF-8 and so should your installation be",
// "default_charset should be UTF-8 as Tiki is fully UTF-8. Please check your php.ini" => "default_charset should be UTF-8 as Tiki is fully UTF-8. Please check your php.ini",
// "You have no timezone set! While there are a lot of fallbacks in PHP to determine the timezone, the only reliable solution is to set it explicitly in php.ini! Please check the value of date.timezone in php.ini" => "You have no timezone set! While there are a lot of fallbacks in PHP to determine the timezone, the only reliable solution is to set it explicitly in php.ini! Please check the value of date.timezone in php.ini",
// "Well done! Having a timezone set protects you from many weird errors" => "Well done! Having a timezone set protects you from many weird errors",
// "You can upload files to your Tiki" => "You can upload files to your Tiki",
// "You will not be able to upload any files to your Tiki" => "You will not be able to upload any files to your Tiki",
// "Your max_execution_time is at" => "Your max_execution_time is at",
// "This is a good value for production sites. If you experience timeouts (such as when performing admin functions) you may need to increase this nevertheless" => "This is a good value for production sites. If you experience timeouts (such as when performing admin functions) you may need to increase this nevertheless",
// "Your max_execution_time is unlimited" => "Your max_execution_time is unlimited",
// "This is not necessarily bad, but it's a good idea to limit this time on productions servers in order to eliminate unexpectedly long running scripts" => "This is not necessarily bad, but it's a good idea to limit this time on productions servers in order to eliminate unexpectedly long running scripts",
// "It is likely that some scripts, e.g. admin functions will not finish in this time! You should raise your max_execution_time to at least 30s" => "It is likely that some scripts, e.g. admin functions will not finish in this time! You should raise your max_execution_time to at least 30s",
// "Your max_input_time is at" => "Your max_input_time is at",
// "Your max_input_time is unlimited" => "Your max_input_time is unlimited",
// "It is likely that some scripts, e.g. admin functions will not finish in this time! You should raise your max_input_time to at least 30 seconds" => "It is likely that some scripts, e.g. admin functions will not finish in this time! You should raise your max_input_time to at least 30 seconds",
// "Your upload_max_filesize is at" => "Your upload_max_filesize is at",
// "You can upload quite big files, but keep in mind to set your script timeouts accordingly" => "You can upload quite big files, but keep in mind to set your script timeouts accordingly",
// "Nothing wrong with that, but some users might want to upload something bigger" => "Nothing wrong with that, but some users might want to upload something bigger",
// "Your post_max_size is at" => "Your post_max_size is at",
// "The GD extension is needed for manipulation of images, e.g. also for CAPTCHAs" => "The GD extension is needed for manipulation of images, e.g. also for CAPTCHAs",
// "The GD extension is loaded, and Tiki can create images, but the FreeType extension is needed for CAPTCHA text generation" => "The GD extension is loaded, and Tiki can create images, but the FreeType extension is needed for CAPTCHA text generation",
// "The GD extension is loaded, but Tiki is unable to create images. Please check your GD library configuration" => "The GD extension is loaded, but Tiki is unable to create images. Please check your GD library configuration",
// "ImageMagick is used as a fallback in case that GD is not available" => "ImageMagick is used as a fallback in case that GD is not available",
// "ImageMagick is available, but unable to create images. Please check your ImageMagick configuration" => "ImageMagick is available, but unable to create images. Please check your ImageMagick configuration",
// "The mbstring extension is needed for an UTF-8 compatible lower case filter in the admin search for example" => "The mbstring extension is needed for an UTF-8 compatible lower case filter in the admin search for example",
// "The mbstring extension is loaded, but mbstring.func_overload = '.' '.\$func_overload.'.'.' '.'Tiki only works with mbsring.func_overload = 0. Please check your php.ini" => "The mbstring extension is loaded, but mbstring.func_overload = '.' '.\$func_overload.'.'.' '.'Tiki only works with mbsring.func_overload = 0. Please check your php.ini",
// "The mbstring extension is loaded, but missing important functions as for example mb_split(). You need to reinstall it with --enable-mbregex or ask your hoster do do it" => "The mbstring extension is loaded, but missing important functions as for example mb_split(). You need to reinstall it with --enable-mbregex or ask your hoster do do it",
// "The mbstring extension is needed for an UTF-8 compatible lower case filter" => "The mbstring extension is needed for an UTF-8 compatible lower case filter",
// "calendar extension is needed by Tiki" => "calendar extension is needed by Tiki",
// "You will not be able to use the calendar feature of Tiki" => "You will not be able to use the calendar feature of Tiki",
// "ctype extension is needed by Tiki" => "ctype extension is needed by Tiki",
// "This extension is needed for WebDAV" => "This extension is needed for WebDAV",
// "This extension is needed to connect your Tiki to an LDAP server. More info at: http://doc.tiki.org/LDAP " => "This extension is needed to connect your Tiki to an LDAP server. More info at: http://doc.tiki.org/LDAP ",
// "You will not be able to connect your Tiki to an LDAP server as the needed PHP extension is missing. More info at: http://doc.tiki.org/LDAP" => "You will not be able to connect your Tiki to an LDAP server as the needed PHP extension is missing. More info at: http://doc.tiki.org/LDAP",
// "This extension can be used to speed up your Tiki by saving sessions as well as wiki and forum data on a memcached server" => "This extension can be used to speed up your Tiki by saving sessions as well as wiki and forum data on a memcached server",
// "This extension is used to interpret SVN information for TortoiseSVN 1.7 or higher" => "This extension is used to interpret SVN information for TortoiseSVN 1.7 or higher",
// "The eval() function is required by the Smarty templating engine" => "The eval() function is required by the Smarty templating engine",
// "You will get \"Please contact support about\" messages instead of modules. eval() is most probably disabled via Suhosin" => "You will get \"Please contact support about\" messages instead of modules. eval() is most probably disabled via Suhosin",
// "The ZipArchive class is needed for features such as XML Wiki Import/Export and PluginArchiveBuilder" => "The ZipArchive class is needed for features such as XML Wiki Import/Export and PluginArchiveBuilder",
// "The DateTime class is needed for the WebDAV feature" => "The DateTime class is needed for the WebDAV feature",
// "Tiki requires MySQL >= 5.x" => "Tiki requires MySQL >= 5.x",
// "Your max_allowed_packet setting is at" => "Your max_allowed_packet setting is at",
// "This limits the size of binary files that can be added to Tiki, when storing files in the database. Please see: <a href=\"http://doc.tiki.org/File+Storage\">file storage</a>" => "This limits the size of binary files that can be added to Tiki, when storing files in the database. Please see: <a href=\"http://doc.tiki.org/File+Storage\">file storage</a>",
// "Tiki is fully UTF-8 and so should every part of your stack be" => "Tiki is fully UTF-8 and so should every part of your stack be",
// "On a fresh install you should have everything set to UTF-8 to not run into any suprises. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>" => "On a fresh install you should have everything set to UTF-8 to not run into any suprises. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>",
// "Tiki is fully UTF-8 and so should every part of your stack be. utf8_unicode_ci is the default collation for Tiki" => "Tiki is fully UTF-8 and so should every part of your stack be. utf8_unicode_ci is the default collation for Tiki",
// "On a fresh install you should have everything set to UTF-8 to not run into any suprises. utf8_unicode_ci is the default collation for Tiki. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>" => "On a fresh install you should have everything set to UTF-8 to not run into any suprises. utf8_unicode_ci is the default collation for Tiki. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>",
// "Your MySQL doesn't log slow queries. If you have performance issues, you might want to enable this, but keep in mind that the logging itself slows MySQL down" => "Your MySQL doesn't log slow queries. If you have performance issues, you might want to enable this, but keep in mind that the logging itself slows MySQL down",
// "Your MySQL logs slow queries. If you don't have performance issues, you should disable this on a production site as it slows MySQL down" => "Your MySQL logs slow queries. If you don't have performance issues, you should disable this on a production site as it slows MySQL down",
// "Tiki needs this module for Search Engine Friendly URLs via .htaccess. We can't check though, if your web server respects configurations made in .htaccess. For further information go to Admin->SefURL in your Tiki" => "Tiki needs this module for Search Engine Friendly URLs via .htaccess. We can't check though, if your web server respects configurations made in .htaccess. For further information go to Admin->SefURL in your Tiki",
// "Tiki needs this module for Search Engine Friendly URLs. For further information go to Admin->SefURL in your Tiki" => "Tiki needs this module for Search Engine Friendly URLs. For further information go to Admin->SefURL in your Tiki",
// "Your RewriteBase is set correctly in .htaccess. Search Engine Friendly URLs should work. Beware though that we can't check if Apache really loads .htaccess" => "Your RewriteBase is set correctly in .htaccess. Search Engine Friendly URLs should work. Beware though that we can't check if Apache really loads .htaccess",
// "Your RewriteBase is not set correctly in .htaccess. Search Engine Friendly URLs are not going to work like that. It should be set to \"" => "Your RewriteBase is not set correctly in .htaccess. Search Engine Friendly URLs are not going to work like that. It should be set to \"",
// "You haven't activated .htaccess. So this check is useless. If you want to use Search Engine Friendly URLs, you will have to activate .htaccess by copying _htaccess into its place (or a symlink if supported by your Operating System). Then come back to have a look at this check again" => "You haven't activated .htaccess. So this check is useless. If you want to use Search Engine Friendly URLs, you will have to activate .htaccess by copying _htaccess into its place (or a symlink if supported by your Operating System). Then come back to have a look at this check again",
// "With this module you can set the HTTP Expires header and therefore increase performance. We can't check though, if mod_expires is configured correctly" => "With this module you can set the HTTP Expires header and therefore increase performance. We can't check though, if mod_expires is configured correctly",
// "With this module you can set the HTTP Expires header and therefore increase performance. Once you install it, you still need to configure it correctly" => "With this module you can set the HTTP Expires header and therefore increase performance. Once you install it, you still need to configure it correctly",
// "With this module you can compress the data your webserver sends out and therefore decrease used bandwidth and increase performance. We can't check though, if mod_deflate is configured correctly" => "With this module you can compress the data your webserver sends out and therefore decrease used bandwidth and increase performance. We can't check though, if mod_deflate is configured correctly",
// "With this module you can compress the data your webserver sends out and therefore decrease used bandwidth and increase performance. Once you install it, you still need to configure it correctly" => "With this module you can compress the data your webserver sends out and therefore decrease used bandwidth and increase performance. Once you install it, you still need to configure it correctly",
// "This module can increase security of your Tiki and therefore your server, but be warned that it is very tricky to configure it correctly. A misconfiguration can lead to failed page saves or other hard to trace bugs" => "This module can increase security of your Tiki and therefore your server, but be warned that it is very tricky to configure it correctly. A misconfiguration can lead to failed page saves or other hard to trace bugs",
// "The URL Rewrite Module is required to use SEFURL on IIS" => "The URL Rewrite Module is required to use SEFURL on IIS",
// "upload_tmp_dir is probably within your Tiki directory. There is a risk that someone can upload any file to this directory and access them via web browser" => "upload_tmp_dir is probably within your Tiki directory. There is a risk that someone can upload any file to this directory and access them via web browser",
// "Can't reliably determine, if your upload_tmp_dir is accessible via a web browser. To make sure you should check your webserver config" => "Can't reliably determine, if your upload_tmp_dir is accessible via a web browser. To make sure you should check your webserver config",
"register_globals should be off by default. See the php manual for details." => "register_globals deve estar desligado por padrão. Veja o manual do php para detalhes.",
"safe" => "seguro",
// "WebKit is enabled" => "WebKit is enabled",
// "Blogs is enabled" => "Blogs is enabled",
// "Exec can potentially be used to execute arbitrary code on your server" => "Exec can potentially be used to execute arbitrary code on your server",
// "Tiki does not need it, you may want to disable it" => "Tiki does not need it, you may want to disable it",
// "Exec can be potentially be used to execute arbitrary code on your server" => "Exec can be potentially be used to execute arbitrary code on your server",
// "Tiki does not need it, you are wise to have it disabled" => "Tiki does not need it, you are wise to have it disabled",
// "Passthru is similar to exec" => "Passthru is similar to exec",
// "Shell_exec is similar to exec" => "Shell_exec is similar to exec",
// "Tiki needs it to run PDF from URL: WebKit (wkhtmltopdf). '.\$pdf_webkit.'If you need this and trust the other PHP software on your server, you should enable it" => "Tiki needs it to run PDF from URL: WebKit (wkhtmltopdf). '.\$pdf_webkit.'If you need this and trust the other PHP software on your server, you should enable it",
// "System is similar to exec" => "System is similar to exec",
// "Proc_open is similar to exec" => "Proc_open is similar to exec",
// "Curl_exec can potentially be abused to write malicious code" => "Curl_exec can potentially be abused to write malicious code",
// "Tiki needs it to run features like Kaltura, CAS login, CClite and the myspace and sf wiki-plugins. If you need these and trust the other PHP software on your server, you should enable it" => "Tiki needs it to run features like Kaltura, CAS login, CClite and the myspace and sf wiki-plugins. If you need these and trust the other PHP software on your server, you should enable it",
// "Curl_multi_exec can potentially be abused to write malicious code" => "Curl_multi_exec can potentially be abused to write malicious code",
// "It is probably an urban myth that this is dangerous. Tiki team will reconsider this check, but be warned" => "It is probably an urban myth that this is dangerous. Tiki team will reconsider this check, but be warned",
"risky" => "arriscado",
"session.use_trans_sid should be off by default. See the php manual for details." => "session.use_trans_sid deve estar desligada por padrão. Veja o manual do php para detalhes.",
// "setting the xbithack option is unsafe. Depending on the file handling of your webserver and your tiki settings, it may be possible that an attacker can upload scripts to file gallery and execute them" => "setting the xbithack option is unsafe. Depending on the file handling of your webserver and your tiki settings, it may be possible that an attacker can upload scripts to file gallery and execute them",
// "allow_url_fopen may potentially be used to upload remote data or scripts. '.\$feature_blogs.'If you dont use the blog feature, you can switch it off" => "allow_url_fopen may potentially be used to upload remote data or scripts. '.\$feature_blogs.'If you dont use the blog feature, you can switch it off",
// "Test mail from Tiki Server Compatibility Test" => "Test mail from Tiki Server Compatibility Test",
// "We were able to send an e-mail. This only means that a mail server accepted the mail for delivery. We don't know, if that server really delivers the mail. Please check the inbox of '.\$_POST['email_test_to'].' to see, if the delivery really works" => "We were able to send an e-mail. This only means that a mail server accepted the mail for delivery. We don't know, if that server really delivers the mail. Please check the inbox of '.\$_POST['email_test_to'].' to see, if the delivery really works",
// "We were not able to send an e-mail. It may be that there is no mail server installed on this machine or that it is badly configured. If you absolutely can't get the local mail server to work, you can setup a regular mail account and set SMTP settings in tiki-admin.php" => "We were not able to send an e-mail. It may be that there is no mail server installed on this machine or that it is badly configured. If you absolutely can't get the local mail server to work, you can setup a regular mail account and set SMTP settings in tiki-admin.php",
// "The fileinfo extension is needed for the 'Validate uploaded file content' preference" => "The fileinfo extension is needed for the 'Validate uploaded file content' preference",
"Top authors" => "Autores mais produtivos",
// "Problem. Try to log in again to receive new confirmation instructions" => "Problem. Try to log in again to receive new confirmation instructions",
// "You must include a subject or a message" => "You must include a subject or a message",
// "You must make sure to have a valid e-mail address in the From field" => "You must make sure to have a valid e-mail address in the From field",
// "%0 sent you a message" => "%0 sent you a message",
"last version" => "última versão",
"Cannot rename page because the new name begins with reserved prefix" => "Não foi possível renomear a página pois o novo nome começa com um prefixo que está reservado",
// "Cannot copy page because maybe new page name already exists" => "Cannot copy page because maybe new page name already exists",
// "TikiHelp WebHelp generation engine. Generating WebHelp using" => "TikiHelp WebHelp generation engine. Generating WebHelp using",
// "Eliminating previous files" => "Eliminating previous files",
// "Index: <strong>%0</strong>" => "Index: <strong>%0</strong>",
// "Directory: <strong>%0</strong>" => "Directory: <strong>%0</strong>",
"You need to change chmod 'whelp' manually to 777" => "Você deve mudar manualmente o chmod de 'whelp' para 777",
// "Creating directory structure in <strong>%0</strong>" => "Creating directory structure in <strong>%0</strong>",
// "Submit a new link" => "Submit a new link",
"Must enter a name to add a site. " => "Deve digitar um nome para adicionar um site. ",
"Must enter a url to add a site. " => "Deve digitar uma url para adicionar um site. ",
"URL already added to the directory. Duplicate site? " => "URL já foi adicionada ao diretório. Duplicar o site? ",
"URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. " => "A URL não pode ser acessada. URL errada ou o site está fora do ar e não pode ser adicionado ao diretório. ",
"Must select a category. " => "Deve selecionar uma categoria. ",
"Must enter a name to add a site" => "É preciso digitar um nome para o site",
"Must enter a url to add a site" => "É preciso digitar um endereço para o site",
"URL already added to the directory. Duplicate site?" => "URL já presente no diretório. Site duplicado?",
"URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory" => "URL não pode ser acessada: URL errada ou o site está fora do ar e não pode ser adicionado ao diretório",
"Admin Directory" => "Administrar diretórios",
"Must select a category" => "É preciso selecionar uma categoria",
"Browse Directory" => "Listar links",
// "How to use Directory" => "How to use Directory",
"No site indicated" => "Nenhum site indicado",
// "This feature is disabled: %0" => "This feature is disabled: %0",
"No parent specified" => "Nenhum parentesco especificado",
// "Last sites of directory %0" => "Last sites of directory %0",
// "Discount code already exists" => "Discount code already exists",
// "File has been deleted" => "File has been deleted",
// "You cannot download this file right now. Your score is low or file limit was reached" => "You cannot download this file right now. Your score is low or file limit was reached",
// "Error : The file %s doesn't exist" => "Error : The file %s doesn't exist",
"Article not found" => "Artigo não encontrado",
"You do not have permission to edit this article" => "Permissão negada: você não pode editar este artigo",
"The language can't be changed as its set of translations has already this language" => "O idioma não pode ser alterado pois ele já se encontra no espaço de traduções",
"Banner not found" => "Banner não encontrado",
"You do not have permission to edit this banner" => "Você não possui a permissão para editar este banner",
"You do not have permission to edit this blog" => "Permissão negada: você não pode editar este blog",
// "Incorrect name" => "Incorrect name",
"You do not have permission to write the style sheet" => "Você não tem permissão para editar a style sheet",
// "Wrong file type, expected %0" => "Wrong file type, expected %0",
// "You do not have permission to view/edit this file" => "You do not have permission to view/edit this file",
// "New Svg Image" => "New Svg Image",
"Invalid request to edit an image" => "Requisição inválida para editar uma imagem",
"You have permission to edit images but not in this gallery" => "Permissão negada: você pode editar imagens, mas não nesta galeria",
"Failed to edit the image" => "Falha ao tentar editar a imagem",
// "Wrote %d new strings and updated %d to lang/%s/language.php" => "Wrote %d new strings and updated %d to lang/%s/language.php",
// "Edit Perspectives" => "Edit Perspectives",
"No content id indicated" => "Não foi indicado um id de conteúdo",
"No question indicated" => "Nenhuma questão indicada",
"No quiz indicated" => "Nenhum teste indicado",
"No structure indicated" => "Nenhuma estrutura indicada",
"Invalid structure_id or page_ref_id" => "structure_id inválida ou page_ref_id",
"You do not have permission to edit submissions" => "Permissão negada: você não pode editar artigos pendentes",
"You have to create a topic first" => "Você deve criar um tópico antes de prosseguir",
// "Template directory %0 unknown" => "Template directory %0 unknown",
"You do not have permission to do that" => "Você não possui a permissão necessária",
"You do not have permission to write the template:" => "Você não tem permissão para escrever no template:",
"You do not have permission to read the template" => "Você não possui a permissão de ler o padrão",
"No topic id specified" => "Nenhum ID de tópico especificado",
"Invalid topic id specified" => "ID de tópico especificado inválido",
"No object indicated" => "Nenhum objeto indicado",
// "Only wiki pages are supported" => "Only wiki pages are supported",
// "Not enable for this type of object" => "Not enable for this type of object",
"Override lock and carry on with edit" => "Ignorar aviso e editar página",
"Page is currently being edited" => "Outro usuário está editando a página",
"page imported" => "página importada",
"created from import" => "criada a partir de uma importação",
"Describe the change you made" => "Descreva a alteração que você fez",
// "This page is being edited by %0. Please check with the user before editing the page,\totherwise the changes will be stored as two separate versions in the history and you will have to manually merge them later" => "This page is being edited by %0. Please check with the user before editing the page,\totherwise the changes will be stored as two separate versions in the history and you will have to manually merge them later",
"Can't import remote HTML page" => "Não posso importar a página HTML remota",
"The SandBox is disabled" => "A Bancada de testes está desabilitada",
"Cannot edit page because it is locked" => "A página não pode ser editada enquanto estiver travada",
"Page already exists. Go back and choose a different name." => "Uma página com esse nome já existe, volte e escolha outro nom/e.",
"Page name is" => "O nome da página é",
// "The translation set already contains a page in this language" => "The translation set already contains a page in this language",
// "Can not open the file" => "Can not open the file",
// "Problem zip initialisation" => "Problem zip initialisation",
// "Problem zip" => "Problem zip",
// "Another user is currently exporting that tracker, please try again later" => "Another user is currently exporting that tracker, please try again later",
"No questions group indicated" => "Sem grupo de questões indicado",
// "Remove archive: " => "Remove archive: ",
// "Remove file gallery: " => "Remove file gallery: ",
"Top visited file galleries" => "Galerias de arquivo mais visitadas",
"Most downloaded files" => "Arquivos mais baixados",
"Last files" => "Arquivos recentes",
"No galleryId specified" => "Nenhum ID de galeria especificado",
// "Form error - no import method selected for some reason" => "Form error - no import method selected for some reason",
// "Form error - no server-side filename entered for selected import method" => "Form error - no server-side filename entered for selected import method",
"No forum indicated" => "Nenhum fórum indicado",
"Last forum topics" => "Últimos tópicos de fóruns",
// "Last replied forum topics" => "Last replied forum topics",
"Most-Read Forum Topics" => "Tópicos mais lidos",
"Top topics" => "Tópicos mais discutidos",
"Forum posts" => "Mensagens do Fórum",
"Most-Visited Forums" => "Fóruns mais visitados",
"No forumId specified" => "Nenhum ID de fórum especificado",
"List Forums" => "Listagem dos fóruns",
// "Not supported yet" => "Not supported yet",
"Accepted friendship request from %s" => "Pedido para entrar na rede de amigos de %s aceito",
"Refused friendship request from %s" => "Pedido para entrar na rede de amigos de %s recusado",
// "Canceled friendship request with %s" => "Canceled friendship request with %s",
"Broke friendship with %s" => "Romper amizade com %s",
"I have broken our friendship!" => "Eu rompi nossa amizade!",
"Friendship request sent to %s" => "Pedido de amizade enviado para %s",
"You're already friend of %s" => "Você já é amigo de %s",
"I have accepted your friendship request!" => "Eu aceitei seu convite para entrar na sua rede de amigos!",
// "I have refused your friendship request" => "I have refused your friendship request",
// "I have canceled my friendship request" => "I have canceled my friendship request",
"first uploaded image" => "primeira imagem enviada",
"last uploaded image" => "última imagem enviada",
"first image" => "primeira imagem",
"last image" => "última imagem",
"random image" => "imagem aleatória",
"You do not have permission to create galleries and so you cannot edit them" => "Permissão negada: você não pode criar galerias ou editá-las",
"You do not have permission to edit this gallery" => "Permissão negada: você não pode editar esta galeria",
"You do not have permission to remove this gallery" => "Permissão negada: você não pode remover esta galeria",
"You do not have permission to make the map of this gallery" => "Permissão negada, você não pode fazer o mapa dessa galeria",
"Top images" => "Imagens mais populares",
"Last images" => "Imagens recentes",
// "Back to item" => "Back to item",
// "No valid renderer found. GD or PDFLib required" => "No valid renderer found. GD or PDFLib required",
"No sheet specified." => "Nenhuma planilha especificada.",
"You must select a renderer." => "Você deve selecionar um renderizador.",
"Invalid Series for current graphic." => "Séries inválidas para o gráfico atual.",
"overwriting old page" => "sobrescrevendo página antiga",
"updated from structured text import" => "atualizado a partir de uma exportação em texto estruturada",
"page created" => "página criada",
"created from structured text import" => "criado a partir de uma exportação em texto estruturada",
// "Operations executed successfully" => "Operations executed successfully",
// "Invalid software name" => "Invalid software name",
"No name indicated for wiki page" => "Nome não indicado para a página Wiki",
// "This version does not exist" => "This version does not exist",
// "There is more than one item in the tracker with this title" => "There is more than one item in the tracker with this title",
// "There are no items in the tracker with this title" => "There are no items in the tracker with this title",
"Page saved (version %d)" => "Página salva (versão %d)",
// "You have requested that this page be machine translated" => "You have requested that this page be machine translated",
// "However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it" => "However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it",
"No repository given" => "Nenhum repositório conhecido",
// "This invitation does not exist or is deprecated" => "This invitation does not exist or is deprecated",
// "Congratulations! You are now part of this invitation group(s)" => "Congratulations! You are now part of this invitation group(s)",
// "Upload Media" => "Upload Media",
// "Communication error" => "Communication error",
// "Invalid response provided by the Kaltura server. Please retry" => "Invalid response provided by the Kaltura server. Please retry",
// "Are you sure you want to permanently remove the article with identifier %0" => "Are you sure you want to permanently remove the article with identifier %0",
"Are you sure you want to permanently remove these %0 articles" => "Você tem certeza que deseja remover os artigos %0",
"You do not have permission to remove articles" => "Permissão negada: você não pode remover artigos",
"You do not have permission to remove banners" => "Permissão negada: você não pode remover banners",
// "List Blog Posts" => "List Blog Posts",
"You do not have permission to remove this blog" => "Permissão negada: você não pode remover este blog",
// "You do not have permission to view the comments for this blog" => "You do not have permission to view the comments for this blog",
// "Delete comments" => "Delete comments",
// "Approved Status" => "Approved Status",
// "Queued" => "Queued",
// "This blog has no posts" => "This blog has no posts",
// "Dynamic content" => "Dynamic content",
// "Admin FAQs" => "Admin FAQs",
"Non-existent gallery" => "Galeria inexistente",
// "You do not have permission to view this gallery" => "You do not have permission to view this gallery",
// "The file is already locked by %s" => "The file is already locked by %s",
// "Permission denied you cannot validate files from this gallery" => "Permission denied you cannot validate files from this gallery",
// "Validate draft: " => "Validate draft: ",
"Quota too big" => "Quota muito grande",
"Quota too small" => "Quota muito pequena",
"You have permission to upload files but not to this file gallery" => "Permissão negada: você pode carregar arquivos mas não nesta galeria de arquivos",
"Not modified since" => "Sem modificações desde",
"Not downloaded since" => "Sem downloads desde",
"You do not have permission to upload files so you cannot edit them" => "Permissão negada: você não pode carregar arquivos, de modo que não pode editá-los",
"This gallery does not exist" => "Essa galeria não existe",
// "List Entries" => "List Entries",
// "Error importing" => "Error importing",
// "Error converting" => "Error converting",
// "Importing" => "Importing",
// "Processing" => "Processing",
"Ready" => "Pronto",
"Pending moderation" => "Esperado moderação",
"Blocked" => "Bloqueado",
"Invalid action" => "Ação inválida",
"Remove permission %0 from %1" => "Remover permissão %0 de %1",
"Assign permission %0 to %1" => "Dar permissão %0 para %1",
// "Delete posts" => "Delete posts",
// "View submissions" => "View submissions",
// "Are you sure you want to permanently remove the submitted article with identifier %0" => "Are you sure you want to permanently remove the submitted article with identifier %0",
// "Are you sure you want to permanently remove these %0 submitted articles" => "Are you sure you want to permanently remove these %0 submitted articles",
// "Are you sure you want to approve these %0 submitted articles" => "Are you sure you want to approve these %0 submitted articles",
// "Are you sure you want to remove the %0 selected pages" => "Are you sure you want to remove the %0 selected pages",
// "Are you sure you want to print the %0 selected pages" => "Are you sure you want to print the %0 selected pages",
// "Are you sure you want to unlock the %0 selected pages" => "Are you sure you want to unlock the %0 selected pages",
// "Are you sure you want to lock the %0 selected pages" => "Are you sure you want to lock the %0 selected pages",
// "Are you sure you want to download a zip of the %0 selected pages" => "Are you sure you want to download a zip of the %0 selected pages",
// "Are you sure you want to modify the %0 pages" => "Are you sure you want to modify the %0 pages",
// "No history will be created" => "No history will be created",
// "You are neither an administrator nor an operator of live support" => "You are neither an administrator nor an operator of live support",
// "Username field cannot be empty. Please go back and try again" => "Username field cannot be empty. Please go back and try again",
"Unable to contact remote server" => "Não foi possível estabelecer comunicação com o servidor remoto",
"XMLRPC Error: " => "Erro XMLRPC: ",
"Unable to create login" => "Não foi possível criar o login",
"More than %d unsuccessful login attempts have been made" => "Foram feitas mais de %d tentativas de login sem sucesso",
"Your account has been suspended" => "Sua conta foi suspendida",
"A site administrator will reactivate it" => "Um administrador vai reativá-la",
"An email has been sent to you with the instructions to follow" => "Um e-mail foi enviado para você com as instruções",
"Account disabled" => "Conta inativa",
"You did not validate your account" => "Você não validou a sua conta",
"Resend" => "Re-enviar",
// "You should have received an email. Check your mailbox and your spam box. Otherwise click on the button to resend the email" => "You should have received an email. Check your mailbox and your spam box. Otherwise click on the button to resend the email",
"You must use the right case for your user name" => "O nome de usuário é sensível a letras maiúsculas e minúsculas",
"You are not yet validated" => "Você ainda não foi validado",
"The mail can't be sent. Contact the administrator" => "O e-mail não pode ser enviado. Por favor, contate o administrador do site.",
// "Your default nickname is already in use. A new one has to be selected" => "Your default nickname is already in use. A new one has to be selected",
// "Verification cancelled" => "Verification cancelled",
// "The selected account is not associated with your identity" => "The selected account is not associated with your identity",
// "unknown action" => "unknown action",
"Authentication method is not OpenID" => "Método de autenticação não é OpenID",
// "Authentication error; probably not a valid OpenID" => "Authentication error; probably not a valid OpenID",
"Could not redirect to server: " => "Não foi possível redirecionar para o servidor: ",
"OpenID authentication failed: " => "Falha na autenticação OpenID: ",
// "You have already validated your account. Please log in" => "You have already validated your account. Please log in",
"Sorry, you can't use this feature." => "Desculpe, você não pode usar essa função.",
// "You must first setup MapServer" => "You must first setup MapServer",
// "invalid mapfile name" => "invalid mapfile name",
// "An error as occurred with the mapfile" => "An error as occurred with the mapfile",
"edit" => "editar",
// "Please create a directory named %0 to hold your map files" => "Please create a directory named %0 to hold your map files",
"Maps feature is not correctly setup : Maps path is missing." => "Os recursos dos mapas não estão configurados corretamente: Faltando a pasta Mapas.",
"mapfile name incorrect" => "nome do arquivo de mapa incorreto",
"This mapfile already exists" => "Este arquivo de mapa já existen",
"You do not have permission to write to the mapfile" => "Você não tem permissão para escrever no arquivo de mapa",
"You do not have permission to delete the mapfile" => "Você não tem permissão para remover o arquivo de mapa",
"I could not make a copy" => "Não foi possível fazer uma cópia",
"You do not have permission to read the mapfile" => "Você não tem permissão para ler o arquivo de mapa",
// "map edit" => "map edit",
"You dont have permission to do that" => "Você não tem permissão para fazer isso",
"Tiki RSS feed for maps" => "Fonte RSS para mapas",
"List of maps available." => "Lista dos mapas disponíveis.",
"Layer Management" => "Gerenciamento de camadas",
"The Directory is not empty" => "O Diretório não está vazio",
"Invalid file name" => "Nome de arquivo inválido",
"Invalid files to index" => "Arquivos inválidos para índice",
"I do not know where is gdaltindex. Set correctly the Map feature" => "Eu não sei onde está o gdaltindex. Configure corretamente a funcionalidade de mapa",
"I could not create the index file" => "Eu não posso criar o arquivo de índice",
// " to " => " to ",
// "No page provided" => "No page provided",
"You need to run setup.sh :<br />./setup.sh \$APACHEUSER all<br />Common Apache users are www-data, apache or nobody" => "Você precisa rodar o script setup.sh :<br />./setup.sh \$APACHEUSER all<br />Usuários comuns no apache são: www-data, apache ou nobody",
"Your PHP installation does not have zlib enabled." => "Sua versão do PHP não tem o zlib habilitado.",
"You must log in to use this feature" => "Você deve se logar para usar este recurso",
"MyTiki Home" => "Área pessoal",
"You do not have permission to view other users data" => "Você não possui permissão para ver dados de outros usuários",
"You must be logged in to subscribe to newsletters" => "Você precisa se logar para assinar os comunicados",
"No note indicated" => "Nenhuma nota indicada",
"merged note:" => "nota composta:",
"File is too big" => "O arquivo é grande demais",
"No item indicated" => "Nenhum item indicado",
// "Are you sure you want to delete this note" => "Are you sure you want to delete this note",
"created from notepad" => "criado a partir do Bloco de Notas",
// "Note not found" => "Note not found",
"Not enough information to display this page" => "Informações insuficientes para exibir esta página",
// "You do not have permission to assign permissions for this object" => "You do not have permission to assign permissions for this object",
// "Are you sure you want to remove the direct permissions from this object" => "Are you sure you want to remove the direct permissions from this object",
// "Are you sure you want paste the copied permissions onto this object" => "Are you sure you want paste the copied permissions onto this object",
// "Manual payment entered" => "Manual payment entered",
// "You do not have permission to enter payment" => "You do not have permission to enter payment",
// "New payment requested" => "New payment requested",
// "Cancel payment %0" => "Cancel payment %0",
// "Payment canceled" => "Payment canceled",
"No article indicated" => "Nenhum artigo indicado",
"Article is not published yet" => "Artigo ainda não foi publicado",
"No post indicated" => "Nenhuma mensagem indicada",
"Blog not found" => "Blog não encontrado",
// "Missing object list type argument" => "Missing object list type argument",
// "Index" => "Index",
// "Index (%0)" => "Index (%0)",
"No pages indicated" => "Nenhuma página indicada",
// "Multiple Print" => "Multiple Print",
"Pageviews" => "Número de vezes que a página foi visualizada",
"No result indicated" => "Nenhum resultado indicado",
"Invalid or unknown username" => "Usuário desconhecido ou inválido",
"Unable to send mail. User has not configured email" => "Não foi possível enviar e-mail. O usuário não configurou um endereço eletrônico",
// "Please provide a username or email" => "Please provide a username or email",
"Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password" => "Por favor, contate o administrador se você não receber nenhuma mensagem ou se houver alguma problema com a sua senha",
"A password reminder email has been sent " => "Um lembrete da senha foi enviado",
"An email with a link to reset your password has been sent " => "Um e-mail com um link para alterar sua senha foi enviado ",
"to the email" => "para o e-mail",
"to the registered email address for" => "para o endereço de email registrado para",
"Non-existent version" => "Versão inexistente",
// "Tiki RSS Feed Error Message: %0" => "Tiki RSS Feed Error Message: %0",
// "This match was not case sensitive" => "This match was not case sensitive",
// "No items selected" => "No items selected",
// "Page cannot be found: " => "Page cannot be found: ",
// "Page has changed since preview: " => "Page has changed since preview: ",
// "Page not updated due to error in replacing: " => "Page not updated due to error in replacing: ",
// "Page updated: " => "Page updated: ",
// "Search Stats" => "Search Stats",
// "%0: Results for \"%1\"" => "%0: Results for \"%1\"",
// "Searchindex" => "Searchindex",
"A problem occurred during file uploading" => "Ocorreu um problema durante o envio do arquivo",
// "File which was causing trouble was at rank" => "File which was causing trouble was at rank",
"The error was" => "O erro foi",
// "Error: You can't send the same newsletter by refreshing this frame content" => "Error: You can't send the same newsletter by refreshing this frame content",
// "Newsletter successfully sent to %s users" => "Newsletter successfully sent to %s users",
// "There was %s errors" => "There was %s errors",
"No newsletters available." => "Nenhuma newsletters disponível.",
// "Cannot login to server maybe the server is down" => "Cannot login to server maybe the server is down",
"successfully sent" => "enviada com sucesso",
"not sent" => "não enviada",
"Error: " => "Erro: ",
"Send Pages" => "Enviar páginas",
// "Notice: this variable may not be empty" => "Notice: this variable may not be empty",
// "Notice: invalid variable value" => "Notice: invalid variable value",
// "Report to the webmaster" => "Report to the webmaster",
// "Token called" => "Token called",
// "Error sending tweet" => "Error sending tweet",
// "Your link was sent" => "Your link was sent",
// "Your email is mandatory" => "Your email is mandatory",
// "Error sending mail to" => "Error sending mail to",
// "Permission to post in forum denied" => "Permission to post in forum denied",
// "No text given for tweet" => "No text given for tweet",
// "Spreadsheet - " => "Spreadsheet - ",
// "Are you sure you want to delete this spreadsheet" => "Are you sure you want to delete this spreadsheet",
// "You do not have permission to edit messages %0" => "You do not have permission to edit messages %0",
// "Permission denied. You cannot view this page" => "Permission denied. You cannot view this page",
// "Updating Theme.." => "Updating Theme..",
// "Update slideshow theme" => "Update slideshow theme",
"Page must be defined inside a structure to use this feature" => "A página tem que ser definida dentro de uma estrutura para o uso deste recurso",
// "Username and email are mandatory" => "Username and email are mandatory",
// "Email is invalid" => "Email is invalid",
// "Clean the sql logs" => "Clean the sql logs",
// "Are you sure you want to clear all statistics and data for this survey" => "Are you sure you want to clear all statistics and data for this survey",
"You cannot take this quiz twice" => "Você não pode fazer este teste mais de uma vez",
"Quiz time limit exceeded quiz cannot be computed" => "Limite de tempo do teste atingido: a nota não será calculada",
"You cannot take this survey twice" => "Você não pode responder a esta pesquisa mais de uma vez",
"Please create a category first" => "Por favor, selecione antes uma categoria",
// "Committing.." => "Committing..",
// "Could not save" => "Could not save",
"Tracker item:" => "Item do formulário:",
"No trackerId specified" => "trackerId não especificado",
// "Incorrect file gallery" => "Incorrect file gallery",
"You must lock the file before editing it" => "Primeiro você precisa travar o arquivo para poder editá-lo",
"Error processing zipped image package" => "Erro tentando processar arquivo zipado de imagem",
"No permission to upload zipped image packages" => "Sem permissão para carregar arquivos zipados de imagem",
"The uploaded file ist not recognized as a image" => "O arquivo enviado não foi reconhecido como imagem",
"You do not have permission to upload images" => "Permissão negada: você não pode carregar imagens",
"You have permission to upload images but not to this gallery" => "Permissão negada: você pode carregar imagens mas não nesta galeria",
"Cannot get image from URL" => "Impossível obter a imagem a partir do endereço",
"That is not an image (or you have php < 4.0.5)" => "Isto não é uma imagem (ou você tem o PHP < 4.0.5)",
"Usage" => "Uso",
"TOP" => "TOP",
"No url indicated" => "Nenhum endereço indicado",
"Unknown user" => "Usuário desconhecido",
"Password has been changed" => "A senha foi alterada",
"Invalid password. Your current password is required to change administrative information" => "Senha inválida. Sua senha é necessária para mudar as informações administrativas",
"Email is set to %s" => "E-mail definido como %s",
"The passwords did not match" => "As senhas não coincidem",
// "If you really want to delete your account, you must check the checkbox" => "If you really want to delete your account, you must check the checkbox",
"unicode" => "unicode",
"was moved into trash" => "foi movido para a lixeira",
"trashed by" => "deletado por",
"open / in process" => "em andamento",
"Rights by creator" => "Direitos do criador",
"END" => "Fim",
"Percentage" => "Porcentagem",
"Task accepted by creator" => "Tarefa aceita pelo criador",
"Task accepted by task user" => "Tarefa aceita pelo usuário",
"Task NOT accepted by creator" => "Tarefa NÃO aceita pelo criador",
"Task NOT accepted by task user" => "Tarefa NÃO aceita pelo usuário",
"Sorry this task does not exist or you have no rights to view this task" => "Desculpe, essa tarefa não existe ou você não tem permissões para visualiza-la",
"Task entries:" => "Entradas da tarefa:",
"Changes:" => "Mudanças:",
"Info message" => "Mensagem informativa",
"NEW Task" => "Nova tarefa",
"Sorry you are not allowed to send tasks to other users, or the user is not allowed to receive tasks!" => "Desculpe mas você não tem permissão para enviar tarefas para outros usuários ou os usuários não podem receber tarefas!",
"Changes on Task" => "Mudanças na tarefa",
"You received a new task" => "Você recebeu uma nova tarefa",
"The priority is" => "A prioridade é",
"very low" => "muito baixa",
"high" => "alta",
"very high" => "muito alta",
"You've to start your work at least on" => "Você precisa começar seu trabalho até",
"You've to finish your work on" => "Você precisa terminar seu trabalho em",
"Login and click the link below" => "Login e clique no link abaixo",
"Please read the task and work on it!" => "Por favor leia as tarefas e trabalhe nelas!",
"Sorry, there was an error while trying to write data into the database" => "Desculpe, houve um erro ao tentar escrever na banco de dados",
// "A new page is created in a language" => "A new page is created in a language",
// "Category change in a language" => "Category change in a language",
// "Remove the notification email" => "Remove the notification email",
// "Language watch" => "Language watch",
// "Category watch: %0, Language: %1" => "Category watch: %0, Language: %1",
"Cannot upload this file not enough quota" => "Impossível carregar este arquivo: cota máxima atingida",
"No user indicated" => "Nenhum usuário indicado",
"Non-existent user" => "Usuário inexistente",
"Articles Home" => "Página principal de Artigos",
"No banner indicated" => "Nenhum banner indicado",
"No blog indicated" => "Nenhum blog indicado",
// "Post not found" => "Post not found",
// "You do not have permission to view this blog post while it is marked as private" => "You do not have permission to view this blog post while it is marked as private",
"No cache information available" => "Informação de cache não disponível",
// "You must suggest a question; please try again" => "You must suggest a question; please try again",
"No faq indicated" => "Nenhum faq indicado",
"You are not permitted to remove someone else's post!" => "Você não pode remover a mensagem postada por outra pessoa!",
// "Incorrect thread" => "Incorrect thread",
"No thread indicated" => "Nenhuma seqüência indicada",
// "Files are read only at this time" => "Files are read only at this time",
// "Are you sure you want to clone this spreadsheet" => "Are you sure you want to clone this spreadsheet",
// "Clone Error" => "Clone Error",
// "Are you sure you want to rollback this spreadsheet" => "Are you sure you want to rollback this spreadsheet",
// "Rollback Error" => "Rollback Error",
// "Tracker Added To Spreadsheet" => "Tracker Added To Spreadsheet",
// "Tracker Removed From Spreadsheet" => "Tracker Removed From Spreadsheet",
// "Spreadsheet added" => "Spreadsheet added",
// "Spreadsheet removed" => "Spreadsheet removed",
"File removed" => "Arquivo removido",
// "Spreadsheet truncated" => "Spreadsheet truncated",
// "Create tracker item" => "Create tracker item",
// "Are you sure you want to remove this attachment" => "Are you sure you want to remove this attachment",
"Edit/Delete" => "Editar/Deletar",
// "You don't have a personal tracker item yet. Click here to make one" => "You don't have a personal tracker item yet. Click here to make one",
"That tracker don't use extras." => "Aquele formulário não usa extras.",
// "Tiki WebDAV access" => "Tiki WebDAV access",
// "You do not have permission to admin the requested webmail account" => "You do not have permission to admin the requested webmail account",
// "You do not have permission to use the requested webmail account" => "You do not have permission to use the requested webmail account",
// "You no longer have permission to use your active webmail account" => "You no longer have permission to use your active webmail account",
// "There was a problem connecting to that account" => "There was a problem connecting to that account",
// "There was a problem deleting that mail" => "There was a problem deleting that mail",
// "Mail ID" => "Mail ID",
// "There was a problem while trying to delete these mails" => "There was a problem while trying to delete these mails",
// "There was a problem while trying to delete that mail" => "There was a problem while trying to delete that mail",
"Are you sure you want to delete this account" => "Você tem certeza de que deseja deletar essa conta",
// "Taking" => "Taking",
// "Putting back" => "Putting back",
// "Checking" => "Checking",
"Aborted" => "Abortado",
"Top pages" => "Páginas mais populares",
"Last pages" => "Páginas recentes",
// "Plugin modified by editor" => "Plugin modified by editor",
// "Tidy Extension not present" => "Tidy Extension not present",
// "The TikiTests Replay File is Empty" => "The TikiTests Replay File is Empty",
// "The TikiTests Replay File has an error" => "The TikiTests Replay File has an error",
// "You are about to delete a TikiTest file, do you want to continue " => "You are about to delete a TikiTest file, do you want to continue ",
"Error deleting the file" => "Erro ao deletar o arquivo",
// "TikiTest List" => "TikiTest List",
// "TikiTest Record" => "TikiTest Record",
// "You need one of the extension pecl HTTP or Curl to replay the TikiTest" => "You need one of the extension pecl HTTP or Curl to replay the TikiTest",
// "The TikiTest Replay File is Empty" => "The TikiTest Replay File is Empty",
// "TikiTest Replay" => "TikiTest Replay",
"The page is empty" => "A página está vazia",
"You do not have permissions to view the maps" => "Você não possui permissões para ver os mapas",
);
